#include <math.h>
#include <stdio.h>
#include <stdlib.h>
extern double cr2,cr3,cr4,cr6,cr12,cgp,c2gp,cgp_4,cr2gp,cgm0,crgm0;
extern int ESNa,ESNa1,ESNp,ESNp1;
extern int ESMp,ESMp1,ES2Mp1;
extern int ESFp,ESFp1,ESnAF;
extern int NPlVac,*k2kPlV;
extern double*rPlVd,*zPlVd;
extern double *EScs1,*ESsn1;

extern double *ESaR0,*ESaZ0,*ESsa,*ESsb,*ESsb1a,*ESsb2a;
extern double *rcT,*rcT1a,*rcT2a,*rsT,*rsT1a,*rsT2a;

extern double *ECb,*ECb1a,*ECb2a;
extern double *ESgt;
extern double R0,Z0,ESRext,ESRBt;
extern int ESiAx;

#ifndef mzl_PL
extern int ESnLm,ESnLm1;
extern double*ESRLm,*ESZLm;
#endif

extern int NPlVac,*k2kPlV;
extern double *rPlVd,*zPlVd;

extern int ESnBL,ESnBL1,nf_X;
extern double ESaRx,ESaZx,ESDx[],ESLx[],ESVx[],ESgFPlVx;
extern double d_vb,gd_vb,b_X,z_X0,z_X2,z_X2n,t_X,singtX;
extern double *x0sep,*x1sep,*x2sep,*X2vb,*x0cs,*x0sn,*dx0cs,*dx0sn;
extern double *rvb,*zvb,*rvbcs,*rvbsn,*drvbcs,*drvbsn;
extern double*Dx0,*Dx2,*Ddx2,*Dz2,*Dx0c,*Dx0s,*Dx2c,*Dx2s,*Ddx2c,*Ddx2s
,*Dz2c,*Dz2s;

extern double *rcs,*rsn,*d1rcs,*d1rsn,*d2rcs,*d2rsn,*z0,*d1z0,*d2z0;

extern double*Fcs,*Fsn,*dFcs,*dFsn,*xinf,*A2m,*yinf,*d1yinf,*d2yinf,*xgt,*ygt;
extern double Eps_tr;

int EcInitPlVacData()
{
  int i,j,k,ki;
  double a,b;

  Eps_tr	=1e-4;
  R0		=ESaR0[0];
  Z0		=ESaZ0[0];
  z_X0		=Z0;
  rPlVd[0]	=R0;
  rPlVd[1]	=R0;
  a		=R0/3.;
  rPlVd[2]	=R0-a;
  rPlVd[3]	=R0+a;
  b		=a;
  zPlVd[0]	=b;
  zPlVd[1]	=-b;
  zPlVd[2]	=Z0;
  zPlVd[3]	=Z0;
  ESaRx		=R0;
  ESaZx		=-b;
  for(i=4 ; i < NPlVac; i++){
    rPlVd[i]	=rPlVd[3];
    zPlVd[i]	=zPlVd[2];
  }
  for(i=0; i < ESNa1; i++){
    z0[i]	=0.;
    d1z0[i]	=0.;
    d2z0[i]	=0.;
  }
  ki	=0;
  for(k=0; k < ESFp1; k++){
    for(i=0; i < ESNa1; i++){
      rcs[ki]	=0.;
      rsn[ki]	=0.;
      d1rcs[ki]	=0.;
      d1rsn[ki]	=0.;
      d2rcs[ki]	=0.;
      d2rsn[ki]	=0.;
      ki++;
    }
  }

  for(j=0;j < ESNp1;j++){
    x0sep[j]= 0.;
    x1sep[j]= 0.;
    x2sep[j]= 0.;
  }
  for(k= 0; k < ESFp1; k++){
    x0cs[k]	=0.;
    x0sn[k]	=0.;
    rvbcs[k]	=0.;
    rvbsn[k]	=0.;
  }
  z_X2= 2.;
  for(i=0; i < 4; i++)
    k2kPlV[i]=1;
  while(i < NPlVac){
    k2kPlV[i]=0;
    rPlVd[i]=rPlVd[3];
    zPlVd[i]=zPlVd[3];
    i++;
  }
  return(0);
}

int ECRcs3D2Rcs2D(int n)
{
  int i,ki,k,km;
  R0	=ESaR0[n];
  Z0	=ESaZ0[n];
  ki	=ESNa1*n;
  for(i=0; i < ESNa1; i++){
    ECb[i]	=ESsb[ki];
    ECb1a[i]	=ESsb1a[ki];
    ECb2a[i]	=ESsb2a[ki];
    ki++;
  }
  ki	=ESnAF*n;
  km	=0;
  for(i=0; i < ESNa1; i++){
    rcs[km]	=rcT[ki];
    d1rcs[km]	=rcT1a[ki];
    d2rcs[km]	=rcT2a[ki];
    z0[km]	=rsT[ki];
    d1z0[km]	=rsT1a[ki];
    d2z0[km]	=rsT2a[ki];
    km++;
    ki++;
  }
  for(k=1; k < ESFp1; k++){
    for(i=0; i < ESNa1; i++){
      rcs[km]	=rcT[ki];
      d1rcs[km]	=rcT1a[ki];
      d2rcs[km]	=rcT2a[ki];
      rsn[km]	=rsT[ki];
      d1rsn[km]	=rsT1a[ki];
      d2rsn[km]	=rsT2a[ki];
      km++;
      ki++;
    }
  }
  return(0);
}

int ECRcs2D2Rcs3D(int n)
{
  int i,ki,k,km,in;

  ESaR0[n]	=R0;
  ESaZ0[n]	=Z0;
  in		=ESNa1*n;
  ki		=ESnAF*n;
  km		=0;
  for(i=0; i < ESNa1; i++){
    ESsb[in]	=ECb[i];
    ESsb1a[in]	=ECb1a[i];
    ESsb2a[in]	=ECb2a[i];
    rcT[ki]	=rcs[km];
    rcT1a[ki]	=d1rcs[km];
    rcT2a[ki]	=d2rcs[km];
    rsT[ki]	=z0[i];
    rsT1a[ki]	=d1z0[i];
    rsT2a[ki]	=d2z0[i];
    km++;
    ki++;
    in++;
  }
  for(k=1; k < ESFp1; k++){
    for(i=0; i < ESNa1; i++){
      rcT[ki]	=rcs[km];
      rcT1a[ki]	=d1rcs[km];
      rcT2a[ki]	=d2rcs[km];
      rsT[ki]	=rsn[km];
      rsT1a[ki]	=d1rsn[km];
      rsT2a[ki]	=d2rsn[km];
      km++;
      ki++;
    }
  }
  return(0);
}

extern double*rCc,*rCs,*rSc,*rSs,*drCc,*drCs,*drSc,*drSs;
extern double*gper,*gpei,*dgper,*dgpei;
extern int M0Mm,M0Lm,m;
static double *ac=NULL,*f,*G,*G1,*F;
static int *index;

int ECFixedPlV2vdrPlV()
{
  static int i,k,ki,kj;
  static int jj;

  for(i=0; i < ESNa1; i++){
    ki	=M0Mm*i+ESMp;
    gpei[ki]	=0.;
    for(k=1; k <  ESMp1; k++){
      kj	= ki-k;
      jj	= ki+k;
      gper[jj]	=cr2*(gper[jj]+gper[kj]);
      gpei[jj]	=cr2*(gpei[jj]-gpei[kj]);
      dgper[jj]	=cr2*(dgper[jj]+dgper[kj]);
      dgpei[jj]	=cr2*(dgpei[jj]-dgpei[kj]);
      gper[kj]	=gper[jj];
      gpei[kj]	=-gpei[jj];
      dgper[kj]	=dgper[jj];
      dgpei[kj]	=-dgpei[jj];
    }
  }
  return(0);
}

int ECVirtualPlV2vdrPlV()
{
  static int i,j,k,ki,ji,kj,Isize=0;
  static int m,mm,mi,mj,ii,jj;
  static double cs,sn,d,s,ss,am,x_0,x_1,x_2;
  static int nX,neq;

  nX	=ESFp1;
  neq	=2*(ESMp+nX);
  k	= neq*(neq+1)+3*ESNp1;
  if(Isize < k){
    if(Isize){
      free(ac);
    }
    Isize	= k;
    ac		= (double*)malloc(Isize*sizeof(double)+neq*sizeof(int));
    if(ac == NULL){
      printf("Allocation failure for ac in ECVirtualPlV2vdrPlV\n");
      exit(0);
    }
    f	=ac+neq*neq;
    G	=f+neq;
    G1	=G+ESNp1;
    F	=G1+ESNp1;
    index	=(int*)(F+ESNp1);
  }
  d_vb	+=gd_vb;
  am	=b_X+d_vb*b_X-ESsb[ESNa];
  for(i=0; i < ESNa1; i++){
    ESsb[i]	+=ESsa[i]*am;
    ESsb1a[i]	+=am;
  }

  ki	=ESNa;
  for(k=0; k < ESMp; k++){
    Fcs[k]=rcT1a[ki]+drCc[k];
    Fsn[k]=rsT1a[ki]+drCs[k];
    ki	+=ESNa1;
  }
  am	=ESsb1a[ESNa]/b_X;
  for(j=0; j < ESNp1; j++){
    ss		=cr2*(1.-ESsn1[j]*singtX)-2.*d_vb;
    s		=sqrt(ss);
    x2sep[j]	=s/d_vb;
    F[j]	=cr4*am*(2.*ss+d_vb)/ss;
    x_0		=x0sep[j];
    x_1		=cr4*x1sep[j];
    G[j]	=-x_0*s-d_vb*x_1/s;
    G1[j]	=am*((x_0-d_vb*x_1/ss)-x_1)/s;
  }
  four(rvbcs,rvbsn,G1);
  rvbcs[0]	-=am*x0sn[0]*singtX;
  rvbsn[0]	=-ESsb1a[ESNa]*singtX;
  rvbsn[1]	-=cr2*am*x0sn[0];
  for(mi=0; mi < ESMp; mi++){
    i		=mi;
    ii		=i+ESMp;
    f[mi]	=rvbcs[i]+Fcs[i];
    f[ii]	=rvbsn[i]+Fsn[i];
    i		*=neq;
    ii		*=neq;
    for(mj=0,j=2*nX; mj < ESMp; mj++,j++){
      jj		=(mj+1)*ESMp1+mi;
      ac[i+j]		=-drCc[jj];
      ac[i+j+ESMp]	=-drSc[jj];
      ac[ii+j]		=-drCs[jj];
      ac[ii+j+ESMp]	=-drSs[jj];
    }
  }
  four(Fcs,Fsn,F);
  ac[0]		=Fcs[0];
  ac[ESMp*neq]	=0.;
  for(k=1; k < nX; k++){
    ac[k]		=2.*Fcs[k];
    ac[nX+k]		=2.*Fsn[k];
    ac[ESMp*neq+k]	=0.;
    ac[ESMp*neq+k+nX]	=0.;
  }
  for(mi=1; mi < ESMp; mi++){
    i	=mi;
    ii	=mi+ESMp;
    i	*=neq;
    ii	*=neq;
    for(mj=0; mj < nX; mj++){
      ac[i+mj]		=0.;
      ac[i+mj+nX]	=0.;
      ac[ii+mj]		=0.;
      ac[ii+mj+nX]	=0.;
    }
    for(k=1,mm=mi+k; k <ESFp1 && mm < nX; k++,mm++){
      ac[i+mm]		+=Fcs[k];
      ac[i+mm+nX]	+=Fsn[k];
      ac[ii+mm]		-=Fsn[k];
      ac[ii+mm+nX]	+=Fcs[k];
    }
    for(k=0,mm=mi-k; k < ESFp1; k++,mm--){
      mj	=abs(mm);
      if(mj < nX){
	if(mm > 0){
	  ac[i+mm]	+=Fcs[k];
	  ac[i+mm+nX]	-=Fsn[k];
	  ac[ii+mm]	+=Fsn[k];
	  ac[ii+mm+nX]	+=Fcs[k];
	}
	else{
	  ac[i+mj]	+=Fcs[k];
	  ac[i+mj+nX]	+=Fsn[k];
	  ac[ii+mj]	+=Fsn[k];
	  ac[ii+mj+nX]	-=Fcs[k];
	}
      }
    }
    ac[i+nX]	=0.;
    ac[ii+nX]	=0.;
  }
  ac[nX]		=2.*am*x0sn[0]*d_vb*singtX;
  ac[ESMp*neq+nX]	=2.*ESsb1a[ESNa]*d_vb*singtX;

  four(rvbcs,rvbsn,G);
  rvbcs[0]	+=ESaR0[0]-ESaRx+x0sn[0]*(1.-d_vb)*singtX;
  rvbsn[0]	=ESaZ0[0]-z_X0-d_vb*b_X*singtX;
  rvbsn[1]	-=cr2*ESsb[ESNa]*x0sn[0]/b_X;
  for(mi=0,k=0; mi < nX; mi++,k++){
    i		=2*ESMp+mi;
    ii		=i+nX;
    f[i]	=rvbcs[k]+rcT[ESNa1*k+ESNa];
    f[ii]	=rvbsn[k]+rsT[ESNa1*k+ESNa];
    i		*= neq;
    ii		*= neq;
    for(mj=0,j=2*nX; mj < ESMp; mj++,j++){
      if(k < ESMp1){
	jj		=(mj+1)*ESMp1+k;
	ac[i+j]		=-rCc[jj];
	ac[i+j+ESMp]	=-rSc[jj];
	ac[ii+j]	=-rCs[jj];
	ac[ii+j+ESMp]	=-rSs[jj];
      }
      else{
	ac[i+j]		=0.;
	ac[i+j+ESMp]	=0.;
	ac[ii+j]	=0.;
	ac[ii+j+ESMp]	=0.;
      }
    }
  }
  am	=cr4*d_vb;
  for(mi=0,k=0; mi < nX; mi++,k++){
    i	=2*ESMp+mi;
    ii	=i+nX;
    i	*=neq;
    ii	*=neq;
    for(mj=0; mj < nX; mj++){
      ac[i+mj]		=0.;
      ac[i+mj+nX]	=0.;
      ac[ii+mj]		=0.;
      ac[ii+mj+nX]	=0.;
    }
    ac[i+k]		=am;
    ac[ii+k+nX]		=am;
  }
  ac[2*ESMp*neq+nX]	=x0sn[0]*d_vb*d_vb*singtX;
  ac[(2*ESMp+nX)*neq+nX]=b_X*d_vb*d_vb*singtX;

  LUdcmp(ac,neq,index,&am);
  LUbksb(ac,neq,index,f);

  z_X2	=f[nX];
  for(j=0; j < ESNp; j++){
    x_2		=0.;
    kj		=0;
    for(k=1; k < nX; k++){
      kj	+=j;
      if(kj >= ESNp){
	kj	-=ESNp;
      }
      x_2	+=f[k]*EScs1[kj]+f[nX+k]*ESsn1[kj];
    }
    x2sep[j]	*=(f[0]+2.*x_2);
  }
  x2sep[ESNp]	=x2sep[0];
  for(i=0; i < ESNa1; i++){
    mj		=M0Mm*i+ESMp;
    gpei[mj]	=0.;
    for(k=1; k < ESMp1; k++){
      kj	=mj-k;
      jj	=mj+k;
      gper[jj]	=cr2*(gper[jj]+gper[kj]);
      gpei[jj]	=cr2*(gpei[jj]-gpei[kj]);
      dgper[jj]	=cr2*(dgper[jj]+dgper[kj]);
      dgpei[jj]	=cr2*(dgpei[jj]-dgpei[kj]);
    }
    for(k=0; k < ESMp1; k++){
      mj	=M0Mm*i+ESMp+k;
      kj	=M0Mm*i+ESMp-k;
      for(m=1,mi=2*nX; m < ESMp1; m++,mi++){
	mm	=mi+ESMp;
	j	=mj+ES2Mp1*m;
	jj	=kj+ES2Mp1*m;
	gper[mj]+=cr2*(f[mi]*(gper[j]+gper[jj])+f[mm]*(gpei[j]+gpei[jj]));
	gpei[mj]+=cr2*(f[mi]*(gpei[j]-gpei[jj])-f[mm]*(gper[j]-gper[jj]));
	dgper[mj]+=cr2*(f[mi]*(dgper[j]+dgper[jj])+f[mm]*(dgpei[j]+dgpei[jj]));
	dgpei[mj]+=cr2*(f[mi]*(dgpei[j]-dgpei[jj])-f[mm]*(dgper[j]-dgper[jj]));
      }
      gper[kj]	=gper[mj];
      gpei[kj]	=-gpei[mj];
      dgper[kj]	=dgper[mj];
      dgpei[kj]	=-dgpei[mj];
    }
  }

  for(k=0; k < ESMp1; k++){
    for(m=1,mi=2*nX; m < ESMp1; m++,mi++){
      mm	=mi+ESMp;
      j		=ESMp1*m+k;
      rCc[k]	+=f[mi]*rCc[j]+f[mm]*rSc[j];
      drCc[k]	+=f[mi]*drCc[j]+f[mm]*drSc[j];
      rCs[k]	+=f[mi]*rCs[j]+f[mm]*rSs[j];
      drCs[k]	+=f[mi]*drCs[j]+f[mm]*drSs[j];
    }
  }
  return(0);
}

int ECDeVirtualPlV2vdrPlV()
{
  if(ac != NULL){
    free(ac);
    ac	=NULL;
  }
  return(0);
}

int EcMetrTnsrX()
{
  static int i,j,k,ki,kj,iX,iO;
  static double r,x_0,dx_0,d2x_0;
  static double cs,sn,d,s,sqs,x_1,x_2,z_1;
  extern double dx_0x,d2x_0x,dx_0o,d2x_0o;

  for(i=0; i < ESnBL1; i++){
    ESDx[i]	=0.;
    ESLx[i]	=0.;
    ESVx[i]	=0.;
  }
  i	=ESNp/4;
  j	=3*ESNp/4;
  if(ESaZx > 0.){
    iX	=i;
    iO	=j;
  }
  else{
    iX	=j;
    iO	=i;
  }
  for(j=0; j < ESNp1; j++){
    dx_0	=0.;
    d2x_0	=0.;
    kj		=0;
    for(k=1; k <nf_X; k++){
      kj	+=j;
      if(kj >= ESNp){
	kj	-=ESNp;
      }
      cs	=EScs1[kj];
      sn	=ESsn1[kj];
      dx_0	+=k*(-x0cs[k]*sn+x0sn[k]*cs);
      d2x_0	+=k*k*(x0cs[k]*cs+x0sn[k]*sn);
    }
    dx_0	*=2.*singtX;
    d2x_0	*=-2.;
    cs		=EScs1[j];
    sn		=ESsn1[j]*singtX;
    s		=1./(cr2*(1.-sn)-2.*d_vb);
    sqs		=sqrt(s);
    x_1		=3.*dx_0*(1.-sn*singtX)+(2.*d2x_0-x0sep[j])*cs;
    for(i=0; i < ESnBL1; i++){
      d		=d_vb*sqrt((ESnBL-i)/(double)ESnBL);
      s		=cr2*(1.-sn)-2.*d;
      sqs	=sqrt(s);
      if(i != ESnBL){
	x_1	=cr4*(x1sep[j]+d*x2sep[j])/s;
      }
      else{
	x_1	=0.;
      }
      z_1	=(d+d*d*z_X2)*singtX+(1.+d)*sn*singtX;
      r		=ESaRx+(x0sep[j]+d*x_1)*sqs+x0sn[0]*(z_1-singtX);
      if(j != iX){
	x_1	=cr2*(dx_0*(4.*z_X2*(1.-sn)-8.*(1.+sn))
		      +(2.*d2x_0*(1.+sn)-2.*x2sep[j]-2.*x0sep[j]*z_X2
			-(2.*dx_0*cs+2.*x0sep[j])/(1.-sn)
			-cr2*x0sep[j]*(5.-sn)
			)*cs)/sqs;
	s	=ESgt[j]-ESgt[iX];
	x_2	=16.*dx_0x/sqrt(s*s-8.*d);
	ESDx[i]	+=x_1+x_2;
	ESLx[i]	+=x_1/r+x_2/ESaRx;
	ESVx[i]	+=x_1*r+x_2*ESaRx;
      }	
    }
  }
  s	=1./ESNp;
  for(i=0; i < ESnBL1; i++){
    ESDx[i]	*=s;
    ESLx[i]	*=s;
    ESVx[i]	*=s;
  }
  x_1	=-16.*dx_0x;
  d	=d_vb;
  ESgFPlVx=-d*d*b_X*ESRBt*(cr4*x_1*(log(-2.*d/(cgp*cgp))-cr2)/ESaRx
			   -0.125*(ESLx[0]+ESLx[1]));
  printf("??? dgaF=%10.3e EsiAx=%d\n",ESgFPlVx,ESiAx);
  return(0);
}

int ECVirtualPlV00()
{
  static int i,j,k,ki,ji,kj;
  static int m,mm,mi,mj,ii,jj;
  static double cs,sn,d,s,ss,am,x_0,x_1,x_2;
  static int nX,neq;

  if(ESiAx == 0){
    return(0);
  }

  nX	=ESFp1;
  neq	=2*nX;

  for(j=0; j < ESNp1; j++){
    cs		=EScs1[j];
    sn		=ESsn1[j];
    ss		=cr2*(1.-singtX*sn)-2.*d_vb;
    s		=sqrt(ss);
    x2sep[j]	=s/d_vb;
    x_0		=x0sep[j];
    x_1		=cr4*x1sep[j];
    G[j]	=-x_0*s-d_vb*x_1/s;
  }
  four(rvbcs,rvbsn,G);
  z_X2	=(ESaZ0[0]+rsT[ESNa]-z_X0-d_vb*b_X*singtX)/b_X;
  am		=4./d_vb;
  rvbcs[0]	+=ESaR0[0]+rcT[ESNa]-ESaRx-x0sn[0]*(1.-d_vb-z_X2)*singtX;
  f[0]		=rvbcs[0]*am;
  z_X2		/=d_vb*d_vb;
  rvbsn[1]	+=cr2*ESsb[ESNa]*x0sn[0]/b_X;
  for(k=1; k < nX; k++){
    f[k]	=(rvbcs[k]+rcT[ESNa1*k+ESNa])*am;
    f[k+nX]	=(rvbsn[k]+rsT[ESNa1*k+ESNa])*am;
  }

  for(j=0; j < ESNp; j++){
    x_2		=0.;
    kj		=0;
    for(k=1; k < nX; k++){
      kj	+=j;
      if(kj >= ESNp){
	kj	-= ESNp;
      }
      x_2	+=f[k]*EScs1[kj]+f[nX+k]*ESsn1[kj];
    }
    x2sep[j]	*=(f[0]+2.*x_2);
  }
  x2sep[ESNp]	=x2sep[0];
  return(0);
}

int ECvdrzCorrectionX()
{
  static int i,j,k,ki,ji,kj;
  static int m,mm,mi,mj,ii,jj;
  static double cs,sn,d,s,ss,am,x_0,x_1,x_2;
  static int nX,neq;

  nX	=ESFp1;
  neq	=2*nX;
  d_vb	=(ECb[ESNa]-b_X)/b_X;

  for(j=0; j < ESNp1; j++){
    ss		=cr2*(1.-ESsn1[j]*singtX)-2.*d_vb;
    s		=sqrt(ss);
    x2sep[j]	=s/d_vb;
    G[j]	=-x0sep[j]*s-d_vb*cr4*x1sep[j]/s;
  }
  four(rvbcs,rvbsn,G);
  z_X2	=(Z0+z0[ESNa]-z_X0-d_vb*b_X*singtX)/b_X;
  am		=4./d_vb;
  rvbcs[0]	+=R0+rcs[ESNa]-ESaRx-x0sn[0]*(1.-d_vb-z_X2)*singtX;
  f[0]		=rvbcs[0]*am;
  z_X2		/=d_vb*d_vb;
  rvbsn[1]	-=cr2*ECb[ESNa]*x0sn[0]/b_X;
  for(k=1; k < nX; k++){
    f[k]	=(rvbcs[k]+rcs[ESNa1*k+ESNa])*am;
    f[k+nX]	=(rvbsn[k]+rsn[ESNa1*k+ESNa])*am;
  }
  for(j=0; j < ESNp; j++){
    x_2		=0.;
    kj		=0;
    for(k=1; k < nX; k++){
      kj	+=j;
      if(kj >= ESNp){
	kj	-=ESNp;
      }
      x_2	+=f[k]*EScs1[kj]+f[nX+k]*ESsn1[kj];
    }
    x2sep[j]	*=(f[0]+2.*x_2);
  }
  x2sep[ESNp]	=x2sep[0];
  return(0);
}

