#include <string.h>
#include <math.h>
#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <X11/Xatom.h>
#include <X11/keysym.h>
#ifdef HP
#define lsode_ lsode
#endif
#ifdef CRAY
#define lsode_ LSODE
#endif

#define NCONST 32
#define NCONST1 10
#define NUNITS 8
#define NInC0 22
#define NInC1 14
#define NDATA0 7
#define NDATA1 9
#include "sesc_def.h"

extern Display*theD;
extern Window theW;
extern int NWin,Wmode;
extern WinPar*WinP;
extern GC theGC;
extern XEvent msg;
extern double cr2,cr3,cr4,cr6,cr12,cgp,c2gp,cgp_4,cr2gp,cgm0,crgm0;
extern double ttime;
extern double ga0,ga1,ga2,ga3;
extern int na,nt,na1,nt1,n_at,nf1;
extern int*icolrz;
extern int Luv,Lr;
extern double*Fcs,*Fsn,*dFcs,*dFsn,*yinf,*d1yinf,*d2yinf,*xgt,*ygt;
extern double*ucs,*usn,*d2ucs,*d2usn,*vcs,*vsn,*d2vcs,*d2vsn,
*rcs,*rsn,*d1rcs,*d1rsn,*d2rcs,*d2rsn;
extern double*ccs,*csn,*Dcs,*d2Dcs,*Dsn,*g22c,*g22s;
extern double*DMer,*d2DMer;
extern double*r,*z;
extern double*dra,*drgt,*dza,*dzgt;
extern double sc_X;
extern double*a,*aa,*b;
extern double*gt;
extern double R0,rcs10,rsn10;
extern FILE*fp;
extern char*RunID,*PageName;
extern double*q_a,*d2q_a,*FF_a,*d2FF_a,*FFs_a,*d2FFs_a,*Ps_a,*d2Ps_a,
*dp_a,*d2dp_a,*gpe0,*dgpe0,*dgp_a,*d2dgp_a,*p_a,*d2p_a,*bJ_a,*d2bJ_a,
*j_sa,*d2j_sa,*j_pa,*d2j_pa;

extern double*ne_a,*d2ne_a,*pe_a,*d2pe_a,*pi_a,*d2pi_a,scal_p[];
extern int Ispl;
extern PlProfile PlProf[];
extern char nameY[];
extern int TaskMask;
extern double NModel[];
extern int MModel[];

int FlagBalOut= 0;

double d2de,gr2rs,gomep1,gomep,gomip1,gomip,gt2tA;
int ntor,ntore,ntors,ntoro;
double go2oi,goiRgo,goiRA,goeRA,goRgoi,goeigen,bR2f,bH2f,bF2f;


double*y,*dy;
double hcur,xout,rtol= 1.0e-6,atlr= 1e-7;
double*rwork,*yh,*acor;
int itol= 1,neq,itask= 5,istate= 1,iopt= 0,mf= 10,lrw,liw= 20;
int*iwork;
double*gbcrBal,*gbBal;


static double *f2,*f1,*f0,*g0,*g1,*g3,*rf2,*gf2,*ggf2,
*d2f2,*d2f1,*d2f0,*d2g0,*d2g1,*d2g3,*d2rf2,*d2gf2,*d2ggf2,*ttA,*d2ttA,
*kkp,*d2kkp,*kkpb,*d2kkpb;
static double *g00,*d2g00,*g01,*d2g01,*g10,*d2g10,*g30,*d2g30;
static double *x1cs,*x1sn,*dx1cs,*dx1sn,gt0= 0.;

int mem4ball(nequations)
     int nequations;
{
  f0	=(double*)malloc(32*nt1*sizeof(double));
  if(f0 == NULL){
    printf("Failure in memory allocation in memball\n");
    exit(0);
  }
  f1	=f0+nt1;
  f2	=f1+nt1;
  g0	=f2+nt1;
  g1	=g0+nt1;
  g3	=g1+nt1;
  rf2	=g3+nt1;
  gf2	=rf2+nt1;
  ggf2	=gf2+nt1;
  d2f2	=ggf2+nt1;
  d2f1	=d2f2+nt1;
  d2f0	=d2f1+nt1;
  d2g0	=d2f0+nt1;
  d2g1	=d2g0+nt1;
  d2g3	=d2g1+nt1;
  d2rf2	=d2g3+nt1;
  d2gf2	=d2rf2+nt1;
  d2ggf2=d2gf2+nt1;
  g00	=d2ggf2+nt1;
  d2g00	=g00+nt1;
  g01	=d2g00+nt1;
  d2g01	=g01+nt1;
  g10	=d2g01+nt1;
  d2g10	=g10+nt1;
  g30	=d2g10+nt1;
  d2g30	=g30+nt1;
  ttA	=d2g30+nt1;
  d2ttA	=ttA+nt1;
  kkp	=d2ttA+nt1;
  d2kkp	=kkp+nt1;
  kkpb	=d2kkp+nt1;
  d2kkpb=kkpb+nt1;

  gbcrBal= (double*)malloc(2*na1*sizeof(double));
  if(gbcrBal == NULL){
    printf("Failure in memory allocation in memball()\n");
    exit(0);
  }
  gbBal	=gbcrBal+na1;

  x1cs	=(double*)malloc(4*nf1*sizeof(double));
  if(x1cs == NULL){
    printf("Failure in memory allocation in memball()\n");
    exit(0);
  }
  x1sn	=x1cs+nf1;
  dx1cs	=x1sn+nf1;
  dx1sn	=dx1cs+nf1;

  neq	=nequations;
  lrw	=liw+16*neq;
  iwork	=(int*)malloc(liw*sizeof(int));
  if(iwork == NULL){
    printf("Failure in memory allocation for iwork in memball()\n");
    exit(0);
  }
  rwork	=(double*)malloc((lrw+2*neq)*sizeof(double));
  if(rwork == NULL){
    printf("Failure in memory allocation for rwork in memball()\n");
    exit(0);
  }
  yh	=rwork+20;
  acor	=rwork+lrw-neq;
  y	=acor+neq;
  dy	=y+neq;
  return(0);
}

int demem4ball()
{
  free(f0);
  free(gbcrBal);
  free(x1cs);
  free(iwork);
  free(rwork);
}

BallooningCoef(A0,i)
     double*A0;
     int i;
{
  static double q,sh,A,rF,drF,BB0,vBB;
  static double g22,g12,D,ts,tq,tb,v,dvgt,dva,br,tor,u0,du0,u,tu;
  static int j,j1,ji,k,ki,kj;
  static double h,h2,a1,a2,a2m,a2m1,ss;
  static double ds,ge,dgea,dgegt,ge0,dgea0,x1,dx1,x0,dx0,cs,sn;
  static double ag00,ag01,ag1,agg1,af2;

  Ispl= i?i-1:0;
  a1= a[i];
  a2= aa[i];
  tor= a1/R0;
  BB0= FF_a[0]/(R0*R0);
  gt2tA= 4.*c2gp*1.6726e-28*ne_a[i]*R0*R0/BB0;

  d2de= 2.8143e+7/ne_a[i];
  gr2rs= d2de*p_a[i]*3672./BB0;
  u0= usn[0]+a2*ucs[i];
  A= -Ps_a[i]*u0*R0/dgpe0[i];
  *A0= A;
  rF= 1./sqrt(FF_a[i]);
  drF= -FFs_a[i]*dgpe0[i]*rF*rF*R0;
  spl_r1(&q,&sh,a+i,q_a,d2q_a,a,&na,&Ispl);
  q= -u0/(R0*dgpe0[i]*rF);
  sh/= q;

  if(i){
    spl_r1(&D,&gomep1,a+i,pe_a,d2pe_a,a,&na,&Ispl);
    spl_r1(&D,&gomip1,a+i,pi_a,d2pi_a,a,&na,&Ispl);
    spl_r1(&D,&goiRgo,a+i,p_a,d2p_a,a,&na,&Ispl);
    gomep1/= (a[i]*dgpe0[i]);
    gomip1/= (a[i]*dgpe0[i]);
    goiRgo/= (a[i]*dgpe0[i]);
  }
  else{
    gomep1= d2pe_a[0]/dgpe0[i];
    gomip1= d2pi_a[0]/dgpe0[i];

    goiRgo= d2p_a[0]/dgpe0[i];
  }
  goeRA= goiRgo!=0.?gomep1/goiRgo:cr2;
  goiRA= goiRgo!=0.?gomip1/goiRgo:cr2;

  gomep1*= -1000./(scal_p[5]*ne_a[i]);

  gomip1*= 1000./(scal_p[5]*ne_a[i]);

  a2m= -1000.*dgpe0[i]/(scal_p[5]*ne_a[i]*u0*R0);
  goeRA*= -a2m;
  goiRA*= a2m;


  spl_r1(Fcs,&du0,a+i,ucs,d2ucs,a,&na,&Ispl);
  ss= 2./u0;
  du0= -(a1*ucs[i]+cr2*a2*du0)*ss;
  for(k= 1;k<Luv;k++){
    ki= na1*k;
    spl_r1(Fcs+k,dFcs+k,a+i,ucs+ki,d2ucs+ki,a,&na,&Ispl);
    Fcs[k]*= ss;
    dFcs[k]= (dFcs[k]*ss+Fcs[k]*du0)*a1/k+Fcs[k];
    spl_r1(Fsn+k,dFsn+k,a+i,usn+ki,d2usn+ki,a,&na,&Ispl);
    Fsn[k]*= ss;
    dFsn[k]= (dFsn[k]*ss+Fsn[k]*du0)*a1/k+Fsn[k];
    ss*= a1;
  }


  x0= a1*rcs[i];
  dx0= a1*d1rcs[i]+2.*rcs[i];
  a2m= 2.;
  a2m1= 2.;
  for(k= 1;k<Lr;k++){
    ki= na1*k+i;
    x1cs[k]= a2m*rcs[ki];
    x1sn[k]= a2m*rsn[ki];
    dx1cs[k]= a2m*d1rcs[ki];
    dx1sn[k]= a2m*d1rsn[ki];
    if(k>1){
      dx1cs[k]+= (k-1)*a2m1*rcs[ki];

      dx1sn[k]+= (k-1)*a2m1*rsn[ki];

      a2m1*= a1;
    }
    a2m*= a1;
  }


  for(j= 0,ji= nt1*i;j<nt1;j++,ji++){
    g22= drgt[ji]*drgt[ji]+dzgt[ji]*dzgt[ji];
    g12= dra[ji]*drgt[ji]+dza[ji]*dzgt[ji];
    D= dra[ji]*dzgt[ji]-dza[ji]*drgt[ji];
    br= r[ji]/R0;
    vBB= (FF_a[i]+aa[i]*g22*dgpe0[i]*dgpe0[i]/(D*D))/(r[ji]*r[ji]);

    kkpb[j]= br*D/(dgpe0[i]*dgpe0[i]);
    kkp[j]= kkpb[j]*vBB;
    kkpb[j]*= BB0;
    ttA[j]= gt2tA*kkpb[j]*br*D;

    tu= 0.;

    ge= 0.;


    dgea= 0.;

    for(k= 1,kj= k+nf1*j;k<Luv;k++,kj++){
      cs= ccs[kj];
      sn= csn[kj];
      tu+= Fcs[k]*cs+Fsn[k]*sn;
      ge+= (Fcs[k]*sn-Fsn[k]*cs)/k;
      dgea+= dFcs[k]*sn-dFsn[k]*cs;
    }
    if(j){
      ge-= ge0;
      dgea-= dgea0;
    }
    else{
      ge0= ge;
      dgea0= dgea;
      ge= 0.;
      dgea= 0.;
    }
    ge*= a1;
    x1= 0.;
    dx1= 0.;

    for(k= 1,kj= k+nf1*j;k<Lr;k++,kj++){
      cs= ccs[kj];
      sn= csn[kj];
      x1+= x1cs[k]*cs+x1sn[k]*sn;
      dx1+= dx1cs[k]*cs+dx1sn[k]*sn;
    }
    xgt[j]= x1;
    u= 1.+tu*a1;
    tq= q*u;
    tb= tor/(br*tq);
    tb= 1./(1.+g22*tb*tb);
    ts= sh*ge+dgea;


    h= g22*tb/(br*D);
    h2= ts/u;
    if(i)h2-= g12/(a1*g22);
    f2[j]= h/(u*u);
    f1[j]= 2.*h*h2*sh/u;
    f0[j]= h*h2*h2;
    if(i)f0[j]+= D/(a2*g22*br);


    h= x1+x0;
    g10[j]= (2.+tor*h)*h;


    dva= 2.*(dx1+dx0)+br*drF;
    g00[j]= (2.*drgt[ji]*ts-dva*u)*br-2.*x1*(u*(x1+x0)/R0+tu);
    g01[j]= -br*br*br*D*tb/(q*q);
    g00[j]-= sh*g10[j];
    h= tb/(tq*tq);
    g10[j]-= tor*g22*h;
    g30[j]= (tor*g22*ts-g12*u/R0)*h;


    rf2[j]= 1./f2[j];
    h= g10[j];
    gf2[j]= h*rf2[j];
    ggf2[j]= h*gf2[j];
    f2[j]*= sh*sh;
    g10[j]*= sh;
  }
  spl_p_(f0,d2f0,gt,&nt);
  spl_p_(f1,d2f1,gt,&nt);
  spl_p_(f2,d2f2,gt,&nt);
  spl_p_(g00,d2g00,gt,&nt);
  spl_p_(g01,d2g01,gt,&nt);
  spl_p_(g10,d2g10,gt,&nt);
  spl_p_(g30,d2g30,gt,&nt);
  spl_p_(rf2,d2rf2,gt,&nt);
  spl_p_(gf2,d2gf2,gt,&nt);
  spl_p_(ggf2,d2ggf2,gt,&nt);
  spl_p_(kkp,d2kkp,gt,&nt);
  spl_p_(kkpb,d2kkpb,gt,&nt);
  spl_p_(ttA,d2ttA,gt,&nt);
  af2= 0.;
  ag00= 0.;
  ag01= 0.;
  ag1= 0.;
  agg1= 0.;
  for(j= 0,j1= j+1;j<nt;j++,j1++){
    h= cr2*(gt[j1]-gt[j]);
    h2= -cr3*h*h;
    af2+= h*(rf2[j]+rf2[j1]+h2*(d2rf2[j]+d2rf2[j1]));

    ag00+= h*(g00[j]+g00[j1]+h2*(d2g00[j]+d2g00[j1]));
    ag01+= h*(g01[j]+g01[j1]+h2*(d2g01[j]+d2g01[j1]));
    ag1+= h*(gf2[j]+gf2[j1]+h2*(d2gf2[j]+d2gf2[j1]));

    agg1+= h*(ggf2[j]+ggf2[j1]+h2*(d2ggf2[j]+d2ggf2[j1]));


  }
  ag1/= af2;
  agg1-= ag1*ag1*af2;
  ag1*= sh;
  ag00+= ag1;
  ag01-= agg1;
  DMer[i]= 0.25*sh*sh+A*(ag00+A*ag01)*af2;

  if(i){
    for(j= 0;j<nt1;j++){
      g10[j]-= ag1;
      g00[j]+= ag1-2.*xgt[j]/a1;
    }
    spl_p_(g00,d2g00,gt,&nt);

    for(j= 0;j<nt1;j++){
      g00[j]+= A*g01[j];
      d2g00[j]+= A*d2g01[j];
      g01[j]= 0.;
      d2g01[j]= 0.;
    }

  }
}

SetBallCoef(P)
     double P;
{
  int j;
  for(j= 0;j<nt1;j++){
    g1[j]= P*g10[j];
    d2g1[j]= P*d2g10[j];
    g3[j]= P*g30[j];
    d2g3[j]= P*d2g30[j];
    g0[j]= P*(g00[j]+P*g01[j]);
    d2g0[j]= P*(d2g00[j]+P*d2g01[j]);
  }
  gomip= P*goiRA;
  gomep= P*goeRA;

  if(gomep<=0.){
    if(gomip>0.)
      goeigen= cr2*gomip;
    else
      goeigen= 0.;
  }
  else
    if(gomip>gomep)
      goeigen= cr2*(gomip+gomep);
    else
      goeigen= 0.;
  go2oi= ntoro*ntoro*goeigen*(gomip-goeigen);
  if(goeigen-gomep!=0.)
    bR2f= goeigen/(goeigen-gomep);
  else
    bR2f= cr2;
  bH2f= ntors*ntors*gr2rs;
  if(fabs(gomip-gomep)>1e-4*fabs(goeigen))
    bF2f= bH2f*goeigen/(gomip-gomep);
  else
    bF2f= 0.;

  bH2f*= bR2f;
  bR2f*= ntore*ntore*d2de;
  bF2f-= bH2f;
  goeigen*= ntoro;
  gomip*= ntoro;
  gomep*= ntoro;
}

void ballooning(neq,x,y,dy)
     int*neq;
     double*x,*y,*dy;
{
  static double t,x0= 0.;
  static double sf2,sf1,sf0,sg0,sg1,sg3,df2,df1,df0,dg0,dg1,dg3;
  static double skp,skpb,bK,bG,bI,dI,bR,bH,bF;

  while(x0>(*x)+gt0)x0-= c2gp;
  while(x0+c2gp<=(*x)+gt0)x0+= c2gp;
  t= ((*x)+gt0-x0)*cr2gp;
  if(t>1.)t= 1.;
  if(t<0.)t= 0.;
  while(gt[Ispl+1]<t)Ispl++;
  while(t<gt[Ispl])Ispl--;
  if(Ispl==nt)Ispl--;
  spl_r1(&sf0,&df0,&t,f0,d2f0,gt,&nt,&Ispl);
  spl_r1(&sf1,&df1,&t,f1,d2f1,gt,&nt,&Ispl);
  spl_r1(&sf2,&df2,&t,f2,d2f2,gt,&nt,&Ispl);
  spl_r1(&sg0,&dg0,&t,g0,d2g0,gt,&nt,&Ispl);
  spl_r1(&sg1,&dg1,&t,g1,d2g1,gt,&nt,&Ispl);
  spl_r1(&sg3,&dg3,&t,g3,d2g3,gt,&nt,&Ispl);
  spl_r1(&skp,&dI,&t,kkp,d2kkp,gt,&nt,&Ispl);
  spl_r1(&skpb,&dI,&t,kkpb,d2kkpb,gt,&nt,&Ispl);
  spl_r1(&bI,&dI,&t,ttA,d2ttA,gt,&nt,&Ispl);
  sg3-= sg1*(*x);
  bK= (sf2*(*x)+sf1)*(*x)+sf0;
  skp*= bK;
  skpb*= bK;
  bR= bR2f*skp;
  bH= bH2f*skpb;
  bF= bF2f*skpb;
  bG= 1./(1.+bH);
  bI*= bK*bG;
  bG*= sg0+sg1+(dg1*(*x)-dg3)*cr2gp;

  dy[0]= (y[1]-sg3*y[0])*(1.+bR)/bK;
  dy[1]= (sg0+bG*bF+go2oi*bI)*y[0]+sg3*dy[0];

  if(fabs(y[0])>1e+10){
    printf("bR2f=%11.4e%11.4e%11.4e\n",bR2f,bH2f,bF2f);
    printf("skp=%11.4e%11.4e\n",skp,skpb);
    printf("bR=%11.4e%11.4e%11.4e\n",bR,bH,bF);
    printf("bK=%11.4e%11.4e\n",bK,bG);
    printf("y=%11.4e%11.4e%11.4e%11.4e\n",y[0],y[1],dy[0],dy[1]);
    exit(0);
  }
}

void ballooning0(neq,x,y,dy)
     int*neq;
     double*x,*y,*dy;
{
  static double t,x0= 0.;
  static double sf2,sf1,sf0,sg0,sg1,sg3,df2,df1,df0,dg0,dg1,dg3;
  static double skp,skpb,bK,bG,bI,dI,bR,bH,bF;

  while(x0>(*x)+gt0)x0-= c2gp;
  while(x0+c2gp<=(*x)+gt0)x0+= c2gp;
  t= ((*x)+gt0-x0)*cr2gp;
  if(t>1.)t= 1.;
  if(t<0.)t= 0.;
  while(gt[Ispl+1]<t)Ispl++;
  while(t<gt[Ispl])Ispl--;
  if(Ispl==nt)Ispl--;
  spl_r1(&sf0,&df0,&t,f0,d2f0,gt,&nt,&Ispl);
  spl_r1(&sf1,&df1,&t,f1,d2f1,gt,&nt,&Ispl);
  spl_r1(&sf2,&df2,&t,f2,d2f2,gt,&nt,&Ispl);
  spl_r1(&sg0,&dg0,&t,g0,d2g0,gt,&nt,&Ispl);
  spl_r1(&sg1,&dg1,&t,g1,d2g1,gt,&nt,&Ispl);
  spl_r1(&sg3,&dg3,&t,g3,d2g3,gt,&nt,&Ispl);
  spl_r1(&skp,&dI,&t,kkp,d2kkp,gt,&nt,&Ispl);
  spl_r1(&skpb,&dI,&t,kkpb,d2kkpb,gt,&nt,&Ispl);
  spl_r1(&bI,&dI,&t,ttA,d2ttA,gt,&nt,&Ispl);
  sg3-= sg1*(*x);
  bK= (sf2*(*x)+sf1)*(*x)+sf0;
  skp*= bK;
  skpb*= bK;
  bR= bR2f*skp;
  bH= bH2f*skpb;
  bF= bF2f*skpb;
  bG= 1./(1.+bH);
  bI*= bK*bG;
  bG*= sg0+sg1+(dg1*(*x)-dg3)*cr2gp;

  dy[0]= (y[1]-sg3*y[0])*(1.+bR)/bK;
  dy[1]= (sg0+bG*bF+go2oi*bI)*y[0]+sg3*dy[0];



  printf("ballonn 0\n");

  printf("bR2f=%11.4e%11.4e%11.4e\n",bR2f,bH2f,bF2f);
  printf("skp=%11.4e%11.4e\n",skp,skpb);
  printf("bR=%11.4e%11.4e%11.4e\n",bR,bH,bF);
  printf("bK=%11.4e%11.4e\n",bK,bG);
  printf("sg0=%11.4e%11.4e%11.4e%11.4e\n",
	 sg0,sg1,(dg1*(*x)-dg3)*cr2gp,sg3);
  printf("y=%11.4e%11.4e%11.4e%11.4e\n",y[0],y[1],dy[0],dy[1]);
}

InitBall(y1,y,dy,x)
     double*y1,x,y,dy;
{
  static double t,x0= 0.;
  static double sf2,sf1,sf0,sg0,sg1,sg3,df,dg1,skp,bK,bR;

  while(x0>x+gt0)x0-= c2gp;
  while(x0+c2gp<=x+gt0)x0+= c2gp;
  t= (x+gt0-x0)*cr2gp;
  if(t>1.)t= 1.;
  if(t<0.)t= 0.;
  while(gt[Ispl+1]<t)Ispl++;
  while(t<gt[Ispl])Ispl--;
  if(Ispl==nt)Ispl--;
  spl_r1(&sf0,&df,&t,f0,d2f0,gt,&nt,&Ispl);
  spl_r1(&sf1,&df,&t,f1,d2f1,gt,&nt,&Ispl);
  spl_r1(&sf2,&df,&t,f2,d2f2,gt,&nt,&Ispl);
  spl_r1(&sg1,&df,&t,g1,d2g1,gt,&nt,&Ispl);
  spl_r1(&sg3,&df,&t,g3,d2g3,gt,&nt,&Ispl);
  spl_r1(&skp,&df,&t,kkp,d2kkp,gt,&nt,&Ispl);
  sg3-= sg1*x;
  bK= (sf2*x+sf1)*x+sf0;
  skp*= bK;
  bR= bR2f*skp;
  *y1= dy*bK/(1.+bR)+sg3*y;
}

FILE*BalFpnt,*BalFpnt1;
BallooningTest0()
{
  static double x,P0,P,P2,fP0,uuu[4],eps= 0.001,s,G,A[na_DEF+1],Acr[na_DEF+1];
  static double y1[1001],x1[1001],xmax;
  static int i,j,ji,k,j1,n1= 1001,Wm0,Wm1,Wm2,Wm3,Wm4,Msk;
  static int istep= 1,ist,itr,Instab,iTest,iPlot,iSecondSt;
  static int iterG;
  void ballooning();
  Msk= (TaskMask>>8)&0xff;
  mem4ball(2);
  iopt= 0;
  rwork[4]= .02;
  rwork[5]= 1.;
  rwork[6]= 0.;
  iwork[4]= 12;
  iwork[5]= 500;
  iwork[6]= 10;
  xmax= 6.;
  if(Msk&1){
    xmax= NModel[8];
    ntor= MModel[8];
  }
  if(Msk&2){
    xmax= NModel[9];
    ntor= MModel[9];
  }
  sprintf(PageName,"%8s n=%2d Ballooning\0",RunID,ntor);
  ntoro= ntor;
  ntore= ntor;
  ntors= ntor;
  OpenBalOut(&FlagBalOut);
  y1[0]= 0.;
  y1[1]= 3.;
  x1[0]= 0.;
  x1[1]= xmax;
  Wm0= (WinP[0].mode&3)-3;
  Wm1= (WinP[1].mode&3)-3;
  Wm2= (WinP[2].mode&3)-3;
  Wm3= (WinP[3].mode&3)-3;
  Wm4= (WinP[4].mode&3)-3;
  sprintf(nameY,"Ballooning Test\0");
  if(Wm1)
    Scale2D(WinP+1,x1,y1,2,5,2);
  if(Wm3&&(Msk&2))
    Scale2D(WinP+3,x1,y1,2,5,2);
  y1[0]= 0.;
  y1[1]= 1.5;
  x1[0]= 0.;
  x1[1]= a[na];
  if(Wm2&&(Msk&2))
    Scale2D(WinP+2,x1,y1,2,5,2);
  iSecondSt= 0;
  for(i= 0;i<na1;i++){
    if(Wm0)
      CheckIfButtonEvents();
    BallooningCoef(&P,i);
    A[i]= 2.*P;
    if(i){
      y1[0]= 0.;
      y1[1]= 3.;
      x1[0]= 0.;
      x1[1]= xmax;
      iTest= 0;
      uuu[0]= -P;
      uuu[1]= P>0.25?-2.*P:-0.5;
      P2= 0.;
      itr= 0;
      iterG= 0;
      do{
	iterG++;
	zero1(&itr,Instab/2,uuu,uuu+2,&G,fP0,eps);
	P= -G;
	SetBallCoef(P);
	gt0= 0;
	x= -xmax*c2gp-gt0;
	y[0]= 0.;
	InitBall(y+1,y[0],.1,x);
	x= 0.;
	y[0]= 1.;
	InitBall(y+1,y[0],0.,x);
	ballooning(&neq,&x,y,dy);
	rwork[0]= xmax*c2gp-gt0;
	istate= 1;
	xout= x+0.08;
	j1= 0;
	x1[j1]= x*cr2gp;
	y1[j1]= y[0];
	istep= 1;
	ist= 0;
	j1++;
	Instab= 0;
	if(Wm1||Wm3)
	  iPlot= 1;
	else
	  iPlot= 0;
	while(x<rwork[0]){
	  lsode_(ballooning,&neq,y,&x,&xout,&itol,&rtol,&atlr,&itask,
		 &istate,&iopt,rwork,&lrw,iwork,&liw,NULL,&mf);
	  if(Instab==0&&y[0]<-1e-4)
	    Instab= 1;
	  if(Instab==1&&y[0]>1e-4)
	    Instab= 2;
	  if(iPlot){
	    if(j1>=n1){
	      for(j= 0,j1= j;j<n1;j+= 2){
		x1[j1]= x1[j];
		y1[j1]= y1[j];
		j1++;
	      }
	      istep*= 2;
	    }
	    ist++;
	    if(ist>=istep){
	      x1[j1]= x*cr2gp;
	      y1[j1]= y[0];
	      j1++;
	      ist= 0;
	    }
	  }
	  xout= rwork[12];
	  if(istate<0){
	    printf("lsode istate=%d\n",istate);
	    exit(0);
	  }
	}
	if(iTest==0){
	  if(Instab)
	    icolrz[i]= 12;
	  else
	    icolrz[i]= 10;
	  Ispl= i-1;
	  spl_r1(&P0,&s,a+i,q_a,d2q_a,a,&na,&Ispl);
	  s/= q_a[i];
	  if(s!=0.)
	    printf("%2d %2d %12.4e%12.4e D_m=%12.4e D_I=%12.4e\n",i,
		   Instab,gpe0[i]/gpe0[na],q_a[i],DMer[i],-DMer[i]/(s*s));
	  else
	    printf("%2d %2d %12.4e%12.4e D_m=%12.4e\n",i,
		   Instab,gpe0[i]/gpe0[na],q_a[i],DMer[i]);
	  if(Wm1)
	    Plot2D(WinP+1,x1,y1,j1,5,2,0,0);
	  P0= P;
	  iTest= 1;
	}
	fP0= y[0];
	ballooning(&neq,&x,y,dy);
	if(Instab==1&&dy[0]>1e-4/xmax)
	  Instab= 2;
	if(Instab/2==0&&fabs(fP0)<1e-5)
	  itr= -1;
	if(Instab==0&&itr==2&&P>3.){
	  icolrz[i]= 9;
	  itr= -1;
	  iSecondSt= i;
	}
	if(iterG>=50)
	  icolrz[i]= 13;
      }while(itr>=0&&itr<20&&(Msk&2)&&iterG<50);
      if(Wm0){
	ji= nt1*i;
	for(j= 0;j<nt1;j++){
	  xgt[j]= sc_X*r[ji+j];
	  ygt[j]= sc_X*z[ji+j];
	}
	Plot2D(WinP+0,xgt,ygt,nt1,5,0,icolrz[i],0);
      }
      if((Msk&2)){
	if(Wm3)
	  Plot2D(WinP+3,x1,y1,j1,5,2,0,0);
	Acr[i]= 2.*P;
	PlProf[4].d00[i]= 2.*P;
	PlProf[2].d00[i]= -P*dgpe0[i]*dgpe0[i]/((usn[0]+aa[i]*ucs[i])*R0);

      }
    }
  }
  if(Wm1)
    Plot2D(WinP+1,x1,y1,1,5,2,0,-1);
  if(Wm3&&Msk&2)
    Plot2D(WinP+3,x1,y1,1,5,2,0,-1);
  if((Msk&2)){
    PlProf[4].d00[0]= (PlProf[4].d00[1]*aa[2]-PlProf[4].d00[2]*aa[1])
      /(aa[2]-aa[1]);
    Acr[0]= PlProf[4].d00[0];
    iSecondSt++;
    i= iSecondSt+1;
    P= (PlProf[2].d00[i]-PlProf[2].d00[iSecondSt])/(aa[i]-aa[iSecondSt]);
    for(i= 0;i<iSecondSt;i++)
      PlProf[2].d00[i]= PlProf[2].d00[iSecondSt]+P*(aa[i]-aa[iSecondSt]);
    spl_f_(yinf,d2yinf,PlProf[2].d00,NULL,a,&na,&ga0,&ga1,&ga2,&ga3);
    spl_e0(yinf,d2yinf,PlProf[3].d00,d1yinf,a,&na);
    P0= d1yinf[0];
    P= p_a[8]-PlProf[3].d00[8];
    for(i= 0;i<na1;i++)
      PlProf[3].d00[i]+= P;
  }




  if((Msk&2&&Wm2)){
    for(i= 0;i<na1;i++){
      P= Dsn[0]+aa[i]*Dcs[i];
      gbcrBal[i]= PlProf[3].d00[i]*P;
      gbBal[i]= p_a[i]*P;
      y1[i]= P;
    }
    spl_f_(yinf,d2yinf,y1,NULL,a,&na,&ga0,&ga1,&ga2,&ga3);
    spl_e0(yinf,d2yinf,y1,d1yinf,a,&na);
    spl_f_(yinf,d2yinf,gbBal,NULL,a,&na,&ga0,&ga1,&ga2,&ga3);
    spl_e0(yinf,d2yinf,gbBal,d1yinf,a,&na);
    spl_f_(yinf,d2yinf,gbcrBal,NULL,a,&na,&ga0,&ga1,&ga2,&ga3);
    spl_e0(yinf,d2yinf,gbcrBal,d1yinf,a,&na);

    P= 1./(j_sa[0]*j_sa[0]*usn[0]*usn[0]);
    gbcrBal[0]= -2.*P0*Dsn[0]*P;
    gbBal[0]= -2.*d2p_a[0]*Dsn[0]*P;
    gbcrBal[0]= 0.;
    gbBal[0]= 0.;
    for(i= 1;i<na1;i++){
      P= 20.*a[i]*b[na]/(R0*q_a[i]*bJ_a[i]*bJ_a[i]);
      gbcrBal[i]= 4.*(gbcrBal[i]-PlProf[3].d00[i]*y1[i])*P;
      gbBal[i]= 4.*(gbBal[i]-p_a[i]*y1[i])*P;
    }
    Plot2D(WinP+2,a,gbcrBal,na1,5,2,9,1);
    Plot2D(WinP+2,a,gbBal,na1,5,2,0,0);




    for(i= 0;i<na1;i++)
      y1[i]= Dsn[0]+aa[i]*Dcs[i];
    spl_r1(&P,&s,a+na,Dcs,d2Dcs,a,&na,&Ispl);
    s+= 2.*Dcs[na];
    spl_f1(yinf,d2yinf,y1,NULL,a,&na,&ga0,&ga1,&ga2,&ga3,&s);
    spl_e0(yinf,d2yinf,y1,d1yinf,a,&na);
    for(i= 0;i<na1;i++)
      y1[i]*= -4.*PlProf[2].d00[i];
    spl_f_(yinf,d2yinf,y1,NULL,a,&na,&ga0,&ga1,&ga2,&ga3);
    spl_e0(yinf,d2yinf,y1,d1yinf,a,&na);
    PlProf[4].nd= na;
    P2= 0.;
    for(i= 0;i<na1;i++){
      if(i){
	s= aa[i]*(g22s[0]+aa[i]*g22c[i])*dgpe0[i];
	PlProf[4].d00[i]= y1[i]/(s*s);
      }
      else{
	s= (g22s[0]+aa[i]*g22c[i])*dgpe0[i];
	PlProf[4].d00[i]= -cr2*PlProf[2].d00[0]*Dsn[0]/(s*s);
      }
      if(i){
	PlProf[4].c[i-1]= 8;
	PlProf[4].xd[i-1]= a[i];
	PlProf[4].yd[i-1]= PlProf[4].d0[i]/PlProf[4].d00[i];
      }
      P= 20.*a[i]*b[na]*PlProf[4].d0[i]/(R0*q_a[i]);
      if(P>P2){
	j1= i;
	P2= P;
      }
    }

    j= 8;
    P= 20.*a[j]*b[na]/(R0*q_a[j]);
    P2= 20.*a[j1]*b[na]/(R0*q_a[j1]);
    if(FlagBalOut){
      fprintf(BalFpnt,"%11.3e%11.3e%11.3e%11.3e%11.3e%11.3e%11.3e",ttime,
	      PlProf[4].d0[j]*P,PlProf[4].d00[j]*P,
	      PlProf[4].d0[j]/PlProf[4].d00[j],
	      PlProf[4].d0[j1]*P2,PlProf[4].d00[j1]*P2,
	      PlProf[4].d0[j1]/PlProf[4].d00[j1]);
      fP0= PlProf[4].d0[j]/PlProf[4].d00[j];
      if(fP0>0.95||PlProf[4].d0[j1]/PlProf[4].d00[j1]>0.95)
	fprintf(BalFpnt," Y\n");
      else
	fprintf(BalFpnt,"  \n");
      for(i= 0;i<na1;i++){
	P= 20.*a[i]*b[na]/(R0*q_a[i]);
	P2= PlProf[4].d00[i]*P;
	P*= PlProf[4].d0[i];
	fP0= PlProf[4].d0[i]/PlProf[4].d00[i];
	fprintf(BalFpnt1,"%3d%11.4e%11.4e%11.4e%11.4e%11.4e%11.4e%11.4e",
		i,a[i],P,P2,fP0,A[i],Acr[i],ttime);
	if(fP0>0.95)
	  fprintf(BalFpnt1," Y\n");
	else
	  fprintf(BalFpnt1,"  \n");
      }
    }
  }
  if(Wm4){
    sprintf(nameY,"Mercier criterion\0");
    Plot2D(WinP+2,a,DMer,na1,5,2,0,1);
    Plot2D(WinP+2,a,DMer,1,5,2,0,-1);
  }
  demem4ball();
  CloseBalOut(&FlagBalOut);
}
OpenBalOut(Flag)
     int*Flag;
{
  static char BalFile[30],BalFile1[30];
  if(strncmp(BalFile+8,RunID,8))
    *Flag= 0;
  if(*Flag){
    BalFpnt= fopen(BalFile,"a");
    BalFpnt1= fopen(BalFile1,"a");
  }
  else{
    sprintf(BalFile,"sescOut/%8sn%2.2d.bl\0",RunID,ntor);
    sprintf(BalFile1,"sescOut/%8sn%2.2d.bl1\0",RunID,ntor);
    BalFpnt= fopen(BalFile,"w");
    BalFpnt1= fopen(BalFile1,"w");
    if(BalFpnt!=NULL&&BalFpnt1!=NULL){
      *Flag= 1;
      fprintf(BalFpnt,"%11s\n",RunID);
      fprintf(BalFpnt,"%11s%11s%11s%11s%11s%11s%11s\n","time","gb_N[8]",
	      "gb_Ncr","gb/gb_cr","gb_Nmx","gb_Ncr","gb/gb_cr");
      fprintf(BalFpnt1,"%11s\n",RunID);
      fprintf(BalFpnt1,"%3s%11s%11s%11s%11s%11s\n","i","a","gb_N",
	      "gb_Ncr","gb/gb_cr","time");
    }
  }
}
CloseBalOut(Flag)
     int*Flag;
{
  if(*Flag){
    fclose(BalFpnt);
    fclose(BalFpnt1);
  }
}

NzCbal(y,yh,nord,y1,y2,icur,d1)
     double*y,*yh,*y1,*y2,*d1;
     int nord,icur;
{
  int i,m,m1,m2,k;
  static double a1;

  a1= -y[0]/y[2];
  *d1+= a1;

  for(i= 0;i<icur;i++)
    y1[i]+= a1*y2[i];
  y[0]+= a1*y[2];
  y[1]+= a1*y[3];
  for(i= 0;i<=nord;i++){
    k= i*neq;
    yh[k]+= a1*yh[k+2];
    k++;
    yh[k]+= a1*yh[k+2];
  }
}

void ballooning1(neq,x,y,dy)
     int*neq;
     double*x,*y,*dy;
{
  static double t,x0= 0.;
  static double sf2,sf1,sf0,sg0,sg1,sg3,df2,df1,df0,dg0,dg1,dg3;
  static double skp,skpb,bK,bG,bI,dI,bR,bH,bF;

  while(x0>(*x)+gt0)
    x0-= c2gp;
  while(x0+c2gp<=(*x)+gt0)
    x0+= c2gp;
  t= ((*x)+gt0-x0)*cr2gp;
  if(t>1.)t= 1.;
  if(t<0.)t= 0.;
  while(gt[Ispl+1]<t)
    Ispl++;
  while(t<gt[Ispl])
    Ispl--;
  if(Ispl==nt)
    Ispl--;
  spl_r1(&sf0,&df0,&t,f0,d2f0,gt,&nt,&Ispl);
  spl_r1(&sf1,&df1,&t,f1,d2f1,gt,&nt,&Ispl);
  spl_r1(&sf2,&df2,&t,f2,d2f2,gt,&nt,&Ispl);
  spl_r1(&sg0,&dg0,&t,g0,d2g0,gt,&nt,&Ispl);
  spl_r1(&sg1,&dg1,&t,g1,d2g1,gt,&nt,&Ispl);
  spl_r1(&sg3,&dg3,&t,g3,d2g3,gt,&nt,&Ispl);
  spl_r1(&skp,&dI,&t,kkp,d2kkp,gt,&nt,&Ispl);
  spl_r1(&skpb,&dI,&t,kkpb,d2kkpb,gt,&nt,&Ispl);
  spl_r1(&bI,&dI,&t,ttA,d2ttA,gt,&nt,&Ispl);
  sg3-= sg1*(*x);
  bK= (sf2*(*x)+sf1)*(*x)+sf0;
  skp*= bK;
  skpb*= bK;
  bR= bR2f*skp;
  bH= bH2f*skpb;
  bF= bF2f*skpb;
  bG= 1./(1.+bH);
  bI*= bK*bG;
  bG*= sg0+sg1+(dg1*(*x)-dg3)*cr2gp;

  dy[0]= (y[1]-sg3*y[0])*(1.+bR)/bK;
  dy[1]= (sg0+bG*bF+go2oi*bI)*y[0]+sg3*dy[0];

  dy[2]= (y[3]-sg3*y[2])*(1.+bR)/bK;
  dy[3]= (sg0+bG*bF+go2oi*bI)*y[2]+sg3*dy[2];
}

InitBall1(y,dy,x)
     double x,*y,*dy;
{
  static double t,x0= 0.;
  static double sf2,sf1,sf0,sg0,sg1,sg3,df,dg1,skp,bK,bR;

  while(x0>x+gt0)
    x0-= c2gp;
  while(x0+c2gp<=x+gt0)
    x0+= c2gp;
  t= (x+gt0-x0)*cr2gp;
  if(t>1.)
    t= 1.;
  if(t<0.)
    t= 0.;
  while(gt[Ispl+1]<t)
    Ispl++;
  while(t<gt[Ispl])
    Ispl--;
  if(Ispl==nt)
    Ispl--;
  spl_r1(&sf0,&df,&t,f0,d2f0,gt,&nt,&Ispl);
  spl_r1(&sf1,&df,&t,f1,d2f1,gt,&nt,&Ispl);
  spl_r1(&sf2,&df,&t,f2,d2f2,gt,&nt,&Ispl);
  spl_r1(&sg1,&df,&t,g1,d2g1,gt,&nt,&Ispl);
  spl_r1(&sg3,&df,&t,g3,d2g3,gt,&nt,&Ispl);
  spl_r1(&skp,&df,&t,kkp,d2kkp,gt,&nt,&Ispl);
  sg3-= sg1*x;
  bK= (sf2*x+sf1)*x+sf0;
  skp*= bK;
  bR= bR2f*skp;
  y[1]= dy[0]*bK/(1.+bR)+sg3*y[0];
  y[3]= dy[2]*bK/(1.+bR)+sg3*y[2];
}

BallooningTest()
{
  static double x,P0,P,P2,fP0,uuu[4],eps= 0.001,s,G,A[na_DEF+1],Acr[na_DEF+1];
  static double y1[1001],y2[1001],x1[1001],xmax,A1;
  static int i,j,ji,k,j1,n1= 1001,Wm0,Wm1,Wm2,Wm3,Wm4,Msk;
  static int istep= 1,ist,itr,Instab,iTest,iPlot,iSecondSt;
  static int iterG;
  void ballooning1();
  Msk= (TaskMask>>8)&0xff;
  mem4ball(4);
  iopt= 0;
  rwork[4]= .02;
  rwork[5]= 1.;
  rwork[6]= 0.;
  iwork[4]= 12;
  iwork[5]= 500;
  iwork[6]= 10;
  xmax= 6.;
  if(Msk&1){
    xmax= NModel[8];
    ntor= MModel[8];
  }
  if(Msk&2){
    xmax= NModel[9];
    ntor= MModel[9];
  }
  ntoro= ntor;
  ntore= ntor;
  ntors= ntor;
  OpenBalOut(&FlagBalOut);
  y1[0]= 0.;
  y1[1]= 3.;
  x1[0]= 0.;
  x1[1]= xmax;
  Wm0= (WinP[0].mode&3)-3;
  Wm1= (WinP[1].mode&3)-3;
  Wm2= (WinP[2].mode&3)-3;
  Wm3= (WinP[3].mode&3)-3;
  Wm4= (WinP[4].mode&3)-3;
  sprintf(nameY,"Ballooning Test n=%2d\0",ntor);
  if(Wm1)
    Scale2D(WinP+1,x1,y1,2,5,2);
  if(Wm3&&(Msk&2))
    Scale2D(WinP+3,x1,y1,2,5,2);
  y1[0]= 0.;
  y1[1]= 1.5;
  x1[0]= 0.;
  x1[1]= a[na];
  if(Wm2&&(Msk&2))
    Scale2D(WinP+2,x1,y1,2,5,2);
  iSecondSt= 0;
  for(i= 0;i<na1;i++){
    if(Wm0)
      CheckIfButtonEvents();
    BallooningCoef(&P,i);
    A[i]= 2.*P;
    if(i){
      y1[0]= 0.;
      y1[1]= 3.;
      x1[0]= 0.;
      x1[1]= xmax;
      iTest= 0;
      uuu[0]= -P;
      uuu[1]= P>0.25?-2.*P:-0.5;
      P2= 0.;
      itr= 0;
      iterG= 0;
      do{
	iterG++;
	zero1(&itr,Instab/2,uuu,uuu+2,&G,fP0,eps);
	P= -G;
	SetBallCoef(P);
	gt0= 0;
	x= 0.;
	y[0]= 1.;
	y[2]= 0.;
	dy[0]= 0.;
	dy[2]= 1.;
	InitBall1(y,dy,x);
	ballooning1(&neq,&x,y,dy);
	rwork[0]= xmax*c2gp-gt0;
	istate= 1;
	xout= x+0.08;
	j1= 0;
	x1[j1]= x*cr2gp;
	y1[j1]= y[0];
	y2[j1]= y[2];
	istep= 1;
	ist= 0;
	j1++;
	Instab= 0;
	if(Wm1||Wm3)
	  iPlot= 1;
	else
	  iPlot= 0;
	A1= 0.;
	while(x<rwork[0]){
	  lsode_(ballooning1,&neq,y,&x,&xout,&itol,&rtol,&atlr,&itask,
		 &istate,&iopt,rwork,&lrw,iwork,&liw,NULL,&mf);
	  if(iPlot){
	    if(j1>=n1){
	      for(j= 0,j1= j;j<n1;j+= 2){
		x1[j1]= x1[j];
		y1[j1]= y1[j];
		y2[j1]= y2[j];
		j1++;
	      }
	      istep*= 2;
	    }
	    ist++;
	    if(ist>=istep){
	      x1[j1]= x*cr2gp;
	      y1[j1]= y[0];
	      y2[j1]= y[2];
	      j1++;
	      ist= 0;
	    }
	  }
	  if(fabs(y[0])>100.)
	    NzCbal(y,yh,iwork[14],y1,y2,j1,&A1);
	  xout= rwork[12];
	  if(istate<0){
	    printf("lsode istate=%d\n",istate);
	    exit(0);
	  }
	}
	NzCbal(y,yh,-1,y1,y2,j1,&A1);
	Instab= 0;
	for(j= 0;j<j1;j++){
	  y1[j]-= A1*y2[j];
	  if(Instab==0&&y1[j]<-0.001)
	    Instab= 1;
	  if(Instab==1&&y1[j]>0.001)
	    Instab= 2;
	  if(y2[j]<0.)
	    Instab= 2;
	  if(Instab==2)
	    break;
	}
	if(iTest==0){
	  if(Instab)
	    icolrz[i]= 12;
	  else
	    icolrz[i]= 10;
	  Ispl= i-1;
	  spl_r1(&P0,&s,a+i,q_a,d2q_a,a,&na,&Ispl);
	  s/= q_a[i];
	  if(s!= 0.)
	    printf("%2d %2d %11.4e%11.4e D_m=%11.4e D_I=%11.4e s=%11.4e\n",i,
		   Instab,gpe0[i]/gpe0[na],q_a[i],DMer[i],-DMer[i]/(s*s),s);
	  else
	    printf("%2d %2d %12.4e%12.4e D_m=%12.4e\n",i,
		   Instab,gpe0[i]/gpe0[na],q_a[i],DMer[i]);
	  if(Wm1){
	    Plot2D(WinP+1,x1,y1,j1,5,2,0,0);
	  }
	  P0= P;
	  iTest= 1;
	}
	ballooning1(&neq,&x,y,dy);
	fP0= -A1;
	if(Instab==1&&dy[0]-A1*dy[2]>1e-4/xmax)
	  Instab= 2;
	if(Instab/2==0&&fabs(fP0)<1e-5)
	  itr= -1;
	if(Instab==0&&itr==2&&P>3.){
	  icolrz[i]= 9;
	  itr= -1;
	  iSecondSt= i;
	}
	if(iterG>=50)
	  icolrz[i]= 13;
      }while(itr>=0&&itr<20&&(Msk&2)&&iterG<50);
      if((Msk&2)){
	if(itr>19)
	  icolrz[i]= 9;
	if(Wm3)
	  Plot2D(WinP+3,x1,y1,j1,5,2,0,0);
	Acr[i]= 2.*P;
	PlProf[4].d00[i]= 2.*P;
	PlProf[2].d00[i]= -P*dgpe0[i]*dgpe0[i]/((usn[0]+aa[i]*ucs[i])*R0);

	if(P0>1.*P)
	  icolrz[i]= 12;
	else
	  icolrz[i]= 10;
      }
      if(Wm0){
	ji= nt1*i;
	for(j= 0;j<nt1;j++){
	  xgt[j]= sc_X*r[ji+j];
	  ygt[j]= sc_X*z[ji+j];
	}
	Plot2D(WinP+0,xgt,ygt,nt1,5,0,icolrz[i],0);
      }
    }
    else{
      Instab= DMer[i]>0?99:0;
      printf("%2d %2d %11.4e%11.4e D_m=%11.4e\n",i,
	     Instab,gpe0[i]/gpe0[na],q_a[i],DMer[i]);
    }
  }
  if(Wm1)
    Plot2D(WinP+1,x1,y1,1,5,2,0,-1);
  if(Wm3&&Msk&2)
    Plot2D(WinP+3,x1,y1,1,5,2,0,-1);
  if((Msk&2)){
    PlProf[4].d00[0]= (PlProf[4].d00[1]*aa[2]-PlProf[4].d00[2]*aa[1])
      /(aa[2]-aa[1]);
    Acr[0]= PlProf[4].d00[0];
    iSecondSt++;
    i= iSecondSt+1;
    P= (PlProf[2].d00[i]-PlProf[2].d00[iSecondSt])/(aa[i]-aa[iSecondSt]);
    for(i= 0;i<iSecondSt;i++){
      PlProf[2].d00[i]= PlProf[2].d00[iSecondSt]+P*(aa[i]-aa[iSecondSt]);
      if(PlProf[2].d0[i]<0.&&fabs(PlProf[2].d00[i])<fabs(PlProf[2].d0[i]))
	PlProf[2].d00[i]= PlProf[2].d0[i];
    }
    spl_f_(yinf,d2yinf,PlProf[2].d00,NULL,a,&na,&ga0,&ga1,&ga2,&ga3);
    spl_e0(yinf,d2yinf,PlProf[3].d00,d1yinf,a,&na);
    P0= d1yinf[0];
    P= p_a[8]-PlProf[3].d00[8];
    for(i= 0;i<na1;i++)
      PlProf[3].d00[i]+= P;
  }




  if((Msk&2&&Wm2)){
    for(i= 0;i<na1;i++){
      P= Dsn[0]+aa[i]*Dcs[i];
      gbcrBal[i]= PlProf[3].d00[i]*P;
      gbBal[i]= p_a[i]*P;
      y1[i]= P;
    }
    spl_f_(yinf,d2yinf,y1,NULL,a,&na,&ga0,&ga1,&ga2,&ga3);
    spl_e0(yinf,d2yinf,y1,d1yinf,a,&na);
    spl_f_(yinf,d2yinf,gbBal,NULL,a,&na,&ga0,&ga1,&ga2,&ga3);
    spl_e0(yinf,d2yinf,gbBal,d1yinf,a,&na);
    spl_f_(yinf,d2yinf,gbcrBal,NULL,a,&na,&ga0,&ga1,&ga2,&ga3);
    spl_e0(yinf,d2yinf,gbcrBal,d1yinf,a,&na);

    P= 1./(j_sa[0]*j_sa[0]*usn[0]*usn[0]);
    gbcrBal[0]= -2.*P0*Dsn[0]*P;
    gbBal[0]= -2.*d2p_a[0]*Dsn[0]*P;
    gbcrBal[0]= 0.;
    gbBal[0]= 0.;
    for(i= 1;i<na1;i++){
      P= 20.*a[i]*b[na]/(R0*q_a[i]*bJ_a[i]*bJ_a[i]);
      gbcrBal[i]= 4.*(gbcrBal[i]-PlProf[3].d00[i]*y1[i])*P;
      gbBal[i]= 4.*(gbBal[i]-p_a[i]*y1[i])*P;
    }
    Plot2D(WinP+2,a,gbcrBal,na1,5,2,9,1);
    Plot2D(WinP+2,a,gbBal,na1,5,2,0,0);




    for(i= 0;i<na1;i++)
      y1[i]= Dsn[0]+aa[i]*Dcs[i];
    spl_r1(&P,&s,a+na,Dcs,d2Dcs,a,&na,&Ispl);
    s+= 2.*Dcs[na];
    spl_f1(yinf,d2yinf,y1,NULL,a,&na,&ga0,&ga1,&ga2,&ga3,&s);
    spl_e0(yinf,d2yinf,y1,d1yinf,a,&na);
    for(i= 0;i<na1;i++)
      y1[i]*= -4.*PlProf[2].d00[i];
    spl_f_(yinf,d2yinf,y1,NULL,a,&na,&ga0,&ga1,&ga2,&ga3);
    spl_e0(yinf,d2yinf,y1,d1yinf,a,&na);
    PlProf[4].nd= na;
    P2= 0.;
    for(i= 0;i<na1;i++){
      if(i){
	s= aa[i]*(g22s[0]+aa[i]*g22c[i])*dgpe0[i];
	PlProf[4].d00[i]= y1[i]/(s*s);
      }
      else{
	s= (g22s[0]+aa[i]*g22c[i])*dgpe0[i];
	PlProf[4].d00[i]= -cr2*PlProf[2].d00[0]*Dsn[0]/(s*s);
      }
      if(i){
	PlProf[4].c[i-1]= 8;
	PlProf[4].xd[i-1]= a[i];
	PlProf[4].yd[i-1]= PlProf[4].d0[i]/PlProf[4].d00[i];
      }
      P= 20.*a[i]*b[na]*PlProf[4].d0[i]/(R0*q_a[i]);
      if(P>P2){
	j1= i;
	P2= P;
      }
    }

    j= 8;
    P= 20.*a[j]*b[na]/(R0*q_a[j]);
    P2= 20.*a[j1]*b[na]/(R0*q_a[j1]);
    if(FlagBalOut){
      fprintf(BalFpnt,"%11.3e%11.3e%11.3e%11.3e%11.3e%11.3e%11.3e",ttime,
	      PlProf[4].d0[j]*P,PlProf[4].d00[j]*P,
	      PlProf[4].d0[j]/PlProf[4].d00[j],
	      PlProf[4].d0[j1]*P2,PlProf[4].d00[j1]*P2,
	      PlProf[4].d0[j1]/PlProf[4].d00[j1]);
      fP0= PlProf[4].d0[j]/PlProf[4].d00[j];
      if(fP0>0.95||PlProf[4].d0[j1]/PlProf[4].d00[j1]>0.95)
	fprintf(BalFpnt," Y\n");
      else
	fprintf(BalFpnt,"  \n");
      for(i= 0;i<na1;i++){
	P= 20.*a[i]*b[na]/(R0*q_a[i]);
	P2= PlProf[4].d00[i]*P;
	P*= PlProf[4].d0[i];
	fP0= PlProf[4].d0[i]/PlProf[4].d00[i];
	fprintf(BalFpnt1,"%3d%11.4e%11.4e%11.4e%11.4e%11.4e%11.4e%11.4e",
		i,a[i],P,P2,fP0,A[i],Acr[i],ttime);
	if(fP0>0.95)
	  fprintf(BalFpnt1," Y\n");
	else
	  fprintf(BalFpnt1,"  \n");
      }
    }
  }
  if(Wm4){
    sprintf(nameY,"Mercier criterion\0");
    Plot2D(WinP+4,a,DMer,na1,5,2,0,1);
    Plot2D(WinP+4,a,DMer,1,5,2,0,-1);
  }
  demem4ball();
  CloseBalOut(&FlagBalOut);
}

MikePhillipsBallCoef(q,dq,dp,i)
     double*q,*dq,*dp;
     int i;
{
  static double g22,D,a1,a2;
  static int j,ji;
  Ispl= i<na?i:na-1;
  a1= a[i];
  a2= aa[i];
  spl_r1(q,dq,a+i,q_a,d2q_a,a,&na,&Ispl);
  if(i)
    *dq/= a[i]*dgpe0[i];
  else
    *dq*= d2q_a[i]/dgpe0[i];
  *dp= Ps_a[i]*5.*cr2gp*1e+6;

  a1*= dgpe0[i];
  for(j= 0,ji= nt1*i;j<nt1;j++,ji++){
    g22= drgt[ji]*drgt[ji]+dzgt[ji]*dzgt[ji];
    D= dra[ji]*dzgt[ji]-dza[ji]*drgt[ji];
    f0[j]= a1*sqrt(g22)/(D*r[ji]);
    f1[j]= r[ji];
    f2[j]= z[ji];
  }
  spl_p_(f0,d2f0,gt,&nt);
  spl_p_(f1,d2f1,gt,&nt);
  spl_p_(f2,d2f2,gt,&nt);
}

