#include <math.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <pfc.h>

char *TimeString();
char *CbGetCodeNm();

extern double cr2,cr3,cr4,cr6,cr12,cgp,c2gp,cgp_4,cr2gp,cgm0,crgm0;
extern int PSnPg;

extern int ESNa,ESNa1,ESNp,ESNp1,ESnAP;
extern int ESMp,ESMp1,ES2Mp,ES2Mp1,ESnMp;
extern int ESFp,ESFp1,ESnAF;

extern int neqU,neqUJ,neqUP,neqUY,neqUR;
extern double tolU;

extern int M0Mm;
extern double *gper,*gpei,*dgper,*dgpei,*aYer,*aYei,*daYer,*daYei;
extern double *gperU,*gpeiU,*dgperU,*dgpeiU,*aYerU,*aYeiU,*daYerU,*daYeiU;
extern double *rCcU,*rCsU,*rScU,*rSsU,*drCcU,*drCsU,*drScU,*drSsU;
extern double *bCcU,*bScU,*dbCcU,*dbScU;

extern char ShotNm[];
extern double *ESsa,*ESpa;
extern double *ESaR0,*ESaZ0,*ESsb,*ESsb1a;
extern double *rcT,*rcT1a,*rsT,*rsT1a;
extern double *rT1a,*rT1gt,*zT1a,*zT1gt;
extern double *EScs1,*ESsn1;
extern int kCol[];

extern double *ESsq,*ESsp;
extern double *ESgY,*ESgF,*ESgF1a;
extern double *ESLc,*ESLs,*ESLc1,*ESLs1,*ESg22c,*ESg22s,*ESg12c,*ESg12s;
extern double *ESVc,*ESVs,*ESVc1,*ESVs1;
extern double *ESDPc,*ESDPc1;
extern double ESIpl,ESBt;
extern double *ESsr,*ESsz;
extern double *ESaJ,*ESaJ1a,*ESaJ2a
  ,*ESjp,*ESjp1a,*ESjp2a
  ,*ESsp,*ESsp1a,*ESsp2a
  ,*ESPs,*ESPs1a,*ESPs2a
  ,*ESjs,*ESjs1a,*ESjs2a
  ,*ESaT,*ESaT1a,*ESaT2a
  ,*ESgY,*ESgY1a,*ESgY2a
  ,*ESgF,*ESgF1a,*ESgF2a
  ,*ESaF,*ESaF1a,*ESaF2a
  ,*ESFF,*ESFF1a,*ESFF2a
  ,*ESdgY,*ESdgY1a,*ESdgY2a
  ,*ESne,*ESne1a,*ESne2a
  ;

extern double Mse[];
extern double Bmod[];

extern int NMSE,nMSE,nMSS,nSightP;
extern DATAMSE MSE[],MSS[];
extern SIGHTLINE SightP[];
extern double glFaraday,cFaraday;

static double pMPa=0.;
static double gyEr[0x20000],gyEi[0x20000],dgyEr[0x20000],dgyEi[0x20000];
static double aYEr[0x20000],aYEi[0x20000],daYEr[0x20000],daYEi[0x20000];
static double gdq[0x100],gdp[0x100];
static double gdWth[0x100],gdWli[0x100],gdWgm[0x100];
static double gdgbV[0x100],gdgmV[0x100],gdliV[0x100];
static double gdgbS[0x100],gdShS[0x100];
static double Bpol[0x100];
static double BzBt[0x100];


int ECReInitEqU()
{
  static int NeqU=0;
  int k,m;

  if(neqU == 0)  return(0);
  neqUY	=ESNp/2;
  m	=ESNa1*ES2Mp1*neqU;
  k	=ESMp1*neqU;

  if(NeqU < neqU){
    NeqU	=neqU;
    if(gperU != NULL) free(gperU);
    gperU	=(double*)malloc((8*m+8*k+4*ESMp1)*sizeof(double));
    if(gperU == NULL){
      printf("Failure in memory allocation for gperU in ECReInitEqU\n");
      exit(0);
    }
  }
  gpeiU	=gperU	+m;
  dgperU=gpeiU	+m;
  dgpeiU=dgperU	+m;
  aYerU	=dgpeiU	+m;
  aYeiU	=aYerU	+m;
  daYerU=aYeiU	+m;
  daYeiU=daYerU	+m;
  rCcU	=daYeiU	+m;
  rCsU	=rCcU	+k;
  rScU	=rCsU	+k;
  rSsU	=rScU	+k;
  drCcU	=rSsU	+k;
  drCsU	=drCcU	+k;
  drScU	=drCsU	+k;
  drSsU	=drScU	+k;

  bCcU	=drSsU	+k;
  bScU	=bCcU	+ESMp1;
  dbCcU	=bScU	+ESMp1;
  dbScU	=dbCcU	+ESMp1;

  return(0);
}

int EqRcVariances(int i0,int i1,int k0,int k1
		  ,int F	/* choice of function */
		  ,int FlP	/* PostScript Flag */
		  )
{
  int iW;
  int i,j,ji,m,n;
  double d,s,x[ESNa1],y[ESNa1];
  char ln[64];
  double *ld,*r,*ra,*rq,*za,*zq,da,dt;
  iW	=6;

  if(neqU == 0 || F < 0) return(0);
  n	=ES2Mp1*neqU;

  switch(F/10){
  case 0:
    ld	=gperU;
    strcpy(ln," gyUr");
    break;
  case 1:
  case 2:
    ld	=gpeiU;
    strcpy(ln," gyUi");
    break;
  }

  switch(F%10){
  case 0:
    break;
  case 1:
    ld	+=2*n*ESNa1;
    strcpy(ln+2,"'_a");
    break;
  }

  if(i0 < 0) i0=0;
  if(i1 > ESNa1) i1=ESNa1;

  if(k0 < 0) k0=0;
  if(k1 > neqU) k1=neqU;

  da	=ESsa[1]-ESsa[0];
  x[0]	=ESsa[i0];
  x[1]	=ESsa[i1-1];

  y[0]	=0.;
  y[1]	=0.;
  for(i=i0; i < i1; i++){
    ji	=n*i+ES2Mp1*k0;
    for(j=k0; j < k1; j++){
      for(m=0; m < ES2Mp1; m++){
	s	=ld[ji];
	if(y[0] > s) y[0]=s;
	if(y[1] < s) y[1]=s;
	ji++;
      }
    }
  }	
  if(FlP){
    static int inx=1,iny=1;
    static int kPS=1;
    static char PSFileNm[16];
    if(FlP > 1){
      if(FlP != 4){
	inx	=FlP-1;
	iny	=FlP-1;
      }
      else{
	inx	=4;
	iny	=4;
      }
    }
    if(kPS && *ShotNm != '\0'){
      sprintf(PSFileNm,"%s.ps",ShotNm);
      PSSetFileName(PSFileNm);
      kPS	=0;
    }
    PSFileOpen(inx,iny);
  }

  sprintf(ln+strlen(ln)," i0=%d i1=%d %d<= k <=%d",i0,i1,k0+1,k1);
  SetPlotName("a",ln,"EqRec Variances");
  Scale2d(iW,x,y,2,6,2);

  if(FlP) PSNewFrame();
  for(j=k0; j < k1; j++){
    for(m=0; m < ES2Mp1; m++){
      for(i=i0; i < i1; i++){
	ji	=n*i+ES2Mp1*j+m;
	x[i]	=ESsa[i];
	y[i]	=ld[ji];
      }
      i	=m < ESMp ? 11 : (m == ESMp ? 14 : 4);

      Plot2d(iW,x+i0,y+i0,i1-i0,6,0,i,0);
      if(FlP) PSPlot2d(x+i0,y+i0,i1-i0,6,0,i,0);
    }
  }
  if(FlP){
    PSFileClose();
  }
  return(0);
}

int PlotJFunction(int iW,int i0,int i1,int m0,int m1
		  ,double **Js,double **Jp,double *T,int FlP)
{
  int m,i,n;
  double x[ESNa+ESNa1],y[ESNa+ESNa1],rT,s,R0;
  double *ld,*lj;
  char ln[0x40];
  
  if(FlP){
    static int inx=1,iny=1;
    static int kPS=1;
    static char PSFileNm[16];
    if(FlP > 1){
      if(FlP != 4){
	inx	=FlP-1;
	iny	=FlP-1;
      }
      else{
	inx	=4;
	iny	=4;
      }
    }
    if(kPS && *ShotNm != '\0'){
      sprintf(PSFileNm,"%s.ps",ShotNm);
      PSSetFileName(PSFileNm);
      kPS	=0;
    }
    PSFileOpen(inx,iny);
  }
  x[0]	=ESsa[i0];
  x[1]	=ESsa[i1-1];
  y[0]	=1e+20;
  y[1]	=-1e+20;
  ld	=ESjs+i0;
  for(i=i0; i < i1; i++){
    if(y[0] > *ld) y[0]=*ld;
    if(y[1] < *ld) y[1]=*ld;
    ld++;
  }
  ld	=ESjp+i0;
  for(i=i0; i < i1; i++){
    if(y[0] > *ld) y[0]=*ld;
    if(y[1] < *ld) y[1]=*ld;
    ld++;
  }

  if(m0 < 0) m0=0;
  if(m1 > neqUR) m1=neqUR;

#ifdef H  
  for(m=m0; m < m1; m++){
    ld	=Js[m]+i0;
    rT	=1./T[m];
    for(i=i0; i < i1; i++){
      s	=*ld*rT;
      if(y[0] > s) y[0]=s;
      if(y[1] < s) y[1]=s;
      ld++;
    }
  }

  for(m=m0;m < m1; m++){
    ld	=Jp[m]+i0;
    rT	=1./T[m];
    for(i=i0; i < i1; i++){
      s	=*ld*rT;
      if(y[0] > s) y[0]=s;
      if(y[1] < s) y[1]=s;
      ld++;
    }
  }
#endif

  s	=fabs(y[0]);
  rT	=fabs(y[1]);
  if(s < rT) s=rT;
  x[2]	=-s;
  x[3]	=s;

  sprintf(ln,"%s i0=%d i1=%d k0=%d k1=%d",ShotNm,i0,i1,m0,m1);
  sprintf(ln,"%d<= i <%d %d<= k <=%d",i0,i1,m0+1,m1);

  SetPlotName("a","gd j_s",ln);
  Scale2d(iW,x,x+2,2,6,2);

  if(FlP){
    PSNewFrame();
    PSSetLineWidth(1.);
  }
  n	=i1-i0;
  for(m=m0; m < m1; m++){
    ld	=Js[m]+i0;

    rT	=1.;
    rT	=1./T[m];
    for(i=i0; i < i1; i++) y[i]=(*ld++)*rT;

    Plot2d(iW,ESsa+i0,y+i0,n,6,0,kCol[m%0x10],0);
    if(FlP) PSPlot2d(ESsa+i0,y+i0,n,6,0,kCol[m%0x10],0);
  }
  ld	=ESjs+i0;
  i	=kCol[0];
  Plot2d(iW,ESsa+i0,ld,n,6,0,i,0);
  if(FlP){
    PSSetLineWidth(3.);
    PSPlot2d(ESsa+i0,ld,n,6,0,i,0);
    PSSetLineWidth(1.);
  }
  iW++;

  iW	=9;
#ifdef HHH
  FlP=0;
#endif
  sprintf(ln,"%s i0=%d i1=%d k0=%d k1=%d",ShotNm,i0,i1,m0,m1);
  sprintf(ln,"%d<= i <%d %d<= k <=%d",i0,i1,m0+1,m1);
  SetPlotName("a","gd j_p",ln);

  Scale2d(iW,x,x+2,2,6,2);
  if(FlP){
    PSNewFrame();
    PSSetLineWidth(1.);
  }
  n	=i1-i0;
  for(m=m0; m < m1; m++){
    ld	=Jp[m]+i0;
    rT	=1.;
    rT	=1./T[m];
    for(i=i0; i < i1; i++) y[i]=(*ld++)*rT;
    Plot2d(iW,ESsa+i0,y+i0,n,6,0,kCol[m%0x10],0);
    if(FlP){
      PSPlot2d(ESsa+i0,y+i0,n,6,0,kCol[m%0x10],0);
    }
  }
  i	=kCol[0];
  ld	=ESjp+i0;
  Plot2d(iW,ESsa+i0,ld,n,6,0,i,0);
  if(FlP){
    PSSetLineWidth(3.);
    PSPlot2d(ESsa+i0,ld,n,6,0,i,0);
    PSSetLineWidth(1.);
  }

  R0	=ESaR0[0];
  sprintf(ln,"%s i0=%d i1=%d k0=%d k1=%d",ShotNm,i0,i1,m0,m1);
  sprintf(ln,"%d<= i <%d %d<= k <=%d",i0,i1,m0+1,m1);
  SetPlotName("r-R0","gd j_t",ln);

  Scale2d(iW,x,x+2,2,6,2);
  if(FlP){
    PSNewFrame();
    PSSetLineWidth(1.);
  }
  s	=1./(ESsr[ESNp1*ESNa]-R0);
  for(i=i0; i < i1; i++){
    x[i]=(ESsr[ESNp1*i]-R0)*s;
  }
  n	=i1-i0;
  for(m=m0; m < m1; m++){
    lj	=Js[m]+i0;
    ld	=Jp[m]+i0;
    rT	=1.;
    rT	=1./T[m];
    for(i=i0; i < i1; i++){
      s	=R0/ESsr[ESNp1*i];
      y[i]=((*lj++)*s+(*ld++)*(1./s-s))*rT;
    }
    Plot2d(iW,x+i0,y+i0,n,6,0,kCol[m%0x10],0);
    if(FlP){
      PSPlot2d(x+i0,y+i0,n,6,0,kCol[m%0x10],0);
    }
  }
  lj	=ESjs+i0;
  ld	=ESjp+i0;
  for(i=i0; i < i1; i++){
    s	=R0/ESsr[ESNp1*i];
    y[i]=(*lj++)*s+(*ld++)*(1./s-s);
  }
  i	=kCol[0];
  Plot2d(iW,x+i0,y+i0,n,6,0,i,0);
  if(FlP){
    PSSetLineWidth(3.);
    PSPlot2d(x+i0,y+i0,n,6,0,i,0);
    PSSetLineWidth(1.);
  }

  if(FlP) PSFileClose();

  return(0);
}

int PlotU(int iW, double ga,double **U,int *ind,int M,int kA
	  ,int m0,int m1,int FlP)
{
  int m,j,k,n,kc;
  double x[M],y[M];
  char ln[0x40];

  if(m0 < 0) m0=0;
  if(m1 > neqUR) m1=neqUR;

  if(FlP){
    static int inx=1,iny=1;
    static int kPS=1;
    static char PSFileNm[16];
    if(FlP > 1){
      if(FlP != 4){
	inx	=FlP-1;
	iny	=FlP-1;
      }
      else{
	inx	=4;
	iny	=4;
      }
    }
    if(kPS && *ShotNm != '\0'){
      sprintf(PSFileNm,"%s.ps",ShotNm);
      PSSetFileName(PSFileNm);
      kPS	=0;
    }
    PSFileOpen(inx,iny);
  }
  x[0]	=0.;
  x[1]	=M+1;
  y[0]	=-2.5;
  y[1]	=2.5;
  sprintf(ln,"%d<= k <=%d",m0+1,m1);
  SetPlotName("m","gd Signal",ln);
  Scale2d(iW,x,y,2,6,2);

  if(FlP){
    PSNewFrame();
    PSSetLineWidth(2.);
  }
  x[0]	=1.;
  y[0]	=1.;
  y[1]	=y[0];
  Plot2d(iW,x,y,2,6,0,14,0);
  if(FlP) PSPlot2d(x,y,2,6,0,14,0);

  y[0]	=-1.;
  y[1]	=y[0];
  Plot2d(iW,x,y,2,6,0,14,0);
  if(FlP) PSPlot2d(x,y,2,6,0,14,0);

  y[0]	=-5.;
  y[1]	=5.;
  kc	=kCol[0];
  x[0]=0.5;
  x[1]=x[0];
  Plot2d(iW,x,y,2,6,0,kc,0);
  if(FlP){
    PSSetLineWidth(1.);
    PSPlot2d(x,y,2,6,0,kc,0);
  }
  j	=ESNp;
  if((kA&0x02)){
    kc	=kCol[1];
    n	=neqUY;
    x[0]=j+0.5;
    x[1]=x[0];
    Plot2d(iW,x,y,2,6,0,kc,0);
    if(FlP) PSPlot2d(x,y,2,6,0,kc,0);
    j	+=n;
  }
  if((kA&0x04)){
    kc	=kCol[2];
    n	=2;
    x[0]=j+0.5;
    x[1]=x[0];
    Plot2d(iW,x,y,2,6,0,kc,0);
    if(FlP) PSPlot2d(x,y,2,6,0,kc,0);
    j	+=n;
  }
  if((kA&0x08)){
    kc	=kCol[3];
    n	=nMSE;
    x[0]=j+0.5;
    x[1]=x[0];
    Plot2d(iW,x,y,2,6,0,kc,0);
    if(FlP) PSPlot2d(x,y,2,6,0,kc,0);
    j	+=n;
  }
  if((kA&0x10)){
    kc	=kCol[5];
    n	=nMSS;
    x[0]=j+0.5;
    x[1]=x[0];
    Plot2d(iW,x,y,2,6,0,kc,0);
    if(FlP) PSPlot2d(x,y,2,6,0,kc,0);
    j	+=n;
  }
  if((kA&0x20)){
    kc	=kCol[4];
    n	=nSightP;
    x[0]=j+0.5;
    x[1]=x[0];
    Plot2d(iW,x,y,2,6,0,kc,0);
    if(FlP) PSPlot2d(x,y,2,6,0,kc,0);
    j	+=n;
  }
  x[0]=j+0.5;
  x[1]=x[0];
  Plot2d(iW,x,y,2,6,0,kc,0);
  if(FlP){
    PSPlot2d(x,y,2,6,0,kc,0);
    PSSetLineWidth(1.);
  }
  for(j=0; j < M; j++) x[j]=j+1;
  for(m=m0; m < m1; m++){
    k	=ind[m];
    kc	=kCol[k%0x10];

    for(j=0; j < M; j++) y[j]=ga*U[j][k];
    Plot2d(iW,x,y,ESNp,6,0,kc,0);
    if(FlP) PSPlot2d(x,y,ESNp,6,0,kc,0);
    j	=ESNp;
    if((kA&0x02)){
      n	=neqUY;
      Plot2d(iW,x+j,y+j,n,6,0,kc,0);
      if(FlP) PSPlot2d(x+j,y+j,n,6,0,kc,0);
      j	+=n;
    }
    if((kA&0x04)){
      n	=2;
      j--;
      x[j]+=0.5;
      x[j+1]+=0.5;
      y[j]=y[j+1];
      Plot2d(iW,x+j,y+j,n,6,0,kc,0);
      if(FlP) PSPlot2d(x+j,y+j,n,6,0,kc,0);
      j	+=n;
    }
    if((kA&0x08)){
      n	=nMSE;
      Plot2d(iW,x+j,y+j,n,6,0,kc,0);
      if(FlP) PSPlot2d(x+j,y+j,n,6,0,kc,0);
      j	+=n;
    }
    if((kA&0x10)){
      n	=nMSS;
      Plot2d(iW,x+j,y+j,n,6,0,kc,0);
      if(FlP) PSPlot2d(x+j,y+j,n,6,0,kc,0);
      j	+=n;
    }
    if((kA&0x20)){
      n	=nSightP;
      Plot2d(iW,x+j,y+j,n,6,0,kc,0);
      if(FlP) PSPlot2d(x+j,y+j,n,6,0,kc,0);
      j	+=n;
    }
  }
  if(FlP){
    PSSetLineWidth(1.);
    PSFileClose();
  }
  return(0);
}

int MakepVariances(double **Jp,double *T)
{
  int k,m,i,ki,j,n,Mm;
  double x[2],y[0x41];
  double gy;
  double F,rT,f0,f1;
  double *lgy,*ld;
  double S,V;

  n	=ESNa1;

  Mm	=ES2Mp1*neqUR;
  for(m=0; m < neqUR; m++){
    rT	=crgm0/(T[m]*ESaR0[0]);
    gy	=0.;
    lgy	=gyEr+Mm+ES2Mp1*m+ESMp;
    ld	=Jp[m];
    F	=0;
    y[0]=0.;
    for(i=1; i < ESNa1; i++){
      F		+=0.5*(ESjp[i]+ESjp[i-1])*(*lgy-gy)
	+0.5*(ld[i]+ld[i-1])*(ESgY[i]-ESgY[i-1]);
      y[i]	=F;
      gy	=*lgy;
      lgy	+=Mm;
    }
    f0	=0.;
    for(i=0; i < ESNa1; i++){
      f1	=(y[i]-F)*rT;
      f0	+=f1*f1;
    }
    gdp[m]	=sqrt(f0/ESNa);
  }
  ESGeometryParam(&V,&S);

  pMPa	=1.25*ESaJ[ESNa]*ESaJ[ESNa]/S;
#ifdef H
  CbStr2UserMessage("Vol=%10.3e\nS  =%10.3e\n",V,S);
#endif
  return(0);
}

int PlotpVariances(int iW,int i0,int i1,int m0,int m1,double **Jp
		   ,double *T,int FlP)
{
  int k,m,i,ki,j,n,Mm;
  double x[2],y[0x41];
  double gy;
  double F,rT,f0,f1;
  double *lgy,*ld;
  char ln[0x40];
  
  if(FlP){
    static int inx=1,iny=1;
    static int kPS=1;
    static char PSFileNm[16];
    if(FlP > 1){
      if(FlP != 4){
	inx	=FlP-1;
	iny	=FlP-1;
      }
      else{
	inx	=4;
	iny	=4;
      }
    }
    if(kPS && *ShotNm != '\0'){
      sprintf(PSFileNm,"%s.ps",ShotNm);
      PSSetFileName(PSFileNm);
      kPS	=0;
    }
    PSFileOpen(inx,iny);
  }
  x[0]	=ESsa[i0];
  x[1]	=ESsa[i1-1];
  y[0]	=0.;
  y[1]	=ESsp[0] < 0.1*cgm0 ? 0.1*cgm0 : ESsp[0]*1.5;
  y[1]	=pMPa;
  n	=1;
  while(y[1] < ESsp[0]*crgm0){
    y[1]+=pMPa;
    n++;
  }
  if(m0 < 0) m0	=0;
  if(m1 > neqUR) m1=neqUR;

  sprintf(ln,"%s i0=%d i1=%d k0=%d k1=%d",ShotNm,i0,i1,m0,m1);

  sprintf(ln,"gbj=%d %d<= i <%d %d<= k <=%d",n,i0,i1,m0+1,m1);

  SetPlotName("a","p [MPa]",ln);
  Scale2d(iW,x,y,2,6,2);

  if(FlP){
    PSNewFrame();
    PSSetLineWidth(1.);
  }
  n	=i1-i0;

  Mm	=ES2Mp1*neqUR;
  for(m=m0; m < m1; m++){
    rT	=crgm0/(T[m]*ESaR0[0]);
    gy	=0.;
    lgy	=gyEr+Mm+ES2Mp1*m+ESMp;
    ld	=Jp[m];
    F	=0;
    y[0]=0.;
    for(i=1; i < ESNa1; i++){
      F		+=0.5*(ESjp[i]+ESjp[i-1])*(*lgy-gy)
	+0.5*(ld[i]+ld[i-1])*(ESgY[i]-ESgY[i-1]);
      y[i]	=F;
      gy	=*lgy;
      lgy	+=Mm;
    }
    f0	=0.;
    for(i=0; i < ESNa1; i++){
      f1	=(y[i]-F)*rT;
      y[i]=crgm0*ESsp[i]+f1;
      f0	+=f1*f1;
    }
    gdp[m]	=sqrt(f0/ESNa);
    Plot2d(iW,ESsa+i0,y+i0,n,6,0,kCol[m%0x10],0);
    if(FlP) PSPlot2d(ESsa+i0,y+i0,n,6,0,kCol[m%0x10],0);
  }

  for(i=0; i < ESNa1; i++) y[i]=crgm0*ESsp[i];

  Plot2d(iW,ESsa+i0,y+i0,n,6,0,0,0);
  if(FlP){
    PSSetLineWidth(3.);
    PSPlot2d(ESsa+i0,y+i0,n,6,0,0,0);
    PSSetLineWidth(1.);
  }
  if(FlP) PSFileClose();
  return(0);
}

int PlotBzBtVariances(int iW,int i0,int i1,int m0,int m1,double ga
		      ,double **U,int *ind,double *err,int FlP)
{
  int k,m,i,j,n;
  double x[NMSE],y[NMSE];
  char ln[0x40];
  double erA,er[0x101];
  
  if(FlP){
    static int inx=1,iny=1;
    static int kPS=1;
    static char PSFileNm[16];
    if(FlP > 1){
      if(FlP != 4){
	inx	=FlP-1;
	iny	=FlP-1;
      }
      else{
	inx	=4;
	iny	=4;
      }
    }
    if(kPS && *ShotNm != '\0'){
      sprintf(PSFileNm,"%s.ps",ShotNm);
      PSSetFileName(PSFileNm);
      kPS	=0;
    }
    PSFileOpen(inx,iny);
  }

  if(i0 < 0) i0=0;
  if(i1 > nMSE) i1=nMSE;

  i0	=0;
  i1	=nMSE;

  erA	=err[1]*cgp/180.;
  for(i=i0; i < i1; i++) er[i]=(err[0]*BzBt[i]+erA)*ga;
  for(i=i0; i < i1; i++) er[i]=(MSE[i].errR*BzBt[i]+MSE[i].errA*cgp/180.)*ga;

  x[0]	=MSE[i0].r;
  x[1]	=MSE[i1-1].r;

  y[0]	=1.25*BzBt[i1-1];
  y[1]	=BzBt[i0] > 0. ? BzBt[i0] : 0.;

  if(m0 < 0) m0	=0;
  if(m1 > neqUR) m1=neqUR;

  sprintf(ln,"%s i0=%d i1=%d k0=%d k1=%d",ShotNm,i0,i1,m0,m1);
  sprintf(ln,"%d<= i <%d %d<= k <=%d",i0,i1,m0+1,m1);

  SetPlotName("a","Bz/Bt",ln);
  Scale2d(iW,x,y,2,6,2);

  if(FlP){
    PSNewFrame();
    PSSetLineWidth(1.);
  }
  n	=i1-i0;

  for(i=0; i < nMSE; i++) x[i]=MSE[i].r;
  for(m=m0; m < m1; m++){
    j	=ind[m];
    for(i=i0; i < i1; i++) y[i]=BzBt[i]+er[i]*U[i][j];
    Plot2d(iW,x+i0,y+i0,n,6,0,kCol[m%0x10],0);
    if(FlP) PSPlot2d(x+i0,y+i0,n,6,0,kCol[m%0x10],0);
  }

  Plot2d(iW,x+i0,BzBt+i0,n,6,0,0,0);
  if(FlP){
    PSSetLineWidth(3.);
    PSPlot2d(x+i0,BzBt+i0,n,6,0,0,0);
    PSSetLineWidth(1.);
  }
  if(FlP) PSFileClose();
  return(0);
}

int MakeqVariances(double *T)
{
  int k,m,i,ki,j,n,Mm;
  double dgY,dgy,L0;
  double F,f0,f1;
  double *gyr,*gyi;


  Mm	=ES2Mp1*neqUR;
  for(m=0; m < neqUR; m++){
    F	=0;
    f1	=0.;
    for(i=1; i < ESNa1; i++){
      f0	=f1;
      f1	=0.;
      j		=Mm*i+ES2Mp1*m+ESMp;
      gyr	=gyEr+j;
      gyi	=gyEi+j;
      for(k=1; k < ESMp1; k++){
	ki	=ESNa1*k+i;
	f1 	+=2.*(ESLc1[ki]*gyr[k]-ESLs1[ki]*gyi[k]);
      }
      F	+=0.25*(f0+f1)*(ESpa[i]-ESpa[i-1]);
    }
    F	*=2./ESgF[ESNa];

    f0	=0.;
    for(i=1; i < ESNa1; i++){
      dgY	=ESdgY[i]*ESsa[i];
      j	=Mm*i+ES2Mp1*m+ESMp;
      dgy	=dgyEr[j];
      f1	=-(ESsq[i]*dgy+ESsa[i]*F)/(dgY*T[m]);

      f1	=-ESsq[i]*dgy/(dgY*T[m]);
      
      f0	+=f1*f1;
    }
    gdq[m]	=sqrt(f0/ESNa);
  }
  return(0);
}

int PlotqVariances(int iW,int i0,int i1,int m0,int m1,double *T,int FlP)
{
  int k,m,i,ki,j,n,Mm;
  double x[2],y[0x41];
  double *ld,dgY,dgy,L0;
  double F,f0,f1;
  double *gyr,*gyi;
  char ln[0x40];
  
  if(FlP){
    static int inx=1,iny=1;
    static int kPS=1;
    static char PSFileNm[16];
    if(FlP > 1){
      if(FlP != 4){
	inx	=FlP-1;
	iny	=FlP-1;
      }
      else{
	inx	=4;
	iny	=4;
      }
    }
    if(kPS && *ShotNm != '\0'){
      sprintf(PSFileNm,"%s.ps",ShotNm);
      PSSetFileName(PSFileNm);
      kPS	=0;
    }
    PSFileOpen(inx,iny);
  }
  x[0]	=ESsa[i0];
  x[1]	=ESsa[i1-1];
  y[0]	=0.;
  y[1]	=ESsq[ESNa];

  if(m0 < 0) m0	=0;
  if(m1 > neqUR) m1=neqUR;

  sprintf(ln,"%s i0=%d i1=%d k0=%d k1=%d",ShotNm,i0,i1,m0,m1);

  sprintf(ln,"i0=%d i1=%d %d<= k <=%d",i0,i1,m0+1,m1);

  SetPlotName("a","q",ln);
  Scale2d(iW,x,y,2,6,2);

  if(FlP){
    PSNewFrame();
    PSSetLineWidth(1.);
  }
  n	=i1-i0;
  ld	=ESjs+i0;

  Mm	=ES2Mp1*neqUR;
  for(m=m0; m < m1; m++){
    F	=0;
    f1	=0.;
    for(i=1; i < ESNa1; i++){
      f0	=f1;
      f1	=0.;
      j		=Mm*i+ES2Mp1*m+ESMp;
      gyr	=gyEr+j;
      gyi	=gyEi+j;
      for(k=1; k < ESMp1; k++){
	ki	=ESNa1*k+i;
	f1 	+=2.*(ESLc1[ki]*gyr[k]-ESLs1[ki]*gyi[k]);
      }
      F	+=0.25*(f0+f1)*(ESpa[i]-ESpa[i-1]);
    }
    F	*=2./ESgF[ESNa];

    f0	=0.;
    for(i=i0 ? i0 : 1; i < i1; i++){
      dgY	=ESdgY[i]*ESsa[i];
      j	=Mm*i+ES2Mp1*m+ESMp;
      dgy	=dgyEr[j];
      f1	=-(ESsq[i]*dgy+ESsa[i]*F)/(dgY*T[m]);

      f1	=-ESsq[i]*dgy/(dgY*T[m]);

      y[i]	=ESsq[i]+f1;
      f0	+=f1*f1;
    }
#ifdef H
    gdq[m]	=sqrt(f0/ESNa);
#endif
    if(i0 == 0) y[0]=y[1];
    Plot2d(iW,ESsa+i0,y+i0,n,6,0,kCol[m%0x10],0);
    if(FlP) PSPlot2d(ESsa+i0,y+i0,n,6,0,kCol[m%0x10],0);
  }
  Plot2d(iW,ESsa+i0,ESsq+i0,n,6,0,0,0);
  if(FlP){
    PSSetLineWidth(3.);
    PSPlot2d(ESsa+i0,ESsq+i0,n,6,0,0,0);
    PSSetLineWidth(1.);
  }
  if(FlP) PSFileClose();
  return(0);
}

int PlotSVDEigenU(int iW,int N,double *E,double Emin,int kA, double err[][2]
		  ,int FlP)
{
  extern int nBeam;
  extern double Err4Beam[][4];
  extern int hF;
  extern double PSfh,PSsy;
  static int inx=1,iny=1;
  int i,k,m;
  double eL[N],eLmn;
  double x[N],y[2],s,d,d2,sX,sY,PSh;
  char ln[0x40];
  double *ld,v;
  
  d2	=Emin*Emin;
  s	=0.;
  v	=0.;
  for(i=0; i < N; i++){
    d	=E[i]*E[i];
    if(d >= d2)  v+=d;
    s	+=d;
  }
  v	*=100./s;
  if(FlP){
    static int kPS=1;
    static char PSFileNm[16];
    if(FlP > 1){
      if(FlP != 4){
	inx	=FlP-1;
	iny	=FlP-1;
      }
      else{
	inx	=4;
	iny	=4;
      }
    }
    if(kPS && *ShotNm != '\0'){
      sprintf(PSFileNm,"%s.ps",ShotNm);
      PSSetFileName(PSFileNm);
      kPS	=0;
    }
    PSFileOpen(inx,iny);
  }
  
  sprintf(ln,"Variance=%10.3e",v);
  SetPlotName("k","log10 of Errors in j,q,p,gbV,li",ln);
  SetPlotName("k","sigma-curves for j,q,p,gbV,li","");

  y[0]	=100;
  y[1]	=-100;
  for(i=0; i < N; i++){
    eL[i]	=E[i] > 1e-10 ? -log10(E[i]) : 10.;
    if(y[0] > eL[i]) y[0]=eL[i];
    if(y[1] < eL[i]) y[1]=eL[i];
  }
  eLmn	=log10(Emin)+y[1];
  if(y[0] > eLmn) y[0]=eLmn;
  x[0]	=0.;
  x[1]	=N+1.;

  y[1]	=6.;
  y[0]	=-4.;

  y[1]	=2.;
  y[0]	=-3.;

  Scale2d(iW,x,y,2,6,2);
  CbGetScale(&sX,&sY);
  if(FlP){
    PSNewFrame();
  }
  /*******/
  if(1){
    char str[0x40];
    double x0,y0,yP,y1,dy,dyP;
    dy	=-hF/sY;
    x0	=0.2;
    y1	=1.8;
    i	=2;
    if((kA&0x20)) i++;
#ifdef H
    if((kA&0x10)) i++;
    if((kA&0x08)) i++;
#endif
    if((kA&0x10)) i+=nBeam;
    if((kA&0x08)) i+=nBeam;

    if((kA&0x04)) i++;
    if((kA&0x02)) i++;
    y0	=y1-dy*i;
    PlotColor(12);
    XFillRect(x0,y0,x0+0.7*(x[1]-x0),y1);
    if(FlP){
      PSSetFont("CourierBold");
      PSh	=PSfh;
      PSfh	=12./inx;
      PSColor(12);
      dyP	=-(PSfh+2)/PSsy;
      yP	=y1-dyP*i;
      PSFillRect(x0,yP,x0+0.55*(x[1]-x0),y1+dyP);
    }
    PlotColor(0);
    y0	=y1-0.5*dy;
    i	=sprintf(str,"Ipl=%6.3f [MA] Bt=%6.4f [T]",5.*ESaJ[ESNa],ESBt);
    XPlotString(x0,y0,str,i);
    y0 -=dy;
    if(FlP){
      yP=y1-0.5*dyP;
      PSPlotString(x0,yP,str,i);
      yP -=dyP;
    }
    i	=sprintf(str,"err     Bp=%5.3f %6.4f [T]",err[0][0],err[0][1]);
    XPlotString(x0,y0,str,i);
    y0	-=dy;
    if(FlP){
      PSPlotString(x0,yP,str,i);
      yP -=dyP;
    }

    if((kA&0x02)){
      i	=sprintf(str,"err     gY=%5.3f %5.4f [Vsec]",err[1][0],err[1][1]);
      XPlotString(x0,y0,str,i);
      y0	-=dy;
      if(FlP){
	PSPlotString(x0,yP,str,i);
	yP -=dyP;
      }
    }
    if((kA&0x04)){
      i	=sprintf(str,"err     gF=%5.3f %5.4f [Vsec]",err[2][0],err[2][1]);
      XPlotString(x0,y0,str,i);
      y0	-=dy;
      if(FlP){
	PSPlotString(x0,yP,str,i);
	yP -=dyP;
      }
    }
    if((kA&0x08)){
      for(m=0; m < nBeam; m++){
	i=sprintf(str,"err MSE-LP=%5.3f %4.2f [^o]"
		  ,Err4Beam[m][0],Err4Beam[m][1]);
	XPlotString(x0,y0,str,i);
	y0	-=dy;
	if(FlP){
	  PSPlotString(x0,yP,str,i);
	  yP -=dyP;
	}
      }
    }
    if((kA&0x10)){
      for(m=0; m < nBeam; m++){
	i=sprintf(str,"err MSE-LS=%5.3f %5.4f [T]"
		  ,Err4Beam[m][2],Err4Beam[m][3]);
	XPlotString(x0,y0,str,i);
	y0	-=dy;
	if(FlP){
	  PSPlotString(x0,yP,str,i);
	  yP -=dyP;
	}
      }
    }
    if((kA&0x20)){
      i	=sprintf(str,"err FaradR=%5.3f %4.2f [^o]",err[5][0],err[5][1]);
      XPlotString(x0,y0,str,i);
      y0	-=dy;
      if(FlP){
	PSPlotString(x0,yP,str,i);
	yP -=dyP;
      }
    }
    if(FlP){
      PSSetFont("Helvetica");
      PSfh	=PSh;
    }
  }	

  i	=0;
  k	=0;
  y[0]	-=1.;
  /*
  while(i < N (&& eL[i] > eLmn)){
  */
  while(i < N){
    x[0]=i+1;
    x[1]=x[0];
    Plot2d(iW,x,y,2,6,0,kCol[k%0x10],0);
    if(FlP) PSPlot2d(x,y,2,6,0,kCol[k%0x10],0);
    k++;
    i++;
  }
  for(i=0; i < N; i++) x[i]=i+1;
  Plot2d(iW,x,eL,N,6,0,kCol[0],0);
  if(FlP){
    PSSetLineWidth(3.);
    PSPlot2d(x,eL,N,6,0,kCol[0],0);
    PSSetLineWidth(2.);
  }

  /* q-profile */
  for(i=0; i < N; i++){
    eL[i]	=gdq[i] < 1e10 ? log10(gdq[i]) : 10.;
  }
  Plot2d(iW,x,eL,N,6,0,kCol[1],0);
  if(FlP) PSPlot2d(x,eL,N,6,0,kCol[1],0);
  if(7 < N)PlotString(x[7],eL[7],"q",1);

  /* li value */
  for(i=0; i < N; i++){
    eL[i]	=gdliV[i] < 1e10 ? log10(gdliV[i]) : 10.;
  }
  Plot2d(iW,x,eL,N,6,0,kCol[3],0);
  if(FlP) PSPlot2d(x,eL,N,6,0,kCol[3],0);
  if(7 < N) PlotString(x[7],eL[7],"li",2);

  /* p-profile */
  for(i=0; i < N; i++){
    s	=gdp[i]/pMPa;
    eL[i]	=s < 1e10 ? log10(s) : 10.;
  }
  Plot2d(iW,x,eL,N,6,0,kCol[11],0);
  if(FlP) PSPlot2d(x,eL,N,6,0,kCol[11],0);
  if(8 < N) PlotString(x[8],eL[8],"p",1);

  /* gbV value */
  for(i=0; i < N; i++){
    eL[i]	=gdgbV[i] < 1e10 ? log10(gdgbV[i]) : 10.;
  }
  Plot2d(iW,x,eL,N,6,0,kCol[12],0);
  if(FlP) PSPlot2d(x,eL,N,6,0,kCol[12],0);
  i	=N-1;
  while(i && eL[i] > -1) i--;
  PlotString(x[i],eL[i],"gbV",3);

#ifdef H
static char Dash[16][16]={
  "",
  "8 2 2 2",
  "12 6",
  "16 2 2 2",
  "2 2",
  "4 4",
  "12 2 2 2",
  "8 8",
  "8 8 2 2",
  "16 4",
  "16 2 2 2",
  "16 4",
  "12 6",
  "8 8",
  "8 8 2 2",
  "4 4"
};

  ,"0.00000 0.00000 0.00000" /* 0<Black><black>*/
  ,"0.00000 0.00000 0.99609" /* 1<Blue><blue>*/
  ,"0.00000 0.99609 0.00000" /* 2<Green><green>*/
  ,"0.00000 0.99609 0.99609" /* 3<Cyan><cyan>*/
  ,"0.99609 0.00000 0.00000" /* 4<Red><red>*/
  ,"0.99609 0.00000 0.99609" /* 5<Magenta><magenta>*/
  ,"0.99609 0.99609 0.00000" /* 6<Yellow><yellow>*/
  ,"0.00000 0.00000 0.54297" /* 7<Blue4><blue4>*/
  ,"0.00000 0.54297 0.00000" /* 8<Green4><green4>*/
  ,"0.54297 0.13672 0.13672" /* 9<Brown4><brown4>*/
  ,"0.54297 0.00000 0.54297" /*10<Magenta4><magenta4>*/
  ,"0.99609 0.64453 0.00000" /*11<orange><orange>*/
  ,"0.54297 0.38672 0.42188" /*12<Pink4><pink4>*/
  ,"0.92969 0.23047 0.23047" /*13<Brown2><brown2>*/
  ,"0.52734 0.80469 0.99609" /*14<SkyBlue1><SkyBlue1>*/
  ,"0.59766 0.59766 0.59766" /*15<Grey60><grey60>*/
#endif

#ifdef H
  for(i=0; i < N; i++){
    eL[i]	=gdShS[i] < 1e10 ? log10(gdShS[i]) : 10.;
  }
  Plot2d(iW,x,eL,N,6,0,9,0);
  if(FlP) PSPlot2d(x,eL,N,6,0,9,0);

  for(i=0; i < N; i++){
    eL[i]	=gdgbS[i] < 1e10 ? log10(gdgbS[i]) : 10.;
  }
  Plot2d(iW,x,eL,N,6,0,9,0);
  if(FlP) PSPlot2d(x,eL,N,6,0,9,0);
#endif

  y[0]	=0;
  y[1]	=y[0];
  x[0]	=1.;
  x[1]	=N;
  Plot2d(iW,x,y,2,6,0,14,0);
  if(FlP){
    PSSetLineWidth(2.);
    PSPlot2d(x,y,2,6,0,0,0);
    PSSetLineWidth(1.);
  }
  y[0]	=-1.;
  y[1]	=y[0];
  Plot2d(iW,x,y,2,6,0,14,0);
  if(FlP){
    PSPlot2d(x,y,2,6,0,0,0);
  }
  if(FlP) PSFileClose();
  return(0);
}

int gDDiaMagSignal(double *DiaS,double *U0,double *E0,int kA,double *err)
{
  int i,j,k,m,MmJ;
  double R0,rR0,s;
  double baLV[ESNa1],p4a[ESNa1];
  double gD,rer,F,dF0,dF1;
  double aT[ESNa1],T[ESNa1];
  double *y,*y2,*lyr,*lyi;
  extern double *ESsr
    ,*ESaT,*ESaT1a,*ESaT2a
    ,*ESaF,*ESaF1a,*ESaF2a
    ,*ESdgY,*ESdgY1a,*ESdgY2a
    ;

  R0	=ESaR0[0];
  rR0	=1./R0;

  p4a[0]	=0.;
  aT[0]	=ESaT[0]/ESaF[0];
  baLV[0]=ESsb1a[0]*rcT1a[ESNa1]*ESdgY[0]*rR0/ESaF[0];
  k	=ESNp1;
  for(i=1; i < ESNa1; i++){
    p4a[i]	=0.125*ESpa[i]*ESpa[i];
    aT[i]	=ESaT[i]/ESaF[i];
    s	=0.;
    for(j=0; j < ESNp; j++,k++) s +=log(ESsr[k]*rR0)*EScs1[j];
    baLV[i]=s*ESsb[i]*ESdgY[i]/(ESpa[i]*ESaF[i]*ESNp);
    k++;
  }

  i	=0;
  gD	=0.;
  dF1	=ESaT[0]*baLV[0];
  for(i=1; i < ESNa1; i++){
    dF0	=dF1;
    dF1	=ESaT[i]*baLV[i];
    gD	+=(dF0+dF1)*(p4a[i]-p4a[i-1]);
  }
  gD	*=c2gp;
  *U0	=gD;
  *E0	=err[0]*fabs(gD)+err[1];
  rer	=1./(*E0);

  MmJ	=ES2Mp1*neqU;
  for(m=0; m < neqU; m++){
    if(m < neqUJ){
      Point2BasicFunctions(&y,&y2,m);
      for(i=0; i < ESNa1; i++) T[i] =y[i]*R0;
    }
    else{
      Point2BasicFunctions(&y,&y2,m-neqUJ);
      for(i=0; i < ESNa1; i++) T[i] =-y[i]*R0;
    }
    k	=MmJ+ES2Mp1*m+ESMp;
    lyr	=gperU+k;
    lyi	=gpeiU+k;
    F	=0.;

    gD		=0.;
    dF1	=T[0]*baLV[0];
    for(i=1; i < ESNa1; i++){
      dF0	=dF1;
      dF1	=T[i]*baLV[i];
      gD	+=(dF0+dF1)*(p4a[i]-p4a[i-1]);
    }

    dF1	=0.;
    for(i=1; i < ESNa1; i++){
      dF0	=dF1;
      j	=i;
      dF1=ESLc[j]*lyr[0];
      for(k=1; k < ESMp1; k++){
	j	+=ESNa1;
	dF1	+=2.*(ESLc1[j]*lyr[k]-ESLs1[j]*lyi[k]);
      }
      dF1	*=aT[i];
      F		+=0.25*(dF0+dF1)*(ESpa[i]-ESpa[i-1]);
      lyr	+=MmJ;
      lyi	+=MmJ;
    }
    DiaS[m]	=c2gp*(gD-F*rR0)*rer;
  }
  if((kA&0x02)){
    int mr,mi,kp,km;
    double Fr,Fi,dF0r,dF1r,dF0i,dF1i;

    for(m=1,mr=neqU,mi=mr+ESMp; m < ESMp1; m++,mr++,mi++){
      i		=0;
      k		=M0Mm+ES2Mp1*m+ESMp;
      lyr	=gper+k;
      lyi	=gpei+k;
      dF1r	=0.;
      dF1i	=0.;
      Fr	=0.;
      Fi	=0.;
      for(i=1; i < ESNa1; i++){
	dF0r	=dF1r;
	dF0i	=dF1i;
	j	=i;
	dF1r	=ESLc[j]*lyr[0];
	dF1i	=ESLc[j]*lyi[0];
	for(k=1; k < ESMp1; k++){
	  j	+=ESNa1;
	  dF1r	+=s*ESLc1[j]*(lyr[k]+lyr[-k])+ESLs1[j]*(lyi[-k]-lyi[k]);
	  dF1i	+=ESLc1[j]*(lyi[k]+lyi[-k])+ESLs1[j]*(lyr[k]-lyr[-k]);
	}
	s	=0.25*(ESpa[i]-ESpa[i-1]);
	dF1r	*=aT[i];
	Fr	+=(dF0r+dF1r)*s;
	dF1i	*=aT[i];
	Fi	+=(dF0i+dF1i)*s;
	lyr	+=M0Mm;
	lyi	+=M0Mm;
      }
      DiaS[mr]	=-c2gp*Fr*rR0*rer;
      DiaS[mi]	=-c2gp*Fi*rR0*rer;
    }
  }
  return(0);
}

int FaradayRotation(double *errF, double *errNe)
{
  int i,j,n,n1;
  double a,r,z,dra,dza,drp,dzp,tx,ty,tr,tf,tz,cs,sn;
  double F,dgY,gtt,D,Bv,S,ABv,Ane,C,ne;
  double *lr,*ra,*rt,*za,*zt,*lD;
  SIGHTLINE *lS;

  C	=2.*cFaraday*glFaraday*glFaraday;
  SetBoxRZ();
  for(i=0; i < nSightP; i++) PunchPoints(SightP+i);
  if(SetupLineIntegration(SightP,nSightP)) return(0);
  for(i=0,lS=SightP; i < nSightP; i++,lS++){
    lr	=lS->r;
    lD	=lS->D;
    ra	=lS->ra;
    rt	=lS->rq;
    za	=lS->za;
    zt	=lS->zq;

    tx	=lS->tx;
    ty	=lS->ty;
    tz	=lS->tz;
    S	=1./sqrt(tx*tx+ty*ty+tz*tz);
    tx	*=S;
    ty	*=S;
    tz	*=S;
    n1	=lS->n1;
    n	=n1-1;
    S	=0.;
    Ane	=0.;
    ABv	=0.;
    for(j=0; j < n1; j++){
      a	=lS->a[j];
      ES2DMapFlx2Lab(&r,&z,&dra,&dza,&drp,&dzp,a,lS->q[j]);
      sn=lS->f[j];
      cs=cos(sn);
      sn=sin(sn);
      tr= tx*cs+ty*sn;
      tf=-tx*sn+ty*cs;
      gtt=drp*drp+dzp*dzp;
      D	=dra*dzp-drp*dza;
      lr[j]	=r;
      ra[j]	=dra;
      rt[j]	=drp;
      za[j]	=dza;
      zt[j]	=dzp;
      lD[j]	=D;
      ESSetSplA(a);
      splRA(&F,NULL,ESFF,ESFF2a);
      F	=sqrt(F);
      splRA(&dgY,NULL,ESdgY,ESdgY2a);
      dgY	*=a/D;
      splRA(&ne,NULL,ESne,ESne2a);
      Bv	=(F*tf+dgY*(drp*tr+dzp*tz))/r;
      if(j == 0 || j == n){
	S	+=0.5*ne*Bv;
	ABv	+=0.5*Bv;
	Ane	+=0.5*ne;
      }
      else{
	S	+=ne*Bv;
	ABv	+=Bv;
	Ane	+=ne;
      }
    }
    lS->S	=C*S*lS->V[0];
    ABv		*=C;
    lS->dS	=lS->V[0]*(ABv*errNe[1]+Ane*errF[1])+(errF[0]+errNe[0])*lS->S;

    if(lS->dS == 0) lS->dS=errF[1];
#ifdef H
    out("&&&&& FRi d dd d^o d",i,lS->L[1]-lS->L[0],ABv,Ane,lS->S,lS->S/360.);
#endif
  }
  return(0);
}

int BmodVariances()
{
  int i,j,k,m,ki,M;
  static int Fl=1;
  double r,z,dra,dza,drp,dzp;
  double F,dgY,gtt,D,Bv;

  ESSetMapBox();
  if(Fl == 0){
    for(i=0; i < nMSS; i++){
      ES2DMapLab2Flx(&MSS[i].a,&MSS[i].gt,MSS[i].r,MSS[i].z);
    }
    for(i=0; i < nMSE; i++){
      ES2DMapLab2Flx(&MSE[i].a,&MSE[i].gt,MSE[i].r,MSE[i].z);
    }
  }
  else{
    MSS[0].a	=0.9;
    MSS[0].gt	=0.;
    for(i=0; i < nMSS; i++){
      if(i){
	MSS[i].a	=MSS[i-1].a;
	MSS[i].gt	=MSS[i-1].gt;
      }
      ES2DMapLab2Flx(&MSS[i].a,&MSS[i].gt,MSS[i].r,MSS[i].z);
    }
    MSE[0].a	=0.5;
    MSE[0].gt	=1.1*cgp;
    for(i=0; i < nMSE; i++){
      if(i){
	MSE[i].a	=MSE[i-1].a;
	MSE[i].gt	=MSE[i-1].gt;
      }
      ES2DMapLab2Flx(&MSE[i].a,&MSE[i].gt,MSE[i].r,MSE[i].z);
    }
    Fl	=0;
  }
  for(i=0; i < nMSS; i++){
    ES2DMapFlx2Lab(&r,&z,&dra,&dza,&drp,&dzp,MSS[i].a,MSS[i].gt);
    r	=MSS[i].r;
    gtt	=drp*drp+dzp*dzp;
    D	=dra*dzp-drp*dza;
    MSS[i].D=D;
    MSS[i].ra	=dra;
    MSS[i].rq	=drp;
    MSS[i].za	=dza;
    MSS[i].zq	=dzp;
    ESSetSplA(MSS[i].a);
    splRA(&F,NULL,ESFF,ESFF2a);
    F	=sqrt(F);
    splRA(&dgY,NULL,ESdgY,ESdgY2a);
    dgY	*=MSS[i].a/D;
    Bv	=F*MSS[i].tf+dgY*(drp*MSS[i].tr+dzp*MSS[i].tz);
    Bmod[i]=(F*F+gtt*dgY*dgY-Bv*Bv)/(r*r);
  }

  for(i=0; i < nMSE; i++){
    ES2DMapFlx2Lab(&r,&z,&dra,&dza,&drp,&dzp,MSE[i].a,MSE[i].gt);
    gtt	=drp*drp+dzp*dzp;
    D	=dra*dzp-drp*dza;
    MSE[i].D	=D;
    MSE[i].ra	=dra;
    MSE[i].rq	=drp;
    MSE[i].za	=dza;
    MSE[i].zq	=dzp;
    ESSetSplA(MSE[i].a);
    splRA(&F,NULL,ESFF,ESFF2a);
    F	=sqrt(F);
    splRA(&dgY,NULL,ESdgY,ESdgY2a);
    dgY	*=MSE[i].a/D;
    Mse[i]=dgY*dzp/F;

#ifdef H
    DMse[i]	=DBmod[i];
    aMse[i]	=aBmod[i];
    gtMse[i]	=gtBmod[i];
    draMse[i]	=draBmod[i];
    drpMse[i]	=drpBmod[i];
    dzaMse[i]	=dzaBmod[i];
    dzpMse[i]	=dzpBmod[i];

    D	=DMse[i];
    ESSetSplA(aMse[i]);
    splRA(&F,NULL,ESFF,ESFF2a);
    F	=sqrt(F);
    splRA(&dgY,NULL,ESdgY,ESdgY2a);
    dgY	*=aMse[i]/D;
    Mse[i]=dgY*dzpMse[i]/F;
#endif
  }
  return(0);
}

int gxSignal(double *U[],double *U0,double *E0,double *err)
{
  extern double *ESgY,*ESdgY,*ESsr;
  int i,j,jj,k,kj,m,mr,mi;
  double gxr,gxi,cs,sn,gx,dgY;
  double erA,erR;
  double *lr,*li;

  dgY	=ESdgY[ESNa];
  erR	=err[0]*fabs(ESgY[ESNa]);
  erA	=cr2gp*err[1];
  erA	=err[1]*fabs(ESgY[ESNa]);

  jj	=ESNp/neqUY;
  k	=ESNp1*ESNa;
  for(j=0,jj=0; j < neqUY; j++,jj+=2){
    U0[j]	=fabs(ESsr[k+jj]*Bpol[jj]);
    E0[j]	=erR+erA;
  }

  jj	=ESNp/neqUY;
  for(i=0,j=0; i < neqUY; i++,j+=jj){
    k	=M0Mm*ESNa+ES2Mp1+ESMp;
    lr	=gper+k;
    li	=gpei+k;
    for(m=1,mr=neqU,mi=mr+ESMp; m < ESMp1; m++,mr++,mi++){
      gxr	=0.;
      gxi	=0.;
      kj	=0;
      for(k=1; k < ESMp1; k++){
	kj	+=j;
	if(kj >= ESNp) kj-=ESNp;
	cs	=EScs1[kj];
	sn	=ESsn1[kj];
	gxr	+=(lr[k]+lr[-k])*cs-(li[k]-li[-k])*sn;
	gxi	+=(li[k]+li[-k])*cs+(lr[k]-lr[-k])*sn;
      }
      U[i][mr]	=-gxr/E0[i];
      U[i][mi]	=-gxi/E0[i];
      lr	+=ES2Mp1;
      li	+=ES2Mp1;
    }
  }
  return(0);
}

int SignalMseLS(double **U,double *U0,double *E0,int kA,double *err)
{
  int i,iB,k,m,ii,Mm;
  double R0,rR0,aD;
  double h2sh,h12p2sh;
  double s,ds;

  double t,gy0,gy1,dgy0,dgy1,h,dgY,d2gY,cs,sn;
  double X,gy0t,gy1t,dgy0t,dgy1t,aB;
  double gy,dgya,dgyt;

  extern double ESBt;

  extern double *ESaJ,*ESaJ1a,*ESaJ2a
    ,*ESaT,*ESaT1a,*ESaT2a
    ,*ESgY,*ESgY1a,*ESgY2a
    ,*ESgF,*ESgF1a,*ESgF2a
    ,*ESaF,*ESaF1a,*ESaF2a
    ,*ESFF,*ESFF1a,*ESFF2a
    ,*ESdgY,*ESdgY1a,*ESdgY2a
    ;
  double T[ESNa1],dT[ESNa1],rF[ESNa1]
    ,F,dF0,dF1,d2F0,d2F1;
  double Br,dBr,Bz,dBz,Bf,dBf;

  double *y,*y2,*lyr,*lyi,*ldyr,*ldyi;

  R0	=ESaR0[0];
  rR0	=1./R0;

  h2sh	=cr2*ESsa[1];
  h12p2sh=cr12*ESpa[1];
  for(i=0; i < ESNa1; i++){
    rF[i]=1./ESaF[i];
  }
  
#ifdef H
  printf("    [ #] %10s %10s %10s  %10s %10s  %10s %10s\n","Br","Bgf","Bz"
	 ,"|B|","v.B","vr","vgf");
#endif

  Mm	=ES2Mp1*neqU;
  for(iB=0; iB < nMSS; iB++){ 
    aB	=MSS[iB].a;
    ESSetSplA(aB);
    splRA(&dgY,NULL,ESdgY,ESdgY2a);
    dgY	*=aB;
    splRA(&dF0,NULL,ESaF,ESaF2a);
    s	=1./MSS[iB].r;
    Bf	=dF0*s;
    s	/=MSS[iB].D;
    Br	=dgY*MSS[iB].rq*s;
    Bz	=dgY*MSS[iB].zq*s;
    dF1	=MSS[iB].tr*Br+MSS[iB].tz*Bz+MSS[iB].tf*Bf;
    U0[iB]	=sqrt(Bf*Bf+Br*Br+Bz*Bz-dF1*dF1);

#ifdef H
    out("??? iddd dd dd",iB,Br,Bf,Bz,sqrt(Bf*Bf+Br*Br+Bz*Bz),dF1
	,trBmod[iB],tfBmod[iB]);
#endif

    E0[iB]	=U0[iB]*err[0]+err[1];
    E0[iB]	=U0[iB]*MSS[iB].errR+MSS[iB].errA;
  }
  for(m=0; m < neqU; m++){
    if(m < neqUJ){
      Point2BasicFunctions(&y,&y2,m);
      splA1a(y,dT,y2);
      for(i=0; i < ESNa1; i++){
	T[i]	=y[i]*R0;
	dT[i]	*=R0;
      }
    }
    else{
      Point2BasicFunctions(&y,&y2,m-neqUJ);
      splA1a(y,dT,y2);
      for(i=0; i < ESNa1; i++){
	T[i]	=-y[i]*R0;
	dT[i]	*=-R0;
      }
    }
    for(iB=0; iB < nMSS; iB++){ 
      aB	=MSS[iB].a;
      ESSetSplA(aB);
      ii=aB/ESsa[1];
      i	=ii+1;
      splRA(&dF0,&d2F0,y,y2);
      if(m < neqUJ){
	dF0	*=R0;
	d2F0	*=R0;
      }
      else{
	dF0	*=-R0;
	d2F0	*=-R0;
      }
      splRA(&dgY,&d2gY,ESdgY,ESdgY2a);

      d2F0	=dF0*d2gY+d2F0*dgY;
      d2F1	=dF0*dgY;
      dF1	=aB*d2F1;
      d2F1	+=aB*d2F0;
      F	=0.;
      if(i < ESNa1){
	dF0	=dF1;
	d2F0	=d2F1;
	d2F1	=ESdgY[i]*T[i];
	dF1	=ESsa[i]*d2F1;
	d2F1	+=ESsa[i]*(ESdgY1a[i]*T[i]+ESdgY[i]*dT[i]);
	ds	=ESsa[i]-aB;
	F	=ds*(cr2*(dF0+dF1)+cr12*ds*(d2F0-d2F1));
	for(i++; i < ESNa1; i++){
	  dF0	=dF1;
	  d2F0	=d2F1;
	  d2F1	=ESdgY[i]*T[i];
	  dF1	=ESsa[i]*d2F1;
	  d2F1	+=ESsa[i]*(ESdgY1a[i]*T[i]+ESdgY[i]*dT[i]);
	  F	+=h2sh*(dF0+dF1)+h12p2sh*(d2F0-d2F1);
	}
      }
      k		=Mm*ii+ES2Mp1*m+ESMp;
      lyr	=gperU+k;
      lyi	=gpeiU+k;
      ldyr	=dgperU+k;
      ldyi	=dgpeiU+k;

      t	=MSS[iB].gt;
      i	=ii+1;
      gy0	=lyr[0];
      dgy0	=ldyr[0];
      gy1	=lyr[Mm];
      dgy1	=ldyr[Mm];

      gy0t	=0.;
      gy1t	=0.;
      dgy0t	=0.;
      dgy1t	=0.;

      lyr++;
      lyi++;
      ldyr++;
      ldyi++;
      for(k=1; k < ESMp1; k++){
	cs	=cos(k*t);
	sn	=sin(k*t);
	gy0	+=2.*(*lyr*cs-*lyi*sn);
	dgy0	+=2.*(*ldyr*cs-*ldyi*sn);
	gy0t	-=2.*k*(*lyr*sn+*lyi*cs);
	dgy0t	-=2.*k*(*ldyr*sn+*ldyi*cs);
	gy1	+=2.*(lyr[Mm]*cs-lyi[Mm]*sn);
	dgy1	+=2.*(ldyr[Mm]*cs-ldyi[Mm]*sn);
	gy1t	-=2.*k*(lyr[Mm]*sn+lyi[Mm]*cs);
	dgy1t	-=2.*k*(ldyr[Mm]*sn+ldyi[Mm]*cs);
	lyr++;
	lyi++;
	ldyr++;
	ldyi++;
      }
      if(i < ESNa1){
	h	=ESsa[i]-ESsa[ii];
	t	=(aB-ESsa[ii])/h;
	X	=1.-t;
	ds	=h*t*X;
	cs	=(3.-2.*X)*X*X;
	sn	=(3.-2.*t)*t*t;
	gy	=cs*gy0+sn*gy1+ds*(X*dgy0-t*dgy1);
	dgyt	=cs*gy0t+sn*gy1t+ds*(X*dgy0t-t*dgy1t);
	dgya	=6.*t*X*(gy1-gy0)/h+X*(X-2.*t)*dgy0+t*(t-2.*X)*dgy1;
      }else{
	gy	=gy0;
	dgyt	=gy0t;
	dgya	=dgy0;
      }

      dgY	*=aB;
      splRA(&dF0,&d2F0,ESaF,ESaF2a);
      s		=1./MSS[iB].r;
      d2F0	-=dF0*MSS[iB].ra*s;
      dBf	=-(F/dF0+d2F0*gy/dgY)*s;

      Bf	=dF0*s;
      s		/=MSS[iB].D;

      dBr	=(dgya*MSS[iB].rq-dgyt*MSS[iB].ra)*s;
      dBz	=(dgya*MSS[iB].zq-dgyt*MSS[iB].za)*s;
      Br	=dgY*MSS[iB].rq*s;
      Bz	=dgY*MSS[iB].zq*s;
      dF1	=MSS[iB].tr*Br+MSS[iB].tz*Bz+MSS[iB].tf*Bf;
      d2F1	=MSS[iB].tr*dBr+MSS[iB].tz*dBz+MSS[iB].tf*dBf;
      U[iB][m]	=(Bf*dBf+Br*dBr+Bz*dBz-dF1*d2F1)/E0[iB];
    }

  }
  if((kA&0x02)){
    int mr,mi,kp,km;
    double gyr,gyi,dgyra,dgyia,dgyrt,dgyit,dgyrat,dgyiat;
    double gyr1,gyi1,dgyra1,dgyia1,dgyrt1,dgyit1,dgyrat1,dgyiat1;

    for(m=1,mr=neqU,mi=mr+ESMp; m < ESMp1; m++,mr++,mi++){
      for(iB=0; iB < nMSS; iB++){ 
	aB	=MSS[iB].a;
	ESSetSplA(aB);
	ii	=aB/ESsa[1];
	i	=ii+1;
	splRA(&dgY,NULL,ESdgY,ESdgY2a);
	dgY	*=aB;
	splRA(&dF0,&d2F0,ESaF,ESaF2a);

	k	=M0Mm*ii+ES2Mp1*m+ESMp;
	lyr	=gper+k;
	lyi	=gpei+k;
	ldyr	=dgper+k;
	ldyi	=dgpei+k;

	t	=MSS[iB].gt;
	gyr	=0.;
	gyi	=0.;
	dgyra	=0.;
	dgyia	=0.;
	dgyrt	=0.;
	dgyit	=0.;
	dgyrat	=0.;
	dgyiat	=0.;
	gyr1	=0.;
	gyi1	=0.;
	dgyra1	=0.;
	dgyia1	=0.;
	dgyrt1	=0.;
	dgyit1	=0.;
	dgyrat1	=0.;
	dgyiat1	=0.;
	for(k=1; k < ESMp1; k++){
	  cs	=cos(k*t);
	  sn	=sin(k*t);
	  gyr	+=(lyr[k]+lyr[-k])*cs+(lyi[-k]-lyi[k])*sn;
	  gyi	+=(lyi[k]+lyi[-k])*cs+(lyr[k]-lyr[-k])*sn;
	  dgyra	+=(ldyr[k]+ldyr[-k])*cs+(ldyi[-k]-ldyi[k])*sn;
	  dgyia	+=(ldyi[k]+ldyi[-k])*cs+(ldyr[k]-ldyr[-k])*sn;

	  dgyrt	+=k*((lyi[-k]-lyi[k])*cs-(lyr[k]+lyr[-k])*sn);
	  dgyit	+=k*((lyr[k]-lyr[-k])*cs-(lyi[k]+lyi[-k])*sn);
	  dgyrat+=k*((ldyi[-k]-ldyi[k])*cs-(ldyr[k]+ldyr[-k])*sn);
	  dgyiat+=k*((ldyr[k]-ldyr[-k])*cs-(ldyi[k]+ldyi[-k])*sn);

	  kp	=M0Mm+k;
	  km	=M0Mm-k;
	  gyr1	+=(lyr[kp]+lyr[km])*cs+(lyi[km]-lyi[kp])*sn;
	  gyi1	+=(lyi[kp]+lyi[km])*cs+(lyr[kp]-lyr[km])*sn;
	  dgyra1+=(ldyr[kp]+ldyr[km])*cs+(ldyi[km]-ldyi[kp])*sn;
	  dgyia1+=(ldyi[kp]+ldyi[km])*cs+(ldyr[kp]-ldyr[km])*sn;
	  dgyrt1+=k*((lyi[km]-lyi[kp])*cs-(lyr[kp]+lyr[km])*sn);
	  dgyit1+=k*((lyr[kp]-lyr[km])*cs-(lyi[kp]+lyi[km])*sn);
	  dgyrat1+=k*((ldyi[km]-ldyi[kp])*cs-(ldyr[kp]+ldyr[km])*sn);
	  dgyiat1+=k*((ldyr[kp]-ldyr[km])*cs-(ldyi[kp]+ldyi[km])*sn);
	}
	h	=ESsa[i]-ESsa[ii];
	t	=(aB-ESsa[ii])/h;
	X	=1.-t;
	ds	=h*t*X;
	cs	=(3.-2.*X)*X*X;
	sn	=(3.-2.*t)*t*t;
	s	=1./MSS[iB].r;
	Bf	=dF0*s;
	d2F0	-=dF0*MSS[iB].ra*s;

	gy	=cs*gyr+sn*gyr1+ds*(X*dgyra-t*dgyra1);
	dgyt	=cs*dgyrt+sn*dgyrt1+ds*(X*dgyrat-t*dgyrat1);
	dgya	=6.*t*X*(gyr1-gyr)/h+X*(X-2.*t)*dgyra+t*(t-2.*X)*dgyra1;

	dBf	=-(d2F0-dF0*MSS[iB].ra*s)*s*gy/dgY;
	s	/=MSS[iB].D;

	dBr	=(dgya*MSS[iB].rq-dgyt*MSS[iB].ra)*s;
	dBz	=(dgya*MSS[iB].zq-dgyt*MSS[iB].za)*s;
	Br	=dgY*MSS[iB].rq*s;
	Bz	=dgY*MSS[iB].zq*s;
	dF1	=MSS[iB].tr*Br+MSS[iB].tz*Bz+MSS[iB].tf*Bf;
	d2F1	=MSS[iB].tr*dBr+MSS[iB].tz*dBz+MSS[iB].tf*dBf;
	U[iB][mr]	=(Bf*dBf+Br*dBr+Bz*dBz-dF1*d2F1)/E0[iB];

	gy	=cs*gyi+sn*gyi1+ds*(X*dgyia-t*dgyia1);
	dgyt	=cs*dgyit+sn*dgyit1+ds*(X*dgyiat-t*dgyiat1);
	dgya	=6.*t*X*(gyi1-gyi)/h+X*(X-2.*t)*dgyia+t*(t-2.*X)*dgyia1;

	s	=1./MSS[iB].r;
	dBf	=-(d2F0-dF0*MSS[iB].ra*s)*s*gy/dgY;
	s	/=MSS[iB].D;
	dBr	=(dgya*MSS[iB].rq-dgyt*MSS[iB].ra)*s;
	dBz	=(dgya*MSS[iB].zq-dgyt*MSS[iB].za)*s;
	Br	=dgY*MSS[iB].rq*s;
	Bz	=dgY*MSS[iB].zq*s;
	dF1	=MSS[iB].tr*Br+MSS[iB].tz*Bz+MSS[iB].tf*Bf;
	d2F1	=MSS[iB].tr*dBr+MSS[iB].tz*dBz+MSS[iB].tf*dBf;
	U[iB][mi]=(Bf*dBf+Br*dBr+Bz*dBz-dF1*d2F1)/E0[iB];
      }
    }
  }
  return(0);
}

int SignalMseLP(double **U,double *U0,double *E0,int kA,double *err)
{
  int i,iB,k,m,ii,Mm;
  double R0,rR0,aD;
  double h2sh,h12p2sh;
  double s,ds;
  double erA,erR;

  double t,gy0,gy1,dgy0,dgy1,h,dgY,d2gY,cs,sn;
  double X,gy0t,gy1t,dgy0t,dgy1t,aB;
  double gy,dgya,dgyt;
  double T[ESNa1],dT[ESNa1],F,dF0,dF1,d2F0,d2F1;
  double Br,dBr,Bz,dBz,Bf,dBf;

  double *y,*y2,*lyr,*lyi,*ldyr,*ldyi;

  R0	=ESaR0[0];
  rR0	=1./R0;

  h2sh	=cr2*ESsa[1];
  h12p2sh=cr12*ESpa[1];
  
  erA	=err[1]*cgp/180.;
  for(iB=0; iB < nMSE; iB++){ 
    aB	=MSE[iB].a;
    ESSetSplA(aB);
    splRA(&dgY,NULL,ESdgY,ESdgY2a);
    dgY	*=aB;

    splRA(&dF0,&d2F0,ESaF,ESaF2a);
    s	=1./MSE[iB].r;
    Bf	=dF0*s;
    s	/=MSE[iB].D;
    Bz	=dgY*MSE[iB].zq*s;
    BzBt[iB]	=Bz/Bf;
    U0[iB]	=Bz/Bf;

    E0[iB]	=U0[iB]*err[0]+erA;
    E0[iB]	=U0[iB]*MSE[iB].errR+MSE[iB].errA*cgp/180.;
  }

  Mm	=ES2Mp1*neqU;
  for(m=0; m < neqU; m++){
    if(m < neqUJ){
      Point2BasicFunctions(&y,&y2,m);
      splA1a(y,dT,y2);
      s	=R0;
    }
    else{
      Point2BasicFunctions(&y,&y2,m-neqUJ);
      splA1a(y,dT,y2);
      s	=-R0;
    }
    for(i=0; i < ESNa1; i++){
      T[i]	=y[i]*s;
      dT[i]	*=s;
    }

    for(iB=0; iB < nMSE; iB++){ 
      aB	=MSE[iB].a;
      ESSetSplA(aB);
      ii=aB/ESsa[1];
      i	=ii+1;
      splRA(&dF0,&d2F0,y,y2);
      s	=m < neqUJ ? R0 : -R0;
      dF0	*=s;
      d2F0	*=s;
      splRA(&dgY,&d2gY,ESdgY,ESdgY2a);
      d2F0	=d2gY*dF0+dgY*d2F0;
      d2F1	=dgY*dF0;
      dF1	=aB*d2F1;
      d2F1	+=aB*d2F0;

      dF0	=dF1;
      d2F0	=d2F1;
      F		=0.;
      if(i < ESNa1){
	d2F1	=ESdgY[i]*T[i];
	dF1	=ESsa[i]*d2F1;
	d2F1	+=ESsa[i]*(ESdgY1a[i]*T[i]+ESdgY[i]*dT[i]);
	ds	=ESsa[i]-aB;
	F		=ds*(cr2*(dF0+dF1)+cr12*ds*(d2F0-d2F1));
	for(i++; i < ESNa1; i++){
	  dF0	=dF1;
	  d2F0	=d2F1;
	  d2F1	=ESdgY[i]*T[i];
	  dF1	=ESsa[i]*d2F1;
	  d2F1	+=ESsa[i]*(ESdgY1a[i]*T[i]+ESdgY[i]*dT[i]);
	  F	+=h2sh*(dF0+dF1)+h12p2sh*(d2F0-d2F1);
	}
      }

      k		=Mm*ii+ES2Mp1*m+ESMp;
      lyr	=gperU+k;
      lyi	=gpeiU+k;
      ldyr	=dgperU+k;
      ldyi	=dgpeiU+k;

      t	=MSE[iB].gt;
      i	=ii+1;
      gy0	=lyr[0];
      dgy0	=ldyr[0];
      gy1	=lyr[Mm];
      dgy1	=ldyr[Mm];
      gy0t	=0.;
      gy1t	=0.;
      dgy0t	=0.;
      dgy1t	=0.;

      lyr++;
      lyi++;
      ldyr++;
      ldyi++;
      for(k=1; k < ESMp1; k++){
	cs	=cos(k*t);
	sn	=sin(k*t);
	gy0	+=2.*(*lyr*cs-*lyi*sn);
	dgy0	+=2.*(*ldyr*cs-*ldyi*sn);
	gy0t	-=2.*k*(*lyr*sn+*lyi*cs);
	dgy0t	-=2.*k*(*ldyr*sn+*ldyi*cs);
	gy1	+=2.*(lyr[Mm]*cs-lyi[Mm]*sn);
	dgy1	+=2.*(ldyr[Mm]*cs-ldyi[Mm]*sn);
	gy1t	-=2.*k*(lyr[Mm]*sn+lyi[Mm]*cs);
	dgy1t	-=2.*k*(ldyr[Mm]*sn+ldyi[Mm]*cs);
	lyr++;
	lyi++;
	ldyr++;
	ldyi++;
      }
      if(i < ESNa1){
	h	=ESsa[i]-ESsa[ii];
	t	=(aB-ESsa[ii])/h;
	X	=1.-t;
	ds	=h*t*X;
	cs	=(3.-2.*X)*X*X;
	sn	=(3.-2.*t)*t*t;
	gy	=cs*gy0+sn*gy1+ds*(X*dgy0-t*dgy1);
	dgyt	=cs*gy0t+sn*gy1t+ds*(X*dgy0t-t*dgy1t);
	dgya	=6.*t*X*(gy1-gy0)/h+X*(X-2.*t)*dgy0+t*(t-2.*X)*dgy1;
      }else{
	gy	=gy0;
	dgyt	=gy0t;
	dgya	=dgy0;
      }
      dgY	*=aB;
      splRA(&dF0,&d2F0,ESaF,ESaF2a);
      s	=1./MSE[iB].r;
      dBf	=-(F/dF0+d2F0*gy/dgY)*s;
      Bf	=dF0*s;
      s		/=MSE[iB].D;

      dBr	=(dgya*MSE[iB].rq-dgyt*MSE[iB].ra)*s;
      dBz	=(dgya*MSE[iB].zq-dgyt*MSE[iB].za)*s;
      s		=U0[iB];
      U[iB][m]	=(dBz-s*dBf)/(Bf*E0[iB]);
    }
  }

  if((kA&0x02)){
    int mr,mi,kp,km;
    double gyr,gyi,dgyra,dgyia,dgyrt,dgyit,dgyrat,dgyiat;
    double gyr1,gyi1,dgyra1,dgyia1,dgyrt1,dgyit1,dgyrat1,dgyiat1;

    for(m=1,mr=neqU,mi=mr+ESMp; m < ESMp1; m++,mr++,mi++){
      for(iB=0; iB < nMSE; iB++){ 
	aB	=MSE[iB].a;
	ESSetSplA(aB);
	ii	=aB/ESsa[1];
	i	=ii+1;
	splRA(&dgY,NULL,ESdgY,ESdgY2a);
	dgY	*=aB;
	splRA(&dF0,&d2F0,ESaF,ESaF2a);

	k	=M0Mm*ii+ES2Mp1*m+ESMp;
	lyr	=gper+k;
	lyi	=gpei+k;
	ldyr	=dgper+k;
	ldyi	=dgpei+k;

	t	=MSE[iB].gt;
	gyr	=0.;
	gyi	=0.;
	dgyra	=0.;
	dgyia	=0.;
	dgyrt	=0.;
	dgyit	=0.;
	dgyrat	=0.;
	dgyiat	=0.;
	gyr1	=0.;
	gyi1	=0.;
	dgyra1	=0.;
	dgyia1	=0.;
	dgyrt1	=0.;
	dgyit1	=0.;
	dgyrat1	=0.;
	dgyiat1	=0.;
	for(k=1; k < ESMp1; k++){
	  cs	=cos(k*t);
	  sn	=sin(k*t);
	  gyr	+=(lyr[k]+lyr[-k])*cs+(lyi[-k]-lyi[k])*sn;
	  gyi	+=(lyi[k]+lyi[-k])*cs+(lyr[k]-lyr[-k])*sn;
	  dgyra	+=(ldyr[k]+ldyr[-k])*cs+(ldyi[-k]-ldyi[k])*sn;
	  dgyia	+=(ldyi[k]+ldyi[-k])*cs+(ldyr[k]-ldyr[-k])*sn;

	  dgyrt	+=k*((lyi[-k]-lyi[k])*cs-(lyr[k]+lyr[-k])*sn);
	  dgyit	+=k*((lyr[k]-lyr[-k])*cs-(lyi[k]+lyi[-k])*sn);
	  dgyrat+=k*((ldyi[-k]-ldyi[k])*cs-(ldyr[k]+ldyr[-k])*sn);
	  dgyiat+=k*((ldyr[k]-ldyr[-k])*cs-(ldyi[k]+ldyi[-k])*sn);

	  kp	=M0Mm+k;
	  km	=M0Mm-k;
	  gyr1	+=(lyr[kp]+lyr[km])*cs+(lyi[km]-lyi[kp])*sn;
	  gyi1	+=(lyi[kp]+lyi[km])*cs+(lyr[kp]-lyr[km])*sn;
	  dgyra1+=(ldyr[kp]+ldyr[km])*cs+(ldyi[km]-ldyi[kp])*sn;
	  dgyia1+=(ldyi[kp]+ldyi[km])*cs+(ldyr[kp]-ldyr[km])*sn;
	  dgyrt1+=k*((lyi[km]-lyi[kp])*cs-(lyr[kp]+lyr[km])*sn);
	  dgyit1+=k*((lyr[kp]-lyr[km])*cs-(lyi[kp]+lyi[km])*sn);
	  dgyrat1+=k*((ldyi[km]-ldyi[kp])*cs-(ldyr[kp]+ldyr[km])*sn);
	  dgyiat1+=k*((ldyr[kp]-ldyr[km])*cs-(ldyi[kp]+ldyi[km])*sn);
	}
	h	=ESsa[i]-ESsa[ii];
	t	=(aB-ESsa[ii])/h;
	X	=1.-t;
	ds	=h*t*X;
	cs	=(3.-2.*X)*X*X;
	sn	=(3.-2.*t)*t*t;
	s	=1./MSE[iB].r;
	Bf	=dF0*s;
	d2F0	-=dF0*MSE[iB].ra*s;

	gy	=cs*gyr+sn*gyr1+ds*(X*dgyra-t*dgyra1);
	dgyt	=cs*dgyrt+sn*dgyrt1+ds*(X*dgyrat-t*dgyrat1);
	dgya	=6.*t*X*(gyr1-gyr)/h+X*(X-2.*t)*dgyra+t*(t-2.*X)*dgyra1;
	dBf	=-(d2F0-dF0*MSE[iB].ra*s)*s*gy/dgY;
	s	/=MSE[iB].D;
	dBr	=(dgya*MSE[iB].rq-dgyt*MSE[iB].ra)*s;
	dBz	=(dgya*MSE[iB].zq-dgyt*MSE[iB].ra)*s;
	s	=U0[iB];
	U[iB][mr]=(dBz-s*dBf)/(Bf*E0[iB]);

	gy	=cs*gyi+sn*gyi1+ds*(X*dgyia-t*dgyia1);
	dgyt	=cs*dgyit+sn*dgyit1+ds*(X*dgyiat-t*dgyiat1);
	dgya	=6.*t*X*(gyi1-gyi)/h+X*(X-2.*t)*dgyia+t*(t-2.*X)*dgyia1;
	s	=1./MSE[iB].r;
	dBf	=-(d2F0-dF0*MSE[iB].ra*s)*s*gy/dgY;
	s	/=MSE[iB].D;
	dBr	=(dgya*MSE[iB].rq-dgyt*MSE[iB].ra)*s;
	dBz	=(dgya*MSE[iB].zq-dgyt*MSE[iB].ra)*s;

	s	=U0[iB];
	U[iB][mi]=(dBz-s*dBf)/(Bf*E0[iB]);
      }
    }
  }
  return(0);
}

int SignalFaradayRot(double **U,double *U0,double *E0,int kA)
{
  int iS,i,j,n,n1,k,m,ii,Mm;
  double R0,rR0,aD;
  double h2sh,h12p2sh;
  double s,ds;
  SIGHTLINE *lS;

  double t,gy0,gy1,dgy0,dgy1,h,dgY,d2gY,ne,dne,cs,sn;
  double X,gy0t,gy1t,dgy0t,dgy1t,aB;
  double gy,dgya,dgyt;

  extern double ESBt;

  extern double *ESaJ,*ESaJ1a,*ESaJ2a
    ,*ESaT,*ESaT1a,*ESaT2a
    ,*ESgY,*ESgY1a,*ESgY2a
    ,*ESgF,*ESgF1a,*ESgF2a
    ,*ESaF,*ESaF1a,*ESaF2a
    ,*ESFF,*ESFF1a,*ESFF2a
    ,*ESdgY,*ESdgY1a,*ESdgY2a
    ;
  double T[ESNa1],dT[ESNa1],rF[ESNa1],F,dF0,dF1,d2F0,d2F1;
  double Br,dBr,Bz,dBz,Bf,dBf;

  double *y,*y2,*lyr,*lyi,*ldyr,*ldyi;
  double tx,ty,tz,tr,tf,S,C;
  double *lr,*ra,*rt,*za,*zt,*lD;

  C	=2.*cFaraday*glFaraday*glFaraday;
  R0	=ESaR0[0];
  rR0	=1./R0;

  h2sh	=cr2*ESsa[1];
  h12p2sh=cr12*ESpa[1];
  for(i=0; i < ESNa1; i++) rF[i]=1./ESaF[i];
  
#ifdef H
  printf("    [ #] %10s %10s %10s  %10s %10s  %10s %10s\n","Br","Bgf","Bz"
	 ,"|B|","v.B","vr","vgf");
#endif

  Mm	=ES2Mp1*neqU;
  for(iS=0,lS=SightP; iS < nSightP; iS++,lS++){ 
    U0[iS]	=lS->S;
    E0[iS]	=lS->dS;
  }
  for(m=0; m < neqU; m++){
    if(m < neqUJ){
      Point2BasicFunctions(&y,&y2,m);
      splA1a(y,dT,y2);
      for(i=0; i < ESNa1; i++){
	T[i]	=y[i]*R0;
	dT[i]	*=R0;
      }
    }
    else{
      Point2BasicFunctions(&y,&y2,m-neqUJ);
      splA1a(y,dT,y2);
      for(i=0; i < ESNa1; i++){
	T[i]	=-y[i]*R0;
	dT[i]	*=-R0;
      }
    }
    for(iS=0,lS=SightP; iS < nSightP; iS++,lS++){ 
      lr	=lS->r;
      lD	=lS->D;
      ra	=lS->ra;
      rt	=lS->rq;
      za	=lS->za;
      zt	=lS->zq;
      tx	=lS->tx;
      ty	=lS->ty;
      tz	=lS->tz;
      s	=1./sqrt(tx*tx+ty*ty+tz*tz);
      tx	*=s;
      ty	*=s;
      tz	*=s;

      n1	=lS->n1;
      n		=n1-1;
      S		=0.;
      for(j=0; j < n1; j++){ 
	sn=lS->f[j];
	cs=cos(sn);
	sn=sin(sn);
	tr= tx*cs+ty*sn;
	tf=-tx*sn+ty*cs;

	aB	=lS->a[j];
	ESSetSplA(aB);
	ii=aB/ESsa[1];
	i	=ii+1;
	splRA(&dF0,&d2F0,y,y2);
	if(m < neqUJ){
	  dF0	*=R0;
	  d2F0	*=R0;
	}
	else{
	  dF0	*=-R0;
	  d2F0	*=-R0;
	}
	splRA(&dgY,&d2gY,ESdgY,ESdgY2a);
	splRA(&ne,&dne,ESne,ESne2a);

	d2F0	=dF0*d2gY+d2F0*dgY;
	d2F1	=dF0*dgY;
	dF1	=aB*d2F1;
	d2F1	+=aB*d2F0;

	dF0	=dF1;
	d2F0	=d2F1;

	F	=0.;
	if(i < ESNa1){
	  d2F1	=ESdgY[i]*T[i];
	  dF1	=ESsa[i]*d2F1;
	  d2F1	+=ESsa[i]*(ESdgY1a[i]*T[i]+ESdgY[i]*dT[i]);
	  ds	=ESsa[i]-aB;
	  F	+=ds*(cr2*(dF0+dF1)+cr12*ds*(d2F0-d2F1));
	  for(i++; i < ESNa1; i++){
	    dF0	=dF1;
	    d2F0=d2F1;
	    d2F1=ESdgY[i]*T[i];
	    dF1	=ESsa[i]*d2F1;
	    d2F1+=ESsa[i]*(ESdgY1a[i]*T[i]+ESdgY[i]*dT[i]);
	    F	+=h2sh*(dF0+dF1)+h12p2sh*(d2F0-d2F1);
	  }
	}

	i	=ii+1;
	k	=Mm*ii+ES2Mp1*m+ESMp;
	lyr	=gperU+k;
	lyi	=gpeiU+k;
	ldyr	=dgperU+k;
	ldyi	=dgpeiU+k;

	t	=lS->q[j];
	gy0	=lyr[0];
	dgy0	=ldyr[0];
	gy1	=lyr[Mm];
	dgy1	=ldyr[Mm];

	gy0t	=0.;
	gy1t	=0.;
	dgy0t	=0.;
	dgy1t	=0.;

	lyr++;
	lyi++;
	ldyr++;
	ldyi++;
	for(k=1; k < ESMp1; k++){
	  cs	=cos(k*t);
	  sn	=sin(k*t);
	  gy0	+=2.*(*lyr*cs-*lyi*sn);
	  dgy0	+=2.*(*ldyr*cs-*ldyi*sn);
	  gy0t	-=2.*k*(*lyr*sn+*lyi*cs);
	  dgy0t	-=2.*k*(*ldyr*sn+*ldyi*cs);
	  gy1	+=2.*(lyr[Mm]*cs-lyi[Mm]*sn);
	  dgy1	+=2.*(ldyr[Mm]*cs-ldyi[Mm]*sn);
	  gy1t	-=2.*k*(lyr[Mm]*sn+lyi[Mm]*cs);
	  dgy1t	-=2.*k*(ldyr[Mm]*sn+ldyi[Mm]*cs);
	  lyr++;
	  lyi++;
	  ldyr++;
	  ldyi++;
	}
	if(i < ESNa1){
	  h	=ESsa[i]-ESsa[ii];
	  t	=(aB-ESsa[ii])/h;
	  X	=1.-t;
	  ds	=h*t*X;
	  cs	=(3.-2.*X)*X*X;
	  sn	=(3.-2.*t)*t*t;
	  gy	=cs*gy0+sn*gy1+ds*(X*dgy0-t*dgy1);
	  dgyt	=cs*gy0t+sn*gy1t+ds*(X*dgy0t-t*dgy1t);
	  dgya	=6.*t*X*(gy1-gy0)/h+X*(X-2.*t)*dgy0+t*(t-2.*X)*dgy1;
	}else{
	  gy	=gy0;
	  dgyt	=gy0t;
	  dgya	=dgy0;
	}

	dgY	*=aB;
	splRA(&dF0,&d2F0,ESaF,ESaF2a);

	s	=1./lr[j];

	d2F0	-=dF0*ra[j]*s;
	dBf	=-(F/dF0+d2F0*gy/dgY)*s;
	Bf	=dF0*s;
	dne	*=-gy/dgY;

	s	/=lD[j];
	dBr	=(dgya*rt[j]-dgyt*ra[j])*s;
	dBz	=(dgya*zt[j]-dgyt*za[j])*s;
	Br	=dgY*rt[j]*s;
	Bz	=dgY*zt[j]*s;

	dF1	=tr*Br+tz*Bz+tf*Bf;
	d2F1	=tr*dBr+tz*dBz+tf*dBf;
	S	+=ne*d2F1+dne*dF1;
      }
      U[iS][m]	=C*S*lS->V[0]/E0[iS];
    }
  }

#ifdef H
  if((kA&0x02)){
    int mr,mi,kp,km;
    double gyr,gyi,dgyra,dgyia,dgyrt,dgyit,dgyrat,dgyiat;
    double gyr1,gyi1,dgyra1,dgyia1,dgyrt1,dgyit1,dgyrat1,dgyiat1;

    for(m=1,mr=neqU,mi=mr+ESMp; m < ESMp1; m++,mr++,mi++){
      for(iB=0; iB < nMSS; iB++){ 
	aB	=MSS[iB].a;
	ESSetSplA(aB);
	ii	=aB/ESsa[1];
	i	=ii+1;
	splRA(&dgY,NULL,ESdgY,ESdgY2a);
	dgY	*=aB;
	splRA(&dF0,&d2F0,ESaF,ESaF2a);

	k	=M0Mm*ii+ES2Mp1*m+ESMp;
	lyr	=gper+k;
	lyi	=gpei+k;
	ldyr	=dgper+k;
	ldyi	=dgpei+k;

	t	=MSS[iB].gt;
	gyr	=0.;
	gyi	=0.;
	dgyra	=0.;
	dgyia	=0.;
	dgyrt	=0.;
	dgyit	=0.;
	dgyrat	=0.;
	dgyiat	=0.;
	gyr1	=0.;
	gyi1	=0.;
	dgyra1	=0.;
	dgyia1	=0.;
	dgyrt1	=0.;
	dgyit1	=0.;
	dgyrat1	=0.;
	dgyiat1	=0.;
	for(k=1; k < ESMp1; k++){
	  cs	=cos(k*t);
	  sn	=sin(k*t);
	  gyr	+=(lyr[k]+lyr[-k])*cs+(lyi[-k]-lyi[k])*sn;
	  gyi	+=(lyi[k]+lyi[-k])*cs+(lyr[k]-lyr[-k])*sn;
	  dgyra	+=(ldyr[k]+ldyr[-k])*cs+(ldyi[-k]-ldyi[k])*sn;
	  dgyia	+=(ldyi[k]+ldyi[-k])*cs+(ldyr[k]-ldyr[-k])*sn;

	  dgyrt	+=k*((lyi[-k]-lyi[k])*cs-(lyr[k]+lyr[-k])*sn);
	  dgyit	+=k*((lyr[k]-lyr[-k])*cs-(lyi[k]+lyi[-k])*sn);
	  dgyrat+=k*((ldyi[-k]-ldyi[k])*cs-(ldyr[k]+ldyr[-k])*sn);
	  dgyiat+=k*((ldyr[k]-ldyr[-k])*cs-(ldyi[k]+ldyi[-k])*sn);

	  kp	=M0Mm+k;
	  km	=M0Mm-k;
	  gyr1	+=(lyr[kp]+lyr[km])*cs+(lyi[km]-lyi[kp])*sn;
	  gyi1	+=(lyi[kp]+lyi[km])*cs+(lyr[kp]-lyr[km])*sn;
	  dgyra1+=(ldyr[kp]+ldyr[km])*cs+(ldyi[km]-ldyi[kp])*sn;
	  dgyia1+=(ldyi[kp]+ldyi[km])*cs+(ldyr[kp]-ldyr[km])*sn;
	  dgyrt1+=k*((lyi[km]-lyi[kp])*cs-(lyr[kp]+lyr[km])*sn);
	  dgyit1+=k*((lyr[kp]-lyr[km])*cs-(lyi[kp]+lyi[km])*sn);
	  dgyrat1+=k*((ldyi[km]-ldyi[kp])*cs-(ldyr[kp]+ldyr[km])*sn);
	  dgyiat1+=k*((ldyr[kp]-ldyr[km])*cs-(ldyi[kp]+ldyi[km])*sn);
	}
	h	=ESsa[i]-ESsa[ii];
	t	=(aB-ESsa[ii])/h;
	X	=1.-t;
	ds	=h*t*X;
	cs	=(3.-2.*X)*X*X;
	sn	=(3.-2.*t)*t*t;
	s	=1./MSS[iB].r;
	Bf	=dF0*s;
	d2F0	-=dF0*MSS[iB].ra*s;

	gy	=cs*gyr+sn*gyr1+ds*(X*dgyra-t*dgyra1);
	dgyt	=cs*dgyrt+sn*dgyrt1+ds*(X*dgyrat-t*dgyrat1);
	dgya	=6.*t*X*(gyr1-gyr)/h+X*(X-2.*t)*dgyra+t*(t-2.*X)*dgyra1;

	dBf	=-(d2F0-dF0*MSS[iB].ra*s)*s*gy/dgY;
	s	/=MSS[iB].D;

	dBr	=(dgya*MSS[iB].rq-dgyt*MSS[iB].ra)*s;
	dBz	=(dgya*MSS[iB].zq-dgyt*MSS[iB].za)*s;
	Br	=dgY*MSS[iB].rq*s;
	Bz	=dgY*MSS[iB].zq*s;
	dF1	=MSS[iB].tr*Br+MSS[iB].tz*Bz+MSS[iB].tf*Bf;
	d2F1	=MSS[iB].tr*dBr+MSS[iB].tz*dBz+MSS[iB].tf*dBf;
	U[iB][mr]	=(Bf*dBf+Br*dBr+Bz*dBz-dF1*d2F1)/E0[iB];

	gy	=cs*gyi+sn*gyi1+ds*(X*dgyia-t*dgyia1);
	dgyt	=cs*dgyit+sn*dgyit1+ds*(X*dgyiat-t*dgyiat1);
	dgya	=6.*t*X*(gyi1-gyi)/h+X*(X-2.*t)*dgyia+t*(t-2.*X)*dgyia1;

	s	=1./MSS[iB].r;
	dBf	=-(d2F0-dF0*MSS[iB].ra*s)*s*gy/dgY;
	s	/=MSS[iB].D;
	dBr	=(dgya*MSS[iB].rq-dgyt*MSS[iB].ra)*s;
	dBz	=(dgya*MSS[iB].zq-dgyt*MSS[iB].za)*s;
	Br	=dgY*MSS[iB].rq*s;
	Bz	=dgY*MSS[iB].zq*s;
	dF1	=MSS[iB].tr*Br+MSS[iB].tz*Bz+MSS[iB].tf*Bf;
	d2F1	=MSS[iB].tr*dBr+MSS[iB].tz*dBz+MSS[iB].tf*dBf;
	U[iB][mi]=(Bf*dBf+Br*dBr+Bz*dBz-dF1*d2F1)/E0[iB];
      }
    }
  }
#endif
  return(0);
}

int EqOutUAO(int m0,int m1,int kA,double *T,double err[][2])
{
  extern int nBeam;
  extern double Err4Beam[][4];
  static int ic=0;
  int i,m,k;
  FILE *lF;
  static char FNm[0x80];
  char SNm[6][2][8]={
    "Bp","[T]",
    "gY","[Vsec]",
    "gF","[Vsec]",
    "MSE","[^o]",
    "Bm","[T]",
    "",""
  };

  if(ic == 0){
    sprintf(FNm,"%s.psd",ShotNm);
    lF	=fopen(FNm,"w");
  }
  else{
    lF	=fopen(FNm,"a");
  }
  ic++;
  fprintf(lF,"Generated by Cb%s, %s\n",CbGetCodeNm(),TimeString());
  fprintf(lF,"%3d Page in %s.ps, Case #%d -----------------------\n"
	  ,PSnPg,ShotNm,ic);
  fprintf(lF,"Ipl=%6.3f [MA] Bt=%6.4f [T]\n",ESIpl,ESBt);
  i	=0;
  fprintf(lF,"!%3s %6s %8s %6s\n","Err","Rel","Abs","Units");
  fprintf(lF,"%4s=%6.4f %8.2e %6s\n",SNm[i][0],err[i][0],err[i][1],SNm[i][1]);
  k	=1;
  for(i=1; i < 5; i++){
    k	<<=1;
    if((kA&k)){
      if(i == 3){
	for(m=0; m < nBeam; m++){
	  fprintf(lF,"%4s=%6.4f %8.2e %6s\n",SNm[i][0],Err4Beam[m][0]
		  ,Err4Beam[m][1],SNm[i][1]);
	}
      }else if(i == 4){
	for(m=0; m < nBeam; m++){
	  fprintf(lF,"%4s=%6.4f %8.2e %6s\n",SNm[i][0],Err4Beam[m][2]
		  ,Err4Beam[m][3],SNm[i][1]);
	}
      }else{
	fprintf(lF,"%4s=%6.4f %8.2e %6s\n",SNm[i][0],err[i][0]
		,err[i][1],SNm[i][1]);
      }
    }
  }
  fprintf(lF,"<log10 of Eigenvalues>[%d]%s\n",neqUR,"(%d %e %e)");
  fprintf(lF,"!%s %4s %10s nJ=%2d nP=%2d nY=%2d\n"
	  ,"#","log10","EigenV",neqUJ,neqUP,(kA&0x02) ? ES2Mp:0);
  for(i=0; i < neqUR; i++){
    fprintf(lF,"%2d %6.2f %10.3e\n",i+1,T[i] > 1e-10 ? log10(T[i]):-10.,T[i]);
  }

  fprintf(lF,"\n<log10 of Error in q>[%d]%s\n",neqUR,"(%d %e %e)");
  fprintf(lF,"!%s %4s %10s nJ=%2d nP=%2d nY=%2d\n"
	  ,"#","log10","gd q",neqUJ,neqUP,(kA&0x02) ? ES2Mp:0);
  for(i=0; i < neqUR; i++){
    fprintf(lF,"%2d %6.2f %10.3e\n",i+1,gdq[i] < 1e10 ? log10(gdq[i]):10.
	    ,gdq[i]); 
  }

  fprintf(lF,"\n<log10 of Error in p>[%d]%s\n",neqUR,"(%d %e %e)");
  fprintf(lF,"!%s %4s %10s nJ=%2d nP=%2d nY=%2d\n"
	  ,"#","log10","gd p [MPa]",neqUJ,neqUP,(kA&0x02) ? ES2Mp:0);
  for(i=0; i < neqUR; i++){
    fprintf(lF,"%2d %6.2f %10.3e\n",i+1,gdp[i] < 1e10 ? log10(gdp[i]):10.
	    ,gdp[i]); 
  }

  fclose(lF);
  return(0);
}

int AllVariances(int i0,int i1,int m0,int m1,int kA,double err[][2],int FlP)
{
  int i,j,k,m,mm,ki,kj,iK,Mm,MmJ;
  int M=ESNp1+neqUY*((kA&0x02)>>1)+nMSE*((kA&0x08)>>3)
	    +nMSS*((kA&0x10)>>4)+nSightP*((kA&0x20)>>5)+2*ESNa1*((kA&0x40)>>6);
  int mr,mi,kp,km;
  int mMse;
  double r,ra,rt;
  double z,za,zt;
  double aK[ESNp1];
  double rc[ESFp1],rs[ESFp1];
  double rca[ESFp1],rsa[ESFp1],rct[ESFp1],rst[ESFp1];
  double *gyca,*gysa;
  double *lr,*li;
  double b,ba,dgY,ga;
  double cs,sn;
  double UU[M*0x40];
  double *U[M];
  double U0[M];
  double E0[M];

  double VV[0x1000];
  double *V[0x40];
  double W[0x40],T[0x40],S[0x40],F[0x40],C[0x40],gg[0x40];
  double sjmx;
  int ind[0x40];
  double *Js[0x40],*d2Js[0x40],*Jp[0x40],*d2Jp[0x40]
    ,dJs[ESNa1*0x80],dJp[ESNa1*0x80],*J[0x20],*d2J[0x20];
  double Bp;
  double erA,erR;

  /*
    kA&0x01 - $Bp$ signal;
    kA&0x02 - $\gd\gy$ signal;
    kA&0x04 - Diamagnetic signal; 
    kA&0x08 - MSE signal;
    kA&0x10 - Bmod signal;
    kA&0x10 - Faraday Rotation;
    Absolute erroors:
    err[0][2]  - error in Bp signal [T];
    err[1][2]  - error in $\bgY$ signal [Vsec];
    err[2][2]  - error in $\gd\gF_{diamag}$ signal [Vsec];
    err[3][2]  - error in $MSE$ signal [${}^o$];
    err[4][2]  - error in $Bmod$ signal [T];
    err[5][2]  - error in polarimetry signal;
    err[6][2]  - error in $j''_s,j''_p$ signal;
   */

  if(neqU == 0) return(0);

  neqUY	=ESNp/2;

  M	=ESNp1+neqUY*((kA&0x02)>>1)+nMSE*((kA&0x08)>>3)+nMSS*((kA&0x10)>>4)
    +nSightP*((kA&0x20)>>5)+2*ESNa1*((kA&0x40)>>6);

  MmJ	=ES2Mp1*neqU;
  neqUR	=neqU;
  if((kA&0x02)) neqUR +=ES2Mp;
  Mm	=ES2Mp1*neqUR;
  memset(UU,'\0',M*0x40*sizeof(double));
  for(j=0; j < M; j++) U[j]=UU+0x40*j;
  for(m=0; m < neqUR; m++) V[m]=VV+0x40*m;

  for(m=0,k=neqUR; m < neqUR; m++,k++){
    Js[m]	=dJs+ESNa1*m;
    d2Js[m]	=dJs+ESNa1*k;
    Jp[m]	=dJp+ESNa1*m;
    d2Jp[m]	=dJp+ESNa1*k;
  }

  k	=neqUJ;
  if(k < neqUP) k	=neqUP;
  for(m=0; m < k; m++){
    Point2BasicFunctions(&lr,&li,m);
    if(m < neqUJ){
      J[m]=lr;
      d2J[m]=li;
    }
    if(m < neqUP){
      J[m+neqUJ]=lr;
      d2J[m+neqUJ]=li;
    }
  }

  i	=ESNa;
  dgY	=ESsa[i]*ESdgY[i];

  rc[0]		=ESaR0[0]+rcT[i];
  rs[0]		=ESaZ0[0]+rsT[i];
  rca[0]	=rcT1a[i];
  rsa[0]	=rsT1a[i];

  b		=ESsb[i];
  ba		=ESsb1a[i];

  ki	=i;
  iK	=1;
  for(k=1; k < ESFp1; k++){
    ki	+=ESNa1;
    rc[k]	=2.*rcT[ki];
    rct[k]	=2.*k*rsT[ki];
    rca[k]	=2.*rcT1a[ki];
    rs[k]	=2.*rsT[ki];
    rst[k]	=-2.*k*rcT[ki];
    rsa[k]	=2.*rsT1a[ki];
    if(rca[k] != 0. || rsa[k] != 0. || rc[k] != 0. || rs[k] != 0.) iK=k+1;
  }

  erR	=err[0][0];
  erA	=err[0][1];
  Bp	=0.;
  for(j=0; j < ESNp; j++){
    r	=rc[0];
    ra	=rca[0];
    rt	=0.;
    cs	=EScs1[j];
    sn	=ESsn1[j];
    za	=rsa[0]+ba*sn;
    zt	=b*cs;
    kj	=0;
    for(k=1; k < iK; k++){
      kj	+=j;
      if(kj >= ESNp) kj-=ESNp;
      cs	=EScs1[kj];
      sn	=ESsn1[kj];
      r		+=rc[k]*cs+rs[k]*sn;
      ra	+=rca[k]*cs+rsa[k]*sn;
      rt	+=rct[k]*cs+rst[k]*sn;
    }
    aK[j]	=sqrt(rt*rt+zt*zt)/(r*(ra*zt-rt*za));
    r	=aK[j]*dgY;
    Bpol[j]=-r;
    U0[j]	=Bpol[j];
    E0[j]	=erR*fabs(Bpol[j])+erA;
    Bp	+=r*r;
  }
  Bp	=sqrt(Bp/ESNp);
#ifdef H
  r	=1./Bp;
  for(j=0; j < ESNp; j++) Bpol[j]	*=r;
  erR	=err[0][0]*Bp;
#endif

  gyca	=rca;
  gysa	=rsa;

  k	=ES2Mp1*neqU*ESNa+ESMp;
  lr	=dgperU+k;
  li	=dgpeiU+k;
  for(m=0; m < neqU; m++){
    gyca[0]	=lr[0];
    gysa[0]	=0.;
    for(k=1; k < ESMp1; k++){
      gyca[k]	=lr[k]+lr[-k];
      gysa[k]	=li[-k]-li[k];
    }

    for(j=0; j < ESNp; j++){
      ra	=gyca[0];
      kj	=0;
      for(k=1; k < ESMp1; k++){
	kj	+=j;
	if(kj >= ESNp) kj-=ESNp;
	ra	+=gyca[k]*EScs1[kj]+gysa[k]*ESsn1[kj];
      }
      U[j][m]	=-aK[j]*ra/E0[j];
    }
    lr	+=ES2Mp1;
    li	+=ES2Mp1;
  } 

  M	=ESNp;
  if((kA&0x02)){
    double dgyra,dgyia;
    double *ldyr,*ldyi;

    for(m=1,mr=neqU,mi=mr+ESMp; m < ESMp1; m++,mr++,mi++){
      k	=M0Mm*ESNa+ES2Mp1*m+ESMp;
      ldyr	=dgper+k;
      ldyi	=dgpei+k;
      for(j=0; j < ESNp; j++){
	dgyra	=ldyr[0];
	dgyia	=0.;
	kj	=0;
	for(k=1; k < ESMp1; k++){
	  kj	+=j;
	  if(kj >= ESNp) kj-=ESNp;
	  cs	=EScs1[kj];
	  sn	=ESsn1[kj];
	  dgyra	+=(ldyr[k]+ldyr[-k])*cs+(ldyi[-k]-ldyi[k])*sn;
	  dgyia	+=(ldyi[k]+ldyi[-k])*cs+(ldyr[k]-ldyr[-k])*sn;
	}
	cs	=-aK[j]/E0[j];
	U[j][mr]	=cs*dgyra;
	U[j][mi]	=cs*dgyia;
      }
    }
    gxSignal(U+M,U0+M,E0+M,err[1]);
    M	+=neqUY;
  }


  if((kA&0x04)){
    gDDiaMagSignal(U[M],U0+M,E0+M,kA,err[2]);
    M++;
  }

  /* Mse perturbations */
  if((kA&0x08)){
    mMse	=M;
    SignalMseLP(U+M,U0+M,E0+M,kA,err[3]);
    M +=nMSE;
  }

  /* Bmod perturbations */
  if((kA&0x10)){
    SignalMseLS(U+M,U0+M,E0+M,kA,err[4]);
    M +=nMSS;
  }
  /* Faraday Rotation */
  if((kA&0x20) && (SignalFaradayRot(U+M,U0+M,E0+M,kA) == 0)) M +=nSightP;

  sjmx	=0.;
  for(i=0; i < ESNa1; i++){
    if(sjmx < ESjs[i])	sjmx=ESjs[i];
    if(sjmx < ESjp[i])	sjmx=ESjp[i];
  }
  if((kA&0x40)){
    ga	=err[6][0]*sjmx*ESNa1;
#ifdef H
    for(i=0; i < ESNa1; i++){
      for(m=0; m < neqUJ; m++) U[M][m]=J[m][i]/ga;
      E0[M]	=ga;
      M++;
    }
#endif
    for(i=0; i < ESNa1; i++){
      for(m=neqUJ; m < neqU; m++) U[M][m]=J[m][i]/ga;
      E0[M]	=ga;
      M++;
    }
  }

  SVDcmp(M,neqUR,U,V,W,T);
  for(i=0; i < neqUR; i++) ind[i]=i;
  HeapSortR2I(neqUR,ind,W);
  m	=neqUR-1;
  i	=0;
  while(i < m){
    j	=ind[m];
    ind[m]	=ind[i];
    ind[i]	=j;
    m--;
    i++;
  }

  ga	=0.5*sqrt((double)M);
  for(m=0; m < neqUR; m++){
    j	=ind[m];
    C[m]=W[j] != 0. ? W[j] : 1e-15;
    T[m]=C[m]/ga;
  }
  for(m=0; m < neqUR; m++){
    gg[m]	=0.;
    j	=ind[m];
    for(i=0; i < ESNa1; i++){
      r	=0.;
      z	=0.;
      for(k=0; k < neqUJ; k++){
	r+=V[k][j]*J[k][i];
	z+=V[k][j]*d2J[k][i];
      }
      Js[m][i]	=r;
      d2Js[m][i]=z;

      r	=fabs(r);
      if(gg[m] < r) gg[m]=r;

      r	=0.;
      z	=0.;
      for(; k < neqU; k++){
	r+=V[k][j]*J[k][i];
	z+=V[k][j]*d2J[k][i];
      }
      Jp[m][i]	=r;
      d2Jp[m][i]=z;
      r	=fabs(r);
      if(gg[m] < r) gg[m]=r;
    }
    r	=sjmx/gg[m];

    if((kA&0x02)){
      extern double *ESsr;
      gg[m]=0.;
      for(i=0; i < neqUY; i++){
	j	=i+ESNp;
	z	=fabs(U[j][m]/U0[j]);
	if(gg[m] < z) gg[m]=z;
      }
      k	=ESNp1*ESNa;
      z	=0.5*(ESsr[k]-ESsr[k+ESNp/2])/gg[m];
      if(r > z) r=z;
    }
    gg[m]	=r;
    C[m]	*=r;
    T[m]	*=r;
    for(i=0; i < ESNa1; i++){
      Js[m][i]	*=r;
      d2Js[m][i]*=r;
      Jp[m][i]	*=r;
      d2Jp[m][i]*=r;
    }

    /* Reordering */
    for(i=0; i < m; i++){
      if(T[i] < T[m]){
	k	=ind[i];
	ind[i]	=ind[m];
	r	=gg[i];
	gg[i]	=gg[m];
	ra	=T[i];
	T[i]	=T[m];
	rt	=C[i];
	C[i]	=C[m];
	while(i < m){
	  i++;
	  j	=ind[i];
	  ind[i]=k;
	  k	=j;
	  z	=gg[i];
	  gg[i]	=r;
	  r	=z;
	  z	=T[i];
	  T[i]	=ra;
	  ra	=z;
	  z	=C[i];
	  C[i]	=rt;
	  rt	=z;
	}
      }
    }
  }

  i	=Mm*ESNa1*sizeof(double);
  memset(gyEr,'\0',i);
  memset(gyEi,'\0',i);
  memset(dgyEr,'\0',i);
  memset(dgyEi,'\0',i);

  memset(aYEr,'\0',i);
  memset(aYEi,'\0',i);
  memset(daYEr,'\0',i);
  memset(daYEi,'\0',i);

  for(m=0; m < neqUR; m++){
    j	=ind[m];
    for(i=0; i < ESNa1; i++){
      for(mm=0; mm < ES2Mp1; mm++){
	r	=0.;
	ra	=0.;
	z	=0.;
	za	=0.;
	ki	=Mm*i+mm;
	kj	=MmJ*i+mm;
	for(k=0; k < neqU; k++){
	  b	=V[k][j];
	  r	+=b*gperU[kj];
	  z	+=b*gpeiU[kj];
	  ra	+=b*dgperU[kj];
	  za	+=b*dgpeiU[kj];
	  kj	+=ES2Mp1;
	}
	k	=ki+ES2Mp1*m;
	gyEr[k]	=r*gg[m];
	gyEi[k]	=z*gg[m];
	dgyEr[k]=ra*gg[m];
	dgyEi[k]=za*gg[m];

	r	=0.;
	ra	=0.;
	z	=0.;
	za	=0.;
	ki	=Mm*i+mm;
	kj	=MmJ*i+mm;
	for(k=0; k < neqU; k++){
	  b	=V[k][j];
	  r	+=b*aYerU[kj];
	  z	+=b*aYeiU[kj];
	  ra	+=b*daYerU[kj];
	  za	+=b*daYeiU[kj];
	  kj	+=ES2Mp1;
	}
	k	=ki+ES2Mp1*m;
	aYEr[k]	=r*gg[m];
	aYEi[k]	=z*gg[m];
	daYEr[k]=ra*gg[m];
	daYEi[k]=za*gg[m];
      }
    }
  }

  if((kA&0x02)){
    for(m=0; m < neqUR; m++){
      j	=ind[m];
      for(i=0; i < ESNa1; i++){
	for(mm=0; mm < ESMp1; mm++){
	  r	=0.;
	  ra	=0.;
	  z	=0.;
	  za	=0.;
	  for(kj=0,k=neqU,kp=M0Mm*i+ES2Mp1+ESMp+mm,km=kp-mm-mm; kj < ESMp;
	      kj++,k++,kp +=ES2Mp1,km +=ES2Mp1){
	    b	=V[k][j];
	    r	+=b*(gper[kp]+gper[km]);
	    ra	+=b*(dgper[kp]+dgper[km]);
	    z	+=b*(gpei[kp]-gpei[km]);
	    za	+=b*(dgpei[kp]-dgpei[km]);
	  }
	  for(kj=0,k=neqU+ESMp,kp=M0Mm*i+ES2Mp1+ESMp+mm,km=kp-mm-mm; kj < ESMp;
	      kj++,k++,kp +=ES2Mp1,km +=ES2Mp1){
	    b	=V[k][j];
	    r	+=b*(gpei[kp]+gpei[km]);
	    ra	+=b*(dgpei[kp]+dgpei[km]);
	    z	+=b*(gper[km]-gper[kp]);
	    za	+=b*(dgper[km]-dgper[kp]);
	  }
	  ki	=Mm*i+ES2Mp1*m+mm;
	  r	*=gg[m];
	  z	*=gg[m];
	  ra	*=gg[m];
	  za	*=gg[m];
	  gyEr[ki]	+=0.5*r;
	  gyEi[ki]	+=0.5*z;
	  dgyEr[ki]	+=0.5*ra;
	  dgyEi[ki]	+=0.5*za;
	  ki	=Mm*i+ES2Mp1*m-mm;
	  gyEr[ki]	+=0.5*r;
	  gyEi[ki]	-=0.5*z;
	  dgyEr[ki]	+=0.5*ra;
	  dgyEi[ki]	-=0.5*za;

	  r	=0.;
	  ra	=0.;
	  z	=0.;
	  za	=0.;
	  for(kj=0,k=neqU,kp=M0Mm*i+ES2Mp1+ESMp+mm,km=kp-mm-mm; kj < ESMp;
	      kj++,k++,kp +=ES2Mp1,km +=ES2Mp1){
	    b	=V[k][j];
	    r	+=b*(aYer[kp]+aYer[km]);
	    ra	+=b*(daYer[kp]+daYer[km]);
	    z	+=b*(aYei[kp]-aYei[km]);
	    za	+=b*(daYei[kp]-daYei[km]);
	  }
	  for(kj=0,k=neqU+ESMp,kp=M0Mm*i+ES2Mp1+ESMp+mm,km=kp-mm-mm; kj < ESMp;
	      kj++,k++,kp +=ES2Mp1,km +=ES2Mp1){
	    b	=V[k][j];
	    r	+=b*(aYei[kp]+aYei[km]);
	    ra	+=b*(daYei[kp]+daYei[km]);
	    z	+=b*(aYer[km]-aYer[kp]);
	    za	+=b*(daYer[km]-daYer[kp]);
	  }
	  ki	=Mm*i+ES2Mp1*m+mm;
	  r	*=gg[m];
	  z	*=gg[m];
	  ra	*=gg[m];
	  za	*=gg[m];
	  aYEr[ki]	+=0.5*r;
	  aYEi[ki]	+=0.5*z;
	  daYEr[ki]	+=0.5*ra;
	  daYEi[ki]	+=0.5*za;
	  ki	=Mm*i+ES2Mp1*m-mm;
	  aYEr[ki]	+=0.5*r;
	  aYEi[ki]	-=0.5*z;
	  daYEr[ki]	+=0.5*ra;
	  daYEi[ki]	-=0.5*za;
	}	
      }
    }
  }

#ifdef H
  for(m=0; m < neqUR; m++) out("???? Ti=d",m,T[m]);
#endif
  MakepVariances(Jp,T);
  MakeqVariances(T);
  gBjVariance(Js,Jp,T);
  PlotSVDEigenU(4,neqUR,T,1./T[0],kA,err,FlP);
  if(FlP) EqOutUAO(m0,m1,kA,T,err);
  PlotqVariances(6,i0,i1,m0,m1,T,FlP);
  PlotpVariances(7,i0,i1,m0,m1,Jp,T,FlP);
  PlotU(5,ga,U,ind,M,kA,m0,m1,FlP);
#ifdef H
  PlotU(8,Bpol,U,T,ind,m0,m1,FlP*0);

#endif

  if((kA&0x08)) PlotBzBtVariances(2,i0,i1,m0,m1,ga,U+mMse,ind,err[3],0*FlP);
  PlotJFunction(8,i0,i1,m0,m1,Js,Jp,T,FlP);

  return(0);
}

int MakeAllVariances(double **Js,double **Jp,double *T)
{
  int k,m,i,ki,j,n,Mm;
  double x[2],y[0x41];
  double gy;
  double F,rT,f0,f1;
  double *lgy,*ld;

  n	=ESNa1;

  Mm	=ES2Mp1*neqUR;
  for(m=0; m < neqUR; m++){
    rT	=crgm0/(T[m]*ESaR0[0]);
    gy	=0.;
    lgy	=gyEr+Mm+ES2Mp1*m+ESMp;
    ld	=Jp[m];
    F	=0;
    y[0]=0.;
    for(i=1; i < ESNa1; i++){
      F		+=0.5*(ESjp[i]+ESjp[i-1])*(*lgy-gy)
	+0.5*(ld[i]+ld[i-1])*(ESgY[i]-ESgY[i-1]);
      y[i]	=F;
      gy	=*lgy;
      lgy	+=Mm;
    }
    f0	=0.;
    for(i=0; i < ESNa1; i++){
      f1	=(y[i]-F)*rT;
      f0	+=f1*f1;
    }
    gdp[m]	=sqrt(f0/ESNa);
  }

#ifdef H
  for(m=m0; m < m1; m++){
    ld	=Jp[m]+i0;
    rT	=1./T[m];
    rT	=1.;
    for(i=i0; i < i1; i++) y[i]=(*ld++)*rT;
    Plot2d(iW,ESsa+i0,y+i0,n,6,0,kCol[m%0x10],0);
    if(FlP) PSPlot2d(ESsa+i0,y+i0,n,6,0,kCol[m%0x10],0);
  }
#endif
  return(0);
}

int gBjVariance(double **Js,double **Jp,double *T)
{
  extern double ESRext;
  extern double *ESsr,*ESdgY;
  int i,ii,i1,j,jj,k,m,Mm,ki;
  double baV[ESNa1],baLV[ESNa1],p4a[ESNa1];
  double R0,rR0;
  double f,f1,f0,F;
  double *ld,*ls,*gyr,*gyi,*dgyr,*dgyi;
  double Wth,Wli,Wgm,gbV,sli,gmV;
  double gdJ;

  double ys[0x100],*y2,yp[0x100];
  
  R0	=ESaR0[0];
  rR0	=1./R0;

  p4a[0]	=0.;
  baLV[0]	=ESsb1a[0]*rcT1a[ESNa1]*R0;
  baV[0]	=ESsb1a[0]*rcT1a[ESNa1]*rR0;
  jj	=ESNp1;
  for(i=1; i < ESNa1; i++){
    p4a[i]	=0.125*ESpa[i]*ESpa[i];
    ii	=i+ESNa1;
    f0	=(R0+rcT[i])*rcT[ii];
    for(k=1; k < ESFp; k++){
      i1	=ii;
      ii	+=ESNa1;
      f0	+=rcT[i1]*rcT[ii]+rsT[i1]*rsT[ii];
    }
    baV[i]	=ESsb[i]*f0/ESpa[i];
    f0	=0.;
    for(j=0; j < ESNp; j++,jj++) f0 +=log(ESsr[jj]*rR0)*EScs1[j];
    baLV[i]=f0*ESsb[i]/(ESpa[i]*ESNp);
    jj++;
  }

  Wth	=0.;
  f1	=ESjp[0]*ESdgY[0]*baV[0];
  for(i=1; i < ESNa1; i++){
    f0	=f1;
    f1	=ESPs[i]*ESdgY[i]*baV[i];
    Wth	-=(f0+f1)*(p4a[i]-p4a[i-1]);
  }
  gbV	=4.*Wth/(ESRext*ESaJ[ESNa]*ESaJ[ESNa]);
  Wth	*=15.*cgp;

  Wli	=0.;
  f1	=ESg22c[0]*ESdgY[0]*ESdgY[0];
  for(i=1; i < ESNa1; i++){
    f0	=f1;
    f1	=ESg22c[i]*ESdgY[i]*ESdgY[i];
    Wli	+=(f0+f1)*(p4a[i]-p4a[i-1]);
  }
  sli	=2.*Wli/(ESRext*ESaJ[ESNa]*ESaJ[ESNa]);
  Wli	*=5.*cgp;

  Wgm	=0.;
  f1	=(ESFF[ESNa]-ESFF[0])*ESLc[0];
  for(i=1; i < ESNa1; i++){
    f0	=f1;
    f1	=(ESFF[ESNa]-ESFF[i])*ESLc[i];
    Wgm	+=0.25*(f0+f1)*(ESpa[i]-ESpa[i-1]);
  }
  gmV	=2.*Wgm/(ESaR0[0]*ESRext*ESaJ[ESNa]*ESaJ[ESNa]);
  Wgm	*=5.*cgp/ESaR0[0];

  Wgm	=0.;
  f1	=ESaT[0]*ESdgY[0]*baLV[0];
  for(i=1; i < ESNa1; i++){
    f0	=f1;
    f1	=ESaT[i]*ESdgY[i]*baLV[i];
    Wgm	+=(f0+f1)*(p4a[i]-p4a[i-1]);
  }
  gmV	=4.*Wgm/(ESRext*ESaJ[ESNa]*ESaJ[ESNa]);
  Wgm	*=10.*cgp;

  Mm	=ES2Mp1*neqUR;
  for(m=0; m < neqUR; m++){
    f	=0.;
    f1	=0.;
    for(i=1; i < ESNa1; i++){
      f0	=f1;
      j		=Mm*i+ES2Mp1*m+ESMp;
      gyr	=gyEr+j;
      gyi	=gyEi+j;
      ki	=i;
      f1	=ESLc1[ki]*gyr[0];
      for(k=1; k < ESMp1; k++){
	ki	+=ESNa1;
	f1 	+=2.*((ESLc[ki]+ESVc[ki])*gyr[k]
		      -(ESLs[ki]+ESVs[ki])*gyi[k]);
      }
      f1	*=ESjp[i];
      f		+=0.25*(f0+f1)*(ESpa[i]-ESpa[i-1]);
    }
    ld	=Jp[m];
    f1	=(*ld++)*rR0*ESdgY[0]*baV[0];
    for(i=1; i < ESNa1; i++){
      f0	=f1;
      f1	=(*ld++)*rR0*ESdgY[i]*baV[i];
      f		-=(f0+f1)*(p4a[i]-p4a[i-1]);
    }
    gdWth[m]	=15.*cgp*f/T[m];

    gdgbS[m]	=4.*f/(ESRext*ESaJ[ESNa]*ESaJ[ESNa]*T[m]);
    gdgbV[m]	=fabs(gdgbS[m]);

    f	=0.;
    f1	=0.;
    for(i=1; i < ESNa1; i++){
      f0	=f1;
      j		=Mm*i+ES2Mp1*m+ESMp;

      gyr	=gyEr+j;
      gyi	=gyEi+j;

      ki	=i;
      f1	=ESLc1[ki]*gyr[0];
      for(k=1; k < ESMp1; k++){
	ki	+=ESNa1;
	f1 	+=2.*(ESLc[ki]*gyr[k]-ESLs[ki]*gyi[k]);
      }
      f1	*=ESaT[i];
      f		-=0.25*(f0+f1)*(ESpa[i]-ESpa[i-1]);
    }
    f	*=rR0;
    ls	=Js[m];
    ld	=Jp[m];
    f1	=(ls[0]-ld[0])*R0*ESdgY[0]*baLV[0];
    for(i=1; i < ESNa1; i++){
      f0	=f1;
      f1	=(ls[i]-ld[i])*R0*ESdgY[i]*baLV[i];
      f		+=(f0+f1)*(p4a[i]-p4a[i-1]);
    }
    gdWgm[m]	=10.*cgp*f/T[m];
    gdgmV[m]	=4.*f/(ESRext*ESaJ[ESNa]*ESaJ[ESNa]*T[m]);

#ifdef H
    out("? ?? mi dd d",m,gdgbV[m],gdgmV[m],gdgbV[m]-gdgmV[m]);
#endif
    gdJ	=0.;
    f1	=ls[0]*ESLc[0]+ld[0]*ESVc[0];
    for(i=1; i < ESNa1; i++){
      f0	=f1;
      j		=Mm*i+ES2Mp1*m+ESMp;
      gyr	=gyEr+j;
      gyi	=gyEi+j;

      ki	=i;
#ifdef H
      f1	=(ESjs1a[i]*ESLc[ki]+ESjp1a[i]*ESVc[ki])*gyr[k];
#endif
      f1	=0.;
      for(k=1; k < ESMp1; k++){
	ki	+=ESNa1;
	f1	+=2.*(ESjs1a[i]*ESLc[ki]+ESjp1a[i]*ESVc[ki])*gyr[k]
	  -2.*(ESjs1a[i]*ESLs[ki]+ESjp1a[i]*ESVs[ki])*gyi[k];	
      }
      f1	/=(ESsa[i]*ESdgY[i]);
      f1	+=ls[i]*ESLc[i]+ld[i]*ESVc[i];
      gdJ	+=0.25*(f0+f1)*(ESpa[i]-ESpa[i-1]);
    }
#ifdef H
    out("???? Ji=d d",m,gdJ,-aYEr[Mm*ESNa+ES2Mp1*m+ESMp]);
#endif

    f	=0.;
    f1	=0.;
    for(i=1; i < ESNa1; i++){
      f0	=f1;
      j		=Mm*i+ES2Mp1*m+ESMp;
      gyr	=gyEr+j;
      gyi	=gyEi+j;
      dgyr	=dgyEr+j;
      dgyi	=dgyEi+j;
      ki	=i;
      f1	=0.;
      for(k=1; k < ESMp1; k++){
	ki	+=ESNa1;
	f1 	+=2.*k*(ESg12s[ki]*gyr[k]+ESg12c[ki]*gyi[k]);
      }
      f1	/=-ESsa[i];
      ki	=i;
      f1	+=ESg22c[ki]*dgyr[0];
      for(k=1; k < ESMp1; k++){
	ki	+=ESNa1;
	f1 	+=2.*(ESg22c[ki]*dgyr[k]-ESg22s[ki]*dgyi[k]);
      }
      f1	*=ESdgY[i];
      f		+=0.25*(f0+f1)*(ESpa[i]-ESpa[i-1]);
    }

    ki	=ESNa;
    f1	=ESg22c[ki]*gyr[0];
    for(k=1; k < ESMp1; k++){
      ki	+=ESNa1;
      f1 	+=2.*(ESg22c[ki]*gyr[k]-ESg22s[ki]*gyi[k]);
    }
    f1		*=ESdgY[ESNa];

    f1	=0.;
    gdWli[m]	=cgp*(10.*f-5.*f1)/T[m];
    f1	=(4.*f-2.*f1)/(ESRext*ESaJ[ESNa]*ESaJ[ESNa]*T[m]);
    gdShS[m]	=fabs(gdgbS[m]+0.5*f1);
    gdliV[m]	=fabs(f1);
  }
  return(0);
}

