#ifndef Blb_Herm.c
/*  */
#ifndef mzl_System_Herm.c
  Undef k1;	/* undefined */
  Undef k2;	/* undefined */
  Undef k3;	/* undefined */
  Undef S;	/* undefined */
  Undef i1;	/* undefined */
  Undef kT1;	/* undefined */
  Undef kt1;	/* undefined */
  Undef f1;	/* undefined */
  Undef i2;	/* undefined */
  Undef kT2;	/* undefined */
  Undef kt2;	/* undefined */
  Undef f2;	/* undefined */
  Undef i3;	/* undefined */
  Undef kT3;	/* undefined */
  Undef kt3;	/* undefined */
  Undef f3;	/* undefined */
#endif
static HERM u[];	/*  */
static HERM v[];	/*  */
static double P[][];	/*  */
int IntPower()
{
  /*
   */
#ifdef Doc_IntPower

\section{Skeleton of IntPower()}
  \begin{verbatim}
    IntPower(){
    }
  \end{verbatim}
\section{IntPower()}
Elementary power integrals
\bqbl
&&
P_{mn}
=
\int^1_0T^mt^ndt
=
\R{t^{n+1}T^m}{n+1}
+\R{m}{n+1}\int^1_0T^{m-1}t^{n+1}dt
,\quad
T
=
1-t
.\eqbl

#endif
}
void main()
{
  Undef k1;
  Undef k2;
  Undef k3;
  Undef S;
  Undef i1;
  Undef kT1;
  Undef kt1;
  Undef f1;
  Undef i2;
  Undef kT2;
  Undef kt2;
  Undef f2;
  Undef i3;
  Undef kT3;
  Undef kt3;
  Undef f3;
  static HERM u[];	/*  :Herm.c */
  static HERM v[];	/*  :Herm.c */
  static double P[][];	/*  :Herm.c */
  int IntPower();	/*  :Herm.c */
/*
   */
#ifdef Doc_main
\section{Skeleton of main()}
  \begin{verbatim}
    main(){
    }
  \end{verbatim}
\section{main()}
Cubic spline representation
\bqbl
&&
g(a)=Xg_i+xg_{i+1}
+[(X^3-X)g''_0+(x^3-x)g''_1]\R{h^2}{6}
,\quad
X
=
\R{a_1-a}{h}
,\quad
x
=
\R{a-a_0}{h}
,\quad
h
\equiv
a_1-a_0
,\\&&
f
=
(3X^2-2X^3)f_0
+(3x^2-2x^3)f_1
+X^2xhf'_0
-x^2Xhf'_1
=
u_1f_0
+u_2f_1
+u_3f'_0
+u_4f'_1
,\\&&
f'
=
6Xx\R{f_1-f_0}{h}
-2Xx(f'_0+f'_1)
+X^2f'_0
+x^2f'_1
=
v_1f_0
+v_2f_1
+v_3f'_0
+v_4f'_1
.\eqbl

Elementary functions in variational principle
\bqbl
&&
g_1
\equiv
X
,\quad
g_2
\equiv
x
,\quad
g_3
\equiv
+X^3-X
,\quad
g_4
\equiv
x^3-x
,\\&&
u_1
\equiv
3X^2-2X^3
,\quad
u_2
\equiv
3x^2-2x^3
,\quad
u_3
\equiv
X^2xh
,\quad
u_4
\equiv
-x^2Xh
,\\&&
v_1
\equiv
-6\R{X-X^2}{h}
,\quad
v_2
\equiv
6\R{x-x^2}{h}
,\quad
v_3
\equiv
X^2
-2Xx
,\quad
v_4
\equiv
x^2
-2xX
.\eqbl
Elementary integrals in variational principle
\bqbl
&&
\int^{a_1}_{a_0}g_iu_ku_j da
=
h\int^1_0 g_iu_ku_j dX
=
h\int^1_0 g_iu_ku_j dx
=
\left<g_iu_ku_j\right>
,\quad
\left<g_iu_kv_j\right>
,\quad
\left<g_iv_kv_j\right>
.\eqbl
\begin{tabular}{|r|c|c|c|c|}\hline
\multicolumn{5}{|c|}{$\left<g_1u_ku_j\right>$}\\\hline
&$u_1$&$u_2$&$u_3$&$u_4$\\\hline
$u_1$ & 2.857142857e-01& 6.428571429e-02& 3.571428571e-02&-1.666666667e-02\\
$u_1$ & 6.428571429e-02& 8.571428571e-02& 1.428571429e-02&-1.666666667e-02\\
$u_1$ & 3.571428571e-02& 1.428571429e-02& 5.952380952e-03&-3.571428571e-03\\
$u_1$ &-1.666666667e-02&-1.666666667e-02&-3.571428571e-03& 3.571428571e-03\\
\hline
\multicolumn{5}{|c|}{$\left<g_2u_ku_j\right>$}\\\hline
&$u_1$&$u_2$&$u_3$&$u_4$\\\hline
$u_2$ & 8.571428571e-02& 6.428571429e-02& 1.666666667e-02&-1.428571429e-02\\
$u_2$ & 6.428571429e-02& 2.857142857e-01& 1.666666667e-02&-3.571428571e-02\\
$u_2$ & 1.666666667e-02& 1.666666667e-02& 3.571428571e-03&-3.571428571e-03\\
$u_2$ &-1.428571429e-02&-3.571428571e-02&-3.571428571e-03& 5.952380952e-03\\
\hline
\multicolumn{5}{|c|}{$\left<g_3u_ku_j\right>$}\\\hline
&$u_1$&$u_2$&$u_3$&$u_4$\\\hline
$u_3$ &-9.404761905e-02&-4.166666667e-02&-1.626984127e-02& 1.031746032e-02\\
$u_3$ &-4.166666667e-02&-7.261904762e-02&-9.920634921e-03& 1.349206349e-02\\
$u_3$ &-1.626984127e-02&-9.920634921e-03&-3.174603175e-03& 2.380952381e-03\\
$u_3$ & 1.031746032e-02& 1.349206349e-02& 2.380952381e-03&-2.777777778e-03\\
\hline
\multicolumn{5}{|c|}{$\left<g_4u_ku_j\right>$}\\\hline
&$u_1$&$u_2$&$u_3$&$u_4$\\\hline
$u_4$ &-7.261904762e-02&-4.166666667e-02&-1.349206349e-02& 9.920634921e-03\\
$u_4$ &-4.166666667e-02&-9.404761905e-02&-1.031746032e-02& 1.626984127e-02\\
$u_4$ &-1.349206349e-02&-1.031746032e-02&-2.777777778e-03& 2.380952381e-03\\
$u_4$ & 9.920634921e-03& 1.626984127e-02& 2.380952381e-03&-3.174603175e-03\\
\hline
\end{tabular}

\begin{tabular}{|r|c|c|c|c|}\hline
\multicolumn{5}{|c|}{$\left<g_1u_kv_j\right>$}\\\hline
&$v_1$&$v_2$&$v_3$&$v_4$\\\hline
$u_1$ &-3.142857143e-01& 3.142857143e-01& 1.095238095e-01&-7.380952381e-02\\
$u_1$ &-1.857142857e-01& 1.857142857e-01&-2.619047619e-02&-9.523809524e-03\\
$u_1$ &-5.714285714e-02& 5.714285714e-02& 4.761904762e-03&-1.190476190e-02\\
$u_1$ & 4.285714286e-02&-4.285714286e-02& 4.761904762e-03& 4.761904762e-03\\
\hline
\multicolumn{5}{|c|}{$\left<g_2u_kv_j\right>$}\\\hline
&$v_1$&$v_2$&$v_3$&$v_4$\\\hline
$u_2$ &-1.857142857e-01& 1.857142857e-01&-9.523809524e-03&-2.619047619e-02\\
$u_2$ &-3.142857143e-01& 3.142857143e-01&-7.380952381e-02& 1.095238095e-01\\
$u_2$ &-4.285714286e-02& 4.285714286e-02&-4.761904762e-03&-4.761904762e-03\\
$u_2$ & 5.714285714e-02&-5.714285714e-02& 1.190476190e-02&-4.761904762e-03\\
\hline
\multicolumn{5}{|c|}{$\left<g_3u_kv_j\right>$}\\\hline
&$v_1$&$v_2$&$v_3$&$v_4$\\\hline
$u_3$ & 1.595238095e-01&-1.595238095e-01&-8.333333333e-03& 3.214285714e-02\\
$u_3$ & 1.404761905e-01&-1.404761905e-01& 2.500000000e-02& 1.190476190e-03\\
$u_3$ & 3.333333333e-02&-3.333333333e-02& 1.190476190e-03& 5.952380952e-03\\
$u_3$ &-3.095238095e-02& 3.095238095e-02&-4.761904762e-03&-2.380952381e-03\\
\hline
\multicolumn{5}{|c|}{$\left<g_4u_kv_j\right>$}\\\hline
&$v_1$&$v_2$&$v_3$&$v_4$\\\hline
$u_4$ & 1.404761905e-01&-1.404761905e-01& 1.190476190e-03& 2.500000000e-02\\
$u_4$ & 1.595238095e-01&-1.595238095e-01& 3.214285714e-02&-8.333333333e-03\\
$u_4$ & 3.095238095e-02&-3.095238095e-02& 2.380952381e-03& 4.761904762e-03\\
$u_4$ &-3.333333333e-02& 3.333333333e-02&-5.952380952e-03&-1.190476190e-03\\
\hline
\end{tabular}
   
\begin{tabular}{|r|c|c|c|c|}\hline
\multicolumn{5}{|c|}{$\left<g_1v_kv_j\right>$}\\\hline
&$v_1$&$v_2$&$v_3$&$v_4$\\\hline
$v_1$ & 6.000000000e-01&-6.000000000e-01&-4.440892099e-16& 1.000000000e-01\\
$v_1$ &-6.000000000e-01& 6.000000000e-01& 8.326672685e-17&-1.000000000e-01\\
$v_1$ &-4.440892099e-16& 2.775557562e-17& 1.000000000e-01&-1.666666667e-02\\
$v_1$ & 1.000000000e-01&-1.000000000e-01&-1.666666667e-02& 3.333333333e-02\\
\hline
\multicolumn{5}{|c|}{$\left<g_2v_kv_j\right>$}\\\hline
&$v_1$&$v_2$&$v_3$&$v_4$\\\hline
$v_2$ & 6.000000000e-01&-6.000000000e-01& 1.000000000e-01&-5.551115123e-17\\
$v_2$ &-6.000000000e-01& 6.000000000e-01&-1.000000000e-01& 2.220446049e-16\\
$v_2$ & 1.000000000e-01&-1.000000000e-01& 3.333333333e-02&-1.666666667e-02\\
$v_2$ &-5.551115123e-17& 6.661338148e-16&-1.666666667e-02& 1.000000000e-01\\
\hline
\multicolumn{5}{|c|}{$\left<g_3v_kv_j\right>$}\\\hline
&$v_1$&$v_2$&$v_3$&$v_4$\\\hline
$v_3$ &-3.857142857e-01& 3.857142857e-01&-3.571428571e-02&-5.000000000e-02\\
$v_3$ & 3.857142857e-01&-3.857142857e-01& 3.571428571e-02& 5.000000000e-02\\
$v_3$ &-3.571428571e-02& 3.571428571e-02&-2.261904762e-02& 3.571428571e-03\\
$v_3$ &-5.000000000e-02& 5.000000000e-02& 3.571428571e-03&-2.023809524e-02\\
\hline
\multicolumn{5}{|c|}{$\left<g_4v_kv_j\right>$}\\\hline
&$v_1$&$v_2$&$v_3$&$v_4$\\\hline
$v_4$ &-3.857142857e-01& 3.857142857e-01&-5.000000000e-02&-3.571428571e-02\\
$v_4$ & 3.857142857e-01&-3.857142857e-01& 5.000000000e-02& 3.571428571e-02\\
$v_4$ &-5.000000000e-02& 5.000000000e-02&-2.023809524e-02& 3.571428571e-03\\
$v_4$ &-3.571428571e-02& 3.571428571e-02& 3.571428571e-03&-2.261904762e-02\\
\hline
\end{tabular}

#endif
}
#endif

#undef Doc_Cb_Structure
#ifdef Blb_Herm.c
Blb_Herm.c{
}
#endif

#undef Doc_Table_Of_Content
#ifndef Blb_Herm.c
			PS p= -1 (  0);
int IntPower();		PS p=  1 (  1);
void main();		PS p=  1 (  1);
#endif

