#ifndef Blb_esc.c
/*
To Do:
1. Thu Jul 10 10:00:02 EDT 1998
   Get rid from x0T,y0T .... in escG.c escPlV.c escA2R.c escE.c escDef.c
2. Wed Sep  9 16:25:17 EDT 1998
   Replace $ab$ with $b$
3. Thu Sep 10 17:40:34 EDT 1998
   Simplify calculations of magnetic fields and vector potential.
4. Tue Oct  6 13:09:23 EDT 1998
   Write for Bill about advancing ESC
Done:
1. Thu Aug 12 18:20:31 EDT 1998
2. Thu Sep 10 16:16:51 EDT 1998
 */
#ifdef Doc_esc.c
\title{Evolution equation for stellarator quilibria}
\author{L.~E.~Zakharov\\
{\em Princeton Plasma Physics Laboratory, Princeton NJ, USA}} 
\date{May 11, 1999}
\maketitle

%----------------------------------
\centerline{\helvV Evolution equation for stellarator}
\vskip0.1in
\centerline{\helvV equilibria}
\vskip0.2in
\centerline{\helvIII L.~E.~Zakharov}
\vskip0.2in
\centerline{\helvOIII PPPL, Princeton NJ} 
\vskip0.2in
\centerline{\helvIII May 20, 1999}

\vskip1in
\refstepcounter{section}
{\helvV 1. Notations}
\vskip0.2in
Flux coordinate system
\bqbl
&&
r
=
r(a,\gq,\gz)
,\quad
z
=
z(a,\gq,\gz)
,\quad
\gf
=
\gz(a,\gq,\gz)
\lbq{CC1}
.\eqbl
Metric tensor
\bqbl
dl^2
=&&
dr^2+dz^2+r^2d\gf^2
\\
\equiv&&
g_{aa}da^2
+2g_{a\gq}dad\gq
+g_{\gq\gq}d\gq^2
+2g_{a\gz}dad\gz
+2g_{\gq\gz}d\gq d\gz
\\&&
+g_{\gz\gz}d\gz^2
,\\
g_{aa}
=&&
r'_ar'_a
+z'_az'_a
+r^2\gf'_a\gf'_a
,\quad
g_{a\gq}
=
r'_ar'_\gq
+z'_az'_\gq
+r^2\gf'_a\gf'_\gq
,\\
g_{\gq\gq}
=&&
r'_\gq r'_\gq
+z'_\gq z'_\gq
+r^2\gf'_\gq\gf'_\gq
,\quad
g_{a\gz}
=
r'_a r'_\gz
+z'_a z'_\gz
+r^2\gf'_a\gf'_\gz
,\\
g_{\gq\gz}
=&&
r'_\gq r'_\gz
+z'_\gq z'_\gz
+r^2\gf'_\gq\gf'_\gz
,\quad
g_{\gz\gz}
=
r'_\gz r'_\gz
+z'_\gz z'_\gz
+r^2\gf'_\gz\gf'_\gz
.\eqbl
\Epg
\np{Notations}
Covariant representation of the vector potential
\bqbl
\waA
=
&&
-\gh\na a
+\gF\na\gq
+\gY\na\gz
,\eqbl
where $\gF$, $\gY$ are the toroidal and poloidal fluxes.
Contravariant representation of the magnetic field in terms of magnetic
fluxes  
\bqbl
&&
\waB
=
\na\times\waA
=
B^\gq\na\gz\times\na a
+B^\gz\na a\times\na\gq
,\\&&
\sqrt{g} B^a
=
\sqrt{g}\waB\cdot\na a
=
0
,\\&&
\sqrt{g} B^\gq
=
\sqrt{g}\waB\cdot\na\gq
=
-\gY'_a-\gh'_\gz
,\\&&
\sqrt{g} B^\gz
=
\sqrt{g}\waB\cdot\na\gz
=
\gF'_a+\gh'_\gq
.\eqbl
Contravariant representation of the current density in terms of currents
\bqbl
&&
\sqrt{g} j^a
=
0
,\\&&
\sqrt{g} j^\gq
=
-F'(a)-\gn'_\gz
,\\&&
\sqrt{g} j^\gz
=
J'(a)
+\gn'_\gq
,\eqbl
where $F$, $J$ are the total poloidal and toroidal currents,
correspondingly. 
\Epg
\np{Notations}
Covariant form of Ampere's law
\bqbl
\gm_0(F'+\gn'_\gz)
=&&
(B_\gz)'_a
-(B_a)'_\gz
,\quad
0
=
(B_\gz)'_\gq
-(B_\gq)'_\gz
,\\
\gm_0(J'+\gn'_\gq)
=&&
(B_\gq)'_a
-(B_a)'_\gq
\lbq{FJ}
,\eqbl
is equivalent to following expressions for covariant components
of the magnetic field
\bqbl
&&
\gm_0(\gn+\gf'_a)
=
B_a
\equiv
-{g_{a\gq}\over\sqrt{g}}(\gY'+\gh'_\gz)
+{g_{a\gz}\over\sqrt{g}}(\gF'+\gh'_\gq)
,\\&&
\gm_0(J+\gf'_\gq)
=
B_\gq
\equiv
-{g_{\gq\gq}\over\sqrt{g}}(\gY'+\gh'_\gz)
+{g_{\gq\gz}\over\sqrt{g}}(\gF'+\gh'_\gq)
,\\&&
\gm_0(F+\gf'_\gz)
=
B_\gz
\equiv
-{g_{\gz\gq}\over\sqrt{g}}(\gY'+\gh'_\gz)
+{g_{\gz\gz}\over\sqrt{g}}(\gF'+\gh'_\gq)
\lbq{Ba}
.\eqbl
The pressure balance
\bqbl
&&
\gm_0p'\sqrt{g}
=
-(\gF'+\gh'_\gq)(F'+\gn'_\gz)
+(\gY'+\gh'_\gz)(J'+\gn'_\gq)
,,\\&&
\gm_0p'(\sqrt{g})_0
=
-\gF'F'
+\gY'J'
\lbq{rfb}
,\eqbl
where $(\ldots)_0$ designates averaging over angle variables $\gq,\gz$.
\Epg
\npb{Evolution equation}
Covariant representation of the electric field
\bqbl
\waE
=
&&
-\R{\pa \waA}{\pa t}
-\na \gf_E
-\gh\na a
+\gF\na\gq
+\gY\na\gz
.\eqbl
Averaged parallel component of the Ohm law
$\gs_\parallel(\waB\cdot\waE)=(\waB\cdot\wsj)$   
\bqbl
(\sqrt{g}\waB\cdot\waE)_0
=&&
\gY'_a\gF'_t
-\gF'_a\gY'_t
,\\
(\sqrt{g}\waB\cdot\wsj)_0
=
&&
FJ'
-JF'
=
FJ'
-JF'
\eqbl
gives the evolution equation in its general form (V.~D.~Shafranov,
Reviews of Plasma Physics, v.2, 1962) as
\bqbl
\gY'_a\gF'_t
-\gF'_a\gY'_t
=&&
\r{\gs_\parallel}(FJ'-JF')
.\eqbl
In the form of a magnetic diffusion equation it can be rewritten as
\bqbl
\gY'_a\gF'_t
-\gF'_a\gY'_t
=&&
\r{\gm_0\gs_\parallel}\left[
  (F+\gm J)\left(
   -{g_{\gq\gq}\over\q{g}}(\gY'+\gh'_\gz)+{g_{\gq\gz}\over\q{g}}(\gF'+\gh'_\gq)
  \right)'_{0a} 
\right.\\&&\left.\kern0.6in
 +\R{\gm_0p'(\sqrt{g})_0J}{\gF'}
 \right]
.\eqbl
\Epg

\np{Evolution equation}
In the flux coordinates with $\gF$ as a radial coordinate (like in VMEC), it
can be simplified as
\bqbl
\gY'_t
=&&
\r{\gm_0\gs_\parallel}\left[
  (F+\gm J)\left(
   {g_{\gq\gq}\over\q{g}}(\gY'_\gF+\gh'_\gz)-{g_{\gq\gz}\over\q{g}}(1+\gh'_\gq)
 \right)'_{0\gF}
\right.\\&&\left.\kern0.6in
 -\gm_0p'(\sqrt{g})_0J
 \right]
.\eqbl
It can be also rewritten as the evolution equation for the rotational
transform $\gm\equiv1/q$
\bqbl
\gm'_t
=&&
\left\{\r{\gm_0\gs_\parallel}\left[
  (F+\gm J)\left({g_{\gq\gq}\over\q{g}}(\gm+\gh'_\gz)
   -{g_{\gq\gz}\over\q{g}}(1+\gh'_\gq)
  \right)'_{0\gF}
\right.\right.\\&&\left.\left.\kern0.6in
 -4\gp p'(\sqrt{g})_0J
 \right]\right\}'_\gF
\eqbl
and, thus, can be used to produce $\gm$ as an input profile for VMEC.
\Epg
%--------------------------------------



{
Advances in MHD theory

Two breakthroughs in 3D MHD theory and a regular progress in development
of ESC (Equilibrium and Stability Code, former SESC)  have been made
in the past three quarters.

In 3D MHD theory:

1. A set of 3D equilibrium equations have been written for ESC
in a regular Grad-Shafranov form. While the existing stellarator
equlibrium theory did never properly resolve the inconsistencies in
equilibrium near the resonant surfaces in 3D configurations, this new
set of equations is consistent and solvable irrespective to presence of
resonance surfaces in the plasma.

2. The Reference Magnetic Coordinates (RMC) have been defined for 3D
MHD as the basis for the adequate description of 3D magnetic
fields. Being topologically as simple as 2D flux coordinates (which do
not exist in 3D case), they allow to describe 3D magnetic fields with
the same efficiency as well-known psi-function in 2D case. A simple
numerical method for generation of RMC has been formulated. It is as
fast as the best methods of reconstruction flux coordiantes in 2D case.
This method eliminates the necessity of using cumbersome field line
tracing procedure in 3D MHD numerical codes.


In assembling the ESC:

1. Fast 3D spline based routine has been implemented for calculations of
3D vacuum magnetic fields.  It is at least 2 order of magnitude faster
than existing Bio-Savart technique of integration along the coils.

2. RMC generation routines has been implemented and tested on some of
existing vacuum stellarator configurations.

3. 2D version of ESC has been created for tokamak calculations. In
contrast to existing equilibrium codes, ESC-2D is flexible in choice of
radial coordinate and input plasma profiles. This makes it compatible
with any of the existing codes and gives the possiblility for extensive
comparisions, which are now uder way. In particular, ESC-2D easily
reproduces any of NSTX configurations, and the proper equilibrium
solving routine for the TRANSP code is under test.


The only thing I can say about your appraisal form, is that I am deeply 
upset that my job during this year was not properly appreciated.

This April, I resolved the problem of proper discription of the
stellarator equilibria, the problem which standed
theoretically unresolved for decades. It was not resolved neither by
Grad or Shafranov or by their predecessors nor later by Cary, Boozer,
Dewar or many others working in this field.

I did it as soon as I started to think on the problem and on
extension of my equilibrium code to stellarator configurations. 
Of course, the breakthrough in understanding the 3-D configurations has
much more applications than just a correct approach to stelalrator
equilibria, but I hesitate to discuss it here. I only mention the level
of feedback from the people of Lab on this result, who said that my
approach is valuable only "for poor people". 

Although this progress in understanding make me proud, at least for
myself, I also made a very fast progress in implementing new description
into the 3D version of my code. I would like to see anybody here or in the
World, who after two months of working can generate a code for
calculation 3-D vacuum fields, which has at least 10% of the speed of
my vacuum part of the code (which is a necessary part of the entire
equilibrium code). 

Although there is a distance between a theoretical progress and a
working code, which exceeds the capacities of existing codes in the
field, I decided to pass this distance being sure in the importance of
the issue. And I do not think, that my performance in doing this is by
any bit lower than that of other people.

Sorry,

Leonid


}

\LARGE
\centerline{\Huge\bf\ }
\helvIII
\centerline{\helvV New 3D MHD equilibrium theory}
\vskip24pt
{\helvIII  3D equilibrium equations of ESC in the
Grad-Shafranov form are presented below}
\LARGE\bf
\helvIII
\bqbl
&&
4\gp p'_a\sqrt{g}
=
-(\gF'_{00}+\gh'_\gq)F'_a
+(\gY'_{00}+\gh'_\gz)J'_a
,\eqbl
\bqbl
&&
F'_\gq-J'_\gz
=
0
,\eqbl
where
\bqbl
&&
F'_\gq
-J'_\gz
\equiv
(B_\gz)'_\gq
-(B_\gq)'_\gz
,\\&&
F'_a
\equiv
(B_\gz)'_a
-(B_a)'_\gz
,\\&&
J'_a
\equiv
(B_\gq)'_a
-(B_a)'_\gq
,\eqbl
\bqbl
&&
B_a
\equiv
{g_{aa}\over\sqrt{g}}(\gY'_\gq-\gF'_\gz)
-{g_{a\gq}\over\sqrt{g}}\gY'_a
+{g_{a\gz}\over\sqrt{g}}\gF'_a
,\\&&
B_\gq
\equiv
{g_{\gq a}\over\sqrt{g}}(\gY'_\gq-\gF'_\gz)
-{g_{\gq\gq}\over\sqrt{g}}\gY'_a
+{g_{\gq\gz}\over\sqrt{g}}\gF'_a
,\\&&
B_\gz
\equiv
{g_{\gz a}\over\sqrt{g}}(\gY'_\gq-\gF'_\gz)
-{g_{\gz\gq}\over\sqrt{g}}\gY'_a
+{g_{\gz\gz}\over\sqrt{g}}\gF'_a
.\eqbl
These equations eliminate the mess in existing 3D theory concerning
the singular currents near the resonant surfaces and constitute a new,
solid basis for 3D MHD. 

\newpage
\centerline{\helvV Linearized equations}
\vskip24pt
The same equations, with linear corrections included
\bqbl
&&
4\gp (p'_a+\gd p')\sqrt{g}
=
-(\gF'_{00}+\gh'_\gq)F'_a
+(\gY'_{00}+\gh'_\gz)J'_a
\\&&
-(\gF'_a-\gF'_{00}+\gh'_\gq)((B_{0\gz})'_a-(B_{0a})'_\gz)
\\&&
+(\gY'_a-\gY'_{00}-\gh'_\gz)((B_{0\gq})'_a-(B_{0a})'_\gq)
\lbq{lpb}
,\eqbl
\bqbl
&&
F'_\gq-J'_\gz
=
(B_{0\gq})'_\gz
-(B_{0\gz})'_\gq
\lbq{lja}
,\eqbl
where 
\bqbl
&&
B_{0a}
\equiv
-{g_{a\gq}\over\sqrt{g}}(\gY'_{00}+\gh'_\gz)
+{g_{a\gz}\over\sqrt{g}}(\gF'_{00}+\gh'_\gq)
,\\&&
B_{0\gq}
\equiv
-{g_{\gq\gq}\over\sqrt{g}}(\gY'_{00}+\gh'_\gz)
+{g_{\gq\gz}\over\sqrt{g}}(\gF'_{00}+\gh'_\gq)
,\\&&
B_{0\gz}
\equiv
-{g_{\gz\gq}\over\sqrt{g}}(\gY'_{00}+\gh'_\gz)
+{g_{\gz\gz}\over\sqrt{g}}(\gF'_{00}+\gh'_\gq)
,\eqbl
and perturbations $\gd p$ and one of additional 1D function, e.g.
\bqbl
&&
j(a)
\equiv
{1\over4\gp^2}\oint(B_{0\gq})'_ad\gq d\gz
,\eqbl
contains only non-resonant parts 
\bqbl
&&
\gd p'
\equiv
\gd p'^\nst
=
-p''\gx^\nst
,\quad
\gd j
\equiv
-j'\gx^\nst
,\\&&
(\gF'_{00}+\gh'_\gq)\gx'^\nst_\gz
-(\gY'_{00}+\gh'_\gz)\gx'^\nst_\gq
\equiv
(\gY'_\gq-\gF'_\gz)^\nst
\lbq{pj}
,\eqbl
give the fast Newton scheme of solving nonlinear 3D equilibrium
equations when two profiles, $p(a)$ and $j(a)$, are prescribed.

\newpage
Note, that with substitution of other constraints instead of
Eq.(\rfq{pj}), (e.g., frozenness conditions and the adiabatic law for  
the pressure), Eq.~(\rfq{lpb}),(\rfq{lja}) reproduces the ideal 3D energy
principle (with inertia neglected).

This gives the possiblity for ESC to provide as an option stability
information (both ideal and resistive) and explains its name as
Equilibrium and Stability Code. 

#ifdef H
\newpage
\title{The theory of 3-D MHD equilibrium}
\author{L.~E.~Zakharov\\
{\em Princeton Plasma Physics Laboratory, Princeton NJ, USA}\\ \\
M.~I.~Mikhailov, ~V.D.~Pustovitov, V.~D.~Shafranov, A.~A.~Subbotin\\
{\em Institute of Nuclear Fsuion, RSC ``Kurchatov Institute'', Moscow,
Russia}} 
\date{October 4, 1998}
\maketitle
\begin{abstract}
The paper resolves three long standing problems in the theory of 3D
equilibrium. First, it gives a complete set of 3D equilibrium equation
in a regular solvable form, which does not contain singular
currents. Second, it introduces the reference magnetic coordinates,
which represent the proper generalization of flux coordinates onto 3D
case, when the flux surfaces may not exist. Third, it formulates the
theory of incomplete equilibrium when the plasma pressure is allowed to
not follow the magnetic field lines. In addition, the simplest Newton
scheme, based on MHD stability theory, is formulated for fastest solving
both 2D and 3D non-linear equilibrium equations. Thus, the paper gives a
solid basis for the plasma physics of 3D configurations as well as for
development of efficient numerical codes for stellarator machines.
\end{abstract}

\section{Introduction}
Stellarator configurations, which were invented more than four decades
ago, give a lot of flexibility in designing stationary magnetic
configurations for the plasma confinement. Despite a fundamental
difficulty in confinement of hot products of the fusion reactions, the
interest to stellarator idea does not diminish with time. This interest
is feed by possibilities, which stellarator configurations provide in
affecting the plasma transport and stability properties by proper
designing the magnetic configuration.

Although, a big progress in understanding the properties of stellarator
configurations has been made since their invention (and experimental
studies basically confirmed this understanding), further progress is
clearly under a siege by several unresolved conceptual problem in the
theory of stellarators. Several of this problems lay at the basic level,
namely, in the MHD equilibrium theory.

While the 3D equilibrium is certainly more complicated than the 2D
equilibrium (like in tokamaks), there are additional fundamental
problems, which have not been properly resolved by the theory.

First, in comparison to tokamaks, one of the problems lays at even more
fundamental level, than MHD equilibrium and is related to description of
3D magnetic fields. In contrast to 2D case, there is no 3D
``$\gY$''-function, which specifies the magnetic surfaces in the 
tokamak-like form 
\bqbl
&&
\gY
=
const
.\eqbl
Instead of this trivial 2D equation, existing 3D theory relies on
numerical line tracing procedure for reconstruction 3D magnetic
fields. This approach (in fact, the only existing), is extremely
inefficient in comparison with methods which use the advantage of
$\gY$-function. (We do not mention, here, methods, which assume
existence of the flux surfaces. Although, being practically useful as a
guidance in designing  the stelalrator configurations, they are
inconsistent with existence of  island topology of 3D equilibrium, and,
thus, do not contribute to resolution of the problem). 

In this paper, (Sect.~2) we introduce the reference magnetic coordinates
(RMC) with a method of their calculation, which does not invoke the line
tracing and is as efficient as the tokamak 2D method, based on existence
of well-defined $\gY$-function. These RMC represent the proper
generalization for 3D configurations the flux coordinates of the 2D 
case. Despite having simple topology of nested toroidal coordinates,
RMC allow to describe in a simplest way magnetic fields with the island
topology. 

The second problem is related to misinterpretation in the existing 3D
theory of equilibrium conditions near the resonant surfaces. It is
well-known that 3D equilibrium equations cannot be resolved at the
resonant surface when the pressure gradient is finite. Attempts to
reconstruct the appropriate equilibrium current density near the
resonant surface, based on existing theory,  results in a singular
resonant current, (if the inverse $B^2$ contains resonant
terms). Failure to resolve this problem by existing theory, leads to use
of singular differential equations in 3D numerical codes, which pretend
to calculate 3D configurations with magnetic islands. As a result, such
codes exhibit extremely poor (if any) convergence for finite pressure
plasmas. 

In this paper (Sect.~3), we formulate an appropriate set of regular 3D
equilibrium equations in the Grad-Shafranov form, which do not contain
any singular currents. This system of equation automatically provides
the necessary conditions for solvability. Absence of any nonregular
terms in our formulation proves that the entire problem of the
``singular currents'' near the resonant surfaces, which was heavily
discuussed in the literature, is a misconcept of the 3D existing theory.

The third problem is related to a conceptual difficulty in the 3D
equilibrium theory about pressure distribution in 3D magnetic
configurations. It is well-known, that in its idealized form
\bqbl
&&
\na p
=
{1\over c}\Bsj\times\BbB
\eqbl
the equilbrium equation has no regorous solution with the finite
pressure gradient because of islands formation and stochastisity near
magnetic islands. Although, in practice, there is no needs in precise
solving this equation, there is no regourous theory on how to find the
``non-rigorous''. All the existent theory relies on one of concequence
of the equilibrium equation 
\bqbl
&&
\BbB\cdot\na p
=
0
,\eqbl
which cannot be fullfilled without arbitrary flattening the pressure
profile. 

In Sec.~4 of this paper, we resolve the issue by noting that the above
equation, which is a source of conceptual problem, is the most
unreliable condition in the equilibrium theory. In contrast to earlier 
attempts to resolve the problem of solvability of equilibrium equations,
based on unrealistic assumptions about an artificially flattened
pressure profile, we formulate the theory of incomplete equilibrium,
which allows to link the equilibrium pressure profile with, e.g.,
transport properties of configurations. Our approach eliminates the
most unreliable element from equilibrium equations and, thus, leads to
a proper resolution of conceptual problem.  

In Sect.~5, we introduce a new element in both 2D and 3D equilibrium
theory by showing application of MHD stability theory for the most
efficient solving equilibrium equations. The general idea relies on the
fact, that the well-known equations of small MHD oscillations (with
plasma inertia neglected) represent a proper linearization of equilibrium
equations. In this regard they can be used as a the most simple and
efficient Newton scheme for solving non-linear equilibrium equations.

In Summary, we are suggesting possible implication of ideas of this
paper to the basic (time dependent) MHD theory, which, until now did not
resolve several fundamental problems, e.g., the problem of the so-called
``resistive'' (in general, non-ideal) S-parameter (because ofthe  lack
of appropriate coordinates) and the problem of fast magneto-sonic waves
(because of lack of a proper coordinate advancing scheme). The progress,
we made in 3D equilibrium theory has a clear generalization for the time
dependent MHD, although we leave the details for the future work.

\section{Reference magnetic coordinates (RMC) for 3D magnetic fields}
In this section we address the issue of designing the proper coordinate
system for 3D magnetic fields, which is the most appropriate for
3D topology of magnetic fields.

Let us, first, introduce some characteristic function $a$ of 3D
magnetic field. It is a general unique 3D function $a=a(x,y,z)$ of the
point in the space and its iso-value equations
\bqbl
&&
a^*
=
const
\eqbl
generate a general toroidal geometry with islands of arbitrary
complexity. Because $a^*$ is an unique function of the point in the space,
those equations does not lead to any stochasticity in iso-surfaces of
$a^*$. 

We connect $a^*$ with 3D magnetic fields by the magnetic differential
equation (MDE) 
\bqbl
&&
\BbB\cdot\na a^*
\simeq
0
\lbq{MDEa}
.\eqbl
Because of the above mentioned restrictions on $a^*$ and possible
stochasticity of the magnetic field lines, this MDE cannot be
satisfied exactly. On the other hand, any prescribed accuracy in
revealing the topology of iso-surfaces of $a^*$ can be reached in
solving this equation, e.g., with the field line tracing procedure.

Leaving for a while aside the technical aspects of efficiency of
reconstructing the iso-level surfaces of $a$, we will assume that some
of this functions has been reconstructed with an adequate accuracy. With
a proper addition of cyclic angular variables $\gq^i,\gz^i$ on $a^*=const$
surfaces (defined separately inside the regular parts of the  body of
configuration and each of topological islands with seperscript $i$
counting the islands), $a^*,\gq^i,\gz^i$ represent the set of 3D
magnetic coordinates for description of the 3D magnetic
field.

Basically, this is an approach, which is implemented in existing
numerical codes, when it is necessary to distribute some physical
quantities in space, in accordance with the topology of magnetic field. 
The inefficiency of it is that the $\simeq$ condition cannot be
implemented with the line tracing technique. As a result, the exact
solution of Eq.~(\rfq{MDEa}), typically obtained after tedious
calculations, then is mapped into much more rough representation with
the calculation grid.

Now, we can address the problem of how to resolve the problem of
describing 3D magnetic fields in another way. We consider general
toroidal curvilinear coordinates $a,\gq,\gz$, which can be be
represented uniquely as 
\bqbl
&&
r
=
r(a,\gq,\gz)
,\quad
z
=
z(a,\gq,\gz)
,\quad
\gf
=
\gz(a,\gq,\gz)
\lbq{CC1}
.\eqbl
The above mentioned magnetic coordinates $a^*,\gq^i,\gz^i$ can be
considerend as a particular case of them, but in practice, we assume a
simpler topology of $a,\gq,\gz$. (Note, that the line tracing method
does not directly provide for this representation and, thus, requires
additional conversion of the line tracing data into the above
represntation.)

The advantage of this form is that the metric tensor of coordinates is
easily calculated as 
\bqbl
&&
dl^2
=
dr^2+dz^2+r^2d\gf^2
\equiv
g_{aa}da^2
+2g_{a\gq}dad\gq
+g_{\gq\gq}d\gq^2
+2g_{a\gz}dad\gz
+2g_{\gq\gz}d\gq d\gz
+g_{\gz\gz}d\gz^2
,\\&&
g_{aa}
=
r'_ar'_a
+z'_az'_a
+r^2\gf'_a\gf'_a
,\quad
g_{a\gq}
=
r'_ar'_\gq
+z'_az'_\gq
+r^2\gf'_a\gf'_\gq
,\quad
g_{\gq\gq}
=
r'_\gq r'_\gq
+z'_\gq z'_\gq
+r^2\gf'_\gq\gf'_\gq
,\\&&
g_{a\gz}
=
r'_a r'_\gz
+z'_a z'_\gz
+r^2\gf'_a\gf'_\gz
,\quad
g_{\gq\gz}
=
r'_\gq r'_\gz
+z'_\gq z'_\gz
+r^2\gf'_\gq\gf'_\gz
,\quad
g_{\gz\gz}
=
r'_\gz r'_\gz
+z'_\gz z'_\gz
+r^2\gf'_\gz\gf'_\gz
.\eqbl

In curvilinear coordinates $a,\gq,\gz$, the vector potential of the
magnetic field can be written in the most general covariant form as  
\bqbl
\BbA
=
&&
-\gh\na a
+\gF\na\gq
+\gY\na\gz
+U'_a\na a
+U'_\gq\na\gq
+U'_\gz\na\gz
,\eqbl
where $U$ is a scalar potential, which does not affect the magnetic
field. This form of $\BbA$ leads to a contravariant representation for
the magnetic field  
\bqbl
\BbB
=
&&
\na\times\BbA
=
B^a\na\gq\times\na\gz
+B^\gq\na\gz\times\na a
+B^\gz\na a\times\na\gq
\eqbl
with contravariant components
\bqbl
&&
\sqrt{g} B^a
=
\sqrt{g}\BbB\cdot\na a
=
\gY'_\gq-\gF'_\gz
,\\&&
\sqrt{g} B^\gq
=
\sqrt{g}\BbB\cdot\na\gq
=
-\gY'_a-\gh'_\gz
,\\&&
\sqrt{g} B^\gz
=
\sqrt{g}\BbB\cdot\na\gz
=
\gF'_a+\gh'_\gq
.\eqbl
Freedom in choosing the scalar potential can be used in two ways. The
first choice is to eliminate $\gq$-dependence in the $\gq$-component of
the vector potential 
\bqbl
&&
\gF(a,\gq,\gz)
+U'_{1,\gq}
=
\gF_{0\cup}
\equiv
\gF_{00}
+\gF_{0\til}
,\quad
\gF_{00}
\equiv
\gF_{00}(a)
,\quad
\gF_{0\cup}
\equiv
\gF_{0\cup}(a,\gz)
,\quad
\gF_{0\til}
\equiv
\gF_{0\cup}
-\gF_{00}
\lbq{gF}
.\eqbl
Upon necessity, we will use ${}_\cup$, ${}_0$, ${}_\til$ as subscripts to
distinguish between general function of the angle coordinate and its
averaged and oscilalting parts. Because of having two of such variables,
we will use two subscripts (if any) with the first one related to $\gq$
and the second to $\gz$. In this notations a general function
$G(a,\gq,\gz)$ can be repesented by its components in many ways
\bqbl
G(a,\gq,\gz)
\equiv&&
G_{0\cup}(a,\gz)
+G_{\til\cup}(a,\gq,\gz)
\equiv
G_{00}(a)
+G_{0\til}(a,\gz)
+G_{\til\cup}(a,\gq,\gz)
\\
\equiv&&
G_{00}(a)
+G_{0\til}(a,\gz)
+G_{\til0}(a,\gq)
+G_{\til\til}(a,\gq,\gz)
\\
\equiv&&
G_{00}(a)
+G_{\til0}(a,\gq)
+G_{\cup\til}(a,\gq,\gz)
\equiv
G_{\cup0}(a,\gq)
+G_{\cup\til}(a,\gq,\gz)
\equiv
G_{\cup\cup}(a,\gq,\gz)
.\eqbl
The meaning of our notations is obvious in Fourier representation of 3D
functions.

In Eq.~(\rfq{gF}), $2\gp\gF_{\cup0}$ represent the toroidal flux of
magnetic  field through the contour $a=const$, $\gz=const$. Note, that
$\gz$-dependence in $\gF_{0\cup}$ can be easily eliminated by a proper
relebeling the radial coordinate. Although, this is the natural
choice to MHD theory, we will not imply that this trivial procedure has
been performed on the coordinate system i separate way.

In this choice of $U$, the $\gz$-component of the vector potential has a
general coordiante dependence and, thus, can be represented as 
\bqbl
&&
\gY
=
\gY_{00}
+\gY_{0\cup}
+\gY_{\til\til}
\equiv
\gY_{00}
+\gY_{0\cup}
+\gy
,\eqbl
where $\gy$ is the oscillatory part of the $\gY$.

The second choice of $U$ is elimination of the radial component of the
vector potential 
\bqbl
&&
\gh(a,\gq,\gz)
+U'_{2,a}
=
0
\eqbl
and we will use it later in equilibrium perturbation theory.
The first calibration is applied thoughout existing the equilbrium
theory, which in addition relies on the flux coordinate formulation, by
implying
\bqbl
&&
\gF
=
\gF_{00}(a)
,\quad
\gY
=
\gY_{00}(a)
.\eqbl
While the assumption about $\gF=\gF_{00}(a)$ is justifiable for
determining the proper coordinates for the problem (and, as mentioned
already,  can be fulfilled in a trivial way), the second assumption is
conceptually wrong as it is imcompatible with existence of islands in
3-D magnetic configurations. It may lead to possible unsolvability
problem, which cannot be resolved without changing topology of
coordinates. 

Our goal is to define an algorithm of advancing coordinates in a way,
that the magnetic field would have the simplest possible representation. 
The obvious, but in general unreachable target is the flux coordiantes,
which have no normal component of magnetic field to the $a=const$
surface. Assuming, that the system is advanced by
\bqbl
&&
a
\to
a+\gx
,\eqbl
the condition of elimination of the radial magnetic field is
\bqbl
&&
\BbB\na\gx
=
\BbB\na a
,\\&&
(\gF'_a+\gh'_\gq)\gx'_\gz
-(\gY'_a+\gh'_\gz)\gx'_\gq
+(\gY'_\gq-\gF'_\gz)\gx'_a
=
\gY'_\gq-\gF'_\gz
.\eqbl
Its linearized version, assuming that the normal component of magnetic
field and $\gx$ are the parameters of linearization, is
\bqbl
&&
(\gF'_{00}+\gh'_\gq)\gx'_\gz
-(\gY'_{00}+\gh'_\gz)\gx'_\gq
=
\gy'_\gq-\gF'_{0\til,\gz}
.\eqbl
This MDE equation, based on averaged components of poloidal and toroidal
fluxes, can be easily solved in Fourier space for nonresonant harmonics
\bqbl
&&
\gy'_\gq-\gF'_{0,\til,\gz}
\equiv
\sum^{m<M}_{m >-M}\sum^{n<N}_{n >-N}\gy_{mn}(a)e^{im\bgq-in\gz}
,\quad
\bgq
\equiv
\gq+{\gh\over\bgF'_{00}}
,\\&&
\gx
\equiv
\sum^{m^\nst<M\atop n^\nst<N}_{m^\nst=1\atop n^\nst=0}
 \gx^\nst_{mn}(a)e^{im\bgq-in\gz}
,\quad
\gx^\nst_{mn}(a)
=
{\gy^\nst_{mn}\over n^\nst\bgF'_{00}+m^\nst\bgY'_{00}}
.\eqbl
It is important, that we keep in $gx$ only nonresonant components and
because of this this theory has no problems with resonaces in the
coordiante advancing scheme. As a result of successive application of
this algorithm, the coordinate system is deformed in a such way, that
the vector potential acquires the simplest possible representation
\bqbl
\BbA
=
&&
-\gh\na a
+\gF_{00}\na\gq
+(\gY_{00}+\gy^*)\na\gz
,\\
\gy^*
&&
=
\sum^{m^*<M\atop n^*<N}_{m^*>-M\atop n>-N}\gx^*_{mn}(a)e^{im\bgq-in\gz}
,\eqbl
where $\gy^*$ contains only resonat terms. We call such a coordinate
system the reference magnetic coordinate (RMC), which is a propoer
subsitution for the the flux coordiantes in 3D case.

Note, that while the total elimination of any of resonant terms is not
further possibble without change in the topology of coordinates, these
coordinates can be optimized in an obvious way, that resonant harmonics
in $\gy^*$ are also localized radially, potentially, up to their island
size
\bqbl
&&
w_{mn}
=
4\sqrt{\left|{m\gy^*_{mn}\over \gF'_{00}\gi'}\right|}
,\quad
\gi
\equiv
-{\gY'_{00}\over\gF_{00}}
.\eqbl

Although, the topology of RMC does not correspond to the topology of the
magnetic field, the magnetic topology can be easily reconstructed by the
perturbation method, using island size as an expansion parameter. In the
simple case, when there is no radial overlapping of the resonant
harmonics, it is determined near the resonant surface like in 2D case
\bqbl
&&
\gY^*_{nm}(a,\gq,gz)
\equiv
n\gF'_{00}+m\gY'_{00}
+\left(\gy^*_{mn}e^{im\bgq-in\gz}+c.c.\right)
=
const
.\eqbl
It is trivial to expand the perturbation theory on either more general
case or include higher order terms in it.

The size of the resulting islands, gives self-contained condition of
applicability of the perturbation theory. If it is not sufficient, the
reconstruction can be performed in the same way inside the islands and
so on.

This coordinate advancing scheme, which leads to RMC, is analogous (in
fact, is better) than the 2D scheme, which relies on condition
$\gY=const$. In fact, it is in the same manner applicable to 2D in the
form
\bqbl
&&
\gY_\til
+\gY'_{00}\gx
\eqbl
for the fast and explicit advancing 2D coordinates.

Thus, in comparing with traditional magnetic coordiantes
$a^*,\gq^i,\gz^i$, the RMC with much simpler topology, can easily
approach the same accuracy in representing 3D magnetic fields. The
described algorithm of generation RMC is based on a fast Newton
scheme in its remarkably simple explicit form.

\section{Grad-Shafranov form of 3-D equilibrium equations}
While, in tokamaks, all the equilibrium theory is based on the
Grad-Shafranov (GSh) form of equilibrium equations, this form, to our
knowledge, has never been derived in 3D equilibrium theory. In order to
better explain our derivation we give a sketch of 2D derivation which is
applicable to the 3D case in a sraightforward manner.

First we assume existence of some background magnetic field
$\bar{\BbB}$ which generates a curvilinear coordinates $a,\gq,\gz$ (2D,
at the moment), which gives the following representation for this
magnetic fields 

\bqbl
&&
\sqrt{g} \bbB^a
=
0
,\\&&
\sqrt{g} \bbB^\gq
=
-\bgY'_{00}(a)
,\\&&
\sqrt{g} \bbB^\gz
=
\bgF'_{00}(a)+\bgh'_\gq
.\eqbl

Now, we introduce another magnetic field $\BbB$ and its vector
potential $\BbA$, with a general representation in these coordinates
\bqbl
&&
\BbA
=
\gF\na\gq
+\gY\na\gz
,\quad
\gF
\equiv
\gF(a,\gq,\gz)
,\quad
\gY
\equiv
\gY(a,\gq,\gz)
,\\&&
\sqrt{g} B^a
=
\gY'_\gq-\gF'_\gz
,\\&&
\sqrt{g} B^\gq
=
-\gY'_a
,\\&&
\sqrt{g} B^\gz
=
\gF'_a
.\eqbl
We intentionally use different calibrations for vector potential of
these two fields. We keep, ignorable in 2D case coordinate $\gz$ in
formulas, which are general for both 2- and 3D cases.

We represent the current density, which corresponds to magnetic field
$\BbB$ by its contravariant components in the similar form
\bqbl
&&
{4\gp\over c}\sqrt{g} j^a
=
F'_\gq-J'_\gz
,\\&&
{4\gp\over c}\sqrt{g} j^\gq
=
-F'_a
,\\&&
{4\gp\over c}\sqrt{g} j^\gz
=
J'_a
,\\&&
F
\equiv
F(a,\gq,\gz)
,\quad
J
\equiv
J(a,\gq,\gz)
,\eqbl
with their expression through the vector potential with the Maxwell
equations 
\bqbl
&&
F'_\gq
-J'_\gz
=
(B_\gz)'_\gq
-(B_\gq)'_\gz
,\quad
F'_a
=
(B_\gz)'_a
-(B_a)'_\gz
,\quad
J'_a
=
(B_\gq)'_a
-(B_a)'_\gq
\lbq{FJ}
,\eqbl
where
\bqbl
&&
B_a
\equiv
{g_{aa}\over\sqrt{g}}(\gY'_\gq-\gF'_\gz)
-{g_{a\gq}\over\sqrt{g}}\gY'_a
+{g_{a\gz}\over\sqrt{g}}\gF'_a
,\\&&
B_\gq
\equiv
{g_{\gq a}\over\sqrt{g}}(\gY'_\gq-\gF'_\gz)
-{g_{\gq\gq}\over\sqrt{g}}\gY'_a
+{g_{\gq\gz}\over\sqrt{g}}\gF'_a
,\\&&
B_\gz
\equiv
{g_{\gz a}\over\sqrt{g}}(\gY'_\gq-\gF'_\gz)
-{g_{\gz\gq}\over\sqrt{g}}\gY'_a
+{g_{\gz\gz}\over\sqrt{g}}\gF'_a
\lbq{Ba}
.\eqbl

Now, assuming that the pressure profile is distributed, based on
the background configuration
\bqbl
&&
p
=
p(a)
,\eqbl
we write the radial force balance equation using magnetic field of the
backgouind configuration and the current density of the auxilliary field
\bqbl
&&
4\gp p'\sqrt{g}
=
-(\gF'_{00}+\gh'_\gq)F'_a
+(\gY'_{00}+\gh'_\gz)J'_a
\lbq{rfb}
,\eqbl
Together with the condition of absence of the radial component of the
current density
\bqbl
&&
F'_\gq-J'_\gz
\lbq{ja}
,\eqbl
these two equation constitute a complete set of equations to determine
unknown fluxes $\gY$ and $\gF$. 

The magnetic configuration is in equilibrium, if the magnetic filed
$\BbB$, obtained in this manner is the same as ``background'' magnetic
field 
\bqbl
&&
\BbB
=
\bar{\BbB}
.\eqbl

If it is not the case, the coordinate system should be advanced, e.g.,
using topology of $\BbB$, or in more advanced manner, which we describe
in Section 5.

This equilibrium equations immediately reduces to 2D GSh equiation
\bqbl
&&
F'_\gq
=
0
,\eqbl
giving $F=F(a)$. Assuming that it is the same as poloidal current of the
background configuration
\bqbl
&&
F
=
{\sqrt{g}\over r^2}(\gF'_{00}+\gh'_\gq)
,\eqbl
we obtain from the radial force balance equation, familiar GSh equation
\bqbl
&&
4\gp p'\sqrt{g}
=
-{\sqrt{g}\over r^2}FF'_a
+(\gY'_{00}+\gh'_\gz)J'_a
.\eqbl

For 3D case, two equations (\rfq{rfb}) and (\rfq{ja}) with definitions
(\rfq{FJ}), (\rfq{Ba}) constitute the proper generalization of the GSh
equation. 


\section{Grad-Shafranov form of 3-D equilibrium equations}
For consideration of equilibrium equations we need expressions for the
plasma current density. They are generated by the covariant
representation of the magnetic field
\bqbl
2\gp\BbB
=
&&
B_a\na a
+B_\gq\na\gq
+B_\gz\na\gz
\equiv
-\gt'_a\na a
+J\na\gq
+F\na\gz
+\gs'_a\na a
+\gs'_\gq\na\gq
+\gs'_\gz\na\gz
\eqbl
which is are related to their contravariant counterparts as
\bqbl
-\gt'_a
+\gs'_a
=&&
g_{aa}B^a
+g_{a\gq}B^\gq
+g_{a\gz}B^\gz
,\\
J+\gs'_\gq
=&&
g_{\gq a}B^a
+g_{\gq\gq}B^\gq
+g_{\gq\gz}B^\gz
,\\
F+\gs'_\gz
=&&
g_{\gz a}B^a
+g_{\gz\gq}B^\gq
+g_{\gz\gz}B^\gz
,\\&&\\
-\gt'_a
+\gs'_a
=&&
{g_{aa}\over\sqrt{g}}(\gY'_\gq-\gF'_\gz)
-{g_{a\gq}\over\sqrt{g}}(\gY'_a+\gh'_\gz)
+{g_{a\gz}\over\sqrt{g}}(\gF'_a+\gh'_\gq)
,\\
J+\gs'_\gq
=&&
{g_{\gq a}\over\sqrt{g}}(\gY'_\gq-\gF'_\gz)
-{g_{\gq\gq}\over\sqrt{g}}(\gY'_a+\gh'_\gz)
+{g_{\gq\gz}\over\sqrt{g}}(\gF'_a+\gh'_\gq)
,\\
F+\gs'_\gz
=&&
{g_{\gz a}\over\sqrt{g}}(\gY'_\gq-\gF'_\gz)
-{g_{\gz\gq}\over\sqrt{g}}(\gY'_a+\gh'_\gz)
+{g_{\gz\gz}\over\sqrt{g}}(\gF'_a+\gh'_\gq)
.\eqbl
(Note, our $\gt'_a$ si simply the same as $\gn$ function in the
literature). The current density has the contravariant representation
\bqbl
&&
{4\gp\over c}\sqrt{g} j^a
=
F'_\gq-J'_\gz
,\\&&
{4\gp\over c}\sqrt{g} j^\gq
=
-(F+\gt'_\gz)'_a
,\\&&
{4\gp\over c}\sqrt{g} j^\gz
=
(J+\gt'_\gq)'_a
.\eqbl
In equilibrium the pressure is the function of the magnetic coordinate
$a^*$
\bqbl
&&
p
=
p(a^*)
.\eqbl
Then the scalar product $\bsj\cdot\na p$
\bqbl
&&
+a'^*_a(F'_\gq-J'_\gz)
-a'^*_\gq(F+\gt'_\gz)'_a
+a'^*_\gz(J+\gt'_\gq)'_a
=
0
\eqbl
leads to relationships
\bqbl
&&
+a'^*_a\tbF'_\gq
-a'^*_\gq\tbF'_a
-a'^*_a\tbJ'_\gz
+a'^*_\gz\tbJ'_a
=
0
,\\&&
\tbF
\equiv
F+\gt'_\gz
,\quad
\tbJ
\equiv
J+\gt'_\gq
,\\&&
\tbF
=
\tbF(a^*,\gq,\gz)
,\quad
\tbJ
=
\tbJ(a^*,\gq,\gz)
,\\&&
\tbF'_\gq
=
\tbJ'_\gz
,\\&&
\tbF
=
F_0(a^*)+u'_\gz
,\quad
\tbJ
=
J_0(a^*)+u'_\gq
,\\&&
F+\gt'_\gz
=
F_0(a^*)+u'_\gz
,\quad
J+\gt'_\gq
=
J_0(a^*)+u'_\gq
.\eqbl
Now, components of the equilibrium force balance equation can be written
as 
\bqbl
&&
4\gp p'_a\sqrt{g}
=
j^\gq B^\gz
-j^\gz B^\gq
=
-(F+\gt'_\gz)'_a(\gF'_a+\gh'_\gq)
+(J+\gt'_\gq)'_a(\gY'_a+\gh'_\gz)
,\\&&
4\gp p'_\gq\sqrt{g}
=
(J+\gt'_\gq)'_a(\gY'_\gq-\gF'_\gz)
-(F'_\gq-J'_\gz)\gF'_a
,\\&&
4\gp p'_\gz\sqrt{g}
=
-(F'_\gq-J'_\gz)\gY'_a
+(F+\gt'_\gz)'_a(\gY'_\gq-\gF'_\gz)
.\eqbl

The system of equilibrium equations for $\gh$, $\gY$, $\gs$, given the
$p(a)$ and $F(a)$
\bqbl
&&
4\gp p'_a\sqrt{g}
=
-(\gF'_a+\gh'_\gq)(B'_{\gz,a}-B'_{a,\gz})
+(\gY'_a+\gh'_\gz)(B'_{\gq,a}-B'_{a,\gq})
,\\&&
F+\gs'_\gz
=
{g_{\gz a}\over\sqrt{g}}(\gY'_\gq-\gF'_\gz)
-{g_{\gz\gq}\over\sqrt{g}}(\gY'_a+\gh'_\gz)
+{g_{\gz\gz}\over\sqrt{g}}(\gF'_a+\gh'_\gq)
,\\&&
\left(
{g_{\gz a}\over\sqrt{g}}(\gY'_\gq-\gF'_\gz)
-{g_{\gz\gq}\over\sqrt{g}}(\gY'_a+\gh'_\gz)
+{g_{\gz\gz}\over\sqrt{g}}(\gF'_a+\gh'_\gq)
 \right)'_\gq
=
\\&&
\left(
{g_{\gq a}\over\sqrt{g}}(\gY'_\gq-\gF'_\gz)
-{g_{\gq\gq}\over\sqrt{g}}(\gY'_a+\gh'_\gz)
+{g_{\gq\gz}\over\sqrt{g}}(\gF'_a+\gh'_\gq)
 \right)'_\gz
,\\&&
B_a
=
{g_{aa}\over\sqrt{g}}(\gY'_\gq-\gF'_\gz)
-{g_{a\gq}\over\sqrt{g}}(\gY'_a+\gh'_\gz)
+{g_{a\gz}\over\sqrt{g}}(\gF'_a+\gh'_\gq)
,\\&&
B_\gq
=
{g_{\gq a}\over\sqrt{g}}(\gY'_\gq-\gF'_\gz)
-{g_{\gq\gq}\over\sqrt{g}}(\gY'_a+\gh'_\gz)
+{g_{\gq\gz}\over\sqrt{g}}(\gF'_a+\gh'_\gq)
,\\&&
B_\gz
=
{g_{\gz a}\over\sqrt{g}}(\gY'_\gq-\gF'_\gz)
-{g_{\gz\gq}\over\sqrt{g}}(\gY'_a+\gh'_\gz)
+{g_{\gz\gz}\over\sqrt{g}}(\gF'_a+\gh'_\gq)
,\\&&
F+\gs'_\gz
=
B_\gz
,\\&&
J+\gs'_\gq
=
B_\gq
,\\&&
-\gt'_a
+\gs'_a
=
B_a
.\eqbl



Covariant representation of the magnetic field


In the most simple form, equilibrium equations can be written in
magnetic coordinates $a^*,\gq^i,\gz^i$. In those coordinates



 Assuming, for a moment that
they are built with the necessary details, so all the islands, which
have to be taken into account are hypotetically taken into account by
the coordinate system

In this Section we formulate

We use this function $a^*$ in order to specify the pressure profile.
\bqbl
&&
p
=
p(a^*)
,\eqbl
Depending on the accuracy in determining $a^*$ from its MDE, this
corresponds to fulfilling MDE equation for $p$ with some accuracy.

Below, in the Grad-Shaftranov formulation of 3-D equilibrium equations,
we will use (just in order to simplify the notations) the second choice,
by assuming that
\bqbl
2\gp\BbA
=
&&
\gF(a,\gq,\gz)\na\gq
+\gY(a,\gq,\gz)\na\gz
.\eqbl
In the more specific problem of finding 3-D equilibria with the
perturbed equilbrium equations, we, like in the MHD stability theory,
will use a combination of two choices 
\bqbl
&&
2\gp\BbA
=
\gh(a,\gq,\gz)\na\gq
+\gF(a,\gq,\gz)\na\gq
+\gY(a,\gq,\gz)\na\gz
,\eqbl
with $\gh(a,\gq,\gz)$ predetermined by elimination of the
$\gq$-dependence in the background field. In other words, for the
backgound field we will use the first representation, while for the
perturbed magnetic field, we will use the second choice. 

With $\gh=0$,
\bqbl
2\gp\BbA
=
&&
\gF\na\gq
+\gY\na\gz
,\eqbl
the magnetic field has contravariant components
\bqbl
2\gp\sqrt{g} B^a
=&&
2\gp\sqrt{g}\BbB\cdot\na a
=
\gY'_\gq-\gF'_\gz
,\\
2\gp\sqrt{g} B^\gq
=&&
2\gp\sqrt{g}\BbB\cdot\na\gq
=
-\gY'_a
,\\
2\gp\sqrt{g} B^\gz
=&&
2\gp\sqrt{g}\BbB\cdot\na\gz
=
\gF'_a
.\eqbl

In a form, analogous to the magnetic field, the current density can be
represented by its contravariant representation
in terms of two 3-D functions $J$ and $F$ (this representation
automatically provides for a zero divergence of $\Bsj$).

Now, components of the equilibrium force balance equation can be written
as 
\bqbl
&&
4\gp p'_a\sqrt{g}
=
j^\gq B^\gz
-j^\gz B^\gq
=
-F'_a\gF'_a
+J'_a\gY'_a
,\\&&
4\gp p'_\gq\sqrt{g}
=
J'_a(\gY'_\gq-\gF'_\gz)
-(F'_\gq-J'_\gz)\gF'_a
,\\&&
4\gp p'_\gz\sqrt{g}
=
-(F'_\gq-J'_\gz)\gY'_a
+F'_a(\gY'_\gq-\gF'_\gz)
.\eqbl
Their scalar product with $\BbB$ leads to the following relationship
\bqbl
&&
(\gY'_\gq-\gF'_\gz)p'_a
-\gY'_ap'_\gq
+\gF'_ap'_\gz
=
0
,\\&&
\gY'_\gq p'_a
-\gY'_ap'_\gq
=
\gF'_ap'_\gz
-\gF'_\gz p'_a
.\eqbl

At this point, we introduce some characteristic function $a^*$ of 3D
magnetic field. It is a general regular 3D function $a^*=a^*(a,\gq,\gz)$
and its iso-value equations
\bqbl
&&
a^*
=
const
\eqbl
generate a general toroidal geometry with islands of arbitrary
complexity. Because $a^*$ is an unique function of coordinates, those
equations does not lead to any stochasticity in iso-surfaces of
$a^*$. We connect $a^*$ with the 3D magnetic field by the magnetic
differential equation (MDE)
\bqbl
&&
\BbB\cdot\na a^*
\simeq
0
.\eqbl
Because of the above mentioned restrictions on $a^*$, this MDE cannot be
satisfied exactly. On the other hand, any prescribed accuracy can be
reached in solving this equation, e.g., with the line tracing
procedure. For the purpose of this Section, it is sufficient, that such
a function exist and can be build in principle, at least, in a very
inefficient manner. 

We use this function $a^*$ in order to specify the pressure profile.
\bqbl
&&
p
=
p(a^*)
,\eqbl
Depending on the accuracy in determining $a^*$ from its MDE, this
corresponds to fulfilling MDE equation for $p$ with some accuracy.

With this pressure profile, its MDE implies
\bqbl
&&
\gY
=
\gY(a^*,\gz)
+\gh'_\gz
,\quad
\gF
=
\gF_(a^*,\gq)
+\gh'_\gq
.\eqbl
Note, that extra dependence on the angles in $\gY(p,\gz)$ and
$\gF_(p,\gq)$ can be absorbed without loosing generality by $\gh$, which
leads to a well known fact, that in a equilibrium
\bqbl
&&
\gY
=
\gY_0(a^*)
+\gh'_\gz
,\quad
\gF
=
\gF_0(a^*)
+\gh'_\gq
,\quad
\gh
=
\gh(a,\gq,\gz)
,\eqbl
where $\gY_0$ and $\gF_0$ represent the poloidal and toroidal fluxes,
while the function $\gh$ is related to the choice of the angle variables
in flux coordinates.

The same procedure, applied to the scalar product of equilibrium
equation with the current density leads to the following equilbrium
representation for currents $F$ abd $J$
\bqbl
&&
F
=
F_0(a^*)
+\bgs'_\gz
,\quad
J
=
J_0(a^*)
+\bgs'_\gq
.\eqbl

After this, we need only the radial component of the force balance
equation 
\bqbl
&&
4\gp p'_a\sqrt{g}
=
-F'_a\gF'_a
+J'_a\gY'_a
.\eqbl
and Maxwell equations
\bqbl
&&
{4\gp\over c}\Bsj
=
\na\times\BbB
\eqbl
as
\bqbl
&&
F'_\gq-J'_\gz
=
B'_{\gz,\gq}
-B'_{\gq,\gz}
,\quad
-F'_a
=
B'_{a,\gz}
-B'_{\gz,a}
,\quad
J'_a
=
B'_{\gq,a}
-B'_{a,\gq}
\eqbl
in order to describe the 3D equilibrium.
The first component of these equations implies that 
\bqbl
&&
F
\equiv
B_\gz
-\tgs'_\gz
,\quad
J
\equiv
B_\gq
-\tgs'_\gq
\eqbl
or
\bqbl
&&
B_\gz
=
F(a^*)
+\gs'_\gz
,\quad
B_\gq
=
J(a^*)
+\gs'_\gq
,\quad
\gs
\equiv
\bgs
+\tgs
.\eqbl

The first component of these equations imply that 
\bqbl
&&
F
\equiv
B_\gz
-\tgs'_\gz
,\quad
J
\equiv
B_\gq
-\tgs'_\gq
,\quad
B_a
\equiv
\tgs'_a
.\eqbl
Only two components of these equations are independent, and it is
necessary to properly select two independent combinations of these
components. Assuming that the coordinate system has a toroidal geometry
with nested coordinate surfaces $a=const$, the radial component of those
equations, which does not contain radial derivatives is the obvious
choice. The radial force balance equation leads to the second
combination. As a result, the 3-D equilibrium equations can be written
as a pair of equations
\bqbl
&&
-F'_a
=
B'_{a,\gz}
-B'_{\gz,a}
,\\&&
J'_a
=
B'_{\gq,a}
-B'_{a,\gq}
,\\&&
4\gp p'_a\sqrt{g}
=
-F'_a\gF'_a
+J'_a\gY'_a
=
-F'_a\gF'_a
+\gY'_a(B'_{\gq,a}-B'_{a,\gq})
.\eqbl
Here, the second equation has an obvious Grad-Shafranov form, which is
the basis of the MHD equilibrium theory in tokamaks and other
asisymmetric devices.

In the expanded form these equations read as
\bqbl
F'_a
=&&
 \left(
  {g_{\gz a}\over\sqrt{g}}(\bgY'_\gq-\bgF'_\gz)
 -{g_{\gz\gq}\over\sqrt{g}}\bgY'_a
 +{g_{\gz\gz}\over\sqrt{g}}\bgF'_a
 \right)_a
-\left(
  {g_{aa}\over\sqrt{g}}(\bgY'_\gq-\bgF'_\gz)
 -{g_{a\gq}\over\sqrt{g}}\bgY'_a
 +{g_{a\gz}\over\sqrt{g}}\bgF'_a
 \right)'_\gz
,\\
4\gp p'_a\sqrt{g}
+F'_a\gF'_a
=&&
\gY'_a\left(
  {g_{\gq a}\over\sqrt{g}}(\bgY'_\gq-\bgF'_\gz)
 -{g_{\gq\gq}\over\sqrt{g}}\bgY'_a
 +{g_{\gq\gz}\over\sqrt{g}}\bgF'_a
 \right)'_a
\\&&
-\gY'_a\left(
  {g_{aa}\over\sqrt{g}}(\bgY'_\gq-\bgF'_\gz)
 -{g_{a\gq}\over\sqrt{g}}\bgY'_a
 +{g_{a\gz}\over\sqrt{g}}\bgF'_a
 \right)'_\gq
,\\
B_a
=&&
{g_{aa}\over\sqrt{g}}(\bgY'_\gq-\bgF'_\gz)
-{g_{a\gq}\over\sqrt{g}}\bgY'_a
+{g_{a\gz}\over\sqrt{g}}\bgF'_a
,\\
B_\gq
=&&
{g_{\gq a}\over\sqrt{g}}(\bgY'_\gq-\bgF'_\gz)
-{g_{\gq\gq}\over\sqrt{g}}\bgY'_a
+{g_{\gq\gz}\over\sqrt{g}}\bgF'_a
,\\
B_\gz
=&&
{g_{\gz a}\over\sqrt{g}}(\bgY'_\gq-\bgF'_\gz)
-{g_{\gz\gq}\over\sqrt{g}}\bgY'_a
+{g_{\gz\gz}\over\sqrt{g}}\bgF'_a
.\eqbl
#endif

#endif
#ifndef mzl_System_esc.c
#ifdef Tbl_UnusedID
  extern int ESmemlev;	/*         :esc.c */
  void ESexit();	/* .mzl_Esc:esc.c */
  void main();		/* .mzl_Esc:esc.c */
#endif
  Undef ESDeInitEsc();		/* NO prototype */
  Systm exit();			/* NO prototype */
  Undef InitConstants();	/* NO prototype */
  Undef ESInitPlGeomInt();	/* NO prototype */
  Undef ESReInit1DPlV();	/* NO prototype */
  Undef ESReInit2DTPlV();	/* NO prototype */
  Undef ESInitTFC();		/* NO prototype */
  Undef ESInit3DSpl();		/* NO prototype */
  Undef ESInitVacMF();		/* NO prototype */
  Undef ESInit1DPlV();		/* NO prototype */
  Undef ESInit2DTPlV();		/* NO prototype */
  Undef ESInitPlGeom();		/* NO prototype */
  Undef ESReInitMetrTnsrCS();	/* NO prototype */
  Undef ESA2RefRZ();		/* NO prototype */
#ifdef Tbl_Esc
  Undef ESDeInitEsc();		/* NO prototype */
  Undef exit();			/* NO prototype */
  Undef ESInitPlGeomInt();	/* NO prototype */
  Undef ESReInit1DPlV();	/* NO prototype */
  Undef ESReInit2DTPlV();	/* NO prototype */
  Undef ESInitTFC();		/* NO prototype */
  Undef ESInit3DSpl();		/* NO prototype */
  Undef ESInitVacMF();		/* NO prototype */
  Undef ESInit1DPlV();		/* NO prototype */
  Undef ESInit2DTPlV();		/* NO prototype */
  Undef ESInitPlGeom();		/* NO prototype */
  Undef ESReInitMetrTnsrCS();	/* NO prototype */
  Undef ESA2RefRZ();		/* NO prototype */
  Undef ESDeInitEsc();		/* NO prototype */
#endif
#endif
#ifndef mzl_Esc
extern int ESmemlev;	/* undefined */
void ESexit(i)
  int i;	/*  */
{
  Undef ESDeInitEsc();
  Undef exit();
  /*
   */
#ifdef Doc_ESexit

#endif
}
void main()
{
  Undef InitConstants();
#ifndef mzl_Esc
#ifndef blb_Machine
#ifndef mzl_Esc
  Undef ESInitPlGeomInt();
  Undef ESReInit1DPlV();
  Undef ESReInit2DTPlV();
#ifndef stg_InitTFC
  Undef ESInitTFC();
#endif
#ifndef stg_SplCoord
  Undef ESInit3DSpl();
#endif
#ifndef stg_VacMF
  Undef ESInitVacMF();
#endif
  Undef ESInit1DPlV();
  Undef ESInit2DTPlV();
#ifndef stg_InitGeom
  Undef ESInitPlGeom();
#endif
  Undef ESReInitMetrTnsrCS();
#ifndef stg_RefRTZ
  Undef ESA2RefRZ();
#endif
#endif
#endif
  Undef ESDeInitEsc();
#endif
  /*
   */
#ifdef Doc_main

#endif
}
#endif
#endif

#undef Doc_Cb_Structure
#ifdef Blb_esc.c
Blb_esc.c{
  mzl_Esc{
    void main(){
      mzl_Esc{
        blb_Machine{
          mzl_Esc{
            stg_InitTFC{
            }
            stg_SplCoord{
            }
            stg_VacMF{
            }
            stg_InitGeom{
            }
            stg_RefRTZ{
            }
          }
        }
      }
    }
  }
}
#endif

#undef Doc_Table_Of_Content
#ifndef Blb_esc.c
		PS p= -1;
#ifndef mzl_Esc
		PS p=  1;
void ESexit();	PS p=  1;
#ifndef blb_main
void main();	PS p=  1;
#ifndef mzl_Esc
		PS p=  1;
#ifndef blb_Machine
		PS p=  1;
#ifndef mzl_Esc
		PS p=  1;
#ifndef stg_InitTFC
		PS p=  1;
#endif
#ifndef stg_SplCoord
		PS p=  1;
#endif
#ifndef stg_VacMF
		PS p=  1;
#endif
#ifndef stg_InitGeom
		PS p=  1;
#endif
#ifndef stg_RefRTZ
		PS p=  1;
#endif
#endif
#endif
#endif
#endif
#endif
#endif
