#ifdef Doc_esc.h

\begin{verbatim}
typedef struct RadCoord{
  int kk[ESND];
  double ad[ESND];
  double xd[ESND];
  double *x0; /* x(a) as a function of active equilibrium coordinate */
  double *x1; /* x'_a */
  double *x2; /* x''_{aa} */
  double *a0; /* a(x) active equilibrium coordinate as a function of x */
  double *a1; /* a'_x */
  double *a2; /* a''_{xx} */
  double X;
  int io;
  int nd;	/* Number of points */
  char Nm[8];
}RadCoord;
\end{verbatim}
#endif

#ifndef mzl_PL
#ifdef Doc_PL
\section{Plasma profiles}
Relation between SESC normalized profiles and dimensional is shown for
``Tokamak'' units $\rm [MJ/m^3],\ V\cdot Sec,\ MA,\ T,\ m$ 
\bqbl
&&
\bsp\equiv0.4\gp p
,\quad
\bgY\equiv{\gY\over2\gp}
,\quad
\bgF\equiv{\gF\over2\gp}
,\quad
\bbF\equiv0.2F
,\quad
\bbJ\equiv0.2J
,\quad
\bsj\equiv0.4\gp j
,\quad
F_s={\bbF'\over\bgY'}
,\quad
P_s={\bsp'\over\bgY'}
.\eqbl
Equilibrium magnetic and electric fields and fluxes
\bqbl
&&
B_p={\sqrt{g_{22}}\over rD}\bgY'
,\quad
B_{tor}={\bbF\over r}
,\quad
\bgF'={a\over R_0}u_0\bbF
,\quad
E_2=-{\pa\bgF\over\pa t}-{\pa\bgf^E\over\pa\gt}
,\quad
E_3=-{\bar{\pa\gY}\over\pa t}
,\quad
q=-{au_0\bbF\over R_0\bgY'}
.\eqbl
Ohm's law
\bqbl
&&
{\BbB\cdot \BbE}={1\over\gs_{||}}{\bf B\cdot j}
,\quad
\bgF'{\pa\bgY\over\pa t}
-\bgY'{\pa\bgF\over\pa t}
=
-{1\over0.4\gp\gs_{||}}\left(
\bbF\bbJ'
+\left<{g_{22}\over rD}\right>\bgY'\bbF'\right)
,\quad
\bbJ'=
-\left<{g_{22}\over rD}\bgY'\right>'
.\eqbl
Averaged metric coefficients
\bqbl
&&
u_0\equiv\left<{R_0D\over ar}\right>
,\quad
v_0\equiv \left<{Dr\over aR_0}-{DR_0\over ar}\right>
.\eqbl
Equilibrium current density
\bqbl
&&
0.4\gp j_{tor}=\bsj_s{R_0\over r}
+\bsj_p\left({r\over R_0}-{R_0\over r}\right)
,\quad
\bsj_p=R_0P_s 
,\quad
\bsj_s={1\over R_0}\bbF F_s+R_0P_s
,\\&&
\bbF\bbF'=R_0\left(\bsj_s-\bsj_p\right)\bgY'
,\quad
\bbJ'=
-\left<{g_{22}\over rD}\bgY'\right>'
,\eqbl
where $\bsj_s\equiv 0.4\gp j_{G-Sh}$ is a conductivity part,
$\bsj_p\equiv0.4\gp j_{PfSh}$ is a Pfirsh-Shlutter part of
the current density. 

Parallel current density
\bqbl
&&
-{\pa\bgY\over\pa t}
+{\bgY'\over\bgF'}{\pa\bgF\over\pa t}
=
{R_0\over\gs_{||}}j_\parallel
,\quad
0.4\gp j_\parallel
\equiv
\bsj_s+{v_0\over u_0}\bsj_p
+\left<{g_{22}\over arD}\right>{\bgY'\bbF'\over u_0\bbF}
,\\&&
\bsj_\parallel=
\bsj_s+{v_0\over u_0}\bsj_p
+\left<{R_0g_{22}\over arD}\right>
{\bgY'^2\over u_0\bbF^2}\left(\bsj_s-\bsj_p\right)
,\\&&
\bsj'_\parallel=
\bsj'_s
+{v_0\over u_0}\bsj'_p
+\left<{R_0g_{22}\over arD}\right>
{\bgY'^2\over u_0\bbF^2}\left(\bsj'_s-\bsj'_p\right)
+\left({v_0\over u_0}\right)'\bsj_p
+\left[\left<{R_0g_{22}\over arD}\right>
{\bgY'^2\over u_0\bbF^2}\right]'\left(\bsj_s-\bsj_p\right)
.\eqbl

TRANSP combination $j_B=<{\bf j\cdot B}>_V$
\bqbl
&&
j_B\equiv 0.4\gp{<{\bf jB}rD>\over<rD>}=
{1\over R_0}\left<{g_{22}\over arD}\right>{\bgY'\bbF'\over u_0+v_0}
+{\bbF\over R_0}{u_0j_s+v_0j_p\over u_0+v_0} 
.\eqbl

Safety factor
\bqbl
&&
q=-{au_0\bbF\over R_0\bgY'}
,\quad
{q'\over q}=
{1\over a}
+{u'_0\over u_0}
+{\bbF'\over\bbF}
-{\bgY''\over \bgY'}
,\quad
\left[a^2\left<{g_{22}\over arD}\right>{u_0\bbF\over R_0q}\right]'
=
a\bsj_su_0
+a\bsj_pv_0
.\eqbl
Pitch angle
\bqbl
&&
i={B_z\over B_{tor}}=
-{\sqrt{g_{22}}\bgY'\over D\bbF}
=
-a{\bgY'\over a\bbF}\sqrt{R_0{g_{22} \over arDu}}
,\quad
{i'\over i}=
{\bgY''\over \bgY'}
-{\bbF'\over\bbF}
+\left({g_{22}\over arD}\right)'{arD\over2g_{22}}
-{u'\over2u}
.\eqbl
Linearized GSh equation
\bqbl
&&
 {\pa\over\pa a}{g_{\gt\gt}\over rD}{\pa\gY\over\pa a}
-{\pa\over\pa a}{g_{a\gt}\over rD}{\pa\gY\over\pa\gt}
-{\pa\over\pa \gt}{g_{a\gt}\over rD}{\pa\gY\over\pa a}
+{\pa\over\pa \gt}{g_{aa}\over rD}{\pa\gY\over\pa\gt}
=
-a(\bsj_s+\gd \bsj_s)u
-a(\bsj_p+\gd \bsj_p)v
-{a\bsj'_su+a\bsj'_pv\over\bgY'}\gY
,\\&&
\left[\left<{g_{\gt\gt}\over rD}\right>\bgY'\right]'
=
-a\bsj_su_0
-a\bsj_pv_0
,\quad
\gY\equiv\bgY(a)+\gy(a,\gt)
.\eqbl
TRANSP combination $j_B=<{\bf j\cdot B}>_V$
\bqbl
&&
j_B\equiv 0.4\gp{<{\bf jB}rD>\over<rD>}=
{1\over R_0}\left<{g_{22}\over arD}\right>{\bgY'\bbF'\over u_0+v_0}
+{\bbF\over R_0}{u_0j_s+v_0j_p\over u_0+v_0} 
.\eqbl
#endif
#endif

#undef Doc_Cb_Structure
#ifdef Blb_esc.h
Blb_esc.h{
  mzl_PL{
  }
}
#endif

#undef Doc_Table_Of_Content
#ifndef Blb_esc.h
	PS p= -1;
#ifndef mzl_PL
	PS p=  1;
#endif
#endif
