#ifndef Blb_escA2R.c
#ifdef Doc_escA2R.c
\section{Reference 3-D Magnetic Coordinates (RMC) $a,\gf,\gt$}
Following notations are used to define functions of different arguments
\bqbl
&&
\bgF_{00}
\equiv
\bgF_{00}(a)
,\quad
\bgF_{\til 0}
\equiv
\bgF_{\til 0}(a,\gf)
,\quad
<\bgF_{\til 0}>_\gf
=
0
,\quad
\bgF_{\cup 0}
\equiv
\bgF_{00}
+\bgF_{\til 0}
,\quad
,\\&&
\bgY_{0\til}
\equiv
\bgY_{0\til}(a,\gt)
,\quad
<\bgY_{0\til}>_\gt
=
0
,\quad
\bgY_{\til\til}
\equiv
\bgY_{\til\til}(a,\gf,\gt)
,\quad
<\bgY_{\til\til}>_\gf
=
<\bgY_{\til\til}>_\gt
=
0
.\eqbl
In order to distinguish between physical (toroidal) $\gf$-component of 
the vector and covariant $\gf$-component, we use index $t$ for physical 
(toroidal) $\gf$-component.

Curvilinear coordinates are parameterized in ESC as
\bqbl
&&
r
=
r(a,\gf,\gt)
=
R_0(\gf)
+2ar^c_{\cup1}\cos\gt
+2ar^s_{\cup1}\sin\gt
+a^2x_{\cup0}
+2a^2x^c_{\cup2}\cos2\gt
+2a^2x^s_{\cup2}\sin2\gt
+a^3x
,\\&&
z
=
z(a,\gf,\gt)
=
Z_0(\gf)
+a^2y_{\cup0}
+ab_{\til0}\sin\gt
.\eqbl
Covariant basic vectors and the metric tensor
\bqbl
&&
\Bse_a
=
r'_a\Bse_r
+z'_a\Bse_z
,\quad
\Bse_\gt
=
r'_\gt\Bse_r
+z'_\gt\Bse_z
,\quad
\Bse_\gf
=
r'_\gf\Bse_r
+z'_\gf\Bse_z
+r\Bse_t
,\\&&
g_{aa}
=
r'^2_a
z'^2_a
,\quad
g_{a\gt}
=
r'_ar'_\gt
+z'_az'_\gt
,\quad
g_{\gt\gt}
=
r'^2_\gt
+z'^2_\gt
,\quad
g_{a\gf}
=
r'_ar'_\gf
+z'_az'_\gf
,\quad
g_{\gt\gf}
=
r'_\gt r'_\gf
+z'_\gt z'_\gf
,\\&&
g_{\gf\gf}
=
r^2
+r'^2_\gf
+z'^2_\gf
,\quad
D
\equiv
D_{\gt a}
=
r'_a{z'_\gt\over a}
-z'_a{r'_\gt\over a}
,\quad
D_{\gf\gt}
\equiv
z'_\gf{r'_\gt\over a}
-r'_\gf{z'_\gt\over a}
,\quad
D_{a\gf}
\equiv
 r'_\gf z'_a
-r'_az'_\gf
.\eqbl
Transformation of gradient vectors
\bqbl
&&
\Bse_r
=
 r'_a\na a
+r'_\gf\na\gf
+r'_\gt\na\gt
,\quad
\Bse_z
=
 z'_a\na a
+z'_\gf\na\gf
+z'_\gt\na\gt
,\\&&
arD\na a
=
rz'_\gt\Bse_r
-rr'_\gt\Bse_z
+aD_{\gf\gt}\Bse_t
,\quad
rD\na\gf
=
D\Bse_t
,\\&&
arD\na\gt
=
 rr'_a\Bse_z
-rz'_a\Bse_r
+D_{a\gf}\Bse_t
.\eqbl
First derivatives of coordinates
\bqbl
&&
r
=
R_0
+2ar^c_{\cup1}\cos\gt
+2ar^s_{\cup1}\sin\gt
+a^2x_{\cup0}
+2a^2x^c_{\cup2}\cos2\gt
+2a^2x^s_{\cup2}\sin2\gt
+a^3x
,\\&&
r'_a
=
 2(ar^c_{\cup1})'_a\cos\gt
+2(ar^s_{\cup1})'_a\sin\gt
+(a^2x_{\cup0})'_a
+2(a^2x^c_{\cup2})'_a\cos2\gt
+2(a^2x^s_{\cup2})'_a\sin2\gt
+(a^3x)'_a
,\\&&
{r'_\gt\over a}
=
-2r^c_{\cup1}\sin\gt
+2r^s_{\cup1}\cos\gt
-4ax^c_{\cup2}\sin2\gt
+4ax^s_{\cup2}\cos2\gt
+a^2x'_\gt
,\\&&
r'_\gf
=
R'_{0,\gf}
+2ar'^c_{\cup1,\gf}\cos\gt
+2ar'^s_{\cup1,\gf}\sin\gt
+a^2x'_{\cup0,\gf}
+2a^2x'^c_{\cup2,\gf}\cos2\gt
+2a^2x'^s_{\cup2,\gf}\sin2\gt
+a^3x'_\gf
,\\&&
z
=
Z_0
+a^2y_{\cup0}
+ab\sin\gt
,\\&&
z'_a
=
(a^2y_{\cup0})'_a
+(ab)'_a\sin\gt
,\quad
{z'_\gt\over a}
=
b\cos\gt
,\quad
z'_\gf
=
Z'_{0,\gf}
+a^2y'_{\cup0,\gf}
+ab'_\gf\sin\gt
.\eqbl
Spline representation
\bqbl
&&
g(\gt)=Tg_0+tg_1
+[(T^3-T)g''_0+(t^3-t)g''_1]{h^2\over6}
,\quad
h\equiv \gt_1-\gt_0
,\\&&
\int_{\gt_0}^\gt g(\gt)d\gt=
{h\over2}
\left\{
(1-T^2)g_0
+t^2g_1
-t^2{h^2\over12}
\left[(1+T)^2g''_0+(2-t^2)g''_1\right]
\right\}
,\\&&
\int_{\gt_0}^{\gt_1} g(\gt)d\gt=
{h\over2}
\left[
g_0
+g_1
-{h^2\over12}
(g''_0+g''_1)
\right]
,\quad
T\equiv{\gt_1-\gt\over h}
,\quad
t\equiv{\gt-\gt_0\over h}
,\\&&
g'(\gt)={g_1-g_0\over h}
+[(3t^2-1)g''_1-(3T^2-1)g''_0]{h\over6}
,\quad
g''(\gt)=Tg''_0+tg''_1
.\eqbl
First derivatives in the nodes
\bqbl
&&
g'_0={g_1-g_0\over h}-[g''_1+2g''_0]{h\over6}
,\quad
g'_1={g_1-g_0\over h}+[2g''_1+g''_0]{h\over6}
.\eqbl

\section{Representation of the vector potential}
Relations between covariant components of the vector potential and 
its physical components 
\bqbl
&&
A_a
=
A_rr'_a
+A_zz'_a
,\quad
\gh
\equiv
A_a
-U'_{\cup\cup,a}
,\\&&
A_\gt
=
A_rr'_\gt
+A_zz'_\gt
,\quad
-\bgF_{00}
-\bgF_{\til0}
\equiv
A_\gt
-U'_{\cup\til,\gt}
,\\&&
A_\gf
=
rA_t
+A_rr'_\gf
+A_zz'_\gf
,\quad
\bgY_{00}
+\bgY_{\cup\til}
\equiv
A_\gf
-U'_{\til\cup,\gf}
.\eqbl
Physical components of magnetic field
\bqbl
&&
rB_r
=
A'_{z,t}
-rA'_{t,z}
,\quad
B_t
=
A'_{r,z}
-A'_{z,r}
,\quad
rB_z
=
(rA_t)'_r
-A'_{r,t}
\eqbl
and contravariant components
\bqbl
&&
\sqrt{g}B^a
=
A'_{\gt,\gf}
-A'_{\gf,\gt}
=
-\bgF'_{\til0,\gf}
-\bgY'_{\cup\til,\gt}
=
a\left[
  \left(rB_r-B_tr'_\gf\right){z'_\gt\over a}
 +\left(B_tz'_\gf-rB_z\right){r'_\gt\over a}
\right]
,\\&&
\sqrt{g}B^\gf
=
A'_{a,\gt}
-A'_{\gt,a}
=
\bgF'_{00}
+\bgF'_{\til0,a}
+\gh'_\gt
=
aDB_t
,\\&&
\sqrt{g}B^\gt
=
A'_{\gf,a}
-A'_{a,\gf}
=
\bgY'_{00}
+\bgY'_{\cup\til,a}
-\gh'_\gf
=
 (rB_z-B_tz'_\gf)r'_a
+(B_tr'_\gf-rB_r)z'_a
.\eqbl
Poloidal component $A_\gt$ determines toroidal flux $\bgF_{\cup0}$ and 
$U_{\cup\til}$
\bqbl
&&
A_\gt
=
\int^a_0(
  A_rr'_\gt
 +A_zz'_\gt
 )'_ada
=
\int^a_0(A_rr'_a+A_zz'_a)'_\gt da
-\int^a_0aB_tDda
,\\&&
\bgF_{00}
+\bgF_{\til0}
=
{1\over2\gp}\int_0^a ada\oint B_tDd\gt
=
-{1\over2\gp}\oint (A_r r'_\gt+A_z z'_\gt)d\gt
,\quad
\bgF'_{00}
+\bgF'_{\til0,a}
=
{a\over2\gp}\oint B_tDd\gt
,\\&&
U_{\cup\cup}
=
\int^a_0(A_rr'_a+A_zz'_a)da
-\int^a_0ada\left[\int^\gt_0d\gt(B_tD)_{\cup\til}\right]_{\cup\til}
+u_{\cup0}
.\eqbl
Toroidal component of the vector potential determines poloidal flux 
$\bgY_{0\cup}$ and $u_{\cup,0}$
\bqbl
&&
A_\gf
=
rA_t
+A_rr'_\gf
+A_zz'_\gf
=
\int^a_0(rB_zr'_a-rB_rz'_a)da
+\int^a_0(A_rr'_a+A_zz'_a)'_\gf da
+\int^a_0B_tD_{a\gf}da
,\\&&
\bgY_{00}
+\bgY_{\cup\til}
=
\int^a_0(rB_zr'_a-rB_rz'_a+B_tD_{a\gf})da
+\int^a_0ada\left[\int^\gt_0d\gt(B_tD)_{\cup\til}\right]'_{\til\til,\gf}
-u'_{\cup0,\gf}
,\\&&
\bgY_{00}
=
-{1\over4\gp^2}\int^a_0da\oint\oint(rB_zr'_a-rB_rz'_a+B_tD_{a\gf})d\gt d\gf
,\\&&
\bgY_{\cup\til}
=
\int^a_0(rB_zr'_a-rB_rz'_a+B_tD_{a\gf})_{\cup\til}da
+\int^a_0ada\left[\int^\gt_0d\gt(B_tD)_{\cup\til}\right]'_{\til\til,\gf}
,\\&&
u_{\cup0,\gf}
=
\int^a_0(rB_zr'_a-rB_rz'_a+B_tD_{a\gf})_{\til0}da
.\eqbl
Radial component of the vector potential
\bqbl
&&
\gh
=
 a\left[\int^\gt_0d\gt(B_tD)_{\cup\til}\right]_{\cup\til}
-a\left[\int^\gt_0d\gt(B_tD)_{\cup\til}\right]_{\cup\til,\gt=0}
-\int^\gf_0(rB_zr'_a-rB_rz'_a+B_tD_{a\gf})_{\til0}d\gf
.\eqbl

#endif
#ifndef mzl_System_escA2R.c
#ifdef Tbl_UnusedID
  extern double cr12;		/*                       :escA2R.c */
  extern double cgp;		/*                       :escA2R.c */
  extern double cgp_4;		/*                       :escA2R.c */
  extern double cgm0;		/*                       :escA2R.c */
  extern double crgm0;		/*                       :escA2R.c */
  extern double *a3a;		/*                       :escA2R.c */
  extern int *ESnF;		/*                       :escA2R.c */
  extern int *ESmF;		/*                       :escA2R.c */
  extern int *ESkF;		/*                       :escA2R.c */
  extern int ESNf;		/*                       :escA2R.c */
  extern int ESNf1;		/*                       :escA2R.c */
  extern double *cs2;		/*                       :escA2R.c */
  extern double *sn2;		/*                       :escA2R.c */
  extern double *dra;		/*                       :escA2R.c */
  extern double *drgt;		/*                       :escA2R.c */
  extern double *dza;		/*                       :escA2R.c */
  extern double *dzgt;		/*                       :escA2R.c */
  extern int ESLt;		/*                       :escA2R.c */
  extern int ESNLt1;		/*                       :escA2R.c */
  extern double *csLT;		/*                       :escA2R.c */
  extern double *snLT;		/*                       :escA2R.c */
  extern double ESgY2a1a;	/*                       :escA2R.c */
  int ESReInit3APTSpl();	/*             .mzl_ESPlV:escA2R.c */
  int ESDeInit3APTSpl();	/*             .mzl_ESPlV:escA2R.c */
  int ESDeInitgXcs();		/*             .mzl_ESPlV:escA2R.c */
  int splA1a();			/*             .mzl_ESPlV:escA2R.c */
  int splAA();			/*             .mzl_ESPlV:escA2R.c */
  int splAA2();			/*             .mzl_ESPlV:escA2R.c */
  int ESSetSplA();		/*             .mzl_ESPlV:escA2R.c */
  int splRA();			/*             .mzl_ESPlV:escA2R.c */
  int splRA2();			/*             .mzl_ESPlV:escA2R.c */
  int f2splP();			/*             .mzl_ESPlV:escA2R.c */
  int DeInitf2splP();		/*             .mzl_ESPlV:escA2R.c */
  int f2splT();			/*             .mzl_ESPlV:escA2R.c */
  int DeInitf2splT();		/*             .mzl_ESPlV:escA2R.c */
  int ESInitSplAPT();		/*             .mzl_ESPlV:escA2R.c */
  int ESGetgFPlV();		/*             .mzl_ESPlV:escA2R.c */
  int ES3DCoord2Spl();		/*             .mzl_ESPlV:escA2R.c */
  int ESAextBext2Spl();		/*             .mzl_ESPlV:escA2R.c */
  int ESNormDispl();		/* .stg_NrmDspl.mzl_ESPlV:escA2R.c */
  int ESgP2gF();		/* .stg_NrmDspl.mzl_ESPlV:escA2R.c */
#endif
  Ignor void;
  Ignor double;
  Ignor char;
  Ignor NULL;
  Systm free();
  Systm malloc();
  Systm printf();
  Systm fabs();
  Undef int;			/* undefined */
  Undef ReInitArray();		/* NO prototype */
  Undef FailureAlarm();		/* NO prototype */
  Undef ESexit();		/* NO prototype */
  Undef inv3x3();		/* NO prototype */
  Undef ludcmp();		/* NO prototype */
  Undef lubksb();		/* NO prototype */
  Undef ESSpl2ArBtAtAz();	/* NO prototype */
  Undef ESSpl2BrBtBz();		/* NO prototype */
  Undef ESSpl2BrBtBzBrrBtrBzr();/* NO prototype */
  Undef Scale2D();		/* NO prototype */
  Undef Plot2d();		/* NO prototype */
  Undef splr1();		/* NO prototype */
  Undef cos();			/* NO prototype */
  Undef sin();			/* NO prototype */
  Undef CbFlush();		/* NO prototype */
  Undef f2spl();		/* NO prototype */
  Undef ESRealGeom();		/* NO prototype */
  extern int ESnAPT;		/* External */
  extern int ESNt1;		/* External */
  extern int ESnAT;		/* External */
  extern double *ESgF;		/* External */
  extern double *ESgF1a;	/* External */
  extern double *ESgF3a;	/* External */
  extern double *ESgY;		/* External */
  extern double *ESgY1a;	/* External */
  extern double *ESgY1a2t;	/* External */
  extern double *ESgY3a;	/* External */
  extern double *ESgi;		/* External */
  extern int ESNa1;		/* External */
  extern double *ESgi1a;	/* External */
  extern double *ESgi2a;	/* External */
  extern double *ESgF0;		/* External */
  extern double *ESgF01a;	/* External */
  extern double *ESgY0;		/* External */
  extern double *ESgY01a;	/* External */
  extern double *ESgY02a;	/* External */
  extern double *ESbY0;		/* External */
  extern double *ESbY01a;	/* External */
  extern double *ESbY02a;	/* External */
  extern int ESNp1;		/* External */
  extern double *ESFaux;	/* External */
  extern double *ESd2Faux;	/* External */
  extern int ESmemlev;		/* External */
  extern double cr2;		/* External */
  extern double cr6;		/* External */
  extern int ESNa;		/* External */
  extern double *a;		/* External */
  extern int ESNp;		/* External */
  extern int ESNt;		/* External */
  extern double *ESgt;		/* External */
  extern double *gf1T;		/* External */
  extern double *aa;		/* External */
  extern double cr3;		/* External */
  extern double cr4;		/* External */
  extern double *bT;		/* External */
  extern double *R0T;		/* External */
  extern double *rcT;		/* External */
  extern double *Z0T;		/* External */
  extern double *rsT;		/* External */
  extern int ESFp1;		/* External */
  extern double *cs1;		/* External */
  extern double *sn1;		/* External */
  extern double ESgFPlV;	/* External */
  extern double ESgFPlV1a;	/* External */
  extern double *bT1a;		/* External */
  extern int ESnAF;		/* External */
  extern double *rcT1t;		/* External */
  extern double *rsT1t;		/* External */
  extern int ESNLt;		/* External */
  extern int ESnAP;		/* External */
  extern double *rcT2a;		/* External */
  extern double *rsT2a;		/* External */
  extern double *rcT1a;		/* External */
  extern double *rsT1a;		/* External */
  extern double cr2gp;		/* External */
  extern double ESgimn;		/* External */
  extern double ESgimx;		/* External */
  extern int ESLt0;		/* External */
  extern double c2gp;		/* External */
  extern double *ESgh;		/* External */
  extern double *cs1T;		/* External */
  extern double *sn1T;		/* External */
  extern double *drsT;		/* External */
  extern double *drcT;		/* External */
  extern double *r;		/* External */
  extern double *z;		/* External */
  extern double *rT;		/* External */
  extern double *zT;		/* External */
  extern int ESFp;		/* External */
  extern double *drcT2a;	/* External */
  extern double *drsT2a;	/* External */
  extern double *drcT1a;	/* External */
  extern double *drsT1a;	/* External */
  extern double *bT2a;		/* External */
  extern int spl_p();		/* External() */
  int ESP2F();			/* No prototype */
#ifdef Tbl_ESmain
#endif
#ifdef Tbl_1Dcore
#endif
#ifdef Tbl_2Dcore
#endif
#ifdef Tbl_3Dcore
#endif
#ifdef Tbl_ESPlV
  Undef int;			/* undefined */
  Undef ReInitArray();		/* NO prototype */
  Undef FailureAlarm();		/* NO prototype */
  Undef ESexit();		/* NO prototype */
  Undef ReInitArray();		/* NO prototype */
  Undef FailureAlarm();		/* NO prototype */
  Undef ESexit();		/* NO prototype */
  Undef inv3x3();		/* NO prototype */
  Undef ludcmp();		/* NO prototype */
  Undef lubksb();		/* NO prototype */
  Undef inv3x3();		/* NO prototype */
  Undef ludcmp();		/* NO prototype */
  Undef lubksb();		/* NO prototype */
  Undef ESSpl2ArBtAtAz();	/* NO prototype */
  Undef ESSpl2BrBtBz();		/* NO prototype */
  Undef ESSpl2BrBtBzBrrBtrBzr();/* NO prototype */
  Undef Scale2D();		/* NO prototype */
  Undef Plot2d();		/* NO prototype */
  Undef splr1();		/* NO prototype */
  Undef cos();			/* NO prototype */
  Undef sin();			/* NO prototype */
  Undef CbFlush();		/* NO prototype */
  Undef f2spl();		/* NO prototype */
  Undef ESRealGeom();		/* NO prototype */
  extern int ESnAPT;		/* External() */
  extern int ESNt1;		/* External() */
  extern int ESnAT;		/* External() */
  extern double *ESgF;		/* External() */
  extern double *ESgF1a;	/* External() */
  extern double *ESgF3a;	/* External() */
  extern double *ESgY;		/* External() */
  extern double *ESgY1a;	/* External() */
  extern double *ESgY1a2t;	/* External() */
  extern double *ESgY3a;	/* External() */
  extern double *ESgi;		/* External() */
  extern int ESNa1;		/* External() */
  extern double *ESgi1a;	/* External() */
  extern double *ESgi2a;	/* External() */
  extern double *ESgF0;		/* External() */
  extern double *ESgF01a;	/* External() */
  extern double *ESgY0;		/* External() */
  extern double *ESgY01a;	/* External() */
  extern double *ESgY02a;	/* External() */
  extern double *ESbY0;		/* External() */
  extern double *ESbY01a;	/* External() */
  extern double *ESbY02a;	/* External() */
  extern int ESNp1;		/* External() */
  extern double *ESFaux;	/* External() */
  extern double *ESd2Faux;	/* External() */
  extern int ESmemlev;		/* External() */
  extern double *ESbY02a;	/* External() */
  extern double *ESbY01a;	/* External() */
  extern double *ESbY0;		/* External() */
  extern double *ESgY02a;	/* External() */
  extern double *ESgY01a;	/* External() */
  extern double *ESgY0;		/* External() */
  extern double *ESgF01a;	/* External() */
  extern double *ESgF0;		/* External() */
  extern double *ESgi2a;	/* External() */
  extern double *ESgi1a;	/* External() */
  extern double *ESgi;		/* External() */
  extern double *ESgY3a;	/* External() */
  extern double *ESgY1a2t;	/* External() */
  extern double *ESgY1a;	/* External() */
  extern double *ESgY;		/* External() */
  extern double *ESgF3a;	/* External() */
  extern double *ESgF1a;	/* External() */
  extern double *ESgF;		/* External() */
  extern int ESNa1;		/* External() */
  extern int ESmemlev;		/* External() */
  extern int ESNa1;		/* External() */
  extern double cr2;		/* External() */
  extern double cr6;		/* External() */
  extern int ESNa;		/* External() */
  extern int ESNa1;		/* External() */
  extern int ESNa1;		/* External() */
  extern double cr2;		/* External() */
  extern double cr6;		/* External() */
  extern int ESNa;		/* External() */
  extern int ESNa1;		/* External() */
  extern int ESNa;		/* External() */
  extern double cr6;		/* External() */
  extern int ESNa;		/* External() */
  extern double *a;		/* External() */
  extern int ESNp1;		/* External() */
  extern int ESNp;		/* External() */
  extern int ESNt1;		/* External() */
  extern int ESNt;		/* External() */
  extern int ESNp1;		/* External() */
  extern double *ESgt;		/* External() */
  extern double cr6;		/* External() */
  extern int ESmemlev;		/* External() */
  extern int ESNp;		/* External() */
  extern int ESNt1;		/* External() */
  extern double *gf1T;		/* External() */
  extern double cr6;		/* External() */
  extern int ESmemlev;		/* External() */
  extern int ESNt;		/* External() */
  extern double cr6;		/* External() */
  extern double *a;		/* External() */
  extern double cr2;		/* External() */
  extern double *aa;		/* External() */
  extern double cr3;		/* External() */
  extern double cr4;		/* External() */
  extern int ESNt;		/* External() */
  extern double *gf1T;		/* External() */
  extern double *ESgt;		/* External() */
  extern int ESNp;		/* External() */
  extern double *bT;		/* External() */
  extern int ESNa;		/* External() */
  extern double *R0T;		/* External() */
  extern double *rcT;		/* External() */
  extern double *Z0T;		/* External() */
  extern double *rsT;		/* External() */
  extern int ESFp1;		/* External() */
  extern int ESNa1;		/* External() */
  extern int ESNp;		/* External() */
  extern double *cs1;		/* External() */
  extern double *sn1;		/* External() */
  extern double ESgFPlV;	/* External() */
  extern double ESgFPlV1a;	/* External() */
  extern double cr2;		/* External() */
  extern int ESNa;		/* External() */
  extern double *a;		/* External() */
  extern double *aa;		/* External() */
  extern int ESNt;		/* External() */
  extern double *R0T;		/* External() */
  extern double *Z0T;		/* External() */
  extern int ESNt1;		/* External() */
  extern double *bT1a;		/* External() */
  extern int ESNa1;		/* External() */
  extern double *bT;		/* External() */
  extern int ESFp1;		/* External() */
  extern double *rcT;		/* External() */
  extern int ESnAF;		/* External() */
  extern double *rcT1t;		/* External() */
  extern double *rsT;		/* External() */
  extern double *rsT1t;		/* External() */
  extern int ESNp1;		/* External() */
  extern int ESNLt;		/* External() */
  extern int ESnAP;		/* External() */
  extern int ESNa1;		/* External() */
  extern double *bT1a;		/* External() */
  extern double *R0T;		/* External() */
  extern double *Z0T;		/* External() */
  extern int ESnAF;		/* External() */
  extern double *rcT2a;		/* External() */
  extern double *rsT2a;		/* External() */
  extern double *rcT1a;		/* External() */
  extern double *rsT1a;		/* External() */
  extern int ESNp;		/* External() */
  extern double *sn1;		/* External() */
  extern double *cs1;		/* External() */
  extern double cr2;		/* External() */
  extern double *ESgF;		/* External() */
  extern double *ESgF1a;	/* External() */
  extern double *ESgY1a;	/* External() */
  extern double *a;		/* External() */
  extern double *rcT;		/* External() */
  extern double *rsT;		/* External() */
  extern double *rcT1t;		/* External() */
  extern double *rsT1t;		/* External() */
  extern int ESFp1;		/* External() */
  extern double *bT;		/* External() */
  extern double *aa;		/* External() */
  extern double cr2gp;		/* External() */
  extern double *ESgt;		/* External() */
  extern int ESNt1;		/* External() */
  extern int ESNt;		/* External() */
  extern double *ESgF01a;	/* External() */
  extern double *ESgY01a;	/* External() */
  extern double *ESgi;		/* External() */
  extern double ESgimn;		/* External() */
  extern double ESgimx;		/* External() */
  extern double ESgFPlV;	/* External() */
  extern double *gf1T;		/* External() */
  extern int ESNa;		/* External() */
  extern double *ESgY;		/* External() */
  extern int ESLt0;		/* External() */
  extern double ESgimn;		/* External() */
  extern double ESgimx;		/* External() */
  extern int ESNp;		/* External() */
  extern int ESNt;		/* External() */
  extern double *ESgF01a;	/* External() */
  extern int ESNt1;		/* External() */
  extern int ESnAP;		/* External() */
  extern int ESNp1;		/* External() */
  extern int ESNa1;		/* External() */
  extern double c2gp;		/* External() */
  extern double cr2gp;		/* External() */
  extern double *ESgh;		/* External() */
  extern double *ESgt;		/* External() */
  extern double *ESgi;		/* External() */
  extern int ESNLt;		/* External() */
  extern double *a;		/* External() */
  extern double *cs1;		/* External() */
  extern double *sn1;		/* External() */
  extern double cr2;		/* External() */
  extern double *cs1T;		/* External() */
  extern double *sn1T;		/* External() */
  extern int ESnAF;		/* External() */
  extern double *bT;		/* External() */
  extern double *bT1a;		/* External() */
  extern double *rcT1a;		/* External() */
  extern double *rsT1a;		/* External() */
  extern double *drsT;		/* External() */
  extern double *drcT;		/* External() */
  extern int ESFp1;		/* External() */
  extern double *r;		/* External() */
  extern double *R0T;		/* External() */
  extern double *z;		/* External() */
  extern double *Z0T;		/* External() */
  extern double *rcT;		/* External() */
  extern double *rsT;		/* External() */
  extern double *rT;		/* External() */
  extern double *zT;		/* External() */
  extern int ESFp;		/* External() */
  extern double *ESgF;		/* External() */
  extern double ESgFPlV;	/* External() */
  extern int ESNa;		/* External() */
  extern double *drcT2a;	/* External() */
  extern double *drsT2a;	/* External() */
  extern double *drcT1a;	/* External() */
  extern double *drsT1a;	/* External() */
  extern double *bT2a;		/* External() */
  extern double *rcT2a;		/* External() */
  extern double *rsT2a;		/* External() */
  extern double *ESgF1a;	/* External() */
  extern double *ESgY;		/* External() */
  extern double *ESgY01a;	/* External() */
  extern int ESNp;		/* External() */
  extern int ESNa1;		/* External() */
  extern double *cs1;		/* External() */
  extern double *sn1;		/* External() */
  extern double cr2;		/* External() */
  extern int ESNp;		/* External() */
  extern double *cs1;		/* External() */
  extern double *sn1;		/* External() */
  extern double cr2;		/* External() */
  extern int spl_p();		/* External */
  int ESP2F();			/* No prototype */
  static double rc[];		/*  .mzl_2Dcore:escA2R.c */
  static double rs[];		/*  .mzl_2Dcore:escA2R.c */
  static double rs1t[];		/*  .mzl_2Dcore:escA2R.c */
  static double rc1a[];		/*  .mzl_2Dcore:escA2R.c */
  static double rs1a[];		/*  .mzl_2Dcore:escA2R.c */
  static double rc1t[];		/*  .mzl_2Dcore:escA2R.c */
#endif
#endif
#ifndef mzl_ESmain
extern double cr2;	/* undefined */
extern double cr3;	/* undefined */
extern double cr4;	/* undefined */
extern double cr6;	/* undefined */
extern double cr12;	/* undefined */
extern double cgp;	/* undefined */
extern double c2gp;	/* undefined */
extern double cgp_4;	/* undefined */
extern double cr2gp;	/* undefined */
extern double cgm0;	/* undefined */
extern double crgm0;	/* undefined */
extern int ESmemlev;	/* undefined */
extern int spl_p();	/* undefined */
#endif
#ifndef mzl_1Dcore
extern int ESNa;	/* undefined */
extern int ESNa1;	/* undefined */
extern double *a;	/* undefined */
extern double *aa;	/* undefined */
extern double *a3a;	/* undefined */
#endif
#ifndef mzl_2Dcore
extern int ESNp;	/* undefined */
extern int ESNp1;	/* undefined */
extern int ESnAP;	/* undefined */
extern int *ESnF;	/* undefined */
extern int *ESmF;	/* undefined */
extern int *ESkF;	/* undefined */
extern int ESNf;	/* undefined */
extern int ESNf1;	/* undefined */
extern int ESFp;	/* undefined */
extern int ESFp1;	/* undefined */
extern int ESnAF;	/* undefined */
static double rc[];	/*  */
static double rs[];	/*  */
static double rc1a[];	/*  */
static double rs1a[];	/*  */
static double rc1t[];	/*  */
static double rs1t[];	/*  */
extern double *ESgh;	/* undefined */
extern double *ESgt;	/* undefined */
extern double *cs1;	/* undefined */
extern double *sn1;	/* undefined */
extern double *cs2;	/* undefined */
extern double *sn2;	/* undefined */
extern double *r;	/* undefined */
extern double *z;	/* undefined */
extern double *dra;	/* undefined */
extern double *drgt;	/* undefined */
extern double *dza;	/* undefined */
extern double *dzgt;	/* undefined */
#endif
#ifndef mzl_3Dcore
extern int ESLt;	/* undefined */
extern int ESNt;	/* undefined */
extern int ESNt1;	/* undefined */
extern int ESnAT;	/* undefined */
extern int ESnAPT;	/* undefined */
extern int ESLt0;	/* undefined */
extern int ESNLt;	/* undefined */
extern int ESNLt1;	/* undefined */
extern double *rcT;	/* undefined */
extern double *rcT1a;	/* undefined */
extern double *rcT2a;	/* undefined */
extern double *rcT1t;	/* undefined */
extern double *rsT;	/* undefined */
extern double *rsT1a;	/* undefined */
extern double *rsT2a;	/* undefined */
extern double *rsT1t;	/* undefined */
extern double *drcT;	/* undefined */
extern double *drcT1a;	/* undefined */
extern double *drcT2a;	/* undefined */
extern double *drsT;	/* undefined */
extern double *drsT1a;	/* undefined */
extern double *drsT2a;	/* undefined */
extern double *R0T;	/* undefined */
extern double *Z0T;	/* undefined */
extern double *rT;	/* undefined */
extern double *zT;	/* undefined */
extern double *bT;	/* undefined */
extern double *bT1a;	/* undefined */
extern double *bT2a;	/* undefined */
extern double *gf1T;	/* undefined */
extern double *csLT;	/* undefined */
extern double *snLT;	/* undefined */
extern double *cs1T;	/* undefined */
extern double *sn1T;	/* undefined */
extern double *ESgF;	/* undefined */
extern double *ESgF1a;	/* undefined */
extern double *ESgF3a;	/* undefined */
extern double ESgFPlV;	/* undefined */
extern double ESgFPlV1a;/* undefined */
extern double *ESgY;	/* undefined */
extern double *ESgY1a;	/* undefined */
extern double *ESgY1a2t;/* undefined */
extern double *ESgY3a;	/* undefined */
extern double *ESgi;	/* undefined */
extern double *ESgi1a;	/* undefined */
extern double *ESgi2a;	/* undefined */
extern double *ESgF0;	/* undefined */
extern double *ESgF01a;	/* undefined */
extern double *ESgY0;	/* undefined */
extern double *ESgY01a;	/* undefined */
extern double *ESgY02a;	/* undefined */
extern double ESgimn;	/* undefined */
extern double ESgimx;	/* undefined */
extern double *ESbY0;	/* undefined */
extern double *ESbY01a;	/* undefined */
extern double *ESbY02a;	/* undefined */
extern double ESgY2a1a;	/* undefined */
#endif
extern double *ESFaux;	/* undefined */
extern double *ESd2Faux;/* undefined */
#ifndef mzl_ESPlV
static double *R0T2t;	/*  */
static double *Z0T2t;	/*  */
static double *bT2t;	/*  */
static double *gX0;	/*  */
static double *gX01a;	/*  */
static double *dR0T;	/*  */
static double *dZ0T;	/*  */
static double *dbT;	/*  */
static double *dbT1a;	/*  */
static double *dbT2a;	/*  */
static double *xT2t;	/*  */
static double *xT22at;	/*  */
static double *xT22tp;	/*  */
static double *xT222atp;/*  */
static double *DP;	/*  */
static double *DP2a;	/*  */
static double *DP2t;	/*  */
static double *DP2p;	/*  */
static double *DP22at;	/*  */
static double *DP22ap;	/*  */
static double *DP22tp;	/*  */
static double *DP222atp;/*  */
static double *gX;	/*  */
static double *gX2a;	/*  */
static double *gX2t;	/*  */
static double *gX2p;	/*  */
static double *gX22at;	/*  */
static double *gX22ap;	/*  */
static double *gX22tp;	/*  */
static double *gX222atp;/*  */
static double *BV;	/* 
  $
  {\gh\over a}
  =
  aV_{\cup\cup}-\int^\gf_0u''_{\cup,0,a\gf}d\gf
  $
 */
static double *BV2t;	/*  */
static double *BA;	/*  */
static double *BA2p;	/*  */
static double *BF;	/*
  $
  {\gh'_\gt\over a^2}
  =
  V'_{\cup\cup,\gt}
  =
  {(B_tD)_{\cup\til}\over a}
  $
  */
static double *BF2p;	/*  */
static double *BP;	/* 
 $
 arDB^\gt =(rB_z-B_tz'_\gf)r'_a+(B_tr'_\gf-rB_r)z'_a
 $
 */
static double *BP2p;	/*  */
static double *GH;	/*
  $
  {\gh\over\bgY'_{00}}=a\int^\gt_0{V'_{\cup\cup,\gt}\over\bgY'_{00}}d\gt
  -\int^\gf_0{u''_{\cup0,a\gf}\over\bgY'_{00}}d\gf
  $
  */
static double *AA22at;	/*  */
static double *AA22ap;	/*  */
static double *AA22tp;	/*  */
static double *AA222atp;/*  */
static double *AF;	/*
  $
  \bgF'_{\cup\til,a}
  $
  */
static double *AF2t;	/*
  $			   
  (V_{\cup\cup}-V_{\cup0})'_gf
  $
  */
static double *AF2p;	/*  */
static double *AF22at;	/*  */
static double *AF22tp;	/*  */
static double *AF222atp;/*  */
static double *AP;	/*  */
static double *AP2a;	/*
  $
  {\gh'_\gt\over a}
  =
  aV'_{\cup\cup,\gt}
  =
  (B_tD)_{\cup\til}
  $
  */
static double *AP2t;	/*  */
static double *AP2p;	/*  */
static double *AP22ap;	/*  */
static double *AP22tp;	/*  */
static double cha;	/*  */
static double crha;	/*  */
static double chha;	/*  */
static double ch2ha;	/*  */
static double ch2h0;	/*  */
static double ch2h1;	/*  */
static double ch4h0;	/*  */
static double ch4h1;	/*  */
static double cht;	/*  */
static double crht;	/*  */
static double chht;	/*  */
static double ch2ht;	/*  */
static double crHt;	/*  */
static double chp;	/*  */
static double crhp;	/*  */
static double chhp;	/*  */
static double ch2hp;	/*  */
static double crHp;	/*  */
static int NnMN;	/*  */
static int nMN;		/*  */
static int nM;		/*  */
static int nN;		/*  */
static double *gXc;	/*  */
static double *gXc2a;	/*  */
static double *gXs;	/*  */
static double *gXs2a;	/*  */
static double *gYRc;	/*  */
static double *gYRc2a;	/*  */
static double *gYRs;	/*  */
static double *gYRs2a;	/*  */
static int *MgYR;	/*  */
static int *NgYR;	/*  */
static int NngYR;	/*  */
static int ngYR;	/*  */
static double *glP;	/*  */
static double *glT;	/*  */
static int NaNpNt;	/*  */
static double *ginf;	/*  */
static double *g2inf;	/*  */
static int iSplA;	/*  */
static int iSplA1;	/*  */
double SplAx;		/*  */
double SplAxx;		/*  */
double SplAX;		/*  */
double SplAXX;		/*  */
int ESReInit3APTSpl()
{
  Undef ReInitArray();
  Undef FailureAlarm();
  Undef ESexit();
  extern int ESnAPT;		/* undefined */
  extern int ESNt1;		/* undefined */
  extern int ESnAT;		/* undefined */
  extern double *ESgF;		/* undefined */
  extern double *ESgF1a;	/* undefined */
  extern double *ESgF3a;	/* undefined */
  extern double *ESgY;		/* undefined */
  extern double *ESgY1a;	/* undefined */
  extern double *ESgY1a2t;	/* undefined */
  extern double *ESgY3a;	/* undefined */
  extern double *ESgi;		/* undefined */
  extern int ESNa1;		/* undefined */
  extern double *ESgi1a;	/* undefined */
  extern double *ESgi2a;	/* undefined */
  extern double *ESgF0;		/* undefined */
  extern double *ESgF01a;	/* undefined */
  extern double *ESgY0;		/* undefined */
  extern double *ESgY01a;	/* undefined */
  extern double *ESgY02a;	/* undefined */
  extern double *ESbY0;		/* undefined */
  extern double *ESbY01a;	/* undefined */
  extern double *ESbY02a;	/* undefined */
  extern int ESNp1;		/* undefined */
  extern double *ESFaux;	/* undefined */
  extern double *ESd2Faux;	/* undefined */
  extern int ESmemlev;		/* undefined */
/*
   */
#ifdef Doc_ESReInit3APTSpl

#endif
}
int ESDeInit3APTSpl()
{
/*
   */
#ifdef Doc_ESDeInit3APTSpl

#endif
}
int ESReInitgXcs()
{
  Undef ReInitArray();
  Undef FailureAlarm();
  Undef ESexit();
  Undef int;
/*
   */
#ifdef Doc_ESReInitgXcs

#endif
}
int ESDeInitgXcs()
{
/*
   */
#ifdef Doc_ESDeInitgXcs

#endif
}
int splA(g,d2g,dg0,dg1)
  double *g;	/*  */
  double *d2g;	/*  */
  double *dg0;	/*  */
  double *dg1;	/*  */
{
  extern double cr2;	/* undefined */
  extern double cr6;	/* undefined */
  extern int ESNa;	/* undefined */
  /*
   */
#ifdef Doc_splA

#endif
}
int splA1a(g,d1g,d2g)
  double *g;	/*  */
  double *d1g;	/*  */
  double *d2g;	/*  */
{
  /*
   */
#ifdef Doc_splA1a

#endif
}
int splAA(g,d1g,d2g,dg0,dg1)
  double *g;	/*  */
  double *d1g;	/*  */
  double *d2g;	/*  */
  double *dg0;	/*  */
  double *dg1;	/*  */
{
  /*
   */
#ifdef Doc_splAA

#endif
}
int splAA2(g,d1g,d2g,d2g0,dg1)
  double *g;	/*  */
  double *d1g;	/*  */
  double *d2g;	/*  */
  double d2g0;	/*  */
  double *dg1;	/*  */
{
  /*
   */
#ifdef Doc_splAA2

#endif
}
int ESSetSplA(A)
  double A;	/*  */
{
  extern double *a;	/* undefined */
  /*
   */
#ifdef Doc_ESSetSplA

#endif
}
int splRA(f,df,g,d2g)
  double *f;	/*  */
  double *df;	/*  */
  double *g;	/*  */
  double *d2g;	/*  */
{
  /*
   */
#ifdef Doc_splRA

#endif
}
int splRA2(f,df,d2f,g,d2g)
  double *f;	/*  */
  double *df;	/*  */
  double *d2f;	/*  */
  double *g;	/*  */
  double *d2g;	/*  */
{
  /*
   */
#ifdef Doc_splRA2

#endif
}
int splP(g,d2g)
  double *g;	/*  */
  double *d2g;	/*  */
{
  extern int ESNp;	/* undefined */
/*
   */
#ifdef Doc_splP

#endif
}
int splT(g,d2g)
  double *g;	/*  */
  double *d2g;	/*  */
{
  extern int ESNt;	/* undefined */
/*
   */
#ifdef Doc_splT

#endif
}
int f2splP(g,d2g,f,ga0,ga_1,ga2,ga_3)
  double *g;	/*  */
  double *d2g;	/*  */
  double *f;	/*  */
  double ga0;	/*  */
  double ga_1;	/*  */
  double ga2;	/*  */
  double ga_3;	/*  */
{
  Undef inv3x3();
  Undef ludcmp();
  Undef lubksb();
  extern double *ESgt;	/* undefined */
/*
   */
#ifdef Doc_f2splP
\section{Smoothing splines for periodic functions}
Notation for coefficients of tridiagonal equations, $i=1$ --- $(N-1)$
\bqbl
&&
h=x_{i+1}-x_i
,\quad
H={h^2\over6}
,\\&&
g'(x)={g_{i+1}-g_i\over h}
+[(3B_i^2-1)g_{i+1}''-(3A_i^2-1)g_i'']{h\over6}
,\\&&
g'_0={g_1-g_0\over h}-(g''_1+2g''_0){h\over6}
,\quad
g'_N={g_N-g_{N-1}\over h}
+(2g''_N+g''_{N-1}){h\over6}
.\eqbl
Tridiagonal equations
\bqbl
&&
-g_{i-1}
+2g_i
-g_{i+1}
+Hg''_{i-1}
+4Hg''_i
+Hg''_{i+1}
=0
,\quad
1\leq i\leq N-1
,\\&&
g_N
=
g_0
,\quad
g''_N
=
g''_0
,\quad
-g_1+2g_0-g_{N-1}+Hg''_1+4Hg''_0+Hg''_{N-1}
=
0
,\quad
i=0
.\eqbl

Least squares functional for a given function $f(x)$
\bqbl
&&
W=
\sum^{i<N}_{i=0}(g_i-f_i)^2
+\ga_0\sum^{N-1}_{i=0}g_i^2
+{\ga_1\over h^2}\sum^{N-1}_{i=0}(g_{i+1}-g_i)^2
+\ga_2L^4\sum^{N-1}_{i=0}g''^2_i
+{\ga_3L^4\over h^2}\sum^{N-1}_{i=0}(g''_{i+1}-g''_i)^2
\\&&
+2\sum_{i=0}^{i<N}\gl_i
(-g_{i-1}
 +2g_i
 -g_{i+1}
 +Hg''_{i-1}
 +4Hg''_i
 +Hg''_{i+1}
 )
,\quad
\bga_1
\equiv
{\ga_1\over h^2}
,\quad
\bga_2
\equiv
\ga_2L^4
,\quad
\bga_3
\equiv
{\ga_3L^4\over h^2}
.\eqbl
Unknown variables are $g_i$, $g''_i$, $\gl_i$, $0\leq i < N$ in 
the intermediate points
\bqbl
&&
-\bga_1g_{i-1}-\gl_{i-1}
+(1+\ga_0+2\bga_1)g_i+2\gl_i
-\bga_1g_{i+1}-\gl_{i+1}
=
f_i
,\\&&
-\bga_3g''_{i-1}+H\gl_{i-1}
+(\bga_2+2\bga_3)g''_i+4H\gl_i
-\bga_3g''_{i+1}+H\gl_{i+1}
=0
,\\&&
-g_{i-1}
+Hg''_{i-1}
+2g_i
+4Hg''_i
-g_{i+1}
+Hg''_{i+1}
=0
,\\&&
g_{-1}
=
g_{N-1}
,\quad
g''_{-1}
=
g''_{N-1}
,\quad
\gl_{-1}
=
\gl_{N-1}
.\eqbl

\section{Matrix form of equations}
\def\db{\displaystyle}
\def\dd{\\\displaystyle}
\def\da{&\displaystyle}
\def\bqy{\begin{eqnarray}}
\def\eqy{\end{eqnarray}}

Matrix equations $0\leq i <N$ 
\bqy
&&
-TY_{i-1}+WY_i-TY_{i+1}=R_i
,\quad
Y_i=\left|
\begin{array}{c}
\db g_i
\dd g''_i
\dd \gl_i
\end{array}
\right|
,\quad
R_i=\left|
\begin{array}{c}
\db f_i
\dd 0
\dd 0
\end{array}
\right|
,\\&&
T
=
\left|
\begin{array}{ccc}
\db \ga_1	\da 0		\da 1
\dd 0		\da \bga_3	\da -H
\dd 1		\da -H		\da 0
\end{array}
\right|
,\quad
W
=
\left|
\begin{array}{ccc}
\db 1+\ga_0+2\bga_1	\da 0			\da 2
\dd 0			\da \bga_2+2\bga_3	\da 4H
\dd 2			\da 4H			\da 0
\end{array}
\right|
\eqy
Backsubstitution and decomposition loops
\bqbl
&&
Y_i=V_iY_{i+1}+U_i+g_{-1}U^0_i+g''_{-1}U^1_i+\gl_{-1}U^2_i
,\quad
Y_0=W^{-1}TY_1+W^{-1}R_0+W^{-1}TY_{-1}
,\\&&
V_i=(W-TV_{i-1})^{-1}T
,\quad
U_i=(W-TV_{i-1})^{-1}R_i+V_iU_{i-1}
,\quad
U^k_i=V_iU^k_{i-1}
,\\&&
V_0=W^{-1}T
,\quad
U_0=W^{-1}R_i+V_0(g_{-1}U^0_i+g''_{-1}U^1_i+\gl_{-1}U^2_i)
,\quad
Y_{N-1}=V_{N-1}Y_0+U_{N-1}
.\eqbl

\section{Subroutine {\tt f2splP()}}
{\tt f2splP(g,d2g,f,x,nx,ga0,ga\_1,ga\_2,ga\_3)}
determines spline approximation of $f(x)\simeq g(x)$ with 
regularization parameters $\ga_0,\ \ga_1,\ \ga_2,\ \ga_3$. 

\begin{tabular}{|lll|}\hline
{\tt f[i]}	&$f(x_i)$	&function to be approximated\\ \hline
{\tt x[i]}	&$x_i$&grid of arguments for $f$ and(!) for splines $g$,
 $g''$\\ \hline
{\tt g[i]}&$p(x_i)g(x_i)\simeq f(t_i)$&spline of the function $f$ \\ \hline
{\tt d2g[i]}	&$g''(x_i)=g''(x_i)$&spline coefficients\\ \hline
{\tt nx}	&$N,\ x_0\leq x\leq x_N$&number of spline intervals \\ \hline
{\tt ga0}	&$\ga_0$	&parameter of regularization\\ \hline
{\tt ga1}	&$\ga_1$	&parameter of regularization\\ \hline
{\tt ga2}	&$\ga_2$	&parameter of regularization\\ \hline
{\tt ga3}	&$\ga_3$	&parameter of regularization\\ \hline
\end{tabular}

\section{Fundamental solution for displacement of the boundary}

{\tt vgp\_b2vdrz\_b()} determines a fundamental solution for
$\gd\vsr$ and $\gd\vsr'$ corresponding to that of $\vec{\psi}$.

General solution
\bqbl
&&
\vgy	=
\vgy^0+\sum_{m=1}^M\left[A_m\vgy^m+A^*_m\vgy^{*m}\right]
=
\vgy^0+\sum_{m=1}^M\left[A_{c,m}(\vgy^m+\vgy^{*m})
+A_{s,m}{\vgy^m-\vgy^{*m}\over i}\right]
,\\&&
\gd\vsr	=\sum_{m=1}^M\left[A_{c,m}\gd\vsr^{c,m}+A_{s,m}\gd\vsr^{s,m}\right]
,\quad
\gd\vsr'	=\gd\vsr'^{c,0}
+\sum_{m=1}^M\left[A_{c,m}\gd\vsr'^{c,m}+A_{s,m}\gd\vsr'^{s,m}\right]
,\\&&
\vgy^m=
\sum_{k=-M}^M\left(\psi^m_{r,k}+i\psi^m_{i,k}\right)e^{ik\gt}
,\quad
\gd\vsr^m=
\sum_{k=-L+1}^{L-1}\left(\gd r^m_{c,k}-i\gd r^m_{s,k}\right)e^{ik\gt}
,\quad
A_m=A_{c,m}-iA_{s,m}
.\eqbl
Transformation $\vgy$ into displacement $\gd r$, $\gd z_0$.
\bqbl
&&
b_0\cos\gt\gd r
=
{r'_\gt\over a}\gd z_0
+\ga{D\over\bar{\gY}'}
-{D\over\bar{\gY}'}{\gY\over a}
=
{r'_\gt\over a}\gd z_0
+\ga{D\over\bar{\gY}'}
+\sum_{m=-L}^LU_me^{im\gt}
,\quad
U_{-m}=U^*_m
,\\&&
b_0\cos\gt\sum_{m=-L+1}^{L-1}\gd r_me^{im\gt}
=
\gd z_0\sum_{m=-L}^Lim{r_m\over a}e^{im\gt}
+\ga\sum_{m=-L}^L{D_m\over\bar{\gY}'}e^{im\gt}
+\sum_{m=-L}^LU_me^{im\gt}
,\\&&
e^{im\gt}
=
\left(e^{i\gt}+e^{-i\gt}\right)e^{i(m-1)\gt}
-e^{i(m-2)\gt}
,\quad
e^{-im\gt}
=
\left(e^{i\gt}+e^{-i\gt}\right)e^{-i(m-1)\gt}
-e^{-i(m-2)\gt}
.\eqbl
Conditions of solvability
\bqbl
&&
\gd z_0\sum_{m=1}^{2m\leq L}(-1)^m\left.{r'_\gt\over a}\right|_{cs,2m}
+\ga{D_0\over2\bar{\gY}'}
+\ga\sum_{m=1}^{2m\leq L}(-1)^m{D_{cs,2m}\over\bar{\gY}'}
+{U_0\over2}
+\sum_{m=1}^{2m\leq L}(-1)^mU_{c,2m}
=0
,\\&&
\gd z_0\sum_{m=0}^{2m+1\leq L}(-1)^m\left.{r'_\gt\over a}\right|_{sn,2m+1}
+\ga\sum_{m=0}^{2m+1\leq L}(-1)^m{D_{sn,2m+1}\over\bar{\gY}'}
+\sum_{m=0}^{2m+1\leq L}(-1)^mU_{s,2m+1}
=0
.\eqbl
Derivative $\gd r'_a$ at the plasma boundary
\bqbl
&&
b_0\cos\gt\gd r'_a
=
{r'_\gt\over a}\gd z_0'
+\ga'{D\over a\bar{\gY}'}
+\left({r'_\gt\over a}\right)'_a\gd z_0
+\ga\left({D\over a\bar{\gY}'}\right)'_a
-\left({D\over a\bar{\gY}'}\right)'_a\gY
-{D\over a\bar{\gY}'}\gY'
.\eqbl
Perturbation of the Jacobian
\bqbl
&&
D=ab_0\cos\gt r'_a-(z_0'+b_0\sin\gt)r'_\gt
,\quad
\gd D=
ab_0\cos\gt\gd r'_a
-r'_\gt\gd z_0'
-(z_0'+b_0\sin\gt)\gd r'_\gt
,\\&&
{\gd D\over a}
=
-(z_0'+b_0\sin\gt){\gd r'_\gt\over a}
+\left({r'_\gt\over a}\right)'_a\gd z_0
+\ga'{D\over a\bar{\gY}'}
+\ga\left({D\over a\bar{\gY}'}\right)'_a
-\left({D\over a\bar{\gY}'}\right)'_a\gY
-{D\over a\bar{\gY}'}\gY'
.\eqbl
\centerline{
\begin{tabular}{@|lll@|}\hline
\multicolumn{3}{@|c@|}{\bf Important internal variables}\\ \hline
{\tt Mmax,M0}&$M,M+1$&\\ \hline
{\tt Mm, M0Mm}&$2M+1,(2M+1)*(M+1)$&the number of harmonics in $\psi$\\ \hline
{\tt Lmax,L0}&$L,L+1$&\\ \hline
{\tt gper[M0Mm*i+Mm*m+Mmax+k]}&$\psi^m_{r,k}(a_i)$&
fundamental solution $\vgy^m(a_i)$-vector\\ \hline
{\tt gpei[M0Mm*i+Mm*m+Mmax+k]}&$\psi^m_{i,k}(a_i)$&
fundamental solution $\vgy^m(a_i)$-vector\\ \hline
{\tt rCc[L0*m+k],rCs[],rSc[],rSs[]}
&$\gd r^{c,m}_{cs,k},\ \gd r^{c,m}_{sn,k},
\ \gd r^{s,m}_{cs,k},\ \gd r^{s,m}_{sn,k}$
&fundamental vector of displacement\\ \hline
{\tt rCs[Lm*m], rSs[Lm*m]}
&$\gd z^{c,m}_0,\ \gd z^{s,m}_0$
&storage for $\gd z^{c,m}_0,\ \gd z^{s,m}_0$\\ \hline
{\tt drCc[L0*m+k],drCs[],drSc[],drSs[]}
&$\gd r'^{c,m}_{cs,k},\ \gd r'^{c,m}_{sn,k},
\ \gd r'^{s,m}_{cs,k},\ \gd r'^{s,m}_{sn,k}$
&fundamental vector of displacement\\ \hline
{\tt drCs[Lm*m], drSs[Lm*m]}
&$\gd z'^{c,m}_0,\ \gd z'^{s,m}_0$
&storage for $\gd z'^{c,m}_0,\ \gd z'^{s,m}_0$\\ \hline
\end{tabular}
}

\section{Displacement of the coordinates}
Shift $\gd r$ for a particular choice of poloidal angle
$z(\tsa,\tgt)=z_0(\tsa)+\tsa\cos\tgt$
\bqbl
&&
b_0a\cos\tgt\gd r
=
\tsr'_\gt\gd z_0
-{\tbD\over\bgY'}(\gY-\bgY)
,\quad
\left[\tsr'_\gt\gd z_0
+{\tbD\over\bgY'}\bgY
=
{\tbD\over\bgY'}\gY
\right]_{\tgt=\pm\gp/2}
.\eqbl
\bqbl
&&
e^{(m+1)i\gt}+e^{-(m+1)i\gt}
=
-\left[e^{(m-1)i\gt}+e^{-(m-1)i\gt}\right]
+\left(e^{i\gt}+e^{-i\gt}\right)\left(e^{mi\gt}+e^{-mi\gt}\right)
,\\&&
e^{(m+1)i\gt}-e^{-(m+1)i\gt}
=
-\left[e^{(m-1)i\gt}-e^{-(m-1)i\gt}\right]
+\left(e^{i\gt}+e^{-i\gt}\right)\left(e^{mi\gt}-e^{-mi\gt}\right)
,\\&&
e^{(m+1)i\gt}
=
\left(e^{i\gt}+e^{-i\gt}\right)e^{mi\gt}
-e^{(m-1)i\gt}
,\\&&
e^{-(m+1)i\gt}
=
\left(e^{i\gt}+e^{-i\gt}\right)e^{-mi\gt}
-e^{-(m-1)i\gt}
.\eqbl
In a matrix form, the solution
\bqbl
&&
b_0\cos\tgt\gd r
=
{\tsr'_\gt\over a}\gd z_0
-{\tbD\over\bgY'}{\gY-\bgY\over a}
=\sum_{m=-\infty}^{\infty}\gd_me^{im\tgt}
,\quad
\vgd\equiv\{\gd_m\}
.\eqbl
Derivative $\gd r'_a$ at the plasma boundary
\bqbl
&&
(\tbD+\gd D)\gY'_a=\tbD\bgY'
,\quad
\gd D=-\tbD{\gY'_a-\bgY'\over\bgY'}
,\quad
b_0\cos\tgt\gd r'_a={\tsr'_\gt\over a}\gd z_0'
+(b_0\sin\tgt+z_0'){\gd r'_\gt\over a}
+{\tbD\over a}{\bgY'-\gY'_a\over\bgY'}
.\eqbl
\centerline{
\begin{tabular}{|r|rrrrrrrrrr|r|rrrrrrrrrr|}\hline
\multicolumn{22}{|c|}{\bf Matrix $\mat{R}$ of Inverse $\cos\tgt$:
 $\cos\tgt\gd r=\vbX,\quad \gd\vec{r}=\mat{R}\vbX$}
\\ \hline
$\cdots$&$\cdots$&$\cdots$&$\cdots$&$\cdots$&$\cdots$&$\cdots$&$\cdots$&
$\cdots$&$\cdots$&$\cdots$&$\cdots$&$\cdots$&$\cdots$&$\cdots$&$\cdots$
&$\cdots$&$\cdots$&$\cdots$&$\cdots$&$\cdots$&$\cdots$\\
-8&$\cdots$& 2& 0& 0& 0& 0& 0& 0& 0& 0&0&0& 0& 0& 0& 0& 0& 0& 0& 0&$\cdots$\\
-7&$\cdots$& 0& 2& 0& 0& 0& 0& 0& 0& 0&0&0& 0& 0& 0& 0& 0& 0& 0& 0&$\cdots$\\ 
-6&$\cdots$&-2& 0& 2& 0& 0& 0& 0& 0& 0&0&0& 0& 0& 0& 0& 0& 0& 0& 0&$\cdots$\\ 
-5&$\cdots$& 0&-2& 0& 2& 0& 0& 0& 0& 0&0&0& 0& 0& 0& 0& 0& 0& 0& 0&$\cdots$\\ 
-4&$\cdots$& 2& 0&-2& 0& 2& 0& 0& 0& 0&0&0& 0& 0& 0& 0& 0& 0& 0& 0&$\cdots$\\ 
-3&$\cdots$& 0& 2& 0&-2& 0& 2& 0& 0& 0&0&0& 0& 0& 0& 0& 0& 0& 0& 0&$\cdots$\\ 
-2&$\cdots$&-2& 0& 2& 0&-2& 0& 2& 0& 0&0&0& 0& 0& 0& 0& 0& 0& 0& 0&$\cdots$\\ 
-1&$\cdots$& 0&-2& 0& 2& 0&-2& 0& 2& 0&0&0& 0& 0& 0& 0& 0& 0& 0& 0&$\cdots$\\
\hline 
 0&$\cdots$& 1& 0&-1& 0& 1& 0&-1& 0& 1&0&1& 0&-1& 0& 1& 0&-1& 0& 1&$\cdots$\\ 
\hline 
 1&$\cdots$& 0& 0& 0& 0& 0& 0& 0& 0& 0&0&0& 2& 0&-2& 0& 2& 0&-2& 0&$\cdots$\\ 
 2&$\cdots$& 0& 0& 0& 0& 0& 0& 0& 0& 0&0&0& 0& 2& 0&-2& 0& 2& 0&-2&$\cdots$\\ 
 3&$\cdots$& 0& 0& 0& 0& 0& 0& 0& 0& 0&0&0& 0& 0& 2& 0&-2& 0& 2& 0&$\cdots$\\ 
 4&$\cdots$& 0& 0& 0& 0& 0& 0& 0& 0& 0&0&0& 0& 0& 0& 2& 0&-2& 0& 2&$\cdots$\\ 
 5&$\cdots$& 0& 0& 0& 0& 0& 0& 0& 0& 0&0&0& 0& 0& 0& 0& 2& 0&-2& 0&$\cdots$\\ 
 6&$\cdots$& 0& 0& 0& 0& 0& 0& 0& 0& 0&0&0& 0& 0& 0& 0& 0& 2& 0&-2&$\cdots$\\ 
 7&$\cdots$& 0& 0& 0& 0& 0& 0& 0& 0& 0&0&0& 0& 0& 0& 0& 0& 0& 2& 0&$\cdots$\\ 
 8&$\cdots$& 0& 0& 0& 0& 0& 0& 0& 0& 0&0&0& 0& 0& 0& 0& 0& 0& 0& 2&$\cdots$\\ 
$\cdots$&$\cdots$&$\cdots$&$\cdots$&$\cdots$&$\cdots$&$\cdots$&$\cdots$&
$\cdots$&$\cdots$&$\cdots$&$\cdots$&$\cdots$&$\cdots$&$\cdots$&$\cdots$
&$\cdots$&$\cdots$&$\cdots$&$\cdots$&$\cdots$&$\cdots$\\ \hline
m&$\cdots$&-9&-8&-7&-6&-5&-4&-3&-2&-1& 0& 1& 2& 3& 4& 5& 6& 7& 8& 9&$\cdots$
\\ \hline   
\end{tabular}
}

#endif
}
int DeInitf2splP()
{
/*
   */
#ifdef Doc_DeInitf2splP
\section{Fourier expansion of the splined function}
\bqbl
&&
f
=
f_0
+2\sum^{m\leq M}_{m=1}(f^c_m\cos m\gt+f^s_m\sin m\gt)
,\\&&
f_0
=
\sum^{i<I}_{i=0}{h_i\over2}\left[
  f_i+f_{i+1}
 -{h^2_i\over12}(f''_i+f''_{i+1})
 \right]
,\\&&
f^c_m
=
{1\over2m^4\gp}\int^{2\gp}_0f''''\cos m\gt d\gt
=
\sum^{i<I}_{i=0}\left[
  {f''_{i+1}-f''_i\over h_i}
 -{f''_i-f''_{i-1}\over h_{i-1}}
 \right]\cos m\gt_i
,\\&&
f^s_m
=
{1\over2m^4\gp}\int^{2\gp}_0f''''\sin m\gt d\gt
=
\sum^{i<I}_{i=0}\left[
  {f''_{i+1}-f''_i\over h_i}
 -{f''_i-f''_{i-1}\over h_{i-1}}
 \right]\sin m\gt_i
.\eqbl
#endif
}
int f2splT(g,d2g,f,ga0,ga_1,ga2,ga_3)
  double *g;	/*  */
  double *d2g;	/*  */
  double *f;	/*  */
  double ga0;	/*  */
  double ga_1;	/*  */
  double ga2;	/*  */
  double ga_3;	/*  */
{
  Undef inv3x3();
  Undef ludcmp();
  Undef lubksb();
  extern double *gf1T;	/* undefined */
/*
   */
#ifdef Doc_f2splT

#endif
}
int DeInitf2splT()
{
/*
   */
#ifdef Doc_DeInitf2splT

#endif
}
int ESInitSplAPT()
{
  extern double *aa;	/* undefined */
  extern double cr3;	/* undefined */
  extern double cr4;	/* undefined */
  /*
   */
#ifdef Doc_ESInitSplAPT

#endif
}
int ESGetgFPlV()
{
  Undef ESSpl2ArBtAtAz();
  extern double *bT;		/* undefined */
  extern double *R0T;		/* undefined */
  extern double *rcT;		/* undefined */
  extern double *Z0T;		/* undefined */
  extern double *rsT;		/* undefined */
  extern int ESFp1;		/* undefined */
  extern double *cs1;		/* undefined */
  extern double *sn1;		/* undefined */
  extern double ESgFPlV;	/* undefined */
  extern double ESgFPlV1a;	/* undefined */
  static double rc[];	/*  .mzl_2Dcore:escA2R.c */
  static double rs[];	/*  .mzl_2Dcore:escA2R.c */
/*
   */
#ifdef Doc_ESGetgFPlV

#endif
}

int ES3DCoord2Spl()
{
  extern double *bT1a;	/* undefined */
  extern int ESnAF;	/* undefined */
  extern double *rcT1t;	/* undefined */
  extern double *rsT1t;	/* undefined */
  /*
     !!! Array bT2t for i=0 (at the magnetic axis) contains $b'''_{a\gf\gf}$
     */
#ifdef Doc_ES3DCoord2Spl

\section{Associated Legendre functions}
\bqbl
&&
P^N_{-1/2}(z)
=
{1\over\gp}\cdot{1\over2}\cdot{3\over2}\cdots{2N-1\over2}
 \int^\gp_0{\cos N\gf d\gf\over\sqrt{z+\sqrt{z^2-1}\cos\gf}}
,\quad
\gn
\equiv
{\sqrt{z^2-1}\over z}
,\quad
z
=
{1\over\sqrt{1-\gn^2}}
,\\&&
P^N_{-1/2}(\gn)
=
{(1-\gn^2)^{1\over4}\over\gp}\cdot{1\over2}\cdot{3\over2}\cdots{2N-1\over2}
 \int^\gp_0{\cos N\gf d\gf\over\sqrt{1-\gn\cos\gf}}
.\eqbl
Useful functions
\bqbl
F^N(\gn)
=&&
 \int^\gp_0{\cos N\gf d\gf\over(1-\gn\cos\gf)^{1/2}}
\\
=&&
 \int^\gp_0{(1-2\gn\cos\gf+\gn^2\cos^2\gf)\cos N\gf d\gf
 \over(1-\gn\cos\gf)^{5/2}}
\\
=&&
 {\gn\over2N}\int^\gp_0{\sin N\gf\sin\gf d\gf\over(1-\gn\cos\gf)^{3/2}}
\\
=&&
 {\gn\over2N^2}\int^\gp_0{\cos N\gf\cos\gf d\gf\over(1-\gn\cos\gf)^{3/2}}
-{3\gn^2\over4N^2}\int^\gp_0{\cos N\gf\sin^2\gf d\gf\over(1-\gn\cos\gf)^{5/2}}
,\\
F'^N(\gn)
=&&
{1\over2}\int^\gp_0{\cos N\gf\cos\gf d\gf\over(1-\gn\cos\gf)^{3/2}}
\\
=&&
{1\over2}\int^\gp_0{(\cos\gf-\gn\cos^2\gf)\cos N\gf d\gf
 \over(1-\gn\cos\gf)^{5/2}}
,\\
F''^N(\gn)
=&&
{3\over4}\int^\gp_0{\cos N\gf\cos^2\gf d\gf\over(1-\gn\cos\gf)^{5/2}}
.\eqbl
Relationship between for $F^N$, $F'^N$, $F''^N$
\bqbl
F^N(\gn)
=&&
\int^\gp_0{\cos N\gf d\gf\over(1-\gn\cos\gf)^{5/2}}
-4\gn F'^N
-\gn^2{4\over3}F''^N
\\
=&&
 {\gn\over N^2}F'^N
+{3\gn^2\over4N^2}{4\over3}F''^N
-{3\gn^2\over4N^2}\int^\gp_0{\cos N\gf d\gf\over(1-\gn\cos\gf)^{5/2}}
.\eqbl
Differential equation for $F^N(\gn)$
\bqbl
&&
(1-\gn^2)F''^N
+{1\over\gn}F'^N
-3\gn F'^N
-{N^2\over\gn^2}F
-{3\over4}F^N
=
0
,\\&&
x
\equiv
\gn^2
,\quad
S^2
\equiv
{N^2\over4}
,\\&&
x^2(1-x)F''^N
+x(1-2x)F'^N
-S^2F
-{3\over16}xF^N
=
0
,\\&&
t
\equiv
1-x
,\\&&
(1-t)^2tF''^N
+(1-t)(1-2t)F'^N
-S^2F
-{3\over16}(1-t)F^N
=
0
.\eqbl
Small solution near $x=0$
\bqbl
&&
f
=
\sum_{k=0}A_kx^{S+k}
,\quad
f'
=
\sum_{k=0}(S+k)A_{k}x^{S+k-1}
,\quad
f''
=
\sum_{k=0}(S+k)(S+k-1)A_{k}\nu^{S+k-2}
,\\&&
A_{k+1}
=
{(S+k)(S+k+1)+{3\over16}\over(k+1)(2S+k+1)}A_k
.\eqbl
Big solution near $x=0$
\bqbl
&&
F
=
\sum^{k<2S}_{k=0}B_kx^{-S+k}
+\sum_{k=2S}B_kx^{-S+k}
+C_S\ln x\sum_{k=2S}A_{k-2S}x^{-S+k}
,\\&&
F'
=
\sum^{k<2S}_{k=0}(-S+k)B_{k}x^{-S+k-1}
+\sum_{k=2S}(-S+k)B_kx^{-S+k-1}
+C_S\sum_{k=2S}A_{k-2S}x^{-S+k-1}
+C_S\ln x f'
,\\&&
F''
=
\sum^{k<2S}_{k=0}(-S+k)(-S+k-1)B_{k}x^{-S+k-2}
+\sum_{k=2S}(-S+k)(-S+k-1)B_{k}x^{-S+k-2}
\\&&
+C_S\sum_{k=2S}(-2S+2k-1)A_{k-2S}x^{-S+k-2}
+C_S\ln x f''
,\\&&
k<2S-1
,\quad
B_{k+1}
=
{(-S+k)(-S+k+1)+{3\over16}\over(k+1)(-2S+k+1)}B_k
,\\&&
k=2S-1
,\quad
C_S
=
{(S-1)S+{3\over16}\over2S}B_{2S-1}
,\\&&
k>=2S
,\quad
B_{k+1}
=
{(-S+k)(-S+k+1)+{3\over16}\over(k+1)(-2S+k+1)}B_k
+{(-2S+2k+1)A_{k-2S}-(-2S+2k+2)A_{k-2S+1}\over(k+1)(-2S+k+1)}C_S
,\\&&
\sum^{k<2S-1}_{k=0}(k+1)(-2S+k+1)B_{k+1}x^{-S+k+1}
-\sum^{k<2S}_{k=0}(-S+k)(-S+k-1)B_{k}x^{-S+k+1}
-\sum^{k<2S}_{k=0}(-2S+2k)B_{k}x^{-S+k+1}
\\&&
-{3\over16}\sum^{k<2S}_{k=0}B_kx^{-S+k+1}
+\sum_{k=2S}(k+1)(-2S+k+1)B_{k+1}x^{-S+k+1}
-\sum_{k=2S}(-S+k)(-S+k+1)B_{k}x^{-S+k+1}
-{3\over16}\sum_{k=2S}B_kx^{-S+k+1}
\\&&
+C_S\sum_{k=2S}2SA_{0}x^{S}
+C_S\sum_{k=2S}(-2S+2k+2)A_{k+1-2S}x^{-S+k+1}
-C_S\sum_{k=2S}(-2S+2k+1)A_{k-2S}x^{-S+k+1}
=
0
,\\&&
(k+1)(-2S+k+1)B_{k+1}
-(-S+k)(-S+k+1)+{3\over16}B_k
=
0
.\eqbl

Regular solution near $t=0$
\bqbl
&&
F
=
\ln t\sum_{k=0}C_kt^{k}
+\sum_{k=0}D_kt^{k}
,\quad
F
=
\sum_{k=0}C_kt^{k}
,\quad
F'
=
\sum_{k=0}kC_{k}t^{k-1}
,\quad
F''
=
\sum_{k=0}k(k-1)C_{k}t^{k-2}
,\\&&
C_0
=
1
,\\&&
C_1
=
S^2
+{3\over16}
,\\&&
C_{k+2}
=
{(k+1)(2k+3)+S^2+{3\over16}\over(k+2)^2}C_{k+1}
-{k(k+1)+{3\over16}\over(k+2)^2}C_k
,\\&&
C_{k+1}
=
{k(2k+1)+S^2+{3\over16}\over(k+1)^2}C_{k}
-{(k-1)k+{3\over16}\over(k+1)^2}C_{k-1}
.\eqbl
Unified representation
\bqbl
&&
F
=
f\ln(1-x)
+g
,\\&&
-\left[
  x^2(1-x)f''
 +x(1-2x)f'
 -S^2f
 -{3\over16}xf
 \right]{\ln(1-x)\over x}
+2xf'
+f
=
\\&&
{x^2(1-x)g''
+x(1-2x)g'
-S^2g
-{3\over16}xg\over x}
,\\&&
f=
\sum_{k=-1}A_kx^{S+k}
,\quad
f'
=
\sum_{k=-1}(S+k)A_{k}x^{S+k-1}
,\quad
f''
=
\sum_{k=-1}(S+k)(S+k-1)A_{k}\nu^{S+k-2}
,\\&&
g=
\sum_{k=0}B_kx^{S+k}
,\quad
g'
=
\sum_{k=0}(S+k)B_{k}x^{S+k-1}
,\quad
g''
=
\sum_{k=0}(S+k)(S+k-1)B_{k}\nu^{S+k-2}
,\\&&
\sum_{k=-1}\left[
  (2kS+k^2)A_{k}
 -x(S+k)(S+k+1)A_{k}
 -x{3\over16}A_{k}
 \right]\sum_{n=0}{x^n\over n+1}x^{k}
\\&&
+\sum_{k=-1}(2S+2k+1)A_{k}x^{k}
=
\sum_{k=0}\left[
  (2kS+k^2)B_{k}
 -x(S+k)(S+k+1)B_{k}
 -x{3\over16}B_{k}
 \right]x^{k-1}
,\\&&
\sum_{n=0}\sum_{k=n-1}{2(k-n)S+(k-n)^2\over n+1}A_{k-n}x^{k}
-\sum_{n=0}\sum_{k=n}{(S+k-n-1)(S+k-n)+{3\over16}\over n+1}A_{k-n-1}x^{k}
\\&&
+\sum_{k=-1}(2S+2k+1)A_{k}x^{k}
=
\sum_{k=0}\left[
  (2(k+1)S+(k+1)^2)B_{k+1}
 -(S+k)(S+k+1)B_{k}
 -{3\over16}B_{k}
 \right]x^{k}
,\\&&
\sum^{n<k+2}_{n=0}{2(k-n)S+(k-n)^2\over n+1}A_{k-n}
-\sum^{n<k+1}_{n=0}{(S+k-n-1)(S+k-n)+{3\over16}\over n+1}A_{k-n-1}
+(2S+2k+1)A_{k}
\\&&
=
 (2(k+1)S+(k+1)^2)B_{k+1}
-(S+k)(S+k+1)B_{k}
-{3\over16}B_{k}
,\\&&
(k+1)(2S+k+1)A_{k}
+\sum^{n<k+1}_{n=0}{2(k-n-1)S+(k-n-1)^2\over n+2}A_{k-n-1}
-\sum^{n<k+1}_{n=0}{(S+k-n-1)(S+k-n)+{3\over16}\over n+1}A_{k-n-1}
\\&&
=
 (2(k+1)S+(k+1)^2)B_{k+1}
-(S+k)(S+k+1)B_{k}
-{3\over16}B_{k}
,\\&&
(k+1)(2S+k+1)A_{k}
+\sum^{n<k+1}_{n=0}{-S(Sn+2S+2k-n)-(k+1)(k-n-1)-{3\over16}(n+2)
 \over(n+1)(n+2)}A_{k-n-1}
\\&&
=
 (2(k+1)S+(k+1)^2)B_{k+1}
-(S+k)(S+k+1)B_{k}
-{3\over16}B_{k}
.\eqbl
Matching conditions
\bqbl
&&
x^{T}f
=
x^{T}\sum^{k<K+1}_{k=0}D_kx^{k}
=
g
=
\sum^{k<K+1}_{k=0}C_k(1-x)^{k}
,\quad
T
\equiv
S-1
,\\&&
\sum^{m<M+1}_{m=0}{T!\over{(T-m)!(M-m)!m!}}f^{(M-m)}
=
(-1)^MC_M
,\\&&
x^{T}f
=
g
,\quad
\sum^{m<M+1}_{m=0}{M!\over{(M-m)!m!}}(x^{T})^{(m)}f^{(M-m)}
=
g^{(M)}
=
(-1)^MM!C_M
,\\&&
\sum^{k<K+1}_{k=m}{(k+T)!\over(k-m)!}D_kx^{k+T-m}
=
\sum^{k<K+1}_{k=0}{(k+1-S)!\over(k+1-S-m)!}C_k(1-x)^{k+1-S-m}
.\eqbl
Differential equation for $F^N(\gn)$
\bqbl
&&
(1-\gn^2)F''^N
+{1\over\gn}F'^N
-3\gn F'^N
-{N^2\over\gn^2}F
-{3\over4}F^N
=
0
,\\&&
x
\equiv
\gn^2
,\quad
S^2
\equiv
{N^2\over4}
,\\&&
x^2(1-x)F''^N
+x(1-2x)F'^N
-S^2F
-{3\over16}xF^N
=
0
,\\&&
t
\equiv
1-x
,\\&&
(1-t)^2tF''^N
+(1-t)(1-2t)F'^N
-S^2F
-{3\over16}(1-t)F^N
=
0
.\eqbl
General representation for regular solution near $t=0$
\bqbl
&&
F
=
\ln t\sum_{k=0}C_kt^{k}
+\sum_{k=0}D_kt^{k}
,\quad
F
=
\sum_{k=0}C_kt^{k}
,\quad
F'
=
\sum_{k=0}kC_{k}t^{k-1}
,\quad
F''
=
\sum_{k=0}k(k-1)C_{k}t^{k-2}
,\\&&
C_0
=
1
,\\&&
C_1
=
S^2
+{3\over16}
,\\&&
C_{k+2}
=
{(k+1)(2k+3)+S^2+{3\over16}\over(k+2)^2}C_{k+1}
-{k(k+1)+{3\over16}\over(k+2)^2}C_k
,\\&&
C_{k+1}
=
{k(2k+1)+S^2+{3\over16}\over(k+1)^2}C_{k}
-{(k-1)k+{3\over16}\over(k+1)^2}C_{k-1}
.\eqbl

#endif
}
int ESAextBext2Spl()
{
  Undef ESSpl2BrBtBz();
  Undef ESSpl2BrBtBzBrrBtrBzr();
  extern int ESNLt;	/* undefined */
  extern int ESnAP;	/* undefined */
  extern double *rcT2a;	/* undefined */
  extern double *rsT2a;	/* undefined */
  extern double *rcT1a;	/* undefined */
  extern double *rsT1a;	/* undefined */
  extern double cr2gp;	/* undefined */
  extern double ESgimn;	/* undefined */
  extern double ESgimx;	/* undefined */
  static double rc[];	/*  .mzl_2Dcore:escA2R.c */
  static double rs[];	/*  .mzl_2Dcore:escA2R.c */
  static double rs1t[];	/*  .mzl_2Dcore:escA2R.c */
  static double rc1a[];	/*  .mzl_2Dcore:escA2R.c */
  static double rs1a[];	/*  .mzl_2Dcore:escA2R.c */
  static double rc1t[];	/*  .mzl_2Dcore:escA2R.c */
/*
   */
#ifdef Doc_ESAextBext2Spl
\section{Decomposition of the vector potential in ESC}
Poloidal Jacobian
\bqbl
D
=&&
 2r^c_{\cup1}b
+a[2x_{\cup0}b+4x^c_{\cup2}b-4r^s_{\cup1}y_{\cup0}]\cos\gt
+4a[x^s_{\cup2}b+r^c_{\cup1}y_{\cup0}]\sin\gt
\\&&
+a(r^c_{\cup1}b)'_a
+a^2x'^c_{\cup2,a}b
+a(r'^c_{\cup1,a}b-r^c_{\cup1}b'_a+x'^c_{\cup2,a}b)\cos2\gt
+a(r'^s_{\cup1,a}b-r^s_{\cup1}b'_a)\sin2\gt
\\&&
+a^2x'_{\cup0,a}b\cos\gt
+4a^2x^c_{\cup2}b'_a\sin\gt\sin2\gt
+2a^2x'^s_{\cup2,a}b\cos\gt\sin2\gt
-4a^2x^s_{\cup2}b'_a\sin\gt\cos2\gt
\\&&
+2a^2r^c_{\cup1}y'_{\cup0,a}\sin\gt
-2a^2r^s_{\cup1}y'_{\cup0,a}\cos\gt
+4ax^c_{\cup2}(a^2y_{\cup0})'_a\sin2\gt
-4ax^s_{\cup2}(a^2y_{\cup0})'_a\cos2\gt
\\&&
-a^2x'_\gt(a^2y_{\cup0})'_a
+a^2(3x+ax'_a)b\cos\gt
-a^2x'_\gt(ab)'_a\sin\gt
,\\
D
=&&
 2r^c_{\cup1}b
+a[(2x_{\cup0}+ax'_{\cup0,a})b+4ax^c_{\cup2}b-4ar^s_{\cup1}y_{\cup0}]\cos\gt
+4a[x^s_{\cup2}b+r^c_{\cup1}y_{\cup0}]\sin\gt
+a^2d
.\eqbl
Toroidal flux and scalar potential (index 0 refers to the value at the 
axis of coordinates $a=0$)
\bqbl
&&
\bgF_{00}
+\bgF_{\til0}
+\int^a_0a^2V'_{\cup\cup,\gt}da
=
\int^a_0aB_tDda
,\quad
{\bgF'_{00}\over a}
+{\bgF'_{\til0,a}\over a}
+aV'_{\cup\cup,\gt}
=
B_tD
,\\&&
\bgF_{00}
+\bgF_{\til0}
=
{1\over2\gp}\int_0^a ada\oint B_tDd\gt
,\quad
{\bgF'_{00}\over a}
+{\bgF'_{\til0,a}\over a}
=
{1\over2\gp}\oint B_tDd\gt
,\\&&
(B_tD)_{\cup\til}
=
B_tD
-{1\over2\gp}\oint B_tDd\gt
,\quad
{(B_tD)_{\cup\til}\over a}
=
B_{t0}{(D)_{\cup\til}\over a}
+\left[{B_t-B_{t0}\over a}D\right]_{\cup\til}
,\\&&
V_{\cup\cup}
\equiv
{1\over a}\int^\gt_0(B_tD)_{\cup\til}d\gt
=
\int^\gt_0{(B_tD)\over a}d\gt
-{\gt\over2\gp}\oint{(B_tD)\over a}d\gt
,\quad
V_{\cup0}
\equiv
{1\over2\gp}\oint V_{\cup\cup}d\gt
.\eqbl
Poloidal flux
\bqbl
&&
\bgY_{00}
+\bgY_{\cup\til}
+u'_{\cup0,\gf}
=
\int^a_0(rB_z-B_tz'_\gf)r'_ada
+\int^a_0(B_tr'_\gf-rB_r)z'_ada
+\int^a_0a^2(V_{\cup\cup}-V_{\cup0})'_\gf da
\\&&
a{\bgY'_{00}\over a}
+\bgY'_{\cup\til,a}
+a{u''_{\cup0,a\gf}\over a}
=
 (rB_z-B_tz'_\gf)r'_a
+(B_tr'_\gf-rB_r)z'_a
+a^2(V_{\cup\cup}-V_{\cup0})'_\gf
.\eqbl
Radial component of the vector potential
\bqbl
&&
{\gh\over a}
=
 a\int^\gt_0V'_{\cup\cup,\gt}d\gt
-\int^\gf_0{u''_{\cup0,a\gf}\over a}d\gf
,\quad
{\gh'_\gt\over a}
=
 aV'_{\cup\cup,\gt}
=
 a{(B_tD)_{\cup\til}\over a}
.\eqbl
Relationsips between physical and contravariant components
\bqbl
&&
rDB^a
=
(rB_r-B_tr'_\gf){z'_\gt\over a}
+(B_tz'_\gf-r B_z){r'_\gt\over a}
=
-{\bgY'_{\cup\til,\gt}\over a}
-a{\bgF'_{\til0,\gf}\over a^2}
,\\&&
rDB^\gf
=
DB_t
=
{\bgF'_{00}\over a}+{\bgF'_{\til0,a}\over a}+a{\gh'_\gt\over a^2}
=
{\bgF'_{00}\over a}+{\bgF'_{\til0,a}\over a}+aV'_{\cup\cup,\gt}
,\\&&
arDB^\gt
=
 (rB_z-B_tz'_\gf)r'_a
+(B_tr'_\gf-rB_r)z'_a
=
a{\bgY'_{00}\over a}+\bgY'_{\cup\til,a}-a{\gh'_\gf\over a}
.\eqbl

#endif
}
#ifndef stg_NrmDspl
int ESNormDispl(iA,iT,M,N)
  int iA;	/*  */
  int iT;	/*  */
  int M;	/*  */
  int N;	/*  */
{
  Undef Scale2D();
  Undef Plot2d();
  Undef splr1();
  Undef cos();
  Undef sin();
  Undef CbFlush();
  Undef f2spl();
  Undef ESRealGeom();
  extern int ESLt0;	/* undefined */
  extern double c2gp;	/* undefined */
  extern double *ESgh;	/* undefined */
  extern int spl_p();	/* undefined */
  extern double *cs1T;	/* undefined */
  extern double *sn1T;	/* undefined */
  extern double *drsT;	/* undefined */
  extern double *drcT;	/* undefined */
  extern double *r;	/* undefined */
  extern double *z;	/* undefined */
  extern double *rT;	/* undefined */
  extern double *zT;	/* undefined */
  extern int ESFp;	/* undefined */
  extern double *drcT2a;/* undefined */
  extern double *drsT2a;/* undefined */
  extern double *drcT1a;/* undefined */
  extern double *drsT1a;/* undefined */
  extern double *bT2a;	/* undefined */
  int ESP2F();		/* No prototype */
  static double rc1a[];	/*  .mzl_2Dcore:escA2R.c */
  static double rs1a[];	/*  .mzl_2Dcore:escA2R.c */
  static double rc[];	/*  .mzl_2Dcore:escA2R.c */
  static double rs[];	/*  .mzl_2Dcore:escA2R.c */
/*
   */
#ifdef Doc_ESNormDispl
\section{Normal component of coordinate displacement}
Equation for the displacement
\bqbl
&&
a
=
\bsa
+\gx
,\quad
B^a\gx'_a
+B^\gf\gx'_\gf
+B^\gt\gx'_\gt
=
B^a
,\quad
a
=
\bsa
+\gx_{\cup0}
+\gx_{\cup\til}
,\quad
\gx_{\cup0}
\equiv
{\bgF_{00}-\bgF_{\cup0}\over\bgF'_{00}}
.\eqbl
Linearized equation for the displacement
\bqbl
&&
(\bgF'_{00}+\gh'_\gt)\gx'_{\cup\til,\gf}
+(\bgY'_{00}-\gh'_\gf)\gx'_{\cup\til,\gt}
=
-\bgY'_{\cup\til,\gt}
-\bgF'_{\til0,\gf}
.\eqbl
Representation of the RHS
\bqbl
&&
-\bgY'_{\cup\til,\gt}
-\bgF'_{\til0,\gf}
=
-\bgY'_{\cup\til,\gt}
+a{\gh'_\gt\over a}{\bgF'_{\til0,\gf}\over\bgF'_{00}}
-a(\bgF'_{00}+\gh'_\gt){\bgF'_{\til0,\gf}\over a\bgF'_{00}}
\eqbl
and representation of the normal displacement
\bqbl
&&
\gx
=
\gx_{\til\til}
+\gx_{\til0}
,\quad
\gx_{\til0}
=
a{\bgF_{00}-\bgF_{\til0}\over a\bgF'_{00}}
,\\&&
\left(1+{\gh'_\gt\over\bgF'_{00}}\right)\gx'_{\til\til,\gf}
+\left(\gi-{\gh'_\gf\over\bgF'_{00}}\right)\gx'_{\til\til,\gt}
=
-{\bgY'_{\til\til,\gt}\over\bgF'_{00}}
+a^2{\gh'_\gt\over a\bgF'_{00}}{\bgF'_{\til0,\gf}\over a\bgF'_{00}}
=
\gy'_{\cup\til,\gt}
.\eqbl
Straight field line angle coordinate $\gq$ and the solution for 
the displacement
\bqbl
&&
\gq
\equiv
\gt
+{\gh\over\bgF'_{00}}
,\quad
\gy_{\cup\til}
=
\gy_{\cup\til}(a,\gf,\gq)
,\quad
\gx_{\cup\til}
=
\gx_{\cup\til}(a,\gf,\gq)
,\\&&
\gx'_{\cup\til,\gf}
+\gi\gx'_{\cup\til,\gq}
=
\gy'_{\cup\til,\gq}
,\\&&
\gy
=
\gy_{00}
+2\sum^{m<M\atop n<N}_{m=1\atop n=0}\left[
  \gy^c_{mn}\cos(m\gq-n\gf)
  +\gy^s_{mn}\sin(m\gq-n\gf)
 \right]
.\eqbl
Rotational transform and the resonant harmonics
\bqbl
\gi
=&&
{1\over q}
=
{\bgY'_{00}\over\bgF'_{00}}
,\quad
m^*\gi(a_{mn})
=
n^*
,\\
\gy
=&&
\gy_{00}
+2\sum^{m^\nst<M\atop n^\nst<N}_{m^\nst=1\atop n^\nst=0}\left[
  \gy^c_{m^\nst n^\nst}\cos(m^\nst\gq-n^\nst\gf)
  +\gy^s_{m^\nst n^\nst}\sin(m^\nst\gq-n^\nst\gf)
 \right]
\\&&
+2\sum^{m^*<M\atop n^*<N}_{m^*,n^*}\left[
  \gy^c_{mn}\cos(m^*\gq-n^*\gf)
  +\gy^s_{mn}\sin(m^*\gq-n^*\gf)
 \right]
.\eqbl
For nonresonant harmonics the solution for the displacement
\bqbl
&&
\gx
=
{\bgF_{\cup 0}-\bgF_{00}\over\bgF'_{00}}
+2\sum^{m^\nst<M\atop n^\nst<N}_{m^\nst=1\atop n^\nst=0}\left[
  \gx^c_{m^\nst n^\nst }\cos(m^\nst\gq-n^\nst\gf)
  +\gx^s_{m^\nst n^\nst}\sin(m^\nst\gq-n^\nst\gf)
 \right]
,\\&&
\gx^c_{m^\nst n^\nst}
={m^\nst\gy^c_{m^\nst n^\nst}\over m^\nst\gi-n^\nst}
,\quad
\gx^s_{m^\nst n^\nst}
={m^\nst\gy^s_{m^\nst n^\nst}\over m^\nst\gi-n^\nst}
,\\&&
\gd r
=
r'_a\gx
+{r'_\gt\over a}\gs
,\quad
\gd z
=
z'_a\gx
+{z'_\gt\over a}\gs
,\quad
\gd r{z'_\gt\over a}
-\gd z{r'_\gt\over a}
=
D\gx
.\eqbl

\section{Advancing coordinate system}
Fourier representation for RHS
\bqbl
\gy
=&&
 2\sum^{m\leq M}_{m=1}\left[
  \gy^{cc}_{m0}
 +2\sum^{m\leq M}_{m=1}\left(
   \gy^{cc}_{mn}\cos n\gf
  +\gy^{cs}_{mn}\sin n\gf
  \right)
 \right]\cos m\gq
\\&&
+2\sum^{m\leq M}_{m=1}\left[
   \gy^{sc}_{m0}
 +2\sum^{m\leq M}_{m=1}\left(
   \gy^{sc}_{mn}\cos n\gf
  +\gy^{ss}_{mn}\sin n\gf
  \right)
 \right]\sin m\gq
.\eqbl
Fourier representation for normal displacement
\bqbl
\gx
=&&
 2\sum^{m\leq M}_{m=1}\left[
  \gx^{cc}_{m0}
 +\sum^{m\leq M}_{m=1}\left(\gx^{cc}_{mn}\cos n\gf+\gx^{cs}_{mn}\sin n\gf
  \right)
 \right]\cos m\gq
\\&&
+2\sum^{m\leq M}_{m=1}\left[
   \gx^{sc}_{m0}
 +\sum^{m\leq M}_{m=1}\left(\gx^{sc}_{mn}\cos n\gf+\gx^{ss}_{mn}\sin n\gf
  \right)
 \right]\sin m\gq
,\\
\gx^{cc}_{m0}
=&&
{\gy^{cc}_{m0}\over\gi}
,\quad
\gx^{cc}_{mn}
=
 {\gy^{cc}_{mn}+\gy^{ss}_{mn}\over\gi-{n\over m}}
+{\gy^{cc}_{mn}-\gy^{ss}_{mn}\over\gi+{n\over m}}
,\quad
\gx^{cs}_{mn}
=
 {\gy^{cs}_{mn}+\gy^{sc}_{mn}\over\gi+{n\over m}}
-{\gy^{sc}_{mn}-\gy^{cs}_{mn}\over\gi-{n\over m}}
,\\
\gx^{sc}_{m0}
=&&
{\gy^{sc}_{m0}\over\gi}
,\quad
\gx^{sc}_{mn}
=
 {\gy^{sc}_{mn}-\gy^{cs}_{mn}\over\gi-{n\over m}}
+{\gy^{cs}_{mn}+\gy^{sc}_{mn}\over\gi+{n\over m}}
,\quad
\gx^{ss}_{mn}
=
 {\gy^{cc}_{mn}+\gy^{ss}_{mn}\over\gi-{n\over m}}
-{\gy^{cc}_{mn}-\gy^{ss}_{mn}\over\gi+{n\over m}}
.\eqbl

Equation for the displacement of coordinates
\bqbl
&&
a
\to
a
+\gx
,\quad
\gt
\to
\gt
+{\gs\over a}
,\quad
\gd r
=
r'_a\gx
+{r'_\gt\over a}\gs
,\quad
\gd z
=
z'_a\gx
+{z'_\gt\over a}\gs
,\quad
\gd r{z'_\gt\over a}
-\gd z{r'_\gt\over a}
=
r'_a{z'_\gt\over a}\gx
-z'_a{r'_\gt\over a}\gx
,\\&&
\gs
=
{\gd z-z'_a\gx\over b\cos\gt}
,\quad
\gd r
=
r'_a\gx
+{r'_\gt\over a}{\gd z-z'_a\gx\over b\cos\gt}
,\quad
\gd z
=
\gd Z_0
+a^2\gd z_{\cup0}
+a\gd b\sin\gt
,\\&&
\gd Z_0
+a^2\gd z_{\cup0}
+a\gd b
-z'_a\gx|_{\gt=\gp/2}
=
0
,\quad
\gd Z_0
+a^2\gd z_{\cup0}
-a\gd b
-z'_a\gx|_{\gt=-\gp/2}
=
0
,\\&&
\gd Z_0+a^2\gd z_{\cup0}
=
{z'_a\gx|_{\gt=\gp/2}+z'_a\gx|_{\gt=-\gp/2}\over2}
,\quad
\gd b
=
{z'_a\gx|_{\gt=\gp/2}-z'_a\gx|_{\gt=-\gp/2}\over2a}
.\eqbl
With the following representation for $\gx$
\bqbl
&&
\gx
=
a\gx_0
+2\gx^c_1\cos\gt
+2\gx^s_1\sin\gt
+2a\gx^c_2\cos2\gt
+2a\gx^s_2\sin2\gt
+2a^2\gx^c_3\cos3\gt
+2a^2\gx^s_3\sin3\gt
+a^3\gx_\til
,\\&&
\gx|_{\gt=\gp/2}
=
 a\gx_0
+2\gx^s_1
-2a\gx^c_2
-2a^2\gx^s_3
+a^3\gx_\til|_{\gt=\gp/2}
,\\&&
\gx|_{\gt=-\gp/2}
=
 a\gx_0
-2\gx^s_1
-2a\gx^c_2
+2a^2\gx^s_3
+a^3\gx_\til|_{\gt=-\gp/2}
,\eqbl
the perturbation of the $z$-coordinate is determined by
\bqbl
\gd b
=&&
(ab)'_a\left[
  \gx_0
 -2\gx^c_2
 +a^2{\gx_\til|_{\gt=\gp/2}+\gx_\til|_{\gt=-\gp/2}\over2}
 \right]
\\&&
+{(a^2z_0)'_a\over a}\left[
  2\gx^s_1
 -2a^2\gx^s_3
 +a^3{\gx_\til|_{\gt=\gp/2}-\gx_\til|_{\gt=-\gp/2}\over2}
 \right]
,\\
\gd Z_0+a^2\gd z_0
=&&
(ab)'_a\left[
  2\gx^s_1
 -2a^2\gx^s_3
+a^3{\gx_\til|_{\gt=\gp/2}-\gx_\til|_{\gt=-\gp/2}\over2}
 \right]
\\&&
+a(a^2z_0)'_a\left[
  \gx_0
 -2\gx^c_2
 +a^2{\gx_\til|_{\gt=\gp/2}+\gx_\til|_{\gt=-\gp/2}\over2}
 \right]
,\eqbl
and that of the $r$-coordinate is determined by 
Poloidal Jacobian
\bqbl
D
=&&
 2r^c_{\cup1}b
+a[2x_{\cup0}b+4x^c_{\cup2}b-4r^s_{\cup1}y_{\cup0}]\cos\gt
+4a[x^s_{\cup2}b+r^c_{\cup1}y_{\cup0}]\sin\gt
\\&&
+a(r^c_{\cup1}b)'_a
+a^2x'^c_{\cup2,a}b
+a(r'^c_{\cup1,a}b-r^c_{\cup1}b'_a+x'^c_{\cup2,a}b)\cos2\gt
+a(r'^s_{\cup1,a}b-r^s_{\cup1}b'_a)\sin2\gt
\\&&
+a^2x'_{\cup0,a}b\cos\gt
+4a^2x^c_{\cup2}b'_a\sin\gt\sin2\gt
+2a^2x'^s_{\cup2,a}b\cos\gt\sin2\gt
-4a^2x^s_{\cup2}b'_a\sin\gt\cos2\gt
\\&&
+2a^2r^c_{\cup1}y'_{\cup0,a}\sin\gt
-2a^2r^s_{\cup1}y'_{\cup0,a}\cos\gt
+4ax^c_{\cup2}(a^2y_{\cup0})'_a\sin2\gt
-4ax^s_{\cup2}(a^2y_{\cup0})'_a\cos2\gt
\\&&
-a^2x'_\gt(a^2y_{\cup0})'_a
+a^2(3x+ax'_a)b\cos\gt
-a^2x'_\gt(ab)'_a\sin\gt
,\\
D
=&&
 2r^c_{\cup1}b
+a[(2x_{\cup0}+ax'_{\cup0,a})b+4ax^c_{\cup2}b-4ar^s_{\cup1}y_{\cup0}]\cos\gt
+4a[x^s_{\cup2}b+r^c_{\cup1}y_{\cup0}]\sin\gt
+a^2\tbD
.\eqbl
\bqbl
\gd r
=&&
 2(ar^c_1)'_a\cos\gt\times
\\&&
 \left[
  a\gx_0
 +2\gx^c_1\cos\gt
 +2\gx^s_1\sin\gt
 +2a\gx^c_2\cos2\gt
 +2a\gx^s_2\sin2\gt
 +2a^2\gx^c_3\cos3\gt
 +2a^2\gx^s_3\sin3\gt
 +a^3\gx_\til
 \right]\gx
\\&&
+2(ar^s_1)'_a\sin\gt\times
\\&&
 \left[
  a\gx_0
 +2\gx^c_1\cos\gt
 +2\gx^s_1\sin\gt
 +2a\gx^c_2\cos2\gt
 +2a\gx^s_2\sin2\gt
 +2a^2\gx^c_3\cos3\gt
 +2a^2\gx^s_3\sin3\gt
 +a^3\gx_\til
 \right]\gx
\\&&
+\left[
  (a^2x_0)'_a
 +2(a^2x^c_2)'_a\cos2\gt
 +2(a^2x^s_2)'_a\sin2\gt
 +(a^3x_3)'_a
 \right]\times
\\&&
 \left[
  a\gx_0
 +2\gx^c_1\cos\gt
 +2\gx^s_1\sin\gt
 +2a\gx^c_2\cos2\gt
 +2a\gx^s_2\sin2\gt
 +2a^2\gx^c_3\cos3\gt
 +2a^2\gx^s_3\sin3\gt
 +a^3\gx_\til
 \right]\gx
\\&&
+{r'_\gt\over a}{\gd z-z'_a\gx\over b\cos\gt}
.\eqbl
At the magnetic axis
\bqbl
&&
\gd Z_0
=
2b\gx^s_{\cup 1}
,\quad
\gd r
=
 4r^c_{\cup1}\gx^c_{\cup1}
+4r^s_{\cup1}\gx^s_{\cup1}
.\eqbl

\section{3-D Equilibrium equations}
Contravariant components of magnetic field
\bqbl
&&
arDB^a
=
\bgY'_\gt-\bgF'_\gf
,\quad
arDB^\gf
=
\bgF'_a+\gh'_\gt
,\quad
arDB^\gt
=
-\bgY'_a-\gh'_\gf
.\eqbl
Contravariant components of the current density
\bqbl
&&
arDj^a
=
 F'_\gt
-J'_\gf
,\quad
arDj^\gf
=
J'_a+\gn'_\gt
,\quad
arDB^\gt
=
-F'_a-\gn'_\gf
.\eqbl
Maxwell equations
\bqbl
&&
\gm_0arDj^a
=
B'_{\gt,\gf}
-B'_{\gf,\gt}
,\quad
\gm_0arDj^\gf
=
B'_{a,\gt}
-B'_{\gt,a}
,\quad
\gm_0arDj^\gt
=
B'_{\gf,a}
-B'_{a,\gf}
.\eqbl
Radial plasma current
\bqbl
&&
B'_{\gt,\gf}
-B'_{\gf,\gt}
=
\gm_0arDj^a
,\\&&
 \left[
  {g_{a\gt}\over arD}(\bgY'_\gt-\bgF'_\gf)
 +{g_{\gf\gt}\over arD}(\bgF'_a+\gh'_\gt)
 +{g_{\gt\gt}\over arD}(-\bgY'_a-\gh'_\gf)
 \right]'_\gf
\\&&
-\left[
  {g_{a\gf}\over arD}(\bgY'_\gt-\bgF'_\gf)
 +{g_{\gf\gf}\over arD}(\bgF'_a+\gh'_\gt)
 +{g_{\gf\gt}\over arD}(-\bgY'_a-\gh'_\gf)
 \right]'_\gt
=
 \gm_0(F'_\gt-J'_\gf)
.\eqbl
Poloidal plasma current
\bqbl
&&
B'_{\gf,a}
-B'_{a,\gf}
=
\gm_0arDj^\gt
,\\&&
 \left[
  {g_{a\gf}\over arD}(\bgY'_\gt-\bgF'_\gf)
 +{g_{\gf\gf}\over arD}(\bgF'_a+\gh'_\gt)
 +{g_{\gf\gt}\over arD}(-\bgY'_a-\gh'_\gf)
 \right]'_a
\\&&
-\left[
  {g_{aa}\over arD}(\bgY'_\gt-\bgF'_\gf)
 +{g_{a\gf}\over arD}(\bgF'_a+\gh'_\gt)
 +{g_{a\gt}\over arD}(-\bgY'_a-\gh'_\gf)
 \right]'_\gf
=
-\gm_0(F'_a+\gn'_\gf)
.\eqbl
Toroidal plasma current
\bqbl
&&
\gm_0arDj^\gf
=
B'_{a,\gt}
-B'_{\gt,a}
,\\&&
 \left[
  {g_{aa}\over arD}(\bgY'_\gt-\bgF'_\gf)
 +{g_{a\gf}\over arD}(\bgF'_a+\gh'_\gt)
 +{g_{a\gt}\over arD}(-\bgY'_a-\gh'_\gf)
 \right]'_\gt
\\&&
-\left[
  {g_{a\gt}\over arD}(\bgY'_\gt-\bgF'_\gf)
 +{g_{\gf\gt}\over arD}(\bgF'_a+\gh'_\gt)
 +{g_{\gt\gt}\over arD}(-\bgY'_a-\gh'_\gf)
 \right]'_a
=
\gm_0(J'_a+\gn'_\gt)
.\eqbl

\section{Expansion of Maxwell equations near the axis}
Coordinates and their first derivatives
\bqbl
r
=&&
 R_0
+2ar^c_{\cup1}\cos\gt
+2ar^s_{\cup1}\sin\gt
+a^2x_{\cup0}
+2a^2x^c_{\cup2}\cos2\gt
+2a^2x^s_{\cup2}\sin2\gt
,\\
r'_a
=&&
 2r^c_{\cup1}\cos\gt
+2r^s_{\cup1}\sin\gt
+2ax_{\cup0}
+4ax^c_{\cup2}\cos2\gt
+4ax^s_{\cup2}\sin2\gt
,\\
{r'_\gt\over a}
=&&
-2r^c_{\cup1}\sin\gt
+2r^s_{\cup1}\cos\gt
-4ax^c_{\cup2}\sin2\gt
+4ax^s_{\cup2}\cos2\gt
,\\
r'_\gf
=&&
 R'_{0,\gf}
+2ar'^c_{1\til 0,\gf}\cos\gt
+2ar'^s_{1\til 0,\gf}\sin\gt
+a^2x'_{\cup0,\gf}
+2a^2x'^c_{\cup2,\gf}\cos2\gt
+2a^2x'^s_{\cup2,\gf}\sin2\gt
,\\
z
=&&
 Z_0
+a^2y_{\cup0}
+ab\sin\gt
,\\
z'_a
=&&
b\sin\gt
+2ay_{\cup0}
,\\
{z'_\gt\over a}
=&&
b\cos\gt
,\\
z'_\gf
=&&
Z'_{0,\gf}
+a^2y'_{\cup0,\gf}
+ab'_\gf\sin\gt
,\\
D
=&&
 2r^c_{\cup1}b
+2ax_{\cup0}b\cos\gt
+4ar^c_{\cup1}y_{\cup0}\sin\gt
-4ar^s_{\cup1}y_{\cup0}\cos\gt
+4ax^c_{\cup2}b\cos\gt
+4ax^s_{\cup2}b\sin\gt
,\\
D_{\gf\gt}
=&&
-R'_{0,\gf}b\cos\gt
-2r^c_{\cup1}Z'_{0,\gf}\sin\gt
+2r^s_{\cup1}Z'_{0,\gf}\cos\gt
-4ax^c_{\cup2}Z'_{0,\gf}\sin2\gt
+4ax^s_{\cup2}Z'_{0,\gf}\cos2\gt
\\&&
-2ar^c_{\cup1}b'_\gf\sin^2\gt
+ar^s_{\cup1}b'_\gf\sin2\gt
-2ar'^c_{1\til 0,\gf}b\cos^2\gt
-ar'^s_{1\til 0,\gf}b\sin2\gt
.\eqbl
Components of the vector potential
\bqbl
&&
\gh
=
 2a\gh^c_{\cup1}\cos\gt
+2a\gh^s_{\cup1}\sin\gt
-2a\gh^c_{\cup1}
+a^2\gh{\cup0}
+2a^2\gh^c_{\cup2}\cos2\gt
+2a^2\gh^s_{\cup2}\sin2\gt
-2a^2\gh^c_{\cup2}
,\\&&
\bgF
=
 {1\over2}\bgF''_{00}a^2
+{1\over2}\bgF''_{\til0}a^2
,\\&&
\bgY
=
 \bgY_{00}
+{1\over2}\bgY''_{00}a^2
+2a\bgY^c_{\cup1}\cos\gt
+2a\bgY^s_{\cup1}\sin\gt
+2a^2\bgY^c_{\cup2}\cos2\gt
+2a^2\bgY^s_{\cup2}\sin2\gt
.\eqbl

\section{Expansion near the axis of RMC}
Coordinates and their first derivatives
\bqbl
r
=&&
R_0
+2ar^c_{\cup1}\cos\gt
+2ar^s_{\cup1}\sin\gt
+a^2r_{2\cup0}
,\\
r'_a
=&&
2r^c_{\cup1}\cos\gt
+2r^s_{\cup1}\sin\gt
+2ax_{\cup0}
,\\
{r'_\gt\over a}
=&&
-2r^c_{\cup1}\sin\gt
+2r^s_{\cup1}\cos\gt
,\\
r'_\gf
=&&
R'_{0,\gf}
+2ar'^c_{1\til 0,\gf}\cos\gt
+2ar'^s_{1\til 0,\gf}\sin\gt
+a^2r'_{2\cup0,\gf}
,\\
z
=&&
Z_0
+a^2z_{\cup0}
+ab\sin\gt
,\\
z'_a
=&&
b\sin\gt
+2ay_{\cup0}
,\\
{z'_\gt\over a}
=&&
b\cos\gt
,\\
z'_\gf
=&&
Z'_{0,\gf}
+a^2z'_{\til 0,\gf}
+ab'_\gf\sin\gt
,\\
D
=&&
2r^c_{\cup1}b
+2ar_{2\cup0}b\cos\gt
-2az_{\cup0}(-2r^c_{\cup1}\sin\gt+2r^s_{\cup1}\cos\gt)
,\\
D_{\gf\gt}
=&&
-R'_{0,\gf}b\cos\gt
-Z'_{0,\gf}(2r^c_{\cup1}\sin\gt-2r^s_{\cup1}\cos\gt)
\\&&
+a(-2r^c_{\cup1}\sin^2\gt+2r^s_{\cup1}\cos\gt\sin\gt)b'_\gf
+a(-2r'^c_{1\til 0,\gf}\cos^2\gt-2r'^s_{1\til 0,\gf}\sin\gt\cos\gt)b
.\eqbl
Expansion of the vector potential
\bqbl
&&
A_r
=
A_r
+a[A'_{r,r}(2r^c_{\cup1}\cos\gt+2r^s_{\cup1}\sin\gt)+A'_{r,z}b\sin\gt]
,\\&&
A_z
=
A_z
+a[A'_{z,r}(2r^c_{\cup1}\cos\gt+2r^s_{\cup1}\sin\gt)+A'_{z,z}b\sin\gt]
,\\&&
A'_{r,t}
=
A'_{r,t}
+a[A''_{r,rt}(2r^c_{\cup1}\cos\gt+2r^s_{\cup1}\sin\gt)+A''_{r,tz}b\sin\gt]
,\\&&
A'_{z,t}
=
A'_{z,t}
+a[A''_{z,rt}(2r^c_{\cup1}\cos\gt+2r^s_{\cup1}\sin\gt)+A''_{z,tz}b\sin\gt]
,\\&&
(A_rr'_a+A_zz'_a)|_{\gt=0}
=
2A_rr^c_{\cup1}
,\\&&
(A_rr'_\gf+A_zz'_\gf)|^\gt_0
=
A_r(R'_{0,\gf}+2ar'^c_{1\til 0,\gf}+a^2r'_{2\cup0,\gf})
+A_zZ'_{0,\gf}
.\eqbl
Toroidal component of the vector potential
\bqbl
&&
A_\gf+u'_{\til 0,\gf}
=
rA_t
+(A_rr'_\gf+A_zz'_\gf)|_{\gt=0}
-\int^\gt_0(
  A'_{r,t}r'_\gt
  +A'_{z,t}z'_\gt
  +aB_tD_{\gf\gt}
 )d\gt
-\gt\bgF'_{\cup 0,\gf} 
,\\&&
rA_t
=
(rA_t)_{00}
+(rA_t)_{\til0}
+a(rA_t)'_r(2r^c_{\cup1}\cos\gt+2r^s_{\cup1}\sin\gt)
+a(rA_t)'_zb\sin\gt
\\&&\qquad
+a^2(rA_t)'_r3r_{2\cup0}
+a^2(rA_t)'_z3z_{\cup0}
+a^2(rA_t)''_{rr}(r^{c2}_{1\til 0}+r^{s2}_{1\til 0})
+a^2(rA_t)''_{rz}br^s_{\cup1}
+{a^2\over4}(rA_t)''_{zz}b^2
,\\&&
(A_rr'_\gf+A_zz'_\gf)|_{\gt=0}
=
A_rR'_{0,\gf}
+A_zZ'_{0,\gf}
+2aA'_{r,r}R'_{0,\gf}r^c_{\cup1}
+2aA'_{z,r}Z'_{0,\gf}r^c_{\cup1}
+2aA_rr'^c_{1\til 0,\gf}
,\\&&
A'_{r,t}r'_\gt
+A'_{z,t}z'_\gt
+aB_tD_{\gf\gt}
+\bgF'_{\cup 0,\gf}
=
aA'_{r,t}(-2r^c_{\cup1}\sin\gt+2r^s_{\cup1}\cos\gt)
+aA'_{z,t}b\cos\gt
\\&&\qquad
-aB_tR'_{0,\gf}b\cos\gt
-aB_tZ'_{0,\gf}(2r^c_{\cup1}\sin\gt-2r^s_{\cup1}\cos\gt)
,\\&&
\int^\gt_0(
  A'_{r,t}r'_\gt
  +A'_{z,t}z'_\gt
  +aB_tD_{\gf\gt}
 )d\gt
+\gt\bgF'_{\cup 0,\gf} 
=
a(A'_{r,t}+B_tZ'_{0,\gf})(2r^c_{\cup1}\cos\gt+2r^s_{\cup1}\sin\gt)
\\&&\qquad
+a(A'_{z,t}-B_tR'_{0,\gf})b\sin\gt
-a(A'_{r,t}+B_tZ'_{0,\gf})2r^c_{\cup1}
.\eqbl
Scalar potential $u_{\cup 0}$ and angle displacement $\gh$
\bqbl
&&
u'_{\cup0,\gf}
=
rA_t
+A_rR'_{0,\gf}
+A_zZ'_{0,\gf}
,\\&&
u''_{\cup0,a\gf}
=
2(A_rr^c_{\cup1})'_\gf
,\\&&
u'_{\cup 0,a}
=
2A_rr^c_{\cup1}
-2(A_rr^c_{\cup1})|_{\gf=0}
,\\&&
\gh
=
0
.\eqbl
Poloidal flux
\bqbl
&&
{\bgY_{00}-(rA_t)_{00}\over a^2}
=
 3(rA_t)'_rr_{2\cup0}
+3(rA_t)'_zz_{\cup0}
+(rA_t)''_{rr}(r^{c2}_{\cup1}+r^{s2}_{\cup1})
+(rA_t)''_{rz}br^s_{\cup1}
+{1\over4}(rA_t)''_{zz}b^2
,\\&&
{\bgY_{\cup\til}\over a}
=
2\bgY^c_{\cup0}\cos\gt
+2\bgY^s_{\cup0}\sin\gt
,\\&&
\bgY^c_{\cup0}
=
[(rA_t)'_r-A'_{r,t}-B_tZ'_{0,\gf}]r^c_{\cup1}
,\\&&
\bgY^s_{\cup0}
=
[(rA_t)'_r-A'_{r,t}-B_tZ'_{0,\gf}]r^s_{\cup1}
+{1\over2}[(rA_t)'_z-A'_{z,t}+B_tR'_{0,\gf}]b
.\eqbl
Displacement of the axis of RMC
\bqbl
&&
{\gy_{\cup\cup}\over a}
=
2\bgY^c_{\cup1}\cos\gq
+2\bgY^s_{\cup1}\sin\gq
,\\&&
\bgY^c_{\cup1}
=
\sum^{n<N}_{n=0}\left[
  \bgY^{cc}_{n1}\cos n\gf
 +\bgY^{cs}_{n1}\sin n\gf
 \right]
,\\&&
\bgY^s_{\cup1}
=
\sum^{n<N}_{n=0}\left[
  \bgY^{sc}_{n1}\cos n\gf
 +\bgY^{ss}_{n1}\sin n\gf
 \right]
,\\&&
\gy^c_{n1}
=
 {1\over2}\bgY^{cc}_{n1}\cos(\gq-n\gf)
+{1\over2}\bgY^{ss}_{n1}\cos(\gq-n\gf)
,\\&&
\gy^c_{-n1}
=
 {1\over2}\bgY^{cc}_{n1}\cos(\gq+n\gf)
-{1\over2}\bgY^{ss}_{n1}\cos(\gq+n\gf)
,\\&&
\gy^s_{n1}
=
 {1\over2}\bgY^{sc}_{n1}\cos(\gq-n\gf)
-{1\over2}\bgY^{cs}_{n1}\sin(\gq-n\gf)
,\\&&
\gy^s_{-n1}
=
 {1\over2}\bgY^{cs}_{n1}\sin(\gq+n\gf)
+{1\over2}\bgY^{sc}_{n1}\cos(\gq+n\gf)
,\\&&
\gx
=
{\bgF_{\cup0}-\bgF_{00}\over\bgF'_{00}}
+2\sum^{n^\nst<N}_{n^\nst=0}\left[
  \gx^c_{n^\nst1}\cos(\gq-n^\nst\gf)
  +\gx^s_{n^\nst1}\sin(\gq-n^\nst\gf)
 \right]
,\\&&
\gx^c_{n^\nst1}
=
{\gy^c_{n^\nst1}\over\bgF'_{00}\left(\gm-n^\nst\right)}
,\quad
\gx^s_{n^\nst1}
=
{\gy^s_{n^\nst1}\over\bgF'_{00}\left(\gm-n^\nst\right)}
.\eqbl
Displacement of the axis of the RMC coordinates
\bqbl
&&
\gd r{z'_\gt\over a}
-\gd z{r'_\gt\over a}
=
D\gx
,\\&&
\gx
=
a\gx_{\cup0}
+2\gx^c_{\cup1}\cos\gt
+2\gx^s_{\cup1}\sin\gt
,\\&&
\gd R_0b\cos\gt
+\gd Z_0(2r^c_{\cup1}\sin\gt-2r^s_{\cup1}\cos\gt)
=
D\gx
,\\&&
\gd Z_0
=
2b\gx^s_{\cup1}
,\\&&
\gd R_0
=
2r^c_{\cup1}\gx^c_{\cup1}
+4r^s_{\cup1}\gx^s_{\cup1}
,\\&&
\gx^c_{\cup1}
=
\sum^{n^\nst<N}_{n^\nst=0}\left[
  \gx^c_{n^\nst1}\cos n^\nst\gf
 -\gx^s_{n^\nst1}\sin n^\nst\gf
 \right]
,\\&&
\gx^s_{\cup1}
=
\sum^{n^\nst<N}_{n^\nst=0}\left[
  \gx^c_{n^\nst1}\sin n^\nst\gf
 +\gx^s_{n^\nst1}\cos n^\nst\gf
 \right]
,\\&&
b\gd r^c_{\cup1}
-r^c_{\cup1}\gd b
=
2r^c_{\cup1}b\gx_{\cup0}
+2r_{2\cup0}b\gx^c_{\cup1}
-4z_{\cup0}r^s_{\cup1}\gx^c_{\cup1}
+4z_{\cup0}r^c_{\cup1}\gx^s_{\cup1}
,\\&&
 b\gd r^c_{\cup1}
+r^c_{\cup1}\gd b
=
 2r_{2\cup0}b\gx^c_{\cup1}
-4z_{\cup0}r^s_{\cup1}\gx^c_{\cup1}
-4z_{\cup0}r^c_{\cup1}\gx^s_{\cup1}
,\\&&
+b\gd r^s_{\cup1}
+r^s_{\cup1}\gd b
=
 4z_{\cup0}r^c_{\cup1}\gx^c_{\cup1}
+2br_{2\cup0}\gx^s_{\cup1}
 -4z_{\cup0}r^s_{\cup1}\gx^s_{\cup1}
.\eqbl
Maxwell equations
\bqbl
&&
\bgY
=
\bgY_{00}+{1\over2}\bgY''_{00}a^2
+2a\bgY^c_{\cup1}\cos\gt+2a\bgY^s_{\cup1}\sin\gt
.\eqbl
Radial plasma current
\bqbl
&&
B'_{\gt,\gf}
-B'_{\gf,\gt}
=
\gm_0arDj^a
,\\&&
 \left[
  {g_{a\gt}\over arD}(\bgY'_\gt-\bgF'_\gf)
 +{g_{\gf\gt}\over arD}(\bgF'_a+\gh'_\gt)
 +{g_{\gt\gt}\over arD}(-\bgY'_a-\gh'_\gf)
 \right]'_\gf
\\&&
-\left[
  {g_{a\gf}\over arD}(\bgY'_\gt-\bgF'_\gf)
 +{g_{\gf\gf}\over arD}(\bgF'_a+\gh'_\gt)
 +{g_{\gf\gt}\over arD}(-\bgY'_a-\gh'_\gf)
 \right]'_\gt
=
 \gm_0(F'_\gt-J'_\gf)
.\eqbl
Poloidal plasma current
\bqbl
&&
B'_{\gf,a}
-B'_{a,\gf}
=
\gm_0arDj^\gt
,\\&&
 \left[
  {g_{a\gf}\over arD}(\bgY'_\gt-\bgF'_\gf)
 +{g_{\gf\gf}\over arD}(\bgF'_a+\gh'_\gt)
 +{g_{\gf\gt}\over arD}(-\bgY'_a-\gh'_\gf)
 \right]'_a
\\&&
-\left[
  {g_{aa}\over arD}(\bgY'_\gt-\bgF'_\gf)
 +{g_{a\gf}\over arD}(\bgF'_a+\gh'_\gt)
 +{g_{a\gt}\over arD}(-\bgY'_a-\gh'_\gf)
 \right]'_\gf
=
-\gm_0(F'_a+\gn'_\gf)
.\eqbl
Toroidal plasma current
\bqbl
&&
\gm_0arDj^\gf
=
B'_{a,\gt}
-B'_{\gt,a}
,\\&&
 \left[
  {g_{aa}\over arD}(\bgY'_\gt-\bgF'_\gf)
 +{g_{a\gf}\over arD}(\bgF'_a+\gh'_\gt)
 +{g_{a\gt}\over arD}(-\bgY'_a-\gh'_\gf)
 \right]'_\gt
\\&&
-\left[
  {g_{a\gt}\over arD}(\bgY'_\gt-\bgF'_\gf)
 +{g_{\gf\gt}\over arD}(\bgF'_a+\gh'_\gt)
 +{g_{\gt\gt}\over arD}(-\bgY'_a-\gh'_\gf)
 \right]'_a
=
\gm_0(J'_a+\gn'_\gt)
.\eqbl

#endif
}
int ESgP2gF(gc,gs,g,M)
  double *gc;	/*  */
  double *gs;	/*  */
  double *g;	/*  */
  int M;	/*  */
{
  /*
   */
#ifdef Doc_ESgP2gF

#endif
}
int ESP2F(gc,gs,g,M)
  double *gc;	/*  */
  double *gs;	/*  */
  double *g;	/*  */
  int M;	/*  */
{
  /*
   */
#ifdef Doc_ESP2F

#endif
}
#endif
#endif
#endif

#undef Doc_Cb_Structure
#ifdef Blb_escA2R.c
Blb_escA2R.c{
  mzl_ESmain{
  }
  mzl_1Dcore{
  }
  mzl_2Dcore{
  }
  mzl_3Dcore{
  }
  mzl_ESPlV{
    stg_NrmDspl{
    }
  }
}
#endif

#undef Doc_Table_Of_Content
#ifndef Blb_escA2R.c
			PS p= -1;
#ifndef mzl_ESmain
			PS p=  1;
#endif
#ifndef mzl_1Dcore
			PS p=  1;
#endif
#ifndef mzl_2Dcore
			PS p=  1;
#endif
#ifndef mzl_3Dcore
			PS p=  1;
#endif
#ifndef mzl_ESPlV
			PS p=  1;
int ESReInit3APTSpl();	PS p=  2;
int ESDeInit3APTSpl();	PS p=  7;
int ESReInitgXcs();	PS p=  9;
int ESDeInitgXcs();	PS p= 10;
int splA();		PS p= 10;
int splA1a();		PS p= 11;
int splAA();		PS p= 11;
int splAA2();		PS p= 12;
int ESSetSplA();	PS p= 13;
int splRA();		PS p= 14;
int splRA2();		PS p= 14;
int splP();		PS p= 14;
int splT();		PS p= 15;
int f2splP();		PS p= 16;
int DeInitf2splP();	PS p= 20;
int f2splT();		PS p= 20;
int DeInitf2splT();	PS p= 24;
int ESInitSplAPT();	PS p= 25;
int ESGetgFPlV();	PS p= 25;
int ESspli();		PS p= 26;
int ES3DCoord2Spl();	PS p= 26;
int ESAextBext2Spl();	PS p= 27;
#ifndef stg_NrmDspl
			PS p= 33;
int ESNormDispl();	PS p= 33;
int ESgP2gF();		PS p= 51;
int ESP2F();		PS p= 52;
#endif
#endif
#endif
