#ifndef Blb_escB.c
/* undefined */
#ifdef Doc_escB.c
\section{Representation of 3-D coordinates}
The following representation of the 3-D coordinates is used in ESC
\bqbl
r
=&&
R_0(\gf)
+ar^c_1(a,\gf)\cos\gt
+ar^s_1(a,\gf)\sin\gt
+a^2X_2(a,\gt,\gf)
,\\
z
=&&
Z_0(\gf)
+ab(a,\gf)\sin \gt
.\eqbl

Below is a garbage.

In a general 3-D case with $L$ serving as the basic toroidal period, 
a rotating coordinate system $X,Y$ is used at every toroidal 
cross-section as
\bqbl
r
=
&&
R_0(\gf)
+ax
,\quad
z
=
Z_0(\gf)
+ay
,\quad
x
=
X\cos L\gf
+Y\sin L\gf
,\quad
y
=
-X\sin L\gf
+Y\cos L\gf
.\eqbl
In the rotating coordinates, the transformation of canonical coordinates 
$a,\gt,\gf$ is taken in the form
\bqbl
X
=
&&
X^c_1(a,\gt,\gf)
+aX_2(a,\gt,\gf)
=
2X^c_1(a,\gf)\cos(\gt+L\gf)
+2X^s_1(a,\gf)\sin(\gt+L\gf)
+aX_2(a,\gt,\gf)
,\\
Y
=
&&
aY_0(a,\gf)
+b(a,\gf)\sin(\gt+L\gf)
,\\
b
=&&
b_0+2\sum_{n=1}^{n<N}\left[
  b^c_{0n}\cos(n\gf)
  +b^s_{0n}\sin(n\gf)
 \right]
.\eqbl

In  2-D case, it is reduced to
\bqbl
&&
r
=
R_0
+aX
,\quad
z
=
Z_0
+aY
,\quad
\ze
=
\gf
,\\&&
X
=
\cos\gt
+aX_2(a,\gt)
,\quad
Y
=
aY_0
+b\sin\gt
.\eqbl

#endif

#ifndef mzl_System_escB.c /* --------------- Use of Variables --------{ */
#ifdef Tbl_UnusedID/* ------------- List of Unused variables ------{ */
  extern int ESInspectMetricTensor();	/*                         :escB.c */
  extern double cr3;			/*                         :escB.c */
  extern double cr12;			/*                         :escB.c */
  extern double cgp_4;			/*                         :escB.c */
  extern double cr2gp;			/*                         :escB.c */
  extern double cgm0;			/*                         :escB.c */
  extern double crgm0;			/*                         :escB.c */
  extern char ShotNm[];			/*                         :escB.c */
  extern int ESShMem;			/*                         :escB.c */
  extern void *ESlShMem;		/*                         :escB.c */
  extern double ESreltol;		/*                         :escB.c */
  extern double ESabstol;		/*                         :escB.c */
  extern int ESkNormJ;			/*                         :escB.c */
  extern double *ECb;			/*                         :escB.c */
  extern double *ECb1a;			/*                         :escB.c */
  extern double *ECb2a;			/*                         :escB.c */
  extern int ESFlHole;			/*                         :escB.c */
  extern int ESFlVirtualB;		/*                         :escB.c */
  extern int ESiIv;			/*                         :escB.c */
  extern int *ESnF;			/*                         :escB.c */
  extern int *ESmF;			/*                         :escB.c */
  extern int *ESkF;			/*                         :escB.c */
  extern int ESNf;			/*                         :escB.c */
  extern int ESNf1;			/*                         :escB.c */
  extern double *ESemK;			/*                         :escB.c */
  extern double *ESemL;			/*                         :escB.c */
  extern double *ESemV;			/*                         :escB.c */
  extern double *ESemW;			/*                         :escB.c */
  extern double *ESemU1;		/*                         :escB.c */
  extern double *ESemU2;		/*                         :escB.c */
  extern double *ESemK2;		/*                         :escB.c */
  extern double *ESemL2;		/*                         :escB.c */
  extern double *ESemV2;		/*                         :escB.c */
  extern double *ESemW2;		/*                         :escB.c */
  extern double *ESemU12;		/*                         :escB.c */
  extern double *ESemU22;		/*                         :escB.c */
  extern double ESTime;			/*                         :escB.c */
  extern double *ESg22c;		/*                         :escB.c */
  extern double *ESg22s;		/*                         :escB.c */
  extern double *ESg22c1;		/*                         :escB.c */
  extern double *ESg22s1;		/*                         :escB.c */
  extern double *ESg22c2;		/*                         :escB.c */
  extern double *ESg22s2;		/*                         :escB.c */
  extern double *ESr22;			/*                         :escB.c */
  extern double *ESr222;		/*                         :escB.c */
  extern double *ESr22c;		/*                         :escB.c */
  extern double *ESr22s;		/*                         :escB.c */
  extern double *ESr22c2;		/*                         :escB.c */
  extern double *ESr22s2;		/*                         :escB.c */
  extern double *ESg12c;		/*                         :escB.c */
  extern double *ESg12s;		/*                         :escB.c */
  extern double *ESg11c;		/*                         :escB.c */
  extern double *ESg11s;		/*                         :escB.c */
  extern double *ESg12c2;		/*                         :escB.c */
  extern double *ESg12s2;		/*                         :escB.c */
  extern double *ESg11c2;		/*                         :escB.c */
  extern double *ESg11s2;		/*                         :escB.c */
  extern double *ESLc;			/*                         :escB.c */
  extern double *ESLs;			/*                         :escB.c */
  extern double *ESVc;			/*                         :escB.c */
  extern double *ESVs;			/*                         :escB.c */
  extern double *ESDPc;			/*                         :escB.c */
  extern double *ESDPs;			/*                         :escB.c */
  extern double *ESLc1;			/*                         :escB.c */
  extern double *ESLs1;			/*                         :escB.c */
  extern double *ESVc1;			/*                         :escB.c */
  extern double *ESVs1;			/*                         :escB.c */
  extern double *ESDPc1;		/*                         :escB.c */
  extern double *ESDPs1;		/*                         :escB.c */
  extern double *ESLc2;			/*                         :escB.c */
  extern double *ESLs2;			/*                         :escB.c */
  extern double *ESVc2;			/*                         :escB.c */
  extern double *ESVs2;			/*                         :escB.c */
  extern double *ESDPc2;		/*                         :escB.c */
  extern double *ESDPs2;		/*                         :escB.c */
  extern double *ESgh;			/*                         :escB.c */
  extern double *cs2;			/*                         :escB.c */
  extern double *sn2;			/*                         :escB.c */
  extern double *vr;			/*                         :escB.c */
  extern double *vz;			/*                         :escB.c */
  extern double *z2;			/*                         :escB.c */
  extern double *drgt;			/*                         :escB.c */
  extern double *dza;			/*                         :escB.c */
  extern double *dzgt;			/*                         :escB.c */
  extern double tolU;			/*                         :escB.c */
  extern int ESNax;			/*                         :escB.c */
  extern int ESNax1;			/*                         :escB.c */
  extern double *Dx2z;			/*                         :escB.c */
  extern double *Ddx2z;			/*                         :escB.c */
  extern double *Dx0c;			/*                         :escB.c */
  extern double *Dx0s;			/*                         :escB.c */
  extern double *Ddx2c;			/*                         :escB.c */
  extern double *Ddx2s;			/*                         :escB.c */
  extern double *Dx2zc;			/*                         :escB.c */
  extern double *Dx2zs;			/*                         :escB.c */
  extern double *Ddx2zc;		/*                         :escB.c */
  extern double *Ddx2zs;		/*                         :escB.c */
  extern double *rcs;			/*                         :escB.c */
  extern double *rsn;			/*                         :escB.c */
  extern double *d1rcs;			/*                         :escB.c */
  extern double *d1rsn;			/*                         :escB.c */
  extern double *d2rcs;			/*                         :escB.c */
  extern double *d2rsn;			/*                         :escB.c */
  extern double *z0;			/*                         :escB.c */
  extern double *d1z0;			/*                         :escB.c */
  extern double *d2z0;			/*                         :escB.c */
  extern double *xinf;			/*                         :escB.c */
  extern double gd_vb;			/*                         :escB.c */
  extern double z_X2n;			/*                         :escB.c */
  extern int ESLt;			/*                         :escB.c */
  extern int ESLt0;			/*                         :escB.c */
  extern int ESNLt1;			/*                         :escB.c */
  extern double *gf1T;			/*                         :escB.c */
  extern double *csLT;			/*                         :escB.c */
  extern double *snLT;			/*                         :escB.c */
  extern double *EScs1T;		/*                         :escB.c */
  extern double *ESsn1T;		/*                         :escB.c */
  extern double *dR0T;			/*                         :escB.c */
  extern double *dZ0T;			/*                         :escB.c */
  extern double *dbT;			/*                         :escB.c */
  extern double *dbT1a;			/*                         :escB.c */
  extern double *dbT2a;			/*                         :escB.c */
  extern double *drcT;			/*                         :escB.c */
  extern double *drcT1a;		/*                         :escB.c */
  extern double *drcT2a;		/*                         :escB.c */
  extern double *drsT;			/*                         :escB.c */
  extern double *drsT1a;		/*                         :escB.c */
  extern double *drsT2a;		/*                         :escB.c */
  extern int FlagEFIT;			/*                         :escB.c */
  extern int kCol[];			/*                         :escB.c */
  static int kW;			/*                         :escB.c */
  static double bW;			/*                         :escB.c */
  static double rcW[];			/*                         :escB.c */
  static double rsW[];			/*                         :escB.c */
  extern int ESNsep;			/*                         :escB.c */
  extern double ESRsep[];		/*                         :escB.c */
  extern double ESZsep[];		/*                         :escB.c */
  extern double ESIpl;			/*                         :escB.c */
  static double *rPlV;			/*                   <ESPlV:escB.c */
  static double *zPlV;			/*                   <ESPlV:escB.c */
  static int iPncr;			/*                   <ESPlV:escB.c */
  extern int ECEqIterFl;		/*                         :escB.c */
  extern int ESEqSolvInPr;		/*                         :escB.c */
  extern int ESEqSolvInCr;		/*                         :escB.c */
  extern double *ESqgF;			/*                         :escB.c */
  extern double *ESqgF1a;		/*                         :escB.c */
  extern double *ESqgF2a;		/*                         :escB.c */
  extern double *ESqgY;			/*                         :escB.c */
  extern double *ESqgY1a;		/*                         :escB.c */
  extern double *ESqgY2a;		/*                         :escB.c */
  extern double *ESsh;			/*                         :escB.c */
  extern double *ESsh1a;		/*                         :escB.c */
  extern double *ESsh2a;		/*                         :escB.c */
  extern double *ESqV;			/*                         :escB.c */
  extern double *ESqV1a;		/*                         :escB.c */
  extern double *ESqV2a;		/*                         :escB.c */
  extern double *ESsp;			/*                         :escB.c */
  extern double *ESsp1a;		/*                         :escB.c */
  extern double *ESsp2a;		/*                         :escB.c */
  extern double *ESsq;			/*                         :escB.c */
  extern double *ESsq1a;		/*                         :escB.c */
  extern double *ESsq2a;		/*                         :escB.c */
  extern double *ESgm;			/*                         :escB.c */
  extern double *ESgm1a;		/*                         :escB.c */
  extern double *ESgm2a;		/*                         :escB.c */
  extern double *ESgY;			/*                         :escB.c */
  extern double *ESgY1a;		/*                         :escB.c */
  extern double *ESgY2a;		/*                         :escB.c */
  int NEEEEE();				/*                         :escB.c */
  int ESGetPlVd();			/*                         :escB.c */
  int ESInit1DPlV();			/*                         :escB.c */
  int ESReInit1DPlV();			/*                         :escB.c */
  int ESDeInit1DPlV();			/*                         :escB.c */
  int ESDeInit2DAPrC();			/*                         :escB.c */
  int n;				/* .ESPncr2PlVData()<3Dcore:escB.c */
  int iPsrf;				/* .ESPncr2PlVData()<3Dcore:escB.c */
  int ESInit2DTPlV();			/*                  <3Dcore:escB.c */
  int ESReInit2DTPlV();			/*                  <3Dcore:escB.c */
  int ESDeInit2DTPlV();			/*                  <3Dcore:escB.c */
  int ESDeInit1DFPlV();			/*                  <2Dcore:escB.c */
  int ESDeInit2DFTPlV();		/*                  <3Dcore:escB.c */
  int ESDeInit2DFPPlV();		/*                  <2Dcore:escB.c */
  int ESDeInitPlVeq();			/*                  <2Dcore:escB.c */
  int MakePlVContour();			/*                  <3Dcore:escB.c */
  double ga;				/* .ESPlVContour2gx()<ESPlV:escB.c */
  int ESMakePlVdataA0();		/*                   <ESPlV:escB.c */
  int Boundary2Points();		/*                   <ESPlV:escB.c */
  int ESBoundaryLayerX();		/*                   <ESPlV:escB.c */
  int ESPlVdata2PlVPolar();		/*                   <ESPlV:escB.c */
  int ESGetPlVDAddr();			/*                   <ESPlV:escB.c */
  int ESSetPlVInt();			/*                   <ESPlV:escB.c */
  int ESInit2DPlGeom();			/*                   <ESPlV:escB.c */
  FILE *lf;				/*       .ESReadInt()<ESPlV:escB.c */
  char *Nm;				/*       .ESReadInt()<ESPlV:escB.c */
  int *i;				/*       .ESReadInt()<ESPlV:escB.c */
  int n;				/*       .ESReadInt()<ESPlV:escB.c */
  FILE *lf;				/*       .ESReadDbl()<ESPlV:escB.c */
  char *Nm;				/*       .ESReadDbl()<ESPlV:escB.c */
  double *a;				/*       .ESReadDbl()<ESPlV:escB.c */
  int n;				/*       .ESReadDbl()<ESPlV:escB.c */
  int ESWritePlVacAO();			/*                   <ESPlV:escB.c */
  int ESReadPlVacAIOld();		/*                   <ESPlV:escB.c */
  int ESReadPlVacAI();			/*                   <ESPlV:escB.c */
  int ReSetVirtualBSize();		/*                   <ESPlV:escB.c */
  int ESHoleEdgeBoundary1();		/*                   <ESPlV:escB.c */
  int ESHoleEdgeBoundary2();		/*                   <ESPlV:escB.c */
  int ESD2vr();				/*                   <ESPlV:escB.c */
  int ReSetHoleSize();			/*                   <ESPlV:escB.c */
  int ESInputPlVac();			/*                   <ESPlV:escB.c */
  int ESInput2DEqSolv();		/*                   <ESPlV:escB.c */
  int ESInitPlGeom();			/*                   <ESPlV:escB.c */
  int ESA2RefRZ();			/*                   <ESPlV:escB.c */
#endif /* }=== End of List of Unused variables ======*/
#ifndef H/* ---------- Used External Variables ------{ */
  Ignor void;
  Ignor int;
  Ignor char;
  Ignor double;
  Ignor NULL;
  Ignor size_t;
  Systm free();
  Systm cos();
  Systm sin();
  Systm sqrt();
  Systm memset();
  Systm asin();
  Systm fabs();
  Systm log();
  Systm atan();
  Systm puts();
  Systm fprintf();
  Systm fputc();
  Systm rewind();
  Undef NEQ;			/* undefined */
  Undef ReInitArray();		/* NO prototype */
  Undef FailureAlarm();		/* NO prototype */
  Undef ESexit();		/* NO prototype */
  Undef splAA();		/* NO prototype */
  Undef f2spl();		/* NO prototype */
  Undef SetIspl();		/* NO prototype */
  Undef splR();			/* NO prototype */
  Undef splAA2();		/* NO prototype */
  Undef LUdcmp();		/* NO prototype */
  Undef LUbksb();		/* NO prototype */
  Undef zero();			/* NO prototype */
  Undef four();			/* NO prototype */
  Undef IsKeyWordFound();	/* NO prototype */
  Undef ReadAI();		/* NO prototype */
  Undef CbStr2UserMessage();	/* NO prototype */
  Undef ESSetSplA();		/* NO prototype */
  Undef splRA();		/* NO prototype */
  Undef spl();			/* NO prototype */
  Undef ESP2F();		/* NO prototype */
  Undef out();			/* NO prototype */
  Undef ESGetSmoothAddr();	/* NO prototype */
  Undef PFFirstSetSpl0();	/* NO prototype */
  Undef PFFirstSetSpl();	/* NO prototype */
  Undef PFFirstSetSpl2();	/* NO prototype */
  Undef PFBasicFPlot();		/* NO prototype */
  Undef ESReInitMetrTnsrCS();	/* NO prototype */
  Undef ECRcs3D2Rcs2D();	/* NO prototype */
  Undef ES3DMetrTnsrCS();	/* NO prototype */
  Undef ES3DMetrTnsrCSHole();	/* NO prototype */
  Undef ES3DMetrTnsrCSHoleV();	/* NO prototype */
  Undef ESGetPncrAddr();	/* NO prototype */
  Undef ESGetgFPlV();		/* NO prototype */
  Undef ES3DCoord2Spl();	/* NO prototype */
  Undef ES3DInvG22();		/* NO prototype */
  Undef ESAextBext2Spl();	/* NO prototype */
  Undef ESNormDispl();		/* NO prototype */
  extern double R0;		/* External */
  extern double Z0;		/* External */
  extern double ESRext;		/* External */
  extern double ESaRx;		/* External */
  extern double ESaZx;		/* External */
  extern int ESiAx;		/* External */
  extern double ESBt;		/* External */
  extern double ESRBt;		/* External */
  extern unsigned int ESmemlev;	/* External */
  extern int ESNLt;		/* External */
  extern int ESNt1;		/* External */
  extern double *ESaR0;		/* External */
  extern double *ESaZ0;		/* External */
  extern int *k2kPlV;		/* External */
  extern int ESNa1;		/* External */
  extern int ESNp1;		/* External */
  extern double *ESgt;		/* External */
  extern double *ESsr;		/* External */
  extern int ESnAP;		/* External */
  extern double *ESsz;		/* External */
  extern double *dra;		/* External */
  extern int ESFp1;		/* External */
  extern int ESnAF;		/* External */
  extern double *rcT;		/* External */
  extern double *rsT;		/* External */
  extern double ESa0;		/* External */
  extern double *ESsb;		/* External */
  extern int ESNp;		/* External */
  extern double *EScs1;		/* External */
  extern double *ESsn1;		/* External */
  extern int EcNjet;		/* External */
  extern double EcZjet[];	/* External */
  extern double EcRjet[];	/* External */
  extern int ESNa;		/* External */
  extern double *ESsa;		/* External */
  extern double *ESsb1a;	/* External */
  extern double *ESpa;		/* External */
  extern double *rcT2a;		/* External */
  extern double *rsT2a;		/* External */
  extern double *rcT1a;		/* External */
  extern double *rsT1a;		/* External */
  extern double *ESp3a;		/* External */
  extern double *ESsb2a;	/* External */
  extern double *ECr;		/* External */
  extern double *ECz;		/* External */
  extern int ESnAT;		/* External */
  extern int ESnAPT;		/* External */
  extern int FlagPoints;	/* External */
  extern double cr2;		/* External */
  extern double cgp;		/* External */
  extern int nf_X;		/* External */
  extern double t_X;		/* External */
  extern double singtX;		/* External */
  extern double z_X0;		/* External */
  extern double b_X;		/* External */
  extern double *dx0cs;		/* External */
  extern double *x0cs;		/* External */
  extern double *dx0sn;		/* External */
  extern double *x0sn;		/* External */
  extern double d_vb;		/* External */
  extern double z_X2;		/* External */
  extern int ESnBL1;		/* External */
  extern double ESDx[];		/* External */
  extern double ESLx[];		/* External */
  extern double ESVx[];		/* External */
  extern double dx_0x;		/* External */
  extern double d2x_0x;		/* External */
  extern double dx_0o;		/* External */
  extern double d2x_0o;		/* External */
  extern double *x0sep;		/* External */
  extern double *x1sep;		/* External */
  extern double cr4;		/* External */
  extern double *x2sep;		/* External */
  extern double *Dz2;		/* External */
  extern double *Ddx2;		/* External */
  extern double *Dx2;		/* External */
  extern double *Dx0;		/* External */
  extern int ESnBL;		/* External */
  extern double ESgFPlVx;	/* External */
  extern double *rvb;		/* External */
  extern double *zvb;		/* External */
  extern double *Dx2c;		/* External */
  extern double *Dx2s;		/* External */
  extern double *Dz2c;		/* External */
  extern double *Dz2s;		/* External */
  extern double *rvbcs;		/* External */
  extern double *rvbsn;		/* External */
  extern double c2gp;		/* External */
  extern int ESMp;		/* External */
  extern int ESMp1;		/* External */
  extern int ES2Mp;		/* External */
  extern int ES2Mp1;		/* External */
  extern int ESnMp;		/* External */
  extern double cr6;		/* External */
  extern int VMFlag;		/* External */
  extern int ESEqSolvFl;	/* External */
  extern int neqUJ;		/* External */
  extern int neqUP;		/* External */
  extern int neqU;		/* External */
  extern int ESEqSolvIt;	/* External */
  extern int ESFp;		/* External */
  extern double ESav;		/* External */
  extern int ESNt;		/* External */
  extern double ESgFPlV1a;	/* External */
  extern double ESgFPlV;	/* External */
  int ESPlVdata2PlV();		/* No prototype */
  int ESPlVPoints2PlV();	/* No prototype */
  int ESPlVSamePlV();		/* No prototype */
#ifdef Tbl_ESmain
#endif
#ifdef Tbl_1Dcore
#endif
#ifdef Tbl_2Dcore
  Undef ReInitArray();		/* NO prototype */
  Undef FailureAlarm();		/* NO prototype */
  Undef ESexit();		/* NO prototype */
  Undef ReInitArray();		/* NO prototype */
  Undef FailureAlarm();		/* NO prototype */
  Undef ESexit();		/* NO prototype */
  Undef ReInitArray();		/* NO prototype */
  Undef FailureAlarm();		/* NO prototype */
  Undef ESexit();		/* NO prototype */
  extern int ESNp1;		/* External */
  extern double *ESgt;		/* External */
  static int NPlVf;		/*   <ESPlV:escB.c */
  static int MPlVf;		/*   <ESPlV:escB.c */
  static double *rPlVc;		/*   <ESPlV:escB.c */
  static double *rPlVs;		/*   <ESPlV:escB.c */
  static double *drPlVc;	/*   <ESPlV:escB.c */
  static double *drPlVs;	/*   <ESPlV:escB.c */
  static double *csPlV;		/*   <ESPlV:escB.c */
  static double *snPlV;		/*   <ESPlV:escB.c */
  static int nPlVf;		/*   <ESPlV:escB.c */
  static int NPlVcs;		/*   <ESPlV:escB.c */
  static int nPlVcs;		/*   <ESPlV:escB.c */
  static int Neq;		/*   <ESPlV:escB.c */
  static int *indx;		/*   <ESPlV:escB.c */
  static double *ac;		/*   <ESPlV:escB.c */
  static double *f;		/*   <ESPlV:escB.c */
#endif
#ifdef Tbl_BndLr
#endif
#ifdef Tbl_3Dcore
  Undef ReInitArray();		/* NO prototype */
  Undef FailureAlarm();		/* NO prototype */
  Undef ESexit();		/* NO prototype */
  Undef ReInitArray();		/* NO prototype */
  Undef FailureAlarm();		/* NO prototype */
  Undef ESexit();		/* NO prototype */
  Undef splAA();		/* NO prototype */
  Undef f2spl();		/* NO prototype */
  Undef SetIspl();		/* NO prototype */
  Undef splR();			/* NO prototype */
  Undef splAA2();		/* NO prototype */
  Undef splAA();		/* NO prototype */
  extern int ESNLt;		/* External */
  extern int ESNt1;		/* External */
  extern double *ESaR0;		/* External */
  extern double *ESaZ0;		/* External */
  extern int *k2kPlV;		/* External */
  extern int ESNa1;		/* External */
  extern double *ESsr;		/* External */
  extern int ESnAP;		/* External */
  extern double *ESsz;		/* External */
  extern double *dra;		/* External */
  extern int ESFp1;		/* External */
  extern int ESnAF;		/* External */
  extern double *rcT;		/* External */
  extern double *rsT;		/* External */
  extern double ESa0;		/* External */
  extern double *ESsb;		/* External */
  extern int ESNp;		/* External */
  extern double *EScs1;		/* External */
  extern double *ESsn1;		/* External */
  extern int EcNjet;		/* External */
  extern double EcZjet[];	/* External */
  extern double EcRjet[];	/* External */
  extern int ESNa;		/* External */
  extern double *ESsa;		/* External */
  extern double *ESsb1a;	/* External */
  extern double *ESpa;		/* External */
  extern double *rcT2a;		/* External */
  extern double *rsT2a;		/* External */
  extern double *rcT1a;		/* External */
  extern double *rsT1a;		/* External */
  extern double *ESp3a;		/* External */
  extern double *ESsb2a;	/* External */
  extern double *ECr;		/* External */
  extern double *ECz;		/* External */
  extern int ESnAT;		/* External */
  extern int ESnAPT;		/* External */
  extern int FlagPoints;	/* External */
  int ESPlVdata2PlV();		/* No prototype */
  int ESPlVPoints2PlV();	/* No prototype */
  int ESPlVSamePlV();		/* No prototype */
  static int nPlVd;		/*   <ESPlV:escB.c */
  static double *rPlVd;		/*   <ESPlV:escB.c */
  static double *zPlVd;		/*   <ESPlV:escB.c */
  static int *k2k;		/*   <ESPlV:escB.c */
  static int nPncr;		/*   <ESPlV:escB.c */
  static int nPsrf;		/*   <ESPlV:escB.c */
  static double bPlV;		/*   <ESPlV:escB.c */
  static double *rPlVc;		/*   <ESPlV:escB.c */
  static int MPlVf;		/*   <ESPlV:escB.c */
  static double *rPlVs;		/*   <ESPlV:escB.c */
  static double *drPlVc;	/*   <ESPlV:escB.c */
  static double *drPlVs;	/*   <ESPlV:escB.c */
  static int NPlVf;		/*   <ESPlV:escB.c */
  static double *aCr;		/*   <ESPlV:escB.c */
  static double *rCc;		/*   <ESPlV:escB.c */
  static double *rCs;		/*   <ESPlV:escB.c */
  static double *rCc2a;		/*   <ESPlV:escB.c */
  static double *rCs2a;		/*   <ESPlV:escB.c */
  int ESPlVdata2PlV();		/*   <ESPlV:escB.c */
  int ESPlVPoints2PlV();	/*   <ESPlV:escB.c */
  int ESPlVSamePlV();		/*   <ESPlV:escB.c */
#endif
#ifdef Tbl_PL
#endif
#ifdef Tbl_ESPlV
  Undef NEQ;			/* undefined */
  Undef LUdcmp();		/* NO prototype */
  Undef LUbksb();		/* NO prototype */
  Undef LUdcmp();		/* NO prototype */
  Undef LUbksb();		/* NO prototype */
  Undef LUdcmp();		/* NO prototype */
  Undef LUbksb();		/* NO prototype */
  Undef LUdcmp();		/* NO prototype */
  Undef LUbksb();		/* NO prototype */
  Undef zero();			/* NO prototype */
  Undef four();			/* NO prototype */
  Undef splAA();		/* NO prototype */
  Undef LUdcmp();		/* NO prototype */
  Undef LUbksb();		/* NO prototype */
  Undef IsKeyWordFound();	/* NO prototype */
  Undef ReadAI();		/* NO prototype */
  Undef CbStr2UserMessage();	/* NO prototype */
  Undef ESSetSplA();		/* NO prototype */
  Undef splRA();		/* NO prototype */
  Undef spl();			/* NO prototype */
  Undef ESSetSplA();		/* NO prototype */
  Undef splRA();		/* NO prototype */
  Undef spl();			/* NO prototype */
  Undef ESSetSplA();		/* NO prototype */
  Undef splRA();		/* NO prototype */
  Undef f2spl();		/* NO prototype */
  Undef ESP2F();		/* NO prototype */
  Undef LUdcmp();		/* NO prototype */
  Undef LUbksb();		/* NO prototype */
  Undef splAA();		/* NO prototype */
  Undef ESP2F();		/* NO prototype */
  Undef LUdcmp();		/* NO prototype */
  Undef LUbksb();		/* NO prototype */
  Undef out();			/* NO prototype */
  Undef ESP2F();		/* NO prototype */
  Undef LUdcmp();		/* NO prototype */
  Undef LUbksb();		/* NO prototype */
  Undef ESGetSmoothAddr();	/* NO prototype */
  Undef PFFirstSetSpl0();	/* NO prototype */
  Undef PFFirstSetSpl();	/* NO prototype */
  Undef PFFirstSetSpl2();	/* NO prototype */
  Undef PFBasicFPlot();		/* NO prototype */
  Undef ESReInitMetrTnsrCS();	/* NO prototype */
  Undef ECRcs3D2Rcs2D();	/* NO prototype */
  Undef ES3DMetrTnsrCS();	/* NO prototype */
  Undef ES3DMetrTnsrCSHole();	/* NO prototype */
  Undef ES3DMetrTnsrCSHoleV();	/* NO prototype */
  Undef ESGetPncrAddr();	/* NO prototype */
  Undef ESGetgFPlV();		/* NO prototype */
  Undef ES3DCoord2Spl();	/* NO prototype */
  Undef ES3DMetrTnsrCS();	/* NO prototype */
  Undef ES3DInvG22();		/* NO prototype */
  Undef ESAextBext2Spl();	/* NO prototype */
  Undef ESNormDispl();		/* NO prototype */
  extern double cr2;		/* External */
  extern double cgp;		/* External */
  extern int nf_X;		/* External */
  extern double t_X;		/* External */
  extern double singtX;		/* External */
  extern double z_X0;		/* External */
  extern double b_X;		/* External */
  extern double *dx0cs;		/* External */
  extern double *x0cs;		/* External */
  extern double *dx0sn;		/* External */
  extern double *x0sn;		/* External */
  extern double d_vb;		/* External */
  extern double z_X2;		/* External */
  extern int ESnBL1;		/* External */
  extern double ESDx[];		/* External */
  extern double ESLx[];		/* External */
  extern double ESVx[];		/* External */
  extern double dx_0x;		/* External */
  extern double d2x_0x;		/* External */
  extern double dx_0o;		/* External */
  extern double d2x_0o;		/* External */
  extern double *x0sep;		/* External */
  extern double *x1sep;		/* External */
  extern double cr4;		/* External */
  extern double *x2sep;		/* External */
  extern double *Dz2;		/* External */
  extern double *Ddx2;		/* External */
  extern double *Dx2;		/* External */
  extern double *Dx0;		/* External */
  extern int ESnBL;		/* External */
  extern double ESgFPlVx;	/* External */
  extern double *rvb;		/* External */
  extern double *zvb;		/* External */
  extern double *Dx2c;		/* External */
  extern double *Dx2s;		/* External */
  extern double *Dz2c;		/* External */
  extern double *Dz2s;		/* External */
  extern double *rvbcs;		/* External */
  extern double *rvbsn;		/* External */
  extern double c2gp;		/* External */
  extern int ESMp;		/* External */
  extern int ESMp1;		/* External */
  extern int ES2Mp;		/* External */
  extern int ES2Mp1;		/* External */
  extern int ESnMp;		/* External */
  extern double cr6;		/* External */
  extern int VMFlag;		/* External */
  extern int ESEqSolvFl;	/* External */
  extern int neqUJ;		/* External */
  extern int neqUP;		/* External */
  extern int neqU;		/* External */
  extern int ESEqSolvIt;	/* External */
  extern int ESFp;		/* External */
  extern double ESav;		/* External */
  extern int ESNt;		/* External */
  extern double ESgFPlV1a;	/* External */
  extern double ESgFPlV;	/* External */
  int ESReInitPlVeq();		/*  <2Dcore:escB.c */
  int ESReInit1DFPlV();		/*  <2Dcore:escB.c */
  int ESReInit2DFPPlV();	/*  <2Dcore:escB.c */
  int ESInit2DFPPlV();		/*  <2Dcore:escB.c */
  static double Z0_vb;		/*   <BndLr:escB.c */
  static double *rPlVdT;	/*  <3Dcore:escB.c */
  static double *zPlVdT;	/*  <3Dcore:escB.c */
  static int *k2kT;		/*  <3Dcore:escB.c */
  static int nDFT;		/*  <3Dcore:escB.c */
  static int NDFT;		/*  <3Dcore:escB.c */
  int ESReInit2DFTPlV();	/*  <3Dcore:escB.c */
  int ESInit3DCoord();		/*  <3Dcore:escB.c */
  int ESReal2RefData();		/*  <3Dcore:escB.c */
  int ESReal2RefGeom();		/*  <3Dcore:escB.c */
  int ESReal2RefDataX();	/*  <3Dcore:escB.c */
  int ESRef2RealGeom();		/*  <3Dcore:escB.c */
  int ESRealGeom();		/*  <3Dcore:escB.c */
  int ESRef2RealData();		/*  <3Dcore:escB.c */
#endif
#endif /* }======== End of Used External Variables ======= */

#endif /* }======== End of Use of Variables ======== */

extern int ESInspectMetricTensor();	/* undefined */

#ifndef mzl_ESmain
extern double cr2;		/* undefined */
extern double cr3;		/* undefined */
extern double cr4;		/* undefined */
extern double cr6;		/* undefined */
extern double cr12;		/* undefined */
extern double cgp;		/* undefined */
extern double c2gp;		/* undefined */
extern double cgp_4;		/* undefined */
extern double cr2gp;		/* undefined */
extern double cgm0;		/* undefined */
extern double crgm0;		/* undefined */
extern char ShotNm[];		/* undefined */
extern int ESShMem;		/* undefined */
extern void *ESlShMem;		/* undefined */
extern unsigned int ESmemlev;	/* undefined */
extern double ESreltol;		/* undefined */
extern double ESabstol;		/* undefined */
#endif
extern int ESkNormJ;	/* undefined */

#ifndef mzl_1Dcore
extern int ESNa;	/* undefined */
extern int ESNa1;	/* undefined */
extern double *ESsa;	/* undefined */
extern double *ESpa;	/* undefined */
extern double *ESp3a;	/* undefined */
extern double *ECb;	/* undefined */
extern double *ECb1a;	/* undefined */
extern double *ECb2a;	/* undefined */
extern double ESa0;	/* undefined */
extern double ESav;	/* undefined */
extern int ESFlHole;	/* undefined */
extern int ESFlVirtualB;/* undefined */
extern int ESiIv;	/* undefined */
#endif

#ifndef mzl_2Dcore
extern int ESNp;	/* undefined */
extern int ESNp1;	/* undefined */
extern int ESnAP;	/* undefined */
extern int ESnAF;	/* undefined */
extern int ESFp;	/* undefined */
extern int ESFp1;	/* undefined */
extern int *ESnF;	/* undefined */
extern int *ESmF;	/* undefined */
extern int *ESkF;	/* undefined */
extern int ESNf;	/* undefined */
extern int ESNf1;	/* undefined */
extern int ESMp;	/* undefined */
extern int ESMp1;	/* undefined */
extern int ES2Mp;	/* undefined */
extern int ES2Mp1;	/* undefined */
extern int ESnMp;	/* undefined */
extern double *ESemK;	/* undefined */
extern double *ESemL;	/* undefined */
extern double *ESemV;	/* undefined */
extern double *ESemW;	/* undefined */
extern double *ESemU1;	/* undefined */
extern double *ESemU2;	/* undefined */
extern double *ESemK2;	/* undefined */
extern double *ESemL2;	/* undefined */
extern double *ESemV2;	/* undefined */
extern double *ESemW2;	/* undefined */
extern double *ESemU12;	/* undefined */
extern double *ESemU22;	/* undefined */
extern double ESTime;	/* undefined */
extern double *ESg22c;	/* undefined */
extern double *ESg22s;	/* undefined */
extern double *ESg22c1;	/* undefined */
extern double *ESg22s1;	/* undefined */
extern double *ESg22c2;	/* undefined */
extern double *ESg22s2;	/* undefined */
extern double *ESr22;	/* undefined */
extern double *ESr222;	/* undefined */
extern double *ESr22c;	/* undefined */
extern double *ESr22s;	/* undefined */
extern double *ESr22c2;	/* undefined */
extern double *ESr22s2;	/* undefined */
extern double *ESg12c;	/* undefined */
extern double *ESg12s;	/* undefined */
extern double *ESg11c;	/* undefined */
extern double *ESg11s;	/* undefined */
extern double *ESg12c2;	/* undefined */
extern double *ESg12s2;	/* undefined */
extern double *ESg11c2;	/* undefined */
extern double *ESg11s2;	/* undefined */
extern double *ESLc;	/* undefined */
extern double *ESLs;	/* undefined */
extern double *ESVc;	/* undefined */
extern double *ESVs;	/* undefined */
extern double *ESDPc;	/* undefined */
extern double *ESDPs;	/* undefined */
extern double *ESLc1;	/* undefined */
extern double *ESLs1;	/* undefined */
extern double *ESVc1;	/* undefined */
extern double *ESVs1;	/* undefined */
extern double *ESDPc1;	/* undefined */
extern double *ESDPs1;	/* undefined */
extern double *ESLc2;	/* undefined */
extern double *ESLs2;	/* undefined */
extern double *ESVc2;	/* undefined */
extern double *ESVs2;	/* undefined */
extern double *ESDPc2;	/* undefined */
extern double *ESDPs2;	/* undefined */
extern double *ESgh;	/* undefined */
extern double *ESgt;	/* undefined */
extern double *EScs1;	/* undefined */
extern double *ESsn1;	/* undefined */
extern double *cs2;	/* undefined */
extern double *sn2;	/* undefined */
extern double R0;	/* undefined */
extern double Z0;	/* undefined */
extern double *ECr;	/* undefined */
extern double *ECz;	/* undefined */
extern double *vr;	/* undefined */
extern double *vz;	/* undefined */
extern double *z2;	/* undefined */
extern double *dra;	/* undefined */
extern double *drgt;	/* undefined */
extern double *dza;	/* undefined */
extern double *dzgt;	/* undefined */
#endif
extern int neqU;	/* undefined */
extern int neqUJ;	/* undefined */
extern int neqUP;	/* undefined */
extern double tolU;	/* undefined */

#ifndef mzl_BndLr
extern double ESaRx;	/* undefined */
extern double ESaZx;	/* undefined */
extern int ESiAx;	/* undefined */
extern int *k2kPlV;	/* undefined */
extern int ESnBL;	/* undefined */
extern int ESnBL1;	/* undefined */
extern int ESNax;	/* undefined */
extern int ESNax1;	/* undefined */
extern double ESLx[];	/* undefined */
extern double ESVx[];	/* undefined */
extern double ESDx[];	/* undefined */
extern double ESgFPlVx;	/* undefined */
extern double *dx0cs;	/* undefined */
extern double *x0cs;	/* undefined */
extern double *dx0sn;	/* undefined */
extern double *x0sn;	/* undefined */
extern double *x0sep;	/* undefined */
extern double *x1sep;	/* undefined */
extern double *x2sep;	/* undefined */
extern double *rvbcs;	/* undefined */
extern double *rvbsn;	/* undefined */
extern double *rvb;	/* undefined */
extern double *zvb;	/* undefined */
extern double *Dx0;	/* undefined */
extern double *Dx2;	/* undefined */
extern double *Ddx2;	/* undefined */
extern double *Dz2;	/* undefined */
extern double *Dx2z;	/* undefined */
extern double *Ddx2z;	/* undefined */
extern double *Dx0c;	/* undefined */
extern double *Dx0s;	/* undefined */
extern double *Dx2c;	/* undefined */
extern double *Dx2s;	/* undefined */
extern double *Ddx2c;	/* undefined */
extern double *Ddx2s;	/* undefined */
extern double *Dz2c;	/* undefined */
extern double *Dz2s;	/* undefined */
extern double *Dx2zc;	/* undefined */
extern double *Dx2zs;	/* undefined */
extern double *Ddx2zc;	/* undefined */
extern double *Ddx2zs;	/* undefined */
extern double *rcs;	/* undefined */
extern double *rsn;	/* undefined */
extern double *d1rcs;	/* undefined */
extern double *d1rsn;	/* undefined */
extern double *d2rcs;	/* undefined */
extern double *d2rsn;	/* undefined */
extern double *z0;	/* undefined */
extern double *d1z0;	/* undefined */
extern double *d2z0;	/* undefined */
extern double *xinf;	/* undefined */
extern int nf_X;	/* undefined */
static double Z0_vb;	/*  */
extern double dx_0x;	/* undefined */
extern double d2x_0x;	/* undefined */
extern double dx_0o;	/* undefined */
extern double d2x_0o;	/* undefined */
extern double d_vb;	/* undefined */
extern double gd_vb;	/* undefined */
extern double b_X;	/* undefined */
extern double z_X0;	/* undefined */
extern double z_X2;	/* undefined */
extern double z_X2n;	/* undefined */
extern double t_X;	/* undefined */
extern double singtX;	/* undefined */
#endif

#ifndef mzl_3Dcore
extern int ESLt;	/* undefined */
extern int ESNt;	/* undefined */
extern int ESNt1;	/* undefined */
extern int ESnAT;	/* undefined */
extern int ESnAPT;	/* undefined */
extern int ESLt0;	/* undefined */
extern int ESNLt;	/* undefined */
extern int ESNLt1;	/* undefined */
extern double *ESaR0;	/* undefined */
extern double *ESaZ0;	/* undefined */
extern double *ESsr;	/* undefined */
extern double *ESsz;	/* undefined */
extern double *ESsb;	/* undefined */
extern double *ESsb1a;	/* undefined */
extern double *ESsb2a;	/* undefined */
extern double *gf1T;	/* undefined */
extern double *csLT;	/* undefined */
extern double *snLT;	/* undefined */
extern double *EScs1T;	/* undefined */
extern double *ESsn1T;	/* undefined */
extern double *rcT;	/* undefined */
extern double *rsT;	/* undefined */
extern double *rcT1a;	/* undefined */
extern double *rsT1a;	/* undefined */
extern double *rsT2a;	/* undefined */
extern double *rcT2a;	/* undefined */
extern double *dR0T;	/* undefined */
extern double *dZ0T;	/* undefined */
extern double *dbT;	/* undefined */
extern double *dbT1a;	/* undefined */
extern double *dbT2a;	/* undefined */
extern double *drcT;	/* undefined */
extern double *drcT1a;	/* undefined */
extern double *drcT2a;	/* undefined */
extern double *drsT;	/* undefined */
extern double *drsT1a;	/* undefined */
extern double *drsT2a;	/* undefined */
extern double ESgFPlV;	/* undefined */
extern double ESgFPlV1a;/* undefined */
extern int FlagEFIT;	/* undefined */
extern int kCol[];	/* undefined */
static int NDT;		/*  */
static int NADT;	/*  */
static int nDT;		/*  */
static int *k2kT;	/*  */
static int NDFT;	/*  */
static int nDFT;	/*  */
static double *rPlVdT;	/*  */
static double *zPlVdT;	/*  */
static double *rPncrDT;	/*  */
static double *zPncrDT;	/*  */
static double *rPlVcT;	/*  */
static double *rPlVsT;	/*  */
static double *drPlVcT;	/*  */
static double *drPlVsT;	/*  */
#endif
static int kW;		/*  */
static double bW;	/*  */
static double rcW[];	/*  */
static double rsW[];	/*  */
extern double EcRjet[];	/* undefined */
extern double EcZjet[];	/* undefined */
extern int EcNjet;	/* undefined */
extern int FlagPoints;	/* undefined */
extern int ESNsep;	/* undefined */
extern double ESRsep[];	/* undefined */
extern double ESZsep[];	/* undefined */

#ifndef mzl_PL
extern double ESBt;	/* undefined */
extern double ESRBt;	/* undefined */
extern double ESRext;	/* undefined */
extern double ESIpl;	/* undefined */
#endif

#ifndef mzl_ESPlV
static int NPlVd;	/*  */
static int nPlVd;	/*  */
static int kPlVd;	/*  */
static int *k2k;	/*  */
static int MPlVf;	/*  */
static int NPlVf;	/*  */
static int nPlVf;	/*  */
static int NPlVcs;	/*  */
static int nPlVcs;	/*  */
static double *rPlVd;	/*  */
static double *zPlVd;	/*  */
static double *rPlV;	/*  */
static double *zPlV;	/*  */
static double bPlV;	/*  */
static double Z0PlV;	/*  */
static double R0PlV;	/*  */
static double *rPlVc;	/*  */
static double *rPlVs;	/*  */
static double *drPlVc;	/*  */
static double *drPlVs;	/*  */
static int NrC;		/*  */
static int nrC;		/*  */
static double *aCr;	/*  */
static double *rCc;	/*  */
static double *rCc2a;	/*  */
static double *rCs;	/*  */
static double *rCs2a;	/*  */
static int Neq;		/*  */
static int neq;		/*  */
static int *indx;	/*  */
static double *ac;	/*  */
static double *f;	/*  */
static double *csPlV;	/*  */
static double *snPlV;	/*  */
static int nPncr;	/*  */
static int nPsrf;	/*  */
static int KPncr;	/*  */
static int iPncr;	/*  */
static int LPncr;	/*  */
static double *rPncr;	/*  */
static double *zPncr;	/*  */
static double *xPncr;	/*  */
static double *yPncr;	/*  */
extern int VMFlag;	/* undefined */
extern int ECEqIterFl;	/* undefined */
#endif
extern int ESEqSolvFl;	/* undefined */
extern int ESEqSolvInPr;/* undefined */
extern int ESEqSolvInCr;/* undefined */
extern int ESEqSolvIt;	/* undefined */
extern double *ESqgF;	/* undefined */
extern double *ESqgF1a;	/* undefined */
extern double *ESqgF2a;	/* undefined */
extern double *ESqgY;	/* undefined */
extern double *ESqgY1a;	/* undefined */
extern double *ESqgY2a;	/* undefined */
extern double *ESsh;	/* undefined */
extern double *ESsh1a;	/* undefined */
extern double *ESsh2a;	/* undefined */
extern double *ESqV;	/* undefined */
extern double *ESqV1a;	/* undefined */
extern double *ESqV2a;	/* undefined */
extern double *ESsp;	/* undefined */
extern double *ESsp1a;	/* undefined */
extern double *ESsp2a;	/* undefined */
extern double *ESsq;	/* undefined */
extern double *ESsq1a;	/* undefined */
extern double *ESsq2a;	/* undefined */
extern double *ESgm;	/* undefined */
extern double *ESgm1a;	/* undefined */
extern double *ESgm2a;	/* undefined */
extern double *ESgY;	/* undefined */
extern double *ESgY1a;	/* undefined */
extern double *ESgY2a;	/* undefined */

int NEEEEE()
{
/*
   */
#ifdef Doc_NEEEEE
\Section{Skeleton of \c{NEEEEE()}}
  \begin{verbatim}
    NEEEEE(){
    }
  \end{verbatim}
\Section{\c{NEEEEE()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int ESGetPlVd(rPlVd0,zPlVd0)
  double *rPlVd0;	/*  */
  double *zPlVd0;	/*  */
{
  double *rPlVd0;	/*  .ESGetPlVd():escB.c */
  double *zPlVd0;	/*  .ESGetPlVd():escB.c */
  static double *rPlVd;	/*        <ESPlV:escB.c */
  static double *zPlVd;	/*        <ESPlV:escB.c */
  static int nPlVd;	/*        <ESPlV:escB.c */
/*
   */
#ifdef Doc_ESGetPlVd
\section{Skeleton of ESGetPlVd()}
  \begin{verbatim}
    ESGetPlVd(){
    }
  \end{verbatim}
\section{ESGetPlVd()}

#endif
}

int ESInit1DPlV()
{
  extern double R0;	/* undefined */
  extern double Z0;	/* undefined */
  extern double ESRext;	/* undefined */
  extern double ESaRx;	/* undefined */
  extern double ESaZx;	/* undefined */
  extern int ESiAx;	/* undefined */
  extern double ESBt;	/* undefined */
  extern double ESRBt;	/* undefined */
  static int kPlVd;	/*  <ESPlV:escB.c */
  static double *rPlVd;	/*  <ESPlV:escB.c */
  static double *zPlVd;	/*  <ESPlV:escB.c */
  static int *k2k;	/*  <ESPlV:escB.c */
  static int nPlVd;	/*  <ESPlV:escB.c */
/*
   */
#ifdef Doc_ESInit1DPlV
\section{Skeleton of ESInit1DPlV()}
  \begin{verbatim}
    ESInit1DPlV(){
    }
  \end{verbatim}
\section{ESInit1DPlV()}

#endif
}

int ESReInit1DPlV()
{
  Undef ReInitArray();
  Undef FailureAlarm();
  Undef ESexit();
  extern unsigned int ESmemlev;	/* undefined */
  static int NPlVd;	/*  <ESPlV:escB.c */
  static int nPlVd;	/*  <ESPlV:escB.c */
  static int *k2k;	/*  <ESPlV:escB.c */
  static double *rPlVd;	/*  <ESPlV:escB.c */
  static double *zPlVd;	/*  <ESPlV:escB.c */
/*
   */
#ifdef Doc_ESReInit1DPlV
\section{Skeleton of ESReInit1DPlV()}
  \begin{verbatim}
    ESReInit1DPlV(){
    }
  \end{verbatim}
\section{ESReInit1DPlV()}

#endif
}

int ESDeInit1DPlV()
{
  static int NPlVd;	/*  <ESPlV:escB.c */
  static double *zPlVd;	/*  <ESPlV:escB.c */
  static double *rPlVd;	/*  <ESPlV:escB.c */
  static int *k2k;	/*  <ESPlV:escB.c */
/*
   */
#ifdef Doc_ESDeInit1DPlV
\section{Skeleton of ESDeInit1DPlV()}
  \begin{verbatim}
    ESDeInit1DPlV(){
    }
  \end{verbatim}
\section{ESDeInit1DPlV()}

#endif
}

int ESReInit2DAPrC()
{
  Undef ReInitArray();
  Undef FailureAlarm();
  Undef ESexit();
  static int NrC;	/*  <ESPlV:escB.c */
  static int nrC;	/*  <ESPlV:escB.c */
  static double *aCr;	/*  <ESPlV:escB.c */
  static double *rCc;	/*  <ESPlV:escB.c */
  static double *rCc2a;	/*  <ESPlV:escB.c */
  static double *rCs;	/*  <ESPlV:escB.c */
  static double *rCs2a;	/*  <ESPlV:escB.c */
/*
   */
#ifdef Doc_ESReInit2DAPrC
\section{Skeleton of ESReInit2DAPrC()}
  \begin{verbatim}
    ESReInit2DAPrC(){
    }
  \end{verbatim}
\section{ESReInit2DAPrC()}

#endif
}

int ESDeInit2DAPrC()
{
  static int NrC;	/*  <ESPlV:escB.c */
  static double *rCs2a;	/*  <ESPlV:escB.c */
  static double *rCs;	/*  <ESPlV:escB.c */
  static double *rCc2a;	/*  <ESPlV:escB.c */
  static double *rCc;	/*  <ESPlV:escB.c */
  static double *aCr;	/*  <ESPlV:escB.c */
/*
   */
#ifdef Doc_ESDeInit2DAPrC
\section{Skeleton of ESDeInit2DAPrC()}
  \begin{verbatim}
    ESDeInit2DAPrC(){
    }
  \end{verbatim}
\section{ESDeInit2DAPrC()}

#endif
}

#ifndef mzl_3Dcore

int ESRef2RealData(iT)
  int iT;	/*  */
{
  static int nPlVd;	/*  <ESPlV:escB.c */
  static double *rPlVd;	/*  <ESPlV:escB.c */
  static double *zPlVd;	/*  <ESPlV:escB.c */
  static int *k2k;	/*  <ESPlV:escB.c */
/*
   */
#ifdef Doc_ESRef2RealData
\section{Skeleton of ESRef2RealData()}
  \begin{verbatim}
    ESRef2RealData(){
    }
  \end{verbatim}
\section{ESRef2RealData()}

#endif
}

int ESReal2RefData(iT)
  int iT;	/*  */
{
  static int nPlVd;	/*  <ESPlV:escB.c */
  static double *rPlVd;	/*  <ESPlV:escB.c */
  static double *zPlVd;	/*  <ESPlV:escB.c */
  static int *k2k;	/*  <ESPlV:escB.c */
/*
   */
#ifdef Doc_ESReal2RefData
\section{Skeleton of ESReal2RefData()}
  \begin{verbatim}
    ESReal2RefData(){
    }
  \end{verbatim}
\section{ESReal2RefData()}

#endif
}

int ESReal2RefDataX(iT)
  int iT;	/*  */
{
  extern int *k2kPlV;	/* undefined */
  static int nPlVd;	/*  <ESPlV:escB.c */
  static double *rPlVd;	/*  <ESPlV:escB.c */
  static double *zPlVd;	/*  <ESPlV:escB.c */
  static int *k2k;	/*  <ESPlV:escB.c */
/*
   */
#ifdef Doc_ESReal2RefDataX
\section{Skeleton of ESReal2RefDataX()}
  \begin{verbatim}
    ESReal2RefDataX(){
    }
  \end{verbatim}
\section{ESReal2RefDataX()}

#endif
}

int ESPncr2PlVData(n,iPsrf)
  int n;	/*  */
  int iPsrf;	/*  */
{
/*
   */
#ifdef Doc_ESPncr2PlVData
\section{Skeleton of ESPncr2PlVData()}
  \begin{verbatim}
    ESPncr2PlVData(){
    }
  \end{verbatim}
\section{ESPncr2PlVData()}

#endif
}

int ESInit2DTPlV()
{
  static int nPncr;	/*  <ESPlV:escB.c */
  static int nPsrf;	/*  <ESPlV:escB.c */
/*
   */
#ifdef Doc_ESInit2DTPlV
\section{Skeleton of ESInit2DTPlV()}
  \begin{verbatim}
    ESInit2DTPlV(){
    }
  \end{verbatim}
\section{ESInit2DTPlV()}

#endif
}

int ESReInit2DTPlV()
{
  Undef ReInitArray();
  Undef FailureAlarm();
  Undef ESexit();
  extern int ESNa1;	/* undefined */
  static int nPlVd;	/*  <ESPlV:escB.c */
/*
   */
#ifdef Doc_ESReInit2DTPlV
\section{Skeleton of ESReInit2DTPlV()}
  \begin{verbatim}
    ESReInit2DTPlV(){
    }
  \end{verbatim}
\section{ESReInit2DTPlV()}

#endif
}

int ESDeInit2DTPlV()
{
/*
   */
#ifdef Doc_ESDeInit2DTPlV
\section{Skeleton of ESDeInit2DTPlV()}
  \begin{verbatim}
    ESDeInit2DTPlV(){
    }
  \end{verbatim}
\section{ESDeInit2DTPlV()}

#endif
}
#endif

#ifndef mzl_2Dcore

int ESReInit1DFPlV()
{
  Undef ReInitArray();
  Undef FailureAlarm();
  Undef ESexit();
  static int NPlVf;	/*  <ESPlV:escB.c */
  static int MPlVf;	/*  <ESPlV:escB.c */
  static double *rPlVc;	/*  <ESPlV:escB.c */
  static double *rPlVs;	/*  <ESPlV:escB.c */
  static double *drPlVc;/*  <ESPlV:escB.c */
  static double *drPlVs;/*  <ESPlV:escB.c */
/*
   */
#ifdef Doc_ESReInit1DFPlV
\section{Skeleton of ESReInit1DFPlV()}
  \begin{verbatim}
    ESReInit1DFPlV(){
    }
  \end{verbatim}
\section{ESReInit1DFPlV()}

#endif
}

int ESDeInit1DFPlV()
{
  static int NPlVf;	/*  <ESPlV:escB.c */
  static double *drPlVs;/*  <ESPlV:escB.c */
  static double *drPlVc;/*  <ESPlV:escB.c */
  static double *rPlVs;	/*  <ESPlV:escB.c */
  static double *rPlVc;	/*  <ESPlV:escB.c */
/*
   */
#ifdef Doc_ESDeInit1DFPlV
\section{Skeleton of ESDeInit1DFPlV()}
  \begin{verbatim}
    ESDeInit1DFPlV(){
    }
  \end{verbatim}
\section{ESDeInit1DFPlV()}

#endif
}
#endif

#ifndef mzl_3Dcore

int ESReInit2DFTPlV()
{
  Undef ReInitArray();
  Undef FailureAlarm();
  Undef ESexit();
/*
   */
#ifdef Doc_ESReInit2DFTPlV
\section{Skeleton of ESReInit2DFTPlV()}
  \begin{verbatim}
    ESReInit2DFTPlV(){
    }
  \end{verbatim}
\section{ESReInit2DFTPlV()}

#endif
}

int ESDeInit2DFTPlV()
{
/*
   */
#ifdef Doc_ESDeInit2DFTPlV
\section{Skeleton of ESDeInit2DFTPlV()}
  \begin{verbatim}
    ESDeInit2DFTPlV(){
    }
  \end{verbatim}
\section{ESDeInit2DFTPlV()}

#endif
}
#endif

#ifndef mzl_2Dcore

int ESInit2DFPPlV()
{
  static int MPlVf;	/*  <ESPlV:escB.c */
  static double *csPlV;	/*  <ESPlV:escB.c */
  static double *snPlV;	/*  <ESPlV:escB.c */
  static int nPlVf;	/*  <ESPlV:escB.c */
/*
   */
#ifdef Doc_ESInit2DFPPlV
\section{Skeleton of ESInit2DFPPlV()}
  \begin{verbatim}
    ESInit2DFPPlV(){
    }
  \end{verbatim}
\section{ESInit2DFPPlV()}

#endif
}

int ESReInit2DFPPlV()
{
  Undef ReInitArray();
  Undef FailureAlarm();
  Undef ESexit();
  static int NPlVcs;	/*  <ESPlV:escB.c */
  static int nPlVcs;	/*  <ESPlV:escB.c */
  static double *csPlV;	/*  <ESPlV:escB.c */
  static double *snPlV;	/*  <ESPlV:escB.c */
/*
   */
#ifdef Doc_ESReInit2DFPPlV
\section{Skeleton of ESReInit2DFPPlV()}
  \begin{verbatim}
    ESReInit2DFPPlV(){
    }
  \end{verbatim}
\section{ESReInit2DFPPlV()}

#endif
}

int ESDeInit2DFPPlV()
{
  static int NPlVcs;	/*  <ESPlV:escB.c */
  static double *csPlV;	/*  <ESPlV:escB.c */
  static double *snPlV;	/*  <ESPlV:escB.c */
/*
   */
#ifdef Doc_ESDeInit2DFPPlV
\section{Skeleton of ESDeInit2DFPPlV()}
  \begin{verbatim}
    ESDeInit2DFPPlV(){
    }
  \end{verbatim}
\section{ESDeInit2DFPPlV()}

#endif
}

int ESReInitPlVeq(n,a,ff,i)
  int n;	/*  */
  double **a;	/*  */
  double **ff;	/*  */
  int **i;	/*  */
{
  Undef ReInitArray();
  Undef FailureAlarm();
  Undef ESexit();
  static int Neq;	/*  <ESPlV:escB.c */
  static int *indx;	/*  <ESPlV:escB.c */
  static double *ac;	/*  <ESPlV:escB.c */
  static double *f;	/*  <ESPlV:escB.c */
/*
   */
#ifdef Doc_ESReInitPlVeq
\section{Skeleton of ESReInitPlVeq()}
  \begin{verbatim}
    ESReInitPlVeq(){
    }
  \end{verbatim}
\section{ESReInitPlVeq()}

#endif
}

int ESDeInitPlVeq()
{
  static int Neq;	/*  <ESPlV:escB.c */
  static double *f;	/*  <ESPlV:escB.c */
  static double *ac;	/*  <ESPlV:escB.c */
  static int *indx;	/*  <ESPlV:escB.c */
/*
   */
#ifdef Doc_ESDeInitPlVeq
\section{Skeleton of ESDeInitPlVeq()}
  \begin{verbatim}
    ESDeInitPlVeq(){
    }
  \end{verbatim}
\section{ESDeInitPlVeq()}

#endif
}
#endif

#ifndef mzl_3Dcore

int ESRealGeom(iT)
  int iT;	/*  */
{
  extern int ESnAP;	/* undefined */
  extern double *dra;	/* undefined */
  extern int ESFp1;	/* undefined */
  extern int ESnAF;	/* undefined */
  extern double ESa0;	/* undefined */
  extern int ESNp;	/* undefined */
  extern double *EScs1;	/* undefined */
  extern double *ESsn1;	/* undefined */
/*
   */
#ifdef Doc_ESRealGeom
\section{Skeleton of ESRealGeom()}
  \begin{verbatim}
    ESRealGeom(){
    }
  \end{verbatim}
\section{ESRealGeom()}
\section{Initiation of coordinates in the core}
Corrections to the existing coordinates $r(a,\gt)$ and $z_0(a)$

This is a gurbage.

\bqbl
&&
r(a,\gt)=R_0
+a^2[r_{cs,0}+\gd r_{cs,0}]
+2\sum_{k=1}^{N_F}a^k\left[
(r_{cs,k}+\gd r_{cs,k})\cos k\gt
+(r_{sn,k}+\gd r_{sn,k})\sin k\gt
\right]
,\\&&
z=Z_0+a^2(z_0+\gd z_0)+b\sin\gt
,\quad
z(a_0,\gt)=Z_X+b_x\left({d\over b_x}+{d^2z_2\over b_x^2}\right)+b\sin\gt
,\\&&
\gd r_{cs,sn,k}=\gd r^0_{cs,sn,k}+{1\over2}a^2\gd r''_{cs,sn,k}
,\quad
\gd z_0(a)=\gd z^0_0+{1\over2}a^2\gd z''_0
.\eqbl
Equations for corrections 
\bqbl
&&
a_0^2\gd r_{cs,0}
=
r_{b,cs,0}-a_0^2r_{cs,0}
,\quad
[a_0^2\gd r_{cs,0}]'
=
r'_{b,cs,0}-[a_0^2r_{cs,0}]'
,\\&&
a_0^k\gd r_{cs,sn,k}
=
r_{b,cs,sn,k}-a_0^kr_{cs,sn,k}
,\quad
[a_0^k\gd r_{cs,sn,k}]'
=
r'_{b,cs,sn}-[a_0^kr_{cs,sn,k}]'
,\\&&
\gd r^0_{cs,0}+{1\over2}a_0^2\gd r''_{cs,0}
=
{r_{b,cs,0}\over a_0^2}-r_{cs,0}
,\quad
\gd r''_{cs,0}
=
{r'_{b,cs,0}\over a_0^3}
-{2r_{b,cs,0}\over a_0^4}
-{r'_{cs,0}\over a_0}
,\\&&
\gd r^0_{cs,sn,k}+{1\over2}a_0^2\gd r''_{cs,sn,k}
=
{r_{b,cs,sn,k}\over a_0^k}
-r_{cs,sn,k}
,\quad
\gd r''_{cs,sn,k}
=
{r'_{b,cs,sn}\over a_0^{k+1}}
-k{r_{b,cs,sn,k}\over a_0^{k+2}}
-{r'_{cs,sn,k}\over a_0}
,\\&&
a_0^2\gd z_0
=z_{b0}-a_0^2z_0
,\quad
[a_0^2\gd z_0]'
=z'_{b0}-[a_0^2z_0]'
,\\&&
\gd z^0_0+{1\over2}a_0^2\gd z''_0
={z_{b0}\over a_0^2}-z_0
,\quad
\gd z''_0
=
{z'_{b0}\over a_0^3}
-2{z_{b0}\over a_0^4}
-{z'_0\over a_0}
.\eqbl

#endif
}

int MakePlVContour()
{
  extern int EcNjet;		/* undefined */
  extern double EcZjet[];	/* undefined */
  extern double EcRjet[];	/* undefined */
  static double bPlV;	/*  <ESPlV:escB.c */
  static double *rPlVc;	/*  <ESPlV:escB.c */
  static int MPlVf;	/*  <ESPlV:escB.c */
  static double *rPlVs;	/*  <ESPlV:escB.c */
/*
   */
#ifdef Doc_MakePlVContour
\Section{Skeleton of \c{MakePlVContour()}}
  \begin{verbatim}
    MakePlVContour(){
    }
  \end{verbatim}
\Section{\c{MakePlVContour()}}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\begin{tabular}{|llp{4in}|}\hline
\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&$$&\\
\c{}&$$&\\
\c{}&$$&\\
\c{}&$$&\\
\hline\end{tabular}
\Subsection{Output}
\vskip1ex\begin{tabular}{|llp{4in}|}\hline
\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&$$&\\
\c{}&$$&\\
\c{}&$$&\\
\c{}&$$&\\
\hline\end{tabular}
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int ESRef2RealGeom(iT)
  int iT;	/*  */
{
  Undef splAA();
  extern int ESNa;	/* undefined */
  extern double *ESsa;	/* undefined */
  extern double *ESpa;	/* undefined */
  extern double *ESp3a;	/* undefined */
  static double *drPlVc;/*  <ESPlV:escB.c */
  static double *drPlVs;/*  <ESPlV:escB.c */
  static double bPlV;	/*  <ESPlV:escB.c */
  static int MPlVf;	/*  <ESPlV:escB.c */
/*
   */
#ifdef Doc_ESRef2RealGeom
\section{Skeleton of ESRef2RealGeom()}
  \begin{verbatim}
    ESRef2RealGeom(){
    }
  \end{verbatim}
\section{ESRef2RealGeom()}

#endif
}

int ESReal2RefGeom(iT)
  int iT;	/*  */
{
  static double bPlV;	/*  <ESPlV:escB.c */
  static double *rPlVc;	/*  <ESPlV:escB.c */
  static double *rPlVs;	/*  <ESPlV:escB.c */
  static int MPlVf;	/*  <ESPlV:escB.c */
/*
   */
#ifdef Doc_ESReal2RefGeom
\section{Skeleton of ESReal2RefGeom()}
  \begin{verbatim}
    ESReal2RefGeom(){
    }
  \end{verbatim}
\section{ESReal2RefGeom()}

#endif
}

int ESEraseCoord()
{
  extern double *ECr;	/* undefined */
  extern double *ECz;	/* undefined */
  static int NPlVf;	/*  <ESPlV:escB.c */
  static double *rPlVc;	/*  <ESPlV:escB.c */
  static double *rPlVs;	/*  <ESPlV:escB.c */
  static double *drPlVc;/*  <ESPlV:escB.c */
  static double *drPlVs;/*  <ESPlV:escB.c */
/*
   */
#ifdef Doc_ESEraseCoord
\section{Skeleton of ESEraseCoord()}
  \begin{verbatim}
    ESEraseCoord(){
    }
  \end{verbatim}
\section{ESEraseCoord()}

#endif
}

int ESInit3DCoord()
{
  Undef f2spl();
  Undef SetIspl();
  Undef splR();
  Undef splAA2();
  Undef splAA();
  extern int FlagPoints;	/* undefined */
  extern double EcRjet[];	/* undefined */
  extern double EcZjet[];	/* undefined */
  extern int EcNjet;		/* undefined */
  int ESPlVdata2PlV();		/* No prototype */
  int ESPlVPoints2PlV();	/* No prototype */
  int ESPlVSamePlV();		/* No prototype */
  static int nPsrf;	/*  <ESPlV:escB.c */
  static double *aCr;	/*  <ESPlV:escB.c */
  static int nPlVd;	/*  <ESPlV:escB.c */
  static double *rPlVc;	/*  <ESPlV:escB.c */
  static double *rPlVs;	/*  <ESPlV:escB.c */
  static int MPlVf;	/*  <ESPlV:escB.c */
  static double *rCc;	/*  <ESPlV:escB.c */
  static double *rCs;	/*  <ESPlV:escB.c */
  static double *rPlVd;	/*  <ESPlV:escB.c */
  static double *zPlVd;	/*  <ESPlV:escB.c */
  static double bPlV;	/*  <ESPlV:escB.c */
  static double *rCc2a;	/*  <ESPlV:escB.c */
  static double *rCs2a;	/*  <ESPlV:escB.c */
  int ESPlVdata2PlV();	/*  <ESPlV:escB.c */
  int ESPlVPoints2PlV();/*  <ESPlV:escB.c */
  int ESPlVSamePlV();	/*  <ESPlV:escB.c */
/*
   */
#ifdef Doc_ESInit3DCoord
\section{Skeleton of ESInit3DCoord()}
  \begin{verbatim}
    ESInit3DCoord(){
    }
  \end{verbatim}
\section{ESInit3DCoord()}

#endif
}
#endif

#ifndef mzl_ESPlV

int ESPlVContour2gx(gx,M,ga,Rb,Zb,J)
  double *gx;	/*  */
  int M;	/*  */
  double ga;	/*  */
  double *Rb;	/*  */
  double *Zb;	/*  */
  int J;	/*  */
{
  Undef LUdcmp();
  Undef LUbksb();
  extern double cr2;	/* undefined */
  extern double cgp;	/* undefined */
  static double *rPlVdT;/*  <3Dcore:escB.c */
  static double *zPlVdT;/*  <3Dcore:escB.c */
  int ESReInitPlVeq();	/*  <2Dcore:escB.c */
/*
   */
#ifdef Doc_ESPlVContour2gx
\Section{Skeleton of \c{ESPlVContour2gx()}}
  \begin{verbatim}
    ESPlVContour2gx(){
    }
  \end{verbatim}
\Section{\c{ESPlVContour2gx()}}
Routine converts the plasma-vacuum contour $R,Z$ into $\gx$ for further
generating the displacement of the coordinates inside the plasma.
\vskip1ex
\begin{tabular}{|llc|p{3.5in}|}\hline
\multicolumn{4}{|c|}{\bf Formal parameters}\\\hline  
ID&I/O&Math&Comment\\\hline
\c{int ESPlVContour2gx}&O&Return&0 - if the contour coinside
with the previous one,
\newline 1 - if changes are necessary\\\hline
\c{double *gxC}&O&$\gx^c_m$&Cos Fourier harmonics of $\gx(\gt)$\\
\c{double *gxS}&O&$\gx^s_m$&Sin Fourier harmonics of $\gx(\gt)$\\
\c{int M}&I&$M$&Number of harmonics in $\gx(\gt)$, $0\leq m\leq M$\\
\c{double ga}&I&$\ga$&regularization parameter in functional $W$,
e.g., $10^{-10}$ or $0$. If $\ga\neq0$, it suppresses the amplitude of
highest harmonics.\\ 
\c{double *Rb}&I&$r_j$&$r$-coordinates of the boundary contour $r(\gt)$\\
\c{double *Zb}&I&$z_j$&$z$-coordinates of the boundary contour $z(\gt)$\\
\c{int J}&I&$J$&Number of points $r_j,z_j$ on the boundary contour\\
\hline\end{tabular}
\vskip1ex
If the first and last points on the contour coinside, the last one is
ignored. 

\Subsection{Description}
Plasma boundary representation
\bqbl
&&
r=
r^c_0
+2\sum_{m=1}^{m\leq M_F}\left(r^c_m\cos m\gt+r^s_m\sin m\gt\right)
,\quad
z=Z_0+b\sin\gt
.\eqbl

\Subsubsection{Advancing the coordinate system}
Normal plasma displacement
\bqbl
&&
\gt
\to
\gt
+\gs
,\quad
a
\to
a
+\gx
,\quad
\gx_\til
=
-{\gy_\til\over\bgY'_0}
,\\&&
\gx
=
\gx^c_0
+2\sum_{m=1}^{m\leq M}\left(\gx^c_m\cos m\gt+\gx^s_m\sin m\gt\right)
,\quad
\gs
=
\gs^c_0
+2\sum_{m=1}^{m\leq M}\left(\gs^c_m\cos m\gt+\gs^s_m\sin m\gt\right)
.\eqbl

Equations for $\gx,\gs$
\bqbl
&&
(r'_a\gx+r'_\gt\gs)_j=(R-r)_j=\gd r_j
,\quad
(z'_a\gx+z'_\gt\gs)_j=(Z-z)_j=\gd z_j
,\\&&
\gx_j
=
\gx^c_0
+2\sum_{m=1}^{m\leq M}\left(\gx^c_m\cos m\gt_j+\gx^s_m\sin m\gt_j\right)
,\quad
\gs
=
\gs^c_0
+2\sum_{m=1}^{m\leq M}\left(\gs^c_m\cos m\gt_j+\gs^s_m\sin m\gt_j\right)
.\eqbl

\Subsubsection{Functional for minimization}
The least square functional
\bqbl
&&
W=\ga \sum_{m=1}^{m\leq M}m^4\left({\gx^c_ m}^2+{\gx^s_m}^2
 +{\gs^c_ m}^2+{\gs^s_m}^2\right)
+\sum_{j=0}^{j<J}(r'_a\gx+r'_\gt\gs-\gd r)^2_j
+\sum_{j=0}^{j<J}(z'_a\gx+z'_\gt\gs-\gd z)^2_j
.\eqbl
Linear system of equations for $\gx,\gs$
\bqbl
&&
\maA\vaX
=\vaY
,\quad
\vaX=\{\gx^c_m,\gx^s_m,\gs^c_m,\gs^s_m\}
,\quad
\vaY=\{Y^c_m,Y^s_m,y^c_m,y^s_m\}
,\quad
A_{ij}=\R{\gd^2 W}{\gd x_i\gd x_j}
,\\&&
\maA=\left|\arr
\sum_{j=0}^{j<J}(g_{aa}\gx+g_{a\gt}\gs)_j\\
\ga m^4\gx^c_m
+\sum_{j=0}^{j<J}2(g_{aa}\gx+g_{a\gt}\gs)_j\cos m\gt_j\\
\ga m^4\gx^s_m
+\sum_{j=0}^{j<J}2(g_{aa}\gx+g_{a\gt}\gs)_j\sin m\gt_j\\
\sum_{j=0}^{j<J}(g_{a\gt}\gx+g_{\gt\gt}\gs)_j\\
\ga m^4\gs^c_m
+\sum_{j=0}^{j<J}2(g_{a\gt}\gx+g_{\gt\gt}\gs)_j\cos m\gt_j\\
\ga m^4\gs^s_m
+\sum_{j=0}^{j<J}2(g_{a\gt}\gx+g_{\gt\gt}\gs)_j\sin m\gt_j\\
\ear\right|
,\quad
\vaY=\left|\arl
\sum_{j=0}^{j<J}(r'_a\gd r+z'_a\gd z)_j\\
\sum_{j=0}^{j<J}2(r'_a\gd r+z'_a\gd z)_j\cos m\gt_j\\
\sum_{j=0}^{j<J}2(r'_a\gd r+z'_a\gd z)_j\sin m\gt_j\\\
\sum_{j=0}^{j<J}(r'_\gt\gd r+z'_\gt\gd z)_j\\
\sum_{j=0}^{j<J}2(r'_\gt\gd r+z'_\gt\gd z)_j\cos m\gt_j\\
\sum_{j=0}^{j<J}2(r'_\gt\gd r+z'_\gt\gd z)_j\sin m\gt_j\\
\ear\right|
.\eqbl
Variations with respect to $\gx_i$
\bqbl
&&
\R{\gd W}{2\gd\gx^c_m}
=
\ga m^4\gx^c_m
+\sum_{j=0}^{j<J}[(r'_a\gx+r'_\gt\gs-\gd r)r'_a
 +(z'_a\gx+z'_\gt\gs-\gd z)z'_a]_j\R{\gd\gx_j}{\gd\gx^c_m}
,\\&&
\R{\gd W}{2\gd\gx^c_0}
=
\sum_{j=0}^{j<J}[(r'_a\gx+r'_\gt\gs-\gd r)r'_a
 +(z'_a\gx+z'_\gt\gs-\gd z)z'_a]_j
,\\&&
\R{\gd W}{2\gd\gx^c_m}
=
\ga m^4\gx^c_m
+\sum_{j=0}^{j<J}[2(r'_a\gx+r'_\gt\gs-\gd r)r'_a
 +(z'_a\gx+z'_\gt\gs-\gd z)z'_a]_j\cos m\gt_j
,\\&&
\R{\gd W}{2\gd\gx^s_m}
=
\ga m^4\gx^s_m
+\sum_{j=0}^{j<J}[2(r'_a\gx+r'_\gt\gs-\gd r)r'_a
 +(z'_a\gx+z'_\gt\gs-\gd z)z'_a]_j\sin m\gt_j
.\eqbl
Variations with respect to $\gs_m$
\bqbl
&&
\R{\gd W}{2\gd\gs^c_m}
=
\ga m^4\gs^c_m
+\sum_{j=0}^{j<J}[(r'_a\gx+r'_\gt\gs-\gd r)r'_\gt
 +(z'_a\gx+z'_\gt\gs-\gd z)z'_\gt]_j\R{\gd\gs_j}{\gd\gs^c_m}
,\\&&
\R{\gd W}{2\gd\gs^c_0}
=
\sum_{j=0}^{j<J}[(r'_a\gx+r'_\gt\gs-\gd r)r'_\gt
 +(z'_a\gx+z'_\gt\gs-\gd z)z'_\gt]_j
,\\&&
\R{\gd W}{2\gd\gs^c_m}
=
\ga m^4\gs^c_m
+\sum_{j=0}^{j<J}[2(r'_a\gx+r'_\gt\gs-\gd r)r'_\gt
 +(z'_a\gx+z'_\gt\gs-\gd z)z'_\gt]_j\cos m\gt_j
,\\&&
\R{\gd W}{2\gd\gs^s_m}
=
\ga m^4\gs^s_m
+\sum_{j=0}^{j<J}[2(r'_a\gx+r'_\gt\gs-\gd r)r'_\gt
 +(z'_a\gx+z'_\gt\gs-\gd z)z'_\gt]_j\sin m\gt_j
.\eqbl

\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\begin{tabular}{|llp{4in}|}\hline
\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&$$&\\
\c{}&$$&\\
\c{}&$$&\\
\c{}&$$&\\
\hline\end{tabular}
\Subsection{Output}
\vskip1ex\begin{tabular}{|llp{4in}|}\hline
\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&$$&\\
\c{}&$$&\\
\c{}&$$&\\
\c{}&$$&\\
\hline\end{tabular}
\Subsection{Known Bugs}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int ESPlVdata2PlV()
{
  Undef LUdcmp();
  Undef LUbksb();
/*
   */
#ifdef Doc_ESPlVdata2PlV
\section{Skeleton of ESPlVdata2PlV()}
  \begin{verbatim}
    ESPlVdata2PlV(){
    }
  \end{verbatim}
\section{ESPlVdata2PlV()}
\section{Plasma-Vacuum interface}
Number of harmonics $m < M$ and the number of control points $K$ is 
related as 
\bqbl
&&
2M-1\geq K
.\eqbl

\subsection{Plasma boundary without X-points}
\bqbl
&&
r=r_{PlV}
+r^c_0
+2\sum_{m=1}^{m<M}\left(r^c_m\cos m\gt+r^s_m\sin m\gt\right)
,\quad
z=Z_0+b\sin\gt
.\eqbl
Equations
\bqbl
&&
r^c_0+2\sum_{m=1}^{m<M}\left(r^c_m\cos m\gt_k+r^s_m\sin m\gt_k\right)
=r_k-r_{PlV}
,\quad
\sin\gt_k={z_k-Z_0\over b}
.\eqbl
Functional for minimization
\bqbl
&&
W=\sum_{m=1}^{m<M}m^4\left({r^c_m}^2+{r^s_m}^2\right)
+2\sum_{k=0}^{k<K}\sum_{m=1}^{m<M}
  \gl_k\left(a^c_{km}r^c_m+a^s_{km}r^s_m-f_k\right)
,\\&&
f_k=r_k-r_{PlV}
,\quad
\gt_k=\arcsin{z_k-Z_0\over b}
,\quad
a^c_{km}=2\cos m\gt_k
,\quad
a^s_{km}=2\sin m\gt_k
.\eqbl

\subsection{Plasma boundary with one X-point}
\bqbl
&&
x=x_X
+\left[x^c_0+2\sum_{k=1}^L\left(x^c_k\cos k\gt+x^s_k\sin k\gt\right)\right]
\left|\sin{\gt_x-\gt\over2}\right|
+x^s_0(1-\sin\gt)
,\quad
z=Z_0+b_x\sin\gt
.\eqbl
Equations
\bqbl
&&
x^c_0+2\sum_{k=1}^L\left(x^c_k\cos k\gt_X+x^s_k\sin k\gt_X\right)=0
,\\&&
\left[x^c_0+2\sum_{k=1}^L\left(x^c_k\cos k\gt_i+x^s_k\sin k\gt_i\right)\right]
\left|\sin{\gt_x-\gt_i\over2}\right|
+x^s_0(1-\sin\gt_i)
=x_i-x_X
,\\&&
2\sum_{k=1}^Lk\left(-x^c_k\sin k\gt_X+x^s_k\cos k\gt_X\right)=
-b_x\sqrt{1+\ga_X^2+\ga_X}
,\quad
x^s_0\equiv-\ga_Xb_x
,\quad
\ga_X=0
.\eqbl
Functional for minimization
\bqbl
&&
W=\sum_{k=1}^Lk^4\left({x^c_k}^2+{x^s_k}^2\right)
+\sum_{i=1}^K\sum_{k=1}^L\gl_i\left(a^c_{ik}x^c_k+a^s_{ik}x^s_k-f_i\right)
,\quad
f_k=x_i-x_X
,\quad
\gt_i=\arcsin{z_i-Z_0\over b_x}
,\\&&
a^c_{i0}=\left|\sin{\gt_x-\gt_i\over2}\right|
,\quad
a^c_{ik}=2\cos k\gt_i\left|\sin{\gt_x-\gt_i\over2}\right|
,\quad
a^s_{i0}=1-\sin\gt_i
,\quad
a^s_{ik}=2\sin k\gt_i\left|\sin{\gt_x-\gt_i\over2}\right|
.\eqbl

\section{Plasma-Vacuum in Polar version}
Number of harmonics $m < M$ and the number of control points $K$ is 
related as 
\bqbl
&&
2M-1\geq K
.\eqbl

\subsection{Plasma boundary without X-points}
\bqbl
&&
\gr^2
=
A_0+2\sum^{m<M}_{m=1}\gr^m\left(A^c_m\cos m\gw+A^s_m\sin m\gw\right)
,\quad
r
=
R_0
+\gr\cos\gw
,\quad
z
=
Z_0+\gr\sin\gq
.\eqbl
Equations
\bqbl
&&
A_0+2\sum^{m<M}_{m=1}\gr^m\left(A^c_m\cos m\gw+A^s_m\sin m\gw\right)
=
\gr^2_k
.\eqbl
Functional for minimization
\bqbl
&&
W=\sum_{m=1}^{m<M}m^4\left({A^r_m}^2+{A^i_m}^2\right)
+2\sum_{k=0}^{k<K}\sum^{m<M}_{m=1}
  \gl_k\left(a^r_{km}A^r_m+a^i_{km}A^i_m-f_k\right)
,\\&&
f_k=\gr^2_k
,\quad
\gw_k=\arctan{z_k-Z_0\over r_k-R_0}
,\quad
a^r_{k0}=a^2
,\quad
a^r_{km}=2\gr^m_k\cos m\gw_k
,\quad
a^i_{km}=2\gr^m_k\sin m\gw_k
.\eqbl
#endif
}

int ESMakePlVdataA0()
{
  extern int EcNjet;		/* undefined */
  extern int FlagPoints;	/* undefined */
  extern double EcRjet[];	/* undefined */
  extern double EcZjet[];	/* undefined */
  static int *k2kT;	/*  <3Dcore:escB.c */
  static int nDFT;	/*  <3Dcore:escB.c */
  static int NDFT;	/*  <3Dcore:escB.c */
  int ESReInit1DFPlV();	/*  <2Dcore:escB.c */
  int ESReInit2DFTPlV();/*  <3Dcore:escB.c */
  int ESReInit2DFPPlV();/*  <2Dcore:escB.c */
  int ESReInitPlVeq();	/*  <2Dcore:escB.c */
  int ESInit2DFPPlV();	/*  <2Dcore:escB.c */
/*
   */
#ifdef Doc_ESMakePlVdataA0
\Section{Skeleton of \c{ESMakePlVdataA0()}}
  \begin{verbatim}
    ESMakePlVdataA0(){
    }
  \end{verbatim}
\Section{\c{ESMakePlVdataA0()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{extern int }&\c{EcNjet}&$$&\\
\c{extern int }&\c{FlagPoints}&$$&\\
\c{extern double }&\c{EcRjet[]}&$$&\\
\c{extern double }&\c{EcZjet[]}&$$&\\
\c{static int }&\c{*k2kT}&$$&\\
\c{int }&\c{ESReInit1DFPlV()}&$$&\\
\c{static int }&\c{nDFT}&$$&\\
\c{static int }&\c{NDFT}&$$&\\
\c{int }&\c{ESReInit2DFTPlV()}&$$&\\
\c{int }&\c{ESReInit2DFPPlV()}&$$&\\
\c{int }&\c{ESReInitPlVeq()}&$$&\\
\c{int }&\c{ESInit2DFPPlV()}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int ESPlVSamePlV()
{
/*
   */
#ifdef Doc_ESPlVSamePlV
\section{Skeleton of ESPlVSamePlV()}
  \begin{verbatim}
    ESPlVSamePlV(){
    }
  \end{verbatim}
\section{ESPlVSamePlV()}
\subsection{Manual}
\begin{itemize}
\item \c{DESCRIPTION:}
\item \c{ARGUMENTS:}
\item \c{EXTERNALS:}
\item \c{RETURN VALUE:}
\begin{itemize}
  \item{\bf Success: }
  \item{\bf Failure: }

    \begin{tabular}{lcl}
    \C{i=ESPlVSamePlV();}& -&\em return value.\\
    \C{i == 1}& -&\em Your Comment\\
    \end{tabular}
\end{itemize}
\item \c{TIPS:}
{\em }
\item \c{BUGS:}
\item \c{SEE ALSO:}
\item \c{TO DO:}
\end{itemize}
#endif
}

int Boundary2Points(Rb,Zb,Nb)
  double *Rb;	/*  */
  double *Zb;	/*  */
  int Nb;	/*  */
{
  static double *rPlVdT;/*  <3Dcore:escB.c */
  static double *zPlVdT;/*  <3Dcore:escB.c */
/*
   */
#ifdef Doc_Boundary2Points
\Section{Skeleton of \c{Boundary2Points()}}
  \begin{verbatim}
    Boundary2Points(){
    }
  \end{verbatim}
\Section{\c{Boundary2Points()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{double }&\c{*Rb}&$$&\\
\c{double }&\c{*Zb}&$$&\\
\c{int }&\c{Nb}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{static double }&\c{*rPlVdT}&$$&\\
\c{static double }&\c{*zPlVdT}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int ESPlVPoints2PlV(Rb,Zb,Nb)
  double *Rb;	/* r of boundary points */
  double *Zb;	/* x of boundary points */
  int Nb;	/* number of boundary points. First and last points overlaps */
{
  Undef LUdcmp();
  Undef LUbksb();
  int ESReInitPlVeq();	/*  <2Dcore:escB.c */
/*
   */
#ifdef Doc_ESPlVPoints2PlV
\Section{Skeleton of \c{ESPlVPoints2PlV()}}
  \begin{verbatim}
    ESPlVPoints2PlV(){
    }
  \end{verbatim}
\Section{\c{ESPlVPoints2PlV()}}
Routine generates Fourier representation of the boundary given by its
\c{r-z} contour.

\Subsection{Description}

\Subsubsection{Top, bottom, left and right points}
Near extreme points the contour is represented as
\bqbl
&&
r=r_0+r't+\R{1}{2}r''t^2
,\quad
z=z_0+z't+\R{1}{2}z''t^2
,\\&&
r''=r_2+r_1-2r_0
,\quad
r'=\R{r_2-r_1}{2}
,\quad
z''=z_2+z_1-zr_0
,\quad
z'=\R{z_2-z_1}{2}
,\\&&
r=r_0+\R{r_2-r_1}{2}t+\R{r_2+r_1-2r_0}{2}t^2
,\quad
z=z_0+\R{z_2-z_1}{2}t+\R{z_2+z_1-2z_0}{2}t^2
.\eqbl
Extreme points
\bqbl
&&
t=-\R{r'}{r''}
,\quad
r=r_0-\R{r'^2}{2r''}
,\quad\mbox{or}\quad
t=-\R{z'}{z''}
,\quad
z=z_0-\R{z'^2}{2z''}
.\eqbl

\Subsubsection{Variational form}
Fourier representation of the plasma boundary is calculated from equations
\bqbl
W
&&\equiv
\sum^{j<N}_{j=0}\left[
  r^c_0+2\sum^{k'<M}_{k'=1}\left(r^c_{k'}\cos k'\gt_j+r^s_{k'}\sin k'\gt_j
 \right)
 -r_j
 \right]^2
+\ga\sum^{k'<M}_{k'=1}k'^4\left({r^c_{k'}}^2+{r^s_{k'}}^2\right)
\\&&
+2\gl_1\left[
  r^c_0+2\sum^{k'<M}_{k'=1}\left(r^c_{k'}\cos k'\gt_1+r^s_{k'}\sin k'\gt_1
 \right)
 -r_1
 \right]
\\&&
+2\gl_2\left[
  r^c_0+2\sum^{k'<M}_{k'=1}\left(r^c_{k'}\cos k'\gt_2+r^s_{k'}\sin k'\gt_2
 \right)
 -r_2
 \right]
,\\
\r{2}\R{\gd W}{\gd r^c_0}
&&=
\sum^{j<N}_{j=0}\left[
  r^c_0+2\sum^{k'<M}_{k'=1}\left(r^c_{k'}\cos k'\gt_j+r^s_{k'}\sin k'\gt_j
 \right)
 -r_j
 \right]
+\gl_1
+\gl_2
=
0
,\\
\r{2}\R{\gd W}{\gd r^c_k}
&&=
\sum^{j<N}_{j=0}2\cos k\gt_j\left[
  r^c_0+2\sum^{k'<M}_{k'=1}\left(r^c_{k'}\cos k'\gt_j+r^s_{k'}\sin k'\gt_j\right)
 -r_j
 \right]
+\ga k^4r^c_k
\\&&
+2\cos k\gt_1\gl_1
+2\cos k\gt_2\gl_2
=
0
,\\
\r{2}\R{\gd W}{\gd r^s_k}
&&=
\sum^{j<N}_{j=0}2\sin k\gt_j\left[
  r^c_0+2\sum^{k'<M}_{k'=1}\left(r^c_{k'}\cos k'\gt_j+r^s_{k'}\sin k'\gt_j
 \right)
 -r_j
 \right]
+\ga k^4r^s_k
\\&&
+2\sin k\gt_1\gl_1
+2\sin k\gt_2\gl_2
=
0
,\\&&
r^c_0+2\sum^{k'<M}_{k'=1}\left(r^c_{k'}\cos k'\gt_1+r^s_{k'}\sin k'\gt_1
 \right)
 -r_1
=0
,\\&&
r^c_0+2\sum^{k'<M}_{k'=1}\left(r^c_{k'}\cos k'\gt_2+r^s_{k'}\sin k'\gt_2
 \right)
 -r_2
=0
.\eqbl
Thus, the position of 4 points (top, bottom, left and right) is
reproduced exactly while the rest of points are approximated by the least
square rule. 

Minimization of the matrix lead to the matrix elements
\bqbl
&&
a_{i0}r_0+\sum^{k<M}_{k=1}(a_{i,2k-1}r_{2k-1}+a_{i,2k}r_{2k})=f_j
,\\&&
a_{00}
=
\sum^{j<N}_{j=0}1
,\quad
a_{0,2k-1}
=
\sum^{j<N}_{j=0}2\cos k\gt_j
,\quad
a_{0,2k}
=
\sum^{j<N}_{j=0}2\sin k\gt_j
,\quad
f_0
=
\sum^{j<N}_{j=0}r_j
,\\&&
a_{2k'-1,0}
=
\sum^{j<N}_{j=0}2\cos k'\gt_j
,\quad
a_{2k'-1,2k-1}
=
\sum^{j<N}_{j=0}4\cos k'\gt_j\cos k\gt_j
+\ga k^4\gd_{kk'}
,\\&&
a_{2k'-1,2k}
=
\sum^{j<N}_{j=0}4\cos k'\gt_j\sin k\gt_j
,\quad
f_{2k-1}
=
\sum^{j<N}_{j=0}2\cos k'\gt_jr_j
,\\&&
a_{2k',0}
=
\sum^{j<N}_{j=0}2\sin k'\gt_j
,\quad
a_{2k',2k-1}
=
\sum^{j<N}_{j=0}4\sin k'\gt_j\cos k\gt_j
,\\&&
a_{2k',2k}
=
\sum^{j<N}_{j=0}4\sin k'\gt_j\sin k\gt_j
+\ga k^4\gd_{k'k}
,\quad
f_{2k}
=
\sum^{j<N}_{j=0}2\sin k\gt_jr_j
=
0
,\eqbl
while the exact equation add to raws and colons more
\bqbl
&&
a_{n,0}
=
a_{0,n}
=1
,\quad
a_{n,2k-1}
=
a_{2k-1,n}
=
2\cos k\gt_1
,\quad
a_{n,2k}
=
a_{2k,n}
=
2\sin k\gt_1
,\\&&
a_{n+1,0}
=
a_{0,n+1}
=
1
,\quad
a_{n+1,2k-1}
=
a_{2k-1,n+1}
=
2\cos k\gt_2
,\quad
a_{n+1,2k}
=
a_{2k,n+1}
=
2\sin k\gt_2
.\eqbl

\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\begin{tabular}{|llp{4in}|}\hline
\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&$$&\\
\c{}&$$&\\
\c{}&$$&\\
\c{}&$$&\\
\hline\end{tabular}
\Subsection{Output}
\vskip1ex\begin{tabular}{|llp{4in}|}\hline
\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&$$&\\
\c{}&$$&\\
\c{}&$$&\\
\c{}&$$&\\
\hline\end{tabular}
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}

#endif
}

int ESPlVdata2PlVX()
{
  Undef NEQ;
  Undef LUdcmp();
  Undef LUbksb();
  Undef zero();
  extern int nf_X;	/* undefined */
  extern double t_X;	/* undefined */
  extern double singtX;	/* undefined */
  extern double z_X0;	/* undefined */
  extern double b_X;	/* undefined */
  extern double *dx0cs;	/* undefined */
  extern double *x0cs;	/* undefined */
  extern double *dx0sn;	/* undefined */
  extern double *x0sn;	/* undefined */
/*
   */
#ifdef Doc_ESPlVdata2PlVX
   \section{Skeleton of \Cline{ESPlVdata2PlVX()}}

   \begin{verbatim}
   ESPlVdata2PlVX(){
   }
   \end{verbatim}

\section{Subroutine \Cline{ESPlVdata2PlVX()}}
Fourier representation of the Separatrix
\bqbl
&&
r_{sep}
=
R_X
+x_0(\gt)
 \left|\sin{\gt-\gt_x\over2}\right|
-\gg_xb_x(\sin\gt-\sin\gt_x)
,\quad
z
=
Z_0
+b_x\sin\gt
,\quad
Z_X
=
Z_0
+b_x\sin\gt_x
,\\&&
x_0(\gt_x)
=0
,\quad
x_0'(\gt_x)
=
-b_x\sqrt{1+\gg_x^2}\sin\gt_x
,\\&&
r_{sep}
=
R_X
+\left[x^c_0+2\sum_{k=1}^K\left(x^c_k\cos k\gt+x^s_k\sin k\gt\right)\right]
\left|\sin{\gt_x-\gt\over2}\right|
+x^s_0(\sin\gt-\sin\gt_x)
,\\&&
z
=
Z_0
+b_x\sin\gt
.\eqbl

Equations
\bqbl
&&
x^c_0+2\sum_{k=1}^K\left(x^c_k\cos k\gt_x+x^s_k\sin k\gt_x\right)=0
,\\&&
\left[x^c_0+2\sum_{k=1}^K\left(x^c_k\cos k\gt_n+x^s_k\sin k\gt_n\right)\right]
\left|\sin{\gt_x-\gt_n\over2}\right|
+x^s_0(\sin\gt_n-\sin\gt_x)
=r_n-R_X
,\\&&
x^s_0
=
-\gg_xb_x
,\quad
2\sum_{k=1}^Kk\left(-x^c_k\sin k\gt_x+x^s_k\cos k\gt_x\right)=
-b_x\sin\gt_x\sqrt{1+\gg_X^2}
.\eqbl

Functional for minimization
\bqbl
&&
W
=
{1\over2}\sum_{k=1}^Kk^4\left({x^c_k}^2+{x^s_k}^2\right)
+\sum_{n=1}^N\sum_{k=0}^K\gl_n\left(a^c_{nk}x^c_k+a^s_{nk}x^s_k-f_n\right)
,\quad
f_n=r_n-R_X
,\\&&
a^c_{n0}=\left|\sin{\gt_x-\gt_n\over2}\right|
,\quad
a^c_{nk}=2\cos k\gt_n\left|\sin{\gt_x-\gt_n\over2}\right|
,\quad
\gt_n=\arcsin{z_n-Z_0\over b_x}
,\\&&
a^s_{n0}=\sin\gt_n-\sin\gt_x
,\quad
a^s_{nk}=2\sin k\gt_n\left|\sin{\gt_x-\gt_n\over2}\right|
.\eqbl

#endif
}

int ESBoundaryLayerX()
{
/*
   */
#ifdef Doc_ESBoundaryLayerX
\Section{Skeleton of \c{ESBoundaryLayerX()}}
  \begin{verbatim}
    ESBoundaryLayerX(){
    }
  \end{verbatim}
\Section{\c{ESBoundaryLayerX()}}
\Subsection{Description}
Geometry near the X-point
\bqbl
&&
y^2-x^2=d^2
,\\&&
y=-\q{d^2+x^2}
.\eqbl

\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\begin{tabular}{|llp{4in}|}\hline
\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&$$&\\
\c{}&$$&\\
\c{}&$$&\\
\c{}&$$&\\
\hline\end{tabular}
\Subsection{Output}
\vskip1ex\begin{tabular}{|llp{4in}|}\hline
\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&$$&\\
\c{}&$$&\\
\c{}&$$&\\
\c{}&$$&\\
\hline\end{tabular}
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}
static double rBL[];	/*  */
static double zBL[];	/*  */

int ESGapCoreSepX()
{
  Undef four();
  extern double d_vb;		/* undefined */
  extern double z_X2;		/* undefined */
  extern int ESnBL1;		/* undefined */
  extern double ESDx[];		/* undefined */
  extern double ESLx[];		/* undefined */
  extern double ESVx[];		/* undefined */
  extern double dx_0x;		/* undefined */
  extern double d2x_0x;		/* undefined */
  extern double dx_0o;		/* undefined */
  extern double d2x_0o;		/* undefined */
  extern double *x0sep;		/* undefined */
  extern double *x1sep;		/* undefined */
  extern double cr4;		/* undefined */
  extern double *x2sep;		/* undefined */
  extern double *Dz2;		/* undefined */
  extern double *Ddx2;		/* undefined */
  extern double *Dx2;		/* undefined */
  extern double *Dx0;		/* undefined */
  extern int ESnBL;		/* undefined */
  extern double ESgFPlVx;	/* undefined */
  extern double *rvb;		/* undefined */
  extern double *zvb;		/* undefined */
  extern double *Dx2c;		/* undefined */
  extern double *Dx2s;		/* undefined */
  extern double *Dz2c;		/* undefined */
  extern double *Dz2s;		/* undefined */
  extern double *rvbcs;		/* undefined */
  extern double *rvbsn;		/* undefined */
  static double Z0_vb;	/*  <BndLr:escB.c */
/*
   */
#ifdef Doc_ESGapCoreSepX
  \section{Skeleton of \Cline{GapCoreSepX()}}

  \begin{verbatim}
  GapCoreSepX(){
  }
  \end{verbatim}

\section{Subroutine GapCoreSepX()}

\Cline{GapCoreSep()} initiates coordinates in the gap
region given the separatrix geometry. It provides the Fourier
coefficients for the virtual plasma boundary.

Magnetic surfaces in the layer between plasma core and boundary
\bqbl
r
&=&
r_X
+\left[
  x_0(\gt)
 +{d\over4b_x}{x_1+{d\over b_x}x_2\over S}
 \right]\sqrt{S}
+x^s_0\left({z\over b_x}-\sin\gt_x\right)
,\\
x_1
&\equiv&
x_0(3-\sin\gt_x\sin\gt)
+2x'_0\sin\gt_x\cos\gt
,\\
S
&\equiv&
\sin^2{\gt_x-\gt\over2}-{2d\over b_x}-{d^2z_2\over b_x^2}
\simeq
\sin^2{\gt_x-\gt\over2}-{2d\over b_x}
=
{1-\sin\gt_x\sin\gt\over2}-{2d\over b_x}
,\\
z
&=&
Z_X
+b_x\left(
  {d\over b_x}\sin\gt_x
 +{d^2z_2\over b_x^2}\sin\gt_x
 +{b\over b_x}\sin\gt
 \right)
,\quad
b
=
b_x+d
,\\
r'_b
&=&
\left[
  {1\over4b_x}{x_0(3-\sin\gt_x\sin\gt)+2x'_0\sin\gt_x\cos\gt+2{d\over b_x}x_2
  \over S}
 \right]
\sqrt{S}
\\&&
-\left[
  {x_0\over b_x}
 -{d\over4b_x^2}{x_0(3-\sin\gt_x\sin\gt)+2x'_0\sin\gt_x\cos\gt+{d\over b_x}x_2
   \over S}
 \right]{1+{dz_2\over b_x}\over\sqrt{S}}
\\&&
+{x^s\over b_x}\left(\sin\gt_x+2{dz_2\over b_x}\sin\gt_x+\sin\gt\right)
,\\
r'_\gt
&=&
\left[
  x'_0
 +{d\over4b_x}{3x'_0(1-\sin\gt_x\sin\gt)-x_0\sin\gt_x\cos\gt
   +2x''_0\sin\gt_x\cos\gt+{d\over b_x}x'_2
   \over S}
 \right]\sqrt{S}
\\&&
-\left[
  x_0
 -{d\over4b_x}{x_0(3-\sin\gt_x\sin\gt)+2x'_0\sin\gt_x\cos\gt+{d\over b_x}x_2
   \over S}
 \right]{\sin\gt_x\cos\gt\over4\sqrt{S}}
+x^s_0{b\over b_x}\cos\gt
,\\
z'_b
&=&
\sin\gt_x+2{dz_2\over b_x}\sin\gt_x+\sin\gt
,\\
z'_\gt
&=&
b\cos\gt
.\eqbl

Fourier expansion of separatrix coordinates
\bqbl
&&
r
=
r_X
+x_0\left|\sin{\gt_x-\gt\over2}\right|
+x^s_0(\sin\gt-\sin\gt_x)
,\quad
x_0=x^c_0+2\sum_{k=1}^L\left(x^c_k\cos k\gt+x^s_k\sin k\gt\right)
,\\&&
x'_0
=
2\sum_{k=1}^Lk\left(-x^c_k\sin k\gt+x^s_k\cos k\gt\right)
,\quad
x''_0=
-2\sum_{k=1}^Lk^2\left(x^c_k\cos k\gt+x^s_k\sin k\gt\right)
,\\&&
z
=
Z_{X0}+b_x\sin\gt
,\quad
x^s=\gg_xb_x
.\eqbl

Determinant in the gap
\bqbl
D
&\equiv&
-{d\over4b_x\sqrt{S}}\baD
,\\
r'_b
&=&
\left[
  {1\over4b_x}{x_0(3-\sin\gt_x\sin\gt)+2x'_0\sin\gt_x\cos\gt+2{d\over b_x}x_2
  \over S}
 \right]
\sqrt{S}
\\&&
-\left[
  {x_0\over b_x}
 -{d\over4b_x^2}{x_0(3-\sin\gt_x\sin\gt)+2x'_0\sin\gt_x\cos\gt+{d\over b_x}x_2
   \over S}
 \right]{1+{dz^*_2\over b_x}\over\sqrt{S}}
\\&&
+{x^s\over b_x}\left(\sin\gt_x+2{dz_2\over b_x}\sin\gt_x+\sin\gt\right)
,\\
r'_\gt
&=&
\left[
  x'_0
 +{d\over4b_x}{3x'_0(1-\sin\gt_x\sin\gt)-x_0\sin\gt_x\cos\gt
   +2x''_0\sin\gt_x\cos\gt+{d\over b_x}x'_2
   \over S}
 \right]\sqrt{S}
\\&&
-\left[
  x_0
 -{d\over4b_x}{x_0(3-\sin\gt_x\sin\gt)+2x'_0\sin\gt_x\cos\gt+{d\over b_x}x_2
   \over S}
 \right]{\sin\gt_x\cos\gt\over4\sqrt{S}}
+x^s_0{b\over b_x}\cos\gt
,\\
z'_b
&=&
\sin\gt_x+2{dz_2\over b_x}\sin\gt_x+\sin\gt
,\\
z'_\gt
&=&
b\cos\gt
,\\
-d\baD
&=&
x_0(3-\sin\gt_x\sin\gt)b\cos\gt
+2bx'_0\sin\gt_x\cos^2\gt
+2b{d\over b_x}x_2\cos\gt
\\&&
+\left[
 -4x_0
 +{d\over b_x}{x_0(3-\sin\gt_x\sin\gt)+2x'_0\sin\gt_x\cos\gt+{d\over b_x}x_2
   \over S}
 \right]{1+{dz^*_2\over b_x}\over}b\cos\gt
\\&&
-d{3x'_0(1-\sin\gt_x\sin\gt)-x_0\sin\gt_x\cos\gt
   +2x''_0\sin\gt_x\cos\gt+{d\over b_x}x'_2
   \over}(\sin\gt_x+2{dz_2\over b_x}\sin\gt_x+\sin\gt)
\\&&
-d{x_0(3-\sin\gt_x\sin\gt)+2x'_0\sin\gt_x\cos\gt+{d\over b_x}x_2\over 4S}
 (1+2{dz_2\over b_x}+\sin\gt_x\sin\gt)\cos\gt
\\&&
-4b_xx'_0S(\sin\gt_x+2{dz_2\over b_x}\sin\gt_x+\sin\gt)
+b_xx_0(1+2{dz_2\over b_x}+\sin\gt_x\sin\gt)\cos\gt
.\eqbl
In the main order
\bqbl
-\baD
&=&
-x_0(1+\sin\gt_x\sin\gt)\cos\gt
-4x_0z^*_2\cos\gt
+2x'_0\sin\gt_x\cos^2\gt
+8x'_0(\sin\gt_x+\sin\gt)
\\&&
+{2x_0(3-\sin\gt_x\sin\gt)+4x'_0\sin\gt_x\cos\gt\over1-\sin\gt_x\sin\gt}\cos\gt
\\&&
-3x'_0(1-\sin\gt_x\sin\gt)(\sin\gt_x+\sin\gt)
+x_0(1+\sin\gt_x\sin\gt)\cos\gt
-2x''_0(1+\sin\gt_x\sin\gt)\cos\gt
\\&&
-{x_0(3-\sin\gt_x\sin\gt)+2x'_0\sin\gt_x\cos\gt\over2(1-\sin\gt_x\sin\gt)}
(1+\sin\gt_x\sin\gt)\cos\gt
\\&&
+2x_2\cos\gt
-8x'_0z_2S\sin\gt_x
+2x_0z_2\cos\gt
,\\
-\baD
&=&
8x'_0(\sin\gt_x+\sin\gt)
-4x'_0z_2(\sin\gt_x-\sin\gt)
-x'_0\sin\gt_x\cos^2\gt
-2x''_0(1+\sin\gt_x\sin\gt)\cos\gt
\\&&
+{2x_0(3-\sin\gt_x\sin\gt)+4x'_0\sin\gt_x\cos\gt\over1-\sin\gt_x\sin\gt}\cos\gt
\\&&
-{x_0(3-\sin\gt_x\sin\gt)+2x'_0\sin\gt_x\cos\gt\over2(1-\sin\gt_x\sin\gt)}
(1+\sin\gt_x\sin\gt)\cos\gt
\\&&
+2x_2\cos\gt
+2x_0(z_2-2z^*_2)\cos\gt
,\\
\baD
&=&
-8x'_0(\sin\gt_x+\sin\gt)
+4x'_0z_2(\sin\gt_x-\sin\gt)
+x'_0\sin\gt_x\cos^2\gt
+2x''_0(1+\sin\gt_x\sin\gt)\cos\gt
\\&&
-{2x_0(3-\sin\gt_x\sin\gt)+4x'_0\sin\gt_x\cos\gt\over1-\sin\gt_x\sin\gt}\cos\gt
\\&&
+{x_0(3-\sin\gt_x\sin\gt)+2x'_0\sin\gt_x\cos\gt\over2(1-\sin\gt_x\sin\gt)}
 (1+\sin\gt_x\sin\gt)\cos\gt
\\&&
-2x_0(z_2-2z^*_2)\cos\gt
-2x_2\cos\gt
.\eqbl
Reasonable guess for $x_2$
\bqbl
\baD
&=&
-8x'_0(\sin\gt_x+\sin\gt)
+4x'_0z_2(\sin\gt_x-\sin\gt)
-2x_2\cos\gt
+2x_0(2z^*_2-z_2)\cos\gt
\\&&
+\left(
  2x''_0(1+\sin\gt_x\sin\gt)
 -{2x'_0\sin\gt_x\cos\gt+2x_0\over1-\sin\gt_x\sin\gt}
 -x_0{5-\sin\gt_x\sin\gt\over2}
 \right)\cos\gt
,\\
x_2
&=&
x''_0(1+\sin\gt_x\sin\gt)
-x_0{5-\sin\gt_x\sin\gt\over4}
+x_0(2z^*_2-z_2)
\\&&
-{x'_0\sin\gt_x\cos\gt+x_0\over1-\sin\gt_x\sin\gt}
-4{[x'_0-x'_0(\gt_x)](\sin\gt_x+\sin\gt)\over\cos\gt}
+2{[x'_0-x'_0(\gt_o)](\sin\gt_x-\sin\gt)\over\cos\gt}z_2
,\\
x_2(\gt_x)
&=&
2x''_0(1+\sin\gt_x\sin\gt)
-x_0
+x_0(2z^*_2-z_2)
+9x''_0
,\\
x_2(\gt_o)
&=&
-2x_0
+x_0(2z^*_2-z_2)
+4x''_0z_2
.\eqbl

%================================== Garbage ==========================
\bqbl
&&
x
=
x_X
+x_0\left|\sin{\gt_x-\gt\over2}\right|
+x^s_0(\sin\gt-\sin\gt_x)
,\quad
x_0
=
x^c_0+2\sum_{k=1}^L\left(x^c_k\cos k\gt+x^s_k\sin k\gt\right)
,\quad
x^s
=
\gg_xb_x
,\\&&
x'_0
=
2\sum_{k=1}^Lk\left(-x^c_k\sin k\gt+x^s_k\cos k\gt\right)
,\quad
x''_0=
-2\sum_{k=1}^Lk^2\left(x^c_k\cos k\gt+x^s_k\sin k\gt\right)
,\\&&
z
=
Z_{X0}+b_x\sin\gt
.\eqbl
Determinant in the gap
\bqbl
&&
\baD(\gt)=
-8x_0'(\gp/2)(1+\sin\gt)
+4z_2x_0'(-\gp/2)(1-\sin\gt)
\\&&
+\left[
4z_2{x_0'-x_0'(-\gp/2)\over\cos\gt}(1-\sin\gt)
-8{x_0'-x_0'(\gp/2)\over\cos\gt}(1+\sin\gt)
-2{x_0'\cos\gt+x_0\over1-\sin\gt}
\right.\\&&\left.
+2x_0''(1+\sin\gt)
-3x_0
+x_0{1+\sin\gt\over2}
+2z_2x_0
-2x_2
\right]\cos\gt
,\\&&
x_2=\bar{x}_2
+2z_2{x_0'-x_0'(-\gp/2)\over\cos\gt}(1-\sin\gt)
-4{x_0'-x_0'(\gp/2)\over\cos\gt}(1+\sin\gt)
-{x_0'\cos\gt+x_0\over1-\sin\gt}
\\&&
+x_0''(1+\sin\gt)
+x_0\left({1+\sin\gt\over4}-{3\over2}+z_2\right)
,\\&&
x_2(\gp/2)=\bar{x}_2
+8x_0''(\gp/2)
+x_0''(\gp/2)
+x_0''(1+\sin\gt)
+x_0\left({1+\sin\gt\over4}-{3\over2}+z_2\right)
,\\&&
x_2(-\gp/2)=\bar{x}_2
+4z_2x_0''(-\gp/2)
-{x_0(-\gp/2)\over2}
+x_0''(1+\sin\gt)
+x_0\left({1+\sin\gt\over4}-{3\over2}+z_2\right)
.\eqbl
Magnetic surfaces
\bqbl
&&
x=x_X+\left[x_0(\gt)
+{d\over4b_x}{x_0(3-\sin\gt)+2x_0'\cos\gt+{d\over b_x}x_2
\over\sin^2{\gt_x-\gt\over2}-{2d\over b_x}-{d^2z_2\over b_x^2}}
\right]
\sqrt{\sin^2{\gt_x-\gt\over2}-{2d\over b_x}-{d^2z_2\over b_x^2}}
\\&&
+x^s_0\left(1-{z\over b_x}\right)
,\quad
z=Z_X+b_x\left({d\over b_x}+{d^2z_2\over b_x^2}+{a\over b_x}\sin\gt\right)
,\quad
a=b_x+d
,\\&&
r'_a=
\left[
{1\over4b_x}{x_0(3-\sin\gt)+2x_0'\cos\gt+2{d\over b_x}x_2
\over\sin^2{\gt_x-\gt\over2}-{2d\over b_x}-{d^2z_2\over b_x^2}}
\right]
\sqrt{\sin^2{\gt_x-\gt\over2}-{2d\over b_x}-{d^2z_2\over b_x^2}}
\\&&
-\left[{x_0\over b_x}
-{d\over4b_x^2}{x_0(3-\sin\gt)+2x_0'\cos\gt+{d\over b_x}x_2
  \over\sin^2{\gt_x-\gt\over2}-{2d\over b_x}-{d^2z_2\over b_x^2}}
\right]
{1+{dz_2\over b_x}
 \over\sqrt{\sin^2{\gt_x-\gt\over2}-{2d\over b_x}-{d^2z_2\over b_x^2}}}
-{x^s\over b_x}\left(1+2{dz_2\over b_x}+\sin\gt\right)
,\\&&
z'_a=1+2{dz_2\over b_x}+\sin\gt
.\eqbl

%================================== Garbage ==========================

\section{GSh equation near the separatrix}
GSh equation in curvilinear coordinates
\bqbl
&&
r{\pa\over\pa r}{1\over r}{\pa\over\pa r}\gY
+{\pa\over\pa z}{\pa\over\pa z}\gY
=
\baF F_s
+P_sr^2
,\\&&
{\pa\over\pa r}{\pa\over\pa r}\gY
+{\pa\over\pa z}{\pa\over\pa z}\gY
=
-\baF F_s
-P_sr^2
+{1\over r}{\pa\over\pa r}\gY
,\\&&
{\pa\over\pa r}
=
{\pa a\over\pa r}{\pa\over\pa a}
+{\pa\gq\over\pa r}{\pa\over\pa\gq}
=
{z'_\gq\over D}{\pa\over\pa a}
-{z'_a\over D}{\pa\over\pa\gq}
,\quad
{\pa\over\pa z}
=
{\pa a\over\pa z}{\pa\over\pa a}
+{\pa\gq\over\pa z}{\pa\over\pa\gq}
=
-{r'_\gq\over D}{\pa\over\pa a}
+{r'_a\over D}{\pa\over\pa\gq}
,\\&&
{z'_\gq\over D}{\pa\over\pa a}{z'_\gq\over D}\gY'
-{z'_a\over D}{\pa\over\pa\gq}{z'_\gq\over D}\gY'
+{r'_\gq\over D}{\pa\over\pa a}{r'_\gq\over D}\gY'
-{r'_a\over D}{\pa\over\pa\gq}{r'_\gq\over D}\gY'
=
-\baF F_s
-P_sr^2
+{1\over r}{z'_\gq\over D}\gY'
.\eqbl

In local dimensionless $x,y$ coordinates near X-point
\bqbl
&&
r
=
R_x+b(x\cos\gg-y\sin\gg)
,\quad
z
=
Z_x
+b(x\sin\gg+y\cos\gg)
,\\&&
\gY
\equiv
\gy_0(y^2-x^2)
=
j_{ext}R_xb^2(y^2-x^2)
,\quad
j(\gY,r)
=
{\baF F_s(\gY)\over R_x}{R_x\over r}
+P_s(\gY)R_x{r\over R_x}
,\\&&
{\pa^2\gY\over\pa r^2}
+{\pa^2\gY\over\pa z^2}
=
-\baF F_s
-P_sr^2
+{1\over r}{\pa\over\pa r}\gY
,\\&&
{\gY''_{xx}\over\gy_0}
+{\gY''_{yy}\over\gy_0}
=
-{j_s(\gY)\over j_{ext}}
-2{j_p(\gY)\over j_{ext}}{b\over R}(x\cos\gg-y\sin\gg)
-{j_p(\gY)\over j_{ext}}{b^2\over R^2_x}(x\cos\gg-y\sin\gg)^2
\\&&\quad
+{b\over r}{\gY'_x\cos\gg-\gY'_y\sin\gg\over\gy_0}
,\\&&
j_s(\gY)
\equiv
{\baF F_s\over R_x}
+P_sR_x
,\quad
j_p(\gY)
\equiv
P_sR_x
.\eqbl

\subsection{Solution near the X-point}
Polinomial expansion of the $n$-th order
\bqbl
&&
P^n(x,y)
=
A^n_0x^n
+A^n_1x^{n-1}y
+A^n_2x^{n-2}y^2
+A^n_3x^{n-3}y^3
+\cdots
.\eqbl

\subsection{Geometry near the separatrix}
X- point is turned on angle $\gg$ ($\gg=0$ corresponds to the bottom
position, while $\gg=\gp$ to the top position, $\gg$ is clock counter-wise) 
\bqbl
&&
\gY
=
y'^2
-x'^2
,\quad
x'
=
x\cos\gg
+y\sin\gg
,\quad
y'
=
-x\sin\gg
+y\cos\gg
,\\&&
\gY
=
y^2\cos2\gg
-x^2\cos2\gg
-2xy\sin2\gg
=
{y^2-x^2-2\gg_xxy\over\sqrt{1+\gg_x^2}}
,\quad
\gg_x
\equiv
{\sin2\gg\over\cos2\gg}
.\eqbl

Bottom (top) point of the magnetic surface
\bqbl
&&
\gY
=
y'^2_t
-x'^2_t
,\quad
x
-yy'
+\gg_xy
+\gg_xxy'
=
0
,\quad
y'
=
0
,\quad
x
=
-\gg_xy_t
,\\&&
\gY
=
\sqrt{1+\gg_x^2}y_t^2
,\quad
x^2
-y^2
+2\gg_xxy
=
-(1+\gg_x^2)y_t^2
,\\&&
x
=
\pm\sqrt{1+\gg_x^2}\sqrt{y^2-y_t^2}
-\gg_xy
,\quad
r
=
R_X
+\sqrt{1+\gg_x^2}
\left(\pm\sqrt{y^2-y_t^2}-{\gg_xy\over\sqrt{1+\gg_x^2}}\right)
.\eqbl

In working coordinates $r,z$ and $b,\gt$
\bqbl
&&
x=r
-R_X
,\quad
y
=
z
-Z_X
,\quad
Z_X
=
Z_0
+b_x\sin\gt_x
,\quad
\gt_x
=\pm{\gp\over2}
,\\&&
b=b_x+d
,\quad
z
=
Z_0
+\left(d+d{d\over b_x}z_2\right)\sin\gt_x+(b_x+d)\sin\gt
,\\&&
y
=
d{d\over b_x}z_2\sin\gt_x
+d(\sin\gt+\sin\gt_x)
+b_x(\sin\gt-\sin\gt_x)
,\quad
y_t
=
d{d\over b_x}z_2\sin\gt_x
+2d\sin\gt_x
,\\&&
y+y_t
=
2d{d\over b_x}z_2\sin\gt_x
+d(\sin\gt+3\sin\gt_x)
+2b_x\sin{\gt-\gt_x\over2}\cos{\gt+\gt_x\over2}
,\\&&
y+y_t
\simeq
2d{d\over b_x}z_2\sin\gt_x
+4d\sin\gt_x
-2b_x\sin^2{\gt-\gt_x\over2}\sin\gt_x
,\\&&
y-y_t
=
b(\sin\gt-\sin\gt_x)
=
-2b\sin^2{\gt-\gt_x\over2}\sin\gt_x
,\\&&
y^2-y_t^2
=
2b\sin^2{\gt-\gt_x\over2}
\left(
 2b_x\sin^2{\gt-\gt_x\over2}
 -2d{d\over b_x}z_2
 -4d
 \right)
.\eqbl

Flux coordinates near X-point
\bqbl
&&
r
=
R_X
+\sqrt{1+\gg_x^2}\left[
  2b_x\sin\gt_x\sin{\gt_x-\gt\over2}\sqrt{
   {b\over b_x}\left(\sin^2{\gt-\gt_x\over2}-{d^2\over b_x^2}z_2-{2d\over b_x}
    \right)
   }
  -{\gg_x\over\sqrt{1+\gg_x^2}}(z-Z_X)
 \right]
,\\&&
z
=
\left(d+d{d\over b_x}z_2\right)\sin\gt_x+(b_x+d)\sin\gt
.\eqbl

For arbitrary 1-X separatrix shape
\bqbl
&&
r
=
R_X
+\left[x_0(\gt)+{d\over4b_x}{x_1(\gt)+{d\over b_x}x_2(\gt)\over S}\right]
 \sqrt{S}
-\gg_x(z-Z_X)
,\quad
S
\equiv
\sin^2{\gt-\gt_x\over2}-{2d\over b_x}
,\\&&
z
=
Z_0
+\left(d+d{d\over b_x}z_2\right)\sin\gt_x+(b_x+d)\sin\gt
,\quad
2S
=
1-\sin\gt\sin\gt_x
-{4d\over b_x}
,\\&&
x_0(\gt_x)
=0
,\quad
x_0'(\gt_x)
=
-b_x\sin\gt_x\sqrt{1+\gg_x^2}
.\eqbl

Metric coefficients
\bqbl
&&
b_xS'_b
=
-2
,\quad
2S'_\gt
=
2{\sin(\gt-\gt_x)\over2}
=
-\cos\gt\sin\gt_x
,\\&&
b_xr'_b
=
{1\over4\sqrt{S}}\left(
 -4x_0
 +x_1+2{d\over b_x}x_2
 +{d\over b_x}{x_1+{d\over b_x}x_2\over S}
 \right)
-\gg_xb_xz'_b
,\\&&
r'_\gt
=
x_0'\sqrt{S}
-{x_0\sin\gt_x\over4\sqrt{S}}\cos\gt
+{d\over4b_x}{x_1'+{d\over b_x}x_2'\over\sqrt{S}}
+{d\over4b_x}{\sin\gt_x\over\sqrt{S}}{x_1+{d\over b_x}x_2\over4S}\cos\gt
-\gg_xz'_\gt
,\\&&
z'_b
=
\left(1+2{d\over b_x}z_2\right)\sin\gt_x
+\sin\gt
,\\&&
z_\gt
=
b_x\left(1+{d\over b_x}\right)\cos\gt
.\eqbl

2-D Jacobian
\bqbl
D
&=&
{1\over4\sqrt{S}}\left(
 -4x_0
 +x_1+2{d\over b_x}x_2
 +{d\over b_x}{x_1+{d\over b_x}x_2\over S}
 \right)\left(1+{d\over b_x}\right)\cos\gt
\\&&
-\left[
 x_0'\sqrt{S}
 -{x_0\sin\gt_x\over4\sqrt{S}}\cos\gt
 +{d\over4b_x}{x_1'+{d\over b_x}x_2'\over\sqrt{S}}
 +{d\over4b_x}{\sin\gt_x\over\sqrt{S}}{x_1+{d\over b_x}x_2\over4S}\cos\gt
 \right](\sin\gt_x+\sin\gt)
\\&&
-\left[
 x_0'\sqrt{S}
 -{x_0\sin\gt_x\over4\sqrt{S}}\cos\gt
 +{d\over4b_x}{x_1'+{d\over b_x}x_2'\over\sqrt{S}}
 +{d\over4b_x}{\sin\gt_x\over\sqrt{S}}{x_1+{d\over b_x}x_2\over4S}\cos\gt
 \right]2{d\over b_x}z_2\sin\gt_x
,\\
D
&=&
{1\over4\sqrt{S}}\left(
 -4x_0
 +x_1+2{d\over b_x}x_2
 +{d\over b_x}{x_1+{d\over b_x}x_2\over S}
 \right)\left(1+{d\over b_x}\right)\cos\gt
\\&&
-{1\over4\sqrt{S}}\left[
 4x_0'S
 -x_0\sin\gt_x\cos\gt
 +{d\over b_x}\left(x_1'+{d\over b_x}x_2'\right)
 +{d\over b_x}\sin\gt_x{x_1+{d\over b_x}x_2\over4S}\cos\gt
 \right](\sin\gt_x+\sin\gt)
\\&&
-{1\over4\sqrt{S}}\left[
 4x_0'S
 -x_0\sin\gt_x\cos\gt
 +{d\over b_x}\left(x_1'+{d\over b_x}x_2'\right)
 +{d\over b_x}\sin\gt_x{x_1+{d\over b_x}x_2\over4S}\cos\gt
 \right]2{d\over b_x}z_2\sin\gt_x
,\\
D
&=&
{1\over4\sqrt{S}}\left[
 x_1
 -2x_0'\sin\gt_x\cos\gt
 -x_0(3-\sin\gt_x\sin\gt)
 \right]\cos\gt
+{d\over4b_x\sqrt{S}}8x_0'(\sin\gt_x+\sin\gt)
\\&&
-{d\over4b_x\sqrt{S}}\left(
 4x_0
 -2x_2
 -x_1+2{d\over b_x}x_2
 -{b\over b_x}{x_1+{d\over b_x}x_2\over S}
 \right)\cos\gt
\\&&
-{d\over4b_x\sqrt{S}}\left[
 \left(x_1'+{d\over b_x}x_2'\right)
 +\sin\gt_x{x_1+{d\over b_x}x_2\over4S}\cos\gt
 \right](\sin\gt_x+\sin\gt)
\\&&
-{d\over4b_x\sqrt{S}}4x_0'z_2(\sin\gt_x-\sin\gt)
-{d\over4b_x\sqrt{S}}\left[
 -2x_0z_2
 \right]\cos\gt
\\&&
-{d^2\over4b_x^2\sqrt{S}}\left[
 -8x_0'\sin\gt_x
 +x_1'\sin\gt_x
 +{d\over b_x}x_2'\sin\gt_x
 +{x_1+{d\over b_x}x_2\over4S}\cos\gt
 \right]2z_2
.\eqbl

Conditions at the separatrix
\bqbl
x_1\sin\gt_x
&=&
2x_0'\cos\gt
+x_0(3\sin\gt_x-\sin\gt)
,\quad
x'_1\sin\gt_x
=
2x_0''\cos\gt
+3x'_0(\sin\gt_x-\sin\gt)
-x_0\cos\gt
,\\
D
&\equiv&
-{d\over4b_x\sqrt{S}}\baD
.\eqbl

Final expression for 2-D Jacobian 
\bqbl
\baD
&=&
-8x_0'(\sin\gt_x+\sin\gt)
+4x_0'z_2(\sin\gt_x-\sin\gt)
\\&&
+\left(
 4x_0
 -2x_2
 -x_1+2{d\over b_x}x_2
 -{b\over b_x}{x_1+{d\over b_x}x_2\over S}
 -2x_0z_2
 \right)\cos\gt
\\&&
+\left[
 \left(x_1'+{d\over b_x}x_2'\right)
 +\sin\gt_x{x_1+{d\over b_x}x_2\over4S}\cos\gt
 \right](\sin\gt_x+\sin\gt)
\\&&
+{d\over b_x}\left[
 -8x_0'\sin\gt_x
 +x_1'\sin\gt_x
 +{d\over b_x}x_2'\sin\gt_x
 +{x_1+{d\over b_x}x_2\over4S}\cos\gt
 \right]2z_2
.\eqbl

At the separatrix
\bqbl
\baD
&=&
-8x_0'(\sin\gt_x+\sin\gt)
+4x_0'z_2(\sin\gt_x-\sin\gt)
\\&&
+\left(
 2x_0''(1+\sin\gt_x\sin\gt)
 -{5-\sin\gt_x\sin\gt\over2}x_0
 -{2x_0'\sin\gt_x\cos\gt+2x_0\over2S}
 -2x_0z_2
 -2x_2
 \right)\cos\gt
,\\
x_2
&=&
 x_0''(1+\sin\gt_x\sin\gt)
 -{5-\sin\gt_x\sin\gt\over4}x_0
 -{x_0'\sin\gt_x\cos\gt+x_0\over2S}
 -x_0z_2
+8x_0'(\gt_x)\sin\gt_x\cos\gt
+\bsx_2
,\\
\baD
&=&
-8x_0'(\sin\gt_x+\sin\gt)
+4x_0'z_2(\sin\gt_x-\sin\gt)
-16x_0'(\gt_x)\sin\gt_x\cos^2\gt
-2\bsx_2\cos\gt
.\eqbl

Expansion of 2-D Jacobian 
\bqbl
x_2
&\equiv&
4X_2\sqrt{S}
,\quad
x'_2
=
4X'_2\sqrt{S}-{X_2\over\sqrt{S}}\sin\gt_x\cos\gt
,\\
D
&=&
D_{x_0}
+D_{z_2}z_2
+D_{x_2}X_2
+D_{x'_2}X'_2
+D_{x'_2z_2}X'_2z_2
,\\
\baD_{x_0}
&=&
{d\over4b_x}(8x_0'-x_1'){\sin\gt_x+\sin\gt\over\sqrt{S}}
-\left(
 4x_0
 -x_1
 -{b\over b_x}{x_1\over S}
 +{x_1\over4S}(1+\sin\gt_x\sin\gt)
 \right){d\over4b_x}{\cos\gt\over\sqrt{S}}
,\\
\baD_{z_2}
&=&
-{dx_0'\over b_x}{\sin\gt_x-\sin\gt\over\sqrt{S}}
+{dx_0\over2b_x}{\cos\gt\over\sqrt{S}}
-{d^2\over2b_x^2\sqrt{S}}\left(
 -8x_0'\sin\gt_x
 +x_1'\sin\gt_x
 +{x_1\over4S}\cos\gt
 \right)
,\\
\baD_{x_2}
&=&
{2d\over b_x}\cos\gt
-{d^2\over b_x^2}\left(2-{b\over b_xS}\right)\cos\gt
,\\
\baD_{x'_2}
&=&
-{d^2\over b_x^2}(\sin\gt_x+\sin\gt)
,\\
\baD_{x'_2z_2}
&=&
-{2d^3\over b_x^3}\sin\gt_x
,\\
x_1
&=&
x_0(3-\sin\gt_x\sin\gt)
+2x_0'\sin\gt_x\cos\gt
,\quad
x_1'\sin\gt_x
=
3x_0'(\sin\gt_x-\sin\gt)
-x_0\cos\gt
+2x_0''\cos\gt
.\eqbl

Better coordinates in the boundary layer $b=b_x+d$, $\gq$
\bqbl
&&
x=r
-R_X
,\quad
z
=
Z_0
+\left[d_0
 +(d-d_0)\sin^2\gq
 +d{d\over b_x}z_2
 \right]\sin\gq_x
+b\sin\gq
,\\&&
\sin\gt
=
\sin\gq
+{d_0-d\over b}\sin\gq_x\cos^2\gq
,\\&&
\sin\gq
=
{2\left(\sin\gt-{d_0-d\over b}\sin\gt_x\right)
 \over1+\sqrt{\left(1-2{d_0-d\over b}\sin\gt_x\sin\gt\right)^2
  +4{(d_0-d)^2\over b^2}\cos^2\gt}}
.\eqbl

#endif
}

int ESCoreX()
{
  Undef splAA();
  static double Z0_vb;	/*  <BndLr:escB.c */
/*
   */
#ifdef Doc_ESCoreX
   \section{Skeleton of \Cline{ESCoreX()}}

   \begin{verbatim}
   ESCoreX(){
   }
   \end{verbatim}

\section{Subroutine \Cline{ESCoreX()}}
\Cline{core\_coordinates()} initiates coordinates in the core.

Corrections to the existing coordinates $r(a,\gt)$ and $z_0(a)$
\bqbl
&&
r(a,\gt)=R_0
+a^2[r_{cs,0}+\gd r_{cs,0}]
+2\sum_{k=1}^{N_F}a^k\left[
(r_{cs,k}+\gd r_{cs,k})\cos k\gt
+(r_{sn,k}+\gd r_{sn,k})\sin k\gt
\right]
,\\&&
z=Z_0+a^2(z_0+\gd z_0)+b\sin\gt
,\quad
z(a_0,\gt)=Z_X+b_x\left({d\over b_x}+{d^2z_2\over b_x^2}\right)+b\sin\gt
,\\&&
\gd r_{cs,sn,k}=\gd r^0_{cs,sn,k}+{1\over2}a^2\gd r''_{cs,sn,k}
,\quad
\gd z_0(a)=\gd z^0_0+{1\over2}a^2\gd z''_0
.\eqbl
Equations for corrections
\bqbl
&&
a_0^2\gd r_{cs,0}
=
r_{b,cs,0}-a_0^2r_{cs,0}
,\quad
[a_0^2\gd r_{cs,0}]'
=
r'_{b,cs,0}-[a_0^2r_{cs,0}]'
,\\&&
a_0^k\gd r_{cs,sn,k}
=
r_{b,cs,sn,k}-a_0^kr_{cs,sn,k}
,\quad
[a_0^k\gd r_{cs,sn,k}]'
=
r'_{b,cs,sn}-[a_0^kr_{cs,sn,k}]'
,\\&&
\gd r^0_{cs,0}+{1\over2}a_0^2\gd r''_{cs,0}
=
{r_{b,cs,0}\over a_0^2}-r_{cs,0}
,\quad
\gd r''_{cs,0}
=
{r'_{b,cs,0}\over a_0^3}
-{2r_{b,cs,0}\over a_0^4}
-{r'_{cs,0}\over a_0}
,\\&&
\gd r^0_{cs,sn,k}+{1\over2}a_0^2\gd r''_{cs,sn,k}
=
{r_{b,cs,sn,k}\over a_0^k}
-r_{cs,sn,k}
,\quad
\gd r''_{cs,sn,k}
=
{r'_{b,cs,sn}\over a_0^{k+1}}
-k{r_{b,cs,sn,k}\over a_0^{k+2}}
-{r'_{cs,sn,k}\over a_0}
,\\&&
a_0^2\gd z_0
=z_{b0}-a_0^2z_0
,\quad
[a_0^2\gd z_0]'
=z'_{b0}-[a_0^2z_0]'
,\\&&
\gd z^0_0+{1\over2}a_0^2\gd z''_0
={z_{b0}\over a_0^2}-z_0
,\quad
\gd z''_0
=
{z'_{b0}\over a_0^3}
-2{z_{b0}\over a_0^4}
-{z'_0\over a_0}
.\eqbl

#endif
}

int ESPlVdata2PlVPolar()
{
  Undef LUdcmp();
  Undef LUbksb();
  extern double c2gp;	/* undefined */
/*
   */
#ifdef Doc_ESPlVdata2PlVPolar
\section{Skeleton of ESPlVdata2PlVPolar()}
  \begin{verbatim}
    ESPlVdata2PlVPolar(){
    }
  \end{verbatim}
\section{ESPlVdata2PlVPolar()}

#endif
}

int ESComprPlVacData(prD,pzD,k2,n)
  double *prD;	/*  */
  double *pzD;	/*  */
  int *k2;	/*  */
  int n;	/*  */
{
/*
   */
#ifdef Doc_ESComprPlVacData
\section{Skeleton of ESComprPlVacData()}
  \begin{verbatim}
    ESComprPlVacData(){
    }
  \end{verbatim}
\section{ESComprPlVacData()}

#endif
}

int ESCheckIntData()
{
/*
   */
#ifdef Doc_ESCheckIntData
\section{Skeleton of ESCheckIntData()}
  \begin{verbatim}
    ESCheckIntData(){
    }
  \end{verbatim}
\section{ESCheckIntData()}

#endif
}

int ESGetPlVDAddr(rdPV,zdPV)
  double **rdPV;	/*  */
  double **zdPV;	/*  */
{
  static double *rPlVdT;/*  <3Dcore:escB.c */
  static double *zPlVdT;/*  <3Dcore:escB.c */
/*
   */
#ifdef Doc_ESGetPlVDAddr
\section{Skeleton of ESGetPlVDAddr()}
  \begin{verbatim}
    ESGetPlVDAddr(){
    }
  \end{verbatim}
\section{ESGetPlVDAddr()}

#endif
}

int ESSetPlVInt(npv,mpv)
  int npv;	/*  */
  int mpv;	/*  */
{
  static int *k2kT;	/*  <3Dcore:escB.c */
/*
   */
#ifdef Doc_ESSetPlVInt
\section{Skeleton of ESSetPlVInt()}
  \begin{verbatim}
    ESSetPlVInt(){
    }
  \end{verbatim}
\section{ESSetPlVInt()}

#endif
}

int ESInit2DPlGeom()
{
  extern int ESMp;	/* undefined */
  extern int ESMp1;	/* undefined */
  extern int ES2Mp;	/* undefined */
  extern int ES2Mp1;	/* undefined */
  extern int ESnMp;	/* undefined */
  static double *rPlVdT;/*  <3Dcore:escB.c */
  static double *zPlVdT;/*  <3Dcore:escB.c */
  static int *k2kT;	/*  <3Dcore:escB.c */
  static int nDFT;	/*  <3Dcore:escB.c */
  static int NDFT;	/*  <3Dcore:escB.c */
  int ESReInit1DFPlV();	/*  <2Dcore:escB.c */
  int ESReInit2DFTPlV();/*  <3Dcore:escB.c */
  int ESReInit2DFPPlV();/*  <2Dcore:escB.c */
  int ESReInitPlVeq();	/*  <2Dcore:escB.c */
  int ESReInit2DAPrC();	/*         :escB.c */
  int ESInit2DFPPlV();	/*  <2Dcore:escB.c */
  int ESInit3DCoord();	/*  <3Dcore:escB.c */
  int ESReal2RefData();	/*  <3Dcore:escB.c */
  int ESReal2RefGeom();	/*  <3Dcore:escB.c */
/*
   */
#ifdef Doc_ESInit2DPlGeom
\section{Skeleton of ESInit2DPlGeom()}
  \begin{verbatim}
    ESInit2DPlGeom(){
    }
  \end{verbatim}
\section{ESInit2DPlGeom()}

#endif
}

int ESUsePlVDataFile()
{
/*
   */
#ifdef Doc_ESUsePlVDataFile
\section{Skeleton of ESUsePlVDataFile()}
  \begin{verbatim}
    ESUsePlVDataFile(){
    }
  \end{verbatim}
\section{ESUsePlVDataFile()}
#endif
}

int ESReadInt(lf,Nm,i,n)
  FILE *lf;	/*  */
  char *Nm;	/*  */
  int *i;	/*  */
  int n;	/*  */
{
/*
   */
#ifdef Doc_ESReadInt
\section{Skeleton of ESReadInt()}
  \begin{verbatim}
    ESReadInt(){
    }
  \end{verbatim}
\section{ESReadInt()}
#endif
}

int ESReadDbl(lf,Nm,a,n)
  FILE *lf;	/*  */
  char *Nm;	/*  */
  double *a;	/*  */
  int n;	/*  */
{
/*
   */
#ifdef Doc_ESReadDbl
\section{Skeleton of ESReadDbl()}
  \begin{verbatim}
    ESReadDbl(){
    }
  \end{verbatim}
\section{ESReadDbl()}
#endif
}

int ESWritePlVacAO(lf)
  FILE *lf;	/*  */
{
/*
   */
#ifdef Doc_ESWritePlVacAO
\section{Skeleton of ESWritePlVacAO()}
  \begin{verbatim}
    ESWritePlVacAO(){
    }
  \end{verbatim}
\section{ESWritePlVacAO()}
\subsection{Description}
\subsection{Algorithm}
\subsection{ToDo}
\subsection{References}
#endif
}

int ESReadPlVacAIOld(lf)
  FILE *lf;	/*  */
{
  extern int EcNjet;		/* undefined */
  extern double EcRjet[];	/* undefined */
  extern double EcZjet[];	/* undefined */
  extern int FlagPoints;	/* undefined */
/*
   */
#ifdef Doc_ESReadPlVacAIOld
\Section{Skeleton of \c{ESReadPlVacAIOld()}}
  \begin{verbatim}
    ESReadPlVacAIOld(){
    }
  \end{verbatim}
\Section{\c{ESReadPlVacAIOld()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{FILE }&\c{*lf}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{extern int }&\c{EcNjet}&$$&\\
\c{extern double }&\c{EcRjet[]}&$$&\\
\c{extern double }&\c{EcZjet[]}&$$&\\
\c{extern int }&\c{FlagPoints}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int ESReadPlVacAI(lf)
  FILE *lf;	/*  */
{
  Undef IsKeyWordFound();
  Undef ReadAI();
  Undef CbStr2UserMessage();
  extern int EcNjet;		/* undefined */
  extern double EcRjet[];	/* undefined */
  extern double EcZjet[];	/* undefined */
  extern int FlagPoints;	/* undefined */
/*
   */
#ifdef Doc_ESReadPlVacAI
\section{Skeleton of ESReadPlVacAI()}
  \begin{verbatim}
    ESReadPlVacAI(){
    }
  \end{verbatim}
\section{ESReadPlVacAI()}
\subsection{Description}
\subsection{Algorithm}
\subsection{ToDo}
\subsection{References}
#endif
}

int ReSetVirtualBSize()
{
  Undef ESSetSplA();
  Undef splRA();
  Undef spl();
  extern double cr6;	/* undefined */
/*
   */
#ifdef Doc_ReSetVirtualBSize
\section{Skeleton of ReSetVirtualBSize()}
  \begin{verbatim}
    ReSetVirtualBSize(){
    }
  \end{verbatim}
\section{ReSetVirtualBSize()}
\subsection{Manual}
\begin{itemize}
\item \c{DESCRIPTION:}
\item \c{ARGUMENTS:}
\item \c{EXTERNALS:}
\item \c{RETURN VALUE:}
\begin{itemize}
  \item{\bf Success: }
  \item{\bf Failure: }

    \begin{tabular}{lcl}
    \C{i=ReSetVirtualBSize();}& -&\em return value.\\
    \C{i == 1}& -&\em Your Comment\\
    \end{tabular}
\end{itemize}
\item \c{TIPS:}
{\em }
\item \c{BUGS:}
\item \c{SEE ALSO:}
\item \c{TO DO:}
\end{itemize}
#endif
}

int ReSetREScs1()
{
  Undef ESSetSplA();
  Undef splRA();
  Undef spl();
/*
   */
#ifdef Doc_ReSetREScs1
\section{Skeleton of ReSetREScs1()}
  \begin{verbatim}
    ReSetREScs1(){
    }
  \end{verbatim}
\section{ReSetREScs1()}
\subsection{Manual}
\begin{itemize}
\item \c{DESCRIPTION:}
\item \c{ARGUMENTS:}
\item \c{EXTERNALS:}
\item \c{RETURN VALUE:}
\begin{itemize}
  \item{\bf Success: }
  \item{\bf Failure: }

    \begin{tabular}{lcl}
    \C{i=ReSetREScs1();}& -&\em return value.\\
    \C{i == 1}& -&\em Your Comment\\
    \end{tabular}
\end{itemize}
\item \c{TIPS:}
{\em }
\item \c{BUGS:}
\item \c{SEE ALSO:}
\item \c{TO DO:}
\end{itemize}
#endif
}

int ReSetRcs2()
{
  Undef ESSetSplA();
  Undef splRA();
  Undef f2spl();
/*
   */
#ifdef Doc_ReSetRcs2
\section{Skeleton of ReSetRcs2()}
  \begin{verbatim}
    ReSetRcs2(){
    }
  \end{verbatim}
\section{ReSetRcs2()}
Routine extends the coordinate system toward the hole near the origin.
Fourier coefficients $b,r^c_1,r^s_1$ are extrapolated in accordance with
\bqbl
&&
f(a)=f_1a+f_2a^2+f_3a^3
,\quad
f_1a_0+f_2a^2_0+f_3a^3_0
=
f(a_0)
,\quad
f_1+2f_2a_0+3f_3a^2_0
=
f'(a_0)
,\\&&
2f_2+6f_3a_0
=
f''(a_0)
,\eqbl
where $a_0$ is the radius of the hole. Other Fourier coefficients, which
have zero first derivative at the center of the coordinate system are
extrapolated as
\bqbl
&&
f(a)=f_2a^2+f_3a^3
,\quad
f_2a^2_0+f_3a^3_0
=
f(a_0)
,\quad
2f_2a_0+3f_3a^2_0
=
f'(a_0)
\eqbl
with matching only first derivative.
#endif
}

int ESHoleEdgeBoundary1()
{
  Undef ESP2F();
  Undef LUdcmp();
  Undef LUbksb();
  Undef splAA();
/*
   */
#ifdef Doc_ESHoleEdgeBoundary1
\section{Skeleton of ESHoleEdgeBoundary1()}
  \begin{verbatim}
    ESHoleEdgeBoundary1(){
    }
  \end{verbatim}
\section{ESHoleEdgeBoundary1()}
\subsection{Manual}
\begin{itemize}
\item \c{DESCRIPTION:}
\item \c{ARGUMENTS:}
\item \c{EXTERNALS:}
\item \c{RETURN VALUE:}
\begin{itemize}
  \item{\bf Success: }
  \item{\bf Failure: }

    \begin{tabular}{lcl}
    \C{i=ESHoleEdgeBoundary1();}& -&\em return value.\\
    \C{i == 1}& -&\em Your Comment\\
    \end{tabular}
\end{itemize}
\item \c{TIPS:}
{\em }
\item \c{BUGS:}
\item \c{SEE ALSO:}
\item \c{TO DO:}
\end{itemize}
#endif
}

int ESHoleEdgeBoundary()
{
/*
   */
#ifdef Doc_ESHoleEdgeBoundary
\section{Skeleton of ESHoleEdgeBoundary()}
  \begin{verbatim}
    ESHoleEdgeBoundary(){
    }
  \end{verbatim}
\section{ESHoleEdgeBoundary()}
Routine performes the smoothing spline representation of Fourier component
of coordinates.

Boundary conditions for Fourier components can be derived from the
equilibrium equation in vicinity of the hole boundary
\bqbl
&&
\maK\vgy''
=
-\maL\bsj_s
-\maV\bsj_p
,\quad
\maK\equiv\R{g_{\gt\gt}}{rD}
,\quad
\maL\equiv\R{R_0D}{r}
,\quad
\maV\equiv D\left(\R{r}{R_0}-\R{R_0}{r}\right)
,\quad
D
=
r'_ab\cos\gt-b'r'_\gt\sin\gt
.\eqbl
Considering as unknowns Fourier components of $r'_a$
\bqbl
&&
\R{g_{\gt\gt}}{r(r'_ab\cos\gt-b'r'_\gt\sin\gt)}\gy''
=
-\left[\R{R_0}{r}\bsj_s
+\left(\R{r}{R_0}-\R{R_0}{r}\right)\bsj_p\right](r'_ab\cos\gt-b'r'_\gt\sin\gt)
,\\&&
r'_a
=
\sum^{m=M}_{m=-M}(r'^c_{am}-ir'^s_{am})e^{im\gt}
,\quad
g
\equiv
\R{g_{\gt\gt}}{r}
,\quad
f
\equiv
\left[\R{R_0}{r}\bsj_s
+\left(\R{r}{R_0}-\R{R_0}{r}\right)\bsj_p\right]
,\\&&
\v{\left(\R{g\gy''}{D}\right)}
=
-\v{(fD)}
,\quad
\v{\left(\R{g\gy''}{D}-\R{g\gy''}{D^2}\gd D\right)}
=
-\v{(fD+f\gd D)}
,\quad
\v{\left(2\R{g\gy''}{D}\right)}=
\v{\left(\R{g\gy''}{D^2}-f\right)D^1}
,\\&&
\v{\left(2\R{g\gy''}{D}\right)}
=
\v{\left(\R{g\gy''}{D^2}-f\right)(r'_ab\cos\gt-b'r'_\gt\sin\gt)}
.\eqbl
Normalization
\bqbl
&&
2\gF_0a_{hole}
=
\baF_0\left(\R{D}{r}\right)_0
,\quad
\gy''
=
-\R{(fD)_0}{K_0}
,\quad
K_0
=
\left(\R{g_{\gt\gt}}{rD}\right)_0
.\eqbl
Final equation in Fourier space
\bqbl
&&
\v{V}
=
\v{(Ud)}
,\quad
V
\equiv
2\R{g\gy''}{D}
,\quad
U
\equiv
\R{g\gy''}{D^2}-f
,\quad
d
\equiv
r'_ab\cos\gt-r'_\gt(b'\sin\gt+r'^s_0)
,\\&&
V
=
\sum^{m=2M}_{m=-2M}V_me^{im\gt}
,\quad
U
=
\sum^{m=2M}_{m=-2M}U_me^{im\gt}
,\\&&
V_m
=
\sum^{k=M}_{k=-M}U_{m-k}d_k
=
U_md_0
+\sum^{k=M}_{k=1}(U_{m-k}d_k+U_{m+k}d^*_k)
,\\&&
V_m
=
U_md_0
+\sum^{k=M}_{k=1}[(U_{m-k}+U_{m+k})d^r_k+i(U_{m-k}-U_{m+k})d^i_k]
.\eqbl
Conversion of $d$ into $r',b'$ 
\bqbl
&&
d
=
r'_ab\cos\gt-r'_\gt(b'\sin\gt+r'^s_0)
,\\&&
r'_\gt
=
\sum^{k=M}_{k=-M}ikr_ke^{ik\gt}
,\\&&
r'_\gt\sin\gt
=
\sum^{k=M}_{k=-M}\R{kr_k}{2}\left(e^{i(k+1)\gt}-e^{i(k-1)\gt}\right)
=
\sum^{k=M+1}_{k=-M+1}\R{k-1}{2}r_{k-1}e^{ik\gt}
-\sum^{k=M-1}_{k=-M-1}\R{k+1}{2}r_{k+1}e^{ik\gt}
,\\&&
d_m
=
\R{b}{2}(r'_{m-1}+r'_{m+1})
-b'(r'_\gt\sin\gt)_m
-imr_mr'^s_0
,\\&&
r'_\gt
=
\sum^{k=M}_{k=-M}ikr_ke^{ik\gt}
,\\&&
r'_\gt\sin\gt
=
\sum^{k=M}_{k=-M}\R{kr_k}{2}\left(e^{i(k+1)\gt}-e^{i(k-1)\gt}\right)
=
\sum^{k=M+1}_{k=-M+1}\R{k-1}{2}r_{k-1}e^{ik\gt}
-\sum^{k=M-1}_{k=-M-1}\R{k+1}{2}r_{k+1}e^{ik\gt}
,\\&&
d_m
=
\R{b}{2}(r'_{m-1}+r'_{m+1})
-\R{(m-1)r_{m-1}-(m+1)r_{m+1}}{2}b'
-imr_mr'^s_0
.\eqbl

Subroutine performs
\begin{enumerate}
\item Normalization
\bqbl
&&
2\gF_0a_{hole}
=
\baF_0\left(\R{D}{r}\right)_0
,\quad
\gy''
=
-\R{(fD)_0}{K_0}
,\quad
K_0
=
\left(\R{g_{\gt\gt}}{rD}\right)_0
.\eqbl
\item Calculation of $d_m$
\bqbl
&&
\v{V}
=
\v{(Ud)}
,\quad
V
\equiv
2\R{g\gy''}{D}
,\quad
U
\equiv
\R{g\gy''}{D^2}-f
,\\&&
V_m
=
U^r_md_0
+iU^i_md_0
+\sum^{k=M}_{k=1}[(U^r_{m-k}+U^r_{m+k})d^r_k-(U^i_{m-k}-U^i_{m+k})d^i_k]
\\&&
\hskip1in
+\sum^{k=M}_{k=1}[i(U^i_{m-k}+U^i_{m+k})d^r_k+i(U^r_{m-k}-U^r_{m+k})d^i_k]
.\eqbl
\item Conversion of $d$ into $r',b'$ 
\bqbl
&&
d
=
r'_ab\cos\gt-r'_\gt(b'\sin\gt+r'^s_0)
,\\&&
d_m
=
\R{b}{2}(r'_{m-1}+r'_{m+1})
-\R{(m-1)r_{m-1}-(m+1)r_{m+1}}{2}b'
-imr_mr'^s_0
.\eqbl
\end{enumerate}

As another approach, the subroutine solves the equations
\bqbl
&&
D=\baD+\R{b'}{b'_0}\taD
,\quad
\baD
\equiv
\sum^{m<M}_{m>-M}D_me^{im\gt}
,\quad
\taD
\equiv
\sum_{|m|>=M}D_m^{im\gt}
,\\&&
2\gF_0a_{hole}
=
\baF_0\left(\R{\baD+\R{b'}{b'_0}\taD}{r}\right)_0
,\quad
\R{2\gF_0a_{hole}}{\baF_0}
=
\left(\R{\baD+\R{b'}{b'_0}\taD}{r}\right)_0
,\\&&
\R{g}{D}(fD)_0
=
\left(\R{g}{D}\right)_0fD
,\\&&
\R{g}{D}(fD)_0
-\R{g}{D^2}(fD)_0\gd D
+\R{g}{D}(f\gd D)_0
=
\left(\R{g}{D}\right)_0fD
-\left(\R{g\gd D}{D^2}\right)_0fD
+\left(\R{g}{D}\right)_0f\gd D
,\\&&
\R{g}{D}(fD)_0
-\left(\R{g}{D}\right)_0fD
=
\R{g}{D^2}(fD)_0\gd D
-\R{g}{D}(f\gd D)_0
-\left(\R{g\gd D}{D^2}\right)_0fD
+\left(\R{g}{D}\right)_0f\gd D
,\\&&
\vaV
=
U\gd D
-\R{g}{D}(f\gd D)_0
-\left(\R{g\gd D}{D^2}\right)_0fD
,\\&&
\vaV
\equiv
\v{\R{g}{D}(fD)_0}
-\v{\left(\R{g}{D}\right)_0fD}
,\quad
U
\equiv
\R{g}{D^2}(fD)_0
+\left(\R{g}{D}\right)_0f
,\\&&
V_m
=
U^r_md_0
+iU^i_md_0
+\sum^{k=M}_{k=1}[(U^r_{m-k}+U^r_{m+k})d^r_k-(U^i_{m-k}-U^i_{m+k})d^i_k]
\\&&
\hskip1in
+\sum^{k=M}_{k=1}[i(U^i_{m-k}+U^i_{m+k})d^r_k+i(U^r_{m-k}-U^r_{m+k})d^i_k]
,\\&&
\baD
=
r'_ab\cos\gt
-r'_\gt\sin\gt b'
+\R{\taD}{b'_0}b'
-r'_\gt r'^s_0
,\\&&
D_m
=
\R{b}{2}(r'_{m-1}+r'_{m+1})
-\R{(m-1)r_{m-1}-(m+1)r_{m+1}}{2}b'
-imr_mr'^s_0
.\eqbl
System of final equations
\bqbl
&&
\R{2\gF_0a_{hole}}{\baF_0}
-\left(\R{\baD}{r}\right)_0
=
\left(\R{\gd D}{r}\right)_0
,\\&&
\vaV
=
U\gd D
-\R{g}{D}(f\gd D)_0
-\left(\R{g\gd D}{D^2}\right)_0fD
,\\&&
\vaV
\equiv
\v{\R{g}{D}(fD)_0}
-\v{\left(\R{g}{D}\right)_0fD}
,\quad
U
\equiv
\R{g}{D^2}(fD)_0
+\left(\R{g}{D}\right)_0f
,\\&&
\gd\baD
=
b\cos\gt\gd r'_a
+\left(\R{\taD}{b'_0}-r'_\gt\sin\gt\right)\gd  b'
-r'_\gt\gd r'^s_0
,\\&&
(fD)_0
=
f^c_0D^c_0+\sum^{m<M}_{m>-M}(2f^c_mD^c_m+2f^s_mD^s_m)
.\eqbl
Correction of coordinates
\bqbl
&&
\gd r_m
=
\gd r'_m(a-a_0)\left[1-\R{a-a_0}{1-a_0}\right]
\eqbl
#endif
}

int ESHoleEdgeBoundary2()
{
  Undef ESP2F();
  Undef LUdcmp();
  Undef LUbksb();
  Undef out();
/*
   */
#ifdef Doc_ESHoleEdgeBoundary2
\section{Skeleton of ESHoleEdgeBoundary2()}
  \begin{verbatim}
    ESHoleEdgeBoundary2(){
    }
  \end{verbatim}
\section{ESHoleEdgeBoundary2()}
\subsection{Manual}
\begin{itemize}
\item \c{DESCRIPTION:}
\item \c{ARGUMENTS:}
\item \c{EXTERNALS:}
\item \c{RETURN VALUE:}
\begin{itemize}
  \item{\bf Success: }
  \item{\bf Failure: }

    \begin{tabular}{lcl}
    \C{i=ESHoleEdgeBoundary2();}& -&\em return value.\\
    \C{i == 1}& -&\em Your Comment\\
    \end{tabular}
\end{itemize}
\item \c{TIPS:}
{\em }
\item \c{BUGS:}
\item \c{SEE ALSO:}
\item \c{TO DO:}
\end{itemize}
#endif
}

int ESD2vr()
{
  Undef ESP2F();
  Undef LUdcmp();
  Undef LUbksb();
/*
   */
#ifdef Doc_ESD2vr
\section{Skeleton of ESD2vr()}
  \begin{verbatim}
    ESD2vr(){
    }
  \end{verbatim}
\section{ESD2vr()}
\subsection{Manual}
\begin{itemize}
\item \c{DESCRIPTION:}
\item \c{ARGUMENTS:}
\item \c{EXTERNALS:}
\item \c{RETURN VALUE:}
\begin{itemize}
  \item{\bf Success: }
  \item{\bf Failure: }

    \begin{tabular}{lcl}
    \C{i=ESD2vr();}& -&\em return value.\\
    \C{i == 1}& -&\em Your Comment\\
    \end{tabular}
\end{itemize}
\item \c{TIPS:}
{\em }
\item \c{BUGS:}
\item \c{SEE ALSO:}
\item \c{TO DO:}
\end{itemize}
#endif
}

int ReSetHoleSize()
{
/*
   */
#ifdef Doc_ReSetHoleSize
\section{Skeleton of ReSetHoleSize()}
  \begin{verbatim}
    ReSetHoleSize(){
    }
  \end{verbatim}
\section{ReSetHoleSize()}
Routine adjusts the coordinate system to the size of the hole near the origin.

#endif
}

int ESInputPlVac()
{
  extern int FlagPoints;	/* undefined */
  extern int EcNjet;		/* undefined */
  extern double EcRjet[];	/* undefined */
  extern double EcZjet[];	/* undefined */
  static double *rPlVdT;/*  <3Dcore:escB.c */
  static double *zPlVdT;/*  <3Dcore:escB.c */
  static int *k2kT;	/*  <3Dcore:escB.c */
  static int nDFT;	/*  <3Dcore:escB.c */
  static int NDFT;	/*  <3Dcore:escB.c */
  int ESReInit1DFPlV();	/*  <2Dcore:escB.c */
  int ESReInit2DFTPlV();/*  <3Dcore:escB.c */
  int ESReInit2DFPPlV();/*  <2Dcore:escB.c */
  int ESReInitPlVeq();	/*  <2Dcore:escB.c */
  int ESInit2DFPPlV();	/*  <2Dcore:escB.c */
  int ESReal2RefDataX();/*  <3Dcore:escB.c */
  int ESReal2RefData();	/*  <3Dcore:escB.c */
  int ESReal2RefGeom();	/*  <3Dcore:escB.c */
  int ESRef2RealGeom();	/*  <3Dcore:escB.c */
  int ESRealGeom();	/*  <3Dcore:escB.c */
/*
   */
#ifdef Doc_ESInputPlVac
\section{Skeleton of ESInputPlVac()}
  \begin{verbatim}
    ESInputPlVac(){
    }
  \end{verbatim}
\section{ESInputPlVac()}
\subsection{Manual}
\begin{itemize}
\item \c{DESCRIPTION:}
\subsection{Alignment of the plasma boundary with the wall surface}
Wall surface
\bqbl
&&
r^w
=
r^w_{c0}
+2\sum^{m<M}_{m=1}\left(r^w_{cm}\cos m\gt+r^w_{sm}\sin m\gt\right)
,\quad
z^w
=
r^w_{s0}+b^w\sin\gt
.\eqbl
Plasma surface
\bqbl
&&3
r^p
=
r^p_0
+2\sum^{m<M}_{m=1}\left(r^p_{cm}\cos m\gt+r^p_{sm}\sin m\gt\right)
,\quad
z^p
=
r^p_{s0}+b^p\sin\gt
.\eqbl
Deviation
\bqbl
&&
r^w
=
r^p+\gd r^w
,\quad
z^w
=
z^p+\gd z^w
,\quad
\gd r_p
=
\R{z'^w\gd n}{\q{{r'^w}^2+{z'^w}^2}}
,\quad
\gd z_p
=
-\R{r'^w\gd n}{\q{{r'^w}^2+{z'^w}^2}}
,\eqbl
where derivatives are taken with respect to the angle.
Iterative solution
\bqbl
&&
r^w+r'^w\gd\gt
=
r^p+\R{z'^w\gd n}{\q{{r'^w}^2+{z'^w}^2}}
,\quad
z^w+z'^w\gd\gt
=
z^p-\R{r'^w\gd n}{\q{{r'^w}^2+{z'^w}^2}}
,\\&&
r'^w\gd\gt-\R{z'^w\gd n}{\q{{r'^w}^2+{z'^w}^2}}
=
r^p-r^w
,\quad
z'^w\gd\gt+\R{r'^w\gd n}{\q{{r'^w}^2+{z'^w}^2}}
=
z^p-z^w
,\\&&
\gd\gt
=
\R{(r^p-r^w)r'^w+(z^p-z^w)z'^w}{{r'^w}^2+{z'^w}^2}
,\quad
\gd n
=
\R{(z^p-z^w)r'^w-(r^p-r^w)z'^w}{\q{{r'^w}^2+{z'^w}^2}}
.\eqbl
\item \c{ARGUMENTS:}
\item \c{EXTERNALS:}
\item \c{RETURN VALUE:}
\begin{itemize}
  \item{\bf Success: }
  \item{\bf Failure: }

    \begin{tabular}{lcl}
    \C{i=ESInputPlVac();}& -&\em return value.\\
    \C{i == 1}& -&\em Your Comment\\
    \end{tabular}
\end{itemize}
\item \c{TIPS:}
{\em }
\item \c{BUGS:}
\item \c{SEE ALSO:}
\item \c{TO DO:}
\end{itemize}
#endif
}

int ESInput2DEqSolv()
{
  Undef ESGetSmoothAddr();
  Undef PFFirstSetSpl0();
  Undef PFFirstSetSpl();
  Undef PFFirstSetSpl2();
  Undef PFBasicFPlot();
  Undef ESReInitMetrTnsrCS();
  Undef ECRcs3D2Rcs2D();
  Undef ES3DMetrTnsrCS();
  Undef ES3DMetrTnsrCSHole();
  Undef ES3DMetrTnsrCSHoleV();
  extern int ESEqSolvFl;/* undefined */
  extern int neqUJ;	/* undefined */
  extern int neqUP;	/* undefined */
  extern int neqU;	/* undefined */
  extern int ESEqSolvIt;/* undefined */
  extern int ESFp;	/* undefined */
  extern double ESav;	/* undefined */
/*
   */
#ifdef Doc_ESInput2DEqSolv
\section{Skeleton of ESInput2DEqSolv()}
  \begin{verbatim}
    ESInput2DEqSolv(){
    }
  \end{verbatim}
\section{ESInput2DEqSolv()}

#endif
}

int ESInitPlGeom()
{
  Undef ESGetPncrAddr();
  extern int ESNt;	/* undefined */
  static double *rPlVdT;/*  <3Dcore:escB.c */
  static double *zPlVdT;/*  <3Dcore:escB.c */
  static int *k2kT;	/*  <3Dcore:escB.c */
  static int nDFT;	/*  <3Dcore:escB.c */
  static int NDFT;	/*  <3Dcore:escB.c */
  int ESRef2RealData();	/*  <3Dcore:escB.c */
  int ESRef2RealGeom();	/*  <3Dcore:escB.c */
  int ESRealGeom();	/*  <3Dcore:escB.c */
  int ESReInit1DFPlV();	/*  <2Dcore:escB.c */
  int ESReInit2DFTPlV();/*  <3Dcore:escB.c */
  int ESReInit2DFPPlV();/*  <2Dcore:escB.c */
  int ESReInitPlVeq();	/*  <2Dcore:escB.c */
  int ESReInit2DAPrC();	/*         :escB.c */
  int ESInit2DFPPlV();	/*  <2Dcore:escB.c */
  int ESInit3DCoord();	/*  <3Dcore:escB.c */
  int ESReal2RefData();	/*  <3Dcore:escB.c */
  int ESReal2RefGeom();	/*  <3Dcore:escB.c */
/*
     Memory allocation
     Basic numbers: Lt,Nt,Np,Na
     Dependencies:
     
     
     *a,*aa,*b		:	Na,NA,NaD;
     ESReInit1ACore()	:	Na,NA
     ESInit1ACore()	:	Na,NaD
     
     *gt,*cs1,*sn1	:	Np,NP,NpD
     ESReInit1PCore()	:	Np,NP
     ESInit1PCore()	:	Np,NpD
     
     *R0T,*Z0T,*gf,*cs1T,
     *sn1T,*Z0PlVT,
     *R0PlVT		:	Lt,Nt,NT,LtD,NtD
     ESReInit1TCore()	:	Nt,NT
     ESInit1TCore()	:	Lt,Nt,NT,LtD,NtD

     *r1cT,*r1sT	:	nAT,NAT,Na,Nt
     ESReInit2ATCore()	:	nAT,NAT

     *r,*z,*r2,*z2,*dra,
     *drt,*dza,*dzt	:	nAP,NAP,Na,Np	
     ESReInit2PACore()	:	nAP,NAP
     
     *rT,*zT,*r2T,*z2T	:	nAPT,NAPT,Na,Np,Nt
     ESReInit3PATCore()	:	nAPT,NAPT

     *k2k,*rPlVd,*zPlVd	:	NPlVd,nPlVd,kPlVd
     ESInit1DPlV()	:	NPlVd,nPlVd,kPlVd
     ESReInit1DPlV()	:	NPlVd,nPlVd

     *k2kT,*rPlVdT,
     *zPlVdT		:	Nt,nPlVd,NPlVd,nPlVd,kPlVd
     ESInit2DTPlV()	:	NDT,nDT
     ESReInit2DTPlV()	:	NDT,nDT

     *rPlVc,*rPlVs,
     *drPlVc,*drPlVs	:	NPlVf,nPlVf,MPlVf
     ESReInit1DFPlV()	:	NPlVf,nPlVf

     *rPlVcT,*rPlVsT,
     *drPlVcT,*drPlVsT	:	NDFT,nDFT
     ESReInit2DFTPlV()

     *csPlV,*snPlV	:
     ESInit2DFPPlV()	:	NPlVcs,nPlVcs
     ESReInit2DFPPlV()	:	NPlVcs,nPlVcs

     *indx,*ac,*f	:	Neq,neq
     ESReInitPlVeq()	:	Neq,neq
   */
#ifdef Doc_ESInitPlGeom
\section{Skeleton of ESInitPlGeom()}
  \begin{verbatim}
    ESInitPlGeom(){
    }
  \end{verbatim}
\section{ESInitPlGeom()}

#endif
}

int ESA2RefRZ()
{
  Undef ESGetgFPlV();
  Undef ES3DCoord2Spl();
  Undef ES3DMetrTnsrCS();
  Undef ES3DInvG22();
  Undef ESAextBext2Spl();
  Undef ESNormDispl();
  extern double ESgFPlV1a;	/* undefined */
  extern double ESgFPlV;	/* undefined */
/*
   */
#ifdef Doc_ESA2RefRZ
\section{Skeleton of ESA2RefRZ()}
  \begin{verbatim}
    ESA2RefRZ(){
    }
  \end{verbatim}
\section{ESA2RefRZ()}

#endif
}
#endif
#endif

#undef Doc_Cb_Structure
#ifdef Blb_escB.c
Blb_escB.c{
  mzl_ESmain{
  }
  mzl_1Dcore{
  }
  mzl_2Dcore{
  }
  mzl_BndLr{
  }
  mzl_3Dcore{
  }
  mzl_PL{
  }
  mzl_ESPlV{
  }
  mzl_3Dcore{
  }
  mzl_2Dcore{
  }
  mzl_3Dcore{
  }
  mzl_2Dcore{
  }
  mzl_3Dcore{
  }
  mzl_ESPlV{
  }
}
#endif

#undef Doc_Table_Of_Content
#ifndef Blb_escB.c
				PS p= 95 ( 48);
#ifndef mzl_ESmain
				PS p=  1 (  1);
#endif
#ifndef mzl_1Dcore
				PS p=  1 (  1);
#endif
#ifndef mzl_2Dcore
				PS p=  1 (  1);
#endif
#ifndef mzl_BndLr
				PS p=  1 (  1);
#endif
#ifndef mzl_3Dcore
				PS p=  2 (  1);
#endif
#ifndef mzl_PL
				PS p=  2 (  1);
#endif
#ifndef mzl_ESPlV
				PS p=  2 (  1);
#endif
int NEEEEE();			PS p=  3 (  2);
int ESGetPlVd();		PS p=  3 (  2);
int ESInit1DPlV();		PS p=  3 (  2);
int ESReInit1DPlV();		PS p=  8 (  4);
int ESDeInit1DPlV();		PS p=  8 (  4);
int ESReInit2DAPrC();		PS p=  9 (  5);
int ESDeInit2DAPrC();		PS p=  9 (  5);
#ifndef mzl_3Dcore
				PS p=  9 (  5);
int ESRef2RealData();		PS p=  9 (  5);
int ESReal2RefData();		PS p= 10 (  5);
int ESReal2RefDataX();		PS p= 10 (  5);
int ESPncr2PlVData();		PS p= 16 (  8);
int ESInit2DTPlV();		PS p= 21 ( 11);
int ESReInit2DTPlV();		PS p= 22 ( 11);
int ESDeInit2DTPlV();		PS p= 22 ( 11);
#endif
#ifndef mzl_2Dcore
				PS p= 22 ( 11);
int ESReInit1DFPlV();		PS p= 22 ( 11);
int ESDeInit1DFPlV();		PS p= 23 ( 12);
#endif
#ifndef mzl_3Dcore
				PS p= 23 ( 12);
int ESReInit2DFTPlV();		PS p= 23 ( 12);
int ESDeInit2DFTPlV();		PS p= 24 ( 12);
#endif
#ifndef mzl_2Dcore
				PS p= 24 ( 12);
int ESInit2DFPPlV();		PS p= 24 ( 12);
int ESReInit2DFPPlV();		PS p= 24 ( 12);
int ESDeInit2DFPPlV();		PS p= 24 ( 12);
int ESReInitPlVeq();		PS p= 25 ( 13);
int ESDeInitPlVeq();		PS p= 25 ( 13);
#endif
#ifndef mzl_3Dcore
				PS p= 25 ( 13);
int ESRealGeom();		PS p= 25 ( 13);
int MakePlVContour();		PS p= 26 ( 13);
int ESRef2RealGeom();		PS p= 27 ( 14);
int ESReal2RefGeom();		PS p= 29 ( 15);
int ESEraseCoord();		PS p= 29 ( 15);
int ESInit3DCoord();		PS p= 30 ( 15);
#endif
#ifndef mzl_ESPlV
				PS p= 34 ( 17);
int ESPlVContour2gx();		PS p= 34 ( 17);
int ESPlVdata2PlV();		PS p= 38 ( 19);
int ESMakePlVdataA0();		PS p= 40 ( 20);
int ESPlVSamePlV();		PS p= 42 ( 21);
int Boundary2Points();		PS p= 42 ( 21);
int ESPlVPoints2PlV();		PS p= 43 ( 22);
int ESPlVdata2PlVX();		PS p= 47 ( 24);
int ESBoundaryLayerX();		PS p= 50 ( 25);
int ESGapCoreSepX();		PS p= 50 ( 25);
int ESCoreX();			PS p= 53 ( 27);
int ESPlVdata2PlVPolar();	PS p= 55 ( 28);
int ESComprPlVacData();		PS p= 56 ( 28);
int ESCheckIntData();		PS p= 57 ( 29);
int ESGetPlVDAddr();		PS p= 57 ( 29);
int ESSetPlVInt();		PS p= 57 ( 29);
int ESInit2DPlGeom();		PS p= 58 ( 29);
int ESUsePlVDataFile();		PS p= 59 ( 30);
int ESReadInt();		PS p= 59 ( 30);
int ESReadDbl();		PS p= 59 ( 30);
int ESWritePlVacAO();		PS p= 60 ( 30);
int ESReadPlVacAIOld();		PS p= 60 ( 30);
int ESReadPlVacAI();		PS p= 61 ( 31);
int ReSetVirtualBSize();	PS p= 61 ( 31);
int ReSetREScs1();		PS p= 63 ( 32);
int ReSetRcs2();		PS p= 64 ( 32);
int ESHoleEdgeBoundary1();	PS p= 67 ( 34);
int ESHoleEdgeBoundary();	PS p= 70 ( 35);
int ESHoleEdgeBoundary2();	PS p= 75 ( 38);
int ESD2vr();			PS p= 81 ( 41);
int ReSetHoleSize();		PS p= 83 ( 42);
int ESInputPlVac();		PS p= 85 ( 43);
int ESInput2DEqSolv();		PS p= 91 ( 46);
int ESInitPlGeom();		PS p= 94 ( 47);
int ESA2RefRZ();		PS p= 95 ( 48);
#endif
#endif
