#ifndef Blb_escK.c
#ifdef Doc_escK.c
\title{MHD Energy principle}
\author{L.~E.~Zakharov\\
\em Princeton University, Princeton Plasma Physics Laboratory}
%\date{October 18, 1999}
\maketitle
\begin{abstract}
Ideal energy principle is presented in both conventional form (in terms
of the plasma displacement) as well as in terms of perturbations of the
vector potential. The second form makes if suitable for resistive
stability calculations.
\end{abstract}

\section{Equilibrium magnetic fields and perturbations}
Normalization
\bqbl
&&
\bsp\equiv4\gp p
,\quad
\bgY\equiv\R{\gY}{2\gp}
,\quad
\bgF\equiv\R{\gF}{2\gp}
,\quad
\baF\equiv\R{2}{c}F
,\quad
\baJ\equiv\R{2}{c}J
,\quad
\bgn\equiv\R{2}{c}\gn
.\eqbl
Vector potential $\waA$ of the equilibrium field in equilibrium coordinates
$\gr,\gt,\gf$
\bqbl
&&
A_{\gr,\gt,\gf}=\left\{
\gh(\gr,\gt)
,\bgF(\gr)
,\bgY(\gr)
\right\}
.\eqbl
Equilibrium magnetic field and the current density
\bqbl
&&
B^{\gr,\gt,\gf}=\left\{
0
,-\R{\bgY'}{\q{g}}
,\R{\baF}{r^2}
\right\}
,\quad
B_{\gr,\gt,\gf}=\left\{
\bgn
,\baJ
,\baF
\right\}
+\na b
,\quad
\baF=\R{r^2}{\q{g}}(\bgF'-\gh'_\gt)
,\\&&
\R{4\gp}{c}j^{\gr,\gt,\gf}=\left\{
0,
-\R{\baF'}{\q{g}},
\R{\baJ'-\bgn'_\gt}{\q{g}}
\right\}
.\eqbl
Maxwell and equilibrium equations
\bqbl
&&
\baJ'-\bgn'_{\gt}=
-\left(\R{g_{\gt\gt}}{\q{g}}\bgY'\right)'_\gr
+\left(\R{g_{a\gt}}{\q{g}}\bgY'\right)'_\gt
,\quad
\q{g}\bsp'=
-\R{\q{g}}{r^2}\baF\baF'
+(\baJ'-\bgn'_{\gt})\bgY'
.\eqbl
Straight field line coordinates $a,\gq,\gz$
\bqbl
&&
a
=
\gr
,\quad
\gq
=
\gt
,\quad
\gz
=
\gf
-\gd
,\quad
\gd'_\gt
=
-q\bgh'_\gt
,\quad
\bgh
=
\R{\gh}{\bgF'}
=
\int^\gt_0\left(\R{L}{L_0}-1\right)d\gt
,\\&&
L
=
\R{\q{g}}{r^2}
=
\R{D}{r}
,\quad
q
\equiv
-\R{L_0\baF}{\bgY'}
,\quad
\gm
\equiv
\r{q}
.\eqbl
Metric tensor in coordinates $a,\gq,\gz$
\bqbl
&&
dl^2
=
g_{\gr\gr}d\gr^2
+2g_{\gr\gt}d\gr d\gt
+g_{\gt\gt}d\gt^2
+r^2d\gf^2
,\\&&
dl^2
=
g_{aa}da^2
+2g_{a\gq}dad\gq
+g_{\gq\gq}d\gq^2
+2g_{a\gz}dad\gz
+2g_{\gq\gz}d\gq d\gz
+r^2d\gz^2
,\\&&
d\gf
=
\gd'_ada
+\gd'_\gt d\gq
+d\gz
,\\&&
d\gf^2
=
\gd'^2_ada^2
+2\gd'_a\gd'_\gt dad\gq
+\gd'^2_\gt d\gq^2
+2\gd'_adad\gz
+2\gd'_\gt d\gq d\gz
+d\gz^2
,\\&&
g_{aa}
=
g_{\gr\gr}+r^2\gd'^2_\gr
,\quad
g_{a\gq}
=
g_{a\gt}+r^2\gd'_a\gd'_\gt
,\quad
g_{\gq\gq}
=
g_{\gt\gt}+r^2\gd'^2_\gt
,\\&&
g_{a\gz}
=
r^2\gd'_a
,\quad
g_{\gq\gz}
=
r^2\gd'_\gt
,\quad
g_{\gz\gz}
=
r^2
.\eqbl
Equilibrium magnetic field and the current density in coordinates $a,\gq,\gz$
\bqbl
&&
A_{a,\gq,\gz}
=
\left\{
0
,\bgF
,\bgY
\right\}
,\quad
B^{a,\gq,\gz}
=
\left\{
0
,-\R{\bgY'}{\q{g}}
,\R{L_0\baF}{\q{g}}
\right\}
=
\left\{
0
,-\R{\bgY'}{\q{g}}
,\R{\bgF'}{\q{g}}
\right\}
,\\&&
B_{a,\gq,\gz}=\left\{
\bgn+\gd'_a\baF+b'_a
,\baJ+\gd'_\gt\baF+b'_\gt
,\baF
\right\}
,\quad
\R{4\gp}{c}j^{a,\gq,\gz}=\left\{
0,
-\R{\baF'}{\q{g}},
\R{\baJ'-\bgn'_\gq+\gd'_\gt\baF'}{\q{g}}
\right\}
.\eqbl
Maxwell and equilibrium equations in coordinates $a,\gq,\gz$
\bqbl
&&
\baJ'-\bgn'_{\gq}=
-\left(\R{g_{\gt\gt}}{\q{g}}\bgY'\right)'_a
+\left(\R{g_{a\gt}}{\q{g}}\bgY'\right)'_\gq
,\quad
\q{g}\bsp'=
-\bgF'\baF'
+(\baJ'-\bgn'_{\gq}+\gd'_\gt\baF')\bgY'
.\eqbl
In the following, in order to distinguish between averaged and
oscillating parts of the periodic functions the indexes ${}_\cup$,
${}_\til$ ${}_0$ are used correspondingly for general function of the
angle variable, for oscillating function, and for function independent
of angle. The first index refers to dependence on $\gq$, while the
second on to  dependence on $\gz$. Thus, the general function
$f(a,\gq,\gz)$ can be represnted as
\bqbl
&&
f
\equiv
f_{\cup\cup}
\equiv
f_{\cup0}
+f_{\cup\til}
\equiv
f_{00}
+f_{\til0}
+f_{0\til}
+f_{\til\til}
\equiv
f_{0\cup}
+f_{\til\cup}
.\eqbl

\section{Functional of potental energy in the ideal MHD}
\bqbl
&&
W=\r{8\gp}\int\left\{
\t\waB^2
+(\vgx\cdot\na\bsp)(\na\cdot\vgx)
-\vgx\times(\na\times\waB)\cdot\t\waB
+\gg_0\bsp(\na\cdot\vgx)^2
\right\}dV
.\eqbl
The displacement vector
\bqbl
&&
\gx^{a,\gq,\gz}\equiv
\left\{\gx^a,\gx^\gq,\gx^\gz\right\}
,\quad
\t{\bf B}=\na\times\left(\vec{\gx}\times{\bf B}\right)
,\\&&
\left(\vec{\gx}\times{\bf B}\right)_{a,\gq,\gz}=
\q{g}\left\{
B^\gz\gx^\gq-B^\gq\gx^\gz
, -B^\gz\gx
,B^\gq\gx
\right\}=
\left\{
\gL
,-\bgF'\gx
,-\bgY'\gx
\right\}
,\quad
\gL\equiv\bgF'\gx^\gq+\bgY'\gx^\gz
\eqbl
and the perturbed magnetic field
\bqbl
&&
\taB^{a,\gq,\gz}=
\r{\q{g}}\left\{
\bgF'\gx'_\gz-\bgY'\gx'_\gq
,\gL'_\gz+(\bgY'\gx)'_a
,-\gL'_\gq-(\bgF'\gx)'_a
\right\}
.\eqbl
Contribution of $\t{\waB}^2$
\bqbl
\r{8\gp}\int\t{\waB}^2dV
&=&
\r{8\gp}\int\left\{
\R{g_{aa}}{\q{g}}(\bgF'\gx'_\gz-\bgY'\gx'_\gq)^2
+2\R{g_{a\gq}}{\q{g}}[\gL'_\gz+(\bgY'\gx)'_a](\bgF'\gx'_\gz-\bgY'\gx'_\gq)
+\R{g_{\gq\gq}}{\q{g}}[\gL'_\gz+(\bgY'\gx)'_a]^2
\right.\\&&\left.
+2\R{r^2\gd'_a}{\q{g}}(\bgF'\gx'_\gz-\bgY'\gx'_\gq)[-\gL'_\gq-(\bgF'\gx)'_a]
\right.\\&&\left.
+2\R{r^2\gd'_\gt}{\q{g}}[\gL'_\gz+(\bgY'\gx)'_a][-\gL'_\gq-(\bgF'\gx)'_a]
+\R{r^2}{\q{g}}[-\gL'_\gq-(\bgF'\gx)'_a]^2
\right\}da d\gq d\gz
.\eqbl
Variable $X=\q{g}(\na\cdot\vgx)$ associated with the compressibility of
$\vgx$  
\bqbl
&&
X
\equiv
(\q{g}\gx)'_a
+(\q{g}\gx^\gq)'_\gq
+(\q{g}\gx^\gz)'_\gz
,\quad
(\q{g}\gx)'_a
+\R{\bgY'(\q{g}\gx^\gq)'_\gq-\bgF'(\q{g}\gx^\gq)'_\gz}{\bgY'}
+\R{(\q{g}\gL)'_\gz}{\bgY'}
=
X
\eqbl
Contribution of $(\vgx\cdot\na\bsp)(\na\cdot\vgx)$
\bqbl
&&
(\vec{\gx}\cdot\na\bsp)(\na\cdot\vec{\gx})
=
\R{\bsp'}{\q{g}}\gx X
.\eqbl
Contribution of $\vgx\times(\na\times\waB)\cdot\t{\waB}$
\bqbl
&&
-\R{4\gp}{c}(\vgx\times\wsj)_{a,\gq,\gf}=
-\left\{
(\baJ'-\bgn'_{\gq}+\gd'_\gq\baF)\gx^\gq+\baF'\gx^\gz
,-(\baJ'-\bgn'_{\gq}+\gd'_\gq\baF')\gx
,-\baF'\gx
\right\}
,\\&&
-\R{4\gp}{c}(\vgx\times\wsj)_{a,\gq,\gf}=
\left\{
-\R{\bsp'\q{g}}{\bgY'}\gx^\gq-\R{\gL}{\bgY'}\baF'
,\R{\bsp'\q{g}}{\bgY'}\gx+\R{\bgF'\baF'}{\bgY'}\gx
,\baF'\gx
\right\}
.\eqbl
With new notations
\bqbl
&&
P
\equiv
\R{\bsp}{\bgY'}
,\quad
F_s
\equiv
\R{\baF'}{\bgY'}
,\quad
v
\equiv
\R{\q{g}}{\bgF'}
\eqbl
$\vgx\times(\na\times\waB)\cdot\t{\waB}$ becomes
\bqbl
&&
-\R{4\gp}{c}(\vgx\times\wsj)_{a,\gq,\gf}=
\left\{
-P\q{g}\gx^\gq-F_s\gL
,P\q{g}\gx+F_s\bgF'\gx
,F_s\bgY'\gx
\right\}
.\eqbl
Contribution after straightforward substitution in terms of
$\gx,\gx^\gq,\gx^\gz$ 
\bqbl
\r{8\gp}\int\left\{-\vgx\times(\na\times\waB)\cdot\t{\waB}\right\}dV
=
&&
\r{8\gp}\int\left\{
P[\bgF'(\q{g}\gx^\gq)'_\gz-\bgY'(\q{g}\gx^\gq)'_\gq]\gx
+P\q{g}\gx\gL'_\gz
+P\q{g}\gx(\bgY'\gx)'_a
\right.\\&&\left.
+2F_s\bgF'\gx\gL'_\gz
-2F_s\bgY'\gx\gL'_\gq
+F_s\bgF'\gx(\bgY'\gx)'_a
-F_s\bgY'\gx(\bgF'\gx)'_a
\right\}da d\gq d\gz
=
\\
&&
\r{8\gp}\int\left\{
-\bsp'X\gx
+P(\q{g}\gx)'_a\bgY'\gx
+2P\q{g}\gL'_\gz\gx
+P\q{g}\gx(\bgY'\gx)'_a
\right.\\&&\left.
+2F_s\bgF'\gx\gL'_\gz
-2F_s\bgY'\gx\gL'_\gq
+F_s\bgF'\gx\bgY''\gx
-F_s\bgY'\gx\bgF''\gx
\right\}da d\gq d\gz
=
\\
&&
\r{8\gp}\int\left\{
-\bsp'X\gx
+[P\q{g}\bgY'\gx^2]'_a
-P'\q{g}\bgY'\gx^2
+2P\q{g}\gL'_\gz\gx
\right.\\&&\left.
+2F_s\bgF'\gx\gL'_\gz
-2F_s\bgY'\gx\gL'_\gq
-F_s\gm'\bgF'^2\gx^2
\right\}da d\gq d\gz
.\eqbl
Contribution of $(\vgx\cdot\na\bsp)(\na\cdot\vgx)
-\vgx\times(\na\times\waB)\cdot\t{\waB}$ 
\bqbl
\r{8\gp}&&\int\left\{
  \vgx\cdot\na\bsp)(\na\cdot\vgx)
 -\vgx\times(\na\times\waB)\cdot\t{\waB}
 \right\}dV
=
\\&&
\r{8\gp}\int\left\{
[P\q{g}\bgY'\gx^2]'_a
-P'\q{g}\bgY'\gx^2
+2P\q{g}\gL'_\gz\gx
+2F_s\bgF'\gx\gL'_\gz
-2F_s\bgY'\gx\gL'_\gq
-F_s\gm'\bgF'^2\gx^2
\right\}da d\gq d\gz
.\eqbl
Functional of potental energy in terms of $\gx,\gL,X$
\bqbl
W
=
\r{8\gp}&&\int\left\{
\R{\gg_0\bsp}{\q{g}}X^2
+\R{g_{aa}}{\q{g}}(\bgF'\gx'_\gz-\bgY'\gx'_\gq)^2
+2\R{g_{a\gq}}{\q{g}}[\gL'_\gz+(\bgY'\gx)'_a](\bgF'\gx'_\gz-\bgY'\gx'_\gq)
+\R{g_{\gq\gq}}{\q{g}}[\gL'_\gz+(\bgY'\gx)'_a]^2
\right.\\&&\left.
+2\R{r^2\gd'_a}{\q{g}}(\bgF'\gx'_\gz-\bgY'\gx'_\gq)[-\gL'_\gq-(\bgF'\gx)'_a]
+2\R{r^2\gd'_\gt}{\q{g}}[\gL'_\gz+(\bgY'\gx)'_a][-\gL'_\gq-(\bgF'\gx)'_a]
\right.\\&&\left.
+\R{r^2}{\q{g}}[-\gL'_\gq-(\bgF'\gx)'_a]^2
+\left[Pv\bgF'\bgY'\gx^2\right]'_a
\right.\\&&\left.
-P'v\bgF'\bgY'\gx^2
+2Pv\bgF'\gx\gL'_\gz
+2F_s\bgF'\gx\gL'_\gz
-2F_s\bgY'\gx\gL'_\gq
-F_s\gm'\bgF'^2\gx^2
\right\}da d\gq d\gz
,\\&&
X
=
\q{g}(\na\cdot\vgx)
.\eqbl

\subsection{Matrix form of the potental energy in the ideal MHD}
Definitions of vectors in Fourier space
\bqbl
&&
X
=
\sum^M_{m=-M}X_me^{im\gq-in\gz}
+\sum^M_{m=-M}X^*_me^{-im\gq+in\gz}
,\quad
\vaX
\equiv
\{X_m\}
,\\&&
\gx
=
\sum^M_{m=-M}\gx_me^{im\gq-in\gz}
+\sum^M_{m=-M}\gx^*_me^{-im\gq+in\gz}
,\quad
\vgx
\equiv
\{\gx_m\}
,\\&&
\gL
=
\sum^M_{m=-M}\gL_me^{im\gq-in\gz}
+\sum^M_{m=-M}\gL^*_me^{-im\gq+in\gz}
,\quad
\vgL
\equiv
\{\gL_m\}
.\eqbl
With these definitions after interegration over $\gq,\gz$, the potential
energy reduces to 
\bqbl
W
=
\gp&&\int\left\{
\gg_0\bsp(\vaX\maG\vaX^*)
+\bgF'^2(\vgx\maQ\maG_{aa}\maQ\vgx^*)
\right.\\&&\left.
+[-in\vgL+(\bgY'\vgx)']\maG_{a\gq}(-i\maQ\bgF'\vgx^*)
+\bgF'i\vgx\maQ\maG_{a\gq}[in\vgL^*+(\bgY'\vgx^*)']
\right.\\&&\left.
+[-in\vgL+(\bgY'\vgx)']\maG_{\gq\gq}[in\vgL^*+(\bgY'\vgx^*)']
\right.\\&&\left.
+\bgF'i\vgx\maQ\maG_{a\gz}[i\maM\vgL^*-(\bgF'\vgx^*)']
+[-i\vgL\maM-(\bgF'\vgx)']\maG_{a\gz}(-i\maQ\bgF'\vgx^*)
\right.\\&&\left.
+[-in\vgL+(\bgY'\vgx)']\maG_{\gq\gz}[i\maM\vgL^*-(\bgF'\vgx^*)']
+[-i\vgL\maM-(\bgF'\vgx)']\maG_{\gq\gz}[in\vgL^*+(\bgY'\vgx^*)']
\right.\\&&\left.
+[-i\vgL\maM-(\bgF'\vgx)']\maG_{\gz\gz}[i\maM\vgL^*-(\bgF'\vgx^*)']
\right.\\&&\left.
+\left[P\bgF'\bgY'\vgx\msv\vgx^*\right]'
-P'\bgF'\bgY'(\vgx\msv\vgx^*)
+nP\bgF'(i\vgx\msv\vgL^*-i\vgL\msv\vgx^*)
\right.\\&&\left.
+nF_s\bgF'(i\vgx\vgL^*-i\vgL\vgx^*)
+F_s\bgY'(i\vgx\maM\vgL^*-i\vgL\maM\vgx^*)
-F_s\gm'\bgF'^2(\vgx\vgx^*)
\right\}da
,\eqbl
where the matrices are defined as
\bqbl
&&
\maI^{mm'}
\equiv
\gd^{mm'}
,\quad
\maM^{mm'}
\equiv
m\gd^{mm'}
,\quad
\maQ
\equiv
\gm\maM-n\maI
,\quad
\maG^{mm'}
\equiv
\left(\R{e^{i(m-m')\gq}}{\q{g}}\right)_0
,\\&&
 \maG^{mm'}_{aa}
\equiv
\left(\R{g_{aa}}{\q{g}}e^{i(m-m')\gq}\right)_0
,\quad
\maG^{mm'}_{a\gq}
\equiv
\left(\R{g_{a\gq}}{\q{g}}e^{i(m-m')\gq}\right)_0
,\quad
\maG^{mm'}_{\gq\gq}
\equiv
\left(\R{g_{\gq\gq}}{\q{g}}e^{i(m-m')\gq}\right)_0
,\\&&
\maG^{mm'}_{a\gz}
\equiv
\left(\R{r^2\gd'_a}{\q{g}}e^{i(m-m')\gq}\right)_0
,\quad
\maG^{mm'}_{\gq\gz}
\equiv
\left(\R{r^2\gd'_\gq}{\q{g}}e^{i(m-m')\gq}\right)_0
,\quad
\maG^{mm'}_{\gz\gz}
\equiv
\left(\R{r^2}{\q{g}}e^{i(m-m')\gq}\right)_0
,\\&&
\msv^{mm'}
\equiv
\left(ve^{i(m-m')\gq}\right)_0
.\eqbl
All of these matrices are Hermitian
\bqbl
&&
\maM
=\maM^\dagger
,\quad
\maQ
=\maQ^\dagger
,\quad
\maG
=
\maG^\dagger
,\quad
\maG_{aa}
=
\maG^\dagger_{aa}
,\quad
\ldots
,\quad
\msv
=\msv^\dagger
,\eqbl
where dagger denotes Hermitian conjugate.

\section{Functional of potental energy in terms of $\t{\waA}$}
\bqbl
&&
W=\r{8\gp}\int\left\{
\t\waB^2
+(\vgx\cdot\na\bsp)(\na\cdot\vgx)
-\vgx\times(\na\times\waB)\cdot\t\waB
+\gg_0\bsp(\na\cdot\vgx)^2
\right\}dV
.\eqbl
The perturbed vector potential $\t{\waA}$ and its reduction by adding a
scalar potential
\bqbl
&&
\taA_{a,\gq,\gz}=\left\{
0
,\taA_\gq
,\taA_\gz
\right\}
+\na u
,\quad
\taA_\gq
=
\taA_{\gq0\cup}
+\taA_{\gq\til\cup}
,\quad
+\taA_{\gq\til\cup}
+u'_\gq
=
0
,\quad
\taA_\gq
+u'_\gq
\equiv
\gj
,\quad
\gj
=
\gj_{0\cup}
,\\&&
\taA_{a,\gq,\gz}=\left\{
\taA_a
,\gj
,\taA_\gz
\right\}
+\na u^1
,\quad
\taA_\gz
=
\taA_{\gz00}
+\taA_{\gz0\til}
+\taA_{\gz\til\cup}
,\quad
\taA_\gz
+u'^1_{0,\til,\gz}
\equiv
\gy
-\gm\gj
,\quad
\gy
=
\gy_{00}
+\gy_{\til\cup}
.\eqbl
Here, $\gy$ refers to the parallel component of the vector potential
\bqbl
&&
(\t{\waA}\cdot\t{\waB})
=
\R{\bgF'}{\q{g}}
[\gm\gj+\gy-\gm\gj]
=
\R{\bgF'}{\q{g}}\gy
.\eqbl
Thus, a convenient form for $\t{\waA}$ is
\bqbl
&&
\taA_{a,\gq,\gz}=\left\{
\tgh-\int^\gz_0(\gm\gj)'_ad\gz
,\gj
,\gy-\gm\gj
\right\}
,\quad
\tgh
\equiv
\tgh_{\til\cup}
,\quad
\gj
\equiv
\gj_{0\cup}
,\quad
\gy
\equiv
\gy_{00}
+\gy_{\til\cup}
.\eqbl
The integral term in the radial component of $\t{\waA}$ is the function
of $a$ and $\gz$ only and was included to simplify the expression for
the magnetic field. In the case of the ideal 
MHD 
\bqbl
&&
A_\gq
=
[\bgF(A_\gz)]_{0\cup}
,\quad
\bgF+\gj_{00}
=
[\bgF(\bgY+\gy-\gm\gj)]_{0\cup}
=
\bgF
+[\bgF'(\gy-\gm\gj)]_{0\cup}
,\quad
\gj_{00}
=
-q(\gy_{00}-\gm\gj)
\eqbl
the zeroth harmonic, $\gy_{00}$, of $\gy$ is absent
\bqbl
&&
\gy
=
\gy_{\til\cup}
,\quad
\gy_{00}=0
\eqbl
and the vector potential is represented as
\bqbl
&&
\taA_{a,\gq,\gz}=\left\{
\tgh-\int^\gz_0(\gm\gj)'_ad\gz
,\gj
,\gy-\gm\gj
\right\}
,\quad
\tgh
\equiv
\tgh_{\til\cup}
,\quad
\gj
\equiv
\gj_{0\cup}
,\quad
\gy
\equiv
\gy_{\til\cup}
.\eqbl
The perturbed magnetic field
\bqbl
&&
\taB^{a,\gq,\gz}=
\r{\q{g}}\left\{
\gy'_\gq-\gj'_\gz
,\tgh'_\gz-\gy'_a
,\gj'_a-\tgh'_\gq
\right\}
.\eqbl
Relationships between $\tgh,\gj,\gy$ and $\gx,\gL$
\bqbl
&&
\bgF'\gx'_\gz-\bgY'\gx'_\gq
=
\gy'_\gq-\gj'_\gz
,\quad
\gL'_\gz+(\bgY'\gx)'_a
=
\tgh'_\gz-\gy'_a
,\quad
-\gL'_\gq-(\bgF'\gx)'_a
=
\gj'_a-\tgh'_\gq
.\eqbl
New independent variables, $u\equiv u_{\til\cup}$ instead of $\gx$ and
$\tgh$ instead of $\gL$ 
\bqbl
&&
\bgF'\gx=u'_\gq-\gj
,\quad
\gL=\tgh-u'_a-\int^\gz_0(\gm\gj)'_ad\gz
,\\&&
\bgF'\gx=u'_\gq-\gj
,\quad
-\bgY'\gx=\gm(u'_{\gq}-\gj)
,\quad
\gL'_\gz=\tgh'_\gz-u''_{a\gz}-(\gm\gj)'_a
,\quad
\gL'_\gq=\tgh'_\gq-u''_{a\gq}
,\\&&
\gy
\equiv
\gm u'_\gq
+u'_{\gz}
,\quad
\bgF'\gx'_\gz-\bgY'\gx'_\gq=
\gy'_\gq
-\gj'_\gz
.\eqbl
Substitution of new variables into functional of potental energy 
\bqbl
&&
-\gL'_\gq-(\bgF'\gx)'_a=\gj'_a-\tgh'_\gq
,\quad
\gL'_\gz+(\bgY'\gx)'_a=\tgh'_\gz-\gy'_a
,\quad
\bgF'\gx'_\gz-\bgY'\gx'_\gq
=
\gy'_\gq-\gj'_\gz
,\\
W
=
\r{8\gp}&&\int\left\{
\R{\gg_0\bsp}{\q{g}}X^2
+\R{g_{aa}}{\q{g}}(\bgF'\gx'_\gz-\bgY'\gx'_\gq)^2
+2\R{g_{a\gq}}{\q{g}}[\gL'_\gz+(\bgY'\gx)'_a](\bgF'\gx'_\gz-\bgY'\gx'_\gq)
+\R{g_{\gq\gq}}{\q{g}}[\gL'_\gz+(\bgY'\gx)'_a]^2
\right.\\&&\left.
+2\R{r^2\gd'_a}{\q{g}}(\bgF'\gx'_\gz-\bgY'\gx'_\gq)[-\gL'_\gq-(\bgF'\gx)'_a]
+2\R{r^2\gd'_\gt}{\q{g}}[\gL'_\gz+(\bgY'\gx)'_a][-\gL'_\gq-(\bgF'\gx)'_a]
\right.\\&&\left.
+\R{r^2}{\q{g}}[-\gL'_\gq-(\bgF'\gx)'_a]^2
+\left[Pv\bgF'\bgY'\gx^2\right]'_a
\right.\\&&\left.
-P'v\bgF'\bgY'\gx^2
+2Pv\bgF'\gx\gL'_\gz
+2F_s\bgF'\gx\gL'_\gz
-2F_s\bgY'\gx\gL'_\gq
-F_s\gm'\bgF'^2\gx^2
\right\}da d\gq d\gz
=
\\
\r{8\gp}&&\int\left\{
\R{\gg_0\bsp}{\q{g}}X^2
+\R{g_{aa}}{\q{g}}(\gy'_\gq-\gj'_\gz)^2
+2\R{g_{a\gq}}{\q{g}}(\tgh'_\gz-\gy'_a)(\gy'_\gq-\gj'_\gz)
+\R{g_{\gq\gq}}{\q{g}}(\tgh'_\gz-\gy'_a)^2
\right.\\&&\left.
+2\R{r^2\gd'_a}{\q{g}}(\gy'_\gq-\gj'_\gz)(\gj'_a-\tgh'_\gq)
+2\R{r^2\gd'_\gt}{\q{g}}(\tgh'_\gz-\gy'_a)(\gj'_a-\tgh'_\gq)
+\R{r^2}{\q{g}}(\gj'_a-\tgh'_\gq)^2
\right.\\&&\left.
+\left[Pv\bgF'\bgY'\gx^2\right]'_a
-P'v\bgF'\bgY'\gx^2
+2Pv\bgF'\gx[-(\bgY'\gx)'_a+\tgh'_\gz-\gy'_a]
\right.\\&&\left.
+2F_s\bgF'\gx[-(\bgY'\gx)'_a+\tgh'_\gz-\gy'_a]
-2F_s\bgY'\gx[-(\bgF'\gx)'_a-\gj'_a+\tgh'_\gq]
-F_s\gm'\bgF'^2\gx^2
\right\}da d\gq d\gz
.\eqbl
The last two lines can be represented as
\bqbl
W
=
\r{8\gp}&&\int\left\{
\ldots
\right.\\&&\left.
+\left[Pv\bgF'\bgY'\gx^2\right]'_a
-P'v\bgF'\bgY'\gx^2
+2Pv\bgF'\gx[-(\bgY'\gx)'_a+\tgh'_\gz-\gy'_a]
\right.\\&&\left.
+2F_s\bgF'\gx[-(\bgY'\gx)'_a+\tgh'_\gz-\gy'_a]
-2F_s\bgY'\gx[-(\bgF'\gx)'_a-\gj'_a+\tgh'_\gq]
-F_s\gm'\bgF'^2\gx^2
\right\}da d\gq d\gz
=
\\
\r{8\gp}&&\int\left\{
\ldots
+Pv'_a\bgF'\bgY'\gx^2
+Pv\gm'\bgF'^2\gx^2
+2Pv\bgF'\gx(\tgh'_\gz-\gy'_a)
\right.\\&&\left.
+F_s\gm'\bgF'^2\gx^2
-2F_s\bgY'\gx(\tgh'_\gq-\gj'_a)
+2F_s\bgF'\gx(\tgh'_\gz-\gy'_a)
\right\}da d\gq d\gz
=
\\
\r{8\gp}&&\int\left\{
\ldots
-Pv'_a\gm(u'_\gq-\gj)^2
+Pv\gm'(u'_\gq-\gj)^2
-2Pv(u'_\gq-\gj)\gy'_a
+2Pv(u'_\gq-\gj)\tgh'_\gz
\right.\\&&\left.
+F_s\gm'(u'_\gq-\gj)^2
+2F_s\gm(u'_{\gq}-\gj)(\tgh'_\gq-\gj'_a)
+2F_s(u'_\gq-\gj)(\tgh'_\gz-\gy'_a)
\right\}da d\gq d\gz
=
\\
\r{8\gp}&&\int\left\{
\ldots
\right.\\&&\left.
-P(v\gm u'^2_\gq)'_a
-2Pvu'_\gq(u'_\gz)'_a
\right.\\&&\left.
+2Pv(u'_\gq-\gj)\tgh'_\gz
+2Pv\gj u''_{a\gz}
+2P(vu'_\gq)'_a\gm\gj
-Pv'_a\gm\gj^2
+Pv\gm'\gj^2
\right.\\&&\left.
+[F_s\gm\gj^2]'_a
+F_s\gm'u'^2_\gq
+2F_s\gm u'_\gq\tgh'_\gq
+2F_su'_\gq(\tgh'_\gz-\gy'_a)
-2F_s\gj\tgh'_\gz
-F'_s\gm\gj^2
\right\}da d\gq d\gz
\eqbl
and finally as
\bqbl
W
=
\r{8\gp}&&\int\left\{
\ldots
\right.\\&&\left.
-P(v\gm u'^2_\gq)'_a
-2Pvu'_\gq(u'_\gz)'_a
\right.\\&&\left.
+2Pv(u'_\gq-\gj)\tgh'_\gz
+2Pv\gj u''_{a\gz}
+2P(vu'_\gq)'_a\gm\gj
-Pv'_a\gm\gj^2
+Pv\gm'\gj^2
\right.\\&&\left.
+[F_s\gm\gj^2]'_a
+F_s\gm'u'^2_\gq
+2F_s\gm u'_\gq\tgh'_\gq
+2F_su'_\gq(\tgh'_\gz-\gy'_a)
-2F_s\gj\tgh'_\gz
-F'_s\gm\gj^2
\right\}da d\gq d\gz
=
\\
\r{8\gp}&&\int\left\{
\ldots
-[Pvu'_\gq\gy]'_a
+P'vu'_\gq\gy
+P(v'_au'_\gq-v'_\gq u'_a)u'_\gz
\right.\\&&\left.
+2Pv(u'_\gq-\gj)\tgh'_\gz
+2Pv\gj u''_{a\gz}
+2P(vu'_\gq)'_a\gm\gj
-Pv'_a\gm\gj^2
+Pv\gm'\gj^2
\right.\\&&\left.
+[F_s\gm\gj^2]'_a
-F_s(u'_\gq\gy)'_a
+2F_s\gy\tgh'_\gq
-2F_s\gj\tgh'_\gz
-F'_s\gm\gj^2
\right\}da d\gq d\gz
=
\\
\r{8\gp}&&\int\left\{
\ldots
\right.\\&&\left.
+[-(Pv+F_s)u'_\gq\gy]'_a
+P'vu'_\gq\gy
+P(v'_au'_\gq-v'_\gq u'_a)u'_\gz
\right.\\&&\left.
+2Pv(u'_\gq-\gj)\tgh'_\gz
+2Pv\gj u''_{a\gz}
+2P(vu'_\gq)'_a\gm\gj
-Pv'_a\gm\gj^2
+Pv\gm'\gj^2
\right.\\&&\left.
+[F_s\gm\gj^2]'_a
+F'_su'_\gq\gy
+2F_s\gy\tgh'_\gq
-2F_s\gj\tgh'_\gz
-F'_s\gm\gj^2
\right\}da d\gq d\gz
.\eqbl
The final expression for the potential energy
\bqbl
W
=
\r{8\gp}&&\int\left\{
\R{\gg_0\bsp}{\q{g}}X^2
+\R{g_{aa}}{\q{g}}(\gy'_\gq-\gj'_\gz)^2
+2\R{g_{a\gq}}{\q{g}}(\tgh'_\gz-\gy'_a)(\gy'_\gq-\gj'_\gz)
+\R{g_{\gq\gq}}{\q{g}}(\tgh'_\gz-\gy'_a)^2
\right.\\&&\left.
+2\R{r^2\gd'_a}{\q{g}}(\gy'_\gq-\gj'_\gz)(\gj'_a-\tgh'_\gq)
+2\R{r^2\gd'_\gt}{\q{g}}(\tgh'_\gz-\gy'_a)(\gj'_a-\tgh'_\gq)
+\R{r^2}{\q{g}}(\gj'_a-\tgh'_\gq)^2
\right.\\&&\left.
+[F_s\gm\gj^2-(Pv+F_s)u'_\gq\gy]'_a
+(P'v+F'_s)u'_\gq\gy
+P(v'_au'_\gq-v'_\gq u'_a)u'_\gz
+2Pv(u'_\gq-\gj)\tgh'_\gz
\right.\\&&\left.
+2Pv\gj u''_{a\gz}
+2P(vu'_\gq)'_a\gm\gj
-Pv'_a\gm\gj^2
+Pv\gm'\gj^2
+2F_s\gy\tgh'_\gq
-2F_s\gj\tgh'_\gz
-F'_s\gm\gj^2
\right\}da d\gq d\gz
.\eqbl

\subsection{Matrix form of the potental energy in terms of $\t{\waA}$}
New independent vectors in Fourier space
\bqbl
&&
u
=
\sum^M_{m=-M}u_me^{im\gq-in\gz}
+\sum^M_{m=-M}u^*_me^{-im\gq+in\gz}
,\quad
\vsu
\equiv
\{u_m\}_{m\neq0}
,\quad
u_0
=0
,\quad
\vgy
\equiv
i\maQ\vsu
,\\&&
\vgh
=
\sum^M_{m=-M}\tgh_me^{im\gq-in\gz}
+\sum^M_{m=-M}\tgh^*_me^{-im\gq+in\gz}
,\quad
\vgh
\equiv
\{\tgh_m\}
,\\&&
\bgF'\vgx
=
i\maM\vsu
-\gj
,\quad
\bgY'\vgx
=
-i\gm\maM\vsu
+\gm\gj
,\quad
-in\vgL=-in\vgh+in\vsu'-(\gm\gj)'
,\quad
i\maM\vgL=i\maM\vgh-i\maM\vsu'
.\eqbl
After these substitutions 
\bqbl
&&
-in\vgL+(\bgY'\vgx)'
=
-in\vgh-\vgy'
,\quad
-i\vgL\maM-(\bgF'\vgx)'
=
-i\maM\vgh+\gj'
,\\
W
=
\gp&&\int\left\{
\gg_0\bsp(\vaX\maG\vaX^*)
+\bgF'^2(\vgx\maQ\maG_{aa}\maQ\vgx^*)
\right.\\&&\left.
+[-in\vgL+(\bgY'\vgx)']\maG_{a\gq}(-i\maQ\bgF'\vgx^*)
+\bgF'i\vgx\maQ\maG_{a\gq}[in\vgL^*+(\bgY'\vgx^*)']
\right.\\&&\left.
+[-in\vgL+(\bgY'\vgx)']\maG_{\gq\gq}[in\vgL^*+(\bgY'\vgx^*)']
\right.\\&&\left.
+\bgF'i\vgx\maQ\maG_{a\gz}[i\maM\vgL^*-(\bgF'\vgx^*)']
+[-i\vgL\maM-(\bgF'\vgx)']\maG_{a\gz}(-i\maQ\bgF'\vgx^*)
\right.\\&&\left.
+[-in\vgL+(\bgY'\vgx)']\maG_{\gq\gz}[i\maM\vgL^*-(\bgF'\vgx^*)']
+[-i\vgL\maM-(\bgF'\vgx)']\maG_{\gq\gz}[in\vgL^*+(\bgY'\vgx^*)']
\right.\\&&\left.
+[-i\vgL\maM-(\bgF'\vgx)']\maG_{\gz\gz}[i\maM\vgL^*-(\bgF'\vgx^*)']
\right.\\&&\left.
+\left[P\bgF'\bgY'\vgx\msv\vgx^*\right]'
-P'\bgF'\bgY'(\vgx\msv\vgx^*)
+nP\bgF'(i\vgx\msv\vgL^*-i\vgL\msv\vgx^*)
\right.\\&&\left.
+nF_s\bgF'(i\vgx\vgL^*-i\vgL\vgx^*)
+F_s\bgY'(i\vgx\maM\vgL^*-i\vgL\maM\vgx^*)
-F_s\gm'\bgF'^2(\vgx\vgx^*)
\right\}da
=
\\
\gp&&\int\left\{
\gg_0\bsp(\vaX\maG\vaX^*)
+(\vgy\maM+n\gj)\maG_{aa}(\maM\vgy^*+n\gj^*)
\right.\\&&\left.
+(\vgy'+in\vgh)i\maG_{a\gq}(\maM\vgy^*+n\gj^*)
-(\vgy\maM+n\gj)i\maG_{a\gq}(\vgy'^*-in\vgh^*)
\right.\\&&\left.
+(\vgy'+in\vgh)\maG_{\gq\gq}(\vgy'^*-in\vgh^*)
\right.\\&&\left.
+(\vgy\maM+n\gj)i\maG_{a\gz}(\gj'^*+i\maM\vgh^*)
-(\gj'-i\vgh\maM)i\maG_{a\gz}(\maM\vgy^*+n\gj^*)
\right.\\&&\left.
-(\vgy'+in\vgh)\maG_{\gq\gz}(\gj'^*+i\maM\vgh^*)
-(\gj'-i\vgh\maM)\maG_{\gq\gz}(\vgy'^*-in\vgh^*)
\right.\\&&\left.
+(\gj'-i\vgh\maM)\maG_{\gz\gz}(\gj'^*+i\maM\vgh^*)
\right.\\&&\left.
+\left[P\bgF'\bgY'\vgx\msv\vgx^*\right]'
-P'\bgF'\bgY'(\vgx\msv\vgx^*)
+nP\bgF'(i\vgx\msv\vgL^*-i\vgL\msv\vgx^*)
\right.\\&&\left.
+nF_s\bgF'(i\vgx\vgL^*-i\vgL\vgx^*)
+F_s\bgY'(i\vgx\maM\vgL^*-i\vgL\maM\vgx^*)
-F_s\gm'\bgF'^2(\vgx\vgx^*)
\right\}da
.\eqbl
With the same substitutions, the last line in the functional, which is
$\propto F_s$ can be written as 
\bqbl
\gp&&\int\left\{
\ldots\quad
+nF_s\bgF'(i\vgx\vgL^*-i\vgL\vgx^*)
+F_s\bgY'(i\vgx\maM\vgL^*-i\vgL\maM\vgx^*)
-F_s\gm'\bgF'^2(\vgx\vgx^*)
\right\}da
=
\\
\gp&&\int\left\{
\ldots\quad
-F_s\bgF'(\vgx(\bgY'\vgx^*)'+(\bgY'\vgx)'\vgx^*)
+inF_s\bgF'(\vgx\vgh^*-\vgh\vgx^*)
-F_s\bgF'(\vgx\vgy'^*+\vgy'\vgx^*)
\right.\\&&\left.
+F_s\bgY'(\vgx(\bgF'\vgx^*)'+(\bgF'\vgx)'\vgx^*)
+iF_s\bgY'(\vgx\maM\vgh^*-\vgh\maM\vgx^*)
+F_s\bgY'(\vgx\gj'^*+\gj'\vgx^*)
-F_s\gm'\bgF'^2(\vgx\vgx^*)
\right\}da
=
\\
\gp&&\int\left\{
\ldots\quad
+F_s[(\maM\maQ^{-1}\vgy-\gj)(\gm(\maM\maQ^{-1}\vgy^*-\gj^*))'
 +(\gm(\maM\maQ^{-1}\vgy-\gj))'(\maM\maQ^{-1}\vgy^*-\gj^*)]
\right.\\&&\left.
-F_s[(\maM\maQ^{-1}\vgy-\gj)(\vgy'^*-in\vgh^*)
 +(\vgy'+in\vgh)(\maM\maQ^{-1}\vgy^*-\gj^*)]
\right.\\&&\left.
-\gm F_s[(\maM\maQ^{-1}\vgy-\gj)(\maM\maQ^{-1}\vgy^*-\gj^*)]'
\right.\\&&\left.
-i\gm F_s[(\maM\maQ^{-1}\vgy-\gj)\maM\vgh^*
 -\vgh\maM(\maM\maQ^{-1}\vgy^*-\gj^*)]
\right.\\&&\left.
+\gm F_s(\gj\gj^*)'
-F_s\gm'(\maM\maQ^{-1}\vgy-\gj)(\maM\maQ^{-1}\vgy^*-\gj^*)
\right\}da
=
\\
\gp&&\int\left\{
\ldots\quad
-[F_s\vgy\maM\maQ^{-1}\vgy^*]'
+[F_s\gm\gj\gj^*]'
\right.\\&&\left.
+F'_s\vgy\maM\maQ^{-1}\vgy^*
+F_s[i\vgh(\maM\vgy^*+n\gj^*)-i(\vgy\maM+n\gj)\vgh^*]
-\gm F'_s\gj\gj^*
\right\}da
,\eqbl
while the term $\propto P$ can be written as
\bqbl
\gp&&\int\left\{
\ldots\quad
+\left[P\bgF'\bgY'\vgx\msv\vgx^*\right]'
-P'\bgF'\bgY'(\vgx\msv\vgx^*)
+nP\bgF'(i\vgx\msv\vgL^*-i\vgL\msv\vgx^*)
\right\}da
=
\\
\gp&&\int\left\{
\ldots\quad
+\left[P\bgF'\bgY'\vgx\msv\vgx^*\right]'
-P'\bgF'\bgY'(\vgx\msv\vgx^*)
-P\bgF'\vgx\msv(\bgY'\vgx^*)'
-P\bgF'(\bgY'\vgx)'\msv\vgx^*
\right.\\&&\left.
+inP\bgF'\vgx\msv\vgh^*
-inP\bgF'\vgh\msv\vgx^*
-P\bgF'\vgx\msv\vgy'^*
-P\bgF'\vgy'\msv\vgx^*
\right\}da
=
\\
\gp&&\int\left\{
\ldots\quad
+\left[P\bgF'\bgY'\vgx\msv\vgx^*\right]'
+\gm P'(\maM\maQ^{-1}\vgy-\gj)\msv(\maM\maQ^{-1}\vgy^*-\gj^*)
\right.\\&&\left.
+P(\maM\maQ^{-1}\vgy-\gj)\msv(\gm(\maM\maQ^{-1}\vgy^*-\gj^*))'
+P(\gm(\maM\maQ^{-1}\vgy-\gj))'\msv(\maM\maQ^{-1}\vgy^*-\gj^*)
\right.\\&&\left.
+inP(\maM\maQ^{-1}\vgy-\gj)\msv\vgh^*
-inP\vgh\msv(\maM\maQ^{-1}\vgy^*-\gj^*)
\right.\\&&\left.
-P(\maM\maQ^{-1}\vgy-\gj)\msv\vgy'^*
-P\vgy'\msv(\maM\maQ^{-1}\vgy^*-\gj^*)
\right\}da
=
\\
\gp&&\int\left\{
\ldots\quad
-[Pv_0\vgy\maM\maQ^{-1}\vgy^*]'
+[P\vgy\msv_\til\gj^*+P\gj\msv_\til\vgy^*]'_a
\right.\\&&\left.
+P'v_0\vgy\maM\maQ^{-1}\vgy^*
-nPv'_0\vgy\maM\maQ^{-2}\vgy^*
\right.\\&&\left.
-\gm P\maM\maQ^{-1}\vgy\msv'_{\til,a}\maM\maQ^{-1}\vgy^*
+\gm'P\maM\maQ^{-1}\vgy\msv_\til\maM\maQ^{-1}\vgy^*
-P[\vgy\maM\maQ^{-1}\msv_\til\vgy'^*+\vgy'\msv_\til\maM\maQ^{-1}\vgy^*]
\right.\\&&\left.
+nP[\vgy\maQ^{-1}\msv'_{\til,a}\gj^*+\gj\msv'_{\til,a}\maQ^{-1}\vgy^*]
-P'[\vgy\msv_\til\gj^*+\gj\msv_\til\vgy^*]
-P[\vgy\msv_\til\gj'^*+\gj'\msv_\til\vgy^*]
\right.\\&&\left.
-\gm'P[\maM\maQ^{-1}\vgy\msv_\til\gj^*+\gj\msv_\til\maM\maQ^{-1}\vgy^*]
+inP[(\maM\maQ^{-1}\vgy-\gj)\msv\vgh^*-\vgh\msv(\maM\maQ^{-1}\vgy^*-\gj^*)]
\right.\\&&\left.
+P\gj(\gm'\msv_0-\gm\msv'_0)\gj^*
\right\}da
.\eqbl
As a result, in the self-adjoint form, the potential energy is
represented by the functional
\bqbl
W
=
\gp&&\int\left\{
\gg_0\bsp(\vaX\maG\vaX^*)
+(\vgy\maM+n\gj)\maG_{aa}(\maM\vgy^*+n\gj^*)
\right.\\&&\left.
+(\vgy'+in\vgh)i\maG_{a\gq}(\maM\vgy^*+n\gj^*)
-(\vgy\maM+n\gj)i\maG_{a\gq}(\vgy'^*-in\vgh^*)
\right.\\&&\left.
+(\vgy'+in\vgh)\maG_{\gq\gq}(\vgy'^*-in\vgh^*)
\right.\\&&\left.
+(\vgy\maM+n\gj)i\maG_{a\gz}(\gj'^*+i\maM\vgh^*)
-(\gj'-i\vgh\maM)i\maG_{a\gz}(\maM\vgy^*+n\gj^*)
\right.\\&&\left.
-(\vgy'+in\vgh)\maG_{\gq\gz}(\gj'^*+i\maM\vgh^*)
-(\gj'-i\vgh\maM)\maG_{\gq\gz}(\vgy'^*-in\vgh^*)
+(\gj'-i\vgh\maM)\maG_{\gz\gz}(\gj'^*+i\maM\vgh^*)
\right.\\&&\left.
-[Pv_0\vgy\maM\maQ^{-1}\vgy^*]'
-[F_s\maM\maQ^{-1}\vgy\vgy^*]'
+[F_s\gm\gj\gj^*]'
+[P\vgy\msv_\til\gj^*+P\gj\msv_\til\vgy^*]'_a
\right.\\&&\left.
+(P'v_0+F'_s)\vgy\maM\maQ^{-1}\vgy^*
-nPv'_0\vgy\maM\maQ^{-2}\vgy^*
\right.\\&&\left.
+P\maM\maQ^{-1}\vgy(\gm\msv_\til)'_a\maM\maQ^{-1}\vgy^*
-P[\vgy\maM\maQ^{-1}\msv_\til\vgy'^*+\vgy'\msv_\til\maM\maQ^{-1}\vgy^*]
\right.\\&&\left.
+nP[\vgy\maQ^{-1}\msv'_{\til,a}\gj^*+\gj\msv'_{\til,a}\maQ^{-1}\vgy^*]
-P'[\vgy\msv_\til\gj^*+\gj\msv_\til\vgy^*]
-P[\vgy\msv_\til\gj'^*+\gj'\msv_\til\vgy^*]
\right.\\&&\left.
-\gm'P[\maM\maQ^{-1}\vgy\msv_\til\gj^*+\gj\msv_\til\maM\maQ^{-1}\vgy^*]
+inP[(\maM\maQ^{-1}\vgy-\gj)\msv\vgh^*-\vgh\msv(\maM\maQ^{-1}\vgy^*-\gj^*)]
\right.\\&&\left.
+P\gj(\gm'\msv_0-\gm\msv'_0)\gj^*
+F_s[i\vgh(\maM\vgy^*+n\gj^*)-i(\vgy\maM+n\gj)\vgh^*]
-\gm F'_s\gj\gj^*
\right\}da
.\eqbl
 
\section{Euler equations for $n\neq0$}
The functional of the potential energy
\bqbl
W
=
\r{8\gp}&&\int\left\{
\R{\gg_0\bsp}{\q{g}}X^2
+\R{g_{aa}}{\q{g}}(\gy'_\gq-\gj'_\gz)^2
+2\R{g_{a\gq}}{\q{g}}(\tgh'_\gz-\gy'_a)(\gy'_\gq-\gj'_\gz)
+\R{g_{\gq\gq}}{\q{g}}(\tgh'_\gz-\gy'_a)^2
\right.\\&&\left.
+2\R{r^2\gd'_a}{\q{g}}(\gy'_\gq-\gj'_\gz)(\gj'_a-\tgh'_\gq)
+2\R{r^2\gd'_\gt}{\q{g}}(\tgh'_\gz-\gy'_a)(\gj'_a-\tgh'_\gq)
+\R{r^2}{\q{g}}(\gj'_a-\tgh'_\gq)^2
\right.\\&&\left.
+[F_s\gm\gj^2-(Pv+F_s)u'_\gq\gy]'_a
+(P'v+F'_s)u'_\gq\gy
+P(v'_au'_\gq-v'_\gq u'_a)u'_\gz
+2Pv(u'_\gq-\gj)\tgh'_\gz
\right.\\&&\left.
+2Pv\gj u''_{a\gz}
+2P(vu'_\gq)'_a\gm\gj
-Pv'_a\gm\gj^2
+Pv\gm'\gj^2
+2F_s\gy\tgh'_\gq
-2F_s\gj\tgh'_\gz
-F'_s\gm\gj^2
\right\}da d\gq d\gz
\eqbl
leads to following equations for test functions. Equation for $X$
\bqbl
&&
X=0
.\eqbl
Equation for $\tgh$
\bqbl
&&
\left[
  \R{r^2}{\q{g}}\tgh'_\gq
 -\R{r^2\gd'_\gt}{\q{g}}\tgh'_\gz
 \right]'_\gq
+\left[
  \R{g_{\gq\gq}}{\q{g}}\tgh'_\gz
  -\R{r^2\gd'_\gt}{\q{g}}\tgh'_\gq
 \right]'_\gz
=
\\&&
+\left[
  \R{r^2}{\q{g}}\gj'_a
 +\R{r^2\gd'_a}{\q{g}}(\gy'_\gq-\gj'_\gz)
 -\R{r^2\gd'_\gt}{\q{g}}\gy'_a
 -F_s\gy
 \right]'_\gq
\\&&
+\left[
  \R{g_{\gq\gq}}{\q{g}}\gy'_a
 -\R{g_{a\gq}}{\q{g}}(\gy'_\gq-\gj'_\gz)
 -\R{r^2\gd'_\gt}{\q{g}}\gj'_a
 -Pv(u'_\gq-\gj)
 +F_s\gj
 \right]'_\gz
.\eqbl
Equation for $\gj$
\bqbl
&&
\left[
  \R{r^2}{\q{g}}(\gj'_a-\tgh'_\gq)
 +\R{r^2\gd'_\gt}{\q{g}}(\tgh'_\gz-\gy'_a)
 +\R{r^2\gd'_a}{\q{g}}(\gy'_\gq-\gj'_\gz)
 \right]'_a
\\&&
+\left[
  \R{g_{aa}}{\q{g}}(\gj'_\gz-\gy'_\gq)
 -\R{g_{a\gq}}{\q{g}}(\tgh'_\gz-\gy'_a)
 -\R{r^2\gd'_a}{\q{g}}(\gj'_a-\tgh'_\gq)
 \right]'_\gz
=
\\&&
+Pv(u''_{a\gz}-\tgh'_\gz)
+P(vu'_\gq)'_a\gm
-Pv'_a\gm\gj
-F_s\tgh'_\gz
-F'_s\gm\gj
.\eqbl
Equation for $u$
\bqbl
&&
\left(\gm\R{\pa}{\pa\gq}+\R{\pa}{\pa\gz}\right)\left[
  \R{g_{\gq\gq}}{\q{g}}(\gy'_a-\tgh'_\gz)
 -\R{g_{a\gq}}{\q{g}}(\gy'_\gq-\gj'_\gz)
 -\R{r^2\gd'_\gt}{\q{g}}(\gj'_a-\tgh'_\gq)
 \right]'_a
\\&&
+\left(\gm\R{\pa}{\pa\gq}+\R{\pa}{\pa\gz}\right)\left[
  \R{g_{aa}}{\q{g}}(\gy'_\gq-\gj'_\gz)
 +\R{g_{a\gq}}{\q{g}}(\tgh'_\gz-\gy'_a)
 +\R{r^2\gd'_a}{\q{g}}(\gj'_a-\tgh'_\gq)
 \right]'_\gq
=
\\&&
\left(\gm\R{\pa}{\pa\gq}+\R{\pa}{\pa\gz}\right)\left[
  (P'v+F'_s)u'_\gq
 +F_s\tgh'_\gq
 \right]
\\&&
-(Pv\gj'_\gz)'_a
+P(v\tgh'_\gz)'_\gq
-Pv'_\gq(\gm\gj)'_a
+P(v'_au''_{\gq\gz}-v'_\gq u''_{a\gz})
.\eqbl

\subsection{Euler equations for $n\neq0$ in Fourier space}
The Hermitian property of metric matrices in the $W$ allows to switch the
order of Fourier vectors in functional
\bqbl
&&
\vaY\maA\vaZ^*
=
Y_mA^{mm'}Z^*_{m'}
=
Y_mA^{*m'm}Z^*_{m'}
=
\vaZ^*\maA^*\vaY
\eqbl
and rewrite $W$ as
\bqbl
W
=
\gp&&\int\left\{
\gg_0\bsp(\vaX^*\maG^*\vaX)
+(\vgy^*\maM+n\gj^*)\maG^*_{aa}(\maM\vgy+n\gj)
\right.\\&&\left.
+(\vgy^*\maM+n\gj^*)i\maG^*_{a\gq}(\vgy'+in\vgh)
-(\vgy'^*-in\vgh^*)i\maG^*_{a\gq}(\maM\vgy+n\gj)
+(\vgy'^*-in\vgh^*)\maG^*_{\gq\gq}(\vgy'+in\vgh)
\right.\\&&\left.
-(\vgy^*\maM+n\gj^*)i\maG^*_{a\gz}(\gj'-i\maM\vgh)
+(\gj'^*+i\vgh^*\maM)i\maG^*_{a\gz}(\maM\vgy+n\gj)
\right.\\&&\left.
-(\vgy'^*-in\vgh^*)\maG^*_{\gq\gz}(\gj'-i\maM\vgh)
-(\gj'^*+i\vgh^*\maM)\maG^*_{\gq\gz}(\vgy'+in\vgh)
+(\gj'^*+i\vgh^*\maM)\maG^*_{\gz\gz}(\gj'-i\maM\vgh)
\right.\\&&\left.
-[Pv_0\vgy^*\maM\maQ^{-1}\vgy]'
-[F_s\maM\maQ^{-1}\vgy^*\vgy]'
+[F_s\gm\gj^*\gj]'
+[P\vgy^*\msv^*_\til\gj+P\gj^*\msv^*_\til\vgy]'_a
\right.\\&&\left.
+(P'v_0+F'_s)\vgy^*\maM\maQ^{-1}\vgy
-nPv'_0\vgy^*\maM\maQ^{-2}\vgy
\right.\\&&\left.
+P\maM\maQ^{-1}\vgy^*(\gm\msv^*_\til)'_a\maM\maQ^{-1}\vgy
-P[\vgy^*\maM\maQ^{-1}\msv^*_\til\vgy'+\vgy'^*\msv^*_\til\maM\maQ^{-1}\vgy]
\right.\\&&\left.
+nP[\vgy^*\maQ^{-1}\msv'^*_{\til,a}\gj+\gj^*\msv'^*_{\til,a}\maQ^{-1}\vgy]
-P'[\vgy^*\msv^*_\til\gj+\gj^*\msv^*_\til\vgy]
-P[\vgy^*\msv^*_\til\gj'+\gj'^*\msv^*_\til\vgy]
\right.\\&&\left.
-\gm'P[\vgy^*\maM\maQ^{-1}\msv^*_\til\gj+\gj^*\msv^*_\til\maM\maQ^{-1}\vgy]
-inP[(\maM\maQ^{-1}\vgy^*-\gj^*)\msv^*\vgh-\vgh^*\msv^*(\maM\maQ^{-1}\vgy-\gj)]
\right.\\&&\left.
+P\gj^*(\gm'v_0-\gm v'_0)\gj
+iF_s[(\vgy^*\maM+n\gj^*)\vgh-\vgh^*(\maM\vgy+n\gj)]
-\gm F'_s\gj^*\gj
\right\}da
.\eqbl
In the following, we consider $\gj$ as the zeroth component of $\vgy$ 
\bqbl
&&
\vgy_0
\equiv
\gj
.\eqbl
Then, with three independent vectors $\vgX$, $\vgh$ and $\vgy$, the
functional of potential energy can be written in a symbolic form
\bqbl
W
=
\gp&&\int\left\{
\gg_0\bsp(\vaX^*\maG^*\vaX)
\right.\\&&\left.
+(-i\vgh^*)\maA i\vgh
+(-i\vgh^*)\maB\vgy'
+\vgy'^*\maB^\dagger i\vgh
+(-i\vgh^*)\maC\vgy
+\vgy^*\maC^\dagger i\vgh
\right.\\&&\left.
+\vgy'^*\maD\vgy'
+\vgy'^*\maE\vgy
+\vgy^*\maE^\dagger\vgy'
+\vgy^*\maH\vgy
\right\}da
,\eqbl
where matrices are defined as
\bqbl
&&
\maA
\equiv
\maM\maG^*_{\gz\gz}\maM
+n^2\maG^*_{\gq\gq}
+n\maG^*_{\gq\gz}\maM
+n\maM\maG^*_{\gq\gz}
,\\&&
\maB
\equiv
n\maG^{*\cup\til}_{\gq\gq}
+\maM\maG^{*\cup\til}_{\gq\gz}
-\maM\maG^{*\cup0}_{\gz\gz}
-n\maG^{*\cup0}_{\gq\gz}
,\\&&
\maC
\equiv
n(F_s-in\maG^*_{a\gq}-i\maM\maG^*_{a\gz}-nP\msv^*\maQ^{-1})^{\cup0}
+(F_s-in\maG^*_{a\gq}-i\maM\maG^*_{a\gz}-nP\msv^*\maQ^{-1})^{\cup\til}\maM
,\\&&
\maD
\equiv
\maG^{*00}_{\gz\gz}
-\maG^{*\til0}_{\gq\gz}
-\maG^{*0\til}_{\gq\gz}
+\maG^{*\til\til}_{\gq\gq}
,\\&&
\maE
\equiv
(in\maG^{*00}_{a\gz}-in\maG^{*\til0}_{a\gq})
+(i\maG^{*0\til}_{a\gz}-i\maG^{*\til\til}_{a\gq})\maM
-P\msv^{*0\til}_\til
-P\msv^{*\til\til}_\til\maM\maQ^{-1}
,\\&&
\maH
\equiv
n^2\maG^{*00}_{aa}
+n\maG^{*0\til}_{aa}\maM
+n\maM\maG^{*\til0}_{aa}
+\maM\maG^{*\til\til}_{aa}\maM
+(P'v_0+F'_s)\maM\maQ^{-1}
-nPv'_0\maM\maQ^{-2}
\\&&
+P\maQ^{-1}\maM(\gm\msv^*_\til)'_a\maM\maQ^{-1}
+nP(\maQ^{-1}\msv'^{*\til0}_{\til,a}+\msv'^{*0\til}_{\til,a}\maQ^{-1})
-P'(\msv^{*\til0}_\til+\msv^{*0\til}_\til)
\\&&
-\gm'P(\maM\maQ^{-1}\msv^{*\til0}_\til+\msv^{*0\til}_\til\maM\maQ^{-1})
+[P(\gm'v_0-\gm v'_0)-\gm F'_s]^{00}
.\eqbl
Its varying with respect to $\vaX^*$, $\vgh^*$, $\vgy^*$ gives Euler
equations, which for $\vaX$ is
\bqbl
&&
\maG^*\vaX
=
0
,\eqbl
for $\vgh$ is
\bqbl
&&
\maA i\vgh
=
-\maB\vgy'
-\maC\vgy
,\eqbl
and the equation for $\vgy$
\bqbl
&&
[\maD\vgy'+\maB^\dagger i\vgh+\maE\vgy]'
=
\maC^\dagger i\vgh
+\maE^\dagger\vgy'
+\maH\vgy
.\eqbl
Elimination of $\vgh$ leads to
\bqbl
&&
i\vgh
=
-\maA^{-1}\maB\vgy'
-\maA^{-1}\maC\vgy
,\eqbl
leads to a final equation for $\vgy$
\bqbl
&&
(\maF\vgy'+\maK\vgy)'
=
\maK^\dagger\vgy'
+\maG\vgy
,\eqbl
where
\bqbl
&&
\maF
\equiv
\maD-\maB^\dagger\maA^{-1}\maB
,\\&&
\maK
\equiv
\maE
-\maB^\dagger\maA^{-1}\maC
,\\&&
\maG
\equiv
\maH
-\maM\maC^\dagger\maA^{-1}\maC\maM
.\eqbl
In the form of two systems of the first order equations they can be
written as 
\bqbl
&&
\vgy'
=
\maF^{-1}(\vaY-\maK\vgy)
,\quad
\vaY'
=
\maK^\dagger\vgy'
+\maG\vgy
.\eqbl

%=========================================================
In axisymmetric straight field line coordinates
\bqbl
&&
\gd
=0
,\quad
v
=
\R{r^2}{\baF}
,\eqbl
and
\bqbl
W
=
\gp&&\int\left\{
\gg_0\bsp(\vaX\msg\vaX^*)
+(\vgy\maM+n\gj)\msg_{aa}(\maM\vgy^*+n\gj^*)
\right.\\&&\left.
+(\vgy'+in\vgh)i\msg_{a\gt}(\maM\vgy^*+n\gj^*)
-(\vgy\maM+n\gj)i\msg_{a\gt}(\vgy'^*-in\vgh^*)
\right.\\&&\left.
+(\vgy'+in\vgh)\msg_{\gt\gt}(\vgy'^*-in\vgh^*)
+(\gj'-i\vgh\maM)\msg_{\gf\gf}(\gj'^*+i\maM\vgh^*)
\right.\\&&\left.
-[Pv_0\vgy\maM\maQ^{-1}\vgy^*]'
-[F_s\maM\maQ^{-1}\vgy\vgy^*]'
+[F_s\gm\gj\gj^*]'
+[P\vgy\msv_\til\gj^*+P\gj\msv_\til\vgy^*]'_a
\right.\\&&\left.
+(P'v_0+F'_s)\vgy\maM\maQ^{-1}\vgy^*
-nPv'_0\vgy\maM\maQ^{-2}\vgy^*
\right.\\&&\left.
+P\maM\maQ^{-1}\vgy(\gm\msv_\til)'_a\maM\maQ^{-1}\vgy^*
-P[\vgy\maM\maQ^{-1}\msv_\til\vgy'^*+\vgy'\msv_\til\maM\maQ^{-1}\vgy^*]
\right.\\&&\left.
+nP[\vgy\maQ^{-1}\msv'_{\til,a}\gj^*+\gj\msv'_{\til,a}\maQ^{-1}\vgy^*]
-P'[\vgy\msv_\til\gj^*+\gj\msv_\til\vgy^*]
-P[\vgy\msv_\til\gj'^*+\gj'\msv_\til\vgy^*]
\right.\\&&\left.
-\gm'P[\maM\maQ^{-1}\vgy\msv_\til\gj^*+\gj\msv_\til\maM\maQ^{-1}\vgy^*]
+inP[(\maM\maQ^{-1}\vgy-\gj)\msv\vgh^*-\vgh\msv(\maM\maQ^{-1}\vgy^*-\gj^*)]
\right.\\&&\left.
+P\gj(\gm'\msv_0-\gm\msv'_0)\gj^*
+F_s[i\vgh(\maM\vgy^*+n\gj^*)-i(\vgy\maM+n\gj)\vgh^*]
-\gm F'_s\gj\gj^*
\right\}da
.\eqbl
\bqbl
W
=
\gp&&\int\left\{
\gg_0\bsp(\vaX^*\maG^*\vaX)
+(\vgy^*\maM+n\gj^*)\msg^*_{aa}(\maM\vgy+n\gj)
\right.\\&&\left.
+(\vgy^*\maM+n\gj^*)i\msg^*_{a\gq}(\vgy'+in\vgh)
-(\vgy'^*-in\vgh^*)i\msg^*_{a\gq}(\maM\vgy+n\gj)
+(\vgy'^*-in\vgh^*)\msg^*_{\gq\gq}(\vgy'+in\vgh)
\right.\\&&\left.
\right.\\&&\left.
+[\gj'^*+i\vgh^*\maM-\gd'_\gq(\vgy'^*-in\vgh^*)-i\gd'_a(\vgy^*\maM+n\gj^*)]
 \maG^*_{\gz\gz}[\gj'-i\maM\vgh-\gd'_\gq(\vgy'+in\vgh)+i\gd'_a(\maM\vgy+n\gj)]
\right.\\&&\left.
\right.\\&&\left.
-[Pv_0\vgy^*\maM\maQ^{-1}\vgy]'
-[F_s\maM\maQ^{-1}\vgy^*\vgy]'
+[F_s\gm\gj^*\gj]'
+[P\vgy^*\msv^*_\til\gj+P\gj^*\msv^*_\til\vgy]'_a
\right.\\&&\left.
+(P'v_0+F'_s)\vgy^*\maM\maQ^{-1}\vgy
-nPv'_0\vgy^*\maM\maQ^{-2}\vgy
\right.\\&&\left.
+P\maM\maQ^{-1}\vgy^*(\gm\msv^*_\til)'_a\maM\maQ^{-1}\vgy
-P[\vgy^*\maM\maQ^{-1}\msv^*_\til\vgy'+\vgy'^*\msv^*_\til\maM\maQ^{-1}\vgy]
\right.\\&&\left.
+nP[\vgy^*\maQ^{-1}\msv'^*_{\til,a}\gj+\gj^*\msv'^*_{\til,a}\maQ^{-1}\vgy]
-P'[\vgy^*\msv^*_\til\gj+\gj^*\msv^*_\til\vgy]
-P[\vgy^*\msv^*_\til\gj'+\gj'^*\msv^*_\til\vgy]
\right.\\&&\left.
-\gm'P[\vgy^*\maM\maQ^{-1}\msv^*_\til\gj+\gj^*\msv^*_\til\maM\maQ^{-1}\vgy]
-inP[(\maM\maQ^{-1}\vgy^*-\gj^*)\msv^*\vgh-\vgh^*\msv^*(\maM\maQ^{-1}\vgy-\gj)]
\right.\\&&\left.
+P\gj^*(\gm'v_0-\gm v'_0)\gj
+iF_s[(\vgy^*\maM+n\gj^*)\vgh-\vgh^*(\maM\vgy+n\gj)]
-\gm F'_s\gj^*\gj
\right\}da
.\eqbl

%=========================================================
Functional of potential energy
\bqbl
W&=&
{1\over8\gp}\int\left\{
\R{g_{aa}}{\q{g}}\left({\pa\gy\over\pa\gq}-{\pa \gj\over\pa\gz}\right)^2
-2\R{g_{a\gq}}{\q{g}}\left({\pa\gy\over\pa a}-{\pa\tgh\over\pa\gz}\right)
\left({\pa\gy\over\pa\gq}-{\pa \gj\over\pa\gz}\right)
+\R{g_{\gq\gq}}{\q{g}}\left({\pa\gy\over\pa a}-{\pa\tgh\over\pa\gz}\right)^2
\right.\\&&\left.
+\R{r^2}{\q{g}}\left({\pa \gj\over\pa a}-{\pa\tgh\over\pa\gq}\right)^2
+\left(P_s'v+F_s'\right)\left({\pa u\over\pa\gq}-\gj\right)\gy
+P_s{\pa u\over\pa\gz}\left[{\pa u\over\pa\gq}v'_a
-{\pa u\over\pa a}v'_\gq\right]
\right.\\&&\left.
-P_s\left[{\pa u\over\pa a}{\pa(v\gj)\over\pa\gz}
+{\pa u\over\pa\gz}{\pa(v\gj)\over\pa a}\right]
+2P_sv{\pa\tgh\over\pa\gz}\left({\pa u\over\pa\gq}-\gj\right)
-2F_s\gy{\pa \gj\over\pa a}
+F_s'u{\pa \gj\over\pa\gz}
\right.\\&&\left.
-2F_s\tgh\left({\pa\gy\over\pa\gq}-{\pa \gj\over\pa\gz}\right)
\right\}da d\gq d\gz
,\quad
P_s\equiv{\bsp'\over\bgY'}
,\quad
F_s\equiv{\baF'\over\bgY'}
,\quad
v\equiv{r^2\over\baF}
.\eqbl
Euler equations
\bqbl
-\left({\pa\over\pa\gq}{\mu\over1+\gh'_\gq}+{\pa\over\pa\gz}\right)
\left[
{\pa\over\pa a}{\gd L\over\gd\gy'_a}
+{\pa\over\pa\gq}{\gd L\over\gd\gy'_\gq}
-{\gd L\over\gd\gy}
\right]
=
{\gd L\over\gd u}
-{\pa\over\pa a}{\gd L\over\gd u'_a}
-{\pa\over\pa\gq}{\gd L\over\gd u'_\gq}
-{\pa\over\pa\gz}{\gd L\over\gd u'_\gz}
,&&\\
{\pa\over\pa a}{\gd L\over\gd\gy'_a}
+{\pa\over\pa\gq}{\gd L\over\gd\gy'_\gq}
=
{\gd L\over\gd\gy}
+{\gd u\over\gd\gy}\left[
{\gd L\over\gd u}
-{\pa\over\pa a}{\gd L\over\gd u'_a}
-{\pa\over\pa\gq}{\gd L\over\gd u'_\gq}
-{\pa\over\pa\gz}{\gd L\over\gd u'_\gz}
\right]
,&&\\
{\pa\over\pa a}{\gd L\over\gd\tgh_{0a}'}
+{\pa\over\pa\gz}{\gd L\over\gd\tgh_{0\gz}'}
=
{\gd L\over\gd\gj}
+{\gd u\over\gd\gj}\left[
{\gd L\over\gd u}
-{\pa\over\pa a}{\gd L\over\gd u'_a}
-{\pa\over\pa\gq}{\gd L\over\gd u'_\gq}
-{\pa\over\pa\gz}{\gd L\over\gd u'_\gz}
\right]
.\eqbl

\section{Euler equations}
Equation for $\gy$
\bqbl
&&
{\pa\over\pa a}\R{g_{\gq\gq}}{\q{g}}\left({\pa\gy\over\pa a}-{\pa\tgh\over\pa\gz}\right)
-{\pa\over\pa a}\R{g_{a\gq}}{\q{g}}\left({\pa\gy\over\pa\gq}-{\pa \gj\over\pa\gz}\right)
-{\pa\over\pa\gq}\R{g_{a\gq}}{\q{g}}\left({\pa\gy\over\pa a}-{\pa\tgh\over\pa\gz}\right)
+{\pa\over\pa\gq}\R{g_{aa}}{\q{g}}\left({\pa\gy\over\pa\gq}-{\pa \gj\over\pa\gz}\right)
=
\\&&
{P_s'v+F_s'\over2}\left({\pa u\over\pa\gq}-\gj\right)
-F_s\left({\pa \gj\over\pa a}-{\pa\tgh\over\pa\gq}\right)
-{\gd u\over\gd\gy}{P_s'v+F_s'\over2}
\left({\pa\gy\over\pa\gq}-{\pa \gj\over\pa\gz}\right)
\\&&
+{\gd u\over\gd\gy}\left[
P_sv'_\gq{\pa\over\pa\gz}\left({\pa u\over\pa a}-\tgh\right)
-{P_s'\over2}v'_\gq\left(\gy-{\pa u\over\pa\gz}\right)
+P_sv{\pa\over\pa\gz}\left({\pa\gj\over\pa a}-{\pa\tgh\over\pa\gq}\right)
-P_sv'_a{\pa\over\pa\gz}\left({\pa u\over\pa\gq}-\gj\right)
\right]
.\eqbl
Equation for $\tgh$
\bqbl
&&
{\pa\over\pa\gq}\R{r^2}{\q{g}}\left({\pa \tgh\over\pa\gq}-{\pa\gj\over\pa a}\right)
+\R{g_{\gq\gq}}{\q{g}}{\pa\over\pa\gz}\left({\pa\tgh\over\pa\gz}-{\pa\gy\over\pa a}\right)
+\R{g_{a\gq}}{\q{g}}{\pa\over\pa\gz}\left({\pa\gy\over\pa\gq}-{\pa \gj\over\pa\gz}\right)
=
\\&&
-P_sv{\pa\over\pa\gz}\left({\pa u\over\pa\gq}-\gj\right)
-F_s\left({\pa\gy\over\pa\gq}-{\pa \gj\over\pa\gz}\right)
.\eqbl
Equation for $\gj$
\bqbl
&&
{\pa\over\pa a}\R{r^2}{\q{g}}\left({\pa \gj\over\pa a}-{\pa\tgh\over\pa\gq}\right)
-\R{g_{aa}}{\q{g}}{\pa\over\pa\gz}\left({\pa\gy\over\pa\gq}-{\pa \gj\over\pa\gz}\right)
+\R{g_{a\gq}}{\q{g}}{\pa\over\pa\gz}\left({\pa\gy\over\pa a}-{\pa\tgh\over\pa\gz}\right)
=
\\&&
{F_s'-P_s'v\over2}\left(\gy-{\pa u\over\pa\gz}\right)
+F_s\left({\pa\gy\over\pa a}-{\pa\tgh\over\pa\gz}\right)
+P_sv{\pa\over\pa\gz}\left({\pa u\over\pa a}-\tgh\right)
-{\gd u\over\gd\gj}{P_s'v+F_s'\over2}
\left({\pa\gy\over\pa\gq}-{\pa \gj\over\pa\gz}\right)
\\&&
+{\gd u\over\gd\gj}\left[
P_sv'_\gq{\pa\over\pa\gz}\left({\pa u\over\pa a}-\tgh\right)
-{P_s'\over2}v'_\gq\left(\gy-{\pa u\over\pa\gz}\right)
+P_sv{\pa\over\pa\gz}\left({\pa\gj\over\pa a}-{\pa\tgh\over\pa\gq}\right)
-P_sv'_a{\pa\over\pa\gz}\left({\pa u\over\pa\gq}-\gj\right)
\right]
.\eqbl
In matrix form
\bqbl
&&
\wsu\equiv1+\gh'_\gq
,\quad
T_{mm'}={\gd_{mm'}\over m\mu-n}
,\quad
\vsu=iu=\waT\wsu\vgy+\mu\waT\vgl_0
,\quad
\vgl=i\tgh
,\quad
i\waD_\gq={\pa\over\pa\gq}
,\quad
\waD_a={\pa\over\pa a}
.\eqbl
Equation for $\vgy$
\bqbl
&&
\waD_a a\wsg_{\gq\gq}\left(\waD_a\vgy+n\vgl\right)
-i\waD_a\wsg_{a\gq}\left(\waD_\gq\vgy+n\vgl_0\right)
-i\waD_\gq\wsg_{a\gq}\left(\waD_a\vgy+n\vgl\right)
-\waD_\gq\R{\wsg_{aa}}{a}\left(\waD_\gq\vgy+n\vgl_0\right)
=
\\&&
{P_s'\wsv+F_s'\over2}\left(\waD_\gq\vsu-\vgl_0\right)
-F_s\left(\waD_a\vgl_0-\waD_\gq\vgl\right)
+\wsu\waT{P_s'\wsv+F_s'\over2}\left(\waD_\gq\vgy+n\vgl_0\right)
\\&&
+\wsu\waT\left[
inP_s\wsv'_\gq\left(-\waD_a\vsu+\vgl\right)
-i{P_s'\over2}\wsv'_\gq\left(\vgy+n\vsu\right)
+nP_s\wsv\left(\waD_a\vgl_0-\waD_\gq\vgl\right)
-nP_s\wsv'_a\left(\waD_\gq\vsu-\vgl_0\right)
\right]
.\eqbl
Equation for $\vgl$
\bqbl
&&
\waD_\gq\R{\wsg_{33}}{a}\left(\waD_\gq\vgl-\waD_a\vgl_0\right)
+na\wsg_{\gq\gq}\left(n\vgl+\waD_a\vgy\right)
-in\wsg_{a\gq}\left(\waD_\gq\vgy+n\vgl_0\right)
=
\\&&
nP_s\wsv\left(\waD_\gq\vsu-\vgl_0\right)
-F_s\left(\waD_\gq\vgy+n\vgl_0\right)
.\eqbl
Equation for $\vgl_0$
\bqbl
&&
\waD_a\R{\wsg_{33}}{a}\left(\waD_a\vgl_0-\waD_\gq\vgl\right)
-n\R{\wsg_{aa}}{a}\left(\waD_\gq\vgy+n\vgl_0\right)
-in\wsg_{a\gq}\left(\waD_a\vgy+n\vgl\right)
=
\\&&
{F_s'-P_s'\wsv\over2}\left(\vgy+n\vsu\right)
+F_s\left(\waD_a\vgy+n\vgl\right)
-nP_s\wsv\left(\waD_a\vsu-\vgl\right)
+\mu\waT{P_s'\wsv+F_s'\over2}\left(\waD_\gq\vgy+n\vgl_0\right)
\\&&
+\mu\waT\left[
inP_s\wsv'_\gq\left(-\waD_a\vsu+\vgl\right)
-i{P_s'\over2}\wsv'_\gq\left(\vgy+n\vsu\right)
+nP_s\wsv\left(\waD_a\vgl_0-\waD_\gq\vgl\right)
-nP_s\wsv'_a\left(\waD_\gq\vsu-\vgl_0\right)
\right]
.\eqbl

\section{Mutual dependence of Euler equations}
Equation for $\vgy$ multiplied by $n$
\bqbl
&&
n\waD_a a\wsg_{\gq\gq}\left(\waD_a\vgy+n\vgl\right)
-in\waD_a\wsg_{a\gq}\left(\waD_\gq\vgy+n\vgl_0\right)
-in\waD_\gq\wsg_{a\gq}\left(\waD_a\vgy+n\vgl\right)
-n\waD_\gq\R{\wsg_{aa}}{a}\left(\waD_\gq\vgy+n\vgl_0\right)
=
\\&&
n{P_s'\wsv+F_s'\over2}\left(\waD_\gq\vsu-\vgl_0\right)
-nF_s\left(\waD_a\vgl_0-\waD_\gq\vgl\right)
+n\wsu\waT{P_s'\wsv+F_s'\over2}\left(\waD_\gq\vgy+n\vgl_0\right)
\\&&
+n\wsu\waT\left[
inP_s\wsv'_\gq\left(-\waD_a\vsu+\vgl\right)
-i{P_s'\over2}\wsv'_\gq\left(\vgy+n\vsu\right)
+nP_s\wsv\left(\waD_a\vgl_0-\waD_\gq\vgl\right)
-nP_s\wsv'_a\left(\waD_\gq\vsu-\vgl_0\right)
\right]
.\eqbl
Equation for $\vgl$ multiplied by $\waD_a$
\bqbl
&&
\waD_\gq\waD_a\R{\wsg_{33}}{a}\left(\waD_\gq\vgl-\waD_a\vgl_0\right)
+n\waD_a a\wsg_{\gq\gq}\left(n\vgl+\waD_a\vgy\right)
-in\waD_a\wsg_{a\gq}\left(\waD_\gq\vgy+n\vgl_0\right)
=
\\&&
n\waD_a P_s\wsv\left(\waD_\gq\vsu-\vgl_0\right)
-\waD_a F_s\left(\waD_\gq\vgy+n\vgl_0\right)
.\eqbl
Difference
\bqbl
&&
\waD_\gq\waD_a\R{\wsg_{33}}{a}\left(\waD_a\vgl_0-\waD_\gq\vgl\right)
-in\waD_\gq\wsg_{a\gq}\left(\waD_a\vgy+n\vgl\right)
-n\waD_\gq\R{\wsg_{aa}}{a}\left(\waD_\gq\vgy+n\vgl_0\right)
=
\\&&
n{F_s'-P_s'\wsv\over2}\left(\waD_\gq\vsu-\vgl_0\right)
-nF_s\left(\waD_a\vgl_0-\waD_\gq\vgl\right)
+n\wsu\waT{P_s'\wsv+F_s'\over2}\left(\waD_\gq\vgy+n\vgl_0\right)
\\&&
+n\wsu\waT\left[
inP_s\wsv'_\gq\left(-\waD_a\vsu+\vgl\right)
-i{P_s'\over2}\wsv'_\gq\left(\vgy+n\vsu\right)
+nP_s\wsv\left(\waD_a\vgl_0-\waD_\gq\vgl\right)
-nP_s\wsv'_a\left(\waD_\gq\vsu-\vgl_0\right)
\right]
\\&&
-nP_s\waD_a\wsv\left(\waD_\gq\vsu-\vgl_0\right)
+F_s'\left(\waD_\gq\vgy+n\vgl_0\right)
+F_s\waD_a\left(\waD_\gq\vgy+n\vgl_0\right)
.\eqbl
It is equal to equation for $\vgl_0$ multiplied by $\waD_\gq$
when one takes into account $\waD_\gq\mu\waT=I+n\wsu\waT$
\bqbl
&&
\waD_a\R{\wsg_{33}}{a}\left(\waD_a\vgl_0-\waD_\gq\vgl\right)
-n\R{\wsg_{aa}}{a}\left(\waD_\gq\vgy+n\vgl_0\right)
-in\wsg_{a\gq}\left(\waD_a\vgy+n\vgl\right)
=
\\&&
{F_s'-P_s'\wsv\over2}\left(\vgy+n\vsu\right)
+F_s\left(\waD_a\vgy+n\vgl\right)
-nP_s\wsv\left(\waD_a\vsu-\vgl\right)
+\mu\waT{P_s'\wsv+F_s'\over2}\left(\waD_\gq\vgy+n\vgl_0\right)
\\&&
+\mu\waT\left[
inP_s\wsv'_\gq\left(-\waD_a\vsu+\vgl\right)
-i{P_s'\over2}\wsv'_\gq\left(\vgy+n\vsu\right)
+nP_s\wsv\left(\waD_a\vgl_0-\waD_\gq\vgl\right)
-nP_s\wsv'_a\left(\waD_\gq\vsu-\vgl_0\right)
\right]
,\\&&
\waD_\gq\mu\waT=I+n\wsu\waT
.\eqbl
Thus, the function $\vgl_0$ is necessary to satisfy only the zeroth harmonic
of the equation for $\vgl_0$.

\section{The choice $\vgl=0$}
This seems to be the simplest choice.

Equation for $\vgy$
\bqbl
&&
\waD_a a\wsg_{\gq\gq}\waD_a\vgy
-i\waD_a\wsg_{a\gq}\left(\waD_\gq\vgy+n\vgl_0\right)
-i\waD_\gq\wsg_{a\gq}\waD_a\vgy
-\waD_\gq\R{\wsg_{aa}}{a}\left(\waD_\gq\vgy+n\vgl_0\right)
=
\\&&
{P_s'\wsv+F_s'\over2}\left(\waD_\gq\vsu-\vgl_0\right)
-F_s\waD_a\vgl_0
+\wsu\waT{P_s'\wsv+F_s'\over2}\left(\waD_\gq\vgy+n\vgl_0\right)
\\&&
+\wsu\waT\left[
-inP_s\wsv'_\gq\waD_a\vsu
-i{P_s'\over2}\wsv'_\gq\left(\vgy+n\vsu\right)
+nP_s\wsv\waD_a\vgl_0
-nP_s\wsv'_a\left(\waD_\gq\vsu-\vgl_0\right)
\right]
.\eqbl
Equation for the variable part $\R{\wsg_{33}}{a}\waD_a\vgl_0$
\bqbl
&&
-\waD_\gq\R{\wsg_{33}}{a}\waD_a\vgl_0
+na\wsg_{\gq\gq}\waD_a\vgy
-in\wsg_{a\gq}\left(\waD_\gq\vgy+n\vgl_0\right)
=
nP_s\wsv\left(\waD_\gq\vsu-\vgl_0\right)
-F_s\left(\waD_\gq\vgy+n\vgl_0\right)
.\eqbl
Equation for the averaged part $\R{\wsg_{33}}{a}\waD_a\vgl_0$
\bqbl
&&
\waD_a\R{\wsg_{33}}{a}\waD_a\vgl_0
-n\R{\wsg_{aa}}{a}\left(\waD_\gq\vgy+n\vgl_0\right)
-in\wsg_{a\gq}\waD_a\vgy
=
\\&&
{F_s'-P_s'\wsv\over2}\left(\vgy+n\vsu\right)
+F_s\waD_a\vgy
-nP_s\wsv\waD_a\vsu
+\mu\waT{P_s'\wsv+F_s'\over2}\left(\waD_\gq\vgy+n\vgl_0\right)
\\&&
+\mu\waT\left[
-inP_s\wsv'_\gq\waD_a\vsu
-i{P_s'\over2}\wsv'_\gq\left(\vgy+n\vsu\right)
+nP_s\wsv\waD_a\vgl_0
-nP_s\wsv'_a\left(\waD_\gq\vsu-\vgl_0\right)
\right]
.\eqbl
Averaging operator
\bqbl
&&
u(a,\gq,\gz)=
\vsu e^{-in\gz}
,\quad
\vsu
=\sum_{m=-\infty}^\infty u_me^{im\gq+inq\t{\gh}}
,\quad
<\vsu>_\gq=
\sum_{m=-\infty}^\infty e_mu_m
,\quad
e_m=\left<e^{im\gq+inq\t{\gh}}\right>_\gq
.\eqbl

\section{Singular layer in the ideal MHD}
Reduced MHD
\bqbl
&&
\waD_a a\wsg_{\gq\gq}\waD_a\vgy
-i\waD_a\wsg_{a\gq}\waD_\gq\vgy
-i\waD_\gq\wsg_{a\gq}\waD_a\vgy
-\waD_\gq\R{\wsg_{aa}}{a}\waD_\gq\vgy
=
\\&&
{P_s'\wsv+F_s'\over2}\waD_\gq\vsu
+\wsu\waT{P_s'\wsv+F_s'\over2}\waD_\gq\vgy
+\wsu\waT\left[
-inP_s\wsv'_\gq\waD_a\vsu
-i{P_s'\over2}\wsv'_\gq\vgy
-nP_s\wsv'_a\waD_\gq\vsu
\right]
.\eqbl
The main terms near the resonant surface
\bqbl
&&
\wsu\vgy''
=
nf\waT\left[
-i\wsv'_\gq\vsu'
-nq\wsv'_a\vsu
-n(q\wsv\gh'_\gq)'_a\vsu
\right]
,\quad
g_0\equiv -q\wsv'_0-(q\wsv\gh'_\gq)'_0
,\quad
g_\gq'=\wsv'_\gq
,\quad
(fg)_0=0
,\\&&
\wsu\vgy''
=
nf\waT\left[
-ig'_\gq\vsu'
+ng_0\vsu
\right]
,\quad
f\equiv P_s{\wsu^2\over a\wsg_{\gq\gq}}
,\quad
(fg)_0=0
.\eqbl
Mercier criterion
\bqbl
&&
\wsu\vgy=(1+\tgy)x^{\gn+1}
,\quad
\vsu=(\vsu_0+x\tsu)x^\gn
,\quad
\vsu_0=-{1\over nS}
,\quad
\tsu'_\gq={i\over\gm}\tgy
,\\&&
(\gn+1)\gn{1+\tgy\over f}
=
nx\waT\left[
ix^{-1}\gn g'_\gq{1\over nS}
-{\gn+1\over\gm}<g\tgy>
-{g_0\over S}
\right]
,\\&&
(\gn+1)\gn{1+\tgy\over f}
=
{g_0\over S^2}+{\gn+1\over\gm S}<g\tgy>
-{\gn\over\gm S}(g-<g>)
,\\&&
(\gn+1)\gn(1+\tgy)
=
{g_0\over S^2}f
+{\gn+1\over\gm S}f<g\tgy>
-{\gn\over\gm S}(fg-f<g>)
,\\&&
(\gn+1)\gn(g+g\tgy)
=
{g_0\over S^2}fg
+{\gn+1\over\gm S}gf<g\tgy>
-{\gn\over\gm S}(fg^2-fg<g>)
,\\&&
(\gn+1)<g\tgy>
=
-(\gn+1)<g>
-{1\over\gm S}<fg^2>
,\\&&
(\gn+1)\gn
=
{g_0\over S^2}<f>
-{1\over\gm S}<f><g>
-{1\over\gm^2S^2}<f><fg^2>
.\eqbl
Resonant eigenfunctions
\bqbl
&&
\wsu\vgy=(1+\tgy)x^{\gn+1}
,\quad
1+\tgy
=
{f\over<f>}
-{fg\over\gm S(\gn+1)}
,\\&&
(\gn+1)\gn
=
{g_0\over S^2}<f>
-{1\over\gm S}<f><g>
-{1\over\gm^2S^2}<f><fg^2>
.\eqbl

\section{Euler equation in the Reduced MHD}
Equation for $\gy$ ($\tgh=0$, $\gj=0$)
\bqbl
&&
{\pa\over\pa a}\left(\R{g_{\gq\gq}}{\q{g}}{\pa\gy\over\pa a}-\R{g_{a\gq}}{\q{g}}{\pa\gy\over\pa\gq}\right)
-{\pa\over\pa\gq}\left(\R{g_{a\gq}}{\q{g}}{\pa\gy\over\pa a}-\R{g_{aa}}{\q{g}}{\pa\gy\over\pa\gq}\right)
=
\\&&
{P_s'v+F_s'\over2}{\pa u\over\pa\gq}
-{\gd u\over\gd\gy}{P_s'v+F_s'\over2}{\pa\gy\over\pa\gq}
-{\gd u\over\gd\gy}{P_s'\over2}
{\pa v\over\pa\gq}\left(\gy-{\pa u\over\pa\gz}\right)
+{\gd u\over\gd\gy}P_s{\pa v\over\pa\gq}{\pa\over\pa\gz}{\pa u\over\pa a}
-{\gd u\over\gd\gy}P_s{\pa v\over\pa a}{\pa\over\pa\gz}{\pa u\over\pa\gq}
.\eqbl
Straight field line reprezentation of the perturburbation
\bqbl
&&
a=a
,\quad
\gq=\gq
,\quad
\gz=\gz-q\gh
,\quad
\gy(a,\gq,\gz)=\gy(a,\gq,\gz-q\gh)
,\quad
u(a,\gq,\gz)=u(a,\gq,\gz-q\gh)
.\eqbl
Matrices from the equilibrium code
\bqbl
&&
\R{\wsg_{aa}}{a}\equiv\R{g_{aa}}{\q{g}}
,\quad
\wsg_{a\gq}\equiv\R{g_{a\gq}}{\q{g}}
,\quad
a\wsg_{\gq\gq}\equiv\R{g_{\gq\gq}}{\q{g}}
,\quad
\wsu\equiv1+\gh'_\gq
,\quad
\wsv\equiv{r^2\over\baF}
.\eqbl
Additional matrices for stability equations
\bqbl
&&
\waG^a=a\wsg_{\gq\gq}\gz'_a-\wsg_{a\gq}\gz'_\gq
,\quad
\R{\waG^\gq}{a}=\R{\wsg_{aa}}{a}\gz'_\gq-\wsg_{a\gq}\gz'_a
,\quad
\R{\waG^2}{a}=\gz'_a\waG^a+\gz'_\gq\R{\waG^\gq}{a}
,\quad
\wsz'_\gq\equiv \gz'_\gq
,\\&&
\wsv^Z=\wsv\gz'_\gq
,\quad
\R{\wsv^D}{a}=\wsv'_a\gz'_\gq-\wsv'_\gq\gz'_a
,\quad
\vsu=\waT\wsu\vgy
,\quad
T_{mm'}={\gd_{mm'}\over m\gm-n}
,\quad
i\waM\equiv{\pa\over\pa\gq}=im\gd_{mm'}
.\eqbl
Reduced MHD equations
\bqbl
&&
\left(a\wsg_{\gq\gq}\vgy'-i\wsg_{a\gq}\waM\vgy-in\waG^a\vgy\right)'
=
\\&&
i\left(\waM\wsg_{a\gq}+n\waG^a-nP_s\wsu\waT\wsv'_\gq\waT\wsu\right)\vgy'
+\left(\waM\R{\wsg_{aa}}{a}\waM-n\R{\waG^\gq}{a}\waM-n\waM\R{\waG^\gq}{a}+n^2\R{\waG^2}{a}\right)\vgy
\\&&
+{F_s'\over2}(\wsu\waT\waM+\waM\waT\wsu-n\wsu\waT\wsz'_\gq-n\wsz'_\gq\waT\wsu)\vgy
\\&&
+{P_s'\over2}(\wsu\waT\wsv\waM-n\wsu\waT\wsv^Z-i\wsu\waT\wsv'_\gq-in\wsu\waT\wsv'_\gq\waT\wsu
+\wsv\waM\waT\wsu-n\wsv^Z\waT\wsu)\vgy
\\&&
+P_s\wsu\waT\left[n^2\R{\wsv^D}{a}\waT\wsu-n\wsv'_a\waM\waT\wsu-in\wsv'_\gq(\waT\wsu)'\right]\vgy
.\eqbl
#endif
#ifndef mzl_System_escK.c
#endif
extern double cr2;	/* undefined */
extern double cr3;	/* undefined */
extern double cr4;	/* undefined */
extern double cr6;	/* undefined */
extern double cr12;	/* undefined */
extern double cgp;	/* undefined */
extern double c2gp;	/* undefined */
extern double cgp_4;	/* undefined */
extern double cr2gp;	/* undefined */
extern double cgm0;	/* undefined */
extern double crgm0;	/* undefined */
extern int ESNa;	/* undefined */
extern int ESNa1;	/* undefined */
extern int ESNp;	/* undefined */
extern int ESNp1;	/* undefined */
extern int ESFp;	/* undefined */
extern int ESFp1;	/* undefined */
extern int ESnAP;	/* undefined */
extern int ESnAF;	/* undefined */
extern int ES2Mp;	/* undefined */
extern int ES2Mp1;	/* undefined */
extern int ESEqSolvFl;	/* undefined */
extern int ESEqSolvInPr;/* undefined */
extern int ESEqSolvInCr;/* undefined */
extern double *ESsa;	/* undefined */
extern double *ESpa;	/* undefined */
extern double *ESgt;	/* undefined */
extern double ESaRx;	/* undefined */
extern double ESaZx;	/* undefined */
extern double *ESaR0;	/* undefined */
extern double *ESaZ0;	/* undefined */
extern double *ESsr;	/* undefined */
extern double *ESsz;	/* undefined */
extern double *ESsb;	/* undefined */
extern double *ESsb1a;	/* undefined */
extern double *ESsb2a;	/* undefined */
extern double *rcT;	/* undefined */
extern double *rcT1a;	/* undefined */
extern double *rcT2a;	/* undefined */
extern double *rsT;	/* undefined */
extern double *rsT1a;	/* undefined */
extern double *rsT2a;	/* undefined */
extern double ESRBt;	/* undefined */
extern double ESRext;	/* undefined */
extern double *ESLc;	/* undefined */
extern double *ESLc2;	/* undefined */
extern double *ESLs;	/* undefined */
extern double *ESLs2;	/* undefined */
extern double *ESVc;	/* undefined */
extern double *ESVc2;	/* undefined */
extern double *ESVs;	/* undefined */
extern double *ESVs2;	/* undefined */
extern double *ESDPc;	/* undefined */
extern double *cs1;	/* undefined */
extern double *sn1;	/* undefined */
extern double *cs2;	/* undefined */
extern double *sn2;	/* undefined */
extern double *dra;	/* undefined */
extern double *dza;	/* undefined */
extern double *drgt;	/* undefined */
extern double *dzgt;	/* undefined */
extern double *ESgY0;	/* undefined */
extern double *ESRC;	/* undefined */
extern double *ESRC1a;	/* undefined */
extern double *ESRC2a;	/* undefined */
extern double *ESqgF;	/* undefined */
extern double *ESqgF1a;	/* undefined */
extern double *ESqgF2a;	/* undefined */
extern double *ESqgY;	/* undefined */
extern double *ESqgY1a;	/* undefined */
extern double *ESqgY2a;	/* undefined */
extern double *ESsh;	/* undefined */
extern double *ESsh1a;	/* undefined */
extern double *ESsh2a;	/* undefined */
extern double *ESqV;	/* undefined */
extern double *ESqV1a;	/* undefined */
extern double *ESqV2a;	/* undefined */
extern double *ESjp;	/* undefined */
extern double *ESjp1a;	/* undefined */
extern double *ESjp2a;	/* undefined */
extern double *ESsp;	/* undefined */
extern double *ESsp1a;	/* undefined */
extern double *ESsp2a;	/* undefined */
extern double *ESPs;	/* undefined */
extern double *ESPs1a;	/* undefined */
extern double *ESPs2a;	/* undefined */
extern double *ESgb;	/* undefined */
extern double *ESgb1a;	/* undefined */
extern double *ESgb2a;	/* undefined */
extern double *ESgB;	/* undefined */
extern double *ESgB1a;	/* undefined */
extern double *ESgB2a;	/* undefined */
extern double *ESjs;	/* undefined */
extern double *ESjs1a;	/* undefined */
extern double *ESjs2a;	/* undefined */
extern double *ESjb;	/* undefined */
extern double *ESjb1a;	/* undefined */
extern double *ESjb2a;	/* undefined */
extern double *ESaJ;	/* undefined */
extern double *ESaJ1a;	/* undefined */
extern double *ESaJ2a;	/* undefined */
extern double *ESaT;	/* undefined */
extern double *ESaT1a;	/* undefined */
extern double *ESaT2a;	/* undefined */
extern double *ESjB;	/* undefined */
extern double *ESjB1a;	/* undefined */
extern double *ESjB2a;	/* undefined */
extern double *ESsq;	/* undefined */
extern double *ESsq1a;	/* undefined */
extern double *ESsq2a;	/* undefined */
extern double *ESgm;	/* undefined */
extern double *ESgm1a;	/* undefined */
extern double *ESgm2a;	/* undefined */
extern double *ESgY;	/* undefined */
extern double *ESgY1a;	/* undefined */
extern double *ESgY2a;	/* undefined */
extern double *ESgF;	/* undefined */
extern double *ESgF1a;	/* undefined */
extern double *ESgF2a;	/* undefined */
extern double *ESaF;	/* undefined */
extern double *ESaF1a;	/* undefined */
extern double *ESaF2a;	/* undefined */
extern double *ESFF;	/* undefined */
extern double *ESFF1a;	/* undefined */
extern double *ESFF2a;	/* undefined */
extern double *ESdgY;	/* undefined */
extern double *ESdgY1a;	/* undefined */
extern double *ESdgY2a;	/* undefined */
extern double *ESjR;	/* undefined */
extern double *ESjR1a;	/* undefined */
extern double *ESjR2a;	/* undefined */
static double *rdPV;	/*  */
static double *zdPV;	/*  */
static int nP;		/*  */
static int nP1;		/*  */
static int nP2;		/*  */
static int nP5;		/*  */
static long int nP0;	/*  */
static double Bala0;	/*  */
static double Bala1;	/*  */
static double Balda;	/*  */
static double R[];	/*  */
static double Z[];	/*  */
static double gtmax;	/*  */
static double *Blnp;	/*  */
static double *Blnpp;	/*  */
static double *Blnq;	/*  */
static double *Blnqp;	/*  */
static double *Blnfg;	/*  */
static double *Blngp;	/*  */
static double *Blnf;	/*  */
static double *Blnfp;	/*  */
static double *Blng22;	/*  */
static double *Blnp2r;	/*  */
static double *Blng11;	/*  */
static double *Blng12;	/*  */
static double *Blndg12t;/*  */
static double *Blndp2ra;/*  */
static double *Blndg22t;/*  */
static double *Blndp2rt;/*  */
static double *Blnqg;	/*  */
static double *Blndqga;	/*  */
static double *Blngd;	/*  */
static double *Blndgda;	/*  */
int ESStab()
{
  /*
   */
#ifdef Doc_ESStab

\section{Skeleton of ESStab()}
  \begin{verbatim}
    ESStab(){
    }
  \end{verbatim}
\section{ESStab()}
#endif
}
#endif

#undef Doc_Cb_Structure
#ifdef Blb_escK.c
Blb_escK.c{
}
#endif

#undef Doc_Table_Of_Content
#ifndef Blb_escK.c
		PS p= -1 (  0);
int ESStab();	PS p=  2 (  1);
#endif



The final expression for the potential energy
\bqbl
W
=
\r{8\gp}&&\int\left\{
\R{g_{aa}}{\q{g}}(\gy'_\gt-\gj'_\gf)^2
+2\R{g_{a\gt}}{\q{g}}(\tgh'_\gf-\gy'_a)(\gy'_\gt-\gj'_\gf)
+\R{g_{\gt\gt}}{\q{g}}(\tgh'_\gf-\gy'_a)^2
\right.\\&&\left.
+\R{r^2}{\q{g}}(\gj'_a-\tgh'_\gt)^2
\right\}da d\gt d\gf
.\eqbl
With a representation
\bqbl
&&
\gy
=
\gy(a,\gt,\gf-\gd)
,\eqbl
the functional becames
\bqbl
W
=
\r{8\gp}&&\int\left\{
\R{g_{aa}}{\q{g}}(\gy'_\gt-\gd'_\gt\gy'_\gf-\gj'_\gf)^2
+2\R{g_{a\gt}}{\q{g}}(\tgh'_\gf-\gy'_a+\gd'_a\gy'_\gf)
 (\gy'_\gt-\gd'_\gt\gy'_\gf-\gj'_\gf)
\right.\\&&\left.
+\R{g_{\gt\gt}}{\q{g}}(\tgh'_\gf-\gy'_a+\gd'_a\gy'_\gf)^2
+\R{r^2}{\q{g}}(\gj'_a+\gd'_a\gj'_\gf-\tgh'_\gt+\gd'_\gt\tgh'_\gf)^2
\right\}da d\gt d\gf
.\eqbl

