#ifndef Blb_escPlV.c
/* undefined */
#ifdef Doc_escPlV.c
\section{Representation of 3-D coordinates}
The following representation of the 3-D coordinates is used in ESC
\bqbl
r
=&&
R_0(\ph)
+ar^c_1(a,\ph)\cos\ta
+ar^s_1(a,\ph)\sin\ta
+a^2X_2(a,\ta,\ph)
,\\
z
=&&
Z_0(\ph)
+ab(a,\ph)\sin \ta
.\eqbl

Below is a garbage.

In a general 3-D case with $L$ serving as the basic toroidal period, 
a rotating coordinate system $X,Y$ is used at every toroidal 
cross-section as
\bqbl
r
=
&&
R_0(\ph)
+ax
,\quad
z
=
Z_0(\ph)
+ay
,\quad
x
=
X\cos L\ph
+Y\sin L\ph
,\quad
y
=
-X\sin L\ph
+Y\cos L\ph
.\eqbl
In the rotating coordinates, the transformation of canonical coordinates 
$a,\ta,\ph$ is taken in the form
\bqbl
X
=
&&
X^c_1(a,\ta,\ph)
+aX_2(a,\ta,\ph)
=
2X^c_1(a,\ph)\cos(\ta+L\ph)
+2X^s_1(a,\ph)\sin(\ta+L\ph)
+aX_2(a,\ta,\ph)
,\\
Y
=
&&
aY_0(a,\ph)
+b(a,\ph)\sin(\ta+L\ph)
,\\
b
=&&
b_0+2\sum_{n=1}^{n<N}\left[
  b^c_{0n}\cos(n\ph)
  +b^s_{0n}\sin(n\ph)
 \right]
.\eqbl

In  2-D case, it is reduced to
\bqbl
&&
r
=
R_0
+aX
,\quad
z
=
Z_0
+aY
,\quad
\ze
=
\ph
,\\&&
X
=
\cos\ta
+aX_2(a,\ta)
,\quad
Y
=
aY_0
+b\sin\ta
.\eqbl

#endif
#ifndef mzl_System_escPlV.c
#ifdef Tbl_UnusedID
  extern double cr3;		/*            :escPlV.c */
  extern double cr12;		/*            :escPlV.c */
  extern double cgp_4;		/*            :escPlV.c */
  extern double cr2gp;		/*            :escPlV.c */
  extern double cgm0;		/*            :escPlV.c */
  extern double crgm0;		/*            :escPlV.c */
  extern int ESna;		/*            :escPlV.c */
  extern int ESna1;		/*            :escPlV.c */
  static int naD;		/* .mzl_1Dcore:escPlV.c */
  extern double *ESgF;		/*            :escPlV.c */
  extern double *ESgF1a;	/*            :escPlV.c */
  static double *rPlV;		/*  .mzl_ESPlV:escPlV.c */
  static double *zPlV;		/*  .mzl_ESPlV:escPlV.c */
  static int iPncr;		/*  .mzl_ESPlV:escPlV.c */
  extern int TFCNt;		/*            :escPlV.c */
  extern int TFCNp;		/*            :escPlV.c */
  int ESDeInit1ACore();		/* .mzl_1Dcore:escPlV.c */
  int ESDeInit1PCore();		/* .mzl_2Dcore:escPlV.c */
  int ESDeInit1FCoreInt();	/* .mzl_2Dcore:escPlV.c */
  int ESDeInit1TCore();		/* .mzl_3Dcore:escPlV.c */
  int ESDeInit2ATCore();	/* .mzl_3Dcore:escPlV.c */
  int ESDeInit2PACore();	/* .mzl_2Dcore:escPlV.c */
  int ESDeInit3PATCore();	/* .mzl_2Dcore:escPlV.c */
  int ESDeInit1DPlV();		/* .mzl_2Dcore:escPlV.c */
  int ESDeInit2DAPrC();		/* .mzl_2Dcore:escPlV.c */
  int ESPncr2Sort();		/* .mzl_3Dcore:escPlV.c */
  int ESPncr2PlVData0();	/* .mzl_3Dcore:escPlV.c */
  int ESDeInit2DTPlV();		/* .mzl_3Dcore:escPlV.c */
  int ESDeInit1DFPlV();		/* .mzl_2Dcore:escPlV.c */
  int ESDeInit2DFTPlV();	/* .mzl_3Dcore:escPlV.c */
  int ESDeInit2DFPPlV();	/* .mzl_2Dcore:escPlV.c */
  int ESDeInitPlVeq();		/* .mzl_2Dcore:escPlV.c */
  int ESInit3DCoord0();		/* .mzl_3Dcore:escPlV.c */
  int ESInitPlGeomInt();	/*  .mzl_ESPlV:escPlV.c */
  int ESInitPlGeom();		/*  .mzl_ESPlV:escPlV.c */
  int ESA2RefRZ();		/*  .mzl_ESPlV:escPlV.c */
  int ESMetricTensor();		/*  .mzl_ESPlV:escPlV.c */
#endif
  Ignor void;
  Ignor double;
  Ignor char;
  Ignor int;
  Systm free();
  Systm cos();
  Systm sin();
  Systm asin();
  Undef NULL;			/* undefined */
  Undef ReInitArray();		/* NO prototype */
  Undef FailureAlarm();		/* NO prototype */
  Undef ESexit();		/* NO prototype */
  Undef ESGetPncrAddr();	/* NO prototype */
  Undef sqrt();			/* NO prototype */
  Undef fabs();			/* NO prototype */
  Undef spl_p();		/* NO prototype */
  Undef SetIspl();		/* NO prototype */
  Undef splR();			/* NO prototype */
  Undef zero();			/* NO prototype */
  Undef Plot2D();		/* NO prototype */
  Undef f2spl();		/* NO prototype */
  Undef ludcmp();		/* NO prototype */
  Undef lubksb();		/* NO prototype */
  Undef abs();			/* NO prototype */
  Undef ESReInit3APTSpl();	/* NO prototype */
  Undef ESInitSplAPT();		/* NO prototype */
  Undef ESGetgFPlV();		/* NO prototype */
  Undef ESSmoothRZ();		/* NO prototype */
  Undef ESCoord2Spl();		/* NO prototype */
  Undef ESNormDispl();		/* NO prototype */
  extern int ESNa;		/* External */
  extern int ESNa1;		/* External */
  extern double *a;		/* External */
  extern double *aa;		/* External */
  extern double *a3a;		/* External */
  extern double *b;		/* External */
  extern int ESmemlev;		/* External */
  extern double c2gp;		/* External */
  extern int ESNp;		/* External */
  extern double *gt;		/* External */
  extern double *ESgh;		/* External */
  extern double *cs1;		/* External */
  extern double *sn1;		/* External */
  extern double *cs2;		/* External */
  extern double *sn2;		/* External */
  extern int ESNp1;		/* External */
  extern int ESNf1;		/* External */
  extern int *ESkF;		/* External */
  extern int *ESnF;		/* External */
  extern int *ESmF;		/* External */
  extern int ESNf;		/* External */
  extern int ESLt;		/* External */
  extern int ESNt;		/* External */
  extern double *gf1T;		/* External */
  extern double *csLT;		/* External */
  extern double *snLT;		/* External */
  extern double *cs1T;		/* External */
  extern double *sn1T;		/* External */
  extern int ESNt1;		/* External */
  extern double *R0T;		/* External */
  extern double *Z0T;		/* External */
  extern double *r1cT;		/* External */
  extern double *r1sT;		/* External */
  extern double *x0T;		/* External */
  extern double *x2cT;		/* External */
  extern double *x2sT;		/* External */
  extern double *y0T;		/* External */
  extern double *bT;		/* External */
  extern double *r;		/* External */
  extern double *dra;		/* External */
  extern double *drt;		/* External */
  extern double *z;		/* External */
  extern double *dza;		/* External */
  extern double *dzt;		/* External */
  extern double *z2;		/* External */
  extern double *rT;		/* External */
  extern double *xT;		/* External */
  extern double *zT;		/* External */
  extern double *yT;		/* External */
  extern int ESnLm;		/* External */
  extern double *ESRLm;		/* External */
  extern double *ESZLm;		/* External */
  extern double R0;		/* External */
  extern double cr2;		/* External */
  extern double Z0;		/* External */
  extern double ESRext;		/* External */
  extern double ESRBt;		/* External */
  extern double cr6;		/* External */
  extern double cr4;		/* External */
  extern double cgp;		/* External */
  extern int ESnLm1;		/* External */
  extern double ESgFPlV1a;	/* External */
  extern double ESgFPlV;	/* External */
  int ESPlVdata2PlV();		/* No prototype */
  int ESPlVdata2PlV();		/* No prototype */
#ifdef Tbl_ESmain
#endif
#ifdef Tbl_1Dcore
  Undef ReInitArray();		/* NO prototype */
  Undef FailureAlarm();		/* NO prototype */
  Undef ESexit();		/* NO prototype */
  extern int ESNa;		/* External() */
  extern int ESNa1;		/* External() */
  extern double *a;		/* External() */
  extern double *aa;		/* External() */
  extern double *a3a;		/* External() */
  extern int ESNa1;		/* External() */
  extern double *a;		/* External() */
  extern double *b;		/* External() */
  extern double *aa;		/* External() */
  extern double *a3a;		/* External() */
  extern int ESmemlev;		/* External() */
  extern double *a3a;		/* External() */
  extern double *aa;		/* External() */
  extern double *b;		/* External() */
  extern double *a;		/* External() */
#endif
#ifdef Tbl_2Dcore
  Undef ReInitArray();		/* NO prototype */
  Undef FailureAlarm();		/* NO prototype */
  Undef ESexit();		/* NO prototype */
  Undef ReInitArray();		/* NO prototype */
  Undef FailureAlarm();		/* NO prototype */
  Undef ESexit();		/* NO prototype */
  Undef ReInitArray();		/* NO prototype */
  Undef FailureAlarm();		/* NO prototype */
  Undef ESexit();		/* NO prototype */
  Undef ReInitArray();		/* NO prototype */
  Undef FailureAlarm();		/* NO prototype */
  Undef ESexit();		/* NO prototype */
  Undef ReInitArray();		/* NO prototype */
  Undef FailureAlarm();		/* NO prototype */
  Undef ESexit();		/* NO prototype */
  Undef ReInitArray();		/* NO prototype */
  Undef FailureAlarm();		/* NO prototype */
  Undef ESexit();		/* NO prototype */
  Undef ReInitArray();		/* NO prototype */
  Undef FailureAlarm();		/* NO prototype */
  Undef ESexit();		/* NO prototype */
  Undef ReInitArray();		/* NO prototype */
  Undef FailureAlarm();		/* NO prototype */
  Undef ESexit();		/* NO prototype */
  Undef ReInitArray();		/* NO prototype */
  Undef FailureAlarm();		/* NO prototype */
  Undef ESexit();		/* NO prototype */
  extern double c2gp;		/* External() */
  extern int ESNp;		/* External() */
  extern double *gt;		/* External() */
  extern double *ESgh;		/* External() */
  extern double *cs1;		/* External() */
  extern double *sn1;		/* External() */
  extern double *cs2;		/* External() */
  extern double *sn2;		/* External() */
  extern int ESNp1;		/* External() */
  extern double *ESgh;		/* External() */
  extern double *gt;		/* External() */
  extern double *cs1;		/* External() */
  extern double *sn1;		/* External() */
  extern double *cs2;		/* External() */
  extern double *sn2;		/* External() */
  extern int ESmemlev;		/* External() */
  extern double *sn2;		/* External() */
  extern double *cs2;		/* External() */
  extern double *sn1;		/* External() */
  extern double *cs1;		/* External() */
  extern double *gt;		/* External() */
  extern double *ESgh;		/* External() */
  extern int ESNf1;		/* External() */
  extern int *ESkF;		/* External() */
  extern int *ESnF;		/* External() */
  extern int *ESmF;		/* External() */
  extern int ESNf;		/* External() */
  extern int ESNf1;		/* External() */
  extern int *ESnF;		/* External() */
  extern int *ESmF;		/* External() */
  extern int *ESkF;		/* External() */
  extern int ESLt;		/* External() */
  extern int ESNf1;		/* External() */
  extern int *ESnF;		/* External() */
  extern int *ESmF;		/* External() */
  extern int *ESnF;		/* External() */
  extern int *ESmF;		/* External() */
  extern int *ESkF;		/* External() */
  extern int ESmemlev;		/* External() */
  extern int *ESkF;		/* External() */
  extern int *ESmF;		/* External() */
  extern int *ESnF;		/* External() */
  extern double *r;		/* External() */
  extern double *dra;		/* External() */
  extern double *drt;		/* External() */
  extern double *z;		/* External() */
  extern double *dza;		/* External() */
  extern double *dzt;		/* External() */
  extern double *z2;		/* External() */
  extern int ESmemlev;		/* External() */
  extern double *z2;		/* External() */
  extern double *dzt;		/* External() */
  extern double *dza;		/* External() */
  extern double *z;		/* External() */
  extern double *drt;		/* External() */
  extern double *dra;		/* External() */
  extern double *r;		/* External() */
  extern double *rT;		/* External() */
  extern double *xT;		/* External() */
  extern double *zT;		/* External() */
  extern double *yT;		/* External() */
  extern int ESmemlev;		/* External() */
  extern double *yT;		/* External() */
  extern double *zT;		/* External() */
  extern double *xT;		/* External() */
  extern double *rT;		/* External() */
  extern int ESnLm;		/* External() */
  extern double *ESRLm;		/* External() */
  extern double *ESZLm;		/* External() */
  extern double R0;		/* External() */
  extern double cr2;		/* External() */
  extern double Z0;		/* External() */
  extern double ESRext;		/* External() */
  extern double ESRBt;		/* External() */
  extern int ESmemlev;		/* External() */
  extern int ESmemlev;		/* External() */
  extern int ESmemlev;		/* External() */
  extern int ESNp1;		/* External() */
  extern double *gt;		/* External() */
  extern int ESmemlev;		/* External() */
  extern int ESmemlev;		/* External() */
  extern int ESNp1;		/* External() */
  extern int ESNa1;		/* External() */
  extern double *a;		/* External() */
  static int NAPT;		/*  .mzl_3Dcore:escPlV.c */
  static int nAPT;		/*  .mzl_3Dcore:escPlV.c */
  static double ESBt;		/*      .mzl_PL:escPlV.c */
  static int kPlVd;		/*   .mzl_ESPlV:escPlV.c */
  static double *rPlVd;		/*   .mzl_ESPlV:escPlV.c */
  static double *zPlVd;		/*   .mzl_ESPlV:escPlV.c */
  static int *k2k;		/*   .mzl_ESPlV:escPlV.c */
  static int nPlVd;		/*   .mzl_ESPlV:escPlV.c */
  static int NPlVd;		/*   .mzl_ESPlV:escPlV.c */
  static int NrC;		/*   .mzl_ESPlV:escPlV.c */
  static int nrC;		/*   .mzl_ESPlV:escPlV.c */
  static double *aCr;		/*   .mzl_ESPlV:escPlV.c */
  static double *rCc;		/*   .mzl_ESPlV:escPlV.c */
  static double *rCc2a;		/*   .mzl_ESPlV:escPlV.c */
  static double *rCs;		/*   .mzl_ESPlV:escPlV.c */
  static double *rCs2a;		/*   .mzl_ESPlV:escPlV.c */
  static int NPlVf;		/*   .mzl_ESPlV:escPlV.c */
  static int MPlVf;		/*   .mzl_ESPlV:escPlV.c */
  static double *rPlVc;		/*   .mzl_ESPlV:escPlV.c */
  static double *rPlVs;		/*   .mzl_ESPlV:escPlV.c */
  static double *drPlVc;	/*   .mzl_ESPlV:escPlV.c */
  static double *drPlVs;	/*   .mzl_ESPlV:escPlV.c */
  static double *csPlV;		/*   .mzl_ESPlV:escPlV.c */
  static double *snPlV;		/*   .mzl_ESPlV:escPlV.c */
  static int nPlVf;		/*   .mzl_ESPlV:escPlV.c */
  static int NPlVcs;		/*   .mzl_ESPlV:escPlV.c */
  static int nPlVcs;		/*   .mzl_ESPlV:escPlV.c */
  static int Neq;		/*   .mzl_ESPlV:escPlV.c */
  static int neq;		/*   .mzl_ESPlV:escPlV.c */
  static int *indx;		/*   .mzl_ESPlV:escPlV.c */
  static double *ac;		/*   .mzl_ESPlV:escPlV.c */
  static double *f;		/*   .mzl_ESPlV:escPlV.c */
#endif
#ifdef Tbl_3Dcore
  Undef NULL;			/* undefined */
  Undef NULL;			/* undefined */
  Undef ReInitArray();		/* NO prototype */
  Undef FailureAlarm();		/* NO prototype */
  Undef ESexit();		/* NO prototype */
  Undef ReInitArray();		/* NO prototype */
  Undef FailureAlarm();		/* NO prototype */
  Undef ESexit();		/* NO prototype */
  Undef ESGetPncrAddr();	/* NO prototype */
  Undef sqrt();			/* NO prototype */
  Undef fabs();			/* NO prototype */
  Undef spl_p();		/* NO prototype */
  Undef SetIspl();		/* NO prototype */
  Undef splR();			/* NO prototype */
  Undef zero();			/* NO prototype */
  Undef Plot2D();		/* NO prototype */
  Undef sqrt();			/* NO prototype */
  Undef fabs();			/* NO prototype */
  Undef spl_p();		/* NO prototype */
  Undef SetIspl();		/* NO prototype */
  Undef splR();			/* NO prototype */
  Undef zero();			/* NO prototype */
  Undef fabs();			/* NO prototype */
  Undef ReInitArray();		/* NO prototype */
  Undef FailureAlarm();		/* NO prototype */
  Undef ESexit();		/* NO prototype */
  Undef ReInitArray();		/* NO prototype */
  Undef FailureAlarm();		/* NO prototype */
  Undef ESexit();		/* NO prototype */
  Undef sqrt();			/* NO prototype */
  Undef f2spl();		/* NO prototype */
  Undef SetIspl();		/* NO prototype */
  Undef splR();			/* NO prototype */
  Undef sqrt();			/* NO prototype */
  Undef f2spl();		/* NO prototype */
  Undef SetIspl();		/* NO prototype */
  Undef splR();			/* NO prototype */
  extern int ESNt;		/* External() */
  extern double c2gp;		/* External() */
  extern double *gf1T;		/* External() */
  extern double *csLT;		/* External() */
  extern int ESLt;		/* External() */
  extern double *snLT;		/* External() */
  extern double *cs1T;		/* External() */
  extern double *sn1T;		/* External() */
  extern int ESNt1;		/* External() */
  extern double *R0T;		/* External() */
  extern double *Z0T;		/* External() */
  extern double *gf1T;		/* External() */
  extern double *csLT;		/* External() */
  extern double *snLT;		/* External() */
  extern double *cs1T;		/* External() */
  extern double *sn1T;		/* External() */
  extern int ESmemlev;		/* External() */
  extern double *sn1T;		/* External() */
  extern double *cs1T;		/* External() */
  extern double *snLT;		/* External() */
  extern double *csLT;		/* External() */
  extern double *gf1T;		/* External() */
  extern double *R0T;		/* External() */
  extern double *Z0T;		/* External() */
  extern double *r1cT;		/* External() */
  extern double *r1sT;		/* External() */
  extern double *x0T;		/* External() */
  extern double *x2cT;		/* External() */
  extern double *x2sT;		/* External() */
  extern double *y0T;		/* External() */
  extern double *bT;		/* External() */
  extern int ESmemlev;		/* External() */
  extern double *bT;		/* External() */
  extern double *y0T;		/* External() */
  extern double *x2sT;		/* External() */
  extern double *x2cT;		/* External() */
  extern double *x0T;		/* External() */
  extern double *r1sT;		/* External() */
  extern double *r1cT;		/* External() */
  extern int ESNt1;		/* External() */
  extern double *R0T;		/* External() */
  extern double R0;		/* External() */
  extern double *Z0T;		/* External() */
  extern double Z0;		/* External() */
  extern double R0;		/* External() */
  extern double *R0T;		/* External() */
  extern double Z0;		/* External() */
  extern double *Z0T;		/* External() */
  extern int ESNt;		/* External() */
  extern double cr2;		/* External() */
  extern double cr6;		/* External() */
  extern double cr4;		/* External() */
  extern int ESNt;		/* External() */
  extern double Z0;		/* External() */
  extern double cr2;		/* External() */
  extern double cr6;		/* External() */
  extern double cr4;		/* External() */
  extern double *R0T;		/* External() */
  extern double *Z0T;		/* External() */
  extern int ESNt;		/* External() */
  extern double cr2;		/* External() */
  extern double cr4;		/* External() */
  extern double Z0;		/* External() */
  extern double *R0T;		/* External() */
  extern double *Z0T;		/* External() */
  extern int ESNt1;		/* External() */
  extern int ESNa1;		/* External() */
  extern int ESmemlev;		/* External() */
  extern int ESmemlev;		/* External() */
  extern double *rT;		/* External() */
  extern double *zT;		/* External() */
  extern double *xT;		/* External() */
  extern double *R0T;		/* External() */
  extern double R0;		/* External() */
  extern double *Z0T;		/* External() */
  extern double Z0;		/* External() */
  extern int ESNa1;		/* External() */
  extern int ESNa;		/* External() */
  extern double *bT;		/* External() */
  extern double *x0T;		/* External() */
  extern double *y0T;		/* External() */
  extern double *r1cT;		/* External() */
  extern double *r1sT;		/* External() */
  extern double *x2cT;		/* External() */
  extern double *x2sT;		/* External() */
  extern int ESNp1;		/* External() */
  extern double *aa;		/* External() */
  extern double *a;		/* External() */
  extern double *cs1;		/* External() */
  extern double *sn1;		/* External() */
  extern double *cs2;		/* External() */
  extern double *sn2;		/* External() */
  extern double *a3a;		/* External() */
  extern int ESNt1;		/* External() */
  extern double *rT;		/* External() */
  extern double *zT;		/* External() */
  extern double *xT;		/* External() */
  extern int ESNa1;		/* External() */
  extern int ESNa;		/* External() */
  extern int ESNp1;		/* External() */
  extern double *R0T;		/* External() */
  extern double *Z0T;		/* External() */
  extern double *aa;		/* External() */
  extern double *x0T;		/* External() */
  extern double *y0T;		/* External() */
  extern double *a;		/* External() */
  extern double *r1cT;		/* External() */
  extern double *r1sT;		/* External() */
  extern double *x2cT;		/* External() */
  extern double *x2sT;		/* External() */
  extern double *bT;		/* External() */
  extern double *cs1;		/* External() */
  extern double *sn1;		/* External() */
  extern double *cs2;		/* External() */
  extern double *sn2;		/* External() */
  extern double *a3a;		/* External() */
  extern double R0;		/* External() */
  extern double *R0T;		/* External() */
  extern double Z0;		/* External() */
  extern double *Z0T;		/* External() */
  extern int ESNa1;		/* External() */
  extern int ESNa;		/* External() */
  extern double *x0T;		/* External() */
  extern double *y0T;		/* External() */
  extern double *r1cT;		/* External() */
  extern double *r1sT;		/* External() */
  extern double *x2cT;		/* External() */
  extern double *x2sT;		/* External() */
  extern double *bT;		/* External() */
  extern double *xT;		/* External() */
  extern int ESNp1;		/* External() */
  extern double cr2;		/* External() */
  extern int ESNp;		/* External() */
  extern double *r;		/* External() */
  extern double *z;		/* External() */
  extern double *bT;		/* External() */
  extern double *x0T;		/* External() */
  extern double *y0T;		/* External() */
  extern double *r1cT;		/* External() */
  extern double *r1sT;		/* External() */
  extern double *x2cT;		/* External() */
  extern double *x2sT;		/* External() */
  extern double *rT;		/* External() */
  extern double *zT;		/* External() */
  extern double *xT;		/* External() */
  extern double *yT;		/* External() */
  extern int ESNt1;		/* External() */
  extern double *R0T;		/* External() */
  extern double *Z0T;		/* External() */
  extern int ESNa1;		/* External() */
  extern double *xT;		/* External() */
  extern double *a;		/* External() */
  extern double *bT;		/* External() */
  extern double *x0T;		/* External() */
  extern double *y0T;		/* External() */
  extern double *r1cT;		/* External() */
  extern double *r1sT;		/* External() */
  extern double *x2cT;		/* External() */
  extern double *x2sT;		/* External() */
  extern int ESNp1;		/* External() */
  extern double *rT;		/* External() */
  extern double *zT;		/* External() */
  extern int ESNa1;		/* External() */
  extern int ESNt1;		/* External() */
  extern double ESRext;		/* External() */
  extern double *R0T;		/* External() */
  extern double *Z0T;		/* External() */
  extern double *xT;		/* External() */
  extern double *a;		/* External() */
  extern double *bT;		/* External() */
  extern double *x0T;		/* External() */
  extern double *y0T;		/* External() */
  extern double *r1cT;		/* External() */
  extern double *r1sT;		/* External() */
  extern double *x2cT;		/* External() */
  extern double *x2sT;		/* External() */
  extern int ESNp1;		/* External() */
  extern double ESRBt;		/* External() */
  extern double *rT;		/* External() */
  extern double *zT;		/* External() */
  int ESPlVdata2PlV();		/* No prototype */
  int ESPlVdata2PlV();		/* No prototype */
  static int nAP;		/*  .mzl_2Dcore:escPlV.c */
  static double *r3;		/*  .mzl_2Dcore:escPlV.c */
  static int NAP;		/*  .mzl_2Dcore:escPlV.c */
  static double ESBt;		/*      .mzl_PL:escPlV.c */
  static int nPlVd;		/*   .mzl_ESPlV:escPlV.c */
  static double *rPlVd;		/*   .mzl_ESPlV:escPlV.c */
  static double *zPlVd;		/*   .mzl_ESPlV:escPlV.c */
  static int *k2k;		/*   .mzl_ESPlV:escPlV.c */
  static int nPncr;		/*   .mzl_ESPlV:escPlV.c */
  static int nPsrf;		/*   .mzl_ESPlV:escPlV.c */
  static double *rPncr;		/*   .mzl_ESPlV:escPlV.c */
  static double *zPncr;		/*   .mzl_ESPlV:escPlV.c */
  static double *xPncr;		/*   .mzl_ESPlV:escPlV.c */
  static double *yPncr;		/*   .mzl_ESPlV:escPlV.c */
  static int KPncr;		/*   .mzl_ESPlV:escPlV.c */
  static int LPncr;		/*   .mzl_ESPlV:escPlV.c */
  static double *drPlVc;	/*   .mzl_ESPlV:escPlV.c */
  static double *drPlVs;	/*   .mzl_ESPlV:escPlV.c */
  static double bPlV;		/*   .mzl_ESPlV:escPlV.c */
  static double *rPlVc;		/*   .mzl_ESPlV:escPlV.c */
  static double *rPlVs;		/*   .mzl_ESPlV:escPlV.c */
  static int MPlVf;		/*   .mzl_ESPlV:escPlV.c */
  static double *csPlV;		/*   .mzl_ESPlV:escPlV.c */
  static double *snPlV;		/*   .mzl_ESPlV:escPlV.c */
  static int NPlVf;		/*   .mzl_ESPlV:escPlV.c */
  static double *aCr;		/*   .mzl_ESPlV:escPlV.c */
  static double *rCc;		/*   .mzl_ESPlV:escPlV.c */
  static double *rCs;		/*   .mzl_ESPlV:escPlV.c */
  static double *rCc2a;		/*   .mzl_ESPlV:escPlV.c */
  static double *rCs2a;		/*   .mzl_ESPlV:escPlV.c */
  int ESPlVdata2PlV();		/*   .mzl_ESPlV:escPlV.c */
#endif
#ifdef Tbl_PL
#endif
#ifdef Tbl_ESPlV
  Undef ludcmp();		/* NO prototype */
  Undef lubksb();		/* NO prototype */
  Undef abs();			/* NO prototype */
  Undef ESReInit3APTSpl();	/* NO prototype */
  Undef ESInitSplAPT();		/* NO prototype */
  Undef ESGetPncrAddr();	/* NO prototype */
  Undef ESGetgFPlV();		/* NO prototype */
  Undef ESSmoothRZ();		/* NO prototype */
  Undef ESCoord2Spl();		/* NO prototype */
  Undef ESNormDispl();		/* NO prototype */
  extern double cr2;		/* External() */
  extern double cgp;		/* External() */
  extern int ESLt;		/* External() */
  extern int ESNt;		/* External() */
  extern int ESnLm;		/* External() */
  extern int ESnLm1;		/* External() */
  extern int ESNa;		/* External() */
  extern int ESNp;		/* External() */
  extern int ESNt1;		/* External() */
  extern int ESNt;		/* External() */
  extern int ESLt;		/* External() */
  extern int ESNa1;		/* External() */
  extern int ESNa;		/* External() */
  extern int ESNp1;		/* External() */
  extern int ESNp;		/* External() */
  extern int ESNt1;		/* External() */
  extern int ESNt;		/* External() */
  extern double *rT;		/* External() */
  extern double *zT;		/* External() */
  extern int ESNp1;		/* External() */
  extern double ESgFPlV1a;	/* External() */
  extern double ESgFPlV;	/* External() */
  extern int ESNt;		/* External() */
  extern double *rT;		/* External() */
  extern double *zT;		/* External() */
  extern int ESNa;		/* External() */
  extern int ESNp;		/* External() */
  static int NA;		/*  .mzl_1Dcore:escPlV.c */
  static int NaD;		/*  .mzl_1Dcore:escPlV.c */
  int ESReInit1ACore();		/*  .mzl_1Dcore:escPlV.c */
  int ESInit1ACore();		/*  .mzl_1Dcore:escPlV.c */
  static int NF;		/*  .mzl_2Dcore:escPlV.c */
  static int nF;		/*  .mzl_2Dcore:escPlV.c */
  static int NP;		/*  .mzl_2Dcore:escPlV.c */
  static int NpD;		/*  .mzl_2Dcore:escPlV.c */
  static int nAP;		/*  .mzl_2Dcore:escPlV.c */
  static int NAP;		/*  .mzl_2Dcore:escPlV.c */
  int ESCore2DCoord();		/*  .mzl_2Dcore:escPlV.c */
  int ESReInit1FCoreInt();	/*  .mzl_2Dcore:escPlV.c */
  int ESCheck1FGeomInt();	/*  .mzl_2Dcore:escPlV.c */
  int ESInit1FEqWaveNum();	/*  .mzl_2Dcore:escPlV.c */
  int ESReInit1PCore();		/*  .mzl_2Dcore:escPlV.c */
  int ESInit1PCore();		/*  .mzl_2Dcore:escPlV.c */
  int ESReInit2PACore();	/*  .mzl_2Dcore:escPlV.c */
  int ESReInit3PATCore();	/*  .mzl_2Dcore:escPlV.c */
  int ESReInit1DPlV();		/*  .mzl_2Dcore:escPlV.c */
  int ESReInit1DFPlV();		/*  .mzl_2Dcore:escPlV.c */
  int ESReInit2DFPPlV();	/*  .mzl_2Dcore:escPlV.c */
  int ESReInitPlVeq();		/*  .mzl_2Dcore:escPlV.c */
  int ESReInit2DAPrC();		/*  .mzl_2Dcore:escPlV.c */
  int ESInit2DFPPlV();		/*  .mzl_2Dcore:escPlV.c */
  static int ESLt0;		/*  .mzl_3Dcore:escPlV.c */
  static int ESNLt;		/*  .mzl_3Dcore:escPlV.c */
  static int ESNLt1;		/*  .mzl_3Dcore:escPlV.c */
  static int NT;		/*  .mzl_3Dcore:escPlV.c */
  static int NtD;		/*  .mzl_3Dcore:escPlV.c */
  static int LtD;		/*  .mzl_3Dcore:escPlV.c */
  static int nAT;		/*  .mzl_3Dcore:escPlV.c */
  static int NAT;		/*  .mzl_3Dcore:escPlV.c */
  static int nAPT;		/*  .mzl_3Dcore:escPlV.c */
  static int NAPT;		/*  .mzl_3Dcore:escPlV.c */
  static int nDT;		/*  .mzl_3Dcore:escPlV.c */
  static int NDT;		/*  .mzl_3Dcore:escPlV.c */
  static double *rPlVdT;	/*  .mzl_3Dcore:escPlV.c */
  static double *zPlVdT;	/*  .mzl_3Dcore:escPlV.c */
  static int *k2kT;		/*  .mzl_3Dcore:escPlV.c */
  static int nDFT;		/*  .mzl_3Dcore:escPlV.c */
  static int NDFT;		/*  .mzl_3Dcore:escPlV.c */
  int ESReInit1TCore();		/*  .mzl_3Dcore:escPlV.c */
  int ESInit1TCore();		/*  .mzl_3Dcore:escPlV.c */
  int ESReInit2ATCore();	/*  .mzl_3Dcore:escPlV.c */
  int ESReInit2DTPlV();		/*  .mzl_3Dcore:escPlV.c */
  int ESInit2DTPlV();		/*  .mzl_3Dcore:escPlV.c */
  int ESRef2RealData();		/*  .mzl_3Dcore:escPlV.c */
  int ESRef2RealGeom();		/*  .mzl_3Dcore:escPlV.c */
  int ESReInit2DFTPlV();	/*  .mzl_3Dcore:escPlV.c */
  int ESInit3DCoord();		/*  .mzl_3Dcore:escPlV.c */
  int ESReal2RefData();		/*  .mzl_3Dcore:escPlV.c */
  int ESReal2RefGeom();		/*  .mzl_3Dcore:escPlV.c */
#endif
#ifdef Tbl_TFC
#endif
#endif
#ifndef mzl_ESmain
extern double cr2;	/* undefined */
extern double cr3;	/* undefined */
extern double cr4;	/* undefined */
extern double cr6;	/* undefined */
extern double cr12;	/* undefined */
extern double cgp;	/* undefined */
extern double c2gp;	/* undefined */
extern double cgp_4;	/* undefined */
extern double cr2gp;	/* undefined */
extern double cgm0;	/* undefined */
extern double crgm0;	/* undefined */
extern int ESmemlev;	/* undefined */
#endif
#ifndef mzl_1Dcore
extern int ESNa;	/* undefined */
extern int ESna;	/* undefined */
extern int ESNa1;	/* undefined */
extern int ESna1;	/* undefined */
extern double *a;	/* undefined */
extern double *aa;	/* undefined */
extern double *a3a;	/* undefined */
extern double *b;	/* undefined */
static int NA;		/*  */
static int NaD;		/*  */
static int naD;		/*  */
#endif
#ifndef mzl_2Dcore
extern int ESNp;	/* undefined */
extern int ESNp1;	/* undefined */
extern int *ESnF;	/* undefined */
extern int *ESmF;	/* undefined */
extern int *ESkF;	/* undefined */
extern int ESNf;	/* undefined */
extern int ESNf1;	/* undefined */
extern double *ESgh;	/* undefined */
extern double *gt;	/* undefined */
extern double *cs1;	/* undefined */
extern double *sn1;	/* undefined */
extern double *cs2;	/* undefined */
extern double *sn2;	/* undefined */
extern double R0;	/* undefined */
extern double Z0;	/* undefined */
extern double *r;	/* undefined */
extern double *z;	/* undefined */
extern double *z2;	/* undefined */
extern double *dra;	/* undefined */
extern double *drt;	/* undefined */
extern double *dza;	/* undefined */
extern double *dzt;	/* undefined */
static int NP;		/*  */
static int NpD;		/*  */
static int NAP;		/*  */
static int nAP;		/*  */
static int NF;		/*  */
static int nF;		/*  */
static double *r3;	/*  */
#endif
#ifndef mzl_3Dcore
extern int ESLt;	/* undefined */
extern int ESNt;	/* undefined */
extern int ESNt1;	/* undefined */
extern double *R0T;	/* undefined */
extern double *Z0T;	/* undefined */
extern double *rT;	/* undefined */
extern double *zT;	/* undefined */
extern double *x0T;	/* undefined */
extern double *r1cT;	/* undefined */
extern double *r1sT;	/* undefined */
extern double *x2cT;	/* undefined */
extern double *x2sT;	/* undefined */
extern double *y0T;	/* undefined */
extern double *bT;	/* undefined */
extern double *xT;	/* undefined */
extern double *yT;	/* undefined */
extern double *gf1T;	/* undefined */
extern double *csLT;	/* undefined */
extern double *snLT;	/* undefined */
extern double *cs1T;	/* undefined */
extern double *sn1T;	/* undefined */
extern double *ESgF;	/* undefined */
extern double *ESgF1a;	/* undefined */
extern double ESgFPlV;	/* undefined */
extern double ESgFPlV1a;/* undefined */
static int NT;		/*  */
static int LtD;		/*  */
static int NtD;		/*  */
static int NAT;		/*  */
static int nAT;		/*  */
static int NAPT;	/*  */
static int nAPT;	/*  */
static int ESLt0;	/*  */
static int ESNLt;	/*  */
static int ESNLt1;	/*  */
static int NDT;		/*  */
static int NADT;	/*  */
static int nDT;		/*  */
static int *k2kT;	/*  */
static int NDFT;	/*  */
static int nDFT;	/*  */
static double *rPlVdT;	/*  */
static double *zPlVdT;	/*  */
static double *rPncrDT;	/*  */
static double *zPncrDT;	/*  */
static double *bPlVT;	/*  */
static double *Z0PlVT;	/*  */
static double *R0PlVT;	/*  */
static double *rPlVcT;	/*  */
static double *rPlVsT;	/*  */
static double *drPlVcT;	/*  */
static double *drPlVsT;	/*  */
#endif
#ifndef mzl_PL
extern double ESRBt;	/* undefined */
extern double ESRext;	/* undefined */
extern int ESnLm;	/* undefined */
extern int ESnLm1;	/* undefined */
extern double *ESRLm;	/* undefined */
extern double *ESZLm;	/* undefined */
static double ESBt;	/*  */
#endif
#ifndef mzl_ESPlV
static int NPlVd;	/*  */
static int nPlVd;	/*  */
static int kPlVd;	/*  */
static int *k2k;	/*  */
static int MPlVf;	/*  */
static int NPlVf;	/*  */
static int nPlVf;	/*  */
static int NPlVcs;	/*  */
static int nPlVcs;	/*  */
static double *rPlVd;	/*  */
static double *zPlVd;	/*  */
static double *rPlV;	/*  */
static double *zPlV;	/*  */
static double bPlV;	/*  */
static double Z0PlV;	/*  */
static double R0PlV;	/*  */
static double *rPlVc;	/*  */
static double *rPlVs;	/*  */
static double *drPlVc;	/*  */
static double *drPlVs;	/*  */
static int NrC;		/*  */
static int nrC;		/*  */
static double *aCr;	/*  */
static double *rCc;	/*  */
static double *rCc2a;	/*  */
static double *rCs;	/*  */
static double *rCs2a;	/*  */
static int Neq;		/*  */
static int neq;		/*  */
static int *indx;	/*  */
static double *ac;	/*  */
static double *f;	/*  */
static double *csPlV;	/*  */
static double *snPlV;	/*  */
static int nPncr;	/*  */
static int nPsrf;	/*  */
static int KPncr;	/*  */
static int iPncr;	/*  */
static int LPncr;	/*  */
static double *rPncr;	/*  */
static double *zPncr;	/*  */
static double *xPncr;	/*  */
static double *yPncr;	/*  */
#endif
#ifndef mzl_TFC
extern int TFCNt;	/* undefined */
extern int TFCNp;	/* undefined */
#endif
#ifndef mzl_1Dcore
int ESInit1ACore()
{
/*
   */
#ifdef Doc_ESInit1ACore

#endif
}
int ESReInit1ACore()
{
  Undef ReInitArray();
  Undef FailureAlarm();
  Undef ESexit();
  extern int ESmemlev;	/* undefined */
/*
   */
#ifdef Doc_ESReInit1ACore

#endif
}
int ESDeInit1ACore()
{
/*
   */
#ifdef Doc_ESDeInit1ACore

#endif
}
#endif
#ifndef mzl_2Dcore
int ESInit1PCore()
{
  extern double c2gp;	/* undefined */
/*
   */
#ifdef Doc_ESInit1PCore

#endif
}
int ESReInit1PCore()
{
  Undef ReInitArray();
  Undef FailureAlarm();
  Undef ESexit();
/*
   */
#ifdef Doc_ESReInit1PCore

#endif
}
int ESDeInit1PCore()
{
/*
   */
#ifdef Doc_ESDeInit1PCore

#endif
}
int ESCheck1FGeomInt()
{
  /*
   */
#ifdef Doc_ESCheck1FGeomInt

#endif
}
int ESInit1FCoreInt()
{
  /*
   */
#ifdef Doc_ESInit1FCoreInt

#endif
}
int ESInit1FEqWaveNum()
{
  extern int ESLt;	/* undefined */
  /*
   */
#ifdef Doc_ESInit1FEqWaveNum

#endif
}
int ESReInit1FCoreInt()
{
  Undef ReInitArray();
  Undef FailureAlarm();
  Undef ESexit();
  /*
   */
#ifdef Doc_ESReInit1FCoreInt

#endif
}
int ESDeInit1FCoreInt()
{
  /*
   */
#ifdef Doc_ESDeInit1FCoreInt

#endif
}
#endif
#ifndef mzl_3Dcore
int ESInit1TCore()
{
/*
   */
#ifdef Doc_ESInit1TCore

#endif
}
int ESReInit1TCore()
{
  Undef ReInitArray();
  Undef FailureAlarm();
  Undef ESexit();
/*
   */
#ifdef Doc_ESReInit1TCore

#endif
}
int ESDeInit1TCore()
{
/*
   */
#ifdef Doc_ESDeInit1TCore

#endif
}
int ESReInit2ATCore()
{
  Undef ReInitArray();
  Undef FailureAlarm();
  Undef ESexit();
/*
   */
#ifdef Doc_ESReInit2ATCore

#endif
}
int ESDeInit2ATCore()
{
/*
   */
#ifdef Doc_ESDeInit2ATCore

#endif
}
#endif
#ifndef mzl_2Dcore
int ESReInit2PACore()
{
  Undef ReInitArray();
  Undef FailureAlarm();
  Undef ESexit();
/*
   */
#ifdef Doc_ESReInit2PACore

#endif
}
int ESDeInit2PACore()
{
/*
   */
#ifdef Doc_ESDeInit2PACore

#endif
}
#endif
#ifndef mzl_2Dcore
int ESReInit3PATCore()
{
  Undef ReInitArray();
  Undef FailureAlarm();
  Undef ESexit();
  extern double *rT;	/* undefined */
  extern double *xT;	/* undefined */
  extern double *zT;	/* undefined */
  extern double *yT;	/* undefined */
  static int NAPT;	/*  .mzl_3Dcore:escPlV.c */
  static int nAPT;	/*  .mzl_3Dcore:escPlV.c */
/*
   */
#ifdef Doc_ESReInit3PATCore

#endif
}
int ESDeInit3PATCore()
{
  static int NAPT;	/*  .mzl_3Dcore:escPlV.c */
/*
   */
#ifdef Doc_ESDeInit3PATCore

#endif
}
#endif
#ifndef mzl_2Dcore
int ESInit1DPlV()
{
  extern int ESnLm;	/* undefined */
  extern double *ESRLm;	/* undefined */
  extern double *ESZLm;	/* undefined */
  extern double cr2;	/* undefined */
  extern double ESRext;	/* undefined */
  extern double ESRBt;	/* undefined */
  static double ESBt;	/*     .mzl_PL:escPlV.c */
  static int kPlVd;	/*  .mzl_ESPlV:escPlV.c */
  static double *rPlVd;	/*  .mzl_ESPlV:escPlV.c */
  static double *zPlVd;	/*  .mzl_ESPlV:escPlV.c */
  static int *k2k;	/*  .mzl_ESPlV:escPlV.c */
  static int nPlVd;	/*  .mzl_ESPlV:escPlV.c */
/*
   */
#ifdef Doc_ESInit1DPlV

#endif
}
int ESReInit1DPlV()
{
  Undef ReInitArray();
  Undef FailureAlarm();
  Undef ESexit();
  static int NPlVd;	/*  .mzl_ESPlV:escPlV.c */
  static int nPlVd;	/*  .mzl_ESPlV:escPlV.c */
  static int *k2k;	/*  .mzl_ESPlV:escPlV.c */
  static double *rPlVd;	/*  .mzl_ESPlV:escPlV.c */
  static double *zPlVd;	/*  .mzl_ESPlV:escPlV.c */
/*
   */
#ifdef Doc_ESReInit1DPlV

#endif
}
int ESDeInit1DPlV()
{
  static int NPlVd;	/*  .mzl_ESPlV:escPlV.c */
  static double *zPlVd;	/*  .mzl_ESPlV:escPlV.c */
  static double *rPlVd;	/*  .mzl_ESPlV:escPlV.c */
  static int *k2k;	/*  .mzl_ESPlV:escPlV.c */
/*
   */
#ifdef Doc_ESDeInit1DPlV

#endif
}
int ESReInit2DAPrC()
{
  Undef ReInitArray();
  Undef FailureAlarm();
  Undef ESexit();
  static int NrC;	/*  .mzl_ESPlV:escPlV.c */
  static int nrC;	/*  .mzl_ESPlV:escPlV.c */
  static double *aCr;	/*  .mzl_ESPlV:escPlV.c */
  static double *rCc;	/*  .mzl_ESPlV:escPlV.c */
  static double *rCc2a;	/*  .mzl_ESPlV:escPlV.c */
  static double *rCs;	/*  .mzl_ESPlV:escPlV.c */
  static double *rCs2a;	/*  .mzl_ESPlV:escPlV.c */
  /*
   */
#ifdef Doc_ESReInit2DAPrC

#endif
}
int ESDeInit2DAPrC()
{
  static int NrC;	/*  .mzl_ESPlV:escPlV.c */
  static double *rCs2a;	/*  .mzl_ESPlV:escPlV.c */
  static double *rCs;	/*  .mzl_ESPlV:escPlV.c */
  static double *rCc2a;	/*  .mzl_ESPlV:escPlV.c */
  static double *rCc;	/*  .mzl_ESPlV:escPlV.c */
  static double *aCr;	/*  .mzl_ESPlV:escPlV.c */
  /*
   */
#ifdef Doc_ESDeInit2DAPrC

#endif
}
#endif
#ifndef mzl_3Dcore
int ESRef2RealData(iT)
  int iT;	/*  */
{
  static int nPlVd;	/*  .mzl_ESPlV:escPlV.c */
  static double *rPlVd;	/*  .mzl_ESPlV:escPlV.c */
  static double *zPlVd;	/*  .mzl_ESPlV:escPlV.c */
  static int *k2k;	/*  .mzl_ESPlV:escPlV.c */
/*
   */
#ifdef Doc_ESRef2RealData

#endif
}
int ESReal2RefData(iT)
  int iT;	/*  */
{
  static int nPlVd;	/*  .mzl_ESPlV:escPlV.c */
  static double *rPlVd;	/*  .mzl_ESPlV:escPlV.c */
  static double *zPlVd;	/*  .mzl_ESPlV:escPlV.c */
  static int *k2k;	/*  .mzl_ESPlV:escPlV.c */
/*
   */
#ifdef Doc_ESReal2RefData

#endif
}
int ESPncr2Sort(n,iPsrf)
  int n;	/*  */
  int iPsrf;	/*  */
{
  Undef ESGetPncrAddr();
  Undef sqrt();
  Undef fabs();
  Undef spl_p();
  Undef SetIspl();
  Undef splR();
  Undef zero();
  Undef Plot2D();
  extern double cr6;	/* undefined */
  extern double cr4;	/* undefined */
  static int nPncr;	/*  .mzl_ESPlV:escPlV.c */
  static int nPsrf;	/*  .mzl_ESPlV:escPlV.c */
  static double *rPncr;	/*  .mzl_ESPlV:escPlV.c */
  static double *zPncr;	/*  .mzl_ESPlV:escPlV.c */
  static double *xPncr;	/*  .mzl_ESPlV:escPlV.c */
  static double *yPncr;	/*  .mzl_ESPlV:escPlV.c */
  static int KPncr;	/*  .mzl_ESPlV:escPlV.c */
  static int LPncr;	/*  .mzl_ESPlV:escPlV.c */
  /*
   */
#ifdef Doc_ESPncr2Sort

#endif
}
int ESPncr2PlVData(n,iPsrf)
  int n;	/*  */
  int iPsrf;	/*  */
{
  Undef sqrt();
  Undef fabs();
  Undef spl_p();
  Undef SetIspl();
  Undef splR();
  Undef zero();
  static int nPlVd;	/*  .mzl_ESPlV:escPlV.c */
  static int KPncr;	/*  .mzl_ESPlV:escPlV.c */
  static double *rPncr;	/*  .mzl_ESPlV:escPlV.c */
  static double *zPncr;	/*  .mzl_ESPlV:escPlV.c */
  static double *xPncr;	/*  .mzl_ESPlV:escPlV.c */
  static double *yPncr;	/*  .mzl_ESPlV:escPlV.c */
  static int LPncr;	/*  .mzl_ESPlV:escPlV.c */
  /*
   */
#ifdef Doc_ESPncr2PlVData

#endif
}
int ESPncr2PlVData0(n,iPsrf)
  int n;	/*  */
  int iPsrf;	/*  */
{
  Undef fabs();
  static int nPlVd;	/*  .mzl_ESPlV:escPlV.c */
  static int KPncr;	/*  .mzl_ESPlV:escPlV.c */
  static double *xPncr;	/*  .mzl_ESPlV:escPlV.c */
  static double *rPncr;	/*  .mzl_ESPlV:escPlV.c */
  static double *yPncr;	/*  .mzl_ESPlV:escPlV.c */
  static double *zPncr;	/*  .mzl_ESPlV:escPlV.c */
  static int LPncr;	/*  .mzl_ESPlV:escPlV.c */
  /*
   */
#ifdef Doc_ESPncr2PlVData0

#endif
}
int ESInit2DTPlV()
{
  static int nPncr;	/*  .mzl_ESPlV:escPlV.c */
  static int nPsrf;	/*  .mzl_ESPlV:escPlV.c */
/*
   */
#ifdef Doc_ESInit2DTPlV

#endif
}
int ESReInit2DTPlV()
{
  Undef ReInitArray();
  Undef FailureAlarm();
  Undef ESexit();
/*
   */
#ifdef Doc_ESReInit2DTPlV

#endif
}
int ESDeInit2DTPlV()
{
/*
   */
#ifdef Doc_ESDeInit2DTPlV

#endif
}
#endif
#ifndef mzl_2Dcore
int ESReInit1DFPlV()
{
  Undef ReInitArray();
  Undef FailureAlarm();
  Undef ESexit();
  static int NPlVf;	/*  .mzl_ESPlV:escPlV.c */
  static int MPlVf;	/*  .mzl_ESPlV:escPlV.c */
  static double *rPlVc;	/*  .mzl_ESPlV:escPlV.c */
  static double *rPlVs;	/*  .mzl_ESPlV:escPlV.c */
  static double *drPlVc;/*  .mzl_ESPlV:escPlV.c */
  static double *drPlVs;/*  .mzl_ESPlV:escPlV.c */
/*
   */
#ifdef Doc_ESReInit1DFPlV

#endif
}
int ESDeInit1DFPlV()
{
  static int NPlVf;	/*  .mzl_ESPlV:escPlV.c */
  static double *drPlVs;/*  .mzl_ESPlV:escPlV.c */
  static double *drPlVc;/*  .mzl_ESPlV:escPlV.c */
  static double *rPlVs;	/*  .mzl_ESPlV:escPlV.c */
  static double *rPlVc;	/*  .mzl_ESPlV:escPlV.c */
/*
   */
#ifdef Doc_ESDeInit1DFPlV

#endif
}
#endif
#ifndef mzl_3Dcore
int ESReInit2DFTPlV()
{
  Undef ReInitArray();
  Undef FailureAlarm();
  Undef ESexit();
/*
   */
#ifdef Doc_ESReInit2DFTPlV

#endif
}
int ESDeInit2DFTPlV()
{
/*
   */
#ifdef Doc_ESDeInit2DFTPlV

#endif
}
#endif
#ifndef mzl_2Dcore
int ESInit2DFPPlV()
{
  static int MPlVf;	/*  .mzl_ESPlV:escPlV.c */
  static double *csPlV;	/*  .mzl_ESPlV:escPlV.c */
  static double *snPlV;	/*  .mzl_ESPlV:escPlV.c */
  static int nPlVf;	/*  .mzl_ESPlV:escPlV.c */
/*
   */
#ifdef Doc_ESInit2DFPPlV

#endif
}
int ESReInit2DFPPlV()
{
  Undef ReInitArray();
  Undef FailureAlarm();
  Undef ESexit();
  static int NPlVcs;	/*  .mzl_ESPlV:escPlV.c */
  static int nPlVcs;	/*  .mzl_ESPlV:escPlV.c */
  static double *csPlV;	/*  .mzl_ESPlV:escPlV.c */
  static double *snPlV;	/*  .mzl_ESPlV:escPlV.c */
/*
   */
#ifdef Doc_ESReInit2DFPPlV

#endif
}
int ESDeInit2DFPPlV()
{
  static int NPlVcs;	/*  .mzl_ESPlV:escPlV.c */
  static double *csPlV;	/*  .mzl_ESPlV:escPlV.c */
  static double *snPlV;	/*  .mzl_ESPlV:escPlV.c */
/*
   */
#ifdef Doc_ESDeInit2DFPPlV

#endif
}
int ESReInitPlVeq()
{
  Undef ReInitArray();
  Undef FailureAlarm();
  Undef ESexit();
  static int Neq;	/*  .mzl_ESPlV:escPlV.c */
  static int neq;	/*  .mzl_ESPlV:escPlV.c */
  static int *indx;	/*  .mzl_ESPlV:escPlV.c */
  static double *ac;	/*  .mzl_ESPlV:escPlV.c */
  static double *f;	/*  .mzl_ESPlV:escPlV.c */
/*
   */
#ifdef Doc_ESReInitPlVeq

#endif
}
int ESDeInitPlVeq()
{
  static int Neq;	/*  .mzl_ESPlV:escPlV.c */
  static double *f;	/*  .mzl_ESPlV:escPlV.c */
  static double *ac;	/*  .mzl_ESPlV:escPlV.c */
  static int *indx;	/*  .mzl_ESPlV:escPlV.c */
/*
   */
#ifdef Doc_ESDeInitPlVeq

#endif
}
#endif
#ifndef mzl_3Dcore
int ESRef2RealGeom(iT)
  int iT;	/*  */
{
  static int nAP;	/*  .mzl_2Dcore:escPlV.c */
  static double *drPlVc;/*   .mzl_ESPlV:escPlV.c */
  static double *drPlVs;/*   .mzl_ESPlV:escPlV.c */
  static double bPlV;	/*   .mzl_ESPlV:escPlV.c */
  static double *r3;	/*  .mzl_2Dcore:escPlV.c */
/*
   */
#ifdef Doc_ESRef2RealGeom

#endif
}
int ESRealGeom(iT)
  int iT;	/*  */
{
  static int nAP;	/*  .mzl_2Dcore:escPlV.c */
  /*
   */
#ifdef Doc_ESRealGeom

#endif
}
int ESReal2RefGeom(iT)
  int iT;	/*  */
{
  static double *rPlVc;	/*   .mzl_ESPlV:escPlV.c */
  static double *rPlVs;	/*   .mzl_ESPlV:escPlV.c */
  static double bPlV;	/*   .mzl_ESPlV:escPlV.c */
  static int nAP;	/*  .mzl_2Dcore:escPlV.c */
  static int MPlVf;	/*   .mzl_ESPlV:escPlV.c */
  static double *csPlV;	/*   .mzl_ESPlV:escPlV.c */
  static double *snPlV;	/*   .mzl_ESPlV:escPlV.c */
/*
   */
#ifdef Doc_ESReal2RefGeom

#endif
}
int ESEraseCoord()
{
  static int NAP;	/*  .mzl_2Dcore:escPlV.c */
  static int NPlVf;	/*   .mzl_ESPlV:escPlV.c */
  static double *rPlVc;	/*   .mzl_ESPlV:escPlV.c */
  static double *rPlVs;	/*   .mzl_ESPlV:escPlV.c */
  static double *drPlVc;/*   .mzl_ESPlV:escPlV.c */
  static double *drPlVs;/*   .mzl_ESPlV:escPlV.c */
/*
   */
#ifdef Doc_ESEraseCoord

#endif
}
int ESInit3DCoord0()
{
  Undef sqrt();
  Undef f2spl();
  Undef NULL;
  Undef SetIspl();
  Undef splR();
  int ESPlVdata2PlV();	/* No prototype */
  static int nPsrf;	/*   .mzl_ESPlV:escPlV.c */
  static double *aCr;	/*   .mzl_ESPlV:escPlV.c */
  static double *rPlVc;	/*   .mzl_ESPlV:escPlV.c */
  static double *rPlVs;	/*   .mzl_ESPlV:escPlV.c */
  static int MPlVf;	/*   .mzl_ESPlV:escPlV.c */
  static double *rCc;	/*   .mzl_ESPlV:escPlV.c */
  static double *rCs;	/*   .mzl_ESPlV:escPlV.c */
  static double bPlV;	/*   .mzl_ESPlV:escPlV.c */
  static double *rCc2a;	/*   .mzl_ESPlV:escPlV.c */
  static double *rCs2a;	/*   .mzl_ESPlV:escPlV.c */
  static int nAP;	/*  .mzl_2Dcore:escPlV.c */
  static double *csPlV;	/*   .mzl_ESPlV:escPlV.c */
  static double *snPlV;	/*   .mzl_ESPlV:escPlV.c */
  int ESPlVdata2PlV();	/*   .mzl_ESPlV:escPlV.c */
  /*
   */
#ifdef Doc_ESInit3DCoord0

#endif
}
int ESInit3DCoord()
{
  Undef sqrt();
  Undef f2spl();
  Undef NULL;
  Undef SetIspl();
  Undef splR();
  int ESPlVdata2PlV();	/* No prototype */
  static int nPsrf;	/*   .mzl_ESPlV:escPlV.c */
  static double *aCr;	/*   .mzl_ESPlV:escPlV.c */
  static int nPlVd;	/*   .mzl_ESPlV:escPlV.c */
  static double *rPlVc;	/*   .mzl_ESPlV:escPlV.c */
  static double *rPlVs;	/*   .mzl_ESPlV:escPlV.c */
  static int MPlVf;	/*   .mzl_ESPlV:escPlV.c */
  static double *rCc;	/*   .mzl_ESPlV:escPlV.c */
  static double *rCs;	/*   .mzl_ESPlV:escPlV.c */
  static double *rPlVd;	/*   .mzl_ESPlV:escPlV.c */
  static double *zPlVd;	/*   .mzl_ESPlV:escPlV.c */
  static double bPlV;	/*   .mzl_ESPlV:escPlV.c */
  static double *rCc2a;	/*   .mzl_ESPlV:escPlV.c */
  static double *rCs2a;	/*   .mzl_ESPlV:escPlV.c */
  static int nAP;	/*  .mzl_2Dcore:escPlV.c */
  static double *csPlV;	/*   .mzl_ESPlV:escPlV.c */
  static double *snPlV;	/*   .mzl_ESPlV:escPlV.c */
  static double ESBt;	/*      .mzl_PL:escPlV.c */
  int ESPlVdata2PlV();	/*   .mzl_ESPlV:escPlV.c */
  /*
   */
#ifdef Doc_ESInit3DCoord

#endif
}
#endif
#ifndef mzl_2Dcore
int ESCore2DCoord()
{
  static int MPlVf;	/*  .mzl_ESPlV:escPlV.c */
  static double *drPlVc;/*  .mzl_ESPlV:escPlV.c */
  static double *csPlV;	/*  .mzl_ESPlV:escPlV.c */
  static double *drPlVs;/*  .mzl_ESPlV:escPlV.c */
  static double *snPlV;	/*  .mzl_ESPlV:escPlV.c */
/*
   */
#ifdef Doc_ESCore2DCoord
\section{Initiation of coordinates in the core}
Corrections to the existing coordinates $r(a,\gt)$ and $z_0(a)$
\bqbl
&&
r(a,\gt)=R_0
+a^2[r_{cs,0}+\de r_{cs,0}]
+2\sum_{k=1}^{N_F}a^k\left[
(r_{cs,k}+\de r_{cs,k})\cos k\gt
+(r_{sn,k}+\de r_{sn,k})\sin k\gt
\right]
,\\&&
z=Z_0+a^2(z_0+\de z_0)+b\sin\gt
,\quad
z(a_0,\gt)=Z_X+b_x\left({d\over b_x}+{d^2z_2\over b_x^2}\right)+b\sin\gt
,\\&&
\de r_{cs,sn,k}=\de r^0_{cs,sn,k}+{1\over2}a^2\de r''_{cs,sn,k}
,\quad
\de z_0(a)=\de z^0_0+{1\over2}a^2\de z''_0
.\eqbl
Equations for corrections
\bqbl
&&
a_0^2\de r_{cs,0}
=
r_{b,cs,0}-a_0^2r_{cs,0}
,\quad
[a_0^2\de r_{cs,0}]'
=
r'_{b,cs,0}-[a_0^2r_{cs,0}]'
,\\&&
a_0^k\de r_{cs,sn,k}
=
r_{b,cs,sn,k}-a_0^kr_{cs,sn,k}
,\quad
[a_0^k\de r_{cs,sn,k}]'
=
r'_{b,cs,sn}-[a_0^kr_{cs,sn,k}]'
,\\&&
\de r^0_{cs,0}+{1\over2}a_0^2\de r''_{cs,0}
=
{r_{b,cs,0}\over a_0^2}-r_{cs,0}
,\quad
\de r''_{cs,0}
=
{r'_{b,cs,0}\over a_0^3}
-{2r_{b,cs,0}\over a_0^4}
-{r'_{cs,0}\over a_0}
,\\&&
\de r^0_{cs,sn,k}+{1\over2}a_0^2\de r''_{cs,sn,k}
=
{r_{b,cs,sn,k}\over a_0^k}
-r_{cs,sn,k}
,\quad
\de r''_{cs,sn,k}
=
{r'_{b,cs,sn}\over a_0^{k+1}}
-k{r_{b,cs,sn,k}\over a_0^{k+2}}
-{r'_{cs,sn,k}\over a_0}
,\\&&
a_0^2\de z_0
=z_{b0}-a_0^2z_0
,\quad
[a_0^2\de z_0]'
=z'_{b0}-[a_0^2z_0]'
,\\&&
\de z^0_0+{1\over2}a_0^2\de z''_0
={z_{b0}\over a_0^2}-z_0
,\quad
\de z''_0
=
{z'_{b0}\over a_0^3}
-2{z_{b0}\over a_0^4}
-{z'_0\over a_0}
.\eqbl

#endif
}
#endif
#ifndef mzl_ESPlV
int ESPlVdata2PlV()
{
  Undef ludcmp();
  Undef lubksb();
  extern double cgp;	/* undefined */
  int ESCore2DCoord();	/*  .mzl_2Dcore:escPlV.c */
/*
   */
#ifdef Doc_ESPlVdata2PlV
\section{Plasma-Vacuum interface}
Number of harmonics $m < M$ and the number of control points $K$ is 
related as 
\bqbl
&&
2M-1\geq K
.\eqbl

\subsection{Plasma boundary without X-points}
\bqbl
&&
r=r_{PlV}
+r^c_0
+2\sum_{m=1}^{m<M}\left(r^c_m\cos m\gt+r^s_m\sin m\gt\right)
,\quad
z=Z_0+b\sin\gt
.\eqbl
Equations
\bqbl
&&
r^c_0+2\sum_{m=1}^{m<M}\left(r^c_m\cos m\gt_k+r^s_m\sin m\gt_k\right)
=r_k-r_{PlV}
,\quad
\sin\gt_k={z_k-Z_0\over b}
.\eqbl
Functional for minimization
\bqbl
&&
W=\sum_{m=1}^{m<M}m^4\left({r^c_m}^2+{r^s_m}^2\right)
+2\sum_{k=0}^{k<K}\sum_{m=1}^{m<M}
  \gl_k\left(a^c_{km}r^c_m+a^s_{km}r^s_m-f_k\right)
,\\&&
f_k=r_k-r_{PlV}
,\quad
\gt_k=\arcsin{z_k-Z_0\over b}
,\quad
a^c_{km}=2\cos m\gt_k
,\quad
a^s_{km}=2\sin m\gt_k
.\eqbl

\subsection{Plasma boundary with one X-point}
\bqbl
&&
x=x_X
+\left[x^c_0+2\sum_{k=1}^L\left(x^c_k\cos k\gt+x^s_k\sin k\gt\right)\right]
\left|\sin{\gt_x-\gt\over2}\right|
+x^s_0(1-\sin\gt)
,\quad
z=Z_0+b_x\sin\gt
.\eqbl
Equations
\bqbl
&&
x^c_0+2\sum_{k=1}^L\left(x^c_k\cos k\gt_X+x^s_k\sin k\gt_X\right)=0
,\\&&
\left[x^c_0+2\sum_{k=1}^L\left(x^c_k\cos k\gt_i+x^s_k\sin k\gt_i\right)\right]
\left|\sin{\gt_x-\gt_i\over2}\right|
+x^s_0(1-\sin\gt_i)
=x_i-x_X
,\\&&
2\sum_{k=1}^Lk\left(-x^c_k\sin k\gt_X+x^s_k\cos k\gt_X\right)=
-b_x\sqrt{1+\ga_X^2+\ga_X}
,\quad
x^s_0\equiv-\ga_Xb_x
,\quad
\ga_X=0
.\eqbl
Functional for minimization
\bqbl
&&
W=\sum_{k=1}^Lk^4\left({x^c_k}^2+{x^s_k}^2\right)
+\sum_{i=1}^K\sum_{k=1}^L\gl_i\left(a^c_{ik}x^c_k+a^s_{ik}x^s_k-f_i\right)
,\quad
f_k=x_i-x_X
,\quad
\gt_i=\arcsin{z_i-Z_0\over b_x}
,\\&&
a^c_{i0}=\left|\sin{\gt_x-\gt_i\over2}\right|
,\quad
a^c_{ik}=2\cos k\gt_i\left|\sin{\gt_x-\gt_i\over2}\right|
,\quad
a^s_{i0}=1-\sin\gt_i
,\quad
a^s_{ik}=2\sin k\gt_i\left|\sin{\gt_x-\gt_i\over2}\right|
.\eqbl

\section{Plasma-Vacuum in Polar version}
Number of harmonics $m < M$ and the number of control points $K$ is 
related as 
\bqbl
&&
2M-1\geq K
.\eqbl

\subsection{Plasma boundary without X-points}
\bqbl
&&
\gr^2
=
A_0+2\sum^{m<M}_{m=1}\gr^m\left(A^c_m\cos m\gw+A^s_m\sin m\gw\right)
,\quad
r
=
R_0
+\gr\cos\gw
,\quad
z
=
Z_0+\gr\sin\gq
.\eqbl
Equations
\bqbl
&&
A_0+2\sum^{m<M}_{m=1}\gr^m\left(A^c_m\cos m\gw+A^s_m\sin m\gw\right)
=
\gr^2_k
.\eqbl
Functional for minimization
\bqbl
&&
W=\sum_{m=1}^{m<M}m^4\left({A^r_m}^2+{A^i_m}^2\right)
+2\sum_{k=0}^{k<K}\sum^{m<M}_{m=1}
  \gl_k\left(a^r_{km}A^r_m+a^i_{km}A^i_m-f_k\right)
,\\&&
f_k=\gr^2_k
,\quad
\gw_k=\arctan{z_k-Z_0\over r_k-R_0}
,\quad
a^r_{k0}=a^2
,\quad
a^r_{km}=2\gr^m_k\cos m\gw_k
,\quad
a^i_{km}=2\gr^m_k\sin m\gw_k
.\eqbl
#endif
}
int ESComprPlVacData(prD,pzD,k2)
  double *prD;	/*  */
  double *pzD;	/*  */
  int *k2;	/*  */
{
  /*
   */
#ifdef Doc_ESComprPlVacData

#endif
}
int ESCheckIntGeom()
{
  Undef abs();
  extern int ESnLm1;	/* undefined */
  static int ESLt0;	/*  .mzl_3Dcore:escPlV.c */
  static int ESNLt;	/*  .mzl_3Dcore:escPlV.c */
  static int ESNLt1;	/*  .mzl_3Dcore:escPlV.c */
  /*
   */
#ifdef Doc_ESCheckIntGeom

#endif
}
int ESInitPlGeomInt()
{
  Undef ESReInit3APTSpl();
  Undef ESInitSplAPT();
  static int NF;		/*  .mzl_2Dcore:escPlV.c */
  static int nF;		/*  .mzl_2Dcore:escPlV.c */
  static int NT;		/*  .mzl_3Dcore:escPlV.c */
  static int NtD;		/*  .mzl_3Dcore:escPlV.c */
  static int LtD;		/*  .mzl_3Dcore:escPlV.c */
  static int NA;		/*  .mzl_1Dcore:escPlV.c */
  static int NaD;		/*  .mzl_1Dcore:escPlV.c */
  static int NP;		/*  .mzl_2Dcore:escPlV.c */
  static int NpD;		/*  .mzl_2Dcore:escPlV.c */
  static int nAT;		/*  .mzl_3Dcore:escPlV.c */
  static int NAT;		/*  .mzl_3Dcore:escPlV.c */
  static int nAP;		/*  .mzl_2Dcore:escPlV.c */
  static int NAP;		/*  .mzl_2Dcore:escPlV.c */
  static int nAPT;		/*  .mzl_3Dcore:escPlV.c */
  static int NAPT;		/*  .mzl_3Dcore:escPlV.c */
  int ESReInit1FCoreInt();	/*  .mzl_2Dcore:escPlV.c */
  int ESCheck1FGeomInt();	/*  .mzl_2Dcore:escPlV.c */
  int ESReInit1TCore();		/*  .mzl_3Dcore:escPlV.c */
  int ESInit1TCore();		/*  .mzl_3Dcore:escPlV.c */
  int ESInit1FEqWaveNum();	/*  .mzl_2Dcore:escPlV.c */
  int ESReInit1ACore();		/*  .mzl_1Dcore:escPlV.c */
  int ESInit1ACore();		/*  .mzl_1Dcore:escPlV.c */
  int ESReInit1PCore();		/*  .mzl_2Dcore:escPlV.c */
  int ESInit1PCore();		/*  .mzl_2Dcore:escPlV.c */
  int ESReInit2ATCore();	/*  .mzl_3Dcore:escPlV.c */
  int ESReInit2PACore();	/*  .mzl_2Dcore:escPlV.c */
  int ESReInit3PATCore();	/*  .mzl_2Dcore:escPlV.c */
  /*
   */
#ifdef Doc_ESInitPlGeomInt

#endif
}
int ESCheckIntData()
{
  /*
   */
#ifdef Doc_ESCheckIntData

#endif
}
int ESInitPlGeom()
{
  Undef ESGetPncrAddr();
  static int ESNLt;	/*  .mzl_3Dcore:escPlV.c */
  static int nDT;	/*  .mzl_3Dcore:escPlV.c */
  static int NDT;	/*  .mzl_3Dcore:escPlV.c */
  static double *rPlVdT;/*  .mzl_3Dcore:escPlV.c */
  static double *zPlVdT;/*  .mzl_3Dcore:escPlV.c */
  static int *k2kT;	/*  .mzl_3Dcore:escPlV.c */
  static int nAP;	/*  .mzl_2Dcore:escPlV.c */
  static int nDFT;	/*  .mzl_3Dcore:escPlV.c */
  static int NDFT;	/*  .mzl_3Dcore:escPlV.c */
  int ESReInit1DPlV();	/*  .mzl_2Dcore:escPlV.c */
  int ESReInit2DTPlV();	/*  .mzl_3Dcore:escPlV.c */
  int ESInit2DTPlV();	/*  .mzl_3Dcore:escPlV.c */
  int ESRef2RealData();	/*  .mzl_3Dcore:escPlV.c */
  int ESRef2RealGeom();	/*  .mzl_3Dcore:escPlV.c */
  int ESReInit1DFPlV();	/*  .mzl_2Dcore:escPlV.c */
  int ESReInit2DFTPlV();/*  .mzl_3Dcore:escPlV.c */
  int ESReInit2DFPPlV();/*  .mzl_2Dcore:escPlV.c */
  int ESReInitPlVeq();	/*  .mzl_2Dcore:escPlV.c */
  int ESReInit2DAPrC();	/*  .mzl_2Dcore:escPlV.c */
  int ESInit2DFPPlV();	/*  .mzl_2Dcore:escPlV.c */
  int ESInit3DCoord();	/*  .mzl_3Dcore:escPlV.c */
  int ESReal2RefData();	/*  .mzl_3Dcore:escPlV.c */
  int ESReal2RefGeom();	/*  .mzl_3Dcore:escPlV.c */
/*
     Memory allocation
     Basic numbers: Lt,Nt,Np,Na
     Dependencies:
     
     
     *a,*aa,*b		:	Na,NA,NaD;
     ESReInit1ACore()	:	Na,NA
     ESInit1ACore()	:	Na,NaD
     
     *gt,*cs1,*sn1	:	Np,NP,NpD
     ESReInit1PCore()	:	Np,NP
     ESInit1PCore()	:	Np,NpD
     
     *R0T,*Z0T,*gf,*cs1T,
     *sn1T,*Z0PlVT,
     *R0PlVT		:	Lt,Nt,NT,LtD,NtD
     ESReInit1TCore()	:	Nt,NT
     ESInit1TCore()	:	Lt,Nt,NT,LtD,NtD

     *r1cT,*r1sT	:	nAT,NAT,Na,Nt
     ESReInit2ATCore()	:	nAT,NAT

     *r,*z,*r2,*z2,*dra,
     *drt,*dza,*dzt	:	nAP,NAP,Na,Np	
     ESReInit2PACore()	:	nAP,NAP
     
     *rT,*zT,*r2T,*z2T	:	nAPT,NAPT,Na,Np,Nt
     ESReInit3PATCore()	:	nAPT,NAPT

     *k2k,*rPlVd,*zPlVd	:	NPlVd,nPlVd,kPlVd
     ESInit1DPlV()	:	NPlVd,nPlVd,kPlVd
     ESReInit1DPlV()	:	NPlVd,nPlVd

     *k2kT,*rPlVdT,
     *zPlVdT		:	Nt,nPlVd,NPlVd,nPlVd,kPlVd
     ESInit2DTPlV()	:	NDT,nDT
     ESReInit2DTPlV()	:	NDT,nDT

     *rPlVc,*rPlVs,
     *drPlVc,*drPlVs	:	NPlVf,nPlVf,MPlVf
     ESReInit1DFPlV()	:	NPlVf,nPlVf

     *rPlVcT,*rPlVsT,
     *drPlVcT,*drPlVsT	:	NDFT,nDFT
     ESReInit2DFTPlV()

     *csPlV,*snPlV	:
     ESInit2DFPPlV()	:	NPlVcs,nPlVcs
     ESReInit2DFPPlV()	:	NPlVcs,nPlVcs

     *indx,*ac,*f	:	Neq,neq
     ESReInitPlVeq()	:	Neq,neq
   */
#ifdef Doc_ESInitPlGeom

#endif
}
int ESA2RefRZ()
{
  Undef ESGetgFPlV();
  Undef ESSmoothRZ();
  Undef ESCoord2Spl();
  Undef ESNormDispl();
  extern double ESgFPlV1a;	/* undefined */
  extern double ESgFPlV;	/* undefined */
  static int nAP;	/*  .mzl_2Dcore:escPlV.c */
  static int ESNLt;	/*  .mzl_3Dcore:escPlV.c */
  /*
   */
#ifdef Doc_ESA2RefRZ

#endif
}
int ESMetricTensor()
{
  /*
   */
#ifdef Doc_ESMetricTensor
\section{Metric tensor}
\bqbl
&&
D={r'_az'_\gt-r'_\gt z'_a\over a}
,\quad
r_{22}\equiv{a^2rD\over r'^2_\gt+z'^2_\gt}
,\quad
g_{22}\equiv{r'^2_\gt+z'^2_\gt\over a^2rD}
,\quad
g_{11}\equiv{r'^2_a+z'^2_a\over rD}
,\quad
g_{12}\equiv{r'_ar'\gt+z'_az'_\gt\over arD}
,\\&&
z=Z_0+a^2\bar{z}_0+{b_0a\over2}\left(-ie^{i\gt}+cc.\right)
,\quad
z'_a=(a^2\bar{z}_0)'+{b_0\over2}\left(-ie^{i\gt}+cc.\right)
,\quad
{z'_\gt\over a}={b_0\over2}\left(e^{i\gt}+cc.\right)
.\eqbl
The appropriate asymptotic of the metric coefficients near the magnetic
axis follows from the representation of $r(\gt,a)$ and $z(\gt,a)$ as 
\bqbl
&&
r
=
 R_0
+a^2\bsr^c_0
+2\sum_{k=1}^{k<N}a^k\left(\bsr^c_k\cos k\gt+\bsr^s_k\sin k\gt\right)
,\\&&
ar'_a
=
 a^2\bsr^{ca}_0
+2\sum_{k=1}^{k<N}a^k\left(\bsr^{ca}_k\cos k\gt+\bsr^{sa}_k\sin k\gt\right)
,\\&&
r'_\gt
=
2\sum_{k=1}^{K<N}a^k\left(\bsr^{c\gt}_k\cos k\gt+\bsr^{s\gt}_k\sin k\gt\right)
.\eqbl
Metrics coefficients have the representation
\bqbl
&&
g_{11}
=
 g^c_{11,0}
+2a\left(g^c_{11,1}\cos\gt+g^s_{11,1}\sin\gt\right)
+2\sum_{k=2}^{k<N}a^{k-2}\left(g^c_{11,k}\cos k\gt+g^s_{11,k}\sin k\gt\right)
,\\&&
g_{12}
=
g^c_{12,0}
+2a\left(g^c_{12,1}\cos\gt+g^s_{12,1}\sin\gt\right)
+2\sum_{k=2}^{k<N}a^{k-2}\left(g^c_{12,k}\cos k\gt+g^s_{12,k}\sin k\gt\right)
,\\&&
g_{22}=g^c_{22,0}
+2a\left(g^c_{22,1}\cos\gt+g^s_{22,1}\sin\gt\right)
+2\sum_{k=2}^{k<N}a^{k-2}\left(g^c_{22,k}\cos k\gt+g^s_{22,k}\sin k\gt\right)
,\\&&
r_{22}=r^c_{22,0}
+2a\left(r^c_{22,1}\cos\gt+r^s_{22,1}\sin\gt\right)
+2\sum_{k=2}^{k<N}a^{0,1}\left(r^c_{22,k}\cos k\gt+r^s_{22,k}\sin k\gt\right)
.\eqbl

\section{Moment equations}
Linearized Grad-Shafranov equation
\bqbl
&&
\gD^*\bgY
=
\gD\bgY
-{1\over r}\bgY'_r
=
-rDP
-{D\over r}T
-rD\gd P
-{D\over r}\gd T
-rD{P'\over\bgY'_0}\bgY_\til
-{D\over r}{T'\over\bgY'_0}\bgY_\til
\lbq{GrSh}
.\eqbl
#endif
}
#endif
#endif

#undef Doc_Cb_Structure
#ifdef Blb_escPlV.c
Blb_escPlV.c{
  mzl_ESmain{
  }
  mzl_1Dcore{
  }
  mzl_2Dcore{
  }
  mzl_3Dcore{
  }
  mzl_PL{
  }
  mzl_ESPlV{
  }
  mzl_TFC{
  }
  mzl_1Dcore{
  }
  mzl_2Dcore{
  }
  mzl_3Dcore{
  }
  mzl_2Dcore{
  }
  mzl_2Dcore{
  }
  mzl_2Dcore{
  }
  mzl_3Dcore{
  }
  mzl_2Dcore{
  }
  mzl_3Dcore{
  }
  mzl_2Dcore{
  }
  mzl_3Dcore{
  }
  mzl_2Dcore{
  }
  mzl_ESPlV{
  }
}
#endif

#undef Doc_Table_Of_Content
#ifndef Blb_escPlV.c
				PS p= 48;
#ifndef mzl_ESmain
				PS p=  1;
#endif
#ifndef mzl_1Dcore
				PS p=  1;
#endif
#ifndef mzl_2Dcore
				PS p=  1;
#endif
#ifndef mzl_3Dcore
				PS p=  1;
#endif
#ifndef mzl_PL
				PS p=  1;
#endif
#ifndef mzl_ESPlV
				PS p=  1;
#endif
#ifndef mzl_TFC
				PS p=  2;
#endif
#ifndef mzl_1Dcore
				PS p=  2;
int ESInit1ACore();		PS p=  2;
int ESReInit1ACore();		PS p=  2;
int ESDeInit1ACore();		PS p=  2;
#endif
#ifndef mzl_2Dcore
				PS p=  3;
int ESInit1PCore();		PS p=  3;
int ESReInit1PCore();		PS p=  3;
int ESDeInit1PCore();		PS p=  3;
int ESCheck1FGeomInt();		PS p=  4;
int ESInit1FCoreInt();		PS p=  4;
int ESInit1FEqWaveNum();	PS p=  5;
int ESReInit1FCoreInt();	PS p=  5;
int ESDeInit1FCoreInt();	PS p=  5;
#endif
#ifndef mzl_3Dcore
				PS p=  6;
int ESInit1TCore();		PS p=  6;
int ESReInit1TCore();		PS p=  6;
int ESDeInit1TCore();		PS p=  7;
int ESReInit2ATCore();		PS p=  7;
int ESDeInit2ATCore();		PS p=  8;
#endif
#ifndef mzl_2Dcore
				PS p=  8;
int ESReInit2PACore();		PS p=  8;
int ESDeInit2PACore();		PS p=  9;
#endif
#ifndef mzl_2Dcore
				PS p=  9;
int ESReInit3PATCore();		PS p=  9;
int ESDeInit3PATCore();		PS p= 10;
#endif
#ifndef mzl_2Dcore
				PS p= 10;
int ESInit1DPlV();		PS p= 10;
int ESReInit1DPlV();		PS p= 11;
int ESDeInit1DPlV();		PS p= 11;
int ESReInit2DAPrC();		PS p= 12;
int ESDeInit2DAPrC();		PS p= 12;
#endif
#ifndef mzl_3Dcore
				PS p= 12;
int ESRef2RealData();		PS p= 12;
int ESReal2RefData();		PS p= 13;
int ESPncr2Sort();		PS p= 13;
int ESPncr2PlVData();		PS p= 19;
int ESPncr2PlVData0();		PS p= 24;
int ESInit2DTPlV();		PS p= 28;
int ESReInit2DTPlV();		PS p= 28;
int ESDeInit2DTPlV();		PS p= 29;
#endif
#ifndef mzl_2Dcore
				PS p= 29;
int ESReInit1DFPlV();		PS p= 29;
int ESDeInit1DFPlV();		PS p= 29;
#endif
#ifndef mzl_3Dcore
				PS p= 30;
int ESReInit2DFTPlV();		PS p= 30;
int ESDeInit2DFTPlV();		PS p= 30;
#endif
#ifndef mzl_2Dcore
				PS p= 30;
int ESInit2DFPPlV();		PS p= 30;
int ESReInit2DFPPlV();		PS p= 31;
int ESDeInit2DFPPlV();		PS p= 31;
int ESReInitPlVeq();		PS p= 31;
int ESDeInitPlVeq();		PS p= 31;
#endif
#ifndef mzl_3Dcore
				PS p= 32;
int ESRef2RealGeom();		PS p= 32;
int ESRealGeom();		PS p= 34;
int ESReal2RefGeom();		PS p= 34;
int ESEraseCoord();		PS p= 35;
int ESInit3DCoord0();		PS p= 35;
int ESInit3DCoord();		PS p= 38;
#endif
#ifndef mzl_2Dcore
				PS p= 42;
int ESCore2DCoord();		PS p= 42;
#endif
#ifndef mzl_ESPlV
				PS p= 43;
int ESPlVdata2PlV();		PS p= 43;
int ESComprPlVacData();		PS p= 44;
int ESCheckIntGeom();		PS p= 45;
int ESInitPlGeomInt();		PS p= 45;
int ESCheckIntData();		PS p= 46;
int ESInitPlGeom();		PS p= 46;
int ESA2RefRZ();		PS p= 48;
int ESMetricTensor();		PS p= 49;
#endif
#endif
