#ifndef Blb_escR.c

#ifdef Doc_escR.c
\title{\bf Two-fluid ballooning equations}
\author{Leonid E. Zakharov, (\c{zakharov@pppl.gov})\\
{\em Princeton University, PPPL MS-27,}\\
{\em Forrestal Campus P.O.Box 451, Princeton NJ 08543} \\
(Started on May 5, 1994)}
\maketitle

\begin{abstract}
\end{abstract}
\tableofcontents

\section{Two-fluid ballooning equations}
Braginskii equations.
We use the following set of two-fluid equations
\bqbl
\na p
&=&
{1\over c}(\Bsj\times\BbB)
,\quad
\na p_i={n_ee\over c}(\BbV_\perp\times\BbB)
,\\
m_in_i{\pa\BbV\over\pa t}
&=&
-\na p+{1\over c}(\Bsj\times \BbB)
+{4\pi n_ee d_e^2\over c^2}{\pa\tilde{\Bsj}_\parallel\over\pa t}
,\\
-\na\gf_E-{1\over c}{\pa\tilde{\BbA}\over\pa t}
&=&
-{1\over c}(\BbV_e\times\BbB)
-{1\over n_ee}\na p_e
+{4\pi\over\gw_{pe}^2}\left(\gn_{ei}+{\pa\over\pa t}\right)
\Bsj_\parallel
,\\
{\pa p_i\over \pa t}
&=&
-(\BbV\cdot\na p_i)
-\gG_ip_i(\na\cdot\BbV)
,\quad
{\pa p_e\over \pa t}
=
-(\BbV_e\cdot\na p_e)
-\gG_ep_e(\na\cdot\BbV_e)
,\\
{\pa n_e\over \pa t}
&=&
-(\BbV\cdot\na n_e)
-n_e(\na\cdot\BbV)
=
-(\BbV_e\cdot\na n_e)
-n_e(\na\cdot\BbV_e)
,\eqbl
where notations are standard
\cite{Drake84,Diamond85,McCarthy92,Zakharov92}.  

To describe the equilibrium, we use following notations
\bqbl
&&
\bgY\equiv{\gY\over2\gp}
,\quad
\bbF\equiv rB_{tor}
,\quad
P_s\equiv{4\gp p'\over\bgY'}
,\quad
F_s\equiv{\bbF'\over\bgY'}
,\quad
v\equiv {r^2\over\bbF}
,\quad
\tsq
\equiv
-{\sqrt{g}\over r^2}{\bbF\over\bgY'}
=
q(1+\gh'_\gq)
\lbq{equil}
,\eqbl
where $\gY$ is the poloidal magnetic flux, $r$ is a cylindrical
radius. In an arbitrary axisymmetric flux coordinates $a$, $\gq$, $\gf$
($a$ is a radial coordinate, $\gq$ is the poloidal angle and $\gf$ is an
azimuth), contravariant component of the equilibrium magnetic field,
current density and the plasma velocity have the form
form
\bqbl
&&
B^i=\left\{
0,
-{\bgY'\over\sqrt{g}},
{\bbF\over r^2}
\right\}
,\quad
{4\gp\over c}j^i=\left\{
0,
-{\bbF'\over\sqrt{g}},
P_s+\bbF F_s{1\over r^2}
\right\}
,\quad
V^i=\left\{
0,
0,
{cp_i'\over n_ee\bgY'}
\right\}
.\eqbl
We introduce characteristic scale lengths of the two-fluid model as
\bqbl
&&
\gr_s^2\equiv{c_s^2\over\gW_{ci}^2}
,\quad
\gW_{ci}\equiv{ZeB\over m_ic}
,\quad
c_s^2\equiv{\gG_ep_e+\gG_ip_i\over m_in_i}
,\quad
\gw_{s}\equiv{c_s\over R}
,\quad
d_e^2\equiv{c^2\over\gw_{pe}^2}
,\quad
\Hsd^2
\equiv
d_e^2\left(1+{\gn_{ei}\over\gg}\right)
\lbq{scl}
,\eqbl
where$B$ is the the magnetic field at the magnetic axis. 

Linearized Braginskii equations are    
\bqbl
&&
m_in_i\gg\tilde{\BbV}
+\na\tsp
=
{1\over c}(\Bsj_\perp\times\BbB)
+{1\over c}(\Bsj\times\tilde{\BbB})
+{4\gp n_ee\gg d_e^2\over c^2}\tilde{\Bsj}_\parallel
,\quad
\tilde{\Bsj}
=
\Bsj_\perp
+\tilde{\Bsj}_\parallel
,\\&&
{m_i\gg\over Ze}\tilde{\BbV}
+\na\tgf
+{\gg-i\gw_{*i}\over c}\tilde{\BbA}
=
{1\over c}(\BbV_\perp\times\BbB)
+{p_i'\tsn_e-n_e'\tsp_i\over n_e^2e}\na a
-{4\gp\gn_{ei}d_e^2\over c^2}\tilde{\Bsj}_\parallel
,\\&&
(\gg-i\gw_{*i})\tsp_i
=
-p_i'\tbV^a
-\gG_ip_i(\na\cdot\tilde{\BbV})
,\\&&
(\gg-i\gw_{*e})\tsp_e
=
-p_e'\tbV_{e\perp}^a
-\gG_ep_e(\na\cdot\tilde{\BbV}_e)
,\\&&
(\gg-i\gw_{*e})\tsn_e
=
-n_e'\tbV_{e\perp}^a
-n_e(\na\cdot\tilde{\BbV}_e)
,\\&&
(\gg-i\gw_{*i})\tsn_e
=
-n_e'\tbV_\perp^a
-n_e(\na\cdot\tilde{\BbV})
.\eqbl
Here
\bqbl
&&
\tgf
\equiv
\gf_E
+{\tsp_i\over n_ee}
,\quad
i\gw_{*i}
\equiv
-\BbV\na
=
-{cp_i'\over n_ee\bgY'}{\pa\over\pa\gf}
,\quad
i\gw_{*e}
\equiv
-\BbV_e\na
=
{cp_e'\over n_ee\bgY'}{\pa\over\pa\gf}
\lbq{omp}
.\eqbl
We also define
\bqbl
&&
i\gw^n_{*i}
\equiv
-{c\gG_iT_in_i'\over n_ee\bgY'}{\pa\over\pa\gf}
,\quad
i\gw^n_{*e}
\equiv
{c\gG_eT_en_e'\over n_ee\bgY'}{\pa\over\pa\gf}
\lbq{omn}
.\eqbl
Vector potential of the perturbed magnetic field will be taken in the form
of a covariant vector
\bqbl
&&
A_i
=
\{
\tgl
,0
,\tgy
\}
,\quad
\tbB^i
=
{1\over\sqrt{g}}
\left\{
{\pa\tgy\over\pa\gq}
,{\pa\tgl\over\pa\gf}-{\pa\tgy\over\pa a}
,-{\pa\tgl\over\pa\gq}
\right\}
,\quad
{4\gp\over c}\BbB\tilde{\Bsj}_\parallel
=
-B^\gf\na^2\tgy
.\eqbl
Perturbation of the longitudinal field
\bqbl
&&
4\gp\tsp
+\BbB\tilde{\BbB}
=
0
,\quad
{\BbB^2\over\bgY'}{\pa\tgl\over\pa\gf}
=
4\gp\tsp
+{\bgY'k^a\over r^2}\tgy
.\eqbl
It follows from this
\bqbl
&&
{4\gp\over c}\tsj^a
=
{1\over\sqrt{g}}\left(
{\pa\tbB_\gf\over\pa\gq}
-{\pa\tbB_\gq\over\pa\gf}
\right)
=
{1\over\sqrt{g}B^\gq}\left(
(\BbB\cdot\na)\tbB_\gf
-B^\gf{\pa\tbB_\gf\over\pa\gf}
-B^\gq{\pa\tbB_\gq\over\pa\gf}
\right)
=
-{1\over\sqrt{g}B^\gq}{\pa\BbB\tilde{\BbB}\over\pa\gf}
,\\&&
\tsj^a
=
ne(\tbV_\perp^a-\tbV_{e\perp}^a)
=
{c\over\sqrt{g}B^\gq}{\pa\tsp\over\pa\gf}
.\eqbl
Using this for the plasma pressure perturbation we have
\bqbl
&&
\tsn_e
=
{cn_e'\over n_ee\sqrt{g}B^\gq(\gg-i\gw_{*e})}{\pa\tsp\over\pa\gf}
-{n_e'\over\gg-i\gw_{*e}}\tbV_\perp^a
-{n_e\over\gg-i\gw_{*e}}(\na\cdot\tilde{\BbV}_e)
,\\&&
\tsn_e
=
-{n_e'\over\gg-i\gw_{*i}}\tbV_\perp^a
-{n_e\over\gg-i\gw_{*i}}(\na\cdot\tilde{\BbV})
,\\&&
(\na\cdot\tilde{\BbV}_e)
=
{cn_e'\over n_e^2e\sqrt{g}B^\gq}{\pa\tsp\over\pa\gf}
+{n_e'(i\gw_{*i}-i\gw_{*e})\over n_e(\gg-i\gw_{*i})}\tbV_\perp^a
+{\gg-i\gw_{*e}\over\gg-i\gw_{*i}}(\na\cdot\tilde{\BbV})
,\\&&
\tsp_i
=
-{p_i'\over\gg-i\gw_{*i}}\tbV_\perp^a
-{\gG_ip_i\over\gg-i\gw_{*i}}(\na\cdot\tilde{\BbV})
,\\&&
\tsp_e
=
{i\gw^n_{*e}-i\gw_{*e}\over\gg-i\gw_{*e}}\tsp
+{p'i\gw^n_{*e}\over(\gg-i\gw_{*i})(\gg-i\gw_{*e})}\tbV_\perp^a
-{p_e'\over\gg-i\gw_{*e}}\tbV_\perp^a
-{\gG_ep_e\over\gg-i\gw_{*i}}(\na\cdot\tilde{\BbV})
,\\&&
\tsp_i
=
-{p_i'\over\gg-i\gw_{*i}}\tbV_\perp^a
-{\gG_ip_i\over\gg-i\gw_{*i}}(\na\cdot\tilde{\BbV})
,\\&&
\tsp
=
-{p'\over\gg-i\gw_{*i}}\tbV_\perp^a
-{m_in_ic_s^2(\gg-i\gw_{*e})\over(\gg-i\gw_{*i})(\gg-i\gw^n_{*e})}(\na\cdot\tilde{\BbV})
,\\&&
p_i'\tsn_e
-n_e'\tsp_i
=
{p_i\gG_in_e'-n_ep_i'\over\gg-i\gw_{*i}}(\na\cdot\tilde{\BbV})
.\eqbl
Thus, the perturbation of pressure can be written in the form
\bqbl
&&
\tsp
=
-{p'\over\gg-i\gw_{*i}}\tbV_\perp^a
-{\gg-i\gw_{*e}\over\gg-i\gw^n_{*e}}m_in_ic_s^2\tbX
,\quad
\tbX
\equiv
{(\na\cdot\tilde{\BbV})\over\gg-i\gw_{*i}}
.\eqbl
Plasma velocity is determined by the Ohm law
\bqbl
&&
\BbV_\perp
=
c{(\BbB\times\na\tgf)\over\BbB^2}
+(\gg-i\gw_{*i}){(\BbB\times\tilde{\BbA})\over\BbB^2}
-{cp_i'\tsn_e-cn_e'\tsp_i\over n_e^2e\BbB^2}(\BbB\times\na a)
+{m_ic\gg\over Ze}{(\BbB\times\tbV_\perp)\over\BbB^2}
,\\&&
\tbV_\perp^a
=
-{c\over\bgY'}{\pa\tgf\over\pa\gf}
-(\gg-i\gw_{*i}){g_{22}B^\gq B^\gq\tgy\over\BbB^2\bgY'}
-{m_ic\gg\over Ze}{r^2\over\bgY'}\tbV_\perp^\gf
,\\&&
\tbV_\perp^\gf
=
{c\bgY'\over r^2\BbB^2}\na a\cdot\na\tgf
-(\gg-i\gw_{*i}){g_{22}B^\gq\over\sqrt{g}\BbB^2}\tgl
+{\gw_{*i}-\gw^n_{*i}\over n}{g_{22}B^\gq B^\gq\over\BbB^2}\tbX
,\\&&
\tbV_\perp^a
=
-{c\over\bgY'}{\pa\tgf\over\pa\gf}
-(\gg-i\gw_{*i}){g_{22}B^\gq B^\gq\tgy\over\BbB^2\bgY'}
-{m_ic^2\gg\over Ze\BbB^2}\na a\cdot\na\tgf
,\quad
\tbV_\perp^a
\simeq
-{c\over\bgY'}{\pa\tgf\over\pa\gf}
,\\&&
\tbV_\perp
\simeq
c{(\BbB\times\na\tgf)\over\BbB^2}
,\\&&
\BbB\cdot(\na\times\tbV_\perp)
\simeq
c\na^2\tgf
.\eqbl
For pressure perturbation it gives
\bqbl
&&
\tsp
=
{p'\over\gg-i\gw_{*i}}{c\over\bgY'}{\pa\tgf\over\pa\gf}
+{p'g_{22}B^\gq B^\gq\over\BbB^2\bgY'}\tgy
+{\gg\over\gg-i\gw_{*i}}{m_ip'c^2\over Ze\BbB^2}\na a\cdot\na\tgf
-{\gg-i\gw_{*e}\over\gg-i\gw^n_{*e}}m_in_ic_s^2\tbX
.\eqbl
Longitudinal equation of motion and longitudinal Ohm's law
\bqbl
&&
(\gg-i\gw_{*e})B^\gf\tgy
=
-c(\BbB\cdot\na)\left(\tgf-{\tsp\over n_ee}\right)
+(\gg-i\gw_{*e})\gl_e^2B^\gf\na^2\tgy
,\quad
\gl_e^2
\equiv
{\gg+\gn_{ei}\over\gg-i\gw_{*e}}d_e^2
,\\&&
c\left(\tgf-{\tsp\over n_ee}\right)
=
{\gg-i\gw_{*e}\over\gg-i\gw_{*i}}c\tgf
+{\gg-i\gw_{*e}\over\gg-i\gw^n_{*e}}{m_icc_s^2\over Ze}\tbX
,\\&&
B^\gf\tgy
=
-(\BbB\cdot\na)
\left({c\tgf\over\gg-i\gw_{*i}}+{m_icc_s^2\over Ze}{\tbX\over\gg-i\gw^n_{*e}}\right)
+\gl_e^2B^\gf\na^2\tgy
,\\&&
{\BbB\tilde{\BbV}\over\BbB^2}
=
-{(\BbB\cdot\na)\tsp\over m_in_i\gg\BbB^2} 
+{Ze\over m_ic\BbB^2}{i\gw_{*i}-i\gw_{*e}\over\gg}B^\gf\tgy
=
-{(\BbB\cdot\na)\tsp\over m_in_i\gg\BbB^2} 
-{cnp'\over m_in_ic\BbB^2\sqrt{g}\gw}\tsq\tgy
\lbq{gle}
.\eqbl
Divergence of the plasma velocity
\bqbl
&&
\Bsg
\equiv
\left(\BbB\times\na{1\over\BbB^2}\right)
-{8\gp\over c}{\Bsj_\perp\over\BbB^2}
=
2{(\Bgk\times\BbB)\over\BbB^2}
,\\&&
(\na\cdot\tilde{\BbV}_\perp)
=
-c\Bsg\cdot\na\tgf
-{m_ic\gg\over Ze\BbB^2}c\na^2\tgf
-{4\gp p\over\BbB^2}(\na\cdot\tilde{\BbV})
-(i\gw_{*i}-i\gw^n_{*i})\tbX
,\\&&
\tbX
=
(\BbB\cdot\na){\BbB\tilde{\BbV}\over\BbB^2(\gg-i\gw_{*i})}
+{(\na\cdot\tilde{\BbV}_\perp)\over\gg-i\gw_{*i}}
.\eqbl
For divergence of the current density
\bqbl
&&
\tilde{\Bsj}
=
\Bsj_\perp-{B^\gf\na^2\tgy\over\BbB^2}\BbB
,\quad
{1\over c}\Bsj_\perp
=
{\BbB\times\na\tsp\over\BbB^2}
+m_in_i\gg{\BbB\times\tilde{\BbV}\over\BbB^2}
-{1\over c}{\BbB\times(\Bsj\times\tilde{\BbB})\over\BbB^2}
,\\&&
-(\BbB\cdot\na){B^\gf\na^2\tgy\over\BbB^2}
=
4\gp\Bsg\cdot\na\tsp
+4\gp m_in_i\gg{c\na^2\tgf\over\BbB^2}
-4\gp m_in_i\gg{c(p_i\gG_in_e'-n_ep_i')\over n_e^2e\BbB^2}(\na a\cdot\na\tbX)
.\eqbl
Two-fluid high-$n$ MHD equations
\bqbl
&&
c\tgf
\equiv
-(\gg-i\gw_{*i})\tbU
,\quad
\Bsg
\equiv
\left(\BbB\times\na{1\over\BbB^2}\right)
-{8\gp\over c}{\Bsj_\perp\over\BbB^2}
=
2{(\Bgk\times\BbB)\over\BbB^2}
,\\&&
{(\BbB\cdot\na)\over B^\gq}{\sqrt{g}B^\gq B^\gq\Bsk^2\over\BbB^2n^2}\tsq\tgy
=
-4\gp\sqrt{g}{\Bsg\cdot\Bsk\over n}{\tsp\over in}
+4\gp m_in_i\gw(\gw_{*i}-\gw)\sqrt{g}{\Bsk^2\tbU\over\BbB^2n^2}
,\\&&
{c_s^2\over\gw(\gw-\gw^n_{*e})}{(\BbB\cdot\na)\over B^\gq}{\sqrt{g}B^\gq B^\gq\over\BbB^2}
{(\BbB\cdot\na)\over B^\gq}{\tbX\over in}
+{P_s\gl_e^2\over4\gp m_in_i\gw(\gw_{*i}-\gw)}
{(\BbB\cdot\na)\over B^\gq}{\sqrt{g}B^\gq B^\gq\Bsk^2\tsq\tgy\over\BbB^2}
=
\\&&
-\sqrt{g}\left({\gw-\gw^n_{*i}\over\gw-\gw_{*i}}+{4\gp p\over\BbB^2}\right){\tbX\over in}
+\sqrt{g}{\Bsg\cdot\Bsk\over n}\tbU
-{nm_ic\gw\over Ze}{\sqrt{g}\Bsk^2\over n^2\BbB^2}\tbU
,\\&&
(1+\gl_e^2\Bsk^2)\tsq\tgy
=
{(\BbB\cdot\na)\over B^\gq}\left(\tbU
-{nm_icc_s^2\over Ze(\gw-\gw^n_{*e})}{\tbX\over in}\right)
,\\&&
{4\gp\tsp\over in}
=
P_s\tbU
-{\gw-\gw_{*e}\over\gw-\gw^n_{*e}}4\gp m_in_ic_s^2{\tbX\over in}
.\eqbl
In curvilinear coordinates, the wave vector $\na=i\Bsk$ has simple
covariant coordinates 
\bqbl
&&
ik_{a,\gq,\gf}
=
\left\{{\pa\over\pa a},{\pa\over\pa\gq},{\pa\over\pa\gf}\right\}
=
in\left\{q(s\gq+\tss),\tsq,-1\right\}
,\quad
s\equiv {q'\over q}
,\quad
\tss\equiv {q'\over q}\gh+\gh'_a
\lbq{vk}
.\eqbl
The operator $\BbB\cdot\na$
\bqbl
&&
\BbB\cdot\na=B^\gq{d\over d\gq}
.\eqbl
The Laplacian has the form
\bqbl
\na^2
&=&
-\Bsk^2
,\quad
\Bsk^2
=
{k_\gq^2\over g_{22}}
+{k_\gf^2\over r^2}
+{1\over g_{22}}
\left({g_{22}\over D}k_a-{g_{12}\over D}k_\gq\right)^2
\lbq{vk2k}
.\eqbl
With the notations
\bqbl
&&
J_0
\equiv
{a\BbB^2\over R\sqrt{g}B^\gq B^\gq}
,\quad
f
\equiv
{a^2\Bsk^2\over n^2J_0}
,\quad
{a^2\Bsk^2\over n^2}
=
fJ_0
,\quad
J_1
\equiv
{\sqrt{g}\over aR}
,\quad
J_2
\equiv
{4\gp p\over\BbB^2}
,\quad
J_3
\equiv
{B^2\over R^2B^\gq B^\gq}
,\\&&
I
\equiv
{B^2\over R^2B^\gq B^\gq}
,\quad
\gt_A^2
\equiv
{4\gp m_in_i R^2\over B^2}
,\quad
g
\equiv
{B\sqrt{g}\over2q}{\Bsg\cdot\Bsk\over n}
=
{B\sqrt{g}\over2q}{\Bsk\over n}\left(\BbB\times\na{1\over\BbB^2}\right)
-2{B\sqrt{g}\over2q}{4\gp\over c}{\Bsk\Bsj_\perp\over n\BbB^2}
,\\&&
g
=
{B\over2q}\left(\tsq v'_a
-{k_a\over n}v'_\gq
+P_s{\sqrt{g}\over\BbB^2}
+{\pa\over\pa\gq}{k_a\over n}{g_{22}B^\gq B^\gq\over B^\gf\BbB^2}
-{\pa\over\pa\gq}{g_{12}B^\gq\over\BbB^2}
\right)
,\quad
v
=
{r^2\over\bbF}
\lbq{balf}
\eqbl
the two-fluid ballooning equations can be written as
\bqbl
&&
\left[f\tsq\tgy\right]'
=
-g\left(\ga\tbU
-{2qaB\gt_A^2c_s^2\over R}{\gw-\gw_{*e}\over\gw-\gw^n_{*e}}{\tbX\over in}\right)
+\gt_A^2\gw(\gw_{*i}-\gw)If\tbU
,\quad
\ga
\equiv
{8\gp p'qaR\over\bgY'B}
,\\&&
{\gw_{s}^2\over\gw(\gw-\gw^n_{*e})}\left[{1\over J_0}{\tbX'\over in}\right]'
-{n^2\ga\gl_e^2\over2qa^2aRB\gt_A^2\gw(\gw-\gw_{*i})}(f\tsq\tgy)'
=
\\&&
-J_1\left({\gw-\gw^n_{*i}\over\gw-\gw_{*i}}+J_2\right){\tbX\over in}
+{2q\over aRB}g\tbU
-{n\gw\over\gW_{ci}B}{fJ_3\over a^2}\tbU
,\\&&
(1+\gl_e^2\Bsk^2)\tsq\tgy
=
\tbU'
-{nm_icc_s^2\over Ze(\gw-\gw^n_{*e})}{\tbX'\over in}
,\quad
1+\gl_e^2\Bsk^2
=
1+{n^2\gl_e^2\over a^2}fJ_0
,\\&&
{4\gp\tsp\over in}
=
P_s\tbU
-4\gp m_in_ic_s^2{\gw-\gw_{*e}\over\gw-\gw^n_{*e}}{\tbX\over in}
,\quad
\gw_{*i}-\gw_{*e}
=
{cn\over4\gp n_ee}P_s
\lbq{baleq}
,\eqbl
where $\ga=\ga_{CHT}$ is the Connor-Hastie-Taylor ballooning parameter
\cite{Connor78}.

Resistive equations
\bqbl
&&
\left[{f\tbU'\over1+\gl_e^2\Bsk^2}\right]'
=
-g\left(\ga\tbU
-{2qaB\gt_A^2c_s^2\over R}{\tbX\over in}\right)
+\gt_A^2\gg^2If\tbU
,\quad
\left[f\tsq\tgy\right]'
=
-gP
+\gt_A^2\gg^2If\tbU
,\\&&
{\gw_{s}^2\over\gg^2}\left[{1\over J_0}{\tbX'\over in}\right]'
-{n^2\ga\gl_e^2\over2qaRa^2\gt_A^2\gg^2B}
\left[{f\tbU'\over1+\gl_e^2\Bsk^2}\right]'
=
J_1(1+J_2){\tbX\over in}
-{2q\over aRB}g\tbU
,\\&&
\tsq\tgy
=
{\tbU'\over1+\gl_e^2\Bsk^2}
,\quad
{4\gp\tsp\over in}
=
P_s\tbU
-4\gp m_in_ic_s^2{\tbX\over in}
,\quad
P
\equiv
\ga\tbU
-{2qaB\gt_A^2c_s^2\over R}{\tbX\over in}
,\\&&
J_1(1+J_2)P
-{\gw_{s}^2\over\gg^2}\left[{P'\over J_0}\right]'
=
\ga J_1(1+J_2)\tbU
-4q^2\gt_A^2\gw_{s}^2g\tbU
-\ga{\gw_{s}^2\over\gg^2}\left[{\tsq\tgy\over J_0}\right]'
.\eqbl

\subsection{Asymptotic analysis for Ideal MHD}
For large $\gq$ two key functions $f(\gq)$ and $g(\gq)$ can be approximated as
\bqbl
&&
f
\simeq
f_2\gq^2
,\quad
g
=
g_0
+(g_1\gq)'
,\quad
F
\equiv
{1\over f_2}
,\quad
\left<g_1J_0\right>
=
0
,\eqbl
where a specific choice is made for $g_1$, which is determined with  the
accuracy of an additive constant. In the ideal case the asymptotic
solution leads to the Mercier criterion 
\bqbl
&&
(f_2\gq^2\tbU')'
=
-\ga g_0\tbU-\ga(g_1\gq)'\tbU
,\quad
\tbT'
=
-\ga\left<g_0\right>\tbU_0
+\ga\left<g_1\gq\tbU'\right>
,\quad
\tbT
\equiv
f_2\gq^2\tbU'
+\ga g_1\gq\tbU
,\\&&
\left<F\right>\tbT
=
\gq^2\tbU_0'
+\ga\left<g_1F\right>\gq\tbU_0
,\quad
\left<g_1\gq\tbU'\right>
=
\left<g_1F\right>{\tbT\over\gq}
-\ga\left<g_1^2F\right>\tbU_0
,\\&&
[\gq^2\tbU_0']'
=
-\ga\left[\left<g_0\right>\left<F\right>
+\left<g_1F\right>
+\ga\left<g_1^2F\right>\left<F\right>
-\ga\left<g_1F\right>^2
\right]\tbU_0
,\\&&
\tbU
=
\gq^\gn
,\quad
\left(\gn+{1\over2}\right)^2
=
{1\over4}
-\ga\left[\left<g_0\right>\left<F\right>
+\left<g_1F\right>
+\ga\left<g_1^2F\right>\left<F\right>
-\ga\left<g_1F\right>^2
\right]
,\\&&
D_M
\equiv
{s^2\over4}
-\ga\left[\left<g_0\right>
+{\left<g_1F\right>\over\left<F\right>}
+\ga\left<g_1^2F\right>
-{\ga\left<g_1F\right>^2\over\left<F\right>}
\right]\left<s^2F\right>
>
0
.\eqbl
At the magnetic axis as well at vanishing shear $s=0$
\bqbl
&&
D_M
=
-\ga\left[\left<g_0\right>
+\ga\left<{g_1^2\over s^2}s^2F\right>
\right]\left<s^2F\right>
>
0
.\eqbl

\subsection{Resistive asymptotic analysis}
Resistive equations
\bqbl
&&
\left[{\gq^2\tbU'\over F+\gd^2J_0\gq^2}\right]'
=
-g\left(\ga\tbU-{2qaB\gt_A^2c_s^2\over R}{\tbX\over in}\right)
+\gt_A^2\gg^2If_2\gq^2\tbU
,\quad
\gd^2
\equiv
{n^2\gl_e^2\over a^2}
,\\&&
{\gw_{s}^2\over\gg^2}\left[{1\over J_0}{\tbX'\over in}\right]'
-{\ga\gd^2\over2qaR\gt_A^2\gg^2B}
\left[{\gq^2\tbU'\over F+\gd^2J_0\gq^2}\right]'
=
J_1(1+J_2){\tbX\over in}
-{2q\over aRB}g\tbU
,\\&&
\tsq\tgy
=
{\tbU'\over1+\gd^2fJ_0}
,\quad
{4\gp\tsp\over in}
=
P_s\tbU
-4\gp m_in_ic_s^2{\tbX\over in}
.\eqbl
With a substitution
\bqbl
&&
{2qaB\gt_A^2c_s^2\over R}{\tbX\over in}
=
\tbY
\eqbl
the equations becomes
\bqbl
&&
\left[{\gq^2\tbU'\over F+\gd^2J_0\gq^2}\right]'
=
-g(\ga\tbU-\tbY)
+\gt_A^2\gg^2\left<If_2\right>\gq^2\tbU
,\\&&
\left[{\tbY'\over J_0}\right]'
-\ga\gd^2\left[{\gq^2\tbU'\over F+\gd^2J_0\gq^2}\right]'
=
{\gg^2\over\gw_{s}^2}J_1(1+J_2)\tbY
-4q^2\gt_A^2\gg^2g\tbU
\eqbl
or (neglecting $\gd\gt_A^2\gg^2$ terms)
\bqbl
&&
\left[{\gq^2\tbU'\over F+\gd^2J_0\gq^2}+g_1\gq(\ga\tbU-\tbY)\right]'
=
-g_0(\ga\tbU-\tbY)
+g_1\gq(\ga\tbU-\tbY)'
+\gt_A^2\gg^2If_2\gq^2\tbU
,\\&&
\left[{\tbY'\over J_0}\right]'
=
{\gg^2\over\gw_{s}^2}J_1(1+J_2)\tbY
-4q^2\gt_A^2\gg^2g\tbU
-\ga^2\gd^2g\tbU
+\ga\gd^2g\tbY
.\eqbl
Elimination of oscillating parts
\bqbl
&&
\tbU
=
\tbU_0
+\tbU_1
,\quad
\tbU_1
\sim
{\tbU_0\over\gq}
,\quad
\tbY
=
\tbY_1
,\quad
\tbY_1
\sim
\tbU_0\gq
,\\&&
\tbT
\equiv
{\gq^2\tbU'\over F+\gd^2J_0\gq^2}
+g_1\gq(\ga\tbU-\tbY)
,\quad
(F+\gd^2J_0\gq^2)\tbT
=
\gq^2\tbU'
+g_1(F+\gd^2J_0\gq^2)\gq(\ga\tbU-\tbY)
,\\&&
\tbT
=
{\gq^2\tbU_0'\over\left<F+\gd^2J_0\gq^2\right>}
+\left<g_1F\right>\gq{\ga\tbU_0\over\left<F+\gd^2J_0\gq^2\right>}
,\quad
\left<g_1\gq\tbU'\right>
=
\left<g_1F\right>{\tbT\over\gq}
-\left<g_1^2F+\gd^2g_1^2J_0\gq^2\right>\ga\tbU_0
,\\&&\
\tbY'
=
-(4q^2\gt_A^2\gg^2+\ga^2\gd^2)g_1J_0\gq\tbU_0
,\quad
\left<g_1\gq\tbY'\right>
=
-(4q^2\gt_A^2\gg^2+\ga^2\gd^2)\left<g_1^2J_0\right>\gq^2\tbU_0
.\eqbl
Equation for the smooth parts
\bqbl
\tbT'
&=&
-\ga\left<g_0\right>\tbU_0
+\left<g_1\gq(\ga\tbU-\tbY)'\right>
+\gt_A^2\gg^2\left<If_2\right>\gq^2\tbU_0
,\\
\left[{\gq^2\tbU_0'\over\left<F+\gd^2J_0\gq^2\right>}\right]'
&=&
-\ga\left[\left<g_0\right>
+\ga\left<g_1^2F\right>
+{\left<g_1F\right>-\ga\left<g_1F\right>^2\over\left<F+\gd^2J_0\gq^2\right>}
\right]\tbU_0
\\&&
+\ga{2\gd^2\gq^2\left<g_1F\right>\left<J_0\right>
 \over\left<F+\gd^2J_0\gq^2\right>^2}\tbU_0
+\gt_A^2\gg^2\left[\left<If_2\right>+4q^2\left<g_1^2J_0\right>\right]\gq^2\tbU_0
.\eqbl
Invariant form for Mercier criterion (without assuming the choice
of $g_1$ that $\left<g_1J_0\right>=0$) ising Glasser's \cite{Glasser76}
$D_I$, $D_R$, $E_G$, $F_G$, $H_G$ 
\bqbl
D_I
&\equiv&
\ga\left[\left<g_0\right>
 +{\left<g_1F\right>\over\left<F\right>}
 +\ga\left<g_1^2F\right>
 -\ga{\left<g_1F\right>^2\over\left<F\right>}
\right]\left<F\right>
-{1\over4}
,\\
E_G
&\equiv&
\ga\left[\left<g_0\right>
 +{\left<g_1J_0\right>\over\left<J_0\right>}
\right]\left<F\right>
,\quad
F_G
\equiv
\ga^2\left[
 \left<g_1^2F\right>
 -{\left<g_1F\right>^2\over\left<F\right>}
\right]\left<F\right>
,\quad
H_G
\equiv
\ga\left[
 {\left<g_1F\right>\over\left<F\right>}
 -{\left<g_1J_0\right>\over\left<J_0\right>}
\right]\left<F\right>
,\\
D_R
&\equiv&
\ga\left[\left<g_0\right>
 +{\left<g_1J_0\right>\over\left<J_0\right>}
 +\ga\left<g_1^2F\right>
 -\ga{\left<g_1F\right>^2\over\left<F\right>}
 +\ga\left<F\right>\left(
   {\left<g_1F\right>\over\left<F\right>}
  -{\left<g_1J_0\right>\over\left<J_0\right>}
 \right)^2
\right]\left<F\right>
.\eqbl
Mercier criterion in the Glasser form
\bqbl
&&
{D_M\over s^2}
=
-D_I
>0
,\quad
D_I
=
E_G+F_G+H_G-{1\over4}
,\quad
D_R
=
E_G+F_G+H_G^2
=
D_I+\left(H_G-{1\over2}\right)^2
.\eqbl
Resistive asymptotic equation
\bqbl
&&
\tbU_0''
=
-\gd^2{\left<J_0\right>\over\left<F\right>}D_R\tbU_0
+\gd^2{\left<J_0\right>\over\left<F\right>}\gt_A^2\gg^2
\left[\left<If_2\right>
 +4q^2\left<g_1^2J_0\right>\right]\left<F\right>\gq^2\tbU_0
,\\&&
\tbU_0
=
e^{-\gn\gq^2}
,\quad
\tbU_0'
=
-2\gn\gq e^{-\gn\gq^2}
,\quad
\tbU_0''
=
4\gn^2\gq^2e^{-\gn\gq^2}
-2\gn e^{-\gn\gq^2}
,\\&&
4\gn^2
=
\gd^2{\left<J_0\right>\over\left<F\right>}\gt_A^2\gg^2
\left[\left<If_2\right>
 +4q^2\left<g_1^2J_0\right>\right]\left<F\right>
,\quad
2\gn
=
\gd^2{\left<J_0\right>\over\left<F\right>}D_R
,\\&&
\gt_A^2\gg^2\left[\left<If_2\right>
 +4q^2\left<g_1^2J_0\right>\right]
=
\gd^2\left<J_0\right>{D_R^2\over\left<F\right>^2}
.\eqbl
\bibliography{stab}

\bibliographystyle{prsty}

#endif


#ifndef mzl_System_escR.c
#endif
#endif

#undef Doc_Cb_Structure
#ifdef Blb_escR.c
Blb_escR.c{
}
#endif

#undef Doc_Table_Of_Content
#ifndef Blb_escR.c
	PS p= -1;
#endif
