#ifndef Blb_escSpl.c
#ifdef Doc_escSpl.c
\Section{Biot-Savart magnetic field}

Vector potential of the straight section
\bqbl
\waA
=
0.1I\int_1^2{\wsi dl\over |\wsr|}
=
0.1I\wsi(F_1-F_2)
,\quad
\wsr
\equiv
(x-X)\wse_x
+(y-Y)\wse_y
+(z-Z)\wse_z
,\quad
\wsi
\equiv
{\waI\over|\waI|}
,\\
F
\equiv
-\ln[|\wsr|+(\wsr\cdot\wsi)]
,\quad
F_2
\equiv
-\ln[|\wsr|_2+(\wsr_2\cdot\wsi)]
,\quad
F_1
\equiv
-\ln[|\wsr|_1+(\wsr_1\cdot\wsi)]
.\eqbl
Magnetic field of the straight section
\bqbl
\waB
=
\na\times\waA
,\quad
\na|\wsr|
=-\wsg
\equiv
-{\wsr\over|\wsr|}
,\quad
\na(\wsr\cdot\wsi)
=-\wsi
,\\
\waB
=
0.1I\int_1^2{(\wsi\times\wsr)dl\over |\wsr|^3}
=
0.1I\left(\na\ln{|\wsr|_2+(\wsr_2\cdot\wsi)\over|\wsr|_1+(\wsr_1\cdot\wsi)}
 \times\wsi\right)
=
0.1I\left(
  {\wsi\times\wsg_2\over|\wsr|_2+(\wsr_2\cdot\wsi)}
  -{\wsi\times\wsg_1\over|\wsr|_1+(\wsr_1\cdot\wsi)}
 \right)
.\eqbl
Derivatives in cylindrical coordinates
\bqbl
x
=
r\cos\gf
,\quad
y
=
r\sin\gf
,\quad
X
=
r
,\quad
Y
=
0
,\\
{\pa\over\pa r}
=
\cos\gf{\pa\over\pa x}+\sin\gf{\pa\over\pa y}
,\quad
{\pa\over\pa\gf}
=
-r\sin\gf{\pa\over\pa x}+r\cos\gf{\pa\over\pa y}
,\\
{\pa^2\over\pa r\pa\gf}
=
-\sin\gf{\pa\over\pa x}+\cos\gf{\pa\over\pa y}
+r\cos\gf\sin\gf\left({\pa^2\over\pa y^2}-{\pa^2\over\pa x^2}\right)
+r\left(\cos^2\gf-\sin^2\gf\right){\pa\over\pa y}{\pa\over\pa x}
.\eqbl
Derivatives of cylindrical components $A_R,rA_T,A_Z$ and $B_R,B_T,B_Z$
\bqbl
A_R
=
A_X\cos\gf
+A_Y\sin\gf
,\\
A'_{Rr}
=
A'_{Xr}\cos\gf+A'_{Yr}\sin\gf
,\\
A'_{R\gf}
=
-A_X\sin\gf
+A_Y\cos\gf
+A'_{X\gf}\cos\gf
+A'_{Y\gf}\sin\gf
,\\
A''_{Rr\gf}
=
-A'_{Xr}\sin\gf
+A'_{Yr}\cos\gf
+A''_{Xr\gf}\cos\gf
+A''_{Yr\gf}\sin\gf
,\\
\\
rA_T
=
-rA_X\sin\gf+rA_Y\cos\gf
,\\
(rA_T)'_r
=
-A_X\sin\gf+A_Y\cos\gf
-rA'_{Xr}\sin\gf+rA'_{Yr}\cos\gf
,\\
(rA_T)'_\gf
=
-rA_X\cos\gf
+rA_Y\sin\gf
-rA'_{X\gf}\sin\gf
+rA'_{Y\gf}\cos\gf
,\\
(rA_T)''_{r\gf}
=
-A_X\cos\gf
+A_Y\sin\gf
-rA'_{Xr}\cos\gf
+rA'_{Yr}\sin\gf
-A'_{X\gf}\sin\gf
+A'_{Y\gf}\cos\gf
\\
-rA''_{Xr\gf}\sin\gf
+rA''_{Yr\gf}\cos\gf
,\\
\\
A_Z
=
A_Z
,\quad
A'_{Zr}
=
A'_{Zr}
,\quad
A'_{Z\gf}
=
A'_{Z\gf}
,\quad
A''_{Zr\gf}
=
A''_{Zr\gf}
,\\
\\
B_T
=
-B_X\sin\gf+B_Y\cos\gf
,\\
B'_{Tr}
=
-B'_{Xr}\sin\gf+B'_{Yr}\cos\gf
,\\
B'_{T\gf}
=
-B_X\cos\gf-B_Y\sin\gf
-B'_{X\gf}\sin\gf+B'_{Y\gf}\cos\gf
,\\
B''_{Tr\gf}
=
-B'_{Xr}\cos\gf-B'_{Yr}\sin\gf
-B''_{Xr\gf}\sin\gf+B''_{Yr\gf}\cos\gf
.\eqbl
For $\gf=0$
\bqbl
{\pa\over\pa r}
=
{\pa\over\pa x}
,\quad
{\pa\over\pa\gf}
=
r{\pa\over\pa y}
,\quad
{\pa^2\over\pa r\pa\gf}
=
{\pa\over\pa y}
+r{\pa^2\over\pa x\pa y}
.\eqbl
Derivatives of cylindrical components $A_R,rA_T,A_Z$ in rotated coordinates
\bqbl
A_R
=
A_X
,\quad
A'_{Rr}
=
A'_{Xx}
,\quad
A'_{R\gf}
=
A_Y
+rA'_{Xy}
,\quad
A''_{Rr\gf}
=
A'_{Yx}
+A'_{Xy}
+rA''_{Xxy}
,\\
\\
rA_T
=
rA_Y
,\quad
(rA_T)'_r
=
A_Y
+rA'_{Yx}
,\quad
(rA_T)'_\gf
=
-rA_X
+r^2A'_{Yy}
,\\
(rA_T)''_{r\gf}
=
-A_X
-rA'_{Xx}
+2rA'_{Yy}
+r^2A''_{Yxy}
,\\
\\
A_Z
=
A_Z
,\quad
A'_{Zr}
=
A'_{Zx}
,\quad
A'_{Z\gf}
=
rA'_{Zy}
,\quad
A''_{Zr\gf}
=
A'_{Zy}
+rA''_{Zxy}
,\\
\\
B_T
=
B_Y
,\\
B'_{Tr}
=
B'_{Yx}
,\\
B'_{T\gf}
=
-B_X
+rB'_{Yy}
,\\
B''_{Tr\gf}
=
-B'_{Xx}
+B'_{Yy}
+rB''_{Yxy}
.\eqbl

Derivatives of the $F$-function
\bqbl
F
=
F(v)
=
-\ln v
,\quad
v
\equiv
|\wsr|+(\wsr\cdot\wsi)
,\quad
F'_v
=
-{1\over v}
,\quad
F''_{vv}
=
{1\over v^2}
,\quad
F'''_{vvv}
=
-{2\over v^3}
,\quad
F''''_{vvvv}
=
{6\over v^4}
,\\
F'_i
=
-h_iF'_v
,\\
h_i
\equiv
g_i+i_i
,\\
F''_{ij}
=
h_ih_jF''_{vv}
-h'_{ij}F'_v
,\\
h'_{ij}
=
g'_{ij}
=
{g_ig_j-\gd_{ij}\over|\wsr|}
,\\
F'''_{ijk}
=
-h_ih_jh_kF'''_{vvv}
+(h'_{ik}h_j+h'_{jk}h_i+h'_{ij}h_k)F''_{vv}
-h''_{ijk}F'_v
,\\
h''_{ijk}
=
g'_{ik}{g_j\over|\wsr|}
+g'_{jk}{g_i\over|\wsr|}
+g'_{ij}{g_k\over|\wsr|}
,\\
F''''_{ijkm}
=
h_ih_jh_kh_mF''''_{vvvv}
-(h'_{im}h_jh_k+h_ih'_{jm}h_k+h_ih_jh'_{km}
  +h'_{ik}h_jh_m+h'_{jk}h_ih_m+h'_{ij}h_kh_m)F'''_{vvv}
\\
+(h''_{ikm}h_j+h'_{ik}h'_{jm}+h''_{jkm}h_i+h'_{jk}h'_{im}
  +h''_{ijm}h_k+h'_{ij}h'_{km}+h''_{ijk}h_m)F''_{vv}
-h'''_{ijkm}F'_v
,\\
h'''_{ijkm}
=
g''_{ijk}{g_m\over|\wsr|}
+g''_{ikm}{g_j\over|\wsr|}
+g''_{jkm}{g_i\over|\wsr|}
+g''_{ijm}{g_k\over|\wsr|}
+{g'_{ik}g'_{jm}\over|\wsr|}
+{g'_{jk}g'_{im}\over|\wsr|}
+{g'_{ij}g'_{km}\over|\wsr|}
.\eqbl

Necessary derivatives of the magnetic field
\bqbl
B^x
=
A'^z_y
-A'^y_z
,\quad
B'^x_x
=
A''^z_{xy}
-A''^y_{xz}
,\quad
B'^x_y
=
A''^z_{yy}
-A''^y_{yz}
,\quad
B''^x_{xy}
=
A'''^z_{xyy}
-A'''^y_{xyz}
,\\
B'^x_z
=
A''^z_{yz}
-A''^y_{zz}
,\quad
B''^x_{yz}
=
A'''^z_{yyz}
-A'''^y_{yzz}
,\quad
B''^x_{xz}
=
A'''^z_{xyz}
-A'''^y_{xzz}
,\quad
B'''^x_{xyz}
=
A''''^z_{xyyz}
-A''''^y_{xyzz}
,\\
\\
B^y
=
A'^x_z
-A'^z_x
,\quad
B'^y_x
=
A''^x_{xz}
-A''^z_{xx}
,\quad
B'^y_y
=
A''^x_{yz}
-A''^z_{xy}
,\quad
B'^y_z
=
A''^x_{zz}
-A''^z_{xz}
,\\
B''^y_{xy}
=
A'''^x_{xyz}
-A'''^z_{xxy}
,\quad
B''^y_{xz}
=
A'''^x_{xzz}
-A'''^z_{xxz}
,\quad
B''^y_{yz}
=
A'''^x_{yzz}
-A'''^z_{xyz}
,\quad
B'''^y_{xyz}
=
A''''^x_{xyzz}
-A''''^z_{xxyz}
,\\
\\
B^z
=
A'^y_x
-A'^x_y
,\quad
B'^z_x
=
A''^y_{xx}
-A''^x_{xy}
,\quad
B'^z_y
=
A''^y_{xy}
-A''^x_{yy}
,\quad
B'^z_z
=
A''^y_{xz}
-A''^x_{yz}
,\\
B''^z_{xy}
=
A'''^y_{xxy}
-A'''^x_{xyy}
,\quad
B''^z_{xz}
=
A'''^y_{xxz}
-A'''^x_{xyz}
,\quad
B''^z_{yz}
=
A'''^y_{xyz}
-A'''^x_{yyz}
,\quad
B'''^z_{xyz}
=
A''''^y_{xxyz}
-A''''^x_{xyyz}
.\eqbl

Necessary derivatives
\bqbl
A'^x_y
,\quad
A'^x_z
,\quad
A''^x_{xy}
,\quad
A''^x_{xz}
A''^x_{yy}
,\quad
A''^x_{yz}
,\quad
A''^x_{zz}
,\\
A'''^x_{xyy}
,\quad
A'''^x_{xyz}
,\quad
A'''^x_{xzz}
,\quad
A'''^x_{yyz}
,\quad
A'''^x_{yzz}
,\quad
A''''^x_{xyyz}
,\quad
A''''^x_{xyzz}
,\\
A'^y_x
,\quad
A'^y_z
,\quad
A''^y_{xx}
,\quad
A''^y_{xy}
,\quad
A''^y_{xz}
,\quad
A''^y_{yz}
,\quad
A''^y_{zz}
,\\
A'''^y_{xxy}
,\quad
A'''^y_{xxz}
,\quad
A'''^y_{xyz}
,\quad
A'''^y_{xzz}
,\quad
A'''^y_{yzz}
,\quad
A''''^y_{xxyz}
,\quad
A''''^y_{xyzz}
,\\
A'^z_x
,\quad
A'^z_y
,\quad
A''^z_{xx}
,\quad
A''^z_{xy}
,\quad
A''^z_{xz}
,\quad
A''^z_{yy}
A''^z_{yz}
,\\
A'''^z_{xxy}
,\quad
A'''^z_{xxz}
,\quad
A'''^z_{xyy}
,\quad
A'''^z_{xyz}
,\quad
A'''^z_{yyz}
,\quad
A'''^z_{xyz}
,\quad
A''''^z_{xxyz}
,\quad
A''''^z_{xyyz}
,\\
\\
F'_x
,\quad
F'_y
,\quad
F'_z
,\quad
F''_{xx}
,\quad
F''_{xy}
,\quad
F''_{xz}
,\quad
F''_{yy}
,\quad
F''_{yz}
,\quad
F''_{zz}
,\\
F'''_{xxy}
,\quad
F'''_{xxz}
,\quad
F'''_{xyy}
,\quad
F'''_{xyz}
,\quad
F'''_{xzz}
,\quad
F'''_{yyz}
,\quad
F'''_{yzz}
,\quad
F''''_{xxyz}
,\quad
F''''_{xyyz}
,\quad
F''''_{xyzz}
.\eqbl

Calculation of necessary derivatives
\bqbl
F''''_{xxyz}
=
h_xh_xh_yh_zF''''_{vvvv}
-(2h'_{xz}h_xh_y+h'_{yz}h_xh_x+2h'_{xy}h_xh_z+h'_{xx}h_yh_z)F'''_{vvv}
\\
+(2h''_{xyz}h_x+h''_{xxz}h_y+h''_{xxy}h_z+2h'_{xy}h'_{xz}+h'_{xx}h'_{yz}
  )F''_{vv}
-h'''_{xxyz}F'_v
,\\
F''''_{xyyz}
=
h_xh_yh_yh_zF''''_{vvvv}
-(h'_{xz}h_yh_y+2h'_{yz}h_xh_y+2h'_{xy}h_yh_z+h'_{yy}h_xh_z)F'''_{vvv}
\\
+(h''_{yyz}h_x+2h''_{xyz}h_y+h''_{xyy}h_z+2h'_{xy}h'_{yz}+h'_{yy}h'_{xz}
  )F''_{vv}
-h'''_{xyyz}F'_v
,\\
F''''_{xyzz}
=
h_xh_yh_zh_zF''''_{vvvv}
-(2h'_{xz}h_yh_z+2h'_{yz}h_xh_z+h'_{zz}h_xh_y+h'_{xy}h_zh_z)F'''_{vvv}
\\
+(h''_{xzz}h_y+h''_{yzz}h_x+2h''_{xyz}h_z+2h'_{xz}h'_{yz}+h'_{xy}h'_{zz}
  )F''_{vv}
-h'''_{xyzz}F'_v
,\\
h'''_{xxyz}
=
g''_{xxy}{g_z\over|\wsr|}
+2g''_{xyz}{g_x\over|\wsr|}
+g''_{xxz}{g_y\over|\wsr|}
+2{g'_{xy}g'_{xz}\over|\wsr|}
+{g'_{xx}g'_{yz}\over|\wsr|}
,\\
h'''_{xyyz}
=
g''_{xyy}{g_z\over|\wsr|}
+2g''_{xyz}{g_y\over|\wsr|}
+g''_{yyz}{g_x\over|\wsr|}
+2{g'_{xy}g'_{yz}\over|\wsr|}
+{g'_{yy}g'_{xz}\over|\wsr|}
,\\
h'''_{xyzz}
=
2g''_{xyz}{g_z\over|\wsr|}
+g''_{xzz}{g_y\over|\wsr|}
+g''_{yzz}{g_x\over|\wsr|}
+2{g'_{xz}g'_{yz}\over|\wsr|}
+{g'_{xy}g'_{zz}\over|\wsr|}
.\eqbl

\Section{Local trisplines}
3-D function
\bqbl
T
=
{\gf_1-\gf\over h_\gf}
,\quad
t
=
{\gf-\gf_0\over h_\gf}
,\quad
Y
=
{z_1-z\over h_z}
,\quad
y
=
{z-z_0\over h_z}
,\quad
X
=
{r_1-r\over h_r}
,\quad
x
=
{r-r_0\over h_r}
,\\
g(\gf,z,r)=
(3T^2-2T^3)g_0(z,r)
+(3t^2-2t^3)g_1(z,r)
+T^2th_tg'_{\gf,0}(z,r)
-t^2Th_tg'_{\gf,1}(z,r)
.\eqbl

2-D coefficients
\bqbl
g_0(z,r)
=
(3Y^2-2Y^3)g_{00}(r)
+(3y^2-2y^3)g_{01}(r)
+Y^2yh_zg'_{z,00}(r)
-y^2Yh_zg'_{z,01}(r)
,\\
g_1(z,r)
=
(3Y^2-2Y^3)g_{10}(r)
+(3y^2-2y^3)g_{11}(r)
+Y^2yh_zg'_{z,10}(r)
-y^2Yh_zg'_{z,11}(r)
,\\
g'_{\gf,0}(z,r)
=
(3Y^2-2Y^3)g'_{\gf,00}(r)
+(3y^2-2y^3)g'_{\gf,01}(r)
+Y^2yh_zg''_{\gf z,00}(r)
-y^2Yh_zg''_{\gf z,01}(r)
,\\
g'_{\gf,1}(z,r)
=
(3Y^2-2Y^3)g'_{\gf,10}(r)
+(3y^2-2y^3)g'_{\gf,11}(r)
+Y^2yh_zg''_{\gf z,10}(r)
-y^2Yh_zg''_{\gf z,11}(r)
.\eqbl

1-D coefficients
\bqbl
g_{00}(r)
=
(3X^2-2X^3)g_{000}
+(3x^2-2x^3)g_{001}
+X^2xh_xg'_{r,000}
-x^2Xh_xg'_{r,001}
,\\
g_{01}(r)
=
(3X^2-2X^3)g_{010}
+(3x^2-2x^3)g_{011}
+X^2xh_xg'_{r,010}
-x^2Xh_xg'_{r,011}
,\\
g'_{z,00}(r)
=
(3X^2-2X^3)g'_{z,000}
+(3x^2-2x^3)g'_{z,001}
+X^2xh_xg''_{zr,000}
-x^2Xh_xg''_{zr,001}
,\\
g'_{z,01}(r)
=
(3X^2-2X^3)g'_{z,010}
+(3x^2-2x^3)g'_{z,011}
+X^2xh_xg''_{zr,010}
-x^2Xh_xg''_{zr,011}
,\\
\\
g_{10}(r)
=
(3X^2-2X^3)g_{100}
+(3x^2-2x^3)g_{101}
+X^2xh_xg'_{r,100}
-x^2Xh_xg'_{r,101}
,\\
g_{11}(r)
=
(3X^2-2X^3)g_{110}
+(3x^2-2x^3)g_{111}
+X^2xh_xg'_{r,110}
-x^2Xh_xg'_{r,111}
,\\
g'_{z,10}(r)
=
(3X^2-2X^3)g'_{z,100}
+(3x^2-2x^3)g'_{z,101}
+X^2xh_xg''_{zr,100}
-x^2Xh_xg''_{zr,101}
,\\
g'_{z,11}(r)
=
(3X^2-2X^3)g'_{z,110}
+(3x^2-2x^3)g'_{z,111}
+X^2xh_xg''_{zr,110}
-x^2Xh_xg''_{zr,111}
,\\
\\
g'_{\gf,00}(r)
=
(3X^2-2X^3)g'_{\gf,000}
+(3x^2-2x^3)g'_{\gf,001}
+X^2xh_xg''_{\gf r,000}
-x^2Xh_xg''_{\gf r,001}
,\\
g'_{\gf,01}(r)
=
(3X^2-2X^3)g'_{\gf,010}
+(3x^2-2x^3)g'_{\gf,011}
+X^2xh_xg''_{\gf r,010}
-x^2Xh_xg''_{\gf r,011}
,\\
g''_{\gf z,00}(r)
=
(3X^2-2X^3)g''_{\gf z,000}
+(3x^2-2x^3)g''_{\gf z,001}
+X^2xh_xg'''_{\gf zr,000}
-x^2Xh_xg'''_{\gf zr,001}
,\\
g''_{\gf z,01}(r)
=
(3X^2-2X^3)g''_{\gf z,010}
+(3x^2-2x^3)g''_{\gf z,011}
+X^2xh_xg'''_{\gf zr,010}
-x^2Xh_xg'''_{\gf zr,011}
,\\
\\
g'_{\gf,10}(r)
=
(3X^2-2X^3)g'_{\gf,100}
+(3x^2-2x^3)g'_{\gf,101}
+X^2xh_xg''_{\gf r,100}
-x^2Xh_xg''_{\gf r,101}
,\\
g'_{\gf,11}(r)
=
(3X^2-2X^3)g'_{\gf,110}
+(3x^2-2x^3)g'_{\gf,111}
+X^2xh_xg''_{\gf r,110}
-x^2Xh_xg''_{\gf r,111}
,\\
g''_{\gf z,10}(r)
=
(3X^2-2X^3)g''_{\gf z,100}
+(3x^2-2x^3)g''_{\gf z,101}
+X^2xh_xg'''_{\gf zr,100}
-x^2Xh_xg'''_{\gf zr,101}
,\\
g''_{\gf z,11}(r)
=
(3X^2-2X^3)g''_{\gf z,110}
+(3x^2-2x^3)g''_{\gf z,111}
+X^2xh_xg'''_{\gf zr,110}
-x^2Xh_xg'''_{\gf zr,111}
.\eqbl
Necessary coefficients
\bqbl
g
,\quad
g'_\gf
,\quad
g'_z
,\quad
g'_r
,\quad
g''_{\gf z}
,\quad
g''_{\gf r}
,\quad
g''_{zr}
,\quad
g'''_{\gf zr}
.\eqbl

#endif
#ifndef mzl_System_escSpl.c
#ifdef Tbl_UnusedID
  extern double cr3;		/*                            :escSpl.c */
  extern double cr4;		/*                            :escSpl.c */
  extern double cr6;		/*                            :escSpl.c */
  extern double cr12;		/*                            :escSpl.c */
  extern double cgp_4;		/*                            :escSpl.c */
  extern double cr2gp;		/*                            :escSpl.c */
  extern double cgm0;		/*                            :escSpl.c */
  extern double crgm0;		/*                            :escSpl.c */
  extern int ESNp;		/*                            :escSpl.c */
  extern int ESNp1;		/*                            :escSpl.c */
  extern int *ESnF;		/*                            :escSpl.c */
  extern int *ESmF;		/*                            :escSpl.c */
  extern int *ESkF;		/*                            :escSpl.c */
  extern int ESNf;		/*                            :escSpl.c */
  extern int ESNf1;		/*                            :escSpl.c */
  extern int ESLt;		/*                            :escSpl.c */
  extern double *csLT;		/*                            :escSpl.c */
  extern double *snLT;		/*                            :escSpl.c */
  extern double *gfTFC;		/*                            :escSpl.c */
  extern double ITFC;		/*                            :escSpl.c */
  static int NrSpl;		/*                    .mzl_TFC:escSpl.c */
  int ESDeInitDmTFC();		/*                    .mzl_SPL:escSpl.c */
  int ESDeInitEnvTFC();		/*                    .mzl_SPL:escSpl.c */
  extern double Ax;		/*                            :escSpl.c */
  extern double Ay;		/*                            :escSpl.c */
  extern double Az;		/*                            :escSpl.c */
  extern double Bx;		/*                            :escSpl.c */
  extern double By;		/*                            :escSpl.c */
  extern double Bz;		/*                            :escSpl.c */
  void ESMFLineSplStep1();	/*                    .mzl_SPL:escSpl.c */
  int *nq;			/* .ESMFLineSplStep1().mzl_SPL:escSpl.c */
  int ESSplineArtz();		/*                    .mzl_SPL:escSpl.c */
  void ESMFLineSplStep();	/*                    .mzl_SPL:escSpl.c */
  int *nq;			/*  .ESMFLineSplStep().mzl_SPL:escSpl.c */
  int ESSpl2ArBtAtAz();		/*                    .mzl_SPL:escSpl.c */
  int ESSpl2BrBtBz();		/*                    .mzl_SPL:escSpl.c */
  int ESSpl2BrBtBzBrrBtrBzr();	/*                    .mzl_SPL:escSpl.c */
  int ESInit3DSpl();		/*                    .mzl_SPL:escSpl.c */
#endif
  Ignor void;
  Ignor int;
  Ignor char;
  Ignor NULL;
  Ignor double;
  Systm free();
  Systm printf();
  Systm sqrt();
  Systm asin();
  Systm cos();
  Systm sin();
  Systm malloc();
  Systm log();
  Systm fabs();
  Systm atan();
  Undef CLOCKS_PER_SEC;		/* undefined */
  Undef ReInitArray();		/* NO prototype */
  Undef FailureAlarm();		/* NO prototype */
  Undef ESexit();		/* NO prototype */
  Undef time();			/* NO prototype */
  Undef ctime();		/* NO prototype */
  Undef ESGetTFCAddr();		/* NO prototype */
  extern int TFCNt;		/* External */
  extern double *rTFC;		/* External */
  extern double *zTFC;		/* External */
  extern int TFCNp1;		/* External */
  extern int ESmemlev;		/* External */
  extern double *xTFC;		/* External */
  extern double *yTFC;		/* External */
  extern int TFCNp;		/* External */
  extern double cgp;		/* External */
  extern double c2gp;		/* External */
  extern int TFCLt;		/* External */
  extern int ESNt1;		/* External */
  extern int ESNt;		/* External */
  extern double *gf1T;		/* External */
  extern double *cs1T;		/* External */
  extern double *sn1T;		/* External */
  extern double ESBgf;		/* External */
  extern double cr2;		/* External */
  extern clock_t clock();	/* External() */
  extern double difftime();	/* External() */
#ifdef Tbl_ESmain
#endif
#ifdef Tbl_2Dcore
#endif
#ifdef Tbl_3Dcore
#endif
#ifdef Tbl_TFC
#endif
#ifdef Tbl_SPL
  Undef CLOCKS_PER_SEC;		/* undefined */
  Undef ReInitArray();		/* NO prototype */
  Undef FailureAlarm();		/* NO prototype */
  Undef ESexit();		/* NO prototype */
  Undef FailureAlarm();		/* NO prototype */
  Undef ESexit();		/* NO prototype */
  Undef FailureAlarm();		/* NO prototype */
  Undef ESexit();		/* NO prototype */
  Undef ReInitArray();		/* NO prototype */
  Undef FailureAlarm();		/* NO prototype */
  Undef ESexit();		/* NO prototype */
  Undef time();			/* NO prototype */
  Undef ctime();		/* NO prototype */
  Undef ESGetTFCAddr();		/* NO prototype */
  extern int TFCNt;		/* External() */
  extern double *rTFC;		/* External() */
  extern double *zTFC;		/* External() */
  extern int TFCNp1;		/* External() */
  extern int TFCNt;		/* External() */
  extern int ESmemlev;		/* External() */
  extern int TFCNt;		/* External() */
  extern int TFCNp1;		/* External() */
  extern double *zTFC;		/* External() */
  extern double *xTFC;		/* External() */
  extern double *yTFC;		/* External() */
  extern int TFCNp;		/* External() */
  extern double *rTFC;		/* External() */
  extern double cgp;		/* External() */
  extern double c2gp;		/* External() */
  extern int TFCLt;		/* External() */
  extern int TFCNt;		/* External() */
  extern int TFCNp1;		/* External() */
  extern double *zTFC;		/* External() */
  extern double *xTFC;		/* External() */
  extern double *yTFC;		/* External() */
  extern int TFCNp;		/* External() */
  extern double *rTFC;		/* External() */
  extern double cgp;		/* External() */
  extern double c2gp;		/* External() */
  extern int TFCLt;		/* External() */
  extern int ESNt1;		/* External() */
  extern int ESNt;		/* External() */
  extern double *gf1T;		/* External() */
  extern double *cs1T;		/* External() */
  extern double *sn1T;		/* External() */
  extern int ESNt1;		/* External() */
  extern int ESNt1;		/* External() */
  extern int ESNt1;		/* External() */
  extern int TFCNt;		/* External() */
  extern int TFCLt;		/* External() */
  extern int ESmemlev;		/* External() */
  extern int ESNt;		/* External() */
  extern double *cs1T;		/* External() */
  extern double *sn1T;		/* External() */
  extern int TFCLt;		/* External() */
  extern int TFCNt;		/* External() */
  extern double *xTFC;		/* External() */
  extern double *yTFC;		/* External() */
  extern double *zTFC;		/* External() */
  extern int TFCNp1;		/* External() */
  extern int ESNt;		/* External() */
  extern double c2gp;		/* External() */
  extern int ESNt;		/* External() */
  extern double ESBgf;		/* External() */
  extern double ESBgf;		/* External() */
  extern double *gf1T;		/* External() */
  extern int ESNt;		/* External() */
  extern double *gf1T;		/* External() */
  extern int ESNt;		/* External() */
  extern int TFCNt;		/* External() */
  extern int TFCLt;		/* External() */
  extern int TFCNp1;		/* External() */
  extern int ESNt1;		/* External() */
  extern double *rTFC;		/* External() */
  extern double *zTFC;		/* External() */
  extern double cr2;		/* External() */
  extern int ESNt;		/* External() */
  extern double *gf1T;		/* External() */
  extern double cgp;		/* External() */
  extern double c2gp;		/* External() */
  extern double *xTFC;		/* External() */
  extern double *yTFC;		/* External() */
  extern clock_t clock();	/* External */
  extern double difftime();	/* External */
  static time_t sTime2;		/*  .mzl_ESmain:escSpl.c */
  static time_t sTime1;		/*  .mzl_ESmain:escSpl.c */
  static double Rmn;		/*     .mzl_TFC:escSpl.c */
  static double Rmx;		/*     .mzl_TFC:escSpl.c */
  static double Zmn;		/*     .mzl_TFC:escSpl.c */
  static double Zmx;		/*     .mzl_TFC:escSpl.c */
  static int *jRmnTFC;		/*     .mzl_TFC:escSpl.c */
  static int *jRmxTFC;		/*     .mzl_TFC:escSpl.c */
  static int *jZmnTFC;		/*     .mzl_TFC:escSpl.c */
  static int *jZmxTFC;		/*     .mzl_TFC:escSpl.c */
  static int NDm;		/*     .mzl_TFC:escSpl.c */
  static double *x1TFC;		/*     .mzl_TFC:escSpl.c */
  static double *x2TFC;		/*     .mzl_TFC:escSpl.c */
  static double *y1TFC;		/*     .mzl_TFC:escSpl.c */
  static double *y2TFC;		/*     .mzl_TFC:escSpl.c */
  static double *r1TFC;		/*     .mzl_TFC:escSpl.c */
  static double *r2TFC;		/*     .mzl_TFC:escSpl.c */
  static double *gf1TFC;	/*     .mzl_TFC:escSpl.c */
  static double *gf2TFC;	/*     .mzl_TFC:escSpl.c */
  static double *zEnv;		/*     .mzl_TFC:escSpl.c */
  static int nzSpl1;		/*     .mzl_TFC:escSpl.c */
  static double dzSpl;		/*     .mzl_TFC:escSpl.c */
  static double *r1Env;		/*     .mzl_TFC:escSpl.c */
  static double *r2Env;		/*     .mzl_TFC:escSpl.c */
  static int **Nr1Spl;		/*     .mzl_TFC:escSpl.c */
  static int **Nr2Spl;		/*     .mzl_TFC:escSpl.c */
  static double drSpl;		/*     .mzl_TFC:escSpl.c */
  static int *Nz1Spl;		/*     .mzl_TFC:escSpl.c */
  static int nzSpl;		/*     .mzl_TFC:escSpl.c */
  static int *Nz2Spl;		/*     .mzl_TFC:escSpl.c */
  static int SplNt;		/*     .mzl_TFC:escSpl.c */
  static int *SplNz;		/*     .mzl_TFC:escSpl.c */
  static int ***k2kSpl;		/*     .mzl_TFC:escSpl.c */
  static int SplN;		/*     .mzl_TFC:escSpl.c */
  static double *BZrtz;		/*     .mzl_TFC:escSpl.c */
  static double *BZtz;		/*     .mzl_TFC:escSpl.c */
  static double *BZrz;		/*     .mzl_TFC:escSpl.c */
  static double *BZrt;		/*     .mzl_TFC:escSpl.c */
  static double *BZz;		/*     .mzl_TFC:escSpl.c */
  static double *BZt;		/*     .mzl_TFC:escSpl.c */
  static double *BZr;		/*     .mzl_TFC:escSpl.c */
  static double *BZ;		/*     .mzl_TFC:escSpl.c */
  static double *BTrtz;		/*     .mzl_TFC:escSpl.c */
  static double *BTtz;		/*     .mzl_TFC:escSpl.c */
  static double *BTrz;		/*     .mzl_TFC:escSpl.c */
  static double *BTrt;		/*     .mzl_TFC:escSpl.c */
  static double *BTz;		/*     .mzl_TFC:escSpl.c */
  static double *BTt;		/*     .mzl_TFC:escSpl.c */
  static double *BTr;		/*     .mzl_TFC:escSpl.c */
  static double *BT;		/*     .mzl_TFC:escSpl.c */
  static double *BRrtz;		/*     .mzl_TFC:escSpl.c */
  static double *BRtz;		/*     .mzl_TFC:escSpl.c */
  static double *BRrz;		/*     .mzl_TFC:escSpl.c */
  static double *BRrt;		/*     .mzl_TFC:escSpl.c */
  static double *BRz;		/*     .mzl_TFC:escSpl.c */
  static double *BRt;		/*     .mzl_TFC:escSpl.c */
  static double *BRr;		/*     .mzl_TFC:escSpl.c */
  static double *BR;		/*     .mzl_TFC:escSpl.c */
  static double *AZrtz;		/*     .mzl_TFC:escSpl.c */
  static double *AZtz;		/*     .mzl_TFC:escSpl.c */
  static double *AZrz;		/*     .mzl_TFC:escSpl.c */
  static double *AZrt;		/*     .mzl_TFC:escSpl.c */
  static double *AZz;		/*     .mzl_TFC:escSpl.c */
  static double *AZt;		/*     .mzl_TFC:escSpl.c */
  static double *AZr;		/*     .mzl_TFC:escSpl.c */
  static double *AZ;		/*     .mzl_TFC:escSpl.c */
  static double *ATrtz;		/*     .mzl_TFC:escSpl.c */
  static double *ATtz;		/*     .mzl_TFC:escSpl.c */
  static double *ATrz;		/*     .mzl_TFC:escSpl.c */
  static double *ATrt;		/*     .mzl_TFC:escSpl.c */
  static double *ATz;		/*     .mzl_TFC:escSpl.c */
  static double *ATt;		/*     .mzl_TFC:escSpl.c */
  static double *ATr;		/*     .mzl_TFC:escSpl.c */
  static double *AT;		/*     .mzl_TFC:escSpl.c */
  static double *ARrtz;		/*     .mzl_TFC:escSpl.c */
  static double *ARtz;		/*     .mzl_TFC:escSpl.c */
  static double *ARrz;		/*     .mzl_TFC:escSpl.c */
  static double *ARrt;		/*     .mzl_TFC:escSpl.c */
  static double *ARz;		/*     .mzl_TFC:escSpl.c */
  static double *ARt;		/*     .mzl_TFC:escSpl.c */
  static double *ARr;		/*     .mzl_TFC:escSpl.c */
  static double *AR;		/*     .mzl_TFC:escSpl.c */
  static double *rSpl;		/*     .mzl_TFC:escSpl.c */
  static double *zSpl;		/*     .mzl_TFC:escSpl.c */
  static double *ySpl;		/*     .mzl_TFC:escSpl.c */
  static double *xSpl;		/*     .mzl_TFC:escSpl.c */
  static int NzSpl;		/*     .mzl_TFC:escSpl.c */
  static double *x1Env;		/*     .mzl_TFC:escSpl.c */
  static double *x2Env;		/*     .mzl_TFC:escSpl.c */
  static double *y1Env;		/*     .mzl_TFC:escSpl.c */
  static double *y2Env;		/*     .mzl_TFC:escSpl.c */
  static double *csL;		/*     .mzl_TFC:escSpl.c */
  static double *snL;		/*     .mzl_TFC:escSpl.c */
  int irCell;			/*     .mzl_TFC:escSpl.c */
  int ktCell;			/*     .mzl_TFC:escSpl.c */
  int jzCell;			/*     .mzl_TFC:escSpl.c */
  static double r1Cell;		/*     .mzl_TFC:escSpl.c */
  static double rCell;		/*     .mzl_TFC:escSpl.c */
  static double t1Cell;		/*     .mzl_TFC:escSpl.c */
  static double tCell;		/*     .mzl_TFC:escSpl.c */
  static double dtSpl;		/*     .mzl_TFC:escSpl.c */
  static double z1Cell;		/*     .mzl_TFC:escSpl.c */
  static double zCell;		/*     .mzl_TFC:escSpl.c */
  int J000;			/*     .mzl_TFC:escSpl.c */
  int J100;			/*     .mzl_TFC:escSpl.c */
  int J001;			/*     .mzl_TFC:escSpl.c */
  int J101;			/*     .mzl_TFC:escSpl.c */
  int J010;			/*     .mzl_TFC:escSpl.c */
  int J110;			/*     .mzl_TFC:escSpl.c */
  int J011;			/*     .mzl_TFC:escSpl.c */
  int J111;			/*     .mzl_TFC:escSpl.c */
  static double rhrCell;	/*     .mzl_TFC:escSpl.c */
  static double Pr0;		/*     .mzl_TFC:escSpl.c */
  static double Pr1;		/*     .mzl_TFC:escSpl.c */
  static double Pr2;		/*     .mzl_TFC:escSpl.c */
  static double Pr3;		/*     .mzl_TFC:escSpl.c */
  static double rhtCell;	/*     .mzl_TFC:escSpl.c */
  static double Pt0;		/*     .mzl_TFC:escSpl.c */
  static double Pt1;		/*     .mzl_TFC:escSpl.c */
  static double Pt2;		/*     .mzl_TFC:escSpl.c */
  static double Pt3;		/*     .mzl_TFC:escSpl.c */
  static double rhzCell;	/*     .mzl_TFC:escSpl.c */
  static double Pz0;		/*     .mzl_TFC:escSpl.c */
  static double Pz1;		/*     .mzl_TFC:escSpl.c */
  static double Pz2;		/*     .mzl_TFC:escSpl.c */
  static double Pz3;		/*     .mzl_TFC:escSpl.c */
  static double dPr1;		/*     .mzl_TFC:escSpl.c */
  static double dPr0;		/*     .mzl_TFC:escSpl.c */
  static double dPr2;		/*     .mzl_TFC:escSpl.c */
  static double dPr3;		/*     .mzl_TFC:escSpl.c */
  static double dPt1;		/*     .mzl_TFC:escSpl.c */
  static double dPt0;		/*     .mzl_TFC:escSpl.c */
  static double dPt2;		/*     .mzl_TFC:escSpl.c */
  static double dPt3;		/*     .mzl_TFC:escSpl.c */
  static double dPz1;		/*     .mzl_TFC:escSpl.c */
  static double dPz0;		/*     .mzl_TFC:escSpl.c */
  static double dPz2;		/*     .mzl_TFC:escSpl.c */
  static double dPz3;		/*     .mzl_TFC:escSpl.c */
  static int TFCNt1;		/*     .mzl_TFC:escSpl.c */
  static double *gf0TFC;	/*     .mzl_TFC:escSpl.c */
  static double *gfL;		/*     .mzl_TFC:escSpl.c */
  static int nTP;		/*     .mzl_TFC:escSpl.c */
  static int nrSpl1;		/*     .mzl_TFC:escSpl.c */
  static int nrSpl;		/*     .mzl_TFC:escSpl.c */
#endif
#endif
#ifndef mzl_ESmain
extern double cr2;		/* undefined */
extern double cr3;		/* undefined */
extern double cr4;		/* undefined */
extern double cr6;		/* undefined */
extern double cr12;		/* undefined */
extern double cgp;		/* undefined */
extern double c2gp;		/* undefined */
extern double cgp_4;		/* undefined */
extern double cr2gp;		/* undefined */
extern double cgm0;		/* undefined */
extern double crgm0;		/* undefined */
extern int ESmemlev;		/* undefined */
extern double difftime();	/* undefined */
extern clock_t clock();		/* undefined */
static time_t sTime1;		/*  */
static time_t sTime2;		/*  */
#endif
#ifndef mzl_2Dcore
extern int ESNp;	/* undefined */
extern int ESNp1;	/* undefined */
extern int *ESnF;	/* undefined */
extern int *ESmF;	/* undefined */
extern int *ESkF;	/* undefined */
extern int ESNf;	/* undefined */
extern int ESNf1;	/* undefined */
#endif
#ifndef mzl_3Dcore
extern int ESLt;	/* undefined */
extern int ESNt;	/* undefined */
extern int ESNt1;	/* undefined */
extern double *gf1T;	/* undefined */
extern double *csLT;	/* undefined */
extern double *snLT;	/* undefined */
extern double *cs1T;	/* undefined */
extern double *sn1T;	/* undefined */
#endif
#ifndef mzl_TFC
extern int TFCLt;	/* undefined */
extern int TFCNt;	/* undefined */
extern int TFCNp;	/* undefined */
extern int TFCNp1;	/* undefined */
extern double *xTFC;	/* undefined */
extern double *yTFC;	/* undefined */
extern double *zTFC;	/* undefined */
extern double *gfTFC;	/* undefined */
extern double *rTFC;	/* undefined */
extern double ITFC;	/* undefined */
static double *gfL;	/*  */
static double *csL;	/*  */
static double *snL;	/*  */
static int nTP;		/*  */
static int TFCNt1;	/*  */
static double Rmn;	/*  */
static double Rmx;	/*  */
static double Zmn;	/*  */
static double Zmx;	/*  */
static double *gf0TFC;	/*  */
static double *x1TFC;	/*  */
static double *x2TFC;	/*  */
static double *y1TFC;	/*  */
static double *y2TFC;	/*  */
static double *r1TFC;	/*  */
static double *r2TFC;	/*  */
static double *gf1TFC;	/*  */
static double *gf2TFC;	/*  */
static int *jRmnTFC;	/*  */
static int *jRmxTFC;	/*  */
static int *jZmnTFC;	/*  */
static int *jZmxTFC;	/*  */
static int NDm;		/*  */
static double *x1Env;	/*  */
static double *x2Env;	/*  */
static double *y1Env;	/*  */
static double *y2Env;	/*  */
static double *zEnv;	/*  */
static double *r1Env;	/*  */
static double *r2Env;	/*  */
static double drSpl;	/*  */
static double dtSpl;	/*  */
static double dzSpl;	/*  */
static double rCell;	/*  */
static double r1Cell;	/*  */
static double tCell;	/*  */
static double t1Cell;	/*  */
static double zCell;	/*  */
static double z1Cell;	/*  */
static double rhrCell;	/*  */
static double rhtCell;	/*  */
static double rhzCell;	/*  */
int irCell;		/*  */
int ktCell;		/*  */
int jzCell;		/*  */
int J000;		/*  */
int J100;		/*  */
int J010;		/*  */
int J001;		/*  */
int J110;		/*  */
int J101;		/*  */
int J011;		/*  */
int J111;		/*  */
static double Pr0;	/*  */
static double Pr1;	/*  */
static double Pr2;	/*  */
static double Pr3;	/*  */
static double dPr0;	/*  */
static double dPr1;	/*  */
static double dPr2;	/*  */
static double dPr3;	/*  */
static double Pt0;	/*  */
static double Pt1;	/*  */
static double Pt2;	/*  */
static double Pt3;	/*  */
static double dPt0;	/*  */
static double dPt1;	/*  */
static double dPt2;	/*  */
static double dPt3;	/*  */
static double Pz0;	/*  */
static double Pz1;	/*  */
static double Pz2;	/*  */
static double Pz3;	/*  */
static double dPz0;	/*  */
static double dPz1;	/*  */
static double dPz2;	/*  */
static double dPz3;	/*  */
static int SplNt;	/*  */
static int *SplNz;	/*  */
static int SplN;	/*  */
static int **Nr1Spl;	/*  */
static int **Nr2Spl;	/*  */
static int *Nz1Spl;	/*  */
static int *Nz2Spl;	/*  */
static int NrSpl;	/*  */
static int NzSpl;	/*  */
static int nrSpl;	/*  */
static int nzSpl;	/*  */
static int nrSpl1;	/*  */
static int nzSpl1;	/*  */
static int ***k2kSpl;	/*  */
static double *xSpl;	/*  */
static double *ySpl;	/*  */
static double *zSpl;	/*  */
static double *rSpl;	/*  */
static double *AR;	/*  */
static double *ARr;	/*  */
static double *ARt;	/*  */
static double *ARz;	/*  */
static double *ARrt;	/*  */
static double *ARrz;	/*  */
static double *ARtz;	/*  */
static double *ARrtz;	/*  */
static double *AT;	/*  */
static double *ATr;	/*  */
static double *ATt;	/*  */
static double *ATz;	/*  */
static double *ATrt;	/*  */
static double *ATrz;	/*  */
static double *ATtz;	/*  */
static double *ATrtz;	/*  */
static double *AZ;	/*  */
static double *AZr;	/*  */
static double *AZt;	/*  */
static double *AZz;	/*  */
static double *AZrt;	/*  */
static double *AZrz;	/*  */
static double *AZtz;	/*  */
static double *AZrtz;	/*  */
static double *BR;	/*  */
static double *BRr;	/*  */
static double *BRt;	/*  */
static double *BRz;	/*  */
static double *BRrt;	/*  */
static double *BRrz;	/*  */
static double *BRtz;	/*  */
static double *BRrtz;	/*  */
static double *BT;	/*  */
static double *BTr;	/*  */
static double *BTt;	/*  */
static double *BTz;	/*  */
static double *BTrt;	/*  */
static double *BTrz;	/*  */
static double *BTtz;	/*  */
static double *BTrtz;	/*  */
static double *BZ;	/*  */
static double *BZr;	/*  */
static double *BZt;	/*  */
static double *BZz;	/*  */
static double *BZrt;	/*  */
static double *BZrz;	/*  */
static double *BZtz;	/*  */
static double *BZrtz;	/*  */
#endif
#ifndef mzl_SPL
int ESInitDmTFC()
{
  extern int TFCNt;	/* undefined */
  extern double *rTFC;	/* undefined */
  extern double *zTFC;	/* undefined */
  extern int TFCNp1;	/* undefined */
  static double Rmn;	/*  .mzl_TFC:escSpl.c */
  static double Rmx;	/*  .mzl_TFC:escSpl.c */
  static double Zmn;	/*  .mzl_TFC:escSpl.c */
  static double Zmx;	/*  .mzl_TFC:escSpl.c */
  static int *jRmnTFC;	/*  .mzl_TFC:escSpl.c */
  static int *jRmxTFC;	/*  .mzl_TFC:escSpl.c */
  static int *jZmnTFC;	/*  .mzl_TFC:escSpl.c */
  static int *jZmxTFC;	/*  .mzl_TFC:escSpl.c */
/*
   */
#ifdef Doc_ESInitDmTFC
\section{Skeleton of ESInitDmTFC()}
  \begin{verbatim}
    ESInitDmTFC(){
    }
  \end{verbatim}
\section{ESInitDmTFC()}
\c{ESInitDmTFC()} calculates arrays of indexes
\c{*jRmnTFC,*jRmxTFC,*jZmnTFC,*jZmxTFC} which for each TFC specify
indexes of grid points determining size of TFC.
#endif
}
int ESReInitDmTFC()
{
  Undef ReInitArray();
  Undef FailureAlarm();
  Undef ESexit();
  extern int ESmemlev;	/* undefined */
  static int NDm;	/*  .mzl_TFC:escSpl.c */
  static int *jRmnTFC;	/*  .mzl_TFC:escSpl.c */
  static int *jRmxTFC;	/*  .mzl_TFC:escSpl.c */
  static int *jZmnTFC;	/*  .mzl_TFC:escSpl.c */
  static int *jZmxTFC;	/*  .mzl_TFC:escSpl.c */
/*
   */
#ifdef Doc_ESReInitDmTFC
\section{Skeleton of ESReInitDmTFC()}
  \begin{verbatim}
    ESReInitDmTFC(){
    }
  \end{verbatim}
\section{ESReInitDmTFC()}

#endif
}
int ESDeInitDmTFC()
{
  static int NDm;	/*  .mzl_TFC:escSpl.c */
  static int *jZmxTFC;	/*  .mzl_TFC:escSpl.c */
  static int *jZmnTFC;	/*  .mzl_TFC:escSpl.c */
  static int *jRmxTFC;	/*  .mzl_TFC:escSpl.c */
  static int *jRmnTFC;	/*  .mzl_TFC:escSpl.c */
/*
   */
#ifdef Doc_ESDeInitDmTFC
\section{Skeleton of ESDeInitDmTFC()}
  \begin{verbatim}
    ESDeInitDmTFC(){
    }
  \end{verbatim}
\section{ESDeInitDmTFC()}

#endif
}
int ESInitEnvTFC(z)
  double z;	/* z of the plane */
{
  extern double *xTFC;	/* undefined */
  extern double *yTFC;	/* undefined */
  extern int TFCNp;	/* undefined */
  extern double cgp;	/* undefined */
  extern double c2gp;	/* undefined */
  extern int TFCLt;	/* undefined */
  static int *jZmnTFC;	/*  .mzl_TFC:escSpl.c */
  static int *jZmxTFC;	/*  .mzl_TFC:escSpl.c */
  static double *x1TFC;	/*  .mzl_TFC:escSpl.c */
  static double *x2TFC;	/*  .mzl_TFC:escSpl.c */
  static double *y1TFC;	/*  .mzl_TFC:escSpl.c */
  static double *y2TFC;	/*  .mzl_TFC:escSpl.c */
  static double *r1TFC;	/*  .mzl_TFC:escSpl.c */
  static double *r2TFC;	/*  .mzl_TFC:escSpl.c */
  static double *gf1TFC;/*  .mzl_TFC:escSpl.c */
  static double *gf2TFC;/*  .mzl_TFC:escSpl.c */
  static double *zEnv;	/*  .mzl_TFC:escSpl.c */
/*
   */
#ifdef Doc_ESInitEnvTFC
\section{Skeleton of ESInitEnvTFC()}
  \begin{verbatim}
    ESInitEnvTFC(){
    }
  \end{verbatim}
\section{ESInitEnvTFC()}
  \begin{verbatim}
  Input{
    *jZmnTFC;
    *jZmxTFC;
  }
  Output{
    *x1TFC;
    *x2TFC;
    *y1TFC;
    *y2TFC;
    *r1TFC;
    *r2TFC;
    *gf1TFC;
    *gf2TFC;
    *zEnv;
  }
  \end{verbatim}
\c{ESInitEnvTFC()} calculates coordinates of 2 points of intersection
between each TFC and a given horizontal plane $z=const$. 

#endif
}
int ESInitSplGrid()
{
  Undef FailureAlarm();
  Undef ESexit();
  extern int ESNt1;	/* undefined */
  extern int ESNt;	/* undefined */
  extern double *gf1T;	/* undefined */
  extern double *cs1T;	/* undefined */
  extern double *sn1T;	/* undefined */
  static int nzSpl1;	/*  .mzl_TFC:escSpl.c */
  static double Zmn;	/*  .mzl_TFC:escSpl.c */
  static double dzSpl;	/*  .mzl_TFC:escSpl.c */
  static int *jZmnTFC;	/*  .mzl_TFC:escSpl.c */
  static int *jZmxTFC;	/*  .mzl_TFC:escSpl.c */
  static double *x1TFC;	/*  .mzl_TFC:escSpl.c */
  static double *x2TFC;	/*  .mzl_TFC:escSpl.c */
  static double *y1TFC;	/*  .mzl_TFC:escSpl.c */
  static double *y2TFC;	/*  .mzl_TFC:escSpl.c */
  static double *r1TFC;	/*  .mzl_TFC:escSpl.c */
  static double *r2TFC;	/*  .mzl_TFC:escSpl.c */
  static double *gf1TFC;/*  .mzl_TFC:escSpl.c */
  static double *gf2TFC;/*  .mzl_TFC:escSpl.c */
  static double *r1Env;	/*  .mzl_TFC:escSpl.c */
  static double Rmn;	/*  .mzl_TFC:escSpl.c */
  static double *r2Env;	/*  .mzl_TFC:escSpl.c */
  static double Rmx;	/*  .mzl_TFC:escSpl.c */
  static int **Nr1Spl;	/*  .mzl_TFC:escSpl.c */
  static int **Nr2Spl;	/*  .mzl_TFC:escSpl.c */
  static double *zEnv;	/*  .mzl_TFC:escSpl.c */
  static double drSpl;	/*  .mzl_TFC:escSpl.c */
  static int *Nz1Spl;	/*  .mzl_TFC:escSpl.c */
  static int nzSpl;	/*  .mzl_TFC:escSpl.c */
  static int *Nz2Spl;	/*  .mzl_TFC:escSpl.c */
  static int SplNt;	/*  .mzl_TFC:escSpl.c */
  static int *SplNz;	/*  .mzl_TFC:escSpl.c */
  static int ***k2kSpl;	/*  .mzl_TFC:escSpl.c */
  static int SplN;	/*  .mzl_TFC:escSpl.c */
  static double *BZrtz;	/*  .mzl_TFC:escSpl.c */
  static double *BZtz;	/*  .mzl_TFC:escSpl.c */
  static double *BZrz;	/*  .mzl_TFC:escSpl.c */
  static double *BZrt;	/*  .mzl_TFC:escSpl.c */
  static double *BZz;	/*  .mzl_TFC:escSpl.c */
  static double *BZt;	/*  .mzl_TFC:escSpl.c */
  static double *BZr;	/*  .mzl_TFC:escSpl.c */
  static double *BZ;	/*  .mzl_TFC:escSpl.c */
  static double *BTrtz;	/*  .mzl_TFC:escSpl.c */
  static double *BTtz;	/*  .mzl_TFC:escSpl.c */
  static double *BTrz;	/*  .mzl_TFC:escSpl.c */
  static double *BTrt;	/*  .mzl_TFC:escSpl.c */
  static double *BTz;	/*  .mzl_TFC:escSpl.c */
  static double *BTt;	/*  .mzl_TFC:escSpl.c */
  static double *BTr;	/*  .mzl_TFC:escSpl.c */
  static double *BT;	/*  .mzl_TFC:escSpl.c */
  static double *BRrtz;	/*  .mzl_TFC:escSpl.c */
  static double *BRtz;	/*  .mzl_TFC:escSpl.c */
  static double *BRrz;	/*  .mzl_TFC:escSpl.c */
  static double *BRrt;	/*  .mzl_TFC:escSpl.c */
  static double *BRz;	/*  .mzl_TFC:escSpl.c */
  static double *BRt;	/*  .mzl_TFC:escSpl.c */
  static double *BRr;	/*  .mzl_TFC:escSpl.c */
  static double *BR;	/*  .mzl_TFC:escSpl.c */
  static double *AZrtz;	/*  .mzl_TFC:escSpl.c */
  static double *AZtz;	/*  .mzl_TFC:escSpl.c */
  static double *AZrz;	/*  .mzl_TFC:escSpl.c */
  static double *AZrt;	/*  .mzl_TFC:escSpl.c */
  static double *AZz;	/*  .mzl_TFC:escSpl.c */
  static double *AZt;	/*  .mzl_TFC:escSpl.c */
  static double *AZr;	/*  .mzl_TFC:escSpl.c */
  static double *AZ;	/*  .mzl_TFC:escSpl.c */
  static double *ATrtz;	/*  .mzl_TFC:escSpl.c */
  static double *ATtz;	/*  .mzl_TFC:escSpl.c */
  static double *ATrz;	/*  .mzl_TFC:escSpl.c */
  static double *ATrt;	/*  .mzl_TFC:escSpl.c */
  static double *ATz;	/*  .mzl_TFC:escSpl.c */
  static double *ATt;	/*  .mzl_TFC:escSpl.c */
  static double *ATr;	/*  .mzl_TFC:escSpl.c */
  static double *AT;	/*  .mzl_TFC:escSpl.c */
  static double *ARrtz;	/*  .mzl_TFC:escSpl.c */
  static double *ARtz;	/*  .mzl_TFC:escSpl.c */
  static double *ARrz;	/*  .mzl_TFC:escSpl.c */
  static double *ARrt;	/*  .mzl_TFC:escSpl.c */
  static double *ARz;	/*  .mzl_TFC:escSpl.c */
  static double *ARt;	/*  .mzl_TFC:escSpl.c */
  static double *ARr;	/*  .mzl_TFC:escSpl.c */
  static double *AR;	/*  .mzl_TFC:escSpl.c */
  static double *rSpl;	/*  .mzl_TFC:escSpl.c */
  static double *zSpl;	/*  .mzl_TFC:escSpl.c */
  static double *ySpl;	/*  .mzl_TFC:escSpl.c */
  static double *xSpl;	/*  .mzl_TFC:escSpl.c */
/*
   */
#ifdef Doc_ESInitSplGrid
\section{Skeleton of ESInitSplGrid()}
  \begin{verbatim}
    ESInitSplGrid(){
    }
  \end{verbatim}
\section{ESInitSplGrid()}

#endif
}
int ESReInitSplGrid()
{
  Undef FailureAlarm();
  Undef ESexit();
  static int NzSpl;	/*  .mzl_TFC:escSpl.c */
  static int nzSpl1;	/*  .mzl_TFC:escSpl.c */
  static int **Nr1Spl;	/*  .mzl_TFC:escSpl.c */
  static int **Nr2Spl;	/*  .mzl_TFC:escSpl.c */
/*
   */
#ifdef Doc_ESReInitSplGrid
\section{Skeleton of ESReInitSplGrid()}
  \begin{verbatim}
    ESReInitSplGrid(){
    }
  \end{verbatim}
\section{ESReInitSplGrid()}

#endif
}
int ESDeInitSplGrid()
{
  static int NzSpl;	/*  .mzl_TFC:escSpl.c */
  static int **Nr1Spl;	/*  .mzl_TFC:escSpl.c */
/*
   */
#ifdef Doc_ESDeInitSplGrid
\section{Skeleton of ESDeInitSplGrid()}
  \begin{verbatim}
    ESDeInitSplGrid(){
    }
  \end{verbatim}
\section{ESDeInitSplGrid()}

#endif
}
int ESReInitEnvTFC()
{
  Undef ReInitArray();
  Undef FailureAlarm();
  Undef ESexit();
  static int SplNt;	/*  .mzl_TFC:escSpl.c */
  static double *x1TFC;	/*  .mzl_TFC:escSpl.c */
  static double *x2TFC;	/*  .mzl_TFC:escSpl.c */
  static double *y1TFC;	/*  .mzl_TFC:escSpl.c */
  static double *y2TFC;	/*  .mzl_TFC:escSpl.c */
  static double *r1TFC;	/*  .mzl_TFC:escSpl.c */
  static double *r2TFC;	/*  .mzl_TFC:escSpl.c */
  static double *gf1TFC;/*  .mzl_TFC:escSpl.c */
  static double *gf2TFC;/*  .mzl_TFC:escSpl.c */
  static int ***k2kSpl;	/*  .mzl_TFC:escSpl.c */
  static int **Nr1Spl;	/*  .mzl_TFC:escSpl.c */
  static int **Nr2Spl;	/*  .mzl_TFC:escSpl.c */
  static int *SplNz;	/*  .mzl_TFC:escSpl.c */
  static int *Nz1Spl;	/*  .mzl_TFC:escSpl.c */
  static int *Nz2Spl;	/*  .mzl_TFC:escSpl.c */
  static double *x1Env;	/*  .mzl_TFC:escSpl.c */
  static double *x2Env;	/*  .mzl_TFC:escSpl.c */
  static double *y1Env;	/*  .mzl_TFC:escSpl.c */
  static double *y2Env;	/*  .mzl_TFC:escSpl.c */
  static double *zEnv;	/*  .mzl_TFC:escSpl.c */
  static double *r1Env;	/*  .mzl_TFC:escSpl.c */
  static double *r2Env;	/*  .mzl_TFC:escSpl.c */
/*
   */
#ifdef Doc_ESReInitEnvTFC
\section{Skeleton of ESReInitEnvTFC()}
  \begin{verbatim}
    ESReInitEnvTFC(){
    }
  \end{verbatim}
\section{ESReInitEnvTFC()}

#endif
}
int ESDeInitEnvTFC()
{
  static int SplNt;	/*  .mzl_TFC:escSpl.c */
  static int *SplNz;	/*  .mzl_TFC:escSpl.c */
  static int ***k2kSpl;	/*  .mzl_TFC:escSpl.c */
  static double *r2Env;	/*  .mzl_TFC:escSpl.c */
  static double *r1Env;	/*  .mzl_TFC:escSpl.c */
  static double *zEnv;	/*  .mzl_TFC:escSpl.c */
  static double *y2Env;	/*  .mzl_TFC:escSpl.c */
  static double *y1Env;	/*  .mzl_TFC:escSpl.c */
  static double *x2Env;	/*  .mzl_TFC:escSpl.c */
  static double *x1Env;	/*  .mzl_TFC:escSpl.c */
  static double *x1TFC;	/*  .mzl_TFC:escSpl.c */
  static int *Nz2Spl;	/*  .mzl_TFC:escSpl.c */
  static int *Nz1Spl;	/*  .mzl_TFC:escSpl.c */
  static int **Nr2Spl;	/*  .mzl_TFC:escSpl.c */
  static int **Nr1Spl;	/*  .mzl_TFC:escSpl.c */
  static int SplN;	/*  .mzl_TFC:escSpl.c */
  static double *rSpl;	/*  .mzl_TFC:escSpl.c */
  static double *zSpl;	/*  .mzl_TFC:escSpl.c */
  static double *ySpl;	/*  .mzl_TFC:escSpl.c */
  static double *xSpl;	/*  .mzl_TFC:escSpl.c */
/*
   */
#ifdef Doc_ESDeInitEnvTFC
\section{Skeleton of ESDeInitEnvTFC()}
  \begin{verbatim}
    ESDeInitEnvTFC(){
    }
  \end{verbatim}
\section{ESDeInitEnvTFC()}

#endif
}
extern double Ax;	/* undefined */
extern double Ay;	/* undefined */
extern double Az;	/* undefined */
extern double Bx;	/* undefined */
extern double By;	/* undefined */
extern double Bz;	/* undefined */
int ESInitArtzBrtzSpl()
{
  Undef time();
  Undef ctime();
  Undef CLOCKS_PER_SEC;
  extern clock_t clock();	/* undefined */
  extern double difftime();	/* undefined */
  static time_t sTime2;	/*  .mzl_ESmain:escSpl.c */
  static time_t sTime1;	/*  .mzl_ESmain:escSpl.c */
  static int *Nz1Spl;	/*     .mzl_TFC:escSpl.c */
  static int *Nz2Spl;	/*     .mzl_TFC:escSpl.c */
  static double Zmn;	/*     .mzl_TFC:escSpl.c */
  static double dzSpl;	/*     .mzl_TFC:escSpl.c */
  static int **Nr1Spl;	/*     .mzl_TFC:escSpl.c */
  static int **Nr2Spl;	/*     .mzl_TFC:escSpl.c */
  static double Rmn;	/*     .mzl_TFC:escSpl.c */
  static double drSpl;	/*     .mzl_TFC:escSpl.c */
  static double *csL;	/*     .mzl_TFC:escSpl.c */
  static double *snL;	/*     .mzl_TFC:escSpl.c */
  static double *AR;	/*     .mzl_TFC:escSpl.c */
  static double *ARr;	/*     .mzl_TFC:escSpl.c */
  static double *ARt;	/*     .mzl_TFC:escSpl.c */
  static double *ARrt;	/*     .mzl_TFC:escSpl.c */
  static double *ARz;	/*     .mzl_TFC:escSpl.c */
  static double *ARrz;	/*     .mzl_TFC:escSpl.c */
  static double *ARtz;	/*     .mzl_TFC:escSpl.c */
  static double *ARrtz;	/*     .mzl_TFC:escSpl.c */
  static double *AT;	/*     .mzl_TFC:escSpl.c */
  static double *ATr;	/*     .mzl_TFC:escSpl.c */
  static double *ATt;	/*     .mzl_TFC:escSpl.c */
  static double *ATrt;	/*     .mzl_TFC:escSpl.c */
  static double *ATz;	/*     .mzl_TFC:escSpl.c */
  static double *ATrz;	/*     .mzl_TFC:escSpl.c */
  static double *ATtz;	/*     .mzl_TFC:escSpl.c */
  static double *ATrtz;	/*     .mzl_TFC:escSpl.c */
  static double *AZ;	/*     .mzl_TFC:escSpl.c */
  static double *AZr;	/*     .mzl_TFC:escSpl.c */
  static double *AZt;	/*     .mzl_TFC:escSpl.c */
  static double *AZrt;	/*     .mzl_TFC:escSpl.c */
  static double *AZz;	/*     .mzl_TFC:escSpl.c */
  static double *AZrz;	/*     .mzl_TFC:escSpl.c */
  static double *AZtz;	/*     .mzl_TFC:escSpl.c */
  static double *AZrtz;	/*     .mzl_TFC:escSpl.c */
  static double *BR;	/*     .mzl_TFC:escSpl.c */
  static double *BRr;	/*     .mzl_TFC:escSpl.c */
  static double *BRt;	/*     .mzl_TFC:escSpl.c */
  static double *BRrt;	/*     .mzl_TFC:escSpl.c */
  static double *BRz;	/*     .mzl_TFC:escSpl.c */
  static double *BRrz;	/*     .mzl_TFC:escSpl.c */
  static double *BRtz;	/*     .mzl_TFC:escSpl.c */
  static double *BRrtz;	/*     .mzl_TFC:escSpl.c */
  static double *BT;	/*     .mzl_TFC:escSpl.c */
  static double *BTr;	/*     .mzl_TFC:escSpl.c */
  static double *BTt;	/*     .mzl_TFC:escSpl.c */
  static double *BTrt;	/*     .mzl_TFC:escSpl.c */
  static double *BTz;	/*     .mzl_TFC:escSpl.c */
  static double *BTrz;	/*     .mzl_TFC:escSpl.c */
  static double *BTtz;	/*     .mzl_TFC:escSpl.c */
  static double *BTrtz;	/*     .mzl_TFC:escSpl.c */
  static double *BZ;	/*     .mzl_TFC:escSpl.c */
  static double *BZr;	/*     .mzl_TFC:escSpl.c */
  static double *BZt;	/*     .mzl_TFC:escSpl.c */
  static double *BZrt;	/*     .mzl_TFC:escSpl.c */
  static double *BZz;	/*     .mzl_TFC:escSpl.c */
  static double *BZrz;	/*     .mzl_TFC:escSpl.c */
  static double *BZtz;	/*     .mzl_TFC:escSpl.c */
  static double *BZrtz;	/*     .mzl_TFC:escSpl.c */
/*
   */
#ifdef Doc_ESInitArtzBrtzSpl

\section{Skeleton of ESInitArtzBrtzSpl()}
  \begin{verbatim}
    ESInitArtzBrtzSpl(){
    }
  \end{verbatim}
\section{ESInitArtzBrtzSpl()}
#endif
}
int ESSetSplRgFZ(r,gf,z)
  double r;	/*  */
  double gf;	/*  */
  double z;	/*  */
{
  int irCell;		/*  .mzl_TFC:escSpl.c */
  int ktCell;		/*  .mzl_TFC:escSpl.c */
  int jzCell;		/*  .mzl_TFC:escSpl.c */
  static double r1Cell;	/*  .mzl_TFC:escSpl.c */
  static double rCell;	/*  .mzl_TFC:escSpl.c */
  static double drSpl;	/*  .mzl_TFC:escSpl.c */
  static double t1Cell;	/*  .mzl_TFC:escSpl.c */
  static double tCell;	/*  .mzl_TFC:escSpl.c */
  static double dtSpl;	/*  .mzl_TFC:escSpl.c */
  static double z1Cell;	/*  .mzl_TFC:escSpl.c */
  static double zCell;	/*  .mzl_TFC:escSpl.c */
  static double dzSpl;	/*  .mzl_TFC:escSpl.c */
  static int *Nz2Spl;	/*  .mzl_TFC:escSpl.c */
  static int *Nz1Spl;	/*  .mzl_TFC:escSpl.c */
  static int **Nr2Spl;	/*  .mzl_TFC:escSpl.c */
  static int **Nr1Spl;	/*  .mzl_TFC:escSpl.c */
  int J000;		/*  .mzl_TFC:escSpl.c */
  static int ***k2kSpl;	/*  .mzl_TFC:escSpl.c */
  int J100;		/*  .mzl_TFC:escSpl.c */
  int J001;		/*  .mzl_TFC:escSpl.c */
  int J101;		/*  .mzl_TFC:escSpl.c */
  int J010;		/*  .mzl_TFC:escSpl.c */
  int J110;		/*  .mzl_TFC:escSpl.c */
  int J011;		/*  .mzl_TFC:escSpl.c */
  int J111;		/*  .mzl_TFC:escSpl.c */
  static double rhrCell;/*  .mzl_TFC:escSpl.c */
  static double Pr0;	/*  .mzl_TFC:escSpl.c */
  static double Pr1;	/*  .mzl_TFC:escSpl.c */
  static double Pr2;	/*  .mzl_TFC:escSpl.c */
  static double Pr3;	/*  .mzl_TFC:escSpl.c */
  static double rhtCell;/*  .mzl_TFC:escSpl.c */
  static double Pt0;	/*  .mzl_TFC:escSpl.c */
  static double Pt1;	/*  .mzl_TFC:escSpl.c */
  static double Pt2;	/*  .mzl_TFC:escSpl.c */
  static double Pt3;	/*  .mzl_TFC:escSpl.c */
  static double rhzCell;/*  .mzl_TFC:escSpl.c */
  static double Pz0;	/*  .mzl_TFC:escSpl.c */
  static double Pz1;	/*  .mzl_TFC:escSpl.c */
  static double Pz2;	/*  .mzl_TFC:escSpl.c */
  static double Pz3;	/*  .mzl_TFC:escSpl.c */
/*
   */
#ifdef Doc_ESSetSplRgFZ

\section{Skeleton of ESSetSplRgFZ()}
  \begin{verbatim}
    ESSetSplRgFZ(){
    }
  \end{verbatim}
\section{ESSetSplRgFZ()}
#endif
}
int ESSetSplDerRTZ(r,gf,z)
  double r;	/*  */
  double gf;	/*  */
  double z;	/*  */
{
  int irCell;		/*  .mzl_TFC:escSpl.c */
  int ktCell;		/*  .mzl_TFC:escSpl.c */
  int jzCell;		/*  .mzl_TFC:escSpl.c */
  static double r1Cell;	/*  .mzl_TFC:escSpl.c */
  static double rCell;	/*  .mzl_TFC:escSpl.c */
  static double drSpl;	/*  .mzl_TFC:escSpl.c */
  static double t1Cell;	/*  .mzl_TFC:escSpl.c */
  static double tCell;	/*  .mzl_TFC:escSpl.c */
  static double dtSpl;	/*  .mzl_TFC:escSpl.c */
  static double z1Cell;	/*  .mzl_TFC:escSpl.c */
  static double zCell;	/*  .mzl_TFC:escSpl.c */
  static double dzSpl;	/*  .mzl_TFC:escSpl.c */
  static int *Nz2Spl;	/*  .mzl_TFC:escSpl.c */
  static int *Nz1Spl;	/*  .mzl_TFC:escSpl.c */
  static int **Nr2Spl;	/*  .mzl_TFC:escSpl.c */
  static int **Nr1Spl;	/*  .mzl_TFC:escSpl.c */
  int J000;		/*  .mzl_TFC:escSpl.c */
  static int ***k2kSpl;	/*  .mzl_TFC:escSpl.c */
  int J100;		/*  .mzl_TFC:escSpl.c */
  int J001;		/*  .mzl_TFC:escSpl.c */
  int J101;		/*  .mzl_TFC:escSpl.c */
  int J010;		/*  .mzl_TFC:escSpl.c */
  int J110;		/*  .mzl_TFC:escSpl.c */
  int J011;		/*  .mzl_TFC:escSpl.c */
  int J111;		/*  .mzl_TFC:escSpl.c */
  static double rhrCell;/*  .mzl_TFC:escSpl.c */
  static double Pr0;	/*  .mzl_TFC:escSpl.c */
  static double Pr1;	/*  .mzl_TFC:escSpl.c */
  static double Pr2;	/*  .mzl_TFC:escSpl.c */
  static double Pr3;	/*  .mzl_TFC:escSpl.c */
  static double dPr1;	/*  .mzl_TFC:escSpl.c */
  static double dPr0;	/*  .mzl_TFC:escSpl.c */
  static double dPr2;	/*  .mzl_TFC:escSpl.c */
  static double dPr3;	/*  .mzl_TFC:escSpl.c */
  static double rhtCell;/*  .mzl_TFC:escSpl.c */
  static double Pt0;	/*  .mzl_TFC:escSpl.c */
  static double Pt1;	/*  .mzl_TFC:escSpl.c */
  static double Pt2;	/*  .mzl_TFC:escSpl.c */
  static double Pt3;	/*  .mzl_TFC:escSpl.c */
  static double dPt1;	/*  .mzl_TFC:escSpl.c */
  static double dPt0;	/*  .mzl_TFC:escSpl.c */
  static double dPt2;	/*  .mzl_TFC:escSpl.c */
  static double dPt3;	/*  .mzl_TFC:escSpl.c */
  static double rhzCell;/*  .mzl_TFC:escSpl.c */
  static double Pz0;	/*  .mzl_TFC:escSpl.c */
  static double Pz1;	/*  .mzl_TFC:escSpl.c */
  static double Pz2;	/*  .mzl_TFC:escSpl.c */
  static double Pz3;	/*  .mzl_TFC:escSpl.c */
  static double dPz1;	/*  .mzl_TFC:escSpl.c */
  static double dPz0;	/*  .mzl_TFC:escSpl.c */
  static double dPz2;	/*  .mzl_TFC:escSpl.c */
  static double dPz3;	/*  .mzl_TFC:escSpl.c */
/*
   */
#ifdef Doc_ESSetSplDerRTZ

\section{Skeleton of ESSetSplDerRTZ()}
  \begin{verbatim}
    ESSetSplDerRTZ(){
    }
  \end{verbatim}
\section{ESSetSplDerRTZ()}
#endif
}
extern double ESBgf;	/* undefined */
void ESMFLineSplStep1(nq,x,yeq,dy)
  int *nq;	/*  */
  double *x;	/*  */
  double *yeq;	/*  */
  double *dy;	/*  */
{
  static double Pt0;	/*  .mzl_TFC:escSpl.c */
  static double dPr0;	/*  .mzl_TFC:escSpl.c */
  static double Pz0;	/*  .mzl_TFC:escSpl.c */
  static double *AT;	/*  .mzl_TFC:escSpl.c */
  int J000;		/*  .mzl_TFC:escSpl.c */
  static double Pz1;	/*  .mzl_TFC:escSpl.c */
  int J001;		/*  .mzl_TFC:escSpl.c */
  static double Pz2;	/*  .mzl_TFC:escSpl.c */
  static double *ATz;	/*  .mzl_TFC:escSpl.c */
  static double Pz3;	/*  .mzl_TFC:escSpl.c */
  static double dPr1;	/*  .mzl_TFC:escSpl.c */
  int J100;		/*  .mzl_TFC:escSpl.c */
  int J101;		/*  .mzl_TFC:escSpl.c */
  static double dPr2;	/*  .mzl_TFC:escSpl.c */
  static double *ATr;	/*  .mzl_TFC:escSpl.c */
  static double *ATrz;	/*  .mzl_TFC:escSpl.c */
  static double dPr3;	/*  .mzl_TFC:escSpl.c */
  static double Pt1;	/*  .mzl_TFC:escSpl.c */
  int J010;		/*  .mzl_TFC:escSpl.c */
  int J011;		/*  .mzl_TFC:escSpl.c */
  int J110;		/*  .mzl_TFC:escSpl.c */
  int J111;		/*  .mzl_TFC:escSpl.c */
  static double Pt2;	/*  .mzl_TFC:escSpl.c */
  static double *ATt;	/*  .mzl_TFC:escSpl.c */
  static double *ATtz;	/*  .mzl_TFC:escSpl.c */
  static double *ATrt;	/*  .mzl_TFC:escSpl.c */
  static double *ATrtz;	/*  .mzl_TFC:escSpl.c */
  static double Pt3;	/*  .mzl_TFC:escSpl.c */
  static double Pr0;	/*  .mzl_TFC:escSpl.c */
  static double dPz0;	/*  .mzl_TFC:escSpl.c */
  static double dPz1;	/*  .mzl_TFC:escSpl.c */
  static double dPz2;	/*  .mzl_TFC:escSpl.c */
  static double dPz3;	/*  .mzl_TFC:escSpl.c */
  static double Pr1;	/*  .mzl_TFC:escSpl.c */
  static double Pr2;	/*  .mzl_TFC:escSpl.c */
  static double Pr3;	/*  .mzl_TFC:escSpl.c */
  static double dPt0;	/*  .mzl_TFC:escSpl.c */
  static double *AR;	/*  .mzl_TFC:escSpl.c */
  static double *ARz;	/*  .mzl_TFC:escSpl.c */
  static double *ARr;	/*  .mzl_TFC:escSpl.c */
  static double *ARrz;	/*  .mzl_TFC:escSpl.c */
  static double dPt1;	/*  .mzl_TFC:escSpl.c */
  static double dPt2;	/*  .mzl_TFC:escSpl.c */
  static double *ARt;	/*  .mzl_TFC:escSpl.c */
  static double *ARtz;	/*  .mzl_TFC:escSpl.c */
  static double *ARrt;	/*  .mzl_TFC:escSpl.c */
  static double *ARrtz;	/*  .mzl_TFC:escSpl.c */
  static double dPt3;	/*  .mzl_TFC:escSpl.c */
  static double *AZ;	/*  .mzl_TFC:escSpl.c */
  static double *AZz;	/*  .mzl_TFC:escSpl.c */
  static double *AZr;	/*  .mzl_TFC:escSpl.c */
  static double *AZrz;	/*  .mzl_TFC:escSpl.c */
  static double *AZt;	/*  .mzl_TFC:escSpl.c */
  static double *AZtz;	/*  .mzl_TFC:escSpl.c */
  static double *AZrt;	/*  .mzl_TFC:escSpl.c */
  static double *AZrtz;	/*  .mzl_TFC:escSpl.c */
/*
   */
#ifdef Doc_ESMFLineSplStep1

\section{Skeleton of ESMFLineSplStep1()}
  \begin{verbatim}
    ESMFLineSplStep1(){
    }
  \end{verbatim}
\section{ESMFLineSplStep1()}
#endif
}
int ESSplineArtz(R,T,Z,Ar,At,Az,Br,Bt,Bz)
  double R;	/*  */
  double T;	/*  */
  double Z;	/*  */
  double *Ar;	/*  */
  double *At;	/*  */
  double *Az;	/*  */
  double *Br;	/*  */
  double *Bt;	/*  */
  double *Bz;	/*  */
{
  static double Pt0;	/*  .mzl_TFC:escSpl.c */
  static double Pr0;	/*  .mzl_TFC:escSpl.c */
  static double Pz0;	/*  .mzl_TFC:escSpl.c */
  static double *AT;	/*  .mzl_TFC:escSpl.c */
  int J000;		/*  .mzl_TFC:escSpl.c */
  static double Pz1;	/*  .mzl_TFC:escSpl.c */
  int J001;		/*  .mzl_TFC:escSpl.c */
  static double Pz2;	/*  .mzl_TFC:escSpl.c */
  static double *ATz;	/*  .mzl_TFC:escSpl.c */
  static double Pz3;	/*  .mzl_TFC:escSpl.c */
  static double Pr1;	/*  .mzl_TFC:escSpl.c */
  int J100;		/*  .mzl_TFC:escSpl.c */
  int J101;		/*  .mzl_TFC:escSpl.c */
  static double Pr2;	/*  .mzl_TFC:escSpl.c */
  static double *ATr;	/*  .mzl_TFC:escSpl.c */
  static double *ATrz;	/*  .mzl_TFC:escSpl.c */
  static double Pr3;	/*  .mzl_TFC:escSpl.c */
  static double Pt1;	/*  .mzl_TFC:escSpl.c */
  int J010;		/*  .mzl_TFC:escSpl.c */
  int J011;		/*  .mzl_TFC:escSpl.c */
  int J110;		/*  .mzl_TFC:escSpl.c */
  int J111;		/*  .mzl_TFC:escSpl.c */
  static double Pt2;	/*  .mzl_TFC:escSpl.c */
  static double *ATt;	/*  .mzl_TFC:escSpl.c */
  static double *ATtz;	/*  .mzl_TFC:escSpl.c */
  static double *ATrt;	/*  .mzl_TFC:escSpl.c */
  static double *ATrtz;	/*  .mzl_TFC:escSpl.c */
  static double Pt3;	/*  .mzl_TFC:escSpl.c */
  static double *AR;	/*  .mzl_TFC:escSpl.c */
  static double *ARz;	/*  .mzl_TFC:escSpl.c */
  static double *ARr;	/*  .mzl_TFC:escSpl.c */
  static double *ARrz;	/*  .mzl_TFC:escSpl.c */
  static double *ARt;	/*  .mzl_TFC:escSpl.c */
  static double *ARtz;	/*  .mzl_TFC:escSpl.c */
  static double *ARrt;	/*  .mzl_TFC:escSpl.c */
  static double *ARrtz;	/*  .mzl_TFC:escSpl.c */
  static double *AZ;	/*  .mzl_TFC:escSpl.c */
  static double *AZz;	/*  .mzl_TFC:escSpl.c */
  static double *AZr;	/*  .mzl_TFC:escSpl.c */
  static double *AZrz;	/*  .mzl_TFC:escSpl.c */
  static double *AZt;	/*  .mzl_TFC:escSpl.c */
  static double *AZtz;	/*  .mzl_TFC:escSpl.c */
  static double *AZrt;	/*  .mzl_TFC:escSpl.c */
  static double *AZrtz;	/*  .mzl_TFC:escSpl.c */
  static double *BT;	/*  .mzl_TFC:escSpl.c */
  static double *BTz;	/*  .mzl_TFC:escSpl.c */
  static double *BTr;	/*  .mzl_TFC:escSpl.c */
  static double *BTrz;	/*  .mzl_TFC:escSpl.c */
  static double *BTt;	/*  .mzl_TFC:escSpl.c */
  static double *BTtz;	/*  .mzl_TFC:escSpl.c */
  static double *BTrt;	/*  .mzl_TFC:escSpl.c */
  static double *BTrtz;	/*  .mzl_TFC:escSpl.c */
  static double *BR;	/*  .mzl_TFC:escSpl.c */
  static double *BRz;	/*  .mzl_TFC:escSpl.c */
  static double *BRr;	/*  .mzl_TFC:escSpl.c */
  static double *BRrz;	/*  .mzl_TFC:escSpl.c */
  static double *BRt;	/*  .mzl_TFC:escSpl.c */
  static double *BRtz;	/*  .mzl_TFC:escSpl.c */
  static double *BRrt;	/*  .mzl_TFC:escSpl.c */
  static double *BRrtz;	/*  .mzl_TFC:escSpl.c */
  static double *BZ;	/*  .mzl_TFC:escSpl.c */
  static double *BZz;	/*  .mzl_TFC:escSpl.c */
  static double *BZr;	/*  .mzl_TFC:escSpl.c */
  static double *BZrz;	/*  .mzl_TFC:escSpl.c */
  static double *BZt;	/*  .mzl_TFC:escSpl.c */
  static double *BZtz;	/*  .mzl_TFC:escSpl.c */
  static double *BZrt;	/*  .mzl_TFC:escSpl.c */
  static double *BZrtz;	/*  .mzl_TFC:escSpl.c */
/*
   */
#ifdef Doc_ESSplineArtz

\section{Skeleton of ESSplineArtz()}
  \begin{verbatim}
    ESSplineArtz(){
    }
  \end{verbatim}
\section{ESSplineArtz()}
#endif
}
void ESMFLineSplStep(nq,x,yeq,dy)
  int *nq;	/*  */
  double *x;	/*  */
  double *yeq;	/*  */
  double *dy;	/*  */
{
  static double Pt0;	/*  .mzl_TFC:escSpl.c */
  static double Pr0;	/*  .mzl_TFC:escSpl.c */
  static double Pz0;	/*  .mzl_TFC:escSpl.c */
  static double *BT;	/*  .mzl_TFC:escSpl.c */
  int J000;		/*  .mzl_TFC:escSpl.c */
  static double Pz1;	/*  .mzl_TFC:escSpl.c */
  int J001;		/*  .mzl_TFC:escSpl.c */
  static double Pz2;	/*  .mzl_TFC:escSpl.c */
  static double *BTz;	/*  .mzl_TFC:escSpl.c */
  static double Pz3;	/*  .mzl_TFC:escSpl.c */
  static double Pr1;	/*  .mzl_TFC:escSpl.c */
  int J100;		/*  .mzl_TFC:escSpl.c */
  int J101;		/*  .mzl_TFC:escSpl.c */
  static double Pr2;	/*  .mzl_TFC:escSpl.c */
  static double *BTr;	/*  .mzl_TFC:escSpl.c */
  static double *BTrz;	/*  .mzl_TFC:escSpl.c */
  static double Pr3;	/*  .mzl_TFC:escSpl.c */
  static double Pt1;	/*  .mzl_TFC:escSpl.c */
  int J010;		/*  .mzl_TFC:escSpl.c */
  int J011;		/*  .mzl_TFC:escSpl.c */
  int J110;		/*  .mzl_TFC:escSpl.c */
  int J111;		/*  .mzl_TFC:escSpl.c */
  static double Pt2;	/*  .mzl_TFC:escSpl.c */
  static double *BTt;	/*  .mzl_TFC:escSpl.c */
  static double *BTtz;	/*  .mzl_TFC:escSpl.c */
  static double *BTrt;	/*  .mzl_TFC:escSpl.c */
  static double *BTrtz;	/*  .mzl_TFC:escSpl.c */
  static double Pt3;	/*  .mzl_TFC:escSpl.c */
  static double *BR;	/*  .mzl_TFC:escSpl.c */
  static double *BRz;	/*  .mzl_TFC:escSpl.c */
  static double *BRr;	/*  .mzl_TFC:escSpl.c */
  static double *BRrz;	/*  .mzl_TFC:escSpl.c */
  static double *BRt;	/*  .mzl_TFC:escSpl.c */
  static double *BRtz;	/*  .mzl_TFC:escSpl.c */
  static double *BRrt;	/*  .mzl_TFC:escSpl.c */
  static double *BRrtz;	/*  .mzl_TFC:escSpl.c */
  static double *BZ;	/*  .mzl_TFC:escSpl.c */
  static double *BZz;	/*  .mzl_TFC:escSpl.c */
  static double *BZr;	/*  .mzl_TFC:escSpl.c */
  static double *BZrz;	/*  .mzl_TFC:escSpl.c */
  static double *BZt;	/*  .mzl_TFC:escSpl.c */
  static double *BZtz;	/*  .mzl_TFC:escSpl.c */
  static double *BZrt;	/*  .mzl_TFC:escSpl.c */
  static double *BZrtz;	/*  .mzl_TFC:escSpl.c */
/*
   */
#ifdef Doc_ESMFLineSplStep

\section{Skeleton of ESMFLineSplStep()}
  \begin{verbatim}
    ESMFLineSplStep(){
    }
  \end{verbatim}
\section{ESMFLineSplStep()}
#endif
}
int ESSetSplRZ(r,z,n)
  double r;	/*  */
  double z;	/*  */
  int n;	/*  */
{
  int irCell;		/*  .mzl_TFC:escSpl.c */
  int ktCell;		/*  .mzl_TFC:escSpl.c */
  int jzCell;		/*  .mzl_TFC:escSpl.c */
  static double r1Cell;	/*  .mzl_TFC:escSpl.c */
  static double rCell;	/*  .mzl_TFC:escSpl.c */
  static double drSpl;	/*  .mzl_TFC:escSpl.c */
  static double tCell;	/*  .mzl_TFC:escSpl.c */
  static double t1Cell;	/*  .mzl_TFC:escSpl.c */
  static double dtSpl;	/*  .mzl_TFC:escSpl.c */
  static double z1Cell;	/*  .mzl_TFC:escSpl.c */
  static double zCell;	/*  .mzl_TFC:escSpl.c */
  static double dzSpl;	/*  .mzl_TFC:escSpl.c */
  static int *Nz2Spl;	/*  .mzl_TFC:escSpl.c */
  static int *Nz1Spl;	/*  .mzl_TFC:escSpl.c */
  static int **Nr2Spl;	/*  .mzl_TFC:escSpl.c */
  static int **Nr1Spl;	/*  .mzl_TFC:escSpl.c */
  int J000;		/*  .mzl_TFC:escSpl.c */
  static int ***k2kSpl;	/*  .mzl_TFC:escSpl.c */
  int J100;		/*  .mzl_TFC:escSpl.c */
  int J001;		/*  .mzl_TFC:escSpl.c */
  int J101;		/*  .mzl_TFC:escSpl.c */
  int J010;		/*  .mzl_TFC:escSpl.c */
  int J110;		/*  .mzl_TFC:escSpl.c */
  int J011;		/*  .mzl_TFC:escSpl.c */
  int J111;		/*  .mzl_TFC:escSpl.c */
  static double rhrCell;/*  .mzl_TFC:escSpl.c */
  static double Pr0;	/*  .mzl_TFC:escSpl.c */
  static double Pr1;	/*  .mzl_TFC:escSpl.c */
  static double Pr2;	/*  .mzl_TFC:escSpl.c */
  static double Pr3;	/*  .mzl_TFC:escSpl.c */
  static double rhzCell;/*  .mzl_TFC:escSpl.c */
  static double Pz0;	/*  .mzl_TFC:escSpl.c */
  static double Pz1;	/*  .mzl_TFC:escSpl.c */
  static double Pz2;	/*  .mzl_TFC:escSpl.c */
  static double Pz3;	/*  .mzl_TFC:escSpl.c */
/*
   */
#ifdef Doc_ESSetSplRZ

\section{Skeleton of ESSetSplRZ()}
  \begin{verbatim}
    ESSetSplRZ(){
    }
  \end{verbatim}
\section{ESSetSplRZ()}
#endif
}
int ESSetSplDerRZ(r,z,n)
  double r;	/*  */
  double z;	/*  */
  int n;	/*  */
{
  int irCell;		/*  .mzl_TFC:escSpl.c */
  int ktCell;		/*  .mzl_TFC:escSpl.c */
  int jzCell;		/*  .mzl_TFC:escSpl.c */
  static double r1Cell;	/*  .mzl_TFC:escSpl.c */
  static double rCell;	/*  .mzl_TFC:escSpl.c */
  static double drSpl;	/*  .mzl_TFC:escSpl.c */
  static double tCell;	/*  .mzl_TFC:escSpl.c */
  static double t1Cell;	/*  .mzl_TFC:escSpl.c */
  static double dtSpl;	/*  .mzl_TFC:escSpl.c */
  static double z1Cell;	/*  .mzl_TFC:escSpl.c */
  static double zCell;	/*  .mzl_TFC:escSpl.c */
  static double dzSpl;	/*  .mzl_TFC:escSpl.c */
  static int *Nz2Spl;	/*  .mzl_TFC:escSpl.c */
  static int *Nz1Spl;	/*  .mzl_TFC:escSpl.c */
  static int **Nr2Spl;	/*  .mzl_TFC:escSpl.c */
  static int **Nr1Spl;	/*  .mzl_TFC:escSpl.c */
  int J000;		/*  .mzl_TFC:escSpl.c */
  static int ***k2kSpl;	/*  .mzl_TFC:escSpl.c */
  int J100;		/*  .mzl_TFC:escSpl.c */
  int J001;		/*  .mzl_TFC:escSpl.c */
  int J101;		/*  .mzl_TFC:escSpl.c */
  int J010;		/*  .mzl_TFC:escSpl.c */
  int J110;		/*  .mzl_TFC:escSpl.c */
  int J011;		/*  .mzl_TFC:escSpl.c */
  int J111;		/*  .mzl_TFC:escSpl.c */
  static double rhrCell;/*  .mzl_TFC:escSpl.c */
  static double Pr0;	/*  .mzl_TFC:escSpl.c */
  static double Pr1;	/*  .mzl_TFC:escSpl.c */
  static double Pr2;	/*  .mzl_TFC:escSpl.c */
  static double Pr3;	/*  .mzl_TFC:escSpl.c */
  static double dPr1;	/*  .mzl_TFC:escSpl.c */
  static double dPr0;	/*  .mzl_TFC:escSpl.c */
  static double dPr2;	/*  .mzl_TFC:escSpl.c */
  static double dPr3;	/*  .mzl_TFC:escSpl.c */
  static double rhzCell;/*  .mzl_TFC:escSpl.c */
  static double Pz0;	/*  .mzl_TFC:escSpl.c */
  static double Pz1;	/*  .mzl_TFC:escSpl.c */
  static double Pz2;	/*  .mzl_TFC:escSpl.c */
  static double Pz3;	/*  .mzl_TFC:escSpl.c */
  static double dPz1;	/*  .mzl_TFC:escSpl.c */
  static double dPz0;	/*  .mzl_TFC:escSpl.c */
  static double dPz2;	/*  .mzl_TFC:escSpl.c */
  static double dPz3;	/*  .mzl_TFC:escSpl.c */
/*
   */
#ifdef Doc_ESSetSplDerRZ

\section{Skeleton of ESSetSplDerRZ()}
  \begin{verbatim}
    ESSetSplDerRZ(){
    }
  \end{verbatim}
\section{ESSetSplDerRZ()}
#endif
}
int ESSpl2ArBtAtAz(Ar,Ar1t,Bt,At,Az,Az1t,R,Z,n)
  double *Ar;	/*  */
  double *Ar1t;	/*  */
  double *Bt;	/*  */
  double *At;	/*  */
  double *Az;	/*  */
  double *Az1t;	/*  */
  double R;	/*  */
  double Z;	/*  */
  int n;	/*  */
{
  static double Pr0;	/*  .mzl_TFC:escSpl.c */
  static double Pz0;	/*  .mzl_TFC:escSpl.c */
  static double *AR;	/*  .mzl_TFC:escSpl.c */
  int J000;		/*  .mzl_TFC:escSpl.c */
  static double Pz1;	/*  .mzl_TFC:escSpl.c */
  int J001;		/*  .mzl_TFC:escSpl.c */
  static double Pz2;	/*  .mzl_TFC:escSpl.c */
  static double *ARz;	/*  .mzl_TFC:escSpl.c */
  static double Pz3;	/*  .mzl_TFC:escSpl.c */
  static double Pr1;	/*  .mzl_TFC:escSpl.c */
  int J100;		/*  .mzl_TFC:escSpl.c */
  int J101;		/*  .mzl_TFC:escSpl.c */
  static double Pr2;	/*  .mzl_TFC:escSpl.c */
  static double *ARr;	/*  .mzl_TFC:escSpl.c */
  static double *ARrz;	/*  .mzl_TFC:escSpl.c */
  static double Pr3;	/*  .mzl_TFC:escSpl.c */
  static double *ARt;	/*  .mzl_TFC:escSpl.c */
  static double *ARtz;	/*  .mzl_TFC:escSpl.c */
  static double *ARrt;	/*  .mzl_TFC:escSpl.c */
  static double *ARrtz;	/*  .mzl_TFC:escSpl.c */
  static double *BT;	/*  .mzl_TFC:escSpl.c */
  static double *BTz;	/*  .mzl_TFC:escSpl.c */
  static double *BTr;	/*  .mzl_TFC:escSpl.c */
  static double *BTrz;	/*  .mzl_TFC:escSpl.c */
  static double *AT;	/*  .mzl_TFC:escSpl.c */
  static double *ATz;	/*  .mzl_TFC:escSpl.c */
  static double *ATr;	/*  .mzl_TFC:escSpl.c */
  static double *ATrz;	/*  .mzl_TFC:escSpl.c */
  static double *AZ;	/*  .mzl_TFC:escSpl.c */
  static double *AZz;	/*  .mzl_TFC:escSpl.c */
  static double *AZr;	/*  .mzl_TFC:escSpl.c */
  static double *AZrz;	/*  .mzl_TFC:escSpl.c */
  static double *AZt;	/*  .mzl_TFC:escSpl.c */
  static double *AZtz;	/*  .mzl_TFC:escSpl.c */
  static double *AZrt;	/*  .mzl_TFC:escSpl.c */
  static double *AZrtz;	/*  .mzl_TFC:escSpl.c */
/*
   */
#ifdef Doc_ESSpl2ArBtAtAz

\section{Skeleton of ESSpl2ArBtAtAz()}
  \begin{verbatim}
    ESSpl2ArBtAtAz(){
    }
  \end{verbatim}
\section{ESSpl2ArBtAtAz()}
#endif
}
int ESSpl2BrBtBz(Ar,Az,Br,Bt,Bz,R,Z,n)
  double *Ar;	/*  */
  double *Az;	/*  */
  double *Br;	/*  */
  double *Bt;	/*  */
  double *Bz;	/*  */
  double R;	/*  */
  double Z;	/*  */
  int n;	/*  */
{
  static double Pr0;	/*  .mzl_TFC:escSpl.c */
  static double Pz0;	/*  .mzl_TFC:escSpl.c */
  static double *AR;	/*  .mzl_TFC:escSpl.c */
  int J000;		/*  .mzl_TFC:escSpl.c */
  static double Pz1;	/*  .mzl_TFC:escSpl.c */
  int J001;		/*  .mzl_TFC:escSpl.c */
  static double Pz2;	/*  .mzl_TFC:escSpl.c */
  static double *ARz;	/*  .mzl_TFC:escSpl.c */
  static double Pz3;	/*  .mzl_TFC:escSpl.c */
  static double Pr1;	/*  .mzl_TFC:escSpl.c */
  int J100;		/*  .mzl_TFC:escSpl.c */
  int J101;		/*  .mzl_TFC:escSpl.c */
  static double Pr2;	/*  .mzl_TFC:escSpl.c */
  static double *ARr;	/*  .mzl_TFC:escSpl.c */
  static double *ARrz;	/*  .mzl_TFC:escSpl.c */
  static double Pr3;	/*  .mzl_TFC:escSpl.c */
  static double *AZ;	/*  .mzl_TFC:escSpl.c */
  static double *AZz;	/*  .mzl_TFC:escSpl.c */
  static double *AZr;	/*  .mzl_TFC:escSpl.c */
  static double *AZrz;	/*  .mzl_TFC:escSpl.c */
  static double *BR;	/*  .mzl_TFC:escSpl.c */
  static double *BRz;	/*  .mzl_TFC:escSpl.c */
  static double *BRr;	/*  .mzl_TFC:escSpl.c */
  static double *BRrz;	/*  .mzl_TFC:escSpl.c */
  static double *BT;	/*  .mzl_TFC:escSpl.c */
  static double *BTz;	/*  .mzl_TFC:escSpl.c */
  static double *BTr;	/*  .mzl_TFC:escSpl.c */
  static double *BTrz;	/*  .mzl_TFC:escSpl.c */
  static double *BZ;	/*  .mzl_TFC:escSpl.c */
  static double *BZz;	/*  .mzl_TFC:escSpl.c */
  static double *BZr;	/*  .mzl_TFC:escSpl.c */
  static double *BZrz;	/*  .mzl_TFC:escSpl.c */
/*
   */
#ifdef Doc_ESSpl2BrBtBz

\section{Skeleton of ESSpl2BrBtBz()}
  \begin{verbatim}
    ESSpl2BrBtBz(){
    }
  \end{verbatim}
\section{ESSpl2BrBtBz()}
#endif
}
int ESSpl2BrBtBzBrrBtrBzr(Br,Bt,Bz,Brr,Btr,Bzr,Brz,Btz,Bzz,R,Z,n)
  double *Br;	/*  */
  double *Bt;	/*  */
  double *Bz;	/*  */
  double *Brr;	/*  */
  double *Btr;	/*  */
  double *Bzr;	/*  */
  double *Brz;	/*  */
  double *Btz;	/*  */
  double *Bzz;	/*  */
  double R;	/*  */
  double Z;	/*  */
  int n;	/*  */
{
  static double Pz0;	/*  .mzl_TFC:escSpl.c */
  static double *BR;	/*  .mzl_TFC:escSpl.c */
  int J000;		/*  .mzl_TFC:escSpl.c */
  static double Pz1;	/*  .mzl_TFC:escSpl.c */
  int J001;		/*  .mzl_TFC:escSpl.c */
  static double Pz2;	/*  .mzl_TFC:escSpl.c */
  static double *BRz;	/*  .mzl_TFC:escSpl.c */
  static double Pz3;	/*  .mzl_TFC:escSpl.c */
  int J100;		/*  .mzl_TFC:escSpl.c */
  int J101;		/*  .mzl_TFC:escSpl.c */
  static double *BRr;	/*  .mzl_TFC:escSpl.c */
  static double *BRrz;	/*  .mzl_TFC:escSpl.c */
  static double Pr0;	/*  .mzl_TFC:escSpl.c */
  static double Pr1;	/*  .mzl_TFC:escSpl.c */
  static double Pr2;	/*  .mzl_TFC:escSpl.c */
  static double Pr3;	/*  .mzl_TFC:escSpl.c */
  static double dPr0;	/*  .mzl_TFC:escSpl.c */
  static double dPr1;	/*  .mzl_TFC:escSpl.c */
  static double dPr2;	/*  .mzl_TFC:escSpl.c */
  static double dPr3;	/*  .mzl_TFC:escSpl.c */
  static double dPz0;	/*  .mzl_TFC:escSpl.c */
  static double dPz1;	/*  .mzl_TFC:escSpl.c */
  static double dPz2;	/*  .mzl_TFC:escSpl.c */
  static double dPz3;	/*  .mzl_TFC:escSpl.c */
  static double *BT;	/*  .mzl_TFC:escSpl.c */
  static double *BTz;	/*  .mzl_TFC:escSpl.c */
  static double *BTr;	/*  .mzl_TFC:escSpl.c */
  static double *BTrz;	/*  .mzl_TFC:escSpl.c */

  static double *BZz;	/*  .mzl_TFC:escSpl.c */
  static double *BZr;	/*  .mzl_TFC:escSpl.c */
  static double *BZrz;	/*  .mzl_TFC:escSpl.c */
/*
   */
#ifdef Doc_ESSpl2BrBtBzBrrBtrBzr

\section{Skeleton of ESSpl2BrBtBzBrrBtrBzr()}
  \begin{verbatim}
    ESSpl2BrBtBzBrrBtrBzr(){
    }
  \end{verbatim}
\section{ESSpl2BrBtBzBrrBtrBzr()}
#endif
}
int ESInit3DSpl()
{
  Undef ESGetTFCAddr();
  extern double cr2;	/* undefined */
  static int NDm;	/*  .mzl_TFC:escSpl.c */
  static int TFCNt1;	/*  .mzl_TFC:escSpl.c */
  static int SplNt;	/*  .mzl_TFC:escSpl.c */
  static double *gf0TFC;/*  .mzl_TFC:escSpl.c */
  static double *gfL;	/*  .mzl_TFC:escSpl.c */
  static double *csL;	/*  .mzl_TFC:escSpl.c */
  static double *snL;	/*  .mzl_TFC:escSpl.c */
  static int nTP;	/*  .mzl_TFC:escSpl.c */
  static double Rmn;	/*  .mzl_TFC:escSpl.c */
  static int *jRmnTFC;	/*  .mzl_TFC:escSpl.c */
  static double Rmx;	/*  .mzl_TFC:escSpl.c */
  static int *jRmxTFC;	/*  .mzl_TFC:escSpl.c */
  static double Zmn;	/*  .mzl_TFC:escSpl.c */
  static int *jZmnTFC;	/*  .mzl_TFC:escSpl.c */
  static double Zmx;	/*  .mzl_TFC:escSpl.c */
  static int *jZmxTFC;	/*  .mzl_TFC:escSpl.c */
  static int nrSpl1;	/*  .mzl_TFC:escSpl.c */
  static int nrSpl;	/*  .mzl_TFC:escSpl.c */
  static int nzSpl1;	/*  .mzl_TFC:escSpl.c */
  static int nzSpl;	/*  .mzl_TFC:escSpl.c */
  static int NzSpl;	/*  .mzl_TFC:escSpl.c */
  static double drSpl;	/*  .mzl_TFC:escSpl.c */
  static double dtSpl;	/*  .mzl_TFC:escSpl.c */
  static double dzSpl;	/*  .mzl_TFC:escSpl.c */
  static double rhrCell;/*  .mzl_TFC:escSpl.c */
  static double rhtCell;/*  .mzl_TFC:escSpl.c */
  static double rhzCell;/*  .mzl_TFC:escSpl.c */
  static double *r1TFC;	/*  .mzl_TFC:escSpl.c */
  static double *r2TFC;	/*  .mzl_TFC:escSpl.c */
  static double *x1TFC;	/*  .mzl_TFC:escSpl.c */
  static double *x2TFC;	/*  .mzl_TFC:escSpl.c */
  static double *y1TFC;	/*  .mzl_TFC:escSpl.c */
  static double *y2TFC;	/*  .mzl_TFC:escSpl.c */
  static double rCell;	/*  .mzl_TFC:escSpl.c */
  static double tCell;	/*  .mzl_TFC:escSpl.c */
  static double zCell;	/*  .mzl_TFC:escSpl.c */
  static double r1Cell;	/*  .mzl_TFC:escSpl.c */
  static double t1Cell;	/*  .mzl_TFC:escSpl.c */
  static double z1Cell;	/*  .mzl_TFC:escSpl.c */
  int irCell;		/*  .mzl_TFC:escSpl.c */
  int ktCell;		/*  .mzl_TFC:escSpl.c */
  int jzCell;		/*  .mzl_TFC:escSpl.c */
/*
   */
#ifdef Doc_ESInit3DSpl
\section{Skeleton of ESInit3DSpl()}
  \begin{verbatim}
    ESInit3DSpl(){
    }
  \end{verbatim}
\section{ESInit3DSpl()}

#endif
}
#endif
#endif

#undef Doc_Cb_Structure
#ifdef Blb_escSpl.c
Blb_escSpl.c{
  mzl_ESmain{
  }
  mzl_2Dcore{
  }
  mzl_3Dcore{
  }
  mzl_TFC{
  }
  mzl_SPL{
  }
}
#endif

#undef Doc_Table_Of_Content
#ifndef Blb_escSpl.c
				PS p= 69 ( 35);
#ifndef mzl_ESmain
				PS p=  1 (  1);
#endif
#ifndef mzl_2Dcore
				PS p=  1 (  1);
#endif
#ifndef mzl_3Dcore
				PS p=  1 (  1);
#endif
#ifndef mzl_TFC
				PS p=  1 (  1);
#endif
#ifndef mzl_SPL
				PS p=  2 (  1);
int ESInitDmTFC();		PS p=  2 (  1);
int ESReInitDmTFC();		PS p=  2 (  1);
int ESDeInitDmTFC();		PS p=  3 (  2);
int ESInitEnvTFC();		PS p=  3 (  2);
int ESInitSplGrid();		PS p=  5 (  3);
int ESReInitSplGrid();		PS p= 17 (  9);
int ESDeInitSplGrid();		PS p= 17 (  9);
int ESReInitEnvTFC();		PS p= 17 (  9);
int ESDeInitEnvTFC();		PS p= 18 (  9);
int ESInitArtzBrtzSpl();	PS p= 19 ( 10);
int ESSetSplRgFZ();		PS p= 29 ( 15);
int ESSetSplDerRTZ();		PS p= 31 ( 16);
void ESMFLineSplStep1();	PS p= 34 ( 17);
int ESSplineArtz();		PS p= 43 ( 22);
void ESMFLineSplStep();		PS p= 52 ( 26);
int ESSetSplRZ();		PS p= 56 ( 28);
int ESSetSplDerRZ();		PS p= 58 ( 29);
int ESSpl2ArBtAtAz();		PS p= 61 ( 31);
int ESSpl2BrBtBz();		PS p= 63 ( 32);
int ESSpl2BrBtBzBrrBtrBzr();	PS p= 65 ( 33);
int ESInit3DSpl();		PS p= 66 ( 33);
#endif
#endif
