#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <sys/shm.h>
#include <string.h>

/*#if defined(_SEM_SEMUN_UNDEFINED)*/
union semun{
  int val;                    /* value for SETVAL */
  struct semid_ds *buf;       /* buffer for IPC_STAT, IPC_SET */
  unsigned short int *array;  /* array for GETALL, SETALL */
  struct seminfo *__buf;      /* buffer for IPC_INFO */
}
/*#endif*/

#define Sem0 0
#define Sem1 1

int ESNa,ESNa1,ESNp,ESNp1,ESFp,ESFp1;
double *ESaR0,*ESaZ0;
double *ESsr,*ESsz,*ESaB;
double *ESsb,*ESsb2a,*rcT,*rcT2a,*rsT,*rsT2a;

double ESgt[129];

static int Pid;
static int SemID;
static int ShmID;
static union semun Mysemun;
static struct sembuf bufP	={Sem0,-1,SEM_UNDO};
static struct sembuf bufV	={Sem1, 1,IPC_NOWAIT};
static char *lShm=NULL;
static int kD,kI;

static int *ShMemI;
static double *ShMemT;
static double *ShMemB;
static double *ShMemP;
static double *ShMemE;
static double *ShMBal;
static double *aBal;
static int *kBal;
static int nBal,NBal=0x100;

int LaunchEsc(char *Opt)
{
  int i,k;
  char elem;
  char *lc,*ls,ln[64];
  double t,dt;

  kD	=sizeof(double);
  kI	=sizeof(int);

  /* Initialize */
  Pid	=getpid();

  /* Init semaphores */
  /* Two semaphores (Empty and Full) are created in one set */
  SemID	=semget((key_t)Pid, 2, 0666|IPC_CREAT);

  /* Init Empty to number of elements in shared memory */
  Mysemun.val	=1;
  semctl(SemID, Sem0, SETVAL, Mysemun);

  /* Init Full to zero, no elements are produced yet */
  Mysemun.val	=0;
  semctl(SemID, Sem1, SETVAL, Mysemun);  
  if(Opt != NULL && *Opt != '\0'){
    sprintf(ln,"cd ../ESC;Obj/esc2 %d %s&",Pid,Opt);
  }
  else{
    sprintf(ln,"cd ../ESC;Obj/esc2 %d&",Pid);
  }
  semop(SemID, &bufP, 1);   /*Set Sem1=0, Lock ASTRA*/
  system(ln);
  semop(SemID, &bufV, 1);   /*Set Sem0=1, Open ESC*/   		   
  semop(SemID, &bufP, 1);   /*Wait until Sem0++ by ESC: Lock ASTRA*/   
  
  /* Init Shared memory */
  ShmID	=shmget((key_t)(Pid+1),0, 0666 | IPC_CREAT);
  /* attach shared memory to process */
  lShm=shmat(ShmID,NULL,0);

  ShMemI	=(int*)lShm;
  ShMemT	=(double*)(ShMemI+32);
  ShMemB	=ShMemT+16;
  ShMemP	=ShMemB+480;
  ShMemE	=ShMemP+0x600;

  ESNa	=ShMemI[1];
  ESNp	=ShMemI[2];
  ESFp	=ShMemI[3];

  ESaR0	=ShMemT+1;
  ESaZ0	=ESaR0+1;

  ESNa1	=ESNa+1;
  ESNp1	=ESNp+1;
  ESFp1	=ESFp+1;

  ShMBal	=ShMemE+ESNp1+(11+18*ESNp1)*ESNa1;
  aBal		=ShMBal;
  kBal		=(int*)(aBal+NBal);

  ESISetMem(ShMemE,ESNa1,ESNp1);
  ESsr	=ShMemE+ESNp1+11*ESNa1;
  i	=ESNp1*ESNa1;
  ESsz	=ESsr+4*i;
  ESaB	=ESsz+4*i;

  ESsb	=(double*)(kBal+NBal);
  ESsb2a=ESsb+ESNa1;
  rcT	=ESsb2a+ESNa1;
  i	=ESNa1*ESFp1;
  rcT2a	=ESsb2a+i;
  rsT	=rcT2a+i;
  rsT2a	=rsT+i;

  dt	=8.*atan(1.)/ESNp;
  for(i=0; i < ESNp1; i++){
    t	=dt*i;
    ESgt[i]	=t;
  }
  semop(SemID, &bufV, 1);   /*Open ESC*/   		   
  return(0);
}

void esc0_()
{
  int k;
  k	=0;
  if(k){
    LaunchEsc("-NoX");
  }
  else{
    LaunchEsc(NULL);
  }
  return;
}
void esc0()
{
  esc0_();
}

void esc1_()
{
  int k;
  struct shmid_ds Myshmid_ds;

  esifree_();
  semop(SemID, &bufP, 1);   
  k	=4;
  memcpy(lShm,(void*)&k,kI);
  semop(SemID, &bufV, 1);   		   

  semop(SemID, &bufP, 1);   
  /* Remove semaphores */
  semctl(SemID,0, IPC_RMID, Mysemun);
  /* Remove shared memory */
  shmctl(ShmID, IPC_RMID, &Myshmid_ds);
  return;
}

void escin_(double	*pProf	/* p[] - pressure related profile */
	    ,double	*jProf	/* j[] - current related profile */
	    ,double	*aProf	/* a[] - normalized sqrt(Phi) square root 
				   of toroidal flux.
				   If a=NULL (dropped in FORTRAN) - uniform 
				   grid from 0 till 1,
				   otherwise it is considered as an array of 
				   grid points */
	    ,int	*nProf	/* number <= 129 of profile points including \
				   magnetic axis and plasma edge */
	    ,int	*nrhH	/* First digit
				   n - 0 - nomalized radial coordinate (0-1)
				       1 - absolute radial coordinate;
				   r - 0 - b (vertical semiaxis)
				           as the radial coordinate,
				       1 - V (volume),
				       2 - gF (toroidal flux),
				       3 - gY (poloidal flux, DO NOT use),
				   h specifies the meaning
				   of pProf:
				   0 - j_p;
				   1 - P =dp/dpsi;
				   2 -p [MPa].
				   Second digit H specifies the meaning
				   of jProf:
				   0 - j_s [MA/m^2];
				   1- j_|| [MA/m^2]=(j dot B)/(R_0 B grad phi),
				                   R_0 = magnetic axis;
				   2- j_||R_0 [MA/m] = (j dot B)/(B grad phi);
				   3 - T=FF';
				   6 - q;
				   7 - 1/q;
				   8 - \gY;
				   For Example:
				   26 - p[] and q[] profiles are supplied;
				   21 - p[] and j||[] profiles are supplied;
				   0 -  jp[] and js[] profiles are supplied.

				   Possible combinations are limited to:
				   0,1,2,6,7
				   10,11,12,16,17
				   21,22,26,27

				 */
	    ,double	*Rpv	/* R[m]- plasma boundary */
	    ,double	*Zpv	/* Z[m]- plasma boundary */
	    ,int	*Npv	/* number <= 240 of the plasma-vacuum 
				   points.
				   If *Npv >12, the first and last points
				   coincide */
	    ,double	*RBtor	/* RBtor [m Tesla] outside the 
				   plasma */
	    ,double	*Rext	/* Reference major radius [m] */
	    )
{
  int i;
  int k;
  void *lc;

  semop(SemID, &bufP, 1);   /*Lock ASTRA*/
  ShMemI[4]	=*nrhH;
  ShMemI[5]	=*Npv;
  ShMemI[6]	=*nProf;
  ShMemT[3]	=*RBtor;
  ShMemT[4]	=*Rext;
  k	=(*Npv)*kD;
  memcpy((void*)ShMemB,(void*)Rpv,k);
  memcpy((char*)ShMemB+k,(void*)Zpv,k);

  k	=(*nProf)*kD;
  if(aProf != NULL) memcpy((void*)ShMemP,(void*)aProf,k);
  memcpy((char*)ShMemP+k,(void*)pProf,k);
  memcpy((char*)ShMemP+2*k,(void*)jProf,k+2*sizeof(double));
  semop(SemID, &bufV, 1);   /*Open ESC for return confirmation*/

  semop(SemID, &bufP, 1);   /*Lock ASTRA*/   
  semop(SemID, &bufV, 1);   /*Open ESC*/   		   
  return;
}
void escin(double	*pProf
	    ,double	*jProf
	    ,double	*aProf
	    ,int	*nProf
	    ,int	*nrhH 
	    ,double	*Rpv  
	    ,double	*Zpv  
	    ,int	*Npv  
	    ,double	*RBtor
	    ,double	*Rext 
	    )
{
  escin_(pProf,jProf,aProf,nProf,nrhH,Rpv,Zpv,Npv,RBtor,Rext);
}

void esc_(
	  int *Ffail 		/* Flag of failure:
				   0 - normal operation;
				   1 - some problems;
				   2 - problems near the boundary;
				   4 - problems near the axis;
				   8 - problems in the middle;
				   ....;
				   */
	  ,int *Fjob 		/* Flag for job assignment:
				   0 - nothing special was requested;
				   1 - save the geometry;
				   2 - take the geometry;
				   4 - write ESI data files;
				   ...;
				   */ 
	  ,int *Mpol		/* Working number of Fourier harmonics
				   in $\Psi$ */
	  ,double *sTime	/* time */
	  )
{
  int k;
  double *ld;

  semop(SemID, &bufP, 1);   /*Lock ASTRA*/   
  ShMemT[0]	=*sTime;
  ShMemI[8]	=*Fjob;
  ShMemI[10]	=0;
  semop(SemID, &bufV, 1);   /*Unlock ESC*/

  semop(SemID, &bufP, 1);   /*Lock ASTRA*/   
  *Mpol	=ShMemI[7];
  *Ffail=ShMemI[9];
  ESIInit();
  semop(SemID, &bufV, 1);	/*Unlock ESC*/
  return;
}
void esc(
	  int *Ffail
	  ,int *Fjob
	  ,int *Mpol
	  ,double *sTime
	  )
{
  esc_(Ffail,Fjob,Mpol,sTime);
}

int getbalst_(
	      double *a /* array of ESC radii (0< a <= 1) of tested surfaces */
	      ,int *ind /* array of 0 - stable, 1 - ballooning unstable,
			      2 - Mercier unstable */
	      , int *n /* number of points in return arrays */
	      )
{
  *n	=ShMemI[10];
  if(ShMemI[10] == 0) return(1);
  memcpy(a,aBal,ShMemI[10]*sizeof(double));
  memcpy(ind,kBal,ShMemI[10]*sizeof(int));
  return(0);
}
