#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <sys/shm.h>
#include <string.h>

#if defined(_SEM_SEMUN_UNDEFINED)
union semun {
  int val;                    /* value for SETVAL */
  struct semid_ds *buf;       /* buffer for IPC_STAT, IPC_SET */
  unsigned short int *array;  /* array for GETALL, SETALL */
  struct seminfo *__buf;      /* buffer for IPC_INFO */
};
#endif

#define Sem0 0
#define Sem1 1

double *ESsr,*ESsz,*ESsb,*ESsb2a,*rcT,*rsT,*rcT2a,*rsT2a,*ESaR0,*ESaZ0;
double *ESsa;
double *ESgY,*ESgY2a,*ESgF,*ESgF2a,*ESaF,*ESaF2a,*ESgm,*ESgm2a,*ESsq
,*ESsq2a,*ESsp,*ESsp2a;

int ESNa,ESNa1,ESNp,ESNp1,ESFp,ESFp1;

static double c2gp;
static double cr3ha,cha,crha,c2rha,cHa,crHa,chha,ch2ha,ch2h1,ch4h0,ch4h1;
static int iSplA=0,iSplA1;
static double SplAx,SplAxx,SplAX,SplAXX;

static int Pid;
static int SemID;
static int ShmID;
static union semun Mysemun;
static struct sembuf bufP	={Sem0,-1,SEM_UNDO};
static struct sembuf bufV	={Sem1, 1,IPC_NOWAIT};
static void *lShm;
static int *lRetFl;
static int kD,kI;

static int *ShMemI;
static double *ShMemT;
static double *ShMemB;
static double *ShMemP;
static double *ShMemE;
static double *ShMemA;

int CheckIfFailure(int iC)
{
  if(*lRetFl < 0){
    printf("!!! escShm process crashed !!!\n");
    exit(0);
    return(-1);
  }
  if(*lRetFl != iC){
    return(1);
  }
  return(0);
}

int ESFirstSetSplA()
{
  double h;

  h	=1./ESNa;
  cha	=h/6.;
  cr3ha	=h/3.;
  crha	=1./h;
  c2rha	=2.*crha;
  chha	=0.5*h;
  ch2ha	=chha*cha;
  cHa	=h*h/6.;
  crHa	=6.*crha*crha; 
  ch2h1	=h*h/3.;
  return(0);
}

int ESSetSplA(double A)
{
  int iA;
  int i,j,kT1;
  
  if(A > 1.){
    A	=1.;
  }
  if(A < ESsa[0]){
    A	=ESsa[0];
  }
  while(iSplA < ESNa && ESsa[iSplA+1] < A){
    iSplA++;
  }
  while(iSplA > 0 && ESsa[iSplA] > A){
    iSplA--;
  }
  iSplA1	=iSplA+1;
  SplAx		=(A-ESsa[iSplA])*crha;
  SplAxx	=SplAx*SplAx;
  SplAX		=1.-SplAx;
  SplAXX	=SplAX*SplAX;
  return(0);
}

int splRA(double*f, double*df, double*g, double*d2g)
{
  *f	=SplAX*g[iSplA]+SplAx*g[iSplA1]
    +(SplAX*(SplAXX-1.)*d2g[iSplA]+SplAx*(SplAxx-1.)*d2g[iSplA1])*cHa;
  if(df != NULL){
    *df	=(g[iSplA1]-g[iSplA]
	  +((3.*SplAxx-1.)*d2g[iSplA1]-(3.*SplAXX-1.)*d2g[iSplA])*cHa)*crha;
  }
  return(0);
}

int LaunchEsc()
{
  int i,k;
  char elem;
  char *lc,*ls,ln[64];

  kD	=sizeof(double);
  kI	=sizeof(int);

  /* Initialize */
  Pid	=getpid();

  /* Init semaphores */
  /* Two semaphores (Empty and Full) are created in one set */
  SemID	=semget((key_t)Pid, 2, 0666|IPC_CREAT);

  /* Init Empty to number of elements in shared memory */
  Mysemun.val	=1;
  semctl(SemID, Sem0, SETVAL, Mysemun);

  /* Init Full to zero, no elements are produced yet */
  Mysemun.val	=0;
  semctl(SemID, Sem1, SETVAL, Mysemun);  

  sprintf(ln,"Obj/esc2 %d&",Pid);

  semop(SemID, &bufP, 1);   /*Lock ASTRA*/
  system(ln);
  semop(SemID, &bufV, 1);   /*Open ESC*/   		   
  semop(SemID, &bufP, 1);   /*Lock ASTRA*/   
  
  /* Init Shared memory */
  ShmID	=shmget((key_t)(Pid+1),0, 0666 | IPC_CREAT);
  /* attach shared memory to process */
  lShm=shmat(ShmID,NULL,0);

  ShMemI	=(int*)lShm;
  ShMemT	=(double*)(ShMemI+32);
  ShMemB	=ShMemT+16;
  ShMemP	=ShMemB+384;
  ShMemE	=(double*)(ShMemI+0x400*sizeof(double));

  lRetFl=(int*)lShm;
  lShm	+=kI;

  ESNa	=lRetFl[1];
  ESNa1	=ESNa+1;
  ESNp	=lRetFl[2];
  ESNp1	=ESNp+1;
  ESFp	=lRetFl[3];
  ESFp1	=ESFp+1;
  ESaR0	=ShMemE;
  ESaZ0	=ShMemE+1;
  ESsa	=ESaZ0+1;
  ESsb	=ESsa+ESNa1;
  ESsb2a=ESsb+ESNa1;
  
  ESgY		=ESsb2a	+ESNa1;
  ESgY2a	=ESgY	+ESNa1;
  ESgF		=ESgY2a	+ESNa1;
  ESgF2a	=ESgF	+ESNa1;
  ESaF		=ESgF2a	+ESNa1;
  ESaF2a	=ESaF	+ESNa1;
  ESgm		=ESaF2a	+ESNa1;
  ESgm2a	=ESgm	+ESNa1;
  ESsq		=ESgm2a	+ESNa1;
  ESsq2a	=ESsq	+ESNa1;
  ESsp		=ESsq2a	+ESNa1;
  ESsp2a	=ESsp	+ESNa1;

  i	=ESNp1*ESNa1;
  ESsr	=ESsp2a+ESNa1;
  ESsz	=ESsr+i;
  rcT	=ESsz+i;
  i	=ESNa1*ESFp1;
  rsT	=rcT+i;
  rcT2a	=rsT+i;
  rsT2a	=rcT2a+i;
  ShMemA=rsT2a+i;
  ESFirstSetSplA();
  semop(SemID, &bufV, 1);   /*Open ESC*/   		   

  c2gp	=8.*atan(1.);
  return(0);
}

void esc0_(char *Nm,int na)
{
  LaunchEsc();
  return;
}

void esc1_()
{
  int k;
  struct shmid_ds Myshmid_ds;
  semop(SemID, &bufP, 1);   
  k	=4;
  memcpy(lShm,(void*)&k,kI);
  semop(SemID, &bufV, 1);   		   

  semop(SemID, &bufP, 1);   
  /* Remove semaphores */
  semctl(SemID,0, IPC_RMID, Mysemun);
  /* Remove shared memory */
  shmctl(ShmID, IPC_RMID, &Myshmid_ds);
  return;
}

void escin_(double	*pProf	/* p[] - pressure related profile */
	    ,double	*jProf	/* j[] - current related profile */
	    ,double	*aProf	/* a[] - normalized sqrt(Phi) square root 
				   of toroidal flux.
				   If a=NULL (dropped in FORTRAN) - uniform 
				   grid from 0 till 1,
				   otherwise it is considered as an array of 
				   grid points */
	    ,int	*nProf	/* number <= 129 of profile points including \
				   magnetic axis and plasma edge */
	    ,int	*hH	/* First digit h specifies the meaning
				   of pProf:
				   0 - j_p;
				   1 - P =dp/dpsi;
				   2 -p [MPa].
				   Second digit H specifies the meaning
				   of jProf:
				   0 - j_s [MA/m^2];
				   1- j_|| [MA/m^2]=(j dot B)/(R_0 B grad phi),
				                   R_0 = magnetic axis;
				   2- j_||R_0 [MA/m] = (j dot B)/(B grad phi);
				   3 - T=FF';
				   6 - q;
				   7 - 1/q;
				   For Example:
				   26 - p[] and q[] profiles are supplied;
				   21 - p[] and j||[] profiles are supplied;
				   0 -  jp[] and js[] profiles are supplied.

				   Possible combinations are limited to:
				   0,1,2,6,7
				   10,11,12,16,17
				   21,22,26,27
				 */
	    ,double	*Rpv	/* R[m]- plasma boundary */
	    ,double	*Zpv	/* Z[m]- plasma boundary */
	    ,int	*Npv	/* number <= 257 of the plasma-vacuum 
				   points.
				   If *Npv >12, the first and last points
				   coincide */
	    ,double	*RBtor	/* RBtor [m Tesla] outside the 
				   plasma */
	    ,double	*Rext	/* Reference major radius [m] */
	    )
{
  int i;
  int k;
  void *lc;

  semop(SemID, &bufP, 1);   /*Lock ASTRA*/
  memcpy((void*)(ShMemI+4),(void*)hH,kI);
  memcpy((void*)(ShMemI+5),(void*)Npv,kI);
  memcpy((void*)(ShMemI+6),(void*)nProf,kI);
  memcpy((void*)(ShMemT+1),(void*)RBtor,kD);
  memcpy((void*)(ShMemT+2),(void*)Rext,kD);
  k	=(*Npv)*kD;
  memcpy((void*)ShMemB,(void*)Rpv,k);
  memcpy((void*)ShMemB+k,(void*)Zpv,k);

  k	=(*nProf)*kD;
  if(aProf != NULL){
    memcpy((void*)ShMemP,(void*)aProf,k);
  }
  memcpy((void*)ShMemP+k,(void*)pProf,k);
  memcpy((void*)ShMemP+2*k,(void*)jProf,k);

  semop(SemID, &bufV, 1);   /*Open ESC for return confirmation*/
  semop(SemID, &bufP, 1);   /*Lock ASTRA*/   
  semop(SemID, &bufV, 1);   /*Open ESC*/   		   
  return;
}

void esc_(
	  int *Ffail 		/* Flag of failure:
				   0 - normal operation;
				   1 - some problems;
				   2 - problems near the boundary;
				   4 - problems near the axis;
				   8 - problems in the middle;
				   ....;
				   */
	  ,int *Fjob 		/* Flag for job assignment:
				   0 - nothing special was requested;
				   1 - save the geometry;
				   2 - take the geometry;
				   4 - write ESI data files;
				   ...;
				   */ 
	  ,int *Mpol		/* Working number of Fourier harmonics
				   in $\Psi$ */
	  ,double *sTime	/* time */
	  )
{
  int k;
  double *ld;

  semop(SemID, &bufP, 1);   /*Lock ASTRA*/   
  memcpy((void*)ShMemT,(void*)sTime,kI);
  memcpy((void*)(ShMemI+8),(void*)Fjob,kI);

  semop(SemID, &bufV, 1);   		   
  semop(SemID, &bufP, 1);   /*Lock ASTRA*/   
  *Mpol	=ShMemI[7];
  *Ffail=ShMemI[9];
  semop(SemID, &bufV, 1);	/*Open ESC for output calculations*/
  return;
}

/*-------------------------------Get functions -----------------------*/

static char *NmOfProf[6]={
  "bgY",
  "bgF",
  "aF",
  "gm",
  "q",
  "bsp"
};

#ifdef H
strcpy(PlPrP[0].Nm,	"j_PfShl");
strcpy(PlPrP[1].Nm,	"Ps     ");
strcpy(PlPrP[2].Nm,	"p      ");
strcpy(PlPrP[3].Nm,	"p'/a   ");
strcpy(PlPrP[4].Nm,	"ga_CHT ");
strcpy(PlPrP[5].Nm,	"n_e    ");
strcpy(PlPrP[6].Nm,	"n_i    ");
strcpy(PlPrP[7].Nm,	"T_e    ");
strcpy(PlPrP[8].Nm,	"T_i    ");
strcpy(PlPrP[9].Nm,	"p_e    ");
strcpy(PlPrP[10].Nm,	"p_i    ");
strcpy(PlPrP[11].Nm,	"gb_Sh  ");
strcpy(PlPrP[12].Nm,	"gb     ");


strcpy(PlCrP[0].Nm,	"j_GSh  ");
strcpy(PlCrP[1].Nm,	"j_||   ");
strcpy(PlCrP[2].Nm,	"J      ");
strcpy(PlCrP[3].Nm,	"FF'    ");
strcpy(PlCrP[4].Nm,	"<j.B>  ");
strcpy(PlCrP[5].Nm,	"Fs     ");
strcpy(PlCrP[6].Nm,	"q      ");
strcpy(PlCrP[7].Nm,	"1/q    ");
strcpy(PlCrP[8].Nm,	"gY     ");
strcpy(PlCrP[9].Nm,	"gF    ");
strcpy(PlCrP[10].Nm,	"F      ");
strcpy(PlCrP[11].Nm,	"FF     ");
strcpy(PlCrP[12].Nm,	"ir+il  ");
strcpy(PlCrP[13].Nm,	"ir-il  ");
strcpy(PlCrP[14].Nm,	"j_r    ");
strcpy(PlCrP[15].Nm,	"j_l    ");
strcpy(PlCrP[16].Nm,	"dgY/a  ");
strcpy(PlCrP[17].Nm,	"j_||R0 ");
#endif

/**
 * @file 
 * @brief List of Get methods. 
 * The following routines give access equilibrium profile data
 * and geometry after execution (Esc).
 */ 

 
/**
 * Get the radial number of grid points used internally by ESC. 
 * @param Na1 the grid size
 * @author L.E. Zakharov, A. Pletzer
 * @see escGetNp1
 * 
 */
void escGetNa1(int *Na1)
{
  *Na1	=ShMemI[1]+1;
}
void escgetna1_(int *Na1)
{
  *Na1	=ShMemI[1]+1;
}
void escgetna1(int *Na1)
{
  *Na1	=ShMemI[1]+1;
}
void ESCGETNA1(int *Na1)
{
  *Na1	=ShMemI[1]+1;
}
 
/**
 * Get the number of poloidal rays + 1 used internally by ESC. 
 * @param Np1 the number of poloidal sections + 1
 * @author L.E. Zakharov, A. Pletzer
 * @see escGetNa1
 */
void escGetNp1(int *Np1)
{
  *Np1	=ShMemI[2]+1;
}
void escgetnp1_(int *Np1)
{
  *Np1	=ShMemI[2]+1;
}
void escgetnp1(int *Np1)
{
  *Np1	=ShMemI[2]+1;
}
void ESCGETNP1(int *Np1)
{
  *Np1	=ShMemI[2]+1;
}
/**
 * Get the poloidal flux/(2*pi) [Wb/rad].
 * @param prof the returned profile
 * @param ns the size of the returned profile (input)
 * @author L.E. Zakharov, A. Pletzer
 * @see escGetPsi
 */

int ESgetProfile(int k,double *P, int n)
{
  int i;
  double *ld,dx;

  ld	=ESgY+2*k*ESNa1;
  dx	=(ESsa[ESNa]-ESsa[0])/(n-1);
  for(i=0; i < n; i++){
    ESSetSplA(ESsa[0]+dx*i);
    splRA(P,NULL,ld,ld+ESNa1);
    P++;
  }
  return(0);
}

void escGetPsibar(double *prof, int *ns){
  int i;
  ESgetProfile(0,prof,*ns);
  for(i=0; i < *ns; i++){
    prof[i]	=-prof[i];
  }
}
void escgetpsibar_(double *prof, int *ns){
  int i;
  ESgetProfile(0,prof,*ns);
  for(i=0; i < *ns; i++){
    prof[i]	=-prof[i];
  }
}
void escgetpsibar(double *prof, int *ns){
  int i;
  ESgetProfile(0,prof,*ns);
  for(i=0; i < *ns; i++){
    prof[i]	=-prof[i];
  }
}
void ESCGETPSIBAR(double *prof, int *ns){
  int i;
  ESgetProfile(0,prof,*ns);
  for(i=0; i < *ns; i++){
    prof[i]	=-prof[i];
  }
}
 
/**
 * Get the poloidal flux [Wb].
 * @param prof the returned profile
 * @param ns the size of the returned profile (input)
 * @author L.E. Zakharov, A. Pletzer
 * @see escGetPsibar
 */
void escGetPsi(double *prof, int *ns){
  int i;
  ESgetProfile(0,prof,*ns);
  for(i=0; i < *ns; i++){
    prof[i]	*=c2gp;
  }
}
void escgetpsi_(double *prof, int *ns){
  int i;
  ESgetProfile(0,prof,*ns);
  for(i=0; i < *ns; i++){
    prof[i]	*=c2gp;
  }
}
void escgetpsi(double *prof, int *ns){
  int i;
  ESgetProfile(0,prof,*ns);
  for(i=0; i < *ns; i++){
    prof[i]	*=c2gp;
  }
}
void ESCGETPSI(double *prof, int *ns){
  int i;
  ESgetProfile(0,prof,*ns);
  for(i=0; i < *ns; i++){
    prof[i]	*=c2gp;
  }
}

/**
 * Get the toroidal flux/(2*pi) [Wb/rad].
 * @param prof the returned profile
 * @param ns the size of the returned profile (input)
 * @author L.E. Zakharov, A. Pletzer
 * @see escGetPhi
 */
void escGetPhibar(double *prof, int *ns){
  ESgetProfile(1,prof,*ns);
}
void escgetphibar_(double *prof, int *ns){
  ESgetProfile(1,prof,*ns);
}
void escgetphibar(double *prof, int *ns){
  ESgetProfile(1,prof,*ns);
}
void ESCGETPHIBAR(double *prof, int *ns){
  ESgetProfile(1,prof,*ns);
}

/**
 * Get the toroidal flux [Wb].
 * @param prof the returned profile
 * @param ns the size of the returned profile (input)
 * @author L.E. Zakharov, A. Pletzer 
 * @see escGetPhibar
 */
void escGetPhi(double *prof, int *ns){
  int i;
  ESgetProfile(1,prof,*ns);
  for(i=0; i < *ns; i++){
    prof[i]	*=c2gp;
  }
}
void escgetphi_(double *prof, int *ns){
  int i;
  ESgetProfile(1,prof,*ns);
  for(i=0; i < *ns; i++){
    prof[i]	*=c2gp;
  }
}
void escgetphi(double *prof, int *ns){
  int i;
  ESgetProfile(1,prof,*ns);
  for(i=0; i < *ns; i++){
    prof[i]	*=c2gp;
  }
}
void ESCGETPHI(double *prof, int *ns){
  int i;
  ESgetProfile(1,prof,*ns);
  for(i=0; i < *ns; i++){
    prof[i]	*=c2gp;
  }
}
/**
 * Get the covariant toroidal magnetic field function [Tm].
 * @param prof the returned profile
 * @param ns the size of the returned profile (input)
 * @author L.E. Zakharov, A. Pletzer 
 * @see escGetIota escGetQ escGetP
 */
void escGetG(double *prof, int *ns){
  ESgetProfile(2,prof,*ns);
}
void escgetg_(double *prof, int *ns){
  ESgetProfile(2,prof,*ns);
}
void escgetg(double *prof, int *ns){
  ESgetProfile(2,prof,*ns);
}
void ESCGETG(double *prof, int *ns){
  ESgetProfile(2,prof,*ns);
}
/**
 * Get the 1/q profile [-].
 * @param prof the returned profile
 * @param ns the size of the returned profile (input)
 * @author L.E. Zakharov, A. Pletzer 
 * @see escGetQ escGetG escGetP
 */ 
void escGetIota(double *prof, int *ns){
  ESgetProfile(3,prof,*ns);
}
void escgetiota_(double *prof, int *ns){
  ESgetProfile(3,prof,*ns);
}
void escgetiota(double *prof, int *ns){
  ESgetProfile(3,prof,*ns);
}
void ESCGETIOTA(double *prof, int *ns){
  ESgetProfile(3,prof,*ns);
}

/**
 * Get the safety factor (q) profile [-].
 * @param prof the returned profile
 * @param ns the size of the returned profile (input)
 * @author L.E. Zakharov, A. Pletzer 
 * @see escGetIota escGetG escGetP
 */ 

void escGetQ(double *prof, int *ns){
  int i;
  ESgetProfile(3,prof,*ns);
  for(i=0; i < *ns; i++){
    prof[i]	=1./prof[i];
  }
}
void escgetq_(double *prof, int *ns){
  int i;
  ESgetProfile(3,prof,*ns);
  for(i=0; i < *ns; i++){
    prof[i]	=1./prof[i];
  }
}
void escgetq(double *prof, int *ns){
  int i;
  ESgetProfile(3,prof,*ns);
  for(i=0; i < *ns; i++){
    prof[i]	=1./prof[i];
  }
}
void ESCGETQ(double *prof, int *ns){
  int i;
  ESgetProfile(3,prof,*ns);
  for(i=0; i < *ns; i++){
    prof[i]	=1./prof[i];
  }
}

/**
 * Get the pressure in [mu0 Pa].
 * @param prof the returned profile
 * @param ns the size of the returned profile (input)
 * @author L.E. Zakharov, A. Pletzer 
 * @see escGetIota escGetG escGetQ
 */
void escGetP(double *prof, int *ns){
  ESgetProfile(5,prof,*ns);
}
void escgetp_(double *prof, int *ns){
  ESgetProfile(5,prof,*ns);
}
void escgetp(double *prof, int *ns){
  ESgetProfile(5,prof,*ns);
}
void ESCGETP(double *prof, int *ns){
  ESgetProfile(5,prof,*ns);
}
 
/** 
 * Get the Fourier coefficients of the R coordinate [m].
 * @param rcos the returned cosine coefficients of sizes [ns][nf]
 * @param rsin the returned sine coefficients
 * @param nf the number of Fourier coefficients (input)
 * @param ns the radial size (input)
 * @author L.E. Zakharov, A. Pletzer 
 * @see escGetFourierZ
 */

void escGetFourierR(double *rcos, double *rsin, int *nf, int *ns)
{
  int i,j,n,k;
  double *lc,*lc2,*ls,*ls2,dx;

  n	=*ns;
  k	=*nf < ESFp1 ? *nf : ESFp1;
  dx	=(ESsa[ESNa]-ESsa[0])/(n-1);
  for(i=0; i < n; i++){
    ESSetSplA(ESsa[0]+dx*i);
    lc	=rcT;
    lc2	=rcT2a;
    ls	=rsT;
    ls2	=rsT2a;
    splRA(rcos,NULL,lc,lc2);
    *rcos++	+=ESaR0[0];
    *rsin++	 =0.;
    for(j=1; j < k; j++){
      lc	+=ESNa1;
      lc2	+=ESNa1;
      splRA(rcos,NULL,lc,lc2);
      *rcos++ *=2.0;
      ls	+=ESNa1;
      ls2	+=ESNa1;
      splRA(rsin,NULL,ls,ls2);
      *rsin++ *=2.0;
    }
    for(j=k; j < *nf; j++){
      *rcos++	=0.0;
      *rsin++	=0.0;
    }
  }
  return;
}

void escgetfourierr_(double *rcos, double *rsin, int *nf, int *ns){
  escGetFourierR(rcos, rsin, nf, ns);
}
void escgetfourierr(double *rcos, double *rsin, int *nf, int *ns){
  escGetFourierR(rcos, rsin, nf, ns);
}
void ESCGETFOURIERR(double *rcos, double *rsin, int *nf, int *ns){
  escGetFourierR(rcos, rsin, nf, ns);
}

/** 
 * Get the R coordinates [m]. The poloidal index varies faster.
 * @param r the returned array of size [ns][nt1].
 * @param nt1 the number of poloidal sections + 1 (input)
 * @param ns the radial size (input)
 * @param clockwise poloidal angle orientation (1 for clockwise, 
 *        0 for counterclockwise)
 * @author L.E. Zakharov, A. Pletzer 
 * @see escGetZ
 */
void escGetR(double *r, int *nt1, int *ns, int *clockwise){
  double *rcos, *rsin;
  int NT1, NS, i, j, k, ni, nf;
  double sum, theta;
  NT1 = *nt1;
  NS  = *ns;
  nf = ESFp1;

  rcos =(double*) malloc( nf*NS*sizeof(double));
  rsin =(double*) malloc( nf*NS*sizeof(double));

  escGetFourierR(rcos, rsin, &nf, ns);

  if(*clockwise!=1){
    for(i=0; i<NS; i++){
      for(j=0; j<NT1; j++){
	sum = 0.0;
	theta = c2gp*(double)j/(double)(NT1-1);
	for(k=0; k<nf; k++){
	  ni = i*nf + k;
	  sum += rcos[ni]*cos(k*theta) + rsin[ni]*sin(k*theta);
	}
	r[i*NT1 + j] = sum;
      }
    }
  }else{
    for(i=0; i<NS; i++){
      for(j=0; j<NT1; j++){
	sum = 0.0;
	theta = c2gp*(double)(NT1-1-j)/(double)(NT1-1);
	for(k=0; k<nf; k++){
	  ni = i*nf + k;
	  sum += rcos[ni]*cos(k*theta) + rsin[ni]*sin(k*theta);
	}
	r[i*NT1 + j] = sum;
      }
    }
  }
  free(rcos);
  free(rsin);
}

void escgetr_(double *r, int *nt1, int *ns, int *clockwise)
{
  escGetR(r, nt1, ns, clockwise);
}
void escgetr(double *r, int *nt1, int *ns, int *clockwise)
{
  escGetR(r, nt1, ns, clockwise);
}
void ESCGETR(double *r, int *nt1, int *ns, int *clockwise)
{
  escGetR(r, nt1, ns, clockwise);
}
 
/** 
 * Get the Fourier coefficients of the Z coordinate [m].
 * @param zcos the returned cosine coefficients of sizes [ns][nf].
 * @param zsin the returned sine coefficients
 * @param nf the number of Fourier coefficients (input)
 * @param ns the radial size (input)
 * @author L.E. Zakharov, A. Pletzer 
 * @see escGetFourierR
 */

void escGetFourierZ(double *rcos, double *rsin, int *nf, int *ns)
{
  int i,j,n;
  double *lc,*lc2,*ls,*ls2,dx;

  n	=*ns;
  dx	=(ESsa[ESNa]-ESsa[0])/(n-1);
  for(i=0; i < n; i++){
    ESSetSplA(ESsa[0]+dx*i);
    splRA(rcos,NULL,rsT,rsT2a);
    *rcos++	+=ESaZ0[0];
    *rsin++	 =0.;
    splRA(rsin,NULL,ESsb,ESsb2a);
    *rsin++;
    *rcos++	=0;;
    for(j=2; j < *nf; j++){
      *rcos++	=0.;
      *rsin++	=0.;
    }
  }
  return;
}

void escgetfourierz_(double *zcos, double *zsin, int *nf, int *ns){
  escGetFourierZ(zcos, zsin, nf, ns);
}
void escgetfourierz(double *zcos, double *zsin, int *nf, int *ns){
  escGetFourierZ(zcos, zsin, nf, ns);
}
void ESCGETFOURIERZ(double *zcos, double *zsin, int *nf, int *ns){
  escGetFourierZ(zcos, zsin, nf, ns);
}

/** 
 * Get the Z coordinate [m]. The poloidal index varies faster.
 * @param r the returned array of size [ns][nt1].
 * @param nt1 the number of poloidal sections + 1 (input)
 * @param ns the radial size (input)
 * @param clockwise poloidal angle orientation (1 for clockwise, 
 *        0 for counterclockwise)
 * @author L.E. Zakharov, A. Pletzer 
 * @see escGetR
 */

void escGetZ(double *z, int *nt1, int *ns, int *clockwise){
  double *zcos, *zsin;
  int NT1, NS, i, j, k, ni, nf;
  double sum, theta;
  NT1 = *nt1;
  NS  = *ns;
  nf = ESFp1;

  zcos =(double*) malloc( nf*NS*sizeof(double));
  zsin =(double*) malloc( nf*NS*sizeof(double));

  escGetFourierZ(zcos, zsin, &nf, ns);

  if(*clockwise!=1){
    for(i=0; i<NS; i++){
      for(j=0; j<NT1; j++){
	sum = 0.0;
	theta = c2gp*(double)j/(double)(NT1-1);
	for(k=0; k<nf; k++){
	  ni = i*nf + k;
	  sum += zcos[ni]*cos(k*theta) + zsin[ni]*sin(k*theta);
	}
	z[i*NT1 + j] = sum;
      }
    }
  }else{
    for(i=0; i<NS; i++){
      for(j=0; j<NT1; j++){
	sum = 0.0;
	theta = c2gp*(double)(NT1-1-j)/(double)(NT1-1);
	for(k=0; k<nf; k++){
	  ni = i*nf + k;
	  sum += zcos[ni]*cos(k*theta) + zsin[ni]*sin(k*theta);
	}
	z[i*NT1 + j] = sum;
      }
    }
  }    
  free(zcos);
  free(zsin);
}
void escgetz_(double *z, int *nt1, int *ns, int * clockwise){
  escGetZ(z, nt1, ns, clockwise);
}
void escgetz(double *z, int *nt1, int *ns, int * clockwise){
  escGetZ(z, nt1, ns, clockwise);
}
void ESCGETZ(double *z, int *nt1, int *ns, int * clockwise){
  escGetZ(z, nt1, ns, clockwise);
}
 
void Esc_p_jparallel(
	      double	*Pressure
	      ,double	*Jparallel
	      ,double	*Rpv
	      ,double	*Zpv
	      ,int	*Npv
	      ,double	*RBtor
	      ,double	*Rext
	      )
{
  double a[129],da;
  int i,n1;
  n1	=21;
  da	=1./(n1-1);
  for(i=0; i < n1; i++){
    a[i]	=da*i;
  }
  i	=21;
  escin_(Pressure,Jparallel,a,&n1,&i,Rpv,Zpv,Npv,RBtor,Rext);
}
 
void Esc_p_q(double	*Pressure
	      ,double	*qprofile
	      ,double	*Rpv
	      ,double	*Zpv
	      ,int	*Npv
	      ,double	*RBtor
	      ,double	*Rext
	      )
{
  double a[129],da;
  int i,n1;
  n1	=21;
  da	=1./(n1-1);
  for(i=0; i < n1; i++){
    a[i]	=da*i;
  }
  i	=26;
  escin_(Pressure,qprofile,a,&n1,&i,Rpv,Zpv,Npv,RBtor,Rext);
}

/*   Total junk */void esc_p_q_(double	*Pressure
	      ,double	*qprofile
	      ,double	*Rpv
	      ,double	*Zpv
	      ,int	*Npv
	      ,double	*RBtor
	      ,double	*Rext
	      )
{
Esc_p_q(
	     Pressure
	     , qprofile
	     , Rpv
	     , Zpv
	     , Npv
	     , RBtor
	     , Rext
	      );
}
void esc_p_q(double	*Pressure
	      ,double	*qprofile
	      ,double	*Rpv
	      ,double	*Zpv
	      ,int	*Npv
	      ,double	*RBtor
	      ,double	*Rext
	      )
{
Esc_p_q(
	     Pressure
	     , qprofile
	     , Rpv
	     , Zpv
	     , Npv
	     , RBtor
	     , Rext
	      );
}
void ESC_P_Q(double	*Pressure
	      ,double	*qprofile
	      ,double	*Rpv
	      ,double	*Zpv
	      ,int	*Npv
	      ,double	*RBtor
	      ,double	*Rext
	      )
{
Esc_p_q(
	     Pressure
	     , qprofile
	     , Rpv
	     , Zpv
	     , Npv
	     , RBtor
	     , Rext
	      );
}
void esc_p_jparallel_(
	      double	*Pressure
	      ,double	*Jparallel
	      ,double	*Rpv
	      ,double	*Zpv
	      ,int	*Npv
	      ,double	*RBtor
	      ,double	*Rext
	      )
{
Esc_p_jparallel(
	      Pressure
	      , Jparallel
	      , Rpv
	      , Zpv
	      , Npv
	      , RBtor
	      , Rext
	      );
}
void esc_p_jparallel(
	      double	*Pressure
	      ,double	*Jparallel
	      ,double	*Rpv
	      ,double	*Zpv
	      ,int	*Npv
	      ,double	*RBtor
	      ,double	*Rext
	      )
{Esc_p_jparallel(
	      Pressure
	      , Jparallel
	      , Rpv
	      , Zpv
	      , Npv
	      , RBtor
	      , Rext
	      );
}
void ESC_P_JPARALLEL(
	      double	*Pressure
	      ,double	*Jparallel
	      ,double	*Rpv
	      ,double	*Zpv
	      ,int	*Npv
	      ,double	*RBtor
	      ,double	*Rext
	      )
{Esc_p_jparallel(
	      Pressure
	      , Jparallel
	      , Rpv
	      , Zpv
	      , Npv
	      , RBtor
	      , Rext
	      );
}

void esc00_(char *MachineRunID, int *na)
{
  LaunchEsc();
}

void esc00(char *MachineRunID, int *na)
{
  LaunchEsc();
}
