#include <math.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

extern double cr2,cr3,cr4,cr6,cr12,cgp,c2gp,cgp_4,cr2gp,cgm0,crgm0;

int ESNt,ESNt1;
double *gf1T,*cs1T,*sn1T;

static double Rmn,Rmx,Zmn,Zmx;
static double drSpl,dtSpl,dzSpl;

static double rCell,r1Cell,tCell,t1Cell,zCell,z1Cell,rhrCell,rhtCell,rhzCell;
int irCell,ktCell,jzCell,
J000=0,J100=0,J010=0,J001=0,J110=0,J101=0,J011=0,J111=0;
static double Pr0,Pr1,Pr2,Pr3,dPr0,dPr1,dPr2,dPr3
,Pt0,Pt1,Pt2,Pt3,dPt0,dPt1,dPt2,dPt3
,Pz0,Pz1,Pz2,Pz3,dPz0,dPz1,dPz2,dPz3;

static int SplN=0;

static int **Nr1Spl,**Nr2Spl,*Nz1Spl,*Nz2Spl
,NrSpl=0,NzSpl=0,nrSpl=20,nzSpl=20,nrSpl1,nzSpl1;

static int ***k2kSpl;
static double *xSpl,*ySpl,*zSpl,*rSpl;
static double *AR,*ARr,*ARt,*ARz,*ARrt,*ARrz,*ARtz,*ARrtz;
static double *AT,*ATr,*ATt,*ATz,*ATrt,*ATrz,*ATtz,*ATrtz;
static double *AZ,*AZr,*AZt,*AZz,*AZrt,*AZrz,*AZtz,*AZrtz;
static double *BR,*BRr,*BRt,*BRz,*BRrt,*BRrz,*BRtz,*BRrtz;
static double *BT,*BTr,*BTt,*BTz,*BTrt,*BTrz,*BTtz,*BTrtz;
static double *BZ,*BZr,*BZt,*BZz,*BZrt,*BZrz,*BZtz,*BZrtz;

int ESInitSplArrays()
{
  int n;
  double h;

  AR	=(double*)malloc(24*SplN*sizeof(double));
  if(AR == NULL){
    FailureAlarm((char*)AR,"ESInitSplGrid() - no memory for AR");
    ESexit(0);
  }
  ARr	=AR+SplN;
  ARt	=ARr+SplN;
  ARz	=ARt+SplN;
  ARrt	=ARz+SplN;
  ARrz	=ARrt+SplN;
  ARtz	=ARrz+SplN;
  ARrtz	=ARtz+SplN;
  AT	=ARrtz+SplN;
  ATr	=AT+SplN;
  ATt	=ATr+SplN;
  ATz	=ATt+SplN;
  ATrt	=ATz+SplN;
  ATrz	=ATrt+SplN;
  ATtz	=ATrz+SplN;
  ATrtz	=ATtz+SplN;
  AZ	=ATrtz+SplN;
  AZr	=AZ+SplN;
  AZt	=AZr+SplN;
  AZz	=AZt+SplN;
  AZrt	=AZz+SplN;
  AZrz	=AZrt+SplN;
  AZtz	=AZrz+SplN;
  AZrtz	=AZtz+SplN;
  
  BR	=(double*)malloc(24*SplN*sizeof(double));
  if(BR == NULL){
    FailureAlarm((char*)BR,"ESInitSplGrid() - no memory for BR");
    ESexit(0);
  }
  BRr	=BR+SplN;
  BRt	=BRr+SplN;
  BRz	=BRt+SplN;
  BRrt	=BRz+SplN;
  BRrz	=BRrt+SplN;
  BRtz	=BRrz+SplN;
  BRrtz	=BRtz+SplN;
  
  BT	=BRrtz+SplN;
  BTr	=BT+SplN;
  BTt	=BTr+SplN;
  BTz	=BTt+SplN;
  BTrt	=BTz+SplN;
  BTrz	=BTrt+SplN;
  BTtz	=BTrz+SplN;
  BTrtz	=BTtz+SplN;
  
  BZ	=BTrtz+SplN;
  BZr	=BZ+SplN;
  BZt	=BZr+SplN;
  BZz	=BZt+SplN;
  BZrt	=BZz+SplN;
  BZrz	=BZrt+SplN;
  BZtz	=BZrz+SplN;
  BZrtz	=BZtz+SplN;

  xSpl=(double*)malloc(4*SplN*sizeof(double));
  if(xSpl == NULL){
    FailureAlarm((char*)xSpl,"ESInitSplGrid() - no memory for xSpl");
    ESexit(0);
  }
  ySpl	=xSpl+SplN;
  zSpl	=ySpl+SplN;
  rSpl	=zSpl+SplN;

  gf1T	=(double*)malloc(3*ESNt1*sizeof(double));
  if(gf1T == NULL){
    FailureAlarm((char*)xSpl,"ESInitSplGrid() - no memory for gf1T");
    ESexit(0);
  }
  cs1T	=gf1T+ESNt1;
  sn1T	=cs1T+ESNt1;
  h	=c2gp/ESNt;
  for(n=0; n < ESNt; n++){
    gf1T[n]	=n*h;
    cs1T[n]	=cos(gf1T[n]);
    sn1T[n]	=sin(gf1T[n]);
  }
  gf1T[n]	=c2gp;
  cs1T[n]	=cs1T[0];
  sn1T[n]	=sn1T[0];
  return(0);
}

int ESDeInitSplArrays()
{
  free(gf1T);
  free(xSpl);
  free(BR);
  free(AR);
  SplN	=0;
  return(0);
}

int ESInitSplIntArrays0()
{
  Nz1Spl	=(int*)malloc(2*ESNt1*sizeof(int));
  if(Nz1Spl == NULL){
    FailureAlarm((char*)Nz1Spl,"ESInitSplIntArrays0() - no memory for Nz1Spl");
    ESexit(0);
  }
  Nz2Spl	=Nz1Spl+ESNt1;

  Nr1Spl	=(int**)malloc(2*ESNt1*sizeof(int*));
  if(Nr1Spl == NULL){
    FailureAlarm((char*)Nr1Spl,"ESInitSplIntArrays0() - no memory for Nr1Spl");
    ESexit(0);
  }
  Nr2Spl	=Nr1Spl+ESNt1;

  k2kSpl	=(int***)malloc(ESNt1*sizeof(int**));
  if(k2kSpl == NULL){
    FailureAlarm((char*)k2kSpl,"ESInitSplIntArrays0() - no memory for k2kSpl");
    ESexit(0);
  }
  return(0);
}

int ESDeInitSplIntArrays0()
{
  free(k2kSpl);
  free(Nr1Spl);
  free(Nz1Spl);
  return(0);
}

int ESInitSplIntArrays1()
{
  int n;

  for(n=0; n < ESNt1; n++){
    Nr1Spl[n]	=(int*)malloc(2*nzSpl1*sizeof(int));
    if(Nr1Spl[n] == NULL){
      FailureAlarm((char*)Nr1Spl[n],
		   "ESInitSplIntArrays1() - no memory for Nr1Spl[n]");
      ESexit(0);	
    }
    Nr2Spl[n]	=Nr1Spl[n]+nzSpl1;
    
    k2kSpl[n]	=(int**)malloc((Nz2Spl[n]-Nz1Spl[n]+1)*sizeof(int*));
    if(k2kSpl[n] == NULL){
      FailureAlarm((char*)k2kSpl[n],
		   "ESInitSplIntArrays1() - no memory for k2kSpl[n]");
      ESexit(0);
    }
  }
  return(0);
}

int ESDeInitSplIntArrays1()
{
  int n;
  for(n=0; n < ESNt1; n++){
    free(k2kSpl[n]);
    free(Nr1Spl[n]);
  }
  return(0);
}

int ESInitSplIntArrays2()
{
  int n,j,j1,J,i,I,jj,*vk;
  jj	=0;
  for(n=0; n < ESNt1; n++){
    J	=Nz2Spl[n]-Nz1Spl[n]+1;
    j1	=Nz1Spl[n];
    for(j=0; j < J; j++){
      I	=Nr2Spl[n][j1]-Nr1Spl[n][j1]+1;
      vk	=(int*)malloc(I*sizeof(int));
      if(vk == NULL){
	FailureAlarm((char*)vk,
		     "ESInitSplIntArrays2() - no memory for k2kSpl[n][j]");
	ESexit(0);
      }
      k2kSpl[n][j]	=vk;
      for(i=0; i < I; i++){
	vk[i]=jj++;
      }
      j1++;
    }
  }
  return(0);
}

int ESDeInitSplIntArrays2()
{
  int n,j,J;
  for(n=0; n < ESNt1; n++){
    J	=Nz2Spl[n]-Nz1Spl[n]+1;
    for(j=0; j < J; j++){
      free(k2kSpl[n][j]);
    }
  }
  return(0);
}

int ESSetSplRgFZ(double r,double gf,double z)
{
  int iR,kT,jZ;
  int i,j,kT1;
  double x,X,xx,XX;
  
  iR	=irCell;
  kT	=ktCell;
  jZ	=jzCell;
  while(r1Cell <= r){
    rCell	=r1Cell;
    r1Cell	+=drSpl;
    irCell++;
  }
  while(rCell > r){
    r1Cell	=rCell;
    rCell	-=drSpl;
    irCell--;
  }
  while(t1Cell <= gf){
    tCell	=t1Cell;
    t1Cell	+=dtSpl;
    ktCell++; 
   if(ktCell == ESNt){
      ktCell	=0;
    }
  }
  while(tCell > gf){
    t1Cell	=tCell;
    tCell	-=dtSpl;
    if(ktCell == 0){
      ktCell	=ESNt;
    }
    ktCell--;
  }
  while(z1Cell <= z){
    zCell	=z1Cell;
    z1Cell	+=dzSpl;
    jzCell++;
  }
  while(zCell > z){
    z1Cell	=zCell;
    zCell	-=dzSpl;
    jzCell--;
  }
  if(iR != irCell || kT != ktCell || jZ != jzCell){
    iR	=irCell;
    kT	=ktCell;
    jZ	=jzCell;
    
    kT1=kT+1;
    if(kT1 == ESNt)
      kT1=0;
    if(jZ >= Nz2Spl[kT] || jZ >= Nz2Spl[kT1]){
      printf("??? jZ=%3d >= Nz2[%3d]=%3d Nz2[%3d]=%3d - Out of spline grid%c\n"
	     ,jZ,kT,Nz2Spl[kT],kT1,Nz2Spl[kT1],7);
      printf("??? r=%10.3e gf=%10.3e %10.3e z=%10.3e kT kT1\n"
	     ,r,gf,gf*ESNt/c2gp,z);
      return(1);
    }
    j	=jZ-Nz1Spl[kT];
    if(j < 0 || iR >= Nr2Spl[kT][jZ]){
      if(j < 0)
	printf("??? jZ=%3d < Nz1[%3d]=%3d - Out of spline grid%c\n"
	       ,jZ,kT,Nz1Spl[kT],7);
      if(iR >= Nr2Spl[kT][jZ])
	printf("??? iR >= %3d < Nr2[%3d][%2d]=%3d - Out of spline grid%c\n"
	       ,iR,kT,jZ,Nr2Spl[kT][jZ],7);
      printf("??? r=%10.3e gf=%10.3e %10.3e z=%10.3e kT\n"
	     ,r,gf,gf*ESNt/c2gp,z);
      return(1);
    }
    i	=iR-Nr1Spl[kT][jZ];
    if(i < 0){
      printf("??? iR < %3d < Nr1[%3d][%2d]=%3d - Out of spline grid%c\n"
	     ,iR,kT,jZ,Nr1Spl[kT][jZ],7);
      printf("??? r=%10.3e gf=%10.3e %10.3e z=%10.3e kT jZ\n"
	     ,r,gf,gf*ESNt/c2gp,z);
      return(1);
    }
    J000	=k2kSpl[kT][j][i];
    J100	=J000+1;
    i	=iR-Nr1Spl[kT][jZ+1];
    if(i < 0 || iR >= Nr2Spl[kT][jZ+1]){
      if(i < 0)
	printf("??? iR=%3d < Nr1[%3d][%2d]=%3d - Out of spline grid%c\n"
	       ,iR,kT,jZ+1,Nr1Spl[kT][jZ+1],7);
      if(iR >= Nr2Spl[kT][jZ+1])
	printf("??? iR=%3d >= Nr2[%3d][%2d]=%3d - Out of spline grid%c\n"
	       ,iR,kT,jZ+1,Nr2Spl[kT][jZ+1],7);
      printf("??? r=%10.3e gf=%10.3e %10.3e z=%10.3e kT jZ+1\n"
	     ,r,gf,gf*ESNt/c2gp,z);
      return(1);
    }
    J001	=k2kSpl[kT][j+1][i];
    J101	=J001+1;
    j	=jZ-Nz1Spl[kT1];
    if(j < 0 || iR >= Nr2Spl[kT1][jZ]){
      if(j < 0)
	printf("??? jZ=%3d < Nz1[%3d]=%3d - Out of spline grid%c\n"
	       ,jZ,kT1,Nz1Spl[kT1],7);
      if(iR >= Nr2Spl[kT1][jZ])
	printf("??? iR >= %3d < Nr2[%3d][%2d]=%3d - Out of spline grid%c\n"
	       ,iR,kT1,jZ,Nr2Spl[kT1][jZ],7);
      printf("??? r=%10.3e gf=%10.3e %10.3e z=%10.3e kT1 jZ\n"
	     ,r,gf,gf*ESNt/c2gp,z);
      return(1);
    }
    i	=iR-Nr1Spl[kT1][jZ];
    if(i < 0){
      if(i < 0)
	printf("??? iR=%3d < Nr1[%3d][%2d]=%3d - Out of spline grid%c\n"
	       ,iR,kT1,jZ,Nr1Spl[kT1][jZ],7);
      printf("??? r=%10.3e gf=%10.3e %10.3e z=%10.3e kT1 jZ\n"
	     ,r,gf,gf*ESNt/c2gp,z);
      return(1);
    }
    J010	=k2kSpl[kT1][j][i];
    J110	=J010+1;
    i	=iR-Nr1Spl[kT1][jZ+1];
    if(i < 0 || iR >= Nr2Spl[kT1][jZ+1]){
      if(i < 0)
	printf("??? iR=%3d < Nr1[%3d][%2d]=%3d - Out of spline grid%c\n"
	       ,iR,kT1,jZ+1,Nr1Spl[kT1][jZ+1],7);
      if(iR >= Nr2Spl[kT1][jZ+1])
	printf("??? iR >= %3d < Nr2[%3d][%2d]=%3d - Out of spline grid%c\n"
	       ,iR,kT1,jZ+1,Nr2Spl[kT1][jZ+1],7);
      printf("??? r=%10.3e gf=%10.3e %10.3e z=%10.3e kT1 jZ+1\n"
	     ,r,gf,gf*ESNt/c2gp,z);
      return(1);
    }
    J011	=k2kSpl[kT1][j+1][i];
    J111	=J011+1;
  }
  x	=(r-rCell)*rhrCell;
  xx	=x*x;
  X	=1.-x;
  XX	=X*X;
  Pr0=XX*(3.-2.*X);
  Pr1=xx*(3.-2.*x);
  Pr2=XX*x*drSpl;
  Pr3=-xx*X*drSpl;
  
  x	=(gf-tCell)*rhtCell;
  xx	=x*x;
  X	=1.-x;
  XX	=X*X;
  Pt0=XX*(3.-2.*X);
  Pt1=xx*(3.-2.*x);
  Pt2=XX*x*dtSpl;
  Pt3=-xx*X*dtSpl;
  
  x	=(z-zCell)*rhzCell;
  xx	=x*x;
  X	=1.-x;
  XX	=X*X;
  Pz0=XX*(3.-2.*X);
  Pz1=xx*(3.-2.*x);
  Pz2=XX*x*dzSpl;
  Pz3=-xx*X*dzSpl;
  return(0);
}

int ESSetSplDerRTZ(double r,double gf,double z)
{
  int iR,kT,jZ;
  int i,j,kT1;
  double x,X,xx,XX,Xx;
  
  iR	=irCell;
  kT	=ktCell;
  jZ	=jzCell;
  while(r1Cell <= r){
    rCell	=r1Cell;
    r1Cell	+=drSpl;
    irCell++;
  }
  while(rCell > r){
    r1Cell	=rCell;
    rCell	-=drSpl;
    irCell--;
  }
  while(t1Cell <= gf){
    tCell	=t1Cell;
    t1Cell	+=dtSpl;
    if(ktCell == ESNt){
      ktCell	=0;
    }
    ktCell++;
  }
  while(tCell > gf){
    t1Cell	=tCell;
    tCell	-=dtSpl;
    if(ktCell == 0){
      ktCell	=ESNt;
    }
    ktCell--;
  }
  while(z1Cell <= z){
    zCell	=z1Cell;
    z1Cell	+=dzSpl;
    jzCell++;
  }
  while(zCell > z){
    z1Cell	=zCell;
    zCell	-=dzSpl;
    jzCell--;
  }
  if(iR != irCell || kT != ktCell || jZ != jzCell){
    iR	=irCell;
    kT	=ktCell;
    jZ	=jzCell;
    kT1	=kT+1;
    if(kT1 == ESNt)
      kT1=0;
  
    if(jZ >= Nz2Spl[kT] || jZ >= Nz2Spl[kT1]){
      printf("??? jZ=%3d >= Nz2[%3d]=%3d Nz2[%3d]=%3d - Out of spline grid%c\n"
	     ,jZ,kT,Nz2Spl[kT],kT1,Nz2Spl[kT1],7);
      return(1);
    }
    j	=jZ-Nz1Spl[kT];
    if(j < 0 || iR >= Nr2Spl[kT][jZ]){
      if(j < 0)
	printf("??? jZ=%3d < Nz1[%3d]=%3d - Out of spline grid%c\n"
	       ,jZ,kT,Nz1Spl[kT],7);
      if(iR >= Nr2Spl[kT][jZ])
	printf("??? iR >= %3d < Nr2[%3d][%2d]=%3d - Out of spline grid%c\n"
	       ,iR,kT,jZ,Nr2Spl[kT][jZ],7);
      return(1);
    }
    i	=iR-Nr1Spl[kT][jZ];
    if(i < 0){
      printf("??? iR < %3d < Nr1[%3d][%2d]=%3d - Out of spline grid%c\n"
	     ,iR,kT,jZ,Nr1Spl[kT][jZ],7);
      return(1);
    }
    J000	=k2kSpl[kT][j][i];
    J100	=J000+1;
    i	=iR-Nr1Spl[kT][jZ+1];
    if(i < 0 || iR >= Nr2Spl[kT][jZ+1]){
      if(i < 0)
	printf("??? iR=%3d < Nr1[%3d][%2d]=%3d - Out of spline grid%c\n"
	       ,iR,kT,jZ+1,Nr1Spl[kT][jZ+1],7);
      if(iR >= Nr2Spl[kT][jZ+1])
	printf("??? iR=%3d >= Nr2[%3d][%2d]=%3d - Out of spline grid%c\n"
	       ,iR,kT,jZ+1,Nr2Spl[kT][jZ+1],7);
      return(1);
    }
    J001	=k2kSpl[kT][j+1][i];
    J101	=J001+1;
    j	=jZ-Nz1Spl[kT1];
    if(j < 0 || iR >= Nr2Spl[kT1][jZ]){
      if(j < 0)
	printf("??? jZ=%3d < Nz1[%3d]=%3d - Out of spline grid%c\n"
	       ,jZ,kT1,Nz1Spl[kT1],7);
      if(iR >= Nr2Spl[kT1][jZ])
	printf("??? iR >= %3d < Nr2[%3d][%2d]=%3d - Out of spline grid%c\n"
	       ,iR,kT1,jZ,Nr2Spl[kT1][jZ],7);
      return(1);
    }
    i	=iR-Nr1Spl[kT1][jZ];
    if(i < 0){
      if(i < 0)
	printf("??? iR=%3d < Nr1[%3d][%2d]=%3d - Out of spline grid%c\n"
	       ,iR,kT1,jZ,Nr1Spl[kT1][jZ],7);
      return(1);
    }
    J010	=k2kSpl[kT1][j][i];
    J110	=J010+1;
    i	=iR-Nr1Spl[kT1][jZ+1];
    if(i < 0 || iR >= Nr2Spl[kT1][jZ+1]){
      if(i < 0)
	printf("??? iR=%3d < Nr1[%3d][%2d]=%3d - Out of spline grid%c\n"
	       ,iR,kT1,jZ+1,Nr1Spl[kT1][jZ+1],7);
      if(iR >= Nr2Spl[kT1][jZ+1])
	printf("??? iR >= %3d < Nr2[%3d][%2d]=%3d - Out of spline grid%c\n"
	       ,iR,kT1,jZ+1,Nr2Spl[kT1][jZ+1],7);
      return(1);
    }
    J011	=k2kSpl[kT1][j+1][i];
    J111	=J011+1;
  }
  x	=(r-rCell)*rhrCell;
  xx	=x*x;
  X	=1.-x;
  XX	=X*X;
  Xx	=2.*x*X;
  Pr0	=XX*(3.-2.*X);
  Pr1	=xx*(3.-2.*x);
  Pr2	=XX*x*drSpl;
  Pr3	=-xx*X*drSpl;

  dPr1	=3.*rhrCell*Xx;
  dPr0	=-dPr1;
  dPr2	=(XX-Xx);
  dPr3	=(xx-Xx);
  
  x	=(gf-tCell)*rhtCell;
  xx	=x*x;
  X	=1.-x;
  XX	=X*X;
  Xx	=2.*x*X;
  Pt0	=XX*(3.-2.*X);
  Pt1	=xx*(3.-2.*x);
  Pt2	=XX*x*dtSpl;
  Pt3=	-xx*X*dtSpl;
  dPt1	=3.*rhtCell*Xx;
  dPt0	=-dPt1;
  dPt2	=(XX-Xx);
  dPt3	=(xx-Xx);
  
  x	=(z-zCell)*rhzCell;
  xx	=x*x;
  X	=1.-x;
  XX	=X*X;
  Xx	=2.*x*X;
  Pz0	=XX*(3.-2.*X);
  Pz1	=xx*(3.-2.*x);
  Pz2	=XX*x*dzSpl;
  Pz3	=-xx*X*dzSpl;
  dPz1	=3.*rhzCell*Xx;
  dPz0	=-dPz1;
  dPz2	=(XX-Xx);
  dPz3	=(xx-Xx);
  return(0);
}

int ESSplineArtz(double R,double T,double Z,double *Ar,double *At,double *Az
		 ,double *Br,double *Bt,double *Bz)
{
  ESSetSplRgFZ(R,T,Z);

  *At	=(Pt0*(Pr0*(Pz0*AT[J000]
		    +Pz1*AT[J001]
		    +Pz2*ATz[J000]
		    +Pz3*ATz[J001]
		    )
	       +Pr1*(Pz0*AT[J100]
		     +Pz1*AT[J101]
		     +Pz2*ATz[J100]
		     +Pz3*ATz[J101]
		     )
	       +Pr2*(Pz0*ATr[J000]
		     +Pz1*ATr[J001]
		     +Pz2*ATrz[J000]
		     +Pz3*ATrz[J001]
		     )
	       +Pr3*(Pz0*ATr[J100]
		     +Pz1*ATr[J101]
		     +Pz2*ATrz[J100]
		     +Pz3*ATrz[J101]
		     )
	       )
	  +Pt1*(Pr0*(Pz0*AT[J010]
		     +Pz1*AT[J011]
		     +Pz2*ATz[J010]
		     +Pz3*ATz[J011]
		     )
		+Pr1*(Pz0*AT[J110]
		      +Pz1*AT[J111]
		      +Pz2*ATz[J110]
		      +Pz3*ATz[J111]
		      )
		+Pr2*(Pz0*ATr[J010]
		      +Pz1*ATr[J011]
		      +Pz2*ATrz[J010]
		      +Pz3*ATrz[J011]
		      )
		+Pr3*(Pz0*ATr[J110]
		      +Pz1*ATr[J111]
		      +Pz2*ATrz[J110]
		      +Pz3*ATrz[J111]
		      )
		)
	  +Pt2*(Pr0*(Pz0*ATt[J000]
		     +Pz1*ATt[J001]
		     +Pz2*ATtz[J000]
		     +Pz3*ATtz[J001]
		     )
		+Pr1*(Pz0*ATt[J100]
		      +Pz1*ATt[J101]
		      +Pz2*ATtz[J100]
		      +Pz3*ATtz[J101]
		      )
		  +Pr2*(Pz0*ATrt[J000]
			+Pz1*ATrt[J001]
			+Pz2*ATrtz[J000]
			+Pz3*ATrtz[J001]
			)
		  +Pr3*(Pz0*ATrt[J100]
			+Pz1*ATrt[J101]
			+Pz2*ATrtz[J100]
			+Pz3*ATrtz[J101]
			)
		  )
	    +Pt3*(Pr0*(Pz0*ATt[J010]
		       +Pz1*ATt[J011]
		       +Pz2*ATtz[J010]
		       +Pz3*ATtz[J011]
		       )
		  +Pr1*(Pz0*ATt[J110]
			+Pz1*ATt[J111]
			+Pz2*ATtz[J110]
			+Pz3*ATtz[J111]
			)
		  +Pr2*(Pz0*ATrt[J010]
			+Pz1*ATrt[J011]
			+Pz2*ATrtz[J010]
			+Pz3*ATrtz[J011]
			)
		  +Pr3*(Pz0*ATrt[J110]
			+Pz1*ATrt[J111]
			+Pz2*ATrtz[J110]
			+Pz3*ATrtz[J111]
			)
		  )
	    );
  
  *Ar	=(Pt0*(Pr0*(Pz0*AR[J000]
		    +Pz1*AR[J001]
		    +Pz2*ARz[J000]
		    +Pz3*ARz[J001]
		    )
		 +Pr1*(Pz0*AR[J100]
		       +Pz1*AR[J101]
		       +Pz2*ARz[J100]
		       +Pz3*ARz[J101]
		       )
		 +Pr2*(Pz0*ARr[J000]
		       +Pz1*ARr[J001]
		       +Pz2*ARrz[J000]
		       +Pz3*ARrz[J001]
		       )
		 +Pr3*(Pz0*ARr[J100]
		       +Pz1*ARr[J101]
		       +Pz2*ARrz[J100]
		       +Pz3*ARrz[J101]
		       )
		 )
	    +Pt1*(Pr0*(Pz0*AR[J010]
		       +Pz1*AR[J011]
		       +Pz2*ARz[J010]
		       +Pz3*ARz[J011]
		       )
		  +Pr1*(Pz0*AR[J110]
			+Pz1*AR[J111]
			+Pz2*ARz[J110]
			+Pz3*ARz[J111]
			)
		  +Pr2*(Pz0*ARr[J010]
			+Pz1*ARr[J011]
			+Pz2*ARrz[J010]
			+Pz3*ARrz[J011]
			)
		  +Pr3*(Pz0*ARr[J110]
			+Pz1*ARr[J111]
			+Pz2*ARrz[J110]
			+Pz3*ARrz[J111]
			)
		  )
	    +Pt2*(Pr0*(Pz0*ARt[J000]
		       +Pz1*ARt[J001]
		       +Pz2*ARtz[J000]
		       +Pz3*ARtz[J001]
		       )
		  +Pr1*(Pz0*ARt[J100]
			+Pz1*ARt[J101]
			+Pz2*ARtz[J100]
			+Pz3*ARtz[J101]
			)
		  +Pr2*(Pz0*ARrt[J000]
			+Pz1*ARrt[J001]
			+Pz2*ARrtz[J000]
			+Pz3*ARrtz[J001]
			)
		  +Pr3*(Pz0*ARrt[J100]
			+Pz1*ARrt[J101]
			+Pz2*ARrtz[J100]
			+Pz3*ARrtz[J101]
			)
		  )
	    +Pt3*(Pr0*(Pz0*ARt[J010]
		       +Pz1*ARt[J011]
		       +Pz2*ARtz[J010]
		       +Pz3*ARtz[J011]
		       )
		  +Pr1*(Pz0*ARt[J110]
			+Pz1*ARt[J111]
			+Pz2*ARtz[J110]
			+Pz3*ARtz[J111]
			)
		  +Pr2*(Pz0*ARrt[J010]
			+Pz1*ARrt[J011]
			+Pz2*ARrtz[J010]
			+Pz3*ARrtz[J011]
			)
		  +Pr3*(Pz0*ARrt[J110]
			+Pz1*ARrt[J111]
			+Pz2*ARrtz[J110]
			+Pz3*ARrtz[J111]
			)
		  )
	    );
  
  *Az	=(Pt0*(Pr0*(Pz0*AZ[J000]
		      +Pz1*AZ[J001]
		      +Pz2*AZz[J000]
		      +Pz3*AZz[J001]
		      )
		 +Pr1*(Pz0*AZ[J100]
		       +Pz1*AZ[J101]
		       +Pz2*AZz[J100]
		       +Pz3*AZz[J101]
		       )
		 +Pr2*(Pz0*AZr[J000]
		       +Pz1*AZr[J001]
		       +Pz2*AZrz[J000]
		       +Pz3*AZrz[J001]
		       )
		 +Pr3*(Pz0*AZr[J100]
		       +Pz1*AZr[J101]
		       +Pz2*AZrz[J100]
		       +Pz3*AZrz[J101]
		       )
		 )
	    +Pt1*(Pr0*(Pz0*AZ[J010]
		       +Pz1*AZ[J011]
		       +Pz2*AZz[J010]
		       +Pz3*AZz[J011]
		       )
		  +Pr1*(Pz0*AZ[J110]
			+Pz1*AZ[J111]
			+Pz2*AZz[J110]
			+Pz3*AZz[J111]
			)
		  +Pr2*(Pz0*AZr[J010]
			+Pz1*AZr[J011]
			+Pz2*AZrz[J010]
			+Pz3*AZrz[J011]
			)
		  +Pr3*(Pz0*AZr[J110]
			+Pz1*AZr[J111]
			+Pz2*AZrz[J110]
			+Pz3*AZrz[J111]
			)
		  )
	    +Pt2*(Pr0*(Pz0*AZt[J000]
		       +Pz1*AZt[J001]
		       +Pz2*AZtz[J000]
		       +Pz3*AZtz[J001]
		       )
		  +Pr1*(Pz0*AZt[J100]
			+Pz1*AZt[J101]
			+Pz2*AZtz[J100]
			+Pz3*AZtz[J101]
			)
		  +Pr2*(Pz0*AZrt[J000]
			+Pz1*AZrt[J001]
			+Pz2*AZrtz[J000]
			+Pz3*AZrtz[J001]
			)
		  +Pr3*(Pz0*AZrt[J100]
			+Pz1*AZrt[J101]
			+Pz2*AZrtz[J100]
			+Pz3*AZrtz[J101]
			)
		  )
	    +Pt3*(Pr0*(Pz0*AZt[J010]
		       +Pz1*AZt[J011]
		       +Pz2*AZtz[J010]
		       +Pz3*AZtz[J011]
		       )
		  +Pr1*(Pz0*AZt[J110]
			+Pz1*AZt[J111]
			+Pz2*AZtz[J110]
			+Pz3*AZtz[J111]
			)
		  +Pr2*(Pz0*AZrt[J010]
			+Pz1*AZrt[J011]
			+Pz2*AZrtz[J010]
			+Pz3*AZrtz[J011]
			)
		  +Pr3*(Pz0*AZrt[J110]
			+Pz1*AZrt[J111]
			+Pz2*AZrtz[J110]
			+Pz3*AZrtz[J111]
			)
		  )
	    );


  *Bt	=(Pt0*(Pr0*(Pz0*BT[J000]
		    +Pz1*BT[J001]
		    +Pz2*BTz[J000]
		    +Pz3*BTz[J001]
		    )
	       +Pr1*(Pz0*BT[J100]
		     +Pz1*BT[J101]
		     +Pz2*BTz[J100]
		     +Pz3*BTz[J101]
		     )
	       +Pr2*(Pz0*BTr[J000]
		     +Pz1*BTr[J001]
		     +Pz2*BTrz[J000]
		     +Pz3*BTrz[J001]
		     )
	       +Pr3*(Pz0*BTr[J100]
		     +Pz1*BTr[J101]
		     +Pz2*BTrz[J100]
		     +Pz3*BTrz[J101]
		     )
	       )
	  +Pt1*(Pr0*(Pz0*BT[J010]
		     +Pz1*BT[J011]
		     +Pz2*BTz[J010]
		     +Pz3*BTz[J011]
		     )
		+Pr1*(Pz0*BT[J110]
		      +Pz1*BT[J111]
		      +Pz2*BTz[J110]
		      +Pz3*BTz[J111]
		      )
		+Pr2*(Pz0*BTr[J010]
		      +Pz1*BTr[J011]
		      +Pz2*BTrz[J010]
		      +Pz3*BTrz[J011]
		      )
		+Pr3*(Pz0*BTr[J110]
		      +Pz1*BTr[J111]
		      +Pz2*BTrz[J110]
		      +Pz3*BTrz[J111]
		      )
		)
	  +Pt2*(Pr0*(Pz0*BTt[J000]
		     +Pz1*BTt[J001]
		     +Pz2*BTtz[J000]
		     +Pz3*BTtz[J001]
		     )
		+Pr1*(Pz0*BTt[J100]
		      +Pz1*BTt[J101]
		      +Pz2*BTtz[J100]
		      +Pz3*BTtz[J101]
		      )
		  +Pr2*(Pz0*BTrt[J000]
			+Pz1*BTrt[J001]
			+Pz2*BTrtz[J000]
			+Pz3*BTrtz[J001]
			)
		  +Pr3*(Pz0*BTrt[J100]
			+Pz1*BTrt[J101]
			+Pz2*BTrtz[J100]
			+Pz3*BTrtz[J101]
			)
		  )
	    +Pt3*(Pr0*(Pz0*BTt[J010]
		       +Pz1*BTt[J011]
		       +Pz2*BTtz[J010]
		       +Pz3*BTtz[J011]
		       )
		  +Pr1*(Pz0*BTt[J110]
			+Pz1*BTt[J111]
			+Pz2*BTtz[J110]
			+Pz3*BTtz[J111]
			)
		  +Pr2*(Pz0*BTrt[J010]
			+Pz1*BTrt[J011]
			+Pz2*BTrtz[J010]
			+Pz3*BTrtz[J011]
			)
		  +Pr3*(Pz0*BTrt[J110]
			+Pz1*BTrt[J111]
			+Pz2*BTrtz[J110]
			+Pz3*BTrtz[J111]
			)
		  )
	    );
  
  *Br	=(Pt0*(Pr0*(Pz0*BR[J000]
		    +Pz1*BR[J001]
		    +Pz2*BRz[J000]
		    +Pz3*BRz[J001]
		    )
		 +Pr1*(Pz0*BR[J100]
		       +Pz1*BR[J101]
		       +Pz2*BRz[J100]
		       +Pz3*BRz[J101]
		       )
		 +Pr2*(Pz0*BRr[J000]
		       +Pz1*BRr[J001]
		       +Pz2*BRrz[J000]
		       +Pz3*BRrz[J001]
		       )
		 +Pr3*(Pz0*BRr[J100]
		       +Pz1*BRr[J101]
		       +Pz2*BRrz[J100]
		       +Pz3*BRrz[J101]
		       )
		 )
	    +Pt1*(Pr0*(Pz0*BR[J010]
		       +Pz1*BR[J011]
		       +Pz2*BRz[J010]
		       +Pz3*BRz[J011]
		       )
		  +Pr1*(Pz0*BR[J110]
			+Pz1*BR[J111]
			+Pz2*BRz[J110]
			+Pz3*BRz[J111]
			)
		  +Pr2*(Pz0*BRr[J010]
			+Pz1*BRr[J011]
			+Pz2*BRrz[J010]
			+Pz3*BRrz[J011]
			)
		  +Pr3*(Pz0*BRr[J110]
			+Pz1*BRr[J111]
			+Pz2*BRrz[J110]
			+Pz3*BRrz[J111]
			)
		  )
	    +Pt2*(Pr0*(Pz0*BRt[J000]
		       +Pz1*BRt[J001]
		       +Pz2*BRtz[J000]
		       +Pz3*BRtz[J001]
		       )
		  +Pr1*(Pz0*BRt[J100]
			+Pz1*BRt[J101]
			+Pz2*BRtz[J100]
			+Pz3*BRtz[J101]
			)
		  +Pr2*(Pz0*BRrt[J000]
			+Pz1*BRrt[J001]
			+Pz2*BRrtz[J000]
			+Pz3*BRrtz[J001]
			)
		  +Pr3*(Pz0*BRrt[J100]
			+Pz1*BRrt[J101]
			+Pz2*BRrtz[J100]
			+Pz3*BRrtz[J101]
			)
		  )
	    +Pt3*(Pr0*(Pz0*BRt[J010]
		       +Pz1*BRt[J011]
		       +Pz2*BRtz[J010]
		       +Pz3*BRtz[J011]
		       )
		  +Pr1*(Pz0*BRt[J110]
			+Pz1*BRt[J111]
			+Pz2*BRtz[J110]
			+Pz3*BRtz[J111]
			)
		  +Pr2*(Pz0*BRrt[J010]
			+Pz1*BRrt[J011]
			+Pz2*BRrtz[J010]
			+Pz3*BRrtz[J011]
			)
		  +Pr3*(Pz0*BRrt[J110]
			+Pz1*BRrt[J111]
			+Pz2*BRrtz[J110]
			+Pz3*BRrtz[J111]
			)
		  )
	    );
  *Bz	=(Pt0*(Pr0*(Pz0*BZ[J000]
		      +Pz1*BZ[J001]
		      +Pz2*BZz[J000]
		      +Pz3*BZz[J001]
		      )
		 +Pr1*(Pz0*BZ[J100]
		       +Pz1*BZ[J101]
		       +Pz2*BZz[J100]
		       +Pz3*BZz[J101]
		       )
		 +Pr2*(Pz0*BZr[J000]
		       +Pz1*BZr[J001]
		       +Pz2*BZrz[J000]
		       +Pz3*BZrz[J001]
		       )
		 +Pr3*(Pz0*BZr[J100]
		       +Pz1*BZr[J101]
		       +Pz2*BZrz[J100]
		       +Pz3*BZrz[J101]
		       )
		 )
	    +Pt1*(Pr0*(Pz0*BZ[J010]
		       +Pz1*BZ[J011]
		       +Pz2*BZz[J010]
		       +Pz3*BZz[J011]
		       )
		  +Pr1*(Pz0*BZ[J110]
			+Pz1*BZ[J111]
			+Pz2*BZz[J110]
			+Pz3*BZz[J111]
			)
		  +Pr2*(Pz0*BZr[J010]
			+Pz1*BZr[J011]
			+Pz2*BZrz[J010]
			+Pz3*BZrz[J011]
			)
		  +Pr3*(Pz0*BZr[J110]
			+Pz1*BZr[J111]
			+Pz2*BZrz[J110]
			+Pz3*BZrz[J111]
			)
		  )
	    +Pt2*(Pr0*(Pz0*BZt[J000]
		       +Pz1*BZt[J001]
		       +Pz2*BZtz[J000]
		       +Pz3*BZtz[J001]
		       )
		  +Pr1*(Pz0*BZt[J100]
			+Pz1*BZt[J101]
			+Pz2*BZtz[J100]
			+Pz3*BZtz[J101]
			)
		  +Pr2*(Pz0*BZrt[J000]
			+Pz1*BZrt[J001]
			+Pz2*BZrtz[J000]
			+Pz3*BZrtz[J001]
			)
		  +Pr3*(Pz0*BZrt[J100]
			+Pz1*BZrt[J101]
			+Pz2*BZrtz[J100]
			+Pz3*BZrtz[J101]
			)
		  )
	    +Pt3*(Pr0*(Pz0*BZt[J010]
		       +Pz1*BZt[J011]
		       +Pz2*BZtz[J010]
		       +Pz3*BZtz[J011]
		       )
		  +Pr1*(Pz0*BZt[J110]
			+Pz1*BZt[J111]
			+Pz2*BZtz[J110]
			+Pz3*BZtz[J111]
			)
		  +Pr2*(Pz0*BZrt[J010]
			+Pz1*BZrt[J011]
			+Pz2*BZrtz[J010]
			+Pz3*BZrtz[J011]
			)
		  +Pr3*(Pz0*BZrt[J110]
			+Pz1*BZrt[J111]
			+Pz2*BZrtz[J110]
			+Pz3*BZrtz[J111]
			)
		  )
	    );
  return(0);
}

int ESSetSplRZ(double r,double z,int n)
{
  int iR,kT,jZ;
  int i,j,kT1;
  double x,X,xx,XX;
  
  iR	=irCell;
  kT	=ktCell;
  jZ	=jzCell;
  while(r1Cell <= r){
    rCell	=r1Cell;
    r1Cell	+=drSpl;
    irCell++;
  }
  while(rCell > r){
    r1Cell	=rCell;
    rCell	-=drSpl;
    irCell--;
  }
  tCell	=gf1T[n];
  t1Cell=tCell+dtSpl;
  ktCell= n == ESNt ? 0 : n; 
  while(z1Cell <= z){
    zCell	=z1Cell;
    z1Cell	+=dzSpl;
    jzCell++;
  }
  while(zCell > z){
    z1Cell	=zCell;
    zCell	-=dzSpl;
    jzCell--;
  }
  if(iR != irCell || kT != ktCell || jZ != jzCell){
    iR	=irCell;
    kT	=ktCell;
    jZ	=jzCell;
   
    kT1=kT+1;
    if(kT1 == ESNt)
      kT1=0;
    if(jZ >= Nz2Spl[kT] || jZ >= Nz2Spl[kT1]){
      printf("??? jZ=%3d >= Nz2[%3d]=%3d Nz2[%3d]=%3d - Out of spline grid%c\n"
	     ,jZ,kT,Nz2Spl[kT],kT1,Nz2Spl[kT1],7);
      printf("??? r=%10.3e n=%d z=%10.3e kT kT1\n",r,n,z);
      return(1);
    }
    j	=jZ-Nz1Spl[kT];
    if(j < 0 || iR >= Nr2Spl[kT][jZ]){
      if(j < 0)
	printf("??? jZ=%3d < Nz1[%3d]=%3d - Out of spline grid%c\n"
	       ,jZ,kT,Nz1Spl[kT],7);
      if(iR >= Nr2Spl[kT][jZ])
	printf("??? iR >= %3d < Nr2[%3d][%2d]=%3d - Out of spline grid%c\n"
	       ,iR,kT,jZ,Nr2Spl[kT][jZ],7);
      printf("??? r=%10.3e n=%d z=%10.3e kT\n",r,n,z);
      return(1);
    }
    i	=iR-Nr1Spl[kT][jZ];
    if(i < 0){
      printf("??? iR < %3d < Nr1[%3d][%2d]=%3d - Out of spline grid%c\n"
	     ,iR,kT,jZ,Nr1Spl[kT][jZ],7);
      printf("??? r=%10.3e n=%d z=%10.3e kT jZ\n",r,n,z);
      return(1);
    }
    J000	=k2kSpl[kT][j][i];
    J100	=J000+1;
    i	=iR-Nr1Spl[kT][jZ+1];
    if(i < 0 || iR >= Nr2Spl[kT][jZ+1]){
      if(i < 0)
	printf("??? iR=%3d < Nr1[%3d][%2d]=%3d - Out of spline grid%c\n"
	       ,iR,kT,jZ+1,Nr1Spl[kT][jZ+1],7);
      if(iR >= Nr2Spl[kT][jZ+1])
	printf("??? iR=%3d >= Nr2[%3d][%2d]=%3d - Out of spline grid%c\n"
	       ,iR,kT,jZ+1,Nr2Spl[kT][jZ+1],7);
      printf("??? r=%10.3e n=%d z=%10.3e kT jZ+1\n",r,n,z);
      return(1);
    }
    J001	=k2kSpl[kT][j+1][i];
    J101	=J001+1;
    j	=jZ-Nz1Spl[kT1];
    if(j < 0 || iR >= Nr2Spl[kT1][jZ]){
      if(j < 0)
	printf("??? jZ=%3d < Nz1[%3d]=%3d - Out of spline grid%c\n"
	       ,jZ,kT1,Nz1Spl[kT1],7);
      if(iR >= Nr2Spl[kT1][jZ])
	printf("??? iR >= %3d < Nr2[%3d][%2d]=%3d - Out of spline grid%c\n"
	       ,iR,kT1,jZ,Nr2Spl[kT1][jZ],7);
      printf("??? r=%10.3e n=%d z=%10.3e kT1 jZ\n",r,n,z);
      return(1);
    }
    i	=iR-Nr1Spl[kT1][jZ];
    if(i < 0){
      if(i < 0)
	printf("??? iR=%3d < Nr1[%3d][%2d]=%3d - Out of spline grid%c\n"
	       ,iR,kT1,jZ,Nr1Spl[kT1][jZ],7);
      printf("??? r=%10.3e n=%d z=%10.3e kT1 jZ\n",r,n,z);
      return(1);
    }
    J010	=k2kSpl[kT1][j][i];
    J110	=J010+1;
    i	=iR-Nr1Spl[kT1][jZ+1];
    if(i < 0 || iR >= Nr2Spl[kT1][jZ+1]){
      if(i < 0)
	printf("??? iR=%3d < Nr1[%3d][%2d]=%3d - Out of spline grid%c\n"
	       ,iR,kT1,jZ+1,Nr1Spl[kT1][jZ+1],7);
      if(iR >= Nr2Spl[kT1][jZ+1])
	printf("??? iR >= %3d < Nr2[%3d][%2d]=%3d - Out of spline grid%c\n"
	       ,iR,kT1,jZ+1,Nr2Spl[kT1][jZ+1],7);
      printf("??? r=%10.3e n=%d z=%10.3e kT1 jZ+1\n",r,n,z);
      return(1);
    }
    J011	=k2kSpl[kT1][j+1][i];
    J111	=J011+1;
  }
  x	=(r-rCell)*rhrCell;
  xx	=x*x;
  X	=1.-x;
  XX	=X*X;
  Pr0=XX*(3.-2.*X);
  Pr1=xx*(3.-2.*x);
  Pr2=XX*x*drSpl;
  Pr3=-xx*X*drSpl;

  x	=(z-zCell)*rhzCell;
  xx	=x*x;
  X	=1.-x;
  XX	=X*X;
  Pz0=XX*(3.-2.*X);
  Pz1=xx*(3.-2.*x);
  Pz2=XX*x*dzSpl;
  Pz3=-xx*X*dzSpl;
  return(0);
}

int ESSetSplDerRZ(double r,double z,int n)
{
  int iR,kT,jZ;
  int i,j,kT1;
  double x,X,xx,XX,Xx;
  
  iR	=irCell;
  kT	=ktCell;
  jZ	=jzCell;
  while(r1Cell <= r){
    rCell	=r1Cell;
    r1Cell	+=drSpl;
    irCell++;
  }
  while(rCell > r){
    r1Cell	=rCell;
    rCell	-=drSpl;
    irCell--;
  }
  tCell=gf1T[n];
  t1Cell=tCell+dtSpl;
  ktCell= n == ESNt ? 0 : n; 
  while(z1Cell <= z){
    zCell	=z1Cell;
    z1Cell	+=dzSpl;
    jzCell++;
  }
  while(zCell > z){
    z1Cell	=zCell;
    zCell	-=dzSpl;
    jzCell--;
  }
  if(iR != irCell || kT != ktCell || jZ != jzCell){
    iR	=irCell;
    kT	=ktCell;
    jZ	=jzCell;
   
    kT1=kT+1;
    if(kT1 == ESNt)
      kT1=0;
 
    if(jZ >= Nz2Spl[kT] || jZ >= Nz2Spl[kT1]){
      printf("??? jZ=%3d >= Nz2[%3d]=%3d Nz2[%3d]=%3d - Out of spline grid%c\n"
	     ,jZ,kT,Nz2Spl[kT],kT1,Nz2Spl[kT1],7);
      printf("??? r=%10.3e n=%d z=%10.3e kT kT1\n",r,n,z);
      return(1);
    }
    j	=jZ-Nz1Spl[kT];
    if(j < 0 || iR >= Nr2Spl[kT][jZ]){
      if(j < 0)
	printf("??? jZ=%3d < Nz1[%3d]=%3d - Out of spline grid%c\n"
	       ,jZ,kT,Nz1Spl[kT],7);
      if(iR >= Nr2Spl[kT][jZ])
	printf("??? iR >= %3d < Nr2[%3d][%2d]=%3d - Out of spline grid%c\n"
	       ,iR,kT,jZ,Nr2Spl[kT][jZ],7);
      printf("??? r=%10.3e n=%d z=%10.3e kT\n",r,n,z);
      return(1);
    }
    i	=iR-Nr1Spl[kT][jZ];
    if(i < 0){
      printf("??? iR < %3d < Nr1[%3d][%2d]=%3d - Out of spline grid%c\n"
	     ,iR,kT,jZ,Nr1Spl[kT][jZ],7);
      printf("??? r=%10.3e n=%d z=%10.3e kT jZ\n",r,n,z);
      return(1);
    }
    J000	=k2kSpl[kT][j][i];
    J100	=J000+1;
    i	=iR-Nr1Spl[kT][jZ+1];
    if(i < 0 || iR >= Nr2Spl[kT][jZ+1]){
      if(i < 0)
	printf("??? iR=%3d < Nr1[%3d][%2d]=%3d - Out of spline grid%c\n"
	       ,iR,kT,jZ+1,Nr1Spl[kT][jZ+1],7);
      if(iR >= Nr2Spl[kT][jZ+1])
	printf("??? iR=%3d >= Nr2[%3d][%2d]=%3d - Out of spline grid%c\n"
	       ,iR,kT,jZ+1,Nr2Spl[kT][jZ+1],7);
      printf("??? r=%10.3e n=%d z=%10.3e kT jZ+1\n",r,n,z);
      return(1);
    }
    J001	=k2kSpl[kT][j+1][i];
    J101	=J001+1;
    j	=jZ-Nz1Spl[kT1];
    if(j < 0 || iR >= Nr2Spl[kT1][jZ]){
      if(j < 0)
	printf("??? jZ=%3d < Nz1[%3d]=%3d - Out of spline grid%c\n"
	       ,jZ,kT1,Nz1Spl[kT1],7);
      if(iR >= Nr2Spl[kT1][jZ])
	printf("??? iR >= %3d < Nr2[%3d][%2d]=%3d - Out of spline grid%c\n"
	       ,iR,kT1,jZ,Nr2Spl[kT1][jZ],7);
      printf("??? r=%10.3e n=%d z=%10.3e kT1 jZ\n",r,n,z);
      return(1);
    }
    i	=iR-Nr1Spl[kT1][jZ];
    if(i < 0){
      if(i < 0)
	printf("??? iR=%3d < Nr1[%3d][%2d]=%3d - Out of spline grid%c\n"
	       ,iR,kT1,jZ,Nr1Spl[kT1][jZ],7);
      printf("??? r=%10.3e n=%d z=%10.3e kT1 jZ\n",r,n,z);
      return(1);
    }
    J010	=k2kSpl[kT1][j][i];
    J110	=J010+1;
    i	=iR-Nr1Spl[kT1][jZ+1];
    if(i < 0 || iR >= Nr2Spl[kT1][jZ+1]){
      if(i < 0)
	printf("??? iR=%3d < Nr1[%3d][%2d]=%3d - Out of spline grid%c\n"
	       ,iR,kT1,jZ+1,Nr1Spl[kT1][jZ+1],7);
      if(iR >= Nr2Spl[kT1][jZ+1])
	printf("??? iR >= %3d < Nr2[%3d][%2d]=%3d - Out of spline grid%c\n"
	       ,iR,kT1,jZ+1,Nr2Spl[kT1][jZ+1],7);
      printf("??? r=%10.3e n=%d z=%10.3e kT1 jZ+1\n",r,n,z);
      return(1);
    }
    J011	=k2kSpl[kT1][j+1][i];
    J111	=J011+1;
  }

  x	=(r-rCell)*rhrCell;
  xx	=x*x;
  X	=1.-x;
  XX	=X*X;
  Pr0=XX*(3.-2.*X);
  Pr1=xx*(3.-2.*x);
  Pr2=XX*x*drSpl;
  Pr3=-xx*X*drSpl;
  Xx	=2.*x*X;
  dPr1	=3.*rhrCell*Xx;
  dPr0	=-dPr1;
  dPr2	=XX-Xx;
  dPr3	=xx-Xx;

  x	=(z-zCell)*rhzCell;
  xx	=x*x;
  X	=1.-x;
  XX	=X*X;
  Pz0=XX*(3.-2.*X);
  Pz1=xx*(3.-2.*x);
  Pz2=XX*x*dzSpl;
  Pz3=-xx*X*dzSpl;
  Xx	=2.*x*X;
  dPz1	=3.*rhzCell*Xx;
  dPz0	=-dPz1;
  dPz2	=XX-Xx;
  dPz3	=xx-Xx;
  return(0);
}

int ESSpl2ArBtAtAz(double *Ar, double *Ar1t, double *Bt,
		   double *At, double *Az, double *Az1t,
		   double R, double Z, int n)
{
  double r;

  if(ESSetSplRZ(R,Z,n)){
    printf("??? Out of spline grid%c\n",7);
  }
  *Ar	=(Pr0*(Pz0*AR[J000]
	       +Pz1*AR[J001]
	       +Pz2*ARz[J000]
	       +Pz3*ARz[J001]
	       )
	  +Pr1*(Pz0*AR[J100]
		+Pz1*AR[J101]
		+Pz2*ARz[J100]
		+Pz3*ARz[J101]
		)
	  +Pr2*(Pz0*ARr[J000]
		+Pz1*ARr[J001]
		+Pz2*ARrz[J000]
		+Pz3*ARrz[J001]
		)
	  +Pr3*(Pz0*ARr[J100]
		+Pz1*ARr[J101]
		+Pz2*ARrz[J100]
		+Pz3*ARrz[J101]
		)
	  );
  
  *Ar1t	=(Pr0*(Pz0*ARt[J000]
	       +Pz1*ARt[J001]
	       +Pz2*ARtz[J000]
	       +Pz3*ARtz[J001]
	       )
	  +Pr1*(Pz0*ARt[J100]
		+Pz1*ARt[J101]
		+Pz2*ARtz[J100]
		+Pz3*ARtz[J101]
		)
	  +Pr2*(Pz0*ARrt[J000]
		+Pz1*ARrt[J001]
		+Pz2*ARrtz[J000]
		+Pz3*ARrtz[J001]
		)
	  +Pr3*(Pz0*ARrt[J100]
		+Pz1*ARrt[J101]
		+Pz2*ARrtz[J100]
		+Pz3*ARrtz[J101]
		)
	  );

  *Bt	=(Pr0*(Pz0*BT[J000]
	       +Pz1*BT[J001]
	       +Pz2*BTz[J000]
	       +Pz3*BTz[J001]
	       )
	  +Pr1*(Pz0*BT[J100]
		+Pz1*BT[J101]
		+Pz2*BTz[J100]
		+Pz3*BTz[J101]
		)
	  +Pr2*(Pz0*BTr[J000]
		+Pz1*BTr[J001]
		+Pz2*BTrz[J000]
		+Pz3*BTrz[J001]
		)
	  +Pr3*(Pz0*BTr[J100]
		+Pz1*BTr[J101]
		+Pz2*BTrz[J100]
		+Pz3*BTrz[J101]
		)
	  );

  *At	=(Pr0*(Pz0*AT[J000]
	       +Pz1*AT[J001]
	       +Pz2*ATz[J000]
	       +Pz3*ATz[J001]
	       )
	  +Pr1*(Pz0*AT[J100]
		+Pz1*AT[J101]
		+Pz2*ATz[J100]
		+Pz3*ATz[J101]
		)
	  +Pr2*(Pz0*ATr[J000]
		+Pz1*ATr[J001]
		+Pz2*ATrz[J000]
		+Pz3*ATrz[J001]
		)
	  +Pr3*(Pz0*ATr[J100]
		+Pz1*ATr[J101]
		+Pz2*ATrz[J100]
		+Pz3*ATrz[J101]
		)
	  );

  *Az	=(Pr0*(Pz0*AZ[J000]
	       +Pz1*AZ[J001]
	       +Pz2*AZz[J000]
	       +Pz3*AZz[J001]
	       )
	  +Pr1*(Pz0*AZ[J100]
		+Pz1*AZ[J101]
		+Pz2*AZz[J100]
		+Pz3*AZz[J101]
		)
	  +Pr2*(Pz0*AZr[J000]
		+Pz1*AZr[J001]
		+Pz2*AZrz[J000]
		+Pz3*AZrz[J001]
		)
	  +Pr3*(Pz0*AZr[J100]
		+Pz1*AZr[J101]
		+Pz2*AZrz[J100]
		+Pz3*AZrz[J101]
		)
	  );

  *Az1t	=(Pr0*(Pz0*AZt[J000]
	       +Pz1*AZt[J001]
	       +Pz2*AZtz[J000]
	       +Pz3*AZtz[J001]
	       )
	  +Pr1*(Pz0*AZt[J100]
		+Pz1*AZt[J101]
		+Pz2*AZtz[J100]
		+Pz3*AZtz[J101]
		)
	  +Pr2*(Pz0*AZrt[J000]
		+Pz1*AZrt[J001]
		+Pz2*AZrtz[J000]
		+Pz3*AZrtz[J001]
		)
	  +Pr3*(Pz0*AZrt[J100]
		+Pz1*AZrt[J101]
		+Pz2*AZrtz[J100]
		+Pz3*AZrtz[J101]
		)
	  );

  return(0);
}

int ESSpl2BrBtBz(double *Ar, double *Az,double *Br, double *Bt, double *Bz, double R, double Z, int n)
{
  double r;

  if(ESSetSplRZ(R,Z,n)){
    printf("??? Out of spline grid%c\n",7);
  }
  
  *Ar	=(Pr0*(Pz0*AR[J000]
	       +Pz1*AR[J001]
	       +Pz2*ARz[J000]
	       +Pz3*ARz[J001]
	       )
	  +Pr1*(Pz0*AR[J100]
		+Pz1*AR[J101]
		+Pz2*ARz[J100]
		+Pz3*ARz[J101]
		)
	  +Pr2*(Pz0*ARr[J000]
		+Pz1*ARr[J001]
		+Pz2*ARrz[J000]
		+Pz3*ARrz[J001]
		)
	  +Pr3*(Pz0*ARr[J100]
		+Pz1*ARr[J101]
		+Pz2*ARrz[J100]
		+Pz3*ARrz[J101]
		)
	  );

  *Az	=(Pr0*(Pz0*AZ[J000]
	       +Pz1*AZ[J001]
	       +Pz2*AZz[J000]
	       +Pz3*AZz[J001]
	       )
	  +Pr1*(Pz0*AZ[J100]
		+Pz1*AZ[J101]
		+Pz2*AZz[J100]
		+Pz3*AZz[J101]
		)
	  +Pr2*(Pz0*AZr[J000]
		+Pz1*AZr[J001]
		+Pz2*AZrz[J000]
		+Pz3*AZrz[J001]
		)
	  +Pr3*(Pz0*AZr[J100]
		+Pz1*AZr[J101]
		+Pz2*AZrz[J100]
		+Pz3*AZrz[J101]
		)
	  );
  
  *Br	=(Pr0*(Pz0*BR[J000]
	       +Pz1*BR[J001]
	       +Pz2*BRz[J000]
	       +Pz3*BRz[J001]
	       )
	  +Pr1*(Pz0*BR[J100]
		+Pz1*BR[J101]
		+Pz2*BRz[J100]
		+Pz3*BRz[J101]
		)
	  +Pr2*(Pz0*BRr[J000]
		+Pz1*BRr[J001]
		+Pz2*BRrz[J000]
		+Pz3*BRrz[J001]
		)
	  +Pr3*(Pz0*BRr[J100]
		+Pz1*BRr[J101]
		+Pz2*BRrz[J100]
		+Pz3*BRrz[J101]
		)
	  );

  *Bt	=(Pr0*(Pz0*BT[J000]
	       +Pz1*BT[J001]
	       +Pz2*BTz[J000]
	       +Pz3*BTz[J001]
	       )
	  +Pr1*(Pz0*BT[J100]
		+Pz1*BT[J101]
		+Pz2*BTz[J100]
		+Pz3*BTz[J101]
		)
	  +Pr2*(Pz0*BTr[J000]
		+Pz1*BTr[J001]
		+Pz2*BTrz[J000]
		+Pz3*BTrz[J001]
		)
	  +Pr3*(Pz0*BTr[J100]
		+Pz1*BTr[J101]
		+Pz2*BTrz[J100]
		+Pz3*BTrz[J101]
		)
	  );

  *Bz	=(Pr0*(Pz0*BZ[J000]
	       +Pz1*BZ[J001]
	       +Pz2*BZz[J000]
	       +Pz3*BZz[J001]
	       )
	  +Pr1*(Pz0*BZ[J100]
		+Pz1*BZ[J101]
		+Pz2*BZz[J100]
		+Pz3*BZz[J101]
		)
	  +Pr2*(Pz0*BZr[J000]
		+Pz1*BZr[J001]
		+Pz2*BZrz[J000]
		+Pz3*BZrz[J001]
		)
	  +Pr3*(Pz0*BZr[J100]
		+Pz1*BZr[J101]
		+Pz2*BZrz[J100]
		+Pz3*BZrz[J101]
		)
	  );

  return(0);
}

int ESSpl2BrBtBzBrrBtrBzr(double *Br, double *Bt, double *Bz,
		 double *Brr, double *Btr, double *Bzr,
		 double *Brz, double *Btz, double *Bzz,
		 double R, double Z, int n)
{
  double r,p0,p1,p2,p3;

  if(ESSetSplDerRZ(R,Z,n)){
    printf("??? Out of spline grid%c\n",7);
  }
  
  p0	=Pz0*BR[J000]+Pz1*BR[J001]+Pz2*BRz[J000]+Pz3*BRz[J001];
  p1	=Pz0*BR[J100]+Pz1*BR[J101]+Pz2*BRz[J100]+Pz3*BRz[J101];
  p2	=Pz0*BRr[J000]+Pz1*BRr[J001]+Pz2*BRrz[J000]+Pz3*BRrz[J001];
  p3	=Pz0*BRr[J100]+Pz1*BRr[J101]+Pz2*BRrz[J100]+Pz3*BRrz[J101];
  
  *Br	=Pr0*p0+Pr1*p1+Pr2*p2+Pr3*p3;
  *Brr	=dPr0*p0+dPr1*p1+dPr2*p2+dPr3*p3;
  *Brz	=(Pr0*(dPz0*BR[J000]+dPz1*BR[J001]+dPz2*BRz[J000]+dPz3*BRz[J001])
	  +Pr1*(dPz0*BR[J100]+dPz1*BR[J101]+dPz2*BRz[J100]+dPz3*BRz[J101])
	  +Pr2*(dPz0*BRr[J000]+dPz1*BRr[J001]+dPz2*BRrz[J000]+dPz3*BRrz[J001])
	  +Pr3*(dPz0*BRr[J100]+dPz1*BRr[J101]+dPz2*BRrz[J100]+dPz3*BRrz[J101])
	  );

  p0	=Pz0*BT[J000]+Pz1*BT[J001]+Pz2*BTz[J000]+Pz3*BTz[J001];
  p1	=Pz0*BT[J100]+Pz1*BT[J101]+Pz2*BTz[J100]+Pz3*BTz[J101];
  p2	=Pz0*BTr[J000]+Pz1*BTr[J001]+Pz2*BTrz[J000]+Pz3*BTrz[J001];
  p3	=Pz0*BTr[J100]+Pz1*BTr[J101]+Pz2*BTrz[J100]+Pz3*BTrz[J101];
  
  *Bt	=Pr0*p0+Pr1*p1+Pr2*p2+Pr3*p3;
  *Btr	=dPr0*p0+dPr1*p1+dPr2*p2+dPr3*p3;
  *Btz	=(Pr0*(dPz0*BT[J000]+dPz1*BT[J001]+dPz2*BTz[J000]+dPz3*BTz[J001])
	  +Pr1*(dPz0*BT[J100]+dPz1*BT[J101]+dPz2*BTz[J100]+dPz3*BTz[J101])
	  +Pr2*(dPz0*BTr[J000]+dPz1*BTr[J001]+dPz2*BTrz[J000]+dPz3*BTrz[J001])
	  +Pr3*(dPz0*BTr[J100]+dPz1*BTr[J101]+dPz2*BTrz[J100]+dPz3*BTrz[J101])
	  );

  p0	=Pz0*BZ[J000]+Pz1*BZ[J001]+Pz2*BZz[J000]+Pz3*BZz[J001];
  p1	=Pz0*BZ[J100]+Pz1*BZ[J101]+Pz2*BZz[J100]+Pz3*BZz[J101];
  p2	=Pz0*BZr[J000]+Pz1*BZr[J001]+Pz2*BZrz[J000]+Pz3*BZrz[J001];
  p3	=Pz0*BZr[J100]+Pz1*BZr[J101]+Pz2*BZrz[J100]+Pz3*BZrz[J101];
  
  *Bz	=Pr0*p0+Pr1*p1+Pr2*p2+Pr3*p3;
  *Bzr	=dPr0*p0+dPr1*p1+dPr2*p2+dPr3*p3; 
  *Bzz	=(Pr0*(dPz0*BZ[J000]+dPz1*BZ[J001]+dPz2*BZz[J000]+dPz3*BZz[J001])
	  +Pr1*(dPz0*BZ[J100]+dPz1*BZ[J101]+dPz2*BZz[J100]+dPz3*BZz[J101])
	  +Pr2*(dPz0*BZr[J000]+dPz1*BZr[J001]+dPz2*BZrz[J000]+dPz3*BZrz[J001])
	  +Pr3*(dPz0*BZr[J100]+dPz1*BZr[J101]+dPz2*BZrz[J100]+dPz3*BZrz[J101])
	  );
  return(0);
}

int ESRead3DSpl()
{
  int n;
  FILE *fp7_3;

  fp7_3	=fopen("3dSplData","r");
  if(fp7_3 == NULL){
    printf("%s is absent %c\n","3dSplData",7);
    return(-1);
  }
  fread(&ESNt,1,sizeof(int),fp7_3);
  ESNt1	=ESNt+1;
  fread(&SplN,1,sizeof(int),fp7_3);
  fread(&nrSpl,1,sizeof(int),fp7_3);
  fread(&nzSpl,1,sizeof(int),fp7_3);
  nrSpl1=nrSpl+1;
  nzSpl1=nzSpl+1;
  fread(&Rmn,1,sizeof(double),fp7_3);
  fread(&Rmx,1,sizeof(double),fp7_3);
  fread(&Zmn,1,sizeof(double),fp7_3);
  fread(&Zmx,1,sizeof(double),fp7_3);
  fread(&drSpl,1,sizeof(double),fp7_3);
  fread(&dzSpl,1,sizeof(double),fp7_3);
  fread(&dtSpl,1,sizeof(double),fp7_3);
  ESInitSplArrays();
  fread(rSpl,SplN,sizeof(double),fp7_3);
  fread(zSpl,SplN,sizeof(double),fp7_3);
  fread(xSpl,SplN,sizeof(double),fp7_3);
  fread(ySpl,SplN,sizeof(double),fp7_3);
  fread(AR,SplN,sizeof(double),fp7_3);
  fread(ARr,SplN,sizeof(double),fp7_3);
  fread(ARt,SplN,sizeof(double),fp7_3);
  fread(ARz,SplN,sizeof(double),fp7_3);
  fread(ARrt,SplN,sizeof(double),fp7_3);
  fread(ARrz,SplN,sizeof(double),fp7_3);
  fread(ARtz,SplN,sizeof(double),fp7_3);
  fread(ARrtz,SplN,sizeof(double),fp7_3);
  fread(AT,SplN,sizeof(double),fp7_3);
  fread(ATr,SplN,sizeof(double),fp7_3);
  fread(ATt,SplN,sizeof(double),fp7_3);
  fread(ATz,SplN,sizeof(double),fp7_3);
  fread(ATrt,SplN,sizeof(double),fp7_3);
  fread(ATrz,SplN,sizeof(double),fp7_3);
  fread(ATtz,SplN,sizeof(double),fp7_3);
  fread(ATrtz,SplN,sizeof(double),fp7_3);
  fread(AZ,SplN,sizeof(double),fp7_3);
  fread(AZr,SplN,sizeof(double),fp7_3);
  fread(AZt,SplN,sizeof(double),fp7_3);
  fread(AZz,SplN,sizeof(double),fp7_3);
  fread(AZrt,SplN,sizeof(double),fp7_3);
  fread(AZrz,SplN,sizeof(double),fp7_3);
  fread(AZtz,SplN,sizeof(double),fp7_3);
  fread(AZrtz,SplN,sizeof(double),fp7_3);
  fread(BR,SplN,sizeof(double),fp7_3);
  fread(BRr,SplN,sizeof(double),fp7_3);
  fread(BRt,SplN,sizeof(double),fp7_3);
  fread(BRz,SplN,sizeof(double),fp7_3);
  fread(BRrt,SplN,sizeof(double),fp7_3);
  fread(BRrz,SplN,sizeof(double),fp7_3);
  fread(BRtz,SplN,sizeof(double),fp7_3);
  fread(BRrtz,SplN,sizeof(double),fp7_3);
  fread(BT,SplN,sizeof(double),fp7_3);
  fread(BTr,SplN,sizeof(double),fp7_3);
  fread(BTt,SplN,sizeof(double),fp7_3);
  fread(BTz,SplN,sizeof(double),fp7_3);
  fread(BTrt,SplN,sizeof(double),fp7_3);
  fread(BTrz,SplN,sizeof(double),fp7_3);
  fread(BTtz,SplN,sizeof(double),fp7_3);
  fread(BTrtz,SplN,sizeof(double),fp7_3);
  fread(BZ,SplN,sizeof(double),fp7_3);
  fread(BZr,SplN,sizeof(double),fp7_3);
  fread(BZt,SplN,sizeof(double),fp7_3);
  fread(BZz,SplN,sizeof(double),fp7_3);
  fread(BZrt,SplN,sizeof(double),fp7_3);
  fread(BZrz,SplN,sizeof(double),fp7_3);
  fread(BZtz,SplN,sizeof(double),fp7_3);
  fread(BZrtz,SplN,sizeof(double),fp7_3);
  ESInitSplIntArrays0();
  fread(Nz1Spl,ESNt1,sizeof(int),fp7_3);
  fread(Nz2Spl,ESNt1,sizeof(int),fp7_3);
  ESInitSplIntArrays1();
  for(n=0; n < ESNt1; n++){
    fread(Nr1Spl[n],nzSpl1,sizeof(int),fp7_3);
    fread(Nr2Spl[n],nzSpl1,sizeof(int),fp7_3);
  }
  fclose(fp7_3);
  ESInitSplIntArrays2();
  rCell		=Rmn-drSpl;
  tCell		=0.;
  zCell		=Zmn-dzSpl;
  r1Cell	=rCell+drSpl;
  t1Cell	=tCell+dtSpl;
  z1Cell	=zCell+dzSpl;
  irCell	=-1;
  ktCell	=0;
  jzCell	=-1;
  rhrCell	=1./drSpl;
  rhtCell	=1./dtSpl;
  rhzCell	=1./dzSpl;
 return(0);
}

int ESVacMF()
{
  double R,Z,gFs,gF;
  double Ar,Az,At,Br,Bz,Bt;

  R=3.3;
  Z=0.;
  gFs=0.;

#ifndef Tbl_VacMF
  gF	=c2gp*gFs;
  while(gF < 0.){
    gF	+=c2gp;
  }
  while(gF > c2gp){
    gF	-=c2gp;
  }
  ESSplineArtz(R,gF,Z,&Ar,&At,&Az,&Br,&Bt,&Bz);
  printf("=== R=%10.3e %10.3e %10.3e\n",R,gFs,Z);
  printf("??? %13.6e %13.6e %13.6e %13.6e %13.6e %13.6e\n",Ar,At,Az,Br,Bt,Bz);

#endif Tbl_VacMF
  return(0);
}
#ifdef H
=== R= 3.300e+00  0.000e+00  0.000e+00
??? Biot-Savart/Splines
???            Ar            At            Az            Br            Bt            Bz
???  8.165170e-15  8.063081e-16  5.553422e-01 -5.974633e-02  3.835525e+00  2.108643e-15
???  4.439027e-16  6.727248e-16 -5.553634e-01  5.966015e-02 -3.835397e+00 -8.610654e-17
./TOS/Wrk/VacMF.tb read :--> VacMF - Tbl
=== R= 3.300e+00  0.000e+00  0.000e+00
??? Biot-Savart/Splines
???            Ar            At            Az            Br            Bt            Bz
???  8.165170e-15  8.063081e-16  5.553422e-01 -5.974633e-02  3.835525e+00  2.108643e-15
???  4.439027e-16  6.727248e-16 -5.553634e-01  5.966015e-02 -3.835397e+00 -8.610654e-17
#endif
