#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>

double *ESsr,*ESsz,*ESsb,*ESsb2a,*rcT,*rsT,*rcT2a,*rsT2a,*ESaR0,*ESaZ0;
static double a0=-1.,a1=1.;
double *ESsa;
int ESNa,ESNa1,ESNp,ESNp1,ESFp,ESFp1;

static double c2gp;
static double cr3ha,cha,crha,c2rha,cHa,crHa,chha,ch2ha,ch2h1,ch4h0,ch4h1;
static int iSplA=0,iSplA1;
static double SplAx,SplAxx,SplAX,SplAXX;

int ESFirstSetSplA()
{
  double h;

  h	=a1-a0;
  cha	=h/6.;
  cr3ha	=h/3.;
  crha	=1./h;
  c2rha	=2.*crha;
  chha	=0.5*h;
  ch2ha	=chha*cha;
  cHa	=h*h/6.;
  crHa	=6.*crha*crha; 
  ch2h1	=h*h/3.;
  c2gp	=8.*atan(1.);
  return(0);
}

int ESSetSplA(double A)
{
  int iA;
  int i,j,kT1;
  
  if(A > 1.){
    A	=1.;
  }
  if(A < a0){
    A	=a0;
  }
  while(iSplA < ESNa && ESsa[iSplA+1] < A){
    iSplA++;
  }
  while(iSplA > 0 && ESsa[iSplA] > A){
    iSplA--;
  }
  iSplA1	=iSplA+1;
  SplAx		=(A-ESsa[iSplA])*crha;
  SplAxx	=SplAx*SplAx;
  SplAX		=1.-SplAx;
  SplAXX	=SplAX*SplAX;
  return(0);
}

int splRA(double*f, double*df, double*g, double*d2g)
{
  *f	=SplAX*g[iSplA]+SplAx*g[iSplA1]
    +(SplAX*(SplAXX-1.)*d2g[iSplA]+SplAx*(SplAxx-1.)*d2g[iSplA1])*cHa;
  if(df != NULL){
    *df	=(g[iSplA1]-g[iSplA]
	  +((3.*SplAxx-1.)*d2g[iSplA1]-(3.*SplAXX-1.)*d2g[iSplA])*cHa)*crha;
  }
  return(0);
}
void esc0_(char *Nm,int na)
{
  LaunchEsc();
  return;
}
static char *NmOfProf[6]={
  "bgY",
  "bgF",
  "aF",
  "gm",
  "q",
  "bsp"
};

#ifdef H
strcpy(PlPrP[0].Nm,	"j_PfShl");
strcpy(PlPrP[1].Nm,	"Ps     ");
strcpy(PlPrP[2].Nm,	"p      ");
strcpy(PlPrP[3].Nm,	"p'/a   ");
strcpy(PlPrP[4].Nm,	"ga_CHT ");
strcpy(PlPrP[5].Nm,	"n_e    ");
strcpy(PlPrP[6].Nm,	"n_i    ");
strcpy(PlPrP[7].Nm,	"T_e    ");
strcpy(PlPrP[8].Nm,	"T_i    ");
strcpy(PlPrP[9].Nm,	"p_e    ");
strcpy(PlPrP[10].Nm,	"p_i    ");
strcpy(PlPrP[11].Nm,	"gb_Sh  ");
strcpy(PlPrP[12].Nm,	"gb     ");


strcpy(PlCrP[0].Nm,	"j_GSh  ");
strcpy(PlCrP[1].Nm,	"j_||   ");
strcpy(PlCrP[2].Nm,	"J      ");
strcpy(PlCrP[3].Nm,	"FF'    ");
strcpy(PlCrP[4].Nm,	"<j.B>  ");
strcpy(PlCrP[5].Nm,	"Fs     ");
strcpy(PlCrP[6].Nm,	"q      ");
strcpy(PlCrP[7].Nm,	"1/q    ");
strcpy(PlCrP[8].Nm,	"gY     ");
strcpy(PlCrP[9].Nm,	"gF    ");
strcpy(PlCrP[10].Nm,	"F      ");
strcpy(PlCrP[11].Nm,	"FF     ");
strcpy(PlCrP[12].Nm,	"ir+il  ");
strcpy(PlCrP[13].Nm,	"ir-il  ");
strcpy(PlCrP[14].Nm,	"j_r    ");
strcpy(PlCrP[15].Nm,	"j_l    ");
strcpy(PlCrP[16].Nm,	"dgY/a  ");
strcpy(PlCrP[17].Nm,	"j_||R0 ");
#endif

/**
 * @file 
 * @brief List of Get methods. 
 * The following routines give access equilibrium profile data
 * and geometry after execution (Esc).
 */ 

 
/**
 * Get the radial number of grid points used internally by ESC. 
 * @param Na1 the grid size
 * @author L.E. Zakharov, A. Pletzer
 * @see escGetNp1
 * 
 */
void escGetNa1(int *Na1)
{
  *Na1	=ESNa1;
}
void escgetna1_(int *Na1)
{
  *Na1	=ESNa1;
}
void escgetna1(int *Na1)
{
  *Na1	=ESNa1;
}
void ESCGETNA1(int *Na1)
{
  *Na1	=ESNa1;
}
 
/**
 * Get the number of poloidal rays + 1 used internally by ESC. 
 * @param Np1 the number of poloidal sections + 1
 * @author L.E. Zakharov, A. Pletzer
 * @see escGetNa1
 */
void escGetNp1(int *Np1)
{
  *Np1	=ESNp1;
}
void escgetnp1_(int *Np1)
{
  *Np1	=ESNp1;
}
void escgetnp1(int *Np1)
{
  *Np1	=ESNp1;
}
void ESCGETNP1(int *Np1)
{
  *Np1	=ESNp1;
}
/**
 * Get the poloidal flux/(2*pi) [Wb/rad].
 * @param prof the returned profile
 * @param ns the size of the returned profile (input)
 * @author L.E. Zakharov, A. Pletzer
 * @see escGetPsi
 */

int ESgetProfile(int k,double *P, int n)
{
  int i;
  double *ld,dx;

  if(a0 != *ESsa){
    a0	=*ESsa;
    ESFirstSetSplA();
  }

  ld	=ESsa+(2*k+1)*ESNa1;
  dx	=(a1-a0)/(n-1);
  for(i=0; i < n; i++){
    ESSetSplA(a0+dx*i);
    splRA(P,NULL,ld,ld+ESNa1);
    P++;
  }
  return(0);
}

void escGetPsibar(double *prof, int *ns){
  int i;
  ESgetProfile(0,prof,*ns);
  for(i=0; i < *ns; i++){
    prof[i]	=-prof[i];
  }
}

void escgetpsibar_(double *prof, int *ns){
  int i;
  ESgetProfile(0,prof,*ns);
  for(i=0; i < *ns; i++){
    prof[i]	=-prof[i];
  }
}
void escgetpsibar(double *prof, int *ns){
  int i;
  ESgetProfile(0,prof,*ns);
  for(i=0; i < *ns; i++){
    prof[i]	=-prof[i];
  }
}
void ESCGETPSIBAR(double *prof, int *ns){
  int i;
  ESgetProfile(0,prof,*ns);
  for(i=0; i < *ns; i++){
    prof[i]	=-prof[i];
  }
}
 
/**
 * Get the poloidal flux [Wb].
 * @param prof the returned profile
 * @param ns the size of the returned profile (input)
 * @author L.E. Zakharov, A. Pletzer
 * @see escGetPsibar
 */
void escGetPsi(double *prof, int *ns){
  int i;
  ESgetProfile(0,prof,*ns);
  for(i=0; i < *ns; i++){
    prof[i]	*=-c2gp;
  }
}
void escgetpsi_(double *prof, int *ns){
  int i;
  ESgetProfile(0,prof,*ns);
  for(i=0; i < *ns; i++){
    prof[i]	*=c2gp;
  }
}
void escgetpsi(double *prof, int *ns){
  int i;
  ESgetProfile(0,prof,*ns);
  for(i=0; i < *ns; i++){
    prof[i]	*=c2gp;
  }
}
void ESCGETPSI(double *prof, int *ns){
  int i;
  ESgetProfile(0,prof,*ns);
  for(i=0; i < *ns; i++){
    prof[i]	*=c2gp;
  }
}

/**
 * Get the toroidal flux/(2*pi) [Wb/rad].
 * @param prof the returned profile
 * @param ns the size of the returned profile (input)
 * @author L.E. Zakharov, A. Pletzer
 * @see escGetPhi
 */
void escGetPhibar(double *prof, int *ns){
  ESgetProfile(1,prof,*ns);
}
void escgetphibar_(double *prof, int *ns){
  ESgetProfile(1,prof,*ns);
}
void escgetphibar(double *prof, int *ns){
  ESgetProfile(1,prof,*ns);
}
void ESCGETPHIBAR(double *prof, int *ns){
  ESgetProfile(1,prof,*ns);
}
 
/**
 * Get the toroidal flux [Wb].
 * @param prof the returned profile
 * @param ns the size of the returned profile (input)
 * @author L.E. Zakharov, A. Pletzer 
 * @see escGetPhibar
 */
void escGetPhi(double *prof, int *ns){
  int i;
  ESgetProfile(1,prof,*ns);
  for(i=0; i < *ns; i++){
    prof[i]	*=c2gp;
  }
}
void escgetphi_(double *prof, int *ns){
  int i;
  ESgetProfile(1,prof,*ns);
  for(i=0; i < *ns; i++){
    prof[i]	*=c2gp;
  }
}
void escgetphi(double *prof, int *ns){
  int i;
  ESgetProfile(1,prof,*ns);
  for(i=0; i < *ns; i++){
    prof[i]	*=c2gp;
  }
}
void ESCGETPHI(double *prof, int *ns){
  int i;
  ESgetProfile(1,prof,*ns);
  for(i=0; i < *ns; i++){
    prof[i]	*=c2gp;
  }
}
/**
 * Get the covariant toroidal magnetic field function [Tm].
 * @param prof the returned profile
 * @param ns the size of the returned profile (input)
 * @author L.E. Zakharov, A. Pletzer 
 * @see escGetIota escGetQ escGetP
 */
void escGetG(double *prof, int *ns){
  ESgetProfile(2,prof,*ns);
}
void escgetg_(double *prof, int *ns){
  ESgetProfile(2,prof,*ns);
}
void escgetg(double *prof, int *ns){
  ESgetProfile(2,prof,*ns);
}
void ESCGETG(double *prof, int *ns){
  ESgetProfile(2,prof,*ns);
}

/**
 * Get the 1/q profile [-].
 * @param prof the returned profile
 * @param ns the size of the returned profile (input)
 * @author L.E. Zakharov, A. Pletzer 
 * @see escGetQ escGetG escGetP
 */ 
void escGetIota(double *prof, int *ns){
  ESgetProfile(3,prof,*ns);
}
void escgetiota_(double *prof, int *ns){
  ESgetProfile(3,prof,*ns);
}
void escgetiota(double *prof, int *ns){
  ESgetProfile(3,prof,*ns);
}
void ESCGETIOTA(double *prof, int *ns){
  ESgetProfile(3,prof,*ns);
}

/**
 * Get the safety factor (q) profile [-].
 * @param prof the returned profile
 * @param ns the size of the returned profile (input)
 * @author L.E. Zakharov, A. Pletzer 
 * @see escGetIota escGetG escGetP
 */ 

void escGetQ(double *prof, int *ns){
  int i;
  ESgetProfile(3,prof,*ns);
  for(i=0; i < *ns; i++){
    prof[i]	=1./prof[i];
  }
}
void escgetq_(double *prof, int *ns){
  int i;
  ESgetProfile(3,prof,*ns);
  for(i=0; i < *ns; i++){
    prof[i]	=1./prof[i];
  }
}
void escgetq(double *prof, int *ns){
  int i;
  ESgetProfile(3,prof,*ns);
  for(i=0; i < *ns; i++){
    prof[i]	=1./prof[i];
  }
}
void ESCGETQ(double *prof, int *ns){
  int i;
  ESgetProfile(3,prof,*ns);
  for(i=0; i < *ns; i++){
    prof[i]	=1./prof[i];
  }
}

/**
 * Get the pressure in [mu0 Pa].
 * @param prof the returned profile
 * @param ns the size of the returned profile (input)
 * @author L.E. Zakharov, A. Pletzer 
 * @see escGetIota escGetG escGetQ
 */
void escGetP(double *prof, int *ns){
  ESgetProfile(5,prof,*ns);
}
void escgetp_(double *prof, int *ns){
  ESgetProfile(5,prof,*ns);
}
void escgetp(double *prof, int *ns){
  ESgetProfile(5,prof,*ns);
}
void ESCGETP(double *prof, int *ns){
  ESgetProfile(5,prof,*ns);
}
 
/** 
 * Get the Fourier coefficients of the R coordinate [m].
 * @param rcos the returned cosine coefficients of sizes [ns][nf]
 * @param rsin the returned sine coefficients
 * @param nf the number of Fourier coefficients (input)
 * @param ns the radial size (input)
 * @author L.E. Zakharov, A. Pletzer 
 * @see escGetFourierZ
 */

void escGetFourierR(double *rcos, double *rsin, int *nf, int *ns)
{
  int i,j,n,k;
  double *lc,*lc2,*ls,*ls2,dx;

  if(a0 != *ESsa){
    a0	=*ESsa;
    ESFirstSetSplA();
  }

  n	=*ns;
  k	=*nf < ESFp1 ? *nf : ESFp1;
  dx	=(a1-a0)/(n-1);
  for(i=0; i < n; i++){
    ESSetSplA(a0+dx*i);
    lc	=rcT;
    ls	=rsT;
    lc2	=rcT2a;
    ls2	=rsT2a;
    splRA(rcos,NULL,lc,lc2);
    *rcos++	+=ESaR0[0];
    *rsin++	 =0.;
    for(j=1; j < k; j++){
      lc	+=ESNa1;
      lc2	+=ESNa1;
      splRA(rcos,NULL,lc,lc2);
      *rcos++ *=2.0;
      ls	+=ESNa1;
      ls2	+=ESNa1;
      splRA(rsin,NULL,ls,ls2);
      *rsin++ *=2.0;
    }
    for(j=k; j < *nf; j++){
      *lc++	=0.0;
      *lc++	=0.0;
    }
  }
  return;
}
void escgetfourierr_(double *rcos, double *rsin, int *nf, int *ns){
  escGetFourierR(rcos, rsin, nf, ns);
}
void escgetfourierr(double *rcos, double *rsin, int *nf, int *ns){
  escGetFourierR(rcos, rsin, nf, ns);
}
void ESCGETFOURIERR(double *rcos, double *rsin, int *nf, int *ns){
  escGetFourierR(rcos, rsin, nf, ns);
}

/** 
 * Get the R coordinates [m]. The poloidal index varies faster.
 * @param r the returned array of size [ns][nt1].
 * @param nt1 the number of poloidal sections + 1 (input)
 * @param ns the radial size (input)
 * @param clockwise poloidal angle orientation (1 for clockwise, 
 *        0 for counterclockwise)
 * @author L.E. Zakharov, A. Pletzer 
 * @see escGetZ
 */
void escGetR(double *r, int *nt1, int *ns, int *clockwise){
  double *rcos, *rsin;
  int NT1, NS, i, j, k, ni, nf;
  double sum, theta;
  NT1 = *nt1;
  NS  = *ns;
  nf = ESFp1;

  rcos =(double*) malloc( nf*NS*sizeof(double));
  rsin =(double*) malloc( nf*NS*sizeof(double));

  escGetFourierR(rcos, rsin, &nf, ns);

  if(*clockwise!=1){
    for(i=0; i<NS; i++){
      for(j=0; j<NT1; j++){
	sum = 0.0;
	theta = c2gp*(double)j/(double)(NT1-1);
	for(k=0; k<nf; k++){
	  ni = i*nf + k;
	  sum += rcos[ni]*cos(k*theta) + rsin[ni]*sin(k*theta);
	}
	r[i*NT1 + j] = sum;
      }
    }
  }else{
    for(i=0; i<NS; i++){
      for(j=0; j<NT1; j++){
	sum = 0.0;
	theta = c2gp*(double)(NT1-1-j)/(double)(NT1-1);
	for(k=0; k<nf; k++){
	  ni = i*nf + k;
	  sum += rcos[ni]*cos(k*theta) + rsin[ni]*sin(k*theta);
	}
	r[i*NT1 + j] = sum;
      }
    }
  }
  free(rcos);
  free(rsin);
}
void escgetr_(double *r, int *nt1, int *ns, int *clockwise)
{
  escGetR(r, nt1, ns, clockwise);
}
void escgetr(double *r, int *nt1, int *ns, int *clockwise)
{
  escGetR(r, nt1, ns, clockwise);
}
void ESCGETR(double *r, int *nt1, int *ns, int *clockwise)
{
  escGetR(r, nt1, ns, clockwise);
}
 
/** 
 * Get the Fourier coefficients of the Z coordinate [m].
 * @param zcos the returned cosine coefficients of sizes [ns][nf].
 * @param zsin the returned sine coefficients
 * @param nf the number of Fourier coefficients (input)
 * @param ns the radial size (input)
 * @author L.E. Zakharov, A. Pletzer 
 * @see escGetFourierR
 */

void escGetFourierZ(double *rcos, double *rsin, int *nf, int *ns)
{
  int i,j,n,k;
  double *lc,*lc2,*ls,*ls2,dx;

  if(a0 != *ESsa){
    a0	=*ESsa;
    ESFirstSetSplA();
  }

  n	=*ns;
  k	=*nf < ESFp1 ? *nf : ESFp1;
  dx	=(a1-a0)/(n-1);
  for(i=0; i < n; i++){
    ESSetSplA(a0+dx*i);
    splRA(rcos,NULL,rsT,rsT2a);
    *rcos++	+=ESaZ0[0];
    *rsin++	 =0.;
    splRA(rsin,NULL,ESsb,ESsb2a);
    *rsin++;
    *rcos++	=0;;
    for(j=2; j < *nf; j++){
      *rcos++	=0.0;
      *rsin++	=0.0;
    }
  }
  return;
}

void escgetfourierz_(double *zcos, double *zsin, int *nf, int *ns){
  escGetFourierZ(zcos, zsin, nf, ns);
}
void escgetfourierz(double *zcos, double *zsin, int *nf, int *ns){
  escGetFourierZ(zcos, zsin, nf, ns);
}
void ESCGETFOURIERZ(double *zcos, double *zsin, int *nf, int *ns){
  escGetFourierZ(zcos, zsin, nf, ns);
}

/** 
 * Get the Z coordinate [m]. The poloidal index varies faster.
 * @param r the returned array of size [ns][nt1].
 * @param nt1 the number of poloidal sections + 1 (input)
 * @param ns the radial size (input)
 * @param clockwise poloidal angle orientation (1 for clockwise, 
 *        0 for counterclockwise)
 * @author L.E. Zakharov, A. Pletzer 
 * @see escGetR
 */

void escGetZ(double *z, int *nt1, int *ns, int *clockwise){
  double *zcos, *zsin;
  int NT1, NS, i, j, k, ni, nf;
  double sum, theta;
  NT1 = *nt1;
  NS  = *ns;
  nf = ESFp1;

  zcos =(double*) malloc( nf*NS*sizeof(double));
  zsin =(double*) malloc( nf*NS*sizeof(double));

  escGetFourierZ(zcos, zsin, &nf, ns);

  if(*clockwise!=1){
    for(i=0; i<NS; i++){
      for(j=0; j<NT1; j++){
	sum = 0.0;
	theta = c2gp*(double)j/(double)(NT1-1);
	for(k=0; k<nf; k++){
	  ni = i*nf + k;
	  sum += zcos[ni]*cos(k*theta) + zsin[ni]*sin(k*theta);
	}
	z[i*NT1 + j] = sum;
      }
    }
  }else{
    for(i=0; i<NS; i++){
      for(j=0; j<NT1; j++){
	sum = 0.0;
	theta = c2gp*(double)(NT1-1-j)/(double)(NT1-1);
	for(k=0; k<nf; k++){
	  ni = i*nf + k;
	  sum += zcos[ni]*cos(k*theta) + zsin[ni]*sin(k*theta);
	}
	z[i*NT1 + j] = sum;
      }
    }
  }    
  free(zcos);
  free(zsin);
}
void escgetz_(double *z, int *nt1, int *ns, int * clockwise){
  escGetZ(z, nt1, ns, clockwise);
}
void escgetz(double *z, int *nt1, int *ns, int * clockwise){
  escGetZ(z, nt1, ns, clockwise);
}
void ESCGETZ(double *z, int *nt1, int *ns, int * clockwise){
  escGetZ(z, nt1, ns, clockwise);
}
