#include <math.h>
#include <stdio.h>

#ifndef amzl_ESC
extern double cr2,cr3,cr4,cr6,cr12,cgp,c2gp,cgp_4,cr2gp,cgm0,crgm0;
extern int ESNa,ESNa1,ESNp,ESNp1,ESFp,ESFp1,TFCNt,TFCNp,ESLt,ESNt
,ESMp,ESMp1,ES2Mp,ES2Mp1,ESnMp;

extern int ESEqSolvFl,ESEqSolvIt,ESEqSolvRadC,ESEqSolvInPr,ESEqSolvInCr;
extern int ESFail;
extern double ESxDtPr[],ESxDtCr[],*ESaR0,*ESaZ0,*ESsa;
extern int ESnDtPr,ESnDtCr;

extern double ESRBt,ESRext;
extern double *ESaF,*ESaF1a,*ESaF2a
,*ESgF,*ESgF1a,*ESgF2a
,*ESgm,*ESgm1a,*ESgm2a
,*ESFF,*ESFF1a,*ESFF2a;

extern double *ESgt,*ESsr,*ESsb,*ESsb1a,*rcT,*rsT,*rcT1a,*rsT1a;
extern double *cs1,*sn1;

extern double *vr,*vz;

extern double *ESg22c,*ESg22c1,*ESg22c2,
*ESDPc,*ESDPc1,*ESDPc2,
*ESLc,*ESLc1,*ESLc2,
*ESVc,*ESVc1,*ESVc2;
#endif

extern double *ESRC,*ESRC1a,*ESRC2a
,*ESqgF,*ESqgF1a,*ESqgF2a
,*ESqgY,*ESqgY1a,*ESqgY2a
,*ESsh,*ESsh1a,*ESsh2a
,*ESqV,*ESqV1a,*ESqV2a

,*ESjp,*ESjp1a,*ESjp2a
,*ESsp,*ESsp1a,*ESsp2a
,*ESPs,*ESPs1a,*ESPs2a
,*ESgb,*ESgb1a,*ESgb2a
,*ESgB,*ESgB1a,*ESgB2a

,*ESjs,*ESjs1a,*ESjs2a
,*ESjb,*ESjb1a,*ESjb2a
,*ESaJ,*ESaJ1a,*ESaJ2a
,*ESaT,*ESaT1a,*ESaT2a
,*ESjB,*ESjB1a,*ESjB2a

,*ESsq,*ESsq1a,*ESsq2a
,*ESgm,*ESgm1a,*ESgm2a
,*ESgY,*ESgY1a,*ESgY2a
,*ESgF,*ESgF1a,*ESgF2a

,*ESaF,*ESaF1a,*ESaF2a
,*ESFF,*ESFF1a,*ESFF2a;

#ifndef amzl_ESCTR
static double *rdPV,*zdPV;
static int np,nj,npv,mpv;

static double cssp,cssj,cssr;
static double *ydPr,*ydCr,*xdPr,*xdCr;
static double stesc;
#endif

#ifndef amzl_ESC
#ifndef ablb_esc
/* ESC initiation, calling and deinitiation routines.
   Interior of routines is subject to changes by
   L.E. Zakharov without notice */
void esc0_(MachineNm)	/* ESC initiation routine */
     char *MachineNm;	/* Name of the machine */
{
  static Fl=0;
  if(Fl){
    return;
  }
  Fl	=1;
  ESNa	=20;
  ESNp	=64;
  ESMp	=12;
  ESFp	=2*ESMp;
  TFCNt	=0;
  TFCNp	=1;
  ESLt	=0;
  ESNt	=0;

  InitConstants();
  ESInitPlGeomInt();
  ESReInit1DPlV();
  ESReInit2DTPlV();
  ESReInitPlProf();
  EcInitArrays();
  
  ESReInitMetrTnsrCS();
  ECReInitFgY();
  
  ESGetPlVDAddr(&rdPV,&zdPV);
  ESInit1DPlV();
  ESInit2DTPlV();
}

void esc_(
	  int *Ffail 		/* Flag of failure:
				   0 - normal operation;
				   1 - some problems;
				   2 - problems near the boundary;
				   4 - problems near the axis;
				   8 - problems in the middle;
				   ....;
				   */
	  ,int *Fjob 		/* Flag for job assignment:
				   0 - nothing special was requested;
				   ...;
				   */ 
	  ,int *Mpol		/* Working number of Fourier harmonics
				   in $\Psi$ */
	  ,double *sTime	/* time */
	  )
{
  int i;
  if(2*(*Mpol) < ESFp){
    ESMp	=*Mpol;
    ESMp1	=ESMp+1;
    ES2Mp	=2*ESMp;
    ES2Mp1	=ES2Mp+1;
    ESnMp	=ESNa1*ES2Mp1;
  }
  stesc		=*sTime;

#ifndef blb_Equil
#ifndef mzl_Tsc2
#ifndef stg_OptPar
#endif

  ESReal2RefData(0);
  ESReal2RefGeom(0);
  ESPlVdata2PlV();
  ESRef2RealGeom(0);
  ESRealGeom(0);

#ifndef stg_RadC
#ifdef XWIN
  ESInpRadC();
#endif
#endif
#ifndef stg_PlVac
#ifdef XWIN
  ESInput2DPlGeom();
#endif
#endif
#ifndef stg_EqSolv
#ifdef XWIN
  ESInput2DEqSolv();
#endif
#endif

  ESReInitMetrTnsrCS();
  ECRcs3D2Rcs2D(0);
  ES3DMetrTnsrCS();
  ECReInitFgY();
  ESInpPlPrCr();
  EC1DEqSolv();
  ESPlProf2Data();

#ifndef stg_PlPr
#ifdef XWIN
  ESInpPlPr();
#endif
#endif
#ifndef stg_PlCr
#ifdef XWIN
  ESInpPlCr();
#endif
#endif
  
  ECRescue2DGeom(0);
  do{
    EC2DEqSolv(0);
    ECgYcs2dRZcsBound(0);
    ECVirtualPlV2vdrPlV();
    ECgYrc2dRZcs(0);
    ECvdrz2vrz(0);
    ECCheckJacob(0);
    ECRcs2D2Rcs3D(0);
    ESRealGeom(0);
    ES3DMetrTnsrCS();
    EC1DEqSolv();
  }while(ECIfEqFound());
  ECRefGeom(0);
  *Ffail	=0;
  if((ESFail&0x0000000F))
    *Ffail	+=1;
  if((ESFail&0x000000F0) || (ESFail&0x0F000000))
    *Ffail	+=8;
  if((ESFail&0x00F00000) || (ESFail&0x0000F000))
    *Ffail	+=4;
  if((ESFail&0x000F0000) || (ESFail&0x00000F00))
    *Ffail	+=2;
#ifndef stg_InitPFC
#endif
#ifndef stg_EqOut
#endif

#endif
#endif
}

void esc1_()
{
  ESDeInitEsc();
  ECDeInitFgY();
  EcDeInitArrays();
  DeInitSplines();
}

void esc0(MachineNm)
     char *MachineNm;
{
  esc0_(MachineNm);
}

void ESC0(MachineNm)
     char *MachineNm;
{
  esc0_(MachineNm);
}

void esc(int *Ffail,int *Fjob,int *Mpol,double *sTime)
{
  esc_(Ffail,Fjob,Mpol,sTime);
}

void ESC(int *Ffail,int *Fjob,int *Mpol,double *sTime)
{
  esc_(Ffail,Fjob,Mpol,sTime);
}

void esc1()
{
  esc1_();
}

void ESC1()
{
  esc1_();
}

void ESexit(int i)
{
  esc1_();
  exit(i);
}

#endif
#endif

#ifndef amzl_ESCTR
/* ESC Input interface routines */
#ifndef ablb_TSC
#ifdef TSC
void tsc2e()
{
  static int Fl=1;

  if(Fl){
    ESEqSolvRadC	=2;
    TSCLim2DPlV();
    ESInit2DPlGeom();
    EcInitPlVacData();
    ECRcs3D2Rcs2D(0);
    ECvr2r(0);
    ECvz2z(0);
    Fl	=0;
  }
}

/* EFIR-ESC interface. 
   Subject to changes by  F.Paoletti & L.E. Zakharov with no notice. */

static double p[129],q[129];

int EFIT2ESPlPrCr()
{
  int i,j,k;
  double s,t;

  ydCr[0]	=q[0]*cssj;
  ydPr[0]	=p[0]*cssp;
  for(i=1; i < nj; i++){
    s	=ESqgY[i];
    t	=s*s;
    j	=64.*s;
    k	=j == 64 ? j-1 : j+1;
    s	=j*j/4096.;
    s	=(t-s)/(k*k/4096.-s);
    ydCr[i]	=q[j]+(q[k]-q[j])*s;
    ydPr[i]	=(p[j]+(p[k]-p[j])*s)*cssp;
  }
}

int EFIT2esc()
{
  static int Fl=1;
  int i,I,j,k,K;
  double Rc[32],Zs[32],s,t;
  double *pr,*pz,R0;
  char ch;
  FILE *fp;

  fp=fopen("efit2esc","r");
  if(fp == NULL){
    printf("efit2esc - file is unavailable%c\n",'\a');
  }
  for(k=0; k < 6; k++){
    while((ch=getc(fp)) != '\n'){
      ;
    }
  }
  while((ch=getc(fp)) != '='){
    putchar(ch);
  }
  fscanf(fp,"%d",&I);
  while((ch=getc(fp)) != '='){
    ;
  }
  fscanf(fp,"%d",&K);
  while((ch=getc(fp)) != '='){
    ;
  }
  while((ch=getc(fp)) != '='){
    ;
  }
  fscanf(fp,"%lg",&R0);
  
  out("siId","I",I,K,R0);
  k	=0;
  while(k < K){
    while((ch=getc(fp)) != '='){
      ;
    }
    for(j=0; j < 5 && k < K; j++){
      fscanf(fp,"%lg",Rc+k);
      k++;
    }
  }
  k	=0;
  while(k < K){
    while((ch=getc(fp)) != '='){
      ;
    }
    for(j=0; j < 5 && k < K; j++){
      fscanf(fp,"%lg",Zs+k);
      k++;
    }
  }
  while((ch=getc(fp)) != '='){
    ;
  }
  fscanf(fp,"%lg",&ESRBt);
  while((ch=getc(fp)) != '='){
    ;
  }
  fscanf(fp,"%lg",&ESRext);
  out("sdd","Bt=",ESRBt,ESRext);
  ESRBt	*=ESRext;
  
  while((ch=getc(fp)) != '\n'){
    ;
  }
  while((ch=getc(fp)) != '\n'){
    ;
  }
  fscanf(fp,"%d%lg%lg%lg%lg%lg",&j,&s,q,&s,p,&s);
  i	=0;
  I	-=2;
  while(i < I){
    fscanf(fp,"%d%lg%lg%lg%lg%lg",&j,&s,q+i,&s,p+i,&s);
    out("sidd","q",i,q[i],p[i]);
    i++;
  }
  fclose(fp);
  if(Fl){
    npv	=12;
    mpv	=npv/2+1;
    ESSetPlVInt(npv,mpv);
    Fl	=0;
  }
  cssp	=cgm0*1e-6;
  cssj	=1;
  cssr	=1.;
    
  ESEqSolvFl	=0x31;
  ESEqSolvIt	=20;

#ifdef H
  ESEqSolvRadC	=2;
#endif

  ESEqSolvInPr	=2;
  ESEqSolvInCr	=6;
  np		=21;
  nj		=21;
  ESnDtPr	=np-1;
  ESnDtCr	=nj-1;
  ESGetPlPrfAddr(&ydPr,&ydCr,&xdPr,&xdCr);
  for(i=0; i < 21; i++){
    xdPr[i]	=0.05*i;
    xdCr[i]	=0.05*i;
    ESxDtPr[i]	=xdPr[i];
    ESxDtCr[i]	=xdCr[i];
  }
  for(i=0; i < ESNa1; i++){
    ESaF[i]	=ESRBt;
    ESaF1a[i]	=0;
    ESaF2a[i]	=0;
  }
  j	=ESNp1*ESNa;
  pr	=vr+j;
  pz	=vz+j;

  zdPV[0]	=0.;
  zdPV[1]	=0.;
  rdPV[2]	=R0;
  rdPV[3]	=R0;
  for(j=0; j < ESNp1; j++){
    t	=ESgt[j];
    *pr	=R0;
    *pz	=0.;
    for(k=0; k < K; k++){
      s		=(k+1)*t;
      *pr	+=Rc[k]*cos(s);
      *pz	+=Zs[k]*sin(s);
    }
    if(zdPV[0] < *pz){
      rdPV[0]	=*pr;
      zdPV[0]	=*pz;
    }
    if(zdPV[1] > *pz){
      rdPV[1]	=*pr;
      zdPV[1]	=*pz;
    }
    if(rdPV[2] > *pr){
      rdPV[2]	=*pr;
      zdPV[2]	=*pz;
    }
    if(rdPV[3] < *pr){
      rdPV[3]	=*pr;
      zdPV[3]	=*pz;
    }
    pr++;
    pz++;
  }
  j		=ESNp1*ESNa;
  pr		=vr+j;
  pz		=vz+j;
  ESaR0[0]	=cr2*(0.8*rdPV[2]+1.2*rdPV[3]);
  ESaZ0[0]	=0.;
  j	=5;
  rdPV[4]	=pr[j];
  zdPV[4]	=pz[j];
  rdPV[5]	=rdPV[4];
  zdPV[5]	=-zdPV[4];
  j	=ESNp/2-5;
  rdPV[6]	=pr[j];
  zdPV[6]	=pz[j];
  rdPV[7]	=rdPV[6];
  zdPV[7]	=-zdPV[6];
  j	=12;
  rdPV[8]	=pr[j];
  zdPV[8]	=pz[j];
  rdPV[9]	=rdPV[8];
  zdPV[9]	=-zdPV[8];
  j	=ESNp/2-10;
  rdPV[10]	=pr[j];
  zdPV[10]	=pz[j];
  rdPV[11]	=rdPV[10];
  zdPV[11]	=-zdPV[10];

  EFIT2ESPlPrCr();
#ifdef H
  if(Fl){
    ESInit2DPlGeom();
    EcInitPlVacData();
    ECRcs3D2Rcs2D(0);
    ECvr2r(0);
    ECvz2z(0);
    ESSwitchInpRadC();
    ESFirstSetSplDPr();
    ESFirstSetSplDCr();
    Fl	=0;
  }
#endif
  return(0);
}

#endif
#endif


#ifndef ablb_ASTRA
#ifdef ASTRA
/* ASTRA-ESC interface. 
   Subject to changes by  G.V.Pereverzev & L.E. Zakharov with no notice. */
static double rc[33],rca[33],rs[33],rsa[33],as[65],as2p[65],as1[65],as12p[65];
static double ch2hp,crHp;

/* ASTRA to ESC input initiation routine */
void astra2e_(double	*Pressure
	      ,double	*Jparallel
	      ,double	*Rpv
	      ,double	*Zpv
	      ,int	*Npv
	      ,double	*RBtor
	      ,double	*Rext
	      ,double	*gFtor
	      )
{
  static int Fl=1;
  int i;

  if(Fl){
    ch2hp	=cr12*ESgt[1]*ESgt[1];
    crHp	=1./ESNp;

    npv		=*Npv < 13 ? *Npv : 12;
    mpv		=npv/2+1;
    ESSetPlVInt(npv,mpv);
    
    cssp	=cgm0;
    cssj	=cgm0;
    cssr	=1.;
    
    ESEqSolvFl	=0x31;
    ESEqSolvIt	=20;
    ESEqSolvRadC	=2;
    ESEqSolvInPr	=2;
    ESEqSolvInCr	=1;
    np		=21;
    nj		=21;
    ESnDtPr	=np-1;
    ESnDtCr	=nj-1;
    ESGetPlPrfAddr(&ydPr,&ydCr,&xdPr,&xdCr);
    for(i=0; i < 21; i++){
      xdPr[i]	=0.05*i;
      xdCr[i]	=0.05*i;
      ESxDtPr[i]	=xdPr[i];
      ESxDtCr[i]	=xdCr[i];
    }
    for(i=0; i < ESNa1; i++){
      ESaF[i]	=ESRBt;
      ESaF1a[i]	=0;
      ESaF2a[i]	=0;
    }
  }
  ESRext	=*Rext;
  ESRBt		=*RBtor;
  for(i=0; i < npv; i++){
    rdPV[i]	=Rpv[i]*cssr;
    zdPV[i]	=Zpv[i]*cssr;
  }
  if(Fl){
    ESaR0[0]	=cr2*(0.9*Rpv[2]+1.1*Rpv[3]);
    ESaZ0[0]	=cr2*(Zpv[0]+Zpv[1]);
    ESInit2DPlGeom();
    EcInitPlVacData();
    ECRcs3D2Rcs2D(0);
    ECvr2r(0);
    ECvz2z(0);
    ESSwitchInpRadC();
    ESFirstSetSplDPr();
    ESFirstSetSplDCr();
    Fl	=0;
  }
  for(i=0; i < np; i++){
    ydPr[i]	=Pressure[i]*cssp;
  }
  for(i=0; i < nj; i++){
    ydCr[i]	=Jparallel[i]*cssj;
  }
}

/* ESC to ASTRA output routine */
void e2astra_(double	*Rmaxis
	      ,double	*Zmaxis
	      ,double	*gFtor
	      ,double	*Fpol
	      ,double	*gM
	      ,double	*G22
	      ,double	*G33
	      ,double	*D2
	      ,double	*D3
	      ,double	*Sside
	      ,double	*Sside1
	      )
{
  int i;
  double rR0,R0;
  int j,ji,k,ki,kj;
  double b,ba;
  double ra,rgt,za,zgt;

  R0		=ESaR0[0];
  rR0		=1./R0;
  *Rmaxis	=R0;
  *Zmaxis	=ESaZ0[0];
  *gFtor	=ESgF[ESNa]*c2gp;
  for(i=0; i < ESNa1; i++){
    Fpol[i]	=ESaF[i];
    gM[i]	=ESgm[i];
    G22[i]	=ESsa[i]*ESg22c[i];
    G33[i]	=ESsa[i]*ESLc[i]*rR0;
    D2[i]	=ESsa[i]*ESDPc[i];
    D3[i]	=ESsa[i]*R0*(ESLc[i]+ESVc[i]);
  }
  Sside[0]	=0.;
  Sside1[0]	=0.;
  for(i=1; i < ESNa1; i++){
    b		=ESsb[i];
    ba		=ESsb1a[i];
    ki		=i;
    rca[0]	=rcT1a[i];
    rsa[0]	=rsT1a[i];
    for(k=1; k < ESFp1; k++){
      ki	+=ESNa1;
      rca[k]	=2.*rcT1a[ki];
      rsa[k]	=2.*rsT1a[ki];
      rc[k]	=2.*k*rcT[ki];
      rs[k]	=2.*k*rsT[ki];
    }
    ji	=ESNp1*i;
    for(j=0; j < ESNp; j++){
      ra	=rca[0];
      rgt	=0.;
      kj	=0;
      for(k=1; k < ESFp1; k++){
	kj	+=j;
	if(kj >= ESNp)
	  kj	-=ESNp;
	ra	+=rca[k]*cs1[kj]+rsa[k]*sn1[kj];
	rgt	+=-rc[k]*sn1[kj]+rs[k]*cs1[kj];
      }
      zgt	=b*cs1[j];
      za	=rsa[0]+ba*sn1[j];
      as[j]	=rgt*rgt+zgt*zgt;
      as1[j]	=sqrt(rgt*rgt+zgt*zgt)*ESsr[ji];
      as[j]	*=ESsr[ji]/(ra*zgt-rgt*za);
      ji++;
    }
    as[j]	=as[0];
    as1[j]	=as1[0];
    splP(as,as2p);
    splP(as1,as12p);
    b	=0.;
    ba	=0.;
    for(j=0; j < ESNp; j++){
      b		+=as[j]-ch2hp*as2p[j];
      ba	+=as1[j]-ch2hp*as12p[j];
    }
    Sside[i]	=b*crHp;
    Sside1[i]	=ba*crHp;
  }
}

void astra2e(double	*Pressure
	      ,double	*Jparallel
	      ,double	*Rpv
	      ,double	*Zpv
	      ,int	*Npv
	      ,double	*RBtor
	      ,double	*Rext
	      ,double	*gFtor
	      )
{
  astra2e_(Pressure,Jparallel,Rpv,Zpv,Npv,RBtor,Rext,gFtor);
}

void ASTRA2E(double	*Pressure
	      ,double	*Jparallel
	      ,double	*Rpv
	      ,double	*Zpv
	      ,int	*Npv
	      ,double	*RBtor
	      ,double	*Rext
	      ,double	*gFtor
	      )
{
  astra2e_(Pressure,Jparallel,Rpv,Zpv,Npv,RBtor,Rext,gFtor);
}

void e2astra(double	*Rmaxis
	      ,double	*Zmaxis
	      ,double	*gFtor
	      ,double	*Fpol
	      ,double	*gM
	      ,double	*G22
	      ,double	*G33
	      ,double	*D2
	      ,double	*D3
	      ,double	*Sside
	      ,double	*Sside1
	      )
{
  e2astra_(Rmaxis,Zmaxis,gFtor,Fpol,gM,G22,G33,D2,D3,Sside,Sside1);
}

void E2ASTRA(double	*Rmaxis
	      ,double	*Zmaxis
	      ,double	*gFtor
	      ,double	*Fpol
	      ,double	*gM
	      ,double	*G22
	      ,double	*G33
	      ,double	*D2
	      ,double	*D3
	      ,double	*Sside
	      ,double	*Sside1
	      )
{
  e2astra_(Rmaxis,Zmaxis,gFtor,Fpol,gM,G22,G33,D2,D3,Sside,Sside1);
}

void lsode_(void *eqj,int *neq,double *gpr,double *x,double *xout
	    ,int *itol,double *rvtol,double *vtol,int *itask
	    ,int *istate,int *iopt,double *rwork,int *lrw
	    ,int *iwork,int *liw,void *k,int *mf)
{
}

#endif

#ifdef H
/* Our old interface */
sesc_(double*agrid,double*Pressure,double*Jparallel,int*Ngrids,
      double*Rpv,double*Zpv,int*Npv,double*Rmaxis,double*gFtor,
      double*Fpol,double*gM,double*G22,double*G33,double*D2,
      double*D3,double*Sside,double*Sside1,double*TTime)
#endif

#endif


#ifndef ablb_TRANSP

#endif
#endif

