#include <math.h>
#include <stdio.h>
#include <string.h>
#include "esc.h"

#ifndef mzl_ESmain
extern double cr2,cr3,cr4,cr6,cr12,cgp,c2gp,cgp_4,cr2gp,cgm0,crgm0;
#endif

#ifndef mzl_1Dcore
extern int ESNa,ESNa1;
extern double *ESsa;
#endif

#ifndef mzl_2Dcore
extern int ESNp,ESNp1,ESnAP;
extern int *ESnF,*ESmF,*ESkF,ESNf,ESNf1;
extern int ESMp,ESMp1,ES2Mp,ES2Mp1,ESnMp;
extern int ESFp,ESFp1,ESnAF;

extern double *ESemK,*ESemL,*ESemV,*ESemW,*ESemU1,*ESemU2;
extern double *ESemK2,*ESemL2,*ESemV2,*ESemW2,*ESemU12,*ESemU22;

extern double *ESg22c,*ESg22s,*ESg22c1,*ESg22s1,*ESg22c2,*ESg22s2;
extern double *ESr22,*ESr222,*ESr22c,*ESr22s,*ESr22c2,*ESr22s2;
extern double *ESg12c,*ESg12s,*ESg11c,*ESg11s;
extern double *ESg12c2,*ESg12s2,*ESg11c2,*ESg11s2;
extern double *ESLc,*ESLs,*ESVc,*ESVs,*ESDPc,*ESDPs;
extern double *ESLc1,*ESLs1,*ESVc1,*ESVs1,*ESDPc1,*ESDPs1;
extern double *ESLc2,*ESLs2,*ESVc2,*ESVs2,*ESDPc2,*ESDPs2;

extern double *cs1,*sn1,*cs2,*sn2;
extern double *dra,*drgt,*dza,*dzgt;
#endif

#ifndef mzl_3Dcore
extern int ESLt,ESNt,ESNt1,ESnAT,ESnAPT,ESLt0,ESNLt,ESNLt1;
extern double *ESsr,*rT1a,*zT1a,*rT1gt,*zT1gt;
extern double *ESaR0,*ESaZ0,*ESsb,*ESsb1a,*ESsb2a
,*rcT,*rsT,*rcT1a,*rsT1a,*rsT2a,*rcT2a;
#endif
extern double *ESFaux,*ESd2Faux;

int ESMetrTnsr()
{
  int i,in,j,ji,n,n1,jni,im,im0,m,m1,mm;
  int K,k,ki,kj;
  double *rc,*rca,*rs,*rsa,*df1;
  
  double r0,rr0,b;
  double s,ba,rA;
  double raa,ragt,zaa,zagt,dg0,dg1;
  double *D,*L,*V,*R22,*G22,*G12,*G11;
  
  D	=dra+ESNp1;
  L	=D+ESNp1;
  rc	=L+ESNp1;
  
  V	=dza+ESNp1;
  G22	=V+ESNp1;
  rca	=G22+ESNp1;
  
  G12	=drgt+ESNp1;
  rs	=G12+ESNp1;
  R22	=rs+ESNp1;
  
  
  G11	=dzgt+ESNp1;
  rsa	=G11+ESNp1;
  
  n		=0;
  K		=0;
  r0		=ESaR0[0];
  rr0		=1./r0;
  jni		=0;
  in		=0;
  im0		=0;
  jni		=0;
  i		=0;
  b		=ESsb1a[0];
  ki		=K+ESNa1;
  rc[1]	=2.*rcT1a[ki];
  rs[1]	=2.*rsT1a[ki];
  ba		=b*rc[1];
  for(j=0; j < ESNp; j++){
    drgt[j]	=-rc[1]*sn1[j]+rs[1]*cs1[j];
    dzgt[j]	=b*cs1[j];
    dra[j]	=rc[1]*cs1[j]+rs[1]*sn1[j];
    dza[j]	=b*sn1[j];
    L[j]	=ba;
    dg0	=rr0/ba;
    G11[j]	=(dra[j]*dra[j]+dza[j]*dza[j])*dg0;
    G12[j]	=(dra[j]*drgt[j]+dza[j]*dzgt[j])*dg0;
    G22[j]	=(drgt[j]*drgt[j]+dzgt[j]*dzgt[j])*dg0;
    R22[j]	=1./G22[j];
    rT1a[jni]	=dra[j];
    rT1gt[jni]=drgt[j];
    zT1a[jni]	=dza[j];
    zT1gt[jni]=dzgt[j];
    jni++;
  }
  L[j]	=L[0];
  G11[j]	=G11[0];
  G12[j]	=G12[0];
  G22[j]	=G22[0];
  R22[j]	=R22[0];
  rT1a[jni]	=dra[0];
  rT1gt[jni]	=drgt[0];
  zT1a[jni]	=dza[0];
  zT1gt[jni]	=dzgt[0];
  jni++;
  im		=im0;
  ESgP2gF(ESr22c+im,ESr22s+im,R22,ES2Mp);
  ESgP2gF(ESg22c+im,ESg22s+im,G22,ES2Mp);
  m1		=im;
  ESg11c[im]	=ESg22c[im];
  ESg11s[im]	=0.;
  ESg12c[im]	=0.;
  ESg12s[im]	=0.;
  ESDPc[im]	=ba;
  ESDPs[im]	=0.;
  ESLc[im]	=ba;
  ESLs[im]	=0.;
  ESVc2[im]	=0.;
  ESVs2[im]	=0.;
  m1	+=ESNa1;
  ESg11c[m1]	=0.;
  ESg11s[m1]	=0.;
  ESg12c[m1]	=0.;
  ESg12s[m1]	=0.;
  ESg22c[m1]	=0.;
  ESg22s[m1]	=0.;
  ESDPc[m1]	=0.;
  ESDPs[m1]	=0.;
  ESLc[m1]	=0.;
  ESLs[m1]	=0.;
  ESVc2[m1]	=ba*rc[1]*rr0;
  ESVs2[m1]	=ba*rs[1]*rr0;
  m1	+=ESNa1;
  ESg12c[m1]	=-ESg22s[m1];
  ESg12s[m1]	=ESg22c[m1];
  ESg11c[m1]	=-ESg22c[m1];
  ESg11s[m1]	=-ESg22s[m1];
  ESDPc[m1]	=0.;
  ESDPs[m1]	=0.;
  ESLc[m1]	=0.;
  ESLs[m1]	=0.;
  ESVc2[m1]	=0.;
  ESVs2[m1]	=0.;
  for(m=3; m < ES2Mp1; m++){
    m1	+=ESNa1;
    ESg11c[m1]	=0.;
    ESg11s[m1]	=0.;
    ESg12c[m1]	=0.;
    ESg12s[m1]	=0.;
    ESDPc[m1]		=0.;
    ESDPs[m1]		=0.;
    ESLc[m1]		=0.;
    ESLs[m1]		=0.;
    ESVc2[m1]		=0.;
    ESVs2[m1]		=0.;
  }
  
  ki		=K;
  rca[0]	=rcT2a[ki];
  rsa[0]	=rsT2a[ki];
  ki		+=ESNa1;
  k		=1;
  rca[1]	=2.*rcT1a[ki];
  rsa[1]	=2.*rsT1a[ki];
  ki		+=ESNa1;
  k		=2;
  rca[2]	=2.*rcT2a[ki];
  rsa[2]	=2.*rsT2a[ki];
  for(j=0; j < ESNp; j++){
    raa	=rca[0]+rca[2]*cs2[j]+rsa[2]*sn2[j];
    zaa	=rsa[0];
    ragt	=-rca[2]*sn2[j]+rsa[2]*cs2[j];
    dg1	=(b*(rca[0]+rca[2])-rsa[1]*rsa[0])*cs1[j]
      +(b*rsa[2]+rca[1]*rsa[0])*sn1[j];
    R22[j]	=(dra[j]*ba+r0*dg1-2.*drgt[j]*ragt*R22[j])/
      (drgt[j]*drgt[j]+dzgt[j]*dzgt[j]);
    dg0	=-dra[j]*rr0;
    D[j]	=dg1;
    L[j]	=L[j]*dg0+dg1;
    dg0	-=dg1/ba;
    G11[j]	*=dg0;
    G12[j]	*=dg0;
    G22[j]	*=dg0;
    dg0	=rr0/ba;
    G11[j]	+=2.*(dra[j]*raa+dza[j]*zaa)*dg0;
    G12[j]	+=(raa*drgt[j]+dra[j]*ragt+zaa*dzgt[j])*dg0;
    G22[j]	+=2.*ragt*drgt[j]*dg0;
  }
  D[j]	=D[0];
  L[j]	=L[0];
  G11[j]	=G11[0];
  G12[j]	=G12[0];
  G22[j]	=G22[0];
  R22[j]	=R22[0];
  im		=im0+i;
  ESgP2gF(ESDPc2+im,ESDPs2+im,D,ES2Mp);
  ESgP2gF(ESLc2+im,ESLs2+im,L,ES2Mp);
  m1		=im;
  for(m=0; m < ES2Mp1; m++){
    ESVc[m1]	=0.;
    ESVs[m1]	=0.;
    m1	+=ESNa1;
  }
  ESgP2gF(ESg11c2+im,ESg11s2+im,G11,ES2Mp);
  ESgP2gF(ESg12c2+im,ESg12s2+im,G12,ES2Mp);
  ESgP2gF(ESg22c2+im,ESg22s2+im,G22,ES2Mp);
  ESgP2gF(ESr22c2+im,ESr22s2+im,R22,ES2Mp);
  in++;
  for(i=1; i < ESNa1; i++){
    rA	=1./ESsa[i];
    b		=ESsb[in];
    ba	=ESsb1a[in];
    ki	=K+i;
    rca[0]	=rcT1a[ki];
    rsa[0]	=rsT1a[ki];
    for(k=1; k < ESFp1; k++){
      ki	+=ESNa1;
      rca[k]	=2.*rcT1a[ki];
      rsa[k]	=2.*rsT1a[ki];
      rc[k]	=2.*k*rcT[ki];
      rs[k]	=2.*k*rsT[ki];
    }
    for(j=0; j < ESNp; j++){
      dra[j]	=rca[0];
      drgt[j]	=0.;
      kj	=0;
      for(k=1; k < ESFp1; k++){
	kj		+=j;
	if(kj >= ESNp)
	  kj	-=ESNp;
	dra[j]	+=rca[k]*cs1[kj]+rsa[k]*sn1[kj];
	drgt[j]	+=-rc[k]*sn1[kj]+rs[k]*cs1[kj];
      }
      dzgt[j]	=b*cs1[j];
      dza[j]	=rsa[0]+ba*sn1[j];
      D[j]	=dra[j]*dzgt[j]-drgt[j]*dza[j];
      if(D[j] <= 0.){
#ifdef H
	printf("D[n=%3d][i=%2d][j=%2d]=%10.3e <= 0%c\n",n,i,j,D[j],7);
#endif
	return(1);
      }
      L[j]	=D[j]*r0/ESsr[jni]*rA;
      V[j]	=D[j]*ESsr[jni]*rr0*rA-L[j];
      dg0	=1./(D[j]*ESsr[jni]);
      D[j]	*=rA;
      G11[j]	=ESsa[i]*(dra[j]*dra[j]+dza[j]*dza[j])*dg0;
      G12[j]	=(dra[j]*drgt[j]+dza[j]*dzgt[j])*dg0;
      G22[j]	=(drgt[j]*drgt[j]+dzgt[j]*dzgt[j])*dg0*rA;
      R22[j]	=1./G22[j];
      rT1a[jni]	=dra[j];
      rT1gt[jni]	=drgt[j];
      zT1a[jni]	=dza[j];
      zT1gt[jni]	=dzgt[j];
      jni++;
    }
    D[j]	=D[0];
    L[j]	=L[0];
    V[j]	=V[0];
    G11[j]	=G11[0];
    G12[j]	=G12[0];
    G22[j]	=G22[0];
    R22[j]	=R22[0];
    rT1a[jni]	=dra[0];
    rT1gt[jni]=drgt[0];
    zT1a[jni]	=dza[0];
    zT1gt[jni]=dzgt[0];
    jni++;
    im	=im0+i;
    ESgP2gF(ESDPc+im,ESDPs+im,D,ES2Mp);
    ESgP2gF(ESLc+im,ESLs+im,L,ES2Mp);
    ESgP2gF(ESVc+im,ESVs+im,V,ES2Mp);
    ESgP2gF(ESg22c+im,ESg22s+im,G22,ES2Mp);
    ESgP2gF(ESg12c+im,ESg12s+im,G12,ES2Mp);
    ESgP2gF(ESg11c+im,ESg11s+im,G11,ES2Mp);
    ESgP2gF(ESr22c+im,ESr22s+im,R22,ES2Mp);
    in++;
  }
  i		=ESNa;
  jni		-=ESNp1;
  in--;
  ki		=K+i;
  rca[0]	=rcT2a[ki];
  rsa[0]	=rsT2a[ki];
  for(k=1; k < ESFp1; k++){
    ki	+=ESNa1;
    rca[k]	=2.*rcT2a[ki];
    rsa[k]	=2.*rsT2a[ki];
    b		=2.*k;
    rc[k]	=b*rcT1a[ki];
    rs[k]	=b*rsT1a[ki];
  }
  b		=ESsb1a[in];
  ba		=ESsb2a[in];
  for(j=0; j < ESNp; j++){
    raa	=rca[0];
    ragt	=0.;
    kj	=0;
    for(k=1; k < ESFp1; k++){
      kj	+=j;
      if(kj >= ESNp)
	kj	-=ESNp;
      raa	+=rca[k]*cs1[kj]+rsa[k]*sn1[kj];
      ragt	+=-rc[k]*sn1[kj]+rs[k]*cs1[kj];
    }
    zaa	=rsa[0]+ba*sn1[j];
    zagt	=b*cs1[j];
    dg0	=-dra[j]/ESsr[jni];
    dg1	=raa*dzgt[j]+dra[j]*zagt-ragt*dza[j]-drgt[j]*zaa;


    L[j]	=(dg0-1.)*L[j]+dg1*r0/ESsr[jni];
    V[j]	=(D[j]*dra[j]+dg1*ESsr[jni]-D[j]*ESsr[jni])*rr0-L[j];


    R22[j]	=(D[j]*ESsr[jni]+ESsa[i]*(ESsr[jni]*dg1+dra[j]*D[j])
		  -2.*(drgt[j]*ragt+dzgt[j]*zagt)*R22[j])/
		    (drgt[j]*drgt[j]+dzgt[j]*dzgt[j]);
    dg0	-=dg1/D[j];
    G12[j]	*=dg0;
    G22[j]	*=(dg0-1.);
    dg0	+=1.;
    G11[j]	*=dg0;
    dg0	=1./(D[j]*ESsr[jni]);
    G11[j]	+=2.*(dra[j]*raa+dza[j]*zaa)*dg0*ESsa[i];
    G12[j]	+=(raa*drgt[j]+dra[j]*ragt+zaa*dzgt[j]+dza[j]*zagt)*dg0;
    G22[j]	+=2.*(drgt[j]*ragt+dzgt[j]*zagt)*dg0;
    D[j]	=dg1-D[j];

    jni++;
  }
  D[j]	=D[0];
  L[j]	=L[0];
  V[j]	=V[0];
  G11[j]	=G11[0];
  G12[j]	=G12[0];
  G22[j]	=G22[0];
  im		=im0+i;
  ESgP2gF(ESDPc2+im,ESDPs2+im,D,ES2Mp);
  ESgP2gF(ESLc2+im,ESLs2+im,L,ES2Mp);
  ESgP2gF(ESVc2+im,ESVs2+im,V,ES2Mp);
  ESgP2gF(ESg22c2+im,ESg22s2+im,G22,ES2Mp);
  ESgP2gF(ESg12c2+im,ESg12s2+im,G12,ES2Mp);
  ESgP2gF(ESg11c2+im,ESg11s2+im,G11,ES2Mp);
  ESgP2gF(ESr22c2+im,ESr22s2+im,R22,ES2Mp);
  im	=im0;
  m1	=0;
  in	=im+ESNa;
  dg0	=ESDPc2[im];
  dg1	=ESDPc2[in];
  splAA(ESDPc+im,ESDPc1+im,ESDPc2+im,&dg0,&dg1);
  dg0	=ESLc2[im];
  dg1	=ESLc2[in];
  splAA(ESLc+im,ESLc1+im,ESLc2+im,&dg0,&dg1);
  dg0	=ESVc2[im];
  dg1	=ESVc2[in];
  splAA(ESVc+im,ESVc1+im,ESVc2+im,&dg0,&dg1);
  dg0	=ESg22c2[im];
  dg1	=ESg22c2[in];
  splAA(ESg22c+im,ESg22c1+im,ESg22c2+im,&dg0,&dg1); /***/
  dg0	=ESg12c2[im];
  dg1	=ESg12c2[in];
  splA(ESg12c+im,ESg12c2+im,&dg0,&dg1);
  dg0	=ESg11c2[im];
  dg1	=ESg11c2[in];
  splA(ESg11c+im,ESg11c2+im,&dg0,&dg1);
  dg0	=ESr22c2[im];
  dg1	=ESr22c2[in];
  splA(ESr22c+im,ESr22c2+im,&dg0,&dg1);
  for(m=0; m < ES2Mp; m++){
    m1++;
    im 	+=ESNa1;
    in	=im+ESNa;
    dg0	=ESDPc2[im];
    dg1	=ESDPc2[in];
    splAA(ESDPc+im,ESDPc1+im,ESDPc2+im,&dg0,&dg1);
    dg0	=ESDPs2[im];
    dg1	=ESDPs2[in];
    splAA(ESDPs+im,ESDPs1+im,ESDPs2+im,&dg0,&dg1);
    dg0	=ESLc2[im];
    dg1	=ESLc2[in];
    splAA(ESLc+im,ESLc1+im,ESLc2+im,&dg0,&dg1);
    dg0	=ESLs2[im];
    dg1	=ESLs2[in];
    splAA(ESLs+im,ESLs1+im,ESLs2+im,&dg0,&dg1);
    dg0	=ESVc2[im];
    dg1	=ESVc2[in];
    splAA(ESVc+im,ESVc1+im,ESVc2+im,&dg0,&dg1);
    dg0	=ESVs2[im];
    dg1	=ESVs2[in];
    splAA(ESVs+im,ESVs1+im,ESVs2+im,&dg0,&dg1);
    dg0	=ESg22c2[im];
    dg1	=ESg22c2[in];
    splAA(ESg22c+im,ESg22c1+im,ESg22c2+im,&dg0,&dg1); /***/
    dg0	=ESg22s2[im];
    dg1	=ESg22s2[in];
    splAA(ESg22s+im,ESg22s1+im,ESg22s2+im,&dg0,&dg1); /***/
    dg0	=ESg12c2[im];
    dg1	=ESg12c2[in];
    splA(ESg12c+im,ESg12c2+im,&dg0,&dg1); /***/
    dg0	=ESg12s2[im];
    dg1	=ESg12s2[in];
    splA(ESg12s+im,ESg12s2+im,&dg0,&dg1); /***/
    dg0	=ESg11c2[im];
    dg1	=ESg11c2[in];
    splA(ESg11c+im,ESg11c2+im,&dg0,&dg1);
    dg0	=ESg11s2[im];
    dg1	=ESg11s2[in];
    splA(ESg11s+im,ESg11s2+im,&dg0,&dg1);
    dg0	=ESr22c2[im];
    dg1	=ESr22c2[in];
    splA(ESr22c+im,ESr22c2+im,&dg0,&dg1);
    dg0	=ESr22s2[im];
    dg1	=ESr22s2[in];
    splA(ESr22s+im,ESr22s2+im,&dg0,&dg1);
  }

#ifdef h
  {
    int kW,k0,i0,i1,i;
    double x[2],y[2],Wx[500],W1[33][500];
    double *p,*p1,*p2,s,t,s1,ds;

    p		=rcT;
    p1		=rcT1a;
    p2		=rcT2a;
    k0		=0;
    y[0]	=p[0];
    y[1]	=y[0];
    i0		=ESNa1-4;
    i1		=ESNa1;
    x[0]	=ESsa[i0];
    x[1]	=ESsa[i1-1];
    s		=(x[1]-x[0])/160.;

    t		=x[0];
    kW	=0;
    while(t <= x[1]){
      ESSetSplA(t);
      Wx[kW]	=t;
      for(k=k0; k < ES2Mp1; k++){
	ki	=ESNa1*k;
	splRA(&ds,&s1,p+ki,p2+ki);
	if(y[0] > ds)
	  y[0]=ds;
	if(y[1] < ds)
	  y[1]=ds;
	W1[k][kW]	=ds;
      }
#ifdef h
      splRA(&ds,&s1,ESsb,ESsb2a);
      if(y[0] > ds)
	y[0]=ds;
      if(y[1] < ds)
	y[1]=ds;
      W1[k][kW]	=ds;
#endif
    
      t	+=s;
      kW++;
    }
    for(i=i0; i < i1; i++){
      for(k=k0; k < ES2Mp1; k++){
	ki	=ESNa1*k;
	ds	=p[ki+i];
	if(y[0] > ds)
	  y[0]=ds;
	if(y[1] < ds)
	  y[1]=ds;
      }
    }
    Scale2D(4,2,x,y,2,6,2);
    for(k=k0; k < ES2Mp1; k++){
      ki	=ESNa1*k;
      Plot2d(4,ESsa+i0,p+ki+i0,i1-i0,6,0,0,0);
      if(k%2)
	Plot2d(4,Wx,W1[k],kW,6,0,14,0);
      else
	Plot2d(4,Wx,W1[k],kW,6,0,4,0);
      if(k == k0)
	Plot2d(4,Wx,W1[k],kW,6,0,11,0);
    }
#ifdef h
    Plot2d(4,ESsa+i0,ESsb+i0,i1-i0,6,0,0,0);
    Plot2d(4,Wx,W1[k],kW,6,0,4,0);
#endif
    CbFlush();
  }
#endif
#ifdef h
  {
    int kW,k0;
    double x[2],y[2],Wx[300],W1[33][202],W2[33][202],W2c[700],W2s[700];
    double *p,*p1,*p2,s,t,s1;

    p		=ESr22c;
    p1		=rcT1a;
    p2		=ESr22c2;
    k0		=0;
    y[0]	=p[0];
    y[1]	=y[0];
    x[0]	=ESsa[ESNa-3];
    x[1]	=1.;
    kW		=0;
    s		=(x[1]-x[0])/100;
    t		=x[0];
    while(t <= 1.+cr2*s){
      ESSetSplA(t);
      Wx[kW]	=t;
      ki	=0;
      for(k=k0; k < ES2Mp1; k++){
	ki	=ESNa1*k;
	splRA(&s1,NULL,p+ki,p2+ki);
	if(y[0] > s1)
	  y[0]=s1;
	if(y[1] < s1)
	  y[1]=s1;
	W1[k][kW]	=s1;
      }
      splRA(&b,&ba,ESsb,ESsb2a);
      splRA(rc,rca,rcT,rcT2a);
      rc[0]	+=ESaR0[0];
      splRA(rs,rsa,rsT,rsT2a);
      rs[0]	+=ESaZ0[0];
      ki	=0;
      for(k=1; k < ESFp1; k++){
	ki	+=ESNa1;
	splRA(rc+k,rca+k,rcT+ki,rcT2a+ki);
	rca[k]	*=2.;
	rc[k]	*=2.;
	splRA(rs+k,rsa+k,rsT+ki,rsT2a+ki);
	rsa[k]	*=2.;
	rs[k]	*=2.;
      }
      for(j=0; j < ESNp; j++){
	dg0	=rc[0];
	raa	=rca[0];
	ragt	=0.;
	kj	=0;
	for(k=1; k < ESFp1; k++){
	  kj		+=j;
	  if(kj >= ESNp)
	    kj	-=ESNp;
	  dg0	+=rc[k]*cs1[kj]+rs[k]*sn1[kj];
	  raa	+=rca[k]*cs1[kj]+rsa[k]*sn1[kj];
	  ragt	+=k*(-rc[k]*sn1[kj]+rs[k]*cs1[kj]);
	}
	zagt	=b*cs1[j];
	zaa	=rsa[0]+ba*sn1[j];
	dg0	*=raa*zagt-ragt*zaa;
	if(dg0 != 0.){
#ifdef h
	  G22[j]	=(ragt*ragt+zagt*zagt)/dg0;
#endif
	  G22[j]	=(ragt*ragt+zagt*zagt)/dg0;
	}
	else
	  G22[j]	=0.;

      }
      G22[j]	=G22[0];
      ESgP2gF(Wc2,Ws2,G22,ES2Mp);
      ki	=0;
      for(k=0; k < ES2Mp1; k++){
	W2[k][kW]	=Wc2[ki];
	ki	+=ESNa1;
      }
      t	+=s;
      kW++;
    }
    Scale2D(4,2,x,y,2,6,2);
    j	=ESNa-3;
    for(k=k0; k < ES2Mp1; k++){
      ki	=ESNa1*k+j;
      Plot2d(4,a+j,p+ki,ESNa1-j,6,0,3,0);
      Plot2d(4,Wx,W1[k],kW,6,0,4,0);
      Plot2d(4,Wx,W2[k],kW,6,0,14,0);
    }
    CbFlush();
  }
#endif
  return(0);
}

int ES3DInvG22()
{
  int i,j,ji,n,n1,im,im1,im0,m,m1,mm;
  
  double *p22c,*p22s,*pr22,*pr222;
  double *ac,*f,s;
  int *indx;

  ESReInitPlVeq(ES2Mp1,&ac,&f,&indx);
  
  return(0);

  im0	=ESNa1*ES2Mp1;
  for(n=0; n < ESNLt; n++){
    im		=im0*n;
    p22c	=ESg22c+im;
    p22s	=ESg22s+im;
    im		*=ES2Mp1;
    pr22	=ESr22+im;
    pr222	=ESr222+im;
    i		=0;
    j		=0;
    im		=i;
    ji		=0;
    ac[ji]	=p22c[im];
    ji++;
    im		+=ESNa1;
    for(mm=0; mm < ESMp; mm++){
      ac[ji]	=2.*p22c[im];
      ji++;
      ac[ji]	=-2.*p22s[im];
      ji++;
      im	+=ESNa1;
    }
    j++;
    for(m=0; m < ESMp; m++){
      ji	=ES2Mp1*j+j;
      m1	=2*m+2;
      im	=i+ESNa1*m1;
      im1	=i;
      for(mm=m; mm < ESMp; mm++){
	if(mm == m){
	  ac[ji]	=2.*(p22c[im]+ac[0]);
	  ji++;
	  ac[ji]	=-2.*p22s[im];
	}
	else{
	  ac[ji]	=2.*(p22c[im]+p22c[im1]);
	  ji++;
	  ac[ji]	=-2.*(p22s[im]+p22s[im1]);
	}
	ji++;
	im1	+=ESNa1;
	im	+=ESNa1;
      }
      j++;
      ji	=ES2Mp1*j+j;
      im	=i+ESNa1*m1;
      im1	=i;
      mm	=m;
      ac[ji]	=2.*(ac[0]-p22c[im]);
      ji++;
      im1	+=ESNa1;
      im	+=ESNa1;
      mm++;
      while(mm < ESMp){
	ac[ji]	=2.*(p22s[im1]-p22s[im]);
	ji++;
	ac[ji]	=2.*(p22c[im1]-p22c[im]);
	ji++;
	im1	+=ESNa1;
	im	+=ESNa1;
	mm++;
      }
      j++;
    }
    if(CholDc(ac,ES2Mp1) < 0){
#ifdef H
      printf("Nonpositive G22 Matrix at n=%3d i=%2d\n",n,i);
      printf("??? ------ ac[%2d] ------\n",i);
      for(m=0; m < ES2Mp1; m++){
	ji	=ES2Mp1*m+m;
	for(mm=0; mm < m; mm++){
	  printf("%10.3s","");
	}
	for(mm=m; mm < ES2Mp1; mm++){
	  printf("%10.3e",ac[ji]);
	  ji++;
	}
	printf("\n");
      }
#endif
    }
    ji	=i;
    for(m=0; m < ES2Mp1; m++){
      for(mm=0; mm <= m ; mm++){
	pr22[ji]	=ac[m*ES2Mp1+mm];
	ji	+=ESNa1;
      }
    }
    p22c	=ESg22c+im0*n;
    p22s	=ESg22s+im0*n;
    for(i=1; i < ESNa1; i++){
      j		=0;
      im	=i;
      ji	=0;
      ac[ji]	=p22c[im];
      ji++;
      im	+=ESNa1;
      for(mm=0; mm < ESMp; mm++){
	ac[ji]	=2.*p22c[im];
	ji++;
	ac[ji]	=-2.*p22s[im];
	ji++;
	im	+=ESNa1;
      }
      j++;
      for(m=0; m < ESMp; m++){
	ji	=ES2Mp1*j+j;
	m1	=2*m+2;
	im	=i+ESNa1*m1;
	im1	=i;
	for(mm=m; mm < ESMp; mm++){
	  if(mm == m){
	    ac[ji]	=2.*(p22c[im]+ac[0]);
	    ji++;
	    ac[ji]	=-2.*p22s[im];
	  }
	  else{
	    ac[ji]	=2.*(p22c[im]+p22c[im1]);
	    ji++;
	    ac[ji]	=-2.*(p22s[im]+p22s[im1]);
	  }
	  ji++;
	  im1	+=ESNa1;
	  im	+=ESNa1;
	}
	j++;
	ji	=ES2Mp1*j+j;
	im	=i+ESNa1*m1;
	im1	=i;
	mm	=m;
	ac[ji]	=2.*(ac[0]-p22c[im]);
	ji++;
	im1	+=ESNa1;
	im	+=ESNa1;
	mm++;
	while(mm < ESMp){
	  ac[ji]	=2.*(p22s[im1]-p22s[im]);
	  ji++;
	  ac[ji]	=2.*(p22c[im1]-p22c[im]);
	  ji++;
	  im1	+=ESNa1;
	  im	+=ESNa1;
	  mm++;
	}
	j++;
      }
      if(CholDc(ac,ES2Mp1) < 0){
#ifdef H
	printf("Nonpositive G22 Matrix at n=%3d i=%2d\n",n,i);
	printf("??? ------ ac[%2d] ------\n",i);
	for(m=0; m < ES2Mp1; m++){
	  ji	=ES2Mp1*m+m;
	  for(mm=0; mm < m; mm++){
	    printf("%10.3s","");
	  }
	  for(mm=m; mm < ES2Mp1; mm++){
	    printf("%10.3e",ac[ji]);
	    ji++;
	  }
	  printf("\n");
	}
#endif
      }
      ji	=i;
      for(m=0; m < ES2Mp1; m++){
	for(mm=0; mm <= m ; mm++){
	  pr22[ji]	=ac[m*ES2Mp1+mm];
	  ji	+=ESNa1;
	}
      }
    }
    ji	=0;
    for(m=0; m < ES2Mp1; m++){
#ifdef J
      printf("??? m=%2d\n",m);
#endif
      for(mm=0; mm <= m ; mm++){
#ifdef J
	printf("???    mm=%2d\n",mm);
	for(i=0; i< ESNa1; i++){
	  printf("??? pr22[%2d]=%10.3e\n",i,*(pr22+ji+i));
	}
#endif
	splA(pr22+ji,pr222+ji,NULL,NULL);
	ji	+=ESNa1;
      }
    }
    n1	=n+ESNLt;
    while(n1 < ESNt1){
      im1	=im0*ES2Mp1*n1;
      ji	=0;
      for(m=0; m < ES2Mp1; m++){
	for(mm=0; mm <= m; mm++){
	  for(i=0; i < ESNa1; i++){
	    ESr22[im1]	=pr22[ji];
	    ESr222[im1]	=pr222[ji];
	    im1++;
	    ji++;
	  }
	}
      }
      n1	+=ESNLt;
    }
  }
#ifdef h
  {
    int kW,k,ki;
    double x[2],y[2],Wx[300],W1[300][200];
    double *p,*p1,*p2,s,t,s1;

    p		=ESr22;
    p1		=rcT1a;
    p2		=ESr222;
    y[0]	=p[0];
    y[1]	=y[0];
    x[0]	=0.;
    x[1]	=1.;
    ki		=0;
    s		=0.125*ESsa[1];
    
    ki	=0;
    k	=0;
    for(m=0; m < ES2Mp1; m++){
      for(mm=0; mm <= m; mm++){
	kW	=0;
	t	=0.;
	while(t <= x[1]+s*0.5){
	  ESSetSplA(t);
	  Wx[kW]	=t;
	  splRA(&s1,NULL,p+ki,p2+ki);
	  if(y[0] > s1)
	    y[0]	=s1;
	  if(y[1] < s1)
	    y[1]	=s1;
	  W1[k][kW]	=s1;
	  t		+=s;
	  kW++;
	}
	k++;
	ki	+=ESNa1;
      }
    }
    Scale2D(4,2,x,y,2,6,2);
    ki	=0;
    k	=0;
    for(m=0; m < ES2Mp1; m++){
      for(mm=0; mm <= m; mm++){
	Plot2d(4,ESsa,p+ki,ESNa1,6,0,4,0);
	Plot2d(4,Wx,W1[k],kW,6,0,0,0);
	k++;
	ki	+=ESNa1;
      }
    }
    CbFlush();
  }
#endif
  return(0);
}    

int ESInitgYbY(double *gyr,double *gyi,double *Yr,double *Yi,double A, int n)
{
  int i,j,m,M,M0,mm,in,k,k1,k2,kk;
  int K,ki,kj;
  double b,ba,S,sr,si,r1c,r1s;

  double *fr,*fi,*dfr,*dfi,*fmr,*fmi,*dfmr,*dfmi;
  double Fc[128],Fs[128],dFc[128],dFs[128],g22c[128],g22s[128],
  g12c[128],g12s[128];

  double gnr,gni,gnn,gnmr,gnmi,gnnm;
  double s,zr,zi,zmr,zmi;
  double f1r,f1i,f2r,f2i;

  if(ES2Mp1 > 128){
    printf("2*Mp+1=%d > 128\n",ES2Mp1);
    ESexit(0);
  }

  K	=ESnAF*n;
  ESSetSplA(A);
  fr	=ESd2Faux+ESNa1;
  fi	=fr	+ESNp1;
  dfr	=fi	+ESNp1;
  dfi	=dfr	+ESNp1;
  fmr	=dfi	+ESNp1;
  fmi	=fmr	+ESNp1;
  dfmr	=fmi	+ESNp1;
  dfmi	=dfmr	+ESNp1;

  in	=ESNa1*n;
  ki	=K+ESNa1;
  zr	=rcT[ki]+cr2*ESsb1a[in];
  zi	=rsT[ki];

  s	=1./(zr*zr+zi*zi);
  zr	*=s;
  zi	*=s;

  b	=ESsb1a[in];
  sr	=2.*rcT[ki];
  s	=sr+b;
  si	=2.*rsT[ki];
  s	=1./(s*s+si*si);
  gnr	=(sr*sr-si*si-b*b)*s;
  gni	=2.*sr*si*s;
  gnn	=gnr*gnr+gni*gni;
  gnmr	=gnr;
  gnmi	=gni;
  gnnm	=gnn;
  zmr	=zr;
  zmi	=zi;
  splRA(&b,&ba,ESsb+in,ESsb2a+in);
  ba	*=A;
  ki	=K;
  for(k=0; k < ESFp1; k++){
    splRA(Fc+k,dFc+k,rcT+ki,rcT2a+ki);
    splRA(Fs+k,dFs+k,rsT+ki,rsT2a+ki);
    ki	+=ESNa1;
  }
  dFc[0]	*=A;
  dFs[0]	*=A;
  S		=2.*A;
  for(k=1; k < ESFp1; k++){
    Fc[k]	*=2.;
    Fs[k]	*=2.;
    dFc[k]	*=S;
    dFs[k]	*=S;
  }
  for(j=0; j < ESNp; j++){
    fr[j]	=Fc[0];
    dfr[j]	=dFc[0];
    kj	=j;
    for(k=1; k < ESFp; k++){
      fr[j]	+=Fc[k]*cs1[kj]+Fs[k]*sn1[kj];
      dfr[j]	+=dFc[k]*cs1[kj]+dFs[k]*sn1[kj];
      kj		+=j;
      if(kj >= ESNp)
	kj	-=ESNp;
    }
    fi[j]	=Fs[0]+b*sn1[j];
    dfi[j]	=dFs[0]+ba*sn1[j];
    fmr[j]	=fr[j];
    fmi[j]	=fi[j];
    dfmr[j]	=dfr[j];
    dfmi[j]	=dfi[j];
  }
  fr[ESNp]	=fr[0];
  fi[ESNp]	=fi[0];
  dfr[ESNp]	=dfr[0];
  dfi[ESNp]	=dfi[0];
  fmr[ESNp]	=fmr[0];
  fmi[ESNp]	=fmi[0];
  dfmr[ESNp]	=dfmr[0];
  dfmi[ESNp]	=dfmi[0];
  M	=0;
  k	=0;
  for(kk	=0; kk < ES2Mp1; kk++){
    gyr[k]	=0.;
    gyi[k]	=0.;
    Yr[k]	=0.;
    Yi[k]	=0.;
    k++;
  }
  M++;
  ESP2F(Fc,Fs,fmr,ESMp);
  ESP2F(dFc,dFs,dfmr,ESMp);
  k	=ES2Mp1*M+ESMp;
  k2	=k;
  k1	=k;
  mm	=0;
  gyr[k]	=Fc[mm];
  gyi[k]	=Fs[mm];
  Yr[k]		=dFc[mm];
  Yi[k]		=dFs[mm];
  while(mm < ESMp){
    k2++;
    k1--;
    mm++;
    gyr[k1]	=Fc[mm];
    gyi[k1]	=Fs[mm];
    Yr[k1]	=dFc[mm];
    Yi[k1]	=dFs[mm];
    gyr[k2]	=Fc[mm];
    gyi[k2]	=-Fs[mm];
    Yr[k2]	=dFc[mm];
    Yi[k2]	=-dFs[mm];
  }
  ESP2F(Fc,Fs,fmi,ESMp);
  ESP2F(dFc,dFs,dfmi,ESMp);
  k	=ES2Mp1*M+ESMp;
  k2	=k;
  k1	=k;
  mm	=0;
  gyr[k]	-=Fs[mm];
  gyi[k]	+=Fc[mm];
  Yr[k]		-=dFs[mm];
  Yi[k]		+=dFc[mm];
  while(mm < ESMp){
    k2++;
    k1--;
    mm++;
    gyr[k1]	-=Fs[mm];
    gyi[k1]	+=Fc[mm];
    Yr[k1]	-=dFs[mm];
    Yi[k1]	+=dFc[mm];
    gyr[k2]	+=Fs[mm];
    gyi[k2]	+=Fc[mm];
    Yr[k2]	+=dFs[mm];
    Yi[k2]	+=dFc[mm];
  }
  s		=1./(1.-gnnm);
  f1r		=zmr*s;
  f1i		=zmi*s;
  f2r		=(gnmr*zmr+gnmi*zmi)*s;
  f2i		=(gnmi*zmr-gnmr*zmi)*s;
  sr		=gnmr;
  si		=gnmi;
  gnmr		=sr*gnr-si*gni;
  gnmi		=si*gnr+sr*gni;
  gnnm		*=gnn;
  sr		=zmr;
  si		=zmi;
  zmr		=sr*zr-si*zi;
  zmi		=si*zr+sr*zi;
  k		=ES2Mp1*M+ESMp;
  sr		=gyr[k];
  si		=gyi[k];
  gyr[k]	=(f1r-f2r)*sr-(f1i+f2i)*si;
  gyi[k]	=(f1i-f2i)*sr+(f1r+f2r)*si;
  sr		=Yr[k];
  si		=Yi[k];
  Yr[k]		=(f1r-f2r)*sr-(f1i+f2i)*si;
  Yi[k]		=(f1i-f2i)*sr+(f1r+f2r)*si;
  for(mm=1; mm < ESMp1; mm++){
    k2		=k+mm;
    k1		=k-mm;
    sr		=gyr[k2];
    si		=gyi[k2];
    r1c		=gyr[k1];
    r1s		=gyi[k1];
    gyr[k2]	=f1r*sr-f1i*si-f2r*r1c-f2i*r1s;
    gyi[k2]	=f1i*sr+f1r*si-f2i*r1c+f2r*r1s;
    gyr[k1]	=f1r*r1c-f1i*r1s-f2r*sr-f2i*si;
    gyi[k1]	=f1i*r1c+f1r*r1s-f2i*sr+f2r*si;
    sr		=Yr[k2];
    si		=Yi[k2];
    r1c		=Yr[k1];
    r1s		=Yi[k1];
    Yr[k2]	=f1r*sr-f1i*si-f2r*r1c-f2i*r1s;
    Yi[k2]	=f1i*sr+f1r*si-f2i*r1c+f2r*r1s;
    Yr[k1]	=f1r*r1c-f1i*r1s-f2r*sr-f2i*si;
    Yi[k1]	=f1i*r1c+f1r*r1s-f2i*sr+f2r*si;
  }	
  for(M=2; M < ESMp1; M++){
    for(j=0; j < ESNp1; j++){
      sr	=fmr[j];
      si	=fmi[j];
      dfmr[j]	=M*(dfr[j]*sr-dfi[j]*si);
      dfmi[j]	=M*(dfr[j]*si+dfi[j]*sr);
      fmr[j]	=fr[j]*sr-fi[j]*si;
      fmi[j]	=fr[j]*si+fi[j]*sr;
    }
    ESP2F(Fc,Fs,fmr,ESMp);
    ESP2F(dFc,dFs,dfmr,ESMp);
    k		=ES2Mp1*M+ESMp;
    k2		=k;
    k1		=k;
    mm		=0;
    gyr[k]	=Fc[mm];
    gyi[k]	=0.;
    Yr[k]	=dFc[mm];
    Yi[k]	=0.;
    while(mm < ESMp){
      k2++;
      k1--;
      mm++;
      gyr[k1]	=Fc[mm];
      gyi[k1]	=Fs[mm];
      Yr[k1]	=dFc[mm];
      Yi[k1]	=dFs[mm];
      gyr[k2]	=Fc[mm];
      gyi[k2]	=-Fs[mm];
      Yr[k2]	=dFc[mm];
      Yi[k2]	=-dFs[mm];
    }
    ESP2F(Fc,Fs,fmi,ESMp);
    ESP2F(dFc,dFs,dfmi,ESMp);
    k		=ES2Mp1*M+ESMp;
    k2		=k;
    k1		=k;
    mm		=0;
    gyi[k]	+=Fc[mm];
    Yi[k]	+=dFc[mm];
    while(mm < ESMp){
      k2++;
      k1--;
      mm++;
      gyr[k1]	-=Fs[mm];
      gyi[k1]	+=Fc[mm];
      Yr[k1]	-=dFs[mm];
      Yi[k1]	+=dFc[mm];
      gyr[k2]	+=Fs[mm];
      gyi[k2]	+=Fc[mm];
      Yr[k2]	+=dFs[mm];
      Yi[k2]	+=dFc[mm];
    }
    s		=1./(1.-gnnm);
    f1r		=zmr*s;
    f1i		=zmi*s;
    f2r		=(gnmr*zmr+gnmi*zmi)*s;
    f2i		=(gnmi*zmr-gnmr*zmi)*s;
    sr		=gnmr;
    si		=gnmi;
    gnmr	=sr*gnr-si*gni;
    gnmi	=si*gnr+sr*gni;
    gnnm	*=gnn;
    sr		=zmr;
    si		=zmi;
    zmr		=sr*zr-si*zi;
    zmi		=si*zr+sr*zi;
    k		=ES2Mp1*M+ESMp;
    sr		=gyr[k];
    si		=gyi[k];
    gyr[k]	=(f1r-f2r)*sr-(f1i+f2i)*si;
    gyi[k]	=(f1i-f2i)*sr+(f1r+f2r)*si;
    sr		=Yr[k];
    si		=Yi[k];
    Yr[k]	=(f1r-f2r)*sr-(f1i+f2i)*si;
    Yi[k]	=(f1i-f2i)*sr+(f1r+f2r)*si;
    for(mm=1; mm < ESMp1; mm++){
      k2	=k+mm;
      k1	=k-mm;
      sr	=gyr[k2];
      si	=gyi[k2];
      r1c	=gyr[k1];
      r1s	=gyi[k1];
      gyr[k2]	=f1r*sr-f1i*si-f2r*r1c-f2i*r1s;
      gyi[k2]	=f1i*sr+f1r*si-f2i*r1c+f2r*r1s;
      gyr[k1]	=f1r*r1c-f1i*r1s-f2r*sr-f2i*si;
      gyi[k1]	=f1i*r1c+f1r*r1s-f2i*sr+f2r*si;
      sr	=Yr[k2];
      si	=Yi[k2];
      r1c	=Yr[k1];
      r1s	=Yi[k1];
      Yr[k2]	=f1r*sr-f1i*si-f2r*r1c-f2i*r1s;
      Yi[k2]	=f1i*sr+f1r*si-f2i*r1c+f2r*r1s;
      Yr[k1]	=f1r*r1c-f1i*r1s-f2r*sr-f2i*si;
      Yi[k1]	=f1i*r1c+f1r*r1s-f2i*sr+f2r*si;
    }	
  }
  k	=ESnMp*n;
  splRA(g22c,NULL,ESg22c+k,ESg22c2+k);
  splRA(g12c,NULL,ESg12c+k,ESg12c2+k);
  S		=1./A;
  g22c[0]	*=S;
  g12c[0]	*=S;
  g22s[0]	=0.;
  g12s[0]	=0.;
  Fc[0]		=0.;
  Fs[0]		=0.;
  k	 	+=ESNa1;
  for(m=1; m < ES2Mp1; m++){
    Fc[m]	=0.;
    Fs[m]	=0.;
    splRA(g22c+m,NULL,ESg22c+k,ESg22c2+k);
    splRA(g22s+m,NULL,ESg22s+k,ESg22s2+k);
    g22c[m]	*=S;
    g22s[m]	*=S;
    splRA(g12c+m,NULL,ESg12c+k,ESg12c2+k);
    splRA(g12s+m,NULL,ESg12s+k,ESg12s2+k);
    g12c[m]	*=S;
    g12s[m]	*=S;
    k 	+=ESNa1;
  }

  for(M=1; M < ESMp1; M++){
    M0		=ES2Mp1*M;
    for(k=0; k < ES2Mp1; k++){
      mm	=M0+k;
      m		=k-ESMp;
      si	=g12c[0]*m;
      sr	=g22c[0];
      Fc[k]	=sr*Yr[mm]+si*gyi[mm];
      Fs[k]	=sr*Yi[mm]-si*gyr[mm];
      for(kk=1, k1=k-kk; k1 >= 0; kk++,k1--){
	mm	=M0+k1;
	m	=k1-ESMp;
	sr	=m*g12c[kk];
	si	=m*g12s[kk];
	Fc[k]	+=g22c[kk]*Yr[mm]+g22s[kk]*Yi[mm]+sr*gyi[mm]-si*gyr[mm];
	Fs[k]	+=g22c[kk]*Yi[mm]-g22s[kk]*Yr[mm]-sr*gyr[mm]-si*gyi[mm];
      }
      for(kk=1, k1=k+kk; k1 < ES2Mp1; kk++, k1++){
	mm	=M0+k1;
	m	=k1-ESMp;
	sr	=m*g12c[kk];
	si	=m*g12s[kk];
	Fc[k]	+=g22c[kk]*Yr[mm]-g22s[kk]*Yi[mm]+sr*gyi[mm]+si*gyr[mm];
	Fs[k]	+=g22c[kk]*Yi[mm]+g22s[kk]*Yr[mm]-sr*gyr[mm]+si*gyi[mm];
      }
    }
    for(k=0; k < ES2Mp1; k++){
      mm	=M0+k;
      Yr[mm]	=Fc[k];
      Yi[mm]	=Fs[k];
    }
  }
  return(0);
}
