#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include "esc.h"

extern clock_t clock(void);

extern double cr2,cr3,cr4,cr6,cr12,cgp,c2gp,cgp_4,cr2gp,cgm0,crgm0;
extern unsigned int ESmemlev;
extern int ESEqSolvInPr,ESEqSolvInCr;

extern int ESNa,ESNa1;
extern double *ESsa;
extern int ESNp,ESNp1;
extern int ES2Mp,ES2Mp1,ESMp,ESMp1;
extern int ESFp1;

extern int ESStN,ESStM1,ESStM2;
static int M1=0,M2=0,N=1,Mp1,MMp1,M4Mp1;
static int NRec,MRec,KRec,FRec,mc,FlagRes;
static double *gyr,*gyi,*aYr,*aYi;

static FILE *fpy,*fpt,*fpY0,*fpY1,*fpS,*fpT;
extern int ESStNRec,ESStMRec,ESStKRec;

int ESBackTransfFundMatr(double a1)
{
  int i,ii,ish,nRec,mRec,kRec,nR;
  int jc,j,j1,jj,kk;
  int Fl;
  double *Ar,*Ai;

  double *Pr,*Pi,*pr,*pi,*Qr,*Qi;
  double *Yr,*Yi,*yr,*yi,*Zr,*Zi;
  double a,s,gar,gai;

  fpt	=fopen("LowN.t","r");
  if(fpt == NULL){
    printf("file LowN.t cannot be opened by ESBackTransfMatr()\n");
    return(-1);
  }
  fpy	=fopen("LowN.y","r");
  if(fpy == NULL){
    printf("file LowN.y cannot be opened by ESBackTransfMatr()\n");
    return(-1);
  }
  fpY0	=fopen("LowN.Y0","w+");
  if(fpY0 == NULL){
    printf("file LowN.Y0 cannot be opened by ESBackTransfMatr()\n");
    return(-1);
  }
  fpY1	=fopen("LowN.Y1","w+");
  if(fpY1 == NULL){
    printf("file LowN.Y1 cannot be opened by ESBackTransfMatr()\n");
    return(-1);
  }
  Ar	=(double*)malloc((2*ESStKRec+M4Mp1)*sizeof(double));
  if(Ar == NULL){
    printf("Failure in memory allocation for Ar in ESBackTransfFundMatr()\n");
    return(-1);
  }
  Ai	=Ar	+ESStKRec;
  gyr	=Ai	+ESStKRec;
  gyi	=gyr	+MMp1;
  aYr	=gyi	+MMp1;
  aYi	=aYr	+MMp1;

  Fl	=0;
  FRec	=0;
  nR	=0;
  fpT	=fpY0;
  fpS	=fpY1;
  for(i=0; i < MRec; i++){
    fread(&kRec,sizeof(int),1,fpt);
    fread(&mRec,sizeof(int),1,fpt);
    fread(&nRec,sizeof(int),1,fpt);
    fread(&mc,sizeof(int),1,fpt);
    fread(&FlagRes,sizeof(int),1,fpt);
    jc	=mc-M1;
    fread(Ar,sizeof(double),kRec,fpt);
    fread(Ai,sizeof(double),kRec,fpt);
    out("siIIIII","kRec",i,kRec,mc,mRec,nR,nRec);

    fread(&a,sizeof(double),1,fpy);
    if(a > a1){
      break;
    }
    
    rewind(fpS);
    rewind(fpT);
    for(ii=0; ii < nR; ii++){
      fread(&s,sizeof(double),1,fpS);
      fwrite(&s,sizeof(double),1,fpT);
      fread(gyr,sizeof(double),M4Mp1,fpS);
      kk	=0;
      /* Low end harmonics */
      Pr	=gyr;
      Pi	=gyi;
      Yr	=aYr;
      Yi	=aYi;
      if(Fl){
	j1	=Mp1*jc;
	for(j=0; j < Mp1; j++){
	  Pr[j1]	=0.;
	  Pi[j1]	=0.;
	  Yr[j1]	=0.;
	  Yi[j1]	=0.;
	  j1++;
	}
      }
      for(j=0; j <= jc; j++){
	kk++;
	Qr	=Pr+Mp1;
	Qi	=Pi+Mp1;
	Zr	=Yr+Mp1;
	Zi	=Yi+Mp1;
	for(j1=j+1; j1 < Mp1; j1++){
	  gar	=Ar[kk];
	  gai	=Ai[kk];
	  kk++;
	  pr	=Pr;
	  pi	=Pi;
	  yr	=Yr;
	  yi	=Yi;
	  for(jj=0; jj < Mp1; jj++){
	    *Qr++	+=gar*(*pr)-gai*(*pi);
	    *Qi++	+=gar*(*pi)+gai*(*pr);
	    pr++;
	    pi++;
	    *Zr++	+=gar*(*yr)-gai*(*yi);
	    *Zi++	+=gar*(*yi)+gai*(*yr);
	    yr++;
	    yi++;
	  }
	}
	Pr	+=Mp1;
	Pi	+=Mp1;
	Yr	+=Mp1;
	Yi	+=Mp1;
      }
      /* High end harmonics */
      Pr	=gyr+MMp1;
      Pi	=gyi+MMp1;
      Yr	=aYr+MMp1;
      Yi	=aYi+MMp1;
      for(j=Mp1-1; j >= jc; j--){
	Pr	-=Mp1;
	Pi	-=Mp1;
	Yr	-=Mp1;
	Yi	-=Mp1;
	kk++;
	j1	=j;
	while(j1 > 0){
	  j1--;
	  jj	=Mp1*j1;
	  Qr	=gyr+jj;
	  Qi	=gyi+jj;
	  Zr	=aYr+jj;
	  Zi	=aYi+jj;
	  gar	=Ar[kk];
	  gai	=Ai[kk];
	  kk++;
	  pr	=Pr;
	  pi	=Pi;
	  yr	=Yr;
	  yi	=Yi;
	  for(jj=0; jj < Mp1; jj++){
	    *Qr++	+=gar*(*pr)-gai*(*pi);
	    *Qi++	+=gar*(*pi)+gai*(*pr);
	    pr++;
	    pi++;
	    *Zr++	+=gar*(*yr)-gai*(*yi);
	    *Zi++	+=gar*(*yi)+gai*(*yr);
	    yr++;
	    yi++;
	  }
	}
      }
      fwrite(gyr,sizeof(double),M4Mp1,fpT);
    }
    for(ii=nR; ii < nRec; ii++){
      if(ii > nR){
	fread(&a,sizeof(double),1,fpy);
      }
      fwrite(&a,sizeof(double),1,fpT);
      fread(gyr,sizeof(double),M4Mp1,fpy);
      kk	=0;
      /* Low end harmonics */
      Pr	=gyr;
      Pi	=gyi;
      Yr	=aYr;
      Yi	=aYi;
      for(j=0; j <= jc; j++){
	kk++;
	Qr	=Pr+Mp1;
	Qi	=Pi+Mp1;
	Zr	=Yr+Mp1;
	Zi	=Yi+Mp1;
	for(j1=j+1; j1 < Mp1; j1++){
	  gar	=Ar[kk];
	  gai	=Ai[kk];
	  kk++;
	  pr	=Pr;
	  pi	=Pi;
	  yr	=Yr;
	  yi	=Yi;
	  for(jj=0; jj < Mp1; jj++){
	    *Qr++	+=gar*(*pr)-gai*(*pi);
	    *Qi++	+=gar*(*pi)+gai*(*pr);
	    pr++;
	    pi++;
	    *Zr++	+=gar*(*yr)-gai*(*yi);
	    *Zi++	+=gar*(*yi)+gai*(*yr);
	    yr++;
	    yi++;
	  }
	}
	Pr	+=Mp1;
	Pi	+=Mp1;
	Yr	+=Mp1;
	Yi	+=Mp1;
      }
      /* High end harmonics */
      Pr	=gyr+MMp1;
      Pi	=gyi+MMp1;
      Yr	=aYr+MMp1;
      Yi	=aYi+MMp1;
      for(j=Mp1-1; j >= jc; j--){
	Pr	-=Mp1;
	Pi	-=Mp1;
	Yr	-=Mp1;
	Yi	-=Mp1;
	kk++;
	j1	=j;
	while(j1 > 0){
	  j1--;
	  jj	=Mp1*j1;
	  Qr	=gyr+jj;
	  Qi	=gyi+jj;
	  Zr	=aYr+jj;
	  Zi	=aYi+jj;
	  gar	=Ar[kk];
	  gai	=Ai[kk];
	  kk++;
	  pr	=Pr;
	  pi	=Pi;
	  yr	=Yr;
	  yi	=Yi;
	  for(jj=0; jj < Mp1; jj++){
	    *Qr++	+=gar*(*pr)-gai*(*pi);
	    *Qi++	+=gar*(*pi)+gai*(*pr);
	    pr++;
	    pi++;
	    *Zr++	+=gar*(*yr)-gai*(*yi);
	    *Zi++	+=gar*(*yi)+gai*(*yr);
	    yr++;
	    yi++;
	  }
	}
      }
      fwrite(gyr,sizeof(double),M4Mp1,fpT);
    }
    Fl	=FlagRes;
    nR	=nRec;
    if(FRec == 0){
      FRec	=1;
      fpT	=fpY1;
      fpS	=fpY0;
    }
    else{
      FRec	=0;
      fpT	=fpY0;
      fpS	=fpY1;
    }
  }

  fclose(fpt);
  fclose(fpy);
  fclose(fpY0);
  fclose(fpY1);
  return(0);
}

int ESShowFundSolution(int m,int m1, int m2, int Fl, double a0,double a1)
{
  int i,k,k0,k1,ist,is,j,kR,kj;
  double y[2],x[2],s;
  double *p,*W,*a;

  k0	=m1-M1;
  if(k0 < 0){
    k0	=0;
  }
  k1	=m2+1-M1;
  if(k1 > Mp1){
    k1	=Mp1;
  }

  ist	=1;
  do{
    kR	=NRec/ist;
    gyr	=(double*)malloc((M4Mp1+kR*(k1-k0+1))*sizeof(double));
    a	=gyr	+M4Mp1;
    W	=a	+kR;
    if(gyr == NULL){
      ist	*=2;
    }
  }while(gyr == NULL && ist < 8);
  if(gyr == NULL){
    printf("Failure in memory allocation for gyr in ESShowFundSolution()\n");
    return(-1);
  }

  p	=gyr+MMp1*Fl+Mp1*(m-M1);
  is	=0;
  j	=0;
  x[0]	=a0;
  y[0]	=1e+100;
  y[1]	=1e-100;
  s	=0.;
  for(i=0; i < NRec && s <= a1; i++){
    fread(&s,sizeof(double),1,fpy);
    fread(gyr,sizeof(double),M4Mp1,fpy);
    if(s >= a0 && s <= a1){
      if(is == 0 && j < kR){
	a[j]	=s;
	kj	=j;
	for(k=k0; k < k1; k++){
	  if(y[0] >  p[k]){
	    y[0]	=p[k];
	  }
	  if(y[1] <  p[k]){
	    y[1]	=p[k];
	  }
	  W[kj]	=p[k];
	  kj	+=kR;
	}
	j++;
      }
      is++;
      if(is == ist){
	is	=0;
      }
    }
  }
  x[1]	=a1;
  Scale2D(4,2,x,y,2,6,2);
  for(k=k0; k < k1; k++){
    Plot2d(4,a,W+kR*(k-k0),j,6,0,4,0);
  }
  free(gyr);
  return(0);
}

int ESNonMHDStabLowN()
{
  static int mV=0,m1=0,m2=1,FlV=4,Fl=0;
  static double a0=0.,a1=1.;

  Fl	=0;
  fpy	=fopen("LowN.n","r");
  if(fpy == NULL){
    printf("file LowN.n cannot be opened by ESNonMHDStabLowN()\n");
    return(-1);
  }
  else{
    fread(&ESStN,sizeof(int),1,fpy);
    fread(&ESStM1,sizeof(int),1,fpy);
    fread(&ESStM2,sizeof(int),1,fpy);
    fread(&ESStNRec,sizeof(int),1,fpy);
    fread(&ESStMRec,sizeof(int),1,fpy);
    fread(&ESStKRec,sizeof(int),1,fpy);
    fclose(fpy);
    Fl	=1;
  }
  N	=ESStN;
  M1	=ESStM1;
  M2	=ESStM2;
  Mp1	=M2-M1+1;
  MMp1	=Mp1*Mp1;
  M4Mp1	=4*MMp1;
  m1	=M1;
  m2	=M2;
  NRec	=ESStNRec;
  MRec	=ESStMRec;
#ifndef Tbl_NonMHD
  if(FlV == 14){
    ESBackTransfFundMatr(a1);
    Fl	=2;
  }  
  if(mV < M1){
    mV	=M1;
  }
  if(mV > M2){
    mV	=M2;
  }
  if(m1 < M1){
    m1	=M1;
  }
  if(m1 > M2-1){
    m1	=M2-1;
  }
  if(m2 < m1){
    m2	=m1;
  }
  if(m2 > M2){
    m2	=M2;
  }
  if(FlV < 0){
    FlV	=0;
  }
  NRec	=ESStNRec;
  MRec	=ESStMRec;
  if(FlV%10 < 4){
    if(Fl != 2 || FlV < 10){
      fpy	=fopen("LowN.y","r");
      if(fpy == NULL){
	printf("file LowN.y cannot be opened by ESShowFundSolution()\n");
	return(-1);
      }
      if(Fl != 2){
	printf("Fl == 14, Make the fumdamental vector\n");
      }
    }
    else{
      if(FRec == 1){
	fpy	=fopen("LowN.Y0","r");
	if(fpy == NULL){
	  printf("file LowN.Y0 cannot be opened by ESShowFundSolution()\n");
	  return(-1);
	}
      }
      else{
	fpy	=fopen("LowN.Y1","r");
	if(fpy == NULL){
	  printf("file LowN.Y1 cannot be opened by ESShowFundSolution()\n");
	  return(-1);
	}
      }
    }
    if(fpy == NULL){
      printf("file LowN. cannot be opened by ESShowFundSolution()\n");
      return(-1);
    }
    ESShowFundSolution(mV,m1,m2,FlV%10,a0,a1);
    fclose(fpy);
  }
#endif/*Tbl_NonMHD*/
  return(0);
}
