#include <math.h>
#include <stdio.h>
#include <string.h>
#include "esc.h"

#ifndef mzl_ESmain
extern double cr2,cr3,cr4,cr6,cr12,cgp,c2gp,cgp_4,cr2gp,cgm0,crgm0;
extern int ESmemlev;
#endif

#ifndef mzl_1Dcore
extern int ESNa,ESNa1;
extern double *a,*aa,*a3a,*b;
static PlProf PRdC,PlPrP[ESNPRPR],PlCrP[ESNCRPR];
static int NPrP=0,NCrP=0,NRdC=0,NPlPD=0;
static RadCoord RdC[ESNRDCR];
static int iPIn=3,iCIn=2,iXIn=0;
static int ioPrP[ESNPRPR],ioCrP[ESNCRPR],*kaRdC;

#endif

#ifndef mzl_PROFL
extern double *ESbY0,*ESbY1a,ESgY2a1a;
extern double *ESRC,*ESRC1a,*ESRC2a
,*ESbJ,*ESbJ1a,*ESbJ2a
,*ESjp,*ESjp1a,*ESjp2a
,*ESsp,*ESsp1a,*ESsp2a
,*ESPs,*ESPs1a,*ESPs2a
,*ESjs,*ESjs1a,*ESjs2a
,*ESsq,*ESsq1a,*ESsq2a
,*ESgy,*ESgy1a,*ESgy2a
,*ESgf,*ESgf1a,*ESgf2a
,*ESgp,*ESgp1a,*ESgp2a
,*ESsb,*ESsb1a,*ESsb2a
,*ESss,*ESss1a,*ESss2a
,*ESbF,*ESbF1a,*ESbF2a
,*ESFF,*ESFF1a,*ESFF2a
,*ESbT,*ESbT1a,*ESbT2a
,*ESgb,*ESgb1a,*ESgb2a
,*ESgB,*ESgB1a,*ESgB2a;

#endif
extern int ESEqSolvRadC,ESEqSolvInPr,ESEqSolvInCr;

int ESReInitPlProf()
{
  int i,j;
  double d;
  static double ga1=1e-9,ga3=1e-11;

  if(NPrP){
    return(0);
  }

  NPrP	=ESNPRPR;
  NCrP	=ESNCRPR;
  NRdC	=ESNRDCR;
  NPlPD	=ESND;

  for(i=0; i < NRdC; i++){
    RdC[i].x0	=(double*)malloc(6*ESNa1*sizeof(double));
    RdC[i].x1	=RdC[i].x0+ESNa1;
    RdC[i].x2	=RdC[i].x1+ESNa1;
    RdC[i].a0	=RdC[i].x2+ESNa1;
    RdC[i].a1	=RdC[i].a0+ESNa1;
    RdC[i].a2	=RdC[i].a1+ESNa1;
    RdC[i].X	=1.;
    RdC[i].io	=0;
    for(j=0; j < ESNa1; j++){
      RdC[i].x0[j]	=a[j];
      RdC[i].x1[j]	=1.;
      RdC[i].x2[j]	=0.;
      RdC[i].a0[j]	=a[j];
      RdC[i].a1[j]	=1.;
      RdC[i].a2[j]	=0.;
    }
    RdC[i].nd	=6;
    for(j=0; j < NPlPD; j++){
      if(j < 6){
	RdC[i].ad[j]	=0.2*j;
	RdC[i].xd[j]	=0.2*j;
	RdC[i].kk[j]	=1;
      }
      else{
	RdC[i].ad[j]	=0.;
	RdC[i].xd[j]	=0.;
	RdC[i].kk[j]	=0;
      }
    }
  }
  RdC[iXIn].io	=1;
  
  strcpy(RdC[0].Nm,"b       ");
  ESsb		=RdC[0].x0;
  ESsb1a	=RdC[0].x1;
  ESsb2a	=RdC[0].x2;
  strcpy(RdC[1].Nm,"v       ");
  ESss		=RdC[1].x0;
  ESss1a	=RdC[1].x1;
  ESss2a	=RdC[1].x2;
  strcpy(RdC[2].Nm,"qgF     ");
  ESgf		=RdC[2].x0;
  ESgf1a	=RdC[2].x1;
  ESgf2a	=RdC[2].x2;
  strcpy(RdC[3].Nm,"qgY     ");
  ESgp		=RdC[3].x0;
  ESgp1a	=RdC[3].x1;
  ESgp2a	=RdC[3].x2;

  kaRdC		=(int*)malloc(NPlPD*sizeof(int));
  PRdC.x0	=(double*)malloc(4*ESNa1*sizeof(double));
  PRdC.y0	=PRdC.x0+ESNa1;
  PRdC.y1	=PRdC.y0+ESNa1;
  PRdC.y2	=PRdC.y1+ESNa1;
  for(j=0; j < ESNa1; j++){
    PRdC.x0[j]	=a[j];
    PRdC.y0[j]	=a[j];
    PRdC.y1[j]	=1.;
    PRdC.y2[j]	=0.;
  }
  PRdC.io	=0;
  PRdC.xin	=0;
  PRdC.nd	=6;
  for(j=0; j < NPlPD; j++){
    if(j < 6){
      PRdC.xd[j]	=0.2*j;
      PRdC.yd[j]	=0.2*j;
      PRdC.kk[j]	=1;
    }
    else{
      PRdC.xd[j]	=0.;
      PRdC.yd[j]	=0.;
      PRdC.kk[j]	=0;
    }
  }

  for(i=0; i < NPrP; i++){
    PlPrP[i].x0	=(double*)malloc(4*ESNa1*sizeof(double));
    PlPrP[i].y0	=PlPrP[i].x0+ESNa1;
    PlPrP[i].y1	=PlPrP[i].y0+ESNa1;
    PlPrP[i].y2	=PlPrP[i].y1+ESNa1;
    for(j=0; j < ESNa1; j++){
      PlPrP[i].x0[j]	=a[j];
      PlPrP[i].y0[j]	=0.;
      PlPrP[i].y1[j]	=0.;
      PlPrP[i].y2[j]	=0.;
    }

    PlPrP[i].io	=0;
    PlPrP[i].xin=0;
    PlPrP[i].nd	=6;
    ioPrP[i]	=0;
    for(j=0; j < NPlPD; j++){
      if(j < 6){
	PlPrP[i].xd[j]	=0.2*j;
	PlPrP[i].yd[j]	=0.;
	PlPrP[i].kk[j]	=1;
      }
      else{
	PlPrP[i].xd[j]	=0.;
	PlPrP[i].yd[j]	=0.;
	PlPrP[i].kk[j]	=0;
      }
    }
  }
  for(i=0; i < NCrP; i++){
    PlCrP[i].x0	=(double*)malloc(4*ESNa1*sizeof(double));
    PlCrP[i].y0	=PlCrP[i].x0+ESNa1;
    PlCrP[i].y1	=PlCrP[i].y0+ESNa1;
    PlCrP[i].y2	=PlCrP[i].y1+ESNa1;
    for(j=0; j < ESNa1; j++){
      PlCrP[i].x0[j]	=a[j];
      PlCrP[i].y0[j]	=0.;
      PlCrP[i].y1[j]	=0.;
      PlCrP[i].y2[j]	=0.;
    }
    PlCrP[i].io	=0;
    PlCrP[i].xin=0;
    PlCrP[i].nd	=6;
    ioCrP[i]	=0;
    for(j=0; j < NPlPD; j++){
      if(j < 6){
	PlCrP[i].xd[j]	=0.2*j;
	PlCrP[i].yd[j]	=0.;
	PlCrP[i].kk[j]	=1;
      }
      else{
	PlCrP[i].xd[j]	=0.;
	PlCrP[i].yd[j]	=0.;
	PlCrP[i].kk[j]	=0;
      }
    }
  }

  strcpy(PRdC.Nm,	"RC     ");
  ESRC	=PRdC.y0;
  ESRC1a=PRdC.y1;
  ESRC2a=PRdC.y2;

  strcpy(PlPrP[0].Nm,	"j_PfShl");
  ESjp	=PlPrP[0].y0;
  ESjp1a=PlPrP[0].y1;
  ESjp2a=PlPrP[0].y2;
  strcpy(PlPrP[1].Nm,	"Ps     ");
  ESPs	=PlPrP[1].y0;
  ESPs1a=PlPrP[1].y1;
  ESPs2a=PlPrP[1].y2;
  strcpy(PlPrP[2].Nm,	"p'/a   ");
  strcpy(PlPrP[3].Nm,	"p      ");
  ESsp	=PlPrP[3].y0;
  ESsp1a=PlPrP[3].y1;
  ESsp2a=PlPrP[3].y2;
  strcpy(PlPrP[4].Nm,	"ga_CHT ");
  strcpy(PlPrP[5].Nm,	"n_e    ");
  strcpy(PlPrP[6].Nm,	"n_i    ");
  strcpy(PlPrP[7].Nm,	"T_e    ");
  strcpy(PlPrP[8].Nm,	"T_i    ");
  strcpy(PlPrP[9].Nm,	"p_e    ");
  strcpy(PlPrP[10].Nm,	"p_i    ");
  strcpy(PlPrP[11].Nm,	"gb_Sh  ");
  ESgb	=PlPrP[11].y0;
  ESgb1a=PlPrP[11].y1;
  ESgb2a=PlPrP[11].y2;
  strcpy(PlPrP[12].Nm,	"gb     ");
  ESgB	=PlPrP[12].y0;
  ESgB1a=PlPrP[12].y1;
  ESgB2a=PlPrP[12].y2;

  strcpy(PlCrP[0].Nm,	"J      ");
  ESbJ	=PlCrP[0].y0;
  ESbJ1a=PlCrP[0].y1;
  ESbJ2a=PlCrP[0].y2;
  strcpy(PlCrP[1].Nm,	"gY     ");
  ESgy	=PlCrP[1].y0;
  ESgy1a=PlCrP[1].y1;
  ESgy2a=PlCrP[1].y2;
  strcpy(PlCrP[2].Nm,	"j_GSh  ");
  ESjs	=PlCrP[2].y0;
  ESjs1a=PlCrP[2].y1;
  ESjs2a=PlCrP[2].y2;
  strcpy(PlCrP[3].Nm,	"FF'    ");
  ESbT	=PlCrP[3].y0;
  ESbT1a=PlCrP[3].y1;
  ESbT2a=PlCrP[3].y2;
  strcpy(PlCrP[4].Nm,	"Fs     ");
  strcpy(PlCrP[5].Nm,	"j_||   ");
  strcpy(PlCrP[6].Nm,	"q      ");
  ESsq	=PlCrP[6].y0;
  ESsq1a=PlCrP[6].y1;
  ESsq2a=PlCrP[6].y2;
  strcpy(PlCrP[7].Nm,	"1/q    ");
  strcpy(PlCrP[8].Nm,	"ir+il  ");
  strcpy(PlCrP[9].Nm,	"ir-il  ");
  strcpy(PlCrP[10].Nm,	"j_t    ");
  strcpy(PlCrP[11].Nm,	"j_r    ");
  strcpy(PlCrP[12].Nm,	"j_l    ");
  strcpy(PlCrP[13].Nm,	"F      ");
  ESbF	=PlCrP[13].y0;
  ESbF1a=PlCrP[13].y1;
  ESbF2a=PlCrP[13].y2;
  strcpy(PlCrP[14].Nm,	"FF     ");
  ESFF	=PlCrP[14].y0;
  ESFF1a=PlCrP[14].y1;
  ESFF2a=PlCrP[14].y2;
  strcpy(PlCrP[15].Nm,	"<j.B>  ");

  ioPrP[0]	=1;
  PlPrP[0].io	=1;
  for(i=0; i < 6; i++){
    d	=0.2*i;
    PlPrP[0].yd[i]	=0.2*(1.-d*d);
  }
  ESPrData2Spl(PlPrP,PlPrP[0].kk,PlPrP[0].xd,PlPrP[0].yd,&ga1,&ga3);
  ESPrSplData2Pr(PlPrP);
  ioCrP[2]	=1;
  PlCrP[2].io	=1;
  for(i=0; i < 6; i++){
    d	=0.2*i;
    PlCrP[2].yd[i]	=1.-d*d;
  }
  ESPrData2Spl(PlCrP+2,PlCrP[2].kk,PlCrP[2].xd,PlCrP[2].yd,&ga1,&ga3);
  ESPrSplData2Pr(PlCrP+2);
  
  ESmemlev |=0x01000000;
  return(0);
}

int ESDeInitPlProf()
{
  int i;

  if(ESNa1 == 0)
    return(0);
  for(i=0; i < NCrP; i++){
    free(PlCrP[i].x0);
  }
  for(i=0; i < NPrP; i++){
    free(PlPrP[i].x0);
  }
  free(PRdC.x0);
  free(kaRdC);
  for(i=0; i < NRdC; i++){
    free(RdC[i].x0);
  }
  NPrP	=0;
  NCrP	=0;
  NRdC	=0;
  return(0);
}

int ESPrSplData2Pr(PlProf *Prof)
{
  int i,i1,i2,nd1,inx;
  double dg0,dg1,x,dx,dy;
  double *xd,*d0,*d2,*x0,*y0;

  xd	=Prof->xd;
  d0	=Prof->d0;
  d2	=Prof->d2;
  nd1	=Prof->nd-1;
  x0	=Prof->x0;
  y0	=Prof->y0;
  inx	=0;
  
  i1	=0;
  for(i=0; i < ESNa1; i++){
    if(inx){
      i2=i == 0 ? 0 : i-1;
#ifdef H
      splr1(&x,&dx,a+i,RadC[inx].x,RadC[inx].d2x,a,&na,&i2);
#endif
    }
    else{
      x		=a[i];
      dx	=1.;
    }
    while(i1 < nd1 && xd[i1+1] < x){
      i1++;
    }
    splr1(y0+i,&dy,&x,d0,d2,xd,&nd1,&i1);
    if(i == 0){
      dg0	=dy*dx;
    }
    x0[i]	=x;
  }
  dg1	=dy*dx;
  splAA(y0,Prof->y1,Prof->y2,&dg0,&dg1);
  return(0);
}

int ESData2Order(double *xd,double *yd,int *k2k,int nd)
{
  int i,j,k;
  double s;
  
  for(k=0; k < nd; k++){
    if(k2k[k] == 0){
      i	=k+1;
      while(i < nd && k2k[i] == 0){
	i++;
      }
      if(i == nd){
	return(k);
      }
      else{
	s	=xd[i];
	xd[i]	=xd[k];
	xd[k]	=s;
	s	=yd[i];
	yd[i]	=yd[k];
	yd[k]	=s;
	k2k[k]	=1;
	k2k[i]	=0;
      }
    }
    i	=k+1;
    while(i < nd){
      if(k2k[i]){
	if(xd[i] < xd[k]){
	  s	=xd[i];
	  xd[i]	=xd[k];
	  xd[k]	=s;
	  s	=yd[i];
	  yd[i]	=yd[k];
	  yd[k]	=s;
	}
	else{
	  if(xd[i] == xd[k]){
	    k2k[i]	=0;
	  }
	}
      }
      i++;
    }
  }
  return(nd);
}

int ESPrData2Spl(PlProf *Prof,int *k2k,double *xd,double *yd,
	     double *ga1,double *ga3)
{
  int i,j,k;
  static double ga0=0.,ga2=0.;
  double dg0,dg1,s;

  k	=0;
  j	=0;
  s	=-1e+20;
  while(j < NPlPD){
    if(k2k[j]){
      Prof->xd[k]	=xd[j];
      Prof->yd[k]	=yd[j];
      if(s < fabs(yd[j]))
	s	=fabs(yd[j]);
      k++;
    }
    j++;
  }
  Prof->nd	=k;
  k--;
  if(Prof->xd[0] != 0.){
    Prof->xd[0]	=0.;
  }
  if(Prof->xd[k] != 1.){
    Prof->xd[k]	=1.;
  }

  if(fabs(Prof->yd[0])/s < 1e-4){
    Prof->yd[0]	=0;
    f2spl(Prof->d0,Prof->d2,NULL,NULL,Prof->yd,NULL,Prof->xd,&k,
	  &ga0,ga1,&ga2,ga3);
  }
  else{
    dg0	=0.;
    f2spl(Prof->d0,Prof->d2,&dg0,NULL,Prof->yd,NULL,Prof->xd,&k,
	  &ga0,ga1,&ga2,ga3);
  }
  return(0);
}

int ESPlProf2Data(int kPr,int kCr)
{
  int i,k,nd;
  double *xd;

  nd	=PlPrP[kPr].nd;
  xd	=PlPrP[kPr].xd;
  for(i=0; i < nd; i++){
    ESSetSplA(xd[i]);
    for(k=0; k < NPrP; k++){
      if(k != kPr){
	PlPrP[k].xd[i]=xd[i];
	PlPrP[k].kk[i]=1;
	if(PlPrP[k].kk[i]){
	  splRA(PlPrP[k].yd+i,NULL,PlPrP[k].y0,PlPrP[k].y2);
	}
      }
    }
  }
  while(i < NPlPD){
    for(k=0; k < NPrP; k++){
      if(k != kPr){
	PlPrP[k].kk[i]=0;
      }
    }
    i++;
  }
  
  nd	=PlCrP[kCr].nd;
  xd	=PlCrP[kCr].xd;
  for(i=0; i < nd; i++){
    ESSetSplA(xd[i]);
    for(k=0; k < NCrP; k++){
      if(k != kCr){
	PlCrP[k].xd[i]=xd[i];
	PlCrP[k].kk[i]=1;
	if(PlCrP[k].kk[i]){
	  splRA(PlCrP[k].yd+i,NULL,PlCrP[k].y0,PlCrP[k].y2);
	}
      }
    }
  }
  
  while(i < NPlPD){
    for(k=0; k < NPrP; k++){
      if(k != kCr){
	PlCrP[k].kk[i]=0;
      }
    }
    i++;
  }
  return(0);
}

int ESRdCSplData2RdC(RadCoord *pRdC)
{
  int i,i1,i2,nd1;
  double dx0,x,dx;
  double *xd,*d0,*d2,*x0;

  nd1	=PRdC.nd-1;
  xd	=PRdC.xd;
  d0	=PRdC.d0;
  d2	=PRdC.d2;
  x0	=pRdC->x0;
  i1	=0;
  for(i=0; i < ESNa1; i++){
    x		=a[i];
    while(i1 < nd1 && xd[i1+1] < x){
      i1++;
    }
    splr1(x0+i,&dx,&x,d0,d2,xd,&nd1,&i1);
    if(i == 0){
      dx0	=dx;
    }
  }
  splAA(x0,pRdC->x1,pRdC->x2,&dx0,&dx);
  return(0);
}

int ESRdCSpl2Data()
{
  int i,k,nd,*kk;
  double *ad;

  nd	=RdC[ESEqSolvRadC].nd;
  ad	=RdC[ESEqSolvRadC].ad;
  kk	=RdC[ESEqSolvRadC].kk;
  for(i=0; i < NPlPD; i++){
    ESSetSplA(ad[i]);
    for(k=0; k < NRdC; k++){
      if(k != ESEqSolvRadC){
	RdC[k].ad[i]=ad[i];
	if(kk[i] == 1){
	  RdC[k].kk[i]=kk[i];
	}
	if(RdC[k].kk[i]){
	  splRA(RdC[k].xd+i,NULL,RdC[k].x0,RdC[k].x2);
	}
      }
    }
  }
  return(0);
}

int ESInpRadC()
{
  int i,k,nd;
  RadCoord *pRdC;
  static double ga1=1e-9,ga3=1e-11;
  double *ad;

  kaRdC[0]	=ESEqSolvRadC;
  pRdC		=RdC+ESEqSolvRadC;
  ad		=pRdC->ad;
#ifndef Tbl_RadC
  for(i=1; i < NPlPD; i++){
    kaRdC[i]	=kaRdC[0];
  }
  pRdC->nd	=ESData2Order(pRdC->ad,pRdC->xd,pRdC->kk,NPlPD);
  ESPrData2Spl(&PRdC,pRdC->kk,pRdC->ad,pRdC->xd,&ga1,&ga3);
  ESRdCSplData2RdC(pRdC);
  ESRdCSpl2Data();
  if(kaRdC[0] != ESEqSolvRadC){
    ESEqSolvRadC	=kaRdC[0];
    pRdC	=RdC+ESEqSolvRadC;
    ad		=pRdC->xd;
  }
#endif Tbl_RadC
  return(0);
}

int ESInpPlPr()
{
  PlProf *pPrP;
  int i,k,*k2k,io;
  double *xd,*x;
  static double ga1=1e-9,ga3=1e-11;

#ifndef Tbl_PlPr
  if(ESEqSolvInPr < 0)
    ESEqSolvInPr	=0;
  if(ESEqSolvInPr > ESNPRPR-1)
    ESEqSolvInPr	=ESNPRPR-1;
  io	=ESEqSolvInPr;
  io	=0;

  for(i=0; i < NPrP; i++){
    PlPrP[i].io	=i == io ? 1 : 0;
    ioPrP[i]	=PlPrP[i].io;
  }
  pPrP	=PlPrP+io;
  xd	=pPrP->xd;
  k2k	=pPrP->kk;
  pPrP->nd=ESData2Order(xd,pPrP->yd,k2k,NPlPD);
  ESPrData2Spl(pPrP,k2k,xd,pPrP->yd,&ga1,&ga3);
  ESPrSplData2Pr(pPrP);
  x	=pPrP->x0;
#ifdef EC
  switch(ESEqSolvInCr){
  case 2:
    EC1DEqSolv(0);
    break;
  case 6:
    EC1DEqqSolv(0);
    break;
  default:
    EC1DEqSolv(0);
    break;
  }
#endif
#endif Tbl_PlPr
  return(0);
}

int ESInpPlCr()
{
  PlProf *pCrP;
  int i,k,io,kk[ESND];
  double *xd,*x;
  static double ga1=1e-9,ga3=1e-11;

#ifdef Solano
  int m;
  double p0[400],p1[400],p2[400],p3[400],p4[400],px[400],h,t,s;
  double dp0[400],dp1[400],dp2[400],dp3[400],dp4[400],dpx[400];
#endif


#ifndef Tbl_PlCr
  if(ESEqSolvInCr < 0)
    ESEqSolvInCr	=0;
  if(ESEqSolvInCr > ESNCRPR-1)
    ESEqSolvInCr	=ESNCRPR-1;
  io	=ESEqSolvInCr == 6 ? 6 : 2;

  pCrP	=PlCrP+io;
  xd	=pCrP->xd;

  for(i=0; i < NPlPD; i++){
    kk[i]	=pCrP->kk[i];
  }
  for(i=0; i < NCrP; i++){
    ioCrP[i]=PlCrP[i].io;
  }
  pCrP->nd	=ESData2Order(xd,pCrP->yd,pCrP->kk,NPlPD);
  ESPrData2Spl(pCrP,pCrP->kk,xd,pCrP->yd,&ga1,&ga3);
  ESPrSplData2Pr(pCrP);
#ifdef EC
  switch(ESEqSolvInCr){
  case 2:
    EC1DEqSolv(0);
    break;
  case 6:
    EC1DEqqSolv(0);
    break;
  default:
    EC1DEqSolv(0);
    break;
  }
  x	=pCrP->x0;
#ifdef Solano
  h	=cr4*cr4*a[1];
  t	=0;
  m	=0;
  while(t <= 1.){
    ESSetSplA(t);
    px[m]	=t;
    splRA(p0+m,dp0+m,PlCrP[2].y0,PlCrP[2].y2);
    splRA(p1+m,NULL,PlCrP[3].y0,PlCrP[3].y2);
    splRA(p2+m,NULL,PlCrP[6].y0,PlCrP[6].y2);
    splRA(p3+m,dp3+m,PlCrP[1].y0,PlCrP[1].y2);
    splRA(p4+m,NULL,PlCrP[0].y0,PlCrP[0].y2);
    t	+=h;
    m++;
  }
  k	=18;
  h	=ESgy1a[k];
  t	=(ESjs2a[k]*h-ESjs1a[k]*ESgy2a[k])/(h*h*h);
  h	=ESgy[k]-ESgy[ESNa];
  printf("??? j''h^2=%10.3e > j=%10.3e %10.3e %10.3e gY=%10.3e %10.3e\n"
	 ,t*h*h,ESjs[k],ESjs1a[k],ESjs2a[k],h,ESgy1a[k]);
#endif

#endif
#endif Tbl_PlCr
  return(0);
}
