#include <math.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "esc.h"

#ifndef mzl_ESmain
extern double cr2,cr3,cr4,cr6,cr12,cgp,c2gp,cgp_4,cr2gp,cgm0,crgm0;
extern unsigned int ESmemlev;
#endif

#ifndef mzl_1Dcore
extern int ESNa,ESNa1;
extern double *ESsa,*ESaR0;
extern PlProf PRdC,PlPrP[],PlCrP[];
extern RadCoord RdC[];
static int NPrP=0,NCrP=0,NRdC=0,NPlPD=0;
static int iPIn=3,iCIn=2,iXIn=0;
static int ioPrP[ESNPRPR],ioCrP[ESNCRPR],*kaRdC;
#endif

#ifndef mzl_PROFL
extern double *ESRC,*ESRC1a,*ESRC2a
,*ESqgF,*ESqgF1a,*ESqgF2a
,*ESqgY,*ESqgY1a,*ESqgY2a
,*ESsh,*ESsh1a,*ESsh2a
,*ESqV,*ESqV1a,*ESqV2a

,*ESjp,*ESjp1a,*ESjp2a
,*ESsp,*ESsp1a,*ESsp2a
,*ESPs,*ESPs1a,*ESPs2a
,*ESgb,*ESgb1a,*ESgb2a
,*ESgB,*ESgB1a,*ESgB2a

,*ESjs,*ESjs1a,*ESjs2a
,*ESjb,*ESjb1a,*ESjb2a
,*ESaJ,*ESaJ1a,*ESaJ2a
,*ESaT,*ESaT1a,*ESaT2a
,*ESjB,*ESjB1a,*ESjB2a

,*ESsq,*ESsq1a,*ESsq2a
,*ESgm,*ESgm1a,*ESgm2a
,*ESgY,*ESgY1a,*ESgY2a
,*ESgF,*ESgF1a,*ESgF2a

,*ESaF,*ESaF1a,*ESaF2a
,*ESFF,*ESFF1a,*ESFF2a
,*ESdgY,*ESdgY1a,*ESdgY2a
,*ESjR,*ESjR1a,*ESjR2a;

extern int ESXNa,ESXNa1,*ESXsxK;
extern double *ESXsxD,*ESXsrD,*ESXsjD,*ESXspD,*ESXsqD,*ESXsiD;
extern double *ESXsx,*ESXsr,*ESXsj,*ESXsp,*ESXsq,*ESXsi;
extern int ESNMSE;
extern double ESrMSE[],ESgiMSE[];

extern int ESnDtPr,ESnDtCr;
extern double ESxDtPr[],ESxDtCr[];

static int iSplDP,iSplDP1,iSplDPold;
static double crxDP,cHxDP,SplDPx,SplDPxx,SplDPX,SplDPXX;

static int iSplDC,iSplDC1,iSplDCold;
static double crxDC,cHxDC,SplDCx,SplDCxx,SplDCX,SplDCXX;
#endif
extern int ESEqSolvRadC,ESEqSolvInPr,ESEqSolvInCr;
extern double *ESg22s,*ESLs,*ESVs,*ESDPs;

int ESDefaultTProf(double RTiTe)
{
  int i,j,nd;
  double d;
  static double ga1=1e-9,ga3=1e-11;

  nd	=21;

  d	=1./(1.+RTiTe);
  for(i=0; i < ESNa1; i++){
    for(j=5; j < 11; j++){
      PlPrP[j].x0[i]	=ESsa[i];
    }
    PlPrP[9].y0[i]	=PlPrP[2].y0[i]*d;	/*p_e*/
    PlPrP[9].y1[i]	=PlPrP[2].y1[i]*d;
    PlPrP[9].y2[i]	=PlPrP[2].y2[i]*d;
    PlPrP[10].y0[i]	=PlPrP[2].y0[i]-PlPrP[9].y0[i];	/*p_i*/
    PlPrP[10].y1[i]	=PlPrP[2].y1[i]-PlPrP[9].y1[i];
    PlPrP[10].y2[i]	=PlPrP[2].y2[i]-PlPrP[9].y2[i];
    PlPrP[7].y0[i]	=10.*(1.-ESpa[i])+1.;	/*T_e*/
    PlPrP[7].y1[i]	=-20.*ESsa[i];
    PlPrP[7].y2[i]	=-20.;
    PlPrP[8].y0[i]	=PlPrP[7].y0[i]*RTiTe;	/*T_i*/
    PlPrP[8].y1[i]	=PlPrP[7].y1[i]*RTiTe;
    PlPrP[8].y2[i]	=PlPrP[7].y2[i]*RTiTe;
    PlPrP[5].y0[i]	=PlPrP[9].y0[i]/PlPrP[7].y0[i];	/*n_e*/
    PlPrP[5].y1[i]	=0.;
    PlPrP[5].y2[i]	=0.;
    PlPrP[6].y0[i]	=PlPrP[5].y0[i];	/*n_i*/
    PlPrP[6].y1[i]	=0.;
    PlPrP[6].y2[i]	=0.;
  }




  strcpy(PlPrP[5].Nm,	"n_e    ");
  strcpy(PlPrP[6].Nm,	"n_i    ");
  strcpy(PlPrP[7].Nm,	"T_e    ");
  strcpy(PlPrP[8].Nm,	"T_i    ");
  strcpy(PlPrP[9].Nm,	"p_e    ");
  strcpy(PlPrP[10].Nm,	"p_i    ");


    PlPrP[i].io	=0;
    PlPrP[i].xin=0;
    PlPrP[i].nd	=nd;
    ioPrP[i]	=0;
    for(j=0; j < NPlPD; j++){
      if(j < nd){
	PlPrP[i].xd[j]	=d*j;
	PlPrP[i].yd[j]	=0.;
	PlPrP[i].kk[j]	=1;
      }
      else{
	PlPrP[i].xd[j]	=0.;
	PlPrP[i].yd[j]	=0.;
	PlPrP[i].kk[j]	=0;
      }
    }
  }
  for(i=0; i < NCrP; i++){
    PlCrP[i].x0	=(double*)malloc(4*ESNa1*sizeof(double));
    if(PlCrP[i].x0 == NULL){
      FailureAlarm((char*)PlCrP[i].x0
		   ,"ESReInitPlProf() - no memory for PlCrP[i].x0");
      ESexit(0);
    }
    PlCrP[i].y0	=PlCrP[i].x0+ESNa1;
    PlCrP[i].y1	=PlCrP[i].y0+ESNa1;
    PlCrP[i].y2	=PlCrP[i].y1+ESNa1;
    for(j=0; j < ESNa1; j++){
      PlCrP[i].x0[j]	=ESsa[j];
      PlCrP[i].y0[j]	=0.;
      PlCrP[i].y1[j]	=0.;
      PlCrP[i].y2[j]	=0.;
    }
    PlCrP[i].io	=0;
    PlCrP[i].xin=0;
    PlCrP[i].nd	=nd;
    ioCrP[i]	=0;
    for(j=0; j < NPlPD; j++){
      if(j < nd){
	PlCrP[i].xd[j]	=d*j;
	PlCrP[i].yd[j]	=0.;
	PlCrP[i].kk[j]	=1;
      }
      else{
	PlCrP[i].xd[j]	=0.;
	PlCrP[i].yd[j]	=0.;
	PlCrP[i].kk[j]	=0;
      }
    }
  }

  strcpy(PRdC.Nm,	"RC     ");
  ESRC	=PRdC.y0;
  ESRC1a=PRdC.y1;
  ESRC2a=PRdC.y2;

  strcpy(PlPrP[0].Nm,	"j_PfShl");
  ESjp	=PlPrP[0].y0;
  ESjp1a=PlPrP[0].y1;
  ESjp2a=PlPrP[0].y2;
  strcpy(PlPrP[1].Nm,	"Ps     ");
  ESPs	=PlPrP[1].y0;
  ESPs1a=PlPrP[1].y1;
  ESPs2a=PlPrP[1].y2;
  strcpy(PlPrP[2].Nm,	"p      ");
  ESsp	=PlPrP[2].y0;
  ESsp1a=PlPrP[2].y1;
  ESsp2a=PlPrP[2].y2;
  strcpy(PlPrP[3].Nm,	"p'/a   ");
  strcpy(PlPrP[4].Nm,	"ga_CHT ");
  strcpy(PlPrP[5].Nm,	"n_e    ");
  strcpy(PlPrP[6].Nm,	"n_i    ");
  strcpy(PlPrP[7].Nm,	"T_e    ");
  strcpy(PlPrP[8].Nm,	"T_i    ");
  strcpy(PlPrP[9].Nm,	"p_e    ");
  strcpy(PlPrP[10].Nm,	"p_i    ");
  strcpy(PlPrP[11].Nm,	"gb_Sh  ");
  ESgb	=PlPrP[11].y0;
  ESgb1a=PlPrP[11].y1;
  ESgb2a=PlPrP[11].y2;
  strcpy(PlPrP[12].Nm,	"gb     ");
  ESgB	=PlPrP[12].y0;
  ESgB1a=PlPrP[12].y1;
  ESgB2a=PlPrP[12].y2;

  strcpy(PlCrP[0].Nm,	"j_GSh  ");
  ESjs	=PlCrP[0].y0;
  ESjs1a=PlCrP[0].y1;
  ESjs2a=PlCrP[0].y2;

  strcpy(PlCrP[1].Nm,	"j_||   ");
  ESjb	=PlCrP[1].y0;
  ESjb1a=PlCrP[1].y1;
  ESjb2a=PlCrP[1].y2;

  strcpy(PlCrP[2].Nm,	"J      ");
  ESaJ	=PlCrP[2].y0;
  ESaJ1a=PlCrP[2].y1;
  ESaJ2a=PlCrP[2].y2;

  strcpy(PlCrP[3].Nm,	"FF'    ");
  ESaT	=PlCrP[3].y0;
  ESaT1a=PlCrP[3].y1;
  ESaT2a=PlCrP[3].y2;

  strcpy(PlCrP[4].Nm,	"<j.B>  ");
  ESjB	=PlCrP[4].y0;
  ESjB1a=PlCrP[4].y1;
  ESjB2a=PlCrP[4].y2;

  strcpy(PlCrP[5].Nm,	"Fs     ");

  strcpy(PlCrP[6].Nm,	"q      ");
  ESsq	=PlCrP[6].y0;
  ESsq1a=PlCrP[6].y1;
  ESsq2a=PlCrP[6].y2;

  strcpy(PlCrP[7].Nm,	"1/q    ");
  ESgm	=PlCrP[7].y0;
  ESgm1a=PlCrP[7].y1;
  ESgm2a=PlCrP[7].y2;

  strcpy(PlCrP[8].Nm,	"gY     ");
  ESgY	=PlCrP[8].y0;
  ESgY1a=PlCrP[8].y1;
  ESgY2a=PlCrP[8].y2;

  strcpy(PlCrP[9].Nm,	"gF    ");
  ESgF	=PlCrP[9].y0;
  ESgF1a=PlCrP[9].y1;
  ESgF2a=PlCrP[9].y2;

  strcpy(PlCrP[10].Nm,	"F      ");
  ESaF	=PlCrP[10].y0;
  ESaF1a=PlCrP[10].y1;
  ESaF2a=PlCrP[10].y2;
  strcpy(PlCrP[11].Nm,	"FF     ");
  ESFF	=PlCrP[11].y0;
  ESFF1a=PlCrP[11].y1;
  ESFF2a=PlCrP[11].y2;

  strcpy(PlCrP[12].Nm,	"ir+il  ");
  strcpy(PlCrP[13].Nm,	"ir-il  ");
  strcpy(PlCrP[14].Nm,	"j_r    ");
  strcpy(PlCrP[15].Nm,	"j_l    ");

  strcpy(PlCrP[16].Nm,	"dgY/a  ");
  ESdgY	=PlCrP[16].y0;
  ESdgY1a=PlCrP[16].y1;
  ESdgY2a=PlCrP[16].y2;

  strcpy(PlCrP[17].Nm,	"j_||R0 ");
  ESjR	=PlCrP[17].y0;
  ESjR1a=PlCrP[17].y1;
  ESjR2a=PlCrP[17].y2;

  ioPrP[0]	=1;
  PlPrP[0].io	=1;
  for(i=0; i < nd; i++){
    PlPrP[0].yd[i]	=0.2*(1.-d*d*i*i);
  }
  ESPrData2Spl(PlPrP,PlPrP[0].kk,PlPrP[0].xd,PlPrP[0].yd,&ga1,&ga3);
  ESPrSplData2Pr(PlPrP);
  ioCrP[0]	=1;
  PlCrP[0].io	=1;
  for(i=0; i < nd; i++){
    PlCrP[0].yd[i]	=1.-d*d*i*i;
  }
  ESPrData2Spl(PlCrP,PlCrP[0].kk,PlCrP[0].xd,PlCrP[0].yd,&ga1,&ga3);
  ESPrSplData2Pr(PlCrP);

  ESXsx	=(double*)malloc(12*NPlPD*sizeof(double));
  if(ESXsx == NULL){
    FailureAlarm((char*)ESXsx
		 ,"ESReInitPlProf() - no memory for ESXsx");
    ESexit(0);	
  }
  ESXsr	=ESXsx	+NPlPD;
  ESXsj	=ESXsr	+NPlPD;
  ESXsp	=ESXsj	+NPlPD;
  ESXsq	=ESXsp	+NPlPD;
  ESXsi	=ESXsq	+NPlPD;
  ESXsxD	=ESXsi	+NPlPD;
  ESXsrD	=ESXsxD	+NPlPD;
  ESXsjD	=ESXsrD	+NPlPD;
  ESXspD	=ESXsjD	+NPlPD;
  ESXsqD	=ESXspD	+NPlPD;
  ESXsiD	=ESXsqD	+NPlPD;
  ESXsxK	=(int*)malloc(NPlPD*sizeof(int));

  d	=2./ESXNa;
  for(i=0; i < NPlPD; i++){
    ESXsx[i]	=i < ESXNa1 ?  -1.+d*i : 0.;
    ESXsr[i]	=ESXsx[i];
    ESXsj[i]	=0.;
    ESXsp[i]	=0.;
    ESXsq[i]	=0.;
    ESXsi[i]	=0.;
    ESXsxK[i]	=0;	
    ESXsxD[i]	=0.;
    ESXsrD[i]	=0.;
    ESXsjD[i]	=0.;
    ESXspD[i]	=0.;
    ESXsqD[i]	=0.;
    ESXsiD[i]	=0.;
  }
  ESmemlev |=0x01000000;
  return(0);
}

int ESDeInitPlProf()
{
  int i;

  if(ESNa1 == 0)
    return(0);
  free(ESXsxK);
  free(ESXsx);
  for(i=0; i < NCrP; i++){
    free(PlCrP[i].x0);
  }
  for(i=0; i < NPrP; i++){
    free(PlPrP[i].x0);
  }
  free(PRdC.x0);
  free(kaRdC);
  for(i=0; i < NRdC; i++){
    free(RdC[i].x0);
  }
  NPrP	=0;
  NCrP	=0;
  NRdC	=0;
  return(0);
}

int ESFirstSetSplDPr()
{
  iSplDP	=0;
  iSplDP1	=1;
  crxDP		=ESxDtPr[1];
  cHxDP		=cr6*crxDP*crxDP;
  crxDP		=1./crxDP;
  iSplDPold	=0;
  return(0);
}

int ESSetSplDPr(double A)
{
  if(A > ESxDtPr[ESnDtPr])
    A	=ESxDtPr[ESnDtPr];
  if(A < 0.)
    A	=0.;
  while(iSplDP < ESnDtPr && ESxDtPr[iSplDP+1] < A){
    iSplDP++;
  }
  while(iSplDP > 0 && ESxDtPr[iSplDP] > A){
    iSplDP--;
  }
  if(iSplDPold	!= iSplDP){
    iSplDPold	=iSplDP;
    iSplDP1	=iSplDP+1;
    crxDP	=ESxDtPr[iSplDP1]-ESxDtPr[iSplDP];
    cHxDP	=cr6*crxDP*crxDP;
    crxDP	=1./crxDP;
  }
  SplDPx	=(A-ESxDtPr[iSplDP])*crxDP;
  SplDPxx	=SplDPx*SplDPx;

  SplDPX	=1.-SplDPx;
  SplDPXX	=SplDPX*SplDPX;
  return(0);
}

int splRDPr(double*f, double*df,int k)
{
  double *d0,*d2;

  d0	=PlPrP[k].d0;
  d2	=PlPrP[k].d2;
  *f	=SplDPX*d0[iSplDP]+SplDPx*d0[iSplDP1]
    +(SplDPX*(SplDPXX-1.)*d2[iSplDP]+SplDPx*(SplDPxx-1.)*d2[iSplDP1])*cHxDP;
  if(df != NULL){
    *df	=(d0[iSplDP1]-d0[iSplDP]+
	  ((3.*SplDPxx-1.)*d2[iSplDP1]-(3.*SplDPXX-1.)*d2[iSplDP])*cHxDP)
      *crxDP;
  }
  return(0);
}

int splRDPr2(double*f, double*df, double*d2f, int k)
{
  double *d0,*d2;

  d0	=PlPrP[k].d0;
  d2	=PlPrP[k].d2;
  *f	=SplDPX*d0[iSplDP]+SplDPx*d0[iSplDP1]
    +(SplDPX*(SplDPXX-1.)*d2[iSplDP]+SplDPx*(SplDPxx-1.)*d2[iSplDP1])*cHxDP;
  if(df != NULL){
    *df	=(d0[iSplDP1]-d0[iSplDP]
	  +((3.*SplDPxx-1.)*d2[iSplDP1]-(3.*SplDPXX-1.)*d2[iSplDP])*cHxDP)
      *crxDP;
  }
  if(d2f != NULL){
    *d2f	=SplDPX*d2[iSplDP]+SplDPx*d2[iSplDP1];
  }
  return(0);
}

int ESFirstSetSplDCr()
{
  iSplDC	=0;
  iSplDC1	=1;
  crxDC		=ESxDtCr[1];
  cHxDC		=cr6*crxDC*crxDC;
  crxDC		=1./crxDC;
  iSplDCold	=0;
  return(0);
}

int ESSetSplDCr(double A)
{
  if(A > ESxDtCr[ESnDtCr])
    A	=ESxDtCr[ESnDtCr];
  if(A < 0.)
    A	=0.;
  while(iSplDC < ESnDtCr && ESxDtCr[iSplDC+1] < A){
    iSplDC++;
  }
  while(iSplDC > 0 && ESxDtCr[iSplDC] > A){
    iSplDC--;
  }
  if(iSplDCold	!= iSplDC){
    iSplDCold	=iSplDC;
    iSplDC1	=iSplDC+1;
    crxDC		=ESxDtCr[iSplDC1]-ESxDtCr[iSplDC];
    cHxDC		=cr6*crxDC*crxDC;
    crxDC		=1./crxDC;
  }
  SplDCx	=(A-ESxDtCr[iSplDC])*crxDC;
  SplDCxx	=SplDCx*SplDCx;

  SplDCX	=1.-SplDCx;
  SplDCXX	=SplDCX*SplDCX;
  return(0);
}

int splRDCr(double*f, double*df,int k)
{
  double *d0,*d2;

  d0	=PlCrP[k].d0;
  d2	=PlCrP[k].d2;
  *f	=SplDCX*d0[iSplDC]+SplDCx*d0[iSplDC1]
    +(SplDCX*(SplDCXX-1.)*d2[iSplDC]+SplDCx*(SplDCxx-1.)*d2[iSplDC1])*cHxDC;
  if(df != NULL){
    *df	=(d0[iSplDC1]-d0[iSplDC]+
	  ((3.*SplDCxx-1.)*d2[iSplDC1]-(3.*SplDCXX-1.)*d2[iSplDC])*cHxDC)
      *crxDC;
  }
  return(0);
}

int splRDCr2(double*f, double*df, double*d2f, int k)
{
  double *d0,*d2;

  d0	=PlCrP[k].d0;
  d2	=PlCrP[k].d2;
  *f	=SplDCX*d0[iSplDC]+SplDCx*d0[iSplDC1]
    +(SplDCX*(SplDCXX-1.)*d2[iSplDC]+SplDCx*(SplDCxx-1.)*d2[iSplDC1])*cHxDC;
  if(df != NULL){
    *df	=(d0[iSplDC1]-d0[iSplDC]
	  +((3.*SplDCxx-1.)*d2[iSplDC1]-(3.*SplDCXX-1.)*d2[iSplDC])*cHxDC)
      *crxDC;
  }
  if(d2f != NULL){
    *d2f	=SplDCX*d2[iSplDC]+SplDCx*d2[iSplDC1];
  }
  return(0);
}

int ESPrSplData2Pr(PlProf *Prof)
{
  int i,i1,i2,nd1,inx;
  double dg0,dg1,x,dx,dy;
  double *xd,*d0,*d2,*x0,*y0;

  xd	=Prof->xd;
  d0	=Prof->d0;
  d2	=Prof->d2;
  nd1	=Prof->nd-1;
  x0	=Prof->x0;
  y0	=Prof->y0;
  inx	=0;
  
  i1	=0;
  for(i=0; i < ESNa1; i++){
    if(inx){
      i2=i == 0 ? 0 : i-1;
#ifdef H
      splr1(&x,&dx,ESsa+i,RadC[inx].x,RadC[inx].d2x,ESsa,&na,&i2);
#endif
    }
    else{
      x		=ESsa[i];
      dx	=1.;
    }
    while(i1 < nd1 && xd[i1+1] < x){
      i1++;
    }
    splr1(y0+i,&dy,&x,d0,d2,xd,&nd1,&i1);
    if(i == 0){
      dg0	=dy*dx;
    }
    x0[i]	=x;
  }
  dg1	=dy*dx;
  splAA(y0,Prof->y1,Prof->y2,&dg0,&dg1);
  return(0);
}

int ESPrSplData2PrPr(int k)
{
  int i;
  static double dy0=0.;
  double dy1,*x0,*y0,*y1,*y2;

  x0	=PlPrP[k].x0;
  y0	=PlPrP[k].y0;
  y1	=PlPrP[k].y1;
  y2	=PlPrP[k].y2;
  for(i=0; i < ESNa1; i++){
    ESSetSplDPr(ESsa[i]);
    splRDPr2(y0+i,y1+i,y2+i,k);
    x0[i]	=ESsa[i];
  }
  return(0);
}

int ESPrSplData2CrPr(int k)
{
  int i;
  static double dy0=0.;
  double dy1,*x0,*y0,*y1,*y2;

  x0	=PlCrP[k].x0;
  y0	=PlCrP[k].y0;
  y1	=PlCrP[k].y1;
  y2	=PlCrP[k].y2;
  for(i=0; i < ESNa1; i++){
    ESSetSplDCr(ESsa[i]);
    splRDCr2(y0+i,y1+i,y2+i,k);
    x0[i]	=ESsa[i];
  }
  return(0);
}

int ESData2Order(double *xd,double *yd,int *k2k,int nd)
{
  int i,j,k;
  double s;
  
  for(k=0; k < nd; k++){
    if(k2k[k] == 0){
      i	=k+1;
      while(i < nd && k2k[i] == 0){
	i++;
      }
      if(i == nd){
	return(k);
      }
      else{
	s	=xd[i];
	xd[i]	=xd[k];
	xd[k]	=s;
	s	=yd[i];
	yd[i]	=yd[k];
	yd[k]	=s;
	k2k[k]	=1;
	k2k[i]	=0;
      }
    }
    i	=k+1;
    while(i < nd){
      if(k2k[i]){
	if(xd[i] < xd[k]){
	  s	=xd[i];
	  xd[i]	=xd[k];
	  xd[k]	=s;
	  s	=yd[i];
	  yd[i]	=yd[k];
	  yd[k]	=s;
	}
	else{
	  if(xd[i] == xd[k]){
	    k2k[i]	=0;
	  }
	}
      }
      i++;
    }
  }
  return(nd);
}

int ESPrData2Spl(PlProf *Prof,int *k2k,double *xd,double *yd,
	     double *ga1,double *ga3)
{
  int i,j,k;
  static double ga0=0.,ga2=0.;
  double dg0,dg1,s;

  k	=0;
  j	=0;
  s	=-1e+20;
  while(j < NPlPD){
    if(k2k[j]){
      Prof->xd[k]	=xd[j];
      Prof->yd[k]	=yd[j];
      if(s < fabs(yd[j]))
	s	=fabs(yd[j]);
      k++;
    }
    j++;
  }
  Prof->nd	=k;
  k--;
  if(Prof->xd[0] != 0.){
    Prof->xd[0]	=0.;
  }
  if(Prof->xd[k] != 1.){
    Prof->xd[k]	=1.;
  }

  if(fabs(Prof->yd[0]) < 1e-4*s){
    Prof->yd[0]	=0;
    f2spl(Prof->d0,Prof->d2,NULL,NULL,Prof->yd,NULL,Prof->xd,&k,
	  &ga0,ga1,&ga2,ga3);
  }
  else{
    dg0	=0.;
    f2spl(Prof->d0,Prof->d2,&dg0,NULL,Prof->yd,NULL,Prof->xd,&k,
	  &ga0,ga1,&ga2,ga3);
  }
  return(0);
}

int ESPlProf2Data()
{
  int i,k,nd;
  double *xd;

  nd	=PlPrP[ESEqSolvInPr].nd;
  xd	=PlPrP[ESEqSolvInPr].xd;
  for(i=0; i < nd; i++){
    ESSetSplA(xd[i]);
    for(k=0; k < NPrP; k++){
      if(k != ESEqSolvInPr){
	PlPrP[k].xd[i]=xd[i];
	PlPrP[k].kk[i]=1;
	if(PlPrP[k].kk[i]){
	  splRA(PlPrP[k].yd+i,NULL,PlPrP[k].y0,PlPrP[k].y2);
	}
      }
    }
  }
  while(i < NPlPD){
    for(k=0; k < NPrP; k++){
      if(k != ESEqSolvInPr){
	PlPrP[k].kk[i]=0;
      }
    }
    i++;
  }
  
  nd	=PlCrP[ESEqSolvInCr].nd;
  xd	=PlCrP[ESEqSolvInCr].xd;
  for(i=0; i < nd; i++){
    ESSetSplA(xd[i]);
    for(k=0; k < NCrP; k++){
      if(k != ESEqSolvInCr){
	PlCrP[k].xd[i]=xd[i];
	PlCrP[k].kk[i]=1;
	if(PlCrP[k].kk[i]){
	  splRA(PlCrP[k].yd+i,NULL,PlCrP[k].y0,PlCrP[k].y2);
	}
      }
    }
  }
  
  while(i < NPlPD){
    for(k=0; k < NPrP; k++){
      if(k != ESEqSolvInCr){
	PlCrP[k].kk[i]=0;
      }
    }
    i++;
  }
  return(0);
}

int ESRdCSplData2RdC(RadCoord *pRdC)
{
  int i,i1,i2,nd1;
  double dx0,x,dx;
  double *xd,*d0,*d2,*x0;

  nd1	=PRdC.nd-1;
  xd	=PRdC.xd;
  d0	=PRdC.d0;
  d2	=PRdC.d2;
  x0	=pRdC->x0;
  i1	=0;
  for(i=0; i < ESNa1; i++){
    x		=ESsa[i];
    while(i1 < nd1 && xd[i1+1] < x){
      i1++;
    }
    splr1(x0+i,&dx,&x,d0,d2,xd,&nd1,&i1);
    if(i == 0){
      dx0	=dx;
    }
  }
  splAA(x0,pRdC->x1,pRdC->x2,&dx0,&dx);
  return(0);
}

int ESRdCSpl2Data()
{
  int i,k,nd,*kk;
  double *ad;

  nd	=RdC[ESEqSolvRadC].nd;
  ad	=RdC[ESEqSolvRadC].ad;
  kk	=RdC[ESEqSolvRadC].kk;
  for(i=0; i < NPlPD; i++){
    ESSetSplA(ad[i]);
    for(k=0; k < NRdC; k++){
      if(1 || k != ESEqSolvRadC){
	RdC[k].ad[i]=ad[i];
	if(kk[i] == 1){
	  RdC[k].kk[i]=kk[i];
	}
	if(RdC[k].kk[i]){
	  splRA(RdC[k].xd+i,NULL,RdC[k].x0,RdC[k].x2);
	}
      }
    }
  }
  return(0);
}

int ESSwitchInpRadC()
{
  RadCoord *pRdC;

  pRdC		=RdC+ESEqSolvRadC;
  pRdC->nd	=ESData2Order(pRdC->ad,pRdC->xd,pRdC->kk,NPlPD);
  ESRdCSpl2Data();
  return(0);
}

int ESInpRadC()
{
  int i,k,nd;
  RadCoord *pRdC;
  static double ga1=1e-9,ga3=1e-11;
  double *ad;

  kaRdC[0]	=ESEqSolvRadC;
  pRdC		=RdC+ESEqSolvRadC;
  ad		=pRdC->ad;
#ifndef Tbl_RadC
  pRdC->nd	=ESData2Order(pRdC->ad,pRdC->xd,pRdC->kk,NPlPD);
#ifdef Later
  ESPrData2Spl(&PRdC,pRdC->kk,pRdC->ad,pRdC->xd,&ga1,&ga3);
  ESRdCSplData2RdC(pRdC);
#endif
  ESRdCSpl2Data();
  if(kaRdC[0] != ESEqSolvRadC){
    ESEqSolvRadC	=kaRdC[0];
    pRdC	=RdC+ESEqSolvRadC;
    ad		=pRdC->ad;
  }
  for(i=1; i < NPlPD; i++){
    kaRdC[i]	=kaRdC[0];
  }
#endif Tbl_RadC
  return(0);
}

int ESInpPlPr()
{
  PlProf *pPrP;
  int i,k,*kk,InP,FlP;
  double *xd,*x;
  static double ga1=1e-9,ga3=1e-11;

  InP	=ESEqSolvInPr;
  FlP	=ESEqSolvInPr;
#ifndef Tbl_PlPr
  if(FlP < 10){
    ESEqSolvInPr	=FlP;
  }

  if(ESEqSolvInPr < 0)
    ESEqSolvInPr	=0;
  if(ESEqSolvInPr > 1)
    ESEqSolvInPr	=2;

  if(ESEqSolvInPr == 2 && (ESEqSolvInCr == 0 || ESEqSolvInCr == 3)){
    printf("given p(a) is not allowed for InCr == %d%c\n",ESEqSolvInCr,'\a');
    ESEqSolvInPr	=InP;
  }

  for(i=0; i < NPrP; i++){
    PlPrP[i].io	=i == ESEqSolvInPr ? 1 : 0;
    ioPrP[i]	=PlPrP[i].io;
  }
  pPrP	=PlPrP+ESEqSolvInPr;
  xd	=pPrP->xd;

  kk	=pPrP->kk;

  pPrP->nd=ESData2Order(xd,pPrP->yd,pPrP->kk,NPlPD);
  ESPrData2Spl(pPrP,pPrP->kk,xd,pPrP->yd,&ga1,&ga3);
  
  ESnDtPr	=pPrP->nd;
  for(i=0; i < ESnDtPr; i++){
    ESxDtPr[i]	=xd[i];
  }
  ESnDtPr--;
  ESFirstSetSplDPr();
  ESPrSplData2PrPr(ESEqSolvInPr);
  x	=pPrP->x0;
#ifdef XWIN
  EC1DEqSolv();
  ESPlProf2Data();
#endif

  if(FlP >= 10){
    for(i=0; i < ESXNa1; i++){
      ESXsxD[i]	=ESXsx[i];
      ESXsrD[i]	=ESXsr[i];
      ESXsjD[i]	=ESXsj[i];
      ESXspD[i]	=ESXsp[i];
      ESXsqD[i]	=ESXsq[i];
      ESXsiD[i]	=ESXsi[i];
    }
    FlP	=ESEqSolvInPr;
  }
#ifdef XWIN
  Scale2D(4,2,ESXsx,ESXsi,ESXNa1,6,2);
  Plot2D(4,ESXsx,ESXsi,ESXNa1,6,0,0,0);
  Plot2D(4,ESXsxD,ESXsiD,ESXNa1,6,1,0,0);
#endif
#endif Tbl_PlPr
  return(0);
}

int ESInpPlCr()
{
  PlProf *pCrP;
  static int FlC=0;
  int i,k,io,kk[129],InC,Nax;
  extern int FlagPS;
  double *xd,*x,r0;
  static double ga1=1e-9,ga3=1e-11;

  for(i=0; i < 129; i++){
    kk[i]	=0;
  }

  Nax	=ESNa1;
  InC	=ESEqSolvInCr;
  FlC	=ESEqSolvInCr;
#ifndef Tbl_PlCr
  if(FlC < 10){
    ESEqSolvInCr	=FlC;
  }
  if(ESEqSolvInCr == 2 || ESEqSolvInCr == 5 || 
     (ESEqSolvInCr > 7 && ESEqSolvInCr != 17)){
    printf("InpCrP == 2, 5 or > 7 are not allowed%c\n",'\a');
    ESEqSolvInCr	=InC;
  }
  if(ESEqSolvInPr == 2 && (ESEqSolvInCr == 0 || ESEqSolvInCr == 3)){
    printf("InpCrP == %d is not allowed for given p(a) == 2%c\n"
	   ,ESEqSolvInCr,'\a');
    ESEqSolvInCr	=InC;
  }

  if(ESEqSolvInCr > ESNCRPR-1)
    ESEqSolvInCr	=ESNCRPR-1;
  io	=ESEqSolvInCr;

  pCrP	=PlCrP+ESEqSolvInCr;

  {
    static int F=0;
    if(F == 0){
      for(i=0; i < ESXNa1; i++){
	ESXsxD[i]	=ESXsx[i];
	ESXsrD[i]	=ESXsr[i];
      }
    }
    F	=1;
  }
  switch(kk[0]){
  case 0:
    xd	=pCrP->xd;
    break;
  case 1:
    xd	=ESXsxD;
    break;
  case 2:
    xd	=ESXsrD;
    break;
  case 3:
    xd	=ESXsrD;
    break;
  default:
    xd	=pCrP->xd;
    break;
  }

#ifdef H
  kk	=pCrP->kk;
#endif
  
  for(i=0; i < NCrP; i++){
    PlCrP[i].io	=i == ESEqSolvInCr ? 1 : 0;
    ioCrP[i]=PlCrP[i].io;
  }
  pCrP->nd	=ESData2Order(pCrP->xd,pCrP->yd,pCrP->kk,NPlPD);
  ESnDtCr	=pCrP->nd;
  for(i=0; i < ESnDtCr; i++){
    ESxDtCr[i]	=pCrP->xd[i];
  }
  ESnDtCr--;
  ESFirstSetSplDCr();
  if(ESEqSolvInCr == 6){
    double dg0,dg1;
    for(i=0; i < pCrP->nd; i++){
      PlCrP[7].kk[i]	=pCrP->kk[i];
      PlCrP[7].xd[i]	=pCrP->xd[i];
      PlCrP[7].yd[i]	=1./pCrP->yd[i];
    }
    PlCrP[7].nd	=pCrP->nd;
    ESPrData2Spl(PlCrP+7,pCrP->kk,pCrP->xd,PlCrP[7].yd,&ga1,&ga3);
    ESPrSplData2CrPr(7);
    for(i=0; i < ESNa1; i++){
      ESsq[i]	=1./ESgm[i];
    }
    dg0	=0.;
    dg1	=-ESgm1a[ESNa]*ESsq[ESNa]*ESsq[ESNa];
    splAA(ESsq,ESsq1a,ESsq2a,&dg0,&dg1);
  }
  else{
    ESPrData2Spl(pCrP,pCrP->kk,pCrP->xd,pCrP->yd,&ga1,&ga3);
    ESPrSplData2CrPr(ESEqSolvInCr);
  }
  if(ESEqSolvInCr == 7){
    double dg0,dg1;
    for(i=0; i < pCrP->nd; i++){
      PlCrP[6].kk[i]	=pCrP->kk[i];
      PlCrP[6].xd[i]	=pCrP->xd[i];
      PlCrP[6].yd[i]	=1./pCrP->yd[i];
    }
    for(i=0; i < ESNa1; i++){
      ESsq[i]	=1./ESgm[i];
    }
    dg0	=0.;
    dg1	=-ESgm1a[ESNa]*ESsq[ESNa]*ESsq[ESNa];
    splAA(ESsq,ESsq1a,ESsq2a,&dg0,&dg1);
  }
  if(ESEqSolvInCr == 1){
    r0	=ESaR0[0];
    for(i=0; i < pCrP->nd; i++){
      PlCrP[17].kk[i]	=pCrP->kk[i];
      PlCrP[17].xd[i]	=pCrP->xd[i];
      PlCrP[17].yd[i]	=r0*pCrP->yd[i];
    }
    PlCrP[17].nd	=pCrP->nd;
    for(i=0; i < ESNa1; i++){
      ESjR[i]	=ESjb[i]*r0;
      ESjR1a[i]	=ESjb1a[i]*r0;
      ESjR2a[i]	=ESjb2a[i]*r0;
    }
  }
  if(ESEqSolvInCr == 17){
    r0	=1./ESaR0[0];
    for(i=0; i < pCrP->nd; i++){
      PlCrP[1].kk[i]	=pCrP->kk[i];
      PlCrP[1].xd[i]	=pCrP->xd[i];
      PlCrP[1].yd[i]	=r0*pCrP->yd[i];
    }
    PlCrP[1].nd	=pCrP->nd;
    for(i=0; i < ESNa1; i++){
      ESjb[i]	=ESjR[i]*r0;
      ESjb1a[i]	=ESjR1a[i]*r0;
      ESjb2a[i]	=ESjR2a[i]*r0;
    }
  }
  
  InC	=ESEqSolvInCr;
#ifdef XWIN
  EC1DEqSolv();
  ESPlProf2Data();
  x	=pCrP->x0;
  switch(kk[0]){
  case 0:
    Nax	=ESNa1;
    x	=pCrP->x0;
    break;
  case 1:
    Nax	=ESXNa1;
    x	=ESXsx;
    break;
  case 2:
    Nax	=ESXNa1;
    x	=ESXsr;
    break;
  case 3:
    Nax	=ESXNa1;
    x	=ESXsr;
    break;
  default:
    Nax	=ESNa1;
    x	=pCrP->x0;
    break;
  }

  if(FlC >= 10){
    for(i=0; i < ESXNa1; i++){
      ESXsxD[i]	=ESXsx[i];
      ESXsrD[i]	=ESXsr[i];
      ESXsjD[i]	=ESXsj[i];
      ESXspD[i]	=ESXsp[i];
      ESXsqD[i]	=ESXsq[i];
      ESXsiD[i]	=ESXsi[i];
    }
    if(FlC == 13){
      Scale2D(4,2,ESXsr,ESXsi,ESXNa1,6,2);
      PSFileOpen();
      PSScale2D(ESXsr,ESXsi,ESXNa1,6,2);
      PSPlotFrame(6,2);
      Plot2d(4,ESXsr,ESXsi,ESXNa1,6,0,0,0);
      PSPlot2D(ESXsr,ESXsi,ESXNa1,6,0,0,0);
      Plot2d(4,ESrMSE,ESgiMSE,ESNMSE,6,1,0,0);
      PSPlot2D(ESrMSE,ESgiMSE,ESNMSE,6,1,0,0);
      PSPlot2D(ESrMSE,ESgiMSE,0,6,1,0,-1);
    }
    FlC	=ESEqSolvInCr;
  }
  if(FlagPS == 0){
    Scale2D(4,2,ESXsr,ESXsi,ESXNa1,6,2);
    Plot2D(4,ESXsr,ESXsi,ESXNa1,6,0,0,0);
#ifdef H
    Plot2D(4,ESXsrD,ESXsiD,ESXNa1,6,1,0,0);
#endif
    Plot2D(4,ESrMSE,ESgiMSE,ESNMSE,6,1,0,0);
  }

#endif
#endif Tbl_PlCr
  return(0);
}

int ESInpPlPrCr()
{
  PlProf *pPr;
  int i,k,*kk;
  double *xd,*x,r0;
  static double ga1=1e-9,ga3=1e-11;

  for(i=0; i < NPrP; i++){
    PlPrP[i].io	=i == ESEqSolvInPr ? 1 : 0;
    ioPrP[i]	=PlPrP[i].io;
  }
  pPr	=PlPrP+ESEqSolvInPr;
  xd	=pPr->xd;
  kk	=pPr->kk;

  pPr->nd=ESData2Order(xd,pPr->yd,kk,NPlPD);
  ESPrData2Spl(pPr,kk,xd,pPr->yd,&ga1,&ga3);
  ESPrSplData2PrPr(ESEqSolvInPr);

  pPr	=PlCrP+ESEqSolvInCr;
  xd	=pPr->xd;
  kk	=pPr->kk;
  
  for(i=0; i < NCrP; i++){
    PlCrP[i].io	=i == ESEqSolvInCr ? 1 : 0;
    ioCrP[i]=PlCrP[i].io;
  }
  pPr->nd	=ESData2Order(xd,pPr->yd,pPr->kk,NPlPD);
  ESPrData2Spl(pPr,pPr->kk,xd,pPr->yd,&ga1,&ga3);
  ESPrSplData2CrPr(ESEqSolvInCr);

  if(ESEqSolvInCr == 7){
    double dg0,dg1;
    for(i=0; i < pPr->nd; i++){
      PlCrP[6].kk[i]	=kk[i];
      PlCrP[6].xd[i]	=xd[i];
      PlCrP[6].yd[i]	=1./pPr->yd[i];
    }
    for(i=0; i < ESNa1; i++){
      ESsq[i]	=1./ESgm[i];
    }
    dg0	=0.;
    dg1	=-ESgm1a[ESNa]*ESsq[ESNa]*ESsq[ESNa];
    splAA(ESsq,ESsq1a,ESsq2a,&dg0,&dg1);
  }
  if(ESEqSolvInCr == 1){
    r0	=ESaR0[0];
    for(i=0; i < pPr->nd; i++){
      PlCrP[17].kk[i]	=kk[i];
      PlCrP[17].xd[i]	=xd[i];
      PlCrP[17].yd[i]	=r0*pPr->yd[i];
    }
    PlCrP[17].nd	=pPr->nd;
    for(i=0; i < ESNa1; i++){
      ESjR[i]	=ESjb[i]*r0;
      ESjR1a[i]	=ESjb1a[i]*r0;
      ESjR2a[i]	=ESjb2a[i]*r0;
    }
  }
  if(ESEqSolvInCr == 17){
    r0	=1./ESaR0[0];
    for(i=0; i < pPr->nd; i++){
      PlCrP[1].kk[i]	=kk[i];
      PlCrP[1].xd[i]	=xd[i];
      PlCrP[1].yd[i]	=r0*pPr->yd[i];
    }
    PlCrP[1].nd	=pPr->nd;
    for(i=0; i < ESNa1; i++){
      ESjb[i]	=ESjR[i]*r0;
      ESjb1a[i]	=ESjR1a[i]*r0;
      ESjb2a[i]	=ESjR2a[i]*r0;
    }
  }
  return(0);
}

