extern double cr2,cr3,cr4,cr6,cr12,cgp,c2gp,cgp_4,cr2gp,cgm0,crgm0;
extern int ESNa,ESNp,ESNa1,ESNp1;
extern int ESFp,ESFp1;
extern double *a,*aa,*b;
extern double *r,*z,*dra,*drgt,*dza,*dzgt;
extern double *ESgt;
extern double R0,Z0,ESRext,ESRBt;

extern double *ESjp,*ESjp2a;
extern double *ESjs,*ESjs2a;
extern double *ESbJ,*ESbJ2a;

extern double *ESgY0,*ESgY01a,*ESgY02a,*ESbY0,*ESbY01a,ESgY2a1a;

extern int*icolrz;
extern int Na,Na1,N_at;

int EscInitArrays()
{
  int i;
  double t,dt;

  ESNa=na_DEF;
  ESNp=72;
  ESNa1= ESNa+1;
  i= ESNp%4;
  if(i){
    ESNp+= 4-i;
  }
  ESNp1= ESNp+1;
  ESFp	=ESNp/2;
  ESFp1	=ESFp+1;
  Na=Na_DEF;
  Na1= Na+1;
  N_at= Na1*ESNp1;

  icolrz= (int*)malloc(Na1*sizeof(int));
  if(icolrz==NULL){
    printf("Failure in memory allocation for icolrz in init_arrays\n");
    exit(0);
  }
  r= (double*)malloc(6*N_at*sizeof(double));
  if(r==NULL){
    printf("Failure in memory allocation for r in init_arrays\n");
    exit(0);
  }
  z= r+N_at;
  dra=z+N_at;
  drgt= dra+N_at;
  dza= drgt+N_at;
  dzgt= dza+N_at;
  ESgt= (double*)malloc(ESNp1*sizeof(double));
  if(ESgt==NULL){
    printf("Failure in memory allocation in init_arrays\n");
    exit(0);
  }
  dt=c2gp/ESNp;
  for(i=0; i < ESNp1; i++){
    ESgt[i]= dt*i;
  }
  a= (double*)malloc(3*Na1*sizeof(double));
  if(a==NULL){
    printf("Failure in memory allocation in init_arrays\n");
    exit(0);
  }
  aa= a+Na1;
  b= aa+Na1;
  dt= 1./ESNa;
  t= ESNa/((double)Na);
  for(i= 0;i<Na1;i++){
    a[i]= dt*i;
    b[i]= t*a[i];
    aa[i]= a[i]*a[i];
  }
  return(0);
}

int EscDeInitArrays()
{
  free(a);
  free(ESgt);
  free(r);
  free(icolrz);
  return(0);
}
