#include <math.h>
#include <stdio.h>

extern double cr2,cr3,cr4,cr6,cr12,cgp,c2gp,cgp_4,cr2gp,cgm0,crgm0;

#ifdef H
extern int na,Na,nt,nf,na1,Na1,nt1,nf1,n_at,N_at,n_af,n_tf;
extern int*icolrz;
extern int Lr;
extern double Eps_tr;
extern double*r,*z;
extern double*a,*aa,*b;
extern double*gt,*ccs,*csn;
extern double b_X,r_X,z_X0,z_X2,z_X2n,dx_X0top,dx_X0bot,t_X,
*x0sep,*x1sep,*x2sep,*X2vb,*x0cs,*x0sn,*dx0cs,*dx0sn,*X2vbc,*X2vbs;
extern double d_vb,b_vb,R0_vb,Z0_vb,*rvb,*zvb,*rvbcs,*rvbsn,*drvbcs,*drvbsn;
extern double*Dx0,*Dx2,*Ddx2,*Dz2,*Dx0c,*Dx0s,*Dx2c,*Dx2s,*Ddx2c,*Ddx2s,
*Dz2c,*Dz2s;
extern double ga0,ga1,ga2,ga3,*ga1P,*ga3P,ga1P1,ga3P1,ga1P2,ga3P2;
extern double*dra,*drgt,*dza,*dzgt;
extern double R0,Z0,*rcs,*rsn,*d1rcs,*d1rsn,*d2rcs,*d2rsn,*z0,*d1z0,*d2z0;
extern double rcs10,rsn10;
extern double*Fcs,*Fsn,*dFcs,*dFsn,*xinf,*A2m,*yinf,*d1yinf,*d2yinf,*xgt,*ygt;
extern FILE*fp,*file;
extern char*line;

init_arrays()
{
  int i,j,k;
  double t,dt;
  Na1= Na+1;
  na1= na+1;
  i= nt%4;
  if(i)nt+= 4-i;
  nt1= nt+1;
  nf= nt/2;
  nf1= nf+1;
  N_at= Na1*nt1;
  n_at= na1*nt1;
  n_af= na1*nf1;
  n_tf= nf1*nt1;
  icolrz= (int*)malloc(Na1*sizeof(int));
  if(icolrz==NULL){
    printf("Failure in memory allocation for icolrz in init_arrays\n");
    exit(0);
  }
  r= (double*)malloc((2*(N_at+9*nf1)+10*nt1)*sizeof(double));
  if(r==NULL){
    printf("Failure in memory allocation for r in init_arrays\n");
    exit(0);
  }
  z= r+N_at;
  x0sep= z+N_at;
  x1sep= x0sep+nt1;
  x2sep= x1sep+nt1;
  X2vb= x2sep+nt1;
  x0cs= X2vb+nt1;
  x0sn= x0cs+nf1;
  dx0cs= x0sn+nf1;
  dx0sn= dx0cs+nf1;
  rvb= dx0sn+nf1;
  zvb= rvb+nt1;
  rvbcs= zvb+nt1;
  rvbsn= rvbcs+nf1;
  drvbcs= rvbsn+nf1;
  drvbsn= drvbcs+nf1;
  Dx0= drvbsn+nf1;
  Dx2= Dx0+nt1;
  Ddx2= Dx2+nt1;
  Dz2= Ddx2+nt1;
  Dx0c= Dz2+nt1;
  Dx0s= Dx0c+nf1;
  Dx2c= Dx0s+nf1;
  Dx2s= Dx2c+nf1;
  Ddx2c= Dx2s+nf1;
  Ddx2s= Ddx2c+nf1;
  Dz2c= Ddx2s+nf1;
  Dz2s= Dz2c+nf1;
  X2vbc= Dz2s+nf1;
  X2vbs= X2vbc+nf1;
  dra= (double*)malloc((4*n_at)*sizeof(double));
  if(dra==NULL){
    printf("Failure in memory allocation for dra in init_arrays\n");
    exit(0);
  }
  drgt= dra+n_at;
  dza= drgt+n_at;
  dzgt= dza+n_at;
  a= (double*)malloc(3*Na1*sizeof(double));
  if(a==NULL){
    printf("Failure in memory allocation in init_arrays\n");
    exit(0);
  }
  aa= a+Na1;
  b= aa+Na1;
  gt= (double*)malloc(nt1*sizeof(double));
  if(gt==NULL){
    printf("Failure in memory allocation in init_arrays\n");
    exit(0);
  }
  ccs= (double*)malloc(2*n_tf*sizeof(double));
  if(ccs==NULL){
    printf("Failure in memory allocation for ccs in init_arrays\n");
    exit(0);
  }
  csn= ccs+n_tf;
  rcs= (double*)malloc((6*n_af+3*na1)*sizeof(double));
  if(rcs==NULL){
    printf("Failure in memory allocation for rcs in init_arrays\n");
    exit(0);
  }
  rsn= rcs+n_af;
  d1rcs= rsn+n_af;
  d2rcs= d1rcs+n_af;
  d1rsn= d2rcs+n_af;
  d2rsn= d1rsn+n_af;
  z0= d2rsn+n_af;
  d1z0= z0+na1;
  d2z0= d1z0+na1;
  Fcs= (double*)malloc((4*nf1+18*na1+2*nt1)*sizeof(double));
  if(Fcs==NULL){
    printf("Failure in memory allocation for r in init_arrays\n");
    exit(0);
  }
  Fsn= Fcs+nf1;
  dFcs= Fsn+nf1;
  dFsn= dFcs+nf1;
  A2m= dFsn+nf1;
  xinf= A2m+na1;
  yinf= xinf+4*na1;
  d1yinf= yinf+4*na1;
  d2yinf= d1yinf+4*na1;
  xgt= d2yinf+4*na1;
  ygt= xgt+nt1;
  cr3= 1./3.;
  cr6= 1./6.;
  cr12= 1./12.;
  cgp_4= atan(1.);
  cgp= 4.*cgp_4;
  c2gp= 2.*cgp;
  cr2gp= 1./c2gp;
  cgm0= 0.4*cgp;
  crgm0= 1./cgm0;
  dt= 1./nt;
  for(j= 0;j<nt1;j++){
    gt[j]= dt*j;
    i= nf1*j;
    for(k= 0;k<nf1;k++){
      t= c2gp*k*gt[j];
      ccs[k+i]= cos(t);
      csn[k+i]= sin(t);
    }
  }
  dt= 1./na;
  t= na/((double)Na);
  for(i= 0;i<Na1;i++){
    a[i]= dt*i;
    b[i]= t*a[i];
    aa[i]= a[i]*a[i];
  }
}

close_arrays()
{
  free(icolrz);
  free(r);
  free(dra);
  free(rcs);
  free(ccs);
  free(gt);
  free(a);
  free(Fcs);
}

vr2rdr()
{
  static int i,j,k,ji,ki,kj;
  static double rc,rs,drca,drct,drsa,drst;


  for(i= 0;i<na1;i++){
    A2m[i]= 2.;
    drca= 2.*a[i]*rcs[i]+aa[i]*d1rcs[i];
    rc= aa[i]*rcs[i];
    for(j= 0,ji= nt1*i;j<nt1;j++,ji++){
      r[ji]= R0+rc;
      dra[ji]= drca;
      drgt[ji]= 0;
    }
  }

  Lr= 1;
  for(i= 1;i<na1;i++)
    xinf[i]= Eps_tr*a[i]*fabs(rcs[na1+i]);

  for(k= 1;k<nf1;k++){
    ki= k*na1;
    if(k==1){
      i= 0;
      rc= 2.*rcs[ki+i];
      rs= 2.*rsn[ki+i];
      rcs10= rc;
      rsn10= rs;
      for(j= 0,kj= k;j<nt1;j++,kj+= nf1){
	dra[j]+= rc*ccs[kj]+rs*csn[kj];
	drgt[j]+= rs*ccs[kj]-rc*csn[kj];
      }
    }
    for(i= 1;i<na1;i++){
      rc= A2m[i]*rcs[ki+i];
      rs= A2m[i]*rsn[ki+i];
      if(Lr<k&&(fabs(rc)>xinf[i]||fabs(rs)>xinf[i]))
	Lr= k;
      drct= k*rc;
      drst= k*rs;
      rc*= a[i];
      rs*= a[i];
      A2m[i]*= a[i];
      drca= drct+A2m[i]*d1rcs[ki+i];
      drsa= drst+A2m[i]*d1rsn[ki+i];
      for(j= 0,ji= nt1*i,kj= k;j<nt1;j++,ji++,kj+= nf1){
	r[ji]+= rc*ccs[kj]+rs*csn[kj];
	dra[ji]+= drca*ccs[kj]+drsa*csn[kj];
	drgt[ji]+= drst*ccs[kj]-drct*csn[kj];
      }
    }
  }
  Lr+= 2;
  return;
}

vz2zdz()
{
  int i,j,k,ji,ki,kj;
  double b0,b1,s,df;
  b0= b[na];
  for(i= 0;i<na1;i++){
    b1= b[i];
    s= Z0+aa[i]*z0[i];
    df= 2.*a[i]*z0[i]+aa[i]*d1z0[i];
    for(j= 0,ji= nt1*i,kj= 1;j<nt1;j++,ji++,kj+= nf1){
      z[ji]= s+b1*csn[kj];
      dza[ji]= df+b0*csn[kj];
      dzgt[ji]= b0*ccs[kj];
    }
  }
  return;
}

four_s(gc,gs,m,g,d2g,x,n)
     double gc[],gs[],g[],d2g[],x[];
     int*m,*n;
{
  int i,ii,k,kk;
  double h,rh,cs,sn,t;
  double dg1,dg2,d3g,gg,rg;
  double*fcs,*fsn;
  i= (*m)+1;
  fcs= (double*)malloc(2*i*sizeof(double));
  if(fcs==NULL){
    printf("Failure in memory allocation in four_s\n");
    exit(0);
  }
  fsn= fcs+i;
  k= *m;
  t= c2gp*x[0];
  cs= cos(t);
  sn= sin(t);
  t*= (double)k;
  fcs[k]= cos(t);
  fsn[k]= sin(t);
  gc[k]= 0.;
  gs[k]= 0.;
  for(kk= k,k--;k>=0;k--,kk--){
    gc[k]= 0.;
    gs[k]= 0.;
    fcs[k]= fcs[kk]*cs+fsn[kk]*sn;
    fsn[k]= fsn[kk]*cs-fcs[kk]*sn;
  }
  h= x[1]-x[0];
  dg2= (g[1]-g[0])/h-(d2g[1]+2.*d2g[0])*h*cr6;

  for(i= 0,ii= 1;i<(*n);i++,ii++){
    h= x[ii]-x[i];
    rh= 1./h;
    dg1= dg2;
    dg2= (g[ii]-g[i])*rh+(2.*d2g[ii]+d2g[i])*h*cr6;
    d3g= (d2g[ii]-d2g[i])*rh;
    for(k= 1;k<=(*m);k++){
      gg= c2gp*(double)k;
      rg= 1./gg;
      gc[k]-= (g[i]*fsn[k]+(dg1*fcs[k]-(d2g[i]*fsn[k]
					+d3g*fcs[k]*rg)*rg)*rg)*rg;
      gs[k]-= (-g[i]*fcs[k]+(dg1*fsn[k]+(d2g[i]*fcs[k]
					 -d3g*fsn[k]*rg)*rg)*rg)*rg;
    }
    k= *m;
    t= c2gp*x[ii];
    cs= cos(t);
    sn= sin(t);
    t*= (double)k;
    fcs[k]= cos(t);
    fsn[k]= sin(t);
    for(kk= k,k--;k>=0;k--,kk--){
      fcs[k]= fcs[kk]*cs+fsn[kk]*sn;
      fsn[k]= fsn[kk]*cs-fcs[kk]*sn;
    }
    gc[0]+= (g[ii]+(-0.5*dg2+cr6*(d2g[ii]-0.25*d3g*h)*h)*h)*h;
    for(k= 1;k<=*m;k++){
      gg= c2gp*(double)k;
      rg= 1./gg;
      gc[k]+= (g[ii]*fsn[k]+(dg2*fcs[k]-(d2g[ii]*fsn[k]
					 +d3g*fcs[k]*rg)*rg)*rg)*rg;
      gs[k]+= (-g[ii]*fcs[k]+(dg2*fsn[k]+(d2g[ii]*fcs[k]
					  -d3g*fsn[k]*rg)*rg)*rg)*rg;
    }
  }
  free(fcs);
  return;
}

four(gc,gs,g)
     double gc[],gs[],g[];
{
  int j,kj,k;
  double h;
  for(k= 0;k<nf1;k++){
    gc[k]= 0.;
    gs[k]= 0.;
  }
  for(j= 0;j<nt;j++){
    kj= nf1*j;
    gc[0]+= g[j]*ccs[kj];
    for(k= 1;k<nf1;k++){
      gc[k]+= g[j]*ccs[k+kj];
      gs[k]+= g[j]*csn[k+kj];
    }
  }
  h= 1./(double)nt;
  gc[0]*= h;
  for(k= 1;k<nf;k++){
    gc[k]*= h;
    gs[k]*= h;
  }
  gc[k]*= cr2*h;
  return;
}

#endif
