#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int SVDcmp(int m,int n,double **a,double **v,double *w,double *rv1)
{
  int i,j,jj,k,l,its,nm;
  double c,f,g,h,s,x,y,z,scale,anorm,aa,ab;

  g	=0.;
  scale	=0.;
  anorm	=0.;
  for(i=0; i < n; i++){
    l	=i+1;
    rv1[i]=scale*g;
    g	=0.0;
    s	=0.0;
    scale=0.0;
    if(i < m){
      for(k=i; k < m; k++){
	scale	+=fabs(a[k][i]);
      }
      if(scale != 0.){
	h	=1./scale;
	for(k=i; k < m; k++){
	  a[k][i]	*=h;
	  s	+=a[k][i]*a[k][i];
	}
	f	=a[i][i];
	g	=f < 0. ? sqrt(s) : -sqrt(s);
	h	=f*g-s;
	a[i][i]	=f-g;
	if(i != n-1){
	  for(j=l; j < n; j++){
	    s	=0.0;
	    for(k=i; k < m; k++){
	      s	+=a[k][i]*a[k][j];
	    }
	    f	=s/h;
	    for(k=i; k < m; k++){
	      a[k][j]	+=f*a[k][i];
	    }
	  }
	}
	for(k=i; k < m; k++){
	  a[k][i]	*=scale;
	}
      }
    }
    w[i]	=scale*g;
    g	=0.;
    s	=0.;
    scale=0.;
    if(i < m && i != n-1){
      for(k=l; k < n; k++){
	scale	+=fabs(a[i][k]);
      }
      if(scale != 0.){
	h	=1./scale;
	for(k=l; k < n; k++){
	  a[i][k]	*=h;
	  s	+=a[i][k]*a[i][k];
	}
	f	=a[i][l];
	g	=f < 0. ? sqrt(s) : -sqrt(s);
	h	=1./(f*g-s);
	a[i][l]	=f-g;
	for(k=l; k < n; k++){
	  rv1[k]	=a[i][k]*h;
	}
	if(i != m-1){
	  for(j=l; j < m; j++){
	    s	=0.;
	    for(k=l; k < n; k++){
	      s	+=a[j][k]*a[i][k];
	    }
	    for(k=l; k < n; k++){
	      a[j][k]	+=s*rv1[k];
	    }
	  }
	}	
	for(k=l; k < n; k++){
	  a[i][k]	*=scale;
	}
      }
    }
    s	=fabs(w[i])+fabs(rv1[i]);
    anorm	=anorm > s ? anorm : s;
  }
  i	=n;
  while(i){
    i--;
    if(i < n-1){
      if (g != 0.){
	for(j=l; j < n; j++){
	  v[j][i]=a[i][j]/(a[i][l]*g);
	}
	for(j=l; j < n; j++){
	  s	=0.0;
	  for(k=l; k < n; k++){
	    s	+=a[i][k]*v[k][j];
	  }
	  for(k=l; k < n; k++){
	    v[k][j]	+=s*v[k][i];
	  }
	}
      }
      for(j=l; j < n; j++){
	v[j][i]	=0.;
	v[i][j]	=0.;
      }
    }
    v[i][i]	=1.;
    g	=rv1[i];
    l	=i;
  }
  i	=n;
  while(i){
    i--;
    l	=i+1;
    g	=w[i];
    if(i < n-1){
      for(j=l; j < n; j++){
	a[i][j]	=0.;
      }
    }
    if (g != 0.){
      g	=1./g;
      if(i != n-1){
	for(j=l; j < n; j++){
	  s	=0.;
	  for(k=l; k < m; k++){
	    s	+=a[k][i]*a[k][j];
	  }
	  f	=s*g/a[i][i];
	  for(k=i; k < m; k++){
	    a[k][j]	+=f*a[k][i];
	  }
	}
      }
      for(j=i; j < m; j++){
	a[j][i]	*=g;
      }
    }
    else{
      for(j=i; j < m; j++){
	a[j][i]	=0.;
      }
    }
    a[i][i]	+=1.;
  }

  k	=n;
  while(k){
    k--;
    for(its=0; its < 50; its++){
      l	=k+1;
      while(l){
	l--;
	nm	=l-1;
	if(fabs(rv1[l])+anorm == anorm){
	  break;
	}
	if(fabs(w[nm])+anorm == anorm){
	  c	=0.0;
	  s	=1.0;
	  for(i=l; i <= k; i++){
	    f	=s*rv1[i];
	    if(fabs(f)+anorm != anorm){
	      g	=w[i];
	      aa	=fabs(f);
	      ab	=fabs(g);
	      if(aa > ab){
		ab	/=aa;
		h	=aa*sqrt(1.+ab*ab);
	      }
	      else{
		if(ab  == 0.){
		  h	=0.;
		}
		else{
		  aa	/=ab;
		  h	=ab*sqrt(1.+aa*aa);
		}
	      }
	      w[i]	=h;
	      h	=1./h;
	      c	=g*h;
	      s	=-f*h;
	      for(j=0; j < m; j++){
		y	=a[j][nm];
		z	=a[j][i];
		a[j][nm]	=y*c+z*s;
		a[j][i]	=z*c-y*s;
	      }
	    }
	  }
	  break;
	}
      }
      z	=w[k];
      if(l == k){
	if(z < 0.){
	  w[k]	=-z;
	  for(j=0; j < n; j++){
	    v[j][k]	=-v[j][k];
	  }
	}
	break;
      }
      /*
	 if (its.eq.50) pause 'no convergence in 50 iterations'
	 */

      x	=w[l];
      nm=k-1;
      y	=w[nm];
      g	=rv1[nm];
      h	=rv1[k];
      f	=((y-z)*(y+z)+(g-h)*(g+h))/(2.*h*y);
      aa	=fabs(f);
      if(aa > 1.){
	ab	=1./aa;
	g	=aa*sqrt(1.+ab*ab);
      }
      else{
	g	=sqrt(1.+aa*aa);
      }
      if(f < 0.){
	g	=-g;
      }
      f	=((x-z)*(x+z)+h*(y/(f+g)-h))/x;
      c	=1.;
      s	=1.;
      nm++;
      for(j=l; j < nm; j++){
	i	=j+1;
	g	=rv1[i];
	y	=w[i];
	h	=s*g;
	g	=c*g;
	aa	=fabs(f);
	ab	=fabs(h);
	if(aa > ab){
	  ab	/=aa;
	  z	=aa*sqrt(1.+ab*ab);
	}
	else{
	  if(ab  == 0.){
	    z	=0.;
	  }
	  else{
	    aa	/=ab;
	    z	=ab*sqrt(1.+aa*aa);
	  }
	}
	rv1[j]	=z;
	c	=f/z;
	s	=h/z;
	f	=x*c+g*s;
	g	=g*c-x*s;
	h	=y*s;
	y	=y*c;
	for(jj=0; jj < n; jj++){
	  x	=v[jj][j];
	  z	=v[jj][i];
	  v[jj][j]	=x*c+z*s;
	  v[jj][i]	=z*c-x*s;
	}
	aa	=fabs(f);
	ab	=fabs(h);
	if(aa > ab){
	  ab	/=aa;
	  z	=aa*sqrt(1.+ab*ab);
	}
	else{
	  if(ab  == 0.){
	    z	=0.;
	  }
	  else{
	    aa	/=ab;
	    z	=ab*sqrt(1.+aa*aa);
	  }
	}
	w[j]	=z;
	if(z != 0.){
	  z	=1./z;
	  c	=f*z;
	  s	=h*z;
	}	  
	f	=c*g+s*y;
	x	=c*y-s*g;
	for(jj=0; jj < m; jj++){
	  y	=a[jj][j];
	  z	=a[jj][i];
	  a[jj][j]	=y*c+z*s;
	  a[jj][i]	=z*c-y*s;
	}
      }
      rv1[l]	=0.;
      rv1[k]	=f;
      w[k]	=x;
    }
  }
  return(0);
}

int SVDbksb(int m,int n,double **u,double **v,double *w,double *b,double *x
	    ,double *tmp)
{     
  int i,j;
  double s;

  for(j=0; j < n; j++){
    s	=0.;
    if(w[j] != 0.){
      for(i=0; i < m; i++) s+=u[i][j]*b[i];
      s	=s/w[j];
    }
    tmp[j]=s;
  }
  for(j=0; j < n; j++){
    s	=0.;
    for(i=0; i < n; i++) s+=v[j][i]*tmp[i];
    x[j]	=s;
  }
  return(0);
}

int SVDbksbC(int m,int n,double **u,double **v,double *w,double *b,double *x
	    ,double *tmp,double Emin)
{     
  int i,j;
  double s;

  for(j=0; j < n; j++){
    s	=0.;
    if(w[j] > Emin){
      for(i=0; i < m; i++) s+=u[i][j]*b[i];
      s	=s/w[j];
    }
    tmp[j]=s;
  }
  for(j=0; j < n; j++){
    s	=0.;
    for(i=0; i < n; i++) s+=v[j][i]*tmp[i];
    x[j]	=s;
  }
  return(0);
}

int SVDsort(int n,double *ra)
{
  int i,j,k,kk;
  double rra;

  kk	=n-1;
  k	=n>>1;
  /* Heap ordering */
  while(k){
    k--;
    rra	=ra[k];
    i	=k;
    j	=k+k+1;
    while(j < n){
      if(j < kk && ra[j] < ra[j+1]){
	j++;
      }
      if(rra < ra[j]){
	ra[i]	=ra[j];
	i	=j;
	j	+=j+1;
      }
      else{
	break;
      }
    }
    ra[i]=rra;
  }

  /* Sorting the heap */
  k	=n-1;
  while(k){
    kk	=k-1;
    rra	=ra[k];
    ra[k]	=ra[0];
    i	=0;
    j	=1;
    while(j < k){
      if(j < kk && ra[j] < ra[j+1]){
	j++;
      }
      if(rra < ra[j]){
	ra[i]	=ra[j];
	i	=j;
	j	+=j+1;
      }
      else{
	break;
      }
    }
    ra[i]	=rra;
    k--;
  }
  return(0);
}

int SVDsortR(int n,double *ra)
{
  int i,j,k,kk;
  double rra;

  kk	=n-1;
  k	=n>>1;
  /* Heap ordering */
  while(k){
    k--;
    rra	=ra[k];
    i	=k;
    j	=k+k+1;
    while(j < n){
      if(j < kk && ra[j] > ra[j+1]){
	j++;
      }
      if(rra > ra[j]){
	ra[i]	=ra[j];
	i	=j;
	j	+=j+1;
      }
      else{
	break;
      }
    }
    ra[i]=rra;
  }
  /* Sorting the heap */
  k	=n-1;
  while(k){
    kk	=k-1;
    rra	=ra[k];
    ra[k]	=ra[0];
    i	=0;
    j	=1;
    while(j < k){
      if(j < kk && ra[j] > ra[j+1]){
	j++;
      }
      if(rra > ra[j]){
	ra[i]	=ra[j];
	i	=j;
	j	+=j+1;
      }
      else{
	break;
      }
    }
    ra[i]	=rra;
    k--;
  }
  return(0);
}

int SVDsortR2I(int n,int *ind,double *ra)
{
  int i,j,k,kk,ii;
  double rra;

  for(i=0; i < n; i++) ind[i]=i;

  kk	=n-1;
  k	=n>>1;
  /* Heap ordering */
  while(k){
    k--;
    rra	=ra[k];
    ii	=ind[k];
    i	=k;
    j	=k+k+1;
    while(j < n){
      if(j < kk && ra[j] > ra[j+1]) j++;
      if(rra > ra[j]){
	ra[i]	=ra[j];
	ind[i]	=ind[j];
	i	=j;
	j	+=j+1;
      }
      else{
	break;
      }
    }
    ra[i]=rra;
    ind[i]	=ii;
  }

  /* Sorting the heap */
  k	=n-1;
  while(k){
    kk	=k-1;
    rra	=ra[k];
    ii	=ind[k];
    ra[k]	=ra[0];
    ind[k]	=ind[0];

    i	=0;
    j	=1;
    while(j < k){
      if(j < kk && ra[j] > ra[j+1]) j++;
      if(rra > ra[j]){
	ra[i]	=ra[j];
	ind[i]	=ind[j];
	i	=j;
	j	+=j+1;
      }
      else{
	break;
      }
    }
    ra[i]	=rra;
    ind[i]	=ii;
    k--;
  }
  return(0);
}

int SVDsortI2I(int n,int *ind,int *ra)
{
  int i,j,k,kk,ii;
  int rra;

  for(i=0; i < n; i++) ind[i]=i;

  kk	=n-1;
  k	=n>>1;
  /* Heap ordering */
  while(k){
    k--;
    rra	=ra[k];
    ii	=ind[k];
    i	=k;
    j	=k+k+1;
    while(j < n){
      if(j < kk && ra[j] > ra[j+1]) j++;
      if(rra > ra[j]){
	ra[i]	=ra[j];
	ind[i]	=ind[j];
	i	=j;
	j	+=j+1;
      }
      else{
	break;
      }
    }
    ra[i]=rra;
    ind[i]	=ii;
  }
  /* Sorting the heap */
  k	=n-1;
  while(k){
    kk	=k-1;
    rra	=ra[k];
    ii	=ind[k];
    ra[k]=ra[0];
    ind[k]=ind[0];

    i	=0;
    j	=1;
    while(j < k){
      if(j < kk && ra[j] > ra[j+1]) j++;
      if(rra > ra[j]){
	ra[i]	=ra[j];
	ind[i]	=ind[j];
	i	=j;
	j	+=j+1;
      }
      else{
	break;
      }
    }
    ra[i]	=rra;
    ind[i]	=ii;
    k--;
  }
  return(0);
}

/* calculates indexes without reshuffling T[]*/
int HeapSortR2I(int n,int *ind,double *T)
{
  int i,j,k,kk;
  double lc,lt,lq;
  int ka;

  if(n < 2) return(0);
  kk	=n-1;
  k	=n>>1;
  /* Heap ordering */
  while(k){
    k--;
    lc	=T[ind[k]];

    ka	=k;
    i	=k;
    j	=k+k+1;
    while(j < n){
      if(j < kk){
	lt	=T[ind[j]];
	lq	=T[ind[j+1]];
	if(lt < lq) j++;
      }
      lt	=T[ind[j]];
      lq	=lc;
      if(lq < lt){
	ind[i]	=ind[j];
	i	=j;
	j	+=j+1;
      }
      else{
	break;
      }
    }
    ind[i]=ka;
  }

  /* Sorting the heap */
  k	=n-1;
  while(k){
    kk	=k-1;
    ka	=ind[k];
    lc	=T[ind[k]];
    ind[k]=ind[0];
    i	=0;
    j	=1;
    while(j < k){
      if(j < kk){
	lt	=T[ind[j]];
	lq	=T[ind[j+1]];
	if(lt < lq) j++;
      }
      lt	=T[ind[j]];
      lq	=lc;
      if(lq < lt){
	ind[i]	=ind[j];
	i	=j;
	j	+=j+1;
      }
      else{
	break;
      }
    }
    ind[i]=ka;
    k--;
  }
  return(0);
}
    
int Mmain00000()
{
  int nth=300,nmax=100,nmax1=nmax+1;
  double th[nth];
  double a[nth][nmax1],wsvd[nmax1],vsvd[nmax1][nmax1],wsvdc[nmax1],rv[nmax1];
  double *ld;
  double fvec[nth],sol[nmax1];
  int i,j;
  double pi,dth,cutoff,wmin,wmax;
  double s;
  double *A[nth],*V[nmax1];

  pi	=4.*atan(1.);
  dth	=2.*pi/(nth-1);
  for(i=0; i < nth; i++){
    th[i]=i*dth;
  }
  /*  set up the function (fvec(th)) whose cosine transform is desired */

  for(i=0; i < nth; i++){
    fvec[i]=4.*cos(th[i]+0.*sin(th[i]))*cos(th[i]);
  }
  for(i=0; i < nth; i++){
    for(j=0; j < nmax1; j++){
      a[i][j]=cos(j*th[i]);
    }
    A[i]	=a[i];
  }
  for(i=0; i < nmax1; i++){
    V[i]	=vsvd[i];
  }

  for(i=0; i < nth; i++){
    a[i][4]=cos(2.*th[i]+0.0001*sin(th[i]));
    a[i][12]=cos(2.*th[i]+0.001*sin(th[i]));
    a[i][18]=cos(2.*th[i]+0.00011*sin(th[i]));
    a[i][30]=cos(2.*th[i]+0.00101*sin(th[i]));
  }
  printf("entering SVDcmp\n");

  SVDcmp(nth,nmax1,A,V,wsvd,rv);

  printf("exiting svdcmp\n");
  for(i=0; i < nmax1; i++){
    printf("%12.5e",wsvd[i]);
    if((i+1)%6 == 0){
      putchar('\n');
    }
  }
  putchar('\n');

  /* find max singular value, scale the values to this max, and
     output the values in decreasing order */
  wmax=0.;
  for(j=0; j < nmax1; j++){
    if(wmax < wsvd[j]){
      wmax	=wsvd[j];
    }
  }
  wmin	=1./wmax;
  for(j=0; j < nmax1; j++){
    wsvdc[j]	=wsvd[j]*wmin;
  }
  SVDsort(nmax1,wsvdc);
  printf("singular values, sorted and scaled to the max:\n");
  i	=nmax1;
  while(i > 0){
    i--;
    printf("%12.5e",wsvdc[i]);
    if(i%6 == 0){
      putchar('\n');
    }
  }
  putchar('\n');
  /* decide on cut-off for singular values, and zero values less
     than the cut-off */
  printf("enter singular value cut-off->");
  fflush(stdout);
  scanf("%lg",&cutoff);
  wmin=wmax*cutoff;
  for(j=0; j < nmax1; j++){
    wsvdc[j]=wsvd[j];
    if(wsvd[j] < wmin){
      wsvdc[j]	=0.;
    }
  }
  /* now back-substitute to get dipole strengths */

  SVDbksb(nth,nmax1,A,V,wsvdc,fvec,sol,rv);


  /* print solution (the fourier coefficients) */

  printf("solution\n");
  for(i=0; i < nmax1; i++){
    printf("%12.5e",sol[i]);
    if((i+1)%6 == 0){
      putchar('\n');
    }
  }
  putchar('\n');
  return(0);
}

int SVDcmpAA(int m,int n,double **a,double **v,double *w,double *rv1)
{
  int i,j,jj,k,l,its,nm;
  double c,f,g,h,s,x,y,z,scale,anorm,aa,ab;

  g	=0.;
  scale	=0.;
  anorm	=0.;
  for(i=0; i < n; i++){
    l	=i+1;
    rv1[i]=scale*g;
    g	=0.0;
    s	=0.0;
    scale=0.0;
    if(i < m){
      for(k=i; k < m; k++){
	scale	+=fabs(a[k][i]);
      }
      if(scale != 0.){
	h	=1./scale;
	for(k=i; k < m; k++){
	  a[k][i]	*=h;
	  s	+=a[k][i]*a[k][i];
	}
	f	=a[i][i];
	g	=f < 0. ? sqrt(s) : -sqrt(s);
	h	=f*g-s;
	a[i][i]	=f-g;
	if(i != n-1){
	  for(j=l; j < n; j++){
	    s	=0.0;
	    for(k=i; k < m; k++){
	      s	+=a[k][i]*a[k][j];
	    }
	    f	=s/h;
	    for(k=i; k < m; k++){
	      a[k][j]	+=f*a[k][i];
	    }
	  }
	}
	for(k=i; k < m; k++){
	  a[k][i]	*=scale;
	}
      }
    }
    w[i]	=scale*g;
    g	=0.;
    s	=0.;
    scale=0.;
    if(i < m && i != n-1){
      for(k=l; k < n; k++){
	scale	+=fabs(a[i][k]);
      }
      if(scale != 0.){
	h	=1./scale;
	for(k=l; k < n; k++){
	  a[i][k]	*=h;
	  s	+=a[i][k]*a[i][k];
	}
	f	=a[i][l];
	g	=f < 0. ? sqrt(s) : -sqrt(s);
	h	=1./(f*g-s);
	a[i][l]	=f-g;
	for(k=l; k < n; k++){
	  rv1[k]	=a[i][k]*h;
	}
	if(i != m-1){
	  for(j=l; j < m; j++){
	    s	=0.;
	    for(k=l; k < n; k++){
	      s	+=a[j][k]*a[i][k];
	    }
	    for(k=l; k < n; k++){
	      a[j][k]	+=s*rv1[k];
	    }
	  }
	}	
	for(k=l; k < n; k++){
	  a[i][k]	*=scale;
	}
      }
    }
    s	=fabs(w[i])+fabs(rv1[i]);
    anorm	=anorm > s ? anorm : s;
  }
  i	=n;
  while(i){
    i--;
    if(i < n-1){
      if (g != 0.){
	for(j=l; j < n; j++){
	  v[j][i]=a[i][j]/(a[i][l]*g);
	}
	for(j=l; j < n; j++){
	  s	=0.0;
	  for(k=l; k < n; k++){
	    s	+=a[i][k]*v[k][j];
	  }
	  for(k=l; k < n; k++){
	    v[k][j]	+=s*v[k][i];
	  }
	}
      }
      for(j=l; j < n; j++){
	v[j][i]	=0.;
	v[i][j]	=0.;
      }
    }
    v[i][i]	=1.;
    g	=rv1[i];
    l	=i;
  }
  i	=n;
  while(i){
    i--;
    l	=i+1;
    g	=w[i];
    if(i < n-1){
      for(j=l; j < n; j++){
	a[i][j]	=0.;
      }
    }
    if (g != 0.){
      g	=1./g;
      if(i != n-1){
	for(j=l; j < n; j++){
	  s	=0.;
	  for(k=l; k < m; k++){
	    s	+=a[k][i]*a[k][j];
	  }
	  f	=s*g/a[i][i];
	  for(k=i; k < m; k++){
	    a[k][j]	+=f*a[k][i];
	  }
	}
      }
      for(j=i; j < m; j++){
	a[j][i]	*=g;
      }
    }
    else{
      for(j=i; j < m; j++){
	a[j][i]	=0.;
      }
    }
    a[i][i]	+=1.;
  }

  k	=n;
  while(k){
    k--;
    for(its=0; its < 50; its++){
      l	=k+1;
      while(l){
	l--;
	nm	=l-1;
	if(fabs(rv1[l])+anorm == anorm){
	  break;
	}
	if(fabs(w[nm])+anorm == anorm){
	  c	=0.0;
	  s	=1.0;
	  for(i=l; i <= k; i++){
	    f	=s*rv1[i];
	    if(fabs(f)+anorm != anorm){
	      g	=w[i];
	      aa	=fabs(f);
	      ab	=fabs(g);
	      if(aa > ab){
		ab	/=aa;
		h	=aa*sqrt(1.+ab*ab);
	      }
	      else{
		if(ab  == 0.){
		  h	=0.;
		}
		else{
		  aa	/=ab;
		  h	=ab*sqrt(1.+aa*aa);
		}
	      }
	      w[i]	=h;
	      h	=1./h;
	      c	=g*h;
	      s	=-f*h;
	      for(j=0; j < m; j++){
		y	=a[j][nm];
		z	=a[j][i];
		a[j][nm]	=y*c+z*s;
		a[j][i]	=z*c-y*s;
	      }
	    }
	  }
	  break;
	}
      }
      z	=w[k];
      if(l == k){
	if(z < 0.){
	  w[k]	=-z;
	  for(j=0; j < n; j++){
	    v[j][k]	=-v[j][k];
	  }
	}
	break;
      }
      /*
	 if (its.eq.50) pause 'no convergence in 50 iterations'
	 */

      x	=w[l];
      nm=k-1;
      y	=w[nm];
      g	=rv1[nm];
      h	=rv1[k];
      f	=((y-z)*(y+z)+(g-h)*(g+h))/(2.*h*y);
      aa	=fabs(f);
      if(aa > 1.){
	ab	=1./aa;
	g	=aa*sqrt(1.+ab*ab);
      }
      else{
	g	=sqrt(1.+aa*aa);
      }
      if(f < 0.){
	g	=-g;
      }
      f	=((x-z)*(x+z)+h*(y/(f+g)-h))/x;
      c	=1.;
      s	=1.;
      nm++;
      for(j=l; j < nm; j++){
	i	=j+1;
	g	=rv1[i];
	y	=w[i];
	h	=s*g;
	g	=c*g;
	aa	=fabs(f);
	ab	=fabs(h);
	if(aa > ab){
	  ab	/=aa;
	  z	=aa*sqrt(1.+ab*ab);
	}
	else{
	  if(ab  == 0.){
	    z	=0.;
	  }
	  else{
	    aa	/=ab;
	    z	=ab*sqrt(1.+aa*aa);
	  }
	}
	rv1[j]	=z;
	c	=f/z;
	s	=h/z;
	f	=x*c+g*s;
	g	=g*c-x*s;
	h	=y*s;
	y	=y*c;
	for(jj=0; jj < n; jj++){
	  x	=v[jj][j];
	  z	=v[jj][i];
	  v[jj][j]	=x*c+z*s;
	  v[jj][i]	=z*c-x*s;
	}
	aa	=fabs(f);
	ab	=fabs(h);
	if(aa > ab){
	  ab	/=aa;
	  z	=aa*sqrt(1.+ab*ab);
	}
	else{
	  if(ab  == 0.){
	    z	=0.;
	  }
	  else{
	    aa	/=ab;
	    z	=ab*sqrt(1.+aa*aa);
	  }
	}
	w[j]	=z;
	if(z != 0.){
	  z	=1./z;
	  c	=f*z;
	  s	=h*z;
	}	  
	f	=c*g+s*y;
	x	=c*y-s*g;
	for(jj=0; jj < m; jj++){
	  y	=a[jj][j];
	  z	=a[jj][i];
	  a[jj][j]	=y*c+z*s;
	  a[jj][i]	=z*c-y*s;
	}
      }
      rv1[l]	=0.;
      rv1[k]	=f;
      w[k]	=x;
    }
  }
  return(0);
}
