#ifndef Blb_mf.c
#ifdef Doc_mf.c
		   Magnetic field calculations

			L.Zakharov
		       Version 1.00
		Thu Jan 29 11:27:06 EST 1998

#endif

#ifndef mzl_System_mf.c /* --------------- Use of Variables --------{ */
#ifdef Tbl_UnusedID/* ------------- List of Unused variables ------{ */
  double ELEE();		/*                 .ELKE<MF:mf.c */
  double ELKK();		/*                 .ELKE<MF:mf.c */
  double *gYR;			/* .SourceGradOfgY().MFF<MF:mf.c */
  double *gYZ;			/* .SourceGradOfgY().MFF<MF:mf.c */
  void gYRingDipole();		/*                  .MFF<MF:mf.c */
  void MFRingDipole();		/*                  .MFF<MF:mf.c */
  int gYdYd2Yd3YWnd();		/*                  .MFF<MF:mf.c */
  void gYdY();			/*                  .MFF<MF:mf.c */
  double GPring();		/*                  .MFF<MF:mf.c */
  double gYRing();		/*                  .MFF<MF:mf.c */
  double gYCoil();		/*                  .MFF<MF:mf.c */
  void EFring();		/*                  .MFF<MF:mf.c */
  void MFwinding();		/*                  .MFF<MF:mf.c */
  int gYdYWnd();		/*                  .MFF<MF:mf.c */
  double BTring();		/*                  .MFF<MF:mf.c */
  double BNring();		/*                  .MFF<MF:mf.c */
  void BTNring();		/*                  .MFF<MF:mf.c */
  void Lik();			/*                  .GRN<MF:mf.c */
  int BioSavartABatXYZ();	/*                      <MF:mf.c */
  int BioSavartBatXYZ();	/*                      <MF:mf.c */
  int BioSavartB();		/*                      <MF:mf.c */
#endif /* }=== End of List of Unused variables ======*/
#ifndef H/* ---------- Used External Variables ------{ */
  Systm log();
  Systm sqrt();
  Systm printf();
  Systm fabs();
  Undef gYrR;	/* undefined */
  Undef gYrZ;	/* undefined */
  Undef gYzR;	/* undefined */
  Undef gYzZ;	/* undefined */
  Undef BrR;	/* undefined */
  Undef BrZ;	/* undefined */
  Undef BzR;	/* undefined */
  Undef BzZ;	/* undefined */
#ifdef Tbl_MF
  Undef gYrR;	/* undefined */
  Undef gYrZ;	/* undefined */
  Undef gYzR;	/* undefined */
  Undef gYzZ;	/* undefined */
  Undef BrR;	/* undefined */
  Undef BrZ;	/* undefined */
  Undef BzR;	/* undefined */
  Undef BzZ;	/* undefined */
#endif
#endif /* }======== End of Used External Variables ======= */

#endif /* }======== End of Use of Variables ======== */


#ifndef mzl_MF

#ifndef stg_ELKE
#ifdef Doc_ELKE
\section{Elliptic Integrals}
\bqbl
&&
{dK(\sqrt{1-t})\over dt}
=
-{1\over2\sqrt{1-t}}K'
=
{1\over2(1-t)}\left(K-{E\over t}\right)
,\quad
K'
=
{K\over2(1-t)}
-{E\over2t(1-t)}
,\\&&
{dE(\sqrt{1-t})\over dt}
=
-{1\over2\sqrt{1-t}}E'
=
-{E-K\over2(1-t)}
,\quad
E'
=
{K\over2(1-t)}
-{E\over2(1-t)}
,\\&&
\left[{1+t\over2}K-E\right]'
=
{1\over2}K
+{1+t\over2}K'
-E'
=
{1\over4}K
-{E\over4t}
,\\&&
\left[K-{1+t\over2t}E\right]'
=
-{K\over4t}
+{1\over2t^2}E
-{1\over4t}E
,\\&&
K'
=
{K\over2(1-t)}
-{E\over2t(1-t)}
,\quad
E'
=
{K\over2(1-t)}
-{E\over2(1-t)}
\eqbl

Derivatives of Elliptic integrals
\bqbl
t
=
{(r-R)^2+z^2\over(r+R)^2+z^2}
=
1-{4rR\over(r+R)^2+z^2}
,\\
t'_{r}
=
4R{r^2-R^2-z^2\over\left[(r+R)^2+z^2\right]^2}
,\quad
t'_R
=
4r\R{R^2-r^2-z^2}{[(r+R)^2+z^2]^2}
,\\
t'_{z}
=
8rR{z\over\left[(r+R)^2+z^2\right]^2}
,\quad
t'_Z
=
-t'_z
,\\
K'_r
=
{r^2-R^2-z^2\over(r+R)^2+z^2}{K\over2r}
-{r^2-R^2-z^2\over(r-R)^2+z^2}{E\over2r}
,\\
K'_R
=
\left({K\over2(1-t)}
-{E\over2t(1-t)}\right)\R{dt}{dR}
,\quad
E'
=
{K\over2(1-t)}
-{E\over2(1-t)}
,\\
{r^2-R^2-z^2\over(r+R)^2+z^2}{K\over2r}
-{r^2-R^2-z^2\over(r-R)^2+z^2}{E\over2r}
,\\
E'_r
=
{r^2-R^2-z^2\over(r+R)^2+z^2}{K\over2r}
-{r^2-R^2-z^2\over(r+R)^2+z^2}{E\over2r}
,\\
K'_r-E'_r
=
-2R{r^2-R^2-z^2\over[(r-R)^2+z^2][(r+R)^2+z^2]}E
,\\
K'_z
=
{z\over(r+R)^2+z^2}K
-{z\over(r-R)^2+z^2}E
,\\
E'_z
=
{z\over(r+R)^2+z^2}K
-{z\over(r+R)^2+z^2}E
,\\
K'_z-E'_z
=
-{4rR\over(r-R)^2+z^2}{z\over(r+R)^2+z^2}E
.\eqbl
#endif

double ELE(t)
  double t;	/* 1-k^2 */
{
/*
   ELE(1-k^2)=E(k) - Old Algol version of elliptic integral
  */
#ifdef Doc_ELE
\Section{Skeleton of \c{ELE()}}
  \begin{verbatim}
    ELE(){
    }
  \end{verbatim}
\Section{\c{ELE()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{double }&\c{t}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

double ELK(t)
  double t;	/* 1-k^2 */
{
/*
   ELK(1-k^2)=K(k) - Old Algol version of elliptic integral
   */
#ifdef Doc_ELK
\Section{Skeleton of \c{ELK()}}
  \begin{verbatim}
    ELK(){
    }
  \end{verbatim}
\Section{\c{ELK()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{double }&\c{t}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

double ELEE(t)
  double t;	/* 1-k^2 */
{
/*
   ELEE(1-k^2)=E(k) - BESM-6 version of elliptic integral
   */
#ifdef Doc_ELEE
\Section{Skeleton of \c{ELEE()}}
  \begin{verbatim}
    ELEE(){
    }
  \end{verbatim}
\Section{\c{ELEE()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{double }&\c{t}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

double ELKK(t)
  double t;	/* 1-k^2 */
{
/*
   ELKK(1-k^2)=K(k) - BESM-6 version of elliptic integral
   */
#ifdef Doc_ELKK
\Section{Skeleton of \c{ELKK()}}
  \begin{verbatim}
    ELKK(){
    }
  \end{verbatim}
\Section{\c{ELKK()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{double }&\c{t}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}
#endif

#ifndef stg_MFF
#ifdef Doc_MFF
\section{Magnetic flux}
\bqbl
&&
\gY
=
0.4\pi\left(
  {1+t\over2}K(\sqrt{1-t})-E(\sqrt{1-t})
 \right)\sqrt{(r+R)^2+z^2}
,\\&&
{\gY\over2\pi}
=
0.2\sqrt{(r+R)^2+z^2}\left({1+t\over2}K-E\right)
,\\&&
{\gY\over2\pi}
=
0.2\sqrt{(r+R)^2+z^2}\left(K-E-{2rR\over(r+R)^2+z^2}K\right)
,\\&&
{\gY'_{r}\over2\pi}
=
{0.2r\over\sqrt{(r+R)^2+z^2}}\left[
  K
  -{r^2-R^2+z^2\over(r-R)^2+z^2}E
 \right]
,\\&&
{\gY'_{z}\over2\pi}
=
{0.2z\over\sqrt{(r+R)^2+z^2}}\left[
  K	
  -{r^2+R^2+z^2\over(r-R)^2+z^2}E
 \right]
=
{0.2z\over\sqrt{(r+R)^2+z^2}}\left[K-{1+t\over2t}E\right]
.\eqbl

\subsection{Second derivatives}
\bqbl
&&
{\gY''_{rr}\over2\pi}
=
{0.2\over[(r+R)^2+z^2]^{1/2}}\left(
  +{2R^2\over(r-R)^2+z^2}E
  -{4rRz^2\over[(r-R)^2+z^2]^2}E
 \right)
\\&&
+{0.2z^2\over[(r+R)^2+z^2]^{3/2}}\left(
   +K
  -E
  +{2rR\over(r-R)^2+z^2}K
 \right)
,\\&&
{\gY''_{rz}\over2\pi}
=
+{0.2rz\over[(r+R)^2+z^2]^{1/2}}\left(
  +{4R(r-R)\over[(r-R)^2+z^2]^2}E
 \right)
\\&&
+{0.2rz\over[(r+R)^2+z^2]^{3/2}}\left(
  -K
  +E
  -{2rR-2R^2\over(r-R)^2+z^2}K
  -{4R^2\over(r-R)^2+z^2}E
 \right)
,\\&&
{\gY''_{zz}\over2\pi}
=
{0.2\over[(r+R)^2+z^2]^{1/2}}\left(
  K	
  -E
  -{2rR\over(r-R)^2+z^2}E
  +{4rRz^2\over[(r-R)^2+z^2]^2}E
 \right)
\\&&
+{0.2z^2\over[(r+R)^2+z^2]^{3/2}}\left(
  +E
  -K
  -{2rR\over(r-R)^2+z^2}K
 \right)
.\eqbl

\subsection{Third derivatives}
\bqbl
&&
{\gY'''_{rrz}\over2\pi}
=
{0.2z\over[(r+R)^2+z^2]^{1/2}}\left(
  -{4R(2r+R)\over[(r-R)^2+z^2]^2}E
  +{16rRz^2\over[(r-R)^2+z^2]^3}E
 \right)
\\&&
+{0.2z\over[(r+R)^2+z^2]^{3/2}}\left(
  +2K
  -2E
  +{4rR+2R^2\over(r-R)^2+z^2}K
  -{4R^2\over(r-R)^2+z^2}E
 \right)
\\&&
+{0.2z^3\over[(r+R)^2+z^2]^{3/2}}\left(
  -{8rR\over[(r-R)^2+z^2]^2}K
  +{6rR\over[(r-R)^2+z^2]^2}E
 \right)
\\&&
+{0.2z^3\over[(r+R)^2+z^2]^{5/2}}\left(
  -3K
  +3E
  -{4rR\over(r-R)^2+z^2}K
  -{4rR\over(r-R)^2+z^2}E
 \right)
.\eqbl

\bqbl
&&
{\gY'''_{zzr}\over2\pi}
=
+{0.2r\over[(r+R)^2+z^2]^{1/2}}\left(
  +{4R(r-R)\over[(r-R)^2+z^2]^2}E
  -{16R(r-R)z^2\over[(r-R)^2+z^2]^3}E
 \right)
\\&&
+{0.2r\over[(r+R)^2+z^2]^{3/2}}\left(
  -K
  +E
  -{2R(r-R)\over(r-R)^2+z^2}K
  -{4R^2\over(r-R)^2+z^2}E
 \right)
\\&&
+{0.2rz^2\over[(r+R)^2+z^2]^{3/2}}\left(
  +{8R(r-R)\over[(r-R)^2+z^2]^2}K
  +{R(-6r+14R)\over[(r-R)^2+z^2]^2}E
 \right)
\\&&
+{0.2rz^2\over[(r+R)^2+z^2]^{5/2}}\left(
  +3K
  -3E
  +{4R(r-2R)\over(r-R)^2+z^2}K
  +{4R(r+4R)\over(r-R)^2+z^2}E
 \right)
.\eqbl

#endif
static double cgp04;	/*  */
#ifdef Doc_cgp04
$0.4\pi$
#endif
static double cr2;	/* 0.5 */
static double cgp;	/*  */

void SourceGradOfgY(gYR,gYZ,r,z,R,Z)
  double *gYR;	/*  */
  double *gYZ;	/*  */
  double r;	/*  */
  double z;	/*  */
  double R;	/*  */
  double Z;	/*  */
{
  Undef gYrR;
  Undef gYrZ;
  Undef gYzR;
  Undef gYzZ;
  /*
   */
#ifdef Doc_SourceGradOfgY
\Section{Skeleton of \c{SourceGradOfgY()}}
  \begin{verbatim}
    SourceGradOfgY(){
    }
  \end{verbatim}
\Section{\c{SourceGradOfgY()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{double }&\c{*gYR}&$$&\\
\c{double }&\c{*gYZ}&$$&\\
\c{double }&\c{r}&$$&\\
\c{double }&\c{z}&$$&\\
\c{double }&\c{R}&$$&\\
\c{double }&\c{Z}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsubsection{Elliptic Integrals}
\bqbl
{dK(\sqrt{1-t})\over dt}
=
{K\over2(1-t)}
-{E\over2t(1-t)}
,\quad
{dE(\sqrt{1-t})\over dt}
=
{K\over2(1-t)}
-{E\over2(1-t)}
,\\
t
=
{(r-R)^2+z^2\over(r+R)^2+z^2}
=
1-{4rR\over(r+R)^2+z^2}
,\quad
\R{1}{1-t}
=
\R{(r+R)^2+z^2}{4rR}
,\\
t'_{r}
=
4R{r^2-R^2-z^2\over\left[(r+R)^2+z^2\right]^2}
,\quad
t'_R
=
4r\R{R^2-r^2-z^2}{[(r+R)^2+z^2]^2}
,\\
t'_{z}
=
8rR{z\over\left[(r+R)^2+z^2\right]^2}
,\quad
t'_Z
=
-t'_z
.\eqbl

\Subsubsection{Magnetic flux}
\def\rR{(2rR)}
\def\ra{\over(r+R)^2+z^2}
\def\ek{K}
\def\ee{E}
\def\eke{K-E}

\def\s{0.2\sqrt{(r+R)^2+z^2}}

\bqbl
&&
{\gY\over2\pi}
=
\s\left(\eke-{\rR\ra}\ek\right)
.\eqbl

\def\rs{{0.2\over[(r+R)^2+z^2]^{1/2}}}
\def\rsa{{0.2\over[(r+R)^2+z^2]^{3/2}}}
\def\rsaa{{0.2\over[(r+R)^2+z^2]^{5/2}}}
\def\rd{\over(r-R)^2+z^2}
\def\rdd{\over[(r-R)^2+z^2]^2}
\def\rddd{\over[(r-R)^2+z^2]^3}
\def\Rr{(2R(r-R))}
\def\RR{(2R^2)}

%-------------------------------------
\bqbl
{\gY'_{r}\over2\pi}
=
\rs r\left[
  \eke
  -{\Rr\rd}\ee
 \right]
,\\
{\gY'_{z}\over2\pi}
=
\rs z\left[
  \eke
  -{\rR\rd}\ee
 \right]
.\eqbl
First derivatives with respect to source points
\bqbl
\R{\gY}{2\gp}
=
0.2\sqrt{(r+R)^2+z^2}
\left(\ek-\ee-\R{2rR}{(r+R)^2+z^2}\ek\right)
,\\
\R{\gY'_R}{2\gp}
=
\R{0.2(r+R)}{\sqrt{(r+R)^2+z^2}}
\left(\ek-\ee-\R{2rR}{(r+R)^2+z^2}\ek\right)
\\+0.2\sqrt{(r+R)^2+z^2}
\left(\ek'-\ee'-\R{2rR}{(r+R)^2+z^2}\ek'\right)t'_R
\\+0.2\sqrt{(r+R)^2+z^2}
\left(-\R{2rz^2}{(r+R)^2+z^2}+\R{2r(R^2-r^2)}{[(r+R)^2+z^2]^2}\right)\ek
,\\
\R{\gY'_Z}{2\gp}
=
-\R{\gY'_z}{2\gp}
.\eqbl

\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{gYrR}&$$&\\
\c{Undef }&\c{gYrZ}&$$&\\
\c{Undef }&\c{gYzR}&$$&\\
\c{Undef }&\c{gYzZ}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

void SourceGradOfBpol(BrR,BrZ,BzR,BzZ,r,z,R,Z)
  double *BrR;	/*  */
  double *BrZ;	/*  */
  double *BzR;	/*  */
  double *BzZ;	/*  */
  double r;	/*  */
  double z;	/*  */
  double R;	/*  */
  double Z;	/*  */
{
/*
   */
#ifdef Doc_SourceGradOfBpol
\Section{Skeleton of \c{SourceGradOfBpol()}}
  \begin{verbatim}
    SourceGradOfBpol(){
    }
  \end{verbatim}
\Section{\c{SourceGradOfBpol()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{double }&\c{*gYrR}&$$&\\
\c{double }&\c{*gYrZ}&$$&\\
\c{double }&\c{*gYzR}&$$&\\
\c{double }&\c{*gYzZ}&$$&\\
\c{double }&\c{r}&$$&\\
\c{double }&\c{z}&$$&\\
\c{double }&\c{R}&$$&\\
\c{double }&\c{Z}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsubsection{Elliptic Integrals}
\bqbl
{dK(\sqrt{1-t})\over dt}
=
{K\over2(1-t)}
-{E\over2t(1-t)}
,\quad
{dE(\sqrt{1-t})\over dt}
=
{K\over2(1-t)}
-{E\over2(1-t)}
,\\
t
=
{(r-R)^2+z^2\over(r+R)^2+z^2}
=
1-{4rR\over(r+R)^2+z^2}
,\quad
\R{1}{1-t}
=
\R{(r+R)^2+z^2}{4rR}
,\\
t'_{r}
=
4R{r^2-R^2-z^2\over\left[(r+R)^2+z^2\right]^2}
,\quad
t'_R
=
4r\R{R^2-r^2-z^2}{[(r+R)^2+z^2]^2}
,\\
t'_{z}
=
8rR{z\over\left[(r+R)^2+z^2\right]^2}
,\quad
t'_Z
=
-t'_z
.\eqbl

\Subsubsection{Magnetic flux}
\def\rR{(2rR)}
\def\ra{\over(r+R)^2+z^2}
\def\ek{K}
\def\ee{E}
\def\eke{K-E}

\def\s{0.2\sqrt{(r+R)^2+z^2}}

\bqbl
&&
{\gY\over2\pi}
=
\s\left(\eke-{\rR\ra}\ek\right)
.\eqbl

\def\rs{{0.2\over[(r+R)^2+z^2]^{1/2}}}
\def\rsa{{0.2\over[(r+R)^2+z^2]^{3/2}}}
\def\rsaa{{0.2\over[(r+R)^2+z^2]^{5/2}}}
\def\rd{\over(r-R)^2+z^2}
\def\rdd{\over[(r-R)^2+z^2]^2}
\def\rddd{\over[(r-R)^2+z^2]^3}
\def\Rr{(2R(r-R))}
\def\RR{(2R^2)}

%-------------------------------------
\bqbl
{\gY'_{r}\over2\pi}
=
\rs r\left[
  \eke
  -{\Rr\rd}\ee
 \right]
,\\
{\gY'_{z}\over2\pi}
=
\rs z\left[
  \eke
  -{\rR\rd}\ee
 \right]
.\eqbl

\Subsubsection{Second derivatives over observation point}
\bqbl
&&
{\gY''_{rr}\over2\pi}
=
\rs\left(
  +{\RR\rd}\ee
  -{2\rR z^2\rdd}\ee
 \right)
\\&&
+\rsa z^2\left(
   \eke
  +{\rR\rd}\ek
 \right)
,\\&&
{\gY''_{rz}\over2\pi}
=
+\rs rz\left(
  +{2\Rr\rdd}\ee
 \right)
\\&&
+\rsa rz\left(
  -(\eke)
  -{\Rr\rd}\ek
  -{2\RR\rd}\ee
 \right)
,\\&&
{\gY''_{zz}\over2\pi}
=
\rs\left(
  \eke
  -{\rR\rd}\ee
  +{2\rR z^2\rdd}\ee
 \right)
\\&&
+\rsa z^2\left(
  -(\eke)
  -{\rR\rd}\ek
 \right)
.\eqbl

\Subsubsection{Second mixed derivatives over observation and source points}
\bqbl
{\gY'_{r}\over2\pi}
=
{0.2\over[(r+R)^2+z^2]^{1/2}}
 r\left[
  \eke
  -{\Rr\rd}\ee
 \right]
,\\
\R{\gY''_{rR}}{2\gp}
=
\R{0.2r(r+R)}{[(r+R)^2+z^2]^{3/2}}
 \left[-\ek+\ee+\R{2R(r-R)}{(r-R)^2+z^2}\ee\right]
\\
+{0.2r\over[(r+R)^2+z^2]^{1/2}}\left[
\ek'-\ee'-\R{2R(r-R)}{(r-R)^2+z^2}\ee'\right]t'_R
\\
+{0.2r\over[(r+R)^2+z^2]^{1/2}}\left[
-\R{2r}{(r-R)^2+z^2}
+\R{4Rz^2}{[(r-R)^2+z^2]^2}
\right]\ee
,\\
{\gY''_{rZ}\over2\pi}
=
-{\gY''_{rz}\over2\pi}
,\\
{\gY'_z\over2\pi}
=
\rs z\left[
  \eke
  -{\rR\rd}\ee
 \right]
,\\
{\gY'_{zR}\over2\pi}
=
-\R{0.2z(r+R)}{[(r+R)^2+z^2]^{3/2}}\left[
  \ek-\ee
  -\R{2rR}{(r-R)^2+z^2}\ee
 \right]
\\
+\R{0.2z}{[(r+R)^2+z^2]^{1/2}}\left[
  -2r\R{r^2-R^2+z^2}{[(r-R)^2+z^2]^2}\ee
  +\left(\ek'-\ee'
  -\R{2rR}{(r-R)^2+z^2}\ee'\right)t'_R
 \right]
,\\
{\gY''_{zZ}\over2\pi}
=
-{\gY''_{zz}\over2\pi}
.\eqbl

\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{gY}&$$&\\
\c{Undef }&\c{gYr}&$$&\\
\c{Undef }&\c{gYz}&$$&\\
\c{Undef }&\c{gYrr}&$$&\\
\c{Undef }&\c{gYrz}&$$&\\
\c{Undef }&\c{gYzz}&$$&\\
\c{Undef }&\c{gYrrz}&$$&\\
\c{Undef }&\c{gYzzr}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

void gYRingDipole(gY,r,z,nR,nZ,R,Z)
  double *gY;	/*  */
  double r;	/*  */
  double z;	/*  */
  double nR;	/*  */
  double nZ;	/*  */
  double R;	/*  */
  double Z;	/*  */
{
/*
   */
#ifdef Doc_gYRingDipole
\Section{Skeleton of \c{gYRingDipole()}}
  \begin{verbatim}
    gYRingDipole(){
    }
  \end{verbatim}
\Section{\c{gYRingDipole()}}
Routine calculates $\gY$ of a unit dipole current ring.

\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{double }&\c{r}&$$&\\
\c{double }&\c{z}&$$&\\
\c{double }&\c{nr}&$$&\\
\c{double }&\c{nz}&$$&\\
\c{double }&\c{r0}&$$&\\
\c{double }&\c{z0}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
Poloidal flux of an elementary dipole
\bqbl
\gY
=
d[(\waN\cdot\na_{\waR}\gY)\wse_r
+(\waN\cdot\na_{\waZ}\gY_z)\wse_z]
,\eqbl
where $R,Z,\waN$ are coordinates and the unit vector of orientation of
the dipole, $r,z$ are coordinates of observation point.

\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

void MFRingDipole(Br,Bz,r,z,nR,nZ,R,Z)
  double *Br;	/*  */
  double *Bz;	/*  */
  double r;	/*  */
  double z;	/*  */
  double nR;	/*  */
  double nZ;	/*  */
  double R;	/*  */
  double Z;	/*  */
{
  Undef BrR;
  Undef BrZ;
  Undef BzR;
  Undef BzZ;
  /*
   */
#ifdef Doc_MFRingDipole
\Section{Skeleton of \c{MFRingDipole()}}
  \begin{verbatim}
    MFRingDipole(){
    }
  \end{verbatim}
\Section{\c{MFRingDipole()}}
Routine calculates the magnetic field of a unit dipole current ring.
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{double }&\c{*Br}&$$&\\
\c{double }&\c{*Bz}&$$&\\
\c{double }&\c{r}&$$&\\
\c{double }&\c{z}&$$&\\
\c{double }&\c{nR}&$$&\\
\c{double }&\c{nZ}&$$&\\
\c{double }&\c{R}&$$&\\
\c{double }&\c{Z}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
Magnetic field of and elementary dipole
\bqbl
B_r
=
-\R{1}{r}\bgY'_z
,\quad
B_z
=
\R{1}{r}\bgY'_r
,\\
\waB
=
d[(\waN\cdot\na_{\waR}b_r(\wsr,\waR))\wse_r
+(\waN\cdot\na_{\waZ}b_z(\wsr,\waR))\wse_z]
,\\
\waB
=
d[(N_rb'_{r,R}+N_zb'_{r,Z})\wse_r+(N_rb'_{z,R}+N_zb'_{z,Z})\wse_z]
,\\
\waB
=
\R{d}{r}[(-N_r\bgY'_{z,R}-N_z\bgY'_{z,Z})\wse_r
 +(N_r\bgY'_{r,R}+N_z\bgY'_{r,Z})\wse_z]
,\eqbl
where $R,Z,\waN$ are coordinates and the unit vector of orientation of
the dipole, $r,z$ are coordinates of observation point.

\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{BrR}&$$&\\
\c{Undef }&\c{BrZ}&$$&\\
\c{Undef }&\c{BzR}&$$&\\
\c{Undef }&\c{BzZ}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

void gYdYd2Yd3Y(gY,gYr,gYz,gYrr,gYrz,gYzz,gYrrz,gYzzr,r,z,R,Z)
  double *gY;		/* Magnetic flux */
  double *gYr;		/* r-derivative of Magnetic flux */
  double *gYz;		/* z-derivative of Magnetic flux */
  double *gYrr;		/* rr-derivative */
  double *gYrz;		/* rz-derivative */
  double *gYzz;		/* zz-derivative */
  double *gYrrz;	/* rrz-derivative */
  double *gYzzr;	/* zzr-derivative */
  double r;		/* r of the observation point */
  double z;		/* z of the observation point */
  double R;		/* R of the source point */
  double Z;		/* Z of the source point */
{
/*
   */
#ifdef Doc_gYdYd2Yd3Y
\Section{Skeleton of \c{gYdYd2Yd3Y()}}
  \begin{verbatim}
    gYdYd2Yd3Y(){
    }
  \end{verbatim}
\Section{\c{gYdYd2Yd3Y()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{double }&\c{*gY}&$$&\\
\c{double }&\c{*gYr}&$$&\\
\c{double }&\c{*gYz}&$$&\\
\c{double }&\c{*gYrr}&$$&\\
\c{double }&\c{*gYrz}&$$&\\
\c{double }&\c{*gYzz}&$$&\\
\c{double }&\c{*gYrrz}&$$&\\
\c{double }&\c{*gYzzr}&$$&\\
\c{double }&\c{r}&$$&\\
\c{double }&\c{z}&$$&\\
\c{double }&\c{R}&$$&\\
\c{double }&\c{Z}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}

\section{Magnetic flux}
\def\rR{(2rR)}
\def\ra{\over(r+R)^2+z^2}
\def\ek{K}
\def\ee{E}
\def\eke{K-E}

\def\s{0.2\sqrt{(r+R)^2+z^2}}

\bqbl
&&
{\gY\over2\pi}
=
\s\left(\eke-{\rR\ra}\ek\right)
.\eqbl

\def\rs{{0.2\over[(r+R)^2+z^2]^{1/2}}}
\def\rsa{{0.2\over[(r+R)^2+z^2]^{3/2}}}
\def\rsaa{{0.2\over[(r+R)^2+z^2]^{5/2}}}
\def\rd{\over(r-R)^2+z^2}
\def\rdd{\over[(r-R)^2+z^2]^2}
\def\rddd{\over[(r-R)^2+z^2]^3}
\def\Rr{(2R(r-R))}
\def\RR{(2R^2)}

%-------------------------------------
\bqbl
{\gY'_{r}\over2\pi}
=
\rs r\left[
  \eke
  -{\Rr\rd}\ee
 \right]
,\\
{\gY'_{z}\over2\pi}
=
\rs z\left[
  \eke
  -{\rR\rd}\ee
 \right]
.\eqbl

\subsection{Second derivatives over observation point}
\bqbl
&&
{\gY''_{rr}\over2\pi}
=
\rs\left(
  +{\RR\rd}\ee
  -{2\rR z^2\rdd}\ee
 \right)
\\&&
+\rsa z^2\left(
   \eke
  +{\rR\rd}\ek
 \right)
,\\&&
{\gY''_{rz}\over2\pi}
=
+\rs rz\left(
  +{2\Rr\rdd}\ee
 \right)
\\&&
+\rsa rz\left(
  -(\eke)
  -{\Rr\rd}\ek
  -{2\RR\rd}\ee
 \right)
,\\&&
{\gY''_{zz}\over2\pi}
=
\rs\left(
  \eke
  -{\rR\rd}\ee
  +{2\rR z^2\rdd}\ee
 \right)
\\&&
+\rsa z^2\left(
  -(\eke)
  -{\rR\rd}\ek
 \right)
.\eqbl

\subsection{Second mixed derivatives over observation and source points}
\bqbl
{\gY'_{r}\over2\pi}
=
{0.2\over[(r+R)^2+z^2]^{1/2}}
 r\left[
  \eke
  -{\Rr\rd}\ee
 \right]
,\\
\R{\gY''_{rR}}{2\gp}
=
\R{0.2r(r+R)}{[(r+R)^2+z^2]^{3/2}}
 \left[-\ek+\ee+\R{2R(r-R)}{(r-R)^2+z^2}\ee\right]
\\
+{0.2r\over[(r+R)^2+z^2]^{1/2}}\left[
\ek'-\ee'-\R{2R(r-R)}{(r-R)^2+z^2}\ee'\right]t'_R
\\
+{0.2r\over[(r+R)^2+z^2]^{1/2}}\left[
-\R{2r}{(r-R)^2+z^2}
+\R{4Rz^2}{[(r-R)^2+z^2]^2}
\right]\ee
,\\
{\gY''_{rZ}\over2\pi}
=
-{\gY''_{rz}\over2\pi}
,\\
{\gY'_z\over2\pi}
=
\rs z\left[
  \eke
  -{\rR\rd}\ee
 \right]
,\\
{\gY'_{zR}\over2\pi}
=
{0.2z\over[(r+R)^2+z^2]^{1/2}}\left[
  \ek-\ee
  -\R{2rR}{(r-R)^2+z^2}\ee
 \right]
\\=
-\R{0.2z(r+R)}{[(r+R)^2+z^2]^{3/2}}\left[
  \ek-\ee
  -\R{2rR}{(r-R)^2+z^2}\ee
 \right]
\\
+\R{0.2z}{[(r+R)^2+z^2]^{1/2}}\left[
  -2r\R{r^2-R^2+z^2}{[(r-R)^2+z^2]^2}\ee
  +\left(\ek'-\ee'
  -\R{2rR}{(r-R)^2+z^2}\ee'\right)t'_R
 \right]
,\\
{\gY''_{zZ}\over2\pi}
=
-{\gY''_{zz}\over2\pi}
.\eqbl

\subsection{Third derivatives over observation point}
\bqbl
&&
{\gY'''_{rrz}\over2\pi}
=
\rs z\left(
  -{4R(2r+R)\rdd}\ee
  +{8\rR z^2\rddd}\ee
 \right)
\\&&
+\rsa z\left(
  +2(\eke)
  +{2\rR+\RR\rd}\ek
  -{2\RR\rd}\ee
 \right)
\\&&
+\rsa z^3\left(
  -{4\rR\rdd}\ek
  +{3\rR\rdd}\ee
 \right)
\\&&
+\rsaa z^3\left(
  -3(\eke)
  -{2\rR\rd}\ek
  -{2\rR\rd}\ee
 \right)
.\eqbl

\bqbl
&&
{\gY'''_{zzr}\over2\pi}
=
+\rs r\left(
  +{2\Rr\rdd}\ee
  -{8\Rr z^2\rddd}\ee
 \right)
\\&&
+\rsa r\left(
  -(\eke)
  -{\Rr\rd}\ek
  -{\RR\rd}\ee
 \right)
\\&&
+\rsa rz^2\left(
  +{4\Rr\rdd}\ek
  +{(-3\Rr+4\RR)\rdd}\ee
 \right)
\\&&
+\rsaa rz^2\left(
  +3(\eke)
  +{2(\rR-2\RR)\rd}\ek
  +{2(\rR+4\RR)\rd}\ee
 \right)
.\eqbl

\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int gYdYd2Yd3YWnd(gY,gYr,gYz,gYrr,gYrz,gYzz,gYrrz,gYzzr,r,z,Rw,Zw,Iw,Nw)
  double *gY;		/*  */
  double *gYr;		/*  */
  double *gYz;		/*  */
  double *gYrr;		/*  */
  double *gYrz;		/*  */
  double *gYzz;		/*  */
  double *gYrrz;	/*  */
  double *gYzzr;	/*  */
  double r;		/*  */
  double z;		/*  */
  double *Rw;		/*  */
  double *Zw;		/*  */
  double *Iw;		/*  */
  int Nw;		/*  */
{
/*
   */
#ifdef Doc_gYdYd2Yd3YWnd
\Section{Skeleton of \c{gYdYd2Yd3YWnd()}}
  \begin{verbatim}
    gYdYd2Yd3YWnd(){
    }
  \end{verbatim}
\Section{\c{gYdYd2Yd3YWnd()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{double }&\c{*gY}&$$&\\
\c{double }&\c{*gYr}&$$&\\
\c{double }&\c{*gYz}&$$&\\
\c{double }&\c{*gYrr}&$$&\\
\c{double }&\c{*gYrz}&$$&\\
\c{double }&\c{*gYzz}&$$&\\
\c{double }&\c{*gYrrz}&$$&\\
\c{double }&\c{*gYzzr}&$$&\\
\c{double }&\c{r}&$$&\\
\c{double }&\c{z}&$$&\\
\c{double }&\c{*Rw}&$$&\\
\c{double }&\c{*Zw}&$$&\\
\c{double }&\c{*Iw}&$$&\\
\c{int }&\c{Nw}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

void gYdY(gY,gYr,gYz,gYR,gYZ,r,z,R,Z)
  double *gY;	/*  */
  double *gYr;	/*  */
  double *gYz;	/*  */
  double *gYR;	/*  */
  double *gYZ;	/*  */
  double r;	/*  */
  double z;	/*  */
  double R;	/*  */
  double Z;	/*  */
{
/*
   */
#ifdef Doc_gYdY
\Section{Skeleton of \c{gYdY()}}
  \begin{verbatim}
    gYdY(){
    }
  \end{verbatim}
\Section{\c{gYdY()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{double }&\c{*gY}&$$&\\
\c{double }&\c{*gYr}&$$&\\
\c{double }&\c{*gYz}&$$&\\
\c{double }&\c{*gYR}&$$&\\
\c{double }&\c{*gYZ}&$$&\\
\c{double }&\c{r}&$$&\\
\c{double }&\c{z}&$$&\\
\c{double }&\c{R}&$$&\\
\c{double }&\c{Z}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}

\section{Magnetic flux}
\def\rR{(2rR)}
\def\ra{\over(r+R)^2+(z-Z)^2}
\def\ek{K}
\def\ee{E}
\def\eke{K-E}

\def\s{0.2\sqrt{(r+R)^2+(z-Z)^2}}

\bqbl
{\gY\over2\pi}
=
\s\left(\eke-{\rR\ra}\ek\right)
.\eqbl
\def\rs{{0.2\over[(r+R)^2+(z-Z)^2]^{1/2}}}
\def\rd{\over(r-R)^2+(z-Z)^2}
\def\RD{(2R(r-R))}
\def\rD{(2r(R-r))}

%-------------------------------------
\bqbl
&&
{\gY'_{r}\over2\pi}
=
\rs r\left[
  \eke
  -{\RD\rd}\ee
 \right]
,\\&&
{\gY'_{R}\over2\pi}
=
\rs R\left[
  \eke
  -{\rD\rd}\ee
 \right]
,\\&&
{\gY'_{z}\over2\pi}
=
\rs (z-Z)\left[
  \eke
  -{\rR\rd}\ee
 \right]
,\\&&
{\gY'_{Z}\over2\pi}
=
\rs (Z-z)\left[
  \eke
  -{\rR\rd}\ee
 \right]
.\eqbl

#endif
}

double GPring(r,z,r0,z0)
  double r;	/* r of observation point,[m] */
  double z;	/* z of observation point,[m] */
  double r0;	/* r of source point,[m] */
  double z0;	/* z of source point,[m] */
{
/*
   */
#ifdef Doc_GPring
\Section{Skeleton of \c{GPring()}}
  \begin{verbatim}
    GPring(){
    }
  \end{verbatim}
\Section{\c{GPring()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{double }&\c{r}&$$&\\
\c{double }&\c{z}&$$&\\
\c{double }&\c{r0}&$$&\\
\c{double }&\c{z0}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}

  GPring() - flux of a single filament,[Vsec];
\bqbl
&&
d
=
{(z-Z)^2+(r-R)^2\over(r+R)^2+(z-Z)^2};
,\quad
\gY
=
0.4\pi\left(
  {1+d\over2}K(d)-E(d)
 \right)\sqrt{(r+R)^2+(z-Z)^2}
\eqbl
#endif
}

double gYRing(r,z,r0,z0)
  double r;	/*  */
  double z;	/*  */
  double r0;	/*  */
  double z0;	/*  */
{
/*
   */
#ifdef Doc_gYRing
\Section{Skeleton of \c{gYRing()}}
  \begin{verbatim}
    gYRing(){
    }
  \end{verbatim}
\Section{\c{gYRing()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{double }&\c{r}&$$&\\
\c{double }&\c{z}&$$&\\
\c{double }&\c{r0}&$$&\\
\c{double }&\c{z0}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

double gYCoil(r,z,r0,z0,I,n)
  double r;	/*  */
  double z;	/*  */
  double *r0;	/*  */
  double *z0;	/*  */
  double *I;	/*  */
  int n;	/*  */
{
/*
   */
#ifdef Doc_gYCoil
\Section{Skeleton of \c{gYCoil()}}
  \begin{verbatim}
    gYCoil(){
    }
  \end{verbatim}
\Section{\c{gYCoil()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{double }&\c{r}&$$&\\
\c{double }&\c{z}&$$&\\
\c{double }&\c{*r0}&$$&\\
\c{double }&\c{*z0}&$$&\\
\c{double }&\c{*I}&$$&\\
\c{int }&\c{n}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

void MFring(gy,Br,Bz,r,z,r0,z0,I)
  double *gy;	/*  */
  double *Br;	/* r-component of the magnetic field,[T] */
  double *Bz;	/* z-component of the magnetic field,[T]  */
  double r;	/* r of observation point,[m] */
  double z;	/* z of observation point,[m] */
  double r0;	/* r of source point,[m] */
  double z0;	/* z of source point,[m] */
  double I;	/* current in the filament,[MA] */
{
/*
   */
#ifdef Doc_MFring
\Section{Skeleton of \c{MFring()}}
  \begin{verbatim}
    MFring(){
    }
  \end{verbatim}
\Section{\c{MFring()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{double }&\c{*gp}&$$&\\
\c{double }&\c{*Br}&$$&\\
\c{double }&\c{*Bz}&$$&\\
\c{double }&\c{r}&$$&\\
\c{double }&\c{z}&$$&\\
\c{double }&\c{r0}&$$&\\
\c{double }&\c{z0}&$$&\\
\c{double }&\c{I}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}

#endif
}

void EFring(gf,Er,Ez,r,z,R,Z,gs)
  double *gf;	/*  */
  double *Er;	/*  */
  double *Ez;	/*  */
  double r;	/*  */
  double z;	/*  */
  double R;	/*  */
  double Z;	/*  */
  double gs;	/*  */
{
/*
   */
#ifdef Doc_EFring
\Section{Skeleton of \c{EFring()}}
  \begin{verbatim}
    EFring(){
    }
  \end{verbatim}
\Section{\c{EFring()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{double }&\c{*gf}&$$&\\
\c{double }&\c{*Er}&$$&\\
\c{double }&\c{*Ez}&$$&\\
\c{double }&\c{r}&$$&\\
\c{double }&\c{z}&$$&\\
\c{double }&\c{r0}&$$&\\
\c{double }&\c{z0}&$$&\\
\c{double }&\c{I}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\bqbl
\gf
=
\R{Q}{4\gp \ge_0}\R{2}{\gp}\R{K(k^2)}{\q{q}}
,\quad
q
\equiv
(r+R)^2+(z-Z)^2
,\quad
k^2
\equiv
\R{4rR}{q}
,\\
E_r
=
\R{Q}{4\gp \ge_0}\R{2}{\gp\q{q}[(r-R)^2+(z-Z)^2]k^2}\left(
2R(1-k^2)K-(2R-k^2(r+R))E\right)
,\\
E_z
=
\R{Q}{4\gp \ge_0}\R{2(z-Z)}{\gp\q{q}[(r-R)^2+(z-Z)^2]}E
,\\
q(1-k^2)
=
(r-R)^2+(z-Z)^2
,\\
2R-k^2(r+R)
=
2R\R{R^2-r^2+(z-Z)^2}{q}
,\\
E_r
=
\R{Q}{4\gp \ge_0}\R{1}{\gp r\q{q}}\left(
K-\R{R^2-r^2+(z-Z)^2}{(r-R)^2+(z-Z)^2}E\right)
.\eqbl
In terms of linear charge density $\gs$
\vskip0.5em
\ebox{
Q
\equiv
2\gp R\gs
,\quad
q
\equiv
(r+R)^2+(z-Z)^2
,\quad
k^2
\equiv
\R{4rR}{q}
,\quad
1-k^2
\equiv
\R{(r-R)^2+(z-Z)^2}{q}
,\\
\gf
=
\R{\gs}{\gp}\R{R}{\q{q}}\baK
,\quad
\baK
=
K(1-k^2)
,\quad
\baE
=
E(1-k^2)
,\\
E_r
=
\R{\gs}{\gp}\R{R}{\q{q}}\R{1}{2r}\left(
\baK+\R{r^2-R^2-(z-Z)^2}{(r-R)^2+(z-Z)^2}\baE\right)
,\\
E_z
=
\R{\gs}{\gp}\R{R}{\q{q}}\R{z-Z}{(r-R)^2+(z-Z)^2}\baE
}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

void MFwinding(gp,Br,Bz,r,z,r0,z0,I,n)
  double *gp;	/*  */
  double *Br;	/*  */
  double *Bz;	/*  */
  double *r;	/*  */
  double *z;	/*  */
  double *r0;	/*  */
  double *z0;	/*  */
  double *I;	/*  */
  int n;	/* number of turns */
{
/*
   */
#ifdef Doc_MFwinding
\Section{Skeleton of \c{MFwinding()}}
  \begin{verbatim}
    MFwinding(){
    }
  \end{verbatim}
\Section{\c{MFwinding()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{double }&\c{*gp}&$$&\\
\c{double }&\c{*Br}&$$&\\
\c{double }&\c{*Bz}&$$&\\
\c{double }&\c{*r}&$$&\\
\c{double }&\c{*z}&$$&\\
\c{double }&\c{*r0}&$$&\\
\c{double }&\c{*z0}&$$&\\
\c{double }&\c{*I}&$$&\\
\c{int }&\c{n}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int gYdYWnd(gY,gYr,gYz,r,z,Rw,Zw,Iw,Nw)
  double *gY;	/*  */
  double *gYr;	/*  */
  double *gYz;	/*  */
  double r;	/*  */
  double z;	/*  */
  double *Rw;	/*  */
  double *Zw;	/*  */
  double *Iw;	/*  */
  int Nw;	/*  */
{
/*
   */
#ifdef Doc_gYdYWnd
\Section{Skeleton of \c{gYdYWnd()}}
  \begin{verbatim}
    gYdYWnd(){
    }
  \end{verbatim}
\Section{\c{gYdYWnd()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{double }&\c{*gY}&$$&\\
\c{double }&\c{*gYr}&$$&\\
\c{double }&\c{*gYz}&$$&\\
\c{double }&\c{r}&$$&\\
\c{double }&\c{z}&$$&\\
\c{double }&\c{*Rw}&$$&\\
\c{double }&\c{*Zw}&$$&\\
\c{double }&\c{*Iw}&$$&\\
\c{int }&\c{Nw}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}
static double Br;	/*  */
static double Bz;	/*  */

double BTring(r,z,nr,nz,r0,z0,I)
  double *r;	/*  */
  double *z;	/*  */
  double *nr;	/* r-component of normal vector */
  double *nz;	/* z-component of normal vector */
  double *r0;	/*  */
  double *z0;	/*  */
  double *I;	/*  */
{
/*
   */
#ifdef Doc_BTring
\Section{Skeleton of \c{BTring()}}
  \begin{verbatim}
    BTring(){
    }
  \end{verbatim}
\Section{\c{BTring()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{double }&\c{*r}&$$&\\
\c{double }&\c{*z}&$$&\\
\c{double }&\c{*nr}&$$&\\
\c{double }&\c{*nz}&$$&\\
\c{double }&\c{*r0}&$$&\\
\c{double }&\c{*z0}&$$&\\
\c{double }&\c{*I}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
   BTring() - tangential component of the magnetic field,[T];
#endif
}

double BNring(r,z,nr,nz,r0,z0,I)
  double *r;	/*  */
  double *z;	/*  */
  double *nr;	/*  */
  double *nz;	/*  */
  double *r0;	/*  */
  double *z0;	/*  */
  double *I;	/*  */
{
/*
   */
#ifdef Doc_BNring
\Section{Skeleton of \c{BNring()}}
  \begin{verbatim}
    BNring(){
    }
  \end{verbatim}
\Section{\c{BNring()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{double }&\c{*r}&$$&\\
\c{double }&\c{*z}&$$&\\
\c{double }&\c{*nr}&$$&\\
\c{double }&\c{*nz}&$$&\\
\c{double }&\c{*r0}&$$&\\
\c{double }&\c{*z0}&$$&\\
\c{double }&\c{*I}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

void BTNring(Bt,Bn,r,z,nr,nz,r0,z0,I)
  double *Bt;	/*  */
  double *Bn;	/*  */
  double *r;	/*  */
  double *z;	/*  */
  double *nr;	/*  */
  double *nz;	/*  */
  double *r0;	/*  */
  double *z0;	/*  */
  double *I;	/*  */
{
/*
   */
#ifdef Doc_BTNring
\Section{Skeleton of \c{BTNring()}}
  \begin{verbatim}
    BTNring(){
    }
  \end{verbatim}
\Section{\c{BTNring()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{double }&\c{*Bt}&$$&\\
\c{double }&\c{*Bn}&$$&\\
\c{double }&\c{*r}&$$&\\
\c{double }&\c{*z}&$$&\\
\c{double }&\c{*nr}&$$&\\
\c{double }&\c{*nz}&$$&\\
\c{double }&\c{*r0}&$$&\\
\c{double }&\c{*z0}&$$&\\
\c{double }&\c{*I}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
   BTring() - normal component of the magnetic field,[T];

#endif
}
#endif

#ifndef stg_GRN
#ifdef Doc_GRN
		Green functions.
#endif

void Lik(gP,n,n0,r,z,d05r,d05z,r0,z0,d05r0,d05z0)
  int n;		/* Number of observation points */
  int n0;		/* Number of the source turns */
  double *gP;		/*  */
  double *r;		/*  */
  double *z;		/*  */
  double *d05r;		/* half of r-size of the target turn,[m] */
  double *d05z;		/* half of z-size of the target turn,[m] */
  double *r0;		/*  */
  double *z0;		/*  */
  double *d05r0;	/* half of r-size of the source turn,[m] */
  double *d05z0;	/* half of z-size of the source turn,[m] */
{
/*
   */
#ifdef Doc_Lik
\Section{Skeleton of \c{Lik()}}
  \begin{verbatim}
    Lik(){
    }
  \end{verbatim}
\Section{\c{Lik()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{int }&\c{n}&$$&\\
\c{int }&\c{n0}&$$&\\
\c{double }&\c{*gP}&$$&\\
\c{double }&\c{*r}&$$&\\
\c{double }&\c{*z}&$$&\\
\c{double }&\c{*d05r}&$$&\\
\c{double }&\c{*d05z}&$$&\\
\c{double }&\c{*r0}&$$&\\
\c{double }&\c{*z0}&$$&\\
\c{double }&\c{*d05r0}&$$&\\
\c{double }&\c{*d05z0}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}
#endif

int BioSavartABatXYZ(A,B,V,v,n1)
  double A[];	/*  */
  double B[];	/*  */
  double V[];	/*  */
  double v[][];	/*  */
  int n1;	/*  */
{
/*
   */
#ifdef Doc_BioSavartABatXYZ
\Section{Skeleton of \c{BioSavartABatXYZ()}}
  \begin{verbatim}
    BioSavartABatXYZ(){
    }
  \end{verbatim}
\Section{\c{BioSavartABatXYZ()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{double }&\c{A[]}&$$&\\
\c{double }&\c{B[]}&$$&\\
\c{double }&\c{V[]}&$$&\\
\c{double }&\c{v[][]}&$$&\\
\c{int }&\c{n1}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsubsection{Biot-Savart magnetic field}

Vector potential of the straight section
\bqbl
\waA
=
0.1I\int_1^2{\wsi dl\over |\wsr|}
=
0.1I\wsi(F_2-F_1)
,\quad
\wsr
\equiv
(x-X)\wse_x
+(y-Y)\wse_y
+(z-Z)\wse_z
,\quad
\wsi
\equiv
{\waI\over|\waI|}
,\\
F
\equiv
\ln[|\wsr|+(\wsr\cdot\wsi)]
,\quad
F_2
\equiv
\ln[|\wsr|_2+(\wsr_2\cdot\wsi)]
,\quad
F_1
\equiv
\ln[|\wsr|_1+(\wsr_1\cdot\wsi)]
.\eqbl
Magnetic field of the straight section
\bqbl
\waB
=
\na\times\waA
,\quad
\na|\wsr|
=
-{\wsr\over|\wsr|}
,\quad
\na(\wsr\cdot\wsi)
=-\wsi
,\\
\waB
=
0.1I\int_1^2{(\wsi\times\wsr)dl\over |\wsr|^3}
=
0.1I\left(\na\ln{|\wsr|_2+(\wsr_2\cdot\wsi)\over|\wsr|_1+(\wsr_1\cdot\wsi)}
 \times\wsi\right)
=
0.1I\left(
  {\wsi\times\R{\wsr_2}{|\wsr|_2}\over|\wsr|_2+(\wsr_2\cdot\wsi)}
  -{\wsi\times\R{\wsr_1}{|\wsr|_1}\over|\wsr|_1+(\wsr_1\cdot\wsi)}
 \right)
.\eqbl
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int BioSavartBatXYZ(B,V,v,n1)
  double B[];	/*  */
  double V[];	/*  */
  double v[][];	/*  */
  int n1;	/*  */
{
/*
   */
#ifdef Doc_BioSavartBatXYZ
\Section{Skeleton of \c{BioSavartBatXYZ()}}
  \begin{verbatim}
    BioSavartBatXYZ(){
    }
  \end{verbatim}
\Section{\c{BioSavartBatXYZ()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{double }&\c{B[]}&$$&\\
\c{double }&\c{V[]}&$$&\\
\c{double }&\c{v[][]}&$$&\\
\c{int }&\c{n1}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int BioSavartB(B,V,v,t,n1)
  double B[];	/*  */
  double V[];	/*  */
  double v[][];	/*  */
  double t[][];	/*  */
  int n1;	/*  */
{
/*
   */
#ifdef Doc_BioSavartB
\Section{Skeleton of \c{BioSavartB()}}
  \begin{verbatim}
    BioSavartB(){
    }
  \end{verbatim}
\Section{\c{BioSavartB()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{double }&\c{B[]}&$$&\\
\c{double }&\c{V[]}&$$&\\
\c{double }&\c{v[][]}&$$&\\
\c{double }&\c{t[][]}&$$&\\
\c{int }&\c{n1}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}
#endif
#endif

#undef Doc_Cb_Structure
#ifdef Blb_mf.c
Blb_mf.c{
  mzl_MF{
    stg_ELKE{
    }
    stg_MFF{
    }
    stg_GRN{
    }
  }
}
#endif

#undef Doc_Table_Of_Content
#ifndef Blb_mf.c
				PS p= -1 (  0);
#ifndef mzl_MF
				PS p=  1 (  1);
#ifndef stg_ELKE
				PS p=  1 (  1);
double ELE();			PS p=  1 (  1);
double ELK();			PS p=  1 (  1);
double ELEE();			PS p=  1 (  1);
double ELKK();			PS p=  1 (  1);
#endif
#ifndef stg_MFF
				PS p=  2 (  1);
void SourceGradOfgY();		PS p=  2 (  1);
void SourceGradOfBpol();	PS p=  2 (  1);
void gYRingDipole();		PS p=  3 (  2);
void MFRingDipole();		PS p=  3 (  2);
void gYdYd2Yd3Y();		PS p=  3 (  2);
int gYdYd2Yd3YWnd();		PS p=  4 (  2);
void gYdY();			PS p=  5 (  3);
double GPring();		PS p=  5 (  3);
double gYRing();		PS p=  6 (  3);
double gYCoil();		PS p=  6 (  3);
void MFring();			PS p=  6 (  3);
void EFring();			PS p=  7 (  4);
void MFwinding();		PS p=  7 (  4);
int gYdYWnd();			PS p=  7 (  4);
double BTring();		PS p=  8 (  4);
double BNring();		PS p=  8 (  4);
void BTNring();			PS p=  8 (  4);
#endif
#ifndef stg_GRN
				PS p=  8 (  4);
void Lik();			PS p=  8 (  4);
#endif
int BioSavartABatXYZ();		PS p= 10 (  5);
int BioSavartBatXYZ();		PS p= 11 (  6);
int BioSavartB();		PS p= 12 (  6);
#endif
#endif
