
#ifndef Blb_pfcW.c
/* undefined */
#ifdef Doc_pfcW.c
\section{Conversion of raw signals into a working signal structure}
\begin{verbatim}
typedef struct RAWDATA{
  double C;	/* Common factor */
  double G;	/* Common Amplification factor */
  double A;	/* Amplification factor of raw data */
  double B;	/* Bias of raw data */
  double dC;	/* Error in Common factor */
  double dG;	/* Error in Common Amplification factor */
  double dA;	/* Error in Amplification factor of raw data */
  double dB;	/* Error in Bias of raw data */
  double S;	/* current raw signal */
  double dS;	/* estimated error in the current raw signal */
  double *D;	/* pointer to the Waveform data */
  double *T;	/* pointer to the Waveform times */
  int kA;	/* Activity factor */
  int kG;	/* Group number*/
  int kS;	/* Sequential position inside the group */
  int c;	/* color */
  int n;	/* number of Wafeform data */
  int i1;	/* index of start of Wafeform interval of interest */
  int i;	/* current index of the Wafeform interval of interest */
  int i2;	/* index of end of Wafeform interval of interest */
}RAWDATA;
\end{verbatim}
Representation of the working signal $S$ in terms of raw signal $\taS$
\bqbl
&&
S
\equiv
\R{C}{G}[\taS-(At_i+B)]
,\\&&
\gd S
=
\R{\gd C}{G}[\taS-(At+B)]
+\R{C\gd G}{G^2}[\taS-(At+B)]
+\R{C}{G}[\gd\taS-(\gd At+\gd B)]
,\eqbl
where coefficients $C,G,A,B$ and there error estimate $\gd C,\gd G,\gd A,\gd B$
are assumed to specific to each signal as well as to the shot number.

#endif

#ifndef mzl_System_pfcW.c /* --------------- Use of Variables --------{ */
#ifdef Tbl_UnusedID/* ------------- List of Unused variables ------{ */
  extern double cr3;		/*                     :pfcW.c */
  extern double cr4;		/*                     :pfcW.c */
  extern double cr6;		/*                     :pfcW.c */
  extern double cr12;		/*                     :pfcW.c */
  extern double c2gp;		/*                     :pfcW.c */
  extern double cgp_4;		/*                     :pfcW.c */
  extern double cgm0;		/*                     :pfcW.c */
  extern int *IndALm;		/*                     :pfcW.c */
  static int MSEkAc[];		/*                 <PFC:pfcW.c */
  static int MSEkAs[];		/*                 <PFC:pfcW.c */
  static char Shot[];		/*                 <PFC:pfcW.c */
  static char DTime[];		/*                 <PFC:pfcW.c */
  static char Ext[];		/*                 <PFC:pfcW.c */
  static char Nm[];		/*                 <PFC:pfcW.c */
  static int iGrI;		/*                 <PFC:pfcW.c */
  extern int nRawP;		/*                     :pfcW.c */
  static double s1Y;		/*                 <PFC:pfcW.c */
  static double s2Y;		/*                 <PFC:pfcW.c */
  static double s1B;		/*                 <PFC:pfcW.c */
  static double s2B;		/*                 <PFC:pfcW.c */
  static double t1;		/*                 <PFC:pfcW.c */
  static double t2;		/*                 <PFC:pfcW.c */
  static int kAT;		/*                 <PFC:pfcW.c */
  int YearAO();			/*                 <PFC:pfcW.c */
  int YearAI();			/*                 <PFC:pfcW.c */
  int PFYear();			/*                 <PFC:pfcW.c */
  int PFWriteAngData();		/*                 <PFC:pfcW.c */
  int PFReadAngData();		/*                 <PFC:pfcW.c */
  int PFMSE_GeomAO();		/*                 <PFC:pfcW.c */
  int PFMSE_GeomAI();		/*                 <PFC:pfcW.c */
  int OldMSEGeom();		/*                 <PFC:pfcW.c */
  int MSEGeomAO();		/*                 <PFC:pfcW.c */
  int MSEGeomAI();		/*                 <PFC:pfcW.c */
  double x0;			/* .MSEPickUpPlot()<PFC:pfcW.c */
  double y0;			/* .MSEPickUpPlot()<PFC:pfcW.c */
  double sc;			/* .MSEPickUpPlot()<PFC:pfcW.c */
  int MSEGeom();		/*                 <PFC:pfcW.c */
  int SigLayOutAO();		/*                 <PFC:pfcW.c */
  int SigLayOutAI();		/*                 <PFC:pfcW.c */
  int SetSensorC();		/*                 <PFC:pfcW.c */
  int SigLayOut();		/*                 <PFC:pfcW.c */
  int WFormYBO();		/*                 <PFC:pfcW.c */
  int WFormYBI();		/*                 <PFC:pfcW.c */
  int WFormPBO();		/*                 <PFC:pfcW.c */
  int WFormPBI();		/*                 <PFC:pfcW.c */
  void PlotPFCWFormW();		/*                 <PFC:pfcW.c */
  int WFormIpAO();		/*                 <PFC:pfcW.c */
  int WFormIpAI();		/*                 <PFC:pfcW.c */
  int WFormIpBI();		/*                 <PFC:pfcW.c */
  int PFReadWFormAI();		/*                 <PFC:pfcW.c */
  int PFReadWFormIpAI();	/*                 <PFC:pfcW.c */
  int FlR;			/*       .GetJETI()<PFC:pfcW.c */
  int WFormIp();		/*                 <PFC:pfcW.c */
  int WFormI();			/*                 <PFC:pfcW.c */
  int PlotSnapShotIp();		/*                 <PFC:pfcW.c */
  int PlotSnapShotY();		/*                 <PFC:pfcW.c */
  int PFWriteWFormAO();		/*                 <PFC:pfcW.c */
  int WFormY();			/*                 <PFC:pfcW.c */
  int WFormPAI();		/*                 <PFC:pfcW.c */
  int WFormP();			/*                 <PFC:pfcW.c */
  int PlotSnapShotI();		/*                 <PFC:pfcW.c */
  int SnapShot();		/*                 <PFC:pfcW.c */
  int PFSaveExpData();		/*                 <PFC:pfcW.c */
  int PFReadExpData();		/*                 <PFC:pfcW.c */
  int PFExpDataAO();		/*                 <PFC:pfcW.c */
  int MSEtangg();		/*                 <PFC:pfcW.c */
  int MSEtanggHole();		/*                 <PFC:pfcW.c */
  int MSEPitchAngle();		/*                 <PFC:pfcW.c */
  int MSEPitchAngleHole();	/*                 <PFC:pfcW.c */
  int MSEPitchAnglePLot();	/*                 <PFC:pfcW.c */
  int PFGetW();			/*                 <PFC:pfcW.c */
  int PFHistoryDataPlot();	/*                 <PFC:pfcW.c */
  int PFEfitOutPlot();		/*                 <PFC:pfcW.c */
  int PFGenerateSignals();	/*                 <PFC:pfcW.c */
  int PFSetExpDataWeights0();	/*                 <PFC:pfcW.c */
  int PFSetExpDataWeightsJET();	/*                 <PFC:pfcW.c */
  void EFITjpPlot();		/*                 <PFC:pfcW.c */
  void EFITjsPlot();		/*                 <PFC:pfcW.c */
  int EFITaP2Jp();		/*                 <PFC:pfcW.c */
  int EFITaT2Js();		/*                 <PFC:pfcW.c */
  int PFExpDataFileList();	/*                 <PFC:pfcW.c */
  int GetExpData();		/*                 <PFC:pfcW.c */
#endif /* }=== End of List of Unused variables ======*/
#ifndef H/* ---------- Used External Variables ------{ */
  Ignor char;
  Ignor int;
  Ignor double;
  Ignor RAWDATA;
  Ignor void;
  Systm NULL;
  Systm feof();
  Systm fgetc();
  Systm sprintf();
  Systm strlen();
  Systm sscanf();
  Systm isspace();
  Systm isdigit();
  Systm strtol();
  Systm strtod();
  Systm strcpy();
  Systm free();
  Systm calloc();
  Systm fputs();
  Systm fprintf();
  Systm memset();
  Systm printf();
  Systm rewind();
  Systm strncmp();
  Systm fopen();
  Systm strstr();
  Systm fscanf();
  Systm fclose();
  Systm sin();
  Systm cos();
  Systm sqrt();
  Systm asin();
  Systm puts();
  Systm fabs();
  Systm fwrite();
  Systm fread();
  Systm malloc();
  Systm putc();
  Systm memcpy();
  Systm opendir();
  Systm readdir();
  Systm strcmp();
  Systm closedir();
  CbExt CbUserPlot;
  CbExt CbGetCurrentCbName();
  CbExt out();
  CbExt ZPlotIntRect();
  CbExt ZColor();
  CbExt ZPlotPolyLine();
  CbExt SetPlotName();
  CbExt Scale2d();
  CbExt Plot2d();
  CbExt numstr();
  CbExt CbStrCpy();
  CbExt ZPlotLUString();
  CbExt ZPlotRect();
  CbExt PSFileOpen();
  CbExt PSNewFrame();
  CbExt PSPlot2d();
  CbExt PSFileClose();
  Undef NTYPEG;			/* undefined */
  Undef GROUPDT;		/* undefined */
  Undef PFCOIL;			/* undefined */
  Undef MFPROBE;		/* undefined */
  Undef NGRP;			/* undefined */
  Undef DATAMSE;		/* undefined */
  Undef CbStr2UserMessage();	/* NO prototype */
  Undef FormatWrite2Read();	/* NO prototype */
  Undef IsKeyWordFound();	/* NO prototype */
  Undef ReadAI();		/* NO prototype */
  Undef CbStr2UserWarning();	/* NO prototype */
  Undef PFReInitPFC();		/* NO prototype */
  Undef PFReInitPSC();		/* NO prototype */
  Undef LimPlot();		/* NO prototype */
  Undef ZPlotUTopMString();	/* NO prototype */
  Undef f2spl();		/* NO prototype */
  Undef splr0();		/* NO prototype */
  Undef ISignal2Splines();	/* NO prototype */
  Undef GetSVDExpansion4Wall();	/* NO prototype */
  Undef ZMessage();		/* NO prototype */
  Undef PFGiveRawAddress();	/* NO prototype */
  Undef ZMessageF();		/* NO prototype */
  Undef GetRespFunction();	/* NO prototype */
  Undef MakeSignalF();		/* NO prototype */
  Undef realpath();		/* NO prototype */
  Undef IsRecordHeadFound();	/* NO prototype */
  Systm tan();			/* NO prototype */
  Undef MFPPlot();		/* NO prototype */
  Undef ppppp();		/* NO prototype */
  Undef ESGetLabMetrics();	/* NO prototype */
  Undef ESSetSplA();		/* NO prototype */
  Undef splRA();		/* NO prototype */
  Undef ESIsOutsidePlasma();	/* NO prototype */
  Undef ESGetMetrics();		/* NO prototype */
  Undef PSSetFileName();	/* NO prototype */
  Undef readefitk_();		/* NO prototype */
  Undef readefita_();		/* NO prototype */
  Undef spl();			/* NO prototype */
  Undef SetIspl();		/* NO prototype */
  Undef splR();			/* NO prototype */
  Undef readefitg_();		/* NO prototype */
  Undef getefitmsek_();		/* NO prototype */
  extern int nDGr;		/* External */
  extern GROUPDT DGr[];		/* External */
  extern int nPFC1;		/* External */
  extern PFCOIL *PFC;		/* External */
  extern int nVVC;		/* External */
  extern PFCOIL *VVC;		/* External */
  extern int nMFP;		/* External */
  extern MFPROBE *MFP;		/* External */
  extern int nRawS;		/* External */
  extern GROUPDT *PGr;		/* External */
  extern int nPGr;		/* External */
  extern int nRawP;		/* External */
  extern int nRaw;		/* External */
  extern int nPFC;		/* External */
  extern int nMFLS;		/* External */
  extern int nMFp;		/* External */
  extern int nMFV;		/* External */
  extern unsigned int ESmemlevP;/* External */
  extern char TypeNm[][];	/* External */
  extern int nMFL;		/* External */
  extern int nMFS;		/* External */
  extern MFPROBE *MFS;		/* External */
  extern MFPROBE *MFp;		/* External */
  extern int nMFd;		/* External */
  extern MFPROBE *MFd;		/* External */
  extern MFPROBE *MFV;		/* External */
  extern MFPROBE *MFL;		/* External */
  extern int MSEFl;		/* External */
  extern DATAMSE MSE[];		/* External */
  extern int NMSE;		/* External */
  extern int nVVB;		/* External */
  extern double cgp;		/* External */
  extern int nMSS;		/* External */
  extern int MSSFl;		/* External */
  extern DATAMSE MSS[];		/* External */
  extern int nMSE;		/* External */
  extern double scMSE;		/* External */
  extern double RplG[];		/* External */
  extern int ESNp1;		/* External */
  extern double x0Mse;		/* External */
  extern double *EScs1;		/* External */
  extern double y0Mse;		/* External */
  extern double *ESsn1;		/* External */
  extern double cr2gp;		/* External */
  extern double *ESRLm;		/* External */
  extern int ESnLm;		/* External */
  extern double *ESZLm;		/* External */
  extern double ZplG[];		/* External */
  extern int kCol[];		/* External */
  extern double PFtWF1;		/* External */
  extern double PFtWF2;		/* External */
  extern double PFtWF;		/* External */
  extern int kTimeHistory;	/* External */
  extern PFBLOCK *PFB;		/* External */
  extern int iSignIp;		/* External */
  extern int iSignBt;		/* External */
  extern char ShotNm[];		/* External */
  extern double cr2;		/* External */
  extern double ESRext;		/* External */
  extern double crgm0;		/* External */
  extern double ESBt;		/* External */
  extern double ESRBt;		/* External */
  extern double ESTime;		/* External */
  extern double ESIpl;		/* External */
  extern int nPFB;		/* External */
  extern int ESNa1;		/* External */
  extern double *ESaZ0;		/* External */
  extern double *ESsb;		/* External */
  extern double *ESaR0;		/* External */
  extern int ESNa;		/* External */
  extern double *ESsr;		/* External */
  extern int ESNp;		/* External */
  extern double *ESsa;		/* External */
  extern double *ESdgY;		/* External */
  extern double *ESdgY2a;	/* External */
  extern double *ESFF;		/* External */
  extern double *ESFF2a;	/* External */
  extern double *ESgY;		/* External */
  extern double *ESgY2a;	/* External */
  extern double ESa0;		/* External */
  extern double *ESaF;		/* External */
  extern PSBLOCK *VVB;		/* External */
  extern int nPEC;		/* External */
  extern double *ESqgY;		/* External */
  extern double *ESqgY2a;	/* External */
  extern int nFList;		/* External */
  extern int NFList;		/* External */
  extern char FListEFIT[][];	/* External */
  extern int iFList;		/* External */
  extern char kFileExt[];	/* External */
  extern int ESkNormJ;		/* External */
  int PFSetShotNm();		/* No prototype */
#ifdef Tbl_MLIB
#endif
#ifdef Tbl_ESC
#endif
#ifdef Tbl_PFC
  Undef NTYPEG;			/* undefined */
  Undef NTYPEG;			/* undefined */
  Undef GROUPDT;		/* undefined */
  Undef PFCOIL;			/* undefined */
  Undef MFPROBE;		/* undefined */
  Undef NGRP;			/* undefined */
  Undef GROUPDT;		/* undefined */
  Undef DATAMSE;		/* undefined */
  Undef DATAMSE;		/* undefined */
  Undef DATAMSE;		/* undefined */
  Undef GROUPDT;		/* undefined */
  Undef PFCOIL;			/* undefined */
  Undef DATAMSE;		/* undefined */
  Undef CbStr2UserMessage();	/* NO prototype */
  Undef FormatWrite2Read();	/* NO prototype */
  Undef IsKeyWordFound();	/* NO prototype */
  Undef ReadAI();		/* NO prototype */
  Undef CbStr2UserMessage();	/* NO prototype */
  Undef CbStr2UserWarning();	/* NO prototype */
  Undef PFReInitPFC();		/* NO prototype */
  Undef PFReInitPSC();		/* NO prototype */
  Undef FormatWrite2Read();	/* NO prototype */
  Undef CbStr2UserMessage();	/* NO prototype */
  Undef FormatWrite2Read();	/* NO prototype */
  Undef IsKeyWordFound();	/* NO prototype */
  Undef CbStr2UserWarning();	/* NO prototype */
  Undef ReadAI();		/* NO prototype */
  Undef LimPlot();		/* NO prototype */
  Undef IsKeyWordFound();	/* NO prototype */
  Undef CbStr2UserWarning();	/* NO prototype */
  Undef ReadAI();		/* NO prototype */
  Undef CbStr2UserWarning();	/* NO prototype */
  Undef ZPlotUTopMString();	/* NO prototype */
  Undef f2spl();		/* NO prototype */
  Undef splr0();		/* NO prototype */
  Undef ISignal2Splines();	/* NO prototype */
  Undef GetSVDExpansion4Wall();	/* NO prototype */
  Undef ZMessage();		/* NO prototype */
  Undef PFGiveRawAddress();	/* NO prototype */
  Undef ISignal2Splines();	/* NO prototype */
  Undef ZMessageF();		/* NO prototype */
  Undef GetRespFunction();	/* NO prototype */
  Undef MakeSignalF();		/* NO prototype */
  Undef ZPlotUTopMString();	/* NO prototype */
  Undef CbStr2UserMessage();	/* NO prototype */
  Undef CbStr2UserMessage();	/* NO prototype */
  Undef CbStr2UserMessage();	/* NO prototype */
  Undef f2spl();		/* NO prototype */
  Undef splr0();		/* NO prototype */
  Undef realpath();		/* NO prototype */
  Undef CbStr2UserMessage();	/* NO prototype */
  Undef IsKeyWordFound();	/* NO prototype */
  Undef ReadAI();		/* NO prototype */
  Undef CbStr2UserWarning();	/* NO prototype */
  Undef CbStr2UserMessage();	/* NO prototype */
  Undef IsRecordHeadFound();	/* NO prototype */
  Undef realpath();		/* NO prototype */
  Undef CbStr2UserMessage();	/* NO prototype */
  Undef CbStr2UserWarning();	/* NO prototype */
  Undef IsKeyWordFound();	/* NO prototype */
  Undef CbStr2UserWarning();	/* NO prototype */
  Undef CbStr2UserMessage();	/* NO prototype */
  Undef CbStr2UserMessage();	/* NO prototype */
  Undef ISignal2Splines();	/* NO prototype */
  Undef ISignal2Splines();	/* NO prototype */
  Undef ISignal2Splines();	/* NO prototype */
  Undef f2spl();		/* NO prototype */
  Undef splr0();		/* NO prototype */
  Undef tan();			/* NO prototype */
  Undef tan();			/* NO prototype */
  Undef IsKeyWordFound();	/* NO prototype */
  Undef ReadAI();		/* NO prototype */
  Undef CbStr2UserMessage();	/* NO prototype */
  Undef IsRecordHeadFound();	/* NO prototype */
  Undef CbStr2UserWarning();	/* NO prototype */
  Undef realpath();		/* NO prototype */
  Undef ZPlotUTopMString();	/* NO prototype */
  Undef f2spl();		/* NO prototype */
  Undef f2spl();		/* NO prototype */
  Undef splr0();		/* NO prototype */
  Undef ISignal2Splines();	/* NO prototype */
  Undef CbStr2UserMessage();	/* NO prototype */
  Undef MFPPlot();		/* NO prototype */
  Undef ppppp();		/* NO prototype */
  Undef CbStr2UserMessage();	/* NO prototype */
  Undef ESGetLabMetrics();	/* NO prototype */
  Undef ESSetSplA();		/* NO prototype */
  Undef splRA();		/* NO prototype */
  Undef ESIsOutsidePlasma();	/* NO prototype */
  Undef ESGetLabMetrics();	/* NO prototype */
  Undef ESSetSplA();		/* NO prototype */
  Undef splRA();		/* NO prototype */
  Undef ESGetMetrics();		/* NO prototype */
  Undef ESSetSplA();		/* NO prototype */
  Undef splRA();		/* NO prototype */
  Undef ESGetMetrics();		/* NO prototype */
  Undef ESSetSplA();		/* NO prototype */
  Undef splRA();		/* NO prototype */
  Undef ESGetMetrics();		/* NO prototype */
  Undef splRA();		/* NO prototype */
  Undef PSSetFileName();	/* NO prototype */
  Undef PSSetFileName();	/* NO prototype */
  Undef readefitk_();		/* NO prototype */
  Undef readefita_();		/* NO prototype */
  Undef ESSetSplA();		/* NO prototype */
  Undef splRA();		/* NO prototype */
  Undef ESSetSplA();		/* NO prototype */
  Undef splRA();		/* NO prototype */
  Undef spl();			/* NO prototype */
  Undef ESSetSplA();		/* NO prototype */
  Undef splRA();		/* NO prototype */
  Undef SetIspl();		/* NO prototype */
  Undef splR();			/* NO prototype */
  Undef spl();			/* NO prototype */
  Undef ESSetSplA();		/* NO prototype */
  Undef splRA();		/* NO prototype */
  Undef SetIspl();		/* NO prototype */
  Undef splR();			/* NO prototype */
  Undef readefitg_();		/* NO prototype */
  Undef getefitmsek_();		/* NO prototype */
  Undef CbStr2UserMessage();	/* NO prototype */
  extern int nDGr;		/* External */
  extern GROUPDT DGr[];		/* External */
  extern int nPFC1;		/* External */
  extern PFCOIL *PFC;		/* External */
  extern int nVVC;		/* External */
  extern PFCOIL *VVC;		/* External */
  extern int nMFP;		/* External */
  extern MFPROBE *MFP;		/* External */
  extern int nRawS;		/* External */
  extern GROUPDT *PGr;		/* External */
  extern int nPGr;		/* External */
  extern int nRawP;		/* External */
  extern int nRaw;		/* External */
  extern int nPFC;		/* External */
  extern int nMFLS;		/* External */
  extern int nMFp;		/* External */
  extern int nMFV;		/* External */
  extern unsigned int ESmemlevP;/* External */
  extern char TypeNm[][];	/* External */
  extern int nMFL;		/* External */
  extern int nMFS;		/* External */
  extern MFPROBE *MFS;		/* External */
  extern MFPROBE *MFp;		/* External */
  extern int nMFd;		/* External */
  extern MFPROBE *MFd;		/* External */
  extern MFPROBE *MFV;		/* External */
  extern MFPROBE *MFL;		/* External */
  extern int MSEFl;		/* External */
  extern DATAMSE MSE[];		/* External */
  extern int NMSE;		/* External */
  extern int nVVB;		/* External */
  extern double cgp;		/* External */
  extern int nMSS;		/* External */
  extern int MSSFl;		/* External */
  extern DATAMSE MSS[];		/* External */
  extern int nMSE;		/* External */
  extern double scMSE;		/* External */
  extern double RplG[];		/* External */
  extern int ESNp1;		/* External */
  extern double x0Mse;		/* External */
  extern double *EScs1;		/* External */
  extern double y0Mse;		/* External */
  extern double *ESsn1;		/* External */
  extern double cr2gp;		/* External */
  extern double *ESRLm;		/* External */
  extern int ESnLm;		/* External */
  extern double *ESZLm;		/* External */
  extern double ZplG[];		/* External */
  extern int kCol[];		/* External */
  extern double PFtWF1;		/* External */
  extern double PFtWF2;		/* External */
  extern double PFtWF;		/* External */
  extern int kTimeHistory;	/* External */
  extern PFBLOCK *PFB;		/* External */
  extern int iSignIp;		/* External */
  extern int iSignBt;		/* External */
  extern char ShotNm[];		/* External */
  extern double cr2;		/* External */
  extern double ESRext;		/* External */
  extern double crgm0;		/* External */
  extern double ESBt;		/* External */
  extern double ESRBt;		/* External */
  extern double ESTime;		/* External */
  extern double ESIpl;		/* External */
  extern int nPFB;		/* External */
  extern int ESNa1;		/* External */
  extern double *ESaZ0;		/* External */
  extern double *ESsb;		/* External */
  extern double *ESaR0;		/* External */
  extern int ESNa;		/* External */
  extern double *ESsr;		/* External */
  extern int ESNp;		/* External */
  extern double *ESsa;		/* External */
  extern double *ESdgY;		/* External */
  extern double *ESdgY2a;	/* External */
  extern double *ESFF;		/* External */
  extern double *ESFF2a;	/* External */
  extern double *ESgY;		/* External */
  extern double *ESgY2a;	/* External */
  extern double ESa0;		/* External */
  extern double *ESaF;		/* External */
  extern PSBLOCK *VVB;		/* External */
  extern int nPEC;		/* External */
  extern double *ESqgY;		/* External */
  extern double *ESqgY2a;	/* External */
  extern int nFList;		/* External */
  extern int NFList;		/* External */
  extern char FListEFIT[][];	/* External */
  extern int iFList;		/* External */
  extern char kFileExt[];	/* External */
  extern int ESkNormJ;		/* External */
  int PFSetShotNm();		/* No prototype */
  static int EFITnA;		/*  <ESC:pfcW.c */
  static double EFITaP[];	/*  <ESC:pfcW.c */
  static double EFITaT[];	/*  <ESC:pfcW.c */
#endif
#endif /* }======== End of Used External Variables ======= */

#endif /* }======== End of Use of Variables ======== */


#ifndef mzl_MLIB
extern double cr2;	/* undefined */
extern double cr3;	/* undefined */
extern double cr4;	/* undefined */
extern double cr6;	/* undefined */
extern double cr12;	/* undefined */
extern double cgp;	/* undefined */
extern double c2gp;	/* undefined */
extern double cgp_4;	/* undefined */
extern double cr2gp;	/* undefined */
extern double cgm0;	/* undefined */
extern double crgm0;	/* undefined */
#endif

#ifndef mzl_ESC
extern double ESTime;	/* undefined */
extern int ESkNormJ;	/* undefined */
extern int ESNa;	/* undefined */
extern int ESNa1;	/* undefined */
extern int ESNp;	/* undefined */
extern int ESNp1;	/* undefined */
extern double ESIpl;	/* undefined */
extern double ESBt;	/* undefined */
extern double ESRBt;	/* undefined */
extern double ESRext;	/* undefined */
extern double ESa0;	/* undefined */
extern double *ESsa;	/* undefined */
extern double *EScs1;	/* undefined */
extern double *ESsn1;	/* undefined */
extern double *ESsb;	/* undefined */
extern double *ESaR0;	/* undefined */
extern double *ESaZ0;	/* undefined */
extern double *ESsr;	/* undefined */
extern double *ESdgY;	/* undefined */
extern double *ESdgY2a;	/* undefined */
extern double *ESaF;	/* undefined */
extern double *ESFF;	/* undefined */
extern double *ESFF2a;	/* undefined */
extern double *ESqgY;	/* undefined */
extern double *ESqgY2a;	/* undefined */
extern double *ESgY;	/* undefined */
extern double *ESgY2a;	/* undefined */
static int EFITnA;	/*  */
static double EFITaP[];	/*  */
static double EFITaT[];	/*  */
#endif

#ifndef mzl_PFC
extern unsigned int ESmemlevP;	/* undefined */
extern int kTimeHistory;	/* undefined */
extern int iSignIp;		/* undefined */
extern int iSignBt;		/* undefined */

#ifndef stg_PlLim
extern int ESnLm;	/* undefined */
extern int *IndALm;	/* undefined */
extern double *ESRLm;	/* undefined */
extern double *ESZLm;	/* undefined */
extern double RplG[];	/* undefined */
extern double ZplG[];	/* undefined */
#endif

#ifndef stg_VacV
extern int nVVB;	/* undefined */
extern PSBLOCK *VVB;	/* undefined */
#endif

#ifndef stg_PSElecP
extern int nVVC;	/* undefined */
extern PFCOIL *VVC;	/* undefined */
#endif

#ifndef stg_MFProbe
extern int nMFP;	/* undefined */
extern int nMFL;	/* undefined */
extern int nMFS;	/* undefined */
extern int nMFLS;	/* undefined */
extern int nMFp;	/* undefined */
extern int nMFd;	/* undefined */
extern int nMFV;	/* undefined */
extern MFPROBE *MFP;	/* undefined */
extern MFPROBE *MFL;	/* undefined */
extern MFPROBE *MFS;	/* undefined */
extern MFPROBE *MFp;	/* undefined */
extern MFPROBE *MFd;	/* undefined */
extern MFPROBE *MFV;	/* undefined */
#endif

#ifndef stg_PFBlocks
extern int nPFB;	/* undefined */
extern PFBLOCK *PFB;	/* undefined */
#endif

#ifndef stg_ElecPar
extern int nPFC;	/* undefined */
extern int nPFC1;	/* undefined */
extern int nPEC;	/* undefined */
extern PFCOIL *PFC;	/* undefined */
#endif
extern int MSEFl;		/* undefined */
extern int MSSFl;		/* undefined */
extern int NMSE;		/* undefined */
extern int nMSE;		/* undefined */
extern int nMSS;		/* undefined */
extern DATAMSE MSE[];		/* undefined */
extern DATAMSE MSS[];		/* undefined */
extern double x0Mse;		/* undefined */
extern double y0Mse;		/* undefined */
extern double scMSE;		/* undefined */
static int MSEkAc[];		/* 0/1 - non-active/active beam line */
static int MSEkAs[];		/* 0/1 - non-active/active sight line */
static int MSEnS;		/* number of sight line of MSE */
static int MSEnC;		/* number of diagnostic MSE beams */
static double MSEga[][];	/* ga in JET MSE geometry */
static double MSEgW[][];	/*  */
static double MSEgd[][];	/* gd in JET MSE geometry */
static double MSEgq[][];	/* gq in JET MSE geometry */
static double MSER[][];		/*  */
static double MSEZ[][];		/*  */
static double MSEA1[][];	/*  */
static double MSEA2[][];	/*  */
static double MSEA3[][];	/*  */
static double MSEA4[][];	/*  */
static double MSEA5[][];	/*  */
static double MSEA6[][];	/*  */
static int nSmP;		/*  */
extern double PFtWF;		/* undefined */
extern double PFtWF1;		/* undefined */
extern double PFtWF2;		/* undefined */
static char Shot[];		/*  */
static char DTime[];		/*  */
static char Ext[];		/*  */
static char Nm[];		/*  */
extern int nDGr;		/* undefined */
extern int nPGr;		/* undefined */
extern int nRawP;		/* undefined */
extern GROUPDT DGr[];		/* undefined */
extern GROUPDT *PGr;		/* undefined */
static char IMg[][];		/*  */
static int PrGr[];		/*  */
static int PrDm[];		/*  */
static char PrNm[][];		/*  */
static int kG0;			/*  */
static int nGrI;		/*  */
static int iGrI;		/*  */
extern char TypeNm[][];		/* undefined */
extern int kCol[];		/* undefined */
extern int nRaw;		/* undefined */
extern int nRawS;		/* undefined */
extern int nRawP;		/* undefined */
static int NRaw;		/*  */
static RAWDATA *RawI;		/*  */
static RAWDATA *RawT;		/*  */
static RAWDATA *RawV;		/*  */
static RAWDATA *RawY;		/*  */
static RAWDATA *RawB;		/*  */
static RAWDATA *RawU;		/*  */
static RAWDATA *RawW;		/*  */
static RAWDATA *RawP;		/*  */
static RAWDATA *Raw;		/*  */
static RAWDATA *RawS;		/*  */
static double gaI[];		/*  */
static double gaS[];		/*  */
static double ga0;		/*  */
static double ga1;		/*  */
static double ga2;		/*  */
static double s1Y;		/*  */
static double s2Y;		/*  */
static double s1B;		/*  */
static double s2B;		/*  */
static double t1;		/*  */
static double t2;		/*  */
static int kAT;			/*  */
static int kG1;			/*  */
static char ln[];		/*  */
static int ExpDataFl;		/*  */
static int nEft;		/*  */
static double rEft[];		/*  */
static double zEft[];		/*  */
static int FlAmpTn;		/*  */
static char Mess[];		/*  */
extern char ShotNm[];		/* undefined */
static int iShot;		/*  */
extern int iFList;		/* undefined */
extern int nFList;		/* undefined */
extern int NFList;		/* undefined */
extern char FListEFIT[][];	/* undefined */
extern char kFileExt[];		/* undefined */

int PFIsKeyWordFound(lF,Message,Str,strF,n)
  FILE *lF;		/*  */
  char *Message;	/* Inp:File Name, Out: Error Message */
  char *Str;		/* Pattern for search */
  char *strF;		/* Out:Format string */
  int *n;		/* Out:Dimension of data */
{
/*
   */
#ifdef Doc_PFIsKeyWordFound
\section{Skeleton of PFIsKeyWordFound()}
  \begin{verbatim}
    PFIsKeyWordFound(){
    }
  \end{verbatim}
\section{PFIsKeyWordFound()}
\subsection{Manual}
\begin{itemize}
\item \c{DESCRIPTION:}
\item \c{ARGUMENTS:}
\item \c{EXTERNALS:}
\item \c{RETURN VALUE:}
\begin{itemize}
  \item{\bf Success: }
  \item{\bf Failure: }

    \begin{tabular}{lcl}
    \C{i=PFIsKeyWordFound();}& -&\em return value.\\
    \C{i == 1}& -&\em Your Comment\\
    \end{tabular}
\end{itemize}
\item \c{TIPS:}
{\em }
\item \c{BUGS:}
\item \c{SEE ALSO:}
\item \c{TO DO:}
\end{itemize}
#endif
}

int PFIfPatternFound(lF,Str)
  FILE *lF;	/* file pointer */
  char *Str;	/* pattern to search */
{
/*
   */
#ifdef Doc_PFIfPatternFound

\section{Skeleton of PFIfPatternFound()}
  \begin{verbatim}
    PFIfPatternFound(){
    }
  \end{verbatim}
\section{PFIfPatternFound()}
Routine searches for a pattern in the file *lF and leaves the file 
pointer right after the pattern in the case of success.
#endif
}

int PFReadAI(lF,Str,Ms,str,n,lv,dl,k)
  FILE *lF;	/*  */
  char *Str;	/*  */
  char *Ms;	/*  */
  char *str;	/*  */
  int n;	/*  */
  char **lv;	/*  */
  int *dl;	/*  */
  int k;	/*  */
{
  Undef CbStr2UserMessage();
/*
   */
#ifdef Doc_PFReadAI
\Section{Skeleton of \c{PFReadAI()}}
  \begin{verbatim}
    PFReadAI(){
    }
  \end{verbatim}
\Section{\c{PFReadAI()}}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\begin{tabular}{|llp{4in}|}\hline
\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&$$&\\
\c{}&$$&\\
\c{}&$$&\\
\c{}&$$&\\
\hline\end{tabular}
\Subsection{Output}
\vskip1ex\begin{tabular}{|llp{4in}|}\hline
\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&$$&\\
\c{}&$$&\\
\c{}&$$&\\
\c{}&$$&\\
\hline\end{tabular}
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int SetGroups()
{
  /*
   */
#ifdef Doc_SetGroups
\Section{Skeleton of \c{SetGroups()}}
  \begin{verbatim}
    SetGroups(){
    }
  \end{verbatim}
\Section{\c{SetGroups()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int PFDeInitWForms()
{
/*
   */
#ifdef Doc_PFDeInitWForms
\section{Skeleton of PFDeInitWForms()}
  \begin{verbatim}
    PFDeInitWForms(){
    }
  \end{verbatim}
\section{PFDeInitWForms()}
#endif
}

int PFInitWForms()
{
/*
   */
#ifdef Doc_PFInitWForms
\Section{Skeleton of \c{PFInitWForms()}}
  \begin{verbatim}
    PFInitWForms(){
    }
  \end{verbatim}
\Section{\c{PFInitWForms()}}
Routine initiates \c{Raw[]} and make mapping between signal enumeration
and code variables through \c{Raw[].kS} and \c{RawS[].kS}.

\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{calloc()}&$$&\\
\c{Undef }&\c{memcpy()}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int YearAO(lF)
  FILE *lF;	/*  */
{
  Undef NTYPEG;
  Undef FormatWrite2Read();
  /*
   */
#ifdef Doc_YearAO
\Section{Skeleton of \c{YearAO()}}
  \begin{verbatim}
    YearAO(){
    }
  \end{verbatim}
\Section{\c{YearAO()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{FILE }&\c{*lF}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{NTYPEG}&$$&\\
\c{Undef }&\c{FormatWrite2Read()}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int YearAI(lF)
  FILE *lF;	/*  */
{
  Undef NTYPEG;
  Undef IsKeyWordFound();
  Undef GROUPDT;
  Undef ReadAI();
  Undef CbStr2UserMessage();
  Undef CbStr2UserWarning();
  Undef PFReInitPFC();
  Undef PFCOIL;
  Undef PFReInitPSC();
  Undef MFPROBE;
  /*
   */
#ifdef Doc_YearAI
\Section{Skeleton of \c{YearAI()}}
  \begin{verbatim}
    YearAI(){
    }
  \end{verbatim}
\Section{\c{YearAI()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{FILE }&\c{*lF}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{NTYPEG}&$$&\\
\c{Undef }&\c{IsKeyWordFound()}&$$&\\
\c{Undef }&\c{GROUPDT}&$$&\\
\c{Undef }&\c{ReadAI()}&$$&\\
\c{Undef }&\c{CbStr2UserMessage()}&$$&\\
\c{Undef }&\c{CbStr2UserWarning()}&$$&\\
\c{Undef }&\c{PFReInitPFC()}&$$&\\
\c{Undef }&\c{PFCOIL}&$$&\\
\c{Undef }&\c{PFReInitPSC()}&$$&\\
\c{Undef }&\c{MFPROBE}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int PFYear()
{
  Undef NGRP;
  Undef GROUPDT;
  /*
   */
#ifdef Doc_PFYear
\Section{Skeleton of \c{PFYear()}}
  \begin{verbatim}
    PFYear(){
    }
  \end{verbatim}
\Section{\c{PFYear()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{NGRP}&$$&\\
\c{Undef }&\c{GROUPDT}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int PFGetMSEAngles(NmF)
  char *NmF;	/* Name of the file */
{
  Undef DATAMSE;
/*
   */
#ifdef Doc_PFGetMSEAngles

\section{Skeleton of PFGetMSEAngles()}
  \begin{verbatim}
    PFGetMSEAngles(){
    }
  \end{verbatim}
\section{PFGetMSEAngles()}
#endif
}

int PFWriteAngData(lF)
  FILE *lF;	/*  */
{
/*
   */
#ifdef Doc_PFWriteAngData

\section{Skeleton of PFWriteAngData()}
  \begin{verbatim}
    PFWriteAngData(){
    }
  \end{verbatim}
\section{PFWriteAngData()}
#endif
}

int PFReadAngData(lF)
  FILE *lF;	/*  */
{
/*
   */
#ifdef Doc_PFReadAngData

\section{Skeleton of PFReadAngData()}
  \begin{verbatim}
    PFReadAngData(){
    }
  \end{verbatim}
\section{PFReadAngData()}
#endif
}

int PFMSE_GeomAO(lF)
  FILE *lF;	/*  */
{
  Undef FormatWrite2Read();
/*
   */
#ifdef Doc_PFMSE_GeomAO
\Section{Skeleton of \c{PFMSE_GeomAO()}}
  \begin{verbatim}
    PFMSE_GeomAO(){
    }
  \end{verbatim}
\Section{\c{PFMSE_GeomAO()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{FILE }&\c{*lF}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{FormatWrite2Read()}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int PFMSE_GeomAI(lF)
  FILE *lF;	/*  */
{
  Undef CbStr2UserMessage();
/*
   */
#ifdef Doc_PFMSE_GeomAI
\Section{Skeleton of \c{PFMSE_GeomAI()}}
  \begin{verbatim}
    PFMSE_GeomAI(){
    }
  \end{verbatim}
\Section{\c{PFMSE_GeomAI()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{FILE }&\c{*lF}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{CbStr2UserMessage()}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int OldMSEGeom()
{
  extern double cgp;	/* undefined */
/*
   */
#ifdef Doc_OldMSEGeom
\Section{Skeleton of \c{OldMSEGeom()}}
  \begin{verbatim}
    OldMSEGeom(){
    }
  \end{verbatim}
\Section{\c{OldMSEGeom()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{extern double }&\c{cgp}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int PickUpMseLS(p,n)
  double *p;	/*  */
  int n;	/*  */
{
/*
   */
#ifdef Doc_PickUpMseLS
\Section{Skeleton of \c{PickUpMseLS()}}
  \begin{verbatim}
    PickUpMseLS(){
    }
  \end{verbatim}
\Section{\c{PickUpMseLS()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{double }&\c{*p}&$$&\\
\c{int }&\c{n}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int PickUpMseLP(p,n)
  double *p;	/*  */
  int n;	/*  */
{
  Undef DATAMSE;
/*
   */
#ifdef Doc_PickUpMseLP
\Section{Skeleton of \c{PickUpMseLP()}}
  \begin{verbatim}
    PickUpMseLP(){
    }
  \end{verbatim}
\Section{\c{PickUpMseLP()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{double }&\c{*p}&$$&\\
\c{int }&\c{n}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{memset()}&$$&\\
\c{Undef }&\c{DATAMSE}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int MSEGeomAO(lF)
  FILE *lF;	/*  */
{
  Undef FormatWrite2Read();
/*
   */
#ifdef Doc_MSEGeomAO
\Section{Skeleton of \c{MSEGeomAO()}}
  \begin{verbatim}
    MSEGeomAO(){
    }
  \end{verbatim}
\Section{\c{MSEGeomAO()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{FILE }&\c{*lF}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{FormatWrite2Read()}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int MSEGeomAI(lF)
  FILE *lF;	/*  */
{
  Undef DATAMSE;
  Undef IsKeyWordFound();
  Undef CbStr2UserWarning();
  Undef ReadAI();
/*
   */
#ifdef Doc_MSEGeomAI
\Section{Skeleton of \c{MSEGeomAI()}}
  \begin{verbatim}
    MSEGeomAI(){
    }
  \end{verbatim}
\Section{\c{MSEGeomAI()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{FILE }&\c{*lF}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{DATAMSE}&$$&\\
\c{Undef }&\c{IsKeyWordFound()}&$$&\\
\c{Undef }&\c{memset()}&$$&\\
\c{Undef }&\c{CbStr2UserWarning()}&$$&\\
\c{Undef }&\c{ReadAI()}&$$&\\
\c{Undef }&\c{GROUPDT}&$$&\\
\c{Undef }&\c{CbStr2UserMessage()}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int MSEDiagnosticPlot()
{
/*
   */
#ifdef Doc_MSEDiagnosticPlot

\section{Skeleton of MSEDiagnosticPlot()}
  \begin{verbatim}
    MSEDiagnosticPlot(){
    }
  \end{verbatim}
\section{MSEDiagnosticPlot()}
#endif
}

void MSEPickUpPlot(x0,y0,sc)
  double x0;	/*  */
  double y0;	/*  */
  double sc;	/*  */
{
  extern int ESNp1;	/* undefined */
  extern double *EScs1;	/* undefined */
  extern double *ESsn1;	/* undefined */
/*
   */
#ifdef Doc_MSEPickUpPlot
\Section{Skeleton of \c{MSEPickUpPlot()}}
  \begin{verbatim}
    MSEPickUpPlot(){
    }
  \end{verbatim}
\Section{\c{MSEPickUpPlot()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{double }&\c{x0}&$$&\\
\c{double }&\c{y0}&$$&\\
\c{double }&\c{sc}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{extern int }&\c{ESNp1}&$$&\\
\c{extern double }&\c{*EScs1}&$$&\\
\c{extern double }&\c{*ESsn1}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

void MSEGeomPlot()
{
  Undef LimPlot();
/*
   */
#ifdef Doc_MSEGeomPlot
\Section{Skeleton of \c{MSEGeomPlot()}}
  \begin{verbatim}
    MSEGeomPlot(){
    }
  \end{verbatim}
\Section{\c{MSEGeomPlot()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int MSEGeom()
{
  extern double cr2gp;	/* undefined */
/*
   */
#ifdef Doc_MSEGeom

\section{Skeleton of MSEGeom()}
  \begin{verbatim}
    MSEGeom(){
    }
  \end{verbatim}
\section{MSEGeom()}
Polarization angle is related to the component of the magnetic field by
\bqbl
&&
\tan\gg_m
=
\R{E_H}{E_V}
=
\\&&
-\R{B_z\cos\gd\cos(\gW+\ga)+\sin\gd(B_r\sin\gW-B_t\cos\gW)}
 {-B_z\sin\gq\cos\gd\sin(\gW+\ga)
 +\sin\gq\sin\gd(B_t\sin\gW+B_r\cos\gW)
 +\cos\gq\cos\gd(B_r\cos\ga-B_t\sin\ga)}
.\eqbl
Another form
\bqbl
&&
\tan\gg_m
=
\R{A_1*B_z+A_5*B_r+A_6*B_t}{A_4*B_z+A_3*B_r+A_2*B_t}
 ,\\&&
\tan\gg_m
=
\R{N_z*B_z+N_r*B_r+N_t*B_t}{D_z*B_z+D_r*B_r+D_t*B_t}
.\eqbl

#endif
}

int SigLayOutAO(lF)
  FILE *lF;	/*  */
{
/*
   */
#ifdef Doc_SigLayOutAO
\Section{Skeleton of \c{SigLayOutAO()}}
  \begin{verbatim}
    SigLayOutAO(){
    }
  \end{verbatim}
\Section{\c{SigLayOutAO()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{FILE }&\c{*lF}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int SigLayOutAI(lf)
  FILE *lf;	/*  */
{
  Undef IsKeyWordFound();
  Undef CbStr2UserWarning();
  Undef ReadAI();
/*
   */
#ifdef Doc_SigLayOutAI
\Section{Skeleton of \c{SigLayOutAI()}}
  \begin{verbatim}
    SigLayOutAI(){
    }
  \end{verbatim}
\Section{\c{SigLayOutAI()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{FILE }&\c{*lf}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{IsKeyWordFound()}&$$&\\
\c{Undef }&\c{ReadAI()}&$$&\\
\c{Undef }&\c{CbStr2UserWarning()}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int SetSensorC(SensorC,SensorG)
  double *SensorC;	/*  */
  double *SensorG;	/*  */
{
/*
   */
#ifdef Doc_SetSensorC
\Section{Skeleton of \c{SetSensorC()}}
  \begin{verbatim}
    SetSensorC(){
    }
  \end{verbatim}
\Section{\c{SetSensorC()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{double }&\c{*SensorC}&$$&\\
\c{double }&\c{*SensorG}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int PFSig2Raw()
{
/*
   */
#ifdef Doc_PFSig2Raw
\Section{Skeleton of \c{PFSig2Raw()}}
  \begin{verbatim}
    PFSig2Raw(){
    }
  \end{verbatim}
\Section{\c{PFSig2Raw()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

void SigLayOutXW()
{
/*
   */
#ifdef Doc_SigLayOutXW
\Section{Skeleton of \c{SigLayOutXW()}}
  \begin{verbatim}
    SigLayOutXW(){
    }
  \end{verbatim}
\Section{\c{SigLayOutXW()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int SigLayOut()
{
  Undef CbStr2UserWarning();
/*
   */
#ifdef Doc_SigLayOut
\Section{Skeleton of \c{SigLayOut()}}
  \begin{verbatim}
    SigLayOut(){
    }
  \end{verbatim}
\Section{\c{SigLayOut()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{CbStr2UserWarning()}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int PFSetTimeRange(kG)
  int kG;	/*  */
{
/*
   */
#ifdef Doc_PFSetTimeRange
\Section{Skeleton of \c{PFSetTimeRange()}}
  \begin{verbatim}
    PFSetTimeRange(){
    }
  \end{verbatim}
\Section{\c{PFSetTimeRange()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{int }&\c{kG}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int PlotRawWF(kG)
  int kG;	/*  */
{
  Undef ZPlotUTopMString();
  Undef f2spl();
  Undef splr0();
/*
   */
#ifdef Doc_PlotRawWF
\Section{Skeleton of \c{PlotRawWF()}}
  \begin{verbatim}
    PlotRawWF(){
    }
  \end{verbatim}
\Section{\c{PlotRawWF()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{int }&\c{kG}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{f2spl()}&$$&\\
\c{Undef }&\c{splr0()}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int CheckIfSplinedI(Fl)
  int Fl;	/*  */
{
  Undef ISignal2Splines();
/*
   */
#ifdef Doc_CheckIfSplinedI
\Section{Skeleton of \c{CheckIfSplinedI()}}
  \begin{verbatim}
    CheckIfSplinedI(){
    }
  \end{verbatim}
\Section{\c{CheckIfSplinedI()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{int }&\c{Fl}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{ISign2Splines()}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int TimeHistoryVirtualI()
{
  Undef GetSVDExpansion4Wall();
  Undef ZMessage();
  Undef PFGiveRawAddress();
/*
   */
#ifdef Doc_TimeHistoryVirtualI
\Section{Skeleton of \c{TimeHistoryVirtualI()}}
  \begin{verbatim}
    TimeHistoryVirtualI(){
    }
  \end{verbatim}
\Section{\c{TimeHistoryVirtualI()}}
Routine stores the initial guess of virtual voltages $V^{pl}_j(t)\propto
I^{pl}(t)$ in \c{Raw[j].V} array.

\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}

\Subsection{Description}
The relationship between the measured signal $S^i(t)$, physical variable
$B^i$ and the response function $r^i_j(t)$ is given by the convolution
integral with the source term $I_j(t)|_{t < t_0}=0$ 
\bqbl
B_i=\R{C_i}{G_i}S_i(t)
=
\R{C_i}{G_i}\sum_j\left[r^j_i(0)V_j(t)
 +\int^{t-t_0}_0r'^j_i(\gt)V_j(t-\gt)d\gt
 \right]
,\\
B^{eddy}_i=\R{C_i}{G_i}\left(S_i-\sum_jr^j_i(T)I_j\right)
.\eqbl
Here, $r_{t>T}=r(T)$ with $T$ is the characteristic time of saturation of
the eddy currents.

Expression of virtual currents $\taI^{pl}_j+\gd\taI^{pl}_j$ and
voltages $V^{pl}_j+\gd V^{pl}_j$ in terms of RHS $\gd I^{pl}_k$
\bqbl
\taI^{pl}_j
=
\sum_l\maJ^l_j\gY^{pl}_l
,\quad
\gd \gY^{pl}_l
=
\sum_k\maY^k_l\gd I^{pl}_k
,\quad
\gd\taI^{pl}_j
=
\sum_l\maJ^l_j\gd\gY^{pl}_l
=
\sum_k\left(\sum_l\maJ^l_j\maY^k_l\right)\gd I^{pl}_k
,\\
V^{pl}_j\equiv
\R{G_j}{C_j}\sum_l\maJ^l_j\gY^{pl}_l
,\quad
\maV^k_j\equiv
\R{G_j}{C_j}\sum_l\maJ^l_j\maY^k_l
,\quad
V^{pl}_j+\gd V^{pl}_j
=
V^{pl}_j+\sum_k\maV^k_j\gd I^{pl}_k
,\eqbl
where $V^{pl}_j$ stands for virtual voltage associated with the
background current distribution.
and of the eddy currents contribution
\bqbl
S^{PFC}_i
=
\sum_j\left[r^j_i(0)V^{PFC}_j(t)
 +\int^{t-t_0}_0r'^j_i(\gt)V^{PFC}_j(t-\gt)d\gt
 -r^j_i(T)V^{PFC}_j(t)
 \right]
,\\
S^{eddy,pl}_i
=
\sum_j\left[r^j_i(0)V^{pl}_j(t)
  +\int^{t-t_0}_0r'^j_i(\gt)V^{pl}_j(t-\gt)d\gt
  -r^j_i(T)V^{pl}_j(t)
  \right]
,\\
\gd S^{eddy,pl}_i
=
\sum_j\left[r^j_i(0)+r'^j_i(0)\R{d\gt}{2}-r^j_i(T)\right]\gd V^{pl}_j(t)
=
\sum_k\sum_j\left[r^j_i(0)-r^j_i(T)+r'^j_i(0)\R{d\gt}{2}\right]\maV^k_j
\gd I^{pl}_k
,\\
\gd S^{eddy,pl}_i
=
\sum_k\sum_j\msr^j_i\maV^k_j\gd I^{pl}_k
,\quad
\msr^j_i
\equiv
r^j_i(0)-r^j_i(T)+r'^j_i(0)\R{d\gt}{2}
.\eqbl
The system of equations for $\gd I^{pl}_k$
\bqbl
\vaB=\maC\vaS
,\quad
\maC^j_i=\R{C_i}{G_i}\gd^j_i
,\quad
\sum_k\left(\maB^k_i+\R{C_i}{G_i}\sum_j\msr^j_i\maV^k_j\right)\gd I^{pl}_k
=
\R{C_i}{G_i}(S_i-S^{PFC}_i-S^{eddy,pl}_i)-B^{pl}_i
.\eqbl

\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{GetSVDExpansion4Wall()}&$$&\\
\c{Undef }&\c{ZMessage()}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int IfSplinedDiamag()
{
  Undef ISignal2Splines();
/*
   */
#ifdef Doc_IfSplinedDiamag
\Section{Skeleton of \c{IfSplinedDiamag()}}
  \begin{verbatim}
    IfSplinedDiamag(){
    }
  \end{verbatim}
\Section{\c{IfSplinedDiamag()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{ISignal2Splines()}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int TimeHistorySignal(Fl)
  int Fl;	/*  */
{
  Undef ZMessageF();
  Undef GetRespFunction();
  Undef MakeSignalF();
/*
   */
#ifdef Doc_TimeHistorySignal
\Section{Skeleton of \c{TimeHistorySignal()}}
  \begin{verbatim}
    TimeHistorySignal(){
    }
  \end{verbatim}
\Section{\c{TimeHistorySignal()}}
Routine generates the contribution $S^{PFC}_i(t)$ and stores it in the
\c{RawY[i].V0} array.
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{int }&\c{Fl}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
The system of equations for $\gd I^{pl}_k$
\bqbl
\vaB=\maC\vaS
,\quad
\maC^j_i=\R{C_i}{G_i}\gd^j_i
,\quad
\sum_k\left(\maB^k_i+\R{C_i}{G_i}\sum_j\msr^j_i\maV^k_j\right)\gd I^{pl}_k
=
\R{C_i}{G_i}(S_i-S^{PFC}_i-S^{eddy,pl}_i)-B^{pl}_i
.\eqbl
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{ZMessageF()}&$$&\\
\c{Undef }&\c{memset()}&$$&\\
\c{Undef }&\c{GetRespFunction()}&$$&\\
\c{Undef }&\c{MakeSignalF()}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int WFormYBO(lF)
  FILE *lF;	/*  */
{
/*
   */
#ifdef Doc_WFormYBO
\Section{Skeleton of \c{WFormYBO()}}
  \begin{verbatim}
    WFormYBO(){
    }
  \end{verbatim}
\Section{\c{WFormYBO()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{FILE }&\c{*lF}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{fwrite()}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int WFormYBI(lF)
  FILE *lF;	/*  */
{
/*
   */
#ifdef Doc_WFormYBI
\Section{Skeleton of \c{WFormYBI()}}
  \begin{verbatim}
    WFormYBI(){
    }
  \end{verbatim}
\Section{\c{WFormYBI()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{FILE }&\c{*lF}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{fread()}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int WFormPBO(lF)
  FILE *lF;	/*  */
{
/*
   */
#ifdef Doc_WFormPBO
\Section{Skeleton of \c{WFormPBO()}}
  \begin{verbatim}
    WFormPBO(){
    }
  \end{verbatim}
\Section{\c{WFormPBO()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{FILE }&\c{*lF}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{fwrite()}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int WFormPBI(lF)
  FILE *lF;	/*  */
{
/*
   */
#ifdef Doc_WFormPBI
\Section{Skeleton of \c{WFormPBI()}}
  \begin{verbatim}
    WFormPBI(){
    }
  \end{verbatim}
\Section{\c{WFormPBI()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{FILE }&\c{*lF}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{fread()}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int PlotSplinedWF(kG)
  int kG;	/*  */
{
  Undef ZPlotUTopMString();
/*
   */
#ifdef Doc_PlotSplinedWF
\Section{Skeleton of \c{PlotSplinedWF()}}
  \begin{verbatim}
    PlotSplinedWF(){
    }
  \end{verbatim}
\Section{\c{PlotSplinedWF()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{int }&\c{kG}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

void PlotVirtualI()
{
/*
   */
#ifdef Doc_PlotVirtualI
\Section{Skeleton of \c{PlotVirtualI()}}
  \begin{verbatim}
    PlotVirtualI(){
    }
  \end{verbatim}
\Section{\c{PlotVirtualI()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

void PlotPlasmaAndEddyWForm()
{
  Undef CbStr2UserMessage();
/*
   */
#ifdef Doc_PlotPlasmaAndEddyWForm
\Section{Skeleton of \c{PlotPlasmaAndEddyWForm()}}
  \begin{verbatim}
    PlotPlasmaAndEddyWForm(){
    }
  \end{verbatim}
\Section{\c{PlotPlasmaAndEddyWForm()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{CbStr2UserMessage()}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

void PlotPFCWFormY()
{
  Undef CbStr2UserMessage();
/*
   */
#ifdef Doc_PlotPFCWFormY
\Section{Skeleton of \c{PlotPFCWFormY()}}
  \begin{verbatim}
    PlotPFCWFormY(){
    }
  \end{verbatim}
\Section{\c{PlotPFCWFormY()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{CbStr2UserMessage()}&$$&\\
\c{Undef }&\c{memset()}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

void PlotPFCWFormW()
{
  Undef CbStr2UserMessage();
/*
   */
#ifdef Doc_PlotPFCWFormW
\Section{Skeleton of \c{PlotPFCWFormW()}}
  \begin{verbatim}
    PlotPFCWFormW(){
    }
  \end{verbatim}
\Section{\c{PlotPFCWFormW()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{CbStr2UserMessage()}&$$&\\
\c{Undef }&\c{memset()}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int PlotSplinedAndRawWF(kG)
  int kG;	/*  */
{
/*
   */
#ifdef Doc_PlotSplinedAndRawWF
\Section{Skeleton of \c{PlotSplinedAndRawWF()}}
  \begin{verbatim}
    PlotSplinedAndRawWF(){
    }
  \end{verbatim}
\Section{\c{PlotSplinedAndRawWF()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{int }&\c{kG}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

void PlotWForm()
{
/*
   */
#ifdef Doc_PlotWForm
\Section{Skeleton of \c{PlotWForm()}}
  \begin{verbatim}
    PlotWForm(){
    }
  \end{verbatim}
\Section{\c{PlotWForm()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

void PlotSplinedWForm()
{
/*
   */
#ifdef Doc_PlotSplinedWForm
\Section{Skeleton of \c{PlotSplinedWForm()}}
  \begin{verbatim}
    PlotSplinedWForm(){
    }
  \end{verbatim}
\Section{\c{PlotSplinedWForm()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

void PlotSplinedAndRawWForm()
{
/*
   */
#ifdef Doc_PlotSplinedAndRawWForm
\Section{Skeleton of \c{PlotSplinedAndRawWForm()}}
  \begin{verbatim}
    PlotSplinedAndRawWForm(){
    }
  \end{verbatim}
\Section{\c{PlotSplinedAndRawWForm()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int TimeSlice(kG)
  int kG;	/*  */
{
  Undef f2spl();
  Undef splr0();
/*
   */
#ifdef Doc_TimeSlice
\Section{Skeleton of \c{TimeSlice()}}
  \begin{verbatim}
    TimeSlice(){
    }
  \end{verbatim}
\Section{\c{TimeSlice()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{int }&\c{kG}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{f2spl()}&$$&\\
\c{Undef }&\c{splr0()}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int PlotTimeSlice(kG)
  int kG;	/*  */
{
/*
   */
#ifdef Doc_PlotTimeSlice
\Section{Skeleton of \c{PlotTimeSlice()}}
  \begin{verbatim}
    PlotTimeSlice(){
    }
  \end{verbatim}
\Section{\c{PlotTimeSlice()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{int }&\c{kG}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int WFormIpAO(lF)
  FILE *lF;	/*  */
{
  Undef realpath();
  Undef CbStr2UserMessage();
  /*
   */
#ifdef Doc_WFormIpAO
\Section{Skeleton of \c{WFormIpAO()}}
  \begin{verbatim}
    WFormIpAO(){
    }
  \end{verbatim}
\Section{\c{WFormIpAO()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{FILE }&\c{*lF}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{realpath()}&$$&\\
\c{Undef }&\c{CbStr2UserMessage()}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int WFormIpAI(lF)
  FILE *lF;	/*  */
{
  Undef IsKeyWordFound();
  Undef ReadAI();
  Undef CbStr2UserWarning();
  Undef CbStr2UserMessage();
  Undef IsRecordHeadFound();
  Undef realpath();
/*
   */
#ifdef Doc_WFormIpAI
\Section{Skeleton of \c{WFormIpAI()}}
  \begin{verbatim}
    WFormIpAI(){
    }
  \end{verbatim}
\Section{\c{WFormIpAI()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{FILE }&\c{*lF}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{IsKeyWordFound()}&$$&\\
\c{Undef }&\c{ReadAI()}&$$&\\
\c{Undef }&\c{CbStr2UserWarning()}&$$&\\
\c{Undef }&\c{CbStr2UserMessage()}&$$&\\
\c{Undef }&\c{IsRecordHeadFound()}&$$&\\
\c{Undef }&\c{fread()}&$$&\\
\c{Undef }&\c{void}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int WFormIpBI(lF)
  FILE *lF;	/*  */
{
  Undef CbStr2UserMessage();
  Undef CbStr2UserWarning();
/*
   */
#ifdef Doc_WFormIpBI
\Section{Skeleton of \c{WFormIpBI()}}
  \begin{verbatim}
    WFormIpBI(){
    }
  \end{verbatim}
\Section{\c{WFormIpBI()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{FILE }&\c{*lF}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{fread()}&$$&\\
\c{Undef }&\c{CbStr2UserMessage()}&$$&\\
\c{Undef }&\c{CbStr2UserWarning()}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int PFReadWFormAI(lf,kG)
  FILE *lf;	/*  */
  int kG;	/*  */
{
  Undef IsKeyWordFound();
  Undef CbStr2UserWarning();
  Undef CbStr2UserMessage();
/*
   */
#ifdef Doc_PFReadWFormAI
\Section{Skeleton of \c{PFReadWFormAI()}}
  \begin{verbatim}
    PFReadWFormAI(){
    }
  \end{verbatim}
\Section{\c{PFReadWFormAI()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{FILE }&\c{*lf}&$$&\\
\c{int }&\c{kG}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{CbStr2UserWarning()}&$$&\\
\c{Undef }&\c{CbStr2UserMessage()}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int PFReadWFormIpAI(lf)
  FILE *lf;	/*  */
{
  Undef CbStr2UserMessage();
  /*
   */
#ifdef Doc_PFReadWFormIpAI
\Section{Skeleton of \c{PFReadWFormIpAI()}}
  \begin{verbatim}
    PFReadWFormIpAI(){
    }
  \end{verbatim}
\Section{\c{PFReadWFormIpAI()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{FILE }&\c{*lf}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{CbStr2UserMessage()}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int GetJETI(FlR)
  int FlR;	/*  */
{
/*
   */
#ifdef Doc_GetJETI
\Section{Skeleton of \c{GetJETI()}}
  \begin{verbatim}
    GetJETI(){
    }
  \end{verbatim}
\Section{\c{GetJETI()}}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\begin{tabular}{|llp{4in}|}\hline
\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&$$&\\
\c{}&$$&\\
\c{}&$$&\\
\c{}&$$&\\
\hline\end{tabular}
\Subsection{Output}
\vskip1ex\begin{tabular}{|llp{4in}|}\hline
\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&$$&\\
\c{}&$$&\\
\c{}&$$&\\
\c{}&$$&\\
\hline\end{tabular}
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int WFormIp()
{
  Undef ISignal2Splines();
  extern double cr2;	/* undefined */
  int PFSetShotNm();	/* No prototype */
/*
   */
#ifdef Doc_WFormIp
\Section{Skeleton of \c{WFormIp()}}
  \begin{verbatim}
    WFormIp(){
    }
  \end{verbatim}
\Section{\c{WFormIp()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{ISignal2Splines()}&$$&\\
\c{extern double }&\c{cr2}&$$&\\
\c{int }&\c{PFSetShotNm()}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int WFormI()
{
  Undef ISignal2Splines();
/*
   */
#ifdef Doc_WFormI
\Section{Skeleton of \c{WFormI()}}
  \begin{verbatim}
    WFormI(){
    }
  \end{verbatim}
\Section{\c{WFormI()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{ISignal2Splines()}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int PlotSnapShotIp()
{
/*
   */
#ifdef Doc_PlotSnapShotIp
\section{Skeleton of PlotSnapShotIp()}
  \begin{verbatim}
    PlotSnapShotIp(){
    }
  \end{verbatim}
\section{PlotSnapShotIp()}
\subsection{Manual}
\begin{itemize}
\item \c{DESCRIPTION:}
\item \c{ARGUMENTS:}
\item \c{EXTERNALS:}
\item \c{RETURN VALUE:}
\begin{itemize}
  \item{\bf Success: }
  \item{\bf Failure: }

    \begin{tabular}{lcl}
    \C{i=PlotSnapShotIp();}& -&\em return value.\\
    \C{i == 1}& -&\em Your Comment\\
    \end{tabular}
\end{itemize}
\item \c{TIPS:}
{\em }
\item \c{BUGS:}
\item \c{SEE ALSO:}
\item \c{TO DO:}
\end{itemize}
#endif
}

int PlotSnapShotY(FlY)
  int FlY;	/*  */
{
/*
   */
#ifdef Doc_PlotSnapShotY
\section{Skeleton of PlotSnapShotY()}
  \begin{verbatim}
    PlotSnapShotY(){
    }
  \end{verbatim}
\section{PlotSnapShotY()}
\subsection{Manual}
\begin{itemize}
\item \c{DESCRIPTION:}
\item \c{ARGUMENTS:}
\item \c{EXTERNALS:}
\item \c{RETURN VALUE:}
\begin{itemize}
  \item{\bf Success: }
  \item{\bf Failure: }

    \begin{tabular}{lcl}
    \C{i=PlotSnapShotY();}& -&\em return value.\\
    \C{i == 1}& -&\em Your Comment\\
    \end{tabular}
\end{itemize}
\item \c{TIPS:}
{\em }
\item \c{BUGS:}
\item \c{SEE ALSO:}
\item \c{TO DO:}
\end{itemize}
#endif
}

int GetJETgY()
{
/*
   */
#ifdef Doc_GetJETgY
\Section{Skeleton of \c{GetJETgY()}}
  \begin{verbatim}
    GetJETgY(){
    }
  \end{verbatim}
\Section{\c{GetJETgY()}}
Example of routines which read the raw coils data and magnetic signals
while making compensation of the toroidal field contribution.
\Subsection{Description}
ID of the Circuit data: \c{PF/SC-Nm<MS}, where \c{Nm} is the name of the
circuit. 

Compensated magnetic signal $S$ has the representation
\bqbl
&&
S=S^u-C^eS^e_{TFC}-C^oS^o_{TFC}
,\eqbl 
where $S^u$ is uncompensated data, $C^e,C^o$ are ``even'' and ``odd''
coefficients, $S^e_{TFC},S^o_{TFC}$ are  ``even'' and ``odd'' TFC signals.

Uncompendated signal has the ID of the form \c{DA/C2-Nm}, $C^e,C^o$ are
defined by their IDs \c{DA/C2-Nm<TFE}, \c{DA/C2-Nm<TFO}, and
$S^e_{TFC},S^o_{TFC}$ data have the ID \c{DA/C2-ITFEVN}, \c{DA/C2-ITFODD}.

Calculation of the plasma currents
\bqbl
I_{pl}
=
\R{1}{\gm_0}\sum^{i<18}_{i=0}B_{pi}l_i
-\sum^{i<4}_{i=0}N_{Di}I_{Di}
-I_{RRU}
-I_{RRL}
,\\
I^{C2}_{pl}
=
\R{1}{\gm_0}\sum^{i<18}_{i=0}B_{pi}l_i
-\sum^{i<4}_{i=0}n_{Di}I_{Di}
-\R{V_{RRU}+V_{RRL}}{R_{RRU}}
.\eqbl
Plasma displacements
\bqbl
Z_{pl}
=
\R{1}{\gm_0I_{pl}}\sum^{i<18}_{i=0}\left(B_{pi}-\sum^{k<4}_{k=0}B_{pi,k}I_{Dk}\right)l_iZ_i
,\\
X_{pl}
=
\R{1}{\gm_0I_{pl}2R_{ext}}\sum^{i<18}_{i=0}
\left(B_{pi}-\sum^{k<4}_{k=0}B_{pi,k}I_{Dk}\right)l_i(R^2_i-R^2_{ext})
.\eqbl
Plasma displacements
\bqbl
Z_{pl}
=
\R{1}{\gm_0I_{pl}}\sum^{i<18}_{i=0}\left(B_{pi}-\sum^{k<4}_{k=0}B_{pi,k}I_{Dk}\right)l_iZ_i
,\\
X_{pl}
=
\R{1}{\gm_0I_{pl}2R_{ext}}\sum^{i<18}_{i=0}
\left(B_{pi}-\sum^{k<4}_{k=0}B_{pi,k}I_{Dk}\right)l_i(R^2_i-R^2_{ext})
.\eqbl

\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\begin{tabular}{|llp{4in}|}\hline
\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&$$&\\
\c{}&$$&\\
\c{}&$$&\\
\c{}&$$&\\
\hline\end{tabular}
\Subsection{Output}
\vskip1ex\begin{tabular}{|llp{4in}|}\hline
\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&$$&\\
\c{}&$$&\\
\c{}&$$&\\
\c{}&$$&\\
\hline\end{tabular}
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int PFWriteWFormAO(lf,kG)
  FILE *lf;	/*  */
  int kG;	/*  */
{
/*
   */
#ifdef Doc_PFWriteWFormAO
\Section{Skeleton of \c{PFWriteWFormAO()}}
  \begin{verbatim}
    PFWriteWFormAO(){
    }
  \end{verbatim}
\Section{\c{PFWriteWFormAO()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{FILE }&\c{*lf}&$$&\\
\c{int }&\c{kG}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int WFormY()
{
  Undef ISignal2Splines();
/*
   */
#ifdef Doc_WFormY
\Section{Skeleton of \c{WFormY()}}
  \begin{verbatim}
    WFormY(){
    }
  \end{verbatim}
\Section{\c{WFormY()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{ISignal2Splines()}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int PTimeSlice(iG)
  int iG;	/*  */
{
  Undef f2spl();
  Undef splr0();
  Undef tan();
/*
   */
#ifdef Doc_PTimeSlice
\Section{Skeleton of \c{PTimeSlice()}}
  \begin{verbatim}
    PTimeSlice(){
    }
  \end{verbatim}
\Section{\c{PTimeSlice()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{int }&\c{iG}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{f2spl()}&$$&\\
\c{Undef }&\c{splr0()}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int PTimeSlicePL(lP,iG,Fl)
  RAWDATA *lP;	/*  */
  int iG;	/*  */
  int Fl;	/*  */
{
  Undef tan();
/*
   */
#ifdef Doc_PTimeSlicePL
\Section{Skeleton of \c{PTimeSlicePL()}}
  \begin{verbatim}
    PTimeSlicePL(){
    }
  \end{verbatim}
\Section{\c{PTimeSlicePL()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{RAWDATA }&\c{*lP}&$$&\\
\c{int }&\c{iG}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int WFormPAI(lF)
  FILE *lF;	/*  */
{
  Undef IsKeyWordFound();
  Undef GROUPDT;
  Undef ReadAI();
  Undef CbStr2UserMessage();
  Undef IsRecordHeadFound();
  Undef CbStr2UserWarning();
  Undef realpath();
/*
   */
#ifdef Doc_WFormPAI
\Section{Skeleton of \c{WFormPAI()}}
  \begin{verbatim}
    WFormPAI(){
    }
  \end{verbatim}
\Section{\c{WFormPAI()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{FILE }&\c{*lF}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{IsKeyWordFound()}&$$&\\
\c{Undef }&\c{GROUPDT}&$$&\\
\c{Undef }&\c{ReadAI()}&$$&\\
\c{Undef }&\c{CbStr2UserMessage()}&$$&\\
\c{Undef }&\c{IsRecordHeadFound()}&$$&\\
\c{Undef }&\c{CbStr2UserWarning()}&$$&\\
\c{Undef }&\c{fread()}&$$&\\
\c{Undef }&\c{void}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}
static RAWDATA *lP0;	/*  */

void WFormPPL()
{
  Undef ZPlotUTopMString();
  Undef f2spl();
/*
   */
#ifdef Doc_WFormPPL
\Section{Skeleton of \c{WFormPPL()}}
  \begin{verbatim}
    WFormPPL(){
    }
  \end{verbatim}
\Section{\c{WFormPPL()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{ZPlotUTopMString()}&$$&\\
\c{Undef }&\c{f2spl()}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int WFormP()
{
/*
   */
#ifdef Doc_WFormP
\Section{Skeleton of \c{WFormP()}}
  \begin{verbatim}
    WFormP(){
    }
  \end{verbatim}
\Section{\c{WFormP()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int TimeSliceOfAll()
{
  Undef f2spl();
  Undef splr0();
/*
   */
#ifdef Doc_TimeSliceOfAll
\Section{Skeleton of \c{TimeSliceOfAll()}}
  \begin{verbatim}
    TimeSliceOfAll(){
    }
  \end{verbatim}
\Section{\c{TimeSliceOfAll()}}
Routine stores a time slice of signals and errror bars, converted into
the physical quantities, in either \c{PFC[j].I0,PFC[j].dI} or
\c{MFP[i].S0,MFP[i].dS}. If the time history exists, then the
contribution $S^{PFC}_i$ of PFC (converted into the physical quantities)
is strored in \c{MFP[i].V0}.
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
The system of equations for $\gd I^{pl}_k$
\bqbl
\vaB=\maC\vaS
,\quad
\maC^j_i=\R{C_i}{G_i}\gd^j_i
,\quad
\sum_k\left(\maB^k_i+\R{C_i}{G_i}\sum_j\msr^j_i\maV^k_j\right)\gd I^{pl}_k
=
\R{C_i}{G_i}(S_i-S^{PFC}_i-S^{eddy,pl}_i)-B^{pl}_i
.\eqbl
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{f2spl()}&$$&\\
\c{Undef }&\c{splr0()}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int PlotSnapShotI()
{
/*
   */
#ifdef Doc_PlotSnapShotI
\section{Skeleton of PlotSnapShotI()}
  \begin{verbatim}
    PlotSnapShotI(){
    }
  \end{verbatim}
\section{PlotSnapShotI()}
\subsection{Manual}
\begin{itemize}
\item \c{DESCRIPTION:}
\item \c{ARGUMENTS:}
\item \c{EXTERNALS:}
\item \c{RETURN VALUE:}
\begin{itemize}
  \item{\bf Success: }
  \item{\bf Failure: }

    \begin{tabular}{lcl}
    \C{i=PlotSnapShotI();}& -&\em return value.\\
    \C{i == 1}& -&\em Your Comment\\
    \end{tabular}
\end{itemize}
\item \c{TIPS:}
{\em }
\item \c{BUGS:}
\item \c{SEE ALSO:}
\item \c{TO DO:}
\end{itemize}
#endif
}

int AsymData(lF)
  FILE *lF;	/*  */
{
  extern double ESRext;	/* undefined */
  extern double crgm0;	/* undefined */
  extern double ESBt;	/* undefined */
  /*
   */
#ifdef Doc_AsymData
\Section{Skeleton of \c{AsymData()}}
  \begin{verbatim}
    AsymData(){
    }
  \end{verbatim}
\Section{\c{AsymData()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{FILE }&\c{*lF}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
Plasma current (JET and ESC)
\bqbl
I^{JET}_{3,7}
=
\R{1}{\gm_0}\sum^{i\leq18}_{i=1}B^i_{3,7}L^i
-\sum^{k\leq4}_{k=1}n_{Dk}I^k_{D}
-aI_{MKII}
-\R{V_{LRRU}+V_{LRRL}}{R_{RR}}I_{RRU}
,\\
I^{ESC}_{3,7}
=
\R{1}{\gm_0}\sum^{i\leq18}_{i=1}\left(
 B^i_{3,7}
 -\sum^{k\leq4}_{k=1}B^i_{Dk}I^k_{D}
 -B^i_{RRU}I_{RRU}
 -B^i_{RRL}I_{RRL}
\right)L^i
.\eqbl
Vertical displacement ($R_0=2.96$)
\bqbl
Z^{JET}_{3,7}
=
\R{1}{I_{3,7}}\left(
\sum^{i\leq18}_{i=1}C^{zB}_iB^i_{3,7}
+\sum^{i\leq14}_{i=1}C^{zS}_i\gY^i_{S3,7}
 +\sum^{k\leq4}_{k=1}C_{zDk}I^k_{D}
 +C^{zV}V_{U}
 +C^{zV}V_{L}
 +C^{zI}I_{MK2}
\right)
,\\
Z^{ESC}_{3,7}
=
\R{1}{\gm_0I_{3,7}}\sum^{i\leq18}_{i=1}\left(
 B^i_{3,7}
 -\sum^{k\leq4}_{k=1}B^i_{Dk}I^k_{D}
 -B^i_{RRU}I_{RRU}
 -B^i_{RRL}I_{RRL}
\right)L^iz^i
,\\
R^{ESC}_{3,7}-R_0
=
\R{1}{\gm_0I_{3,7}}\sum^{i\leq18}_{i=1}\left(
 B^i_{3,7}
 -\sum^{k\leq4}_{k=1}B^i_{Dk}I^k_{D}
 -B^i_{RRU}I_{RRU}
 -B^i_{RRL}I_{RRL}
\right)L^i\R{{R^i}^2-R^2_0}{2R_0}
,\\
X^{JET}_{3,7}
=
\R{1}{I_{3,7}}\left(
\sum^{i\leq18}_{i=1}C^{xB}_iB^i_{3,7}
+\sum^{i\leq14}_{i=1}C^{xS}_i\gY^i_{S3,7}
 +\sum^{k\leq4}_{k=1}C_{xDk}I^k_{D}
 +C^{xV}V_{U}
 +C^{xV}V_{L}
 +C^{xI}I_{MK2}
\right)
.\eqbl
\bqbl
I_{surf}
\equiv
2ai_{\gf}
=
-a\gx_{11}\R{4B_\gf}{R_0\gm_0}
\lbq{eq:Isurf}
,\eqbl
\bqbl
\gx_{11}
\simeq
\R{Z_7-Z_3}{2}
,\eqbl
while the minor plasma radius $a$ is calculated as
\bqbl
a\simeq
Z_{top}-Z_7
.\eqbl
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{extern double }&\c{ESRext}&$$&\\
\c{extern double }&\c{crgm0}&$$&\\
\c{extern double }&\c{ESBt}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int SnapShot()
{
  Undef ISignal2Splines();
  Undef CbStr2UserMessage();
  extern double ESRBt;	/* undefined */
  extern double ESTime;	/* undefined */
  extern double ESIpl;	/* undefined */
/*
   */
#ifdef Doc_SnapShot
\section{Skeleton of SnapShot()}
  \begin{verbatim}
    SnapShot(){
    }
  \end{verbatim}
\section{SnapShot()}
\subsection{Manual}
\begin{itemize}
\item \c{DESCRIPTION:}
\item \c{ARGUMENTS:}
\item \c{EXTERNALS:}
\item \c{RETURN VALUE:}
\begin{itemize}
  \item{\bf Success: }
  \item{\bf Failure: }

    \begin{tabular}{lcl}
    \C{i=SnapShot();}& -&\em return value.\\
    \C{i == 1}& -&\em Your Comment\\
    \end{tabular}
\end{itemize}
\item \c{TIPS:}
{\em }
\item \c{BUGS:}
\item \c{SEE ALSO:}
\item \c{TO DO:}
\end{itemize}
#endif
}
static int SignFl;	/*  */

int PFEfitBoundPlot()
{
/*
   */
#ifdef Doc_PFEfitBoundPlot

\section{Skeleton of PFEfitBoundPlot()}
  \begin{verbatim}
    PFEfitBoundPlot(){
    }
  \end{verbatim}
\section{PFEfitBoundPlot()}
#endif
}

void MFSignalPlot()
{
  Undef MFPPlot();
/*
   */
#ifdef Doc_MFSignalPlot
\section{Skeleton of MFSignalPlot()}
  \begin{verbatim}
    MFSignalPlot(){
    }
  \end{verbatim}
\section{MFSignalPlot()}
#endif
}

int PFSaveExpData(lF)
  FILE *lF;	/*  */
{
/*
   */
#ifdef Doc_PFSaveExpData

\section{Skeleton of PFSaveExpData()}
  \begin{verbatim}
    PFSaveExpData(){
    }
  \end{verbatim}
\section{PFSaveExpData()}
#endif
}

int MSESetCoeff()
{
  Undef ppppp();
/*
   */
#ifdef Doc_MSESetCoeff
\section{Skeleton of MSESetCoeff()}
  \begin{verbatim}
    MSESetCoeff(){
    }
  \end{verbatim}
\section{MSESetCoeff()}
#endif
}

int PFReadExpData(lF)
  FILE *lF;	/*  */
{
/*
   */
#ifdef Doc_PFReadExpData

\section{Skeleton of PFReadExpData()}
  \begin{verbatim}
    PFReadExpData(){
    }
  \end{verbatim}
\section{PFReadExpData()}
#endif
}

int PFExpDataAO(lF)
  FILE *lF;	/*  */
{
/*
   */
#ifdef Doc_PFExpDataAO
\Section{Skeleton of \c{PFExpDataAO()}}
  \begin{verbatim}
    PFExpDataAO(){
    }
  \end{verbatim}
\Section{\c{PFExpDataAO()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{FILE }&\c{*lF}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{fputs()}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int PFExpDataAI(lF)
  FILE *lF;	/*  */
{
  Undef CbStr2UserMessage();
  Undef PFCOIL;
  Undef DATAMSE;
/*
   */
#ifdef Doc_PFExpDataAI
\Section{Skeleton of \c{PFExpDataAI()}}
  \begin{verbatim}
    PFExpDataAI(){
    }
  \end{verbatim}
\Section{\c{PFExpDataAI()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{FILE }&\c{*lF}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{CbStr2UserMessage()}&$$&\\
\c{Undef }&\c{PFCOIL}&$$&\\
\c{Undef }&\c{DATAMSE}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int MSEtangg()
{
  Undef ESGetLabMetrics();
  Undef ESSetSplA();
  Undef splRA();
  extern int ESNa1;		/* undefined */
  extern double *ESaZ0;		/* undefined */
  extern double *ESsb;		/* undefined */
  extern double *ESaR0;		/* undefined */
  extern int ESNa;		/* undefined */
  extern double *ESsr;		/* undefined */
  extern int ESNp;		/* undefined */
  extern double *ESsa;		/* undefined */
  extern double *ESdgY;		/* undefined */
  extern double *ESdgY2a;	/* undefined */
  extern double *ESFF;		/* undefined */
  extern double *ESFF2a;	/* undefined */
  extern double *ESgY;		/* undefined */
  extern double *ESgY2a;	/* undefined */
/*
   */
#ifdef Doc_MSEtangg
\section{Skeleton of MSEtangg()}
  \begin{verbatim}
    MSEtangg(){
    }
  \end{verbatim}
\section{MSEtangg()}
Conversion of flux representation of the magnetic field into laboratory
system. 
\bqbl
&&
\waB
=
\R{\bgY'}{rD}\wse_\gt
=
\R{\bgY'}{rD}(r'_\gt\wse_r+z'_\gt\wse_z)
.\eqbl
Polarization angle is related to the component of the magnetic field by
\bqbl
\tan\gg_m
=
\R{E_H}{E_V}
=
\\
\R{-B_z\cos\gd\cos(\gW+\ga)-\sin\gd(B_r\sin\gW-B_t\cos\gW)}
 {-B_z\sin\gq\cos\gd\sin(\gW+\ga)
 +\sin\gq\sin\gd(B_t\sin\gW+B_r\cos\gW)
 +\cos\gq\cos\gd(B_r\cos\ga-B_t\sin\ga)}
.\eqbl
For NSTX
\bqbl
\gQ
=
0
,\quad
\gd
=
0
,\quad
\tan\gg_m
=
\R{E_H}{E_V}
=
\R{B_z\cos(\gW+\ga)}{B_t\sin\ga-B_r\cos\ga}
.\eqbl

Another form
\bqbl
\tan\gg_m
=
\R{A_1B_z+A_5B_r+A_6B_t}{A_4B_z+A_3B_r+A_2B_t}
=
\R{P_0B_r+P_1B_z+P_2B_t}{P_3B_r+P_4B_z+P_5B_t}
 ,\\
\tan\gg_m
=
\R{N_rB_r+N_zB_z+N_tB_t}{D_rB_r+D_zB_z+D_tB_t}
.\eqbl
\newpage
Conversion of geometry into polarization angle
\bqbl
\wsv
=
v_r\wse_r
+v_\gf\wse_\gf
+v_z\wse_z
,\quad
\wss
=
s_r\wse_r
+s_\gf\wse_\gf
+s_z\wse_z
,\\
\waE
\propto
\wsv\times\waB
=
(B_zv_\gf-B_\gf v_z)\wse_r
+(B_rv_z-B_zv_r)\wse_\gf
+(B_\gf v_r-B_rv_\gf)\wse_z
,\\
(\wss\times\waE)
=
(\wss\times(\wsv\times\waB))
=
\wsv(\wss\cdot\waB)
-\waB(\wss\cdot\wsv)
,\\
\wse_x
=
\R{\wss\times\wse_z}{|\wss\times\wse_z|}
,\quad
\wse_y
=
\wss\times\wse_x
,\quad
\tan\gg
=
\R{\wse_x\cdot\waE}{\wse_y\cdot\waE}
=
\R{\waB\cdot(\wse_x\times\wsv)}{\waB\cdot(\wse_y\times\wsv)}
.\eqbl
In components
\bqbl
c_\gq
\equiv
\cos\gq
,\quad
s_\gq
\equiv
\sin\gq
,\quad
c_\gd
\equiv
\cos\gd
,\quad
s_\gd
\equiv
\sin\gd
,\quad
c_\ga
\equiv
\cos\ga
,\quad
s_\ga
\equiv
\sin\ga
,\\
\wss
=
c_\gq\sin\gW\wse_r
+c_\gq\cos\gW\wse_\gf
+ s_\gq\wse_z
,\quad
\wsv
=
- c_\gd s_\ga\wse_r
+ c_\gd c_\ga\wse_\gf
+ s_\gd\wse_z
,\\
\waE
\propto
(B_z c_\gd c_\ga-B_\gf s_\gd)\wse_r
+(B_r s_\gd+B_z c_\gd s_\ga)\wse_\gf
+(-B_\gf c_\gd s_\ga-B_r c_\gd c_\ga)\wse_z
,\\
\wss\cdot\wsv
=
 c_\gd c_\gq\cos(\gW+\ga)
+ s_\gd s_\gq
,\\
\wss\cdot\waB
=
B_rc_\gq\sin\gW
+B_\gf c_\gq\cos\gW
+B_z s_\gq
,\\
\wss\times\wse_z
=
c_\gq\cos\gW\wse_r
-c_\gq\sin\gW \wse_\gf
,\quad
|\wss\times\wse_z|
=
|c_\gq|
,\\
\wse_x
=
\cos\gW\wse_r-\sin\gW \wse_\gf
,\\
\wse_x\times\wsv
=
-s_\gd(\sin\gW\wse_r+\cos\gW\wse_\gf)
+c_\gd\cos(\gW+\ga)\wse_z
,\\
\wse_y
=
\wss\times\wse_x
=
 s_\gq\sin\gW\wse_r
+ s_\gq\cos\gW\wse_\gf
-c_\gq\wse_z
,\\
\wse_y\times\wsv
=
(c_\ga\wse_r+s_\ga\wse_\gf)c_\gq c_\gd
+(\cos\gW\wse_r-\sin\gW\wse_\gf)s_\gq s_\gd
+s_\gq c_\gd\sin(\gW+\ga)\wse_z
,\\
\tan\gg
=
\R{-(B_r\sin\gW+B_\gf\cos\gW)s_\gd+B_zc_\gd\cos(\gW+\ga)}
 {(B_rc_\ga+B_\gf s_\ga)c_\gq c_\gd+(B_r\cos\gW-B_\gf\sin\gW)s_\gq s_\gd
 +B_zs_\gq c_\gd\sin(\gW+\ga)
 }
.\eqbl
For $\gq=\gd=0$
\bqbl
\tan\gg
=
\R{B_z\cos(\gW+\ga)}{B_rc_\ga+B_\gf s_\ga}
.\eqbl
For opposite orientation of angles
\bqbl
\gW\to-\gW
,\quad
\ga\to-\ga
,\\
\tan\gg
=
\R{-(-B_r\sin\gW+B_\gf\cos\gW)s_\gd+B_zc_\gd\cos(\gW+\ga)}
 {(B_rc_\ga-B_\gf s_\ga)c_\gq c_\gd+(B_r\cos\gW+B_\gf\sin\gW)s_\gq s_\gd
 -B_zs_\gq c_\gd\sin(\gW+\ga)
 }
.\eqbl
Formula from JET
\bqbl
\tan\gg_m
=
\R{E_H}{E_V}
=
\\
-\R{(B_r\sin\gW-B_t\cos\gW)s_\gd+B_zc_\gd\cos(\gW+\ga)}
 {(B_r\cos\gW+B_\gf\sin\gW)s_\gq s_\gd
 +(B_r c_\ga-B_t s_\ga)c_\gq c_\gd-B_zs_\gq c_\gd\sin(\gW+\ga)}
.\eqbl

#endif
}

int MSEtanggHole()
{
  Undef ESIsOutsidePlasma();
  Undef ESGetLabMetrics();
  Undef ESSetSplA();
  Undef splRA();
  extern double ESa0;	/* undefined */
  extern double *ESaF;	/* undefined */
/*
   */
#ifdef Doc_MSEtanggHole
\section{Skeleton of MSEtanggHole()}
  \begin{verbatim}
    MSEtanggHole(){
    }
  \end{verbatim}
\section{MSEtanggHole()}
#endif
}

int MSEPitchAngle()
{
  Undef ESGetMetrics();
  Undef ESSetSplA();
  Undef splRA();
/*
   */
#ifdef Doc_MSEPitchAngle
\Section{Skeleton of \c{MSEPitchAngle()}}
  \begin{verbatim}
    MSEPitchAngle(){
    }
  \end{verbatim}
\Section{\c{MSEPitchAngle()}}
Converts the MSE-LP angle $\gg$ into pitch angle of magnetic field.
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\bqbl
t_\gg\equiv\tan\gg_m
=
\R{P_0B_r+P_1B_z+P_2B_\gf}{P_3B_r+P_4B_z+P_5B_\gf}
,\\
B_z
=
\R{P_0B_r+P_2B_\gf-t_\gg(P_3B_r+P_5B_\gf)}{t_\gg P_4-P_1}
=
\R{(P_0-t_\gg P_3)B_r+(P_2-t_\gg P_5)B_\gf}{t_\gg P_4-P_1}
,\\
\waB_p
=
\R{\q{g_{\gt\gt}}}{rD}\bgY'\R{r'_\gt}{\q{g_{\gt\gt}}}\wse_r
+\R{\q{g_{\gt\gt}}}{rD}\bgY'\R{z'_\gt}{\q{g_{\gt\gt}}}\wse_z
=
\R{\bgY'r'_\gt}{rD}\wse_r
+\R{\bgY'z'_\gt}{rD}\wse_z
,\\
t_\gg(P_3B_r+P_4B_z)
-P_0B_r-P_1B_z
=
P_2B_\gf
-t_\gg P_5B_\gf
,\\
\R{P_0r'_\gt+P_1z'_\gt-t_\gg(P_3r'_\gt+P_4z'_\gt)}{rD}\bgY'
=
(t_\gg P_5-P_2)B_\gf
,\quad
\R{\bgY'}{rD}
=
\R{t_\gg P_5-P_2}{P_0r'_\gt+P_1z'_\gt-t_\gg(P_3r'_\gt+P_4z'_\gt)}B_\gf
.\eqbl


\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{ESGetMetrics()}&$$&\\
\c{Undef }&\c{ESSetSplA()}&$$&\\
\c{Undef }&\c{splRA()}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int MSEPitchAngleHole()
{
  Undef ESGetMetrics();
  Undef ESSetSplA();
  Undef splRA();
/*
   */
#ifdef Doc_MSEPitchAngleHole
\section{Skeleton of MSEPitchAngleHole()}
  \begin{verbatim}
    MSEPitchAngleHole(){
    }
  \end{verbatim}
\section{MSEPitchAngleHole()}
#endif
}

int MSEPitchAnglePLot(W)
  int W;	/*  */
{
  Undef ESGetMetrics();
  Undef splRA();
/*
   */
#ifdef Doc_MSEPitchAnglePLot
\section{Skeleton of MSEPitchAnglePLot()}
  \begin{verbatim}
    MSEPitchAnglePLot(){
    }
  \end{verbatim}
\section{MSEPitchAnglePLot()}
#endif
}

int MSEDataPlot(W,Fl,str)
  int W;	/*  */
  int Fl;	/*  */
  char *str;	/*  */
{
/*
   */
#ifdef Doc_MSEDataPlot
\section{Skeleton of MSEDataPlot()}
  \begin{verbatim}
    MSEDataPlot(){
    }
  \end{verbatim}
\section{MSEDataPlot()}
#endif
}

int PFGetW(W,WI,WV,WL,WB)
  double *W;	/*  */
  double *WI;	/*  */
  double *WV;	/*  */
  double *WL;	/*  */
  double *WB;	/*  */
{
/*
   */
#ifdef Doc_PFGetW
\section{Skeleton of PFGetW()}
  \begin{verbatim}
    PFGetW(){
    }
  \end{verbatim}
\section{PFGetW()}
#endif
}

int PFExpDataComparisonStore()
{
/*
   */
#ifdef Doc_PFExpDataComparisonStore
\section{Skeleton of PFExpDataComparisonStore()}
  \begin{verbatim}
    PFExpDataComparisonStore(){
    }
  \end{verbatim}
\section{PFExpDataComparisonStore()}
\subsection{Manual}
\begin{itemize}
\item \c{DESCRIPTION:}
\item \c{ARGUMENTS:}
\item \c{EXTERNALS:}
\item \c{RETURN VALUE:}
\begin{itemize}
  \item{\bf Success: }
  \item{\bf Failure: }

    \begin{tabular}{lcl}
    \C{i=PFExpDataComparisonStore();}& -&\em return value.\\
    \C{i == 1}& -&\em Your Comment\\
    \end{tabular}
\end{itemize}
\item \c{TIPS:}
{\em }
\item \c{BUGS:}
\item \c{SEE ALSO:}
\item \c{TO DO:}
\end{itemize}
#endif
}

int PFExpDataPlot(Fl,str)
  int Fl;	/*  */
  char *str;	/*  */
{
  Undef PSSetFileName();
/*
   */
#ifdef Doc_PFExpDataPlot
\section{Skeleton of PFExpDataPlot()}
  \begin{verbatim}
    PFExpDataPlot(){
    }
  \end{verbatim}
\section{PFExpDataPlot()}
Routine \c{PFExpDataPlot()} plots:

\begin{tabular}{|p{0.4in}p{0.3in}rp{4in}|}\hline
Signal	&Color	&Frame	&Comment\\\hline
\c{PFC.I0}	&\em black	&3	&data value of one turn current in PFC 
  (Plasma current excluded)\\
\c{PFC.I}	&\em blue	&3	&calculated value of one turn current 
  in PFC\\
\c{PFC.Ie}	&\em red	&3	& EFIT calculated value of one turn 
  current (optional)\\\hline

\c{MFL.S0}	&\em black	&4	&signal of the flux loops and saddle 
  coils\\
\c{MFL.S}	&\em blue	&4	&its calculated value\\
\c{MFL.Ie}	&\em red	&4	&EFIT calculated value (optional)\\
\hline

\c{MFP.S0}	&\em black	&5	&signal of magnetic probes\\
\c{MFP.S}	&\em blue	&5	&its calculated value\\
\c{MFP.Ie}	&\em red	&5	&EFIT calculated value (optional)\\
\hline

\c{VVC.I0}	&\em black	&6	&data value of the passsive element
  current\\
\c{VVC.I}	&\em blue	&6	&its calculated value\\
\c{VVC.Ie}	&\em red	&6	& EFIT calculated value (optional)\\
\hline
\end{tabular}
#endif
}

int PFHistoryDataPlot(Fl,str)
  int Fl;	/*  */
  char *str;	/*  */
{
  Undef PSSetFileName();
/*
   */
#ifdef Doc_PFHistoryDataPlot
\Section{Skeleton of \c{PFHistoryDataPlot()}}
  \begin{verbatim}
    PFHistoryDataPlot(){
    }
  \end{verbatim}
\Section{\c{PFHistoryDataPlot()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{int }&\c{Fl}&$$&\\
\c{char }&\c{*str}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{PSSetFileName()}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int PFEfitOutPlot()
{
/*
   */
#ifdef Doc_PFEfitOutPlot

\section{Skeleton of PFEfitOutPlot()}
  \begin{verbatim}
    PFEfitOutPlot(){
    }
  \end{verbatim}
\section{PFEfitOutPlot()}
#endif
}

int PFGenerateSignals()
{
/*
   */
#ifdef Doc_PFGenerateSignals

\section{Skeleton of PFGenerateSignals()}
  \begin{verbatim}
    PFGenerateSignals(){
    }
  \end{verbatim}
\section{PFGenerateSignals()}
#endif
}

int PFSetExpDataWeights0()
{
/*
   */
#ifdef Doc_PFSetExpDataWeights0

\section{Skeleton of PFSetExpDataWeights0()}
  \begin{verbatim}
    PFSetExpDataWeights0(){
    }
  \end{verbatim}
\section{PFSetExpDataWeights0()}
#endif
}

int PFSetExpDataWeights()
{
/*
   */
#ifdef Doc_PFSetExpDataWeights
\Section{Skeleton of \c{PFSetExpDataWeights()}}
  \begin{verbatim}
    PFSetExpDataWeights(){
    }
  \end{verbatim}
\Section{\c{PFSetExpDataWeights()}}
\Subsection{Description}
Routine specifies weight coefficients of MHD signals in the discrepancy
matrix
\bqbl
&&
\left|\arr
w^I_i(S^I_i-S^{I0}_i)\\
w^v_i(S^v_i-S^{v0}_i)\\
w^\gy_i(S^\gy_i-S^{\gy0}_i)\\
w^B_i(S^B_i-S^{B0}_i)\\
\ear\right|
\simeq
\left|\arr
0\\
0\\
0\\
0\\
\ear\right|
\mbox{for}
\left\{\arr
0 < N^I\\
0 < N^v\\
0 < N^\gy\\
0 < N^B\\
\ear\right.
,\eqbl
where $N^I$ is the number of currents in the PFCoils (including the
plasma current) and in TFC, $N^v$ is the number of currents in the
passive screens, $N^\gy$ is the number of flux loop signals, and $N^B$ is
the number of local magnetic probe signals.

\Subsection{Algorithm}
Weights of the signals (coil currents, flux loops and probe signals) are
based on their estimated errors. E.g., for  coils currents 
\bqbl
&&
w^I_i=\left\{\arr
\R{1}{\ge^I_i},&&\ge^I_i\neq 0\\
\R{1}{\bge^I},&&\ge^I_i=0\\
\ear\right.
.\eqbl
The default ``error'' $\bge^I$ is determined either by maximum non-zero
error or is taken as a number
\bqbl
&&
\bgd^I=\left\{\arr
\max{\ge^I_i},&&\mbox{if}\max{\ge^I_i}\neq 0\\
0.001,&&\mbox{if}\max{\ge^I_i}=0\\
\ear\right.
.\eqbl
For passive screens (e.g., vacuum vessel) the ``error'' is defined in 
terms of currents in the coils as
\bqbl
&&
\ge^v_i=\R{\gs_i}{\gs}\gd^v_0
,\quad
\bge^v=
0.01\sum^{N^I}_{i=0}S^{I0}_iT_i
,\quad
\gs\equiv\sum^{N^v}_{i=0}\gs_i
,\eqbl
where $\gs_i$ and $\gs$ are conductivity of each passive screeen
element and of all of them.

\Subsection{Input}
\vskip1ex\begin{tabular}{|llp{4in}|}\hline
\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&$$&\\
\c{}&$$&\\
\c{}&$$&\\
\c{}&$$&\\
\hline\end{tabular}
\Subsection{Output}
\vskip1ex\begin{tabular}{|llp{4in}|}\hline
\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&$$&\\
\c{}&$$&\\
\c{}&$$&\\
\c{}&$$&\\
\hline\end{tabular}
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int PFSetExpDataWeightsJET()
{
/*
   */
#ifdef Doc_PFSetExpDataWeightsJET
\Section{Skeleton of \c{PFSetExpDataWeightsJET()}}
  \begin{verbatim}
    PFSetExpDataWeightsJET(){
    }
  \end{verbatim}
\Section{\c{PFSetExpDataWeightsJET()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int PFExpDataFromEFIT(NmF)
  char *NmF;	/*  */
{
  Undef readefitk_();
/*
   */
#ifdef Doc_PFExpDataFromEFIT
\section{Skeleton of PFExpDataFromEFIT()}
  \begin{verbatim}
    PFExpDataFromEFIT(){
    }
  \end{verbatim}
\section{PFExpDataFromEFIT()}
#endif
}

int PFOutAFromEFIT(NmF)
  char *NmF;	/*  */
{
  Undef readefita_();
/*
   */
#ifdef Doc_PFOutAFromEFIT
\section{Skeleton of PFOutAFromEFIT()}
  \begin{verbatim}
    PFOutAFromEFIT(){
    }
  \end{verbatim}
\section{PFOutAFromEFIT()}
#endif
}

void EFITjpPlot()
{
  Undef ESSetSplA();
  Undef splRA();
  extern double *ESqgY;		/* undefined */
  extern double *ESqgY2a;	/* undefined */
  static int EFITnA;		/*  <ESC:pfcW.c */
  static double EFITaP[];	/*  <ESC:pfcW.c */
/*
   */
#ifdef Doc_EFITjpPlot
\section{Skeleton of EFITjpPlot()}
  \begin{verbatim}
    EFITjpPlot(){
    }
  \end{verbatim}
\section{EFITjpPlot()}
#endif
}

void EFITjsPlot()
{
  Undef ESSetSplA();
  Undef splRA();
  static int EFITnA;		/*  <ESC:pfcW.c */
  static double EFITaT[];	/*  <ESC:pfcW.c */
  static double EFITaP[];	/*  <ESC:pfcW.c */
/*
   */
#ifdef Doc_EFITjsPlot
\section{Skeleton of EFITjsPlot()}
  \begin{verbatim}
    EFITjsPlot(){
    }
  \end{verbatim}
\section{EFITjsPlot()}
#endif
}

int EFITaP2Jp(xd,yd,nd)
  double *xd;	/*  */
  double *yd;	/*  */
  int nd;	/*  */
{
  Undef spl();
  Undef ESSetSplA();
  Undef splRA();
  Undef SetIspl();
  Undef splR();
  static int EFITnA;		/*  <ESC:pfcW.c */
  static double EFITaP[];	/*  <ESC:pfcW.c */
/*
   */
#ifdef Doc_EFITaP2Jp
\section{Skeleton of EFITaP2Jp()}
  \begin{verbatim}
    EFITaP2Jp(){
    }
  \end{verbatim}
\section{EFITaP2Jp()}
#endif
}

int EFITaT2Js(xd,yd,nd)
  double *xd;	/*  */
  double *yd;	/*  */
  int nd;	/*  */
{
  Undef spl();
  Undef ESSetSplA();
  Undef splRA();
  Undef SetIspl();
  Undef splR();
  static int EFITnA;		/*  <ESC:pfcW.c */
  static double EFITaP[];	/*  <ESC:pfcW.c */
  static double EFITaT[];	/*  <ESC:pfcW.c */
/*
   */
#ifdef Doc_EFITaT2Js
\section{Skeleton of EFITaT2Js()}
  \begin{verbatim}
    EFITaT2Js(){
    }
  \end{verbatim}
\section{EFITaT2Js()}
#endif
}

int PFFileListEFIT(DirNm)
  char *DirNm;	/*  */
{
/*
   */
#ifdef Doc_PFFileListEFIT
\section{Skeleton of PFFileListEFIT()}
  \begin{verbatim}
    PFFileListEFIT(){
    }
  \end{verbatim}
\section{PFFileListEFIT()}
#endif
}

int PFExpDataFileList(DirNm)
  char *DirNm;	/*  */
{
/*
   */
#ifdef Doc_PFExpDataFileList
\Section{Skeleton of \c{PFExpDataFileList()}}
  \begin{verbatim}
    PFExpDataFileList(){
    }
  \end{verbatim}
\Section{\c{PFExpDataFileList()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{char }&\c{*DirNm}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int PFSetShotNm()
{
/*
   */
#ifdef Doc_PFSetShotNm
\section{Skeleton of PFSetShotNm()}
  \begin{verbatim}
    PFSetShotNm(){
    }
  \end{verbatim}
\section{PFSetShotNm()}
\subsection{Manual}
\begin{itemize}
\item \c{DESCRIPTION:}
\item \c{ARGUMENTS:}
\item \c{EXTERNALS:}
\item \c{RETURN VALUE:}
\begin{itemize}
  \item{\bf Success: }
  \item{\bf Failure: }

    \begin{tabular}{lcl}
    \C{i=PFSetShotNm();}& -&\em return value.\\
    \C{i == 1}& -&\em Your Comment\\
    \end{tabular}
\end{itemize}
\item \c{TIPS:}
{\em }
\item \c{BUGS:}
\item \c{SEE ALSO:}
\item \c{TO DO:}
\end{itemize}
#endif
}

int GetExpData()
{
  Undef readefitg_();
  Undef getefitmsek_();
  Undef CbStr2UserMessage();
  extern int ESkNormJ;	/* undefined */
  static double EFITaP[];	/*  <ESC:pfcW.c */
  static double EFITaT[];	/*  <ESC:pfcW.c */
  static int EFITnA;		/*  <ESC:pfcW.c */
/*
   */
#ifdef Doc_GetExpData

\section{Skeleton of GetExpData()}
  \begin{verbatim}
    GetExpData(){
    }
  \end{verbatim}
\section{GetExpData()}
#endif
}
#endif
#endif

#undef Doc_Cb_Structure
#ifdef Blb_pfcW.c
Blb_pfcW.c{
  mzl_MLIB{
  }
  mzl_ESC{
  }
  mzl_PFC{
    stg_PlLim{
    }
    stg_VacV{
    }
    stg_PSElecP{
    }
    stg_MFProbe{
    }
    stg_PFBlocks{
    }
    stg_ElecPar{
    }
  }
}
#endif

#undef Doc_Table_Of_Content
#ifndef Blb_pfcW.c
					PS p=150 ( 75);
#ifndef mzl_MLIB
					PS p=  1 (  1);
#endif
#ifndef mzl_ESC
					PS p=  1 (  1);
#endif
#ifndef mzl_PFC
					PS p=  1 (  1);
#ifndef stg_PlLim
					PS p=  1 (  1);
#endif
#ifndef stg_VacV
					PS p=  1 (  1);
#endif
#ifndef stg_PSElecP
					PS p=  1 (  1);
#endif
#ifndef stg_MFProbe
					PS p=  1 (  1);
#endif
#ifndef stg_PFBlocks
					PS p=  1 (  1);
#endif
#ifndef stg_ElecPar
					PS p=  1 (  1);
#endif
int PFIsKeyWordFound();			PS p=  3 (  2);
int PFIfPatternFound();			PS p=  4 (  2);
int PFReadAI();				PS p=  4 (  2);
int SetGroups();			PS p=  6 (  3);
int PFDeInitWForms();			PS p=  7 (  4);
int PFInitWForms();			PS p=  8 (  4);
int YearAO();				PS p= 10 (  5);
int YearAI();				PS p= 13 (  7);
int PFYear();				PS p= 17 (  9);
int PFGetMSEAngles();			PS p= 20 ( 10);
int PFWriteAngData();			PS p= 22 ( 11);
int PFReadAngData();			PS p= 22 ( 11);
int PFMSE_GeomAO();			PS p= 24 ( 12);
int PFMSE_GeomAI();			PS p= 25 ( 13);
int OldMSEGeom();			PS p= 26 ( 13);
int PickUpMseLS();			PS p= 27 ( 14);
int PickUpMseLP();			PS p= 28 ( 14);
int MSEGeomAO();			PS p= 29 ( 15);
int MSEGeomAI();			PS p= 29 ( 15);
int MSEDiagnosticPlot();		PS p= 32 ( 16);
void MSEPickUpPlot();			PS p= 32 ( 16);
void MSEGeomPlot();			PS p= 33 ( 17);
int MSEGeom();				PS p= 33 ( 17);
int SigLayOutAO();			PS p= 34 ( 17);
int SigLayOutAI();			PS p= 36 ( 18);
int SetSensorC();			PS p= 38 ( 19);
int PFSig2Raw();			PS p= 38 ( 19);
void SigLayOutXW();			PS p= 39 ( 20);
int SigLayOut();			PS p= 39 ( 20);
int PFSetTimeRange();			PS p= 41 ( 21);
int PlotRawWF();			PS p= 42 ( 21);
int CheckIfSplinedI();			PS p= 43 ( 22);
int TimeHistoryVirtualI();		PS p= 43 ( 22);
int IfSplinedDiamag();			PS p= 44 ( 22);
int TimeHistorySignal();		PS p= 44 ( 22);
int WFormYBO();				PS p= 45 ( 23);
int WFormYBI();				PS p= 45 ( 23);
int WFormPBO();				PS p= 46 ( 23);
int WFormPBI();				PS p= 46 ( 23);
int PlotSplinedWF();			PS p= 47 ( 24);
void PlotVirtualI();			PS p= 47 ( 24);
void PlotPlasmaAndEddyWForm();		PS p= 48 ( 24);
void PlotPFCWFormY();			PS p= 49 ( 25);
void PlotPFCWFormW();			PS p= 49 ( 25);
int PlotSplinedAndRawWF();		PS p= 50 ( 25);
void PlotWForm();			PS p= 50 ( 25);
void PlotSplinedWForm();		PS p= 50 ( 25);
void PlotSplinedAndRawWForm();		PS p= 50 ( 25);
int TimeSlice();			PS p= 50 ( 25);
int PlotTimeSlice();			PS p= 52 ( 26);
int WFormIpAO();			PS p= 53 ( 27);
int WFormIpAI();			PS p= 55 ( 28);
int WFormIpBI();			PS p= 58 ( 29);
int PFReadWFormAI();			PS p= 61 ( 31);
int PFReadWFormIpAI();			PS p= 62 ( 31);
int GetJETI();				PS p= 63 ( 32);
int WFormIp();				PS p= 68 ( 34);
int WFormI();				PS p= 70 ( 35);
int PlotSnapShotIp();			PS p= 72 ( 36);
int PlotSnapShotY();			PS p= 73 ( 37);
int GetJETgY();				PS p= 75 ( 38);
int PFWriteWFormAO();			PS p= 78 ( 39);
int WFormY();				PS p= 79 ( 40);
int PTimeSlice();			PS p= 81 ( 41);
int PTimeSlicePL();			PS p= 82 ( 41);
int WFormPAI();				PS p= 83 ( 42);
void WFormPPL();			PS p= 86 ( 43);
int WFormP();				PS p= 87 ( 44);
int TimeSliceOfAll();			PS p= 89 ( 45);
int PlotSnapShotI();			PS p= 90 ( 45);
int AsymData();				PS p= 91 ( 46);
int SnapShot();				PS p= 93 ( 47);
int PFEfitBoundPlot();			PS p= 97 ( 49);
void MFSignalPlot();			PS p= 97 ( 49);
int PFSaveExpData();			PS p= 97 ( 49);
int MSESetCoeff();			PS p= 99 ( 50);
int PFReadExpData();			PS p=100 ( 50);
int PFExpDataAO();			PS p=104 ( 52);
int PFExpDataAI();			PS p=105 ( 53);
int MSEtangg();				PS p=110 ( 55);
int MSEtanggHole();			PS p=112 ( 56);
int MSEPitchAngle();			PS p=114 ( 57);
int MSEPitchAngleHole();		PS p=114 ( 57);
int MSEPitchAnglePLot();		PS p=115 ( 58);
int MSEDataPlot();			PS p=116 ( 58);
int PFGetW();				PS p=118 ( 59);
int PFExpDataComparisonStore();		PS p=119 ( 60);
int PFExpDataPlot();			PS p=122 ( 61);
int PFHistoryDataPlot();		PS p=128 ( 64);
int PFEfitOutPlot();			PS p=134 ( 67);
int PFGenerateSignals();		PS p=134 ( 67);
int PFSetExpDataWeights0();		PS p=135 ( 68);
int PFSetExpDataWeights();		PS p=136 ( 68);
int PFSetExpDataWeightsJET();		PS p=137 ( 69);
int PFExpDataFromEFIT();		PS p=138 ( 69);
int PFOutAFromEFIT();			PS p=140 ( 70);
void EFITjpPlot();			PS p=141 ( 71);
void EFITjsPlot();			PS p=142 ( 71);
int EFITaP2Jp();			PS p=142 ( 71);
int EFITaT2Js();			PS p=142 ( 71);
int PFFileListEFIT();			PS p=143 ( 72);
int PFExpDataFileList();		PS p=144 ( 72);
int PFSetShotNm();			PS p=144 ( 72);
int GetExpData();			PS p=145 ( 73);
#endif
#endif
