#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <unistd.h>
#include <time.h>

#ifndef mzl_ESC

#ifdef SHMEM
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <sys/shm.h>

#define LDBL sizeof(double)
#define LINT sizeof(int)
/* Number of elements in shared memory buffer */
#define NUM_ELEM 10

#define SHMEMLENGTH 65536
#define S0 0
#define S1 1

int SemID;
int ShmID;
static struct sembuf bufV={S0, 1,IPC_NOWAIT};
static struct sembuf bufP={S1, -1,SEM_UNDO};
void *lShm;
static int *lRetFl;

#endif/*SHMEM*/

#ifndef FORK

#ifdef SHMEM
int ESUpDateCleanFile()
{
  FILE *lF;
  char buf[256];
  long int BegOfRecord;

  /* ipcs -list of allocated resources */

  lF	=fopen("escCLEAN","r+");
  if(lF == NULL){
    lF	=fopen("escCLEAN","w+");
    fprintf(lF,"#%10d\n",0);
  }
  else{
    fscanf(lF,"#%ld\n",&BegOfRecord);
    out("sl","BegOfRecord=",BegOfRecord);
    fseek(lF,BegOfRecord,SEEK_SET);
  }
  fprintf(lF,"ipcrm sem %d\n",SemID);
  fprintf(lF,"ipcrm shm %d\n",ShmID);
  fprintf(lF,"kill %d\n",getpid());
  BegOfRecord=ftell(lF);
  fprintf(lF,"rm %s/escCLEAN\n",getcwd(buf,(size_t)256));
  fprintf(lF,"ipcs\n");
  rewind(lF);
  fprintf(lF,"#%10ld\n",BegOfRecord);
  fclose(lF);
  chmod("escCLEAN",00777);
  printf("escCLEAN - type it (if exists) to free semaphores and shmem\n");
  return(0);
}
#endif/*SHMEM*/

extern clock_t clock(void);
extern unsigned int ESmemlev,ESmemlevP;
extern double cr2,cr3,cr4,cr6,cr12,cgp,c2gp,cgp_4,cr2gp,cgm0,crgm0;
extern double GlTime,dGlTime,StTime,ETime;

extern int ESEqSolvIt;
extern int ECEqFound();
extern void esc0_(char *NmM);
extern void esc1_();
extern double ESa0;

static clock_t Ect0;

#ifdef H
int amain(int argc, char **argv)
{
  int Fl=0;
  int Pid;
  int na;
  char ln[32];
  int i,k;
  char elem;
  
  Pid	=atoi(argv[1]);
  /* Init Shared memory */
  ShmID	=shmget((key_t)(Pid+1), 0, 0666|IPC_CREAT);

  /* Init semaphores */
  /* Two semaphores (Empty and Full) are created in one set */
  SemID	=semget((key_t)Pid, 0,0666|IPC_CREAT);
  /* attach shared memory to process */
  lShm	=shmat(ShmID,NULL,0);
  lRetFl	=(int*)lShm;
  *lRetFl	=0;
  lShm	+=LINT;

#ifdef H
  printf("Esc: SemID=%d %d %lx\n",SemID,ShmID,lShm);
#endif
  semop(SemID, &bufP, 1);   
  esc00_(argv[1],&na);
  semop(SemID, &bufV, 1);   		   
  
  ESUpDateCleanFile();
  while(1){
    semop(SemID, &bufP, 1);   
    Fl	=*(int*)lShm;
    switch(Fl){
    case 1:
      EscIn();
      *lRetFl	=1;
      semop(SemID, &bufV, 1);   		   
      semop(SemID, &bufP, 1);   
      break;
    case 2:
      EscEq();
      *lRetFl	=2;
      semop(SemID, &bufV, 1);   		   
      break;
    case 3:
      E2Astra();
      *lRetFl	=3;
      semop(SemID, &bufV, 1);   		   
      semop(SemID, &bufP, 1);   
      break;
    case 5:
      ESSendProfile();
      *lRetFl	=5;
      semop(SemID, &bufV, 1);   		   
      semop(SemID, &bufP, 1);   
      break;
    case 6:
      ESSendFourierR();
      *lRetFl	=6;
      semop(SemID, &bufV, 1);   		   
      semop(SemID, &bufP, 1);   
      break;
    case 7:
      ESSendFourierZ();
      *lRetFl	=7;
      semop(SemID, &bufV, 1);   		   
      semop(SemID, &bufP, 1);   
      break;
    case 4:
      *lRetFl	=4;
      semop(SemID, &bufV, 1);   		   
      esc1_();
      ESRestoreCleanFile();
      exit(0);
      break;
    default:
      break;
    }
    semop(SemID, &bufV, 1);   		   
  }

#ifdef H
  i=0;
  while(i < 26){
    /* Wait(Full) */
    semop(SemID, &bufP, 1);   
    for(k=0; k < 10 && i < 26; k++){
      /* Get and consume element, Example element are chars 'a'-'z' */
      elem	=*((char *)lPtr+(i%NUM_ELEM));
      printf("                             Consumed Elem '%c'\n", elem);
      i++;
    }
    /* Signal(Empty) */
    semop(SemID, &bufV, 1);   		   
  }
#endif
  exit(0);
}

#endif

double swatch_(double	*secs)
{
#include	<unistd.h>
#include	<time.h>
#include	<sys/times.h>
  double	runsec;
  clock_t	  cpu_time, run_time;
  static clock_t time0=0, prev_time;
  static double  secs_per_tick;
  struct   tms	  buf;
  if (time0 == -1) { return -1.; }		/* Overflow range of clock_t */
  if (time0 ==  0) { 				/* Set time0 at start */
    secs_per_tick = 1./sysconf(_SC_CLK_TCK);
    time0 = times(&buf);
    prev_time = buf.tms_utime+buf.tms_stime;
    return 0.;
  }
  run_time = times(&buf)-time0;		/* Set time difference */
  cpu_time = buf.tms_utime+buf.tms_stime;
  *secs += (cpu_time-prev_time)*secs_per_tick;
  /* printf("Process: %f  %f\n", cpu_time*secs_per_tick, */
  /* (cpu_time-prev_time)*secs_per_tick); */
  prev_time = cpu_time;	
  runsec = run_time*secs_per_tick;	/* printf("Process: %f\n", runsec); */
  return runsec;
}

int main(int argc, char **argv)
{
  extern int ESShMem,ESiAx;
  extern int ESNa,ESNa1,ESNp,ESNp1,ESFp,ESFp1;
  extern double rBLX[],zBLX[],rBLXq[],zBLXq[],*rBL,*zBL,*rBLq,*zBLq;
  extern void *ESlShMem;
  extern int *ESShMemI;
  extern double *ESShMemT;
  extern double *ESShMemB;
  extern double *ESShMemP;
  extern double *ESShMemE;
  extern double *ESShMBal;
  int Fl=0;
#include <fenv.h>
#ifdef H
  feenableexcept(FE_INVALID|FE_OVERFLOW|FE_UNDERFLOW|FE_DIVBYZERO);
#endif
  feenableexcept(FE_INVALID|FE_OVERFLOW|FE_DIVBYZERO);
#ifndef mzl_ESC

#ifndef blb_Machine
  esc0_(NULL);
  
  rBL	=rBLX+2*ESNp1;
  zBL	=zBLX+2*ESNp1;
  rBLq	=rBLXq+2*ESNp1;
  zBLq	=zBLXq+2*ESNp1;
#ifdef SHMEM
  {
    int L,Nesi;
    
    if(argc > 1 && sscanf(argv[1],"%d",&Fl) == 1) ESShMem=7;

    if(Fl){
      /* Init semaphores */
      /* Two semaphores (Empty and Full) are created in one set */
      SemID	=semget((key_t)Fl,0,0666|IPC_CREAT);
      /* Init Shared memory */
      Nesi	=ESNp1+(11+18*ESNp1)*ESNa1;
      L	=32*LINT;
      L	+=(16+480+0x600+Nesi)*LDBL;

      /* Extra Shared memory for Fourier Coefficients*/
      L	+=ESNa1*(2+4*ESFp1)*LDBL;

      ShmID	=shmget((key_t)(Fl+1),L,0666 | IPC_CREAT);
      /* attach shared memory to process */

      ESlShMem	=shmat(ShmID,NULL,0);
      lRetFl	=(int*)ESlShMem;
      *lRetFl	=0;

      ESShMemI	=(int*)ESlShMem;
      ESShMemT	=(double*)(ESShMemI+32);
      ESShMemB	=ESShMemT+16;
      ESShMemP	=ESShMemB+480;
      ESShMemE	=ESShMemP+0x600;

      ESShMBal	=ESShMemE+Nesi; /* Not Used */

      ESShMemI[0]	=0;
      ESShMemI[1]	=ESNa;
      ESShMemI[2]	=ESNp;
      ESShMemI[3]	=ESFp;

/***********/
      *ESShMemT	=46.;
/***********/
      ESISetMem(ESShMemE,ESNa1,ESNp1);
      semop(SemID, &bufP, 1);	/*Lock ESC*/   
      semop(SemID, &bufV, 1); 	/*Open ASTRA*/  		   
      swatch_(ESShMemT+15);
    }
  }
#endif/*SHMEM*/

#ifndef mzl_ESC
#ifndef stg_PlLim
  PFPlLim();
#endif
#ifndef stg_CHI
  CHIElectrodes();
#endif
#ifndef stg_VacV
  PFVacVessel();
#endif
#ifndef stg_PSElecP
  PSBElecPar();
#endif
#ifndef stg_MFProbe
  MFProbe();
#endif
#ifndef stg_PFBlocks
  PFBlocks();
#endif
#ifndef stg_ElecPar
  PFBElecPar();
#endif
#ifndef stg_Wall
  PFWall();
#endif
#ifndef stg_PFBSplD
  PFCSplD();
#endif
  PFFirstSetSpl();
#ifndef stg_ExtMF
  ExtMField();
#endif
#ifndef blb_Year
#ifndef mzl_ESC
  PFYear();
#ifndef stg_MSEGeom
  MSEGeom();
#endif
#ifndef stg_SigLayOut
    SigLayOut();
#endif
#ifndef blb_Shot
#ifndef mzl_ESC
  PFSetShotNm();
  tsc2e();
#ifndef stg_WFormIp
    WFormIp();
#endif
#ifndef stg_WFormI
    WFormI();
#endif
#ifndef stg_WFormY
    WFormY();
#endif
#ifndef stg_WFormP
    WFormP();
#endif
#ifndef blb_Equil
#ifdef SHMEM
  if(ESlShMem){
    semop(SemID, &bufP, 1);	/*Lock ESC*/    
    ESShMem	=ESShMemI[0];
    semop(SemID, &bufV, 1); 	/*Open ASTRA*/  		   
    if(ESShMem) semop(SemID, &bufP, 1); /*Lock ESC till escin*/
  }
#endif/*SHMEM*/
#ifndef mzl_ESC
#ifndef stg_SnapShot
#ifdef SHMEM
  ESShMem &=0x0e;
#endif/*SHMEM*/
   SnapShot();
#endif
#ifndef stg_ExpData
  GetExpData();
#endif
#ifndef stg_RadC
  ESInpRadC();
#endif
#ifndef stg_PlVac
  ESInputPlVac();
#endif
#ifndef stg_EqSolv
  ESInput2DEqSolv();
  ECReInitFgY();
  ECReInitEqU();
#endif
#ifndef stg_PFCoils
  PFCoils();
#endif
#ifndef stg_PFCOpt
  PFCOptPar();
#endif
#ifndef stg_PFCIeq
  FreeBoundaryEq();
#ifdef H
  PFCPlVac();
#endif
#endif

#ifndef stg_EqRcnstr
  EqRcnstr();
#endif

#ifndef stg_EqCHI
  CHIEquil();
#endif
#ifndef stg_PlPr
  ESInpPlPr();
#endif
#ifndef stg_MSE
  ESInpMSE();
#endif
#ifndef stg_PlCr
  ESInpPlCr();
#endif
#ifdef SHMEM
  if(ESlShMem && ESShMem){
    semop(SemID, &bufV, 1); 	/*Open ASTRA for check of return*/
    semop(SemID, &bufP, 1); /*Lock ESC till esc()*/
    semop(SemID, &bufV, 1); 	/*Open ASTRA for check of return*/
    semop(SemID, &bufP, 1); /*Lock ESC till esc()*/
  }
#endif/*SHMEM*/
  Ect0=clock();

  ECRescue2DGeom(0);
  Fl	=0;
  do{	
    if(EC2DEqSolv(0) == 0){
      extern int ESNa1,ESMp1;
#ifdef H
      ESCheckGShFourier(0,ESNa1,0,ESMp1,0);
#endif
      ECgYcs2dRZcsBound();
      if(ESiAx != 0){
	ECVirtualPlV2vdrPlV();
      }
      else{
	ECFixedPlV2vdrPlV();
      }
      if(ESa0 == 0.){
	ECgYrc2dRZcs();
	ECvdrz2vrz();
	ECMonitor2D();
#ifdef H
#endif
	ECCheckJacob();
      }
      else{
	ECgYrc2dRZcsHole(0);
	ECvdrz2vrzHole(0);
	ECCheckJacobHole(0);
      }
      Fl	=1;
    }
    else{
      Fl	=0;
      ECRestore2DGeom();
    }
#ifndef stg_InsFSol
    InsFundSol();
#endif
    ECRcs2D2Rcs3D(0);
    if(ESa0 != 0.){
      ESHoleEdgeBoundary();
      ESRealGeom(0);
      ES3DMetrTnsrCSHole();
    }
    else{
      extern int ESiAx;
      if(ESiAx){
	ESReal2RefDataX(0);
	ESPlVdata2PlVX();
	ESGapCoreSepX();
      }
      ESRealGeom(0);
      ES3DMetrTnsrCS();
    }
#ifdef ASTRA    
    ESInpPlPrCr();
#endif

    EC1DEqSolv();
  }while(ECIfEqFound());
  ECRefGeom(0);
#ifndef stg_EqOut
  ESEquilOut();
#endif
#ifndef stg_BalSt
  ESBalStab();
#endif
#ifdef SHMEM
  if(ESlShMem){
    int i;
    double gF,gY,s;

    ESWriteEqOutShM();
    semop(SemID, &bufV, 1); 	/*Open ASTRA*/  		   
    swatch_(ESShMemT+15);
  }
#endif/*SHMEM*/

#ifndef stg_LowNSt
  ESMHDStabLowN();
#endif

#ifndef stg_NonMHD
  ESNonMHDStabLowN();
#endif

#ifndef stg_Orbits
  ESOrbits();
#endif

#ifdef H
  ESTransport();
#ifndef stg_SrfCrrEq
  SrfCrrntEq();
#endif
#endif

#endif
#endif

#endif
#endif

#endif
#endif
#endif/*mzl_ESC*/
#endif/*blb_Machine*/
  esc1_();
  ESDeInitTsc();
#endif/*mzl_ESC*/
  return(0);
}

#else
#include <wait.h>
int main(int argc, char **argv)
{
#include <unistd.h>
  pid_t pid;

  pid = fork();
  if (pid == -1) {
    fprintf(stderr,"fork failed\n");
    exit(1);
  }
  if(pid == 0) {/* Child */
    if(execvp("./Cbesc",argv) == -1){
      fprintf(stderr,"execvp failed\n");
      exit(0);
    }
  }
  if(pid > 0) {/* parent */
    int status;
    wait(&status);
    if(WIFEXITED(status) == 0){
      *lRetFl	=-1;
      semop(SemID, &bufV, 1);   		   
    }
    printf("status=%d %d: %s\n",status,WIFEXITED(status)
	   ,WIFEXITED(status) ? "Normal" : "Crash");
    exit(0);
  }
  exit(0);
}
#endif /*FORK*/
#endif
