#include <math.h>
#include <stdio.h>

#ifndef mzl_MF
#ifndef stg_ELKE
double ELE(t)
     double t;
{
  if(t > 1e-10)
    return(((4.0905094E-2*t+8.5099193E-2)*t+0.44479204)*t
	   +1.-log(t)*(((1.382999E-2*t+8.150224E-2)*t+0.24969795)*t));
  else
    return(0.);
}

double ELK(t)
     double t;
{
  if(t > 1e-10)
    return(((3.2024666E-2*t+5.4544409E-2)*t+9.7932891E-2)*t+1.3862944
	   -log(t)*(((1.0944912E-2*t+6.0118519E-2)*t+0.12475074)*t+0.5));
  else
    return(0.);
}
double ELEE(t)
     double t;
{
  if(t > 1e-10)
    return((((((((((1.494662175718133e-4*t+2.468503330460723e-3)*t
		   +8.638442173604074e-3)*t+1.077063503986646e-2)*t
		 +7.820404060959554e-3)*t+7.595093422559432e-3)*t
	       +1.15695957452954e-2)*t+2.183181167613048e-2)*t
	     +5.680519456755916e-2)*t+4.431471805608895e-1)*t+1.
	   -log(t)*((((((((((3.185919565550157e-5)*t+9.898332846225385e-4)*t
			   +6.432146586438302e-3)*t+1.680402334636338e-2)*t
			 +2.614501470031388e-2)*t+3.347894366576163e-2)*t
		       +4.27178905473831e-2)*t+5.859366125553149e-2)*t
		     +9.374999972120314e-2)*t+.2499999999999018)*t);
  else
    return(0.);
}
double ELKK(t)
     double t;
{
  if(t > 1e-10)
    return((((((((((1.393087857006647e-4*t+2.296634898396959e-3)*t
		   +8.003003980649985e-3)*t+9.848929322176894e-3)*t
		 +6.847909282624505e-3)*t+6.179627446053318e-3)*t
	       +8.789801874555065e-3)*t+1.493801353268717e-2)*t
	     +3.088514627130519e-2)*t+9.657359028085626e-2)*t
	   +1.386294361119891
	   -log(t)*((((((((((2.970028096655561e-5*t+9.215546349632498e-4)*t
			    +5.973904299155429e-3)*t+1.553094163197720e-2)*t
			  +2.393191332311079e-2)*t+3.012484901289893e-2)*t
			+3.737773975862360e-2)*t+4.882804190686240e-2)*t
		      +7.031249973903835e-2)*t+.1249999999999081)*t+.5));
  else
    return(0.);
}
#endif

#ifndef stg_MFF
#ifdef H
static double cgp02=0.62831853,cgp04=1.256637061,cgp08=2.513274122,cr2=0.5;
#endif
static double cgp04=1.256637061,cr2=0.5,cgp=3.141592653589793;

void SourceGradOfgY(double *gYR,double *gYZ
		      ,double r,double z,double R,double Z)

{
  double a,aa,d,dd,y,yy,ee,ek,tR,dek,dee;
  double s,rs,rd,eke,ra,rR;

  y	=z-Z;
  yy	=y*y;
  d	=r-R;
  dd	=d*d+yy;
  a	=r+R;
  aa	=a*a;
  ra	=1./(aa+yy);
  s	=dd*ra;
  ek	=ELK(s);
  ee	=ELE(s);
  eke	=ek-ee;
  rR	=2.*r*R;
  s	=cgp04*sqrt(aa+yy);
  rs	=s*ra;
  rd	=1./dd;

  dek	=0.25*(ek-ee/(dd*ra))*(aa+yy)/rR;
  dee	=0.25*(ek-ee)*(aa+yy)/rR;
  tR	=4.*r*(R*R-r*r-yy)*ra*ra;

  *gYR	=rs*a*(eke-rR*ra*ek)
    +rs*(dek-dee-rR*ra*dek)*tR
    -2.*rs*ra*r*(yy+d*a*ra)*ek;
  *gYZ	=-rs*y*(eke-rR*rd*ee);
}

void SourceGradOfBpol(double *BrR,double *BrZ,double *BzR,double *BzZ
		      ,double r,double z,double R,double Z)

{
  double a,aa,d,dd,y,yy,ee,ek,tR,dek,dee;
  double s,rs,rsa,rd,rdd,eke,ra,rR,Rr,RR;

  y	=z-Z;
  yy	=y*y;
  d	=r-R;
  dd	=d*d+yy;
  a	=r+R;
  aa	=a*a;
  ra	=1./(aa+yy);
  s	=dd*ra;
  ek	=ELK(s);
  ee	=ELE(s);
  eke	=ek-ee;
  rR	=2.*r*R;
  s	=0.2*sqrt(aa+yy);
  rs	=s*ra;
  rsa	=rs*ra;
  rd	=1./dd;
  rdd	=rd*rd;
  Rr	=2.*R*(r-R);
  RR	=2.*R*R;

  dek	=0.25*(ek-ee/(dd*ra))*(aa+yy)/rR;
  dee	=0.25*(ek-ee)*(aa+yy)/rR;
  tR	=4.*r*(R*R-r*r-yy)*ra*ra;

  *BzR= rsa*a*(-eke+2.*R*d*rd*ee)
    +rs*(dek-dee-2.*R*d*rd*dee)*tR
    +rs*(-2.*r+4.*R*yy*rd)*rd*ee;
  *BzZ	=-(rs*2.*Rr*rdd*ee-rsa*(eke+Rr*rd*ek+2.*RR*rd*ee))*y;

  *BrR	=(rsa*y*a*(eke-rR*rd*ee)
	  -rs*y*(-2.*r*(a*d+yy)*rdd*ee
		 +(dek-dee-rR*rd*dee)*tR))/r;
  *BrZ	=(rs*(eke+(2.*yy*rdd-rd)*rR*ee)-rsa*yy*(eke+rR*rd*ek))/r;
}

void gYRingDipole(double *gY,double r,double z
		  ,double nR,double nZ,double R,double Z)
{
  double gYR,gYZ;
  SourceGradOfgY(&gYR,&gYZ,r,z,R,Z);
  *gY	=gYR*nR+gYZ*nZ;
}

void MFRingDipole(double *Br,double *Bz,double r,double z
		  ,double nR,double nZ,double R,double Z)
{
  double BrR,BrZ,BzR,BzZ;
  SourceGradOfBpol(&BrR,&BrZ,&BzR,&BzZ,r,z,R,Z);
  *Br	=BrR*nR+BrZ*nZ;
  *Bz	=BzR*nR+BzZ*nZ;
}

void gYdYd2Yd3Y(double *gY
		,double *gYr,double *gYz
		,double *gYrr,double *gYrz,double *gYzz
		,double *gYrrz,double *gYzzr
		,double r,double z,double R,double Z)

{
  double a,aa,d,dd,y,yy,ee,ek;
  double s,rs,rsa,rsaa,rd,rdd,rddd,eke,ra,rR,Rr,RR;

  y	=z-Z;
  yy	=y*y;
  d	=r-R;
  dd	=d*d+yy;
  a	=r+R;
  aa	=a*a;
  ra	=1./(aa+yy);
  s	=dd*ra;
  ek	=ELK(s);
  ee	=ELE(s);
  eke	=ek-ee;
  rR	=2.*r*R;
  s	=cgp04*sqrt(aa+yy);

  *gY	=s*(eke-rR*ra*ek);

  rs	=s*ra;
  rsa	=rs*ra;
  rsaa	=rsa*ra;
  rd	=1./dd;
  rdd	=rd*rd;
  rddd	=rdd*rd;
  Rr	=2.*R*(r-R);
  RR	=2.*R*R;

  *gYr	=rs*r*(eke-Rr*rd*ee);
  *gYz	=rs*y*(eke-rR*rd*ee);
  *gYrr	=rs*(RR*rd-2.*rR*yy*rdd)*ee+rsa*yy*(eke+rR*rd*ek);
  *gYrz	=(rs*2.*Rr*rdd*ee-rsa*(eke+Rr*rd*ek+2.*RR*rd*ee))*r*y;
  *gYzz	=rs*(eke+(2.*yy*rdd-rd)*rR*ee)-rsa*yy*(eke+rR*rd*ek);

  *gYrrz=((8.*rR*yy*rddd-(4.*rR+2.*RR)*rdd)*ee*rs
	 +(2.*eke+((2.*rR+RR)*ek-2.*RR*ee)*rd-yy*(ek+3.*eke)*rR*rdd)*rsa
	 -(3.*eke+(ek+ee)*2.*rR*rd)*rsaa*yy
	 )*y;

  *gYzzr=((2.*rdd-8.*yy*rddd)*Rr*ee*rs
	 -(eke+(Rr*ek+RR*ee)*rd)*rsa
	 +((4.*Rr*ek+(-3.*Rr+4.*RR)*ee)*rdd*rsa
	   +(3.*eke+2.*((rR-2.*RR)*ek+(rR+4.*RR)*ee)*rd)*rsaa)*yy
	 )*r;
}

int gYdYd2Yd3YWnd(double *gY
		,double *gYr,double *gYz
		,double *gYrr,double *gYrz,double *gYzz
		,double *gYrrz,double *gYzzr
		,double r,double z,double *Rw,double *Zw,double *Iw, int Nw)
{
  int i;
  double gy,gyr,gyz,gyrr,gyrz,gyzz,gyrrz,gyzzr;
  double Y,Yr,Yz,Yrr,Yrz,Yzz,Yrrz,Yzzr;
  gy	=0.;
  gyr	=0.;
  gyz	=0.;
  gyrr	=0.;
  gyrz	=0.;
  gyzz	=0.;
  gyrrz	=0.;
  gyzzr	=0.;
  for(i=0; i < Nw; i++){
    gYdYd2Yd3Y(&Y,&Yr,&Yz,&Yrr,&Yrz,&Yzz,&Yrrz,&Yzzr,r,z,Rw[i],Zw[i]);
    gy	 +=Y*Iw[i];
    gyr	 +=Yr*Iw[i];
    gyz	 +=Yz*Iw[i];
    gyrr +=Yrr*Iw[i];
    gyrz +=Yrz*Iw[i];
    gyzz +=Yzz*Iw[i];
    gyrrz+=Yrrz*Iw[i];
    gyzzr+=Yzzr*Iw[i];
  }
  *gY	=gy;
  *gYr	=gyr;
  *gYz	=gyz;
  *gYrr	=gyrr;
  *gYrz	=gyrz;
  *gYzz	=gyzz;
  *gYrrz=gyrrz;
  *gYzzr=gyzzr;
  return(0);
}

void gYdY(double *gY,double *gYr,double *gYz,double *gYR,double *gYZ
		,double r,double z,double R,double Z)

{
  double a,aa,d,dd,y,yy,ee,ek;
  double s,rs,rd,eke,ra,rR;

  y=z-Z;
  yy=y*y;
  d=r-R;
  dd=d*d+yy;
  a=r+R;
  aa=a*a;
  ra=1./(aa+yy);
  s=dd*ra;
  ek=ELK(s);
  ee=ELE(s);
  eke=ek-ee;
  rR=2.*r*R;
  s=cgp04*sqrt(aa+yy);
  *gY=s*(eke-rR*ra*ek);
  rs=s*ra;
  rd=1./dd;
  *gYr=rs*r*(eke-2.*R*(r-R)*rd*ee);
  *gYR=rs*R*(eke-2.*r*(R-r)*rd*ee);
  *gYz=rs*y*(eke-rR*rd*ee);
  *gYZ=-(*gYz);
}

double GPring(double r,double z,double r0,double z0)
{
  double b,a,c,d,ek,ee;
  a	=r+r0;
  d	=z-z0;
  d	*=d;
  c	=a*a+d;
  b	=r-r0;
  d	=(d+b*b)/c;
  return(cgp04*((1.-cr2*(1.-d))*ELK(d)-ELE(d))*sqrt(c));
}

double gYRing(double r,double z,double r0,double z0)
{
  double b,c,d,ek,ee;
  c	=r+r0;
  b	=r-r0;
  d	=z-z0;
  d	*=d;
  c	=d+c*c;
  d	=(d+b*b)/c;
  return(cgp04*((1.-cr2*(1.-d))*ELK(d)-ELE(d))*sqrt(c));
}

double gYCoil(double r,double z,double *r0,double *z0,double *I,int n)
{
  int i;
  double gY,b,a,c,d,ek,ee;

  gY	=0.;
  for(i=0; i < n; i++){
    a	=r+r0[i];
    d	=z-z0[i];
    d	*=d;
    c	=d+a*a;
    b	=r-r0[i];
    d	=(d+b*b)/c;
    gY	+=((1.-cr2*(1.-d))*ELK(d)-ELE(d))*sqrt(c)*I[i];
  }
  return(cgp04*gY);
}

void MFring(double *gy,double *Br,double *Bz
	    ,double r, double z, double r0, double z0, double I)
{
  double b,a,c,ek,ee;
  double s,rr,rr0;

  a	=r+r0;
  b	=r-r0;
  z	-=z0;
 
  rr0	=r0*r0;
  c	=b*b+z*z;
  if(c != 0.){
    b	=a*a+z*z;
    a	=c/b;
    rr	=r*r+z*z;
    b	=sqrt(b);

    ek	=ELK(a);
    ee	=ELE(a);
    s	=0.2*I/b;
    *Br	=z*(ee/c*(rr0+rr)-ek)*s/(r+1e-12);
    *Bz	=(ek+ee/c*(rr0-rr))*s;
    *gy	=b*((1.-cr2*(1.-a))*ek-ee)*cgp04*I;
  }
  else{
    *Br	=0.;
    *Bz	=0.;
    *gy	=0.;
  }
}

void EFring(double *gf,double *Er,double *Ez
	    ,double r, double z, double R, double Z, double gs)
{
  double q,a,x,c,ek,ee;
  a	=r+R;
  x	=r-R;
  z	-=Z;
  c	=x*x+z*z;
  if(c != 0.){
    q	=a*a+z*z;
    ee	=c/q;
    ek	=ELK(ee);
    ee	=ELE(ee)/c;
    gs	*=R/(cgp*sqrt(q));
    *gf	=gs*ek;
    *Er	=gs*(ek+(a*x-z*z)*ee)/(2.*r);
    *Ez	=gs*z*ee;
  }
  else{
    *Er	=0.;
    *Ez	=0.;
    *gf	=0.;
  }
}

void MFwinding(gp,Br,Bz,r,z,r0,z0,I,n)
     double *gp,*Br,*Bz,*r,*z,*r0,*z0,*I;
     int n;
{
  static double b,a,c,d,ek,ee;
  static int i;

  *gp=0.;
  *Br=0.;
  *Bz=0.;
  for(i=0; i< n; i++){
    MFring(&a,&b,&c,*r,*z,r0[i],z0[i],I[i]);
    *gp	+=a;
    *Br	+=b;
    *Bz	+=c;
  }
}

int gYdYWnd(double *gY,double *gYr,double *gYz
	    ,double r,double z,double *Rw,double *Zw,double *Iw, int Nw)
{
  int i;
  double a,aa,d,dd,y,yy,ee,ek;
  double R,Z,s,rs,rd,eke,ra,rR;
  double gy,gyr,gyz;

  gy	=0.;
  gyr	=0.;
  gyz	=0.;
  for(i=0; i < Nw; i++){
    R	=Rw[i];
    Z	=Zw[i];
    y	=z-Z;
    yy	=y*y;
    d	=r-R;
    dd	=d*d+yy;
    a	=r+R;
    aa	=a*a;
    ra	=1./(aa+yy);
    s	=dd*ra;
    ek	=ELK(s);
    ee	=ELE(s);
    eke	=ek-ee;
    rR	=2.*r*R;
    s	=cgp04*sqrt(aa+yy)*Iw[i];
    gy	+=s*(eke-rR*ra*ek);
    rs	=s*ra;
    rd	=1./dd;
    gyr	+=rs*r*(eke-2.*R*(r-R)*rd*ee);
    gyz	+=rs*y*(eke-rR*rd*ee);
  }
  *gY	=gy;
  *gYr	=gyr;
  *gYz	=gyz;
  return(0);
}

static double Br,Bz;
double BTring(r,z,nr,nz,r0,z0,I)
     double *r,*z,*nr,*nz,*r0,*z0,*I;
{
  static double b,a,c,d,ek,ee;
  MFring(&a,&Br,&Bz,*r,*z,*r0,*z0,*I);
  return(Br*(*nz)-Bz*(*nr));
}

double BNring(r,z,nr,nz,r0,z0,I)
     double *r,*z,*nr,*nz,*r0,*z0,*I;
{
  static double b,a,c,d,ek,ee;
  MFring(&a,&Br,&Bz,*r,*z,*r0,*z0,*I);
  return(Br*(*nr)+Bz*(*nz));
}
void BTNring(Bt,Bn,r,z,nr,nz,r0,z0,I)
     double *Bt,*Bn,*r,*z,*nr,*nz,*r0,*z0,*I;
{
  static double b,a,c,d,ek,ee;
  MFring(&a,&Br,&Bz,*r,*z,*r0,*z0,*I);
  *Bt	=Br*(*nz)-Bz*(*nr);
  *Bn	=Br*(*nr)+Bz*(*nz);
}
#ifdef H
#endif
#endif

#ifndef stg_GRN
void Lik(gP,n,n0,r,z,d05r,d05z,r0,z0,d05r0,d05z0)
     double *gP,*r,*z,*d05r,*d05z,*r0,*z0,*d05r0,*d05z0;
{
  static int i;
  static int j,k,ix,iy,ix0,iy0,nx=4,ny=4;
  static double b,a,c,d,ek,ee;
  static double x,y,x0,y0,ss,dx,dy,dx0,dy0,ga,gaa,gr,grr;
  double GPring();

  ss	=nx*ny;
  ss	=1./(ss*ss);
  k=0;
  for(i=0; i<n; i++){
    printf("%4d",i);
    if((i+1)%20 == 0 || i+1 == n)
      printf("\n");
    for(j=0; j<n0; j++){
      a	=r[i]-r0[j];
      b	=z[i]-z0[j];
      if(a*a+b*b > 5.*(d05z[i]*d05z[i]+d05r[i]*d05r[i]))
	gP[k]=GPring(r[i],z[i],r0[j],z0[j]);
      else{
	gP[k]	=0.;
	dx	=2.*d05r[i]/nx;
	dy	=2.*d05z[i]/ny;
	dx0	=2.*d05r0[j]/nx;
	dy0	=2.*d05z0[j]/ny;
	for(ix=0; ix < nx; ix++){
	  x	=r[i]-d05r[i]+(cr2+ix)*dx;
	  for(iy=0; iy < ny; iy++){
	    y	=z[i]-d05z[i]+(cr2+iy)*dy;
	    for(ix0=0; ix0 < nx; ix0++){
	      x0	=r0[j]-d05r0[j]+(cr2+ix0)*dx0;
	      for(iy0=0; iy0 < ny; iy0++){
		y0	=z0[j]-d05z0[j]+(cr2+iy0)*dy0;
		a	=x-x0;
		b	=y-y0;
		if(fabs(a) < dx && fabs(b) < dy){
		  a	=d05z[i]/d05r[i];
		  if(a > 3.0)
		    d	=.13;
		  else
		    if(a >= 2.)
		      d	=0.2+0.11*(3.-a);
		    else
		      if(a >= 1.6)
			d	=.31+.2*(2.-a);
		      else
			if(a >= 1.)
			  d	=.39+.7167*(1.6-a);
			else
			  d	=.82;
		  ga	=cr2*dy/x;
		  gr	=cr2*dx/x;
		  gaa	=ga*ga;
		  grr	=gr*gr;
		  a	=4./(ga+gr);
		  b	=(3.*gaa+grr)/24.;
		  c	=4./sqrt(gaa+grr);
		  gP[k]	+=cgp04*x*(log(a)-cr2+b*log(c)+d*gaa*.25)*ss;
		}
		else
		  gP[k]	+=GPring(x,y,x0,y0)*ss;
	      }
	    }
	  }
	}
      }
      k++;
    }
  }
}
#endif

int BioSavartABatXYZ(double A[3],double B[3],double V[3],double v[][3],int n1)
{
  int i;
  double Ax,Ay,Az;
  double Bx,By,Bz;
  double F1,F2,s;
  double x1,y1,z1,x2,y2,z2;
  double Ix,Iy,Iz,R1,rR1,R2,rR2;

  Ax	=0.;
  Ay	=0.;
  Az	=0.;
  Bx	=0.;
  By	=0.;
  Bz	=0.;

  i	=0;
  x2	=v[i][0]-V[0];
  y2	=v[i][1]-V[1];
  z2	=v[i][2]-V[2];
  R2	=sqrt(x2*x2+y2*y2+z2*z2);
  rR2	=1./R2;
  for(i=1; i < n1; i++){
    x1	=x2;
    y1	=y2;
    z1	=z2;
    R1	=R2;
    rR1	=rR2;
    x2	=v[i][0]-V[0];
    y2	=v[i][1]-V[1];
    z2	=v[i][2]-V[2];
    if(x2 != x1 || y2 != y1 || z2 != z1){
      R2	=sqrt(x2*x2+y2*y2+z2*z2);
      rR2	=1./R2;
      Ix	=x2-x1;
      Iy	=y2-y1;
      Iz	=z2-z1;
      s		=1./sqrt(Ix*Ix+Iy*Iy+Iz*Iz);
      Ix	*=s;
      Iy	*=s;
      Iz	*=s;

      F1	=Ix*x1+Iy*y1+Iz*z1+R1;
      F2	=Ix*x2+Iy*y2+Iz*z2+R2;
      s		=log(F2/F1);
      Ax	+=Ix*s;
      Ay	+=Iy*s;
      Az	+=Iz*s;
      s		=rR1/F1;
      Bx	-=(Iy*z2-Iz*y2)*s;
      By	-=(Iz*x2-Ix*z2)*s;
      Bz	-=(Ix*y2-Iy*x2)*s;
      s		=rR2/F2;
      Bx	+=(Iy*z2-Iz*y2)*s;
      By	+=(Iz*x2-Ix*z2)*s;
      Bz	+=(Ix*y2-Iy*x2)*s;
    }
  }
  A[0]	=0.1*Ax;
  A[1]	=0.1*Ay;
  A[2]	=0.1*Az;
  B[0]	=0.1*Bx;
  B[1]	=0.1*By;
  B[2]	=0.1*Bz;
  return(0);
}

int BioSavartBatXYZ(double B[3],double V[3],double v[][3],int n1)
{
  int i;
  double Bx,By,Bz;
  double x1,y1,z1,x2,y2,z2;
  double Ix,Iy,Iz,R1,rR1,R2,rR2,s;


  Bx	=0.;
  By	=0.;
  Bz	=0.;

  i	=0;
  x2	=v[i][0]-V[0];
  y2	=v[i][1]-V[1];
  z2	=v[i][2]-V[2];
  R2	=sqrt(x2*x2+y2*y2+z2*z2);
  rR2	=1./R2;
  for(i=1; i < n1; i++){
    x1	=x2;
    y1	=y2;
    z1	=z2;
    R1	=R2;
    rR1	=rR2;
    x2	=v[i][0]-V[0];
    y2	=v[i][1]-V[1];
    z2	=v[i][2]-V[2];
    if(x2 != x1 || y2 != y1 || z2 != z1){
      R2	=sqrt(x2*x2+y2*y2+z2*z2);
      rR2	=1./R2;
      Ix	=x2-x1;
      Iy	=y2-y1;
      Iz	=z2-z1;
      s		=1./sqrt(Ix*Ix+Iy*Iy+Iz*Iz);
      Ix	*=s;
      Iy	*=s;
      Iz	*=s;
      s		=rR1/(R1+Ix*x1+Iy*y1+Iz*z1);
      Bx	-=(Iy*z1-Iz*y1)*s;
      By	-=(Iz*x1-Ix*z1)*s;
      Bz	-=(Ix*y1-Iy*x1)*s;
      s		=rR2/(R2+Ix*x2+Iy*y2+Iz*z2);
      Bx	+=(Iy*z2-Iz*y2)*s;
      By	+=(Iz*x2-Ix*z2)*s;
      Bz	+=(Ix*y2-Iy*x2)*s;
    }
  }
  B[0]	=0.1*Bx;
  B[1]	=0.1*By;
  B[2]	=0.1*Bz;
  return(0);
}

int BioSavartB(double B[3],double V[3],double v[][3],double t[][3],int n1)
{
  int i;
  double Bx,By,Bz;
  double x,y,z;
  double Ix,Iy,Iz,R,s;
  double *lt;
  double *lv;

  Bx	=0.;
  By	=0.;
  Bz	=0.;

  lv	=v[0];
  lt	=t[0];
  x	=lv[0]-V[0];
  y	=lv[1]-V[1];
  z	=lv[2]-V[2];
  R	=sqrt(x*x+y*y+z*z);
  for(i=1; i < n1; i++){
    lv+=3;
    lt+=3;
    if(lt[0] != 0. || lt[1] != 0. || lt[2] != 0.){
      Ix	=lt[0];
      Iy	=lt[1];
      Iz	=lt[2];
      s		=Ix*x+Iy*y+Iz*z;
      if(s < 0.){
	s	=-s;
	Ix	=-Ix;
	Iy	=-Iy;
	Iz	=-Iz;
      }
      s		=1./(R*(R+s));
      Bx	-=(Iy*z-Iz*y)*s;
      By	-=(Iz*x-Ix*z)*s;
      Bz	-=(Ix*y-Iy*x)*s;
      x	=lv[0]-V[0];
      y	=lv[1]-V[1];
      z	=lv[2]-V[2];
      R		=sqrt(x*x+y*y+z*z);
      s		=1./(R*(R+Ix*x+Iy*y+Iz*z));
      Bx	+=(Iy*z-Iz*y)*s;
      By	+=(Iz*x-Ix*z)*s;
      Bz	+=(Ix*y-Iy*x)*s;
    }
  }
  B[0]	=0.1*Bx;
  B[1]	=0.1*By;
  B[2]	=0.1*Bz;
  return(0);
}

#endif
