#include <math.h>
#include <stdio.h>

#ifndef mzl_MLIB
extern double cr2,cr3,cr4,cr6,cr12,cgp,c2gp,cgp_4,cr2gp,cgm0,crgm0;
#endif
extern int gYdYWnd(double *gY,double *gYr,double *gYz,double r,double z
		   ,double *Rw,double *Zw,double *Iw, int Nw);

#ifndef mzl_SPLN
extern int SetSplXY(double x,double y);
extern int SetSplgYCell();
extern int PFCgYSpl(double *gY,double *gYr,double *gYz);
#endif

#ifndef mzl_PLV
static int nPlV;
static double *rPlV,*zPlV,*IsPlV;
extern int EGwNp;
extern double *EGwRp,*EGwZp,*EGwIp;
#endif

static int Nln=0,Iln,Npnt=200,Nc=4,Nlin=4;
static double Rln[200],Zln[200],*Xc,*Yc,Step;


double Rppp[50][200];
double Zppp[50][200];
static int kP;
int iPPP[50],kPPP;

int TSCGetAddPlV(int nPlV0,double *rPlV0,double *zPlV0,double *IsPlV0)
{
  nPlV	=nPlV0;
  rPlV	=rPlV0;
  zPlV	=zPlV0;
  IsPlV	=IsPlV0;
  return(0);
}

int MFLines(int iW,int ic)
{
  int Icol[4]={4,4,4,4};
  double st,st0,stst,rerr;
  double gPln,dgP,gP0;
  double x,y,tx,ty,h,dx,dy,R2,Z2;
  double F,dFx,dFy,gY,gYr,gYz;
  int i,Iside,Ist,iter;
  int INTER,n;

  dx	=1.*(rPlV[1]-rPlV[0]);
  dy	=1.*(zPlV[1]-zPlV[0]);
  Step=sqrt(dx*dx+dy*dy);
  
  PlotCon(&Xc,&Yc);
  gP0	= 1e+20;
  gPln	=-1e+20;
  for(i=0; i < Nc; i++){
    gYdYWnd(&F,&dFx,&dFy,Xc[i],Yc[i],rPlV,zPlV,IsPlV,nPlV);
    if(SetSplXY(Xc[i],Yc[i])){
      PFCgYMF(&gY,&gYr,&gYz,Xc[i],Yc[i]);
    }
    else{
      SetSplgYCell();
      PFCgYSpl(&gY,&gYr,&gYz);
    }
    F	+=gY;
    dFx	+=gYr;
    dFy	+=gYz;
    if(gPln < F){
      gPln	=F;
    }
    if(gP0 > F){
      gP0	=F;
    }
  }
  dgP	=(gPln-gP0)/Nlin;
  /*Beginning line calculations*/

  kPPP=0;
  for(n=0; n <= Nlin; n++){
    gPln	=gP0+dgP*n;
    
    /*Beginning the line with a given $\Psi=\Psi_{line}$*/
    for(Iside=0; Iside < 2; Iside++){
      /*Initial conditions*/
      if(Iside){
	Rln[0]	=Xc[3];
	Zln[0]	=Yc[3];
      }
      else{
	iter	=0;
	rerr	=Step*Step*1e-4;
	R2	=Xc[1];
	Z2	=Yc[1];
	do{
	  gYdYWnd(&F,&dFx,&dFy,R2,Z2,rPlV,zPlV,IsPlV,nPlV);

	  if(SetSplXY(R2,Z2)){
	    PFCgYMF(&gY,&gYr,&gYz,R2,Z2);
	  }
	  else{
	    SetSplgYCell();
	    PFCgYSpl(&gY,&gYr,&gYz);
	  }
	  F	+=gY;
	  dFx	+=gYr;
	  dFy	+=gYz;

	  h	=(gPln-F)/(dFx*dFx+dFy*dFy);
	  dx	=dFx*h;
	  dy	=dFy*h;
	  R2	+=dx;
	  Z2	+=dy;
	  if(R2 < 0.)
	    R2	=1.e-6*rPlV[0];
	  iter++;
	}while(dx*dx+dy*dy > rerr && iter < 10);
	Rln[0]	=R2;
	Zln[0]	=Z2;
      }
      st0	=Step;
      gYdYWnd(&F,&dFx,&dFy,Rln[0],Zln[0],rPlV,zPlV,IsPlV,nPlV);

      if(SetSplXY(Rln[0],Zln[0])){
	PFCgYMF(&gY,&gYr,&gYz,Rln[0],Zln[0]);
      }
      else{
	SetSplgYCell();
	PFCgYSpl(&gY,&gYr,&gYz);
      }
      F	+=gY;
      dFx	+=gYr;
      dFy	+=gYz;

      if(dFx < 0.)
	st0	=-Step;
      stst	=st0*st0;
      rerr	=stst*1e-4;
      
      /*Beginning of a particular line*/
      for(Ist=0, st=st0; Ist<2; Ist++, st=-st0){
	Iln	=0;
	x	=Rln[Iln];
	y	=Zln[Iln];
	INTER	=0;
	do{
	  /*First Step*/
	  iter	=0;
	  do{
	    gYdYWnd(&F,&dFx,&dFy,x,y,rPlV,zPlV,IsPlV,nPlV);
	    
	    if(SetSplXY(x,y)){
	      PFCgYMF(&gY,&gYr,&gYz,x,y);
	      {
		int j;
		if(Iln > 2){
		  for(j=0; j < Iln; j++){
		    Rppp[kPPP][j]	=Rln[j];
		    Zppp[kPPP][j]	=Zln[j];
		  }
		  iPPP[kPPP]	=Iln;
		  kPPP++;
		}
	      }
/*
	      Plot2D(iW,Rln,Zln,Iln,6,0,ic,0);
*/
	      Iln	=-1;
	      break;break;
	    }
	    else{
	      SetSplgYCell();
	      PFCgYSpl(&gY,&gYr,&gYz);
	    }
	    F	+=gY;
	    dFx	+=gYr;
	    dFy	+=gYz;

	    h	=(gPln-F)/(dFx*dFx+dFy*dFy);
	    dx	=dFx*h;
	    dy	=dFy*h;
	    x	+=dx;
	    y	+=dy;
	    if(x < 0.)
	      x	=1.e-6*rPlV[0];
	    iter++;
	  }while(dx*dx+dy*dy > rerr && iter < 10);
	  if(Iln >= 0){
	    Rln[Iln]=x;
	    Zln[Iln]=y;
	  }
	  if(Iln > 0){
	    dx	=x-Rln[Iln-1];
     	    dy	=y-Zln[Iln-1];
	    h	=sqrt(dx*dx+dy*dy);
	    tx	=dx/h;
	    ty	=dy/h;
	    if(h > 2.*Step){
	      {
		int j;
		if(Iln > 2){
		  for(j=0; j < Iln; j++){
		    Rppp[kPPP][j]	=Rln[j];
		    Zppp[kPPP][j]	=Zln[j];
		  }
		  iPPP[kPPP]	=Iln;
		  kPPP++;
		}
	      }
/*
	      Plot2D(iW,Rln,Zln,Iln,6,0,ic,0);
*/
	      Iln	=-1;;
	    }
	  }
	  /*Analysis*/
	  if(Iln > 1){
	    if((Zln[Iln]-Zln[0])*(Zln[Iln-1]-Zln[0]) < 0. &&
	       fabs(Rln[Iln]-Rln[0])<Step)
	      Ist++;
	    if((Zln[Iln]-Z2)*(Zln[Iln-1]-Z2) < 0. &&
	       fabs(Rln[Iln]-R2)<Step)
	      Iside++;
	    
	    if(Iside > 1){
	      {
		int j;
		if(Iln > 2){
		  for(j=0; j < Iln; j++){
		    Rppp[kPPP][j]	=Rln[j];
		    Zppp[kPPP][j]	=Zln[j];
		  }
		  iPPP[kPPP]	=Iln;
		  kPPP++;
		}
	      }
/*
	      Plot2D(iW,Rln,Zln,Iln,6,0,ic,0);
*/
	      Iln	=-1;
	      Ist++;
	    }
	    for(i=0; i<Iln-1; i++){
	      dx	=x-Rln[i];
	      dy	=y-Zln[i];
	      if(dx*dx+dy*dy < stst)
		INTER++;
	    }
	    if(INTER > 3){
	      {
		int j;
		if(Iln > 2){
		  for(j=0; j < Iln; j++){
		    Rppp[kPPP][j]	=Rln[j];
		    Zppp[kPPP][j]	=Zln[j];
		  }
		  iPPP[kPPP]	=Iln;
		  kPPP++;
		}
	      }
/*
	      Plot2D(iW,Rln,Zln,Iln,6,0,ic,0);
*/
	      Iln	=-1;
	    }
	  }
	  
	  /*Next approximated step*/
	  h	=st/sqrt(dFx*dFx+dFy*dFy);
	  dx	=-dFy*h;
	  dy	=dFx*h;
	  if(Iln > 0){
	    if(tx*dx+ty*dy < 0.){
	      st	=-st;
	      dx	=-dx;
	      dy	=-dy;
	    }
	  }
	  x	+=dx;
	  y	+=dy;
	  Iln++;
	}while(Iln < Npnt && Iln > 0);
	if(Iln > 0){
	  {
	    int j;
	    for(j=0; j < Iln; j++){
	      Rppp[kPPP][j]	=Rln[j];
	      Zppp[kPPP][j]	=Zln[j];
	    }
	    iPPP[kPPP]	=Iln;
	    kPPP++;
	  }
	  Plot2D(iW,Rln,Zln,Iln,6,0,ic,0);
/*
*/
	}
      }/*{\tt Ist} cycle*/
    }/*{\tt Iside} cycle*/
  }
  printf("??? kPPP=%d\n",kPPP);
  return(0);
}
