#include <math.h>
#include <stdio.h>
#include <time.h>

extern double cr2,cgp;

char *NmC[32],NmCC[32*8];
int kD[128],kC[128]={128*0},iC=0,mC=0;
double rC[512]={512*0.},zC[512]={512*0.},tnC[32],dSC[32];
int iB[512]={512*0};

char *NmB[1280],NmBB[1280*8];
double rB[1280],zB[1280],wB[1280],hB[1280],tB[1280],ga[1280],ga2[1280];
int kc[1280],kA[1280],nB=0;
int k1=0,k2=1280;

double *re,*ze,*we,*he;
int *ke,ne=0;
char **NmE,*NmEE;

int kv[1024],kav[1024],nv=0,nV=0,nVV=0,FlVV=0,NVV=192;
char *NmV[1024],NmVV[1048*8];
double rv[1024],zv[1024],wv[1024],hv[1024],gav[1024];
double xv[192],yv[192],xve[192],yve[192],Dv=0.15;

int kI[144],bI[144]={144*0},kaI[144],nI=0,NI=144,FlI=0,mI=0;
char *NmI[144],NmII[144*8];
double rI[144],zI[144],wI[144],hI[144],gaI[144];
double rrI[144][4],zzI[144][4];

int nPlr=20,nPlz=33;
double rPl[2],zPl[2];
int NL0=160,nL0=0,nL1=0,nL2=0;
double rL0[160],zL0[160],rL1[32],zL1[32],rL2[16],zL2[16];
int kaL[160];

int nL=0,nS=0,nP=0;
double rL[256],zL[256],*rS,*zS,rP[256],zP[256],gaP[256];
char *NmL[256],NmLL[256*8];

int PFWritePlLim()
{
  FILE*lf;
  int i,k;

  k	=0;
  for(i=0; i < nL0; i++){
    if(kaL[i]){
      k++;
    }
  }

  lf	=fopen("PlLim.ai","w");
  fprintf(lf,"Plasma Box\n");
  fprintf(lf,"%7.4f %7.4f %7.4f %7.4f %3d x %3d\n",rPl[0],zPl[0],rPl[1],zPl[1]
	  ,nPlr,nPlz);
  fprintf(lf,"%7s %7s %7s %7s %3s x %3s\n"
	  ,"Rpl 1","Z pl 1","Rpl 2","Zpl 2","Nr","Nz");
  fprintf(lf,"Limiter\n");
  fprintf(lf,"%d\n",k);
  k	=0;
  for(i=0; i < nL0; i++){
    if(kaL[i]){
      fprintf(lf,"%3d %11.4e %11.4e\n",k,rL0[i],zL0[i]);
      k++;
    }
  }
  fprintf(lf," # %7s %7s\n","rLim","zLim");
  fclose(lf);
  out("s","PlLim.ai - file has been written");
  return(0);
}

int PFCalibrVV()
{
  int i,j,m,n;
  double s,t;

  m	=1;
  i	=0;
  do{
    j	=i;
    do{
      j++;
      s	=xv[j]-xv[i];
      t	=yv[j]-yv[i];
      t	=sqrt(s*s+t*t);
    }while(t < Dv && yv[j] > 0.);
    i	=j;
    xv[m]	=xv[i];
    yv[m]	=yv[i];
    xve[m]	=xve[i];
    yve[m]	=yve[i];
    m++;
  }while(yv[i] > 0.);
  i	=m-1;
  while(i > 0){
    i--;
    xv[m]	=xv[i];
    yv[m]	=-yv[i];
    xve[m]	=xve[i];
    yve[m]	=-yve[i];
    m++;
  }
  nVV	=m;
  return(0);
}

int PFWriteVacV()
{
  FILE*lf;
  int i,j,m,n,n1,n2;
  int ir[256];
  double s,t;
  char Nm[256][8];

  lf	=fopen("VacV.ai","w");
  n	=nVV-1;
  m	=0;
  for(i=0; i < n; i++){
    ir[i]	=1;
  }
  for(i=0; i < n; i++){
    if(ir[i] != 0){
      if(yv[i] < 0.){
	sprintf(Nm[i],"V-%dL",m);
      }
      else{
	sprintf(Nm[i],"V-%dU",m);
      }
      for(j=i+1; j < n;j++){
	if(xv[j] == xv[i] && fabs(yv[j]) == fabs(yv[i])){
	  if(yv[j] < 0.){
	    sprintf(Nm[j],"V-%dL",m);
	  }
	  else{
	    sprintf(Nm[j],"V-%dU",m);
	  }
	  ir[j]	=0;
	}
      }
      m++;
      ir[i]	=0;
    }
  }
  fprintf(lf,"%d\n",n);
  for(i=0; i < n; i++){
    s	=xv[i+1]-xv[i];
    t	=yv[i+1]-yv[i];
    t	=sqrt(s*s+t*t);
    s	=sqrt(t*Dv);
    s	=s != 0. ? 1./s : 1.;
    n1	=4.*Dv*s+1;
    n2	=2.*t/Dv+1;
    n1	=2.;
    fprintf(lf
	    ,"%3d %7.4f %7.4f %7.4f %7.4f %7.4f %7.4f %7.4f %7.4f %2d x %2d\n"
	    ,i,xv[i],yv[i],xve[i],yve[i],xve[i+1],yve[i+1],xv[i+1],yv[i+1]
	    ,n1,n2);
    fprintf(lf,"           %6.2f x%9.2e %3d %2d %s\n"
	    ,1.,1./7.20e-07,i+100,0,Nm[i]);
  }
  fprintf(lf,"%3s %7s %7s %7s %7s %7s %7s %7s %7s %7s\n"
	  ,"#","r[0]","z[0]","r[1]","z[1]","r[2]","z[2]","r[3]","z[3]"
	  ,"Nn x Nt");
  fprintf(lf,"          %6s x%9s %3s %2s  %s\n","FF","gs","C#","kA","Name");
  fclose(lf);
  out("s","VacV.ai - file has been written");
  return(0);
}

int PFWriteMFP()
{
  int i,j;
  FILE*lf;
  lf	=fopen("MFProbe.ai","w");
  fprintf(lf,"%2d\n",nL+nS/2+nP);

  for(i=0; i < nL; i++){
    fprintf(lf,"%3d %8.5f %8.5f %10.5f %10.3e %10.3e %2d %s\n",i
	    ,rL[i],zL[i],0.,1.,1.,1,NmL[i]);
  }
  j	=nL;
  for(i=0; i < nS; i++){
    fprintf(lf,"%3d %8.5f %8.5f %10.5f %10.3e %10.3e %2d %s\n",j
	    ,rS[i],zS[i],0.,1.,1.,2,NmL[j]);
    i++;
    fprintf(lf,"%3d %8.5f %8.5f\n",j,rS[i],zS[i]);
    j++;
  }
  for(i=0; i < nP; i++){
    fprintf(lf,"%3d %8.5f %8.5f %10.5f %10.3e %10.3e %2d P-%d\n",j
	    ,rP[i],zP[i],gaP[i],1.,1.,3,i);
    j++;
  }
  fprintf(lf,"%3s %8s %8s %10s %10s %10s %2s %s\n"," #"
	  ,"R","Z","ga","T/(Vsec)","w Opt","i","Name");
  fclose(lf);
  out("s","MFProbe.ai - file has been written");
  return(0);
}

int PFReadJetLim()
{
  FILE*lf;
  int i;

  lf	=fopen("JET/In/limiter.mk2gb","r");
  if(lf == NULL){
    printf("File does not exist%c\n",7);
    return(1);
  }
  if(fscanf(lf,"%d",&nL0) != 1){
    fclose(lf);
    return(1);
  }
  for(i=0; i < nL0; i++){
    if(fscanf(lf,"%lg%lg",rL0+i,zL0+i) != 2){
      printf("No data for rL0%c\n",7);
      fclose(lf);
      return(1);
    }
  }
  rL0[nL0]	=rL0[0];
  zL0[nL0++]	=zL0[0];
  if(fscanf(lf,"%d",&nL1) != 1){
    return(1);
  }
  for(i=0; i < nL1; i++){
    if(fscanf(lf,"%lg%lg",rL1+i,zL1+i) != 2){
      printf("No data for rL1%c\n",7);
      fclose(lf);
      return(1);
    }
  }
  if(fscanf(lf,"%d",&nL2) != 1){
    fclose(lf);
    return(1);
  }
  for(i=0; i < nL2; i++){
    if(fscanf(lf,"%lg%lg",rL2+i,zL2+i) != 2){
      printf("No data for rL1%c\n",7);
      fclose(lf);
      return(1);
    }
  }
  fclose(lf);
  return(0);
}

int PFWritePFB()
{
  FILE *lf;
  int i,n,n1,n2;
  double r[2],z[2],s,w,h;

  n	=0;
  for(i=0; i < nB; i++){
    if(*NmB[i] != 'I' && *NmB[i] != 'i'){
      n++;
    }
  }

  lf	=fopen("PFBlocks.ai","w");
  fprintf(lf,"%2d\n",n+1);
  fprintf(lf,"%4d %9.6f %10.6f %9.6f %9.6f %5.1f %3d %3dx%3d  %s\n"
	  ,n,cr2*(rPl[1]+rPl[0]),cr2*(zPl[1]+zPl[0])
	  ,rPl[1]-rPl[0],zPl[1]-zPl[0],1.,0,nPlr,nPlz,"Plasma");
  n	=1;
  s	=sqrt((rPl[1]-rPl[0])*(zPl[1]-zPl[0])/1024.);
  for(i=0; i < nB; i++){
    if(*NmB[i] != 'I' && *NmB[i] != 'i'){
      n1	=wB[i]/s+1;
      n2	=hB[i]/s+1;
      fprintf(lf,"%4d %9.6f %10.6f %9.6f %9.6f %5.1f %3d %3dx%3d  %s\n"
	      ,n,rB[i],zB[i],wB[i],hB[i],tB[i],kc[i],n1,n2,NmB[i]);
      n++;
    }
  }
  fprintf(lf,"%4s %9s %10s %9s %9s %5s %3s %7s %s\n"
	  ,"#","R PFB","Z PFB","W PFB","H PFB","tnPFB","kD"
	  ,"nx x ny","Name");
  fclose(lf);
  out("s","PFBlocks.ai - file has been written");
  return(0);
}

int PFReadPFB()
{
  FILE *lf;
  double s;
  int i,j,k,m[3];
  
  lf	=fopen("PFBlocks.ai","r");

  if(k=fscanf(lf,"%d\n",&i) < 1){
    printf("%d < 1: no data for n of Limiter elements in PFBloks.ai\n",k);
    return(1);
  }
  i--;
  if(nB < i){
    for(j=0; j < i; j++){
      NmB[j]	=NmBB+j*8;
    }
  }
  nB	=i;
  i	=0;
  k=fscanf(lf,"%d %lg %lg %lg %lg %lg %d %dx%d %s\n"
	   ,&j,rB+i,zB+i,wB+i,hB+i,tB+i,kc+i,m+1,m+2,NmB[i]);
  if(k < 10){
    printf("%d < 10: no data for %d-th Plasma in PFBlocks.ai\n",k,i);
    return(1);
  }
  for(i=0; i < nB; i++){
    k=fscanf(lf,"%d %lg %lg %lg %lg %lg %d %dx%d %s\n"
	     ,&j,rB+i,zB+i,wB+i,hB+i,tB+i,kc+i,m+1,m+2,NmB[i]);
    if(k < 10){
      printf("%d < 10: no data for %d-th PFBlock in PFBlocks.ai\n",k,i);
      return(1);
    }
  }
  fclose(lf);
  return(0);
}

int LimPLot()
{
  int i1,i2;
  ZColor(0);
  i2=0;
  while(i2 < nL0){
    i1	=i2;
    while(i1 < nL0 && kaL[i1] == 0){
      i1++;
    }
    if(i2 && i1 < nL0){
      ZPlotLine(rL0[i2-1],zL0[i2-1],rL0[i1],zL0[i1]);
    }
    i2	=i1;
    while(i2 < nL0 && kaL[i2]){
      i2++;
    }
    if(i2-i1){
      ZPlotPolyLine(rL0+i1,zL0+i1,i2-i1);
    }
  }
  return(0);
  ZPlotPolyLine(rL1,zL1,nL1);
  ZPlotPolyLine(rL2,zL2,nL2);
  return(0);
}

void VVPlot()
{
  int i;
  double s,r[5],z[5];

  if(FlVV == 0 || (FlVV&0x01)){
    ZColor(14);
    for(i=0; i < nv; i++){
      switch(kav[i]){
      case 0:
	r[0]	=rv[i]-cr2*wv[i];
	z[0]	=zv[i]-cr2*hv[i];
	r[1]	=rv[i]+cr2*wv[i];
	z[1]	=z[0];
	r[2]	=r[1];
	z[2]	=zv[i]+cr2*hv[i];
	r[3]	=r[0];
	z[3]	=z[2];
	break;
      case 1:
	s	=cr2*wv[i]*tan(gav[i]*cgp/180.);
	r[0]	=rv[i]-cr2*wv[i];
	z[0]	=zv[i]-cr2*hv[i]-s;
	r[1]	=rv[i]+cr2*wv[i];
	z[1]	=zv[i]-cr2*hv[i]+s;
	r[2]	=r[1];
	z[2]	=zv[i]+cr2*hv[i]+s;
	r[3]	=r[0];
	z[3]	=zv[i]+cr2*hv[i]-s;
	break;
      case 2:
	s	=cr2*hv[i]*tan((gav[i]-90.)*cgp/180.);
	r[0]	=rv[i]-cr2*wv[i]+s;
	z[0]	=zv[i]-cr2*hv[i];
	r[1]	=rv[i]+cr2*wv[i]+s;
	z[1]	=z[0];
	r[2]	=rv[i]+cr2*wv[i]-s;
	z[2]	=zv[i]+cr2*hv[i];
	r[3]	=rv[i]-cr2*wv[i]-s;
	z[3]	=z[2];
	break;
      default:
	break;
      }
      r[4]	=r[0];
      z[4]	=z[0];
      ZPlotPolyLine(r,z,5);
    }
  }
  if((FlVV&0x02)){
    ZColor(4);
    ZPlotPolyLine(xv,yv,nVV);
    ZPlotPolyLine(xve,yve,nVV);
  }
  if((FlVV&0x04)){
    int n;
    n	=nVV-1;
    ZColor(4);
    for(i=0; i < n; i++){
      r[0]	=xv[i];
      z[0]	=yv[i];
      r[1]	=xve[i];
      z[1]	=yve[i];
      r[2]	=xve[i+1];
      z[2]	=yve[i+1];
      r[3]	=xv[i+1];
      z[3]	=yv[i+1];
      r[4]	=r[0];
      z[4]	=z[0];
      ZPlotPolyLine(r,z,5);
    }
  }
}

void IronPlot()
{
  int i,j;
  char ln[16];
  double s,r[5],z[5];
  double tx,ty,nx0,ny0,nx1,ny1;

  if(FlI == 0 || (FlI&1)){
    ZColor(14);
    for(i=0; i < nI; i++){
      r[0]	=rI[i]-cr2*wI[i];
      z[0]	=zI[i]-cr2*hI[i];
      r[1]	=rI[i]+cr2*wI[i];
      z[1]	=zI[i]-cr2*hI[i];
      r[2]	=rI[i]+cr2*wI[i];
      z[2]	=zI[i]+cr2*hI[i];
      r[3]	=rI[i]-cr2*wI[i];
      z[3]	=zI[i]+cr2*hI[i];
      switch(kaI[i]){
      case 0:
	break;
      case 1:
	s	=cr2*wI[i]*tan(gaI[i]*cgp/180.);
	z[0]	-=s;
	z[1]	+=s;
	z[2]	+=s;
	z[3]	-=s;
	break;
      case 2:
	s	=cr2*hI[i]*tan((gaI[i]-90.)*cgp/180.);
	r[0]	+=s;
	r[1]	+=s;
	r[2]	-=s;
	r[3]	-=s;
	break;
      default:
	break;
      }
      r[4]	=r[0];
      z[4]	=z[0];
      ZPlotPolyLine(r,z,5);
    }
  }
  if((FlI&2)){
    ZColor(0);
    for(i=0; i < nI; i++){
      for(j=0; j < 4; j++){
	r[j]	=rrI[i][j];
	z[j]	=zzI[i][j];
      }
      r[4]	=r[0];
      z[4]	=z[0];
      ZPlotPolyLine(r,z,5);
    }
  }
}

void PFBPlot()
{
  int i,j;
  double x[5],y[5];

#ifdef H
  for(i=0; i < nB; i++){
    if(strcmp(NmB[i],NmC[iC]) == 0){
      ZPlotRect(rB[i]-0.5*wB[i],zB[i]-0.5*hB[i],rB[i]+0.5*wB[i]
		,zB[i]+0.5*hB[i],14);
    }
  }
#endif
  ZColor(4);
  for(j=0; j < mC; j++){
    i	=iB[j];
    ZPlotRect(rB[i]-0.5*wB[i],zB[i]-0.5*hB[i]
	      ,rB[i]+0.5*wB[i],zB[i]+0.5*hB[i],14);
  }
  ZColor(0);
  for(i=0; i < nB; i++){
    x[0]	=rB[i]-0.5*wB[i];
    x[1]	=rB[i]+0.5*wB[i];
    x[2]	=x[1];
    x[3]	=x[0];
    x[4]	=x[0];
    
    y[0]	=zB[i]-0.5*hB[i];
    y[1]	=y[0];
    y[2]	=zB[i]+0.5*hB[i];
    y[3]	=y[2];
    y[4]	=y[0];
    ZPlotPolyLine(x,y,5);
  }
  IronPlot();
  VVPlot();
  LimPLot();
}

void PFBPlot0()
{
  int i;

  for(i=0; i < nB; i++){
    ZPlotRect(rB[i]-0.5*wB[i],zB[i]-0.5*hB[i],rB[i]+0.5*wB[i],zB[i]+0.5*hB[i],4);
  }
}

int PFSmoothVV()
{
  int i,n,j;
  double s,r[5],z[5];
  double tx,ty,nx0,ny0,nx1,ny1;

  n	=0;
  for(i=0; i < nv; i++){
    switch(kav[i]){
    case 0:
      break;
    case 1:
      s		=cr2*wv[i]*tan(gav[i]*cgp/180.);
      r[0]	=rv[i]-cr2*wv[i];
      z[0]	=zv[i]-cr2*hv[i]-s;
      r[1]	=rv[i]+cr2*wv[i];
      z[1]	=zv[i]-cr2*hv[i]+s;
      break;
    case 2:
      s		=cr2*hv[i]*tan((gav[i]-90.)*cgp/180.);
      r[0]	=rv[i]-cr2*wv[i]+s;
      z[0]	=zv[i]-cr2*hv[i];
      r[1]	=rv[i]+cr2*wv[i]+s;
      z[1]	=z[0];
      r[2]	=rv[i]+cr2*wv[i]-s;
      z[2]	=zv[i]+cr2*hv[i];
      r[3]	=rv[i]-cr2*wv[i]-s;
      z[3]	=z[2];
      r[4]	=r[0];
      z[4]	=z[0];
      if(s < 0.){
	r[0]	=r[1];
	z[0]	=z[1];
	r[1]	=r[2];
	z[1]	=z[2];
      }
      else{
	r[0]	=r[3];
	z[0]	=z[3];
	r[1]	=r[4];
	z[1]	=z[4];
      }
      break;
    default:
      break;
    }
    if(kav[i] && zv[i] > 0.){
      xv[n]	=r[0];
      yv[n++]	=z[0];
      xv[n]	=r[1];
      yv[n]	=z[1];
    }
  }
  n++;
  j	=n-1;
  yv[0]	=0.;
  yv[j]	=0.;
  while(j > 0 && n < NVV){
    j--;
    xv[n]	=xv[j];
    yv[n++]	=-yv[j];
  }
  nVV	=n;
  xve[0]=xv[0]-Dv;
  yve[0]=yv[0];
  tx	=xv[1]-xv[0];
  ty	=yv[1]-yv[0];
  s	=1./sqrt(tx*tx+ty*ty);
  tx	*=s;
  ty	*=s;
  nx1	=-ty;
  ny1	=tx;
  for(i=2; i < n; i++){
    j	=i-1;
    nx0	=nx1;
    ny0	=ny1;
    tx	=xv[i]-xv[j];
    ty	=yv[i]-yv[j];
    s	=1./sqrt(tx*tx+ty*ty);
    tx	*=s;
    ty	*=s;
    nx1	=-ty;
    ny1	=tx;
    tx	=nx0+nx1;
    ty	=ny0+ny1;
    s	=1./sqrt(tx*tx+ty*ty);
    tx	*=s;
    ty	*=s;
    xve[j]	=xv[j]+Dv*tx;
    yve[j]	=yv[j]+Dv*ty;
  }
  xve[n-1]	=xve[0];
  yve[n-1]	=yve[0];
  return(0);
}

int FromEFIT()
{
  extern void efitpfc_(char *NmOut,char *Nm);
  extern void efitlim_(char *NmOut,char *Nm);
  int i,j,k;
  double X[2]={0,6.},Y[2]={-3.,3.},s;
  int kk[2]={0,0};
  char str[4][32]={"JET/In/","./","pfcJET","input"};
  char *NmD,*NmF[2];
  char Nm1[64],Nm2[64];
  char Dir[64],Nm[64];
  char *lc;
  
  for(i=0; i < 1024; i++){
    kA[i]	=0;
  }

  NmD		=str[0];
  NmF[0]	=str[2];
  NmF[1]	=str[3];

  for(i=0; i < 32; i++){
    NmC[i]	=NmCC+8*i;
    sprintf(NmC[i],">---<");
  }
  for(i=0; i < 256; i++){
    NmL[i]	=NmLL+8*i;
    strcpy(NmL[i],">---<");
  }

#ifndef Tbl_EFIT
  if(kk[0] || kk[1]){
    char *lD,*lN,*lc;
    CbGetCurrentCbName(&lD,&lN);
    sprintf(Dir,"%s/",lD);
  }
  if(kk[0]){
    sprintf(Nm1,"%s%s",NmD,NmF[0]);
    eftmfp_(rL,zL,NmLL,&nL,&nS,rP,zP,gaP,&nP,Nm1);
    eftcoil_(rB,zB,wB,hB,ga,ga2,kc,NmBB,&nB);
    for(i=0; i < nL; i++){
      lc	=NmL[i];
      while(*lc !=' ' && *lc != '\0'){
	lc++;
      }
      *lc	='\0';
    }
    k	=nL+nS/2;
    for(i=nL; i < k; i++){
      lc	=NmL[i];
      while(*lc !=' ' && *lc != '\0'){
	lc++;
      }
      *lc	='\0';
    }
    k	=0;
    for(i=0; i < nB; i++){
      tB[i]	=1.;
      if(k < kc[i]){
	k	=kc[i];
      }
      NmB[i]	=NmBB+8*i;
      lc	=NmB[i];
      j	=0;
      while(j < 8 && !isspace(*lc)){
	lc++;
	j++;
      }
      *lc	='\0';
    }
    nI	=0;
    j	=0;
    for(i=0; i < nB; i++){
      if(*NmB[i] == 'I' || *NmB[i] == 'i'){
	rI[nI]	=rB[i];
	zI[nI]	=zB[i];
	wI[nI]	=wB[i];
	hI[nI]	=hB[i];
	kaI[nI]	=0.;
	if(ga[i] != 0.){
	  gaI[nI]	=ga[i];
	  kaI[nI]	=1;
	}
	if(ga2[i] != 0.){
	  gaI[nI]	=ga2[i];
	  kaI[nI]	=2;
	}
	kI[nI]	=kc[i];
	NmI[nI]	=NmII+nI*8;
	strcpy(NmI[nI],NmB[i]);
	nI++;
      }
      else{
	if(j != i){
	  rB[j]	=rB[i];
	  zB[j]	=zB[i];
	  wB[j]	=wB[i];
	  hB[j]	=hB[i];
	  kc[j]	=kc[i];
	  strcpy(NmB[j],NmB[i]);
	}
	j++;
      }
    }
    nB	=j;
    re	=rB+nB;
    ze	=zB+nB;
    we	=wB+nB;
    he	=hB+nB;
    ke	=kc+nB;
    NmE	=NmB+nB;
    NmEE=NmBB+8*nB;
    eftoh_(re,ze,we,he,ke,NmEE,&ne);
    for(i=0; i < ne; i++){
      ke[i]	+=k;
      ga[nB+i]	=0.;
      ga2[nB+i]	=0.;
      tB[nB+i]	=1.;
      NmE[i]	=NmEE+8*i;
      lc	=NmE[i];
      j	=0;
      while(j < 8 && !isspace(*lc)){
	lc++;
	j++;
      }
      *lc	='\0';
    }
    out("sIIII","nB=",nB,ne,nB+ne,nI);
    nB	+=ne;
    ne	=0;
    eftvacv_(rv,zv,wv,hv,gav,kav,kv,&nv);
    PFSmoothVV();
    PFReadJetLim();
    rPl[0]	=rL0[0];
    rPl[1]	=rPl[0];
    zPl[0]	=zL0[0];
    zPl[1]	=zPl[0];
    for(i=1; i < nL0; i++){
      if(rPl[0] > rL0[i]){
	rPl[0]	=rL0[i];
      }
      if(rPl[1] < rL0[i]){
	rPl[1]	=rL0[i];
      }
      if(zPl[0] > zL0[i]){
	zPl[0]	=zL0[i];
      }
      if(zPl[1] < zL0[i]){
	zPl[1]	=zL0[i];
      }
    }
    s	=sqrt((rPl[1]-rPl[0])*(zPl[1]-zPl[0])/1024.);
    nPlr	=(rPl[1]-rPl[0])/s;
    nPlz	=(zPl[1]-zPl[0])/s;
    nPlz	=(nPlz/2)*2+1;
    nPlr	=(nPlr/2+1)*2;

    kk[0]	=0;
    X[0]	=rB[0];
    X[1]	=rB[0];
    Y[0]	=zB[0];
    Y[1]	=zB[0];
    for(i=1; i < nB; i++){
      if(X[0] > rB[i]){
	X[0]	=rB[i];
      }
      if(X[1] < rB[i]){
	X[1]	=rB[i];
      }
      if(Y[0] > zB[i]){
	Y[0]	=zB[i];
      }
      if(Y[1] < zB[i]){
	Y[1]	=zB[i];
      }
    }
    for(i=0; i < nI; i++){
      if(X[0] > rI[i]){
	X[0]	=rI[i];
      }
      if(X[1] < rI[i]){
	X[1]	=rI[i];
      }
      if(Y[0] > zI[i]){
	Y[0]	=zI[i];
      }
      if(Y[1] < zI[i]){
	Y[1]	=zI[i];
      }
    }
    for(i=0; i < nv; i++){
      if(X[0] > rv[i]){
	X[0]	=rv[i];
      }
      if(X[1] < rv[i]){
	X[1]	=rv[i];
      }
      if(Y[0] > zv[i]){
	Y[0]	=zv[i];
      }
      if(Y[1] < zv[i]){
	Y[1]	=zv[i];
      }
    }
  }
  if(kk[1]){
    sprintf(Nm2,"%s%s",NmD,NmF[1]);
    efitlim_(Dir,Nm2);
    kk[1]	=0;
  }
  CbUserPlot	=PFBPlot;
#endif Tbl_EFIT
  return(0);
}

int PFLimiter()
{
  int i,j,Fl=0;
  double X[2]={0,6.},Y[2]={-3.,3.};

  X[0]	=rL0[0];
  X[1]	=rL0[0];
  Y[0]	=zL0[0];
  Y[1]	=zL0[0];
  kaL[0]=1;
  for(i=1; i < nL0; i++){
    if(X[0] > rL0[i]){
      X[0]	=rL0[i];
    }
    if(X[1] < rL0[i]){
      X[1]	=rL0[i];
    }
    if(Y[0] > zL0[i]){
      Y[0]	=zL0[i];
    }
    if(Y[1] < zL0[i]){
      Y[1]	=zL0[i];
    }
    kaL[i]	=1;
  }
#ifndef Tbl_Lim

  out("sI","nL0=",nL0);
  if(Fl){
    PFWritePlLim();	
    Fl	=0;
  }
  j	=nL0/2;
  for(i=nL0; i < NL0; i++){
    rL0[i]	=rL0[j];
    zL0[i]	=zL0[j];
    kaL[i]	=0;
  }
  CbUserPlot	=PFBPlot;
#endif Tbl_Lim
  return(0);
}

int PFBlocks()
{
  int i,ii,j,jj,k,nC=0,Fl;
  double tC[512],s;
  int kk[512]={512*0};
  int ib[512]={1,511*0};
  char *lc;
  double r1[2],z1[2],r2[2],z2[2];
  

  ii	=0;
  nC	=0;
  for(i=0; i < nB && nC < 32; i++){
    s	=wB[i]*hB[i];
    lc	=NmB[i];
    for(j=0; j < nC; j++){
      if(strcmp(lc,NmC[j]) == 0){
	tnC[j]	+=s;	
	if(dSC[j] > s){
	  dSC[j]	=s;
	}
	break;
      }
    }
    if(j == nC){
      strcpy(NmC[nC],lc);	
      dSC[nC]	=s;
      tnC[nC]	=s;
      nC++;
    }
  }
  for(i=0; i < nC; i++){
    tnC[i]	/=dSC[i];
  }
  for(i=0; i < nB; i++){
    s	=wB[i]*hB[i];
    lc	=NmB[i];
    for(j=0; j < nC; j++){
      if(strcmp(lc,NmC[j]) == 0){
	tB[i]	=s/dSC[j];	
	break;
      }
    }
  }

  for(i=0; i < 1024; i++){
    kA[i]	=0;
  }
  Fl	=0;
#ifndef Tbl_Blk
  /* Merging */
  k	=nB;
  for(i=0; i < mC; i++){
    if(ib[i]){
      ii	=iB[i];
      r1[0]=rB[ii]-cr2*wB[ii];
      r1[1]=rB[ii]+cr2*wB[ii];
      z1[0]=zB[ii]-cr2*hB[ii];
      z1[1]=zB[ii]+cr2*hB[ii];
      for(j=i+1; j < mC; j++){
	if(ib[j]){
	  jj	=iB[j];
	  r2[0]	=rB[jj]-cr2*wB[jj];
	  r2[1]	=rB[jj]+cr2*wB[jj];
	  z2[0]	=zB[jj]-cr2*hB[jj];
	  z2[1]	=zB[jj]+cr2*hB[jj];
	  if(r1[0] > r2[0]){
	    r1[0]	=r2[0];
	  }
	  if(r1[1] < r2[1]){
	    r1[1]	=r2[1];
	  }
	  if(z1[0] > z2[0]){
	    z1[0]	=z2[0];
	  }
	  if(z1[1] < z2[1]){
	    z1[1]	=z2[1];
	  }
	  ib[j]	=0;
	}
      }      
      rB[ii]	=cr2*(r1[1]+r1[0]);
      zB[ii]	=cr2*(z1[1]+z1[0]);
      wB[ii]	=r1[1]-r1[0];
      hB[ii]	=z1[1]-z1[0];
      k	=ii+1;
      jj=ii+1;
      while(jj < nB){
	if(((Fl&0x01) == 0 && kc[jj] != kc[ii])
	   || rB[jj] < r1[0] || r1[1] < rB[jj] || 
	   zB[jj] < z1[0] || z1[1] < zB[jj]){
	  rB[k]	=rB[jj];
	  zB[k]	=zB[jj];
	  wB[k]	=wB[jj];
	  hB[k]	=hB[jj];
	  ga[k]	=ga[jj];
	  ga2[k]=ga2[jj];
	  tB[k]	=tB[jj];
	  kc[k]	=kc[jj];
	  strcpy(NmB[k],NmB[jj]);
	  k++;
	}
	else{
	  tB[ii]	+=tB[jj];
	}
	jj++;
      }
      ib[i]	=0;
      break;
    }
  }
  out("sIII","nB=",nB,k,nC);
  nB	=k;
  if((Fl&0x08)){
    PFReadPFB();
  }
  ii	=0;
  nC	=0;
  for(i=0; i < nB && nC < 32; i++){
    s	=wB[i]*hB[i];
    lc	=NmB[i];
    for(j=0; j < nC; j++){
      if(strcmp(lc,NmC[j]) == 0){
	break;
      }
    }
    if(j == nC){
      strcpy(NmC[nC],lc);	
      nC++;
    }
  }
  for(i=0; i < nC; i++){
    out("siissdd","NmC",i,kk[i],NmC[i]," tn=",tnC[i],dSC[i]);
  }
  for(i=0; i < nC; i++){
    if(kk[i]){
      iC	=i;
      break;
    }
  }
  lc	=NmC[iC];
  out("ss","lc=",lc);
  k	=0;
  mC	=0;
  for(i=0; i < nB && k < 512 && mC < 512; i++){
    if(strcmp(lc,NmB[i]) == 0){
      rC[mC]	=rB[i];
      zC[mC]	=zB[i];
      tC[mC]	=kc[i];
      iB[mC]	=i;
      mC++;
      for(j=0; j < k; j++){
	if(kD[j] == kc[i]){
	  break;
	}
      }
      if(j == k){
	kD[k]	=kc[i];
	k++;
      }
    }
  }
  out("sI","mC=",mC);

  if((Fl&0x10)){
    PFWritePFB();
  }

  Fl	=0;
  CbUserPlot	=PFBPlot;
#endif Tbl_Blk
  return(0);
}

int PScreens()
{
  int i,j;
#ifndef Tbl_Scr
  PFSmoothVV();
  if((FlVV&8)){
    PFCalibrVV();
  }
  j	=0;
  for(i=nVV; i < NVV; i++){
    xv[i]	=xv[j];
    yv[i]	=yv[j];
  }
  if((FlVV&16)){
    PFWriteVacV();
  }
  CbUserPlot	=PFBPlot;
#endif Tbl_Scr
  return(0);
}

int PSEFIT2Esc()
{
  int i,j,k,n;
  double r[4],z[4],s,t,er,ez,x,y,w,h;
  for(i=0; i < nI; i++){
    rrI[i][0]	=rI[i]-cr2*wI[i];
    zzI[i][0]	=zI[i]-cr2*hI[i];
    rrI[i][1]	=rI[i]+cr2*wI[i];
    zzI[i][1]	=zI[i]-cr2*hI[i];
    rrI[i][2]	=rI[i]+cr2*wI[i];
    zzI[i][2]	=zI[i]+cr2*hI[i];
    rrI[i][3]	=rI[i]-cr2*wI[i];
    zzI[i][3]	=zI[i]+cr2*hI[i];
    switch(kaI[i]){
    case 0:
      break;
    case 1:
      s	=cr2*wI[i]*tan(gaI[i]*cgp/180.);
      zzI[i][0]	-=s;
      zzI[i][1]	+=s;
      zzI[i][2]	+=s;
      zzI[i][3]	-=s;
      break;
    case 2:
      s	=cr2*hI[i]*tan((gaI[i]-90.)*cgp/180.);
      rrI[i][0]	+=s;
      rrI[i][1]	+=s;
      rrI[i][2]	-=s;
      rrI[i][3]	-=s;
      break;
    default:
      break;
    }
  }
  return(0);
}

int PFStraightIronSection()
{
  int i,j,k,n;
  double r[4],z[4],s,t,er,ez,x,y,w,h;

  n	=0;
  for(i=0; i < nI; i++){
    if(bI[i] == 1){
      r[n]	=rI[i];
      z[n]	=zI[i];
      n++;
      if(n == 2){
	break;
      }
    }
  }
  er	=r[1]-r[0];
  ez	=z[1]-z[0];
  s	=1./(er*er+ez*ez);
  er	*=s;
  ez	*=s;
  n	=0;
  for(i=0; i < nI; i++){
    if(bI[i] == 1){
      r[0]	=rI[i]-cr2*wI[i];
      z[0]	=zI[i]-cr2*hI[i];
      r[1]	=rI[i]+cr2*wI[i];
      z[1]	=zI[i]-cr2*hI[i];
      r[2]	=rI[i]+cr2*wI[i];
      z[2]	=zI[i]+cr2*hI[i];
      r[3]	=rI[i]-cr2*wI[i];
      z[3]	=zI[i]+cr2*hI[i];
      switch(kaI[i]){
      case 0:
	if(fabs(er) > fabs(ez)){
	  t	=er > 0. ? cr2*wI[i] : -cr2*wI[i];
	}
	h	=hI[i];
	break;
      case 1:
	s	=cr2*wI[i]*tan(gaI[i]*cgp/180.);
	if(fabs(er) > fabs(ez)){
	  t	=er > 0. ? cr2*wI[i] : -cr2*wI[i];
	}
	h	=hI[i];
	z[0]	-=s;
	z[1]	+=s;
	z[2]	+=s;
	z[3]	-=s;
	break;
      case 2:
	s	=cr2*hI[i]*tan((gaI[i]-90.)*cgp/180.);
	if(fabs(er) > fabs(ez)){
	  t	=er > 0. ? fabs(s) : -fabs(s);
	  h	=cr2*wI[i]*hI[i]/s;
	}
	r[0]	+=s;
	r[1]	+=s;
	r[2]	-=s;
	r[3]	-=s;
	break;
      default:
	break;
      }
      if(fabs(er) > fabs(ez)){
	if(n == 0){
	  x	=rI[i]-t;
	  y	=zI[i]-t*ez/er;
	  rrI[i][0]	=x;
	  zzI[i][0]	=y-cr2*h;
	  rrI[i][1]	=x;
	  zzI[i][1]	=y+cr2*h;
	}
	else{
	  rrI[i][0]	=rrI[i-1][3];
	  zzI[i][0]	=zzI[i-1][3];
	  rrI[i][1]	=rrI[i-1][2];
	  zzI[i][1]	=zzI[i-1][2];
	}
	x	=rI[i]+t;
	y	=zI[i]+t*ez/er;
	rrI[i][2]	=x;
	zzI[i][2]	=y+cr2*h;
	rrI[i][3]	=x;
	zzI[i][3]	=y-cr2*h;
      }
      else{
	t	=ez > 0. ? cr2*h : -cr2*h;
	if(n == 0){
	  x	=rI[i]-t*er/ez;
	  y	=zI[i]-t;
	  rrI[i][0]	=x-cr2*wI[i];
	  zzI[i][0]	=y;
	  rrI[i][3]	=x+cr2*wI[i];
	  zzI[i][3]	=y;
	}
	else{
	  rrI[i][0]	=rrI[i-1][3];
	  zzI[i][0]	=zzI[i-1][3];
	  rrI[i][1]	=rrI[i-1][2];
	  zzI[i][1]	=zzI[i-1][2];
	}
	x	=rI[i]+t*er/ez;
	y	=zI[i]+t;
	rrI[i][1]	=x-cr2*wI[i];
	zzI[i][1]	=y;
	rrI[i][2]	=x+cr2*wI[i];
	zzI[i][2]	=y;
      }
      n++;
      bI[i]	=0;
    }
  }
  return(0);
}

int PFWriteIron(int k0)
{
  FILE*lf;
  int i,n1,n2;
  double s,t,tx,ty;

  k0	-=kI[0];
  lf	=fopen("Iron.ai","w");
  fprintf(lf,"%d\n",nI);
  for(i=0; i < nI; i++){
    tx	=rrI[i][1]-rrI[i][0];
    ty	=zzI[i][1]-zzI[i][0];
    t	=sqrt(tx*tx+ty*ty);
    tx	=rrI[i][2]-rrI[i][1];
    ty	=zzI[i][2]-zzI[i][1];
    ty	=sqrt(tx*tx+ty*ty);
    tx	=t;
    s	=sqrt(tx*ty);
    s	=s != 0. ? 1./s : 1.;
    n1	=tx*s+1;
    n2	=ty*s+1;
    fprintf(lf
	    ,"%3d %7.4f %7.4f %7.4f %7.4f %7.4f %7.4f %7.4f %7.4f %2d x %2d\n"
	    ,i,rrI[i][0],zzI[i][0],rrI[i][1],zzI[i][1]
	    ,rrI[i][2],zzI[i][2],rrI[i][3],zzI[i][3]
	    ,n1,n2);
    fprintf(lf,"           %6.2f x%9.2e %3d %2d %s\n"
	    ,1.,1./7.20e-07,k0+kI[i],1,NmI[i]);
  }
  fprintf(lf,"%3s %7s %7s %7s %7s %7s %7s %7s %7s %7s\n"
	  ,"#","r[0]","z[0]","r[1]","z[1]","r[2]","z[2]","r[3]","z[3]"
	  ,"Nn x Nt");
  fprintf(lf,"          %6s x%9s %3s %2s  %s\n","FF","gs","C#","kA","Name");
  fclose(lf);
  out("s","Iron.ai - file has been written");
  return(0);
}

int PFIron()
{
  int i,j,k0=0;

  PSEFIT2Esc();
#ifndef Tbl_Iron
  CbUserPlot	=PFBPlot;

  if((FlI&4)){
    PFStraightIronSection();
  }
  if((FlI&8)){
    PSEFIT2Esc();
  }
  if((FlI&16)){
    PFWriteIron(k0);
  }
  j	=0;
  for(i=nI; i < NI; i++){
    rI[i]	=rI[j];
    zI[i]	=zI[j];
  }
#endif Tbl_Iron
  return(0);
}

void ProbePlot()
{
  int i,k;
  double x[2],y[2],tx,ty,s;
  
  PFBPlot();
  for(i=0; i < nL; i++){
    ZPlotIntRect(rL[i],zL[i],2,2,0);
  }
  for(i=0; i < nS; i++){
    tx	=rS[i+1]-rS[i];
    ty	=zS[i+1]-zS[i];
    s	=sqrt(tx*tx+ty*ty);
    if(s == 0){
      out("sidddd","Wrong Saddle coil rS",i,rS[i+1],rS[i],zS[i+1],zS[i]);
    }
    else{
      s	=1./s;
    }
    tx	*=s;
    ty	*=s;
    x[0]	=rS[i];
    x[1]	=rS[i]+0.04*tx;
    y[0]	=zS[i];
    y[1]	=zS[i]+0.04*ty;
    ZPlotIntRect(rS[i],zS[i],2,2,4);
    ZPlotLine(x[0],y[0],x[1],y[1]);
    i++;
    x[0]	=rS[i];
    x[1]	=rS[i]-0.04*tx;
    y[0]	=zS[i];
    y[1]	=zS[i]-0.04*ty;
    ZPlotIntRect(rS[i],zS[i],2,2,4);
    ZPlotLine(x[0],y[0],x[1],y[1]);
  }
  for(i=0; i < nP; i++){
    ZPlotIntRect(rP[i],zP[i],2,2,14);
    tx	=cos(gaP[i]*cgp/180.);
    ty	=sin(gaP[i]*cgp/180.);
    x[0]	=rP[i]-0.02*tx;
    x[1]	=rP[i]+0.02*tx;
    y[0]	=zP[i]-0.02*ty;
    y[1]	=zP[i]+0.02*ty;
    ZPlotLine(x[0],y[0],x[1],y[1]);
  }
}

int PFProbe()
{
  int i,j,Fl=0,n,n1,n2,n3;
  double r[nL+nS+nP],z[nL+nS+nP];

  rS	=rL+nL;
  zS	=zL+nL;
#ifndef Tbl_Prb
  n1	=nL;
  n2	=nS;
  n3	=nP;
  j	=0;
  if(Fl == 0 || (Fl&0x01)){
    for(i=0; i < nL; i++){
      r[j]	=rL[i];
      z[j]	=zL[i];
      j++;
    }
  }
  if((Fl&0x02)){
    for(i=0; i < nS; i++){
      r[j]	=rS[i];
      z[j]	=zS[i];
      j++;
    }
  }
  if((Fl&0x04)){
    for(i=0; i < nP; i++){
      r[j]	=rP[i];
      z[j]	=zP[i];
      j++;
    }
  }
  if((Fl&0x10)){
    PFWriteMFP();
    Fl	=0;
  }
  CbUserPlot	=ProbePlot;
#endif Tbl_Prb
  return(0);
}

void main()
{
  InitConstants();
#ifndef mzl_PFC
#ifndef blb_EFIT
  FromEFIT();
#ifndef mzl_PFC
#ifndef stg_PFLim
  PFLimiter();
#endif
#ifndef stg_PFBlck
  PFBlocks();
#endif
#ifndef stg_PFScreen
  PScreens();
#endif
#ifndef stg_PFIron
  PFIron();
#endif
#ifndef stg_Probe
  PFProbe();
#endif

#endif
#endif
#endif
  return(0);
}
