#include <stdio.h>
#include <string.h>
#include "pfc.h"

extern unsigned int ESmemlevP;

double GlTime= -0.3,dGlTime= 0.1,StTime= 0.,ETime= 1.;

#ifndef mzl_PFC
#ifndef blb_Machine
#ifndef mzl_PFC

int kTimeHistory=0;
int iSignIp=0,iSignBt=0;
double EmnIV=1e-6;

#ifndef stg_PlLim
int *ESiALm,ESnLm=43;
double *ESRLm=NULL,*ESZLm=NULL;

int akCol[16]={0,14,11,4,9,17,13,10,12,14,11,4,12,17,13,0};
int bkCol[16]={54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69};
int kCol[16] ={54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69};

int nGr=0,nDGr=0,nPGr=0,nRaw=0,nRawS=0,nRawP=0;
GROUPDT DGr[NGRP],*PGr;
char TypeNm[0x10][0x20]={
  "Ipl"
  ,"OH coil"
  ,"PFCoils"
  ,"TFCoil"
  ,"Voltage"
  ,"Flux loops"
  ,"Saddle coils"
  ,"B-probes"
  ,"gF-Loop"
  ,"V-loops"
  ,""
  ,""
  ,"MSE-LP"
  ,"MSE-LS"
  ,"Transp"
  ,""
};

int EGNp=0;
double EGdr,EGdz,EGdS;
int NplG[2]={16,25};
double RplG[2]={1.,2.},ZplG[2]={-1.5,1.5};
double EGgYb=0.;
int *EGkAp=NULL,*EGkA=NULL;
double *EGaRp=NULL,*EGaZp=NULL;
int nGrLm,iGrLm[256],jGrLm[256],kGrLm[256],nGrEnv,iGrEnv[256][2];
double RGrLm[256],ZGrLm[256],ErGrLm[256],EzGrLm[256];

int EGwNp=0;
double *EGwRp=NULL,*EGwZp=NULL,*EGwIp=NULL;
double **gYpp=NULL;
double *EGsa=NULL,*EGgYp=NULL,*EGgYe=NULL,*EGaIp=NULL,*EGdIp=NULL
,*EGjs=NULL,*EGjp=NULL,*EGs1=NULL,*EGs2=NULL
,*EGgf[42]={NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL
,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL
,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL
,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL
,NULL,NULL};

#endif

#ifndef stg_CHI
int nCHI=0,n0CHI=0,n1CHI=0,nEl0=0,nEl1=0;
double *CHIr0=NULL,*CHIz0=NULL,*CHIr1=NULL,*CHIz1=NULL;
int kEl0[256],kEl1[256];
double RGrEl0[256],ZGrEl0[256],RGrEl1[256],ZGrEl1[256];
#endif

#ifndef stg_VacV
int nVVB=24;
PSBLOCK *VVB=NULL;
PSBLOCK *PSB=NULL;
WALL VVWall;
double *gYWC[0x100];
double *IWgYi[0x100];
double *gYWp[0x100];

WALL VVTile;
#endif

#ifndef stg_PSElecP
int nVVC=0;
PFCOIL *VVC=NULL;
double **gYpS=NULL;
#endif

#ifndef stg_MFProbe
int nMFP=30,nMFL=0,nMFS=0,nMFLS=0,nMFp=0,nMFd=0,nMFV=0;
MFPROBE *MFP=NULL,*MFL=NULL,*MFS=NULL,*MFp=NULL,*MFd=NULL,*MFV=NULL;
double **gYip=NULL,**gYiS=NULL;
double *aSip=NULL,*aSiC=NULL,*aSi=NULL,*daSi=NULL;
#endif

#ifndef stg_PFBlocks
int nPFB=31,nPFB1=32;

double *Rb1=NULL,*Zb1=NULL,*Rb2=NULL,*Zb2=NULL,*IbPF=NULL;
PFBLOCK *PFB=NULL;
#endif

#ifndef stg_ElecPar
int nPFC=0,nPFC1=0;
int nPEC=0,nPSC=0;
PFCOIL *PFC=NULL,*PEC=NULL;
double **gYCC=NULL,**gYpC=NULL,**gYiC=NULL;
#endif

#ifndef stg_PFBSplD
int NDSpl=0,nDSpl=4,iDSpl=0;
double *XDSpl1=NULL,*XDSpl2=NULL,*YDSpl1=NULL,*YDSpl2=NULL,*dXDSpl=NULL
,*dYDSpl=NULL;
#endif

#ifndef blb_Year
#ifndef mzl_PFC

int ESiEqRec=0;
#ifndef stg_MSE_Geom
int MSEFl=0,MSSFl=0,nSightP=0;
int NMSE=64,nMSE=0,nMSS=0;
DATAMSE MSE[64],MSS[64];
int nBeam=1;
double Err4Beam[4][4]={
   0.01,0.1, 0.01,0.005
  ,0.01,0.1, 0.01,0.005
  ,0.01,0.1, 0.01,0.005
  ,0.01,0.1, 0.01,0.005
};
/*[beam][errR-LP,errA-LP,errR-LS,errA-LS]*/
double Bmod[0x40],dBmod[0x40];
double Mse[0x40],dMse[0x40];
double x0Mse=0.,y0Mse=0.,scMSE=0.4;
SIGHTLINE SightP[0x40];
double glFaraday=118e-6,cFaraday=1.502e+9;

#endif

#ifndef blb_Shot
#ifndef mzl_PFC
#ifndef stg_WFormY
double PFtWF1=-1e+20,PFtWF=0.,PFtWF2=0.;
#endif

#ifndef stg_WFormB
#endif

#ifndef stg_WFormI
#endif

#ifndef blb_Equil
#ifndef mzl_PFC

#ifndef stg_ExpData
int iFList=0,nFList=0,NFList=512;
char FListEFIT[512][16],kFileExt[16]="",ShotNm[32]="";
#endif

#ifndef stg_PFCoils
#endif
#ifndef stg_PFCOpt
double PFwrP[41]; 
#endif

#ifndef stg_PFCIeq
int nCntP=0;
MFPROBE CNTP[12];
double *gYcp[12]={NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL}
,*BRcp[12]={NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL}
,*BZcp[12]={NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL}
,*gYcS[12]={NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL}
,*BRcS[12]={NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL}
,*BZcS[12]={NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL}
,*gYcC[12]={NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL}
,*BRcC[12]={NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL}
,*BZcC[12]={NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL};
#endif

#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif

int ESDeInitTsc()
{
  if((ESmemlevP&0x80000000)){
    ESmemlevP -=0x80000000;
  }
  if((ESmemlevP&0x40000000)){
    ESmemlevP -=0x40000000;
  }
  if((ESmemlevP&0x20000000)){
    ESmemlevP -=0x20000000;
  }
  if((ESmemlevP&0x10000000)){
    ESmemlevP -=0x10000000;
  }
  if((ESmemlevP&0x08000000)){
    ESmemlevP -=0x08000000;
  }
  if((ESmemlevP&0x04000000)){
    ESmemlevP -=0x04000000;
  }
  if((ESmemlevP&0x02000000)){
    ESmemlevP -=0x02000000;
  }
  if((ESmemlevP&0x01000000)){
    ESmemlevP -=0x01000000;
  }
  if((ESmemlevP&0x00800000)){
    ESmemlevP -=0x00800000;
  }
  if((ESmemlevP&0x004000000)){
    DeMem4EqRcnstrSVD();
    ESmemlevP -=0x00400000;
  }
  if((ESmemlevP&0x00200000)){
    DeInitSVD();
    ESmemlevP -=0x00200000;
  }
  if((ESmemlevP&0x00100000)){
    DeInitWall();
    ESmemlevP -=0x00100000;
  }
  if((ESmemlevP&0x00080000)){
    DeInitCHI();
    ESmemlevP -=0x00080000;
  }
  if((ESmemlevP&0x00040000)){
    PFDeInitWForms();
    ESmemlevP -=0x00040000;
  }
  if((ESmemlevP&0x00020000)){
    ESmemlevP -=0x00020000;
  }
  if((ESmemlevP&0x00010000)){
    PFDeInitGreenProbes();
    ESmemlevP -=0x00010000;
  }
  if((ESmemlevP&0x00008000)){
    PFDeInitGreenScreen();
    ESmemlevP -=0x00008000;
  }
  if((ESmemlevP&0x00004000)){
    PFDeInitEqGrid();
    ESmemlevP -=0x00004000;
  }
  if((ESmemlevP&0x00002000)){
    PFDeInitPSC();
    ESmemlevP -=0x00002000;
  }
  if((ESmemlevP&0x00001000)){
    PFDeInitAA();
    ESmemlevP -=0x00001000;
  }
  if((ESmemlevP&0x00000800)){
    PFDeInitPFC();
    ESmemlevP -=0x00000800;
  }
  if((ESmemlevP&0x00000400)){
    ESmemlevP -=0x00000400;
  }
  if((ESmemlevP&0x00000200)){
    PFDeInitMFP();
    ESmemlevP -=0x00000200;
  }
  if((ESmemlevP&0x00000100)){
    PFDeInitGreenPlasma();
    ESmemlevP -=0x00000100;
  }
  if((ESmemlevP&0x00000080)){
    PFDeInitVVB();
    ESmemlevP -=0x00000080;
  }
  if((ESmemlevP&0x00000040)){
    DeInitLim();
    ESmemlevP -=0x00000040;
  }
  if((ESmemlevP&0x00000020)){
    ESmemlevP -=0x00000020;
  }
  if((ESmemlevP&0x00000010)){
    ESmemlevP -=0x00000010;
  }
  if((ESmemlevP&0x00000008)){
    PFDeInitBasicFunctions();
    ESmemlevP -=0x00000008;
  }
  if((ESmemlevP&0x00000004)){
    DeInitPFCgYSpl();
    ESmemlevP -=0x00000004;
  }
  if((ESmemlevP&0x00000002)){
    DeInitSplB();
    ESmemlevP -=0x00000002;
  }
  if((ESmemlevP&0x00000001)){
    PFDeInitPFB();
    ESmemlevP -=0x00000001;
  }
  return(0);
}

int PFCheckMem()
{
  char Nm[4096][16];
  long int A[4096],L0,L1,l0,l1;
  int L[4096];
  
  int i,j,n;

  /* Limiter */
  n	=0;
  strcpy(Nm[n],"ESRLm");
  out("sis","Nm",n,Nm[n]);
  A[n]	=(long int)ESRLm;
  L[n++]=ESnLm*sizeof(double);
  strcpy(Nm[n],"ESZLm");
  out("sis","Nm",n,Nm[n]);
  A[n]	=(long int)ESZLm;
  L[n++]=ESnLm*sizeof(double);
  /* Plasma */
  strcpy(Nm[n],"EGkAp");
  out("sis","Nm",n,Nm[n]);
  A[n]	=(long int)EGkAp;
  L[n++]=EGNp*sizeof(int);
  strcpy(Nm[n],"EGkA");
  out("sis","Nm",n,Nm[n]);
  A[n]	=(long int)EGkA;
  L[n++]=EGNp*sizeof(int);
  strcpy(Nm[n],"EGaRp");
  out("sis","Nm",n,Nm[n]);
  A[n]	=(long int)EGaRp;
  L[n++]=EGNp*sizeof(double);
  strcpy(Nm[n],"EGaZp");
  out("sis","Nm",n,Nm[n]);
  A[n]	=(long int)EGaZp;
  L[n++]=EGNp*sizeof(double);
  strcpy(Nm[n],"EGwRp");
  out("sis","Nm",n,Nm[n]);
  A[n]	=(long int)EGwRp;
  L[n++]=EGNp*sizeof(double);
  strcpy(Nm[n],"EGwZp");
  out("sis","Nm",n,Nm[n]);
  A[n]	=(long int)EGwZp;
  L[n++]=EGNp*sizeof(double);
  strcpy(Nm[n],"EGwIp");
  out("sis","Nm",n,Nm[n]);
  A[n]	=(long int)EGwIp;
  L[n++]=EGNp*sizeof(double);
  strcpy(Nm[n],"EGsa");
  out("sis","Nm",n,Nm[n]);
  A[n]	=(long int)EGsa;
  L[n++]=EGNp*sizeof(double);
  strcpy(Nm[n],"EGgYp");
  out("sis","Nm",n,Nm[n]);
  A[n]	=(long int)EGgYp;
  L[n++]=EGNp*sizeof(double);
  strcpy(Nm[n],"EGgYe");
  out("sis","Nm",n,Nm[n]);
  A[n]	=(long int)EGgYe;
  L[n++]=EGNp*sizeof(double);
  strcpy(Nm[n],"EGaIp");
  out("sis","Nm",n,Nm[n]);
  A[n]	=(long int)EGaIp;
  L[n++]=EGNp*sizeof(double);
  strcpy(Nm[n],"EGdIp");
  out("sis","Nm",n,Nm[n]);
  A[n]	=(long int)EGdIp;
  L[n++]=EGNp*sizeof(double);
  strcpy(Nm[n],"EGjs");
  out("sis","Nm",n,Nm[n]);
  A[n]	=(long int)EGjs;
  L[n++]=EGNp*sizeof(double);
  strcpy(Nm[n],"EGjp");
  out("sis","Nm",n,Nm[n]);
  A[n]	=(long int)EGjp;
  L[n++]=EGNp*sizeof(double);
  strcpy(Nm[n],"EGs1");
  out("sis","Nm",n,Nm[n]);
  A[n]	=(long int)EGs1;
  L[n++]=EGNp*sizeof(double);
  strcpy(Nm[n],"EGs2");
  out("sis","Nm",n,Nm[n]);
  A[n]	=(long int)EGs2;
  L[n++]=EGNp*sizeof(double);

  strcpy(Nm[n],"gYpC");
  out("sis","Nm",n,Nm[n]);
  A[n]	=(long int)gYpC;
  L[n++]=EGNp*sizeof(double*);
  if(gYpC != NULL){
    for(i=0; i < EGNp; i++){
      sprintf(Nm[n],"gYpC[%3d]",i);
      A[n]	=(long int)gYpC[i];
      L[n++]	=nPFC*sizeof(double);
    }
  }
  strcpy(Nm[n],"gYpp");
  out("sis","Nm",n,Nm[n]);
  A[n]	=(long int)gYpp;
  L[n++]=EGNp*sizeof(double*);
  if(gYpp != NULL){
    for(i=0; i < EGNp; i++){
      sprintf(Nm[n],"gYpp[%3d]",i);
      A[n]	=(long int)gYpp[i];
      L[n++]	=EGNp*sizeof(double);
    }
  }
  out("sis","Nm",n,"EGgf[]");
  for(i=0; i < 42; i++){
    sprintf(Nm[n],"EGgf[%2d]",i);
    ;
    A[n]	=(long int)EGgf[i];
    L[n++]	=EGNp*sizeof(double);
  }
  /* VacVessel */
  strcpy(Nm[n],"VVB");
  out("sis","Nm",n,Nm[n]);
  A[n]	=(long int)VVB;
  L[n++]=nVVB*sizeof(PSBLOCK);

  /* PSElecP */
  strcpy(Nm[n],"VVC");
  out("sis","Nm",n,Nm[n]);
  A[n]	=(long int)VVC;
  L[n++]=nVVC*sizeof(PFCOIL);

  strcpy(Nm[n],"gYpS");
  out("sis","Nm",n,Nm[n]);
  A[n]	=(long int)gYpS;
  L[n++]=EGNp*sizeof(double*);
  if(gYpS != 0){
    for(i=0; i < EGNp; i++){
      sprintf(Nm[n],"gYpS[%2d]",i);
      A[n]	=(long int)gYpS[i];
      L[n++]	=nVVC*sizeof(double);
    }
  }

  /* MFProbes */
  strcpy(Nm[n],"MFP");
  out("sis","Nm",n,Nm[n]);
  A[n]	=(long int)MFP;
  L[n++]=nMFP*sizeof(MFPROBE);
  strcpy(Nm[n],"MFL");
  out("sis","Nm",n,Nm[n]);
  A[n]	=(long int)MFL;
  L[n++]=nMFL*sizeof(MFPROBE);
  strcpy(Nm[n],"MFp");
  out("sis","Nm",n,Nm[n]);
  A[n]	=(long int)MFp;
  L[n++]=nMFp*sizeof(MFPROBE);

  strcpy(Nm[n],"gYip");
  out("sis","Nm",n,Nm[n]);
  A[n]	=(long int)gYip;
  L[n++]=nMFP*sizeof(double*);
  if(gYip != 0){
    for(i=0; i < nMFP; i++){
      sprintf(Nm[n],"gYip[%2d]",i);
      A[n]	=(long int)gYip[i];
      L[n++]	=EGNp*sizeof(double);
    }
  }

  strcpy(Nm[n],"gYiC");
  out("sis","Nm",n,Nm[n]);
  A[n]	=(long int)gYiC;
  L[n++]=nMFP*sizeof(double*);
  if(gYiC != 0){
    for(i=0; i < nMFP; i++){
      sprintf(Nm[n],"gYiC[%2d]",i);
      A[n]	=(long int)gYiC[i];
      L[n++]	=nPFC*sizeof(double);
    }
  }
  strcpy(Nm[n],"aSip");
  out("sis","Nm",n,Nm[n]);
  A[n]	=(long int)aSip;
  L[n++]=nMFP*sizeof(double);
  strcpy(Nm[n],"aSiC");
  out("sis","Nm",n,Nm[n]);
  A[n]	=(long int)aSiC;
  L[n++]=nMFP*sizeof(double);
  strcpy(Nm[n],"aSi");
  out("sis","Nm",n,Nm[n]);
  A[n]	=(long int)aSi;
  L[n++]=nMFP*sizeof(double);
  strcpy(Nm[n],"daSi");
  out("sis","Nm",n,Nm[n]);
  A[n]	=(long int)daSi;
  L[n++]=nMFP*sizeof(double);

  /* PFBlocks */
  strcpy(Nm[n],"PFB");
  out("sis","Nm",n,Nm[n]);
  A[n]	=(long int)PFB;
  L[n++]=nPFC*sizeof(PFBLOCK);
  strcpy(Nm[n],"Rb1");
  out("sis","Nm",n,Nm[n]);
  A[n]	=(long int)Rb1;
  L[n++]=nPFB*sizeof(double);
  strcpy(Nm[n],"Zb1");
  out("sis","Nm",n,Nm[n]);
  A[n]	=(long int)Zb1;
  L[n++]=nPFB*sizeof(double);
  strcpy(Nm[n],"Rb2");
  out("sis","Nm",n,Nm[n]);
  A[n]	=(long int)Rb2;
  L[n++]=nPFB*sizeof(double);
  strcpy(Nm[n],"Zb2");
  out("sis","Nm",n,Nm[n]);
  A[n]	=(long int)Zb2;
  L[n++]=nPFB*sizeof(double);
  strcpy(Nm[n],"IbPF");
  out("sis","Nm",n,Nm[n]);
  A[n]	=(long int)IbPF;
  L[n++]=nPFB*sizeof(double);

  strcpy(Nm[n],"gYCC");
  out("sis","Nm",n,Nm[n]);
  A[n]	=(long int)gYCC;
  L[n++]=nPFB*sizeof(double*);
  if(gYCC != 0){
    for(i=0; i < nPFC; i++){
      sprintf(Nm[n],"gYCC[%2d]",i);
      A[n]	=(long int)gYCC[i];
      L[n++]	=nPFB*sizeof(double);
    }
  }
  PFGetMemDataB(Nm,A,L,&n);

  out("sI","N=",n);
  for(i=0; i < n; i++){
    if(A[i] != 0){
      L0	=A[i];
      L1	=L0+L[i];
      for(j=i+1; j < n; j++){
	if(A[j] != 0){
	  l0	=A[j];
	  l1	=l0+L[j];
	  if(!(l1 <= L0 || L1 <= l0)){
	    printf("%10s[%4d] %10ld %10ld %4ld\n",Nm[i],i,L0,L1,L1-L0);
	    printf("%10s[%4d] %10ld %10ld %4ld\n",Nm[j],j,l0,l1,l1-l0);
	    printf("%16s %10d %10ld %10ld %10ld\n","Conflict",0,L1-L0,l0-L0
		   ,l1-L0);
	  }
	}
      }
    }
  }

#ifdef H
  strcpy(Nm[n],"");
  out("sis","Nm",n,Nm[n]);
  A[n]	=(long int);
  L[n++]=*sizeof(double);

#ifndef stg_ElecPar
int nPFC=0;
int nPEC=0,nPSC=0;
PFCOIL *PFC=NULL,*PEC=NULL;
double **gYCC=NULL,**gYpC=NULL,**gYiC=NULL
,*gYcC[12]={NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL}
,*BrcC[12]={NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL}
,*BzcC[12]={NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL};
#endif

#ifndef stg_PFBSplD
int NDSpl=0,nDSpl=4,iDSpl=0;
double *XDSpl1=NULL,*XDSpl2=NULL,*YDSpl1=NULL,*YDSpl2=NULL,*dXDSpl=NULL
,*dYDSpl=NULL;
SPL ****gYPFBS=NULL;
#endif


#ifndef stg_PFCIeq
int nCntP=0;
MFPROBE CNTP[12];
double *gYcp[12]={NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL}
,*BRcp[12]={NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL}
,*BZcp[12]={NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL}
,*gYcb[12]={NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL}
,*BRcb[12]={NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL}
,*BZcb[12]={NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL};
#endif
#endif

  return(0);
}

