#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>		/* for cos(), sin(), and sqrt() */

#ifdef OPENGL

#include <GL/glx.h>		/* this includes X and gl.h headers */
#include <GL/glu.h>
#include "pfc.h"

extern double cr2,cr3,cr4,cr6,cr12,cgp,c2gp,cgp_4,cr2gp,cgm0,crgm0;

typedef enum{
  RESERVED,PLGRID,LIMITER,PLLIM,VACV
}List;

static int ngqGL=0,ngfGL=0;
static float nC[6][3]={
  -1.,0.,0.,1.,0.,0.,
  0.,-1.,0.,0.,1.,0.,
  0.,0.,-1.,0.,0.,1.
};

static float vC[8][3]={
  0.,0.,0.,0.,1.,0.,0.,1.,1.,0.,0.,1.,
  1.,0.,0.,1.,1.,0.,1.,1.,1.,1.,0.,1.
};


static GLfloat dgfGL;
static double angle[6]={0.,-80.,-45.,0.,-60.,-20.};

int init() 
{
  unsigned int w;
  glShadeModel(GL_FLAT);
  glShadeModel(GL_SMOOTH);
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  glEnable(GL_DEPTH_TEST);
  glClearColor(1.,1.,.3,1.);
  return(0);
}

static GLdouble vTor[0x1081][3];
static GLdouble nTor[0x1081][3];
static GLuint iTor[0x1041*2];
static double R,Z;

static GLdouble vSig[0x4100][3];
static GLuint iSig0[0x2080];
static GLuint iSig1[0x2080];
static GLdouble nSig[6][3];

static GLdouble vSigS[0x1000][3];
static GLdouble nSigS[0x1000][3];

static int FlGL=0;

extern double *EGaRp,*EGaZp;
static int ngfGL;

int PlasmaGrid2GL(double gf0,double gf1,double *RplG,double *ZplG,int *NplG)
{
  int Np=64;
  double x[128],y[128],nx[128],ny[128];
  int i,I1;
  int j,J1,ji;
  GLdouble *n;
  GLdouble *v;
  GLuint *li;
  double cs,sn,xa,ya,q,dq;

#ifdef HH
  while(gf1 > gf0+1.) gf1-=1.;
  while(gf0 < 0.){
    gf0	+=1.;
    gf1	+=1.;
  }
  while(gf1 > 1.){
    gf0-=1.;
    gf1-=1.;
  }
  ngfGL	=(gf1-gf0)*Np;
  if(ngfGL == 0)  ngfGL=1;
  I1	=ngfGL+1;
  q	=gf0*c2gp;
  dq	=c2gp*(gf1-gf0)/ngfGL;
  I1	=ngfGL+1;
  for(i=0; i < ngfGL; i++){

  }
  glNewList(PLASMA, GL_COMPILE);

  for(i=0; i < ngfGL; i++){
    glDrawElements(GL_QUAD_STRIP,J2,GL_UNSIGNED_INT,li);
    li+=J2;
  }


  glDisable(GL_LIGHTING);
  glColor3f(0.,0.,0.);
  glBegin(GL_LINES);
  v[0]	=0.;
  v[1]	=0.;
  v[2]	=0.;
  glVertex3fv(v);
  v[2]	=Z*1.5;
  glVertex3fv(v);
  v[0]	=0.;
  v[1]	=0.;
  v[2]	=0.;
  glVertex3fv(v);
  v[0]	=R*1.5;
  glVertex3fv(v);
  v[0]	=0.;
  v[1]	=0.;
  v[2]	=0.;
  glVertex3fv(v);
  v[1]	=R*1.5;
  glVertex3fv(v);
  glEnd();
  glEnable(GL_LIGHTING);
  glEndList();



  n	=nTor[0];
  v	=vTor[0];
  q	=gf0*c2gp;
  for(i=0; i < I1; i++){
    cs	=cos(q);
    sn	=sin(q);
    j	=0;
    while(j < J1){
      *n++	=nx[j]*cs;
      *n++	=nx[j]*sn;
      *n++	=ny[j];
      *v++	=x[j]*cs;
      *v++	=x[j]*sn;
      *v++	=y[j];
      j++;
    }
    q	+=dq;
  }
  li	=iTor;
  ji	=0;
  for(i=0; i < J1*ngfGL; i++){
    *li++	=ji;
    *li++	=ji+J1;
    ji++;
  }
  glDeleteLists(PLGRID,1);
  ViewTorSurface0();
#endif
  return(0);
}

#ifdef H
int Give2GL(int i)
{
  FlGL	=i;
  return(0);
}

int ViewTorSurface()
{
  glCallList(PLASMA);
  ViewXArrayGL((FlGL&0x01));
  GetObjAnlges(angle,angle+1,angle+2);
  return(0);
}

int ViewTorSurface0()
{
  int i,j,I1,J1,J2;
  GLuint *li;
  GLfloat v[3];
  GLdouble *ld,*vd;
  
  J1	=ngqGL+1;
  J2	=2*J1;

  glNewList(PLASMA, GL_COMPILE);
  li	=iTor;
  for(i=0; i < ngfGL; i++){
    glDrawElements(GL_QUAD_STRIP,J2,GL_UNSIGNED_INT,li);
    li+=J2;
  }
  glDisable(GL_LIGHTING);
  glColor3f(0.,0.,0.);
  glBegin(GL_LINES);
  v[0]	=0.;
  v[1]	=0.;
  v[2]	=0.;
  glVertex3fv(v);
  v[2]	=Z*1.5;
  glVertex3fv(v);
  v[0]	=0.;
  v[1]	=0.;
  v[2]	=0.;
  glVertex3fv(v);
  v[0]	=R*1.5;
  glVertex3fv(v);
  v[0]	=0.;
  v[1]	=0.;
  v[2]	=0.;
  glVertex3fv(v);
  v[1]	=R*1.5;
  glVertex3fv(v);
  glEnd();
  glEnable(GL_LIGHTING);
  glEndList();
  return(0);
}

int MakeTorSurface(double gq0,double gq1,double gf0,double gf1,double a)
{
  int Np=64;
  double x[128],y[128],nx[128],ny[128];
  int i,I1;
  int j,J1,ji;
  GLdouble *n;
  GLdouble *v;
  GLuint *li;
  double cs,sn,xa,ya,q,dq;

  a	=1.;
  q	=0.;
  EsiGetGeom(x,&xa,ny,y,&ya,nx,&a,&q,1);
  R	=x[0];
  q	=1.5*cgp;
  EsiGetGeom(x,&xa,ny,y,&ya,nx,&a,&q,1);
  Z	=y[0];

  while(gq1 > gq0+1.) gq1-=1.;
  while(gq0 < 0.){
    gq0	+=1.;
    gq1	+=1.;
  }
  while(gq1 > 1.){
     gq0-=1.;
     gq1-=1.;
  }
  ngqGL	=(gq1-gq0)*Np;
  if(ngqGL == 0)  ngqGL=1;
  J1	=ngqGL+1;
  
  q	=gq0*c2gp;
  dq	=c2gp*(gq1-gq0)/ngqGL;
  for(j=0; j < J1; j++){
    EsiGetGeom(x+j,&xa,ny+j,y+j,&ya,nx+j,&a,&q,1);
    xa	=1./sqrt(nx[j]*nx[j]+ny[j]*ny[j]);
    nx[j]	*=-xa;
    ny[j]	*=xa;
    q	+=dq;
  }
  while(gf1 > gf0+1.) gf1-=1.;
  while(gf0 < 0.){
    gf0	+=1.;
    gf1	+=1.;
  }
  while(gf1 > 1.){
    gf0-=1.;
    gf1-=1.;
  }
  ngfGL	=(gf1-gf0)*Np;
  if(ngfGL == 0)  ngfGL=1;
  I1	=ngfGL+1;

  q	=gf0*c2gp;
  dq	=c2gp*(gf1-gf0)/ngfGL;
  n	=nTor[0];
  v	=vTor[0];
  q	=gf0*c2gp;
  for(i=0; i < I1; i++){
    cs	=cos(q);
    sn	=sin(q);
    j	=0;
    while(j < J1){
      *n++	=nx[j]*cs;
      *n++	=nx[j]*sn;
      *n++	=ny[j];
      *v++	=x[j]*cs;
      *v++	=x[j]*sn;
      *v++	=y[j];
      j++;
    }
    q	+=dq;
  }
  li	=iTor;
  ji	=0;
  for(i=0; i < J1*ngfGL; i++){
    *li++	=ji;
    *li++	=ji+J1;
    ji++;
  }
  glDeleteLists(PLASMA,1);
  ViewTorSurface0();
  return(0);
}

static GLfloat vS[6]={-32.,-32.,-32.,-32.,-32.,-32.};
int ViewSignal()
{
  if((FlGL&0x04)) glCallList(SIGNAL);
  if((FlGL&0x08)) glCallList(PHOTONFLUX);
  GetObjAnlges(angle+3,angle+4,angle+5);
  return(0);
}

int ViewSignal0()
{
  int N=64,N1;
  int i,j,ji;
  GLuint *li;
  double L=48.;
  GLdouble *v0,*v1,*n0,*n1;

  N1	=N+1;
  glNewList(SIGNAL, GL_COMPILE);
  glShadeModel(GL_FLAT);
  li	=iSig0;
  for(i=0; i < N; i++){
    glBegin(GL_POLYGON);
    glNormal3dv(nSig[2]);
    for(j=0; j < N1; j++){
      glVertex3dv(vSig[*li]);
      li++;
      glVertex3dv(vSig[*li]);
      li++;
    }
    glEnd();
  }
  li	=iSig1;
  for(i=0; i < N; i++){
    glBegin(GL_POLYGON);
    glNormal3dv(nSig[3]);
    for(j=0; j < N1; j++){
      glVertex3dv(vSig[*li]);
      li++;
      glVertex3dv(vSig[*li]);
      li++;
    }
    glEnd();
  }
  v0	=vSig[0];
  v1	=v0+3;
  for(i=0; i < N; i++){
    glBegin(GL_QUAD_STRIP);
    for(j=0; j < N1; j++){
      glVertex3dv(v0);
      glVertex3dv(v1);
      v0+=6;
      if(v0[2] < v1[2]){
	glNormal3dv(nSig[0]);
      }  
      else{
	glNormal3dv(nSig[1]);
      }
      v1+=6;
      glVertex3dv(v0);
      glVertex3dv(v1);
      glNormal3dv(nSig[4]);
      v1+=6;
      v0+=6;
    }
    glEnd();
  }
  glDisable(GL_LIGHTING);
  glColor3f(0.,0.,0.);
  glBegin(GL_LINES);
  glVertex3fv(vS);
  vS[5]	=L;
  glVertex3fv(vS+3);
  glVertex3fv(vS);
  vS[5]	=-32.;
  vS[3]	=L;
  glVertex3fv(vS+3);
  glVertex3fv(vS);
  vS[3]	=-32.;
  vS[4]	=L;
  glVertex3fv(vS+3);
  vS[4]	=-32.;
  glEnd();
  glEnable(GL_LIGHTING);
  glEndList();

  N1	=N-1;
  glNewList(PHOTONFLUX, GL_COMPILE);
  glShadeModel(GL_SMOOTH);

  glBegin(GL_QUAD_STRIP);
  v0	=vSigS[0];
  glNormal3dv(nSig[2]);
  for(j=0; j < N; j++){
    glVertex3d(v0[0],v0[1],-32.);
    glVertex3dv(v0);
    v0+=3;
  }
  glEnd();

  glBegin(GL_QUAD_STRIP);
  glNormal3dv(nSig[3]);
  v0	=vSigS[N*N1];
  for(j=0; j < N; j++){
    glVertex3d(v0[0],v0[1],-32.);
    glVertex3dv(v0);
    v0+=3;
  }
  glEnd();
  glBegin(GL_QUAD_STRIP);

  glBegin(GL_QUAD_STRIP);
  ji	=0;
  glNormal3dv(nSig[1]);
  for(i=0; i < N; i++){
    v0	=vSigS[ji];
    glVertex3d(v0[0],v0[1],-32.);
    glVertex3dv(v0);
    ji	+=N;
  }
  glEnd();

  glBegin(GL_QUAD_STRIP);
  ji	=N1;
  glNormal3dv(nSig[0]);
  for(i=0; i < N; i++){
    v0	=vSigS[ji];
    glVertex3d(v0[0],v0[1],-32.);
    glVertex3dv(v0);
    ji	+=N;
  }
  glEnd();
  n0	=nSigS[0];
  n1	=nSigS[N];
  v0	=vSigS[0];
  v1	=vSigS[N];
  for(i=0; i < N1; i++){
    glBegin(GL_QUAD_STRIP);
    for(j=0; j < N; j++){
      glNormal3dv(n0);
      glVertex3dv(v0);
      glNormal3dv(n1);
      glVertex3dv(v1);
      n0+=3;
      n1+=3;
      v0+=3;
      v1+=3;
    }
    glEnd();
  }

  glDisable(GL_LIGHTING);
  glColor3f(0.,0.,0.);
  glBegin(GL_LINES);
  glVertex3fv(vS);
  vS[5]	=L;
  glVertex3fv(vS+3);
  glVertex3fv(vS);
  vS[5]	=-32.;
  vS[3]	=L;
  glVertex3fv(vS+3);
  glVertex3fv(vS);
  vS[3]	=-32.;
  vS[4]	=L;
  glVertex3fv(vS+3);
  vS[4]	=-32.;
  glEnd();
  glEnable(GL_LIGHTING);
  glEndList();
  return(0);
}

int MakeSigBase(double h0,double w0,int I,int J)
{
  int J1;
  int i;
  int j,ji;
  GLdouble *n;
  GLdouble *v;
  GLuint *li0,*li1;
  double x1,y1,z1,x2,y2;
  double h,h1;

  J1	=J+1;
  h	=h0/w0;
  h1	=1.-h;

  v	=vSig[0];
  li0	=iSig0;
  li1	=iSig1;

  x2	=-I/2;
  y2	=J/2-h1;
  z1	=-32.;
  ji	=0;
  for(i=0; i < I; i++){
    x1	=x2;
    y1	=y2;
    for(j=0; j < J1; j++){
      *v++	=x1;
      *v++	=y1;
      *v++	=z1;
      *li0++	=ji++;
      *v++	=x1;
      *v++	=y1-h;
      *v++	=z1;
      *li1++	=ji++;
      *v++	=x1;
      *v++	=y1;
      *v++	=z1;
      *li0++	=ji++;
      *v++	=x1;
      *v++	=y1-h;
      *v++	=z1;
      *li1++	=ji++;
      x1	+=1.;
    }
    y2	-=1.;
  }
  n	=nSig[0];
  *n++	=1.;
  *n++	=0.;
  *n++	=0.;
  *n++	=-1.;
  *n++	=0.;
  *n++	=0.;

  *n++	=0.;
  *n++	=1.;
  *n++	=0.;
  *n++	=0.;
  *n++	=-1.;
  *n++	=0.;

  *n++	=0.;
  *n++	=0.;
  *n++	=1.;
  *n++	=0.;
  *n++	=0.;
  *n++	=-1.;
  return(0);
}

int SetSignal(double *f,int I,int J)
{
  int I1,J1;
  int i;
  int j,k,ji;
  GLdouble *v,*n;
  GLuint *li;
  double z1,scz;
  double g[64],g2[64],x[64];
  
  I1	=I-1;
  J1	=J-1;
  
  z1	=0.;
  ji	=I*J;
  for(i=0; i < ji; i++) if(z1 < f[i]) z1=f[i];
  scz	=z1 != 0. ? 84./z1 : 1.;

  v	=vSig[0]+2;
  ji	=0;
  for(i=0; i < I; i++){
    v+=6;
    for(j=0; j < J; j++){
      z1	=scz*f[ji]-32.;
      *v	=z1;
      v	+=3;
      *v	=z1;
      v	+=3;
      *v	=z1;
      v	+=3;
      *v	=z1;
      v	+=3;
      ji++;
    }
    v+=6;
  }
  ji	=0;
  v	=vSigS[0];
  n	=nSigS[0];
  for(j=0; j < J; j++) x[j]=j-31.5;

  for(i=0; i < I; i++){
    for(j=0; j < J; j++){
      g[j]	=scz*f[ji]-32.;
      *v++	=x[j];
      *v++	=31.5-i;
      *v++	=g[j];
      ji++;
    }
    spl(g,g2,NULL,NULL,x,&J1);
    for(j=0; j < J1; j++){
      *n++	=g[j+1]-g[j]-cr6*(g2[j+1]+2.*g2[j]);
      n++;
      *n++	=1.;
    }
    *n++	=g[j]-g[j-1]+cr6*(2.*g2[j]+g2[j-1]);
    n++;
    *n++	=1.;
  }

  for(i=0; i < I; i++) x[i]=31.5-i;
  for(j=0; j < J; j++){
    ji	=j;
    for(i=0; i < I; i++){
      g[i]	=scz*f[ji]-32.;
      ji	+=J;
    }
    spl(g,g2,NULL,NULL,x,&I1);
    ji	=j;
    for(i=0; i < I1; i++){
      nSigS[ji][1]	=g[i+1]-g[i]-cr6*(g2[i+1]+2.*g2[i]);
      ji	+=J;
    }
    nSigS[ji][1]	=g[i]-g[i-1]+cr6*(2.*g2[i]+g2[i-1]);
    ji	+=J;
  }
  n	=nSigS[0];
  for(i=0; i < I; i++){
    for(j=0; j < J; j++){
      z1	=1./sqrt(n[0]*n[0]+n[1]*n[1]+n[2]*n[2]);
      *n	*=z1;
      n++;
      *n	*=z1;
      n++;
      *n	*=z1;
      n++;
    }
  }
  glDeleteLists(SIGNAL,2);
  ViewSignal0();
  return(0);
}

int SetOutGL(int i)
{
  extern int (*DisplObj)(void);
  lA	=&XArray;
  if(i == 0){
    double X[2]={-2.5,2.5},Y[2]={-2.5,2.5},Z[2]={-2.5,2.5};
    GLfloat lightZeroColor[]={1.,.4,.4,0.};
    SetWinGL(1);
    init();
    glEnableClientState(GL_NORMAL_ARRAY);
    glEnableClientState(GL_VERTEX_ARRAY);
    glNormalPointer(GL_DOUBLE,0,(void*)nTor[0]);
    glVertexPointer(3,GL_DOUBLE,0,(void*)vTor[0]);
    glLightfv(GL_LIGHT0, GL_DIFFUSE, lightZeroColor);
    SetObjAnlges(angle[0],angle[1],angle[2]);
    DisplObj	=ViewTorSurface;
    ScaleObj2Win(X[0],X[1],Y[0],Y[1],Z[0],Z[1],0);
  }
  else{
    double X[2]={-56.,56.},Y[2]={-56.,56.},Z[2]={-56.,56.};
    GLfloat lightZeroColor[]={.6,1.,.6,0.};
    SetWinGL(3);
    init();
    glDisableClientState(GL_NORMAL_ARRAY);
    glVertexPointer(3,GL_DOUBLE,0,(void*)vSig[0]);
    glLightfv(GL_LIGHT0, GL_DIFFUSE, lightZeroColor);
    SetObjAnlges(angle[3],angle[4],angle[5]);
    DisplObj	=ViewSignal;
    ScaleObj2Win(X[0],X[1],Y[0],Y[1],Z[0],Z[1],0);
  }
  return(0);
}

int ViewXArrayGL(int Fl)
{
  int i,j,I,J;
  double x1,y1,z1,x2,y2,z2,dx1,dy1,dz1,dx2,dy2,dz2,dx3,dy3,dz3;
  double x[8],y[8],z[8],L,tx,ty,tz,t,h,h1;
  SIGHTLINE *ls;

  glDisable(GL_LIGHTING);
  glBegin(GL_LINE_LOOP);
  for(i=1; i < 5; i++) glVertex3d(lA->x[i],lA->y[i],lA->z[i]);
  glEnd();

  ls	=lA->lSL;
  tx	=ls->tx;
  ty	=ls->ty;
  tz	=ls->tz;
  L	=sqrt(tx*tx+ty*ty+tz*tz);
  I	=lA->nW;
  J	=lA->nH;
  h	=lA->h0/lA->w0;
  h1	=1.-h;
  dx1	=lA->x[2]-lA->x[1];
  dy1	=lA->y[2]-lA->y[1];
  dz1	=lA->z[2]-lA->z[1];
  dx2	=(lA->x[3]-lA->x[2])/J;
  dy2	=(lA->y[3]-lA->y[2])/J;
  dz2	=(lA->z[3]-lA->z[2])/J;
  dx3	=dx2*h1;
  dy3	=dy2*h1;
  dz3	=dz2*h1;
  x2	=lA->x[1];
  y2	=lA->y[1];
  z2	=lA->z[1];
  x1=x2;
  y1=y2;
  z1=z2;
  glBegin(GL_POLYGON);
  glColor3f(0.,0.,1.);
  for(j=0; j < J; j++){
    x[0]	=x1;
    y[0]	=y1;
    z[0]	=z1;
    x[1]	=x1+dx1;
    y[1]	=y1+dy1;
    z[1]	=z1+dz1;
    x[2]	=x[1]+dx3;
    y[2]	=y[1]+dy3;
    z[2]	=z[1]+dz3;
    x[3]	=x1+dx3;
    y[3]	=y1+dy3;
    z[3]	=z1+dz3;
    for(i=0; i < 4; i++) glVertex3d(x[i],y[i],z[i]);
    x1	+=dx2;
    y1	+=dy2;
    z1	+=dz2;
  }
  glEnd();

  h1	=1./I;
  dx1	*=h1;
  dy1	*=h1;
  dz1	*=h1;
  x2	+=cr2*dx1;
  y2	+=cr2*dy1;
  z2	+=cr2*dz1;
  h1	=1.-cr2*h;
  if((Fl&0x01)){
    L	+=lA->D;
    glBegin(GL_LINES);
    glColor3f(0.,0.,0.);
    for(i=0; i < I; i++){
      x1=x2;
      y1=y2;
      z1=z2;
      for(j=0; j < J; j++){
	x[0]	=x1+dx2*h1;
	y[0]	=y1+dy2*h1;
	z[0]	=z1+dz2*h1;
	tx	=ls->x[0]-x[0];
	ty	=ls->y[0]-y[0];
	tz	=ls->z[0]-z[0];
	t	=L/sqrt(tx*tx+ty*ty+tz*tz);
	tx	*=t;
	ty	*=t;
	tz	*=t;
	x[1]	=x[0]+tx;
	y[1]	=y[0]+ty;
	z[1]	=z[0]+tz;
	glVertex3d(x[0],y[0],z[0]);
	glVertex3d(x[1],y[1],z[1]);
	x1	+=dx2;
	y1	+=dy2;
	z1	+=dz2;
      }
      x2	+=dx1;
      y2	+=dy1;
      z2	+=dz1;
    }
    glEnd();
  }
  else{
    x[1]	=ls->x[0];
    y[1]	=ls->y[0];
    z[1]	=ls->z[0];
    glBegin(GL_LINE_STRIP);
    for(i=0; i < 3; i++){
      t	=i < 2 ? ls->t[i] : 1.; 
      if(i == 1) glColor3f(1.,1.,0.);
      else glColor3f(0.,0.,0.);
      x[0]	=x[1];
      y[0]	=y[1];
      z[0]	=z[1];
      x[1]	=ls->x[0]+ls->tx*t;
      y[1]	=ls->y[0]+ls->ty*t;
      z[1]	=ls->z[0]+ls->tz*t;
      glVertex3d(x[0],y[0],z[0]);
      glVertex3d(x[1],y[1],z[1]);
    }
    glEnd();
  }
  glEnable(GL_LIGHTING);
  return(0);
}
#endif


#endif
