#include <math.h>
#include <stdio.h>
#include <string.h>
#include "pfc.h"

#ifndef mzl_MLIB
extern double cr2,cr3,cr4,cr6,cr12,cgp,c2gp,cgp_4,cr2gp,cgm0,crgm0;
#endif

extern PFBLOCK *PFB;
extern int ESNa,ESNa1;
extern double *ESaJ,*ESgY,*ESgY2a,*ESqgY,*ESqgY2a;
extern double *ESaR0,*ESaZ0;
extern int ESNa,ESNa1,ESNp1,ESnAP;
extern int ESNsep;
extern double ESRsep[],ESZsep[];

extern int gYdYWnd(double *gY,double *gYr,double *gYz,double r,double z
		   ,double *Rw,double *Zw,double *Iw, int Nw);

#ifndef mzl_SPLN
extern int SetSplXY(double x,double y);
extern int SetSplgYCell();
extern int PFCgYSpl(double *gY,double *gYr,double *gYz);
#endif

#ifndef mzl_PLV
extern int EGwNp;
extern double *EGwRp,*EGwZp,*EGwIp;
#endif
static int Nln=0,Iln,Npnt=256;
static double Rln[256],Zln[256];

double Rppp[32][256];
double Zppp[32][256];
static int kP;
int iPPP[32],kPPP;

static double Xm,Xx,Ym,Yx;
static double drdLSep[256],dzdLSep[256];
int ESNoln,kSln[0x40];
double ESrOln[0x600],ESzOln[0x600],ESgYOln[0x40];
double ESdrOln[0x600],ESdzOln[0x600];
double rDiv[0x100],zDiv[0x100];

int MFLinesOld()
{
  int i;
  for(i=0; i < kPPP; i++){
    ZPlotPolyLine(Rppp[i],Zppp[i],iPPP[i]);
  }
  return(0);
}

int MFLines(double Bx[2],double By[2],double *Xc,double *Yc,int Nc
	    ,int Nlin,double Step)
{
  double st,st0,stst,rerr;
  double gPln,dgP,gP0;
  double x,y,tx,ty,h,dx,dy,R2,Z2;
  double F,dFx,dFy,gY,gYr,gYz;
  int i,Iside,Ist,iter;
  int INTER,n;

  i	=Nc;
  Xm	=Bx[0];
  Ym	=By[0];
  Xx	=Bx[1];
  Yx	=By[1];

  gP0	= 1e+20;
  gPln	=-1e+20;
  for(i=0; i < Nc; i++){
    gYdYWnd(&F,&dFx,&dFy,Xc[i],Yc[i],EGwRp,EGwZp,EGwIp,EGwNp);
    if(SetSplXY(Xc[i],Yc[i])){
      PFCgYMF(&gY,&gYr,&gYz,Xc[i],Yc[i]);
      h		=c2gp*Xc[i];
      gYr	*=h;
      gYz	*=-h;
    }
    else{
      SetSplgYCell();
      PFCgYSpl(&gY,&gYr,&gYz);
    }
    F	+=gY;
    dFx	+=gYr;
    dFy	+=gYz;
    if(gPln < F){
      gPln	=F;
    }
    if(gP0 > F){
      gP0	=F;
    }
  }
  dgP	=(gPln-gP0)/Nlin;
  /*Beginning line calculations*/

  kPPP=0;
  for(n=0; n < Nlin; n++){
    gPln	=gP0+dgP*n;

    /*Beginning the line with a given $\Psi=\Psi_{line}$*/
    for(Iside=0; Iside < 2; Iside++){
      /*Initial conditions*/
      if(Iside){
	Rln[0]	=Xc[3];
	Zln[0]	=Yc[3];
      }
      else{
	iter	=0;
	rerr	=Step*Step*1e-4;
	R2	=Xc[1];
	Z2	=Yc[1];
	do{
	  gYdYWnd(&F,&dFx,&dFy,R2,Z2,EGwRp,EGwZp,EGwIp,EGwNp);
	  if(SetSplXY(R2,Z2)){
	    PFCgYMF(&gY,&gYr,&gYz,R2,Z2);
	    h	=c2gp*R2;
	    gYr	*=h;
	    gYz	*=-h;
	  }
	  else{
	    SetSplgYCell();
	    PFCgYSpl(&gY,&gYr,&gYz);
	  }
	  F	+=gY;
	  dFx	+=gYr;
	  dFy	+=gYz;

	  h	=(gPln-F)/(dFx*dFx+dFy*dFy);
	  dx	=dFx*h;
	  dy	=dFy*h;
	  R2	+=dx;
	  Z2	+=dy;
	  if(R2 < 0.){
	    R2	=1.e-6*EGwRp[0];
	  }
	  iter++;
	}while(dx*dx+dy*dy > rerr && iter < 10);
	Rln[0]	=R2;
	Zln[0]	=Z2;
      }
      st0	=Step;
      gYdYWnd(&F,&dFx,&dFy,Rln[0],Zln[0],EGwRp,EGwZp,EGwIp,EGwNp);

      if(SetSplXY(Rln[0],Zln[0])){
	PFCgYMF(&gY,&gYr,&gYz,Rln[0],Zln[0]);
	h	=c2gp*Rln[0];
	gYr	*=h;
	gYz	*=-h;
      }
      else{
	SetSplgYCell();
	PFCgYSpl(&gY,&gYr,&gYz);
      }
      F	+=gY;
      dFx	+=gYr;
      dFy	+=gYz;

      if(dFx < 0.){
	st0	=-Step;
      }
      stst	=st0*st0;
      rerr	=stst*1e-4;
      
      /*Beginning of a particular line*/
      for(Ist=0, st=st0; Ist < 2; Ist++, st=-st0){
	Iln	=0;
	x	=Rln[Iln];
	y	=Zln[Iln];
	INTER	=0;
	do{
	  /*First Step*/
	  iter	=0;
	  do{
	    gYdYWnd(&F,&dFx,&dFy,x,y,EGwRp,EGwZp,EGwIp,EGwNp);
	    if(SetSplXY(x,y)){
	      PFCgYMF(&gY,&gYr,&gYz,x,y);
	      h		=c2gp*x;
	      gYr	*=h;
	      gYz	*=-h;
	    }
	    else{
	      SetSplgYCell();
	      PFCgYSpl(&gY,&gYr,&gYz);
	    }
	    F	+=gY;
	    dFx	+=gYr;
	    dFy	+=gYz;

	    h	=(gPln-F)/(dFx*dFx+dFy*dFy);
	    dx	=dFx*h;
	    dy	=dFy*h;
	    x	+=dx;
	    y	+=dy;
	    if(x < 0.){
	      x	=1.e-6*EGwRp[0];
	    }
	    iter++;
	  }while(dx*dx+dy*dy > rerr && iter < 10);
	  if(Iln >= 0){
	    Rln[Iln]=x;
	    Zln[Iln]=y;
	  }
	  if(Iln > 0){
	    dx	=x-Rln[Iln-1];
     	    dy	=y-Zln[Iln-1];
	    h	=sqrt(dx*dx+dy*dy);
	    tx	=dx/h;
	    ty	=dy/h;
	    if(h > 2.*Step){
	      if(Iln > 2 && kPPP < 32){
		int j;
		for(j=0; j < Iln; j++){
		  Rppp[kPPP][j]	=Rln[j];
		  Zppp[kPPP][j]	=Zln[j];
		}
		iPPP[kPPP]	=Iln;
		kPPP++;
	      }
	      ZPlotPolyLine(Rln,Zln,Iln);
	      Iln	=-1;;
	    }
	  }
	  /*Analysis*/
	  if(Iln > 1){
	    if((Zln[Iln]-Zln[0])*(Zln[Iln-1]-Zln[0]) < 0. &&
	       fabs(Rln[Iln]-Rln[0]) < Step){
	      Ist++;
	    }
	    if((Zln[Iln]-Z2)*(Zln[Iln-1]-Z2) < 0. && fabs(Rln[Iln]-R2) < Step){
	      Iside++;
	    }	    
	    if(Iside > 1){
	      int j;
	      if(Iln > 2 && kPPP < 32){
		for(j=0; j < Iln; j++){
		  Rppp[kPPP][j]	=Rln[j];
		  Zppp[kPPP][j]	=Zln[j];
		}
		iPPP[kPPP]	=Iln;
		kPPP++;
	      }
	      ZPlotPolyLine(Rln,Zln,Iln);
	      Iln	=-1;
	      Ist++;
	    }
	    for(i=0; i <Iln-1; i++){
	      dx	=x-Rln[i];
	      dy	=y-Zln[i];
	      if(dx*dx+dy*dy < stst)
		INTER++;
	    }
	    if(INTER > 3){
	      int j;
	      if(Iln > 2 && kPPP < 32){
		for(j=0; j < Iln; j++){
		  Rppp[kPPP][j]	=Rln[j];
		  Zppp[kPPP][j]	=Zln[j];
		}
		iPPP[kPPP]	=Iln;
		kPPP++;
	      }
	      ZPlotPolyLine(Rln,Zln,Iln);
	      Iln	=-1;
	    }
	  }
	  /*Next approximated step*/
	  h	=st/sqrt(dFx*dFx+dFy*dFy);
	  dx	=-dFy*h;
	  dy	=dFx*h;
	  if(Iln > 0){
	    if(tx*dx+ty*dy < 0.){
	      st	=-st;
	      dx	=-dx;
	      dy	=-dy;
	    }
	  }
	  x	+=dx;
	  y	+=dy;
	  Iln++;
	}while(Iln < Npnt && Iln > 0
	       && Xm <= x && x <= Xx && Ym <= y && y <= Yx);
	if(Iln > 0){
	  if(kPPP < 32 && Iln > 2){
	    int j;
	    for(j=0; j < Iln; j++){
	      Rppp[kPPP][j]	=Rln[j];
	      Zppp[kPPP][j]	=Zln[j];
	    }
	    iPPP[kPPP]	=Iln;
	    kPPP++;
	  }
	  ZPlotPolyLine(Rln,Zln,Iln);
	}
      }/*{\tt Ist} cycle*/
    }/*{\tt Iside} cycle*/
  }
  return(0);
}

int MagFLines(double Bx[2],double By[2],double *Xc,double *Yc,int Nc
	      ,double *wR,double *wZ,double *wI,int Nw,int Nlin,double Step)
{
  double st,st0,stst,rerr;
  double gPln,dgP,gP0;
  double x,y,tx,ty,h,dx,dy,R2,Z2;
  double F,dFx,dFy;
  int i,Iside,Ist,iter;
  int INTER,n;

  i	=Nc;
  Xm	=Bx[0];
  Ym	=By[0];
  Xx	=Bx[1];
  Yx	=By[1];

  gP0	= 1e+20;
  gPln	=-1e+20;
  for(i=0; i < Nc; i++){
    gYdYWnd(&F,&dFx,&dFy,Xc[i],Yc[i],wR,wZ,wI,Nw);
    if(gPln < F) gPln	=F;
    if(gP0 > F) gP0	=F;
  }
  dgP	=(gPln-gP0)/Nlin;

  /*Beginning line calculations*/
  kPPP=0;
  for(n=0; n < Nlin; n++){
    gPln	=gP0+dgP*n;
    /*Beginning the line with a given $\Psi=\Psi_{line}$*/
    for(Iside=0; Iside < 2; Iside++){
      /*Initial conditions*/
      if(Iside){
	Rln[0]	=Xc[3];
	Zln[0]	=Yc[3];
      }
      else{
	iter	=0;
	rerr	=Step*Step*1e-4;
	R2	=Xc[1];
	Z2	=Yc[1];
	do{
	  gYdYWnd(&F,&dFx,&dFy,R2,Z2,wR,wZ,wI,Nw);
	  h	=(gPln-F)/(dFx*dFx+dFy*dFy);
	  dx	=dFx*h;
	  dy	=dFy*h;
	  R2	+=dx;
	  Z2	+=dy;
	  if(R2 < 0.) R2=1.e-6*wR[0];
	  iter++;
	}while(dx*dx+dy*dy > rerr && iter < 10);
	Rln[0]	=R2;
	Zln[0]	=Z2;
      }
      st0	=Step;
      gYdYWnd(&F,&dFx,&dFy,Rln[0],Zln[0],wR,wZ,wI,Nw);
      if(dFx < 0.) st0	=-Step;
      stst	=st0*st0;
      rerr	=stst*1e-4;
      
      /*Beginning of a particular line*/
      for(Ist=0, st=st0; Ist < 2; Ist++, st=-st0){
	Iln	=0;
	x	=Rln[Iln];
	y	=Zln[Iln];
	INTER	=0;
	do{
	  /*First Step*/
	  iter	=0;
	  do{
	    gYdYWnd(&F,&dFx,&dFy,x,y,wR,wZ,wI,Nw);
	    h	=(gPln-F)/(dFx*dFx+dFy*dFy);
	    dx	=dFx*h;
	    dy	=dFy*h;
	    x	+=dx;
	    y	+=dy;
	    if(x < 0.) x=1.e-6*wR[0];
	    iter++;
	  }while(dx*dx+dy*dy > rerr && iter < 10);
	  if(Iln >= 0){
	    Rln[Iln]=x;
	    Zln[Iln]=y;
	  }
	  if(Iln > 0){
	    dx	=x-Rln[Iln-1];
     	    dy	=y-Zln[Iln-1];
	    h	=sqrt(dx*dx+dy*dy);
	    tx	=dx/h;
	    ty	=dy/h;
	    if(h > 2.*Step){
	      if(Iln > 2 && kPPP < 32){
		int j;
		for(j=0; j < Iln; j++){
		  Rppp[kPPP][j]	=Rln[j];
		  Zppp[kPPP][j]	=Zln[j];
		}
		iPPP[kPPP]	=Iln;
		kPPP++;
	      }
	      ZPlotPolyLine(Rln,Zln,Iln);
	      Iln	=-1;;
	    }
	  }
	  /*Analysis*/
	  if(Iln > 1){
	    if((Zln[Iln]-Zln[0])*(Zln[Iln-1]-Zln[0]) < 0. &&
	       fabs(Rln[Iln]-Rln[0]) < Step){
	      Ist++;
	    }
	    if((Zln[Iln]-Z2)*(Zln[Iln-1]-Z2) < 0. && fabs(Rln[Iln]-R2) < Step){
	      Iside++;
	    }	    
	    if(Iside > 1){
	      int j;
	      if(Iln > 2 && kPPP < 32){
		for(j=0; j < Iln; j++){
		  Rppp[kPPP][j]	=Rln[j];
		  Zppp[kPPP][j]	=Zln[j];
		}
		iPPP[kPPP]	=Iln;
		kPPP++;
	      }
	      ZPlotPolyLine(Rln,Zln,Iln);
	      Iln	=-1;
	      Ist++;
	    }
	    for(i=0; i <Iln-1; i++){
	      dx	=x-Rln[i];
	      dy	=y-Zln[i];
	      if(dx*dx+dy*dy < stst) INTER++;
	    }
	    if(INTER > 3){
	      int j;
	      if(Iln > 2 && kPPP < 32){
		for(j=0; j < Iln; j++){
		  Rppp[kPPP][j]	=Rln[j];
		  Zppp[kPPP][j]	=Zln[j];
		}
		iPPP[kPPP]	=Iln;
		kPPP++;
	      }
	      ZPlotPolyLine(Rln,Zln,Iln);
	      Iln	=-1;
	    }
	  }
	  /*Next approximated step*/
	  h	=st/sqrt(dFx*dFx+dFy*dFy);
	  dx	=-dFy*h;
	  dy	=dFx*h;
	  if(Iln > 0){
	    if(tx*dx+ty*dy < 0.){
	      st	=-st;
	      dx	=-dx;
	      dy	=-dy;
	    }
	  }
	  x	+=dx;
	  y	+=dy;
	  Iln++;
	}while(Iln < Npnt && Iln > 0
	       && Xm <= x && x <= Xx && Ym <= y && y <= Yx);
	if(Iln > 0){
	  if(kPPP < 32 && Iln > 2){
	    int j;
	    for(j=0; j < Iln; j++){
	      Rppp[kPPP][j]	=Rln[j];
	      Zppp[kPPP][j]	=Zln[j];
	    }
	    iPPP[kPPP]	=Iln;
	    kPPP++;
	  }
	  ZPlotPolyLine(Rln,Zln,Iln);
	}
      }/*{\tt Ist} cycle*/
    }/*{\tt Iside} cycle*/
  }
  return(0);
}

int PFBzNullAtZ(double *X,double y,double Step)
{
  double x;
  double dFx,gY,gYr,gYz;
  int j,k;
  double u[2],v[2];

  u[0]	=*X;
  u[1]	=*X+Step;
  j	=0;
  while((k=Zero(&j,u,v,&x,dFx)) > 0 && j < 15){
    gYdYWnd(&gY,&dFx,&gYz,x,y,EGwRp,EGwZp,EGwIp,EGwNp);
    if(SetSplXY(x,y)){
      PFCgYMF(&gY,&gYr,&gYz,x,y);
      gYr	*=c2gp*x;
    }
    else{
      SetSplgYCell();
      PFCgYSpl(&gY,&gYr,&gYz);
    }
    dFx		+=gYr;
  }
  if(k == 0){
    *X	=x;
    return(0);
  }
  if(k < 0){
    return(-1);
  }
  return(1);
}

int MFOneLine(double *X,double *Y,int *Nb,double gYb,double Step)
{
  double stst,rerr;
  double x,y,h,dx,dy,d;
  double F,dFx,dFy,gY,gYr,gYz;
  int i,iter;
  
  stst	=1.1*Step*Step;
  rerr	=stst*1e-4;
  d	=2.*stst;
  i	=0;
  x	=X[0];
  y	=Y[0];
  do{
    iter	=0;
    do{
      gYdYWnd(&F,&dFx,&dFy,x,y,EGwRp,EGwZp,EGwIp,EGwNp);
      if(SetSplXY(x,y)){
	PFCgYMF(&gY,&gYr,&gYz,x,y);
	h	=c2gp*x;
	gYr	*=h;
	gYz	*=-h;
      }
      else{
	SetSplgYCell();
	PFCgYSpl(&gY,&gYr,&gYz);
      }
      F		+=gY;
      dFx	+=gYr;
      dFy	+=gYz;
      h		=(gYb-F)/(dFx*dFx+dFy*dFy);
      dx	=dFx*h;
      dy	=dFy*h;
      x		+=dx;
      y		+=dy;
      iter++;
    }while(dx*dx+dy*dy > rerr && iter < 10);
    X[i]	=x;
    Y[i]	=y;
    if(i > 2){
      dx	=x-X[0];
      dy	=y-Y[0];
      d	=dx*dx+dy*dy;
    }
    i++;
    h	=Step/sqrt(dFx*dFx+dFy*dFy);
    x	-=dFy*h;
    y	+=dFx*h;
  }while(i < 255 && d > stst);

  X[i]	=X[0];
  Y[i++]=Y[0];

#ifdef H
  out("&&&& s=i d","Step",i,Step);
  if(i < 32 || i > 255) return(0);
#endif
  *Nb	=i;
  return(1);
}

int kSbr[8],Nbr=0;
int PlotSepLine()
{
  int k,j;
  j	=0;
  for(k=0; k < Nbr; k++){
    ZPlotPolyLine(ESRsep+j,ESZsep+j, kSbr[k]-j);
    j	=kSbr[k];
  }
  return(0);
}

int MFSepLineOld(double *Bx,double *By,double Rx,double Zx,double Step,int Fl)
{
  double stst,rerr,d;
  double dir;
  double x,y,h,dx,dy,dx1,dy1,R,Z,st,gYx;
  double Xc[4],Yc[4],St[4],Dr[4];
  double F,dFx,dFy,gY,gYr,gYz;
  int i,j,k,Ist,iter,kA[4]={0,0,0,0};

  Nbr	=4;
  Xm	=Bx[0]-Step;
  Xx	=Bx[1]+Step;
  Ym	=By[0]-Step;
  Yx	=By[1]+Step;

  stst	=Step*Step;
  rerr	=stst*1e-4;
  
  x	=Rx;
  y	=Zx;

  gYdYWnd(&gYx,&dFx,&dFy,x,y,EGwRp,EGwZp,EGwIp,EGwNp);
  if(SetSplXY(x,y)){
    PFCgYMF(&gY,&gYr,&gYz,x,y);
    h	=c2gp*x;
    gYr	*=h;
    gYz	*=-h;
  }
  else{
    SetSplgYCell();
    PFCgYSpl(&gY,&gYr,&gYz);
  }
  gYx	+=gY;

  st	=Step;
  dy	=-0.5*Step;
  dx	=Zx > ESaZ0[0] ? 0.5*Step : -0.5*Step;
  for(i=0; i < 4; i++){
    x	=Rx-dy;
    y	=Zx+dx;
    do{
      gYdYWnd(&F,&dFx,&dFy,x,y,EGwRp,EGwZp,EGwIp,EGwNp);
      if(SetSplXY(x,y)){
	PFCgYMF(&gY,&gYr,&gYz,x,y);
	h	=c2gp*x;
	gYr	*=h;
	gYz	*=-h;
      }
      else{
	SetSplgYCell();
	PFCgYSpl(&gY,&gYr,&gYz);
      }
      F	+=gY;
      dFx+=gYr;
      dFy+=gYz;
      h	=(gYx-F)/(dFx*dFx+dFy*dFy);
      dx	=dFx*h;
      dy	=dFy*h;
      x	+=dx;
      y	+=dy;
      iter++;
    }while(dx*dx+dy*dy > rerr && iter < 10);

    h	=Step/sqrt(dFx*dFx+dFy*dFy);
    dx	=-dFy*h;
    dy	=dFx*h;

    k	=i;
    if(i == 1) k=2;
    if(i == 2) k=1;
    if(dx*(x-Rx)+dy*(y-Zx) > 0.){
      Dr[k]	=1.;
      St[k]	=Step;
    }else{
      Dr[k]	=-1.;
      St[k]	=-Step;
    }
    dx	=x-Rx;
    dy	=y-Zx;

    h	=0.5*Step/sqrt(dx*dx+dy*dy);
    dx	*=h;
    dy	*=h;
    Xc[k]	=Rx+dx;
    Yc[k]	=Zx+dy;
    kA[k]	=2;
    kSbr[i]	=0;
  }
  ESNsep	=0;
  for(k=0; k < 4; k++){
    if(kA[k]){
      kA[k]	=0;
      ESRsep[ESNsep]=Rx;
      ESZsep[ESNsep]=Zx;
      ESNsep++;
      R	=Rx;
      Z	=Zx;
      dx =Xc[k]-Rx;
      dy =Yc[k]-Zx;
      st=Dr[k]*Step;
      j	=0;
      x	=R;
      y	=Z;
      do{
	dx1	=dx;
	dy1	=dy;
	x	+=dx;
	y	+=dy;
	iter	=0;
	do{
	  gYdYWnd(&F,&dFx,&dFy,x,y,EGwRp,EGwZp,EGwIp,EGwNp);
	  if(SetSplXY(x,y)){
	    PFCgYMF(&gY,&gYr,&gYz,x,y);
	    h	=c2gp*x;
	    gYr	*=h;
	    gYz	*=-h;
	  }
	  else{
	    SetSplgYCell();
	    PFCgYSpl(&gY,&gYr,&gYz);
	  }
	  F	+=gY;
	  dFx	+=gYr;
	  dFy	+=gYz;
	  h	=(gYx-F)/(dFx*dFx+dFy*dFy);
	  dx	=dFx*h;
	  dy	=dFy*h;
	  x	+=dx;
	  y	+=dy;
	  if(x < 0.) x=1.e-6*EGwRp[0];
	  iter++;
	}while(dx*dx+dy*dy > rerr && iter < 10
	       && Xm <= x && x <= Xx && Ym <= y && y <= Yx);
	if(Xm <= x && x <= Xx && Ym <= y && y <= Yx){
	  ESRsep[ESNsep]=x;
	  ESZsep[ESNsep]=y;
	  ESNsep++;
	  j++;
	}
	else{
	  break;
	}
	/*Next approximated step*/
	h	=st/sqrt(dFx*dFx+dFy*dFy);
	dx	=-dFy*h;
	dy	=dFx*h;
	if(dx*dx1+dy*dy1 < 0.){
	  st	=-st;
	  dx	=-dx;
	  dy	=-dy;
	}
	if(j > 1){
	  for(i=k; i < 4; i++){
	    if(kA[i]){
	      dFx	=Xc[i]-x;
	      dFy	=Yc[i]-y;
	      d	=dFx*dFx+dFy*dFy;
	      if(d < stst){
		kA[i]=0;
		if(ESNsep < Npnt){
		  ESRsep[ESNsep]=Xc[i];
		  ESZsep[ESNsep]=Yc[i];
		  ESNsep++;
		}
		if(ESNsep < Npnt){
		  ESRsep[ESNsep]=Rx;
		  ESZsep[ESNsep]=Zx;
		  ESNsep++;
		}
		break;
	      }
	    }
	  }
	}
      }while(ESNsep < Npnt && Xm <= x && x <= Xx && Ym <= y && y <= Yx);
    }
    kSbr[k]	=ESNsep;
  }
#ifdef aaH
  ZPlotPolyLine(ESRsep,ESZsep,ESNsep);
#endif
  return(0);
}

int MFOutLines(double *Bx,double *By,double X,double Y,double gY00,double dgY
	       ,int N,double Step)
{
  double st,st0,stst,rerr;
  double x,y,tx,ty,h,dx,dy,dX,dY;
  int nC=0x20,kC[0x20];
  double Xc[0x21],Yc[0x21],gYc[0x21];
  double F,F1,dFx,dFy,gY,gYr,gYz,gY0,Ymn,Ymx;
  int i,j,Ist,iter;
  int INTER,n;

  Xm	=Bx[0]-0.1*Step;
  Ym	=By[0]-0.1*Step;
  Xx	=Bx[1]+0.1*Step;
  Yx	=By[1]+0.1*Step;

  dx	=4.*(Bx[1]-Bx[0])/nC;
  dy	=4.*(By[1]-By[0])/nC;

  j	=0;
  for(i=0; i < nC/4; i++){
    Xc[j]	=Bx[0]+dx*i;
    Yc[j++]	=By[0];
  }
  for(i=0; i < nC/4; i++){
    Xc[j]	=Bx[1];
    Yc[j++]	=By[0]+dy*i;
  }
  for(i=0; i < nC/4; i++){
    Xc[j]	=Bx[1]-dx*i;
    Yc[j++]	=By[1];
  }
  for(i=0; i < nC/4; i++){
    Xc[j]	=Bx[0];
    Yc[j++]	=By[1]-dy*i;
  }
  Xc[j]	=Xc[0];
  Yc[j++]=Yc[0];

  Ymx	=gY00;
  Ymn	=Ymx;
  for(i=0; i < nC; i++){
    x	=Xc[i];
    y	=Yc[i];
    gYdYWnd(&F,&dFx,&dFy,x,y,EGwRp,EGwZp,EGwIp,EGwNp);
    if(SetSplXY(x,y)){
      PFCgYMF(&gY,&gYr,&gYz,x,y);
    }
    else{
      SetSplgYCell();
      PFCgYSpl(&gY,&gYr,&gYz);
    }
    F	+=gY;
    gYc[i]	=F;
    if(Ymx < F) Ymx	=F;
    if(Ymn > F) Ymn	=F;
  }
  gYc[i]	=gYc[0];

  stst	=Step*Step;
  rerr	=stst*1e-4;
  kPPP	=0;
  gY0	=gY00;

  for(n=0; n < 0*N; n++){
    gY0	+=dgY;
    for(Ist=0, st=Step; Ist < 2; Ist++, st=-Step){
      Iln	=0;
      x		=X;
      y		=Y;
      dx	=0.;
      dy	=0.;
      INTER	=0;
      do{
	x	+=dx;
	y	+=dy;
	iter	=0;
	do{
	  gYdYWnd(&F,&dFx,&dFy,x,y,EGwRp,EGwZp,EGwIp,EGwNp);
	  if(SetSplXY(x,y)){
	    PFCgYMF(&gY,&gYr,&gYz,x,y);
	    h	=c2gp*x;
	    gYr	*=h;
	    gYz	*=-h;
	  }
	  else{
	    SetSplgYCell();
	    PFCgYSpl(&gY,&gYr,&gYz);
	  }
	  F	+=gY;
	  dFx	+=gYr;
	  dFy	+=gYz;

	  h	=(gY0-F)/(dFx*dFx+dFy*dFy);
	  dx	=dFx*h;
	  dy	=dFy*h;
	  x	+=dx;
	  y	+=dy;
	  if(x < 0.) x =1.e-6*EGwRp[0];
	  iter++;
	}while(dx*dx+dy*dy > rerr && iter < 10
	       && Xm <= x && x <= Xx && Ym <= y && y <= Yx);
	if(Iln == 0){
	  X	=x;
	  Y	=y;
	}
	Rln[Iln]=x;
	Zln[Iln]=y;
	if(Iln > 0){
	  dx	=x-Rln[Iln-1];
	  dy	=y-Zln[Iln-1];
	  h	=sqrt(dx*dx+dy*dy);
	  tx	=dx/h;
	  ty	=dy/h;
	  if(h > 2.*Step){
	    if(Iln > 2 && kPPP < 32){
	      int j;
	      for(j=0; j < Iln; j++){
		Rppp[kPPP][j]	=Rln[j];
		Zppp[kPPP][j]	=Zln[j];
	      }
	      iPPP[kPPP]	=Iln;
	      kPPP++;
	      ZPlotPolyLine(Rln,Zln,Iln);
	      Iln	=0;
	      break;
	    }
	  }
	}
	if(Iln > 1){
	  if((Zln[Iln]-Zln[0])*(Zln[Iln-1]-Zln[0]) < 0. &&
	     fabs(Rln[Iln]-Rln[0]) < Step){
	    ZPlotPolyLine(Rln,Zln,Iln);
	    Iln	=0;
	    Ist++;
	    break;
	  }
	  for(i=0; i <Iln-1; i++){
	    dx	=x-Rln[i];
	    dy	=y-Zln[i];
	    if(dx*dx+dy*dy < stst) INTER++;
	  }
	  if(INTER > 3){
	    int j;
	    if(Iln > 2 && kPPP < 32){
	      for(j=0; j < Iln; j++){
		Rppp[kPPP][j]	=Rln[j];
		Zppp[kPPP][j]	=Zln[j];
	      }
	      iPPP[kPPP]	=Iln;
	      kPPP++;
	    }
	    ZPlotPolyLine(Rln,Zln,Iln);
	    Iln	=0;
	    break;
	  }
	}
	/*Next approximated step*/
	h	=st/sqrt(dFx*dFx+dFy*dFy);
	dx	=-dFy*h;
	dy	=dFx*h;
	if(Iln > 0){
	  if(tx*dx+ty*dy < 0.){
	    st	=-st;
	    dx	=-dx;
	    dy	=-dy;
	  }
	}
	Iln++;
      }while(Iln < Npnt && Xm <= x && x <= Xx && Ym <= y && y <= Yx);
      if(Iln > 0 && kPPP < 32){
	int j;
	for(j=0; j < Iln; j++){
	  Rppp[kPPP][j]	=Rln[j];
	  Zppp[kPPP][j]	=Zln[j];
	}
	iPPP[kPPP]	=Iln;
	kPPP++;
	ZPlotPolyLine(Rln,Zln,Iln);
      }
    } /*{\tt Ist} cycle*/
  }


  st	=Step;
  gY0	=gY00;
  dgY	=fabs(dgY);
  while(gY0 >= Ymn) gY0 -=dgY;
  gY0	+=dgY;
  while(gY0 < Ymx){
    if(fabs(gY0-gY00) > 0.1*dgY){
      memset(kC,0,nC*sizeof(int));
      F1	=gYc[0];
      for(i=0; i < nC; i++){
	F	=F1;
	F1=gYc[i+1];
	if((F < gY0 && gY0 <= F1) || (F1 <= gY0 && gY0 < F)) kC[i]=1;
      }
      for(i=0; i < nC; i++){
	if(kC[i]){
	  Iln	=0;
	  x	=Xc[i];
	  y	=Yc[i];
	  dX	=Xc[i+1]-Xc[i];
	  dY	=Yc[i+1]-Yc[i];
	  do{
	    iter	=0;
	    do{
	      gYdYWnd(&F,&dFx,&dFy,x,y,EGwRp,EGwZp,EGwIp,EGwNp);
	      if(SetSplXY(x,y)){
		PFCgYMF(&gY,&gYr,&gYz,x,y);
		h	=c2gp*x;
		gYr	*=h;
		gYz	*=-h;
	      }
	      else{
		SetSplgYCell();
		PFCgYSpl(&gY,&gYr,&gYz);
	      }
	      F	+=gY;
	      dFx	+=gYr;
	      dFy	+=gYz;
	      if(Iln){
		h	=(gY0-F)/(dFx*dFx+dFy*dFy);
		dx	=dFx*h;
		dy	=dFy*h;
	      }else{
		h	=(gY0-F)/(dFx*dX+dFy*dY);
		dx	=dX*h;
		dy	=dY*h;
	      }
	      x	+=dx;
	      y	+=dy;
	      iter++;
	    }while(dx*dx+dy*dy > rerr && iter < 10 && Xm <= x && x <= Xx
		   && Ym <= y && y <= Yx);
	    if(Iln == 0 && (dFy*dY+dFx*dX)*st < 0.) st=-st;
	    Rln[Iln]	=x;
	    Zln[Iln++]	=y;
	    /*Next approximated step*/
	    h	=st/sqrt(dFx*dFx+dFy*dFy);
	    dx	=-dFy*h;
	    dy	=dFx*h;
	    x	+=dx;
	    y	+=dy;
	  }while(Iln < Npnt && Xm <= x && x <= Xx && Ym <= y && y <= Yx);
	  if(Iln > 0){
	    ZPlotPolyLine(Rln,Zln,Iln);
	    for(j=i+1; j < nC; j++){
	      dx	=fabs(Xc[j+1]-Xc[j]);
	      dy	=fabs(Yc[j+1]-Yc[j]);
	      h	=dx > dy ? dx : dy;
	      if((fabs(x-Xc[j]) < h && fabs(y-Yc[j]) < h)
		 || (fabs(x-Xc[j]) < h && fabs(y-Yc[j+1]) < h)){
		kC[j]=0;
	      }
	    }
	  }
	}
      }
    }
    gY0	+=dgY;
  }
  return(0);
}

int MFSepLineLZ(double *Bx,double *By,double Rx,double Zx,double Step,int Fl)
{
  double stst,rerr,d;
  double dir;
  double x,y,h,dx,dy,dx1,dy1,R,Z,st,gYx;
  double Xc[4],Yc[4],St[4],Dr[4];
  double F,dFx,dFy,gY,gYr,gYz;
  int i,j,k,Ist,iter,kA[4]={0,0,0,0};

  Nbr	=4;
  Xm	=Bx[0]-2.*Step;
  Xx	=Bx[1]+2.*Step;
  Ym	=By[0]-2.*Step;
  Yx	=By[1]+2.*Step;

  stst	=Step*Step;
  rerr	=stst*1e-4;
  
  x	=Rx;
  y	=Zx;

  gYdYWnd(&gYx,&dFx,&dFy,x,y,EGwRp,EGwZp,EGwIp,EGwNp);
  PFCgYMF(&gY,&gYr,&gYz,x,y);
  h	=c2gp*x;
  gYr	*=h;
  gYz	*=-h;
  gYx	+=gY;

  st	=Step;
  dy	=-0.5*Step;
  dx	=Zx > ESaZ0[0] ? 0.5*Step : -0.5*Step;
  for(i=0; i < 4; i++){
    x	=Rx-dy;
    y	=Zx+dx;
    do{
      gYdYWnd(&F,&dFx,&dFy,x,y,EGwRp,EGwZp,EGwIp,EGwNp);
      PFCgYMF(&gY,&gYr,&gYz,x,y);
      h	=c2gp*x;
      gYr	*=h;
      gYz	*=-h;
      F	+=gY;
      dFx+=gYr;
      dFy+=gYz;
      h	=(gYx-F)/(dFx*dFx+dFy*dFy);
      dx	=dFx*h;
      dy	=dFy*h;
      x	+=dx;
      y	+=dy;
      iter++;
    }while(dx*dx+dy*dy > rerr && iter < 10);

    h	=Step/sqrt(dFx*dFx+dFy*dFy);
    dx	=-dFy*h;
    dy	=dFx*h;

    k	=i;
    if(i == 1) k=2;
    if(i == 2) k=1;
    if(dx*(x-Rx)+dy*(y-Zx) > 0.){
      Dr[k]	=1.;
      St[k]	=Step;
    }else{
      Dr[k]	=-1.;
      St[k]	=-Step;
    }
    dx	=x-Rx;
    dy	=y-Zx;

    h	=0.5*Step/sqrt(dx*dx+dy*dy);
    dx	*=h;
    dy	*=h;
    Xc[k]	=Rx+dx;
    Yc[k]	=Zx+dy;
    kA[k]	=2;
    kSbr[i]	=0;
  }
  ESNsep	=0;
  for(k=0; k < 4; k++){
    if(kA[k]){
      kA[k]	=0;
      ESRsep[ESNsep]=Rx;
      ESZsep[ESNsep]=Zx;
      ESNsep++;
      R	=Rx;
      Z	=Zx;
      dx =Xc[k]-Rx;
      dy =Yc[k]-Zx;
      st=Dr[k]*Step;
      j	=0;
      x	=R;
      y	=Z;
      do{
	dx1	=dx;
	dy1	=dy;
	x	+=dx;
	y	+=dy;
	iter	=0;
	do{
	  gYdYWnd(&F,&dFx,&dFy,x,y,EGwRp,EGwZp,EGwIp,EGwNp);
	  PFCgYMF(&gY,&gYr,&gYz,x,y);
	  h	=c2gp*x;
	  gYr	*=h;
	  gYz	*=-h;
	  F	+=gY;
	  dFx	+=gYr;
	  dFy	+=gYz;
	  h	=(gYx-F)/(dFx*dFx+dFy*dFy);
	  dx	=dFx*h;
	  dy	=dFy*h;
	  x	+=dx;
	  y	+=dy;
	  if(x < 0.) x=1.e-6*EGwRp[0];
	  iter++;
	}while(dx*dx+dy*dy > rerr && iter < 10
	       && Xm <= x && x <= Xx && Ym <= y && y <= Yx);
	if(Xm <= x && x <= Xx && Ym <= y && y <= Yx){
	  ESRsep[ESNsep]=x;
	  ESZsep[ESNsep]=y;
	  ESNsep++;
	  j++;
	}
	else{
	  break;
	}
	/*Next approximated step*/
	h	=st/sqrt(dFx*dFx+dFy*dFy);
	dx	=-dFy*h;
	dy	=dFx*h;
	if(dx*dx1+dy*dy1 < 0.){
	  st	=-st;
	  dx	=-dx;
	  dy	=-dy;
	}
	if(j > 1){
	  for(i=k; i < 4; i++){
	    if(kA[i]){
	      dFx	=Xc[i]-x;
	      dFy	=Yc[i]-y;
	      d	=dFx*dFx+dFy*dFy;
	      if(d < stst){
		kA[i]=0;
		if(ESNsep < Npnt){
		  ESRsep[ESNsep]=Xc[i];
		  ESZsep[ESNsep]=Yc[i];
		  ESNsep++;
		}
		if(ESNsep < Npnt){
		  ESRsep[ESNsep]=Rx;
		  ESZsep[ESNsep]=Zx;
		  ESNsep++;
		}
		break;
	      }
	    }
	  }
	}
      }while(ESNsep < Npnt && Xm <= x && x <= Xx && Ym <= y && y <= Yx);
    }
    kSbr[k]	=ESNsep;
  }

  return(0);
  {
    FILE *lF;
    lF	=fopen("SepCont.00","w");
    fprintf(lF,"%4d\n",ESNsep);

    j	=0;
    for(k=0; k < Nbr; k++){
      fprintf(lF,"k=%4d\n",k);
      for(i=j,j	=kSbr[k]; i < j; i++){
	fprintf(lF,"%4d %24.16e %24.16e\n",i,ESRsep[i],ESZsep[i]);
      }
    }
    fclose(lF);
    CbStr2UserMessage("Output:%s\n","SepCont.00");
    printf("Output: %s\n","SepCont.00");
  }

#ifdef aaH
  ZPlotPolyLine(ESRsep,ESZsep,ESNsep);
#endif
  return(0);
}

int MFSepLine(double *Bx,double *By,double *Rx,double *Zx,int Nx
	      ,double Step,int Fl)
{
  double stst,ststr4,rerr,d,d0;
  double dir;
  double x,y,h,dx,dy,dx1,dy1,st,gYx;
  double Xc[8],Yc[8],St[8],Dr[8];
  double F,dFx,dFy,gY,gYr,gYz;
  double drdLX[4],dzdLX[4],drdLc[8],dzdLc[8];
  int i,j,k,kk,ik,n,iter,kA[8]={0,0,0,0,0,0,0,0};

  Xm	=Bx[0]-2.*Step;
  Xx	=Bx[1]+2.*Step;
  Ym	=By[0]-2.*Step;
  Yx	=By[1]+2.*Step;

  stst	=Step*Step;
  ststr4=stst*0.25;
  rerr	=stst*1e-6;
  
  x	=Rx[0];
  y	=Zx[0];
  gYdYWnd(&gYx,&dFx,&dFy,x,y,EGwRp,EGwZp,EGwIp,EGwNp);
  PFCgYMF(&gY,&gYr,&gYz,x,y);
  gYx	+=gY;

  dFx+=gYr;
  dFy+=gYz;
  drdLX[0]	=-dFy;
  dzdLX[0]	=dFx;
  for(i=1; i < Nx; i++){
    x	=Rx[i];
    y	=Zx[i];
    gYdYWnd(&F,&dFx,&dFy,x,y,EGwRp,EGwZp,EGwIp,EGwNp);
    PFCgYMF(&gY,&gYr,&gYz,x,y);
    dFx+=gYr;
    dFy+=gYz;
    drdLX[i]	=-dFy;
    dzdLX[i]	=dFx;
  }

  st	=Step;
  dy1	=0.7*Step;
  dx1	=0.7*Step;
  Nbr	=4*Nx;

  for(n=0; n < Nx; n++){
    for(i=0; i < 4; i++){
      dx	=dx1;
      dy	=dy1;
      dx1	=dy;
      dy1	=-dx;
      x	=Rx[n]+dx1;
      y	=Zx[n]+dy1;
      do{
	gYdYWnd(&F,&dFx,&dFy,x,y,EGwRp,EGwZp,EGwIp,EGwNp);
	PFCgYMF(&gY,&gYr,&gYz,x,y);
	h	=c2gp*x;
	gYr	*=h;
	gYz	*=-h;
	F	+=gY;
	dFx+=gYr;
	dFy+=gYz;
	h	=(gYx-F)/(dFx*dFx+dFy*dFy);
	dx	=dFx*h;
	dy	=dFy*h;
	x	+=dx;
	y	+=dy;
	iter++;
      }while(dx*dx+dy*dy > rerr && iter < 10);

      h	=Step/sqrt(dFx*dFx+dFy*dFy);
      dx	=-dFy*h;
      dy	=dFx*h;

      k	=4*n+i;
      if(i == 1) k=4*n+2;
      if(i == 2) k=4*n+1;
      if(dx*(x-Rx[n])+dy*(y-Zx[n]) > 0.){
	Dr[k]	=1.;
	St[k]	=Step;
      }else{
	Dr[k]	=-1.;
	St[k]	=-Step;
      }
      dx1	=x-Rx[n];
      dy1	=y-Zx[n];
      Xc[k]	=x;
      Yc[k]	=y;
      drdLc[k]	=-dFy;
      dzdLc[k]	=dFx;
      kA[k]	=2;
      kSbr[k]	=0;
    }
    dy1	=Step;
    dx1	=Step;
  }
  Step	*=0.75;
  ESNsep	=0;
  for(k=0; k < Nbr; k++){
    n	=k/4;
    if(kA[k]){
      kA[k]	=0;
      ESRsep[ESNsep]=Rx[n];
      ESZsep[ESNsep]=Zx[n];
      ESNsep++;

      dx =Xc[k]-Rx[n];
      dy =Yc[k]-Zx[n];
      st=Dr[k]*Step;
      j	=0;
      x	=Rx[n];
      y	=Zx[n];
      do{
	dx1	=dx;
	dy1	=dy;
	x	+=dx;
	y	+=dy;
	iter	=0;
	do{
	  gYdYWnd(&F,&dFx,&dFy,x,y,EGwRp,EGwZp,EGwIp,EGwNp);
	  PFCgYMF(&gY,&gYr,&gYz,x,y);
	  h	=c2gp*x;
	  gYr	*=h;
	  gYz	*=-h;
	  F	+=gY;
	  dFx	+=gYr;
	  dFy	+=gYz;
	  h	=(gYx-F)/(dFx*dFx+dFy*dFy);
	  dx	=dFx*h;
	  dy	=dFy*h;
	  x	+=dx;
	  y	+=dy;
	  if(x < 0.) x=1.e-6*EGwRp[0];
	  iter++;
	}while(dx*dx+dy*dy > rerr && iter < 10
	       && Xm <= x && x <= Xx && Ym <= y && y <= Yx);
	if(Xm <= x && x <= Xx && Ym <= y && y <= Yx){
	  ESRsep[ESNsep]=x;
	  ESZsep[ESNsep]=y;
	  drdLSep[ESNsep]=-dFy;
	  dzdLSep[ESNsep]=dFx;
	  ESNsep++;
	  j++;
	}
	else{
	  break;
	}
	/*Next approximated step*/
	h	=st/sqrt(dFx*dFx+dFy*dFy);
	dx	=-dFy*h;
	dy	=dFx*h;
	if(dx*dx1+dy*dy1 < 0.){
	  st	=-st;
	  dx	=-dx;
	  dy	=-dy;
	}
	if(j > 1){
	  d0=	stst;
	  ik	=-1;
	  for(i=k; i < Nbr; i++){
	    if(kA[i]){
	      dFx	=Xc[i]-x;
	      dFy	=Yc[i]-y;
	      d	=dFx*dFx+dFy*dFy;

	      if(d < d0){
		d0	=d;
		ik	=i;
	      }
	    }
	  }
	  if(kA[ik]){
	    if(ik >= 0){
	      kA[ik]=0;
	      out("@@@@@ ii dd",k,ik,Xc[ik],Yc[ik]);
	      if(ESNsep < Npnt && d0 > ststr4){
		ESRsep[ESNsep]=Xc[ik];
		ESZsep[ESNsep]=Yc[ik];
		drdLSep[ESNsep]=drdLc[ik];
		dzdLSep[ESNsep]=dzdLc[ik];
		ESNsep++;
		x	=Xc[ik];
		y	=Yc[ik];

	      }
	      if(ESNsep < Npnt){
		kk	=ik/4;
		ESRsep[ESNsep]=Rx[kk];
		ESZsep[ESNsep]=Zx[kk];
		drdLSep[ESNsep]=drdLX[kk];
		dzdLSep[ESNsep]=dzdLX[kk];
		x	=Rx[kk];
		y	=Zx[kk];
		ESNsep++;
	      }
	      i	=Nbr;
	      x	=Xx+Xx;
	    }
	  }
	  
	}
      }while(ESNsep < Npnt && Xm <= x && x <= Xx && Ym <= y && y <= Yx);
    }
    kSbr[k]	=ESNsep;
  }

  {
    FILE *lF;
    lF	=fopen("SepCont.00","w");
    fprintf(lF,"%4d\n",ESNsep);

    j	=0;
    for(k=0; k < Nbr; k++){
      fprintf(lF,"# %s  %s\n","Branch","N");
      fprintf(lF,"%7d %4d\n",k,kSbr[k]-j);
      for(i=j; i < kSbr[k]; i++){
	fprintf(lF,"%4d %24.16e %24.16e\n",i,ESRsep[i],ESZsep[i]);
      }
      j	=kSbr[k];
    }
    fclose(lF);
    CbStr2UserMessage("Output:%s\n","SepCont.00");
    printf("Output: %s\n","SepCont.00");
  }


  return(0);

  {
    FILE *lF;
    lF	=fopen("SepCont.00","w");
    fprintf(lF,"%4d\n",ESNsep);
    for(i=0; i < ESNsep; i++){
      fprintf(lF,"%4d %24.16e %24.16e\n",i,ESRsep[i],ESZsep[i]);
    }
    fclose(lF);
    CbStr2UserMessage("Output:%s\n","SepCont.00");
    printf("Output: %s\n","SepCont.00");
  }


#ifdef aaH
  ZPlotPolyLine(ESRsep,ESZsep,ESNsep);
#endif
  return(0);
}

int MFOutLine(double *Bx,double *By,double Rx,double Zx,double Step,int Fl)
{
  double stst,rerr,d;
  double x,y,h,dx,dy,st,gYx;
  double F,dFx,dFy,gY,gYr,gYz;
  int i,iter;

  Xm	=Bx[0]-2.*Step;
  Ym	=By[0]-2.*Step;
  Xx	=Bx[1]+2.*Step;
  Yx	=By[1]+2.*Step;

  Rx	=5.05;
  Zx	=-3.05;
  Ym	=-3.052;

  stst	=Step*Step;
  rerr	=stst*1e-4;
  
  x	=Rx;
  y	=Zx;

  gYdYWnd(&gYx,&dFx,&dFy,x,y,EGwRp,EGwZp,EGwIp,EGwNp);
  PFCgYMF(&gY,&gYr,&gYz,x,y);
  gYx	+=gY;

  st	=Step;

  ESNsep=0;
  dx	=0.;
  dy	=0.;
  x	=Rx;
  y	=Zx;
  do{
    iter	=0;
    x	+=dx;
    y	+=dy;
    do{
      gYdYWnd(&F,&dFx,&dFy,x,y,EGwRp,EGwZp,EGwIp,EGwNp);
      PFCgYMF(&gY,&gYr,&gYz,x,y);
      h		=c2gp*x;
      gYr	*=h;
      gYz	*=-h;
      F		+=gY;
      dFx	+=gYr;
      dFy	+=gYz;
      h		=(gYx-F)/(dFx*dFx+dFy*dFy);
      dx	=dFx*h;
      dy	=dFy*h;
      x	+=dx;
      y	+=dy;
      if(x < 0.) x=1.e-6*EGwRp[0];
      iter++;
    }while(dx*dx+dy*dy > rerr && iter < 10
	   && Xm <= x && x <= Xx && Ym <= y && y <= Yx);

    if(Xm <= x && x <= Xx && Ym <= y && y <= Yx){
      ESRsep[ESNsep]=x;
      ESZsep[ESNsep]=y;
      ESNsep++;
    }
    else{
      break;
    }
    /*Next approximated step*/
    h	=st/sqrt(dFx*dFx+dFy*dFy);
    dx	=-dFy*h;
    dy	=dFx*h;
  }while(ESNsep < Npnt && Xm <= x && x <= Xx && Ym <= y && y <= Yx);

  if(Fl){
    char FNm[0x10]="OutCont.00";
    FILE *lF;
    lF	=fopen(FNm,"w");
    fprintf(lF,"%4d\n",ESNsep);
    for(i=0; i < ESNsep; i++){
      fprintf(lF,"%4d %24.16e %24.16e\n",i,ESRsep[i],ESZsep[i]);
    }
    fclose(lF);
    CbStr2UserMessage("\nOutput:%s\n",FNm);
    printf("Output: %s\n",FNm);
  }
  return(0);
}

int MFFullLine(double *Bx,double *By,double baF,double R,double Z
	       ,double Step,int Fl)
{
  double stst,rerr,d;
  double x,y,f,h,dx,dy,df,st,gYx;
  double F,dFx,dFy,gY,gYr,gYz;
  int nF,nF0=0x1000;
  double r[0x1000],gf[0x1000],z[0x1000];
  int i,iter;

  Xm	=Bx[0]-2.*Step;
  Xx	=Bx[1]+2.*Step;
  Ym	=By[0]-2.*Step;
  Yx	=By[1]+2.*Step;

  R	=5.05;
  Z	=-3.05;
  Ym	=-3.052;

  stst	=Step*Step;
  rerr	=stst*1e-4;
  
  x	=R;
  y	=Z;

  gYdYWnd(&gYx,&dFx,&dFy,x,y,EGwRp,EGwZp,EGwIp,EGwNp);
  PFCgYMF(&gY,&gYr,&gYz,x,y);
  gYx	+=gY;

  st	=Step;

  nF=0;
  dx	=0.;
  dy	=0.;
  df	=0.;
  x	=R;
  y	=Z;
  f	=0.;
  do{
    x	+=dx;
    y	+=dy;
    f	+=df;
    iter=0;
    do{
      gYdYWnd(&F,&dFx,&dFy,x,y,EGwRp,EGwZp,EGwIp,EGwNp);
      PFCgYMF(&gY,&gYr,&gYz,x,y);
      h		=c2gp*x;
      gYr	*=h;
      gYz	*=-h;
      F		+=gY;
      dFx	+=gYr;
      dFy	+=gYz;
      h		=(gYx-F)/(dFx*dFx+dFy*dFy);
      dx	=dFx*h;
      dy	=dFy*h;
      x	+=dx;
      y	+=dy;
      if(x < 0.) x=1.e-6*EGwRp[0];
      iter++;
    }while(dx*dx+dy*dy > rerr && iter < 10
	   && Xm <= x && x <= Xx && Ym <= y && y <= Yx);
    
    if(Xm <= x && x <= Xx && Ym <= y && y <= Yx){
      r[nF]	=x;
      z[nF]	=y;
      gf[nF]	=f;
      nF++;
    }
    else{
      break;
    }
    /*Next approximated step*/
    dFx	*=cr2gp;
    dFy	*=cr2gp;
    h	=st/sqrt(dFx*dFx+dFy*dFy+baF*baF);
    dx	=-dFy*h;
    dy	=dFx*h;
    df	=baF*h/x;
  }while(nF < nF0 && Xm <= x && x <= Xx && Ym <= y && y <= Yx);

  if(Fl){
    extern double ESRBt;
    double Y,Yr,Yz,Yrr,Yrz,Yzz,Yrrz,Yzzr;
    double gYrr,gYrz,gYzz,gYrrz,gYzzr;
    char FNm[0x10]="FullLine.00";
    FILE *lF;

    lF	=fopen(FNm,"w");
    fprintf(lF,"%4d %8.4f %24.16e\n",nF,ESRBt,st);
    for(i=0; i < nF; i++){
      fprintf(lF,"%4d %24.16e %24.16e %24.16e\n",i,r[i],z[i],gf[i]);
    }

    fprintf(lF,"\n%4d %8.4f %24.16e\n",nF,ESRBt,st);
    for(i=0; i < nF; i++){
      gYdYd2Yd3YWnd(&Y,&Yr,&Yz,&Yrr,&Yrz,&Yzz,&Yrrz,&Yzzr,r[i],z[i]
		    ,EGwRp,EGwZp,EGwIp,EGwNp);
      gYdYd2Yd3YPFC(&gY,&gYr,&gYz,&gYrr,&gYrz,&gYzz,&gYrrz,&gYzzr,r[i],z[i]);
      Y		+=gY;
      Yr	+=gYr;
      Yz	+=gYz;
      Yrr	+=gYrr;
      Yrz	+=gYrz;
      Yzz	+=gYzz;
      Yrrz	+=gYrrz;
      Yzzr	+=gYzzr;
      
      Y		*=cr2gp;
      Yr	*=cr2gp;
      Yz	*=cr2gp;
      Yrr	*=cr2gp;

      Yrz	*=cr2gp;
      Yzz	*=cr2gp;
      Yrrz	*=cr2gp;
      Yzzr	*=cr2gp;
      fprintf(lF,"%4d %24.16e %24.16e %24.16e %24.16e\n",i,Y,Yr,Yz,Yrr);
      fprintf(lF,"%4d %24.16e %24.16e %24.16e %24.16e\n",i,Yrz,Yzz,Yrrz,Yzzr);
    }
    fclose(lF);
    CbStr2UserMessage("Output:%s\n",FNm);
    printf("Output: %s\n",FNm);
  }	
  return(0);
}

int MFDivertorsPer(double StD,double Step,int nStD,int nStS,int Nx)
{
  int i,j,k,nDiv,ns,Ndiv,nSg,nSt;
  int Nbr[4]={0,0,0,0},kt[4]={0,0,0,0};
  double st,s,Xc,Yc,dx,dy;
  double *lr,*lz,*ldr,*ldz;

  ns	=nStD+1;
  st	=StD;
  nSt	=nStS; 

  if(Nx == 1){
    kt[0]	=0;
    kt[1]	=2;
    nDiv	=2;
  }
  if(Nx == 2){
    kt[0]	=4;
    kt[1]	=6;
    kt[2]	=3;
    kt[3]	=1;
    nDiv	=4;
  }
  nSg	=2*nDiv;
  Ndiv	=0;
  for(i=0; i < nDiv; i++){
    if(kt[i] == 0){
      k	=0;
    }else{
      k	=kSbr[kt[i]-1];
    }
    lr	=ESRsep+k;
    lz	=ESZsep+k;
    ldr	=drdLSep+k;
    ldz	=dzdLSep+k;
    Xc	=lr[nSt];
    Yc	=lz[nSt];
    s	=st/sqrt(ldr[nSt]*ldr[nSt]+ldz[nSt]*ldz[nSt]);
    dx	=-ldz[nSt]*s;
    dy	=ldr[nSt]*s;
    for(j=0; j < ns; j++){
      rDiv[Ndiv]	=Xc+j*dx;
      zDiv[Ndiv]	=Yc+j*dy;
      Ndiv++;
    }
    dx	=ldz[nSt]*s;
    dy	=-ldr[nSt]*s;
    for(j=0; j < ns; j++){
      rDiv[Ndiv]	=Xc+j*dx;
      zDiv[Ndiv]	=Yc+j*dy;
      Ndiv++;
    }
  }
  for(i=0; i < nSg; i++){
    lr	=rDiv+i*ns;
    lz	=zDiv+i*ns;
    ZPlotPolyLine(lr,lz,ns);
  }	
  return(0);
}

int MFDivertors(double StD,double Step,int nStD,int nStS,int Nx)
{
  int i,ii,j,k,nDiv,ns,Ndiv,nSg,nSt,nSD;
  int nRg,nWk,nsD1,iter,nc,nSbrm;
  int knWk[2],kD[4]={0,0,0,0};
  int org[4],end[4];
  double st,s,s1,ss,ss1,h,x,y,dx,dy,dx1,dy1,XC,YC;
  double F,dFx,dFy,gY,gYr,gYz,gYx,Sn;
  double stst,rerr,err,d,dr;
  double rWk[0x200],zWk[0x200],drWk[0x100],dzWk[0x100],gYWk[0x100];
  double Xc[0x20],Yc[0x20],rDivE[2],zDivE[2];
  double uu[2],vv[2],Dr[4];
  double *lr,*lz,*lr1,*lz1,*ldr,*ldz,*lx,*ly,*lx1,*ly1;

  j	=0;
  nSbrm	=kSbr[0];
  for(k=0; k < Nbr; k++){
    nc	=kSbr[k]-j;
    if(nc && nc < nSbrm) nSbrm=nc;
    j	=kSbr[k];
  }
  if(nStS < 0) nStS=0;
  if(nStS > nSbrm-1) nStS=nSbrm-1;

  if(Nx == 1){
    kD[0]	=0;
    kD[1]	=2;
    nDiv	=2;
    nRg	=2;
    org[0]	=2;
    org[1]	=1;
    end[0]	=0;
    end[1]	=3;
    Dr[0]	=1.;
    Dr[1]	=-1.;
  }
  if(Nx == 2){
    kD[0]	=4;
    kD[1]	=6;
    kD[2]	=3;
    kD[3]	=1;
    nDiv	=4;
    nRg	=4;
    org[0]	=2;
    org[1]	=7;
    org[2]	=0;
    org[3]	=1;
    end[0]	=6;
    end[1]	=5;
    end[2]	=4;
    end[3]	=3;
    Dr[0]	=1.;
    Dr[1]	=-1.;
    Dr[2]	=-1.;
    Dr[3]	=-1.;
  }

  nSD	=nStD;
  nsD1	=nStD+1;
  ns	=nSD+1;;
  st	=StD;
  nSt	=nStS; 
  nSg	=2*nDiv;
  nc	=0;
  for(i=0; i < nDiv; i++){
    if(kD[i] == 0){
      k	=0;
    }else{
      k	=kSbr[kD[i]-1];
    }
    lr	=ESRsep+k;
    lz	=ESZsep+k;
    ldr	=drdLSep+k;
    ldz	=dzdLSep+k;

    s	=st/sqrt(ldr[nSt]*ldr[nSt]+ldz[nSt]*ldz[nSt]);
    dx	=-ldz[nSt]*s;
    dy	=ldr[nSt]*s;

    Xc[nc]	=lr[nSt];
    Yc[nc]	=lz[nSt];
    nc++;
    Xc[nc]	=lr[nSt]+nSD*dx;
    Yc[nc]	=lz[nSt]+nSD*dy;
    nc++;
    dx	=ldz[nSt]*s;
    dy	=-ldr[nSt]*s;
    Xc[nc]	=lr[nSt];
    Yc[nc]	=lz[nSt];
    nc++;
    Xc[nc]	=lr[nSt]+nSD*dx;
    Yc[nc]	=lz[nSt]+nSD*dy;
    nc++;
  }

  Nln	=0;
  ESNoln=0;
  nWk	=0;
  Ndiv	=0;
  for(i=0; i < nRg; i++){
    /*Redefine the position of the divertor*/
    dr	=Dr[i];
    lx	=Xc+2*org[i];
    ly	=Yc+2*org[i];
    lx1	=Xc+2*end[i];
    ly1	=Yc+2*end[i];
    dx1	=lx1[1]-lx1[0];
    dy1	=ly1[1]-ly1[0];

    for(ii=0; ii < 2; ii++){
      x	=lx[1];
      y	=ly[1];
      if(ii == 0){
	XC	=lx1[0];
	YC	=ly1[0];
	ss	=dy1*(x-lx1[0])-dx1*(y-ly1[0]);
      }
      if(ii == 1){
	XC	=lx[0];
	YC	=ly[0];
	ss1	=-1.;
      }
      gYdYWnd(&F,&dFx,&dFy,x,y,EGwRp,EGwZp,EGwIp,EGwNp);
      PFCgYMF(&gY,&gYr,&gYz,x,y);
      h	=c2gp*x;
      gYr*=h;
      gYz*=-h;
      F	+=gY;
      dFx+=gYr;
      dFy+=gYz;
      gYWk[nWk]	=F;
      gYx	=F;
      s	=-dFy*(x-XC)+dFx*(y-YC);
      dx	=0.;
      dy	=0.;
      do{
	iter	=0;
	x	+=dx;
	y	+=dy;
	do{
	  gYdYWnd(&F,&dFx,&dFy,x,y,EGwRp,EGwZp,EGwIp,EGwNp);
	  PFCgYMF(&gY,&gYr,&gYz,x,y);
	  h	=c2gp*x;
	  gYr	*=h;
	  gYz	*=-h;
	  F	+=gY;
	  dFx	+=gYr;
	  dFy	+=gYz;
	  h	=(gYx-F)/(dFx*dFx+dFy*dFy);
	  dx	=dFx*h;
	  dy	=dFy*h;
	  x	+=dx;
	  y	+=dy;
	  if(x < 0.) x=1.e-6*EGwRp[0];
	  iter++;
	}while(dx*dx+dy*dy > rerr && iter < 10);

	s1	=-dFy*(x-XC)+dFx*(y-YC);
	s1	*=s;
	if(ii == 0){
	  ss1	=dy1*(x-lx1[0])-dx1*(y-ly1[0]);
	  ss1	*=ss;
	}
	rWk[nWk]=x;
	zWk[nWk]=y;
	drWk[nWk]=-dFy;
	dzWk[nWk]=dFx;
	nWk++;
	if(s1 < 0. && ss1 < 0.){
	  break;
	}
	/*Next approximated step*/
	h	=st*dr/sqrt(dFx*dFx+dFy*dFy);
	dx	=-dFy*h;
	dy	=dFx*h;
      }while(nWk < 3*Npnt);
      rDivE[ii]	=x;
      zDivE[ii]	=y;
      knWk[ii]	=nWk;
      dr	*=-1.;
    }
    dx	=(rDivE[1]-lx[0])/nSD;
    dy	=(zDivE[1]-ly[0])/nSD;
    dx1	=(rDivE[0]-lx1[0])/nSD;
    dy1	=(zDivE[0]-ly1[0])/nSD;
    lr	=rDiv+nsD1*org[i];
    lz	=zDiv+nsD1*org[i];
    lr1	=rDiv+nsD1*end[i];
    lz1	=zDiv+nsD1*end[i];
    for(j=0; j < ns; j++){
      lr[j]	=lx[0]+j*dx;
      lz[j]	=ly[0]+j*dy;
      Ndiv++;
      lr1[j]	=lx1[0]+j*dx1;
      lz1[j]	=ly1[0]+j*dy1;
      Ndiv++;
    }
  }

  for(i=0; i < nSg; i++){
    lr	=rDiv+i*ns;
    lz	=zDiv+i*ns;
    ZPlotPolyLine(lr,lz,ns);
  }	
  return(0);
}

int MFOpenLn(int nStD,double Step,int Nx)
{
  int i,j,ic,iter,k,kk;
  int nsD1,nRg;
  int org[4],end[4];
  double *lr,*lz,*lr1,*lz1;
  double stst,rerr,err,d;
  double uu[2],vv[2],Dr[4];
  double x,y,x1,y1,dx,dy,dx1,dy1,h,st,Xnd,Ynd;
  double F,dFx,dFy,gY,gYr,gYz,gYx,s,Sn;
 
  if(Nx == 1){
    nRg	=2;
    org[0]	=2;
    org[1]	=1;
    end[0]	=0;
    end[1]	=3;
    Dr[0]	=1.;
    Dr[1]	=-1.;
  }
  if(Nx == 2){
    nRg	=4;
    org[0]	=2;
    org[1]	=7;
    org[2]	=0;
    org[3]	=1;
    end[0]	=6;
    end[1]	=5;
    end[2]	=4;
    end[3]	=3;
    Dr[0]	=1.;
    Dr[1]	=-1.;
    Dr[2]	=-1.;
    Dr[3]	=-1.;
  }
  nsD1	=nStD+1;
  stst	=Step*Step;
  rerr	=stst*1e-4;
  st	=Step;
  Nln	=0;
  ESNoln=0;
  for(i=0; i < nRg; i++){
    lr	=rDiv+nsD1*org[i];
    lz	=zDiv+nsD1*org[i];
    lr1	=rDiv+nsD1*end[i];
    lz1	=zDiv+nsD1*end[i];
    dx1	=lr1[1]-lr1[0];
    dy1	=lz1[1]-lz1[0];
    for(k=1; k < nsD1; k++){
      x	=lr[k];
      y	=lz[k];
      s	=dy1*(x-lr1[0])-dx1*(y-lz1[0]);
      if(s > 0.){
	Sn=1.;
      }else{
	Sn=-1.;
      }
      gYdYWnd(&F,&dFx,&dFy,x,y,EGwRp,EGwZp,EGwIp,EGwNp);
      PFCgYMF(&gY,&gYr,&gYz,x,y);
      F	+=gY;
      ESgYOln[Nln]	=F;
      gYx	=F;
      dx	=0.;
      dy	=0.;
      do{
	iter	=0;
	x	+=dx;
	y	+=dy;
	do{
	  gYdYWnd(&F,&dFx,&dFy,x,y,EGwRp,EGwZp,EGwIp,EGwNp);
	  PFCgYMF(&gY,&gYr,&gYz,x,y);
	  h	=c2gp*x;
	  gYr	*=h;
	  gYz	*=-h;
	  F	+=gY;
	  dFx	+=gYr;
	  dFy	+=gYz;
	  h	=(gYx-F)/(dFx*dFx+dFy*dFy);
	  dx	=dFx*h;
	  dy	=dFy*h;
	  x	+=dx;
	  y	+=dy;
	  if(x < 0.) x=1.e-6*EGwRp[0];
	  iter++;
	}while(dx*dx+dy*dy > rerr && iter < 10);
	s	=dy1*(x-lr1[0])-dx1*(y-lz1[0]);
	s	*=Sn;
	ESrOln[ESNoln]=x;
	ESzOln[ESNoln]=y;
	ESdrOln[ESNoln]=-dFy;
	ESdzOln[ESNoln]=dFx;
	ESNoln++;
	if(s < 0.){
	  break;
	}
	/*Next approximated step*/
	h	=st*Dr[i]/sqrt(dFx*dFx+dFy*dFy);
	dx	=-dFy*h;
	dy	=dFx*h;
      }while(ESNoln < 3*Npnt);
      kSln[Nln]	=ESNoln;
      Nln++;
    }
  }
#ifdef H
  j	=0;
  for(i=0;i < Nln; i++){
    ZPlotPolyLine(ESrOln+j,ESzOln+j,kSln[i]-j);
    j	=kSln[i];
  }
#endif
  return(0);
}

#ifdef EEC

/******************Grid Test************************/
extern double *ESsa,*ESsr,*ESsz,*ESsrt,*ESszt,*ESsra,*ESsza;
int jXSep;
int Np,Np1,nBL,nBL1,NSep;
double rXSoL[2],zXSoL[2];
double rSoL[0x20*0x100],zSoL[0x20*0x100],rqSoL[0x20*0x100],zqSoL[0x20*0x100]
  ,raSoL[0x20*0x100],zaSoL[0x20*0x100],raqSoL[0x20*0x100],zaqSoL[0x20*0x100];

double RBL[0x20][0x101],ZBL[0x20][0x101];
double RBLq[0x20][0x101],ZBLq[0x20][0x101];
double RBLa[0x20][0x101],ZBLa[0x20][0x101];
double RBLaq[0x20][0x101],ZBLaq[0x20][0x101]; 
double sr[0x41*0x101],sra[0x41*0x101],srq[0x41*0x101]
  ,sz[0x41*0x101],sza[0x41*0x101],szq[0x41*0x101];
double srBL[0x20*0x101],szBL[0x20*0x101],srqBL[0x20*0x101],szqBL[0x20*0x101];
double srSoL[0x600],szSoL[0x600],srqSoL[0x600],szqSoL[0x600];
 
int nBase[4],ERNa[4],ERNa1[4];
double aVac[4],saVac[0x40],gqVac[0x100];

int ESGridBL1X()
{
  int i,j,j1,k,m,m1,n,n1,ia;
  int nbr[8];
  double rX,zX,rX1,zX1,Av;
  double RSep[0x101],ZSep[0x101],RqSep[0x101],ZqSep[0x101];
  double dq,q[0x101],r2q[0x101];
  double *lr,*lrq,*lz,*lzq,*lr1,*lz1;
  double r[16],z[16];
  int ji,kk,jX;
  double r1,z1,dr1,dz1;
  double rv,rq,zv,zq,dr,dz,da;
  double nr,nz,tr,tz;
  double s,s1,x,err=0.,ierr;
  double uu[2],vv[2],gq[0x100];
  double z2q[0x101],L[0x20],La[0x20],f2[0x101];
  double sa[0x100];
 
  Av	=0.8;
  ia	=ESNa*Av;
  Np1	=ESNp1;
  Np	=Np1-1;
  nBL	=ESNa-ia;
  nBL1	=nBL+1;
  j	=0;
  for(i=0; i < Nbr; i++){	
    nbr[i]	=kSbr[i]-j;
    j	=kSbr[i];
  }

  lr	=ESRsep+nbr[0];
  lz	=ESZsep+nbr[0];
  lr1	=RSep;
  lz1	=ZSep;

  for(j=0; j < nbr[1]; j++){
    lr1[j]	=*(lr++);
    lz1[j]	=*(lz++);
  }

  NSep	=nbr[1];
  rX	=RSep[0];
  zX	=ZSep[0];
  rXSoL[0]	=rX;
  zXSoL[0]	=zX;

  m1	=nbr[1];
  m	=m1-1;
  dq	=c2gp/nbr[1];
  for(j=0; j < m1 ; j++){
    gq[j]	=j*dq;
  }
  lr	=RSep;
  lz	=ZSep;
  lrq	=RqSep;
  lzq	=ZqSep;
  spl1(lr,lrq,f2,NULL,NULL,gq,m);
  spl1(lz,lzq,f2,NULL,NULL,gq,m);

  k	=0;
  for(i=0; i < ESNa1; i++){
    ji	=ESNp1*i+ESNp1;
    for(j=0; j < ESNp1; j++){
      ji--;
      sr[k]	=ESsr[ji];
      sz[k]	=ESsz[ji];
      k++;
    }
  }
  da	=(1.-Av)/nBL;
  for(i=0; i < nBL1; i++){
    sa[i]	=Av+i*da;
  }

  for(i=0; i < nBL; i++){
    k	=(ia+i)*Np1;
    kk	=i*Np1;
    for(j=0; j < Np1; j++){
      srBL[kk+j]	=sr[k+j];
      szBL[kk+j]	=sz[k+j];
    }
  }
  dq	=c2gp/Np;
  for(j=0; j < Np; j++){
    gq[j]	=j*dq;
  }
  gq[Np]	=c2gp;
  for(i=0; i < nBL; i++){
    kk	=i*Np1;
    splp1(srBL+kk,srqBL+kk,f2,gq,Np);
    splp1(szBL+kk,szqBL+kk,f2,gq,Np);
  }

  SetXHermit(c2gp,Np);
  i	=0;
  uu[0]	=cgp/2.;
  uu[1]	=cgp/2.+0.05;
  do{
    zero(&i,uu,vv,&x,err);
    SetInterval(x);
    XHermit(&rv,&rq,srBL,srqBL);
    XHermit(&zv,&zq,szBL,szqBL);
    dr=rX-rv;
    dz=zX-zv;
    err	=dr*rq+dz*zq;
  }while(i < 15 && fabs(err) > 1e-9);
  if(i==15)  printf("&&&& q0:i=%d err=%10.3e q0=%10.3e\n",i,err,x);
  dq	=c2gp/Np;
  for(j=0; j < Np;j++){
    gq[j]	=x+j*dq;
    if(gq[j] > c2gp) gq[j]-=c2gp;
    SetInterval(gq[j]);
    XHermit(RBL[0]+j,RBLq[0]+j,srBL,srqBL);
    XHermit(ZBL[0]+j,ZBLq[0]+j,szBL,szqBL);
  }
  gq[Np]	=gq[0] > 0. ? gq[0] : gq[0]+c2gp;
  RBL[0][Np]	=RBL[0][0];
  RBLq[0][Np]	=RBLq[0][0];
  ZBL[0][Np]	=ZBL[0][0];
  ZBLq[0][Np]	=ZBLq[0][0];

  lr	=RSep;
  lrq	=RqSep;
  lz	=ZSep;
  lzq	=ZqSep;
  SetXHermit(c2gp,m);
  dq	=cgp/m;
  uu[0]	=0.;
  uu[1]	=dq;
  for(j=1; j < Np; j++){
    tr	=RBLq[0][j];
    tz	=ZBLq[0][j];
    i	=0;
    do{
      zero(&i,uu,vv,&x,err);
      SetInterval(x);
      XHermit(&r1,&dr1,lr,lrq);
      XHermit(&z1,&dz1,lz,lzq);
      dr	=r1-RBL[0][j];
      dz	=z1-ZBL[0][j];
      err	=dr*tr+dz*tz;
    }while(i < 15 && fabs(err) > 1e-9);
    if(i == 15) printf("warning Sep:j=%3d,iter=%3d,err=%10.3e\n",j,i,err);
    uu[0]	=x;
    uu[1]	=x+dq;
    RBL[nBL][j]	=r1;
    ZBL[nBL][j]	=z1;
  }
  RBL[nBL][0]	=RSep[0];
  ZBL[nBL][0]	=ZSep[0];
  RBL[nBL][Np]	=RSep[0];
  ZBL[nBL][Np]	=ZSep[0];

  SetXHermit(c2gp,Np);
  dq	=cgp/Np;
  uu[0]	=cgp/2.;
  uu[1]	=uu[0]+dq;
  for(i=1; i < nBL; i++){
    ji	=Np1*i;
    for(j=0; j < Np; j++){
      tr	=ZBL[nBL][j]-ZBL[0][j];
      tz	=RBL[0][j]-RBL[nBL][j];
      k	=0;
      do{
	zero(&k,uu,vv,&x,err);
	SetInterval(x);
	XHermit(&rv,&rq,srBL+ji,srqBL+ji);
	XHermit(&zv,&zq,szBL+ji,szqBL+ji);
	dr	=rv-RBL[0][j];
	dz	=zv-ZBL[0][j];
	err	=dr*tr+dz*tz;
      }while(k < 15 && fabs(err) > 1e-9);
      if(k == 15) 
	printf("warning BL:i=%3d,j=%3d,iter=%3d,err=%10.3e\n",i,j,k,err);
      if(x > c2gp) x-=c2gp;
      if(x < 0.) x+=c2gp;
      uu[0]	=x;
      uu[1]	=x+dq;
      RBL[i][j]	=rv;
      ZBL[i][j]	=zv;
      RBLq[i][j]=rq;
      ZBLq[i][j]=zq;
    }
    RBL[i][Np]	=RBL[i][0];
    ZBL[i][Np]	=ZBL[i][0];
    RBLq[i][Np]	=RBLq[i][0];
    ZBLq[i][Np]	=ZBLq[i][0];
  }

  for(j=0; j < Np; j++){
    for(i=0; i < nBL1; i++){	
      dr	=RBL[i][j]-RBL[0][j];
      dz	=ZBL[i][j]-ZBL[0][j];
      L[i]	=sqrt(dr*dr+dz*dz);
    }
    spl1(L,La,r2q,NULL,NULL,sa,nBL);
    nr	=-ZBLq[0][j];
    nz	=RBLq[0][j];
    s	=1./sqrt(nr*nr+nz*nz);
    nr	*=s;
    nz	*=s;
    for(i=0; i < nBL1; i++){
      RBLa[i][j]	=nr*La[i];
      ZBLa[i][j]	=nz*La[i];
    }
  }
  for(i=0; i < nBL1; i++){
    RBLa[i][Np]	=RBLa[i][0];
    ZBLa[i][Np]	=ZBLa[i][0];
  }

  dq	=c2gp/Np;
  for(j=0; j < Np; j++){
    gq[j]	=j*dq;
  }
  gq[Np]	=c2gp;

  for(i=0; i < nBL; i++){	
    splp1(RBL[i],RBLq[i],f2,gq,Np);
    splp1(ZBL[i],ZBLq[i],f2,gq,Np);
    RBLq[i][Np]=RBLq[i][0];
    ZBLq[i][Np]=ZBLq[i][0];
  }
  for(i=0; i < nBL; i++){	
    splp1(RBLa[i],RBLaq[i],f2,gq,Np);
    splp1(ZBLa[i],ZBLaq[i],f2,gq,Np);
    RBLaq[i][Np]=RBLaq[i][0];
    ZBLaq[i][Np]=ZBLaq[i][0];
  }
  i	=nBL;
  spl1(RBL[i],RBLq[i],f2,NULL,NULL,gq,Np);
  spl1(ZBL[i],ZBLq[i],f2,NULL,NULL,gq,Np);
  spl1(RBLa[i],RBLaq[i],f2,NULL,NULL,gq,Np);
  spl1(ZBLa[i],ZBLaq[i],f2,NULL,NULL,gq,Np);

  for(j=0; j < Np; j++){                                                      
    for(i=0; i < nBL1; i++){
      r[i]	=RBL[i][j];
      z[i]	=ZBL[i][j];
    }
    ZPlotPolyLine(r,z,nBL1);
  }
  for(i=0; i < nBL1; i++){
    ZPlotPolyLine(RBL[i],ZBL[i],Np1);
  }
  return(0);
}

int ESGridSoL1X(int nSD,int nSS)
{
  int i,j,k,ik,jk,ns1,nsm1,nn,m,m1,nSl,nSoL;
  int nRg=2;
  int nOln[0x40],nL[0x20],N[4],kSoL[0x40];
  double s,r,z,rq,zq,dr,dz,ds,dq,rX,zX,err=0.;
  double gq[0x100],L[0x100],La[0x100],sL[0x10],uu[2],vv[2],r2q[0x100];
  double *lr,*lz,*lrq,*lzq,*lr1,*lz1,*lrq1,*lzq1
    ,*lrS,*lzS,*lrqS,*lzqS,*lx,*ly,*lsL;
  double rBase[0x100],zBase[0x100];
  double rP[0x10],zP[0x10];
  int *ln;
  int na,na1,nq,nq1,kk;
  double aX,da,gq0,gq1,nr,nz;
  double *lra,*lza,*lraq,*lzaq,*lsa,*lgq;

  ns1	=nSD+1;
  nsm1	=nSD-1;
  j	=0;
  for(i=0; i < Nln; i++){
    nL[i]	=kSln[i]-j;
    j	=kSln[i];
  }

  /*Up region*/
  N[0]	=0;
  for(i=0; i < nSD; i++){
    N[0]	+=nL[i];
  }
  lr1	=ESrOln;
  lz1	=ESzOln;
  lrq1	=ESdrOln;
  lzq1	=ESdzOln;
  lr	=srSoL;
  lz	=szSoL;
  lrq	=srqSoL;
  lzq	=szqSoL;
  for(i=0; i < nSD; i++){
    memcpy(lr,lr1,nL[i]*sizeof(double));
    memcpy(lz,lz1,nL[i]*sizeof(double));
    memcpy(lrq,lrq1,nL[i]*sizeof(double));
    memcpy(lzq,lzq1,nL[i]*sizeof(double));
    lr	+=nL[i];
    lz	+=nL[i];
    lrq	+=nL[i];
    lzq	+=nL[i];
    lr1	+=nL[i];
    lz1	+=nL[i];
    lrq1+=nL[i];
    lzq1+=nL[i];
    nOln[i]=nL[i];
  }

  ln	=nOln;
  lr	=srSoL;
  lz	=szSoL;
  lrq	=srqSoL;
  lzq	=szqSoL;
  for(i=0; i < nSD; i++){
    m1	=ln[i];
    m	=m1-1;
    L[0]	=0.;
    for(j=1; j < m1; j++){
      dr	=lr[j]-lr[j-1];
      dz	=lz[j]-lz[j-1];
      s	=sqrt(dr*dr+dz*dz);
      L[j]	=L[j-1]+s;
    }
    sL[i]	=L[m];
    spl1(lr,lrq,r2q,NULL,NULL,L,m);
    spl1(lz,lzq,r2q,NULL,NULL,L,m);
    lr	+=m1;
    lz	+=m1;
    lrq	+=m1;
    lzq	+=m1;
  }

  nBase[0]	=0;
  k	=2;
  lr1	=ESRsep+kSbr[k-1]+nSS;
  lz1	=ESZsep+kSbr[k-1]+nSS;
  lr	=rBase;
  lz	=zBase;
  for(j=0; j < nSS; j++){
    *(lr++)	=*(lr1--);
    *(lz++)	=*(lz1--);
    nBase[0]++;
  }
  lr1	=RBL[nBL];
  lz1	=ZBL[nBL];
  for(j=0; j < Np1;j++){
    *(lr++)	=lr1[j];
    *(lz++)	=lz1[j];
    nBase[0]++;
  }

  k	=0;
  lr1	=ESRsep+kSbr[k-1];
  lz1	=ESZsep+kSbr[k-1];
  for(j=0; j < nSS; j++){
    *(lr++)	=lr1[j+1];
    *(lz++)	=lz1[j+1];
    nBase[0]++;
  }

  nn	=N[0]-ln[nsm1];
  m1	=ln[nsm1];
  m	=m1-1;
  lr	=srSoL+nn;
  lz	=szSoL+nn;
  lrq	=srqSoL+nn;
  lzq	=szqSoL+nn;
  dr	=lr[1]-lr[0];
  dz	=lz[1]-lz[0];
  ds	=0.5*sqrt(dr*dr+dz*dz);
  SetXHermit(sL[nsm1],m);

  nSoL=0;
  uu[0]	=0.;
  uu[1]	=ds;
  lr1	=rSoL+nBase[0]*nSD;
  lz1	=zSoL+nBase[0]*nSD;
  lrq1	=rqSoL+nBase[0]*nSD;
  lzq1	=zqSoL+nBase[0]*nSD;
  for(j=0; j < nBase[0];j++){
    rX	=rBase[j];
    zX	=zBase[j];
    k	=0;
    do{
      zero(&k,uu,vv,&s,err);
      SetInterval(s);
      XHermit(&r,&rq,lr,lrq);
      XHermit(&z,&zq,lz,lzq);
      dr=rX-r;
      dz=zX-z;
      err	=dr*rq+dz*zq;
    }while(k < 16 && fabs(err) > 1e-9);
    if(k==15)  printf("&&&& Up:j=%d k=%d err=%10.3e s=%10.3e\n",j,k,err,s);
    uu[0]	=s;
    uu[1]	=s+ds;
    lr1[j]	=r;
    lz1[j]	=z;
    lrq1[j]	=rq;
    lzq1[j]	=zq;
  }
  
  lr1	=rSoL;
  lz1	=zSoL;
  lrq1	=rqSoL;
  lzq1	=zqSoL;
  memcpy(lr1,rBase,nBase[0]*sizeof(double));
  memcpy(lz1,zBase,nBase[0]*sizeof(double));

  lr1	=rSoL+nBase[0];
  lz1	=zSoL+nBase[0];
  lrq1	=rqSoL+nBase[0];
  lzq1	=zqSoL+nBase[0];
  lrS	=rSoL+nBase[0]*nSD;
  lzS	=zSoL+nBase[0]*nSD;
  lr	=srSoL;
  lz	=szSoL;
  lrq	=srqSoL;
  lzq	=szqSoL;
  for(i=0; i < nsm1; i++){
    m1	=ln[i];
    m	=m1-1;
    SetXHermit(sL[i],m);
    uu[0]	=0.;
    uu[1]	=ds;
    for(j=0; j < nBase[0];j++){
      rX	=zBase[j]-lzS[j];
      zX	=lrS[j]-rBase[j];
      k	=0;
      do{
	zero(&k,uu,vv,&s,err);
	SetInterval(s);
	XHermit(&r,&rq,lr,lrq);
	XHermit(&z,&zq,lz,lzq);
	dr=rBase[j]-r;
	dz=zBase[j]-z;
	err	=dr*rX+dz*zX;
      }while(k < 16 && fabs(err) > 1e-9);
      if(k==15)  printf("&&&& Up:j=%d k=%d err=%10.3e s=%10.3e\n",j,k,err,s);
      uu[0]	=s;
      uu[1]	=s+ds;
      lr1[j]	=r;
      lz1[j]	=z;
      lrq1[j]	=rq;
      lzq1[j]	=zq;
    }
    lr1	+=nBase[0];
    lz1	+=nBase[0];
    lrq1+=nBase[0];
    lzq1+=nBase[0];
    lr	+=ln[i];
    lz	+=ln[i];
    lrq	+=ln[i];
    lzq	+=ln[i];
  }

#ifdef H
  lr	=rSoL;
  lz	=zSoL;
  for(i=0; i < ns1; i++){
    ZPlotPolyLine(lr,lz,nBase[0]);
    lr+=nBase[0];
    lz+=nBase[0];
  }
#endif
  lr	=rSoL;
  lz	=zSoL;
  for(j=0; j < nBase[0];j++){
    for(i=0; i < ns1; i++){
      k	=i*nBase[0]+j;
      rP[i]	=lr[k];
      zP[i]	=lz[k];
    }
    ZPlotPolyLine(rP,zP,ns1);
  }

  /*Down region*/
  N[1]	=0;
  ik	=nSD;
  jk	=2*nSD;
  for(i=ik; i < jk; i++){
    N[1]	+=nL[i];
  }
  nSl	=kSln[ik-1];
  lr1	=ESrOln+nSl;
  lz1	=ESzOln+nSl;
  lrq1	=ESdrOln+nSl;
  lzq1	=ESdzOln+nSl;
  lr	=srSoL+nSl;
  lz	=szSoL+nSl;
  lrq	=srqSoL+nSl;
  lzq	=szqSoL+nSl;
  ln	=nOln+ik;
  lsL	=sL+ik;
  for(i=0; i < nSD; i++){
    j	=i+ik;
    memcpy(lr,lr1,nL[j]*sizeof(double));
    memcpy(lz,lz1,nL[j]*sizeof(double));
    memcpy(lrq,lrq1,nL[j]*sizeof(double));
    memcpy(lzq,lzq1,nL[j]*sizeof(double));
    lr	+=nL[j];
    lz	+=nL[j];
    lrq	+=nL[j];
    lzq	+=nL[j];
    lr1	+=nL[j];
    lz1	+=nL[j];
    lrq1+=nL[j];
    lzq1+=nL[j];
    ln[i]=nL[j];
  }

  lr	=srSoL+nSl;
  lz	=szSoL+nSl;
  lrq	=srqSoL+nSl;
  lzq	=szqSoL+nSl;
  for(i=0; i < nSD; i++){
    m1	=ln[i];
    m	=m1-1;
    L[0]	=0.;
    for(j=1; j < m1; j++){
      dr	=lr[j]-lr[j-1];
      dz	=lz[j]-lz[j-1];
      s	=sqrt(dr*dr+dz*dz);
      L[j]	=L[j-1]+s;
    }
    lsL[i]	=L[m];
    spl1(lr,lrq,r2q,NULL,NULL,L,m);
    spl1(lz,lzq,r2q,NULL,NULL,L,m);
    lr	+=m1;
    lz	+=m1;
    lrq	+=m1;
    lzq	+=m1;
  }

  nBase[1]	=0;
  k	=0;
  lr1	=ESRsep+kSbr[k-1]+nSS;
  lz1	=ESZsep+kSbr[k-1]+nSS;
  lr	=rBase;
  lz	=zBase;
  for(j=0; j < nSS; j++){
    *(lr++)	=*(lr1--);
    *(lz++)	=*(lz1--);
    nBase[1]++;
  }

  k	=2;
  lr1	=ESRsep+kSbr[k-1];
  lz1	=ESZsep+kSbr[k-1]; 
  for(j=0; j < nSS+1; j++){
    *(lr++)	=lr1[j];
    *(lz++)	=lz1[j];
    nBase[1]++;
  }

  nn	=N[1]-ln[nsm1];
  m1	=ln[nsm1];
  m	=m1-1;
  lr	=srSoL+nSl+nn;
  lz	=szSoL+nSl+nn;
  lrq	=srqSoL+nSl+nn;
  lzq	=szqSoL+nSl+nn;
  dr	=lr[1]-lr[0];
  dz	=lz[1]-lz[0];
  ds	=0.5*sqrt(dr*dr+dz*dz);
  SetXHermit(lsL[nsm1],m);

  lrS	=rSoL+nBase[0]*ns1;
  lzS	=zSoL+nBase[0]*ns1;
  lrqS	=rqSoL+nBase[0]*ns1;
  lzqS	=zqSoL+nBase[0]*ns1;
  lr1	=lrS+nBase[1]*nSD;
  lz1	=lzS+nBase[1]*nSD;
  lrq1	=lrqS+nBase[1]*nSD;
  lzq1	=lzqS+nBase[1]*nSD;

  uu[0]	=0.;
  uu[1]	=ds;
  for(j=0; j < nBase[1];j++){
    rX	=rBase[j];
    zX	=zBase[j];
    k	=0;
    do{
      zero(&k,uu,vv,&s,err);
      SetInterval(s);
      XHermit(&r,&rq,lr,lrq);
      XHermit(&z,&zq,lz,lzq);
      dr=rX-r;
      dz=zX-z;
      err	=dr*rq+dz*zq;
    }while(k < 16 && fabs(err) > 1e-9);
    if(k==15)  printf("&&&& Down:j=%d k=%d err=%10.3e s=%10.3e\n",j,k,err,s);
    uu[0]	=s;
    uu[1]	=s+ds;
    lr1[j]	=r;
    lz1[j]	=z;
    lrq1[j]	=rq;
    lzq1[j]	=zq;
  }

  lr1	=lrS;
  lz1	=lzS;
  lrq1	=lrqS;
  lzq1	=lzqS;
  memcpy(lr1,rBase,nBase[1]*sizeof(double));
  memcpy(lz1,zBase,nBase[1]*sizeof(double));
  lr1	+=nBase[1];
  lz1	+=nBase[1];
  lrq1	+=nBase[1];
  lzq1	+=nBase[1];

  lx	=lrS+nBase[1]*nSD;
  ly	=lzS+nBase[1]*nSD;
  lr	=srSoL+nSl;
  lz	=szSoL+nSl;
  lrq	=srqSoL+nSl;
  lzq	=szqSoL+nSl;
  for(i=0; i < nsm1; i++){
    m1	=ln[i];
    m	=m1-1;
    SetXHermit(lsL[i],m);
    uu[0]	=0.;
    uu[1]	=ds;
    for(j=0; j < nBase[1];j++){
      rX	=zBase[j]-ly[j];
      zX	=lx[j]-rBase[j];
      k	=0;
      do{
	zero(&k,uu,vv,&s,err);
	SetInterval(s);
	XHermit(&r,&rq,lr,lrq);
	XHermit(&z,&zq,lz,lzq);
	dr=rBase[j]-r;
	dz=zBase[j]-z;
	err	=dr*rX+dz*zX;
      }while(k < 16 && fabs(err) > 1e-9);
      if(k==15)  printf("&&&& Up:j=%d k=%d err=%10.3e s=%10.3e\n",j,k,err,s);
      uu[0]	=s;
      uu[1]	=s+ds;
      lr1[j]	=r;
      lz1[j]	=z;
      lrq1[j]	=rq;
      lzq1[j]	=zq;
    }
    lr1	+=nBase[1];
    lz1	+=nBase[1];
    lrq1+=nBase[1];
    lzq1+=nBase[1];
    lr	+=ln[i];
    lz	+=ln[i];
    lrq	+=ln[i];
    lzq	+=ln[i];
  }

#ifdef H
  lr	=lrS;
  lz	=lzS;
  for(i=0; i < ns1; i++){
    ZPlotPolyLine(lr,lz,nBase[1]);
    lr+=nBase[1];
    lz+=nBase[1];
  }
#endif
  lr	=lrS;
  lz	=lzS;
  for(j=0; j < nBase[1];j++){
    for(i=0; i < ns1; i++){
      k	=i*nBase[1]+j;
      rP[i]	=lr[k];
      zP[i]	=lz[k];
    }
    ZPlotPolyLine(rP,zP,ns1);
  }

  for(k=0; k < nRg; k++){
    ik	=k*nSD;
    nSl	=kSln[ik-1];
    lr	=srSoL+nSl;
    lz	=szSoL+nSl;
    ln	=nOln+ik;
    for(i=0; i < nSD; i++){
      ZPlotPolyLine(lr,lz,ln[i]);
      lr+=ln[i];
      lz+=ln[i];
    }
  }



  /*Derivatives*/
  aX		=1.;
  aVac[0]	=1.4;
  aVac[1]	=1.4;
  na	=nSD;
  na1	=na+1;
  for(i=0; i < 4; i++){
    ERNa[i]	=nSD;
    ERNa1[i]	=nSD+1;
  }

  nq1	=nBase[0];
  nq	=nq1-1;
  lgq	=gqVac;
  lr	=rSoL;
  lz	=zSoL;
  L[0]	=0.;
  for(j=1; j < nq1; j++){
    dr	=lr[j]-lr[j-1];
    dz	=lz[j]-lz[j-1];
    s	=sqrt(dr*dr+dz*dz);
    L[j]	=L[j-1]+s;
  }
  k	=nq-nSS;
  gq0	=-c2gp*L[nSS]/(L[k]-L[nSS]);
  gq1	=c2gp+c2gp*(L[nq]-L[k])/(L[k]-L[nSS]);

  dq	=-gq0/nSS;
  for(j=0; j < nSS; j++){
    *(lgq++)	=gq0+j*dq;
  }
  k	=nq1-2*nSS;
  dq	=c2gp/(k-1);
  for(j=0; j < k; j++){
    *(lgq++)	=j*dq;
  }
  dq	=(gq1-c2gp)/nSS;
  for(j=1; j < nSS+1; j++){
    *(lgq++)	=c2gp+j*dq;
  }
  dq	=(gq1-c2gp)/nSS;
  for(j=0; j < nSS; j++){
    *(lgq++)	=gq1-j*dq-c2gp;
  }
  dq	=gq0/nSS;
  for(j=0; j < nSS+1; j++){
    *(lgq++)	=j*dq;  
  }

  lr	=rSoL;
  lz	=zSoL;
  lra	=raSoL;
  lza	=zaSoL;
  lsa	=saVac;
  for(k=0; k < nRg; k++){
    nq1	=nBase[k];
    nq	=nq1-1;
    da	=(aVac[k]-aX)/na;
    for(i=0; i < na1; i++){
      lsa[i]	=aX+i*da;
    }
    for(j=0; j < nq1; j++){
      for(i=0; i < na1; i++){
	kk	=i*nq1+j;
	dr	=lr[kk]-lr[j];
	dz	=lz[kk]-lz[j];
	L[i]	=sqrt(dr*dr+dz*dz);
      }
      spl1(L,La,r2q,NULL,NULL,lsa,na);
      nr	=dr;
      nz	=dz;
      s	=1./sqrt(nr*nr+nz*nz);
      nr	*=s;
      nz	*=s;

      for(i=0; i < na1; i++){
	kk	=i*nq1+j;
	lra[kk]	=nr*La[i];
	lza[kk]	=nz*La[i];
      }
    }
    lsa	+=na1;
    lr	+=nq1*na1;
    lz	+=nq1*na1;
    lra	+=nq1*na1;
    lza	+=nq1*na1;
  }

  lr	=rSoL;
  lz	=zSoL;
  lra	=raSoL;
  lza	=zaSoL;
  lrq	=rqSoL;
  lzq	=zqSoL;
  lraq	=raqSoL;
  lzaq	=zaqSoL;
  lgq	=gqVac;
  for(k=0; k < nRg; k++){
    nq1	=nBase[k];
    nq	=nq1-1;
    for(i=0; i < na1; i++){
      spl1(lr,lrq,r2q,NULL,NULL,lgq,nq);
      spl1(lz,lzq,r2q,NULL,NULL,lgq,nq);
      spl1(lra,lraq,r2q,NULL,NULL,lgq,nq);
      spl1(lza,lzaq,r2q,NULL,NULL,lgq,nq);
      lr+=nq1 ;
      lz+=nq1 ;
      lra+=nq1;
      lza+=nq1;
      lrq+=nq1;
      lzq+=nq1;
      lraq+=nq1;
      lzaq+=nq1;
    }
    lgq	+=nq1;
  }
  return(0);
}

int ESGridBL2X()
{
  int i,j,j1,k,m,m1,n,n1,ia;
  int nbr[8];
  double rX,zX,rX1,zX1,Av;
  double RSep[0x101],ZSep[0x101],RqSep[0x101],ZqSep[0x101];
  double dq,q[0x101],r2q[0x101];
  double *lr,*lrq,*lz,*lzq,*lr1,*lz1;
  double r[16],z[16];
  int ji,kk,jX;
  double r1,z1,dr1,dz1;
  double rv,rq,zv,zq,dr,dz,da;
  double nr,nz,tr,tz;
  double s,s1,x,err=0.,ierr;
  double uu[2],vv[2],gq[0x100];
  double z2q[0x101],L[0x20],La[0x20],f2[0x101];
  double sa[0x100];
 
  Av	=0.8;
  ia	=ESNa*Av;
  Np1	=ESNp1;
  Np	=Np1-1;
  nBL	=ESNa-ia;
  nBL1	=nBL+1;
  j	=0;
  for(i=0; i < Nbr; i++){	
    nbr[i]	=kSbr[i]-j;
    j	=kSbr[i];
  }

  lr	=ESRsep+nbr[0]+nbr[1]+nbr[2];
  lz	=ESZsep+nbr[0]+nbr[1]+nbr[2];
  lr1	=RSep;
  lz1	=ZSep;

  lr--;
  lz--; 
  for(j=0; j < nbr[2]; j++){
    lr1[j]	=*(lr--);
    lz1[j]	=*(lz--);
  }
  lr	=ESRsep;
  lz	=ESZsep;

  lr1	=RSep+nbr[2];
  lz1	=ZSep+nbr[2];
  for(j=0; j < nbr[0]; j++){
    lr1[j]	=lr[j];
    lz1[j]	=lz[j];
  }

  n1	=nbr[0];
  m1	=nbr[2];
  n	=n1-1;
  m	=m1-1;
  NSep	=m1+n1;
  rX	=RSep[0];
  zX	=ZSep[0];
  rX1	=RSep[m1];
  zX1	=ZSep[m1];
  rXSoL[0]	=rX;
  zXSoL[0]	=zX;
  rXSoL[1]	=rX1;
  zXSoL[1]	=zX1;

  dq	=cgp/m;
  for(j=0; j < m1 ; j++){
    q[j]	=j*dq;
  }
  lr	=RSep;
  lz	=ZSep;
  lrq	=RqSep;
  lzq	=ZqSep;
  spl1(lr,lrq,r2q,NULL,NULL,q,m);
  spl1(lz,lzq,r2q,NULL,NULL,q,m);
  dq	=cgp/n;
  for(j=0; j < n1 ; j++){
    q[j]	=cgp+j*dq;
  }

  lr	=RSep+m1;
  lz	=ZSep+m1;
  lrq	=RqSep+m1;
  lzq	=ZqSep+m1;
  spl1(lr,lrq,r2q,NULL,NULL,q,n);
  spl1(lz,lzq,r2q,NULL,NULL,q,n);

  k	=0;
  for(i=0; i < ESNa1; i++){
    ji	=ESNp1*i+ESNp1;
    for(j=0; j < ESNp1; j++){
      ji--;
      sr[k]	=ESsr[ji];
      sz[k]	=ESsz[ji];
      k++;
    }
  }

  da	=(1.-Av)/nBL;
  for(i=0; i < nBL1; i++){
    sa[i]	=Av+i*da;
  }

  for(i=0; i < nBL; i++){
    k	=(ia+i)*Np1;
    kk	=i*Np1;
    for(j=0; j < Np1; j++){
      srBL[kk+j]	=sr[k+j];
      szBL[kk+j]	=sz[k+j];
    }
  }

  dq	=c2gp/Np;
  for(j=0; j < Np; j++){
    gq[j]	=j*dq;
  }
  gq[Np]	=c2gp;
  for(i=0; i < nBL; i++){
    kk	=i*Np1;
    splp1(srBL+kk,srqBL+kk,f2,gq,Np);
    splp1(szBL+kk,szqBL+kk,f2,gq,Np);
  }
  SetXHermit(c2gp,Np);
  i	=0;
  uu[0]	=cgp/2.;
  uu[1]	=cgp/2.+0.05;
  do{
    zero(&i,uu,vv,&x,err);
    SetInterval(x);
    XHermit(&rv,&rq,srBL,srqBL);
    XHermit(&zv,&zq,szBL,szqBL);
    dr=rX-rv;
    dz=zX-zv;
    err	=dr*rq+dz*zq;
  }while(i < 15 && fabs(err) > 1e-9);
  if(i==15)  printf("&&&& q0:i=%d err=%10.3e q0=%10.3e\n",i,err,x);
  dq	=c2gp/Np;
  for(j=0; j < Np;j++){
    gq[j]	=x+j*dq;
    if(gq[j] > c2gp) gq[j]-=c2gp;
    SetInterval(gq[j]);
    XHermit(RBL[0]+j,RBLq[0]+j,srBL,srqBL);
    XHermit(ZBL[0]+j,ZBLq[0]+j,szBL,szqBL);
  }
  gq[Np]	=gq[0] > 0. ? gq[0] : gq[0]+c2gp;
  RBL[0][Np]	=RBL[0][0];
  RBLq[0][Np]	=RBLq[0][0];
  ZBL[0][Np]	=ZBL[0][0];
  ZBLq[0][Np]	=ZBLq[0][0];

  k	=Np/4;
  kk	=3*Np/4;
  for(j=k; j < kk; j++){
    dr	=rX1-RBL[0][j];
    dz	=zX1-ZBL[0][j];
    tr	=RBLq[0][j];
    tz	=ZBLq[0][j];
    s	=dr*tr+dz*tz;
    if(s < 0.){
      jX	=j;
      break;
    }
  }
  out("@@@@@@@@@@ ii i",k,kk,jX);

  lr	=RSep;
  lrq	=RqSep;
  lz	=ZSep;
  lzq	=ZqSep;
  SetXHermit(cgp,m);

  dq	=cgp/(2.*m);
  uu[0]	=0.;
  uu[1]	=dq;
  for(j=1; j < jX; j++){
    tr	=RBLq[0][j];
    tz	=ZBLq[0][j];
    i	=0;
    do{
      zero(&i,uu,vv,&x,err);
      SetInterval(x);
      XHermit(&r1,&dr1,lr,lrq);
      XHermit(&z1,&dz1,lz,lzq);
      dr	=r1-RBL[0][j];
      dz	=z1-ZBL[0][j];
      err	=dr*tr+dz*tz;
    }while(i < 15 && fabs(err) > 1e-9);
    if(i == 15) printf("warning Sep:j=%3d,iter=%3d,err=%10.3e\n",j,i,err);
    uu[0]	=x;
    uu[1]	=x+dq;
    RBL[nBL][j]	=r1;
    ZBL[nBL][j]	=z1;
  }

  lr	=RSep+m1;
  lrq	=RqSep+m1;
  lz	=ZSep+m1 ;
  lzq	=ZqSep+m1;
  SetXHermit(cgp,n);

  dq	=cgp/(2.*n);
  uu[0]	=cgp;
  uu[1]	=dq;
  for(j=jX; j < Np; j++){
    tr	=RBLq[0][j];
    tz	=ZBLq[0][j];
    i	=0;
    do{
      zero(&i,uu,vv,&x,err);
      SetInterval(x);
      XHermit(&r1,&dr1,lr,lrq);
      XHermit(&z1,&dz1,lz,lzq);
      dr	=r1-RBL[0][j];
      dz	=z1-ZBL[0][j];
      err	=dr*tr+dz*tz;
     }while(i < 15 && fabs(err) > 1e-9);
    if(i == 15) printf("warning Sep:j=%3d,iter=%3d,err=%10.3e\n",j,i,err);
    uu[0]	=x;
    uu[1]	=x+dq;
    RBL[nBL][j]	=r1;
    ZBL[nBL][j]	=z1;
  }
  RBL[nBL][0]	=RSep[0];
  ZBL[nBL][0]	=ZSep[0];
  RBL[nBL][Np]	=RSep[0];
  ZBL[nBL][Np]	=ZSep[0];

  s	=(RBL[nBL][jX-1]-rX1)*(RBL[nBL][jX-1]-rX1)
    +(ZBL[nBL][jX-1]-zX1)*(ZBL[nBL][jX-1]-zX1);
  s1	=(RBL[nBL][jX]-rX1)*(RBL[nBL][jX]-rX1)
    +(ZBL[nBL][jX]-zX1)*(ZBL[nBL][jX]-zX1);
  if(s > s1){
    RBL[nBL][jX]  =rX1;
    ZBL[nBL][jX]  =zX1;
  }else{
    RBL[nBL][jX-1]=rX1;
    ZBL[nBL][jX-1]=zX1;
    jX	=jX-1;
  }
  jXSep	=jX;

  /*Modification near the X-point*/
  int NmX;
  if(NmX < 2) NmX=0;
  NmX	=2;
  lr	=RBL[nBL]+jX;
  lz	=ZBL[nBL]+jX;
  L[0]	=0.;
  for(j=0; j < NmX; j++){
    lr1	=lr--;
    lz1	=lz--;
    s	=sqrt((lr[0]-lr1[0])*(lr[0]-lr1[0])+(lz[0]-lz1[0])*(lz[0]-lz1[0]));
    L[0]+=s;
    lr--;
    lz--;
  }
  L[0] /=NmX;

  lr	=RSep;
  lrq	=RqSep;
  lz	=ZSep;
  lzq	=ZqSep;
  SetXHermit(cgp,m);

  dq	=cgp/(2.*m);
  uu[0]	=jX*dq;
  uu[1]	=-dq;
  rv	=rX1;
  zv	=zX1;
  for(j=1; j < NmX; j++){
    i	=0;
    do{
      zero(&i,uu,vv,&x,err);
      SetInterval(x);
      XHermit(&r1,&dr1,lr,lrq);
      XHermit(&z1,&dz1,lz,lzq);
      dr	=r1-rv;
      dz	=z1-zv;
      err	=dr*dr+dz*dz-L[0]*L[0];
    }while(i < 15 && fabs(err) > 1e-9);
    if(i == 15) printf("warning Sep:j=%3d,iter=%3d,err=%10.3e\n",j,i,err);
    uu[0]	=x;
    uu[1]	=x-dq;
    RBL[nBL][jX-j]	=r1;
    ZBL[nBL][jX-j]	=z1;
  }

  lr	=RBL[nBL]+jX;
  lz	=ZBL[nBL]+jX;
  L[0]	=0.;
  for(j=0; j < NmX; j++){
    lr1	=lr++;
    lz1	=lz++;
    s	=sqrt((lr[0]-lr1[0])*(lr[0]-lr1[0])+(lz[0]-lz1[0])*(lz[0]-lz1[0]));
    L[0]+=s;
    lr++;
    lz++;
  }
  L[0] /=NmX;
  lr	=RSep+m1;
  lrq	=RqSep+m1;
  lz	=ZSep+m1 ;
  lzq	=ZqSep+m1;
  SetXHermit(cgp,n);

  dq	=cgp/(2.*n);
  uu[0]	=jX*dq;
  uu[1]	=dq;
  rv	=rX1;
  zv	=zX1;
  for(j=1; j < NmX; j++){
    i	=0;
    do{
      zero(&i,uu,vv,&x,err);
      SetInterval(x);
      XHermit(&r1,&dr1,lr,lrq);
      XHermit(&z1,&dz1,lz,lzq);
      dr	=r1-rv;
      dz	=z1-zv;
      err	=dr*dr+dz*dz-L[0]*L[0];
    }while(i < 15 && fabs(err) > 1e-9);
    if(i == 15) printf("warning Sep:j=%3d,iter=%3d,err=%10.3e\n",j,i,err);
    uu[0]	=x;
    uu[1]	=x+dq;
    RBL[nBL][jX+j]	=r1;
    ZBL[nBL][jX+j]	=z1;
  }
  /*********/
  SetXHermit(c2gp,Np);
  dq	=c2gp/(2.*Np);
  uu[0]	=cgp/2.;
  uu[1]	=uu[0]+dq;
  for(i=1; i < nBL; i++){
    ji	=Np1*i;
    for(j=0; j < Np; j++){
      tr	=ZBL[nBL][j]-ZBL[0][j];
      tz	=RBL[0][j]-RBL[nBL][j];
      k	=0;
      do{
	zero(&k,uu,vv,&x,err);
	SetInterval(x);
	XHermit(&rv,&rq,srBL+ji,srqBL+ji);
	XHermit(&zv,&zq,szBL+ji,szqBL+ji);
	dr	=rv-RBL[0][j];
	dz	=zv-ZBL[0][j];
	err	=dr*tr+dz*tz;
      }while(k < 15 && fabs(err) > 1e-9);
      if(k == 15) 
	printf("warning BL:i=%3d,j=%3d,iter=%3d,err=%10.3e\n",i,j,k,err);
      if(x > c2gp) x-=c2gp;
      if(x < 0.) x+=c2gp;
      uu[0]	=x;
      uu[1]	=x+dq;
      RBL[i][j]	=rv;
      ZBL[i][j]	=zv;
      RBLq[i][j]=rq;
      ZBLq[i][j]=zq;
    }
    RBL[i][Np]	=RBL[i][0];
    ZBL[i][Np]	=ZBL[i][0];
    RBLq[i][Np]	=RBLq[i][0];
    ZBLq[i][Np]	=ZBLq[i][0];
  }

  for(j=0; j < Np; j++){
    for(i=0; i < nBL1; i++){	
      dr	=RBL[i][j]-RBL[0][j];
      dz	=ZBL[i][j]-ZBL[0][j];
      L[i]	=sqrt(dr*dr+dz*dz);
    }
    spl1(L,La,r2q,NULL,NULL,sa,nBL);
    nr	=-ZBLq[0][j];
    nz	=RBLq[0][j];
    s	=1./sqrt(nr*nr+nz*nz);
    nr	*=s;
    nz	*=s;
    for(i=0; i < nBL1; i++){
      RBLa[i][j]	=nr*La[i];
      ZBLa[i][j]	=nz*La[i];
    }
  }
  for(i=0; i < nBL1; i++){
    RBLa[i][Np]	=RBLa[i][0];
    ZBLa[i][Np]	=ZBLa[i][0];
  }

  dq	=c2gp/Np;
  for(j=0; j < Np; j++){
    gq[j]	=j*dq;
  }
  gq[Np]	=c2gp;

  for(i=0; i < nBL; i++){	
    splp1(RBL[i],RBLq[i],f2,gq,Np);
    splp1(ZBL[i],ZBLq[i],f2,gq,Np);
    RBLq[i][Np]=RBLq[i][0];
    ZBLq[i][Np]=ZBLq[i][0];
  }
  for(i=0; i < nBL; i++){	
    splp1(RBLa[i],RBLaq[i],f2,gq,Np);
    splp1(ZBLa[i],ZBLaq[i],f2,gq,Np);
    RBLaq[i][Np]=RBLaq[i][0];
    ZBLaq[i][Np]=ZBLaq[i][0];
  }
  k	=Np1-jX;
  i	=nBL;
  lr	=RBL[i]+jX;
  lz	=ZBL[i]+jX;
  lrq	=RBLq[i]+jX;
  lzq	=ZBLq[i]+jX;
  spl1(lr,lrq,r2q,NULL,NULL,gq+jX,k);
  spl1(lz,lzq,r2q,NULL,NULL,gq+jX,k);

  RBLq[i][Np1]	=lrq[0];
  ZBLq[i][Np1]	=lzq[0];
  lr	=RBLa[i]+jX;
  lz	=ZBLa[i]+jX;
  lrq	=RBLaq[i]+jX;
  lzq	=ZBLaq[i]+jX;
  spl1(lr,lrq,r2q,NULL,NULL,gq+jX,k);
  spl1(lz,lzq,r2q,NULL,NULL,gq+jX,k);
  RBLaq[i][Np1]	=lrq[0];
  ZBLaq[i][Np1]	=lzq[0];

  lr	=RBL[i] ;
  lz	=ZBL[i] ;
  lrq	=RBLq[i];
  lzq	=ZBLq[i];
  spl1(lr,lrq,r2q,NULL,NULL,gq,jX);
  spl1(lz,lzq,r2q,NULL,NULL,gq,jX);
  lr	=RBLa[i] ;
  lz	=ZBLa[i] ;
  lrq	=RBLaq[i];
  lzq	=ZBLaq[i];
  spl1(lr,lrq,r2q,NULL,NULL,gq,jX);
  spl1(lz,lzq,r2q,NULL,NULL,gq,jX);

  for(j=0; j < Np; j++){                                                      
    for(i=0; i < nBL1; i++){
      r[i]	=RBL[i][j];
      z[i]	=ZBL[i][j];
    }
    ZPlotPolyLine(r,z,nBL1);
  }
  for(i=0; i < nBL; i++){
    ZPlotPolyLine(RBL[i],ZBL[i],Np1);
  }
  i	=nBL;
  ZPlotPolyLine(RBL[i],ZBL[i],Np1);
  return(0);
}

int ESGridSoL2X(int nSD,int nSS)
{
  int i,j,k,ik,jk,kk,iik,ns1,nsm1,nn,m,m1,nSl;
  int nOln[0x40],nL[0x40],N[4];
  int nSoL,kSoL[0x40];
  double s,r,z,rq,zq,dr,dz,ds,dq,rX,zX,err=0.;
  double srSoL[0x600],szSoL[0x600],srqSoL[0x600],szqSoL[0x600];
  double gq[0x100],L[0x100],La[0x100],sL[0x40],uu[2],vv[2],r2q[0x100];
  double rBase[0x100],zBase[0x100],rP[0x10],zP[0x10];
  double *lr,*lz,*lrq,*lzq,*lr1,*lz1,*lrq1,*lzq1
    ,*lsL,*lrS,*lzS,*lrqS,*lzqS,*lx,*ly,*lrB,*lzB;
  int *ln;
  int nRg=4;
  int na,na1,nq,nq1;
  double aX,da,gq0,gq1,gq2,gq3,nr,nz;
  double *lra,*lza,*lraq,*lzaq,*lsa,*lgq;

  ns1	=nSD+1;
  nsm1	=nSD-1;
  j	=0;
  for(i=0; i < Nln; i++){
    nL[i]	=kSln[i]-j;
    j	=kSln[i];
  }
  
  for(k=0; k < nRg; k++){
    ik	=k*nSD;
    jk	=ik+nSD;
    N[k]=0;
    for(i=ik; i < jk; i++){
      N[k]	+=nL[i];
    }
    nSl	=kSln[ik-1];
    lr1	=ESrOln+nSl;
    lz1	=ESzOln+nSl;
    lrq1=ESdrOln+nSl;
    lzq1=ESdzOln+nSl;
    lr	=srSoL+nSl;
    lz	=szSoL+nSl;
    lrq	=srqSoL+nSl;
    lzq	=szqSoL+nSl;
    ln	=nOln+ik;
    lsL	=sL+ik;
    if(k == 2){
      for(i=0; i < nSD; i++){
	iik	=i+ik;
	kk=nL[iik];
	for(j=0; j < nL[iik]; j++){
	  kk--;
	  lr[kk]	=lr1[j];
	  lz[kk]	=lz1[j];
	  lrq[kk]	=lrq1[j];
	  lzq[kk]	=lzq1[j];
	}
	lr  +=nL[iik];
	lz  +=nL[iik];
	lrq +=nL[iik];
	lzq +=nL[iik];
	lr1 +=nL[iik];
	lz1 +=nL[iik];
	lrq1+=nL[iik];
	lzq1+=nL[iik];
	ln[i]=nL[iik];
      }  
    }else{
      for(i=0; i < nSD; i++){
	j	=i+ik;
	memcpy(lr,lr1,nL[j]*sizeof(double));
	memcpy(lz,lz1,nL[j]*sizeof(double));
	memcpy(lrq,lrq1,nL[j]*sizeof(double));
	memcpy(lzq,lzq1,nL[j]*sizeof(double));
	lr  +=nL[j];
	lz  +=nL[j];
	lrq +=nL[j];
	lzq +=nL[j];
	lr1 +=nL[j];
	lz1 +=nL[j];
	lrq1+=nL[j];
	lzq1+=nL[j];
	ln[i]=nL[j];
      }
    }
    lr	=srSoL+nSl;
    lz	=szSoL+nSl;
    lrq	=srqSoL+nSl;
    lzq	=szqSoL+nSl;
    for(i=0; i < nSD; i++){
      m1	=ln[i];
      m	=m1-1;
      L[0]	=0.;
      for(j=1; j < m1; j++){
	dr	=lr[j]-lr[j-1];
	dz	=lz[j]-lz[j-1];
	s	=sqrt(dr*dr+dz*dz);
	L[j]	=L[j-1]+s;
      }
      lsL[i]	=L[m];
      spl1(lr,lrq,r2q,NULL,NULL,L,m);
      spl1(lz,lzq,r2q,NULL,NULL,L,m);
      lr	+=m1;
      lz	+=m1;
      lrq	+=m1;
      lzq	+=m1;
    }
  }

  nBase[0]	=0;
  k	=6;
  nn	=nSS;
  lr1	=ESRsep+kSbr[k-1]+nn;
  lz1	=ESZsep+kSbr[k-1]+nn;
  lr	=rBase;
  lz	=zBase;
  for(j=0; j < nn; j++){
    *(lr++)	=*(lr1--);
    *(lz++)	=*(lz1--);
    nBase[0]++;
  }
  lr1	=RBL[nBL];
  lz1	=ZBL[nBL];
  for(j=0; j < jXSep+1;j++){
    *(lr++)	=lr1[j];
    *(lz++)	=lz1[j];
    nBase[0]++;
  }
  k	=1;
  lr1	=ESRsep+kSbr[k-1];
  lz1	=ESZsep+kSbr[k-1];
  for(j=0; j < nn; j++){
    *(lr++)	=lr1[j+1];
    *(lz++)	=lz1[j+1];
    nBase[0]++;
  }

  nBase[1]	=0;
  k	=1;
  lr1	=ESRsep+kSbr[k-1]+nSS;
  lz1	=ESZsep+kSbr[k-1]+nSS;
  for(j=0; j < nSS; j++){
    *(lr++)	=*(lr1--);
    *(lz++)	=*(lz1--);
    nBase[1]++;
  }
  k	=3;
  lr1	=ESRsep+kSbr[k-1];
  lz1	=ESZsep+kSbr[k-1]; 
  for(j=0; j < nSS+1; j++){
    *(lr++)	=lr1[j];
    *(lz++)	=lz1[j];
    nBase[1]++;
  }

  nBase[2]	=0;
  k	=3;
  lr1	=ESRsep+kSbr[k-1]+nn;
  lz1	=ESZsep+kSbr[k-1]+nn;
  for(j=0; j < nn; j++){
    *(lr++)	=*(lr1--);
    *(lz++)	=*(lz1--);
    nBase[2]++;
  }
  lr1	=RBL[nBL];
  lz1	=ZBL[nBL];
  for(j=jXSep; j < Np;j++){
    *(lr++)	=lr1[j];
    *(lz++)	=lz1[j];
    nBase[2]++;
  }
  k	=4;
  lr1	=ESRsep+kSbr[k-1];
  lz1	=ESZsep+kSbr[k-1];
  for(j=0; j < nn+1; j++){
    *(lr++)	=lr1[j];
    *(lz++)	=lz1[j];
    nBase[2]++;
  }

  nBase[3]=0;
  k	=4;
  lr1	=ESRsep+kSbr[k-1]+nn;
  lz1	=ESZsep+kSbr[k-1]+nn;
  for(j=0; j < nn; j++){
    *(lr++)	=*(lr1--);
    *(lz++)	=*(lz1--);
    nBase[3]++;
  }
  k	=6;
  lr1	=ESRsep+kSbr[k-1];
  lz1	=ESZsep+kSbr[k-1];
  for(j=0; j < nn+1; j++){
    *(lr++)	=lr1[j];
    *(lz++)	=lz1[j];
    nBase[3]++;
  }

  lrS	=rSoL;
  lzS	=zSoL;
  lrqS	=rqSoL;
  lzqS	=zqSoL;
  lrB	=rBase;
  lzB	=zBase;
  for(k=0; k < nRg; k++){
    ik	=k*nSD;
    jk	=ik+nSD;
    ln	=nOln+ik;
    lsL	=sL+ik;
    nn	=N[k]-ln[nsm1];
    m1	=ln[nsm1];
    m	=m1-1;
    nSl	=kSln[ik-1];
    lr	=srSoL+nSl+nn;
    lz	=szSoL+nSl+nn;
    lrq	=srqSoL+nSl+nn;
    lzq	=szqSoL+nSl+nn;
    lr1	=lrS+nBase[k]*nSD;
    lz1	=lzS+nBase[k]*nSD;
    lrq1=lrqS+nBase[k]*nSD;
    lzq1=lzqS+nBase[k]*nSD;
    dr	=lr[1]-lr[0];
    dz	=lz[1]-lz[0];
    ds	=0.5*sqrt(dr*dr+dz*dz);
    SetXHermit(lsL[nsm1],m);

    uu[0]	=0.;
    uu[1]	=ds;
    for(j=0; j < nBase[k];j++){
      rX	=lrB[j];
      zX	=lzB[j];
      kk	=0;
      do{
	zero(&kk,uu,vv,&s,err);
	SetInterval(s);
	XHermit(&r,&rq,lr,lrq);
	XHermit(&z,&zq,lz,lzq);
	dr=rX-r;
	dz=zX-z;
	err	=dr*rq+dz*zq;
      }while(kk < 16 && fabs(err) > 1e-9);
      if(kk==15) printf("&&&&Down:j=%d kk=%d err=%10.3e s=%10.3e\n",j,kk,err,s);
      uu[0]	=s;
      uu[1]	=s+ds;
      lr1[j]	=r;
      lz1[j]	=z;
    }
    lr1	=lrS;
    lz1	=lzS;
    lrq1=lrqS;
    lzq1=lzqS;
    memcpy(lr1,lrB,nBase[k]*sizeof(double));
    memcpy(lz1,lzB,nBase[k]*sizeof(double));
    lr1	+=nBase[k];
    lz1	+=nBase[k];
    lrq1+=nBase[k];
    lzq1+=nBase[k];

    lx	=lrS+nBase[k]*nSD;
    ly	=lzS+nBase[k]*nSD;
    lr	=srSoL+nSl;
    lz	=szSoL+nSl;
    lrq	=srqSoL+nSl;
    lzq	=szqSoL+nSl;
    for(i=0; i < nsm1; i++){
      m1	=ln[i];
      m	=m1-1;
      SetXHermit(lsL[i],m);
      uu[0]	=0.;
      uu[1]	=ds;
      for(j=0; j < nBase[k];j++){
	rX	=lzB[j]-ly[j];
	zX	=lx[j]-lrB[j];
	kk	=0;
	do{
	  zero(&kk,uu,vv,&s,err);
	  SetInterval(s);
	  XHermit(&r,&rq,lr,lrq);
	  XHermit(&z,&zq,lz,lzq);
	  dr=lrB[j]-r;
	  dz=lzB[j]-z;
	  err	=dr*rX+dz*zX;
	}while(kk < 16 && fabs(err) > 1e-9);
	if(kk==15) printf("&&&&Up:j=%d kk=%d err=%10.3e s=%10.3e\n",j,kk,err,s);
	uu[0]	=s;
	uu[1]	=s+ds;
	lr1[j]	=r;
	lz1[j]	=z;
      }
      lr1+=nBase[k];
      lz1+=nBase[k];
      lrq1+=nBase[k];
      lzq1+=nBase[k];
      lr+=ln[i];
      lz+=ln[i];
      lrq+=ln[i];
      lzq+=ln[i];
    }

#ifdef H
    lr	=lrS;
    lz	=lzS;
    for(i=0; i < ns1; i++){
      ZPlotPolyLine(lr,lz,nBase[k]);
      lr+=nBase[k];
      lz+=nBase[k];
    }
#endif
    lr	=lrS;
    lz	=lzS;
    for(j=0; j < nBase[k];j++){
      for(i=0; i < ns1; i++){
	kk	=i*nBase[k]+j;
	rP[i]	=lr[kk];
	zP[i]	=lz[kk];
      }
      ZPlotPolyLine(rP,zP,ns1);
    }
    lrS	+=nBase[k]*ns1;
    lzS	+=nBase[k]*ns1;
    lrqS+=nBase[k]*ns1;
    lzqS+=nBase[k]*ns1;
    lrB	+=nBase[k];
    lzB	+=nBase[k];
  }

  for(k=0; k < nRg; k++){
    ik	=k*nSD;
    nSl	=kSln[ik-1];
    lr	=srSoL+nSl;
    lz	=szSoL+nSl;
    ln	=nOln+ik;
    for(i=0; i < nSD; i++){
      ZPlotPolyLine(lr,lz,ln[i]);
      lr+=ln[i];
      lz+=ln[i];
    }
  }

  /*Derivatives*/
  aX		=1.;
  aVac[0]	=1.4;
  aVac[1]	=1.4;
  aVac[2]	=1.4;
  aVac[3]	=1.4;
  na	=nSD;
  na1	=na+1;
  for(i=0; i < 4; i++){
    ERNa[i]	=nSD;
    ERNa1[i]	=nSD+1;
  }

  nq1	=nBase[0];
  nq	=nq1-1;
  lgq	=gqVac;
  lr	=rSoL;
  lz	=zSoL;
  L[0]	=0.;
  for(j=1; j < nq1; j++){
    dr	=lr[j]-lr[j-1];
    dz	=lz[j]-lz[j-1];
    s	=sqrt(dr*dr+dz*dz);
    L[j]	=L[j-1]+s;
  }
  k	=nq-nSS;
  gq0	=-cgp*L[nSS]/(L[k]-L[nSS]);
  gq1	=cgp+cgp*(L[nq]-L[k])/(L[k]-L[nSS]);

  dq	=-gq0/nSS;
  for(j=0; j < nSS; j++){
    *(lgq++)	=gq0+j*dq;
  }
  k	=nq1-2*nSS;
  dq	=cgp/(k-1);
  for(j=0; j < k; j++){
    *(lgq++)	=j*dq;
  }
  dq	=(gq1-cgp)/nSS;
  for(j=1; j < nSS+1; j++){
    *(lgq++)	=cgp+j*dq;
  }

  nq1	=nBase[2];
  nq	=nq1-1;
  lr	=rSoL+nBase[0]+nBase[1];
  lz	=zSoL+nBase[0]+nBase[1];
  L[0]	=0.;
  for(j=1; j < nq1; j++){
    dr	=lr[j]-lr[j-1];
    dz	=lz[j]-lz[j-1];
    s	=sqrt(dr*dr+dz*dz);
    L[j]	=L[j-1]+s;
  }
  k	=nq-nSS;
  gq2	=cgp-cgp*L[nSS]/(L[k]-L[nSS]);
  gq3	=c2gp+cgp*(L[nq]-L[k])/(L[k]-L[nSS]);
  dq	=(gq1-cgp)/nSS;
  for(j=0; j < nSS; j++){
    *(lgq++)	=gq1-j*dq;
  }
  dq	=(gq2-cgp)/nSS;
  for(j=0; j < nSS+1; j++){
    *(lgq++)	=cgp+j*dq;
  }

  for(j=0; j < nSS; j++){
    *(lgq++)	=gq2-j*dq;
  }
  k	=nq1-2*nSS;
  dq	=cgp/(k-1);
  for(j=0; j < k; j++){
    *(lgq++)	=cgp+j*dq;
  }
  dq	=(gq3-c2gp)/nSS;
  for(j=1; j < nSS+1; j++){
    *(lgq++)	=c2gp+j*dq;
  }

  dq	=(gq3-c2gp)/nSS;
  for(j=0; j < nSS; j++){
    *(lgq++)	=gq3-j*dq-c2gp;
  }
  dq	=gq0/nSS;
  for(j=0; j < nSS+1; j++){
    *(lgq++)	=j*dq;
  }


  lr	=rSoL;
  lz	=zSoL;
  lra	=raSoL;
  lza	=zaSoL;
  lsa	=saVac;
  for(k=0; k < nRg; k++){
    nq1	=nBase[k];
    nq	=nq1-1;
    da	=(aVac[k]-aX)/na;
    for(i=0; i < na1; i++){
      lsa[i]	=aX+i*da;
    }
    for(j=0; j < nq1; j++){
      for(i=0; i < na1; i++){
	kk	=i*nq1+j;
	dr	=lr[kk]-lr[j];
	dz	=lz[kk]-lz[j];
	L[i]	=sqrt(dr*dr+dz*dz);
      }
      spl1(L,La,r2q,NULL,NULL,lsa,na);
        nr	=dr;
      nz	=dz;
      s	=1./sqrt(nr*nr+nz*nz);
      nr	*=s;
      nz	*=s;

      for(i=0; i < na1; i++){
	kk	=i*nq1+j;
	lra[kk]	=nr*La[i];
	lza[kk]	=nz*La[i];
      }
    }
    lsa	+=na1;
    lr	+=nq1*na1;
    lz	+=nq1*na1;
    lra	+=nq1*na1;
    lza	+=nq1*na1;
  }

  lr	=rSoL;
  lz	=zSoL;
  lra	=raSoL;
  lza	=zaSoL;
  lrq	=rqSoL;
  lzq	=zqSoL;
  lraq	=raqSoL;
  lzaq	=zaqSoL;
  lgq	=gqVac;
  for(k=0; k < nRg; k++){
    nq1	=nBase[k];
    nq	=nq1-1;
    for(i=0; i < na1; i++){
      spl1(lr,lrq,r2q,NULL,NULL,lgq,nq);
      spl1(lz,lzq,r2q,NULL,NULL,lgq,nq);
      spl1(lra,lraq,r2q,NULL,NULL,lgq,nq);
      spl1(lza,lzaq,r2q,NULL,NULL,lgq,nq);
      lr+=nq1 ;
      lz+=nq1 ;
      lra+=nq1;
      lza+=nq1;
      lrq+=nq1;
      lzq+=nq1;
      lraq+=nq1;
      lzaq+=nq1;
    }
    lgq	+=nq1;
  }
  return(0);
}

int VgridYdYd2Yd3Y(double *gY
		,double *gYr,double *gYz
		,double *gYrr,double *gYrz,double *gYzz
		,double *gYrrz,double *gYrzz
		  ,double r, double z)
{
  double Y,Yr,Yz,Yrr,Yrz,Yzz,Yrrz,Yrzz;

  PFCgYdYd2Yd3Y(gY,gYr,gYz,gYrr,gYrz,gYzz,gYrrz,gYrzz,r,z);
  gYdYd2Yd3YWnd(&Y,&Yr,&Yz,&Yrr,&Yrz,&Yzz,&Yrrz,&Yrzz
		,r,z,EGwRp,EGwZp,EGwIp,EGwNp);
  *gY		+=Y   ;
  *gYr		+=Yr  ;
  *gYz		+=Yz  ;
  *gYrr		+=Yrr ;
  *gYrz		+=Yrz ;
  *gYzz		+=Yzz ;
  *gYrrz	+=Yrrz;
  *gYrzz	+=Yrzz;
  return(0);
}
#endif
