#include <stdio.h>
#include <string.h>
#include <math.h>

extern int n0CHI,n1CHI;
extern double *CHIr0,*CHIz0,*CHIr1,*CHIz1;

static double df,fmn,fmx;

int SetRectContourPlot(double **f,int nx1,int ny1)
{
  int i,j;
  double *ld;

  fmn	=1e+20;
  fmx	=-fmn;
  for(i=0; i < ny1; i++){
    ld	=f[i];
    for(j=0; j < nx1; j++){
      if(fmn > *ld){
	fmn	=*ld;
      }
      if(fmx < *ld){
	fmx	=*ld;
      }
      ld++;
    }
  }
  return(0);
}

int PutRectContourPlot(double f0,double f1)
{
  fmn	=f0;
  fmx	=f1;
  return(0);
}

int RectGridContourPlot(double **f, double Bx[2], double By[2]
			,int nx1,int ny1,int Nlines)
{
  int i,ii,j,jj,is,n,m;
  int it,iit,jt,jjt;
  int k,k0,k1,k2,kt,ks;
  char iA[4*nx1*ny1];
  double dx,dy,x,y,X[3],Y[3],g[3],s;
  double F,f0,f1,f2,x0,y0;
  int Np=64;
  double xp[64],yp[64];

  if(Nlines == 0){
    return(0);
  }
  df	=Nlines > 1 ? (fmx-fmn)/(Nlines-1) : fmx-fmn;

  dx	=(Bx[1]-Bx[0])/(nx1-1);
  dy	=(By[1]-By[0])/(ny1-1);

  ZColor(4);
  F	=fmn;
  for(n=0; n < Nlines; n++){
    memset((void*)iA,0,4*nx1*ny1);
    for(i=0,ii=1; ii < ny1; i++,ii++){
      for(j=0,jj=1; jj < nx1; j++,jj++){
	for(is=0; is < 4; is++){
	  switch(is){
	  case 0:
	    f2	=f[i][jj];
	    f1	=f[i][j];
	    xp[0]	=Bx[0]+dx*j;
	    yp[0]	=By[0]+dy*i;
	    break;
	  case 1:
	    f2	=f[ii][jj];
	    f1	=f[i][jj];
	    break;
	  case 2:
	    f2	=f[ii][j];
	    f1	=f[ii][jj];
	    break;
	  case 3:
	    f2	=f[i][j];
	    f1	=f[ii][j];
	    break;
	  }
	  k	=4*(nx1*i+j)+is;
	  if(iA[k] == '\0' && ((f1 < F && f2 >= F) || (f1 > F && f2 <= F))){
	    m	=0;
	    xp[m]	=Bx[0]+dx*j;
	    yp[m]	=By[0]+dy*i;
	    switch(is){
	    case 0:
	      xp[m]	+=(F-f1)*dx/(f2-f1);
	      break;
	    case 1:
	      xp[m]	+=dx;
	      yp[m]	+=(F-f1)*dy/(f2-f1);
	      break;
	    case 2:
	      xp[m]	+=(F-f2)*dx/(f1-f2);
	      yp[m]	+=dy;
	      break;
	    case 3:
	      yp[m]	+=(F-f2)*dy/(f1-f2);
	      break;
	    }
	    m++;
	    kt	=is;
	    ks	=is;
	    it	=i;
	    iit	=ii;
	    jt	=j;
	    jjt	=jj;
	    while(iit > 0 && iit < ny1 && jjt > 0 && jjt < nx1){
	      f0	=0.25*(f[it][jt]+f[iit][jt]+f[it][jjt]+f[iit][jjt]);
	      x0	=Bx[0]+dx*(jt+0.5);
	      y0	=By[0]+dy*(it+0.5);
	      X[0]	=x0;
	      Y[0]	=y0;
	      g[0]	=f0;
	      k		=4*(nx1*it+jt)+kt;
	      if(iA[k] != '\0'){
		break;
	      }
	      iA[k]	='a';
	      switch(kt){
	      case 0:
		X[1]	=x0-0.5*dx;
		Y[1]	=y0-0.5*dy;
		g[1]	=f[it][jt];
		X[2]	=X[1]+dx;
		Y[2]	=Y[1];
		g[2]	=f[it][jjt];
		switch(ks){
		case 0:
		  k0	=0;
		  k1	=1;
		  k2	=2;
		  if((g[k0] < F && g[k1] >= F) || (g[k0] > F && g[k1] <= F)){
		    kt	=3;
		    ks	=4;
		    k	=k1;
		  }
		  else{
		    kt	=1;
		    ks	=5;
		    k	=k2;
		  }
		  break;
		case 4:
		  k0	=2;
		  k1	=1;
		  k2	=0;
		  if((g[k0] < F && g[k1] >= F) || (g[k0] > F && g[k1] <= F)){
		    kt	=2;
		    ks	=2;
		    it--;
		    iit--;
		    k	=k1;
		  }
		  else{
		    kt	=1;
		    ks	=5;
		    k	=k2;
		  }
		  break;
		case 5:
		  k0	=1;
		  k1	=0;
		  k2	=2;
		  if((g[k0] < F && g[k1] >= F) || (g[k0] > F && g[k1] <= F)){
		    kt	=3;
		    ks	=4;
		    k	=k1;
		  }
		  else{
		    kt	=2;
		    ks	=2;
		    it--;
		    iit--;
		    k	=k2;
		  }
		  break;
		}
		break;
	      case 1:
		X[1]	=x0+0.5*dx;
		Y[1]	=y0-0.5*dy;
		g[1]	=f[it][jjt];
		X[2]	=X[1];
		Y[2]	=Y[1]+dy;
		g[2]	=f[iit][jjt];
		switch(ks){
		case 1:
		  k0	=0;
		  k1	=1;
		  k2	=2;
		  if((g[k0] < F && g[k1] >= F) || (g[k0] > F && g[k1] <= F)){
		    kt	=0;
		    ks	=5;
		    k	=k1;
		  }
		  else{
		    kt	=2;
		    ks	=6;
		    k	=k2;
		  }
		  break;
		case 5:
		  k0	=2;
		  k1	=1;
		  k2	=0;
		  if((g[k0] < F && g[k1] >= F) || (g[k0] > F && g[k1] <= F)){
		    kt	=3;
		    ks	=3;
		    jt++;
		    jjt++;
		    k	=k1;
		  }
		  else{
		    kt	=2;
		    ks	=6;
		    k	=k2;
		  }
		  break;
		case 6:
		  k0	=1;
		  k1	=0;
		  k2	=2;
		  if((g[k0] < F && g[k1] >= F) || (g[k0] > F && g[k1] <= F)){
		    kt	=0;
		    ks	=5;
		    k	=k1;
		  }
		  else{
		    kt	=3;
		    ks	=3;
		    jt++;
		    jjt++;
		    k	=k2;
		  }
		  break;
		}
		break;
	      case 2:
		X[1]	=x0+0.5*dx;
		Y[1]	=y0+0.5*dy;
		g[1]	=f[iit][jjt];
		X[2]	=X[1]-dx;
		Y[2]	=Y[1];
		g[2]	=f[iit][jt];
		switch(ks){
		case 2:
		  k0	=0;
		  k1	=1;
		  k2	=2;
		  if((g[k0] < F && g[k1] >= F) || (g[k0] > F && g[k1] <= F)){
		    kt	=1;
		    ks	=6;
		    k	=k1;
		  }
		  else{
		    kt	=3;
		    ks	=7;
		    k	=k2;
		  }
		  break;
		case 6:
		  k0	=2;
		  k1	=1;
		  k2	=0;
		  if((g[k0] < F && g[k1] >= F) || (g[k0] > F && g[k1] <= F)){
		    kt	=0;
		    ks	=0;
		    it++;
		    iit++;
		    k	=k1;
		  }
		  else{
		    kt	=3;
		    ks	=7;
		    k	=k2;
		  }
		  break;
		case 7:
		  k0	=1;
		  k1	=0;
		  k2	=2;
		  if((g[k0] < F && g[k1] >= F) || (g[k0] > F && g[k1] <= F)){
		    kt	=1;
		    ks	=6;
		    k	=k1;
		  }
		  else{
		    kt	=0;
		    ks	=0;
		    it++;
		    iit++;
		    k	=k2;
		  }
		  break;
		}
		break;
	      case 3:
		X[1]	=x0-0.5*dx;
		Y[1]	=y0+0.5*dy;
		g[1]	=f[iit][jt];
		X[2]	=X[1];
		Y[2]	=Y[1]-dy;
		g[2]	=f[it][jt];
		switch(ks){
		case 3:
		  k0	=0;
		  k1	=1;
		  k2	=2;
		  if((g[k0] < F && g[k1] >= F) || (g[k0] > F && g[k1] <= F)){
		    kt	=2;
		    ks	=7;
		    k	=k1;
		  }
		  else{
		    kt	=0;
		    ks	=4;
		    k	=k2;
		  }
		  break;
		case 7:
		  k0	=2;
		  k1	=1;
		  k2	=0;
		  if((g[k0] < F && g[k1] >= F) || (g[k0] > F && g[k1] <= F)){
		    kt	=1;
		    ks	=1;
		    jt--;
		    jjt--;
		    k	=k1;
		  }
		  else{
		    kt	=0;
		    ks	=4;
		    k	=k2;
		  }
		  break;
		case 4:
		  k0	=1;
		  k1	=0;
		  k2	=2;
		  if((g[k0] < F && g[k1] >= F) || (g[k0] > F && g[k1] <= F)){
		    kt	=2;
		    ks	=7;
		    k	=k1;
		  }
		  else{
		    kt	=1;
		    ks	=1;
		    jt--;
		    jjt--;
		    k	=k2;
		  }
		  break;
		}
		break;
	      }
	      s	=(F-g[k0])/(g[k]-g[k0]);
	      yp[m]	=Y[k0]+s*(Y[k]-Y[k0]);
	      xp[m]	=X[k0]+s*(X[k]-X[k0]);
	      m++;
	      if(m >= Np){
		ZPlotPolyLine(xp,yp,m);
		xp[0]	=xp[m-1];
		yp[0]	=yp[m-1];
		m	=1;
	      }
	    } /* end of while loop */
	    if(m > 1){
	      ZPlotPolyLine(xp,yp,m);
	      m	=0;
	    }
	  }
	}
      }
    }
    F	+=df;
  }
  return(0);
}

int RectGridRayPlot(double **f, double Bx[2], double By[2]
			,int nx1,int ny1,int Nlines)
{
  int i0,iSt;
  int i,ii,j,jj,is,n,m;
  int k,k0,k1,k2,kt,ks;
  double dx,dy,x,y,X[3],Y[3],g[3],G[4],s;
  double F,Fx,Fy,f0,f1,f2,x0,y0,x1,y1,x2,y2;
  int Np=64;
  double xp[64],yp[64];
  double L,dL,tx,ty,t;

  L	=0;
  x	=CHIr0[0];
  y	=CHIz0[0];
  for(i=1; i < n0CHI; i++){
    tx	=CHIr0[i]-x;
    ty	=CHIz0[i]-y;
    L	+=sqrt(tx*tx+ty*ty);
    x	=CHIr0[i];
    y	=CHIz0[i];
  }
  dL	=L/(Nlines-1);

  dx	=(Bx[1]-Bx[0])/(nx1-1);
  dy	=(By[1]-By[0])/(ny1-1);

  ZColor(4);

  x	=CHIr0[0];
  y	=CHIz0[0];
  i0	=1;
  L	=0;
  for(n=0; n < Nlines; n++){
    /* next start point */
    tx	=CHIr0[i0]-x;
    ty	=CHIz0[i0]-y;
    t	=sqrt(tx*tx+ty*ty);
    while(t < n*dL-L && i0 < n0CHI){
      L	+=t;
      x	=CHIr0[i0];
      y	=CHIz0[i0];
      i0++;
      tx=CHIr0[i0]-x;
      ty=CHIz0[i0]-y;
      t	=sqrt(tx*tx+ty*ty);
    }
    t	=(n*dL-L)/t;
    x	+=tx*t;
    y	+=ty*t;
    xp[0]	=x;
    yp[0]	=y;
    m		=1;
    jj	=(x-Bx[0])/dx+1;
    ii	=(y-By[0])/dy+1;
    i	=ii-1;
    j	=jj-1;
    if(i < 0){
      if(j < 0){
	G[0]	=f[0][0]-0.5*f[1][1];
	G[3]	=ii < ny1 ? f[ii][0]-0.5*f[ii][1] :f[ny1-1][0]-0.5*f[ny1-2][1];
      }
      else{
	G[0]	=f[0][j]-0.5*f[1][j];
	G[3]	=ii < ny1 ? f[ii][j] : f[ny1-1][j]-0.5*f[ny1-2][j];
      }
      G[1]	=jj < nx1 ? f[0][jj]-0.5*f[1][jj] :f[0][nx1-1]-0.5*f[1][nx1-2];
    }
    else{
      if(j < 0){
	G[0]	=f[i][0]-0.5*f[i][1];
	G[3]	=ii < ny1 ? f[ii][0]-0.5*f[ii][1] :f[ny1-1][0]-0.5*f[ny1-2][1];
      }
      else{
	G[0]	=f[i][j];
	G[3]	=ii < ny1 ? f[ii][j] : f[ny1-1][j]-0.5*f[ny1-2][j];
      } 
      G[1]	=jj < nx1 ? f[i][jj] : f[i][nx1-1]-0.5*f[i][nx1-2];
    }
    if(ii < ny1){
      if(jj < nx1){
	G[2]	=f[ii][jj];
      }
      else{
	G[2]	=f[ii][nx1-1]-0.5*f[ii][nx1-2];
      }
    }
    else{
      if(jj < nx1){
	G[2]	=f[ny1-1][jj]-0.5*f[ny1-2][jj];
      }
      else{
	G[2]	=f[ny1-1][nx1-1]-0.5*f[ny1-2][nx1-2];
      }
    }

    f0	=0.25*(G[0]+G[1]+G[2]+G[3]);
    x0	=Bx[0]+dx*(j+0.5);
    y0	=By[0]+dy*(i+0.5);
    if((x-x0)/dx > fabs(y-y0)/dy){
      kt	=1;
      f2	=G[2];
      f1	=G[1];
      x1	=Bx[0]+dx*jj;
      y1	=By[0]+dy*i;
      x2	=x1;
      y2	=y1+dy;
      Fx	=(f1+f2-2.*f0)/dx;
      Fy	=(f2-f1)/dy;
      F		=f0+Fx*(x-x0)+Fy*(y-y0);
      ks 	=-1;
      if(f0 <= F && F < f1){
	s	=f0 != f1 ? (F-f0)/(f0-f1) : 0.;
	xp[m]	=x0+s*(x0-x1);
	yp[m]	=y0+s*(y0-y1);
	if((xp[m]-x)*ty-(yp[m]-y)*tx > 0.){
	  ks	=5;
	}
      }
      if(ks < 0 && f1 <= F && F < f2){
	s	=f1 != f2 ? (F-f1)/(f1-f2) : 0.;
	xp[m]	=x1+s*(x1-x2);
	yp[m]	=y1+s*(y1-y2);
	if((xp[m]-x)*ty-(yp[m]-y)*tx > 0.){
	  ks	=1;
	  j++;
	  jj++;
	}
      }
      if(ks < 0 && f2 <= F && F < f0){
	s	=f2 != f0 ? (F-f2)/(f2-f0) : 0.;
	xp[m]	=x2+s*(x2-x0);
	yp[m]	=y2+s*(y2-y0);
	if((xp[m]-x)*ty-(yp[m]-y)*tx > 0.){
	  ks	=6;
	}
      }
    }
    else if((x-x0)/dx < -fabs(y-y0)/dy){
      kt	=3;
      f1	=G[3];
      f2	=G[0];
      x1	=Bx[0]+dx*j;
      y1	=By[0]+dy*ii;
      x2	=x1;
      y2	=y1-dy;
      Fx	=(2.*f0-f1-f2)/dx;
      Fy	=(f1-f2)/dy;
      F		=f0+Fx*(x-x0)+Fy*(y-y0);
      ks 	=-1;
      if(f0 <= F && F < f1){
	s	=f0 != f1 ? (F-f0)/(f0-f1) : 0.;
	xp[m]	=x0+s*(x0-x1);
	yp[m]	=y0+s*(y0-y1);
	if((xp[m]-x)*ty-(yp[m]-y)*tx > 0.){
	  ks	=7;
	}
      }
      if(ks < 0 && f1 <= F && F < f2){
	s	=f1 != f2 ? (F-f1)/(f1-f2) : 0.;
	xp[m]	=x1+s*(x1-x2);
	yp[m]	=y1+s*(y1-y2);
	if((xp[m]-x)*ty-(yp[m]-y)*tx > 0.){
	  ks	=3;
	  j--;
	  jj--;
	}
      }
      if(ks < 0 && f2 <= F && F < f0){
	s	=f2 != f0 ? (F-f2)/(f2-f0) : 0.;
	xp[m]	=x2+s*(x2-x0);
	yp[m]	=y2+s*(y2-y0);
	if((xp[m]-x)*ty-(yp[m]-y)*tx > 0.){
	  ks	=4;
	}
      }
    }
    else if(y > y0){
      kt	=2;
      f2	=G[3];
      f1	=G[2];
      x1	=Bx[0]+dx*jj;
      y1	=By[0]+dy*ii;
      x2	=x1-dx;
      y2	=y1;
      Fx	=(f1-f2)/dx;
      Fy	=(f2+f1-2.*f0)/dy;
      F		=f0+Fx*(x-x0)+Fy*(y-y0);
      ks 	=-1;
      if(f0 <= F && F < f1){
	s	=f0 != f1 ? (F-f0)/(f0-f1) : 0.;
	xp[m]	=x0+s*(x0-x1);
	yp[m]	=y0+s*(y0-y1);
	if((xp[m]-x)*ty-(yp[m]-y)*tx > 0.){
	  ks	=6;
	}
      }
      if(ks < 0 && f1 <= F && F < f2){
	s	=f1 != f2 ? (F-f1)/(f1-f2) : 0.;
	xp[m]	=x1+s*(x1-x2);
	yp[m]	=y1+s*(y1-y2);
	if((xp[m]-x)*ty-(yp[m]-y)*tx > 0.){
	  ks	=2;
	  i++;
	  ii++;
	}
      }
      if(ks < 0 && f2 <= F && F < f0){
	s	=f2 != f0 ? (F-f2)/(f2-f0) : 0.;
	xp[m]	=x2+s*(x2-x0);
	yp[m]	=y2+s*(y2-y0);
	if((xp[m]-x)*ty-(yp[m]-y)*tx > 0.){
	  ks	=7;
	}
      }
    }
    else{
      kt	=0;
      f2	=G[1];
      f1	=G[0];
      x1	=Bx[0]+dx*j;
      y1	=By[0]+dy*i;
      x2	=x1+dx;
      y2	=y1;
      Fx	=(f2-f1)/dx;
      Fy	=(2.*f0-f2-f1)/dy;
      F		=f0+Fx*(x-x0)+Fy*(y-y0);
      ks 	=-1;
      if(f0 <= F && F < f1){
	s	=f0 != f1 ? (F-f0)/(f0-f1) : 0.;
	xp[m]	=x0+s*(x0-x1);
	yp[m]	=y0+s*(y0-y1);
	if((xp[m]-x)*ty-(yp[m]-y)*tx > 0.){
	  ks	=4;
	}
      }
      if(ks < 0 && f1 <= F && F < f2){
	s	=f1 != f2 ? (F-f1)/(f1-f2) : 0.;
	xp[m]	=x1+s*(x1-x2);
	yp[m]	=y1+s*(y1-y2);
	if((xp[m]-x)*ty-(yp[m]-y)*tx > 0.){
	  ks	=0;
	  i--;
	  ii--;
	}
      }
      if(ks < 0 && f2 <= F && F < f0){
	s	=f2 != f0 ? (F-f2)/(f2-f0) : 0.;
	xp[m]	=x2+s*(x2-x0);
	yp[m]	=y2+s*(y2-y0);
	if((xp[m]-x)*ty-(yp[m]-y)*tx > 0.){
	  ks	=5;
	}
      }
    }
    m++;
    iSt	=1;
    while(iSt || (ii > 0 && ii < ny1 && jj > 0 && jj < nx1)){
      f0	=0.25*(G[0]+G[3]+G[1]+G[2]);
      x0	=Bx[0]+dx*(j+0.5);
      y0	=By[0]+dy*(i+0.5);
      X[0]	=x0;
      Y[0]	=y0;
      g[0]	=f0;
      out("siiII","kt",i,j,kt,ks);
      switch(kt){
      case 0:
	X[1]	=x0-0.5*dx;
	Y[1]	=y0-0.5*dy;
	g[1]	=G[0];
	X[2]	=X[1]+dx;
	Y[2]	=Y[1];
	g[2]	=G[1];
	switch(ks){
	case 0:
	  k0	=0;
	  k1	=1;
	  k2	=2;
	  if((g[k0] < F && g[k1] >= F) || (g[k0] > F && g[k1] <= F)){
	    kt	=3;
	    ks	=4;
	    k	=k1;
	  }
	  else{
	    kt	=1;
	    ks	=5;
	    k	=k2;
	  }
	  break;
	case 4:
	  k0	=2;
	  k1	=1;
	  k2	=0;
	  if((g[k0] < F && g[k1] >= F) || (g[k0] > F && g[k1] <= F)){
	    kt	=2;
	    ks	=2;
	    i--;
	    ii--;
	    G[0]	=f[i][j];
	    G[1]	=f[i][jj];
	    G[2]	=f[ii][jj];
	    G[3]	=f[ii][j];
	    iSt	=0;
	    k	=k1;
	  }
	  else{
	    kt	=1;
	    ks	=5;
	    k	=k2;
	  }
	  break;
	case 5:
	  k0	=1;
	  k1	=0;
	  k2	=2;
	  if((g[k0] < F && g[k1] >= F) || (g[k0] > F && g[k1] <= F)){
	    kt	=3;
	    ks	=4;
	    k	=k1;
	  }
	  else{
	    kt	=2;
	    ks	=2;
	    i--;
	    ii--;
	    G[0]	=f[i][j];
	    G[1]	=f[i][jj];
	    G[2]	=f[ii][jj];
	    G[3]	=f[ii][j];
	    iSt	=0;
	    k	=k2;
	  }
	  break;
	}
	break;
      case 1:
	X[1]	=x0+0.5*dx;
	Y[1]	=y0-0.5*dy;
	g[1]	=G[1];
	X[2]	=X[1];
	Y[2]	=Y[1]+dy;
	g[2]	=G[2];
	switch(ks){
	case 1:
	  k0	=0;
	  k1	=1;
	  k2	=2;
	  if((g[k0] < F && g[k1] >= F) || (g[k0] > F && g[k1] <= F)){
	    kt	=0;
	    ks	=5;
	    k	=k1;
	  }
	  else{
	    kt	=2;
	    ks	=6;
	    k	=k2;
	  }
	  break;
	case 5:
	  k0	=2;
	  k1	=1;
	  k2	=0;
	  if((g[k0] < F && g[k1] >= F) || (g[k0] > F && g[k1] <= F)){
	    kt	=3;
	    ks	=3;
	    j++;
	    jj++;
	    G[0]	=f[i][j];
	    G[1]	=f[i][jj];
	    G[2]	=f[ii][jj];
	    G[3]	=f[ii][j];
	    iSt	=0;
	    k	=k1;
	  }
	  else{
	    kt	=2;
	    ks	=6;
	    k	=k2;
	  }
	  break;
	case 6:
	  k0	=1;
	  k1	=0;
	  k2	=2;
	  if((g[k0] < F && g[k1] >= F) || (g[k0] > F && g[k1] <= F)){
	    kt	=0;
	    ks	=5;
	    k	=k1;
	  }
	  else{
	    kt	=3;
	    ks	=3;
	    j++;
	    jj++;
	    G[0]	=f[i][j];
	    G[1]	=f[i][jj];
	    G[2]	=f[ii][jj];
	    G[3]	=f[ii][j];
	    iSt	=0;
	    k	=k2;
	  }
	  break;
	}
	break;
      case 2:
	X[1]	=x0+0.5*dx;
	Y[1]	=y0+0.5*dy;
	g[1]	=G[2];
	X[2]	=X[1]-dx;
	Y[2]	=Y[1];
	g[2]	=G[3];
	switch(ks){
	case 2:
	  k0	=0;
	  k1	=1;
	  k2	=2;
	  if((g[k0] < F && g[k1] >= F) || (g[k0] > F && g[k1] <= F)){
	    kt	=1;
	    ks	=6;
	    k	=k1;
	  }
	  else{
	    kt	=3;
	    ks	=7;
	    k	=k2;
	  }
	  break;
	case 6:
	  k0	=2;
	  k1	=1;
	  k2	=0;
	  if((g[k0] < F && g[k1] >= F) || (g[k0] > F && g[k1] <= F)){
	    kt	=0;
	    ks	=0;
	    i++;
	    ii++;
	    G[0]	=f[i][j];
	    G[1]	=f[i][jj];
	    G[2]	=f[ii][jj];
	    G[3]	=f[ii][j];
	    iSt	=0;
	    k	=k1;
	  }
	  else{
	    kt	=3;
	    ks	=7;
	    k	=k2;
	  }
	  break;
	case 7:
	  k0	=1;
	  k1	=0;
	  k2	=2;
	  if((g[k0] < F && g[k1] >= F) || (g[k0] > F && g[k1] <= F)){
	    kt	=1;
	    ks	=6;
	    k	=k1;
	  }
	  else{
	    kt	=0;
	    ks	=0;
	    i++;
	    ii++;
	    G[0]	=f[i][j];
	    G[1]	=f[i][jj];
	    G[2]	=f[ii][jj];
	    G[3]	=f[ii][j];
	    iSt	=0;
	    k	=k2;
	  }
	  break;
	}
	break;
      case 3:
	X[1]	=x0-0.5*dx;
	Y[1]	=y0+0.5*dy;
	g[1]	=G[3];
	X[2]	=X[1];
	Y[2]	=Y[1]-dy;
	g[2]	=G[0];
	switch(ks){
	case 3:
	  k0	=0;
	  k1	=1;
	  k2	=2;
	  if((g[k0] < F && g[k1] >= F) || (g[k0] > F && g[k1] <= F)){
	    kt	=2;
	    ks	=7;
	    k	=k1;
	  }
	  else{
	    kt	=0;
	    ks	=4;
	    k	=k2;
	  }
	  break;
	case 7:
	  k0	=2;
	  k1	=1;
	  k2	=0;
	  if((g[k0] < F && g[k1] >= F) || (g[k0] > F && g[k1] <= F)){
	    kt	=1;
	    ks	=1;
	    j--;
	    jj--;
	    G[0]	=f[i][j];
	    G[1]	=f[i][jj];
	    G[2]	=f[ii][jj];
	    G[3]	=f[ii][j];
	    iSt	=0;
	    k	=k1;
	  }
	  else{
	    kt	=0;
	    ks	=4;
	    k	=k2;
	  }
	  break;
	case 4:
	  k0	=1;
	  k1	=0;
	  k2	=2;
	  if((g[k0] < F && g[k1] >= F) || (g[k0] > F && g[k1] <= F)){
	    kt	=2;
	    ks	=7;
	    k	=k1;
	  }
	  else{
	    kt	=1;
	    ks	=1;
	    j--;
	    jj--;
	    G[0]	=f[i][j];
	    G[1]	=f[i][jj];
	    G[2]	=f[ii][jj];
	    G[3]	=f[ii][j];
	    iSt	=0;
	    k	=k2;
	  }
	  break;
	}
	break;
      }
      s	=(F-g[k0])/(g[k]-g[k0]);
      yp[m]	=Y[k0]+s*(Y[k]-Y[k0]);
      xp[m]	=X[k0]+s*(X[k]-X[k0]);
      m++;
      if(m >= Np){
	ZPlotPolyLine(xp,yp,m);
	xp[0]	=xp[m-1];
	yp[0]	=yp[m-1];
	m	=1;
      }
    } /* end of while loop */
    if(m > 1){
      ZPlotPolyLine(xp,yp,m);
      m	=0;
    }
  }
  return(0);
}

int MFLineLength(double *L,double **f, double Bx[2], double By[2]
			,int nx1,int ny1)
{
  int Nlines;
  int i,ii,j,jj,is,n,m;
  int it,iit,jt,jjt;
  int k,k0,k1,k2,kt,ks;
  char iA[4*nx1*ny1];
  double dx,dy,x,y,X[3],Y[3],g[3],s;
  double F,f0,f1,f2,x0,y0;
  int Np=64;
  double xp[64],yp[64];


  Nlines=21;
  df	=(fmx-fmn)/(Nlines-1);
  dx	=(Bx[1]-Bx[0])/(nx1-1);
  dy	=(By[1]-By[0])/(ny1-1);

  F	=fmn;
  for(n=0; n < Nlines; n++){
    L[n]	=0.;
    memset((void*)iA,0,4*nx1*ny1);
    for(i=0,ii=1; ii < ny1; i++,ii++){
      for(j=0,jj=1; jj < nx1; j++,jj++){
	for(is=0; is < 4; is++){
	  switch(is){
	  case 0:
	    f2	=f[i][jj];
	    f1	=f[i][j];
	    xp[0]	=Bx[0]+dx*j;
	    yp[0]	=By[0]+dy*i;
	    break;
	  case 1:
	    f2	=f[ii][jj];
	    f1	=f[i][jj];
	    break;
	  case 2:
	    f2	=f[ii][j];
	    f1	=f[ii][jj];
	    break;
	  case 3:
	    f2	=f[i][j];
	    f1	=f[ii][j];
	    break;
	  }
	  k	=4*(nx1*i+j)+is;
	  if(iA[k] == '\0' && ((f1 < F && f2 >= F) || (f1 > F && f2 <= F))){
	    m	=0;
	    xp[m]	=Bx[0]+dx*j;
	    yp[m]	=By[0]+dy*i;
	    switch(is){
	    case 0:
	      xp[m]	+=(F-f1)*dx/(f2-f1);
	      break;
	    case 1:
	      xp[m]	+=dx;
	      yp[m]	+=(F-f1)*dy/(f2-f1);
	      break;
	    case 2:
	      xp[m]	+=(F-f2)*dx/(f1-f2);
	      yp[m]	+=dy;
	      break;
	    case 3:
	      yp[m]	+=(F-f2)*dy/(f1-f2);
	      break;
	    }
	    m++;
	    kt	=is;
	    ks	=is;
	    it	=i;
	    iit	=ii;
	    jt	=j;
	    jjt	=jj;
	    while(iit > 0 && iit < ny1 && jjt > 0 && jjt < nx1){
	      f0	=0.25*(f[it][jt]+f[iit][jt]+f[it][jjt]+f[iit][jjt]);
	      x0	=Bx[0]+dx*(jt+0.5);
	      y0	=By[0]+dy*(it+0.5);
	      X[0]	=x0;
	      Y[0]	=y0;
	      g[0]	=f0;
	      k		=4*(nx1*it+jt)+kt;
	      if(iA[k] != '\0'){
		break;
	      }
	      iA[k]	='a';
	      switch(kt){
	      case 0:
		X[1]	=x0-0.5*dx;
		Y[1]	=y0-0.5*dy;
		g[1]	=f[it][jt];
		X[2]	=X[1]+dx;
		Y[2]	=Y[1];
		g[2]	=f[it][jjt];
		switch(ks){
		case 0:
		  k0	=0;
		  k1	=1;
		  k2	=2;
		  if((g[k0] < F && g[k1] >= F) || (g[k0] > F && g[k1] <= F)){
		    kt	=3;
		    ks	=4;
		    k	=k1;
		  }
		  else{
		    kt	=1;
		    ks	=5;
		    k	=k2;
		  }
		  break;
		case 4:
		  k0	=2;
		  k1	=1;
		  k2	=0;
		  if((g[k0] < F && g[k1] >= F) || (g[k0] > F && g[k1] <= F)){
		    kt	=2;
		    ks	=2;
		    it--;
		    iit--;
		    k	=k1;
		  }
		  else{
		    kt	=1;
		    ks	=5;
		    k	=k2;
		  }
		  break;
		case 5:
		  k0	=1;
		  k1	=0;
		  k2	=2;
		  if((g[k0] < F && g[k1] >= F) || (g[k0] > F && g[k1] <= F)){
		    kt	=3;
		    ks	=4;
		    k	=k1;
		  }
		  else{
		    kt	=2;
		    ks	=2;
		    it--;
		    iit--;
		    k	=k2;
		  }
		  break;
		}
		break;
	      case 1:
		X[1]	=x0+0.5*dx;
		Y[1]	=y0-0.5*dy;
		g[1]	=f[it][jjt];
		X[2]	=X[1];
		Y[2]	=Y[1]+dy;
		g[2]	=f[iit][jjt];
		switch(ks){
		case 1:
		  k0	=0;
		  k1	=1;
		  k2	=2;
		  if((g[k0] < F && g[k1] >= F) || (g[k0] > F && g[k1] <= F)){
		    kt	=0;
		    ks	=5;
		    k	=k1;
		  }
		  else{
		    kt	=2;
		    ks	=6;
		    k	=k2;
		  }
		  break;
		case 5:
		  k0	=2;
		  k1	=1;
		  k2	=0;
		  if((g[k0] < F && g[k1] >= F) || (g[k0] > F && g[k1] <= F)){
		    kt	=3;
		    ks	=3;
		    jt++;
		    jjt++;
		    k	=k1;
		  }
		  else{
		    kt	=2;
		    ks	=6;
		    k	=k2;
		  }
		  break;
		case 6:
		  k0	=1;
		  k1	=0;
		  k2	=2;
		  if((g[k0] < F && g[k1] >= F) || (g[k0] > F && g[k1] <= F)){
		    kt	=0;
		    ks	=5;
		    k	=k1;
		  }
		  else{
		    kt	=3;
		    ks	=3;
		    jt++;
		    jjt++;
		    k	=k2;
		  }
		  break;
		}
		break;
	      case 2:
		X[1]	=x0+0.5*dx;
		Y[1]	=y0+0.5*dy;
		g[1]	=f[iit][jjt];
		X[2]	=X[1]-dx;
		Y[2]	=Y[1];
		g[2]	=f[iit][jt];
		switch(ks){
		case 2:
		  k0	=0;
		  k1	=1;
		  k2	=2;
		  if((g[k0] < F && g[k1] >= F) || (g[k0] > F && g[k1] <= F)){
		    kt	=1;
		    ks	=6;
		    k	=k1;
		  }
		  else{
		    kt	=3;
		    ks	=7;
		    k	=k2;
		  }
		  break;
		case 6:
		  k0	=2;
		  k1	=1;
		  k2	=0;
		  if((g[k0] < F && g[k1] >= F) || (g[k0] > F && g[k1] <= F)){
		    kt	=0;
		    ks	=0;
		    it++;
		    iit++;
		    k	=k1;
		  }
		  else{
		    kt	=3;
		    ks	=7;
		    k	=k2;
		  }
		  break;
		case 7:
		  k0	=1;
		  k1	=0;
		  k2	=2;
		  if((g[k0] < F && g[k1] >= F) || (g[k0] > F && g[k1] <= F)){
		    kt	=1;
		    ks	=6;
		    k	=k1;
		  }
		  else{
		    kt	=0;
		    ks	=0;
		    it++;
		    iit++;
		    k	=k2;
		  }
		  break;
		}
		break;
	      case 3:
		X[1]	=x0-0.5*dx;
		Y[1]	=y0+0.5*dy;
		g[1]	=f[iit][jt];
		X[2]	=X[1];
		Y[2]	=Y[1]-dy;
		g[2]	=f[it][jt];
		switch(ks){
		case 3:
		  k0	=0;
		  k1	=1;
		  k2	=2;
		  if((g[k0] < F && g[k1] >= F) || (g[k0] > F && g[k1] <= F)){
		    kt	=2;
		    ks	=7;
		    k	=k1;
		  }
		  else{
		    kt	=0;
		    ks	=4;
		    k	=k2;
		  }
		  break;
		case 7:
		  k0	=2;
		  k1	=1;
		  k2	=0;
		  if((g[k0] < F && g[k1] >= F) || (g[k0] > F && g[k1] <= F)){
		    kt	=1;
		    ks	=1;
		    jt--;
		    jjt--;
		    k	=k1;
		  }
		  else{
		    kt	=0;
		    ks	=4;
		    k	=k2;
		  }
		  break;
		case 4:
		  k0	=1;
		  k1	=0;
		  k2	=2;
		  if((g[k0] < F && g[k1] >= F) || (g[k0] > F && g[k1] <= F)){
		    kt	=2;
		    ks	=7;
		    k	=k1;
		  }
		  else{
		    kt	=1;
		    ks	=1;
		    jt--;
		    jjt--;
		    k	=k2;
		  }
		  break;
		}
		break;
	      }
	      s	=(F-g[k0])/(g[k]-g[k0]);
	      yp[m]	=Y[k0]+s*(Y[k]-Y[k0]);
	      xp[m]	=X[k0]+s*(X[k]-X[k0]);
	      m++;
	      if(m >= Np){
		ZPlotPolyLine(xp,yp,m);
		xp[0]	=xp[m-1];
		yp[0]	=yp[m-1];
		m	=1;
	      }
	    } /* end of while loop */
	    if(m > 1){
	      ZPlotPolyLine(xp,yp,m);
	      m	=0;
	    }
	  }
	}
      }
    }
    F	+=df;
  }
  return(0);
}

