#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "pfc.h"

extern unsigned int ESmemlevP;
extern void gYdYd2Yd3Y(double *gY
		,double *gYr,double *gYz
		,double *gYrr,double *gYrz,double *gYzz
		,double *gYrrz,double *gYzzr
		,double r,double z,double R,double Z);
extern double GPring(double r,double z,double r0,double z0);
extern void MFring(double *gp,double *Br,double *Bz
	    , double r, double z, double r0, double z0, double I);

#ifndef mzl_MLIB
extern double cr2,cr3,cr4,cr6,cr12,cgp,c2gp,cgp_4,cr2gp,cgm0,crgm0;
extern int kCol[];
extern char ShotNm[];
#endif

#ifndef mzl_ESC
extern int ESNa,ESNa1;
extern double *ESaR0,*ESaZ0;
extern double ESa0;
#endif /*PFB*/

#ifndef mzl_PFC

#ifndef stg_PlLim
extern int EGNp;
extern int *EGkA;
extern double **gYpb,*EGaRp,*EGaZp;

extern int ESnLm;
extern double*ESRLm,*ESZLm;
#endif

#ifndef stg_VacV
extern int nVVB;
extern PSBLOCK *VVB;
#endif

#ifndef stg_PSElecP
extern int nVVC;
extern PFCOIL *VVC;
extern double **gYpS;
#endif

#ifndef stg_MFProbe
extern int nMFP;
extern MFPROBE *MFP;
#endif

#ifndef stg_PFBlocks
extern int nPFB;
extern PFBLOCK *PFB;
extern double*Rb1,*Zb1,*Rb2,*Zb2;
#endif

#ifndef stg_PFCoils
extern int nPFC,nPEC;
extern PFCOIL *PFC;
extern double **gYpC,**gYiC;
#endif

#ifndef stg_PFBSplD
static SPL ****gYPFBS=NULL;
static SPL *pSgY00,*pSgY10,*pSgY01,*pSgY11;
static int NgYDSpl=0,NgYPFB=0,*NgYRSpl,*NgYZSpl;
#endif

#ifndef stg_PFBSplD
extern int NDSpl,nDSpl,iDSpl;
extern double *XDSpl1,*XDSpl2,*YDSpl1,*YDSpl2,*dXDSpl,*dYDSpl;
extern double PFwrP[]; 

static double **XSpl,**YSpl,*wSpl,*rwSpl,*hSpl,*rhSpl;
static int *FlDSpl,*NXSpl,*nXSpl,*NYSpl,*nYSpl,iXSpl=0,iYSpl=0;
static double xSC1,xSC2,XSC1,XSC2,ySC1,ySC2,YSC1,YSC2,*pxSC,*pySC;

static int iSplPF,iSplPF1,iSplPFold;
static double crxPF,cHxPF,SplPFx,SplPFxx,SplPFX,SplPFXX;
static double *xSplPF;
static double *fcs[21],*d2fcs[21],**fcsP=NULL,**d2fcsP;

static char Mess[256];

#endif

#ifndef stg_PFBSplD
int ReInitSplB()
{
  int k;

  if(NDSpl >= nDSpl){
    return(0);
  }
  if(ReInitArray((void**)&FlDSpl,NDSpl,nDSpl,sizeof(int)) < 0)
    FailureAlarm((char*)FlDSpl,"ReInitPFCSplD() - no memory for FlDSpl");
  if(ReInitArray((void**)&NXSpl,NDSpl,nDSpl,sizeof(int)) < 0){
    FailureAlarm((char*)NXSpl,"ReInitPFCSplD() - no memory for NXSpl");
  }
  if(ReInitArray((void**)&nXSpl,NDSpl,nDSpl,sizeof(int)) < 0)
    FailureAlarm((char*)nXSpl,"ReInitPFCSplD() - no memory for nXSpl");
  if(ReInitArray((void**)&NYSpl,NDSpl,nDSpl,sizeof(int)) < 0)
    FailureAlarm((char*)NYSpl,"ReInitPFCSplD() - no memory for NYSpl");
  if(ReInitArray((void**)&nYSpl,NDSpl,nDSpl,sizeof(int)) < 0)
    FailureAlarm((char*)nYSpl,"ReInitPFCSplD() - no memory for nYSpl");
  if(ReInitArray((void**)&XDSpl1,NDSpl,nDSpl,sizeof(double)) < 0)
    FailureAlarm((char*)XDSpl1,"ReInitPFCSplD() - no memory for XDSpl1");
  if(ReInitArray((void**)&XDSpl2,NDSpl,nDSpl,sizeof(double)) < 0)
    FailureAlarm((char*)XDSpl2,"ReInitPFCSplD() - no memory for XDSpl2");
  if(ReInitArray((void**)&dXDSpl,NDSpl,nDSpl,sizeof(double)) < 0)
    FailureAlarm((char*)dXDSpl,"ReInitPFCSplD() - no memory for dXDSpl");
  if(ReInitArray((void**)&YDSpl1,NDSpl,nDSpl,sizeof(double)) < 0)
    FailureAlarm((char*)YDSpl1,"ReInitPFCSplD() - no memory for YDSpl1");
  if(ReInitArray((void**)&YDSpl2,NDSpl,nDSpl,sizeof(double)) < 0)
    FailureAlarm((char*)YDSpl2,"ReInitPFCSplD() - no memory for YDSpl2");
  if(ReInitArray((void**)&dYDSpl,NDSpl,nDSpl,sizeof(double)) < 0)
    FailureAlarm((char*)dYDSpl,"ReInitPFCSplD() - no memory for dYDSpl");
  if(ReInitArray((void**)&XSpl,NDSpl,nDSpl,sizeof(double*)) < 0)
    FailureAlarm((char*)XSpl,"ReInitPFCSplD() - no memory for XSpl");
  if(ReInitArray((void**)&wSpl,NDSpl,nDSpl,sizeof(double)) < 0)
    FailureAlarm((char*)wSpl,"ReInitPFCSplD() - no memory for wSpl");
  if(ReInitArray((void**)&rwSpl,NDSpl,nDSpl,sizeof(double)) < 0)
    FailureAlarm((char*)rwSpl,"ReInitPFCSplD() - no memory for rwSpl");

  if(ReInitArray((void**)&YSpl,NDSpl,nDSpl,sizeof(double*)) < 0)
    FailureAlarm((char*)YSpl,"ReInitPFCSplD() - no memory for YSpl");
  if(ReInitArray((void**)&hSpl,NDSpl,nDSpl,sizeof(double*)) < 0)
    FailureAlarm((char*)hSpl,"ReInitPFCSplD() - no memory for hSpl");
  if(ReInitArray((void**)&rhSpl,NDSpl,nDSpl,sizeof(double*)) < 0)
    FailureAlarm((char*)rhSpl,"ReInitPFCSplD() - no memory for rhSpl");
  for(k=NDSpl; k < nDSpl; k++){
    FlDSpl[k]=1;
    NXSpl[k]=0;
    nXSpl[k]=10;
    NYSpl[k]=0;
    nYSpl[k]=10;
    XDSpl1[k]=0.;
    XDSpl2[k]=0.;
    dXDSpl[k]=0.;
    YDSpl1[k]=0.;
    YDSpl2[k]=0.;
    dYDSpl[k]=0.;
  }
  NDSpl=nDSpl;

  ESmemlevP	|=0x00000002;
  return(0);
}

int DeInitSplB()
{
  int i;
  if(NDSpl){
    i	=NDSpl;
    while(i){
      free(YSpl[i]);
      free(XSpl[i]);
      i--;
    }
    free(rhSpl);
    free(hSpl);
    free(YSpl);
    free(rwSpl);
    free(wSpl);
    free(XSpl);
    free(dYDSpl);
    free(YDSpl2);
    free(YDSpl1);
    free(dXDSpl);
    free(XDSpl2);
    free(XDSpl1);
    free(nYSpl);
    free(NYSpl);
    free(nXSpl);
    free(NXSpl);
    free(FlDSpl);
  }
  NDSpl	=0;
  return(0);
}

int DefaultSplD()
{
  int k;
  double Rmn,Rmx,Zmn,Zmx;
  PFBLOCK *lB;

  lB	=PFB;
  Rmn	=lB->R+2.*lB->dR;
  Rmx	=0.;
  Zmn	=lB->Z+2.*lB->dZ;
  Zmx	=lB->Z-2.*lB->dZ;
  for(k=1; k < nPFB; k++){
    lB	=PFB+k;
    if(Rmn > lB->R+2.*lB->dR){
      Rmn	=lB->R+2.*lB->dR;
    }
    if(Rmx < lB->R-2.*lB->dR){
      Rmx	=lB->R-2.*lB->dR;
    }
    if(Zmn > lB->Z+2.*lB->dZ){
      Zmn	=lB->Z+2.*lB->dZ;
    }
    if(Zmx < lB->Z-2.*lB->dZ){
      Zmx	=lB->Z-2.*lB->dZ;
    }
  }
  lB	=PFB;
  FlDSpl[0]	=0;
  XDSpl1[0]	=lB->R-lB->dR;
  XDSpl2[0]	=lB->R+lB->dR;
  YDSpl1[0]	=lB->Z-lB->dZ;
  YDSpl2[0]	=lB->Z+lB->dZ;
  dXDSpl[0]	=2*lB->dR;
  dYDSpl[0]	=2*lB->dZ;
  
  Zmx=(Zmx-Zmn)/(nDSpl-1);
  for(k=1; k < nDSpl; k++){
    FlDSpl[k]	=1;
    XDSpl1[k]	=Rmn;
    XDSpl2[k]	=Rmx;
    YDSpl1[k]	=Zmn;
    Zmn		+=Zmx;
    YDSpl2[k]	=Zmn;
    dXDSpl[k]	=XDSpl2[k]-XDSpl1[k];
    dYDSpl[k]	=YDSpl2[k]-YDSpl1[k];
  }

  iDSpl	=nDSpl;
  return(0);
}

int WritePFBSplDAO(FILE *lf)
{
  int i,n;
  char str[64];
  char ln[128];
  double ScaleR;

  strcpy(ln,"%2d %7.4f %7.4f %7.4f %7.4f %3d x %3d%c");
  strcpy(str,ln);
  FormatWrite2Read(str);
  fprintf(lf,"<PFC Spline Domain>[%d](%s)\n",nDSpl,str);
  ScaleR=4./1.8;
  n	=0;
  for(i=0; i < nDSpl; i++){
    fprintf(lf,ln,n,ScaleR*XDSpl1[i],ScaleR*YDSpl1[i],ScaleR*XDSpl2[i],ScaleR*YDSpl2[i]
	    ,nXSpl[i],nYSpl[i],'\n');
  }
  return(0);
}

int ReadPFBSplDAI(FILE *lf)
{
  int i,n;
  char str[64];
  char *lc;
  char *lm;
  void *lv[7];
  int dl[7]={0,0,0,0,0,0,0};

  strcpy(Mess,"PFBSplD.ai");
  lm	=Mess+strlen(Mess);
  lc	="<PFC Spline Domain>";
  if(PFIsKeyWordFound(lf,lm,lc,str,&n)){
    nDSpl	=n;
    if(NDSpl < nDSpl){
      ReInitSplB();
    }
    lv[0]	=(void*)&i;
    lv[1]	=(void*)XDSpl1;
    lv[2]	=(void*)YDSpl1;
    lv[3]	=(void*)XDSpl2;
    lv[4]	=(void*)YDSpl2;
    lv[5]	=(void*)nXSpl;
    lv[6]	=(void*)nYSpl;
    dl[0]	=0;
    dl[1]	=sizeof(double);
    dl[2]	=sizeof(double);
    dl[3]	=sizeof(double);
    dl[4]	=sizeof(double);
    dl[5]	=sizeof(int);
    dl[6]	=sizeof(int);
    PFReadAI(lf,lc,Mess,str,n,lv,dl,7);
  }
  else{
    sprintf(lm,": NO %s section.\n",lc);
    lm	+=strlen(lm);
  }
  strcpy(str," was read.\n");
  for(i=0; i < nDSpl; i++){
    FlDSpl[i]=1;
    dXDSpl[i]=XDSpl2[i]-XDSpl1[i];
    dYDSpl[i]=YDSpl2[i]-YDSpl1[i];
  }
  return(0);
}

int ReInitSplCell()
{
  int i,j,k,m;

  k	=0;
  while(k < nDSpl){
    i	=NXSpl[k];
    if(i < nXSpl[k]+1){
      ReInitArray((void**)(XSpl+k), NXSpl[k],nXSpl[k]+1,sizeof(double));
      NXSpl[k]	=nXSpl[k]+1;
      for(; i < NXSpl[k]; i++){
	XSpl[k][i]=0.;
      }
    }
    i	=NYSpl[k];
    if(i < nYSpl[k]+1){
      ReInitArray((void**)(YSpl+k), NYSpl[k],nYSpl[k]+1,sizeof(double));
      NYSpl[k]	=nYSpl[k]+1;
      for(; i < NYSpl[k]; i++){
	YSpl[k][i]=0.;
      }
    }
    k++;
  }
  return(0);
}

int SetSplXY(double x,double y)
{
  int i,i1;
  static double h,rh,w,rw;
  double t,tt,T,TT;
  static int Nx=0,Ny=0;

  i	=iDSpl;
  while(i < nDSpl){
    if(XDSpl1[i] <= x && x <= XDSpl2[i] && YDSpl1[i] <= y && y <= YDSpl2[i]){
      break;
    }
    i++;
  }
  if(i == nDSpl){
    i=iDSpl-1;
    while(i >= 0){
      if(XDSpl1[i] <= x && x <= XDSpl2[i] && YDSpl1[i] <= y && y <= YDSpl2[i]){
	break;
      }
      i--;
    }
  }
  if(i < 0){
    return(1);
  }
  if(iDSpl != i){
    iDSpl	=i;
    iXSpl	=0;
    iYSpl	=0;
    pxSC	=XSpl[iDSpl];
    pySC	=YSpl[iDSpl];
    w		=wSpl[iDSpl];
    rw		=rwSpl[iDSpl];
    h		=hSpl[iDSpl];
    rh		=rhSpl[iDSpl];
    Nx		=nXSpl[iDSpl];
    Ny		=nYSpl[iDSpl];
  }
  i	=iXSpl;
  i1	=i+1;
  while(pxSC[i1] < x && i1 < Nx){
    i++;
    i1++;
  }
  while(x < pxSC[i] && i > 0){
    i--;
    i1--;
  }
  iXSpl	=i;
  T	=(pxSC[i1]-x)*rw;
  TT	=T*T;
  t	=(x-pxSC[i])*rw;
  tt	=t*t;
  XSC1	=TT*(3.-2.*T);
  XSC2	=TT*t*w;
  xSC1	=tt*(3.-2.*t);
  xSC2	=-tt*T*w;
  i	=iYSpl;
  i1	=i+1;
  while(pySC[i1] < y && i1 < Ny){
    i++;
    i1++;
  }
  while(y < pySC[i] && i > 0){
    i--;
    i1--;
  }
  iYSpl	=i;
  T	=(pySC[i1]-y)*rh;
  TT	=T*T;
  t	=(y-pySC[i])*rh;
  tt	=t*t;
  YSC1	=TT*(3.-2.*T);
  YSC2	=TT*t*h;
  ySC1	=tt*(3.-2.*t);
  ySC2	=-tt*T*h;
  return(0);
}
#endif

#ifndef blb_PMF
#ifndef mzl_PFBS

int DeInitPFCgYSpl()
{
  int i,j;
  if(gYPFBS != NULL){
    nDSpl=NDSpl;
    while(nDSpl){
      i=NXSpl[nDSpl];
      while(i){
	j=NYSpl[nDSpl];
	while(j){
	  free(gYPFBS[nDSpl][i][j]);
	  j--;
	}
	free(gYPFBS[nDSpl][i]);
	i--;
      }
      free(gYPFBS[nDSpl]);
      nDSpl--;
    }
    free(NgYRSpl);
    free(gYPFBS);
    gYPFBS	=NULL;
  }
  NgYDSpl=0;
  NgYPFB=0;
  return(0);
}

int ReInitPFCgYSpl()
{
  int i,j,k,m;

  if(NgYDSpl){
    DeInitPFCgYSpl();
  }
  if((gYPFBS=(SPL****)malloc(nDSpl*sizeof(SPL***))) == NULL){
    FailureAlarm((char*)gYPFBS,"ReInitPFCgYSpl() - no memory for gYPFBS");
    exit(0);
  }
  if((NgYRSpl=(int*)malloc(2*nDSpl*sizeof(int))) == NULL){
    FailureAlarm((char*)NgYRSpl,"ReInitPFCgYSpl() - no memory for NgYRSpl");
    exit(0);
  }
  NgYZSpl=NgYRSpl+nDSpl;

  for(k=0; k < nDSpl; k++){
    gYPFBS[k]	=NULL;
    NgYRSpl[k]=nXSpl[k]+1;
    NgYZSpl[k]=nYSpl[k]+1;
  }
  k=0;
  while(k < nDSpl){
    if((gYPFBS[k]=(SPL***)malloc((nXSpl[k]+1)*sizeof(SPL**))) == NULL){
      printf("ReInitPFCgYSpl() - no memory for gYPFBS[%d]\n",k);
      exit(0);
    }
    for(i=0; i < nXSpl[k]+1; i++){
      gYPFBS[k][i]	=NULL;
    }		    
    for(i=0; i < nXSpl[k]+1; i++){
      m	=gYPFBS[k][i] != NULL ? NgYZSpl[k] : 0;
      if((gYPFBS[k][i]=(SPL**)malloc((nYSpl[k]+1)*sizeof(SPL*))) == NULL){
	printf("ReInitPFCgYSpl() - no memory for gYPFBS[%d][%d]\n",k,i);
	exit(0);
      }
      for(j=0; j < nYSpl[k]+1; j++){
	gYPFBS[k][i][j]	=NULL;
      }
      for(j=0; j < nYSpl[k]+1; j++){
	m	=gYPFBS[k][i][j] != NULL ? NgYPFB : 0;
	if((gYPFBS[k][i][j]=(SPL*)malloc(nPEC*sizeof(SPL))) == NULL){
	  printf("ReInitPFCgYSpl() - no memory for gYPFBS[%d][%d][%d]\n"
		 ,k,i,j);
	  exit(0);
	}
      }
    }
    k++;
  }
  NgYDSpl	=nDSpl;
  NgYPFB	=nPEC;
  ESmemlevP	|=0x00000004;
  return(0);
}

int PFWritePFBSplBO(FILE *lf)
{
  PFBLOCK *lB;
  PSBLOCK *lS;

  int i,j,k,n,Ni,Nj;
  size_t ii,id,iv;

  ii	=(size_t)sizeof(int);
  id	=(size_t)sizeof(double);
  iv	=(size_t)nDSpl;
  fwrite(&nDSpl,ii,(size_t)1,lf);
  fwrite(nXSpl,ii,iv,lf);
  fwrite(nYSpl,ii,iv,lf);
  fwrite(XDSpl1,id,iv,lf);
  fwrite(XDSpl2,id,iv,lf);
  fwrite(YDSpl1,id,iv,lf);
  fwrite(YDSpl2,id,iv,lf);

  /* PSBlocks */
  n	=0;
  for(i=0; i < nVVB; i++){
    if(VVB[i].kA){
      n++;
    }
  }
  fwrite(&n,sizeof(int),(size_t)1,lf);
  for(i=0; i < nVVB; i++){
    if(VVB[i].kA){
      lS	=VVB+i;
      fwrite(&lS->kC,sizeof(int),(size_t)1,lf);
      fwrite(&lS->r,id,(size_t)4,lf);
      fwrite(&lS->z,id,(size_t)4,lf);
      fwrite(&lS->gS,id,(size_t)1,lf);
      fwrite(&lS->n1,sizeof(int),(size_t)1,lf);
      fwrite(&lS->n2,sizeof(int),(size_t)1,lf);
    }
  }

  /* PFBlocks */
  fwrite(&nPFB,ii,(size_t)1,lf);
  for(i=0; i < nPFB; i++){
    fwrite(&PFB[i].nr,ii,(size_t)2,lf);
  }
  for(i=0; i < nPFB; i++){
    lB	=PFB+i;
    fwrite(&lB->R, id,(size_t)1,lf);
    fwrite(&lB->dR,id,(size_t)1,lf);
    fwrite(&lB->Z, id,(size_t)1,lf);
    fwrite(&lB->dZ,id,(size_t)1,lf);
  }
  id	=(size_t)sizeof(SPL);
  iv	=(size_t)nPEC;
  for(k=0; k < nDSpl; k++){
    Ni	=nXSpl[k]+1;	
    Nj	=nYSpl[k]+1;	
    for(i=0; i < Ni; i++){
      for(j=0; j < Nj; j++){
	fwrite(gYPFBS[k][i][j],id,iv,lf);
      }
    }
  }
  return(0);
}

int PFReadPFBSplBI(FILE *lf)
{
  PFBLOCK *lB;
  PSBLOCK *lS;
  int i,j,m,n,k[8],Ni,Nj;
  double s[8];
  size_t ii,id,iv;

  ii	=(size_t)sizeof(int);
  id	=(size_t)sizeof(double);
  iv	=(size_t)nDSpl;
  m	=fread(k,ii,(size_t)1,lf);

  if(m < 1 || nDSpl != k[0]){
    return(1);
  }
  m	=fread(k,ii,iv,lf);
  if(m < nDSpl){
    return(1);
  }
  for(i=0; i < nDSpl; i++){
    if(nXSpl[i] != k[i]){
      return(1);
    }
  }
  m	=fread(k,ii,iv,lf);
  if(m < nDSpl){
    return(1);
  }
  for(i=0; i < nDSpl; i++){
    if(nYSpl[i] != k[i]){
      return(1);
    }
  }
  m	=fread(s,id,iv,lf);
  if(m < nDSpl){
    return(1);
  }
  for(i=0; i < nDSpl; i++){
    if(XDSpl1[i] != s[i]){
      return(1);
    }
  }
  m	=fread(s,id,iv,lf);
  if(m < nDSpl){
    return(1);
  }
  for(i=0; i < nDSpl; i++){
    if(XDSpl2[i] != s[i]){
      return(1);
    }
  }
  m	=fread(s,id,iv,lf);
  if(m < nDSpl){
    return(1);
  }
  for(i=0; i < nDSpl; i++){
    if(YDSpl1[i] != s[i]){
      return(1);
    }
  }
  m	=fread(s,id,iv,lf);
  if(m < nDSpl){
    return(1);
  }
  for(i=0; i < nDSpl; i++){
    if(YDSpl2[i] != s[i]){
      return(1);
    }
  }

  /* PSBlocks */
  n	=0;
  for(i=0; i < nVVB; i++){
    if(VVB[i].kA){
      n++;
    }
  }
  m	=fread(k,sizeof(int),(size_t)1,lf);
  if(m < 1 || n != k[0]){
    return(1);
  }
  for(i=0; i < nVVB; i++){
    if(VVB[i].kA){
      lS	=VVB+i;
      m	=fread(k,sizeof(int),(size_t)1,lf);
      if(m < 1 || lS->kC != k[0]){
	return(1);
      }
      m	=fread(s,id,(size_t)4,lf);
      if(m < 4){
	return(1);
      }
      if(lS->r[0] != s[0] || lS->r[1] != s[1] 
	 || lS->r[2] != s[2] || lS->r[3] != s[3]){
	return(1);
      }
      m	=fread(s,id,(size_t)4,lf);
      if(m < 4){
	return(1);
      }
      if(lS->z[0] != s[0] || lS->z[1] != s[1] 
	 || lS->z[2] != s[2] || lS->z[3] != s[3]){
	return(1);
      }
      m	=fread(s,id,(size_t)1,lf);
      if(m < 1){
	return(1);
      }
      if(lS->gS != s[0]){
	return(1);
      }
      m	=fread(k,sizeof(int),(size_t)2,lf);
      if(m < 2){
	return(1);
      }
      if(lS->n1 != k[0] || lS->n2 != k[1]){
	return(1);
      }
    }
  }

  /* PFBlocks */
  m	=fread(k,ii,(size_t)1,lf);
  if(m < 1 || nPFB != k[0]){
    return(1);
  }
  for(i=0; i < nPFB; i++){
    m	=fread(k,ii,(size_t)2,lf);
    if(m < 2 || PFB[i].nr != k[0] || PFB[i].nz != k[1]){
      return(1);
    }
  }
  for(i=0; i < nPFB; i++){
    lB	=PFB+i;
    m	=fread(s,id,(size_t)4,lf);
    if(m < 4){
      return(1);
    }
    if(lB->R != s[0] || lB->dR != s[1] || lB->Z != s[2] || lB->dZ != s[3]){
      return(1);
    }
  }
  id	=(size_t)sizeof(SPL);
  iv	=(size_t)nPEC;
  for(m=0; m < nDSpl; m++){
    Ni=nXSpl[m]+1;	
    Nj=nYSpl[m]+1;	
    for(i=0; i < Ni; i++){
      for(j=0; j < Nj; j++){
	if(fread(gYPFBS[m][i][j],id,iv,lf) < iv){
	  return(1);
	}
      }
    }
  }
  return(0);
}

int SetPFCSplGeom()
{
  int i,Ni,j,Nj,k;
  double h,r,z,*pr,*pz;

  for(k=0; k < nDSpl; k++){
    h		=(XDSpl2[k]-XDSpl1[k])/nXSpl[k];
    wSpl[k]	=h;
    rwSpl[k]	=1./h;
    Ni	=nXSpl[k]+1;
    pr	=XSpl[k];
    r	=XDSpl1[k];
    for(j=0; j < Ni; j++){
      *pr++	=r;
      r	+=h;
    }
    h		=(YDSpl2[k]-YDSpl1[k])/nYSpl[k];
    hSpl[k]	=h;
    rhSpl[k]	=1./h;
    Nj	=nYSpl[k]+1;
    z		=YDSpl1[k];
    pz	=YSpl[k];
    for(j=0; j < Nj; j++){
      *pz++	=z;
      z	+=h;
    }
  }
  return(0);
}

int SetPFCSpl()
{
  int i,Ni,j,Nj,k,m,mr,mz,nr,nz;
  double h,gp,Br,Bz,*pr,*pz,r0,z0,r1,z1,hr,hz;

  double gy,gyr,gyz,gyrr,gyrz,gyzz,gyrrz,gyzzr;
  double gY,gYr,gYz,gYrr,gYrz,gYzz,gYrrz,gYzzr;
  char ln[64];
  SPL *pS;
  int *li;
  PSBLOCK *lS;
  int kC,kB,nB,n1,n2,k1,k2;
  double dS,dS0,dSr,dSz,S,er[4],ez[4],r[4],z[4],dr,dz;

  for(k=0; k < nDSpl; k++){
    Ni	=nXSpl[k]+1;
    Nj	=nYSpl[k]+1;
    pr	=XSpl[k];
    pz	=YSpl[k];
    for(i=0; i < Ni; i++){
      r0	=pr[i];
      for(j=0; j < Nj; j++){
	z0	=pz[j];
	sprintf(ln,"Splining MF of PFCoils:\n %3d < %3d %3d < %3d",i,Ni,j,Nj);
	for(kC=1; kC < nPFC; kC++){
	  pS	=gYPFBS[k][i][j]+kC;
	  pS->f	=0.;
	  pS->x	=0.;
	  pS->y	=0.;
	  pS->xx=0.;
	  pS->yy=0.;
	  pS->xy=0.;
	  pS->xxy=0.;
	  pS->yyx=0.;
	  nB	=PFC[kC].nB;
	  li	=PFC[kC].kB;
	  for(kB=0; kB < nB; kB++){
	    m	=li[kB];
	    ZMessage(ln);
	    nr	=PFB[m].nr;
	    hr	=(Rb2[m]-Rb1[m])/nr;
	    nz	=PFB[m].nz;
	    hz	=(Zb2[m]-Zb1[m])/nz;
	    r1	=Rb1[m]+hr*0.5;
	    gY	=0.;
	    gYr	=0.;
	    gYz	=0.;
	    gYrr=0.;
	    gYzz=0.;
	    gYrz=0.;
	    gYrrz=0.;
	    gYzzr=0.;
	    for(mr=0; mr < nr; mr++){
	      z1	=Zb1[m]+hz*0.5;
	      for(mz=0; mz < nz; mz++){
		gYdYd2Yd3Y(&gy,&gyr,&gyz,&gyrr,&gyrz,&gyzz,&gyrrz,&gyzzr
			   ,r0,z0,r1,z1);
		gY	+=gy;
		gYr	+=gyr;
		gYz	+=gyz;
		gYrr	+=gyrr;
		gYzz	+=gyzz;
		gYrz	+=gyrz;
		gYrrz	+=gyrrz;
		gYzzr	+=gyzzr;
		z1 +=hz;
	      }
	      r1 +=hr;
	    } 
	    h		=PFB[m].tn/(nr*nz);
	    pS->f	+=gY*h;
	    pS->x	+=gYr*h;
	    pS->y	+=gYz*h;
	    pS->xx	+=gYrr*h;
	    pS->yy	+=gYzz*h;
	    pS->xy	+=gYrz*h;
	    pS->xxy	+=gYrrz*h;
	    pS->yyx	+=gYzzr*h;
	  }
	}
      }
    }
  }

  /*Screens */
  for(m=0; m < nDSpl; m++){
    Ni	=nXSpl[m]+1;
    Nj	=nYSpl[m]+1;
    for(i=0; i < Ni; i++){
      for(j=0; j < Nj; j++){
	pS	=gYPFBS[m][i][j]+nPFC;
	for(k=0; k < nVVC; k++){
	  pS->f		=0.;
	  pS->x		=0.;
	  pS->y		=0.;
	  pS->xx	=0.;
	  pS->yy	=0.;
	  pS->xy	=0.;
	  pS->xxy	=0.;
	  pS->yyx	=0.;
	  pS++;
	}
      }
    }
  }

  for(k=0; k < nVVB; k++){
    if(VVB[k].kA){    
      sprintf(ln,"Plasma-PScreens: %4d < %d",k,nVVB);
      ZMessage(ln);
      lS	=VVB+k;
      kC	=lS->kC;
      n1	=lS->n1;
      n2	=lS->n2;
      er[0]	=(lS->r[1]-lS->r[0])/n1;
      er[1]	=(lS->r[2]-lS->r[1])/n2;
      er[2]	=(lS->r[2]-lS->r[3])/n1;
      er[3]	=(lS->r[3]-lS->r[0])/n2;
      ez[0]	=(lS->z[1]-lS->z[0])/n1;
      ez[1]	=(lS->z[2]-lS->z[1])/n2;
      ez[2]	=(lS->z[2]-lS->z[3])/n1;
      ez[3]	=(lS->z[3]-lS->z[0])/n2;
      dr	=(er[2]-er[0])/n2;
      dz	=(ez[2]-ez[0])/n2;
      dS0	=2.*(er[0]*ez[3]-ez[0]*er[3]);
      dSr	=(er[0]*(ez[2]-ez[0])-ez[0]*(er[2]-er[0]))/n2;
      dSz	=(er[3]*(ez[2]-ez[0])-ez[3]*(er[2]-er[0]))/n2;
      for(m=0; m < nDSpl; m++){
	Ni	=nXSpl[m]+1;
	Nj	=nYSpl[m]+1;
	pr	=XSpl[m];
	pz	=YSpl[m];
	for(i=0; i < Ni; i++){
	  r0	=pr[i];
	  for(j=0; j < Nj; j++){
	    z0	=pz[j];
	    pS	=gYPFBS[m][i][j]+nPFC+kC;
	    S	=0.;
	    gY	=0.;
	    gYr	=0.;
	    gYz	=0.;
	    gYrr	=0.;
	    gYrz	=0.;
	    gYzz	=0.;
	    gYrrz	=0.;
	    gYzzr	=0.;
	    for(k1=0; k1 < n1; k1++){
	      for(k2=0; k2 < n2; k2++){
		r1	=lS->r[0]+k1*er[0]+k2*er[3]+k1*k2*dr;
		r[0]	=r1;
		r[1]	=r1+er[0]+k2*dr;
		r[2]	=r1+er[0]+er[3]+(k1+k2+1)*dr;
		r[3]	=r1+er[3]+k1*dr;
		z1	=lS->z[0]+k1*ez[0]+k2*ez[3]+k1*k2*dz;
		z[0]	=z1;
		z[1]	=z1+ez[0]+k2*dz;
		z[2]	=z1+ez[0]+ez[3]+(k1+k2+1)*dz;
		z[3]	=z1+ez[3]+k1*dz;
		r1	=cr4*(r[0]+r[1]+r[2]+r[3]);
		z1	=cr4*(z[0]+z[1]+z[2]+z[3]);
		gYdYd2Yd3Y(&gy,&gyr,&gyz,&gyrr,&gyrz,&gyzz,&gyrrz,&gyzzr
			   ,r0,z0,r1,z1);
		dS	=fabs(dS0+(2*k1+1)*dSr-(2*k2+1)*dSz);
		gY	+=gy*dS;
		gYr	+=gyr*dS;
		gYz	+=gyz*dS;
		gYrr	+=gyrr*dS;
		gYrz	+=gyrz*dS;
		gYzz	+=gyzz*dS;
		gYrrz	+=gyrrz*dS;
		gYzzr	+=gyzzr*dS;
		S	+=dS;
	      }
	    }
	    h		=lS->tn/S;
	    pS->f	+=gY*h;
	    pS->x	+=gYr*h;
	    pS->y	+=gYz*h;
	    pS->xx	+=gYrr*h;
	    pS->xy	+=gYrz*h;
	    pS->yy	+=gYzz*h;
	    pS->xxy	+=gYrrz*h;
	    pS->yyx	+=gYzzr*h;
	  }
	}
      }
    }
  }
  return(0);
}

int SetSplgYCell()
{
  static int iX=-1,iY=-1,iD=-1;

  if(iX == iXSpl && iY == iYSpl && iD == iDSpl){
    return(0);
  }
  iX	=iXSpl;
  iY	=iYSpl;
  iD	=iDSpl;

  pSgY00=gYPFBS[iD][iX][iY];
  pSgY10=gYPFBS[iD][iX+1][iY];
  pSgY01=gYPFBS[iD][iX][iY+1];
  pSgY11=gYPFBS[iD][iX+1][iY+1];
  return(0);
}

int GetNodeBz(double *gY,double *gYr,double *gYrr,double x,double y)
{
  int m,k;
  double f,fx,fxx,Ic;
  SPL *pS00;

  SetSplXY(x,y);
  SetSplgYCell();
  f	=0.;
  fx	=0.;
  fxx	=0.;
  for(m=1; m < nPEC; m++){
    if(m < nPFC){
      k	=PFC[m].kA;
      Ic=PFC[m].I;
    }
    else{
      k	=m-nPFC;
      Ic=VVC[k].I;
      k	=VVC[k].kA;
    }
    if(k){
      pS00	=pSgY00+m;
      f		+=pS00->f*Ic;
      fx	+=pS00->x*Ic;
      fxx	+=pS00->xx*Ic;
    }
  }
  *gY	=f;
  *gYr	=fx;
  *gYrr	=fxx;
  return(0);
}

int PFCgYSpl(double *gY,double *gYr,double *gYz)
{
  int m;
  double f,fx,fy,Ic;
  SPL *pS00,*pS10,*pS01,*pS11;

  f	=0.;
  fx	=0.;
  fy	=0.;
  pS00	=pSgY00+1;
  pS10	=pSgY10+1;
  pS01	=pSgY01+1;
  pS11	=pSgY11+1;
  for(m=1; m < nPEC; m++){
    Ic	=m < nPFC ? PFC[m].I :  VVC[m-nPFC].I;
    pS00	=pSgY00+m;
    pS10	=pSgY10+m;
    pS01	=pSgY01+m;
    pS11	=pSgY11+m;

    f	+=(XSC1*(YSC1*pS00->f+ySC1*pS01->f+YSC2*pS00->y+ySC2*pS01->y)
	   +xSC1*(YSC1*pS10->f+ySC1*pS11->f+YSC2*pS10->y+ySC2*pS11->y)
	   +XSC2*(YSC1*pS00->x+ySC1*pS01->x+YSC2*pS00->xy+ySC2*pS01->xy)
	   +xSC2*(YSC1*pS10->x+ySC1*pS11->x+YSC2*pS10->xy+ySC2*pS11->xy)
	   )*Ic;
    fx	+=(XSC1*(YSC1*pS00->x+ySC1*pS01->x+YSC2*pS00->xy+ySC2*pS01->xy)
	   +xSC1*(YSC1*pS10->x+ySC1*pS11->x+YSC2*pS10->xy+ySC2*pS11->xy)
	   +XSC2*(YSC1*pS00->xx+ySC1*pS01->xx+YSC2*pS00->xxy+ySC2*pS01->xxy)
	   +xSC2*(YSC1*pS10->xx+ySC1*pS11->xx+YSC2*pS10->xxy+ySC2*pS11->xxy)
	   )*Ic;
    fy	+=(XSC1*(YSC1*pS00->y+ySC1*pS01->y+YSC2*pS00->yy+ySC2*pS01->yy)
	   +xSC1*(YSC1*pS10->y+ySC1*pS11->y+YSC2*pS10->yy+ySC2*pS11->yy)
	   +XSC2*(YSC1*pS00->xy+ySC1*pS01->xy+YSC2*pS00->yyx+ySC2*pS01->yyx)
	   +xSC2*(YSC1*pS10->xy+ySC1*pS11->xy+YSC2*pS10->yyx+ySC2*pS11->yyx)
	   )*Ic;
  }
  *gY	=f;
  *gYr	=fx;
  *gYz	=fy;
  return(0);
}

int PFCgY0Spl(double *gY,double *gYr,double *gYz,int m)
{
  SPL *pS00,*pS10,*pS01,*pS11;

  pS00	=pSgY00+m;
  pS10	=pSgY10+m;
  pS01	=pSgY01+m;
  pS11	=pSgY11+m;
  
  *gY	=(XSC1*(YSC1*pS00->f+ySC1*pS01->f+YSC2*pS00->y+ySC2*pS01->y)
	  +xSC1*(YSC1*pS10->f+ySC1*pS11->f+YSC2*pS10->y+ySC2*pS11->y)
	  +XSC2*(YSC1*pS00->x+ySC1*pS01->x+YSC2*pS00->xy+ySC2*pS01->xy)
	  +xSC2*(YSC1*pS10->x+ySC1*pS11->x+YSC2*pS10->xy+ySC2*pS11->xy)
	  );
  *gYr	=(XSC1*(YSC1*pS00->x+ySC1*pS01->x+YSC2*pS00->xy+ySC2*pS01->xy)
	  +xSC1*(YSC1*pS10->x+ySC1*pS11->x+YSC2*pS10->xy+ySC2*pS11->xy)
	  +XSC2*(YSC1*pS00->xx+ySC1*pS01->xx+YSC2*pS00->xxy+ySC2*pS01->xxy)
	  +xSC2*(YSC1*pS10->xx+ySC1*pS11->xx+YSC2*pS10->xxy+ySC2*pS11->xxy)
	  );
  *gYz	=(XSC1*(YSC1*pS00->y+ySC1*pS01->y+YSC2*pS00->yy+ySC2*pS01->yy)
	  +xSC1*(YSC1*pS10->y+ySC1*pS11->y+YSC2*pS10->yy+ySC2*pS11->yy)
	  +XSC2*(YSC1*pS00->xy+ySC1*pS01->xy+YSC2*pS00->yyx+ySC2*pS01->yyx)
	  +xSC2*(YSC1*pS10->xy+ySC1*pS11->xy+YSC2*pS10->yyx+ySC2*pS11->yyx)
	  );
  return(0);
}

int PFCgYMF0(double *gY,double *Br,double *Bz,double r0, double z0, int kC)
{
  int m,k,n;
  int mr,mz,n1,n2;
  double h,r1,z1,hr,hz;
  double gy,br,bz;
  double dgY,dBr,dBz;
  double s,t;
  
  if(kC < nPFC){
    dgY	=0.;
    dBr	=0.;
    dBz	=0.;
    n	=PFC[kC].nB;
    for(k=0; k < n; k++){
      m	=PFC[kC].kB[k];
      t	=PFB[m].tn;
      n1=PFB[m].nr;
      n2=PFB[m].nz;
      hr=(Rb2[m]-Rb1[m])/n1;
      hz=(Zb2[m]-Zb1[m])/n2;
      h	=t/(n1*n2);
      r1=Rb1[m]+hr*0.5;
      for(mr=0; mr < n1; mr++){
	z1	=Zb1[m]+hz*0.5;
	for(mz=0; mz < n2; mz++){
	  MFring(&gy,&br,&bz,r0,z0,r1,z1,h);
	  dgY	+=gy;
	  dBr	+=br;
	  dBz	+=bz;
	  z1 	+=hz;
	}
	r1 +=hr;
      } 
    }
    *gY	=dgY;
    *Br	=dBr;
    *Bz	=dBz;
  }
  else{
    PFgYBrBzScreen0(gY,Br,Bz,r0,z0,kC-nPFC);
  }
  return(0);
}

int PFgYBrBzScreen0(double *gY,double *Br,double *Bz,double r0,double z0,int m)
{
  int n,j;
  double gy,br,bz;
  double dgY,dBr,dBz;
  PSBLOCK *lS;
  int k1,k2,n1,n2;
  double gY1,Br1,Bz1;
  double dS,dS0,dSr,dSz,S,er[4],ez[4],r[4],z[4],r1,z1,dr,dz;

  gY1	=0.;
  Br1	=0.;
  Bz1	=0.;
  n	=VVC[m].nB;
  for(j=0; j < n; j++){
    lS	=VVB+VVC[m].kB[j];
    n1	=lS->n1;
    n2	=lS->n2;
    er[0]	=(lS->r[1]-lS->r[0])/n1;
    er[1]	=(lS->r[2]-lS->r[1])/n2;
    er[2]	=(lS->r[2]-lS->r[3])/n1;
    er[3]	=(lS->r[3]-lS->r[0])/n2;
    ez[0]	=(lS->z[1]-lS->z[0])/n1;
    ez[1]	=(lS->z[2]-lS->z[1])/n2;
    ez[2]	=(lS->z[2]-lS->z[3])/n1;
    ez[3]	=(lS->z[3]-lS->z[0])/n2;
    dr	=(er[2]-er[0])/n2;
    dz	=(ez[2]-ez[0])/n2;
    dS0	=2.*(er[0]*ez[3]-ez[0]*er[3]);
    dSr	=(er[0]*(ez[2]-ez[0])-ez[0]*(er[2]-er[0]))/n2;
    dSz	=(er[3]*(ez[2]-ez[0])-ez[3]*(er[2]-er[0]))/n2;
    S	=0.;
    dgY	=0.;
    dBr	=0.;
    dBz	=0.;
    for(k1=0; k1 < n1; k1++){
      for(k2=0; k2 < n2; k2++){
	r1	=lS->r[0]+k1*er[0]+k2*er[3]+k1*k2*dr;
	r[0]	=r1;
	r[1]	=r1+er[0]+k2*dr;
	r[2]	=r1+er[0]+er[3]+(k1+k2+1)*dr;
	r[3]	=r1+er[3]+k1*dr;
	z1	=lS->z[0]+k1*ez[0]+k2*ez[3]+k1*k2*dz;
	z[0]	=z1;
	z[1]	=z1+ez[0]+k2*dz;
	z[2]	=z1+ez[0]+ez[3]+(k1+k2+1)*dz;
	z[3]	=z1+ez[3]+k1*dz;
	r1	=cr4*(r[0]+r[1]+r[2]+r[3]);
	z1	=cr4*(z[0]+z[1]+z[2]+z[3]);
	dS	=fabs(dS0+(2*k1+1)*dSr-(2*k2+1)*dSz);
	S	+=dS;
	MFring(&gy,&br,&bz,r0,z0,r1,z1,dS);
	dgY	+=gy;
	dBr	+=br;
	dBz	+=bz;
      }
    }
    dS	=lS->tn/S;
    gY1	+=dgY*dS;
    Br1	+=dBr*dS;
    Bz1	+=dBz*dS;
  }
  *gY	=gY1;
  *Br	=Br1;
  *Bz	=Bz1;
  return(0);
}

int PFCgYMF(double *gY,double *Bz,double *Br,double r0, double z0)
{
  int m,mr,mz;
  double h;
  int n,j;
  PSBLOCK *lS;
  int k1,k2,n1,n2;

  double gy,br,bz;
  double gY1,Bz1,Br1;
  double dgY,dBr,dBz;
  double dS,dS0,dSr,dSz,S,er[4],ez[4],r[4],z[4],r1,z1,dr,dz;
  
  gY1	=0.;
  Bz1	=0.;
  Br1	=0.;
  for(m=1; m < nPFB; m++){
    n1	=PFB[m].nr;
    n2	=PFB[m].nz;
    dr	=(Rb2[m]-Rb1[m])/n1;
    dz	=(Zb2[m]-Zb1[m])/n2;
    h	=PFC[PFB[m].kC].I*PFB[m].tn/(n1*n2);
    r1	=Rb1[m]+dr*0.5;
    for(mr=0; mr < n1; mr++){
      z1=Zb1[m]+dz*0.5;
      for(mz=0; mz < n2; mz++){
	MFring(&gy,&dBr,&dBz,r0,z0,r1,z1,h);
	gY1	+=gy;
	Br1	+=dBr;
	Bz1	+=dBz;
	z1 	+=dz;
      }
      r1 +=dr;
    } 
  }
  for(m=0; m < nVVC; m++){
    n	=VVC[m].nB;
    for(j=0; j < n; j++){
      lS	=VVB+VVC[m].kB[j];
      n1	=lS->n1;
      n2	=lS->n2;
      er[0]	=(lS->r[1]-lS->r[0])/n1;
      er[1]	=(lS->r[2]-lS->r[1])/n2;
      er[2]	=(lS->r[2]-lS->r[3])/n1;
      er[3]	=(lS->r[3]-lS->r[0])/n2;
      ez[0]	=(lS->z[1]-lS->z[0])/n1;
      ez[1]	=(lS->z[2]-lS->z[1])/n2;
      ez[2]	=(lS->z[2]-lS->z[3])/n1;
      ez[3]	=(lS->z[3]-lS->z[0])/n2;
      dr	=(er[2]-er[0])/n2;
      dz	=(ez[2]-ez[0])/n2;
      dS0	=2.*(er[0]*ez[3]-ez[0]*er[3]);
      dSr	=(er[0]*(ez[2]-ez[0])-ez[0]*(er[2]-er[0]))/n2;
      dSz	=(er[3]*(ez[2]-ez[0])-ez[3]*(er[2]-er[0]))/n2;
      S	=0.;
      dgY	=0.;
      dBr	=0.;
      dBz	=0.;
      for(k1=0; k1 < n1; k1++){
	for(k2=0; k2 < n2; k2++){
	  r1	=lS->r[0]+k1*er[0]+k2*er[3]+k1*k2*dr;
	  r[0]	=r1;
	  r[1]	=r1+er[0]+k2*dr;
	  r[2]	=r1+er[0]+er[3]+(k1+k2+1)*dr;
	  r[3]	=r1+er[3]+k1*dr;
	  z1	=lS->z[0]+k1*ez[0]+k2*ez[3]+k1*k2*dz;
	  z[0]	=z1;
	  z[1]	=z1+ez[0]+k2*dz;
	  z[2]	=z1+ez[0]+ez[3]+(k1+k2+1)*dz;
	  z[3]	=z1+ez[3]+k1*dz;
	  r1	=cr4*(r[0]+r[1]+r[2]+r[3]);
	  z1	=cr4*(z[0]+z[1]+z[2]+z[3]);
	  dS	=fabs(dS0+(2*k1+1)*dSr-(2*k2+1)*dSz);
	  S	+=dS;
	  MFring(&gy,&br,&bz,r0,z0,r1,z1,dS);
	  dgY	+=gy;
	  dBr	+=br;
	  dBz	+=bz;
	}
      }
      dS	=VVC[m].I*lS->tn/S;
      gY1	+=dgY*dS;
      Br1	+=dBr*dS;
      Bz1	+=dBz*dS;
    }
  }
  *gY	=gY1;
  *Br	=Br1;
  *Bz	=Bz1;
  return(0);
}

int PFCgYdYd2Yd3Y(double *gY
		,double *gYr,double *gYz
		,double *gYrr,double *gYrz,double *gYzz
		,double *gYrrz,double *gYrzz
		  ,double r0, double z0)
{
  int m,mr,mz;
  double h;
  int n,j;
  PSBLOCK *lS;
  int k1,k2,n1,n2;

  double y,yr,yz,yrr,yrz,yzz,yrrz,yrzz;
  double Y,Yr,Yz,Yrr,Yrz,Yzz,Yrrz,Yrzz;

  double gY1,Bz1,Br1;
  double dS,dS0,dSr,dSz,S,er[4],ez[4],r[4],z[4],r1,z1,dr,dz;
  

  Y	=0.;
  Yr	=0.;
  Yz	=0.;
  Yrr	=0.;
  Yrz	=0.;
  Yzz	=0.;
  Yrrz	=0.;
  Yrzz	=0.;
  for(m=1; m < nPFB; m++){
    n1	=PFB[m].nr;
    n2	=PFB[m].nz;
    dr	=(Rb2[m]-Rb1[m])/n1;
    dz	=(Zb2[m]-Zb1[m])/n2;
    h	=PFC[PFB[m].kC].I*PFB[m].tn/(n1*n2);
    r1	=Rb1[m]+dr*0.5;
    for(mr=0; mr < n1; mr++){
      z1=Zb1[m]+dz*0.5;
      for(mz=0; mz < n2; mz++){
	gYdYd2Yd3Y(&y,&yr,&yz,&yrr,&yrz,&yzz,&yrrz,&yrzz
		   ,r0,z0,r1,z1);
	Y	+=y*h;
	Yr	+=yr*h  ;
	Yz	+=yz*h  ;
	Yrr	+=yrr*h ;
	Yrz	+=yrz*h ;
	Yzz	+=yzz*h ;
	Yrrz	+=yrrz*h;
	Yrzz	+=yrzz*h;
	z1 	+=dz;
      }
      r1 +=dr;
    } 
  }
#ifdef H
  for(m=0; m < nVVC; m++){
    n	=VVC[m].nB;
    for(j=0; j < n; j++){
      lS	=VVB+VVC[m].kB[j];
      n1	=lS->n1;
      n2	=lS->n2;
      er[0]	=(lS->r[1]-lS->r[0])/n1;
      er[1]	=(lS->r[2]-lS->r[1])/n2;
      er[2]	=(lS->r[2]-lS->r[3])/n1;
      er[3]	=(lS->r[3]-lS->r[0])/n2;
      ez[0]	=(lS->z[1]-lS->z[0])/n1;
      ez[1]	=(lS->z[2]-lS->z[1])/n2;
      ez[2]	=(lS->z[2]-lS->z[3])/n1;
      ez[3]	=(lS->z[3]-lS->z[0])/n2;
      dr	=(er[2]-er[0])/n2;
      dz	=(ez[2]-ez[0])/n2;
      dS0	=2.*(er[0]*ez[3]-ez[0]*er[3]);
      dSr	=(er[0]*(ez[2]-ez[0])-ez[0]*(er[2]-er[0]))/n2;
      dSz	=(er[3]*(ez[2]-ez[0])-ez[3]*(er[2]-er[0]))/n2;
      S	=0.;
      dgY	=0.;
      dBr	=0.;
      dBz	=0.;
      for(k1=0; k1 < n1; k1++){
	for(k2=0; k2 < n2; k2++){
	  r1	=lS->r[0]+k1*er[0]+k2*er[3]+k1*k2*dr;
	  r[0]	=r1;
	  r[1]	=r1+er[0]+k2*dr;
	  r[2]	=r1+er[0]+er[3]+(k1+k2+1)*dr;
	  r[3]	=r1+er[3]+k1*dr;
	  z1	=lS->z[0]+k1*ez[0]+k2*ez[3]+k1*k2*dz;
	  z[0]	=z1;
	  z[1]	=z1+ez[0]+k2*dz;
	  z[2]	=z1+ez[0]+ez[3]+(k1+k2+1)*dz;
	  z[3]	=z1+ez[3]+k1*dz;
	  r1	=cr4*(r[0]+r[1]+r[2]+r[3]);
	  z1	=cr4*(z[0]+z[1]+z[2]+z[3]);
	  dS	=fabs(dS0+(2*k1+1)*dSr-(2*k2+1)*dSz);
	  S	+=dS;
	  MFring(&gy,&br,&bz,r0,z0,r1,z1,dS);
	  dgY	+=gy;
	  dBr	+=br;
	  dBz	+=bz;
	}
      }
      dS	=VVC[m].I*lS->tn/S;
      gY1	+=dgY*dS;
      Br1	+=dBr*dS;
      Bz1	+=dBz*dS;
    }
  }
#endif
  *gY		=Y   ;
  *gYr		=Yr  ;
  *gYz		=Yz  ;
  *gYrr		=Yrr ;
  *gYrz		=Yrz ;
  *gYzz		=Yzz ;
  *gYrrz	=Yrrz;
  *gYrzz	=Yrzz;
  return(0);
}

int PFCgYMF1(double *gY,double *gYr,double *gYz,double r, double z)
{
  int m,mr,mz,nr,nz;
  double h,Br,Bz,r0,z0,hr,hz;

  double gy,s,ss;
  double gY0,gY0r,gY0z;

  gY0	=0.;
  gY0r	=0.;
  gY0z	=0.;
  for(m=1; m < nPFB; m++){
    nr	=PFB[m].nr;
    nz	=PFB[m].nz;
    hr	=(Rb2[m]-Rb1[m])/nr;
    hz	=(Zb2[m]-Zb1[m])/nz;
    h	=PFC[PFB[m].kC].I*PFB[m].tn/(nr*nz);
    r0	=Rb1[m]+hr*0.5;
    for(mr=0; mr < nr; mr++){
      z0=Zb1[m]+hz*0.5;
      for(mz=0; mz < nz; mz++){
	gYdY(&gy,&Br,&Bz,&s,&ss,r,z,r0,z0);
	gY0	+=gy*h;
	gY0r	+=Br*h;
	gY0z	+=Bz*h;
	z0 	+=hz;
      }
      r0 +=hr;
    } 
  }
  *gY	=gY0;
  *gYr	=gY0r;
  *gYz	=gY0z;
  return(0);
}

int SplLijPlPFC()
{
  int i,j,i0,j0,i1,j1;
  double gY,gYr,gYz,err,err1,gY0,gY1;

  err	=0.;
  err1	=0.;
  i0	=0;
  j0	=0;
  i1	=0;
  j1	=0;
  for(i=0; i < EGNp; i++){
    SetSplXY(EGaRp[i],EGaZp[i]);
    SetSplgYCell();
    for(j=1; j < nPFC; j++){
      PFCgY0Spl(&gY,&gYr,&gYz,j);
      gYr	=fabs(gY-gYpC[i][j]);
      if(EGkA[i] && err < gYr){
	err	=gYr;
	i0	=i;
	j0	=j;
	gY0	=gYpC[i][j];    
      }
      gYpC[i][j]	=gY;
    }
    for(j=0; j < nVVC; j++){
      PFCgY0Spl(&gY,&gYr,&gYz,j+nPFC);
      gYr	=fabs(gY-gYpS[i][j]);
      if(EGkA[i] && err1 < gYr){
	err1	=gYr;
	i1	=i;
	j1	=j;
	gY1	=gYpS[i][j];    
      }
      gYpS[i][j]	=gY;
    }
  }
#ifdef H
  if(nPFC){
    printf("Inaccuracy in gYpC: err[%d][%d]=%10.3e gY=%10.3e %10.3e\n"
	   ,i0,j0,err,gYpC[i0][j0],gY0);
    printf("R[%d]=%7.5f Z=%8.5f\n",i0,EGaRp[i0],EGaZp[i0]);
  }
  if(nVVC){
    printf("Inaccuracy in gYpS: err[%d][%d]=%10.3e gY=%10.3e %10.3e\n"
	   ,i1,j1,err1,gYpS[i1][j1],gY1);
    printf("R[%d]=%7.5f Z=%8.5f\n",i1,EGaRp[i1],EGaZp[i1]);
  }
#endif
  return(0);
}

#undef Ins4a
int PFCSplD()
{
  static int Fl=1;
  int i,k,n,kk[4];
  double s;
  
  nPEC	=nPFC+nVVC;
  ReInitSplB();
  if(Fl){
    DefaultSplD();
    Fl	=0;
  }
#ifndef AscI4a
#undef AscI4a
#endif/*AscI4a*/
  for(i=0; i < 4; i++){
    kk[i]	=i < nDSpl ? 0 : 1;
  }
  nXSpl[0] =PFB->nr;
  nYSpl[0] =PFB->nz;
  XDSpl1[0]=PFB->r[0];
  XDSpl2[0]=PFB->r[1];
  YDSpl1[0]=PFB->z[0];
  YDSpl2[0]=PFB->z[1];
#ifndef Tbl4a
  k	=0;
  for(i=0; i < 4; i++){
    if(kk[i] == 0) k++;
  }

  if(nDSpl != k){
    nDSpl	=k;
    ReInitSplB();
  }
  k	=0;
  for(i=0; i < 4; i++){
    if(kk[i] == 0){
      n	=nXSpl[i];
      nXSpl[i] =nXSpl[k];
      nXSpl[k] =n;
      n	=nYSpl[i];
      nYSpl[i] =nYSpl[k];
      nYSpl[k] =n;

      s	=XDSpl1[i];
      XDSpl1[i]=XDSpl1[k];
      XDSpl1[k]=s;
      s	=XDSpl2[i];
      XDSpl2[i]=XDSpl2[k];
      XDSpl2[k]=s;
      s	=YDSpl1[i];
      YDSpl1[i]=YDSpl1[k];
      YDSpl1[k]=s;
      s	=YDSpl2[i];
      YDSpl2[i]=YDSpl2[k];
      YDSpl2[k]=s;
      dXDSpl[k] =XDSpl2[k]-XDSpl1[k];
      dYDSpl[k] =YDSpl2[k]-YDSpl1[k];
      dXDSpl[i] =XDSpl2[i]-XDSpl1[i];
      dYDSpl[i] =YDSpl2[i]-YDSpl1[i];
      k++;
    }
  }
#undef Ins4b
#endif/*Tbl4a*/
#ifndef AscO4a
#undef AscO4a
#endif/*AscO4a*/
  iDSpl	=nDSpl;
  ReInitSplCell();
  ReInitPFCgYSpl();
  SetPFCSplGeom();
  k	=1;
#ifndef BnrI4a
#undef BnrI4a
#endif/*BnrI4a*/
  if(k) SetPFCSpl();
#ifndef BnrO4a
#undef BnrO4a
#endif/*BnrO4a*/
  SplLijPlPFC();
  return(0);
}

static char Comment[32];
int ExtMFAI(FILE *lF)
{
  int m;
  double s;

  fscanf(lF,"%s",Comment);
  puts(Comment);
  for(m=1; m < nPFC; m++){
    if(fscanf(lF,"%lg",&s) < 1) break;
    PFC[m].I=0.001*s;
  }
  return(0);
}


int ExtMField()
{
  int i,j,k,Fl,iNxt;
  char ln[128];
  double R[nPEC],Z[nPEC],R1,R2,Z1,Z2;
  char *NmB[nPEC],Nm0[8]=">---<";
  double r,z,gY,gYr,gYz,gY0,gYr0,gYz0;
  double Br,Bz;
  double dr=0.,dz=0.;
  double *ld;
  extern void IbPFIPlot();

  r	=cr2*(XDSpl1[0]+XDSpl2[0]);
  z	=cr2*(YDSpl1[0]+YDSpl2[0]);
  iDSpl	=nDSpl;

#ifdef JET
  printf("%6s %7s %13s %12s %12s\n","r","z","gY","Br","Bz");
#endif

  Fl=0;
  iNxt=0;
#ifndef Tbl5a
  if(Fl){
#ifndef AscI_ExtMF
#undef AscI_ExtMF
#endif/*AscI_ExtMF*/
  }

  R1	=XDSpl1[0];
  R2	=XDSpl2[0];
  Z1	=YDSpl1[0];
  Z2	=YDSpl2[0];
  for(i=1; i < nDSpl; i++){
    if(R1 > XDSpl1[i]) R1=XDSpl1[i];
    if(R2 < XDSpl2[i]) R2=XDSpl2[i];
    if(Z1 > YDSpl1[i]) Z1=YDSpl1[i];
    if(Z2 < YDSpl2[i]) Z2=YDSpl2[i];
  }
  if(iNxt){
    r	+=dr;
    z	+=dz;
  }

#ifndef JET
  if(r < R1) r=R1;
  if(r > R2) r=R2;
  if(z < Z1) z=Z1;
  if(z > Z2) z=Z2;
#endif
  for(i=0; i < nPFC; i++){
    j		=PFC[i].kB[0];
    NmB[i]	=PFC[i].Nm;
    R[i]	=PFB[j].R;
    Z[i]	=PFB[j].Z;
  }
  for(j=0; j < nVVC; j++,i++){
    k	=VVC[j].kB[0];
    ld	=VVB[k].r;
    R[i]	=cr4*(ld[0]+ld[1]+ld[2]+ld[3]);
    ld		=VVB[k].z;
    Z[i]	=cr4*(ld[0]+ld[1]+ld[2]+ld[3]);
    NmB[i]	=VVC[j].Nm;
  }
#ifndef JET
  SetSplXY(r,z);
  SetSplgYCell();
  PFCgYSpl(&gY,&gYr,&gYz);
  CbStr2UserMessage("gY=%13.6e %12.5e %12.5e\n",gY,gYr,gYz);
  printf("%6.4f %7.4f %13.6e %12.5e %12.5e\n",r,z,gY,gYr,gYz);
#endif

  SetSplXY(r,z);
  SetSplgYCell();
  PFCgYSpl(&gY,&gYr,&gYz);
  Br	=-gYz/(c2gp*r);
  Bz	=gYr/(c2gp*r);
  CbStr2UserMessage("gY=%13.6e %12.5e %12.5e\n",gY,Br,Bz);
#ifdef H
  printf("%6.4f %7.4f %13.6e %12.5e %12.5e\n",r,z,gY,Br,Bz);
#endif
  PFCgYMF(&gY,&Bz,&Br,r,z);
#ifndef JET
  sprintf(ln+43,"gY=%13.6e %12.5e %12.5e",gY,Br,Bz);
#else
  CbStr2UserMessage("gY=%13.6e %12.5e %12.5e",gY,Br,Bz);
  printf("%6.4f %7.4f %13.6e %12.5e %12.5e\n",r,z,gY,Br,Bz);
#endif
  CbUserPlot	=IbPFIPlot;
#endif/*Tbl5a*/
  return(0);
}

int PFInitBasicFunctions()
{
  int k;

  fcsP	=fcs+15;
  d2fcsP=d2fcs+15;
  for(k=0; k < 21; k++){
    fcs[k]	=(double*)malloc(2*ESNa1*sizeof(double));
    d2fcs[k]	=fcs[k]+ESNa1;
  }
  xSplPF	=(double*)malloc(ESNa1*sizeof(double));
  ESmemlevP |=0x00000008;
  return(0);
}

int PFDeInitBasicFunctions()
{
  int k;

  free(xSplPF);
  for(k=0; k < 21; k++) free(fcs[k]);
  fcsP	=NULL;
  return(0);
}

int PFFirstSetSplWrong()	/* cos2n\gp a^2, sin2n\gp a^2 */
{
  int i,k;
  double x,xx,df0,df1;

  if(fcsP == NULL) PFInitBasicFunctions();

  x	=(1.-ESa0)/ ESNa;
  for(i=0; i < ESNa1; i++){
    xSplPF[i]	=ESa0+x*i;
    fcs[0][i]	=1.;
    d2fcs[0][i]	=0.;
    fcsP[0][i]	=1.;
    d2fcsP[0][i]=0.;
  }
  df0	=0.;

  for(k=1; k < 8; k++){
    df1	=k*c2gp;
    for(i=0; i < ESNa1; i++){
      x	=xSplPF[i]-ESa0;
      xx=df1*x*x;
      fcs[2*k-1][i]	=sin(xx);
      fcs[2*k][i]	=cos(xx);
    }
    i	=ESNa;
    df1	*=2.*fcs[2*k][i];
    spl(fcs[2*k-1],d2fcs[2*k-1],&df0,&df1,xSplPF,&i);
    df1	=0.;
    spl(fcs[2*k],d2fcs[2*k],&df0,&df1,xSplPF,&i);
  }

  for(k=1; k < 6; k++){
    x	=fcs[k][ESNa];
    for(i=0; i < ESNa1; i++){
      fcsP[k][i]	=fcs[k][i]-x;
      d2fcsP[k][i]	=d2fcs[k][i];
    }
  }

  PFwrP[0]	=0.;
  for(k=1; k < 21; k++){
    df0	=0.;
    for(i=0; i < ESNa1; i++){
      x		=d2fcs[k][i];
      df0	+=x*x;
    }
    PFwrP[k]	=0.001*df0/20.;
  }

  iSplPF	=0;
  iSplPF1	=1;
  crxPF		=xSplPF[1]-xSplPF[0];
  cHxPF		=cr6*crxPF*crxPF;
  crxPF		=1./crxPF;
  iSplPFold	=0;
  return(0);
}

int PFFirstSetSpl02()	/* cos n\gp a^2, sin n\gp a^2 */
{
  int i,k;
  double x,xx,df0,df1;

  if(fcsP == NULL) PFInitBasicFunctions();

  x	=(1.-ESa0)/ ESNa;
  for(i=0; i < ESNa1; i++){
    xSplPF[i]	=ESa0+x*i;
    fcs[0][i]	=1.;
    d2fcs[0][i]	=0.;
    fcsP[0][i]	=1.;
    d2fcsP[0][i]=0.;
  }
  df0	=0.;

  for(k=1; k < 8; k++){
    df1	=k*cgp;
    for(i=0; i < ESNa1; i++){
      x	=xSplPF[i]-ESa0;
      xx=df1*x*x;
      fcs[2*k-1][i]	=sin(xx);
      fcs[2*k][i]	=cos(xx);
    }
    i	=ESNa;
    df1	*=2.*fcs[2*k][i];
    spl(fcs[2*k-1],d2fcs[2*k-1],&df0,&df1,xSplPF,&i);
    df1	=0.;
    spl(fcs[2*k],d2fcs[2*k],&df0,&df1,xSplPF,&i);
  }

  for(k=1; k < 6; k++){
    x	=fcs[k][ESNa];
    for(i=0; i < ESNa1; i++){
      fcsP[k][i]	=fcs[k][i]-x;
      d2fcsP[k][i]	=d2fcs[k][i];
    }
  }

  PFwrP[0]	=0.;
  for(k=1; k < 21; k++){
    df0	=0.;
    for(i=0; i < ESNa1; i++){
      x		=d2fcs[k][i];
      df0	+=x*x;
    }
    PFwrP[k]	=0.001*df0/20.;
  }

  iSplPF	=0;
  iSplPF1	=1;
  crxPF		=xSplPF[1]-xSplPF[0];
  cHxPF		=cr6*crxPF*crxPF;
  crxPF		=1./crxPF;
  iSplPFold	=0;
  return(0);
}

int PFFirstSetSpl0()	/* cos n\gp a/2 */
{
  int i,k;
  double x,xx,df0,df1;

  if(fcsP == NULL) PFInitBasicFunctions();

  x	=(1.-ESa0)/ ESNa;
  for(i=0; i < ESNa1; i++){
    xSplPF[i]	=ESa0+x*i;
    fcs[0][i]	=1.;
    d2fcs[0][i]	=0.;
    fcsP[0][i]	=1.;
    d2fcsP[0][i]=0.;
  }
  df0	=0.;
  for(k=1; k < 15; k++){
    df1	=0.5*k*cgp;
    for(i=0; i < ESNa1; i++) fcs[k][i] =cos(df1*xSplPF[i]);
    i	=ESNa;
    df1	*=-sin(df1*xSplPF[i]);
    spl(fcs[k],d2fcs[k],&df0,&df1,xSplPF,&i);
  }

  for(k=1; k < 6; k++){
    x	=fcs[k][ESNa];
    for(i=0; i < ESNa1; i++){
      fcsP[k][i]	=fcs[k][i]-x;
      d2fcsP[k][i]	=d2fcs[k][i];
    }
  }

  PFwrP[0]	=0.;
  for(k=1; k < 21; k++){
    df0	=0.;
    for(i=0; i < ESNa1; i++){
      x		=d2fcs[k][i];
      df0	+=x*x;
    }
    PFwrP[k]	=0.001*df0/20.;
  }

  iSplPF	=0;
  iSplPF1	=1;
  crxPF		=xSplPF[1]-xSplPF[0];
  cHxPF		=cr6*crxPF*crxPF;
  crxPF		=1./crxPF;
  iSplPFold	=0;
  return(0);
}


int PFFirstSetSpl2()	/* spline of \gd{x-x_k} */
{
  int i,k;
  double x,xx,df0,df1;

    if(fcsP == NULL) PFInitBasicFunctions();

  x	=(1.-ESa0)/ ESNa;
  for(i=0; i < ESNa1; i++){
    xSplPF[i]	=ESa0+x*i;
    fcs[0][i]	=1.;
    d2fcs[0][i]	=0.;
    fcsP[0][i]	=1.;
    d2fcsP[0][i]=0.;
  }
  df0	=0.;

  for(k=1; k < 8; k++){
    df1	=k*cgp;
    for(i=0; i < ESNa1; i++){
      x	=xSplPF[i]-ESa0;
      xx=df1*x*x;
      fcs[2*k-1][i]	=sin(xx);
      fcs[2*k][i]	=cos(xx);
    }
    i	=ESNa;
    df1	*=2.*fcs[2*k][i];
    spl(fcs[2*k-1],d2fcs[2*k-1],&df0,&df1,xSplPF,&i);
    df1	=0.;
    spl(fcs[2*k],d2fcs[2*k],&df0,&df1,xSplPF,&i);
  }

  for(k=1; k < 6; k++){
    x	=fcs[k][ESNa];
    for(i=0; i < ESNa1; i++){
      fcsP[k][i]	=fcs[k][i]-x;
      d2fcsP[k][i]	=d2fcs[k][i];
    }
  }

  PFwrP[0]	=0.;
  for(k=1; k < 21; k++){
    df0	=0.;
    for(i=0; i < ESNa1; i++){
      x		=d2fcs[k][i];
      df0	+=x*x;
    }
    PFwrP[k]	=0.001*df0/20.;
  }

  iSplPF	=0;
  iSplPF1	=1;
  crxPF		=xSplPF[1]-xSplPF[0];
  cHxPF		=cr6*crxPF*crxPF;
  crxPF		=1./crxPF;
  iSplPFold	=0;
  return(0);
}

int Point2BasicFunctions(double **y, double **d2y,int k)
{
  *y	=fcs[k];
  if(d2y != NULL) *d2y=d2fcs[k];
  return(0);
}

int PFGetBasicFunctionsJ(double *y, double *d2y,int k)
{
  int i;
  
  for(i=0; i < ESNa1; i++){
    y[i]	=fcs[k][i];
    if(d2y != NULL) d2y[i]=d2fcs[k][i];
  }
  return(0);
}

int PFGetBasicFSetAtPoint(double *y, double *d2y,int i,int nKj)
{
  int k,kk;

  for(k=0; k < nKj; k++){
    y[k]	=fcs[k][i];
    if(d2y != NULL) d2y[k]=d2fcs[k][i];
  }
  return(0);
}

int PFGetBasicFunctionsP(double *y, double *d2y,int k)
{
  int i;
  
  for(i=0; i < ESNa1; i++){
    y[i]	=fcsP[k][i];
    if(d2y != NULL) d2y[i]=d2fcsP[k][i];
  }
  return(0);
}

int PFFirstSetSpl()	/* Simple zero edge x^2 polynomes */
{
  int i,k;
  double x,xx,df0,df1;
  double *ld0,*ld2;

  if(fcsP == NULL) PFInitBasicFunctions();
  PFwrP[0]	=0.;
  PFwrP[0]	=1.;
  x	=(1.-ESa0)/ESNa;
  for(i=0; i < ESNa1; i++){
    xSplPF[i]	=ESa0+x*i;
    fcs[0][i]	=1.;
    d2fcs[0][i]	=0.;
  }
  df0	=0.;
  for(k=1; k < 15; k++){
    for(i=0; i <  ESNa1; i++){
      x	=xSplPF[i]-ESa0;
      fcs[k][i]	=fcs[k-1][i]*x*x;
    }
    i	= ESNa;
    df1	=2.*k;
    spl(fcs[k],d2fcs[k],&df0,&df1,xSplPF,&i);
    PFwrP[k]	=1.;
    PFwrP[k]	=2.*k*(2.*k-1.);
  }
  for(k=1; k < 15; k++){		/* Zero edge polynoms */
    for(i=0; i <  ESNa1; i++) fcs[k][i] -=1.;
  }
  for(k=0; k < 6; k++){
    for(i=0; i < ESNa1; i++){
      fcsP[k][i]	=fcs[k][i];
      d2fcsP[k][i]	=d2fcs[k][i];
    }
    PFwrP[k+15]	=PFwrP[k];
  }
  iSplPF	=0;
  iSplPF1	=1;
  crxPF		=xSplPF[1]-xSplPF[0];
  cHxPF		=cr6*crxPF*crxPF;
  crxPF		=1./crxPF;
  iSplPFold	=0;
  return(0);
}

int PFFirstSetSpl1()	/* Polynomials of (1-x^2)^n */
{
  int i,k;
  double x,xx,df0,df1;
  double *ld0,*ld2;
  double A[ESNa1];

  if(fcsP == NULL) PFInitBasicFunctions();
  PFwrP[0]	=0.;
  PFwrP[0]	=1.;
  x	=(1.-ESa0)/ESNa;
  for(i=0; i < ESNa1; i++) xSplPF[i]=ESa0+x*i;

  for(i=0; i < ESNa1; i++) A[i]=1.;
  df0	=0.;
  for(k=0; k < 15; k++){
    for(i=0; i <  ESNa1; i++){
      x	=xSplPF[i];
      A[i]	*=1.-x*x;
      fcs[k][i]	=A[i];
    }
    i	= ESNa;
    df1	=k ? 0. : -2.*(k+1);
    spl(fcs[k],d2fcs[k],&df0,&df1,xSplPF,&i);
    df1	=0;
    for(i=0; i <  ESNa1; i++)df1+=d2fcs[k][i];
    PFwrP[k]	=fabs(df1)/ESNa;
  }
  for(k=0; k < 6; k++){
    for(i=0; i < ESNa1; i++){
      fcsP[k][i]	=fcs[k][i];
      d2fcsP[k][i]	=d2fcs[k][i];
    }
    PFwrP[k+15]	=PFwrP[k];
  }
  iSplPF	=0;
  iSplPF1	=1;
  crxPF		=xSplPF[1]-xSplPF[0];
  cHxPF		=cr6*crxPF*crxPF;
  crxPF		=1./crxPF;
  iSplPFold	=0;
  return(0);
}

int PFBasicFPlot(int K,int FlP)
{
  int k;
  double x[2],y[2];
  int iW=2;
  char ln[0x40];

  x[0]	=0.;
  x[1]	=1.;
  y[0]	=-1.;
  y[1]	=1.1;
  if(FlP){
    static int inx=1,iny=1;
    static int kPS=1;
    static char PSFileNm[16];
    if(FlP > 1){
      if(FlP != 4){
	inx	=FlP-1;
	iny	=FlP-1;
      }
      else{
	inx	=4;
	iny	=4;
      }
    }
    if(kPS && *ShotNm != '\0'){
      sprintf(PSFileNm,"%s.ps",ShotNm);
      PSSetFileName(PSFileNm);
      kPS	=0;
    }
    PSFileOpen(inx,iny);
  }

  sprintf(ln,"f_m i0=%d i1=%d %d<= m <%d",0,ESNa1,0,K);
  SetPlotName("a",ln,"Basic functions");
  Scale2d(iW,x,y,2,6,2);

  if(FlP) PSNewFrame();
  for(k=0; k < K; k++){
    Plot2d(iW,xSplPF,fcs[k],ESNa1,6,0,kCol[k%8],0);
    if(FlP){
      PSSetLineWidth(2.);
      PSPlot2d(xSplPF,fcs[k],ESNa1,6,0,kCol[k%8],0);
      PSSetLineWidth(.3);
    }
  }
  if(FlP) PSFileClose();
  return(0);
}

int PFBasicJPlot()
{
  int k;
  double x[2],y[2];

  x[0]	=0.;
  x[1]	=1.;
  y[0]	=-1.;
  y[1]	=1.;
  Scale2d(2,x,y,2,6,2);
  for(k=0; k < 10; k++) Plot2d(2,xSplPF,fcs[k],ESNa1,6,0,4,0);
  return(0);
}

int PFSetSplPF(double A)
{
  if(A > 1.){
    A	=1.;
  }
  if(A < ESa0){
    A	=ESa0;
  }
  while(iSplPF < ESNa && xSplPF[iSplPF+1] < A){
    iSplPF++;
  }
  while(iSplPF > 0 && xSplPF[iSplPF] > A){
    iSplPF--;
  }
  if(iSplPFold	!= iSplPF){
    iSplPFold	=iSplPF;
    iSplPF1	=iSplPF+1;
  }
  SplPFx	=(A-xSplPF[iSplPF])*crxPF;
  SplPFxx	=SplPFx*SplPFx;

  SplPFX	=1.-SplPFx;
  SplPFXX	=SplPFX*SplPFX;
  return(0);
}

int PFSplR(double*f,double*df,int k)
{
  double *d0,*d2;

  d0	=fcs[k];
  d2	=d2fcs[k];
  *f	=SplPFX*d0[iSplPF]+SplPFx*d0[iSplPF1]
    +(SplPFX*(SplPFXX-1.)*d2[iSplPF]+SplPFx*(SplPFxx-1.)*d2[iSplPF1])*cHxPF;
  if(df != NULL){
    *df	=(d0[iSplPF1]-d0[iSplPF]+
	  ((3.*SplPFxx-1.)*d2[iSplPF1]-(3.*SplPFXX-1.)*d2[iSplPF])*cHxPF)
      *crxPF;
  }
  return(0);
}

int PFSplRA(double*f, double*df,int k)
{
  splRA(f,df,fcs[k],d2fcs[k]);
  return(0);
}

int gYdYd2Yd3YPFC(double *gY,double *gYr,double *gYz
		  ,double *gYrr,double *gYrz,double *gYzz
		  ,double *gYrrz,double *gYzzr,double r0,double z0)
{
  int m,mr,mz,nr,nz;
  int kC,kB,nB;
  double h,hr,hz,r1,z1;
  double gy,gyr,gyz,gyrr,gyrz,gyzz,gyrrz,gyzzr;
  double Y,Yr,Yz,Yrr,Yrz,Yzz,Yrrz,Yzzr;
  int *li;
  PSBLOCK *lS;

  *gY	=0.;
  *gYr	=0.;
  *gYz	=0.;
  *gYrr=0.;
  *gYzz=0.;
  *gYrz=0.;
  *gYrrz=0.;
  *gYzzr=0.;
  for(kC=1; kC < nPFC; kC++){
    nB	=PFC[kC].nB;
    li	=PFC[kC].kB;
    for(kB=0; kB < nB; kB++){
      m		=li[kB];
      nr	=PFB[m].nr;
      hr	=(Rb2[m]-Rb1[m])/nr;
      nz	=PFB[m].nz;
      hz	=(Zb2[m]-Zb1[m])/nz;
      r1	=Rb1[m]+hr*0.5;
      Y	=0.;
      Yr=0.;
      Yz=0.;
      Yrr=0.;
      Yzz=0.;
      Yrz=0.;
      Yrrz=0.;
      Yzzr=0.;
      for(mr=0; mr < nr; mr++){
	z1	=Zb1[m]+hz*0.5;
	for(mz=0; mz < nz; mz++){
	  gYdYd2Yd3Y(&gy,&gyr,&gyz,&gyrr,&gyrz,&gyzz,&gyrrz,&gyzzr
		     ,r0,z0,r1,z1);
	  Y	+=gy;
	  Yr	+=gyr;
	  Yz	+=gyz;
	  Yrr	+=gyrr;
	  Yzz	+=gyzz;
	  Yrz	+=gyrz;
	  Yrrz	+=gyrrz;
	  Yzzr	+=gyzzr;
	  z1 +=hz;
	}
	r1 +=hr;
      } 
      h	=PFC[kC].I*PFB[m].tn/(nr*nz);
      *gY   +=Y*h;
      *gYr  +=Yr*h;
      *gYz  +=Yz*h;
      *gYrr +=Yrr*h;
      *gYzz +=Yzz*h;
      *gYrz +=Yrz*h;
      *gYrrz+=Yrrz*h;
      *gYzzr+=Yzzr*h;
    }
  }
  return(0);
}

#endif
#endif
#endif
