typedef struct TBLB{
  char*nm;
  int nM;
  struct TMZL*M;
}TBLB;

typedef struct TMZL{
  char*nm;
  int nB;
  int nS;
  struct TBLB*B;
  char**S;
}TMZL;

#define LBLBID 8
typedef struct STG{
  char *Nm;	/* Name */
  char *TF;	/* Target file name */
  char *SF;	/* Source file name */
  char *Tt;	/* ???? */
  char *Tb;	/* Tbl Source file name */
  char *Hlp;	/* Help text */
  int m;	/* Acting Mode switch in OCPanel:
		   |________|________|________|________|;
		   |       Bitwize mode       |A P     |;
		   A m&0x80 - On/Off switch;
		   P m&0x7f - visible switch;
		   */
  int O;	/* Acting Output switch in OCPanel:
		   |________|________|________|________|;
		   |       Bitwize mode       |  P     |;
		   P m&0xff - visible switch;
		   */
  int I;	/* Acting Input switch in OCPanel */
  int mt;	/* Given Mode switch in Output CPanel */
  int Ot;	/* Given Output switch in Output CPanel */
  int It;	/* Given Input switch in Output CPanel */

  int iB;	/* Parent  blb */
  int iM;	/* Parent  mzl */

  int im;
  int iO;
  int iI;
  int imt;	/* Given Mode switch in Input CPanel */
  int iOt;	/* Given Output switch in Input CPanel */
  int iIt;	/* Given Input switch in Input CPanel */


  /* X related stuff */
  int iC;
  int jC;
}STG;

typedef struct MZL{
  char *Nm;	/* Name */
  char *TF;	/* Target file name */
  char *SF;	/* Source file name */
  char *Tt;	/* ???? */
  char *Tb;	/* Tbl Source file name */
  char *Hlp;	/* Help text */

  int m;	/* Acting Mode switch in OCPanel:
		   |________|________|________|________|;
		   |       Bitwize mode       |A P     |;
		   A m&0x80 - On/Off switch;
		   P m&0x7f - visible switch;
		   */
  int O;	/* Acting Output switch in OCPanel:
		   |________|________|________|________|;
		   |       Bitwize mode       |  P     |;
		   P m&0xff - visible switch;
		   */
  int I;	/* Acting Input switch in OCPanel */
  int mt;	/* Given Mode switch in Output CPanel */
  int Ot;	/* Given Output switch in Output CPanel */
  int It;	/* Given Input switch in Output CPanel */

  int im;
  int iO;
  int iI;
  int imt;	/* Given Mode switch in Input CPanel */
  int iOt;	/* Given Output switch in Input CPanel */
  int iIt;	/* Given Input switch in Input CPanel */
  int iB;	/* Parent  blb */


  int nB;	/* total number of child blb's */
  int nS;	/* total number of child stg's */
  int *S;	/* indexes of child stg's */
  int *B;	/* indexes of child blb's */
  int *kB;	/* positions of blb's among stg's in mzl's*/

  /* X related stuff */
  int iC;
  int jC;
}MZL;

typedef struct BBLB{
  char *Nm;	/* Name */
  char *TF;	/* Target file name */
  char *SF;	/* Source file name */
  char *Tt;	/* ???? */
  char *Tb;	/* Tbl Source file name */
  char *Hlp;	/* Help text */
  int m;	/* Acting Mode switch in OCPanel:
		   |________|________|________|________|;
		   |       Bitwize mode       |A P     |;
		   A m&0x80 - On/Off switch;
		   P m&0x7f - visible switch;
		   */
  int O;	/* Acting Output switch in OCPanel:
		   |________|________|________|________|;
		   |       Bitwize mode       |  P     |;
		   P m&0xff - visible switch;
		   */
  int I;	/* Acting Input switch in OCPanel */
  int mt;	/* Given Mode switch in Output CPanel */
  int Ot;	/* Given Output switch in Output CPanel */
  int It;	/* Given Input switch in Output CPanel */

  int im;
  int iO;
  int iI;
  int imt;	/* Given Mode switch in Input CPanel */
  int iOt;	/* Given Output switch in Input CPanel */
  int iIt;	/* Given Input switch in Input CPanel */

  int iB;	/* Parent  blb */
  int iM;	/* Parent  mzl */
  int kB;	/* Position in Parent mzl among stg's and blb's*/
  int dDB;	/* Depth of block in Data Base */
  int dCb;	/* Depth in Cb structure */

  char OD[LBLBID+1];	/* Output directory */
  char ID[LBLBID+1];	/* Input directory */
  double t[3];	/* record parameters of blb-file */

  char *lO;	/* Path for Output directory */
  char *lI;	/* Path for Input directory */

  int LO;	/* String length of *lO */
  int LI;	/* String length of *lI */
  int nM;	/* total number of child mzl's */
  int *M;	/* index of child mzl's */

  /* X related stuff */
  int s;	/* Visibility state:
		   0 - blb is visible;
		   1 - xM mzl is visible;
		   2 - blb is hidden. */
  int xM;       /* Visible mzl on the CPanel */
  int iC;	/*  ? */
  int jC;	/*  ? */
  int jD;	/*  ? */
}BBLB;

typedef struct BLB{
  int iB,iM,kS;
  int s,mB,OB,IB,mBt,OBt,IBt,iCB,jCB,jDB;
  int imB,iOB,iIB,imBt,iOBt,iIBt;
  char*NmB;
  char OD[LBLBID+1];
  char ID[LBLBID+1];
  double t[3];
  char*NmBTF,*NmBSF;
  char*TtB;
  char*TbB;
  char*path;
  char*pathI;
  int Lpath;
  int LpathI;
  int dDB;	/* depth in DataBase */
  int dCb;	/* depth in Cb structure */
  char*HpB;

  int xM,nM;
  int*mM,*OM,*IM,*mMt,*OMt,*IMt,*iCM,*jCM;
  int*imM,*iOM,*iIM,*imMt,*iOMt,*iIMt;
  int*iMB,*iMM;

  char**NmM,**NmMTF,**NmMSF;
  char**TtM;
  char**TbM;
  char**bTbM;
  char**eTbM;
  char**HpM;

  int*nS;
  int**mS,**OS,**IS,**mSt,**OSt,**ISt,**iCS,**jCS;
  int**imS,**iOS,**iIS,**imSt,**iOSt,**iISt;
  char***NmS,***NmSTF,***NmSSF;
  char***TtS;
  char***TbS;
  char***bTbS;
  char***eTbS;
  char***HpS;

  int*nB;
  int**kB;
  int**nxtB;
}BLB;

typedef struct InpTblPar{
  int W;	/* Window */
  unsigned int mode;	/* mode */
  int iB;	/* Blb numbers */
  int iM;	/* Mzl numbers */
  int iS;	/* Stg numbers */
  int iT;	/* Tbl numbers */
  char *Nm;	/* Name of the Table */
  char *SF;	/* Name of the source file */
  char *Beg;	/* Pointer to beginning of the Table scope */
  char *End;	/* Pointer to the end of the Table scope */
  int nL;	/* Number of lines in the Table */
  int NP;	/* Total number of parameters in the Table */
  int NPC;	/* Number of PCells */
  int NM;	/* Total number of External Menues in the Table */
  int *nP;	/* Number of parameters in one PCell */
  int *nUP;	/* Index of the Units */
  int *iUP;	/* Number in the list of Units */
  int *iCP;	/* C-Type of parameter
		   |________|________|________|________|;
		   |        |        |        |   gm	;
		   0 - string;
		   1 - double;
		   2 - int;
		   3 - float;
		   4 - long int;
		   0x8 - menu vector;
		   0x10 - graphics;
		   */
  int *iPP;	/* Plotting Index */
  int *cP;	/* Index activity*/
  int *ixP;	/* x - position of the parameter */
  int *iyP;	/* y - position of the parameter */
  int *inP;	/* length of the data cell */

  char **nmP;	/* Name in the parameter in the code:
		   <Name> - ordinary parameter;
		   NULL - external menue parameter;
		   "" - name of internal menue.
		   */
  char **aP;	/* Activity index of the parameter*/
  char **nmEP;	/* Name in the Table */
  char **aEP;	/* Activity simbols of the parameter*/
  char **nmM;	/* Name of Menus in the Table*/
  char **HlpP;	/* Pointer to Help string*/
  char **ScpP;	/* Pointer to the name of scale factor */
  char **P;	/* Addresses of parameter in the code */
  char **P1;	/* Pointer to backup parameters */
  int **vaP;	/* Pointer to values of state of parameters */
  double *scP;	/* Scale factor */

  int NNmV;	/* Total number of vector names in the Table */
  int NNmVC;	/* Number of VCells for vector names in the Table*/
  int NV;	/* Number of vectors in the Table */
  int *nNmV;	/* Number of vector names in one VCell */
  int **cV;	/* Index activity*/

  int *LV;	/* Dimension of vectors in the Table*/
  int *lV;	/* current size of vectors in the Table*/
  int *LaV;	/* Dimension of vectors Indexes in the Table*/
  int *laV;	/* current size of vectors Indexes in the Table*/

  int *nUV;	/* Index of the Units */
  int *iUV;	/* Number in the list of Units */
  int *iCV;	/* C-Type of vector:
		   |________|________|________|________|;
		   |        |        |        |   gm	;
		   0 - string;
		   1 - double;
		   2 - int;
		   3 - float;
		   4 - long int;
		   0x8 - menu vector;
		   0x10 - graphics;
		   */
  int *iPV;	/* Plotting Index */
  int *ixV;	/* x - position of the Vector name */
  int *iyV;	/* y - position of the Vector name */
  int *ivV;	/* vertical orientation Vector cells */
  int *inV;	/* length of the Vector data cell */
  char **nmV;	/* Name in the source file */
  char **aV;	/* Activity index of the Vector*/
  char **nmEV;	/* FUll (code) Vector Name in the Table */
  char **nmEVs;	/* Short (just the name) Vector Name in the Table */
  char **aEV;	/* Activity simbols of the Vector*/
  char **HlpV;	/* Pointer to Help string*/
  char **ScpV;	/* Pointer to the name of scale factor */
  char ***V;	/* Addresses of vector in the code */
  char ***V1;	/* Pointer ot backup parameters */
  int ***vaV;	/* Pointer to values of state of parameters */
  double *scV;	/* Scale factor */
}InpTblPar;

typedef struct PltPar{
  int iT;

  int nP;
  int*i0;
  int*i1;
  int*c;
  int*f;

  int*s;
  int*iX;
  int*iY;
  char**nmP;
  char**opt;
  char**pi0;
  char**pi1;
  char**pc;

  int nM;
  char**nmM;
  int*mV;
  int*iV;

  int nV;
  int*sizeV;
  int*nKV;
  int*nUV;
  int*iUV;
  int*iCV;
  int**kV;
  int**i0V;
  int**i1V;

  char**nmV;
  char**nmEV;
  char**ScpV;
  char***V;
  char***pi0V;
  char***pi1V;
  double**V1;
  double*scV;
}PltPar;

typedef struct RngPar{
  int ni;	/* Number of common for Tbl, Plt integer parameters */
  int nd;	/* Number of common for Tbl, Plt double parameters */
  int	*vi;	/* Values of common for Tbl, Plt integer parameters */
  double*vd;	/* Values of common for Tbl, Plt double parameters */
  char **pvi;	/* Names of common for Tbl, Plt integer parameters */
  char **pvd;	/* Names of common for Tbl, Plt double parameters */
}RngPar;

typedef struct CbUnits{
  char nmU[8];
  char **U;
  char **TU;
  char *pntU;
  int Ln;
  int nU;
  int iU;
  double *scU;
  double sc;
  double rsc;
}CbUnits;

typedef struct CbVectorNm{
  int k;
  char*pi0;
  char*pi1;
  int i0;
  int i1;
  int p;
}CbVectorNm;

typedef struct CbIOPar{
  int iT;
  char*SF;
  char*Beg;
  char*End;
  int N;
}CbIOPar;

typedef struct CbIOVec{
  int id;
  int d;
  char*V;
  int*st;
  char*Nm;
}CbIOVec;

typedef struct CbIOLoop{
  int pL;
  int d;
  int n;
  int N;
  int nV;
  int nL;
  int*kV;
  int*i0V;
  int*stV;

  char**ImV;
  int*kL;
  int**iV;
  int**fV;
  int*t;
  int i0,i1,st;
  char*NmI;
  char*pi0;
  char*pi1;
  char*pst;
  char***piV;
}CbIOLoop;

typedef struct CbIOObj{
  int id;
  int nU;
  int iU;
  int nL;
  double Sc;
  char*NmE;
  char*pSc;
}CbIOObj;

typedef struct CbIOSet{
  int n;
  int k;
  int nP;
  int kP;
  int kS;
  int nV;
  int kV;
  int N;

  int*kO;
  int*i0;
  int*i1;
  int*ki0;
  int*ki1;
}CbIOSet;

typedef struct CbPltSet{
  int n;
  int k;
  int nP;
  int kP;
  int kS;
  int nV;
  int kV;
  int nG;
  int kG;
  int N;

  int*kXO;
  int*kYO;
  int*i0;
  int*i1;
  int*ki0;
  int*ki1;

  int NG;

  int nM;
  char**nmM;
  int*mV;
  int*iV;

  int*c;
  int*f;

  int*s;
  int*pc;
  int*pf;
  int*ps;

  char**nmP;
  char**opt;
}CbPltSet;

typedef struct CbIOGrp{
  int n;
  int nO;
  int nM;
  int*kO;
  int*kM;
  char*Nm;
}CbIOGrp;

typedef struct CbIOMnu{
  int d;
  int nG;
  int*kG;
  char*Nm;
}CbIOMnu;

