#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <X11/Xatom.h>
#include <X11/keysym.h>

typedef struct WinPar{
  Window W;
  char*nm;
  unsigned int mode;
  unsigned int Hlp;
  unsigned int state;
  int iX,iY,iW,iH;
  int ix,iy,iw,ih;
  int iconx,icony;
  double xm,ym,xmx,ymx,x,y,sx,sy;
}WinPar;

typedef struct InputCell{
  int x,y;	/* coordinates of the Cell in terms of display dots */
  int xs;	/* x-coordinate of the Cell Index box */
  int xd;	/* x-coordinate of the Cell Data box */
  int xu;	/* x-coordinate of the Cell Units box */
  int w;	/* total width of the Cell */
  int wn;	/* width of the name */
  int ws;	/* width of the Index */
  int wd;	/* width of the Data box */
  int wu;	/* width of the Unit box */
  int h;	/* height of the Cell */
  int c;	/* - color */
  int ln;	/* length of the name */
  int l;	/* length of the data */
  int lu;	/* length of the Units */
  int nU;	/* Units set */
  int ids;	/* type of the Cell */
  int	*vs;	/* *** */
  char  *pn;	/* pointer to name */
  char	*ps;	/* pointer to the Index */
  char	*ps0;	/* pointer to beginning of the Index */
  char	*pv;	/* pointer to the data */
  char	*pu;	/* pointer to the Unit */
  char	*pH;	/* pointer to Help */
}InputCell;

typedef struct PanelCell{
  int *s;
  int *xM;
  int *m;
  int *O;
  int *I;
  int kW;
  int kO;
  int kI;
  char **pW;
  char **pO;
  char **pI;
  int x,y,w;
  int ids;
  int ln;
  int iB,iM,iS;
  char *pn;
  char *pH;
}PanelCell;

typedef struct XCbMenu{
  int j;	/* Menue Cell Index */
  int d;	/* depth of the Menue element:
		   0 -;	 
		   1 -;
		   */
  int i;	/* Local Menue index of the exposed element */
  int n;	/* Number of elements in the Menue */
  int mb;
  int iV;
  int *p;	/* Table Indexes of Menue elements */ 
  int *m;	/* Indexes of Menues elements */ 
  char *Nm;	/* Name of the Menu element */
}XCbMenu;

