#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#include "CbType.h"

extern int NCbMode,NCbOut,NCbIn;
extern char *CbUAliasMode;
extern char *CbLAliasMode;
extern char *CbUAliasOut;
extern char *CbLAliasOut;
extern char *CbUAliasInp;
extern char *CbLAliasInp;

typedef struct ChList{
  char*p,ch;
  struct ChList*pb,*pf;
}ChList;

static struct stat statbuf;
static ChList*TOC;
static int NTOC= 500,nTOC;

static FILE*fp;
static char*NmF,NmFCb[80],ln[80],NmTF[80],NmCode[33],NmPE[64],NmA[64];
static char*Buff,*pBuff,**BBuff,**NmTFiles;
static int NBuff,nBuff,NTargF= 5,nTargF,iTargF;
static int Lstr= 132;
static int FlagMain= 0;

static char**RefElem,**RefAddr;
static int*iRef,NRef= 10,nRef;

static int nBlb=0,nMzl=0,nStg=0;
static BBLB *Blb;
static STG *Stg;
static MZL *Mzl;

char*CbMakeCbFile(char*argv1,char*argv2)
{
  int i,CorF;
  char *p;

  CbExchangeBlb(&nBlb,&Blb,&nMzl,&Mzl,&nStg,&Stg);
  strcpy(NmCode,argv2);
  
  TOC= (ChList*)malloc((size_t)(NTOC*sizeof(ChList)));
  FailureAlarm(TOC," - no memory for TOC in CbMakeCbFile");
  nTOC= 0;
  TOC[nTOC].pb= NULL;
  TOC[nTOC].pf= NULL;
  
  BBuff= (char**)malloc((size_t)(2*NTargF*sizeof(char*)));
  FailureAlarm(BBuff," - no memory for BBuff in CbMakeCbFile");
  NmTFiles= BBuff+NTargF;

  RefElem= (char**)malloc((size_t)(NRef*sizeof(char*)));
  RefAddr= (char**)malloc((size_t)(NRef*sizeof(char*)));
  iRef= (int*)malloc((size_t)(NRef*sizeof(int)));
  for(i= 0;i<NRef;i++){
    iRef[i]= 0;
  }
  nRef= 0;
  iTargF= 0;
  nTargF= 0;
  AddNmTFile(argv1);
  
  while(iTargF < nTargF){
    NmF= NmTFiles[iTargF];
    fp= fopen(NmF,"r");
    if(fp==NULL){
      printf("%s does not exist\n",NmF);
      exit(1);
    }
    p= NmF+strlen(NmF)-1;
    switch(*p){
    case 'c':
    case 'C':
      CorF= 0;
      break;
    case 'f':
    case 'F':
      CorF= 1;
      break;
    default:
      CorF= 0;
      break;
    }

    NBuff	=2000;
    Buff	=(char*)malloc((size_t)(NBuff*sizeof(char)));
    FailureAlarm(Buff," - no memory for Buff in CbMakeCbFile");
    pBuff	=Buff;
    nBuff	=0;
    
    if(CorF==0){
      i	=FillBuffC();
    }
    else{
      i	=FillBuffF();
    }
    
    if(FlagMain==0){
      printf("%s\n",Buff);
      printf("main() or PROGRAM  has not been found%c\n",7);
      free(Buff);
      for(i= 0;i<nTargF;i++)
	free(NmTFiles[i]);
      free(BBuff);
      free(TOC);
      exit(1);
    }
    if(i){
      printf("%s\n",Buff+strlen(Buff)+1);
      printf("Something wrong with main()\n");
      free(Buff);
      for(i= 0;i<nTargF;i++)
	free(NmTFiles[i]);
      free(BBuff);
      free(TOC);
      exit(1);
    }
    
    fclose(fp);

#ifdef H
    printf("%s\n",Buff);
    printf("nBuff=%d\n",nBuff);
#endif
    
    nTOC= 0;
    if(MakeSectCbTofContent()){
      fclose(fp);
      free(Buff);
      for(i= 0;i<nTargF-1;i++){
	free(BBuff[i]);
      }
      for(i= 0;i<nTargF;i++)
	free(NmTFiles[i]);
      free(BBuff);
      free(TOC);
      exit(1);
    }
    MakeBuffCbTofContent();
    free(Buff);
    for(i= 0;i<nRef;i++){
      if(iRef[i]<=iTargF&&RefElem[i][0]!='&'){
	UpdateCbTargetFiles(i);
      }
    }
    iTargF++;
  }

  if(MakeCbTofContent()){
    NmFCb[0]= '\0';
    return(NmFCb);
  }
  
  i	=strlen(argv1);
  while(i > 0 && argv1[i-1] != '/') i--;
  sprintf(NmFCb,"Out/%s",argv1+i);
  i	=4;
  while(NmFCb[i]!='.'&&NmFCb[i]!='\0'){
    i++;
  }
  strcpy(NmFCb+i,".Cb");
  fp	=fopen(NmFCb,"w");
  
  WriteTofContents();
  WriteTofConsistency();

  strcpy(NmTF,argv1);
  if(WriteCbDescription()){
    fclose(fp);
    for(i= 0;i<nTargF;i++){
      free(BBuff[i]);
      free(NmTFiles[i]);
    }
    free(BBuff);
    free(TOC);
    CbDeInitCb();
    exit(1);
  }
 
#ifdef H
#endif
  fclose(fp);
  for(i=0; i < nMzl; i++){
    free(Mzl[i].S);
  }
  for(i=0; i < nBlb; i++){
    free(Blb[i].M);
  }
  
  printf("\n%s containing structure of <%s> ",NmFCb,NmCode);
  printf("has been written by zcb\n");
  printf("Inspect it, edit and move into In/ directory\n\n");
  free(RefElem);
  free(RefAddr);
  free(iRef);
  for(i= 0;i<nTargF;i++){
    free(BBuff[i]);
    free(NmTFiles[i]);
  }
  free(BBuff);
  free(TOC);
  return(NmFCb);
}

int MakeCbTofContent()
{
  int i,j,ic,n,n1;
  char*p,*p1;
  ChList*pL,*pL1;
  
  nTOC= 0;
  n= 0;
  pL= TOC;
  for(i= 0;i<nRef;i++){
    iRef[i]= 0;
  }
  for(i= 0;i<nRef;i++){
    p= RefAddr[i];
    n1= n;
    ic= -1;
    while(ic&&*p!='\0'){
      pL->p= p+1;
      if(*p=='&'){
	for(j= i+1;j<nRef;j++){
	  if(RefElem[j]==p){
	    iRef[j]= n;
	  }
	}
      }
      pL->pf= pL+1;
      pL->pb= n?pL-1:pL;
      while(*p!='\n'){
	if(ic==-1&&*p==';')
	  ic= 0;
	if(*p=='{'){
	  if(ic==-1)
	    ic= 0;
	  ic++;
	}
	if(*p=='}'){
	  ic--;
	}
	p++;
      }
      pL++;
      n++;
      p++;
    }
    if(i){
      if(n-n1>2){
	j= iRef[i];
	TOC[j].pf= TOC+n1+1;
	TOC[n-2].pf= TOC+j+1;
      }
    }
    else{
      pL->p= NULL;
      pL++;
      n++;
    }
  }

  PrintCbTofContent();
  return(0);
}

int UpdateCbTargetFiles(int iR)
{
  char ch,*p,*p1,*p2,*StartNm;
  int i,ic;
  ChList*pL;

  StartNm= RefElem[iR];
  strcpy(NmF,NmTFiles[iRef[iR]]);

  p= BBuff[iRef[iR]];
  Buff= p;
  ic= 0;
  while(*p!='\0'){
    if(*p==' '){
      p2= p;
      p++;
      if(*p!='}'){
	p1= StartNm+1;
	while((isalnum(*p1)||*p1=='_')&&*p1==*p){
	  p1++;
	  p++;
	}
	if(!isalnum(*p1)&&*p1!='_'&&!isalnum(*p)&&*p!='_'){
	  p= p2;
	  break;
	}
      }
      PrintLine0(p2);
    }
    while(*p!='\n'){
      p++;
    }
    p++;
  }
  RefAddr[iR]= p2;

  ic= -1;
  while(ic&&*p!='\0'){
    if(*p!=' '){
      p1= StartNm;
      while((isalnum(*p1)||*p1=='_')){
	putchar(*p1);
      }
      printf(" - Double referenced element in file %s\n",NmF);
      return(1);
    }
    *p= '*';
    p2= p;
    p++;
    if(*p!='}'){
      p+= 4;
      while(*p!='('&&*p!=';'&&*p!='{')
	p++;
      if(*p=='('){
	if(UpdateCbElm(&p)){
	  printf("%s - No second ')' after alias in line:%c\n",NmF,7);
	  PrintLine0(p);
	}
	for(i= 0;i<nTargF;i++){
	  if(strcmp(NmTFiles[i],NmTF)==0)
	    break;
	}
	RefElem[nRef]= p2;
	iRef[nRef]= i;
	nRef++;
	if(NRef==nRef){
	  NRef+= 10;
	  RefElem= (char**)realloc((void*)RefElem,(size_t)(NRef*sizeof(char*)));
	  RefAddr= (char**)realloc((void*)RefAddr,(size_t)(NRef*sizeof(char*)));
	  iRef= (int*)realloc((void*)iRef,(size_t)(NRef*sizeof(int)));
	  FailureAlarm(iRef," - no memory for iRef in UpdateCbTargetFiles");
	}
	if(i==nTargF){
	  AddNmTFile(NmTF);
	}
	while(*p!=';'&&*p!='{')
	  p++;
      }
      if(ic==-1){
	ic= 0;
      }
      if(*p=='{'){
	ic++;
      }
    }
    else{
      ic--;
    }
    while(*p!='\n'){
      p++;
    }
    p++;
  }
  *StartNm= '&';
  return(0);
}

int AddNmTFile(char*NameTF)
{
  int i;

  NmTFiles[nTargF]= (char*)malloc((size_t)((strlen(NameTF)+1)*sizeof(char)));
  strcpy(NmTFiles[nTargF],NameTF);

  nTargF++;
  if(nTargF==NTargF){
    NTargF+= 10;
    BBuff= (char**)realloc((void*)BBuff,(size_t)(2*NTargF*sizeof(char*)));
    FailureAlarm(BBuff," - no memory for BBuff in AddTFile()");
    NmTFiles= BBuff+NTargF;
    for(i= 0;i<nTargF;i++){
      NmTFiles[i]= BBuff[i+nTargF];
    }
  }
  return(0);
}

int MakeBuffCbTofContent()
{
  int i,n;
  char*p,*p0,*p1,ch;
  ChList*pL,*pL1;

  n= 0;
  pL= TOC;
  ch= 'b';
  while(pL->p!=NULL){
    p= pL->p+1;
    if(*p=='i'){
      p+= 7;
      while(isspace(*p)){
	p++;
      }
      ch= *p;
      n++;
      while(*p!='('&&*p!='\n'){
	p++;
	n++;
      }
      if(*p=='('){
	p--;
	n--;
      }
      while(isspace(*p)){
	p--;
	n--;
      }
      n++;
      while(*p!='('&&*p!='\n'){
	p++;
      }
      if(*p=='('){
	while(*p!=')'&&*p!='\n'){
	  n++;
	  p++;
	}
	if(*p!=')'){
	  printf("No closing ')' in Cb structuring line%c\n",7);
	  p= pL->p;
	  while(*p!='\n'&&*p!='\0'){
	    putchar(*p++);
	  }
	  putchar('\n');
	  exit(1);
	}
	n++;
      }
      n+= 2;
    }
    else{
      if(ch!='s'){
	n+= 3;
      }
      else{
	ch= 'm';
      }
    }
    pL= pL->pf;
  }
  n++;
  BBuff[iTargF]= (char*)malloc((size_t)(n*sizeof(char)));
  FailureAlarm(BBuff[iTargF],
	       " - no memory for BBuff[] in MakeBuffCbTofContent()");
  p1= BBuff[iTargF];
  pL= TOC;
  pL1= pL;
  ch= 'b';
  while(pL->p!=NULL){
    p= pL->p+1;
    if(*p=='i'){
      if(nRef==0&&p==RefElem[nRef]){
	RefElem[nRef]= p1;
	nRef++;
      }
      *(p1++)= ' ';
      pL1->p= p1;
      pL1->pf= pL1+1;
      pL1= pL1->pf;
      p+= 7;
      while(isspace(*p)){
	p++;
      }
      ch= *p;
      p0= p;
      n= 0;
      while(*p!='('&&*p!='\n'){
	p++;
	n++;
      }
      if(*p=='('){
	p--;
	n--;
      }
      while(isspace(*p)){
	p--;
	n--;
      }
      n++;
      i= 0;
      p= p0;
      while(i<n){
	*(p1++)= *(p++);
	i++;
      }
      while(*p!='('&&*p!='\n'){
	p++;
      }
      if(*p=='('){
	while(*p!=')'&&*p!='\n'){
	  *(p1++)= *(p++);
	}
	*(p1++)= *p;
      }
      if(ch=='s'){
	*(p1++)= ';';
      }
      else{
	*(p1++)= '{';
      }
      *(p1++)= '\n';
    }
    else{
      if(ch!='s'){
	*(p1++)= ' ';
	pL1->p= p1;
	pL1->pf= pL1+1;
	pL1= pL1->pf;
	*(p1++)= '}';
	*(p1++)= '\n';
      }
      else{
	ch= 'm';
      }
    }
    pL= pL->pf;
  }
  *p1= '\0';
  pL1->p= NULL;

#ifdef H
  printf("BBuff[%d]=<\n%s>\n",iTargF,BBuff[iTargF]);
#endif

  return(0);
}

int PrintCbTofContent()
{
  int indent;
  char*p,ch;
  ChList*pL;

  printf("------ Table of Content ------\n");
  pL= TOC;
  indent= 0;
  ln[indent]= '\0';
  while(pL->p!=NULL){
    p= pL->p;
    if(*p!='}'){
      ch= *p;
      printf("%s",ln);
      while(*p!='{'&&*p!='('&&*p!=';'&&*p!='\n'){
	printf("%c",*p);
	p++;
      }
      if(ch == 's'){
	puts("(y,y,u,u,tg,u);");
      }
      else{
	puts("(yx,y,u,u,tg,u){");
      }
      if(ch!='s'){
	if(indent%4)
	  ln[indent]= '.';
	else
	  ln[indent]= '|';
	indent++;
	ln[indent]= ' ';
	indent++;
	ln[indent]= '\0';
      }
    }
    else{
      if(indent>1){
	indent-= 2;
	ln[indent]= '\0';
	printf("%s}\n",ln);
      }
      else{
	printf("Too much #endif's\n");
	exit(1);
      }	
    }
    pL	=pL->pf;
  }
  return(0);
}

int WriteTofContents()
{
  int indent,n_endif;
  char *p,ch,*lc,*lt;
  ChList *pL;
  char *CbW[3]={"blb_","mzl_","stg_"};
  char Nm[32];
  int i,nM,nS,k,L,ic;
  char str[64];
  int M,iM,O,iO,I,iI;

  n_endif	=0;
  pL	=TOC;
  indent	=0;
  ln[indent]	='\0';
  while(pL->p != NULL){
    p	=pL->p;
    if(*p != '}'){
      ch	=*p;
      fputs(ln,fp);
      lc	=Nm;
      while(*p != '{' && *p!= '(' && *p!= ';' && *p!='\n'){
	fputc(*p,fp);
    	*lc++	=*p++;
      }
      *lc	='\0';
      L	=lc-Nm-4;
      for(k=0; k < 3; k++){
	if(strncmp(Nm,CbW[k],4) == 0){
	  break;
	}
      }
      lc	=Nm+4;
      M	=-1;
      switch(k){
      case 0:
	for(i=0; i < nBlb; i++){
	  lt	=Blb[i].Nm;
	  if(strcmp(lc,lt) == 0){
	    M	=Blb[i].mt;	
	    iM	=Blb[i].imt;
	    O	=Blb[i].Ot;
	    iO	=Blb[i].iOt;
	    I	=Blb[i].It;
	    iI	=Blb[i].iIt;
	    break;
	  }
	}
	break;
      case 1:
	for(i=0; i < nMzl; i++){
	  lt	=Mzl[i].Nm;
	  if(strcmp(lc,lt) == 0){
	    M	=Mzl[i].mt;	
	    iM	=Mzl[i].imt;
	    O	=Mzl[i].Ot;
	    iO	=Mzl[i].iOt;
	    I	=Mzl[i].It;
	    iI	=Mzl[i].iIt;
	    break;
	  }
	}
	break;
      case 2:
	for(i=0; i < nStg; i++){
	  lt	=Stg[i].Nm;
	  if(strcmp(lc,lt) == 0){
	    M	=Stg[i].mt;	
	    iM	=Stg[i].imt;
	    O	=Stg[i].Ot;
	    iO	=Stg[i].iOt;
	    I	=Stg[i].It;
	    iI	=Stg[i].iIt;
	    break;
	  }
	}
	break;
      }
      if(M < 0){
	fputs("(yx,y,u,u,tg,u)",fp);
      }
      else{
	fputc('(',fp);
	CbSwitch2Str(str,CbLAliasMode,M);
	if(*str != '.') fputs(str,fp);
	CbSwitch2Str(str,CbLAliasMode,iM);
	fputc(',',fp);
	if(*str != '.') fputs(str,fp);
	CbSwitch2Str(str,CbLAliasOut,O);
	fputc(',',fp);
	if(*str != '.') fputs(str,fp);
	CbSwitch2Str(str,CbLAliasOut,iO);
	fputc(',',fp);
	if(*str != '.') fputs(str,fp);
	CbSwitch2Str(str,CbLAliasInp,I);
	fputc(',',fp);
	if(*str != '.') fputs(str,fp);
	CbSwitch2Str(str,CbLAliasInp,iI);
	fputc(',',fp);
	if(*str != '.') fputs(str,fp);
	fputc(')',fp);
      }
      if(k < 2){
	fputc('{',fp);
      }
      else{
	fputc(';',fp);
      }
      fputc('\n',fp);
      if(ch!='s'){
	strcpy(ln+indent,"  ");
	indent	+=2;
      }
    }
    else{
      n_endif++;
      if(indent > 1){
	indent	-=2;
	ln[indent]	='\0';
	fputs(ln,fp);
	fputc('}',fp);
	fputc('\n',fp);
      }
      else{
	printf("%d - Too much #endif's\n",n_endif);
	CbDeInitCb();
	exit(1);
      }
    }
    pL= pL->pf;
  }
  return(0);
}

int WriteTofConsistency()
{
  int indent,n_endif;
  char *p,ch,*lc,*lt;
  ChList *pL;
  char *CbW[3]={"blb_","mzl_","stg_"};
  char Nm[32];
  int i,nM,nS,k,L,ic;

  fputs("\nTable of Consistency\n",fp);
  fputs("'-' - Off\n",fp);
  fputs("'+' - On\n",fp);
  fputs("'*' - Off || On is ignorable\n",fp);
  fputs("'3' - Others are ignorable\n",fp);
  pL	=TOC;
  indent	=0;
  strcpy(ln,"  |  ");
  while(pL->p != NULL){
    p	=pL->p;
    if(*p != '}'){
      ch	=*p;
      lc	=Nm;
      while(*p != '{' && *p!= '(' && *p!= ';' && *p!='\n'){
    	*lc++	=*p++;
      }
      *lc	='\0';
      for(k=0; k < 3; k++){
	if(strncmp(Nm,CbW[k],4) == 0){
	  break;
	}
      }
      fputc('*',fp);
      fputs(ln,fp);
      lc	=Nm+4;
      fputs(lc,fp);
      switch(k){
      case 0:
	strcpy(ln+5+indent,".");
	indent++;
	break;
      case 1:
	strcpy(ln+5+indent," ");
	indent++;
	break;
      case 2:
	break;
      }
#ifdef H
      if(k < 2){
	fputc('{',fp);
      }
      else{
	fputc(';',fp);
      }
#endif
      fputc('\n',fp);
    }
    else{
      if(indent){
	indent--;
	ln[5+indent]	='\0';
#ifdef H
	fputc(' ',fp);
	fputs(ln,fp);
	fputc('}',fp);
	fputc('\n',fp);
#endif
      }
    }
    pL= pL->pf;
  }
  return(0);
}

int CbSkipComment(char*ch01,char*ch0,char*NmFile)
{
  char ch1,ch;

  ch1= *ch01;
  ch= *ch0;

  if(feof(fp)==0)
    ch= fgetc(fp);
  else{
    printf("%s-file ends in the middle of comment\n",NmFile);
    exit(1);
  }
  ch1= ch;
  if(feof(fp)==0)
    ch= fgetc(fp);
  else{
    printf("%s-file ends in the middle of comment\n",NmFile);
    exit(1);
  }
  while(feof(fp)==0&&(ch1!='*'||ch!='/')){
    ch1= ch;
    ch= fgetc(fp);
  }
  if(ch1=='*'||ch=='/'){
    *ch0= ' ';
    return(0);
  }
  else{
    printf("%s-file ends in the middle of comment\n",NmFile);
    exit(1);
  }
}

extern int FlFtn;
int FillBuffF()
{
  char ch,ch1,ch2;
  int icm,FlM;
  char*p,*pch,*pchU,*str= "program",*strE= "end",*strU= "PROGRAM",*strEU= "END";
  
  FlM= FlagMain?2:0;
  pch= str;
  pchU= strU;
  
  ch1= '\n';
  ch= '\n';
  while(feof(fp)==0){
    ch2= ch1;
    ch1= ch;
    ch= fgetc(fp);
    if(ch1=='/'&&ch=='*'&&FlFtn==0){
      CbSkipComment(&ch1,&ch,NmF);
    }
    if(ch1=='\n'&&ch=='c'){
      while(feof(fp)==0&&ch!='#'&&ch!='\n'){
	ch2= ch1;
	ch1= ch;
	ch= fgetc(fp);
      }
      if(ch=='#'){
	if(nBuff+Lstr>=NBuff){
	  NBuff+= 1000;
	  Buff= (char*)realloc((void*)Buff,(size_t)(NBuff*sizeof(char)));
	  pBuff= Buff+nBuff;
	}
	*pBuff= ch;
	nBuff++;
	pBuff++;
	do{
	  ch2= ch1;
	  ch1= ch;
	  ch= fgetc(fp);
	  *pBuff= ch;
	  nBuff++;
	  pBuff++;
	}while(feof(fp)==0&&ch!='\n');
      }
    }

    if(FlM==0){
      if(ch==*pch||ch==*pchU){
	if((ch!='p'&&ch!='P')||isspace(ch1)){
	  pch++;
	  pchU++;
	  if(*pch=='\0'){
	    ch1= ch;
	    ch= fgetc(fp);
	    if(!isspace(ch)){
	      pch= str;
	      pchU= strU;
	      break;
	    }
	    else{
	      if(nBuff+Lstr>=NBuff){
		NBuff+= 1000;
		Buff= (char*)realloc((void*)Buff,(size_t)(NBuff*sizeof(char)));
		pBuff= Buff+nBuff;
	      }
	      RefElem[nRef]= pBuff+1;
	      strcpy(pBuff,"#ifndef blb_");
	      pBuff+= 12;
	      nBuff+= 12;
	      p= NmCode;
	      while(*p!='\0'){
		*(pBuff++)= *(p++);
		nBuff++;
	      }
	      *(pBuff++)= '\n';
	      nBuff++;
	      FlM= 1;
	      FlagMain= 1;
	      icm= 0;
	      pch= strE;
	      pchU= strEU;
	    }
	    while(feof(fp)==0&&ch!='\n'){
	      ch2= ch1;
	      ch1= ch;
	      ch= fgetc(fp);
	    }
	  }
	}
      }
      else{
	pch= str;
	pchU= strU;
      }
    }
    if(FlM==1){
      if(ch==*pch||ch==*pchU){
	if((ch!='e'&&ch!='E')||isspace(ch1)){
	  pch++;
	  pchU++;
	  if(*pch=='\0'){
	    while(feof(fp)==0){
	      ch2= ch1;
	      ch1= ch;
	      ch= fgetc(fp);
	      if(ch1=='/'&&ch=='*'){
		CbSkipComment(&ch1,&ch,NmF);
	      }
	      if(!isspace(ch)){
		pch= strE;
		pchU= strEU;
		break;
	      }
	      if(ch=='\n'){
		if(nBuff+Lstr>=NBuff){
		  NBuff+= 1000;
		  Buff= (char*)realloc((void*)Buff,
				       (size_t)(NBuff*sizeof(char)));
		  pBuff= Buff+nBuff;
		}
		strcpy(pBuff,"#endif\n");
		pBuff+= 7;
		nBuff+= 7;
		FlM= 2;
		break;
	      }
	    }
	  }
	}
      }
      else{
	pch= strE;
	pchU= strEU;
      }
    }
  }
  
  if(nBuff==NBuff){
    NBuff++;
    Buff= (char*)realloc((void*)Buff,(size_t)(NBuff*sizeof(char)));
    pBuff= Buff+nBuff;
  }
  
  *pBuff= '\0';
  return(0);
}

int FillBuffC()
{
  char ch,ch1;
  int icm,FlM;
  char*p,*pch,*str= "main(";

  FlM= FlagMain?2:0;
  pch= str;

  ch= '\n';
  while(feof(fp)==0){
    ch1= ch;
    ch= fgetc(fp);
    if(ch1=='/'&&ch=='*'){
      CbSkipComment(&ch1,&ch,NmF);
    }
    if(ch1=='\n'&&ch=='#'){
      if(nBuff+Lstr>=NBuff){
	NBuff+= 1000;
	Buff= (char*)realloc((void*)Buff,(size_t)(NBuff*sizeof(char)));
	pBuff= Buff+nBuff;
      }
      *pBuff= ch;
      nBuff++;
      pBuff++;
      do{
	ch1= ch;
	ch= fgetc(fp);
	*pBuff= ch;
	nBuff++;
	pBuff++;
      }while(feof(fp)==0&&ch!='\n');
    }

    if(FlM==0){
      if(*pch!='\0'){
	if(ch==*pch){
	  if(ch!='m'||isspace(ch1))
	    pch++;
	}
	else{
	  if(*pch!='('||!isspace(ch)){
	    pch= str;
	  }
	}
      }
      else{
	if(ch=='{'){
	  if(nBuff+Lstr>=NBuff){
	    NBuff+= 1000;
	    Buff= (char*)realloc((void*)Buff,(size_t)(NBuff*sizeof(char)));
	    pBuff= Buff+nBuff;
	  }
	  RefElem[nRef]= pBuff+1;
	  strcpy(pBuff,"#ifndef blb_");
	  pBuff+= 12;
	  nBuff+= 12;
	  p= NmCode;
	  while(*p!='\0'){
	    *(pBuff++)= *(p++);
	    nBuff++;
	  }
	  *(pBuff++)= '\n';
	  nBuff++;
	  FlM= 1;
	  FlagMain= 1;
	  icm= 0;
	}
      }
    }
    if(FlM==1){
      if(ch=='{'){
	icm++;
      }
      if(ch=='}'){
	icm--;
      }
      if(icm==0){
	if(nBuff+Lstr>=NBuff){
	  NBuff+= 1000;
	  Buff= (char*)realloc((void*)Buff,(size_t)(NBuff*sizeof(char)));
	  pBuff= Buff+nBuff;
	}
	strcpy(pBuff,"#endif\n");
	pBuff+= 7;
	nBuff+= 7;
	FlM= 2;
      }
    }
  }
  if(nBuff==NBuff){
    NBuff++;
    Buff= (char*)realloc((void*)Buff,(size_t)(NBuff*sizeof(char)));
    pBuff= Buff+nBuff;
  }
  *pBuff= '\0';
  return(0);
}

int MakeSectCbTofContent()
{
  char ch,ch1,*pnt,*pnt1;
  int ic,i;
  static int nCPrPW= 8,LCPrPW[]= {7,6,6,6,7,3,5,5};
  char*CPrPW[]= 
{"#define","#undef","#endif","#ifdef","#ifndef","#if","#else","#elif"};
  static int nCbW= 5,LCbW= 3,iCbW;
  char*CbW[5]= {"stg","Stg","mzl","blb","Blb"};
  char**pdef;
  int*Ldef,ndef,Fl,Fl1;
  int depth,*Idepth;

  pBuff= Buff;
  i= 0;
  ic= 0;
  ch= '\n';
  depth= 1;
  do{
    if(ch=='\n'){
      if(strncmp(pBuff,"#define",7)==0)
	ic++;
      if(strncmp(pBuff,"#if",3)==0){
	depth++;
	if(i<depth)
	  i= depth;
      }
      if(strncmp(pBuff,"#endif",6)==0){
	depth--;
	if(depth==0){
	  pnt= Buff;
	  ic= 0;
	  while(*pnt!='\0'){
	    while(*pnt!='#')
	      pnt++;
	    pnt++;
	    if(*pnt=='e'){
	      ic--;
	    }
	    i= 0;
	    while(i<ic){
	      if(i%2)
		putchar('.');
	      else
		putchar('|');
	      putchar(' ');
	      i++;
	    }
	    if(*pnt=='i')
	      ic++;
	    putchar('#');
	    while(*pnt!='\n')
	      putchar(*pnt++);
	    putchar(*pnt++);
	  }
	  printf("-----------------------\n");
	  printf("%s\n",pBuff);
	  printf("more #endif's than #ifndef's in the source file%c\n",7);
	  return(1);
	}
      }
    }
    ch= *pBuff;
    pBuff++;
  }while(*pBuff!='\0');

  pdef= (char**)malloc((size_t)(ic*sizeof(char*)));
  Ldef= (int*)malloc((size_t)(ic*sizeof(int)));
  Idepth= (int*)malloc((size_t)(i*sizeof(int)));

  pBuff= Buff;
  ndef= 0;
  ch= '\n';
  Idepth[0]= 1;
  Fl1= 1;
  Fl= 1;
  depth= 1;
  do{
    if(ch=='\n'){
      for(i= 0;i<nCPrPW;i++){
	if(strncmp(pBuff,CPrPW[i],LCPrPW[i])==0){
	  break;
	}
      }
      if(i<nCPrPW){
	pnt= pBuff+LCPrPW[i];
	while(isspace(*pnt))
	  pnt++;
	switch(i){
	case 0:
	  if(Fl){
	    ic= 0;
	    while(isalnum(pnt[ic])||pnt[ic]=='_'){
	      ic++;
	    }
	    Ldef[ndef]= ic;
	    for(i= 0;i<ndef;i++){
	      if(ic==Ldef[i]&&strncmp(pnt,pdef[i],ic)==0)
		break;
	    }
	    if(i==ndef){
	      pdef[ndef]= pnt;
	      ndef++;
	    }
	  }
	  break;
	case 1:
	  if(Fl){
	    ic= 0;
	    while(isalnum(pnt[ic])||pnt[ic]=='_'){
	      ic++;
	    }
	    for(i= 0;i<ndef;i++){
	      if(ic==Ldef[i]&&strncmp(pnt,pdef[i],ic)==0)
		break;
	    }
	    if(i<ndef){
	      ndef--;
	      pdef[i]= pdef[ndef];
	      Ldef[i]= Ldef[ndef];
	    }
	  }
	  break;
	case 2:
	  if(Fl==-1){
	    TOC[nTOC].p= pBuff;
	    TOC[nTOC].pf= TOC+nTOC+1;
	    nTOC++;
	    TOC[nTOC].pb= TOC+nTOC-1;
	    TOC[nTOC].p= NULL;
	  }
	  depth--;
	  Fl= Idepth[depth-1];
	  Fl1= depth>1?Idepth[depth-2]:1;
	  break;
	case 3:
	  if(Fl){
	    ic= 0;
	    while(isalnum(pnt[ic])||pnt[ic]=='_'){
	      ic++;
	    }
	    for(i= 0;i<ndef;i++){
	      if(ic==Ldef[i]&&strncmp(pnt,pdef[i],ic)==0)
		break;
	    }
	    Idepth[depth]= i<ndef?1:0;
	  }
	  else{
	    Idepth[depth]= 0;
	  }
	  Fl1= Fl;
	  Fl= Idepth[depth];
	  depth++;
	  break;
	case 4:
	  if(Fl){
	    ic= 0;
	    while(isalnum(pnt[ic])||pnt[ic]=='_'){
	      ic++;
	    }
	    for(i= 0;i<ndef;i++){
	      if(ic==Ldef[i]&&strncmp(pnt,pdef[i],ic)==0)
		break;
	    }
	    Idepth[depth]= i<ndef?0:1;

	    if(Idepth[depth]&&ic>=LCbW){
	      for(i= 0;i<nCbW;i++){
		if(strncmp(pnt,CbW[i],LCbW)==0)
		  break;
	      }
	      if(i<nCbW){
		Idepth[depth]= -1;
		iCbW= i<2?0:1;
	      }
	    }
	  }
	  else{
	    Idepth[depth]= 0;
	  }
	  Fl1= Fl;
	  Fl= Idepth[depth];
	  depth++;
	  if(Fl==-1){
	    pnt+= 3;
	    if(*pnt!='_'){
	      printf("%s --- No name attached to Cb element in line:\n",NmF);
	      pnt--;
	      PrintLine0(pnt);
	      free(pdef);
	      free(Ldef);
	      free(Idepth);
	      return(1);
	    }
	    TOC[nTOC].p= pBuff;
	    TOC[nTOC].pf= TOC+nTOC+1;
	    nTOC++;
	    TOC[nTOC].pb= TOC+nTOC-1;
	    TOC[nTOC].pf= NULL;
	  }
	  break;
	case 5:
	  if(Fl){
	    Idepth[depth]= 1;
	  }
	  else{
	    Idepth[depth]= 0;
	  }
	  Fl1= Fl;
	  Fl= Idepth[depth];
	  depth++;
	  break;
	case 6:
	  if(Fl){
	    Idepth[depth-1]= 0;
	    Fl= 0;
	  }
	  else{
	    if(Fl1){
	      Idepth[depth-1]= 1;
	      Fl= 1;
	    }
	  }
	  break;
	case 7:
	  if(Fl){
	    Idepth[depth-1]= 0;
	    Fl= 0;
	  }
	  else{
	    if(Fl1){
	      Idepth[depth-1]= 1;
	      Fl= 1;
	    }
	  }
	  break;
	default:
	  break;
	}
      }
    }
    ch= *pBuff;
    pBuff++;
  }while(*pBuff!='\0');

  free(pdef);
  free(Ldef);
  free(Idepth);

  if(depth!=1){
    pnt= Buff;
    ic= 0;
    while(*pnt!='\0'){

      while(*pnt!='#')
	pnt++;
      pnt++;
      if(*pnt=='e'){
	ic--;
      }
      i= 0;
      while(i<ic){
	if(i%2)
	  putchar('.');
	else
	  putchar('|');
	putchar(' ');
	i++;
      }
      if(*pnt=='i')
	ic++;
      putchar('#');
      while(*pnt!='\n')
	putchar(*pnt++);
      putchar(*pnt++);
    }
    printf("-----------------------\n");
    printf("%s\n",pBuff);
    printf("more #ifndef's than #endif's in the source file%c\n",7);
    return(1);
  }
  return(0);
}

int WriteCbTemplate(char ch)
{
  static int ic=0;
  int i,k;
  char *lc;
  
  fputc('\n',fp);
  switch(ch){
  case 'b':
  case 'B':
    for(i=0; i < nBlb; i++){
      lc	=Blb[i].Nm;
      if(strcmp(lc,NmA) == 0){
	break;
      }
    }
    fprintf(fp,"blb_%s{\n",NmA);
    fprintf(fp,"  mzl =%s;\n",NmPE);
    if(i < nBlb){
      if(*Blb[i].OD != '\0'){
	fprintf(fp,"  OD  =%s;\n",Blb[i].OD);
      }
      else{
	fprintf(fp,"  OD  =;\n");
      }
      fprintf(fp,"  str =0. 0. 1.;\n");
      fprintf(fp,"  TF  =%s;\n",Blb[i].TF);
      fprintf(fp,"  TbF =%s;\n",Blb[i].Tb);
      lc	=Blb[i].Hlp;
    }
    else{
      if(ic < 2){
	if(ic == 0) fprintf(fp,"  OD  =.;\n");
	else fprintf(fp,"  OD  =%s;\n",NmA);
      }
      else fprintf(fp,"  OD  =;\n");
      fprintf(fp,"  str =0. 0. 1.;\n");
      fprintf(fp,"  TF  =%s;\n",NmTF);
      fprintf(fp,"  TbF =%s.CmC;\n",NmA);
      lc	=NULL;
    }
    ic++;
    break;
  case 's':
  case 'S':
    for(i=0; i < nStg; i++){
      lc	=Stg[i].Nm;
      if(strcmp(lc,NmA) == 0){
	break;
      }
    }
    fprintf(fp,"stg_%s{\n",NmA);
    fprintf(fp,"  mzl =%s;\n",NmPE);
    if(i < nStg){
      fprintf(fp,"  TF  =%s;\n",Stg[i].TF);
      fprintf(fp,"  TbF =%s;\n",Stg[i].Tb);
      lc	=Stg[i].Hlp;
    }
    else{
      fprintf(fp,"  TF  =%s;\n",NmTF);
      fprintf(fp,"  TbF =%s.CmC;\n",NmA);
      lc	=NULL;
    }
    break;
  case 'm':
    for(i=0; i < nMzl; i++){
      lc	=Mzl[i].Nm;
      if(strcmp(lc,NmA) == 0){
	break;
      }
    }
    fprintf(fp,"mzl_%s{\n",NmA);
    fprintf(fp,"  blb =%s;\n",NmPE);
    if(i < nStg){
      lc	=Mzl[i].Hlp;
    }
    else{
      lc	=NULL;
    }
    break;
  }
  fprintf(fp,"  Nm=%s;\n",NmA);
  fprintf(fp,"  Hlp =\n");
  if(lc != NULL){
    fputs(lc,fp);
  }
  else{
    fprintf(fp,"Help for %s is NOT written yet.\n",NmA);
  }
  fprintf(fp,"\\;Hlp\n");
  fputs("}\n",fp);
  return(0);
}

int WriteCbDescription()
{
  char ch,*p,*p1;
  int i,iM,nM;

  int Fl,Fl1;
  int depth;
  ChList*pL;

  char**NmB,**NmM,**NmT,**NmMzl;
  int CbD;

  pL	=TOC;
  depth	=0;
  CbD	=0;
  nM	=0;
  while(pL->p != NULL){
    p	=pL->p;
    if(*p != '}'){
      if(*p != 's'){
	depth++;
	if(CbD < depth) CbD= depth;
	if(*p == 'm'){
	  nM++;
	}
      }
    }	
    else{
      depth--;
    }
    pL	=pL->pf;
  }

  CbD++;
  fprintf(fp,"\nDescription of Cb elements:\n");
  NmB	=(char**)malloc((size_t)(3*CbD*sizeof(char*)));
  NmM	=NmB+CbD;
  NmT	=NmM+CbD;
  for(i=0; i < CbD; i++){
    NmB[i]	=(char*)malloc((size_t)(3*64*sizeof(char)));
    NmM[i]	=NmB[i]+64;
    NmT[i]	=NmM[i]+64;
  }

  NmMzl	=(char**)malloc((size_t)(nM*sizeof(char*)));
  for(i=0; i < nM; i++){
    NmMzl[i]	=(char*)malloc((size_t)(64*sizeof(char)));
  }

  depth	=0;
  strcpy(NmB[depth],NmCode);
  strcpy(NmM[depth],NmCode);
  strcpy(NmT[depth],NmTF);

  iM	=0;
  pL	=TOC;
  while(pL->p != NULL){
    p	=pL->p;
    if(*p != '}'){
      ch	=*p;
      p	+=4;
      i	=0;
      while(*p != '(' && *p != '{' && *p != ';' && *p != '\n' && *p != '\0'){
	NmA[i]	=*(p++);
	i++;
      }
      NmA[i]	='\0';
      while( *p != '(' && *p != '\n') p++;
      switch(ch){
      case 's':
	strcpy(NmPE,NmM[depth]);
	strcpy(NmTF,NmT[depth]);
	if(*p == '('){
	  if(UpdateCbElm(&p)){
	    printf("%s - No second ')' after alias in line:%c\n",NmF,7);
	    PrintLine0(p);
	  }
	}
	WriteCbTemplate(ch);
	break;
      case 'b':
	strcpy(NmPE,NmM[depth]);
	strcpy(NmTF,NmT[depth]);
	WriteCbTemplate(ch);

	if(*p == '('){
	  if(UpdateCbElm(&p)){
	    printf("%s - No second ')' after alias in line:%c\n",NmF,7);
	    PrintLine0(p);
	  }
	}
	depth++;
	strcpy(NmM[depth],NmPE);
	strcpy(NmB[depth],NmA);
	strcpy(NmT[depth],NmTF);
	break;
      case 'm':
	strcpy(NmPE,NmB[depth]);
	for(i=0; i < iM; i++){
	  if((strcmp(NmMzl[i],NmA) == 0))
	    break;
	}
	if(i == iM){
	  strcpy(NmMzl[iM],NmA);
	  iM++;
	  WriteCbTemplate(ch);
	}
	depth++;
	strcpy(NmB[depth],NmPE);
	strcpy(NmM[depth],NmA);
	strcpy(NmT[depth],NmT[depth-1]);
	break;
      default:
	break;
      }
    }
    else{
      depth--;
    }
    pL	=pL->pf;
  }

  for(i=0; i < nM; i++){
    free(NmMzl[i]);
  }
  free(NmMzl);
  for(i	=0; i < CbD;i++){
    free(NmB[i]);
  }
  free(NmB);
  return(0);
}

int UpdateCbElm(pnt0)
     char**pnt0;
{
  char*pnt,*pnt1;
  int i;
  static int nCbE= 4,LCbE[]= {1,3,3,3},iCbE;
  char*CbE[]= {"F","mzl","blb","Blb"};

  for(i= 0;i<nCbE;i++){
    pnt= *pnt0;
    while(*pnt!=')'&&*pnt!='\n'){
      pnt++;
      if(strncmp(pnt,CbE[i],LCbE[i])==0){
	while(*pnt!='='&&*pnt!='\n')
	  pnt++;
	if(*pnt=='='){
	  pnt++;
	  while(isspace(*pnt)&&*pnt!='\n')
	    pnt++;
	  switch(i){
	  case 0:
	    pnt1= NmTF;
	    break;
	  case 1:
	  case 2:
	  case 3:
	    pnt1= NmPE;
	    break;
	  default:
	    break;
	  }
	  while(*pnt!=','&&*pnt!=';'&&*pnt!=')'&&*pnt!='\n'){
	    *pnt1= *pnt;
	    pnt++;
	    pnt1++;
	  }
	  *pnt1= '\0';
	}
	break;
      }
    }
  }
  *pnt0= pnt;
  if(*pnt!=')')
    return(1);
  return(0);
}

int PrintLine0(pnt)
     char*pnt;
{
  while(*pnt!='\n'&&pnt>Buff)
    pnt--;
  if(*pnt=='\n')
    pnt++;
  while(*pnt!='\n'&&pnt!='\0'){
    putchar(*pnt);
    pnt++;
  }
  putchar('\n');
  return(0);
}

int CbBasicDirectorySet()
{
  int i,n=8;
  char *D[8]= {"Csrc","Fsrc","In","Out","Wrk","Hlp","Obj","../dB0"};
  char *lc;

  strcpy(ln,"mkdir ");
  lc	=ln+6;
  for(i	=0; i < n; i++){
    if(stat(D[i],&statbuf)){
      strcpy(lc,D[i]);
      system(ln);
      printf("%s/ directory has been created\n",D[i]);
    }
    else if((statbuf.st_mode&S_IFDIR) == 0){
      printf("%s exists but is not a directory%c\n",D[i],7);
    }
  }
  return(0);
}

