#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include "CbType.h"
#include "XCbType.h"

extern Display*theD;
extern Window theW;
extern int Wmode;
extern GC theGC;
extern WinPar*WinP;
extern int wF,hF;
extern unsigned long int ColorPix[16];

extern char *CbMakeCbFile(char* s,char* s1);
extern char *CbMakeZSourceFile(char*s);

char NmCbF[80];
static char NmInitF[81],NmMkF[81],**NmCfF,NmMain[81],NmCode[81];
static char ln[81];
static FILE*fp;
int FlFtn;

int CbPrintUsageMessage()
{
  printf("Usage:\n\nMake <C-file name>.Cb file for code <code-name>:\n");
  printf("zcb <C-file name>.c -i <code-name> <Enter>\n\n");
  printf("Make <C-file name>.Cb file for code");
  printf(" <code-name>=<C-file-name>:\n");
  printf("zcb <C-file name>.c <Enter>\n\n");
  printf("Make default *.CmC files:\n");
  printf("zcb <Cb-file name>.Cb <Enter>\n\n");
  printf("Make all Csrc/Cb<C-file names>.c source files:\n");
  printf("zcb <Cb-file name>.Cb -a <Enter>\n\n");
  printf("Make all source files Csrc/Cb*.c and Cb-Makefile:\n");
  printf("zcb <Cb-file name>.Cb -a <make-file name> <Enter>\n\n");
  printf("Make only Cb-Makefile:\n");
  printf("zcb <Cb-file name>.Cb -m <make-file name> <Enter>\n\n");
  printf("Make only one Csrc/Cb<C-file name>.c source file:\n");
  printf("zcb <Cb-file name>.Cb -f <C-file name>.c <Enter>\n\n");
  printf("<In/> directory may be dropped in <Cb-file name>.Cb\n\n");
  return(0);
}

int main(argc,argv)
     int argc;
     char**argv;
{
  char*pnt,*pnt1,*pnt2;
  int i,j,FlCb,Flc,Flmk,Flcf,Fli;

  if(argc < 2){
    CbPrintUsageMessage();
    exit(1);
  }
  CbBasicDirectorySet();
  FlCb	=0;
  for(i=1; i < argc; i++){
    pnt =strstr(argv[i],".Cb");
    if(pnt != NULL && *(pnt+3) == '\0'){
      pnt	=argv[i];
      pnt1	=NmCbF;
      pnt2	=NmMain;
      while(*pnt != '\0'){
	*pnt1	=*pnt;
	*pnt2	=*pnt;
	if(*pnt2 == '.'){
	  *pnt2	='\0';
	}
	pnt2++;
	if(*pnt =='/'){
	  pnt2 =NmMain;
	}
	pnt1++;
	pnt++;
      }
      *pnt1	='\0';
      if(strncmp(NmCbF,"In/",3) != 0){
	fp	= fopen(NmCbF,"r");
	if(fp == NULL){
	  strcpy(ln,NmCbF);
	  strcpy(NmCbF,"In/");
	  strcpy(NmCbF+3,ln);
	}
	else{
	  printf("\nIt is better to move %s into In/ directory%c\n\n",NmCbF,7);
	  fclose(fp);
	}
      }
      FlCb	=1;
      break;
    }
  }

  Fli	=0;
  Flc	=0; 
  Flcf	=0; 
  FlFtn	=0;
  Flmk	=0;
  if(FlCb == 0){
    for(i=1; i < argc; i++){
      pnt	=strstr(argv[i],"-i");
      if(pnt != NULL && *(pnt+2) == '\0'){
	i++;
	if(i < argc && *argv[i] != '-'){
	  pnt	=argv[i];
	  pnt1	=NmCode;
	  while(*pnt!='\0'){
	    *pnt1	=*pnt;
	    pnt1++;
	    pnt++;
	  }
	  *pnt1	='\0';
	  Fli	=1;
	  break;
	}
	else{
	  CbPrintUsageMessage();
	  exit(1);
	}
      }
    }
    pnt	=strstr(argv[1],".c");
    if(pnt != NULL && *(pnt+2) == '\0'){
      pnt	=argv[1];
      pnt1	=NmInitF;
      pnt2	=NmMain;
      while(*pnt != '\0'){
	*pnt1	=*pnt;
	*pnt2	=*pnt;
	if(*pnt2 == '.'){
	  *pnt2	='\0';
	}
	pnt2++;
	if(*pnt == '/'){
	  pnt2	=NmMain;
	}
	pnt1++;
	pnt++;
      }
      *pnt1	='\0';
      sprintf(NmCbF,"Out/%s.Cb",NmMain);
      Flc	=1;
      if(Fli == 0){
	strcpy(NmCode,NmMain);
	printf("Name of the code has not been provided\n");
	printf("%s is used instead\n",NmCode);
      }
      sprintf(NmCbF,"In/%s.Cb",NmCode);
      CbInitBLB(NmCbF);
      pnt	=CbMakeCbFile(NmInitF,NmCode);
      strcpy(NmCbF,pnt);
      CbDeInitCb();
      exit(0);
    }
    if(Flc == 0){
      pnt=strstr(argv[1],".f");
      if(pnt != NULL && *(pnt+2) == '\0'){
	pnt	=argv[1];
	pnt1	=NmInitF;
	pnt2	=NmMain;
	while(*pnt!='\0'){
	  *pnt1	=*pnt;
	  *pnt2	=*pnt;
	  if(*pnt2 == '.'){
	    *pnt2	='\0';
	  }
	  pnt2++;
	  if(*pnt == '/'){
	    pnt2	=NmMain;
	  }
	  pnt1++;
	  pnt++;
	}
	*pnt1	='\0';
	sprintf(NmCbF,"Out/%s.Cb",NmMain);
	FlFtn	=1;
	Flc	=1;
	if(Fli == 0){
	  strcpy(NmCode,NmMain);
	  printf("Name of the code has not been provided\n");
	  printf("%s is used instead\n",NmCode);
	}
	pnt	=CbMakeCbFile(NmInitF,NmCode);
	strcpy(NmCbF,pnt);
	exit(0);
      }
      if(FlFtn == 0){
	CbPrintUsageMessage();
	return(1);
      }
    }
  }
  else{
    for(i=1; i < argc; i++){
      pnt	=strstr(argv[i],"-m");
      if(pnt != NULL && *(pnt+2) == '\0'){
	i++;
	if(i < argc && *argv[i] != '-'){
	  pnt	=argv[i];
	  pnt1	=NmMkF;
	  while(*pnt != '\0'){
	    *pnt1=*pnt;
	    pnt1++;
	    pnt++;
	  }
	  *pnt1='\0';
	  Flmk=1;
	}
	else{
	  Flmk=2;
	}
	break;
      }
    }
    for(i=1; i < argc; i++){
      pnt	=strstr(argv[i],"-f");
      if(pnt != NULL && *(pnt+2) =='\0'){
	Flcf++;
      }
    }
    NmCfF	=NULL;
    if(Flcf){
      NmCfF	=(char**)malloc(Flcf*sizeof(char*));
      Flcf	=0;
      for(i=1; i < argc; i++){
	pnt	=strstr(argv[i],"-f");
	if(pnt !=NULL && *(pnt+2) == '\0'){
	  i++;
	  if(i < argc && *argv[i] != '-'){
	    pnt		=argv[i];
	    j	=0;
	    while(j < Flcf && strcmp(pnt,NmCfF[j])){
	      j++;
	    }
	    if(j == Flcf){
	      NmCfF[Flcf]	=argv[i];
	      Flcf++;;
	    }
	  }
	  else{
	    CbPrintUsageMessage();
	    return(1);
	  }
	}
      }		
    }
    else{
      for(i=1; i < argc; i++){
	pnt	=strstr(argv[i],"-a");
	if(pnt != NULL && *(pnt+2) == '\0'){
	  Flcf	=-1;
	  break;
	}
      }
    }
    CbInitBLB(NmCbF);
#ifdef H
    CbPrintBlbContent(0);
#endif
    if(Flmk == 0 && Flcf == 0){
      XCbInitX();
      XCbNotSave();
      XCbInputCntrPanel();
      CbMakeTblTempFiles();
      XCbDeInitX();
    }
    else{
      CbSetFlagEdit();
      CbInitInpTables();
      printf("=========== Inserting Code Control ===========\n");
      CbMakeTFiles(NmCfF,NmMain,Flcf);
#ifdef H
      XCbTestTables();
#endif
      printf("=========== Modifying Source Files ===========\n");
      if(CbMakeSFiles(NmMain,NmCfF,Flcf)){
	CbDeInitCb();
	exit(0);
      }
      if(Flmk == 1){
	printf("=========== Modifying  Make  File  ===========\n");
	if(CbMakeMkF(NmMkF)){
	  CbDeInitCb();
	  exit(0);
	}
      }
      if(Flmk == 2){
	printf("=========== Writing New MakeFile ===========\n");
	if(CbMakeNewMkF(NmMain,NmCbF)){
	  CbDeInitCb();
	  exit(0);
	}
      }
    }
#ifdef H
    sprintf(ln,"make -f %s.mk",NmMain);
    printf("Making executable with\n");
    printf("%s\n",ln);
    system(ln);
    printf("Cb finished\n");
    CbFreeBLB();
#endif
    CbDeInitCb();
  }
  if(Flcf){
    free(NmCfF);
  }
  return(0);
}
