#ifndef Blb_libCb.c
/*  */
#ifdef Doc_libCb.c
\section{Skeleton of libCb.c}
  \begin{verbatim}
   {
     C	-routines;
     CP	-routines;
     Cb	-routines;
    }
  \end{verbatim}
\section{CbIsExtNameObj()}
#endif

#ifndef mzl_System_libCb.c /* --------------- Use of Variables --------{ */
#ifdef Tbl_UnusedID/* ------------- List of Unused variables ------{ */
  int CbIsCID();		/*  <C_routines:libCb.c */
  int CbIsCNumber();		/*  <C_routines:libCb.c */
  char *CbErrC[];		/*  <C_routines:libCb.c */
  static int nD;		/*  <C_routines:libCb.c */
  static int ND;		/*  <C_routines:libCb.c */
  static int kDb[];		/*  <C_routines:libCb.c */
  static int kDe[];		/*  <C_routines:libCb.c */
  int CbIsCName();		/*  <C_routines:libCb.c */
  static int kT;		/*             :libCb.c */
  static int LCW;		/*             :libCb.c */
  char *ErrMessObj[];		/*             :libCb.c */
  int CbIsExtNameObj();		/*             :libCb.c */
  int CbIsIntName();		/*             :libCb.c */
  int CbIsObjType();		/*             :libCb.c */
  int CbIsIntNameObj();		/*             :libCb.c */
  int CbSkipCCommentFile();	/* <Cb_routines:libCb.c */
  int CbCopyCCommentFile();	/* <Cb_routines:libCb.c */
  int CMainParameters();		/* <Cb_routines:libCb.c */
#endif /* }=== End of List of Unused variables ======*/
#ifndef H/* ---------- Used External Variables ------{ */
  Ignor int;
  Systm isdigit();
  Systm isalnum();
  Systm isalpha();
  Systm isspace();
  Systm strcmp();
  Systm feof();
  Systm fgetc();
  Systm printf();
  Systm fputc();
  Undef strncmp();	/* NO prototype */
#ifdef Tbl_C_routines
#endif
#ifdef Tbl_Cb_routines
  Undef strncmp();	/* NO prototype */
#endif
#endif /* }======== End of Used External Variables ======= */

#endif /* }======== End of Use of Variables ======== */


#ifndef mzl_C_routines

int CbIsIndex(I)
  char *I;	/* C-line */
{
/*
   */
#ifdef Doc_CbIsIndex
\section{Skeleton of CbIsIndex()}
  \begin{verbatim}
    CbIsIndex(){
    }
  \end{verbatim}
\section{CbIsIndex()}
Checks if \C{I} is a C-integer.
\subsection{Manual}
\begin{itemize}
\item \c{DESCRIPTION:}
\item \c{ARGUMENTS:}
\item \c{EXTERNALS:}
\item \c{RETURN VALUE:}
\begin{itemize}
  \item{\bf Success: }
  \item{\bf Failure: }

  \begin{tabular}{lcl}
  \C{i=CbIsNameC();}& -&\em return value.\\ 
  \C{i\&0xff}	  & -&\em position of error in \C{I};\\
  \C{i>>8 == 1}& -&\em NO digits in \c{<Integer>};\\
  \C{i>>8 == 2}& -&\em TOO long \c{<Integer>};\\
  \C{i>>8 == 3}& -&\em WRONG symbol after \c{<Integer>};\\
  \end{tabular}
\end{itemize}
\item \c{TIPS:}
{\em }
\item \c{BUGS:}
\item \c{SEE ALSO:}
\item \c{TO DO:}
\end{itemize}
#endif
}

int CbIsCID(Nm)
  char *Nm;	/*  */
{
/*
   */
#ifdef Doc_CbIsCID
\section{Skeleton of CbIsCID()}
  \begin{verbatim}
    CbIsCID(){
    }
  \end{verbatim}
\section{CbIsCID()}
\subsection{Manual}
\begin{itemize}
\item \c{DESCRIPTION:}
\item \c{ARGUMENTS:}
\item \c{EXTERNALS:}
\item \c{RETURN VALUE:}
\begin{itemize}
  \item{\bf Success: }
  \item{\bf Failure: }

    \begin{tabular}{lcl}
    \C{i=CbIsCID();}& -&\em return value.\\
    \C{i\&0xff}	 & -&\em position of error in \C{Nm};\\
    \C{i>>8 == 4}& -&\em "NOT a \c{C}-ID;\\
    \C{i>>8 == 5}& -&\em "TOO long \c{C}-ID;\\
    \end{tabular}
\end{itemize}
\item \c{TIPS:}
{\em }
\item \c{BUGS:}
\item \c{SEE ALSO:}
\item \c{TO DO:}
\end{itemize}
#endif
}

int CbIsCNumber(N)
  char *N;	/* C-line */
{
/*
   */
#ifdef Doc_CbIsCNumber
\section{Skeleton of CbIsCNumber()}
  \begin{verbatim}
    CbIsCNumber(){
    }
  \end{verbatim}
\section{CbIsCNumber()}
Checks of \C{C}-line starts with a \c{<C-Number>}.
\subsection{Manual}
\begin{itemize}
\item \c{DESCRIPTION:}
\item \c{ARGUMENTS:}
\item \c{EXTERNALS:}
\item \c{RETURN VALUE:}
\begin{itemize}
  \item{\bf Success: }
  \item{\bf Failure: }

  \begin{tabular}{rcl}
  \C{i=CbIsCNumber();}& -&\em return value.\\ 
  \C{i\&0xff}	  & -&\em position of error in \C{N};\\
  \C{i>>8 == 6}& -&\em NO digits or \C{'.'} in \c{<C-Number>};\\
  \C{i>>8 == 7}& -&\em TOO long \c{<C-Number>};\\
  \C{i>>8 == 8}& -&\em NO digits after \C{'.'} in \c{<C-Number>};\\
  \C{i>>8 == 9}& -&\em NO digits after \C{'e'} in \c{<C-Number>};\\
  \C{i>>8 == 0xa}& -&\em WRONG symbol after \c{<C-Number>};\\
  \end{tabular}
\end{itemize}
\item \c{TIPS:}
{\em }
\item \c{BUGS:}
\item \c{SEE ALSO:}
\item \c{TO DO:}
\end{itemize}
#endif
}
char *CbErrC[];		/*  */
static int nD;		/*  */
static int ND;		/*  */
static int kDb[];	/*  */
static int kDe[];	/*  */

int CbIsPrefix(lNm)
  char **lNm;	/*  */
{
/*
   */
#ifdef Doc_CbIsPrefix
\section{Skeleton of CbIsPrefix()}
  \begin{verbatim}
    CbIsPrefix(){
    }
  \end{verbatim}
\section{CbIsPrefix()}
\subsection{Manual}
\begin{itemize}
\item \c{DESCRIPTION:}
\item \c{ARGUMENTS:}
\item \c{EXTERNALS:}
\item \c{RETURN VALUE:}
\begin{itemize}
  \item{\bf Success: }
  \item{\bf Failure: }

    \begin{tabular}{lcl}
    \C{i=CbIsPrefix();}& -&\em return value.\\
    \C{i == 1}& -&\em Your Comment\\
    \end{tabular}
\end{itemize}
\item \c{TIPS:}
{\em }
\item \c{BUGS:}
\item \c{SEE ALSO:}
\item \c{TO DO:}
\end{itemize}
#endif
}

int CbIsCName(Nm)
  char *Nm;	/* C-line */
{
/*
   */
#ifdef Doc_CbIsCName
\section{Skeleton of CbIsCName()}
  \begin{verbatim}
CbIsCName(){
}
  \end{verbatim}
\section{CbIsCName()}
Checks of \C{C}-line starts with a \c{<C-Name>}.
\subsection{Manual}
\begin{itemize}
\item \c{DESCRIPTION:}
\item \c{ARGUMENTS:}
\item \c{EXTERNALS:}
\item \c{RETURN VALUE:}
\begin{itemize}
  \item{\bf Success: }
  \item{\bf Failure: }

    \begin{tabular}{lcl}
    \C{i=CbIsCName();}& -&\em return value.\\
    \C{i\&0xff}	  & -&\em position of error in \C{Nm};\\
    \C{i>>8 == 0x0b}& -&\em NOT a \c{<C-Name>};\\
    \C{i>>8 == 0x0c}& -&\em NO ID after '.' in \c{<C-Name>};\\
    \C{i>>8 == 0x0d}& -&\em TOO long ID in \c{<C-Name>};\\
    \C{i>>8 == 0x0e}& -&\em NO '>' after '-' in \c{<C-Name>};\\
    \C{i>>8 == 0x0f}& -&\em NO ']' after '[' in \c{<C-Name>};\\
    \C{i>>8 == 0x10}& -&\em NO ')' after '(' in \c{<C-Name>};\\
    \C{i>>8 == 0x11}& -&\em EXTRA ']' in \c{<C-Name>};\\
    \C{i>>8 == 0x12}& -&\em EXTRA ')' in \c{<C-Name>};\\
    \C{i>>8 == 0x13}& -&\em WRONG symbol after \c{<C-Name>};\\
    \end{tabular}
\end{itemize}
\item \c{TIPS:}
{\em !!! No white characters in \C{Nm} !!!}

{\em !!! No functions () inside \C{Nm} !!!}
\item \c{BUGS:}
\item \c{SEE ALSO:}
\item \c{TO DO:}
\end{itemize}
#endif
}
#endif
static int kT;		/*  */
static int kI;		/*  */
static int nCW;		/*  */
static int nCWh;	/*  */
static int LCW;		/*  */
static char *CW[];	/*  */
char *ErrMessObj[];	/*  */

int CbIsExtNameObj(Nm)
  char *Nm;	/* string with an External Name of CmObject in beginning */
{
  char *Nm;	/*  .CbIsExtNameObj():libCb.c */
/*
   */
#ifdef Doc_CbIsExtNameObj
\section{Skeleton of CbIsExtNameObj()}
  \begin{verbatim}
    CbIsExtNameObj(){
    }
  \end{verbatim}
\section{CbIsExtNameObj()}
\C{CbIsExtNameObj()} checks if \C{*Nm} starts with an  External Name
 of Communication Object. 
\subsection{Manual}
\begin{itemize}
\item \c{DESCRIPTION:}
Checks existence of symbols in \c{"<ExtName>"(<SetNm>.<UnitNm>),"<IndexList>"}
\item \c{ARGUMENTS:}
\item \c{EXTERNALS:}
\item \c{RETURN VALUE:}
\begin{itemize}
  \item{\bf Success: }length of External Name;
  \item{\bf Failure: } 

  \begin{tabular}{lcl}
  \C{i=CbIsExtNameObj();}& -&\em return value.\\ 
  \C{i>>8}	  & -&\em position of error in \C{*T};\\
  \C{i\&0xff == 1}& -&\em NO \C{'"'} before \c{<ExtNm>};\\
  \C{i\&0xff == 2}& -&\em NO \C{'"'} after \c{<ExtNm>};\\
  \C{i\&0xff == 3}& -&\em NO \C{'.'} \c{Units};\\
  \C{i\&0xff == 4}& -&\em NO \C{')'} after \c{Units};\\
  \C{i\&0xff == 5}& -&\em NO \C{'"'} before \c{<IndexList>};\\
  \C{i\&0xff == 6}& -&\em NO \C{'"'} after \c{<IndexList>}.\\
  \end{tabular}

\end{itemize}
\item \c{TIPS:}
{\em }
\item \c{BUGS:}
\item \c{SEE ALSO:}
\item \c{TO DO:}
\end{itemize}
#endif
}

int CbIsIntName(Nm)
  char *Nm;	/*  */
{
  char *Nm;	/*  .CbIsIntName():libCb.c */
/*
   */
#ifdef Doc_CbIsIntName
\section{Skeleton of CbIsIntName()}
  \begin{verbatim}
    CbIsIntName(){
    }
  \end{verbatim}
\section{CbIsIntName()}
\subsection{Manual}
\begin{itemize}
\item \c{DESCRIPTION:}
\item \c{ARGUMENTS:}
\item \c{EXTERNALS:}
\item \c{RETURN VALUE:}
\begin{itemize}
  \item{\bf Success: }
  \item{\bf Failure: }
\end{itemize}
\item \c{TIPS:}
{\em }
\item \c{BUGS:}
\item \c{SEE ALSO:}
\item \c{TO DO:}
\end{itemize}
#endif
}

int CbIsObjType(iType,iV,T)
  int *iType;	/*  */
  int *iV;	/*  */
  char *T;	/*  */
{
  char *T;		/*  .CbIsObjType():libCb.c */
  int *iType;		/*  .CbIsObjType():libCb.c */
  int *iV;		/*  .CbIsObjType():libCb.c */
  static int kI;	/*                :libCb.c */
  static int nCW;	/*                :libCb.c */
  static char *CW[];	/*                :libCb.c */
  static int nCWh;	/*                :libCb.c */
/*
   */
#ifdef Doc_CbIsObjType
\section{Skeleton of CbIsObjType()}
  \begin{verbatim}
    CbIsObjType(){
    }
  \end{verbatim}
\section{CbIsObjType()}
\C{CbIsObjType()} checks if \C{*T} starts with a Type of Communication Object. 
\subsection{Manual}
\begin{itemize}
\item \c{DESCRIPTION:}
Checks existence of symbols in \c{=(<Type>*<digit>)}
\item \c{ARGUMENTS:}
\item \c{EXTERNALS:}
\item \c{RETURN VALUE:}
\begin{itemize}
  \item{\bf Success: }length of Type.
  \item{\bf Failure: } 

  \begin{tabular}{lcl}
  \C{i=CbIsObjType();}& -&\em return value.\\ 
  \C{i>>8}	  & -&\em position of error in \C{*T};\\
  \C{i\&0xff == 1}& -&\em NO \C{'='} before \c{Type};\\
  \C{i\&0xff == 1}& -&\em NO \C{'('} before \c{<Type>>};\\
  \C{i\&0xff == 2}& -&\em Wrong \c{<Type>} ID;\\
  \C{i\&0xff == 3}& -&\em NO \C{'*'} or \C{')'} after \c{<Type>};\\
  \C{i\&0xff == 4}& -&\em NO \C{'*'} in \C{str\%d}-ID;\\
  \C{i\&0xff == 5}& -&\em NO length \C{\%d} in \C{str\%d}-ID;\\
  \C{i\&0xff == 6}& -&\em NO \C{')'} in \c{Type}.\\
  \end{tabular}

\end{itemize}
\item \c{TIPS:}
{\em }
\item \c{BUGS:}
\item \c{SEE ALSO:}
\item \c{TO DO:}
\end{itemize}
#endif
}

int CbIsIntNameObj(Nm)
  char *Nm;	/*  */
#ifdef Doc_Nm
#endif
{
  char *Nm;	/*  .CbIsIntNameObj():libCb.c */
/*
   */
#ifdef Doc_CbIsIntNameObj
\section{Skeleton of CbIsIntNameObjObj()}
  \begin{verbatim}
    CbIsIntNameObj(){
    }
  \end{verbatim}
\section{CbIsIntNameObj()}
\subsection{Manual}
\begin{itemize}
\item \c{DESCRIPTION:}
Checks existence of symbols in 
\c{"<IntNameObj>","<IndexList>"}
\item \c{ARGUMENTS:}
\item \c{EXTERNALS:}
\item \c{RETURN VALUE:}
\begin{itemize}
  \item{\bf Success: }length of External Name;
  \item{\bf Failure: } 

  \begin{tabular}{lcl}
  \C{i=CbIsExtNameObj();}& -&\em return value.\\ 
  \C{i>>8}	  & -&\em position of error in \C{*T};\\
  \C{i\&0xff == 1}& -&\em NO \C{'"'} before \c{<ExtNm>};\\
  \C{i\&0xff == 2}& -&\em NO \C{'"'} after \c{<ExtNm>};\\
  \C{i\&0xff == 3}& -&\em NO \C{'.'} \c{Units};\\
  \C{i\&0xff == 4}& -&\em NO \C{')'} after \c{Units};\\
  \C{i\&0xff == 5}& -&\em NO \C{'"'} before \c{<IndexList>};\\
  \C{i\&0xff == 6}& -&\em NO \C{'"'} after \c{<IndexList>}.\\
  \end{tabular}

\end{itemize}
\item \c{TIPS:}
{\em }
\item \c{BUGS:}
\item \c{SEE ALSO:}
\item \c{TO DO:}
\end{itemize}
#endif
}

#ifndef mzl_Cb_routines
static char *Mess;	/*  */

int CbSkipCCommentFile(lF,NmFile)
  FILE *lF;	/*  */
  char *NmFile;	/*  */
{
/*
   */
#ifdef Doc_CbSkipCCommentFile
\section{Skeleton of CbSkipCCommentFile()}
  \begin{verbatim}
    CbSkipCCommentFile(){
    }
  \end{verbatim}
\section{CbSkipCCommentFile()}
\subsection{Manual}
\begin{itemize}
\item \c{DESCRIPTION:}
Scips the C-comment in while reading the file.
\item \c{ARGUMENTS:}
\item \c{EXTERNALS:}
\item \c{RETURN VALUE:}
\begin{itemize}
  \item{\bf Success: 0}
  \item{\bf Failure: }

    \begin{tabular}{lcl}
    \C{i=CbSkipCCommentFile();}& -&\em return value.\\
    \C{i == 1}& -&\em if file ended before end of comment was reached;\\
    \end{tabular}
\end{itemize}
\item \c{TIPS:}
{\em }
\item \c{BUGS:}
\item \c{SEE ALSO:}
\item \c{TO DO:}
\end{itemize}
#endif
}

int CbCopyCCommentFile(lT,lF,NmFile)
  FILE *lT;	/*  */
  FILE *lF;	/*  */
  char *NmFile;	/*  */
{
/*
   */
#ifdef Doc_CbCopyCCommentFile
\section{Skeleton of CbCopyCCommentFile()}
  \begin{verbatim}
    CbCopyCCommentFile(){
    }
  \end{verbatim}
\section{CbCopyCCommentFile()}
\subsection{Manual}
\begin{itemize}
\item \c{DESCRIPTION:}
\item \c{ARGUMENTS:}
\item \c{EXTERNALS:}
\item \c{RETURN VALUE:}
\begin{itemize}
  \item{\bf Success: }
  \item{\bf Failure: }

    \begin{tabular}{lcl}
    \C{i=CbCopyCCommentFile();}& -&\em return value.\\
    \C{i == 1}& -&\em Your Comment\\
    \end{tabular}
\end{itemize}
\item \c{TIPS:}
{\em }
\item \c{BUGS:}
\item \c{SEE ALSO:}
\item \c{TO DO:}
\end{itemize}
#endif
}

int CMainParameters(str)
  char *str;	/* string '('"arguments" ')' with no white characters inside*/
{
  Undef strncmp();
  /*
   */
#ifdef Doc_CMainParameters
\section{Skeleton of CMainParameters()}
  \begin{verbatim}
    CMainParameters(){
    }
  \end{verbatim}
\section{CMainParameters()}
\subsection{Manual}
\begin{itemize}
\item \c{DESCRIPTION:}
Extracts two formal parameters from argument list of \c{main()} C-routine.
\item \c{ARGUMENTS:} String of characters \c{'('"arguments" ')'} with no white 
characters inside.
\item \c{EXTERNALS:}
\item \c{RETURN VALUE:}
\begin{itemize}
  \item{\bf Success: 0}
  \item{\bf Failure: 1}

  \begin{tabular}{lcl}
  \C{i=CMainParameters();}& -&\em return value.\\
  \C{i == 1}& -&\em if parameter list is incossistent with main definition.\\
  \end{tabular}
\end{itemize}
\item \c{TIPS:}
{\em }
\item \c{BUGS:}
Do not check the out of \c{main()} list of declaration of parameters.
\item \c{SEE ALSO:}
\item \c{TO DO:}
\end{itemize}
#endif
}
#endif
#endif

#undef Doc_Cb_Structure
#ifdef Blb_libCb.c
Blb_libCb.c{
  mzl_C_routines{
  }
  mzl_Cb_routines{
  }
}
#endif

#undef Doc_Table_Of_Content
#ifndef Blb_libCb.c
				PS p= -1 (  0);
#ifndef mzl_C_routines
				PS p=  1 (  1);
int CbIsIndex();		PS p=  1 (  1);
int CbIsCID();			PS p=  1 (  1);
int CbIsCNumber();		PS p=  2 (  1);
int CbIsPrefix();		PS p=  3 (  2);
int CbIsCName();		PS p=  4 (  2);
#endif
int CbIsExtNameObj();		PS p=  5 (  3);
int CbIsIntName();		PS p=  6 (  3);
int CbIsObjType();		PS p=  7 (  4);
int CbIsIntNameObj();		PS p=  8 (  4);
#ifndef mzl_Cb_routines
				PS p=  9 (  5);
int CbSkipCCommentFile();	PS p=  9 (  5);
int CbCopyCCommentFile();	PS p=  9 (  5);
int CMainParameters();		PS p= 10 (  5);
#endif
#endif
