 #include <string.h>
#include <stdlib.h>
#include <math.h>
#include <stdio.h>

#ifdef OPENGL
#include <GL/glx.h>		/* this includes X and gl.h headers */
#endif

#include "XCbType.h"

#ifdef OPENGL
extern GLXContext cxGL;
static GLboolean doubleBuffer=GL_TRUE;
static int configuration[]={GLX_DOUBLEBUFFER,GLX_RGBA,GLX_DEPTH_SIZE,24,None};
static XVisualInfo *viGL;

#endif

static XVisualInfo vi;
static Colormap CMap;
static XSetWindowAttributes swa;
static Atom wmDeleteWindow;

extern int CbNoX;
extern Display*theD;
extern Window theHW,theMW;
extern GC theGC,theGCE,theGCT,theGCM,theGCH,theGCHb,theGCHi;
extern WinPar*WinP;
extern int NWin;
extern XEvent msg;
extern int wF,hF,wFHelp,hFHelp;
extern int XCbNColor;
extern char **ColorNames;
extern unsigned long int ColorPix[];

extern int theD_w,theD_h;
extern int icon_width;
extern int icon_height;
extern char*icon_bits;
extern Window theRW;

static int scr_n;
static int count_W=0;
static unsigned long int theBGColor;
static Font theFont,theHelpFont,theHelpFontB,theHelpFontO;
static XFontStruct*theFontStr,*HelpFontStr1,*HelpFontStr2,*HelpFontStr3;
static XFontStruct*theFontStr,*HelpFontStr1,*HelpFontStr2,*HelpFontStr3;

static char*ln=NULL;
static int Nln=128;
static int wxF;

static int nBoldStr,*LBoldStr;
static char **BoldStr;
static int nBStr0=10,LBStr0[10];
static char* BStr0[10]={
  "Overview:",
  "Tutorial:",
  "Known Bugs:",
  "Control Parameters:",
  "Input:",
  "Output:",
  "Tips:",
  "Description:",
  "Algorithm:",
  "ToDo:"
};

static int nBStr1=10,LBStr1[10];
static char* BStr1[10]={
  "Overview:",
  "Tutorial:",
  "Known Bugs:",
  "Control Parameters:",
  "Input:",
  "Output:",
  "Tips:",
  "Description:",
  "Algorithm:",
  "ToDo:"
};

static int nBStr2=10,LBStr2[10];
static char* BStr2[10]={
  "Overview:",
  "Tutorial:",
  "Known Bugs:",
  "Control Parameters:",
  "Input:",
  "Output:",
  "Tips:",
  "Description:",
  "Algorithm:",
  "ToDo:"
};

static int nBStr3=10,LBStr3[10];
static char* BStr3[10]={
  "Overview:",
  "Tutorial:",
  "Known Bugs:",
  "Control Parameters:",
  "Input:",
  "Output:",
  "Tips:",
  "Description:",
  "Algorithm:",
  "ToDo:"
};

int XSetBGColor()
{
  Colormap theColormap;
  XColor theColor;

  theColormap= DefaultColormap(theD,scr_n);
  if(XParseColor(theD,theColormap,ColorNames[44],&theColor)==0){
    printf("%s - Color-name is not resolved in XSetBGColor()%c\n",
	   ColorNames[44],7);
  }
  
  XAllocColor(theD,theColormap,&theColor);
  theBGColor= theColor.pixel;
  return(0);
}
#ifdef OPENGL
int Win4GL()
{
  /*** (3) make sure OpenGL's GLX extension supported ***/
  if (!glXQueryExtension(theD, NULL, NULL)){
    fprintf(stderr, "WinGL(): X server has no OpenGL GLX extension\n");
  }
  /*** (4) find an appropriate visual and a colormap for it ***/
  /* find an OpenGL-capable RGB visual with depth buffer */
  if (!doubleBuffer) goto SingleBufferOverride;

  viGL	=glXChooseVisual(theD,DefaultScreen(theD),configuration);
  if(viGL == NULL){
  SingleBufferOverride:
    viGL = glXChooseVisual(theD, DefaultScreen(theD),configuration+1);
    if (viGL == NULL)
    fprintf(stderr, "WinGL(): no appropriate RGB visual with depth buffer\n");
    doubleBuffer=GL_FALSE;
  }
  cxGL	=glXCreateContext(theD,viGL,NULL,GL_TRUE);
  if(cxGL == NULL){
    fprintf(stderr, "WinGL(): could not create rendering context");
    return(1);
  }
  return(0);
}
#endif

int screen_attributes(int *theD_w,int *theD_h)
{
  int *li,n=0;

  if((theD=XOpenDisplay(NULL)) == NULL){
    fprintf(stderr,"cannot connect to X server %s\n",XDisplayName(NULL));
    exit(-1);
  }
  scr_n		=DefaultScreen(theD);
  *theD_h	=DisplayHeight(theD,scr_n);
  *theD_w	=DisplayWidth(theD,scr_n);
  theRW		=RootWindow(theD,scr_n);
  configuration[3]=DefaultDepth(theD,scr_n);
  XSetBGColor();

#ifdef OPENGL
  Win4GL();
  if(viGL != NULL){
    CMap=XCreateColormap(theD,theRW,viGL->visual, AllocNone);
    swa.colormap =CMap;
  }
  swa.background_pixel=theBGColor;
  swa.border_pixel = 0;
  swa.event_mask=ExposureMask|StructureNotifyMask|KeyPressMask
	       |EnterWindowMask|Button1MotionMask|Button2MotionMask
    |Button3MotionMask
    |ButtonPressMask|ButtonReleaseMask;
#endif

  wmDeleteWindow = XInternAtom(theD, "WM_DELETE_WINDOW", False);

  return(0);
}
     
int XCbFontDir()
{
  char *lL[2]={
#ifdef H
    "/usr/X11R6/lib/X11/fonts/misc/"
    ,"/usr/X11R6/lib/X11/fonts/75dpi/"
#endif
    "/usr/share/fonts/misc/"
    ,"/usr/share/fonts/75dpi/"
  };
#ifdef H
  XSetFontPath(theD,lL,2);
#endif
  return(0);
}

int XCbSpecifyColors()
{
  int i;
  Colormap theColormap;
  XColor theColor;

  theColormap	=DefaultColormap(theD,scr_n);
  for(i=0; i < XCbNColor; i++){
    if(XParseColor(theD,theColormap,ColorNames[i],&theColor)==0){
      printf("%s[%2d] - Color-name is not resolved in specify_colors()%c\n",
	     ColorNames[i],i,7);
    }
    XAllocColor(theD,theColormap,&theColor);
    ColorPix[i]	=theColor.pixel;
  }

  return(0);
}

int create_window(int i)
{
  WinPar* WP;
  unsigned int border_width= 4;
  Pixmap icon_pixmap;
  XSizeHints size_hints;
  XIconSize*size_list;
  XEvent rep;

  WP	=WinP+i;
#ifdef OPENGL
  WP->W= XCreateWindow(theD,theRW,WP->iX,WP->iY,WP->iW,WP->iH,
		      0, viGL->depth,InputOutput, viGL->visual,
		      CWBackPixel|CWBorderPixel|CWColormap|CWEventMask,&swa);
#else
  WP->W= XCreateSimpleWindow(theD,theRW,WP->iX,WP->iY,WP->iW,WP->iH,
			     border_width,BlackPixel(theD,scr_n),
			     theBGColor);
#endif

  XSetWMProtocols(theD,WP->W,&wmDeleteWindow, 1);
  icon_pixmap= XCreateBitmapFromData(theD,WP->W,icon_bits,
				     icon_width,icon_height);
  size_hints.flags= USPosition|USSize|PMinSize;
  size_hints.min_width= 217;
  size_hints.min_height= 150;
  {
    XWMHints wm_hints;
    XClassHint class_hints;
    XTextProperty windowName,iconName;

    if(XStringListToTextProperty(&WP->nm,1,&windowName)==0){
      fprintf(stderr," structure allocation for window failed.\n");
      exit(-1);
    }
    if(XStringListToTextProperty(&WP->nm,1,&iconName)==0){
      fprintf(stderr,"structure allocation for icon failed.\n");
      exit(-1);
    }
    wm_hints.initial_state= WP->state ? NormalState : IconicState;
    wm_hints.input= True;
    wm_hints.icon_pixmap= icon_pixmap;
    wm_hints.icon_x= WP->iconx;
    wm_hints.icon_y= WP->icony;
    wm_hints.flags	=StateHint|IconPixmapHint|InputHint|IconPositionHint;
    class_hints.res_name= NULL;
    class_hints.res_class= WP->nm;
    XSetWMProperties(theD,WP->W,&windowName,&iconName,
		     NULL,0,&size_hints,&wm_hints,
		     &class_hints);
  }
#ifndef OPENGL

#ifdef H
  XSelectInput(theD,WP->W,ExposureMask|StructureNotifyMask|KeyPressMask
	       |EnterWindowMask|Button1MotionMask|Button2MotionMask
	       |ButtonPressMask|ButtonReleaseMask);
#endif
  XSelectInput(theD,WP->W,ExposureMask|StructureNotifyMask|KeyPressMask
	       |EnterWindowMask|Button1MotionMask|Button2MotionMask
	       |Button3MotionMask|ButtonPressMask|ButtonReleaseMask);

#endif
  if(CbNoX == 0) XMapWindow(theD,WP->W);
  if(count_W == 0){
    XGCValues val;
    char fontname[6];
    int x,y;
    Window c;

    if(wF < 10){
      if(hF< 10){
	sprintf(fontname,"%1dx%1d",wF,hF);
      }
      else{
	sprintf(fontname,"%1dx%2d",wF,hF);
      }
    }
    else{
      if(hF<10){
	sprintf(fontname,"%2dx%1d",wF,hF);
      }
      else{
	sprintf(fontname,"%2dx%2d",wF,hF);
      }
    }
    theFontStr= XLoadQueryFont(theD,fontname);
    wF=XTextWidth(theFontStr,"x",1);
#ifdef H
    XFreeFont(theD,theFontStr);
    theFont= XLoadFont(theD,fontname);
#endif
    theFont	=theFontStr->fid;
    val.font= theFont;
    val.foreground= BlackPixel(theD,scr_n);
    val.background= WhitePixel(theD,scr_n);

    theGC	=XCreateGC(theD,WP->W
			   ,GCFont|GCForeground|GCBackground,&val);
    theGCT	=XCreateGC(theD,WP->W,GCFont|GCForeground|GCBackground,&val);
    theGCE	=XCreateGC(theD,WP->W,GCFont|GCForeground|GCBackground,&val);
    XCbSpecifyColors();
    XSetForeground(theD,theGCE,ColorPix[45]);
    XWarpPointer(theD,theRW,WP->W,0,0,theD_w,theD_h,100,100);
  }
  count_W++;
  return(0);
}

static XSizeHints HlpSize;

int XCbCreateHelpWindowXLi(WinPar*WP)
{
  int i;
  XSetWindowAttributes Attr;
  unsigned int border_width=1;
  
  ln	=(char*)malloc(Nln*sizeof(char));
  for(i=0; i < nBStr0; i++){
    LBStr0[i]	=strlen(BStr0[i]);
  }
  for(i=0; i < nBStr1; i++){
    LBStr1[i]	=strlen(BStr1[i]);
  }
  for(i=0; i < nBStr2; i++){
    LBStr2[i]	=strlen(BStr2[i]);
  }
  for(i=0; i < nBStr3; i++){
    LBStr3[i]	=strlen(BStr3[i]);
  }

  WP->state	=0;
  WP->W	=XCreateSimpleWindow(theD,theRW,WP->iX,WP->iY,WP->iW,WP->iH,
			     border_width,BlackPixel(theD,scr_n),
			     WhitePixel(theD,scr_n));
  theHW	=WP->W;
  Attr.override_redirect=1;
  Attr.save_under=True;
  XChangeWindowAttributes(theD,theHW,
			  CWOverrideRedirect|CWSaveUnder,&Attr);
  
  HlpSize.flags		=USPosition|USSize|PMinSize;
  HlpSize.min_width	=217;
  HlpSize.min_height	=150;
  HlpSize.min_width	=400;
  HlpSize.min_height	=300;
  {
    XWMHints wm_hints;
    XClassHint class_hints;
    XTextProperty windowName;

    if(XStringListToTextProperty(&WP->nm,1,&windowName)==0){
      puts(" structure allocation for window failed.");
      exit(-1);
    }
    wm_hints.initial_state	=WP->state ? NormalState:IconicState;
    wm_hints.input= True;
    wm_hints.flags= StateHint|InputHint;
    class_hints.res_name= NULL;
    class_hints.res_class= WP->nm;

    XSetWMProperties(theD,theHW,&windowName,NULL,
		     NULL,0,&HlpSize,&wm_hints,
		     &class_hints);
  }
  XSelectInput(theD,theHW,ExposureMask|Button1MotionMask|
	       ButtonPressMask|ButtonReleaseMask|StructureNotifyMask);
  {
    int L;
    XGCValues val;
    char ln[0x100];
    char ln0[0x20]="-adobe-courier-";
    char ln1[0x20]="medium-";
    char ln2[0x20]="r-*-*-";
    char ln3[0x20]="20-";
    char ln4[0x20]="*-*-*-*-*-*-*";
    char fontname[0x10];

    sprintf(ln3,"%d",hFHelp);
    sprintf(ln,"%s%s%s%s%s",ln0,ln1,ln2,ln3,ln4);

    L	=sprintf(fontname,"%dx%d",wF,hF);
    HelpFontStr1	=XLoadQueryFont(theD,fontname);
#ifdef H
    HelpFontStr= XLoadQueryFont(theD,"*helvetica-medium-r-normal--12*");
    HelpFontStr1= XLoadQueryFont(theD,ln);
    if(HelpFontStr1 == NULL){
      out("ss",ln," is not available");
    }
#endif
    theHelpFont	=HelpFontStr1->fid;
    val.font	=theHelpFont;
    val.foreground	=BlackPixel(theD,scr_n);
    val.background	=WhitePixel(theD,scr_n);
    theGCH	=XCreateGC(theD,theHW,GCFont|GCForeground|GCBackground,&val);
#ifdef H
    HelpFontStr	=XLoadQueryFont(theD,fontname);
#endif
    *ln2	='o';
    sprintf(ln,"%s%s%s%s%s",ln0,ln1,ln2,ln3,ln4);

    HelpFontStr2= XLoadQueryFont(theD,ln);
    if(HelpFontStr2 == NULL){
      out("ss",ln," is not available");
    }
    hFHelp	=HelpFontStr1->ascent+HelpFontStr1->descent;
    wxF		=HelpFontStr1->min_bounds.width;

    theHelpFontO =HelpFontStr2->fid;
    val.font	 =theHelpFontO;
    val.foreground	=ColorPix[4];
    theGCHi	=XCreateGC(theD,theHW,GCFont|GCForeground|GCBackground,&val);
#ifdef H
    strcpy(fontname+L,"bold");
    HelpFontStr	=XLoadQueryFont(theD,fontname);
#endif
#ifdef H
    lc	="-adobe-courier-bold-r-*-*-*-120-*-75-m-*-*-*";
#endif
    strcpy(ln1,"bold-");
    sprintf(ln,"%s%s%s%s%s",ln0,ln1,ln2,ln3,ln4);
    HelpFontStr3= XLoadQueryFont(theD,ln);
    if(HelpFontStr3 == NULL){
      out("ss",ln," is not available");
    }
    if(HelpFontStr3 == NULL){
      out("ss",fontname," is not available");
    }
    theHelpFontB	=HelpFontStr3->fid;
    val.font	=theHelpFontB;
    val.foreground	=ColorPix[14];
    theGCHb	=XCreateGC(theD,theHW,GCFont|GCForeground|GCBackground,&val);

    val.font	=theHelpFont;
    val.foreground	=WhitePixel(theD,scr_n);
    val.background	=ColorPix[14];
    theGCM=	XCreateGC(theD,theRW,GCFont|GCForeground|GCBackground,&val);
  }
  count_W++;
  return(0);
}

int XCbCreateHelpWindow(WinPar*WP)
{
  int i;
  XSetWindowAttributes Attr;
  unsigned int border_width=1;
  char *lc;
  
  ln	=(char*)malloc(Nln*sizeof(char));
  for(i=0; i < nBStr0; i++){
    LBStr0[i]	=strlen(BStr0[i]);
  }
  for(i=0; i < nBStr1; i++){
    LBStr1[i]	=strlen(BStr1[i]);
  }
  for(i=0; i < nBStr2; i++){
    LBStr2[i]	=strlen(BStr2[i]);
  }
  for(i=0; i < nBStr3; i++){
    LBStr3[i]	=strlen(BStr3[i]);
  }

  WP->state	=0;
  WP->W	=XCreateSimpleWindow(theD,theRW,WP->iX,WP->iY,WP->iW,WP->iH,
			     border_width,BlackPixel(theD,scr_n),
			     WhitePixel(theD,scr_n));
  theHW	=WP->W;
  Attr.override_redirect=1;
  Attr.save_under=True;
  XChangeWindowAttributes(theD,theHW,
			  CWOverrideRedirect|CWSaveUnder,&Attr);
  
  HlpSize.flags		=USPosition|USSize|PMinSize;
  HlpSize.min_width	=217;
  HlpSize.min_height	=150;
  HlpSize.min_width	=400;
  HlpSize.min_height	=300;
  {
    XWMHints wm_hints;
    XClassHint class_hints;
    XTextProperty windowName;

    if(XStringListToTextProperty(&WP->nm,1,&windowName)==0){
      puts(" structure allocation for window failed.");
      exit(-1);
    }
    wm_hints.initial_state	=WP->state ? NormalState:IconicState;
    wm_hints.input= True;
    wm_hints.flags= StateHint|InputHint;
    class_hints.res_name= NULL;
    class_hints.res_class= WP->nm;

    XSetWMProperties(theD,theHW,&windowName,NULL,
		     NULL,0,&HlpSize,&wm_hints,
		     &class_hints);
  }
  XSelectInput(theD,theHW,ExposureMask|Button1MotionMask|
	       ButtonPressMask|ButtonReleaseMask|StructureNotifyMask);
  {
    int L;
    XGCValues val;
    
    char fontname[6];
    if(wFHelp < 10){
      if(hFHelp < 10)
	sprintf(fontname,"%1dx%1d",wFHelp,hFHelp);
      else
	sprintf(fontname,"%1dx%2d",wFHelp,hFHelp);
    }
    else{
      if(hFHelp<10)
	sprintf(fontname,"%2dx%1d",wFHelp,hFHelp);
      else
	sprintf(fontname,"%2dx%2d",wFHelp,hFHelp);
    }
    L	=strlen(fontname);
#ifdef H
    HelpFontStr= XLoadQueryFont(theD,"*helvetica-medium-r-normal--12*");
    HelpFontStr	=XLoadQueryFont(theD,fontname);
#endif
    lc	="-adobe-courier-medium-r-*-*-*-120-*-75-m-*-*-*";
    HelpFontStr1= XLoadQueryFont(theD,lc);
    if(HelpFontStr1 == NULL){
      out("ss",lc," is not available");
    }
    hFHelp	=HelpFontStr1->ascent+HelpFontStr1->descent;
    wxF		=HelpFontStr1->min_bounds.width;

    theHelpFont	=HelpFontStr1->fid;
    val.font	=theHelpFont;
    val.foreground	=BlackPixel(theD,scr_n);
    val.background	=WhitePixel(theD,scr_n);
    theGCH	=XCreateGC(theD,theHW,GCFont|GCForeground|GCBackground,&val);
#ifdef H
    HelpFontStr	=XLoadQueryFont(theD,fontname);
#endif
    lc	="-adobe-courier-medium-o-*-*-*-120-*-75-m-*-*-*";
    HelpFontStr2= XLoadQueryFont(theD,lc);
    if(HelpFontStr2 == NULL){
      out("ss",lc," is not available");
    }
    theHelpFontO =HelpFontStr2->fid;
    val.font	 =theHelpFontO;
    val.foreground	=ColorPix[4];
    theGCHi	=XCreateGC(theD,theHW,GCFont|GCForeground|GCBackground,&val);
#ifdef H
    strcpy(fontname+L,"bold");
    HelpFontStr	=XLoadQueryFont(theD,fontname);
#endif
    lc	="-adobe-courier-bold-r-*-*-*-120-*-75-m-*-*-*";
    HelpFontStr3= XLoadQueryFont(theD,lc);
    if(HelpFontStr3 == NULL){
      out("ss",lc," is not available");
    }
    if(HelpFontStr3 == NULL){
      out("ss",fontname," is not available");
    }
    theHelpFontB	=HelpFontStr3->fid;
    val.font	=theHelpFontB;
    val.foreground	=ColorPix[14];
    theGCHb	=XCreateGC(theD,theHW,GCFont|GCForeground|GCBackground,&val);

    val.font	=theHelpFont;
    val.foreground	=WhitePixel(theD,scr_n);
    val.background	=ColorPix[14];
    theGCM=	XCreateGC(theD,theRW,GCFont|GCForeground|GCBackground,&val);
  }
  count_W++;
  return(0);
}

int XCbCreateMenuWindow(WinPar*WP)
{
  XSetWindowAttributes Attr;
  theMW	=XCreateSimpleWindow(theD,theRW,WP->iX,WP->iY,WP->iW,WP->iH,
			     0,ColorPix[0],ColorPix[8]);
  WP->W	=theMW;
  Attr.override_redirect	=1;
  Attr.save_under	=1;
  XChangeWindowAttributes(theD,theMW,
			  CWOverrideRedirect|CWSaveUnder,&Attr);
  XSelectInput(theD,theMW,ButtonPressMask|ButtonReleaseMask);
  count_W++;

  XCbSetMenuTexts();
  return(0);
}

int XCbHelpText(char *text)
{
  int Fl,dn;
  int i,j,jj;
  int FlS;
  int n,k;
  int y,dy,H,Nw;
  char	*p,*p1;
  GC iGC;
  int iB;
  char	*lc;

  int nkB;
  int kB[0x20];

  Nw	=WinP[NWin].iW/wxF;
  H	=WinP[NWin].iH;
  dy	=hFHelp+2;
  n	=1;
  y	=dy;
  p1	=*text == '\n' ? text+1 : text;

  p	=ln;
  *p	='\0';
  k	=0;
  Fl	=0;
  FlS	=0;
  iB	=0;
  nkB	=nBoldStr;
  for(i=0; i < nBoldStr; i++) kB[i]=i;

  while(*p1 != '\0' && y < H){/*Inside the text*/
    if(iB == 0 && isspace(*p1)){
      /*Space or end of text vs non-space */
      if(*p1 != '\n'){
	Fl	=*p1 == '\t' ? 3 : 2;
      }
      else{
	if(*(p1-1) == ';'){
	  p--;
	  k--;
	  n--;
	  Fl	=1;
	}
      }
    }
    else{/*Advance word and position;*/
      *p++	=*p1;
      jj	=0;
      for(j =0; j < nkB; j++){
	i	=kB[j];
	lc	=BoldStr[i]+iB;
	if(iB < LBoldStr[i] && *p1 == *lc){
	  kB[jj]	=i;
	  jj++;
	}
      }
      if(jj && iB == k){
	nkB	=jj;
	iB++;
	if(jj == 1 && *(lc+1) == '\0'){
	  Fl	|=8;
	  iB	=0;
	}
      }	
      else{
	iB	=0;
      }
      if(iB == 0 && nkB < nBoldStr){
	nkB	=nBoldStr;
	for(i=0; i < nBoldStr; i++){
	  kB[i]	=i;
	}
      }
      k++;
      n++;
    }

    if(*p1 == '"'){/*Needs font modification*/
      FlS	^=0x10000;
      if((FlS&0x10000) == 0){
	Fl	|=4;
      }
    }
    else{
      if((FlS&0x10000) == 0){
	if(*p1 == '(' || *p1 == '[' || *p1 == '{' || *p1 == '<'){
	  FlS++;
	}
	if((FlS&0xFFFF) > 0 && (*p1 == ')' || *p1 == ']' || *p1 == '}' 
				|| *p1 == '>')){
	  FlS--;
	  if(FlS == 0) Fl	|=4;
	}
      }
    }
    p1++;
    if(*p1 == '\0' && k){
      Fl	|=1;
    }

    if(k && Fl){/*End of word*/
      *p	='\0';
      if((Fl&0x08)){
	iGC	=theGCHb;
	Fl	-=8;
      }
      else if((Fl&0x04)){
	iGC	=theGCH;
	Fl	-=4;
      }
      else{
	iGC	=FlS ? theGCH : theGCHi;
      }
      if(n > Nw){
	y	+=dy;
	n	=k+1;
      }
      XDrawString(theD,theHW,iGC,(n-k)*wxF,y,ln,k);
      k	=0;
      p	=ln;
    }
    
    /*Advance position;*/
    if(Fl){
      if(Fl == 2){
	n++;
      }
      else{
	if(Fl == 1){
	  y	+=dy;
	  n	=1;
	}
	else{
	  n	=((n-1)/8+1)*8+1;
	}
      }
      Fl=0;
    }
    /*Advance one character;*/
  }
  XFlush(theD);
  return(0);
}

int XCbHelpTextHeight(char*text)
{
  int n,Fl,Flcont;
  int x,y,dy,W,H,w,Nw;
  char	*p,*p1;
  char	*lc;;
   

  W	=WinP[NWin].iW;
  H	=WinP[NWin].iH;

  Nw	=W/wxF;
  x	=wxF;
  dy	=hFHelp+2;
  y	=dy;
  p1	=*text == '\n' ? text+1 : text;

  p	=ln;
  *p	='\0';
  n	=0;
  w	=0;
  Fl	=isspace(*p1) ? 0 : 1;
  Flcont	=0;
  while(*p1 != '\0'){
    if(isspace(*p1)){
      if(Fl == 1){
	if(*p1 == '\n' && *(p1-1) == ';'){
	  n--;
	  ln[n]	='\0';
	  Flcont	=1;
	}
	else{
	  Flcont	=0;
	}
	if(x+w > W){
	  y  	+=dy;
	  x	=wxF;
	}
	ln[n]	='\0';
	if(Flcont == 1){
	  y	+=dy;
	  x	=wxF;
	}
	else{
	  x	+=w;
	}
      }
      Fl	=0;
      n	=0;

      while(isspace(*p1)){
	if(*p1 == '\n'){
	  if(Fl == 0){
	    n	=Flcont ? 0 : 1;
	  }
	  else{
	    n	=0;
	  }
	  Fl++;
	  if(Fl==2){
	    x	=wxF;
	    y	+=dy;
	    if(Flcont == 0){
	      y	+=dy;
	    }
	  }
	}
	else{
	  if(*p1=='\t'){
	    n	=(n/8+1)*8;
	  }
	  else{
	    n++;
	  }
	}
	p1++;
      }
      x	+=n*wxF;

      p	=ln;
      n	=0;
      w	=0;
      Fl	=0;
    }
    if(n >= Nln){
      Nln	+=120;
      ln	=(char*)realloc((void*)ln,Nln*sizeof(char));
      p	=ln+n;
    }
    if(*p1 == '\0')
      break;
    Fl	=1;
    *p++	=*p1++;
    w	+=XTextWidth(HelpFontStr3,ln+n,1);
    n++;
    if(w >= W){
      y	+=dy;
      x	=wxF;
      *p	='\0';
      x	+=w;
      w	=XTextWidth(HelpFontStr3,ln+n-2,2);
      ln[0]	=ln[n-2];
      ln[1]	=ln[n-1];
      n	=2;
      p	=ln+n;
    }
  }

  if(n){
    w	=XTextWidth(HelpFontStr3,ln,n);
    if(x+w > W){
      y	+=dy;
      x	=wxF;
    }
  }
#ifdef H
  XDrawString(theD,theHW,theGCH,x,y,ln,n);
#endif
  return(y+2);
}

int XCbHelpWindow(int iWin,int x,int y,char *ptxt,int k)
{
  switch(k){
  case 0:
    nBoldStr	=nBStr0;
    LBoldStr	=LBStr0;
    BoldStr	=BStr0;
    break;
  case 1:
    nBoldStr	=nBStr1;
    LBoldStr	=LBStr1;
    BoldStr	=BStr1;
    break;
  case 2:
    nBoldStr	=nBStr2;
    LBoldStr	=LBStr2;
    BoldStr	=BStr2;
    break;
  case 3:
    nBoldStr	=nBStr3;
    LBoldStr	=LBStr3;
    BoldStr	=BStr3;
    break;
  default:
    nBoldStr	=nBStr0;
    LBoldStr	=LBStr0;
    BoldStr	=BStr0;
    break;
  }

  WinP[NWin].iH	=ptxt == NULL ? XCbHelpTextHeight("No Help is available") :
    XCbHelpTextHeight(ptxt);
  x	+=WinP[iWin].iX;
  y	+=WinP[iWin].iY+hFHelp;

  if(x+WinP[NWin].iW > theD_w) x +=theD_w-x-WinP[NWin].iW;
  WinP[NWin].iX	=x;
  WinP[NWin].iY	=y;
  XMoveWindow(theD,theHW,x,y);
  XResizeWindow(theD,theHW,WinP[NWin].iW,WinP[NWin].iH);
  XMapWindow(theD,theHW);
  XRaiseWindow(theD,theHW);
  while(XCheckMaskEvent(theD,ExposureMask|StructureNotifyMask,&msg)) ;
  if(ptxt == NULL){
    XCbHelpText("No Help was available");
  }
  else{
    XCbHelpText(ptxt);
  }
  do{
    XNextEvent(theD,&msg);
  }while(msg.type != ButtonRelease);
  XUnmapWindow(theD,theHW);
  while(XCheckMaskEvent(theD,ExposureMask|StructureNotifyMask,&msg)) ;
  return(0);
}

void XCbFlush()
{
  XFlush(theD);
}

void endX()
{
  if(ln != NULL){
    free(ln);
  }
  XFreeGC(theD,theGCM);
  XFreeGC(theD,theGCH);
  XFreeGC(theD,theGC);
#ifdef H
  XUnloadFont(theD,theFont);
#endif
  XFreeFont(theD,HelpFontStr3);
  XFreeFont(theD,HelpFontStr2);
  XFreeFont(theD,HelpFontStr1);
  XFreeFont(theD,theFontStr);
  while(count_W--) XDestroyWindow(theD,WinP[count_W].W);

  XCloseDisplay(theD);
  exit(0);
}

int CloseX()
{
  if(ln != NULL) free(ln);
  XFreeGC(theD,theGCM);
  XFreeGC(theD,theGCH);
  XFreeGC(theD,theGC);
#ifdef H
  XUnloadFont(theD,theFont);
#endif
  XFreeFont(theD,HelpFontStr3);
  XFreeFont(theD,HelpFontStr2);
  XFreeFont(theD,HelpFontStr1);
  XFreeFont(theD,theFontStr);

  while(count_W--) XDestroyWindow(theD,WinP[count_W].W);
  XCloseDisplay(theD);
  return(0);
}
