#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include "CbType.h"

#ifdef CRAY
#define ioftnb_ IOFTNB
#define ioftns_ IOFTNS
#define ioftna_ IOFTNA
#define iblbsv_ IBLBSV
#define istgsv_ ISTGSV
#define iblbrs_ IBLBRS
#define istgrs_ ISTGRS
#define iblbwr_ IBLBWR
#define istgwr_ ISTGWR
#define iblbrd_ IBLBRD
#define istgrd_ ISTGRD
#define iblbbo_ IBLBBO
#define istgbo_ ISTGBO
#define iblbbi_ IBLBBI
#define istgbi_ ISTGBI
#define iblbao_ IBLBAO
#define istgao_ ISTGAO
#define iblbai_ IBLBAI
#define istgai_ ISTGAI
#endif

#ifdef HP
#define ioftnb_ ioftnb
#define ioftns_ ioftns
#define ioftna_ ioftna
#define iblbsv_ iblbsv
#define istgsv_ istgsv
#define iblbrs_ iblbrs
#define istgrs_ istgrs
#define iblbwr_ iblbwr
#define istgwr_ istgwr
#define iblbrd_ iblbrd
#define istgrd_ istgrd
#define iblbbo_ iblbbo
#define istgbo_ istgbo
#define iblbbi_ iblbbi
#define istgbi_ istgbi
#define iblbao_ iblbao
#define istgao_ istgao
#define iblbai_ iblbai
#define istgai_ istgai
#endif

extern CbUnits*XUnits;
extern int NXUnits;

static char NmF[80],ln[80],NmIOFile[80];

static BLB*blb;
static int nblb,iblb;

static InpTblPar*Tbl,*pntT;
static int nTbl;

static FILE*fpASC,*fpBnr;

static FILE**fpBRc,**fpBSv,**fpBRd,**fpBWr,**fpBnrI,**fpBnrO,
**fpAscI,**fpAscO;

static CbIOLoop*IOLoop;
static CbIOVec*IOVec;
static CbIOObj*IOObj;
static CbIOSet**IOSet;
static int StackI[10];
static int ILc;
static struct stat stbuff;

int Cb2IOBlbTblAddress(int nblb0,BLB*blb0,int nTbl0,InpTblPar*Tbl0,
		       FILE***fpTbl)
{
  nblb	=nblb0;
  nTbl	=nTbl0;
  blb	=blb0;
  Tbl	=Tbl0;
  fpBRc	=fpTbl[0];
  fpBSv	=fpTbl[1];
  fpBRd	=fpTbl[2];
  fpBWr	=fpTbl[3];
  fpBnrI=fpTbl[4];
  fpBnrO=fpTbl[5];
  fpAscI=fpTbl[6];
  fpAscO=fpTbl[7];
  return(0);
}

int CbGiveIOStruct(CbIOLoop*Loop,CbIOVec*Vec,CbIOObj*Obj,CbIOSet**Set)
{
  IOLoop=Loop;
  IOVec	=Vec;
  IOObj	=Obj;
  IOSet	=Set;
  return(0);
}

int CbSaveTbl(int iT)
{
  int i,j,L,L1,L2;
  char ch,ch1;
  FILE *fp;

  ch	='\0';

  pntT	=Tbl+iT;
  i	=pntT->iB;
  if(blb[i].path[0]!='\0'){
    sprintf(NmF,"%s/Wrk/%s.tb",blb[i].path,pntT->Nm);
  }
  else{
    sprintf(NmF,"Wrk/%s.tb",pntT->Nm);
  }

  fp	=fopen(NmF,"r");
  if(fp != NULL){
    char ln[132];
    sprintf(ln,"mv %s %s.bak",NmF,NmF);
    system(ln);
    fclose(fp);
  }
  fp	=fopen(NmF,"wb");
  if(fp == NULL){
    printf("<%s> -- cannot open file for Tbl %s%c\n",NmF,pntT->Nm,7);
    return(1);
  }

  fwrite(&pntT->mode,sizeof(int),1,fp);
  fwrite(&pntT->NP,sizeof(int),1,fp);
  if(pntT->NP){
    L	=0;
    for(i=0; i < pntT->NP; i++){
      L		+=strlen(pntT->nmEP[i])+1;
      if(pntT->nmP[i]!=NULL)
	L		+=strlen(pntT->nmP[i])+1;
      else
	L++;
    }
    fwrite(&L,sizeof(int),1,fp);

    for(i=0; i < pntT->NP; i++){
      L	=strlen(pntT->nmEP[i])+1;
      fwrite(pntT->nmEP[i],sizeof(char),L,fp);
      if(pntT->nmP[i]!=NULL){
	L	=strlen(pntT->nmP[i])+1;
	fwrite(pntT->nmP[i],sizeof(char),L,fp);
      }
      else{
	L	=1;
	fwrite(&ch,sizeof(char),L,fp);
      }
    }
    fwrite(pntT->iCP,sizeof(int),pntT->NP,fp);
    fwrite(pntT->nUP,sizeof(int),pntT->NP,fp);
    fwrite(pntT->scP,sizeof(double),pntT->NP,fp);

    for(i=0;i < pntT->NP; i++){
      if(pntT->nmP[i]!=NULL&&pntT->nmP[i][0]!='\0'){
	if(pntT->aEP[i]!=NULL){
	  L1	=strlen(pntT->aEP[i])+1;
	  L	=L1;
	  ch1	=*pntT->vaP[i];
	  L++;
	  if(pntT->aP[i]!=NULL){
	    L2	=strlen(pntT->aP[i])+1;
	  }
	  else{
	    L2	=1;
	  }
	  L	+=L2;
	  fwrite(&L,sizeof(int),1,fp);
	  fwrite(pntT->aEP[i],sizeof(char),L1,fp);
	  fwrite(&ch1,sizeof(char),1,fp);
	  if(pntT->aP[i]!=NULL){
	    fwrite(pntT->aP[i],sizeof(char),L2,fp);
	  }
	  else{
	    fwrite(&ch,sizeof(char),1,fp);
	  }
	}
	else{
	  L	=0;
	  fwrite(&L,sizeof(int),1,fp);
	}
	switch(pntT->iCP[i]&7){
	case 0:
	  L	=strlen(pntT->P[i])+1;
	  fwrite(&L,sizeof(int),1,fp);
	  break;
	case 1:
	  L	=sizeof(double);
	  break;
	case 3:
	  L	=sizeof(float);
	  break;
	case 2:
	  L	=sizeof(int);
	  break;
	}
	fwrite(pntT->P[i],sizeof(char),L,fp);
      }
    }
  }

  fwrite(&pntT->NNmV,sizeof(int),1,fp);
  if(pntT->NNmV){
    L	=0;
    for(i=0; i < pntT->NNmV; i++){
      L	+=strlen(pntT->nmEV[i])+1;
      if(pntT->nmV[i]!=NULL)
	L	+=strlen(pntT->nmV[i])+1;
      else
	L++;
    }
    fwrite(&L,sizeof(int),1,fp);

    for(i=0; i < pntT->NNmV; i++){
      L	=strlen(pntT->nmEV[i])+1;
      fwrite(pntT->nmEV[i],sizeof(char),L,fp);
      if(pntT->nmV[i]!=NULL){
	L	=strlen(pntT->nmV[i])+1;
	fwrite(pntT->nmV[i],sizeof(char),L,fp);
      }
      else{
	L	=1;
	fwrite(&ch,sizeof(char),L,fp);
      }
    }
    L	=pntT->NNmV;
    fwrite(pntT->iCV,sizeof(int),L,fp);
    fwrite(pntT->nUV,sizeof(int),L,fp);
    fwrite(pntT->lV,sizeof(int),L,fp);
    fwrite(pntT->laV,sizeof(int),L,fp);
    fwrite(pntT->scV,sizeof(double),L,fp);

    for(i=0; i < pntT->NNmV; i++){
      if(pntT->laV[i]!=0){
	L1	=strlen(pntT->aEV[i])+1;
	if(pntT->aV[i]!=NULL){
	  L2	=strlen(pntT->aV[i])+1;
	}
	else{
	  L2	=1;
	}
	L	=L1+L2;
	fwrite(&L,sizeof(int),1,fp);
	fwrite(pntT->aEV[i],sizeof(char),L1,fp);
	if(pntT->aV[i]!=NULL){
	  fwrite(pntT->aV[i],sizeof(char),L2,fp);
	}
	else{
	  fwrite(&ch,sizeof(char),1,fp);
	}
	L	=pntT->laV[i];
	for(j=0; j < L; j++){
	  fwrite(pntT->vaV[i][j],sizeof(int),1,fp);
	}
      }
      if(pntT->nmV[i]!=NULL){
	switch((pntT->iCV[i]&7)){
	case 0:
	  for(j=0; j < pntT->lV[i]; j++){
	    L= strlen(pntT->V[i][j])+1;
	    fwrite(&L,sizeof(int),1,fp);
	    fwrite(pntT->V[i][j],sizeof(char),L,fp);
	  }
	  break;
	case 1:
	  L	=sizeof(double);
	  for(j=0; j < pntT->lV[i]; j++){
	    fwrite(pntT->V[i][j],sizeof(char),L,fp);
	  }
	  break;
	case 3:
	  L	=sizeof(float);
	  for(j=0; j < pntT->lV[i]; j++){
	    fwrite(pntT->V[i][j],sizeof(char),L,fp);
	  }
	  break;
	case 2:
	  L	=sizeof(int);
	  for(j=0; j < pntT->lV[i]; j++){
	    fwrite(pntT->V[i][j],sizeof(char),L,fp);
	  }
	  break;
	}
      }
    }
  }

  fclose(fp);
  printf("%s --- %s-Tbl has been saved\n",NmF,pntT->Nm);
  return(0);
}

#ifdef H 
int CbWriteTbl(int iT,char *wa)
{
  int i,j,k,n,n1,n2,lV,id,ic;
  int L1,L2,L3,L=8,LN;
  char Sp[32];	/* space line */
  char str[16],Str1[16],Str2[16],Str22[16],Str3[32];
  char StrN[8],ln[32];
  char *lc;
  double s;

  char ch,ch1;

  Sp[0]	='\0';
  pntT	=Tbl+iT;
  i	=pntT->iB;
  if(blb[i].path[0] != '\0'){
    sprintf(NmF,"%s/Wrk/%s.ta",blb[i].path,pntT->Nm);
  }
  else{
    sprintf(NmF,"Wrk/%s.ta",pntT->Nm);
  }

  if(stat(NmF,&stbuff) == 0){
    char ln[132];
    sprintf(ln,"mv %s %s.bak",NmF,NmF);
    system(ln);
  }

  fp	=fopen(NmF,wa);
  if(fp == NULL){
    printf("<%s> -- cannot open file for Tbl %s%c\n",NmF,pntT->Nm,7);
    return(1);
  }

  fprintf(fp,"Tbl mode=%d\n",pntT->mode);
  n	=pntT->NP;
  fprintf(fp,"%d - Number of Parameters\n",n);
  ic	=0;
  for(i=0; i < n; i++){
    if((pntT->iCP[i]&0x08)){
      if(ic) fseek(fp,-1L,SEEK_CUR);
      Sp[ic++]=' ';
      Sp[ic]	='\0';
      putc('{',fp);
      putc('\n',fp);
    }
    else{
      if(pntT->nmP[i] == NULL){
	ic--;
	Sp[ic]	='\0';
	putc('}',fp);
	putc('\n',fp);
      }
    }
    fputs(Sp,fp);

    fprintf(fp,"\"%s\"",pntT->nmEP[i]);
    fprintf(fp,"(%d.d)",pntT->nU[i],pntT->iU[i]);
    fprintf(fp,"\"%s\"=",pntT->aEP[i]);

    if(pntT->nmP[i] != NULL && pntT->nmP[i][0] != '\0'){
      id	=pntT->iCP[i]&0x07;
      switch(id){
      case 0:
	sprintf(StrS,"=\"%c%ds\"",'%',pntT->iUP[i]);
	fprintf(fp,"",pntT->P[i]);
	sprintf(StrS,"str*%d",pntT->iUP[i]);
	lc	=StrS;
	break;
      case 1:
	s	=*(double*)pntT->P[i];
	if(pntT->scP[i] != 1.){
	  s	*=pntT->scP[i];
	}
	numstr(s,str,L);
	lc	="dbl";
	break;
      case 2:
	j	=*(int*)pntT->P[i];
	if(pntT->scP[i] != 1.){
	  j	*=pntT->scP[i];
	}
	sprintf(str,StrI,j);
	lc	="int";
	break;
      case 3:
	s	=*(float*)pntT->P[i];
	if(pntT->scP[i] != 1.){
	  s	*=pntT->scP[i];
	}
	numstr(s,str,L);
	lc	="flt";
	break;
      case 4:
	j	=*(long*)pntT->P[i];
	if(pntT->scP[i] != 1.){
	  j	*=pntT->scP[i];
	}
	sprintf(str,StrI,j);
	lc	="lng";
	break;
      case 5:
	j	=*(int*)pntT->P[i];
	if(pntT->scP[i] != 1.){
	  j	*=pntT->scP[i];
	}
	sprintf(str,StrI,j);
	lc	="mon";
	break;
      }
      if(id){
	fprintf(fp,Str1,str);
      }
      if(L2){
	if(pntT->nUP[i] < 0){
	  fprintf(fp,Str22,"");
	}
	else{
	  fprintf(fp,Str2,XUnits[pntT->nUP[i]].nmU
		  ,XUnits[pntT->nUP[i]].U[pntT->iUP[i]]);
	}
      }
      fprintf(fp,Str3,lc,pntT->iCP[i],pntT->nmP[i]);
      if(pntT->aEP[i] != NULL){
	lc	=pntT->aEP[i];
	fprintf(fp,", \"%s\"[%d]",lc,*pntT->vaP[i]);
	if(pntT->aP[i] != NULL){
	  fprintf(fp," <%s>",pntT->aP[i]);
	}
	else{
	  fprintf(fp," < >");
	}
      }
      fputc(';',fp);
    }
    fputc('\n',fp);
  }
  while(ic){
    ic--;
    Sp[ic]	='\0';
    fputs(Sp,fp);
    putc('}',fp);
    putc('\n',fp);
  }

  n	=pntT->NNmV;
  fprintf(fp,"%d - Number of Vectors\n",n);
  if(n){
    L1	=0;
    L2	=0;
    L3	=0;
    lV	=0;
    for(i=0; i < n; i++){
      j	=strlen(pntT->nmEV[i]);
      if(L1 < j){
	L1	=j;
      }
      if(pntT->nmV[i] != NULL && L3 < (j=strlen(pntT->nmV[i]))){
	L3	=j;
      }
      if(pntT->nUV[i] >= 0){
	j	=strlen(XUnits[pntT->nUV[i]].nmU);
	if(L2 < j){
	  L2	=j;
	}
      }
      k	=pntT->iPV[i] ? pntT->lV[i]-2 : pntT->lV[i];
      if(lV < k){
	lV	=k;
      }
    }
    if(L2){
      sprintf(Str2," [%c%ds.%c4s]",'%',L2,'%');
      sprintf(Str22,"  %c%ds      ",'%',L2);
    }
    sprintf(Str3," (%cs)(%c2d) <%c%ds>",'%','%','%',L3);
    ic	=0;
    Sp[ic]	='\0';
    for(i=0; i < n; i++){
      if((pntT->iCV[i]&8)){
	if(ic){
	  fseek(fp,-1L,SEEK_CUR);
	}
	Sp[ic]	=' ';
	ic++;
	Sp[ic]	='\0';
	putc('{',fp);
	putc('\n',fp);
      }
      else{
	if(pntT->nmV[i] == NULL){
	  ic--;
	  Sp[ic]	='\0';
	  putc('}',fp);
	  putc('\n',fp);
	}
      }
      fputs(Sp,fp);
      j		=L1-strlen(pntT->nmEV[i]);
      while(j){
	j--;
	putc(' ',fp);
      }
      putc('<',fp);
      fputs(pntT->nmEV[i],fp);
      putc('>',fp);
      n1	=ic+L1+2;
      if(pntT->nmV[i] != NULL){
	id	=pntT->iCV[i]&7;
	switch(id){
	case 0:
	  sprintf(StrS,"str*%d",pntT->iUV[i]);
	  lc	=StrS;
	  n1	+=3;
	  break;
	case 1:
	  lc	="dbl";
	  break;
	case 2:
	  lc	="int";
	  break;
	case 3:
	  lc	="flt";
	  break;
	case 4:
	  lc	="lng";
	  break;
	case 5:
	  lc	="mon";
	  break;
	}
	if(L2){
	  if(pntT->nUV[i] < 0){
	    fprintf(fp,Str22,"");
	  }
	  else{
	    fprintf(fp,Str2,XUnits[pntT->nUV[i]].nmU
		    ,XUnits[pntT->nUV[i]].U[pntT->iUV[i]]);
	  }
	  n1	+=L2+7;
	}
	n2	=n1+1;
	fprintf(fp,Str3,lc,pntT->iCV[i],pntT->nmV[i]);
	n1	+=3+3+4+L3+4;
	if(pntT->aEV[i] != NULL){
	  fputc(',',fp);
	  lc	=pntT->aEV[i];
	  n1	+=strlen(lc)+8;
	  if(pntT->aV[i] != NULL){
	    n1	+=strlen(pntT->aV[i])-1;
	  }
	  if(n1 > 79){
	    fputc('\n',fp);
	    while(n2){
	      fputc(' ',fp);
	      n2--;
	    }
	  }
	  fprintf(fp," \"%s\"",lc);
	  if(pntT->aV[i] != NULL){
	    fprintf(fp," <%s>",pntT->aV[i]);
	  }
	  else{
	    fprintf(fp," < >");
	  }
	}
	fputc(';',fp);
      }
      fputc('\n',fp);
    }
    while(ic){
      ic--;
      Sp[ic]	='\0';
      fputs(Sp,fp);
      putc('}',fp);
      putc('\n',fp);
    }
    LN	=1;
    i	=1;
    while(i < lV){
      LN++;
      i	*=10;
    }
    sprintf(StrN,"%c%dd",'%',LN);
    sprintf(Str1," %c%ds",'%',L);
    n1	=0;
    n2	=n;
    while(n1 < n){
      fprintf(fp,StrN,n1);
      j	=LN;
      i	=n1;
      while(i < n && j < 80){ 
	if(pntT->nmV[i] != NULL){
	  n2	=(pntT->iCV[i]&7) ? L+1 : 3+pntT->iUV[i];
	  if(pntT->laV[i]){
	    sprintf(ln,"%c%ds    ",'%',n2);
	    n2	+=4;
	  }
	  else{
	    sprintf(ln,"%c%ds",'%',n2);
	  }
	  j	+=n2;
	  if(j < 80){
	    fprintf(fp,ln,pntT->nmEV[i]);
	  }
	}
	i++;
      } 
      n2	=j < 80 ? i : i-1;
      fputc('\n',fp);
      j	=1;
      while(j < LN){
	fputc(' ',fp);
	j++;
      }
      fputc('#',fp);
      for(i=n1; i < n2; i++){
	if(pntT->nmV[i] != NULL){
	  j	=(pntT->iCV[i]&7) ? L+1 : 3+pntT->iUV[i];
	  sprintf(ln,"%c%dd",'%',j);
	  k	=pntT->iPV[i] ? pntT->lV[i]-2 : pntT->lV[i];
	  fprintf(fp,ln,k);
	  if(pntT->laV[i]){
	    fputs("    ",fp);
	  }
	}
      }
      fputc('\n',fp);
      for(j=0; j < lV; j++){
	fprintf(fp,StrN,j);
	for(i=n1; i < n2; i++){
	  k	=pntT->iPV[i] ? pntT->lV[i]-2 : pntT->lV[i];
	  if(pntT->nmV[i] != NULL){
	    id	=pntT->iCV[i]&7;
	    if(j < k){
	      switch(id){
	      case 0:
		sprintf(StrS," \"%c%ds\"",'%',pntT->iUV[i]);
		fprintf(fp,StrS,pntT->V[i][j]);
		break;
	      case 1:
		s	=*(double*)pntT->V[i][j];
		if(pntT->scV[i] != 1.){
		  s	*=pntT->scV[i];
		}
		numstr(s,str,L);
		break;
	      case 2:
	      case 5:
		j	=*(int*)pntT->V[i][j];
		if(pntT->scV[i] != 1.){
		  j	*=pntT->scV[i];
		}
		sprintf(str,StrI,j);
		break;
	      case 3:
		s	=*(float*)pntT->V[i][j];
		if(pntT->scV[i] != 1.){
		  s	*=pntT->scV[i];
		}
		numstr(s,str,L);
		break;
	      case 4:
		j	=*(long*)pntT->V[i][j];
		if(pntT->scV[i] != 1.){
		  j	*=pntT->scV[i];
		}
		sprintf(str,StrI,j);
		break;
	      }
	    }
	    else{
	      *str	='\0';
	      if(id == 0){
		fprintf(fp,StrS,str);
	      }
	    }
	    if(id){
	      fprintf(fp,Str1,str);
	    }
	    if(pntT->laV[i]){
	      if(j < pntT->laV[i]){
		fprintf(fp," [%d]",*(pntT->vaV[i][j]));
	      }
	      else{
		fprintf(fp,"    ");
	      }
	    }
	  }
	} 
	fputc('\n',fp);
      }
      n1	=n2;
    }
  }
  fclose(fp);
  if(*wa == 'w'){
    printf("%s --- %s-Tbl has been written\n",NmF,pntT->Nm);
  }
  else{
    printf("%s --- %s-Tbl has been stored\n",NmF,pntT->Nm);
  }
  return(0);
}

int CbWriteTbl0(int iT,char *wa)
{
  int i,j,k,ka,n,n1,n2,lV,id,ic;
  int LL,LLL;
  int L1,L2,L3,L=8,LN;
  char Sp[32];	/* space line */
  char str[16],Str1[16],Str2[16],Str22[16],Str3[32],StrI[8],StrS[16];
  char StrN[8],ln[0x100];
  char *lc;
  double s;
  FILE * fp;

  Sp[0]	='\0';
  sprintf(StrI,"%c%dd",'%',L);
  sprintf(Str1,"=%c%ds",'%',L);

  pntT	=Tbl+iT;
  i	=pntT->iB;
  if(blb[i].path[0] != '\0'){
    sprintf(NmF,"%s/Wrk/%s.ta",blb[i].path,pntT->Nm);
  }
  else{
    sprintf(NmF,"Wrk/%s.ta",pntT->Nm);
  }

  if(stat(NmF,&stbuff) == 0){
    sprintf(ln,"mv %s %s.bak",NmF,NmF);
    system(ln);
  }

  fp	=fopen(NmF,wa);
  if(fp == NULL){
    printf("<%s> -- cannot open file for Tbl %s%c\n",NmF,pntT->Nm,7);
    return(1);
  }

  fprintf(fp,"%d Tbl mode\n",pntT->mode);
  n	=pntT->NP;
  k	=0;
  for(i=0; i < n; i++){
    if((pntT->iCP[i]&0x07)) k++;
  }
  fprintf(fp,"%d - Number of Parameter data\n",k);
  if(n){
    L1	=0;
    L2	=0;
    L3	=0;
    for(i=0; i < n; i++){
      j	=strlen(pntT->nmEP[i]);
      if(L1 < j) L1=j;
      if(pntT->nmP[i] != NULL && L3 < (j=strlen(pntT->nmP[i]))) L3=j;
      if(pntT->nUP[i] >= 0 && L2 < (j=strlen(XUnits[pntT->nUP[i]].nmU))) L2=j;
    }
    if(L2){
      sprintf(Str2," [%c%ds.%c4s]",'%',L2,'%');
      sprintf(Str22,"  %c%ds      ",'%',L2);
    }
    sprintf(Str3," (%cs)(%c2d) <%c%ds>",'%','%','%',L3);
    ic	=0;
    for(i=0; i < n; i++){
      if((pntT->iCP[i]&0x08)){
	if(ic) fseek(fp,-1L,SEEK_CUR);
	Sp[ic++]=' ';
	Sp[ic]	='\0';
	putc('{',fp);
	putc('\n',fp);
      }
      else{
	if(pntT->nmP[i] == NULL){
	  ic--;
	  Sp[ic]	='\0';
	  putc('}',fp);
	  putc('\n',fp);
	}
      }
      fputs(Sp,fp);
      j		=L1-strlen(pntT->nmEP[i]);
      while(j){
	j--;
	putc(' ',fp);
      }
      putc('<',fp);
      fputs(pntT->nmEP[i],fp);
      putc('>',fp);

      if(pntT->nmP[i] != NULL && pntT->nmP[i][0] != '\0'){
	id	=pntT->iCP[i]&0x07;
	switch(id){
	case 0:
	  sprintf(StrS,"=\"%c%ds\"",'%',pntT->iUP[i]);
	  fprintf(fp,StrS,pntT->P[i]);
	  sprintf(StrS,"str*%d",pntT->iUP[i]);
	  lc	=StrS;
	  break;
	case 1:
	  s	=*(double*)pntT->P[i];
	  if(pntT->scP[i] != 1.){
	    s	*=pntT->scP[i];
	  }
	  numstr(s,str,L);
	  lc	="dbl";
	  break;
	case 2:
	  j	=*(int*)pntT->P[i];
	  if(pntT->scP[i] != 1.){
	    j	*=pntT->scP[i];
	  }
	  sprintf(str,StrI,j);
	  lc	="int";
	  break;
	case 3:
	  s	=*(float*)pntT->P[i];
	  if(pntT->scP[i] != 1.){
	    s	*=pntT->scP[i];
	  }
	  numstr(s,str,L);
	  lc	="flt";
	  break;
	case 4:
	  j	=*(long*)pntT->P[i];
	  if(pntT->scP[i] != 1.){
	    j	*=pntT->scP[i];
	  }
	  sprintf(str,StrI,j);
	  lc	="lng";
	  break;
	case 5:
	  j	=*(int*)pntT->P[i];
	  if(pntT->scP[i] != 1.){
	    j	*=pntT->scP[i];
	  }
	  sprintf(str,StrI,j);
	  lc	="mon";
	  break;
	}
	if(id){
	  fprintf(fp,Str1,str);
	}
	if(L2){
	  if(pntT->nUP[i] < 0){
	    fprintf(fp,Str22,"");
	  }
	  else{
	    fprintf(fp,Str2,XUnits[pntT->nUP[i]].nmU
		    ,XUnits[pntT->nUP[i]].U[pntT->iUP[i]]);
	  }
	}
	fprintf(fp,Str3,lc,pntT->iCP[i],pntT->nmP[i]);
	if(pntT->aEP[i] != NULL){
	  lc	=pntT->aEP[i];
	  fprintf(fp,", \"%s\"[%d]",lc,*pntT->vaP[i]);
	  if(pntT->aP[i] != NULL){
	    fprintf(fp," <%s>",pntT->aP[i]);
	  }
	  else{
	    fprintf(fp," < >");
	  }
	}
	fputc(';',fp);
      }
      fputc('\n',fp);
    }
    while(ic){
      ic--;
      Sp[ic]	='\0';
      fputs(Sp,fp);
      putc('}',fp);
      putc('\n',fp);
    }
  }
  n	=pntT->NNmV;
  k	=0;
  for(i=0; i < n; i++){
    if((pntT->iCV[i]&0x07)) k++;
  }
  fprintf(fp,"%d - Number of Vector data\n",k);
  if(n){
    L1	=0;
    L2	=0;
    L3	=0;
    lV	=0;
    for(i=0; i < n; i++){
      j	=strlen(pntT->nmEV[i]);
      if(L1 < j) L1=j;
      if(pntT->nmV[i] != NULL && L3 < (j=strlen(pntT->nmV[i]))) L3=j;
      if(pntT->nUV[i] >= 0){
	j	=strlen(XUnits[pntT->nUV[i]].nmU);
	if(L2 < j) L2=j;
      }
      k	=pntT->iPV[i] ? pntT->lV[i]-2 : pntT->lV[i];
      if(lV < k) lV=k;
    }
    if(L2){
      sprintf(Str2," [%c%ds.%c4s]",'%',L2,'%');
      sprintf(Str22,"  %c%ds      ",'%',L2);
    }
    sprintf(Str3," (%cs)(%c2d) <%c%ds>",'%','%','%',L3);
    ic	=0;
    Sp[ic]	='\0';
    for(i=0; i < n; i++){
      if((pntT->iCV[i]&0x08)){
	if(ic) fseek(fp,-1L,SEEK_CUR);
	Sp[ic]	=' ';
	ic++;
	Sp[ic]	='\0';
	putc('{',fp);
	putc('\n',fp);
      }
      else{
	if(pntT->nmV[i] == NULL){
	  ic--;
	  Sp[ic]	='\0';
	  fputs(Sp,fp);
	  putc('}',fp);
	  putc('\n',fp);
	}
      }
      fputs(Sp,fp);
      j		=L1-strlen(pntT->nmEV[i]);
      while(j){
	j--;
	putc(' ',fp);
      }
      putc('<',fp);
      fputs(pntT->nmEV[i],fp);
      putc('>',fp);
      n1	=ic+L1+2;
      if(pntT->nmV[i] != NULL){
	id	=pntT->iCV[i]&0x07;
	switch(id){
	case 0:
	  sprintf(StrS,"str*%d",pntT->iUV[i]);
	  lc	=StrS;
	  n1	+=3;
	  break;
	case 1:
	  lc	="dbl";
	  break;
	case 2:
	  lc	="int";
	  break;
	case 3:
	  lc	="flt";
	  break;
	case 4:
	  lc	="lng";
	  break;
	case 5:
	  lc	="mon";
	  break;
	}
	if(L2){
	  if(pntT->nUV[i] < 0){
	    fprintf(fp,Str22,"");
	  }
	  else{
	    fprintf(fp,Str2,XUnits[pntT->nUV[i]].nmU
		    ,XUnits[pntT->nUV[i]].U[pntT->iUV[i]]);
	  }
	  n1	+=L2+7;
	}
	n2	=n1+1;
	fprintf(fp,Str3,lc,pntT->iCV[i],pntT->nmV[i]);
	n1	+=3+3+4+L3+4;
	if(pntT->aEV[i] != NULL){
	  fputc(',',fp);
	  lc	=pntT->aEV[i];
	  n1	+=strlen(lc)+8;
	  if(pntT->aV[i] != NULL) n1 +=strlen(pntT->aV[i])-1;
	  if(n1 > 79){
	    fputc('\n',fp);
	    while(n2){
	      fputc(' ',fp);
	      n2--;
	    }
	  }
	  fprintf(fp," \"%s\"",lc);
	  if(pntT->aV[i] != NULL){
	    fprintf(fp," <%s>",pntT->aV[i]);
	  }
	  else{
	    fprintf(fp," < >");
	  }
	}
	fputc(';',fp);
	fputc('\n',fp);
	k	=pntT->iPV[i] ? pntT->lV[i]-2 : pntT->lV[i];
	ka	=pntT->laV[i];
	fprintf(fp,"%d,%d:",k,ka);
	id	=pntT->iCV[i]&0x07;
	LL=80;

	switch(id){
	case 0:
	  for(j=0; j < k; j++){
	    LLL	=CbStrCpy0(ln,pntT->V[i][j])+3;
	    LL	+=LLL+1;
	    if(LL < 80){
	      fprintf(fp," '%s',",ln);
	    }
	    else{
	      fprintf(fp,"\n'%s',",ln);
	      LL	=LLL;
	    }
	    if(j < ka){
	      fprintf(fp,"%d,",*(pntT->vaV[i][j]));
	      LL+=2;
	    }
	  }
	  break;
	case 1:
	  for(j=0; j < k; j++){
	    s	=*(double*)pntT->V[i][j];
	    numstr(s,ln,L);
	    LL	+=L+2;
	    if(LL >=80){
	      fputc('\n',fp);
	      LL	=L+1;
	    }
	    else{
	      fputc(' ',fp);
	    }
	    fprintf(fp,"%s,",ln);
	    if(j < ka){
	      fprintf(fp,"%d,",*(pntT->vaV[i][j]));
	      LL+=2;
	    }
	  }
	  break;
	case 2:
	case 5:
	  for(j=0; j < k; j++){
	    LL	+=10;
	    if(LL >=80){
	      fputc('\n',fp);
	      LL	=9;
	    }
	    else{
	      fputc(' ',fp);
	    }
	    fprintf(fp,"%8d,",*(int*)pntT->V[i][j]);
	    if(j < ka){
	      fprintf(fp,"%d,",*(pntT->vaV[i][j]));
	      LL+=2;
	    }
	  }
	  break;
	case 3:
	  for(j=0; j < k; j++){
	    s	=*(float*)pntT->V[i][j];
	    numstr(s,ln,L);
	    LL	+=L+2;
	    if(LL >=80){
	      fputc('\n',fp);
	      LL	=L+1;
	    }
	    else{
	      fputc(' ',fp);
	    }
	    fprintf(fp,"%s,",ln);
	    if(j < ka){
	      fprintf(fp,"%d,",*(pntT->vaV[i][j]));
	      LL+=2;
	    }
	  }
	  break;
	case 4:
	  for(j=0; j < k; j++){
	    LL	+=10;
	    if(LL >=80){
	      fputc('\n',fp);
	      LL	=9;
	    }
	    fprintf(fp,"%8d,",(int)(*(long*)pntT->V[i][j]));
	    if(j < ka){
	      fprintf(fp,"%d,",*(pntT->vaV[i][j]));
	      LL+=2;
	    }
	  }
	  break;
	}
	putc(';',fp);
      }
      fputc('\n',fp);
    }
    while(ic){
      ic--;
      Sp[ic]	='\0';
      fputs(Sp,fp);
      putc('}',fp);
      putc('\n',fp);
    }
  }
  fclose(fp);
  printf("Output: %s <- %s.Tbl\n",NmF,pntT->Nm);
  return(0);
}
#endif

int CbWriteTbl(int iT,char *wa)
{
  int i,j,k,ka,n,n1,n2,lV,id,ic;
  int LL,LLL;
  int L1,L2,L3,L=8,LN;
  char Sp[32];	/* space line */
  char str[16],Str1[16],Str2[16],Str22[16],Str3[32],StrI[8],StrS[16];
  char StrN[8],ln[0x100];
  char *lc;
  double s;
  FILE * fp;

  Sp[0]	='\0';
  sprintf(StrI,"%c%dd",'%',L);
  sprintf(Str1,"=%c%ds",'%',L);

  pntT	=Tbl+iT;
  i	=pntT->iB;
  if(blb[i].path[0] != '\0'){
    sprintf(NmF,"%s/Wrk/%s.ta",blb[i].path,pntT->Nm);
  }
  else{
    sprintf(NmF,"Wrk/%s.ta",pntT->Nm);
  }

  if(stat(NmF,&stbuff) == 0){
    sprintf(ln,"mv %s %s.bak",NmF,NmF);
    system(ln);
  }

  fp	=fopen(NmF,wa);
  if(fp == NULL){
    printf("<%s> -- cannot open file for Tbl %s%c\n",NmF,pntT->Nm,7);
    return(1);
  }

  fprintf(fp,"%ud Tbl mode\n",pntT->mode);
  n	=pntT->NP;
  k	=0;
  for(i=0; i < n; i++){
    if((pntT->iCP[i]&0x07)) k++;
  }
  fprintf(fp,"%d - Number of Parameter data\n",k);
  if(n){
    L1	=0;
    L2	=0;
    L3	=0;
    for(i=0; i < n; i++){
      j	=strlen(pntT->nmEP[i]);
      if(L1 < j) L1=j;
      if(pntT->nmP[i] != NULL && L3 < (j=strlen(pntT->nmP[i]))) L3=j;
      if(pntT->nUP[i] >= 0 && L2 < (j=strlen(XUnits[pntT->nUP[i]].nmU))) L2=j;
    }
    if(L2){
      sprintf(Str2," [%c%ds.%c4s]",'%',L2,'%');
      sprintf(Str22,"  %c%ds      ",'%',L2);
    }
    sprintf(Str3," (%cs)(%c2d) <%c%ds>",'%','%','%',L3);
    ic	=0;
    for(i=0; i < n; i++){
      if((pntT->iCP[i]&0x08)){
	if(ic) fseek(fp,-1L,SEEK_CUR);
	Sp[ic++]=' ';
	Sp[ic]	='\0';
#ifdef H
	putc('{',fp);
#endif
	putc('\n',fp);
      }
      else{
	if(pntT->nmP[i] == NULL){
	  ic--;
	  Sp[ic]	='\0';
#ifdef H
	  putc('}',fp);
	  putc('\n',fp);
#endif
	}
      }
      fputs(Sp,fp);
      j		=L1-strlen(pntT->nmEP[i]);
      while(j){
	j--;
	putc(' ',fp);
      }
#ifdef H
      putc('<',fp);
      fputs(pntT->nmEP[i],fp);
      putc('>',fp);
#endif
      if(pntT->nmP[i] != NULL && pntT->nmP[i][0] != '\0'){
	putc('<',fp);
	fputs(pntT->nmEP[i],fp);
	putc('>',fp);

	id	=pntT->iCP[i]&0x07;
	switch(id){
	case 0:
	  sprintf(StrS,"=\"%c%ds\"",'%',pntT->iUP[i]);
	  fprintf(fp,StrS,pntT->P[i]);
	  sprintf(StrS,"str*%d",pntT->iUP[i]);
	  lc	=StrS;
	  break;
	case 1:
	  s	=*(double*)pntT->P[i];
	  if(pntT->scP[i] != 1.){
	    s	*=pntT->scP[i];
	  }
	  numstr(s,str,L);
	  lc	="dbl";
	  break;
	case 2:
	  j	=*(int*)pntT->P[i];
	  if(pntT->scP[i] != 1.){
	    j	*=pntT->scP[i];
	  }
	  sprintf(str,StrI,j);
	  lc	="int";
	  break;
	case 3:
	  s	=*(float*)pntT->P[i];
	  if(pntT->scP[i] != 1.){
	    s	*=pntT->scP[i];
	  }
	  numstr(s,str,L);
	  lc	="flt";
	  break;
	case 4:
	  j	=*(long*)pntT->P[i];
	  if(pntT->scP[i] != 1.){
	    j	*=pntT->scP[i];
	  }
	  sprintf(str,StrI,j);
	  lc	="lng";
	  break;
	case 5:
	  j	=*(int*)pntT->P[i];
	  if(pntT->scP[i] != 1.){
	    j	*=pntT->scP[i];
	  }
	  sprintf(str,StrI,j);
	  lc	="mon";
	  break;
	}
	if(id){
	  fprintf(fp,Str1,str);
	}
	if(L2){
	  if(pntT->nUP[i] < 0){
	    fprintf(fp,Str22,"");
	  }
	  else{
	    fprintf(fp,Str2,XUnits[pntT->nUP[i]].nmU
		    ,XUnits[pntT->nUP[i]].U[pntT->iUP[i]]);
	  }
	}
	fprintf(fp,Str3,lc,pntT->iCP[i],pntT->nmP[i]);
	if(pntT->aEP[i] != NULL){
	  lc	=pntT->aEP[i];
	  fprintf(fp,", \"%s\"[%d]",lc,*pntT->vaP[i]);
	  if(pntT->aP[i] != NULL){
	    fprintf(fp," <%s>",pntT->aP[i]);
	  }
	  else{
	    fprintf(fp," < >");
	  }
	}
	fputc(';',fp);
      }
      fputc('\n',fp);
    }
    while(ic){
      ic--;
      Sp[ic]	='\0';
#ifdef H
      fputs(Sp,fp);
      putc('}',fp);
      putc('\n',fp);
#endif
    }
  }
  n	=pntT->NNmV;
  k	=0;
  for(i=0; i < n; i++){
    if((pntT->iCV[i]&0x07)) k++;
  }
  fprintf(fp,"%d - Number of Vector data\n",k);
  if(n){
    L1	=0;
    L2	=0;
    L3	=0;
    lV	=0;
    for(i=0; i < n; i++){
      j	=strlen(pntT->nmEV[i]);
      if(L1 < j) L1=j;
      if(pntT->nmV[i] != NULL && L3 < (j=strlen(pntT->nmV[i]))) L3=j;
      if(pntT->nUV[i] >= 0){
	j	=strlen(XUnits[pntT->nUV[i]].nmU);
	if(L2 < j) L2=j;
      }
      k	=pntT->iPV[i] ? pntT->lV[i]-2 : pntT->lV[i];
      if(lV < k) lV=k;
    }
    if(L2){
      sprintf(Str2," [%c%ds.%c4s]",'%',L2,'%');
      sprintf(Str22,"  %c%ds      ",'%',L2);
    }
    sprintf(Str3," (%cs)(%c2d) <%c%ds>",'%','%','%',L3);
    ic	=0;
    Sp[ic]	='\0';
    for(i=0; i < n; i++){
      if((pntT->iCV[i]&0x08)){
	if(ic) fseek(fp,-1L,SEEK_CUR);
	Sp[ic]	=' ';
	ic++;
	Sp[ic]	='\0';
#ifdef H
	putc('{',fp);
#endif
	putc('\n',fp);
      }
      else{
	if(pntT->nmV[i] == NULL){
	  ic--;
	  Sp[ic]	='\0';
#ifdef H
	  fputs(Sp,fp);
	  putc('}',fp);
	  putc('\n',fp);
#endif
	}
      }
      fputs(Sp,fp);
      j		=L1-strlen(pntT->nmEV[i]);
      while(j){
	j--;
	putc(' ',fp);
      }
#ifdef H
      putc('<',fp);
      fputs(pntT->nmEV[i],fp);
      putc('>',fp);
#endif
      n1	=ic+L1+2;
      if(pntT->nmV[i] != NULL){

	putc('<',fp);
	fputs(pntT->nmEV[i],fp);
	putc('>',fp);

	id	=pntT->iCV[i]&0x07;
	switch(id){
	case 0:
	  sprintf(StrS,"str*%d",pntT->iUV[i]);
	  lc	=StrS;
	  n1	+=3;
	  break;
	case 1:
	  lc	="dbl";
	  break;
	case 2:
	  lc	="int";
	  break;
	case 3:
	  lc	="flt";
	  break;
	case 4:
	  lc	="lng";
	  break;
	case 5:
	  lc	="mon";
	  break;
	}
	if(L2){
	  if(pntT->nUV[i] < 0){
	    fprintf(fp,Str22,"");
	  }
	  else{
	    fprintf(fp,Str2,XUnits[pntT->nUV[i]].nmU
		    ,XUnits[pntT->nUV[i]].U[pntT->iUV[i]]);
	  }
	  n1	+=L2+7;
	}
	n2	=n1+1;
	fprintf(fp,Str3,lc,pntT->iCV[i],pntT->nmV[i]);
	n1	+=3+3+4+L3+4;
	if(pntT->aEV[i] != NULL){
	  fputc(',',fp);
	  lc	=pntT->aEV[i];
	  n1	+=strlen(lc)+8;
	  if(pntT->aV[i] != NULL) n1 +=strlen(pntT->aV[i])-1;
	  if(n1 > 79){
	    fputc('\n',fp);
	    while(n2){
	      fputc(' ',fp);
	      n2--;
	    }
	  }
	  fprintf(fp," \"%s\"",lc);
	  if(pntT->aV[i] != NULL){
	    fprintf(fp," <%s>",pntT->aV[i]);
	  }
	  else{
	    fprintf(fp," < >");
	  }
	}
	fputc(';',fp);
	fputc('\n',fp);
	k	=pntT->iPV[i] ? pntT->lV[i]-2 : pntT->lV[i];
	ka	=pntT->laV[i];
	fprintf(fp,"%d,%d:",k,ka);
	id	=pntT->iCV[i]&0x07;
	LL=80;

	switch(id){
	case 0:
	  for(j=0; j < k; j++){
	    LLL	=CbStrCpy0(ln,pntT->V[i][j])+3;
	    LL	+=LLL+1;
	    if(LL < 80){
	      fprintf(fp," '%s',",ln);
	    }
	    else{
	      fprintf(fp,"\n'%s',",ln);
	      LL	=LLL;
	    }
	    if(j < ka){
	      fprintf(fp,"%d,",*(pntT->vaV[i][j]));
	      LL+=2;
	    }
	  }
	  break;
	case 1:
	  for(j=0; j < k; j++){
	    s	=*(double*)pntT->V[i][j];
	    numstr(s,ln,L);
	    LL	+=L+2;
	    if(LL >=80){
	      fputc('\n',fp);
	      LL	=L+1;
	    }
	    else{
	      fputc(' ',fp);
	    }
	    fprintf(fp,"%s,",ln);
	    if(j < ka){
	      fprintf(fp,"%d,",*(pntT->vaV[i][j]));
	      LL+=2;
	    }
	  }
	  break;
	case 2:
	case 5:
	  for(j=0; j < k; j++){
	    LL	+=10;
	    if(LL >=80){
	      fputc('\n',fp);
	      LL	=9;
	    }
	    else{
	      fputc(' ',fp);
	    }
	    fprintf(fp,"%8d,",*(int*)pntT->V[i][j]);
	    if(j < ka){
	      fprintf(fp,"%d,",*(pntT->vaV[i][j]));
	      LL+=2;
	    }
	  }
	  break;
	case 3:
	  for(j=0; j < k; j++){
	    s	=*(float*)pntT->V[i][j];
	    numstr(s,ln,L);
	    LL	+=L+2;
	    if(LL >=80){
	      fputc('\n',fp);
	      LL	=L+1;
	    }
	    else{
	      fputc(' ',fp);
	    }
	    fprintf(fp,"%s,",ln);
	    if(j < ka){
	      fprintf(fp,"%d,",*(pntT->vaV[i][j]));
	      LL+=2;
	    }
	  }
	  break;
	case 4:
	  for(j=0; j < k; j++){
	    LL	+=10;
	    if(LL >=80){
	      fputc('\n',fp);
	      LL	=9;
	    }
	    fprintf(fp,"%8d,",(int)(*(long*)pntT->V[i][j]));
	    if(j < ka){
	      fprintf(fp,"%d,",*(pntT->vaV[i][j]));
	      LL+=2;
	    }
	  }
	  break;
	}
	putc(';',fp);
      }
      fputc('\n',fp);
    }
    while(ic){
      ic--;
      Sp[ic]	='\0';
#ifdef H
      fputs(Sp,fp);
      putc('}',fp);
      putc('\n',fp);
#endif
    }
  }
  fclose(fp);
  printf("Output: %s <- %s.Tbl\n",NmF,pntT->Nm);
  return(0);
}

typedef struct
{
  int it;	/*type*/
  int ia;	/*index value*/
  char *lNmE;
  char *lNm;
  char *lNmA;
  char *lv;
  char *lu0;
  char *lu1;
  char *lt;
  char *la;
  char *lsc;
}TBLOBJ;

int Str2TblObj(TBLOBJ *lT,char *ln)
{
  char *lc;
  
  lc	=ln;
  while(isspace(*lc)) lc++;
  lT->ia	=0;
  lT->it	=0;
  lT->lNmE	=lc;
  lT->lNm	=lc;
  lT->lNmA	=lc;
  lT->lv	=lc;
  lT->lu0	=lc;
  lT->lu1	=lc;
  lT->lt	=lc;
  lT->la	=lc;
  lT->lsc	=lc;

  if(*lc == '<') *lc++=0;
  lT->lNmE=lc;
  while(*lc != '>' && *lc) lc++;
  if(*lc) *lc++=0;
  while(isspace(*lc)) lc++;
  if(*lc == '='){
    lc++;
    while(isspace(*lc)) lc++;
    if(*lc == '"'){
      lc++;
      while(isspace(*lc)) lc++;
      lT->lv	=lc;
      while(*lc != '"') lc++;
    }else{
      lT->lv	=lc;
      while(!isspace(*lc) && *lc) lc++;
    }
    if(*lc) *lc++=0;
    while(isspace(*lc)) lc++;
  }
  if(*lc == '['){
    lc++;
    while(isspace(*lc)) lc++;
    lT->lu0=lc;
    while(*lc != '.' && *lc != ']' && *lc) lc++;
    if(*lc == '.'){
      *lc++	=0;
      while(isspace(*lc)) lc++;
      lT->lu1=lc;
      while(*lc != ']' && *lc) lc++;
    }
    if(*lc) *lc++=0;
    while(isspace(*lc)) lc++;
  }
  if(*lc == '('){
    lc++;
    while(isspace(*lc)) lc++;
    lT->lt	=lc;
    while(*lc != ')' && *lc) lc++;
    if(*lc) *lc++	=0;
    while(isspace(*lc)) lc++;
  }
  if(*lc == '('){
    lc++;
    lT->it=atoi(lc);
    while(*lc != ')' && *lc) lc++;
    if(*lc) *lc++	=0;
    while(isspace(*lc)) lc++;
  }
  if(*lc == '<'){
    lc++;
    while(isspace(*lc)) lc++;
    lT->lNm	=lc;
    while(*lc != '>' && *lc) lc++;
    if(*lc) *lc++	=0;
    while(isspace(*lc)) lc++;
  }
  if(*lc == ','){
    lc++;
    while(isspace(*lc)) lc++;
    if(*lc == '"'){
      lc++;
      lT->la	=lc;
      while(*lc != '"' && *lc) lc++;
      if(*lc) *lc++	=0;
    }
    while(isspace(*lc)) lc++;
    if(*lc == '['){
      lc++;
      lT->ia=atoi(lc);
      while(*lc != ']' && *lc) lc++;
      if(*lc) *lc++	=0;
      while(isspace(*lc)) lc++;
    }
    if(*lc == '<'){
      lc++;
      while(isspace(*lc)) lc++;
      lT->lNmA	=lc;
      while(*lc != '>' && *lc) lc++;
      if(*lc) *lc++	=0;
      while(isspace(*lc)) lc++;
    }
  }
  if(*lc == '*' || *lc == '/'){
    lT->lsc	=lc;
    while(*lc != ';' && *lc) lc++;
    if(*lc) *lc++	=0;
  }
  return(0);
}

int TblObj2Par(int *iP,int *kk,TBLOBJ *lO)
{
  int i,n;
  long int L;
  char *lc,*lt;
  double sc;

  n	=pntT->NP;
  lc	=lO->lNm;
  for(i=*iP; i < n; i++){
    if(kk[i] == 0){
      lt	=pntT->nmP[i];
      if(strcmp(lt,lc) == 0) break;
    }
  }
  if(i == n){
    n	=*iP;
    for(i=0; i < n; i++){
      if(kk[i] == 0){
	lt	=pntT->nmP[i];
	if(strcmp(lt,lc) == 0) break;
      }
    }
  }
  if(i == n){
    lc	=lO->lNmE;
    for(i=*iP; i < n; i++){
      if(kk[i] == 0){
	lt	=pntT->nmEP[i];
	if(strcmp(lt,lc) == 0) break;
      }
    }
    if(i == n){
      n	=*iP;
      for(i=0; i < n; i++){
	if(kk[i] == 0){
	  lt	=pntT->nmEP[i];
	  if(strcmp(lt,lc) == 0) break;
	}
      }
    }
    if(i == n) return(1);
  }
  *iP	=i;
  kk[i] =1;
  lc	=lO->lv;
  switch((lO->it&0x07)){
  case 0:
    break;
  case 1:
    sc	=strtod(lc,&lt);
    if(lt != NULL) *(double*)pntT->P[i]=sc;
    break;
  case 2:
    *(int*)pntT->P[i]=atoi(lc);
    break;
  case 3:{
    float f;
    sc	=strtod(lc,&lt);
    f	=sc;
#ifdef H
    f	=strtof(lc,&lt);
#endif
    if(lt != NULL) *(float*)pntT->P[i]=f;
    break;
  }
  case 4:
    *(long*)pntT->P[i]=atol(lc);
    break;
  case 5:
    *(int*)pntT->P[i]=atoi(lc);
    break;
  }
  lc	=pntT->aEP[i] != NULL ? pntT->aEP[i] : NULL;
  lt	=lO->la;
  if(lc != NULL && lt != NULL){
    lt	+=lO->ia;
    while(*lc && *lc != *lt) lc++;
    if(*lc == *lt) *pntT->vaP[i]=lc-pntT->aEP[i];
    else if(lO->ia < strlen(pntT->aEP[i])) *pntT->vaP[i]=lO->ia;
  }
  return(0);
}

int TblObj2Vec(int *iP,int *kk,TBLOBJ *lO)
{
  int i,n;
  long int L;
  char *lc,*lt;
  double sc;

  n	=pntT->NNmV;
  lc	=lO->lNm;
  for(i=*iP; i < n; i++){
    if(kk[i] == 0){
      lt	=pntT->nmV[i];
      if(strcmp(lt,lc) == 0) break;
    }
  }
  if(i == n){
    n	=*iP;
    for(i=0; i < n; i++){
      if(kk[i] == 0){
	lt	=pntT->nmV[i];
	if(strcmp(lt,lc) == 0) break;
      }
    }
  }
  if(i == n){
    lc	=lO->lNmE;
    for(i=*iP; i < n; i++){
      if(kk[i] == 0){
	lt	=pntT->nmEV[i];
	if(strcmp(lt,lc) == 0) break;
      }
    }
    if(i == n){
      n	=*iP;
      for(i=0; i < n; i++){
	if(kk[i] == 0){
	  lt	=pntT->nmEV[i];
	  if(strcmp(lt,lc) == 0) break;
	}
      }
    }
    if(i == n) return(1);
  }
  *iP	=i;
  kk[i] =1;
#ifdef H
  lc	=lO->lv;
  switch((lO->it&0x07)){
  case 0:
    break;
  case 1:
    sc	=strtod(lc,&lt);
    if(lt != NULL) *(double*)pntT->P[i]=sc;
    break;
  case 2:
    *(int*)pntT->P[i]=atoi(lc);
    break;
  case 3:{
    float f;
    sc	=strtod(lc,&lt);
    f	=sc;
#ifdef H
    f	=strtof(lc,&lt);
#endif
    if(lt != NULL) *(float*)pntT->P[i]=f;
    break;
  }
  case 4:
    *(long*)pntT->P[i]=atol(lc);
    break;
  case 5:
    *(int*)pntT->P[i]=atoi(lc);
    break;
  }
  lc	=pntT->aEP[i];
  lt	=lO->la;
  if(lc != NULL && lt != NULL){
    lt	+=lO->ia;
    while(*lc && *lc != *lt) lc++;
    if(*lc == *lt) *pntT->vaP[i]=lc-pntT->aEP[i];
    else if(lO->ia < strlen(pntT->aEP[i])) *pntT->vaP[i]=lO->ia;
  }
#endif
  return(0);
}

int CbReadTblA(int iT,int io)
{
  int i,ii,j,jj,k,ka,n,id;
  int kk[0x100];
  FILE *lF;
  char *lc,*lt;
  char ln[0x1000];
  double sc;
  float f;
  long int L;
  TBLOBJ Obj;

  pntT	=Tbl+iT;
  n	=pntT->NP;
  for(i=0; i < n; i++) kk[i]=pntT->nmP[i] == NULL ? 1 : 0;

  i	=pntT->iB;
  if(blb[i].path[0] != '\0'){
    if(io && blb[i].pathI[0] != '\0'){
      sprintf(NmF,"%s/Wrk/%s.ta",blb[i].pathI,pntT->Nm);
    }
    else{
      sprintf(NmF,"%s/Wrk/%s.ta",blb[i].path,pntT->Nm);
    }
  }
  else{
    sprintf(NmF,"Wrk/%s.ta",pntT->Nm);
  }
  lF	=fopen(NmF,"r");
  if(lF == NULL){
    printf("%s -- no file for Tbl %s%c\n",NmF,pntT->Nm,7);
    return(1);
  }
  lc=ln;
  while((*lc=getc(lF)) != '\n' && *lc != EOF) lc++;
  *lc=0;
  pntT->mode=atoi(ln);

  lc=ln;
  while((*lc=getc(lF)) != '\n' && *lc != EOF) lc++;
  *lc=0;
  n=atoi(ln);

  j	=0;
  i	=0;
  id	=0;
  while(j < n){
    lc=ln;
    while((*lc=getc(lF)) != ';' && *lc != EOF && *lc != '{' && *lc != '}') lc++;
    if(*lc == '{') id++;
    if(*lc == '}') id--;
    if(*lc != '{' && *lc != '}'){
      if(*lc == EOF) j=n;
      *lc=0;
      Str2TblObj(&Obj,ln);
      if(TblObj2Par(&i,kk,&Obj)) fprintf(stderr,"Error: <%s> <%s> no object\n"
					 ,Obj.lNmE,Obj.lNm);
      j++;
    }
    while((*lc=getc(lF)) != '\n' && *lc != EOF);
  }
  if(id){
    while(id && *lc != EOF){
      *lc=getc(lF);
      if(*lc == '{') id++;
      if(*lc == '}') id--;
    }
    while((*lc=getc(lF)) != '\n' && *lc != EOF);
  } 
  n	=pntT->NNmV;
  if(n == 0) return(0);
  for(i=0; i < n; i++) kk[i]=pntT->nmV[i] == NULL ? 1 : 0;

  lc=ln;
  while((*lc=getc(lF)) != '\n' && *lc != EOF) lc++;
  *lc=0; 
  n=atoi(ln);
  j	=0;
  i	=0;
  while(j < n){
    lc=ln;
    while((*lc=getc(lF)) != ';' && *lc != EOF && *lc != '{' && *lc != '}') lc++;
    if(*lc == '{') id++;
    if(*lc == '}') id--;
    if(*lc != '{' && *lc != '}'){
      if(*lc == EOF) j=n;
      *lc=0;

      Str2TblObj(&Obj,ln);
      k=TblObj2Vec(&i,kk,&Obj);
      if(k){
	fprintf(stderr,"Error: <%s> <%s> no object\n",Obj.lNmE,Obj.lNm);
	lc	=ln;
	while((*lc=getc(lF)) != ';' && *lc != EOF);
	while((*lc=getc(lF)) != '\n' && *lc != EOF);
      }
      else{
	lc	=ln;
	while(isspace((*lc=getc(lF))));
	lc++;
	while((*lc=getc(lF)) != ',') lc++;
	*lc	=0;
	jj	=atoi(ln);
	k	=pntT->iPV[i] ? pntT->lV[i]-2 : pntT->lV[i];
	if(k > jj) k=jj;

	lc++;
	while((*lc=getc(lF)) != ':') lc++;
	*lc	=0;
	ka	=atoi(ln);
	if(ka > pntT->laV[i]) ka=pntT->laV[i];
	switch((pntT->iCV[i]&0x07)){
	case 0:
	  for(jj=0; jj < k; jj++){
	    lc=ln;
	    while((*lc=getc(lF)) != '\'');
	    lc	=pntT->V[i][jj];
	    while((*lc=getc(lF)) != '\'') lc++;
	    *lc=0;
	    while((*lc=getc(lF)) != ',') lc++;
	    if(jj < ka){
	      lc=ln;
	      while((*lc=getc(lF)) != ',') lc++;
	      *(pntT->vaV[i][jj])	=atoi(ln);
	    }
	  }
	  while((*lc=getc(lF)) != ';');
	  break;
	case 1:
	  for(jj=0; jj < k; jj++){
	    lc=ln;
	    while((*lc=getc(lF)) != ',') lc++;
	    sc	=strtod(ln,&lt);
	    if(lt != NULL) *(double*)pntT->V[i][jj]=sc;
	    if(jj < ka){
	      lc=ln;
	      while((*lc=getc(lF)) != ',') lc++;
	      *(pntT->vaV[i][jj])	=atoi(ln);
	    }
	  }
	  break;
	case 2:
	case 5:
	  for(jj=0; jj < k; jj++){
	    lc=ln;
	    while((*lc=getc(lF)) != ',') lc++;
	    *(int*)pntT->V[i][jj]=atoi(ln);
	    if(jj < ka){
	      lc=ln;
	      while((*lc=getc(lF)) != ',') lc++;
	      *(pntT->vaV[i][jj])	=atoi(ln);
	    }
	  }
	  break;
	case 3:
	  for(jj=0; jj < k; jj++){
	    lc=ln;
	    while((*lc=getc(lF)) != ',') lc++;
    sc	=strtod(ln,&lt);
    f	=sc;
#ifdef H
    f	=strtof(ln,&lt);
#endif
	    if(lt != NULL) *(double*)pntT->V[i][jj]=f;
	    if(jj < ka){
	      lc=ln;
	      while((*lc=getc(lF)) != ',') lc++;
	      *(pntT->vaV[i][jj])	=atoi(ln);
	    }
	  }
	  break;
	case 4:
	  for(jj=0; jj < k; jj++){
	    lc=ln;
	    while((*lc=getc(lF)) != ',') lc++;
	    *(long*)pntT->V[i][jj]=atol(ln);
	    if(jj < ka){
	      lc=ln;
	      while((*lc=getc(lF)) != ',') lc++;
	      *(pntT->vaV[i][jj])	=atoi(ln);
	    }
	  }
	  break;
	}
	while((*lc=getc(lF)) != ';');
      }
      j++;
    }
    else{
      while((*lc=getc(lF)) != '\n' && *lc != EOF);
    }
  }
  fclose(lF);
  printf("Input: %s --> %s.Tbl\n",NmF,pntT->Nm);
  return(0);
}

int CbReadTbl(int iT,int io)
{
  int i,ii,j,L,n,k;
  int nP,nV,NP,NV;
  char*p,*ep,*ap,*aep;
  char*bff,**nm,**nmE,ch1;
  int*iC,*nU,*sz,*laV;
  double*sc;
  FILE *fp;
  
  pntT	=Tbl+iT;
  i	=pntT->iB;
  if(blb[i].path[0] != '\0'){
    if(io && blb[i].pathI[0] != '\0'){
      sprintf(NmF,"%s/Wrk/%s.tb",blb[i].pathI,pntT->Nm);
    }
    else{
      sprintf(NmF,"%s/Wrk/%s.tb",blb[i].path,pntT->Nm);
    }
  }
  else{
    sprintf(NmF,"Wrk/%s.tb",pntT->Nm);
  }
  fp	=fopen(NmF,"r");
  if(fp == NULL){
    printf("%s -- no file for Tbl %s%c\n",NmF,pntT->Nm,7);
    return(1);
  }

  if(fread(&pntT->mode,sizeof(int),1,fp) < 1){
    fclose(fp);
    return(1);
  }
  if(fread(&nP,sizeof(int),1,fp) < 1){
    fclose(fp);
    return(1);
  }
  if(nP){
    if(fread(&L,sizeof(int),1,fp) < 1){
      fclose(fp);
      return(1);
    }
    bff	=(char*)malloc(L*sizeof(char));
    nm	=(char**)malloc(2*nP*sizeof(char*));
    nmE	=nm+nP;
    iC	=(int*)malloc(2*nP*sizeof(int));
    nU	=iC+nP;
    sc	=(double*)malloc(nP*sizeof(double));
    
    if(L&&fread(bff,L,1,fp)<1){
      free(sc);
      free(iC);
      free(nm);
      free(bff);
      fclose(fp);
      return(1);
    }
    p	=bff;
    for(i=0; i < nP; i++){
      nmE[i]	=p;
      while(*p!='\0'){
	p++;
      }
      p++;
      nm[i]	=p;
      while(*p != '\0'){
	p++;
      }
      p++;
    }
    if(fread((char*)iC,sizeof(int),nP,fp) < nP){
      free(sc);
      free(iC);
      free(nm);
      free(bff);
      fclose(fp);
      return(1);
    }
    if(fread((char*)nU,sizeof(int),nP,fp) < nP){
      free(sc);
      free(iC);
      free(nm);
      free(bff);
      fclose(fp);
      return(1);
    }
    if(fread((char*)sc,sizeof(double),nP,fp) < nP){
      free(sc);
      free(iC);
      free(nm);
      free(bff);
      fclose(fp);
      return(1);
    }
    ii	=0;
    NP	=pntT->NP;
    for(i=0; i < nP; i++){
      if(nm[i][0] != '\0'){
	fread(&L,sizeof(int),1,fp);
	if(L){
	  fread(ln,sizeof(char),L,fp);
	  aep	=ln;
	  ap	=ln+strlen(ln)+1;
	  ch1	=*ap;
	  ap++;
	}
	iC[i]	&=7;
	p	=nm[i];
	ep	=nmE[i];
	for(j=ii; j < NP; j++){
	  if(pntT->nmP[j] != NULL){
	    if(strcmp(p,pntT->nmP[j]) == 0 || strcmp(ep,pntT->nmEP[j]) == 0){
	      if(L){
		if(pntT->aEP[j] != NULL || strcmp(aep,pntT->aEP[j]) == 0){
		  if(pntT->aP[j] != NULL){
		    if(strcmp(ap,pntT->aP[j]) == 0){
		      *pntT->vaP[j]	=ch1;
		      ii	=j;
		      break;
		    }
		  }
		  else{
		    if(*ap == '\0'){
		      *pntT->vaP[j]	=ch1;
		      ii	=j;
		      break;
		    }
		  }
		}
	      }
	      else{
		ii	=j;
		break;
	      }
	    }
	  }
	}
	if(j == NP){
	  for(j=ii-1; j >= 0; j--){
	    if(pntT->nmP[j]!=NULL){
	      if(strcmp(p,pntT->nmP[j])==0 || strcmp(ep,pntT->nmEP[j])==0){
		if(L){
		  if(pntT->aEP[j]!=NULL || strcmp(aep,pntT->aEP[j])==0){
		    if(pntT->aP[j]!=NULL){
		      if(strcmp(ap,pntT->aP[j])==0){
			*pntT->vaP[j]= ch1;
			ii= j;
			break;
		      }
		    }
		    else{
		      if(*ap=='\0'){
			*pntT->vaP[j]= ch1;
			ii= j;
			break;
		      }
		    }
		  }
		}
		else{
		  ii= j;
		  break;
		}
	      }
	    }
	  }
	}
	switch(iC[i]){
	case 0:
	  fread(&L,sizeof(int),1,fp);
	  break;
	case 1:
	  L= sizeof(double);
	  break;
	case 3:
	  L= sizeof(float);
	  break;
	case 2:
	case 5:
	  L= sizeof(int);
	  break;
	}
	if(0 <= j && j < NP && iC[i] == (pntT->iCP[ii]&7)
	   && nU[i] == pntT->nUP[ii] && sc[i] == pntT->scP[ii]){
	  fread(pntT->P[ii],sizeof(char),L,fp);
	}
	else{
	  while(L>80){
	    fread(ln,sizeof(char),80,fp);
	    L-= 80;
	  }
	  fread(ln,sizeof(char),L,fp);
	}
      }
    }

    free(sc);
    free(iC);
    free(nm);
    free(bff);
  }

  if(fread(&nV,sizeof(int),1,fp)<1){
    fclose(fp);
    return(1);
  }
  if(nV){
    if(fread(&L,sizeof(int),1,fp)<1){
      fclose(fp);
      return(1);
    }
    bff	=(char*)malloc(L*sizeof(char));
    nm	=(char**)malloc(2*nV*sizeof(char*));
    nmE	=nm+nV;
    iC	=(int*)malloc(4*nV*sizeof(int));
    nU	=iC+nV;
    sz	=nU+nV;
    laV	=sz+nV;
    sc	=(double*)malloc(nV*sizeof(double));
    
    if(L&&fread(bff,L,1,fp)<1){
      free(sc);
      free(iC);
      free(nm);
      free(bff);
      fclose(fp);
      return(1);
    }
    p	=bff;
    for(i= 0;i<nV;i++){
      nmE[i]	=p;
      while(*p!='\0')
	p++;
      p++;
      nm[i]	=p;
      while(*p!='\0')
	p++;
      p++;
    }
    if(fread((char*)iC,sizeof(int),nV,fp)<nV){
      free(sc);
      free(iC);
      free(nm);
      free(bff);
      fclose(fp);
      return(1);
    }
    if(fread((char*)nU,sizeof(int),nV,fp)<nV){
      free(sc);
      free(iC);
      free(nm);
      free(bff);
      fclose(fp);
      return(1);
    }
    if(fread((char*)sz,sizeof(int),nV,fp)<nV){
      free(sc);
      free(iC);
      free(nm);
      free(bff);
      fclose(fp);
      return(1);
    }
    if(fread((char*)laV,sizeof(int),nV,fp)<nV){
      free(sc);
      free(iC);
      free(nm);
      free(bff);
      fclose(fp);
      return(1);
    }
    if(fread((char*)sc,sizeof(double),nV,fp)<nV){
      free(sc);
      free(iC);
      free(nm);
      free(bff);
      fclose(fp);
      return(1);
    }
    ii	=0;
    NP	=pntT->NNmV;
    for(i=0; i < nV; i++){
      if(nm[i][0] != '\0'){
	if(laV[i] != 0){
	  fread(&L,sizeof(int),1,fp);
	  fread(ln,sizeof(char),L,fp);
	  aep	=ln;
	  ap	=ln+strlen(ln)+1;
	}
	iC[i]	&=7;
	p	=nm[i];
	ep	=nmE[i];
	for(j=ii; j < NP; j++){
	  if(pntT->nmV[j] != NULL && pntT->nmV[j][0] != '\0'){
	    if(strcmp(p,pntT->nmV[j])==0 || strcmp(ep,pntT->nmEV[j])==0){
	      if(laV[i]){
		if(strcmp(aep,pntT->aEV[j])==0){
		  if((pntT->aV[j]!=NULL || strcmp(ap,pntT->aV[j])==0)||
		     (pntT->aV[j]==NULL&&*ap=='\0')){
		    ii= j;
		    L= laV[i];
		    for(k= 0;k<L;k++){
		      fread(pntT->vaV[ii][k],sizeof(int),1,fp);
		    }
		    break;
		  }
		}
	      }
	      else{
		ii= j;
		break;
	      }
	    }
	  }
	}
	if(j==NP){
	  for(j= ii-1;j>=0;j--){
	    if(pntT->nmV[j]!=NULL&&pntT->nmV[j][0]!='\0'){
	      if(strcmp(p,pntT->nmV[j])==0 || strcmp(ep,pntT->nmEV[j])==0){
		if(laV[i]){
		  if(strcmp(aep,pntT->aEV[j])==0){
		    if((pntT->aV[j]!=NULL || strcmp(ap,pntT->aV[j]))==0||
		       (pntT->aV[j]==NULL&&*ap=='\0')){
		      ii= j;
		      L= laV[i];
		      for(k= 0;k<L;k++){
			fread(pntT->vaV[ii][k],sizeof(int),1,fp);
		      }
		      break;
		    }
		  }
		}
		else{
		  ii= j;
		  break;
		}
	      }
	    }
	  }
	}
	if(0<=j&&j<NP&&iC[i]==(pntT->iCV[ii]&7)
	   &&nU[i]==pntT->nUV[ii]&&sc[i]==pntT->scV[ii]){
	  k= pntT->lV[ii]<sz[i]?pntT->lV[ii]:sz[i];
	  switch(iC[i]){
	  case 0:
	    for(j= 0;j<k;j++){
	      fread(&L,sizeof(int),1,fp);
	      fread(pntT->V[ii][j],sizeof(char),L,fp);
	    }
	    for(;j<sz[i];j++){
	      fread(&L,sizeof(int),1,fp);
	      while(L>80){
		fread(ln,sizeof(char),80,fp);
		L-= 80;
	      }
	      fread(ln,sizeof(char),L,fp);
	    }
	    break;
	  case 1:
	    L= sizeof(double);
	    for(j= 0;j<k;j++){
	      fread(pntT->V[ii][j],sizeof(char),L,fp);
	    }
	    for(;j<sz[i];j++){
	      fread(ln,sizeof(char),L,fp);
	    }
	    break;
	  case 2:
	  case 5:
	    L= sizeof(int);
	    for(j= 0;j<k;j++){
	      fread(pntT->V[ii][j],sizeof(char),L,fp);
	    }
	    for(;j<sz[i];j++){
	      fread(ln,sizeof(char),L,fp);
	    }
	    break;
	  case 3:
	    L= sizeof(float);
	    for(j= 0;j<k;j++){
	      fread(pntT->V[ii][j],sizeof(char),L,fp);
	    }
	    for(;j<sz[i];j++){
	      fread(ln,sizeof(char),L,fp);
	    }
	    break;
	  }
	}
	else{
	  switch(iC[i]){
	  case 0:
	    for(j= 0;j<sz[i];j++){
	      fread(&L,sizeof(int),1,fp);
	      while(L>80){
		fread(ln,sizeof(char),80,fp);
		L-= 80;
	      }
	      fread(ln,sizeof(char),L,fp);
	    }
	    break;
	  case 1:
	    L= sizeof(double);
	    for(j= 0;j<sz[i];j++){
	      fread(pntT->V[ii][j],sizeof(char),L,fp);
	    }
	    break;
	  case 2:
	  case 5:
	    L= sizeof(int);
	    for(j= 0;j<sz[i];j++){
	      fread(pntT->V[ii][j],sizeof(char),L,fp);
	    }
	    break;
	  }
	}
      }
    }
    free(sc);
    free(iC);
    free(nm);
    free(bff);
  }
  fclose(fp);
  printf("%s read :--> %s - Tbl\n",NmF,pntT->Nm);
  return(0);
}

int CbReadTblRigorous(int iT,int io)
{
  int i,ii,j,L,n,k;
  int nP,nV,NP,NV;
  char*p,*ep,*ap,*aep;
  char*bff,**nm,**nmE,ch1;
  int*iC,*nU,*sz,*laV;
  double*sc;
  FILE *fp;
  
  pntT= Tbl+iT;
  i= pntT->iB;
  if(blb[i].path[0]!='\0'){
    if(io)
      sprintf(NmF,"%s/Wrk/%s.tb",blb[i].pathI,pntT->Nm);
    else
      sprintf(NmF,"%s/Wrk/%s.tb",blb[i].path,pntT->Nm);
  }
  else{
    sprintf(NmF,"Wrk/%s.tb",pntT->Nm);
  }
  fp= fopen(NmF,"rb");
  if(fp==NULL){
    printf("%s -- no file for Tbl %s%c\n",NmF,pntT->Nm,7);
    return(1);
  }

  if(fread(&pntT->mode,sizeof(int),1,fp)<1){
    fclose(fp);
    return(1);
  }
  if(fread(&nP,sizeof(int),1,fp)<1){
    fclose(fp);
    return(1);
  }
  if(nP){
    if(fread(&L,sizeof(int),1,fp)<1){
      fclose(fp);
      return(1);
    }
    bff= (char*)malloc(L*sizeof(char));
    nm= (char**)malloc(2*nP*sizeof(char*));
    nmE= nm+nP;
    iC= (int*)malloc(2*nP*sizeof(int));
    nU= iC+nP;
    sc= (double*)malloc(nP*sizeof(double));
    
    if(L&&fread(bff,L,1,fp)<1){
      free(sc);
      free(iC);
      free(nm);
      free(bff);
      fclose(fp);
      return(1);
    }
    p= bff;
    for(i= 0;i<nP;i++){
      nmE[i]= p;
      while(*p!='\0')
	p++;
      p++;
      nm[i]= p;
      while(*p!='\0')
	p++;
      p++;
    }
    if(fread((char*)iC,sizeof(int),nP,fp)<nP){
      free(sc);
      free(iC);
      free(nm);
      free(bff);
      fclose(fp);
      return(1);
    }
    if(fread((char*)nU,sizeof(int),nP,fp)<nP){
      free(sc);
      free(iC);
      free(nm);
      free(bff);
      fclose(fp);
      return(1);
    }
    if(fread((char*)sc,sizeof(double),nP,fp)<nP){
      free(sc);
      free(iC);
      free(nm);
      free(bff);
      fclose(fp);
      return(1);
    }
    ii= 0;
    NP= pntT->NP;
    for(i= 0;i<nP;i++){
      if(nm[i][0]!='\0'){
	fread(&L,sizeof(int),1,fp);
	if(L){
	  fread(ln,sizeof(char),L,fp);
	  aep= ln;
	  ap= ln+strlen(ln)+1;
	  ch1= *ap;
	  ap++;
	}
	iC[i]&= 7;
	p= nm[i];
	ep= nmE[i];
	for(j= ii;j<NP;j++){
	  if(pntT->nmP[j]!=NULL){
	    if(strcmp(p,pntT->nmP[j])==0&&strcmp(ep,pntT->nmEP[j])==0){
	      if(L){
		if(pntT->aEP[j]!=NULL&&strcmp(aep,pntT->aEP[j])==0){
		  if(pntT->aP[j]!=NULL){
		    if(strcmp(ap,pntT->aP[j])==0){
		      *pntT->vaP[j]= ch1;
		      ii= j;
		      break;
		    }
		  }
		  else{
		    if(*ap=='\0'){
		      *pntT->vaP[j]= ch1;
		      ii= j;
		      break;
		    }
		  }
		}
	      }
	      else{
		ii= j;
		break;
	      }
	    }
	  }
	}
	if(j==NP){
	  for(j= ii-1;j>=0;j--){
	    if(pntT->nmP[j]!=NULL){
	      if(strcmp(p,pntT->nmP[j])==0&&strcmp(ep,pntT->nmEP[j])==0){
		if(L){
		  if(pntT->aEP[j]!=NULL&&strcmp(aep,pntT->aEP[j])==0){
		    if(pntT->aP[j]!=NULL){
		      if(strcmp(ap,pntT->aP[j])==0){
			*pntT->vaP[j]= ch1;
			ii= j;
			break;
		      }
		    }
		    else{
		      if(*ap=='\0'){
			*pntT->vaP[j]= ch1;
			ii= j;
			break;
		      }
		    }
		  }
		}
		else{
		  ii= j;
		  break;
		}
	      }
	    }
	  }
	}
	switch(iC[i]){
	case 0:
	  fread(&L,sizeof(int),1,fp);
	  break;
	case 1:
	  L= sizeof(double);
	  break;
	case 3:
	  L= sizeof(float);
	  break;
	case 2:
	case 5:
	  L= sizeof(int);
	  break;
	}
	if(0 <= j && j < NP && iC[i] == (pntT->iCP[ii]&7)
	   && nU[i] == pntT->nUP[ii] && sc[i] == pntT->scP[ii]){
	  fread(pntT->P[ii],sizeof(char),L,fp);
	}
	else{
	  while(L>80){
	    fread(ln,sizeof(char),80,fp);
	    L-= 80;
	  }
	  fread(ln,sizeof(char),L,fp);
	}
      }
    }

    free(sc);
    free(iC);
    free(nm);
    free(bff);
  }

  if(fread(&nV,sizeof(int),1,fp)<1){
    fclose(fp);
    return(1);
  }
  if(nV){
    if(fread(&L,sizeof(int),1,fp)<1){
      fclose(fp);
      return(1);
    }
    bff	=(char*)malloc(L*sizeof(char));
    nm	=(char**)malloc(2*nV*sizeof(char*));
    nmE	=nm+nV;
    iC	=(int*)malloc(4*nV*sizeof(int));
    nU	=iC+nV;
    sz	=nU+nV;
    laV	=sz+nV;
    sc	=(double*)malloc(nV*sizeof(double));
    
    if(L&&fread(bff,L,1,fp)<1){
      free(sc);
      free(iC);
      free(nm);
      free(bff);
      fclose(fp);
      return(1);
    }
    p	=bff;
    for(i= 0;i<nV;i++){
      nmE[i]	=p;
      while(*p!='\0')
	p++;
      p++;
      nm[i]	=p;
      while(*p!='\0')
	p++;
      p++;
    }
    if(fread((char*)iC,sizeof(int),nV,fp)<nV){
      free(sc);
      free(iC);
      free(nm);
      free(bff);
      fclose(fp);
      return(1);
    }
    if(fread((char*)nU,sizeof(int),nV,fp)<nV){
      free(sc);
      free(iC);
      free(nm);
      free(bff);
      fclose(fp);
      return(1);
    }
    if(fread((char*)sz,sizeof(int),nV,fp)<nV){
      free(sc);
      free(iC);
      free(nm);
      free(bff);
      fclose(fp);
      return(1);
    }
    if(fread((char*)laV,sizeof(int),nV,fp)<nV){
      free(sc);
      free(iC);
      free(nm);
      free(bff);
      fclose(fp);
      return(1);
    }
    if(fread((char*)sc,sizeof(double),nV,fp)<nV){
      free(sc);
      free(iC);
      free(nm);
      free(bff);
      fclose(fp);
      return(1);
    }
    ii	=0;
    NP	=pntT->NNmV;
    for(i=0; i < nV; i++){
      if(nm[i][0] != '\0'){
	if(laV[i] != 0){
	  fread(&L,sizeof(int),1,fp);
	  fread(ln,sizeof(char),L,fp);
	  aep	=ln;
	  ap	=ln+strlen(ln)+1;
	}
	iC[i]	&=7;
	p	=nm[i];
	ep	=nmE[i];
	for(j=ii; j < NP; j++){
	  if(pntT->nmV[j]!=NULL&&pntT->nmV[j][0]!='\0'){
	    if(strcmp(p,pntT->nmV[j])==0&&strcmp(ep,pntT->nmEV[j])==0){
	      if(laV[i]){
		if(strcmp(aep,pntT->aEV[j])==0){
		  if((pntT->aV[j]!=NULL&&strcmp(ap,pntT->aV[j])==0)||
		     (pntT->aV[j]==NULL&&*ap=='\0')){
		    ii= j;
		    L= laV[i];
		    for(k= 0;k<L;k++){
		      fread(pntT->vaV[ii][k],sizeof(int),1,fp);
		    }
		    break;
		  }
		}
	      }
	      else{
		ii= j;
		break;
	      }
	    }
	  }
	}
	if(j==NP){
	  for(j= ii-1;j>=0;j--){
	    if(pntT->nmV[j]!=NULL&&pntT->nmV[j][0]!='\0'){
	      if(strcmp(p,pntT->nmV[j])==0&&strcmp(ep,pntT->nmEV[j])==0){
		if(laV[i]){
		  if(strcmp(aep,pntT->aEV[j])==0){
		    if((pntT->aV[j]!=NULL&&strcmp(ap,pntT->aV[j]))==0||
		       (pntT->aV[j]==NULL&&*ap=='\0')){
		      ii= j;
		      L= laV[i];
		      for(k= 0;k<L;k++){
			fread(pntT->vaV[ii][k],sizeof(int),1,fp);
		      }
		      break;
		    }
		  }
		}
		else{
		  ii= j;
		  break;
		}
	      }
	    }
	  }
	}
	if(0<=j&&j<NP&&iC[i]==(pntT->iCV[ii]&7)
	   &&nU[i]==pntT->nUV[ii]&&sc[i]==pntT->scV[ii]){
	  k= pntT->lV[ii]<sz[i]?pntT->lV[ii]:sz[i];
	  switch(iC[i]){
	  case 0:
	    for(j= 0;j<k;j++){
	      fread(&L,sizeof(int),1,fp);
	      fread(pntT->V[ii][j],sizeof(char),L,fp);
	    }
	    for(;j<sz[i];j++){
	      fread(&L,sizeof(int),1,fp);
	      while(L>80){
		fread(ln,sizeof(char),80,fp);
		L-= 80;
	      }
	      fread(ln,sizeof(char),L,fp);
	    }
	    break;
	  case 1:
	    L= sizeof(double);
	    for(j= 0;j<k;j++){
	      fread(pntT->V[ii][j],sizeof(char),L,fp);
	    }
	    for(;j<sz[i];j++){
	      fread(ln,sizeof(char),L,fp);
	    }
	    break;
	  case 2:
	  case 5:
	    L= sizeof(int);
	    for(j= 0;j<k;j++){
	      fread(pntT->V[ii][j],sizeof(char),L,fp);
	    }
	    for(;j<sz[i];j++){
	      fread(ln,sizeof(char),L,fp);
	    }
	    break;
	  case 3:
	    L= sizeof(float);
	    for(j= 0;j<k;j++){
	      fread(pntT->V[ii][j],sizeof(char),L,fp);
	    }
	    for(;j<sz[i];j++){
	      fread(ln,sizeof(char),L,fp);
	    }
	    break;
	  }
	}
	else{
	  switch(iC[i]){
	  case 0:
	    for(j= 0;j<sz[i];j++){
	      fread(&L,sizeof(int),1,fp);
	      while(L>80){
		fread(ln,sizeof(char),80,fp);
		L-= 80;
	      }
	      fread(ln,sizeof(char),L,fp);
	    }
	    break;
	  case 1:
	    L= sizeof(double);
	    for(j= 0;j<sz[i];j++){
	      fread(pntT->V[ii][j],sizeof(char),L,fp);
	    }
	    break;
	  case 2:
	  case 5:
	    L= sizeof(int);
	    for(j= 0;j<sz[i];j++){
	      fread(pntT->V[ii][j],sizeof(char),L,fp);
	    }
	    break;
	  }
	}
      }
    }
    free(sc);
    free(iC);
    free(nm);
    free(bff);
  }
  fclose(fp);
  printf("%s read :--> %s - Tbl\n",NmF,pntT->Nm);
  return(0);
}

int CbInitIOLoop(int kL)
{
  int i,n,iL;
  int i0,i1,i2,N;
  CbIOLoop*pL;

  pL= IOLoop+kL;
  n= pL->n;
  if(pL->NmI!=NULL){
    i0= pL->i0;
    i1= pL->i1;
    i2= (i1-1-i0)/pL->st+1;
    if(i0<i1){
      N= pL->nV;
      iL= 0;
      n= pL->nL;
      while(iL<n){
	i= pL->kL[iL];
	CbInitIOLoop(i);
	N	+=IOLoop[i].N;
	iL++;
      }
      N*= i2;
    }
    else{
      N= 0;
    }
  }
  else{
    N= pL->nV;
    iL= 0;
    n= pL->nL;
    while(iL<n){
      i= pL->kL[iL];
      CbInitIOLoop(i);
      N	+=IOLoop[i].N;
      iL++;
    }
  }
  pL->N= N;
  return(0);
}

int CbBnrIHD2Loop(int kL,int i0L,int i1L)
{
  int i,iL,iV,id,d,d0,dL,st,stV,n,k,kV;
  int i0,i1,i2,I;
  int*fV,*vP;
  char*p;
  CbIOLoop*pL;
  CbIOVec*pV;

  if(ILc>=i1L)
    return(0);
  pL= IOLoop+kL;
  dL= pL->d;
  n= pL->n;

  I= pL->i0;
  StackI[dL]= I;
  i1= pL->i1;
  if(I>=i1||ILc>=i1L)
    return(0);
  i2= pL->st;

  i= 0;
  iL= 0;
  iV= 0;
  n= pL->nV;
  while(iV<n){
    kV= pL->kV[iV];
    pV= IOVec+kV;
    d= pV->d;
    if(d){
      stV= 0;
      i0= 0;
      fV= pL->fV[iV];
      vP= pL->iV[iV];
      while(d>0){
	d--;
	st= pV->st[d];
	if(fV[d]<0){
	  i0	+=st*vP[d];
	}
	else{
	  i0	+=st*StackI[fV[d]];
	  if(fV[d]==dL){
	    stV	+=st;
	  }
	}
      }
      pL->i0V[iV]= i0;
      pL->stV[iV]= stV;
    }
    else{
      pL->i0V[iV]= 0;
      pL->stV[iV]= 0;
    }
    iV++;
  }
  if(ILc<i0L){
    i= (i1-1-I)/i2+1;
    n= pL->N/i;
    if(ILc+pL->N<i0L){
      k= i;
      ILc	+=n*k;
      if(ILc>=i1L)
	return(0);
      I	+=k*i2;
      StackI[dL]= I;
      iV= 0;
      n= pL->nV;
      while(iV<n){
	pL->i0V[iV]	+=k*pL->stV[iV];
	iV++;
      }
      return(0);
    }
    else{
      k= (i0L-ILc)/n;
      ILc	+=n*k;
      if(ILc>=i1L)
	return(0);
      I	+=k*i2;
      StackI[dL]= I;
      iV= 0;
      n= pL->nV;
      while(iV<n){
	pL->i0V[iV]	+=k*pL->stV[iV];
	iV++;
      }
    }
  }
  n= pL->n;
  while(I<i1){
    i= 0;
    iL= 0;
    iV= 0;
    while(i<n){
      if(pL->t[i]==8){
	CbBnrIHD2Loop(pL->kL[iL],i0L,i1L);
	iL++;
      }
      else{
	if(ILc>=i0L){
	  kV= pL->kV[iV];
	  pV= IOVec+kV;
	  p= pV->V+pL->i0V[iV];
	  id= pV->id&7;
	  switch(id){
	  case 0:
	    fread(p,(size_t)strlen(p),1,fpBnr);
	    break;
	  case 1:
	    fread(p,sizeof(double),1,fpBnr);
	    break;
	  case 2:
	    fread(p,sizeof(int),1,fpBnr);
	    break;
	  case 3:
	    fread(p,sizeof(float),1,fpBnr);
	    break;
	  case 4:
	    fread(p,sizeof(long),1,fpBnr);
	    break;
	  case 5:
	    fread(p,(size_t)strlen(p),1,fpBnr);
	    break;
	  }
	}
	pL->i0V[iV]	+=pL->stV[iV];
	iV++;
	ILc++;
      }
      if(ILc>=i1L)
	return(0);
      i++;
    }
    I	+=i2;
    StackI[dL]= I;
  }
  return(0);
}

int CbBnrOLoop2HD(int kL,int i0L,int i1L)
{
  int i,iL,iV,id,d,d0,dL,st,stV,n,k,kV;
  int i0,i1,i2,I;
  int*fV,*vP;
  char*p;
  CbIOLoop*pL;
  CbIOVec*pV;

  if(ILc>=i1L)
    return(0);
  pL= IOLoop+kL;
  dL= pL->d;
  n= pL->n;

  I= pL->i0;
  StackI[dL]= I;
  i1= pL->i1;
  if(I>=i1||ILc>=i1L)
    return(0);
  i2= pL->st;

  i= 0;
  iL= 0;
  iV= 0;
  n= pL->nV;
  while(iV<n){
    kV= pL->kV[iV];
    pV= IOVec+kV;
    d= pV->d;
    if(d){
      stV= 0;
      i0= 0;
      fV= pL->fV[iV];
      vP= pL->iV[iV];
      while(d>0){
	d--;
	st= pV->st[d];
	if(fV[d]<0){
	  i0	+=st*vP[d];
	}
	else{
	  i0	+=st*StackI[fV[d]];
	  if(fV[d]==dL){
	    stV	+=st;
	  }
	}
      }
      pL->i0V[iV]= i0;
      pL->stV[iV]= stV;
    }
    else{
      pL->i0V[iV]= 0;
      pL->stV[iV]= 0;
    }
    iV++;
  }
  if(ILc<i0L){
    i= (i1-1-I)/i2+1;
    n= pL->N/i;
    if(ILc+pL->N<i0L){
      k= i;
      ILc	+=n*k;
      if(ILc>=i1L)
	return(0);
      I	+=k*i2;
      StackI[dL]= I;
      iV= 0;
      n= pL->nV;
      while(iV<n){
	pL->i0V[iV]	+=k*pL->stV[iV];
	iV++;
      }
      return(0);
    }
    else{
      k= (i0L-ILc)/n;
      ILc	+=n*k;
      if(ILc>=i1L)
	return(0);
      I	+=k*i2;
      StackI[dL]= I;
      iV= 0;
      n= pL->nV;
      while(iV<n){
	pL->i0V[iV]	+=k*pL->stV[iV];
	iV++;
      }
    }
  }
  n= pL->n;
  while(I<i1){
    i= 0;
    iL= 0;
    iV= 0;
    while(i<n){
      if(pL->t[i]==8){
	CbBnrOLoop2HD(pL->kL[iL],i0L,i1L);
	iL++;
      }
      else{
	if(ILc>=i0L){
	  kV= pL->kV[iV];
	  pV= IOVec+kV;
	  p= pV->V+pL->i0V[iV];
	  id= pV->id&7;
	  switch(id){
	  case 0:
	    fwrite(p,(size_t)strlen(p),1,fpBnr);
	    break;
	  case 1:
	    fwrite(p,sizeof(double),1,fpBnr);
	    break;
	  case 2:
	    fwrite(p,sizeof(int),1,fpBnr);
	    break;
	  case 3:
	    fwrite(p,sizeof(float),1,fpBnr);
	    break;
	  case 4:
	    fwrite(p,sizeof(long),1,fpBnr);
	    break;
	  case 5:
	    fwrite(p,sizeof(int),1,fpBnr);
	    break;
	  case 6:
	    fwrite(p,(size_t)strlen(p),1,fpBnr);
	    break;
	  }
	}
	pL->i0V[iV]	+=pL->stV[iV];
	iV++;
	ILc++;
      }
      if(ILc>=i1L)
	return(0);
      i++;
    }
    I	+=i2;
    StackI[dL]= I;
  }
  return(0);
}

int CbAscIHD2Loop(int kL,int i0L,int i1L)
{
  int i,iL,iV,id,d,d0,dL,st,stV,n,k,kV;
  int i0,i1,i2,I;
  int*fV,*vP;
  char*p;
  CbIOLoop*pL;
  CbIOVec*pV;

  if(ILc>=i1L)
    return(0);
  pL= IOLoop+kL;
  dL= pL->d;
  n= pL->n;

  I= pL->i0;
  StackI[dL]= I;
  i1= pL->i1;
  if(I>=i1||ILc>=i1L)
    return(0);
  i2= pL->st;

  i= 0;
  iL= 0;
  iV= 0;
  n= pL->nV;
  while(iV<n){
    kV= pL->kV[iV];
    pV= IOVec+kV;
    d= pV->d;
    if(d){
      stV= 0;
      i0= 0;
      fV= pL->fV[iV];
      vP= pL->iV[iV];
      while(d>0){
	d--;
	st= pV->st[d];
	if(fV[d]<0){
	  i0	+=st*vP[d];
	}
	else{
	  i0	+=st*StackI[fV[d]];
	  if(fV[d]==dL){
	    stV	+=st;
	  }
	}
      }
      pL->i0V[iV]= i0;
      pL->stV[iV]= stV;
    }
    else{
      pL->i0V[iV]= 0;
      pL->stV[iV]= 0;
    }
    iV++;
  }
  if(ILc<i0L){
    i= (i1-1-I)/i2+1;
    n= pL->N/i;
    if(ILc+pL->N<i0L){
      k= i;
      ILc	+=n*k;
      if(ILc>=i1L)
	return(0);
      I	+=k*i2;
      StackI[dL]= I;
      iV= 0;
      n= pL->nV;
      while(iV<n){
	pL->i0V[iV]	+=k*pL->stV[iV];
	iV++;
      }
      return(0);
    }
    else{
      k= (i0L-ILc)/n;
      ILc	+=n*k;
      if(ILc>=i1L)
	return(0);
      I	+=k*i2;
      StackI[dL]= I;
      iV= 0;
      n= pL->nV;
      while(iV<n){
	pL->i0V[iV]	+=k*pL->stV[iV];
	iV++;
      }
    }
  }
  n= pL->n;
  while(I<i1){
    i= 0;
    iL= 0;
    iV= 0;
    while(i<n){
      if(pL->t[i]==8){
	CbAscIHD2Loop(pL->kL[iL],i0L,i1L);
	iL++;
      }
      else{
	if(ILc>=i0L){
	  kV= pL->kV[iV];
	  pV= IOVec+kV;
	  p= pV->V+pL->i0V[iV];
	  id= pV->id&7;
	  switch(id){
	  case 0:
	    printf("<%s>;\n",p);
	    break;
	  case 1:
	    printf("%10.3e;\n",*(double*)p);
	    break;
	  case 2:
	    printf("%d;\n",*(int*)p);
	    break;
	  case 3:
	    printf("%10.3e;\n",*(float*)p);
	    break;
	  case 4:
	    printf("%ld;\n",*(long*)p);
	    break;
	  case 5:
	    printf("%d;\n",*(int*)p);
	    break;
	  case 6:
	    printf("<%s>;\n",p);
	    break;
	  }
	}
	pL->i0V[iV]	+=pL->stV[iV];
	iV++;
	ILc++;
      }
      if(ILc>=i1L)
	return(0);
      i++;
    }
    I	+=i2;
    StackI[dL]= I;
  }
  return(0);
}

int CbAscOLoop2HD(int kL,int i0L,int i1L)
{
  int i,iL,iV,id,d,d0,dL,st,stV,n,k,kV;
  int i0,i1,i2,I;
  int*fV,*vP;
  char*p;
  CbIOLoop*pL;
  CbIOVec*pV;

  if(ILc>=i1L)
    return(0);
  pL= IOLoop+kL;
  dL= pL->d;
  n= pL->n;

  I= pL->i0;
  StackI[dL]= I;
  i1= pL->i1;
  if(I>=i1||ILc>=i1L)
    return(0);
  i2= pL->st;

  i= 0;
  iL= 0;
  iV= 0;
  n= pL->nV;
  while(iV<n){
    kV= pL->kV[iV];
    pV= IOVec+kV;
    d= pV->d;
    if(d){
      stV= 0;
      i0= 0;
      fV= pL->fV[iV];
      vP= pL->iV[iV];
      while(d>0){
	d--;
	st= pV->st[d];
	if(fV[d]<0){
	  i0	+=st*vP[d];
	}
	else{
	  i0	+=st*StackI[fV[d]];
	  if(fV[d]==dL){
	    stV	+=st;
	  }
	}
      }
      pL->i0V[iV]= i0;
      pL->stV[iV]= stV;
    }
    else{
      pL->i0V[iV]= 0;
      pL->stV[iV]= 0;
    }
    iV++;
  }
  if(ILc<i0L){
    i= (i1-1-I)/i2+1;
    n= pL->N/i;
    if(ILc+pL->N<i0L){
      k= i;
      ILc	+=n*k;
      if(ILc>=i1L)
	return(0);
      I	+=k*i2;
      StackI[dL]= I;
      iV= 0;
      n= pL->nV;
      while(iV<n){
	pL->i0V[iV]	+=k*pL->stV[iV];
	iV++;
      }
      return(0);
    }
    else{
      k= (i0L-ILc)/n;
      ILc	+=n*k;
      if(ILc>=i1L)
	return(0);
      I	+=k*i2;
      StackI[dL]= I;
      iV= 0;
      n= pL->nV;
      while(iV<n){
	pL->i0V[iV]	+=k*pL->stV[iV];
	iV++;
      }
    }
  }
  n= pL->n;
  while(I<i1){
    i= 0;
    iL= 0;
    iV= 0;
    while(i<n){
      if(pL->t[i]==8){
	CbAscOLoop2HD(pL->kL[iL],i0L,i1L);
	iL++;
      }
      else{
	if(ILc>=i0L){
	  kV= pL->kV[iV];
	  pV= IOVec+kV;
	  p= pV->V+pL->i0V[iV];
	  id= pV->id&7;
	  switch(id){
	  case 0:
	    printf("<%s>;\n",p);
	    break;
	  case 1:
	    printf("%10.3e;\n",*(double*)p);
	    break;
	  case 2:
	    printf("%d;\n",*(int*)p);
	    break;
	  case 3:
	    printf("%10.3e;\n",*(float*)p);
	    break;
	  case 4:
	    printf("%ld;\n",*(long*)p);
	    break;
	  case 5:
	    printf("%d;\n",*(int*)p);
	    break;
	  case 6:
	    printf("<%s>;\n",p);
	    break;
	  }
	}
	pL->i0V[iV]	+=pL->stV[iV];
	iV++;
	ILc++;
      }
      if(ILc>=i1L)
	return(0);
      i++;
    }
    I	+=i2;
    StackI[dL]= I;
  }
  return(0);
}

int CbBnrIHD2Obj(int kO,int i0,int i1)
{
  int kL;

  if(i0>=i1)
    return(0);
  kL= IOObj[kO].nL;
  CbInitIOLoop(kL);
  ILc= 0;
  CbBnrIHD2Loop(kL,i0,i1);
  return(0);
}

int CbBnrOObj2HD(int kO,int i0,int i1)
{
  int kL;

  if(i0>=i1)
    return(0);
  kL= IOObj[kO].nL;
  CbInitIOLoop(kL);
  ILc= 0;
  CbBnrOLoop2HD(kL,i0,i1);
  return(0);
}

int CbAscIHD2Obj(int kO,int i0,int i1)
{
  int kL;

  if(i0>=i1)
    return(0);
  kL= IOObj[kO].nL;
  CbInitIOLoop(kL);
  ILc= 0;
  CbAscIHD2Loop(kL,i0,i1);
  return(0);
}

int CbAscOObj2HD(int kO,int i0,int i1)
{
  int kL;

  if(i0>=i1)
    return(0);
  kL= IOObj[kO].nL;
  CbInitIOLoop(kL);
  ILc= 0;
  CbAscOLoop2HD(kL,i0,i1);
  return(0);
}

int CbIOSet2HD(int iIO,int iT)
{
  int i,n,iN;
  CbIOSet*pS;

  iN= iIO+3;
  pS= IOSet[iN]+iT;
  if(pS->N==0)
    return(0);
  n= pS->N;

  switch(iN){
  case 3:
    for(i= 0;i<n;i++){
      CbBnrIHD2Obj(pS->kO[i],pS->i0[i],pS->i1[i]);
    }
    break;
  case 4:
    for(i= 0;i<n;i++){
      CbBnrOObj2HD(pS->kO[i],pS->i0[i],pS->i1[i]);
    }
    break;
  case 5:
    for(i= 0;i<n;i++){
      CbBnrIHD2Obj(pS->kO[i],pS->i0[i],pS->i1[i]);
    }
    break;
  case 6:
    for(i= 0;i<n;i++){
      CbBnrOObj2HD(pS->kO[i],pS->i0[i],pS->i1[i]);
    }
    break;
  case 7:
    for(i= 0;i<n;i++){
      CbBnrIHD2Obj(pS->kO[i],pS->i0[i],pS->i1[i]);
    }
    break;
  case 8:
    for(i= 0;i<n;i++){
      CbBnrOObj2HD(pS->kO[i],pS->i0[i],pS->i1[i]);
    }
    break;
  case 9:
    for(i= 0;i<n;i++){
      CbAscIHD2Obj(pS->kO[i],pS->i0[i],pS->i1[i]);
    }
    break;
  case 10:
    for(i= 0;i<n;i++){
      CbAscOObj2HD(pS->kO[i],pS->i0[i],pS->i1[i]);
    }
    break;
  }
  return(0);
}

int CbCloseIO(int iN,int iT)
{

  switch(iN){
  case 3:
    fclose(fpBRc[iT]);
    break;
  case 4:
    fclose(fpBSv[iT]);
    break;
  case 5:
    fclose(fpBRd[iT]);
    break;
  case 6:
    fclose(fpBWr[iT]);
    break;
  case 7:
    fclose(fpBnrI[iT]);
    break;
  case 8:
    fclose(fpBnrO[iT]);
    break;
  case 9:
    fclose(fpAscI[iT]);
    break;
  case 10:
    fclose(fpAscO[iT]);
    break;
  }
  return(0);
}

int CbBlbRestore(int iT,FILE**fp)
{
  char ch;
  int iB;

  iB= Tbl[iT].iB;
  printf("Restoring Blb_%s mB=0x%x\n",blb[iB].NmB,(unsigned)blb[iB].mB);
  sprintf(NmIOFile,"%s/Wrk/%s.sv",blb[iB].pathI,blb[iB].NmB);
  fpBnr= fopen(NmIOFile,"rb");
  fpBRc[iT]= fpBnr;
  if(fpBnr==NULL){
    printf("Absent: <%s> for Input\a\n",NmIOFile);
    printf("In order to proceed, type 'y'\n");
    printf("In order to exit,    type 'n'\n");
    ch= getchar();
    switch(ch){
    case 'y':
    case 'Y':
      return(0);
    case 'n':
    case 'N':
    default:
      XDeInitWin();
      exit(0);
    }
  }
  *fp= fpBnr;
  if(fpBnr !=NULL){
    printf("Input : %s\n",NmIOFile);
    return(1);
  }
  else{
    CbIOSet2HD(0,iT);
    return(0);
  }
}

int iblbrs_(int*iT,int*fU)
{
  char ch;
  int iB;
  iB= Tbl[*iT].iB;

  printf("Restoring Blb_%s mB=0x%x\n",blb[iB].NmB,(unsigned)blb[iB].mB);
  sprintf(NmIOFile,"%s/Wrk/%s.sv",blb[iB].pathI,blb[iB].NmB);
  if(*fU){
    iB= ioftnb_(fU,NmIOFile,"r");
    if(iB){
      fpBnr= (FILE*)1L;
    }
    else{
      fpBnr= NULL;
    }
  }
  else{
    fpBnr= fopen(NmIOFile,"rb");
    fpBRc[*iT]= fpBnr;
  }
  if(fpBnr==NULL){
    printf("Absent: <%s> for Input\a\n",NmIOFile);
    printf("In order to proceed, type 'y'\n");
    printf("In order to exit,    type 'n'\n");
    ch= getchar();
    switch(ch){
    case 'y':
    case 'Y':
      return(0);
    case 'n':
    case 'N':
    default:
      XDeInitWin();
      exit(0);
    }
  }
  printf("Input : %s\n",NmIOFile);
  if(*fU==0){
    CbIOSet2HD(0,*iT);
    return(0);
  }
  return(iB);
}

int CbStgRestore(int iT,FILE**fp)
{
  char ch;
  int iB,iM,iS;

  iB= Tbl[iT].iB;
  iM= Tbl[iT].iM;
  iS= Tbl[iT].iS;

  printf("Restoring Stg_%s mS=0x%x\n",
	 blb[iB].NmS[iM][iS],(unsigned)blb[iB].mS[iM][iS]);
  sprintf(NmIOFile,"%s/Wrk/%s.sv",blb[iB].pathI,blb[iB].NmS[iM][iS]);
  fpBnr= fopen(NmIOFile,"rb");
  fpBRc[iT]= fpBnr;
  if(fpBnr==NULL){
    printf("Absent: <%s> for Input\a\n",NmIOFile);
    printf("In order to proceed, type 'y'\n");
    printf("In order to exit,    type 'n'\n");
    ch= getchar();
    switch(ch){
    case 'y':
    case 'Y':
      return(0);
    case 'n':
    case 'N':
    default:
      XDeInitWin();
      exit(0);
    }
  }
  *fp=fpBnr;
  if(fpBnr != NULL){
    printf("Input : %s\n",NmIOFile);
    return(1);
  }
  else{
    CbIOSet2HD(0,iT);
    return(0);
  }
}

int istgrs_(int*iT,int*fU)
{
  char ch;
  int iB,iM,iS;
  iB= Tbl[*iT].iB;
  iM= Tbl[*iT].iM;
  iS= Tbl[*iT].iS;

  printf("Restoring Stg_%s mS=0x%x\n",
	 blb[iB].NmS[iM][iS],(unsigned)blb[iB].mS[iM][iS]);
  sprintf(NmIOFile,"%s/Wrk/%s.sv",blb[iB].pathI,blb[iB].NmS[iM][iS]);
  if(*fU){
    iB= ioftnb_(fU,NmIOFile,"r");
    if(iB){
      fpBnr= (FILE*)1L;
    }
    else{
      fpBnr= NULL;
    }
  }
  else{
    fpBnr= fopen(NmIOFile,"rb");
    fpBRc[*iT]= fpBnr;
  }
  if(fpBnr==NULL){
    printf("Absent: <%s> for Input\a\n",NmIOFile);
    printf("In order to proceed, type 'y'\n");
    printf("In order to exit,    type 'n'\n");
    ch= getchar();
    switch(ch){
    case 'y':
    case 'Y':
      return(0);
    case 'n':
    case 'N':
    default:
      XDeInitWin();
      exit(0);
    }
  }
  printf("Input : %s\n",NmIOFile);
  if(*fU==0){
    CbIOSet2HD(0,*iT);
    return(0);
  }
  return(iB);
}

int CbBlbSave(int iT,FILE**fp)
{
  char ch;
  int iB;
  iB= Tbl[iT].iB;

  printf("Saving Blb_%s mB=0x%x\n",blb[iB].NmB,(unsigned)blb[iB].mB);
  sprintf(NmIOFile,"%s/Wrk/%s.sv",blb[iB].pathI,blb[iB].NmB);
  fpBnr= fopen(NmIOFile,"wb");
  fpBSv[iT]= fpBnr;
  if(fpBnr==NULL){
    printf("<%s> - No output File%c\n",NmIOFile,7);
    printf("In order to proceed, type 'y'\n");
    printf("In order to exit,    type 'n'\n");
    ch= getchar();
    switch(ch){
    case 'y':
    case 'Y':
      return(0);
    case 'n':
    case 'N':
    default:
      XDeInitWin();
      exit(0);
    }
  }
  *fp= fpBnr;
  if(fpBnr != NULL){
    printf("Output: %s\n",NmIOFile);
    return(1);
  }
  else{
    CbIOSet2HD(1,iT);
    return(0);
  }
}

int iblbsv_(int*iT,int*fU)
{
  char ch;
  int iB;

  iB= Tbl[*iT].iB;
  printf("Saving Blb_%s mB=0x%x\n",blb[iB].NmB,(unsigned)blb[iB].mB);
  sprintf(NmIOFile,"%s/Wrk/%s.sv",blb[iB].pathI,blb[iB].NmB);
  if(*fU){
    iB= ioftnb_(fU,NmIOFile,"w");
    if(iB){
      fpBnr= (FILE*)1L;
    }
    else{
      fpBnr= NULL;
    }
  }
  else{
    fpBnr= fopen(NmIOFile,"wb");
    fpBSv[*iT]= fpBnr;
  }
  if(fpBnr==NULL){
    printf("<%s> - No output File%c\n",NmIOFile,7);
    printf("In order to proceed, type 'y'\n");
    printf("In order to exit,    type 'n'\n");
    ch= getchar();
    switch(ch){
    case 'y':
    case 'Y':
      return(0);
    case 'n':
    case 'N':
    default:
      XDeInitWin();
      exit(0);
    }
  }
  printf("Output: %s\n",NmIOFile);
  if(*fU==0){
    CbIOSet2HD(1,*iT);
    return(0);
  }
  return(iB);
}

int CbStgSave(int iT,FILE**fp)
{
  char ch;
  int iB,iM,iS;
  iB= Tbl[iT].iB;
  iM= Tbl[iT].iM;
  iS= Tbl[iT].iS;

  printf("Saving Stg_%s mS=0x%x\n",blb[iB].NmS[iM][iS]
	 ,(unsigned)blb[iB].mS[iM][iS]);
  sprintf(NmIOFile,"%s/Wrk/%s.sv",blb[iB].pathI,blb[iB].NmS[iM][iS]);
  fpBnr= fopen(NmIOFile,"wb");
  fpBSv[iT]= fpBnr;
  if(fpBnr==NULL){
    printf("Absent: <%s> for Input\a\n",NmIOFile);
    printf("In order to proceed, type 'y'\n");
    printf("In order to exit,    type 'n'\n");
    ch= getchar();
    switch(ch){
    case 'y':
    case 'Y':
      return(0);
    case 'n':
    case 'N':
    default:
      XDeInitWin();
      exit(0);
    }
  }
  *fp= fpBnr;
  if(fpBnr != NULL){
    printf("Output: %s\n",NmIOFile);
    return(1);
  }
  else{
    CbIOSet2HD(1,iT);
    return(0);
  }
}

int istgsv_(int*iT,int*fU)
{
  char ch;
  int iB,iM,iS;

  iB= Tbl[*iT].iB;
  iM= Tbl[*iT].iM;
  iS= Tbl[*iT].iS;
  printf("Saving Stg_%s mS=0x%x\n",blb[iB].NmS[iM][iS]
	 ,(unsigned)blb[iB].mS[iM][iS]);
  sprintf(NmIOFile,"%s/Wrk/%s.sv",blb[iB].pathI,blb[iB].NmS[iM][iS]);
  if(*fU){
    iB= ioftnb_(fU,NmIOFile,"w");
    if(iB){
      fpBnr= (FILE*)1L;
    }
    else{
      fpBnr= NULL;
    }
  }
  else{
    fpBnr= fopen(NmIOFile,"wb");
    fpBSv[*iT]= fpBnr;
  }
  if(fpBnr==NULL){
    printf("Absent: <%s> for Input\a\n",NmIOFile);
    printf("In order to proceed, type 'y'\n");
    printf("In order to exit,    type 'n'\n");
    ch= getchar();
    switch(ch){
    case 'y':
    case 'Y':
      return(0);
    case 'n':
    case 'N':
    default:
      XDeInitWin();
      exit(0);
    }
  }
  printf("Output: %s\n",NmIOFile);
  if(*fU==0){
    CbIOSet2HD(1,*iT);
    return(0);
  }
  return(iB);
}

int CbBlbRead(int iT,FILE**fp)
{
  char ch;
  int iB;
  iB= Tbl[iT].iB;

  sprintf(NmIOFile,"%s/Wrk/%s.rd",blb[iB].pathI,blb[iB].NmB);
  fpBnr= fopen(NmIOFile,"rb");
  fpBRd[iT]= fpBnr;
  if(fpBnr==NULL){
    printf("Absent: <%s> for Input\a\n",NmIOFile);
    printf("In order to proceed, type 'y'\n");
    printf("In order to exit,    type 'n'\n");
    ch= getchar();
    switch(ch){
    case 'y':
    case 'Y':
      return(0);
    case 'n':
    case 'N':
    default:
      XDeInitWin();
      exit(0);
    }
  }
  *fp= fpBnr;
  if(fpBnr!=NULL){
    printf("Input : %s\n",NmIOFile);
    return(1);
  }
  else{
    CbIOSet2HD(2,iT);
    return(0);
  }
}

int iblbrd_(int*iT,int*fU)
{
  char ch;
  int iB;

  iB= Tbl[*iT].iB;
  sprintf(NmIOFile,"%s/Wrk/%s.rd",blb[iB].pathI,blb[iB].NmB);
  if(*fU){
    iB= ioftns_(fU,NmIOFile,"r");
    if(iB){
      fpBnr= (FILE*)1L;
    }
    else{
      fpBnr= NULL;
    }
  }
  else{
    fpBnr= fopen(NmIOFile,"rb");
    fpBRd[*iT]= fpBnr;
  }
  if(fpBnr==NULL){
    printf("Absent: <%s> for Input\a\n",NmIOFile);
    printf("In order to proceed, type 'y'\n");
    printf("In order to exit,    type 'n'\n");
    ch= getchar();
    switch(ch){
    case 'y':
    case 'Y':
      return(0);
    case 'n':
    case 'N':
    default:
      XDeInitWin();
      exit(0);
    }
  }
  printf("Input : %s\n",NmIOFile);
  if(*fU==0){
    CbIOSet2HD(2,*iT);
    return(0);
  }
  return(iB);
}

int CbStgRead(int iT,FILE**fp)
{
  char ch;
  int iB,iM,iS;

  iB= Tbl[iT].iB;
  iM= Tbl[iT].iM;
  iS= Tbl[iT].iS;
  sprintf(NmIOFile,"%s/Wrk/%s.rd",blb[iB].pathI,blb[iB].NmS[iM][iS]);
  fpBnr= fopen(NmIOFile,"rb");
  fpBRd[iT]= fpBnr;
  if(fpBnr==NULL){
    printf("Absent: <%s> for Input\a\n",NmIOFile);
    printf("In order to proceed, type 'y'\n");
    printf("In order to exit,    type 'n'\n");
    ch= getchar();
    switch(ch){
    case 'y':
    case 'Y':
      return(0);
    case 'n':
    case 'N':
    default:
      XDeInitWin();
      exit(0);
    }
  }
  *fp= fpBnr;
  if(fpBnr!=NULL){
    printf("Input : %s\n",NmIOFile);
    return(1);
  }
  else{
    CbIOSet2HD(2,iT);
    return(0);
  }
}

int istgrd_(int*iT,int*fU)
{
  char ch;
  int iB,iM,iS;

  iB= Tbl[*iT].iB;
  iM= Tbl[*iT].iM;
  iS= Tbl[*iT].iS;
  sprintf(NmIOFile,"%s/Wrk/%s.rd",blb[iB].pathI,blb[iB].NmS[iM][iS]);
  if(*fU){
    iB= ioftns_(fU,NmIOFile,"r");
    if(iB){
      fpBnr= (FILE*)1L;
    }
    else{
      fpBnr= NULL;
    }
  }
  else{
    fpBnr= fopen(NmIOFile,"rb");
    fpBRd[*iT]= fpBnr;
  }
  if(fpBnr==NULL){
    printf("Absent: <%s> for Input\a\n",NmIOFile);
    printf("In order to proceed, type 'y'\n");
    printf("In order to exit,    type 'n'\n");
    ch= getchar();
    switch(ch){
    case 'y':
    case 'Y':
      return(0);
    case 'n':
    case 'N':
    default:
      XDeInitWin();
      exit(0);
    }
  }
  printf("Input : %s\n",NmIOFile);
  if(*fU==0){
    CbIOSet2HD(2,*iT);
    return(0);
  }
  return(iB);
}

int CbBlbWrite(int iT,FILE**fp)
{
  char ch;
  int iB;
  iB= Tbl[iT].iB;

  sprintf(NmIOFile,"%s/Wrk/%s.wr",blb[iB].pathI,blb[iB].NmB);
  fpBnr= fopen(NmIOFile,"wb");
  fpBWr[iT]= fpBnr;
  if(fpBnr==NULL){
    printf("Absent: <%s> for Input\a\n",NmIOFile);
    printf("In order to proceed, type 'y'\n");
    printf("In order to exit,    type 'n'\n");
    ch= getchar();
    switch(ch){
    case 'y':
    case 'Y':
      return(0);
    case 'n':
    case 'N':
    default:
      XDeInitWin();
      exit(0);
    }
  }
  *fp= fpBnr;
  if(fpBnr != NULL){
    printf("Output: %s\n",NmIOFile);
    return(1);
  }
  else{
    CbIOSet2HD(3,iT);
    return(0);
  }
}

int iblbwr_(int*iT,int*fU)
{
  char ch;
  int iB;

  iB= Tbl[*iT].iB;
  sprintf(NmIOFile,"%s/Wrk/%s.wr",blb[iB].pathI,blb[iB].NmB);
  if(*fU){
    iB= ioftns_(fU,NmIOFile,"w");
    if(iB){
      fpBnr= (FILE*)1L;
    }
    else{
      fpBnr= NULL;
    }
  }
  else{
    fpBnr= fopen(NmIOFile,"wb");
    fpBWr[*iT]= fpBnr;
  }
  if(fpBnr==NULL){
    printf("Absent: <%s> for Input\a\n",NmIOFile);
    printf("In order to proceed, type 'y'\n");
    printf("In order to exit,    type 'n'\n");
    ch= getchar();
    switch(ch){
    case 'y':
    case 'Y':
      return(0);
    case 'n':
    case 'N':
    default:
      XDeInitWin();
      exit(0);
    }
  }
  printf("Output: %s\n",NmIOFile);
  if(*fU==0){
    CbIOSet2HD(3,*iT);
    return(0);
  }
  return(iB);
}

int CbStgWrite(int iT,FILE**fp)
{
  char ch;
  int iB,iM,iS;

  iB= Tbl[iT].iB;
  iM= Tbl[iT].iM;
  iS= Tbl[iT].iS;
  sprintf(NmIOFile,"%s/Wrk/%s.wr",blb[iB].pathI,blb[iB].NmS[iM][iS]);
  fpBnr= fopen(NmIOFile,"wb");
  fpBWr[iT]= fpBnr;
  if(fpBnr==NULL){
    printf("Absent: <%s> for Input\a\n",NmIOFile);
    printf("In order to proceed, type 'y'\n");
    printf("In order to exit,    type 'n'\n");
    ch= getchar();
    switch(ch){
    case 'y':
    case 'Y':
      return(0);
    case 'n':
    case 'N':
    default:
      XDeInitWin();
      exit(0);
    }
  }
  *fp= fpBnr;
  if(fpBnr != NULL){
    printf("Output: %s\n",NmIOFile);
    return(1);
  }
  else{
    CbIOSet2HD(3,iT);
    return(0);
  }
}

int istgwr_(int*iT,int*fU)
{
  char ch;
  int iB,iM,iS;

  iB= Tbl[*iT].iB;
  iM= Tbl[*iT].iM;
  iS= Tbl[*iT].iS;
  sprintf(NmIOFile,"%s/Wrk/%s.wr",blb[iB].pathI,blb[iB].NmS[iM][iS]);
  if(*fU){
    iB= ioftns_(fU,NmIOFile,"w");
    if(iB){
      fpBnr= (FILE*)1L;
    }
    else{
      fpBnr= NULL;
    }
  }
  else{
    fpBnr= fopen(NmIOFile,"wb");
    fpBWr[*iT]= fpBnr;
  }
  if(fpBnr==NULL){
    printf("Absent: <%s> for Input\a\n",NmIOFile);
    printf("In order to proceed, type 'y'\n");
    printf("In order to exit,    type 'n'\n");
    ch= getchar();
    switch(ch){
    case 'y':
    case 'Y':
      return(0);
    case 'n':
    case 'N':
    default:
      XDeInitWin();
      exit(0);
    }
  }
  printf("Output: %s\n",NmIOFile);
  if(*fU==0){
    CbIOSet2HD(3,*iT);
    return(0);
  }
  return(iB);
}

int CbBlbBnrInp(int iT,FILE**fp)
{
  char ch;
  int iB;

  iB= Tbl[iT].iB;
  sprintf(NmIOFile,"%s/Wrk/%s.bi",blb[iB].pathI,blb[iB].NmB);
  fpBnr= fopen(NmIOFile,"rb");
  fpBnrI[iT]= fpBnr;
  if(fpBnr==NULL){
    printf("Absent: <%s> for Input\a\n",NmIOFile);
    printf("In order to proceed, type 'y'\n");
    printf("In order to exit,    type 'n'\n");
    ch= getchar();
    switch(ch){
    case 'y':
    case 'Y':
      return(0);
    case 'n':
    case 'N':
    default:
      XDeInitWin();
      exit(0);
    }
  }
  *fp= fpBnr;
  if(fpBnr != NULL){
    printf("Input : %s\n",NmIOFile);
    return(1);
  }
  else{
    CbIOSet2HD(4,iT);
    return(0);
  }
}

int iblbbi_(int*iT,int*fU)
{
  char ch;
  int iB;

  iB= Tbl[*iT].iB;
  sprintf(NmIOFile,"%s/Wrk/%s.bi",blb[iB].pathI,blb[iB].NmB);
  if(*fU){
    iB= ioftnb_(fU,NmIOFile,"r");
    if(iB){
      fpBnr= (FILE*)1L;
    }
    else{
      fpBnr= NULL;
    }
  }
  else{
    fpBnr= fopen(NmIOFile,"rb");
    fpBnrI[*iT]= fpBnr;
  }
  if(fpBnr==NULL){
    printf("Absent: <%s> for Input\a\n",NmIOFile);
    printf("In order to proceed, type 'y'\n");
    printf("In order to exit,    type 'n'\n");
    ch= getchar();
    switch(ch){
    case 'y':
    case 'Y':
      return(0);
    case 'n':
    case 'N':
    default:
      XDeInitWin();
      exit(0);
    }
  }
  printf("Input : %s\n",NmIOFile);
  if(*fU==0){
    CbIOSet2HD(4,*iT);
    return(0);
  }
  return(iB);
}

int CbStgBnrInp(int iT,FILE**fp)
{
  char ch;
  int iB,iM,iS;

  iB= Tbl[iT].iB;
  iM= Tbl[iT].iM;
  iS= Tbl[iT].iS;
  sprintf(NmIOFile,"%s/Wrk/%s.bi",blb[iB].pathI,blb[iB].NmS[iM][iS]);
  fpBnr= fopen(NmIOFile,"rb");
  fpBnrI[iT]= fpBnr;
  if(fpBnr==NULL){
    printf("Absent: <%s> for Input\a\n",NmIOFile);
    printf("In order to proceed, type 'y'\n");
    printf("In order to exit,    type 'n'\n");
    ch= getchar();
    switch(ch){
    case 'y':
    case 'Y':
      return(0);
    case 'n':
    case 'N':
    default:
      XDeInitWin();
      exit(0);
    }
  }
  *fp= fpBnr;
  if(fpBnr != NULL){
    printf("Input : %s\n",NmIOFile);
    return(1);
  }
  else{
    CbIOSet2HD(4,iT);
    return(0);
  }
}

int istgbi_(int*iT,int*fU)
{
  char ch;
  int iB,iM,iS;

  iB= Tbl[*iT].iB;
  iM= Tbl[*iT].iM;
  iS= Tbl[*iT].iS;
  sprintf(NmIOFile,"%s/Wrk/%s.bi",blb[iB].pathI,blb[iB].NmS[iM][iS]);
  if(*fU){
    iB= ioftnb_(fU,NmIOFile,"r");
    if(iB){
      fpBnr= (FILE*)1L;
    }
    else{
      fpBnr= NULL;
    }
  }
  else{
    fpBnr= fopen(NmIOFile,"rb");
    fpBnrI[*iT]= fpBnr;
  }
  if(fpBnr==NULL){
    printf("Absent: <%s> for Input\a\n",NmIOFile);
    printf("In order to proceed, type 'y'\n");
    printf("In order to exit,    type 'n'\n");
    ch= getchar();
    switch(ch){
    case 'y':
    case 'Y':
      return(0);
    case 'n':
    case 'N':
    default:
      XDeInitWin();
      exit(0);
    }
  }
  printf("Input : %s\n",NmIOFile);
  if(*fU==0){
    CbIOSet2HD(4,*iT);
    return(0);
  }
  return(iB);
}

int CbBlbBnrOut(int iT,FILE**fp)
{
  char ch;
  int iB;
  iB= Tbl[iT].iB;

  sprintf(NmIOFile,"%s/Wrk/%s.bo",blb[iB].path,blb[iB].NmB);
  fpBnr= fopen(NmIOFile,"wb");
  fpBnrO[iT]= fpBnr;
  if(fpBnr==NULL){
    printf("Absent: <%s> for Input\a\n",NmIOFile);
    printf("In order to proceed, type 'y'\n");
    printf("In order to exit,    type 'n'\n");
    ch= getchar();
    switch(ch){
    case 'y':
    case 'Y':
      return(0);
    case 'n':
    case 'N':
    default:
      XDeInitWin();
      exit(0);
    }
  }
  *fp= fpBnr;
  if(fpBnr!=NULL){
    printf("Output: %s\n",NmIOFile);
    return(1);
  }
  else{
    CbIOSet2HD(5,iT);
    return(0);
  }
}

int iblbbo_(int*iT,int*fU)
{
  char ch;
  int iB;

  iB= Tbl[*iT].iB;
  sprintf(NmIOFile,"%s/Wrk/%s.bo",blb[iB].path,blb[iB].NmB);
  if(*fU){
    iB= ioftnb_(fU,NmIOFile,"w");
    if(iB){
      fpBnr= (FILE*)1L;
    }
    else{
      fpBnr= NULL;
    }
  }
  else{
    fpBnr= fopen(NmIOFile,"wb");
    fpBnrO[*iT]= fpBnr;
  }
  if(fpBnr==NULL){
    printf("Absent: <%s> for Input\a\n",NmIOFile);
    printf("In order to proceed, type 'y'\n");
    printf("In order to exit,    type 'n'\n");
    ch= getchar();
    switch(ch){
    case 'y':
    case 'Y':
      return(0);
    case 'n':
    case 'N':
    default:
      XDeInitWin();
      exit(0);
    }
  }
  printf("Output: %s\n",NmIOFile);
  if(*fU==0){
    CbIOSet2HD(5,*iT);
    return(0);
  }
  return(iB);
}

int CbStgBnrOut(int iT,FILE**fp)
{
  char ch;
  int iB,iM,iS;

  iB= Tbl[iT].iB;
  iM= Tbl[iT].iM;
  iS= Tbl[iT].iS;
  sprintf(NmIOFile,"%s/Wrk/%s.bo",blb[iB].path,blb[iB].NmS[iM][iS]);
  fpBnr= fopen(NmIOFile,"wb");
  fpBnrO[iT]= fpBnr;
  *fp= fpBnr;
  if(fpBnr != NULL){
    printf("Output: %s\n",NmIOFile);
    return(1);
  }
  else{
    CbIOSet2HD(5,iT);
    return(0);
  }
}

int istgbo_(int*iT,int*fU)
{
  char ch;
  int iB,iM,iS;

  iB= Tbl[*iT].iB;
  iM= Tbl[*iT].iM;
  iS= Tbl[*iT].iS;
  sprintf(NmIOFile,"%s/Wrk/%s.bo",blb[iB].path,blb[iB].NmS[iM][iS]);
  if(*fU){
    iB= ioftnb_(fU,NmIOFile,"w");
    if(iB){
      fpBnr= (FILE*)1L;
    }
    else{
      fpBnr= NULL;
    }
  }
  else{
    fpBnr= fopen(NmIOFile,"wb");
    fpBnrO[*iT]= fpBnr;
  }
  printf("Output: %s\n",NmIOFile);
  if(*fU==0){
    CbIOSet2HD(5,*iT);
    return(0);
  }
  return(iB);
}

int CbBlbAscInp(int iT,FILE**fp)
{
  char ch;
  int iB;

  iB= Tbl[iT].iB;
  sprintf(NmIOFile,"%s/In/%s.ai",blb[iB].pathI,blb[iB].NmB);

  fpBnr= fopen(NmIOFile,"r");
  fpAscI[iT]= fpBnr;
  if(fpBnr==NULL){
    printf("Absent: <%s> for Input\a\n",NmIOFile);
    printf("In order to proceed, type 'y'\n");
    printf("In order to exit,    type 'n'\n");
    ch= getchar();
    switch(ch){
    case 'y':
    case 'Y':
      return(0);
    case 'n':
    case 'N':
    default:
      XDeInitWin();
      exit(0);
    }
  }
  *fp	=fpBnr;
  if(fpBnr != NULL){
    printf("Input : %s\n",NmIOFile);
    return(1);
  }
  else{
    CbIOSet2HD(6,iT);
    return(0);
  }
}

int iblbai_(int*iT,int*fU)
{
  char ch;
  int iB;

  iB= Tbl[*iT].iB;
  sprintf(NmIOFile,"%s/In/%s.ai",blb[iB].pathI,blb[iB].NmB);
  if(*fU){
    iB= ioftna_(fU,NmIOFile,"r");
    if(iB){
      fpBnr= (FILE*)1L;
    }
    else{
      fpBnr= NULL;
    }
  }
  else{
    fpBnr= fopen(NmIOFile,"r");
    fpAscI[*iT]= fpBnr;
  }
  if(fpBnr==NULL){
    printf("Absent: <%s> for Input\a\n",NmIOFile);
    printf("In order to proceed, type 'y'\n");
    printf("In order to exit,    type 'n'\n");
    ch= getchar();
    switch(ch){
    case 'y':
    case 'Y':
      return(0);
    case 'n':
    case 'N':
    default:
      XDeInitWin();
      exit(0);
    }
  }
  printf("Input : %s\n",NmIOFile);
  if(*fU==0){
    CbIOSet2HD(6,*iT);
    return(0);
  }
  return(iB);
}

int CbStgAscInp(int iT,FILE**fp)
{
  char ch;
  int iB,iM,iS;

  iB= Tbl[iT].iB;
  iM= Tbl[iT].iM;
  iS= Tbl[iT].iS;
  sprintf(NmIOFile,"%s/In/%s.ai",blb[iB].pathI,blb[iB].NmS[iM][iS]);
  fpBnr= fopen(NmIOFile,"r");
  fpAscI[iT]= fpBnr;
  if(fpBnr==NULL){
    printf("Absent: <%s> for Input\a\n",NmIOFile);
    printf("In order to proceed, type 'y'\n");
    printf("In order to exit,    type 'n'\n");
    ch= getchar();
    switch(ch){
    case 'y':
    case 'Y':
      return(0);
    case 'n':
    case 'N':
    default:
      XDeInitWin();
      exit(0);
    }
  }
  *fp= fpBnr;
  if(fpBnr != NULL){
    printf("Input : %s\n",NmIOFile);
    return(1);
  }
  else{
    CbIOSet2HD(6,iT);
    return(0);
  }
}

int istgai_(int*iT,int*fU)
{
  char ch;
  int iB,iM,iS;

  iB= Tbl[*iT].iB;
  iM= Tbl[*iT].iM;
  iS= Tbl[*iT].iS;
  sprintf(NmIOFile,"%s/In/%s.ai",blb[iB].pathI,blb[iB].NmS[iM][iS]);

  if(*fU){
    iB= ioftna_(fU,NmIOFile,"r");
    if(iB){
      fpBnr= (FILE*)1L;
    }
    else{
      fpBnr= NULL;
    }
  }
  else{
    fpBnr= fopen(NmIOFile,"r");
    fpAscI[*iT]= fpBnr;
  }
  if(fpBnr==NULL){
    printf("Absent: <%s> for Input\a\n",NmIOFile);
    printf("In order to proceed, type 'y'\n");
    printf("In order to exit,    type 'n'\n");
    ch= getchar();
    switch(ch){
    case 'y':
    case 'Y':
      return(0);
    case 'n':
    case 'N':
    default:
      XDeInitWin();
      exit(0);
    }
  }
  printf("Input : %s\n",NmIOFile);
  if(*fU==0){
    CbIOSet2HD(6,*iT);
    return(0);
  }
  return(iB);
}

int CbBlbAscOut(int iT,FILE**fp)
{
  char ch;
  int iB;

  iB= Tbl[iT].iB;
  sprintf(NmIOFile,"%s/Out/%s.ao",blb[iB].path,blb[iB].NmB);
  fpBnr	=fopen(NmIOFile,"w");
  fpAscO[iT]	=fpBnr;
  *fp	=fpBnr;
  if(fpBnr != NULL){
    printf("Output: %s\n",NmIOFile);
    return(1);
  }
  else{
    CbIOSet2HD(7,iT);
    return(0);
  }
}

int iblbao_(int*iT,int*fU)
{
  char ch;
  int iB;

  iB= Tbl[*iT].iB;
  sprintf(NmIOFile,"%s/Out/%s.ao",blb[iB].path,blb[iB].NmB);
  if(*fU){
    iB= ioftna_(fU,NmIOFile,"w");
    if(iB){
      fpBnr= (FILE*)1L;
    }
    else{
      fpBnr= NULL;
    }
  }
  else{
    fpBnr= fopen(NmIOFile,"w");
    fpAscO[*iT]= fpBnr;
  }
  if(fpBnr == NULL){
    printf("Absent: <%s> for Input\a\n",NmIOFile);
    printf("In order to proceed, type 'y'\n");
    printf("In order to exit,    type 'n'\n");
    ch= getchar();
    switch(ch){
    case 'y':
    case 'Y':
      return(0);
    case 'n':
    case 'N':
    default:
      XDeInitWin();
      exit(0);
    }
  }
  if(*fU == 0){
    CbIOSet2HD(7,*iT);
    return(0);
  }
  else{
    printf("Output: %s\n",NmIOFile);
  }
  return(iB);
}

int CbStgAscOut(int iT,FILE**fp)
{
  char ch;
  int iB,iM,iS;

  iB= Tbl[iT].iB;
  iM= Tbl[iT].iM;
  iS= Tbl[iT].iS;
  sprintf(NmIOFile,"%s/Out/%s.ao",blb[iB].path,blb[iB].NmS[iM][iS]);
  fpBnr= fopen(NmIOFile,"w");
  fpAscO[iT]= fpBnr;
  *fp	=fpBnr;
  if(fpBnr != NULL){
    printf("Output: %s\n",NmIOFile);
    return(1);
  }
  else{
    CbIOSet2HD(7,iT);
    return(0);
  }
}

int istgao_(int*iT,int*fU)
{
  char ch;
  int iB,iM,iS;

  iB= Tbl[*iT].iB;
  iM= Tbl[*iT].iM;
  iS= Tbl[*iT].iS;
  sprintf(NmIOFile,"%s/Out/%s.ao",blb[iB].path,blb[iB].NmS[iM][iS]);
  if(*fU){
    iB= ioftna_(fU,NmIOFile,"w");
    if(iB){
      fpBnr= (FILE*)1L;
    }
    else{
      fpBnr= NULL;
    }
  }
  else{
    fpBnr= fopen(NmIOFile,"w");
    fpAscO[*iT]= fpBnr;
  }
  if(fpBnr==NULL){
    printf("Absent: <%s> for Input\a\n",NmIOFile);
    printf("In order to proceed, type 'y'\n");
    printf("In order to exit,    type 'n'\n");
    ch= getchar();
    switch(ch){
    case 'y':
    case 'Y':
      return(0);
    case 'n':
    case 'N':
    default:
      XDeInitWin();
      exit(0);
    }
  }
  if(*fU == 0){
    CbIOSet2HD(7,*iT);
    return(0);
  }
  else{
    printf("Output: %s\n",NmIOFile);
  }
  return(iB);
}

int FormatStr2Scales(char *strF,int *m,double *Scales)
{
  char Units[0x10];
  char *lc,*lu;
  int i,j,k,nU,iU;

  lc	=strF;
  i	=0;
  j	=1;
  k	=0;
  while(*lc){
    while(isspace(*lc)) lc++;
    if(isdigit(*lc)){
      j	=(*lc)-'0';
      lc++;
      while(isdigit(*lc)){
	j=j*10+(*lc)-'0';
	lc++;
      }
    }
    if(*lc == '%'){
      m[i]	=j;
      Scales[i]	=1.;
      strcpy(Units,"(1.)");
      j	=1;
      lc++;
      while(isspace(*lc) || *lc == 'e' || *lc == 'd' || *lc == 's') lc++;
      if(*lc == '('){
	lu	=Units;
	while(*lc != ')' && *lc){
	  *lu++=*lc++;
	}	
	*lu++=')';
	*lu	=0;
	CbGetObjUnits(&iU,&nU,Units);
	if(iU >= 0 && nU >=0){
	  CbSetUnitScale(Scales+j,nU,iU);
	}else{
	  CbStr2UserMessage("Error: Wrong Units <%s>\n",Units);
 	}
	if(Scales[j] != 1.) k++;
      }
      i++;
    }else{
      j=1;
    }
    if(*lc) lc++;
  }
  return(k);
}

int IsRecordFound(FILE *lF,char *Message,char *RecNm,char *strF
		  ,int *lPos,char *FNm,int *m,int *n)
{
  char ch,ch0,*lc;
  int k,j;

  lc	=RecNm;
  ch0	=*lc;
  while(feof(lF) == 0){
    ch	=(char)fgetc(lF);
    if(ch == ch0){
      do{
	lc++;
      }while(*lc != '\0' && feof(lF) == 0 && *lc == (ch=(char)fgetc(lF)));
      if(*lc == '\0'){
	break;
      }
      else{
	lc	=RecNm;
      }
    }
  }
  if(feof(lF)){
    CbStr2UserMessage("%s: %s is absent\n",Message,RecNm);
    return(0);
  }

  k	=0;
  while(feof(lF) == 0 && ch != '('){
    ch	=(char)fgetc(lF);
    if(ch == '['){
      lc	=strF;
      while(feof(lF) == 0 && (*lc=(char)fgetc(lF)) != ']' && lc-strF < 0x100)
	lc++;
      *lc	='\0';
      if((k=sscanf(strF,"%d @ %d : %s",n,lPos,FNm)) == 0){
	CbStr2UserMessage("%s: %d < 1: no N in %s\n",Message,RecNm);
	return(0);
      }
    }
  }

  lc	=strF;
  while(feof(lF) == 0 && (*lc=(char)fgetc(lF)) != ')') lc++;
  *lc	='\0';
  lc	=strF;
  *m	=0;
  while(*lc){
    while(isspace(*lc)) lc++;
    j	=isdigit(*lc) ? 0 : 1;
    while(*lc && isdigit(*lc)){
      j	=j*10+(*lc)-'0';
      lc++;
    }
    if(*lc == '%'){
      *m	+=j;
    }
    lc++;
  }
  return(k);
}

int IsKeyWordFoundM(FILE *lF,char *Message,char *Str,char *strF,int *m,int *n)
{
  char ch,ch0,*lc;
  int k,j;

  lc	=Str;
  ch0	=*lc;
  while(feof(lF) == 0){
    ch	=(char)fgetc(lF);
    if(ch == ch0){
      do{
	lc++;
      }while(*lc != '\0' && feof(lF) == 0 && *lc == (ch=(char)fgetc(lF)));
      if(*lc == '\0'){
	break;
      }
      else{
	lc	=Str;
      }
    }
  }
  if(feof(lF)){
    CbStr2UserMessage("%s: %s is absent\n",Message,Str);
    return(0);
  }
  while(feof(lF) == 0 && ch != '('){
    ch	=(char)fgetc(lF);
    if(ch == '['){
      lc	=strF;
      while(feof(lF) == 0 && (*lc=(char)fgetc(lF)) != ']' && lc-strF < 0x100)
	lc++;
      *lc	='\0';
      if((k=sscanf(strF,"%d",n)) != 1){
	CbStr2UserMessage("%s: %d < 1: no N in %s\n",Message,Str);
	return(0);
      }
    }
  }

  lc	=strF;
  while(feof(lF) == 0 && (*lc=(char)fgetc(lF)) != ')') lc++;
  *lc	='\0';
  lc	=strF;
  *m	=0;
  while(*lc){
    while(isspace(*lc)) lc++;
    k	=isdigit(*lc) ? 0 : 1;
    while(*lc && isdigit(*lc)){
      k	=k*10+(*lc)-'0';
      lc++;
    }
    if(*lc == '%'){
      *m	+=k;
    }
    lc++;
  }
  return(1);
}

int IsKeyWordFound(FILE *lF, char *Message, char *Str, char *strF,int *n)
{
  char ch,ch0,*lc;
  int k,j;

  lc	=Str;
  ch0	=*lc;
  while(feof(lF) == 0){
    ch	=(char)fgetc(lF);
    if(ch == ch0){
      do{
	lc++;
      }while(*lc != '\0' && feof(lF) == 0 && *lc == (ch=(char)fgetc(lF)));
      if(*lc == '\0'){
	break;
      }
      else{
	lc	=Str;
      }
    }
  }
  if(feof(lF)){
    CbStr2UserMessage("%s: %s is absent\n",Message,Str);
    return(0);
  }
  while(feof(lF) == 0 && ch != '('){
    ch	=(char)fgetc(lF);
    if(ch == '['){
      lc	=strF;
      while(feof(lF) == 0 && (*lc=(char)fgetc(lF)) != ']' && lc-strF < 0x100)
	lc++;
      *lc	='\0';
      if((k=sscanf(strF,"%d",n)) != 1){
	CbStr2UserMessage("%s: %d < 1: no N in %s\n",Message,Str);
	return(0);
      }
    }
  }
  while(feof(lF) == 0 && (*strF=(char)fgetc(lF)) != ')') strF++;
  *strF	='\0';
  return(1);
}

int IsRecordHeadFound(FILE *lF, char *Message, char *Str
		      ,int *lPos,char *FNm, char *strF,int *n)
{
  char ch,ch0,*lc;
  int k;

  lc	=Str;
  ch0	=*lc;
  while(feof(lF) == 0){
    ch	=(char)fgetc(lF);
    if(ch == ch0){
      do{
	lc++;
      }while(*lc != '\0' && feof(lF) == 0 && *lc == (ch=(char)fgetc(lF)));
      if(*lc == '\0'){
	break;
      }
      else{
	lc	=Str;
      }
    }
  }
  if(feof(lF)){
    CbStr2UserMessage("%s: %s is absent\n",Message,Str);
    return(0);
  }
  k	=0;
  while(feof(lF) == 0 && ch != '('){
    ch	=(char)fgetc(lF);
    if(ch == '['){
      lc	=strF;
      while(feof(lF) == 0 && (*lc=(char)fgetc(lF)) != ']' && lc-strF < 0x100)
	lc++;
      *lc	='\0';
      if((k=sscanf(strF,"%d @ %d : %s",n,lPos,FNm)) == 0){
	CbStr2UserMessage("%s: %d < 1: no N in %s\n",Message,Str);
	return(0);
      }
    }
  }
  while(feof(lF) == 0 && (*strF=(char)fgetc(lF)) != ')') strF++;
  *strF	='\0';
  return(k);
}

int FormatWrite2Read(char *str)
{
  char *lc;

  while(isspace(*str)) str++;
  lc	=str;
  while(*str != '\0'){
    if(*str == '%'){
      str++;
      while(*str != '\0' && !isalpha(*str)) str++;
      switch(*str){
      case 'e':
      case 'f':
      case 'g':
	strcpy(lc,"%e");
	lc	+=2;
	break;
      case 'd':
	strcpy(lc,"%d");
	lc	+=2;
	break;
      case 's':
	strcpy(lc,"%s");
	lc	+=2;
	break;
      case 'c':
	break;
      }
    }
    else{
      if(isspace(*str)){
	if(*(lc-1) != ' ') *lc++=' ';
      }
      else{
	*lc++	=*str;
      }
    }
    str++;
  }
  *lc	='\0';
  return(0);
}

int FormatStr2m(char *str)
{
  int k,m;
  char *ls;

  ls	=str;
  k	=0;
  while(*ls){
    while(isspace(*ls)) ls++;
    m	=1;
    if(isdigit(*ls)){
      m	=(*ls++)-'0';
      while(isdigit(*ls)) m=m*10+(*ls++)-'0';
    }
    if(*ls == '%') k +=m;
    ls++;
  }
  return(k);
}

int ReadAI(FILE *lF,char *Str,char *Ms,char *str,int n, char **lv,int *dl
	     ,int k)
{
  int i,j,m;
  char ln[256],*lc,*ls;
  char ch;

  for(i=0; i < n; i++){
    ls	=str;
    j	=0;
    while(j < k){
      while(isspace(*ls)) ls++;
      m	=isdigit(*ls) ? 0 : 1;
      while(isdigit(*ls)){
	m	=m*10+(*ls)-'0';
	ls++;
      }
      if(*ls == '%'){
	ls++;
	switch(*ls){
	case 'd':
	  while(m){
	    m--;
	    lc	=ln;
	    while(feof(lF) == 0 && (isspace(ch=(char)fgetc(lF)) || ch == '!')){
	      if(ch == '!')while(feof(lF) == 0&&(ch=(char)fgetc(lF)) != '\n') ;
	    }
	    *lc++	=ch;
	    while(feof(lF) == 0 && !isspace(ch=(char)fgetc(lF))) *lc++=ch;
	    *lc	='\0';
	    *(int*)lv[j]	=strtol(ln,&lc,10);
	    if(*lc != '\0'){
	      sprintf(ln,": in %s wrong [%d][%d]-th data\n",Str,i,j);
	      CbStr2UserMessage("%s: in %s wrong [%d][%d]-th data\n"
				,Ms,Str,i,j);
	    }
	    lv[j]	+=dl[j];
	    j++;
	  }
	  ls++;
	  break;
	case 'e':
	  while(m){
	    m--;
	    lc	=ln;
	    while(feof(lF) == 0 && (isspace(ch=(char)fgetc(lF)) || ch == '!')){
	      if(ch == '!')while(feof(lF) == 0 && (ch=(char)fgetc(lF))!='\n') ;
	    }
	    *lc++	=ch;
	    while(feof(lF) == 0 && !isspace(ch=(char)fgetc(lF))) *lc++=ch;
	    *lc	='\0';
	    *(double*)lv[j]	=strtod(ln,&lc);
	    if(*lc != '\0'){
	      CbStr2UserMessage("%s: in %s wrong [%d][%d]-th data\n"
				,Ms,Str,i,j);
	    }
	    lv[j]	+=dl[j];
	    j++;
	  }
	  ls++;
	  break;
	case 's':
	  while(m){
	    m--;
	    lc	=ln;
	    while(feof(lF) == 0 && (isspace(ch=(char)fgetc(lF)) || ch == '!')){
	      if(ch == '!')while(feof(lF) == 0 &&(ch=(char)fgetc(lF))!= '\n') ;
	    }
	    *lc++	=ch;
	    while(feof(lF) == 0 && !isspace(ch=(char)fgetc(lF))) *lc++=ch;
	    *lc	='\0';
	    strcpy((char*)lv[j],ln);
	    if(*lc != '\0'){
	      CbStr2UserMessage("%s: in %s wrong [%d][%d]-th data\n"
				,Ms,Str,i,j);
	    }
	    lv[j]	+=dl[j];
	    j++;
	  }
	  ls++;
	  break;
	}
      }
      else{
	while(feof(lF) == 0 && (isspace(ch=(char)fgetc(lF)) || ch == '!')){
	  if(ch == '!')while(feof(lF) == 0 && (ch=(char)fgetc(lF)) != '\n') ;
	}
	while(*ls != '\0' && ch == *ls && *ls != '%' && !isspace(*ls)){
	  ls++;
	  if(feof(lF) == 0) ch=(char)fgetc(lF);
	}
      }      
    }
    while(feof(lF) == 0 && ch != '\n') ch=(char)fgetc(lF);
  }
  return(0);
}

