#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>		/* for cos(), sin(), and sqrt() */
#include <GL/glx.h>		/* this includes X and gl.h headers */
#include "XCbType.h"

extern Display *theD;
extern Window WinGL;
extern WinPar*WinP;
extern GLXContext cxGL;

static double cgp,cgp2a,a2cgp;
int CbGetCurrentCbName(char** lD,char** lN);

static int iWinGL=1;
static float angleX=0.,angleY=0.,angleZ=0.,Scale=1.;
static float shiftX=0.,shiftY=0.;
static int lastX,lastY,kScale=0;

static double ScaleX=1.,ScaleY=1.,ScaleZ=1.;

int (*DisplObj)(void);
static Font fID;

static int nCMap=14;
static char *NmCMap[14]={
  "/w/oGL/Dat/cmap/Ps.cmap",
  "/w/oGL/Dat/cmap/bobsrainbow.cmap",
  "/w/oGL/Dat/cmap/carnation_red_white.cmap",
  "/w/oGL/Dat/cmap/default.map",
  "/w/oGL/Dat/cmap/default2.cmap",
  "/w/oGL/Dat/cmap/ensightcolordef.cmap",
  "/w/oGL/Dat/cmap/fastdefault.cmap",
  "/w/oGL/Dat/cmap/greyscale.cmap",
  "/w/oGL/Dat/cmap/hotmetal.cmap",
  "/w/oGL/Dat/cmap/lavawaves.cmap",
  "/w/oGL/Dat/cmap/morning_glory_blue_tan.cmap",
  "/w/oGL/Dat/cmap/peanutbutter_and_jelly.cmap",
  "/w/oGL/Dat/cmap/rainbow_banded.cmap",
  "/w/oGL/Dat/cmap/saturn_pastelyellow_to_purple.cmap"
};

int ReadCMap(GLfloat cmap[][4],int i)
{
  FILE *lF;
  float *lf;
  static int kC=-1;
  int j;

  if(i == 0 || kC == i) return(0);
  if(i > nCMap) i=nCMap;
  kC	=i;
  i--;
  lF=fopen(NmCMap[i],"r");
  fscanf(lF,"%d",&j);
  lf	=cmap[0];
  j++;
  for(i=0; i < j; i++){
    fscanf(lF,"%g %g %g %g",lf,lf+1,lf+2,lf+3);
    lf	+=4;
  }
  fclose(lF);
  return(0);
}

#ifdef H
/*
 * This program was written by Max Waterman (Global Product Support, SGI)
 * According to how insightII got compiled, you will need to edit dlopen() to
 * /usr/lib32/libGL.so, or /usr/lib64/libGL.so .
 *
 * $ cc -g -c glxChooseVisual.c
 * $ ld -shared glXChooseVisual.o -o glXChooseVisual.so -soname \
 * glXChooseVisual.so -ldl
 *
 * After compiling the share object library, you will have to setenv _RLD_LIST
 * to point to the right one.
 */



#include <dlfcn.h>
int new_attribList[] = {
  GLX_RGBA,
  None
};

XVisualInfo *glXChooseVisual0( Display *dpy, int screen, int *attribList )
{
  XVisualInfo *ret_val;
  void *handle;
  XVisualInfo * (*fPtr)(Display *, int, int *);
  int *this_attribList = attribList;

  if ( attribList[0] == None ) {
    this_attribList = new_attribList;
    fprintf( stderr, "WARNING:overriding attribList in glXChoosVisual()\n" );
  }

  if ((handle = dlopen( "/usr/lib/libGL.so", RTLD_LAZY ) ) == NULL ) {
    fprintf( stderr, "ERROR:dlopen() returned NULL\n" );
    fprintf( stderr, "%s\n", dlerror() );
    exit( -1 );
  }

  if ( ( fPtr = (XVisualInfo *(*)(Display *, int, int *))
                dlsym( handle, "glXChooseVisual" ) ) == NULL ) {
    fprintf( stderr, "ERROR:dlsym() returned NULL\n" );
    fprintf( stderr, "%s\n", dlerror() );
    exit( -1 );
  }
  ret_val = (*fPtr)(dpy, screen, this_attribList);

  dlclose( handle );

  return ret_val;
}
#endif

int InitFontGL()
{
  XFontStruct *font;
  char *lc;
  lc	="-adobe-courier-bold-r-*-*-*-180-*-75-m-*-*-*";
  font	=XLoadQueryFont(theD,lc);
  fID	=font->fid;
  glXUseXFont(fID,32,96,2000+32);
  lc	="-adobe-symbol-medium-r-*-*-*-180-*-75-p-*-*-*";
  font	=XLoadQueryFont(theD,lc);
  fID	=font->fid;
  glXUseXFont(fID,32,96,2200+32);

  cgp	=4.*atan(1.);
  cgp2a	=180./cgp;
  a2cgp	=cgp/180.;

  return(0);
}

int GetSizeWinGL(int *W,int *H)
{
  *W	=WinP[iWinGL].iW;
  *H	=WinP[iWinGL].iH;
  return(0);
}

int SetWinGL(int i)
{
  iWinGL	=i;
  WinGL	=WinP[iWinGL].W;
  glXMakeCurrent(theD,WinGL,cxGL);
  if(fID == 0) InitFontGL();
  return(0);
}

int SetViewPort(int Fl)
{
  if(Fl == 0){
    GLsizei w;
    w	=WinP[iWinGL].iW < WinP[iWinGL].iH ? WinP[iWinGL].iW : WinP[iWinGL].iH;
    glViewport(0,0,w,w);
  }
  else{
    glViewport((GLsizei)0,(GLsizei)0,(GLsizei)WinP[iWinGL].iW
	       ,(GLsizei)WinP[iWinGL].iH);
    if(Fl == 2) glOrtho(0.,WinP[iWinGL].iW,0.,WinP[iWinGL].iH,-1.,1.);
  }
  return(0);
}

int SetObjAngles(double x,double y,double z,double Sc)
{
  angleX	=x;
  angleY	=y;
  angleZ	=z;
  Scale		=Sc;

  glLoadIdentity();
  glTranslatef(shiftX,shiftY,0.0);
  glRotatef(angleX,1.0,0.0,0.0);
  glRotatef(angleY,0.0,1.0,0.0);
  glRotatef(angleZ,0.0,0.0,1.0);
  return(0);
}

int GetObjAngles(double *x,double *y,double *z,double *Sc)
{
  double cq,sq,cj,sj,cy,sy,s;
  int i,j;
  GLdouble amat[0x10],bmat[0x10];

  GetAngles();
  *x	=angleX;
  *y	=angleY;
  *z	=angleZ;
  *Sc	=Scale;
  return(0);
}

int GetAngles()
{
  double cq,cj;
  GLdouble amat[0x10];
  
  glGetDoublev(GL_MODELVIEW_MATRIX,amat);
  angleY	=amat[8];	
  cj	=1.-angleY*angleY;
  angleY	=angleY < -1. ? -90. : (angleY > 1. ? 90. :asin(angleY)*cgp2a);
  if(cj > 0.){
    cj	=1./sqrt(cj);
    angleX	=-amat[9]*cj;
    cq	=amat[10];
    angleZ	=-amat[4]*cj;
    angleZ	=angleZ < -1. ? -90. : (angleZ > 1. ? 90. :asin(angleZ)*cgp2a);
    if(amat[0] < 0.) angleZ=180.-angleZ;
  }
  else{
    angleZ	=0.;
    angleX	=amat[1];
    cq	=amat[5];
  }
  angleX	=angleX < -1. ? -90. :(angleX > 1. ? 90. : asin(angleX)*cgp2a);
  if(cq < 0.) angleX=180.-angleX;
  return(0);
}

int SetObjShifts(double x,double y)
{
  shiftX	=x;
  shiftY	=y;
  return(0);
}

int GetObjShifts(double *x,double *y)
{
  *x	=shiftX;
  *y	=shiftY;
  return(0);
}

int GLgrabPixels()
{
  static int nCb=0;
  static int kCb[0x20]={
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
  static char *lDCb[0x20],*lNCb[0x20];
  int i,L;
  char str[0x100];
  char FNm[0x200];
  char *lD,*lN;
  FILE *lF;

#ifdef H
  int j;
  unsigned char bbb[0x10000000],*lu;


  out("???? IIx",WinP[iWinGL].iW,WinP[iWinGL].iH
      ,WinP[iWinGL].iW*WinP[iWinGL].iH*3);
  glReadPixels(0,0,WinP[iWinGL].iW,WinP[iWinGL].iH,GL_BLUE
	       ,GL_UNSIGNED_BYTE,bbb);

  lu	=bbb;
  for(i=0; i < 36; i++){
    for(j=0; j < 36; j++) printf("%02hx",*lu++);
    putchar('\n');
  }
#endif
  CbGetCurrentCbName(&lD,&lN);
  puts(lD);
  puts(lN);

  for(i=0; i < nCb; i++){
    if(lDCb[i] == lD && lNCb[i] == lN) break;
  }
  if(i == nCb){
    lDCb[i]	=lD;
    lNCb[i]	=lN;
    nCb++;
  }
  L	=sprintf(FNm,"%s/Out/%sf%2.2d",lDCb[i],lNCb[i],kCb[i]++);
  sprintf(str,"xwd -id %ld|xwdtopnm|tee %s.pnm|"
	  "pnmtops -nocenter -noturn -w %d -h %d > %s.eps"
	  ,WinGL,FNm,WinP[iWinGL].iW,WinP[iWinGL].iH,FNm);
  puts(FNm);
  puts(str);
  system(str);
  sprintf(str,"cjpeg -qual 100 %s.pnm > %s.jpg",FNm,FNm);
  system(str);
  out("sss","Output: ",FNm,".pnm");
  out("sss","Output: ",FNm,".eps");
  out("sss","Output: ",FNm,".jpg");
  return(0);
}

int ScaleObj2Win(double x1,double x2,double y1,double y2,double z1,double z2
		 ,int Fl)
{
  double r;

  SetViewPort(Fl);
  if(Fl > 1) return(0);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  r	=1./Scale;
  glOrtho(x1*r,x2*r,y1*r,y2*r,z1*r,z2*r);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
#ifdef H
  glRotatef(angleX,0.0,1.0,0.0);
  glRotatef(angleY,1.0,0.0,0.0);
  glRotatef(angleZ,0.0,0.0,1.0);
#endif

  ScaleX	=(x2-x1)/WinP[iWinGL].iW;
  ScaleY	=(y2-y1)/WinP[iWinGL].iH;
  ScaleZ	=ScaleX;

  return(0);
}

int ShowObj2D(XEvent *event)
{
  static int needRedraw=1;
  if(event == NULL){
#ifdef H
    glPopMatrix();
    glPushMatrix();
#endif
    glLoadIdentity();
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    DisplObj();
    glPopMatrix();
    glXSwapBuffers(theD,WinGL);
    glFlush();
    needRedraw=0;
    return(0);
  }
  switch (event->type){
  case ConfigureNotify:
  case Expose:
    while(event->type == Expose  || event->type == ConfigureNotify){
      XNextEvent(theD,event);
    }
    GuiReSetWP(iWinGL);
    SetViewPort(0);
    needRedraw=1;
    break;
  case MotionNotify:
    angleZ-=(lastX-event->xmotion.x);
    if(angleZ < 0.) angleZ+=360.;
    if(angleZ > 360.) angleZ-=360.;
    lastX=event->xbutton.x;
    needRedraw=1;
    break;
  case ButtonPress:
    lastX=event->xbutton.x;
    break;
  }
  if(needRedraw) {
#ifdef H
    glPopMatrix();
    glPushMatrix();
#endif
    glLoadIdentity();
    glRotatef(angleZ,0.0,0.0,1.0);
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    DisplObj();
    glPopMatrix();
    glXSwapBuffers(theD,WinGL);
    needRedraw=0;
  }
  return(0);
}

int (*pSetLight)(void);

int ShowObj3D(XEvent *event)
{
  static int Bk=0;
  static int needRedraw=1;
  int dx,dy,kRot;

  kRot=4;
  switch(event == NULL ? 0 : event->type){
  case 0:
    needRedraw=1;
    break;
  case ConfigureNotify:
  case Expose:
    while(event->type == Expose  || event->type ==ConfigureNotify){
      XNextEvent(theD,event);
    }
    GuiReSetWP(iWinGL);
    SetViewPort(0);
    needRedraw=1;
    break;
  case MotionNotify:
    dx	=lastX-event->xmotion.x;
    dy	=lastY-event->xmotion.y;
    if((event->xkey.state&0x01) == 0 && abs(dx)+abs(dy) < 5) return(0);
    /*Shift*/

    if((event->xkey.state&0x08)){
      kRot=0;
      if(Bk == 1){
	shiftX-=dx*ScaleX/Scale;
      }
      else{
	if(Bk == 2){
	  shiftY+=dy*ScaleY/Scale;
	}
      }
    }
    else{
      kRot=Bk;
      if(Bk == 1){
	angleY-=dx;
	if(angleY < 0.) angleY	+=360.;
	if(angleY > 360.) angleY	-=360.;
      }
      else{
	if(Bk == 2){
	  angleX-=dy;
	  if(angleX < 0.) angleX	+=360.;
	  if(angleX > 360.) angleX	-=360.;
	}
	else{
	  angleZ-=dx;
	  if(angleZ < 0.) angleZ	+=360.;
	  if(angleZ > 360.) angleZ-=360.;
	}
      }
    }
    lastX=event->xbutton.x;
    lastY=event->xbutton.y;
    needRedraw=1;
    break;
  case KeyPress:
    if(event->xkey.state && event->xkey.keycode == 33){/*Cntr*/
      GLgrabPixels();
    }
    break;
  case ButtonPress:
    lastX=event->xbutton.x;
    lastY=event->xbutton.y;
    Bk=event->xbutton.button;
    if((event->xkey.state&0x06)){/*Cntr || CapL, Shift || Shift+CapL*/
      switch(Bk){
      case 1:
	Scale *=1.125;
	glMatrixMode(GL_PROJECTION);
	glScalef(1.125,1.125,1.125);
	glMatrixMode(GL_MODELVIEW);
 	break;
      case 2:
	Scale *=8./9.;
	glMatrixMode(GL_PROJECTION);
	glScalef(8./9,8./9,8./9);
	glMatrixMode(GL_MODELVIEW);
	break;
      case 3:
	Scale=1./Scale;
	glMatrixMode(GL_PROJECTION);
	glScalef(Scale,Scale,Scale);
	glMatrixMode(GL_MODELVIEW);
	Scale =1.;
	shiftX	=0.;
	shiftY	=0.;
	break;
      }
      kScale	=1;
      kScale	=0;
      needRedraw=1;
    }
    break;
  }

  if(needRedraw) {
#ifdef H
    glLoadIdentity();

    glMatrixMode(GL_MODELVIEW);
    if(kScale) glEnable(GL_RESCALE_NORMAL);
    glScalef(Scale,Scale,Scale);

    glTranslatef(shiftX,shiftY,0.0);

    glRotatef(angleX,1.0,0.0,0.0);
    glRotatef(angleY,0.0,1.0,0.0);
    glRotatef(angleZ,0.0,0.0,1.0);

#endif

    switch(kRot){
    case 0:
      glTranslatef(shiftX,shiftY,0.0);
      break;
    case 1:
      glRotatef(-dx,0.0,1.0,0.0); /* around Y */
      break;
    case 2:
      glRotatef(-dy,1.0,0.0,0.0); /* around X */
      break;
    case 3:
      glRotatef(-dx,0.0,0.0,1.0); /* arounZ */
      break;
    default:
      break;
    }

    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    DisplObj();
    glXSwapBuffers(theD,WinGL);

#ifdef H
    if(kScale){
      glDisable(GL_RESCALE_NORMAL);
      kScale	=0;
    }
#endif
    needRedraw=0;
    GetAngles();
  }
  return(0);
}

#ifdef H
static char *EventNm[]={
  "",
  "",
  "KeyPress",
  "KeyRelease",
  "ButtonPress",
  "ButtonRelease",
  "MotionNotify",
  "EnterNotify",
  "LeaveNotify",
  "FocusIn",
  "FocusOut",
  "KeymapNotify",
  "Expose",
  "GraphicsExpose",
  "NoExpose",
  "VisibilityNotify",
  "CreateNotify",
  "DestroyNotify",
  "UnmapNotify",
  "MapNotify",
  "MapRequest",
  "ReparentNotify",
  "ConfigureNotify",
  "ConfigureRequest",
  "GravityNotify",
  "ResizeRequest",
  "CirculateNotify",
  "CirculateRequest",
  "PropertyNotify",
  "SelectionClear",
  "SelectionRequest",
  "SelectionNotify",
  "ColormapNotify"
  "ClientMessage"
  "MappingNotify"
};

{
  void glClearColor(GLclampf red,GLclampf green,GLclampf blue,GLclampf alpha);
  void glClearAccum(GLclampf red,GLclampf green,GLclampf blue,GLclampf alpha);
  /*[-1,1]*/
  void glClearDepth(GLclampd depth); /*[0,1]*/
  void glClearIndex(GLfloat c); /* ? */
  void glClearStencil(GLint i); /* ? */

  {
    void glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT |
		 GL_ACCUM_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);

    void glViewport(GLint x,GLint y,GLsizei width,GLsizei height);

    void glMatrixMode(GL_MODELVIEW || GL_PROJECTION || GL_TEXTURE || GL_COLOR);
    void glLoadIdentity(void);
    void glOrtho(GLdouble left,GLdouble right,GLdouble bottom,
		 GLdouble top,GLdouble near_val,GLdouble far_val);
    void glEnable(GL_ALPHA_TEST || GL_AUTO_NORMAL || GL_BLEND || 
		  GL_CLIP_PLANEi || GL_COLOR_LOGIC_OP || GL_COLOR_MATERIAL || 
		  GL_COLOR_TABLE || GL_CONVOLUTION_1D || GL_CONVOLUTION_2D || 
		  GL_CULL_FACE || GL_DEPTH_TEST || GL_DITHER || GL_FOG || 
		  GL_HISTOGRAM || GL_INDEX_LOGIC_OP || GL_LIGHTi || 
		  GL_LIGHTING || GL_LINE_SMOOTH || GL_LINE_STIPPLE || 
		  GL_MAP1_COLOR_4 || GL_MAP1_INDEX || GL_MAP1_NORMAL || 
		  GL_MAP1_TEXTURE_COORD_1 || GL_MAP1_TEXTURE_COORD_2 || 
		  GL_MAP1_TEXTURE_COORD_3 || GL_MAP1_TEXTURE_COORD_4 || 
		  GL_MAP1_VERTEX_3 || GL_MAP1_VERTEX_4 || GL_MAP2_COLOR_4 || 
		  GL_MAP2_INDEX || GL_MAP2_NORMAL || GL_MAP2_TEXTURE_COORD_1 ||
		  GL_MAP2_TEXTURE_COORD_2 || GL_MAP2_TEXTURE_COORD_3 || 
		  GL_MAP2_TEXTURE_COORD_4 || GL_MAP2_VERTEX_3 || 
		  GL_MAP2_VERTEX_4 || GL_MINMAX || GL_NORMALIZE || 
		  GL_POINT_SMOOTH || GL_POLYGON_OFFSET_FILL || 
		  GL_POLYGON_OFFSET_LINE || GL_POLYGON_OFFSET_POINT || 
		  GL_POLYGON_SMOOTH || GL_POLYGON_STIPPLE || 
		  GL_POST_COLOR_MATRIX_COLOR_TABLE || 
		  GL_POST_CONVOLUTION_COLOR_TABLE || GL_RESCALE_NORMAL || 
		  GL_SEPARABLE_2D || GL_SCISSOR_TEST || GL_STENCIL_TEST || 
		  GL_TEXTURE_1D || GL_TEXTURE_2D || GL_TEXTURE_3D || 
		  GL_TEXTURE_GEN_Q || GL_TEXTURE_GEN_R || GL_TEXTURE_GEN_S || 
		  GL_TEXTURE_GEN_T);

  {
      void glColor3f(GLfloat red,GLfloat green,GLfloat blue);
      void glColor4f(GLfloat red,GLfloat green,GLfloat blue,GLfloat alpha);
      void glPointSize(GLfloat size);
      void glLineWidth(GLfloat width);

      if(glISEnabled(GL_LINE_STIPPLE)){
	void glLineStipple(GLint factor,GLushort pattern);
      }
      void glPolygonMode(GL_FRONT || GL_BACK || GL_FRONT_AND_BACK,
			 GL_POINT || GL_LINE || GL_FILL);

      void glFrontFace(GL_CW || GL_CCW);

      if(glISEnabled(GL_CULL_FACE)){
	void glCullFace(GL_FRONT || GL_BACK || GL_FRONT_AND_BACK);
      }

      void glBegin(GL_POINTS || GL_LINES || GL_LINE_STRIP || GL_LINE_LOOP || 
		   GL_TRIANGLES || GL_TRIANGLE_STRIP || GL_TRIANGLE_FAN || 
		   GL_QUADS || GL_QUAD_STRIP || GL_POLYGON);
      {
	void glColor3f(...);
	void glIndexf(GLfloat c);
	void glNormal3f(GLfloat nx,GLfloat ny,GLfloat nz);
	void glMaterialf(GL_FRONT || GL_BACK || GL_FRONT_AND_BACK
			 ,GL_SHININESS,GLfloat param);
	void glMaterialfv(GL_FRONT || GL_BACK || GL_FRONT_AND_BACK,
			  GL_AMBIENT || GL_DIFFUSE || GL_SPECULAR || 
			  GL_EMISSION || GL_SHININESS || 
			  GL_AMBIENT_AND_DIFFUSE || GL_COLOR_INDEXES,
			  const GLfloat *params);

	void glVertex3f(GLfloat x,GLfloat y,GLfloat z);
      }
      void glEnd();
    }
  }
}


glNormal3fv() does not work;
#endif
