#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#ifndef mzl_DOC
typedef struct DOCTXT{
  int t;	/* Type of the Comment block */
  int kID;  	/* nCNmID*/
  int kCB;  	/* nCBTkn */
  int k0;	/* Starting line # in the file */
  int k1;	/* End line # in the file */
}DOCTXT;
typedef struct CMMNT{
  int t; /* Type of the Comment block */
  int kID;  /* nCNmID */
  int kCB;  /* nCBTkn */
  int k0; /* Starting line # in the file */
  int k1; /* End line # in the file */
  char *b; /* pointer to beginning of Comment block*/
  char *e; /* pointer to end of Comment block*/
}CMMNT;
typedef struct STRNG{
  int k0; /* Starting line # in the file */
  int k1; /* End line # in the file */
  char *b; /* pointer to beginning of String block*/
  char *e; /* pointer to end of String block*/
}STRNG;
struct tm *pTm;
int nHLWrd,nCMMnt,iCMMnt;
CMMNT *CMMnt;
int NCMMnt=0;
#endif

#ifndef mzl_DOC
static time_t sTime;
static int DocWrt=1;
static int NDTxt=0,nDTxt;
static DOCTXT *DTxt;

static int NSTRng=0,nSTRng;
static STRNG *STRng;
#endif

#ifndef mzl_FILES
char NmF[80],NmSF[80];
int iFLn,nFBff,kLnFL,*fFLn,LCln=0;
char *FBff,*Cln;
long int *pFLn;
int nFLn;

static struct stat statbuf;
static char NmSD[80],NmDF[80],NmOF[80];
static char *Nmxtn[]={"c","h","c.d","h.d","L","Cb","blb","blb.d"
			,"mzl","mzl.d","stg","stg.d","f","f.d"};
static FILE *fpS,*fpO;
static int LNmSD,Nxtn=14,Ixtn;
static int NFBff=0,NFLn=0,iFLnB;
#endif

#ifndef mzl_LST
typedef struct NMSF{
  char *p;
  char *b;
  int L;
  int Lxtn;
  int xtn;
  int n;
}NMSF;

static NMSF *pNmSF;
static int nNmSF,NNmSF=0;
#endif

#ifndef mzl_CB
typedef struct ResWord{
  int L;
  char *p;
}ResWord;
typedef struct CBTKN{
  int L; /* Flag */
  int d; /* depth */
  int t; /* CbType */
  int f; /* File number */
  int k0; /* Starting line # in the file */
  int k1; /* End line # in the file */
  int kTxt; /* Doc Comment */
  int kCMM; /* C Comment */
  int kPg;  /* PS Page */
  int i0; /* Starting Global ID */
  int i1; /* Ending Global ID */
  int j0; /* Starting Global Used ID */
  int j1; /* Ending Global Used ID */
  char *Nm; /* pointer to Name*/
}CBTKN;
CBTKN *CBTkn;
ResWord CbCResW[9]={
  4,"blb_",
  4,"mzl_",
  4,"stg_",
  3,"Tbl",
  3,"Asc",
  3,"Bnr",
  3,"Ins",
  3,"Del",
  3,"Doc"
};
int kCBD,*kCB,iCBD,NCBD=0,*fCB;
int NCBTkn=0,nCBTkn;
int kCBF;

static int nCBTknD;
static int NMzl=0,nMzl,*kMzl;
static int NCbCResW=9,iCbCResW;

#endif

#ifndef mzl_PRP
char Cword[64];
static int NCprResW=12,iCprResW;
static ResWord CprResW[12]={
  6,"ifndef",
  5,"ifdef",
  2,"if",
  4,"else",
  4,"elif",
  5,"endif",
  5,"undef",
  6,"define",
  7,"include",
  4,"line",
  6,"pragma",
  5,"error"
};

static int NPRD=0,iPRD,*fPR;
static int NPRNmDf=0,nPRNmDf,*LPRNmDf,NPRNmUn=0,nPRNmUn,*LPRNmUn;
static char **PRNmDf,**vPRNmDf,**PRNmUn;
#endif

#ifndef mzl_C
typedef struct CNMID{
  int d;
  int t;
  int n;
  int L;
  int ID;
  int k;
  int kTxt;
  int kCMM;
  int kPg;
  char *p;
}CNMID;
CNMID *CNmID,*CNmUS;

int NCNmID=0,nCNmID,*LCTp,nCTp,kCTp,NCNmUS=0,nCNmUS;
static int kCNmID,iCNmID,nCNmIDD,CNmDmnA,CNmDmnP;
static int NCD=0,iCD,iCDi,nCD;
static int iCDr,iCDc,*i0CNmID;
static int NCTp=0,nCTpD,dnCTpD=4,fCDcl,fCTp;
static char **CTp,bfID[64];
static int NCResW=37,iCResW;
static ResWord CResW[37]={
  3,"asm",
  4,"auto",
  5,"break",
  4,"case",
  4,"char",
  5,"const",
  8,"continue",
  7,"default",
  2,"do",
  6,"double",
  4,"else",
  5,"entry",
  4,"enum",
  6,"extern",
  5,"float",
  3,"for",
  7,"fortran",
  4,"goto",
  2,"if",
  3,"int",
  4,"long",
  8,"register",
  6,"return",
  5,"short",
  6,"signed",
  6,"sizeof",
  6,"static",
  6,"struct",
  6,"switch",
  7,"typedef",
  5,"union",
  8,"unsigned",
  4,"void",
  8,"volatile",
  5,"while",
  4,"main",
  6,"CbMain"
};

static int NCResWTpDf=3;
static ResWord CResWTpDf[3]={
  4,"enum",
  7,"typedef",
  5,"union"
};

static int NCPreResWTp=12;
static ResWord CPreResWTp[12]={
  6,"static",
  6,"extern",
  6,"struct",
  5,"union",
  4,"long",
  5,"short",
  8,"unsigned",
  5,"const",
  6,"signed",
  4,"auto",
  8,"register",
  8,"volatile"
};

static int NCResWTp=5;
static ResWord CResWTp[5]={
  4,"char",
  6,"double",
  5,"float",
  3,"int",
  4,"void"
};

static int NCResWSt=14;
static ResWord CResWSt[14]={
  5,"break",
  4,"case",
  8,"continue",
  7,"default",
  2,"do",
  4,"else",
  5,"entry",
  3,"for",
  4,"goto",
  2,"if",
  6,"return",
  6,"sizeof",
  6,"switch",
  5,"while",
};

static int NCResWOth=3;
static ResWord CResWOth[3]={
  4,"main",
  3,"asm",
  7,"fortran"
};

static int NCCmpAssOp=10;
static ResWord CCmpAssOp[10]={
  2,"+=",
  2,"-=",
  2,"*=",
  2,"/=",
  2,"%=",
  3,"<<=",
  3,">>=",
  2,"&=",
  2,"^=",
  2,"|="
};

static int NCCmpOp=11;
static ResWord CCmpOp[11]={
  2,"->",
  2,"++",
  2,"--",
  2,"<<",
  2,">>",
  2,"<=",
  2,">=",
  2,"==",
  2,"!=",
  2,"&&",
  2,"||"
};

static int NCSmplOp=15;
static char CSmplOp[15]={
  '!',
  '%',
  '^',
  '&',
  '*',
  '-',
  '+',
  '=',
  '~',
  '|',
  '.',
  '<',
  '>',
  '/',
  '?'
};

static int NCSepCh=9;
static char CSepCh[9]={
  '(',
  ')',
  '[',
  ']',
  '{',
  '}',
  ',',
  ';',
  ':'
};
#endif

#ifndef mzl_PS
extern int LndPrt;
extern int nPSPg;
extern int NPSPg;
extern int *fPSPg;
#endif

#ifndef mzl_FILES
int CbDocInitFileNames()
{
  char ch,*p,*p1,*p2,*p3;

  p	=NmSF;
  p1	=p;
  while(*p != '\0'){
    if(*p == '/'){
      p1=p+1;
    }
    if(*p == '.'){
      break;
    }
    p++;
  }
  ch	=*p1;
  *p1	='\0';
  strcpy(NmSD,NmSF);
  LNmSD	=p1-NmSF;
  *p1	=ch;
  p	=p1;
  p1	=NmF;
  strcpy(NmOF,"Out/");
  p2	=NmOF+4;
  strcpy(NmDF,"Doc/");
  p3	=NmDF+4;
  while(*p != '\0' && *p != '.'){
    *p1++=*p;
    *p2++=*p;
    *p3++=*p++;
  }
  if(*p == '.'){
    for(Ixtn=0; Ixtn < Nxtn; Ixtn++){
      if(strcmp(p+1,Nmxtn[Ixtn]) == 0){
	break;
      }
    }
  }
  else{
    Ixtn=Nxtn;
  }
  while(*p != '\0'){
    *p1++=*p;
    *p2++=*p;
    *p3++=*p++;
  }
  *p1='\0';
  strcpy(p2,".d");
  strcpy(p3,".d");
  return(0);
}

#ifndef stg_Init
int CbDocReInitFLn()
{
  if(NFLn){
    NFLn+=0x100;
    fFLn=(int *)realloc((void*)fFLn,(size_t)NFLn*sizeof(int));
    pFLn=(long int *)realloc((void*)pFLn,(size_t)NFLn*sizeof(long int));
  }
  else{
    NFLn=0x400;
    fFLn=(int *)malloc((size_t)NFLn*sizeof(int));
    pFLn=(long int*)malloc((size_t)NFLn*sizeof(long int));
  }
  if(pFLn == NULL || fFLn == NULL){
    printf("Reading %s - file interrupted%c\n",NmSF,7);
    printf("Error at %d: No memory for %d pFLn's or fFLn's\n",kLnFL,NFLn);
    return(-1);
  }
  return(0);
}

int CbDocDeInitFLn()
{
  if(NFLn){
    free(pFLn);
    free(fFLn);
  }
  NFLn=0;
  return(0);
}
#endif

int CbDocReInitFBff()
{
  if(NFBff){
    NFBff+=0x4000;
    FBff=(char *)realloc((void*)FBff,(size_t)NFBff*sizeof(char));
  }
  else{
    NFBff=0x10000;
    FBff=(char *)malloc((size_t)NFBff*sizeof(char));
  }
  if(FBff == NULL){
    printf("Reading %s - file interrupted%c\n",NmSF,7);
    printf("Error at %d: No memory for %d FBff's\n",kLnFL,NFBff);
    return(-1);
  }
  return(0);
}

int CbDocDeInitFBff()
{
  if(NFBff){
    free(FBff);
    NFBff=0;
  }
  return(0);
}

int CbDocReInitCln()
{
  if(LCln){
    LCln+=0x100;
    Cln=(char*)realloc((void*)Cln,(size_t)LCln*sizeof(char));
  }
  else{
    LCln=0x100;
    Cln=(char*)malloc((size_t)LCln*sizeof(char));
  }
  if(Cln == NULL){
    printf("Error at %d: No memory for %d Cln\n",kLnFL,LCln);
    return(-1);
  }
  return(0);
}

int CbDocDeInitCln()
{
  if(LCln)
    free(Cln);
  LCln=0;
  return(0);
}

int CbDocFile2Bff(char *NameSF)
{
  char ln[80];
  char *p;
  int k;

  strcpy(ln,NameSF);
  k	=0;
  if(stat(ln,&statbuf) == 0){
    k	=statbuf.st_size;
  }
  else{
    strcpy(ln,"Src/");
    strcpy(ln+4,NameSF);
    if(stat(ln,&statbuf) == 0){
      k	=statbuf.st_size;
    }
  }
  if(k == 0){
    printf("%s - file cannot be open for input\n",ln);
    return(-1);
  }
  fpS	=fopen(ln,"r");

  printf("%s - file is open for input\n",ln);
  nFBff=0;
  *FBff='\n'; /* Fake symbol */
  p=FBff;

  nFLn=0;
  kLnFL=0;
  while(feof(fpS) == 0){
    if(*p == '\n'){
      if(nFLn >= NFLn){
	if(CbDocReInitFLn()){
	  fclose(fpS);
	  return(-1);
	}
      }
      pFLn[nFLn]=(long)(p-FBff+1);
      fFLn[nFLn]=(p > FBff && *(p-1) == '\\') ? 0x20000000 : 0;
      nFLn++;
      kLnFL++;
    }
    p++;
    nFBff++;
    if(nFBff >= NFBff){
      if(CbDocReInitFBff()){
	fclose(fpS);
	return(-1);
      }
      p=FBff+nFBff;
    }
    *p=(char)fgetc(fpS);
  }

  *p='\0';
  if(FBff+pFLn[nFLn-1] != p){
    if(nFLn >= NFLn){
      if(CbDocReInitFLn()){
	fclose(fpS);
	return(-1);
      }
    }
    pFLn[nFLn]=(long)(p-FBff);
    fFLn[nFLn]=0;
    nFLn++;
  }
  fclose(fpS);
  return(nFBff);
}
#endif

#ifndef mzl_CB
int CbDocReInitMzl()
{
  if(NMzl){
    NMzl+=8;
    kMzl=(int*)realloc((void*)kMzl,(size_t)NMzl*sizeof(int));
  }
  else{
    NMzl=8;
    kMzl=(int*)malloc((size_t)NMzl*sizeof(int));
  }
  if(kMzl == NULL){
    printf("No memory for %d Mzl's%c\n",NMzl,7);
    exit(0);
  }
  return(0);
}

int CbDocDeInitMzl()
{
  if(NMzl){
    free(kMzl);
    NMzl=0;
  }
  return(0);
}

int CbDocReInitCBD()
{
  if(NCBD){
    NCBD+=8;
    fCB=(int*)realloc((void*)fCB,(size_t)NCBD*sizeof(int));
    kCB=(int*)realloc((void*)kCB,(size_t)NCBD*sizeof(int));
  }
  else{
    NCBD=8;
    fCB=(int*)malloc((size_t)NCBD*sizeof(int));
    kCB=(int*)malloc((size_t)NCBD*sizeof(int));
  }
  if(fCB == NULL || kCB == NULL){
    printf("No memory for %d fCB's%c\n",NCBD,7);
    exit(0);
  }
  return(0);
}

int CbDocDeInitCBD()
{
  free(kCB);
  free(fCB);
  return(0);
}

int CbDocReInitCBTkn()
{
  if(NCBTkn){
    NCBTkn+=32;
    CBTkn=(CBTKN*)realloc((void*)CBTkn,(size_t)NCBTkn*sizeof(CBTKN));
  }
  else{
    NCBTkn=32;
    CBTkn=(CBTKN*)malloc((size_t)NCBTkn*sizeof(CBTKN));
  }
  if(CBTkn == NULL){
    printf("No memory for %d CBTkn's%c\n",NCBTkn,7);
    exit(0);
  }
  return(0);
}

int CbDocFreeCBTknNm()
{
  int i;
  for(i=0; i < nCBTkn; i++){
    CBTkn[i].L=0;
    free(CBTkn[i].Nm);
  }
  return(0);
}

int CbDocDeInitCBTkn()
{
  int i;
  free(CBTkn);
  return(0);
}

int CbDocGetCbCResWord()
{
  int i,L;
  char *p,*p1;

#ifdef H
  if(kCBD){
    if(DocWrt < 2){
      return(-1);
    }
  }
  else{
    if(DocWrt == 2){
      return(-1);
    }
  }
#endif
  for(iCbCResW=0; iCbCResW < NCbCResW; iCbCResW++){
    if(strncmp(Cword,CbCResW[iCbCResW].p,CbCResW[iCbCResW].L) == 0){
      break;
    }
  }
  if(iCbCResW < NCbCResW){
    if(iCbCResW < 3){
      p1=Cword+CbCResW[iCbCResW].L;
      L=strlen(p1);
      CBTkn[nCBTkn].L=L;
      CBTkn[nCBTkn].Nm=(char*)malloc((size_t)(L+1)*sizeof(char));
      p=CBTkn[nCBTkn].Nm;
      while(*p1 != '\0'){
	*p++=*p1++;
      }
      *p='\0';
      if(CBTkn[nCBTkn].L > 31){
	CBTkn[nCBTkn].L=31;
	*(CBTkn[nCBTkn].Nm+CBTkn[nCBTkn].L)='\0';
      }
      CBTkn[nCBTkn].L<<=24;
      CBTkn[nCBTkn].t =iCbCResW;
      if(iCbCResW == 1){
	p=CBTkn[nCBTkn].Nm;
	for(i=0; i < nCBTkn; i++){
	  if((CBTkn[i].t&0xFF) == 1 && strcmp(p,CBTkn[i].Nm) == 0){
	    break;
	  }
	}
	CBTkn[nCBTkn].t |=i<<16;
      }
    }
    return(iCbCResW);
  }
  return(-1);
}

int CbDocSetCBTknTp(int n)
{
  int i,ii,k;

  for(i=n+1; i < nCBTkn; i++){
    if((CBTkn[i].d&0xFFFF) == 0)
      break;
    switch((CBTkn[i].t&0xFF)){
    case 0:
      CBTkn[i].t |=i<<16;
      break;
    case 1:
      k=CBTkn[i].t>>16;
      for(ii=0; ii < nMzl; ii++){
	if(kMzl[ii] == k)
	  break;
      }
      if(ii == nMzl){
	kMzl[ii]=k;
	nMzl++;
	if(nMzl >= NMzl)
	  CbDocReInitMzl();
      }
      break;
    case 2:
      ii=i;
      do{
	ii=CBTkn[ii].d>>16;
      }while((CBTkn[ii].t&0xFF) == 2);
      CBTkn[i].t |=(CBTkn[ii].t&0xFFFF0000);
      break;
    }
  }
  return(0);
}

int CbDocPrintCBPath(int i)
{
  int L;
  do{
    L	=CBTkn[i].t&0x01FF;
    if((L&0x0100)){
      printf(".%s()",CBTkn[i].Nm);
    }
    else{
      if((CBTkn[i].d&0xFFFF) == 0){
	printf("<-%s",CBTkn[i].Nm);
	break;
      }
      else{
	printf(".%s%s",CbCResW[(L&0xFF)].p,CBTkn[i].Nm);
      }
    }
    i=CBTkn[i].d>>16;
  }while(1);
  return(0);
}
#endif

#ifndef mzl_C
int IsAlNum(char ch)
{
  if(ch == '_' || ('a' <= ch && ch <= 'z') || ('A' <= ch && ch <= 'Z')
     || ('0' <= ch && ch <= '9'))
    return(1);
  else
    return(0);
}

int IsAlpha(char ch)
{
  if(ch == '_' || ('a' <= ch && ch <= 'z') || ('A' <= ch && ch <= 'Z'))
    return(1);
  else
    return(0);
}

int CbDocGetPRPWord(char *w,char *s)
{
  int n;

  n=0;
  while(IsAlpha(*s)){
    *w++=*s++;
    n++;
    if(n == 33){
      break;
    }
  }
  *w='\0';
  return(n);
}

int CbDocGetCWord(char *w,char *s)
{
  int n;

  n=0;
  if(IsAlpha(*s) == 0)
    return(0);
  while(IsAlNum(*s)){
    *w++=*s++;
    n++;
    if(n == 33){
      break;
    }
  }
  *w='\0';
  return(n);
}

int CbDocIfCResWrd(char *s)
{
  int i;
  for(i=0; i < NCResW; i++){
    if(strcmp(s,CResW[i].p) == 0){
      return(1);
    }
  }
  return(0);
}

int CbDocReInitCD()
{
  if(NCD){
    NCD+=8;
    i0CNmID=(int*)realloc((void*)i0CNmID,(size_t)NCD*sizeof(int));
  }
  else{
    NCD=8;
    i0CNmID=(int*)malloc((size_t)NCD*sizeof(int));
  }
  if(i0CNmID == NULL){
    printf("No memory for %d fCD's%c\n",NCD,7);
    exit(0);
  }
  return(0);
}

int CbDocDeInitCD()
{
  if(NCD){
    free(i0CNmID);
    NCD=0;
  }
  return(0);
}

int CbDocReInitCTp()
{
  if(NCTp){
    NCTp+=32;
    LCTp=(int*)realloc((void*)LCTp,(size_t)NCTp*sizeof(int));
    CTp=(char**)realloc((void*)CTp,(size_t)NCTp*sizeof(char*));
  }
  else{
    NCTp=32;
    LCTp=(int*)malloc((size_t)NCTp*sizeof(int));
    CTp=(char**)malloc((size_t)NCTp*sizeof(char*));
  }
  if(CTp == NULL){
    printf("No memory for %d CTp's%c\n",NCTp,7);
    exit(0);
  }
  return(0);
}

int CbDocDeInitCTp()
{
  int i;
  if(NCTp){
    for(i=0; i < nCTp; i++){
      free(CTp[i]);
    }
    free(CTp);
    NCTp=0;
  }
  return(0);
}

int CbDocDeInitCNmUS()
{
  int i;

  if(NCNmUS){
    for(i=0; i < nCNmUS; i++) free(CNmUS[i].p);
    free(CNmUS);
    NCNmUS=0;
  }
  return(0);
}

int CbDocReInitCNmUS()
{
  int i;
  if(NCNmUS){
    i	=NCNmUS;
    NCNmUS	+=32;
    CNmUS	=(CNMID*)realloc((void*)CNmUS,(size_t)NCNmUS*sizeof(CNMID));
  }
  else{
    i	=0;
    NCNmUS=32;
    CNmUS=(CNMID*)malloc((size_t)NCNmUS*sizeof(CNMID));
  }
  if(CNmUS == NULL){
    printf("No memory for %d CNmUS's%c\n",NCNmUS,7);
    exit(0);
  }
  while(i < NCNmUS){
    CNmUS[i].p	=(char*)malloc((size_t)32*sizeof(char));
    if(CNmUS[i].p == NULL){
      printf("No memory for %d CNmUS[%d].p's%c\n",i,NCNmUS,7);
      exit(0);
    }
    i++;
  }
  return(0);
}

int CbDocReInitCNmID()
{
  int i;
  if(NCNmID){
    i=nCNmID;
    NCNmID+=32;
    CNmID=(CNMID*)realloc((void*)CNmID,(size_t)NCNmID*sizeof(CNMID));
  }
  else{
    i=0;
    NCNmID=32;
    CNmID=(CNMID*)malloc((size_t)NCNmID*sizeof(CNMID));
  }
  if(CNmID == NULL){
    printf("No memory for %d CNmID's%c\n",NCNmID,7);
    exit(0);
  }
  while(i < NCNmID){
    CNmID[i].p=(char*)malloc((size_t)32*sizeof(char));
    if(CNmID[i].p == NULL){
      printf("No memory for %d CNmID[%d].p's%c\n",i,NCNmID,7);
      exit(0);
    }
    i++;
  }
  return(0);
}

int CbDocDeInitCNmID()
{
  int i;

  if(NCNmID){
    for(i=0; i < nCNmID; i++){
      free(CNmID[i].p);
    }
    free(CNmID);
    NCNmID=0;
  }
  return(0);
}

int CbDocPrintCNmTp(int j,int F)
{
  int ind,L;

  L=LCTp[j];
  ind=0;
  if((L&0x8000)){
    if(F)
      printf("static ");
    ind+=7;
  }
  if((L&0x4000)){
    if(F)
      printf("extern ");
    ind+=7;
  }
  if((L&0x2000)){
    if(F)
      printf("struct ");
    ind+=7;
  }
  if((L&0x1000)){
    if(F)
      printf("union ");
    ind+=6;
  }
  if((L&0x0800)){
    if(F)
      printf("long ");
    ind+=5;
  }
  if((L&0x0400)){
    if(F)
      printf("short ");
    ind+=6;
  }
  if((L&0x0200)){
    if(F)
      printf("unsigned ");
    ind+=9;
  }
  if((L&0x0100)){
    if(F)
      printf("const ");
    ind+=6;
  }
  if(F)
    printf("%s ",CTp[j]);
  ind+=(LCTp[j]&0x1F)+1;

  return(ind);
}

int CbDocPrintCNmID(int i,int F)
{
  int ind,k,j;

  k=CNmID[i].t;
  ind=CNmID[i].L&0xFFFF;
  if(F){
    if((j=k&0xF0000000)){
      j >>=28;
      while(j > 0){
	printf("*");
	ind++;
	j --;
      }
    }
    printf("%s",CNmID[i].p);
    if((j=k&0x0F000000)){
      j >>=24;
      while(j > 0){
	printf("[]");
	ind +=2;
	j --;
      }
    }
    if((k&0x200000)){
      printf("()");
      ind +=2;
    }
  }
  else{
    if((j=k&0xF0000000)){
      ind +=j>>28;
    }
    if((j=k&0x0F000000)){
      ind +=j>>23;
    }
    if((k&0x200000)){
      ind +=2;
    }
  }
  return(ind);
}

int CbDocCheckCTp(char *str)
{
  int i,L;

  L=LCTp[nCTp]&0xFFC0;
  for(i=0; i < nCTp; i++){
    if(L == (LCTp[i]&0xFFC0) && strcmp(str,CTp[i]) == 0){
      break;
    }
  }
  if(i < nCTp){
    LCTp[nCTp]=0;
  }
  else{
    L=strlen(str);
    LCTp[nCTp] |=0x20|L;
    CTp[nCTp]	 =(char*)malloc((size_t)(L+1)*sizeof(char));
    strcpy(CTp[nCTp],str);
    nCTp++;
    if(nCTp >= NCTp){
      CbDocReInitCTp();
    }
    LCTp[nCTp]=0;
  }
  kCTp=i;
  return(0);
}

int CbDocSetAttrCTp(int i)
{
  if(i < NCPreResWTp){
    LCTp[nCTp] |=0x20;
  }
  switch(i){
  case 0:			/* "static" */
    LCTp[nCTp] |=0x8000;
    break;
  case 1:			/* "extern" */
    LCTp[nCTp] |=0x4000;
    break;
  case 2:			/* "struct" */
    LCTp[nCTp] |=0x2000;
    break;
  case 3:			/* "union" */
    LCTp[nCTp] |=0x1000;
    break;
  case 4:			/* "long" */
    LCTp[nCTp] |=0x0800;
    break;
  case 5:			/* "short" */
    LCTp[nCTp] |=0x0400;
    break;
  case 6:			/* "unsigned" */
    LCTp[nCTp] |=0x0200;
    break;
  case 7:			/* "const" */
    LCTp[nCTp] |=0x0100;
    break;
  default :			/* "signed","auto","register","volatile" */
    break;
  }
  return(0);
}

int CBDocIsCResWTpDf(char *s)
{
  int i;

  for(i=0; i < NCResWTpDf; i++){
    if(strcmp(s,CResWTpDf[i].p) == 0){
      return(i);
    }
  }
  return(-1);
}

int CBDocIsCPreResWTp(char *s)
{
  int i;
  for(i=0; i < NCPreResWTp; i++){
    if(strcmp(s,CPreResWTp[i].p) == 0){
      return(i);
    }
  }
  return(-1);
}

int CBDocIsCResWTp(char *s)
{
  int i;
  for(i=0; i < NCResWTp; i++){
    if(strcmp(s,CResWTp[i].p) == 0){
      return(i);
    }
  }
  return(-1);
}

int CBDocIsCResWSt(char *s)
{
  int i;
  for(i=0; i < NCResWSt; i++){
    if(strcmp(s,CResWSt[i].p) == 0){
      return(i);
    }
  }
  return(-1);
}
#ifndef blb_Declared
#ifndef mzl_C
int CbDocFileSetCNmID(int n)
{
  int i,i0,i1,k,kk,L;

  i0=CBTkn[n].i0;
  i1=CBTkn[n].i1;
  for(i=i0; i < i1; i++){
    if((CNmID[i].t&0x008000) == 0){ /* fp == 0 */
      L=CNmID[i].d>>16;
      if((CBTkn[L].t&0xFF)){
	CNmID[i].t |=0x080000; /* lm */
      }
      kk=CNmID[i].n;
      if((CNmID[i].t&0x200000) == 0){
	if((LCTp[kk]&0x4000)){
	  CNmID[i].t |=0x100000; /* ext */
	}
	if((LCTp[kk]&0x8000)){
	  CNmID[i].t |=0x400000; /* stt */
	  CNmID[i].ID=i;
	  CNmID[i].L |=CNmID[i].d&0xFFFF0000;
	}
      }
      if((CNmID[i].t&0x100000) == 0){
	CNmID[i].t |=0x010000; /* lcf */
	if((CNmID[i].t&0xF00000) == 0){
	  CNmID[i].t |=0x800000; /* pbl */
	  CNmID[i].ID=i;
	  CNmID[i].L |=CNmID[i].d&0xFFFF0000;
	}
	if((CNmID[i].t&0x080000)){
	  CNmID[i].t |=0x060000; /* dlm lcm */
	}
      }
      else{
	if((CNmID[i].t&0x400000)){
	  printf("Error: incompatible  static in %c",7);
	  CbDocPrintCNmTp(CNmID[i].n,1);
	  CbDocPrintCNmID(i,1);
	  printf(" from ");
	  CbDocPrintCBPath(CNmID[i].d>>16);
	  printf("\n");
	}
      }
#ifdef H
      printf("??? 0x%8.8x ",CNmID[i].t);
      CbDocPrintCNmTp(CNmID[i].n,1);
      CbDocPrintCNmID(i,1);
      printf("\t");
      CbDocPrintCBPath(CNmID[i].d>>16);
      printf("\n");
#endif
    }
  }
  return(0);
}

int CbDocGlobalSetCNmID()
{
  int i,ii,j,k,kk,L,LL,m,m0;
  char *s;
 
  m0	=0;
  for(i=0; i < nCNmID; i++){
    k	=CNmID[i].t;
    s	=CNmID[i].p;

    if((k&0x908000) == 0x100000){/* extern variables and function prototypes */
      s	=CNmID[i].p;
      kk=CNmID[i].n;
      for(j=0; j < nCNmID; j++){
	L=CNmID[j].t;
	if((L&0x108000) == 0 && (L&0xC00000) && (k&0x200000) == (L&0x200000)
	   && strcmp(s,CNmID[j].p) == 0){
	  LL=CNmID[j].n;
	  if((LCTp[kk]&0x3F00) == (LCTp[LL]&0x3F00) &&
	     strcmp(CTp[kk],CTp[LL]) == 0){
	    CNmID[i].t |=0x800000;
	    CNmID[i].ID=j;
	    CNmID[i].L=(CNmID[i].L&0xFFFF)|(CNmID[j].d&0xFFFF0000);
	    if((L&0x080000))
	      CNmID[i].t |=0x040000;
	    L =CNmID[i].d>>16;
	    LL=CNmID[j].d>>16;
	    if(CBTkn[L].f == CBTkn[LL].f){
	      CNmID[i].t |=0x010000;
	    }
	    L =CBTkn[L].t>>16;
	    LL=CBTkn[LL].t>>16;
	    if((CNmID[i].t&0x0C0000) == 0x0C0000 && L == LL){
	      CNmID[i].t |=0x020000;
	    }
	  }
	  else{
	    printf("Warning: Inconsistent definition %c",7);
	    CbDocPrintCNmTp(LL,1);
	    CbDocPrintCNmID(j,1);
	    printf(" at ");
	    CbDocPrintCBPath(CNmID[j].d>>16);
	    printf(" for\n");
	    CbDocPrintCNmTp(kk,1);
	    CbDocPrintCNmID(i,1);
	    printf(" from ");
	    CbDocPrintCBPath(CNmID[i].d>>16);
	    printf("\n");
	  }
	  break;
	} 
      }
      if(j == nCNmID){
	CNmID[i].ID=-1;
#ifdef H
	printf("Warning: Undefined %c",7);
	CbDocPrintCNmTp(CNmID[i].n,1);
	CbDocPrintCNmID(i,1);
	printf(" from ");
	CbDocPrintCBPath(CNmID[i].d>>16);
	printf("\n");
#endif
      }
    }
    else{
      if((k&0xC00000) && m0 < 100){
	m=0;
	for(j=i+1; j < nCNmID; j++){
	  if((CNmID[j].t&0x100000) == 0 && strcmp(s,CNmID[j].p) == 0){
	    L	=CNmID[j].t&0x008000;
	    if(m == 0){
	      if(L){
		puts("Warning: same name for public ID"
		       " and function parameter:\a");
	      }
	      else{
		puts("Warning: multiple definition:\a");
	      }
	      printf("0. ");
	      CbDocPrintCNmTp(CNmID[i].n,1);
	      CbDocPrintCNmID(i,1);
	      printf(" at ");
	      CbDocPrintCBPath(CNmID[i].d>>16);
	    }
	    m++;
	    m0++;
	    printf(" and\n%d.",m);
	    CbDocPrintCNmTp(CNmID[j].n,1);
	    CbDocPrintCNmID(j,1);
	    if(L){
	      L	=CNmID[j].L>>16;
	      printf(" %4d in %s",CBTkn[L].k0,CBTkn[L].Nm);
	    }
	    printf(" at");
	    CbDocPrintCBPath(CNmID[j].d>>16);
	  }
	  if(m0 > 50){
	    putchar('\n');
	    puts("Warning: more that 50 multiple definitions in the code.");
	    m=0;
	    m0=100;
	    break;
	  }
	}
	if(m){
	  putchar('\n');
	}
      }
    }
  }
  return(0);
}
#endif
#endif

#ifndef blb_Used
#ifndef mzl_C
int CbDocAddCNmUS(char *s,int f)
{
  int i,k,n;
  char *t;

  CNmUS[nCNmUS].t=f ? 0x200000 : 0x000000;
  CNmUS[nCNmUS].n=-1;

  k=kCB[kCBD];
  for(i=CBTkn[k].j0; i < nCNmUS; i++){
    if((CNmUS[i].d>>16) == k && strcmp(s,CNmUS[i].p) == 0) return(0);
  }
  /* Auto ID */
  for(i=iCNmID; i < nCNmID; i++){
    if((CNmID[i].t&0x100000) == 0 && strcmp(s,CNmID[i].p) == 0){
      if((CNmID[i].d >> 16) == k){
	return(0);
      }
      else{
	break;
      }
    }
  }
  CNmUS[nCNmUS].kTxt=-1;
  CNmUS[nCNmUS].kCMM=-1;
  CNmUS[nCNmUS].kPg =-1;
  CNmUS[nCNmUS].d=(k<<16)|(iCD<<8)|(CBTkn[k].t&0xFF);
  t=CNmUS[nCNmUS].p;
  while(*s != '\0') *t++=*s++;
  *t='\0';

  CNmUS[nCNmUS].L=t-CNmUS[nCNmUS].p;
  if(i < nCNmID){
    CNmUS[nCNmUS].n=CNmID[i].n;
    CNmID[i].t |=0x002000; /* usd */
    CNmUS[nCNmUS].t |=0x014000|(CNmID[i].t&0xFF000000); /* lcf dfv */
    if((CNmID[i].t&0x104000) == 0x004000 || i == iCNmID){
      CNmUS[nCNmUS].ID=i;
      CNmUS[nCNmUS].t |=0x008000; /* fp */
      n=CNmID[i].L&0xFFFF0000;
    }
    else{
      CNmUS[nCNmUS].ID=-1;
      n=CNmID[i].d&0xFFFF0000;
    }
    CNmUS[nCNmUS].L |=n;
  }
  nCNmUS++;
  if(nCNmUS >= NCNmUS) CbDocReInitCNmUS();
  return(0);
}

int CbDocSetCNmUS()
{
  int i,j,k,L,n;
  char *s;
 
  k=kCB[kCBD];
  for(i=CBTkn[k].j0; i < nCNmUS; i++){
    if((CNmUS[i].d>>16) == k && (CNmUS[i].t&0x004000) == 0){
      s=CNmUS[i].p;
      for(j=kCNmID; j < iCNmID; j++){
	if((CNmID[j].t&0x008000) == 0 && strcmp(s,CNmID[j].p) == 0){
	  CNmUS[i].n =CNmID[j].n;
	  CNmID[j].t |=0x002000; /* usd */
	  CNmUS[i].ID =j;
	  CNmUS[i].t|=0x001000|(CNmID[j].t&0xFF000000); /* prt */
	  break;
	}
      }
    }
  }
  return(0);
}

int CbDocGlobalSetCNmUS(int n)
{
  int i,i0,i1,j,j0,j1,k,L,M;
  char *s;
 
  i0=CBTkn[n].i0;
  i1=CBTkn[n].i1;
  j0=CBTkn[n].j0;
  j1=CBTkn[n].j1;

  for(j=j0; j < j1; j++){
    k=CNmUS[j].t;
    if((k&0x000001) == 0){
      L=CBTkn[CNmUS[j].d>>16].t>>16;
      if((CBTkn[L].t&0xFF) == 1){
	CNmUS[j].t |=0x002000; /* ulm */
      }
      if((k&0x004000) == 0){
	s=CNmUS[j].p;
	if((k&0x001000) == 0){
	  for(i=0; i < nCNmID; i++){
	    L=CNmID[i].t;
	    if((L&0x908000) == 0x800000 && strcmp(s,CNmID[i].p) == 0){
	      CNmUS[j].n=CNmID[i].n;
	      CNmID[i].t |=0x002000; /* usd */
	      CNmUS[j].ID=i;
	      CNmUS[j].t |=(0x800000|(CNmID[i].t&0x0C0000)); /* pbl lm dlm */
	      M=CNmID[i].L&0xFFFF0000;
	      CNmUS[j].L=(CNmUS[j].L&0xFFFF)|M;
	      M >>=16;
	      if(CBTkn[M].f == CBTkn[n].f)
		CNmUS[j].t|=0x010000; /* lcf */
	      M=CBTkn[M].t>>16;
	      L=CBTkn[CNmUS[j].d>>16].t>>16;
	      if((CNmUS[j].t&0x002000) && M == L){
		CNmUS[j].t |=0x020000; /* lcm */
	      }
	      for(k=j+1; k < j1; k++){
		if((CNmUS[k].t&0xC05001) == 0 && strcmp(s,CNmUS[k].p)==0){
		  CNmUS[k].ID=i;
		  CNmUS[k].n=CNmUS[j].n;
		  CNmUS[k].L=CNmUS[j].L;
		  L=CBTkn[CNmUS[k].d>>16].t>>16;
		  if((CBTkn[L].t&0xFF) == 1){
		    CNmUS[k].t |=0x002000; /* ulm */
		    if(M == L)
		      CNmUS[k].t |=0x020000; /* lcm */
		  }
		  CNmUS[k].t|=(CNmUS[j].t&0xCD0000)|0x000001; /* pbl rpn */
		}
	      }
	      break;
	    }
	  }
	}
	else{
	  i=CNmUS[j].ID;
	  CNmUS[j].t |=CNmID[i].t&0x0D0000; /* lm dlm lcf */
	  if(CNmID[i].ID >= 0){
	    i=CNmID[i].ID;
	    CNmUS[j].n=CNmID[i].n;
	    CNmUS[j].L=(CNmUS[j].L&0xFFFF)|(CNmID[i].L&0xFFFF0000);
	    CNmUS[j].t |=(CNmID[i].ID&0x400000)?0x400000:0x800000;/* pbl/stt */
	    L=CBTkn[CNmUS[j].d>>16].t>>16;
	    M=CBTkn[CNmUS[j].L>>16].t>>16;
	    if((CNmUS[j].t&0x002000) && M == L){
	      CNmUS[j].t |=0x020000; /* lcm */
	    }
	    for(k=j+1; k < j1; k++){
	      if((CNmUS[k].t&0xC05001) == 0x001000  && CNmUS[k].ID == i){
		CNmUS[k].n=CNmUS[j].n;
		CNmUS[k].L=CNmUS[j].L;
		L=CBTkn[CNmUS[k].d>>16].t>>16;
		if((CBTkn[L].t&0xFF) == 1){
		  CNmUS[k].t |=0x002000; /* ulm */
		  if(M == L){
		    CNmUS[k].t |=0x020000; /* lcm */
		  }
		}
		CNmUS[k].t|=(CNmUS[j].t&0xCD0000)|0x000001; /* pbl/stt rpn */
	      }
	    }
	  }
	  else{
	    CNmUS[j].n=CNmID[i].n;
	    CNmUS[j].t |=(CNmID[i].t&0x080000)|0x000200; /* lm und */
	    M=CNmID[i].d&0xFFFF0000;
	    CNmUS[j].L |=M;
	    L=CBTkn[M>>16].t>>16;
	    if((CNmUS[j].t&0x080000)){
	      CNmUS[j].t |=0x040000; /* dlm */
	      if(L == (CBTkn[CNmUS[j].d>>16].t>>16)){
		CNmUS[j].t |=0x020000; /* lcm */
	      }
	    }
	    for(k=j+1; k < j1; k++){
	      if((CNmUS[k].t&0xC05001) ==0x001000  && CNmUS[k].ID == i){
		CNmUS[k].n=CNmUS[j].n;
		CNmUS[k].L |=M;
		L=CBTkn[CNmUS[k].d>>16].t>>16;
		if((CBTkn[L].t&0xFF) == 1){
		  CNmUS[k].t |=0x002000; /* ulm */
		}
		CNmUS[k].t|=(CNmUS[j].t&0x0C0000)|0x000201; /* lm dlm und rpn*/
		if((CNmUS[j].t&0x080000) && L== (CBTkn[CNmUS[k].d>>16].t>>16)){
		  CNmUS[k].t |=0x020000; /* lcm */
		}
	      }
	    }
	  }
	}
      }
      else{
	L=CBTkn[CNmUS[j].d>>16].t>>16;
	i=CBTkn[CNmUS[j].L>>16].t>>16;
	if((CBTkn[i].t&0xFF) == 1){
	  CNmUS[j].t |=0x0C0000; /* lm dlm */
	  if(i == L){
	    CNmUS[j].t |=0x020000; /* lcm */
	  }
	}
      }
    }
  }
  return(0);
}
#endif
#endif

int CbDocCTypes()
{
  static char *p,*p1,*p2,ch;
  static CNMID *pC,*pCi;
  static int i,L;
  
  p=Cln;
  while(*p != '\0'){
    if(fCDcl){    /* Declarations and Definitions */
      switch(fCTp){
      case 0:
	if(IsAlpha(*p)){
	  p1=bfID;
	  *p1++=*p;
	  fCTp=1;
	}
	else{
	  switch(*p){
	  case '*':
	    if(kCTp < 0){
	      if(LCTp[nCTp] == 0 && iCD){
		fCDcl=0;
		break;
	      }
	      else{
		printf("Warning at %d: implicit int type%c\n",iFLn+1,7);
		CbDocCheckCTp("int");
	      }
	    }
	    CNmDmnP++;
	    break;
	  case ')':
	    if(fCDcl == 2){
	      fCTp=0;
	      LCTp[nCTp]=0;
	      CNmDmnP=0;
	      CNmDmnA=0;
	      kCTp=-1;
	      fCDcl=3;
	    }
	    else{
	      printf("Error at %d: wrong declaration before ')'%c\n",iFLn+1,7);
	    }
	    break;
	  case '{':
	    if(fCDcl != 3){
	      printf("Error at %d: wrong declaration before '{'%c\n",iFLn+1,7);
	      break;
	    }
	    iCNmID=i0CNmID[iCD]-1;
	    if((LCTp[CNmID[iCNmID].n]&0x8000)){
	      CNmID[iCNmID].t|=0x410000; /* stt lcf */
	    }
	    else{
	      CNmID[iCNmID].t|=0x810000; /* pbl lcf */
	    }
	    CNmID[iCNmID].ID=iCNmID;
	    CNmID[iCNmID].kTxt=-1;
	    CNmID[iCNmID].kCMM=iCMMnt;
	    fFLn[iFLnB] |=0xC000;
	    for(i=iCNmID; i < nCNmID; i++){
	      CNmID[i].L |=(nCBTkn<<16);
	    }
	    iCBD++;
	    if(iCBD == NCBD){
	      CbDocReInitCBD();
	    }
	    fCB[iCBD]=0x40C00000|(iCBD < 0x40FF ? (iCBD<<8) : 0x3FFF00);
	    kCBD++;
	    kCB[kCBD]=nCBTkn;
	    i=(CNmID[iCNmID].L&0xFFFF);
	    CBTkn[nCBTkn].f=kCBF;
	    CBTkn[nCBTkn].L=i;
	    CBTkn[nCBTkn].Nm=(char*)malloc((size_t)(i+1)*sizeof(char));
	    strcpy(CBTkn[nCBTkn].Nm,CNmID[iCNmID].p);
	    CBTkn[nCBTkn].L<<=24;
	    CBTkn[nCBTkn].t =0x0100;
	    CBTkn[nCBTkn].L |=fCB[iCBD];
	    CBTkn[nCBTkn].d =kCBD ? (kCB[kCBD-1]<<16)|kCBD : kCBD;
	    CBTkn[nCBTkn].k0 =iFLnB;
	    CBTkn[nCBTkn].kTxt =-1;
	    CBTkn[nCBTkn].kCMM =-1;
	    CBTkn[nCBTkn].kPg =-1;
	    CBTkn[nCBTkn].i0 =iCNmID;
	    CBTkn[nCBTkn].j0 =nCNmUS;
	    nCBTkn++;
	    if(nCBTkn == NCBTkn){
	      CbDocReInitCBTkn();
	    }
	    break;
	  default :
	    if((iCD == 0 && fCDcl != 3) || kCTp >= 0 || LCTp[nCTp]){
	      if(iCD && kCTp >= 0 && *p == '='){
		fCDcl=0;
		fCTp=0;
		CbDocAddCNmUS(CTp[kCTp],0);
		break;
	      }
	      else{
		printf("Error at %d: wrong declaration%c\n",iFLn+1,7);
	      }
	    }
	    if(fCDcl == 3){
	      nCNmID=i0CNmID[iCD];
	      iCNmID=nCNmID-1;
	      L=CNmID[iCNmID].n;
	      CNmID[iCNmID].t |=0x100000; /* ext */
	      if((LCTp[L]&0x8000)){
		printf("Error at %d: inconsistent type:%c\n",iFLn+1,7);
		CbDocPrintCNmTp(L,1);
		printf(" %s();\n",CNmID[iCNmID].p);
	      }
	    }
	    fCDcl=1;
	    break;
	  }
	}
	break;
      case 1:
	if(IsAlNum(*p)){
	  if(p == Cln){
	    *p1='\0';
	    i=CBDocIsCResWTpDf(bfID);
	    if(i >= 0){	/* typedef */
	      fCTp=8;
	      iCDi=0;
	      break;
	    }
	    i=CBDocIsCPreResWTp(bfID);
	    if(i >= 0){
	      CbDocSetAttrCTp(i);
	    }
	    else{
	      CbDocCheckCTp(bfID);
	    }
	    p1=bfID;
	  }
	  if(p1-bfID < 32){
	    *p1++=*p;
	  }
	}
	else{
	  *p1='\0';
	  if(iCD && CBDocIsCResWSt(bfID) >= 0){
	    fCDcl=0;
	    fCTp=0;
	    break;
	  }
	  switch(*p){
	  case ' ':
	    i=CBDocIsCResWTpDf(bfID);
	    if(i >= 0){	/* typedef */
	      fCTp=8;
	      iCDi=0;
	      break;
	    }
	    i=CBDocIsCPreResWTp(bfID);
	    if(i >= 0){
	      CbDocSetAttrCTp(i);
	    }
	    else{
	      CbDocCheckCTp(bfID);
	    }
	    fCTp=0;
	    break;
	  case '*':
	    i=CBDocIsCResWTpDf(bfID);
	    if(i >= 0){
	      printf("Error at %d: wrong C type <%s>%c\n",iFLn+1,bfID,7);
	      fCTp=8;
	      iCDi=0;
	      break;
	    }
	    i=CBDocIsCPreResWTp(bfID);
	    if(i >= 0){
	      CbDocSetAttrCTp(i);
	      printf("Warning at %d: implicit int type%c\n",iFLn+1,7);
	      CbDocCheckCTp("int");
	    }
	    else{
	      CbDocCheckCTp(bfID);
	    }
	    fCTp=0;
	    p1=bfID;
	    *p1++=*p;
	    CNmDmnP++;
	    break;
	  case '(':
	    if(kCTp < 0){
	      if(LCTp[nCTp] == 0 && iCD){
		fCDcl=0;
		break;
	      }
	      else{
		printf("Warning at %d: implicit int type%c\n",iFLn+1,7);
		CbDocCheckCTp("int");
	      }
	    }
	    *p1='\0';
	    pC=CNmID+nCNmID;
	    strcpy(pC->p,bfID);
	    pC->kTxt=-1;
	    pC->kCMM=iCMMnt;
	    i=kCB[kCBD];
	    if(iCD){
	      pC->kCMM=-1;
	      nCMMnt=iCMMnt;
	      if(CBTkn[i].kCMM == nCMMnt)
		CBTkn[i].kCMM=-1;
	    }
	    pC->kPg=-1;
	    pC->t=(CNmDmnP<<28)|0x200000; /* fn */
	    pC->n=kCTp;
	    fFLn[iFLn] |=(nCNmID<<16)|iCBD;
	    iFLnB=iFLn;
	    pC->d=(i<<16)|(iCD<<8)|(CBTkn[i].t&0xFF);
	    pC->L=p1-bfID;
	    nCNmID++;
	    if(nCNmID >= NCNmID){
	      CbDocReInitCNmID();
	      pC=CNmID+nCNmID-1;
	    }
	    if(iCD == 0){
	      i0CNmID[iCD]=nCNmID;
	      fCTp=0;
	      LCTp[nCTp]=0;
	      CNmDmnP=0;
	      CNmDmnA=0;
	      kCTp=-1;
	      fCDcl=2;
	    }
	    else{
	      fCTp=4;
	    }
	    break;
	  case ')':
	    if(fCDcl != 2){
	      printf("Error at %d: wrong declaration before ')'%c\n",iFLn+1,7);
	      break;
	    }
	    if(kCTp < 0){
	      if(fCDcl != 2)
		printf("Warning at %d: implicit int type%c\n",iFLn+1,7);
	      CbDocCheckCTp("int");
	    }
	    *p1='\0';
	    pC=CNmID+nCNmID;
	    strcpy(pC->p,bfID);
	    pC->kTxt=-1;
	    pC->kCMM=iCMMnt;
	    i=kCB[kCBD];
	    if(iCD){
	      pC->kCMM=-1;
	      nCMMnt=iCMMnt;
	      if(CBTkn[i].kCMM == nCMMnt)
		CBTkn[i].kCMM=-1;
	    }
	    pC->kPg=-1;
	    pC->t=(CNmDmnP<<28)|(CNmDmnA<<24)|0x01C000; /* lcf fp ufp */
	    pC->ID=nCNmID;
	    pC->n=kCTp;
	    pC->d=(i<<16)|(iCD<<8)|(CBTkn[i].t&0xFF);
	    pC->L=(nCBTkn<<16)|(p1-bfID);
	    nCNmID++;
	    if(nCNmID >= NCNmID){
	      CbDocReInitCNmID();
	      pC=CNmID+nCNmID-1;
	    }
	    fCTp=0;
	    LCTp[nCTp]=0;
	    CNmDmnP=0;
	    CNmDmnA=0;
	    kCTp=-1;
	    fCDcl=3;
	    break;
	  case '[':
	    if(kCTp < 0){
	      if(LCTp[nCTp] == 0 && iCD){
		fCDcl=0;
		break;
	      }
	      else{
		if(fCDcl != 2)
		  printf("Warning at %d: implicit int type%c\n",iFLn+1,7);
		CbDocCheckCTp("int");
	      }
	    }
	    *p1='\0';
	    pC=CNmID+nCNmID;
	    strcpy(pC->p,bfID);
	    pC->kTxt=-1;
	    pC->kCMM=iCMMnt;
	    i=kCB[kCBD];
	    if(iCD){
	      pC->kCMM=-1;
	      nCMMnt=iCMMnt;
	      if(CBTkn[i].kCMM == nCMMnt)
		CBTkn[i].kCMM=-1;
	    }
	    pC->kPg=-1;
	    pC->d=(i<<16)|(iCD<<8)|(CBTkn[i].t&0xFF);
	    pC->n=kCTp;
	    pC->t=CNmDmnP<<28;
	    pC->L=p1-bfID;
	    if(fCDcl == 2){
	      pC->t |=0x01C000; /* lcf fp ufp */
	      pC->ID=nCNmID;
	      pC->L |=(nCBTkn<<16);
	    }
	    if(fCDcl == 3){
	      pC->L |=(nCBTkn<<16);
	      i=i0CNmID[iCD];
	      while((CNmID[i].t&0x00C000) == 0x00C000){
		if(strcmp(pC->p,CNmID[i].p) == 0){
		  CNmID[i].t=pC->t|0x10C000; /* ext fp ufp */
		  CNmID[i].n=kCTp;
		  CNmID[i].ID=nCNmID;
		}
		i++;
	      }
	      pC->t |=0x018000; /* lcf fp */
	      pC->ID=nCNmID;
	    }
	    nCNmID++;
	    if(nCNmID >= NCNmID){
	      CbDocReInitCNmID();
	      pC=CNmID+nCNmID-1;
	    }
	    fCTp=6;
	    break;
	  case '=':
	    if(kCTp < 0){
	      if(LCTp[nCTp] == 0 && iCD){
		fCDcl=0;
		break;
	      }
	      else{
		if(fCDcl != 2)
		  printf("Warning at %d: implicit int type%c\n",iFLn+1,7);
		CbDocCheckCTp("int");
	      }
	    }
	    *p1='\0';
	    pC=CNmID+nCNmID;
	    strcpy(pC->p,bfID);
	    pC->kTxt=-1;
	    pC->kCMM=iCMMnt;
	    i=kCB[kCBD];
	    if(iCD){
	      pC->kCMM=-1;
	      nCMMnt=iCMMnt;
	      if(CBTkn[i].kCMM == nCMMnt)
		CBTkn[i].kCMM=-1;
	    }
	    pC->kPg=-1;
	    pC->t=CNmDmnP<<28;
	    pC->n=kCTp;
	    pC->d=(i<<16)|(iCD<<8)|(CBTkn[i].t&0xFF);
	    pC->L=p1-bfID;
	    nCNmID++;
	    if(nCNmID >= NCNmID){
	      CbDocReInitCNmID();
	      pC=CNmID+nCNmID-1;
	    }
	    fCTp=7;
	    iCDi=0;
	    break;
	  case ',':
	    if(kCTp < 0){
	      if(LCTp[nCTp] == 0 && iCD){
		fCDcl=0;
		printf("Warning at %d: suspicous operator%c\n",iFLn+1,7);
		break;
	      }
	      else{
		if(fCDcl != 2)
		  printf("Warning at %d: implicit int type%c\n",iFLn+1,7);
		CbDocCheckCTp("int");
	      }
	    }
	    *p1='\0';
	    pC=CNmID+nCNmID;
	    strcpy(pC->p,bfID);
	    pC->kTxt=-1;
	    pC->kCMM=iCMMnt;
	    i=kCB[kCBD];
	    if(iCD){
	      pC->kCMM=-1;
	      nCMMnt=iCMMnt;
	      if(CBTkn[i].kCMM == nCMMnt)
		CBTkn[i].kCMM=-1;
	    }
	    pC->kPg=-1;
	    pC->d=(i<<16)|(iCD<<8)|(CBTkn[i].t&0xFF);
	    pC->n=kCTp;
	    pC->t=CNmDmnP<<28;
	    pC->L=p1-bfID;
	    if(fCDcl == 2){
	      pC->t |=0x01C000; /* lcf fp ufp */
	      pC->ID=nCNmID;
	      pC->L |=(nCBTkn<<16);
	    }
	    if(fCDcl == 3){
	      pC->L |=(nCBTkn<<16);
	      i=i0CNmID[iCD];
	      while((CNmID[i].t&0x00C000) == 0x00C000){
		if(strcmp(pC->p,CNmID[i].p) == 0){
		  CNmID[i].t=pC->t|0x10C000; /* ext fp ufp */
		  CNmID[i].n=kCTp;
		  CNmID[i].ID=nCNmID;
		}
		i++;
	      }
	      pC->t |=0x018000; /* lcf fp */
	      pC->ID=nCNmID;
	    }
	    nCNmID++;
	    if(nCNmID >= NCNmID){
	      CbDocReInitCNmID();
	      pC=CNmID+nCNmID-1;
	    }
	    fCTp=0;
	    CNmDmnP=0;
	    CNmDmnA=0;
	    break;
	  case ';':
	    if(kCTp < 0){
	      if(LCTp[nCTp] == 0 && iCD){
		fCDcl=0;
		printf("Warning at %d: suspicous operator%c\n",iFLn+1,7);
		break;
	      }
	      else{
		if(fCDcl != 2)
		  printf("Warning at %d: implicit int type%c\n",iFLn+1,7);
		CbDocCheckCTp("int");
	      }
	    }
	    *p1='\0';
	    pC=CNmID+nCNmID;
	    strcpy(pC->p,bfID);
	    pC->kTxt=-1;
	    pC->kCMM=iCMMnt;
	    i=kCB[kCBD];
	    if(iCD){
	      pC->kCMM=-1;
	      nCMMnt=iCMMnt;
	      if(CBTkn[i].kCMM == nCMMnt)
		CBTkn[i].kCMM=-1;
	    }
	    pC->kPg=-1;
	    pC->d=(i<<16)|(iCD<<8)|(CBTkn[i].t&0xFF);
	    pC->n=kCTp;
	    pC->t=CNmDmnP<<28;
	    pC->L=p1-bfID;
	    if(fCDcl == 2){
	      pC->t |=0x01C000; /* lcf fp ufp */
	      pC->ID=nCNmID;
	      pC->L |=(nCBTkn<<16);
	    }
	    if(fCDcl == 3){
	      pC->L |=(nCBTkn<<16);
	      i=i0CNmID[iCD];
	      while((CNmID[i].t&0x00C000) == 0x00C000){
		if(strcmp(pC->p,CNmID[i].p) == 0){
		  CNmID[i].t=pC->t|0x10C000; /* ext fp ufp */
		  CNmID[i].n=kCTp;
		  CNmID[i].ID=nCNmID;
		}
		i++;
	      }
	      pC->t |=0x018000; /* lcf fp */
	      pC->ID=nCNmID;
	    }
	    nCNmID++;
	    if(nCNmID >= NCNmID){
	      CbDocReInitCNmID();
	      pC=CNmID+nCNmID-1;
	    }
	    fCTp=0;
	    break;
	  default :
	    if(iCD && kCTp < 0 && LCTp[nCTp] == 0){
	      fCTp=0;
	      fCDcl=0;
	    }
	    else{
	      printf("Error at %d: wrong declaration%c\n",iFLn+1,7);
	    }
	    break;
	  }
	}
	break;
      case 4:
	if(*p == ')') fCTp=5;
	break;
      case 5:
	if(*p == ','){
	  fCTp=0;
	}
	else{
	  if(*p != ';'){
	    printf("Error at %d: wrong declaration%c\n",iFLn+1,7);
	  }
	}
	break;
      case 6:
	switch(*p){
	case '[':
	  if(iCDr != 0){
	    printf("Error at %d: wrong declaration before '['%c\n",iFLn+1,7);
	  }
	  break;
	case ']':
	  CNmDmnA++;
	  break;
	case ',':
	case ';':
	  pC->t |=(CNmDmnA<<24);
	  fCTp=0;
	  CNmDmnP=0;
	  CNmDmnA=0;
	  break;
	case '=':
	  pC->t |=(CNmDmnA<<24);
	  fCTp=7;
	  CNmDmnP=0;
	  CNmDmnA=0;
	  iCDi=0;
	  break;
	default :
	  if(iCDr == 0){
	    printf("Error at %d: wrong declaration%c\n",iFLn+1,7);
	  }
	  break;
	}
	break;
      case 7:
	if(*p == '{') iCDi++;
	if(*p == '}') iCDi--;
	if((*p == ';' || *p == ',') && iCDi == 0){
	  CNmDmnP=0;
	  CNmDmnA=0;
	  fCTp=0;
	}
	break;
      case 8: /* Type definition */
	if(*p == '{') iCDi++;
	if(*p == '}') iCDi--;
	if(*p == ';' && iCDi == 0){
	  fCTp=0;
	}
	break;
      default :
	printf("Error at %d: wrong declaration%c\n",iFLn+1,7);
	break;
      }
      if(*p == ';' && fCTp != 8 && fCTp != 7){
	fCTp=0;
	LCTp[nCTp]=0;
	CNmDmnP=0;
	CNmDmnA=0;
	kCTp=-1;
      }
    }
    if(fCDcl == 0){ /* Expressions */
      switch(fCTp){
      case 0:
	if(IsAlpha(*p)){
	  L=CbDocGetCWord(bfID,p);
	  if(p > Cln){
	    p1=p-1;
	    if(*p1 == '.' || isdigit(*p1)
	       || (*p1 == '>' && p1 > Cln && *(p1-1) == '-')){
	      p+=L-1;
	      break;
	    }
	  }
	  p+=L;
	  if(CBDocIsCResWSt(bfID) >= 0){
	    p--;
	    break;
	  }
	  if(*p == '\0'){
	    fCTp=1;
	  }
	  else{
	    L= *p == '(' ? 1 : 0;
	    CbDocAddCNmUS(bfID,L);
	  }
	  p--;
	}
	break;
      case 1:
	fCTp=0;
	L= *p == '(' ? 1 : 0;
	CbDocAddCNmUS(bfID,L);
	break;
      default :
	printf("Error at %d: wrong declaration%c\n",iFLn+1,7);
	break;
      }
    }
    if(*p == '{'){
      if(iCD && iCD < 0x40){
	fFLn[iFLn] |=0xC000|(iCD<<8)|iCBD;
      }
      iCD++;
      if(iCD == NCD){
	CbDocReInitCD();
      }
      if(fCTp != 8 && fCTp != 7){
	i0CNmID[iCD]=nCNmID;
	fCTp=0;
	LCTp[nCTp]=0;
	CNmDmnP=0;
	CNmDmnA=0;
	kCTp=-1;
	fCDcl=1;
      }
    }
    if(*p == '('){
      iCDc++;
    }
    if(*p == '['){
      iCDr++;
    }
    if(*p == '}'){
      iCD--;
      if(fCTp != 8 && fCTp != 7){
	nCNmID=i0CNmID[iCD+1];
	if(iCD == 0){
	  fCTp=0;
	  LCTp[nCTp]=0;
	  CNmDmnP=0;
	  CNmDmnA=0;
	  kCTp=-1;
	  fCDcl=1;
	  CbDocSetCNmUS();
	  i=kCB[kCBD];
	  if(nCBTkn == i+1)
	    CBTkn[i].t=0x0102;
	  CBTkn[i].k1=iFLn;
	  CBTkn[i].i1 =nCNmID;
	  CBTkn[i].j1 =nCNmUS;
	  kCBD--;
	  iCBD--;
	  if((CBTkn[i].t&0xFF) == 0){
	    if((fCB[iCBD]&0x7F) != 1){
	      printf("Cb Error at %d: %s%s should be inside mzl_%c\n"
		     ,iFLn+1,CbCResW[0].p,CNmID[iCNmID].p,7);
	    }
	    if(iCBD%2 == 0){
	      printf("Cb Error at %d: %s%s has wrong nestness %d%c\n"
		     ,iFLn+1,CbCResW[0].p,CNmID[iCNmID].p,iCBD+1,7);
	    }
	  }
	  if(iCBD < 0 || kCBD < 0){
	    printf("Error: more Cb #endif's than #ifndef's%c\n",7);
	    iCBD=0;
	    kCBD=0;
	  }
#ifdef H
	  iCMMnt=CNmID[iCNmID].kTxt;
	  while(iCMMnt < nDTxt){
	    DTxt[iCMMnt].kID=iCNmID;
	    iCMMnt++;
	  }
#endif

	  iCMMnt=CNmID[iCNmID].kCMM;
	  while(iCMMnt < nCMMnt){
	    CMMnt[iCMMnt].kID=iCNmID;
	    iCMMnt++;
	  }
	}
	if(iCD < 0x40){
	  fFLn[iFLn] |=0x4000|(iCD<<8)|iCBD;
	}
      }
      if(iCDc < 0){
	printf("**********Error at %d: extra )%c\n",kLnFL,7);
      }
      if(iCDc > 0){
	printf("**********Error at %d: extra (%c\n",kLnFL,7);
      }
      if(iCDr < 0){
	printf("**********Error at %d: extra ]%c\n",kLnFL,7);
      }
      if(iCDr > 0){
	printf("**********Error at %d: extra [%c\n",kLnFL,7);
      }
      if(iCD < 0){
	printf("**********Error at %d: extra }%c\n",kLnFL,7);
      }
    }
    
    if(*p == ')'){
      iCDc--;
      if(iCDc < 0){
	printf("**********Error at %d: extra )%c\n",kLnFL,7);
      }
    }
    if(*p == ']'){
      iCDr--;
      if(iCDr < 0){
	printf("**********Error at %d: extra ]%c\n",kLnFL,7);
      }
    }
    p++;
  }
  while(iCMMnt < nCMMnt){
    CMMnt[iCMMnt].kID=nCNmID;
    iCMMnt++;
  }
  return(0);
}
#endif

#ifndef mzl_PRP
int CbDocReInitPRNmDf()
{
  if(NPRNmDf){
    NPRNmDf+=32;
    PRNmDf=(char**)realloc((void*)PRNmDf,(size_t)NPRNmDf*sizeof(char*));
    vPRNmDf=(char**)realloc((void*)PRNmDf,(size_t)NPRNmDf*sizeof(char*));
    LPRNmDf=(int*)realloc((void*)LPRNmDf,(size_t)NPRNmDf*sizeof(int));
  }
  else{
    NPRNmDf=32;
    nPRNmDf=0;
    PRNmDf=(char**)malloc((size_t)NPRNmDf*sizeof(char*));
    vPRNmDf=(char**)malloc((size_t)NPRNmDf*sizeof(char*));
    LPRNmDf=(int*)malloc((size_t)NPRNmDf*sizeof(int));
  }
  if(PRNmDf == NULL || LPRNmDf == NULL){
    printf("No memory for %d PRNmDf's and LPRNmDf's%c\n",NPRNmDf,7);
    exit(0);
  }
  return(0);
}

int CbDocReInitPRNmUn()
{
  if(NPRNmUn){
    NPRNmUn+=32;
    PRNmUn=(char**)realloc((void*)PRNmUn,(size_t)NPRNmUn*sizeof(char*));
    LPRNmUn=(int*)realloc((void*)LPRNmUn,(size_t)NPRNmUn*sizeof(int));
  }
  else{
    NPRNmUn=32;
    nPRNmUn=0;
    PRNmUn=(char**)malloc((size_t)NPRNmUn*sizeof(char*));
    LPRNmUn=(int*)malloc((size_t)NPRNmUn*sizeof(int));
  }
  if(PRNmUn == NULL || LPRNmUn == NULL){
    printf("No memory for %d PRNmUn's and LPRNmUn's%c\n",NPRNmUn,7);
    exit(0);
  }
  return(0);
}

int CbDocDeInitPRNmDfUn()
{
  if(NPRNmUn){
    int i;
    for(i=0; i < nPRNmUn; i++){
      free(PRNmUn[i]);
    }
    free(PRNmUn);
    free(LPRNmUn);
  }
  if(NPRNmDf){
    int i;
    for(i=0; i < nPRNmDf; i++){
      if(vPRNmDf[i] != NULL)
	free(vPRNmDf[i]);
      free(PRNmDf[i]);
    }
    free(PRNmDf);
    free(LPRNmDf);
  }
  NPRNmUn=0;
  NPRNmDf=0;
  return(0);
}

int CbDocReInitPRD()
{
  if(NPRD){
    NPRD+=8;
    fPR=(int*)realloc((void*)fPR,(size_t)NPRD*sizeof(int));
  }
  else{
    NPRD=8;
    fPR=(int*)malloc((size_t)NPRD*sizeof(int));
  }
  if(fPR == NULL){
    printf("Error at %d: No memory for %d fPR's%c\n",kLnFL,NPRD,7);
    exit(0);
  }
  return(0);
}

int CbDocDeInitPRD()
{
  if(NPRD)
    free(fPR);
  NPRD=0;
  return(0);
}

int CbDocPRNmVal(char *p)
{
  long int k,k1,k2,k3,ic;
  char *p1;

  while(isspace(*p)) p++;
  if(*p == '('){
    p++;
    while(isspace(*p)) p++;
  }
  if(sscanf(p,"%ld",&k) < 1){
    return(0x100);
  }
  else{
    return(k ? 0x000 : 0x100);
  }
}

int CbDocSetPRFlag(char *p,int iPRW)
{
  int i;
  char *p1;

  switch(iPRW){
  case 0: /* #ifndef */
    for(i=0; i < nPRNmDf; i++){
      if(strcmp(Cword,PRNmDf[i]) == 0) break;
    }
    fPR[iPRD] |=i < nPRNmDf ? 0x100 : 0x000;
    break;
  case 1: /* #ifdef */
    for(i=0; i < nPRNmDf; i++){
      if(strcmp(Cword,PRNmDf[i]) == 0) break;
    }
    fPR[iPRD] |=i < nPRNmDf ? 0x000 : 0x100;
    break;
  case 2: /* #if */
    fPR[iPRD] |=CbDocPRNmVal(p);
    break;
  case 3: /* #else */
    break;
  case 4: /* #elif */
    fPR[iPRD] |=CbDocPRNmVal(p);
    break;
  case 5: /* #endif */
    break;
  case 6: /* #undef */
    for(i=0; i < nPRNmDf; i++){
      if(strcmp(Cword,PRNmDf[i]) == 0) break;
    }
    if(i < nPRNmDf){
      free(PRNmDf[i]);
      nPRNmDf--;
      while(i < nPRNmDf){
	PRNmDf[i] =PRNmDf[i+1];
	vPRNmDf[i]=vPRNmDf[i+1];
	LPRNmDf[i]=LPRNmDf[i+1];
	i++;
      }
    }
    for(i=0; i < nPRNmUn; i++){
      if(strcmp(Cword,PRNmUn[i]) == 0) break;
    }
    if(i == nPRNmUn){
      nPRNmUn++;
      if(nPRNmUn >= NPRNmUn) CbDocReInitPRNmUn();
      LPRNmUn[i]=strlen(Cword);
      PRNmUn[i]=(char *)malloc((size_t)(LPRNmUn[i]+1)*sizeof(char));
      strcpy(PRNmUn[i],Cword);
    }
    break;
  case 7: /* #define */
    for(i=0; i < nPRNmDf; i++){
      if(strcmp(Cword,PRNmDf[i]) == 0)break;
    }
    if(i == nPRNmDf){
      nPRNmDf++;
      if(nPRNmDf >= NPRNmDf) CbDocReInitPRNmDf();
      LPRNmDf[i]=strlen(Cword);
      PRNmDf[i]=(char *)malloc((size_t)(LPRNmDf[i]+1)*sizeof(char));
      strcpy(PRNmDf[i],Cword);
      p	+=LPRNmDf[i];
      while(isspace(*p)) p++;
      p1=p;
      while(*p1 != '\n' && *p1 != '\0')	p1++;
      vPRNmDf[i]=(char *)malloc((size_t)(p1-p+1)*sizeof(char));
      p1=vPRNmDf[i];
      while(*p != '\n' && *p != '\0') *p1++=*p++;
      *p1='\0';
    }
    for(i=0; i < nPRNmUn; i++){
      if(strcmp(Cword,PRNmUn[i]) == 0) break;
    }
    if(i < nPRNmUn){
      free(PRNmUn[i]);
      nPRNmUn--;
      while(i < nPRNmUn){
	PRNmUn[i] =PRNmUn[i+1];
	LPRNmUn[i]=LPRNmUn[i+1];
	i++;
      }
    }
    break;
  case 8: /* #include */
    break;
  case 9: /* #line */
    break;
  case 10: /* #pragma */
    break;
  case 11: /* #error */
    break;
  }
  return(0);
}

int CbDocCPRPLine()
{
  char *p;
  int L,m;
  m=iCD ? 0x80000000 : 0x40000000;

  p=Cln;
  CbDocGetPRPWord(Cword,p);
  for(iCprResW=0; iCprResW < NCprResW; iCprResW++){
    if(strcmp(Cword,CprResW[iCprResW].p) == 0){
      break;
    }
  }
  fFLn[iFLn] |=0x40000000|(iCprResW << 25);
  if(iCprResW == NCprResW){
    printf("Error at %d: wrong C preprocessor instruction%c\n",iFLn+1,7);
    return(NCprResW);
  }

  L=CprResW[iCprResW].L;
  p+=L;

  switch(iCprResW){
  case  0: /* #ifndef */
    iPRD++;
    if(iPRD == NPRD){
      CbDocReInitPRD();
    }
    if((fPR[iPRD-1]&0x300)){
      fPR[iPRD]=0x200;
      break;
    }
    else{
      fPR[iPRD]=0x000;
    }
    if(*p != ' '){
      printf("Error at %d: wrong C preprocessor instruction%c\n",iFLn+1,7);
      return(NCprResW);
    }
    p++;
    if(CbDocGetCWord(Cword,p) == 0){
      break;
    }
    CbDocSetPRFlag(NULL,0);
    L=CbDocGetCbCResWord();
    if(L >= 0){
      fPR[iPRD] |=0x80|L;
      if(L < 3){
	switch(L){
	case 0:
	case 2:
	  if((fCB[iCBD]&0x7F) != 1){
	    printf("Cb Error at %d: %s%s should be inside mzl_%c\n"
		   ,iFLn+1,CbCResW[L].p,CBTkn[nCBTkn].Nm,7);
	  }
	  if(iCBD%2 == 0){
	    printf("Cb Error at %d: %s%s has wrong nestness %d%c\n"
		   ,iFLn+1,CbCResW[L].p,CBTkn[nCBTkn].Nm,iCBD+1,7);
	  }
	  break;
	case 1:
	  if((fCB[iCBD]&0x7F) != 0){
	    printf("Cb Error at %d: mzl_%s should be inside blb_%c\n"
		   ,iFLn+1,CBTkn[nCBTkn].Nm,7);
	  }
	  break;
	}
      }
      iCBD++;
      if(iCBD == NCBD){
	CbDocReInitCBD();
      }
      fCB[iCBD] =m|0xC00000|(iCBD < 0x40FF ? (iCBD<<8) : 0x3FFF00)|L;
      fFLn[iFLn] |=(iCBD < 0x40 ? iCBD << 8 : 0x3F00)|0xC080|L;
      if(L < 3){
	kCBD++;
	kCB[kCBD]=nCBTkn;
	fFLn[iFLn] |=((nCBTkn&0x01FF)<<16);
	CBTkn[nCBTkn].f=kCBF;
	CBTkn[nCBTkn].L |=fCB[iCBD];
	CBTkn[nCBTkn].d =(kCB[kCBD-1]<<16)|kCBD;
	CBTkn[nCBTkn].k0 =iFLn;
	CBTkn[nCBTkn].kTxt =-1;
	CBTkn[nCBTkn].kCMM =-1;
	CBTkn[nCBTkn].kPg =-1;
	CBTkn[nCBTkn].i0 =iCD ? iCNmID+1 : nCNmID;
	CBTkn[nCBTkn].j0 =nCNmUS;
	nCBTkn++;
	if(nCBTkn == NCBTkn){
	  CbDocReInitCBTkn();
	}
      }
    }
    break;
  case  1: /* #ifdef */
    iPRD++;
    if(iPRD == NPRD){
      CbDocReInitPRD();
    }
    if((fPR[iPRD-1]&0x300)){
      fPR[iPRD]=0x200;
      break;
    }
    else{
      fPR[iPRD]=0x000;
    }
    if(*p != ' '){
      printf("Error at %d: wrong C preprocessor instruction%c\n",iFLn+1,7);
      return(NCprResW);
    }
    p++;
    if(CbDocGetCWord(Cword,p) == 0){
      break;
    }
    CbDocSetPRFlag(NULL,1);
    
    L=CbDocGetCbCResWord();
    if(L >= 0){
      fPR[iPRD] |=0x80|L;
      if(L < 3){
	printf("Cb Error at %d: %s%s cannot follow #ifdef%c\n"
	       ,iFLn+1,CbCResW[L].p,CBTkn[nCBTkn].Nm,7);
	break;
      }
      iCBD++;
      if(iCBD == NCBD){
	CbDocReInitCBD();
      }
      fCB[iCBD] =m|0xC00000|(iCBD < 0x40FF ? (iCBD<<8) : 0x3FFF00)|L;
      fFLn[iFLn] |=(iCBD < 0x40 ? iCBD << 8 : 0x3F00)|0xC080|L;
    }
    break;
  case  2: /* #if */
    iPRD++;
    if(iPRD == NPRD){
      CbDocReInitPRD();
    }
    if((fPR[iPRD-1]&0x300)){
      fPR[iPRD]=0x200;
    }
    CbDocSetPRFlag(p,2);
    break;
  case  3: /* #else */
    fPR[iPRD] ^=0x100;
    break;
  case  4: /* #elif */
    if((fPR[iPRD]&0x200)){
      fPR[iPRD] |=0x100;
      break;
    }
    else{
      fPR[iPRD] ^=0x100;
      if((fPR[iPRD]&0x100)){
	fPR[iPRD] |=0x200;
	break;
      }
    }
    CbDocSetPRFlag(p,4);
    break;
  case  5: /* #endif */
    if((fPR[iPRD]&0x80)){
      L=fCB[iCBD]&0x7F;
      if(L < 3){
	int kk;
	if(iCD){
	  CbDocSetCNmUS();
	}
	kk=kCB[kCBD];
	kCBD--;
	CBTkn[kk].k1=iFLn;
	CBTkn[kk].i1 =iCD ? iCNmID+1 : nCNmID;
	CBTkn[kk].j1 =nCNmUS;
	kk &=0x01FF;
	fFLn[iFLn] |=(kk<<16)|(iCBD < 0x40 ? iCBD << 8 : 0x3F00)|0x4080|L;
      }
      else{
	fFLn[iFLn] |=(iCBD < 0x40 ? iCBD << 8 : 0x3F00)|0x4080|L;
      }
      iCBD--;
      if(iCBD < 0 || kCBD < 0){
	printf("Error: more Cb #endif's than #ifndef's%c\n",7);
	iCBD=0;
	kCBD=0;
      }
    }
    fPR[iPRD]=0x000;
    iPRD--;
    if(iPRD < 0){
      printf("Error: more #endif's than #if's\n");
      iPRD=0;
    }
    break;
  case 6: /* #undef */
    if((fPR[iPRD]&0x300))
      break;
    if(*p != ' '){
      printf("Error at %d: wrong C preprocessor instruction%c\n",iFLn+1,7);
      return(NCprResW);
    }
    p++;
    if(CbDocGetCWord(Cword,p) == 0){
      break;
    }
    CbDocSetPRFlag(NULL,6);
    L=CbDocGetCbCResWord();
    if(L >= 0){
      fFLn[iFLn] |=(iCBD < 0x40 ? iCBD << 8 : 0x3F00)|0x0080|L;
    }
    break;
  case  7: /* #define */
    if((fPR[iPRD]&0x300)) break;
    if(*p != ' '){
      printf("Error at %d: wrong C preprocessor instruction%c\n",iFLn+1,7);
      return(NCprResW);
    }
    p++;
    if(CbDocGetCWord(Cword,p) == 0) break;
    CbDocSetPRFlag(p,7);
    break;
  case  8: /* #include */
    break;
  case  9: /* #line */
    break;
  case 10: /* #pragma */
    break;
  case 11: /* #error */
    break;
  default:
    break;
  }
  return(iCprResW);
}
#endif

#ifndef mzl_DOC
int CbDocReInitDTxt()
{
  if(NDTxt){
    NDTxt+=32;
    DTxt=(DOCTXT*)realloc((void*)DTxt,(size_t)NDTxt*sizeof(DOCTXT));
  }
  else{
    NDTxt=32;
    DTxt=(DOCTXT*)malloc((size_t)NDTxt*sizeof(DOCTXT));
  }
  if(DTxt == NULL){
    printf("Error at %d: No memory for %d DTxt's%c\n",kLnFL,NDTxt,7);
    exit(0);
  }
  return(0);
}

int CbDocDeInitDTxt()
{
  if(NDTxt){
    free(DTxt);
  }
  NDTxt=0;
  return(0);
}

int CbDocReInitCMMnt()
{
  if(NCMMnt){
    NCMMnt+=32;
    CMMnt=(CMMNT*)realloc((void*)CMMnt,(size_t)NCMMnt*sizeof(CMMNT));
  }
  else{
    NCMMnt=32;
    CMMnt=(CMMNT*)malloc((size_t)NCMMnt*sizeof(CMMNT));
  }
  if(CMMnt == NULL){
    printf("Error at %d: No memory for %d CMMnt's%c\n",kLnFL,NCMMnt,7);
    exit(0);
  }
  return(0);
}

int CbDocDeInitCMMnt()
{
  if(NCMMnt){
    free(CMMnt);
  }
  NCMMnt=0;
  return(0);
}

int CbDocReInitSTRng()
{
  if(NSTRng){
    NSTRng+=32;
    STRng=(STRNG*)realloc((void*)STRng,(size_t)NSTRng*sizeof(STRNG));
  }
  else{
    NSTRng=32;
    STRng=(STRNG*)malloc((size_t)NSTRng*sizeof(STRNG));
  }
  if(STRng == NULL){
    printf("Error at %d: No memory for %d STRng's%c\n",kLnFL,NSTRng,7);
    exit(0);
  }
  return(0);
}

int CbDocDeInitSTRng()
{
  if(NSTRng){
    free(STRng);
    NSTRng=0;
  }
  return(0);
}

int CbDocGetCln(char *S)
{
  int i,j,k;
  char *p,*s,*t;

  s=S;
  p=Cln;
  while(*s != '\0'){
    while(*s == '\\' && *(s+1) == '\n'){
      kLnFL++;
      s+=2;
    }
    switch(*s){
    case '\0':
      *p='\0';
      return((int)(s-S));
    case '\n':
      if(p > Cln && *(p-1) == ' '){
	p--;
      }
      *p='\0';
      kLnFL++;
      return((int)(s-S+1));
    case ' ':
    case '\t':
    case '\v':
      if(p > Cln && IsAlNum(*(p-1))){
	*p++=' ';
      }
      s++;
      break;
    case '/':
      if(nCMMnt >= NCMMnt) CbDocReInitCMMnt();
      CMMnt[nCMMnt].k0=kLnFL;
      t	=s;
      if(p > Cln && *(p-1) == ' ') p--;
      *p++	=*s++;
      while(*s == '\\' && *(s+1) == '\n'){
	kLnFL++;
	s+=2;
      }
      if(*s == '*'){ /*Inside Comment */
	i	=kCB[kCBD];
	CMMnt[nCMMnt].kID=nCNmID;
	CMMnt[nCMMnt].kCB=i;
	CMMnt[nCMMnt].b=t;
	if(CBTkn[i].kCMM < 0) CBTkn[i].kCMM=nCMMnt;
	CMMnt[nCMMnt].k1=nFLn;
	CMMnt[nCMMnt].e=FBff+nFBff;
	t=s;
	s++;
	while(*s != '/' || *t != '*'){
	  t=s;
	  s++;
	  while(*s == '\\' && *(s+1) == '\n'){
	    kLnFL++;
	    s+=2;
	  }
	  if(*s == '\0'){
	    *(p-1)='\0';
	    printf("Error at %d: zero char inside comment%c\n"
		   ,CMMnt[nCMMnt].k0,7);
	    return((int)(s-S));
	  }
	  if(*s == '\n') kLnFL++;
	}
	s++;
	CMMnt[nCMMnt].t=2;
	CMMnt[nCMMnt].k1=kLnFL;
	CMMnt[nCMMnt].e=s;
	nCMMnt++;
	p--;
	if(p > Cln && IsAlNum(*(p-1))) *p++=' ';
      }
      break;
    case '\'':
      if(p > Cln && *(p-1) == ' ') p--;
      k=kLnFL;
      *p++=*s++;
      while(*s == '\\' && *(s+1) == '\n'){
	kLnFL++;
	s+=2;
      }
      if(*s == '\0'){
	*p='\0';
	printf("Error at %d: zero char inside character constant%c\n",k,7);
	return((int)(s-S));
      }
      if(*s == '\n'){
	kLnFL++;
      }
      i=0;
      j=0;
      while(i == 0){
	if(*s == '\\' && j == 0){
	  j=1;
	}
	else{
	  j=0;
	}
	if(j == 0)
	  i++;
	s++;
	while(*s == '\\' && *(s+1) == '\n'){
	  kLnFL++;
	  s+=2;
	}
	if(*s == '\0'){
	  *p='\0';
	  printf("Error at %d: zero char inside character constant%c\n",k,7);
	  return((int)(s-S));
	}
	if(*s == '\n'){
	  kLnFL++;
	}
      }
      if(i == 1 && *s !='\''){
	printf("Error at %d: Wrong character constant%c\n",k,7);
	break;
      }
      *p++='+'; /* Fake substitution */
      *p++='\'';
      s++;
      break;
    case '"':
      if(p > Cln && *(p-1) == ' ') p--;
      if(nSTRng >= NSTRng) CbDocReInitSTRng();
      STRng[nSTRng].k0=kLnFL;
      STRng[nSTRng].b=s;
      STRng[nSTRng].k1=nFLn;
      STRng[nSTRng].e=FBff+nFBff;
  
      *p++	=*s;
      t	=s;
      s++;
      while(*s != '"'){
	t=s;
	s++;
	while(*s == '\\' && *(s+1) == '\n'){
	  s+=2;
	  kLnFL++;
	}
	if(*s == '\n') kLnFL++;
	if(*t == '\\' && (*s == '"' || *s == '\\')) s++;
	if(*s == '\0'){
	  *p	='\0';
	  printf("Error at %d: zero char inside string constant%c\n"
		 ,STRng[nSTRng].k0,7);
	  exit(0);
	  return((int)(s-S));
	}
      }
      STRng[nSTRng].k1=kLnFL;
      STRng[nSTRng].e=s;
      nSTRng++;
      *p++	=*s++;
      break;
    default :
      if(p > Cln && *(p-1) == ' ' && IsAlNum(*s) == 0){
	*(p-1)=*s;
      }
      else{
	*p++=*s;
      }
      s++;
      break;
    }
    i=p-Cln;
    if(i+3 >= LCln){
      CbDocReInitCln();
      p=Cln+i;
    }
  }
  *p='\0';
  return((int)(s-S));
}

int CbDocGetPRPln(char *S)
{
  int i;
  char *p,*s,*t;
  
  s=S;
  s++;
  p=Cln;
  while(*s != '\0'){
    while(*s == '\\' && *(s+1) == '\n'){
      kLnFL++;
      s+=2;
    }
    switch(*s){
    case '\0':
      *p='\0';
      return((int)(s-S));
    case '\n':
      if(p > Cln && *(p-1) == ' '){
	p--;
      }
      *p='\0';
      kLnFL++;
      return((int)(s-S+1));
    case ' ':
    case '\t':
    case '\v':
      if(p > Cln && IsAlNum(*(p-1))){
	*p++=' ';
      }
      s++;
      break;
    case '/':
      t=s;
      if(p > Cln && *(p-1) == ' ') p--;
      *p++=*s++;
      while(*s == '\\' && *(s+1) == '\n'){
	kLnFL++;
	s+=2;
      }
      if(*s == '*'){ /*Inside Comment */
	s++;
	while(*s == '\\' && *(s+1) == '\n'){
	  kLnFL++;
	  s+=2;
	}
	if(*s == '\n') kLnFL++;
	t=s;
	while(*s != '/' || *t != '*'){
	  t=s;
	  s++;
	  while(*s == '\\' && *(s+1) == '\n'){
	    kLnFL++;
	    s+=2;
	  }
	  if(*s == '\n') kLnFL++;
	}
	p--;
	if(p > Cln && IsAlNum(*(p-1))) *p++=' ';
	s++;
      }
      break;
    default :
      if(p > Cln && *(p-1) == ' ' && IsAlNum(*s) == 0){
	*(p-1)=*s;
      }
      else{
	*p++=*s;
      }
      s++;
      break;
    }
    i=p-Cln;
    if(i+3 >= LCln){
      CbDocReInitCln();
      p=Cln+i;
    }
  }
  *p='\0';
  return((int)(s-S));
}

int CbDocGetCStruct()
{
  int i,n,k,L;
  char *p,*p1,*p2;

  nPRNmDf=0;
  if(nPRNmDf >= NPRNmDf)
    CbDocReInitPRNmDf();
  nPRNmUn=0;
  if(nPRNmUn >= NPRNmUn)
    CbDocReInitPRNmUn();
  iPRD=0;
  fPR[iPRD]=0;

  nDTxt=0;
  nCMMnt=0;
  nHLWrd=0;
  nSTRng=0;

  iCD=0;
  nCD=0;
  iCDc=0;
  iCDr=0;

  iCBD=0;
  kCBD=0;
  fCB[iCBD]=0x40C00000;
  p=NmF;
  p1=p;
  while(*p != '\0'){
#ifdef H
    if(*p == '.')
      break;
#endif
    p++;
  }
  CBTkn[nCBTkn].L=p-p1;
  CBTkn[nCBTkn].Nm=(char *)malloc((size_t)(CBTkn[nCBTkn].L+1)*sizeof(char));
  p=CBTkn[nCBTkn].Nm;
#ifdef H
  while(*p1 != '\0' && *p1 != '.'){
    *p++=*p1++;
  }
#endif
  while(*p1 != '\0'){
    *p++=*p1++;
  }
  *p='\0';
  if(CBTkn[nCBTkn].L > 31){
    CBTkn[nCBTkn].L=31;
    *(CBTkn[nCBTkn].Nm+CBTkn[nCBTkn].L)='\0';
  }
  kCB[kCBD]=nCBTkn;
  CBTkn[nCBTkn].f=kCBF;
  CBTkn[nCBTkn].d=0;
  CBTkn[nCBTkn].t=0;
  CBTkn[nCBTkn].k0=0;
  CBTkn[nCBTkn].kTxt =-1;
  CBTkn[nCBTkn].kCMM =-1;
  CBTkn[nCBTkn].kPg =-1;
  CBTkn[nCBTkn].i0=nCNmID;
  CBTkn[nCBTkn].j0=nCNmUS;
  CBTkn[nCBTkn].L<<=24;
  CBTkn[nCBTkn].L |=0x800000;
  nCBTkn++;
  if(nCBTkn == NCBTkn){
    CbDocReInitCBTkn();
  }
  kCTp=-1;
  LCTp[nCTp]=0;
  CNmDmnA=0;
  CNmDmnP=0;
  fCDcl=1;
  fCTp=0;

  kLnFL=1;
  iFLn=0;
  do{
    p=FBff+pFLn[iFLn];
    if(*p == '#'){
      n=CbDocGetPRPln(p);
      CbDocCPRPLine();
      k=fFLn[iFLn];
      iFLn++;
      while(iFLn < kLnFL-1){
	fFLn[iFLn] |=k;
	iFLn++;
      }
      if((fPR[iPRD]&0x300)){
	L=(fPR[iPRD]&0x80) ? (fPR[iPRD]&0x7F) : -1;
	if(L == 8){
	  k=kCB[kCBD];
	  if(iCD){
	    DTxt[nDTxt].kID=-1;
	    DTxt[nDTxt].kCB=k;
	    if(CBTkn[k].kTxt < 0){
	      CBTkn[k].kTxt=nDTxt;
	    }
	  }
	  else{
	    if(nCNmID >	nCNmIDD && nCNmID != CBTkn[k].i0){
	      DTxt[nDTxt].kID=nCNmID;
	      DTxt[nDTxt].kCB=-1;
	      CNmID[nCNmID-1].kTxt=nDTxt;
	    }
	    else{
	      DTxt[nDTxt].kID=-1;
	      DTxt[nDTxt].kCB=k;
	      if(CBTkn[k].kTxt < 0){
		CBTkn[k].kTxt=nDTxt;
	      }
	    }
	  }
	  if(CBTkn[k].kTxt < 0 && nCNmID == CBTkn[k].i0){
	    CBTkn[k].kTxt=nDTxt;
	  }
	  DTxt[nDTxt].k0=iFLn;
	}
	while((fFLn[iFLn]&0x20000000) || *(FBff+pFLn[iFLn]) != '#'){
	  fFLn[iFLn] |=0x80000000;
	  iFLn++;
	  if(iFLn == nFLn)
	    break;
	}
	if(L == 8){
	  DTxt[nDTxt].k1=iFLn;
	  nDTxt++;
	  if(nDTxt >= NDTxt){
	    CbDocReInitDTxt();
	  }
	}
	kLnFL=iFLn+1;
      }
    }
    else{
      iCMMnt=nCMMnt;
      n=CbDocGetCln(p);
      CbDocCTypes();
      iFLn=kLnFL-1;
    }
    if(n == 0)
      break;
  }while(iFLn < nFLn);

  if(iCBD || kCBD){
    printf("Error in Cb structure: %d more #ifndef's than #endif's%c\n"
	   ,iCBD,7);
  }
  k=kCB[kCBD];
  CBTkn[k].L ^=0x20000000;
  CBTkn[k].k1=iFLn;
  CBTkn[k].i1=nCNmID;
  CBTkn[k].j1=nCNmUS;
  CbDocDeInitPRNmDfUn();
  return(0);
}
#endif

#ifndef mzl_CB
int CbDocGetCbStruct()
{
  int i,n,k,L;
  char *p,*p1,*p2;

  nPRNmDf=0;
  if(nPRNmDf >= NPRNmDf)
    CbDocReInitPRNmDf();
  nPRNmUn=0;
  if(nPRNmUn >= NPRNmUn)
    CbDocReInitPRNmUn();
  CbReInitPObj();
  CbReInitClstD();
  CbReInitCbLn();
  CbReInitCmmncO();
  CbReInitCmmncC();
  CbReInitCmmncS();
  iPRD=0;
  fPR[iPRD]=0;
  
  iCD	=0;
  nCD	=0;
  iCDc	=0;
  iCDr	=0;

  iCBD	=0;
  kCBD	=0;
  fCB[iCBD]=0x40C00000;
  p	=NmF;
  p1	=p;
  while(*p != '\0'){
    p++;
  }
  CBTkn[nCBTkn].L=p-p1;
  CBTkn[nCBTkn].Nm=(char *)malloc((size_t)(CBTkn[nCBTkn].L+1)*sizeof(char));
  p=CBTkn[nCBTkn].Nm;
  while(*p1 != '\0'){
    *p++=*p1++;
  }
  *p='\0';
  if(CBTkn[nCBTkn].L > 31){
    CBTkn[nCBTkn].L=31;
    *(CBTkn[nCBTkn].Nm+CBTkn[nCBTkn].L)='\0';
  }
  kCB[kCBD]=nCBTkn;
  CBTkn[nCBTkn].f=kCBF;
  CBTkn[nCBTkn].d=0;
  CBTkn[nCBTkn].t=0;
  CBTkn[nCBTkn].k0=0;
  CBTkn[nCBTkn].kTxt =-1;
  CBTkn[nCBTkn].kCMM =-1;
  CBTkn[nCBTkn].kPg =-1;
  CBTkn[nCBTkn].i0=nCNmID;
  CBTkn[nCBTkn].j0=nCNmUS;
  CBTkn[nCBTkn].L<<=24;
  CBTkn[nCBTkn].L |=0x800000;
  nCBTkn++;
  if(nCBTkn == NCBTkn){
    CbDocReInitCBTkn();
  }
  kCTp	=-1;
  LCTp[nCTp]=0;
  CNmDmnA=0;
  CNmDmnP=0;
  fCDcl	=1;
  fCTp	=0;

  kLnFL	=1;
  iFLn	=0;
  do{
    p	=FBff+pFLn[iFLn];
    switch(CbDocTypeCbLn(p)){
    case 0:
      n		=CbDocCbCmmnTypes(p);
      n		=CbDocGetCbln(p+n);
      CbDocCbCommObj();
      iFLn	=kLnFL-1;
      break;
    case 1:
      n		=CbDocSkipCbln(p);
      break;
    case 2:
      n	=CbDocGetPRPln(p);
      CbDocCPRPLine();
      k	=fFLn[iFLn];
      iFLn++;
      while(iFLn < kLnFL-1){
	fFLn[iFLn] |=k;
	iFLn++;
      }
      if((fPR[iPRD]&0x300)){
	L=(fPR[iPRD]&0x80) ? (fPR[iPRD]&0x7F) : -1;
	if(L == 8){
	  k	=kCB[kCBD];
	  if(iCD){
	    DTxt[nDTxt].kID=-1;
	    DTxt[nDTxt].kCB=k;
	    if(CBTkn[k].kTxt < 0){
	      CBTkn[k].kTxt=nDTxt;
	    }
	  }
	  else{
	    if(nCNmID >	nCNmIDD && nCNmID != CBTkn[k].i0){
	      DTxt[nDTxt].kID=nCNmID;
	      DTxt[nDTxt].kCB=-1;
	      CNmID[nCNmID-1].kTxt=nDTxt;
	    }
	    else{
	      DTxt[nDTxt].kID=-1;
	      DTxt[nDTxt].kCB=k;
	      if(CBTkn[k].kTxt < 0){
		CBTkn[k].kTxt=nDTxt;
	      }
	    }
	  }
	  if(CBTkn[k].kTxt < 0 && nCNmID == CBTkn[k].i0){
	    CBTkn[k].kTxt=nDTxt;
	  }
	  DTxt[nDTxt].k0=iFLn;
	}
	while((fFLn[iFLn]&0x20000000) || *(FBff+pFLn[iFLn]) != '#'){
	  fFLn[iFLn] |=0x80000000;
	  iFLn++;
	  if(iFLn == nFLn)
	    break;
	}
	if(L == 8){
	  DTxt[nDTxt].k1=iFLn;
	  nDTxt++;
	  if(nDTxt >= NDTxt){
	    CbDocReInitDTxt();
	  }
	}
	kLnFL=iFLn+1;
      }
      break;
    case 3:
      n		=CbDocGetCbln(p);
      CbDocCbCommObj();
      iFLn	=kLnFL-1;
      break;
    default :
      break;
    }
    if(n == 0)
      break;
  }while(iFLn < nFLn);

  if(iCBD || kCBD){
    printf("Error in Cb structure: %d more #ifndef's than #endif's%c\n"
	   ,iCBD,7);
  }
  k	=kCB[kCBD];
  CBTkn[k].L ^=0x20000000;
  CBTkn[k].k1=iFLn;
  CBTkn[k].i1=nCNmID;
  CBTkn[k].j1=nCNmUS;
  CbDocDeInitPRNmDfUn();
  return(0);
}
#endif

#ifndef mzl_LST
int CbDocReInitNmSF()
{
  if(NNmSF){
    NNmSF+=8;
    pNmSF=(NMSF*)realloc((void*)pNmSF,(size_t)NNmSF*sizeof(NMSF));
  }
  else{
    NNmSF=8;
    pNmSF=(NMSF*)malloc((size_t)NNmSF*sizeof(NMSF));
  }
  if(pNmSF == NULL){
    printf("Reading %s - file interrupted%c\n",NmSF,7);
    printf("Error at %d: No memory for pNmSF %d 's\n",kLnFL,NNmSF);
    return(-1);
  }
  return(0);
}

int CbDocDeInitNmSF()
{
  if(NNmSF){
    int i;
    for(i=0; i < nNmSF; i++){
      free(pNmSF[i].p);
      free(pNmSF[i].b);
    }
    free(pNmSF);
    NNmSF=0;
  }
  return(0);
}

int CbDocNmSF()
{
  static char *p,*p1,*p2;
  static int i,L;
  
  p=Cln;
  p1=p;
  p2=p;
  while(*p != '\0'){
    if(*p == '.'){
      p2=p+1;
    }
    p++;
    if(*p == ' ' || *p == '\0'){
      *p='\0';
      L=p-p1;
      pNmSF[nNmSF].p=(char *)malloc((size_t)(L+1)*sizeof(char));
      strcpy(pNmSF[nNmSF].p,p1);
      pNmSF[nNmSF].b=NULL;
      pNmSF[nNmSF].L=L;
      pNmSF[nNmSF].Lxtn=p2-p1;;
      for(i=0; i < Nxtn; i++){
	if(strcmp(p2,Nmxtn[i]) == 0){
	  break;
	}
      }
      pNmSF[nNmSF].xtn=i;
      nNmSF++;
      if(nNmSF >= NNmSF)
	CbDocReInitNmSF();
      p1=p+1;
      p2=p1;
    }
  }
  return(0);
}

int CbDocGetLNmSF()
{
  int i,n,k,L;
  char *p,*p1,*p2;

  nNmSF=0;
  if(nNmSF >= NNmSF)
    CbDocReInitNmSF();
  kLnFL=1;
  iFLn=0;
  do{
    p=FBff+pFLn[iFLn];
    if(*p == '#'){
      n=CbDocGetPRPln(p);
      k=fFLn[iFLn];
      iFLn++;
      while(iFLn < kLnFL-1){
	fFLn[iFLn] |=k;
	iFLn++;
      }
    }
    else{
      n=CbDocGetCln(p);
      CbDocNmSF();
      iFLn=kLnFL-1;
    }
    if(n == 0)
      break;
  }while(iFLn < nFLn);
  return(0);
}
#endif

#ifndef mzl_Out
int CbDocCalCCommCID(int n)
{
  int d,iC,i,i1,i0,ii,j,j0,j1,k,L;

  char *s,*t;
  CNMID *pC;
  CBTKN *pT;

  /* CB segments */
  for(i=nCBTknD; i < nCBTkn; i++){
    pT=CBTkn+i;
    j=pT->kCMM;
    if(j >= 0 && (pT->L&0x40000000) && pT->i0 != CMMnt[j].kID){
      pT->kCMM=-1;
    }
    if(pT->kCMM > 0){
      CMMnt[j].kID=-1;
    }
  }

  /* Collecting Texts and Comments for given mzl */
  for(i=nCBTknD; i < nCBTkn; i++){
    pT=CBTkn+i;
    if((pT->t&0xFF) != 1)
      continue;
    if(pT->kTxt < 0){
      j=i+1;
      while(j < nCBTkn){
	if(CBTkn[j].t == pT->t && CBTkn[j].kTxt >= 0){
	  pT->kTxt=CBTkn[j].kTxt;
	  CBTkn[j].kTxt=-1;
	  break;
	}
	j++;
      }
    }
    if(pT->kCMM < 0){
      j=i+1;
      while(j < nCBTkn){
	if(CBTkn[j].t == pT->t && CBTkn[j].kCMM >= 0){
	  pT->kCMM=CBTkn[j].kCMM;
	  CBTkn[j].kCMM=-1;
	  break;
	}
	j++;
      }
    }
  }
  
  /* IDs */
  for(iC=0; iC < nCNmIDD; iC++){
    CNmID[iC].kCMM=-1;
    CNmID[iC].kTxt=-1;
  }

  i0=nCNmIDD-1;
  j0=nCTpD+dnCTpD;
  for(i=nCNmIDD; i < nCNmID; i++){
    pC=CNmID+i;
    j=pC->kTxt;
    k=pC->kCMM;
    ii=i+1;
    L=pC->n;
    if(nCTpD <= L && L <= j0)
      i0=i;
    /* External variables !!! Information can be lost */
    if((pC->t&0x100000) || L == j0){
      pC->kTxt=-1;
      pC->kCMM=-1;
      if(j >= 0 && j < nDTxt && DTxt[j].kID == ii){
	DTxt[j].kCB=-1;
	DTxt[j].kID=-1;
      }
      if(k >= 0 && k < nCMMnt && CMMnt[k].kID == ii){
	CMMnt[k].kCB=-1;
	CMMnt[k].kID=-1;
      }
    }
    if(j >= nDTxt || (j >=0 && DTxt[j].kID != ii)){
      pC->kTxt=-1;
    }
    if(k >= nCMMnt || (k >=0 && CMMnt[k].kID != ii)){
      pC->kCMM=-1;
    }
  }

  i0++;
  /* Comparison Used ID with System declarations */
  j0=CBTkn[n].j0;
  j1=CBTkn[n].j1;
  for(j=j0; j < j1; j++){
    if((CNmUS[j].t&0xC05E01) == 0){
      s=CNmUS[j].p;
      for(i=nCNmIDD; i < i0; i++){
	if(strcmp(s,CNmID[i].p) == 0){
	  break;
	}
      }
      if(i < i0){
	L=CNmID[i].n;
	CNmUS[j].kTxt=CNmID[i].kTxt;
	CNmUS[j].kCMM=CNmID[i].kCMM;
      }
      else{
	L=nCTpD+dnCTpD;
      }
      CNmUS[j].n=L;
      k=0;
      if(L == nCTpD || L == nCTpD+2){/* Ignor, CbStr */
	k=0x000400;
      }
      if(L == nCTpD+1 || L == nCTpD+3){/* Systm, CbExt*/
	k=0x000800;
      }
      if(L == nCTpD+dnCTpD){/* Undef */
	k=0x000200;
      }
      CNmUS[j].t |=k;
      k |=0x000001;
      for(i=j+1; i < j1; i++){
	if((CNmUS[i].t&0xC05E01) == 0 && strcmp(s,CNmUS[i].p) == 0){
	  CNmUS[i].n=CNmUS[j].n;
	  CNmUS[i].t|=k;
	}
      }
    }
  }

  /* Linking code CB segments with Doc texts and comments */
  d=CBTkn[n].d&0xFFFF;
  i1=CBTkn[n].i1;
  i0=nCBTknD;

  iC=n;
  while(iC < nCBTknD){
    pT=CBTkn+iC;
    pT->kTxt=-1;
    pT->kCMM=-1;
    s=pT->Nm;
    L=pT->L&0xC00000FF;
    for(i=i0; i < nCBTkn; i++){
      if(i == i0 && CBTkn[i].kCMM == -1 && CBTkn[i].kTxt == -1){
	i0++;
	continue;
      }
      if(L == (CBTkn[i].L&0xC00000FF) && strcmp(s,CBTkn[i].Nm) == 0){
	pT->kTxt=CBTkn[i].kTxt;
	pT->kCMM=CBTkn[i].kCMM;
	CBTkn[i].kTxt=-1;
	CBTkn[i].kCMM=-1;
	if((pT->t&0x0100)){
	  ii=pT->i0;
	  CNmID[ii].kTxt=-1;
	  CNmID[ii].kCMM=-1;
	  ii++;
	  while(ii < i1){
	    pC=CNmID+ii;
	    if((pC->t&0x008000) == 0)
	      break;
	    pC->kTxt=-1;
	    pC->kCMM=-1;
	    if((pC->t&0x100000) == 0){
	      s=pC->p;
	      j=CBTkn[i].i0+1;
	      while(j < nCNmID){
		k=CNmID[j].t;
		if((k&0x008000) == 0)
		  break;
		if((k&0x100000) == 0 && strcmp(s,CNmID[j].p) == 0){	
		  pC->kTxt=CNmID[j].kTxt;
		  CNmID[j].kTxt=-1;
		  pC->kCMM=CNmID[j].kCMM;
		  CNmID[j].kCMM=-1;
		  break;
		}
		j++;
	      }
	    }
	    ii++;
	  }
	}
	break;
      }
    }
    if((pT->t&0xFF) == 1){
      i=iC+1;
      while(i < nCBTknD && (CBTkn[i].d&0xFFFF)){
	if(CBTkn[i].t == pT->t){
	  if(CBTkn[i].kTxt < 0)
	    break;
	  CBTkn[i].kTxt=-1;
	  CBTkn[i].kCMM=-1;
	}
	i++;
      }
    }
    iC++;
    if(iC == nCBTknD || (CBTkn[iC].d&0xFFFF) <= d)
      break;
  }

  j=nCNmIDD;
  for(i=nCNmIDD; i < i0; i++){
    L=CNmID[i].n;
    if(nCTpD <= L && L < ii){
      CNmID[i].kTxt=-1;
      CNmID[i].kCMM=-1;
    }
    if(i == j && CNmID[i].kCMM == -1 && CNmID[i].kTxt == -1){
      j++;
    }
  }

  /* Linking code declarations with Doc Text and Comments */
  i0=j;
  j0=CBTkn[n].i0;
  j1=CBTkn[n].i1;
  
  for(iC=j0; iC < j1; iC++){
    pC=CNmID+iC;
    if((pC->t&0x308000)){
      continue;
    }
    pC->kTxt=-1;
    pC->kCMM=-1;
    s=pC->p;
    for(i=i0; i < nCNmID; i++){
      if(i == i0 && CNmID[i].kCMM == -1 && CNmID[i].kTxt == -1){
	i0++;
	continue;
      }
      if((CNmID[i].t&0x308000) == 0 && strcmp(s,CNmID[i].p) == 0){
	pC->kTxt=CNmID[i].kTxt;
	CNmID[i].kTxt=-1;
	pC->kCMM=CNmID[i].kCMM;
	CNmID[i].kCMM=-1;
	break;
      }
    }
  }
  return(0);
}

static int iCNmOut,jCNmOut,jCNmOut1;
int CbDocPrintCNmDcl(int i)
{
  int j,k,L,ind;

  ind=0;
  k=CNmID[i].t;
  j=CNmID[i].n;
  L=LCTp[j];
  if((L&0x8000)){
    printf("static ");
  }
  else{
    if((L&0x4000)){
      printf("extern ");
    }
    else{
      printf("       ");
    }
  }
  ind+=7;
  if((L&0x2000)){
    printf("struct ");
    ind+=7;
  }
  if((L&0x1000)){
    printf("union ");
    ind+=6;
  }
  if((L&0x0800)){
    printf("long ");
    ind+=5;
  }
  if((L&0x0400)){
    printf("short ");
    ind+=6;
  }
  if((L&0x0200)){
    printf("unsigned ");
    ind+=9;
  }
  if((L&0x0100)){
    printf("const ");
    ind+=6;
  }
  printf("%s ",CTp[j]);
  ind+=(LCTp[j]&0x1F)+1;
  if((j=k&0xF0000000)){
    j >>=28;
    while(j > 0){
      printf("*");
      j--;
    }
  }
  printf("%s",CNmID[i].p);
  if((k&0x10000)){
    printf("()");
    if((k&0x20000)){
      printf("{\n");
      while(ind > 0){
	printf(" ");
	ind --;
      }
      printf("}\n");
    }
    else{
      printf(";\n");
    }
  }
  else{
    if((j=k&0x0F000000)){
      j >>=24;
      while(j > 0){
	printf("[]");
	j--;
      }
    }
    printf(";\n");
  }
  return(0);
}

int CbDocWriteCNmTp(int j,int F)
{
  int ind,L;

  L=LCTp[j];
  ind=0;
  if((L&0x8000)){
    if(F)
      fprintf(fpO,"static ");
    ind+=7;
  }
  if((L&0x4000)){
    if(F)
      fprintf(fpO,"extern ");
    ind+=7;
  }
  if((L&0x2000)){
    if(F)
      fprintf(fpO,"struct ");
    ind+=7;
  }
  if((L&0x1000)){
    if(F)
      fprintf(fpO,"union ");
    ind+=6;
  }
  if((L&0x0800)){
    if(F)
      fprintf(fpO,"long ");
    ind+=5;
  }
  if((L&0x0400)){
    if(F)
      fprintf(fpO,"short ");
    ind+=6;
  }
  if((L&0x0200)){
    if(F)
      fprintf(fpO,"unsigned ");
    ind+=9;
  }
  if((L&0x0100)){
    if(F)
      fprintf(fpO,"const ");
    ind+=6;
  }
  if(F){
    fprintf(fpO,"%s ",CTp[j]);
  }
  ind	+=(LCTp[j]&0x1F)+1;

  return(ind);
}

int CbDocWriteCNmUS(int i,int F)
{
  int ind,k,j;
  
  k=CNmUS[i].t;
  ind=CNmUS[i].L&0xFFFF;
  j=k&0xF0000000;
  if(j){
    j >>=28;
    while(j > 0){
      if(F)
	fprintf(fpO,"*");
      ind++;
      j --;
    }
  }
  if(F){
    fprintf(fpO,"%s",CNmUS[i].p);
  }
  j=k&0x0F000000;
  if(j){
    j >>=24;
    while(j > 0){
      if(F){
	fprintf(fpO,"[]");
      }
      ind +=2;
      j --;
    }
  }
  if((k&0x200000)){
    if(F){
      fprintf(fpO,"()");
    }
    ind +=2;
  }
  return(ind);
}

int CbDocWriteCNmID(int i,int F)
{
  int ind,k,j;

  k=CNmID[i].t;
  ind=CNmID[i].L&0xFFFF;
  if((j=k&0xF0000000)){
    j >>=28;
    while(j > 0){
      if(F){
	fprintf(fpO,"*");
      }
      ind++;
      j --;
    }
  }
  if(F){
    fprintf(fpO,"%s",CNmID[i].p);
  }
  if((j=k&0x0F000000)){
    j >>=24;
    while(j > 0){
      if(F){
	fprintf(fpO,"[]");
      }
      ind +=2;
      j --;
    }
  }
  return(ind);
}

int CbDocWriteCNmFnc(int i1,int im)
{
  int i,j,k,ind;

  i=iCNmOut;

  while(i < i1){
    k=CNmID[i].t;
    if((k&0x300000) == 0x200000){
      ind=CbDocWriteCNmTp(CNmID[i].n,1);
      ind +=CbDocWriteCNmID(i,1)+3;
      fprintf(fpO,"();");
      ind=(ind/8)*8;
      j=(im-ind)/8;
      while(j > 0){
	fprintf(fpO,"\t");
	j--;
      }
      fprintf(fpO,"PS p=%3d (%3d);\n",CNmID[i].kPg,(CNmID[i].kPg+1)/2);
    }
    i++;
  }
  iCNmOut=i;
  return(0);
}

int CbDocWriteCNmCmm(int j,int i)
{
  char *s,*t;

  while(j){
    fprintf(fpO,"\t");
    j--;
  }
  j=CNmID[i].kCMM;
  if(j < 0 || j == nCMMnt){
    fprintf(fpO,"/*  */\n");
  }
  else{
    s=CMMnt[j].b;
    t=CMMnt[j].e;
    while(s < t){
      fprintf(fpO,"%c",*s);
      s++;
    }
    fprintf(fpO,"\n");
    CMMnt[j].kID=-1;
    CMMnt[j].kCB=-1;
  }
  return(0);
}
      
int CbDocWriteCNmTxt(int i)
{
  int j;
  char *s,*t;
  j=CNmID[i].kTxt;
  if(j >= 0){
    fprintf(fpO,"#ifdef Doc_%s\n",CNmID[i].p);
    s=FBff+pFLn[DTxt[j].k0];
    t=FBff+pFLn[DTxt[j].k1];
    while(s < t){
      fprintf(fpO,"%c",*s);
      s++;
    }
    fprintf(fpO,"#endif\n");
    DTxt[j].kID=-1;
    DTxt[j].kCB=-1;
  }
  return(0);
}

int CbDocWriteCBPath(int i,int F)
{
  int L;
  char ch[9]={':','<','.','-','-','-','-','-','-'};

  L	=0;
  do{
    if((CBTkn[i].t&0x0100)){
      if(F){
	fprintf(fpO,".%s()",CBTkn[i].Nm);
      }
      L	+=3+((CBTkn[i].L&0x1F000000)>>24);
    }
    else{
      if((CBTkn[i].d&0xFFFF) == 0){
	if(F){
	  fprintf(fpO,":%s",CBTkn[i].Nm);
	}
	break;
      }
      else{
	if(F){
	  fprintf(fpO,"%c%s",ch[(CBTkn[i].t&0xFF)],CBTkn[i].Nm);
#ifdef H
	  fprintf(fpO,".%s%s",CbCResW[(CBTkn[i].t&0xFF)].p,CBTkn[i].Nm);
#endif
	}
	L	+=1+((CBTkn[i].L&0x1F000000)>>24);
#ifdef H
	L	+=5+((CBTkn[i].L&0x1F000000)>>24);
#endif
      }
    }
    i=CBTkn[i].d>>16;
  }while(1);
  return(L);
}

int CbDocWriteCbBlockFnc(int n)
{
  int i,ii,j,k,kk,i1,ind,im;
  char *s,*t;

  i=CBTkn[n].i0;
  k=CNmID[i].t;
  j=CNmID[i].n;
  fputc('\n',fpO);
  CbDocWriteCNmTp(j,1);
  CbDocWriteCNmID(i,1);
  i++;
  i1=i;
  fprintf(fpO,"(");
  while(i1 < nCNmID && (CNmID[i1].t&0x004000)){
    if(i1 != i)
      fprintf(fpO,",");
    fprintf(fpO,"%s",CNmID[i1].p);
    i1++;
  }
  while(i1 < nCNmID && (CNmID[i1].t&0x008000)){
    i1++;
  }
  fprintf(fpO,")\n");
  if(i < i1){
    im=0;
    ii=i;
    while(ii < i1){
      kk=CNmID[ii].t;
      if((kk&0x100000) == 0){
	ind=2+CbDocWriteCNmTp(CNmID[ii].n,0);
	ind +=((kk&0xF0000000)>>28)+((kk&0x0F000000)>>23)
	  +(CNmID[ii].L&0xFFFF)+1;
	if(im < ind){
	  im=ind;
	}
      }
      ii++;
    }
    im=(im/8+1)*8;
    ii=i;
    while(ii < i1){
      kk=CNmID[ii].t;
      if((kk&0x100000) == 0){
	fprintf(fpO,"  ");
	ind=2+CbDocWriteCNmTp(CNmID[ii].n,1);
	ind +=CbDocWriteCNmID(ii,1);
	fprintf(fpO,";");
	ind++;
	ind=(ind/8)*8;
	j=(im-ind)/8;
	CbDocWriteCNmCmm(j,ii);
	CbDocWriteCNmTxt(ii);
      }
      ii++;
    }
  }
  fprintf(fpO,"{\n");
  iCNmOut=i1;
  return(0);
}


int CbDocWriteCbBlockFncIO(int n)
{
  int i,k;

  i	=CBTkn[n].i0+1;
  while(i < nCNmID && ((k=CNmID[i].t)&0x004000)){
    if((k&0x100000) == 0){
      fputs("\\c{",fpO);
      CbDocWriteCNmTp(CNmID[i].n,1);
      fputs("}&\\c{",fpO);
      CbDocWriteCNmID(i,1);
      fprintf(fpO,"}&$$&\\\\\n");
    }
    i++;
  }
  while(i < nCNmID && ((k=CNmID[i].t)&0x008000)){
    if((k&0x100000) == 0){
      fputs("\\c{",fpO);
      CbDocWriteCNmTp(CNmID[i].n,1);
      fputs("}&\\c{",fpO);
      CbDocWriteCNmID(i,1);
      fprintf(fpO,"}&$$&\\\\\n");
    }
    i++;
  }
  return(0);
}


int CbDocWriteCNmUSCmm(int im,int im1,int i)
{
  int k,j,jj,ind;

  fprintf(fpO,"  ");
  ind=2+CbDocWriteCNmTp(CNmUS[i].n,1);
  ind +=CbDocWriteCNmUS(i,1);
  fprintf(fpO,";");
  ind++;
  ind=(ind/8)*8;
  k=(im-ind)/8;
  while(k){
    fprintf(fpO,"\t");
    k--;
  }
  fprintf(fpO,"/*  ");
  j=CNmUS[i].L>>16;
  if((CNmUS[i].t&0x200000))
    j=CBTkn[j].d>>16;
  ind=CbDocWriteCBPath(j,0)-im1;
  while(ind < 0){
    fprintf(fpO," ");
    ind++;
  }
  CbDocWriteCBPath(j,1);
  fprintf(fpO," */\n");
  return(ind);
}

int CbDocWriteCNmUSMzl(int n)
{
  int i,ii,j,L,k,k1,kk,kk1,j0,j1,im,im1;
  char *s;

  j0=CBTkn[n].j0;
  j1=CBTkn[n].j1;

  im=0;
  for(i=j0; i < j1; i++){
    L=CNmUS[i].t;
    if((L&0xC02F00) == 0x002200 || (L&0x205F00) == 0x200000){
      j=3+CbDocWriteCNmTp(CNmUS[i].n,0)+CbDocWriteCNmUS(i,0);
      if(im < j)
	im=j;
    }      
  }

  /* Used */
  i=j0;
  im1=0;
  while(i < j1){
    if((CNmUS[i].t&0x022F00) == 0x002000){
      j=3+CbDocWriteCNmTp(CNmUS[i].n,0)+CbDocWriteCNmUS(i,0);
      if(im < j){
	im=j;
      }
      j=CNmUS[i].L>>16;
      if((CNmUS[i].t&0x200000)){
	j=CBTkn[j].d>>16;
      }
      j=CbDocWriteCBPath(j,0);
      if(im1 < j){
	im1=j;
      }
    }
    i++;
  }
  im=((im-1)/8+1)*8;

  for(k=0; k < nMzl; k++){
    fprintf(fpO,"#ifdef Tbl_%s\n",CBTkn[kMzl[k]].Nm);
    for(i=j0; i < j1; i++){	/* ID */
      L=CNmUS[i].t;
      if((L&0x002000)){
	kk=CBTkn[CNmUS[i].d>>16].t>>16;
	if(kMzl[k] == kk && (L&0xE01F00) == 0x000200){
	  fprintf(fpO,"  ");
	  j=3+CbDocWriteCNmTp(CNmUS[i].n,1);
	  j +=CbDocWriteCNmUS(i,1);
	  fprintf(fpO,";");
	  j=(j/8)*8;
	  j=(im-j)/8;
	  while(j > 0){
	    fprintf(fpO,"\t");
	    j--;
	  }
	  fprintf(fpO,"/* undefined */\n");
	}      
      }
    }
    for(i=j0; i < j1; i++){	/* Functions */
      L=CNmUS[i].t;
      if((L&0x002000)){
	kk=CBTkn[CNmUS[i].d>>16].t>>16;
	if(kMzl[k] == kk && (L&0xE01F00) == 0x200200){
	  fprintf(fpO,"  ");
	  j=3+CbDocWriteCNmTp(CNmUS[i].n,1);
	  j +=CbDocWriteCNmUS(i,1);
	  fprintf(fpO,";");
	  j=(j/8)*8;
	  j=(im-j)/8;
	  while(j > 0){
	    fprintf(fpO,"\t");
	    j--;
	  }
	  fprintf(fpO,"/* NO prototype */\n");
	}      
      }
    }
    
    im=((im-1)/8+1)*8;
    for(i=j0; i < j1; i++){	/* ID */
      L=CNmUS[i].t;
      if((L&0x002000)){
	kk=CBTkn[CNmUS[i].d>>16].t>>16;
	if(kMzl[k] == kk && (L&0xE01F00) == 0x001200){
	  for(ii=j0; ii < i; ii++){
	    if(strcmp(CNmUS[i].p,CNmUS[ii].p) == 0){
	      break;
	    }
	  }
	  if(ii == i){
	    fprintf(fpO,"  ");
	    j=3+CbDocWriteCNmTp(CNmUS[i].n,1);
	    j +=CbDocWriteCNmUS(i,1);
	    fprintf(fpO,";");
	    j=(j/8)*8;
	    j=(im-j)/8;
	    while(j > 0){
	      fprintf(fpO,"\t");
	      j--;
	    }
	    fprintf(fpO,"/* External */\n");
	  }
	}      
      }
    }
    
    for(i=j0; i < j1; i++){	/* Functions */
      L=CNmUS[i].t;
      if((L&0x002000)){
	kk=CBTkn[CNmUS[i].d>>16].t>>16;
	if(kMzl[k] == kk && (L&0xE01F00) == 0x201200){
	  fprintf(fpO,"  ");
	  j=3+CbDocWriteCNmTp(CNmUS[i].n,1);
	  j +=CbDocWriteCNmUS(i,1);
	  fprintf(fpO,";");
	  j=(j/8)*8;
	  j=(im-j)/8;
	  while(j > 0){
	    fprintf(fpO,"\t");
	    j--;
	  }
	  fprintf(fpO,"/* External() */\n");
	}      
      }
    }
    
    for(i=j0; i < j1; i++){	/* Unprototyped Functions */
      L=CNmUS[i].t;
      if((L&0x002000)){
	kk=CBTkn[CNmUS[i].d>>16].t>>16;
	if(kMzl[k] == kk && (L&0x205F00) == 0x200000){
	  fprintf(fpO,"  ");
	  j=3+CbDocWriteCNmTp(CNmUS[i].n,1);
	  j +=CbDocWriteCNmUS(i,1);
	  fprintf(fpO,";");
	  j=(j/8)*8;
	  j=(im-j)/8;
	  while(j > 0){
	    fprintf(fpO,"\t");
	    j--;
	  }
	  fprintf(fpO,"/* No prototype */\n");
	}      
      }
    }

    for(k1=0; k1 < nMzl; k1++){
      if(k1 == k){
	k1++;
	if(k1 == nMzl)
	  break;
      }
      i=j0;
      while(i < j1){
	L=CNmUS[i].t;
	if((L&0x002002) == 0x002000){
	  kk=CBTkn[CNmUS[i].d>>16].t>>16;
	  kk1=(L&0x040000) ? CBTkn[CNmUS[i].L>>16].t>>16 : kMzl[k1];
	  if(kMzl[k] == kk && kMzl[k1] == kk1 && (L&0x024F00) == 0x004000){
	    CbDocWriteCNmUSCmm(im,im1,i);
	    CNmUS[i].t |=0x000002;
	    for(j=i+1; j < j1; j++){
	      L=CNmUS[j].t;
	      if((L&0x002002) == 0x002000){
		kk=CBTkn[CNmUS[j].d>>16].t>>16;
		if(kMzl[k] == kk && (L&0x024F00) == 0x004000
		   && strcmp(CNmUS[j].p,CNmUS[i].p) == 0){
		  CNmUS[j].t |=0x000002;
		}
	      }
	    }
	  }
	}
	i++;
      }
      
      i=j0;
      while(i < j1){
	L=CNmUS[i].t;
	if((L&0x002002) == 0x002000){
	  kk=CBTkn[CNmUS[i].d>>16].t>>16;
	  kk1=CBTkn[CNmUS[i].L>>16].t>>16;
	  if(kMzl[k] == kk && kMzl[k1] == kk1 && (L&0x224F00) == 0x000000){
	    CbDocWriteCNmUSCmm(im,im1,i);
	    CNmUS[i].t |=0x000002;
	    for(j=i+1; j < j1; j++){
	      L=CNmUS[j].t;
	      if((L&0x002002) == 0x002000){
		kk=CBTkn[CNmUS[j].d>>16].t>>16;
		if(kMzl[k] == kk && (L&0x224F00) == 0x000000
		   && strcmp(CNmUS[j].p,CNmUS[i].p) == 0){
		  CNmUS[j].t |=0x000002;
		}
	      }
	    }
	  }
	}
	i++;
      }
      
      i=j0;
      while(i < j1){
	L=CNmUS[i].t;
	if((L&0x002002) == 0x002000){
	  kk=CBTkn[CNmUS[i].d>>16].t>>16;
	  kk1=CBTkn[CNmUS[i].L>>16].t>>16;
	  if(kMzl[k] == kk && kMzl[k1] == kk1 && (L&0x224F00) == 0x200000){
	    CbDocWriteCNmUSCmm(im,im1,i);
	    CNmUS[i].t |=0x000002;
	    for(j=i+1; j < j1; j++){
	      L=CNmUS[j].t;
	      if((L&0x002002) == 0x002000){
		kk=CBTkn[CNmUS[j].d>>16].t>>16;
		if(kMzl[k] == kk && (L&0x224F00) == 0x200000
		   && strcmp(CNmUS[j].p,CNmUS[i].p) == 0){
		  CNmUS[j].t |=0x000002;
		}
	      }
	    }
	  }
	}
	i++;
      }
    }
    fprintf(fpO,"#endif\n");
  }
  return(0);
}

int CbDocWriteCNmUSExt(int n)
{
  int i,j,L,j0,j1,im;
  char *s;

  j0=CBTkn[n].j0;
  j1=CBTkn[n].j1;
  j=nCTpD;
  while(j < nCTpD+dnCTpD){
    for(i=j0; i < j1; i++){ /* ID */
      L=CNmUS[i].t;
      if((L&0xE00001) == 0 && CNmUS[i].n == j){
	s=CNmUS[i].p;
	fprintf(fpO,"  %s %s;\n",CTp[j],s);
      }      
    }
    for(i=j0; i < j1; i++){ /* Functions */
      L=CNmUS[i].t;
      if((L&0xE00001) == 0x200000 && CNmUS[i].n == j){
	s=CNmUS[i].p;
	fprintf(fpO,"  %s %s();\n",CTp[j],s);
      }      
    }
    j++;
  }

  im=0;
  for(i=j0; i < j1; i++){
    L=CNmUS[i].t;
    if((L&0xC00F01) == 0x000200 || (L&0x205F00) == 0x200000){
      j=3+CbDocWriteCNmTp(CNmUS[i].n,0)+CbDocWriteCNmUS(i,0);
      if(im < j)
	im=j;
    }      
  }

  im=((im-1)/8+1)*8;
  for(i=j0; i < j1; i++){ /* ID */
    L=CNmUS[i].t;
    if((L&0xE01F01) == 0x000200){
      fprintf(fpO,"  ");
      j=3+CbDocWriteCNmTp(CNmUS[i].n,1);
      j +=CbDocWriteCNmUS(i,1);
      fprintf(fpO,";");
      j=(j/8)*8;
      j=(im-j)/8;
      while(j > 0){
	fprintf(fpO,"\t");
	j--;
      }
      fprintf(fpO,"/* undefined */\n");
    }      
  }
  for(i=j0; i < j1; i++){ /* Functions */
    L=CNmUS[i].t;
    if((L&0xE01F01) == 0x200200){
      fprintf(fpO,"  ");
      j=3+CbDocWriteCNmTp(CNmUS[i].n,1);
      j +=CbDocWriteCNmUS(i,1);
      fprintf(fpO,";");
      j=(j/8)*8;
      j=(im-j)/8;
      while(j > 0){
	fprintf(fpO,"\t");
	j--;
      }
      fprintf(fpO,"/* NO prototype */\n");
    }      
  }
  im=((im-1)/8+1)*8;
  for(i=j0; i < j1; i++){ /* ID */
    L	=CNmUS[i].t;
    if((L&0xE01F01) == 0x001200){
      fprintf(fpO,"  ");
      j=3+CbDocWriteCNmTp(CNmUS[i].n,1);
      j +=CbDocWriteCNmUS(i,1);
      fprintf(fpO,";");
      j=(j/8)*8;
      j=(im-j)/8;
      while(j > 0){
	fprintf(fpO,"\t");
	j--;
      }
      fprintf(fpO,"/* External */\n");
    }      
  }

  for(i=j0; i < j1; i++){ /* Functions */
    L=CNmUS[i].t;
    if((L&0xE01F01) == 0x201200){
      fprintf(fpO,"  ");
      j=3+CbDocWriteCNmTp(CNmUS[i].n,1);
      j +=CbDocWriteCNmUS(i,1);
      fprintf(fpO,";");
      j=(j/8)*8;
      j=(im-j)/8;
      while(j > 0){
	fprintf(fpO,"\t");
	j--;
      }
      fprintf(fpO,"/* External() */\n");
    }      
  }

  for(i=j0; i < j1; i++){ /* Unprototyped Functions */
    L=CNmUS[i].t;
    if((L&0x205F00) == 0x200000){
      fprintf(fpO,"  ");
      j=3+CbDocWriteCNmTp(CNmUS[i].n,1);
      j +=CbDocWriteCNmUS(i,1);
      fprintf(fpO,";");
      j=(j/8)*8;
      j=(im-j)/8;
      while(j > 0){
	fprintf(fpO,"\t");
	j--;
      }
      fprintf(fpO,"/* No prototype */\n");
    }      
  }
  CbDocWriteCNmUSMzl(n);
  return(0);
}

int CbDocWriteCNmUsed(int j1)
{
  int i,j,jj,k,im,im1,ind;

  i=jCNmOut;
  jCNmOut1	=i;

  /* Undefined */
  while(i < j1){
    k=CNmUS[i].t;
    if((k&0x001200) == 0x000200){
      fprintf(fpO,"  ");
      CbDocWriteCNmTp(CNmUS[i].n,1);
      CbDocWriteCNmUS(i,1);
      fprintf(fpO,";\n");
    }
    i++;
  }

  im=0;
  i=jCNmOut;
  ind=0;
  while(i < j1){
    k=CNmUS[i].t;
    if((k&0x021200) == 0x001200 || (k&0x205F00) == 0x200000){
      ind=3+CbDocWriteCNmTp(CNmUS[i].n,0)+CbDocWriteCNmUS(i,0);
      if(im < ind)
	im=ind;
    }
    i++;
  }
  im=((im-1)/8+1)*8;

  i=jCNmOut;
  while(i < j1){
    k=CNmUS[i].t;
    if((k&0x021200) == 0x001200){
      fprintf(fpO,"  ");
      ind=3+CbDocWriteCNmTp(CNmUS[i].n,1)+CbDocWriteCNmUS(i,1);
      fprintf(fpO,";");
      ind=(ind/8)*8;
      j=(im-ind)/8;
      while(j){
	fprintf(fpO,"\t");
	j--;
      }
      fprintf(fpO,"/* undefined */\n");
    }
    i++;
  }

  i=jCNmOut;
  while(i < j1){
    k=CNmUS[i].t;
    if((k&0x205F00) == 0x200000){
      fprintf(fpO,"  ");
      ind=3+CbDocWriteCNmTp(CNmUS[i].n,1)+CbDocWriteCNmUS(i,1);
      fprintf(fpO,";");
      ind=(ind/8)*8;
      j=(im-ind)/8;
      while(j){
	fprintf(fpO,"\t");
	j--;
      }
      fprintf(fpO,"/* No prototype */\n");
    }
    i++;
  }

  /* Used */
  i=jCNmOut;
  im=0;
  im1=0;
  while(i < j1){
    if((CNmUS[i].t&0x020F00) == 0x000000){
      ind=3+CbDocWriteCNmTp(CNmUS[i].n,0)+CbDocWriteCNmUS(i,0);
      if(im < ind)
	im=ind;
      j=CNmUS[i].L>>16;
      if((CNmUS[i].t&0x200000))
	j=CBTkn[j].d>>16;
      ind=CbDocWriteCBPath(j,0);
      if(im1 < ind)
	im1=ind;
    }
    i++;
  }
  im=((im-1)/8+1)*8;
  
  i=jCNmOut;
  while(i < j1){
    if((CNmUS[i].t&0x024F00) == 0x004000){
      CbDocWriteCNmUSCmm(im,im1,i);
    }
    i++;
  }
  
  i=jCNmOut;
  while(i < j1){
    if((CNmUS[i].t&0x224F00) == 0x000000){
      CbDocWriteCNmUSCmm(im,im1,i);
    }
    i++;
  }
  
  i=jCNmOut;
  while(i < j1){
    if((CNmUS[i].t&0x224F00) == 0x200000){
      CbDocWriteCNmUSCmm(im,im1,i);
    }
    i++;
  }

  jCNmOut=i;
  return(0);
}

int CbDocWriteCNmUsedIO(int j1)
{
  int i,k;

  i=jCNmOut1;

  /* Undefined */
  while(i < j1){
    k=CNmUS[i].t;
    if((k&0x001200) == 0x000200){
      fputs("\\c{",fpO);
      CbDocWriteCNmTp(CNmUS[i].n,1);
      fputs("}&\\c{",fpO);
      CbDocWriteCNmUS(i,1);
      fprintf(fpO,"}&$$&\\\\\n");
    }
    i++;
  }

  i=jCNmOut1;
  while(i < j1){
    k=CNmUS[i].t;
    if((k&0x021200) == 0x001200){
      fputs("\\c{",fpO);
      CbDocWriteCNmTp(CNmUS[i].n,1);
      fputs("}&\\c{",fpO);
      CbDocWriteCNmUS(i,1);
      fprintf(fpO,"}&$$&\\\\\n");
    }
    i++;
  }

  i=jCNmOut1;
  while(i < j1){
    k=CNmUS[i].t;
    if((k&0x205F00) == 0x200000){
      fputs("\\c{",fpO);
      CbDocWriteCNmTp(CNmUS[i].n,1);
      fputs("}&\\c{",fpO);
      CbDocWriteCNmUS(i,1);
      fprintf(fpO,"}&$$&\\\\\n");
    }
    i++;
  }

  /* Used */
  i=jCNmOut1;
  while(i < j1){
    if((CNmUS[i].t&0x020F00) == 0x000000){
      fputs("\\c{",fpO);
      CbDocWriteCNmTp(CNmUS[i].n,1);
      fputs("}&\\c{",fpO);
      CbDocWriteCNmUS(i,1);
      fprintf(fpO,"}&$$&\\\\\n");
    }
    i++;
  }
  return(0);
}

int CbDocWriteCNmUnused(int n)
{
  int i,j,L,i0,i1,im,im1;

  i0=CBTkn[n].i0;
  i1=CBTkn[n].i1;
  im=0;
  im1=0;
  for(i=i0; i < i1; i++){
    L=CNmID[i].t;
    if((L&0x002000) == 0 && (L&0x108000) != 0x108000){
      j=3+CbDocWriteCNmTp(CNmID[i].n,0)+CbDocWriteCNmID(i,0);
      if((L&0x200000)){
	j +=2;
      }
      if(im < j)
	im=j;
      j=CNmID[i].L>>16;
      if((CNmID[i].t&0x200000))
	j=CBTkn[j].d>>16;
      j=CbDocWriteCBPath(j,0);
      if(im1 < j){
	im1=j;
      }
    }      
  }
  im=((im-1)/8+1)*8;
  if(im1 == 0)
    return(0);
  fprintf(fpO,"#ifdef Tbl_UnusedID");
  fprintf(fpO,"/* ------------- List of Unused variables ------{ */\n");
  for(i=i0; i < i1; i++){
    L=CNmID[i].t;
    if((L&0x002000) == 0 && (L&0x108000) != 0x108000){
      fprintf(fpO,"  ");
      j=3+CbDocWriteCNmTp(CNmID[i].n,1)+CbDocWriteCNmID(i,1);
      if((L&0x200000)){
	fprintf(fpO,"()");
	j +=2;
      }
      fprintf(fpO,";");
      j=(j/8)*8;
      j=(im-j)/8;
      while(j > 0){
	fprintf(fpO,"\t");
	j--;
      }
      fprintf(fpO,"/* ");
      j=CNmID[i].L>>16;
      if((CNmID[i].t&0x200000)){
	j=CBTkn[j].d>>16;
      }
      j=CbDocWriteCBPath(j,0)-im1;
      while(j < 0){
	fprintf(fpO," ");
	j++;
      }
      j=CNmID[i].L>>16;
      if((CNmID[i].t&0x200000)){
	j=CBTkn[j].d>>16;
      }
      CbDocWriteCBPath(j,1);
      fprintf(fpO," */\n");
    }      
  }
  fprintf(fpO,"#endif /* }=== End of List of Unused variables ======*/\n");
  return(0);
}

int CbDocWriteCNmDcl(int i1)
{
  int i,ii,iC,ind,j,k,jj,L,im,im1;
  im=0;
  im1=0;
  i=iCNmOut;

  while(i < i1){
    k=CNmID[i].t;
    j=CNmID[i].n;
    ind=CbDocWriteCNmTp(j,0);
    ind +=((k&0xF0000000)>>28)+((k&0x0F000000)>>23)+(CNmID[i].L&0xFFFF);
    if((k&0x200000)) ind+=2;
    ind++;
    if(im < ind) im=ind;
    if((k&0x108000) == 0x100000){
      ind=(k&0x800000) ? CbDocWriteCBPath(CNmID[i].L>>16,0) : 8;
      if(im1 < ind) im1=ind;
    }
    i++;
  }
  im=((im-1)/8+1)*8;
  i=iCNmOut;
  while(i < i1){
    k=CNmID[i].t;
    j=CNmID[i].n;
    ind=CbDocWriteCNmTp(j,1);
    ind +=CbDocWriteCNmID(i,1);
    if((k&0x200000)){
      fprintf(fpO,"()");
      ind +=2;
    }
    fprintf(fpO,";");
    ind++;
    ind=(ind/8)*8;
    jj=(im-ind)/8;
    if((k&0x108000) == 0x100000){
      while(jj){
	fprintf(fpO,"\t");
	jj--;
      }
      fprintf(fpO,"/* ");
      ind=(k&0x800000) ? CbDocWriteCBPath(CNmID[i].L>>16,0) : 8;
      ind=im1-ind;
      while(ind){
	fprintf(fpO," ");
	ind--;
      }
      if((k&0x800000)){
	CbDocWriteCBPath(CNmID[i].L>>16,1);
      }
      else{
	fprintf(fpO,"undefined");
      }
      fprintf(fpO," */\n");
    }
    else{
      CbDocWriteCNmCmm(jj,i);
      CbDocWriteCNmTxt(i);
    }
    i++;
  }
  iCNmOut=i;
  return(0);
}

int CbDocPrintTOC()
{
  int i,d,k,j,ind;
  d=0;
  for(i=0; i < nCBTkn; i++){
    ind=CBTkn[i].d&0xFFFF;
#ifdef H
    if((CBTkn[i].t&0x0100)){
      if(i+1 == nCBTkn || ind >= (CBTkn[i+1].d&0xFFFF))
	continue;
    }
#endif
    while(d > ind){
      d--;
      k=0;
      while(k < d){
	printf("  ");
	k++;
      }
      printf("}\n");
    }
    k=0;
    while(k < ind){
      printf("  ");
      k++;
    }
    if(ind){
      if((CBTkn[i].t&0x0100)){
	j=CNmID[CBTkn[i].i0].n;
	CbDocPrintCNmTp(j,1);
	CbDocPrintCNmID(CBTkn[i].i0,1);
	printf("{\n");
      }
      else{
	printf("%s%s{\n",CbCResW[(CBTkn[i].t&0xFF)].p,CBTkn[i].Nm);
      }
    }
    else{
      printf("blb_%s{\n",CBTkn[i].Nm);
    }
    if(d < ind+1)
      d=ind+1;
  }

  while(d > 0){
    d--;
    k=0;
    while(k < d){
      printf("  ");
      k++;
    }
    printf("}\n");
  }
  return(0);
}

int CbDocWriteCBStruct(int n)
{
  int i,d,k,j;
  d=0;
  fprintf(fpO,"#ifdef Blb_%s\n",NmF);
  for(i=n; i < nCBTkn; i++){
    if((CBTkn[i].t&0x0100)){
      if(i+1 == nCBTkn || (CBTkn[i].d&0xFFFF) >= (CBTkn[i+1].d&0xFFFF))
	continue;
    }
    while(d > (CBTkn[i].d&0xFFFF)){
      d--;
      k=d;
      while(k > 0){
	fprintf(fpO,"  ");
	k--;
      }
      fprintf(fpO,"}\n");
    }
    k=0;
    while(k < (CBTkn[i].d&0xFFFF)){
      fprintf(fpO,"  ");
      k++;
    }
    if(i != n){
      if((CBTkn[i].d&0xFFFF) == 0)
	break;
      if((CBTkn[i].t&0x0100)){
	j=CNmID[CBTkn[i].i0].n;
	CbDocWriteCNmTp(j,1);
	fprintf(fpO,"%s(){\n",CBTkn[i].Nm);
      }
      else{
	fprintf(fpO,"%s%s{\n",CbCResW[(CBTkn[i].t&0xFF)].p,CBTkn[i].Nm);
      }
    }
    else{
      fprintf(fpO,"Blb_%s{\n",CBTkn[i].Nm);
    }
    if(d < (CBTkn[i].d&0xFFFF)+1)
      d=(CBTkn[i].d&0xFFFF)+1;
  }

  while(d > 0){
    d--;
    k=0;
    while(k < d){
      fprintf(fpO,"  ");
      k++;
    }
    fprintf(fpO,"}\n");
  }
  fprintf(fpO,"#endif\n");
  return(0);
}

int CbDocWriteCbBlockTxt(int n,int n0)
{
  int i,j,L;
  char *s,*t;

  j=CBTkn[n].kTxt;
  if(j >= 0){
    fprintf(fpO,"#ifdef Doc_%s\n",CBTkn[n].Nm);
    s=FBff+pFLn[DTxt[j].k0];
    t=FBff+pFLn[DTxt[j].k1];
    if((CBTkn[n].t&0x0100) &&
       CbDocIfImageFirst(s,"\\section{Skeleton of ") == 0 &&
       CbDocIfImageFirst(s,"\\Section{Skeleton of ") == 0){
      fprintf(fpO,"\\Section{Skeleton of \\c{%s()}}\n",CBTkn[n].Nm);
      fprintf(fpO,"  \\begin{verbatim}\n");
      fprintf(fpO,"    %s(){\n",CBTkn[n].Nm);
      fprintf(fpO,"    }\n");
      fprintf(fpO,"  \\end{verbatim}\n");
      fprintf(fpO,"\\Section{\\c{%s()}}\n",CBTkn[n].Nm);
      fputs("\\Subsection{Formal parameters}\n",fpO);
      fputs("\\vskip1ex\\noindent\\begin{tabular}{|lllp{4in}|}\\hline\n",fpO);
      fputs("\\c{Type}&\\c{ID}&\\bf\\em Math&\\bf\\em Comment\\\\\\hline\n"
	    ,fpO);

      CbDocWriteCbBlockFncIO(n);

      fputs("\\hline\\end{tabular}\\vskip1ex\n",fpO);
      fputs("\\Subsection{Return values}\n",fpO);
      fputs("{\\obeylines\\parindent0in\n",fpO);
      fputs("\\c{0} - upon success;\n",fpO);
      fputs("\\c{1} - if failed;\n",fpO);
      fputs("}\n",fpO);
      fputs("\\Subsection{Description}\n",fpO);
      fputs("\\Subsection{Algorithm}\n",fpO);
      fputs("\\Subsection{Input}\n",fpO);
      fputs("\\vskip1ex\\noindent\\begin{tabular}{|lllp{4in}|}\\hline\n",fpO);
      fputs("\\c{Type}&\\c{ID}&\\bf\\em Math&\\bf\\em Comment\\\\\\hline\n"
	    ,fpO);

      CbDocWriteCNmUsedIO(CBTkn[n].j1);

      fputs("\\c{}&\\c{}&$$&\\\\\n",fpO);
      fputs("\\hline\\end{tabular}\\vskip1ex\n",fpO);
      fputs("\\Subsection{Output}\n",fpO);
      fputs("\\vskip1ex\\noindent\\begin{tabular}{|lllp{4in}|}\\hline\n",fpO);
      fputs("\\c{Type}&\\c{ID}&\\bf\\em Math&\\bf\\em Comment\\\\\\hline\n"
	    ,fpO);
      fputs("\\c{}&\\c{}&$$&\\\\\n",fpO);
      fputs("\\hline\\end{tabular}\\vskip1ex\n",fpO);
      fputs("\\Subsection{ToDo}\n",fpO);
      fputs("\\begin{enumerate}\n",fpO);
      fputs("\\item\n",fpO);
      fputs("\\end{enumerate}\n",fpO);
      fputs("\\Subsection{References}\n",fpO);
      fprintf(fpO,"#endif\n");
    }

    while(s < t){
      fprintf(fpO,"%c",*s);
      s++;
    }
    DTxt[j].kCB=-1;
    DTxt[j].kID=-1;
    if((CBTkn[n].t&0xFF) == 1){
      L=CBTkn[n].L&0xC00000FF;
      for(i=nCBTknD; i < nCBTkn; i++){
	if(i == nCBTknD && CBTkn[i].kCMM == -1 && CBTkn[i].kTxt == -1){
	  nCBTknD++;
	  continue;
	}
	if(CBTkn[i].kTxt >= 0 && CBTkn[i].t == CBTkn[n].t){
	  j=CBTkn[i].kTxt;
	  s=FBff+pFLn[DTxt[j].k0];
	  t=FBff+pFLn[DTxt[j].k1];
	  fprintf(fpO,"\n");
	  while(s < t){
	    fprintf(fpO,"%c",*s);
	    s++;
	  }
	  CBTkn[i].kTxt=-1;
	  DTxt[j].kCB=-1;
	  DTxt[j].kID=-1;
	  break;
	}
      }
    }
    fprintf(fpO,"#endif\n");
  }
  else{
    if((CBTkn[n].t&0x0100)){
      fprintf(fpO,"#ifdef Doc_%s\n",CBTkn[n].Nm);
      fprintf(fpO,"\\Section{Skeleton of \\c{%s()}}\n",CBTkn[n].Nm);
      fprintf(fpO,"  \\begin{verbatim}\n");
      fprintf(fpO,"    %s(){\n",CBTkn[n].Nm);
      fprintf(fpO,"    }\n");
      fprintf(fpO,"  \\end{verbatim}\n");
      fprintf(fpO,"\\Section{\\c{%s()}}\n",CBTkn[n].Nm);
      fputs("\\Subsection{Formal parameters}\n",fpO);
      fputs("\\vskip1ex\\noindent\\begin{tabular}{|lllp{4in}|}\\hline\n",fpO);
      fputs("\\c{Type}&\\c{ID}&\\bf\\em Math&\\bf\\em Comment\\\\\\hline\n"
	    ,fpO);

      CbDocWriteCbBlockFncIO(n);

      fputs("\\hline\\end{tabular}\\vskip1ex\n",fpO);
      fputs("\\Subsection{Return values}\n",fpO);
      fputs("{\\obeylines\\parindent0in\n",fpO);
      fputs("\\c{0} - upon success;\n",fpO);
      fputs("\\c{1} - if failed;\n",fpO);
      fputs("}\n",fpO);
      fputs("\\Subsection{Description}\n",fpO);
      fputs("\\Subsection{Algorithm}\n",fpO);
      fputs("\\Subsection{Input}\n",fpO);
      fputs("\\vskip1ex\\noindent\\begin{tabular}{|lllp{4in}|}\\hline\n",fpO);
      fputs("\\c{Type}&\\c{ID}&\\bf\\em Math&\\bf\\em Comment\\\\\\hline\n"
	    ,fpO);

      CbDocWriteCNmUsedIO(CBTkn[n].j1);

      fputs("\\c{}&\\c{}&$$&\\\\\n",fpO);
      fputs("\\hline\\end{tabular}\\vskip1ex\n",fpO);
      fputs("\\Subsection{Output}\n",fpO);
      fputs("\\vskip1ex\\noindent\\begin{tabular}{|lllp{4in}|}\\hline\n",fpO);
      fputs("\\c{Type}&\\c{ID}&\\bf\\em Math&\\bf\\em Comment\\\\\\hline\n"
	    ,fpO);
      fputs("\\c{}&\\c{}&$$&\\\\\n",fpO);
      fputs("\\hline\\end{tabular}\\vskip1ex\n",fpO);
      fputs("\\Subsection{ToDo}\n",fpO);
      fputs("\\begin{enumerate}\n",fpO);
      fputs("\\item\n",fpO);
      fputs("\\end{enumerate}\n",fpO);
      fputs("\\Subsection{References}\n",fpO);
      fprintf(fpO,"#endif\n");
    }
  }
  return(0);
}

int CbDocWriteCbBlockCmm(int n)
{
  int i,j,L;
  char *s,*t;

  j=CBTkn[n].kCMM;
  if(j >= 0){
    s=CMMnt[j].b;
    t=CMMnt[j].e;
    while(s < t){
      fprintf(fpO,"%c",*s);
      s++;
    }
    fprintf(fpO,"\n");
    CMMnt[j].kCB=-1;
    CMMnt[j].kID=-1;
    if((CBTkn[n].t&0xFF) == 1){
      L=CBTkn[n].L&0xC00000FF;
      for(i=nCBTknD; i < nCBTkn; i++){
	if(i == nCBTknD && CBTkn[i].kCMM == -1 && CBTkn[i].kTxt == -1){
	  nCBTknD++;
	  continue;
	}
	if(CBTkn[i].kCMM >= 0 && CBTkn[i].t == CBTkn[n].t){
	  j=CBTkn[i].kCMM;
	  s=CMMnt[j].b;
	  t=CMMnt[j].e;
	  fprintf(fpO,"\n");
	  while(s < t){
	    fprintf(fpO,"%c",*s);
	    s++;
	  }
	  fprintf(fpO,"\n");
	  CBTkn[i].kCMM=-1;
	  CMMnt[j].kCB=-1;
	  CMMnt[j].kID=-1;
	  break;
	}
      }
    }
  }
  else{
    if((CBTkn[n].t&0x0100)){
      fprintf(fpO,"  /*\n   */\n");
    }
  }
  return(0);
}

int CbDocWriteCbBlock(int n,int n0)
{
  int j,d,n1,i1,j1;

  d	=CBTkn[n].d&0xFFFF;
  if(n != n0){
    if((CBTkn[n].t&0x0100)){
      CbDocWriteCbBlockFnc(n);
    }
    else{
      fprintf(fpO,"\n#ifndef %s%s\n",CbCResW[(CBTkn[n].t&0xFF)].p,CBTkn[n].Nm);
      CbDocWriteCbBlockCmm(n);
      CbDocWriteCbBlockTxt(n,n0);
    }
  }
  else{
    if(n) putc('\n',fpO);
    fprintf(fpO,"#ifndef Blb_%s\n",CBTkn[n].Nm);
    CbDocWriteCbBlockCmm(n);
    CbDocWriteCbBlockTxt(n,n0);
  }
  if(n == n0){
    fprintf(fpO,"\n#ifndef mzl_System_%s",CBTkn[n].Nm);
    fprintf(fpO," /* --------------- Use of Variables --------{ */\n");
    CbDocWriteCNmUnused(n0);
    fprintf(fpO,"#ifndef H/* ---------- Used External Variables ------{ */\n");
    CbDocWriteCNmUSExt(n0);
    fprintf(fpO,"#endif");
    fprintf(fpO," /* }======== End of Used External Variables ======= */\n\n");
    fprintf(fpO,"#endif");
    fprintf(fpO," /* }======== End of Use of Variables ======== */\n\n");
  }


  n1=n+1;
  while(d < (CBTkn[n1].d&0xFFFF) && n1 < nCBTkn){
    i1=CBTkn[n1].i0;
    j1=CBTkn[n1].j0;
    CbDocWriteCNmDcl(i1);
    CbDocWriteCNmUsed(j1);
    n1=CbDocWriteCbBlock(n1,n0);
  }

  i1=CBTkn[n].i1;
  CbDocWriteCNmDcl(i1);
  j1=CBTkn[n].j1;

  CbDocWriteCNmUsed(j1);
  if((CBTkn[n].t&0x0100)){
    CbDocWriteCbBlockCmm(n);
    CbDocWriteCbBlockTxt(n,n0);
    fprintf(fpO,"}\n");
  }
  else{
    fprintf(fpO,"#endif\n");
  }
  return(n1);
}

int CbDocWriteCBUnused()
{
  int i,k,n,F;
  char *s,*t;

  F=0;
  for(i=0; i < nDTxt; i++){
    if(DTxt[i].kCB >= 0){
      F=1;
      break;
    }
    if(DTxt[i].kID >= 0){
      F=1;
      break;
    }
  }
  if(F == 0){
    for(i=0; i < nCMMnt; i++){
      if(CMMnt[i].kCB >= 0){
	F=1;
	break;
      }
      if(CMMnt[i].kID >= 0){
	F=1;
	break;
      }
    }
  }

  if(F){
    printf("There is unused Doc information%c\n",7);
    fprintf(fpO,"\n#undef Doc_Unused_Doc_Information /* ------------{ */\n");
    fprintf(fpO,"#ifdef Doc_Unused_Doc_Information\n");
  }

  /* Texts */
  for(i=0; i < nDTxt; i++){
    if(DTxt[i].kCB >= 0){
      n=DTxt[i].kCB;
      fprintf(fpO,"#ifndef %s%s\n",CbCResW[(CBTkn[n].t&0xFF)].p,CBTkn[n].Nm);
      if(DTxt[i].kID >= 0){
	k=DTxt[i].kID-1;
	CbDocWriteCNmTp(CNmID[k].n,1);
	CbDocWriteCNmID(k,1);
	if((CNmID[k].t&0x200000)){
	  fprintf(fpO,"()");
	}
	fprintf(fpO,";\n");
	DTxt[i].kID=-1;
      }
      fprintf(fpO,"#ifdef Doc_%s\n",CBTkn[n].Nm);
      s=FBff+pFLn[DTxt[i].k0];
      t=FBff+pFLn[DTxt[i].k1];
      while(s < t){
	fprintf(fpO,"%c",*s);
	s++;
      }
      fprintf(fpO,"#endif\n");
      fprintf(fpO,"#endif\n");
      DTxt[i].kCB=-1;
    }
    if(DTxt[i].kID >= 0){
      n=DTxt[i].kID-1;
      k=CNmID[n].t;
      CbDocWriteCNmTp(CNmID[n].n,1);
      CbDocWriteCNmID(n,1);
      if((k&0x200000)){
	fprintf(fpO,"()");
      }
      fprintf(fpO,";\n");
      fprintf(fpO,"#ifdef Doc_%s\n",CNmID[n].p);
      s=FBff+pFLn[DTxt[i].k0];
      t=FBff+pFLn[DTxt[i].k1];
      while(s < t){
	fprintf(fpO,"%c",*s);
	s++;
      }
      fprintf(fpO,"#endif\n");
      DTxt[i].kID=-1;
    }
  }

  /* Comments */
  for(i=0; i < nCMMnt; i++){
    if(CMMnt[i].kCB >= 0){
      n=CMMnt[i].kCB;
      fprintf(fpO,"#ifndef %s%s\n",CbCResW[(CBTkn[n].t&0xFF)].p,CBTkn[n].Nm);
      if(CMMnt[i].kID >= 0){
	k=CMMnt[i].kID-1;
	CbDocWriteCNmTp(CNmID[k].n,1);
	CbDocWriteCNmID(k,1);
	if((CNmID[k].t&0x200000)){
	  fprintf(fpO,"()");
	}
	fprintf(fpO,";\n");
	CMMnt[i].kID=-1;
      }
      s=CMMnt[i].b;
      t=CMMnt[i].e;
      while(s < t){
	fprintf(fpO,"%c",*s);
	s++;
      }
      fprintf(fpO,"\n");
      fprintf(fpO,"#endif\n");
      CMMnt[i].kCB=-1;
    }
    if(CMMnt[i].kID >= 0){
      k=CMMnt[i].kID-1;
      CbDocWriteCNmTp(CNmID[k].n,1);
      CbDocWriteCNmID(k,1);
      if((CNmID[k].t&0x200000)){
	fprintf(fpO,"()");
      }
      fprintf(fpO,";\t");
      s=CMMnt[i].b;
      t=CMMnt[i].e;
      while(s < t){
	fprintf(fpO,"%c",*s);
	s++;
      }
      fprintf(fpO,"\n");
      CMMnt[i].kID=-1;
    }
  }
  if(F){
    fprintf(fpO,"#endif  /* }== Remove this section ======== */\n");
  }
  return(0);
}

int CbDocWriteCbTOC(int n,int n0,int im)
{
  int j,d,k,i0,i1,n1;

  k=1;
  n1=n+1;
  if((CBTkn[n].t&0x0100)){
    if(n1 == nCBTkn || (CBTkn[n].d&0xFFFF) >= (CBTkn[n1].d&0xFFFF))
      k=0;
  }

  d=CBTkn[n].d&0xFFFF;
  if(n != n0){
    if(k)
      fprintf(fpO,"#ifndef %s%s\n",CbCResW[(CBTkn[n].t&0xFF)].p,CBTkn[n].Nm);
  }
  else{
    fprintf(fpO,"#ifndef Blb_%s\n",CBTkn[n].Nm);
  }
  if((CBTkn[n].t&0x0100) == 0){
    j=im/8;
    while(j){
      fprintf(fpO,"\t");
      j--;
    }
    fprintf(fpO,"PS p=%3d (%3d);\n",CBTkn[n].kPg,(CBTkn[n].kPg+1)/2);
  }
  while(n1 < nCBTkn && d < (CBTkn[n1].d&0xFFFF)){
    i1=CBTkn[n1].i0;
    CbDocWriteCNmFnc(i1,im);
    n1=CbDocWriteCbTOC(n1,n0,im);
  }
  i1=CBTkn[n].i1;
  CbDocWriteCNmFnc(i1,im);

  if(k){
    fprintf(fpO,"#endif\n");
  }
  return(n1);
}

int CbDocWriteTOC(int n)
{
  int i,i1,d,k,im;

  fpO	=fopen(NmOF,"w");
  if(fpO == NULL){
    printf("%s - file cannot be open for Doc output\n",NmOF);
    return(1);
  }
  printf("%s - Doc output: mv %s Doc\n",NmOF,NmOF);
  iCNmOut=CBTkn[n].i0;
  jCNmOut=CBTkn[n].j0;
  CbDocWriteCbBlock(n,n);
  CbDocWriteCBUnused();
  fprintf(fpO,"\n#undef Doc_Cb_Structure\n");
  iCNmOut=CBTkn[n].i0;
  CbDocWriteCBStruct(n);

  fprintf(fpO,"\n#undef Doc_Table_Of_Content\n");
  im=0;
  i=CBTkn[n].i0;
  i1=CBTkn[n].i1;
  while(i < i1){
    k=CNmID[i].t;
    if((k&0x300000) == 0x200000){
      d=CbDocWriteCNmTp(CNmID[i].n,0);
      d +=((k&0xF0000000)>>28)+((k&0x0F000000)>>23)+(CNmID[i].L&0xFFFF)+4;
      if(im < d)
	im=d;
    }
    i++;
  }
  im=(im/8+1)*8;
  CbDocWriteCbTOC(n,n,im);
  fclose(fpO);
  nDTxt=0;
  nCMMnt=0;
  nHLWrd=0;
  nSTRng=0;
  return(0);
}
#endif


#ifndef mzl_DOC
int CbDocUsage()
{
  printf("Usage: c2ps [-L] [-W] [-I] [-EI] filenames\n");
  printf("Where:\n");
  printf(" -L  option switches to portrait mode;\n");
  printf(" -W  option turns off writing Doc/<filename>.d file;\n");
  printf(" -I  option switches processing to internal Cb structure;\n");
  printf(" -EI option processes both external/internal Cb structures;\n");
  printf(" -p3-6 (no spaces) option specifies exclusively output PS pages,\n");
  printf("       it can be repeated;\n");
  printf(" filenames should NOT contain *-wild card\n");
  return(0);
}

int CbDocGetOpt(int n, char **P)
{
  static int nOpt=0;
  int j,k,k1,k2,NOpt=6;
  char *p,*Op[6]={"-W","-L","-I","-EI","-IE","-p"};

  nOpt++;
  time(&sTime);
  pTm=localtime(&sTime);
  LndPrt=1;

  nPSPg=-1;
  if(n < 2){
    CbDocUsage();
    exit(0);
  }
  while(nOpt < n){
    p=P[nOpt];
    for(j=0; j < NOpt; j++){
      if(j != NOpt-1){
	if(strcmp(p,Op[j]) == 0){
	  break;
	}
      }
      else{
	if(strncmp(p,Op[j],2) == 0){
	  break;
	}
      }
    }
    switch(j){
    case 0:
      DocWrt=0;
      break;
    case 1:
      LndPrt=1;
      break;
    case 2:
      DocWrt=2;
      break;
    case 3:
    case 4:
      DocWrt=3;
      break;
    case 5:
      p+=2;
      if(sscanf(p,"%d-%d",&k,&k1) < 2){
	CbDocUsage();
	exit(0);
      }
      else{
	if(k <= k1)
	  k--;
	else{
	  k1--;
	  k2=k;
	  k=k1;
	  k1=k2;
	}
	if(nPSPg < k1)
	  nPSPg=k1;
      }
      if(nPSPg >= NPSPg){
	if(NPSPg){
	  fPSPg=(int*)realloc((void*)fPSPg,(size_t)(nPSPg+32)*sizeof(int));
	}
	else{
	  fPSPg=(int*)malloc((size_t)(nPSPg+32)*sizeof(int));
	}
	for(j=NPSPg; j < nPSPg+32; j++){
 	  fPSPg[j]=0;
	}
	NPSPg=nPSPg+32;
      }
      while(k < k1){
	fPSPg[k]=1;
	k++;
      }
      break;
    default:
      if(*p == '-'){
	CbDocUsage();
	exit(0);
      }
      else{
	return(nOpt);
      }
      break;
    }
    nOpt++;
  }
  return(nOpt);
}

int main(int argc, char **argv)
{
  int iOpt,iFile,i,n;
  
#ifndef mzl_DOC
  if(argc < 2){
    CbDocUsage();
    printf("Usage: you have to provide one or more file names\n");
    exit(0);
  }

#ifndef stg_Init
  CbDocReInitPRD();
  CbDocReInitCBD();
  CbDocReInitCBTkn();
  CbDocReInitMzl();
  CbDocReInitCD();
  CbDocReInitCTp();
  CbDocReInitCNmID();
  CbDocReInitCNmUS();

  CbDocReInitDTxt();
  CbDocReInitCMMnt();
  CbDocReInitHLWrd();
  CbDocReInitSTRng();

  CbDocReInitCln();
  CbDocReInitFLn();
  CbDocReInitFBff();
#endif

  while((iOpt=CbDocGetOpt(argc,argv)) < argc){
#ifndef blb_Files
    printf(" --------------- %s --------------------- \n",argv[iOpt]);
    strcpy(NmSF,argv[iOpt]);
    CbDocInitFileNames();
    if(CbDocFile2Bff(NmSF) > 0){
      nCTp=0;
      LCTp[nCTp]=0;
      nCNmID=0;
      kCNmID=0;
      iCNmID=0;
      nCNmUS=0;
      kCBF=0;
      nCBTkn=0;
      nMzl=0;
      switch(Ixtn){
      case 0:			/* .c-file */
      case 1:			/* .h-file */
	nCNmIDD=nCNmID;
	CbDocGetCStruct();
	CbDocSetCBTknTp(0);
	CbDocFileSetCNmID(0);
	CbDocGlobalSetCNmID();
	CbDocGlobalSetCNmUS(0);
#ifdef H
	CbDocPrintTOC();
#endif
	CbDocWritePS();
	if(DocWrt){
	  n=nCBTkn;
	  nCBTknD=nCBTkn;
	  nCNmIDD=nCNmID;
	  nCTpD=nCTp;
	  LCTp[nCTp]=0;
	  CbDocCheckCTp("Ignor");
	  LCTp[nCTp]=0;
	  CbDocCheckCTp("Systm");
	  LCTp[nCTp]=0;
	  CbDocCheckCTp("CbStr");
	  LCTp[nCTp]=0;
	  CbDocCheckCTp("CbExt");
	  LCTp[nCTp]=0;
	  CbDocCheckCTp("Undef");
	  if(CbDocFile2Bff(NmDF) > 0){
	    CbDocGetCStruct();
	    CbDocFileSetCNmID(n);
	  }
	  else{
	    strcpy(NmSD+LNmSD,NmDF+4);
	    if(CbDocFile2Bff(NmSD) > 0){
	      CbDocGetCStruct();
	      CbDocFileSetCNmID(n);
	    }
	    else{
	      nDTxt=0;
	      nCMMnt=0;
	      nHLWrd=0;
	      nSTRng=0;
	    }
	    NmSD[LNmSD]='\0';
	  }
	  CbDocCalCCommCID(0);
	  CbDocWriteTOC(0);
	}
	break;
      case 2:			/* .c.d-file */
      case 3:			/* .h.d-file */
      case 7:			/* .blb.d-file */
      case 9:			/* .mzl.d-file */
      case 11:			/* .stg.d-file */
      case 13:			/* .f.d-file */
	CbDocGetCStruct();
#ifdef H
	CbDocPrintTOC();
#endif
	CbDocWritePS();
	break;
      case 4:			/* .L- Listing file */
	CbDocGetLNmSF();
	for(iFile=0; iFile < nNmSF; iFile++){
	  pNmSF[iFile].n=nCBTkn;
	  n=nCBTkn;
	  kCNmID=nCNmID;
	  strcpy(NmSF,pNmSF[iFile].p);
	  CbDocInitFileNames();
	  if(CbDocFile2Bff(NmSF) > 0){
	    switch(Ixtn){
	    case 0:			/* .c-file */
	      CbDocGetCStruct();
	      CbDocSetCBTknTp(n);
	      CbDocFileSetCNmID(n);
	      CbDocWritePS();
	      break;
	    default:
	      break;
	    }
	    kCBF++;
	  }
	}

	CbDocPrintTOC();
	CbDocGlobalSetCNmID();
	if(DocWrt){
	  nCNmIDD=nCNmID;
	  nCTpD=nCTp;
	  nCBTknD=nCBTkn;
	  LCTp[nCTp]=0;
	  CbDocCheckCTp("Ignor");
	  LCTp[nCTp]=0;
	  CbDocCheckCTp("Systm");
	  LCTp[nCTp]=0;
	  CbDocCheckCTp("CbStr");
	  LCTp[nCTp]=0;
	  CbDocCheckCTp("CbExt");
	  LCTp[nCTp]=0;
	  CbDocCheckCTp("Undef");
	  for(iFile=0; iFile < nNmSF; iFile++){
	    n=pNmSF[iFile].n;
	    CbDocGlobalSetCNmUS(n);
	    strcpy(NmSF,pNmSF[iFile].p);
	    CbDocInitFileNames();
	    if(CbDocFile2Bff(NmDF) > 0){
	      CbDocGetCStruct();
	      CbDocSetCBTknTp(nCBTknD);
	      CbDocFileSetCNmID(nCBTknD);
	      kCBF++;
	    }
	    else{
	      strcpy(NmSD+LNmSD,NmDF+4);
	      if(CbDocFile2Bff(NmSD) > 0){
		CbDocGetCStruct();
		CbDocSetCBTknTp(nCBTknD);
		CbDocFileSetCNmID(nCBTknD);
		kCBF++;
	      }
	      else{
		nDTxt=0;
		nCMMnt=0;
		nHLWrd=0;
		nSTRng=0;
	      }
	      NmSD[LNmSD]='\0';
	    }
	    CbDocCalCCommCID(n);
	    CbDocWriteTOC(n);
	    nCNmID=nCNmIDD;
	    nCTp=nCTpD+dnCTpD+1;
	    nCBTkn=nCBTknD;
	  }
	}
	CbDocDeInitNmSF();
	break;
      case 5:			/* .Cb-file */
	break;
      case 6:			/* .blb-file */
      case 8:			/* .mzl-file */
      case 10:			/* .stg-file */
	nCNmIDD=nCNmID;
	CbDocGetCbStruct();
	CbDocSetCBTknTp(0);
	CbDocPrintTOC();
	CbDocWritePS();
	if(DocWrt){
	  n=nCBTkn;
	  nCBTknD=nCBTkn;
	  nCNmIDD=nCNmID;
	  nCTpD=nCTp;
	  LCTp[nCTp]=0;
	  CbDocCheckCTp("Ignor");
	  LCTp[nCTp]=0;
	  CbDocCheckCTp("Systm");
	  LCTp[nCTp]=0;
	  CbDocCheckCTp("CbStr");
	  LCTp[nCTp]=0;
	  CbDocCheckCTp("CbExt");
	  LCTp[nCTp]=0;
	  CbDocCheckCTp("Undef");
	  if(CbDocFile2Bff(NmDF) > 0){
	    CbDocGetCStruct();
	    CbDocFileSetCNmID(n);
	  }
	  else{
	    strcpy(NmSD+LNmSD,NmDF+4);
	    if(CbDocFile2Bff(NmSD) > 0){
	      CbDocGetCStruct();
	      CbDocFileSetCNmID(n);
	    }
	    else{
	      nDTxt=0;
	      nCMMnt=0;
	      nHLWrd=0;
	      nSTRng=0;
	    }
	    NmSD[LNmSD]='\0';
	  }
	  CbDocCalCCommCID(0);
	  CbDocWriteTOC(0);
	}
	break;
      case 12:			/* .f-file */
	break;
      default:
	break;
      }
      CbDocFreeCBTknNm();
    }
#endif
  }

#ifndef Stg_DeInit
  CbDeInitPObj();
  CbDeInitClstD();
  CbDeInitCbLn();
  CbDeInitCmmncO();
  CbDeInitCmmncC();
  CbDeInitCmmncS();

  CbDocDeInitFBff();
  CbDocDeInitFLn();
  CbDocDeInitCln();

  CbDocDeInitSTRng();
  CbDocDeInitHLWrd();
  CbDocDeInitCMMnt();
  CbDocDeInitDTxt();

  CbDocDeInitCNmUS();
  CbDocDeInitCNmID();
  CbDocDeInitCTp();
  CbDocDeInitCD();
  CbDocDeInitMzl();
  CbDocDeInitCBTkn();
  CbDocDeInitCBD();
  CbDocDeInitPRD();
#endif

#endif
  exit(0);
}
#endif
