#include <math.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

#ifndef mzl_DOC
typedef struct DOCTXT{
  int t;	/* Type of the Comment block */
  int kID;  	/* nCNmID*/
  int kCB;  	/* nCBTkn */
  int k0;	/* Starting line # in the file */
  int k1;	/* End line # in the file */
}DOCTXT;
typedef struct CMMNT{
  int t; /* Type of the Comment block */
  int kID;  /* nCNmID */
  int kCB;  /* nCBTkn */
  int k0; /* Starting line # in the file */
  int k1; /* End line # in the file */
  char *b; /* pointer to beginning of Comment block*/
  char *e; /* pointer to end of Comment block*/
}CMMNT;
typedef struct STRNG{
  int k0; /* Starting line # in the file */
  int k1; /* End line # in the file */
  char *b; /* pointer to beginning of String block*/
  char *e; /* pointer to end of String block*/
}STRNG;
extern struct tm *pTm;
extern int  NCMMnt,nCMMnt,iCMMnt;
extern CMMNT *CMMnt;
#endif

#ifndef mzl_C
typedef struct CNMID{
  int d;
  int t;
  int n;
  int L;
  int ID;
  int k;
  int kTxt;
  int kCMM;
  int kPg;
  char *p;
}CNMID;
extern CNMID *CNmID;
extern int NCNmID,nCNmID,*LCTp,nCTp,kCTp,NCNmUS,nCNmUS;
#endif

#ifndef mzl_CB
typedef struct ResWord{
  int L;
  char *p;
}ResWord;
typedef struct CBTKN{
  int L; /* Flag */
  int d; /* depth */
  int t; /* CbType */
  int f; /* File number */
  int k0; /* Starting line # in the file */
  int k1; /* End line # in the file */
  int kTxt; /* Doc Comment */
  int kCMM; /* C Comment */
  int kPg;  /* PS Page */
  int i0; /* Starting Global ID */
  int i1; /* Ending Global ID */
  int j0; /* Starting Global Used ID */
  int j1; /* Ending Global Used ID */
  char *Nm; /* pointer to Name*/
}CBTKN;

typedef struct CMMNCSECT{
  int t;
  int Tkn;
  int W;
  int L;
  char *F;
  char *Beg;
  char *End;
}CMMNCSECT;

typedef struct CMMNCOBJ{
  int t;	/* type */
  int L;	/* length of string */
  int d;	/* depth */
  int D;	/* dimension */
  int U;	/* Units set */
  int u;	/* unit in the set */
  char *Nm;	/* External name */
  char *C;	/* state of the cell */
  char *Bd;	/* body */
  char *Sc;	/* Name of the scale variable */
  char *S;	/* Name of the state variable */
}CMMNCOBJ;

typedef struct CMMNCCLST{
  int T;	/* type */
  int n;	/* dimension */
  int *k;	/* pointer to object */
  int *TO;	/* types of objects */
  char *Nm;	/* External name */
  char *C;	/* State of the Cell */
  char *S;	/* Name of the state variable */
}CMMNCCLST;

typedef struct POBJ{
  int T;	/* type */
  int t;	/* C-type */
  int L;	/* length of string */
  int d;	/* depth */
  int U;	/* Units set */
  int u;	/* unit in the set */
  int k;	/* pointer to object */
  char *Nm;	/* External name */
  char *C;	/* State of the Cell */
}POBJ;

extern int NCBTkn,nCBTkn;
extern CBTKN *CBTkn;
extern int kCBD,*kCB,iCBD,NCBD,*fCB;
extern int kCBF;

static int NCmmncS=0,nCmmncS=0;
static CMMNCSECT *CmmncS;

static int NCmmncO=0,nCmmncO=0;
static CMMNCOBJ *CmmncO;

static int NCmmncC=0,nCmmncC=0,kCmmncC,*ClstD,kClstD,nClstD=0,NClstD=0;
static CMMNCCLST *CmmncC;

static int NPObj=0,nPObj=0;
static POBJ *PObj; 

static int NCbResW=14,iCbResW,NCmmnOpt=5;
static ResWord CbResW[14]={
  3,"Tbl",
  3,"Hlp",
  3,"Plt",
  4,"ScrO",
  3,"BRc",
  3,"BSv",
  3,"BRd",
  3,"BWr",
  4,"BnrI",
  4,"BnrO",
  4,"AscI",
  4,"AscO",
  6,"Insert",
  6,"Delete"
};

static ResWord CmmnOpt[5]={
  1,"W",
  1,"L",
  1,"F",
  3,"Beg",
  3,"End"
};

static int iCD=0,nCD=0,iCDc=0,iCDr=0;
static int fDcl=0,NCbLn=0,nCbLn=0;
static char *CbLn;
static char *CW[10]={"str","dbl","int","flt","lng",
		       "fch","Dbl","Int","Flt","Lng"};
static int NCW=10,nCW,LCW,kCW,nU,iU;
#endif

#ifndef mzl_FILES

extern char NmF[81],NmSF[81];
extern int nFLn,iFLn,*fFLn,nFBff,kLnFL,LCln;
extern char *FBff,*Cln;

static int iFLnB=0;
#endif

#ifndef mzl_DOC
int CbFailureAlarm(char*p,char*RoutineName)
{
  if(p==NULL){
    printf("Failure in routine %s\n",RoutineName);
    exit(0);
  }
  return(0);
}

int CbReInitAray(void **p, int N, int n, int L)
{
  if(N < n){
    if(N){
      *p=(void*)realloc((void*)(*p),(size_t)(n*L));
    }
    else{
      *p=(void*)malloc((size_t)(n*L));
    }
    if(*p == NULL){
      CbFailureAlarm((char*)(*p),"CbReInitAray()- no memory for *p");
      return(-1);
    }
  }
  return(0);
}
#endif

#ifndef mzl_CB
#ifndef stg_Init
int CbReInitCbLn()
{
  if(NCbLn > nCbLn)
    return(0);
  if(CbReInitAray((void**)&CbLn,NCbLn,nCbLn+128,sizeof(char)) < 0)
    CbFailureAlarm((char*)CbLn,"CbReInitCbLn() - no memory for CbLn");
  NCbLn=nCbLn+128;
  return(0);
}

int CbDeInitCbLn()
{
  if(NCbLn){
    free(CbLn);
    NCbLn=0;
  }
  return(0);
}

int CbReInitClstD()
{
  if(NClstD > nClstD)
    return(0);
  if(CbReInitAray((void**)&ClstD,NClstD,nClstD+8,sizeof(int)) < 0)
    CbFailureAlarm((char*)ClstD,"CbReInitClstD() - no memory for ClstD");
  NClstD=nClstD+8;
  return(0);
}

int CbDeInitClstD()
{
  if(NClstD){
    free(ClstD);
    NClstD=0;
  }
  return(0);
}

int CbReInitCmmncO()
{
  if(NCmmncO > nCmmncO)
    return(0);
  if(CbReInitAray((void**)&CmmncO,NCmmncO,nCmmncO+64,sizeof(CMMNCOBJ)) < 0)
    CbFailureAlarm((char*)CmmncO,"CbReInitCmmncO() - no memory for CmmncO");
  NCmmncO=nCmmncO+64;
  return(0);
}

int CbDeInitCmmncO()
{
  int i;
  if(NCmmncO){
    for(i=0; i < nCmmncO; i++){
      if(CmmncO[i].Nm != NULL)
	free(CmmncO[i].Nm);
      if(CmmncO[i].C != NULL)
	free(CmmncO[i].C);
      if(CmmncO[i].Bd != NULL)
	free(CmmncO[i].Bd);
      if(CmmncO[i].Sc != NULL)
	free(CmmncO[i].Sc);
      if(CmmncO[i].S != NULL)
	free(CmmncO[i].S);
    }
    free(CmmncO);
    NCmmncO=0;
  }
  return(0);
}

int CbReInitCmmncC()
{
  if(NCmmncC > nCmmncC)
    return(0);
  if(CbReInitAray((void**)&CmmncC,NCmmncC,nCmmncC+32,sizeof(CMMNCCLST)) < 0)
    CbFailureAlarm((char*)CmmncC,"CbReInitCmmncC() - no memory for CmmncC");
  NCmmncC=nCmmncC+32;
  return(0);
}

int CbDeInitCmmncC()
{
  int i;
  if(NCmmncC){
    for(i=0; i < nCmmncC; i++){
      if(CmmncC[i].Nm != NULL)
	free(CmmncC[i].Nm);
      if(CmmncC[i].k != NULL)
	free(CmmncC[i].k);
      if(CmmncC[i].TO != NULL)
	free(CmmncC[i].TO);
    }
    free(CmmncC);
    NCmmncC=0;
  }
  return(0);
}

int CbReInitCmmncS()
{
  if(NCmmncS > nCmmncS)
    return(0);
  if(CbReInitAray((void**)&CmmncS,NCmmncS,nCmmncS+32,sizeof(CMMNCSECT)) < 0)
    CbFailureAlarm((char*)CmmncS,"CbReInitCmmncS() - no memory for CmmncS");
  NCmmncS=nCmmncS+32;
  return(0);
}

int CbDeInitCmmncS()
{
  int i;
  if(NCmmncS){
    for(i=0; i < nCmmncS; i++){
      if(CmmncS[i].F != NULL)
	free(CmmncS[i].F);
      if(CmmncS[i].Beg != NULL)
	free(CmmncS[i].Beg);
      if(CmmncS[i].End != NULL)
	free(CmmncS[i].End);
    }
    free(CmmncS);
    NCmmncS=0;
  }
  return(0);
}

int CbReInitPObj()
{
  if(NPObj > nPObj)
    return(0);
  if(CbReInitAray((void**)&PObj,NPObj,nPObj+32,sizeof(POBJ)) < 0)
    CbFailureAlarm((char*)PObj,"CbReInitPObj() - no memory for PObj");
  NPObj=nPObj+32;
  return(0);
}

int CbDeInitPObj()
{
  int i;
  if(NPObj){
    free(PObj);
    NPObj=0;
  }
  return(0);
}
#endif

#ifndef stg_CommObj
int CbGetCommObjUnits(char *S)
{
  char *s,*t,ch;
  int i;

  nU	=0;
  iU	=0;
  s	=S;
  t	=s;
  while(*t != '.' && *t != '\0'){
    t++;
  }
  if(*t != '.'){
    printf("Error at %d: absent '.' in Units in %s section in%c\n"
	   ,kLnFL,CbResW[iCbResW].p,7);
    printf("%s\n",Cln);
    exit(0);
  }
  *t	='\0';

  *t++	='.';
  s	=t;
  while(*t != ')' && *t != '\0'){
    t++;
  }
  ch	=*t;
  *t	='\0';

  *t	=ch;
  return((int)(t-S-1));
}

int CbGetCellChar(char *S)
{
  char *s;
  
  s	=S;
  if(*s != '"'){
    printf("Error at %d: absent '\"' in Cell state in %s section in%c\n"
	   ,kLnFL,CbResW[iCbResW].p,7);
    printf("%s\n",Cln);
    exit(0);
  } 
  s++;
  while(*s != '"' && *s != '\0'){
    s++;
  }
  if(*s != '"'){
    printf("Error at %d: absent second '\"' in Cell state in %s section in%c\n"
	   ,kLnFL,CbResW[iCbResW].p,7);
    printf("%s\n",Cln);
    exit(0);
  }
  return((int)(s-S-1));
}

int CbGetCommObjType(char *S)
{
  char *s;
  int i;

  s	=S;
  for(i=0; i < NCW; i++){
    if(strncmp(s,CW[i],3) == 0){
      break;
    }
  }
  if(i < NCW){
    nCW=i;
    s +=3;
    if(*s == '*'){
      s++;
      LCW	=0;
      if(i == 0 || i == 5){
	sscanf(s,"%d",&LCW);
	if(LCW == 0){
	  printf("Error at %d: absent length of %s object in %s section in%c\n"
		 ,kLnFL,CW[i],CbResW[iCbResW].p,7);
	  printf("%s\n",Cln);
	  exit(0);
	}
	while(isdigit(*s)){
	  s++;
	}
      }
    }
    else{
      if(i == 0 || i == 5){
	printf("Error at %d: Absent '*' in %s object in %s section in%c\n"
	       ,kLnFL,CW[i],CbResW[iCbResW].p,7);
	printf("%s\n",Cln);
	exit(0);
      }
    }
  }
  else{
    printf("Error at %d: Wrong type of object in %s section in%c\n"
	   ,kLnFL,CbResW[iCbResW].p,7);
    printf("%s\n",Cln);
    exit(0);
  }
  return((int)(s-S-1));
}
#endif

int CbDocTypeCbLn(char *S)
{
  char *s;

  s	=S;
  while(isspace(*s) || (*s == '\\' && *(s+1) == '\n')){
    s++;
  }
  if(iCBD){
    if(*s == '#')
      return(2);
    else
      return(3);
  }
  for(iCbResW=0; iCbResW < NCbResW; iCbResW++){
    if(strncmp(s,CbResW[iCbResW].p,CbResW[iCbResW].L) == 0)
      break;
  }
  if(iCbResW < NCbResW){
    iFLnB	=iFLn;
    switch(iCbResW){
    case 0:
    case 1:
    case 2:
      CbDocCheckCTp("CbGUI");
      break;
    case 3:
      CbDocCheckCTp("CbPlt");
      break;
    case 4:
    case 6:
    case 8:
    case 10:
      CbDocCheckCTp("CbInp");
      break;
    case 5:
      CbDocCheckCTp("CbI/O");
      break;
    case 7:
    case 9:
    case 11:
      CbDocCheckCTp("CbOut");
      break;
    case 12:
    case 13:
      CbDocCheckCTp("CbPrg");
      break;
    }
    nPObj	=0;;
    fDcl	=0;
    nClstD	=0;
    return(0);
  }
  else{
    return(1);
  }
}

int CbDocCbGetSectOption(char *S)
{
  char *s,*t,*p;
  int i,k;

  s	=S+1;
  while(*s != ')' &&  *s != '{' &&  *s != '\0'){
    while(isspace(*s) || (*s == '\\' && *(s+1) == '\n')){
      if(*s == '\n'){
	kLnFL++;
	iFLn++;
      }
      s++;
    }
    if(*s == ')')
      break;
    for(i=0; i < NCmmnOpt; i++){
      if(strncmp(s,CmmnOpt[i].p,CmmnOpt[i].L) == 0){
	break;
      }
    }
    if(i < NCmmnOpt){
      s +=CmmnOpt[i].L;
      while(isspace(*s) || (*s == '\\' && *(s+1) == '\n')){
	if(*s == '\n'){
	  kLnFL++;
	  iFLn++;
	}
	s++;
      }
      if(*s != '='){
	i=NCmmnOpt;
      }
      else{
	s++;
	while(isspace(*s) || (*s == '\\' && *(s+1) == '\n')){
	  if(*s == '\n'){
	    kLnFL++;
	    iFLn++;
	  }
	  s++;
	}
      }
    }
    switch(i){
    case 0:
      p=s;
      while(isdigit(*p))
	p++;
      sscanf(s,"%d",&k);
      if(k < 0){
	printf("Error at %d: Value of %s-option in %s section\n"
	       ,kLnFL,CmmnOpt[i].p,CbResW[iCbResW].p);
	printf("cannot be negative%c\n",7);
	exit(0);
      }
      CmmncS[nCmmncS].W=k;
      s=p;
      break;
    case 1:
      p=s;
      while(isdigit(*p))
	p++;
      sscanf(s,"%d",&k);
      if(k < 0){
	printf("Error at %d: Value of %s-option in %s section\n"
	       ,kLnFL,CmmnOpt[i].p,CbResW[iCbResW].p);
	printf("cannot be negative%c\n",7);
	exit(0);
      }
      CmmncS[nCmmncS].L=k;
      s=p;
      break;
    case 2:
      p=s;
      if(*p != '"'){
	printf("Error at %d: No \" in %s-option value in %s section%c\n"
	       ,kLnFL,CmmnOpt[i].p,CbResW[iCbResW].p,7);
	exit(0);
      }
      do{
	p++;
      }while(*p != '"');
      k=p-s;
      CmmncS[nCmmncS].F=(char*)malloc(k*sizeof(char));
      s++;
      t=CmmncS[nCmmncS].F;
      while(s < p){
	*t++=*s++;
      }
      *t='\0';
      s++;
      break;
    case 3:
      p=s;
      if(*p != '"'){
	printf("Error at %d: No \" in %s-option value in %s section%c\n"
	       ,kLnFL,CmmnOpt[i].p,CbResW[iCbResW].p,7);
	exit(0);
      }
      do{
	p++;
      }while(*p != '"');
      k=p-s;
      CmmncS[nCmmncS].Beg=(char*)malloc(k*sizeof(char));
      s++;
      t=CmmncS[nCmmncS].Beg;
      while(s < p){
	*t++=*s++;
      }
      *t='\0';
      s++;
      break;
    case 4:
      p=s;
      if(*p != '"'){
	printf("Error at %d: No \" in %s-option value in %s section%c\n"
	       ,kLnFL,CmmnOpt[i].p,CbResW[iCbResW].p,7);
	exit(0);
      }
      do{
	p++;
      }while(*p != '"');
      k=p-s;
      CmmncS[nCmmncS].End=(char*)malloc(k*sizeof(char));
      s++;
      t=CmmncS[nCmmncS].End;
      while(s < p){
	*t++=*s++;
      }
      *t='\0';
      s++;
      break;
    default:
      printf("Error at %d: Wrong option in %s section. Use one of%c\n"
	     ,kLnFL,CbResW[iCbResW].p,7);
      for(i=0; i < NCmmnOpt; i++){
	printf("%s\n",CmmnOpt[i].p);
      }
      exit(0);
    }
    if(*s != ',' && *s != ')'){
      printf("Error at %d: Wrong %s-option in %s section.%c\n"
	     ,kLnFL,CmmnOpt[i].p,CbResW[iCbResW].p,7);
      exit(0);
    }
    if(*s == ')')
      break;
    s++;
  }
  if(*s != ')'){
    printf("Error at %d: absent ')' in %s section in the option list%c\n"
	   ,kLnFL,CbResW[iCbResW].p,7);
    return(-1);
  }
  else{
    return((int)(s-S));
  }
}

int CbDocCbCmmnTypes(char *S)
{
  static int i,L;
  static char *p,*p1,*p2;
  static CNMID *pC;

  p	=S;
  while(isspace(*p) || (*p == '\\' && *(p+1) == '\n')){
    if(*p == '\n'){
      kLnFL++;
      iFLn++;
    }
    p++;
  }
  if(nCmmncS == NCmmncS){
    CbReInitCmmncS();
  }
  CmmncS[nCmmncS].t	=iCbResW;
  CmmncS[nCmmncS].Tkn	=nCBTkn;
  CmmncS[nCmmncS].W	=1;
  CmmncS[nCmmncS].L	=0;
  CmmncS[nCmmncS].F	=NULL;
  CmmncS[nCmmncS].Beg	=NULL;
  CmmncS[nCmmncS].End	=NULL;
  p +=CbResW[iCbResW].L;

  while(isspace(*p) || (*p == '\\' && *(p+1) == '\n')){
    if(*p == '\n'){
      kLnFL++;
      iFLn++;
    }
    p++;
  }
  if(*p == '('){
    i	=CbDocCbGetSectOption(p);
    if(i < 0){
      exit(0);
    }
    p	+=i+1;
    while(isspace(*p) || (*p == '\\' && *(p+1) == '\n')){
      if(*p == '\n'){
	kLnFL++;
	iFLn++;
      }
      p++;
    }
  }
  if(*p != '{'){
    printf("Error at %d: no starting '{' in %s section%c\n"
	   ,kLnFL,CbResW[iCbResW].p,7);
    exit(0);
  }

  L	=strlen(NmF)+CbResW[iCbResW].L+1;
  if(L > 31)
    L=31;
  pC=CNmID+nCNmID;
  sprintf(pC->p,"%s_",CbResW[iCbResW].p);
  i	=CbResW[iCbResW].L+1;
  p1	=pC->p+i;
  p2	=NmF;
  while(*p2 != '.' && *p2 != '\0' && i < L){
    *p1++	=*p2++;
    i++;
  }
  *p1	='\0';
  pC->kTxt=-1;
  pC->kCMM=-1;
  i	=kCB[kCBD];
  pC->kPg=-1;
  pC->t	=0x200000|0x410000;	/* stt fn lcf */
  pC->ID=nCNmID;
  pC->n	=kCTp;
  fFLn[iFLn] |=(nCNmID<<16)|iCBD;
  iFLnB	=iFLn;
  pC->d	=(i<<16)|(iCD<<8)|(CBTkn[i].t&0xFF);
  pC->L	=0;

  fFLn[iFLnB] |=0xC000;
  iCBD++;
  if(iCBD == NCBD){
    CbDocReInitCBD();
  }
  fCB[iCBD]=0x40C00000|(iCBD < 0x40FF ? (iCBD<<8) : 0x3FFF00);
  kCBD++;
  kCB[kCBD]=nCBTkn;
  CBTkn[nCBTkn].f=kCBF;
  CBTkn[nCBTkn].L=L;
  CBTkn[nCBTkn].Nm=(char*)malloc((size_t)(L+1)*sizeof(char));
  strcpy(CBTkn[nCBTkn].Nm,pC->p);
  CBTkn[nCBTkn].L<<=24;
  CBTkn[nCBTkn].t =0x0100;
  CBTkn[nCBTkn].L |=fCB[iCBD];
  CBTkn[nCBTkn].d =kCBD ? (kCB[kCBD-1]<<16)|kCBD : kCBD;
  CBTkn[nCBTkn].k0 =iFLnB;
  CBTkn[nCBTkn].kTxt =-1;
  CBTkn[nCBTkn].kCMM =-1;
  CBTkn[nCBTkn].kPg =-1;
  CBTkn[nCBTkn].i0 =nCNmID;
  CBTkn[nCBTkn].j0 =nCNmUS;
  nCBTkn++;
  if(nCBTkn == NCBTkn){
    CbDocReInitCBTkn();
  }
  nCNmID++;
  if(nCNmID >= NCNmID){
    CbDocReInitCNmID();
    pC	=CNmID+nCNmID-1;
  }
  if(iCD == 0){
    LCTp[nCTp]=0;
    kCTp=-1;
  }
  nCmmncS++;
  return((int)(p-S));
}

int CbDocSkipCbln(char *S)
{
  char *s;

  s	=S;
  while(*s != '\n' && *s != '\0'){
    if(*s == '\\' && *(s+1) == '\n'){
      kLnFL++;
      iFLn++;
      s++;
    }
    s++;
  }
  if(*s == '\n'){
    kLnFL++;
    iFLn++;
    return((int)(s-S+1));
  }
  else{
    return((int)(s-S));
  }
}

int CbDocGetCbln(char *S)
{
  int i,j,k;
  char *p,*s,*t;
  
  s=S;
  p=Cln;
  while(*s != '\0'){
    while(*s == '\\' && *(s+1) == '\n'){
      kLnFL++;
      s+=2;
    }
    switch(*s){
    case '\0':
      *p='\0';
      return((int)(s-S));
    case '\n':
      if(p > Cln && *(p-1) == ' '){
	p--;
      }
      *p='\0';
      kLnFL++;
      return((int)(s-S+1));
    case ' ':
    case '\t':
    case '\v':
      s++;
      break;
    case '/':
      if(nCMMnt >= NCMMnt){
	CbDocReInitCMMnt();
      }
      CMMnt[nCMMnt].k0=kLnFL;
      t=s;
      s++;
      while(*s == '\\' && *(s+1) == '\n'){
	kLnFL++;
	s+=2;
      }
      if(*s == '*'){ /*Inside Comment */
	i=kCB[kCBD];
	CMMnt[nCMMnt].kID=-1;
	CMMnt[nCMMnt].kCB=i;
	CMMnt[nCMMnt].b=t;
	if(CBTkn[i].kCMM < 0)
	  CBTkn[i].kCMM=nCMMnt;
	CMMnt[nCMMnt].k1=nFLn;
	CMMnt[nCMMnt].e=FBff+nFBff;
	s++;
	while(*s == '\\' && *(s+1) == '\n'){
	  kLnFL++;
	  s+=2;
	}
	if(*s == '\0'){
	  *p='\0';
	  printf("Error at %d: zero char inside comment%c\n"
		 ,CMMnt[nCMMnt].k0,7);
	  return((int)(s-S));
	}
	if(*s == '\n'){
	  kLnFL++;
	}
	t=s;
	while(*s != '/' || *t != '*'){
	  t=s;
	  s++;
	  while(*s == '\\' && *(s+1) == '\n'){
	    kLnFL++;
	    s+=2;
	  }
	  if(*s == '\0'){
	    *p='\0';
	    printf("Error at %d: zero char inside comment%c\n"
		   ,CMMnt[nCMMnt].k0,7);
	    return((int)(s-S));
	  }
	  if(*s == '\n'){
	    kLnFL++;
	  }
	}
	CMMnt[nCMMnt].t=2;
	CMMnt[nCMMnt].k1=kLnFL;
	CMMnt[nCMMnt].e=s+1;
	nCMMnt++;
	s++;
      }
      else{
	*p++='/';
      }
      break;
    case '\'':
      k=kLnFL;
      *p++=*s++;
      while(*s == '\\' && *(s+1) == '\n'){
	kLnFL++;
	s+=2;
      }
      if(*s == '\0'){
	*p='\0';
	printf("Error at %d: zero char inside character constant%c\n",k,7);
	return((int)(s-S));
      }
      if(*s == '\n'){
	kLnFL++;
      }
      i=0;
      j=0;
      while(i == 0){
	if(*s == '\\' && j == 0){
	  j=1;
	}
	else{
	  j=0;
	}
	if(j == 0)
	  i++;
	*p++=*s++;
	while(*s == '\\' && *(s+1) == '\n'){
	  kLnFL++;
	  s+=2;
	}
	if(*s == '\0'){
	  *p='\0';
	  printf("Error at %d: zero char inside character constant%c\n",k,7);
	  return((int)(s-S));
	}
	if(*s == '\n'){
	  kLnFL++;
	}
      }
      if(i == 1 && *s !='\''){
	printf("Error at %d: wrong character constant%c\n",k,7);
	break;
      }
      *p++=*s++;
      break;
    case '"':
      *p++=*s++;
      while(*s == '\\' && *(s+1) == '\n'){
	kLnFL++;
	s+=2;
      }
      if(*s == '\0'){
	*p='\0';
	printf("Error at %d:  zero char inside string constant%c\n"
	       ,kLnFL,7);
	return((int)(s-S));
      }
      if(*s == '\n'){
	kLnFL++;
      }
      t	=s;
      while(*s != '"' || *t == '\\'){
	t=s;
	*p++=*s++;
	i=p-Cln;
	if(i >= LCln){
	  CbDocReInitCln();
	  p=Cln+i;
	}
	while(*s == '\\' && *(s+1) == '\n'){
	  kLnFL++;
	  s+=2;
	}
	if(*s == '\0'){
	  *p='\0';
	  printf("Error at %d: zero char inside string constant%c\n"
		 ,kLnFL,7);
	  return((int)(s-S));
	}
	if(*s == '\n'){
	  kLnFL++;
	}
      }
      *p++=*s++;
      break;
    case ';':
      *p++=*s++;
      if(iCbResW == 1){
	if(nCMMnt >= NCMMnt){
	  CbDocReInitCMMnt();
	}
	CMMnt[nCMMnt].k0=kLnFL;
	t=s;
	i=kCB[kCBD];
	CMMnt[nCMMnt].kID=-1;
	CMMnt[nCMMnt].kCB=i;
	CMMnt[nCMMnt].b=t;
	if(CBTkn[i].kCMM < 0)
	  CBTkn[i].kCMM=nCMMnt;
	CMMnt[nCMMnt].k1=nFLn;
	CMMnt[nCMMnt].e=FBff+nFBff;
	while((*t != '\\' || *s != ';') && *s != '\0'){
	  if(*s == '\n'){
	    kLnFL++;
	  }
	  t=s;
	  s++;
	}
	if(*s == '\0'){
	  *p='\0';
	  printf("Error at %d: zero char inside comment%c\n"
		 ,CMMnt[nCMMnt].k0,7);
	  return((int)(s-S));
	}
	CMMnt[nCMMnt].t=3;
	CMMnt[nCMMnt].k1=kLnFL;
	CMMnt[nCMMnt].e=t;
	nCMMnt++;
	s++;
      }
      break;
    default :
      *p++=*s++;
      break;
    }
    i=p-Cln;
    if(i+3 >= LCln){
      CbDocReInitCln();
      p=Cln+i;
    }
  }
  *p='\0';
  return((int)(s-S));
}

int CbDocCbCommObj()
{
  int i,L,ic;
  char *p,*p1;
  POBJ *pP;
  CMMNCCLST *pC; 
  CMMNCOBJ *pO; 


  p	=Cln;
  if(*p == '\0')
    return(0);
  while(*p != '\0'){
    switch(fDcl){
    case 0:
      switch(*p){
      case '{':
	if(iCD && iCD < 0x40){
	  fFLn[iFLn] |=0xC000|(iCD<<8)|iCBD;
	}
	iCD++;
	pP	=PObj+nPObj;
	pP->T	=1;
	pP->t	=-1;
	pP->L	=0;
	pP->d	=nClstD;
	pP->U	=-1;
	pP->u	=0;
	pP->k	=nCmmncC;
	pP->Nm	=NULL;
	pP->C	=NULL;
	nPObj++;
	if(nPObj >= NPObj){
	  CbReInitPObj();
	  pP	=PObj+nPObj;
	}
	ClstD[nClstD]	=nPObj;
	nClstD++;
	if(nClstD >= NClstD){
	  CbReInitClstD();
	}
	nCmmncC++;
	if(nCmmncC >= NCmmncC){
	  CbReInitCmmncC();
	}
	break;
      case '"':
	p1	=CbLn;
	*p1++	=*p;
	nCbLn	=1;
	pP	=PObj+nPObj;
	pP->T	=0;
	pP->t	=-1;
	pP->L	=0;
	pP->d	=nClstD;
	pP->U	=-1;
	pP->u	=0;
	pP->k	=nCmmncO;
	pP->Nm	=NULL;
	pP->C	=NULL;
	fDcl	=1;
	break;
      case '}':
	iCD--;
	if(iCD < 0){
	  printf("Error at %d: extra '}'%c\n",kLnFL,7);
	}
	if(nClstD){
	  i	=nPObj-1;
	  while(PObj[i].d == nClstD){
	    i--;
	  }
	  L	=nPObj-i-1;
	  nClstD--;
	  pC	=CmmncC+PObj[ClstD[nClstD]].k;
	  pC->T	=PObj[i].T;
	  pC->n	=L;
	  pC->k	=(int*)malloc(L*sizeof(int));
	  pC->Nm=PObj[i].Nm;
	  pC->C	=PObj[i].C;
	  pC->S	=NULL;
	  PObj[i].Nm	=NULL;
	  PObj[i].C	=NULL;
	  L	=0;
	  i++;
	  while(i < nPObj){
	    pC->TO[L]	=PObj[i].T;
	    pC->k[L]	=PObj[i].k;
	    i++;
	    L++;
	  }
	  nPObj	-=L;
	  fDcl	=18;
	}
	if(iCD == 0){
	  i	=kCB[kCBD];
	  if(nCBTkn == i+1)
	    CBTkn[i].t=0x0102;
	  CBTkn[i].k1=iFLn;
	  CBTkn[i].i1 =-1;
	  CBTkn[i].j1 =-1;
	  kCBD--;
	  iCBD--;
	  if((CBTkn[i].t&0xFF) == 0){
	    if((fCB[iCBD]&0x7F) != 1){
	      printf("Cb Error at %d: %s should be inside mzl_%c\n"
		     ,iFLn+1,CBTkn[i].Nm,7);
	    }
	    if(iCBD%2 == 0){
	      printf("Cb Error at %d: %s has wrong nestness %d%c\n"
		     ,iFLn+1,CBTkn[i].Nm,iCBD+1,7);
	    }
	  }
	  if(iCBD < 0 || kCBD < 0){
	    printf("Error: more Cb #endif's than #ifndef's%c\n",7);
	    iCBD=0;
	    kCBD=0;
	  }
	  fFLn[iFLn] |=0x4000|(iCD<<8)|iCBD;
	  return(0);
	}
	if(iCD < 0x40){
	  fFLn[iFLn] |=0x4000|(iCD<<8)|iCBD;
	}
	break;
      default:
	i	=NCbResW-2;
	if(strncmp(p,CbResW[i].p,CbResW[i].L) == 0){
	  p	+=CbResW[i].L;
	  ic	=0;
	  fDcl	=21;
	  break;
	}
	i++;
	if(strncmp(p,CbResW[i].p,CbResW[i].L) == 0){
	  p	+=CbResW[i].L;
	  fDcl	=22;
	  break;
	}
      }
      break;
    case 1:
      *p1++	=*p;
      nCbLn++;
      if(nCbLn >= NCbLn)
	CbReInitCbLn();
      if(*p == '"'){
	L	=p1-Cln;
	PObj[nPObj].Nm=(char*)malloc((size_t)(L+1)*sizeof(char));
	*p1	='\0';
	strcpy(PObj[nPObj].Nm,CbLn);
	p1	=CbLn;
	nCbLn	=0;
	ic	=0;
	fDcl	=2;
      }
      break;
    case 2:
      switch(*p){
      case ',':
	if(ic){
	  printf("Warning at %d: Extra ',' after name %c\n",kLnFL,7);
	  printf("<%s>\n",Cln);
	}
	ic++;
	break;
      case '(':
	fDcl	=3;
	break;
      case '"':
	L	=CbGetCellChar(p);
	p1	=(char*)malloc(L*sizeof(char));
	p++;
	L--;
	strncpy(p1,p,L);
	*(p1+L)	='\0';
	PObj[nPObj].C	=p1;
	p	+=L;
	ic	=0;
	fDcl	=6;
	break;
      case '=':
	if(ic){
	  printf("Warning at %d: Extra ',' before '=' %c\n",kLnFL,7);
	  printf("<%s>\n",Cln);
	}
	fDcl	=7;
	break;
      default:
	printf("Error at %d: '%c' cannot be at this place in%c\n",kLnFL,*p,7);
	printf("<%s>\n",Cln);
	exit(0);
	break;
      }
      break;
    case 3:
      p			+=CbGetCommObjUnits(p);
      PObj[nPObj].U	=nU;
      PObj[nPObj].u	=iU;
      fDcl	=4;
      break;
    case 4:
      if(*p != ')'){
	printf("Error at %d: Absent ')' after units in%c%c\n",kLnFL,*p,7);
	printf("<%s>\n",Cln);
	exit(0);
      }
      ic	=0;
      fDcl	=5;
      break;
    case 5:
      switch(*p){
      case ',':
	if(ic){
	  printf("Warning at %d: Extra ',' after name %c\n",kLnFL,7);
	  printf("<%s>\n",Cln);
	}
	ic++;
	break;
      case '"':
	L	=CbGetCellChar(p);
	p1	=(char*)malloc(L*sizeof(char));
	p++;
	L--;
	strncpy(p1,p,L);
	*(p1+L)	='\0';
	PObj[nPObj].C	=p1;
	p	+=L;
	ic	=0;
	fDcl	=6;
	break;
      case '=':
	if(ic){
	  printf("Warning at %d: Extra ',' before '=' %c\n",kLnFL,7);
	  printf("<%s>\n",Cln);
	}
	fDcl	=7;
	break;
      default:
	printf("Error at %d: '%c' cannot be at this place in%c\n",kLnFL,*p,7);
	printf("<%s>\n",Cln);
	exit(0);
      }
      break;
    case 6:
      switch(*p){
      case '=':
	if(ic){
	  printf("Warning at %d: Extra ',' before '=' %c\n",kLnFL,7);
	  printf("<%s>\n",Cln);
	}
	fDcl	=7;
	break;
      default:
	printf("Error at %d: '%c' cannot be at this place in%c\n",kLnFL,*p,7);
	printf("<%s>\n",Cln);
	exit(0);
	break;
      }
      break;
    case 7:
      switch(*p){
      case '(':
	fDcl	=8;
	break;
      case '{':
	iCD++;
	PObj[nPObj].T	=2;
	PObj[nPObj].k	=nCmmncC;
	kCmmncC		=nCmmncC;
	ClstD[nClstD]	=nCmmncC;
	nClstD++;
	if(nClstD >= NClstD){
	  CbReInitClstD();
	}
	nCmmncC++;
	if(nCmmncC >= NCmmncC){
	  CbReInitCmmncC();
	}
	nPObj++;
	if(nPObj >= NPObj)
	  CbReInitPObj();
	fDcl	=0;
	break;
      default:
	printf("Error at %d: '%c' cannot be at this place in%c\n",kLnFL,*p,7);
	printf("<%s>\n",Cln);
	exit(0);
	break;
      }
      break;
    case 8:
      p	+=CbGetCommObjType(p);
      PObj[nPObj].t	=nCW;
      PObj[nPObj].L	=LCW;
      fDcl	=9;
      break;
    case 9:
      if(*p != ')'){
	printf("Error at %d: ')' should be after the object type in%c\n"
	       ,kLnFL,7);
	printf("<%s>\n",Cln);
	exit(0);
      }
      fDcl	=10;
      break;
    case 10:
      switch(*p){
      case '(':
	fDcl	=11;
	pO	=CmmncO+nCmmncO;
	pO->t	=PObj[nPObj].t;
	pO->L	=PObj[nPObj].L;
	pO->d	=PObj[nPObj].d;
	pO->U	=PObj[nPObj].U;
	pO->u	=PObj[nPObj].u;
	pO->Nm	=PObj[nPObj].Nm;
	pO->C	=PObj[nPObj].C;
	pO->Sc	=NULL;
	pO->S	=NULL;
	p1	=CbLn;
	nCbLn	=0;
	break;
      case '{':
	iCD++;
	PObj[nPObj].T	=2;
	PObj[nPObj].k	=nCmmncC;
	kCmmncC		=nCmmncC;
	ClstD[nClstD]	=nCmmncC;
	nClstD++;
	if(nClstD >= NClstD){
	  CbReInitClstD();
	}
	nCmmncC++;
	if(nCmmncC >= NCmmncC){
	  CbReInitCmmncC();
	}
	nPObj++;
	if(nPObj >= NPObj)
	  CbReInitPObj();
	fDcl	=0;
	break;
      default:
	printf("Error at %d: '%c' cannot be at this place in%c\n",kLnFL,*p,7);
	printf("<%s>\n",Cln);
	exit(0);
	break;
      }
      break;
    case 11:
      *p1++	=*p;
      nCbLn++;
      if(nCbLn >= NCbLn)
	CbReInitCbLn();
      if(*p1 == ')'){
	L	=p1-CbLn;
	CmmncO[nCmmncO].Bd	=(char*)malloc((L+1)*sizeof(char));
	*p1	='\0';
	strcpy(CmmncO[nCmmncO].Bd,p1);
	ic	=0;
	fDcl	=13;
      }
      break;
    case 13:
      switch(*p){
      case '*':
	fDcl	=14;
	p1	=CbLn;
	nCbLn	=0;
	break;
      case ',':
	if(ic){
	  printf("Warning at %d: Extra ',' after object description %c\n"
		 ,kLnFL,7);
	  printf("<%s>\n",Cln);
	}
	ic++;
	break;
      case '(':
	fDcl	=16;
	p1	=CbLn;
	nCbLn	=0;
	break;
      case ';':
	nPObj++;
	if(nPObj >= NPObj)
	  CbReInitPObj();
	fDcl	=0;
	break;
      default:
	printf("Error at %d: '%c' cannot be at this place in%c\n",kLnFL,*p,7);
	printf("<%s>\n",Cln);
	exit(0);
	break;
      }
    case 14:
#ifdef H
      L	=CbGetScaleName(p);
#endif
      p1	=(char*)malloc((L+1)*sizeof(char));
      CmmncO[nCmmncO].Sc	=p1;
      strncpy(p1,p,L);
      p	+=L;
      fDcl	=15;
      ic	=0;
      break;
    case 15:
      switch(*p){
      case ',':
	if(ic){
	  printf("Warning at %d: Extra ',' after object description %c\n"
		 ,kLnFL,7);
	  printf("<%s>\n",Cln);
	}
	ic++;
	break;
      case '(':
	fDcl	=16;
	p1	=CbLn;
	nCbLn	=0;
	break;
      case ';':
	nPObj++;
	if(nPObj >= NPObj)
	  CbReInitPObj();
	fDcl	=0;
	break;
      default:
	printf("Error at %d: '%c' cannot be at this place in%c\n",kLnFL,*p,7);
	printf("<%s>\n",Cln);
	exit(0);
	break;
      }
      break;
    case 16:
      *p1++	=*p;
      nCbLn++;
      if(nCbLn >= NCbLn)
	CbReInitCbLn();
      if(*p1 == ')'){
	L	=p1-CbLn;
	CmmncO[nCmmncO].S	=(char*)malloc((L+1)*sizeof(char));
	strcpy(CmmncO[nCmmncO].S,CbLn);
	fDcl	=17;
	ic	=0;
      }
      break;
    case 17:
      switch(*p){
      case ';':
	nPObj++;
	if(nPObj >= NPObj)
	  CbReInitPObj();
	nCmmncO++;
	if(nCmmncO >= NCmmncO)
	  CbReInitCmmncO();
	fDcl	=0;
	break;
      default:
	printf("Error at %d: '%c' cannot be at this place in%c\n",kLnFL,*p,7);
	printf("<%s>\n",Cln);
	exit(0);
	break;
      }
      break;
    case 18:	/* Name of the state variable */
      if(*p == '('){
	fDcl	=19;
	p1	=CbLn;
	nCbLn	=0;
      }
      else{
	p--;
	fDcl	=0;
      }
      break;
    case 19:	/* Name of the state variable */
      *p1++	=*p;
      if(*p1 == ')'){
	*p1	='\0';
	L	=p1-CbLn;
	pC->S	=(char*)malloc((L+1)*sizeof(char));
	strcpy(pC->S,CbLn);
	fDcl	=20;
      }
      break;
    case 20:
      if(*p != ';'){
	printf("Error at %d: ';' should be after (%s) in%c\n"
	       ,kLnFL,CbLn,7);
	printf("<%s>\n",Cln);
	exit(0);
      }
      fDcl	=0;
      break;
    case 21:	/* Insert */
      if(*p == '{'){
	ic++;
      }
      if(*p == '}'){
	ic--;
	if(ic == 0){
	  fDcl	=0;
	}
      }
      break;
    case 22:	/* Delete */
      if(*p != '('){
	printf("Error at %d: '(' should be after \"Delete\" in%c\n"
	       ,kLnFL,7);
	printf("<%s>\n",Cln);
	exit(0);
      }
      if(*p == ')'){
	fDcl	=23;
      }
      break;
    case 23:	/* Delete */
      if(*p != ';'){
	printf("Error at %d: ';' should be in the end of \"Delete\" in%c\n"
	       ,kLnFL,7);
	printf("<%s>\n",Cln);
	exit(0);
      }
      fDcl	=0;
      break;
    default:
      break;
    }
    p++;
  }
  return(0);
}

#endif
