#include <string.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include "hb.h"

#ifndef mzl_C_routines

int CbIsIndex(char *I)
{
  int i,k;
  char *lc;

  i	=0;
  lc	=I;
  if(*lc == '+' || *lc == '-'){
    lc++;
    i	=1;
  }
  k	=0;
  while(isdigit(*lc) && k < 32){
    k++;
    lc++;
  }
  if(lc-i-I == 0){
    return(0x0100|(int)(lc-I));
  }
  if(k == 32){
    return(0x0200|(int)(lc-I));
  }
  if(*lc == 'L' || *lc == 'l'){
    lc++;
  }
  if(isalnum(*lc) || *lc == '_' || *lc == '.'){
    return(0x0300|(int)(lc-I));
  }
  return((int)(lc-I));
}

int CbIsCID(char*Nm)
{
  char *lc;
  int k;

  lc	=Nm;
  if(isalpha(*lc) == 0 && *lc != '_'){
    return(0x0400|(int)(lc-Nm));
  }
  lc++;
  k	=1;
  while((isalnum(*lc) || *lc == '_') && k < 32 ){
    k++;
    lc++;
  }
  if(k == 32){
    return(0x0500|(int)(lc-Nm));
  }
  return((int)(lc-Nm));
}

int CbIsCNumber(char *N)
{
  int i,k;
  char *lc;

  i	=0;
  lc	=N;
  if(*lc == '+' || *lc == '-'){
    lc++;
    i	=1;
  }
  k	=0;
  while(isdigit(*lc) && k < 32){
    k++;
    lc++;
  }
  if(*lc != '.'){
    if(lc-i-N == 0){
      return(0x0600|(int)(i));
    }
    if(k == 32){
      return(0x0700|(int)(lc-N));
    }
  }
  else{
    lc++;
  }
  i	=0;
  while(isdigit(*lc)){
    lc++;
    i++;
  }
  if(k==0 && i == 0){
    return(0x0800|(int)(lc-N));
  }
  if(*lc == 'e' || *lc == 'E'){
    lc++;
    if(*lc == '+' || *lc == '-'){
      lc++;
    }
    i	=0;
    while(isdigit(*lc)){
      lc++;
      i++;
    }
    if(i == 0){
      return(0x0900|(int)(i));
    }
  }
  if(isalnum(*lc) || *lc == '_' || *lc == '.'){
    return(0x0a00|(int)(lc-N));
  }
  return((int)(lc-N));
}
char *CbErrC[]=
{
  "",
/*01*/  "NO digits in Integer",
/*02*/  "TOO long Integer",
/*03*/  "WRONG symbol after Integer",
/*04*/  "NOT a C-ID",
/*05*/  "TOO long C-ID",
/*06*/  "NO digits or '.' in C-Number",
/*07*/  "TOO long C-Number",
/*08*/  "NO digits after '.' in C-Number",
/*09*/  "NO digits after 'e' in C-Number",
/*0a*/  "WRONG symbol after C-Number",
/*0b*/  "NOT a C-Name",
/*0c*/  "NO ID after '.' in C-Name",
/*0d*/  "TOO long ID in C-Name",
/*0e*/  "NO '>' after '-' in C-Name",
/*1f*/  "NO ']' after '[' in C-Name",
/*10*/  "NO ')' after '(' in C-Name",
/*11*/  "EXTRA ']' in C-Name",
/*12*/  "EXTRA ')' in C-Name",
/*13*/  "WRONG symbol after C-Name",
/*14*/  "",
/*15*/  ""
};

static int nD=0,ND=8;
static int kDb[8],kDe[8];

int CbIsPrefix(char**lNm)
{
  char *lc;
  int i,j,k,n,d1,d2;

  lc	=*lNm;
  if(!isalpha(*lc) && *lc != '_'){ /*First symbol*/
    return(0);
  }
  lc++;
  k	=1;
  do{				/*prefix*/
    i	=0;
    if((isalnum(*lc) || *lc == '_') && k < 32 ){ /*Length*/
      k++;
      lc++;
      i	=1;
    }
    if(k == 32){
      *lNm	=lc;
      return(0);
    }
    if(*lc == '.'){		/*Check '.'*/
      i	=2;
    }
    if(*lc == '-'){		/*Check "->"*/
      lc++;
      if(*lc != '>'){
	*lNm	=lc;
	return(0);
      }
      i	=2;
    }
    if(i == 2){
      lc++;
      if(!isalpha(*lc) && *lc != '_'){ /*Not a First symbol*/
	*lNm	=lc;
	return(0);
      }
      lc++;
      k	=0;
    }
  }while(i);			/*prefix*/
  *lNm	=lc;
  return(1);
}

int CbIsCName(char*Nm)
{
  char *lc,*ls;
  int i,j,k,n,d1,d2;

  d1	=0;
  d2	=0;
  lc	=Nm;
  do{
    ls	=lc;
    i	=CbIsPrefix(&lc);
    if(i == 0){
      if(lc-ls >= 32){
	return(0x0d00|(int)(lc-Nm));
      }
      return(0x0b00|(int)(lc-Nm));
    }
    i	=0;
    if(*lc == '['){/*array index*/
      i	=1;
      d1++;
      lc++;
      i	=CbIsIndex(lc);
      if((i&0xff00) == 0){
	lc	+=i&0xff;
	if(*lc != ']'){/*array index*/
	  return(0x1100|(int)(lc-Nm));
	}
	i	=0;
      }
    }
    if(*lc == ']'){/*array index*/
      while(*lc == ']'){/*array index*/
	d1--;
	if(d1 < 0){
	  return(0x1100|(int)(lc-Nm));
	}
	*lc++;
      }
      if(*lc == '.'){		/*Check '.'*/
	i	=2;
      }
      if(*lc == '-'){		/*Check "->"*/
	lc++;
	if(*lc != '>'){
	  return(0x0e00|(int)(lc-Nm));
	}
	i	=2;
      }
    }
    if(i == 2){
      lc++;
    }
  }while(i && d1 >=0 && *lc !='\0'); 
  if(d1 < 0){
    return(0x1100|(int)(lc-Nm));
  }
  if(d1 > 0){
    return(0x0f00|(int)(lc-Nm));
  }
  if(isalnum(*lc) || *lc == '_'){
    return(0x1300|(int)(lc-Nm));
  }
  return((int)(lc-Nm));
}

#endif/*C-routines*/
static int kT=7,kI=14;

static int nCW=12,nCWh=6,LCW=3;
static char *CW[12]={"str","dbl","int","flt","lng","mon"
		       ,"fch","Dbl","Int","Flt","Lng","Mon"};


char *ErrMessObj[]={
  "",
 "NO '\"' before <ExtNm>",
 "NO '\"' after <ExtNm>",
 "NO '.' Units",
 "NO ')' after Units",
 "NO '\"' before <IndexList>",
 "NO '\"' after <IndexList>",

  "NO '=' before Type",
  "NO '=' before <Type>",
  "Wrong <Type> ID",
  "NO '*' or ')' after <Type>",
  "NO '*' is 'str*%d'-ID",
  "NO length %d in 'str*%d'-ID",
  "NO ')' in Type",

 "NO '\"' before <ExtNm>",
 "NO '\"' after <ExtNm>",
 "NO '.' Units",
 "NO ')' after Units",
 "NO '\"' before <IndexList>",
 "NO '\"' after <IndexList>"
};

int CbIsExtNameObj(char *Nm)
{
  char *lc,*ls;

  lc	=Nm;
  while(isspace(*lc)) lc++;
  if(*lc != '"'){
    return(0x01|(int)(lc-Nm));
  }
  lc++;
  ls	=lc;
  while(*lc != '"' && *lc != '\0') lc++;
  if(*lc != '"'){
    return(0x02|(int)(ls-Nm));
  }
  lc++;
  while(isspace(*lc)) lc++;

  if(*lc == '('){
    while(*lc != '.' && *lc != '\0') lc++;
    if(*lc != '.'){
      return(0x03|(int)(lc-Nm));
    }
    ls	=lc;
    while(*lc != ')' && *lc != '\0') lc++;
    if(*lc != ')'){
      return(0x04|(int)(ls-Nm));
    }
    lc++;
    while(isspace(*lc)) lc++;
  }
  if(*lc == ','){
    lc++;
    while(isspace(*lc)) lc++;
    if(*lc != '"'){
      return(0x05|(int)(lc-Nm));
    }
    lc++;
    ls	=lc;
    while(*lc != '"' && *lc != '\0') lc++;
    if(*lc != '"'){
      return(0x06|(int)(ls-Nm));
    }
    lc++;
    while(isspace(*lc)) lc++;
  }
  return((int)(lc-Nm));
}

int CbIsIntName(char *Nm)
{
  char *lc,*ls;

  lc	=Nm;
  while(isspace(*lc)) lc++;
  if(*lc != '"'){
    return(0x01|(int)(lc-Nm));
  }
  lc++;
  ls	=lc;
  while(*lc != '"' && *lc != '\0') lc++;
  if(*lc != '"'){
    return(0x02|(int)(ls-Nm));
  }
  lc++;
  while(isspace(*lc)) lc++;

  if(*lc == '('){
    while(*lc != '.' && *lc != '\0') lc++;
    if(*lc != '.'){
      return(0x03|(int)(lc-Nm));
    }
    ls	=lc;
    while(*lc != ')' && *lc != '\0') lc++;
    if(*lc != ')'){
      return(0x04|(int)(ls-Nm));
    }
    lc++;
    while(isspace(*lc)) lc++;
  }
  if(*lc == ','){
    lc++;
    while(isspace(*lc)) lc++;
    if(*lc != '"'){
      return(0x05|(int)(lc-Nm));
    }
    lc++;
    ls	=lc;
    while(*lc != '"' && *lc != '\0') lc++;
    if(*lc != '"'){
      return(0x06|(int)(ls-Nm));
    }
    lc++;
    while(isspace(*lc)) lc++;
  }
  return((int)(lc-Nm));
}

int CbIsObjType(int *iType, int *iV,char *T)
{
  char ch,*lc,*lc1;
  int i;

  lc	=T;
  while(isspace(*lc)) lc++;
  if(*lc != '='){
    return((kI+0x01)|(int)(lc-T));
  }
  lc++;
  while(isspace(*lc)) lc++;
  if(*lc != '('){
    return((kI+0x02)|(int)(lc-T));
  }
  lc++;
  while(isspace(*lc)) lc++;
  lc1	=lc;
  while((ch=*lc) != '*' && ch != ')' && !isspace(ch) && ch != '\0'){
    lc++;
  }
  ch	=*lc;
  *lc= '\0';
  for(i=0; i < nCW; i++){
    if(strcmp(lc1,CW[i]) == 0){
      break;
    }
  }
  *lc	=ch;
  while(isspace(*lc)) lc++;
  *iType	=i;
  if(i == nCW){
    return((kI+0x03)|(int)(lc1-T));
  }
/***************/
  if(*lc != '*' && *lc != ')' && !isspace(*lc)){
    return((kI+0x04)|(int)(lc-T));
  }
  if(i == 0 || i == nCWh){
    if(ch != '*'){
      return((kI+0x05)|(int)(lc-T));
    }
    lc++;
    lc1	=lc;
    while(isdigit(*lc)) lc++;
    if(lc == lc1){
      return((kI+0x06)|(int)(lc-T));
    }
  }
  if(*lc == '*'){
    *iV	=1;
    lc++;
  }
  else{
    *iV	=0;
  }
  if(*lc != ')'){
    return((kI+0x07)|(int)(lc-T));
  }
  while(isspace(*lc)) lc++;
  return((int)(lc-T));
}

int CbIsIntNameObj(char *Nm)
{
  char *lc,*ls;

  lc	=Nm;
  while(isspace(*lc)) lc++;
  if(*lc != '"'){
    return(0x01|(int)(lc-Nm));
  }
  lc++;
  ls	=lc;
  while(*lc != '"' && *lc != '\0') lc++;
  if(*lc != '"'){
    return(0x02|(int)(ls-Nm));
  }
  if(lc == ls){
    return(0x03|(int)(ls-Nm));
  }
  lc++;
  while(isspace(*lc)) lc++;

  ls	=lc;
  while(*lc != '"' && *lc != '\0') lc++;

  if(*lc != '"'){
    return(0x04|(int)(ls-Nm));
  }

  if(*lc == ','){
    lc++;
    while(isspace(*lc)) lc++;
    if(*lc != '"'){
      return(0x05|(int)(lc-Nm));
    }
    lc++;
    ls	=lc;
    while(*lc != '"' && *lc != '\0') lc++;
    if(*lc != '"'){
      return(0x06|(int)(ls-Nm));
    }
    lc++;
    while(isspace(*lc)) lc++;
  }
#ifdef H
static int nIntNm=6;
 "NO '\"' before <IntNm>",
 "NO '\"' after <IntNm>",
 "EMPTY <IntNm>",
 "NO '\"' before <IndexList>",
 "NO '\"' after <IndexList>",
#endif
  return((int)(lc-Nm));
}

#ifndef mzl_Cb_routines
static char *Mess="-file ends in the middle of comment";

int CbSkipCCommentFile(FILE *lF,char *NmFile)
{
  char ch1,ch;

  if(feof(lF) == 0)
    ch	=fgetc(lF);
  else{
    printf("%s\n",NmFile);
    return(1);
  }
  ch1	=ch;
  if(feof(lF) == 0)
    ch	=fgetc(lF);
  else{
    printf("%s%s\n",NmFile,Mess);
    return(1);
  }
  while(feof(lF) == 0 && (ch1 != '*' || ch != '/')){
    ch1	=ch;
    ch	=fgetc(lF);
  }
  if(ch1 == '*' || ch == '/'){
    return(0);
  }
  else{
    printf("%s%s\n",NmFile,Mess);
    return(1);
  }
}

int CbCopyCCommentFile(FILE *lT,FILE *lF,char *NmFile)
{
  char ch1,ch;

  if(feof(lF) == 0){
    ch	=fgetc(lF);
    fputc(ch,lT);
  }
  else{
    printf("%s%s\n",NmFile,Mess);
    return(1);
  }
  ch1	=ch;
  if(feof(lF) == 0){
    ch	=fgetc(lF);
    fputc(ch,lT);
  }
  else{
    printf("%s%s\n",NmFile,Mess);
    return(1);
  }
  while(feof(lF) == 0 && (ch1 != '*' || ch != '/')){
    ch1	=ch;
    ch	=fgetc(lF);
    fputc(ch,lT);
  }
  if(ch1 == '*' || ch == '/'){
    return(0);
  }
  else{
    printf("%s%s\n",NmFile,Mess);
    return(1);
  }
}

int CMainParameters(char *str)
{
  char *p;

  p	=str;
  p++;
  str++;
  while(isspace(*p)) p++;
  if(strncmp(p,"int ",4) == 0){
    p	+=4;
  }
  if(*p == ')'){
    *str++	=')';
    *str	='\0';
    return(0);
  }
  while(isspace(*p)) p++;
  while(*p !=',' && *p != '\0') *str++	=*p++;
  if(*p != ','){
    out("ss","str=",str);
    out("ss","p=",p);
    printf("Wrong list of parameters in main()\a\n");
    return(1);
  }
  *str++	=*p++;
  while(isspace(*p)) p++;
  if(strncmp(p,"char",4) == 0){
    p	+=4;
  }
  while(isspace(*p)) p++;
  if(*p != '*'){
    printf("No '*' in main() after char in list of parameters\a\n");
    return(1);
  }
  while(*p == '*') p++;
  while(isspace(*p)) p++;
  while(*p != ')' && *p != '\0') *str++	=*p++;
  *str++=')';
  *str	='\0';
  if(*p != ')'){
    printf("No ')' in main() \a\n");
    return(1);
  }
  return(0);
}
#endif
