#include <string.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <unistd.h>
#include <ctype.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <X11/Xatom.h>
#include <X11/keysym.h>
#include "CbType.h"
#include "XCbType.h"

#ifndef mzl_X
char *EventNm[]={
"",
"",
"KeyPress",
"KeyRelease",
"ButtonPress",
"ButtonRelease",
"MotionNotify",
"EnterNotify",
"LeaveNotify",
"FocusIn",
"FocusOut",
"KeymapNotify",
"Expose",
"GraphicsExpose",
"NoExpose",
"VisibilityNotify",
"CreateNotify",
"DestroyNotify",
"UnmapNotify",
"MapNotify",
"MapRequest",
"ReparentNotify",
"ConfigureNotify",
"ConfigureRequest",
"GravityNotify",
"ResizeRequest",
"CirculateNotify",
"CirculateRequest",
"PropertyNotify",
"SelectionClear",
"SelectionRequest",
"SelectionNotify",
"ColormapNotify"
"ClientMessage"
"MappingNotify"
};

static struct stat statbuf;

extern int CbMemoryL;

static int itheW;

extern Display*theD;
extern int theD_w,theD_h;
extern Window theW,theHW,theMW,CPanelW,theRW;
extern unsigned int Wmode;
extern GC theGC,theGCE,theGCT,theGCH;
extern int NWin;
extern int *ExposeW,*ConfW;
extern WinPar*WinP;
extern int wF,hF;
extern int XCbNColor;
extern unsigned long int ColorPix[];

extern XEvent msg;

#ifdef OPENGL
extern Window WinGL;
extern int (*CbUserGLRoutine)(XEvent *);
#endif

extern CbUnits*XUnits;
extern int NXUnits;

extern void (*CbUserControl)(void);
extern Window theUserCW;

extern int xMessW,yMessW,kMessW;

static int hF1;
static int iT=0;
int xshift;
int CbBoxFl=0;
double CbBoxX[2]={0.,0.,},CbBoxY[2]={0.,0.};

static int Wwidth,Hheight;
static char line[128],line1[128];

static int theBk,theBx,theBy;

static int kStM=7,kStO=4,kStI=5;
extern int mSetM;
extern int mSetO;
extern int mSetI;
static int UnSetM,UnSetO,UnSetI,nx80;
static char*CbMode[]={" On ","~Sv ","~Tab","~Rd ","~Wrt"," ~X ","~Lp ","~Set"};
static char*CbMODE[]={"Off "," Sv "," Tab"," Rd "," Wrt","  X "," Lp "," Set"};
static char*CbOut[]= {"~As","~Bn","~ps"," ~X","~St"};
static char*CbOUT[]= {" As"," Bn"," ps","  X","Set"};
static char*CbInp[]= {"~Tb","~Pl","~As","~Bn"," ~X","~St"};
static char*CbINP[]= {" Tb"," Pl"," As"," Bn","  X","Set"};

typedef struct SWMENU{
char *Nm;
int L;
int n;
int w;
int k;
int sL[16];
char *s[16];
}SWMENU;

static SWMENU SwMenu[4]={
  {
    "<- Modes:",
    0,0,0,0, 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    "Take from Buff",
    "Copy to Buff",
    "Top in !-blb",
    "- Off / On",
    "- Save in .sv",
    "- Take from  .tb",
    "- Read from .rd",
    "- Write to .wr",
    "- X On/Off",
    "- Loop On/Off",
    "EntireBlock",
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
 },
  {
    "<- Outputs:",
    0,0,0,0, 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    "Take from Buff",
    "Copy to Buff",
    "Top in !-blb",
    "- ASCII to .ao",
    "- Binary to .bo",
    "- PostScript to .ps",
    "- X On/Off",
    "Entire Block",
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
 },
  {
    "<- Inputs:",
    0,0,0,0, 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    "Take from Buff",
    "Copy to Buff",
    "Top in !-blb",
    "- Table",
    "- Graphics",
    "- ASCII from .ai",
    "- Binary from .bi",
    "- X On/Off",
    "Entire Block",
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
  },
  {
    "Save (with <mouse-M>) CPanel at",
    0,0,0,0, 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
 }
};

static int wM,wO,wI,wMOI;
static char*strID[3]= {"t0","dt","t1"};
static PanelCell*XCPCell;
static InputCell*XIDCell;
static int*nXCPCell,*kXCPCell,nXCPC,*nXIDCell,*kXIDCell,nXIDC,ixPC=0,iyPC=0;
static int iCPanelW,iclmCP= 0,ioCPanel= 0;
static int XColBut;

static double *pxg_0,*pyg_0,*pxmin,*pymin,*pxmax,*pymax,*psx,*psy;
static double xg_0,yg_0,xmin,ymin,xmax,ymax,sx,sy;

#ifdef H
char *ColorNames1[]= {"Black"
,"AntiqueWhite3","AntiqueWhite2","White"
,"Blue","SkyBlue1","lavender"
,"cyan3","cyan2","cyan"
,"DarkGreen","Green","Yellow"
,"Magenta","Red","Grey85"
,"DeepPink","orange","linen"
,"orchid1","plum2","plum1"
,"Black"					/* Text of Buttons */
,"White","AntiqueWhite2","AntiqueWhite3"	/* Help Button */
,"lavender","SkyBlue1","Blue"
,"cyan","cyan2","cyan3" 			/* Activity Button */
,"Yellow","Green","DarkGreen"			/* Return Button */
,"Grey85","Red","Magenta"
,"linen","orange","DeepPink"			/* GuiEButtons */
,"plum1","plum2","orchid1"			/* ESC Button */
,"Grey85"					/* BackGround of Windows */
,"Grey85"					/* BackGround of Plots */
,"Red"						/* Trace of Graphic data 46*/
,"cyan"						/* Table Background DataCell */
,"cyan2"					/* Inactive Data Cell */
,"Green"					/* Input Data Cell */
};
#endif

char*txtR[]= {"Enter","Save ","Save?","Save?","Save?","Save?","Save?","Read?"};
char*txtE[]= {"Esc"};
char*txtA[]= {"Active ","Passive"," Movie ","Hidden "};
char*txtM[]= {"Table ","WriteT","SavePS","Save T",
		"StT+PS","StrmPS","Strm T","Read T"};
char*txtIO[]= {"Output","Input "};


static Pixmap theP1;
static int nPixR=0,ixPixR=0,iyPixR=0,iwPixR=800,ihPixR=600;
static char FNm[0x100]="Pix/aaa";
static int NotSave=0;

int XCbSetPixR(int ix,int iy,int iw,int ih)
{
  return(0);
}

int XCbGetPixR(int *iw,int *ih)
{
  return(0);
}

int XCbPixR2pnm()
{
  return(0);
}

int XCbNotSave()
{
  return(0);
}

int CbExit()
{
  return(0);
}

#ifndef stg_HELP
typedef struct HELP{
  char *v;	/* Visible text on the button */
  char *m;	/* Text in menu */
  char f[32];	/* File name with text help */
  char *t;	/* Text help */
  char dvi[64];	/* System command for .dvi help*/
  char ps[32];	/* System command for .ps help*/
}HELP;

static int nH0=6,nH1=4;
static HELP Help0[10],*Help1,lH0,lH1;

char*listH1[4];
char*listH0[6];
int XCbFreeHelpTxt()
{
  return(0);
}

int XCbInitHelpTxt()
{
  return(0);
}

int XCbDisplaySectHelp(int ix,int iy,int kC)
{
  return(0);
}
#endif/*stg_HELP*/

#ifndef stg_GUI
static unsigned int xB,xB3,yB2,yB3,hB,hB2,hB3,
LR,xR,xR1,xR2,xR3,wBR,wBR3,
LE,xE,xE1,xE2,xE3,wBE,wBE3,
LA,xA,xA1,xA2,xA3,wBA,wBA3,
LM,xM,xM1,xM2,xM3,wBM,wBM3,
LH,xH,xH1,xH2,xH3,wBH,wBH3;

int XCbSetWindowButtons()
{
  return(0);
}

int GuiHButton(int iW)
{
  return(0);
}

int GuiEButton(int iW)
{
  return(0);
}

int GuiEraseRButton(Window W)
{
  return(0);
}

int GuiRButton(W,m)
     Window W;
     int m;
{
  return(0);
}

int GuiERButtons(int iW)
{
  return(0);
}

int GuiMButton(W,m)
     Window W;
     int m;
{
  return(0);
}

int GuiIOButton(Window W,int m)
{
  return(0);
}

int GuiAButton(W,i)
     Window W;
     int i;
{
  return(0);
}

int GuiButton(Window W,int ix,int iy,int iw,int n)
{
  return(0);
}

int GuiRect(W,ix,iy,iw,n)
     Window W;
     int ix,iy,iw,n;
{
  return(0);
}

int XCbCleanWindow(int i)
{
  return(0);
}

int GuiShowAHButtons(int i)
{
  return(0);
}

int DisplayActivity()
{
  return(0);
}

int GuiReSetWP(int i)
{
  return(0);
}

int XCbTableErase()
{
  return(0);
}
#endif/*stg_GUI*/

#ifndef stg_MENU

int XCbSetMenuTexts()
{
  return(0);
}

int XCbSetOutDirMenu()
{
  return(0);
}

int OneChoiceMenu(int *M,char*Nm,char**llc,int n,int x,int y, int iWin)
{
  return(msg.xbutton.button);
}

int XTAdvanceMenu(int iB,char**unit)
{
  return(0);
}

int ColumnOfSmallButtons(int m,int n,char ch,int ix, int iy)
{
  return(0);
}

int XCbMenuWindow(int k,int *M,int *Madd,int *Mor,int x,int y)
{
  return(msg.xbutton.button);
}

#endif/*stg_MENU*/

#ifndef stg_EVENTS
int WinNumber(nw)
     int*nw;
{
  return(0);
}

int CheckActivity()
{
  return(0);
}

int XIDShowCells()
{
  return(0);
}

int ConfExposeAction()
{
  return(0);
}

int ingtxt(char str[],int len,int *il,int ix0,int iy0)
{
  return(0);
}

int CheckIfEvents()
{
  return(0);
}

int IsButtonPress()
{
  return(msg.xbutton.button);
}

int CheckIfButtonEvents()
{
  return(0);
}

int CbCheckIfEvents()
{
  return(0);
}

int EvGetCntrKey()
{
  return(0);
}
#endif/*stg_EVENTS*/

#ifndef stg_Table
int CbSend2XUTable(int iTable)
{
  return(0);
}

int XCbInitTblPlotAddress(Xg_0,Yg_0,Xmin,Ymin,Xmax,Ymax,Sx,Sy)
     double *Xg_0,*Yg_0,*Xmin,*Ymin,*Xmax,*Ymax,*Sx,*Sy;
{
  return(0);
}

int XCbSetPlotLimits(double *gdx,double *gdy,int *xg0,int *yg0,int*xg1,int*yg1)
{
  return(0);
}

int XCbGetPlotLimits(double *xg0,double *pxmn,double *pxmx,double *psx
		     ,double *yg0,double *pymn,double *pymx,double *psy)
{
  return(0);
}

int Show1DDot(InputCell *lC,int ic)
{
  return(0);
}

int XCbDotShow(InputCell*data,int nkx,int *kx2j,int *ky2j
	     ,int *kx,int *ky,double gdx,double gdy)
{
  return(0);
}

int ZTableShow(InputCell *data,int n_data)
{
  return(0);
}

int XCb2DTableInput(iWin,L,data,n_data,kx2j,ky2j,j2kx,j2ky,kx,ky,nkx,iclm)
     int iWin,L;
     InputCell*data;
     int n_data,*kx2j,*ky2j,*j2kx,*j2ky,*kx,*ky,nkx,*iclm;
{
  return(0);
}

int XCb1DDotShow(InputCell*data,int nkx,int *kx2j,int *kx)
{
  return(0);
}

int XCb1DTableInput(iWin,data,n_data,kx2j,j2kx,kx,nkx,iclm)
     int iWin;
     InputCell*data;
     int n_data,*kx2j,*j2kx,*kx,nkx,*iclm;
{
  return(0);
}

int display_cell(data,color)
     InputCell*data;
     int color;
{
  return(0);
}
#endif/*stg_Table*/

#ifndef stg_CPanel

int XCbInitXCPCell(PanelCell*CPCell,int*kCPCell,int*nCPCell,
		   InputCell*IDCell,int*kIDCell,int*nIDCell)
{
  return(0);
}

int XCbGetCntrPanel()
{
  return(0);
}

int XCbGetInputRootDirName(int kD, int iy)
{
  return(0);
}

int XCbGetDirName(int kD, int iy)
{
  return(0);
}

int XCbGetStreemPar(int kD,int iy)
{
  return(0);
}

int XCPanelShowCells()
{
  return(0);
}

int XCPanelEraseCells()
{
  return(0);
}

int XCPanelShowSwitch(int key)
{
  return(0);
}

int XCPanelShowSwitches()
{
  return(0);
}

int XIDEraseCells()
{
  return(0);
}

int XIDCellPos()
{
  return(0);
}

int XCbClickOnCPanelTbl()
{
  return(0);
}

int XCbIfCPanelRE()
{
  return(0);
}

int CpShowOneModSwitch(int kC)
{
  return(0);
}

int CpShowOneOutSwitch(int kC)
{
  return(0);
}

int CpShowOneInpSwitch(int kC)
{
  return(0);
}

int CpShowBlbModSwitches(int kC)
{
  return(0);
}

int CpShowBlbOutSwitches(int kC)
{
  return(0);
}

int CpShowBlbInpSwitches(int kC)
{
  return(0);
}

int CpReSetModSwitch(int kC)
{
  return(0);
}

int CpReSetOutSwitch(int kC)
{
  return(0);
}

int CpReSetInpSwitch(int kC)
{
  return(0);
}

int CheckCPanelIO()
{
  return(0);
}

int CpPos()
{
  return(0);
}

int XCbInputCntrPanel()
{
  return(0);
}
#endif/*stg_CPanel*/

#ifndef stg_Junk
/* Non active */
int XCbCPanel2PixCP(Pixmap lCP,int xP,int yP)
{
  return(0);
}
#endif/*stg_Junk*/
#endif/*mzl_X*/
