#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include "CbType.h"
#include "XCbType.h"


static struct stat statbuf;

extern Display*theD;
extern Window theW;
extern int Wmode;
extern GC theGC;
extern WinPar*WinP;
extern int wF,hF;
extern unsigned long int ColorPix[16];
extern char AuthorNm[];

extern char *CbMakeCbFile(char *s,char *s1);
extern char *CbMakeZSourceFile(char*s);

char NmCbF[64];
static char NmInitF[64],NmMkF[64],**NmCfF,NmMain[64],NmCode[64];
static char ln[64];
static FILE*fp;

int CbPrintUsageMessage()
{
  printf("Usage:\n\nMake <C-file name>.Cb file for code <code-name>:\n");
  printf("zcb <C-file name>.c -i <code-name> -a\"<Author Name>\" <Enter>\n\n");
  printf("Make <C-file name>.Cb file for code");
  printf(" <code-name>=<C-file-name>:\n");
  printf("zcb <C-file name>.c <Enter>\n\n");
  printf("Make default *.CmC files:\n");
  printf("zcb <Cb-file name>.Cb -a \"<Author Name>\" <Enter>\n\n");
  printf("Make all Csrc/Cb<C-file names>.c source files:\n");
  printf("zcb <Cb-file name>.Cb -a <Enter>\n\n");
  printf("Make all source files Csrc/Cb*.c and Cb-Makefile:\n");
  printf("zcb <Cb-file name>.Cb -M <make-file name> <Enter>\n\n");
  printf("Make only Cb-Makefile:\n");
  printf("zcb <Cb-file name>.Cb -m <make-file name> <Enter>\n\n");
  printf("Make only one Csrc/Cb<C-file name>.c source file:\n");
  printf("zcb <Cb-file name>.Cb -f <C-file name>.c <Enter>\n\n");
  printf("<In/> directory may be dropped in <Cb-file name>.Cb\n\n");
  return(0);
}

int main(int argc,char** argv)
{
  char *lc,*lc1,*lc2,*lb;
  int i,j,FlCb,Flmk,Flcf,Fli;

  if(argc < 2){
    CbPrintUsageMessage();
    exit(1);
  }
  CbBasicDirectorySet();
  FlCb	=0;
  for(i=1; i < argc; i++){
    if(strcmp(argv[i],"-a") == 0){
      i++;
      if(i < argc && *argv[i] != '-'){
	lc	=argv[i];
	lc1	=AuthorNm;
	if(*lc == '"') lc++;
	while(*lc && *lc != '"') *lc1++=*lc++;
	*lc1	='\0';
      }
    }else{
      lc	=argv[i];
      lc1	=NmCode;
      while(*lc != '\0'){
	*lc1	=*lc++;
	if(*lc1 =='/'){
	  lc1	=NmCode;
	}
	else{
	  lc1++;
	}
	if(*lc == '.' && strcmp(lc+1,"Cb") == 0){
	  *lc1	='\0';
	  if(stat(argv[i],&statbuf)){
	    sprintf(NmCbF,"In/%s.Cb",NmCode);
	    if(stat(NmCbF,&statbuf) == 0){
	      FlCb	=1;
	    }else{
	      printf("\nError: wrong %s.Cb file\a\n\n",argv[i]);
	    }
	  }else{
	    strcpy(NmCbF,argv[i]);
	    FlCb	=1;
	  }

	  i	=argc;
	  break;
	}
      }
    }
  }

  Fli	=0;
  Flcf	=0; 
  Flmk	=0;
  if(FlCb == 0){
    for(i=1; i < argc; i++){
      if(strcmp(argv[i],"-i") == 0){
	i++;
	if(i < argc && *argv[i] != '-'){
	  lc	=argv[i];
	  lc1	=NmCode;
	  while(*lc) *lc1++ =*lc++;
	  *lc1	='\0';
	  Fli	=1;
	  break;
	}
	else{
	  CbPrintUsageMessage();
	  exit(1);
	}
      }
    }

    InitCWDir();
    lc	=argv[1];
    lc1	=NmInitF;
    lc2	=NmMain;
    while(*lc){
      *lc2	=*lc != '.' ? *lc : '\0';
      if(*lc == '/'){
	lc2	=NmMain;
      }
      else{
	lc2++;
      }
      *lc1++	=*lc++;
   }
    *lc2	='\0';
    *lc1	='\0';
    lc1	=NmInitF+Path2RelPath(NmInitF);
    lc1 -=2;
    lc--;

    if(*lc1 == '.' && (*lc == 'c' || *lc == 'f')){
      if(Fli == 0){
	strcpy(NmCode,NmMain);
	printf("Name of the code has not been provided\n");
	printf("%s is used instead <%s>\n",NmCode,NmMain);
      }
      sprintf(NmCbF,"In/%s.Cb",NmCode);
      CbInitBLB(NmCbF,0,NULL);
      lc	=CbMakeCbFile(NmInitF,NmCode);
      strcpy(NmCbF,lc);
      CbDeInitCb();
    }
    else{
      CbPrintUsageMessage();
    }
    return(0);
  }
  else{
    for(i=1; i < argc; i++){
      if(strcmp(argv[i],"-m") == 0){
	i++;
	if(i < argc && *argv[i] != '-'){
	  lc	=argv[i];
	  lc1	=NmMkF;
	  while(*lc) *lc1++ =*lc++;
	  *lc1	=0;
	  Flmk	=1;
	}else{
	  Flmk=2;
	}
	break;
      }
    }
    for(i=1; i < argc; i++){
      if(strcmp(argv[i],"-f") == 0) Flcf++;
    }

    NmCfF	=NULL;
    if(Flcf){
      NmCfF	=(char**)malloc(Flcf*sizeof(char*));
      Flcf	=0;
      for(i=1; i < argc; i++){
	if(strcmp(argv[i],"-f") == 0){
	  i++;
	  if(i < argc && *argv[i] != '-'){
	    lc		=argv[i];
	    j	=0;
	    while(j < Flcf && strcmp(lc,NmCfF[j])) j++;
	    if(j == Flcf){
	      NmCfF[Flcf]	=argv[i];
	      Flcf++;;
	    }
	  }
	  else{
	    CbPrintUsageMessage();
	    return(1);
	  }
	}
      }		
    }
    else{
      for(i=1; i < argc; i++){
	if(strcmp(argv[i],"-M") == 0){
	  Flcf	=-1;
	  break;
	}
      }
    }
    if(CbInitBLB(NmCbF,0,NULL)){
      printf("%s file is absent\n",NmCbF);
      return(1);
    }
#ifdef H
    CbPrintBlbContent(0);
#endif
    if(Flmk == 0 && Flcf == 0){
      XCbInitX();
      XCbNotSave();
      XCbInputCntrPanel();
      CbMakeTblTempFiles();
      XCbDeInitX();
    }
    else{
      CbSetFlagEdit();
      CbInitInpTables();
      printf("=========== Inserting Code Control ===========\n");
      CbMakeTFiles(NmCfF,NmCode,Flcf);
#ifdef H
      XCbTestTables();
#endif
      printf("=========== Modifying Source Files ===========\n");
      if(CbMakeSFiles(NmCode,NmCfF,Flcf)){
	CbDeInitCb();
	exit(0);
      }
      if(Flmk == 1){
	printf("=========== Modifying  Make  File  ===========\n");
	if(CbMakeMkF(NmMkF)){
	  CbDeInitCb();
	  exit(0);
	}
      }
      if(Flmk == 2){
	printf("=========== Writing New MakeFile ===========\n");
	if(CbMakeNewMkF(NmCode,NmCbF)){
	  CbDeInitCb();
	  exit(0);
	}
      }
    }
    CbDeInitCb();
  }
  if(Flcf){
    free(NmCfF);
  }
  return(0);
}
