/*
  Routine for updating files <CodeName>.Cntr in data base file system

  cc -o zup Src/zup.c
 */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <dirent.h>
#include <sys/stat.h>
#include <unistd.h>

int Usage()
{
  puts("Usage:");
  puts("zup <Input Dir, e.g. Wrk> <Code name, e.g. esc> <Dir for Scan>");
  puts("First update Wrk/<>.Cntr Wrk/<>.ioD");
  puts("zup Wrk j2e ../dB0");
  exit(1);
}
 
struct dirent*direntp;
struct stat statbuf;
char ln[256],str[128];
DIR *dirp;

int ND=0x20;
int iD=0;
struct dirent *lF0[0x20];
DIR *lD[0x20];
int L[0x20];
char Nm[0x80];
int LInp,LOut;
char bUpd[0x8000];
char bInp[0x8000];
char bOut[0x8000];

int nNmS,nNmT,LT;
int iS[0x1000],iT[0x1000];
char NmS[0x0100][16],NmT[0x0100][16];

char bfI[0x40][0x40];
char bfO[0x40][0x40];
char bfU[0x40][0x40];

int MakeSesctionNames(int *nNm,char Nmm[][16], int *iL, char* lI)
{
  int k,n;
  char *lc,*lt;
  lc	=lI;
  n	=0;
  do{
    k	=0;
    iL[n]	=lc-lI;
    while(*lc != ':' && *lc != '\n' && *lc) lc++;
    if(*lc == ':'){
      lc++;
      while(isspace(*lc) && *lc != '\n') lc++;
      if(*lc != '\n'){
	lt	=Nmm[n];
	while(!isspace(*lc) && *lc) *lt++=*lc++;
	*lt	='\0';
	n++;
	while(isspace(*lc) && *lc != '\n') lc++;
	if(*lc == '\n') lc++;
	k	=1;
      }
    }
  }while(k);
  LT	=0;
  if(n){
    lc	=lI;
    while(*lc != ':') lc++;
    LT	=lc-lI;
  }
  *nNm	=n;
  return(0);
}

int Update()
{
  int i,j,j1,k;
  char *lc,*lt;

  strcpy(bUpd,bInp);
  j1	=0;
  for(i=0; i < nNmS; i++){
    lc	=NmS[i];
    k	=1;
    for(j=j1; j < nNmT; j++){
      lt	=NmT[j];
      if(*lt != '\0' && strcmp(lc,lt) == 0){
	memcpy(bUpd+iS[i],bOut+iT[j],LT);
	*lt	='\0';
      }
      if(k && *lt != '\0'){
	k	=0;
	j1	=j;
      }
    }
  }
  return(0);
}

int GetInpBuff(int *nLn, char* lI)
{
  int k,K,i,n;
  char *lc,*lt;
  lc	=lI;
  k	=0;
  lt	=bfI[k];
  while(*lc){
    if(*lc == '\n'){
      *lt	=0;
      k++;
      lt	=bfI[k];
    }else{
      *lt++	=*lc;
    }
    lc++;
  }
  *nLn	=k;
  return(0);
}

int GetOutBuff(int *nLn, char* lO)
{
  int k,K,i,n;
  char *lc,*lt;

  lc	=lO;
  k	=0;
  lt	=bfO[k];
  while(*lc){
    if(*lc == '\n'){
      *lt	=0;
      k++;
      lt	=bfO[k];
    }else{
      *lt++	=*lc;
    }
    lc++;
  }
  *nLn	=k;
  return(0);
}

int UpdateIOD()
{
  int i,k;
  char *lc,*lt;

  for(k=0; k < nNmS; k++){
    lc	=bfI[k];
    lt	=bfO[k];

    while(*lc != '-' && *lc) lc++;
    while(*lt != '-' && *lt) lt++;
    i	=0;
    while(*lc == '-' && *lc != '\n' && *lc){
      lc++;
      i++;
    }
    if(i == 3){
      i	=0;
      while(*lt == '-' && *lt){
	lt++;
	i++;
      }
      if(i == 3){
	strcpy(lt,lc);
      }
    }
  }
  return(0);
}


int UpdateFileIOD(char** argv)
{
  int i,k,iW;
  char NmCntr[32]="";
  char NmI[0x80];
  char NmD[0x80];
  char *lc;
  FILE *lF;
  FILE *lT;

  i=sprintf(NmI,"%s",argv[1]);
  if(NmI[i-1] != '/'){
    NmI[i++]	='/';
    NmI[i]	='\0';
  }
  sprintf(NmCntr,"%s.ioD",argv[2]);
  strcpy(NmI+i,NmCntr);
  if(stat(NmI,&statbuf)){
    printf("<%s>: absent\n",NmI);
    exit(1);
  }
  LInp	=statbuf.st_size;
  lF=fopen(NmI,"r");
  fread(bInp,1,LInp,lF);
  bInp[LInp]='\0';
  GetInpBuff(&nNmS,bInp);

  iD	=0;
  i=sprintf(Nm,"%s",argv[3]);
  if(Nm[i-1] != '/'){
    Nm[i++]	='/';
    Nm[i]	='\0';
  }
  L[iD]=i;
  iW	=0;
  lD[iD]	=opendir(Nm);
  printf("%2d <%s>\n",iD,Nm);
  if(lD[iD] == NULL){
    printf("<%s> - wrong name\n",Nm);
    return(0);
  }
  do{
    if((lF0[iD]=readdir(lD[iD])) != NULL){
      lc	=lF0[iD]->d_name;
      if(*lc != '.'){
	strcpy(Nm+L[iD],lc);
	if(stat(Nm,&statbuf) == 0){
	  if(S_ISREG(statbuf.st_mode) && strcmp(lc,NmCntr) == 0){
	    LOut	=statbuf.st_size;
	    lT=fopen(Nm,"r+");
	    fread(bOut,1,LOut,lT);
	    bOut[LOut]	='\0';
	    GetOutBuff(&i,bOut);
	    if(i != nNmS){
	      printf("Error: %d != %d <%s> <%s>\n",i,nNmS,NmI,Nm);
	      fclose(lT);
	      exit(0);
	    }
	    UpdateIOD();
	    rewind(lT);
	    for(i=0; i < nNmS; i++){
	      fprintf(lT,"%s\n",bfO[i]);
	    }
#ifdef H
	      printf("Output Nm[%d]: <%s>\n",i,bfO[i]);

	    for(i=0; i < nNmS; i++){
	      fprintf(lT,"Output Nm[%d]: <%s>\n",i,bfO[i]);
	    }
#endif
	    fclose(lT);
	    printf("%2d <%s>\n",iD,Nm);
	  }
	  if(S_ISDIR(statbuf.st_mode)){
	    i	=strlen(lc);
	    if(lc[i-1]	!= '/'){
	      lc[i++]	='/';
	      lc[i]	='\0';
	    }
	    strcpy(Nm+L[iD],lc);
	    i	+=L[iD];
	    iD++;
	    if(iD == ND){
	      puts("Depth limit was reached");
	      exit(0);
	    }
	    L[iD]	=i;
	    lD[iD]	=opendir(Nm);
	  }
	}
      }	
    }
    else{
      closedir(lD[iD]);
      if(iD == 0) break;
      iD--;
      Nm[L[iD]]='\0';
    }
  }while(1);
  fclose(lF);
  return(0);
}

int main(int argc, char** argv)
{
  int i,iW;
  char NmCntr[32]="";
  char NmI[0x20];
  char *lc;
  FILE *lF;
  FILE *lT;

  if(argc < 4) Usage();

  i=sprintf(NmI,"%s",argv[1]);
  if(NmI[i-1] != '/'){
    NmI[i++]	='/';
    NmI[i]	='\0';
  }
  sprintf(NmCntr,"%s.Cntr",argv[2]);
  strcpy(NmI+i,NmCntr);
  if(stat(NmI,&statbuf)){
    printf("<%s>: absent\n",NmI);
    exit(1);
  }
  LInp	=statbuf.st_size;
  lF=fopen(NmI,"r");
  fread(bInp,1,LInp,lF);
  bInp[LInp]='\0';
  MakeSesctionNames(&nNmS,NmS,iS,bInp);

  iD	=0;
  i=sprintf(Nm,"%s",argv[3]);
  if(Nm[i-1] != '/'){
    Nm[i++]	='/';
    Nm[i]	='\0';
  }
  L[iD]=i;
  iW	=0;
  lD[iD]	=opendir(Nm);
  printf("%2d <%s>\n",iD,Nm);
  if(lD[iD] == NULL){
    printf("<%s> - wrong name\n",Nm);
    return(0);
  }
  do{
    if((lF0[iD]=readdir(lD[iD])) != NULL){
      lc	=lF0[iD]->d_name;
      if(*lc != '.'){
	strcpy(Nm+L[iD],lc);
	if(stat(Nm,&statbuf) == 0){
	  if(S_ISREG(statbuf.st_mode) && strcmp(lc,NmCntr) == 0){
	    LOut	=statbuf.st_size;
	    lT=fopen(Nm,"r+");
	    fread(bOut,1,LOut,lT);
	    bOut[LOut]	='\0';
	    MakeSesctionNames(&nNmT,NmT,iT,bOut);
	    Update();
	    rewind(lT);
	    fwrite(bUpd,1,LInp,lT);
	    fclose(lT);
	    printf("%2d <%s>\n",iD,Nm);
	  }
	  if(S_ISDIR(statbuf.st_mode)){
	    i	=strlen(lc);
	    if(lc[i-1]	!= '/'){
	      lc[i++]	='/';
	      lc[i]	='\0';
	    }
	    strcpy(Nm+L[iD],lc);
	    i	+=L[iD];
	    iD++;
	    if(iD == ND){
	      puts("Depth limit was reached");
	      exit(0);
	    }
	    L[iD]	=i;
#ifdef H
	    printf("%d <%s>\n",iD,Nm);
#endif
	    lD[iD]	=opendir(Nm);
	  }
	}
      }	
    }
    else{
      closedir(lD[iD]);
      if(iD == 0) break;
      iD--;
      Nm[L[iD]]='\0';
    }
  }while(1);
  fclose(lF);

  putchar('\n');
  UpdateFileIOD(argv);
  return(0);
}
