#ifndef Blb_escL.c
/* 
   work to do:
   1. Improve start up by using the next term of expansion.
   2. Improve start up with eigen-value decomposition.

 */
#ifdef Doc_escL.c

\centerline{\LARGE\bf Toroidal MHD energy principle}
\vskip12pt
\centerline{\Large\bf L.~E.~Zakharov}
\vskip8pt
\centerline{\Large\em 
  Princeton University, Princeton Plasma Physics Laboratory
 }
\vskip8pt
\centerline{\Large October 18, 1999}
%\maketitle
\begin{abstract}
The ideal energy principle is presented in the conventional form (in
terms of the plasma displacement) as well as in a form where the
components of the perturbed vector potential play the role of test   
functions. The paper reveals a fundamental problem for the conventional
approach in interfacing equilibrium and stability codes for resistive
calculations, while the new form, being much simpler, is suitable for
both ideal and resistive stability calculations. The paper covers 2- and
3-dimentional cases.
\end{abstract}
\tableofcontents

\section{Equilibrium magnetic fields and perturbations}
Normalization
\bqbl
&&
\bsp\equiv4\gp p
,\quad
\bgY\equiv\R{\gY}{2\gp}
,\quad
\bgF\equiv\R{\gF}{2\gp}
,\quad
\baF\equiv\R{2}{c}F
,\quad
\baJ\equiv\R{2}{c}J
,\quad
\bgn\equiv\R{2}{c}\gn
.\eqbl
Vector potential $\waA$ of the equilibrium field in equilibrium coordinates
$\gr,\gt,\gf$
\bqbl
&&
A_{\gr,\gt,\gf}=\left\{
\gh(\gr,\gt)
,\bgF(\gr)
,\bgY(\gr)
\right\}
.\eqbl
Equilibrium magnetic field and the current density
\bqbl
&&
B^{\gr,\gt,\gf}=\left\{
0
,-\R{\bgY'}{\q{g}}
,\R{\baF}{r^2}
\right\}
,\quad
B_{\gr,\gt,\gf}=\left\{
\bgn
,\baJ
,\baF
\right\}
+\na b
,\quad
\baF=\R{r^2}{\q{g}}(\bgF'-\gh'_\gt)
,\\&&
\R{4\gp}{c}j^{\gr,\gt,\gf}=\left\{
0,
-\R{\baF'}{\q{g}},
\R{\baJ'-\bgn'_\gt}{\q{g}}
\right\}
.\eqbl
Maxwell and equilibrium equations
\bqbl
&&
\baJ'-\bgn'_{\gt}=
-\left(\R{g_{\gt\gt}}{\q{g}}\bgY'\right)'_\gr
+\left(\R{g_{a\gt}}{\q{g}}\bgY'\right)'_\gt
,\quad
\q{g}\bsp'=
-\R{\q{g}}{r^2}\baF\baF'
+(\baJ'-\bgn'_{\gt})\bgY'
.\eqbl
Straight field line coordinates $a,\gq,\gz$
\bqbl
&&
a
=
\gr
,\quad
\gq
=
\gt
,\quad
\gz
=
\gf
-\gd
,\quad
\gd'_\gt
=
-q\bgh'_\gt
,\quad
\bgh
=
\R{\gh}{\bgF'}
=
-\int^\gt_0\left(\R{L}{L_0}-1\right)d\gt
,\\&&
L
=
\R{\q{g}}{r^2}
=
\R{D}{r}
,\quad
q
\equiv
-\R{L_0\baF}{\bgY'}
,\quad
\gm
\equiv
\r{q}
.\eqbl
Metric tensor in coordinates $a,\gq,\gz$
\bqbl
&&
dl^2
=
g_{\gr\gr}d\gr^2
+2g_{\gr\gt}d\gr d\gt
+g_{\gt\gt}d\gt^2
+r^2d\gf^2
,\\&&
dl^2
=
g_{aa}da^2
+2g_{a\gq}dad\gq
+g_{\gq\gq}d\gq^2
+2g_{a\gz}dad\gz
+2g_{\gq\gz}d\gq d\gz
+r^2d\gz^2
,\\&&
d\gf
=
\gd'_ada
+\gd'_\gt d\gq
+d\gz
,\\&&
d\gf^2
=
\gd'^2_ada^2
+2\gd'_a\gd'_\gt dad\gq
+\gd'^2_\gt d\gq^2
+2\gd'_adad\gz
+2\gd'_\gt d\gq d\gz
+d\gz^2
,\\&&
g_{aa}
=
g_{\gr\gr}+r^2\gd'^2_\gr
,\quad
g_{a\gq}
=
g_{a\gt}+r^2\gd'_a\gd'_\gt
,\quad
g_{\gq\gq}
=
g_{\gt\gt}+r^2\gd'^2_\gt
,\\&&
g_{a\gz}
=
r^2\gd'_a
,\quad
g_{\gq\gz}
=
r^2\gd'_\gt
,\quad
g_{\gz\gz}
=
r^2
.\eqbl
Equilibrium magnetic field and the current density in coordinates $a,\gq,\gz$
\bqbl
&&
A_{a,\gq,\gz}
=
\left\{
0
,\bgF
,\bgY
\right\}
,\quad
B^{a,\gq,\gz}
=
\left\{
0
,-\R{\bgY'}{\q{g}}
,\R{L_0\baF}{\q{g}}
\right\}
=
\left\{
0
,-\R{\bgY'}{\q{g}}
,\R{\bgF'}{\q{g}}
\right\}
,\\&&
B_{a,\gq,\gz}=\left\{
\bgn+\gd'_a\baF+b'_a
,\baJ+\gd'_\gt\baF+b'_\gt
,\baF
\right\}
,\quad
\R{4\gp}{c}j^{a,\gq,\gz}=\left\{
0,
-\R{\baF'}{\q{g}},
\R{\baJ'-\bgn'_\gq+\gd'_\gt\baF'}{\q{g}}
\right\}
.\eqbl
Maxwell and equilibrium equations in coordinates $a,\gq,\gz$
\bqbl
&&
\baJ'-\bgn'_{\gq}=
-\left(\R{g_{\gt\gt}}{\q{g}}\bgY'\right)'_a
+\left(\R{g_{a\gt}}{\q{g}}\bgY'\right)'_\gq
,\quad
\q{g}\bsp'=
-\bgF'\baF'
+(\baJ'-\bgn'_{\gq}+\gd'_\gt\baF')\bgY'
.\eqbl
In the following, in order to distinguish between averaged and
oscillating parts of the periodic functions the indexes ${}_\cup$,
${}_\til$ ${}_0$ are used correspondingly for general function of the
angle variable, for oscillating function, and for function independent
of angle. The first index refers to dependence on $\gq$, while the
second on to  dependence on $\gz$. Thus, the general function
$f(a,\gq,\gz)$ can be represnted as
\bqbl
&&
f
\equiv
f_{\cup\cup}
\equiv
f_{\cup0}
+f_{\cup\til}
\equiv
f_{00}
+f_{\til0}
+f_{0\til}
+f_{\til\til}
\equiv
f_{0\cup}
+f_{\til\cup}
.\eqbl

\section{Functional of potental energy in the ideal MHD}
\bqbl
&&
W=\r{8\gp}\int\left\{
\t\waB^2
+(\vgx\cdot\na\bsp)(\na\cdot\vgx)
-\vgx\times(\na\times\waB)\cdot\t\waB
+\gg_0\bsp(\na\cdot\vgx)^2
\right\}dV
.\eqbl
The displacement vector
\bqbl
&&
\gx^{a,\gq,\gz}\equiv
\left\{\gx^a,\gx^\gq,\gx^\gz\right\}
,\quad
\t{\bf B}=\na\times\left(\vec{\gx}\times{\bf B}\right)
,\\&&
\left(\vec{\gx}\times{\bf B}\right)_{a,\gq,\gz}=
\q{g}\left\{
B^\gz\gx^\gq-B^\gq\gx^\gz
, -B^\gz\gx
,B^\gq\gx
\right\}=
\left\{
\gL
,-\bgF'\gx
,-\bgY'\gx
\right\}
,\quad
\gL\equiv\bgF'\gx^\gq+\bgY'\gx^\gz
\eqbl
and the perturbed magnetic field
\bqbl
&&
\taB^{a,\gq,\gz}=
\r{\q{g}}\left\{
\bgF'\gx'_\gz-\bgY'\gx'_\gq
,\gL'_\gz+(\bgY'\gx)'_a
,-\gL'_\gq-(\bgF'\gx)'_a
\right\}
.\eqbl
Contribution of $\t{\waB}^2$
\bqbl
\r{8\gp}\int\t{\waB}^2dV
&=&
\r{8\gp}\int\left\{
\R{g_{aa}}{\q{g}}(\bgF'\gx'_\gz-\bgY'\gx'_\gq)^2
+2\R{g_{a\gq}}{\q{g}}[\gL'_\gz+(\bgY'\gx)'_a](\bgF'\gx'_\gz-\bgY'\gx'_\gq)
+\R{g_{\gq\gq}}{\q{g}}[\gL'_\gz+(\bgY'\gx)'_a]^2
\right.\\&&\left.
+2\R{r^2\gd'_a}{\q{g}}(\bgF'\gx'_\gz-\bgY'\gx'_\gq)[-\gL'_\gq-(\bgF'\gx)'_a]
\right.\\&&\left.
+2\R{r^2\gd'_\gt}{\q{g}}[\gL'_\gz+(\bgY'\gx)'_a][-\gL'_\gq-(\bgF'\gx)'_a]
+\R{r^2}{\q{g}}[-\gL'_\gq-(\bgF'\gx)'_a]^2
\right\}da d\gq d\gz
.\eqbl
Variable $X=\q{g}(\na\cdot\vgx)$ associated with the compressibility of
$\vgx$  
\bqbl
&&
X
\equiv
(\q{g}\gx)'_a
+(\q{g}\gx^\gq)'_\gq
+(\q{g}\gx^\gz)'_\gz
,\quad
(\q{g}\gx)'_a
+\R{\bgY'(\q{g}\gx^\gq)'_\gq-\bgF'(\q{g}\gx^\gq)'_\gz}{\bgY'}
+\R{(\q{g}\gL)'_\gz}{\bgY'}
=
X
\eqbl
Contribution of $(\vgx\cdot\na\bsp)(\na\cdot\vgx)$
\bqbl
&&
(\vec{\gx}\cdot\na\bsp)(\na\cdot\vec{\gx})
=
\R{\bsp'}{\q{g}}\gx X
.\eqbl
Contribution of $\vgx\times(\na\times\waB)\cdot\t{\waB}$
\bqbl
&&
-\R{4\gp}{c}(\vgx\times\wsj)_{a,\gq,\gf}=
-\left\{
(\baJ'-\bgn'_{\gq}+\gd'_\gq\baF)\gx^\gq+\baF'\gx^\gz
,-(\baJ'-\bgn'_{\gq}+\gd'_\gq\baF')\gx
,-\baF'\gx
\right\}
,\\&&
-\R{4\gp}{c}(\vgx\times\wsj)_{a,\gq,\gf}=
\left\{
-\R{\bsp'\q{g}}{\bgY'}\gx^\gq-\R{\gL}{\bgY'}\baF'
,\R{\bsp'\q{g}}{\bgY'}\gx+\R{\bgF'\baF'}{\bgY'}\gx
,\baF'\gx
\right\}
.\eqbl
With new notations
\bqbl
&&
P
\equiv
\R{\bsp}{\bgY'}
,\quad
F_s
\equiv
\R{\baF'}{\bgY'}
,\quad
v
\equiv
\R{\q{g}}{\bgF'}
\eqbl
$\vgx\times(\na\times\waB)\cdot\t{\waB}$ becomes
\bqbl
&&
-\R{4\gp}{c}(\vgx\times\wsj)_{a,\gq,\gf}=
\left\{
-P\q{g}\gx^\gq-F_s\gL
,P\q{g}\gx+F_s\bgF'\gx
,F_s\bgY'\gx
\right\}
.\eqbl
Contribution after straightforward substitution in terms of
$\gx,\gx^\gq,\gx^\gz$ 
\bqbl
\r{8\gp}\int\left\{-\vgx\times(\na\times\waB)\cdot\t{\waB}\right\}dV
=
&&
\r{8\gp}\int\left\{
P[\bgF'(\q{g}\gx^\gq)'_\gz-\bgY'(\q{g}\gx^\gq)'_\gq]\gx
+P\q{g}\gx\gL'_\gz
+P\q{g}\gx(\bgY'\gx)'_a
\right.\\&&\left.
+2F_s\bgF'\gx\gL'_\gz
-2F_s\bgY'\gx\gL'_\gq
+F_s\bgF'\gx(\bgY'\gx)'_a
-F_s\bgY'\gx(\bgF'\gx)'_a
\right\}da d\gq d\gz
=
\\
&&
\r{8\gp}\int\left\{
-\bsp'X\gx
+P(\q{g}\gx)'_a\bgY'\gx
+2P\q{g}\gL'_\gz\gx
+P\q{g}\gx(\bgY'\gx)'_a
\right.\\&&\left.
+2F_s\bgF'\gx\gL'_\gz
-2F_s\bgY'\gx\gL'_\gq
+F_s\bgF'\gx\bgY''\gx
-F_s\bgY'\gx\bgF''\gx
\right\}da d\gq d\gz
=
\\
&&
\r{8\gp}\int\left\{
-\bsp'X\gx
+[P\q{g}\bgY'\gx^2]'_a
-P'\q{g}\bgY'\gx^2
+2P\q{g}\gL'_\gz\gx
\right.\\&&\left.
+2F_s\bgF'\gx\gL'_\gz
-2F_s\bgY'\gx\gL'_\gq
-F_s\gm'\bgF'^2\gx^2
\right\}da d\gq d\gz
.\eqbl
Contribution of $(\vgx\cdot\na\bsp)(\na\cdot\vgx)
-\vgx\times(\na\times\waB)\cdot\t{\waB}$ 
\bqbl
\r{8\gp}&&\int\left\{
  \vgx\cdot\na\bsp)(\na\cdot\vgx)
 -\vgx\times(\na\times\waB)\cdot\t{\waB}
 \right\}dV
=
\\&&
\r{8\gp}\int\left\{
[P\q{g}\bgY'\gx^2]'_a
-P'\q{g}\bgY'\gx^2
+2P\q{g}\gL'_\gz\gx
+2F_s\bgF'\gx\gL'_\gz
-2F_s\bgY'\gx\gL'_\gq
-F_s\gm'\bgF'^2\gx^2
\right\}da d\gq d\gz
.\eqbl
Functional of potental energy in terms of $\gx,\gL,X$
\bqbl
W
=
\r{8\gp}&&\int\left\{
\R{\gg_0\bsp}{\q{g}}X^2
+\R{g_{aa}}{\q{g}}(\bgF'\gx'_\gz-\bgY'\gx'_\gq)^2
+2\R{g_{a\gq}}{\q{g}}[\gL'_\gz+(\bgY'\gx)'_a](\bgF'\gx'_\gz-\bgY'\gx'_\gq)
+\R{g_{\gq\gq}}{\q{g}}[\gL'_\gz+(\bgY'\gx)'_a]^2
\right.\\&&\left.
+2\R{r^2\gd'_a}{\q{g}}(\bgF'\gx'_\gz-\bgY'\gx'_\gq)[-\gL'_\gq-(\bgF'\gx)'_a]
+2\R{r^2\gd'_\gt}{\q{g}}[\gL'_\gz+(\bgY'\gx)'_a][-\gL'_\gq-(\bgF'\gx)'_a]
\right.\\&&\left.
+\R{r^2}{\q{g}}[-\gL'_\gq-(\bgF'\gx)'_a]^2
+\left[Pv\bgF'\bgY'\gx^2\right]'_a
\right.\\&&\left.
-P'v\bgF'\bgY'\gx^2
+2Pv\bgF'\gx\gL'_\gz
+2F_s\bgF'\gx\gL'_\gz
-2F_s\bgY'\gx\gL'_\gq
-F_s\gm'\bgF'^2\gx^2
\right\}da d\gq d\gz
,\\&&
X
=
\q{g}(\na\cdot\vgx)
.\eqbl

\subsection{Matrix form of the potental energy in the ideal MHD}
Definitions of vectors in Fourier space
\bqbl
&&
X
=
\sum^M_{m=-M}X_me^{im\gq-in\gz}
+\sum^M_{m=-M}X^*_me^{-im\gq+in\gz}
,\quad
\vaX
\equiv
\{X_m\}
,\\&&
\gx
=
\sum^M_{m=-M}\gx_me^{im\gq-in\gz}
+\sum^M_{m=-M}\gx^*_me^{-im\gq+in\gz}
,\quad
\vgx
\equiv
\{\gx_m\}
,\\&&
\gL
=
\sum^M_{m=-M}\gL_me^{im\gq-in\gz}
+\sum^M_{m=-M}\gL^*_me^{-im\gq+in\gz}
,\quad
\vgL
\equiv
\{\gL_m\}
.\eqbl
With these definitions after interegration over $\gq,\gz$, the potential
energy reduces to 
\bqbl
W
=
\gp&&\int\left\{
\gg_0\bsp(\vaX\maG\vaX^*)
+\bgF'^2(\vgx\maQ\maG_{aa}\maQ\vgx^*)
\right.\\&&\left.
+[-in\vgL+(\bgY'\vgx)']\maG_{a\gq}(-i\maQ\bgF'\vgx^*)
+\bgF'i\vgx\maQ\maG_{a\gq}[in\vgL^*+(\bgY'\vgx^*)']
\right.\\&&\left.
+[-in\vgL+(\bgY'\vgx)']\maG_{\gq\gq}[in\vgL^*+(\bgY'\vgx^*)']
\right.\\&&\left.
+\bgF'i\vgx\maQ\maG_{a\gz}[i\maM\vgL^*-(\bgF'\vgx^*)']
+[-i\vgL\maM-(\bgF'\vgx)']\maG_{a\gz}(-i\maQ\bgF'\vgx^*)
\right.\\&&\left.
+[-in\vgL+(\bgY'\vgx)']\maG_{\gq\gz}[i\maM\vgL^*-(\bgF'\vgx^*)']
+[-i\vgL\maM-(\bgF'\vgx)']\maG_{\gq\gz}[in\vgL^*+(\bgY'\vgx^*)']
\right.\\&&\left.
+[-i\vgL\maM-(\bgF'\vgx)']\maG_{\gz\gz}[i\maM\vgL^*-(\bgF'\vgx^*)']
\right.\\&&\left.
+\left[P\bgF'\bgY'\vgx\msv\vgx^*\right]'
-P'\bgF'\bgY'(\vgx\msv\vgx^*)
+nP\bgF'(i\vgx\msv\vgL^*-i\vgL\msv\vgx^*)
\right.\\&&\left.
+nF_s\bgF'(i\vgx\vgL^*-i\vgL\vgx^*)
+F_s\bgY'(i\vgx\maM\vgL^*-i\vgL\maM\vgx^*)
-F_s\gm'\bgF'^2(\vgx\vgx^*)
\right\}da
,\eqbl
where the matrices are defined as
\bqbl
&&
\maI^{mm'}
\equiv
\gd^{mm'}
,\quad
\maM^{mm'}
\equiv
m\gd^{mm'}
,\quad
\maQ
\equiv
\gm\maM-n\maI
,\quad
\maG^{mm'}
\equiv
\left(\R{e^{i(m-m')\gq}}{\q{g}}\right)_0
,\\&&
 \maG^{mm'}_{aa}
\equiv
\left(\R{g_{aa}}{\q{g}}e^{i(m-m')\gq}\right)_0
,\quad
\maG^{mm'}_{a\gq}
\equiv
\left(\R{g_{a\gq}}{\q{g}}e^{i(m-m')\gq}\right)_0
,\quad
\maG^{mm'}_{\gq\gq}
\equiv
\left(\R{g_{\gq\gq}}{\q{g}}e^{i(m-m')\gq}\right)_0
,\\&&
\maG^{mm'}_{a\gz}
\equiv
\left(\R{r^2\gd'_a}{\q{g}}e^{i(m-m')\gq}\right)_0
,\quad
\maG^{mm'}_{\gq\gz}
\equiv
\left(\R{r^2\gd'_\gq}{\q{g}}e^{i(m-m')\gq}\right)_0
,\quad
\maG^{mm'}_{\gz\gz}
\equiv
\left(\R{r^2}{\q{g}}e^{i(m-m')\gq}\right)_0
,\\&&
\msv^{mm'}
\equiv
\left(ve^{i(m-m')\gq}\right)_0
.\eqbl
All of these matrices are Hermitian
\bqbl
&&
\maM
=\maM^\dagger
,\quad
\maQ
=\maQ^\dagger
,\quad
\maG
=
\maG^\dagger
,\quad
\maG_{aa}
=
\maG^\dagger_{aa}
,\quad
\ldots
,\quad
\msv
=\msv^\dagger
,\eqbl
where dagger denotes Hermitian conjugate.

\section{Functional of potental energy in terms of $\t{\waA}$}
\bqbl
&&
W=\r{8\gp}\int\left\{
\t\waB^2
+(\vgx\cdot\na\bsp)(\na\cdot\vgx)
-\vgx\times(\na\times\waB)\cdot\t\waB
+\gg_0\bsp(\na\cdot\vgx)^2
\right\}dV
.\eqbl
The perturbed vector potential $\t{\waA}$ and its reduction by adding a
scalar potential
\bqbl
&&
\taA_{a,\gq,\gz}=\left\{
0
,\taA_\gq
,\taA_\gz
\right\}
+\na u
,\quad
\taA_\gq
=
\taA_{\gq0\cup}
+\taA_{\gq\til\cup}
,\quad
+\taA_{\gq\til\cup}
+u'_\gq
=
0
,\quad
\taA_\gq
+u'_\gq
\equiv
\gj
,\quad
\gj
=
\gj_{0\cup}
,\\&&
\taA_{a,\gq,\gz}=\left\{
\taA_a
,\gj
,\taA_\gz
\right\}
+\na u^1
,\quad
\taA_\gz
=
\taA_{\gz00}
+\taA_{\gz0\til}
+\taA_{\gz\til\cup}
,\quad
\taA_\gz
+u'^1_{0,\til,\gz}
\equiv
\gy
-\gm\gj
,\quad
\gy
=
\gy_{00}
+\gy_{\til\cup}
.\eqbl
Here, $\gy$ refers to the parallel component of the vector potential
\bqbl
&&
(\t{\waA}\cdot\t{\waB})
=
\R{\bgF'}{\q{g}}
[\gm\gj+\gy-\gm\gj]
=
\R{\bgF'}{\q{g}}\gy
.\eqbl
Thus, a convenient form for $\t{\waA}$ is
\bqbl
&&
\taA_{a,\gq,\gz}=\left\{
\tgh-\int^\gz_0(\gm\gj)'_ad\gz
,\gj
,\gy-\gm\gj
\right\}
,\quad
\tgh
\equiv
\tgh_{\til\cup}
,\quad
\gj
\equiv
\gj_{0\cup}
,\quad
\gy
\equiv
\gy_{00}
+\gy_{\til\cup}
.\eqbl
The integral term in the radial component of $\t{\waA}$ is the function
of $a$ and $\gz$ only and was included to simplify the expression for
the magnetic field. In the case of the ideal 
MHD 
\bqbl
&&
A_\gq
=
[\bgF(A_\gz)]_{0\cup}
,\quad
\bgF+\gj_{00}
=
[\bgF(\bgY+\gy-\gm\gj)]_{0\cup}
=
\bgF
+[\bgF'(\gy-\gm\gj)]_{0\cup}
,\quad
\gj_{00}
=
-q(\gy_{00}-\gm\gj)
\eqbl
the zeroth harmonic, $\gy_{00}$, of $\gy$ is absent
\bqbl
&&
\gy
=
\gy_{\til\cup}
,\quad
\gy_{00}=0
\eqbl
and the vector potential is represented as
\bqbl
&&
\taA_{a,\gq,\gz}=\left\{
\tgh-\int^\gz_0(\gm\gj)'_ad\gz
,\gj
,\gy-\gm\gj
\right\}
,\quad
\tgh
\equiv
\tgh_{\til\cup}
,\quad
\gj
\equiv
\gj_{0\cup}
,\quad
\gy
\equiv
\gy_{\til\cup}
.\eqbl
The perturbed magnetic field
\bqbl
&&
\taB^{a,\gq,\gz}=
\r{\q{g}}\left\{
\gy'_\gq-\gj'_\gz
,\tgh'_\gz-\gy'_a
,\gj'_a-\tgh'_\gq
\right\}
.\eqbl
Relationships between $\tgh,\gj,\gy$ and $\gx,\gL$
\bqbl
&&
\bgF'\gx'_\gz-\bgY'\gx'_\gq
=
\gy'_\gq-\gj'_\gz
,\quad
\gL'_\gz+(\bgY'\gx)'_a
=
\tgh'_\gz-\gy'_a
,\quad
-\gL'_\gq-(\bgF'\gx)'_a
=
\gj'_a-\tgh'_\gq
.\eqbl
New independent variables, $u\equiv u_{\til\cup}$ instead of $\gx$ and
$\tgh$ instead of $\gL$ 
\bqbl
&&
\bgF'\gx=u'_\gq-\gj
,\quad
\gL=\tgh-u'_a-\int^\gz_0(\gm\gj)'_ad\gz
,\\&&
\bgF'\gx=u'_\gq-\gj
,\quad
-\bgY'\gx=\gm(u'_{\gq}-\gj)
,\quad
\gL'_\gz=\tgh'_\gz-u''_{a\gz}-(\gm\gj)'_a
,\quad
\gL'_\gq=\tgh'_\gq-u''_{a\gq}
,\\&&
\gy
\equiv
\gm u'_\gq
+u'_{\gz}
,\quad
\bgF'\gx'_\gz-\bgY'\gx'_\gq=
\gy'_\gq
-\gj'_\gz
.\eqbl
Substitution of new variables into functional of potental energy 
\bqbl
&&
-\gL'_\gq-(\bgF'\gx)'_a=\gj'_a-\tgh'_\gq
,\quad
\gL'_\gz+(\bgY'\gx)'_a=\tgh'_\gz-\gy'_a
,\quad
\bgF'\gx'_\gz-\bgY'\gx'_\gq
=
\gy'_\gq-\gj'_\gz
,\\
W
=
\r{8\gp}&&\int\left\{
\R{\gg_0\bsp}{\q{g}}X^2
+\R{g_{aa}}{\q{g}}(\bgF'\gx'_\gz-\bgY'\gx'_\gq)^2
+2\R{g_{a\gq}}{\q{g}}[\gL'_\gz+(\bgY'\gx)'_a](\bgF'\gx'_\gz-\bgY'\gx'_\gq)
+\R{g_{\gq\gq}}{\q{g}}[\gL'_\gz+(\bgY'\gx)'_a]^2
\right.\\&&\left.
+2\R{r^2\gd'_a}{\q{g}}(\bgF'\gx'_\gz-\bgY'\gx'_\gq)[-\gL'_\gq-(\bgF'\gx)'_a]
+2\R{r^2\gd'_\gt}{\q{g}}[\gL'_\gz+(\bgY'\gx)'_a][-\gL'_\gq-(\bgF'\gx)'_a]
\right.\\&&\left.
+\R{r^2}{\q{g}}[-\gL'_\gq-(\bgF'\gx)'_a]^2
+\left[Pv\bgF'\bgY'\gx^2\right]'_a
\right.\\&&\left.
-P'v\bgF'\bgY'\gx^2
+2Pv\bgF'\gx\gL'_\gz
+2F_s\bgF'\gx\gL'_\gz
-2F_s\bgY'\gx\gL'_\gq
-F_s\gm'\bgF'^2\gx^2
\right\}da d\gq d\gz
=
\\
\r{8\gp}&&\int\left\{
\R{\gg_0\bsp}{\q{g}}X^2
+\R{g_{aa}}{\q{g}}(\gy'_\gq-\gj'_\gz)^2
+2\R{g_{a\gq}}{\q{g}}(\tgh'_\gz-\gy'_a)(\gy'_\gq-\gj'_\gz)
+\R{g_{\gq\gq}}{\q{g}}(\tgh'_\gz-\gy'_a)^2
\right.\\&&\left.
+2\R{r^2\gd'_a}{\q{g}}(\gy'_\gq-\gj'_\gz)(\gj'_a-\tgh'_\gq)
+2\R{r^2\gd'_\gt}{\q{g}}(\tgh'_\gz-\gy'_a)(\gj'_a-\tgh'_\gq)
+\R{r^2}{\q{g}}(\gj'_a-\tgh'_\gq)^2
\right.\\&&\left.
+\left[Pv\bgF'\bgY'\gx^2\right]'_a
-P'v\bgF'\bgY'\gx^2
+2Pv\bgF'\gx[-(\bgY'\gx)'_a+\tgh'_\gz-\gy'_a]
\right.\\&&\left.
+2F_s\bgF'\gx[-(\bgY'\gx)'_a+\tgh'_\gz-\gy'_a]
-2F_s\bgY'\gx[-(\bgF'\gx)'_a-\gj'_a+\tgh'_\gq]
-F_s\gm'\bgF'^2\gx^2
\right\}da d\gq d\gz
.\eqbl
The last two lines can be represented as
\bqbl
W
=
\r{8\gp}&&\int\left\{
\ldots
\right.\\&&\left.
+\left[Pv\bgF'\bgY'\gx^2\right]'_a
-P'v\bgF'\bgY'\gx^2
+2Pv\bgF'\gx[-(\bgY'\gx)'_a+\tgh'_\gz-\gy'_a]
\right.\\&&\left.
+2F_s\bgF'\gx[-(\bgY'\gx)'_a+\tgh'_\gz-\gy'_a]
-2F_s\bgY'\gx[-(\bgF'\gx)'_a-\gj'_a+\tgh'_\gq]
-F_s\gm'\bgF'^2\gx^2
\right\}da d\gq d\gz
=
\\
\r{8\gp}&&\int\left\{
\ldots
+Pv'_a\bgF'\bgY'\gx^2
+Pv\gm'\bgF'^2\gx^2
+2Pv\bgF'\gx(\tgh'_\gz-\gy'_a)
\right.\\&&\left.
+F_s\gm'\bgF'^2\gx^2
-2F_s\bgY'\gx(\tgh'_\gq-\gj'_a)
+2F_s\bgF'\gx(\tgh'_\gz-\gy'_a)
\right\}da d\gq d\gz
=
\\
\r{8\gp}&&\int\left\{
\ldots
-Pv'_a\gm(u'_\gq-\gj)^2
+Pv\gm'(u'_\gq-\gj)^2
-2Pv(u'_\gq-\gj)\gy'_a
+2Pv(u'_\gq-\gj)\tgh'_\gz
\right.\\&&\left.
+F_s\gm'(u'_\gq-\gj)^2
+2F_s\gm(u'_{\gq}-\gj)(\tgh'_\gq-\gj'_a)
+2F_s(u'_\gq-\gj)(\tgh'_\gz-\gy'_a)
\right\}da d\gq d\gz
=
\\
\r{8\gp}&&\int\left\{
\ldots
-[Pv_0u'_\gq\gy]'_a
+P'v_0u'_\gq\gy
+Pv'_0u'_\gq u'_\gz
-2Pv_\til(u'_\gq-\gj)\gy'_a
+P(\gm'v_\til-\gm v'_{\til,a})(u'_\gq-\gj)^2
\right.\\&&\left.
+P(v_0\gm'-\gm v'_0)\gj^2
+2Pv(u'_\gq-\gj)\tgh'_\gz
\right.\\&&\left.
+[F_s\gm\gj^2]'_a
+F_s\gm'u'^2_\gq
+2F_s\gm u'_\gq\tgh'_\gq
+2F_su'_\gq(\tgh'_\gz-\gy'_a)
-2F_s\gj\tgh'_\gz
-F'_s\gm\gj^2
\right\}da d\gq d\gz
=
\\
\r{8\gp}&&\int\left\{
\ldots
-[Pv_0u'_\gq\gy]'_a
+P'v_0u'_\gq\gy
+Pv'_0u'_\gq u'_\gz
-2Pv_\til(u'_\gq-\gj)\gy'_a
+P(\gm'v_\til-\gm v'_{\til,a})(u'_\gq-\gj)^2
\right.\\&&\left.
+P(v_0\gm'-\gm v'_0)\gj^2
+2Pv(u'_\gq-\gj)\tgh'_\gz
\right.\\&&\left.
+[F_s\gm\gj^2]'_a
-[F_su'_\gq\gy]'_a
+F'_su'_\gq\gy
+2F_s\gy\tgh'_\gq
-2F_s\gj\tgh'_\gz
-F'_s\gm\gj^2
\right\}da d\gq d\gz
.\eqbl
The final expression for the potential energy can be written as
\bqbl
W
=
\r{8\gp}&&\int\left\{
\R{\gg_0\bsp}{\q{g}}X^2
+\R{g_{aa}}{\q{g}}(\gy'_\gq-\gj'_\gz)^2
+2\R{g_{a\gq}}{\q{g}}(\tgh'_\gz-\gy'_a)(\gy'_\gq-\gj'_\gz)
+\R{g_{\gq\gq}}{\q{g}}(\tgh'_\gz-\gy'_a)^2
\right.\\&&\left.
+2\R{r^2\gd'_a}{\q{g}}(\gy'_\gq-\gj'_\gz)(\gj'_a-\tgh'_\gq)
+2\R{r^2\gd'_\gt}{\q{g}}(\tgh'_\gz-\gy'_a)(\gj'_a-\tgh'_\gq)
+\R{r^2}{\q{g}}(\gj'_a-\tgh'_\gq)^2
\right.\\&&\left.
+[F_s\gm\gj^2-(Pv_0+F_s)u'_\gq\gy+2Pv_\til\gj\gy]'_a
\right.\\&&\left.
+(P'v_0+F'_s)u'_\gq\gy
+Pv'_0u'_\gq u'_\gz
+P(\gm'v_\til-\gm v'_{\til,a})u'^2_\gq
-2Pv_\til u'_\gq\gy'_a
\right.\\&&\left.
-2P'v_\til\gj\gy
-2Pv_\til\gj'_a\gy
-2P\gm'v_\til u'_\gq\gj
-2Pv'_{\til,a}u'_\gz\gj
+2Pv(u'_\gq-\gj)\tgh'_\gz
\right.\\&&\left.
+P(\gm'v_0-\gm v'_0)\gj^2
+2F_s\gy\tgh'_\gq
+2F_s\gj'_\gz\tgh
-F'_s\gm\gj^2
\right\}da d\gq d\gz
.\eqbl

In Hamada coordinates, where $v\equiv v_0$, the expression for the
potential energy is especially simple
\bqbl
W
=
\r{8\gp}&&\int\left\{
\R{\gg_0\bsp}{\q{g}}X^2
+\R{g_{aa}}{\q{g}}(\gy'_\gq-\gj'_\gz)^2
+2\R{g_{a\gq}}{\q{g}}(\tgh'_\gz-\gy'_a)(\gy'_\gq-\gj'_\gz)
+\R{g_{\gq\gq}}{\q{g}}(\tgh'_\gz-\gy'_a)^2
\right.\\&&\left.
+2\R{r^2\gd'_a}{\q{g}}(\gy'_\gq-\gj'_\gz)(\gj'_a-\tgh'_\gq)
+2\R{r^2\gd'_\gt}{\q{g}}(\tgh'_\gz-\gy'_a)(\gj'_a-\tgh'_\gq)
+\R{r^2}{\q{g}}(\gj'_a-\tgh'_\gq)^2
\right.\\&&\left.
+[F_s\gm\gj^2-(Pv_0+F_s)u'_\gq\gy]'_a
+(P'v_0+F'_s)u'_\gq\gy
+Pv'_0u'_\gq u'_\gz
\right.\\&&\left.
+P(\gm'v_0-\gm v'_0)\gj^2
+2Pv_0(u'_\gq-\gj)\tgh'_\gz
+2F_s\gy\tgh'_\gq
+2F_s\gj'_\gz\tgh
-F'_s\gm\gj^2
\right\}da d\gq d\gz
.\eqbl

In axisymmetric straight field line coordinates, where $\gd=0$, the
expression for the potential energy can be reduced to
\bqbl
W
=
\r{8\gp}&&\int\left\{
\R{\gg_0\bsp}{\q{g}}X^2
+\R{g_{\gr\gr}}{\q{g}}(\gy'_\gt-\gj'_\gf)^2
+2\R{g_{\gr\gt}}{\q{g}}(\tgh'_\gf-\gy'_\gr)(\gy'_\gt-\gj'_\gf)
+\R{g_{\gt\gt}}{\q{g}}(\tgh'_\gf-\gy'_\gr)^2
+\R{r^2}{\q{g}}(\gj'_\gr-\tgh'_\gt)^2
\right.\\&&\left.
+[F_s\gm\gj^2-(Pv_0+F_s)u'_\gt\gy+2Pv_\til\gj\gy]'_\gr
\right.\\&&\left.
+(P'v_0+F'_s)u'_\gt\gy
+Pv'_0u'_\gt u'_\gf
+P(\gm'v_\til-\gm v'_{\til,\gr})u'^2_\gt
-2Pv_\til u'_\gt\gy'_\gr
\right.\\&&\left.
-2P'v_\til\gj\gy
-2Pv_\til\gj'_a\gy
-2P\gm'v_\til u'_\gt\gj
-2Pv'_{\til,\gr}u'_\gf\gj
+2Pv(u'_\gt-\gj)\tgh'_\gf
\right.\\&&\left.
+P(\gm'v_0-\gm v'_0)\gj^2
+2F_s\gy\tgh'_\gt
+2F_s\gj'_\gf\tgh
-F'_s\gm\gj^2
\right\}d\gr d\gt d\gf
,\\&&
v
=
\R{r^2}{\baF}
.\eqbl

\subsection{Matrix form of the potental energy in terms of $\t{\waA}$}
New independent vectors in Fourier space
\bqbl
&&
u
=
\sum^M_{m=-M}u_me^{im\gq-in\gz}
+\sum^M_{m=-M}u^*_me^{-im\gq+in\gz}
,\quad
\vsu
\equiv
\{u_m\}_{m\neq0}
,\quad
u_0
=0
,\quad
\vgy
\equiv
i\maQ\vsu
,\\&&
\vgh
=
\sum^M_{m=-M}\tgh_me^{im\gq-in\gz}
+\sum^M_{m=-M}\tgh^*_me^{-im\gq+in\gz}
,\quad
\vgh
\equiv
\{\tgh_m\}
.\eqbl
In the self-adjoint form, the potential energy is
represented by the functional
\bqbl
W
=
\gp&&\int\left\{
\gg_0\bsp(\vaX\maG\vaX^*)
+(\vgy\maM+n\gj)\maG_{aa}(\maM\vgy^*+n\gj^*)
\right.\\&&\left.
+(\vgy'+in\vgh)i\maG_{a\gq}(\maM\vgy^*+n\gj^*)
-(\vgy\maM+n\gj)i\maG_{a\gq}(\vgy'^*-in\vgh^*)
\right.\\&&\left.
+(\vgy'+in\vgh)\maG_{\gq\gq}(\vgy'^*-in\vgh^*)
\right.\\&&\left.
+(\vgy\maM+n\gj)i\maG_{a\gz}(\gj'^*+i\maM\vgh^*)
-(\gj'-i\vgh\maM)i\maG_{a\gz}(\maM\vgy^*+n\gj^*)
\right.\\&&\left.
-(\vgy'+in\vgh)\maG_{\gq\gz}(\gj'^*+i\maM\vgh^*)
-(\gj'-i\vgh\maM)\maG_{\gq\gz}(\vgy'^*-in\vgh^*)
+(\gj'-i\vgh\maM)\maG_{\gz\gz}(\gj'^*+i\maM\vgh^*)
\right.\\&&\left.
-[Pv_0\vgy\maM\maQ^{-1}\vgy^*]'
-[F_s\maM\maQ^{-1}\vgy\vgy^*]'
+[F_s\gm\gj\gj^*]'
+[P\vgy\msv_\til\gj^*+P\gj\msv_\til\vgy^*]'_a
\right.\\&&\left.
+(P'v_0+F'_s)\vgy\maM\maQ^{-1}\vgy^*
-nPv'_0\vgy\maM\maQ^{-2}\vgy^*
\right.\\&&\left.
+P\maM\maQ^{-1}\vgy(\gm'\msv_\til-\gm\msv'_{\til,a})\maM\maQ^{-1}\vgy^*
-P[\vgy\maM\maQ^{-1}\msv_\til\vgy'^*+\vgy'\msv_\til\maM\maQ^{-1}\vgy^*]
\right.\\&&\left.
+nP[\vgy\maQ^{-1}\msv'_{\til,a}\gj^*+\gj\msv'_{\til,a}\maQ^{-1}\vgy^*]
-P'[\vgy\msv_\til\gj^*+\gj\msv_\til\vgy^*]
-P[\vgy\msv_\til\gj'^*+\gj'\msv_\til\vgy^*]
\right.\\&&\left.
-\gm'P[\maM\maQ^{-1}\vgy\msv_\til\gj^*+\gj\msv_\til\maM\maQ^{-1}\vgy^*]
+inP[(\maM\maQ^{-1}\vgy-\gj)\msv\vgh^*-\vgh\msv(\maM\maQ^{-1}\vgy^*-\gj^*)]
\right.\\&&\left.
+P\gj(\gm'\msv_0-\gm\msv'_0)\gj^*
+F_s[i\vgh(\maM\vgy^*+n\gj^*)-i(\vgy\maM+n\gj)\vgh^*]
-\gm F'_s\gj\gj^*
\right\}da
.\eqbl
 
\section{Euler equations for $n\neq0$}
Functional of the potential energy
\bqbl
W
=
\r{8\gp}&&\int\left\{
\R{\gg_0\bsp}{\q{g}}X^2
+\R{g_{aa}}{\q{g}}(\gy'_\gq-\gj'_\gz)^2
+2\R{g_{a\gq}}{\q{g}}(\tgh'_\gz-\gy'_a)(\gy'_\gq-\gj'_\gz)
+\R{g_{\gq\gq}}{\q{g}}(\tgh'_\gz-\gy'_a)^2
\right.\\&&\left.
+2\R{r^2\gd'_a}{\q{g}}(\gy'_\gq-\gj'_\gz)(\gj'_a-\tgh'_\gq)
+2\R{r^2\gd'_\gt}{\q{g}}(\tgh'_\gz-\gy'_a)(\gj'_a-\tgh'_\gq)
+\R{r^2}{\q{g}}(\gj'_a-\tgh'_\gq)^2
\right.\\&&\left.
+[F_s\gm\gj^2-(Pv_0+F_s)u'_\gq\gy+2Pv_\til\gj\gy]'_a
\right.\\&&\left.
+(P'v_0+F'_s)u'_\gq\gy
+Pv'_0u'_\gq u'_\gz
+P(\gm'v_\til-\gm v'_{\til,a})u'^2_\gq
-2Pv_\til u'_\gq\gy'_a
\right.\\&&\left.
-2P'v_\til\gj\gy
-2Pv_\til\gj'_a\gy
-2P\gm'v_\til u'_\gq\gj
-2Pv'_{\til,a}u'_\gz\gj
+2Pv(u'_\gq-\gj)\tgh'_\gz
\right.\\&&\left.
+P(\gm'v_0-\gm v'_0)\gj^2
+2F_s\gy\tgh'_\gq
+2F_s\gj'_\gz\tgh
-F'_s\gm\gj^2
\right\}da d\gq d\gz
\eqbl
leads to the following equations for the test functions. The equation
for $X$ 
\bqbl
&&
X=0
.\eqbl
The equation for $\tgh$
\bqbl
&&
\left[
  \R{r^2}{\q{g}}\tgh'_\gq
-\R{r^2\gd'_\gt}{\q{g}}\tgh'_\gz
 \right]'_\gq
+\left[
  \R{g_{\gq\gq}}{\q{g}}\tgh'_\gz
 -\R{r^2\gd'_\gt}{\q{g}}\tgh'_\gq
 \right]'_\gz
=
\\&&
+\left[
 \R{r^2}{\q{g}}\gj'_a
 -\R{r^2\gd'_\gt}{\q{g}}\gy'_a
 +\R{r^2\gd'_a}{\q{g}}(\gy'_\gq-\gj'_\gz)
 -F_s\gy
 \right]'_\gq
\\&&
+\left[
  \R{g_{\gq\gq}}{\q{g}}\gy'_a
 -\R{g_{a\gq}}{\q{g}}(\gy'_\gq-\gj'_\gz)
 -\R{r^2\gd'_\gt}{\q{g}}\gj'_a
 -Pv(u'_\gq-\gj)
 +F_s\gj
 \right]'_\gz
.\eqbl
The equation for $\gj$
\bqbl
&&
\left[
  \R{r^2}{\q{g}}(\gj'_a-\tgh'_\gq)
 +\R{r^2\gd'_a}{\q{g}}(\gy'_\gq-\gj'_\gz)
 +\R{r^2\gd'_\gt}{\q{g}}(\tgh'_\gz-\gy'_a)
 -Pv_\til\gy
 \right]'^0
\\&&
+\left[
 \R{g_{aa}}{\q{g}}(\gj'_\gz-\gy'_\gq)
 -\R{g_{a\gq}}{\q{g}}(\tgh'_\gz-\gy'_a)
 -\R{r^2\gd'_a}{\q{g}}(\gj'_a-\tgh'_\gq)
 \right]'^0_\gz
=
\\&&
\left[
  P(\gm'v_0-\gm v'_0)\gj
 -P'v_\til\gy
 -P\gm'v_\til u'_\gq
 -Pv'_{\til,a}u'_\gz
 -Pv\tgh'_\gz
 -F_s\tgh'_\gz
 -F'_s\gm\gj
\right]^0
.\eqbl
The equation for $u$
\bqbl
&&
\left(\gm\R{\pa}{\pa\gq}+\R{\pa}{\pa\gz}\right)\left[
+\R{g_{\gq\gq}}{\q{g}}(\gy'_a-\tgh'_\gz)
-\R{g_{a\gq}}{\q{g}}(\gy'_\gq-\gj'_\gz)
-\R{r^2\gd'_\gt}{\q{g}}(\gj'_a-\tgh'_\gq)
-Pv_\til u'_\gq
 \right]'^\til_a
\\&&
+\left(\gm\R{\pa}{\pa\gq}+\R{\pa}{\pa\gz}\right)\left[
+\R{g_{aa}}{\q{g}}(\gy'_\gq-\gj'_\gz)
+\R{g_{a\gq}}{\q{g}}(\tgh'_\gz-\gy'_a)
+\R{r^2\gd'_a}{\q{g}}(\gj'_a-\tgh'_\gq)
 \right]'^\til_\gq
=
\\&&
\left(\gm\R{\pa}{\pa\gq}+\R{\pa}{\pa\gz}\right)\left[
 (P'v_0+F'_s)u'_\gq
-P'v_\til\gj
-Pv_\til\gj'_a
+F_s\tgh'_\gq
 \right]^\til
\\&&
+\left[
 Pv'_0u'_\gz
+P(\gm'v_\til-\gm v'_{\til,a})u'_\gq
-Pv_\til\gy'_a
-P\gm'v_\til\gj
+Pv\tgh'_\gz
 \right]'^\til_\gq
-Pv'_{\til,a}\gj'_\gz
.\eqbl
\subsection{Euler equations for $n\neq0$ in Fourier space}
The Hermitian property of metric matrices in the $W$ allows to switch the
order of Fourier vectors in functional
\bqbl
&&
\vaY\maA\vaZ^*
=
Y_mA^{mm'}Z^*_{m'}
=
Y_mA^{*m'm}Z^*_{m'}
=
\vaZ^*\maA^*\vaY
\eqbl
and rewrite $W$ as
\bqbl
W
=
\gp&&\int\left\{
\gg_0\bsp(\vaX^*\maG^*\vaX)
+(\vgy^*\maM+n\gj^*)\maG^*_{aa}(\maM\vgy+n\gj)
\right.\\&&\left.
+(\vgy^*\maM+n\gj^*)i\maG^*_{a\gq}(\vgy'+in\vgh)
-(\vgy'^*-in\vgh^*)i\maG^*_{a\gq}(\maM\vgy+n\gj)
+(\vgy'^*-in\vgh^*)\maG^*_{\gq\gq}(\vgy'+in\vgh)
\right.\\&&\left.
-(\vgy^*\maM+n\gj^*)i\maG^*_{a\gz}(\gj'-i\maM\vgh)
+(\gj'^*+i\vgh^*\maM)i\maG^*_{a\gz}(\maM\vgy+n\gj)
\right.\\&&\left.
-(\vgy'^*-in\vgh^*)\maG^*_{\gq\gz}(\gj'-i\maM\vgh)
-(\gj'^*+i\vgh^*\maM)\maG^*_{\gq\gz}(\vgy'+in\vgh)
+(\gj'^*+i\vgh^*\maM)\maG^*_{\gz\gz}(\gj'-i\maM\vgh)
\right.\\&&\left.
-[Pv_0\vgy^*\maM\maQ^{-1}\vgy]'
-[F_s\maM\maQ^{-1}\vgy^*\vgy]'
+[F_s\gm\gj^*\gj]'
+[P\vgy^*\msv^*_\til\gj+P\gj^*\msv^*_\til\vgy]'_a
\right.\\&&\left.
+(P'v_0+F'_s)\vgy^*\maM\maQ^{-1}\vgy
-nPv'_0\vgy^*\maM\maQ^{-2}\vgy
\right.\\&&\left.
+P\maM\maQ^{-1}\vgy^*(\gm'\msv^*_\til-\gm\msv'^*_{\til,a})\maM\maQ^{-1}\vgy
-P[\vgy^*\maM\maQ^{-1}\msv^*_\til\vgy'+\vgy'^*\msv^*_\til\maM\maQ^{-1}\vgy]
\right.\\&&\left.
+nP[\vgy^*\maQ^{-1}\msv'^*_{\til,a}\gj+\gj^*\msv'^*_{\til,a}\maQ^{-1}\vgy]
-P'[\vgy^*\msv^*_\til\gj+\gj^*\msv^*_\til\vgy]
-P[\vgy^*\msv^*_\til\gj'+\gj'^*\msv^*_\til\vgy]
\right.\\&&\left.
-\gm'P[\vgy^*\maM\maQ^{-1}\msv^*_\til\gj+\gj^*\msv^*_\til\maM\maQ^{-1}\vgy]
-inP[(\maM\maQ^{-1}\vgy^*-\gj^*)\msv^*\vgh-\vgh^*\msv^*(\maM\maQ^{-1}\vgy-\gj)]
\right.\\&&\left.
+P\gj^*(\gm'v_0-\gm v'_0)\gj
+iF_s[(\vgy^*\maM+n\gj^*)\vgh-\vgh^*(\maM\vgy+n\gj)]
-\gm F'_s\gj^*\gj
\right\}da
.\eqbl
In the following, we consider $\gj$ as the zeroth component of $\vgy$ 
\bqbl
&&
\vgy_0
\equiv
\gj
.\eqbl
Then, with three independent vectors $\vaX$, $\vgh$ and $\vgy$, the
functional of potential energy can be written in a symbolic form
\bqbl
W
=
\gp&&\int\left\{
\gg_0\bsp(\vaX^*\maG^*\vaX)
\right.\\&&\left.
+(-i\vgh^*)\maA i\vgh
+(-i\vgh^*)\maB\vgy'
+\vgy'^*\maB^\dagger i\vgh
+(-i\vgh^*)\maC\vgy
+\vgy^*\maC^\dagger i\vgh
\right.\\&&\left.
+\vgy'^*\maD\vgy'
+\vgy'^*\maE\vgy
+\vgy^*\maE^\dagger\vgy'
+\vgy^*\maH\vgy
\right\}da
,\eqbl
where matrices are defined as
\bqbl
&&
\maA
\equiv
\maM\maG^*_{\gz\gz}\maM
+n^2\maG^*_{\gq\gq}
+n\maG^*_{\gq\gz}\maM
+n\maM\maG^*_{\gq\gz}
,\\&&
\maB
\equiv
n\maG^{*\cup\til}_{\gq\gq}
+\maM\maG^{*\cup\til}_{\gq\gz}
-\maM\maG^{*\cup0}_{\gz\gz}
-n\maG^{*\cup0}_{\gq\gz}
,\\&&
\maC
\equiv
n(F_s-in\maG^*_{a\gq}-i\maM\maG^*_{a\gz}-nP\msv^*\maQ^{-1})^{\cup0}
+(F_s-in\maG^*_{a\gq}-i\maM\maG^*_{a\gz}-nP\msv^*\maQ^{-1})^{\cup\til}\maM
,\\&&
\maD
\equiv
\maG^{*00}_{\gz\gz}
-\maG^{*\til0}_{\gq\gz}
-\maG^{*0\til}_{\gq\gz}
+\maG^{*\til\til}_{\gq\gq}
,\\&&
\maE
\equiv
(in\maG^{*00}_{a\gz}-in\maG^{*\til0}_{a\gq})
+(i\maG^{*0\til}_{a\gz}-i\maG^{*\til\til}_{a\gq})\maM
-P\msv^{*0\til}_\til
-P\msv^{*\til\til}_\til\maM\maQ^{-1}
,\\&&
\maH
\equiv
n^2\maG^{*00}_{aa}
+n\maG^{*0\til}_{aa}\maM
+n\maM\maG^{*\til0}_{aa}
+\maM\maG^{*\til\til}_{aa}\maM
+(P'v_0+F'_s)\maM\maQ^{-1}
-nPv'_0\maM\maQ^{-2}
\\&&
+P\maQ^{-1}\maM(\gm'\msv^*_\til-\gm\msv'^*_{\til,a})\maM\maQ^{-1}
+nP(\maQ^{-1}\msv'^{*\til0}_{\til,a}+\msv'^{*0\til}_{\til,a}\maQ^{-1})
-P'(\msv^{*\til0}_\til+\msv^{*0\til}_\til)
\\&&
-\gm'P(\maM\maQ^{-1}\msv^{*\til0}_\til+\msv^{*0\til}_\til\maM\maQ^{-1})
+[P(\gm'v_0-\gm v'_0)-\gm F'_s]^{00}
.\eqbl
Its variation with respect to $\vaX^*$, $\vgh^*$, $\vgy^*$ gives the Euler
equations for $\vaX$
\bqbl
&&
\maG^*\vaX
=
0
,\eqbl
for $\vgh$ is
\bqbl
&&
\maA i\vgh
=
-\maB\vgy'
-\maC\vgy
\eqbl
and for $\vgy$
\bqbl
&&
[\maD\vgy'+\maB^\dagger i\vgh+\maE\vgy]'
=
\maC^\dagger i\vgh
+\maE^\dagger\vgy'
+\maH\vgy
.\eqbl
Elimination of $\vgh$ leads to
\bqbl
&&
i\vgh
=
-\maA^{-1}\maB\vgy'
-\maA^{-1}\maC\vgy
,\eqbl
and finally to the single equation for $\vgy$
\bqbl
&&
(\maF\vgy'+\maK\vgy)'
=
\maK^\dagger\vgy'
+\maG\vgy
,\eqbl
where
\bqbl
&&
\maF
\equiv
\maD-\maB^\dagger\maA^{-1}\maB
,\\&&
\maK
\equiv
\maE
-\maB^\dagger\maA^{-1}\maC
,\\&&
\maG
\equiv
\maH
-\maC^\dagger\maA^{-1}\maC
.\eqbl
In the form of a system of the first order equations it can be
written as 
\bqbl
&&
\vgy'
=
\maF^{-1}(\vaY-\maK\vgy)
,\quad
\vaY'
=
\maK^\dagger\vgy'
+\maG\vgy
.\eqbl

\section{Rationalized form of potential energy}
The energy functional can be written in the form
\bqbl
W
=
\r{8\gp}&&\int\left\{
\R{\gg_0\bsp}{\q{g}}X^2
+\R{g_{\gr\gr}}{\q{g}}(\gy'_\gq-\gj'_\gz)^2
+2\R{g_{\gr\gt}}{\q{g}}(\gl'_\gz-\gy'_a)(\gy'_\gq-\gj'_\gz)
+\R{g_{\gt\gt}}{\q{g}}(\gl'_\gz-\gy'_a)^2
\right.\\&&\left.
+\R{r^2}{\q{g}}\left[
  \gj'_a-\gl'_\gq
 +\gd'_\gt(\gl'_\gz-\gy'_a)
 +\gd'_a(\gy'_\gq-\gj'_\gz)
 \right]^2
\right.\\&&\left.
+[F_s\gm\gj^2-(Pv_0+F_s)u'_\gq\gy+2Pv_\til\gj\gy]'_a
\right.\\&&\left.
+(P'v_0+F'_s)u'_\gq\gy
+Pv'_0u'_\gq u'_\gz
+P(\gm'v_\til-\gm v'_{\til,a})u'^2_\gq
-2Pv_\til u'_\gq\gy'_a
\right.\\&&\left.
-2P'v_\til\gj\gy
-2Pv_\til\gj'_a\gy
-2P\gm'v_\til u'_\gq\gj
-2Pv'_{\til,a}u'_\gz\gj
+2Pv(u'_\gq-\gj)\gl'_\gz
\right.\\&&\left.
+P(\gm'v_0-\gm v'_0)\gj^2
+2F_s\gy\gl'_\gq
-2F_s\gj\gl'_\gz
-F'_s\gm\gj^2
\right\}da d\gq d\gz
,\\
W
=
\r{8\gp}&&\int\left\{
\R{\gg_0\bsp}{\q{g}}X^2
+\R{g_{\gr\gr}}{\q{g}}(\gy'_\gq-\gj'_\gz)^2
+2\R{g_{\gr\gt}}{\q{g}}(\gl'_\gz-\gy'_a)(\gy'_\gq-\gj'_\gz)
+\R{g_{\gt\gt}}{\q{g}}(\gl'_\gz-\gy'_a)^2
\right.\\&&\left.
+\R{r^2}{\q{g}}\left[
  \gj'_a-\gl'_\gq
 +\gd'_\gt(\gl'_\gz-\gy'_a)
 +\gd'_a(\gy'_\gq-\gj'_\gz)
 \right]^2
\right.\\&&\left.
+[F_s\gm\gj^2-(Pv_0+F_s)u'_\gq\gy]'_a
\right.\\&&\left.
+(P'v_0+F'_s)u'_\gq\gy
+Pv'_0u'_\gq u'_\gz
+P(\gm'v_\til-\gm v'_{\til,a})(u'_\gq-\gj)^2
-2Pv_\til(u'_\gq-\gj)\gy'_a
\right.\\&&\left.
+2Pv(u'_\gq-\gj)\gl'_\gz
+P(\gm'v_0-\gm v'_0)\gj^2
+2F_s\gy\gl'_\gq
-2F_s\gj\gl'_\gz
-F'_s\gm\gj^2
\right\}da d\gq d\gz
,\eqbl
which gives an explicit transition to the Reduced Magnetohydrodynamics
\bqbl
&&
\gj'_a-\gl'_\gq
+\gd'_\gt(\gl'_\gz-\gy'_a)
+\gd'_a(\gy'_\gq-\gj'_\gz)
=
0
.\eqbl
In matrix form, with substitution $\vgl=-i\vgl$, this energy functional 
can be written as 
\bqbl
W
=
\r{8\gp}&&\int\left\{
\gg_0\bsp(\vaX^\dagger\maG\vaX)
+(\vgy'^\dagger-n\vgl^\dagger)\maG_{\gt\gt}(\vgy'-n\vgl)
+(\vgy^\dagger\maM+n\gj^*)\maG_{\gr\gr}(\maM\vgy+n\gj)
\right.\\&&\left.
-(\vgy'^\dagger-n\vgl^\dagger)i\maG_{\gr\gt}(\maM\vgy+n\gj)
+(\vgy^\dagger\maM+n\gj^*)i\maG_{\gr\gt}(\vgy'-n\vgl)
\right.\\&&\left.\hskip-0.9in
+\left[
  \gj'^*+\vgl^\dagger\maM
 -(\vgy'^\dagger-n\vgl^\dagger)\maZ^\dagger_{\gt}
 -i(\vgy^\dagger\maM+n\gj^*)\maZ^\dagger_\gr
 \right]\maG_{\gf\gf}\left[
  \gj'+\maM\vgl
 -\maZ_\gt(\vgy'-n\vgl)
 +i\maZ_\gr(\maM\vgy+n\gj)
 \right]
\right.\\&&\left.
+[F_s\gm\gj^*\gj-(Pv_0+F_s)\vgy^\dagger\maT\vgy]'_a
\right.\\&&\left.
+(P'v_0+F'_s)\vgy^\dagger\maT\vgy
-Pv'_0\vgy^\dagger n\maT\maQ^{-1}\vgy
\right.\\&&\left.
+P(\vgy^\dagger\maT-\gj^*)(\gm'\maV_\til-\gm\maV'_\til)(\maT\vgy-\gj)
-P(\vgy^\dagger\maT-\gj^*)\maV_\til\vgy'
-P\vgy'^\dagger\maV_\til(\maT\vgy-\gj)
\right.\\&&\left.
+nP\vgl^\dagger\maV(\maT\vgy-\gj)
+nP(\vgy^\dagger\maT-\gj^*)\maV\vgl
\right.\\&&\left.
+P(\gm'v_0-\gm v'_0)\gj^*\gj
-F_s\maM\vgl^\dagger\vgy 
-F_s\vgy^\dagger\maM\vgl
-nF_s\vgl^\dagger\gj
-nF_s\gj^*\vgl
-F'_s\gm\gj^*\gj
\right\}da d\gq d\gz
,\eqbl
where matrices are defined as
\bqbl
&&
\maI^{mm'}
\equiv
\gd^{mm'}
,\quad
\maM^{mm'}
\equiv
m\gd^{mm'}
,\quad
\maQ
\equiv
\gm\maM-n\maI
,\quad
\maT
\equiv
\maM\maQ^{-1}
,\quad
\vsu_\gq
\equiv
\maT\vgy
,\quad
\vsu_\gz
\equiv
-n\maQ^{-1}\vgy
,\\&&
 \maG^{mm'}_{\gr\gr}
\equiv
\left(\R{g_{\gr\gr}}{\q{g}}e^{-i(m-m')\gq}\right)_0
,\quad
\maG^{mm'}_{\gr\gt}
\equiv
-\left(\R{g_{\gr\gt}}{\q{g}}e^{-i(m-m')\gq}\right)_0
,\quad
\maG^{mm'}_{\gt\gt}
\equiv
\left(\R{g_{\gt\gt}}{\q{g}}e^{-i(m-m')\gq}\right)_0
,\\&&
\maZ^{mm'}_{\gt}
\equiv
q\left[\left(\R{L}{L_0}-1\right)e^{-i(m-m')\gq}\right]_0
,\quad
\maZ^{mm'}_\gr
\equiv
\left[q\left(\R{L}{L_0}-1\right)\R{e^{-i(m-m')\gq}}{i(m-m')}\right]'_0
,\\&&
\maG^{mm'}_{\gf\gf}
\equiv
\left(\R{r^2}{\q{g}}e^{-i(m-m')\gq}\right)_0
,\quad
\maG^{mm'}
\equiv
\left(\R{e^{-i(m-m')\gq}}{\q{g}}\right)_0
,\quad
\msv^{mm'}
\equiv
\left(Ve^{-i(m-m')\gq}\right)_0
.\eqbl
Then, with three independent vectors $\vaX=0$, $\vgh$ and $\vgy$, the
functional of potential energy can be written in a symbolic form
\bqbl
W
=
\gp&&\int\left\{
\vgl^*\maA\vgl
+\vgl^*\maB\vgy'
+\vgy'^*\maB^\dagger\vgl
+\vgl^*\maC\vgy
+\vgy^*\maC^\dagger\vgl
+\vgy'^*\maD\vgy'
+\vgy'^*\maE\vgy
+\vgy^*\maE^\dagger\vgy'
+\vgy^*\maH\vgy
\right\}da
,\eqbl
where matrices are defined as
\bqbl
&&
\maA
\equiv
(\maM+n\maZ^\dagger_{\gt})\maG_{\gf\gf}(\maM+n\maZ_\gt)
+n^2\maG_{\gt\gt}
,\\&&
\maB
\equiv
-[n\maG_{\gt\gt}+(\maM+n\maZ^\dagger_{\gt})\maG_{\gf\gf}\maZ_\gt]^{\cup\til}
+(\maM+n\maZ^\dagger_{\gt})\maG_{\gf\gf}^{\cup0}
,\\&&
\maC
\equiv
[in\maG_{\gr\gt}
 -F_s
 +(\maM+n\maZ^\dagger_{\gt})\maG_{\gf\gf}i\maZ_\gr]\maM
+nP\maV\maT
\\&&
+n[in\maG_{\gr\gt}
 +(\maM+n\maZ^\dagger_{\gt})\maG_{\gf\gf}i\maZ_\gr
 -P\maV
 -F_s]^{\cup0}
,\\&&
\maD
\equiv
\maG_{\gt\gt}^{\til\til}
+(\maZ^\dagger_{\gt}\maG_{\gf\gf}\maZ_\gt)^{\til\til}
-(\maG_{\gf\gf}\maZ_\gt)^{0\til}
-(\maZ^\dagger_{\gt}\maG_{\gf\gf})^{\til0}
+\maG_{\gf\gf}^{00}
,\\&&
\maE
\equiv
-i\maG_{\gr\gt}^{\til\til}\maM
-in\maG_{\gr\gt}^{\til0}
-(\maZ^\dagger_{\gt}\maG_{\gf\gf}i\maZ_\gr\maM)^{\til\til}
-n(\maZ^\dagger_{\gt}\maG_{\gf\gf}i\maZ_\gr)^{\til0}
+(\maG_{\gf\gf}i\maZ_\gr\maM)^{0\til}
+n(\maG_{\gf\gf}i\maZ_\gr)^{00}
\\&&
-P(\maV_\til\maT)^{\til\til}
+P(\maV_\til)^{\til0}
,\\&&
\maH
\equiv
\maM\maG_{\gr\gr}\maM
+n\maM\maG_{\gr\gr}^{\til0}
+n\maG_{\gr\gr}^{0\til}\maM
+n^2\maG_{\gr\gr}^{00}
\\&&
+\maM\maZ^\dagger_\gr\maG_{\gf\gf}\maZ_\gr\maM
+n(\maM\maZ^\dagger_\gr\maG_{\gf\gf}\maZ_\gr)^{\til0}
+n(\maZ^\dagger_\gr\maG_{\gf\gf}\maZ_\gr\maM)^{0\til}
+n^2(\maZ^\dagger_\gr\maG_{\gf\gf}\maZ_\gr)^{00}
\\&&
+(P'v_0+F'_s)\maT
-nPv'_0\maT\maQ^{-1}
+P\maT(\gm'\maV_\til-\gm\maV'_\til)\maT
-P[\maT(\gm'\maV_\til-\gm\maV'_\til)]^{\til0}
-P[(\gm'\maV_\til-\gm\maV'_\til)\maT]^{0\til}
\\&&
+[P(\gm'v_0-\gm v'_0)-F'_s\gm]^{00}
.\eqbl


Its variation with respect to $\vaX^*$, $\vgl^*$, $\vgy^*$ gives the Euler
equations for $\vaX$
\bqbl
&&
\maG^*\vaX
=
0
,\eqbl
for $\vgl$ is
\bqbl
&&
\maA\vgl
=
-\maB\vgy'
-\maC\vgy
\eqbl
and for $\vgy$
\bqbl
&&
[\maD\vgy'+\maB^\dagger\vgl+\maE\vgy]'
=
\maC^\dagger\vgl
+\maE^\dagger\vgy'
+\maH\vgy
.\eqbl
Elimination of $\vgl$ leads to
\bqbl
&&
\vgl
=
-\maA^{-1}\maB\vgy'
-\maA^{-1}\maC\vgy
,\eqbl
and finally to the single equation for $\vgy$
\bqbl
&&
(\maF\vgy'+\maK\vgy)'
=
\maK^\dagger\vgy'
+\maG\vgy
,\eqbl
where
\bqbl
&&
\maF
\equiv
\maD-\maB^\dagger\maA^{-1}\maB
,\\&&
\maK
\equiv
\maE
-\maB^\dagger\maA^{-1}\maC
,\\&&
\maG
\equiv
\maH
-\maC^\dagger\maA^{-1}\maC
.\eqbl
In the form of a system of the first order equations it can be
written as 
\bqbl
&&
\vgy'
=
\maF^{-1}(\vaY-\maK\vgy)
,\quad
\vaY'
=
\maK^\dagger\vgy'
+\maG\vgy
.\eqbl

\section{Solution near the origin}
Near the origin
\bqbl
&&
\gj'_a
-\tgh'_\gq
=
\gd'_\gt\gy'_a
-\gd'_a\gy'_\gq
,\quad
\gy^j
\propto
a^j
,\quad
\gj^j
\propto
a^{j+1}
,\quad
\tgh_\til
\propto
a^j
,\quad
\tgh_0
\propto
a^{j-1}
,\\&&
\gj'_a
=
(\gd'_\gt\gy'_a-\gd'_a\gy'_\gq)_{0\cup}
=
-(j+1)q\R{L'^c_1+iL'^s_1}{L_0}a\gy^j_1e^{-in\gz}
-(j-1)q\R{L'^c_1-iL'^s_1}{L_0}a\gy^j_{-1}e^{-in\gz}
,\\&&
\gj
=
-q\R{L'^c_1+iL'^s_1}{L_0}a\gy^j_1e^{-in\gz}
-q\R{L'^c_1-iL'^s_1}{L_0}a\gy^j_{-1}e^{-in\gz}
,\quad
\tgh'_\gq
=
-(\gd'_\gt\gy'_a-\gd'_a\gy'_\gq)_{\til\cup}
\eqbl
and the energy functional can be reduced to
\bqbl
W
=
\r{8\gp}&&\int\left\{
\R{g_{\gr\gr}}{\q{g}}\gy'^2_\gq
-2\R{g_{\gr\gt}}{\q{g}}(\gy'_a-\tgh'_{0,\gz})\gy'_\gq
+\R{g_{\gt\gt}}{\q{g}}(\gy'_a-\tgh'_{0,\gz})^2
\right\}da d\gq d\gz
.\eqbl
Euler equation for $\gy$
\bqbl
&&
\left[
  \R{g_{\gt\gt}}{\q{g}}(\gy'_a-\tgh'_{0,\gz})
 -\R{g_{\gr\gt}}{\q{g}}\gy'_\gq
 \right]'_a
+\left[
  \R{g_{\gr\gr}}{\q{g}}\gy'_\gq
 -\R{g_{\gr\gt}}{\q{g}}(\gy'_a-\tgh'_{0,\gz})
 \right]'_\gq
=
0
\eqbl
reduces to solving tridiagonal equations
\bqbl
&&
A_k
\equiv
(j^2-k^2)K_0
,\quad
B_k
\equiv
(j+k)(j+k+2)(E^r-iE^i)
,\\&&
C_k
\equiv
(j-k)(j-k+2)(E^r+iE^i)
,\\&&
 B_k\gy^j_{k+2}
+A_k\gy^j_k
+C_k\gy^j_{k-2}
=
0
.\eqbl
Here, $E^r$, $E^i$ are defined as
\bqbl
&&
E^r
\equiv
K^c_2
,\quad
E^i
\equiv
-K^s_2
,\\&&
G_{\gt\gt}
=
aK_0
+2aK^c_2\cos2\gt
+2aK^s_2\sin2\gt
,\\&&
G_{a\gt}
=
-2K^s_2\cos2\gt
+2K^c_2\sin2\gt
,\\&&
aG_{aa}
=
K_0
-2K^c_2\cos2\gt
-2K^s_2\sin2\gt
.\eqbl
Boundary conditions for the homogeneous solution
\bqbl
&&
\gy^j_j
=
1
,\quad
\gy^j_{J}
=
0
,\quad
J
=
\max{(M_1,-j)}
.\eqbl
Decomposition and backsubstitution loops for homoheneous solution
\bqbl
&&
\gy^j_k
=
V_k\gy^j_{k-2}
+U_k
,\quad
V_j
=
0
,\quad
U_j
=
1
,\\&&
V_k
=
-{C_k\over A_k+B_kV_{k+2}}
,\\&&
U_k
=
{-B_kU_{k+2}\over A_k+B_kV_{k+2}}
.\eqbl

In terms of polinomials
\bqbl
&&
x
=
a(r'^c_1-ir'^s_1)e^{i\gq}
+a(r'^c_1+ir'^s_1)e^{-i\gq}
,\quad
y
=
a\R{b'}{2i}e^{i\gq}
-a\R{b'}{2i}e^{-i\gq}
,\\&&
z
=
x+iy
=
a\left(r'^c_1+\R{b'}{2}-ir'^s_1\right)e^{i\gq}
+a\left(r'^c_1-\R{b'}{2}+ir'^s_1\right)e^{-i\gq}
=
a\left(r'^c_1+\R{b'}{2}-ir'^s_1\right)\left(e^{i\gq}+\gn e^{-i\gq}\right)
,\\&&
\gn
\equiv
\R{r'^c_1-\R{b'}{2}+ir'^s_1}{r'^c_1+\R{b'}{2}-ir'^s_1}
\eqbl
its solution can be expressed as
\bqbl
&&
\gy^j
=
a^j\left(e^{i\gq}+\gn e^{-i\gq}\right)^j
.\eqbl

\section{Solution near the resonant point}
Near the resonant point, the matrices in MHD equations have the
asymptotic form
\bqbl
&&
\maC
\equiv
\b{\maC}\maT^{m/n}
=
nP\maV\maT
,\quad
\left(\maT^{m/n}\right)_{ij}
=
\R{\gd_{ij}\gd_{jm}}{\gm'x}
,\\&&
\maK
\equiv
\b{\maK}\maT^{m/n}
=
\maE-\maB^\dagger\maA^{-1}\maC
=
-P(\maV_\til\maT)^{\til\til}
-nP\maB^\dagger\maA^{-1}\maV\maT^{m/n}
,\\&&
\maG
\equiv
\maT^{m/n}\b{\maG}\maT^{m/n}
=
\maH
-\maC^\dagger\maA^{-1}\maC
,\\&&
\maH
\equiv
\maT^{m/n}\b{\maH}\maT^{m/n}
=
P\maT(\gm'\maV_\til-\gm\maV'_\til)\maT
-nPv'_0\maT\maQ^{-1}
,\\&&
\maG
=
P\maT(\gm'\maV_\til-\gm\maV_\til)\maT
-nPv'_0\maT\maQ^{-1}
-n^2P^2\maT\maV^\dagger\maA^{-1}\maV\maT
\eqbl
and the Euler equations becomes singular
\bqbl
&&
\vgy'
=
\maF^{-1}(\vaY-\maK\vgy)
=
\maF^{-1}(\vaY-\b{\maK}\maT^{m/n}\vgy)
,\\&&
\vaY'
=
\maK^\dagger\vgy'
+\maG\vgy
=
\maT^{m/n}\b{\maK}^\dagger\vgy'
+\maT^{m/n}\b{\maG}\maT^{m/n}\vgy
.\eqbl
The resonant fundamental vector has the following asymptotics 
\bqbl
&&
\vgy
=
C^L|x|^{D^L}\vgy^L
+C^S|x|^{D^S}\vgy^S
,\quad
x^D
=
a-a_{m/n}
,\eqbl
and $D^L$, $D^S$ are the Mercier power corresponding to large and small
solutions. 

It is seen from the Euler equations that in $\vaY$ only the resonant
harmonic $Y_m$ is essential, $Y_{m'\neq m}\propto xY_m$. 
\bqbl
&&
\vaY'
=
\maT^{m/n}\b{\maK}^\dagger\vgy'
+\maT^{m/n}\b{\maG}\maT^{m/n}\vgy
,\quad
\R{D-1}{x}\vaY
=
\R{D}{x}\maT^{m/n}\b{\maK}^\dagger\vgy
+\maT^{m/n}\b{\maG}\maT^{m/n}\vgy
.\eqbl
In its turn, from
\bqbl
&&
\R{D}{x}\vgy
=
\maF^{-1}(\vaY-\b{\maK}\maT^{m/n}\vgy)
,\eqbl
$Y_m$ can be expressed in terms of the resonant harmonic as
\bqbl
&&
\left(\maF^{-1}\right)_{mm}Y_m
=
\R{D}{x}\gy_m
+\left(\maF^{-1}\b{\maK}\maT^{m/n}\right)_{mm}\gy_m
,\eqbl
which gives after substitution into
\bqbl
&&
\R{D-1}{x}\vaY
=
\maT^{m/n}\b{\maK}^\dagger\maF^{-1}(\vaY-\b{\maK}\maT^{m/n}\vgy)
+\maT^{m/n}\b{\maG}\maT^{m/n}\vgy
.\eqbl
the equation for powers $D^L$ and $D^S$
\bqbl
&&
\R{D-1}{x}\vaY
=
\maT^{m/n}\b{\maK}^\dagger\maF^{-1}\vaY
+\maT^{m/n}\left(\b{\maG}-\b{\maK}^\dagger\maF^{-1}\b{\maK}\right)\maT^{m/n}
 \vgy 
,\\&&
\gm'^2D(D-1)
=
\gm'D\left(\b{\maK}^\dagger\maF^{-1}-\maF^{-1}\b{\maK}\right)_{mm}
+\left(\b{\maK}^\dagger\maF^{-1}\right)_{mm}\left(\maF^{-1}\b{\maK}\right)_{mm}
+\left(\maF^{-1}\right)_{mm}\left(\b{\maG}-\b{\maK}^\dagger\maF^{-1}\b{\maK}\right)_{mm}
,\\&&
\gm'^2D(D-1)
=
\gm'D\left(\b{\maK}^\dagger\maF^{-1}-\maF^{-1}\b{\maK}\right)_{mm}
+\left|\maF^{-1}\b{\maK}\right|^2_{mm}
+\left(\maF^{-1}\right)_{mm}\left(\b{\maG}-\b{\maK}^\dagger\maF^{-1}\b{\maK}\right)_{mm}
.\eqbl

 
%========================================================================
\centerline{\helvV Energy principle for ideal and resistive MHD}
\vskip12pt
\centerline{\helvOIII Leonid E. Zakharov,}
\vskip8pt
\centerline{\helvOII Princeton University, Princeton Plasma Physics
Laboratory} 
\centerline{\helvOII November 8, 1999}
\vskip72pt
Besides the geometry of the magnetic surfaces, standard form of the
energy principle requies a lot of plasma profiles transmitted from the
equilibrium codes to the stability code.
\vskip12pt
This deteriorate the numerical reliability of the results and creates a
fundamental problem for resistive calculations, where the derivative of
the current density plays an important role in the stability.
\Epg

\npb{Standard form of the energy principle}
Independent test functions
\bqbl
&&
X
\equiv
\q{g}(\na\cdot\vgx)
,\\&&
\gL
\equiv
\bgF'\gx^\gq+\bgY'\gx^\gz
,\\&&
\gx
=
\vgx\cdot\na a
.\eqbl
Functional of the potential energy
\bqbl
W
=
\gp&&\int\left\{
\gg_0\bsp(\vaX^*\maG^*\vaX)
\right.\\&&\left.
+\vgL^*\maA\vgL
+\vgL^*\maB\vgx'
+\vgx'^*\maB^\dagger\vgL
+i\vgL^*\maC\vgx
+\vgx^*\maC^\dagger\vgL
\right.\\&&\left.
+\vgx'^*\maD\vgx'
+\vgx'^*\maE\vgx
+\vgx^*\maE^\dagger\vgx'
+\vgx^*\maH\vgx
\right\}da
.\eqbl
\Epg

\np{Standard form of the energy principle}
Definitions of matrices in Hamada coordinates
\bqbl
\maA
&\equiv&
\maM\maG^*_{\gz\gz}\maM
+n^2\maG^*_{\gq\gq}
+n\maG^*_{\gq\gz}\maM
+n\maM\maG^*_{\gq\gz}
,\\
\maB
&\equiv&
-i\gc'\left[
  n\maG_{\gq\gq}
 +q\maG_{\gq\gz}
 +\maM\maG_{\gq\gz}
 -q\maM\maG_{\gz\gz}
\right]
,\\
\maC
&\equiv&
-i\left[
  \gc''(n\maG^*_{\gq\gq}+\maM\maG_{\gq\gz})
 +(q\gc')(n\maG^*_{\gq\gz}+\maM\maG_{\gz\gz})
\right]
\\&&
-\gc'(n\maG^*_{a\gq}+\maM\maG^*_{a\gz})\maQ
-i(\baF'\maQ+nP\maI)
,\\
\maD
&\equiv&
\gc'^2\left[
  \maG_{\gq\gq}
 +q\maG_{\gq\gz}
 +q\maG_{\gq\gz}
 +q^2\maG_{\gz\gz}
 \right]
,\\
\maE
&\equiv&
\gc'\left[
  \gc''(\maG_{\gq\gq}+q\maG_{\gq\gz})
 +(q\gc')'(\maG_{\gq\gz}+q\maG_{\gz\gz})
 \right]
\\&&
-\gc'^2(i\maG_{a\gq}+qi\maG_{a\gz})
+P\maI
,\\
\maH
&\equiv&
\gc''\left[\gc''\maG_{\gq\gq}+(q\gc')'\maG_{\gq\gz})\right]
+(q\gc')'\left[\gc''\maG_{\gq\gz}+(q\gc')'\maG_{\gz\gz})\right]
\\&&
+i\gc'\left[\gc''(\maM\maG_{a\gq}-\maG_{a\gq}\maM)
  +(q\gc')'(\maM\maG_{a\gz}-\maG_{a\gz}\maM)\right]
\\&&
+\gc'^2\maQ\maG_{aa}\maQ
+(\gc''P+q'F_s)\maI
.\eqbl
\Epg

\npb{Energy principle in terms of $\t{\waA}$}
Perturbations of the vector potential
\bqbl
&&
\taA_{a,\gq,\gz}=\left\{
\tgh-\int^\gz_0(\gm\gj)'_ad\gz
,\quad\gj
,\quad\gy-\gm\gj
\right\}
,\\&&
\tgh
\equiv
\tgh_{\til\cup}
,\quad
\gj
\equiv
\gj_{0\cup}
,\quad
\gy
\equiv
\gy_{\til\cup}
.\eqbl
Independent test functions
\bqbl
&&
X
\equiv
\q{g}(\na\cdot\vgx)
,\\&&
i\gh
,\\&&
\gj_{0\cup}
,\quad
\gy_{\til\cup}
.\eqbl
Relationships with standart test function
\bqbl
&&
\bgF'\gx=u'_\gq-\gj
,\\&&
\gL=\tgh-u'_a-\int^\gz_0(\gm\gj)'_ad\gz
,\\&&
\gy
\equiv
\gm u'_\gq
+u'_{\gz}
,\\&&
\bgF'\gx'_\gz-\bgY'\gx'_\gq=
\gy'_\gq
-\gj'_\gz
.\eqbl

Functional of the potential energy
\bqbl
W
=
\gp&&\int\left\{
\gg_0\bsp(\vaX^*\maG^*\vaX)
\right.\\&&\left.
+\vgh^*\maA\vgh
+\vgh^*\maB\vgy'
+\vgy'^*\maB^\dagger\vgh
+\vgh^*\maC\vgy
+\vgy^*\maC^\dagger\vgh
\right.\\&&\left.
+\vgy'^*\maD\vgy'
+\vgy'^*\maE\vgy
+\vgy^*\maE^\dagger\vgy'
+\vgy^*\maH\vgy
\right\}da
,\eqbl
\Epg

\np{Energy principle in terms of $\t{\waA}$}
Matrices in the functional
\bqbl
\maA
&\equiv&
\maM\maG^*_{\gz\gz}\maM
+n^2\maG^*_{\gq\gq}
+n\maG^*_{\gq\gz}\maM
+n\maM\maG^*_{\gq\gz}
,\\
\maB
&\equiv&
n\maG^{*\cup\til}_{\gq\gq}
+\maM\maG^{*\cup\til}_{\gq\gz}
-\maM\maG^{*\cup0}_{\gz\gz}
-n\maG^{*\cup0}_{\gq\gz}
,\\
\maC
&\equiv&
n(F_s-in\maG^*_{a\gq}-i\maM\maG^*_{a\gz}-nP\msv^*\maQ^{-1})^{\cup0}
\\&&
+(F_s-in\maG^*_{a\gq}-i\maM\maG^*_{a\gz}-nP\msv^*\maQ^{-1})^{\cup\til}\maM
,\\
\maD
&\equiv&
\maG^{*00}_{\gz\gz}
-\maG^{*\til0}_{\gq\gz}
-\maG^{*0\til}_{\gq\gz}
+\maG^{*\til\til}_{\gq\gq}
,\\
\maE
&\equiv&
(in\maG^{*00}_{a\gz}-in\maG^{*\til0}_{a\gq})
+(i\maG^{*0\til}_{a\gz}-i\maG^{*\til\til}_{a\gq})\maM
-P\msv^{*0\til}_\til
-P\msv^{*\til\til}_\til\maM\maQ^{-1}
,\\
\maH
&\equiv&
n^2\maG^{*00}_{aa}
+n\maG^{*0\til}_{aa}\maM
+n\maM\maG^{*\til0}_{aa}
+\maM\maG^{*\til\til}_{aa}\maM
\\&&
+(P'v_0+F'_s)\maM\maQ^{-1}
-nPv'_0\maM\maQ^{-2}
\\&&
+P\maQ^{-1}\maM(\gm\msv^*_\til)'_a\maM\maQ^{-1}
+nP(\maQ^{-1}\msv'^{*\til0}_{\til,a}+\msv'^{*0\til}_{\til,a}\maQ^{-1})
\\&&
-P'(\msv^{*\til0}_\til+\msv^{*0\til}_\til)
-\gm'P(\maM\maQ^{-1}\msv^{*\til0}_\til+\msv^{*0\til}_\til\maM\maQ^{-1})
\\&&
+[P(\gm'v_0-\gm v'_0)-\gm F'_s]^{00}
.\eqbl
\Epg

\np{Energy principle in terms of $\t{\waA}$}
In Hamada coordinates
\bqbl
\maA
&\equiv&
\maM\maG^*_{\gz\gz}\maM
+n^2\maG^*_{\gq\gq}
+n\maG^*_{\gq\gz}\maM
+n\maM\maG^*_{\gq\gz}
,\\
\maB
&\equiv&
\left[
  n\maG^{*\cup\til}_{\gq\gq}
 -n\maG^{*\cup0}_{\gq\gz}
\right]
+\left[
  \maM\maG^{*\cup\til}_{\gq\gz}
 -\maM\maG^{*\cup0}_{\gz\gz}
\right]
,\\
\maC
&\equiv&
n(F_s-in\maG^*_{a\gq}-i\maM\maG^*_{a\gz}-nP\msv^*\maQ^{-1})^{\cup0}
\\&&
+(F_s-in\maG^*_{a\gq}-i\maM\maG^*_{a\gz}-nP\msv^*\maQ^{-1})^{\cup\til}\maM
,\\
\maD
&\equiv&
\maG^{*00}_{\gz\gz}
-\maG^{*\til0}_{\gq\gz}
-\maG^{*0\til}_{\gq\gz}
+\maG^{*\til\til}_{\gq\gq}
,\\
\maE
&\equiv&
\left[
  in\maG^{*00}_{a\gz}
 -in\maG^{*\til0}_{a\gq}
 +(i\maG^{*0\til}_{a\gz}-i\maG^{*\til\til}_{a\gq})\maM
 \right]
,\\
\maH
&\equiv&
\left[
  n^2\maG^{*00}_{aa}
 +n\maG^{*0\til}_{aa}\maM
 +n\maM\maG^{*\til0}_{aa}
 +\maM\maG^{*\til\til}_{aa}\maM
 \right]
\\&&
+(P'v_0+F'_s)\maM\maQ^{-1}
-nPv'_0\maM\maQ^{-2}
\\&&
+[P(\gm'v_0-\gm v'_0)-\gm F'_s]^{00}
.\eqbl
Now, the $H$ term contains explicitely the tearing and ballooning
driving terms.
\Epg

\npb{Summary}
The energy principle has been written in terms of appropriate
perturbations of the vector potential.
\vskip1in
It provides a consistent way of communication between equilibrium and
stability codes and represents the most appropriate form for both ideal 
and resistive numerical calculations.
\Epg

#endif
#ifndef mzl_System_escL.c
#ifdef Tbl_UnusedID
  extern double cr3;			/*                        :escL.c */
  extern double cr4;			/*                        :escL.c */
  extern double cr6;			/*                        :escL.c */
  extern double cr12;			/*                        :escL.c */
  extern double cgp;			/*                        :escL.c */
  extern double c2gp;			/*                        :escL.c */
  extern double cgp_4;			/*                        :escL.c */
  extern double cr2gp;			/*                        :escL.c */
  extern double cgm0;			/*                        :escL.c */
  extern double crgm0;			/*                        :escL.c */
  extern int ESMp;			/*                        :escL.c */
  extern int ESMp1;			/*                        :escL.c */
  extern int ESFp1;			/*                        :escL.c */
  extern double *ESsq1a;		/*                        :escL.c */
  extern double *ESsq2a;		/*                        :escL.c */
  extern double *ESPs1a;		/*                        :escL.c */
  extern double *ESaT1a;		/*                        :escL.c */
  extern double *ESFF1a;		/*                        :escL.c */
  extern double *ESaF;			/*                        :escL.c */
  extern double *ESaF1a;		/*                        :escL.c */
  extern double *ESaF2a;		/*                        :escL.c */
  extern double *ESDPc;			/*                        :escL.c */
  extern double *ESDPc1;		/*                        :escL.c */
  extern double *ESDPc2;		/*                        :escL.c */
  extern double *ESDPs;			/*                        :escL.c */
  extern double *ESDPs1;		/*                        :escL.c */
  extern double *ESDPs2;		/*                        :escL.c */
  extern double *ESVc1;			/*                        :escL.c */
  extern double *ESVs1;			/*                        :escL.c */
  extern double *ESg22c1;		/*                        :escL.c */
  extern double *ESg22s1;		/*                        :escL.c */
  extern double *cs2;			/*                        :escL.c */
  extern double *sn2;			/*                        :escL.c */
  extern double *drgt;			/*                        :escL.c */
  extern double *dza;			/*                        :escL.c */
  extern double *dzgt;			/*                        :escL.c */
  extern double *ESsb;			/*                        :escL.c */
  extern double *ESsb1a;		/*                        :escL.c */
  extern double *ESsb2a;		/*                        :escL.c */
  extern double *rcT;			/*                        :escL.c */
  extern double *rsT;			/*                        :escL.c */
  extern double *rcT1a;			/*                        :escL.c */
  extern double *rsT1a;			/*                        :escL.c */
  extern double *rsT2a;			/*                        :escL.c */
  extern double *rcT2a;			/*                        :escL.c */
  double ESsAVc[];			/*                        :escL.c */
  double ESsAVs[];			/*                        :escL.c */
  double ESsAVc2[];			/*                        :escL.c */
  double ESsAVs2[];			/*                        :escL.c */
  static double gjr;			/*                        :escL.c */
  static double *gji;			/*                        :escL.c */
  static double *Yjr;			/*                        :escL.c */
  static double *Yji;			/*                        :escL.c */
  static double *dgji;			/*                        :escL.c */
  static double *dYjr;			/*                        :escL.c */
  static double *dYji;			/*                        :escL.c */
  static double hcur;			/*                        :escL.c */
  int Opt;				/* .ESInitStFundSolution():escL.c */
  int *n;				/*            .st2DVrMHD():escL.c */
  int ESStInitSmallResSolution();	/*                        :escL.c */
  int ESStSetVatol();			/*                        :escL.c */
  int ESMHDStCheckLowN();		/*                        :escL.c */
  int ESMHDStShiftUpLowN();		/*                        :escL.c */
  int ESMHDStShiftDnLowN();		/*                        :escL.c */
  int ESMHDStabLowN();			/*                        :escL.c */
#endif
  Ignor void;
  Ignor double;
  Ignor char;
  Ignor int;
  Systm NULL;
  Systm CLOCKS_PER_SEC;
  Systm free();
  Systm malloc();
  Systm printf();
  Systm fabs();
  Systm sqrt();
  Systm abs();
  Systm fopen();
  Systm fwrite();
  Systm fclose();
  Undef ESsVc;			/* undefined */
  Undef ESsVc2;			/* undefined */
  Undef ESsVs;			/* undefined */
  Undef ESsVs2;			/* undefined */
  Undef ESGaac;			/* undefined */
  Undef ESGaac2;		/* undefined */
  Undef ESGaqc;			/* undefined */
  Undef ESGaqc2;		/* undefined */
  Undef ESGqqc;			/* undefined */
  Undef ESGqqc2;		/* undefined */
  Undef gazr;			/* undefined */
  Undef ESGazc;			/* undefined */
  Undef ESGazc2;		/* undefined */
  Undef gazi;			/* undefined */
  Undef gqzr;			/* undefined */
  Undef ESGqzc;			/* undefined */
  Undef ESGqzc2;		/* undefined */
  Undef gqzi;			/* undefined */
  Undef ESGaas;			/* undefined */
  Undef ESGaas2;		/* undefined */
  Undef ESGaqs;			/* undefined */
  Undef ESGaqs2;		/* undefined */
  Undef ESGqqs;			/* undefined */
  Undef ESGqqs2;		/* undefined */
  Undef ESGazs;			/* undefined */
  Undef ESGazs2;		/* undefined */
  Undef ESGqzs;			/* undefined */
  Undef ESGqzs2;		/* undefined */
  Undef ReInitArray();		/* NO prototype */
  Undef FailureAlarm();		/* NO prototype */
  Undef ESgP2gF();		/* NO prototype */
  Undef splA();			/* NO prototype */
  Undef ESSetSplA();		/* NO prototype */
  Undef splRA();		/* NO prototype */
  Undef splRA2();		/* NO prototype */
  Undef ESSetSplDCr();		/* NO prototype */
  Undef splRDCr();		/* NO prototype */
  Undef ESSetSplDPr();		/* NO prototype */
  Undef splRDPr();		/* NO prototype */
  Undef CholDeComp();		/* NO prototype */
  Undef CholBksbComp();		/* NO prototype */
  Undef pow();			/* NO prototype */
  Undef out();			/* NO prototype */
  Undef lsode_();		/* NO prototype */
  extern int ESNa1;		/* External */
  extern int ES2Mp1;		/* External */
  extern double *ESGzzc;	/* External */
  extern double *ESGzzc2;	/* External */
  extern double *ESGzzs;	/* External */
  extern double *ESGzzs2;	/* External */
  extern int ESmemlev;		/* External */
  extern double *dra;		/* External */
  extern int ESNp1;		/* External */
  extern int ESNa;		/* External */
  extern double *ESLc;		/* External */
  extern double *ESLc1;		/* External */
  extern double *ESLs;		/* External */
  extern double *ESLs1;		/* External */
  extern int ESNp;		/* External */
  extern double *cs1;		/* External */
  extern double *sn1;		/* External */
  extern int ES2Mp;		/* External */
  extern double *ESLc2;		/* External */
  extern double *ESLs2;		/* External */
  extern double *ESsa;		/* External */
  extern double *ESgm;		/* External */
  extern double *ESgm2a;	/* External */
  extern double *ESgm1a;	/* External */
  extern double cr2;		/* External */
  extern double *ESg22c;	/* External */
  extern double *ESg22s;	/* External */
  extern double *ESsq;		/* External */
  extern double *ESg11c;	/* External */
  extern double *ESg11c2;	/* External */
  extern double *ESg12c;	/* External */
  extern double *ESg12c2;	/* External */
  extern double *ESg22c2;	/* External */
  extern double *ESVc;		/* External */
  extern double *ESVc2;		/* External */
  extern double *ESg11s;	/* External */
  extern double *ESg11s2;	/* External */
  extern double *ESg12s;	/* External */
  extern double *ESg12s2;	/* External */
  extern double *ESg22s2;	/* External */
  extern double *ESVs;		/* External */
  extern double *ESVs2;		/* External */
  extern double *ESFF;		/* External */
  extern double *ESFF2a;	/* External */
  extern double *ESaT;		/* External */
  extern double *ESaT2a;	/* External */
  extern int ESEqSolvInCr;	/* External */
  extern int ESEqSolvInPr;	/* External */
  extern double *ESPs;		/* External */
  extern double *ESPs2a;	/* External */
  extern int ESStKRec;		/* External */
  extern int ESStNRec;		/* External */
  extern int ESStMRec;		/* External */
  extern int ESStN;		/* External */
  extern int ESStM1;		/* External */
  extern int ESStM2;		/* External */
  extern double *ESaR0;		/* External */
  extern clock_t clock();	/* External() */
#endif
extern clock_t clock();	/* undefined */
extern double cr2;	/* undefined */
extern double cr3;	/* undefined */
extern double cr4;	/* undefined */
extern double cr6;	/* undefined */
extern double cr12;	/* undefined */
extern double cgp;	/* undefined */
extern double c2gp;	/* undefined */
extern double cgp_4;	/* undefined */
extern double cr2gp;	/* undefined */
extern double cgm0;	/* undefined */
extern double crgm0;	/* undefined */
extern int ESmemlev;	/* undefined */
extern int ESEqSolvInPr;/* undefined */
extern int ESEqSolvInCr;/* undefined */
extern int ESNa;	/* undefined */
extern int ESNa1;	/* undefined */
extern double *ESsa;	/* undefined */
extern int ESNp;	/* undefined */
extern int ESNp1;	/* undefined */
extern int ES2Mp;	/* undefined */
extern int ES2Mp1;	/* undefined */
extern int ESMp;	/* undefined */
extern int ESMp1;	/* undefined */
extern int ESFp1;	/* undefined */
extern double *ESsq;	/* undefined */
extern double *ESsq1a;	/* undefined */
extern double *ESsq2a;	/* undefined */
extern double *ESgm;	/* undefined */
extern double *ESgm1a;	/* undefined */
extern double *ESgm2a;	/* undefined */
extern double *ESPs;	/* undefined */
extern double *ESPs1a;	/* undefined */
extern double *ESPs2a;	/* undefined */
extern double *ESaT;	/* undefined */
extern double *ESaT1a;	/* undefined */
extern double *ESaT2a;	/* undefined */
extern double *ESFF;	/* undefined */
extern double *ESFF1a;	/* undefined */
extern double *ESFF2a;	/* undefined */
extern double *ESaF;	/* undefined */
extern double *ESaF1a;	/* undefined */
extern double *ESaF2a;	/* undefined */
extern double *ESDPc;	/* undefined */
extern double *ESDPc1;	/* undefined */
extern double *ESDPc2;	/* undefined */
extern double *ESDPs;	/* undefined */
extern double *ESDPs1;	/* undefined */
extern double *ESDPs2;	/* undefined */
extern double *ESLc;	/* undefined */
extern double *ESLs;	/* undefined */
extern double *ESVc;	/* undefined */
extern double *ESVs;	/* undefined */
extern double *ESLc1;	/* undefined */
extern double *ESLs1;	/* undefined */
extern double *ESVc1;	/* undefined */
extern double *ESVs1;	/* undefined */
extern double *ESLc2;	/* undefined */
extern double *ESLs2;	/* undefined */
extern double *ESVc2;	/* undefined */
extern double *ESVs2;	/* undefined */
extern double *ESg22c;	/* undefined */
extern double *ESg22s;	/* undefined */
extern double *ESg22c1;	/* undefined */
extern double *ESg22s1;	/* undefined */
extern double *ESg22c2;	/* undefined */
extern double *ESg22s2;	/* undefined */
extern double *ESg12c;	/* undefined */
extern double *ESg12s;	/* undefined */
extern double *ESg12c2;	/* undefined */
extern double *ESg12s2;	/* undefined */
extern double *ESg11c;	/* undefined */
extern double *ESg11s;	/* undefined */
extern double *ESg11c2;	/* undefined */
extern double *ESg11s2;	/* undefined */
extern double *cs1;	/* undefined */
extern double *sn1;	/* undefined */
extern double *cs2;	/* undefined */
extern double *sn2;	/* undefined */
extern double *dra;	/* undefined */
extern double *drgt;	/* undefined */
extern double *dza;	/* undefined */
extern double *dzgt;	/* undefined */
extern double *ESaR0;	/* undefined */
extern double *ESsb;	/* undefined */
extern double *ESsb1a;	/* undefined */
extern double *ESsb2a;	/* undefined */
extern double *rcT;	/* undefined */
extern double *rsT;	/* undefined */
extern double *rcT1a;	/* undefined */
extern double *rsT1a;	/* undefined */
extern double *rsT2a;	/* undefined */
extern double *rcT2a;	/* undefined */
extern double *ESGzzc;	/* undefined */
extern double *ESGzzs;	/* undefined */
extern double *ESGzzc2;	/* undefined */
extern double *ESGzzs2;	/* undefined */
extern int ESStN;	/* undefined */
extern int ESStM1;	/* undefined */
extern int ESStM2;	/* undefined */
extern int ESStNRec;	/* undefined */
extern int ESStMRec;	/* undefined */
extern int ESStKRec;	/* undefined */
double ESsAVc[];	/*  */
double ESsAVs[];	/*  */
double ESsAVc2[];	/*  */
double ESsAVs2[];	/*  */
static clock_t ESst0;	/*  */
static double rR0;	/*  */
static double R0;	/*  */
static int dM1;		/* low band for poloidal wave numbers */
static int dM2;		/* high band for poloidal wave numbers */
static int M1;		/* m min lowest poloidal wave number */
static int M2;		/* m max highest poloidal wave number */
static int Mmx;		/*  */
static int N;		/* toroidal wave number */
static int Mp1;		/* number of harmonics */
static int MMp1;	/* Mp1*Mp1 */
static int M4Mp1;	/* 4*Mp1*Mp1 */
static int nRes;	/* number of resonant points */
static int Mres;	/*  */
static int iRes;	/*  */
static int kRes;	/*  */
static int *mRes;	/* m at the resonant points */
static double qmn;	/* q min */
static double qmx;	/* q max */
static double PM1;	/*  */
static double PM2;	/*  */
static double *aRes;	/* a of the resosnant points */
static double *qRes;	/* q at the resonant points */
static double *gmRes;	/* gm=1/q at the resonant points */
static double *dgmRes;	/* gm' at the resonant points */
static double aResChck;	/*  */
static double *gyr;	/* {\vgy^j}, real part */
static double *gyi;	/* {\vgy^j}, imaginary part */
static double *aYr;	/* {\vaY^j}, real part */
static double *aYi;	/* {\vaY^j}, imaginary part */
static double gjr;	/* {\vgj^j_0}, real part */
static double *gji;	/* {\vgj^j_0}, imaginary part */
static double *Yjr;	/* {\vaY^j_j}, real part */
static double *Yji;	/* {\vaY^j_j}, imaginary part */
static double *dgyr;	/* Drivatives of the fundamental solution */
static double *dgyi;	/*  */
static double *daYr;	/*  */
static double *daYi;	/*  */
static double *dgji;	/*  */
static double *dYjr;	/*  */
static double *dYji;	/*  */
static double *gaar;	/* working metric tensor */
static double *gaai;	/*  */
static double *gaqr;	/*  */
static double *gaqi;	/*  */
static double *gqqr;	/*  */
static double *gqqi;	/*  */
static double *gzzr;	/*  */
static double *gzzi;	/*  */
static double *svr;	/* \msv */
static double *svi;	/* \msv */
static double *dsvr;	/*  */
static double *dsvi;	/*  */
static double *aLr;	/*  */
static double *aLi;	/*  */
static double *daLr;	/*  */
static double *daLi;	/*  */
static double *Ar;	/*  */
static double *Ai;	/*  */
static double *Br;	/*  */
static double *Bi;	/*  */
static double *Cr;	/*  */
static double *Ci;	/*  */
static double *Dr;	/*  */
static double *Di;	/*  */
static double *Er;	/*  */
static double *Ei;	/*  */
static double *Fr;	/*  */
static double *Fi;	/*  */
static double *Gr;	/*  */
static double *Gi;	/*  */
static double *Kr;	/*  */
static double *Ki;	/*  */
static double *Rr;	/*  */
static double *Ri;	/*  */
static double *GNr;	/*  */
static double *GNi;	/*  */
static double *GSr;	/*  */
static double *GSi;	/*  */
static double *VNr;	/*  */
static double *VNi;	/*  */
static double *VSr;	/*  */
static double *VSi;	/*  */
static double *Tr;	/*  */
static double *X1r;	/*  */
static double *X1i;	/*  */
static double *X2r;	/*  */
static double *X2i;	/*  */
static double **wAr;	/* $\msa$ */
static double **wAi;	/* $\msa$ */
static double **wBr;	/*  */
static double **wBi;	/*  */
static double **wCr;	/* $\maK^s$ */
static double **wCi;	/* $\maK^s$ */
static double **wDr;	/*  */
static double **wDi;	/*  */
static double **wEr;	/*  */
static double **wEi;	/*  */
static double **wFr;	/*  */
static double **wFi;	/*  */
static double **wGr;	/* $\maH$ */
static double **wGi;	/* $\maH$ */
static double **wKr;	/* $\maK^n$ */
static double **wKi;	/* $\maK^n$ */
static double **wRr;	/*  */
static double **wRi;	/*  */
static double **wGNr;	/* $\maG^n$ */
static double **wGNi;	/* $\maG^n$ */
static double **wGSr;	/* $\maG^s$ */
static double **wGSi;	/* $\maG^s$ */
static double **wVNr;	/*  */
static double **wVNi;	/*  */
static double **wVSr;	/*  */
static double **wVSi;	/*  */
static int *ind;	/*  */
static int FlStChol;	/*  */
static int kCheck;	/*  */
static double ESsgnX;	/*  */
static double ESsgnY;	/*  */
static double gymr;	/*  */
static double gymi;	/*  */
static double aYmr;	/*  */
static double aYmi;	/*  */
static double ESdet;	/*  */
static int FlagRes;	/*  */
static int neq;		/* number of ODEs */
static double hcur;	/*  */
static double xout;	/*  */
static double reltol;	/*  */
static double abstol;	/*  */
static double *rwork;	/*  */
static double *yh;	/*  */
static double *vatol;	/*  */
static int itol;	/*  */
static int itask;	/*  */
static int istate;	/*  */
static int iopt;	/*  */
static int mf;		/*  */
static int lrw;		/*  */
static int liw;		/*  */
static int *iwork;	/*  */
static int NA2Mp1;	/*  */
static int Mgy;		/*  */
static int MaY;		/*  */
static FILE *fpy;	/*  */
static FILE *fpt;	/*  */
static int NRec;	/*  */
static int MRec;	/*  */
static int KRec;	/*  */
int ESReInitMHDMetrTnsr()
{
  Undef ReInitArray();
  Undef FailureAlarm();
  Undef ESsVc;
  Undef ESsVc2;
  Undef ESsVs;
  Undef ESsVs2;
  extern int ESNa1;		/* undefined */
  extern int ES2Mp1;		/* undefined */
  extern double *ESGzzc;	/* undefined */
  extern double *ESGzzc2;	/* undefined */
  extern double *ESGzzs;	/* undefined */
  extern double *ESGzzs2;	/* undefined */
  extern int ESmemlev;		/* undefined */
  static int NA2Mp1;	/*  :escL.c */
/*
   */
#ifdef Doc_ESReInitMHDMetrTnsr

\section{Skeleton of ESReInitMHDMetrTnsr()}
  \begin{verbatim}
    ESReInitMHDMetrTnsr(){
    }
  \end{verbatim}
\section{ESReInitMHDMetrTnsr()}
#endif
}
int ESDeInitMHDMetrTnsr()
{
  extern double *ESGzzc;/* undefined */
  static int NA2Mp1;	/*  :escL.c */
/*
   */
#ifdef Doc_ESDeInitMHDMetrTnsr

\section{Skeleton of ESDeInitMHDMetrTnsr()}
  \begin{verbatim}
    ESDeInitMHDMetrTnsr(){
    }
  \end{verbatim}
\section{ESDeInitMHDMetrTnsr()}
#endif
}
int ESMHDMetrTnsr()
{
  Undef ESgP2gF();
  Undef splA();
  extern double *dra;		/* undefined */
  extern int ESNp1;		/* undefined */
  extern int ES2Mp1;		/* undefined */
  extern double *ESGzzc;	/* undefined */
  extern double *ESGzzs;	/* undefined */
  extern double *ESGzzc2;	/* undefined */
  extern double *ESGzzs2;	/* undefined */
  extern int ESNa1;		/* undefined */
  extern int ESNa;		/* undefined */
  extern double *ESLc;		/* undefined */
  extern double *ESLc1;		/* undefined */
  extern double *ESLs;		/* undefined */
  extern double *ESLs1;		/* undefined */
  extern int ESNp;		/* undefined */
  extern double *cs1;		/* undefined */
  extern double *sn1;		/* undefined */
  extern int ES2Mp;		/* undefined */
  extern double *ESLc2;		/* undefined */
  extern double *ESLs2;		/* undefined */
  static double R0;	/*  :escL.c */
/*
   */
#ifdef Doc_ESMHDMetrTnsr
\section{Skeleton of ESMHDMetrTnsr()}
  \begin{verbatim}
    ESMHDMetrTnsr(){
      Calculations of $\gd$;
    }
  \end{verbatim}
\section{ESMHDMetrTnsr()}
In the equilibrium documentation part of the code, there is an
inconsistency between the conventional, ``clock-wise'', direction of the
poloidal magnetic field and the ``counter-clock'' $\gt$ coordinate. In
the stability part of \ESC, we refer equilibrium coordinates as
$\gr^E,\gt^E\gf^E$, while using $\gr,\gt,\gf$ for coordinates consistent
with the conventional directions of the magnetic field. 

\subsection{Relationships between the stability and the equilibrium
coordinates} 
\bqbl
&&
\gr
=
\gr^E
,\quad
\gt
=
-\gt^E
,\quad
\gf
=
\gf^E
,\quad
D
=
\R{D(z,r)}{D(a,\gt)}
=
D^E
,\\&&
B^\gt(\gr,\gt)
=
B^{\gt^E}(\gr,-\gt)
,\quad
\gh
=
-\gh^E(\gr,-\gt)
,\quad
j^\gt(\gr,\gt)
=
j^{\gt^E}(\gr,-\gt)
,\quad
\bgn
=
-\bgn^E(\gr,-\gt)
,\\&&
g_{\gr\gr}(\gr,\gt)
=
g^E_{\gr\gr}(\gr,-\gt)
,\quad
g_{\gr\gt}(\gr,\gt)
=
-g^E_{\gr\gt}(\gr,-\gt)
,\quad
g_{\gt\gt}(\gr,\gt)
=
g^E_{\gt\gt}(\gr,-\gt)
.\eqbl
\subsection{Metric tensor of the straight field line coordinates}
Straight field line coordinates $a,\gq,\gz$
\bqbl
&&
a
=
\gr
,\quad
\gq
=
\gt
,\quad
\gz
=
\gf
-\gd
,\quad
\gd
=
-q\bgh
,\quad
\bgh
\equiv
\R{\gh}{\bgF'}
=
-\int^\gt_0\left(\R{L}{L_0}-1\right)d\gt
,\\&&
L
=
\R{R_0D}{ar}
,\quad
q
\equiv
-\R{aL_0\baF}{R_0\bgY'}
,\quad
\gm
\equiv
\r{q}
.\eqbl
Metric tensor in straight field line coordinates
\bqbl
&&
g_{aa}
=
g_{\gr\gr}+r^2\gd'^2_\gr
,\quad
g_{a\gq}
=
g_{a\gt}+r^2\gd'_\gr\gd'_\gt
,\quad
g_{\gq\gq}
=
g_{\gt\gt}+r^2\gd'^2_\gt
,\quad
g_{a\gz}
=
r^2\gd'_\gr
,\quad
g_{\gq\gz}
=
r^2\gd'_\gt
,\quad
g_{\gz\gz}
=
r^2
.\eqbl
Necessary metric tensor combinations for $W$
\bqbl
&&
G_{aa}
=
\R{g_{aa}}{\q{g}}
=
\R{\baG_{aa}}{a}
,\quad
G_{a\gq}
=
\R{g_{a\gq}}{\q{g}}
=
\baG_{a\gq}
,\quad
G_{\gq\gq}
=
\R{g_{\gq\gq}}{\q{g}}
=
a\baG_{\gq\gq}
,\\&&
G_{a\gz}
=
\R{g_{a\gz}}{\q{g}}
=
\R{\baG_{a\gz}}{a}
,\quad
G_{\gq\gz}
=
\R{g_{\gq\gz}}{\q{g}}
=
\baG_{\gq\gz}
,\quad
G_{\gz\gz}
=
\R{g_{\gz\gz}}{\q{g}}
=
\R{\baG_{\gz\gz}}{a}
,\quad
v
=
\R{\q{g}}{\bgF'}
.\eqbl
They are calculated as
\bqbl
&&
\R{\gd'_\gt}{a}
=
q\R{\taL}{aL_0}
,\quad
\baG_{\gz\gz}
=
\R{R_0}{L}
,\quad
G_{\gq\gz}
=
\R{R_0\gd'_\gt}{La}
,\quad
\baG_{a\gz}
=
\R{R_0\gd'_\gr}{L}
,\\&&
\baG_{aa}
=
a\R{g_{\gr\gr}}{\q{g}}
+\R{R_0\gd'^2_\gr}{L}
,\quad
G_{a\gq}
=
\R{g_{\gr\gt}}{\q{g}}
+\R{R_0\gd'_\gr\gd'_\gt}{La}
,\quad
\baG_{\gq\gq}
=
\R{g_{\gt\gt}}{a\q{g}}
+\R{R_0\gd'^2_\gt}{La^2}
,\\&&
v
=
\R{R^2_0(V+L)}{L_0\baF}
,\quad
v'_a
=
\R{R^2_0(V'+L')}{\baF L_0}
-\R{R^2_0(V+L)}{\baF L_0}\left(\R{\baF'}{\baF}+\R{L'_0}{L_0}\right)
.\eqbl
Asymptotic values of $\gd$ derivatives at $a=0$
\bqbl
&&
\R{\gd'_\gt}{\gr}
=
q\R{\taL}{aL_0}
=
q\R{2L'^c_1\cos\gt+2L'^s_1\sin\gt+aL''^c_2\cos2\gt+aL''^s_2\sin2\gt}{L_0}
,\\&&
\left(\R{\gd'_\gt}{\gr}\right)'_a
=
q\R{L''^c_2\cos2\gt+L''^s_2\sin2\gt}{L_0}
,\\&&
\gd
=
q\R{2aL'^c_1\sin\gt-2aL'^s_1\cos\gt
 +\r{2}a^2L''^c_2\sin2\gt-\r{2}a^2L''^s_2\cos2\gt}{L_0} 
,\\&&
\gd'_\gr
=
q\R{2L'^c_1\sin\gt-2L'^s_1\cos\gt+aL''^c_2\sin2\gt-aL''^s_2\cos2\gt}{L_0} 
,\\&&
\gd''_\gr
=
q\R{L''^c_2\sin2\gt-L''^s_2\cos2\gt}{L_0} 
.\eqbl
Asymptotic values of metric coefficients at $a=0$
\bqbl
&&
\baG_{\gz\gz}
=
\R{R_0}{L_0}
,\quad
\baG'_{\gz\gz,a}
=
-\R{R_0(2L'^c_1\cos\gt+2L'^s_1\sin\gt)}{L^2_0}
,\\&&
\baG_{a\gz}
=
\gd'_\gr\baG_{\gz\gz}
,\quad
\baG'_{a\gz,a}
=
\gd''_{\gr\gr}\baG_{\gz\gz}
+\gd'_\gr\baG'_{\gz\gz,a}
,\\&&
\baG_{\gq\gz}
=
\R{\gd'_\gt}{\gr}\baG_{\gz\gz}
,\quad
\baG'_{\gq\gz,a}
=
\left(\R{\gd'_\gt}{\gr}\right)'_\gr\baG_{\gz\gz}
+\R{\gd'_\gt}{\gr}\baG'_{\gz\gz,a}
,\\&&
\baG_{aa}
=
\R{\gr g_{\gr\gr}}{\q{g}}
+\gd'_\gr\baG_{a\gz}
,\quad
\baG'_{aa,a}
=
\left(\R{\gr g_{\gr\gr}}{\q{g}}\right)'_\gr
+\gd''_{\gr\gr}\baG_{a\gz}
+\gd'_\gr\baG'_{a\gz,a}
,\\&&
\baG_{a\gq}
=
\R{g_{\gr\gt}}{\q{g}}
+\gd'_\gr\baG_{\gq\gz}
,\quad
\baG'_{a\gq,a}
=
\left(\R{g_{\gr\gt}}{\q{g}}\right)'_\gr
+\gd''_{\gr\gr}\baG_{\gq\gz}
+\gd'_\gr\baG'_{\gq\gz,a}
,\\&&
\baG_{\gq\gq}
=
\R{g_{\gt\gt}}{\gr\q{g}}
+\R{\gd'_\gt}{\gr}\baG_{\gq\gz}
,\quad
\baG'_{\gq\gq,a}
=
\left(\R{g_{\gt\gt}}{\gr\q{g}}\right)'_\gr
+\left(\R{\gd'_\gt}{\gr}\right)'_\gr\baG_{\gq\gz}
+\R{\gd'_\gt}{\gr}\baG'_{\gq\gz,a}
.\eqbl
Metric tensor is calculated using an auxiliary functions
\bqbl
&&
F
\equiv
\taL
=
2\sum^M_{k=1}(L^c_k\cos k\gt+L^s_k\sin k\gt)
,\quad
H
\equiv
2\sum^M_{k=1}\left(
  \R{L^c_k\sin k\gt-L^s_k\cos k\gt}{k}
 \right)
,\\&&
\left(\r{L_0}\right)'_\gr
=
-\R{L'_0}{L^2_0}
,\quad
\left(\r{L_0}\right)''_{\gr\gr}
=
2\R{L'^2_0}{L^3_0}
-\R{L''_0}{L^2_0}
,\\&&
\R{\gd'_\gt}{\gr}
=
q\R{F}{\gr L_0}
,\quad
\left(\R{\gd'_\gt}{\gr}\right)'_\gr
=
q'\R{F}{\gr L_0}
+q\R{F'}{\gr L_0}
-q\R{F}{\gr L_0}\left(\r{\gr}+\R{L'_0}{L_0}\right)
,\\&&
\gd'_\gr
=
q'\R{H}{L_0}
+q\R{H'}{L_0}
-q\R{H}{L_0}\R{L'_0}{L_0}
,\\&&
\gd''_{\gr\gr}
=
q''\R{H}{L_0}
+2q'\left(\R{H'}{L_0}-\R{H}{L_0}\R{L'_0}{L_0}\right)
+q\left[\R{H''}{L_0}-2\R{H'}{L_0}\R{L'_0}{L_0}
 +\R{H}{L_0}L_0\left(\r{L_0}\right)''\right]
.\eqbl
Radial derivatives of metric coefficients at $a=1$
\bqbl
&&
\baG_{\gz\gz}
=
\R{R_0}{L}
,\quad
\baG'_{\gz\gz,a}
=
-\R{R_0L'}{L^2}
=
-\R{L'}{L}\baG_{\gz\gz}
,\\&&
\baG_{a\gz}
=
\gd'_{\gr}\baG_{\gz\gz}
,\quad
\baG'_{a\gz,a}
=
\gd''_{\gr\gr}\baG_{\gz\gz}
+\gd'_\gr\baG'_{\gz\gz,a}
,\\&&
\baG_{\gq\gz}
=
\R{\gd'_\gt}{\gr}\baG_{\gz\gz}
,\quad
\baG'_{\gq\gz,a}
=
\left(\R{\gd'_\gt}{\gr}\right)'_\gr\baG_{\gz\gz}
+\R{\gd'_\gt}{\gr}\baG'_{\gz\gz,a}
,\\&&
\baG_{aa}
=
\R{\gr g_{\gr\gr}}{\q{g}}
+\gd'_\gr\baG_{a\gz}
,\quad
\baG'_{aa,a}
=
\left(\R{\gr g_{\gr\gr}}{\q{g}}\right)'_\gr
+\gd''_{\gr\gr}\baG_{a\gz}
+\gd'_\gr\baG'_{a\gz,a}
,\\&&
\baG_{a\gq}
=
\R{g_{\gr\gt}}{\q{g}}
+\gd'_\gr\baG_{\gq\gz}
,\quad
\baG'_{a\gq,a}
=
\left(\R{g_{\gr\gt}}{\q{g}}\right)'_\gr
+\gd''_{\gr\gr}\baG_{\gq\gz}
+\gd'_\gr\baG'_{\gq\gz,a}
,\\&&
\baG_{\gq\gq}
=
\R{g_{\gt\gt}}{\gr\q{g}}
+\R{\gd'_\gt}{\gr}\baG_{\gq\gz}
,\quad
\baG'_{\gq\gq,a}
=
\left(\R{g_{\gt\gt}}{\gr\q{g}}\right)'_\gr
+\left(\R{\gd'_\gt}{\gr}\right)'_\gr\baG_{\gq\gz}
+\R{\gd'_\gt}{\gr}\baG'_{\gq\gz,a}
.\eqbl
#endif
}
int ESInitStLSODE(n)
  int n;	/*  */
{
  int n;		/*  .ESInitStLSODE():escL.c */
  static int lrw;	/*                  :escL.c */
  static int liw;	/*                  :escL.c */
  static int *iwork;	/*                  :escL.c */
  static double *rwork;	/*                  :escL.c */
  static double *yh;	/*                  :escL.c */
  static double *vatol;	/*                  :escL.c */
/*
   */
#ifdef Doc_ESInitStLSODE

\section{Skeleton of ESInitStLSODE()}
  \begin{verbatim}
    ESInitStLSODE(){
    }
  \end{verbatim}
\section{ESInitStLSODE()}
#endif
}
int ESDeInitStLSODE()
{
  static double *rwork;	/*  :escL.c */
  static int *iwork;	/*  :escL.c */
/*
   */
#ifdef Doc_ESDeInitStLSODE

\section{Skeleton of ESDeInitStLSODE()}
  \begin{verbatim}
    ESDeInitStLSODE(){
    }
  \end{verbatim}
\section{ESDeInitStLSODE()}
#endif
}
int ESStResonances()
{
  Undef ESSetSplA();
  Undef splRA();
  Undef splRA2();
  extern double *ESsa;	/* undefined */
  extern double *ESgm;	/* undefined */
  extern double *ESgm2a;/* undefined */
  extern int ESNa;	/* undefined */
  extern double *ESgm1a;/* undefined */
  extern double cr2;	/* undefined */
  static int N;		/*  :escL.c */
  static int nRes;	/*  :escL.c */
  static double qmn;	/*  :escL.c */
  static double qmx;	/*  :escL.c */
  static double *aRes;	/*  :escL.c */
  static double *qRes;	/*  :escL.c */
  static double *gmRes;	/*  :escL.c */
  static double *dgmRes;/*  :escL.c */
  static int *mRes;	/*  :escL.c */
/*
   */
#ifdef Doc_ESStResonances

\section{Skeleton of ESStResonances()}
  \begin{verbatim}
    ESStResonances(){
    }
  \end{verbatim}
\section{ESStResonances()}
The routine calculates the position of the resonant points and certain
parameters in the resonant points.

Spline representation of $\gm(a)$ at an elementary interval
\bqbl
&&
\gm
=
x\gm_i+X\gm_{i+1}
+[(x^3-x)\gm''_i+(X^3-x)\gm''_{i+1}]{h^2\over6}
,\\&&
h\equiv a_{i+1}-a_i
,\quad
x\equiv{a_{i+1}-a\over h}
,\quad
X\equiv{a-a_i\over h}
,\\&&
\gm'={\gm_{i+1}-\gm_i\over h}
+[(3X^2-1)\gm''_{i+1}-(3x^2-1)\gm''_i]{h\over6}
,\quad
\gm''=x\gm''_i+X\gm''_{i+1}
.\eqbl

\begin{enumerate}
\item No point $\gm''=0$
\begin{enumerate}
\item different signs of $\gm'_i$ and $\gm'_{i+1}$
\begin{itemize}
\item local extremum between $a_i$ and $a_{i+1}$
\end{itemize}
\item same signs of $\gm'_i$ and $\gm'(a_{i+1})$
\begin{itemize}
\item no local extremum between $a_i$ and $a_{i+1}$
\end{itemize}
\end{enumerate}
\item Point $\gm''(a_s)=0$ inside the interval
\begin{enumerate}
\item different signs of $\gm'_i$ and $\gm'(a_s)$
\begin{itemize}
\item local extremum between $a_i$ and $a_s$
\end{itemize}
\item same signs of $\gm'_i$ and $\gm'(a_s)$
\begin{itemize}
\item no local extremum between $a_i$ and $a_s$
\end{itemize}
\item different signs of $\gm'_{i+1}$ and $\gm'(a_s)$
\begin{itemize}
\item local extremum between $a_{i+1}$ and $a_s$
\end{itemize}
\item same signs of $\gm'_{i+1}$ and $\gm'(a_s)$
\begin{itemize}
\item no local extremum between $a_{i+1}$ and $a_s$
\end{itemize}
\end{enumerate}
\end{enumerate}

#endif
}
int ESReInitMHDStabLowN()
{
  extern int ES2Mp1;	/* undefined */
  extern int ESmemlev;	/* undefined */
  static int MMp1;	/*  :escL.c */
  static int Mp1;	/*  :escL.c */
  static int M4Mp1;	/*  :escL.c */
  static int neq;	/*  :escL.c */
  static double *Ar;	/*  :escL.c */
  static double *Ai;	/*  :escL.c */
  static double *Br;	/*  :escL.c */
  static double *Bi;	/*  :escL.c */
  static double *Cr;	/*  :escL.c */
  static double *Ci;	/*  :escL.c */
  static double *Dr;	/*  :escL.c */
  static double *Di;	/*  :escL.c */
  static double *Er;	/*  :escL.c */
  static double *Ei;	/*  :escL.c */
  static double *Fr;	/*  :escL.c */
  static double *Fi;	/*  :escL.c */
  static double *Gr;	/*  :escL.c */
  static double *Gi;	/*  :escL.c */
  static double *Kr;	/*  :escL.c */
  static double *Ki;	/*  :escL.c */
  static double *Rr;	/*  :escL.c */
  static double *Ri;	/*  :escL.c */
  static double *GNr;	/*  :escL.c */
  static double *GNi;	/*  :escL.c */
  static double *GSr;	/*  :escL.c */
  static double *GSi;	/*  :escL.c */
  static double *VNr;	/*  :escL.c */
  static double *VNi;	/*  :escL.c */
  static double *VSr;	/*  :escL.c */
  static double *VSi;	/*  :escL.c */
  static double *Tr;	/*  :escL.c */
  static double *X1r;	/*  :escL.c */
  static double *X1i;	/*  :escL.c */
  static double *X2r;	/*  :escL.c */
  static double *X2i;	/*  :escL.c */
  static double **wAr;	/*  :escL.c */
  static double **wAi;	/*  :escL.c */
  static double **wBr;	/*  :escL.c */
  static double **wBi;	/*  :escL.c */
  static double **wCr;	/*  :escL.c */
  static double **wCi;	/*  :escL.c */
  static double **wDr;	/*  :escL.c */
  static double **wDi;	/*  :escL.c */
  static double **wEr;	/*  :escL.c */
  static double **wEi;	/*  :escL.c */
  static double **wFr;	/*  :escL.c */
  static double **wFi;	/*  :escL.c */
  static double **wGr;	/*  :escL.c */
  static double **wGi;	/*  :escL.c */
  static double **wKr;	/*  :escL.c */
  static double **wKi;	/*  :escL.c */
  static double **wRr;	/*  :escL.c */
  static double **wRi;	/*  :escL.c */
  static double **wGNr;	/*  :escL.c */
  static double **wGNi;	/*  :escL.c */
  static double **wGSr;	/*  :escL.c */
  static double **wGSi;	/*  :escL.c */
  static double **wVNr;	/*  :escL.c */
  static double **wVNi;	/*  :escL.c */
  static double **wVSr;	/*  :escL.c */
  static double **wVSi;	/*  :escL.c */
  static double *gyr;	/*  :escL.c */
  static double *gyi;	/*  :escL.c */
  static double *aYr;	/*  :escL.c */
  static double *aYi;	/*  :escL.c */
  static double *dgyr;	/*  :escL.c */
  static double *dgyi;	/*  :escL.c */
  static double *daYr;	/*  :escL.c */
  static double *daYi;	/*  :escL.c */
  static int *ind;	/*  :escL.c */
  static double *gaar;	/*  :escL.c */
  static double *gaai;	/*  :escL.c */
  static double *gaqr;	/*  :escL.c */
  static double *gaqi;	/*  :escL.c */
  static double *gqqr;	/*  :escL.c */
  static double *gqqi;	/*  :escL.c */
  static double *gzzr;	/*  :escL.c */
  static double *gzzi;	/*  :escL.c */
  static double *svr;	/*  :escL.c */
  static double *svi;	/*  :escL.c */
  static double *dsvr;	/*  :escL.c */
  static double *dsvi;	/*  :escL.c */
  static double *aLr;	/*  :escL.c */
  static double *aLi;	/*  :escL.c */
  static double *daLr;	/*  :escL.c */
  static double *daLi;	/*  :escL.c */
  int ESInitStLSODE();	/*  :escL.c */
  int ESDeInitStLSODE();/*  :escL.c */
/*
   */
#ifdef Doc_ESReInitMHDStabLowN

\section{Skeleton of ESReInitMHDStabLowN()}
  \begin{verbatim}
    ESReInitMHDStabLowN(){
    }
  \end{verbatim}
\section{ESReInitMHDStabLowN()}
Representation of the fundamental solution
\bqbl
&&
\vgy
=
\sum^{M_2}_{j=M_1}A_i\vgy^j
,\quad
\vgy^j
=
\sum^{M_2}_{k=M_1}\gy^j_k e^{ik\gq-in\gz}
=
\sum^{M_2}_{k=M_1}(\gy^{rj}_k+i\gy^{ij}_k)e^{ik\gq-in\gz}
,\\&&
\vaY
=
\sum^{M_2}_{j=M_1}A_i\vaY^j
,\quad
\vaY^j
=
\sum^{M_2}_{k=M_1}Y^j_k e^{ik\gq-in\gz}
=
\sum^{M_2}_{k=M_1}(Y^{rj}_k+iY^{ij}_k)e^{ik\gq-in\gz}
.\eqbl

#endif
}
int ESDeInitMHDStabLowN()
{
  static double *gaar;	/*  :escL.c */
  static int *ind;	/*  :escL.c */
  static double *gyr;	/*  :escL.c */
  static double **wAr;	/*  :escL.c */
  static double *Ar;	/*  :escL.c */
  int ESDeInitStLSODE();/*  :escL.c */
/*
   */
#ifdef Doc_ESDeInitMHDStabLowN

\section{Skeleton of ESDeInitMHDStabLowN()}
  \begin{verbatim}
    ESDeInitMHDStabLowN(){
    }
  \end{verbatim}
\section{ESDeInitMHDStabLowN()}

#endif
}
int ESInitStFundSolution(Opt,x)
  int Opt;	/*  */
  double x;	/*  */
{
  extern double *ESg22c;/* undefined */
  extern int ESNa1;	/* undefined */
  extern double *ESg22s;/* undefined */
  extern double *ESsq;	/* undefined */
  extern double *ESLc;	/* undefined */
  extern double *ESLc1;	/* undefined */
  extern double *ESLs1;	/* undefined */
  double x;		/*  .ESInitStFundSolution():escL.c */
  static int M1;	/*                         :escL.c */
  static int Mp1;	/*                         :escL.c */
  static double *gyr;	/*                         :escL.c */
  static double *gyi;	/*                         :escL.c */
  static double *aYr;	/*                         :escL.c */
  static double *aYi;	/*                         :escL.c */
  static int M2;	/*                         :escL.c */
  static double R0;	/*                         :escL.c */
  static double reltol;	/*                         :escL.c */
  static double *vatol;	/*                         :escL.c */
  static int MMp1;	/*                         :escL.c */
  static double *yh;	/*                         :escL.c */
  static int neq;	/*                         :escL.c */
  static double *rwork;	/*                         :escL.c */
  static int *iwork;	/*                         :escL.c */
  static int lrw;	/*                         :escL.c */
  static int liw;	/*                         :escL.c */
/*
   */
#ifdef Doc_ESInitStFundSolution

\section{Skeleton of ESInitStFundSolution()}
  \begin{verbatim}
  ESInitStFundSolution(){
    if(M1 <=0){
      for(m=M1; m <= |M1|; m++){
        Asymptotic solutions;
        Initialization of rwork and atol;
      }
    }
    else{
      m=M1;
      Asymptotic solutions;
      Initialization of rwork and atol;
    }
    for(m=|M1|+1; m <= M2; m++){
      Asymptotic solutions;
      Initialization of rwork and atol;
    }
    if(Opt == 1){
      Getting metric coefficients;
      for(m=M1; m <= M2; m++){
        Regular solution: dgy, dY -> gy -> Y;
      }
    }
  }
  \end{verbatim}

\section{ESInitStFundSolution()}
\Cline{ESInitStFundSolution()} solves the Laplace equation near the
origin of the coordinate system.

\subsection{Solution near the origin}
Near the origin
\bqbl
&&
\gj'_a
-\tgh'_\gq
=
\gd'_\gt\gy'_a
-\gd'_a\gy'_\gq
,\quad
\gy^j
\propto
a^j
,\quad
\gj^j
\propto
a^{j+1}
,\quad
\tgh_\til
\propto
a^j
,\quad
\tgh_0
\propto
a^{j-1}
,\\&&
\gj'_a
=
(\gd'_\gt\gy'_a-\gd'_a\gy'_\gq)_{0\cup}
=
-(j+1)q\R{L'^c_1+iL'^s_1}{L_0}a\gy^j_1e^{-in\gz}
-(j-1)q\R{L'^c_1-iL'^s_1}{L_0}a\gy^j_{-1}e^{-in\gz}
,\\&&
\gj
=
-q\R{L'^c_1+iL'^s_1}{L_0}a\gy^j_1e^{-in\gz}
-q\R{L'^c_1-iL'^s_1}{L_0}a\gy^j_{-1}e^{-in\gz}
,\quad
\tgh'_\gq
=
-(\gd'_\gt\gy'_a-\gd'_a\gy'_\gq)_{\til\cup}
\eqbl
and the energy functional can be reduced to
\bqbl
W
=
\r{8\gp}&&\int\left\{
\R{g_{\gr\gr}}{\q{g}}\gy'^2_\gq
-2\R{g_{\gr\gt}}{\q{g}}(\gy'_a-\tgh'_{0,\gz})\gy'_\gq
+\R{g_{\gt\gt}}{\q{g}}(\gy'_a-\tgh'_{0,\gz})^2
\right\}da d\gq d\gz
.\eqbl
{\bf We consider $\tgh'_{0,\gz}$ as $-\gy'_{0,a}$}.
Euler equation for $\gy$
\bqbl
&&
\left[
  \R{g_{\gt\gt}}{\q{g}}\bgy'_a
 -\R{g_{\gr\gt}}{\q{g}}\bgy'_\gq
 \right]'_a
+\left[
  \R{g_{\gr\gr}}{\q{g}}\bgy'_\gq
 -\R{g_{\gr\gt}}{\q{g}}\bgy'_a
 \right]'_\gq
=
0
,\quad
\v{\bgy}'
=
\vgy'-\tgh'_{0,\gz}
\eqbl
in the matrix form can be written as
\bqbl
&&
\maK^\dagger a\vgy'
-i\maG^\dagger_{a\gt}\maM\vgy
=
\vbY
,\\&&
a\vbY'
=
\maM\maG^\dagger_{aa}\maM\vgy
+i\maM\maG^\dagger_{a\gt}a\vgy'
,\eqbl
where
\bqbl
&&
K
=
K_0
+2K^c_2\cos2\gt
+2K^s_2\sin2\gt
=
K_0
+(K^c_2-iK^s_2)e^{2i\gt}
+(K^c_2+iK^s_2)e^{-2i\gt}
,\\&&
iG_{a\gt}
=
2iK^c_2\sin2\gt
-2iK^s_2\cos2\gt
=
(K^c_2-iK^s_2)e^{2i\gt}
-(K^c_2+iK^s_2)e^{-2i\gt}
,\\&&
aG_{aa}
=
K_0
-2K^c_2\cos2\gt
-2K^s_2\sin2\gt
=
K_0
-(K^c_2-iK^s_2)e^{2i\gt}
-(K^c_2+iK^s_2)e^{2i\gt}
.\eqbl
It can be reduced to tridiagonal equations
\bqbl
&&
A_k
\equiv
(j^2-k^2)K_0
,\quad
B_k
\equiv
(j+k)(j+k+2)(K^r-iK^i)
,\\&&
C_k
\equiv
(j-k)(j-k+2)(K^r+iK^i)
,\\&&
 B_k\gy^j_{k+2}
+A_k\gy^j_k
+C_k\gy^j_{k-2}
=
0
.\eqbl
Here, $K^r$, $K^i$ are defined as
\bqbl
&&
K^r
\equiv
K^c_2
,\quad
K^i
\equiv
-K^s_2
,\\&&
G_{\gt\gt}
=
aK_0
+2aK^c_2\cos2\gt
+2aK^s_2\sin2\gt
,\\&&
G_{a\gt}
=
-2K^s_2\cos2\gt
+2K^c_2\sin2\gt
,\\&&
aG_{aa}
=
K_0
-2K^c_2\cos2\gt
-2K^s_2\sin2\gt
.\eqbl
Boundary conditions for the homogeneous solution
\bqbl
&&
\gy^j_j
=
1
,\quad
\gy^j_{J}
=
0
,\quad
J
=
\max{(M_1,-j)}
.\eqbl
Decomposition and backsubstitution loops for homoheneous solution
\bqbl
&&
\gy^j_k
=
V_k\gy^j_{k-2}
+U_k
,\quad
V_j
=
0
,\quad
U_j
=
1
,\\&&
V_k
=
-{C_k\over A_k+B_kV_{k+2}}
,\\&&
U_k
=
{-B_kU_{k+2}\over A_k+B_kV_{k+2}}
.\eqbl
Complimentary vector
\bqbl
&&
\vbY
=
\maK^\dagger a\vgy'
-i\maG^\dagger_{a\gt}\maM\vgy
,\quad
\vbY^j
=
j\maK^\dagger\vgy^j
-i\maG^\dagger_{a\gt}\maM\vgy^j
,\\&&
\vbY^j
=
j(K_0+K_2e^{2i\gt}+K^*_2e^{-2i\gt})\vgy^j
-(K_2e^{2i\gt}-K^*_2e^{-2i\gt})\maM\vgy^j
,\\&&
Y^j_k
=
jK_0\gy^j_k
+(j+k+2)K^*_2\gy^j_{k+2}
+(j-k+2)K_2\gy^j_{k-2}
.\eqbl

\subsection{Initial conditions for the smooth start}
Using previous asymptotic solution as a basis for derivatives 
\bqbl
&&
a\vgy'
=
|j|\vgy
,\quad
a\vaY'
=
|j|\vaY
,\eqbl
the initial conditions are determined by 3 steps. Equation
\bqbl
&&
\maM a\maG^\dag_{aa}\maM\vgy
=
a\vaY'
-\maM i\maG\dag_{a\gt}a\vgy'
,\eqbl
with a given $a\vgy',a\vaY'$ specifies the oscillating part of
$\vgy$. Then the equation
\bqbl
&&
Y_0
=
K_0a \gy'_0
+\sum_{k=1}(K^*_ka\gy'_k+K_ka\gy'_{-k})
-i\sum_{k=1}k(G^*_{a\gt,k}\gy_k-G_{a\gt,k}\gy'_{-k})
=
0
\eqbl
specifies $\gy_0$ and finally
\bqbl
&&
\vaY
=
\maK a\vgy'
-i\maG_{a\gt}\maM\vgy
\eqbl
determines $\vaY$.

#endif
}
void st2DVrMHD(n,x,Y,dY)
  int *n;	/*  */
  double *x;	/*  */
  double *Y;	/*  */
  double *dY;	/*  */
{
  Undef ESSetSplA();
  Undef splRA();
  Undef ESSetSplDCr();
  Undef splRDCr();
  Undef ESSetSplDPr();
  Undef splRDPr();
  Undef CholDeComp();
  Undef CholBksbComp();
  extern double *ESg11c;	/* undefined */
  extern double *ESg11c2;	/* undefined */
  extern double *ESg12c;	/* undefined */
  extern double *ESg12c2;	/* undefined */
  extern double *ESg22c;	/* undefined */
  extern double *ESg22c2;	/* undefined */
  extern double *ESGzzc;	/* undefined */
  extern double *ESGzzc2;	/* undefined */
  extern double *ESLc;		/* undefined */
  extern double *ESLc2;		/* undefined */
  extern double *ESVc;		/* undefined */
  extern double *ESVc2;		/* undefined */
  extern int ES2Mp1;		/* undefined */
  extern int ESNa1;		/* undefined */
  extern double *ESg11s;	/* undefined */
  extern double *ESg11s2;	/* undefined */
  extern double *ESg12s;	/* undefined */
  extern double *ESg12s2;	/* undefined */
  extern double *ESg22s;	/* undefined */
  extern double *ESg22s2;	/* undefined */
  extern double *ESGzzs;	/* undefined */
  extern double *ESGzzs2;	/* undefined */
  extern double *ESLs;		/* undefined */
  extern double *ESLs2;		/* undefined */
  extern double *ESVs;		/* undefined */
  extern double *ESVs2;		/* undefined */
  extern double *ESFF;		/* undefined */
  extern double *ESFF2a;	/* undefined */
  extern double cr2;		/* undefined */
  extern double *ESaT;		/* undefined */
  extern double *ESaT2a;	/* undefined */
  extern int ESEqSolvInCr;	/* undefined */
  extern double *ESgm;		/* undefined */
  extern double *ESgm2a;	/* undefined */
  extern int ESEqSolvInPr;	/* undefined */
  extern double *ESPs;		/* undefined */
  extern double *ESPs2a;	/* undefined */
  double *x;		/*  .st2DVrMHD():escL.c */
  double *Y;		/*  .st2DVrMHD():escL.c */
  double *dY;		/*  .st2DVrMHD():escL.c */
  static double *gaar;	/*              :escL.c */
  static double *gaai;	/*              :escL.c */
  static double *gaqr;	/*              :escL.c */
  static double *gaqi;	/*              :escL.c */
  static double *gqqr;	/*              :escL.c */
  static double *gqqi;	/*              :escL.c */
  static double *gzzr;	/*              :escL.c */
  static double *gzzi;	/*              :escL.c */
  static double *aLr;	/*              :escL.c */
  static double *daLr;	/*              :escL.c */
  static double *aLi;	/*              :escL.c */
  static double *daLi;	/*              :escL.c */
  static double *svr;	/*              :escL.c */
  static double *dsvr;	/*              :escL.c */
  static double *svi;	/*              :escL.c */
  static double *dsvi;	/*              :escL.c */
  static int M1;	/*              :escL.c */
  static int Mp1;	/*              :escL.c */
  static double *Tr;	/*              :escL.c */
  static int Mres;	/*              :escL.c */
  static double *gmRes;	/*              :escL.c */
  static int kRes;	/*              :escL.c */
  static int N;		/*              :escL.c */
  static double rR0;	/*              :escL.c */
  static double R0;	/*              :escL.c */
  static double **wAr;	/*              :escL.c */
  static double **wAi;	/*              :escL.c */
  static double **wKr;	/*              :escL.c */
  static double **wKi;	/*              :escL.c */
  static double **wFr;	/*              :escL.c */
  static double **wFi;	/*              :escL.c */
  static double **wCr;	/*              :escL.c */
  static double **wCi;	/*              :escL.c */
  static double *Ar;	/*              :escL.c */
  static double *Ai;	/*              :escL.c */
  static int FlStChol;	/*              :escL.c */
  static double **wDr;	/*              :escL.c */
  static double **wDi;	/*              :escL.c */
  static double **wRr;	/*              :escL.c */
  static double **wRi;	/*              :escL.c */
  static double *X1r;	/*              :escL.c */
  static double *X1i;	/*              :escL.c */
  static double *Br;	/*              :escL.c */
  static double *Bi;	/*              :escL.c */
  static double **wBr;	/*              :escL.c */
  static double **wBi;	/*              :escL.c */
  static double **wGr;	/*              :escL.c */
  static double **wGi;	/*              :escL.c */
  static double **wEr;	/*              :escL.c */
  static double **wEi;	/*              :escL.c */
  static double **wVNr;	/*              :escL.c */
  static double **wVNi;	/*              :escL.c */
  static double **wVSr;	/*              :escL.c */
  static double **wVSi;	/*              :escL.c */
  static double *Fr;	/*              :escL.c */
  static double *Fi;	/*              :escL.c */
  static double **wGNr;	/*              :escL.c */
  static double **wGNi;	/*              :escL.c */
  static double **wGSr;	/*              :escL.c */
  static double **wGSi;	/*              :escL.c */
  static int MMp1;	/*              :escL.c */
  static double *Kr;	/*              :escL.c */
  static double *Ki;	/*              :escL.c */
/*
   */
#ifdef Doc_st2DVrMHD
\section{Skeleton of st2DVrMHD()}
  \begin{verbatim}
    st2DVrMHD(){
    }
  \end{verbatim}
\section{st2DVrMHD()}

\title{\bf void st2DVrMHD()}
\author{Leonid E. Zakharov, (\c{zakharov@pppl.gov})\\
{\em Princeton University, PPPL MS-27,}\\
{\em Forrestal Campus P.O.Box 451, Princeton NJ 08543} \\
(Started on June 10, 2000)}
\maketitle

\begin{abstract}
The routine \Cline{st2DVrMHD()} calculates the left hand side of the
following set of first order equations
\bqbl
&&
\vgy'
=
\maF^{-1}(\vaY-\maK\vgy)
,\quad
\vaY'
=
\maK^\dagger\vgy'
+\maG\vgy
,\quad
\vaY
\equiv
\maF\vgy'+\maK\vgy
.\eqbl
It solves linear system of equations for $\vgy'$ by using Cholesky
decomposition for Hermitian matrices 
\bqbl
&&
\maF\vgy'
=
\sum^{m\leq M_2}_{m=M_1}
 \left(\sum^{m'\leq M_2}_{m'=M_1}F_{m'-m}\gy'_{m'}\right)e^{im\gq}
,\quad
\maF
\equiv
\msf\msf^\dagger
,\quad
\msf_{mm'}|_{m < m'}=0
,\quad
\maF^{-1}
=
\msf^{-1\dagger}\msf^{-1}
,\eqbl 
%'
where $\msf$ is the low-left triagonal matrix. \Cline{st2DVrMHD()} is
used as an input routine for \c{LSODE} solver. 
\end{abstract}
\tableofcontents
\section{Skeleton of st2DVrMHD()}
  \begin{verbatim}
    st2DVrMHD(){
      Getting metric coefficients;
      Getting 1D profiles;
      Calculation of $\maV$, $\msz_\gq$ and $\msz_a$;
      Elimination of $\vgl${
        Calculation of $\msa$ in $\maA=\msa\msa^\dagger${
          Calculation of $\maG_{\gz\gz}$, $\maS_1$, $\maG_{\gq\gq}$;
          Calculation of $\maU_2=\maG_{\gz\gz}\maS_1$;
          Calculation of $\maA$;
        }
        Calculation of $\maR${
          $\maU_1=\msa^{-1}\maG_{\gq\gq}$;
          Calculations of $\maR_1$ and $\maS$;
          Decomposition of $\maS=\mss\mss^\dagger$;
          Product $\maR=\maS^{-1}\maR_1\maS^{-1}$;
        }
      }
      Calculation of basic matrix combinations{
        Calculation of $\maZ_\gq$, $\msz_a\maM$, $n\maU_1\maI_{00}$;
        Calculation of $\maB_0$ and $\maC_0$;
        Calculation of $\maU_0$ and $\maV_0$;
        Calculation of $\maC^n_1$ and $\maC^s_1$;
        Calculation of $\maV^n_1$ and $\maV^s_1$;
        Calculation of $\maW$;
      }
      Calculation of matrix $\maF=\msf\msf^\dagger${
        Calculation of $\maF$;
      }
      Calculation of $\maK${
        Calculation of $\maK^n$ and  $\maK^s$;
      }
      Calculation of $\maG${
        Calculation of $\maR\msz_a\maM$;
        Calculation of $\maG^n$ and $\maG^s$;
        Calculation of $\maH$;
      }
      Calculation of $\vgy'$ and $\vaY'${
        Calculation of $\maK$ and $\maG$;
        for(j=0; j < Mp1; j++){
          Calculation of $\vgy'$;
          Calculation of $\vaY'$;
        }
      }
    }
  \end{verbatim}

\section{Getting metric coefficients}
Relationships between equilibrium (splined) $\baG^E_{ik}$ and stability 
$G_{ik}$ metric coefficients
\bqbl
&&
G_{aa}
=
\R{\baG^{*E}_{\gr\gr}}{\gr}
,\quad
G_{a\gq}
=
-\baG^{*E}_{\gr\gt}
,\quad
G_{\gq\gq}
=
\gr\baG^{*E}_{\gt\gt}
,\quad
G_{\gz\gz}
=
\R{\baG^{*E}_{\gf\gf}}{\gr}
,\quad
V
\equiv
\R{(rD)^*}{L_0\baF}
=
\R{R^2_0(\baV^*+\baL^*)}{\baF \baL_0}
,\\&&
z_\gq
\equiv
\R{\baL^*_\til}{\gm\baL_0}
,\quad
z_a
\equiv
-i\left(\int\R{\baL^*_\til}{\gm\baL_0}d\gt\right)'_a
.\eqbl

\section{Getting 1D profiles}
\section{Calculation of $\maV$, $\msz_\gq$ and $\msz_a$}
\bqbl
&&
V
=
\R{R^2_0(\baV^*+\baL^*)}{\baL_0\baF}
,\quad
V'_a
=
\R{R^2_0(\baV'^*_a+\baL'^*_a)}{\baL_0\baF}
+V\left(-\R{\baL'_0}{\baL_0}-\R{\baF'}{\baF}\right)
,\\&&
z_\gq
\equiv
\sum_{k\neq0}\R{\baL^*_k}{\gm\baL_0}e^{ik\gq}
,\quad
z_a
\equiv
\sum_{k\neq0}\left[\R{\baL'^*_k}{k\gm\baL_0}
 +\R{\baL^*_k}{k\gm\baL_0}\left(-\R{\gm'}{\gm}-\R{\baL'_0}{\baL_0}\right)
 \right]e^{ik\gq}
.\eqbl

\section{Elimination of $\vgl$}
Product of band matrices
\bqbl
&&
Y_{m''}
=
\sum^{\leq M_2}_{m'=M_1}F_{m''-m'}X_{m'}
,\quad
Z_m
=
\sum^{\leq M_2}_{m''=M_1}G_{m-m''}Y_{m''}
=
\sum^{\leq M_2}_{m''=M_1}G_{m-m''}\sum^{\leq M_2}_{m'=M_1}F_{m''-m'}X_{m'}
,\\&&
(GF)^{mm'}
=
\sum^{\leq M_2}_{m''=M_1}G_{m-m''}F_{m''-m'}
.\eqbl

\subsection{Calculation of $\msa$ in $\maA=\msa\msa^\dagger$}
Matrix $\maA$
\bqbl
&&
\maS_1
\equiv
\msm+n\msz_\gq
,\quad
\maA
\equiv
\maS_1\maG_{\gz\gz}\maS_1
+n^2\maG_{\gq\gq}
.\eqbl
It is represented in the Cholesky form
\bqbl
&&
\maA=\msa\msa^\dagger
,\quad
\maA^{-1}=\msa^{-1\dagger}\msa^{-1}
,\eqbl
where $\msa$ is a {\bf left-low} triangular matrix.

\subsubsection{Calculation of $\maG_{\gz\gz}$, $\maS_1$, $\maG_{\gq\gq}$}
\bqbl
&&
\b{\maF}
=
\maG_{\gq\gq}
.\eqbl

\subsubsection{Calculation of $\maU_2=\maG_{\gz\gz}\maS_1$}
\bqbl
&&
\maU_2
\equiv
\maG_{\gz\gz}\maS_1
.\eqbl

\subsubsection{Calculation of $\maA$}
\bqbl
&&
\maA
=
\maS^\dagger_1\maU_2+n^2\maG_{\gq\gq}
.\eqbl

\subsection{Calculation of $\maR$}
Matrix $\maR$ is defined as
\bqbl
\maR
\equiv&&
\maG_{\gz\gz}
-\maG_{\gz\gz}\maS_1\maA^{-1}\maS^\dagger_1\maG_{\gz\gz}
,\quad
\maS
\equiv
nq\maI_{00}
+\maS_1
,\quad
\maR^\dagger
=
\maR
,\quad
\maS^\dagger
=
\maS
.\eqbl
Matrix $\maR$ contains subtraction of large matrices and can be
calculated as 
\bqbl
\maR
=&&
\maS^{-1}\left(
  \maS\maG_{\gz\gz}\maS
  -\maS\maG_{\gz\gz}\maS_1\maA^{-1}\maS_1\maG_{\gz\gz}\maS
 \right)\maS^{-1}
\\
=&&
n^2q^2\maS^{-1}\maI_{00}\left(
  \maG_{\gz\gz}
 -\maG_{\gz\gz}\maS_1\maA^{-1}\maS_1\maG_{\gz\gz}
  \right)\maI_{00}\maS^{-1}
\\&&
+n^2\maS^{-1}\left(
  \maG_{\gq\gq}
 +nq\maI_{00}\maG_{\gz\gz}\maS_1\maA^{-1}\maG_{\gq\gq}
 +nq\maG_{\gq\gq}\maA^{-1}\maS_1\maG_{\gz\gz}\maI_{00}
 -n^2\maG_{\gq\gq}\maA^{-1}\maG_{\gq\gq}
 \right)\maS^{-1}
.\eqbl

\subsubsection{$\maU_1=\msa^{-1}\maG_{\gq\gq}$}
Using the temporary definitions
\bqbl
&&
\maU_1
\equiv
\msa^{-1}\maG_{\gq\gq}
,\quad
\vaX
\equiv
\msa^{-1}\maU^\dagger_2\maI_{00}
,\eqbl
it can be calculated as
\bqbl
&&
\maR
=
\maS^{-1}\maR_1\maS^{-1}
,\quad
\maR_1
\equiv
n^2\left[q^2\maI_{00}\left(
  \maG_{\gz\gz}
 -\vaX^\dagger\vaX
  \right)\maI_{00}
+\maG_{\gq\gq}
 +nq\vaX^\dagger\maU_1
 +nq\maU^\dagger_1\vaX
 -n^2\maU^\dagger_1\maU_1
 \right]
.\eqbl

Product with an inverse left-low triagonal matrix is calculated by the
algorithm
\bqbl
&&
\maU
\equiv
\msa^{-1}\maB
,\quad
\msa\maU
=
\maB
,\quad
U_{ik}
=
\r{a_{ii}}\left(B_{ik}-\sum^{j<i}_{j=0}a_{ij}U_{jk}\right)
.\eqbl

\subsubsection{Calculations of $\maR_1$ and $\maS$}
\bqbl
&&
\maR_1
\equiv
n^2\left[q^2\maI_{00}\left(
  \maG_{\gz\gz}
 -\vaX^\dagger\vaX
  \right)\maI_{00}
+\maG_{\gq\gq}
 +nq\vaX^\dagger\maU_1
 +nq\maU^\dagger_1\vaX
 -n^2\maU^\dagger_1\maU_1
 \right]
.\eqbl

\subsubsection{Decomposition of $\maS=\mss\mss^\dagger$}
Matrix $\maS$ first is represented in Cholesky form
\bqbl
&&
\maS
=
\mss\mss^\dagger
,\quad
\maS^{-1}
=
\mss^{-1,\dagger}\mss^{-1}
.\eqbl

\subsubsection{Product $\maR=\maS^{-1}\maR_1\maS^{-1}$}
This product is calculated as
\bqbl
&&
\maR
=
\maS^{-1}\maR_1\maS^{-1}
=
\mss^{-1,\dagger}\mss^{-1}\maR_1\mss^{-1,\dagger}\mss^{-1}
.\eqbl
Calculations of partial products
\bqbl
&&
\maU
\equiv
\maR_2
=
\mss^{-1}\maR_1
,\quad
U_{ik}
=
\r{s_{ii}}\left(R_{1,ik}-\sum^{j<i}_{j=0}s_{ij}U_{jk}\right)
,\\&&
\maU
\equiv
\maR_3
=
\mss^{-1,\dagger}\maR_2
,\quad
U_{ik}
=
\r{s_{ii}}\left(R_{2,ik}-\sum_{j>i}s^*_{ji}U_{jk}\right)
,\\&&
\maU
\equiv
\maR_4
=
\maR_3\mss^{-1,\dagger}
,\quad
U_{ik}
=
\r{s_{ii}}\left(R_{3,ik}-\sum^{j<k}_{j=0}U_{ij}s^*_{kj}\right)
,\\&&
\maU 
\equiv
\maR_5
=
\maR_4\mss^{-1}
,\quad
U_{ik}
=
\r{s_{ii}}\left(R_{4,ik}-\sum_{j>k}U_{ij}s_{jk}\right)
.\eqbl

\section{Calculation of basic matrix combinations}
The matrices in the Euler equation for $\vgy$ have representation
\bqbl
&&
\maF
=
\maI_{\til\til}\maG_{\gq\gq}\maI_{\til\til}
-\maB_1^\dagger\maA^{-1}\maB_1
-\maB_1^\dagger\maA^{-1}\maB_0
-\maB_0^\dagger\maA^{-1}\maB_1
+\maZ^\dagger_\gq\maR\maZ_\gq
,\\&&
\maK
=
\maE_1
-\maB_1^\dagger\maA^{-1}\maC_1
-\maB_1^\dagger\maA^{-1}\maC_0
-\maB_0^\dagger\maA^{-1}\maC_1
-\maZ^\dagger_\gq\maR\msz_a\maM
,\\&&
\maG
=
\maH_1
-\maC_1^\dagger\maA^{-1}\maC_1
-\maC_1^\dagger\maA^{-1}\maC_0
-\maC_0^\dagger\maA^{-1}\maC_1
+\maM\msz^\dagger_a\maR\msz_a\maM
,\eqbl
where matrices are defined as
\bqbl
&&
\maA^{-1}
\equiv
\msa^{-1,\dagger}\msa^{-1}
,\\&&
\maB_0
=
-\maS^\dagger_1\maG_{\gz\gz}\maZ_\gq
=
-\maU^\dagger_2\maZ_\gq
,\quad
\maB_1
=
-n\maG_{\gq\gq}\maI_{\til\til}
,\\&&
\maC_0
=
\maS^\dagger_1\maG_{\gz\gz}\msz_a\maM
=
\maU^\dagger_2\msz_a\maM
,\quad
\maC_1
=
\maC^n_1
+\maC^s_1\maT
,\quad
\maC^n_1
=
in\maG_{a\gq}\maM
-F_s\maM
,\quad
\maC^s_1
=
nP\maV
,\\&&
\maE_1
=
-\maI_{\til\til}i\maG_{a\gq}\maM
-\maI_{\til\til}P\maV_\til\maT
,\\&&
\maH_1
=
\maM\maG_{aa}\maM
+(P'V_0+F'_s)\mst
-nPV'_0\mst\maQ^{-1}
+P\maT(\gm'\maV_\til-\gm\maV'_\til)\maT
+[P(\gm'V_0-\gm V'_0)-F'_s\gm]^{00}
,\\&&
\maZ_\gq
\equiv
\msz_\gq-\maI_{00}
,\quad
\maM
\equiv
\msm+n\maI_{00}
,\quad
\maT
\equiv
\mst-\maI_{00}
,\quad
\mst
\equiv
\msm\maQ^{-1}
,\quad
\maQ
\equiv
\gm\msm-n\maI
.\eqbl
Following matrices enter in $\maF$, $\maK$, and $\maG$ 
\bqbl
&&
\maU_0
\equiv
\msa^{-1}\maB_0
,\quad
\maU_1
\equiv
\msa^{-1}\maG_{\gq\gq}
,\quad
\maV_0
\equiv
\msa^{-1}\maC_0
,\quad
\maV_1
=
\maV^n_1
+\maV^s_1\maT
\equiv
\msa^{-1}(\maC^n_1+\maC^s_1\maT)
,\quad
\maW
\equiv
\maR\maZ_\gq
.\eqbl

\subsection{Calculation of $\maZ_\gq$, $\msz_a\maM$, $n\maU_1\maI_{00}$}
\bqbl
&&
\maZ_\gq
=
\msz_\gq-\maI_{00}
.\eqbl
\subsection{Calculation of $\maB_0$ and $\maC_0$}
\bqbl
&&
\maB_0
=
-\maU^\dagger_2\maZ_\gq
,\quad
\maC_0
=
\maU^\dagger_2\msz_a\maM
.\eqbl
\subsection{Calculation of $\maU_0$ and $\maV_0$}
\bqbl
&&
\maU_0
\equiv
\msa^{-1}\maB_0
,\quad
\maV_0
\equiv
\msa^{-1}\maC_0
.\eqbl
\subsection{Calculation of $\maC^n_1$ and $\maC^s_1$}
\bqbl
&&
\maC_1
=
\maC^n_1
+\maC^s_1\maT
,\quad
\maC^n_1
=
in\maG_{a\gq}\maM
-F_s\maM
,\quad
\maC^s_1
=
nP\maV
.\eqbl

\subsection{Calculation of $\maV^n_1$ and $\maV^s_1$}
\bqbl
&&
\maV_1
=
\maV^n_1
+\maV^s_1\maT
,\quad
\maV^n_1
=
\msa^{-1}\maC^n_1
,\quad
\maV^s_1
=
\msa^{-1}\maC^s_1
.\eqbl

\subsection{Calculation of $\maW$}
\bqbl
&&
\maW
=
\maR\maZ_\gq
.\eqbl

With all definitions made, the matrices in Euler equation can be reduced to
\bqbl
&&
\maF
=
\maI_{\til\til}\maG_{\gq\gq}\maI_{\til\til}
-n^2\maI_{\til\til}\maU_1^\dagger\maU_1\maI_{\til\til}
+n\maI_{\til\til}\maU^\dagger_1\maU_0
+n\maU^\dagger_0\maU_1\maI_{\til\til}
+\maZ^\dagger_\gq\maW
,\\&&
\maK
=
\maK^n
+\maK^s\maT
,\\&&
\maK^n
=
-\maI_{\til\til}i\maG_{a\gq}\maM
+n\maI_{\til\til}\maU^\dagger_1\maV^n_1
+n\maI_{\til\til}\maU^\dagger_1\maV_0
-\maU^\dagger_0\maV^n_1
-\maW^\dagger\msz_a\maM
,\quad
\maK^s
=
-\maI_{\til\til}P\maV_\til
+n\maI_{\til\til}\maU^\dagger_1\maV^s_1
-\maU^\dagger_0\maV^s_1
,\\&&
\maG
=
\maG^n
+\maT\maH^\dagger
+\maH\maT
+\maT\maG^s\maT
+(P'V_0+F'_s)\mst
-nPV'_0\mst\maQ^{-1}
+[P(\gm'V_0-\gm V'_0)-F'_s\gm]^{00}
,\\&&
\maG^n
=
\maM(\maG_{aa}+\msz^\dagger_a\maR\msz_a)\maM
-{\maV^n}^\dagger_1\maV^n_1
-{\maV^n}^\dagger_1\maV_0
-\maV^\dagger_0\maV^n_1
,\\&&
\maH
=
-{\maV^n}^\dagger_1\maV^s_1
-\maV^\dagger_0\maV^s_1
,\\&&
\maG^s
=
P(\gm'\maV_\til-\gm\maV'_\til)
-{\maV^s}^\dagger_1\maV^s_1
.\eqbl

\section{Calculation of matrix $\maF=\msf\msf^\dagger$}
\subsection{Calculation of $\maF$}
\bqbl
&&
\maF
=
\maI_{\til\til}\maG_{\gq\gq}\maI_{\til\til}
-n^2\maI_{\til\til}\maU_1^\dagger\maU_1\maI_{\til\til}
+n\maI_{\til\til}\maU^\dagger_1\maU_0
+n\maU^\dagger_0\maU_1\maI_{\til\til}
+\maZ^\dagger_\gq\maW
.\eqbl

\section{Calculation of $\maK$}
\bqbl
&&
\maK^n
=
-\maI_{\til\til}i\maG_{a\gq}\maM
+n\maI_{\til\til}\maU^\dagger_1\maV^n_1
+n\maI_{\til\til}\maU^\dagger_1\maV_0
-\maU^\dagger_0\maV^n_1
-\maW^\dagger\msz_a\maM
,\quad
\maK^s
=
-\maI_{\til\til}P\maV_\til
+n\maI_{\til\til}\maU^\dagger_1\maV^s_1
-\maU^\dagger_0\maV^s_1
.\eqbl
\subsection{Calculation of $\maK^n$ and  $\maK^s$}
\bqbl
&&
\maK^n
=
-\maI_{\til\til}i\maG_{a\gq}\maM
+n\maI_{\til\til}\maU^\dagger_1(\maV^n_1+\maV_0)
-\maU^\dagger_0\maV^n_1
-\maW^\dagger\msz_a\maM
,\quad
\maK^s
=
-\maI_{\til\til}P\maV_\til
+(n\maI_{\til\til}\maU^\dagger_1-\maU^\dagger_0)\maV^s_1
.\eqbl

\section{Calculation of $\maG$}
\bqbl
&&
\maG
=
\maG^n
+\maT\maH^\dagger
+\maH\maT
+\maT\maG^s\maT
+(P'V_0+F'_s)\mst
-nPV'_0\mst\maQ^{-1}
+[P(\gm'V_0-\gm V'_0)-F'_s\gm]^{00}
,\\&&
\maG^n
=
\maM\maG_{aa}\maM
+\maM\msz^\dagger_a\maR\msz_a\maM
-{\maV^n}^\dagger_1\maV^n_1
-{\maV^n}^\dagger_1\maV_0
-\maV^\dagger_0\maV^n_1
,\\&&
\maH
=
-{\maV^n}^\dagger_1\maV^s_1
-\maV^\dagger_0\maV^s_1
,\\&&
\maG^s
=
P(\gm'\maV_\til-\gm\maV'_\til)
-{\maV^s}^\dagger_1\maV^s_1
.\eqbl

\subsection{Calculation of $\maR\msz_a\maM$}
\bqbl
&&
\b{\maA}
=
\maR\msz_a\maM
.\eqbl

\subsection{Calculation of $\maG^n$ and $\maG^s$}
\bqbl
&&
\maG
=
\maG^n
+\maT\maH^\dagger
+\maH\maT
+\maT\maG^s\maT
+(P'V_0+F'_s)\mst
-nPV'_0\mst\maQ^{-1}
+[P(\gm'V_0-\gm V'_0)-F'_s\gm]^{00}
,\\&&
\maG^n
=
\maM\maG_{aa}\maM
+\maM\msz^\dagger_a\maR\msz_a\maM
-\maV^\dagger_0\maV^n_1
-{\maV^n}^\dagger_1(\maV^n_1+\maV_0)
,\\&&
\maG^s
=
P(\gm'\maV_\til-\gm\maV'_\til)
-{\maV^s}^\dagger_1\maV^s_1
.\eqbl

\subsection{Calculation of $\maH$}
\bqbl
&&
\maH
=
-({\maV^n}^\dagger_1+\maV^\dagger_0)\maV^s_1
.\eqbl

\section{Calculation of $\vgy'$ and $\vaY'$}
Derivatives $\vgy'$ of the fundamental solution are calculated as
\bqbl
&&
\vgy'
=
\maF^{-1}(\vaY-\maK\vgy)
.\eqbl

\subsection{Calculation of $\maK$ and $\maG$}
\bqbl
&&
\maK
=
\maK^n
+\maK^s\maT
,\\&&
\maG
=
\maG^n
+\maT\maH^\dagger
+\maH\maT
+\maT\maG^s\maT
+(P'V_0+F'_s)\mst
-nPV'_0\mst\maQ^{-1}
+[P(\gm'V_0-\gm V'_0)-F'_s\gm]^{00}
.\eqbl
\subsection{Calculation of $\vgy'$}
Derivatives $\vgy'$ of the fundamental solution are calculated as
\bqbl
&&
\vgy'
=
\maF^{-1}(\vaY-\maK\vgy)
,\quad
\vgy'
=
\msf^{-1,\dagger}\msf^{-1}\vsx
,\quad
\vsx
\equiv
\vaY-\maK\vgy
.\eqbl
\subsection{Calculation of $\vaY'$}
Derivatives of complimentary vector $\vaY'$ are calculated as 
\bqbl
&&
\vaY'
=
\maK^\dagger\vgy'
+\maG\vgy
.\eqbl

#endif
}
int ESResAsymptotics()
{
  Undef ESSetSplA();
  Undef splRA();
  Undef ESGaac;
  Undef ESGaac2;
  Undef ESGaqc;
  Undef ESGaqc2;
  Undef ESGqqc;
  Undef ESGqqc2;
  Undef gazr;
  Undef ESGazc;
  Undef ESGazc2;
  Undef gazi;
  Undef gqzr;
  Undef ESGqzc;
  Undef ESGqzc2;
  Undef gqzi;
  Undef ESsVc;
  Undef ESsVc2;
  Undef ESGaas;
  Undef ESGaas2;
  Undef ESGaqs;
  Undef ESGaqs2;
  Undef ESGqqs;
  Undef ESGqqs2;
  Undef ESGazs;
  Undef ESGazs2;
  Undef ESGqzs;
  Undef ESGqzs2;
  Undef ESsVs;
  Undef ESsVs2;
  Undef ESSetSplDPr();
  Undef splRDPr();
  Undef CholDeComp();
  Undef CholBksbComp();
  extern double *ESGzzc;	/* undefined */
  extern double *ESGzzc2;	/* undefined */
  extern int ES2Mp1;		/* undefined */
  extern int ESNa1;		/* undefined */
  extern double *ESGzzs;	/* undefined */
  extern double *ESGzzs2;	/* undefined */
  extern int ESEqSolvInPr;	/* undefined */
  extern double *ESPs;		/* undefined */
  extern double *ESPs2a;	/* undefined */
  extern double cr2;		/* undefined */
  static double *aRes;	/*  :escL.c */
  static int kRes;	/*  :escL.c */
  static double *gaar;	/*  :escL.c */
  static double *gaai;	/*  :escL.c */
  static double *gaqr;	/*  :escL.c */
  static double *gaqi;	/*  :escL.c */
  static double *gqqr;	/*  :escL.c */
  static double *gqqi;	/*  :escL.c */
  static double *gzzr;	/*  :escL.c */
  static double *gzzi;	/*  :escL.c */
  static double *svr;	/*  :escL.c */
  static double *dsvr;	/*  :escL.c */
  static double *svi;	/*  :escL.c */
  static double *dsvi;	/*  :escL.c */
  static double *gmRes;	/*  :escL.c */
  static double *dgmRes;/*  :escL.c */
  static int Mp1;	/*  :escL.c */
  static double *Tr;	/*  :escL.c */
  static int Mres;	/*  :escL.c */
  static int M1;	/*  :escL.c */
  static double rR0;	/*  :escL.c */
  static double *Ar;	/*  :escL.c */
  static int N;		/*  :escL.c */
  static double *Ai;	/*  :escL.c */
  static int FlStChol;	/*  :escL.c */
  static double *Br;	/*  :escL.c */
  static double *Bi;	/*  :escL.c */
  static double *Fr;	/*  :escL.c */
  static double *Fi;	/*  :escL.c */
  static double *Cr;	/*  :escL.c */
  static double *Ci;	/*  :escL.c */
  static double *Kr;	/*  :escL.c */
  static double *Ki;	/*  :escL.c */
  static double *Gr;	/*  :escL.c */
  static double *Gi;	/*  :escL.c */
  static double *X1r;	/*  :escL.c */
  static double *X1i;	/*  :escL.c */
  static double *X2r;	/*  :escL.c */
  static double *X2i;	/*  :escL.c */
  static int *mRes;	/*  :escL.c */
  static double PM1;	/*  :escL.c */
  static double PM2;	/*  :escL.c */
/*
   */
#ifdef Doc_ESResAsymptotics
%----------
\title{\bf void ESResAsymptotics()}
\author{Leonid E. Zakharov, (\c{zakharov@pppl.gov})\\
{\em Princeton University, PPPL MS-27,}\\
{\em Forrestal Campus P.O.Box 451, Princeton NJ 08543} \\
(Started on June 10, 2000)}
\maketitle

\begin{abstract}
Routine \Cline{ESResAsymptotics()} determines the asymptotic behaviour near 
the resonant point. 
\end{abstract}
\tableofcontents

\section{Skeleton of ESResAsymptotics()}
  \begin{verbatim}
    ESResAsymptotics(){
    }
  \end{verbatim}
\section{ESResAsymptotics()}
Near the resonant point, the matrices in MHD equations have the
asymptotic form

\bqbl
&&
\maK
=
\maK^s\maT
,\\&&
\maG
=
\maT\maH^\dagger
+\maH\maT
+\maT\maG^s\maT
+(P'V_0+F'_s)\mst
-nPV'_0\mst\maQ^{-1}
+[P(\gm'V_0-\gm V'_0)-F'_s\gm]^{00}
.\eqbl

Derivatives $\vgy'$ of the fundamental solution are calculated as
\bqbl
&&
\vgy'
=
\maF^{-1}(\vaY-\maK^s\maT\vgy)
,\quad
\vgy'
=
\msf^{-1,\dagger}\msf^{-1}\vsx
,\quad
\vsx
\equiv
\vaY-\maK^s\maT\vgy
.\eqbl
Derivatives of complimentary vector $\vaY'$ are calculated as 
\bqbl
&&
\vaY'
=
\maT{\maK^s}^\dagger\vgy'
+\maG\vgy
.\eqbl
or
\bqbl
&&
\maC
\equiv
\b{\maC}\maT^{m/n}
=
nP\maV\maT
,\quad
\left(\maT^{m/n}\right)_{ij}
=
\R{\gd_{ij}\gd_{jm}}{\gm'x}
,\\&&
\maK
\equiv
\b{\maK}\maT^{m/n}
=
\maE-\maB^\dagger\maA^{-1}\maC
=
-P(\maV_\til\maT)^{\til\til}
-nP\maB^\dagger\maA^{-1}\maV\maT^{m/n}
,\\&&
\maG
\equiv
\maT^{m/n}\b{\maG}\maT^{m/n}
=
\maH
-\maC^\dagger\maA^{-1}\maC
,\\&&
\maH
\equiv
\maT^{m/n}\b{\maH}\maT^{m/n}
=
P\maT(\gm'\maV_\til-\gm\maV'_\til)\maT
-nPv'_0\maT\maQ^{-1}
,\\&&
\maG
=
P\maT(\gm'\maV_\til-\gm\maV_\til)\maT
-nPv'_0\maT\maQ^{-1}
-n^2P^2\maT\maV^\dagger\maA^{-1}\maV\maT
\eqbl
and the Euler equations becomes singular
\bqbl
&&
\vgy'
=
\maF^{-1}(\vaY-\maK\vgy)
=
\maF^{-1}(\vaY-\b{\maK}\maT^{m/n}\vgy)
,\\&&
\vaY'
=
\maK^\dagger\vgy'
+\maG\vgy
=
\maT^{m/n}\b{\maK}^\dagger\vgy'
+\maT^{m/n}\b{\maG}\maT^{m/n}\vgy
.\eqbl
The resonant fundamental vector has the following asymptotics 
\bqbl
&&
\vgy
=
C^L|x|^{D^L}\vgy^L
+C^S|x|^{D^S}\vgy^S
,\quad
x^D
=
a-a_{m/n}
,\eqbl
and $D^L$, $D^S$ are the Mercier power corresponding to large and small
solutions. 

It is seen from the Euler equations that in $\vaY$ only the resonant
harmonic $Y_m$ is essential, $Y_{m'\neq m}\propto xY_m$. 
\bqbl
&&
\vaY'
=
\maT^{m/n}\b{\maK}^\dagger\vgy'
+\maT^{m/n}\b{\maG}\maT^{m/n}\vgy
,\quad
Y_m
\propto
x^{D-1}
,\quad
\R{D-1}{x}\vaY
=
\R{D}{x}\maT^{m/n}\b{\maK}^\dagger\vgy
+\maT^{m/n}\b{\maG}\maT^{m/n}\vgy
.\eqbl
Numerically the resonant solution is determined by using algorithm of
the main stablity routine. Let us determine normalized resonant vector
$\vaI$, which have all components be zero except the resonant harmonic
\bqbl
&&
(\vaI)_{mm}
=
1
,\quad
(\vaI)_{m'\neq m}
=
0
,\eqbl
and define also
\bqbl
&&
\vaY
\equiv
\vaI\R{Y^R}{\gm'x}
,\quad
\maT^{m/n}
=
\R{\maI^{m/n}}{\gm' x}
,\quad
\vaX^1
\equiv
\maF^{-1}\vaI
,\quad
\vaX^2
\equiv
-\maF^{-1}\b{\maK}\vaI
.\eqbl
Then, the system of Euler equations near the resonance
\bqbl
&&
\vgy'
=
\maF^{-1}(\vaY-\b{\maK}\maT^{m/n}\vgy)
,\\&&
\vaY'
=
\maT^{m/n}\b{\maK}^\dagger\vgy'
+\maT^{m/n}\b{\maG}\maT^{m/n}\vgy
\eqbl
can be written in the form
\bqbl
&&
\gm'x\vgy'
=
\vaX^1Y^R
+\vaX^2\gy^R
,\\&&
\gm'(D-1)Y^R
=
 (\b{\maK}^\dagger\vaX^1)_mY^R
+(\b{\maK}^\dagger\vaX^2)_m\gy^R
+(\b{\maG})_{mm}\gy^R
\eqbl
or finally as
\bqbl
&&
\gm'D\gy^R
=
\vaX^1_mY^R
+\vaX^2_m\gy^R
,\\&&
\gm'(D-1)Y^R
=
-\vaX^{2*}_mY^R
+(\b{\maK}^\dagger\vaX^2)_m\gy^R
+(\b{\maG})_{mm}\gy^R
.\eqbl
From here, the $D$ can be determined as an eigenvalue
\bqbl
&&
[-\vaX^{2*}_m-\gm'(D-1)] Y^R
+(\b{\maK}^\dagger\vaX^2)_m\gy^R
+(\b{\maG})_{mm}\gy^R
=
0
,\quad
\vaX^1_mY^R
+[\vaX^2_m-\gm'D]\gy^R
=
0
,\\&&
\gm'^2D(D-1)+\gm'D(\vaX^{2*}_m-\vaX^2_m)
=
C
,\quad
C
\equiv
\vaX^1_m[(\b{\maK}^\dagger\vaX^2)_m+(\b{\maG})_{mm}]
+|\vaX^2|^2_m
-\gm'\vaX^2_m
,\\&&
D^S
=
\r{2}+\q{\R{1}{4}+\R{C}{\gm'^2}}
,\quad
D^L
=
\r{2}-\q{\R{1}{4}+\R{C}{\gm'^2}}
.\eqbl
Then, from
\bqbl
&&
\gm'D\vgy
=
\vaX^1Y^R
+\vaX^2\gy^R
,\quad
\gy^R
=
x^D
,\quad
\vaY
\equiv
\vaI\R{Y^R}{\gm'x}
\eqbl
$Y^R$ and components of $\vgy$ can be determined in terms of $\gy^R$.

\section{{\helvV The puzzle}}

In DCON notations the Euler equations (AHG,23) can be written as 
\bqbl
&&
\vgX'
=
-\maQ^{-1}\b{\maF}^{-1}\b{\maK}\vgX
+\maQ^{-1}\b{\maF}^{-1}\maQ^{-1}\vaY
,\\&&
\vaY'
=
\msg\vgX
+\b{\maK}^\dagger\b{\maF}^{-1}\maQ^{-1}\vaY
,\eqbl
where
\bqbl
&&
\vaY
\equiv
\maF\vgX'
+\maK\vgX
,\quad
\msg
\equiv
\b{\maG}
-\b{\maK}^\dagger\b{\maF}^{-1}\b{\maK}
.\eqbl
Near the resonant point, $m=nq$, the polinomial solution for $\vgX$
behaves like 
\bqbl
&&
(\vgX)_{k=m}
=
x^\gn\bgx_m
,\quad
(\vgX)_{k\neq m}
\propto
x^{\gn+1}
.\eqbl
From Eq.(AHG,21)
\bqbl
&&
\vaY'
=
\b{\maK}^\dagger\maQ\vgX'
+\maG\vgX
\eqbl
it is seen that $\vaY$  behaves uniformly like
\bqbl
&&
(\vaY)_{k=m}
=
x^{\gn+1}\baY_m
,\quad
(\vaY)_{k\neq m}
\propto
x^{\gn+1}
.\eqbl

Now it is seen that in Euler equations written in the form (1.1) (or
AHG,23), only resonant components of $\vgX$ and $\vaY$ are essential for
determining the exponent $\gn$ 
\bqbl
&&
\gn \bgx_m
=
\R{1}{nq'}\left(\b{\maF}^{-1}\b{\maK}\right)_{mm}\bgx_m
+\R{1}{n^2q'^2}\left(\b{\maF}^{-1}\right)_{mm}\baY_m
,\\&&
(\gn+1)\baY_m
=
(\msg)_{mm}\bgx_m
-\R{1}{nq'}\left(\b{\maK}^\dagger\b{\maF}^{-1}\right)_{mm}\baY_m
.\eqbl
This system of equation can be written in the form
\bqbl
&&
\gn \bgx_m
=
a\bgx_m
+b\baY_m
,\\&&
(\gn+1)\baY_m
=
c\bgx_m
-a^*\baY_m
,\\&&
a
\equiv
\R{1}{nq'}\left(\b{\maF}^{-1}\b{\maK}\right)_{mm}
,\quad
b
\equiv
\R{1}{n^2q'^2}\left(\b{\maF}^{-1}\right)_{mm}
,\quad
c
\equiv
(\msg)_{mm}
\eqbl
and gives a quadratic equation for $\gn$
\bqbl
&&
(a-\gn)(-a^*-\gn-1)-bc
=
0
,\eqbl
or
\bqbl
&&
\gn^2
+\gn(a^*-a+1)
-a(a^*+1)
-bc
=
0
.\eqbl
The puzzle is that the presence of $a$ in this equation makes it
different from standard Mercier form. The inflamatory thing is that it
suggests an imaginary part in the roots if $Im(a)\neq0$.

The question is if it is obvious that 
\bqbl
&&
Im(a)
=
Im\left(\R{1}{nq'}\left(\b{\maF}^{-1}\b{\maK}\right)_{mm}\right)
=
0
.\eqbl
Numerically, I found that $Im(a) \ll1$ but is still present in
configurations without up-down symmetry. 
%----------

#endif
}
int ESStInitSmallResSolution(n,xcur)
  int n;	/*  */
  double *xcur;	/*  */
{
  Undef pow();
  double *xcur;		/*  .ESStInitSmallResSolution():escL.c */
  int n;		/*  .ESStInitSmallResSolution():escL.c */
  static double *aRes;	/*                             :escL.c */
  static int kRes;	/*                             :escL.c */
  static int Mres;	/*                             :escL.c */
  static int M1;	/*                             :escL.c */
  static int Mp1;	/*                             :escL.c */
  static double *gyr;	/*                             :escL.c */
  static double *gyi;	/*                             :escL.c */
  static double *aYr;	/*                             :escL.c */
  static double *aYi;	/*                             :escL.c */
  static double *dgmRes;/*                             :escL.c */
  static double PM1;	/*                             :escL.c */
  static double *X2r;	/*                             :escL.c */
  static double *X1r;	/*                             :escL.c */
  static double *X2i;	/*                             :escL.c */
  static double *X1i;	/*                             :escL.c */
  static double *yh;	/*                             :escL.c */
  static int neq;	/*                             :escL.c */
  static int MMp1;	/*                             :escL.c */
/*
   */
#ifdef Doc_ESStInitSmallResSolution

\section{Skeleton of ESStInitSmallResSolution()}
  \begin{verbatim}
    ESStInitSmallResSolution(){
    }
  \end{verbatim}
\section{ESStInitSmallResSolution()}
#endif
}
int ESStSetVatol(x)
  double x;	/*  */
{
  double x;		/*  .ESStSetVatol():escL.c */
  static double reltol;	/*                 :escL.c */
  static int M1;	/*                 :escL.c */
  static int Mp1;	/*                 :escL.c */
  static double *vatol;	/*                 :escL.c */
  static int MMp1;	/*                 :escL.c */
  static int M2;	/*                 :escL.c */
/*
   */
#ifdef Doc_ESStSetVatol

\section{Skeleton of ESStSetVatol()}
  \begin{verbatim}
    ESStSetVatol(){
    }
  \end{verbatim}
\section{ESStSetVatol()}
#endif
}
int ESMHDStCheckLowN(nord,mc,x)
  int nord;	/*  */
  int mc;	/*  */
  double x;	/*  */
{
  Undef out();
  int mc;		/*  .ESMHDStCheckLowN():escL.c */
  int nord;		/*  .ESMHDStCheckLowN():escL.c */
  double x;		/*  .ESMHDStCheckLowN():escL.c */
  static int KRec;	/*                     :escL.c */
  static int M1;	/*                     :escL.c */
  static double *gyr;	/*                     :escL.c */
  static double *gyi;	/*                     :escL.c */
  static double *aYr;	/*                     :escL.c */
  static double *aYi;	/*                     :escL.c */
  static double *Ar;	/*                     :escL.c */
  static double *Ai;	/*                     :escL.c */
  static int Mp1;	/*                     :escL.c */
  static double *yh;	/*                     :escL.c */
  static int neq;	/*                     :escL.c */
  static int MMp1;	/*                     :escL.c */
  static int kCheck;	/*                     :escL.c */
  static double aYmr;	/*                     :escL.c */
  static double aYmi;	/*                     :escL.c */
  static double gymr;	/*                     :escL.c */
  static double gymi;	/*                     :escL.c */
  static double ESsgnY;	/*                     :escL.c */
  static double ESsgnX;	/*                     :escL.c */
  static double ESdet;	/*                     :escL.c */
/*
   */
#ifdef Doc_ESMHDStCheckLowN

\section{Skeleton of ESMHDStCheckLowN()}
  \begin{verbatim}
    ESMHDStCheckLowN(){
    }
  \end{verbatim}
\section{ESMHDStCheckLowN()}
The routine performs reshuffling the fundamental solution around the 
principal hamonic $m=m_c$ in order to eliminate the side harmonics in each 
independent vector
\bqbl
&&
\vgy^j \to \vgy^j
,\quad
\gy^j_{|m-m_c| > |j-j_c|}=0
.\eqbl
In addition it calculates the low-left triangular transformation matrix
\bqbl
&&
\vgy^j_{new} =\maA\vgy^j_{old}
\eqbl
and stores it in the matrix \Cline{Ar,Ai}.

Euler equations preserve the following combination
\bqbl
&&
(\vgy^\dagger_1\vaY_2
-\vaY^\dagger_1\vgy_2)'_a
=
0
\eqbl
of two arbitrary solutions. For the central harmonics after elimination
of side bands
\bqbl
&&
\vgy^\dagger_m\vaY_m
-\vaY^\dagger_m\vgy_m
=
0
\eqbl
the ratio
\bqbl
&&
\R{\gy^*_m}{aY^*_m}
=
\R{\gy_m}{Y_m}
\eqbl
is the real number. Crossing the zero with the same sign of $\vaY_1$
means instability of the given mode.

The routine checks the sign 
\bqbl
&&
\R{\gy_m}{Y_m}
.\eqbl

#endif
}
int ESMHDStShiftUpLowN()
{
  Undef ESSetSplA();
  Undef splRA();
  extern double *ESg22c;	/* undefined */
  extern double *ESg22c2;	/* undefined */
  extern int ES2Mp1;		/* undefined */
  extern int ESNa1;		/* undefined */
  extern double *ESg22s;	/* undefined */
  extern double *ESg22s2;	/* undefined */
  static double *rwork;	/*  :escL.c */
  static double *gqqr;	/*  :escL.c */
  static double *gqqi;	/*  :escL.c */
  static int M1;	/*  :escL.c */
  static int M2;	/*  :escL.c */
  static double *gyr;	/*  :escL.c */
  static double *gyi;	/*  :escL.c */
  static double *aYr;	/*  :escL.c */
  static double *aYi;	/*  :escL.c */
  static int Mp1;	/*  :escL.c */
  static double *vatol;	/*  :escL.c */
  static int MMp1;	/*  :escL.c */
  static double reltol;	/*  :escL.c */
  static int neq;	/*  :escL.c */
  static double *dgyr;	/*  :escL.c */
  static int *iwork;	/*  :escL.c */
  static double *yh;	/*  :escL.c */
  void st2DVrMHD();	/*  :escL.c */
/*
   */
#ifdef Doc_ESMHDStShiftUpLowN

\section{Skeleton of ESMHDStShiftUpLowN()}
  \begin{verbatim}
    ESMHDStShiftUpLowN(){
    }
  \end{verbatim}
\section{ESMHDStShiftUpLowN()}
Routine \Cline{ESMHDStShiftUpLowN()} performs deactivation of the lowest 
harmonic in the fundamental solution, shifts enumeration of fundamental 
vectors, and activates a new, next after the highest, harmonic
\bqbl
&&
\gy^j_{m,new}|^{m<M_2}_{m=M_1}
=
\gy^{j+1}_{m+1,old}|^{m<M_2}_{m=M_1}
,\quad
\gy^j_{M_2,new}
=
0
.\eqbl
\vskip12pt
\centerline{
\psfig{figure=/u/zakharov/wrk/Esc/Doc/escH.c.f0.ps,height=3in%
,bbllx=0in,bblly=4in,bburx=8in,bbury=6.5in}
}
\vskip12pt
The routine shifs boundaries of the Fourier spectrum
\bqbl
&&
M_1\to M_1+1
,\quad
M_2\to M_2+1
\eqbl
It generates a new fundamental vector, $\vgy^{M_2}$, $\vaY^{M_2}$. First,
it solves tridiagonal equations
\bqbl
&&
 B_k\gy^j_{k+2}
+A_k\gy^j_k
+C_k\gy^j_{k-2}
=
0
,\quad
j=M_2
,\quad
\gy^j_j
=
1
,\quad
\gy^j_{J}
=
0
,\\&&
A_k
\equiv
(j^2-k^2)K_0
,\quad
B_k
\equiv
(j+k)(j+k+2)(K^r-iK^i)
,\\&&
C_k
\equiv
(j-k)(j-k+2)(K^r+iK^i)
,\eqbl
where
\bqbl
&&
K
\equiv
\R{G_{a\gt}}{a}|_{a=0}
=
K_0
+(K^r_2+iK^i_2)e^{2i\gt}
+(K^r_2-iK^i_2)e^{-2i\gt}
.\eqbl
Decomposition and backsubstitution loops 
\bqbl
&&
\gy^j_k
=
V_k\gy^j_{k-2}
+U_k
,\quad
V_j
=
0
,\quad
U_j
=
1
,\\&&
V_k
=
-{C_k\over A_k+B_kV_{k+2}}
,\\&&
U_k
=
{-B_kU_{k+2}\over A_k+B_kV_{k+2}}
.\eqbl
Then, the complimentary vector $\vaY^j$
\bqbl
&&
\vaY^j
=
\maK^\dagger a\vgy'
-i\maG^\dagger_{a\gt}\maM\vgy
\eqbl
is calculated as
\bqbl
&&
\vaY^j
=
j\maK^\dagger\vgy^j
.\eqbl
The derivatives of $\vgy^j$, $\vaY^j$, necessary for initialization 
\Cline{LSODE}, are calculated as
\bqbl
&&
\R{(\vgy^j)^{(n)}}{n!}
=
\R{j!(j-n)!}{n!a^n}\vgy^j
,\quad
\R{(\vaY^j)^{(n)}}{n!}
=
\R{j!(j-n)!}{n!a^n}\vaY^j
.\eqbl
Finally, $\vgy^j$ is made zero
\bqbl
&&
\vgy^j
=
0
.\eqbl

#endif
}
int ESMHDStShiftDnLowN()
{
  Undef ESSetSplA();
  Undef splRA();
  extern double *ESg22c;	/* undefined */
  extern double *ESg22c2;	/* undefined */
  extern int ES2Mp1;		/* undefined */
  extern int ESNa1;		/* undefined */
  extern double *ESg22s;	/* undefined */
  extern double *ESg22s2;	/* undefined */
  static double *rwork;	/*  :escL.c */
  static double *gqqr;	/*  :escL.c */
  static double *gqqi;	/*  :escL.c */
  static int M1;	/*  :escL.c */
  static int M2;	/*  :escL.c */
  static int MMp1;	/*  :escL.c */
  static double *gyr;	/*  :escL.c */
  static double *gyi;	/*  :escL.c */
  static double *aYr;	/*  :escL.c */
  static double *aYi;	/*  :escL.c */
  static int Mp1;	/*  :escL.c */
  static double *vatol;	/*  :escL.c */
  static double reltol;	/*  :escL.c */
  static int neq;	/*  :escL.c */
  static double *dgyr;	/*  :escL.c */
  static int *iwork;	/*  :escL.c */
  static double *yh;	/*  :escL.c */
  void st2DVrMHD();	/*  :escL.c */
/*
   */
#ifdef Doc_ESMHDStShiftDnLowN

\section{Skeleton of ESMHDStShiftDnLowN()}
  \begin{verbatim}
    ESMHDStShiftDnLowN(){
    }
  \end{verbatim}
\section{ESMHDStShiftDnLowN()}

\section{Skeleton of ESMHDStShiftUpLowN()}
  \begin{verbatim}
    ESMHDStShiftUpLowN(){
    }
  \end{verbatim}
\section{ESMHDStShiftUpLowN()}
Routine \Cline{ESMHDStShiftUpLowN()} performs deactivation of the highest
harmonic in the fundamental solution, shifts downward enumeration of 
fundamental vectors, and activates a new, the previous to the lowest, 
harmonic
\bqbl
&&
\gy^j_{m,new}|^{m\leq M_2}_{m=M_1+1}
=
\gy^{j-1}_{m-1,old}|^{m\leq M_2}_{m=M_1+1}
,\quad
\gy^j_{M_1,new}
=
0
.\eqbl
\vskip12pt
\centerline{
\psfig{figure=/u/zakharov/wrk/Esc/Doc/escH.c.f1.ps,height=3in%
,bbllx=0in,bblly=4.25in,bburx=8in,bbury=6.75in}
}
\vskip12pt
The routine shifs boundaries of the Fourier spectrum
\bqbl
&&
M_1\to M_1-1
,\quad
M_2\to M_2-1
\eqbl
It generates a new fundamental vector, $\vgy^{M_1}$, $\vaY^{M_1}$. First,
it solves tridiagonal equations
\bqbl
&&
 B_k\gy^j_{k+2}
+A_k\gy^j_k
+C_k\gy^j_{k-2}
=
0
,\quad
j=M_1
,,\quad
J=-M_1
\quad
\gy^j_j
=
1
,\quad
\gy^j_{J}
=
0
,\\&&
A_k
\equiv
(j^2-k^2)K_0
,\quad
B_k
\equiv
(j+k)(j+k+2)(K^r-iK^i)
,\\&&
C_k
\equiv
(j-k)(j-k+2)(K^r+iK^i)
,\eqbl
where
\bqbl
&&
K
\equiv
\R{G_{a\gt}}{a}|_{a=0}
=
K_0
+(K^r_2+iK^i_2)e^{2i\gt}
+(K^r_2-iK^i_2)e^{-2i\gt}
.\eqbl
Decomposition and backsubstitution loops 
\bqbl
&&
\gy^j_k
=
V_k\gy^j_{k-2}
+U_k
,\quad
V_j
=
0
,\quad
U_j
=
1
,\\&&
V_k
=
-{C_k\over A_k+B_kV_{k+2}}
,\\&&
U_k
=
{-B_kU_{k+2}\over A_k+B_kV_{k+2}}
.\eqbl
Then, the complimentary vector $\vaY^j$
\bqbl
&&
\vaY^j
=
\maK^\dagger a\vgy'
-i\maG^\dagger_{a\gt}\maM\vgy
\eqbl
is calculated as
\bqbl
&&
\vaY^j
=
j\maK^\dagger\vgy^j
.\eqbl
The derivatives of $\vgy^j$, $\vaY^j$, necessary for initialization 
\Cline{LSODE}, are calculated as
\bqbl
&&
\R{(\vgy^j)^{(n)}}{n!}
=
\R{j!(j-n)!}{n!a^n}\vgy^j
,\quad
\R{(\vaY^j)^{(n)}}{n!}
=
\R{j!(j-n)!}{n!a^n}\vaY^j
.\eqbl
Finally, $\vgy^j$ is made zero
\bqbl
&&
\vgy^j
=
0
.\eqbl
#endif
}
int ESStSetXres(xres,x)
  double *xres;	/*  */
  double x;	/*  */
{
  extern double *ESsa;	/* undefined */
  extern int ESNa;	/* undefined */
  double x;		/*  .ESStSetXres():escL.c */
  double *xres;		/*  .ESStSetXres():escL.c */
  static int iRes;	/*                :escL.c */
  static int nRes;	/*                :escL.c */
  static double *aRes;	/*                :escL.c */
/*
   */
#ifdef Doc_ESStSetXres

\section{Skeleton of ESStSetXres()}
  \begin{verbatim}
    ESStSetXres(){
    }
  \end{verbatim}
\section{ESStSetXres()}
#endif
}
int ESStSetXcenter(mcen,xcen,i)
  int *mcen;	/*  */
  double *xcen;	/*  */
  int i;	/*  */
{
  extern double cr2;	/* undefined */
  extern double *ESsq;	/* undefined */
  extern int ESNa;	/* undefined */
  extern double *ESsa;	/* undefined */
  int i;			/*  .ESStSetXcenter():escL.c */
  int *mcen;			/*  .ESStSetXcenter():escL.c */
  double *xcen;			/*  .ESStSetXcenter():escL.c */
  static int nRes;		/*                   :escL.c */
  static int *mRes;		/*                   :escL.c */
  static double *aRes;		/*                   :escL.c */
  static int Mres;		/*                   :escL.c */
  static int kRes;		/*                   :escL.c */
  static int N;			/*                   :escL.c */
  int ESResAsymptotics();	/*                   :escL.c */
/*
   */
#ifdef Doc_ESStSetXcenter

\section{Skeleton of ESStSetXcenter()}
  \begin{verbatim}
    ESStSetXcenter(){
    }
  \end{verbatim}
\section{ESStSetXcenter()}
#endif
}
int ESStSetCheckPoint(xchk,x,dx)
  double *xchk;	/*  */
  double x;	/*  */
  double dx;	/*  */
{
  double *xchk;			/*  .ESStSetCheckPoint():escL.c */
  double dx;			/*  .ESStSetCheckPoint():escL.c */
  double x;			/*  .ESStSetCheckPoint():escL.c */
  static double *rwork;		/*                      :escL.c */
  static int FlagRes;		/*                      :escL.c */
  static double aResChck;	/*                      :escL.c */
  static int Mres;		/*                      :escL.c */
/*
   */
#ifdef Doc_ESStSetCheckPoint

\section{Skeleton of ESStSetCheckPoint()}
  \begin{verbatim}
    ESStSetCheckPoint(){
    }
  \end{verbatim}
\section{ESStSetCheckPoint()}
#endif
}
int ES2DStSolv(Opt,a1)
  int Opt;	/*  */
  double a1;	/*  */
{
  Undef lsode_();
  Undef out();
  extern double *ESsa;	/* undefined */
  extern int ESNa;	/* undefined */
  extern int ESStKRec;	/* undefined */
  extern int ESStNRec;	/* undefined */
  extern int ESStMRec;	/* undefined */
  extern int ESStN;	/* undefined */
  extern int ESStM1;	/* undefined */
  extern int ESStM2;	/* undefined */
  double a1;			/*  .ES2DStSolv():escL.c */
  int Opt;			/*  .ES2DStSolv():escL.c */
  static double *aRes;		/*               :escL.c */
  static int nRes;		/*               :escL.c */
  static int iRes;		/*               :escL.c */
  static double aResChck;	/*               :escL.c */
  static double *rwork;		/*               :escL.c */
  static int FlStChol;		/*               :escL.c */
  static int mf;		/*               :escL.c */
  static int itol;		/*               :escL.c */
  static int itask;		/*               :escL.c */
  static int iopt;		/*               :escL.c */
  static int *iwork;		/*               :escL.c */
  static double reltol;		/*               :escL.c */
  static double abstol;		/*               :escL.c */
  static int istate;		/*               :escL.c */
  static int neq;		/*               :escL.c */
  static double *gyr;		/*               :escL.c */
  static double *dgyr;		/*               :escL.c */
  static int kCheck;		/*               :escL.c */
  static int NRec;		/*               :escL.c */
  static int MRec;		/*               :escL.c */
  static FILE *fpy;		/*               :escL.c */
  static FILE *fpt;		/*               :escL.c */
  static double xout;		/*               :escL.c */
  static int FlagRes;		/*               :escL.c */
  static double *vatol;		/*               :escL.c */
  static int lrw;		/*               :escL.c */
  static int liw;		/*               :escL.c */
  static int Mgy;		/*               :escL.c */
  static int M1;		/*               :escL.c */
  static int Mp1;		/*               :escL.c */
  static double *gyi;		/*               :escL.c */
  static double *aYr;		/*               :escL.c */
  static double *aYi;		/*               :escL.c */
  static int MaY;		/*               :escL.c */
  int ESStSetXcenter();		/*               :escL.c */
  int ESStSetXres();		/*               :escL.c */
  int ESInitStFundSolution();	/*               :escL.c */
  void st2DVrMHD();		/*               :escL.c */
  int ESStSetCheckPoint();	/*               :escL.c */
/*
   */
#ifdef Doc_ES2DStSolv
\section{Skeleton of ES2DStSolv()}
  \begin{verbatim}
    ES2DStSolv(){
    }
  \end{verbatim}
\section{ES2DStSolv()}
Self-adjoinness
\bqbl
&&
\vgy'_1
=
\maF^{-1}(\vaY_1-\maK\vgy_1)
,\quad
\vaY'_1
=
\maK^\dagger\vgy'_1
+\maG\vgy_1
,\quad
\vgy'^\dagger_1
=
(\vaY^\dagger_1-\vgy^\dagger_1\maK^\dagger)\maF^{-1}
,\quad
\vaY'^\dagger_1
=
\vgy'^\dagger_1\maK
+\vgy^\dagger_1\maG
,\\&&
\vgy'_2
=
\maF^{-1}(\vaY_2-\maK\vgy_2)
,\quad
\vaY'_2
=
\maK^\dagger\vgy'_2
+\maG\vgy_2
,\quad
\vgy'^\dagger_2
=
(\vaY^\dagger_2-\vgy^\dagger_2\maK^\dagger)\maF^{-1}
,\quad
\vaY'^\dagger_2
=
\vgy'^\dagger_2\maK
+\vgy^\dagger_2\maG
,\\&&
\vgy'^\dagger_2\vaY_1
+\vgy^\dagger_2\vaY'_1
-\vaY'^\dagger_2\vgy_1
-\vaY^\dagger_2\vgy'_1
=
-\vgy^\dagger_2\maK^\dagger(\maF^{-1}\vaY_1-\vgy'_1)
+(\vaY^\dagger_2\maF^{-1}-\vgy'^\dagger_2)\maK\vgy_1
,\\&&
(\vgy^\dagger_2\vaY_1-\vaY^\dagger_2\vgy_1)'
=
0
,\quad
\vgy^\dagger_2\vaY_1-\vaY^\dagger_2\vgy_1
=
\mbox{const}
,\quad
\vgy^\dagger_1\vaY_2-\vaY^\dagger_1\vgy_2
=
\mbox{const}
.\eqbl
Instability condition
\bqbl
&&
\vgy^\dagger_{NR2}\vaY_{NR1}-\vaY^\dagger_{NR2}\vgy_{NR1}
=
0
,\\&&
\vgy^\dagger_{NR}\vaY_{R}-\vaY^\dagger_{NR}\vgy_{R}
=
-Y^*_{NR,m}\gy_{R,m}
,\\&&
\vgy^\dagger_{R}\vaY_{NR}-\vaY^\dagger_{R}\vgy_{NR}
=
\gy^*_{R,m}Y_{NR,m}
,\\&&
\vgy^\dagger_{R}\vaY_{R}-\vaY^\dagger_{R}\vgy_{R}
=
\gy^*_{R,m}Y_{R,m}-Y^*_{R,m}\gy_{R,m}
.\eqbl
#endif
}
int ESMHDStabLowN()
{
  extern double *ESaR0;		/* undefined */
  extern double *ESsa;		/* undefined */
  extern double *ESsq;		/* undefined */
  extern int ESNa1;		/* undefined */
  extern int ESStNRec;		/* undefined */
  extern int ESStMRec;		/* undefined */
  extern int ESStKRec;		/* undefined */
  extern clock_t clock();	/* undefined */
  extern int ESmemlev;		/* undefined */
  extern int ESStN;		/* undefined */
  extern int ESStM1;		/* undefined */
  extern int ESStM2;		/* undefined */
  static double R0;		/*  :escL.c */
  static double rR0;		/*  :escL.c */
  static double *aRes;		/*  :escL.c */
  static double qmn;		/*  :escL.c */
  static double qmx;		/*  :escL.c */
  static int Mgy;		/*  :escL.c */
  static int N;			/*  :escL.c */
  static int MaY;		/*  :escL.c */
  static int dM1;		/*  :escL.c */
  static int dM2;		/*  :escL.c */
  static clock_t ESst0;		/*  :escL.c */
  static int *mRes;		/*  :escL.c */
  static int M1;		/*  :escL.c */
  static int Mmx;		/*  :escL.c */
  static int M2;		/*  :escL.c */
  static int Mp1;		/*  :escL.c */
  static int nRes;		/*  :escL.c */
  static double *qRes;		/*  :escL.c */
  static int NRec;		/*  :escL.c */
  static int MRec;		/*  :escL.c */
  int ESDeInitMHDMetrTnsr();	/*  :escL.c */
  int ESStResonances();		/*  :escL.c */
  int ESReInitMHDStabLowN();	/*  :escL.c */
  int ESReInitMHDMetrTnsr();	/*  :escL.c */
  int ESMHDMetrTnsr();		/*  :escL.c */
  int ES2DStSolv();		/*  :escL.c */
  int ESDeInitMHDStabLowN();	/*  :escL.c */
/*
   */
#ifdef Doc_ESMHDStabLowN

\section{Skeleton of ESMHDStabLowN()}
  \begin{verbatim}
    ESMHDStabLowN(){
    }
  \end{verbatim}
\section{ESMHDStabLowN()}
The routine is the launcher of low-n stability test.

#endif
}
#endif

#undef Doc_Cb_Structure
#ifdef Blb_escL.c
Blb_escL.c{
}
#endif

#undef Doc_Table_Of_Content
#ifndef Blb_escL.c
					PS p= 72 ( 36);
int ESReInitMHDMetrTnsr();		PS p=  2 (  1);
int ESDeInitMHDMetrTnsr();		PS p=  2 (  1);
int ESMHDMetrTnsr();			PS p=  2 (  1);
int ESInitStLSODE();			PS p=  4 (  2);
int ESDeInitStLSODE();			PS p=  5 (  3);
int ESStResonances();			PS p=  5 (  3);
int ESReInitMHDStabLowN();		PS p=  9 (  5);
int ESDeInitMHDStabLowN();		PS p= 12 (  6);
int ESInitStFundSolution();		PS p= 12 (  6);
void st2DVrMHD();			PS p= 21 ( 11);
int ESResAsymptotics();			PS p= 42 ( 21);
int ESStInitSmallResSolution();		PS p= 50 ( 25);
int ESStSetVatol();			PS p= 52 ( 26);
int ESMHDStCheckLowN();			PS p= 53 ( 27);
int ESMHDStShiftUpLowN();		PS p= 57 ( 29);
int ESMHDStShiftDnLowN();		PS p= 61 ( 31);
int ESStSetXres();			PS p= 65 ( 33);
int ESStSetXcenter();			PS p= 65 ( 33);
int ESStSetCheckPoint();		PS p= 66 ( 33);
int ES2DStSolv();			PS p= 66 ( 33);
int ESMHDStabLowN();			PS p= 72 ( 36);
#endif
