#ifndef Blb_escQ.c
/* undefined */
#ifdef Doc_escQ.c
\title{Equations of Guiding Center Motion} 
\date{July 14, 2002}
\maketitle
\Section{Littlejohn Lagrangian in physical units}
\bqbl
&&
L
=
\R{e}{c}\waA\cdot\wsv
+mv^2_\parallel
-H
,\quad
H
\equiv
\R{mv^2_\parallel}{2}
+e\gF_E
+\gm B
,\quad
\gm
\equiv
\R{mv^2_\perp}{2B}
.\eqbl
Normalized form
\bqbl
&&
\baL
\equiv
\R{c}{eB_0}L
=
\R{\waA}{B_0}\cdot\wsv
+\R{\gr_\parallel}{\gW_0}(\waB\cdot\wsv)
-\baH
,\quad
\baH
\equiv
\R{1}{\gW_0}\R{\gr^2_\parallel}{2}B^2
+\R{c}{B_0}\gF_E
+\R{1}{\gW_0}\bgm\R{B}{B_0}
,\\&&
\gW_0
\equiv
\R{eB_0}{mc}
,\quad
\gr_\parallel
\equiv
\R{(\waB\cdot\wsv)}{B^2}
,\quad
\bgm
\equiv
\R{v^2_\perp B_0}{2B}
.\eqbl

Transition to R.White normalizaton
\bqbl
&&
v
=
\bsv\R{ReB}{mc}
,\quad
L
=
\baL\R{R^2e^2B^2}{mc^2}
,\quad
\baL
=
\b{\waA}\cdot\b{\wsv}
+\bsv^2_\parallel
-\baH
,\quad
\waA
=
\b{\waA}RB
,\\&&
H
=
\baH\R{R^2e^2B^2}{mc^2}
,\quad
\baH
=
\R{\bsv^2_\parallel}{2}
+\bgF_E
+\bgm B
,\quad
e\gF_E
=
\bgF_E\R{R^2e^2B^2}{mc^2}
,\quad
\gm
=
\bgm\R{R^2e^2B^2}{mc^2}
.\eqbl
Dimensional normalization factors
\bqbl
&&
m_p
=
1.6726\cdot10^{-24}\ \mbox{[g]}
,\quad
e_p
=
4.8032\cdot10^{-10}\ \mbox{[CGS]}
,\quad
c
=
2.9979\cdot10^{10}\ \mbox{[cm/sec]}
,\\&&
R_0
=
1\ \mbox{[m]}
,\quad
B_0
=
1\ \mbox{[T]}
,\quad
\gW_c
\equiv
\R{eB}{mc}
=
0.9579\cdot10^{8}\ \mbox{[1/sec]}
,\quad
V_0
\equiv
\R{ReB}{mc}
=
0.9579\cdot10^{8}\ \mbox{[m/sec]}
,\\&&
\gF_E
=
\bgF_E\R{R^2eB^2}{mc^2}3\cdot10^2\ \mbox{[V]}
=
\bgF_E\R{RB V_0}{c}
,\quad
\gF_{E0}
=
0.9579\cdot10^{8}\ \mbox{[V]}
,\quad
t_0
=
\R{1}{\gW_c}\ \mbox{[sec]}
.\eqbl
Thermal particle velocity
\bqbl
&&
\R{mV_i^2}{2}
=
1.6022\cdot10^{-9}E\ \mbox{[keV]}
,\quad
V_{i1}
=
4.377\cdot10^{5}\ \mbox{[m/sec]}
,\quad
V_{i10}
=
1.3841\cdot10^{6}\ \mbox{[m/sec]}
.\eqbl

\Section{Lagrangian in the laboratory coordinates $a,\gq,\gf$}
Vector potential in arbitrary flux coordinates
\bqbl
&&
\waA
=
-\gh\na a
+\bgF\na\gq
+\bgY\na\gf
.\eqbl
Contravariant representation of the magnetic field
\bqbl
&&
\waB\cdot\na a
=
0
,\quad
\waB\cdot\na\gq
=
-\R{\bgY'+\gh'_\gf}{\q{g}}
,\quad
\waB\cdot\na\gf
=
\R{\bgF'+\gh'_\gq}{\q{g}}
.\eqbl
Contravariant representation of the current density
\bqbl
&&
\wsj\cdot\na a
=
0
,\quad
\wsj\cdot\na\gq
=
-\R{\baF'+\gn'_\gf}{\q{g}}
,\quad
\wsj\cdot\na\gf
=
\R{\baI'+\gn'_\gq}{\q{g}}
.\eqbl
Covariant component of the magnetic field
\bqbl
&&
\waB
=
B_a\na a
+B_\gq\na\gq
+B_\gf\na\gf
,\\&&
B_a
=
-\R{g_{a\gq}}{\q{g}}(\bgY'+\gh'_\gf)
+\R{g_{a\gf}}{\q{g}}(\bgF'+\gh'_\gq)
,\\&&
B_\gq
=
-\R{g_{\gq\gq}}{\q{g}}(\bgY'+\gh'_\gf)
+\R{g_{\gq\gf}}{\q{g}}(\bgF'+\gh'_\gq)
,\\&&
B_\gf
=
-\R{g_{\gq\gf}}{\q{g}}(\bgY'+\gh'_\gf)
+\R{g_{\gf\gf}}{\q{g}}(\bgF'+\gh'_\gq)
.\eqbl
In terms of currents the convariant components are
\bqbl
&&
B_a
=
\gs'_a-\gn
,\quad
B_\gq
=
\baI+\gs'_\gq
,\quad
B_\gf
=
\baF+\gs'_\gf
.\eqbl
Amplitude of the magnetic field
\bqbl
&&
\q{g}B^2
=
\R{g_{\gq\gq}}{\q{g}}(\bgY'+\gh'_\gf)^2
-2\R{g_{\gq\gf}}{\q{g}}(\bgY'+\gh'_\gf)(\bgF'+\gh'_\gq)
+\R{g_{\gf\gf}}{\q{g}}(\bgF'+\gh'_\gq)^2
.\eqbl
Equation for $\gs$ can be obtained from different expressions for $B^2$
\bqbl
&&
-(\bgY'+\gh'_\gf)(I+\gs'_\gq)
+(\bgF'+\gh'_\gq)(F+\gs'_\gf)
=
\q{g}B^2
.\eqbl
Equation for $\gn$
\bqbl
&&
\bsp'\q{g}
=
-(\baF'+\gn'_\gf)(\bgF'+\gh'_\gq)
+(\baI'+\gn'_\gq)(\bgY'+\gh'_\gf)
.\eqbl
1-D relationships between functions entering Lagrangian
\bqbl
&&
\bsp'(\q{g})_{00}
=
-\baF'\bgF'
+\baI'\bgY'
.\eqbl
3-D relationships between functions entering Lagrangian
\bqbl
&&
\bsp'\q{g}
=
-(\bgF'+\gh'_\gq)\gn'_\gf
-\baF'(\bgF'+\gh'_\gq)
+(\bgY'+\gh'_\gf)\gn'_\gq
+\baI'(\bgY'+\gh'_\gf)
.\eqbl
Lagrangian
\bqbl
&&
L=
P_a\d{a}
+P_\gq\d{\gq}
+P_\gf\d{\gf}
-H
,\\&&
P_a
\equiv
-\gh
+\gr_\parallel(\gs'_a-\gn)
,\quad
P_\gq
\equiv
\bgF+\gr_\parallel(I+\gs'_\gq)
,\quad
P_\gf
\equiv
\bgY+\gr_\parallel(F+\gs'_\gf)
.\eqbl
\Section{Equations in the laboratory coordinates}
\begin{eqnarray}
&&
\left|
\begin{array}{rrrr}
\db0
\da\gs'_a-\gn
\da a_{11}
\da a_{21}
\dd-\gs'_a+\gn
\da0
\da a_{12}
\da a_{22}
\dd a_{11}
\da a_{12}
\da0
\da0
\dd a_{21}
\da a_{22}
\da0
\da0
\end{array}
\right|
\cdot
\left|
\begin{array}{l}
\db\d{\gr}_\parallel
\dd\d{a}
\dd\d{\gq}
\dd\d{\gf}
\end{array}
\right|
=
\left|
\begin{array}{r}
\db\R{\pa H}{\pa\gr_\parallel}
\dd\R{\pa H}{\pa a}
\dd-\R{\pa H}{\pa\gq}
\dd-\R{\pa H}{\pa\gf}
\end{array}
\right|
,\end{eqnarray}
where
\bqbl
&&
a_{11}
\equiv
I+\gs'_\gq
,\quad
a_{12}
\equiv
\bgF'+\gh'_\gq+\gr_\parallel(I'+\gn'_\gq)
,\\&&
a_{21}
\equiv
F+\gs'_\gf
,\quad
a_{22}
\equiv
\bgY'+\gh'_\gf+\gr_\parallel(F'+\gn'_\gf)
.\eqbl
In terms of metric coefficients the Lagrangian matrix can be calculated as
\bqbl
&&
a_{11}
=
-K\bgY'
,\quad
a_{21}
=
F
,\quad
a_{12}
=
L\baF+\gr_\parallel\left(rDP+LT\right)
,\quad
a_{22}
=
\bgY'+\gr_\parallel\baF'
,\\&&
D\equiv r'_az'_\gq-r'_\gq z'_a
,\quad
K
=
\R{g_{\gq\gq}}{rD}
=
\R{r'^2_\gq+z'^2_\gq}{rD}
,\quad
N
=
\R{g_{a\gq}}{rD}
=
\R{r'_ar'_\gq+z'_az'_\gq}{rD}
,\quad
L
=
\R{D}{r}
,\\&&
P
\equiv
\R{\bsp'}{\bgY'}
,\quad
T
\equiv
\R{\baF\baF'}{\bgY'}
,\quad
B^2
=
\R{K\bgY'^2}{\q{g}}+\R{\baF^2}{r^2}
.\eqbl

Using the inverted matrix
\begin{eqnarray}
&&
\maA
\equiv
\left|
\begin{array}{rr}
\db a_{11}
\da a_{12}
\dd a_{21}
\da a_{22}
\end{array}
\right|^{-1}
=
\left|
\begin{array}{rr}
\db \R{a_{22}}{D}
\da -\R{a_{12}}{D}
\dd -\R{a_{21}}{D}
\da \R{a_{11}}{D}
\end{array}
\right|
,\\&&
D
\equiv
(I+\gs'_\gq)[\bgY'+\gh'_\gf+\gr_\parallel(F'+\gn'_\gf)]
-(F+\gs'_\gf)[\bgF'+\gh'_\gq+\gr_\parallel(I'+\gn'_\gq)]
,\end{eqnarray}
the equations of motion can be written in the explicit form
\begin{eqnarray}
&&
\left|
\begin{array}{l}
\db\d{\gr}_\parallel
\dd\d{a}
\dd\d{\gq}
\dd\d{\gf}
\end{array}
\right|
=
\left|
\begin{array}{rrrr}
\db0
\da0
\da \R{a_{22}}{D}
\da -\R{a_{12}}{D}
\dd0
\da0
\da -\R{a_{21}}{D}
\da \R{a_{11}}{D}
\dd \R{a_{22}}{D}
\da -\R{a_{21}}{D}
\da0
\da-\R{\gs'_a+\gn}{D}
\dd -\R{a_{12}}{D}
\da \R{a_{11}}{D}
\da\R{\gs'_a-\gn}{D}
\da0
\end{array}
\right|
\cdot
\left|
\begin{array}{r}
\db\R{\pa H}{\pa\gr_\parallel}
\dd\R{\pa H}{\pa a}
\dd-\R{\pa H}{\pa\gq}
\dd-\R{\pa H}{\pa\gf}
\end{array}
\right|
.\end{eqnarray}

\Section{Basic set of functions for 2-D case}
In equilibrium configuration with the known metrics of the coordinates,
the 2-dimensional functions $\gh'_\gq,B^2,\gs,\gn$ are determined by the
following equations 
\bqbl
&&
\bgF'+\gh'_\gq
=
L\baF
,\quad
\baI+\gs'_\gq
=
-K\bgY'
,\quad
B^2
=
\R{K\bgY'^2+L\baF^2}{\q{g}}
,\quad
\baI'+\gn'_\gq
=
\q{g}\R{\bsp'}{\bgY'}
+L\R{\baF\baF'}{\bgY'}
,\\&&
L
\equiv
\R{\q{g}}{r^2}\baF
,\quad
K
\equiv
\R{g_{\gq\gq}}{\q{g}}
.\eqbl
Among these 4 functions, i.e., $\gh'_\gq,B^2,\gs,\gn$ entering
Lagrangian, only 3, i.e., $\gh'_\gq,B^2,\gs$ are independent
while $\gn$ can be expressed as
\bqbl
&&
\gn'_\gq
=
\R{\bsp'}{\bgY'}\R{(\bgF'+\gh'_\gq)\baF-(I+\gs)\bgY'}{B^2}
+\R{\baF'(\bgF'+\gh'_\gq)}{\bgY'}
-\baI'
.\eqbl
In addition, the following 1-D profiles 
\bqbl
&&
\bgF(a),\bgY(a),\baI(a),\baF(a),\baF',\bsp'
\eqbl
should be supplemented to Lagrangian equations of motion.
#endif

#ifndef mzl_System_escQ.c /* --------------- Use of Variables --------{ */
#ifdef Tbl_UnusedID/* ------------- List of Unused variables ------{ */
  extern double cr12;		/*                 :escQ.c */
  extern double cgp_4;		/*                 :escQ.c */
  extern unsigned int ESmemlev;	/*                 :escQ.c */
  extern int ESnAP;		/*                 :escQ.c */
  extern int ES2Mp1;		/*                 :escQ.c */
  extern double *ESjp;		/*                 :escQ.c */
  extern double *ESjp1a;	/*                 :escQ.c */
  extern double *ESsq1a;	/*                 :escQ.c */
  extern double *ESjs;		/*                 :escQ.c */
  extern double *ESgF;		/*                 :escQ.c */
  extern double *ESaJ;		/*                 :escQ.c */
  extern double *ESaJ2a;	/*                 :escQ.c */
  extern double *ESPs;		/*                 :escQ.c */
  extern double *ESPs1a;	/*                 :escQ.c */
  extern double *ESPs2a;	/*                 :escQ.c */
  extern double *ESLs;		/*                 :escQ.c */
  extern double *ESLs1;		/*                 :escQ.c */
  extern double *ESVc1;		/*                 :escQ.c */
  extern double *ESVs;		/*                 :escQ.c */
  extern double *ESVs1;		/*                 :escQ.c */
  extern double *ESg22c;	/*                 :escQ.c */
  extern double *ESg22c1;	/*                 :escQ.c */
  extern double *ESg22s;	/*                 :escQ.c */
  extern double *ESg22s1;	/*                 :escQ.c */
  extern double *ESdgY;		/*                 :escQ.c */
  extern double ESBt;		/*                 :escQ.c */
  extern double ESRBt;		/*                 :escQ.c */
  extern double ESRext;		/*                 :escQ.c */
  static double cEeV;		/*                 :escQ.c */
  static double hcur;		/*                 :escQ.c */
  static double xout;		/*                 :escQ.c */
  static double dyGC[];		/*                 :escQ.c */
  static int NPart;		/*                 :escQ.c */
  int ESIget2DFunc();		/*                 :escQ.c */
  int ESWriteESI0();		/*                 :escQ.c */
  int ESBasicFunctionsPEST();	/*                 :escQ.c */
  int ES2PEST();		/*                 :escQ.c */
  int ESBasicFunctionsHamada();	/*                 :escQ.c */
  int ES2Hamada();		/*                 :escQ.c */
  int ESBasicFunctionsBoozer();	/*                 :escQ.c */
  int ES2Boozer();		/*                 :escQ.c */
  int ESBasicFunctionsHat();	/*                 :escQ.c */
  int ES2Hat();		/*                 :escQ.c */
  double YYa;			/*                 :escQ.c */
  double YYx;			/*                 :escQ.c */
  double YYX;			/*                 :escQ.c */
  double YYq;			/*                 :escQ.c */
  double YYy;			/*                 :escQ.c */
  double YYY;			/*                 :escQ.c */
  static double Yza[];		/*                 :escQ.c */
  static double Yzq[];		/*                 :escQ.c */
  static double YB[];		/*                 :escQ.c */
  static double YBa[];		/*                 :escQ.c */
  static double YBq[];		/*                 :escQ.c */
  static double Ya[];		/*                 :escQ.c */
  static double Yq[];		/*                 :escQ.c */
  static double Rloss[];	/*                 :escQ.c */
  static double Zloss[];	/*                 :escQ.c */
  int *n;			/*  .GCLagrangeEq():escQ.c */
  double *x;			/*  .GCLagrangeEq():escQ.c */
  int *n;			/* .GCLagrangeEqA():escQ.c */
  double *x;			/* .GCLagrangeEqA():escQ.c */
  int ES4Output();		/*                 :escQ.c */
  double a0;			/*     .ES4Output():escQ.c */
  double a1;			/*     .ES4Output():escQ.c */
  double gt0;			/*     .ES4Output():escQ.c */
  double gt1;			/*     .ES4Output():escQ.c */
  int na;			/*     .ES4Output():escQ.c */
  int nt;			/*     .ES4Output():escQ.c */
  double t1;			/* .GetBounceTime():escQ.c */
  int ReadFractionLosses();	/*                 :escQ.c */
  int ESOrbits();		/*                 :escQ.c */
  int ESBootstrap1();		/*                 :escQ.c */
  int ESBootstrap();		/*                 :escQ.c */
#endif /* }=== End of List of Unused variables ======*/
#ifndef H/* ---------- Used External Variables ------{ */
  Ignor double;
  Systm NULL;
  Systm free();
  Systm malloc();
  Systm printf();
  Systm sqrt();
  Systm sprintf();
  Systm fopen();
  Systm fclose();
  Systm fprintf();
  Systm cos();
  Systm sin();
  Systm fabs();
  Undef int;			/* undefined */
  Undef CbUserPlot;		/* undefined */
  Undef esiget2dfunctions_();	/* NO prototype */
  Undef gcmotion_();		/* NO prototype */
  Undef fwrite();		/* NO prototype */
  Undef fputs();		/* NO prototype */
  Undef fputc();		/* NO prototype */
  Undef splA1a();		/* NO prototype */
  Undef esiread_();		/* NO prototype */
  Undef ESSetSplA();		/* NO prototype */
  Undef splRA();		/* NO prototype */
  Undef splRA2();		/* NO prototype */
  Undef ESP2F();		/* NO prototype */
  Undef ZColor();		/* NO prototype */
  Undef ES2DMapFlx2Lab();	/* NO prototype */
  Undef lsode_();		/* NO prototype */
  Undef ZPlotPolyLine();	/* NO prototype */
  Undef ESIsInsidePlasma();	/* NO prototype */
  Undef fscanf();		/* NO prototype */
  Undef CbStr2UserMessage();	/* NO prototype */
  Undef puts();			/* NO prototype */
  Undef CbGetCurrentCbName();	/* NO prototype */
  Undef putchar();		/* NO prototype */
  Undef out();			/* NO prototype */
  Undef ZPlotLine();		/* NO prototype */
  Undef esilink2c_();		/* NO prototype */
  Undef ESSetMapBox();		/* NO prototype */
  Undef ES1DMapZ2gt();		/* NO prototype */
  Undef ES2DMapLab2Flx();	/* NO prototype */
  Undef ESFreeRZspaceEq();	/* NO prototype */
  Undef f2spl();		/* NO prototype */
  Undef splr0();		/* NO prototype */
  Undef SetPlotName();		/* NO prototype */
  Undef Scale2d();		/* NO prototype */
  Undef Plot2d();		/* NO prototype */
  extern double cr2;		/* External */
  extern double cr6;		/* External */
  extern double cr3;		/* External */
  extern double *ESaF;		/* External */
  extern double *ESaR0;		/* External */
  extern double *ESsb;		/* External */
  extern double *ESsb1a;	/* External */
  extern double *ESsb2a;	/* External */
  extern double *rcT2a;		/* External */
  extern double *rsT2a;		/* External */
  extern double *rcT1a;		/* External */
  extern int ESNa1;		/* External */
  extern double *rsT1a;		/* External */
  extern int ESFp1;		/* External */
  extern int ESNp1;		/* External */
  extern double *EScs1;		/* External */
  extern double *ESsn1;		/* External */
  extern int ESNp;		/* External */
  extern double *ESsra;		/* External */
  extern double *ESsrt;		/* External */
  extern double *ESsrat;	/* External */
  extern double *ESsza;		/* External */
  extern double *ESszt;		/* External */
  extern double *ESszat;	/* External */
  extern double *ESaB;		/* External */
  extern double *ESaBa;		/* External */
  extern double *ESaBt;		/* External */
  extern double *ESaBat;	/* External */
  extern double *ESgH;		/* External */
  extern double *ESgHt;		/* External */
  extern double *ESgHa;		/* External */
  extern double *ESgHat;	/* External */
  extern double *ESsa;		/* External */
  extern double *ESdgY;		/* External */
  extern double *ESdgY1a;	/* External */
  extern double *ESFF;		/* External */
  extern double *ESFF1a;	/* External */
  extern double *rcT;		/* External */
  extern double *ESaZ0;		/* External */
  extern double *rsT;		/* External */
  extern double *ESsz;		/* External */
  extern double *ESsr;		/* External */
  extern int ESNa;		/* External */
  extern double *ESgt;		/* External */
  extern double *ESaF1a;	/* External */
  extern double *ESLc;		/* External */
  extern double *ESLc1;		/* External */
  extern double *ESaT;		/* External */
  extern double *ESaT2a;	/* External */
  extern double *ESPs;		/* External */
  extern double *ESPs1a;	/* External */
  extern double *ESaT1a;	/* External */
  extern double cgm0;		/* External */
  extern double *ESVc;		/* External */
  extern double *ESsp;		/* External */
  extern double cr4;		/* External */
  extern double *ESpa;		/* External */
  extern double c2gp;		/* External */
  extern double *ESsp1a;	/* External */
  extern double *ESFF2a;	/* External */
  extern double *ESdgY2a;	/* External */
  extern double *ESLc2;		/* External */
  extern double *ESPs2a;	/* External */
  extern double *ESVc2;		/* External */
  extern double *ESsp2a;	/* External */
  extern int ESFp;		/* External */
  extern double cr2gp;		/* External */
  extern double *ESaF2a;	/* External */
  extern double *ESgY;		/* External */
  extern double *ESgY2a;	/* External */
  extern double cgp;		/* External */
  extern double *ESsq;		/* External */
  extern double *ESsq2a;	/* External */
  extern double crgm0;		/* External */
  extern double *ESjb;		/* External */
  extern time_t time();		/* External() */
  extern struct tm *localtime();/* External() */
  int ESIWriteDensity();	/* No prototype */
#ifdef Tbl_MLIB
#endif
#endif /* }======== End of Used External Variables ======= */

#endif /* }======== End of Use of Variables ======== */

extern time_t time();		/* undefined */
extern struct tm *localtime();	/* undefined */
static struct tm *ltm;		/*  */
static time_t stTime;		/*  */

#ifndef mzl_MLIB
extern double cr2;		/* undefined */
extern double cr3;		/* undefined */
extern double cr4;		/* undefined */
extern double cr6;		/* undefined */
extern double cr12;		/* undefined */
extern double cgp;		/* undefined */
extern double c2gp;		/* undefined */
extern double cgp_4;		/* undefined */
extern double cr2gp;		/* undefined */
extern double cgm0;		/* undefined */
extern double crgm0;		/* undefined */
extern unsigned int ESmemlev;	/* undefined */
#endif
extern int ESNa;	/* undefined */
extern int ESNa1;	/* undefined */
extern int ESNp;	/* undefined */
extern int ESNp1;	/* undefined */
extern int ESnAP;	/* undefined */
extern int ES2Mp1;	/* undefined */
extern int ESFp;	/* undefined */
extern int ESFp1;	/* undefined */
extern double *ESsa;	/* undefined */
extern double *ESpa;	/* undefined */
extern double *ESaR0;	/* undefined */
extern double *ESaZ0;	/* undefined */
extern double *ESsb;	/* undefined */
extern double *ESsb1a;	/* undefined */
extern double *ESsb2a;	/* undefined */
extern double *ESgt;	/* undefined */
extern double *EScs1;	/* undefined */
extern double *ESsn1;	/* undefined */
extern double *ESjp;	/* undefined */
extern double *ESjp1a;	/* undefined */
extern double *ESsp;	/* undefined */
extern double *ESsp1a;	/* undefined */
extern double *ESsp2a;	/* undefined */
extern double *ESsq;	/* undefined */
extern double *ESsq1a;	/* undefined */
extern double *ESsq2a;	/* undefined */
extern double *ESPs;	/* undefined */
extern double *ESPs1a;	/* undefined */
extern double *ESPs2a;	/* undefined */
extern double *ESjs;	/* undefined */
extern double *ESjb;	/* undefined */
extern double *ESgY;	/* undefined */
extern double *ESgY2a;	/* undefined */
extern double *ESFF;	/* undefined */
extern double *ESFF1a;	/* undefined */
extern double *ESFF2a;	/* undefined */
extern double *ESaF;	/* undefined */
extern double *ESaF1a;	/* undefined */
extern double *ESaF2a;	/* undefined */
extern double *ESgF;	/* undefined */
extern double *ESdgY;	/* undefined */
extern double *ESdgY2a;	/* undefined */
extern double *ESaJ;	/* undefined */
extern double *ESaJ2a;	/* undefined */
extern double *ESPs;	/* undefined */
extern double *ESPs1a;	/* undefined */
extern double *ESPs2a;	/* undefined */
extern double *ESaT;	/* undefined */
extern double *ESaT1a;	/* undefined */
extern double *ESaT2a;	/* undefined */
extern double *rcT;	/* undefined */
extern double *rcT1a;	/* undefined */
extern double *rcT2a;	/* undefined */
extern double *rsT;	/* undefined */
extern double *rsT1a;	/* undefined */
extern double *rsT2a;	/* undefined */
extern double *ESLc;	/* undefined */
extern double *ESLc1;	/* undefined */
extern double *ESLc2;	/* undefined */
extern double *ESLs;	/* undefined */
extern double *ESLs1;	/* undefined */
extern double *ESVc;	/* undefined */
extern double *ESVc1;	/* undefined */
extern double *ESVc2;	/* undefined */
extern double *ESVs;	/* undefined */
extern double *ESVs1;	/* undefined */
extern double *ESg22c;	/* undefined */
extern double *ESg22c1;	/* undefined */
extern double *ESg22s;	/* undefined */
extern double *ESg22s1;	/* undefined */
extern double *ESdgY;	/* undefined */
extern double *ESdgY1a;	/* undefined */
extern double ESBt;	/* undefined */
extern double ESRBt;	/* undefined */
extern double ESRext;	/* undefined */
extern double *ESsr;	/* undefined */
extern double *ESsra;	/* undefined */
extern double *ESsrt;	/* undefined */
extern double *ESsrat;	/* undefined */
extern double *ESsz;	/* undefined */
extern double *ESsza;	/* undefined */
extern double *ESszt;	/* undefined */
extern double *ESszat;	/* undefined */
extern double *ESaB;	/* undefined */
extern double *ESaBa;	/* undefined */
extern double *ESaBt;	/* undefined */
extern double *ESaBat;	/* undefined */
extern double *ESgH;	/* undefined */
extern double *ESgHa;	/* undefined */
extern double *ESgHt;	/* undefined */
extern double *ESgHat;	/* undefined */
static int Spi0;	/*  */
static int Spi1;	/*  */
static int Spj0;	/*  */
static int Spj1;	/*  */
static double ha;	/*  */
static double rha;	/*  */
static double hq;	/*  */
static double rhq;	/*  */
static double gmP;	/*  */
static double grn0;	/*  */
static double B0;	/*  */
static double Vn;	/*  */
static double Vb;	/*  */
static double pVb;	/*  */
static double Vtot;	/*  */
static double Pi[];	/*  */
static double Pe[];	/*  */
static double cmi;	/*  */
static double cc;	/*  */
static double ce;	/*  */
static double cEeV;	/*  */
static double cEkeV;	/*  */
double cgWc;		/*  */
static double cV1keV;	/*  */
static double cgr1keV;	/*  */
TRAPPED BounceData;	/*  */
TRAPPED *lBD;		/*  */
static int neq;		/*  */
static double hcur;	/*  */
static double xout;	/*  */
static double reltol;	/*  */
static double abstol;	/*  */
static double *rwork;	/*  */
static double *yh;	/*  */
static double *vatol;	/*  */
static int itol;	/*  */
static int itask;	/*  */
static int istate;	/*  */
static int iopt;	/*  */
static int mf;		/*  */
static int lrw;		/*  */
static int liw;		/*  */
static int *iwork;	/*  */
static double yGC[];	/*  */
static double dyGC[];	/*  */
static int NWRK;	/*  */
static int nWRK;	/*  */
static double *RKgr0;	/*  */
static double *RKgr1;	/*  */
static double *RKgr2;	/*  */
static double *RKgr3;	/*  */
static double *RKgr4;	/*  */
static double *RKa0;	/*  */
static double *RKa1;	/*  */
static double *RKa2;	/*  */
static double *RKa3;	/*  */
static double *RKa4;	/*  */
static double *RKgq0;	/*  */
static double *RKgq1;	/*  */
static double *RKgq2;	/*  */
static double *RKgq3;	/*  */
static double *RKgq4;	/*  */
static double *RKgf0;	/*  */
static double *RKgf1;	/*  */
static double *RKgf2;	/*  */
static double *RKgf3;	/*  */
static double *RKgf4;	/*  */
static double *rPrt0;	/*  */
static double *rPrt1;	/*  */
static double *zPrt0;	/*  */
static double *zPrt1;	/*  */
static double *Xgr;	/*  */
static double *Xa;	/*  */
static double *Xgq;	/*  */
static double *Xgf;	/*  */
static double *Xgm;	/*  */
static double *dXgr;	/*  */
static double *dXa;	/*  */
static double *dXgq;	/*  */
static double *dXgf;	/*  */

int GCInitRKSolv(n)
  int n;	/*  */
{
  int n;		/*  .GCInitRKSolv():escQ.c */
  static int nWRK;	/*                 :escQ.c */
  static int NWRK;	/*                 :escQ.c */
  static double *RKgr0;	/*                 :escQ.c */
  static double *RKgr1;	/*                 :escQ.c */
  static double *RKgr2;	/*                 :escQ.c */
  static double *RKgr3;	/*                 :escQ.c */
  static double *RKgr4;	/*                 :escQ.c */
  static double *RKa0;	/*                 :escQ.c */
  static double *RKa1;	/*                 :escQ.c */
  static double *RKa2;	/*                 :escQ.c */
  static double *RKa3;	/*                 :escQ.c */
  static double *RKa4;	/*                 :escQ.c */
  static double *RKgq0;	/*                 :escQ.c */
  static double *RKgq1;	/*                 :escQ.c */
  static double *RKgq2;	/*                 :escQ.c */
  static double *RKgq3;	/*                 :escQ.c */
  static double *RKgq4;	/*                 :escQ.c */
  static double *RKgf0;	/*                 :escQ.c */
  static double *RKgf1;	/*                 :escQ.c */
  static double *RKgf2;	/*                 :escQ.c */
  static double *RKgf3;	/*                 :escQ.c */
  static double *RKgf4;	/*                 :escQ.c */
  static double *rPrt0;	/*                 :escQ.c */
  static double *rPrt1;	/*                 :escQ.c */
  static double *zPrt0;	/*                 :escQ.c */
  static double *zPrt1;	/*                 :escQ.c */
  static double *Xgr;	/*                 :escQ.c */
  static double *Xa;	/*                 :escQ.c */
  static double *Xgq;	/*                 :escQ.c */
  static double *Xgf;	/*                 :escQ.c */
  static double *Xgm;	/*                 :escQ.c */
  static double *dXgr;	/*                 :escQ.c */
  static double *dXa;	/*                 :escQ.c */
  static double *dXgq;	/*                 :escQ.c */
  static double *dXgf;	/*                 :escQ.c */
/*
   */
#ifdef Doc_GCInitRKSolv
\Section{Skeleton of GCInitRKSolv()}
  \begin{verbatim}
    GCInitRKSolv(){
    }
  \end{verbatim}
\Section{GCInitRKSolv()}
#endif
}

int GCDeInitRKSolv()
{
  static int NWRK;	/*  :escQ.c */
  static double *RKgr0;	/*  :escQ.c */
/*
   */
#ifdef Doc_GCDeInitRKSolv
\Section{Skeleton of GCDeInitRKSolv()}
  \begin{verbatim}
    GCDeInitRKSolv(){
    }
  \end{verbatim}
\Section{GCDeInitRKSolv()}
#endif
}
static int NPart;	/*  */
static int nPart;	/*  */
static double XF[];	/*  */
static double XFa[];	/*  */
static double XgFa[];	/*  */
static double XgFaa[];	/*  */
static double XgYa[];	/*  */
static double XgYaa[];	/*  */
static double XT[];	/*  */
static double XTa[];	/*  */
static double XP[];	/*  */
static double XPa[];	/*  */
static double Xr[];	/*  */
static double Xra[];	/*  */
static double Xrq[];	/*  */
static double Xz[];	/*  */
static double Xza[];	/*  */
static double Xzq[];	/*  */
static double XB[];	/*  */
static double XBa[];	/*  */
static double XBq[];	/*  */
static double Xgh[];	/*  */
static double Xgha[];	/*  */
static double Xghq[];	/*  */

int ESIget2DFunc(r,ra,rq,z,za,zq,B,Ba,Bq,gh,gha,ghq,a,gq)
  double *r;	/*  */
  double *ra;	/*  */
  double *rq;	/*  */
  double *z;	/*  */
  double *za;	/*  */
  double *zq;	/*  */
  double *B;	/*  */
  double *Ba;	/*  */
  double *Bq;	/*  */
  double *gh;	/*  */
  double *gha;	/*  */
  double *ghq;	/*  */
  double a;	/*  */
  double gq;	/*  */
{
  Undef esiget2dfunctions_();
  double a;		/*  .ESIget2DFunc():escQ.c */
  double gq;		/*  .ESIget2DFunc():escQ.c */
  double *r;		/*  .ESIget2DFunc():escQ.c */
  double *ra;		/*  .ESIget2DFunc():escQ.c */
  double *rq;		/*  .ESIget2DFunc():escQ.c */
  double *z;		/*  .ESIget2DFunc():escQ.c */
  double *za;		/*  .ESIget2DFunc():escQ.c */
  double *zq;		/*  .ESIget2DFunc():escQ.c */
  double *B;		/*  .ESIget2DFunc():escQ.c */
  double *Ba;		/*  .ESIget2DFunc():escQ.c */
  double *Bq;		/*  .ESIget2DFunc():escQ.c */
  double *gh;		/*  .ESIget2DFunc():escQ.c */
  double *gha;		/*  .ESIget2DFunc():escQ.c */
  double *ghq;		/*  .ESIget2DFunc():escQ.c */
  static double Xr[];	/*                 :escQ.c */
  static double Xra[];	/*                 :escQ.c */
  static double Xrq[];	/*                 :escQ.c */
  static double Xz[];	/*                 :escQ.c */
  static double Xza[];	/*                 :escQ.c */
  static double Xzq[];	/*                 :escQ.c */
  static double XB[];	/*                 :escQ.c */
  static double XBa[];	/*                 :escQ.c */
  static double XBq[];	/*                 :escQ.c */
  static double Xgh[];	/*                 :escQ.c */
  static double Xgha[];	/*                 :escQ.c */
  static double Xghq[];	/*                 :escQ.c */
/*
   */
#ifdef Doc_ESIget2DFunc
\Section{Skeleton of \c{ESIget2DFunc()}}
  \begin{verbatim}
    ESIget2DFunc(){
    }
  \end{verbatim}
\Section{\c{ESIget2DFunc()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{double }&\c{*r}&$$&\\
\c{double }&\c{*ra}&$$&\\
\c{double }&\c{*rq}&$$&\\
\c{double }&\c{*z}&$$&\\
\c{double }&\c{*za}&$$&\\
\c{double }&\c{*zq}&$$&\\
\c{double }&\c{*B}&$$&\\
\c{double }&\c{*Ba}&$$&\\
\c{double }&\c{*Bq}&$$&\\
\c{double }&\c{*gh}&$$&\\
\c{double }&\c{*gha}&$$&\\
\c{double }&\c{*ghq}&$$&\\
\c{double }&\c{a}&$$&\\
\c{double }&\c{gq}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{esiget2dfunctions_()}&$$&\\
\c{double }&\c{a}&$$&\\
\c{double }&\c{gq}&$$&\\
\c{double }&\c{*r}&$$&\\
\c{static double }&\c{Xr[]}&$$&\\
\c{double }&\c{*ra}&$$&\\
\c{static double }&\c{Xra[]}&$$&\\
\c{double }&\c{*rq}&$$&\\
\c{static double }&\c{Xrq[]}&$$&\\
\c{double }&\c{*z}&$$&\\
\c{static double }&\c{Xz[]}&$$&\\
\c{double }&\c{*za}&$$&\\
\c{static double }&\c{Xza[]}&$$&\\
\c{double }&\c{*zq}&$$&\\
\c{static double }&\c{Xzq[]}&$$&\\
\c{double }&\c{*B}&$$&\\
\c{static double }&\c{XB[]}&$$&\\
\c{double }&\c{*Ba}&$$&\\
\c{static double }&\c{XBa[]}&$$&\\
\c{double }&\c{*Bq}&$$&\\
\c{static double }&\c{XBq[]}&$$&\\
\c{double }&\c{*gh}&$$&\\
\c{static double }&\c{Xgh[]}&$$&\\
\c{double }&\c{*gha}&$$&\\
\c{static double }&\c{Xgha[]}&$$&\\
\c{double }&\c{*ghq}&$$&\\
\c{static double }&\c{Xghq[]}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int GCRKStep(X,h)
  double *X;	/*  */
  double h;	/*  */
{
  Undef gcmotion_();
  extern double cr2;	/* undefined */
  extern double cr6;	/* undefined */
  extern double cr3;	/* undefined */
  double *X;		/*  .GCRKStep():escQ.c */
  double h;		/*  .GCRKStep():escQ.c */
  static int nPart;	/*             :escQ.c */
  static double *RKgr1;	/*             :escQ.c */
  static double *dXgr;	/*             :escQ.c */
  static double *RKgr0;	/*             :escQ.c */
  static double *Xgr;	/*             :escQ.c */
  static double *RKa1;	/*             :escQ.c */
  static double *dXa;	/*             :escQ.c */
  static double *RKa0;	/*             :escQ.c */
  static double *Xa;	/*             :escQ.c */
  static double *RKgq1;	/*             :escQ.c */
  static double *dXgq;	/*             :escQ.c */
  static double *RKgq0;	/*             :escQ.c */
  static double *Xgq;	/*             :escQ.c */
  static double *RKgf1;	/*             :escQ.c */
  static double *dXgf;	/*             :escQ.c */
  static double *RKgf0;	/*             :escQ.c */
  static double *Xgf;	/*             :escQ.c */
  static double *RKgr2;	/*             :escQ.c */
  static double *RKa2;	/*             :escQ.c */
  static double *RKgq2;	/*             :escQ.c */
  static double *RKgf2;	/*             :escQ.c */
  static double *Xgm;	/*             :escQ.c */
  static double *RKgr3;	/*             :escQ.c */
  static double *RKa3;	/*             :escQ.c */
  static double *RKgq3;	/*             :escQ.c */
  static double *RKgf3;	/*             :escQ.c */
  static double *RKgr4;	/*             :escQ.c */
  static double *RKa4;	/*             :escQ.c */
  static double *RKgq4;	/*             :escQ.c */
  static double *RKgf4;	/*             :escQ.c */
/*
   */
#ifdef Doc_GCRKStep
\Section{Skeleton of \c{GCRKStep()}}
  \begin{verbatim}
    GCRKStep(){
    }
  \end{verbatim}
\Section{\c{GCRKStep()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{double }&\c{*X}&$$&\\
\c{double }&\c{h}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{gcmotion_()}&$$&\\
\c{extern double }&\c{cr2}&$$&\\
\c{extern double }&\c{cr6}&$$&\\
\c{extern double }&\c{cr3}&$$&\\
\c{double }&\c{*X}&$$&\\
\c{static int }&\c{nPart}&$$&\\
\c{static double }&\c{*RKgr1}&$$&\\
\c{double }&\c{h}&$$&\\
\c{static double }&\c{*dXgr}&$$&\\
\c{static double }&\c{*RKgr0}&$$&\\
\c{static double }&\c{*Xgr}&$$&\\
\c{static double }&\c{*RKa1}&$$&\\
\c{static double }&\c{*dXa}&$$&\\
\c{static double }&\c{*RKa0}&$$&\\
\c{static double }&\c{*Xa}&$$&\\
\c{static double }&\c{*RKgq1}&$$&\\
\c{static double }&\c{*dXgq}&$$&\\
\c{static double }&\c{*RKgq0}&$$&\\
\c{static double }&\c{*Xgq}&$$&\\
\c{static double }&\c{*RKgf1}&$$&\\
\c{static double }&\c{*dXgf}&$$&\\
\c{static double }&\c{*RKgf0}&$$&\\
\c{static double }&\c{*Xgf}&$$&\\
\c{static double }&\c{*RKgr2}&$$&\\
\c{static double }&\c{*RKa2}&$$&\\
\c{static double }&\c{*RKgq2}&$$&\\
\c{static double }&\c{*RKgf2}&$$&\\
\c{static double }&\c{*Xgm}&$$&\\
\c{static double }&\c{*RKgr3}&$$&\\
\c{static double }&\c{*RKa3}&$$&\\
\c{static double }&\c{*RKgq3}&$$&\\
\c{static double }&\c{*RKgf3}&$$&\\
\c{static double }&\c{*RKgr4}&$$&\\
\c{static double }&\c{*RKa4}&$$&\\
\c{static double }&\c{*RKgq4}&$$&\\
\c{static double }&\c{*RKgf4}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int ESBasicFunctions()
{
  extern double *ESaF;		/* undefined */
  extern double *ESaR0;		/* undefined */
  extern double *ESsb;		/* undefined */
  extern double *ESsb1a;	/* undefined */
  extern double *ESsb2a;	/* undefined */
  extern double *rcT2a;		/* undefined */
  extern double *rsT2a;		/* undefined */
  extern double *rcT1a;		/* undefined */
  extern int ESNa1;		/* undefined */
  extern double *rsT1a;		/* undefined */
  extern int ESFp1;		/* undefined */
  extern int ESNp1;		/* undefined */
  extern double *EScs1;		/* undefined */
  extern double *ESsn1;		/* undefined */
  extern int ESNp;		/* undefined */
  extern double *ESsra;		/* undefined */
  extern double *ESsrt;		/* undefined */
  extern double *ESsrat;	/* undefined */
  extern double *ESsza;		/* undefined */
  extern double *ESszt;		/* undefined */
  extern double *ESszat;	/* undefined */
  extern double *ESaB;		/* undefined */
  extern double *ESaBa;		/* undefined */
  extern double *ESaBt;		/* undefined */
  extern double *ESaBat;	/* undefined */
  extern double *ESgH;		/* undefined */
  extern double *ESgHt;		/* undefined */
  extern double *ESgHa;		/* undefined */
  extern double *ESgHat;	/* undefined */
  extern double *ESsa;		/* undefined */
  extern double *ESdgY;		/* undefined */
  extern double *ESdgY1a;	/* undefined */
  extern double *ESFF;		/* undefined */
  extern double *ESFF1a;	/* undefined */
  extern double *rcT;		/* undefined */
  extern double *ESaZ0;		/* undefined */
  extern double *rsT;		/* undefined */
  extern double *ESsz;		/* undefined */
  extern double *ESsr;		/* undefined */
/*
   */
#ifdef Doc_ESBasicFunctions
\Section{Skeleton of ESBasicFunctions()}
  \begin{verbatim}
    ESBasicFunctions(){
    }
  \end{verbatim}
\Section{ESBasicFunctions()}
Routine generates Bicubic spline coefficients for reconstruction in a
real space the geometry of an axisymmetric equilibrium configuraion. In
particular, the 1-D profiles and 2-D functions entering stability,
particle orbit, and gyrokinetic codes can be calculated at any point
inside the plasma without using the second derivatives of splines.

\Subsection{Set of Basic Equilibrium Functions}
In curvilinear coordinates $a,\gq,\gf$ the set of basic functions
consists of 5 following 1-D profiles 
\bqbl
&&
\baF(a)
,\R{\bgF'(a)}{a}
,\R{\bgY'(a)}{a}
,T(a)
,P(a)
,\qquad
T\equiv\R{\baF\baF'}{\bgY'}
,\quad
P\equiv\R{\bsp'}{\bgY'}
,\eqbl
and the 4 following 2-D functions 
\bqbl
r
=
R_0
+a\bsr(a,\gq)
,\quad
z
=
Z_0
+a\bsz(a,\gq)
,\quad
|B|
=
B(a,\gq)
,\quad
\gh
=
\gh(a,\gq)
,\quad
\gH
\equiv
\gh'_\gq
=
\R{\taL}{L_0}
\eqbl
and their first (including mixed) derivatives
\bqbl
&&
\baF'(a)
,\left(\R{\bgF'(a)}{a}\right)'
,\left(\R{\bgY'(a)}{a}\right)'
,T'
,P'
,\quad
r'_a,r'_\gq,r''_{a\gq}
,\quad
z'_a,z'_\gq,z''_{a\gq}
,\quad
B_a,B'_\gq,B''_{a\gq}
,\quad
\gH_a,\gH'_\gq,\gH''_{a\gq}
.\eqbl
Stored on the rectangular grid $a,\gq$, covering a certain domain inside
the equilibrium configuration, this set allows to reconstruct the basic
functions and their first derivatives at any point in the domain cells
by using Bicubic spline representation.

Note, that $B$ has been included into the set of basic functions despite
the fact that it can be expressed in terms of other basic functions and
their derivatives
\bqbl
&&
B^2
=
\R{g_{\gq\gq}}{g}\bgY^2
+\R{\baF^2}{r^2}
.\eqbl
The reason is that the first derivatives of $|B|$ is required for other
codes. 

Function $\gh$ is a complimentary function, which is necessary only in
the case of making transition to the ``straight'' field line coordinates.

\Subsection{At the origin}
\bqbl
\R{D}{a}
=
\baD_0
+a\baD_1
=
(r'_a+ar''_{aa})(z''_{a\gt}+az'''_{aa\gt}/2)
-(r''_{a\gt}+ar'''_{aa\gt}/2)(z'_a+az''_{aa})
,\\
\baD_0
=
r'_az''_{a\gt}
-r''_{a\gt}z'_a
,\quad
\baD_1
=
r''_{aa}z''_{a\gt}
-r''_{a\gt}z''_{aa}
+r'_az'''_{aa\gt}/2
-r'''_{aa\gt}z'_a/2
,\\
\R{L}{L_0}
=
\R{D}{r}
=
1+a\R{D_1}{D_0}-a\R{r'_a}{R_0}
,\quad
\gh'_\gq
=
a\R{D_1}{D_0}-a\R{r'_a}{R_0}
,\quad
\gh''_{a\gq}
=
\R{D_1}{D_0}-\R{r'_a}{R_0}
,\quad
\gh'''_{a\gq\gq}
=
\R{D'_{1\gq}}{D_0}-\R{r''_{a\gq}}{R_0}
,\\
\tgz'_\gq
=
\R{a\baF}{\bgY'}\R{\taL}{a}
=
\R{a\baF}{\bgY'}\left(\R{D_0+aD_1\taL}{R_0+ar'_a}-\R{D_0}{R_0}\right)
=
\R{a\baF}{\bgY'}a\left(\R{D_1\taL}{R_0}-\R{D_0r'_a}{R^2_0}\right)
.\eqbl

\Subsection{Geometry and metric coefficients}
The metric coefficients are calculated as 
\bqbl
&&
D
\equiv
z'_ar'_\gq-z'_\gq r'_a
,\quad
\q{g}
=
rD
,\quad
L
=
\R{D}{r}
,\\&&
K
=
\R{g_{\gq\gq}}{rD}
=
\R{r'^2_\gq+z'^2_\gq}{rD}
,\quad
N
=
\R{g_{a\gq}}{rD}
=
\R{r'_ar'_\gq+z'_az'_\gq}{rD}
,\quad
M
=
\R{g_{aa}}{rD}
=
\R{r'^2_a+z'^2_a}{rD}
.\eqbl
Basic vectors of curvilinear coordinates have the following
reprsentation in terms of first derivatives
\bqbl
&&
\na a=\R{r'_\gq\wse_z-z'_\gq\wse_r}{D}
,\quad
\na\gq=\R{z'_a\wse_r-r'_a\wse_z}{D}
,\\&&
\na a\times\na\gq
=
\R{\wse_\gf}{D}
,\quad
\na\gq\times\na\gf
=
\R{z'_a\wse_z+r'_a\wse_r}{rD}
,\quad
\na\gf\times\na a
=
\R{r'_\gq\wse_r+z'_\gq\wse_z}{rD}
.\eqbl

\Subsection{Magnetic field}
The vector potential has the form
\bqbl
&&
\waA
=
-\bgF'\gh\na a
+\bgF\na\gq
+\bgY\na\gf
,\qquad
\bgF'(1+\gh'_\gq)
=
L\baF
.\eqbl
The contravariant components of the magnetic field and the current
density are
\bqbl
&&
\waB
=
rDB^\gq(\na\gf\times\na a)
+rDB^\gf(\na a\times\na\gq)
,\qquad
B^\gq
=
-\R{\bgY'}{rD}
,\quad
B^\gf
=
\R{\baF}{r^2}
,\\&&
\gm_0\wsj
=
rD\bsj^\gq(\na\gf\times\na a)
+rD\bsj^\gf(\na a\times\na\gq)
,\qquad
\bsj^\gq
=
-\R{\baF'}{rD}
,\quad
\bsj^\gf
=
P+\R{1}{r^2}T
.\eqbl
Covariant components of the vector potential and the magnetic field
\bqbl
&&
\waB
=
B_a\na a
+B_\gq\na\gq
+B_\gf\na\gf
,\qquad
B_a
=
-N\bgY'
,\quad
B_\gq
=
-K\bgY'
,\quad
B_\gf
=
\baF
.\eqbl

\Subsection{Straight field line coordinates}
Transformation to the straight field line coordinates $a,\gq,\gz$ is
determined by 
\bqbl
&&
\gz=\gf-q\gh
,\quad
rD\waB\cdot\na\gz
=
L\baF-\bgF'\gh'_\gq
=
\bgF'(a)
,\quad
\gh'_\gq
=
\R{L}{L_0}-1
,\quad
\R{D(r,z,\gf)}{D(a,\gq,\gz)}
=
D
.\eqbl
In coordinates $a,\gq,\gz$
\bqbl
&&
\waA
=
\bgF\na\gq
+\bgY\na\gf
,\\&&
B^\gq
=
-\R{\bgY'}{rD}
,\quad
B^\gz
=
\R{\bgF'}{rD}
,\\&&
\bsj^\gq
=
-\R{\baF'}{rD}
,\quad
\bsj^\gz
=
\R{rDP-\R{\bgF'}{\baF}T}{rD}
,\eqbl
while the covariant components of the magnetic field
\bqbl
&&
\waB
=
(\baF(q\gh)'_a-N\bgY')\na a
+(q\baF\gh'_\gq-K\bgY')\na\gq
+\baF\na\gz
.\eqbl

\Subsection{Transition from ESC to Other coordinates}
Transition from ESC $(a,\gt,\gf)$ to new flux coordinates
$(a,\gq,\gf)$ are determined by derivative
\bqbl
\left.\R{\pa\gq}{\pa\gt}\right|_{a=const}
=
\gQ(a,\gt)
,\quad
\gQ_0
=
\R{1}{2\gp}\oint\gQ d\gt
=
1
,\eqbl
where $\gQ_0$ is the zeroth Fourier harmonic of $\gQ$. Then
\bqbl
&&
\gq
=
\gt+\int^\gt_0(\gQ-\gQ_0)d\gt
,\quad
\gq'_\gt
=
\gQ
,\quad
\gq'_a
=
\int^\gt_0\gQ'_ad\gt
,\quad
\gq''_{a\gt}
=
\gQ'_a
,\quad
\gq''_{\gt\gt}
=
\gQ'_\gt
.\eqbl
Derivatives of ESC coordinates in terms of new coordinates
\bqbl
d\gq=\gq'_ada+\gq'_\gt d\gt
,\quad
d\bsa=da
,\quad
\gq'_\gt d\gt=d\gq-\gq'_ad\bsa
,\quad
\gt'_\gq=\R{1}{\gQ}
,\quad
\gt'_\bsa=-\R{\gq'_a}{\gQ}
,\quad
\gt''_{\bsa\gq}=
-\R{\gQ'_a}{\gQ^2}
-\gt'_\bsa\R{\gQ'_\gt}{\gQ^2}
.\eqbl
Derivatives of functions of $(a,\gt,\gf)$ in terms of new coordinates
\bqbl
&&
f
=f(a,\gt)
=f(\bsa,\gt(\bsa,\gq))
,\quad
f'_\bsa
=
f'_\bsa
+f'_\gt\gt'_\bsa
,\quad
f'_\gq
=
f'_\gt\gt'_\gq
,\quad
f'_{a\gq}
=
f''_{a\gt}\gt'_\gq
+f''_{\gt\gt}\gt'_\gq\gt'_a
+f'_\gt\gt''_{a\gq}
.\eqbl
Behavior near the axis
\bqbl
\gQ
=
1+a\tgQ
,\quad
\gq'_a
=
\tgq+a\tgq'_a
,\quad
\tgq
\equiv
\int^\gt_0\tgQ d\gt
,\quad
\gq''_{a\gt}
=
\tgQ+a\tgQ'_a
,\quad
\gq''_{\gt\gt}
=
a\tgQ'_\gt
,\\
\gt'_\gq\simeq1
,\quad
\gt'_a\simeq-\tgq
,\quad
\gt''_{a\gq}=
-\tgQ
,\\
f'_a
\simeq
f'_a
-f'_\gt\tgq
,\quad
f'_\gq
\simeq
f'_\gt
,\quad
f'_{a\gq}
\simeq
f''_{a\gt}
-f''_{\gt\gt}\tgq
-f'_\gt\tgQ
.\eqbl
Straight field line coordinates
\bqbl
&&
\gz=\gf-q\gh
,\quad
\gh'_\gq
=
\R{\baL}{\baL_0}-1
,\quad
\baD
=
\R{D(r,z)}{D(a,\gq)}
=
\R{D}{\gQ}
,\quad
\baL_0
=
\R{1}{2\gp}\oint\R{\baD}{r}d\gq
=
L_0
,\quad
\gh'_\gq
=
\R{L}{\gQ L_0}-1
.\eqbl

\Subsection{PEST coordinates}
Definition of PEST $\gq$ coordinates
\bqbl
\R{D(z,r)}{D(\bsa,\gq)}=f(a)r
,\quad
D=f(a)r\gq'_\gt
,\quad
L\equiv\R{D}{r}
,\quad
\gq
=
\gt+\int^\gt_0\R{L-L_0}{L_0}d\gt
,\\
\gq'_\gt
=
\gQ
=\R{L}{L_0}
,\quad
\gq'_a
=
\int^\gt_0\left[\R{L}{L_0}\right]'_ad\gt
,\quad
\gq''_{a\gt}
=
\left[\R{L}{L_0}\right]'_a
,\quad
\gq''_{\gt\gt}
=
\R{L'_\gt}{L_0}
.\eqbl

\Subsection{Hamada coordinates}
Definition of Hamada $\gq$ coordinates
\bqbl
\R{D(z,r)}{D(\bsa,\gq)}=\R{f(a)}{r}
,\quad
D=\R{f(a)}{r}\gq'_\gt
,\quad
\gq'_\gt
=
\gQ
=\R{rD}{(rD)_0}
,\quad
\gq'_a
=
\int^\gt_0\left[\R{rD}{(rD)_0}\right]'_ad\gt
,\\
\gq''_{a\gt}
=
\left[\R{rD}{(rD)_0}\right]'_a
,\quad
\gq''_{\gt\gt}
=
\R{(rD)'_\gt}{(rD)_0}
.\eqbl

\Subsection{Boozer coordinates}
Definition of Boozer $\gq$ coordinates
\bqbl
\R{D(z,r)}{D(a,\gq)}=\R{f(a)}{rB^2}
,\quad
D=\R{f(a)}{rB^2}\gq'_\gt
,\quad
\gQ
=\R{rDB^2}{(rDB^2)_0}
,\quad
\gq'_a
=
\int^\gt_0\left[\R{rDB^2}{(rDB^2)_0}\right]'_ad\gt
,\\
\gq''_{a\gt}
=
\left[\R{rDB^2}{(rDB^2)_0}\right]'_a
,\quad
\gq''_{\gt\gt}
=
\R{(rDB^2)'_\gt}{(rDB^2)_0}
.\eqbl
Properties of Boozer coordinates
\bqbl
\waB
=
B_a\na a+B_\gt\na\gt+B_\gz\na\gz
=
(\gs'_a-\gn)\na a
+(\baJ+\gs'_\gt)\na\gt
+(\baF+\gs'_\gz)\na\gz
,\quad
\gs
=
0
,\\
B_\gt
=
q\baF\gh'_\gt-K\bgY'
=
q\baF\R{L-L_0}{L_0}-K\bgY'
,\quad
B^2
=
\R{g_{\gt\gt}\bgY'^2}{r^2D^2}
+\R{\baF^2}{r^2}
,\quad
r\baD B^2
=
-J\bgY'+F\bgF'
.\eqbl

\Subsection{Particle Orbits}
Guiding center Lagrangian
\bqbl
&&
\R{L}{\gW_c}
=
\left(\R{\waA}{B_0}+\gr_\parallel\waB\right)\cdot\wsv
-H
,\quad
H
\equiv
\gW_c\gr^2_\parallel\R{B^2}{2}
+c\R{\gF_E}{B_0}
+\gW_c\gm B
,\quad
\gm
\equiv
\R{v^2_\perp}{2B\gW^2_c}
,\quad
\gW_c
\equiv
\R{eB_0}{mc}
.\eqbl
Equations of drift motion
\begin{eqnarray}
&&
\left|
\begin{array}{l}
\db\d{\gr}_\parallel
\dd\d{a}
\dd\d{\gq}
\dd\d{\gf}
\end{array}
\right|
=
\left|
\begin{array}{rrrr}
\db0
\da0
\da \R{a_{22}}{D}
\da -\R{a_{12}}{D}
\dd0
\da0
\da -\R{a_{21}}{D}
\da \R{a_{11}}{D}
\dd \R{a_{22}}{D}
\da -\R{a_{21}}{D}
\da0
\da-\R{B_a}{D}
\dd -\R{a_{12}}{D}
\da \R{a_{11}}{D}
\da\R{B_a}{D}
\da0
\end{array}
\right|
\cdot
\left|
\begin{array}{r}
\db\R{\pa H}{\pa\gr_\parallel}
\dd\R{\pa H}{\pa a}
\dd-\R{\pa H}{\pa\gq}
\dd-\R{\pa H}{\pa\gf}
\end{array}
\right|
,\end{eqnarray}
where
\bqbl
&&
a_{11}
\equiv
I+\gs'_\gq
,\quad
a_{12}
\equiv
\bgF'+\gh'_\gq+\gr_\parallel(I'+\gn'_\gq)
,\\&&
a_{21}
\equiv
F+\gs'_\gf
,\quad
a_{22}
\equiv
\bgY'+\gh'_\gf+\gr_\parallel(F'+\gn'_\gf)
,\\&&
D
\equiv
a_{11}a_{22}-a_{12}a_{21}
.\eqbl
For axysimmetric case
\begin{eqnarray}
&&
\left|
\begin{array}{l}
\db\d{\gr}_\parallel
\dd\d{a}
\dd\d{\gq}
\dd\d{\gf}
\end{array}
\right|
=
\left|
\begin{array}{rrr}
\db0
\da0
\da \R{a_{22}}{D}
\dd0
\da0
\da -\R{a_{21}}{D}
\dd \R{a_{22}}{D}
\da -\R{a_{21}}{D}
\da0
\dd -\R{a_{12}}{D}
\da \R{a_{11}}{D}
\da\R{B_a}{D}
\end{array}
\right|
\cdot
\left|
\begin{array}{r}
\db\R{\pa H}{\pa\gr_\parallel}
\dd\R{\pa H}{\pa a}
\dd-\R{\pa H}{\pa\gq}
\end{array}
\right|
,\\&&
B_a
=
-N\bgY'
,\quad
B^2
=
\R{K\bgY'^2}{\q{g}}+\R{\baF^2}{r^2}
,\\&&
a_{11}
=
-K\bgY'
,\quad
a_{21}
=
F
,\quad
a_{12}
=
L\baF+\gr_\parallel\left(rDP+LT\right)
,\quad
a_{22}
=
\bgY'+\gr_\parallel\baF'
.\end{eqnarray}

\Subsection{Curvature of the magnetic field lines}
The curvature of the magnetic field lines is determined as
\bqbl
&&
\wsk
\equiv
\left(\R{\waB}{B}\cdot\na\right)\R{\waB}{B}
=
-\left(\R{\waB}{B}\times\left(\na\times\R{\waB}{B}\right)\right)
=
\R{\bsp'}{B^2}\na a
-\R{(B^\gq B'_\gq)}{B^3}\waB
+\R{B'_a}{B}\na a
+\R{B'_\gq}{B}\na\gq
\eqbl
and can be calculated using basic set of functions in a straigtforward way.
#endif
}

int ESWriteESI0()
{
  Undef fwrite();
  Undef int;
  Undef fputs();
  Undef fputc();
  Undef splA1a();
  Undef esiread_();
  extern int ESNp1;		/* undefined */
  extern time_t time();		/* undefined */
  extern struct tm *localtime();/* undefined */
  extern int ESNa;		/* undefined */
  extern int ESNa1;		/* undefined */
  extern double *ESgt;		/* undefined */
  extern double *ESsa;		/* undefined */
  extern double *ESaF;		/* undefined */
  extern double *ESaF1a;	/* undefined */
  extern double *ESaR0;		/* undefined */
  extern double *ESLc;		/* undefined */
  extern double *ESLc1;		/* undefined */
  extern double *ESdgY;		/* undefined */
  extern double *ESdgY1a;	/* undefined */
  extern double *ESaT;		/* undefined */
  extern double *ESaT2a;	/* undefined */
  extern double *ESPs;		/* undefined */
  extern double *ESPs1a;	/* undefined */
  extern double *ESaT1a;	/* undefined */
  extern double *ESsr;		/* undefined */
  extern double *ESsra;		/* undefined */
  extern double *ESsrt;		/* undefined */
  extern double *ESsrat;	/* undefined */
  extern double *ESsz;		/* undefined */
  extern double *ESsza;		/* undefined */
  extern double *ESszt;		/* undefined */
  extern double *ESszat;	/* undefined */
  extern double *ESaB;		/* undefined */
  extern double *ESaBa;		/* undefined */
  extern double *ESaBt;		/* undefined */
  extern double *ESaBat;	/* undefined */
  extern double *ESgH;		/* undefined */
  extern double *ESgHa;		/* undefined */
  extern double *ESgHt;		/* undefined */
  extern double *ESgHat;	/* undefined */
  extern double cgm0;		/* undefined */
  extern double *ESVc;		/* undefined */
  extern double *ESsp;		/* undefined */
  extern double cr4;		/* undefined */
  extern double *ESpa;		/* undefined */
  extern double c2gp;		/* undefined */
  extern double *ESsp1a;	/* undefined */
  int ESIWriteDensity();	/* No prototype */
  static time_t stTime;	/*  :escQ.c */
  static struct tm *ltm;/*  :escQ.c */
  int ESIWriteDensity();/*  :escQ.c */
/*
   */
#ifdef Doc_ESWriteESI0
\Section{Skeleton of \c{ESWriteESI0()}}
  \begin{verbatim}
    ESWriteESI0(){
    }
  \end{verbatim}
\Section{\c{ESWriteESI0()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{fwrite()}&$$&\\
\c{Undef }&\c{int}&$$&\\
\c{Undef }&\c{fputs()}&$$&\\
\c{Undef }&\c{fputc()}&$$&\\
\c{Undef }&\c{splA1a()}&$$&\\
\c{Undef }&\c{esiread_()}&$$&\\
\c{extern int }&\c{ESNp1}&$$&\\
\c{extern time_t }&\c{time()}&$$&\\
\c{extern struct tm }&\c{*localtime()}&$$&\\
\c{extern int }&\c{ESNa}&$$&\\
\c{extern int }&\c{ESNa1}&$$&\\
\c{extern double }&\c{*ESgt}&$$&\\
\c{extern double }&\c{*ESsa}&$$&\\
\c{extern double }&\c{*ESaF}&$$&\\
\c{extern double }&\c{*ESaF1a}&$$&\\
\c{extern double }&\c{*ESaR0}&$$&\\
\c{extern double }&\c{*ESLc}&$$&\\
\c{extern double }&\c{*ESLc1}&$$&\\
\c{extern double }&\c{*ESdgY}&$$&\\
\c{extern double }&\c{*ESdgY1a}&$$&\\
\c{extern double }&\c{*ESaT}&$$&\\
\c{extern double }&\c{*ESaT2a}&$$&\\
\c{extern double }&\c{*ESPs}&$$&\\
\c{extern double }&\c{*ESPs1a}&$$&\\
\c{extern double }&\c{*ESaT1a}&$$&\\
\c{extern double }&\c{*ESsr}&$$&\\
\c{extern double }&\c{*ESsra}&$$&\\
\c{extern double }&\c{*ESsrt}&$$&\\
\c{extern double }&\c{*ESsrat}&$$&\\
\c{extern double }&\c{*ESsz}&$$&\\
\c{extern double }&\c{*ESsza}&$$&\\
\c{extern double }&\c{*ESszt}&$$&\\
\c{extern double }&\c{*ESszat}&$$&\\
\c{extern double }&\c{*ESaB}&$$&\\
\c{extern double }&\c{*ESaBa}&$$&\\
\c{extern double }&\c{*ESaBt}&$$&\\
\c{extern double }&\c{*ESaBat}&$$&\\
\c{extern double }&\c{*ESgH}&$$&\\
\c{extern double }&\c{*ESgHa}&$$&\\
\c{extern double }&\c{*ESgHt}&$$&\\
\c{extern double }&\c{*ESgHat}&$$&\\
\c{extern double }&\c{cgm0}&$$&\\
\c{extern double }&\c{*ESVc}&$$&\\
\c{extern double }&\c{*ESsp}&$$&\\
\c{extern double }&\c{cr4}&$$&\\
\c{extern double }&\c{*ESpa}&$$&\\
\c{extern double }&\c{c2gp}&$$&\\
\c{extern double }&\c{*ESsp1a}&$$&\\
\c{int }&\c{ESIWriteDensity()}&$$&\\
\c{static time_t }&\c{stTime}&$$&\\
\c{static struct tm }&\c{*ltm}&$$&\\
\c{int }&\c{ESIWriteDensity()}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int ESWriteESI(CoordNm,sr,sz,aB,gH,Na,Np)
  char *CoordNm;	/*  */
  double *sr;		/*  */
  double *sz;		/*  */
  double *aB;		/*  */
  double *gH;		/*  */
  int Na;		/*  */
  int Np;		/*  */
{
  Undef fputs();
  Undef fputc();
  Undef ESSetSplA();
  Undef splRA();
  Undef esiread_();
  extern double *ESsa;		/* undefined */
  extern int ESNa;		/* undefined */
  extern time_t time();		/* undefined */
  extern struct tm *localtime();/* undefined */
  extern double *ESaR0;		/* undefined */
  extern double *ESFF;		/* undefined */
  extern double *ESFF2a;	/* undefined */
  extern double *ESdgY;		/* undefined */
  extern double *ESdgY2a;	/* undefined */
  extern double *ESLc;		/* undefined */
  extern double *ESLc2;		/* undefined */
  extern double *ESaT;		/* undefined */
  extern double *ESaT2a;	/* undefined */
  extern double *ESPs;		/* undefined */
  extern double *ESPs2a;	/* undefined */
  extern double *ESVc;		/* undefined */
  extern double *ESsp;		/* undefined */
  extern double *ESVc2;		/* undefined */
  extern double *ESsp2a;	/* undefined */
  int Na;		/*  .ESWriteESI():escQ.c */
  int Np;		/*  .ESWriteESI():escQ.c */
  double *sr;		/*  .ESWriteESI():escQ.c */
  double *sz;		/*  .ESWriteESI():escQ.c */
  double *aB;		/*  .ESWriteESI():escQ.c */
  double *gH;		/*  .ESWriteESI():escQ.c */
  char *CoordNm;	/*  .ESWriteESI():escQ.c */
  static time_t stTime;	/*               :escQ.c */
  static struct tm *ltm;/*               :escQ.c */
/*
   */
#ifdef Doc_ESWriteESI
\Section{Skeleton of \c{ESWriteESI()}}
  \begin{verbatim}
    ESWriteESI(){
    }
  \end{verbatim}
\Section{\c{ESWriteESI()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{char }&\c{*CoordNm}&$$&\\
\c{double }&\c{*sr}&$$&\\
\c{double }&\c{*sz}&$$&\\
\c{double }&\c{*aB}&$$&\\
\c{double }&\c{*gH}&$$&\\
\c{int }&\c{Na}&$$&\\
\c{int }&\c{Np}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{fputs()}&$$&\\
\c{Undef }&\c{fputc()}&$$&\\
\c{Undef }&\c{ESSetSplA()}&$$&\\
\c{Undef }&\c{splRA()}&$$&\\
\c{Undef }&\c{esiread_()}&$$&\\
\c{extern double }&\c{*ESsa}&$$&\\
\c{extern int }&\c{ESNa}&$$&\\
\c{extern time_t }&\c{time()}&$$&\\
\c{extern struct tm }&\c{*localtime()}&$$&\\
\c{extern double }&\c{*ESaR0}&$$&\\
\c{extern double }&\c{*ESFF}&$$&\\
\c{extern double }&\c{*ESFF2a}&$$&\\
\c{extern double }&\c{*ESdgY}&$$&\\
\c{extern double }&\c{*ESdgY2a}&$$&\\
\c{extern double }&\c{*ESLc}&$$&\\
\c{extern double }&\c{*ESLc2}&$$&\\
\c{extern double }&\c{*ESaT}&$$&\\
\c{extern double }&\c{*ESaT2a}&$$&\\
\c{extern double }&\c{*ESPs}&$$&\\
\c{extern double }&\c{*ESPs2a}&$$&\\
\c{extern double }&\c{*ESVc}&$$&\\
\c{extern double }&\c{*ESsp}&$$&\\
\c{extern double }&\c{*ESVc2}&$$&\\
\c{extern double }&\c{*ESsp2a}&$$&\\
\c{int }&\c{Na}&$$&\\
\c{int }&\c{Np}&$$&\\
\c{double }&\c{*sr}&$$&\\
\c{double }&\c{*sz}&$$&\\
\c{double }&\c{*aB}&$$&\\
\c{double }&\c{*gH}&$$&\\
\c{char }&\c{*CoordNm}&$$&\\
\c{static time_t }&\c{stTime}&$$&\\
\c{static struct tm }&\c{*ltm}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int ESBasicFunctionsPEST(Na,Np)
  int Na;	/*  */
  int Np;	/*  */
{
  Undef ESSetSplA();
  Undef splRA();
  Undef splRA2();
  Undef ESP2F();
  extern double *ESsa;		/* undefined */
  extern int ESNa;		/* undefined */
  extern int ESNa1;		/* undefined */
  extern double *rcT1a;		/* undefined */
  extern double *rsT1a;		/* undefined */
  extern double *ESsb1a;	/* undefined */
  extern double *ESaF;		/* undefined */
  extern double *ESaR0;		/* undefined */
  extern double *ESaZ0;		/* undefined */
  extern double *ESFF;		/* undefined */
  extern double *ESFF2a;	/* undefined */
  extern double *ESdgY;		/* undefined */
  extern double *ESdgY2a;	/* undefined */
  extern double *ESsb;		/* undefined */
  extern double *ESsb2a;	/* undefined */
  extern double *rcT;		/* undefined */
  extern double *rcT2a;		/* undefined */
  extern double *rsT;		/* undefined */
  extern double *rsT2a;		/* undefined */
  extern int ESFp1;		/* undefined */
  extern int ESNp;		/* undefined */
  extern double *EScs1;		/* undefined */
  extern double *ESsn1;		/* undefined */
  extern int ESFp;		/* undefined */
  int Np;		/*  .ESBasicFunctionsPEST():escQ.c */
  int Na;		/*  .ESBasicFunctionsPEST():escQ.c */
  int ESWriteESI();	/*                         :escQ.c */
/*
   */
#ifdef Doc_ESBasicFunctionsPEST
\Section{Skeleton of ESBasicFunctionsPEST()}
  \begin{verbatim}
    ESBasicFunctionsPEST(){
    }
  \end{verbatim}

\Section{ESBasicFunctionsPEST()}
Routine generates Bicubic spline coefficients for reconstruction in a
real space the geometry of an axisymmetric equilibrium configuration. In
particular, the 1-D profiles and 2-D functions entering stability,
particle orbit, and gyrokinetic codes can be calculated at any point
inside the plasma without using the second derivatives of splines.

\Subsection{Set of Basic Equilibrium Functions}
In curvilinear coordinates $a,\gq,\gf$ the set of basic functions
consists of 5 following 1-D profiles 
\bqbl
&&
\baF(a)
,\R{\bgF'(a)}{a}
,\R{\bgY'(a)}{a}
,T(a)
,P(a)
,\qquad
T\equiv\R{\baF\baF'}{\bgY'}
,\quad
P\equiv\R{\bsp'}{\bgY'}
,\eqbl
and the 4 following 2-D functions 
\bqbl
&&
r
=
r(a,\gq)
,\quad
z
=
z(a,\gq)
,\quad
|B|
=
B(a,\gq)
,\quad
\gH
\equiv
\gh'_\gq(a,\gq)
=
\R{L}{L_0}-1
\eqbl
and their first (including mixed) derivatives
\bqbl
&&
\baF'(a)
,\left(\R{\bgF'(a)}{a}\right)'
,\left(\R{\bgY'(a)}{a}\right)'
,T'
,P'
,\quad
r'_a,r'_\gq,r''_{a\gq}
,\quad
z'_a,z'_\gq,z''_{a\gq}
,\quad
B_a,B'_\gq,B''_{a\gq}
,\quad
\gH_a,\gH'_\gq,\gH''_{a\gq}
.\eqbl
Stored on the rectangular grid $a,\gq$, covering a certain domain inside
the equilibrium configuration, this set allows to reconstruct the basic
functions and their first derivatives at any point in the domain cells
by using Bicubic spline representation.

Note, that $B$ has been included into the set of basic functions despite
the fact that it can be expressed in terms of other basic functions and
their derivatives
\bqbl
&&
B^2
=
\R{g_{\gq\gq}}{g}\bgY^2
+\R{\baF^2}{r^2}
.\eqbl
The reason is that the first derivatives of $|B|$ is required for other
codes. 

Function $\gh$ is a complimentary function, which is necessary only in
the case of making transition to the ``straight'' field line coordinates.

\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{int }&\c{Na}&$$&\\
\c{int }&\c{Np}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsubsection{Definition of PEST coordinates}
\bqbl
&&
\gq'_\gt
=
\R{L}{L_0}
,\quad
L
=
\R{D}{r}
,\quad
\gq
=
\gt+\int^\gt_0\R{L}{L_0}d\gt
,\\&&
\gQ
\equiv
\gq'_\gt
=
\R{L}{L_0}
,\quad
\gq'_a
=
\int^\gt_0\left[\R{L}{L_0}\right]'_ad\gt
,\quad
\gq''_{a\gt}
=
\left[\R{L}{L_0}\right]'_a
,\quad
\gq''_{\gt\gt}
=
\R{L'_\gt}{L_0}
.\eqbl
Derivatives of ESC coordinates in terms of PEST coordinates
\bqbl
&&
d\gq=\gq'_ada+\gq'_\gt d\gt
,\quad
\gt'_\gq=\R{1}{\gq'_\gt}
,\quad
\gt'_a=-\R{\gq'_a}{\gq'_\gt}
,\quad
\gt''_{a\gq}
=
-\R{\gq''_{a\gt}}{\gq'^2_\gt}
+\R{\gq'_a\gq''_{\gt\gt}}{\gq'^3_\gt}
=
-\R{\gq''_{a\gt}+\gt'_a\gq''_{\gt\gt}}{\gQ^2}
.\eqbl
Derivatives in PEST coordinates in terms of derivatives in ESC coordinates
\bqbl
&&
f=f(a,\gt(a,\gq))
,\quad
f'_a
=
f'_a
+f'_\gt\gt'_a
,\quad
f'_\gq
=
f'_\gt\gt'_\gq
,\\&&
f'_{a\gq}
=
f''_{a\gt}\gt'_\gq
+f''_{\gt\gt}\gt'_\gq\gt'_a
+f'_\gt\gt''_{a\gq}
.\eqbl
Behavior near the axis
\bqbl
&&
\R{D(z,r)}{D(a,\gq)}=f(a)r
,\quad
\R{D(z,r)}{D(a,\gt)}=f(a)r\gq'_\gt
,\quad
\gq
=
\gt+a\tgq
,\\&&
\gq'_\gt
=
1+a\tgq'_\gt
,\quad
\gq'_a
=
\tgq+a\tgq'_a
,\quad
\gq''_{a\gt}
=
\tgq'_\gt+a\tgq''_{a\gt}
,\quad
\gq''_{\gt\gt}
=
a\tgq''_{\gt\gt}
,\\&&
\gt'_\gq\simeq1
,\quad
\gt'_a\simeq-\tgq
,\quad
\gt''_{a\gq}=
-\tgq'_\gt
,\\&&
f'_a
\simeq
f'_a
-f'_\gt\tgq
,\quad
f'_\gq
\simeq
f'_\gt
,\\&&
f'_{a\gq}
\simeq
f''_{a\gt}
-f''_{\gt\gt}\tgq
-f'_\gt\tgq'_\gt
.\eqbl

\Subsubsection{Calculation of derivatives}
Necessary derivatives are calculated as
\bqbl
&&
K=\R{1}{r^2}
,\quad
K'_a=-\R{2r'_a}{r^3}
,\quad
K'_\gt=-\R{2r'_\gt}{r^3}
,\quad
K''_{a\gt}=-\R{2r''_{a\gt}}{r^3}+\R{6r'_ar'_\gt}{r^4}
,\quad
K''_{\gt\gt}=-\R{2r''_{\gt\gt}}{r^3}+\R{6r'^2_\gt}{r^4}
,\\&&
G=\R{1}{D^2}
,\quad
G'_a=-\R{2D'_a}{D^3}
,\quad
G'_\gt=-\R{2D'_\gt}{D^3}
,\quad
G''_{a\gt}=-\R{2D''_{a\gt}}{D^3}+\R{6D'_aD'_\gt}{D^4}
,\quad
G''_{\gt\gt}=-\R{2D''_{\gt\gt}}{D^3}+\R{6D'^2_\gt}{D^4}
,\\&&
D=KG
,\quad
D'_a=K'_aG+KG'_a
,\quad
D'_\gt=K'_\gt G+KG'_\gt
,\\&&
D'_{a\gt}=K''_{a\gt}G+K'_\gt G'_a+K'_aG'_\gt+KG''_{a\gt}
,\quad
D'_{\gt\gt}=K''_{\gt\gt}G+2K'_\gt G'_\gt+KG''_{\gt\gt}
.\eqbl

\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{ESSetSplA()}&$$&\\
\c{Undef }&\c{splRA()}&$$&\\
\c{Undef }&\c{splRA2()}&$$&\\
\c{Undef }&\c{ESP2F()}&$$&\\
\c{Undef }&\c{ESWriteESI()}&$$&\\
\c{extern double }&\c{*ESsa}&$$&\\
\c{extern int }&\c{ESNa}&$$&\\
\c{extern int }&\c{ESNa1}&$$&\\
\c{extern double }&\c{*rcT1a}&$$&\\
\c{extern double }&\c{*rsT1a}&$$&\\
\c{extern double }&\c{*ESsb1a}&$$&\\
\c{extern double }&\c{*ESaF}&$$&\\
\c{extern double }&\c{*ESaR0}&$$&\\
\c{extern double }&\c{*ESaZ0}&$$&\\
\c{extern double }&\c{*ESFF}&$$&\\
\c{extern double }&\c{*ESFF2a}&$$&\\
\c{extern double }&\c{*ESdgY}&$$&\\
\c{extern double }&\c{*ESdgY2a}&$$&\\
\c{extern double }&\c{*ESsb}&$$&\\
\c{extern double }&\c{*ESsb2a}&$$&\\
\c{extern double }&\c{*rcT}&$$&\\
\c{extern double }&\c{*rcT2a}&$$&\\
\c{extern double }&\c{*rsT}&$$&\\
\c{extern double }&\c{*rsT2a}&$$&\\
\c{extern int }&\c{ESFp1}&$$&\\
\c{extern int }&\c{ESNp}&$$&\\
\c{extern double }&\c{*EScs1}&$$&\\
\c{extern double }&\c{*ESsn1}&$$&\\
\c{int }&\c{Np}&$$&\\
\c{int }&\c{Na}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}

#endif
}

int ES2PEST(R,Z,Na,Np)
  double *R;	/*  */
  double *Z;	/*  */
  int Na;	/*  */
  int Np;	/*  */
{
  Undef ESSetSplA();
  Undef splRA();
  Undef ESP2F();
  extern double *ESsa;	/* undefined */
  extern int ESNa;	/* undefined */
  extern double *ESaR0;	/* undefined */
  extern double *ESaZ0;	/* undefined */
  extern double *ESsb;	/* undefined */
  extern double *ESsb2a;/* undefined */
  extern double *rcT;	/* undefined */
  extern double *rcT2a;	/* undefined */
  extern double *rsT;	/* undefined */
  extern double *rsT2a;	/* undefined */
  extern int ESFp1;	/* undefined */
  extern int ESNa1;	/* undefined */
  extern int ESNp;	/* undefined */
  extern double *EScs1;	/* undefined */
  extern double *ESsn1;	/* undefined */
  extern int ESFp;	/* undefined */
  int Na;	/*  .ES2PEST():escQ.c */
  int Np;	/*  .ES2PEST():escQ.c */
  double *R;	/*  .ES2PEST():escQ.c */
  double *Z;	/*  .ES2PEST():escQ.c */
/*
   */
#ifdef Doc_ES2PEST
\Section{Skeleton of \c{ES2PEST()}}
  \begin{verbatim}
    ES2PEST(){
    }
  \end{verbatim}
\Section{\c{ES2PEST()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{double }&\c{*R}&$$&\\
\c{double }&\c{*Z}&$$&\\
\c{int }&\c{Na}&$$&\\
\c{int }&\c{Np}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{ESSetSplA()}&$$&\\
\c{Undef }&\c{splRA()}&$$&\\
\c{Undef }&\c{ESP2F()}&$$&\\
\c{extern double }&\c{*ESsa}&$$&\\
\c{extern int }&\c{ESNa}&$$&\\
\c{extern double }&\c{*ESaR0}&$$&\\
\c{extern double }&\c{*ESaZ0}&$$&\\
\c{extern double }&\c{*ESsb}&$$&\\
\c{extern double }&\c{*ESsb2a}&$$&\\
\c{extern double }&\c{*rcT}&$$&\\
\c{extern double }&\c{*rcT2a}&$$&\\
\c{extern double }&\c{*rsT}&$$&\\
\c{extern double }&\c{*rsT2a}&$$&\\
\c{extern int }&\c{ESFp1}&$$&\\
\c{extern int }&\c{ESNa1}&$$&\\
\c{extern int }&\c{ESNp}&$$&\\
\c{extern double }&\c{*EScs1}&$$&\\
\c{extern double }&\c{*ESsn1}&$$&\\
\c{extern int }&\c{ESFp}&$$&\\
\c{int }&\c{Na}&$$&\\
\c{int }&\c{Np}&$$&\\
\c{double }&\c{*R}&$$&\\
\c{double }&\c{*Z}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int ESBasicFunctionsHamada(Na,Np)
  int Na;	/*  */
  int Np;	/*  */
{
  Undef ESSetSplA();
  Undef splRA();
  Undef splRA2();
  Undef ESP2F();
  extern double *ESsa;		/* undefined */
  extern int ESNa;		/* undefined */
  extern int ESNa1;		/* undefined */
  extern double *rcT1a;		/* undefined */
  extern double *rsT1a;		/* undefined */
  extern double *ESsb1a;	/* undefined */
  extern double *ESaF;		/* undefined */
  extern double *ESaR0;		/* undefined */
  extern double *ESaZ0;		/* undefined */
  extern double *ESLc;		/* undefined */
  extern double *ESLc2;		/* undefined */
  extern double *ESFF;		/* undefined */
  extern double *ESFF2a;	/* undefined */
  extern double *ESdgY;		/* undefined */
  extern double *ESdgY2a;	/* undefined */
  extern double *ESsb;		/* undefined */
  extern double *ESsb2a;	/* undefined */
  extern double *rcT;		/* undefined */
  extern double *rcT2a;		/* undefined */
  extern double *rsT;		/* undefined */
  extern double *rsT2a;		/* undefined */
  extern int ESFp1;		/* undefined */
  extern int ESNp;		/* undefined */
  extern double *EScs1;		/* undefined */
  extern double *ESsn1;		/* undefined */
  extern int ESFp;		/* undefined */
  int Np;		/*  .ESBasicFunctionsHamada():escQ.c */
  int Na;		/*  .ESBasicFunctionsHamada():escQ.c */
  int ESWriteESI();	/*                           :escQ.c */
/*
   */
#ifdef Doc_ESBasicFunctionsHamada
\Section{Skeleton of \c{ESBasicFunctionsHamada()}}
  \begin{verbatim}
    ESBasicFunctionsHamada(){
    }
  \end{verbatim}
\Section{\c{ESBasicFunctionsHamada()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{int }&\c{Na}&$$&\\
\c{int }&\c{Np}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}

\Subsection{Description}
\Subsubsection{Definition of Hamada coordinates}
\bqbl
\R{D(z,r)}{D(\bsa,\gq)}=\R{f(a)}{r}
,\quad
D=\R{f(a)}{r}\gq'_\gt
,\quad
\gq'_\gt
=
\gQ
=\R{V}{V_0}
,\quad
V
\equiv
rD
,\quad
\gq'_a
=
\int^\gt_0\left[\R{V}{V_0}\right]'_ad\gt
,\\
\gq''_{a\gt}
=
\left[\R{V}{V_0}\right]'_a
,\quad
\gq''_{\gt\gt}
=
\R{(rD)'_\gt}{(rD)_0}
.\eqbl
Derivatives
\bqbl
V'_a
=
r'_aD
+rD'_a
,\quad
D
=
r'_az'_\gt-r'_\gt z'_a
,\quad
D'_a
=
r''_{aa}z'_\gt+r'_az''_{a\gt}-r''_{a\gt} z'_a-r'_\gt z''_{aa}
,\\
L
=
\R{D}{r}
,\quad
L'_a
=
\R{D'_a}{r}
-L\R{r'_a}{r}
.\eqbl

\Subsubsection{Basic 2-D functions}
Transition from ESC $(a,\gt,\gf)$ to new flux coordinates
$(a,\gq,\gf)$ are determined by derivative
angle
\bqbl
\left.\R{\pa\gq}{\pa\gt}\right|_{a=const}
=
\gQ(a,\gt)
,\quad
\gQ_0
=
\R{1}{2\gp}\oint\gQ d\gt
=
1
,\eqbl
where $\gQ_0$ is the zeroth Fourier harmonic of $\gQ$. Then
\bqbl
&&
\gq
=
\gt+\int^\gt_0(\gQ-\gQ_0)d\gt
,\quad
\gq'_\gt
=
\gQ
,\quad
\gq'_a
=
\int^\gt_0\gQ'_ad\gt
,\quad
\gq''_{a\gt}
=
\gQ'_a
,\quad
\gq''_{\gt\gt}
=
\gQ'_\gt
.\eqbl
Derivatives of ESC coordinates in terms of new coordinates
\bqbl
d\gq=\gq'_ada+\gq'_\gt d\gt
,\quad
d\bsa=da
,\quad
\gq'_\gt d\gt=d\gq-\gq'_ad\bsa
,\quad
\gt'_\gq=\R{1}{\gQ}
,\quad
\gt'_\bsa=-\R{\gq'_a}{\gQ}
,\quad
\gt''_{\bsa\gq}=
-\R{\gQ'_a}{\gQ^2}
+\R{\gq'_a\gQ'_\gt}{\gQ^3}
.\eqbl
Basic functions and their derivatives
\bqbl
r
=r(a,\gt)
=r(\bsa,\gt(\bsa,\gq))
,\quad
r'_\bsa
=
r'_\bsa
+r'_\gt\gt'_\bsa
,\quad
r'_\gq
=
r'_\gt\gt'_\gq
,\quad
r'_{a\gq}
=
r''_{a\gt}\gt'_\gq
+r''_{\gt\gt}\gt'_\gq\gt'_a
+r'_\gt\gt''_{a\gq}
,\\
z
=z(a,\gt)
=z(\bsa,\gt(\bsa,\gq))
,\quad
z'_\bsa
=
z'_\bsa
+z'_\gt\gt'_\bsa
,\quad
z'_\gq
=
z'_\gt\gt'_\gq
,\quad
z'_{a\gq}
=
z''_{a\gt}\gt'_\gq
+z''_{\gt\gt}\gt'_\gq\gt'_a
+z'_\gt\gt''_{a\gq}
,\\
B
=
\q{B^2}
,\quad
B'_a
=
\R{(B^2)'_a}{2B}
,\quad
B'_\gt
=
\R{(B^2)'_\gt}{2B}
,\quad
B''_{a\gt}
=
\R{(B^2)''_{a\gt}}{2B}
-\R{B'_\gt B'_a}{B}
,\quad
B''_{\gt\gt}
=
\R{(B^2)''_{\gt\gt}}{2B}
-\R{B'^2_\gt}{B}
,\\
B
=B(a,\gt)
=B(\bsa,\gt(\bsa,\gq))
,\quad
B'_\bsa
=
B'_\bsa
+B'_\gt\gt'_\bsa
,\quad
B'_\gq
=
B'_\gt\gt'_\gq
,\quad
B'_{a\gq}
=
B''_{a\gt}\gt'_\gq
+B''_{\gt\gt}\gt'_\gq\gt'_a
+B'_\gt\gt''_{a\gq}
,\\
\gH\equiv\gh'_\gq
=
\R{L}{\gQ L_0}-1
,\quad
\R{L}{\gQ L_0}-1
,\\
\gH
=\gH(a,\gt)
,\quad
\gH'_\bsa
=
\gH'_\bsa
+\gH'_\gt\gt'_\bsa
,\quad
\gH'_\gq
=
\gH'_\gt\gt'_\gq
,\quad
\gH'_{a\gq}
=
\gH''_{a\gt}\gt'_\gq
+\gH''_{\gt\gt}\gt'_\gq\gt'_a
+\gH'_\gt\gt''_{a\gq}
.\eqbl

Behavior near the axis
\bqbl
V
=
rD
,\quad
\gQ
=
\R{V}{V_0}
,\\
\gQ
=
1+a\tgQ
,\quad
\gq'_a
=
\tgq+a\tgq'_a
,\quad
\tgq
\equiv
\int^\gt_0\tgQ d\gt
,\quad
\gq''_{a\gt}
=
\tgQ+a\tgQ'_a
,\quad
\gq''_{\gt\gt}
=
a\tgQ'_\gt
,\\
\gt'_\gq\simeq1
,\quad
\gt'_a\simeq-\tgq
,\quad
\gt''_{a\gq}=
-\tgQ
,\\
f'_a
\simeq
f'_a
-f'_\gt\tgq
,\quad
f'_\gq
\simeq
f'_\gt
,\quad
f'_{a\gq}
\simeq
f''_{a\gt}
-f''_{\gt\gt}\tgq
-f'_\gt\tgQ
,\\
H
=
\R{R^2_0}{r^2}-1
=
0
,\quad
H'_a
=
-2\R{r'_a}{R_0}
,\quad
H'_\gt
=
0
,\quad
H''_{a\gt}
=
-2\R{r''_{a\gt}}{R_0}
.\eqbl

\Subsection{Algorithm}
Calclulations of basic functions and their derivatives
\bqbl
\gQ
=\R{V}{V_0}
,\quad
L
=
\R{D}{r}
,\quad
D
=
r'_az'_\gt-r'_\gt z'_a
,\quad
B^2
=
\R{r'^2_\gt+z'^2_\gt}{V^2}\bgY'^2
+\R{\baF^2}{r^2}
,\\
V'_a
=
r'_aD
+rD'_a
,\quad
V'_\gt
=
r'_\gt D
+rD'_\gt
,\quad
V''_{a\gt}
=
r''_{a\gt} D
+r'_\gt D'_a
+r'_aD'_\gt
+rD''_{a\gt}
,\quad
V''_{\gt\gt}
=
r''_{\gt\gt} D
+2r'_\gt D'_\gt
+rD''_{\gt\gt}
,\\
K'_a
=
2\R{r'_\gt r'_{a\gt}+z'_\gt z'_{a\gt}}{rD}
-K\R{r'_aD+rD'_a}{rD}
,\quad
D'_a
=
r''_{aa}z'_\gt+r'_az''_{a\gt}-r''_{a\gt} z'_a-r'_\gt z''_{aa}
,\quad
L'_a
=
\R{D'_a}{r}
-L\R{r'_a}{r}
.\eqbl
Transition from ESC $(a,\gt,\gf)$ to new flux coordinates
$(a,\gq,\gf)$ are determined by derivative
angle
\bqbl
Q
=
\R{1}{2\gp}\oint rDB^2 d\gt
,\quad
Q'_a
=
\R{1}{2\gp}\oint (rDB^2)'_a d\gt
,\\
\gq
=
\R{1}{Q}\int^\gt_0 rDB^2 d\gt
,\quad
\gq'_a
=
\R{1}{Q}\int^\gt_0 (rDB^2)'_a d\gt
-\R{Q'_a}{Q}\gq
,\\
\gq'_\gt
=
\R{rDB^2}{Q}
,\quad
\gq''_{\gt\gt}
=
\R{(rDB^2)'_\gt}{Q}
,\quad
\gq''_{a\gt}
=
\R{(rDB^2)'_a}{Q}
-R{Q'_a}{Q}\gq'_\gt
.\eqbl
Derivatives of ESC coordinates in terms of new coordinates
\bqbl
\gQ
=
\R{rDB^2}{Q}
,\quad
\gt'_\gq=\R{1}{\gQ}
,\quad
\gt'_\bsa=-\R{\gq'_a}{\gQ}
,\quad
\gt''_{\bsa\gq}=
-\R{\gQ'_a}{\gQ^2}
-\gt'_\bsa\R{\gQ'_\gt}{\gQ^2}
.\eqbl
Derivatives of functions of $(a,\gt,\gf)$ in terms of new coordinates
\bqbl
&&
f'_\bsa
=
f'_\bsa
+f'_\gt\gt'_\bsa
,\quad
f'_\gq
=
f'_\gt\gt'_\gq
,\quad
f'_{a\gq}
=
f''_{a\gt}\gt'_\gq
+f''_{\gt\gt}\gt'_\gq\gt'_a
+f'_\gt\gt''_{a\gq}
.\eqbl
Behavior near the axis
\bqbl
\gQ
=
1+a\tgQ
,\quad
\gq'_a
=
\tgq+a\tgq'_a
,\quad
\tgq
\equiv
\int^\gt_0\tgQ d\gt
,\quad
\gq''_{a\gt}
=
\tgQ+a\tgQ'_a
,\quad
\gq''_{\gt\gt}
=
a\tgQ'_\gt
,\\
\gt'_\gq\simeq1
,\quad
\gt'_a\simeq-\tgq
,\quad
\gt''_{a\gq}=
-\tgQ
,\\
f'_a
\simeq
f'_a
-f'_\gt\tgq
,\quad
f'_\gq
\simeq
f'_\gt
,\quad
f'_{a\gq}
\simeq
f''_{a\gt}
-f''_{\gt\gt}\tgq
-f'_\gt\tgQ
.\eqbl

\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{ESSetSplA()}&$$&\\
\c{Undef }&\c{splRA()}&$$&\\
\c{Undef }&\c{splRA2()}&$$&\\
\c{Undef }&\c{ESP2F()}&$$&\\
\c{Undef }&\c{ESWriteESI()}&$$&\\
\c{extern double }&\c{*ESsa}&$$&\\
\c{extern int }&\c{ESNa}&$$&\\
\c{extern int }&\c{ESNa1}&$$&\\
\c{extern double }&\c{*rcT1a}&$$&\\
\c{extern double }&\c{*rsT1a}&$$&\\
\c{extern double }&\c{*ESsb1a}&$$&\\
\c{extern double }&\c{*ESaF}&$$&\\
\c{extern double }&\c{*ESaR0}&$$&\\
\c{extern double }&\c{*ESaZ0}&$$&\\
\c{extern double }&\c{*ESLc}&$$&\\
\c{extern double }&\c{*ESLc2}&$$&\\
\c{extern double }&\c{*ESFF}&$$&\\
\c{extern double }&\c{*ESFF2a}&$$&\\
\c{extern double }&\c{*ESdgY}&$$&\\
\c{extern double }&\c{*ESdgY2a}&$$&\\
\c{extern double }&\c{*ESsb}&$$&\\
\c{extern double }&\c{*ESsb2a}&$$&\\
\c{extern double }&\c{*rcT}&$$&\\
\c{extern double }&\c{*rcT2a}&$$&\\
\c{extern double }&\c{*rsT}&$$&\\
\c{extern double }&\c{*rsT2a}&$$&\\
\c{extern int }&\c{ESFp1}&$$&\\
\c{extern int }&\c{ESNp}&$$&\\
\c{extern double }&\c{*EScs1}&$$&\\
\c{extern double }&\c{*ESsn1}&$$&\\
\c{extern int }&\c{ESFp}&$$&\\
\c{int }&\c{Np}&$$&\\
\c{int }&\c{Na}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int ES2Hamada(R,Z,Na,Np)
  double *R;	/*  */
  double *Z;	/*  */
  int Na;	/*  */
  int Np;	/*  */
{
  Undef ESSetSplA();
  Undef splRA();
  Undef ESP2F();
  extern double *ESsa;	/* undefined */
  extern int ESNa;	/* undefined */
  extern double *ESaR0;	/* undefined */
  extern double *ESaZ0;	/* undefined */
  extern double *ESsb;	/* undefined */
  extern double *ESsb2a;/* undefined */
  extern double *rcT;	/* undefined */
  extern double *rcT2a;	/* undefined */
  extern double *rsT;	/* undefined */
  extern double *rsT2a;	/* undefined */
  extern int ESFp1;	/* undefined */
  extern int ESNa1;	/* undefined */
  extern int ESNp;	/* undefined */
  extern double *EScs1;	/* undefined */
  extern double *ESsn1;	/* undefined */
  extern int ESFp;	/* undefined */
  int Na;	/*  .ES2Hamada():escQ.c */
  int Np;	/*  .ES2Hamada():escQ.c */
  double *R;	/*  .ES2Hamada():escQ.c */
  double *Z;	/*  .ES2Hamada():escQ.c */
/*
   */
#ifdef Doc_ES2Hamada
\Section{Skeleton of \c{ES2Hamada()}}
  \begin{verbatim}
    ES2Hamada(){
    }
  \end{verbatim}
\Section{\c{ES2Hamada()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{double }&\c{*R}&$$&\\
\c{double }&\c{*Z}&$$&\\
\c{int }&\c{Na}&$$&\\
\c{int }&\c{Np}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{ESSetSplA()}&$$&\\
\c{Undef }&\c{splRA()}&$$&\\
\c{Undef }&\c{ESP2F()}&$$&\\
\c{extern double }&\c{*ESsa}&$$&\\
\c{extern int }&\c{ESNa}&$$&\\
\c{extern double }&\c{*ESaR0}&$$&\\
\c{extern double }&\c{*ESaZ0}&$$&\\
\c{extern double }&\c{*ESsb}&$$&\\
\c{extern double }&\c{*ESsb2a}&$$&\\
\c{extern double }&\c{*rcT}&$$&\\
\c{extern double }&\c{*rcT2a}&$$&\\
\c{extern double }&\c{*rsT}&$$&\\
\c{extern double }&\c{*rsT2a}&$$&\\
\c{extern int }&\c{ESFp1}&$$&\\
\c{extern int }&\c{ESNa1}&$$&\\
\c{extern int }&\c{ESNp}&$$&\\
\c{extern double }&\c{*EScs1}&$$&\\
\c{extern double }&\c{*ESsn1}&$$&\\
\c{extern int }&\c{ESFp}&$$&\\
\c{int }&\c{Na}&$$&\\
\c{int }&\c{Np}&$$&\\
\c{double }&\c{*R}&$$&\\
\c{double }&\c{*Z}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int ESBasicFunctionsBoozer(Na,Np)
  int Na;	/*  */
  int Np;	/*  */
{
  Undef ESSetSplA();
  Undef splRA();
  Undef splRA2();
  Undef ESP2F();
  extern double *ESsa;		/* undefined */
  extern int ESNa;		/* undefined */
  extern int ESNa1;		/* undefined */
  extern double *rcT1a;		/* undefined */
  extern double *rsT1a;		/* undefined */
  extern double *ESsb1a;	/* undefined */
  extern double *ESaF;		/* undefined */
  extern double *ESaR0;		/* undefined */
  extern double *ESaZ0;		/* undefined */
  extern double *ESLc;		/* undefined */
  extern double *ESLc2;		/* undefined */
  extern double *ESFF;		/* undefined */
  extern double *ESFF2a;	/* undefined */
  extern double *ESdgY;		/* undefined */
  extern double *ESdgY2a;	/* undefined */
  extern double *ESsb;		/* undefined */
  extern double *ESsb2a;	/* undefined */
  extern double *rcT;		/* undefined */
  extern double *rcT2a;		/* undefined */
  extern double *rsT;		/* undefined */
  extern double *rsT2a;		/* undefined */
  extern int ESFp1;		/* undefined */
  extern int ESNp;		/* undefined */
  extern double *EScs1;		/* undefined */
  extern double *ESsn1;		/* undefined */
  extern int ESFp;		/* undefined */
  int Np;		/*  .ESBasicFunctionsBoozer():escQ.c */
  int Na;		/*  .ESBasicFunctionsBoozer():escQ.c */
  int ESWriteESI();	/*                           :escQ.c */
/*
   */
#ifdef Doc_ESBasicFunctionsBoozer
\Section{Skeleton of \c{ESBasicFunctionsBoozer()}}
  \begin{verbatim}
    ESBasicFunctionsBoozer(){
    }
  \end{verbatim}
\Section{\c{ESBasicFunctionsBoozer()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{int }&\c{Na}&$$&\\
\c{int }&\c{Np}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsubsection{Definition of Boozer coordinates}
\bqbl
\R{D(z,r)}{D(a,\gq)}=\R{f(a)}{rB^2}
,\quad
D=\R{f(a)}{rB^2}\gq'_\gt
,\quad
\gQ
\equiv
\gq'_\gt
=\R{rDB^2}{(rDB^2)_0}
,\quad
\gq
=
\int^\gt_0\R{rDB^2}{(rDB^2)_0}d\gt
,\\
\gq'_a
=
\int^\gt_0\left[\R{rDB^2}{(rDB^2)_0}\right]'_ad\gt
=
\int^\gt_0\R{(rDB^2)'_a}{(rDB^2)_0}d\gt
-\gq\R{(rDB^2)'_0}{(rDB^2)_0}
,\\
\gq''_{a\gt}
=
\left[\R{rDB^2}{(rDB^2)_0}\right]'_a
,\quad
\gq''_{\gt\gt}
=
\R{(rDB^2)'_\gt}{(rDB^2)_0}
.\eqbl
Derivatives
\bqbl
rDB^2
=
K\bgY'^2
+L\baF^2
,\quad
(rDB^2)'_a
=
K'_a\bgY'^2
+K(\bgY'^2)'
+L'_a\baF^2
+L(\baF^2)'
,\\
B^2
=
\R{r'^2_\gt+z'^2_\gt}{r^2D^2}\bgY'^2
+\R{\baF^2}{r^2}
,\quad
K
=
\R{r'^2_\gt+z'^2_\gt}{rD}
,\quad
L
=
\R{D}{r}
,\quad
D
=
r'_az'_\gt-r'_\gt z'_a
,\\
K'_a
=
2\R{r'_\gt r'_{a\gt}+z'_\gt z'_{a\gt}}{rD}
-K\R{r'_aD+rD'_a}{rD}
,\quad
D'_a
=
r''_{aa}z'_\gt+r'_az''_{a\gt}-r''_{a\gt} z'_a-r'_\gt z''_{aa}
,\quad
L'_a
=
\R{D'_a}{r}
-L\R{r'_a}{r}
.\eqbl

\Subsubsection{Basic 2-D functions}
Transition from ESC $(a,\gt,\gf)$ to new flux coordinates
$(a,\gq,\gf)$ are determined by derivative
angle
\bqbl
\left.\R{\pa\gq}{\pa\gt}\right|_{a=const}
=
\gQ(a,\gt)
,\quad
\gQ_0
=
\R{1}{2\gp}\oint\gQ d\gt
=
1
,\eqbl
where $\gQ_0$ is the zeroth Fourier harmonic of $\gQ$. Then
\bqbl
&&
\gq
=
\gt+\int^\gt_0(\gQ-\gQ_0)d\gt
,\quad
\gq'_\gt
=
\gQ
,\quad
\gq'_a
=
\int^\gt_0\gQ'_ad\gt
,\quad
\gq''_{a\gt}
=
\gQ'_a
,\quad
\gq''_{\gt\gt}
=
\gQ'_\gt
.\eqbl
Derivatives of ESC coordinates in terms of new coordinates
\bqbl
d\gq=\gq'_ada+\gq'_\gt d\gt
,\quad
d\bsa=da
,\quad
\gq'_\gt d\gt=d\gq-\gq'_ad\bsa
,\quad
\gt'_\gq=\R{1}{\gQ}
,\quad
\gt'_\bsa=-\R{\gq'_a}{\gQ}
,\quad
\gt''_{\bsa\gq}=
-\R{\gQ'_a}{\gQ^2}
+\R{\gq'_a\gQ'_\gt}{\gQ^3}
.\eqbl
Basic functions and their derivatives
\bqbl
r
=r(a,\gt)
=r(\bsa,\gt(\bsa,\gq))
,\quad
r'_\bsa
=
r'_\bsa
+r'_\gt\gt'_\bsa
,\quad
r'_\gq
=
r'_\gt\gt'_\gq
,\quad
r'_{a\gq}
=
r''_{a\gt}\gt'_\gq
+r''_{\gt\gt}\gt'_\gq\gt'_a
+r'_\gt\gt''_{a\gq}
,\\
z
=z(a,\gt)
=z(\bsa,\gt(\bsa,\gq))
,\quad
z'_\bsa
=
z'_\bsa
+z'_\gt\gt'_\bsa
,\quad
z'_\gq
=
z'_\gt\gt'_\gq
,\quad
z'_{a\gq}
=
z''_{a\gt}\gt'_\gq
+z''_{\gt\gt}\gt'_\gq\gt'_a
+z'_\gt\gt''_{a\gq}
,\\
B
=
\q{B^2}
,\quad
B'_a
=
\R{(B^2)'_a}{2B}
,\quad
B'_\gt
=
\R{(B^2)'_\gt}{2B}
,\quad
B''_{a\gt}
=
\R{(B^2)''_{a\gt}}{2B}
-\R{B'_\gt B'_a}{B}
,\quad
B''_{\gt\gt}
=
\R{(B^2)''_{\gt\gt}}{2B}
-\R{B'^2_\gt}{B}
,\\
B
=B(a,\gt)
=B(\bsa,\gt(\bsa,\gq))
,\quad
B'_\bsa
=
B'_\bsa
+B'_\gt\gt'_\bsa
,\quad
B'_\gq
=
B'_\gt\gt'_\gq
,\quad
B'_{a\gq}
=
B''_{a\gt}\gt'_\gq
+B''_{\gt\gt}\gt'_\gq\gt'_a
+B'_\gt\gt''_{a\gq}
,\\
\gH\equiv\gh'_\gq
=
\R{L}{\gQ L_0}-1
,\quad
\R{L}{\gQ L_0}-1
,\\
\gH
=\gH(a,\gt)
=\gH(\bsa,\gt(\bsa,\gq))
,\quad
\gH'_\bsa
=
\gH'_\bsa
+\gH'_\gt\gt'_\bsa
,\quad
\gH'_\gq
=
\gH'_\gt\gt'_\gq
,\quad
\gH'_{a\gq}
=
\gH''_{a\gt}\gt'_\gq
+\gH''_{\gt\gt}\gt'_\gq\gt'_a
+\gH'_\gt\gt''_{a\gq}
.\eqbl

Behavior near the axis
\bqbl
rDB^2
=
\baF^2L
,\quad
\gQ
=
\R{L}{L_0}
,\\
\gQ
=
1+a\tgQ
,\quad
\gq'_a
=
\tgq+a\tgq'_a
,\quad
\tgq
\equiv
\int^\gt_0\tgQ d\gt
,\quad
\gq''_{a\gt}
=
\tgQ+a\tgQ'_a
,\quad
\gq''_{\gt\gt}
=
a\tgQ'_\gt
,\\
\gt'_\gq\simeq1
,\quad
\gt'_a\simeq-\tgq
,\quad
\gt''_{a\gq}=
-\tgQ
,\\
f'_a
\simeq
f'_a
-f'_\gt\tgq
,\quad
f'_\gq
\simeq
f'_\gt
,\quad
f'_{a\gq}
\simeq
f''_{a\gt}
-f''_{\gt\gt}\tgq
-f'_\gt\tgQ
,\\
H
=
0
.\eqbl

\Subsection{Algorithm}
Definition of Boozer $\gq$ coordinates
\bqbl
\gQ
=\R{rDB^2}{(rDB^2)_0}
,\quad
rDB^2
=
K\bgY'^2
+L\baF^2
,\quad
K
=
\R{r'^2_\gt+z'^2_\gt}{rD}
,\quad
L
=
\R{D}{r}
,\quad
D
=
r'_az'_\gt-r'_\gt z'_a
,\\
rDB^2
=
K\bgY'^2
+L\baF^2
,\quad
(rDB^2)'_a
=
K'_a\bgY'^2
+K(\bgY'^2)'
+L'_a\baF^2
+L(\baF^2)'
,\\
K'_a
=
2\R{r'_\gt r'_{a\gt}+z'_\gt z'_{a\gt}}{rD}
-K\R{r'_aD+rD'_a}{rD}
,\quad
D'_a
=
r''_{aa}z'_\gt+r'_az''_{a\gt}-r''_{a\gt} z'_a-r'_\gt z''_{aa}
,\quad
L'_a
=
\R{D'_a}{r}
-L\R{r'_a}{r}
,\\
B^2
=
\R{r'^2_\gt+z'^2_\gt}{r^2D^2}\bgY'^2
+\R{\baF^2}{r^2}
.\eqbl
Transition from ESC $(a,\gt,\gf)$ to new flux coordinates
$(a,\gq,\gf)$ are determined by derivative
angle
\bqbl
Q
=
\R{1}{2\gp}\oint rDB^2 d\gt
,\quad
Q'_a
=
\R{1}{2\gp}\oint (rDB^2)'_a d\gt
,\\
\gq
=
\R{1}{Q}\int^\gt_0 rDB^2 d\gt
,\quad
\gq'_a
=
\R{1}{Q}\int^\gt_0 (rDB^2)'_a d\gt
-\R{Q'_a}{Q}\gq
,\\
\gq'_\gt
=
\R{rDB^2}{Q}
,\quad
\gq''_{\gt\gt}
=
\R{(rDB^2)'_\gt}{Q}
,\quad
\gq''_{a\gt}
=
\R{(rDB^2)'_a}{Q}
-R{Q'_a}{Q}\gq'_\gt
.\eqbl
Derivatives of ESC coordinates in terms of new coordinates
\bqbl
\gQ
=
\R{rDB^2}{Q}
,\quad
\gt'_\gq=\R{1}{\gQ}
,\quad
\gt'_\bsa=-\R{\gq'_a}{\gQ}
,\quad
\gt''_{\bsa\gq}=
-\R{\gQ'_a}{\gQ^2}
-\gt'_\bsa\R{\gQ'_\gt}{\gQ^2}
.\eqbl
Derivatives of functions of $(a,\gt,\gf)$ in terms of new coordinates
\bqbl
&&
f'_\bsa
=
f'_\bsa
+f'_\gt\gt'_\bsa
,\quad
f'_\gq
=
f'_\gt\gt'_\gq
,\quad
f'_{a\gq}
=
f''_{a\gt}\gt'_\gq
+f''_{\gt\gt}\gt'_\gq\gt'_a
+f'_\gt\gt''_{a\gq}
.\eqbl
Behavior near the axis
\bqbl
\gQ
=
1+a\tgQ
,\quad
\gq'_a
=
\tgq+a\tgq'_a
,\quad
\tgq
\equiv
\int^\gt_0\tgQ d\gt
,\quad
\gq''_{a\gt}
=
\tgQ+a\tgQ'_a
,\quad
\gq''_{\gt\gt}
=
a\tgQ'_\gt
,\\
\gt'_\gq\simeq1
,\quad
\gt'_a\simeq-\tgq
,\quad
\gt''_{a\gq}=
-\tgQ
,\\
f'_a
\simeq
f'_a
-f'_\gt\tgq
,\quad
f'_\gq
\simeq
f'_\gt
,\quad
f'_{a\gq}
\simeq
f''_{a\gt}
-f''_{\gt\gt}\tgq
-f'_\gt\tgQ
.\eqbl

\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{ESSetSplA()}&$$&\\
\c{Undef }&\c{splRA()}&$$&\\
\c{Undef }&\c{splRA2()}&$$&\\
\c{Undef }&\c{ESP2F()}&$$&\\
\c{Undef }&\c{ESWriteESI()}&$$&\\
\c{extern double }&\c{*ESsa}&$$&\\
\c{extern int }&\c{ESNa}&$$&\\
\c{extern int }&\c{ESNa1}&$$&\\
\c{extern double }&\c{*rcT1a}&$$&\\
\c{extern double }&\c{*rsT1a}&$$&\\
\c{extern double }&\c{*ESsb1a}&$$&\\
\c{extern double }&\c{*ESaF}&$$&\\
\c{extern double }&\c{*ESaR0}&$$&\\
\c{extern double }&\c{*ESaZ0}&$$&\\
\c{extern double }&\c{*ESFF}&$$&\\
\c{extern double }&\c{*ESFF2a}&$$&\\
\c{extern double }&\c{*ESdgY}&$$&\\
\c{extern double }&\c{*ESdgY2a}&$$&\\
\c{extern double }&\c{*ESsb}&$$&\\
\c{extern double }&\c{*ESsb2a}&$$&\\
\c{extern double }&\c{*rcT}&$$&\\
\c{extern double }&\c{*rcT2a}&$$&\\
\c{extern double }&\c{*rsT}&$$&\\
\c{extern double }&\c{*rsT2a}&$$&\\
\c{extern int }&\c{ESFp1}&$$&\\
\c{extern int }&\c{ESNp}&$$&\\
\c{extern double }&\c{*EScs1}&$$&\\
\c{extern double }&\c{*ESsn1}&$$&\\
\c{int }&\c{Np}&$$&\\
\c{int }&\c{Na}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int ES2Boozer(R,Z,Na,Np)
  double *R;	/*  */
  double *Z;	/*  */
  int Na;	/*  */
  int Np;	/*  */
{
  Undef ESSetSplA();
  Undef splRA();
  Undef ESP2F();
  extern double *ESsa;		/* undefined */
  extern int ESNa;		/* undefined */
  extern double *ESaR0;		/* undefined */
  extern double *ESaZ0;		/* undefined */
  extern double *ESFF;		/* undefined */
  extern double *ESFF2a;	/* undefined */
  extern double *ESdgY;		/* undefined */
  extern double *ESdgY2a;	/* undefined */
  extern double *ESsb;		/* undefined */
  extern double *ESsb2a;	/* undefined */
  extern double *rcT;		/* undefined */
  extern double *rcT2a;		/* undefined */
  extern double *rsT;		/* undefined */
  extern double *rsT2a;		/* undefined */
  extern int ESFp1;		/* undefined */
  extern int ESNa1;		/* undefined */
  extern int ESNp;		/* undefined */
  extern double *EScs1;		/* undefined */
  extern double *ESsn1;		/* undefined */
  extern int ESFp;		/* undefined */
  int Na;	/*  .ES2Boozer():escQ.c */
  int Np;	/*  .ES2Boozer():escQ.c */
  double *R;	/*  .ES2Boozer():escQ.c */
  double *Z;	/*  .ES2Boozer():escQ.c */
/*
   */
#ifdef Doc_ES2Boozer
\Section{Skeleton of \c{ES2Boozer()}}
  \begin{verbatim}
    ES2Boozer(){
    }
  \end{verbatim}
\Section{\c{ES2Boozer()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{double }&\c{*R}&$$&\\
\c{double }&\c{*Z}&$$&\\
\c{int }&\c{Na}&$$&\\
\c{int }&\c{Np}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{ESSetSplA()}&$$&\\
\c{Undef }&\c{splRA()}&$$&\\
\c{Undef }&\c{ESP2F()}&$$&\\
\c{extern double }&\c{*ESsa}&$$&\\
\c{extern int }&\c{ESNa}&$$&\\
\c{extern double }&\c{*ESaR0}&$$&\\
\c{extern double }&\c{*ESaZ0}&$$&\\
\c{extern double }&\c{*ESFF}&$$&\\
\c{extern double }&\c{*ESFF2a}&$$&\\
\c{extern double }&\c{*ESdgY}&$$&\\
\c{extern double }&\c{*ESdgY2a}&$$&\\
\c{extern double }&\c{*ESsb}&$$&\\
\c{extern double }&\c{*ESsb2a}&$$&\\
\c{extern double }&\c{*rcT}&$$&\\
\c{extern double }&\c{*rcT2a}&$$&\\
\c{extern double }&\c{*rsT}&$$&\\
\c{extern double }&\c{*rsT2a}&$$&\\
\c{extern int }&\c{ESFp1}&$$&\\
\c{extern int }&\c{ESNa1}&$$&\\
\c{extern int }&\c{ESNp}&$$&\\
\c{extern double }&\c{*EScs1}&$$&\\
\c{extern double }&\c{*ESsn1}&$$&\\
\c{extern int }&\c{ESFp}&$$&\\
\c{int }&\c{Na}&$$&\\
\c{int }&\c{Np}&$$&\\
\c{double }&\c{*R}&$$&\\
\c{double }&\c{*Z}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int ESBasicFunctionsHat(Na,Np)
  int Na;	/*  */
  int Np;	/*  */
{
  Undef ESSetSplA();
  Undef splRA();
  Undef splRA2();
  Undef ESP2F();
  extern double *ESsa;		/* undefined */
  extern int ESNa;		/* undefined */
  extern int ESNa1;		/* undefined */
  extern double *rcT1a;		/* undefined */
  extern double *rsT1a;		/* undefined */
  extern double *ESsb1a;	/* undefined */
  extern double *ESaF;		/* undefined */
  extern double *ESaR0;		/* undefined */
  extern double *ESaZ0;		/* undefined */
  extern double *ESLc;		/* undefined */
  extern double *ESLc2;		/* undefined */
  extern double *ESFF;		/* undefined */
  extern double *ESFF2a;	/* undefined */
  extern double *ESdgY;		/* undefined */
  extern double *ESdgY2a;	/* undefined */
  extern double *ESsb;		/* undefined */
  extern double *ESsb2a;	/* undefined */
  extern double *rcT;		/* undefined */
  extern double *rcT2a;		/* undefined */
  extern double *rsT;		/* undefined */
  extern double *rsT2a;		/* undefined */
  extern int ESFp1;		/* undefined */
  extern int ESNp;		/* undefined */
  extern double *EScs1;		/* undefined */
  extern double *ESsn1;		/* undefined */
  extern int ESFp;		/* undefined */
  int Np;		/*  .ESBasicFunctionsHat():escQ.c */
  int Na;		/*  .ESBasicFunctionsHat():escQ.c */
  int ESWriteESI();	/*                           :escQ.c */
  /*
   */
#ifdef Doc_ESBasicFunctionsHat
\Section{Skeleton of \c{ESBasicFunctionsHat()}}
  \begin{verbatim}
    ESBasicFunctionsHat(){
    }
  \end{verbatim}
\Section{\c{ESBasicFunctionsHat()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{int }&\c{Na}&$$&\\
\c{int }&\c{Np}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsubsection{Definition of Hat coordinates}
\bqbl
\hgq
=
\gq
+\ga
,\quad
\hgz
=
\gz
+\gb
\lbq{GCCan0}
,\eqbl
where $\ga,\gb$ satisfy equations
\bqbl
\gn\na a
+\na\gs
+\na(\baI\ga)
+\na(\baF\gb)
-\baI'\ga\na a
-\baF'\gb\na a
=
0
,\\
\baI'\ga
+\baF'\gb
=
\gn
,\quad
\baI\ga
+\baF\gb
=
-\gs
,\quad
\ga
=
-\R{\baF\gn+\baF'\gs}{\baF\baI'-\baI\baF'}
,\quad
\gb
=
\R{\baI\gn+\baI'\gs}{\baF\baI'-\baI\baF'}
,\\
\baI'
-\gn'_\gq
=
TL+PV
,\quad
\baI
+\gs'_\gq
=
-K\bgY'
,\quad
\baF\baF'
=
T\baY'
,\\
1+\ga'_\gq
=
\R{\baF(\baI'-\gn_\gq)-\baF'(\baI+\gs_\gq)}{\baF\baI'-\baI\baF'}
=
\R{\baF^2(TL+PV)+KT\baY'^2}{\baF^2(TL_0+PV_0)+K_0T\baY'^2}
=
\R{\baF^2(TL+PV)+\baY'^2TK}{\baF^2(TL_0+PV_0)+\baY'^2TK_0}
,\\
1+\ga'_\gq
=
\R{T(JB^2)+\baF^2PV}{T(JB^2)_0+\baF^2PV_0}
\lbq{GCCan}
.\eqbl
In canonical coordinates $a,\hgq,\hgz$ the covariant representation of
the magnetic field is very simple 
\bqbl
\waB
=
\baI\na\hgq
+\baF\na\hgz
.\eqbl
The vector potential becomes
\bqbl
\waA
=
-\bgF'\hgh\na a
+\bgF\na\hgq
+\bgY\na\hgz
,\quad
\bgF'\hgh
\equiv
\bgF'\gh
-\bgF'\ga
-\bgY'\gb
\eqbl
Calculation of $\ga,\gb$ and their derivatives 
\bqbl
\gn'_\gt
=
-P(V-V_0)
,\quad
\gn
=
-P\int^\gt_0(V-V_0)d\gt
,\quad
\gn'_a
=
-P\int^\gt_0(V'_a-V'_0)d\gt
,\\
\gn''_{a\gt}
=
-[P(V-V_0]'_a
,\quad
\gn''_{\gt\gt}
=
-(PV)'_\gt
,\\
\gs'_\gt
=
-\bgY'(K-K_0)
,\quad
\gs
=
-\bgY'\int^\gt_0(K-K_0)d\gt
,\quad
\gs'_a
=
-\bgY'\int^\gt_0(K'_a-K'_0)d\gt
,\\
\gs''_{a\gt}
=
-[\bgY'(K-K_0]'_a
,\quad
\gs''_{\gt\gt}
=
-(\bgY'K)'_\gt
,\\
\hgq
=
\gq
+\ga
,\quad
\hgz
=
\gz
+\gb
,\quad
\ga
=
-\R{\baF\gn+\baF'\gs}{\baF\baI'-\baI\baF'}
,\quad
\gb
=
\R{\baI\gn+\baI'\gs}{\baF\baI'-\baI\baF'}
,\\
\baI
=
-K_0\bgY'
,\quad
\baI'
=
L_0T
+V_0P
,\quad
\baI''
=
(L_0T+V_0P)'
,\quad
\baF'
=
\R{T\bgY'}{\baF}
,\quad
\baF''
=
\left(\R{T\bgY'}{\baF}\right)'_a
.\eqbl

\Subsubsection{Basic 2-D functions}
Transition from ESC $(a,\gt,\gf)$ to new flux coordinates
$(a,\gq,\gf)$ are determined by derivative
angle
\bqbl
\left.\R{\pa\gq}{\pa\gt}\right|_{a=const}
=
\gQ(a,\gt)
,\quad
\gQ_0
=
\R{1}{2\gp}\oint\gQ d\gt
=
1
,\eqbl
where $\gQ_0$ is the zeroth Fourier harmonic of $\gQ$. Then
\bqbl
&&
\gq
=
\gt+\int^\gt_0(\gQ-\gQ_0)d\gt
,\quad
\gq'_\gt
=
\gQ
,\quad
\gq'_a
=
\int^\gt_0\gQ'_ad\gt
,\quad
\gq''_{a\gt}
=
\gQ'_a
,\quad
\gq''_{\gt\gt}
=
\gQ'_\gt
.\eqbl
Derivatives of ESC coordinates in terms of new coordinates
\bqbl
d\gq=\gq'_ada+\gq'_\gt d\gt
,\quad
d\bsa=da
,\quad
\gq'_\gt d\gt=d\gq-\gq'_ad\bsa
,\quad
\gt'_\gq=\R{1}{\gQ}
,\quad
\gt'_\bsa=-\R{\gq'_a}{\gQ}
,\quad
\gt''_{\bsa\gq}=
-\R{\gQ'_a}{\gQ^2}
+\R{\gq'_a\gQ'_\gt}{\gQ^3}
.\eqbl
Basic functions and their derivatives
\bqbl
r
=r(a,\gt)
=r(\bsa,\gt(\bsa,\gq))
,\quad
r'_\bsa
=
r'_\bsa
+r'_\gt\gt'_\bsa
,\quad
r'_\gq
=
r'_\gt\gt'_\gq
,\quad
r'_{a\gq}
=
r''_{a\gt}\gt'_\gq
+r''_{\gt\gt}\gt'_\gq\gt'_a
+r'_\gt\gt''_{a\gq}
,\\
z
=z(a,\gt)
=z(\bsa,\gt(\bsa,\gq))
,\quad
z'_\bsa
=
z'_\bsa
+z'_\gt\gt'_\bsa
,\quad
z'_\gq
=
z'_\gt\gt'_\gq
,\quad
z'_{a\gq}
=
z''_{a\gt}\gt'_\gq
+z''_{\gt\gt}\gt'_\gq\gt'_a
+z'_\gt\gt''_{a\gq}
,\\
B
=
\q{B^2}
,\quad
B'_a
=
\R{(B^2)'_a}{2B}
,\quad
B'_\gt
=
\R{(B^2)'_\gt}{2B}
,\quad
B''_{a\gt}
=
\R{(B^2)''_{a\gt}}{2B}
-\R{B'_\gt B'_a}{B}
,\quad
B''_{\gt\gt}
=
\R{(B^2)''_{\gt\gt}}{2B}
-\R{B'^2_\gt}{B}
,\\
B
=B(a,\gt)
=B(\bsa,\gt(\bsa,\gq))
,\quad
B'_\bsa
=
B'_\bsa
+B'_\gt\gt'_\bsa
,\quad
B'_\gq
=
B'_\gt\gt'_\gq
,\quad
B'_{a\gq}
=
B''_{a\gt}\gt'_\gq
+B''_{\gt\gt}\gt'_\gq\gt'_a
+B'_\gt\gt''_{a\gq}
,\\
\gH\equiv\gh'_\gq
=
\R{L}{\gQ L_0}-1
,\quad
\R{L}{\gQ L_0}-1
,\\
\gH
=\gH(\bsa,\gt(\bsa,\gq))
,\quad
\gH'_\bsa
=
\gH'_\bsa
+\gH'_\gt\gt'_\bsa
,\quad
\gH'_\gq
=
\gH'_\gt\gt'_\gq
,\quad
\gH'_{a\gq}
=
\gH''_{a\gt}\gt'_\gq
+\gH''_{\gt\gt}\gt'_\gq\gt'_a
+\gH'_\gt\gt''_{a\gq}
.\eqbl

Behavior near the axis
\bqbl
V_\til
=
2a^2R_0[(\baL'^c_1+\baV'^c_1)\cos\gt+(\baL'^s_1+\baV'^s_1)\sin\gt]
,\quad
\gs
=
0
,\quad
\baI''
=
\baL_0\R{T}{R_0}+\baL_0R_0P
,\\
\ga'_\gt
=
-\R{\gn}{\baI'}
=
P\R{V_\til}{\baI'}
=
aA
\R{2[(\baL'^c_1+\baV'^c_1)\cos\gt+(\baL'^s_1+\baV'^s_1)\sin\gt]}
 {\baL_0}
,\quad
A
\equiv
\R{PR^2_0}{(T+R^2_0P)}
,\quad
\gb
=
0
,\\
f'_a
\simeq
f'_a
-f'_\gt\tgq
,\quad
f'_\gq
\simeq
f'_\gt
,\quad
f'_{a\gq}
\simeq
f''_{a\gt}
-f''_{\gt\gt}\tgq
-f'_\gt\tgQ
,\\
\gH\equiv\gh'_\gq
=
\R{L}{\gQ L_0}-1
=
(1-A)\R{\taL}{L_0}
=
\R{T}{T+R^2_0P}\R{\taL}{L_0}
.\eqbl

\Subsection{Algorithm}
Definition of Boozer $\gq$ coordinates
\bqbl
\gQ
=\R{rDB^2}{(rDB^2)_0}
,\quad
rDB^2
=
K\bgY'^2
+L\baF^2
,\quad
K
=
\R{r'^2_\gt+z'^2_\gt}{rD}
,\quad
L
=
\R{D}{r}
,\quad
D
=
r'_az'_\gt-r'_\gt z'_a
,\\
rDB^2
=
K\bgY'^2
+L\baF^2
,\quad
(rDB^2)'_a
=
K'_a\bgY'^2
+K(\bgY'^2)'
+L'_a\baF^2
+L(\baF^2)'
,\\
K'_a
=
2\R{r'_\gt r'_{a\gt}+z'_\gt z'_{a\gt}}{rD}
-K\R{r'_aD+rD'_a}{rD}
,\quad
D'_a
=
r''_{aa}z'_\gt+r'_az''_{a\gt}-r''_{a\gt} z'_a-r'_\gt z''_{aa}
,\quad
L'_a
=
\R{D'_a}{r}
-L\R{r'_a}{r}
,\\
B^2
=
\R{r'^2_\gt+z'^2_\gt}{r^2D^2}\bgY'^2
+\R{\baF^2}{r^2}
.\eqbl
Transition from ESC $(a,\gt,\gf)$ to new flux coordinates
$(a,\gq,\gf)$ are determined by derivative
angle
\bqbl
Q
=
\R{1}{2\gp}\oint rDB^2 d\gt
,\quad
Q'_a
=
\R{1}{2\gp}\oint (rDB^2)'_a d\gt
,\\
\gq
=
\R{1}{Q}\int^\gt_0 rDB^2 d\gt
,\quad
\gq'_a
=
\R{1}{Q}\int^\gt_0 (rDB^2)'_a d\gt
-\R{Q'_a}{Q}\gq
,\\
\gq'_\gt
=
\R{rDB^2}{Q}
,\quad
\gq''_{\gt\gt}
=
\R{(rDB^2)'_\gt}{Q}
,\quad
\gq''_{a\gt}
=
\R{(rDB^2)'_a}{Q}
-R{Q'_a}{Q}\gq'_\gt
.\eqbl
Derivatives of ESC coordinates in terms of new coordinates
\bqbl
\gQ
=
\R{rDB^2}{Q}
,\quad
\gt'_\gq=\R{1}{\gQ}
,\quad
\gt'_\bsa=-\R{\gq'_a}{\gQ}
,\quad
\gt''_{\bsa\gq}=
-\R{\gQ'_a}{\gQ^2}
-\gt'_\bsa\R{\gQ'_\gt}{\gQ^2}
.\eqbl
Derivatives of functions of $(a,\gt,\gf)$ in terms of new coordinates
\bqbl
&&
f'_\bsa
=
f'_\bsa
+f'_\gt\gt'_\bsa
,\quad
f'_\gq
=
f'_\gt\gt'_\gq
,\quad
f'_{a\gq}
=
f''_{a\gt}\gt'_\gq
+f''_{\gt\gt}\gt'_\gq\gt'_a
+f'_\gt\gt''_{a\gq}
.\eqbl
Behavior near the axis
\bqbl
\gQ
=
1+a\tgQ
,\quad
\gq'_a
=
\tgq+a\tgq'_a
,\quad
\tgq
\equiv
\int^\gt_0\tgQ d\gt
,\quad
\gq''_{a\gt}
=
\tgQ+a\tgQ'_a
,\quad
\gq''_{\gt\gt}
=
a\tgQ'_\gt
,\\
\gt'_\gq\simeq1
,\quad
\gt'_a\simeq-\tgq
,\quad
\gt''_{a\gq}=
-\tgQ
,\\
f'_a
\simeq
f'_a
-f'_\gt\tgq
,\quad
f'_\gq
\simeq
f'_\gt
,\quad
f'_{a\gq}
\simeq
f''_{a\gt}
-f''_{\gt\gt}\tgq
-f'_\gt\tgQ
.\eqbl
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{ESSetSplA()}&$$&\\
\c{Undef }&\c{splRA()}&$$&\\
\c{Undef }&\c{splRA2()}&$$&\\
\c{Undef }&\c{ESP2F()}&$$&\\
\c{extern double }&\c{*ESsa}&$$&\\
\c{extern int }&\c{ESNa}&$$&\\
\c{extern int }&\c{ESNa1}&$$&\\
\c{extern double }&\c{*rcT1a}&$$&\\
\c{extern double }&\c{*rsT1a}&$$&\\
\c{extern double }&\c{*ESsb1a}&$$&\\
\c{extern double }&\c{*ESaF}&$$&\\
\c{extern double }&\c{*ESaR0}&$$&\\
\c{extern double }&\c{*ESaZ0}&$$&\\
\c{extern double }&\c{*ESLc}&$$&\\
\c{extern double }&\c{*ESLc2}&$$&\\
\c{extern double }&\c{*ESFF}&$$&\\
\c{extern double }&\c{*ESFF2a}&$$&\\
\c{extern double }&\c{*ESdgY}&$$&\\
\c{extern double }&\c{*ESdgY2a}&$$&\\
\c{extern double }&\c{*ESsb}&$$&\\
\c{extern double }&\c{*ESsb2a}&$$&\\
\c{extern double }&\c{*rcT}&$$&\\
\c{extern double }&\c{*rcT2a}&$$&\\
\c{extern double }&\c{*rsT}&$$&\\
\c{extern double }&\c{*rsT2a}&$$&\\
\c{extern int }&\c{ESFp1}&$$&\\
\c{extern int }&\c{ESNp}&$$&\\
\c{extern double }&\c{*EScs1}&$$&\\
\c{extern double }&\c{*ESsn1}&$$&\\
\c{extern int }&\c{ESFp}&$$&\\
\c{int }&\c{Np}&$$&\\
\c{int }&\c{Na}&$$&\\
\c{int }&\c{ESWriteESI()}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int ES2Hat(R,Z,Na,Np)
  double *R;	/*  */
  double *Z;	/*  */
  int Na;	/*  */
  int Np;	/*  */
{
  Undef ESSetSplA();
  Undef splRA();
  Undef ESP2F();
  extern double *ESsa;		/* undefined */
  extern int ESNa;		/* undefined */
  extern double *ESaR0;		/* undefined */
  extern double *ESaZ0;		/* undefined */
  extern double *ESFF;		/* undefined */
  extern double *ESFF2a;	/* undefined */
  extern double *ESdgY;		/* undefined */
  extern double *ESdgY2a;	/* undefined */
  extern double *ESsb;		/* undefined */
  extern double *ESsb2a;	/* undefined */
  extern double *rcT;		/* undefined */
  extern double *rcT2a;		/* undefined */
  extern double *rsT;		/* undefined */
  extern double *rsT2a;		/* undefined */
  extern int ESFp1;		/* undefined */
  extern int ESNa1;		/* undefined */
  extern int ESNp;		/* undefined */
  extern double *EScs1;		/* undefined */
  extern double *ESsn1;		/* undefined */
  extern int ESFp;		/* undefined */
  int Na;	/*  .ES2Hat():escQ.c */
  int Np;	/*  .ES2Hat():escQ.c */
  double *R;	/*  .ES2Hat():escQ.c */
  double *Z;	/*  .ES2Hat():escQ.c */
  /*
   */
#ifdef Doc_ES2Hat
\Section{Skeleton of \c{ES2Hat()}}
  \begin{verbatim}
    ES2Hat(){
    }
  \end{verbatim}
\Section{\c{ES2Hat()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{double }&\c{*R}&$$&\\
\c{double }&\c{*Z}&$$&\\
\c{int }&\c{Na}&$$&\\
\c{int }&\c{Np}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{ESSetSplA()}&$$&\\
\c{Undef }&\c{splRA()}&$$&\\
\c{Undef }&\c{ESP2F()}&$$&\\
\c{extern double }&\c{*ESsa}&$$&\\
\c{extern int }&\c{ESNa}&$$&\\
\c{extern double }&\c{*ESaR0}&$$&\\
\c{extern double }&\c{*ESaZ0}&$$&\\
\c{extern double }&\c{*ESFF}&$$&\\
\c{extern double }&\c{*ESFF2a}&$$&\\
\c{extern double }&\c{*ESdgY}&$$&\\
\c{extern double }&\c{*ESdgY2a}&$$&\\
\c{extern double }&\c{*ESsb}&$$&\\
\c{extern double }&\c{*ESsb2a}&$$&\\
\c{extern double }&\c{*rcT}&$$&\\
\c{extern double }&\c{*rcT2a}&$$&\\
\c{extern double }&\c{*rsT}&$$&\\
\c{extern double }&\c{*rsT2a}&$$&\\
\c{extern int }&\c{ESFp1}&$$&\\
\c{extern int }&\c{ESNa1}&$$&\\
\c{extern int }&\c{ESNp}&$$&\\
\c{extern double }&\c{*EScs1}&$$&\\
\c{extern double }&\c{*ESsn1}&$$&\\
\c{extern int }&\c{ESFp}&$$&\\
\c{int }&\c{Na}&$$&\\
\c{int }&\c{Np}&$$&\\
\c{double }&\c{*R}&$$&\\
\c{double }&\c{*Z}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int ESFirstBiSpline()
{
  extern double *ESsa;	/* undefined */
  extern double *ESgt;	/* undefined */
  static int Spi0;	/*  :escQ.c */
  static int Spi1;	/*  :escQ.c */
  static int Spj0;	/*  :escQ.c */
  static int Spj1;	/*  :escQ.c */
  static double ha;	/*  :escQ.c */
  static double rha;	/*  :escQ.c */
  static double hq;	/*  :escQ.c */
  static double rhq;	/*  :escQ.c */
/*
   */
#ifdef Doc_ESFirstBiSpline
\Section{Skeleton of ESFirstBiSpline()}
  \begin{verbatim}
    ESFirstBiSpline(){
    }
  \end{verbatim}
\Section{ESFirstBiSpline()}
1-D radial function
\bqbl
&&
T
=
{a_1-a\over h_0}
,\quad
t
=
{a-a_0\over h_0}
,\quad
h
\equiv
h_0
,\\&&
f(a)=
(3T^2-2T^3)f_0
+(3t^2-2t^3)f_1
+T^2thf'_0
-t^2Thf'_1
,\\&&
f'=
-\R{6Tt}{h}f_0
+\R{6tT}{h}f_1
+T(1-3t)f'_0
+t(1-3T)f'_1
,\\&&
\int^{a_1}_{a_0}fda
=
{h\over2}(f_0+f_1)
+{h^2\over12}(f'_0-f'_1)
.\eqbl

2-D function
\bqbl
&&
T_a
=
{a_1-a\over h_a}
,\quad
t_a
=
{a-a_0\over h_a}
,\quad
h_a
\equiv
a_1-a_0
,\quad
T_\gq
=
{\gq_1-\gq\over h_\gq}
,\quad
t_\gq
=
{\gq-\gq_0\over h_\gq}
,\quad
h_\gq
\equiv
\gq_1-\gq_0
,\\&&
f(a,\gq)=
(3T^2_\gq-2T^3_\gq)f_0
+(3t^2_\gq-2t^3_\gq)f_1
+T^2_\gq t_\gq h_\gq f'_{\gq0}
-t^2_\gq T_\gq h_\gq f'_{\gq1}
,\\&&
f_0
=
(3T^2_a-2T^3_a)f_{00}
+(3t^2_a-2t^3_a)f_{01}
+T^2_a t_a h_a f'_{a00}
-t^2_a T_a h_a f'_{a01}
,\\&&
f_1
=
(3T^2_a-2T^3_a)f_{10}
+(3t^2_a-2t^3_a)f_{11}
+T^2_a t_a h_a f'_{a10}
-t^2_a T_a h_a f'_{a11}
,\\&&
f'_{a0}
=
(3T^2_a-2T^3_a)f'_{a00}
+(3t^2_a-2t^3_a)f'a_{a01}
+T^2_a t_a h_a f''_{aa00}
-t^2_a T_a h_a f''_{aa01}
,\\&&
f'_{a1}
=
(3T^2_a-2T^3_a)f'_{a10}
+(3t^2_a-2t^3_a)f'_{a11}
+T^2_a t_a h_a f''_{aa10}
-t^2_a T_a h_a f''_{aa11}
,\\&&
\int^{\gq_1}_{\gq_0}fd\gq
=
{h_\gq\over2}(f_0+f_1)
+{h^2_\gq\over12}(f'_0-f'_1)
,\\&&
\int^\gq_{\gq_0}fd\gq
=
\R{h_\gq}{2}(1-2T^3_\gq+T^4_\gq)f_0
+\R{h_\gq}{2}(2t^3_\gq-t^4_\gq)f_1
+\R{h^2_\gq}{12}(1-T^4_\gq-4T^3_\gq t_\gq)f'_{\gq0}
-\R{h^2_\gq}{12}(4t^3_\gq T_\gq+t^4_\gq)f'_{\gq1}
.\eqbl
#endif
}
double YYa;		/*  */
double YYx;		/*  */
double YYX;		/*  */
double YYq;		/*  */
double YYy;		/*  */
double YYY;		/*  */
double XYa;		/*  */
double XYx;		/*  */
double XYX;		/*  */
double XYq;		/*  */
double XYy;		/*  */
double XYY;		/*  */
static double XSC1;	/*  */
static double XSC2;	/*  */
static double xSC1;	/*  */
static double xSC2;	/*  */

int ESBiSplRAP(r,ra,rq,z,za,zq,B,Ba,Bq,gh,gha,ghq,a,gq)
  double *r;	/*  */
  double *ra;	/*  */
  double *rq;	/*  */
  double *z;	/*  */
  double *za;	/*  */
  double *zq;	/*  */
  double *B;	/*  */
  double *Ba;	/*  */
  double *Bq;	/*  */
  double *gh;	/*  */
  double *gha;	/*  */
  double *ghq;	/*  */
  double a;	/*  */
  double gq;	/*  */
{
  extern double *ESsa;	/* undefined */
  extern int ESNa;	/* undefined */
  extern double cr2gp;	/* undefined */
  extern int ESNp;	/* undefined */
  extern double *ESgt;	/* undefined */
  extern int ESNp1;	/* undefined */
  extern double *ESsr;	/* undefined */
  extern double *ESsra;	/* undefined */
  extern double *ESsrt;	/* undefined */
  extern double *ESsrat;/* undefined */
  extern double *ESsz;	/* undefined */
  extern double *ESsza;	/* undefined */
  extern double *ESszt;	/* undefined */
  extern double *ESszat;/* undefined */
  extern double *ESaB;	/* undefined */
  extern double *ESaBa;	/* undefined */
  extern double *ESaBt;	/* undefined */
  extern double *ESaBat;/* undefined */
  extern double *ESgH;	/* undefined */
  extern double *ESgHa;	/* undefined */
  extern double *ESgHt;	/* undefined */
  extern double *ESgHat;/* undefined */
  double a;		/*  .ESBiSplRAP():escQ.c */
  double gq;		/*  .ESBiSplRAP():escQ.c */
  double *r;		/*  .ESBiSplRAP():escQ.c */
  double *rq;		/*  .ESBiSplRAP():escQ.c */
  double *z;		/*  .ESBiSplRAP():escQ.c */
  double *zq;		/*  .ESBiSplRAP():escQ.c */
  double *B;		/*  .ESBiSplRAP():escQ.c */
  double *Bq;		/*  .ESBiSplRAP():escQ.c */
  double *gh;		/*  .ESBiSplRAP():escQ.c */
  double *ghq;		/*  .ESBiSplRAP():escQ.c */
  double *ra;		/*  .ESBiSplRAP():escQ.c */
  double *za;		/*  .ESBiSplRAP():escQ.c */
  double *Ba;		/*  .ESBiSplRAP():escQ.c */
  double *gha;		/*  .ESBiSplRAP():escQ.c */
  static int Spi0;	/*               :escQ.c */
  static double rha;	/*               :escQ.c */
  static int Spi1;	/*               :escQ.c */
  static int Spj1;	/*               :escQ.c */
  static int Spj0;	/*               :escQ.c */
  static double rhq;	/*               :escQ.c */
  double XYa;		/*               :escQ.c */
  double XYx;		/*               :escQ.c */
  double XYX;		/*               :escQ.c */
  double XYq;		/*               :escQ.c */
  double XYy;		/*               :escQ.c */
  double XYY;		/*               :escQ.c */
  static double XSC1;	/*               :escQ.c */
  static double XSC2;	/*               :escQ.c */
  static double ha;	/*               :escQ.c */
  static double xSC1;	/*               :escQ.c */
  static double xSC2;	/*               :escQ.c */
  static double hq;	/*               :escQ.c */
/*
   */
#ifdef Doc_ESBiSplRAP
\Section{Skeleton of ESBiSplRAP()}
  \begin{verbatim}
    ESBiSplRAP(){
    }
  \end{verbatim}
\Section{ESBiSplRAP()}
#endif
}

int ESBiSplRA(F,dgY,T,P)
  double *F;	/*  */
  double *dgY;	/*  */
  double *T;	/*  */
  double *P;	/*  */
{
  extern double *ESaF;		/* undefined */
  extern double *ESaF1a;	/* undefined */
  extern double *ESaT;		/* undefined */
  extern double *ESaT1a;	/* undefined */
  extern double *ESPs;		/* undefined */
  extern double *ESPs1a;	/* undefined */
  extern double *ESdgY;		/* undefined */
  extern double *ESdgY1a;	/* undefined */
  double *F;		/*  .ESBiSplRA():escQ.c */
  double *T;		/*  .ESBiSplRA():escQ.c */
  double *P;		/*  .ESBiSplRA():escQ.c */
  double *dgY;		/*  .ESBiSplRA():escQ.c */
  static double XSC1;	/*              :escQ.c */
  static int Spi0;	/*              :escQ.c */
  static double xSC1;	/*              :escQ.c */
  static int Spi1;	/*              :escQ.c */
  static double XSC2;	/*              :escQ.c */
  static double xSC2;	/*              :escQ.c */
/*
   */
#ifdef Doc_ESBiSplRA
\Section{Skeleton of ESBiSplRA()}
  \begin{verbatim}
    ESBiSplRA(){
    }
  \end{verbatim}
\Section{ESBiSplRA()}
Hermitian representation
\bqbl
&&
T
=
{x_1-x\over h}
,\quad
t
=
{x-x_0\over h}
,\quad
h
\equiv
x_1-x_0
,\\&&
f(t)=
(3T^2-2T^3)f_0
+(3t^2-2t^3)f_1
+T^2thf'_0
-t^2Thf'_1
,\\&&
hf'(t)=
6tT(f_1-f_0)
+(T^2-2Tt)hf'_0
+(t^2-2tT)hf'_1
,\\&&
h^2f''(t)=
6(T-t)(f_1-f_0)
+(2t-4T)hf'_0
+(4t-2T)hf'_1
,\\&&
h^3f'''(t)=
-12(f_1-f_0)
+6hf'_0
+6hf'_1
.\eqbl
Polynomial representation
\bqbl
&&
f_0
=
f_0
,\quad
f'_0
=
f'_0
,\quad
\R{1}{2}h^2f''_0
=
3(f_1-f_0)
-2hf'_0
-hf'_1
,\quad
\R{1}{6}h^3f'''_0
=
-2(f_1-f_0)
+hf'_0
+hf'_1
,\\&&
f(t)=
f_0+f'_0t+\R{1}{2}f''_0t^2+\R{1}{6}f'''_0t^3
.\eqbl
#endif
}
static int nst;		/*  */
static int ist;		/*  */
static double Yr[];	/*  */
static double Yra[];	/*  */
static double Yrq[];	/*  */
static double Yz[];	/*  */
static double Yza[];	/*  */
static double Yzq[];	/*  */
static double YB[];	/*  */
static double YBa[];	/*  */
static double YBq[];	/*  */
static double Ya[];	/*  */
static double Yq[];	/*  */
static double Rloss[];	/*  */
static double Zloss[];	/*  */

void GCLagrangeEq(n,x,Y,dY)
  int *n;	/*  */
  double *x;	/*  */
  double *Y;	/*  */
  double *dY;	/*  */
{
  Undef ESSetSplA();
  Undef splRA();
  extern double *ESdgY;		/* undefined */
  extern double *ESdgY2a;	/* undefined */
  extern double *ESaF;		/* undefined */
  extern double *ESaF2a;	/* undefined */
  extern double *ESPs;		/* undefined */
  extern double *ESPs2a;	/* undefined */
  extern double *ESaT;		/* undefined */
  extern double *ESaT2a;	/* undefined */
  double *Y;		/*  .GCLagrangeEq():escQ.c */
  double *dY;		/*  .GCLagrangeEq():escQ.c */
  static int istate;	/*                 :escQ.c */
  static double gmP;	/*                 :escQ.c */
  int ESBiSplRAP();	/*                 :escQ.c */
  int ESBiSplRA();	/*                 :escQ.c */
/*
   */
#ifdef Doc_GCLagrangeEq
\Section{Skeleton of \c{GCLagrangeEq()}}
  \begin{verbatim}
    GCLagrangeEq(){
    }
  \end{verbatim}
\Section{\c{GCLagrangeEq()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{int }&\c{*n}&$$&\\
\c{double }&\c{*x}&$$&\\
\c{double }&\c{*Y}&$$&\\
\c{double }&\c{*dY}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
Guiding center Lagrangian
\bqbl
\left|\arl
\dgr_\parallel\\
\dsa\\
\dgq\\
\dgf\\
\ear\right|
=
\left|\arr
0&0& \R{a_{22}}{D}\\
0&0&-\R{a_{21}}{D}\\
 \R{a_{22}}{D}&-\R{a_{21}}{D}&0\\
-\R{a_{12}}{D}& \R{a_{11}}{D}&\R{B_a}{D}\\
\ear\right|
\cdot
\left|\arr
\R{\pa H}{\pa\gr_\parallel}\\
\R{\pa H}{\pa a}\\
-\R{\pa H}{\pa\gq}\\
\ear\right|
,\\
\R{\pa H}{\pa\gr_\parallel}
=
\gW_c\gr_\parallel|B|^2
,\quad
\R{\pa H}{\pa a}
=
\gW_c\gr^2_\parallel|B||B|'_a
+c\R{\gF'_{Ea}}{B_0}
+\gW_c\gm|B|'_a
,\\
-\R{\pa H}{\pa\gq}
=
-\gW_c\gr^2_\parallel|B||B|'_\gq
-c\R{\gF'_{E\gq}}{B_0}
-\gW_c\gm|B|'_\gq
,\\
a_{11}
=
-K\bgY'
,\quad
a_{21}
=
F
,\quad
a_{12}
=
L\baF+\gr_\parallel\left(rDP+LT\right)
,\quad
a_{22}
=
\bgY'+\gr_\parallel\baF'
,\\
B_a
=
-N\bgY'
,\quad
D
\equiv
a_{11}a_{22}-a_{12}a_{21}
.\eqbl
where
\bqbl
&&
a_{11}
\equiv
I+\gs'_\gq
,\quad
a_{12}
\equiv
\bgF'+\gh'_\gq+\gr_\parallel(I'+\gn'_\gq)
,\\&&
a_{21}
\equiv
F+\gs'_\gf
,\quad
a_{22}
\equiv
\bgY'+\gh'_\gf+\gr_\parallel(F'+\gn'_\gf)
.\eqbl
In terms of metric coefficients the Lagrangian matrix can be calculated as
\bqbl
&&
a_{11}
=
-K\bgY'
,\quad
a_{21}
=
F
,\quad
a_{12}
=
L\baF+\gr_\parallel\left(rDP+LT\right)
,\quad
a_{22}
=
\bgY'+\gr_\parallel\baF'
,\\&&
D\equiv r'_az'_\gq-r'_\gq z'_a
,\quad
K
=
\R{g_{\gq\gq}}{rD}
=
\R{r'^2_\gq+z'^2_\gq}{rD}
,\quad
N
=
\R{g_{a\gq}}{rD}
=
\R{r'_ar'_\gq+z'_az'_\gq}{rD}
,\quad
L
=
\R{D}{r}
,\\&&
P
\equiv
\R{\bsp'}{\bgY'}
,\quad
T
\equiv
\R{\baF\baF'}{\bgY'}
,\quad
B^2
=
\R{K\bgY'^2}{\q{g}}+\R{\baF^2}{r^2}
.\eqbl
\bqbl
\maA
\equiv
\left|\arr
a_{11}&a_{12}\\
a_{21}&a_{22}\\
\ear
\right|
,\quad
|\maA|
\equiv
a_{11}a_{22}-a_{12}a_{21}
=
J[|B|^2+\gr_\parallel(\waB\cdot(\na\times\waB))]
,\\
a_{11}\equiv B_\gq
,\quad a_{12}\equiv J(B^\gz+\gr_\parallel j^\gz)
,\quad a_{21}\equiv B_\gz
,\quad a_{22}\equiv-J(B^\gq+\gr_\parallel j^\gq)
.\eqbl

Straight field line coordinates
\bqbl
\gz
=
\bgz-\tgz
,\quad
\tgz
=
\R{\bgF'}{\bgY'}\gh
,\\
dl^2
=
g_{aa}da^2
+2g_{a\gq}dad\gq
+g_{\gq\gq}d\gq^2
+r^2d\gz^2
=
g_{aa}da^2
+2g_{a\gq}dad\gq
+g_{\gq\gq}d\gq^2
+r^2(d\bgz-\tgz'_ada-\tgz'_\gq d\gq)^2
,\\
dl^2
=
(g_{aa}+r^2\tgz'^2_a)da^2
+2(g_{a\gq}+r^2\tgz'_a\tgz'_\gq)dad\gq
+(g_{\gq\gq}+r^2\tgz'^2_\gq)d\gq^2
-2r^2\tgz'_adad\bgz
-2r^2\tgz'_\gq d\gq d\bgz
+r^2d\bgz^2
,\\
B^\gq
=
-\R{\bgY'}{J}
,\quad
JB^\bgz
=
\bgF'(1+\gh'_\gq)-\bgY'\tgz'_\gq
,\quad
\tgz'_\gq
=
\R{\bgF'}{\bgY'}\gh'_\gq
,\quad
\tgz'_a
=
\left(\R{\bgF'}{\bgY'}\gh\right)'_a
,\\
\baB_a
=
g_{a\gq}B^\gq
+r^2\tgz'_a(\tgz'_\gq B^\gq-B^\bgz)
=
g_{a\gq}B^\gq
-\baF\tgz'_a
=
-N\bgY'
-\baF\tgz'_a
,\\
\baB_\gq
=
g_{\gq\gq}B^\gq
+r^2\tgz'_\gq(\tgz'_\gq B^\gq-B^\bgz)
=
g_{\gq\gq}B^\gq
-\baF\tgz'_\gq
=
-K\bgY'
-\baF\tgz'_\gq
,\\
B_\bgz
=
r^2(B^\bgz-\tgz'_\gq B^\gq)
=
\baF
,\\
J\bsj^\gq
=
-\baF'
,\quad
J\bsj^\bgz
=
(g_{\gq\gq}B^\gq-\baF\tgz'_\gq)'_a
-(g_{a\gq}B^\gq-\baF\tgz'_a)'_\gq
=
J\bsj^\gz
-\baF'\tgz'_\gq
=
PJ+TL_0
.\eqbl

Roscoe's coefficients in equilibrium coordinates
\bqbl
B_a
=
-N\bgY'
,\quad
a^R_{11}
=
a_{11}
=
\baB_\gq
=
-K\bgY'
,\\
a_{12}
=
JB^\bgz
+\gr_\parallel(\baB'_{\gq,a}-\baB'_{a,\gq})
=
L\baF
+\gr_\parallel(rDP+LT)
,\\
a^R_{12}
=
JB^\bgz
+\gr_\parallel\baB'_{\gq,a}
=
L\baF
+\gr_\parallel\left(rDP+LT-N'_\gq\bgY'\right)
,\\
a_{21}
=
\baF
,\quad
a_{22}
\equiv
\bgY'+\gr_\parallel\baF'
.\eqbl
Roscoe's coefficients in straight field line coordinates
\bqbl
B_a
=
-N\bgY'
-\baF\tgz'_a
=
-N\bgY'
-TL_0\gh
-\baF^2\R{L_0\gh'_a}{\bgY'}
-\baF^2\left(\R{L_0}{\bgY'}\right)'_a\gh
,\\
a^R_{11}
=
a_{11}
=
\baB_\gq
=
-K\bgY'
-\baF\tgz'_\gq
=
-K\bgY'
-\baF\R{\bgF'}{\bgY'}\gh'_\gq
=
-K\bgY'
-\R{\baF^2}{\bgY'}\taL
,\\
a_{12}
=
JB^\bgz
+\gr_\parallel(\baB'_{\gq,a}-\baB'_{a,\gq})
=
L_0\baF
+\gr_\parallel(rDP+L_0T)
,\\
a^R_{12}
=
JB^\bgz
+\gr_\parallel\baB'_{\gq,a}
=
L_0\baF
+\gr_\parallel\left[rDP+L_0T
-N'_\gq\bgY'-\baF\left(\R{\baF}{\bgY'}\taL\right)'_a\right]
,\\
a^R_{12}
=
L_0\baF
+\gr_\parallel\left[rDP+L_0T
-N'_\gq\bgY'
-T\taL
-\R{\baF^2}{\bgY'}\left(\taL'_a-\R{\bgY''}{\bgY'}\taL\right)
\right]
,\\
a_{21}
=
\baF
,\quad
a_{22}
\equiv
\bgY'+\gr_\parallel\baF'
.\eqbl

Transformation to the straight field line coordinates
\bqbl
\waA=
-\bgF'\gh\na a
+\bgF\na\gq
+\bgY\na\gz
,\quad
\gz
=
\bgz-\tgz
,\quad
\waA=
-\bgF'\gh\na a
+\bgF\na\gq
+\bgY\na\bgz
+\bgY'\tgz\na a
-\na(\bgY\tgz)
,\\
\tgz
=
\R{\bgF'}{\bgY'}\gh
,\quad
\gz
=
\bgz-\R{\bgF'}{\bgY'}\gh
,\quad
\bgF'\gh
=
\baF\int^\gq\taL d\gq
,\\
\waB
=
B_a\na a
+B_\gq\na\gq
+\baF\na\gz
=
\left(B_a-\baF(\R{\bgF'\gh}{\bgY'})'_a\right)\na a
+\left(B_\gq-\baF\R{\bgF'\gh'_\gq}{\bgY'}\right)\na\gq
+\baF\na\bgz
,\\
\baB_a
=
B_a-\baF(\R{\bgF'\gh}{\bgY'})'_a
=
B_a-\baF\left(\R{\baF}{\bgY'}\int^\gq\taL d\gq\right)'_a
,\\
a_{11}
=
\baB_\gq
=
B_\gq-\R{\baF^2}{\bgY'}\taL
,\quad
B^\bgz
=
B^\gz+B^\gq\R{\bgF'\gh'_\gq}{\bgY'}
=
\R{\bgF'}{J}
,\\
J\bsj^\gz
=
(\baB_\gq)'_a
-(\baB_a)'_\gq
=
Jj^\gz+Jj^\gq\baF\R{\bgF'\gh'_\gq}{\bgY'}
=
PJ+TL_0
,\\
(\baB_\gq)'_a
=
PJ+TL_0
+(\baB_a)'_\gq
=
PJ+TL_0
-T\taL
-N'_\gq\bgY'
-\baF^2\left(\R{\taL}{\bgY'}\right)'_a
,\\
\bsp'\q{g}
=
-\baF'(\bgF'+\gh'_\gq)
+(\baI'+\gn'_\gq)\bgY'
,\quad
\baI'+\gn'_\gq
=
PJ+T\R{J}{r^2}
,\\
j^\bgz
=
j^\gz+j^\gq\R{\bgF'\gh'_\gq}{\bgY'}
=
P+\R{T}{J}\left(\R{J}{r^2}\right)_0
,\\
\bsa_{12}
=
\bgF'+\gr_\parallel\left[PJ+T\left(\R{J}{r^2}\right)_0\right]
=
L_0\baF+\gr_\parallel(rDP+L_0T)
.\eqbl
Roscoe's simplifications
\bqbl
a_{11}\equiv B_\gq
,\quad a_{12}\equiv J(B^\gz+\gr_\parallel j^\gz)
,\quad a_{21}\equiv B_\gz
,\quad a_{22}\equiv-J(B^\gq+\gr_\parallel j^\gq)
,\\
a_{11}
=
-K\bgY'
,\quad
a_{21}
=
F
,\quad
a_{12}
=
L\baF+\gr_\parallel\left(rDP+LT\right)
,\quad
a_{22}
=
\bgY'+\gr_\parallel\baF'
,\\
D\equiv r'_az'_\gq-r'_\gq z'_a
,\quad
K
=
\R{g_{\gq\gq}}{rD}
=
\R{r'^2_\gq+z'^2_\gq}{rD}
,\quad
N
=
\R{g_{a\gq}}{rD}
=
\R{r'_ar'_\gq+z'_az'_\gq}{rD}
,\quad
L
=
\R{D}{r}
,\\
P
\equiv
\R{\bsp'}{\bgY'}
,\quad
T
\equiv
\R{\baF\baF'}{\bgY'}
,\quad
B^2
=
\R{K\bgY'^2}{\q{g}}+\R{\baF^2}{r^2}
,\\
\baB_a
=
-N\bgY'
-T\int^\gq\taL d\gq
-\baF^2\R{1}{\bgY'}\int^\gq\taL'_a d\gq
+\R{\baF^2\bgY''}{\bgY'^2}\int^\gq\taL d\gq
,\\
\R{\pa\baB_a}{\pa\gq}
=
-N'_\gq\bgY'
-T\taL
-\R{\baF^2}{\bgY'}\taL'_a
+\R{\baF^2\bgY''}{\bgY'^2}\taL
,\\
a_{11}
=
-K\bgY'
=
I+\gs'_\gq
,\quad
a_{12}
=
L\baF+\gr_\parallel\left(I'+\gs''_{a\gq}+\gn'_\gq-\gs''_{a\gq}\right)
,\quad
\gs''_{a\gq}
=
\gn'_\gq-N'_\gq\bgY'
,\\
a_{12}
=
L\baF+\gr_\parallel\left(I'+\gn'_\gq-N'_\gq\bgY'+[\gn'_\gq-\gs''_{a\gq}]\right)
=
L\baF+\gr_\parallel\left(rDP+LT-N'_\gq\bgY'+[\gn'_\gq-\gs''_{a\gq}]\right)
.\eqbl


\Subsubsection{Roscoe derivation}
Guiding center Lagrangian
\bqbl
\left|\arl
\dgr_\parallel\\
\dsa\\
\dgq\\
\dgf\\
\ear\right|
=
\left|\arr
0&0& \R{a_{22}}{D}\\
0&0&-\R{a_{21}}{D}\\
 \R{a_{22}}{D}&-\R{a_{21}}{D}&0\\
-\R{a_{12}}{D}& \R{a_{11}}{D}&\R{B_a}{D}\\
\ear\right|
\cdot
\left|\arr
\R{\pa H}{\pa\gr_\parallel}\\
\R{\pa H}{\pa a}\\
-\R{\pa H}{\pa\gq}\\
\ear\right|
,\\
\R{\pa H}{\pa\gr_\parallel}
=
\gW_c\gr_\parallel|B|^2
,\quad
\R{\pa H}{\pa a}
=
\gW_c\gr^2_\parallel|B||B|'_a
+\gW_c\gm|B|'_a
,\\
-\R{\pa H}{\pa\gq}
=
-\gW_c\gr^2_\parallel|B||B|'_\gq
-\gW_c\gm|B|'_\gq
,\\
a_{11}
=
-K\bgY'
,\quad
a_{21}
=
F
,\quad
a_{12}
=
L\baF+\gr_\parallel\left(rDP+LT\right)
,\quad
a_{22}
=
\bgY'+\gr_\parallel\baF'
,\\
B_a
=
-N\bgY'
,\quad
D
\equiv
a_{11}a_{22}-a_{12}a_{21}
.\eqbl
where
\bqbl
&&
a_{11}
\equiv
I+\gs'_\gq
,\quad
a_{12}
\equiv
\bgF'+\gh'_\gq+\gr_\parallel(I'+\gn'_\gq)
,\\&&
a_{21}
\equiv
F+\gs'_\gf
,\quad
a_{22}
\equiv
\bgY'+\gh'_\gf+\gr_\parallel(F'+\gn'_\gf)
.\eqbl
Equations
\bqbl
\dgq
=
\R{a_{22}}{D}\R{\pa H}{\pa\gr_\parallel}
-\R{a_{21}}{D}\R{\pa H}{\pa a}
=
\R{\gr_\parallel|B|^2}{D}a_{22}
-\R{\gr^2_\parallel|B||B|'_a+\gm|B|'_a}{D}a_{21}
,\\
\dgf
=
-\R{a_{12}}{D}\R{\pa H}{\pa\gr_\parallel}
+\R{a_{11}}{D}\R{\pa H}{\pa a}
-\R{B_a}{D}\R{\pa H}{\pa\gq}
=
-\R{\gr_\parallel|B|^2}{D}a_{12}
+\R{\gr^2_\parallel|B||B|'_a+\gm|B|'_a}{D}a_{11}
-\R{\gr^2_\parallel|B||B|'_\gq+\gm|B|'_\gq}{D}B_a
,\\
\R{\dgf}{\dgq}
=
\R{
-\R{a_{12}}{D}\R{\pa H}{\pa\gr_\parallel}
+\R{a_{11}}{D}\R{\pa H}{\pa a}
-\R{B_a}{D}\R{\pa H}{\pa\gq}
}{
\R{a_{22}}{D}\R{\pa H}{\pa\gr_\parallel}
}
,\\
\R{\pa H}{\pa\gr_\parallel}
=
\gW_c\gr_\parallel|B|^2
,\quad
\R{\pa H}{\pa a}
=
\gW_c\gr^2_\parallel|B||B|'_a
+\gW_c\gm|B|'_a
,\\
\R{\pa H}{\pa\gq}
=
\gW_c\gr^2_\parallel|B||B|'_\gq
+\gW_c\gm|B|'_\gq
.\eqbl

\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{ESSetSplA()}&$$&\\
\c{Undef }&\c{splRA()}&$$&\\
\c{extern double }&\c{*ESdgY}&$$&\\
\c{extern double }&\c{*ESdgY2a}&$$&\\
\c{extern double }&\c{*ESaF}&$$&\\
\c{extern double }&\c{*ESaF2a}&$$&\\
\c{extern double }&\c{*ESPs}&$$&\\
\c{extern double }&\c{*ESPs2a}&$$&\\
\c{extern double }&\c{*ESaT}&$$&\\
\c{extern double }&\c{*ESaT2a}&$$&\\
\c{double }&\c{*Y}&$$&\\
\c{int }&\c{ESBiSplRAP()}&$$&\\
\c{static int }&\c{istate}&$$&\\
\c{double }&\c{*dY}&$$&\\
\c{int }&\c{ESBiSplRA()}&$$&\\
\c{static double }&\c{gmP}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

void GCLagrangeEqA(n,x,Y,dY)
  int *n;	/*  */
  double *x;	/*  */
  double *Y;	/*  */
  double *dY;	/*  */
{
  Undef gcmotion_();
  double *Y;		/*  .GCLagrangeEqA():escQ.c */
  double *dY;		/*  .GCLagrangeEqA():escQ.c */
  static double Yr[];	/*                  :escQ.c */
  static double Yra[];	/*                  :escQ.c */
  static double Yrq[];	/*                  :escQ.c */
  static double Yz[];	/*                  :escQ.c */
  static double gmP;	/*                  :escQ.c */
/*
   */
#ifdef Doc_GCLagrangeEqA
\Section{Skeleton of \c{GCLagrangeEqA()}}
  \begin{verbatim}
    GCLagrangeEqA(){
    }
  \end{verbatim}
\Section{\c{GCLagrangeEqA()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{int }&\c{*n}&$$&\\
\c{double }&\c{*x}&$$&\\
\c{double }&\c{*Y}&$$&\\
\c{double }&\c{*dY}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{gcmotion_()}&$$&\\
\c{static double }&\c{Yr[]}&$$&\\
\c{static double }&\c{Yra[]}&$$&\\
\c{static double }&\c{Yrq[]}&$$&\\
\c{static double }&\c{Yz[]}&$$&\\
\c{double }&\c{*Y}&$$&\\
\c{static double }&\c{gmP}&$$&\\
\c{double }&\c{*dY}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int ES4Output(a0,a1,gt0,gt1,na,nt)
  double a0;	/*  */
  double a1;	/*  */
  double gt0;	/*  */
  double gt1;	/*  */
  int na;	/*  */
  int nt;	/*  */
{
/*
   */
#ifdef Doc_ES4Output
\Section{Skeleton of \c{ES4Output()}}
  \begin{verbatim}
    ES4Output(){
    }
  \end{verbatim}
\Section{\c{ES4Output()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{double }&\c{a0}&$$&\\
\c{double }&\c{a1}&$$&\\
\c{double }&\c{gt0}&$$&\\
\c{double }&\c{gt1}&$$&\\
\c{int }&\c{na}&$$&\\
\c{int }&\c{nt}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int ESInitOrbLSODE(n)
  int n;	/*  */
{
  Undef int;
  int n;		/*  .ESInitOrbLSODE():escQ.c */
  static int lrw;	/*                   :escQ.c */
  static int liw;	/*                   :escQ.c */
  static int *iwork;	/*                   :escQ.c */
  static double *rwork;	/*                   :escQ.c */
  static double *yh;	/*                   :escQ.c */
  static double *vatol;	/*                   :escQ.c */
/*
   */
#ifdef Doc_ESInitOrbLSODE
\Section{Skeleton of \c{ESInitOrbLSODE()}}
  \begin{verbatim}
    ESInitOrbLSODE(){
    }
  \end{verbatim}
\Section{\c{ESInitOrbLSODE()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{int }&\c{n}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{int}&$$&\\
\c{static int }&\c{lrw}&$$&\\
\c{static int }&\c{liw}&$$&\\
\c{int }&\c{n}&$$&\\
\c{static int }&\c{*iwork}&$$&\\
\c{static double }&\c{*rwork}&$$&\\
\c{static double }&\c{*yh}&$$&\\
\c{static double }&\c{*vatol}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int ESDeInitOrbLSODE()
{
  static double *rwork;	/*  :escQ.c */
  static int *iwork;	/*  :escQ.c */
/*
   */
#ifdef Doc_ESDeInitOrbLSODE
\Section{Skeleton of \c{ESDeInitOrbLSODE()}}
  \begin{verbatim}
    ESDeInitOrbLSODE(){
    }
  \end{verbatim}
\Section{\c{ESDeInitOrbLSODE()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{static double }&\c{*rwork}&$$&\\
\c{static int }&\c{*iwork}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int GetBounceTime(t0,gq0,t1)
  double *t0;	/*  */
  double gq0;	/*  */
  double t1;	/*  */
{
  double gq0;		/*  .GetBounceTime():escQ.c */
  double *t0;		/*  .GetBounceTime():escQ.c */
  static int *iwork;	/*                  :escQ.c */
  static double *rwork;	/*                  :escQ.c */
  static double *yh;	/*                  :escQ.c */
/*
   */
#ifdef Doc_GetBounceTime
\Section{Skeleton of \c{GetBounceTime()}}
  \begin{verbatim}
    GetBounceTime(){
    }
  \end{verbatim}
\Section{\c{GetBounceTime()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{double }&\c{*t0}&$$&\\
\c{double }&\c{gq0}&$$&\\
\c{double }&\c{t1}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
Storage in \c{yh} of \c{lsode()}
\bqbl
X_k
\equiv
\{\gr_\parallel,a,\gq,\gf\}
,\quad
\gr_\parallel
=
\c{yh}
,\quad
a
=
\c{yh+1}
,\quad
\gq
=
\c{yh+2}
,\quad
\gf
=
\c{yh+3}
,\\
X_k(t)
=
\sum^n_{i=0}\R{t^i}{h^i}y_{k+4i}
\eqbl

\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{static int }&\c{*iwork}&$$&\\
\c{static double }&\c{*rwork}&$$&\\
\c{static double }&\c{*yh}&$$&\\
\c{double }&\c{gq0}&$$&\\
\c{double }&\c{*t0}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int InitLsode4Orbit(t,va)
  double t;	/*  */
  double va;	/*  */
{
  double t;		/*  .InitLsode4Orbit():escQ.c */
  double va;		/*  .InitLsode4Orbit():escQ.c */
  static int mf;	/*                    :escQ.c */
  static int itol;	/*                    :escQ.c */
  static int itask;	/*                    :escQ.c */
  static int iopt;	/*                    :escQ.c */
  static double *rwork;	/*                    :escQ.c */
  static int *iwork;	/*                    :escQ.c */
  static double reltol;	/*                    :escQ.c */
  static double *vatol;	/*                    :escQ.c */
  static double abstol;	/*                    :escQ.c */
  static int istate;	/*                    :escQ.c */
/*
   */
#ifdef Doc_InitLsode4Orbit
\Section{Skeleton of \c{InitLsode4Orbit()}}
  \begin{verbatim}
    InitLsode4Orbit(){
    }
  \end{verbatim}
\Section{\c{InitLsode4Orbit()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{double }&\c{t}&$$&\\
\c{double }&\c{va}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{static int }&\c{mf}&$$&\\
\c{static int }&\c{itol}&$$&\\
\c{static int }&\c{itask}&$$&\\
\c{static int }&\c{iopt}&$$&\\
\c{static double }&\c{*rwork}&$$&\\
\c{double }&\c{t}&$$&\\
\c{static int }&\c{*iwork}&$$&\\
\c{static double }&\c{reltol}&$$&\\
\c{static double }&\c{*vatol}&$$&\\
\c{double }&\c{va}&$$&\\
\c{static double }&\c{abstol}&$$&\\
\c{static int }&\c{istate}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

void GCOrbitPlot2D()
{
  Undef ZColor();
  Undef ES2DMapFlx2Lab();
  Undef lsode_();
  Undef ZPlotPolyLine();
  static double *rwork;	/*                 :escQ.c */
  static double yGC[];	/*                 :escQ.c */
  static int ist;	/*                 :escQ.c */
  void GCLagrangeEq;	/*  .GCLagrangeEq():escQ.c */
  static int neq;	/*                 :escQ.c */
  static int itol;	/*                 :escQ.c */
  static double reltol;	/*                 :escQ.c */
  static double *vatol;	/*                 :escQ.c */
  static int itask;	/*                 :escQ.c */
  static int istate;	/*                 :escQ.c */
  static int iopt;	/*                 :escQ.c */
  static int lrw;	/*                 :escQ.c */
  static int *iwork;	/*                 :escQ.c */
  static int liw;	/*                 :escQ.c */
  static int mf;	/*                 :escQ.c */
  TRAPPED *lBD;		/*                 :escQ.c */
  double cgWc;		/*                 :escQ.c */
  static int nst;	/*                 :escQ.c */
  int GetBounceTime();	/*                 :escQ.c */
/*
   */
#ifdef Doc_GCOrbitPlot2D
\Section{Skeleton of \c{GCOrbitPlot2D()}}
  \begin{verbatim}
    GCOrbitPlot2D(){
    }
  \end{verbatim}
\Section{\c{GCOrbitPlot2D()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\obeylines{\C{
c yh      21             the nordsieck history array, of size nyh by
c                        (nqcur + 1), where nyh is the initial value
c                        of neq.  for j = 0,1,...,nqcur, column j+1
c                        of yh contains hcur**j/factorial(j) times
c                        the j-th derivative of the interpolating
c                        polynomial currently representing the solution,
c                        evaluated at t = tcur.
c hu      rwork(11) the step size in t last used (successfully).
c
c hcur    rwork(12) the step size to be attempted on the next step.
c
c tcur    rwork(13) the current value of the independent variable
c                   which the solver has actually reached, i.e. the
c                   current internal mesh point in t.  on output, tcur
c                   will always be at least as far as the argument
c                   t, but may be farther (if interpolation was done).
c nqu     iwork(14) the method order last used (successfully).
c
c nqcur   iwork(15) the order to be attempted on the next step.
}}

\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{ZColor()}&$$&\\
\c{Undef }&\c{ES2DMapFlx2Lab()}&$$&\\
\c{Undef }&\c{lsode_()}&$$&\\
\c{Undef }&\c{ZPlotPolyLine()}&$$&\\
\c{static double }&\c{*rwork}&$$&\\
\c{static double }&\c{yGC[]}&$$&\\
\c{static int }&\c{ist}&$$&\\
\c{void }&\c{GCLagrangeEq}&$$&\\
\c{static int }&\c{neq}&$$&\\
\c{static int }&\c{itol}&$$&\\
\c{static double }&\c{reltol}&$$&\\
\c{static double }&\c{*vatol}&$$&\\
\c{static int }&\c{itask}&$$&\\
\c{static int }&\c{istate}&$$&\\
\c{static int }&\c{iopt}&$$&\\
\c{static int }&\c{lrw}&$$&\\
\c{static int }&\c{*iwork}&$$&\\
\c{static int }&\c{liw}&$$&\\
\c{static int }&\c{mf}&$$&\\
\c{int }&\c{GetBounceTime()}&$$&\\
\c{TRAPPED }&\c{*lBD}&$$&\\
\c{double }&\c{cgWc}&$$&\\
\c{static int }&\c{nst}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

void GCOrbitPlot2DLarmor()
{
  Undef ZColor();
  Undef ES2DMapFlx2Lab();
  Undef lsode_();
  Undef ESSetSplA();
  Undef splRA();
  Undef ESIsInsidePlasma();
  Undef ZPlotPolyLine();
  extern double *ESaF;	/* undefined */
  extern double *ESaF2a;/* undefined */
  extern int ESNp1;	/* undefined */
  extern double *EScs1;	/* undefined */
  extern double *ESsn1;	/* undefined */
  static double *rwork;	/*                 :escQ.c */
  static double yGC[];	/*                 :escQ.c */
  static double grn0;	/*                 :escQ.c */
  static int ist;	/*                 :escQ.c */
  void GCLagrangeEq;	/*  .GCLagrangeEq():escQ.c */
  static int neq;	/*                 :escQ.c */
  static int itol;	/*                 :escQ.c */
  static double reltol;	/*                 :escQ.c */
  static double *vatol;	/*                 :escQ.c */
  static int itask;	/*                 :escQ.c */
  static int istate;	/*                 :escQ.c */
  static int iopt;	/*                 :escQ.c */
  static int lrw;	/*                 :escQ.c */
  static int *iwork;	/*                 :escQ.c */
  static int liw;	/*                 :escQ.c */
  static int mf;	/*                 :escQ.c */
  static double B0;	/*                 :escQ.c */
  static int nst;	/*                 :escQ.c */
  int ESBiSplRAP();	/*                 :escQ.c */
/*
   */
#ifdef Doc_GCOrbitPlot2DLarmor
\Section{Skeleton of \c{GCOrbitPlot2DLarmor()}}
  \begin{verbatim}
    GCOrbitPlot2DLarmor(){
    }
  \end{verbatim}
\Section{\c{GCOrbitPlot2DLarmor()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
View of the larmor radius
\bqbl
\wsb
\equiv
\R{\waB}{|\waB|}
=
b_p\wse_p
+b_\gf\wse_\gf
=
b_\gf\wse_\gf
+b_p\wst
,\quad
,\\
b_p=0
,\quad
b_n=0
,\quad
b_\gf=0
,\\
a_p=1
,\quad
a_n=0
,\quad
a_\gf=0
,\\
c_p=0
,\quad
c_n=1
,\quad
c_\gf=0
,\\
b_p=\sin\gq
,\quad
b_n=0
,\quad
b_\gf=\cos\gq
,\\
a_p=\cos\gq
,\quad
a_n=0
,\quad
a_\gf=-\sin\gq
,\\
c_p=0
,\quad
c_n=1
,\quad
c_\gf=0
.\eqbl
Vector of the larmor orbit
\bqbl
\wsr
=
\gr_\perp\wsa\cos\gw_ct
+\gr_\perp\wsn\sin\gw_ct
.\eqbl
Distance along $\gf=\gp/2$
\bqbl
\wsr
=
\gr_\perp\wsa\cos\gw_ct
+\gr_\perp\wsc\sin\gw_ct
.\eqbl
Projection to the poloidal plane
\bqbl
\wsr
=
\gr_\perp\cos\gq\cos\gw_ct\wst
+\gr_\perp\sin\gw_ct\wsn
,\\
\cos\gq
=
\R{B_{tor}}{|B|}
.\eqbl
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{ZColor()}&$$&\\
\c{Undef }&\c{ES2DMapFlx2Lab()}&$$&\\
\c{Undef }&\c{lsode_()}&$$&\\
\c{Undef }&\c{ESSetSplA()}&$$&\\
\c{Undef }&\c{splRA()}&$$&\\
\c{Undef }&\c{ESIsInsidePlasma()}&$$&\\
\c{Undef }&\c{ZPlotPolyLine()}&$$&\\
\c{extern double }&\c{*ESaF}&$$&\\
\c{extern double }&\c{*ESaF2a}&$$&\\
\c{extern int }&\c{ESNp1}&$$&\\
\c{extern double }&\c{*EScs1}&$$&\\
\c{extern double }&\c{*ESsn1}&$$&\\
\c{static double }&\c{*rwork}&$$&\\
\c{static double }&\c{yGC[]}&$$&\\
\c{static double }&\c{grn0}&$$&\\
\c{static int }&\c{ist}&$$&\\
\c{void }&\c{GCLagrangeEq}&$$&\\
\c{static int }&\c{neq}&$$&\\
\c{static int }&\c{itol}&$$&\\
\c{static double }&\c{reltol}&$$&\\
\c{static double }&\c{*vatol}&$$&\\
\c{static int }&\c{itask}&$$&\\
\c{static int }&\c{istate}&$$&\\
\c{static int }&\c{iopt}&$$&\\
\c{static int }&\c{lrw}&$$&\\
\c{static int }&\c{*iwork}&$$&\\
\c{static int }&\c{liw}&$$&\\
\c{static int }&\c{mf}&$$&\\
\c{int }&\c{ESBiSplRAP()}&$$&\\
\c{static double }&\c{B0}&$$&\\
\c{static int }&\c{nst}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int FractionLosses()
{
  Undef fscanf();
  Undef CbStr2UserMessage();
  Undef puts();
  Undef CbGetCurrentCbName();
  Undef fputc();
  extern int ESNa1;	/* undefined */
  extern int ESNp1;	/* undefined */
  extern double *ESsa;	/* undefined */
  extern double *ESsp;	/* undefined */
  extern int ESNp;	/* undefined */
  extern double *ESsr;	/* undefined */
  extern double *ESsra;	/* undefined */
  extern double *ESszt;	/* undefined */
  extern double *ESsrt;	/* undefined */
  extern double *ESsza;	/* undefined */
  static double Pi[];	/*  :escQ.c */
  static double Pe[];	/*  :escQ.c */
/*
   */
#ifdef Doc_FractionLosses
\Section{Skeleton of \c{FractionLosses()}}
  \begin{verbatim}
    FractionLosses(){
    }
  \end{verbatim}
\Section{\c{FractionLosses()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{fscanf()}&$$&\\
\c{Undef }&\c{CbStr2UserMessage()}&$$&\\
\c{Undef }&\c{puts()}&$$&\\
\c{Undef }&\c{CbGetCurrentCbName()}&$$&\\
\c{Undef }&\c{fputc()}&$$&\\
\c{extern int }&\c{ESNa1}&$$&\\
\c{extern int }&\c{ESNp1}&$$&\\
\c{extern double }&\c{*ESsa}&$$&\\
\c{extern double }&\c{*ESsp}&$$&\\
\c{extern int }&\c{ESNp}&$$&\\
\c{extern double }&\c{*ESsr}&$$&\\
\c{extern double }&\c{*ESsra}&$$&\\
\c{extern double }&\c{*ESszt}&$$&\\
\c{extern double }&\c{*ESsrt}&$$&\\
\c{extern double }&\c{*ESsza}&$$&\\
\c{static double }&\c{Pi[]}&$$&\\
\c{static double }&\c{Pe[]}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int ReadFractionLosses()
{
  Undef CbGetCurrentCbName();
  Undef puts();
  Undef fscanf();
  Undef CbStr2UserMessage();
  extern int ESNa1;	/* undefined */
  extern int ESNp;	/* undefined */
/*
   */
#ifdef Doc_ReadFractionLosses
\Section{Skeleton of \c{ReadFractionLosses()}}
  \begin{verbatim}
    ReadFractionLosses(){
    }
  \end{verbatim}
\Section{\c{ReadFractionLosses()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{CbGetCurrentCbName()}&$$&\\
\c{Undef }&\c{puts()}&$$&\\
\c{Undef }&\c{fscanf()}&$$&\\
\c{Undef }&\c{CbStr2UserMessage()}&$$&\\
\c{extern int }&\c{ESNa1}&$$&\\
\c{extern int }&\c{ESNp}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

void GCOrbitPlot2DLoss()
{
  Undef ZColor();
  Undef lsode_();
  Undef ESIsInsidePlasma();
  Undef ZPlotPolyLine();
  Undef fputc();
  Undef putchar();
  Undef puts();
  extern int ESNa1;	/* undefined */
  extern int ESNp1;	/* undefined */
  extern double *ESgt;	/* undefined */
  extern double *EScs1;	/* undefined */
  extern double *ESsn1;	/* undefined */
  static double yGC[];	/*                 :escQ.c */
  static double Pe[];	/*                 :escQ.c */
  static double Pi[];	/*                 :escQ.c */
  static double Vb;	/*                 :escQ.c */
  static double Vtot;	/*                 :escQ.c */
  static double Vn;	/*                 :escQ.c */
  static double grn0;	/*                 :escQ.c */
  double cgWc;		/*                 :escQ.c */
  static double B0;	/*                 :escQ.c */
  static double gmP;	/*                 :escQ.c */
  static double *rwork;	/*                 :escQ.c */
  static double *vatol;	/*                 :escQ.c */
  void GCLagrangeEq;	/*  .GCLagrangeEq():escQ.c */
  static int neq;	/*                 :escQ.c */
  static int itol;	/*                 :escQ.c */
  static double reltol;	/*                 :escQ.c */
  static int itask;	/*                 :escQ.c */
  static int istate;	/*                 :escQ.c */
  static int iopt;	/*                 :escQ.c */
  static int lrw;	/*                 :escQ.c */
  static int *iwork;	/*                 :escQ.c */
  static int liw;	/*                 :escQ.c */
  static int mf;	/*                 :escQ.c */
  int ESBiSplRAP();	/*                 :escQ.c */
  int InitLsode4Orbit();/*                 :escQ.c */
/*
   */
#ifdef Doc_GCOrbitPlot2DLoss
\Section{Skeleton of \c{GCOrbitPlot2DLoss()}}
  \begin{verbatim}
    GCOrbitPlot2DLoss(){
    }
  \end{verbatim}
\Section{\c{GCOrbitPlot2DLoss()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
Loss of $\ga$-particles
\bqbl
d\d{N}(a,\gq,\gw)
=\d{N}(a,\gq)\R{d\gW}{4\gp}
=\d{N}(a,\gq)\R{\sin\gw d\gw}{2}
=\d{N}(a,\gq)\R{dp_\parallel(\gw)}{2}
,\quad
\d{N}(a,\gq)
=\d{N}(a,\gq)\int^1_{-1}\R{dp_\parallel}{2}
,\\
d\d{N}(a)
=
4\gp^2da\left<\d{N}(a,\gq)rD\int^1_{-1}\R{dp_\parallel}{2}\right>_0
,\quad
\d{N}
=
4\gp^2\int^1_0da\left<\d{N}(a,\gq)rD\int^1_{-1}\R{dp_\parallel}{2}\right>_0
.\eqbl
Fraction and the number of escaped particles
\bqbl
f^*(a,\gq)
\equiv
\int^{p_2}_{p_1}\R{dp_\parallel}{2}
,\quad
\d{N}^*
=
4\gp^2\int^1_0da\left<\d{N}(a,\gq)f^*(a,\gq)rD\right>_0
.\eqbl

\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{ZColor()}&$$&\\
\c{Undef }&\c{lsode\_()}&$$&\\
\c{Undef }&\c{ESIsInsidePlasma()}&$$&\\
\c{Undef }&\c{ZPlotPolyLine()}&$$&\\
\c{Undef }&\c{fputc()}&$$&\\
\c{Undef }&\c{putchar()}&$$&\\
\c{Undef }&\c{puts()}&$$&\\
\c{extern int }&\c{ESNa1}&$$&\\
\c{extern int }&\c{ESNp1}&$$&\\
\c{extern double }&\c{*ESgt}&$$&\\
\c{extern double }&\c{*EScs1}&$$&\\
\c{extern double }&\c{*ESsn1}&$$&\\
\c{static double }&\c{yGC[]}&$$&\\
\c{static double }&\c{Pe[]}&$$&\\
\c{static double }&\c{Pi[]}&$$&\\
\c{static double }&\c{Vb}&$$&\\
\c{static double }&\c{Vtot}&$$&\\
\c{static double }&\c{Vn}&$$&\\
\c{int }&\c{ESBiSplRAP()}&$$&\\
\c{static double }&\c{grn0}&$$&\\
\c{double }&\c{cgWc}&$$&\\
\c{static double }&\c{B0}&$$&\\
\c{static double }&\c{gmP}&$$&\\
\c{static double }&\c{*rwork}&$$&\\
\c{int }&\c{InitLsode4Orbit()}&$$&\\
\c{static double }&\c{*vatol}&$$&\\
\c{void }&\c{GCLagrangeEq}&$$&\\
\c{static int }&\c{neq}&$$&\\
\c{static int }&\c{itol}&$$&\\
\c{static double }&\c{reltol}&$$&\\
\c{static int }&\c{itask}&$$&\\
\c{static int }&\c{istate}&$$&\\
\c{static int }&\c{iopt}&$$&\\
\c{static int }&\c{lrw}&$$&\\
\c{static int }&\c{*iwork}&$$&\\
\c{static int }&\c{liw}&$$&\\
\c{static int }&\c{mf}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

void GCOrbitPlot2DB()
{
  Undef ZColor();
  Undef ES2DMapFlx2Lab();
  Undef lsode_();
  Undef ZPlotPolyLine();
  Undef out();
  static double *rwork;	/*                  :escQ.c */
  static double yGC[];	/*                  :escQ.c */
  static int ist;	/*                  :escQ.c */
  void GCLagrangeEqA;	/*  .GCLagrangeEqA():escQ.c */
  static int neq;	/*                  :escQ.c */
  static int itol;	/*                  :escQ.c */
  static double reltol;	/*                  :escQ.c */
  static double *vatol;	/*                  :escQ.c */
  static int itask;	/*                  :escQ.c */
  static int istate;	/*                  :escQ.c */
  static int iopt;	/*                  :escQ.c */
  static int lrw;	/*                  :escQ.c */
  static int *iwork;	/*                  :escQ.c */
  static int liw;	/*                  :escQ.c */
  static int mf;	/*                  :escQ.c */
  static int nst;	/*                  :escQ.c */
/*
   */
#ifdef Doc_GCOrbitPlot2DB
\Section{Skeleton of \c{GCOrbitPlot2DB()}}
  \begin{verbatim}
    GCOrbitPlot2DB(){
    }
  \end{verbatim}
\Section{\c{GCOrbitPlot2DB()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{ZColor()}&$$&\\
\c{Undef }&\c{ES2DMapFlx2Lab()}&$$&\\
\c{Undef }&\c{lsode\_()}&$$&\\
\c{Undef }&\c{ZPlotPolyLine()}&$$&\\
\c{Undef }&\c{out()}&$$&\\
\c{static double }&\c{*rwork}&$$&\\
\c{static double }&\c{yGC[]}&$$&\\
\c{static int }&\c{ist}&$$&\\
\c{void }&\c{GCLagrangeEqA}&$$&\\
\c{static int }&\c{neq}&$$&\\
\c{static int }&\c{itol}&$$&\\
\c{static double }&\c{reltol}&$$&\\
\c{static double }&\c{*vatol}&$$&\\
\c{static int }&\c{itask}&$$&\\
\c{static int }&\c{istate}&$$&\\
\c{static int }&\c{iopt}&$$&\\
\c{static int }&\c{lrw}&$$&\\
\c{static int }&\c{*iwork}&$$&\\
\c{static int }&\c{liw}&$$&\\
\c{static int }&\c{mf}&$$&\\
\c{static int }&\c{nst}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

void GCOrbitPlot2DA()
{
  Undef ZColor();
  Undef ES2DMapFlx2Lab();
  Undef gcmotion_();
  Undef ZPlotLine();
  static int nPart;	/*  :escQ.c */
  static double *rPrt0;	/*  :escQ.c */
  static double *zPrt0;	/*  :escQ.c */
  static double *Xa;	/*  :escQ.c */
  static double *Xgq;	/*  :escQ.c */
  static double *dXgr;	/*  :escQ.c */
  static double *dXa;	/*  :escQ.c */
  static double *dXgq;	/*  :escQ.c */
  static double *dXgf;	/*  :escQ.c */
  static double *Xgr;	/*  :escQ.c */
  static double *Xgm;	/*  :escQ.c */
  static int ist;	/*  :escQ.c */
  static double *rwork;	/*  :escQ.c */
  static double *rPrt1;	/*  :escQ.c */
  static double *zPrt1;	/*  :escQ.c */
  static int nst;	/*  :escQ.c */
  int GCRKStep();	/*  :escQ.c */
/*
   */
#ifdef Doc_GCOrbitPlot2DA
\Section{Skeleton of \c{GCOrbitPlot2DA()}}
  \begin{verbatim}
    GCOrbitPlot2DA(){
    }
  \end{verbatim}
\Section{\c{GCOrbitPlot2DA()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{ZColor()}&$$&\\
\c{Undef }&\c{ES2DMapFlx2Lab()}&$$&\\
\c{Undef }&\c{gcmotion\_()}&$$&\\
\c{Undef }&\c{ZPlotLine()}&$$&\\
\c{static int }&\c{nPart}&$$&\\
\c{static double }&\c{*rPrt0}&$$&\\
\c{static double }&\c{*zPrt0}&$$&\\
\c{static double }&\c{*Xa}&$$&\\
\c{static double }&\c{*Xgq}&$$&\\
\c{static double }&\c{*dXgr}&$$&\\
\c{static double }&\c{*dXa}&$$&\\
\c{static double }&\c{*dXgq}&$$&\\
\c{static double }&\c{*dXgf}&$$&\\
\c{static double }&\c{*Xgr}&$$&\\
\c{static double }&\c{*Xgm}&$$&\\
\c{static int }&\c{ist}&$$&\\
\c{static double }&\c{*rwork}&$$&\\
\c{int }&\c{GCRKStep()}&$$&\\
\c{static double }&\c{*rPrt1}&$$&\\
\c{static double }&\c{*zPrt1}&$$&\\
\c{static int }&\c{nst}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int ESIWriteDensity(Na,Fic)
  int Na;	/*  */
  int Fic;	/*  */
{
  Undef ESSetSplA();
  Undef splRA();
  extern double *ESsa;	/* undefined */
  extern int ESNa;	/* undefined */
  extern double *ESsp;	/* undefined */
  extern double *ESsp2a;/* undefined */
  int Fic;	/*  .ESIWriteDensity():escQ.c */
  int Na;	/*  .ESIWriteDensity():escQ.c */
/*
   */
#ifdef Doc_ESIWriteDensity
\Section{Skeleton of \c{ESIWriteDensity()}}
  \begin{verbatim}
    ESIWriteDensity(){
    }
  \end{verbatim}
\Section{\c{ESIWriteDensity()}}
Relations between plasma temperature, density and ESC pressure
\bqbl
&&
\bsp
=
\gm_0p
=\gm_0n(T_e+T_i)\cdot10^{20}\cdot10^{3}\cdot1.60022\cdot10^{-19}\cdot10^{-6}
.\eqbl
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\begin{tabular}{|llp{4in}|}\hline
\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&$$&\\
\c{}&$$&\\
\c{}&$$&\\
\c{}&$$&\\
\hline\end{tabular}
\Subsection{Output}
\vskip1ex\begin{tabular}{|llp{4in}|}\hline
\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&$$&\\
\c{}&$$&\\
\c{}&$$&\\
\c{}&$$&\\
\hline\end{tabular}
\Subsection{Known Bugs}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int ESOrbits()
{
  Undef esiread_();
  Undef esilink2c_();
  Undef ESSetMapBox();
  Undef ES2DMapFlx2Lab();
  Undef ES1DMapZ2gt();
  Undef ES2DMapLab2Flx();
  Undef ESSetSplA();
  Undef splRA();
  Undef CbStr2UserMessage();
  Undef CbUserPlot;
  Undef ESFreeRZspaceEq();
  extern int ESNp1;	/* undefined */
  extern int ESNa;	/* undefined */
  extern int ESNp;	/* undefined */
  extern double *ESsr;	/* undefined */
  extern double *ESsz;	/* undefined */
  extern double *ESsa;	/* undefined */
  extern double *ESFF;	/* undefined */
  extern double *ESFF2a;/* undefined */
  extern double *ESgY;	/* undefined */
  extern double *ESgY2a;/* undefined */
  extern double *ESaR0;	/* undefined */
  TRAPPED *lBD;			/*                        :escQ.c */
  TRAPPED BounceData;		/*                        :escQ.c */
  static int neq;		/*                        :escQ.c */
  static double XF[];		/*                        :escQ.c */
  static double XFa[];		/*                        :escQ.c */
  static double XgFa[];		/*                        :escQ.c */
  static double XgFaa[];	/*                        :escQ.c */
  static double XgYa[];		/*                        :escQ.c */
  static double XgYaa[];	/*                        :escQ.c */
  static double XT[];		/*                        :escQ.c */
  static double XTa[];		/*                        :escQ.c */
  static double XP[];		/*                        :escQ.c */
  static double XPa[];		/*                        :escQ.c */
  static double Xr[];		/*                        :escQ.c */
  static double Xra[];		/*                        :escQ.c */
  static double Xrq[];		/*                        :escQ.c */
  static double Xz[];		/*                        :escQ.c */
  static double Xza[];		/*                        :escQ.c */
  static double Xzq[];		/*                        :escQ.c */
  static double XB[];		/*                        :escQ.c */
  static double XBa[];		/*                        :escQ.c */
  static double XBq[];		/*                        :escQ.c */
  static double Xgh[];		/*                        :escQ.c */
  static double Xgha[];		/*                        :escQ.c */
  static double Xghq[];		/*                        :escQ.c */
  static int *iwork;		/*                        :escQ.c */
  double cgWc;			/*                        :escQ.c */
  static double ce;		/*                        :escQ.c */
  static double cmi;		/*                        :escQ.c */
  static double cc;		/*                        :escQ.c */
  static double cV1keV;		/*                        :escQ.c */
  static double cEkeV;		/*                        :escQ.c */
  static double cgr1keV;	/*                        :escQ.c */
  static double Vtot;		/*                        :escQ.c */
  static double pVb;		/*                        :escQ.c */
  static double Vb;		/*                        :escQ.c */
  static double Vn;		/*                        :escQ.c */
  static double grn0;		/*                        :escQ.c */
  static double B0;		/*                        :escQ.c */
  static double gmP;		/*                        :escQ.c */
  static double yGC[];		/*                        :escQ.c */
  static double abstol;		/*                        :escQ.c */
  void GCOrbitPlot2D;		/*        .GCOrbitPlot2D():escQ.c */
  void GCOrbitPlot2DLarmor;	/*  .GCOrbitPlot2DLarmor():escQ.c */
  void GCOrbitPlot2DLoss;	/*    .GCOrbitPlot2DLoss():escQ.c */
  static int nPart;		/*                        :escQ.c */
  static double *Xa;		/*                        :escQ.c */
  static double *Xgq;		/*                        :escQ.c */
  static double *Xgf;		/*                        :escQ.c */
  static double *Xgr;		/*                        :escQ.c */
  static double *Xgm;		/*                        :escQ.c */
  void GCOrbitPlot2DA;		/*       .GCOrbitPlot2DA():escQ.c */
  void GCOrbitPlot2DB;		/*       .GCOrbitPlot2DB():escQ.c */
  int ESBasicFunctions();	/*                        :escQ.c */
  int ESFirstBiSpline();	/*                        :escQ.c */
  int ESInitOrbLSODE();		/*                        :escQ.c */
  int ESBiSplRAP();		/*                        :escQ.c */
  int InitLsode4Orbit();	/*                        :escQ.c */
  int FractionLosses();		/*                        :escQ.c */
  int GCInitRKSolv();		/*                        :escQ.c */
  int GCDeInitRKSolv();		/*                        :escQ.c */
  int ESDeInitOrbLSODE();	/*                        :escQ.c */
/*
   */
#ifdef Doc_ESOrbits
\Section{Skeleton of \c{ESOrbits()}}
  \begin{verbatim}
    ESOrbits(){
    }
  \end{verbatim}
\Section{\c{ESOrbits()}}
\Subsection{Formal parameters}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\hline\end{tabular}\vskip1ex
\Subsection{Return values}
{\obeylines\parindent0in
\c{0} - upon success;
\c{1} - if failed;
}
\Subsection{Description}
\Subsubsection{Launching Orbits with the same $P_\gf,\gm$}
\bqbl
&&
P_\gf
=
\bgY+\gr_\parallel\baF
,\quad
\gr_\parallel
=
\R{v_\parallel}{|B|\gW_{c0}}
,\quad
\gm
=
\R{mv^2_\perp}{2|B|}
,\quad
v_\parallel=\q{\R{2(E-\gm|B|)}{m}}
,\quad
m\gW^2_{c0}\R{|B|^2\gr^2_\parallel}{2}
+\gm|B|=E
,\\&&
P_\gf=
\bgY+\gr_\parallel\baF
+(\bgY'+\gr_\parallel\baF')da+\baF\gd\gr_\parallel
,\quad
m\gW^2_{c0}|B|^2\gr_\parallel\gd\gr_\parallel
=-\left(\gm+m\gW^2_{c0}|B|\gr^2_\parallel\right)|B|'_ada
,\\&&
\gd\gr_\parallel
=-\left(\R{\gr^2_\perp}{2}+\gr^2_\parallel\right)\R{|B|'_a}{|B|\gr_\parallel}da
,\quad
\left[\bgY'+\gr_\parallel\baF'
-\baF\left(\R{\gr^2_\perp}{2}+\gr^2_\parallel\right)
 \R{|B|'_a}{|B|\gr_\parallel}\right]da
=
P_\gf
-\bgY-\gr_\parallel\baF
.\eqbl

\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{Undef }&\c{esiread\_()}&$$&\\
\c{Undef }&\c{esilink2c\_()}&$$&\\
\c{Undef }&\c{ESSetMapBox()}&$$&\\
\c{Undef }&\c{ES2DMapFlx2Lab()}&$$&\\
\c{Undef }&\c{ES1DMapZ2gt()}&$$&\\
\c{Undef }&\c{ES2DMapLab2Flx()}&$$&\\
\c{Undef }&\c{ESSetSplA()}&$$&\\
\c{Undef }&\c{splRA()}&$$&\\
\c{Undef }&\c{CbStr2UserMessage()}&$$&\\
\c{Undef }&\c{CbUserPlot}&$$&\\
\c{Undef }&\c{ESFreeRZspaceEq()}&$$&\\
\c{extern int }&\c{ESNp1}&$$&\\
\c{extern int }&\c{ESNa}&$$&\\
\c{extern int }&\c{ESNp}&$$&\\
\c{extern double }&\c{*ESsr}&$$&\\
\c{extern double }&\c{*ESsz}&$$&\\
\c{extern double }&\c{*ESsa}&$$&\\
\c{extern double }&\c{*ESFF}&$$&\\
\c{extern double }&\c{*ESFF2a}&$$&\\
\c{extern double }&\c{*ESgY}&$$&\\
\c{extern double }&\c{*ESgY2a}&$$&\\
\c{extern double }&\c{*ESaR0}&$$&\\
\c{TRAPPED }&\c{*lBD}&$$&\\
\c{TRAPPED }&\c{BounceData}&$$&\\
\c{int }&\c{ESBasicFunctions()}&$$&\\
\c{int }&\c{ESFirstBiSpline()}&$$&\\
\c{int }&\c{ESInitOrbLSODE()}&$$&\\
\c{static int }&\c{neq}&$$&\\
\c{static double }&\c{XF[]}&$$&\\
\c{static double }&\c{XFa[]}&$$&\\
\c{static double }&\c{XgFa[]}&$$&\\
\c{static double }&\c{XgFaa[]}&$$&\\
\c{static double }&\c{XgYa[]}&$$&\\
\c{static double }&\c{XgYaa[]}&$$&\\
\c{static double }&\c{XT[]}&$$&\\
\c{static double }&\c{XTa[]}&$$&\\
\c{static double }&\c{XP[]}&$$&\\
\c{static double }&\c{XPa[]}&$$&\\
\c{static double }&\c{Xr[]}&$$&\\
\c{static double }&\c{Xra[]}&$$&\\
\c{static double }&\c{Xrq[]}&$$&\\
\c{static double }&\c{Xz[]}&$$&\\
\c{static double }&\c{Xza[]}&$$&\\
\c{static double }&\c{Xzq[]}&$$&\\
\c{static double }&\c{XB[]}&$$&\\
\c{static double }&\c{XBa[]}&$$&\\
\c{static double }&\c{XBq[]}&$$&\\
\c{static double }&\c{Xgh[]}&$$&\\
\c{static double }&\c{Xgha[]}&$$&\\
\c{static double }&\c{Xghq[]}&$$&\\
\c{static int }&\c{*iwork}&$$&\\
\c{double }&\c{cgWc}&$$&\\
\c{static double }&\c{ce}&$$&\\
\c{static double }&\c{cmi}&$$&\\
\c{static double }&\c{cc}&$$&\\
\c{static double }&\c{cV1keV}&$$&\\
\c{static double }&\c{cEkeV}&$$&\\
\c{static double }&\c{cgr1keV}&$$&\\
\c{int }&\c{ESBiSplRAP()}&$$&\\
\c{static double }&\c{Vtot}&$$&\\
\c{static double }&\c{pVb}&$$&\\
\c{static double }&\c{Vb}&$$&\\
\c{static double }&\c{Vn}&$$&\\
\c{static double }&\c{grn0}&$$&\\
\c{static double }&\c{B0}&$$&\\
\c{static double }&\c{gmP}&$$&\\
\c{static double }&\c{yGC[]}&$$&\\
\c{int }&\c{InitLsode4Orbit()}&$$&\\
\c{static double }&\c{abstol}&$$&\\
\c{void }&\c{GCOrbitPlot2D}&$$&\\
\c{void }&\c{GCOrbitPlot2DLarmor}&$$&\\
\c{int }&\c{FractionLosses()}&$$&\\
\c{void }&\c{GCOrbitPlot2DLoss}&$$&\\
\c{int }&\c{GCInitRKSolv()}&$$&\\
\c{static int }&\c{nPart}&$$&\\
\c{static double }&\c{*Xa}&$$&\\
\c{static double }&\c{*Xgq}&$$&\\
\c{static double }&\c{*Xgf}&$$&\\
\c{static double }&\c{*Xgr}&$$&\\
\c{static double }&\c{*Xgm}&$$&\\
\c{void }&\c{GCOrbitPlot2DA}&$$&\\
\c{void }&\c{GCOrbitPlot2DB}&$$&\\
\c{int }&\c{GCDeInitRKSolv()}&$$&\\
\c{int }&\c{ESDeInitOrbLSODE()}&$$&\\
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{Output}
\vskip1ex\noindent\begin{tabular}{|lllp{4in}|}\hline
\c{Type}&\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&\c{}&$$&\\
\hline\end{tabular}\vskip1ex
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int ESFractionOfTrapped(frac,i)
  double *frac;	/*  */
  int i;	/*  */
{
  extern double *ESsa;	/* undefined */
  extern double *ESdgY;	/* undefined */
  extern double *ESFF;	/* undefined */
  extern double *ESaR0;	/* undefined */
  extern double *rcT;	/* undefined */
  extern double *ESaZ0;	/* undefined */
  extern double *rsT;	/* undefined */
  extern double *rcT1a;	/* undefined */
  extern double *rsT1a;	/* undefined */
  extern double *ESsb;	/* undefined */
  extern double *ESsb1a;/* undefined */
  extern int ESFp1;	/* undefined */
  extern int ESNa1;	/* undefined */
  extern int ESNp;	/* undefined */
  extern double *EScs1;	/* undefined */
  extern double *ESsn1;	/* undefined */
  extern int ESNp1;	/* undefined */
  extern double *ESgt;	/* undefined */
  int i;	/*  .ESFractionOfTrapped():escQ.c */
  double *frac;	/*  .ESFractionOfTrapped():escQ.c */
/*
   */
#ifdef Doc_ESFractionOfTrapped
\Section{Skeleton of ESFractionOfTrapped()}
  \begin{verbatim}
    ESFractionOfTrapped(){
    }
  \end{verbatim}
\Section{ESFractionOfTrapped()}
#endif
}

int ESFractionOfTrapped1(frac,a)
  double *frac;	/*  */
  double a;	/*  */
{
  Undef ESSetSplA();
  Undef splRA();
  extern double *ESdgY;		/* undefined */
  extern double *ESdgY2a;	/* undefined */
  extern double *ESFF;		/* undefined */
  extern double *ESFF2a;	/* undefined */
  extern double *rcT;		/* undefined */
  extern double *rcT2a;		/* undefined */
  extern double *ESaR0;		/* undefined */
  extern double *rsT;		/* undefined */
  extern double *rsT2a;		/* undefined */
  extern double *ESaZ0;		/* undefined */
  extern double *ESsb;		/* undefined */
  extern double *ESsb2a;	/* undefined */
  extern int ESFp1;		/* undefined */
  extern int ESNa1;		/* undefined */
  extern int ESNp;		/* undefined */
  extern double *EScs1;		/* undefined */
  extern double *ESsn1;		/* undefined */
  extern int ESNp1;		/* undefined */
  extern double *ESgt;		/* undefined */
  double a;	/*  .ESFractionOfTrapped1():escQ.c */
  double *frac;	/*  .ESFractionOfTrapped1():escQ.c */
/*
   */
#ifdef Doc_ESFractionOfTrapped1
\Section{Skeleton of \c{ESFractionOfTrapped1()}}
  \begin{verbatim}
    ESFractionOfTrapped1(){
    }
  \end{verbatim}
\Section{\c{ESFractionOfTrapped1()}}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\begin{tabular}{|llp{4in}|}\hline
\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&$$&\\
\c{}&$$&\\
\c{}&$$&\\
\c{}&$$&\\
\hline\end{tabular}
\Subsection{Output}
\vskip1ex\begin{tabular}{|llp{4in}|}\hline
\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&$$&\\
\c{}&$$&\\
\c{}&$$&\\
\c{}&$$&\\
\hline\end{tabular}
\Subsection{Known Bugs}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}
double ESjbs[];	/*  */

int ESBootstrap1()
{
  Undef f2spl();
  Undef ESSetSplA();
  Undef splRA();
  Undef ES2DMapFlx2Lab();
  Undef splr0();
  Undef out();
  extern double *ESLc;		/* undefined */
  extern double *ESLc2;		/* undefined */
  extern double *ESVc;		/* undefined */
  extern double *ESVc2;		/* undefined */
  extern double *ESaR0;		/* undefined */
  extern double cgp;		/* undefined */
  extern double *ESsq;		/* undefined */
  extern double *ESsq2a;	/* undefined */
  extern double *ESsp;		/* undefined */
  extern double *ESsp2a;	/* undefined */
  extern double *ESPs;		/* undefined */
  extern double *ESPs2a;	/* undefined */
  extern double *ESdgY;		/* undefined */
  extern double *ESdgY2a;	/* undefined */
  extern double crgm0;		/* undefined */
  double ESjbs[];		/*  :escQ.c */
  int ESFractionOfTrapped1();	/*  :escQ.c */
/*
   */
#ifdef Doc_ESBootstrap1
\Section{Skeleton of \c{ESBootstrap1()}}
  \begin{verbatim}
    ESBootstrap1(){
    }
  \end{verbatim}
\Section{\c{ESBootstrap1()}}
\Subsection{Description}
\Subsection{Algorithm}
\Subsection{Input}
\vskip1ex\begin{tabular}{|llp{4in}|}\hline
\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&$$&\\
\c{}&$$&\\
\c{}&$$&\\
\c{}&$$&\\
\hline\end{tabular}
\Subsection{Output}
\vskip1ex\begin{tabular}{|llp{4in}|}\hline
\c{ID}&\bf\em Math&\bf\em Comment\\\hline
\c{}&$$&\\
\c{}&$$&\\
\c{}&$$&\\
\c{}&$$&\\
\hline\end{tabular}
\Subsection{Known Bugs}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{ToDo}
\begin{enumerate}
\item
\end{enumerate}
\Subsection{References}
#endif
}

int ESBootstrap()
{
  Undef SetPlotName();
  Undef Scale2d();
  Undef Plot2d();
  extern double *ESjb;	/* undefined */
  extern int ESNa1;	/* undefined */
  extern double *ESLc;	/* undefined */
  extern double *ESVc;	/* undefined */
  extern double *ESaR0;	/* undefined */
  extern int ESNp1;	/* undefined */
  extern double *ESsr;	/* undefined */
  extern int ESNp;	/* undefined */
  extern double *ESsq;	/* undefined */
  extern double *ESsp;	/* undefined */
  extern double *ESPs;	/* undefined */
  extern double *ESsa;	/* undefined */
  double ESjbs[];		/*  :escQ.c */
  int ESFractionOfTrapped();	/*  :escQ.c */
/*
   */
#ifdef Doc_ESBootstrap
\Section{Skeleton of ESBootstrap()}
  \begin{verbatim}
    ESBootstrap(){
    }
  \end{verbatim}
\Section{ESBootstrap()}
Simplified expression for the bootstrap current
\bqbl
&&
j_{\parallel}
=
xA\R{dp}{d\bgY}\R{R_0}{\left<\R{1}{r^2}\right>}
,\\&&
A
=
\R{0.754+2.21Z+Z^2+x(0.348+1.24Z+Z^2)}
{1.414Z+Z^2+x(0.754+2.657Z+2Z^2)+x^2(0.348+1.243Z+Z^2)}
.\eqbl
Fraction of trapped particles\cite{Hirshman88}
\bqbl
&&
f_t
=
1-\R{3}{4}\left<h^2\right>\int^1_0
 \R{\gl d\gl}{\left<\q{1-\gl h}\right>}
,\quad
h
\equiv
\R{B}{B_{max}}
,\quad
x
\equiv
\R{f_t}{1-f_t}
.\eqbl
Roscoe expression for a circular tokamak
\bqbl
&&
j_b
=
-\q{\R{R}{a}}\R{q}{B}\R{dp}{dr}
=
-\q{\R{a}{R}}\R{1}{B_p}\R{dp}{dr}
=
\q{\R{a}{R}}R\R{\R{dp}{dr}}{\R{d\bgY}{dr}}
=
\q{\R{a}{R}}R\R{dp}{d\bgY}
.\eqbl
Roscoe conversion to [MA/m$^2$]
\bqbl
&&
\R{v^2}{c^2}
=
\R{2E\cdot1.6022}{1.6726\cdot2.9979^2\cdot10^5p}
=
\R{2E}{9.3823\cdot10^5p}
,\quad
v
=
4.37\cdot10^5\q{\R{E}{p}}
,\\&&
j
=
nve\cdot10^{20}\cdot10^{-6}
=
n1.6022\cdot10^{-19}4.37\cdot10^5\q{\R{E}{p}}
\cdot10^{20}\cdot10^{-6}
=
1.6022\cdot4.37n\q{\R{E}{p}}
=
7.0128n\q{\R{E}{p}}
.\eqbl

\begin{verbatim}
 i   sq(a/R)         AxA/sqrt(a/R) 1/<R/r^2>1/<R^2/r^2>        jb       jBS
 1 1.112e-01 1.296e+00 1.955e+00 4.064e+00 9.998e-01 1.765e-02 3.450e-02
 1 frac= 1.437e-01 x= 1.678e-01
 2 1.572e-01 1.132e+00 2.032e+00 4.062e+00 9.992e-01 2.477e-02 5.030e-02
 2 frac= 2.202e-01 x= 2.823e-01
 3 1.926e-01 1.025e+00 2.002e+00 4.057e+00 9.981e-01 2.996e-02 5.987e-02
 3 frac= 2.733e-01 x= 3.760e-01
 4 2.224e-01 9.436e-01 1.961e+00 4.051e+00 9.966e-01 3.398e-02 6.642e-02
 4 frac= 3.161e-01 x= 4.623e-01
 5 2.487e-01 8.763e-01 1.921e+00 4.043e+00 9.946e-01 3.710e-02 7.089e-02
 5 frac= 3.528e-01 x= 5.451e-01
 6 2.725e-01 8.189e-01 1.883e+00 4.034e+00 9.923e-01 3.946e-02 7.372e-02
 6 frac= 3.851e-01 x= 6.264e-01
 7 2.944e-01 7.689e-01 1.847e+00 4.022e+00 9.894e-01 4.111e-02 7.513e-02
 7 frac= 4.142e-01 x= 7.072e-01
 8 3.148e-01 7.244e-01 1.814e+00 4.009e+00 9.861e-01 4.208e-02 7.526e-02
 8 frac= 4.407e-01 x= 7.881e-01
 9 3.339e-01 6.845e-01 1.783e+00 3.993e+00 9.823e-01 4.239e-02 7.422e-02
 9 frac= 4.652e-01 x= 8.697e-01
10 3.521e-01 6.483e-01 1.753e+00 3.976e+00 9.781e-01 4.203e-02 7.207e-02
10 frac= 4.878e-01 x= 9.523e-01
11 3.694e-01 6.152e-01 1.726e+00 3.957e+00 9.733e-01 4.101e-02 6.887e-02
11 frac= 5.089e-01 x= 1.036e+00
12 3.860e-01 5.848e-01 1.699e+00 3.935e+00 9.680e-01 3.931e-02 6.467e-02
12 frac= 5.286e-01 x= 1.121e+00
13 4.019e-01 5.568e-01 1.674e+00 3.911e+00 9.621e-01 3.694e-02 5.950e-02
13 frac= 5.472e-01 x= 1.208e+00
14 4.172e-01 5.308e-01 1.650e+00 3.885e+00 9.557e-01 3.386e-02 5.341e-02
14 frac= 5.647e-01 x= 1.297e+00
15 4.320e-01 5.066e-01 1.628e+00 3.856e+00 9.486e-01 3.008e-02 4.644e-02
15 frac= 5.812e-01 x= 1.388e+00
16 4.464e-01 4.841e-01 1.606e+00 3.824e+00 9.407e-01 2.557e-02 3.863e-02
16 frac= 5.968e-01 x= 1.480e+00
17 4.603e-01 4.632e-01 1.584e+00 3.789e+00 9.320e-01 2.033e-02 3.002e-02
17 frac= 6.115e-01 x= 1.574e+00
18 4.738e-01 4.437e-01 1.564e+00 3.749e+00 9.223e-01 1.433e-02 2.066e-02
18 frac= 6.254e-01 x= 1.670e+00
19 4.871e-01 4.257e-01 1.543e+00 3.705e+00 9.114e-01 7.558e-03 1.063e-02
19 frac= 6.384e-01 x= 1.765e+00
20 5.000e-01 4.093e-01 1.523e+00 3.654e+00 8.988e-01 0.000e+00 0.000e+00
20 frac= 6.504e-01 x= 1.860e+00
\end{verbatim}

Viscous coefficients
\bqbl
&&
\h{\gm}^e_{ij}
\equiv
3\gm^e_{ij}\R{\left<(\wsn\cdot\na B)^2\right>}{\left<B^2\right>}
.\eqbl
Thermal friction coefficients
\bqbl
&&
l_{11}
=
\R{m_en_e}{\gt_{ei}}
,\quad
l_{12}
=
-\R{3}{2}l_{11}
,\quad
l_{22}
=
\left(\R{13}{4}+\R{\q{2}}{Z_i}\right)l_{11}
.\eqbl
Viscous constants Eq(9a-f)\cite{Hirshman88}
\bqbl
&&
\h{\gm}^e_{11}
=
\R{n_em_ex}{\gt_{ee}}(0.533+Z_i)
,\quad
\h{\gm}^e_{12}
=
-\R{n_em_ex}{\gt_{ee}}(0.625+1.5Z_i)
,\quad
\h{\gm}^e_{22}
=
\R{n_em_ex}{\gt_{ee}}(1.386+3.25Z_i)
,\\&&
\h{\gm}^i_{11}
=
\R{\q{2}n_im_ix}{\gt_{ii}}0.377
,\quad
\h{\gm}^i_{12}
=
-\R{\q{2}n_im_ix}{\gt_{ii}}0.442
,\quad
\h{\gm}^i_{22}
=
\R{\q{2}n_im_ix}{\gt_{ii}}0.980
.\eqbl
Other constants
\bqbl
&&
j_0
=
-\R{2\gp I}{\gc'}cp_e
,\\&&
d_1
=
\h{\gm}^e_{11}(\h{\gm}^e_{22}+l_{22})-\h{\gm}^e_{12}(\h{\gm}^e_{12}+l_{12})
,\quad
d_2
=
\h{\gm}^e_{12}(\h{\gm}^e_{22}+l_{22})-\h{\gm}^e_{22}(\h{\gm}^e_{12}+l_{12})
,\\&&
D
=
(\h{\gm}^e_{11}+l_{11})(\h{\gm}^e_{22}+l_{22})-(\h{\gm}^e_{12}+l_{12})^2
.\eqbl
Ion viscous function
\bqbl
&&
\ga_i
=
\R{}{}\R{\h{\gm}^i_{12}l^i_{22}}
{\h{\gm}^i_{11}(l^i_{22}+\h{\gm}^i_{22})-\h{\gm}^i_{12}\h{\gm}^i_{12}}
,\quad
l^i_{22}
=
\R{\q{2}n_im_i}{\gt_{ii}}
.\eqbl
Expression\cite{Hirshman88} for the bootstrap current
\bqbl
&&
\left<\wsj\cdot\waB\right>
=
\R{d_1}{D} \left[j_0\left(\R{p'_e}{p_e}-\R{|e|\gF'}{T_e}\right)
+n_e|e|\left<\wsu_i\cdot\waB\right>\right]
+\R{d_2}{D}j_0\R{T'_e}{T_e}
,\eqbl
where
\bqbl
&&
\R{n_e|e|}{j_0}\left<\wsu_i\cdot\waB\right>
=
\R{T_i}{Z_iT_e}\left(\R{p'_i}{p}+\R{Z_i|e|\gF'}{T_i}+\ga_i\R{T'_i}{T_i}
\right)
.\eqbl

JSOLVER expression for the bootstrap current
\bqbl
&&
j_{BS}=
-\R{1}{d<D/r>}\left[a_1\left(\R{d\bsp}{d\bgY}
-\ga_i\bsp_i\R{T'_i}{T_i}\right)
-a_2\bsp_e\R{T'_e}{T_e}\right]
,\\&&
\ga_i
=
\R{1.172}{1+0.462x}
,\quad
x
=
\R{f}{1-f}
,\\&&
d=
(1.414+Z)Z+x((0.754+(2.657+2Z)Z)+x(0.348+(1.243+Z)Z))
.\\&&
a_1
=
x(0.754+Z(2.21+Z)+x(0.348+Z(1.24+Z)))
,\quad
a_2
=
x(0.884+2.07Z)
,\eqbl
where $f$ is the fraction of trapped particles, $Z=Z_{eff}$,

\bibliography{stab}
\bibliographystyle{prsty}
#endif
}
#endif

#undef Doc_Cb_Structure
#ifdef Blb_escQ.c
Blb_escQ.c{
  mzl_MLIB{
  }
}
#endif

#undef Doc_Table_Of_Content
#ifndef Blb_escQ.c
				PS p= 66 ( 33);
#ifndef mzl_MLIB
				PS p=  1 (  1);
#endif
int GCInitRKSolv();		PS p=  2 (  1);
int GCDeInitRKSolv();		PS p=  3 (  2);
int ESIget2DFunc();		PS p=  3 (  2);
int GCRKStep();			PS p=  3 (  2);
int ESBasicFunctions();		PS p=  4 (  2);
int ESWriteESI0();		PS p=  9 (  5);
int ESWriteESI();		PS p= 13 (  7);
int ESBasicFunctionsPEST();	PS p= 16 (  8);
int ES2PEST();			PS p= 22 ( 11);
int ESBasicFunctionsHamada();	PS p= 24 ( 12);
int ES2Hamada();		PS p= 31 ( 16);
int ESBasicFunctionsBoozer();	PS p= 33 ( 17);
int ES2Boozer();		PS p= 39 ( 20);
int ESBasicFunctionsHat();	PS p= 41 ( 21);
int ES2Hat(); 		        PS p= 48 ( 24);
int ESFirstBiSpline();		PS p= 50 ( 25);
int ESBiSplRAP();		PS p= 50 ( 25);
int ESBiSplRA();		PS p= 53 ( 27);
void GCLagrangeEq();		PS p= 53 ( 27);
void GCLagrangeEqA();		PS p= 54 ( 27);
int ES4Output();		PS p= 55 ( 28);
int ESInitOrbLSODE();		PS p= 55 ( 28);
int ESDeInitOrbLSODE();		PS p= 56 ( 28);
int GetBounceTime();		PS p= 56 ( 28);
int InitLsode4Orbit();		PS p= 56 ( 28);
void GCOrbitPlot2D();		PS p= 57 ( 29);
void GCOrbitPlot2DLarmor();	PS p= 58 ( 29);
int FractionLosses();		PS p= 60 ( 30);
int ReadFractionLosses();	PS p= 61 ( 31);
void GCOrbitPlot2DLoss();	PS p= 62 ( 31);
void GCOrbitPlot2DB();		PS p= 64 ( 32);
void GCOrbitPlot2DA();		PS p= 65 ( 33);
int ESIWriteDensity();		PS p= 65 ( 33);
int ESOrbits();			PS p= 66 ( 33);
int ESFractionOfTrapped();	PS p= 70 ( 35);
int ESFractionOfTrapped1();	PS p= 71 ( 36);
int ESBootstrap1();		PS p= 73 ( 37);
int ESBootstrap();		PS p= 78 ( 39);
#endif
