#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>

extern clock_t clock(void);

extern double cr2,cr3,cr4,cr6,cr12,cgp,c2gp,cgp_4,cr2gp,cgm0,crgm0;
extern int ESNa,ESNa1;
extern int ESNp,ESNp1,ESFp,ESFp1,ESnAP,ESnAF,ESMp,ESMp1,ES2Mp,ES2Mp1;
extern int ESEqSolvFl,ESEqSolvInPr,ESEqSolvInCr;
extern double *ESsa,*ESpa,*ESgt;
extern double ESaRx,ESaZx,*ESaR0,*ESaZ0,*ESsr,*ESsz,*ESsb,*ESsb1a,*ESsb2a;
extern double *rcT,*rcT1a,*rcT2a,*rsT,*rsT1a,*rsT2a;
extern double ESBt,ESRBt,ESRext,ESgbext;
extern double *ESLc,*ESLc2,*ESLs,*ESLs2,*ESVc,*ESVc2,*ESVs,*ESVs2,*ESDPc;
extern double *cs1,*sn1,*cs2,*sn2,*dra,*dza,*drgt,*dzgt;

extern double *ESgY0;

extern double *ESRC,*ESRC1a,*ESRC2a
,*ESqgF,*ESqgF1a,*ESqgF2a
,*ESqgY,*ESqgY1a,*ESqgY2a
,*ESsh,*ESsh1a,*ESsh2a
,*ESqV,*ESqV1a,*ESqV2a

,*ESjp,*ESjp1a,*ESjp2a
,*ESsp,*ESsp1a,*ESsp2a
,*ESPs,*ESPs1a,*ESPs2a
,*ESgb,*ESgb1a,*ESgb2a
,*ESgB,*ESgB1a,*ESgB2a

,*ESjs,*ESjs1a,*ESjs2a
,*ESjb,*ESjb1a,*ESjb2a
,*ESaJ,*ESaJ1a,*ESaJ2a
,*ESaT,*ESaT1a,*ESaT2a
,*ESjB,*ESjB1a,*ESjB2a

,*ESsq,*ESsq1a,*ESsq2a
,*ESgm,*ESgm1a,*ESgm2a
,*ESgY,*ESgY1a,*ESgY2a
,*ESgF,*ESgF1a,*ESgF2a

,*ESaF,*ESaF1a,*ESaF2a
,*ESFF,*ESFF1a,*ESFF2a
,*ESdgY,*ESdgY1a,*ESdgY2a
,*ESjR,*ESjR1a,*ESjR2a;

static int FlVm6=1;
static double *rdPV,*zdPV;
int VmNa=40,VmMpol=10;
static int VmNa1=41, FlVm=0;
static double R[65*201],Z[65*201],gL[65*201]
,R1[65*201],Z1[65*201],gL1[65*201];
static clock_t Vmt0;

static int nAjso=64,nA1jso=65,nPjso=64,nP1jso=65,nAPjso=65*65;
static double Rjso[65*65],Zjso[65*65],psibar0;

#ifdef H
static int nAjso=4*64,nA1jso=4*64+1,nPjso=4*64,nP1jso=4*64+1,nAPjso=257*257;
static double Rjso[257*257],Zjso[257*257],psibar0;
#endif

static int FlStart=0;
static int nDjso=21;
static double pprime_s[21],ajb[21];

double xahg[4000],gpahg[4000],gp2a[4000];/*data for A.H.Glasser*/
int nahg; 			/*data for A.H.Glasser*/

int Dcon2Esc(dfname)
     char dfname[80];
{
  int i,i0,i1;
  double xgt[65],ygt[65],s;
  double x[2],y[2];
  static int mm[2],n1,nt1;
  double *f;

  openftn_(dfname);
  i	=2;
  frdi_(mm,&i);
  n1	=mm[0];
  nt1	=mm[1];
  printf("nr=%4d ntau=%4d\n",n1,nt1);

  printf("Reading Flux coordinates R,Z, [m]\n");
  x[0]	=rdPV[2];
  x[1]	=rdPV[3];
  y[0]	=zdPV[1];
  y[1]	=zdPV[0];
  Scale2D(4,2,x,y,2,6,2);
  for(i=0;i < n1;i++){
    printf("i=%4d x=%12.4e\n",i+1,xahg[i]);
    frdd_(xgt,&nt1);
    frdd_(ygt,&nt1);
    Plot2d(4,xgt,ygt,nt1,6,0,0,0);
  }
  CbFlush();
  printf("??? ->");
  getchar();

  f	=(double*)malloc(2*n1*sizeof(double));
  printf("Reading \\Psi, [Vsec]\n");
  frdd_(f,&n1);

  i0=0;
  i1=n1;

#ifdef H
  s	=1./f[n1-1];
#endif
  s	=1./(n1-1);
  for(i=0;i<n1;i++){
    printf("Psi[%3d]=%12.4e\n",i,f[i]);
#ifdef H
    xahg[i]=f[i]*s;
#endif
    xahg[i]=s*i;
  }
  x[0]	=xahg[i0];
  x[1]	=xahg[i1-1];
  y[0]	=f[i0];
  y[1]	=f[i1-1];
  Scale2D(4,2,x,y,2,6,2);
  Plot2d(4,xahg+i0,f+i0,i1-i0,6,0,0,0);
  CbFlush();
  printf("??? ->");
  getchar();

  printf("Reading q \n");
  frdd_(f,&n1);
  for(i= 0;i<n1;i++)
    printf("q[%3d]=%12.4e\n",i,f[i]);

  x[0]	=xahg[i0];
  x[1]	=xahg[i1-1];
  y[0]	=f[i0];
  y[1]	=f[i1-1];
  Scale2D(4,2,x,y,2,6,2);
  Plot2d(4,xahg+i0,f+i0,i1-i0,6,0,0,0);
  CbFlush();
  printf("??? ->");
  getchar();

  printf("Writing RB_{tor} [mTesla]\n");
  frdd_(f,&n1);
  for(i= 0;i<n1;i++)
    printf("rB[%3d]=%12.4e\n",i,f[i]);

  x[0]	=xahg[i0];
  x[1]	=xahg[i1-1];
  y[0]	=f[i0];
  y[1]	=f[i1-1];
  Scale2D(4,2,x,y,2,6,2);
  Plot2d(4,xahg+i0,f+i0,i1-i0,6,0,0,0);
  CbFlush();
  printf("??? ->");
  getchar();

  printf("Writing {d(RB_{tor})\\over d\\Psi} [mTesla/Vsec]\n");
  frdd_(f,&n1);
  for(i= 0;i<n1;i++)
    printf("FF'(Psi)[%3d]=%12.4e\n",i,f[i]);

  x[0]	=xahg[i0];
  x[1]	=xahg[i1-1];
  y[0]	=f[i0];
  y[1]	=f[i1-1];
  Scale2D(4,2,x,y,2,6,2);
  Plot2d(4,xahg+i0,f+i0,i1-i0,6,0,0,0);
  CbFlush();
  printf("??? ->");
  getchar();

  printf("Writing {dp\\over d\\Psi} [MPa/Vsec]\n");
  frdd_(f,&n1);
  for(i= 0;i<n1;i++)
    printf("p'(Psi)[%3d]=%12.4e\n",i,f[i]);

  x[0]	=xahg[i0];
  x[1]	=xahg[i1-1];
  y[0]	=f[i0];
  y[1]	=f[i1-1];
  Scale2D(4,2,x,y,2,6,2);
  Plot2d(4,xahg+i0,f+i0,i1-i0,6,0,0,0);
  CbFlush();
  printf("??? ->");
  getchar();

  closeftn_();
  free(f);
  printf("%s Interface file for DCON\n",dfname);
  return(0);
}

int ES4Dcon1()
{
  FILE *fp;
  int i,ii,j,k,ki;
  double a,b,rc[65],rs[65],w[10];
  int na,na1;
  double dx;

  fp=fopen("dc.d","w");

  na	=1024;
  na1	=na+1;
  dx	=ESsa[ESNa]/na;
  spl(gpahg,gp2a,ESsa,ESdgY+ESNa,xahg,&nahg);
  ii	=0;
  for(i=0; i < na1; i++){
    a		=dx*i;
    while(xahg[ii+1] < a){
      ii++;
    }
    splr1(w,NULL,&a,gpahg,gp2a,xahg,&nahg,&ii); /*$\Psi$*/
    ESSetSplA(a);
    splRA(w+1,NULL,ESgm,ESgm2a);
    w[1]	=1./w[1];	/*$q$*/
    splRA(w+2,NULL,ESaF,ESaF2a);/*$RB_{tor}$*/
    splRA(w+3,NULL,ESaT,ESaT2a);
    w[3]	/=w[2];		/*${d(RB_{tor}\over d\Psi}$*/
    splRA(w+4,NULL,ESPs,ESPs2a);		/*${dp\over d\Psi}$*/
    splRA(w+5,NULL,ESsb,ESsb2a);/*$b$*/
    splRA(rc,NULL,rcT,rcT2a);
    splRA(rs,NULL,rsT,rsT2a);
    ki		=0;
    for(k=1; k < ESFp1; k++){
      ki	+=ESNa1;
      splRA(rc+k,NULL,rcT+ki,rcT2a+ki);
      rc[k]	*=2.;
      splRA(rs+k,NULL,rsT+ki,rsT2a+ki);
      rs[k]	*=2.;
    }
    fwrite(w,(size_t)sizeof(double),(size_t)6,fp);
    fwrite(rc,(size_t)sizeof(double),(size_t)33,fp);
  }
  fclose(fp);
  return(0);
}

int ES4Dcon(double ttime)
{
  int i,ii,j,k,ki,kj;
  double a,b,rc[65],rs[65],xgt[129],ygt[129];
  int mm[2],n1,na,na1;
  double *f,*xa,dx;
  char str[12];

  sprintf(str,"ES4Dcon%4.2f",ttime);

  na	=128;
  openftn_(str);
  data4ahg_(xahg,gpahg,&nahg);
  if(nahg < 4000){
    printf("nahg=%d\n",nahg);
  }
  else{
    printf("nahg=%d%c\n",nahg,7);
    return(0);
  }

  n1	=nahg+1;
  i	=nahg;
  j	=i-1;
  while(i > 0){
    xahg[i]	=xahg[j];
    gpahg[i]	=gpahg[j];
#ifdef H
    printf("i=%4d x=%12.4e %12.4e\n",i,xahg[i],gpahg[i]);
#endif
    i--;
    j--;
  }
  xahg[i]	=0.;
  gpahg[i]	=0.;
#ifdef H
  printf("i=%4d x=%12.4e %12.4e\n",i,xahg[i],gpahg[i]);
#endif
  na1	=na+1;

  f	=(double*)malloc(2*na1*sizeof(double));
  xa	=f+na1;
  dx	=ESsa[ESNa]/na;

  spl(gpahg,gp2a,ESsa,ESdgY+ESNa,xahg,&nahg);
  j	=2;
#ifdef H
  printf("nr=%4d ntau=%4d\n",ESNa1,ESNp1);
#endif
  mm[0]	=na1;
  mm[1]	=ESNp1;
  fwri_(mm,&j);		/* {\tt write(1)ma,mtau}*/
  
  printf("Writing Flux coordinates R,Z, [m]\n");
  for(j=0; j < ESNp1; j++){
    xgt[j]	=ESaR0[0];
    ygt[j]	=ESaZ0[0];
  }
  fwrd_(xgt,&ESNp1);/*$r$, {\tt write(1)(r(itau,ia)),itau=1,mtau)}*/
  fwrd_(ygt,&ESNp1);/*$r$, {\tt write(1)(z(itau,ia)),itau=1,mtau)}*/
  xa[0]	=0.;
  for(i=1; i < na1; i++){
    xa[i]	=dx*i;
    a		=xa[i];
    ESSetSplA(a);
    splRA(&b,NULL,ESsb,ESsb2a);
    splRA(rc,NULL,rcT,rcT2a);
    splRA(rs,NULL,rsT,rsT2a);
    ki		=0;
    for(k=1; k < ESFp1; k++){
      ki	+=ESNa1;
      splRA(rc+k,NULL,rcT+ki,rcT2a+ki);
      rc[k]	*=2.;
      splRA(rs+k,NULL,rsT+ki,rsT2a+ki);
      rs[k]	*=2.;
    }
    for(j=0; j < ESNp1; j++){
      xgt[j]	=ESaR0[0]+rc[0];
      ygt[j]	=ESaZ0[0]+rs[0]+b*sn1[j];
      kj	=0;
      for(k=1; k < ESFp1; k++){
	kj	+=j;
	if(kj >= ESNp)
	  kj	-=ESNp;
	xgt[j]	+=rc[k]*cs1[kj]+rs[k]*sn1[kj];
      }
    }
    fwrd_(xgt,&ESNp1);/*$r$, {\tt write(1)(r(itau,ia)),itau=1,mtau)}*/
    fwrd_(ygt,&ESNp1);/*$r$, {\tt write(1)(z(itau,ia)),itau=1,mtau)}*/
  }

  printf("Writing \\Psi, [Vsec]\n");
  ii	=0;
  for(i=0; i < na1; i++){
    while(xahg[ii+1] < xa[i]){
      ii++;
    }
    splr1(f+i,NULL,xa+i,gpahg,gp2a,xahg,&nahg,&ii);
    f[i]	*=c2gp;
#ifdef H
    printf("x[%4d]=%12.4e f=%12.4e\n",i,xa[i],f[i]);
#endif
  }
  fwrd_(f,&na1);		/*$\Psi,\ [Vsec]$*/

  printf("Writing q \n");
  for(i=0; i < na1; i++){
    ESSetSplA(xa[i]);
    splRA(&b,NULL,ESgm,ESgm2a);
    f[i]	=1./b;
  }
  fwrd_(f,&na1);		/*$q$*/

  printf("Writing RB_{tor} [mTesla]\n");
  f[0]	=sqrt(ESaF[0]);
  for(i=0; i < na1; i++){
    ESSetSplA(xa[i]);
    splRA(f+i,NULL,ESaF,ESaF2a);
  }
  fwrd_(f,&na1);		/*$RB_{tor}$*/

  printf("Writing {d(RB_{tor})\\over d\\Psi} [mTesla/Vsec]\n");
  for(i=0; i < na1; i++){
    ESSetSplA(xa[i]);
    splRA(&b,NULL,ESaT,ESaT2a);
    f[i]=b*cr2gp/f[i];
  }
  fwrd_(f,&na1);		/*${d(RB_{tor}\over d\Psi}$*/

  printf("Writing {dp\\over d\\Psi} [MPa/Vsec]\n");
  b	=5.*cr2gp*cr2gp;
  for(i=0; i < na1; i++){
    ESSetSplA(xa[i]);
    splRA(f+i,NULL,ESPs,ESPs2a);
    f[i]	*=b;
  }
  fwrd_(f,&na1);		/*${dp\over d\Psi}$*/
  closeftn_();
  free(f);
  printf("%s Interface file for DCON\n",str);
#ifdef H
  Dcon2Esc(str);
#endif
  return(0);
}

#ifdef VMEC
int ESInitjso()
{
  int i;
  int ndoub,mn,isym;

  if(FlStart){
    ndoub	=-1;
    mn		=8;
    mn		=6;
  }
  else{
    ndoub	=1;
    mn		=7;
    mn		=5;
  }

  isym	=0;
  jsoinit_(&mn,&ndoub,&isym);

  i	=1; /* 0 => mesh in sqrt(psi)
	       1 => mesh in psi
	       */
  jsosetipsi_(&i);
  
  i	=11; /* max number of inner iterations before
		metric update
		*/
  jsosetnimax_(&i);
      
  i	=1000; /* max number of outer iterations */
  jsosetnumit_(&i);

  i	=0;
  jsosetiverbose_(&i);
  i	=0;
  jsosetieqdsk_(&i);

  return(0);
}

int ESEsc2jso(double *R11,double *Z11)
{
  int i,kmax=12;
  double facimp=-1e-6;
  
  double *pr,*pz;
  double rd[13],zd[13];

  i	=ESNp1*ESNa;
  pr	=ESsr+i;
  pz	=ESsz+i;

  rd[0]	=pr[0];
  zd[0]	=pz[0];
  rd[1]	=pr[6];
  zd[1]	=pz[6];
  rd[2]	=pr[12];
  zd[2]	=pz[12];
  rd[3]	=pr[16];
  zd[3]	=pz[16];
  rd[4]	=pr[20];
  zd[4]	=pz[20];
  rd[5]	=pr[26];
  zd[5]	=pz[26];
  rd[6]	=pr[32];
  zd[6]	=pz[32];
  rd[7]	=pr[38];
  zd[7]	=pz[38];
  rd[8]	=pr[44];
  zd[8]	=pz[44];
  rd[9]	=pr[48];
  zd[9]	=pz[48];
  rd[10]=pr[52];
  zd[10]=pz[52];
  rd[11]=pr[58];
  zd[11]=pz[58];
  rd[12]=pr[64];
  zd[12]=pz[64];

  ESe2jsoPr(pprime_s,ajb);
  ESInitjso();
  jsoexec_(&facimp,&ESRBt,&ESNp,&nDjso,pprime_s,ajb,pr,pz,&psibar0,
	   Rjso,Zjso,&i);
  jsofree_();
  if(i != 0){
    printf("JSOLVER TEST FAILED\n");
    FlStart=0;
  }
  else{
    int i1,j,ji,ji1;
    int ma,mp;
    
    nAjso	=64;
    nA1jso	=nAjso+1;
    nPjso	=64;
    nP1jso	=nPjso+1;
#ifdef H
#endif
    ma	=nA1jso/32;
    mp	=nP1jso/64;

    printf("??? ma=%d mp=%d\n",ma,mp);

    FlStart	=1;
    ji1	=0;
    for(i=0; i < nA1jso; i +=ma){
      ji	=nP1jso*i;
      for(j=0; j < nP1jso; j +=mp){
	R11[ji1]	=Rjso[ji];
	Z11[ji1]	=Zjso[ji];
	ji		+=mp;
	ji1++;
      }
    }
  }
  return(0);
}
#endif

double piota_(double *x)
{
  int i;
  double a,gm;
  
  a	=sqrt(*x);
  if(ESEqSolvInCr == 6 || ESEqSolvInCr == 7){
    ESSetSplDCr(a);
    splRDCr(&gm,NULL,7);
  }
  else{
    ESSetSplA(a);
    splRA(&gm,NULL,ESgm,ESgm2a);
  }
  return(gm);
}

double pmass_(double *x)
{
  int i;
  double a,p;
  
  a	=sqrt(*x);
  if(ESEqSolvInPr == 2){
    ESSetSplDPr(a);
    splRDPr(&p,NULL,2);
  }
  else{
    ESSetSplA(a);
    splRA(&p,NULL,ESsp,ESsp2a);
  }
  return(p);
}

double piotaY_(double *x)
{
  int i;
  double a,gm,ss,ds,s;
  
  ss	=sqrt(*x);
  a	=ss;
  do{
    ESSetSplA(a);
    splRA(&s,&ds,ESqgY,ESqgY2a);
    a		+=(ss-s)/ds;
  }while(fabs(ss-s) > 1e-6);
  if(ESEqSolvInCr == 6 || ESEqSolvInCr == 7){
    ESSetSplDCr(a);
    splRDCr(&gm,NULL,7);
  }
  else{
    ESSetSplA(a);
    splRA(&gm,NULL,ESgm,ESgm2a);
  }
  return(gm);
}

double pmassY_(double *x)
{
  int i;
  double a,p,s,ds,ss;
  
  ss	=sqrt(*x);
  a	=ss;
  do{
    ESSetSplA(a);
    splRA(&s,&ds,ESqgY,ESqgY2a);
    a		+=(ss-s)/ds;
  }while(fabs(ss-s) > 1e-6);
  if(ESEqSolvInPr == 2){
    ESSetSplDPr(a);
    splRDPr(&p,NULL,2);
  }
  else{
    ESSetSplA(a);
    splRA(&p,NULL,ESsp,ESsp2a);
  }
  return(p);
}

int ESe2vm8G(double *rv, double *zv)
{
  int i,j,ji,k,ki,kj;
  double da,ds,a,b,rc[65],rs[65];

  ji	=0;
  for(j=0; j < ESNp1; j++){
    rv[ji]	=ESaR0[0];
    zv[ji]	=ESaZ0[0];
    ji++;
  }

  da	=1./VmNa;
  for(i=1; i < VmNa1; i++){
    a	=sqrt(da*i);
    ESSetSplA(a);
    splRA(&b,&ds,ESsb,ESsb2a);
    splRA(rc,&ds,rcT,rcT2a);
    splRA(rs,&ds,rsT,rsT2a);
    ki		=0;
    for(k=1; k < ESFp1; k++){
      ki	+=ESNa1;
      splRA(rc+k,&ds,rcT+ki,rcT2a+ki);
      rc[k]	*=2.;
      splRA(rs+k,&ds,rsT+ki,rsT2a+ki);
      rs[k]	*=2.;
    }
    for(j=0; j < ESNp1; j++){
      rv[ji]	=ESaR0[0]+rc[0];
      zv[ji]	=ESaZ0[0]+rs[0]+b*sn1[j];;
      kj	=0;
      for(k=1; k < ESFp1; k++){
	kj	+=j;
	if(kj >= ESNp)
	  kj	-=ESNp;
	rv[ji]	+=rc[k]*cs1[kj]+rs[k]*sn1[kj];
      }
      ji++;
    }

    splRA(&b,NULL,ESaF,ESaF2a);
    printf("F[%3d]=%12.5e\n",i,b);
  }
  return(0);
}

int ESe2vm8gL(double *gd,double *gd1,double *r,double *z,double *gL,double a)
{
  int i,j,k,ki,kj,jmx,jmn;
  double Lc[33],Ls[33],L0,gh,gt,b,r0,z0,rmx,zmx,rmn,zmn;

  ESSetSplA(a);
  splRA(Lc,NULL,ESLc,ESLc2);
  L0	=2./Lc[0];
  ki	=0;
  for(k=1; k < ES2Mp1; k++){
    ki	+=ESNa1;
    splRA(Lc+k,NULL,ESLc+ki,ESLc2+ki);
    Lc[k]	*=L0;
    splRA(Ls+k,NULL,ESLs+ki,ESLs2+ki);
    Ls[k]	*=L0;
  }

  zmx=0;
  zmn=0;
  for(j=0; j < ESNp1; j++){
    if(zmx < z[j]){
      zmx	=z[j];
      rmx	=r[j];
      jmx	=j;
    }
    if(zmn > z[j]){
      zmn	=z[j];
      rmn	=r[j];
      jmn	=j;
    }
  }
  L0	=cr2*(z[jmx+1]-z[jmx-1]);
  z0	=z[jmx-1]+z[jmx+1]-2.*z[jmx];
  b	=-L0/z0;
  zmx	-=cr2*L0*L0/z0;
  L0	=cr2*(r[jmx+1]-r[jmx-1]);
  rmx	+=cr2*(r[jmx+1]-r[jmx-1]+(r[jmx-1]+r[jmx+1]-2.*r[jmx])*b)*b;

  L0	=cr2*(z[jmn+1]-z[jmn-1]);
  z0	=z[jmn-1]+z[jmn+1]-2.*z[jmn];
  b	=-L0/z0;
  zmn	-=cr2*L0*L0/z0;
  rmn	+=cr2*(r[jmn+1]-r[jmn-1]+(r[jmn-1]+r[jmn+1]-2.*r[jmn])*b)*b;

  r0	=ESaR0[0];
  z0	=cr2*(zmx+zmn);
  b	=cr2*(zmx-zmn);
  for(j=0; j < ESNp1; j++){
    gt	=(z[j]-z0)/b;
    if(gt > 1.){
      gt	=1.;
    }
    if(gt < -1.)
      gt	=-1.;
    if(gt > 0.){
      L0	=(rmx-r0)*(z[j]-z0)-(zmx-z0)*(r[j]-r0);
    }
    else{
      L0	=(r[j]-r0)*(zmn-z0)-(z[j]-z0)*(rmn-r0);
    }
    if(j < 2){
      gt=asin(gt);
    }
    else{
      if(j > ESNp-2){
	gt=c2gp+asin(gt);
      }
      else{
	if(L0 > 0.){
	  gt=cgp-asin(gt);
	}
	else{
	  gt=asin(gt);
	  if(gt < 0.){
	    gt	+=c2gp;
	  }
	}
      }
    }
    gh	=0.;
    for(k=1; k < ES2Mp1; k++){
      gh	+=(Lc[k]*sin(k*gt)+Ls[k]*(1.-cos(k*gt)))/k;
    }
#ifdef H
    gd[j]	=gt+gh-ESgt[j];
#endif
    gd[j]	=gh;
    gd1[j]	=ESgt[j]+gL[j]-gt;
  }
  return(0);
}

int  ESe2jsoPr(double *dpdgy,double *jbb)
{
  int i;
  double s,ss,ds,a;

  a	=0.;
  for(i=0; i < 21; i++){
    ss	=sqrt(0.05*i);
    do{
      ESSetSplA(a);
      splRA(&s,&ds,ESqgY,ESqgY2a);
      a		+=(ss-s)/ds;
    }while(fabs(ss-s) > 1e-6);
    ESSetSplA(a);
    splRA(&s,&ds,ESqgY,ESqgY2a);
    if(ESEqSolvInCr == 1){
      ESSetSplDCr(a);
      splRDCr(jbb+i,&ds,ESEqSolvInCr);
    }
    else{
      splRA(jbb+i,&ds,ESjb,ESjb2a);
    }
    jbb[i]	*=ESaR0[0];
    ESSetSplDPr(a);
    switch(ESEqSolvInPr){
    case 0:
      splRDPr(dpdgy+i,&ds,0);
      dpdgy[i]	/=ESaR0[0];
      break;
    case 1:
      splRDPr(dpdgy+i,&ds,1);
      break;
    default:
      splRA(dpdgy+i,&ds,ESPs,ESPs2a);
      break;
    }
    dpdgy[i]	*=ESgY[ESNa];
  }

  return(0);
}

double esjsopp_(double *gp)
{
  static int i=0;
  double s,ss,ds,a;
  
  if(*gp >= 1.){
    a	=1.;
  }
  else{
    if(*gp == 0.){
      a	=0.;
    }
    else{
      ss	=sqrt(*gp);
      while(ESqgY[i+1] < ss){
	i++;
      }
      while(ESqgY[i] > ss){
	i--;
      }
      a	=ESsa[i];
      do{
	ESSetSplA(a);
	splRA(&s,&ds,ESqgY,ESqgY2a);
	a		+=(ss-s)/ds;
      }while(fabs(ss-s) > 1e-6);
    }
  }
  switch(ESEqSolvInPr){
  case 0:
    ESSetSplDPr(a);
    splRDPr(&s,&ds,0);
    return(s/ESaR0[0]);
    break;
  case 1:
    ESSetSplDPr(a);
    splRDPr(&s,&ds,1);
    return(s);
    break;
  default:
    ESSetSplA(a);
    splRA(&s,NULL,ESPs,ESPs2a);
    return(s);
    break;
  }
  return(0.);
}

double esjsote3h_(double *gp)
{
  static int i=0;
  double s,ss,ds,a;
  
  if(*gp >= 1.){
    a	=1.;
  }
  else{
    if(*gp == 0.){
      a	=0.;
    }
    else{
      ss	=sqrt(*gp);
      while(ESqgY[i+1] < ss){
	i++;
      }
      while(ESqgY[i] > ss){
	i--;
      }
      a	=ESsa[i];
      do{
	ESSetSplA(a);
	splRA(&s,&ds,ESqgY,ESqgY2a);
	a		+=(ss-s)/ds;
      }while(fabs(ss-s) > 1e-6);
    }
  }
  if(ESEqSolvInCr == 1){
    ESSetSplDCr(a);
    splRDCr(&ss,&ds,ESEqSolvInCr);
  }
  else{
    ESSetSplA(a);
    splRA(&ss,&ds,ESjb,ESjb2a);
  }
  return(ss*ESaR0[0]);
}

int ESjso2eG(double *rv, double *zv)
{
  int i,j,ji,k,ki,kj;
  double s,ss,ds,a,b,rc[65],rs[65];

  ji	=0;
  for(j=0; j < ESNp1; j++){
    rv[ji]	=ESaR0[0];
    zv[ji]	=ESaZ0[0];
    ji++;
  }

  a	=ESsa[1];
  for(i=1; i < 33; i++){
    ss	=sqrt((double)i/32.);
    do{
      ESSetSplA(a);
      splRA(&s,&ds,ESqgY,ESqgY2a);
      a		+=(ss-s)/ds;
    }while(fabs(ss-s) > 1e-6);
    ESSetSplA(a);
    splRA(&b,&ds,ESsb,ESsb2a);
    splRA(rc,&ds,rcT,rcT2a);
    splRA(rs,&ds,rsT,rsT2a);
    ki		=0;
    for(k=1; k < ESFp1; k++){
      ki	+=ESNa1;
      splRA(rc+k,&ds,rcT+ki,rcT2a+ki);
      rc[k]	*=2.;
      splRA(rs+k,&ds,rsT+ki,rsT2a+ki);
      rs[k]	*=2.;
    }
    for(j=0; j < ESNp1; j++){
      rv[ji]	=ESaR0[0]+rc[0];
      zv[ji]	=ESaZ0[0]+rs[0]+b*sn1[j];
      kj	=0;
      for(k=1; k < ESFp1; k++){
	kj	+=j;
	if(kj >= ESNp)
	  kj	-=ESNp;
	rv[ji]	+=rc[k]*cs1[kj]+rs[k]*sn1[kj];
      }
      ji++;
    }
  }
  return(0);
}

int ESDconVsPst(int k)
{
  FILE *fp;
  static double R=0.,a0=0.,b0=0.,d0=0.;
  double a,b,d;
  char ch;

  Vmt0=clock()-Vmt0;
  printf("->");
  ch	='\n';
  while(isspace(ch)){
    ch=getchar();
  }
  a	=cr2*(rdPV[3]-rdPV[2]);
  b	=cr2*(zdPV[0]-zdPV[1]);
  d	=(cr2*(rdPV[3]+rdPV[2])-rdPV[0])/a;
  fp=fopen("DconPst.d","a+");
  if(R != ESRext || a != a0 || b != b0 || d != d0){
    R	=ESRext;
    a0	=a;
    b0	=b;
    d0	=d;
    fprintf(fp,"%11s%11s%11s%11s\n","---------- R","a","b","d ----------");
    fprintf(fp,"%12.4e%11.4e%11.4e%11.4e\n",ESRext,a0,b0,d0);
    fprintf(fp,"%8s%8s%8s%8s%8s%8s%8s%8s\n","B","gb%","q0","qa","jp(0)"
	    ,"DCON","PEST4","PEST12");
  }
  switch(k){
  case 0:
    fprintf(fp,"%8.4f%8.4f%8.4f%8.4f%8.4f%7.1f%c\n"
	    ,ESBt,ESgbext*100.,ESsq[0],ESsq[ESNa],ESjp[0]
	    ,(double)Vmt0/CLOCKS_PER_SEC,ch);
    printf("DCON ");
    break;
  case 1:
    fprintf(fp,"%8.4f%8.4f%8.4f%8.4f%8.4f%8s%7.1f%c\n"
	    ,ESBt,ESgbext*100.,ESsq[0],ESsq[ESNa],ESjp[0]
	    ,"",(double)Vmt0/CLOCKS_PER_SEC,ch);
    printf("Pst4 ");
    break;
  case 2:
    fprintf(fp,"%8.4f%8.4f%8.4f%8.4f%8.4f%8s%8s%7.1f%c\n"
	    ,ESBt,ESgbext*100.,ESsq[0],ESsq[ESNa],ESjp[0]
	    ,"","",(double)Vmt0/CLOCKS_PER_SEC,ch);
    printf("Pst12 ");
    break;
  }
  fclose(fp);

  printf("%7.1f%c%8.4f%8.4f%8.4f%8.4f%8.4f\n"
	 ,(double)Vmt0/CLOCKS_PER_SEC,ch
	 ,ESBt,ESgbext*100.,ESsq[0],ESsq[ESNa],ESjp[0]);
  return(0);
}

int ESEquilOut()
{
  int i,n0,n1;
  static int nA=400;
  int Fl=0,FlMap=0;
  double Bt,Rext,r0,z0,rx,zx;
  double *pr,*pz,*pvr,*pvz,rD[12],zD[12];
  static double ttime=0.;
  static char FNm[12]="ES4Dcon00.0";

  ESGetPlVDAddr(&rdPV,&zdPV);

  FlMap	=0;
#ifndef Tbl_EqOut
  if(VmNa > 200){
    VmNa	=200;
  }
  if(VmNa < 20){
    VmNa	=20;
  }
  VmNa1	=VmNa+1;
  if(VmMpol > 20){
    VmMpol	=20;
  }
  if(VmMpol < 3){
    VmMpol	=3;
  }

  pr	=ESsr;
  pz	=ESsz;
  n0	=ESnAP;
  n1	=ESnAP;
  pvr	=ESsr;
  pvz	=ESsz;
  r0	=ESaR0[0];
  z0	=ESaZ0[0];
  rx	=ESaRx;
  zx	=ESaZx;
  for(i=0; i < 12; i++){
    rD[i]	=rdPV[i];
    zD[i]	=zdPV[i];
  }
  Bt	=ESRBt/ESRext;
  Rext	=ESRext;

  switch(Fl){
  case 0:
    break;
#ifdef VMEC
  case 1:
    if(FlVm6){
      ESInitTrGrid();
      FlVm6=0;
    }
    i	=ESnAP-ESNp1;
    VMbound(pr+i,pz+i,ESNp,R1+i,Z1+i);
    Vmt0=clock();
    Vm2EC(R1,Z1);
    printf("Vmtime=%10.3e sec\n",(double)(clock()-Vmt0)/CLOCKS_PER_SEC);
    n1	=ESnAP;
    pvr	=R1;
    pvz	=Z1;
#ifdef H
    {
      FILE *fp;
      char *NmFp="esc2vmP",*NmFb="esc2vmB",*NmFg="esc2vmG";
      int n,n1,j,m,m1,k,ki,kj,ji;
      double a,d,gF,gY,p,gm;
      double t,dt,r,z,rc[33],rs[33],cs,sn,b;

      fp	=fopen(NmFp,"w");
      if(fp == NULL){
	printf("%s cannot be written%c\n",NmFp,'\a');
	break;
      }
      n		=40;
      while(n < 100){
	fprintf(fp,"--------- Plasma profiles on %2d %s\n",n,
		"Radial intervals ---------");
	fprintf(fp,"%12s %14s %14s\n","Rref [m]"
		,"Btor ref [T]","RBtor [m x T]");
	fprintf(fp,"%12.5e %14.5e %14.5e\n",ESRext,ESRBt/ESRext,ESRBt);
	fprintf(fp,"%2s %11s %12s %12s %12s %12s\n"," #","\\Phi/\\Phi_0"
		,"\\Phi [Vsec]","\\Psi [Vsec]","p [MPa]","\\iota");
	n1	=n+1;
	d	=ESsa[ESNa]/n;
	for(i=0; i < n1; i++){
	  a	=sqrt(i*d);
	  ESSetSplA(a);
	  splRA(&gF,NULL,ESgF,ESgF2a);
	  splRA(&gY,NULL,ESgY,ESgY2a);
	  if(ESEqSolvInPr == 2){
	    ESSetSplDPr(a);
	    splRDPr(&p,NULL,2);
	  }
	  else{
	    splRA(&p,NULL,ESsp,ESsp2a);
	  }
	  if(ESEqSolvInCr == 6 || ESEqSolvInCr == 7){
	    ESSetSplDCr(a);
	    splRDCr(&gm,NULL,7);
	  }
	  else{
	    splRA(&gm,NULL,ESgm,ESgm2a);
	  }
	  fprintf(fp,"%2d %11.2f %12.5e %12.5e %12.5e %12.5e\n",i,i*d
		  ,gF*c2gp,gY*c2gp,p*crgm0,gm);
	}
	n	*=2;
	fprintf(fp,"\n");
      }
      fclose(fp);
      printf("%s has been written\n",NmFp);

      fp	=fopen(NmFb,"w");
      if(fp == NULL){
	printf("%s cannot be written%c\n",NmFb,'\a');
	break;
      }
      m		=64;
      while(m < 200){
	fprintf(fp,"--------- Plasma boundary on %2d %s\n",m,
		"Poloidal intervals ---------");
	fprintf(fp,"%3s %12s %12s\n"," #","Rpl-vac","Zpl-vac");
	m1	=m+1;
	dt	=c2gp/m;
	ki	=ESNa;
	for(k=0; k < ESFp1; k++){
	  rc[k]	=rcT[ki];
	  rs[k]	=rsT[ki];
	  ki	+=ESNa1;
	}
	for(j=0; j < m1; j++){
	  t	=j*dt;
	  r	=0.;
	  for(k=2; k < ESFp1; k++){
	    cs	=cos(k*t);
	    sn	=sin(k*t);
	    r	+=rc[k]*cs+rs[k]*sn;
	  }
	  cs	=cos(t);
	  sn	=sin(t);
	  r	=ESaR0[0]+rc[0]+2.*(r+rc[1]*cs+rs[1]*sn);
	  z	=ESaZ0[0]+rs[0]+ESsb[ESNa]*sn;
	  fprintf(fp,"%3d %12.5e %12.5e\n",j,r,z);
	}
	m	*=2;
	fprintf(fp,"\n");
      }
      fclose(fp);
      printf("%s has been written\n",NmFb);

      fp	=fopen(NmFg,"w");
      if(fp == NULL){
	printf("%s cannot be written%c\n",NmFg,'\a');
	break;
      }
      n		=20;
      n1	=n+1;
      d	=ESsa[ESNa]/n;
      m		=64;
      m1	=m+1;
      dt	=c2gp/m;
      i		=0;
      ji	=0;
      fprintf(fp,"------ Plasma geometry on %2d Radial x %3d Poloidal%s\n"
	      ,n,m," intervals ------");
      while(i < n1){
	a	=sqrt(i*d);
	ESSetSplA(a);
	ki	=0;
	for(k=0; k < ESFp1; k++){
	  splRA(rc+k,NULL,rcT+ki,rcT2a+ki);
	  splRA(rs+k,NULL,rsT+ki,rsT2a+ki);
	  ki	+=ESNa1;
	}
	for(j=0; j < m1; j++){
	  t	=j*dt;
	  r	=0.;
	  for(k=2; k < ESFp1; k++){
	    cs	=cos(k*t);
	    sn	=sin(k*t);
	    r	+=rc[k]*cs+rs[k]*sn;
	  }
	  cs	=cos(t);
	  sn	=sin(t);
	  r	=ESaR0[0]+rc[0]+2.*(r+rc[1]*cs+rs[1]*sn);
	  splRA(&b,NULL,ESsb,ESsb);
	  z	=ESaZ0[0]+rs[0]+b*sn;
	  R[ji]	=r;
	  Z[ji]	=z;
	  ji++;
	}
	i++;
	if(i%3 == 0){
	  fprintf(fp,"%2s     r[%2d] %9sz     r[%2d] %9sz     r[%2d] %9sz\n"
		  ," #",i-3,"",i-2,"",i-1,"");
	  ji	-=m1;
	  kj	=ji-m1;
	  ki	=kj-m1;
	  for(j=0; j < m1; j++){
	    fprintf(fp,"%2d %10.3e %10.3e %10.3e %10.3e %10.3e %10.3e\n",j
		    ,R[ki],Z[ki],R[kj],Z[kj],R[ji],Z[ji]);
	    ji++;
	    ki++;
	    kj++;
	  }
	}
      }
      fclose(fp);
      printf("%s has been written\n",NmFg);
    }
#endif
    break;
  case 2:
    i	=ESnAP-ESNp1;
    printf("Vmec8 started\n");
    Vmt0=clock();

    vm8B(pr+i,pz+i,ESNp,R1,Z1,gL1);

    printf("Vmtime=%10.3e sec\n",(double)(clock()-Vmt0)/CLOCKS_PER_SEC);
    ESe2vm8G(R,Z);
    FlVm=1;
    n0	=65*VmNa1;
    n1	=65*VmNa1;
    pr	=R;
    pz	=Z;
    pvr	=R1;
    pvz	=Z1;
    {
      extern int FlagPS;
      double gh0,ghmx,ghmn,x[2],y[2],dy,z0,gh1[65],ghV[65],da;
      int j,ji,ii;
      ghmx=0.;
      ghmn=0.;
      da	=1./VmNa;
      ii	=VmNa1/40;
      for(i=ii; i < VmNa1; i +=ii){
	ji	=ESNp1*i;
	for(j=0; j < ESNp1; j++){
	  gh0	=gL1[ji];
	  if(ghmx < gh0)
	    ghmx=gh0;
	  if(ghmn > gh0)
	    ghmn=gh0;
	  ji++;
	}
      }
      x[0]	=ESgt[0];
      x[1]	=ESgt[ESNp];
      dy	=0.1*(ghmx-ghmn)/ii;
      y[0]	=ghmn;
      y[1]	=dy*VmNa+ghmx;
      Scale2D(2,2,x,y,2,6,2);
      PSFileOpen();
      PSScale2D(x,y,2,6,2);
      PSPlotFrame(6,2);
      for(i=ii; i < VmNa1; i +=ii){
	z0	=dy*i;
	ji	=ESNp1*i;
	ESe2vm8gL(gh1,ghV,R1+ji,Z1+ji,gL1+ji,sqrt(da*(i-0.5)));
	for(j=0; j < ESNp1; j++){
	  gh1[j]	+=z0;
	  ghV[j]	+=z0;
	}
	Plot2d(2,ESgt,gh1,ESNp1,6,0,0,0);
	PSPlot2D(ESgt,gh1,ESNp1,6,2,0,0);

	Plot2d(2,ESgt,ghV,ESNp1,6,0,4,0);
	PSPlot2D(ESgt,ghV,ESNp1,6,2,4,0);
#ifdef H
	for(j=0; j < ESNp1; j++){
	  gh1[j]=z0+gL1[ji];
	  ji++;
	}
	Plot2d(2,ESgt,gh1,ESNp1,6,0,4,0);
	PSPlot2D(ESgt,gh1,ESNp1,6,2,4,0);
#endif
      }
      PSPlot2D(ESgt,gh1,ESNp1,6,2,4,-1);
      CbFlush();
    }
    break;
  case 62:
    i	=ESnAP-ESNp1;
    ESe2vm8G(R,Z);
    n0	=65*VmNa1;
    n1	=65*VmNa1;
    pr	=R;
    pz	=Z;
    pvr	=R1;
    pvz	=Z1;
    break;
  case 3:
    n1	=33*65;
    pr	=R;
    pz	=Z;
    n0	=n1;
    pvr	=R1;
    pvz	=Z1;
    ESjso2eG(R,Z);
    printf("Jsolver started\n");
    Vmt0=clock();
    ESEsc2jso(R1,Z1);
    printf("Jsotime=%10.3e sec\n",(double)(clock()-Vmt0)/CLOCKS_PER_SEC);
    break;
#endif
  case 4:
    FlStart=0;
    break;
  case 5:
    ES2eqdskS(ttime);
    ttime	+=0.01;
    break;
  case 6:
    ES2eqdsk(ttime);
    ttime	+=0.01;
    break;
  case 7:
    if((ESEqSolvFl&0x0F) == 0){
      ES4Dcon(ttime);
      ES4Dcon1();
    }
    else{
      printf("Switch Eq Solver to Lsode%c\n",7);
    }
    break;
  case 8:
    if((ESEqSolvFl&0x0F) == 0){
      if(FlMap == 0){
	ttime	+=0.01;
      }
      sprintf(FNm,"ES4Dcon%4.2f",ttime);
      ES4Dcon(ttime);
      FlMap	=5;
      {
	int fp;
	char *str="/ES4Dcon",ch,*p;
	fp=open("../dcon_3.10/dcon/dcon.in",O_RDWR);
	p	=FNm;
	ch	='\0';
	while(p-FNm != 7 && ch != EOF){
	  read(fp,&ch,1);
	  if(ch == *p){
	    p++;
	  }
	  else{
	    p	=FNm;
	  }
	}
	if(ch != EOF){
	  write(fp,p,4);
	  close(fp);
	  Vmt0=clock();
	  system("cd /scratchu/zakh/dcon_3.10/dcon;"
		 "dcon;cd /scratchu/zakh/Tsc");
	  ESDconVsPst(0);
	}
	else{
	  printf("No image ES4Dcon in dcon.in file\n");
	  close(fp);
	}
      }
    }
    else{
      printf("Switch Eq Solver to Lsode%c\n",7);
    }
    break;
  case 9:
    if((ESEqSolvFl&0x0F) == 0){
      if(FlMap == 0){
	ttime	+=0.01;
      }
      sprintf(FNm,"ES4Dcon%4.2f",ttime);
      ES4Dcon(ttime);
      FlMap	=5;
      {
	int fp;
	char *str="/ES4Dcon",ch,*p;
	fp=open("../dcon_3.10/dcon/dcon.in",O_RDWR);
	p	=FNm;
	ch	='\0';
	while(p-FNm != 7 && ch != EOF){
	  read(fp,&ch,1);
	  if(ch == *p){
	    p++;
	  }
	  else{
	    p	=FNm;
	  }
	}
	if(ch != EOF){
	  write(fp,p,4);
	  close(fp);
	  Vmt0=clock();
	  system("cd /scratchu/zakh/dcon_3.10/dcon;"
		 "dconNew;cd /scratchu/zakh/Tsc");
	  ESDconVsPst(0);
	}
	else{
	  printf("No image ES4Dcon in dcon.in file\n");
	  close(fp);
	}
      }
    }
    else{
      printf("Switch Eq Solver to Lsode%c\n",7);
    }
    break;
  case 10:
    if(FlMap != 1){
      if(FlMap == 0){
	ttime	+=0.01;
      }
      sprintf(FNm,"ES4Pest%4.2f",ttime);
      ES4Pst(nA,ttime);
      FlMap	=1;
    }
    printf("Using PEST2 version from /scratchu/zakh/Pst\n");
    system("cd /scratchu/zakh/Pst;gobal; cd /scratchu/zakh/Tsc");
    break;
  case 11:
    if(FlMap != 1){
      if(FlMap == 0){
	ttime	+=0.01;
      }
      sprintf(FNm,"ES4Pest%4.2f",ttime);
      ES4Pst(nA,ttime);
      FlMap	=1;
    }
    printf("Using PEST2 version from /scratchu/zakh/Pst\n");
    Vmt0=clock();
    system("cd /scratchu/zakh/Pst;go24zb; cd /scratchu/zakh/Tsc");
    ESDconVsPst(1);
    break;
  case 12:
    if(FlMap != 1){
      if(FlMap == 0){
	ttime	+=0.01;
      }
      sprintf(FNm,"ES4Pest%4.2f",ttime);
      ES4Pst(nA,ttime);
      FlMap	=1;
    }
    printf("Using PEST2 version from /scratchu/zakh/Pst\n");
    system("cd /scratchu/zakh/Pst;gobal;go24zb; cd /scratchu/zakh/Tsc");
    break;
  case 13:
    if(FlMap != 1){
      if(FlMap == 0){
	ttime	+=0.01;
      }
      sprintf(FNm,"ES4Pest%4.2f",ttime);
      ES4Pst(1200,ttime);
      FlMap	=1;
    }
    printf("Using PEST2 version from /scratchu/zakh/Pst\n");
    Vmt0=clock();
    system("cd /scratchu/zakh/Pst;pst12; cd /scratchu/zakh/Tsc");
    ESDconVsPst(2);
    break;
  case 20:
    if(FlMap != 2){
      if(FlMap == 0){
	ttime	+=0.01;
      }
      sprintf(FNm,"ES4Pest%4.2f",ttime);
      ES4Pst0(nA,ttime);
      FlMap	=2;
    }
    printf("Using PEST2 version from /scratchu/zakh/Pst\n");
    system("cd /scratchu/zakh/Pst;gobal; cd /scratchu/zakh/Tsc");
    break;
  case 21:
    if(FlMap != 2){
      if(FlMap == 0){
	ttime	+=0.01;
      }
      sprintf(FNm,"ES4Pest%4.2f",ttime);
      ES4Pst0(nA,ttime);
      FlMap	=2;
    }
    printf("Using PEST2 version from /scratchu/zakh/Pst\n");
    system("cd /scratchu/zakh/Pst;go24zb; cd /scratchu/zakh/Tsc");
    break;
  case 22:
    if(FlMap != 2){
      if(FlMap == 0){
	ttime	+=0.01;
      }
      sprintf(FNm,"ES4Pest%4.2f",ttime);
      ES4Pst0(nA,ttime);
      FlMap	=2;
    }
    printf("Using PEST2 version from /scratchu/zakh/Pst\n");
    system("cd /scratchu/zakh/Pst;gobal;go24zb; cd /scratchu/zakh/Tsc");
    break;
  case 30:
    if(FlMap != 3){
      if(FlMap == 0){
	ttime	+=0.01;
      }
      sprintf(FNm,"ES4Pest%4.2f",ttime);
      ES4Pst1(nA,ttime);
      FlMap	=3;
    }
    printf("Using PEST2 version from /scratchu/zakh/Pst\n");
    system("cd /scratchu/zakh/Pst;gobal; cd /scratchu/zakh/Tsc");
    break;
  case 31:
    if(FlMap != 3){
      if(FlMap == 0){
	ttime	+=0.01;
      }
      sprintf(FNm,"ES4Pest%4.2f",ttime);
      ES4Pst1(nA,ttime);
      FlMap	=3;
    }
    printf("Using PEST2 version from /scratchu/zakh/Pst\n");
    system("cd /scratchu/zakh/Pst;go24zb; cd /scratchu/zakh/Tsc");
    break;
  case 32:
    if(FlMap != 3){
      if(FlMap == 0){
	ttime	+=0.01;
      }
      sprintf(FNm,"ES4Pest%4.2f",ttime);
      ES4Pst1(nA,ttime);
      FlMap	=3;
    }
    printf("Using PEST2 version from /scratchu/zakh/Pst\n");
    system("cd /scratchu/zakh/Pst;gobal;go24zb; cd /scratchu/zakh/Tsc");
    break;
  case 40:
    if(FlMap != 4){
      if(FlMap == 0){
	ttime	+=0.01;
      }
      sprintf(FNm,"ES4Pest%4.2f",ttime);
      ES4Pst2(nA,ttime);
      FlMap	=4;
    }
    printf("Using PEST2 version from /scratchu/zakh/Pst\n");
    system("cd /scratchu/zakh/Pst;gobal; cd /scratchu/zakh/Tsc");
    break;
  case 41:
    if(FlMap != 4){
      if(FlMap == 0){
	ttime	+=0.01;
      }
      sprintf(FNm,"ES4Pest%4.2f",ttime);
      ES4Pst2(nA,ttime);
      FlMap	=4;
    }
    printf("Using PEST2 version from /scratchu/zakh/Pst\n");
    system("cd /scratchu/zakh/Pst;go24zb; cd /scratchu/zakh/Tsc");
    break;
  case 42:
    if(FlMap != 4){
      if(FlMap == 0){
	ttime	+=0.01;
      }
      sprintf(FNm,"ES4Pest%4.2f",ttime);
      ES4Pst2(nA,ttime);
      FlMap	=4;
    }
    printf("Using PEST2 version from /scratchu/zakh/Pst\n");
    system("cd /scratchu/zakh/Pst;gobal;go24zb; cd /scratchu/zakh/Tsc");
    break;
  case 50:
    ES2eqdskS(ttime);
    printf("Using PEST2 version from /scratchu/zakh/Pst\n");
    system("cd /scratchu/zakh/Pst;god24zb263;gobal; cd /scratchu/zakh/Tsc");
    break;
  case 51:
    ES2eqdskS(ttime);
    printf("Using PEST2 version from /scratchu/zakh/Pst\n");
    system("cd /scratchu/zakh/Pst;god24zb263;go24zb; cd /scratchu/zakh/Tsc");
    break;
  case 52:
    ES2eqdskS(ttime);
    printf("Using PEST2 version from /scratchu/zakh/Pst\n");
    system("cd /scratchu/zakh/Pst;god24zb263;gobal;go24zb;"
	   "cd /scratchu/zakh/Tsc");
    break;
  default:
    break;
  }
  Fl	=0;
#endif Tbl_EqOut
  return(0);
}

#define NSIZE 263
#define NA 128
#define NP 128

#define NAP 1200
#define NPP 128
typedef struct{
  char		Title[160];
  char		date[8];
  long int	nxx[5];
  double	axx[13];
  long int	nxy[10];
  double	axy[10];
}PPPLEQ;

static PPPLEQ Ttl;

int ES4Pst(int nA,double ttime)
{
  int nA1=NAP+1,nP=NPP,nP1=NPP+1,nP5=NPP+5;
  FILE *Fp,*fp;
  int i,j,k,ki,kj,ji;
  double dgy,dgt,dgya,rf,rg,a,ss,s,ds,rBt,p2rBt;
  double A[NAP+1];
  double *sp,*Ps,sq[NAP+1],dsqgy[NAP+1],*g,*dggy,*fb,*dfbgy;
  double *r,*z,*rt,*zt,*ra,*za;
  double *g22,*p2r,*g11,*g12,*dg12t,*dp2ra,*dg22t,*dp2rt,*qg,*dqga,*gd,*dgda;

  double *rc,*rs,*drc,*drs,*rct,*rst,dra,drt,dza,dzt,cs,sn,b,db,d2b;
  double *Gh,*Gh2,gh,t;
  double *d2rttc,*d2rtts,*d2ratc,*d2rats,*d2raac,*d2raas;
  double d2rtt,d2ztt,d2rat,d2zat,d2raa,d2zaa;
  double *Lc,*Ls,*dLc,*dLs,D0,dD0,D,dD,dg22,dg12,dgqt,gqt,L0;

  double *w1[6],*w2[6],*w3[6];


  double dGh[65],dGh2[65],chhp,ch2hp;


  nA1=nA+1;

  chhp	=cr2*ESgt[1];
  ch2hp	=chhp*cr6*ESgt[1];

  i	=nP*nA1;
  for(k=0; k < 6; k++){
    w1[k]	=NULL;
    w2[k]	=NULL;
    w3[k]	=NULL;
    w1[k]	=(double*)malloc(i*sizeof(double));
    w2[k]	=(double*)malloc(i*sizeof(double));
    w3[k]	=(double*)malloc(i*sizeof(double));
    if(w1[k] == NULL || w2[k] == NULL || w3[k] == NULL){
      printf("No memory for w[%d] in ES4Pst()%c\n",k,7);
      j=k;
      while(j >= 0){
	free(w3[j]);
	free(w2[j]);
	free(w1[j]);
	j--;
      }
      return(0);
    }
  }

  r	=w1[0];
  z	=w1[1];
  rt	=w1[2];
  zt	=w1[3];
  ra	=w1[4];
  za	=w1[5];

  g22	=w2[0];
  p2r	=w2[1];
  g11	=w2[2];
  g12	=w2[3];
  dg12t	=w2[4];
  dp2ra	=w2[5];
  dg22t	=w3[0];
  dp2rt	=w3[1];
  qg	=w3[2];
  dqga	=w3[3];
  gd	=w3[4];
  dgda	=w3[5];
  
  Gh	=(double*)malloc((4*ESNp1+12*ESFp1+4*ES2Mp1)*sizeof(double));
  Gh2	=Gh	+ESNp1;
  rc	=Gh2	+ESNp1;
  rs	=rc	+ESFp1;
  drc	=rs	+ESFp1;
  drs	=drc	+ESFp1;
  rct	=drs	+ESFp1;
  rst	=rct	+ESFp1;
  d2raac	=rst	+ESFp1;
  d2raas	=d2raac	+ESFp1;
  d2ratc	=d2raas	+ESFp1;
  d2rats	=d2ratc	+ESFp1;
  d2rttc	=d2rats	+ESFp1;
  d2rtts	=d2rttc	+ESFp1;
  Lc	=d2rtts	+ESFp1;
  Ls	=Lc	+ES2Mp1;
  dLc	=Ls	+ES2Mp1;
  dLs	=dLc	+ES2Mp1;

  if(Gh == NULL){
    printf("No memory for Gh in ES4Pst()\n");
    fclose(fp);
    return(0);
  }
  sp	=r;
  Ps	=z;
#ifdef H
  sq	=rt;
  dsqgy	=zt;
#endif
  g	=ra;
  dggy	=za;
  fb	=g22;
  dfbgy	=p2r;

  rg	=1./ESRBt;
  rBt	=ESRext*rg;
  p2rBt	=rBt*rBt;
  rf	=-ESgY[ESNa]*rBt;
  dgt	=c2gp/nP;
  dgy	=1./nA;
  
#ifdef H
  sprintf(Ttl.Title,"ES4PstGm%4.2f",ttime); /* fort.31 */
  sprintf(Ttl.Title,"ES4PstGm",ttime);
  Fp	=fopen(Ttl.Title,"w");

  sprintf(Ttl.Title,"ES4PstPr%4.2f",ttime); /* fort.32 */
  sprintf(Ttl.Title,"ES4Pst",ttime);
  fp	=fopen(Ttl.Title,"w");
#endif
  sprintf(Ttl.Title,"/scratchu/zakh/Pst/fort.31",ttime); /* fort.31 */
  Fp	=fopen(Ttl.Title,"w");

  sprintf(Ttl.Title,"/scratchu/zakh/Pst/fort.32",ttime); /* fort.32 */
  fp	=fopen(Ttl.Title,"w");

  printf("Writing plasma profiles\n");
  strcpy(Ttl.Title,"ESC has written this garbage");
  i	=strlen(Ttl.Title);
  while(i < 159){
    Ttl.Title[i]	=' ';
    i++;
  }
  Ttl.Title[i]	='\0';
  g[0]	=0.;
  fwrite((void*)g,(size_t)8,(size_t)1,Fp);
  fwrite((void*)g,(size_t)8,(size_t)1,fp);
  i	=0;
  while(i < 8){
    Ttl.date[i]	='\0';
    i++;
  }
  Ttl.nxx[0]	=ESNp;
  Ttl.nxx[1]	=ESNa1;			/* number of radial intervals +1*/ 
  Ttl.nxx[2]	=nA1;			/* Number of magnetic surfaces */
  Ttl.nxx[3]	=nP;			/* Number of poloidal intervals */ 
  Ttl.nxx[4]	=0;			/* Junk */ 
  Ttl.axx[0]	=rdPV[3]-rdPV[2];
  Ttl.axx[1]	=zdPV[0]-zdPV[1];
  Ttl.axx[2]	=zdPV[0];
  Ttl.axx[3]	=ESaR0[0];
  Ttl.axx[4]	=ESRext;
  Ttl.axx[5]	=ESsp[0]*p2rBt;
  Ttl.axx[6]	=ESRBt*rBt/ESRext;
  Ttl.axx[7]	=c2gp*ESgY[ESNa]*rBt;
  Ttl.axx[8]	=0.;
  Ttl.axx[9]	=c2gp*ESgY[ESNa]*rBt;
  Ttl.axx[10]	=0.;
  Ttl.axx[11]	=0.;
  Ttl.axx[12]	=1.;	/* constant C in rD=Cr^m\na\bgY^n */

  Ttl.nxy[0]	=1;	/* exponent n in rD=Cr^m\na\bgY^n */
  Ttl.nxy[1]	=1;	/* exponent m in rD=Cr^m\na\bgY^n,
			   2 - straight field lines */
  Ttl.nxy[2]	=0;	/* Junk */ 
  Ttl.nxy[3]	=0;	/* Junk */ 
  Ttl.nxy[4]	=0;	/* Junk */
  Ttl.nxy[5]	=0;	/* Junk */
  Ttl.nxy[6]	=0;	/* Junk */ 
  Ttl.nxy[7]	=0;	/* Junk */
  Ttl.nxy[8]	=nP1;	/* Junk */
  Ttl.nxy[9]	=nA1;	/* Junk */

  Ttl.axy[0]	=dgt;
  Ttl.axy[1]	=dgy;
  Ttl.axy[2]	=cgp;
  Ttl.axy[3]	=ESRext;
  Ttl.axy[4]	=ESRBt/ESRext;
  for(i=5; i < 10; i++){
    Ttl.axy[i]	=0.;
  }
  fwrite((void*)&Ttl,(size_t)8,(size_t)49,Fp);
  fwrite((void*)&Ttl,(size_t)8,(size_t)49,fp);

  a	=0.;
  i	=0;
  A[i]	=a;
  sp[i]	=ESsp[0]*p2rBt;
  Ps[i]	=-ESPs[0]*rBt;
  sq[i]	=1./ESgm[0];
  if(ESEqSolvInCr != 6 && ESEqSolvInCr != 7){
    dsqgy[i]	=ESgm2a[0]*sq[i]*sq[i]/(ESdgY[0]*rBt);
  }
  else{
    ESSetSplDCr(a);
    splRDCr2(&s,NULL,dsqgy,7);
    dsqgy[i]	*=sq[i]*sq[i]/(ESdgY[0]*rBt);
  }
  g[i]	=ESaF[0]*rg;
  s	=ESaT[0]*rBt;
  dggy[i]=-s/(ESRext*ESRext*g[i]);
  fb[i]	=-ESaR0[0]*ESdgY[0]*rBt/ESLc[0];
  dfbgy[i]	=ESaR0[0]*(ESdgY2a[0]-ESdgY[0]*ESLc2[0]/ESLc[0])/
    (ESdgY[0]*ESLc[0]);
  for(i=1; i < nA1; i++){
    ss	=sqrt(dgy*i);
    do{
      ESSetSplA(a);
      splRA(&s,&dgya,ESqgY,ESqgY2a);
      a		+=(ss-s)/dgya;
    }while(fabs(ss-s) > 1e-8);
    A[i]	=a;
    ESSetSplA(a);
    if(ESEqSolvInPr != 2){
      splRA(sp+i,NULL,ESsp,ESsp2a);
    }
    else{
      ESSetSplDPr(a);
      splRDPr(sp+i,&ds,2);
    }
    sp[i]	*=p2rBt;
    switch(ESEqSolvInPr){
    case 0:
      ESSetSplDPr(a);
      splRDPr(Ps+i,&ds,0);
      Ps[i]	/=ESaR0[0];
      break;
    case 1:
      ESSetSplDPr(a);
      splRDPr(Ps+i,&ds,1);
      break;
    default:
      splRA(Ps+i,NULL,ESPs,ESPs2a);
      break;
    }
    Ps[i]	*=-rBt;
    splRA(&dgya,&ds,ESdgY,ESdgY2a);
    splRA(&s,&ss,ESLc,ESLc2);
    fb[i]	=-ESaR0[0]*dgya/s;
    dgya	*=a;
    dfbgy[i]	=(ESaR0[0]*ds+fb[i]*ss)/(dgya*s);
    fb[i]	*=rBt;
    if(ESEqSolvInCr != 6 && ESEqSolvInCr != 7){
      splRA(&s,&ds,ESgm,ESgm2a);
    }
    else{
      ESSetSplDCr(a);
      splRDCr(&s,&ds,7);
    }
    sq[i]	=1./s;
    dsqgy[i]	=ds/(dgya*rBt*s*s);
    splRA(g+i,&ds,ESaF,ESaF2a);
    g[i]	*=rg;
    splRA(&s,NULL,ESaT,ESaT2a);
    s		*=rBt;
    dggy[i]	=-s/(ESRext*ESRext*g[i]);
  }
  fwrite((void*)sp,(size_t)8,(size_t)nA1,fp);
  fwrite((void*)Ps,(size_t)8,(size_t)nA1,fp);
  fwrite((void*)sq,(size_t)8,(size_t)nA1,fp);
  fwrite((void*)dsqgy,(size_t)8,(size_t)nA1,fp);
  fwrite((void*)g,(size_t)8,(size_t)nA1,fp);
  fwrite((void*)dggy,(size_t)8,(size_t)nA1,fp);
  fwrite((void*)fb,(size_t)8,(size_t)nA1,fp);
  fwrite((void*)dfbgy,(size_t)8,(size_t)nA1,fp);

  a	=0.;
  ss	=sqrt(dgy*0.01);
  do{
    ESSetSplA(a);
    splRA(&s,&dgya,ESqgY,ESqgY2a);
    a		+=(ss-s)/dgya;
  }while(fabs(ss-s) > 1e-8);
  A[0]	=a;
  
  printf("Writing ESC metric tensor\n");
  
  ji	=0;
  for(i=0; i < nA1; i++){
    a	=A[i];
    ESSetSplA(a);
    splRA(&dgya,&dD0,ESdgY,ESdgY2a);
    rf	=-1./(dgya*a*rBt);
    splRA(Lc,dLc,ESLc,ESLc2);
    s		=-1./(ESaR0[0]*dgya*rBt);
    D0		=Lc[0]*s;
    dD0		=(dLc[0]-Lc[0]*dD0/dgya)*s*rf;
    L0		=2./Lc[0];
    s		=rf*L0;
    dLc[0]	*=rf/Lc[0];
    ki	=0;
    for(k=1; k < ES2Mp1; k++){
      ki	+=ESNa1;
      splRA(Lc+k,dLc+k,ESLc+ki,ESLc2+ki);
      Lc[k]	*=L0;
      dLc[k]	=dLc[k]*s-Lc[k]*dLc[0];
      splRA(Ls+k,dLs+k,ESLs+ki,ESLs2+ki);
      Ls[k]	*=L0;
      dLs[k]	=dLs[k]*s-Ls[k]*dLc[0];
    }
    splRA(&b,&db,ESsb,ESsb2a);
    db	*=rf;
    splRA(rs,drs,rsT,rsT2a);
    drs[0]	*=rf;
    splRA(rc,drc,rcT,rcT2a);
    rc[0]	+=ESaR0[0];
    drc[0]	*=rf;
    ki	=0;
    for(k=1; k < ESFp1; k++){
      ki	+=ESNa1;
      splRA(rc+k,drc+k,rcT+ki,rcT2a+ki);
      rc[k]	*=2.;
      drc[k]	*=2.*rf;
      rct[k]	=-k*rc[k];
      d2ratc[k]	=-k*drc[k];
      d2rttc[k]	=k*rct[k];
      splRA(rs+k,drs+k,rsT+ki,rsT2a+ki);
      rs[k]	*=2.;
      drs[k]	*=2.*rf;
      rst[k]	=k*rs[k];
      d2rats[k]	=k*drs[k];
      d2rtts[k]	=-k*rst[k];
    }
#ifdef H
    for(j=0; j < ESNp; j++){
      s		=0.;
      kj	=0;
      for(k=1; k < ES2Mp1; k++){
	kj	+=j;
	if(kj >= ESNp){
	  kj	-=ESNp;
	}
	s	+=(Lc[k]*sn1[kj]+Ls[k]*(1.-cs1[kj]))/k;
      }
      Gh[j]	=s;
    }
    Gh[j]	=Gh[0];
#endif
    for(j=0; j < ESNp; j++){
      ss	=rc[0];
      dra	=drc[0];
      drt	=0.;
      kj	=0;
      for(k=1; k < ESFp1; k++){
	kj	+=j;
	if(kj >= ESNp){
	  kj	-=ESNp;
	}
	cs	=cs1[kj];
	sn	=sn1[kj];
	ss	+=rc[k]*cs+rs[k]*sn;
	dra	+=drc[k]*cs+drs[k]*sn;
	drt	+=rct[k]*sn+rst[k]*cs;
      }
      dGh[j]	=(dra*b*cs1[j]-(drs[0]+db*sn1[j])*drt)/ss;
    }
    dGh[j]	=dGh[0];
    dGh2[j]	=dGh2[0];
    splP(dGh,dGh2);
    k		=0;
    Gh[0]	=0.;
    for(j=0; j < ESNp; j++){
      k++;
      Gh[k]	=Gh[j]+chhp*(dGh[j]+dGh[k])-ch2hp*(dGh2[j]+dGh2[k]);
    }

    L0	=c2gp/Gh[k];
    for(j=0; j < ESNp1; j++){
      dGh[j]	*=L0;
      dGh2[j]	*=L0;
      Gh[j]	=Gh[j]*L0-ESgt[j];
    }
    L0	=1./D0;
    splP(Gh,Gh2);
    for(j=0; j < nP; j++){
      t		=c2gp-dgt*j;
      s		=t;
      cs	=cos(s);
      sn	=sin(s);
      ss	=rc[0]+rc[1]*cs+rs[1]*sn;
      dra	=drc[0]+drc[1]*cs+drs[1]*sn;
      drt	=rct[1]*sn+rst[1]*cs;
      ds	=dLc[1]*sn+dLs[1]*(1.-cs);
      gh	=Lc[1]*sn+Ls[1]*(1.-cs);
      gqt	=1.+Lc[1]*cs+Ls[1]*sn;
      dgqt	=dLc[1]*cs+dLs[1]*sn;
      z[ji]	=rs[0]+b*sn;
      dza	=drs[0]+db*sn;
      dzt	=b*cs;
      d2rat	=d2ratc[1]*sn+d2rats[1]*cs;
      d2rtt	=d2rttc[1]*cs+d2rtts[1]*sn;
      d2zat	=db*cs;
      d2ztt	=-b*sn;
      for(k=2; k < ESFp1; k++){
	s	=k*t;
	cs	=cos(s);
	sn	=sin(s);
	ss	+=rc[k]*cs+rs[k]*sn;
	dra	+=drc[k]*cs+drs[k]*sn;
	drt	+=rct[k]*sn+rst[k]*cs;
	d2rat	+=d2ratc[k]*sn+d2rats[k]*cs;
	d2rtt	+=d2rttc[k]*cs+d2rtts[k]*sn;
	if(k <  ES2Mp1){
	  ds	+=(dLc[k]*sn+dLs[k]*(1.-cs))/k;
	  gh	+=(Lc[k]*sn+Ls[k]*(1.-cs))/k;
	  gqt	+=Lc[k]*cs+Ls[k]*sn;
	  dgqt	+=dLc[k]*cs+dLs[k]*sn;
	}
      }
      r[ji]	=ss;
      p2r[ji]	=ss*ss;
      ra[ji]	=dra;
      za[ji]	=dza;
      rt[ji]	=-drt;
      zt[ji]	=-dzt;
      dp2rt[ji]	=-2.*ss*drt;
      dp2ra[ji]	=2.*ss*dra;

      D		=dra*dzt-drt*dza;
      g22[ji]	=(drt*drt+dzt*dzt)/(D*D);
      g11[ji]	=(dra*dra+dza*dza)/(D*D);
      g12[ji]	=(dra*drt+dza*dzt)/(D*D);
      
      dD	=d2rat*dzt+dra*d2ztt-d2rtt*dza-drt*d2zat;
      dg12	=d2rat*drt+dra*d2rtt+d2zat*dzt+dza*d2ztt;
      dg22	=2.*(d2rtt*drt+d2ztt*dzt);

      dg12t[ji]	=(2.*g12[ji]*dD-dg12/D)/D;
      dg22t[ji]	=(2.*g22[ji]*dD-dg22/D)/D;
      
      qg[ji]	=ss*D;
#ifdef H
      dqga[ji]	=dra*D+ss*(d2raa*d2zat+dra*d2zat-d2rat*dza-drt*d2zaa)
	-qg[ji]*d2gya;
      qg[ji]	=p2r[ji]*D0*gqt;
#endif

      dqga[ji]	=(dp2ra[ji]*D0+p2r[ji]*dD0)*gqt+p2r[ji]*D0*dgqt;

#ifdef H
      ESSetSplP(t);
      splRP(&s,NULL,Gh,Gh2);
      gd[ji]	=-s;
      dgda[ji]	=-ds;
#endif
      gd[ji]	=-gh;
      dgda[ji]	=-sq[i]*ds-dsqgy[i]*gh;
      ji++;
    }
  }
  free(Gh);
  {
    double *p,*P,d[3]={0.,0.,0.};

    ji	=nP*nA;
    /* $r_b$ into Esc2PstGm*/
    P	=r+ji;
    fwrite((void*)P,(size_t)8,(size_t)nP,Fp);
    fwrite((void*)P,(size_t)8,(size_t)2,Fp);
    /* $z_b$ into Esc2PstGm*/
    P	=z+ji;
    fwrite((void*)P,(size_t)8,(size_t)nP,Fp);
    fwrite((void*)P,(size_t)8,(size_t)2,Fp);
    /* $\bgY_{PEST}$ into Esc2PstGm*/
    s	=ESgY[ESNa]*c2gp*rBt;
    ds	=-s*dgy;
    for(i=0; i < nA1; i++){
      A[i]	=s+ds*i;
    }
    fwrite((void*)A,(size_t)8,(size_t)nA1,Fp);
    /* $r$ and $|\na\bgY|^2$*/
    /* $z$ and $r^2$*/
    /* $r'_{\gq_{PEST}}$ and $|\na\gq_{PEST}|^2$*/
    /* $z'_{\gq_{PEST}}$ and $(\na\bgY_{PEST}\cdot\na\gq_{PEST})$ */
    /* $r'_{\bgY_{PEST}}$ and $\R{\pa(\na\bgY\cdot\na\gq)}{\pa\gq}$*/
    /* $z'_{\bgY_{PEST}}$ and $\R{\pa r^2}{\pa a}$ */
    for(k=0; k < 6; k++){
      p	=w1[k];
      P	=w2[k];
      for(i=0; i < nA1; i++){
	fwrite((void*)P,(size_t)8,(size_t)nP,Fp);
	fwrite((void*)P,(size_t)8,(size_t)2,Fp);
	fwrite((void*)d,(size_t)8,(size_t)3,Fp);
	P	+=nP;
	fwrite((void*)p,(size_t)8,(size_t)nP,fp);
	fwrite((void*)p,(size_t)8,(size_t)2,fp);
	fwrite((void*)d,(size_t)8,(size_t)3,fp);
	p	+=nP;
      }
      if(k == 0){
	for(j=0; j < nP5; j++){
	  r[j]	=0.;
	}
      }
      fwrite((void*)r,(size_t)8,(size_t)nP5,Fp);
      fwrite((void*)r,(size_t)8,(size_t)nP5,fp);
    }

    /* $\R{\pa|\na\bgY|^2}{\pa\gq}$ */
    /* $\R{\pa r^2}{\pa\gq}$ */
    /* $\q{g_{PEST}}$ */
    /* $\R{\pa\q{g_{PEST}}}{\pa a}$ */
    /* $\gd_{PEST}$ */
    /* $\R{\pa\gd_{PEST}}{\pa a}$ */
    for(k=0; k < 6; k++){
      P	=w3[k];
      for(i=0; i < nA1; i++){
	fwrite((void*)P,(size_t)8,(size_t)nP,Fp);
	fwrite((void*)P,(size_t)8,(size_t)2,Fp);
	fwrite((void*)d,(size_t)8,(size_t)3,Fp);
	P	+=nP;
      }
      fwrite((void*)r,(size_t)8,(size_t)nP5,Fp);
    }
    for(k=0; k < 6; k++){
      free(w3[k]);
      free(w2[k]);
      free(w1[k]);
    }
  }
  printf("ES4PstGm%4.2f (fort.31) has been written\n",ttime);
  fclose(Fp);
  printf("ES4PstPr%4.2f (fort.32) has been written\n",ttime);
  fclose(fp);
  return(0);
}

/* Mapper with $\gz=\gf$ */
int ES4Pst0(int nA,double ttime)
{
  int nA1=NAP+1,nP=NPP,nP1=NPP+1,nP5=NPP+5;
  FILE *Fp,*fp;
  int i,j,k,ki,kj,ji;
  double dgy,dgt,dgya,rf,rg,a,ss,s,ds,rBt,p2rBt;
  double A[NAP+1];
  double *sp,*Ps,*sq,*dsqgy,*g,*dggy,*fb,*dfbgy;
  double *r,*z,*rt,*zt,*ra,*za;
  double *g22,*p2r,*g11,*g12,*dg12t,*dp2ra,*dg22t,*dp2rt,*qg,*dqga,*gd,*dgda;

  double *rc,*rs,*drc,*drs,*rct,*rst,dra,drt,dza,dzt,cs,sn,b,db,dz,fac;
  double *Gh,*Gh2,gh,t;
  double *d2rttc,*d2rtts,*d2ratc,*d2rats,d2rtt,d2ztt,d2rat,d2zat;
  double *Lc,*Ls,*dLc,*dLs,D0,dD0,D,dD,dg22,dg12,dgqt,L0;

  double *w1[6],*w2[6],*w3[6];

  double dGh[65],dGh2[65],chhp,ch2hp;

  nA1=nA+1;
  chhp	=cr2*ESgt[1];
  ch2hp	=chhp*cr6*ESgt[1];

  i	=nP*nA1;
  for(k=0; k < 6; k++){
    w1[k]	=NULL;
    w2[k]	=NULL;
    w3[k]	=NULL;
    w1[k]	=(double*)malloc(i*sizeof(double));
    w2[k]	=(double*)malloc(i*sizeof(double));
    w3[k]	=(double*)malloc(i*sizeof(double));
    if(w1[k] == NULL || w2[k] == NULL || w3[k] == NULL){
      printf("No memory for w[%d] in ES4Pst0()%c\n",k,7);
      j=k;
      while(j >= 0){
	free(w3[j]);
	free(w2[j]);
	free(w1[j]);
	j--;
      }
      return(0);
    }
  }

  r	=w1[0];
  z	=w1[1];
  rt	=w1[2];
  zt	=w1[3];
  ra	=w1[4];
  za	=w1[5];

  g22	=w2[0];
  p2r	=w2[1];
  g11	=w2[2];
  g12	=w2[3];
  dg12t	=w2[4];
  dp2ra	=w2[5];
  dg22t	=w3[0];
  dp2rt	=w3[1];
  qg	=w3[2];
  dqga	=w3[3];
  gd	=w3[4];
  dgda	=w3[5];
  
  Gh	=(double*)malloc((4*ESNp1+10*ESFp1+4*ES2Mp1)*sizeof(double));
  Gh2	=Gh	+ESNp1;
  rc	=Gh2	+ESNp1;
  rs	=rc	+ESFp1;
  drc	=rs	+ESFp1;
  drs	=drc	+ESFp1;
  rct	=drs	+ESFp1;
  rst	=rct	+ESFp1;
  d2ratc	=rst	+ESFp1;
  d2rats	=d2ratc	+ESFp1;
  d2rttc	=d2rats	+ESFp1;
  d2rtts	=d2rttc	+ESFp1;
  Lc	=d2rtts	+ESFp1;
  Ls	=Lc	+ES2Mp1;
  dLc	=Ls	+ES2Mp1;
  dLs	=dLc	+ES2Mp1;

  if(Gh == NULL){
    printf("No memory for Gh in ES4Pst0()\n");
    fclose(fp);
    return(0);
  }
  sp	=r;
  Ps	=z;
  sq	=rt;
  dsqgy	=zt;
  g	=ra;
  dggy	=za;
  fb	=g22;
  dfbgy	=p2r;

  rg	=1./ESRBt;
  rBt	=ESRext*rg;
  p2rBt	=rBt*rBt;
  rf	=-ESgY[ESNa]*rBt;
  dgt	=c2gp/nP;
  dgy	=1./nA;
  
#ifdef H
  sprintf(Ttl.Title,"ES4PstGm%4.2f",ttime); /* fort.31 */
  sprintf(Ttl.Title,"ES4PstGm",ttime);
  Fp	=fopen(Ttl.Title,"w");

  sprintf(Ttl.Title,"ES4PstPr%4.2f",ttime); /* fort.32 */
  sprintf(Ttl.Title,"ES4Pst",ttime);
  fp	=fopen(Ttl.Title,"w");
#endif
  sprintf(Ttl.Title,"/scratchu/zakh/Pst/fort.31",ttime); /* fort.31 */
  Fp	=fopen(Ttl.Title,"w");

  sprintf(Ttl.Title,"/scratchu/zakh/Pst/fort.32",ttime); /* fort.32 */
  fp	=fopen(Ttl.Title,"w");

  printf("Writing plasma profiles\n");
  strcpy(Ttl.Title,"ESC has written this garbage");
  i	=strlen(Ttl.Title);
  while(i < 159){
    Ttl.Title[i]	=' ';
    i++;
  }
  Ttl.Title[i]	='\0';
  g[0]	=0.;
  fwrite((void*)g,(size_t)8,(size_t)1,Fp);
  fwrite((void*)g,(size_t)8,(size_t)1,fp);
  i	=0;
  while(i < 8){
    Ttl.date[i]	='\0';
    i++;
  }
  Ttl.nxx[0]	=nP1; /* number of poloidal intervals (+1 in symmetric case)*/
  Ttl.nxx[1]	=nA1;			/* number of radial intervals +1*/ 
  Ttl.nxx[2]	=401;			/* Number of magnetic surfaces */
  Ttl.nxx[3]	=128;			/* Number of poloidal intervals */ 
  Ttl.nxx[4]	=0;			/* Junk */ 
  Ttl.axx[0]	=rdPV[3]-rdPV[2];
  Ttl.axx[1]	=zdPV[0]-zdPV[1];
  Ttl.axx[2]	=zdPV[0];
  Ttl.axx[3]	=ESaR0[0];
  Ttl.axx[4]	=ESRext;
  Ttl.axx[5]	=ESsp[0]*p2rBt;
  Ttl.axx[6]	=ESRBt*rBt/ESRext;
  Ttl.axx[7]	=c2gp*ESgY[ESNa]*rBt;
  Ttl.axx[8]	=0.;
  Ttl.axx[9]	=c2gp*ESgY[ESNa]*rBt;
  Ttl.axx[10]	=0.;
  Ttl.axx[11]	=0.;
  Ttl.axx[12]	=1.;	/* constant C in rD=Cr^m\na\bgY^n */

  Ttl.nxy[0]	=0;	/* exponent n in rD=Cr^m\na\bgY^n */
  Ttl.nxy[1]	=2;	/* exponent m in rD=Cr^m\na\bgY^n,
			   2 - straight field lines */
  Ttl.nxy[2]	=0;	/* Junk */ 
  Ttl.nxy[3]	=0;	/* Junk */ 
  Ttl.nxy[4]	=0;	/* Junk */
  Ttl.nxy[5]	=0;	/* Junk */
  Ttl.nxy[6]	=0;	/* Junk */ 
  Ttl.nxy[7]	=0;	/* Junk */
  Ttl.nxy[8]	=NSIZE;	/* Junk */
  Ttl.nxy[9]	=NSIZE;	/* Junk */

  Ttl.axy[0]	=dgt;
  Ttl.axy[1]	=dgy;
  Ttl.axy[2]	=cgp;
  Ttl.axy[3]	=ESRext;
  Ttl.axy[4]	=ESRBt/ESRext;
  for(i=5; i < 10; i++){
    Ttl.axy[i]	=0.;
  }
  fwrite((void*)&Ttl,(size_t)8,(size_t)49,Fp);
  fwrite((void*)&Ttl,(size_t)8,(size_t)49,fp);

  a	=0.;
  i	=0;
  A[i]	=a;
  sp[i]	=ESsp[0]*p2rBt;
  Ps[i]	=-ESPs[0]*rBt;
  sq[i]	=1./ESgm[0];
  if(ESEqSolvInCr != 6 && ESEqSolvInCr != 7){
    dsqgy[i]	=ESgm2a[0]*sq[i]*sq[i]/(ESdgY[0]*rBt);
  }
  else{
    ESSetSplDCr(a);
    splRDCr2(&s,NULL,dsqgy,7);
    dsqgy[i]	*=sq[i]*sq[i]/(ESdgY[0]*rBt);
  }

  g[i]	=ESaF[0]*rg;
  s	=ESaT[0]*rBt;
  dggy[i]=-s/(ESRext*ESRext*g[i]);
  fb[i]	=-ESaR0[0]*ESdgY[0]*rBt/ESLc[0];
  dfbgy[i]	=ESaR0[0]*(ESdgY2a[0]-ESdgY[0]*ESLc2[0]/ESLc[0])/
    (ESdgY[0]*ESLc[0]);
  for(i=1; i < nA1; i++){
    ss	=sqrt(dgy*i);
    do{
      ESSetSplA(a);
      splRA(&s,&dgya,ESqgY,ESqgY2a);
      a		+=(ss-s)/dgya;
    }while(fabs(ss-s) > 1e-8);
    A[i]	=a;
    ESSetSplA(a);
    if(ESEqSolvInPr != 2){
      splRA(sp+i,NULL,ESsp,ESsp2a);
    }
    else{
      ESSetSplDPr(a);
      splRDPr(sp+i,&ds,2);
    }
    sp[i]	*=p2rBt;
    switch(ESEqSolvInPr){
    case 0:
      ESSetSplDPr(a);
      splRDPr(Ps+i,&ds,0);
      Ps[i]	/=ESaR0[0];
      break;
    case 1:
      ESSetSplDPr(a);
      splRDPr(Ps+i,&ds,1);
      break;
    default:
      splRA(Ps+i,NULL,ESPs,ESPs2a);
      break;
    }
    Ps[i]	*=-rBt;
    splRA(&dgya,&ds,ESdgY,ESdgY2a);
    splRA(&s,&ss,ESLc,ESLc2);
    fb[i]	=-ESaR0[0]*dgya/s;
    dgya	*=a;
    dfbgy[i]	=(ESaR0[0]*ds+fb[i]*ss)/(dgya*s);
    fb[i]	*=rBt;
    if(ESEqSolvInCr != 6 && ESEqSolvInCr != 7){
      splRA(&s,&ds,ESgm,ESgm2a);
    }
    else{
      ESSetSplDCr(a);
      splRDCr(&s,&ds,7);
    }
    sq[i]	=1./s;
    dsqgy[i]	=ds/(dgya*rBt*s*s);
    splRA(g+i,&ds,ESaF,ESaF2a);
    g[i]	*=rg;
    splRA(&s,NULL,ESaT,ESaT2a);
    s		*=rBt;
    dggy[i]	=-s/(ESRext*ESRext*g[i]);
  }
  fwrite((void*)sp,(size_t)8,(size_t)nA1,fp);
  fwrite((void*)Ps,(size_t)8,(size_t)nA1,fp);
  fwrite((void*)sq,(size_t)8,(size_t)nA1,fp);
  fwrite((void*)dsqgy,(size_t)8,(size_t)nA1,fp);
  fwrite((void*)g,(size_t)8,(size_t)nA1,fp);
  fwrite((void*)dggy,(size_t)8,(size_t)nA1,fp);
  fwrite((void*)fb,(size_t)8,(size_t)nA1,fp);
  fwrite((void*)dfbgy,(size_t)8,(size_t)nA1,fp);

  a	=0.;
  ss	=sqrt(dgy*0.01);
  do{
    ESSetSplA(a);
    splRA(&s,&dgya,ESqgY,ESqgY2a);
    a		+=(ss-s)/dgya;
  }while(fabs(ss-s) > 1e-8);
  A[0]	=a;
  
  printf("Writing PEST metric tensor\n");
  
  ji	=0;
  for(i=0; i < nA1; i++){
    a	=A[i];
    ESSetSplA(a);
    splRA(&dgya,&dD0,ESdgY,ESdgY2a);
    rf	=-1./(dgya*a*rBt);
    splRA(Lc,dLc,ESLc,ESLc2);
    s	=1./(ESaR0[0]*dgya*rBt);
    D0	=-Lc[0]*s;
    dD0	=-(dLc[0]*s+D0*dD0/dgya)*rf;
    L0		=2./Lc[0];
    s		=rf*L0;
    dLc[0]	*=rf/Lc[0];
    ki	=0;
    for(k=1; k < ES2Mp1; k++){
      ki	+=ESNa1;
      splRA(Lc+k,dLc+k,ESLc+ki,ESLc2+ki);
      Lc[k]	*=L0;
      dLc[k]	=dLc[k]*s-Lc[k]*dLc[0];
      splRA(Ls+k,dLs+k,ESLs+ki,ESLs2+ki);
      Ls[k]	*=L0;
      dLs[k]	=dLs[k]*s-Ls[k]*dLc[0];
    }
    splRA(&b,&db,ESsb,ESsb2a);
    db	*=rf;
    splRA(rs,drs,rsT,rsT2a);
    drs[0]	*=rf;
    splRA(rc,drc,rcT,rcT2a);
    rc[0]	+=ESaR0[0];
    drc[0]	*=rf;
    ki	=0;
    for(k=1; k < ESFp1; k++){
      ki	+=ESNa1;
      splRA(rc+k,drc+k,rcT+ki,rcT2a+ki);
      rc[k]	*=2.;
      drc[k]	*=2.*rf;
      rct[k]	=-k*rc[k];
      d2ratc[k]	=-k*drc[k];
      d2rttc[k]	=k*rct[k];
      splRA(rs+k,drs+k,rsT+ki,rsT2a+ki);
      rs[k]	*=2.;
      drs[k]	*=2.*rf;
      rst[k]	=k*rs[k];
      d2rats[k]	=k*drs[k];
      d2rtts[k]	=-k*rst[k];
    }
    for(j=0; j < ESNp; j++){
      s		=0.;
      kj	=0;
      for(k=1; k < ES2Mp1; k++){
	kj	+=j;
	if(kj >= ESNp){
	  kj	-=ESNp;
	}
	s	+=(Lc[k]*sn1[kj]+Ls[k]*(1.-cs1[kj]))/k;
      }
      Gh[j]	=s;
    }
    Gh[j]	=Gh[0];
#ifdef H
    for(j=0; j < ESNp; j++){
      ss	=rc[0];
      dra	=drc[0];
      drt	=0.;
      kj	=0;
      for(k=1; k < ESFp1; k++){
	kj	+=j;
	if(kj >= ESNp){
	  kj	-=ESNp;
	}
	cs	=cs1[kj];
	sn	=sn1[kj];
	ss	+=rc[k]*cs+rs[k]*sn;
	dra	+=drc[k]*cs+drs[k]*sn;
	drt	+=rct[k]*sn+rst[k]*cs;
      }
      dGh[j]	=(dra*b*cs1[j]-(drs[0]+db*sn1[j])*drt)/ss;
    }
    dGh[j]	=dGh[0];
    dGh2[j]	=dGh2[0];
    splP(dGh,dGh2);
    k		=0;
    Gh[0]	=0.;
    for(j=0; j < ESNp; j++){
      k++;
      Gh[k]	=Gh[j]+chhp*(dGh[j]+dGh[k])-ch2hp*(dGh2[j]+dGh2[k]);
    }

    L0	=c2gp/Gh[k];
    for(j=0; j < ESNp1; j++){
      dGh[j]	*=L0;
      dGh2[j]	*=L0;
      Gh[j]	=Gh[j]*L0-ESgt[j];
    }
#endif
    L0	=1./D0;
    splP(Gh,Gh2);
    t	=c2gp;
    for(j=0; j < nP; j++){
      gh	=c2gp-dgt*j;
      do{
	ESSetSplP(t);
	splRP(&s,&ds,Gh,Gh2);
	s	+=t-gh;
	t	-=s/(1.+ds);
      }while(fabs(s) > 1e-8);
      s		=t;
      cs	=cos(s);
      sn	=sin(s);
      ss	=rc[0]+rc[1]*cs+rs[1]*sn;
      dra	=drc[0]+drc[1]*cs+drs[1]*sn;
      drt	=rct[1]*sn+rst[1]*cs;
      ds	=dLc[1]*sn+dLs[1]*(1.-cs);
      dgqt	=dLc[1]*cs+dLs[1]*sn;
      z[ji]	=rs[0]+b*sn;
      dza	=drs[0]+db*sn;
      dzt	=b*cs;
      d2rat	=d2ratc[1]*sn+d2rats[1]*cs;
      d2rtt	=d2rttc[1]*cs+d2rtts[1]*sn;
      d2zat	=db*cs;
      d2ztt	=-b*sn;
      for(k=2; k < ESFp1; k++){
	s	=k*t;
	cs	=cos(s);
	sn	=sin(s);
	ss	+=rc[k]*cs+rs[k]*sn;
	dra	+=drc[k]*cs+drs[k]*sn;
	drt	+=rct[k]*sn+rst[k]*cs;
	d2rat	+=d2ratc[k]*sn+d2rats[k]*cs;
	d2rtt	+=d2rttc[k]*cs+d2rtts[k]*sn;
	if(k <  ES2Mp1){
	  ds	+=(dLc[k]*sn+dLs[k]*(1.-cs))/k;
	  dgqt+=dLc[k]*cs+dLs[k]*sn;
	}
      }
      r[ji]	=ss;
      D		=dra*dzt-drt*dza;
      g22[ji]	=(drt*drt+dzt*dzt)/(D*D);
      dD	=d2rat*dzt+dra*d2ztt-d2rtt*dza-drt*d2zat;
      dg12	=d2rat*drt+dra*d2rtt+d2zat*dzt+dza*d2ztt;
      dg22	=2.*(d2rtt*drt+d2ztt*dzt);
      s		=ss/(D*L0);
      dg12t[ji]	=(dg22*ds/(D*D)+g22[ji]*(dgqt-2.*ds*dD/D))*s
	-(dg12-(dra*drt+dza*dzt)*(dD*ss+D*drt)/(D*ss))/(D*D);

      dg22t[ji]	=(2.*g22[ji]*dD-dg22/D)*s/D;


      dg12t[ji]	=-(dg12-(dra*drt+dza*dzt)*(dD*ss+D*drt)/(D*ss))/(D*D);


      dg22t[ji]	=(2.*g22[ji]*dD-dg22/D)*s/D;


      rt[ji]	=-drt*s;
      zt[ji]	=-dzt*s;

      p2r[ji]	=r[ji]*r[ji];
      dp2rt[ji]	=2.*r[ji]*rt[ji];
      ds	*=s;
      dra	-=drt*ds;
      dza	-=dzt*ds;
      ra[ji]	=dra;
      za[ji]	=dza;
      g11[ji]	=(dra*dra+dza*dza)*L0*L0/(ss*ss);
      g12[ji]	=(dra*drt+dza*dzt)*L0/(D*ss);
      dp2ra[ji]	=2.*ss*dra;
      qg[ji]	=ss*ss*D0;
      dqga[ji]	=dp2ra[ji]*D0+p2r[ji]*dD0;
      gd[ji]	=0.;
      dgda[ji]	=0.;
      ji++;
    }
  }
  free(Gh);
  {
    double *p,*P,d[3]={0.,0.,0.};

    ji	=nP*nA;
    /* $r_b$ into Esc2PstGm*/
    P	=r+ji;
    fwrite((void*)P,(size_t)8,(size_t)nP,Fp);
    fwrite((void*)P,(size_t)8,(size_t)2,Fp);
    /* $z_b$ into Esc2PstGm*/
    P	=z+ji;
    fwrite((void*)P,(size_t)8,(size_t)nP,Fp);
    fwrite((void*)P,(size_t)8,(size_t)2,Fp);
    /* $\bgY_{PEST}$ into Esc2PstGm*/
    s	=ESgY[ESNa]*c2gp*rBt;
    ds	=-s*dgy;
    for(i=0; i < nA1; i++){
      A[i]	=s+ds*i;
    }
    fwrite((void*)A,(size_t)8,(size_t)nA1,Fp);
    /* $r$ and $|\na\bgY|^2$*/
    /* $z$ and $r^2$*/
    /* $r'_{\gq_{PEST}}$ and $|\na\gq_{PEST}|^2$*/
    /* $z'_{\gq_{PEST}}$ and $(\na\bgY_{PEST}\cdot\na\gq_{PEST})$ */
    /* $r'_{\bgY_{PEST}}$ and $\R{\pa(\na\bgY\cdot\na\gq)}{\pa\gq}$*/
    /* $z'_{\bgY_{PEST}}$ and $\R{\pa r^2}{\pa a}$ */
    for(k=0; k < 6; k++){
      p	=w1[k];
      P	=w2[k];
      for(i=0; i < nA1; i++){
	fwrite((void*)P,(size_t)8,(size_t)nP,Fp);
	fwrite((void*)P,(size_t)8,(size_t)2,Fp);
	fwrite((void*)d,(size_t)8,(size_t)3,Fp);
	P	+=nP;
	fwrite((void*)p,(size_t)8,(size_t)nP,fp);
	fwrite((void*)p,(size_t)8,(size_t)2,fp);
	fwrite((void*)d,(size_t)8,(size_t)3,fp);
	p	+=nP;
      }
      if(k == 0){
	for(j=0; j < nP5; j++){
	  r[j]	=0.;
	}
      }
      fwrite((void*)r,(size_t)8,(size_t)nP5,Fp);
      fwrite((void*)r,(size_t)8,(size_t)nP5,fp);
    }

    /* $\R{\pa|\na\bgY|^2}{\pa\gq}$ */
    /* $\R{\pa r^2}{\pa\gq}$ */
    /* $\q{g_{PEST}}$ */
    /* $\R{\pa\q{g_{PEST}}}{\pa a}$ */
    /* $\gd_{PEST}$ */
    /* $\R{\pa\gd_{PEST}}{\pa a}$ */
    for(k=0; k < 6; k++){
      P	=w3[k];
      for(i=0; i < nA1; i++){
	fwrite((void*)P,(size_t)8,(size_t)nP,Fp);
	fwrite((void*)P,(size_t)8,(size_t)2,Fp);
	fwrite((void*)d,(size_t)8,(size_t)3,Fp);
	P	+=nP;
      }
      fwrite((void*)r,(size_t)8,(size_t)nP5,Fp);
    }
    for(k=0; k < 6; k++){
      free(w3[k]);
      free(w2[k]);
      free(w1[k]);
    }
  }
  printf("ES4PstGm%4.2f (fort.31) has been written\n",ttime);
  fclose(Fp);
  printf("ES4PstPr%4.2f (fort.32) has been written\n",ttime);
  fclose(fp);
  return(0);
}

/* Mapper with $g_{\gq\gq}=const$ */
int ES4Pst1(int nA,double ttime)
{
  int nA1=NAP+1,nP=NPP,nP1=NPP+1,nP5=NPP+5;
  FILE *Fp,*fp;
  int i,j,k,ki,kj,ji;
  double dgy,dgt,dgya,rf,rg,a,ss,s,ds,rBt,p2rBt;
  double A[NAP+1];
  double *sp,*Ps,sq[NAP+1],dsqgy[NAP+1],*g,*dggy,*fb,*dfbgy;
  double *r,*z,*rt,*zt,*ra,*za;
  double *g22,*p2r,*g11,*g12,*dg12t,*dp2ra,*dg22t,*dp2rt,*qg,*dqga,*gd,*dgda;

  double *rc,*rs,*drc,*drs,*rct,*rst,dra,drt,dza,dzt,cs,sn,b,db;
  double *gQ,*gQ2,gq,gqa,gqt,gqat,gqtt,t;
  double *d2rttc,*d2rtts,*d2ratc,*d2rats,d2rtt,d2ztt,d2rat,d2zat;
  double *Lc,*Ls,*dLc,*dLs,D0,dD0,D,dD;
  double dg22,dg12,gh,ght,gha,ghat,ghtt,L0,G0;
  double *g22c,*g22c2,*g22s,*g22s2,*G22c,*dG22c,*G22s,*dG22s;

  double *w1[6],*w2[6],*w3[6];

  nA1	=nA+1;
  i	=nP*nA1;
  for(k=0; k < 6; k++){
    w1[k]	=NULL;
    w2[k]	=NULL;
    w3[k]	=NULL;
    w1[k]	=(double*)malloc(i*sizeof(double));
    w2[k]	=(double*)malloc(i*sizeof(double));
    w3[k]	=(double*)malloc(i*sizeof(double));
    if(w1[k] == NULL || w2[k] == NULL || w3[k] == NULL){
      printf("No memory for w[%d] in ES4Pst1()%c\n",k,7);
      j=k;
      while(j >= 0){
	free(w3[j]);
	free(w2[j]);
	free(w1[j]);
	j--;
      }
      return(0);
    }
  }

  r	=w1[0];
  z	=w1[1];
  rt	=w1[2];
  zt	=w1[3];
  ra	=w1[4];
  za	=w1[5];

  g22	=w2[0];
  p2r	=w2[1];
  g11	=w2[2];
  g12	=w2[3];
  dg12t	=w2[4];
  dp2ra	=w2[5];
  dg22t	=w3[0];
  dp2rt	=w3[1];
  qg	=w3[2];
  dqga	=w3[3];
  gd	=w3[4];
  dgda	=w3[5];
  
  gQ	=(double*)malloc((4*ESNp1+18*ESFp1)*sizeof(double));
  gQ2	=gQ	+ESNp1;
  rc	=gQ2	+ESNp1;
  rs	=rc	+ESFp1;
  drc	=rs	+ESFp1;
  drs	=drc	+ESFp1;
  rct	=drs	+ESFp1;
  rst	=rct	+ESFp1;
  d2ratc	=rst	+ESFp1;
  d2rats	=d2ratc	+ESFp1;
  d2rttc	=d2rats	+ESFp1;
  d2rtts	=d2rttc	+ESFp1;
  Lc		=d2rtts	+ESFp1;
  Ls		=Lc	+ESFp1;
  dLc		=Ls	+ESFp1;
  dLs		=dLc	+ESFp1;
  G22c		=dLs	+ESFp1;
  G22s		=G22c	+ESFp1;
  dG22c		=G22s	+ESFp1;
  dG22s		=dG22c	+ESFp1;

  if(gQ == NULL){
    printf("No memory for gQ in ES4Pst1()\n");
    return(0);
  }
  sp	=r;
  Ps	=z;
  g	=ra;
  dggy	=za;
  fb	=g22;
  dfbgy	=p2r;

  i	=ESNa1*ESFp1;
  g22c	=(double*)malloc(4*i*sizeof(double));
  g22c2	=g22c	+i;
  g22s	=g22c2	+i;
  g22s2	=g22s	+i;
  if(g22c == NULL){
    printf("No memory for gQ in ES4Pst1()\n");
    return(0);
  }

  i		=0;
  b		=ESsb1a[i];
  ki		=ESNa1;
  rc[1]		=2.*rcT1a[ki];
  rs[1]		=2.*rsT1a[ki];
  for(j=0; j < ESNp; j++){
    rt[j]	=-rc[1]*sn1[j]+rs[1]*cs1[j];
    zt[j]	=b*cs1[j];
    g22[j]	=sqrt(rt[j]*rt[j]+zt[j]*zt[j]);
  }
  g22[j]	=g22[0];
  ESgP2gF(g22c+i,g22s+i,g22,ESFp);

  ki		=2*ESNa1;
  rc[2]		=2.*rcT2a[ki];
  rs[2]		=2.*rsT2a[ki];
  for(j=0; j < ESNp; j++){
    dra		=-rc[2]*sn2[j]+rs[2]*cs2[j];
    g22[j]	=dra*rt[j]/g22[j];
  }
  g22[j]	=g22[0];
  ESgP2gF(g22c2+i,g22s2+i,g22,ESFp);
  for(i=1; i < ESNa1; i++){
    db	=1./ESsa[i];
    b	=ESsb[i]*db;
    ki	=i;
    db	*=2.;
    for(k=1; k < ESFp1; k++){
      ki	+=ESNa1;
      rc[k]	=k*rcT[ki]*db;
      rs[k]	=k*rsT[ki]*db;
    }
    for(j=0; j < ESNp; j++){
      rt[j]	=0.;
      kj	=0;
      for(k=1; k < ESFp1; k++){
	kj		+=j;
	if(kj >= ESNp)
	  kj	-=ESNp;
	rt[j]	+=-rc[k]*sn1[kj]+rs[k]*cs1[kj];
      }
      zt[j]	=b*cs1[j];
      g22[j]	=sqrt(rt[j]*rt[j]+zt[j]*zt[j]);
    }
    g22[j]	=g22[0];
    ESgP2gF(g22c+i,g22s+i,g22,ESFp);
  }
  i		=ESNa;
  ki		=i;
  for(k=1; k < ESFp1; k++){
    ki		+=ESNa1;
    b		=2.*k;
    rc[k]	=b*rcT1a[ki];
    rs[k]	=b*rsT1a[ki];
  }
  b		=ESsb1a[i];
  for(j=0; j < ESNp; j++){
    dra	=0.;
    kj	=0;
    for(k=1; k < ESFp1; k++){
      kj	+=j;
      if(kj >= ESNp)
	kj	-=ESNp;
      dra	+=-rc[k]*sn1[kj]+rs[k]*cs1[kj];
    }
    dza		=b*cs1[j];
    g22[j]	=(rt[j]*dra+zt[j]*dza)/g22[j];
  }
  g22[j]	=g22[0];
  ESgP2gF(g22c2+i,g22s2+i,g22,ESFp);
  dg12	=g22c2[0];
  dg22	=g22c2[ESNa];
  splA(g22c,g22c2,&dg12,&dg22);
  ki	=0;
  for(k=1; k < ESFp1; k++){
    ki 		+=ESNa1;
    i		=ki+ESNa;
    dg12	=g22c2[ki];
    dg22	=g22c2[i];
    splA(g22c+ki,g22c2+ki,&dg12,&dg22);
    dg12	=g22s2[ki];
    dg22	=g22s2[i];
    splA(g22s+ki,g22s2+ki,&dg12,&dg22);
  }

  rg	=1./ESRBt;
  rBt	=ESRext*rg;
  p2rBt	=rBt*rBt;
  rf	=-ESgY[ESNa]*rBt;
  dgt	=c2gp/nP;
  dgy	=1./nA;
  
#ifdef H
  sprintf(Ttl.Title,"ES4PstGm%4.2f",ttime); /* fort.31 */
  sprintf(Ttl.Title,"ES4PstGm",ttime);
  Fp	=fopen(Ttl.Title,"w");

  sprintf(Ttl.Title,"ES4PstPr%4.2f",ttime); /* fort.32 */
  sprintf(Ttl.Title,"ES4Pst",ttime);
  fp	=fopen(Ttl.Title,"w");
#endif
  sprintf(Ttl.Title,"/scratchu/zakh/Pst/fort.31",ttime); /* fort.31 */
  Fp	=fopen(Ttl.Title,"w");

  sprintf(Ttl.Title,"/scratchu/zakh/Pst/fort.32",ttime); /* fort.32 */
  fp	=fopen(Ttl.Title,"w");

  printf("Writing plasma profiles\n");
  strcpy(Ttl.Title,"ESC has written this garbage");
  i	=strlen(Ttl.Title);
  while(i < 159){
    Ttl.Title[i]	=' ';
    i++;
  }
  Ttl.Title[i]	='\0';
  g[0]	=0.;
  fwrite((void*)g,(size_t)8,(size_t)1,Fp);
  fwrite((void*)g,(size_t)8,(size_t)1,fp);
  i	=0;
  while(i < 8){
    Ttl.date[i]	='\0';
    i++;
  }
  Ttl.nxx[0]	=nP1; /* number of poloidal intervals (+1 in symmetric case)*/
  Ttl.nxx[1]	=nA1;			/* number of radial intervals +1*/ 
  Ttl.nxx[2]	=401;			/* Number of magnetic surfaces */
  Ttl.nxx[3]	=128;			/* Number of poloidal intervals */ 
  Ttl.nxx[4]	=0;			/* Junk */ 
  Ttl.axx[0]	=rdPV[3]-rdPV[2];
  Ttl.axx[1]	=zdPV[0]-zdPV[1];
  Ttl.axx[2]	=zdPV[0];
  Ttl.axx[3]	=ESaR0[0];
  Ttl.axx[4]	=ESRext;
  Ttl.axx[5]	=ESsp[0]*p2rBt;
  Ttl.axx[6]	=ESRBt*rBt/ESRext;
  Ttl.axx[7]	=c2gp*ESgY[ESNa]*rBt;
  Ttl.axx[8]	=0.;
  Ttl.axx[9]	=c2gp*ESgY[ESNa]*rBt;
  Ttl.axx[10]	=0.;
  Ttl.axx[11]	=0.;
  Ttl.axx[12]	=1.;	/* constant C in rD=Cr^m\na\bgY^n */

  Ttl.nxy[0]	=0;	/* exponent n in rD=Cr^m\na\bgY^n */
  Ttl.nxy[1]	=2;	/* exponent m in rD=Cr^m\na\bgY^n,
			   2 - straight field lines */
  Ttl.nxy[2]	=0;	/* Junk */ 
  Ttl.nxy[3]	=0;	/* Junk */ 
  Ttl.nxy[4]	=0;	/* Junk */
  Ttl.nxy[5]	=0;	/* Junk */
  Ttl.nxy[6]	=0;	/* Junk */ 
  Ttl.nxy[7]	=0;	/* Junk */
  Ttl.nxy[8]	=NSIZE;	/* Junk */
  Ttl.nxy[9]	=NSIZE;	/* Junk */

  Ttl.axy[0]	=dgt;
  Ttl.axy[1]	=dgy;
  Ttl.axy[2]	=cgp;
  Ttl.axy[3]	=ESRext;
  Ttl.axy[4]	=ESRBt/ESRext;
  for(i=5; i < 10; i++){
    Ttl.axy[i]	=0.;
  }
  fwrite((void*)&Ttl,(size_t)8,(size_t)49,Fp);
  fwrite((void*)&Ttl,(size_t)8,(size_t)49,fp);

  a	=0.;
  i	=0;
  A[i]	=a;
  sp[i]	=ESsp[0]*p2rBt;
  Ps[i]	=-ESPs[0]*rBt;
  sq[i]	=1./ESgm[0];
  if(ESEqSolvInCr != 6 && ESEqSolvInCr != 7){
    dsqgy[i]	=ESgm2a[0]*sq[i]*sq[i]/(ESdgY[0]*rBt);
  }
  else{
    ESSetSplDCr(a);
    splRDCr2(&s,NULL,dsqgy,7);
    dsqgy[i]	*=sq[i]*sq[i]/(ESdgY[0]*rBt);
  }
  g[i]	=ESaF[0]*rg;
  s	=ESaT[0]*rBt;
  dggy[i]=-s/(ESRext*ESRext*g[i]);
  fb[i]	=-ESaR0[0]*ESdgY[0]*rBt/ESLc[0];
  dfbgy[i]	=ESaR0[0]*(ESdgY2a[0]-ESdgY[0]*ESLc2[0]/ESLc[0])/
    (ESdgY[0]*ESLc[0]);
  for(i=1; i < nA1; i++){
    ss	=sqrt(dgy*i);
    do{
      ESSetSplA(a);
      splRA(&s,&dgya,ESqgY,ESqgY2a);
      a		+=(ss-s)/dgya;
    }while(fabs(ss-s) > 1e-8);
    A[i]	=a;
    ESSetSplA(a);
    if(ESEqSolvInPr != 2){
      splRA(sp+i,NULL,ESsp,ESsp2a);
    }
    else{
      ESSetSplDPr(a);
      splRDPr(sp+i,&ds,2);
    }
    sp[i]	*=p2rBt;
    switch(ESEqSolvInPr){
    case 0:
      ESSetSplDPr(a);
      splRDPr(Ps+i,&ds,0);
      Ps[i]	/=ESaR0[0];
      break;
    case 1:
      ESSetSplDPr(a);
      splRDPr(Ps+i,&ds,1);
      break;
    default:
      splRA(Ps+i,NULL,ESPs,ESPs2a);
      break;
    }
    Ps[i]	*=-rBt;
    splRA(&dgya,&ds,ESdgY,ESdgY2a);
    splRA(&s,&ss,ESLc,ESLc2);
    fb[i]	=-ESaR0[0]*dgya/s;
    dgya	*=a;
    dfbgy[i]	=(ESaR0[0]*ds+fb[i]*ss)/(dgya*s);
    fb[i]	*=rBt;
    if(ESEqSolvInCr != 6 && ESEqSolvInCr != 7){
      splRA(&s,&ds,ESgm,ESgm2a);
    }
    else{
      ESSetSplDCr(a);
      splRDCr(&s,&ds,7);
    }
    sq[i]	=1./s;
    dsqgy[i]	=ds/(dgya*rBt*s*s);
    splRA(g+i,&ds,ESaF,ESaF2a);
    g[i]	*=rg;
    splRA(&s,NULL,ESaT,ESaT2a);
    s		*=rBt;
    dggy[i]	=-s/(ESRext*ESRext*g[i]);
  }
  fwrite((void*)sp,(size_t)8,(size_t)nA1,fp);
  fwrite((void*)Ps,(size_t)8,(size_t)nA1,fp);
  fwrite((void*)sq,(size_t)8,(size_t)nA1,fp);
  fwrite((void*)dsqgy,(size_t)8,(size_t)nA1,fp);
  fwrite((void*)g,(size_t)8,(size_t)nA1,fp);
  fwrite((void*)dggy,(size_t)8,(size_t)nA1,fp);
  fwrite((void*)fb,(size_t)8,(size_t)nA1,fp);
  fwrite((void*)dfbgy,(size_t)8,(size_t)nA1,fp);

  a	=0.;
  ss	=sqrt(dgy*0.01);
  do{
    ESSetSplA(a);
    splRA(&s,&dgya,ESqgY,ESqgY2a);
    a		+=(ss-s)/dgya;
  }while(fabs(ss-s) > 1e-8);
  A[0]	=a;
  
  printf("Writing equidistant metric tensor\n");
  
  ji	=0;
  for(i=0; i < nA1; i++){
    a	=A[i];
    ESSetSplA(a);
    splRA(&dgya,&dD0,ESdgY,ESdgY2a);
    rf	=-1./(dgya*a*rBt);

    splRA(Lc,dLc,ESLc,ESLc2);
    s	=-1./(ESaR0[0]*dgya*rBt);
    D0	=Lc[0]*s;
    dD0	=(dLc[0]-Lc[0]*dD0/dgya)*s*rf;

    L0		=2./Lc[0];
    s		=rf*L0;
    dLc[0]	*=rf/Lc[0];
    ki	=0;
    for(k=1; k < ES2Mp1; k++){
      ki	+=ESNa1;
      splRA(Lc+k,dLc+k,ESLc+ki,ESLc2+ki);
      Lc[k]	*=L0;
      dLc[k]	=dLc[k]*s-Lc[k]*dLc[0];
      splRA(Ls+k,dLs+k,ESLs+ki,ESLs2+ki);
      Ls[k]	*=L0;
      dLs[k]	=dLs[k]*s-Ls[k]*dLc[0];
    }

    splRA(G22c,dG22c,g22c,g22c2);
    L0		=2./G22c[0];
    s		=rf*L0;
    dG22c[0]	*=rf/G22c[0];
    ki	=0;
    for(k=1; k < ESFp1; k++){
      ki	+=ESNa1;
      splRA(G22c+k,dG22c+k,g22c+ki,g22c2+ki);
      G22c[k]	*=L0;
      dG22c[k]	=dG22c[k]*s-G22c[k]*dG22c[0];
      splRA(G22s+k,dG22s+k,g22s+ki,g22s2+ki);
      G22s[k]	*=L0;
      dG22s[k]	=dG22s[k]*s-G22s[k]*dG22c[0];
    }

    splRA(&b,&db,ESsb,ESsb2a);
    db	*=rf;
    splRA(rs,drs,rsT,rsT2a);
    drs[0]	*=rf;
    splRA(rc,drc,rcT,rcT2a);
    rc[0]	+=ESaR0[0];
    drc[0]	*=rf;
    ki	=0;
    for(k=1; k < ESFp1; k++){
      ki	+=ESNa1;
      splRA(rc+k,drc+k,rcT+ki,rcT2a+ki);
      rc[k]	*=2.;
      drc[k]	*=2.*rf;
      rct[k]	=-k*rc[k];
      d2ratc[k]	=-k*drc[k];
      d2rttc[k]	=k*rct[k];
      splRA(rs+k,drs+k,rsT+ki,rsT2a+ki);
      rs[k]	*=2.;
      drs[k]	*=2.*rf;
      rst[k]	=k*rs[k];
      d2rats[k]	=k*drs[k];
      d2rtts[k]	=-k*rst[k];
    }

    for(j=0; j < ESNp; j++){
      s		=0.;
      kj	=0;
      for(k=1; k < ESFp1; k++){
	kj	+=j;
	if(kj >= ESNp){
	  kj	-=ESNp;
	}
	s	+=(G22c[k]*sn1[kj]+G22s[k]*(1.-cs1[kj]))/k;
      }
      gQ[j]	=s;
    }
    gQ[j]	=gQ[0];
    splP(gQ,gQ2);
    t	=c2gp;
    for(j=0; j < nP; j++){
      gq	=c2gp-dgt*j;
      do{
	ESSetSplP(t);
	splRP(&s,&ds,gQ,gQ2);
	s	+=t-gq;
	t	-=s/(1.+ds);
      }while(fabs(s) > 1e-8);
      s		=t;
      cs	=cos(s);
      sn	=sin(s);
      ss	=rc[0]+rc[1]*cs+rs[1]*sn;
      dra	=drc[0]+drc[1]*cs+drs[1]*sn;
      drt	=rct[1]*sn+rst[1]*cs;

      gqa	=dG22c[1]*sn+dG22s[1]*(1.-cs);
      gqt	=1.+G22c[1]*cs+G22s[1]*sn;
      gqat	=dG22c[1]*cs+dG22s[1]*sn;
      gqtt	=-G22c[1]*sn+G22s[1]*cs;

      gh	=(Lc[1]-G22c[1])*sn+(Ls[1]-G22s[1])*(1.-cs);
      gha	=dLc[1]*sn+dLs[1]*(1.-cs);
      ght	=1.+Lc[1]*cs+Ls[1]*sn;
      ghtt	=-Lc[1]*sn+Ls[1]*cs;
      ghat	=dLc[1]*cs+dLs[1]*sn;

      z[ji]	=rs[0]+b*sn;
      dza	=drs[0]+db*sn;
      dzt	=b*cs;
      d2rat	=d2ratc[1]*sn+d2rats[1]*cs;
      d2rtt	=d2rttc[1]*cs+d2rtts[1]*sn;
      d2zat	=db*cs;
      d2ztt	=-b*sn;
      for(k=2; k < ESFp1; k++){
	s	=k*t;
	cs	=cos(s);
	sn	=sin(s);
	ss	+=rc[k]*cs+rs[k]*sn;
	dra	+=drc[k]*cs+drs[k]*sn;
	drt	+=rct[k]*sn+rst[k]*cs;
	d2rat	+=d2ratc[k]*sn+d2rats[k]*cs;
	d2rtt	+=d2rttc[k]*cs+d2rtts[k]*sn;
	gqa	+=(dG22c[k]*sn+dG22s[k]*(1.-cs))/k;
	gqt	+=G22c[k]*cs+G22s[k]*sn;
	gqat	+=dG22c[k]*cs+dG22s[k]*sn;
	gqtt	+=k*(-G22c[k]*sn+G22s[k]*cs);
	if(k <  ES2Mp1){
	  gh	+=((Lc[k]-G22c[k])*sn+(Ls[k]-G22s[k])*(1.-cs))/k;
	  gha	+=(dLc[k]*sn+dLs[k]*(1.-cs))/k;
	  ght	+=Lc[k]*cs+Ls[k]*sn;
	  ghtt	+=k*(-Lc[k]*sn+Ls[k]*cs);
	  ghat	+=dLc[k]*cs+dLs[k]*sn;
	}
	else{
	  gh	-=(G22c[k]*sn+G22s[k]*(1.-cs))/k;
	}
      }
      gd[ji]	=-gh;
      r[ji]	=ss;
      D		=dra*dzt-drt*dza;
      gh	=1./D;
      dD	=(d2rat*dzt+dra*d2ztt-d2rtt*dza-drt*d2zat)*gh;
#ifdef H
      gh	*=gh;
#endif
      gh	*=1./(ss*D0*ght);

      g22[ji]	=(drt*drt+dzt*dzt)*gh;
      dg12	=(d2rat*drt+dra*d2rtt+d2zat*dzt+dza*d2ztt)*gh;
      dg22	=2.*(d2rtt*drt+d2ztt*dzt)*gh;

      gh	*=(dra*drt+dza*dzt);

      g12[ji]	=gh*gqt-g22[ji]*gqa;

      s		=1./gqt;
      dg12t[ji]	=(2.*g12[ji]*dD-dg12*gqt-gh*gqtt+dg22*gqa+g22[ji]*gqat)*s;
      dg22t[ji]	=(2.*g22[ji]*dD-dg22)*s;

      rt[ji]	=-drt*s;
      zt[ji]	=-dzt*s;

      p2r[ji]	=ss*ss;
      dp2rt[ji]	=2.*r[ji]*rt[ji];
      gqa	*=s;
      dra	-=drt*gqa;
      dza	-=dzt*gqa;
      ra[ji]	=dra;
      za[ji]	=dza;

      dgda[ji]	=-sq[i]*(gha-ght*gqa)+dsqgy[i]*gd[ji];

      D		*=s;
#ifdef H
      g11[ji]	=(dra*dra+dza*dza)/(D*D);
#endif

      dp2ra[ji]	=2.*ss*dra;

      qg[ji]	=p2r[ji]*D0*ght*s;
      g11[ji]	=(dra*dra+dza*dza)*ss/(D*qg[ji]);

      dqga[ji]	=(dp2ra[ji]*D0+p2r[ji]*dD0)*ght*s
	+p2r[ji]*D0*(ghat*gqt-ght*gqat)*s*s
	  -p2r[ji]*D0*(ghtt*gqt-ght*gqtt)*s*s*gqa;
      ji++;
    }
  }
  free(gQ);
  {
    double *p,*P,d[3]={0.,0.,0.};

    ji	=nP*nA;
    /* $r_b$ into Esc2PstGm*/
    P	=r+ji;
    fwrite((void*)P,(size_t)8,(size_t)nP,Fp);
    fwrite((void*)P,(size_t)8,(size_t)2,Fp);
    /* $z_b$ into Esc2PstGm*/
    P	=z+ji;
    fwrite((void*)P,(size_t)8,(size_t)nP,Fp);
    fwrite((void*)P,(size_t)8,(size_t)2,Fp);
    /* $\bgY_{PEST}$ into Esc2PstGm*/
    s	=ESgY[ESNa]*c2gp*rBt;
    ds	=-s*dgy;
    for(i=0; i < nA1; i++){
      A[i]	=s+ds*i;
    }
    fwrite((void*)A,(size_t)8,(size_t)nA1,Fp);
    /* $r$ and $|\na\bgY|^2$*/
    /* $z$ and $r^2$*/
    /* $r'_{\gq_{PEST}}$ and $|\na\gq_{PEST}|^2$*/
    /* $z'_{\gq_{PEST}}$ and $(\na\bgY_{PEST}\cdot\na\gq_{PEST})$ */
    /* $r'_{\bgY_{PEST}}$ and $\R{\pa(\na\bgY\cdot\na\gq)}{\pa\gq}$*/
    /* $z'_{\bgY_{PEST}}$ and $\R{\pa r^2}{\pa a}$ */
    for(k=0; k < 6; k++){
      p	=w1[k];
      P	=w2[k];
      for(i=0; i < nA1; i++){
	fwrite((void*)P,(size_t)8,(size_t)nP,Fp);
	fwrite((void*)P,(size_t)8,(size_t)2,Fp);
	fwrite((void*)d,(size_t)8,(size_t)3,Fp);
	P	+=nP;
	fwrite((void*)p,(size_t)8,(size_t)nP,fp);
	fwrite((void*)p,(size_t)8,(size_t)2,fp);
	fwrite((void*)d,(size_t)8,(size_t)3,fp);
	p	+=nP;
      }
      if(k == 0){
	for(j=0; j < nP5; j++){
	  r[j]	=0.;
	}
      }
      fwrite((void*)r,(size_t)8,(size_t)nP5,Fp);
      fwrite((void*)r,(size_t)8,(size_t)nP5,fp);
    }

    /* $\R{\pa|\na\bgY|^2}{\pa\gq}$ */
    /* $\R{\pa r^2}{\pa\gq}$ */
    /* $\q{g_{PEST}}$ */
    /* $\R{\pa\q{g_{PEST}}}{\pa a}$ */
    /* $\gd_{PEST}$ */
    /* $\R{\pa\gd_{PEST}}{\pa a}$ */
    for(k=0; k < 6; k++){
      P	=w3[k];
      for(i=0; i < nA1; i++){
	fwrite((void*)P,(size_t)8,(size_t)nP,Fp);
	fwrite((void*)P,(size_t)8,(size_t)2,Fp);
	fwrite((void*)d,(size_t)8,(size_t)3,Fp);
	P	+=nP;
      }
      fwrite((void*)r,(size_t)8,(size_t)nP5,Fp);
    }
    for(k=0; k < 6; k++){
      free(w3[k]);
      free(w2[k]);
      free(w1[k]);
    }
  }
  printf("ES4PstGm%4.2f (fort.31) has been written\n",ttime);
  fclose(Fp);
  printf("ES4PstPr%4.2f (fort.32) has been written\n",ttime);
  fclose(fp);
  return(0);
}

/* Mapper to Hamada coordinates */
int ES4Pst2(int nA,double ttime)
{
  int nA1=NAP+1,nP=NPP,nP1=NPP+1,nP5=NPP+5;
  FILE *Fp,*fp;
  int i,j,k,ki,kj,ji;
  double dgy,dgt,dgya,rf,rg,a,ss,s,ds,rBt,p2rBt;
  double A[NAP+1];
  double *sp,*Ps,sq[NAP+1],dsqgy[NAP+1],*g,*dggy,*fb,*dfbgy;
  double *r,*z,*rt,*zt,*ra,*za;
  double *g22,*p2r,*g11,*g12,*dg12t,*dp2ra,*dg22t,*dp2rt,*qg,*dqga,*gd,*dgda;

  double *rc,*rs,*drc,*drs,*rct,*rst,dra,drt,dza,dzt,cs,sn,b,db;
  double *gQ,*gQ2,gq,gqa,gqt,gqat,gqtt,t;
  double *d2rttc,*d2rtts,*d2ratc,*d2rats,d2rtt,d2ztt,d2rat,d2zat;
  double *Lc,*Ls,*dLc,*dLs,D0,dD0,D,dD;
  double dg22,dg12,gh,ght,gha,ghat,ghtt,L0,G0;
  double *rDc,*rDc2,*rDs,*rDs2,*Jc,*dJc,*Js,*dJs;

  double *w1[6],*w2[6],*w3[6];

  nA1	=nA+1;
  i	=nP*nA1;
  for(k=0; k < 6; k++){
    w1[k]	=NULL;
    w2[k]	=NULL;
    w3[k]	=NULL;
    w1[k]	=(double*)malloc(i*sizeof(double));
    w2[k]	=(double*)malloc(i*sizeof(double));
    w3[k]	=(double*)malloc(i*sizeof(double));
    if(w1[k] == NULL || w2[k] == NULL || w3[k] == NULL){
      printf("No memory for w[%d] in ES4Pst1()%c\n",k,7);
      j=k;
      while(j >= 0){
	free(w3[j]);
	free(w2[j]);
	free(w1[j]);
	j--;
      }
      return(0);
    }
  }

  r	=w1[0];
  z	=w1[1];
  rt	=w1[2];
  zt	=w1[3];
  ra	=w1[4];
  za	=w1[5];

  g22	=w2[0];
  p2r	=w2[1];
  g11	=w2[2];
  g12	=w2[3];
  dg12t	=w2[4];
  dp2ra	=w2[5];
  dg22t	=w3[0];
  dp2rt	=w3[1];
  qg	=w3[2];
  dqga	=w3[3];
  gd	=w3[4];
  dgda	=w3[5];
  
  gQ	=(double*)malloc((4*ESNp1+18*ESFp1)*sizeof(double));
  gQ2	=gQ	+ESNp1;
  rc	=gQ2	+ESNp1;
  rs	=rc	+ESFp1;
  drc	=rs	+ESFp1;
  drs	=drc	+ESFp1;
  rct	=drs	+ESFp1;
  rst	=rct	+ESFp1;
  d2ratc	=rst	+ESFp1;
  d2rats	=d2ratc	+ESFp1;
  d2rttc	=d2rats	+ESFp1;
  d2rtts	=d2rttc	+ESFp1;
  Lc		=d2rtts	+ESFp1;
  Ls		=Lc	+ESFp1;
  dLc		=Ls	+ESFp1;
  dLs		=dLc	+ESFp1;
  Jc		=dLs	+ESFp1;
  Js		=Jc	+ESFp1;
  dJc		=Js	+ESFp1;
  dJs		=dJc	+ESFp1;

  if(gQ == NULL){
    printf("No memory for gQ in ES4Pst1()\n");
    return(0);
  }
  sp	=r;
  Ps	=z;
  g	=ra;
  dggy	=za;
  fb	=g22;
  dfbgy	=p2r;

  i	=ESNa1*ESFp1;
  rDc	=(double*)malloc(4*i*sizeof(double));
  rDc2	=rDc	+i;
  rDs	=rDc2	+i;
  rDs2	=rDs	+i;
  if(rDc == NULL){
    printf("No memory for gQ in ES4Pst1()\n");
    return(0);
  }

  i	=ESNa1*ES2Mp1;
  for(ki=0; ki < i; ki++){
    rDc[ki]	=ESLc[ki]	+ESVc[ki];
    rDc2[ki]	=ESLc2[ki]	+ESVc2[ki];
    rDs[ki]	=ESLs[ki]	+ESVs[ki];
    rDs2[ki]	=ESLs2[ki]	+ESVs2[ki];
  }

  rg	=1./ESRBt;
  rBt	=ESRext*rg;
  p2rBt	=rBt*rBt;
  rf	=-ESgY[ESNa]*rBt;
  dgt	=c2gp/nP;
  dgy	=1./nA;
  
#ifdef H
  sprintf(Ttl.Title,"ES4PstGm%4.2f",ttime); /* fort.31 */
  sprintf(Ttl.Title,"ES4PstGm",ttime);
  Fp	=fopen(Ttl.Title,"w");

  sprintf(Ttl.Title,"ES4PstPr%4.2f",ttime); /* fort.32 */
  sprintf(Ttl.Title,"ES4Pst",ttime);
  fp	=fopen(Ttl.Title,"w");
#endif
  sprintf(Ttl.Title,"/scratchu/zakh/Pst/fort.31",ttime); /* fort.31 */
  Fp	=fopen(Ttl.Title,"w");

  sprintf(Ttl.Title,"/scratchu/zakh/Pst/fort.32",ttime); /* fort.32 */
  fp	=fopen(Ttl.Title,"w");

  printf("Writing plasma profiles\n");
  strcpy(Ttl.Title,"ESC has written this garbage");
  i	=strlen(Ttl.Title);
  while(i < 159){
    Ttl.Title[i]	=' ';
    i++;
  }
  Ttl.Title[i]	='\0';
  g[0]	=0.;
  fwrite((void*)g,(size_t)8,(size_t)1,Fp);
  fwrite((void*)g,(size_t)8,(size_t)1,fp);
  i	=0;
  while(i < 8){
    Ttl.date[i]	='\0';
    i++;
  }
  Ttl.nxx[0]	=nP1; /* number of poloidal intervals (+1 in symmetric case)*/
  Ttl.nxx[1]	=nA1;			/* number of radial intervals +1*/ 
  Ttl.nxx[2]	=401;			/* Number of magnetic surfaces */
  Ttl.nxx[3]	=128;			/* Number of poloidal intervals */ 
  Ttl.nxx[4]	=0;			/* Junk */ 
  Ttl.axx[0]	=rdPV[3]-rdPV[2];
  Ttl.axx[1]	=zdPV[0]-zdPV[1];
  Ttl.axx[2]	=zdPV[0];
  Ttl.axx[3]	=ESaR0[0];
  Ttl.axx[4]	=ESRext;
  Ttl.axx[5]	=ESsp[0]*p2rBt;
  Ttl.axx[6]	=ESRBt*rBt/ESRext;
  Ttl.axx[7]	=c2gp*ESgY[ESNa]*rBt;
  Ttl.axx[8]	=0.;
  Ttl.axx[9]	=c2gp*ESgY[ESNa]*rBt;
  Ttl.axx[10]	=0.;
  Ttl.axx[11]	=0.;
  Ttl.axx[12]	=1.;	/* constant C in rD=Cr^m\na\bgY^n */

  Ttl.nxy[0]	=0;	/* exponent n in rD=Cr^m\na\bgY^n */
  Ttl.nxy[1]	=2;	/* exponent m in rD=Cr^m\na\bgY^n,
			   2 - straight field lines */
  Ttl.nxy[2]	=0;	/* Junk */ 
  Ttl.nxy[3]	=0;	/* Junk */ 
  Ttl.nxy[4]	=0;	/* Junk */
  Ttl.nxy[5]	=0;	/* Junk */
  Ttl.nxy[6]	=0;	/* Junk */ 
  Ttl.nxy[7]	=0;	/* Junk */
  Ttl.nxy[8]	=NSIZE;	/* Junk */
  Ttl.nxy[9]	=NSIZE;	/* Junk */

  Ttl.axy[0]	=dgt;
  Ttl.axy[1]	=dgy;
  Ttl.axy[2]	=cgp;
  Ttl.axy[3]	=ESRext;
  Ttl.axy[4]	=ESRBt/ESRext;
  for(i=5; i < 10; i++){
    Ttl.axy[i]	=0.;
  }
  fwrite((void*)&Ttl,(size_t)8,(size_t)49,Fp);
  fwrite((void*)&Ttl,(size_t)8,(size_t)49,fp);

  a	=0.;
  i	=0;
  A[i]	=a;
  sp[i]	=ESsp[0]*p2rBt;
  Ps[i]	=-ESPs[0]*rBt;
  sq[i]	=1./ESgm[0];
  if(ESEqSolvInCr != 6 && ESEqSolvInCr != 7){
    dsqgy[i]	=ESgm2a[0]*sq[i]*sq[i]/(ESdgY[0]*rBt);
  }
  else{
    ESSetSplDCr(a);
    splRDCr2(&s,NULL,dsqgy,7);
    dsqgy[i]	*=sq[i]*sq[i]/(ESdgY[0]*rBt);
  }
  g[i]	=ESaF[0]*rg;
  s	=ESaT[0]*rBt;
  dggy[i]=-s/(ESRext*ESRext*g[i]);
  fb[i]	=-ESaR0[0]*ESdgY[0]*rBt/ESLc[0];
  dfbgy[i]	=ESaR0[0]*(ESdgY2a[0]-ESdgY[0]*ESLc2[0]/ESLc[0])/
    (ESdgY[0]*ESLc[0]);
  for(i=1; i < nA1; i++){
    ss	=sqrt(dgy*i);
    do{
      ESSetSplA(a);
      splRA(&s,&dgya,ESqgY,ESqgY2a);
      a		+=(ss-s)/dgya;
    }while(fabs(ss-s) > 1e-8);
    A[i]	=a;
    ESSetSplA(a);
    if(ESEqSolvInPr != 2){
      splRA(sp+i,NULL,ESsp,ESsp2a);
    }
    else{
      ESSetSplDPr(a);
      splRDPr(sp+i,&ds,2);
    }
    sp[i]	*=p2rBt;
    switch(ESEqSolvInPr){
    case 0:
      ESSetSplDPr(a);
      splRDPr(Ps+i,&ds,0);
      Ps[i]	/=ESaR0[0];
      break;
    case 1:
      ESSetSplDPr(a);
      splRDPr(Ps+i,&ds,1);
      break;
    default:
      splRA(Ps+i,NULL,ESPs,ESPs2a);
      break;
    }
    Ps[i]	*=-rBt;
    splRA(&dgya,&ds,ESdgY,ESdgY2a);
    splRA(&s,&ss,ESLc,ESLc2);
    fb[i]	=-ESaR0[0]*dgya/s;
    dgya	*=a;
    dfbgy[i]	=(ESaR0[0]*ds+fb[i]*ss)/(dgya*s);
    fb[i]	*=rBt;
    if(ESEqSolvInCr != 6 && ESEqSolvInCr != 7){
      splRA(&s,&ds,ESgm,ESgm2a);
    }
    else{
      ESSetSplDCr(a);
      splRDCr(&s,&ds,7);
    }
    sq[i]	=1./s;
    dsqgy[i]	=ds/(dgya*rBt*s*s);
    splRA(g+i,&ds,ESaF,ESaF2a);
    g[i]	*=rg;
    splRA(&s,NULL,ESaT,ESaT2a);
    s		*=rBt;
    dggy[i]	=-s/(ESRext*ESRext*g[i]);
  }
  fwrite((void*)sp,(size_t)8,(size_t)nA1,fp);
  fwrite((void*)Ps,(size_t)8,(size_t)nA1,fp);
  fwrite((void*)sq,(size_t)8,(size_t)nA1,fp);
  fwrite((void*)dsqgy,(size_t)8,(size_t)nA1,fp);
  fwrite((void*)g,(size_t)8,(size_t)nA1,fp);
  fwrite((void*)dggy,(size_t)8,(size_t)nA1,fp);
  fwrite((void*)fb,(size_t)8,(size_t)nA1,fp);
  fwrite((void*)dfbgy,(size_t)8,(size_t)nA1,fp);

  a	=0.;
  ss	=sqrt(dgy*0.01);
  do{
    ESSetSplA(a);
    splRA(&s,&dgya,ESqgY,ESqgY2a);
    a		+=(ss-s)/dgya;
  }while(fabs(ss-s) > 1e-8);
  A[0]	=a;
  
  printf("Writing Hamada metric tensor\n");
  
  ji	=0;
  for(i=0; i < nA1; i++){
    a	=A[i];
    ESSetSplA(a);
    splRA(&dgya,&dD0,ESdgY,ESdgY2a);
    rf	=-1./(dgya*a*rBt);
    splRA(Lc,dLc,ESLc,ESLc2);
    L0		=2./Lc[0];
    s		=rf*L0;
    dLc[0]	*=rf/Lc[0];
    ki	=0;
    for(k=1; k < ES2Mp1; k++){
      ki	+=ESNa1;
      splRA(Lc+k,dLc+k,ESLc+ki,ESLc2+ki);
      Lc[k]	*=L0;
      dLc[k]	=dLc[k]*s-Lc[k]*dLc[0];
      splRA(Ls+k,dLs+k,ESLs+ki,ESLs2+ki);
      Ls[k]	*=L0;
      dLs[k]	=dLs[k]*s-Ls[k]*dLc[0];
    }

    splRA(Jc,dJc,rDc,rDc2);
    s	=-ESaR0[0]/(dgya*rBt);
    D0	=Jc[0]*s;
    dD0	=(dJc[0]-Jc[0]*dD0/dgya)*s*rf;

    L0		=2./Jc[0];
    s		=rf*L0;
    dJc[0]	*=rf/Jc[0];
    ki	=0;
    for(k=1; k < ES2Mp1; k++){
      ki	+=ESNa1;
      splRA(Jc+k,dJc+k,rDc+ki,rDc2+ki);
      Jc[k]	*=L0;
      dJc[k]	=dJc[k]*s-Jc[k]*dJc[0];
      splRA(Js+k,dJs+k,rDs+ki,rDs2+ki);
      Js[k]	*=L0;
      dJs[k]	=dJs[k]*s-Js[k]*dJc[0];
    }

    splRA(&b,&db,ESsb,ESsb2a);
    db	*=rf;
    splRA(rs,drs,rsT,rsT2a);
    drs[0]	*=rf;
    splRA(rc,drc,rcT,rcT2a);
    rc[0]	+=ESaR0[0];
    drc[0]	*=rf;
    ki	=0;
    for(k=1; k < ESFp1; k++){
      ki	+=ESNa1;
      splRA(rc+k,drc+k,rcT+ki,rcT2a+ki);
      rc[k]	*=2.;
      drc[k]	*=2.*rf;
      rct[k]	=-k*rc[k];
      d2ratc[k]	=-k*drc[k];
      d2rttc[k]	=k*rct[k];
      splRA(rs+k,drs+k,rsT+ki,rsT2a+ki);
      rs[k]	*=2.;
      drs[k]	*=2.*rf;
      rst[k]	=k*rs[k];
      d2rats[k]	=k*drs[k];
      d2rtts[k]	=-k*rst[k];
    }

    for(j=0; j < ESNp; j++){
      s		=0.;
      kj	=0;
      for(k=1; k < ES2Mp1; k++){
	kj	+=j;
	if(kj >= ESNp){
	  kj	-=ESNp;
	}
	s	+=(Jc[k]*sn1[kj]+Js[k]*(1.-cs1[kj]))/k;
      }
      gQ[j]	=s;
    }
    gQ[j]	=gQ[0];
    splP(gQ,gQ2);
    t	=c2gp;
    for(j=0; j < nP; j++){
      gq	=c2gp-dgt*j;
      do{
	ESSetSplP(t);
	splRP(&s,&ds,gQ,gQ2);
	s	+=t-gq;
	t	-=s/(1.+ds);
      }while(fabs(s) > 1e-8);
      s		=t;
      cs	=cos(s);
      sn	=sin(s);
      ss	=rc[0]+rc[1]*cs+rs[1]*sn;
      dra	=drc[0]+drc[1]*cs+drs[1]*sn;
      drt	=rct[1]*sn+rst[1]*cs;

      gqa	=dJc[1]*sn+dJs[1]*(1.-cs);
      gqt	=1.+Jc[1]*cs+Js[1]*sn;
      gqat	=dJc[1]*cs+dJs[1]*sn;
      gqtt	=-Jc[1]*sn+Js[1]*cs;

      gh	=(Lc[1]-Jc[1])*sn+(Ls[1]-Js[1])*(1.-cs);
      gha	=dLc[1]*sn+dLs[1]*(1.-cs);
      ght	=1.+Lc[1]*cs+Ls[1]*sn;
      ghtt	=-Lc[1]*sn+Ls[1]*cs;
      ghat	=dLc[1]*cs+dLs[1]*sn;

      z[ji]	=rs[0]+b*sn;
      dza	=drs[0]+db*sn;
      dzt	=b*cs;
      d2rat	=d2ratc[1]*sn+d2rats[1]*cs;
      d2rtt	=d2rttc[1]*cs+d2rtts[1]*sn;
      d2zat	=db*cs;
      d2ztt	=-b*sn;
      for(k=2; k < ESFp1; k++){
	s	=k*t;
	cs	=cos(s);
	sn	=sin(s);
	ss	+=rc[k]*cs+rs[k]*sn;
	dra	+=drc[k]*cs+drs[k]*sn;
	drt	+=rct[k]*sn+rst[k]*cs;
	d2rat	+=d2ratc[k]*sn+d2rats[k]*cs;
	d2rtt	+=d2rttc[k]*cs+d2rtts[k]*sn;
	if(k <  ES2Mp1){
	  gqa	+=(dJc[k]*sn+dJs[k]*(1.-cs))/k;
	  gqt	+=Jc[k]*cs+Js[k]*sn;
	  gqat	+=dJc[k]*cs+dJs[k]*sn;
	  gqtt	+=k*(-Jc[k]*sn+Js[k]*cs);

	  gh	+=((Lc[k]-Jc[k])*sn+(Ls[k]-Js[k])*(1.-cs))/k;
	  gha	+=(dLc[k]*sn+dLs[k]*(1.-cs))/k;
	  ght	+=Lc[k]*cs+Ls[k]*sn;
	  ghtt	+=k*(-Lc[k]*sn+Ls[k]*cs);
	  ghat	+=dLc[k]*cs+dLs[k]*sn;
	}
      }
      gd[ji]	=-gh;
      r[ji]	=ss;
      D		=dra*dzt-drt*dza;
      gh	=1./D;
      dD	=(d2rat*dzt+dra*d2ztt-d2rtt*dza-drt*d2zat)*gh;
#ifdef H
      gh	*=gh;
#endif
      gh	*=ss/(D0*gqt);

      g22[ji]	=(drt*drt+dzt*dzt)*gh;
      dg12	=(d2rat*drt+dra*d2rtt+d2zat*dzt+dza*d2ztt)*gh;
      dg22	=2.*(d2rtt*drt+d2ztt*dzt)*gh;

      gh	*=(dra*drt+dza*dzt);

      g12[ji]	=gh*gqt-g22[ji]*gqa;

      s		=1./gqt;
      dg12t[ji]	=(2.*g12[ji]*dD-dg12*gqt-gh*gqtt+dg22*gqa+g22[ji]*gqat)*s;
      dg22t[ji]	=(2.*g22[ji]*dD-dg22)*s;

      rt[ji]	=-drt*s;
      zt[ji]	=-dzt*s;

      p2r[ji]	=ss*ss;
      dp2rt[ji]	=2.*r[ji]*rt[ji];
      gqa	*=s;
      dra	-=drt*gqa;
      dza	-=dzt*gqa;
      ra[ji]	=dra;
      za[ji]	=dza;

      dgda[ji]	=-sq[i]*(gha-ght*gqa)+dsqgy[i]*gd[ji];

      D		*=s;
#ifdef H
      g11[ji]	=(dra*dra+dza*dza)/(D*D);
#endif
      g11[ji]	=(dra*dra+dza*dza)*ss/(D*D0);
      dp2ra[ji]	=2.*ss*dra;

      qg[ji]	=D0;
      dqga[ji]	=dD0;
      ji++;
    }
  }
  free(gQ);
  {
    double *p,*P,d[3]={0.,0.,0.};

    ji	=nP*nA;
    /* $r_b$ into Esc2PstGm*/
    P	=r+ji;
    fwrite((void*)P,(size_t)8,(size_t)nP,Fp);
    fwrite((void*)P,(size_t)8,(size_t)2,Fp);
    /* $z_b$ into Esc2PstGm*/
    P	=z+ji;
    fwrite((void*)P,(size_t)8,(size_t)nP,Fp);
    fwrite((void*)P,(size_t)8,(size_t)2,Fp);
    /* $\bgY_{PEST}$ into Esc2PstGm*/
    s	=ESgY[ESNa]*c2gp*rBt;
    ds	=-s*dgy;
    for(i=0; i < nA1; i++){
      A[i]	=s+ds*i;
    }
    fwrite((void*)A,(size_t)8,(size_t)nA1,Fp);
    /* $r$ and $|\na\bgY|^2$*/
    /* $z$ and $r^2$*/
    /* $r'_{\gq_{PEST}}$ and $|\na\gq_{PEST}|^2$*/
    /* $z'_{\gq_{PEST}}$ and $(\na\bgY_{PEST}\cdot\na\gq_{PEST})$ */
    /* $r'_{\bgY_{PEST}}$ and $\R{\pa(\na\bgY\cdot\na\gq)}{\pa\gq}$*/
    /* $z'_{\bgY_{PEST}}$ and $\R{\pa r^2}{\pa a}$ */
    for(k=0; k < 6; k++){
      p	=w1[k];
      P	=w2[k];
      for(i=0; i < nA1; i++){
	fwrite((void*)P,(size_t)8,(size_t)nP,Fp);
	fwrite((void*)P,(size_t)8,(size_t)2,Fp);
	fwrite((void*)d,(size_t)8,(size_t)3,Fp);
	P	+=nP;
	fwrite((void*)p,(size_t)8,(size_t)nP,fp);
	fwrite((void*)p,(size_t)8,(size_t)2,fp);
	fwrite((void*)d,(size_t)8,(size_t)3,fp);
	p	+=nP;
      }
      if(k == 0){
	for(j=0; j < nP5; j++){
	  r[j]	=0.;
	}
      }
      fwrite((void*)r,(size_t)8,(size_t)nP5,Fp);
      fwrite((void*)r,(size_t)8,(size_t)nP5,fp);
    }

    /* $\R{\pa|\na\bgY|^2}{\pa\gq}$ */
    /* $\R{\pa r^2}{\pa\gq}$ */
    /* $\q{g_{PEST}}$ */
    /* $\R{\pa\q{g_{PEST}}}{\pa a}$ */
    /* $\gd_{PEST}$ */
    /* $\R{\pa\gd_{PEST}}{\pa a}$ */
    for(k=0; k < 6; k++){
      P	=w3[k];
      for(i=0; i < nA1; i++){
	fwrite((void*)P,(size_t)8,(size_t)nP,Fp);
	fwrite((void*)P,(size_t)8,(size_t)2,Fp);
	fwrite((void*)d,(size_t)8,(size_t)3,Fp);
	P	+=nP;
      }
      fwrite((void*)r,(size_t)8,(size_t)nP5,Fp);
    }
    for(k=0; k < 6; k++){
      free(w3[k]);
      free(w2[k]);
      free(w1[k]);
    }
  }
  printf("ES4PstGm%4.2f (fort.31) has been written\n",ttime);
  fclose(Fp);
  printf("ES4PstPr%4.2f (fort.32) has been written\n",ttime);
  fclose(fp);
  return(0);
}

int ES2eqdsk(double ttime)
{
  int nA=128,nA1=129,nA5=NSIZE,nP=256,nP1=257,nP4=260,nP5=NSIZE;
  FILE *fp;
  int i,j,ia,j0=2;
  long int nxy[10];
  char Title[160];
  double dgy,dgt,dgya,rf,rg,a,ss,s,ds,rBt,p2rBt;
  double A[2*NSIZE];
  double sp[NSIZE],Ps[NSIZE],sq[NSIZE],dsqgy[NSIZE],gy[NSIZE];
  double g[NSIZE],dggy[NSIZE],fb[NSIZE],dfbgy[NSIZE];

  double aT[NSIZE];

  rg	=1./ESRBt;
  rBt	=ESRext*rg;
  rf	=-ESgY[ESNa]*rBt;
  p2rBt	=rBt*rBt;

  sprintf(Title,"Esc2dsk%4.2f",ttime);
  sprintf(Title,"../Pst/fort.17",ttime);
  printf("Writing plasma profiles\n");

  fp	=fopen(Title,"w");
  strcpy(Title,"ESC has written this garbage");
  i	=strlen(Title);
  while(i < 159){
    Title[i]	=' ';
    i++;
  }
  Title[i]	='\0';
  g[0]	=0.;
  fwrite((void*)g,(size_t)8,(size_t)1,fp);
  fwrite((void*)Title,(size_t)8,(size_t)20,fp);
  fwrite((void*)g,(size_t)8,(size_t)1,fp);
  nxy[0]  =nP;
  nxy[1]  =nA1; 
  nxy[2]  =0;
  nxy[3]  =0; 
  nxy[4]  =0; 
  fwrite((void*)nxy,(size_t)8,(size_t)5,fp);

  g[0]	=rdPV[3]-rdPV[2];
  g[1]	=zdPV[0]-zdPV[1];
  g[2]	=zdPV[0];
  g[3]	=ESaR0[0];
  g[4]	=ESRext;
  g[5]	=ESsp[0]*p2rBt;
  g[6]	=ESRBt*rBt/ESRext;
  g[7]	=c2gp*ESgY[ESNa]*rBt;
  g[8]	=0.;
  g[9]	=g[7];
  g[10]=0.;
  g[11]=0.;
  g[12]=1.;
  fwrite((void*)g,(size_t)8,(size_t)13,fp);

  nxy[0]	=2; 
  nxy[1]	=0; 
  nxy[2]	=0; 
  nxy[3]	=0; 
  nxy[4]	=2;
  nxy[5]	=0;
  nxy[6]	=1; 
  nxy[7]	=0;	/* symmetry index */
  nxy[8]	=nP5;	/* poloidal allocation size */
  nxy[9]	=nA5;	/* radial allocation size */
  fwrite((void*)nxy,(size_t)8,(size_t)10,fp);
  
  dgt	=c2gp/nP;
  dgy	=1./nA;
  g[0]	=dgt;
  g[1]	=dgy;
  g[2]	=cgp;
  g[3]	=ESRext;
  g[4]	=ESRBt/ESRext;
  printf("dt=%15.7e %15.7e %15.7e %15.7e %15.7e\n",g[0],g[1],g[2],g[3],g[4]);
  for(i=5; i < 10; i++){
    g[i]	=0.;
  }
  fwrite((void*)g,(size_t)8,(size_t)10,fp);

  a	=0.;
  i	=0;
  ia	=0;
  A[ia]	=a;
  ia++;
  gy[i]	=ESgY[ESNa]*rBt;
  Ps[i]	=-ESPs[0]*rBt;

  sq[i]	=1./ESgm[0];
  if(ESEqSolvInCr != 6 && ESEqSolvInCr != 7){
    dsqgy[i]	=ESgm2a[0]*sq[i]*sq[i]/(ESdgY[0]*rBt);
  }
  else{
    ESSetSplDCr(a);
    splRDCr2(&s,NULL,dsqgy,7);
    dsqgy[i]	*=sq[i]*sq[i]/(ESdgY[0]*rBt);
  }

  g[i]	=ESaF[0]*rg;
  splRA(&s,NULL,ESaT,ESaT2a);
  s	=ESaT[0]*rBt;
  aT[i]	=s;
  dggy[i]=-s/(ESRext*ESRext*g[i]);
  fb[i]	=-ESaR0[0]*ESdgY[0]*rBt/ESLc[0];
  dfbgy[i]	=ESaR0[0]*(ESdgY2a[0]-ESdgY[0]*ESLc2[0]/ESLc[0])/
    (ESdgY[0]*ESLc[0]);

  ss	=sqrt(dgy*(i+0.5));
  do{
    ESSetSplA(a);
    splRA(&s,&dgya,ESqgY,ESqgY2a);
    a		+=(ss-s)/dgya;
  }while(fabs(ss-s) > 1e-8);
  A[ia]	=a;
  ia++;
  ESSetSplA(a);
  splRA(g+i,&ds,ESaF,ESaF2a);
  g[i]	*=rg;
  if(ESEqSolvInPr != 2){
    splRA(sp+i,NULL,ESsp,ESsp2a);
  }
  else{
    ESSetSplDPr(a);
    splRDPr(sp+i,&ds,2);
  }
  sp[i]	*=p2rBt;
  for(i=1; i < nA1; i++){
    ss	=sqrt(dgy*i);
    do{
      ESSetSplA(a);
      splRA(&s,&dgya,ESqgY,ESqgY2a);
      a		+=(ss-s)/dgya;
    }while(fabs(ss-s) > 1e-8);
    A[ia]	=a;
    ia++;
    ESSetSplA(a);
    splRA(&dgya,&ds,ESdgY,ESdgY2a);
    splRA(&s,&ss,ESLc,ESLc2);
    fb[i]	=-ESaR0[0]*dgya/s;
    dgya	*=a;
    dfbgy[i]	=(ESaR0[0]*ds+fb[i]*ss)/(dgya*s);
    fb[i]	*=rBt;
    gy[i]	=ESgY[ESNa]*(1.-dgy*i)*rBt;
    switch(ESEqSolvInPr){
    case 0:
      ESSetSplDPr(a);
      splRDPr(Ps+i,&ds,0);
      Ps[i]	/=ESaR0[0];
      break;
    case 1:
      ESSetSplDPr(a);
      splRDPr(Ps+i,&ds,1);
      break;
    default:
      splRA(Ps+i,NULL,ESPs,ESPs2a);
      break;
    }
    Ps[i]	*=-rBt;
    if(ESEqSolvInCr != 6 && ESEqSolvInCr != 7){
      splRA(&s,&ds,ESgm,ESgm2a);
    }
    else{
      ESSetSplDCr(a);
      splRDCr(&s,&ds,7);
    }
    sq[i]	=1./s;
    dsqgy[i]	=ds*sq[i]*sq[i]/(dgya*rBt);
    splRA(g+i,&ds,ESaF,ESaF2a);
    g[i]	*=rg;
    splRA(&s,NULL,ESaT,ESaT2a);
    s		*=rBt;
    aT[i]	=s;
    dggy[i]	=-s/(ESRext*ESRext*g[i]);
    if(i < nA){
      ss	=sqrt(dgy*(i+0.5));
      do{
	ESSetSplA(a);
	splRA(&s,&dgya,ESqgY,ESqgY2a);
	a		+=(ss-s)/dgya;
      }while(fabs(ss-s) > 1e-8);
      ESSetSplA(a);
      splRA(g+i,&ds,ESaF,ESaF2a);
      g[i]	*=rg;
      if(ESEqSolvInPr != 2){
	splRA(sp+i,NULL,ESsp,ESsp2a);
      }
      else{
	ESSetSplDPr(a);
	splRDPr(sp+i,&ds,2);
      }
      sp[i]	*=p2rBt;
    }
    else{
      sp[i]	=0.;
      g[i]	=(ESaF[ESNa]+ESaF1a[ESNa]*(a-ESsa[ESNa]))*rg;
    }
    A[ia]	=a;
    ia++;
  }
  ds	=dgy*ESgY[ESNa]/ESgY1a[ESNa];
  A[ia]	=ds;
  ia++;
  sp[i]	=0.;
  Ps[i]	=-(ESPs[ESNa]+ESPs1a[ESNa]*ds)*rBt;
  Ps[i]	=0.;
  sq[i]	=1./(ESgm[ESNa]+ESgm1a[ESNa]*ds);
  sq[i]	=0.;
  dsqgy[i]	=0.;
  g[i]	=(ESaF[ESNa]+ESaF1a[ESNa]*ds)*rg;
  g[i]	=0.;
  dggy[i]=0.;
  fb[i]	=0.;
  dfbgy[i]=0.;
  gy[i]	=ESgY[ESNa]*(1.-dgy*i)*rBt;

  i++;
  while(i < nA5){
    sp[i]	=0.;
    Ps[i]	=0.;
    sq[i]	=0.;
    dsqgy[i]	=0.;
    g[i]	=0.;
    dggy[i]	=0.;
    fb[i]	=0.;
    dfbgy[i]	=0.;
    gy[i]	=0.;
    i++;
  }
  for(i=0; i < nA1+1; i++){
    printf("gy[%3d]=%13.5e%13.5e%13.5e%13.5e%13.5e%13.5e\n",i
	   ,sp[i],Ps[i],sq[i],dsqgy[i],g[i],dggy[i]);
  }

  fwrite((void*)sp,(size_t)8,(size_t)nA5,fp);
  fwrite((void*)Ps,(size_t)8,(size_t)nA5,fp);
  fwrite((void*)sq,(size_t)8,(size_t)nA5,fp);
  fwrite((void*)dsqgy,(size_t)8,(size_t)nA5,fp);
  fwrite((void*)g,(size_t)8,(size_t)nA5,fp);
  fwrite((void*)dggy,(size_t)8,(size_t)nA5,fp);
  fwrite((void*)fb,(size_t)8,(size_t)nA5,fp);
  fwrite((void*)dfbgy,(size_t)8,(size_t)nA5,fp);
  i	=0;
  g[i]	=rf;
  s	=-0.5*nA*ESgY[ESNa]*rBt;
  dggy[i]=2.*s;
  for(i=1; i < nA1; i++){
    g[i]	=rf;
    dggy[i]	=s/i;
  }
  while(i < nA5){
    g[i]	=0.;
    dggy[i]	=0.;
    i++;
  }
  fwrite((void*)g,(size_t)8,(size_t)nA5,fp);
  fwrite((void*)dggy,(size_t)8,(size_t)nA5,fp);
  fwrite((void*)gy,(size_t)8,(size_t)nA5,fp);

  {
    int k,ki,jj;
    double *r,*rc,*rs,*drc,*drs,*rct,*rst,dra,drt,cs,sn,b,db,dz,fac;

    r	=g;
    rc	=sp;
    rs	=Ps;
    drc	=fb;
    drs	=dfbgy;
    rct	=sq;
    rst	=dsqgy;

    printf("Writing geometry ->r[  0]");
    /* r */
    for(j=0; j < nP4; j++){
      r[j]	=ESaR0[0];
    }
    for(j=nP4; j < nP5; j++){
      r[j]	=0.;
    }
    fwrite((void*)r,(size_t)8,(size_t)nP5,fp);
    ia	=2;
    for(i=1; i < nA1; i++){
      printf("\b\b\b\b%3d]",i);
      a		=A[ia];
      ia	+=2;
      ESSetSplA(a);
      ki	=0;
      splRA(rc,NULL,rcT,rcT2a);
      rc[0]	+=ESaR0[0];
      for(k=1; k < ESFp1; k++){
	ki	+=ESNa1;
	splRA(rc+k,NULL,rcT+ki,rcT2a+ki);
	splRA(rs+k,NULL,rsT+ki,rsT2a+ki);
      }
      for(j=0; j < nP4; j++){
	s	=dgt*(j-j0);
	ss	=0.;
	for(k=1; k < ESFp1; k++){
	  rf	=k*s;
	  ss	+=rc[k]*cos(rf)+rs[k]*sin(rf);
	}
	r[j]	=rc[0]+2.*ss;
      }
      fwrite((void*)r,(size_t)8,(size_t)nP5,fp);
    }
    rf	=A[ia];
    rc[0]	=ESaR0[0]+rcT[ESNa]+rcT1a[ESNa]*rf;
    ki	=ESNa;
    for(k=1; k < ESFp1; k++){
      ki	+=ESNa1;
      rc[k]	=rcT[ki]+rcT1a[ki]*rf;
      rs[k]	=rsT[ki]+rsT1a[ki]*rf;
    }
    for(j=0; j < nP4; j++){
      s		=dgt*(j-j0);
      ss	=0.;
      for(k=1; k < ESFp1; k++){
	rf	=k*s;
	ss	+=rc[k]*cos(rf)+rs[k]*sin(rf);
      }
      r[j]	=rc[0]+2.*ss;
    }
    i++;
    fwrite((void*)r,(size_t)8,(size_t)nP5,fp);
    for(j=0; j < nP4; j++){
      r[j]	=0.;
    }
    while(i < nA5){
      fwrite((void*)r,(size_t)8,(size_t)nP5,fp);
      i++;
    }
    /* z */
    printf("\b\b\b\b\b\bz[%3d]",0);
    for(j=0; j < nP4; j++){
      r[j]	=ESaZ0[0];
    }
    fwrite((void*)r,(size_t)8,(size_t)nP5,fp);
    ia	=2;
    for(i=1; i < nA1; i++){
      printf("\b\b\b\b%3d]",i);
      a		=A[ia];
      ia	+=2;
      ESSetSplA(a);
      splRA(rs,NULL,rsT,rsT2a);
      rs[0]	+=ESaZ0[0];
      splRA(&b,NULL,ESsb,ESsb2a);
      for(j=0; j < nP4; j++){
	r[j]	=rs[0]+b*sin(dgt*(j-j0));
      }
      fwrite((void*)r,(size_t)8,(size_t)nP5,fp);
    }
    b	=ESsb[ESNa]+ESsb1a[ESNa]*A[ia];
    rs[0]=ESaZ0[0]+rsT[ESNa]+rsT1a[ESNa]*A[ia];
    for(j=0; j < nP4; j++){
      r[j]	=rs[0]+b*sin(dgt*(j-j0));
    }
    i++;
    fwrite((void*)r,(size_t)8,(size_t)nP5,fp);
    for(j=0; j < nP4; j++){
      r[j]	=0.;
    }
    while(i < nA5){
      fwrite((void*)r,(size_t)8,(size_t)nP5,fp);
      i++;
    }
    
    fac	=-ESgY[ESNa]*rBt;
    /* qg05 */
    printf("\b\b\b\b\b\bqg05[%3d]",0);
    s	=-ESaR0[0]*ESDPc[0]*fac/(ESdgY[0]*rBt);
    for(j=0; j < nP4; j++){
      r[j]	=s;
    }
    fwrite((void*)r,(size_t)8,(size_t)nP5,fp);
    ia	=2;
    for(i=1; i < nA1; i++){
      printf("\b\b\b\b%3d]",i);
      a		=A[ia];
      ia	+=2;
      ESSetSplA(a);
      splRA(&dgya,NULL,ESdgY,ESdgY2a);
      splRA(&b,&db,ESsb,ESsb2a);
      splRA(&rf,&dz,rsT,rsT2a);
      rf	=-fac/(dgya*a*rBt);
      splRA(rc,drc,rcT,rcT2a);
      rc[0]	+=ESaR0[0];
      drc[0]	*=rf;
      ki	=0;
      for(k=1; k < ESFp1; k++){
	ki	+=ESNa1;
	splRA(rc+k,drc+k,rcT+ki,rcT2a+ki);
	drc[k]	*=rf;
	rct[k]	=-k*rc[k]*rf;
	splRA(rs+k,drs+k,rsT+ki,rsT2a+ki);
	drs[k]	*=rf;
	rst[k]	=k*rs[k]*rf;
      }
      for(j=0; j < nP4; j++){
	s	=dgt*(j-j0-0.5);
	ss	=0.;
	dra	=0.;
	drt	=0.;
	for(k=1; k < ESFp1; k++){
	  rf	=k*s;
	  cs	=cos(rf);
	  sn	=sin(rf);
	  ss	+=rc[k]*cs+rs[k]*sn;
	  dra	+=drc[k]*cs+drs[k]*sn;
	  drt	+=rct[k]*sn+rst[k]*cs;
	}
	dra	=drc[0]+2.*dra;
	drt	*=2.;
	r[j]	=(rc[0]+2.*ss)*(dra*b*cos(s)-(dz+db*sin(s))*drt);
      }
      fwrite((void*)r,(size_t)8,(size_t)nP5,fp);
    }
    s	=A[ia];
    a	=ESsa[ESNa]+s;
    dgya=ESdgY[ESNa]+ESdgY1a[ESNa]*s;
    b	=ESsb[ESNa]+ESsb1a[ESNa]*s;
    db	=ESsb1a[ESNa]+ESsb2a[ESNa]*s;
    dz	=rsT1a[ESNa]+rsT2a[ESNa]*s;
    rf	=-fac/(dgya*a*rBt);
    rc[0]	=ESaR0[0]+rcT[ESNa]+rcT1a[ESNa]*s;
    drc[0]	=(rcT1a[ESNa]+rcT2a[ESNa]*s)*rf;
    ki	=ESNa;
    for(k=1; k < ESFp1; k++){
      ki	+=ESNa1;
      rc[k]	=rcT[ki]+rcT1a[ki]*s;
      drc[k]	=(rcT1a[ki]+rcT2a[ki]*s)*rf;
      rct[k]	=-k*rc[k]*rf;
      rs[k]	=rsT[ki]+rsT1a[ki]*s;
      drs[k]	=(rsT1a[ki]+rsT2a[ki]*s)*rf;
      rst[k]	=k*rs[k]*rf;
    }
    for(j=0; j < nP4; j++){
      s		=dgt*(j-j0-0.5);
      ss	=0.;
      dra	=0.;
      drt	=0.;
      for(k=1; k < ESFp1; k++){
	rf	=k*s;
	cs	=cos(rf);
	sn	=sin(rf);
	ss	+=rc[k]*cs+rs[k]*sn;
	dra	+=drc[k]*cs+drs[k]*sn;
	drt	+=rct[k]*sn+rst[k]*cs;
      }
      dra	=drc[0]+2.*dra;
      drt	*=2.;
      r[j]	=(rc[0]+2.*ss)*(dra*b*cos(s)-(dz+db*sin(s))*drt);
    }
    i++;
    fwrite((void*)r,(size_t)8,(size_t)nP5,fp);
    for(j=0; j < nP4; j++){
      r[j]	=0.;
    }
    while(i < nA5){
      fwrite((void*)r,(size_t)8,(size_t)nP5,fp);
      i++;
    }
    /* qg */
    printf("\b\b\b\b\b\b\b\b\bqg[%3d]",0);
    s	=-ESaR0[0]*ESDPc[0]*fac/(ESdgY[0]*rBt);
    for(j=0; j < nP4; j++){
      r[j]	=s;
    }
    fwrite((void*)r,(size_t)8,(size_t)nP5,fp);
    ia	=2;
    for(i=1; i < nA1; i++){
      printf("\b\b\b\b%3d]",i);
      a		=A[ia];
      ia	+=2;
      ESSetSplA(a);
      splRA(&dgya,NULL,ESdgY,ESdgY2a);
      splRA(&b,&db,ESsb,ESsb2a);
      splRA(&rf,&dz,rsT,rsT2a);

      rf	=-fac/(dgya*a*rBt);
      splRA(rc,drc,rcT,rcT2a);
      rc[0]	+=ESaR0[0];
      drc[0]	*=rf;
      ki	=0;
      for(k=1; k < ESFp1; k++){
	ki	+=ESNa1;
	splRA(rc+k,drc+k,rcT+ki,rcT2a+ki);
	drc[k]	*=rf;
	rct[k]	=-k*rc[k]*rf;
	splRA(rs+k,drs+k,rsT+ki,rsT2a+ki);
	drs[k]	*=rf;
	rst[k]	=k*rs[k]*rf;
      }
      for(j=0; j < nP4; j++){
	s	=dgt*(j-j0);
	ss	=0.;
	dra	=0.;
	drt	=0.;
	for(k=1; k < ESFp1; k++){
	  rf	=k*s;
	  cs	=cos(rf);
	  sn	=sin(rf);
	  ss	+=rc[k]*cs+rs[k]*sn;
	  dra	+=drc[k]*cs+drs[k]*sn;
	  drt	+=rct[k]*sn+rst[k]*cs;
	}
	dra	=drc[0]+2.*dra;
	drt	*=2.;
	r[j]	=(rc[0]+2.*ss)*(dra*b*cos(s)-(dz+db*sin(s))*drt);
      }
      fwrite((void*)r,(size_t)8,(size_t)nP5,fp);
    }
    s	=A[ia];
    a	=ESsa[ESNa]+s;
    dgya=ESdgY[ESNa]+ESdgY1a[ESNa]*s;
    b	=ESsb[ESNa]+ESsb1a[ESNa]*s;
    db	=ESsb1a[ESNa]+ESsb2a[ESNa]*s;
    dz	=rsT1a[ESNa]+rsT2a[ESNa]*s;

    rf	=-fac/(dgya*a*rBt);
    rc[0]	=ESaR0[0]+rcT[ESNa]+rcT1a[ESNa]*s;
    drc[0]	=(rcT1a[ESNa]+rcT2a[ESNa]*s)*rf;
    ki	=ESNa;
    for(k=1; k < ESFp1; k++){
      ki	+=ESNa1;
      rc[k]	=rcT[ki]+rcT1a[ki]*s;
      drc[k]	=(rcT1a[ki]+rcT2a[ki]*s)*rf;
      rct[k]	=-k*rc[k]*rf;
      rs[k]	=rsT[ki]+rsT1a[ki]*s;
      drs[k]	=(rsT1a[ki]+rsT2a[ki]*s)*rf;
      rst[k]	=k*rs[k]*rf;
    }

    for(j=0; j < nP4; j++){
      s		=dgt*(j-j0);
      ss	=0.;
      dra	=0.;
      drt	=0.;
      for(k=1; k < ESFp1; k++){
	rf	=k*s;
	cs	=cos(rf);
	sn	=sin(rf);
	ss	+=rc[k]*cs+rs[k]*sn;
	dra	+=drc[k]*cs+drs[k]*sn;
	drt	+=rct[k]*sn+rst[k]*cs;
      }
      dra	=drc[0]+2.*dra;
      drt	*=2.;
      r[j]	=(rc[0]+2.*ss)*(dra*b*cos(s)-(dz+db*sin(s))*drt);
    }
    i++;
    fwrite((void*)r,(size_t)8,(size_t)nP5,fp);
    for(j=0; j < nP4; j++){
      r[j]	=0.;
    }
    while(i < nA5){
      fwrite((void*)r,(size_t)8,(size_t)nP5,fp);
      i++;
    }
  }
  fclose(fp);
  printf("\r");
  printf("Esc2dsk%4.2f has been written\n",ttime);
  return(0);
}

int ES2eqdskS(double ttime)
{
  int nA=128,nA1=129,nA5=NSIZE,nP=128,nP1=129,nP4=132,nP5=NSIZE;
  FILE *fp;
  int i,j,ia,j0=2;
  long int nxy[10];
  char Title[160];
  double dgy,dgt,dgya,rf,rg,a,ss,s,ds,rBt,p2rBt;
  double A[2*NSIZE];
  double sp[NSIZE],Ps[NSIZE],sq[NSIZE],dsqgy[NSIZE],gy[NSIZE];
  double g[NSIZE],dggy[NSIZE],fb[NSIZE],dfbgy[NSIZE];

  double aT[NSIZE];

  rg	=1./ESRBt;
  rBt	=ESRext*rg;
  rf	=-ESgY[ESNa]*rBt;
  p2rBt	=rBt*rBt;

  sprintf(Title,"Esc2dsk%4.2f",ttime);
  sprintf(Title,"../Pst/fort.17",ttime);
  printf("Writing plasma profiles\n");

  fp	=fopen(Title,"w");
  strcpy(Title,"ESC has written this garbage");
  i	=strlen(Title);
  while(i < 159){
    Title[i]	=' ';
    i++;
  }
  Title[i]	='\0';
  g[0]	=0.;
  fwrite((void*)g,(size_t)8,(size_t)1,fp);
  fwrite((void*)Title,(size_t)8,(size_t)20,fp);
  fwrite((void*)g,(size_t)8,(size_t)1,fp);
  nxy[0]  =nP1;	/*  +1 for symmetric case */
  nxy[1]  =nA1; 
  nxy[2]  =0;
  nxy[3]  =0; 
  nxy[4]  =0; 
  fwrite((void*)nxy,(size_t)8,(size_t)5,fp);

  g[0]	=rdPV[3]-rdPV[2];
  g[1]	=zdPV[0]-zdPV[1];
  g[2]	=zdPV[0];
  g[3]	=ESaR0[0];
  g[4]	=ESRext;
  g[5]	=ESsp[0]*p2rBt;
  g[6]	=ESRBt*rBt/ESRext;
  g[7]	=c2gp*ESgY[ESNa]*rBt;
  g[8]	=0.;
  g[9]	=g[7];
  g[10]=0.;
  g[11]=0.;
  g[12]=1.;
  fwrite((void*)g,(size_t)8,(size_t)13,fp);

  nxy[0]	=2; 
  nxy[1]	=0; 
  nxy[2]	=0; 
  nxy[3]	=0; 
  nxy[4]	=0;
  nxy[5]	=0;
  nxy[6]	=0; 
  nxy[7]	=0;	/* symmetry index */
  nxy[8]	=nP5;	/* poloidal allocation size */
  nxy[9]	=nA5;	/* radial allocation size */
  fwrite((void*)nxy,(size_t)8,(size_t)10,fp);
  
  dgy	=1./nA;
  dgt	=cgp/nP;
  g[0]	=dgt;
  g[1]	=dgy;
  g[2]	=cgp;
  g[3]	=ESRext;
  g[4]	=ESRBt/ESRext;
  printf("dt=%15.7e %15.7e %15.7e %15.7e %15.7e\n",g[0],g[1],g[2],g[3],g[4]);
  for(i=5; i < 10; i++){
    g[i]	=0.;
  }
  fwrite((void*)g,(size_t)8,(size_t)10,fp);
  
  for(i=0; i < ESNa1; i++){
    printf("??? ESgm[%2d]=%11.4e %11.4e %11.4e %11.4e %11.4e %11.4e\n",i
	   ,ESgm[i],ESgm1a[i],ESgm2a[i],ESdgY[i],ESdgY1a[i],ESdgY2a[i]);
  }

  a	=0.;
  i	=0;
  ia	=0;
  A[ia]	=a;
  ia++;
  gy[i]	=ESgY[ESNa]*rBt;
  Ps[i]	=-ESPs[0]*rBt;

  sq[i]	=1./ESgm[0];
  if(ESEqSolvInCr != 6 && ESEqSolvInCr != 7){
    dsqgy[i]	=ESgm2a[0]*sq[i]*sq[i]/(ESdgY[0]*rBt);
  }
  else{
    ESSetSplDCr(a);
    splRDCr2(&s,NULL,dsqgy,7);
    dsqgy[i]	*=sq[i]*sq[i]/(ESdgY[0]*rBt);
  }

  g[i]	=ESaF[0]*rg;
  splRA(&s,NULL,ESaT,ESaT2a);
  s	=ESaT[0]*rBt;
  aT[i]	=s;
  dggy[i]=-s/(ESRext*ESRext*g[i]);
  fb[i]	=-ESaR0[0]*ESdgY[0]*rBt/ESLc[0];
  dfbgy[i]	=ESaR0[0]*(ESdgY2a[0]-ESdgY[0]*ESLc2[0]/ESLc[0])/
    (ESdgY[0]*ESLc[0]);

  ss	=sqrt(dgy*(i+0.5));
  do{
    ESSetSplA(a);
    splRA(&s,&dgya,ESqgY,ESqgY2a);
    a		+=(ss-s)/dgya;
  }while(fabs(ss-s) > 1e-8);
  A[ia]	=a;
  ia++;
  ESSetSplA(a);
  splRA(g+i,&ds,ESaF,ESaF2a);
  g[i]	*=rg;
  if(ESEqSolvInPr != 2){
    splRA(sp+i,NULL,ESsp,ESsp2a);
  }
  else{
    ESSetSplDPr(a);
    splRDPr(sp+i,&ds,2);
  }
  sp[i]	*=p2rBt;
  for(i=1; i < nA1; i++){
    ss	=sqrt(dgy*i);
    do{
      ESSetSplA(a);
      splRA(&s,&dgya,ESqgY,ESqgY2a);
      a		+=(ss-s)/dgya;
    }while(fabs(ss-s) > 1e-8);
    A[ia]	=a;
    ia++;
    ESSetSplA(a);
    splRA(&dgya,&ds,ESdgY,ESdgY2a);
    splRA(&s,&ss,ESLc,ESLc2);
    fb[i]	=-ESaR0[0]*dgya/s;
    dgya	*=a;

    dfbgy[i]	=(ESaR0[0]*ds+fb[i]*ss)/(dgya*s);
    fb[i]	*=rBt;
    gy[i]	=ESgY[ESNa]*(1.-dgy*i)*rBt;
    switch(ESEqSolvInPr){
    case 0:
      ESSetSplDPr(a);
      splRDPr(Ps+i,&ds,0);
      Ps[i]	/=ESaR0[0];
      break;
    case 1:
      ESSetSplDPr(a);
      splRDPr(Ps+i,&ds,1);
      break;
    default:
      splRA(Ps+i,NULL,ESPs,ESPs2a);
      break;
    }
    Ps[i]	*=-rBt;
    if(ESEqSolvInCr != 6 && ESEqSolvInCr != 7){
      splRA(&s,&ds,ESgm,ESgm2a);
    }
    else{
      ESSetSplDCr(a);
      splRDCr(&s,&ds,7);
    }
    sq[i]	=1./s;
    dsqgy[i]	=ds*sq[i]*sq[i]/(dgya*rBt);
    printf("??? dgya[%3d]=%12.4e %12.4e %12.4e\n",i,dgya,ds,dsqgy[i]);
    splRA(g+i,&ds,ESaF,ESaF2a);
    g[i]	*=rg;
    splRA(&s,NULL,ESaT,ESaT2a);
    s		*=rBt;
    aT[i]	=s;
    dggy[i]	=-s/(ESRext*ESRext*g[i]);
    if(i < nA){
      ss	=sqrt(dgy*(i+0.5));
      do{
	ESSetSplA(a);
	splRA(&s,&dgya,ESqgY,ESqgY2a);
	a		+=(ss-s)/dgya;
      }while(fabs(ss-s) > 1e-8);
      ESSetSplA(a);
      splRA(g+i,&ds,ESaF,ESaF2a);
      g[i]	*=rg;
      if(ESEqSolvInPr != 2){
	splRA(sp+i,NULL,ESsp,ESsp2a);
      }
      else{
	ESSetSplDPr(a);
	splRDPr(sp+i,&ds,2);
      }
      sp[i]	*=p2rBt;
    }
    else{
      sp[i]	=0.;
      g[i]	=(ESaF[ESNa]+ESaF1a[ESNa]*(a-ESsa[ESNa]))*rg;
    }
    A[ia]	=a;
    ia++;
  }
  ds	=dgy*ESgY[ESNa]/ESgY1a[ESNa];
  A[ia]	=ds;
  ia++;
  sp[i]	=0.;
  Ps[i]	=-(ESPs[ESNa]+ESPs1a[ESNa]*ds)*rBt;
  Ps[i]	=0.;
  sq[i]	=1./(ESgm[ESNa]+ESgm1a[ESNa]*ds);
  sq[i]	=0.;
  dsqgy[i]	=0.;
  g[i]	=(ESaF[ESNa]+ESaF1a[ESNa]*ds)*rg;
  g[i]	=0.;
  dggy[i]=0.;
  fb[i]	=0.;
  dfbgy[i]=0.;
  gy[i]	=ESgY[ESNa]*(1.-dgy*i)*rBt;

  i++;
  while(i < nA5){
    sp[i]	=0.;
    Ps[i]	=0.;
    sq[i]	=0.;
    dsqgy[i]	=0.;
    g[i]	=0.;
    dggy[i]	=0.;
    fb[i]	=0.;
    dfbgy[i]	=0.;
    gy[i]	=0.;
    i++;
  }

#ifdef H
  for(i=0; i < nA1+1; i++){
    printf("gy[%3d]=%13.5e%13.5e%13.5e%13.5e%13.5e%13.5e\n",i
	   ,sp[i],Ps[i],sq[i],dsqgy[i],g[i],dggy[i]);
  }
#endif

  fwrite((void*)sp,(size_t)8,(size_t)nA5,fp);
  fwrite((void*)Ps,(size_t)8,(size_t)nA5,fp);
  fwrite((void*)sq,(size_t)8,(size_t)nA5,fp);
  fwrite((void*)dsqgy,(size_t)8,(size_t)nA5,fp);
  fwrite((void*)g,(size_t)8,(size_t)nA5,fp);
  fwrite((void*)dggy,(size_t)8,(size_t)nA5,fp);
  fwrite((void*)fb,(size_t)8,(size_t)nA5,fp);
  fwrite((void*)dfbgy,(size_t)8,(size_t)nA5,fp);
  i	=0;
  g[i]	=rf;
  s	=-0.5*nA*ESgY[ESNa]*rBt;
  dggy[i]=2.*s;
  for(i=1; i < nA1; i++){
    g[i]	=rf;
    dggy[i]	=s/i;
  }
  while(i < nA5){
    g[i]	=0.;
    dggy[i]	=0.;
    i++;
  }
  fwrite((void*)g,(size_t)8,(size_t)nA5,fp);
  fwrite((void*)dggy,(size_t)8,(size_t)nA5,fp);
  fwrite((void*)gy,(size_t)8,(size_t)nA5,fp);

  {
    int k,ki;
    double *r,*rc,*rs,*drc,*drs,*rct,*rst,dra,drt,cs,sn,b,db,dz,fac;

    r	=g;
    rc	=sp;
    rs	=Ps;
    drc	=fb;
    drs	=dfbgy;
    rct	=sq;
    rst	=dsqgy;

    printf("Writing metric tensor\n");
    /* r */
    for(j=0; j < nP4; j++){
      r[j]	=ESaR0[0];
    }
    for(j=nP4; j < nP5; j++){
      r[j]	=0.;
    }
    fwrite((void*)r,(size_t)8,(size_t)nP5,fp);
    ia	=2;
    for(i=1; i < nA1; i++){
      a		=A[ia];
      ia	+=2;
      ESSetSplA(a);
      ki	=0;
      splRA(rc,NULL,rcT,rcT2a);
      rc[0]	+=ESaR0[0];
      for(k=1; k < ESFp1; k++){
	ki	+=ESNa1;
	splRA(rc+k,NULL,rcT+ki,rcT2a+ki);
	splRA(rs+k,NULL,rsT+ki,rsT2a+ki);
      }
      for(j=0; j < nP4; j++){
	s	=dgt*(j-j0);
	ss	=0.;
	for(k=1; k < ESFp1; k++){
	  rf	=k*s;
	  ss	+=rc[k]*cos(rf)+rs[k]*sin(rf);
	}
	r[j]	=rc[0]+2.*ss;
      }
      fwrite((void*)r,(size_t)8,(size_t)nP5,fp);
    }
    rf	=A[ia];
    rc[0]	=ESaR0[0]+rcT[ESNa]+rcT1a[ESNa]*rf;
    ki	=ESNa;
    for(k=1; k < ESFp1; k++){
      ki	+=ESNa1;
      rc[k]	=rcT[ki]+rcT1a[ki]*rf;
      rs[k]	=rsT[ki]+rsT1a[ki]*rf;
    }
    for(j=0; j < nP4; j++){
      s		=dgt*(j-j0);
      ss	=0.;
      for(k=1; k < ESFp1; k++){
	rf	=k*s;
	ss	+=rc[k]*cos(rf)+rs[k]*sin(rf);
      }
      r[j]	=rc[0]+2.*ss;
    }
    i++;
    fwrite((void*)r,(size_t)8,(size_t)nP5,fp);
    for(j=0; j < nP4; j++){
      r[j]	=0.;
    }
    while(i < nA5){
      fwrite((void*)r,(size_t)8,(size_t)nP5,fp);
      i++;
    }
    /* z */
    for(j=0; j < nP4; j++){
      r[j]	=ESaZ0[0];
    }
    fwrite((void*)r,(size_t)8,(size_t)nP5,fp);
    ia	=2;
    for(i=1; i < nA1; i++){
      a		=A[ia];
      ia	+=2;
      ESSetSplA(a);
      splRA(rs,NULL,rsT,rsT2a);
      rs[0]	+=ESaZ0[0];
      splRA(&b,NULL,ESsb,ESsb2a);
      for(j=0; j < nP4; j++){
	r[j]	=rs[0]+b*sin(dgt*(j-j0));
      }
      fwrite((void*)r,(size_t)8,(size_t)nP5,fp);
    }
    b	=ESsb[ESNa]+ESsb1a[ESNa]*A[ia];
    rs[0]=ESaZ0[0]+rsT[ESNa]+rsT1a[ESNa]*A[ia];
    for(j=0; j < nP4; j++){
      r[j]	=rs[0]+b*sin(dgt*(j-j0));
    }
    i++;
    fwrite((void*)r,(size_t)8,(size_t)nP5,fp);
    for(j=0; j < nP4; j++){
      r[j]	=0.;
    }
    while(i < nA5){
      fwrite((void*)r,(size_t)8,(size_t)nP5,fp);
      i++;
    }
    
    fac	=-ESgY[ESNa]*rBt;
    /* qg05 */
    s	=-ESaR0[0]*ESDPc[0]*fac/(ESdgY[0]*rBt);
    for(j=0; j < nP4; j++){
      r[j]	=s;
    }
    fwrite((void*)r,(size_t)8,(size_t)nP5,fp);
    ia	=2;
    for(i=1; i < nA1; i++){
      a		=A[ia];
      ia	+=2;
      ESSetSplA(a);
      splRA(&dgya,NULL,ESdgY,ESdgY2a);
      splRA(&b,&db,ESsb,ESsb2a);
      splRA(&rf,&dz,rsT,rsT2a);
      rf	=-fac/(dgya*a*rBt);
      splRA(rc,drc,rcT,rcT2a);
      rc[0]	+=ESaR0[0];
      drc[0]	*=rf;
      ki	=0;
      for(k=1; k < ESFp1; k++){
	ki	+=ESNa1;
	splRA(rc+k,drc+k,rcT+ki,rcT2a+ki);
	drc[k]	*=rf;
	rct[k]	=-k*rc[k]*rf;
	splRA(rs+k,drs+k,rsT+ki,rsT2a+ki);
	drs[k]	*=rf;
	rst[k]	=k*rs[k]*rf;
      }
      for(j=0; j < nP4; j++){
	s	=dgt*(j-j0-0.5);
	ss	=0.;
	dra	=0.;
	drt	=0.;
	for(k=1; k < ESFp1; k++){
	  rf	=k*s;
	  cs	=cos(rf);
	  sn	=sin(rf);
	  ss	+=rc[k]*cs+rs[k]*sn;
	  dra	+=drc[k]*cs+drs[k]*sn;
	  drt	+=rct[k]*sn+rst[k]*cs;
	}
	dra	=drc[0]+2.*dra;
	drt	*=2.;
	r[j]	=(rc[0]+2.*ss)*(dra*b*cos(s)-(dz+db*sin(s))*drt);
      }
      fwrite((void*)r,(size_t)8,(size_t)nP5,fp);
    }
    s	=A[ia];
    a	=ESsa[ESNa]+s;
    dgya=ESdgY[ESNa]+ESdgY1a[ESNa]*s;
    b	=ESsb[ESNa]+ESsb1a[ESNa]*s;
    db	=ESsb1a[ESNa]+ESsb2a[ESNa]*s;
    dz	=rsT1a[ESNa]+rsT2a[ESNa]*s;
    rf	=-fac/(dgya*a*rBt);
    rc[0]	=ESaR0[0]+rcT[ESNa]+rcT1a[ESNa]*s;
    drc[0]	=(rcT1a[ESNa]+rcT2a[ESNa]*s)*rf;
    ki	=ESNa;
    for(k=1; k < ESFp1; k++){
      ki	+=ESNa1;
      rc[k]	=rcT[ki]+rcT1a[ki]*s;
      drc[k]	=(rcT1a[ki]+rcT2a[ki]*s)*rf;
      rct[k]	=-k*rc[k]*rf;
      rs[k]	=rsT[ki]+rsT1a[ki]*s;
      drs[k]	=(rsT1a[ki]+rsT2a[ki]*s)*rf;
      rst[k]	=k*rs[k]*rf;
    }
    for(j=0; j < nP4; j++){
      s		=dgt*(j-j0-0.5);
      ss	=0.;
      dra	=0.;
      drt	=0.;
      for(k=1; k < ESFp1; k++){
	rf	=k*s;
	cs	=cos(rf);
	sn	=sin(rf);
	ss	+=rc[k]*cs+rs[k]*sn;
	dra	+=drc[k]*cs+drs[k]*sn;
	drt	+=rct[k]*sn+rst[k]*cs;
      }
      dra	=drc[0]+2.*dra;
      drt	*=2.;
      r[j]	=(rc[0]+2.*ss)*(dra*b*cos(s)-(dz+db*sin(s))*drt);
    }
    i++;
    fwrite((void*)r,(size_t)8,(size_t)nP5,fp);
    for(j=0; j < nP4; j++){
      r[j]	=0.;
    }
    while(i < nA5){
      fwrite((void*)r,(size_t)8,(size_t)nP5,fp);
      i++;
    }
    /* qg */
    s	=-ESaR0[0]*ESDPc[0]*fac/(ESdgY[0]*rBt);
    for(j=0; j < nP4; j++){
      r[j]	=s;
    }
    fwrite((void*)r,(size_t)8,(size_t)nP5,fp);
    ia	=2;
    for(i=1; i < nA1; i++){
      a		=A[ia];
      ia	+=2;
      ESSetSplA(a);
      splRA(&dgya,NULL,ESdgY,ESdgY2a);
      splRA(&b,&db,ESsb,ESsb2a);
      splRA(&rf,&dz,rsT,rsT2a);

      rf	=-fac/(dgya*a*rBt);
      splRA(rc,drc,rcT,rcT2a);
      rc[0]	+=ESaR0[0];
      drc[0]	*=rf;
      ki	=0;
      for(k=1; k < ESFp1; k++){
	ki	+=ESNa1;
	splRA(rc+k,drc+k,rcT+ki,rcT2a+ki);
	drc[k]	*=rf;
	rct[k]	=-k*rc[k]*rf;
	splRA(rs+k,drs+k,rsT+ki,rsT2a+ki);
	drs[k]	*=rf;
	rst[k]	=k*rs[k]*rf;
      }
      for(j=0; j < nP4; j++){
	s	=dgt*(j-j0);
	ss	=0.;
	dra	=0.;
	drt	=0.;
	for(k=1; k < ESFp1; k++){
	  rf	=k*s;
	  cs	=cos(rf);
	  sn	=sin(rf);
	  ss	+=rc[k]*cs+rs[k]*sn;
	  dra	+=drc[k]*cs+drs[k]*sn;
	  drt	+=rct[k]*sn+rst[k]*cs;
	}
	dra	=drc[0]+2.*dra;
	drt	*=2.;
	r[j]	=(rc[0]+2.*ss)*(dra*b*cos(s)-(dz+db*sin(s))*drt);
      }
      fwrite((void*)r,(size_t)8,(size_t)nP5,fp);
    }
    s	=A[ia];
    a	=ESsa[ESNa]+s;
    dgya=ESdgY[ESNa]+ESdgY1a[ESNa]*s;
    b	=ESsb[ESNa]+ESsb1a[ESNa]*s;
    db	=ESsb1a[ESNa]+ESsb2a[ESNa]*s;
    dz	=rsT1a[ESNa]+rsT2a[ESNa]*s;

    rf	=-fac/(dgya*a*rBt);
    rc[0]	=ESaR0[0]+rcT[ESNa]+rcT1a[ESNa]*s;
    drc[0]	=(rcT1a[ESNa]+rcT2a[ESNa]*s)*rf;
    ki	=ESNa;
    for(k=1; k < ESFp1; k++){
      ki	+=ESNa1;
      rc[k]	=rcT[ki]+rcT1a[ki]*s;
      drc[k]	=(rcT1a[ki]+rcT2a[ki]*s)*rf;
      rct[k]	=-k*rc[k]*rf;
      rs[k]	=rsT[ki]+rsT1a[ki]*s;
      drs[k]	=(rsT1a[ki]+rsT2a[ki]*s)*rf;
      rst[k]	=k*rs[k]*rf;
    }

    for(j=0; j < nP4; j++){
      s		=dgt*(j-j0);
      ss	=0.;
      dra	=0.;
      drt	=0.;
      for(k=1; k < ESFp1; k++){
	rf	=k*s;
	cs	=cos(rf);
	sn	=sin(rf);
	ss	+=rc[k]*cs+rs[k]*sn;
	dra	+=drc[k]*cs+drs[k]*sn;
	drt	+=rct[k]*sn+rst[k]*cs;
      }
      dra	=drc[0]+2.*dra;
      drt	*=2.;
      r[j]	=(rc[0]+2.*ss)*(dra*b*cos(s)-(dz+db*sin(s))*drt);
    }
    i++;
    fwrite((void*)r,(size_t)8,(size_t)nP5,fp);
    for(j=0; j < nP4; j++){
      r[j]	=0.;
    }
    while(i < nA5){
      fwrite((void*)r,(size_t)8,(size_t)nP5,fp);
      i++;
    }
  }
  printf("Esc2dsk%4.2f has been written\n",ttime);
  fclose(fp);
  return(0);
}
