#include <stdio.h>
#include <math.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include "pfc.h"

int PFReadAI(FILE *lF,char *Str,char *Ms,char *str,int n, char **lv,int *dl
	     ,int k);

extern unsigned int ESmemlevP;
#ifndef mzl_MLIB
extern int FailureAlarm(char * p, char * RoutineName);
extern double GPring(double r,double z,double r0,double z0);

extern double cr2,cr3,cr4,cr6,cr12,cgp,c2gp,cgp_4,cr2gp,cgm0,crgm0;
#endif
extern int ESNsep;
extern double ESRsep[],ESZsep[];

static int FlVacVPlot=0;
#ifndef mzl_PFC

#ifndef stg_PlLim
extern int *ESiALm,ESnLm;
extern double*ESRLm,*ESZLm;
extern int nGrLm,iGrLm[],jGrLm[],kGrLm[],nGrEnv,iGrEnv[256][2];
extern double RGrLm[],ZGrLm[],ErGrLm[],EzGrLm[];

extern int EGNp,EGwNp;
extern int *EGkAp,*EGkA;
extern double EGdr,EGdz,EGdS;
extern double RplG[2],ZplG[2];
extern double *EGwRp,*EGwZp,*EGwIp;
extern double **gYpp;
extern double *EGsa,*EGgYp,*EGgYe,*EGaRp,*EGaZp,*EGaIp,*EGdIp,*EGjs,*EGjp
,*EGs1,*EGs2,*EGgf[42];

extern int NplG[2];
static int NLm=0,NGrid=0,FlPlG=0x0F;

static int FlLimPlot=0;
#endif

#ifndef stg_CHI
extern int nCHI,n0CHI,n1CHI,nEl0,nEl1;
extern double *CHIr0,*CHIz0,*CHIr1,*CHIz1;
extern int kEl0[],kEl1[];
extern double RGrEl0[],ZGrEl0[],RGrEl1[],ZGrEl1[];
static int NCHI=0,i0CHI,j0CHI,i1CHI,j1CHI;
#endif

#ifndef stg_VacV
extern WALL VVWall,VVTile;
extern int nVVB;
extern PSBLOCK *VVB;

static int NVVB=0;
static int *kVCB=NULL;
static int kkCol[8]={0,10,4,0,14,0,0,0};
extern int kCol[];
static double *Rv=NULL,*Zv=NULL;
#endif

#ifndef stg_PSElecP
extern int nVVC;
extern PFCOIL *VVC;

static int NVVC=0;
static int *FlPSC=NULL;
extern double **gYpS;
#endif

#ifndef stg_MFProbe
extern int nMFP,nMFL,nMFS,nMFLS,nMFp,nMFd,nMFV;
extern MFPROBE *MFP,*MFL,*MFS,*MFp,*MFd,*MFV;
extern double **gYip,**gYiS;
extern double *aSip,*aSiC,*aSi,*daSi;

static int NMFP=0,FlMFP=0x0F;
#endif

#ifndef stg_PFBlocks
extern int nPFB,nPFB1;
extern PFBLOCK *PFB;
extern double *Rb1,*Zb1,*Rb2,*Zb2,*IbPF;
static int NPFB=0;
static int kPFBPlot=0;
#endif

#ifndef stg_ElecPar
static int *FlPFC=NULL;
extern int nPFC,nPFC1,nPEC;
extern PFCOIL *PFC,*PEC;
extern double **gYCC,**gYpC,**gYiC,*gYcC[],*BRcC[],*BZcC[];
extern double *gYWC[],*IWgYi[],*gYWp[];
extern double EmnIV;

static int NPFC=0;
static char CoilNm[512][8]={128*8*'\0'};
static int kCB[1024];
static int LImgMFP=0;
static char ImgMFP[0x10]="";
#endif

extern int MSEFl,MSSFl;
extern int NMSE,nMSE,nMSS;
extern DATAMSE MSE[],MSS[];

#ifndef stg_PFCIeq
extern double *gYcp[],*BRcp[],*BZcp[],*gYcb[],*BRcb[],*BZcb[]
,*gYcS[],*BRcS[],*BZcS[];
#endif

int IfHasImage(char *str)
{
  char *lc;
  char *lt;
  lc	=ImgMFP;
  lt	=str;
  while(*lc && *lt){
    if(*lc != '?' && *lc != *lt) break;
    lc++;
    lt++;
  }
  if(*lc == 0 || (*lc == ';' && *lt == 0)) return(1);
  return(0);
}

int PFGetMemDataB(char Nm[][16],long int *A,int *L,int *k)
{
  int n;
  n	=*k;

  strcpy(Nm[n],"FlPSC");
  A[n]	=(long int)FlPSC;
  L[n++]=nVVC*sizeof(int);

  strcpy(Nm[n],"kVCB");
  A[n]	=(long int)kVCB;
  L[n++]=nVVB*sizeof(int);

  strcpy(Nm[n],"Rv");
  A[n]	=(long int)Rv;
  L[n++]=nVVB*sizeof(double);
  strcpy(Nm[n],"Zv");
  A[n]	=(long int)Zv;
  L[n++]=nVVB*sizeof(double);

  *k=	n;
  return(0);
}

#ifndef stg_PlLim
int DeInitLim()
{
  if(NLm){
    free(ESiALm);
    free(ESRLm);
    NLm	=0;
  }
  return(0);
}

int PFDefaultLim()
{
  int i;
  double t,dt,a,b,gd,r0,z0,sn;

  r0	=cr2*(RplG[1]+RplG[0]);
  z0	=cr2*(ZplG[1]+ZplG[0]);
  a	=cr2*(RplG[1]-RplG[0]);
  b	=cr2*(ZplG[1]-ZplG[0]);
  gd	=cr2*a*(b-a)/(b+a);
  dt	=c2gp/(ESnLm-1);
  for(i=0; i < ESnLm-1; i++){
    t	=dt*i;
    sn	=sin(t);
    ESiALm[i]=1;
    ESRLm[i]=r0+a*cos(t)-gd*sn*sn;
    ESZLm[i]=z0+b*sn;
  }
  ESiALm[i]=1;
  ESRLm[i]=ESRLm[0];
  ESZLm[i]=ESZLm[0];

  return(0);
}

int ReInitLim()
{
  if(NLm < ESnLm){
    int i;
    if(NLm){
      double *ld;
      ESRLm	=(double*)realloc((void*)ESRLm,2*ESnLm*sizeof(double));
      ESZLm	=ESRLm+ESnLm;
      ESiALm	=(int*)realloc((void*)ESiALm,ESnLm*sizeof(int));
      i		=NLm;
      ld	=ESRLm+2*NLm;
      while(i > 0){
	i--;
	ld--;
	ESZLm[i]	=*ld;
      }
    }
    else{
      ESRLm	=(double*)malloc(2*ESnLm*sizeof(double));
      ESZLm	=ESRLm+ESnLm;
      ESiALm	=(int*)malloc(ESnLm*sizeof(int));
      PFDefaultLim();
    }
    NLm		=ESnLm;
    for(i=0; i < ESnLm; i++) ESiALm[i]=1;
    ESmemlevP	|=0x00000040;
  }
  return(0);
}

void PlBGrid()
{
  int i;
  double s,ds;
  ZColor(3);
  ds	=(RplG[1]-RplG[0])/NplG[0];
  for(i=1; i < NplG[0]; i++){
    s	=RplG[0]+ds*i;
    ZPlotLine(s,ZplG[0],s,ZplG[1]);
  }
  ds	=(ZplG[1]-ZplG[0])/NplG[1];
  for(i=1; i < NplG[1]; i++){
    s	=ZplG[0]+ds*i;
    ZPlotLine(RplG[0],s,RplG[1],s);
  }
  return;
}

static double ScaleR=1.;

int PlLimAO(FILE *lf){
  int i,n;
  char str[64];
  char ln[128];

  ScaleR=4./1.8;
  ScaleR=1.;

  strcpy(ln,"%7.4f %7.4f %7.4f %7.4f %3d x %3d%c");
  strcpy(str,ln);
  FormatWrite2Read(str);

  fprintf(lf,"<Plasma Box>[%d](%s)\n",1,str);
  fprintf(lf,ln,ScaleR*RplG[0],ScaleR*ZplG[0],ScaleR*RplG[1]
	  ,ScaleR*ZplG[1],NplG[0],NplG[1],'\n');
  fprintf(lf,"%7s %7s %7s %7s %3s x %3s\n"
	  ,"Rpl 1","Zpl 1","Rpl 2","Zpl 2","Nr","Nz");
  fprintf(lf,"%7s %7s %7s %7s\n"
	  ,"(L.m)","(L.m)","(L.m)","(L.m)");
  strcpy(ln,"%3d %7.4f %7.4f%c");
  strcpy(str,ln);
  FormatWrite2Read(str);
  n	=0;
  for(i=0; i < ESnLm; i++) if(ESiALm[i]) n++;

  fprintf(lf,"<Limiter>[%d](%s)\n",n,str);
  fprintf(lf,"! # %7s %7s\n","RLm","ZLm");
  fprintf(lf,"!   %7s %7s\n","(L.m)","(L.m)");
  n=0;
  for(i=0; i < ESnLm; i++){
    if(ESiALm[i]){
      fprintf(lf,ln,n,ScaleR*ESRLm[i],ScaleR*ESZLm[i],'\n');
      n++;
    }
  }
  fprintf(lf,"! # %7s %7s\n","RLm","ZLm");
  fprintf(lf,"!   %7s %7s\n","(L.m)","(L.m)");
  return(0);
}

int PlLimAI(FILE *lf)
{
  int n;
  char str[64];
  char *lc;
  char *lm;
  char *lv[6];
  int dl[6]={0,0,0,0,0,0};
  
  lm	="PlLim.ai";
  lc	="<Plasma Box>";
  if(IsKeyWordFound(lf,lm,lc,str,&n)){
    lv[0]	=(char*)RplG;
    lv[1]	=(char*)ZplG;
    lv[2]	=(char*)(RplG+1);
    lv[3]	=(char*)(ZplG+1);
    lv[4]	=(char*)NplG;
    lv[5]	=(char*)(NplG+1);
    ReadAI(lf,lc,lm,str,n,lv,dl,6);
  }
  else{
    CbStr2UserMessage("No %s section\n",lc);
  }
  lc	="<Limiter>";
  if(IsKeyWordFound(lf,lm,lc,str,&n)){
    ESnLm	=n;
    ReInitLim();
    lv[0]	=(char*)&n;
    lv[1]	=(char*)ESRLm;
    lv[2]	=(char*)ESZLm;
    dl[0]	=0;
    dl[1]	=sizeof(double);
    dl[2]	=sizeof(double);
    ReadAI(lf,lc,lm,str,ESnLm,lv,dl,3);
  }
  else{
    CbStr2UserMessage("Error: %s - No %s section\n",lm,lc);
    return(1);
  }
  CbStr2UserMessage("Input: %s\n",lm);
  return(0);
}

int PFLim2DPlV()
{
  ESInit1DLim2PlV(ESnLm,ESRLm,ESZLm);
  return(0);
}

int PFDeInitEqGrid()
{
  if(NGrid){
    free(EGkAp);
    free(EGaRp);
  }
  return(0);
}

int PFReInitEqGrid()
{
  if(NGrid >= EGNp){
    return(0);
  }
  if(NGrid){
    PFDeInitEqGrid();
  }
  EGaRp	=(double*)malloc(5*EGNp*sizeof(double));
  if(EGaRp == NULL){
    printf("No memory for EGaRp in PFReInitEqGrid()\n");
    return(1);
  }
  EGaZp	=EGaRp+EGNp;
  EGwRp	=EGaZp+EGNp;
  EGwZp	=EGwRp+EGNp;
  EGwIp	=EGwZp+EGNp;

  EGkAp	=(int*)malloc(2*EGNp*sizeof(int));
  if(EGkAp == NULL){
    printf("No memory for EGkAp in PFReInitEqGrid()\n");
    return(1);
  }
  EGkA	=EGkAp+EGNp;
  NGrid	=EGNp;
  ESmemlevP	|=0x00004000;
  return(0);
}


int PFGridLim()
{
  int i,j,k,k1,m,nr,nz,n,nn;
  double Z,R,r,z,Tr,Tz;
  double rL[0x100],zL[0x100];
  int kL[256];
  
  nr	=NplG[0];
  nz	=NplG[1];

  /* Plasma Grid points */
  k	=0;
  Z	=ZplG[0]+cr2*EGdz;
  for(j=0; j < nz; j++){
    R	=RplG[0]+cr2*EGdr;
    for(i=0; i < nr; i++){
      EGaRp[k]	=R;
      EGaZp[k]	=Z;
      EGkA[k]	=0;
      EGkAp[k]	=0;
      R		+=EGdr;
      k++;
    }
    Z	+=EGdz;
  }
  
  /*{Generation of numerical limiter rL,zL*/
  n	=0;
  i	=0;
  while(i < ESnLm){/*Elimination of points with z < Z0 and z > Z1;*/
    if(ESiALm[i]){
      z	=ZplG[0];
      if(ESZLm[i] < z){
	if(n &&  ZGrLm[n-1] > z){/*Entrance*/
	  j	=n-1;
	  Tr	=(RGrLm[j]-ESRLm[i])/(ZGrLm[j]-ESZLm[i]);
	  ZGrLm[n]	=z;
	  RGrLm[n]	=ESRLm[i]+Tr*(z-ESZLm[i]);
	  jGrLm[n]	=jGrLm[j];
	  n++;
	}
	i++;
	while(i < ESnLm && ESZLm[i] < z) i++;
	if(i < ESnLm){/*Exit*/
	  j	=i-1;
	  Tr	=(ESRLm[j]-ESRLm[i])/(ESZLm[j]-ESZLm[i]);
	  ZGrLm[n]	=z;
	  RGrLm[n]	=ESRLm[i]+Tr*(z-ESZLm[i]);
	  jGrLm[n]	=j;
	  n++;
	}
      }
      else{
	z	=ZplG[1];
	if(ESZLm[i] > z){
	  if(n &&  ZGrLm[n-1] < z){/*Entrance*/
	    j	=n-1;
	    Tr	=(RGrLm[j]-ESRLm[i])/(ZGrLm[j]-ESZLm[i]);
	    ZGrLm[n]	=z;
	    RGrLm[n]	=ESRLm[i]+Tr*(z-ESZLm[i]);
	    jGrLm[n]	=jGrLm[j];
	    n++;
	  }
	  i++;
	  while(i < ESnLm && ESZLm[i] > z) i++;
	  if(i < ESnLm){/*Exit*/
	    j	=i-1;
	    Tr	=(ESRLm[j]-ESRLm[i])/(ESZLm[j]-ESZLm[i]);
	    ZGrLm[n]	=z;
	    RGrLm[n]	=ESRLm[i]+Tr*(z-ESZLm[i]);
	    jGrLm[n]	=j;
	    n++;
	  }
	}
	else{
	  ZGrLm[n]	=ESZLm[i];
	  RGrLm[n]	=ESRLm[i];
	  jGrLm[n]	=i ? i-1 : i;
	  n++;
	  i++;
	}
      }
    }
    else{
      i++;
    }
  }
  ZGrLm[n]	=ZGrLm[0];
  RGrLm[n]	=RGrLm[0];
  n++;
  nGrLm	=n;

  n	=0;
  i	=0;
  while(i < nGrLm){/*Elimination of points with r < R0 and r > R1;*/
    r	=RplG[0];
    if(RGrLm[i] < r){
      if(n &&  rL[n-1] > r){/*Entrance*/
	j	=n-1;
	Tz	=(zL[j]-ZGrLm[i])/(rL[j]-RGrLm[i]);
	zL[n]	=ZGrLm[i]+Tz*(r-RGrLm[i]);
	rL[n]	=r;
	kL[n]	=kL[j];
	n++;
      }
      i++;
      while(i < ESnLm && RGrLm[i] < r) i++;
      j	=i-1;
      if(i < ESnLm){/*Exit*/
	Tz	=(ZGrLm[j]-ZGrLm[i])/(RGrLm[j]-RGrLm[i]);
	zL[n]	=ZGrLm[i]+Tz*(r-RGrLm[i]);
	rL[n]	=r;
	kL[n]	=jGrLm[j];
	n++;
      }
    }
    else{
      r	=RplG[1];
      if(RGrLm[i] > r){
	if(n &&  rL[n-1] < r){/*Entrance*/
	  j	=n-1;
	  Tz	=(zL[j]-ZGrLm[i])/(rL[j]-RGrLm[i]);
	  zL[n]	=ZGrLm[i]+Tz*(r-RGrLm[i]);
	  rL[n]	=r;
	  kL[n]	=kL[j];
	  n++;
	}
	i++;
	while(i < ESnLm && RGrLm[i] > r) i++;
	if(i < ESnLm){/*Exit*/
	  j	=i-1;
	  Tz	=(ZGrLm[j]-ZGrLm[i])/(RGrLm[j]-RGrLm[i]);
	  zL[n]	=ZGrLm[i]+Tz*(r-RGrLm[i]);
	  rL[n]	=r;
	  kL[n]	=jGrLm[j];
	  n++;
	}
      }
      else{
	rL[n]	=RGrLm[i];
	zL[n]	=ZGrLm[i];
	kL[n]	=jGrLm[i];
	n++;
	i++;
      }
    }
  }
  zL[n]	=zL[0];
  rL[n]	=rL[0];
  n++;
  nGrLm	=n;

  /*Compressing contour of numerical limiter;*/
  i=1;
  while(rL[i] == rL[0] && zL[i] == zL[0]) i++;
  rL[1] =rL[i];
  zL[1] =zL[i];
  i++;
  n	=2;
  while(i < nGrLm){
    r	=rL[i];
    z	=zL[i];
    rL[n]	=r;
    zL[n]	=z;
    j	=n-1;
    k	=n-2;
    if((rL[j] != r && (zL[k] != z || zL[j] != z)) ||
       (zL[j] != z && (rL[k] != r || rL[j] != r))){
      n++;
    }
    else{
      rL[j]	=r;
      zL[j]	=z;
    }
    i++;
  }

#ifdef H
  j	=1;
  k	=n-2;
  if((zL[k] == z && zL[j] == z) || (rL[k] == r && rL[j] == r)){
    rL[0]	=rL[k];
    zL[0]	=zL[k];
    n--;
  }
#endif

  nGrLm	=n;
  /*}Generation of numerical limiter rL,zL*/

  /* Internal points;*/
  R	=EGaRp[0];
  Z	=EGaZp[0];
  n	=0;
  for(i=1,j=0; i < nGrLm; i++,j++){
    k1	=(zL[i]-Z)/EGdz;
    k	=(zL[j]-Z)/EGdz;
    if(zL[j] < zL[i]){
      if(Z+k*EGdz < zL[j]) k++;
      if(Z+k1*EGdz >= zL[i]) k1--;
      Tr	=(rL[i]-rL[j])/(zL[i]-zL[j]);
      while(k <= k1){
	z	=Z+k*EGdz;
	r	=rL[j]+Tr*(z-zL[j]);
	m	=(r-R)/EGdr;
	if(R+m*EGdr < r) m++;
	while(m < nr){
	  EGkA[k*nr+m]	^=1;
	  m++;
	}
	k++;
      }
    }
    if(zL[j] > zL[i]){
      Tr	=(rL[i]-rL[j])/(zL[i]-zL[j]);
      if(Z+k*EGdz >= zL[j]) k--;
      if(Z+k1*EGdz < zL[i]) k1++;
      while(k >= k1){
	z	=Z+k*EGdz;
	r	=rL[j]+Tr*(z-zL[j]);
	m	=(r-R)/EGdr;
	if(R+m*EGdr < r) m++;
	while(m < nr){
	  EGkA[k*nr+m]	^=1;
	  m++;
	}
	k--;
      }
    }
  }

  EGwNp	=0;
  for(i=0; i < EGNp; i++){
    if(EGkA[i]){
      EGwRp[EGwNp]	=EGaRp[i];
      EGwZp[EGwNp]	=EGaZp[i];
      EGwNp++;
    }
  }

  /*{Test points on the numerical limiter */
  n	=0;
  nn	=0;
  for(i=1,j=0; i < nGrLm; i++,j++){
    Tr	=rL[i]-rL[j];
    Tz	=zL[i]-zL[j];
    z	=1./sqrt(Tr*Tr+Tz*Tz);
    Tr	*=z;
    Tz	*=z;
    if(fabs(Tz) > fabs(Tr)){
      k	=(zL[j]-Z)/EGdz;
      k1=(zL[i]-Z)/EGdz;
      if(zL[j] < zL[i]){
	if(Z+k*EGdz < zL[j]) k++;
	if(Z+k1*EGdz > zL[i]) k1--;
	while(k <= k1){
	  z	=Z+k*EGdz;
	  ErGrLm[n]	=Tz;
	  EzGrLm[n]	=-Tr;
	  RGrLm[n]	=rL[j]+Tr*(z-zL[j])/Tz;
	  ZGrLm[n]	=z;
	  kGrLm[n]	=kL[j];
	  m	=(RGrLm[n]-R)/EGdr;
	  r	=R+m*EGdr;
	  if(fabs(r-RGrLm[n]) > fabs(r+EGdr-RGrLm[n])) m++;
	  if(m > nr-1) m	=nr-1;
	  jGrLm[n]	=k ? (k< nr-1 ? nr*k+m: nr*k-nr+m) : nr+m;
	  if(m < 1) m	=1;
	  if(m > nr-2) m	=nr-2;
	  iGrLm[n]	=nr*k+m;
	  if(n < 255) n++;
	  nn++;
	  k++;
	}
      }
      else{
	if(Z+k1*EGdz < zL[i]) k1++;
	if(Z+k*EGdz > zL[j]) k--;
	while(k >=k1){
	  z	=Z+k*EGdz;
	  ErGrLm[n]	=Tz;
	  EzGrLm[n]	=-Tr;
	  RGrLm[n]	=rL[j]+Tr*(z-zL[j])/Tz;
	  ZGrLm[n]	=z;
	  kGrLm[n]	=kL[j];
	  m	=(RGrLm[n]-R)/EGdr;
	  r	=R+m*EGdr;
	  if(fabs(r-RGrLm[n]) > fabs(r+EGdr-RGrLm[n])) m++;
	  if(m > nr-1) m	=nr-1;
	  jGrLm[n]	=k ? (k< nr-1 ? nr*k+m: nr*k-nr+m) : nr+m;
	  if(m < 1) m	=1;
	  if(m > nr-2) m	=nr-2;
	  iGrLm[n]	=nr*k+m;
	  if(n < 255) n++;
	  nn++;
	  k--;
	}
      }
    }
    else{
      k1=(rL[i]-R)/EGdr;
      k	=(rL[j]-R)/EGdr;
      if(rL[j] < rL[i]){
	if(R+k*EGdr < rL[j]) k++;
	if(R+k1*EGdr > rL[i]) k1--;
	while(k <= k1){
	  r	=R+k*EGdr;
	  ErGrLm[n]	=Tz;
	  EzGrLm[n]	=-Tr;
	  RGrLm[n]	=r;
	  ZGrLm[n]	=zL[j]+Tz*(r-rL[j])/Tr;
	  kGrLm[n]	=kL[j];
	  m	=(ZGrLm[n]-Z)/EGdz;
	  z	=Z+m*EGdz;
	  if(fabs(z-ZGrLm[n]) > fabs(z+EGdz-ZGrLm[n])) m++;
	  if(m == nz) m--;
	  jGrLm[n]	=m ? (m < nz-1 ? nr*m+k : nr*m-nr+k) : nr+k;
	  iGrLm[n]	=k ? (k < nr-1 ? nr*m+k : nr*m+nr-2) : nr*m+1;
	  if(n < 255) n++;
	  nn++;
	  k++;
	}
      }
      else{
	if(R+k1*EGdr < rL[i]) k1++;
	if(R+k*EGdr > rL[j]) k--;
	while(k >=k1){
	  r	=R+k*EGdr;
	  ErGrLm[n]	=Tz;
	  EzGrLm[n]	=-Tr;
	  RGrLm[n]	=r;
	  ZGrLm[n]	=zL[j]+Tz*(r-rL[j])/Tr;
	  kGrLm[n]	=kL[j];
	  m	=(ZGrLm[n]-Z)/EGdz;
	  z	=Z+m*EGdz;
	  if(fabs(z-ZGrLm[n]) > fabs(z+EGdz-ZGrLm[n])) m++;
	  if(m == nz) m--;
	  jGrLm[n]	=m ? (m < nz-1 ? nr*m+k : nr*m-nr+k) : nr+k;
	  iGrLm[n]	=k ? (k < nr-1 ? nr*m+k : nr*m+nr-2) : nr*m+1;
	  if(n < 255) n++;
	  nn++;
	  k--;
	}
      }
    }
  }
  nGrLm	=n;
  if(nn > 256){
    char ln[64];
    sprintf(ln,"256 < nGrLim=%d -reduce grid resolution\n",nn);
    CbStr2UserWarning(ln);
  }
  Z	=ZplG[0]+(nz/2+cr2)*EGdz;
  R	=RplG[0]+(nr/2+cr2)*EGdr;
  i	=0;
  while(fabs(ZGrLm[i]-Z) > 1e-6) i++;
  if(ErGrLm[i]*(RGrLm[i]-R) > 0.){
    for(i=0; i < nGrLm; i++){
      ErGrLm[i]	=-ErGrLm[i];
      EzGrLm[i]	=-EzGrLm[i];	
    }
  }
  /*}Test points on the numerical limiter */

  /* Envelop calculations;*/
  j	=0;
  k	=nz-1;
  for(i=1; i < k; i++){
    m	=i*nr;
    iGrEnv[j][0]	=m;
    iGrEnv[j][1]	=m+1;
    if(j < 255) j++;
  }
  k	=nr-1;
  for(i=1; i < k; i++){
    m	=nr*(nz-1)+i;
    iGrEnv[j][0]	=m;
    iGrEnv[j][1]	=m-nr;
    n	=m-nr;
    if(j < 255) j++;
  }
  k	=nz-1;
  for(i=1; i < k; i++){
    m	=nr*(nz-i)-1;
    iGrEnv[j][0]	=m;
    iGrEnv[j][1]	=m-1;
   if(j < 255) j++;
  }
  k	=nr-1;
  for(i=1; i < k; i++){
    iGrEnv[j][0]	=i;
    iGrEnv[j][1]	=i+nr;
    if(j < 255) j++;
  }
  nGrEnv	=j;

  if(nn > 256){
    char ln[64];
    sprintf(ln,"256 < nGrEnv=%d -reduce grid resolution\n",nn);
    CbStr2UserWarning(ln);
  }
  return(0);
}

int MFLinesInsideRect(int NLines)
{
  int i;
  double *f[64],Bx[2],By[2];

  for(i=0; i < NplG[1]; i++){
    f[i]	=EGgYp+NplG[0]*i;
  }
  Bx[0]	=RplG[0]+cr2*EGdr;
  Bx[1]	=RplG[1]-cr2*EGdr;
  By[0]	=ZplG[0]+cr2*EGdz;
  By[1]	=ZplG[1]-cr2*EGdz;
  RectGridContourPlot(f,Bx,By,NplG[0],NplG[1],NLines);
#ifdef H
  RectGridRayPlot(f,Bx,By,NplG[0],NplG[1],NLines);
#endif
  return(0);
}

int PFDeInitGreenPlasma()
{
  if(gYpp != NULL){
    int i;

    i	=12;
    while(i > 0){
      i--;
      free(gYcp[i]);
      gYcp[i]	=0;
    }
    i	=EGNp+51;
    while(i > 0){
      i--;
      free(gYpp[i]);
    }
    free(gYpp);
    gYpp	=NULL;
  }
  return(0);
}

int PFReInitGreenPlasma()
{
  static int Np=0;
  
  if(gYpp == NULL || Np != EGNp){
    int i,k;
    
    if(Np) PFDeInitGreenPlasma();
    Np		=EGNp;
    k		=51;
    gYpp	=(double**)malloc((EGNp+k)*sizeof(double*));
    if(gYpp == NULL){
      printf("No memory for gYpp in PFReInitGreenPlasma()\n");
      return(1);
    }
    for(i=0; i < EGNp+k; i++){
      gYpp[i]	=(double*)malloc(EGNp*sizeof(double));
      if(gYpp[i] == NULL){
	printf("No memory for gYpp[%d] in PFReInitGreenPlasma()\n",i);
	return(1);
      }
    }
    i		=EGNp;
    EGsa	=gYpp[i++];
    EGgYp	=gYpp[i++];
    EGgYe	=gYpp[i++];
    EGaIp	=gYpp[i++];
    EGdIp	=gYpp[i++];
    EGjs	=gYpp[i++];
    EGjp	=gYpp[i++];
    EGs1	=gYpp[i++];
    EGs2	=gYpp[i++];
    for(k=0; k < 42; k++) EGgf[k]=gYpp[i++];
    for(i=0; i < 12; i++){
      gYcp[i]	=(double*)malloc(3*EGNp*sizeof(double));
      if(gYcp[i] == NULL){
	printf("No memory for gYcp[%d] in PFReInitGreenPlasma()\n",i);
	return(1);
      }
      BRcp[i]	=gYcp[i]+EGNp;
      BZcp[i]	=BRcp[i]+EGNp;
    }
    FlPlG	|=0x01;
    ESmemlevP 	|=0x00000100;
  }
  return(0);
}

int PFSaveLijPlasma(FILE *lf)
{
  int i,n;
  size_t id;

  /* Plasma */
  id	=(size_t)sizeof(int);
  fwrite(NplG,id,(size_t)2,lf);
  id	=(size_t)sizeof(double);
  fwrite(RplG,id,(size_t)2,lf);
  fwrite(ZplG,id,(size_t)2,lf);
  /* Green Function */
  for(i=0; i < EGNp; i++){
    fwrite(gYpp[i]+i,id,(size_t)(EGNp-i),lf);
  }
  return(0);
}

int PFReadLijPlasma(FILE *lf)
{
  int i,m,k[2];
  double s[4];
  size_t id;

  /* Plasma */
  id	=(size_t)sizeof(int);
  m	=fread(k,id,(size_t)2,lf);
  if(m < 2 || NplG[0] != k[0] || NplG[1] != k[1]){
    FlPlG	|=0x01;
    return(1);
  }
  id	=(size_t)sizeof(double);
  m	=fread(s,id,(size_t)4,lf);
  if(m < 4 || RplG[0] != s[0] || RplG[1] != s[1] || 
     ZplG[0] != s[2] || ZplG[1] != s[3]){
    FlPlG	|=0x01;
    return(1);
  }
  /* Green Function */
  for(i=0; i < EGNp; i++){
    m	=fread(gYpp[i]+i,id,(size_t)(EGNp-i),lf);
    if(m < EGNp-i){
      FlPlG	|=0x01;
      return(1);
    }
    for(m=i+1; m < EGNp; m++){
      gYpp[m][i]	=gYpp[i][m];
    }	
  }
  FlPlG	&=0x0E;
  return(0);
}

int PFSetLijPlasma()
{
  static double cR[2]={0.,0.},cZ[2]={0.,0.};
  static int icnr=0,icnz=0;
  char ln[64];
  int m,k;
  int nr0,nz0,nr1,nz1;
  double r0,z0,r1,z1;
  double hr0,hz0,hr1,hz1;
  double R0,Z0,R1,Z1;
  double ss,gY;
  static int nx=4,ny=4;
  
  int ix0,iy0,ix1,iy1;
  double b,a,c,d;
  double x0,y0,x1,y1,dx0,dy0,dx1,dy1,ga,gaa,gr,grr;
  
  if((FlPlG&0x01) == 0){
    icnr	=NplG[0];
    icnz	=NplG[1];
    cR[0]	=RplG[0];
    cR[1]	=RplG[1];
    cZ[0]	=ZplG[0];
    cZ[1]	=ZplG[1];
    return(0);
  }
  if(icnr == NplG[0] && icnz == NplG[1] && 
     cR[0] == RplG[0] && cR[1] == RplG[1] && 
     cZ[0] == ZplG[0] && cZ[1] == ZplG[1]){
    return(0);
  }
  FlPlG	=0x0F;
  nx	=4;
  ny	=4;

  ss	=nx*ny;
  ss	=1./(ss*ss);

  nr0	=NplG[0];
  nz0	=NplG[1];
  hr0	=EGdr;
  hz0	=EGdz;
  dx0	=hr0/nx;
  dy0	=hz0/ny;
  a	=dy0/dx0;
  if(a > 3.0){
    d	=.13;
  }
  else{
    if(a >= 2.){
      d	=0.2+0.11*(3.-a);
    }
    else{
      if(a >= 1.6){
	d	=.31+.2*(2.-a);
      }
      else{
	if(a >= 1.){
	  d	=.39+.7167*(1.6-a);
	}
	else{
	  d	=.82;
	}
      }
    }
  }
  dx1	=dx0;
  dy1	=dy0;
  gY	=0.;
  for(m=0; m < EGNp; m++){
    sprintf(ln,"Plasma-Plasma: %4d < %d",m,EGNp);
    ZMessage(ln);
    r0	=EGaRp[m];
    z0	=EGaZp[m];
    R0	=r0-cr2*hr0;
    Z0	=z0-cr2*hz0;
    gY	=0.;
    x0	=R0+cr2*dx0;
    for(ix0=0; ix0 < nx; ix0++){
      y0	=Z0+cr2*dy0;
      for(iy0=0; iy0 < ny; iy0++){
	x1	=R0+cr2*dx0;
	for(ix1=0; ix1 < nx; ix1++){
	  y1	=Z0+cr2*dy0;
	  for(iy1=0; iy1 < ny; iy1++){
	    if(ix1 == ix0 && iy1 == iy0){
	      ga	=cr2*dy0/x0;
	      gr	=cr2*dx0/x0;
	      gaa	=ga*ga;
	      grr	=gr*gr;
	      gY	+=cgm0*x0*(log(4./(ga+gr))-cr2
				   +(3.*gaa+grr)*log(4./sqrt(gaa+grr))/24.
				   +d*gaa*.25);
	    }
	    else{
	      gY	+=GPring(x0,y0,x1,y1);
	    }
	    y1	+=dy1;
	  }
	  x1	+=dx1;
	}
	y0	+=dy0;
      }
      x0	+=dx0;
    }
    gYpp[m][m]	=gY*ss;
    for(k=m+1; k < EGNp; k++){
      r1	=EGaRp[k];
      z1	=EGaZp[k];
      if(fabs(r0-r1) > 1.1*hr0 || fabs(z0-z1) > 1.1*hz0){
	gY	=GPring(r0,z0,r1,z1);
      }
      else{
	R1	=r1-cr2*hr0;
	Z1	=z1-cr2*hz0;
	gY	=0.;
	x0	=R0+cr2*dx0;
	for(ix0=0; ix0 < nx; ix0++){
	  y0	=Z0+cr2*dy0;
	  for(iy0=0; iy0 < ny; iy0++){
	    x1	=R1+cr2*dx1;
	    for(ix1=0; ix1 < nx; ix1++){
	      y1	=Z1+cr2*dy1;
	      for(iy1=0; iy1 < ny; iy1++){
		gY	+=GPring(x0,y0,x1,y1)*ss;
		y1	+=dy1;
	      }
	      x1	+=dx1;
	    }
	    y0	+=dy0;
	  }
	  x0	+=dx0;
	}
      }
      gYpp[m][k]	=gY;
      gYpp[k][m]	=gY;
    }
  }
  FlPlG	&=0x0E;
  icnr	=NplG[0];
  icnz	=NplG[1];
  cR[0]	=RplG[0];
  cR[1]	=RplG[1];
  cZ[0]	=ZplG[0];
  cZ[1]	=ZplG[1];
  return(0);
}

void LimPlot0()
{
  int i,j;
  double r[0x100],z[0x100];

  ZColor(4);
  if((FlLimPlot&0x01)){
    int i;
    double d;
    d	=cr2*EGdr;
    for(i=0; i < nGrLm; i++){
      ZPlotLine(RGrLm[i],ZGrLm[i],RGrLm[i]+d*ErGrLm[i],ZGrLm[i]+d*EzGrLm[i]);
    }
  }
  j	=0;
  for(i=0; i < ESnLm; i++){
    if(ESiALm[i]){
      r[j]	=ESRLm[i];
      z[j]	=ESZLm[i];
      j++;
    }
  }
  ZPlotPolyLine(r,z,j);

  return;
}

void LimPlot()
{
  int i,j;
  double r[0x100],z[0x100];
  PlBGrid();
  ZColor(4);
  if((FlLimPlot&0x01)){
    int i;
    double d;
    d	=cr2*EGdr;
    for(i=0; i < nGrLm; i++){
      ZPlotLine(RGrLm[i],ZGrLm[i],RGrLm[i]+d*ErGrLm[i],ZGrLm[i]+d*EzGrLm[i]);
    }
  }
  j	=0;
  for(i=0; i < ESnLm; i++){
    if(ESiALm[i]){
      r[j]	=ESRLm[i];
      z[j]	=ESZLm[i];
      j++;
    }
  }
  ZPlotPolyLine(r,z,j);

  return;
}

int SetMSESightLine(double x0, double y0,double z0,double *v,double L,int n)
{
  int i;
  double R;
  double gw1,gw2;
  double s,t0,t,t1;
  double vx,vy,vz;
  double x,y,r,cs,sn;
  double a,b,c;
  nMSS	=n+1;

  vx	=v[0];
  vy	=v[1];
  vz	=v[2];

  s	=1./sqrt(vx*vx+vy*vy+vz*vz);
  vx	*=s;
  vy	*=s;
  vz	*=s;

  s	=1./sqrt(vx*vx+vy*vy);
  for(i=0; i < nMSS; i++){
    MSS[i].vx	=vx*s;
    MSS[i].vy	=vy*s;
    MSS[i].vz	=vz*s;
  }

  if(L > 0.){
    t0	=L;
    t1	=0.;
  }
  else{
    R	=0.5*(RplG[0]+RplG[1]);
    if((vx*x0+vy*y0)/sqrt(vx*vx+vy*vy) > sqrt(x0*x0+y0*y0-R*R)){
      s	=1./sqrt(x0*x0+y0*y0);
      gw2	=asin(y0*s);
      s	=asin(R*s);
      if(x0 < 0.){
	gw2=cgp-gw2;
	s=cgp-s;
      }
      s	=fabs(s);
      gw1	=gw2-s;
      gw2	+=s;
      s	=sqrt(vx*vx+vy*vy);
      vx	=s*cos(gw1);
      vy	=s*sin(gw1);
    }	 
    t	=vx*x0+vy*y0;
    if(t > 0.){
      vx	=-vx;
      vy	=-vy;
      vz	=-vz;
    }
    s	=(x0*vx+y0*vy)/sqrt(vx*vx+vy*vy);
    t0	=-sqrt(fabs(s*s+R*R-x0*x0-y0*y0))-s;

    t0	*=1.2;
    t1	=0.;
  }
  s	=(t1-t0)/n;

  x	=x0+t0*vx;
  y	=y0+t0*vy;

  r	=sqrt(x*x+y*y);
  s	=(sqrt(x0*x0+y0*y0)-r)/n;

  for(i=0; i < nMSS; i++){
    t	=t0+s*i;

    t	=r+s*i;
    c	=t*t-x0*x0-y0*y0;
    a	=vx*vx+vy*vy;
    b	=vx*x0+vy*y0;
    t	=(-sqrt(b*b+c*a)-b)/a;

    x	=x0+vx*t;
    y	=y0+vy*t;
    MSS[i].x=x;
    MSS[i].y=y;
    MSS[i].z=z0+vz*t;

    sn	=sqrt(x*x+y*y);
    MSS[i].r=sn;
    cs	=x/sn;
    sn	=y/sn;
    MSS[i].gf=asin(sn);
    if(x < 0.) MSS[i].gf =y > 0. ? cgp-MSS[i].gf : -cgp-MSS[i].gf;
    MSS[i].tr=vx*cs+vy*sn;
    MSS[i].tz=vz;
    MSS[i].tf=vy*cs-vx*sn;
  }
  MSSFl	=1;
  MSEFl	=1;
  memset(MSE,0,NMSE*sizeof(DATAMSE));
  nMSE=n+1;
  memcpy(MSE,MSS,nMSE*sizeof(DATAMSE));
  return(0);
}

int BmodGeom()
{
  int i;
  double x0,y0,z0,L;
  double x,y,z;
  double v[4];
  char *lD,*lN;

  CbGetCurrentCbName(&lD,&lN);
  if(strcmp(lD,"../dB0/Reconstr") == 0){
    double cs,sn;
    x0	=7.969e+00;
    y0	=-1.452e+00;
    z0	=3.988e-01;
    
    v[0]	=-8.610e-01;
    v[1]	=-5.070e-01;
    v[2]	=-4.000e-02;

    x	=5.297e+00-x0;
    y	=-3.025e+00-y0;
    z	=2.747e-01-z0;
    L	=sqrt(x*x+y*y+z*z);

    /* rotation of ITER*/
    sn	=y0/sqrt(x0*x0+y0*y0);
    cs	=x0/sqrt(x0*x0+y0*y0);
    z=x0;
    x0=x0*cs+y0*sn;
    y0	=y0*cs-z*sn;
    z	=v[0];
    v[0]	=v[0]*cs+v[1]*sn;
    v[1]	=v[1]*cs-z*sn;
  }
  else{
    x0	=RplG[1]-0.1*(RplG[1]-RplG[0]);
    y0	=0.;
    z0	=0.;
    v[0]	=-1.;
    v[1]	=0.;
    v[2]	=0.;
    L	=-1.;
  }
  SetMSESightLine(x0,y0,z0,v,L,20);
  return(0);
}

int PFPlLim()
{
  static int Fl=1,FlLm=1,FlBmod=0;
  int i,ii,j,n,N,N2,*kA,kk[256];
  double r[256],z[256];
  double R[2048],Z[2048];

  double rS[NMSE],zS[NMSE],rP[NMSE],zP[NMSE];
  int iAPl[2];
  int I=0;
  int kBmod;

#ifndef AscI_PlLim
#undef AscI_PlLim
#endif/*AscI_PlLim*/
  if(Fl){
    ReInitLim();
    Fl	=0;
  }
  kk[0]	=0;
  kk[1]	=0;
  kA	=kk+2;
  for(i=0; i < ESnLm; i++){
    r[i]	=ESRLm[i];
    z[i]	=ESZLm[i];
    kA[i]	=1;
  }
  N	=ESnLm;
  kBmod	=0;
#ifndef Tbl_PlLim
  iAPl[0]=1;
  iAPl[1]=1;
  CbUserPlot	=LimPlot;
  EGNp	=NplG[0]*NplG[1];

  if(NGrid < EGNp) PFReInitEqGrid();
  EGdr	=(RplG[1]-RplG[0])/NplG[0];
  EGdz	=(ZplG[1]-ZplG[0])/NplG[1];
  EGdS	=EGdr*EGdz;

  j	=0;
  for(i=0; i < N; i++) if(kA[i]) j++;
  ESnLm	=j;
  j	=0;
  for(i=0; i < N; i++){
    if(kA[i]){
      ESRLm[j]	=r[i];
      ESZLm[j]	=z[i];
      j++;
    }
  }
  if((I&0x80))  FlLm	=0;
  if(FlLm == 0){
    PFDefaultLim();
    for(i=0; i < ESnLm; i++){
      r[i]	=ESRLm[i];
      z[i]	=ESZLm[i];
      kA[i]	=1;
    }
    while(i < N){
      r[i]	=r[0];
      z[i]	=z[0];
      kA[i]	=0;
      i++;
    }
    FlLm	=1;
  }
  PFGridLim();
  FlLimPlot	=I;
  n	=0;
  j	=1;
  if(I == 0 || (I&0x01)){
    for(i=0; i < nGrLm; i++){
      if(j){
	R[n]	=RGrLm[i];
	Z[n]	=ZGrLm[i];
	n++;
	if(n == 2048){
	  CbStr2UserWarning("Too many grid-limiter intersections\n");
	  j	=0;
	}
      }
    }
  }
  if((I&0x02)){
    for(i=0; i < EGNp; i++){
      if(EGkA[i]){
	if(j){
	  R[n]	=EGaRp[i];
	  Z[n]	=EGaZp[i];
	  n++;
	  if(n == 2048){
	    CbStr2UserWarning("Too many grid points inside the plasma\n");
	    j	=0;
	  }
	}
      }
    }
  }
  if((I&0x04)){
    for(i=0; i < nGrLm; i++){
      if(j){
	ii	=iGrLm[i];
	R[n]	=EGaRp[ii];
	Z[n]	=EGaZp[ii];
	n++;
	if(n == 2048){
	  CbStr2UserWarning("Too many grid points for radial derivatives\n");
	  j	=0;
	}
      }
    }
  }
  if((I&0x08)){
    for(i=0; i < nGrLm; i++){
      if(j){
	ii	=jGrLm[i];
	R[n]	=EGaRp[ii];
	Z[n]	=EGaZp[ii];
	n++;
	if(n == 2048){
	  CbStr2UserWarning("Too many grid points for vertical derivatives\n");
	  j	=0;
	}
      }
    }
  }
  if((I&0x10)){
    for(i=0; i < EGNp; i++){
      if(j){
	R[n]	=EGaRp[i];
	Z[n]	=EGaZp[i];
	n++;
	if(n == 2048){
	  CbStr2UserWarning("Too many grid points\n");
	  j	=0;
	}
      }
    }
  }
  if((I&0x20)){
    for(i=0; i < nGrEnv; i++){
      if(j){
	ii	=iGrEnv[i][0];
	R[n]	=EGaRp[ii];
	Z[n]	=EGaZp[ii];
	n++;
	if(n == 2048){
	  CbStr2UserWarning("Too many envelop grid points\n");
	  j	=0;
	}
      }
    }
  }
  if((I&0x40)){
    for(i=0; i < nGrEnv; i++){
      if(j){
	ii	=iGrEnv[i][1];
	R[n]	=EGaRp[ii];
	Z[n]	=EGaZp[ii];
	n++;
	if(n == 2048){
	  CbStr2UserWarning("Too many envelop grid points\n");
	  j	=0;
	}
      }
    }
  }
  if(n > 2048){
    CbStr2UserWarning("2048 < n=%d -reduce grid resolution\n",n);
    n=2048;
  }

  if(FlBmod){
    BmodGeom();
    kBmod=nMSS;
    for(i=0; i < nMSS; i++){
      rS[i]	=MSS[i].r;
      zS[i]	=MSS[i].z;
    }
    for(i=0; i < nMSE; i++){
      rP[i]	=MSE[i].r;
      zP[i]	=MSE[i].z;
    }
  }
  else{
    kBmod=0;
  }
#endif/*Tbl_PlLim*/
  FlLimPlot	=0;

#ifndef AscO_PlLim
#undef AscO_PlLim
#endif/*AscO_PlLim*/
  PFReInitGreenPlasma();
#ifndef BnrI_PlLim
#undef BnrI_PlLim
#endif/*BnrI_PlLim*/
  PFSetLijPlasma();
#ifndef BnrO_PlLim
#undef BnrO_PlLim
#endif/*BnrO_PlLim*/
  return(0);
}
#endif

#ifndef stg_CHI

int DeInitCHI()
{
  if(NCHI) free(CHIr0);
  NCHI	=0;
  return(0);
}

int ReInitCHI()
{
  if(NCHI < nCHI){
    if(NCHI){
      free(CHIr0);
    }
    else{
      CHIr0	=(double*)malloc(2*nCHI*sizeof(double));
    }
    NCHI	=nCHI;
    ESmemlevP	|=0x00080000;
  }
  return(0);
}

void CHIElectrodePlot()
{
  PlBGrid();
  ZColor(4);
  if((FlLimPlot&0x01)){
    int i;
    double d;
    d	=cr2*EGdr;
    for(i=0; i < nGrLm; i++){
      ZPlotLine(RGrLm[i],ZGrLm[i],RGrLm[i]+d*ErGrLm[i],ZGrLm[i]+d*EzGrLm[i]);
    }
  }
#ifdef H
  ZPlotPolyLine(ESRLm,ESZLm,ESnLm);
#endif
  return;
}

int CHIElectrodes()
{
  static int Fl=1,nLm;
  int i,j,ii,k;
  double r[6],z[6],dx,dy,d,d0;

  if(Fl){
#ifdef H
    nLm		=ESnLm-1;
    if(ESRLm[0] == ESRLm[nLm] || ESZLm[0] == ESZLm[nLm]) nLm--;
    i0CHI	=0;
    j0CHI	=nLm/2;
    i1CHI	=j0CHI+1;
    j1CHI	=nLm;
    r[0]	=ESRLm[i0CHI];
    r[1]	=ESRLm[j0CHI];
    z[0]	=ESZLm[i0CHI];
    z[1]	=ESZLm[j0CHI];
    r[2]	=ESRLm[i1CHI];
    r[3]	=ESRLm[j1CHI];
    z[2]	=ESZLm[i1CHI];
    z[3]	=ESZLm[j1CHI];
    nCHI	=j0CHI*2+2;
#endif
    nCHI	=nGrLm*2+2;
    ReInitCHI();
    nLm		=nGrLm;
    i0CHI	=0;
    j0CHI	=nLm/2;
    i1CHI	=j0CHI+1;
    j1CHI	=nLm;
    r[0]	=RGrLm[i0CHI];
    r[1]	=RGrLm[j0CHI];
    z[0]	=ZGrLm[i0CHI];
    z[1]	=ZGrLm[j0CHI];
    r[2]	=RGrLm[i1CHI];
    r[3]	=RGrLm[j1CHI];
    z[2]	=ZGrLm[i1CHI];
    z[3]	=ZGrLm[j1CHI];
    Fl	=0;
  }
#ifndef Tbl_CHI
  CbUserPlot	=CHIElectrodePlot;
#ifdef H
  r[4]	=ESRLm[0];
  r[5]	=ESRLm[0];
  z[4]	=ESZLm[0];
  z[5]	=ESZLm[0];
  for(i=1; i < ESnLm; i++){
    if(r[4] > ESRLm[i]) r[4]=ESRLm[i];
    if(r[5] < ESRLm[i]) r[5]=ESRLm[i];
    if(z[4] > ESZLm[i]) z[4]=ESZLm[i];
    if(z[5] < ESZLm[i]) z[5]=ESZLm[i];
  }
  for(j=0; j < 4; j++){
    d	=1e+6;
    for(i=0; i < ESnLm; i++){
      dx	=ESRLm[i]-r[j];
      dy	=ESZLm[i]-z[j];
      d0	=dx*dx+dy*dy;
      if(d > d0){
	ii	=i;
	d	=d0;
      }
    }
    r[j]	=ESRLm[ii];
    z[j]	=ESZLm[ii];
    switch(j){
    case 0:
      i0CHI	=ii;
      break;
    case 1:
      j0CHI	=ii;
      break;
    case 2:
      i1CHI	=ii;
      break;
    case 3:
      j1CHI	=ii;
      break;
    }
  }
#endif
  r[4]	=RGrLm[0];
  r[5]	=RGrLm[0];
  z[4]	=ZGrLm[0];
  z[5]	=ZGrLm[0];
  for(i=1; i < nGrLm; i++){
    if(r[4] > RGrLm[i]) r[4]=RGrLm[i];
    if(r[5] < RGrLm[i]) r[5]=RGrLm[i];
    if(z[4] > ZGrLm[i]) z[4]=ZGrLm[i];
    if(z[5] < ZGrLm[i]) z[5]=ZGrLm[i];
  }
  for(j=0; j < 4; j++){
    d	=1e+6;
    for(i=0; i < nGrLm; i++){
      dx	=RGrLm[i]-r[j];
      dy	=ZGrLm[i]-z[j];
      d0	=dx*dx+dy*dy;
      if(d > d0){
	ii	=i;
	d	=d0;
      }
    }
    r[j]	=RGrLm[ii];
    z[j]	=ZGrLm[ii];
    switch(j){
    case 0:
      i0CHI	=ii;
      break;
    case 1:
      j0CHI	=ii;
      break;
    case 2:
      i1CHI	=ii;
      break;
    case 3:
      j1CHI	=ii;
      break;
    }
  }

  n0CHI	=j0CHI > i0CHI ? j0CHI-i0CHI+1 : nLm+j0CHI-i0CHI+2;
  n1CHI	=j1CHI > i1CHI ? j1CHI-i1CHI+1 : nLm+j1CHI-i1CHI+2;
  CHIz0	=CHIr0+n0CHI;
  CHIr1	=CHIz0+n0CHI;
  CHIz1	=CHIr1+n1CHI;

#ifdef H
  for(i=0,j=i0CHI; i < n0CHI; i++){
    if(j > nLm) j=0;
    CHIr0[i]	=ESRLm[j];
    CHIz0[i]	=ESZLm[j];
    j++;
  }
#endif
  for(i=0,j=i0CHI; i < n0CHI; i++){
    if(j > nLm) j=0;
    CHIr0[i]	=RGrLm[j];
    CHIz0[i]	=ZGrLm[j];
    j++;
  }
#ifdef H
  nEl0	=0;
  ii	=n0CHI-1;
  for(i=0,j=i0CHI; i < ii; i++){
    if(j > nLm) j=0;
    for(k=0; k < nGrLm; k++){
      if(kGrLm[k] == j){
	kEl0[nEl0]	=k;
	RGrEl0[nEl0]	=RGrLm[k];
	ZGrEl0[nEl0]	=ZGrLm[k];
	nEl0++;
      }
    }
    j++;
  }
  for(i=0,j=i1CHI; i < n1CHI; i++){
    if(j > nLm) j=0;
    CHIr1[i]	=ESRLm[j];
    CHIz1[i]	=ESZLm[j];
    j++;
  }
  nEl1	=0;
  ii	=n1CHI-1;
  for(i=0,j=i1CHI; i < ii; i++){
    if(j > nLm) j=0;
    for(k=0; k < nGrLm; k++){
      if(kGrLm[k] == j){
	kEl1[nEl1]	=k;
	RGrEl1[nEl1]	=RGrLm[k];
	ZGrEl1[nEl1]	=ZGrLm[k];
	nEl1++;
      }
    }
    j++;
  }
#endif
  nEl0	=0;
  ii	=n0CHI-1;
  for(i=0,j=i0CHI; i < ii; i++){
    if(j > nLm) j=0;
    kEl0[nEl0]		=j;
    RGrEl0[nEl0]	=RGrLm[j];
    ZGrEl0[nEl0]	=ZGrLm[j];
    nEl0++;
    j++;
  }
  for(i=0,j=i1CHI; i < n1CHI; i++){
    if(j > nLm) j=0;
    CHIr1[i]	=RGrLm[j];
    CHIz1[i]	=ZGrLm[j];
    j++;
  }
  nEl1	=0;
  ii	=n1CHI-1;
  for(i=0,j=i1CHI; i < ii; i++){
    if(j > nLm) j=0;
    kEl1[nEl1]		=j;
    RGrEl1[nEl1]	=RGrLm[j];
    ZGrEl1[nEl1]	=ZGrLm[j];
    nEl1++;
    j++;
  }

#endif/*Tbl_CHI*/
  return(0);
}

#endif

#ifndef stg_VacV
int PFReInitVVB()
{
  if(NVVB < nVVB){
    int i,k;
    double R,Z;
    PSBLOCK *lS;

    if(NVVB){
      VVB	=(PSBLOCK*)realloc((void*)VVB,nVVB*sizeof(PSBLOCK));
      Rv	=(double*)realloc((void*)Rv,nVVB*sizeof(double));
      Zv	=(double*)realloc((void*)Zv,nVVB*sizeof(double));
      kVCB	=(int*)realloc((void*)kVCB,nVVB*sizeof(int));
    }
    else{
      VVB	=(PSBLOCK*)malloc(nVVB*sizeof(PSBLOCK));
      Rv	=(double*)malloc(nVVB*sizeof(double));
      Zv	=(double*)malloc(nVVB*sizeof(double));
      kVCB	=(int*)malloc(nVVB*sizeof(int));
    }
    if(Rv == NULL || Zv == NULL || VVB == NULL){
      printf("No memory for VVBlocks in PFReInitVVB()\n");
      return(1);
    }
#ifdef H
    if(NVVB == 0){
      double t,dt,a,b,d,gd,r0,z0,cs,sn;
      double r[2],z[2];
      r0	=cr2*(RplG[1]+RplG[0]);
      z0	=cr2*(ZplG[1]+ZplG[0]);
      a		=1.1*cr2*(RplG[1]-RplG[0]);
      b		=1.1*cr2*(ZplG[1]-ZplG[0]);
      a		=cr2*(RplG[1]-RplG[0]);
      b		=cr2*(ZplG[1]-ZplG[0]);
      gd	=cr2*a*(b-a)/(b+a);
      k		=a > 1. ? 5. : 5.*a;
      d		=0.01*k;
      dt	=c2gp/nVVB;
      r[0]	=r0-a;
      z[0]	=z0;
      r[1]	=r[0]-d;
      z[1]	=z[0];
      for(i=0; i < nVVB; i++){
	lS	=VVB+i;
	lS->r[0]	=r[0];
	lS->z[0]	=z[0];
	lS->r[1]	=r[1];
	lS->z[1]	=z[1];
	t	=dt*(i+1);
	sn	=sin(t);
	cs	=cos(t);
	r[0]	=r0-a*cs-gd*sn*sn;
	z[0]	=z0+b*sn;
	r[1]	=-b*cs;
	z[1]	=(a-2.*gd*cs)*sn;
	cs	=1./sqrt(r[1]*r[1]+z[1]*z[1]);
	r[1]	=r[0]+d*r[1]*cs;
	z[1]	=z[0]+d*z[1]*cs;
	lS->r[3]	=r[0];
	lS->z[3]	=z[0];
	lS->r[2]	=r[1];
	lS->z[2]	=z[1];
	lS->R	=cr4*(lS->r[0]+lS->r[1]+lS->r[2]+lS->r[3]);
	lS->Z	=cr4*(lS->z[0]+lS->z[1]+lS->z[2]+lS->z[3]);
	lS->dS	=fabs(cr2*((lS->r[2]-lS->r[0])*(lS->z[1]-lS->z[3])
			   +(lS->r[3]-lS->r[1])*(lS->z[2]-lS->z[0])));
	sn	=1./sqrt(lS->dS);
	lS->n1	=d*sn+1;
	cs	=(lS->r[3]-lS->r[0])*sn;
	sn	*=lS->z[3]-lS->z[0];
	lS->n2	=sqrt(cs*cs+sn*sn)+1;
      }
    }
    else{
      int n1,n2;
      double r[4],z[4],dS;
      lS	=VVB+NVVB-1;
      for(k=0; k < 4; k++){
	r[k]	=lS->r[k];
	z[k]	=lS->z[k];
      }
      R	=cr4*(r[0]+r[1]+r[2]+r[3]);
      Z	=cr4*(z[0]+z[1]+z[2]+z[3]);
      dS=lS->dS;
      n1=lS->n1;
      n2=lS->n2;
      for(i=NVVB; i < nVVB; i++){
	lS	=VVB+i;
	for(k=0; k < 4; k++){
	  lS->r[k]	=r[k];
	  lS->z[k]	=z[k];
	}
	lS->R	=R;
	lS->Z	=Z;
	lS->dS	=dS;
	lS->n1	=n1;
	lS->n2	=n2;
      }
    }

    for(i=NVVB; i < nVVB; i++){
      lS	=VVB+i;
      lS->ff	=1.;
      lS->gs	=1./7.20e-07;

      lS->gS	=lS->ff*lS->gs*lS->dS;
      lS->tn	=1.;
      lS->I	=0.;
      lS->gY	=0.;
      lS->V	=0.;
      lS->n1	=1;
      lS->n2	=8;
      lS->kA	=1;
      lS->c	=1+i%16;
      lS->kC	=i;
      sprintf(lS->Nm,"VVB%3.3d",i);
      sprintf(lS->NmC,"VVC%3.3d",lS->kC);
    }
#endif
    NVVB	=nVVB;
  }
  ESmemlevP |=0x00000080;
  return(0);
}

int PFDeInitVVB()
{
  if(NVVB){
    free(kVCB);
    free(Zv);
    free(Rv);
    free(VVB);
  }
  return(0);
}

void VVBPlot()
{
  int i,j,k,m,n;
  double dr1,dz1,dr2,dz2;
  char ln[0x20];
  extern FILE *PSFile;
  extern int FlagPS;
  extern double PSfh;
  extern int wF,hF,wFHelp,hFHelp;
  double fh,s,d,h,sx,sy,L;
  PSBLOCK *pS;
  double xS[nVVB],yS[nVVB],wS[nVVB];

  k	=-1;
  fh	=PSfh;
  PSfh	=7.;

  j	=FlVacVPlot%10 ? FlVacVPlot%10 : 3;
  for(i=0; i < nVVB; i++){
    pS	=VVB+i;
    if(j == 3 || (j == 1 && pS->kA) || (j == 2 && (pS->kA == 0))){
      k	=pS->kA ? pS->c-1 : 0;
      ZColor(kCol[k]);
      ZPlotPolyLineC(pS->r,pS->z,4);
      if(FlVacVPlot/10 == 2 || FlVacVPlot/10 == 4){
	if(FlagPS){
	  fprintf(PSFile,"%%Lines\nnewpath 1 setlinewidth\n");
	}
	n	=pS->n1;
	if(n > 1){
	  dr1	=(pS->r[1]-pS->r[0])/n;
	  dz1	=(pS->z[1]-pS->z[0])/n;
	  dr2	=(pS->r[2]-pS->r[3])/n;
	  dz2	=(pS->z[2]-pS->z[3])/n;
	  for(m=1; m < n; m++){
	    ZPlotLine(pS->r[0]+dr1*m,pS->z[0]+dz1*m
		      ,pS->r[3]+dr2*m,pS->z[3]+dz2*m);
	  }
	}
	n	=pS->n2;
	if(n > 1){
	  dr1	=(pS->r[3]-pS->r[0])/n;
	  dz1	=(pS->z[3]-pS->z[0])/n;
	  dr2	=(pS->r[2]-pS->r[1])/n;
	  dz2	=(pS->z[2]-pS->z[1])/n;
	  for(m=1; m < n; m++){
	    ZPlotLine(pS->r[0]+dr1*m,pS->z[0]+dz1*m
		      ,pS->r[1]+dr2*m,pS->z[1]+dz2*m);
	  }
	}
	if(FlagPS) fprintf(PSFile,"stroke\n");
      }
    }
  }
  ZColor(0);
  if(FlVacVPlot/10 == 1){
    for(i=0; i < nVVB; i++){
      pS	=VVB+i;
      if(j == 3 || (j == 1 && pS->kA) || (j == 2 && pS->kA == 0)){
	ZPlotLUString(pS->R,pS->Z,pS->Nm,strlen(pS->Nm));
      }
    }
  }
  LimPlot();

#ifdef H
  CbGetScale(&sx,&sy);

  ZColor(0);
  d	=2./sx;
  h	=hF/fabs(sy);
  for(i=0; i < nVVB; i++){
    L=sprintf(ln,"%s",VVB[i].Nm);
    xS[i]=VVB[i].r[0];
    yS[i]=VVB[i].z[0];
    for(j=1; j < 4; j++) if(xS[i] < VVB[i].r[j]){
      xS[i]=VVB[i].r[j];
      yS[i]=VVB[i].z[j];
    }
    xS[i]	+=d;
    wS[i]	=L*wF/sx;
    j	=0;
    while(j < i){
      if(yS[i] < yS[j]+h && yS[i]+h > yS[j] && xS[i] < xS[j]+wS[j] && 
	 xS[i]+wS[i] > xS[j]) yS[i] = VVB[i].Z < VVB[j].Z ? yS[j]-h: yS[j]+h;
      j++;
    }
    ZPlotLUString(xS[i],yS[i],ln,L);
  }
#endif
  PSfh	=fh;
}

int VacVAO(FILE *lf)
{
  int i,j,L;
  PSBLOCK *pS;
  char *lc;
  char str[0x100];
  char ln[0x100];

  strcpy(ln,"%3d %7.4f %7.4f %7.4f %7.4f %7.4f %7.4f %7.4f %7.4f %s%c");
  if(nVVB > 1000) ln[1]='4';
  if(nVVB >10000) ln[1]='5';
  strcpy(str,ln);
  FormatWrite2Read(str);
  fprintf(lf,"<Vacuum Vessel>[%d](%s)\n",nVVB,str);
  str[0]='!';
  str[1]='%';
  str[2]=ln[1]-1;
  strcpy(str+3,"s %7s %7s %7s %7s %7s %7s %7s %7s %s\n");

  fprintf(lf,str,"#"
	  ,"r[0]","z[0]","r[1]","z[1]","r[2]","z[2]","r[3]","z[3]","NameB");
  for(i=0; i < nVVB; i++){
    pS	=VVB+i;
    fprintf(lf,ln,i,ScaleR*pS->r[0],ScaleR*pS->z[0],ScaleR*pS->r[1]
	    ,ScaleR*pS->z[1],ScaleR*pS->r[2],ScaleR*pS->z[2] 
	    ,ScaleR*pS->r[3],ScaleR*pS->z[3],pS->Nm,'\n');
  }
  fprintf(lf,"!%2s %7s %7s %7s %7s %7s %7s %7s %7s %s\n","#"
	  ,"r[0]","z[0]","r[1]","z[1]","r[2]","z[2]","r[3]","z[3]","NameB");

  L	=0;
  for(i=0; i < nVVB; i++){
    lc	=VVB[i].Nm;
    j	=strlen(lc);
    if(L < j) L=j;
    if(*VVB[i].NmC == 0) sprintf(VVB[i].NmC,"VVC-%3.3d",VVB[i].kC);
  }

  sprintf(ln+4,"%s%ds %s","%2d x %2d %3d %3d %2d %",L,"%s%c");
  strcpy(str,ln);
  FormatWrite2Read(str);

  fprintf(lf,"<Vacuum Vessel, cont>[%d](%s)\n",nVVB,str);
  *str='!';
  str[0]='!';
  str[1]='%';
  str[2]=ln[1]-1;
  sprintf(str+3,"s %s%ds %s","%2s x %2s %3s %3s %2s %",L,"%s\n");
  fprintf(lf,str,"#","Nn","Nt","c","#C","kA","NameB","Coil");
  for(i=0; i < nVVB; i++){
    pS	=VVB+i;
    fprintf(lf,ln,i,pS->n1,pS->n2,pS->c,pS->kC,pS->kA,pS->Nm,pS->NmC,'\n');
  }
  fprintf(lf,str,"#","Nn","Nt","c","#C","kA","NameB","Coil");

  /* HT-7 */
  {
    int n,n1;
    double cs05[64],sn05[64],cs[65],sn[65];
    double t,dt;
    double r[4],z[4],R=1.22,r1=0.345,r2=0.37;
    char nm[0x10];
    n	=64;
    n1	=n+1;
    dt	=c2gp/n;
    for(i=0; i < n; i++){
      t	=dt*i;
      cs[i]	=cos(t);
      sn[i]	=sin(t);
    }
    cs[i]	=cs[0];
    sn[i]	=sn[0];

    strcpy(ln,"%3d %7.4f %7.4f %7.4f %7.4f %7.4f %7.4f %7.4f %7.4f %s%c");
    strcpy(str,ln);
    FormatWrite2Read(str);
    fprintf(lf,"\n\n");
    fprintf(lf,"<Vacuum Vessel>[%d](%s)\n",n,str);
    str[0]='!';
    str[1]='%';
    str[2]=ln[1]-1;
    strcpy(str+3,"s %7s %7s %7s %7s %7s %7s %7s %7s %s\n");
    fprintf(lf,str,"#"
	    ,"r[0]","z[0]","r[1]","z[1]","r[2]","z[2]","r[3]","z[3]","NameB");
    for(i=0; i < n; i++){
      r[0]	=R-r1*cs[i+1];
      z[0]	=r1*sn[i+1];
      r[1]	=R-r1*cs[i];
      z[1]	=r1*sn[i];
      r[2]	=R-r2*cs[i];
      z[2]	=r2*sn[i];
      r[3]	=R-r2*cs[i+1];
      z[3]	=r2*sn[i+1];
      sprintf(nm,"vv-%2.2d",i);
      fprintf(lf,ln,i,r[0],z[0],r[1],z[1],r[2],z[2],r[3],z[3],nm,'\n');
    }
    fprintf(lf,str,"#"
	    ,"r[0]","z[0]","r[1]","z[1]","r[2]","z[2]","r[3]","z[3]","NameB");

    L=5;
    sprintf(ln+4,"%s%ds %s","%2d x %2d %3d %3d %2d %",L,"%s%c");
    strcpy(str,ln);
    FormatWrite2Read(str);

    fprintf(lf,"<Vacuum Vessel, cont>[%d](%s)\n",n,str);
    *str='!';
    str[0]='!';
    str[1]='%';
    str[2]=ln[1]-1;
    sprintf(str+3,"s %s%ds %s","%2s x %2s %3s %3s %2s %",L,"%s\n");
    fprintf(lf,str,"#","Nn","Nt","c","#C","kA","NameB","Coil");
    for(i=0; i < n; i++){
      sprintf(nm,"vv-%2.2d",i);
      fprintf(lf,ln,i,4,4,i%16+1,i,1,nm,nm,'\n');
    }
    fprintf(lf,str,"#","Nn","Nt","c","#C","kA","NameB","Coil");


    n	=11;
    n1	=n+1;
    strcpy(ln,"%3d %7.4f %7.4f %7.4f %7.4f %7.4f %7.4f %7.4f %7.4f %s%c");
    strcpy(str,ln);
    FormatWrite2Read(str);
    fprintf(lf,"\n\n");
    fprintf(lf,"<Vacuum Vessel>[%d](%s)\n",n,str);
    str[0]='!';
    str[1]='%';
    str[2]=ln[1]-1;
    strcpy(str+3,"s %7s %7s %7s %7s %7s %7s %7s %7s %s\n");
    fprintf(lf,str,"#"
	    ,"r[0]","z[0]","r[1]","z[1]","r[2]","z[2]","r[3]","z[3]","NameB");
    r2	=r1;
    r1	=r2-.023;
    t	=asin(0.26/r1);
    dt	=2.*t/n;
    t	=-t;
    for(i=0; i < n1; i++){
      cs[i]	=cos(t);
      sn[i]	=sin(t);
      t+=dt;
    }
    for(i=0; i < n; i++){
      r[0]	=R+r1*cs[i];
      z[0]	=r1*sn[i];
      r[1]	=R+r1*cs[i+1];
      z[1]	=r1*sn[i+1];
      r[2]	=R+r2*cs[i+1];
      z[2]	=r2*sn[i+1];
      r[3]	=R+r2*cs[i];
      z[3]	=r2*sn[i];
      sprintf(nm,"vv-%2.2d",i);
      fprintf(lf,ln,i,r[0],z[0],r[1],z[1],r[2],z[2],r[3],z[3],nm,'\n');
    }
    fprintf(lf,str,"#"
	    ,"r[0]","z[0]","r[1]","z[1]","r[2]","z[2]","r[3]","z[3]","NameB");


    fprintf(lf,str,"#"
	    ,"r[0]","z[0]","r[1]","z[1]","r[2]","z[2]","r[3]","z[3]","NameB");
    r2	=r1;
    r1	=0.27;
    t	=asin(0.26/r2);
    dt	=2.*t/n;
    t	=-t;
    for(i=0; i < n1; i++){
      cs[i]	=cos(t);
      sn[i]	=sin(t);
      t+=dt;
    }
    for(i=0; i < n; i++){
      r[0]	=R+r1*cs[i];
      z[0]	=r1*sn[i];
      r[1]	=R+r1*cs[i+1];
      z[1]	=r1*sn[i+1];
      r[2]	=R+r2*cs[i+1];
      z[2]	=r2*sn[i+1];
      r[3]	=R+r2*cs[i];
      z[3]	=r2*sn[i];
      sprintf(nm," T-%2.2d",i);
      fprintf(lf,ln,i,r[0],z[0],r[1],z[1],r[2],z[2],r[3],z[3],nm,'\n');
    }
    fprintf(lf,str,"#"
	    ,"r[0]","z[0]","r[1]","z[1]","r[2]","z[2]","r[3]","z[3]","NameB");

  }
  return(0);
}

int RZ2VacV(double *r1,double *z1,double *r2,double *z2,int n1,int n2)
{
  int i,k,n,ii;
  double *r,*z;
  double R1[0x100],Z1[0x100],R2[0x100],Z2[0x100];
  double d2r[0x100],d2z[0x100],x[0x100];
  double dr,dz,d,s;
  PSBLOCK *lV;

  /*Written for ITER */

  nVVB	=n1+n2-2;
  PFReInitVVB();

  d	=0.06/2.;
  nVVB	=0;
  for(k=0; k < 2; k++){
    if(k == 0){
      n	=n1;
      r	=r1;
      z	=z1;
    }
    else{
      n	=n2;
      r	=r2;
      z	=z2;
    }
    for(i=0; i < n; i++) x[i]=i;
    n--;

    spl_p(r,d2r,x,n);
    spl_p(z,d2z,x,n);
    d2r[n]	=d2r[0];
    d2z[n]	=d2z[0];

    for(i=0; i < n; i++){
      splr1(&s,&dr,x+i,r,d2r,x,&n,&i);
      splr1(&s,&dz,x+i,z,d2z,x,&n,&i);
      s	=d/sqrt(dr*dr+dz*dz);
      dr	*=s;
      dz	*=s;
      R1[i]	=r[i]+dz;
      Z1[i]	=z[i]-dr;
      R2[i]	=r[i]-dz;
      Z2[i]	=z[i]+dr;
    }
    R1[n]	=R1[0];
    Z1[n]	=Z1[0];
    R2[n]	=R2[0];
    Z2[n]	=Z2[0];

    lV	=VVB+nVVB;
    for(i=0; i < n; i++){
      ii	=i+1;
      lV->r[0]	=R1[i];
      lV->z[0]	=Z1[i];
      lV->r[1]	=R1[ii];
      lV->z[1]	=Z1[ii];
      lV->r[2]	=R2[ii];
      lV->z[2]	=Z2[ii];
      lV->r[3]	=R2[i];
      lV->z[3]	=Z2[i];
      sprintf(lV->Nm, k ? "VVo-%2d" : "VVi-%2d",i);
      lV->n1	=1;
      lV->n2	=1;
      lV->ff	=1.;
      lV->gs	=1e+6/0.825;
      lV->kC	=i;
      lV->kA	=1;
      lV++;
    }
    nVVB	+=n;
  }
  return(0);
}

int VacVAI(FILE *lf)
{
  int i,j,n;
  PSBLOCK *pS;
  char str[64];
  char *lc;
  char *lm;
  char *lv[0x10];
  int dl[0x10];

  lm	="VacV.ai";

  lc	="<Vacuum Vessel>";
  dl[0]	=0;
  dl[1]	=sizeof(PSBLOCK);
  dl[2]	=dl[1];
  dl[3]	=dl[1];
  dl[4]	=dl[1];
  dl[5]	=dl[1];
  dl[6]	=dl[1];
  dl[7]	=dl[1];
  dl[8]	=dl[1];
  dl[9]	=dl[1];
  if(IsKeyWordFound(lf,lm,lc,str,&n)){
    nVVB	=n;
    PFReInitVVB();
    pS		=VVB;
    lv[0]	=(char*)&i;
    lv[1]	=(char*)pS->r;
    lv[2]	=(char*)pS->z;
    lv[3]	=(char*)(pS->r+1);
    lv[4]	=(char*)(pS->z+1);
    lv[5]	=(char*)(pS->r+2);
    lv[6]	=(char*)(pS->z+2);
    lv[7]	=(char*)(pS->r+3);
    lv[8]	=(char*)(pS->z+3);
    lv[9]	=(char*)pS->Nm;
    ReadAI(lf,lc,lm,str,n,lv,dl,10);
    fflush(stdout);
  }
  else{
    CbStr2UserMessage("Error:%s  NO %s section\n",lm,lc);
  }
  lc	="<Vacuum Vessel, cont>";
  if(IsKeyWordFound(lf,lm,lc,str,&n)){
    pS		=VVB;
    lv[0]	=(char*)&i;
    lv[1]	=(char*)&(pS->n1);
    lv[2]	=(char*)&(pS->n2);
    lv[3]	=(char*)&(pS->c);
    lv[4]	=(char*)&(pS->kC);
    lv[5]	=(char*)&(pS->kA);
    lv[6]	=(char*)pS->Nm;
    lv[7]	=(char*)pS->NmC;
    ReadAI(lf,lc,lm,str,n,lv,dl,8);
  }
  else{
    CbStr2UserMessage("Error:%s  NO %s section\n",lm,lc);
    {/*ITER Stuff*/
      double r1[0x100],r2[0x100],z1[0x100],z2[0x100];
      int n1,n2;
      rewind(lf);

      dl[0]	=0;
      dl[1]	=sizeof(double);
      dl[2]	=dl[1];
      lc	="<ITER Inner Vacuum Vessel>";
      if(PFIsKeyWordFound(lf,lm,lc,str,&n)){
	n1	=n;
	lv[0]	=(char*)&i;
	lv[1]	=(char*)r1;
	lv[2]	=(char*)z1;
	PFReadAI(lf,lc,lm,str,n,lv,dl,3);
      }
      else{
	CbStr2UserMessage("VacV.ai: NO %s section",lc);
	return(1);
      }
      lc	="<ITER Outer Vacuum Vessel>";
      if(PFIsKeyWordFound(lf,lm,lc,str,&n)){
	n2	=n;
	lv[0]	=(char*)&i;
	lv[1]	=(char*)r2;
	lv[2]	=(char*)z2;
	PFReadAI(lf,lc,lm,str,n,lv,dl,3);
      }
      else{
	CbStr2UserMessage("VacV.ai: NO %s section",lc);
	return(1);
      }
      RZ2VacV(r1,z1,r2,z2,n1,n2);
    }
  }
  n=-1;
  for(i=0; i < nVVB; i++){
    pS		=VVB+i;
    pS->R	=0.25*(pS->r[0]+pS->r[1]+pS->r[2]+pS->r[3]);
    pS->Z	=0.25*(pS->z[0]+pS->z[1]+pS->z[2]+pS->z[3]);
    pS->dS	=fabs(cr2*((pS->r[2]-pS->r[0])*(pS->z[1]-pS->z[3])
			   +(pS->r[3]-pS->r[1])*(pS->z[2]-pS->z[0])));
    Rv[i]	=pS->R;
    Zv[i]	=pS->Z;
    pS->tn	=1.;
    pS->I	=0.;
    pS->gY	=0.;
    pS->V	=0.;
    pS->ff	=1.;
    pS->gs	=1./7.20e-07;
    pS->gS	=pS->ff*pS->gs*pS->dS/(c2gp*pS->R);
    pS->gS	=pS->ff*pS->gs*pS->dS;
    if(pS->kC != n){
      n		=pS->kC;
      lc	=pS->NmC;
      for(j=0; j < i; j++){
	if(VVB[j].kC == pS->kC) break;
      } 
      if(j < i){
	if(strcmp(VVB[j].NmC,lc)){
	  CbStr2UserMessage("Error:NmC[%d]=<%s> !=<%s>[%d]\n"
			    ,i,lc,VVB[j].NmC,j);
	  printf("Error:NmC[%d]=<%s> !=<%s>[%d]\n",i,lc,VVB[j].NmC,j);
	  return(1);
	}
      }
      if(*pS->NmC == 0) sprintf(pS->NmC,"VVC-%3.3d",pS->kC);
    }
    else{
      strcpy(pS->NmC,lc);
    }
    if(pS->kA == 0) pS->c=0;
  }
  CbStr2UserMessage("Input:%s\n",lm);
  return(0);
}

int PFPrintfVacV()
{
  int i,n,n1,n2;
  char ln[0x80];
  double r[4],z[4],er[4],ez[4],dr,dz;
  PSBLOCK *lS;
  FILE *lF;

  lF	=fopen("VacV.ai","w");
  n=0;
  for(i=0,lS=VVB; i < nVVB; i++,lS++) n+=lS->n1*lS->n2;

  printf("<Vacuum Vessel>[%d]>(%s)\n",n,"%d %e %e %e %e %e %e %e %e %s");
  fprintf(lF,"<Vacuum Vessel>[%d]>(%s)\n",n,"%d %e %e %e %e %e %e %e %e %s");
  printf("! # %7s %7s %7s %7s %7s %7s %7s %7s %s\n",
	  "r[0]","z[0]","r[1]","z[1]","r[2]","z[2]","r[3]","z[3]","Name");
  fprintf(lF,"! # %7s %7s %7s %7s %7s %7s %7s %7s %s\n",
	  "r[0]","z[0]","r[1]","z[1]","r[2]","z[2]","r[3]","z[3]","Name");
  strcpy(ln,"%3d %7.4f %7.4f %7.4f %7.4f %7.4f %7.4f %7.4f %7.4f %s:%dx%d\n");
  n=0;
  for(i=0; i < nVVB; i++){
    lS	=VVB+i;
    er[0]	=(lS->r[1]-lS->r[0])/lS->n1;
    er[1]	=(lS->r[2]-lS->r[1])/lS->n2;
    er[2]	=(lS->r[2]-lS->r[3])/lS->n1;
    er[3]	=(lS->r[3]-lS->r[0])/lS->n2;
    ez[0]	=(lS->z[1]-lS->z[0])/lS->n1;
    ez[1]	=(lS->z[2]-lS->z[1])/lS->n2;
    ez[2]	=(lS->z[2]-lS->z[3])/lS->n1;
    ez[3]	=(lS->z[3]-lS->z[0])/lS->n2;
    dr		=(er[2]-er[0])/lS->n2;
    dz		=(ez[2]-ez[0])/lS->n2;
    for(n1=0; n1 < lS->n1; n1++){
      for(n2=0; n2 < lS->n2; n2++){
	r[0]	=lS->r[0]+n1*er[0]+n2*er[3]+n1*n2*dr;
	r[1]	=r[0]+er[0]+n2*dr;
	r[2]	=r[0]+er[0]+er[3]+(n1+n2+1)*dr;
	r[3]	=r[0]+er[3]+n1*dr;
	z[0]	=lS->z[0]+n1*ez[0]+n2*ez[3]+n1*n2*dz;
	z[1]	=z[0]+ez[0]+n2*dz;
	z[2]	=z[0]+ez[0]+ez[3]+(n1+n2+1)*dz;
	z[3]	=z[0]+ez[3]+n1*dz;
	printf(ln,n,r[0],z[0],r[1],z[1],r[2],z[2],r[3],z[3],lS->Nm,n1,n2);
	fprintf(lF,ln,n,r[0],z[0],r[1],z[1],r[2],z[2],r[3],z[3],lS->Nm,n1,n2);
	n++;
      }
    }
  }
  printf("! # %7s %7s %7s %7s %7s %7s %7s %7s %s\n",
	  "r[0]","z[0]","r[1]","z[1]","r[2]","z[2]","r[3]","z[3]","Name");
  fprintf(lF,"!  # %7s %7s %7s %7s %7s %7s %7s %7s %s\n",
	  "r[0]","z[0]","r[1]","z[1]","r[2]","z[2]","r[3]","z[3]","Name");
  printf("%2d\n",n);


  fprintf(lF,"\n<Vacuum Vessel, cont>[%d](%s)\n"
	  ,n,"%d %d x %d  %d %d %d %s %s");

  strcpy(ln+4,"%2d x %2d %3d %3d %2d %s %s :%dx%d\n");
  fprintf(lF,"! # %7s %3s %3s %2s %s %s\n"
	  ,"Nn x Nt","c","#C","kA","Name","Coil");
  n=0;
  for(i=0; i < nVVB; i++){
    lS	=VVB+i;
    for(n1=0; n1 < lS->n1; n1++){
      for(n2=0; n2 < lS->n2; n2++){
	fprintf(lF,ln,n,1,1,lS->c,lS->kC,lS->kA,lS->Nm,lS->NmC,n1,n2);
	n++;
      }
    }
  }
  fprintf(lF,"! # %7s %3s %3s %2s %s %s\n"
	  ,"Nn x Nt","c","#C","kA","Name","Coil");
  fclose(lF);
  puts("Output: VacV.ai");
  return(0);
}

int PFPrintfVacV0()
{
  int i,n,n1,n2;
  double r[4],z[4],er[4],ez[4],dr,dz;
  PSBLOCK *lS;
  FILE *lF;

  lF	=fopen("VacV.ai","w");

  n=0;
  for(i=0; i < nVVB; i++){
    lS	=VVB+i;

    er[0]	=(lS->r[1]-lS->r[0])/lS->n1;
    er[1]	=(lS->r[2]-lS->r[1])/lS->n2;
    er[2]	=(lS->r[2]-lS->r[3])/lS->n1;
    er[3]	=(lS->r[3]-lS->r[0])/lS->n2;
    ez[0]	=(lS->z[1]-lS->z[0])/lS->n1;
    ez[1]	=(lS->z[2]-lS->z[1])/lS->n2;
    ez[2]	=(lS->z[2]-lS->z[3])/lS->n1;
    ez[3]	=(lS->z[3]-lS->z[0])/lS->n2;
    dr		=(er[2]-er[0])/lS->n2;
    dz		=(ez[2]-ez[0])/lS->n2;
    for(n1=0; n1 < lS->n1; n1++){
      for(n2=0; n2 < lS->n2; n2++){
	r[0]	=lS->r[0]+n1*er[0]+n2*er[3]+n1*n2*dr;
	r[1]	=r[0]+er[0]+n2*dr;
	r[2]	=r[0]+er[0]+er[3]+(n1+n2+1)*dr;
	r[3]	=r[0]+er[3]+n1*dr;
	z[0]	=lS->z[0]+n1*ez[0]+n2*ez[3]+n1*n2*dz;
	z[1]	=z[0]+ez[0]+n2*dz;
	z[2]	=z[0]+ez[0]+ez[3]+(n1+n2+1)*dz;
	z[3]	=z[0]+ez[3]+n1*dz;
	
	printf("%3d%8.4f %7.4f %7.4f %7.4f %7.4f %7.4f %7.4f %7.4f %2d x %2d\n"
	    ,n,r[0],z[0],r[1],z[1],r[2],z[2],r[3],z[3],1,1);
	printf("           %6.2f x%9.2e %3d %2d %s:%dx%d\n"
	       ,lS->ff,lS->gs,n,lS->kA,lS->Nm,n1,n2);
	fprintf(lF,"%3d%8.4f %7.4f %7.4f %7.4f %7.4f %7.4f %7.4f %7.4f"
		" %2d x %2d\n",n,r[0],z[0],r[1],z[1],r[2],z[2],r[3],z[3],1,1);
	fprintf(lF,"           %6.2f x%9.2e %3d %2d %s:%dx%d\n"
	       ,lS->ff,lS->gs,n,lS->kA,lS->Nm,n1,n2);
	n++;
      }
    }
  }
  printf("%3s %7s %7s %7s %7s %7s %7s %7s %7s %7s\n"
	 ,"#","r[0]","z[0]","r[1]","z[1]","r[2]","z[2]","r[3]","z[3]"
	 ,"Nn x Nt");
  printf("          %6s x%9s %3s %3s %2s  %s\n","FF","gs","c","#C","kA","Name");
  printf("%2d\n",n);
  fprintf(lF,"%3s %7s %7s %7s %7s %7s %7s %7s %7s %7s\n"
	 ,"#","r[0]","z[0]","r[1]","z[1]","r[2]","z[2]","r[3]","z[3]"
	 ,"Nn x Nt");
  fprintf(lF,"          %6s x%9s %3s %3s %2s  %s\n"
	  ,"FF","gs","c","C#","kA","Name");
  fprintf(lF,"%2d\n",n);
  fclose(lF);
  puts("Output: VacV.ai");
  return(0);
}

int PFPrintfVacV1()
{
  int i,n,n1,n2;
  double r[4],z[4],er[4],ez[4],dr,dz;
  PSBLOCK *lS;
  FILE *lF;

  lF	=fopen("VacV.ai","w");

  n=0;
  for(i=0; i < nVVB; i++){
    lS	=VVB+i;
    er[0]	=(lS->r[1]-lS->r[0])/lS->n1;
    er[1]	=(lS->r[2]-lS->r[1])/lS->n2;
    er[2]	=(lS->r[2]-lS->r[3])/lS->n1;
    er[3]	=(lS->r[3]-lS->r[0])/lS->n2;
    ez[0]	=(lS->z[1]-lS->z[0])/lS->n1;
    ez[1]	=(lS->z[2]-lS->z[1])/lS->n2;
    ez[2]	=(lS->z[2]-lS->z[3])/lS->n1;
    ez[3]	=(lS->z[3]-lS->z[0])/lS->n2;
    dr		=(er[2]-er[0])/lS->n2;
    dz		=(ez[2]-ez[0])/lS->n2;
    for(n1=0; n1 < lS->n1; n1++){
      for(n2=0; n2 < lS->n2; n2++){
	r[0]	=lS->r[0]+n1*er[0]+n2*er[3]+n1*n2*dr;
	r[1]	=r[0]+er[0]+n2*dr;
	r[2]	=r[0]+er[0]+er[3]+(n1+n2+1)*dr;
	r[3]	=r[0]+er[3]+n1*dr;
	z[0]	=lS->z[0]+n1*ez[0]+n2*ez[3]+n1*n2*dz;
	z[1]	=z[0]+ez[0]+n2*dz;
	z[2]	=z[0]+ez[0]+ez[3]+(n1+n2+1)*dz;
	z[3]	=z[0]+ez[3]+n1*dz;
#ifdef H
printf("%3d %7.4f %7.4f %7.4f %7.4f %7.4f %7.4f %7.4f %7.4f %2d x %2d\n"
	    ,n,r[0],z[0],r[1],z[1],r[2],z[2],r[3],z[3],1,1);
	printf("           %6.2f x%9.2e %3d %2d %s:%dx%d\n"
	       ,lS->ff,lS->gs,n,lS->kA,lS->Nm,n1,n2);
#endif
printf("%3d %7.4f %7.4f %7.4f %7.4f %7.4f %7.4f %6.1f %2d x %2d %s:%d.%d\n"
       ,n
       ,cr4*(r[0]+r[1]+r[2]+r[3])
       ,cr4*(z[0]+z[1]+z[2]+z[3])
       ,r[3]-r[0],r[2]-r[1],z[1]-z[0],z[2]-z[3]
       ,1.0,1,1,lS->Nm,n1,n2);
fprintf(lF,"%3d %7.4f %7.4f %7.4f %7.4f %7.4f %7.4f %6.1f %2d x %2d %s:%d.%d\n"
       ,n
       ,cr4*(r[0]+r[1]+r[2]+r[3])
       ,cr4*(z[0]+z[1]+z[2]+z[3])
       ,r[3]-r[0],r[2]-r[1],z[1]-z[0],z[2]-z[3]
       ,1.0,1,1,lS->Nm,n1,n2);
	n++;
      }
    }
  }
  printf("%3s %7s %7s %7s %7s %7s %7s %7s %7s  %s\n"
	 ,"#","R","Z","w1","w2","h1","h2","Tn","Nn x Nt","Name");
  printf("%2d\n",n);
  fprintf(lF,"%3s %7s %7s %7s %7s %7s %7s %7s %7s  %s\n"
	 ,"#","R","Z","w1","w2","h1","h2","Tn","Nn x Nt","Name");
  fprintf(lF,"%2d\n",n);
  fclose(lF);
  puts("Output: VacV.ai");
  return(0);
}

int PFRefineVacV(double d)
{
  int i,j,k;
  PSBLOCK *lS;
  double dx,dy,s,t;

  for(i=0; i < nVVB; i++){
    lS	=VVB+i;
    dx	=lS->r[1]-lS->r[0];
    dy	=lS->z[1]-lS->z[0];
    s	=dx*dx+dy*dy;
    dx	=lS->r[3]-lS->r[2];
    dy	=lS->z[3]-lS->z[2];
    t	=dx*dx+dy*dy;
    if(t < s) t=s;
    lS->n1	=sqrt(t)/d+1;
    dx	=lS->r[2]-lS->r[1];
    dy	=lS->z[2]-lS->z[1];
    s	=dx*dx+dy*dy;
    dx	=lS->r[0]-lS->r[3];
    dy	=lS->z[0]-lS->z[3];
    t	=dx*dx+dy*dy;
    if(t < s) t=s;
    lS->n2	=sqrt(t)/d+1;
  }
  return(0);
}

int PFVacVessel()
{
  static int ii[2]={0,1},nRef=1;
  int i,j,k,i1,i2;
  PSBLOCK *pS;
  double r[256],z[256],n1[256],n2[256];
  double r1[8],z1[8],s,d,dx,dy;
  int kc[256];

#ifndef AscI_VacV
#undef AscI_VacV
#endif/*AscI_VacV*/
  PFReInitVVB();
  if(nVVB == 0) return(0);
  for(i=0; i < nVVB && i < 256; i++){
    pS		=VVB+i;
    pS->R	=0.25*(pS->r[0]+pS->r[1]+pS->r[2]+pS->r[3]);
    pS->Z	=0.25*(pS->z[0]+pS->z[1]+pS->z[2]+pS->z[3]);
    Rv[i]	=pS->R;
    Zv[i]	=pS->Z;
    r[i]	=Rv[i];
    z[i]	=Zv[i];
    kc[i]	=pS->c;
    n1[i]	=pS->n1;
    n2[i]	=pS->n2;
  }  
  j	=0;
  for(i=0; i < nVVB && i < 2; i++){
    pS		=VVB+ii[i];
    for(k=0; k < 4; k++){
      r1[j]	=pS->r[k];
      z1[j++]	=pS->z[k];
    }
  }
  i1	=ii[0];
  i2	=ii[1];
#ifndef Tbl_VacV
  j	=0;
  for(i=0; i < nVVB && i < 2; i++){
    pS		=VVB+ii[i];
    for(k=0; k < 4; k++){
      pS->r[k]	=r1[j];
      pS->z[k]	=z1[j++];
    }
  }
  
  ii[0]	=i1;
  ii[1]	=i2;
  j	=0;
  for(i=0; i < nVVB && i < 2; i++){
    pS		=VVB+ii[i];
    for(k=0; k < 4; k++){
      r1[j]	=pS->r[k];
      z1[j]	=pS->z[k];
      j++;
    }
  }
  j	=0;
  for(i=0; i < nVVB && i < 256; i++){
    pS		=VVB+i;
    pS->R	=0.25*(pS->r[0]+pS->r[1]+pS->r[2]+pS->r[3]);
    pS->Z	=0.25*(pS->z[0]+pS->z[1]+pS->z[2]+pS->z[3]);
    pS->n1	=n1[i];
    pS->n2	=n2[i];
    Rv[i]	=pS->R;
    Zv[i]	=pS->Z;
    r[i]	=Rv[i];
    z[i]	=Zv[i];
    pS->c	=kc[i];
    pS->kA	=kc[i] ? 1 : 0;
  }  
  CbUserPlot	=VVBPlot;
  if(FlVacVPlot/10 == 3) PFPrintfVacV();
  if(FlVacVPlot/10 == 4){
    d	=0;
    for(i=0; i < nVVB; i++){
      pS	=VVB+i;
      for(k=0,j=3; k < 4; k++){
	dx	=pS->r[k]-pS->r[j];
	dy	=pS->z[k]-pS->z[j];
	s	=dx*dx+dy*dy;
	if(d < s)  d=s;
	j	=k;
      }
    }
    d	=sqrt(d)/nRef;
    PFRefineVacV(d);
    for(i=0; i < nVVB; i++){
      pS	=VVB+i;
      n1[i]	=pS->n1;
      n2[i]	=pS->n2;
    }
  }
  if(FlVacVPlot/10 == 5) PFPrintfVacV1();
#endif/*Tbl_VacV*/
  for(i=0; i < nVVB; i++){
    pS		=VVB+i;
    pS->dS	=fabs(cr2*((pS->r[2]-pS->r[0])*(pS->z[1]-pS->z[3])
			   +(pS->r[3]-pS->r[1])*(pS->z[2]-pS->z[0])));
    pS->gS	=pS->ff*pS->gs*pS->dS/(c2gp*pS->R);
    pS->I	=0.;
    pS->gY	=0.;
    pS->V	=0.;
  }
#ifndef AscO_VacV
#undef AscO_VacV
#endif/*AscO_VacV*/
  memset(&VVWall,'\0',sizeof(WALL));
  memset(&VVTile,'\0',sizeof(WALL));
  return(0);
}
#endif

#ifndef stg_PSElecP
int PFDeInitPSC()
{
  if(NPFC){
    free(VVC);
    NVVC=0;
  }
  return(0);
}

int PFReInitPSC()
{
  if(NVVC < nVVC){
    if(NVVC) PFDeInitPSC();
    VVC	=(PFCOIL*)calloc(nVVC,sizeof(PFCOIL));
    if(VVC == NULL){
      printf("No memory for PSCoils in PFReInitPSC()\n");
      return(1);
    }
    NVVC	=nVVC;
  }
  ESmemlevP |=0x00002000;
  return(0);
}

int PSElecPAO(FILE *lf)
{
  int i,j,L;
  PSBLOCK *lS;
  char str[0x100];
  char ln[0x100];
  char *lc;
  
  L=0;
  for(i=0; i < nVVB; i++){
    j=strlen(VVB[i].Nm);
    if(L < j) L=j;
  }
  sprintf(ln,"%s%d%s","%3d %6.3f x %9.2e %10.3e %9.7f %",L,"s %2d %3d %s%c");
  if(nVVB > 1000) ln[1]='4';
  if(nVVB > 10000) ln[1]='5';
  strcpy(str,ln);
  FormatWrite2Read(str);
  fprintf(lf,"<Vacuum Vessel Electrics>[%d](%s)\n",nVVB,str);
  str[0]='!';
  str[1]='%';
  str[2]=ln[1]-1;
  sprintf(str+3,"%s%d%s","s %6s x %9s %10s %9s %",L,"s %2s %3s %s\n");
  fprintf(lf,str,"#","Form","Electric","Inverse","Current"
	  ,"Block","c","#C","Coil");
  fprintf(lf,str,"","factor","conduct.","Resistance","fraction"
	  ,"Name"," ","","Name");
  fprintf(lf,str,"","","1/(Om*m)","1/Om","",""
	  ," ","","");
  for(i=0; i < nVVB; i++){
    lS	=VVB+i;
    lc	=lS->kA ? VVC[lS->kC].Nm : ">--<";
    fprintf(lf,ln,i,lS->ff,lS->gs,lS->gS,lS->tn,lS->Nm,lS->c,lS->kC,lc,'\n');
  }
  fprintf(lf,str,"#","Form","Electric","Inverse","Current"
	  ,"Block","c","#C","Coil");
  fprintf(lf,str,"","factor","conduct.","Resistance","fraction"
	  ,"Name"," ","","Name");
  fprintf(lf,str,"","","1/(Om*m)","1/Om","",""
	  ,""," ","");
  return(0);
}

int PSElecPAI(FILE *lf,char **NmC)
{
  int j,n;
  PSBLOCK *lS;
  char str[64];
  char *lc;
  char *lm;
  char *lv[0x10];
  int dl[0x10];

  lm	="PSElecP.ai";
  lc	="<Vacuum Vessel Electrics>";
  if(IsKeyWordFound(lf,lm,lc,str,&n)){
    nVVC	=n;
    lS		=VVB;
    lv[0]	=(char*)&n;
    lv[1]	=(char*)&lS->ff;
    lv[2]	=(char*)&lS->gs;
    lv[3]	=(char*)&lS->gS;
    lv[4]	=(char*)&lS->tn;
    lv[5]	=(char*)lS->Nm;
    lv[6]	=(char*)&lS->c;
    lv[7]	=(char*)&lS->kC;
    lv[8]	=(char*)NmC[0];
    dl[0]	=0;
    dl[1]	=sizeof(PSBLOCK);
    dl[2]	=dl[1];
    dl[3]	=dl[1];
    dl[4]	=dl[1];
    dl[5]	=dl[1];
    dl[6]	=dl[1];
    dl[7]	=dl[1];
    dl[8]	=(int)(NmC[1]-NmC[0]);
    ReadAI(lf,lc,lm,str,nVVB,lv,dl,9);
  }
  else{
    CbStr2UserMessage("%s: NO %s section",lm,lc);
    return(1);
  }
  return(0);
}

int PFDeInitGreenScreen()
{
  if(gYpS != NULL){
    int i;

    free(FlPSC);
    i	=12;
    while(i > 0){
      i--;
      free(gYcS[i]);
    }
    i	=EGNp;
    while(i > 0){
      i--;
      free(gYpS[i]);
    }
    free(gYpS);
    gYpS	=NULL;
  }
  return(0);
}

int PFReInitGreenScreen()
{
  static int Np=0,Ns=0;

  if(gYpS == NULL || Np != EGNp || Ns != nVVC){
    int i,k;
    if(Np) PFDeInitGreenScreen();
    Np	=EGNp;
    Ns	=nVVC;
    gYpS	=(double**)malloc(EGNp*sizeof(double*));
    if(gYpS == NULL){
      printf("No memory for %s in %s\n","gYpS","PFReInitGreenScreen()");
      return(1);
    }
    for(i=0; i < EGNp; i++){
      gYpS[i]	=(double*)malloc(nVVC*sizeof(double));
      if(gYpS[i] == NULL){
	printf("No memory for %s[%d] in %s\n","gYpS",i
	       ,"PFReInitGreenScreen()");
	return(1);
      }
    }
    for(i=0; i < 12; i++){
      gYcS[i]	=(double*)malloc(3*nVVC*sizeof(double));
      if(gYcS[i] == NULL){
	printf("No memory for %s[%d] in %s\n","gYcS",i
	       ,"PFReInitGreenScreen()");
	return(1);
      }
      BRcS[i]	=gYcS[i]+nVVC;
      BZcS[i]	=BRcS[i]+nVVC;
    }
    FlPSC	=(int*)malloc(nVVC*sizeof(int));
    for(i=0; i < nVVC; i++){
      FlPSC[i]	=0x0F;
    }
    ESmemlevP	|=0x00008000;
  }
  return(0);
}

int PFSaveLijScreens(FILE *lf)
{
  PSBLOCK *lS;

  int i,n;
  size_t ii,id;

  /* Plasma */
  ii	=(size_t)sizeof(int);
  id	=(size_t)sizeof(double);
  fwrite(NplG,ii,(size_t)2,lf);
  fwrite(RplG,id,(size_t)2,lf);
  fwrite(ZplG,id,(size_t)2,lf);

  /* PSBlocks */
  n	=0;
  for(i=0; i < nVVB; i++){
    if(VVB[i].kA){
      n++;
    }
  }
  fwrite(&n,ii,(size_t)1,lf);
  for(i=0; i < nVVB; i++){
    if(VVB[i].kA){
      lS	=VVB+i;
      fwrite(&lS->kC,ii,(size_t)1,lf);
      fwrite(&lS->r,id,(size_t)4,lf);
      fwrite(&lS->z,id,(size_t)4,lf);
      fwrite(&lS->gS,id,(size_t)1,lf);
      fwrite(&lS->n1,ii,(size_t)1,lf);
      fwrite(&lS->n2,ii,(size_t)1,lf);
    }
  }

  /* Green Functions */
  for(i=0; i < EGNp; i++){
    fwrite(gYpS[i],id,(size_t)nVVC,lf);
  }
  return(0);
}

int SetFlPSC()
{
  int i;
  for(i=0; i < nVVC; i++) FlPSC[i]=0x0F;
  return(0);
}

int PFReadLijScreens(FILE *lf)
{
  PSBLOCK *lS;
  int i,n,m,k[4];
  double s[4];
  size_t ii,id;

  /* Plasma */
  ii	=(size_t)sizeof(int);
  id	=(size_t)sizeof(double);
  m	=fread(k,ii,(size_t)2,lf);
  if(m < 2 || NplG[0] != k[0] || NplG[1] != k[1]){
    FlPlG	|=0x02;
    return(1);
  }
  m	=fread(s,id,(size_t)4,lf);
  if(m < 4 || RplG[0] != s[0] || RplG[1] != s[1] || 
     ZplG[0] != s[2] || ZplG[1] != s[3]){
    FlPlG	|=0x02;
    return(1);
  }

  /* PSBlocks */
  n	=0;
  for(i=0; i < nVVB; i++){
    if(VVB[i].kA){
      n++;
    }
  }

  m	=fread(k,ii,(size_t)1,lf);
  if(m < 1 || n != k[0]){
    SetFlPSC();
    return(1);
  }
  for(i=0; i < nVVC; i++){
    FlPSC[i]	&=0x0E;
  }
  for(i=0; i < nVVB; i++){
    if(VVB[i].kA){
      lS	=VVB+i;
      m	=fread(k,ii,(size_t)1,lf);
      if(m < 1 || lS->kC != k[0]){
	SetFlPSC();
	return(1);
      }
      m	=fread(s,id,(size_t)4,lf);
      if(m < 4){
	SetFlPSC();
	return(1);
      }
      if(lS->r[0] != s[0] || lS->r[1] != s[1] 
	 || lS->r[2] != s[2] || lS->r[3] != s[3]){
	FlPSC[lS->kC]	|=0x01;
      }
      m	=fread(s,id,(size_t)4,lf);
      if(m < 4){
	SetFlPSC();
	return(1);
      }
      if(lS->z[0] != s[0] || lS->z[1] != s[1] 
	 || lS->z[2] != s[2] || lS->z[3] != s[3]){
	FlPSC[lS->kC]	|=0x01;
      }
      m	=fread(s,id,(size_t)1,lf);
      if(m < 1){
	SetFlPSC();
	return(1);
      }
      if(lS->gS != s[0]){
	FlPSC[lS->kC]	|=0x01;
      }
      m	=fread(k,ii,(size_t)2,lf);
      if(m < 2){
	SetFlPSC();
	return(1);
      }
      if(lS->n1 != k[0] || lS->n2 != k[1]){
	FlPSC[lS->kC]	|=0x01;
      }
    }
  }

  /* Green Functions */
  for(i=0; i < EGNp; i++){
    m	=fread(gYpS[i],id,(size_t)nVVC,lf);
    if(m < nVVC){
      SetFlPSC();
      return(1);
    }
  }
  FlPlG	&=0x0D;
  return(0);
}

int PFSetLijScreens()
{
  PSBLOCK *lS;
  char ln[64];

  int m,mr,mz,k,k1,k2,kC;
  int nr0,nz0,n1,n2;
  double r0,z0,r1,z1;
  double r[4],z[4],er[4],ez[4],dr,dz,dS0,dSr,dSz,S,dS;
  double x[4],y[4],ex[4],ey[4],dx,dy,ds0,dSx,dSy;

  double hr0,hz0;
  double R0,Z0,R1,Z1;
  double ss,gY;
  static int nx=4,ny=4;
  
  int ix0,iy0,i1,i2;
  double b,a,c,d;
  double x0,y0,x1,y1,dx0,dy0,dx1,dy1,ga,gaa,gr,grr;

  nx	=4;
  ny	=4;

  ss	=1./(nx*ny);

  nr0	=NplG[0];
  nz0	=NplG[1];
  hr0	=EGdr;
  hz0	=EGdz;
  dx0	=hr0/nx;
  dy0	=hz0/ny;
  a	=dy0/dx0;
  if(a > 3.0){
    d	=.13;
  }
  else{
    if(a >= 2.){
      d	=0.2+0.11*(3.-a);
    }
    else{
      if(a >= 1.6){
	d	=.31+.2*(2.-a);
      }
      else{
	if(a >= 1.){
	  d	=.39+.7167*(1.6-a);
	}
	else{
	  d	=.82;
	}
      }
    }
  }
  for(m=0; m < EGNp; m++){
    for(k=0; k < nVVC; k++){
      if((FlPSC[k]&0x01) || (FlPlG&0x02)){
	gYpS[m][k]	=0.;
      }
    }
  }
  for(k=0; k < nVVB; k++){
    sprintf(ln,"Plasma-PScreens: %4d < %d",k,nVVB);
    ZMessage(ln);
    
    lS	=VVB+k;
    kC	=lS->kC;
    n1	=lS->n1;
    n2	=lS->n2;
    er[0]	=(lS->r[1]-lS->r[0])/n1;
    er[1]	=(lS->r[2]-lS->r[1])/n2;
    er[2]	=(lS->r[2]-lS->r[3])/n1;
    er[3]	=(lS->r[3]-lS->r[0])/n2;
    ez[0]	=(lS->z[1]-lS->z[0])/n1;
    ez[1]	=(lS->z[2]-lS->z[1])/n2;
    ez[2]	=(lS->z[2]-lS->z[3])/n1;
    ez[3]	=(lS->z[3]-lS->z[0])/n2;
    dr	=(er[2]-er[0])/n2;
    dz	=(ez[2]-ez[0])/n2;
    dS0	=2.*(er[0]*ez[3]-ez[0]*er[3]);
    dSr	=(er[0]*(ez[2]-ez[0])-ez[0]*(er[2]-er[0]))/n2;
    dSz	=(er[3]*(ez[2]-ez[0])-ez[3]*(er[2]-er[0]))/n2;
    
    for(m=0; m < EGNp; m++){
      if(VVB[k].kA && ((FlPSC[kC]&0x01) || (FlPlG&0x02))){
	r0	=EGaRp[m];
	z0	=EGaZp[m];
	R0	=r0-cr2*hr0;
	Z0	=z0-cr2*hz0;
	
	S	=0.;
	gY	=0.;
	for(k1=0; k1 < n1; k1++){
	  for(k2=0; k2 < n2; k2++){
	    r1	=lS->r[0]+k1*er[0]+k2*er[3]+k1*k2*dr;
	    r[0]	=r1;
	    r[1]	=r1+er[0]+k2*dr;
	    r[2]	=r1+er[0]+er[3]+(k1+k2+1)*dr;
	    r[3]	=r1+er[3]+k1*dr;
	    z1		=lS->z[0]+k1*ez[0]+k2*ez[3]+k1*k2*dz;
	    z[0]	=z1;
	    z[1]	=z1+ez[0]+k2*dz;
	    z[2]	=z1+ez[0]+ez[3]+(k1+k2+1)*dz;
	    z[3]	=z1+ez[3]+k1*dz;
	    r1		=cr4*(r[0]+r[1]+r[2]+r[3]);
	    z1		=cr4*(z[0]+z[1]+z[2]+z[3]);

	    if(fabs(r0-r1) > 1.1*hr0 || fabs(z0-z1) > 1.1*hz0){
	      dS	=fabs(dS0+(2*k1+1)*dSr-(2*k2+1)*dSz);
	      gY	+=GPring(r0,z0,r1,z1)*dS;
	      S		+=dS;
	    }
	    else{
	      ex[0]	=(r[1]-r[0])/nx;
	      ex[1]	=(r[2]-r[1])/ny;
	      ex[2]	=(r[2]-r[3])/nx;
	      ex[3]	=(r[3]-r[0])/ny;
	      ey[0]	=(z[1]-z[0])/nx;
	      ey[1]	=(z[2]-z[1])/ny;
	      ey[2]	=(z[2]-z[3])/nx;
	      ey[3]	=(z[3]-z[0])/ny;
	      
	      dx	=(ex[2]-ex[0])/ny;
	      dy	=(ey[2]-ey[0])/ny;
	      ds0	=2.*(ex[0]*ey[3]-ey[0]*ex[3]);
	      dSx	=(ex[0]*(ey[2]-ey[0])-ey[0]*(ex[2]-ex[0]))/ny;
	      dSy	=(ex[3]*(ey[2]-ey[0])-ey[3]*(ex[2]-ex[0]))/ny;
	      for(i1=0; i1 < nx; i1++){
		for(i2=0; i2 < ny; i2++){
		  x1	=r[0]+i1*ex[0]+i2*(ex[3]+i1*dx);
		  x[0]	=x1;
		  x[1]	=x1+ex[0]+i2*dx;
		  x[2]	=x1+ex[0]+ex[3]+(i1+i2+1)*dx;
		  x[3]	=x1+ex[3]+i1*dx;
		  y1	=z[0]+i1*ey[0]+i2*(ey[3]+i1*dy);
		  y[0]	=y1;
		  y[1]	=y1+ey[0]+i2*dy;
		  y[2]	=y1+ey[0]+ey[3]+(i1+i2+1)*dy;
		  y[3]	=y1+ey[3]+i1*dy;
		  x1		=cr4*(x[0]+x[1]+x[2]+x[3]);
		  y1		=cr4*(y[0]+y[1]+y[2]+y[3]);
		  dS		=fabs(ds0+(2*i1+1)*dSx-(2*i2+1)*dSy);
		  S		+=dS;
		  
		  x0		=R0+cr2*dx0;
		  for(ix0=0; ix0 < nx; ix0++){
		    y0	=Z0+cr2*dy0;
		    for(iy0=0; iy0 < ny; iy0++){
		      gY	+=GPring(x0,y0,x1,y1)*ss*dS;
		      y0	+=dy0;
		    }
		    x0	+=dx0;
		  }
		}
	      }
	      
	    }
	  }
	}
	gYpS[m][kC]	+=gY*lS->tn/S;
      }
    }
  }
#ifdef H
  for(m=0; m < nPFB; m++){
    for(k=0; k < nVVC; k++){
      gYbS[m][k]	=0.;
    }
  }
  for(k=0; k < nVVB; k++){
    sprintf(ln,"PFBlocks-Screens: %4d < %d",k,nVVB);
    ZMessage(ln);
    lS	=VVB+k;
    kC	=lS->kC;
    n1	=lS->n1;
    n2	=lS->n2;
    er[0]	=(lS->r[1]-lS->r[0])/n1;
    er[1]	=(lS->r[2]-lS->r[1])/n2;
    er[2]	=(lS->r[2]-lS->r[3])/n1;
    er[3]	=(lS->r[3]-lS->r[0])/n2;
    ez[0]	=(lS->z[1]-lS->z[0])/n1;
    ez[1]	=(lS->z[2]-lS->z[1])/n2;
    ez[2]	=(lS->z[2]-lS->z[3])/n1;
    ez[3]	=(lS->z[3]-lS->z[0])/n2;
    dr	=(er[2]-er[0])/n2;
    dz	=(ez[2]-ez[0])/n2;
    dS0	=2.*(er[0]*ez[3]-ez[0]*er[3]);
    dSr	=(er[0]*(ez[2]-ez[0])-ez[0]*(er[2]-er[0]))/n2;
    dSz	=(er[3]*(ez[2]-ez[0])-ez[3]*(er[2]-er[0]))/n2;

    for(m=1; m < nPFB; m++){
      if(VVB[k].kA && (FlPSC[kC] || FlPFC[m])){
	lB	=PFB+m;
	nr0	=lB->nr;
	nz0	=lB->nz;
	hr0	=2.*lB->dR/nr0;
	hz0	=2.*lB->dZ/nz0;
	dx0	=hr0/nx;
	dy0	=hz0/ny;
	a	=dy0/dx0;
	if(a > 3.0){
	  d	=.13;
	}
	else{
	  if(a >= 2.){
	    d	=0.2+0.11*(3.-a);
	  }
	  else{
	    if(a >= 1.6){
	      d	=.31+.2*(2.-a);
	    }
	    else{
	      if(a >= 1.){
		d	=.39+.7167*(1.6-a);
	      }
	      else{
		d	=.82;
	      }
	    }
	  }
	}
	S	=0.;
	gY	=0.;
	for(k1=0; k1 < n1; k1++){
	  for(k2=0; k2 < n2; k2++){
	    r1	=	lS->r[0]+k1*er[0]+k2*er[3]+k1*k2*dr;
	    r[0]	=r1;
	    r[1]	=r1+er[0]+k2*dr;
	    r[2]	=r1+er[0]+er[3]+(k1+k2+1)*dr;
	    r[3]	=r1+er[3]+k1*dr;
	    z1		=lS->z[0]+k1*ez[0]+k2*ez[3]+k1*k2*dz;
	    z[0]	=z1;
	    z[1]	=z1+ez[0]+k2*dz;
	    z[2]	=z1+ez[0]+ez[3]+(k1+k2+1)*dz;
	    z[3]	=z1+ez[3]+k1*dz;
	    r1		=cr4*(r[0]+r[1]+r[2]+r[3]);
	    z1		=cr4*(z[0]+z[1]+z[2]+z[3]);

	    R0	=lB->R-lB->dR;
	    r0	=R0+cr2*hr0;
	    for(mr=0; mr < nr0; mr++){
	      Z0	=lB->Z-lB->dZ;
	      z0	=Z0+cr2*hz0;
	      for(mz=0; mz < nz0; mz++){
		if(fabs(r0-r1) > 1.1*hr0 ||fabs(z0-z1) > 1.1*hz0){
		  dS	=fabs(dS0+(2*k1+1)*dSr-(2*k2+1)*dSz);
		  gY	+=GPring(r0,z0,r1,z1)*dS;
		}
		else{
		  ex[0]	=(r[1]-r[0])/nx;
		  ex[1]	=(r[2]-r[1])/ny;
		  ex[2]	=(r[2]-r[3])/nx;
		  ex[3]	=(r[3]-r[0])/ny;
		  ey[0]	=(z[1]-z[0])/nx;
		  ey[1]	=(z[2]-z[1])/ny;
		  ey[2]	=(z[2]-z[3])/nx;
		  ey[3]	=(z[3]-z[0])/ny;
		  
		  dx	=(ex[2]-ex[0])/ny;
		  dy	=(ey[2]-ey[0])/ny;
		  ds0	=2.*(ex[0]*ey[3]-ey[0]*ex[3]);
		  dSx	=(ex[0]*(ey[2]-ey[0])-ey[0]*(ex[2]-ex[0]))/ny;
		  dSy	=(ex[3]*(ey[2]-ey[0])-ey[3]*(ex[2]-ex[0]))/ny;
		  for(i1=0; i1 < nx; i1++){
		    for(i2=0; i2 < ny; i2++){
		      x1	=r[0]+i1*ex[0]+i2*(ex[3]+i1*dx);
		      x[0]	=x1;
		      x[1]	=x1+ex[0]+i2*dx;
		      x[2]	=x1+ex[0]+ex[3]+(i1+i2+1)*dx;
		      x[3]	=x1+ex[3]+i1*dx;
		      y1	=z[0]+i1*ey[0]+i2*(ey[3]+i1*dy);
		      y[0]	=y1;
		      y[1]	=y1+ey[0]+i2*dy;
		      y[2]	=y1+ey[0]+ey[3]+(i1+i2+1)*dy;
		      y[3]	=y1+ey[3]+i1*dy;
		      x1	=cr4*(x[0]+x[1]+x[2]+x[3]);
		      y1	=cr4*(y[0]+y[1]+y[2]+y[3]);
		      dS	=fabs(ds0+(2*i1+1)*dSx-(2*i2+1)*dSy);
		      S		+=dS;

		      x0	=R0+cr2*dx0;
		      for(ix0=0; ix0 < nx; ix0++){
			y0	=Z0+cr2*dy0;
			for(iy0=0; iy0 < ny; iy0++){
			  a	=x0-x1;
			  b	=y0-y1;
			  if(fabs(x0-x1) < dx0 && fabs(y0-y1) < dy0){
			    ga	=cr2*dy0/x0;
			    gr	=cr2*dx0/x0;
			    gaa	=ga*ga;
			    grr	=gr*gr;
			    a	=4./(ga+gr);
			    b	=(3.*gaa+grr)/24.;
			    c	=4./sqrt(gaa+grr);
			    gY +=cgm0*x0*(log(a)-cr2+b*log(c)+d*gaa*.25)*ss*dS;
			  }
			  else{
			    gY	+=GPring(x0,y0,x1,y1)*ss*dS;
			  }

			  y0	+=dy0;
			}
			x0	+=dx0;
		      }
		    }
		  }
		}
		z0 +=hz0;
		Z0 +=hz0;
	      }
	      r0 +=hr0;
	      R0 +=hr0;
	    }
	  } 
	}
	gYbS[m][kC]	+=gY*lS->tn/(nr0*nz0*S);
      }
    }
  }
#endif
  for(k=0; k < nVVC; k++) FlPSC[k]&=0x0E;
  FlPlG		&=0x0D;
  return(0);
}

int PSBElecPar()
{
  int i,j,k,m,n,nn,nP;
  int kc[nVVB],kC[nVVB],iC[nVVB],kCC[nVVB];
  double R[nVVB],Z[nVVB],gs[nVVB],ff[nVVB],tc[nVVB],s;
  PSBLOCK *lS;
  PFCOIL *lC;
  char *NmC[nVVB],Nm[nVVB][0x10],*lc;

  for(i=0; i < nVVB; i++){
    strcpy(Nm[i],VVB[i].NmC);
    NmC[i]	=Nm[i];
    VVB[i].c	=VVB[i].kA ? (VVB[i].kC)%0x10+1 : 0;
  }
#ifndef AscIPSE
#undef AscIPSE
#endif/*AscIPSE*/

  n	=0;
  for(i=0; i < nVVB; i++){
    if(VVB[i].kA){
      lS	=VVB+i;
      gs[n]	=lS->gs;
      ff[n]	=lS->ff;
      tc[n]	=lS->kC;
      kc[n]	=lS->c;
      NmC[n]	=NmC[i];
      n++;
    }
  }
  if(n == 0) return(0);
#ifndef Tbl_PSElecP 
  CbUserPlot	=VVBPlot;
  n	=0;
  for(i=0; i < nVVB; i++){
    if(VVB[i].kA){
      lS	=VVB+i;
      R[n]	=lS->R;
      Z[n]	=lS->Z;
      VVB[i].c	=kc[n];
      kCC[n]	=tc[n];
      lS->kC	=n;
      n++;
    }
  }

  SVDsortI2I(n,iC,kCC);
  nVVC	=0;
  k	=-1;
  i	=n;
  while(i){
    i--;
    if(k != kCC[i]){
      k=kCC[i];
      lc=NmC[iC[i]];
      nVVC++;
    }
    else{
      strcpy(NmC[iC[i]],lc); 
    }
    kC[iC[i]]=nVVC-1;
    tc[iC[i]]=nVVC-1;
  }
  nP	=n;
#endif/*Tbl_PSElecP*/
  n	=0;
  PFReInitPSC();
  for(i=0; i < nVVB; i++){
    if(VVB[i].kA){
      lS	=VVB+i;
      lS->gs	=gs[n];
      lS->ff	=ff[n];
      lS->gS	=lS->ff*gs[n]*lS->dS/(c2gp*lS->R);
      lS->kC	=kC[n];
      lc	=VVC[kC[n]].Nm;
      if(*lc == '\0') strcpy(lc,NmC[n]);
      lS->kD	=lS->kC;
      n++;
    }
  }
  k	=0;
  for(i=0; i < nVVC; i++){
    lC	=VVC+i;
    lC->kB=kVCB+k;
    s	=0.;
    n	=0;
    for(j=0; j < nVVB; j++){
      if(VVB[j].kA && VVB[j].kC == i){
	kVCB[k++]	=j;
	s	+=VVB[j].gS;
	n++;
      }
    }
    s	=s != 0. ? 1./s : 1.;
    lC->Res	=s;
    lC->kG	=-1;
    m		=lC->kB[0];
    strcpy(VVC[i].NmS,">---<");
    lC->tn	=1.;
    lC->nB	=n;
    lC->gt	=0.;
    lC->I	=0.;
    lC->V	=0.;
    lC->gY	=0.;
    lC->I0	=0.;
    lC->Ie	=0.;
    lC->dI	=0.;
    lC->V0	=0.;
    lC->gY0	=0.;
    lC->Emf	=0.;
    lC->wW	=0.;
    lC->wgY	=0.;
    lC->wI	=0.;
    lC->wR	=0.;
    lC->wV	=0.;
    lC->kA	=1;
    lC->c	=VVB[m].c;
    for(j=0; j < n; j++){
      m	=lC->kB[j];
      VVB[m].tn=VVB[m].gS*s;
    }
  }
#ifndef AscOPSE
#undef AscOPSE
#endif/*AscOPSE*/
  PFReInitGreenScreen();
#ifndef BnrIScr
#undef BnrIScr
#endif/*BnrIScr*/
  PFSetLijScreens();
#ifndef BnrOScr
#undef BnrOScr
#endif/*BnrOScr*/
  return(0);
}
#endif

#ifndef stg_MFProbe
int PFDeInitMFP()
{
  if(NMFP){
    free(MFP);
    NMFP=0;
  }
  return(0);
}

int PFReInitMFP()
{
  if(NMFP < nMFP){
    int i;

    if(NMFP){
      MFP	=(MFPROBE*)realloc((void*)MFP,(nMFP+1)*sizeof(MFPROBE));
    }
    else{
      MFP	=(MFPROBE*)malloc((nMFP+1)*sizeof(MFPROBE));
    }
    if(MFP == NULL){
      printf("No memory for MFProbes in PFReInitMFP()\n");
      return(1);
    }
    if(NMFP){
      void *lv;
      size_t n;

      n	=sizeof(MFPROBE);
      lv=(void*)(MFP+NMFP-1);
      for(i=NMFP; i < nMFP; i++){
	memcpy((void*)(MFP+i),lv,n);
	MFP[i].kA	=0;
      }
    }
    else{
      MFPROBE *lP;
      for(i=NMFP; i < nMFP+1; i++){
	lP	=MFP+i;
	lP->R	=1.;
	lP->Z	=0.;
	lP->R1	=1.;
	lP->Z1	=0.;
	lP->ga	=0.;
	lP->Tr	=0.;
	lP->Tz	=1.;
	lP->s	=1.;
	lP->aErr=0.;
	lP->rErr=0.;
	lP->S	=0.;
	lP->S0	=0.;
	lP->Se	=0.;
	lP->dS	=0.;
	lP->gY	=0.;
	lP->Br	=0.;
	lP->Bz	=0.;
	lP->w	=1e-6;
	lP->kA	=0;
	lP->c	=1;
	lP->kG	=-1;
	sprintf(lP->Nm,"MP-%2d",i);
      }
    }
    NMFP	=nMFP;
  }
  ESmemlevP |=0x00000200;
  return(0);
}	

int MFProbeAO(FILE *lf)
{
  int i,j,L,L1;
  MFPROBE *lP;
  char str[64];
  char ln[128];

  fprintf(lf,"\n<Total Number>[%d]() ! total number of Loops+Saddles+Probles"
	  "+DiamagnLoop+VLoops\n",nMFP);

  strcpy(ln,"%3d %6.4f %7.4f %10.3e %2d %s%c");
  strcpy(str,ln);
  FormatWrite2Read(str);
  fprintf(lf,"<Flux Loops>[%d](%s)\n",nMFL,str);
  fprintf(lf,"!%2s %6s %7s %10s %2s %s\n"," #","R","Z","Vsec/V","kA","Name");
  for(i=0; i < nMFL; i++){
    lP	=MFP+i;
    fprintf(lf,ln,i,ScaleR*lP->R,ScaleR*lP->Z,lP->s,lP->kA,lP->Nm,'\n');
  }
  fprintf(lf,"!%2s %6s %7s %10s %2s %s\n"," #","R","Z","Vsec/V","kA","Name");

  strcpy(ln,"%3d %6.4f %7.4f %6.4f %7.4f %10.3e %2d %s%c");
  strcpy(str,ln);
  FormatWrite2Read(str);
  fprintf(lf,"<Saddle Coils>[%d](%s)\n",nMFS,str);
  fprintf(lf,"!%2s %6s %7s %6s %7s %10s %2s %s\n"," #"
	  ,"R","Z","R1","Z1","Vsec/V","kA","Name");
  for(i=0; i < nMFS; i++){
    lP	=MFS+i;
    fprintf(lf,ln,i,ScaleR*lP->R,ScaleR*lP->Z,lP->R1,ScaleR*lP->Z1,lP->s,lP->kA,lP->Nm,'\n');
  }
  fprintf(lf,"!%2s %6s %7s %6s %7s %10s %2s %s\n"," #"
	  ,"R","Z","R1","Z1","Vsec/V","kA","Name");

  strcpy(ln,"%3d %6.4f %7.4f %9.4f %10.3e %2d %s%c");
  strcpy(str,ln);
  FormatWrite2Read(str);
  fprintf(lf,"<Magnetic Probes>[%d](%s)\n",nMFp,str);
  fprintf(lf,"!%2s %6s %7s %9s %10s %2s %s\n"
	  ," #","R","Z","gA","T/V","kA","Name");
  for(i=0; i < nMFp; i++){
    lP	=MFp+i;
    fprintf(lf,ln,i,ScaleR*lP->R,ScaleR*lP->Z,lP->ga,lP->s,lP->kA,lP->Nm,'\n');
  }
  fprintf(lf,"!%2s %6s %7s %9s %10s %2s %s\n"
	  ," #","R","Z","gA","T/V","kA","Name");

  strcpy(ln,"%3d %10.3e %2d %s%c");
  strcpy(str,ln);
  FormatWrite2Read(str);
  fprintf(lf,"<Diamagnetic Loop>[%d](%s)\n",nMFd,str);
  fprintf(lf,"!%2s %10s %2s %s\n"," #","T/V","kA","Name");
  for(i=0; i < nMFd; i++){
    lP	=MFd+i;
    fprintf(lf,ln,i,lP->s,lP->kA,lP->Nm,'\n');
  }
  fprintf(lf,"!%2s %10s %2s %s\n"," #","T/V","kA","Name");

  strcpy(ln,"%3d %6.4f %7.4f %10.3e %2d %s%c");
  strcpy(str,ln);
  FormatWrite2Read(str);
  fprintf(lf,"<V-Loop>[%d](%s)\n",nMFV,str);
  fprintf(lf,"!%2s %6s %7s %10s %2s %s\n"," #","R","Z","T/V","kA","Name");
  for(i=0; i < nMFV; i++){
    lP	=MFV+i;
    fprintf(lf,ln,i,ScaleR*lP->R,ScaleR*lP->Z,lP->s,lP->kA,lP->Nm,'\n');
  }
  fprintf(lf,"!%2s %6s %7s %10s %2s %s\n"," #","R","Z","T/V","kA","Name");
  return(0);
}

int MFProbeAI(FILE *lf)
{
  int i,j,n;
  MFPROBE *lP;
  char str[64];
  char *lc,*lt;
  char *lm;
  char *lv[12];
  int dl[12];

  lm	="MFProbe.ai";
  lc	="<Total Number>";
  if(IsKeyWordFound(lf,lm,lc,str,&n)){
    if(nMFP < n){
      nMFP	=n;
      PFReInitMFP();
    }
    CbStr2UserMessage("%s:%s\n",lm,lc);
  }
  else{
    CbStr2UserMessage("Warning: %s - NO %s section.\n",lm,lc);
    printf("Warning:%s - NO %s section.\n",lm,lc);
    return(1);
  }

  MFL	=MFP;
  lc	="<Flux Loops>";
  if(IsKeyWordFound(lf,lm,lc,str,&n)){
    nMFL	=n;
    if(n){
      lP		=MFP;
      lv[0]	=(char*)&n;
      lv[1]	=(char*)&lP->R;
      lv[2]	=(char*)&lP->Z;
      lv[3]	=(char*)&lP->s;
      lv[4]	=(char*)&lP->kA;
      lv[5]	=(char*)lP->Nm;
      dl[0]	=0;
      dl[1]	=sizeof(MFPROBE);
      dl[2]	=dl[1];
      dl[3]	=dl[1];
      dl[4]	=dl[1];
      dl[5]	=dl[1];
      ReadAI(lf,lc,lm,str,n,lv,dl,6);
      CbStr2UserMessage("%s:%s\n",lm,lc);
    }
  }
  else{
    CbStr2UserMessage("Error: %s: %s is absent\n",lm,lc);
    printf("Error:%s: %s is absent\n",lm,lc);
    return(1);
  }
  for(i=0; i < nMFL; i++){
    lP	=MFP+i;
    if(lP->s != 0.){
      lP->w	=1.;
    }
    else{
      lP->kA	=0;
      lP->w	=0.;
    }
    lP->ga	=0.;
    lP->gY	=0.;
    lP->Br	=0.;
    lP->Bz	=0.;
    lP->c	=1;
    lP->kG	=-1;
    lP->rErr	=0.01;
    lP->aErr	=0.;
   }
  nMFP	=nMFL;
  MFS	=MFP+nMFL;
  nMFS	=0;
  lc	="<Saddle Coils>";
  if(IsKeyWordFound(lf,lm,lc,str,&n)){
    nMFS	=n;
    if(n){
      lP		=MFS;
      lv[0]	=(char*)&n;
      lv[1]	=(char*)&lP->R;
      lv[2]	=(char*)&lP->Z;
      lv[3]	=(char*)&lP->R1;
      lv[4]	=(char*)&lP->Z1;
      lv[5]	=(char*)&lP->s;
      lv[6]	=(char*)&lP->kA;
      lv[7]	=(char*)lP->Nm;
      dl[0]	=0;
      dl[1]	=sizeof(MFPROBE);
      dl[2]	=dl[1];
      dl[3]	=dl[1];
      dl[4]	=dl[1];
      dl[5]	=dl[1];
      dl[6]	=dl[1];
      dl[7]	=dl[1];
      ReadAI(lf,lc,lm,str,n,lv,dl,8);
      CbStr2UserMessage("%s:%s\n",lm,lc);
    }
  }
  else{
    nMFS	=0;
    CbStr2UserMessage("Info: %s: %s is absent\n",lm,lc);
    rewind(lf);
  }
  for(i=0; i < nMFS; i++){
    lP	=MFS+i;
    n	=lP->kA;
    if(lP->s != 0.){
      lP->w	=1.;
    }
    else{
      lP->kA	=0;
      lP->w	=0.;
    }
    lP->ga	=0.;
    lP->gY	=0.;
    lP->Br	=0.;
    lP->Bz	=0.;
    lP->c	=1;
    lP->kG	=-1;
    lP->rErr	=0.01;
    lP->aErr	=0.;
  }

  nMFP	+=nMFS;
  nMFLS	=nMFL+nMFS;
  MFp	=MFS+nMFS;
  nMFp	=0;
  lc	="<Magnetic Probes>";
  if(IsKeyWordFound(lf,lm,lc,str,&n)){
    nMFp	=n;
    if(n){
      lP		=MFp;
      lv[0]	=(char*)&n;
      lv[1]	=(char*)&lP->R;
      lv[2]	=(char*)&lP->Z;
      lv[3]	=(char*)&lP->ga;
      lv[4]	=(char*)&lP->s;
      lv[5]	=(char*)&lP->kA;
      lv[6]	=(char*)lP->Nm;
      dl[0]	=0;
      dl[1]	=sizeof(MFPROBE);
      dl[2]	=dl[1];
      dl[3]	=dl[1];
      dl[4]	=dl[1];
      dl[5]	=dl[1];
      dl[6]	=dl[1];
      ReadAI(lf,lc,lm,str,n,lv,dl,7);
      CbStr2UserMessage("%s:%s\n",lm,lc);
    }
  }
  else{
    CbStr2UserMessage("Error: %s: %s is absent\n",lm,lc);
    printf("Error:%s: %s is absent\n",lm,lc);
    return(1);
  }
  for(i=0; i < nMFp; i++){
    lP	=MFp+i;
    if(lP->s != 0.){
      lP->w	=1.;
    }
    else{
      lP->kA	=0;
      lP->w	=0.;
    }
    lP->Tr	=cos(lP->ga*cgp/180.);
    lP->Tz	=sin(lP->ga*cgp/180.);
    lP->gY	=0.;
    lP->Br	=0.;
    lP->Bz	=0.;
    lP->c	=1;
    lP->kG	=-1;
    lP->rErr	=0.01;
    lP->aErr	=0.;
  }
  nMFP	+=nMFp;
  MFd	=MFp+nMFp;
  nMFd	=0;
  lc	="<Diamagnetic Loop>";
  if(IsKeyWordFound(lf,lm,lc,str,&n)){
    nMFd	=n;
    if(n){
      lP	=MFd;
      lv[0]	=(char*)&n;
      lv[1]	=(char*)&lP->s;
      lv[2]	=(char*)&lP->kA;
      lv[3]	=(char*)lP->Nm;
      dl[0]	=0;
      dl[1]	=sizeof(MFPROBE);
      dl[2]	=dl[1];
      dl[3]	=dl[1];
      ReadAI(lf,lc,lm,str,n,lv,dl,4);
      CbStr2UserMessage("%s:%s\n",lm,lc);
    }
  }
  else{
    CbStr2UserMessage("Info: %s: %s is absent\n",lm,lc);
    printf("Error:%s - NO %s section.\n",lm,lc);
    rewind(lf);
  }
  for(i=0; i < nMFd; i++){
    lP	=MFd+i;
    if(lP->s != 0.) lP->w=1.;
    lP->c	=1;
    lP->kG	=-1;
    lP->rErr	=0.01;
    lP->aErr	=0.;
  }
  nMFP	+=nMFd;
  nMFV	=0;
  MFV	=MFd+nMFd;
  lc	="<V-Loop>";
  if(IsKeyWordFound(lf,lm,lc,str,&n)){
    nMFV	=n;
    if(n){
      lP	=MFV;
      lv[0]	=(char*)&n;
      lv[1]	=(char*)&lP->R;
      lv[2]	=(char*)&lP->Z;
      lv[3]	=(char*)&lP->s;
      lv[4]	=(char*)&lP->kA;
      lv[5]	=(char*)lP->Nm;
      dl[0]	=0;
      dl[1]	=sizeof(MFPROBE);
      dl[2]	=dl[1];
      dl[3]	=dl[1];
      dl[4]	=dl[1];
      dl[5]	=dl[1];
      ReadAI(lf,lc,lm,str,n,lv,dl,6);
      CbStr2UserMessage("%s:%s\n",lm,lc);
    }
  }
  else{
    rewind(lf);
    CbStr2UserMessage("Info: %s: %s is absent",lm,lc);
    printf("Error:%s - NO %s section.\n",lm,lc);
  }
  for(i=0; i < nMFV; i++){
    lP	=MFV+i;
    if(lP->s != 0.) lP->w=1.;
    lP->c	=1;
    lP->kG	=-1;
    lP->rErr	=0.01;
    lP->aErr	=0.;
  }
  nMFP	+=nMFV;
  CbStr2UserMessage("Input:%s\n",lm);
  return(0);
}

int PFDeInitGreenProbes()
{
  if(gYip != NULL){
    int i;
    free(aSip);
    i	=nMFP;
    while(i > 0){
      i--;
      free(gYip[i]);
    }
    free(gYip);
  }
  return(0);
}

int PFReInitGreenProbes()
{
  static int kgY=0,kPl=0,kS=0;

  if(gYip == NULL || kgY != nMFP || kPl != EGNp || kS != nVVC){
    int i;
    if(gYip != NULL) PFDeInitGreenProbes();
    gYip	=(double**)malloc(2*nMFP*sizeof(double*));
      
    if(gYip == NULL){
      printf("No memory for %s in  %s\n","gYip","PFReInitGreenProbes");
      return(1);
    }
    gYiS	=gYip+nMFP;
    for(i=0; i < nMFP; i++){
      gYip[i]	=(double*)malloc((EGNp+nVVC)*sizeof(double));
      if(gYip[i] == NULL){
	printf("No memory for %s[%d] in  %s\n","gYip",i,"PFReInitGreenProbes");
	return(1);
      }
      gYiS[i]	=gYip[i]+EGNp;
    }
    aSip	=(double*)malloc(4*nMFP*sizeof(double));
    if(aSip == NULL){
      printf("No memory for %s in  %s\n","aSip","PFReInitGreenProbes");
      return(1);
    }
    aSiC	=aSip+nMFP;
    aSi		=aSiC+nMFP;
    daSi	=aSi+nMFP;

    kgY	=nMFP;
    kPl	=EGNp;
    kS	=nVVC;
    ESmemlevP	|=0x00010000;
    FlMFP	=0x0F;
  }
  return(0);
}

int PFSaveLijProbes(FILE *lf)
{
  PSBLOCK *lS;
  int i,n;
  size_t kD,kI;

  kI	=(size_t)sizeof(int);
  kD	=(size_t)sizeof(double);

  /* Plasma */
  fwrite(NplG,kI,(size_t)2,lf);
  fwrite(RplG,kD,(size_t)2,lf);
  fwrite(ZplG,kD,(size_t)2,lf);

  /* PSBlocks */
  n	=0;
  for(i=0; i < nVVB; i++){
    if(VVB[i].kA){
      n++;
    }
  }
  fwrite(&n,sizeof(int),(size_t)1,lf);
  for(i=0; i < nVVB; i++){
    if(VVB[i].kA){
      lS	=VVB+i;
      fwrite(&lS->kC,kI,(size_t)1,lf);
      fwrite(&lS->r,kD,(size_t)4,lf);
      fwrite(&lS->z,kD,(size_t)4,lf);
      fwrite(&lS->gS,kD,(size_t)1,lf);
      fwrite(&lS->n1,kI,(size_t)1,lf);
      fwrite(&lS->n2,kI,(size_t)1,lf);
    }
  }

  /* Probes */
  fwrite(&nMFL,kI,(size_t)1,lf);
  fwrite(&nMFS,kI,(size_t)1,lf);
  fwrite(&nMFp,kI,(size_t)1,lf);
  for(i=0; i < nMFL; i++){
    fwrite(&MFL[i].R,kD,(size_t)1,lf);
    fwrite(&MFL[i].Z,kD,(size_t)1,lf);
  }
  for(i=0; i < nMFS; i++){
    fwrite(&MFS[i].R,kD,(size_t)1,lf);
    fwrite(&MFS[i].Z,kD,(size_t)1,lf);
    fwrite(&MFS[i].R1,kD,(size_t)1,lf);
    fwrite(&MFS[i].Z1,kD,(size_t)1,lf);
  }
  for(i=0; i < nMFp; i++){
    fwrite(&MFp[i].R,kD,(size_t)1,lf);
    fwrite(&MFp[i].Z,kD,(size_t)1,lf);
    fwrite(&MFp[i].Tr,kD,(size_t)1,lf);
    fwrite(&MFp[i].Tz,kD,(size_t)1,lf);
  }

  /* Green Functions */
#ifdef H 
  for(i=0; i < nMFP; i++){
    fwrite(gYip[i],kD,(size_t)EGNp,lf);
  }
  for(i=0; i < nMFP; i++){
    fwrite(gYiS[i],kD,(size_t)nVVC,lf);
  }
#endif

  n	=nMFLS+nMFp;
  for(i=0; i < n; i++){
    fwrite(gYip[i],kD,(size_t)EGNp,lf);
  }
  for(i=0; i < n; i++){
    fwrite(gYiS[i],kD,(size_t)nVVC,lf);
  }
  return(0);
}

int PFReadLijProbes(FILE *lf)
{
  PSBLOCK *lS;
  int i,n,nC,m,k[4];
  double s[4];
  size_t kD,kI;

  kI	=(size_t)sizeof(int);
  kD	=(size_t)sizeof(double);

  /* Plasma */
  m	=fread(k,kI,(size_t)2,lf);
  if(m < 2 || NplG[0] != k[0] || NplG[1] != k[1]){
    FlMFP	|=0x03;
    return(1);
  }
  m	=fread(s,kD,(size_t)4,lf);
  if(m < 4 || RplG[0] != s[0] || RplG[1] != s[1] || 
     ZplG[0] != s[2] || ZplG[1] != s[3]){
    FlMFP	|=0x03;
    return(1);
  }

  /* PSBlocks */
  n	=0;
  for(i=0; i < nVVB; i++){
    if(VVB[i].kA){
      n++;
    }
  }

  m	=fread(k,kI,(size_t)1,lf);
  if(m < 1 || n != k[0]){
    FlMFP	|=0x02;
    return(1);
  }

  for(i=0; i < nVVB; i++){
    if(VVB[i].kA){
      lS	=VVB+i;
      m	=fread(k,kI,(size_t)1,lf);
      if(m < 1 || lS->kC != k[0]){
	FlMFP	|=0x02;
	return(1);
      }
      m	=fread(s,kD,(size_t)4,lf);
      if(m < 4){
	FlMFP	|=0x02;
	return(1);
      }
      if(lS->r[0] != s[0] || lS->r[1] != s[1] 
	 || lS->r[2] != s[2] || lS->r[3] != s[3]){
	FlMFP	|=0x02;
	return(1);
      }
      m	=fread(s,kD,(size_t)4,lf);
      if(m < 4){
	FlMFP	|=0x02;
	return(1);
      }
      if(lS->z[0] != s[0] || lS->z[1] != s[1] 
	 || lS->z[2] != s[2] || lS->z[3] != s[3]){
	FlMFP	|=0x02;
	return(1);
      }
      m	=fread(s,kD,(size_t)1,lf);
      if(m < 1){
	FlMFP	|=0x02;
	return(1);
      }
      if(lS->gS != s[0]){
	FlMFP	|=0x02;
	return(1);
      }
      m	=fread(k,kI,(size_t)2,lf);
      if(m < 2){
	FlMFP	|=0x02;
	return(1);
      }
      if(lS->n1 != k[0] || lS->n2 != k[1]){
	FlMFP	|=0x02;
	return(1);
      }
    }
  }

  /* Probes */
  m	=fread(k,kI,(size_t)3,lf);
  if(m < 1 || k[0] != nMFL || k[1] != nMFS || k[2] != nMFp){
    FlMFP	|=0x04;
    return(1);
  }
  for(i=0; i < nMFL; i++){
    m	=fread(s,kD,(size_t)2,lf);
    if(m < 2 || s[0] != MFL[i].R || s[1] != MFL[i].Z){
      FlMFP	|=0x04;
      return(1);
    }
  }
  for(i=0; i < nMFS; i++){
    m	=fread(s,kD,(size_t)4,lf);
    if(m < 2 || s[0] != MFS[i].R || s[1] != MFS[i].Z || 
       s[2] != MFS[i].R1 || s[3] != MFS[i].Z1){
      FlMFP	|=0x04;
      return(1);
    }
  }
  for(i=0; i < nMFp; i++){
    m	=fread(s,kD,(size_t)4,lf);
    if(m < 2 || s[0] != MFp[i].R || s[1] != MFp[i].Z || 
       s[2] != MFp[i].Tr || s[3] != MFp[i].Tz){
      FlMFP	|=0x04;
      return(1);
    }
  }

  /* Green Functions */
  n=nMFLS+nMFp;
  for(i=0; i < n; i++){
    m	=fread(gYip[i],kD,(size_t)EGNp,lf);
    if(m < EGNp){
      FlMFP	|=0x03;
      return(1);
    }
  }
  FlPlG	&=0x0B;
  FlMFP	&=0x0E;
  for(i=0; i < n; i++){
    m	=fread(gYiS[i],kD,(size_t)nVVC,lf);
    if(m < nVVC){
      FlMFP	|=0x02;
      return(1);
    }
  }
  FlMFP	&=0x0D;
  return(0);
}

int PFSetLijProbes()
{
  char ln[32];
  PSBLOCK *lS;
  MFPROBE *lP;
  int i,i1,i2,k,k1,k2;
  int n1,n2,N;
  double r0,z0,r1,z1,gr;
  double R1,Z1;
  double s,ss,gY,Br,Bz,gy,br,bz,Tr,Tz;

  static int nx=4,ny=4;
  
  double r[4],z[4],er[4],ez[4],dr,dz,dS0,dSr,dSz,S,dS;
  double x[4],y[4],ex[4],ey[4],dx,dy,ds0,dSx,dSy;

  int ix1,iy1;
  double x1,y1,dx1,dy1;

  dx1	=EGdr/nx;
  dy1	=EGdz/ny;
  ss	=(double)1./(nx*ny);

  N	=nMFLS+nMFp;
  if((FlMFP&0x01) || (FlPlG&0x04)){
    for(i=0; i < N; i++){
      sprintf(ln,"Probes-Plasma: %4d < %d",i,N);
      ZMessage(ln);
      lP	=MFP+i;
      r0	=lP->R;
      z0	=lP->Z;
      Tr	=lP->Tr; 
      Tz	=lP->Tz;
      for(k=0; k < EGNp; k++){
	gY	=0.;
	Br	=0.;
	Bz	=0.;
	r1	=EGaRp[k];
	z1	=EGaZp[k];
	R1	=r1-cr2*EGdr;
	Z1	=z1-cr2*EGdz;
	if(fabs(r0-r1) > 1.2*EGdr || fabs(z0-z1) > 1.2*EGdz){
	  MFring(&gy,&br,&bz,r0,z0,r1,z1,(double)1.);
	  gY	+=gy;
	  Br	+=br;
	  Bz	+=bz;
	  if(lP->kA == 2){
	    MFring(&gy,&br,&bz,lP->R1,lP->Z1,r1,z1,(double)1.);
	    gY	-=gy;
	    Br	-=br;
	    Bz	-=bz;
	  }
	}
	else{
	  x1	=R1+cr2*dx1;
	  for(ix1=0; ix1 < nx; ix1++){
	    y1	=Z1+cr2*dy1;
	    for(iy1=0; iy1 < ny; iy1++){
	      MFring(&gy,&br,&bz,r0,z0,x1,y1,ss);
	      gY	+=gy;
	      Br	+=br;
	      Bz	+=bz;
	      if(lP->kA == 2){
		MFring(&gy,&br,&bz,lP->R1,lP->Z1,x1,y1,ss);
		gY	-=gy;
		Br	-=br;
		Bz	-=bz;
	      }
	      y1	+=dy1;
	    }
	    x1	+=dx1;
	  }
	}
	gYip[i][k]	=lP->kA < 3 ? gY : Br*Tr+Bz*Tz;
      }
    }
    FlPlG	&=0x0B;
    FlMFP	&=0x0E;
  }
  if((FlMFP&0x02)){
    for(i=0; i < N; i++) memset(gYiS[i],0,nVVC*sizeof(double));
    for(k=0; k < nVVB; k++){
      sprintf(ln,"Probes-Screens: %4d < %d",k,nVVB);
      ZMessage(ln);
      if(VVB[k].kA){
	lS	=VVB+k;
	n1	=lS->n1;
	n2	=lS->n2;
	er[0]	=(lS->r[1]-lS->r[0])/n1;
	er[1]	=(lS->r[2]-lS->r[1])/n2;
	er[2]	=(lS->r[2]-lS->r[3])/n1;
	er[3]	=(lS->r[3]-lS->r[0])/n2;
	ez[0]	=(lS->z[1]-lS->z[0])/n1;
	ez[1]	=(lS->z[2]-lS->z[1])/n2;
	ez[2]	=(lS->z[2]-lS->z[3])/n1;
	ez[3]	=(lS->z[3]-lS->z[0])/n2;
	dr	=(er[2]-er[0])/n2;
	dz	=(ez[2]-ez[0])/n2;
	dS0	=2.*(er[0]*ez[3]-ez[0]*er[3]);
	dSr	=(er[0]*(ez[2]-ez[0])-ez[0]*(er[2]-er[0]))/n2;
	dSz	=(er[3]*(ez[2]-ez[0])-ez[3]*(er[2]-er[0]))/n2;
	gr	=1.1*sqrt(fabs(dS0));
	for(i=0; i < N; i++){
	  lP	=MFP+i;
	  r0	=lP->R;
	  z0	=lP->Z;
	  Tr	=lP->Tr; 
	  Tz	=lP->Tz;
	  S	=0.;
	  gY	=0.;
	  Br	=0.;
	  Bz	=0.;
	  for(k1=0; k1 < n1; k1++){
	    for(k2=0; k2 < n2; k2++){
	      r1	=lS->r[0]+k1*er[0]+k2*er[3]+k1*k2*dr;
	      r[0]	=r1;
	      r[1]	=r1+er[0]+k2*dr;
	      r[2]	=r1+er[0]+er[3]+(k1+k2+1)*dr;
	      r[3]	=r1+er[3]+k1*dr;
	      z1	=lS->z[0]+k1*ez[0]+k2*ez[3]+k1*k2*dz;
	      z[0]	=z1;
	      z[1]	=z1+ez[0]+k2*dz;
	      z[2]	=z1+ez[0]+ez[3]+(k1+k2+1)*dz;
	      z[3]	=z1+ez[3]+k1*dz;
	      r1	=cr4*(r[0]+r[1]+r[2]+r[3]);
	      z1	=cr4*(z[0]+z[1]+z[2]+z[3]);

	      if(fabs(r0-r1) > gr || fabs(z0-z1) > gr){
		dS	=fabs(dS0+(2*k1+1)*dSr-(2*k2+1)*dSz);
		MFring(&gy,&br,&bz,r0,z0,r1,z1,dS);
		gY	+=gy;
		Br	+=br;
		Bz	+=bz;
		if(lP->kA == 2){
		  MFring(&gy,&br,&bz,lP->R1,lP->Z1,r1,z1,dS);
		  gY	-=gy;
		  Br	-=br;
		  Bz	-=bz;
		}
		S		+=dS;
	      }
	      else{
		ex[0]	=(r[1]-r[0])/nx;
		ex[1]	=(r[2]-r[1])/ny;
		ex[2]	=(r[2]-r[3])/nx;
		ex[3]	=(r[3]-r[0])/ny;
		ey[0]	=(z[1]-z[0])/nx;
		ey[1]	=(z[2]-z[1])/ny;
		ey[2]	=(z[2]-z[3])/nx;
		ey[3]	=(z[3]-z[0])/ny;
		dx	=(ex[2]-ex[0])/ny;
		dy	=(ey[2]-ey[0])/ny;
		ds0	=2.*(ex[0]*ey[3]-ey[0]*ex[3]);
		dSx	=(ex[0]*(ey[2]-ey[0])-ey[0]*(ex[2]-ex[0]))/ny;
		dSy	=(ex[3]*(ey[2]-ey[0])-ey[3]*(ex[2]-ex[0]))/ny;
		for(i1=0; i1 < nx; i1++){
		  for(i2=0; i2 < ny; i2++){

		    x1	=r[0]+i1*ex[0]+i2*(ex[3]+i1*dx);
		    x[0]	=x1;
		    x[1]	=x1+ex[0]+i2*dx;
		    x[2]	=x1+ex[0]+ex[3]+(i1+i2+1)*dx;
		    x[3]	=x1+ex[3]+i1*dx;
		    y1	=z[0]+i1*ey[0]+i2*(ey[3]+i1*dy);
		    y[0]	=y1;
		    y[1]	=y1+ey[0]+i2*dy;
		    y[2]	=y1+ey[0]+ey[3]+(i1+i2+1)*dy;
		    y[3]	=y1+ey[3]+i1*dy;
		    x1	=cr4*(x[0]+x[1]+x[2]+x[3]);
		    y1	=cr4*(y[0]+y[1]+y[2]+y[3]);
		    dS	=fabs(ds0+(2*i1+1)*dSx-(2*i2+1)*dSy);
		    S	+=dS;
		    MFring(&gy,&br,&bz,r0,z0,x1,y1,dS);
		    gY	+=gy;
		    Br	+=br;
		    Bz	+=bz;
		    if(lP->kA == 2){
		      MFring(&gy,&br,&bz,lP->R1,lP->Z1,x1,y1,dS);
		      gY	-=gy;
		      Br	-=br;
		      Bz	-=bz;
		    }
		  }
		}
	      }
	    }
	  }
	  s	=lS->tn/S;
	  gYiS[i][lS->kC]	+=lP->kA < 3 ? gY*s : (Br*Tr+Bz*Tz)*s;
	}
      }
    }
    for(i=0; i < nVVC; i++) FlPSC[i]&=0x0B;
    FlMFP	&=0x0D;
  }
  return(0);
}

static int kMFPPlot=0;
void MFPPlot()
{
  int i,ii,j,k,kk,L,m;
  char *lc,ln[0x40];
  double x[2],y[2],tx,ty,s;
  double xi,yi,wi,xj,yj,wj;
  extern double PSfh;
  extern int wF,hF,wFHelp,hFHelp;
  double fh;
  MFPROBE *lP;
  double xS[nMFP+nMFS],yS[nMFP+nMFS],wS[nMFP+nMFS];
  double sx,sy,d,h;
	
  VVBPlot();
  ZColor(4);
  ZPlotPolyLine(ESRLm,ESZLm,ESnLm);
  CbGetScale(&sx,&sy);
  fh	=PSfh;
  PSfh	=7.;
  for(i=0; i < nMFP; i++){
    lP	=MFP+i;
    switch(lP->kA){
    case 0:
      break;
    case 1:
      j	=0;
      m	=i;
      ZPlotIntRect(lP->R,lP->Z,2,2,j);
      break;
    case 2:
      j	=4;
      m	=i-nMFL;
      d	=0.04;
      ZColor(14);
      if(strncmp(lP->Nm,"SX",2) == 0){
	d	=0.4;
	x[0]	=0.5*(lP->R+lP->R1);
	y[0]	=0.5*(lP->Z+lP->Z1);
	L=sprintf(ln,"%s",lP->Nm);
	ZPlotLUString(x[0],y[0],ln,L);
      }
      ZColor(4);
      ZPlotIntRect(lP->R,lP->Z,2,2,j);
      ZPlotIntRect(lP->R1,lP->Z1,2,2,j);
      tx	=lP->R1-lP->R;
      ty	=lP->Z1-lP->Z;
      s		=1./sqrt(tx*tx+ty*ty);
      tx	*=s;
      ty	*=s;
      x[0]	=lP->R;
      x[1]	=lP->R+d*tx;
      y[0]	=lP->Z;
      y[1]	=lP->Z+d*ty;
      ZNewPath();
      ZPlotLine(x[0],y[0],x[1],y[1]);
      x[0]	=lP->R1;
      x[1]	=lP->R1-d*tx;
      y[0]	=lP->Z1;
      y[1]	=lP->Z1-d*ty;
      ZPlotLine(x[0],y[0],x[1],y[1]);
      x[0]	=lP->R1-d*tx-0.25*d*ty;
      x[1]	=lP->R1-d*tx+0.25*d*ty;
      y[0]	=lP->Z1-d*ty+0.25*d*tx;
      y[1]	=lP->Z1-d*ty-0.25*d*tx;
      ZPlotLine(x[0],y[0],x[1],y[1]);
      ZStroke();
      break;
    case 3:
      j	=14;
      m	=i-nMFLS;
      ZPlotIntRect(lP->R,lP->Z,2,2,j);
      x[0]	=lP->R;
      x[1]	=lP->R+0.04*lP->Tr;
      y[0]	=lP->Z;
      y[1]	=lP->Z+0.04*lP->Tz;
      ZNewPath();
      ZPlotLine(x[0],y[0],x[1],y[1]);
      ZStroke();
      break;
    default :
      break;
    }
  } 

  LImgMFP=strlen(ImgMFP);
  ZColor(0);
  d	=0.5*wF/sx;
  h	=0.5*hF/fabs(sy);
  ii=0;
  for(i=0,lP=MFP; i < nMFP; i++,lP++){
    k	=lP->kA < 3 ? lP->kA : 4;
    if((k&kMFPPlot) && IfHasImage(lP->Nm)){
      j	=i < nMFLS ? i : i-nMFLS;
      L=sprintf(ln,"%s.%d",lP->Nm,j+1);
      lc	=ln;
      lc	=lP->Nm;
      L	=strlen(lc);
#ifdef H
#endif
      xS[ii]=lP->R+d;
      yS[ii]=lP->Z;
      wS[ii]=L*wF/sx;
      j	=0;
      yi=yS[ii];
      xi=xS[ii];
      wi=wS[ii];
      while(j < ii){
	yj=yS[j];
	xj=xS[j];
	wj=wS[j];
	if(yi < yj+h  && yi+h > yj && xi < xj+wj && xi+wi > xj){
	  yS[ii]=yj+h*1.001;
	  yi=yS[ii];
	  j	=0;
	}
	else{
	  j++;
	}
      }
#ifdef H
#endif
      ZPlotLUString(xS[ii],yS[ii],lc,L);
      ii++;
      if(lP->kA == 2){
	xS[ii]=lP->R1+d;
	yS[ii]=lP->Z1;
	wS[ii]=L*wF/sx;
	j	=0;
	while(j < ii){
	  if(yS[ii] < yS[j]+h && yS[ii]+h > yS[j] && xS[ii] < xS[j]+wS[j] && 
	     xS[ii]+wS[ii] > xS[j]){
	    yS[ii]+=h;
	    j	=0;
	  }
	  else{
	    j++;
	  }
	}
#ifdef H
#endif
	ZPlotLUString(xS[ii],yS[ii],lc,L);
	ii++;

      }
    }
  }
  PSfh	=fh;
}
    
int MFProbe()
{
  static int Fl=-1,Fl1=-1;
  double Rp[256],Zp[256],ga;
  char *Nm[256];
  int i,j,k[256],n,nL,nS,nP,ind;
  MFPROBE *lP;
  PFReInitMFP();
#ifndef Tbl_MFProbe
  if(Fl == -1){
#ifndef AscIMFProbe
#undef AscIMFProbe
#endif/*AscIMFProbe*/
    Fl	=0;
  }
  kMFPPlot = Fl == 0 ? 0 : Fl&0x0F;
  nL	=nMFL;
  nS	=nMFS;
  nP	=nMFp;
  j	=0;
  if(Fl == 0 || (Fl&0x01)){
    lP	=MFL;
    for(i=0; i < nMFL; i++){
      if(Fl1 == Fl){
	lP->R	=Rp[j];
	lP->Z	=Zp[j];
	lP->kA	=k[j];
      }
      else{
	Rp[j]	=lP->R;
	Zp[j]	=lP->Z;
	k[j]	=lP->kA;
      }
      Nm[j]	=lP->Nm;
      j++;
      lP++;
    }
  }
  if((Fl&0x02)){
    lP	=MFS;
    for(i=0; i < nMFS; i++){
      if(Fl1 == Fl){
	lP->R	=Rp[j];
	lP->Z	=Zp[j];
	lP->kA	=k[j];
      }
      else{
	Rp[j]	=lP->R;
	Zp[j]	=lP->Z;
	k[j]	=lP->kA;
      }
      Nm[j]	=lP->Nm;
      j++;
      if(Fl1 == Fl){
	lP->R1	=Rp[j];
	lP->Z1	=Zp[j];
	lP->kA	=k[j];
      }
      else{
	Rp[j]	=lP->R1;
	Zp[j]	=lP->Z1;
	k[j]	=lP->kA;
      }
      Nm[j]	=lP->Nm;
      lP++;
    }
  }
  if((Fl&0x04)){
    lP	=MFp;
    for(i=0; i < nMFp; i++){
      if(Fl1 == Fl){
	lP->R	=Rp[j];
	lP->Z	=Zp[j];
	lP->kA	=k[j];
      }
      else{
	Rp[j]	=lP->R;
	Zp[j]	=lP->Z;
	k[j]	=lP->kA;
      }
      Nm[j]	=lP->Nm;
      j++;
      lP++;
    }
  }
  Fl1=Fl;
  CbUserPlot	=MFPPlot;
#endif/*Tbl_MFProbe*/
  nMFLS	=nMFL+nMFS;

#ifndef AscOMFProbe
#undef AscOMFProbe
#endif/*AscOMFProbe*/
  PFReInitGreenProbes();
  ind	=1;
#ifndef BnrIMFProbe
#undef BnrIMFProbe
#endif/*BnrIMFProbe*/
  if(ind) PFSetLijProbes();
#ifndef BnrOMFProbe
#undef BnrOMFProbe
#endif/*BnrOMFProbe*/
  return(0);
}
#endif

#ifndef stg_PFBlocks
int DefaultPFB()
{
  int i,j,k;
  double Rcse,Rcsi,Zcst,Zcsb,dR,dZ;
  int Ncs=2;
  PFBLOCK *lB;

  nPFB1	=nPFB+1;
  Rcse	=0.5*RplG[0];
  Rcsi	=0.9*Rcse;
  Zcst	=1.8*ZplG[1];
  Zcsb	=1.8*ZplG[0];
  j		=0;
  lB		=PFB;
  Rb1[j]	=RplG[0];
  Rb2[j]	=RplG[1];
  Zb1[j]	=ZplG[0];
  Zb2[j]	=ZplG[1];
  lB->nr	=NplG[0];
  lB->nz	=NplG[1];
  strcpy(lB->Nm,"Plasma");
  lB++;
  j++;
  if(j >= nPFB) return(0);
  dZ	=Zcst/Ncs;
  for(i=0; i < Ncs; i++){
    Rb1[j]	=Rcsi;
    Rb2[j]	=Rcse;
    Zb1[j]	=dZ*i;
    Zb2[j]	=Zb1[j]+dZ;
    strcpy(lB->Nm,"CSol");
    lB++;
    j++;
    if(j >= nPFB) return(0);
  }
  dR	=0.05*(RplG[1]-RplG[0]);
  dZ	=0.05*(ZplG[1]-ZplG[0]);
  Rb1[j]	=RplG[0];
  Zb1[j]	=Zcst;
  Rb2[j]	=Rb1[j]+dR;
  Zb2[j]	=Zb1[j]+dZ;
  strcpy(lB->Nm,"PF1u");
  lB++;
  j++;
  if(j >= nPFB) return(0);
  Rb1[j]	=RplG[1]+0.2*(RplG[1]-RplG[0]);
  Zb1[j]	=0.75*ZplG[1];
  Rb2[j]	=Rb1[j]+dR;
  Zb2[j]	=Zb1[j]+dZ;
  strcpy(lB->Nm,"PF2u");
  lB++;
  j++;
  if(j >= nPFB) return(0);
  Rb1[j]	=RplG[1]+0.3*(RplG[1]-RplG[0]);
  Zb1[j]	=0.2*ZplG[1];
  Rb2[j]	=Rb1[j]+dR;
  Zb2[j]	=Zb1[j]+dZ;
  strcpy(lB->Nm,"PF3u");
  j++;
  if(j >= nPFB) return(0);
  lB++;
  while(j < nPFB/2){
    Rb1[j]	=RplG[1]+0.5*(RplG[1]-RplG[0]);
    Zb1[j]	=1.2*ZplG[1];
    Rb2[j]	=Rb1[j]+dR;
    Zb2[j]	=Zb1[j]+dZ;
    strcpy(lB->Nm,"PF  ");
    j++;
    if(j >= nPFB) return(0);
    lB++;
  }
  k	=j-1;
  for(i=0; i < nPFB/2; i++){
    Rb1[j]	=Rb1[k];
    Zb1[j]	=-Zb2[k];
    Rb2[j]	=Rb2[k];
    Zb2[j]	=-Zb1[k];
    strcpy(lB->Nm,PFB[k].Nm);
    lB++;
    j++;
    if(j >= nPFB) return(0);
    k--;
  }
  if(nPFB%2){
    Rb1[j]	=RplG[0]+0.2*(RplG[1]-RplG[0]);
    Zb1[j]	=1.3*ZplG[0];
    Rb2[j]	=Rb1[j]+dR;
    Zb2[j]	=Zb1[j]+dZ;
    strcpy(lB->Nm,"PF2u");
    lB++;
    j++;
    if(j >= nPFB) return(0);
  }
  i		=0;
  lB		=PFB;
  lB->R		=cr2*(Rb2[i]+Rb1[i]);
  lB->dR	=cr2*(Rb2[i]-Rb1[i]);
  lB->Z		=cr2*(Zb2[i]+Zb1[i]);
  lB->dZ	=cr2*(Zb2[i]-Zb1[i]);
  lB->tn	=1.;
  lB->gr	=0.;
  lB->Res	=0.;
  lB->gt	=0.;
  lB->AI	=0.;
  lB->I		=0.;
  lB->gY	=0.;
  lB->V		=0.;
  lB->gq	=0;
  lB->kS	=0;
  lB->kC	=0;
  lB->kA	=1;
  lB->kD	=0;
  lB->kG	=-1;
  for(i=1; i < nPFB; i++){
    lB++;
    lB->nr	=2;
    lB->nz	=2;
    lB->R	=cr2*(Rb2[i]+Rb1[i]);
    lB->dR	=cr2*(Rb2[i]-Rb1[i]);
    lB->Z	=cr2*(Zb2[i]+Zb1[i]);
    lB->dZ	=cr2*(Zb2[i]-Zb1[i]);
    lB->tn	=100.*(Rb2[i]-Rb1[i])*(Zb2[i]-Zb1[i]);
    lB->gr	=2.5*1e-2;
    lB->Res	=c2gp*lB->R*lB->gr/(4.*lB->dR*lB->dZ);
    lB->gt	=0.;
    lB->AI	=0.;
    lB->I	=0.;
    lB->gY	=0.;
    lB->V	=0.;
    lB->gq	=0;
    lB->kS	=0;
    lB->kC	=i;
    lB->kA	=1;
    lB->kD	=0;
    lB->kG	=-1;
  }
  lB++;
  lB->nr=1;
  lB->nz=1;
  lB->R	=cr2*(RplG[0]+RplG[1]);
  lB->dR=cr2*(RplG[1]-RplG[0]);
  lB->Z	=cr2*(ZplG[0]+ZplG[1]);
  lB->dZ=cr2*(ZplG[1]-ZplG[0]);
  lB->tn=36;
  lB->gr=2.5*1e-2;
  lB->Res=c2gp*lB->R*lB->gr/(4.*lB->dR*lB->dZ);
  lB->gt=0.;
  lB->AI=0.;
  lB->I	=0.;
  lB->gY=0.;
  lB->V	=0.;
  lB->gq=0;
  lB->kS=0;
  lB->kC=0;
  lB->kA=1;
  lB->kD=0;
  lB->kG=-1;
  return(0);
}

int PFDeInitPFB()
{
  if(NPFB){
    free(IbPF);
    free(PFB);
    free(Zb2);
    free(Zb1);
    free(Rb2);
    free(Rb1);
    NPFB	=0;
  }
  return(0);
}

int PFReInitPFB()
{
  nPFB1	=nPFB+1;
  if(NPFB < nPFB1){
    int i;
    PFBLOCK *lB;

    if(NPFB) PFDeInitPFB();

    Rb1		=(double*)malloc(nPFB1*sizeof(double));
    Rb2		=(double*)malloc(nPFB1*sizeof(double));
    Zb1		=(double*)malloc(nPFB1*sizeof(double));
    Zb2		=(double*)malloc(nPFB1*sizeof(double));
    IbPF	=(double*)malloc((nPFB1+nVVC)*sizeof(double));

    PFB		=(PFBLOCK*)malloc((nPFB1)*sizeof(PFBLOCK));
    if(Rb1 == NULL || Rb2 == NULL || Zb1 == NULL
       || Zb2 == NULL || IbPF == NULL || PFB == NULL){
      printf("No memory for PFBlocks in PFReInitPFB()\n");
      return(1);
    }
    lB	=PFB;
    for(i=0; i < nPFB; i++){
      strcpy(lB->Nm,">---<");
      lB->nr	=2;
      lB->nz	=2;
      IbPF[i]	=0.;
      lB->tn	=100.;
      lB->gr	=2.5e-2;
      lB->kc	=1;
      lB->kC	=i;
      lB->kG	=-1;
      lB++;
    }
    lB->r[0]	=0.;
    lB->r[1]	=0.;
    lB->z[0]	=0.;
    lB->z[1]	=0.;
    lB->R	=0.;
    lB->Z	=0.;
    lB->dR	=0.;
    lB->dZ	=0.;
    lB->tn	=36.;
    lB->gr	=2.5e-2;
    lB->Res	=1.;
    lB->gt	=1.;
    lB->AI	=1.;
    lB->I	=0.;
    lB->gY	=0.;
    lB->V	=0.;
    lB->gq	=0.;
    lB->nr	=1;
    lB->nz	=1;
    lB->kS	=3;
    lB->kc	=1;
    lB->kC	=nPFB;
    lB->kA	=1;
    lB->kD	=1;
    lB->kG	=-1;
    strcpy(lB->Nm,"TFC");
    strcpy(lB->NmC,"ITF");
    for(i=nPFB; i < nPFB+nVVC; i++) IbPF[i]=0.;
    if(NPFB == 0) DefaultPFB();
    NPFB	=nPFB1;
  }

  ESmemlevP |=0x00000001;
  return(0);
}

int OldPFBlocksAO(FILE *lf)
{
  PFBLOCK *lB;
  char str[64];
  char ln[64];
  int i;
  
  strcpy(ln,"%3d %7.4f %8.4f %7.4f %7.4f %5.1f %3d x%3d %8s %5d %8s%c");
  strcpy(str,ln);
  FormatWrite2Read(str);

  fprintf(lf,"<PFBlocks>[%d](%s)\n",nPFB,str);
  fprintf(lf,"!%2s %7s %8s %7s %7s %5s %7s %8s %5s %8s\n","#","R [m]"
	  ,"Z [m]","dR [m]","dZ [m]","N_turn","nX *nY","NmBlock","Coil#"
	  ,"Coil");
  for(i=0; i < nPFB; i++){
    lB	=PFB+i;
    fprintf(lf,ln,i,lB->R,lB->Z,2.*lB->dR,2.*lB->dZ,lB->tn
	    ,lB->nr,lB->nz,lB->Nm,lB->kD,lB->NmC,'\n');
  }
  fprintf(lf,"!%2s %7s %8s %7s %7s %5s %7s %8s %5s %8s\n","#","R [m]"
	  ,"Z [m]","dR [m]","dZ [m]","N_turn","nX *nY","NmBlock","Coil#"
	  ,"Coil");

  fprintf(lf,"\n<TF Block>[%d](%s)\n",1,str);
  fprintf(lf,"!%2s %7s %8s %7s %7s %5s %7s %8s %5s %8s\n","#","R [m]"
	  ,"Z [m]","dR [m]","dZ [m]","N_turn","nX *nY","NmBlock","Coil#"
	  ,"Coil");
  lB	=PFB+nPFB;
  fprintf(lf,ln,lB->kC,lB->R,lB->Z,2.*lB->dR,2.*lB->dZ,lB->tn
	  ,lB->nr,lB->nz,lB->Nm,lB->kD,lB->NmC,'\n');
  fprintf(lf,"!%2s %7s %8s %7s %7s %5s %7s %8s %5s %8s\n","#","R [m]"
	  ,"Z [m]","dR [m]","dZ [m]","N_turn","nX *nY","NmBlock","Coil#"
	  ,"Coil");
  return(0);
}

int PFBlocksAO(FILE *lf)
{
  int i;
  PFBLOCK *lB;
  char str[0x100];
  char ln[0x100];
  
  strcpy(ln,"%3d %7.4f %8.4f %7.4f %7.4f %5.1f %3d x %3d %8s %5d %8s%c");
  strcpy(str,ln);
  FormatWrite2Read(str);

  fprintf(lf,"<PFBlocks R-Z>[%d](%s)\n",nPFB,str);
  fprintf(lf,"!%2s %7s %8s %7s %7s %5s %7s %9s %5s %8s\n","#","R1 [m]"
	  ,"Z1 [m]","R2 [m]","Z2 [m]","N_turn","nX * nY","NmBlock","Coil#"
	  ,"Coil");
  for(i=0; i < nPFB; i++){
    lB	=PFB+i;
    fprintf(lf,ln,i,ScaleR*lB->r[0],ScaleR*lB->z[0],ScaleR*lB->r[1],ScaleR*lB->z[1],lB->tn
	    ,lB->nr,lB->nz,lB->Nm,lB->kC,lB->NmC,'\n');
  }
  fprintf(lf,"!%2s %7s %8s %7s %7s %5s %7s %9s %5s %8s\n","#","R1 [m]"
	  ,"Z1 [m]","R2 [m]","Z2 [m]","N_turn","nX * nY","NmBlock","Coil#"
	  ,"Coil");
  fprintf(lf,"\n<PFBlocks>[%d](%s)\n",nPFB,str);
  fprintf(lf,"!%2s %7s %8s %7s %7s %5s %7s %9s %5s %8s\n","#","R [m]"
	  ,"Z [m]","W [m]","H [m]","N_turn","nX * nY","NmBlock","Coil#"
	  ,"Coil");
  for(i=0; i < nPFB; i++){
    lB	=PFB+i;
    fprintf(lf,ln,i,ScaleR*lB->R,ScaleR*lB->Z,ScaleR*2.*lB->dR,ScaleR*2.*lB->dZ,lB->tn
	    ,lB->nr,lB->nz,lB->Nm,lB->kC,lB->NmC,'\n');
  }
  fprintf(lf,"!%2s %7s %8s %7s %7s %5s %7s %9s %5s %8s\n","#","R [m]"
	  ,"Z [m]","W [m]","H [m]","N_turn","nX * nY","NmBlock","Coil#"
	  ,"Coil");

  fprintf(lf,"\n<TF Block>[%d](%s)\n",1,str);
  fprintf(lf,"!%2s %7s %8s %7s %7s %5s %7s %9s %5s %8s\n","#","R1 [m]"
	  ,"Z1 [m]","R2 [m]","Z2 [m]","N_turn","nX * nY","NmBlock","Coil#"
	  ,"Coil");
  lB	=PFB+nPFB;
  fprintf(lf,ln,i,ScaleR*lB->r[0],ScaleR*lB->z[0],ScaleR*lB->r[1],ScaleR*lB->z[1],lB->tn
	  ,lB->nr,lB->nz,lB->Nm,lB->kC,lB->NmC,'\n');
  fprintf(lf,"!%2s %7s %8s %7s %7s %5s %7s %9s %5s %8s\n","#","R1 [m]"
	  ,"Z1 [m]","R2 [m]","Z2 [m]","N_turn","nX * nY","NmBlock","Coil#"
	  ,"Coil");
  return(0);
}

int PFBlocksAI(FILE *lf)
{
  int i,n;
  PFBLOCK *lB;
  char str[64];
  char *lc;
  char *lm;
  char *lv[16];
  int dl[16];

  lm	="PFBlocks.ai";
  lc	="<PFBlocks R-Z>";
  if(IsKeyWordFound(lf,lm,lc,str,&n)){
    nPFB	=n;
    nPFB1	=n+1;
    if(NPFB < nPFB1) PFReInitPFB();
    lB	=PFB;
    lv[0]	=(char*)&n;
    lv[1]	=(char*)lB->r;
    lv[2]	=(char*)lB->z;
    lv[3]	=(char*)(lB->r+1);
    lv[4]	=(char*)(lB->z+1);
    lv[5]	=(char*)&lB->tn;
    lv[6]	=(char*)&lB->nr;
    lv[7]	=(char*)&lB->nz;
    lv[8]	=(char*)lB->Nm;
    lv[9]	=(char*)&lB->kC;
    lv[10]	=(char*)lB->NmC;
    dl[0]	=0;
    dl[1]	=sizeof(PFBLOCK);
    dl[2]	=dl[1];
    dl[3]	=dl[1];
    dl[4]	=dl[1];
    dl[5]	=dl[1];
    dl[6]	=dl[1];
    dl[7]	=dl[1];
    dl[8]	=dl[1];
    dl[9]	=dl[1];
    dl[10]	=dl[1];
    ReadAI(lf,lc,lm,str,n,lv,dl,11);
    for(i=1; i < nPFB; i++){
      lB	=PFB+i;
      lB->R	=0.5*(lB->r[1]+lB->r[0]);
      lB->Z	=0.5*(lB->z[1]+lB->z[0]);
      lB->dR	=0.5*(lB->r[1]-lB->r[0]);
      lB->dZ	=0.5*(lB->z[1]-lB->z[0]);
      lB->kD	=lB->kC;
      lB->kG	=-1;
    }
  }
  else{
    rewind(lf);
    lc	="<PFBlocks>";
    if(IsKeyWordFound(lf,lm,lc,str,&n)){
      nPFB	=n;
      nPFB1	=n+1;
      if(NPFB < nPFB1) PFReInitPFB();
      lB		=PFB;
      lv[0]	=(char*)&n;
      lv[1]	=(char*)&lB->R;
      lv[2]	=(char*)&lB->Z;
      lv[3]	=(char*)&lB->dR;
      lv[4]	=(char*)&lB->dZ;
      lv[5]	=(char*)&lB->tn;
      lv[6]	=(char*)&lB->nr;
      lv[7]	=(char*)&lB->nz;
      lv[8]	=(char*)lB->Nm;
      lv[9]	=(char*)&lB->kC;
      lv[10]	=(char*)lB->NmC;
      dl[0]	=0;
      dl[1]	=sizeof(PFBLOCK);
      dl[2]	=dl[1];
      dl[3]	=dl[1];
      dl[4]	=dl[1];
      dl[5]	=dl[1];
      dl[6]	=dl[1];
      dl[7]	=dl[1];
      dl[8]	=dl[1];
      dl[9]	=dl[1];
      dl[10]	=dl[1];
      ReadAI(lf,lc,lm,str,n,lv,dl,11);
      for(i=1; i < nPFB; i++){
	lB	=PFB+i;
	lB->dR	*=0.5;
	lB->dZ	*=0.5;
	lB->r[0]	=lB->R-lB->dR;
	lB->r[1]	=lB->R+lB->dR;
	lB->z[0]	=lB->Z-lB->dZ;
	lB->z[1]	=lB->Z+lB->dZ;
	lB->kD	=lB->kC;
	lB->kG	=-1;
      }
    }
    else{
      CbStr2UserMessage("Error:%s: %s is absent\n",lm,lc);
      printf("Error:%s - NO %s section.\n",lm,lc);
      return(1);
    }
  }

  lc	="<TF Block>";
  if(IsKeyWordFound(lf,lm,lc,str,&n)){
    lB		=PFB+nPFB;
    lv[0]	=(char*)&lB->kC;
    lv[1]	=(char*)lB->r;
    lv[2]	=(char*)lB->z;
    lv[3]	=(char*)(lB->r+1);
    lv[4]	=(char*)(lB->z+1);
    lv[5]	=(char*)&lB->tn;
    lv[6]	=(char*)&lB->nr;
    lv[7]	=(char*)&lB->nz;
    lv[8]	=(char*)lB->Nm;
    lv[9]	=(char*)&lB->kC;
    lv[10]	=(char*)lB->NmC;
    dl[0]	=0;
    dl[1]	=sizeof(PFBLOCK);
    dl[2]	=dl[1];
    dl[3]	=dl[1];
    dl[4]	=dl[1];
    dl[5]	=dl[1];
    dl[6]	=dl[1];
    dl[7]	=dl[1];
    dl[8]	=dl[1];
    dl[9]	=dl[1];
    dl[10]	=dl[1];
    ReadAI(lf,lc,lm,str,n,lv,dl,11);
  }
  else{
    CbStr2UserMessage("Error:%s: %s is absent\n",lm,lc);
    printf("Error:%s - NO %s section.\n",lm,lc);
    return(1);
  }

  lB	=PFB+nPFB;
  lB->R	=0.5*(lB->r[1]+lB->r[0]);
  lB->Z	=0.5*(lB->z[1]+lB->z[0]);
  lB->dR	=0.5*(lB->r[1]-lB->r[0]);
  lB->dZ	=0.5*(lB->z[1]-lB->z[0]);
  lB->kD	=lB->kC;
  lB->kG	=-1;

  lB		=PFB;
  lB->r[0]	=RplG[0];
  lB->r[1]	=RplG[1];
  lB->z[0]	=ZplG[0];
  lB->z[1]	=ZplG[1];
  lB->R		=cr2*(RplG[0]+RplG[1]);
  lB->Z		=cr2*(ZplG[0]+ZplG[1]);
  lB->dR	=0.5*(RplG[1]-RplG[0]);
  lB->dZ	=0.5*(ZplG[1]-ZplG[0]);
  lB->tn	=1.;
  lB->nr	=NplG[0];
  lB->nz	=NplG[1];
  lB->kD	=0;
  lB->kC	=0;

  CbStr2UserMessage("Input:%s\n",lm);
  return(0);
}

#ifdef H
int PFDeInitGreenBlocks()
{
  if(gYpb != NULL){
    int i;

    free(FlPFB);
    for(i=0; i < nPFB; i++){
      free(gYbb[i]);
    }
    free(gYbb);
    gYbb	=NULL;

    i	=12;
    while(i > 0){
      i--;
      free(gYcb[i]);
    }
    i	=nMFP;
    while(i > 0){
      i--;
      free(gYib[i]);
    }
    free(gYib);
    i	=EGNp;
    while(i > 0){
      i--;
      free(gYpb[i]);
    }
    free(gYpb);
    gYpb	=NULL;
  }
  return(0);
}

int PFReInitGreenBlocks()
{
  static int Np=0,Nb=0,Ns=0,Nm=0;

  if(gYpb == NULL || Nb != nPFB || Np != EGNp || Ns != nVVC || Nm != nMFP){
    int i,k;

    Np	=EGNp;
    Nb	=nPFB;
    Ns	=nVVC;
    Nm	=nMFP;
    if(Nb){
      PFDeInitGreenBlocks();
    }
    gYpb	=(double**)malloc(EGNp*sizeof(double*));
    if(gYpb == NULL){
      printf("No memory for %s in %s\n","gYpb","PFReInitGreenBlocks()");
      return(1);
    }
    for(i=0; i < EGNp; i++){
      gYpb[i]	=(double*)malloc(nPFB*sizeof(double));
      if(gYpb[i] == NULL){
	printf("No memory for %s[%d] in %s\n","gYpb",i
	       ,"PFReInitGreenBlocks()");
	return(1);
      }
    }
    gYib	=(double**)malloc(nMFP*sizeof(double*));
    if(gYib == NULL){
      printf("No memory for %s in %s\n","gYib","PFReInitGreenBlocks()");
      return(1);
    }
    for(i=0; i < nMFP; i++){
      gYib[i]	=(double*)malloc(nPFB*sizeof(double));
      if(gYib[i] == NULL){
	printf("No memory for %s[%d] in %s\n","gYib",i
	       ,"PFReInitGreenBlocks()");
	return(1);
      }
    }
    for(i=0; i < 12; i++){
      gYcb[i]	=(double*)malloc(3*nPFB*sizeof(double));
      if(gYcb[i] == NULL){
	printf("No memory for %s[%d] in %s\n","gYcb",i
	       ,"PFReInitGreenBlocks()");
	return(1);
      }
      BRcb[i]	=gYcb[i]+nPFB;
      BZcb[i]	=BRcb[i]+nPFB;
    }
    gYbb	=(double**)malloc(nPFB*sizeof(double*)); 
    if(gYbb == NULL){
      printf("No memory for %s in %s\n","gYbb","PFReInitGreenBlocks()");
      return(1);
    }
    for(i=0; i < nPFB; i++){
      gYbb[i]	=(double*)malloc(nPFB*sizeof(double));
      if(gYbb[i] == NULL){
	printf("No memory for %s[%d] in %s\n","gYbb",i
	       ,"PFReInitGreenBlocks()");
	return(1);
      }
    }
    FlPFB	=(int*)malloc(nPFB*sizeof(int));
    for(i=0; i < nPFB; i++){
      FlPFB[i]	=0x0F;
    }
    ESmemlevP	|=0x00020000;
  }
  return(0);
}

int PFSaveLijBlocks(FILE *lf)
{
  PFBLOCK *lB;
  PSBLOCK *lS;

  int i,n;
  size_t ii,id;

  ii	=(size_t)sizeof(int);
  id	=(size_t)sizeof(double);

  /* Plasma */
  fwrite(NplG,ii,(size_t)2,lf);
  fwrite(RplG,id,(size_t)2,lf);
  fwrite(ZplG,id,(size_t)2,lf);

  /* Probes */
  fwrite(&nMFL,ii,(size_t)1,lf);
  fwrite(&nMFS,ii,(size_t)1,lf);
  fwrite(&nMFp,ii,(size_t)1,lf);
  for(i=0; i < nMFL; i++){
    fwrite(&MFL[i].R,id,(size_t)1,lf);
    fwrite(&MFL[i].Z,id,(size_t)1,lf);
  }
  for(i=0; i < nMFS; i++){
    fwrite(&MFS[i].R,id,(size_t)1,lf);
    fwrite(&MFS[i].Z,id,(size_t)1,lf);
    fwrite(&MFS[i].R1,id,(size_t)1,lf);
    fwrite(&MFS[i].Z1,id,(size_t)1,lf);
  }
  for(i=0; i < nMFp; i++){
    fwrite(&MFp[i].R,id,(size_t)1,lf);
    fwrite(&MFp[i].Z,id,(size_t)1,lf);
    fwrite(&MFp[i].Tr,id,(size_t)1,lf);
    fwrite(&MFp[i].Tz,id,(size_t)1,lf);
  }

  /* PFBlocks */
  fwrite(&nPFB,ii,(size_t)1,lf);
  for(i=0; i < nPFB; i++){
    fwrite(&(PFB[i].nr),ii,(size_t)1,lf);
    fwrite(&(PFB[i].nz),ii,(size_t)1,lf);
  }
  for(i=0; i < nPFB; i++){
    lB	=PFB+i;
    fwrite(&lB->R, id,(size_t)1,lf);
    fwrite(&lB->dR,id,(size_t)1,lf);
    fwrite(&lB->Z, id,(size_t)1,lf);
    fwrite(&lB->dZ,id,(size_t)1,lf);
  }

  /* Green Functions */
  for(i=0; i < EGNp; i++){
    fwrite(gYpb[i],id,(size_t)nPFB,lf);
  }
  for(i=1; i < nPFB; i++){
    fwrite(gYbb[i]+i,id,(size_t)(nPFB-i),lf);
  }
  for(i=0; i < nMFP; i++) fwrite(gYib[i],id,(size_t)nPFB,lf);
  return(0);
}

int PFReadLijBlocks(FILE *lf)
{
  PFBLOCK *lB;
  PSBLOCK *lS;
  int i,n,nC,m,k[4];
  double s[4];
  size_t ii,id;

  ii	=(size_t)sizeof(int);
  id	=(size_t)sizeof(double);

  /* Plasma */
  m	=fread(k,ii,(size_t)2,lf);
  if(m < 2 || NplG[0] != k[0] || NplG[1] != k[1]){
    SetFlPFB(1);
    return(1);
  }
  m	=fread(s,id,(size_t)4,lf);
  if(m < 4 || RplG[0] != s[0] || RplG[1] != s[1] || 
     ZplG[0] != s[2] || ZplG[1] != s[3]){
    SetFlPFB(1);
    return(1);
  }
  FlPlG	&=0x07;

  /* Probes */
  m	=fread(k,ii,(size_t)3,lf);
  if(m < 3 || k[0] != nMFL || k[1] != nMFS || k[2] != nMFp){
    SetFlPFB(1);
    return(1);
  }
  for(i=0; i < nMFL; i++){
    m	=fread(s,id,(size_t)2,lf);
    if(m < 2 || s[0] != MFL[i].R || s[1] != MFL[i].Z){
      SetFlPFB(1);
      return(1);
    }
  }
  for(i=0; i < nMFS; i++){
    m	=fread(s,id,(size_t)4,lf);
    if(m < 4 || s[0] != MFS[i].R || s[1] != MFS[i].Z || 
       s[2] != MFS[i].R1 || s[3] != MFS[i].Z1){
      SetFlPFB(1);
      return(1);
    }
  }
  for(i=0; i < nMFp; i++){
    m	=fread(s,id,(size_t)4,lf);
    if(m < 4 || s[0] != MFp[i].R || s[1] != MFp[i].Z || 
       s[2] != MFp[i].Tr || s[3] != MFp[i].Tz){
      SetFlPFB(1);
      return(1);
    }
  }
  FlMFP	&=0x07;

  /* PFBlocks */
  m	=fread(k,ii,(size_t)1,lf);
  if(m < 1 || nPFB != k[0]){
    SetFlPFB(1);
    return(1);
  }
  for(i=0; i < nPFB; i++){
    FlPFB[i]	=0;
    m	=fread(k,ii,(size_t)2,lf);
    if(m < 2){
      SetFlPFB(1);
      return(1);
    }
    if(PFB[i].nr != k[0] || PFB[i].nz != k[1]){
      FlPFB[i]	|=0x0D;
    }
  }
  for(i=0; i < nPFB; i++){
    lB	=PFB+i;
    m	=fread(s,id,(size_t)4,lf);
    if(m < 4){
      SetFlPFB(1);
      return(1);
    }
    if(lB->R != s[0] || lB->dR != s[1] || lB->Z != s[2] || lB->dZ != s[3]){
      FlPFB[i]	|=0x0D;
    }
  }
  /* Green Functions */
  for(i=0; i < EGNp; i++){
    m	=fread(gYpb[i],id,(size_t)nPFB,lf);
    if(m < nPFB){
      SetFlPFB(1);
      return(1);
    }
  }
  for(i=1; i < nPFB; i++){
    m	=fread(gYbb[i]+i,id,(size_t)(nPFB-i),lf);
    if(m < nPFB-i){
      SetFlPFB(1);
      return(1);
    }
    for(m=i+1; m < nPFB; m++){
      gYbb[m][i]	=gYbb[i][m];
    }
  }
  for(i=0; i < nMFP; i++){
    m	=fread(gYib[i],id,(size_t)nPFB,lf);
    if(m < nPFB){
      SetFlPFB(1);
      return(1);
    }
  }
  return(0);
}

int PFSetLijBlocks()
{
  MFPROBE *lP;
  PFBLOCK *lB0,*lB1;
  char ln[64];

  int m,mr,mz,k,kr,kz;
  int nr0,nz0,nr1,nz1;
  double r0,z0,r1,z1;
  double hr0,hz0,hr1,hz1;
  double R0,Z0,R1,Z1;
  double ss,s,gY,Br,Bz,gy,br,bz,Tr,Tz;
  static int nx=4,ny=4;
  
  int ix0,iy0,ix1,iy1;
  double b,a,c,d;
  double x0,y0,x1,y1,dx0,dy0,dx1,dy1,ga,gaa,gr,grr;

  nx	=4;
  ny	=4;

  ss	=nx*ny;
  ss	=1./(ss*ss);

  lB0	=PFB;
  hr0	=EGdr;
  hz0	=EGdz;
  dx0	=hr0/nx;
  dy0	=hz0/ny;
  a	=dy0/dx0;
  if(a > 3.0){
    d	=.13;
  }
  else{
    if(a >= 2.){
      d	=0.2+0.11*(3.-a);
    }
    else{
      if(a >= 1.6){
	d	=.31+.2*(2.-a);
      }
      else{
	if(a >= 1.){
	  d	=.39+.7167*(1.6-a);
	}
	else{
	  d	=.82;
	}
      }
    }
  }
  dx1	=dx0;
  dy1	=dy0;
  for(m=0; m < EGNp; m++){
    r0	=EGaRp[m];
    z0	=EGaZp[m];
    R0	=r0-cr2*hr0;
    Z0	=z0-cr2*hz0;
    sprintf(ln,"Plasma-PFBlocks: %4d < %d",m,EGNp);
    ZMessage(ln);
    for(k=1; k < nPFB; k++){
      lB1	=PFB+k;
      if((FlPlG&0x08) || (FlPFB[k]&0x01)){
	nr1	=lB1->nr;
	hr1	=2.*lB1->dR/nr1;
	nz1	=lB1->nz;
	hz1	=2.*lB1->dZ/nz1;
	dx1	=hr1/nx;
	dy1	=hz1/ny;
	R1	=lB1->R-lB1->dR;
	r1	=R1+cr2*hr1;
	gY	=0.;
	for(kr=0; kr < nr1; kr++){
	  Z1	=lB1->Z-lB1->dZ;
	  z1	=Z1+cr2*hz1;
	  for(kz=0; kz < nz1; kz++){
	    if(fabs(r0-r1) > 1.1*hr0 || fabs(z0-z1) > 1.1*hz0){
	      gY	+=GPring(r0,z0,r1,z1);
	    }
	    else{
	      x0	=R0+cr2*dx0;
	      for(ix0=0; ix0 < nx; ix0++){
		y0	=Z0+cr2*dy0;
		for(iy0=0; iy0 < ny; iy0++){
		  x1	=R1+cr2*dx1;
		  for(ix1=0; ix1 < nx; ix1++){
		    y1	=Z1+cr2*dy1;
		    for(iy1=0; iy1 < ny; iy1++){
		      gY	+=GPring(x0,y0,x1,y1)*ss;
		      y1	+=dy1;
		    }
		    x1	+=dx1;
		  }
		  y0	+=dy0;
		}
		x0	+=dx0;
	      }
	    }
	    z1 	+=hz1;
	    Z1	+=hz1;
	  }
	  r1 +=hr1;
	  R1 +=hr1;
	}
	gYpb[m][k]	=gY/(nr1*nz1);
      }
    }
  }
  for(m=1; m < nPFB; m++){
    sprintf(ln,"PFBlocks-PFBlocks: %4d < %d",m,nPFB);
    ZMessage(ln);
    lB0	=PFB+m;
    nr0	=lB0->nr;
    hr0	=2.*lB0->dR/nr0;
    nz0	=lB0->nz;
    hz0	=2.*lB0->dZ/nz0;
    dx0	=hr0/nx;
    dy0	=hz0/ny;
    a	=dy0/dx0;
    if(a > 3.0){
      d	=.13;
    }
    else{
      if(a >= 2.){
	d	=0.2+0.11*(3.-a);
      }
      else{
	if(a >= 1.6){
	  d	=.31+.2*(2.-a);
	}
	else{
	  if(a >= 1.){
	    d	=.39+.7167*(1.6-a);
	  }
	  else{
	    d	=.82;
	  }
	}
      }
    }
    for(k=m; k < nPFB; k++){
      lB1	=PFB+k;
      if((FlPFB[m]&0x08) || (FlPFB[k]&0x08)){
	nr1	=lB1->nr;
	hr1	=2.*lB1->dR/nr1;
	nz1	=lB1->nz;
	hz1	=2.*lB1->dZ/nz1;
	dx1	=hr1/nx;
	dy1	=hz1/ny;
	gY	=0.;
	R0	=lB0->R-lB0->dR;
	r0	=R0+cr2*hr0;
	for(mr=0; mr < nr0; mr++){
	  Z0	=lB0->Z-lB0->dZ;
	  z0	=Z0+cr2*hz0;
	  for(mz=0; mz < nz0; mz++){
	    R1	=lB1->R-lB1->dR;
	    r1	=R1+cr2*hr1;
	    for(kr=0; kr < nr1; kr++){
	      Z1	=lB1->Z-lB1->dZ;
	      z1	=Z1+cr2*hz1;
	      for(kz=0; kz < nz1; kz++){
		a	=r0-r1;
		b	=z0-z1;
		if(fabs(r0-r1) > 1.1*hr0 ||fabs(z0-z1) > 1.1*hz0){
		  gY	+=GPring(r0,z0,r1,z1);
		}
		else{
		  x0	=R0+cr2*dx0;
		  for(ix0=0; ix0 < nx; ix0++){
		    y0	=Z0+cr2*dy0;
		    for(iy0=0; iy0 < ny; iy0++){
		      x1	=R1+cr2*dx1;
		      for(ix1=0; ix1 < nx; ix1++){
			y1	=Z1+cr2*dy1;
			for(iy1=0; iy1 < ny; iy1++){
			  y1	=Z1+(cr2+iy1)*dy1;
			  a	=x0-x1;
			  b	=y0-y1;
			  if(fabs(x0-x1) < dx0 && fabs(y0-y1) < dy0){
			    ga	=cr2*dy0/x0;
			    gr	=cr2*dx0/x0;
			    gaa	=ga*ga;
			    grr	=gr*gr;
			    a	=4./(ga+gr);
			    b	=(3.*gaa+grr)/24.;
			    c	=4./sqrt(gaa+grr);
			    gY	+=cgm0*x0*(log(a)-cr2+b*log(c)+d*gaa*.25)*ss;
			  }
			  else{
			    gY	+=GPring(x0,y0,x1,y1)*ss;
			  }
			  y1	+=dy1;
			}
			x1	+=dx1;
		      }
		      y0	+=dy0;
		    }
		    x0	+=dx0;
		  }
		}
		z1 	+=hz1;
		Z1 	+=hz1;
	      }
	      r1 +=hr1;
	      R1 +=hr1;
	    } 
	    z0 +=hz0;
	    Z0 +=hz0;
	  }
	  r0 +=hr0;
	  R0 +=hr0;
	}
	gY	/=nr0*nz0*nr1*nz1;
	gYbb[m][k]	=gY;
	gYbb[k][m]	=gY;
      }
    }
  }

  ss	=(double)1./(nx*ny);
  for(m=0; m < nMFP; m++){
    sprintf(ln,"? Probes-Blocks: %4d < %d",m,nMFP);
    ZMessage(ln);
    lP	=MFP+m;
    r0	=lP->R;
    z0	=lP->Z;
    Tr	=lP->Tr; 
    Tz	=lP->Tz;
    for(k=1; k < nPFB; k++){
      lB1	=PFB+k;
      if((FlMFP&0x08) || (FlPFB[k]&0x04)){
	nr1	=lB1->nr;
	hr1	=2.*lB1->dR/nr1;
	nz1	=lB1->nz;
	hz1	=2.*lB1->dZ/nz1;
	s		=(double)1./(nr1*nz1);
	dx1	=hr1/nx;
	dy1	=hz1/ny;
	gY	=0.;
	Br	=0.;
	Bz	=0.;
	R1	=lB1->R-lB1->dR;
	r1	=R1+cr2*hr1;
	for(kr=0; kr < nr1; kr++){
	  Z1	=lB1->Z-lB1->dZ;
	  z1	=Z1+cr2*hz1;
	  for(kz=0; kz < nz1; kz++){
	    br	=r0-r1;
	    bz	=z0-z1;
	    if(fabs(r0-r1) > hr1 || fabs(z0-z1) > hz1){
	      MFring(&gy,&br,&bz,r0,z0,r1,z1,(double)1.);
	      gY	+=gy;
	      Br	+=br;
	      Bz	+=bz;
	      if(lP->kA == 2){
		MFring(&gy,&br,&bz,lP->R1,lP->Z1,r1,z1,(double)1.);
		gY	-=gy;
		Br	-=br;
		Bz	-=bz;
	      }
	    }
	    else{
	      x1	=R1+cr2*dx1;
	      for(ix1=0; ix1 < nx; ix1++){
		y1	=Z1+cr2*dy1;
		for(iy1=0; iy1 < ny; iy1++){
		  MFring(&gy,&br,&bz,r0,z0,x1,y1,ss);
		  gY	+=gy;
		  Br	+=br;
		  Bz	+=bz;
		  if(lP->kA == 2){
		    MFring(&gy,&br,&bz,lP->R1,lP->Z1,x1,y1,ss);
		    gY	-=gy;
		    Br	-=br;
		    Bz	-=bz;
		  }
		  y1	+=dy1;
		}
		x1	+=dx1;
	      }
	    }
	    z1 	+=hz1;
	    Z1	+=hz1;
	  }
	  r1 +=hr1;
	  R1 +=hr1;
	}
	gYib[m][k]	=lP->kA < 3 ? gY*s : (Br*Tr+Bz*Tz)*s;
      }
    }
  }
  FlPlG	&=0x07;
  FlMFP	&=0x07;
  for(k=1; k < nPFB; k++){
    FlPFB[k]	=0;
  }
  return(0);
}
#endif

void PFBGrid()
{
  int i,k,n;
  double s,ds;


  ZNewPath();
  ZColor(3);
  for(k=0; k < nPFB; k++){
    n	=PFB[k].nr;
    ds	=(Rb2[k]-Rb1[k])/n;
    for(i=1; i < n; i++){
      s	=Rb1[k]+ds*i;
      ZPlotLine(s,Zb1[k],s,Zb2[k]);
    }
    n	=PFB[k].nz;
    ds	=(Zb2[k]-Zb1[k])/n;
    for(i=1; i < n; i++){
      s	=Zb1[k]+ds*i;
      ZPlotLine(Rb1[k],s,Rb2[k],s);
    }
  }
  ZStroke();
  return;
}

void PFBPlot()
{
  int i,j,n,L;
  char *lc,ln[32];
  extern double PSfh;
  extern int wF,hF,wFHelp,hFHelp;
  double fh,x[6],y[6],d,h;
  double xS[nPFB],yS[nPFB],wS[nPFB];
  double sx,sy;

  CbGetScale(&sx,&sy);
  fh	=PSfh;
  PSfh	=7.;
  for(j=1; j < nPFB; j++){
    i	=strncmp(PFB[j].Nm,"OH",2) ? 4 : 14; 
    i	=11;
    ZPlotRect(Rb1[j],Zb1[j],Rb2[j],Zb2[j],i);
  }
  PFBGrid();
  ZColor(0);
  for(j=0; j < nPFB; j++){
    x[0]	=Rb1[j];
    x[1]	=Rb2[j];
    x[2]	=Rb2[j];
    x[3]	=Rb1[j];
    x[4]	=x[0];
    y[0]	=Zb1[j];
    y[1]	=Zb1[j];
    y[2]	=Zb2[j];
    y[3]	=Zb2[j];
    y[4]	=y[0];
    ZPlotPolyLine(x,y,5);
  }

  VVBPlot();
  ZColor(4);
  ZPlotPolyLine(ESRLm,ESZLm,ESnLm);

  if(kPFBPlot == 0) return;
  ZColor(0);
  d	=2./sx;
  h	=hF/fabs(sy);
  for(i=1; i < nPFB; i++){
    sprintf(ln,"%s.%s",PFB[i].NmC,PFB[i].Nm);
    L	=strlen(ln);
    xS[i]=PFB[i].r[1]+d;
    yS[i]=PFB[i].z[0];
    wS[i]=L*wF/sx;
    j	=1;
    while(j < i){
      if(yS[i] < yS[j]+h && yS[i]+h > yS[j] && xS[i] < xS[j]+wS[j] && 
	 xS[i]+wS[i] > xS[j]) yS[i] = PFB[i].Z < PFB[j].Z ? yS[j]-h: yS[j]+h;
      j++;
    }
    ZPlotLUString(xS[i],yS[i],ln,L);
  }
  PSfh	=fh;
}

int PFBlocks()
{
  static int iNm=0;
  int i,j,m,n,Fl;
  PFBLOCK *lB;

#ifndef AscI_PFBlocks
#undef AscI_PFBlocks
#endif/*AscI_PFBlocks*/
  PFReInitPFB();
  PFB[0].nr	=NplG[0];
  PFB[0].nz	=NplG[1];

  for(i=0; i < nPFB; i++){
    lB		=PFB+i;

    Rb1[i]	=lB->r[0];
    Zb1[i]	=lB->z[0];
    Rb2[i]	=lB->r[1];
    Zb2[i]	=lB->z[1];
  }
  {
    int nr[nPFB],nz[nPFB];
    double r1[nPFB],r2[nPFB],z1[nPFB],z2[nPFB];
    char *NmB[nPFB];

    for(i=0; i < nPFB; i++){
      nr[i]	=PFB[i].nr;
      nz[i]	=PFB[i].nz;
      r1[i]	=Rb1[i];
      r2[i]	=Rb2[i];
      z1[i]	=Zb1[i];
      z2[i]	=Zb2[i];
    }

#ifndef Tbl_PFBlocks
    n	=nPFB;
    i	=0;
    NmB[i]	=iNm ? PFB[i].Nm : PFB[i].NmC;
    for(i=1; i < nPFB; i++){
      if(Rb1[i] != r1[i] || Rb2[i] != r2[i] || PFB[i].nr != nr[i] ||
	 Zb1[i] != z1[i] || Zb2[i] != z2[i] || PFB[i].nz != nz[i]){
	PFB[i].nr=nr[i];
	PFB[i].nz=nz[i];
	Rb1[i]	=r1[i];
	Rb2[i]	=r2[i];
	Zb1[i]	=z1[i];
	Zb2[i]	=z2[i];
      }
      NmB[i]	=iNm ? PFB[i].Nm : PFB[i].NmC;
    }
    nr[0]	=PFB[0].nr;
    nz[0]	=PFB[0].nz;
    r1[0]	=Rb1[0];
    r2[0]	=Rb2[0];
    z1[0]	=Zb1[0];
    z2[0]	=Zb2[0];
    CbUserPlot	=PFBPlot;
#endif/*Tbl_PFBlocks*/
  }
  NplG[0]	=PFB[0].nr;
  NplG[1]	=PFB[0].nz;
  for(i=0; i < nPFB; i++){
    lB		=PFB+i;
    lB->R	=cr2*(Rb2[i]+Rb1[i]);
    lB->dR	=cr2*(Rb2[i]-Rb1[i]);
    lB->Z	=cr2*(Zb2[i]+Zb1[i]);
    lB->dZ	=cr2*(Zb2[i]-Zb1[i]);
    lB->r[0]	=Rb1[i];
    lB->z[0]	=Zb1[i];
    lB->r[1]	=Rb2[i];
    lB->z[1]	=Zb2[i];
  }

#ifndef AscO_PFBlocks
#undef AscO_PFBlocks
#endif/*AscO_PFBlocks*/
  i		=0;
  lB		=PFB;
  lB->gr	=0.;
  lB->Res	=0.;
  lB->gt	=0.;
  lB->AI	=0.;
  lB->I		=0.;
  lB->gY	=0.;
  lB->gY	=0.;
  lB->V		=0.;
  lB->gq	=0.;
  lB->kS	=0;
  lB->kA	=1;
  for(i=1; i < nPFB; i++){
    lB++;
    lB->gr	=1e-6;
    lB->Res	=c2gp*lB->R*lB->tn*lB->tn*lB->gr/(4.*lB->dR*lB->dZ);
    lB->gt	=0.;
    lB->AI	=0.;
    lB->I	=0.;
    lB->gY	=0.;
    lB->V	=0.;
    lB->gq	=0.;
    lB->kS	=0;
    lB->kA	=1;
  }
#ifdef H
  PFReInitGreenBlocks();
#ifndef BnrI_PFBlocks
#undef BnrI_PFBlocks
#endif/*BnrI_PFBlocks*/
  PFSetLijBlocks();
#ifndef BnrO_PFBlocks
#undef BnrO_PFBlocks
#endif/*BnrO_PFBlocks*/
#endif
  return(0);
}
#endif

#ifndef stg_ElecPar
void IbPFBPlot()
{
  int i,j;
  char *lc;
  extern double PSfh;
  extern double ESTime;
  double fh=PSfh;

  PSfh	=7.;
  j	=0;
  ZPlotRect(Rb1[j],Zb1[j],Rb2[j],Zb2[j],12);
  for(j=1; j < nPFB; j++){
    lc	=PFB[j].Nm;
    i	=strncmp(lc,"OH",2) == 0 ? 14 : 4;
    if(*lc == 'V' || *lc == 'v' || *lc == 'I' || *lc == 'i') i=10;
    ZPlotRect(Rb1[j],Zb1[j],Rb2[j],Zb2[j],i);
    ZPlotLUString(Rb2[j]+0.01,Zb1[j],lc,strlen(lc));
  }
  MFPPlot();
  ZColor(0);
  ZPlotPolyLine(ESRLm,ESZLm,ESnLm);
  PSfh	=fh;
}

void IbPFCPlot()
{
  int i,j;
  char *lc;
  extern double PSfh;
  double fh=PSfh;

  PSfh	=7.;
  j	=0;
  ZPlotRect(Rb1[j],Zb1[j],Rb2[j],Zb2[j],12);
  for(j=1; j < nPFB; j++){
    i	=PFB[j].kC;
    lc	=PFC[i].Nm;

    i++;
#ifdef H
 out("????? i I II",j,i,PFB[j].kc,kCol[PFB[j].kc%0x10]);


    i	=strncmp(lc,"OH",2) == 0 ? 14 : 4;
    if(*lc == 'V' || *lc == 'v' || *lc == 'I' || *lc == 'i') i=10;

int kCol[16]={0,0,14,11,4,12,17,13,0,0,14,11,4,12,17,13};              
int kCol[16]={54 ,58 ,56,55 ,57 ,59,60,61,62,63,64,65,66,67,68,69};
 out("????? i II",i%0x10,PFB[j].kc,kCol[PFB[j].kc%0x10]);
#endif


    ZPlotRect(Rb1[j],Zb1[j],Rb2[j],Zb2[j],kCol[PFB[j].kc-1]);
  }
  if(kPFBPlot){
    ZColor(0);
    for(j=1; j < nPFB; j++){
      i	=PFB[j].kC;
      lc	=PFC[i].Nm;
      ZPlotLUString(Rb2[j]+0.01,Zb1[j],lc,strlen(lc));
    }
  }
  PFEfitBoundPlot();
  MFPPlot();
  ZColor(0);
  ZPlotPolyLine(ESRLm,ESZLm,ESnLm);
  PSfh	=fh;
}

void IbPFIPlot()
{
  int i,j;
  char ln[16],ln1[8];
  extern double PSfh;
  double fh=PSfh;

  PSfh	=7.;
  j	=0;

  if(NPFB){
    ZPlotRect(Rb1[j],Zb1[j],Rb2[j],Zb2[j],12);
    for(j=1; j < nPFB; j++){
      i	=strncmp(PFB[j].Nm,"OH",2) == 0 ? 14 : 4;
      ZPlotRect(Rb1[j],Zb1[j],Rb2[j],Zb2[j],kCol[PFB[j].kc-1]);
      numstr(PFB[j].AI,ln,6);
      strcpy(ln1,"I=");
      i	=CbStrCpy(ln1+2,ln);
      ZPlotLUString(Rb2[j]+0.01,Zb1[j],ln1,i+2);
    }
  }
  if(NPFB){
    PFEfitBoundPlot();
    MFPPlot();
  }
  if(NLm){
    ZColor(0);
    ZPlotPolyLine(ESRLm,ESZLm,ESnLm);
  }
  if(MSEFl || MSSFl) MSEDiagnosticPlot();
  if(ESNsep) PlotSepLine();
  if(VVWall.n1){
    ZColor(13);
    SetLine(0,3);
    ZPlotPolyLine(VVWall.r,VVWall.z,VVWall.n1);
    SetLine(0,1);
  }

  if(VVTile.n1){
    ZColor(13);
    SetLine(0,3);
    ZPlotPolyLine(VVTile.r,VVTile.z,VVTile.n1);
  }
  PSfh	=fh;
}

int PFDeInitPFC()
{
  if(NPFC){
    free(FlPFC);
    free(gYcC[0]);
    free(gYiC[0]);
    free(gYpC[0]);
    free(gYCC[0]);
    free(gYCC);
    free(PFC);
    NPFC	=0;
  }
  return(0);
}

int PFReInitPFC()
{
  if(NPFC < nPFC){
    int i;

    if(NPFC) PFDeInitPFC();
    gYCC=(double**)malloc((nPFC+EGNp+nMFP)*sizeof(double*));
    
    PFC	=(PFCOIL*)calloc((nPFC1),sizeof(PFCOIL));
    if(PFC == NULL || gYCC == NULL){
      printf("No memory for PFCoils in PFReInitPFC()\n");
      return(1);
    }
    gYpC	=gYCC+nPFC;
    gYiC	=gYpC+EGNp;
    
    gYCC[0]	=(double*)malloc(nPFC*nPFC*sizeof(double));
    if(gYCC[0] == NULL){
      CbStr2UserWarning("No memory for gYCC[0] in PFReInitPFC()\n");
      return(1);
    }
    for(i=1; i < nPFC; i++) gYCC[i]=gYCC[i-1]+nPFC;

    gYpC[0]	=(double*)malloc(EGNp*nPFC*sizeof(double));
    if(gYpC[0] == NULL){
      CbStr2UserWarning("No memory for gYpC[0] in PFReInitPFC()\n");
      return(1);
    }
    for(i=1; i < EGNp; i++) gYpC[i]=gYpC[i-1]+nPFC;

    gYiC[0]	=(double*)malloc(nMFP*nPFC*sizeof(double));
    if(gYiC[0] == NULL){
      CbStr2UserWarning("No memory for gYiC[0] in PFReInitPFC()\n");
      return(1);
    }
    for(i=1; i < nMFP; i++) gYiC[i]=gYiC[i-1]+nPFC;

    gYcC[0]	=(double*)malloc(12*3*nPFC*sizeof(double));
    if(gYcC[0] == NULL){
      CbStr2UserWarning("No memory for gYcC[0] in PFReInitPFC()\n");
      return(1);
    }
    BRcC[0]	=gYcC[0]+12*nPFC;
    BZcC[0]	=BRcC[0]+12*nPFC;

    for(i=1; i < 12; i++){
      gYcC[i]	=gYcC[i-1]+nPFC;
      BRcC[i]	=BRcC[i-1]+nPFC;
      BZcC[i]	=BZcC[i-1]+nPFC;
    }
    FlPFC	=(int*)malloc(nPFC*sizeof(int));
    NPFC	=nPFC1;
  }
  ESmemlevP |=0x00000800;
  return(0);
}

int ElecParAO(FILE *lf)
{
  PFBLOCK *lB;
  char st[0x80],str0[0x80];
  char ln[0x80];
  char *lc;
  int i,j,k,L;

  L=0;
  for(i=0; i < nPFB1; i++){
    j=strlen(PFB[i].Nm);
    if(L < j) L=j;
  }

  sprintf(ln,"%s%d%s","%3d %5d %2d %",L,"s %s%c");
  sprintf(st,"%s%d%s","%3s %5s %2s %",L,"s %s\n");
  strcpy(str0,ln);
  FormatWrite2Read(str0);
  fprintf(lf,"\n<Electric Parameters>[%d](%s)\n",nPFB+1,str0);
  fprintf(lf,st,"!nB","Coil#","c","NmBlock","Coil");
  for(i=0; i < nPFC1; i++){
    lc	=PFC[i].kA ? PFC[i].Nm : ">--<";
    L	=PFC[i].nB;
    for(j=0; j < L; j++){
      k	=PFC[i].kB[j];
      lB	=PFB+k;
      fprintf(lf,ln,k,lB->kC,lB->kc,lB->Nm,lc,'\n');
    }
  }
  fprintf(lf,st,"!nB","Coil#","c","NmBlock","Coil");

  fputs("\n! #        enumeration\n"            
	"! Coil#    coil number, should be in ascending order\n"
	"! Data#    enumeration of signals as read from the data base\n"
	"! c        color: 0 - absent, 1- black\n"
	"! kG       group number\n"
	"! NmBlock  name of the PFBlock\n"
	"! Circuit  name of the PFCoil\n\n",lf);
  return(0);
}

int ElecParAI(FILE *lf)
{
  int i,j,k,n;
  int kk[nPFB+1];
  PFBLOCK B[nPFB+1];
  PFBLOCK *lB,*lb;
  char str[64];
  char *lc,*lt;
  char *lm;
  char *lv[8];
  int dl[8];

  lm	="ElecPar.ai";

  lc	="<Electric Parameters>";
  if(IsKeyWordFound(lf,lm,lc,str,&n)){
    if(nPFB != n-1){
      CbStr2UserMessage("Error:%s %s: nPFB=%d !=%d\n",lm,lc,nPFB,n-1);
      printf("Error:%s %s: nPFB=%d !=%d\n",lm,lc,nPFB,n-1);
      return(1);
    } 
    lB		=B;
    lv[0]	=(char*)kk;
    lv[1]	=(char*)&lB->kC;
    lv[2]	=(char*)&lB->kc;
    lv[3]	=(char*)lB->Nm;
    lv[4]	=(char*)lB->NmC;
    dl[0]	=sizeof(int);
    dl[1]	=sizeof(PFBLOCK);
    dl[2]	=dl[1];
    dl[3]	=dl[1];
    dl[4]	=dl[1];
    ReadAI(lf,lc,lm,str,n,lv,dl,5);
    CbStr2UserMessage("%s:%s\n",lm,lc);
  }
  else{
    CbStr2UserMessage("Error:%s: %s is absent\n",lm,lc);
    printf("Error:%s: %s is absent\n",lm,lc);
    return(1);
  }

  for(i=0,lB=B; i < n; i++,lB++){
    lb	=PFB+kk[i];
    lb->kC	=lB->kC;
    lb->kc	=lB->kc;
    if(strcmp(lb->Nm,lB->Nm)){
      CbStr2UserMessage("Error:%s: <%s>[%d] !=<%s>%d\n"
			,lm,lb->Nm,i,lB->Nm,kk[i]);
      printf("Error:%s: <%s>[%d] !=<%s>%d\n",lm,lb->Nm,i,lB->Nm,kk[i]);
      return(1);
    } 
    strcpy(lb->NmC,lB->NmC);
  }
  return(0);
}


#ifdef H
int SetLijPFCoils00()
{
  int i,j,ni,nj,ii,jj,ki,kj;
  double Y,Br,Bz,t;
  int *li,*lj;

  for(i=1; i < nPFC; i++){
    ni	=PFC[i].nB;
    li	=PFC[i].kB;
    for(j=i; j < nPFC; j++){
      nj	=PFC[j].nB;
      lj	=PFC[j].kB;
      Y	=0.;
      for(ii=0; ii < ni; ii++){
	ki	=li[ii];
	for(jj=0; jj < nj; jj++){
	  kj	=lj[jj];
	  Y	+=PFB[ki].tn*gYbb[ki][kj]*PFB[kj].tn;
	}
      }
      gYCC[i][j]	=Y;
      gYCC[j][i]	=Y;
    }
  }
  for(i=0; i < EGNp; i++){
    for(j=1; j < nPFC; j++){
      nj	=PFC[j].nB;
      lj	=PFC[j].kB;
      Y	=0.;
      for(jj=0; jj < nj; jj++){
	kj	=lj[jj];
	Y	+=gYpb[i][kj]*PFB[kj].tn;
      }
      gYpC[i][j]	=Y;
    }
  }
  for(i=0; i < nMFP; i++){
    for(j=1; j < nPFC; j++){
      nj	=PFC[j].nB;
      lj	=PFC[j].kB;
      Y		=0.;
      for(jj=0; jj < nj; jj++){
	kj	=lj[jj];
	Y	+=gYib[i][kj]*PFB[kj].tn;
      }
      gYiC[i][j]	=Y;
    }
  }
  return(0);
}
#endif

int AddFlPFC(int k)
{
  int i;
  for(i=0; i < nPFC; i++){
    FlPFC[i]	|=k;
  }
  return(0);
}

int MFCalibrAO()
{
  FILE *lF;
  char FNm[64]="Machine.ai";
  int i,j,k,n,L;
  char str[64];
  char *lc;

  L	=0;
  for(i=0; i < nMFP; i++) if(L < (j=strlen(MFP[i].Nm))) L=j;

  lF	=fopen(FNm,"w");

  n	=nPFC1;
  fprintf(lF,"<PFC Names>[%d](%d%s)\n",1,n,"%s");
  sprintf(str,"%c%ds",'%',L);
  fprintf(lF,str,PFC[0].Nm);
  k	=0;
  for(i=1; i < n; i++){
    if(k == 0 && i-1) fprintf(lF,str,"");
    fprintf(lF,"%24s",PFC[i].Nm);
    k++;
    if(k == 3){
      fputc('\n',lF);
      k	=0;
    }
  }
  if(k) fputc('\n',lF);

  fprintf(lF,"\n<MFProbe-PFC Green Functions>[%d](%s %d%s)\n"
	  ,nMFP,"%s",n-1,"%e");
  sprintf(str,"!%c%ds",'%',L-1);
  fprintf(lF,str,"Name");
  k	=0;
  for(i=1; i < n; i++){
    if(k == 0 && i-1) fprintf(lF,str,"");
    fprintf(lF,"%24s",PFC[i].Nm);
    k++;
    if(k == 3){
      fputc('\n',lF);
      k	=0;
    }
  }
  if(k) fputc('\n',lF);
  sprintf(str,"%c%ds",'%',L);

  for(j=0; j < nMFP; j++){
    fprintf(lF,str,MFP[j].Nm);
    k	=0;
    for(i=1; i < n; i++){
      if(k == 0 && i-1) fprintf(lF,str,"");
      fprintf(lF,"%24.16e",i < nPFC ? gYiC[j][i]: 0.);
      k++;
      if(k == 3){
	fputc('\n',lF);
	k	=0;
      }
    }
    if(k) fputc('\n',lF);
  }
  fclose(lF);
  {
    char *lD;
    CbGetCurrentCbName(&lD,&lc);
    printf("Output: %s mv %s %s/In\n",FNm,FNm,lD);
  }

  return(0);
}

int PFWriteElecParBO(FILE *lf)
{
  PFBLOCK *lB;
  PSBLOCK *lS;
  
  int i,n;
  size_t ii,id;

  ii	=(size_t)sizeof(int);
  id	=(size_t)sizeof(double);

  /* Plasma */
  fwrite(NplG,ii,(size_t)2,lf);
  fwrite(RplG,id,(size_t)2,lf);
  fwrite(ZplG,id,(size_t)2,lf);
  
  /* Probes */
  fwrite(&nMFL,ii,(size_t)1,lf);
  fwrite(&nMFS,ii,(size_t)1,lf);
  fwrite(&nMFp,ii,(size_t)1,lf);
  for(i=0; i < nMFL; i++){
    fwrite(&MFL[i].R,id,(size_t)1,lf);
    fwrite(&MFL[i].Z,id,(size_t)1,lf);
  }
  for(i=0; i < nMFS; i++){
    fwrite(&MFS[i].R,id,(size_t)1,lf);
    fwrite(&MFS[i].Z,id,(size_t)1,lf);
    fwrite(&MFS[i].R1,id,(size_t)1,lf);
    fwrite(&MFS[i].Z1,id,(size_t)1,lf);
  }
  for(i=0; i < nMFp; i++){
    fwrite(&MFp[i].R,id,(size_t)1,lf);
    fwrite(&MFp[i].Z,id,(size_t)1,lf);
    fwrite(&MFp[i].Tr,id,(size_t)1,lf);
    fwrite(&MFp[i].Tz,id,(size_t)1,lf);
  }

  /* PFBlocks */
  fwrite(&nPFB,ii,(size_t)1,lf);
  for(i=0; i < nPFB; i++){
    fwrite(&(PFB[i].nr),ii,(size_t)1,lf);
    fwrite(&(PFB[i].nz),ii,(size_t)1,lf);
    fwrite(&(PFB[i].kC),ii,(size_t)1,lf);
  }
  for(i=0; i < nPFB; i++){
    lB	=PFB+i;
    fwrite(&lB->R, id,(size_t)1,lf);
    fwrite(&lB->dR,id,(size_t)1,lf);
    fwrite(&lB->Z, id,(size_t)1,lf);
    fwrite(&lB->dZ,id,(size_t)1,lf);
  }

  /* Green Functions */
  for(i=0; i < EGNp; i++){
    fwrite(gYpC[i],id,(size_t)nPFC,lf);
  }
  for(i=1; i < nPFC; i++){
    fwrite(gYCC[i]+i,id,(size_t)(nPFC-i),lf);
  }
  for(i=0; i < nMFP; i++){
    fwrite(gYiC[i],id,(size_t)nPFC,lf);
  }
  return(0);
}

int PFReadElecParBI(FILE *lf)
{
  PFBLOCK *lB;
  PSBLOCK *lS;
  int i,n,nC,m,k[4];
  double s[4];
  size_t ii,id;

  ii	=(size_t)sizeof(int);
  id	=(size_t)sizeof(double);

  for(i=0; i < nPFC; i++){
    FlPFC[i]	=0;
  }

  /* Plasma */
  m	=fread(k,ii,(size_t)2,lf);
  if(m < 2 || NplG[0] != k[0] || NplG[1] != k[1]){
    AddFlPFC(0x1f);
    return(1);
  }
  m	=fread(s,id,(size_t)4,lf);
  if(m < 4 || RplG[0] != s[0] || RplG[1] != s[1] || 
     ZplG[0] != s[2] || ZplG[1] != s[3]){
    AddFlPFC(0x1f);
    return(1);
  }

  /* Probes */
  m	=fread(k,ii,(size_t)3,lf);
  if(m < 3 || k[0] != nMFL || k[1] != nMFS || k[2] != nMFp){
    AddFlPFC(0x1e);
    return(1);
  }
  for(i=0; i < nMFL; i++){
    if(fread(s,id,(size_t)2,lf) < 2 || s[0] != MFL[i].R || s[1] != MFL[i].Z){
      AddFlPFC(0x1e);
      return(1);
    }
  }
  for(i=0; i < nMFS; i++){
    m	=fread(s,id,(size_t)4,lf);
    if(m < 4 || s[0] != MFS[i].R || s[1] != MFS[i].Z || 
       s[2] != MFS[i].R1 || s[3] != MFS[i].Z1){
      AddFlPFC(0x1c);
      return(1);
    }
  }
  for(i=0; i < nMFp; i++){
    m	=fread(s,id,(size_t)4,lf);
    if(m < 4 || s[0] != MFp[i].R || s[1] != MFp[i].Z || 
       s[2] != MFp[i].Tr || s[3] != MFp[i].Tz){
      AddFlPFC(0x18);
      return(1);
    }
  }

  /* PFBlocks */
  m	=fread(k,ii,(size_t)1,lf);
  if(m < 1 || nPFB != k[0]){
    AddFlPFC(0x10);
    return(1);
  }
  for(i=0; i < nPFB; i++){
    m	=fread(k,ii,(size_t)3,lf);
    if(m < 3 || PFB[i].nr != k[0] || PFB[i].nz != k[1] || PFB[i].kC != k[2]){
      AddFlPFC(0x10);
      return(1);
    }
  }

  for(i=0; i < nPFB; i++){
    lB	=PFB+i;
    m	=fread(s,id,(size_t)4,lf);
    if(m < 4){
      AddFlPFC(0x10);
      return(1);
    }
    if(lB->R != s[0] || lB->dR != s[1] || lB->Z != s[2] || lB->dZ != s[3]){
      FlPFC[lB->kC]	|=0x10;
    }
  }

  /* Green Functions */
  for(i=0; i < EGNp; i++){
    m	=fread(gYpC[i],id,(size_t)nPFC,lf);
    if(m < nPFC){
      AddFlPFC(0x1f);
      return(1);
    }
  }

  for(i=1; i < nPFC; i++){
    m	=fread(gYCC[i]+i,id,(size_t)(nPFC-i),lf);
    if(m < nPFC-i){
      AddFlPFC(0x1e);
      return(1);
    }
    for(m=i+1; m < nPFC; m++){
      gYCC[m][i]	=gYCC[i][m];
    }
  }
  for(i=0; i < nMFP; i++){
    m	=fread(gYiC[i],id,(size_t)nPFC,lf);
    if(m < nPFC){
      AddFlPFC(0x1c);
      return(1);
    }
  }
  return(0);
}

int SetLijPFCoils()
{
  MFPROBE *lP;
  PFBLOCK *lB0,*lB1;
  char ln[64];

  int kCj,kCi,n;
  int m,mr,mz,k,kr,kz;
  int nr0,nz0,nr1,nz1;
  double r0,z0,r1,z1;
  double hr0,hz0,hr1,hz1;
  double R0,Z0,R1,Z1;
  double ss,s,gY,Br,Bz,gy,br,bz,Tr,Tz;
  static int nx=4,ny=4;
  
  int ix0,iy0,ix1,iy1;
  double b,a,c,d;
  double x0,y0,x1,y1,dx0,dy0,dx1,dy1,ga,gaa,gr,grr;

  double Y1,Y2;
  int ni,*li,nj,*lj,i,ii,j,jj;
  nx	=4;
  ny	=4;

  ss	=nx*ny;
  ss	=1./(ss*ss);

  hr0	=EGdr;
  hz0	=EGdz;
  dx0	=hr0/nx;
  dy0	=hz0/ny;
  a	=dy0/dx0;
  if(a > 3.0){
    d	=.13;
  }
  else{
    if(a >= 2.){
      d	=0.2+0.11*(3.-a);
    }
    else{
      if(a >= 1.6){
	d	=.31+.2*(2.-a);
      }
      else{
	if(a >= 1.){
	  d	=.39+.7167*(1.6-a);
	}
	else{
	  d	=.82;
	}
      }
    }
  }

  for(m=0; m < EGNp; m++){
    r0	=EGaRp[m];
    z0	=EGaZp[m];
    R0	=r0-cr2*hr0;
    Z0	=z0-cr2*hz0;
    sprintf(ln,"Plasma-PFCoils: %4d < %d",m,EGNp);
    ZMessage(ln);
    for(j=1; j < nPFC; j++){
      if((FlPFC[j]&0x01)){
	nj	=PFC[j].nB;
	lj	=PFC[j].kB;
	gYpC[m][j]	=0.;
	for(jj=0; jj < nj; jj++){
	  k	=lj[jj];
	  lB1	=PFB+k;
	  nr1	=lB1->nr;
	  hr1	=2.*lB1->dR/nr1;
	  nz1	=lB1->nz;
	  hz1	=2.*lB1->dZ/nz1;
	  dx1	=hr1/nx;
	  dy1	=hz1/ny;
	  R1	=lB1->R-lB1->dR;
	  r1	=R1+cr2*hr1;
	  gY	=0.;
	  for(kr=0; kr < nr1; kr++){
	    Z1	=lB1->Z-lB1->dZ;
	    z1	=Z1+cr2*hz1;
	    for(kz=0; kz < nz1; kz++){
	      if(fabs(r0-r1) > 1.1*hr0 || fabs(z0-z1) > 1.1*hz0){
		gY	+=GPring(r0,z0,r1,z1);
	      }
	      else{
		x0	=R0+cr2*dx0;
		for(ix0=0; ix0 < nx; ix0++){
		  y0	=Z0+cr2*dy0;
		  for(iy0=0; iy0 < ny; iy0++){
		    x1	=R1+cr2*dx1;
		    for(ix1=0; ix1 < nx; ix1++){
		      y1	=Z1+cr2*dy1;
		      for(iy1=0; iy1 < ny; iy1++){
			gY	+=GPring(x0,y0,x1,y1)*ss;
			y1	+=dy1;
		      }
		      x1	+=dx1;
		    }
		    y0	+=dy0;
		  }
		  x0	+=dx0;
		}
	      }
	      z1 	+=hz1;
	      Z1	+=hz1;
	    }
	    r1 +=hr1;
	    R1 +=hr1;
	  }
	  gY	=gY*lB1->tn/(nr1*nz1);
	  gYpC[m][j]	+=gY;
	}
      }
    }
  }

  for(i=1; i < nPFC; i++){
    sprintf(ln,"PFCoils-PFCoils: %4d < %d",i,nPFC);
    ZMessage(ln);
    ni	=PFC[i].nB;
    li	=PFC[i].kB;
    for(j=i; j < nPFC; j++){
      if((FlPFC[i]&0x10) || (FlPFC[j]&0x10)){
	gYCC[i][j]	=0.;
	nj	=PFC[j].nB;
	lj	=PFC[j].kB;
	for(ii=0; ii < ni; ii++){
	  lB0	=PFB+li[ii];
	  nr0	=lB0->nr;
	  hr0	=2.*lB0->dR/nr0;
	  nz0	=lB0->nz;
	  hz0	=2.*lB0->dZ/nz0;
	  dx0	=hr0/nx;
	  dy0	=hz0/ny;
	  a	=dy0/dx0;
	  if(a > 3.0){
	    d	=.13;
	  }
	  else{
	    if(a >= 2.){
	      d	=0.2+0.11*(3.-a);
	    }
	    else{
	      if(a >= 1.6){
		d	=.31+.2*(2.-a);
	      }
	      else{
		if(a >= 1.){
		  d	=.39+.7167*(1.6-a);
		}
		else{
		  d	=.82;
		}
	      }
	    }
	  }
	  for(jj=0; jj < nj; jj++){
	    lB1	=PFB+lj[jj];
	    nr1	=lB1->nr;
	    hr1	=2.*lB1->dR/nr1;
	    nz1	=lB1->nz;
	    hz1	=2.*lB1->dZ/nz1;
	    dx1	=hr1/nx;
	    dy1	=hz1/ny;
	    gY	=0.;
	    R0	=lB0->R-lB0->dR;
	    r0	=R0+cr2*hr0;
	    for(mr=0; mr < nr0; mr++){
	      Z0	=lB0->Z-lB0->dZ;
	      z0	=Z0+cr2*hz0;
	      for(mz=0; mz < nz0; mz++){
		R1	=lB1->R-lB1->dR;
		r1	=R1+cr2*hr1;
		for(kr=0; kr < nr1; kr++){
		  Z1	=lB1->Z-lB1->dZ;
		  z1	=Z1+cr2*hz1;
		  for(kz=0; kz < nz1; kz++){
		    a	=r0-r1;
		    b	=z0-z1;
		    if(fabs(r0-r1) > 1.1*hr0 ||fabs(z0-z1) > 1.1*hz0){
		      gY	+=GPring(r0,z0,r1,z1);
		    }
		    else{
		      x0	=R0+cr2*dx0;
		      for(ix0=0; ix0 < nx; ix0++){
			y0	=Z0+cr2*dy0;
			for(iy0=0; iy0 < ny; iy0++){
			  x1	=R1+cr2*dx1;
			  for(ix1=0; ix1 < nx; ix1++){
			    y1	=Z1+cr2*dy1;
			    for(iy1=0; iy1 < ny; iy1++){
			      y1	=Z1+(cr2+iy1)*dy1;
			      a	=x0-x1;
			      b	=y0-y1;
			      if(fabs(x0-x1) < dx0 && fabs(y0-y1) < dy0){
				ga	=cr2*dy0/x0;
				gr	=cr2*dx0/x0;
				gaa	=ga*ga;
				grr	=gr*gr;
				a	=4./(ga+gr);
				b	=(3.*gaa+grr)/24.;
				c	=4./sqrt(gaa+grr);
				gY+=cgm0*x0*(log(a)-cr2+b*log(c)+d*gaa*.25)*ss;
			      }
			      else{
				gY	+=GPring(x0,y0,x1,y1)*ss;
			      }
			      y1	+=dy1;
			    }
			    x1	+=dx1;
			  }
			  y0	+=dy0;
			}
			x0	+=dx0;
		      }
		    }
		    z1 	+=hz1;
		    Z1 	+=hz1;
		  }
		  r1 +=hr1;
		  R1 +=hr1;
		} 
		z0 +=hz0;
		Z0 +=hz0;
	      }
	      r0 +=hr0;
	      R0 +=hr0;
	    }
	    gY	=gY*lB0->tn*lB1->tn/(nr0*nz0*nr1*nz1);
	    gYCC[i][j] +=gY;
	  }
	}
	if(i != j) gYCC[j][i]=gYCC[i][j];
      }
    }
  }

  ss	=(double)1./(nx*ny);
  n	=nMFLS+nMFp;
  for(m=0; m < n; m++){
    sprintf(ln,"Probes-Blocks: %4d < %d",m,nMFP);
    ZMessage(ln);
    lP	=MFP+m;
    r0	=lP->R;
    z0	=lP->Z;
    Tr	=lP->Tr; 
    Tz	=lP->Tz;
    for(j=1; j < nPFC; j++){
      if((FlPFC[j]&0x0e)){
	nj	=PFC[j].nB;
	lj	=PFC[j].kB;
	gYiC[m][j]	=0.;
	for(jj=0; jj < nj; jj++){
	  lB1	=PFB+lj[jj];
	  nr1	=lB1->nr;
	  hr1	=2.*lB1->dR/nr1;
	  nz1	=lB1->nz;
	  hz1	=2.*lB1->dZ/nz1;
	  s	=lB1->tn/(nr1*nz1);
	  dx1	=hr1/nx;
	  dy1	=hz1/ny;
	  gY	=0.;
	  Br	=0.;
	  Bz	=0.;
	  R1	=lB1->R-lB1->dR;
	  r1	=R1+cr2*hr1;
	  for(kr=0; kr < nr1; kr++){
	    Z1	=lB1->Z-lB1->dZ;
	    z1	=Z1+cr2*hz1;
	    for(kz=0; kz < nz1; kz++){
	      br	=r0-r1;
	      bz	=z0-z1;
	      if(fabs(r0-r1) > hr1 || fabs(z0-z1) > hz1){
		MFring(&gy,&br,&bz,r0,z0,r1,z1,(double)1.);
		gY	+=gy;
		Br	+=br;
		Bz	+=bz;
		if(lP->kA == 2){
		  MFring(&gy,&br,&bz,lP->R1,lP->Z1,r1,z1,(double)1.);
		  gY	-=gy;
		  Br	-=br;
		  Bz	-=bz;
		}
	      }
	      else{
		x1	=R1+cr2*dx1;
		for(ix1=0; ix1 < nx; ix1++){
		  y1	=Z1+cr2*dy1;
		  for(iy1=0; iy1 < ny; iy1++){
		    MFring(&gy,&br,&bz,r0,z0,x1,y1,ss);
		    gY	+=gy;
		    Br	+=br;
		    Bz	+=bz;
		    if(lP->kA == 2){
		      MFring(&gy,&br,&bz,lP->R1,lP->Z1,x1,y1,ss);
		      gY	-=gy;
		      Br	-=br;
		      Bz	-=bz;
		    }
		    y1	+=dy1;
		  }
		  x1	+=dx1;
		}
	      }
	      z1 	+=hz1;
	      Z1	+=hz1;
	    }
	    r1 +=hr1;
	    R1 +=hr1;
	  }
	  gY	=lP->kA < 3 ? gY*s : (Br*Tr+Bz*Tz)*s;
	  gYiC[m][j]	+=gY;
	}
      }
    }
  }
  return(0);
}

int SetLijPFCoilsOld()
{
  MFPROBE *lP;
  PFBLOCK *lB0,*lB1;
  char ln[64];

  int kCj,kCi;
  int m,mr,mz,k,kr,kz;
  int nr0,nz0,nr1,nz1;
  double r0,z0,r1,z1;
  double hr0,hz0,hr1,hz1;
  double R0,Z0,R1,Z1;
  double ss,s,gY,Br,Bz,gy,br,bz,Tr,Tz;
  static int nx=4,ny=4;
  
  int ix0,iy0,ix1,iy1;
  double b,a,c,d;
  double x0,y0,x1,y1,dx0,dy0,dx1,dy1,ga,gaa,gr,grr;

  nx	=4;
  ny	=4;

  ss	=nx*ny;
  ss	=1./(ss*ss);

  lB0	=PFB;
  hr0	=EGdr;
  hz0	=EGdz;
  dx0	=hr0/nx;
  dy0	=hz0/ny;
  a	=dy0/dx0;
  if(a > 3.0){
    d	=.13;
  }
  else{
    if(a >= 2.){
      d	=0.2+0.11*(3.-a);
    }
    else{
      if(a >= 1.6){
	d	=.31+.2*(2.-a);
      }
      else{
	if(a >= 1.){
	  d	=.39+.7167*(1.6-a);
	}
	else{
	  d	=.82;
	}
      }
    }
  }
  dx1	=dx0;
  dy1	=dy0;

  for(k=1; k < nPFC; k++){
    if((FlPFC[k]&0x01)){
      for(m=0; m < EGNp; m++){
	gYpC[m][k]	=0.;
      }
    }
  }

  for(m=0; m < EGNp; m++){
    r0	=EGaRp[m];
    z0	=EGaZp[m];
    R0	=r0-cr2*hr0;
    Z0	=z0-cr2*hz0;
    sprintf(ln,"Plasma-PFCoils: %4d < %d",m,EGNp);
    ZMessage(ln);
    for(k=1; k < nPFB; k++){
      lB1	=PFB+k;
      kCj	=lB1->kC;
      if((FlPFC[kCj]&0x01)){
	nr1	=lB1->nr;
	hr1	=2.*lB1->dR/nr1;
	nz1	=lB1->nz;
	hz1	=2.*lB1->dZ/nz1;
	dx1	=hr1/nx;
	dy1	=hz1/ny;
	R1	=lB1->R-lB1->dR;
	r1	=R1+cr2*hr1;
	gY	=0.;
	for(kr=0; kr < nr1; kr++){
	  Z1	=lB1->Z-lB1->dZ;
	  z1	=Z1+cr2*hz1;
	  for(kz=0; kz < nz1; kz++){
	    if(fabs(r0-r1) > 1.1*hr0 || fabs(z0-z1) > 1.1*hz0){
	      gY	+=GPring(r0,z0,r1,z1);
	    }
	    else{
	      x0	=R0+cr2*dx0;
	      for(ix0=0; ix0 < nx; ix0++){
		y0	=Z0+cr2*dy0;
		for(iy0=0; iy0 < ny; iy0++){
		  x1	=R1+cr2*dx1;
		  for(ix1=0; ix1 < nx; ix1++){
		    y1	=Z1+cr2*dy1;
		    for(iy1=0; iy1 < ny; iy1++){
		      gY	+=GPring(x0,y0,x1,y1)*ss;
		      y1	+=dy1;
		    }
		    x1	+=dx1;
		  }
		  y0	+=dy0;
		}
		x0	+=dx0;
	      }
	    }
	    z1 	+=hz1;
	    Z1	+=hz1;
	  }
	  r1 +=hr1;
	  R1 +=hr1;
	}
	gYpC[m][kCj]	+=gY*lB1->tn/(nr1*nz1);
      }	
    }
  }

  for(m=0; m < nPFC; m++){
    if((FlPFC[m]&0x01)){
      for(k=1; k < nPFC; k++){
	if((FlPFC[k]&0x01)) gYCC[m][k]=0.;
      }
    }
  }

  for(m=1; m < nPFB; m++){
    sprintf(ln,"PFCoils-PFCoils: %4d < %d",m,nPFB);
    ZMessage(ln);
    lB0	=PFB+m;
    kCi	=lB0->kC;
    nr0	=lB0->nr;
    hr0	=2.*lB0->dR/nr0;
    nz0	=lB0->nz;
    hz0	=2.*lB0->dZ/nz0;
    dx0	=hr0/nx;
    dy0	=hz0/ny;
    a	=dy0/dx0;
    if(a > 3.0){
      d	=.13;
    }
    else{
      if(a >= 2.){
	d	=0.2+0.11*(3.-a);
      }
      else{
	if(a >= 1.6){
	  d	=.31+.2*(2.-a);
	}
	else{
	  if(a >= 1.){
	    d	=.39+.7167*(1.6-a);
	  }
	  else{
	    d	=.82;
	  }
	}
      }
    }
    for(k=m; k < nPFB; k++){
      lB1	=PFB+k;
      kCj	=lB1->kC;
      if((FlPFC[kCi]&0x10) || (FlPFC[kCj]&0x10)){
	nr1	=lB1->nr;
	hr1	=2.*lB1->dR/nr1;
	nz1	=lB1->nz;
	hz1	=2.*lB1->dZ/nz1;
	dx1	=hr1/nx;
	dy1	=hz1/ny;
	gY	=0.;
	R0	=lB0->R-lB0->dR;
	r0	=R0+cr2*hr0;
	for(mr=0; mr < nr0; mr++){
	  Z0	=lB0->Z-lB0->dZ;
	  z0	=Z0+cr2*hz0;
	  for(mz=0; mz < nz0; mz++){
	    R1	=lB1->R-lB1->dR;
	    r1	=R1+cr2*hr1;
	    for(kr=0; kr < nr1; kr++){
	      Z1	=lB1->Z-lB1->dZ;
	      z1	=Z1+cr2*hz1;
	      for(kz=0; kz < nz1; kz++){
		a	=r0-r1;
		b	=z0-z1;
		if(fabs(r0-r1) > 1.1*hr0 ||fabs(z0-z1) > 1.1*hz0){
		  gY	+=GPring(r0,z0,r1,z1);
		}
		else{
		  x0	=R0+cr2*dx0;
		  for(ix0=0; ix0 < nx; ix0++){
		    y0	=Z0+cr2*dy0;
		    for(iy0=0; iy0 < ny; iy0++){
		      x1	=R1+cr2*dx1;
		      for(ix1=0; ix1 < nx; ix1++){
			y1	=Z1+cr2*dy1;
			for(iy1=0; iy1 < ny; iy1++){
			  y1	=Z1+(cr2+iy1)*dy1;
			  a	=x0-x1;
			  b	=y0-y1;
			  if(fabs(x0-x1) < dx0 && fabs(y0-y1) < dy0){
			    ga	=cr2*dy0/x0;
			    gr	=cr2*dx0/x0;
			    gaa	=ga*ga;
			    grr	=gr*gr;
			    a	=4./(ga+gr);
			    b	=(3.*gaa+grr)/24.;
			    c	=4./sqrt(gaa+grr);
			    gY	+=cgm0*x0*(log(a)-cr2+b*log(c)+d*gaa*.25)*ss;
			  }
			  else{
			    gY	+=GPring(x0,y0,x1,y1)*ss;
			  }
			  y1	+=dy1;
			}
			x1	+=dx1;
		      }
		      y0	+=dy0;
		    }
		    x0	+=dx0;
		  }
		}
		z1 	+=hz1;
		Z1 	+=hz1;
	      }
	      r1 +=hr1;
	      R1 +=hr1;
	    } 
	    z0 +=hz0;
	    Z0 +=hz0;
	  }
	  r0 +=hr0;
	  R0 +=hr0;
	}
	gY	*=lB0->tn*lB1->tn/(nr0*nz0*nr1*nz1);
	gYCC[kCi][kCj] +=gY;
	if(kCi != kCj) gYCC[kCj][kCi]+=gY;
      }
    }
  }

  for(k=1; k < nPFC; k++){
    if((FlPFC[k]&0x01)){
      for(m=0; m < nMFP; m++){
	gYiC[m][k]	=0.;
      }
    }
  }

  ss	=(double)1./(nx*ny);
  for(m=0; m < nMFP; m++){
    sprintf(ln,"Probes-Blocks: %4d < %d",m,nMFP);
    ZMessage(ln);
    lP	=MFP+m;
    r0	=lP->R;
    z0	=lP->Z;
    Tr	=lP->Tr; 
    Tz	=lP->Tz;
    for(k=1; k < nPFB; k++){
      lB1	=PFB+k;
      kCj	=lB1->kC;
      if((FlPFC[kCj]&0x0e)){
	nr1	=lB1->nr;
	hr1	=2.*lB1->dR/nr1;
	nz1	=lB1->nz;
	hz1	=2.*lB1->dZ/nz1;
	s	=(double)lB1->tn/(nr1*nz1);
	dx1	=hr1/nx;
	dy1	=hz1/ny;
	gY	=0.;
	Br	=0.;
	Bz	=0.;
	R1	=lB1->R-lB1->dR;
	r1	=R1+cr2*hr1;
	for(kr=0; kr < nr1; kr++){
	  Z1	=lB1->Z-lB1->dZ;
	  z1	=Z1+cr2*hz1;
	  for(kz=0; kz < nz1; kz++){
	    br	=r0-r1;
	    bz	=z0-z1;
	    if(fabs(r0-r1) > hr1 || fabs(z0-z1) > hz1){
	      MFring(&gy,&br,&bz,r0,z0,r1,z1,(double)1.);
	      gY	+=gy;
	      Br	+=br;
	      Bz	+=bz;
	      if(lP->kA == 2){
		MFring(&gy,&br,&bz,lP->R1,lP->Z1,r1,z1,(double)1.);
		gY	-=gy;
		Br	-=br;
		Bz	-=bz;
	      }
	    }
	    else{
	      x1	=R1+cr2*dx1;
	      for(ix1=0; ix1 < nx; ix1++){
		y1	=Z1+cr2*dy1;
		for(iy1=0; iy1 < ny; iy1++){
		  MFring(&gy,&br,&bz,r0,z0,x1,y1,ss);
		  gY	+=gy;
		  Br	+=br;
		  Bz	+=bz;
		  if(lP->kA == 2){
		    MFring(&gy,&br,&bz,lP->R1,lP->Z1,x1,y1,ss);
		    gY	-=gy;
		    Br	-=br;
		    Bz	-=bz;
		  }
		  y1	+=dy1;
		}
		x1	+=dx1;
	      }
	    }
	    z1 	+=hz1;
	    Z1	+=hz1;
	  }
	  r1 +=hr1;
	  R1 +=hr1;
	}
	gYiC[m][kCj]	+=lP->kA < 3 ? gY*s : (Br*Tr+Bz*Tz)*s;
      }
    }
  }
  return(0);
}

int PFC2MFProbes4CDX()
{
  FILE *lF;
  int i,j,k;
  double s;

  lF=fopen("PFC2MFProbes","w");

  fprintf(lF,"%5d %5d\n",nMFP,nPFC-1);
  for(i=1; i < nPFC; i++){
    fprintf(lF,"%24s",PFC[i].Nm);
    if(i%4 == 0) fputs("\n",lF);
  }
  if(i%4 != 1) fputs("\n",lF);

  for(j=0; j < nMFP; j++){
    fprintf(lF,"%3d %s\n",j,MFP[j].Nm);
    for(i=1; i < nPFC; i++){
      fprintf(lF,"%24.16e",gYiC[j][i]);
      if(i%4 == 0) fputs("\n",lF);
    }
    if(i%4 != 1) fputs("\n",lF);
  }
 
  fputs("\n============================\n",lF);
  fprintf(lF,"%5d %5d\n",nMFP,nPFC-1);
  for(i=1; i < nPFC; i++){
    fprintf(lF,"%24s",PFC[i].Nm);
    if(i%4 == 0) fputs("\n",lF);
  }
  if(i%4 != 1) fputs("\n",lF);

  for(j=0; j < nMFP; j++){
    s	=gYiC[j][5] != 0. ? 1./gYiC[j][5] : 1.;
    fprintf(lF,"%3d %s\n",j,MFP[j].Nm);
    for(i=1; i < nPFC; i++){
      fprintf(lF,"%24.16e",gYiC[j][i]*s);
      if(i%4 == 0) fputs("\n",lF);
    }
    if(i%4 != 1) fputs("\n",lF);
  }
  fclose(lF);
  puts("Output: PFC2MFProbes");
  return(0);
}

int PFBElecPar()
{
  static int iNm=0;
  int i,j,k,m,n;
  int kC[nPFB];
  double R[nPFB],Z[nPFB],gr[nPFB],Res[nPFB],tn[nPFB],tC[nPFB];
  PFBLOCK *lB;
  PFCOIL *lC;
  char *NmB[nPFB],*lc;

#ifndef AscIElP
#undef AscIElP
#endif/*AscIElP*/
  for(i=0; i < nPFB; i++){
    lB		=PFB+i;
    gr[i]	=lB->gr;
    tn[i]	=lB->tn;
    tC[i]	=lB->kC;
    Res[i]	=lB->Res;
  }
#ifndef Tbl_ElecP 
  CbUserPlot	=IbPFCPlot;
  for(i=0; i < nPFB; i++){
    lB		=PFB+i;
    R[i]	=lB->R;
    Z[i]	=lB->Z;
    lB->kC	=i;
    NmB[i]	=iNm ? lB->Nm : lB->NmC;
  }
  
  for(i=1; i < nPFB; i++) kC[i]=tC[i] < 1. ? PFB[i].kC : tC[i];
  nPFC	=1;
  i	=1;
  while(i < nPFB){
    k	=kC[i];
    m	=i;
    for(j=i+1; j < nPFB; j++){
      if(k > kC[j] && kC[j] >= nPFC){
	k	=kC[j];
	m	=j;
      }
    }
    PFB[m].kC	=nPFC;
    kC[m]	=nPFC;
    lc		=PFB[m].NmC;
    for(j=m+1; j < nPFB; j++){
      if(kC[j] == k){
	PFB[j].kC	=nPFC;
	kC[j]		=nPFC;
	strcpy(PFB[j].NmC,lc);
      }
    }
    while(i < nPFB && kC[i] <= nPFC) i++;
    nPFC++;
  }
  nPFC1	=nPFC+1;
  for(i=1; i < nPFB; i++) tC[i]=kC[i];
  PFReInitPFC();
  k	=0;
  for(i=0; i < nPFC; i++){
    PFC[i].kB	=kCB+k;
    for(j=0; j < nPFB; j++){
      if(PFB[j].kA && PFB[j].kC == i) kCB[k++]	=j;
    }
    j	=PFC[i].kB[0];
    strcpy(PFC[i].Nm,PFB[j].NmC);
    NmB[i]	=iNm ? PFB[i].Nm : PFB[i].NmC;
  }
#endif/*Tbl_ElecP*/
  nPEC	=nPFC+nVVC;
  for(i=1; i < nPFB; i++){
    lB		=PFB+i;
    lB->gr	=gr[i];
    lB->tn	=tn[i];
    lB->Res	=Res[i];
  }
  for(k=0; k < nPFC; k++){
    lC		=PFC+k;
    lC->tn	=0.;
    lC->Tn	=0.;
    lC->Res	=0.;
    lC->gt	=0.;
    lC->I	=0.;
    lC->V	=0.;
    lC->gY	=0.;
    lC->I0	=0.;
    lC->Ie	=0.;
    lC->dI	=0.;
    lC->V0	=0.;
    lC->gY0	=0.;
    lC->Emf	=0.;
    lC->wW	=0.;
    lC->wgY	=0.;
    lC->wI	=0.;
    lC->wR	=0.;
    lC->wV	=0.;
    lC->kA	=1;
    lC->kG	=-1;
    i	=lC->kB[0];
    lC->c	=PFB[i].kc;
    lC->kD	=PFB[i].kD;
    lC->nB	=0;
  }
  for(i=0; i < nPFB; i++){
    k	=PFB[i].kC;
    PFC[k].tn	+=PFB[i].tn;
    PFC[k].Tn	+=fabs(PFB[i].tn);
    PFC[k].Res	+=PFB[i].Res;
    PFC[k].nB++;
  }
  lB		=PFB+nPFB;
  lC		=PFC+nPFC;

  lC->tn	=lB->tn;
#ifdef H
  lC->tn	=lB->tn*lB->kC;
#endif

  lC->Tn	=lC->tn;
  lC->Res	=0.;
  lC->gt	=0.;
  lC->I		=0.;
  lC->V		=0.;
  lC->gY	=0.;
  lC->I0	=0.;
  lC->Ie	=0.;
  lC->dI	=0.;
  lC->V0	=0.;
  lC->gY0	=0.;
  lC->Emf	=0.;
  lC->wW	=0.;
  lC->wgY	=0.;
  lC->wI	=0.;
  lC->wR	=0.;
  lC->wV	=0.;
  lC->kA	=1;
  lC->kG	=-1;
  lC->kD	=lB->kD;
  lC->c		=lB->kc;
  lC->nB	=1;
  lB->kC	=nPFC;
  kCB[nPFB]	=nPFB;
  lC->kB	=kCB+nPFB;
  strcpy(lC->Nm,lB->NmC);
#ifndef AscOElP
#undef AscOElP
#endif/*AscOElP*/
  for(i=0; i < nPFC; i++) FlPFC[i]=0x1f;
#ifndef BnrI_ElecPar
#undef BnrI_ElecPar
#endif/*BnrI_ElecPar*/
  SetLijPFCoils();
#ifndef BnrOElecPar
#undef BnrO_ElecPar
#endif/*BnrOElecPar*/
  PFInitCntP();
#ifdef H
  PFC2MFProbes4CDX();
  for(i=0; i < nPFC1; i++)out("???? i Idd <s>",i,PFC[i].kD,PFC[i].tn
			      ,PFC[i].Tn,PFC[i].Nm);
#endif
  return(0);
}

#endif

int DeInitWall(){
  free(gYWp[0]);
  free(gYWC[0]);
  free(IWgYi[0]);
  return(0);
}

int InitWall()
{
  int i,n1;

  if((ESmemlevP&0x00100000)){
    DeInitWall();
    ESmemlevP	-=0x00100000;
  }
  n1	=VVWall.n1;

  IWgYi[0]	=(double*)malloc(n1*nMFLS*sizeof(double));
  gYWC[0]	=(double*)malloc(n1*nPFC*sizeof(double));
  gYWp[0]	=(double*)malloc(n1*EGNp*sizeof(double));

  if(IWgYi[0] == NULL){
    CbStr2UserWarning("PFWall(): No memory of IWgYi[0]");
    return(1);
  }
  if(gYWC[0] == NULL){
    free(IWgYi[0]);
    CbStr2UserWarning("PFWall(): No memory of gYWC");
    return(1);
  }
  if(gYWp[0] == NULL){
    free(IWgYi[0]);
    free(gYWC[0]);
    CbStr2UserWarning("PFWall(): No memory of gYWp");
    return(1);
  }
  for(i=1; i < n1; i++){
    IWgYi[i]=IWgYi[i-1]+nMFLS;
    gYWC[i]=gYWC[i-1]+nPFC;
    gYWp[i]=gYWp[i-1]+EGNp;
  }
  ESmemlevP	|=0x00100000;
  return(0);
}

int DefaultWall()
{
  int i;
  PSBLOCK *lS;

  lS		=VVB;
  for(i=0; i < nVVB && i < 256; i++,lS++){
    VVWall.r[i]	=lS->R;
    VVWall.z[i]	=lS->Z;
  }  
  VVWall.r[i]	=VVWall.r[0];
  VVWall.z[i]	=VVWall.z[0];

  VVWall.n1	=nVVB+1;
  strcpy(VVWall.Nm,"VVWall");
  return(0);
}

int PFWallAO(FILE *lf){
  int i,n1;
  char str[64];
  char ln[128];

  strcpy(ln,"%3d %11.8f %11.8f%c");
  strcpy(str,ln);
  FormatWrite2Read(str);
  n1	=VVWall.n1;
  fprintf(lf,"<Vacuum Vessel Wall>[%d](%s)\n",VVWall.n1,str);
  fprintf(lf,"! # %11s %11s\n","RWall","ZWall");
  fprintf(lf,"!   %11s %11s\n","(L.m)","(L.m)");
  for(i=0; i < n1; i++){
    fprintf(lf,ln,i,ScaleR*VVWall.r[i],ScaleR*VVWall.z[i],'\n');
  }
  fprintf(lf,"! # %11s %11s\n","RWall","ZWall");

  n1	=VVTile.n1;
  fprintf(lf,"<In-Vessel Tiles>[%d](%s)\n",VVTile.n1,str);
  fprintf(lf,"! # %11s %11s\n","RTile","ZTile");
  fprintf(lf,"!   %11s %11s\n","(L.m)","(L.m)");
  for(i=0; i < n1; i++){
    fprintf(lf,ln,i,ScaleR*VVTile.r[i],ScaleR*VVTile.z[i],'\n');
  }
  fprintf(lf,"! # %11s %11s\n","RTile","ZTile");
  return(0);
}

int PFWallAI(FILE *lf)
{
  int n1;
  char str[64];
  char *lc,*lm;
  char *lv[4];
  int dl[4]={0,0,0,0};
  
  lm	="Wall.ai";
  lc	="<Vacuum Vessel Wall>";
  if(PFIsKeyWordFound(lf,lc,lc,str,&n1)){
    VVWall.n1	=n1;
    lv[0]	=(char*)&n1;
    lv[1]	=(char*)VVWall.r;
    lv[2]	=(char*)VVWall.z;
    dl[0]	=0;
    dl[1]	=sizeof(double);
    dl[2]	=sizeof(double);
    PFReadAI(lf,lc,lc,str,VVWall.n1,lv,dl,3);
  }
  else{
    CbStr2UserMessage("Error: %s - NO %s record.\n",lm,lc);
    return(1);
  }
  lc	="<In-Vessel Tiles>";
  if(PFIsKeyWordFound(lf,lc,lc,str,&n1)){
    VVTile.n1	=n1;
    lv[0]	=(char*)&n1;
    lv[1]	=(char*)VVTile.r;
    lv[2]	=(char*)VVTile.z;
    dl[0]	=0;
    dl[1]	=sizeof(double);
    dl[2]	=sizeof(double);
    PFReadAI(lf,lc,lc,str,VVTile.n1,lv,dl,3);
  }
  else{
    CbStr2UserMessage("Warning: %s - NO %s record.\n",lm,lc);
  }
  CbStr2UserMessage("Input: %s\n",lm);
  return(0);
}

int PFSetLijWall()
{
  char ln[0x40];
  PFBLOCK *lB0,*lB1;
  int nWall;
  int i;
  double r0,z0,r1,z1,gr;
  double R1,Z1;
  double s,ss,gY,gy,br,bz;
  int ix1,iy1;
  double x1,y1,dx1,dy1;
  int mr,mz,kr,kz;
  int nr1,nz1;
  double hr1,hz1;
  int nj,*lj,j,jj;
  int nx=4,ny=4;

  nWall	=VVWall.n1;
  dx1	=EGdr/nx;
  dy1	=EGdz/ny;
  ss	=(double)1./(nx*ny);

  for(i=0; i < nWall; i++){
    sprintf(ln,"Wall-Plasma: %4d < %d",i,nWall);
    ZMessage(ln);
    r0	=VVWall.r[i];
    z0	=VVWall.z[i];
    for(j=0; j < EGNp; j++){
      gY	=0.;
      r1	=EGaRp[j];
      z1	=EGaZp[j];
      R1	=r1-cr2*EGdr;
      Z1	=z1-cr2*EGdz;
      if(fabs(r0-r1) > 1.2*EGdr || fabs(z0-z1) > 1.2*EGdz){
	MFring(&gy,&br,&bz,r0,z0,r1,z1,(double)1.);
	gY	+=gy;
      }
      else{
	x1	=R1+cr2*dx1;
	for(ix1=0; ix1 < nx; ix1++){
	  y1	=Z1+cr2*dy1;
	  for(iy1=0; iy1 < ny; iy1++){
	    MFring(&gy,&br,&bz,r0,z0,x1,y1,ss);
	    gY	+=gy;
	    y1	+=dy1;
	  }
	  x1	+=dx1;
	}
      }
      gYWp[i][j]	=gY;
    }

    for(j=1; j < nPFC; j++){
      nj	=PFC[j].nB;
      lj	=PFC[j].kB;
      gYWC[i][j-1]	=0.;
      for(jj=0; jj < nj; jj++){
	lB1	=PFB+lj[jj];
	nr1	=lB1->nr;
	hr1	=2.*lB1->dR/nr1;
	nz1	=lB1->nz;
	hz1	=2.*lB1->dZ/nz1;
	s	=lB1->tn/(nr1*nz1);
	dx1	=hr1/nx;
	dy1	=hz1/ny;
	gY	=0.;
	R1	=lB1->R-lB1->dR;
	r1	=R1+cr2*hr1;
	for(kr=0; kr < nr1; kr++){
	  Z1	=lB1->Z-lB1->dZ;
	  z1	=Z1+cr2*hz1;
	  for(kz=0; kz < nz1; kz++){
	    br	=r0-r1;
	    bz	=z0-z1;
	    if(fabs(r0-r1) > hr1 || fabs(z0-z1) > hz1){
	      MFring(&gy,&br,&bz,r0,z0,r1,z1,(double)1.);
	      gY	+=gy;
	    }
	    else{
	      x1	=R1+cr2*dx1;
	      for(ix1=0; ix1 < nx; ix1++){
		y1	=Z1+cr2*dy1;
		for(iy1=0; iy1 < ny; iy1++){
		  MFring(&gy,&br,&bz,r0,z0,x1,y1,ss);
		  gY	+=gy;
		  y1	+=dy1;
		}
		x1	+=dx1;
	      }
	    }
	    z1 	+=hz1;
	    Z1	+=hz1;
	  }
	  r1 +=hr1;
	  R1 +=hr1;
	}
	gYWC[i][j-1]	+=gY*s;
      }
    }
  }
  return(0);
}

int PFWallBO(FILE *lf)
{
  PFBLOCK *lB;
  int i,n,n1;
  size_t ii,id;

  ii	=sizeof(int);
  id	=sizeof(double);
  n1	=VVWall.n1;

  /* Plasma */
  fwrite(NplG,ii,2,lf);
  fwrite(RplG,id,2,lf);
  fwrite(ZplG,id,2,lf);

  /* Wall */
  fwrite(&n1,ii,1,lf);
  for(i=0; i < n1; i++){
    fwrite(VVWall.r+i,id,1,lf);
    fwrite(VVWall.z+i,id,1,lf);
  }

  /* PFBlocks */
  fwrite(&nPFB,ii,1,lf);
  for(i=0; i < nPFB; i++){ 
    fwrite(&PFB[i].nr,ii,1,lf);
    fwrite(&PFB[i].nz,ii,1,lf);
    fwrite(&PFB[i].kC,ii,1,lf);
  }
  for(i=0; i < nPFB; i++){
    lB	=PFB+i;
    fwrite(&lB->R,id,1,lf);
    fwrite(&lB->dR,id,1,lf);
    fwrite(&lB->Z,id,1,lf);
    fwrite(&lB->dZ,id,1,lf);
  }

  /* gYWp, gYWC */
  n	=n1*EGNp;
  fwrite(gYWp[0],id,n,lf);
  n	=n1*(nPFC-1);
  fwrite(gYWC[0],id,n,lf);
  return(0);
}

int PFWallBI(FILE *lf)
{
  PFBLOCK *lB;
  int i,n,n1,k[4];
  double s[4];
  size_t ii,id;

  ii	=sizeof(int);
  id	=sizeof(double);
  n1	=VVWall.n1;

  /* Plasma */
  if(fread(k,ii,2,lf) < 2 || NplG[0] != k[0] || NplG[1] != k[1]) return(1);
  if(fread(s,id,(size_t)4,lf) < 4 || RplG[0] != s[0] || RplG[1] != s[1] || 
     ZplG[0] != s[2] || ZplG[1] != s[3]) return(1);

  /* Wall */
  if(fread(k,ii,1,lf) < 1 || k[0] != VVWall.n1) return(1);
  for(i=0; i < n1; i++){
    if(fread(s,id,2,lf) < 2 || s[0] !=VVWall.r[i]
       || s[1] != VVWall.z[i]) return(1);
  }

  /* PFBlocks */
  if(fread(k,ii,1,lf) < 1 || nPFB != k[0]) return(1);
  for(i=0; i < nPFB; i++){ 
    if(fread(k,ii,3,lf) < 3 || PFB[i].nr != k[0] || PFB[i].nz != k[1] 
       || PFB[i].kC != k[2]){
      return(1);
    }
  }
  for(i=0; i < nPFB; i++){
    lB	=PFB+i;
    if(fread(s,id,4,lf) < 4 || lB->R != s[0] || lB->dR != s[1]
       || lB->Z != s[2] || lB->dZ != s[3]) return(1);
  }
  /* gYWp, gYWC */
  n	=n1*EGNp;
  if(fread(gYWp[0],id,n,lf) < n) return(1);
  n	=n1*(nPFC-1);
  if(fread(gYWC[0],id,n,lf) < n) return(1);
  return(0);
}

int ExpandWall(double *R,double *Z,int *iA, double dn,int *n1)
{
  int i,i1,n;
  double x[0x100],r[0x100],r2[0x100],z[0x100],z2[0x100];
  double rt,zt,h,rh,r6h;

  n	=*n1-1;
  i1	=0;
  for(i=0; i < n; i++){
    if(iA[i]){
      r[i1]=VVWall.r[i];
      z[i1]=VVWall.z[i];
      i1++;
    }
  }
  n	=i1;
  *n1	=n+1;

  x[0]	=0.;
  for(i=0,i1=1; i1 < n; i++,i1++){
    rt	=r[i1]-r[i];
    zt	=z[i1]-z[i];
    x[i1]=x[i]+sqrt(rt*rt+zt*zt);
  }
  spl_p(r,r2,x,n);
  spl_p(z,z2,x,n);
  
  i1	=1;
  i	=0;
  h	=x[i1]-x[i];
  rh	=1./h;
  r6h	=cr6*h;
  rt	=(r[i1]-r[i])*rh-(r2[i1]+2.*r2[i])*r6h;
  zt	=(z[i1]-z[i])*rh-(z2[i1]+2.*z2[i])*r6h;
  h	=dn/sqrt(rt*rt+zt*zt);
  R[i]=r[i]-zt*h;
  Z[i]=z[i]+rt*h;
  for(; i1 < n; i1++,i++){
    h	=x[i1]-x[i];
    rh	=1./h;
    r6h	=cr6*h;
    rt	=(r[i1]-r[i])*rh+(2.*r2[i1]+r2[i])*r6h;
    zt	=(z[i1]-z[i])*rh+(2.*z2[i1]+z2[i])*r6h;
    h	=dn/sqrt(rt*rt+zt*zt);
    R[i1]=r[i1]-zt*h;
    Z[i1]=z[i1]+rt*h;
  }
  R[n]	=R[0];
  Z[n]	=Z[0];
  return(0);
}

#ifdef H
int MassageWall(WALL *W)
{
  int i,i1,k,n,n1;
  double *t,*L,r[W->n1],r1[W->n1],r2[W->n1],z[W->n1],z1[W->n1],z2[W->n1];
  double t2[W->n1];
  double rt,zt,h0,h1,dL;

  n1	=W->n1;
  n	=n1-1;
  t	=W->t;
  L	=W->L;
  memcpy(r1,W->r,n1*LDBL);
  memcpy(z1,W->z,n1*LDBL);
  for(i=0; i < n1; i++) t[i]=i;
  for(k=0; k < 2; k++){
    memcpy(r,r1,n1*LDBL);
    memcpy(z,z1,n1*LDBL);
    spl_p(r,r2,t,n);
    spl_p(z,z2,t,n);
    r[n]	=r[0];	
    r2[n]	=r2[0];	
    z[n]	=z[0];	
    z2[n]	=z2[0];	
    L[0]	=0.;
    i1	=1;
    i	=0;
    rt	=r[i1]-r[i]-(r2[i1]+2.*r2[i])*cr6;
    zt	=z[i1]-z[i]-(z2[i1]+2.*z2[i])*cr6;
    h1	=sqrt(rt*rt+zt*zt);
    for(; i1 < n1; i1++,i++){
      h0	=h1;
      rt	=r[i1]-r[i]+(2.*r2[i1]+r2[i])*cr6;
      zt	=z[i1]-z[i]+(2.*z2[i1]+z2[i])*cr6;
      h1	=dn/sqrt(rt*rt+zt*zt);
      L[i1]	=L[i]+0.5*(h1+h0);
    }
    spl(t,t2,NULL,NULL,L,&n);

    dL	=L[n]/n;
    for(i=1; i < n; i++){
      h1	=dL*i;
      splr0(&h0,NULL,&h1,t,t2,L,&n);
      i1	=h0;
      Splr1(r1+i,NULL,h0,r,r2,t,i1);
      Splr1(z1+i,NULL,h0,z,z2,t,i1);
    }
    r1[n]	=r1[0];	
    z1[n]	=z1[0];	
  }

  memcpy(W->r,r1,n1*LDBL);
  memcpy(W->z,z1,n1*LDBL);
  return(0);
}
#endif

int TFCoil(double *rC, double *zC, double *RC, double *ZC
	   ,double R2,double R1,double D,int N)
{
  int i,j;
  int neq=1,n,n1;
  double RKy0[2],RKy1[2],RKy2[2],RKy3[2],RKy4[2];
  double x,y[2],dy[2],r;
  double ga,h,L,s,cs;
  double u[2],v[2];
   
  n	=(N-3)/2;
  n1	=n+1;
  ga	=0.5*log(R2/R1);
  h	=cgp/n;
  L	=0.;	
  r	=R2;
  y[0]	=0.;
  rC[0]	=r;
  zC[0]	=y[0];
  rC[0]	=r;
  zC[0]	=y[0];
  RC[0]	=rC[0]+D;
  ZC[0]	=zC[0];
  dy[0]	=ga*r;
  for(j=1; j < n1; j++){
    for(i=0; i < neq; i++){
      RKy1[i]	=h*dy[i];
      RKy0[i]	=y[i]+cr2*RKy1[i];
    }
    cs	=cos(L+cr2*h);
    r	=R2*exp((cs-1.)*ga);
    RKy2[0]	=ga*r*cs;
    for(i=0; i < neq; i++){
      RKy2[i]	*=h;
      RKy0[i]	=y[i]+cr2*RKy2[i];
    }
    RKy3[0]	=ga*r*cs;
    for(i=0; i < neq; i++){
      RKy3[i]	*=h;
      RKy0[i]	=y[i]+RKy3[i];
    }
    L+=h;
    cs	=cos(L);
    r	=R2*exp((cs-1.)*ga);
    RKy4[0]	=ga*r*cs;
    for(i=0; i < neq; i++){
      RKy4[i]	*=h;
      y[i]	+=cr6*(RKy1[i]+RKy4[i])+cr3*(RKy2[i]+RKy3[i]);
    }
    dy[0]	=ga*r*cs;
    rC[j]	=r;
    zC[j]	=y[0];
    RC[j]	=rC[j]+D*cs;
    ZC[j]	=zC[j]+D*sin(L);
  }
  rC[j]	=r;
  zC[j]	=0.;
  RC[j]	=rC[j]+D*cs;
  ZC[j]	=0.;
  i	=j;
  while(i){
    i--;
    j++;
    rC[j]	=rC[i];
    zC[j]	=-zC[i];
    RC[j]	=RC[i];
    ZC[j]	=-ZC[i];
  }
  return(0);
}

int WallResolution(int *iA, int iSc)
{
  int i,j,n1,N,N1;
  double R[0x100],Z[0x100];
  double *r,*z,d,D,x,y,s,L,dL;

  N1	=VVWall.n1;
  N	=N1-1;
  r	=VVWall.r;
  z	=VVWall.z;
  memcpy(R,r,N1*LDBL);
  memcpy(Z,z,N1*LDBL);

  L	=0;
  for(i=0; i < N; i++){
    x	=R[i+1]-R[i];
    y	=R[i+1]-R[i];
    L	+=sqrt(x*x+y*y);
  }
  d	=L/(N*iSc);

  j	=0;
  for(i=0; i < N; i++){ 
    x	=R[i+1]-R[i];
    y	=Z[i+1]-Z[i];
    s	=sqrt(x*x+y*y);
    n1	=s/d+1;
    x	/=n1;
    y	/=n1;
    dL	=s/n1;
    r[j]	=R[i];
    z[j]	=Z[i];
    L		=1.5*dL;
    iA[j++]	=1;
    while(L < s){
      r[j]	=r[j-1]+x;
      z[j]	=z[j-1]+y;
      L		+=dL;
      iA[j++]	=1;
    }
  }
  r[j]	=r[0];
  z[j]	=z[0];
  iA[j++]=1;
  VVWall.n1=j;

  return(0);
}

int PFSetWall(double *r,double *z,int nw1)
{
  double rs2[nw1],zs2[nw1],L[nw1];
  double dr,dz,s;
  int i,nw;

  nw	=nw1-1;
  VVWall.n1	=nw1;
  L[0]	=0;
  VVWall.L[0]	=0.;
  for(i=1; i < nw1; i++){
    dr	=r[i]-r[i-1];
    dz	=z[i]-z[i-1];
    L[i]=L[i-1]+sqrt(dr*dr+dz*dz);
    VVWall.L[i]	=L[i];
  }
  VVWall.dL[0]	=0.5*(L[1]-L[0]+L[nw]-L[nw-1]);
  for(i=1; i < nw; i++) VVWall.dL[i]=0.5*(L[i+1]-L[i-1]);

  dr	=0.;
  spl(r,rs2,&dr,&dr,L,&nw);
  dz	=1.;
  spl(z,zs2,&dz,&dz,L,&nw);

  for(i=0; i < nw; i++){
    splr1(VVWall.r+i,&dr,L+i,r,rs2,L,&nw,&i);
    splr1(VVWall.z+i,&dz,L+i,z,zs2,L,&nw,&i);
    s	=1./sqrt(dr*dr+dz*dz);
    VVWall.nr[i]	=-dz*s;
    VVWall.nz[i]	=dr*s;
  }
  return(0);
}

int PFWall()
{
  static int FlV=0,iSc=0;
  int Fl=0;
  int i,j,nT1,n1,nw1,nRw1=0;
  int iA[0x100];
  double *rT,*zT;
  double rw[0x101],zw[0x101];
  double Rw[0x100],Zw[0x100],dn=0.;
  double r,z,r0,z0,Br,Bz;
  double gY[0x100],Iim[0x20];
  double R2[2]={6.,6.3},R1[2]={2.,1.7};

  if(nPFC > 0x20) CbStr2UserWarning("%d > %d - excessive number of PFCoils"
				    ,nPFC,0x20);
  if(VVWall.n1 == 0) DefaultWall();
#ifndef AscI_Wall
#undef AscI_Wall
#endif/*AscI_Wall*/
  InitWall();
  nT1	=VVTile.n1;
  rT	=VVTile.r;
  zT	=VVTile.z;
  r0	=PFB[0].R;
  z0	=PFB[0].Z;
  n1	=VVWall.n1;
  for(i=0; i < n1; i++) iA[i]=1;
#ifndef Tbl_Wall
  if(iSc) WallResolution(iA,iSc+1);
  n1	=VVWall.n1;

  switch(FlV){
  case 1:
    CbUserPlot	=VVBPlot;
    break;
  case 2:
    CbUserPlot	=MFPPlot;
    break;
  case 3:
    CbUserPlot	=IbPFCPlot;
    nw1	=51;
    TFCoil(rw,zw,Rw,Zw,R2[0],R1[0],R2[1]-R2[0],nw1);
    j	=nw1;
    for(i=0; i < nw1; i++){
      VVWall.r[i]	=rw[i];
      VVWall.z[i]	=zw[i];
      iA[i]	=1;
      VVWall.r[j]	=Rw[i];
      VVWall.z[j]	=Zw[i];
      iA[j++]	=1;
    }
    while(j < n1) iA[j++]=0;
    nRw1	=nw1;
    break;
  case 4:
    nRw1	=n1;
    ExpandWall(Rw,Zw,iA,dn,&nRw1);
    break;
  case 5:
    nRw1=0;
    break;
  case 6:
    nRw1	=n1;
    ExpandWall(Rw,Zw,iA,dn,&nRw1);
    j	=0;
    for(i=0; i < n1; i++){
      if(iA[i]){
	VVWall.r[i]	=Rw[j];
	VVWall.z[i]	=Zw[j];
	j++;
      }
    }
    nRw1=0;
    FlV	=0;
    break;
  default:
    CbUserPlot	=NULL;
    break;
  }
  nw1	=0;
  for(i=0; i < n1; i++){
    if(iA[i]){
      rw[nw1]	=VVWall.r[i];
      zw[nw1]	=VVWall.z[i];
      nw1++;
    }
  }
  VVWall.n1	=nw1;
  switch(Fl){
  case 1:
    for(i=0; i < nw1; i++){
      r	=rw[i];
      z	=zw[i];
      for(j=1; j < nPFC; j++) PFCgYMF0(gYWC[i]+j-1,&Br,&Bz,r,z,j);
    }
    SVD4Wall(gYWC,nw1,nPFC-1);
    Fl	=2;
  case 2:
    for(i=0; i < nw1; i++) MFring(gY+i,&Br,&Bz,rw[i],zw[i],r0,z0,1.);
    GetSVDExpansion4Wall(Iim,gY,EmnIV);
    PlotEigenSVD();
    PlotDiscrWall(gYWC,Iim,gY);
    break;
  case 3:
    PFSetLijWall();
    SVD4Wall(gYWC,nw1,nPFC-1);
    Fl	=4;
  case 4:
    for(i=0; i < nw1; i++) MFring(gY+i,&Br,&Bz,rw[i],zw[i],r0,z0,1.);
    GetSVDExpansion4Wall(Iim,gY,EmnIV);
    PlotEigenSVD();
    PlotDiscrWall(gYWC,Iim,gY);
    for(i=0; i < nPFC-1; i++) out("?++? id",i,Iim[i]);
    break;
  default:
    break;
  }
#endif/*Tbl_Wall*/
  PFSetWall(rw,zw,nw1);
#ifndef AscO_Wall
#undef AscO_Wall
#endif/*AscO_Wall*/

  i	=1;
#ifndef BnrI_Wall
#undef BnrI_Wall
#endif/*BnrI_Wall*/
  if(i) PFSetLijWall();
  SVD4Wall(gYWC,nw1,nPFC-1);
#ifndef BnrO_Wall
#undef BnrO_Wall
#endif/*BnrO_Wall*/

  return(0);
}
#endif
