#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include <time.h>
#include <sys/time.h>

#include "pfc.h"

extern time_t time(time_t *t);
extern struct tm *localtime(const time_t *timep);
static struct tm *ltm;
static time_t stTime;

#ifndef mzl_ZCB
extern double cr2,cr3,cr4,cr6,cr12,cgp,c2gp,cgp_4,cr2gp,cgm0,crgm0;
#endif

extern unsigned int ESmemlevP;
extern int kTimeHistory;
#ifndef mzl_ESC
extern int ESEqSolvInCr,ESEqSolvInPr;
extern double EcRjet[],EcZjet[];
extern int EcNjet,FlagPoints;
extern int ESNsep,ESiAx;
extern double ESRsep[],ESZsep[];
extern int ESNa,ESNa1,ESNp,ESNp1,ESnAP;
extern double *ESsa,*ESsr,*ESsz,*ESaR0,*ESaZ0;
extern double *ESgY,*ESgY2a,*ESgF,*ESgF2a,*ESqgY,*ESqgY2a;
extern double *ESaJ,*ESjs,*ESjs2a,*ESjp,*ESjp2a,*ESgm,*ESgm2a;
extern double ESRext,ESRBt,ESBt;
extern double *ESLc,*ESLc1;

extern double *ESgF,*ESdgY,*ESdgY1a,*ESdgY2a,*ESaJ,*ESaJ2a;
extern double *ESaF,*ESaF1a,*ESsq,*ESsp,*ESaT,*ESaT1a,*ESaT2a,*ESPs,*ESPs1a;

extern double ESa0;
extern int ESFlHole;
extern double srSoL[],szSoL[];
#endif

#ifndef mzl_PFC
#ifndef stg_PlLim
extern int ESnLm;
extern double*ESRLm,*ESZLm;
extern int EGNp,NplG[2];
extern double EGdr,EGdz,EGdS;
extern double RplG[2],ZplG[2];
extern int *EGkA,*EGkAp;
extern double *EGaRp,*EGaZp;
extern int nGrLm,iGrLm[],jGrLm[],nGrEnv,iGrEnv[256][2];
extern double RGrLm[],ZGrLm[],ErGrLm[],EzGrLm[];
extern int EGwNp;
extern double *EGwRp,*EGwZp,*EGwIp;
extern double **gYpp,*gYWC[],*gYWp[];
extern double *EGsa,*EGgYp,*EGgYe,*EGaIp,*EGdIp,*EGjs,*EGjp
,*EGs1,*EGs2,*EGgf[];
static double EGcgf[42], EGcgf0[42];

static double Js[41],Js2a[41],Jp[41],Jp2a[41];
#endif

#ifndef stg_CHI
extern int n0CHI,n1CHI,nEl0,nEl1,kEl0[],kEl1[];
extern double *CHIr0,*CHIz0,*CHIr1,*CHIz1;
extern double RGrEl0[],ZGrEl0[],RGrEl1[],ZGrEl1[];
static double gYEl0mn=0.,gYEl0mx=0.;
static int NLines=12;
#endif

#ifndef stg_VacV
extern int nVVB;
extern PSBLOCK *VVB;
#endif

#ifndef stg_PSElecP
extern int nVVC;
extern PFCOIL *VVC;
extern double **gYpS;
#endif

#ifndef stg_MFProbe
extern int nMFP,nMFL,nMFS,nMFLS,nMFp,nMFd,nMFV;
extern MFPROBE *MFP;
extern double **gYip,**gYiS;
extern double *aSip,*aSiC,*aSi,*daSi;
#endif

#ifndef stg_PFBlocks
extern int nPFB;
extern double*Rb1,*Zb1,*Rb2,*Zb2;
extern double *IbPF;
extern double **gYpb,**gYib,**gYbb;
extern PFBLOCK *PFB;
extern double ESIpl;
#endif
extern int iSignIp;
extern double EGgYb;
#ifndef stg_ElecPar
extern int nPFC,nPEC;
extern PFCOIL *PFC;
extern double **gYCC,**gYpC,**gYiC;
static int iOH=0;
#endif

#ifndef stg_PFBSplD
extern double *XDSpl1,*XDSpl2,*YDSpl1,*YDSpl2;
#endif

#ifndef stg_PFCOpt
extern double PFwrP[]; 
#endif

#ifndef stg_PFCIeq
extern int nCntP;
extern MFPROBE CNTP[];
extern double *gYcp[],*BRcp[],*BZcp[],*gYcC[],*BRcC[],*BZcC[]
,*gYcS[],*BRcS[],*BZcS[];

static int FlFree2Fix=0;
static MFPROBE CNTP0[12];

static int NKj=15,NKp=5;
static int PFCnY,PFCnB,PFCnX,PFCnQ,PFCnF,PFCnO,PFCnK=0,nKj=0,nKp=0;
static int *iAA=NULL,nItr=1,iItr=0;
static double **lAA,*AA,*FA=NULL,*FAs,*FAi,*FAp;
static int ngYc=0;
static double gYc[0x10],rgYc[0x10],zgYc[0x10];
static double EGgY0,EGaR0,EGaZ0,EGaRb,EGaZb,EGgYL;
static int EGi0;

static char ln[256];
static double RPlt[6],ZPlt[6],Step;
static double RPlLm,ZPlLm;
static int igYb=0;
static double EGaRx,EGaZx,EGgYx,EGsab;

static int nRx=0;
static double EGvRx[0x20],EGvZx[0x20],EGvgYx[0x20];
static int nRX=0;
static double EGvRX[4],EGvZX[4],EGgYX[4];
static int nStD=5,nStS=6;
static double StD;

static int MSVDH=0,NSVDH=0;
static int MSVD=0,NSVD=0;
static int FlPLot=0,FlBlockIter=0,SVDFl=0;
static double tSVD=3e-8,tSVD1=3e-8,EignV[2]={0.,0.,};
static double err=0.;
static double **aU=NULL,**aV,*aF,*aS,*aT,*aW,EigenMin,EigenMax;
static double **bU=NULL,**bV,*bF,*bS,*bT,*bW;

static double Inorm;
static int FlagE=0,FlagIter=0;
static int nMFPE=0;
#endif

#ifndef stg_EqCHI
extern int iFList,nFList,NFList;
extern char FListEFIT[][16],kFileExt[16],ShotNm[32];
static double ZUp;
#endif
#endif

static int kHist=0;
int ERnRx=0;

#ifndef mzl_PFC

#ifndef stg_PFCoils
int PFCoils()
{
  extern double ESTime;
  static int Fl=1;
  int i,j,k,m,n,nCV,kc[nPFB+nVVC],iA[nPFB+nVVC];
  double R[nPFB+nVVC],Z[nPFB+nVVC],Ib[nPFB+nVVC],It[nPFB+nVVC];
  double s;

  PFBLOCK *lB;
  PSBLOCK *lS;
  PFCOIL *lC;
  char *NmC[nPFB+nVVC],*NmB[nPFB+nVVC];
  extern void IbPFIPlot();

  nCV	=nPFB+nVVC;
  if(Fl == 1){
    for(i=0; i < nPFB; i++){
      lB	=PFB+i;
      k		=lB->kC;
      lB->I	=PFC[k].I0;
      lB->AI	=PFC[k].I0*lB->tn;
    }
    for(i=0; i < nVVC; i++){
      lC	=VVC+i;
      lC->I	=lC->I0;
    }
    Fl=0;
  }
  for(i=0; i < nPFB; i++){
    lB		=PFB+i;
    NmB[i]	=lB->Nm;
    lB->AI	=lB->I*lB->tn;
    It[i]	=lB->I;
    Ib[i]	=lB->AI;
    k		=lB->kC;
    NmC[i]	=PFC[k].Nm;
    kc[i]	=PFC[k].kA;
    iA[i]	=0;
  }
  for(j=0; j < nVVC; j++,i++){
    lC		=VVC+j;
    NmB[i]	=lC->Nm;
    It[i]	=lC->I;
    Ib[i]	=lC->I;
    NmC[i]	=lC->Nm;
    kc[i]	=lC->kA;
    iA[i]	=0;
  }
  R[0]	=ESaR0[0];
  Z[0]	=ESaZ0[0];
#ifndef Tbl_PFCoils
  switch(Fl){
  case 0:
    for(i=0; i < nPFC; i++){
      lC	=PFC+i;
      n	=lC->nB;
      for(j=0; j < n; j++){
	k	=lC->kB[j];
	if(iA[k]){
	  m	=k;
	  break;
	}
      }
      if(j < n){
	It[m]	=Ib[m]/PFB[m].tn;
	for(j=0; j < n; j++){
	  k	=lC->kB[j];
	  It[k]	=It[m];
	  Ib[k]	=It[m]*PFB[k].tn;
	  kc[k]	=kc[m];
	  iA[k]	=1;
	}
      }
      k	=lC->kB[0];
      lC->I	=It[k];
      lC->kA	=kc[k];
    }
    break;
  case 1:
    for(i=0; i < nPFC; i++){
      lC=PFC+i;
      n	=lC->nB;
      for(j=0; j < n; j++){
	k	=lC->kB[j];
	if(iA[k]){
	  m	=k;
	  break;
	}
	k++;
      }
      if(j < n){
	for(j=0; j < n; j++){
	  k	=lC->kB[j];
	  It[k]	=It[m];
	  Ib[k]	=It[m]*PFB[k].tn;
	  kc[k]	=kc[m];
	  iA[k]	=1;
	}
      }
      k	=lC->kB[0];
      lC->I	=It[k];
      lC->kA	=kc[k];
    }
    break;
  case 2:
    for(i=0; i < nPFB; i++){
      lB	=PFB+i;
      k		=lB->kC;
      It[i]	=PFC[k].I0;
      Ib[i]	=PFC[k].I0*lB->tn;
      iA[i]	=0;
    }
    for(j=0; j < nVVC; j++,i++){
      It[i]	=VVC[j].I0;
      Ib[i]	=VVC[j].I0;
      iA[i]	=0;
    }
    Fl=0;
    break;
  case 3:
    for(i=0; i < nPFC; i++){
      lC	=PFC+i;
      lC->I0	=lC->I;
      n	=lC->nB;
      for(j=0; j < n; j++){
	iA[lC->kB[j]]	=0;
      }
    }
    for(j=0; j < nVVC; j++){
      lC	=VVC+j;
      lC->I0	=lC->I;
      iA[j+nPFB]	=0;
    }
    break;
  }
  lB	=PFB;
  R[0]	=ESaR0[0];
  Z[0]	=ESaZ0[0];
  if(iA[0]){
    lB->AI	=Ib[0];
    lB->I	=It[0];
    lB->kA	=kc[0];
    iA[0]	=0;
  }
  else{
    Ib[0]	=lB->AI;
    It[0]	=lB->I;
    kc[0]	=lB->kA;
  }
  for(i=1; i < nPFB; i++){
    lB		=PFB+i;
    R[i]	=lB->R;
    Z[i]	=lB->Z;
    if(iA[i]){
      lB->AI	=Ib[i];
      lB->I	=It[i];
      lB->kA	=kc[i];
      iA[i]	=0;
    }
    else{
      Ib[i]	=lB->AI;
      It[i]	=lB->I;
      kc[i]	=lB->kA;
    }
  }
  for(j=0; j < nVVC; j++,i++){
    lC		=VVC+j;
    lS		=VVB+lC->kB[0];
    R[i]	=cr4*(lS->r[0]+lS->r[1]+lS->r[2]+lS->r[3]);
    Z[i]	=cr4*(lS->z[0]+lS->z[1]+lS->z[2]+lS->z[3]);
    It[i]	=Ib[i];
    lC->I	=Ib[i];
    lC->kA	=kc[i];
    iA[i]	=0;
  }
  for(i=0; i < nPFC; i++){
    lC	=PFC+i;
    lC->kA	=kc[lC->kB[0]];
  }

  PFCnO	=0;
  PFCnF	=0;
  for(i=0; i < nPFC; i++){
    if(PFC[i].kA == 2){
      PFCnF++;
    }
    if(PFC[i].kA == 3){
      PFCnO++;
    }
  }
  for(i=0; i < nVVC; i++){
    if(VVC[i].kA == 2){
      PFCnF++;
    }
    if(VVC[i].kA == 3){
      PFCnO++;
    }
  }
  if(1 || ESTime != 0.){
    sprintf(ln,"%s t=%5.3f",ShotNm,ESTime);
  } 
  else{
    sprintf(ln,"%s.%s",ShotNm,kFileExt);
  }
  PFExpDataPlot(0,ln);
  PFPlasmaJPlot();
  if(PFCnF+PFCnO < PFCnQ){
    CbStr2UserWarning("%d < %d -Too\nfew feedback coils\n",PFCnF,PFCnQ);
  }
  CbUserPlot	=IbPFIPlot;
#endif/*Tbl_PFCoils*/
  return(0);
}
#endif
#ifndef stg_PFCOpt

int PFCOptPar()
{
  extern void IbPFIPlot();
  double Rp[128],Zp[128],wM[128],wI[64],wY[64],wW[64];
  int i,j,k[128],iA[64];
  PFCOIL *lC;
  char *NmC[64],Nm[64][8],Nm0[8]=">---<";

  PFBasicJPlot();
  for(i=0; i < nMFP && i < 128; i++) wM[i]=MFP[i].w;
  while(i < 128) i++;
  for(i=0; i < nPFC && i < 64; i++){
    lC		=PFC+i;
    NmC[i]	=Nm[i];
    wI[i]	=lC->wI;
    wY[i]	=lC->wgY;
    wW[i]	=lC->wW;
  }
  for(j=0; j < nVVC && i < 64; j++,i++){
    lC		=VVC+j;
    NmC[i]	=Nm[i];
    wI[i]	=lC->wI;
    wY[i]	=lC->wgY;
    wW[i]	=lC->wW;
  }
  while(i < 64){
    wI[i]	=0.;
    wY[i]	=0.;
    wW[i]	=0.;
    NmC[i]	=Nm0;
    i++;
  }
#ifndef Tbl_OptP
  for(i=0; i < nMFP && i < 128; i++){
    Rp[i]	=MFP[i].R;
    Zp[i]	=MFP[i].Z;
    MFP[i].w	=wM[i];
    k[i]	=MFP[i].kA;
  }
  while(i < 128){
    Rp[i]	=0.;
    Zp[i]	=0.;
    wM[i]	=0.;
    k[i]	=0;
    i++;
  }
  for(i=0; i < nPFC && i < 64; i++){
    lC		=PFC+i;
    iA[i]	=lC->kA;
    lC->wI	=wI[i];
    lC->wgY	=wY[i];
    lC->wW	=wW[i];
    strcpy(Nm[i],lC->Nm);
  }
  for(j=0; j < nVVC && i < 64; j++,i++){
    lC		=VVC+j;
    iA[i]	=lC->kA;
    lC->wI	=wI[i];
    lC->wgY	=wY[i];
    lC->wW	=wW[i];
    strcpy(Nm[i],lC->Nm);
  }
  while(i < 64){
    iA[i]	=0.;
    wI[i]	=0.;
    wY[i]	=0.;
    wW[i]	=0.;
    i++;
  }
  CbUserPlot	=IbPFIPlot;
#endif/*Tbl_OptP*/
  return(0);
}
#endif

#ifndef stg_PFCIeq
int PFInitCntP()
{
  static int Fl=0;
  
  if(Fl == 0){
    MFPROBE *lP;
    void *lv;
    size_t n;
    int i;

    Fl	=1;
    nCntP	=4;
    CNTP[0].R	=PFB[0].R;
    CNTP[0].Z	=PFB[0].Z+PFB[0].dZ;
    CNTP[1].R	=PFB[0].R;
    CNTP[1].Z	=PFB[0].Z-PFB[0].dZ;
    CNTP[2].R	=PFB[0].R-PFB[0].dR;
    CNTP[2].Z	=PFB[0].Z;
    CNTP[3].R	=PFB[0].R+PFB[0].dR;
    CNTP[3].Z	=PFB[0].Z;
    for(i=0; i < nCntP; i++){
      lP	=CNTP+i;
      lP->ga	=0.;
      lP->Tr	=0.;
      lP->Tz	=0.;
      lP->gY	=0.;
      lP->Br	=0.;
      lP->Bz	=0.;
      lP->kA	=1;
      sprintf(lP->Nm,"CP-%d",i);
    }
    n	=sizeof(MFPROBE);
    lv	=(void*)lP;
    for(i=nCntP; i < 12; i++){
      memcpy((void*)(CNTP+i),lv,sizeof(MFPROBE));
      CNTP[i].kA	=0;
      sprintf(CNTP[i].Nm,"CP-%d",i);
    }

    lP		=CNTP0;
    lP->ga	=0.;
    lP->Tr	=0.;
    lP->Tz	=0.;
    lP->gY	=0.;
    lP->Br	=0.;
    lP->Bz	=0.;
    lP->kA	=0.;
    lP->Nm[0]	='\0';
    lv	=(void*)lP;
    for(i=1; i < 12; i++) memcpy((void*)(CNTP0+i),lv,sizeof(MFPROBE));
  }
  return(0);
}

int ESGetPlVac(double *rD,double *zD,int *iA)
{
  int i,j,m;
  double a,r;

  FlFree2Fix	=1;
  if(FlFree2Fix == 0 || nCntP == 0){
    return(0);
  }
  for(i=0; i < 12; i++){
    rD[i]	=CNTP[i].R;
    zD[i]	=CNTP[i].Z;
    iA[i]	=CNTP[i].kA ? 1 : 0;
  }
 
  m	=0;
  for(i=0; i < 12; i++){
    if(iA[i] && zD[m] < zD[i]) m=i;
  }
  if(m != 0){
    a		=zD[0];
    zD[0]	=zD[m];
    zD[m]	=a;
    a		=rD[0];
    rD[0]	=rD[m];
    rD[m]	=a;
    j		=iA[0];
    iA[0]	=iA[m];
    iA[m]	=j;
  }
  m	=1;
  for(i=1; i < 12; i++){
    if(iA[i] && zD[m] > zD[i]) m=i;
  }
  if(m != 1){
    a		=zD[1];
    zD[1]	=zD[m];
    zD[m]	=a;
    a		=rD[1];
    rD[1]	=rD[m];
    rD[m]	=a;
    j		=iA[1];
    iA[1]	=iA[m];
    iA[m]	=j;
  }
  m	=2;
  for(i=2; i < 12; i++) if(iA[i] && rD[m] > rD[i]) m=i;
  if(m != 2){
    a		=zD[2];
    zD[2]	=zD[m];
    zD[m]	=a;
    a		=rD[2];
    rD[2]	=rD[m];
    rD[m]	=a;
    j		=iA[2];
    iA[2]	=iA[m];
    iA[m]	=j;
  }
  m	=3;
  for(i=3; i < 12; i++){
    if(iA[i] && rD[m] < rD[i]) m=i;
  }
  if(m != 3){
    a		=zD[3];
    zD[3]	=zD[m];
    zD[m]	=a;
    a		=rD[3];
    rD[3]	=rD[m];
    rD[m]	=a;
    j		=iA[3];
    iA[3]	=iA[m];
    iA[m]	=j;
  }

  if(FlFree2Fix == 1) return(0);
  r	=cr2*(rD[3]+rD[2]);
  a	=cr4*(rD[3]-rD[2]);
  if(ESaR0[0] < r-a || ESaR0[0] > r+a) ESaR0[0]=r;
  r	=cr2*(zD[0]+zD[1]);
  a	=cr4*(zD[0]-zD[1]);
  if(ESaZ0[0] < r-a || ESaZ0[0] > r+a) ESaZ0[0]=r;
  FlFree2Fix	=0;
  return(0);
}

int ESSetCntrPoints(double *rD,double *zD,int *iA)
{
  int i;

  PFCnB	=0;
  PFCnY	=0;
  PFCnX	=0;
  nRX	=0;
  for(i=0; i < 12; i++){
    CNTP[i].R	=rD[i];
    CNTP[i].Z	=zD[i];
    CNTP[i].kA	=iA[i];
    if(iA[i] == 1 || iA[i] == 4) PFCnB++;
    if(iA[i] == 2) PFCnY++;
    if(iA[i] == 3 || iA[i] == 4){
      PFCnX++;
      EGvRX[nRX]	=rD[i];
      EGvZX[nRX]	=zD[i];
      nRX++;
    }
  }
  PFCnQ	=PFCnY+PFCnB+2*PFCnX;
  if(PFCnB) PFCnQ--;
  nCntP	=PFCnY+PFCnB+PFCnX;
  return(0);
}

int SetLijCntP()
{
  PFBLOCK *lB;
  PSBLOCK *lS;
  MFPROBE *lP,*lP0;
  int n,j;
  int k1,k2,n1,n2;

  int m,mr,mz,k,kr,kz;
  int nr1,nz1;
  double r0,z0;
  double hr1,hz1,R1,Z1;
  double s,gY,Br,Bz;
  double GPring();
  double gy,br,bz;
  double dgY,dBr,dBz;
  double dS,dS0,dSr,dSz,S,er[4],ez[4],r[4],z[4],r1,z1,dr,dz;

  for(m=0; m < 12; m++){
    for(k=1; k < nPFC; k++){
      gYcC[m][k]	=0.;
      BRcC[m][k]	=0.;
      BZcC[m][k]	=0.;
    }
    lP	=CNTP+m;
    lP0	=CNTP0+m;
/**********/
    if(1 || lP->kA){
      if(1 || lP0->R !=lP->R || lP0->Z !=lP->Z || lP0->kA !=lP->kA){
	r0	=lP->R;
	z0	=lP->Z;
	switch(lP->kA){
/**********/
	case 0:
	case 1:
	case 2:
	  for(k=0; k < EGNp; k++) gYcp[m][k]=GPring(r0,z0,EGaRp[k],EGaZp[k]);
	  for(k=1; k < nPFB; k++){
	    lB	=PFB+k;
	    if(lB->kA){
	      nr1	=lB->nr;
	      nz1	=lB->nz;
	      hr1	=2.*lB->dR/nr1;
	      hz1	=2.*lB->dZ/nz1;
	      R1	=lB->R-lB->dR;
	      Z1	=lB->Z-lB->dZ;
	      gY	=0.;
	      r1	=R1+cr2*hr1;
	      for(kr=0; kr < nr1; kr++){
		z1	=Z1+cr2*hz1;
		for(kz=0; kz < nz1; kz++){
		  gY	+=GPring(r0,z0,r1,z1);
		  z1 	+=hz1;
		}
		r1 +=hr1;
	      }
	      s		=lB->tn/(nr1*nz1);
	      kr	=lB->kC;
	      gYcC[m][kr]+=gY*s;
	    }
	  }

	  for(k=0; k < nVVC; k++){
	    n	=VVC[k].nB;
	    gY	=0.;
	    for(j=0; j < n; j++){
	      lS	=VVB+VVC[k].kB[j];
	      n1	=lS->n1;
	      n2	=lS->n2;
	      er[0]	=(lS->r[1]-lS->r[0])/n1;
	      er[1]	=(lS->r[2]-lS->r[1])/n2;
	      er[2]	=(lS->r[2]-lS->r[3])/n1;
	      er[3]	=(lS->r[3]-lS->r[0])/n2;
	      ez[0]	=(lS->z[1]-lS->z[0])/n1;
	      ez[1]	=(lS->z[2]-lS->z[1])/n2;
	      ez[2]	=(lS->z[2]-lS->z[3])/n1;
	      ez[3]	=(lS->z[3]-lS->z[0])/n2;
	      dr	=(er[2]-er[0])/n2;
	      dz	=(ez[2]-ez[0])/n2;
	      dS0	=2.*(er[0]*ez[3]-ez[0]*er[3]);
	      dSr	=(er[0]*(ez[2]-ez[0])-ez[0]*(er[2]-er[0]))/n2;
	      dSz	=(er[3]*(ez[2]-ez[0])-ez[3]*(er[2]-er[0]))/n2;
	      S		=0.;
	      dgY	=0.;
	      for(k1=0; k1 < n1; k1++){
		for(k2=0; k2 < n2; k2++){
		  r1	=lS->r[0]+k1*er[0]+k2*er[3]+k1*k2*dr;
		  r[0]	=r1;
		  r[1]	=r1+er[0]+k2*dr;
		  r[2]	=r1+er[0]+er[3]+(k1+k2+1)*dr;
		  r[3]	=r1+er[3]+k1*dr;
		  z1	=lS->z[0]+k1*ez[0]+k2*ez[3]+k1*k2*dz;
		  z[0]	=z1;
		  z[1]	=z1+ez[0]+k2*dz;
		  z[2]	=z1+ez[0]+ez[3]+(k1+k2+1)*dz;
		  z[3]	=z1+ez[3]+k1*dz;
		  r1	=cr4*(r[0]+r[1]+r[2]+r[3]);
		  z1	=cr4*(z[0]+z[1]+z[2]+z[3]);
		  dS	=fabs(dS0+(2*k1+1)*dSr-(2*k2+1)*dSz);
		  S	+=dS;
		  dgY	+=GPring(r0,z0,r1,z1)*dS;
		}
	      }
	      dS	=lS->tn/S;
	      gY	+=dgY*dS;
	    }
	    gYcS[m][k]	=gY;
	  }
	  break;
	case 3:
	case 4:
	  for(k=0; k < EGNp; k++){
	    MFring(gYcp[m]+k,BRcp[m]+k,BZcp[m]+k,r0,z0
		   ,EGaRp[k],EGaZp[k],(double)1.);
	  }
	  for(k=1; k < nPFB; k++){
	    lB	=PFB+k;
	    if(lB->kA){
	      nr1	=lB->nr;
	      nz1	=lB->nz;
	      s		=lB->tn/(nr1*nz1);
	      hr1	=2.*lB->dR/nr1;
	      hz1	=2.*lB->dZ/nz1;
	      R1	=lB->R-lB->dR;
	      Z1	=lB->Z-lB->dZ;
	      gY	=0.;
	      Br	=0.;
	      Bz	=0.;
	      r1	=R1+cr2*hr1;
	      for(kr=0; kr < nr1; kr++){
		z1	=Z1+cr2*hz1;
		for(kz=0; kz < nz1; kz++){
		  MFring(&gy,&br,&bz,r0,z0,r1,z1,s);
		  gY	+=gy;
		  Br	+=br;
		  Bz	+=bz;
		  z1 	+=hz1;
		}
		r1 +=hr1;
	      }
	      kr	=lB->kC;
	      gYcC[m][kr]	+=gY;
	      BRcC[m][kr]	+=Br;
	      BZcC[m][kr]	+=Bz;
	    }
	  }
	  for(k=0; k < nVVC; k++){
	    gY	=0.;
	    Bz	=0.;
	    Br	=0.;
	    n	=VVC[k].nB;
	    for(j=0; j < n; j++){
	      lS	=VVB+VVC[k].kB[j];
	      n1	=lS->n1;
	      n2	=lS->n2;
	      er[0]	=(lS->r[1]-lS->r[0])/n1;
	      er[1]	=(lS->r[2]-lS->r[1])/n2;
	      er[2]	=(lS->r[2]-lS->r[3])/n1;
	      er[3]	=(lS->r[3]-lS->r[0])/n2;
	      ez[0]	=(lS->z[1]-lS->z[0])/n1;
	      ez[1]	=(lS->z[2]-lS->z[1])/n2;
	      ez[2]	=(lS->z[2]-lS->z[3])/n1;
	      ez[3]	=(lS->z[3]-lS->z[0])/n2;
	      dr	=(er[2]-er[0])/n2;
	      dz	=(ez[2]-ez[0])/n2;
	      dS0	=2.*(er[0]*ez[3]-ez[0]*er[3]);
	      dSr	=(er[0]*(ez[2]-ez[0])-ez[0]*(er[2]-er[0]))/n2;
	      dSz	=(er[3]*(ez[2]-ez[0])-ez[3]*(er[2]-er[0]))/n2;
	      S		=0.;
	      dgY	=0.;
	      dBr	=0.;
	      dBz	=0.;
	      for(k1=0; k1 < n1; k1++){
		for(k2=0; k2 < n2; k2++){
		  r1	=lS->r[0]+k1*er[0]+k2*er[3]+k1*k2*dr;
		  r[0]	=r1;
		  r[1]	=r1+er[0]+k2*dr;
		  r[2]	=r1+er[0]+er[3]+(k1+k2+1)*dr;
		  r[3]	=r1+er[3]+k1*dr;
		  z1	=lS->z[0]+k1*ez[0]+k2*ez[3]+k1*k2*dz;
		  z[0]	=z1;
		  z[1]	=z1+ez[0]+k2*dz;
		  z[2]	=z1+ez[0]+ez[3]+(k1+k2+1)*dz;
		  z[3]	=z1+ez[3]+k1*dz;
		  r1	=cr4*(r[0]+r[1]+r[2]+r[3]);
		  z1	=cr4*(z[0]+z[1]+z[2]+z[3]);
		  dS	=fabs(dS0+(2*k1+1)*dSr-(2*k2+1)*dSz);
		  S	+=dS;
		  MFring(&gy,&br,&bz,r0,z0,r1,z1,dS);
		  dgY	+=gy;
		  dBr	+=br;
		  dBz	+=bz;
		}
	      }
	      dS	=lS->tn/S;
	      gY	+=dgY*dS;
	      Br	+=dBr*dS;
	      Bz	+=dBz*dS;
	    }
	    gYcS[m][k]	=gY;
	    BRcS[m][k]	=Br;
	    BZcS[m][k]	=Bz;
	  }
	  break;
	default:
	  break;
	}
      }
    }	
    lP0->R	=lP->R;
    lP0->Z	=lP->Z;
    lP0->kA	=lP->kA;
  }
  return(0);
}

int PFPlasmaJPlot()
{
  int iW;
  int i,j,jj,k,kp;
  double x[64],y[64],y1[64],y2[64],X[2],Y[2];
  double js,jp,f;
  static double Is[21],Is2a[21],Ip[21],Ip2a[21];
  double Yd[ESNa1],d2Yd[ESNa1];

  iW	=2;

  j	=(PFB[0].nz/2)*PFB[0].nr;
  jj	=0;
  X[0]	=1e+20;
  X[1]	=0.;
  Y[0]	=1e+20;
  Y[1]	=-1e+20;
  for(i=0; i < PFB[0].nr; i++){
    if(EGkAp[j]){
      x[jj]	=EGaRp[j];
      y[jj]	=EGaIp[j]/EGdS; 
      y1[jj]	=EGdIp[j]/EGdS;
      y2[jj]	=(EGaIp[j]-EGdIp[j])/EGdS;
      if(X[0] > x[jj]) X[0]=x[jj];
      if(X[1] < x[jj]) X[1]=x[jj];
      if(Y[0] > y[jj]) Y[0]=y[jj];
      if(Y[1] < y[jj]) Y[1]=y[jj];
      if(Y[0] > y1[jj]) Y[0]=y1[jj];
      if(Y[1] < y1[jj])	Y[1]=y1[jj];
      if(Y[0] > y2[jj])	Y[0]=y2[jj];
      if(Y[1] < y2[jj])	Y[1]=y2[jj];
      jj++;
    }
    j++;
  }
  SetPlotName("R","j tor","Plasma Current density");
  Scale2d(iW,X,Y,2,6,2);
  X[0]	=EGaR0;
  X[1]	=X[0];
  Plot2d(iW,X,Y,2,6,0,9,0);
  X[0]	=ESsr[0];
  X[1]	=X[0];
  Plot2d(iW,X,Y,2,6,0,14,0);
  X[0]	=ESsr[ESNp/2];
  X[1]	=X[0];
  Plot2d(iW,X,Y,2,6,0,14,0);

  Plot2d(iW,x,y1,jj,6,0,4,0);
  Plot2d(iW,x,y2,jj,6,0,14,0);
  Plot2d(iW,x,y,jj,6,0,0,0);

  if(PFCnK == 0) return(0);

  if(FlagE != 6){
    for(i=0; i < ESNa1; i++){
      Is[i]	=Js[i];
      Is2a[i]	=Js2a[i];
      Ip[i]	=Jp[i];
      Ip2a[i]	=Jp2a[i];
    }
    for(k=0; k < nKj; k++){
      PFGetBasicFunctionsJ(Yd,d2Yd,k);
      for(i=0; i < ESNa1; i++){
	Is[i]	+=EGcgf[k]*Yd[i];
	Is2a[i]	+=EGcgf[k]*d2Yd[i];
      }
    }
    for(kp=0; kp < nKp; kp++,k++){
      PFGetBasicFunctionsP(Yd,d2Yd,kp);
      for(i=0; i < ESNa1; i++){
	Ip[i]	+=EGcgf[k]*Yd[i];
	Ip2a[i]	+=EGcgf[k]*d2Yd[i];
      }
    }
  }

  j	=(PFB[0].nz/2)*PFB[0].nr;
  jj	=0;
  for(i=0; i < PFB[0].nr; i++){
    if(EGkAp[j]){
      x[jj]	=EGaRp[j];

      ESSetSplA(EGsa[j]);
      splRA(&jp,NULL,Jp,Jp2a);
      splRA(&js,NULL,Js,Js2a);
      for(k=0; k < nKj; k++){
	PFSplRA(&f,NULL,k);
	js	+=EGcgf[k]*f;
      }
      for(kp=0; kp < nKp; kp++){
	PFSplRA(&f,NULL,kp+15);
	jp	+=EGcgf[k]*f;
	k++;
      }
      y2[jj]	=(js*ESaR0[0]/EGaRp[j]
		  +jp*(EGaRp[j]/ESaR0[0]-ESaR0[0]/EGaRp[j]));
      splRA(&jp,NULL,Ip,Ip2a);
      splRA(&js,NULL,Is,Is2a);
      y1[jj]	=(js*ESaR0[0]/EGaRp[j]
		  +jp*(EGaRp[j]/ESaR0[0]-ESaR0[0]/EGaRp[j]));
      jj++;
    }
    j++;
  }
  Plot2d(iW,x,y2,jj,6,0,9,0);
  Plot2d(iW,x,y1,jj,6,0,11,0);
  return(0);
}

int PFPlasmagYPlot()
{
  int i,j,k;
  double x[64],y[64],y1[64],y2[64],X[2],Y[2];

  j	=PFB[0].nz/2;
  j	*=PFB[0].nr;
  k	=0;

  X[0]	=1e+20;
  X[1]	=0.;
  Y[0]	=1e+20;
  Y[1]	=-1e+20;
  for(i=0; i < PFB[0].nr; i++){
    if(EGkAp[j]){
      x[k]	=EGaRp[j];
      y[k]	=EGgYe[j]; 
      if(X[0] > x[k]) X[0]=x[k];
      if(X[1] < x[k]) X[1]=x[k];
      if(Y[0] > y[k]) Y[0]=y[k];
      if(Y[1] < y[k]) Y[1]=y[k];
      k++;
    }
    j++;
  }
  Scale2d(2,X,Y,2,6,2);
  Plot2d(2,x,y,k,6,0,0,0);
  return(0);
}

int PFSetPlotPoints()
{
  if(XDSpl1 == NULL) return(1);

  RPlt[0]	=CNTP[3].R;
  ZPlt[0]	=CNTP[3].Z;
  RPlt[1]	=XDSpl2[0];
  ZPlt[1]	=ZPlt[0];
  
  RPlt[2]	=CNTP[0].R;
  ZPlt[2]	=CNTP[0].Z;
  RPlt[3]	=RPlt[2];
  ZPlt[3]	=YDSpl2[0];

  RPlt[4]	=XDSpl1[0];
  ZPlt[4]	=YDSpl1[0];
  RPlt[5]	=XDSpl2[0];
  ZPlt[5]	=YDSpl2[0];
  Step		=EGaRp[1]-EGaRp[0];
  Step		=sqrt(EGdr*EGdz);
  return(0);
}

int PFCOneCellCurrent()
{
  int i;
  for(i=0; i < EGNp; i++){
    EGkAp[i]	=0;
    EGjs[i]	=0.;
    EGjp[i]	=0.;
    EGaIp[i]	=0.;
    EGgYp[i]	=0.;
  }
  i	=(PFB[0].nz/2)*PFB[0].nr+PFB[0].nr/2;
  EGkAp[i]	=1;
  EGsa[i]	=0.;
  EGjs[i]	=PFC[0].I0/EGdS;
  EGaIp[i]	=PFC[0].I0;
  EGwNp		=1;
  EGwRp[0]	=EGaRp[i];
  EGwZp[0]	=EGaZp[i];
  EGwIp[0]	=EGaIp[i];

  nKj	=0;
  nKp	=0;
  return(0);
}

int PFCFlxEq2PlPFB()
{
  int i,j,j1,Np,k;
  double z,z1;
  double R,R0,R1,R2;
  double a,gt,Ip;

  R0	=ESaR0[0];
  Np	=0;

  ESSetMapBox();
  z1	=PFB[0].Z-PFB[0].dZ+cr2*EGdz;
  Ip	=0.;
  j1	=0;
  a	=.95;
  for(i=0; i < PFB[0].nz;  i++){
    j	=j1;
    j1	+=PFB[0].nr;
    z	=z1+i*EGdz;
    if(ES1DMapZ2gt(&gt,&R1,&R2,z) == 0){
      while(EGaRp[j] < R1 && j < j1){
	EGkAp[j]	=0;
	EGgYp[j]	=c2gp*ESgY[ESNa];
	j++;
      }
      gt	=cgp-gt;
      while(EGaRp[j] < R2 && j < j1){
	EGkAp[j]	=1;
	R	=EGaRp[j];
	k	=ES2DMapLab2Flx(&a,&gt,R,z);
	if(k) out("siIddddd","k",Np,k,R,ESaR0[0],z,a,gt);
	ESSetSplA(a);
	if(ESEqSolvInPr != 0){
	  splRA(EGjp+j,NULL,ESjp,ESjp2a);
	}
	else{
	  ESSetSplDPr(a);
	  splRDPr(EGjp+j,NULL,0);
	}
	if(ESEqSolvInCr != 0){
	  splRA(EGjs+j,NULL,ESjs,ESjs2a);
	}
	else{
	  ESSetSplDCr(a);
	  splRDCr(EGjs+j,NULL,0);
	}
	splRA(EGgYp+j,NULL,ESgY,ESgY2a);
	EGgYp[j]	=c2gp*(EGgYp[j]-ESgY[ESNa]);
	EGsa[j]		=a;
	EGjs[j]		*=crgm0*R0/R;
	EGjp[j]		*=crgm0*(R/R0-R0/R);
	EGaIp[j]	=(EGjs[j]+EGjp[j])*EGdS;
	Ip		+=EGaIp[j];
	Np++;
	j++;
      }
      while(j < j1){
	EGkAp[j]	=0;
	EGgYp[j]	=c2gp*ESgY[ESNa];
	j++;
      }
    }
    else{
      while(j < j1){
	EGkAp[j]	=0;
	EGgYp[j]	=c2gp*ESgY[ESNa];
	j++;
      }
    }
  }
  a	=PFC[0].I0/Ip;
  EGwNp		=0;
  for(i=0; i < EGNp;  i++){
    if(EGkAp[i]){
      EGjs[i]	*=a;
      EGjp[i]	*=a;
      EGaIp[i]	*=a;
      EGdIp[i]	=EGaIp[i];
      EGwRp[EGwNp]	=EGaRp[i];
      EGwZp[EGwNp]	=EGaZp[i];
      EGwIp[EGwNp]	=EGaIp[i];
      EGwNp++;
    }
  }
  igYb	=0;
  EGgY0	=c2gp*(ESgY[0]-ESgY[ESNa]);
  EGgYb	=0.;
  return(0);
}

int PFCgY2BasicFuncIp()
{
  int i,k,kp;
  double s,R,rR;

  for(i=0; i < EGNp;  i++){
    if(EGkAp[i]){
      R	=EGaRp[i]/EGaR0;
      rR=EGdS/R;
      R	=R*EGdS-rR;
      ESSetSplA(EGsa[i]);
      for(k=0; k < nKj; k++){
	PFSplRA(&s,NULL,k);
	EGgf[k][i]	=s*rR;
      }
      for(kp=0; kp < nKp; kp++,k++){
	PFSplRA(&s,NULL,kp+15);
	EGgf[k][i]	=s*R;
      }
    }
  }
  return(0);
}

int PFSetJProfile0(double *y,double *d2y)
{
  int i,k;
  double Y[ESNa1],d2Y[ESNa1];

  for(i=0; i < ESNa1; i++){
    y[i]	=Js[i];
    if(d2y != NULL) d2y[i]=Js2a[i];
  }
  if(nKj == 0){
    return(0);
  }
  for(k=0; k < nKj; k++){
    PFGetBasicFunctionsJ(Y,d2Y,k);
    for(i=0; i < ESNa1; i++){
      y[i]	+=EGcgf[k]*Y[i];
      if(d2y != NULL) d2y[i]+=EGcgf[k]*d2Y[i];
    }
  }
  return(0);
}

int PFSetPProfile0(double *y,double *d2y)
{
  int i,k,kp;
  double Y[ESNa1],d2Y[ESNa1];

  for(i=0; i < ESNa1; i++){
    y[i]	=Jp[i];
    if(d2y != NULL) d2y[i]=Jp2a[i];
  }
  if(nKp == 0)  return(0);
  for(kp=0,k=nKj; kp < nKp; kp++,k++){
    PFGetBasicFunctionsP(Y,d2Y,kp);
    for(i=0; i < ESNa1; i++){
      y[i]	+=EGcgf[k]*Y[i];
      if(d2y != NULL) d2y[i]+=EGcgf[k]*d2Y[i];
    }
  }	
  return(0);
}

int PFSetJProfile(double *x,double *y,int n)
{
  int i,k,kp;
  double f,df,a,s;
  double h2sh,h12p2sh;
  double dJ0,dJ1,d2J0,d2J1,js,js1a,jp,jp1a;
  double Ipl;
  extern double *ESLc,*ESLc1,*ESVc,*ESVc1;
  
  s	=(EGsab-ESa0)/(ESsa[ESNa]-ESa0);

  h12p2sh=ESsa[1]-ESsa[0];
  h2sh	=cr2*h12p2sh;
  h12p2sh*=cr12*h12p2sh;

  Ipl	=0;
  ESSetSplA(ESa0);
  splRA(&js,&js1a,Js,Js2a);
  splRA(&jp,&jp1a,Jp,Jp2a);
  if(nKj){
    for(k=0; k < nKj; k++){
      PFSplRA(&f,&df,k);
      js	+=EGcgf[k]*f;
      js1a	+=EGcgf[k]*df*s;
    }
  }
  if(nKp){
    for(kp=0,k=nKj; kp < nKp; kp++,k++){
      PFSplRA(&f,&df,kp+15);
      jp	+=EGcgf[k]*f;
      jp1a	+=EGcgf[k]*df*s;
    }
  }
  js	*=cgm0;
  js1a	*=cgm0*s;
  jp	*=cgm0;
  jp1a	*=cgm0*s;


  d2J1	=js*ESLc[0]+jp*ESVc[0];
  dJ1	=ESsa[0]*d2J1;
  d2J1	+=ESsa[0]*(js1a*ESLc[0]+jp1a*ESVc[0]+js*ESLc1[0]+jp*ESVc1[0]);
  for(i=1; i < ESNa1; i++){
    dJ0		=dJ1;
    d2J0	=d2J1;
    ESSetSplA(ESa0+(ESsa[i]-ESa0)*s);
    splRA(&js,&js1a,Js,Js2a);
    splRA(&jp,&jp1a,Jp,Jp2a);
    if(nKj){
      for(k=0; k < nKj; k++){
	PFSplRA(&f,&df,k);
	js	+=EGcgf[k]*f;
	js1a	+=EGcgf[k]*df*s;
      }
    }
    if(nKp){
      for(kp=0,k=nKj; kp < nKp; kp++,k++){
	PFSplRA(&f,&df,kp+15);
	jp	+=EGcgf[k]*f;
	jp1a	+=EGcgf[k]*df*s;
      }
    }
    js	*=cgm0;
    js1a*=cgm0*s;
    jp	*=cgm0;
    jp1a*=cgm0*s;
    d2J1	=js*ESLc[i]+jp*ESVc[i];
    dJ1		=ESsa[i]*d2J1;
    d2J1	+=ESsa[i]*(js1a*ESLc[i]+jp1a*ESVc[i]+js*ESLc1[i]+jp*ESVc1[i]);
    Ipl		+=h2sh*(dJ0+dJ1)+h12p2sh*(d2J0-d2J1);
  }
  if(Ipl != 0.) Ipl=0.2*ESIpl/Ipl;
  for(i=0; i < n; i++){
    ESSetSplA(ESa0+(x[i]-ESa0)*s);
    splRA(y+i,NULL,Js,Js2a);
    y[i]	*=cgm0*Ipl;
    if(nKj){
      for(k=0; k < nKj; k++){
	PFSplRA(&f,NULL,k);
	y[i]	+=cgm0*EGcgf[k]*f*Ipl;
      }
    }
  }
  return(0);
}

int PFSetPProfile(double *x,double *y,int n)
{
  int i,k,kp;
  double f,s;

  s	=(EGsab-ESa0)/(ESsa[ESNa]-ESa0);
  for(i=0; i < n; i++){
    ESSetSplA(ESa0+(x[i]-ESa0)*s);
    splRA(y+i,NULL,Jp,Jp2a);
    y[i]	*=cgm0;
    if(nKp){
      for(kp=0,k=nKj; kp < nKp; kp++,k++){
	PFSplRA(&f,NULL,kp+15);
	y[i]	+=cgm0*EGcgf[k]*f;
      }
    }
  }
  return(0);
}

int PFReSetJsJp()
{
  int i,k,kp;
  double Y[ESNa1],d2Y[ESNa1];

  if(PFCnK == 0) return(0);
  for(k=0; k < nKj; k++){
    PFGetBasicFunctionsJ(Y,d2Y,k);
    for(i=0; i < ESNa1; i++){
      Js[i]	+=EGcgf[k]*Y[i];
      Js2a[i]	+=EGcgf[k]*d2Y[i];
    }
    EGcgf[k]	=0.;
  }
  for(kp=0; kp < nKp; kp++,k++){
    PFGetBasicFunctionsP(Y,d2Y,kp);
    for(i=0; i < ESNa1; i++){
      Jp[i]	+=EGcgf[k]*Y[i];
      Jp2a[i]	+=EGcgf[k]*d2Y[i];
    }
    EGcgf[k]	=0.;
  }
  return(0);
}

int PFSetJsJp()
{
  int i;
  for(i=0; i < ESNa1; i++){
    Js[i]	=crgm0*ESjs[i];
    Js2a[i]	=crgm0*ESjs2a[i];
    Jp[i]	=crgm0*ESjp[i];
    Jp2a[i]	=crgm0*ESjp2a[i];
  }
  return(0);
}

int PFInitJsJp()
{
  int i;
  for(i=0; i < ESNa1; i++){
    Js[i]	=1.-ESsa[i]*ESsa[i];
    Js2a[i]	=-2.;
    Jp[i]	=0.2*Js[i];
    Jp2a[i]	=0.2*Js2a[i];
  }
  return(0);
}

static int Nc;
static double Rc[512],Zc[512];

int PFSetGridAct()
{
  int i,j,j1,j2,na,np;
  double gY;
  double a,gy,rdgy,dgya,s;

  for(i=0; i < EGNp;  i++){
    EGkAp[i]=EGkA[i] && EGgYp[i] >= EGgYb ? 1 : 0;
      if(CNTP[0].Z < EGaZp[i]) EGkAp[i]=0;
      if(CNTP[1].Z > EGaZp[i]) EGkAp[i]=0;
#ifdef H
    for(j=0; j < nRx && EGkAp[i]; j++){
      if(EGvZx[j] < EGaZ0 && EGaZp[i] < EGvZx[j]) EGkAp[i]=0;
      if(EGaZ0 < EGvZx[j] && EGvZx[j] < EGaZp[i]) EGkAp[i]=0;
    }
#endif
  }

  Nc	=0;
  if(0 && (igYb&0x02)){
    for(i=0; i < nGrEnv; i++){
      j		=iGrEnv[i][0];
      j1	=iGrEnv[i][1];
      if(EGgYp[j] > EGgYp[j1]){
	np	=i+1 < nGrEnv ? iGrEnv[i+1][0]-iGrEnv[i][0] : 
	  iGrEnv[i][0]-iGrEnv[i-1][0];
	na	=iGrEnv[i][1]-iGrEnv[i][0];
	gY	=EGgYp[j];
	j2	=j;
	Rc[Nc]	=EGaRp[j];
	Zc[Nc++]=EGaZp[j];
	Rc[Nc]	=EGaRp[j1];
	Zc[Nc++]	=EGaZp[j1];
	while(EGgYp[j] > EGgYp[j1] && i < nGrEnv){
	  EGkAp[j]	=0;
	  j	=iGrEnv[i][0];
	  j1	=iGrEnv[i][1];
	  Rc[Nc]	=EGaRp[j];
	  Zc[Nc++]	=EGaZp[j];
	  Rc[Nc]	=EGaRp[j1];
	  Zc[Nc++]	=EGaZp[j1];
	  if(gY < EGgYp[j]){
	    gY	=EGgYp[j];
	    j2	=j;
	  }
	  i++;
	}
	j	=j2;
	while(EGgYp[j] > EGgYp[j+na]){
	  j	+=na;
	  while(EGgYp[j+np] > EGgYp[j]) j+=np;
	  while(EGgYp[j-np] > EGgYp[j]) j-=np;
	  j1	=j;
	  while(EGkAp[j1] && EGgYp[j1] > EGgYp[j1+na]){
	    EGkAp[j1]	=0;
	    j1	+=np;
	  }
	  j1	=j-np;
	  while(EGkAp[j1] && EGgYp[j1] > EGgYp[j1+na]){
	    EGkAp[j1]	=0;
	    j1	-=np;
	  }
	}
      }
    }
  }
  rdgy	=1./(EGgY0-EGgYb);
  for(i=0; i < EGNp;  i++){
    if(EGkAp[i]){
      gy	=sqrt((EGgY0-EGgYp[i])*rdgy);
      a		=gy;
      do{
	ESSetSplA(a);
	splRA(&s,&dgya,ESqgY,ESqgY2a);
	a	+=(gy-s)/dgya;
      }while(fabs(gy-s) > 1e-8);
      EGsa[i]	=a;
    }
  }
  return(0);
}

int PFSetGridActHole()
{
  int i,j,j1,j2,na,np;
  double gY;
  double a,gy,rdgy,dgya,s;

  for(i=0; i < EGNp;  i++){
    if(EGkA[i] && EGgYp[i] >= EGgYb){
      j	=ESrz2agt(EGsa+i,&s,EGaRp[i],EGaZp[i]);
      EGkAp[i]	=j == 0 ? 1 : 0;
    }
    else{
      EGkAp[i]	=0;
    }
#ifdef H
    j	=ESIsOutsidePlasma(EGaRp[i],EGaZp[i]);
    if(j == 1 && EGgY0 > EGgYp[i]){
      EGgY0	=EGgYp[i];
    }
#endif
  }
  Nc	=0;
  if((igYb&0x02)){
    for(i=0; i < nGrEnv; i++){
      j		=iGrEnv[i][0];
      j1	=iGrEnv[i][1];
      if(EGgYp[j] > EGgYp[j1]){
	np	=i+1 < nGrEnv ? iGrEnv[i+1][0]-iGrEnv[i][0] : 
	  iGrEnv[i][0]-iGrEnv[i-1][0];
	na	=iGrEnv[i][1]-iGrEnv[i][0];
	gY	=EGgYp[j];
	j2	=j;
	Rc[Nc]	=EGaRp[j];
	Zc[Nc++]=EGaZp[j];
	Rc[Nc]	=EGaRp[j1];
	Zc[Nc++]	=EGaZp[j1];
	while(EGgYp[j] > EGgYp[j1] && i < nGrEnv){
	  EGkAp[j]	=0;
	  j	=iGrEnv[i][0];
	  j1	=iGrEnv[i][1];
	  Rc[Nc]	=EGaRp[j];
	  Zc[Nc++]	=EGaZp[j];
	  Rc[Nc]	=EGaRp[j1];
	  Zc[Nc++]	=EGaZp[j1];
	  if(gY < EGgYp[j]){
	    gY	=EGgYp[j];
	    j2	=j;
	  }
	  i++;
	}
	j	=j2;
	while(EGgYp[j] > EGgYp[j+na]){
	  j	+=na;
	  while(EGgYp[j+np] > EGgYp[j]){
	    j	+=np;
	  }
	  while(EGgYp[j-np] > EGgYp[j]){
	    j	-=np;
	  }
	  j1	=j;
	  while(EGkAp[j1] && EGgYp[j1] > EGgYp[j1+na]){
	    EGkAp[j1]	=0;
	    j1	+=np;
	  }
	  j1	=j-np;
	  while(EGkAp[j1] && EGgYp[j1] > EGgYp[j1+na]){
	    EGkAp[j1]	=0;
	    j1	-=np;
	  }
	}
      }
    }
  }
#ifdef H
  rdgy	=1./(EGgY0-EGgYb);
  for(i=0; i < EGNp;  i++){
    if(EGkAp[i]){
      gy	=(EGgY0-EGgYp[i])*rdgy;
      gy	=gy > 0. ? sqrt((EGgY0-EGgYp[i])*rdgy) : 0.;
      a		=ESa0+gy*(1.-ESa0);
      out("sidd","a0",i,a,gy,EGgY0-EGgYp[i]);
      do{
	ESSetSplA(a);
	splRA(&s,&dgya,ESqgY,ESqgY2a);
	a	+=(gy-s)/dgya;
      }while(fabs(gy-s) > 1e-8);
      EGsa[i]	=a;
      out("siddd","a",i,EGsa[i],gy,gy-s);
    }
  }
#endif
  return(0);
}

int PFCgY2Ip()
{
  int i,k;
  double a,s,Ip;

  EGaR0	=ESaR0[0];
  Ip	=0.;
  for(i=0; i < EGNp;  i++){
    if(EGkAp[i]){
      a		=EGsa[i];
      ESSetSplA(a);
      splRA(EGjp+i,NULL,Jp,Jp2a);
      splRA(EGjs+i,NULL,Js,Js2a);
#ifdef H
      if(1 || ESEqSolvInPr != 0){
	splRA(EGjp+i,NULL,ESjp,ESjp2a);
      }
      else{
	ESSetSplDPr(a);
	splRDPr(EGjp+i,NULL,0);
      }
      if(1 || ESEqSolvInCr != 0){
	splRA(EGjs+i,NULL,ESjs,ESjs2a);
      }
      else{
	ESSetSplDCr(a);
	splRDCr(EGjs+i,NULL,0);
      }
#endif
      s		=EGaR0/EGaRp[i];
      EGjs[i]	*=s;
      EGjp[i]	*=EGaRp[i]/EGaR0-s;
      EGaIp[i]	=(EGjs[i]+EGjp[i])*EGdS;
      Ip	+=EGaIp[i];
    }
  }
  s	=PFC[0].I0/Ip;
  Inorm	=s;
  out("sd","Inorm=",Inorm);
  for(i=0; i < ESNa1;  i++){
    Js[i]	*=s;
    Js2a[i]	*=s;
    Jp[i]	*=s;
    Jp2a[i]	*=s;
  }
  for(k=0; k < PFCnK; k++) EGcgf[k]=1.;
  for(i=0; i < EGNp;  i++){
    if(EGkAp[i]){
      EGjs[i]	*=s;
      EGjp[i]	*=s;
      EGaIp[i]	*=s;
      EGdIp[i]	=EGaIp[i];
    }
  }
  return(0);
}

int PFDeInitAA()
{
  free(iAA);
  free(lAA);
  free(FA);
  return(0);
}

int PFInitAA(int n)
{
  static int nQ=0;

  if(nQ >= n) return(0);
  if(nQ) PFDeInitAA();
  FA	=(double*)malloc((n*n+4*n)*sizeof(double));
  lAA	=(double**)malloc(n*sizeof(double*));
  iAA	=(int*)malloc(n*sizeof(int));
  if(FA == NULL || lAA == NULL || iAA == NULL){
    printf("No memory for FA,lAA,iAA in PFInitAA()\n");
    return(1);
  }
  FAi	=FA+n;
  FAs	=FAi+n;
  FAp	=FAs+n;
  AA	=FAp+n;
  nQ	=n;
  ESmemlevP |=0x00001000;
  return(0);
}

int PFCInvEqMatr0()
{
  int i,j,n;
  double *lA,*lAA;
  double s;

  n	=PFCnB+PFCnY+2*PFCnX;
  if(PFInitAA(n)) return(1);

  lA	=AA;
  for(i=0; i < 12; i++){
    if(CNTP[i].kA == 2){
      for(j=0; j < nPFC; j++){
	if(PFC[j].kA == 2){
	  *lA++		=gYcC[i][j];
	}
      }
      for(j=0; j < nVVC; j++){
	if(VVC[j].kA == 2){
	  *lA++		=gYcS[i][j];
	}
      }
    }
  }
  for(i=0; i < 12; i++){
    if(CNTP[i].kA == 3 || CNTP[i].kA == 4){
      for(j=0; j < nPFC; j++){
	if(PFC[j].kA == 2){
	  *lA++		=BRcC[i][j];
	}
      }
      for(j=0; j < nVVC; j++){
	if(VVC[j].kA == 2){
	  *lA++		=BRcS[i][j];
	}
      }
      for(j=0; j < nPFC; j++){
	if(PFC[j].kA == 2){
	  *lA++		=BZcC[i][j];
	}
      }
      for(j=0; j < nVVC; j++){
	if(VVC[j].kA == 2){
	  *lA++		=BZcS[i][j];
	}
      }
    }
  }
  for(i=0; i < 12; i++){
    if(CNTP[i].kA == 1 || CNTP[i].kA == 4){
      for(j=0; j < nPFC; j++){
	if(PFC[j].kA == 2){
	  *lA++		=gYcC[i][j];
	}
      }
      for(j=0; j < nVVC; j++){
	if(VVC[j].kA == 2){
	  *lA++		=gYcS[i][j];
	}
      }
    }
  }
  if(PFCnB){
    lA	=AA+PFCnF*(PFCnY+2*PFCnX);
    lAA	=AA+PFCnF*(n-1);
    n	=PFCnB-1;
    for(i=0; i < n; i++){
      for(j=0; j < PFCnF; j++){
	*lA++	-=lAA[j];
      }
    }
  }
#ifdef H
  printf("===============\n");
  for(i=0; i < PFCnF; i++){
    for(j=0; j < PFCnF; j++){
      printf("%10.3e",AA[i*PFCnF+j]);
    }
    putchar('\n');
  }
#endif
  LUdcmp(AA,PFCnF,iAA,&s);
  return(0);
}

int TopBottomPlasma(double *X,double y)
{
  double x,F[3];
  double dFx,gY,gYr,gYz;
  int j,k,i[3];
  
  j	=(*X-EGaRp[0])/EGdr;
  if(*X-EGaRp[j] > EGaRp[j+1]-*X){
    j++;
  }
  i[0]	=j;
  i[1]	=j+1;
  i[2]	=j-1;

  for(k=0; k < 3; k++){
    j	=i[k];
    x	=EGaRp[j];
    gYdYWnd(&gY,&dFx,&gYz,x,y,EGwRp,EGwZp,EGwIp,EGwNp);
    if(SetSplXY(x,y)){
      PFCgYMF(&gY,&gYr,&gYz,x,y);
      gYr	*=c2gp*x;
    }
    else{
      SetSplgYCell();
      PFCgYSpl(&gY,&gYr,&gYz);
    }
    dFx		+=gYr;
    F[k]	=dFx;
  }
  gYr	=cr2*(F[1]-F[2])/EGdr;
  gYz	=(F[1]+F[2]-2.*F[0])/(EGdr*EGdr);
  gY	=gYr*gYr-2.*gYz*F[0];
  if(gY < 0.) return(-1);
  gY	=sqrt(gY);
  if(gYr < 0.) gY=-gY;
  *X	=EGaRp[i[0]]-2.*F[0]/(gY+gYr);
  return(0);
}

int PFaIp2gY(double *Err)
{
  int i,j,k,ki,j1,j2,nz,nr;
  double gY,dY,gYbi;
  double Dr,Dz,dr,dz;
  double gYr,gYrr,gYz,gYzz,gYrz,Br,Bz;

  int ic;

  Dr	=1./EGdr;
  Dz	=1./EGdz;
  EGi0	=0;
  EGgY0	=-1e20;
  *Err	=0.;
  for(i=0; i < EGNp; i++){
    gY	=0.;
    for(j=0; j < EGNp; j++) if(EGkAp[j]) gY+=gYpp[i][j]*EGaIp[j];
    for(j=1; j < nPFC; j++) if(PFC[j].kA) gY+=gYpC[i][j]*PFC[j].I;
    for(j=0; j < nVVC; j++) if(VVC[j].kA) gY+=gYpS[i][j]*VVC[j].I;
    dY	=fabs(gY-EGgYp[i]);
    if(*Err < dY) *Err=dY;
    EGgYe[i]	=gY;
    EGgYp[i]	=gY;
    if(EGkA[i] && EGgY0 < gY && EGaZp[i] < CNTP[0].Z && CNTP[1].Z < EGaZp[i]){
      EGi0	=i;
      EGgY0	=gY;
    }
  }
  gYbi	=-1e+20;
  j1	=-1;
  ngYc	=0;
  k	=0;
  for(i=0; i < 12; i++){
    if(CNTP[i].kA == 1 || CNTP[i].kA == 4){
      rgYc[ngYc]=CNTP[i].R;
      zgYc[ngYc]=CNTP[i].Z;
      gY	=0.;
      for(j=0; j < EGNp; j++) if(EGkAp[j])  gY+=gYcp[i][j]*EGaIp[j];
      for(j=1; j < nPFC; j++) if(PFC[j].kA) gY+=gYcC[i][j]*PFC[j].I;
      for(j=0; j < nVVC; j++) if(VVC[j].kA) gY+=gYcS[i][j]*VVC[j].I;
      gYc[ngYc]	=gY;
      if(gYbi < gY){
	if(gYbi < gY){;
	  EGaRb=CNTP[i].R;
	  EGaZb=CNTP[i].Z;
	  gYbi=gY;
	  j1=i;
	}
      }
      ngYc++;
    }
    nRX	=0;
    if(CNTP[i].kA == 3 || CNTP[i].kA == 4){
      gY	=0.;
      Br	=0.;
      Bz	=0.;
      for(j=0; j < EGNp; j++){
	if(EGkAp[j]){
	  gY+=gYcp[i][j]*EGaIp[j];
	  Br+=BRcp[i][j]*EGaIp[j];
	  Bz+=BZcp[i][j]*EGaIp[j];
	}
      }
      for(j=1; j < nPFC; j++){
	if(PFC[j].kA){
	  gY+=gYcC[i][j]*PFC[j].I;
	  Br+=BRcC[i][j]*PFC[j].I;
	  Bz+=BZcC[i][j]*PFC[j].I;
	}
      }
      for(j=0; j < nVVC; j++){
	if(VVC[j].kA){
	  gY+=gYcS[i][j]*VVC[j].I;
	  Br+=BRcS[i][j]*VVC[j].I;
	  Bz+=BZcS[i][j]*VVC[j].I;
	}
      }
      if(CNTP[i].kA == 4){
	EGvgYx[k++]=gY;
      }

      EGgYX[nRX]=gY;
    }
  }
  EGgYb	=gYbi;

  if(j1 >= 0) out("sid","gY Control Points:",j1,gYbi);
#ifdef H
  for(i=0; i < nGrEnv; i++){
    j	=iGrEnv[i][0];
    j1	=iGrEnv[i][1];
    out("????? Ei d<dd dd c",i,gYbi,EGgYp[j],EGgYp[j1],EGaRp[j],EGaZp[j],
	EGgYp[j] > EGgYp[j1] ? '*' :' ');
  }
#endif

  igYb	=0;
  EGgYx	=-1e+20;

  /* Internal points */
  nr	=PFB[0].nr;
  nz	=PFB[0].nz;
  for(i=1; i < nz-1; i++){
    for(k=1; k < nr-1; k++){
      j	=nr*i+k;
      j2=j+1;
      j1=j-1;
      if(EGkA[j]){
	gY	=EGgYp[j];
	gYrr	=(EGgYp[j2]-2.*gY+EGgYp[j1])*Dr*Dr;
	gYr	=cr2*(EGgYp[j2]-EGgYp[j1])*Dr;
	j2	=j+nr;
	j1	=j-nr;
	gYzz	=(EGgYp[j2]-2.*gY+EGgYp[j1])*Dz*Dz;
	gYz	=cr2*(EGgYp[j2]-EGgYp[j1])*Dz;
	gYrz	=cr4*(EGgYp[j2+1]-EGgYp[j2-1]+EGgYp[j1-1]-EGgYp[j1+1])*Dr*Dz;
	dz	=gYrr*gYzz-gYrz*gYrz;
	if(dz < 0.){
	  dz	=1./dz;
	  dr	=(gYrz*gYz-gYzz*gYr)*dz;
	  dz	*=gYrz*gYr-gYrr*gYz;
	  gY	+=(gYr+cr2*gYrr*dr)*dr+(gYz+cr2*gYzz*dz+gYrz*dr)*dz;
	  if(fabs(dr) <= EGdr && fabs(dz) <= EGdz){ 
#ifdef H
  nRx	=0;


	    EGvRx[nRx]	=EGaRp[j]+dr;
	    EGvZx[nRx]	=EGaZp[j]+dz;
	    EGvgYx[nRx]	=gY;
	    nRx++;
#endif
	    if((igYb&0x2) == 0 || EGgYx < gY){
	      igYb	|=0x02;
	      EGaRx	=EGaRp[j]+dr;
	      EGaZx	=EGaZp[j]+dz;
	      EGgYx	=gY;
	      if(EGgYb < gY){
		EGaRb	=EGaRx;
		EGaZb	=EGaZx;
		EGgYb	=gY;
		igYb	|=0x04;
	      }
	    }
	  }
	}
      }
    }
  }
  if((igYb&0x2)){
    EGvRX[nRX]=EGaRx;
    EGvZX[nRX]=EGaZx;
    EGgYX[nRX++]=EGgYx;
  }

#ifdef H
  for(i=0; i < nGrEnv; i++){
    j	=iGrEnv[i][0];
    j1	=iGrEnv[i][1];
    if(EGgYp[j] > EGgYp[j1]){
      nr	=i+1 < nGrEnv ? iGrEnv[i+1][0]-iGrEnv[i][0] : 
	iGrEnv[i][0]-iGrEnv[i-1][0];
      nz	=iGrEnv[i][1]-iGrEnv[i][0];
      gY	=EGgYp[j];
      j2	=j;
      while(i < nGrEnv && EGgYp[j] > EGgYp[j1]){
	j	=iGrEnv[i][0];
	j1	=iGrEnv[i][1];
	if(gY < EGgYp[j]){
	  gY	=EGgYp[j];
	  j2	=j;
	  nr	=i+1 < nGrEnv ? iGrEnv[i+1][0]-iGrEnv[i][0] : 
	    iGrEnv[i][0]-iGrEnv[i-1][0];
	  nz	=iGrEnv[i][1]-iGrEnv[i][0];
	}
	i++;
      }
      j	=j2;
      while(j+nz && j+nz < EGNp && EGgYp[j] > EGgYp[j+nz]){
	j	+=nz;
	while(j+nr < EGNp && EGgYp[j+nr] > EGgYp[j]) j+=nr;
	if(j && j < EGNp){
	  while(j >=nr && j < EGNp && EGgYp[j-nr] > EGgYp[j]) j-=nr;
	}
      }

      j1	=j/PFB[0].nr;
      if(j1 == 0) j1++;
      if(j1 == PFB[0].nz-1) j1--;
      j2	=j%PFB[0].nr;
      if(j2 == 0) j2++;
      if(j == PFB[0].nr-1) j2--;
      j	=j1*PFB[0].nr+j2;

      j2	=j+1;
      j1	=j-1;
      gYrr	=(EGgYp[j2]-2.*EGgYp[j]+EGgYp[j1])*Dr*Dr;
      gYr	=cr2*(EGgYp[j2]-EGgYp[j1])*Dr;
      j2	=j+PFB[0].nr;
      j1	=j-PFB[0].nr;
      gYzz	=(EGgYp[j2]-2.*EGgYp[j]+EGgYp[j1])*Dz*Dz;
      gYz	=cr2*(EGgYp[j2]-EGgYp[j1])*Dz;
      gYrz	=cr4*(EGgYp[j2+1]-EGgYp[j2-1]+EGgYp[j1-1]-EGgYp[j1+1])*Dr*Dz;

      dz	=1./(gYrr*gYzz-gYrz*gYrz);
      dr	=(gYrz*gYz-gYzz*gYr)*dz;
      dz	*=gYrz*gYr-gYrr*gYz;
      gY	=EGgYp[j]+(gYr+cr2*gYrr*dr)*dr+(gYz+cr2*gYzz*dz+gYrz*dr)*dz;

      gYr	=EGaRp[j]+dr;
      gYz	=EGaZp[j]+dz;
      if(RplG[0] < gYr && gYr < RplG[1] && ZplG[0] < gYz && gYz < ZplG[1]){
	if((igYb&0x2) == 0 || EGgYx < gY){
	  EGaRx	=gYr;
	  EGaZx	=gYz;
	  EGgYx	=gY;
	  igYb	|=0x02;
	  if(EGgYb < gY){
	    EGaRb	=EGaRx;
	    EGaZb	=EGaZx;
	    EGgYb	=gY;
	    igYb	|=0x04;
	  }
	}
      }
    }
  }
#endif

  if((igYb&0x02)){
    out("si sd gY_b=d sdd",(igYb&06) == 6 ? "X-point:" : "Fake X-point:"
	,igYb,"gY_x=",EGgYx,EGgYb,"Rx=",EGaRx,EGaZx);
  }
  else{
    EGgYx	=EGgYb;
    out("sisd=gY_b=d","No X-point",igYb," gYx=",EGgYx,EGgYb);
  }
  EGgYL	=-1e+20;
  for(i=0; i < nGrLm; i++){
    j	=iGrLm[i];
    j1	=j-1;
    j2	=j+1;
    gYrr=(EGgYp[j2]-2.*EGgYp[j]+EGgYp[j1])*Dr*Dr;
    gYr	=cr2*(EGgYp[j2]-EGgYp[j1])*Dr;
    dr	=RGrLm[i]-EGaRp[j];
    gY	=EGgYp[j]+(gYr+cr2*gYrr*dr)*dr;

#ifdef H
    j	=jGrLm[i];
    gYr	+=gYrr*dr;
    gYz	=(EGgYp[j]-EGgYp[j-PFB[0].nr])*Dz;
    dY	=1./sqrt(gYr*gYr+gYz*gYz);
    gYr	*=dY;
    gYz	*=dY;
    dY	=gYr*ErGrLm[i]+gYz*EzGrLm[i];
    if(dY < -0.5 && EGgYL < gY){
    }
#endif
    if(EGgYL < gY){
      EGgYL	=gY;
      RPlLm	=RGrLm[i];
      ZPlLm	=ZGrLm[i];
    }
  }
  if(ESa0 == 0.){
    j1	=EGi0+1;
    j	=EGi0-1;
    gYrr	=(EGgYp[j1]-2.*EGgY0+EGgYp[j])*Dr*Dr;
    gYr	=cr2*(EGgYp[j1]-EGgYp[j])*Dr;
    j1	=EGi0+PFB[0].nr;
    j	=EGi0-PFB[0].nr;
    gYzz	=(EGgYp[j1]-2.*EGgY0+EGgYp[j])*Dz*Dz;
    gYz	=cr2*(EGgYp[j1]-EGgYp[j])*Dz;
    gYrz	=cr4*(EGgYp[j1+1]-EGgYp[j1-1]+EGgYp[j-1]-EGgYp[j+1])*Dr*Dz;
    dz	=1./(gYrr*gYzz-gYrz*gYrz);
    dr	=(gYrz*gYz-gYzz*gYr)*dz;
    dz	*=gYrz*gYr-gYrr*gYz;
    EGaR0	=EGaRp[EGi0]+dr;
    EGaZ0	=EGaZp[EGi0]+dz;
    EGgY0	+=(gYr+cr2*gYrr*dr)*dr+(gYz+cr2*gYzz*dz+gYrz*dr)*dz;
  }
  else{
    EGaR0	=ESaR0[0];
    EGaZ0	=ESaZ0[0];
  }
  *Err		/=(EGgY0-EGgYb);

  if(EGgYb < EGgYL){
    if((igYb&0x06) == 0 || (ZPlLm < EGaZ0 && EGaZx < ZPlLm)
       || (EGaZ0 < ZPlLm && ZPlLm < EGaZx)){ 
      igYb	|=0x01;
      EGgYb	=EGgYL; 
    }
  }
  out("si gY_L=d gY_b=d","gY limiter:",igYb,EGgYL,EGgYb);

  if((igYb&0x01)){
    out("sid>ddddd","Boundary at the Limiter:",igYb,EGgYb,gYbi,EGgYx,EGgYL
	,RPlLm,ZPlLm);
  }
  else{
    if((igYb&0x04)){
      out("sid > ddd","Boundary at the X-point:",igYb,EGgYb,gYbi,EGgYx,EGgYL);
    }
    else{
      out("sid > ddd","Boundary at the Contr P:",igYb,EGgYb,gYbi,EGgYx,EGgYL);
    }
  }
  out("s gY0=d gYb=d gY0-gY=d","Fluxes: ",EGgY0,EGgYb,EGgY0-EGgYb);
  {
    double r,z;
    dr	=1.15;
    for(i=0; i < 4; i++){
      dz	=1.*i;
      gYdYWnd(&dY,&gYr,&gYz,dr,dz,EGwRp,EGwZp,EGwIp,EGwNp);
      PFCgYMF(&gY,&Bz,&Br,dr,dz);
      gY	+=dY;
      dY	=cr2gp/dr;
      Br	-=gYz*dY;
      Bz	+=gYr*dY;
      out("s gY0=d Br=d Bz=d r=d z=d","CSol:",gY,Br,Bz,dr,dz);
    }
  }
#ifdef H
#endif
  return(0);
}

int PFCSolvMatrEq0()
{
  int i,j,ki;
  double gY,Br,Bz;
 
  iItr	=0;
  do{
    if(FlBlockIter){
      for(i=0; i < EGNp;  i++) if(EGkAp[i]) EGaIp[i]=EGdIp[i];
    }	
    else{
      if(FlagIter) PFSetGridAct();
      FlagIter=1;
      PFCgY2Ip();
    }
    ki	=0;
    for(i=0; i < 12; i++){
      if(CNTP[i].kA == 2){
	gYc[ki]	=0.;
	for(j=0; j < EGNp; j++) if(EGkAp[j]) gYc[ki]+=gYcp[i][j]*EGaIp[j];
	for(j=1; j < nPFC; j++)
	  if(PFC[j].kA == 1 || PFC[j].kA == 4) gYc[ki]+=gYcC[i][j]*PFC[j].I;
	for(j=0; j < nVVC; j++)
	  if(VVC[j].kA == 1 || VVC[j].kA == 4) gYc[ki]+=gYcS[i][j]*VVC[j].I;
	FA[ki]	=CNTP[i].gY-gYc[ki];
	ki++;
      }
    }
    for(i=0; i < 12; i++){
      if(CNTP[i].kA == 3 || CNTP[i].kA == 4){
	Br	=0.;
	Bz	=0.;
	for(j=0; j < EGNp; j++){
	  if(EGkAp[j]){
	    Br	+=BRcp[i][j]*EGaIp[j];
	    Bz	+=BZcp[i][j]*EGaIp[j];
	  }
	}
	for(j=1; j < nPFC; j++){
	  if(PFC[j].kA == 1 || PFC[j].kA == 4){
	    Br	+=BRcC[i][j]*PFC[j].I;
	    Bz	+=BZcC[i][j]*PFC[j].I;
	  }
	}
	for(j=0; j < nVVC; j++){
	  if(VVC[j].kA == 1 || VVC[j].kA == 4){
	    Br	+=BRcS[i][j]*VVC[j].I;
	    Bz	+=BZcS[i][j]*VVC[j].I;
	  }
	}
	FA[ki++]	=-Br;
	FA[ki++]	=-Bz;
      }
    }
    if(PFCnB){
      for(i=0; i < 12; i++){
	if(CNTP[i].kA == 1 || CNTP[i].kA == 4){
	  gYc[ki]	=0.;
	  for(j=0; j < EGNp; j++) if(EGkAp[j]) gYc[ki]+=gYcp[i][j]*EGaIp[j];
	  for(j=1; j < nPFC; j++)
	    if(PFC[j].kA == 1 || PFC[j].kA == 4)gYc[ki]+=gYcC[i][j]*PFC[j].I;
	  for(j=0; j < nVVC; j++)
	    if(VVC[j].kA == 1 || VVC[j].kA == 4)gYc[ki]+=gYcS[i][j]*VVC[j].I;
	  FA[ki]	=-gYc[ki];
	  ki++;
	}
      }
      ki--;
      for(i=PFCnY+2*PFCnX; i < PFCnF; i++) FA[i]-=FA[ki];
    }
#ifdef H
    printf("FA===================\n");
    for(i=0; i < PFCnF; i++){
      printf("%10.3e",FA[i]);
    }
    putchar('\n');
#endif
    LUbksb(AA,PFCnF,iAA,FA);
    ki	=0;
    for(i=1; i < nPFC; i++){
      if(PFC[i].kA == 2) PFC[i].I=FA[ki++];
    }
    for(j=0; j < nVVC; j++){
      if(VVC[j].kA == 2) VVC[j].I=FA[ki++];
    }
#ifdef H
    printf("I===================\n");
    for(i=0; i < PFCnF; i++){
      printf("%10.3e",FA[i]);
    }
    putchar('\n');
#endif
    PFaIp2gY(&err);
    iItr++;
  }while(iItr < nItr && err > 0.001);
  out("sid","Err",iItr,err);
  for(i=0; i < EGNp; i++){
    if(EGkAp[i]) EGdIp[i]=EGaIp[i];
  }
  return(0);
}

int PFCSolvMatrEq1(double wL,double wB,double wI,double wC)
{
  int i;

  iItr	=0;
  do{
    if(FlBlockIter){
      for(i=0; i < EGNp;  i++){
	if(EGkAp[i]){
	  EGaIp[i]	=EGdIp[i];
	}
      }
    }
    else{
      PFSetGridAct();
      PFCgY2Ip();
    }
    PFCOptEqRHS(wL,wB,wI,wC);
    PFaIp2gY(&err);
    iItr++;
  }while(iItr < nItr && err > 0.001);
  out("sid","Err",iItr,err);
  for(i=0; i < EGNp; i++){
    if(EGkAp[i]){
      EGdIp[i]	=EGaIp[i];
    }
  }
  return(0);
}

void MFLinePlot()
{
  extern double *ECr,*ECz;
  extern void IbPFIPlot();
  char ln[0x20];
  int i,Fl=1;

  IbPFIPlot();
  ZColor(0);
  i	=sprintf(ln,"Ip=%8.6f [MA]",PFC[0].I0);
  ZPlotUTopMString(ln,i);
  for(i=0; i < 12; i++){
    if(CNTP[i].kA == 3 || CNTP[i].kA == 4){
#ifdef XJ    
      MFSepLineLZ(RPlt+4,ZPlt+4,CNTP[i].R,CNTP[i].Z,Step,0);
#endif      
#ifdef H
      PlotSepLine();
#endif
      Fl	=0;
    }
  }
  if(FlPLot == 0){
    ZColor(0);
    if(kHist == 1){
#ifdef EEC
      MFDivertors(StD,Step,nStD,nStS,nRx);
      ZColor(13);
      MFOpenLn(nStD,Step,nRx);
      switch(nRx){
      case 1:
	ESGridBL1X();
	ESGridSoL1X(nStD,nStS);
	break;
      case 2:
	ESGridBL2X();
	ESGridSoL2X(nStD,nStS);
	ZColor(0);
	break;
      default:
	break;
      }
      MFVac2ESI();
#endif
    }else{
      MFOutLines(RPlt+4,ZPlt+4,RPlt[0],ZPlt[0],(igYb&0x04) ? EGgYx : EGgYb
		 ,(ESgY[ESNa-1]-ESgY[ESNa])*(EGgY0-EGgYb)/ESgY[ESNa]
		 ,2,Step);
    }
  }
  else{
    MFLinesOld();
    FlPLot	=0;
  }

  if(EcNjet){
    ZColor(14);
    ZPlotPolyLine(EcRjet,EcZjet,EcNjet);
  }

  if(Fl){
    if((igYb&0x02)){
      ZColor(4);
      MFSepLineLZ(RPlt+4,ZPlt+4,EGaRx,EGaZx,Step,0);
#ifdef H
      PlotSepLine();
#endif
    }
    else{
      ESNsep=0;
    }
  }
#ifdef H
  ZColor(11);
  for(i=0; i < ESNa1; i++){
    ZPlotPolyLine(ECr+ESNp1*i,ECz+ESNp1*i,ESNp1);
  }

  ESOutPlotRec();
#endif
  return;
}

int PFSetCoilOptIndex()
{
  int i;

  for(i=1; i < nPFC; i++){
    if(PFC[i].kA && strncmp(PFC[i].Nm,"OH",2)) PFC[i].kA=3;
  }
  for(i=0; i < nVVC; i++) VVC[i].kA=3;
  for(i=0; i < 12; i++){
    if(CNTP[i].kA && i != 2) CNTP[i].kA=0;
  }
  return(0);
}

int PFIsConsistent(int *iA,int *kC,int Fl)
{
  int i,j,nB,nX,nY,nQ,nF,nO;

  nB	=0;
  nY	=0;
  nX	=0;
  for(i=0; i < 12; i++){
    switch(iA[i]){
    case 1:
      nB++;
      break;
    case 2:
      nY++;
      break;
    case 3:
      nX++;
      break;
    case 4:
      nX++;
      nB++;
      break;
    }
  }
  nQ	=nY+nB+2*nX;
  if(nB) nQ--;
  nF	=0;
  nO	=0;
  j	=nPFC+nVVC;
  for(i=0; i < j; i++){
    if(kC[i] == 2) nF++;
    if(kC[i] == 3) nO++;
  }
  *ln='\0';
  switch(Fl){
  case 0:
    if(nO || nF != nQ){
      CbStr2UserWarning("%d != %d -number of conditions\n!="
			" number of feedback coils\n",nQ,nF);
      *ln='0';
      out("sIsIsIsI","nB=",nB,"nY=",nY,"nX=",nX,"nB=",nB);
      out("sIsIsI","nF=",nF,"nO=",nO,"nF+nO=",nF+nO);
    }
    break;
  case 1:
  case 2:
    if(nO+nF < nQ){
      CbStr2UserWarning("%d < %d -Too\nfew feedback coils\n",nF+nO,nQ);
      *ln='1';
      break;
    }
    if(nQ < nF){
      *ln='2';
      CbStr2UserWarning("%d < %d -Excessive\nfeedback coils\n",nF+nO,nQ);
    }
    break;
  case 3:
    break;
  case 4:
    for(i=0; i < nPFC; i++){
      if(kC[i] == 2){
	kC[i]	=3;
	nO++;
	nF--;
      }
      if(i && kC[i] == 1 && strncmp(PFC[i].Nm,"OH",2)){
	kC[i]	=3;
	nO++;
      }
    }
    for(j=0; j < nVVC; j++,i++){
      if(kC[i] == 2){
	kC[i]	=3;
	nO++;
	nF--;
      }
      if(kC[i] == 1){
	kC[i]	=3;
	nO++;
      }
    }
    break;
  default :
    break;
  }
  if(*ln != '\0'){
    for(i=0; i < nPFC; i++){
      kC[i]	=PFC[i].kA;
    }
    for(j=0; j < nVVC; j++,i++){
      kC[i]	=VVC[j].kA;
    }
    for(i=0; i < 12; i++){
      iA[i]	=CNTP[i].kA;
    }
    *ln=0;
    return(0);
  }
  PFCnQ	=nQ;
  PFCnY	=nY;
  PFCnB	=nB;
  PFCnX	=nX;
  PFCnF	=nF;
  PFCnO	=nO;
  nCntP	=PFCnY+PFCnB+PFCnX;
  nB	=1;
  for(i=0; i < 12; i++){
    if(CNTP[i].kA != iA[i]) nB|=2;
    CNTP[i].kA	=iA[i];
  }
  for(i=0; i < nPFC; i++){
    if(PFC[i].kA != kC[i]) nB|=4;
    PFC[i].kA	=kC[i];
  }
  for(j=0; j < nVVC; j++,i++){
    if(VVC[j].kA != kC[i]) nB|=4;
    VVC[j].kA	=kC[i];
  }
  return(nB);
}

int PFInitOptimization()
{
  int i,j;

  for(i=1; i < nPFC; i++){
    if(strncmp(PFC[i].Nm,"OH",2)) PFC[i].kA=3;
  }
  for(j=0; j < nVVC; j++) VVC[j].kA=3;
  for(i=0; i < 12; i++) CNTP[i].kA=0;
  CNTP[2].kA	=1;
  return(0);
}

int PFSetPFBCurrents()
{
  int i,j;
  double I;

  I	=0.;
  for(i=0; i < EGNp; i++){
    if(EGkAp[i]) I+=EGaIp[i];
  }
  PFC[0].I	=I;
  for(i=0; i < nPFB; i++){
    PFB[i].I	=PFB[i].kA ? PFC[PFB[i].kC].I : 0.;
    PFB[i].AI	=PFB[i].I*PFB[i].tn;
  }

  EGwNp	=0;
  for(i=0; i < EGNp; i++){
    if(EGkAp[i]){
      EGwRp[EGwNp]	=EGaRp[i];
      EGwZp[EGwNp]	=EGaZp[i];
      EGwIp[EGwNp++]	=EGaIp[i];
    }
  }
  return(0);
}

int PFBoundary2ESC()
{
  int i,j;
  double gY,gy;
  double I;
  gY	=EGgYb;
  EGsab	=1.;


  if((igYb&0x06) == 2){
    gy	=EGgYx+0.02*(EGgY0-EGgYx);
    if(gy > EGgYb){
      double s,dgya;
      gY	=gy;
      gy	=sqrt((EGgY0-gY)/(EGgY0-EGgYb));
      EGsab	=gy;
      do{
	ESSetSplA(EGsab);
	splRA(&s,&dgya,ESqgY,ESqgY2a);
	EGsab	+=(gy-s)/dgya;
      }while(fabs(gy-s) > 1e-8);
    }
  }
  if((igYb&0x04)){
    double s,dgya;
    gY	=EGgYx+0.02*(EGgY0-EGgYx);
    gy	=sqrt((EGgY0-gY)/(EGgY0-EGgYx));
    EGsab	=gy;
    do{
      ESSetSplA(EGsab);
      splRA(&s,&dgya,ESqgY,ESqgY2a);
      EGsab	+=(gy-s)/dgya;
    }while(fabs(gy-s) > 1e-8);
    out("sd=ddd<d","\\qgYESC=",gy,gy*gy,EGgY0-gY,EGgY0-EGgYx,ESgY[ESNa]*c2gp);
  }

  if((igYb&0x01)){
    EcRjet[0]	=RPlLm;
    EcZjet[0]	=ZPlLm;
    gY	=EGgYL;
  }
  else{
    EcRjet[0]	=RplG[1]-EGdr;
    EcZjet[0]	=PFB[0].Z;
  }

  EcNjet	=0;
  out("sIIIsdddd","igYb=",igYb&1,igYb&2,igYb&4,"gY0,x,b,esc="
      ,EGgY0,EGgYx,EGgYb,gY);

  if(MFOneLine(EcRjet,EcZjet,&EcNjet,gY,Step)){
    /*plasma boundary for flux coordinates*/
    out("sI","EcNjet=",EcNjet);
    ESNsep=0;
    if((igYb&0x02)) {
      MFSepLine(RPlt+4,ZPlt+4,EGvRx,EGvZx,nRx,Step,0);
    }
    if(FlagPoints && EcNjet > 31 && EcNjet < 0x100){
      ESaR0[0]	=EGaR0;
      ESaZ0[0]	=EGaZ0;
      ESReal2RefData(0);
      ESReal2RefGeom(0);
      ESPlVPoints2PlV(EcRjet,EcZjet,EcNjet);
      ESRef2RealGeom(0);
      ESRealGeom(0);
      if(ESa0 != 0.){
	ES3DMetrTnsrCSHole();
      }
      else{
	ES3DMetrTnsrCS();
      }
    }
  }
  out("sI","EcNjet=",EcNjet);
#ifdef H
#endif
  return(0);
}

int PFDiscrepancy(double wL,double wB,double wI,double wV,double wF)
{
  int i,j,k;
  double gY,gy;
  double dL,L,dB,B,dI,I,dV,V;

  dI	=0.;
  I	=0.;
  k	=0;
  for(i=0; i < nPFC; i++){
    gY	=PFC[i].I-PFC[i].I0;
    if(PFC[i].kA == 3) dI+=gY*gY*PFC[i].wI*PFC[i].tn*PFC[i].tn;
    I	+=fabs(PFC[i].I0);
    k++;
  }
  dI	*=wI*wI;
  if(k) I	/=k;

  dV	=0.;
  V	=0.;
  k	=0;
  for(i=0; i < nVVC; i++){
    gY	=VVC[i].I-VVC[i].I0;
    if(VVC[i].kA == 3) dV+=VVC[i].wI*gY*gY;
    V	+=fabs(VVC[i].I0);
    k++;
  }
  dV	*=wV*wV;
  if(k) V	/=k;
#ifdef H
  dI	=sqrt(k*dI)/I;
#endif
  dL	=0.;
  L	=0.;
  k	=0;
  for(i=0; i < nMFLS; i++){
    if(MFP[i].kA){
      gY	=0.;
      for(j=0; j < EGNp; j++){
	if(EGkAp[j]) gY+=gYip[i][j]*EGaIp[j];
      }
      for(j=1; j < nPFC; j++){
	if(PFC[j].kA) gY+=gYiC[i][j]*PFC[j].I;
      }
      for(j=0; j < nVVC; j++){
	if(VVC[j].kA) gY+=gYiS[i][j]*VVC[j].I;
      }
      MFP[i].S	=gY;
      gY	-=MFP[i].S0;
      dL	+=MFP[i].w*gY*gY;
      L		+=fabs(MFP[i].S0);
      k++;
    }
  }
  if(k) L	/=k;
  dL	*=wL*wL;
#ifdef H
  dL	=sqrt(k*dL)/L;
#endif
  dB	=0.;
  B	=0.;
  k	=0;
  for(; i < nMFP; i++){
    gY	=0.;
    if(MFP[i].kA){
      for(j=0; j < EGNp; j++){
	if(EGkAp[j]) gY+=gYip[i][j]*EGaIp[j];
      }
      for(j=1; j < nPFC; j++){
	if(PFC[j].kA)gY+=gYiC[i][j]*PFC[j].I;
      }
      for(j=0; j < nVVC; j++){
	if(VVC[j].kA)gY+=gYiS[i][j]*VVC[j].I;
      }
      MFP[i].S	=gY;
      gY	-=MFP[i].S0;
      dB	+=MFP[i].w*gY*gY;
      B		+=fabs(MFP[i].S0);
      k++;
    }
  }
  if(k) B	/=k;
  dB	*=wB*wB;
#ifdef H
  dB	=sqrt(k*dB)/B;
#endif
  return(0);
}

int PFCMakeSVD(double wL,double wB,double wI,double wV,double wF,double wP)
{
  int i,j,jj,k,n,kD=sizeof(double);
  int M,N;
  double w,s,ss;
  double Igf[42];
  double *F,*S,*W,*T;
  double gY,gYr,gYrr,Fr,dFr;
  double **lYC,**lYS,**lYp,*ld;
  double wPL,wPB;
  double y[2]={-9.,1.};
  int nB,nL;

  N	=PFCnK+PFCnF+PFCnO;
  W	=bV[N];
  S	=bV[N+1];
  T	=bV[N+2];
  F	=bV[N+3];

  M	=0;
  for(i=1; i < nPFC; i++){
    if(PFC[i].kA == 2 || PFC[i].kA == 3){
      for(j=0; j < N; j++) bU[M][j]	=0.;
      w		=wI*PFC[i].wI;
      bU[M][M]	=w;
      F[M]	=w*PFC[i].I0;
      M++;
    }
  }
  for(i=0; i < nVVC; i++){
    if(VVC[i].kA == 2 || VVC[i].kA == 3){
      for(j=0; j < N; j++) bU[M][j]=0.;
      w		=wV*VVC[i].wI;
      bU[M][M]	=w;
      F[M]	=w*VVC[i].I0;
      M++;
    }
  }
  if(PFCnK){
    for(i=0; i < PFCnK; i++){
      s	=0.;
      for(j=0; j < EGNp; j++){
	if(EGkAp[j]) s+=EGgf[i][j];
      }
      Igf[i]	=s;
    }
    for(k=0; k < PFCnK; k++){
      for(j=0; j < N; j++) bU[M][j]=0.;
      bU[M][M]	=wF*PFC[0].wI*sqrt(PFwrP[k/2])*fabs(Igf[k]);
      F[M]	=0.;
      M++;
    }
    j	=PFCnF+PFCnO;
    for(jj=0; jj < j; jj++) bU[M][jj]=0.;
    w	=wI*PFC[0].wI;
    for(j=0; j < PFCnK; j++){
      bU[M][jj]	=w*Igf[j];
      jj++;
    }
    F[M]	=0.;
    M++;
  }
  wPL	=0.;
  wPB	=0.;
  nL	=0;
  nB	=0;
  if(wL > 0.){
    for(i=0; i < nMFLS; i++){
      if(MFP[i].kA){
	nL++;
	wPL	+=MFP[i].w;
	w	=wL*MFP[i].w;
	ss	=0;
	for(j=0; j < EGNp; j++){
	  if(EGkAp[j]) ss+=gYip[i][j]*EGaIp[j];
	}
	jj	=0;
	for(j=1; j < nPFC; j++){
	  if(PFC[j].kA == 2 || PFC[j].kA == 3){
	    bU[M][jj]	=w*gYiC[i][j];
	    jj++;
	  }
	  if(PFC[j].kA == 1 || PFC[j].kA == 4) ss+=gYiC[i][j]*PFC[j].I;
	}
	for(j=0; j < nVVC; j++){
	  if(VVC[j].kA == 2 || VVC[j].kA == 3){
	    bU[M][jj]	=w*gYiS[i][j];
	    jj++;
	  }
	  if(VVC[j].kA == 1 || VVC[j].kA == 4) ss+=gYiS[i][j]*VVC[j].I;
	}
	for(k=0; k < PFCnK; k++){
	  s	=0.;
	  for(j=0; j < EGNp; j++){
	    if(EGkAp[j]) s+=gYip[i][j]*EGgf[k][j];
	  }
	  bU[M][jj]	=w*s;
	  jj++;
	}
	F[M]	=w*(MFP[i].S0-ss);
	M++;
      }
    }
  }

  if(wB > 0.){
    for(; i < nMFP; i++){
      if(MFP[i].kA){
	nB++;
	wPB	+=MFP[i].w;
	w	=wB*MFP[i].w;
	ss	=0;
	for(j=0; j < EGNp; j++){
	  if(EGkAp[j]) ss+=gYip[i][j]*EGaIp[j];
	}
	jj	=0;
	for(j=1; j < nPFC; j++){
	  if(PFC[j].kA == 2 || PFC[j].kA == 3){
	    bU[M][jj]	=w*gYiC[i][j];
	    jj++;
	  }
	  if(PFC[j].kA == 1 || PFC[j].kA == 4) ss+=gYiC[i][j]*PFC[j].I;
	}
	for(j=0; j < nVVC; j++){
	  if(VVC[j].kA == 2 || VVC[j].kA == 3){
	    bU[M][jj]	=w*gYiS[i][j];
	    jj++;
	  }
	  if(VVC[j].kA == 1 || VVC[j].kA == 4) ss+=gYiS[i][j]*VVC[j].I;
	}
	for(k=0; k < PFCnK; k++){
	  s	=0.;
	  for(j=0; j < EGNp; j++){
	    if(EGkAp[j]) s+=gYip[i][j]*EGgf[k][j];
	  }
	  bU[M][jj]	=w*s;
	  jj++;
	}
	F[M]	=w*(MFP[i].S0-ss);
	M++;
      }
    }
  }
  if(nL) wPL *=wP/nL;
  if(nB) wPB *=wP/nB;
  for(i=0; i < 12; i++){
    jj	=0;
    if(CNTP[i].kA == 2){
      lYC=gYcC;
      lYS=gYcS;
      lYp=gYcp;
      w	=wPL;
      jj	=1;
    }
    if(CNTP[i].kA == 3 || CNTP[i].kA == 4){
      lYC=BRcC;
      lYS=BRcS;
      lYp=BRcp;
      w	=wPB;
      jj	=2;
    }
    while(jj){
      ss	=0.;
      ld	=bU[M];
      for(j=1; j < nPFC; j++){
	if(PFC[j].kA == 2 || PFC[j].kA == 3) *ld++=w*lYC[i][j];
	if(PFC[j].kA == 1 || PFC[j].kA == 4) ss+=lYC[i][j]*PFC[j].I;
      }
      for(j=0; j < nVVC; j++){
	if(VVC[j].kA == 2 || VVC[j].kA == 3) *ld++=w*lYS[i][j];
	if(VVC[j].kA == 1 || VVC[j].kA == 4) ss+=lYS[i][j]*VVC[j].I;
      }
      for(k=0; k < PFCnK; k++){
	s	=0.;
	for(j=0; j < EGNp; j++) if(EGkAp[j]) s+=lYp[i][j]*EGgf[k][j];
	*ld++	=w*s;
      }
      for(j=0; j < EGNp; j++) if(EGkAp[j]) ss+=lYp[i][j]*EGaIp[j];
      F[M]	=-w*ss;
      M++;
      jj--;
      lYC=BZcC;
      lYS=BZcS;
      lYp=BZcp;
    }
  }
  if(PFCnB > 1){
    for(i=0; i < 12; i++){
      if(CNTP[i].kA == 1 || CNTP[i].kA == 4){
	ss	=0.;
	jj	=0;
	ld	=bU[M];
	for(j=1; j < nPFC; j++){
	  if(PFC[j].kA == 2 || PFC[j].kA == 3) *ld++=wPL*gYcC[i][j];
	  if(PFC[j].kA == 1 || PFC[j].kA == 4) ss+=gYcC[i][j]*PFC[j].I;
	}
	for(j=0; j < nVVC; j++){
	  *ld++	=wPL*gYcS[i][j];
	  if(VVC[j].kA == 2 || VVC[j].kA == 3){
	    bU[M][jj]	=wPL*gYcS[i][j];
	    jj++;
	  }
	  if(VVC[j].kA == 1 || VVC[j].kA == 4) ss+=gYcS[i][j]*VVC[j].I;
	}
	for(k=0; k < PFCnK; k++){
	  s	=0.;
	  for(j=0; j < EGNp; j++) if(EGkAp[j]) s+=gYcp[i][j]*EGgf[k][j];
	  *ld++ =wPL*s;
	}
	for(j=0; j < EGNp; j++) if(EGkAp[j]) ss+=gYcp[i][j]*EGaIp[j];
	F[M]	=-wPL*ss;
	M++;
      }
    }

    M	-=PFCnB;
    for(i=1; i < PFCnB; i++){
      F[M]	-=F[M+1];
      for(j=0; j < N; j++) bU[M][j]-=bU[M+1][j];
      M++;
    }
  }

  SVDcmp(M,N,bU,bV,W,T);
  for(i=0; i < N; i++) T[i]=W[i];
  SVDsortR(N,T);
  s	=1./T[0];
  for(i=0; i < N; i++) T[i]*=s;
  PlotSVDEigen(7,N,T,tSVD,y,0);

  for(i=0; i < N; i++) if(W[i]*s < tSVD) W[i]=0.;

  SVDbksb(M,N,bU,bV,W,F,S,T);

  ld	=S;
  for(i=1; i < nPFC; i++) if(PFC[i].kA == 2 || PFC[i].kA == 3) PFC[i].I=*ld++;
  for(i=0; i < nVVC; i++) if(VVC[i].kA == 2 || VVC[i].kA == 3) VVC[i].I=*ld++;

  ss	=0.;
  for(i=0; i < EGNp; i++) if(EGkAp[i]) ss+=EGaIp[i];
  s	=0.;
  for(k=0; k < PFCnK; k++){
    w	=*ld++;
    EGcgf[k]	*=w;
    for(i=0; i < EGNp; i++){
      if(EGkAp[i]){
	s	+=w*EGgf[k][i];
	EGaIp[i]+=w*EGgf[k][i];
      }
    }
  }	
  return(0); 
#ifdef H
  Fr	=0.;
  dFr	=0.;
  s	=0.;	
  for(i=0; i < EGNp; i++){
    if(EGkAp[i]){
      s+=EGaIp[i];
      GetNodeBz(&gY,&gYr,&gYrr,EGaRp[i],EGaZp[i]);
      Fr	+=EGaIp[i]*gYr;
      dFr	+=EGaIp[i]*gYrr;
    }
  }
  PFC[0].I	=s;
  out("sddd","Herb Berk Ipl=",s,Fr,dFr);
#endif
  return(0);
}

int DeMem4EqRcnstrSVD()
{
  if(bU != NULL){
    free(bU[0]);
    free(bU);
  }
  return(0);
}

int Mem4EqRcnstrSVD(double ***UU,double ***VV
		    ,double **FF,double **SS,double **TT,double **WW
		    ,int M,int N)
{
  int i,I;
  double **u,**v;
  I	=N+4;
  u	=(double **)malloc((M+I)*sizeof(double*));
  *UU	=u;
  if(u == NULL){
    CbStr2UserWarning("Mem4EqRcnstrSVD(): no %d memory for *UU\n",M);
    return(1);
  }
  v	=u+M;
  *VV	=v;
  u[0]	=(double*)malloc(((M+N+3)*N+M)*sizeof(double));
  if(u[0] == NULL){
    free(u);
    CbStr2UserWarning("Mem4EqRcnstrSVD(): no %d memory for *UU[0]\n"
		      ,(M+N+3)*N+M);
    *UU	=NULL;
    *VV	=NULL;
    return(1);
  }
  for(i=1; i < M; i++) u[i]=u[i-1]+N;
  
  v[0]	=u[M-1]+N;
  for(i=1; i < I; i++) v[i]=v[i-1]+N;
  *WW	=v[N];
  *SS	=v[N+1];
  *TT	=v[N+2];
  *FF	=v[N+3];
  ESmemlevP |=0x00400000;
  return(0);
}

int MakeSVDHistory(double wL,double wB,double wI,double wV,double wv
		   ,double wF,double wP)
{
  extern int NWin;
  extern WALL VVWall;
  extern double EmnIV;
  int i,j,k,n,n1,M,N;
  double w,s,ss,LL;
  double Igf[42];
  double gY,gYr,gYrr,Fr,dFr;
  RAWDATA *lR;
  double *gy,Iim[nPFC];
  double wPL,wPB;
  double y[2]={-9.,1.};
  int nB,nL;

  for(i=0; i < PFCnK; i++){
    s	=0.;
    for(j=0; j < EGNp; j++) if(EGkAp[j]) s+=EGgf[i][j];
    Igf[i]	=s;
  }

  N	=PFCnK+nVVC;
  M	=0;
  LL	=N*sizeof(double);

  for(k=0; k < PFCnK; k++){
    memset(aU[M],'\0',LL);
    aU[M][M]	=wF*PFC[0].wI*sqrt(PFwrP[k/2])*fabs(Igf[k]);
    aF[M]	=0.;
    M++;
  }

  for(i=0; i < nVVC; i++){
    memset(aU[M],'\0',LL);
    aU[M][M]	=wv*VVC[i].wI;
    aF[M]	=0.;
    M++;
  }
  w	=wI*PFC[0].wI;
  memset(aU[M],'\0',LL);
  for(j=0; j < PFCnK; j++) aU[M][j]=w*Igf[j];
  aF[M]	=0.;
  M++;


  wPL	=0.;
  wPB	=0.;
  nL	=0;
  nB	=0;
  for(i=nMFLS; i < nMFP && i < nMFLS+nMFp/2; i++){
    if(MFP[i].kA){
      if(i < nMFLS){
	nL++;
	wPL	+=MFP[i].w;
	w	=wL*MFP[i].w;
      }
      else{
	nB++;
	wPB	+=MFP[i].w;
	w	=wB*MFP[i].w;
      }
      memset(aU[M],'\0',N*sizeof(double));
      for(k=0; k < PFCnK; k++){
	s	=0.;
	for(j=0; j < EGNp; j++) if(EGkAp[j]) s+=gYip[i][j]*EGgf[k][j];
	aU[M][k]	=w*s;
      }
      for(j=0; j < nVVC; j++,k++) aU[M][k]=w*gYiS[i][j];
      ss	=0.;
      for(j=0; j < EGNp; j++) if(EGkAp[j]) ss+=gYip[i][j]*EGaIp[j];
      aF[M]	=w*(MFP[i].V0-ss);

      M++;
    }
  }

  wPL =nL ? wPL*wP/nL : wP;
  wPB =nB ? wPB*wP/nL : wP;
  
  SVDcmp(M,N,aU,aV,aW,aT);
  for(i=0; i < N; i++) aT[i]=aW[i];

  SVDsortR(N,aT);
  EigenMax	=aT[0];
  s	=1./aT[0];
  for(i=0; i < N; i++) aT[i]*=s;
  PlotSVDEigen(7,N,aT,tSVD1,y,0);

  SVDbksbC(M,N,aU,aV,aW,aF,aS,aT,EigenMax*tSVD1);
  
  ss	=0.;
  for(k=0; k < PFCnK; k++){
    s	=aS[k];
    EGcgf[k]	*=s;
    Igf[k]	*=s;
    for(i=0; i < EGNp; i++) if(EGkAp[i]) EGaIp[i]+=s*EGgf[k][i];
    ss	+=Igf[k];
  }
  for(i=0; i < nVVC; i++,k++) VVC[i].Ie=aS[k];

  for(i=1; i < nPFC; i++) if(PFC[i].kA == 2||PFC[i].kA == 3)PFC[i].I=PFC[i].I0;
  for(i=0; i < nMFP; i++){
    if(MFP[i].kA){
      s	=0.;
      for(j=0; j < nVVC; j++) s+=gYiS[i][j]*VVC[j].Ie;
      for(j=0; j < EGNp; j++) if(EGkAp[j]) s+=gYip[i][j]*EGaIp[j];
      MFP[i].S	=MFP[i].S0-MFP[i].V0+s;
      MFP[i].V	=s;
    }
  }

  /* determination of PFScreen currents */
  N	=nVVC;
  M	=0;
  for(i=0; i < nVVC; i++){
    memset(aU[M],'\0',N*sizeof(double));
    aU[M][M]	=wV*VVC[i].wI;
    aF[M]	=0.;
    M++;
  }
  for(i=0; i < nMFL; i++){
    if(MFP[i].kA){
      w		=i < nMFLS ? wL*MFP[i].w : wB*MFP[i].w;
      for(j=0; j < nVVC; j++) aU[M][j]=w*gYiS[i][j];
      ss	=0;
      for(j=0; j < EGNp; j++) if(EGkAp[j]) ss+=gYip[i][j]*EGaIp[j];
      for(j=1; j < nPFC; j++) if(PFC[j].kA) ss+=gYiC[i][j]*PFC[j].I;
      aF[M]	=w*(MFP[i].S0-ss);
      M++;
    }
  }

  if(PFCnB > 1){
    for(i=0; i < 12; i++){
      if(CNTP[i].kA == 1 || CNTP[i].kA == 4){
	for(j=0; j < nVVC; j++) aU[M][j]=wPL*gYcS[i][j];
	s	=0.;
	for(j=0; j < EGNp; j++) if(EGkAp[j]) s+=gYcp[i][j]*EGaIp[j];
	for(j=1; j < nPFC; j++) if(PFC[j].kA) s+=gYcC[i][j]*PFC[j].I;
	aF[M]	=-wPL*s;
	M++;
      }	
    }
    M-=PFCnB;
    for(i=1; i < PFCnB; i++){
      aF[M]	-=aF[M+1];
      for(j=0; j < N; j++) aU[M][j]-=aU[M+1][j];
      M++;
    }
  }
  SVDcmp(M,nVVC,aU,aV,aW,aT);

  for(i=0; i < nVVC; i++) aT[i]=aW[i];
  SVDsortR(nVVC,aT);
  EigenMax	=aT[0];
  
  s	=1./aT[0];
  for(i=0; i < N; i++) aT[i]*=s;
  if(9 < NWin) PlotSVDEigen(9,N,aT,tSVD,y,0);

  SVDbksbC(M,nVVC,aU,aV,aW,aF,aS,aT,EigenMax*tSVD);
  for(i=0; i < nVVC; i++) VVC[i].I=aS[i];
  for(i=0; i < nMFL; i++){
    if(MFP[i].kA){
      s	=0.;
      for(j=1; j < nPFC; j++) if(PFC[j].kA) s+=gYiC[i][j]*PFC[j].I;
      for(j=0; j < nVVC; j++) s+=gYiS[i][j]*VVC[j].I;
      for(j=0; j < EGNp; j++) if(EGkAp[j]) s+=gYip[i][j]*EGaIp[j];
      MFP[i].S	=s;
    }
  }
  return(0);
}

int MakeSVDHistory0(double wL,double wB,double wI,double wV,double wF
		    ,double wP)
{
  extern WALL VVWall;
  extern double EmnIV;
  int i,j,k,n,n1,M,N;
  double w,s,ss;
  double Igf[42];
  double gY,gYr,gYrr,Fr,dFr;
  RAWDATA *lR;
  double *ld,*lY,Iim[nPFC];
  double wPL,wPB;
  double y[2]={-9.,1.};
  int nB,nL;

  for(i=0; i < PFCnK; i++){
    s	=0.;
    for(j=0; j < EGNp; j++) if(EGkAp[j]) s+=EGgf[i][j];
    Igf[i]	=s;
  }

  N	=PFCnK;
  M	=0;
  for(k=0; k < PFCnK; k++){
    memset(aU[M],'\0',N*sizeof(double));
    aU[M][M]	=wF*PFC[0].wI*sqrt(PFwrP[k/2])*fabs(Igf[k]);
    aF[M]	=0.;
    M++;
  }
  w	=wI*PFC[0].wI;
  memset(aU[M],'\0',N*sizeof(double));
  for(j=0; j < PFCnK; j++) aU[M][j]=w*Igf[j];
  aF[M]	=0.;
  M++;
  wPL	=0.;
  wPB	=0.;
  nL	=0;
  nB	=0;
  for(i=0; i < nMFP; i++){
    if(MFP[i].kA){
      if(i < nMFLS){
	nL++;
	wPL	+=MFP[i].w;
	w	=wL*MFP[i].w;
      }
      else{
	nB++;
	wPB	+=MFP[i].w;
	w	=wB*MFP[i].w;
      }
      memset(aU[M],'\0',N*sizeof(double));
      w		=i < nMFLS ? wL*MFP[i].w : wB*MFP[i].w;
      lY	=gYip[i];
      for(k=0; k < PFCnK; k++){
	s	=0.;
	ld	=EGgf[k];
	for(j=0; j < EGNp; j++) if(EGkAp[j]) s+=lY[j]*(*ld++);
	aU[M][k]	=w*s;
      }
      ss	=0.;
      for(j=0; j < EGNp; j++) if(EGkAp[j]) ss+=gYip[i][j]*EGaIp[j];
      aF[M]	=w*(MFP[i].V0-ss);
      M++;
    }
  }
  if(nL) wPL *=wP/nL;
  if(nB) wPB *=wP/nB;


  n1	=VVWall.n1;
  lY	=gYWC[0];

  Iim[0]=0.;
  for(k=0; k < PFCnK; k++){
    memset(lY,'\0',n1*sizeof(double));
    for(j=0; j < EGNp; j++){
      if(EGkAp[j]){
	s	=EGgf[k][j];
	for(i=0; i < n1; i++) lY[i]+=gYWp[i][j]*s;
      }
    }
    GetSVDExpansion4Wall(Iim+1,lY,EmnIV);

    M	=PFCnK+1;
    for(i=0; i < nMFP; i++){
      if(MFP[i].kA){
	HistoryPhysicalMatRV(&ss,lY,i,EmnIV);
	w	=i < nMFLS ? wL*MFP[i].w : wB*MFP[i].w;
	aU[M][k]+=w*ss;
	M++;
      }
    }
  }

  SVDcmp(M,N,aU,aV,aW,aT);
  for(i=0; i < N; i++) aT[i]=aW[i];

  SVDsortR(N,aT);
  EigenMax	=aT[0];
  s	=1./aT[0];
  for(i=0; i < N; i++) aT[i]*=s;
  PlotSVDEigen(7,N,aT,tSVD,y,0);
  SVDbksbC(M,N,aU,aV,aW,aF,aS,aT,EigenMax*tSVD);
  
  for(i=1; i < nPFC; i++){
    if(PFC[i].kA == 2 || PFC[i].kA == 3) PFC[i].I=PFC[i].I0;
  }
  for(k=0; k < PFCnK; k++){
    s	=aS[k];
    EGcgf[k]	*=s;
    for(i=0; i < EGNp; i++) if(EGkAp[i]) EGaIp[i]+=s*EGgf[k][i];
  }
  for(i=0; i < nVVC; i++,k++) VVC[i].Ie=aS[k];

  for(i=0; i < nMFP; i++){
    if(MFP[i].kA){
      s	=0.;
      for(j=0; j < nVVC; j++) s+=gYiS[i][j]*VVC[j].Ie;
      for(j=0; j < EGNp; j++) if(EGkAp[j]) s+=gYip[i][j]*EGaIp[j];
      MFP[i].S	=MFP[i].S0+s-MFP[i].V0;
      MFP[i].V	=s;
    }
  }

  /* determination of PFScreen currents */
  M	=0;
  for(i=0; i < nMFL; i++){
    if(MFP[i].kA){
      w		=i < nMFLS ? wL*MFP[i].w : wB*MFP[i].w;
      for(j=0; j < nVVC; j++) aU[i][j]=w*gYiS[i][j];
      ss	=0;
      for(j=0; j < EGNp; j++) if(EGkAp[j]) ss+=gYip[i][j]*EGaIp[j];
      for(j=1; j < nPFC; j++) if(PFC[j].kA) ss+=gYiC[i][j]*PFC[j].I;
      aF[i]	=w*(MFP[i].S0-ss);
      M++;
    }
  }
  if(PFCnB > 1){
    for(i=0; i < 12; i++){
      if(CNTP[i].kA == 1 || CNTP[i].kA == 4){
	for(j=0; j < nVVC; j++) aU[M][j]=wPL*gYcS[i][j];
	s	=0.;
	for(j=0; j < EGNp; j++) if(EGkAp[j]) s+=gYcp[i][j]*EGaIp[j];
	for(j=1; j < nPFC; j++) if(PFC[j].kA) s+=gYcC[i][j]*PFC[j].I;
	aF[M]	=-wPL*s;
	M++;
      }	
    }
    M-=PFCnB;
    for(i=1; i < PFCnB; i++){
      aF[M]	-=aF[M+1];
      for(j=0; j < N; j++) aU[M][j]-=aU[M+1][j];
      M++;
    }
  }
  SVDcmp(M,nVVC,aU,aV,aW,aT);

  for(i=0; i < nVVC; i++) aT[i]=aW[i];
  SVDsortR(nVVC,aT);
  EigenMax	=aT[0];
  SVDbksbC(M,nVVC,aU,aV,aW,aF,aS,aT,EigenMax*tSVD);
  for(i=0; i < nVVC; i++) VVC[i].I=aS[i];
  return(0);
}

int MakeSVDHistory1(double wL,double wB,double wI,double wV,double wF)
{
  extern WALL VVWall;
  extern double EmnIV;
  int i,j,k,n,n1,M,N;
  double w,s,ss;
  double Igf[42];
  double gY,gYr,gYrr,Fr,dFr;
  RAWDATA *lR;
  double *gy,Iim[nPFC];

  N	=PFCnK;
  for(i=0; i < PFCnK; i++){
    s	=0.;
    for(j=0; j < EGNp; j++) if(EGkAp[j]) s+=EGgf[i][j];
    Igf[i]	=s;
  }
  
  M	=0;
  for(k=0; k < PFCnK; k++){
    memset(aU[M],'\0',N*sizeof(double));
    aU[M][M]	=wF*PFC[0].wI*sqrt(PFwrP[k/2])*fabs(Igf[k]);
    aF[M]	=0.;
    M++;
  }
  w	=wI*PFC[0].wI;
  memset(aU[M],'\0',N*sizeof(double));
  for(j=0; j < PFCnK; j++) aU[M][j]=w*Igf[j];
  aF[M]	=0.;
  M++;
  for(i=0; i < nMFP; i++){
    if(MFP[i].kA){
      w		=i < nMFLS ? wL*MFP[i].w : wB*MFP[i].w;
      for(k=0; k < PFCnK; k++){
	s	=0.;
	for(j=0; j < EGNp; j++) if(EGkAp[j]) s+=gYip[i][j]*EGgf[k][j];
	aU[M][k]	=w*s;
      }
      HistoryEddyIp2PhysicalSignal(&ss,i);
      for(j=0; j < EGNp; j++){
	if(EGkAp[j]) ss+=gYip[i][j]*EGaIp[j];
      }
      aF[M]	=w*(MFP[i].S0-MFP[i].V0-ss);
      M++;
    }
  }

  n1	=VVWall.n1;
  gy	=gYWC[0];

  Iim[0]=0.;
  for(k=0; k < PFCnK; k++){
    memset(gy,'\0',n1*sizeof(double));
    for(j=0; j < EGNp; j++){
      if(EGkAp[j]){
	s	=EGgf[k][j];
	for(i=0; i < n1; i++) gy[i]+=gYWp[i][j]*s;
      }
    }
    GetSVDExpansion4Wall(Iim+1,gy,EmnIV);

    M	=PFCnK+1;
    for(i=0; i < nMFP; i++){
      if(MFP[i].kA){
	HistoryPhysicalMatRV(&ss,gy,i,EmnIV);
	w	=i < nMFLS ? wL*MFP[i].w : wB*MFP[i].w;
	aU[M][k]+=w*ss;
	M++;
      }
    }
  }

  SVDcmp(M,PFCnK,aU,aV,aW,aT);
  for(i=0; i < PFCnK; i++) aT[i]=aW[i];

  SVDsortR(PFCnK,aT);
  EigenMax	=aT[0];
  SVDbksbC(M,PFCnK,aU,aV,aW,aF,aS,aT,EigenMax*tSVD);
  
  for(i=1; i < nPFC; i++){
    if(PFC[i].kA == 2 || PFC[i].kA == 3) PFC[i].I=PFC[i].I0;
  }
  for(i=0; i < nVVC; i++) if(VVC[i].kA == 2 || VVC[i].kA == 3) VVC[i].I=0.;

  for(k=0; k < PFCnK; k++){
    s	=aS[k];
    EGcgf[k]	*=s;
    for(i=0; i < EGNp; i++) if(EGkAp[i]) EGaIp[i]+=s*EGgf[k][i];
  }

  /* determination of PFScreen currents */
  M	=0;
  for(i=0; i < nMFL; i++){
    if(MFP[i].kA){
      w		=i < nMFLS ? wL*MFP[i].w : wB*MFP[i].w;
      for(j=0; j < nVVC; j++) aU[i][j]=w*gYiS[i][j];
      ss	=0;
      for(j=0; j < EGNp; j++) if(EGkAp[j])  ss+=gYip[i][j]*EGaIp[j];
      for(j=1; j < nPFC; j++) if(PFC[j].kA) ss+=gYiC[i][j]*PFC[j].I;
      aF[i]	=w*(MFP[i].S0-ss);
      M++;
    }
  }
  SVDcmp(M,nVVC,aU,aV,aW,aT);
  for(i=0; i < nVVC; i++) aT[i]=aW[i];
  SVDsortR(nVVC,aT);
  EigenMax	=aT[0];
  SVDbksbC(M,nVVC,aU,aV,aW,aF,aS,aT,EigenMax*tSVD);
  for(i=0; i < nVVC; i++) VVC[i].I=aS[i];
  return(0);
}

int PFCSolvSVDHistory(double wL,double wB,double wI,double wV,double wv
		      ,double wF,double wP,int Fl)
{
  int i,j;

  if(PFCnK == 0) return(1); 
  iItr	=0;
  do{
    if(FlBlockIter){
      for(i=0; i < EGNp;  i++) if(EGkAp[i]) EGaIp[i]=EGdIp[i];
    }
    else{
      if(FlagIter){
	if(ESa0 == 0.){
	  PFSetGridAct();
	}
	else{
	  PFSetGridActHole();
	}
	PFCgY2Ip();
      }
      FlagIter=1;
    }
    if(PFCnK) PFCgY2BasicFuncIp();
    if(Fl == 4) MakeSVDHistory(wL,wB,wI,wV,wv,wF,wP);
    else MakeSVDHistory0(wL,wB,wI,wV,wF,wP);

    PFaIp2gY(&err);
    iItr++;
  }while(iItr < nItr && err > 0.001); 

  out("sid","Err",iItr,err);
  return(0);
}

int PFCOptSVDold(double wL,double wB,double wI,double wV,double wF,double wP)
{
  int i,j,jj,k,n,kD=sizeof(double);
  int M,N;
  int ind[0x10];
  double C[0x100],bC[0x100],Co[0x10*nPEC],bCo[0x10*nPEC],c[0x10],c1[0x10];
  double w,s,ss;
  double Igf[42];
  double *F,*S,*W,*T;
  double gY,gYr,gYrr,Fr,dFr;
  double **lYC,**lYS,**lYp,*ld,*lo;
  double wPL,wPB;
  double y[2]={-9.,1.};
  int nB,nL;

  M	=0;
  N	=PFCnO;
  ld	=C;
  lo	=Co;
  for(i=0; i < 12; i++){
    jj	=0;
    if(CNTP[i].kA == 2){
      lYC=gYcC;
      lYS=gYcS;
      lYp=gYcp;
      jj	=1;
    }
    if(CNTP[i].kA == 3 || CNTP[i].kA == 4){
      lYC=BRcC;
      lYS=BRcS;
      lYp=BRcp;
      jj	=2;
    }
    while(jj){
      ss	=0.;
      for(j=1; j < nPFC; j++){
	if(PFC[j].kA == 2) *ld++=lYC[i][j];
	if(PFC[j].kA == 3) *lo++=lYC[i][j];
	if(PFC[j].kA == 1 || PFC[j].kA == 4) ss+=lYC[i][j]*PFC[j].I;
      }
      for(j=0; j < nVVC; j++){
	if(VVC[j].kA == 2) *ld++=lYS[i][j];
	if(VVC[j].kA == 3) *lo++=lYS[i][j];
	if(VVC[j].kA == 1 || VVC[j].kA == 4) ss+=lYS[i][j]*VVC[j].I;
      }
      for(j=0; j < EGNp; j++) if(EGkAp[j]) ss+=lYp[i][j]*EGaIp[j];
      c[M]	=-ss;
      M++;
      jj--;
      lYC=BZcC;
      lYS=BZcS;
      lYp=BZcp;
    }
  }
  if(PFCnB > 1){
    jj	=0;
    for(i=0; i < 12; i++){
      if(CNTP[i].kA == 1 || CNTP[i].kA == 4){
	ss	=0.;
	for(j=1; j < nPFC; j++){
	  if(PFC[j].kA == 2) *ld++=gYcC[i][j];
	  if(PFC[j].kA == 3) *lo++=gYcC[i][j];
	  if(PFC[j].kA == 1 || PFC[j].kA == 4) ss+=gYcC[i][j]*PFC[j].I;
	}
	for(j=0; j < nVVC; j++){
	  if(VVC[j].kA == 2) *ld++=gYcS[i][j];
	  if(VVC[j].kA == 3) *lo++=gYcS[i][j];
	  if(VVC[j].kA == 1 || VVC[j].kA == 4) ss+=gYcS[i][j]*VVC[j].I;
	}
	for(j=0; j < EGNp; j++) if(EGkAp[j]) ss+=gYcp[i][j]*EGaIp[j];
	c[M]	=-ss;
	if(jj){
	  c[M-1]-=c[M];
	  for(j=0; j < N; j++) Co[N*(M-1)+j]-=Co[N*M+j];
	  for(j=0; j < PFCnF; j++) C[PFCnF*(M-1)+j]-=C[PFCnF*M+j];
	}
	M++;
	jj++;
      }
    }
    M--;
  }
  if(M){
    LUdcmp(C,M,ind,&s);
    LUbksb(C,M,ind,c);
    for(j=0; j < N; j++){
      for(i=0; i < M; i++) c1[i]=Co[N*i+j];
      LUbksb(C,M,ind,c1);
      for(i=0; i < M; i++) bC[N*i+j]=c1[i];
    }
  }

  N	=PFCnF+PFCnO;
  W	=bV[N];
  S	=bV[N+1];
  T	=bV[N+2];
  F	=bV[N+3];

  M	=0;
  for(i=1; i < nPFC; i++){
    if(PFC[i].kA == 2 || PFC[i].kA == 3){
      memset(bU[M],0,N*kD);
      bU[M][M]	=wI;
      F[M]	=0.;
      M++;
    }
  }
  for(i=0; i < nVVC; i++){
    if(VVC[i].kA == 2 || VVC[i].kA == 3){
      memset(bU[M],0,N*kD);
      bU[M][M]	=wV;
      F[M]	=0.;
      M++;
    }
  }
  for(i=0; i < 12; i++){
    jj	=0;
    if(CNTP[i].kA == 2){
      lYC=gYcC;
      lYS=gYcS;
      lYp=gYcp;
      w	=wL;
      jj	=1;
    }
    if(CNTP[i].kA == 3 || CNTP[i].kA == 4){
      lYC=BRcC;
      lYS=BRcS;
      lYp=BRcp;
      w	=wB;
      jj	=2;
    }
    while(jj){
      ss	=0.;
      ld	=bU[M];
      for(j=1; j < nPFC; j++){
	if(PFC[j].kA == 2 || PFC[j].kA == 3) *ld++=w*lYC[i][j];
	if(PFC[j].kA == 1 || PFC[j].kA == 4) ss+=lYC[i][j]*PFC[j].I;
      }
      for(j=0; j < nVVC; j++){
	if(VVC[j].kA == 2 || VVC[j].kA == 3) *ld++=w*lYS[i][j];
	if(VVC[j].kA == 1 || VVC[j].kA == 4) ss+=lYS[i][j]*VVC[j].I;
      }
      for(j=0; j < EGNp; j++) if(EGkAp[j]) ss+=lYp[i][j]*EGaIp[j];
      F[M]	=-w*ss;
      M++;
      jj--;
      lYC=BZcC;
      lYS=BZcS;
      lYp=BZcp;
    }
  }
  if(PFCnB > 1){
    wPL	=wL;
    for(i=0; i < 12; i++){
      if(CNTP[i].kA == 1 || CNTP[i].kA == 4){
	ss	=0.;
	jj	=0;
	ld	=bU[M];
	for(j=1; j < nPFC; j++){
	  if(PFC[j].kA == 2 || PFC[j].kA == 3) *ld++=wPL*gYcC[i][j];
	  if(PFC[j].kA == 1 || PFC[j].kA == 4) ss+=gYcC[i][j]*PFC[j].I;
	}
	for(j=0; j < nVVC; j++){
	  *ld++	=wPL*gYcS[i][j];
	  if(VVC[j].kA == 2 || VVC[j].kA == 3){
	    bU[M][jj]	=wPL*gYcS[i][j];
	    jj++;
	  }
	  if(VVC[j].kA == 1 || VVC[j].kA == 4) ss+=gYcS[i][j]*VVC[j].I;
	}
	for(k=0; k < PFCnK; k++){
	  s	=0.;
	  for(j=0; j < EGNp; j++) if(EGkAp[j]) s+=gYcp[i][j]*EGgf[k][j];
	  *ld++ =wPL*s;
	}
	for(j=0; j < EGNp; j++) if(EGkAp[j]) ss+=gYcp[i][j]*EGaIp[j];
	F[M]	=-wPL*ss;
	M++;
      }
    }

    M	-=PFCnB;
    for(i=1; i < PFCnB; i++){
      F[M]	-=F[M+1];
      for(j=0; j < N; j++) bU[M][j]-=bU[M+1][j];
      M++;
    }
  }

  SVDcmp(M,N,bU,bV,W,T);
  for(i=0; i < N; i++) T[i]=W[i];
  SVDsortR(N,T);
  s	=1./T[0];
  for(i=0; i < N; i++) T[i]*=s;
  PlotSVDEigen(7,N,T,tSVD,y,0);

  for(i=0; i < N; i++) if(W[i]*s < tSVD) W[i]=0.;

  SVDbksb(M,N,bU,bV,W,F,S,T);

  ld	=S;
  for(i=1; i < nPFC; i++) if(PFC[i].kA == 2 || PFC[i].kA == 3) PFC[i].I=*ld++;
  for(i=0; i < nVVC; i++) if(VVC[i].kA == 2 || VVC[i].kA == 3) VVC[i].I=*ld++;

  ss	=0.;
  for(i=0; i < EGNp; i++) if(EGkAp[i]) ss+=EGaIp[i];
  return(0); 
}

int PFCOptSVD(double wL,double wB,double wI,double wV,double wF,double wP)
{
  int i,j,jj,k,n,kD=sizeof(double);
  int M,N;
  int ind[0x10],kk[nPEC],*kkF;
  double C[0x100],bC[0x100],Co[0x10*nPEC],bCo[0x10*nPEC],c1[0x10];
  double w,s,ss;
  double Igf[42];
  double *F,*S,*W,*T,*c;
  double gY,gYr,gYrr,Fr,dFr;
  double **lYC,**lYS,**lYp,*ld,*lo;
  double wPL,wPB;
  double y[2]={-9.,1.};
  int nB,nL;
  int nP3,nV3,nP2,nV2,nP1,nV1;

  N	=PFCnF+PFCnO;
  W	=bV[N];
  S	=bV[N+1];
  c	=S+PFCnO;
  T	=bV[N+2];
  F	=bV[N+3];

  i	=0;
  for(j=1; j < nPFC; j++) if(PFC[j].kA == 3) kk[i++]=j;
  nP3	=i;
  for(j=0; j < nVVC; j++) if(VVC[j].kA == 3) kk[i++]=j;
  nV3	=i;
  kkF	=kk+nV3;
  for(j=1; j < nPFC; j++) if(PFC[j].kA == 2) kk[i++]=j;
  nP2	=i;
  for(j=0; j < nVVC; j++) if(VVC[j].kA == 2) kk[i++]=j;
  nV2	=i;
  for(j=1; j < nPFC; j++) if(PFC[j].kA == 1 || PFC[j].kA == 4) kk[i++]=j;
  nP1	=i;
  for(j=0; j < nVVC; j++) if(VVC[j].kA == 1 || VVC[j].kA == 4) kk[i++]=j;
  nV1	=i;

  M	=0;
  ld	=C;
  lo	=Co;
  for(i=0; i < 12; i++){
    jj	=0;
    if(CNTP[i].kA == 2){
      lYC=gYcC;
      lYS=gYcS;
      lYp=gYcp;
      jj	=1;
    }
    if(CNTP[i].kA == 3 || CNTP[i].kA == 4){
      lYC=BRcC;
      lYS=BRcS;
      lYp=BRcp;
      jj	=2;
    }
    while(jj){
      ss	=0.;
      for(j=0; j < nP3; j++) *lo++=lYC[i][kk[j]];
      for(; j < nV3; j++) *lo++=lYS[i][kk[j]];
      for(; j < nP2; j++) *ld++=lYC[i][kk[j]];
      for(; j < nV2; j++) *ld++=lYS[i][kk[j]];

      for(; j < nP2; j++) ss	+=lYC[i][kk[j]]*PFC[kk[j]].I;
      for(; j < nV2; j++) ss	+=lYS[i][kk[j]]*VVC[kk[j]].I;
      for(j=0; j < EGNp; j++) if(EGkAp[j]) ss+=lYp[i][j]*EGaIp[j];
      c[M]	=-ss;
      M++;
      jj--;
      lYC=BZcC;
      lYS=BZcS;
      lYp=BZcp;
    }
  }
  if(PFCnB > 1){
    jj	=0;
    for(i=0; i < 12; i++){
      if(CNTP[i].kA == 1 || CNTP[i].kA == 4){
	ss	=0.;
	for(j=0; j < nP3; j++) *lo++=gYcC[i][kk[j]];
	for(; j < nV3; j++) *lo++=gYcS[i][kk[j]];
	for(; j < nP2; j++) *ld++=gYcC[i][kk[j]];
	for(; j < nV2; j++) *ld++=gYcS[i][kk[j]];
	for(; j < nP2; j++) ss	+=gYcC[i][kk[j]]*PFC[kk[j]].I;
	for(; j < nV2; j++) ss	+=gYcS[i][kk[j]]*VVC[kk[j]].I;

	for(j=0; j < EGNp; j++) if(EGkAp[j]) ss+=gYcp[i][j]*EGaIp[j];
	c[M]	=-ss;
	if(jj){
	  c[M-1]-=c[M];
	  for(j=0; j < PFCnO; j++) Co[PFCnO*(M-1)+j]-=Co[PFCnO*M+j];
	  for(j=0; j < PFCnF; j++) C[PFCnF*(M-1)+j]-=C[PFCnF*M+j];
	}
	M++;
	jj++;
      }
    }
    M--;
  }
  if(M){
    LUdcmp(C,M,ind,&s);
    LUbksb(C,M,ind,c);
    for(j=0; j <PFCnO ; j++){
      for(i=0; i < M; i++) c1[i]=Co[PFCnO*i+j];
      LUbksb(C,M,ind,c1);
      for(i=0; i < M; i++) bC[PFCnO*i+j]=c1[i];
    }
  }

  N	=PFCnF+PFCnO;
  M	=0;
  for(i=0; i < N; i++) memset(bU[i],0,N*kD);
  for(i=0; i < nP3; i++){
    bU[M][M]	=wI;
    M++;
  }
  for(; i < nV3; i++){
    bU[M][M]	=wV;
    M++;
  }
  for(; i < nP2; i++){
    bU[M][M]	=wP;
    M++;
  }
  for(; i < nV2; i++){
    bU[M][M]	=wV;
    M++;
  }
  memset(F,0,M*kD);
  for(i=PFCnO,k=0; i < N; i++,k++){
    w	=bU[i][i];
    F[i]	-=w*c[k];
    ss	=0.;
    ld	=bC+PFCnO*k;
    for(j=0; j < PFCnO; j++) bU[i][j] -=w*(*ld++);
  }

  N	=PFCnO;
  SVDcmp(M,N,bU,bV,W,T);
  for(i=0; i < N; i++) T[i]=W[i];
  SVDsortR(N,T);
  s	=1./T[0];
  for(i=0; i < N; i++) T[i]*=s;
  PlotSVDEigen(7,N,T,tSVD,y,0);

  for(i=0; i < N; i++) if(W[i]*s < tSVD) W[i]=0.;

  SVDbksb(M,N,bU,bV,W,F,S,T);

  for(i=0; i < PFCnF; i++){
    ss	=0.;
    ld	=bC+PFCnO*i;
    for(j=0; j < PFCnO; j++) ss+=(*ld++)*S[j];
    c[i]	-=ss;
  }

  for(j=0; j < nP3; j++) PFC[kk[j]].I=S[j];
  for(; j < nV3; j++) VVC[kk[j]].I=S[j];
  for(; j < nP2; j++) PFC[kk[j]].I=S[j];
  for(; j < nV2; j++) VVC[kk[j]].I=S[j];

  ss	=0.;
  for(i=0; i < EGNp; i++) if(EGkAp[i]) ss+=EGaIp[i];
  return(0); 
}

int PFCSVD(double wL,double wB,double wI,double wV,double wF,double wP)
{
  int i;

  iItr=0;
  do{
    if(FlBlockIter){
      for(i=0; i < EGNp;  i++){
	if(EGkAp[i]) EGaIp[i]=EGdIp[i];
      }
    }
    else{
      if(FlagIter){
	if(ESa0 == 0.){
	  PFSetGridAct();
	}
	else{
	  PFSetGridActHole();
	}
	PFCgY2Ip();
      }
      FlagIter=1;
    }
    PFCOptSVD(wL,wB,wI,wV,wF,wP);
    PFaIp2gY(&err);
    iItr++;
  }while(iItr < nItr && err > 0.001);
  out("sid","Err",iItr,err);
  return(0);
}

int PFCSolvSVD(double wL,double wB,double wI,double wV,double wF,double wP)
{
  int i,j;

  iItr=0;
  do{
    if(FlBlockIter){
      int i;
      for(i=0; i < EGNp;  i++){
	if(EGkAp[i]) EGaIp[i]=EGdIp[i];
      }
    }
    else{
      if(FlagIter){
	if(ESa0 == 0.){
	  PFSetGridAct();
	}
	else{
	  PFSetGridActHole();
	}
	PFCgY2Ip();
      }
      FlagIter=1;
    }

    if(PFCnK) PFCgY2BasicFuncIp();
    PFCMakeSVD(wL,wB,wI,wV,wF,wP);

    PFaIp2gY(&err);
    iItr++;
  }while(iItr < nItr && err > 0.001);
  out("sid","Err",iItr,err);
  return(0);
}

int WriteYCC()
{
  size_t ii,id;
  int i,k,n;
  FILE *lF;

  ii	=(size_t)sizeof(int);
  id	=(size_t)sizeof(double);
  n	=nPFC-1;

  lF=fopen("gYpC","w");
#ifdef H
  for(i=0; i < nPFC; i++){
    fwrite(&PFC[i].kA,ii,1,lF);
    fwrite(&PFC[i].I0,id,1,lF);
    fwrite(&PFC[i].dI,id,1,lF);
  }
  for(i=0; i < nVVC; i++){
    fwrite(&VVC[i].kA,ii,1,lF);
    fwrite(&VVC[i].I0,id,1,lF);
    fwrite(&VVC[i].dI,id,1,lF);
  }
  for(i=0; i < nMFP; i++){
    if(MFP[i].kA){
      fwrite(&MFP[i].kA,ii,1,lF);
      fwrite(&MFP[i].S0,id,1,lF);
      fwrite(&MFP[i].dS,id,1,lF);
    }
  }
  fwrite(&EGNp,ii,1,lF);
  fwrite(EGkAp,ii,EGNp,lF);
#endif
  k	=0;
  for(i=0; i < EGNp; i++){
    if(EGkAp[i]) k++;
  }
  fwrite(&k,ii,1,lF);
  for(i=0; i < EGNp; i++){
    if(EGkAp[i]){
      fwrite(EGaIp+i,id,1,lF);
    }
  }
  fclose(lF);

#ifdef H
  lF=fopen("gYpC","w");
  for(i=0; i < EGNp; i++){
    fwrite(gYpC[i]+1,id,(size_t)n,lF);
  }
  fclose(lF);

  lF=fopen("gYpS","w");
  out("sI","nVVC=",nVVC);
  for(i=0; i < EGNp; i++){
    fwrite(gYpS[i],id,(size_t)nVVC,lF);
  }
  fclose(lF);
  lF=fopen("gYCC","w");
  for(i=1; i < nPFC; i++){
    fwrite(gYCC[i]+i,id,(size_t)(nPFC-i),lF);
  }
  fclose(lF);

  lF=fopen("gYiC","w");
  for(i=0; i < nMFP; i++){
    fwrite(gYiC[i]+1,id,(size_t)n,lF);
  }
  fclose(lF);
#endif
  return(0);
}

int FreeBoundaryEq()
{
  extern double ESTime;
  static int Fl=12,FlE=-1;
#ifdef H
  static int Fl=32,FlE=-1;
#endif
  static int fl=1;

  int i,j,k,n,m;
  static double wL=1.,wB=1.,wI=1.,wV=1.,wF=1.,wP=1.;
  static int kP[12]={0,0,0,0,0,0,0,0,0,0,0,0};
  static double rP[12]={0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.};
  static double zP[12]={0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.};

  int kc[nPEC];
  double R[nPEC],Z[nPEC],I0[nPEC],Ib[nPEC],It[nPEC];
  int Np,iD[nPEC];

  double Rp[512],Zp[512];
  double W,WI,WV,WL,WB;

  PFBLOCK *lB;
  PSBLOCK *lS;
  PFCOIL *lC;
  char *NmC[nPEC],*NmB[nPEC];
  char str[64];

  int nCP=0;
  double rCP[12],zCP[12];
  
  if(0){
    FILE *lf;
    lf	=fopen("CDX.MFp-C","w");
    fprintf(lf,"Green functions Flux Loops-Coils, [Vsec/MA]\n");
    fputs(" #",lf);
    for(j=1; j < nPFC; j++) fprintf(lf," %10s",PFC[j].Nm);
    fputc('\n',lf);
    for(i=0; i < nMFL; i++){
      fprintf(lf,"%2d",i+1);
      for(j=1; j < nPFC; j++) fprintf(lf,"%11.4e",gYiC[i][j]);
      fputc('\n',lf);
    }
    fputc('\n',lf);
    fprintf(lf,"Green functions Magnetic Probes-Coils, [T/MA]\n");
    fputs(" #",lf);
    for(j=1; j < nPFC; j++){
      fprintf(lf," %10s",PFC[j].Nm);
    }
    fputc('\n',lf);
    for(i=0; i < nMFp; i++){
      fprintf(lf,"%2d",i+1);
      for(j=1; j < nPFC; j++){
	fprintf(lf,"%11.4e",gYiC[i+nMFLS][j]);
      }
      fputc('\n',lf);
    }
    fclose(lf);
  }

  if((ESFlHole&0x10)){
    PFFirstSetSpl();
    ESFlHole	&=~0x10;
  }

  if(fl == 1){
    ESInpPlPr4PF();
    ESInpPlCr4PF();
    PFSetJsJp();
    fl=0;
  }

#ifdef H
  PFInitOptimization();
#endif
  FlagPoints	=1;
  k	=0;
  for(i=0; i < 12; i++){
    if(kP[i] != CNTP[i].kA || rP[i] != CNTP[i].R || zP[i] != CNTP[i].Z){
      kP[i]	=CNTP[i].kA;
      rP[i]	=CNTP[i].R;
      zP[i]	=CNTP[i].Z;
      k	=1;
    }
  }
  if(k || FlE != Fl/10){
    FlE	=Fl/10;
    switch(FlE){
    case 0:
      SetLijCntP();
      PFCInvEqMatr0();
      break;
    case 1:
      SetLijCntP();
      PFCInvEqMatr0();
#ifdef H
      PFCInvEqMatr1(wL,wB,wI,wV);
#endif
      break;
    default:
      PFSetCoilOptIndex();
      SetLijCntP();
      break;
    }
  }
  for(i=0; i < 12; i++) kP[i]=CNTP[i].kA;
  for(i=0; i < nPFC; i++){
    k		=PFC[i].kB[0];
    NmB[i]	=PFB[k].Nm;
    Ib[i]	=PFC[i].I0*PFB[k].tn;
    kc[i]	=PFC[i].kA;
    iD[i]	=0;
    NmC[i]	=PFC[i].Nm;
  } 

  for(j=0; j < nVVC; j++,i++){
    lC		=VVC+j;
    k		=lC->kB[0];
    NmB[i]	=lC->Nm;
    Ib[i]	=lC->I;
    kc[i]	=lC->kA;
    iD[i]	=0;
    NmC[i]	=lC->Nm;
  }

  EGaR0	=PFB[0].R;
  EGaZ0	=PFB[0].Z;

  m	=0;
#ifndef Tbl_Ieq
  if(fl == 1){
    ESInpPlPr4PF();
    ESInpPlCr4PF();
    PFSetJsJp();
    fl=0;
  }
  if(fl == 2){
    PFInitJsJp();
    fl=0;
  }

  if(nKj > NKj) nKj=NKj;
  if(nKj < 0) nKj=0;
  if(nKp > NKp) nKp=NKp;
  if(nKp < 0) nKp=0;
  PFCnK	=nKj+nKp;
  if((k=PFIsConsistent(kP,kc,Fl/10))){
    for(i=0; i < nPFC; i++){
      lC	=PFC+i;
      if(lC->kA == 1) lC->I=Ib[i]/PFB[lC->kB[0]].tn;
    }
    for(j=0; j < nVVC; j++,i++){
      lC	=VVC+j;
      if(lC->kA == 1) lC->I=Ib[i];
    }
    j	=0;
    for(i=0; i < 12; i++){
      if((k&0x02) || rP[i] != CNTP[i].R || zP[i] != CNTP[i].Z){
	CNTP[i].R	=rP[i];
	CNTP[i].Z	=zP[i];
	j	=1;
      }
    }
    i	=0;
    if(j) SetLijCntP();
    if((k&0x04) || j || FlE != Fl/10){
      FlE	=Fl/10;
      switch(FlE){
      case 0:
	PFCInvEqMatr0();
	break;
      case 1:
	PFCInvEqMatr0();
#ifdef H
	PFCInvEqMatr1(wL,wB,wI,wV);
#endif
	break;
      default:
	break;
      }
    }
    switch((Fl%10)){
    case 0:
      break;
    case 1:
      PFCOneCellCurrent();
      Fl	=FlE*10;
      break;
    case 2:
      ESSetMapBox();
      PFCFlxEq2PlPFB();
      Fl	=FlE*10;
      break;
    case 3:
      FlagPoints	=1;
      Fl	=FlE*10;
      break;
    case 4:
      FlagPoints	=0;
      Fl	=FlE*10;
      break;
    case 5:
      /* Make .ps file */
      break;
    case 6:
      for(i=0; i < nPFC; i++){
	lC	=PFC+i;
	if(lC->kA == 1) lC->I=lC->I0;
      }
      for(j=0; j < nVVC; j++,i++){
	lC	=VVC+j;
	if(lC->kA == 1) lC->I=lC->I0;
      }
      Fl	=FlE*10;
      break;
    case 7:
      PFGenerateSignals();
      Fl	=FlE*10;
      break;
    case 8:
      FlBlockIter	=1;
      PFSetJsJp();
      break;
    case 9:
      FlBlockIter	=0;
      Fl	=FlE*10;
      break;
    default:
      break;
    }

    FlE	=Fl/10;
    FlagE	=FlE;
    switch(FlE){
    case 0:
      PFCSolvMatrEq0();
      break;
    case 1:
#ifdef H
      PFCInvEqMatr1(wL,wB,wI,wV);
      PFCOptEqRHSC(wL,wB,wI,wV);
      PFCSolvMatrEq1(wL,wB,wI,wV);
#endif
      PFCSolvMatrEq0();
      break;
    case 2:
      PFCSolvMatrEq2(wL,wB,wI,wV,wF);
      break;
    case 3:
      PFCSolvSVD(wL,wB,wI,wV,wF,wP);
      break;
    case 4:
      /* Initiate optimization */
      break;
    case 5:
      PFCSolvMatrEq5(wL,wB,wI,wV,wF);
      break;
    case 6:
      PFReSetJsJp();
      PFCSolvSVD(wL,wB,wI,wV,wF,wP);
      break;
    case 7:
      PFReSetJsJp();
      PFCSolvMatrEq5(wL,wB,wI,wV,wF);
      break;
    default:
      break;
    }
    PFSetPFBCurrents();
    PFBoundary2ESC();
    PFDiscrepancy(wL,wB,wI,wV,wF);
    CbUserPlot	=MFLinePlot;
  }
  else{
    extern void IbPFIPlot();
    CbUserPlot	=IbPFIPlot;
  }
  for(i=0; i < nPFC; i++){
    lC	=PFC+i;
    n		=lC->nB;
    for(j=0; j < n; j++){
      k		=lC->kB[j];
      lB	=PFB+k;
      lB->I	=lC->I;
      lB->AI	=lC->I*lB->tn;
      if(j == 0){
	Ib[i]	=lB->AI;
	R[i]	=lB->R;
	Z[i]	=lB->Z;
      }
    }
    I0[i]	=lC->I0;
    It[i]	=lC->I;
  }

  for(j=0; j < nVVC; j++,i++){
    lC		=VVC+j;
    lS		=VVB+lC->kB[0];
    R[i]	=cr4*(lS->r[0]+lS->r[1]+lS->r[2]+lS->r[3]);
    Z[i]	=cr4*(lS->z[0]+lS->z[1]+lS->z[2]+lS->z[3]);
    I0[i]	=lC->I0;
    It[i]	=lC->I;
    Ib[i]	=lC->I;
  }

  if(1 || ESTime != 0.){
    sprintf(str,"%s t=%5.3f",ShotNm,ESTime);
  } 
  else{
    sprintf(str,"%s.%s",ShotNm,kFileExt);
  }
  if(m == 4) m++;
  PFExpDataPlot(m,str);
  m	=0;
  PFGetW(&W,&WI,&WV,&WL,&WB);
  CbStr2UserMessage("W1=%9.3e\nwL=%9.3e\nwB=%9.3e\nwI=%9.3e\nwV=%9.3e\n"
		    "W =%9.3e\nEr=%9.3e",WI+WL+WB,WL,WB,WI,WV,W,err);

#ifdef H
  PFPlasmaJPlot();
#endif
  R[0]	=EGaR0;
  Z[0]	=EGaZ0;

  Np	=0;
  for(i=0; i < EGNp & Np < 512; i++){
    if(EGkAp[i]){
      Rp[Np]	=EGaRp[i];
      Zp[Np]	=EGaZp[i];
      Np++;
    }
  }
  nCP	=0;
  for(i=0; i < 12; i++){
    if(CNTP[i].kA){
      rCP[nCP]	=CNTP[i].R;
      zCP[nCP]	=CNTP[i].Z;
      nCP++;
    }
  }
  ESIpl	=PFC[0].I;
  SetPlotLimits(1);
#endif/*Tbl_Ieq*/
  CbUserMessage=NULL;
  return(0);
}

int PFIsConsist(int Fl)
{
  int i,j,nB,nX,nY,nQ,nF,nO;

  nB	=0;
  nY	=0;
  nX	=0;
  for(i=0; i < 12; i++){
    switch(CNTP[i].kA){
    case 1:
      nB++;
      break;
    case 2:
      nY++;
      break;
    case 3:
      nX++;
      break;
    case 4:
      nX++;
      nB++;
      break;
    }
  }
  nQ	=nY+nB+2*nX;
  if(nB) nQ--;
  nF	=0;
  nO	=0;
  j	=nPFC+nVVC;

  for(i=0; i < nPFC; i++){
    if(PFC[i].kA == 2) nF++;
    if(PFC[i].kA == 3) nO++;
  }
  for(i=0; i < nVVC; i++){
    if(VVC[i].kA == 2) nF++;
    if(VVC[i].kA == 3) nO++;
  }

  *ln='\0';
  switch(Fl){
  case 0:
    if(nO || nF != nQ){
      CbStr2UserWarning("%d != %d -number of conditions\n!= "
	"number of feedback coils\n",nQ,nF);
    *ln='0';
      out("sIsIsIsI","nB=",nB,"nY=",nY,"nX=",nX,"nB=",nB);
      out("sIsIsI","nF=",nF,"nO=",nO,"nF+nO=",nF+nO);
    }
    break;
  case 1:
  case 2:
    if(nO+nF < nQ){
      CbStr2UserWarning("%d < %d -Too\nfew feedback coils\n",nF+nO,nQ);
      *ln='1';
      break;
    }
    if(nQ < nF){
      *ln='2';
      CbStr2UserWarning("%d < %d -Excessive\nfeedback coils\n",nF+nO,nQ);
    }
    break;
  case 3:
    break;
  case 4:
    for(i=0; i < nPFC; i++){
      if(PFC[i].kA == 2){
	PFC[i].kA	=3;
	nO++;
	nF--;
      }
      if(i && (PFC[i].kA == 1 || PFC[i].kA == 4) && strncmp(PFC[i].Nm,"OH",2)){
	PFC[i].kA	=3;
	nO++;
      }
    }
    for(j=0; j < nVVC; j++,i++){
      if(VVC[i].kA == 2){
	VVC[i].kA	=3;
	nO++;
	nF--;
      }
      if(VVC[i].kA == 1 || VVC[i].kA == 4){
	VVC[i].kA	=3;
	nO++;
      }
    }
    break;
  default :
    break;
  }
  if(*ln){
    *ln=0;
    return(0);
  }
  PFCnQ	=nQ;
  PFCnY	=nY;
  PFCnB	=nB;
  PFCnX	=nX;
  PFCnF	=nF;
  PFCnO	=nO;
  nCntP	=PFCnY+PFCnB+PFCnX;
  nB	=1;
  return(nB);
}

int SetCntrPoints()
{
  static double R[12]={0.,0.,0.,0.,0.,0.,0.,0.}
  ,Z[12]={0.,0.,0.,0.,0.,0.,0.,0.};
  static int kA[12]={0,0,0,0,0,0,0,0,0,0,0,0};
  int i;

  for(i=0; i < 12; i++){
    if(kA[i] != CNTP[i].kA || R[i] != CNTP[i].R || Z[i] != CNTP[i].Z){
      R[i]	=CNTP[i].R;
      Z[i]	=CNTP[i].Z;
      kA[i]	=CNTP[i].kA;
      SetLijCntP();
      i=12;
    }
  }
  nRx	=0;
  for(i=0; i < 12; i++){
    if(CNTP[i].kA == 4){
      EGvRx[nRx]	=CNTP[i].R;
      EGvZx[nRx]	=CNTP[i].Z;
      nRx++;
    }
  }
  ERnRx=nRx;
  return(0);
}

int InitPFCoils(int cFl,double *Ib)
{
  int i;

  PFC[0].I	=PFC[0].I0;
  switch(cFl){
  case 1:
    for(i=1; i < nPFC; i++){
      if(PFC[i].kA != 2){
	if(PFC[i].kA != 4) PFC[i].kA =1;
	PFC[i].I	=PFC[i].I0;
	Ib[i]		=PFC[i].I*PFB[PFC[i].kB[0]].tn;
      }
    }
    break;
  case 2:
    for(i=1; i < nPFC; i++) PFC[i].kA=3;
    if(iOH < nPFC){
      PFC[iOH].kA=1;
      PFC[iOH].I=PFC[iOH].I0;
      Ib[iOH]	=PFC[i].I*PFB[PFC[i].kB[0]].tn;
    }
    break;
  case 3:
    for(i=1; i < nPFC; i++) PFC[i].kA =3;
    break;
  case 4:
    for(i=0; i < nPFC; i++){
      if(PFC[i].kA == 4){
	PFC[i].I0=Ib[i]/PFB[PFC[i].kB[0]].tn;
	PFC[i].I	=PFC[i].I0;
      }
    }
    break;
  case 5:
    for(i=0; i < nPFC; i++){
      PFC[i].I	=Ib[i]/PFB[PFC[i].kB[0]].tn;
      PFC[i].I0	=PFC[i].I;
    }
    break;
  default:
    for(i=0; i < nPFC; i++)
      if(PFC[i].kA == 1 || PFC[i].kA == 4)PFC[i].I=Ib[i]/PFB[PFC[i].kB[0]].tn;
    break;
  }
  return(0);
}

int InitVVCoils(int vFl,double *Ib)
{
  int i;

  switch(vFl){
  case 1:
    for(i=0; i < nVVC; i++){
      if(VVC[i].kA != 2){
	if(VVC[i].kA != 4) VVC[i].kA =1;
	VVC[i].I	=VVC[i].I0;
	Ib[i]		=VVC[i].I;
      }
    }
    break;
  case 2:
    for(i=0; i < nVVC; i++) VVC[i].kA=0;
    break;
  case 3:
    for(i=1; i < nVVC; i++) VVC[i].kA =3;
    break;
  case 4:
    for(i=0; i < nVVC; i++){
      if(VVC[i].kA == 4){
	VVC[i].I	=Ib[i];
	VVC[i].I0	=VVC[i].I;
      }
    }
    break;
  case 5:
    for(i=0; i < nVVC; i++){
      VVC[i].I	=Ib[i];
      VVC[i].I0	=VVC[i].I;
    }
    break;
  default:
    for(i=0; i < nVVC; i++)
      if(VVC[i].kA == 1 || VVC[i].kA == 4) VVC[i].I=Ib[i];
    break;
  }
  return(0);
}

int InitPlCoil(int jFl)
{
  int i,j;

  switch(jFl){
  case 1:
    PFCOneCellCurrent();
    break;
  case 2:
    PFCFlxEq2PlPFB();
    EcNjet	=ESNp1;
    for(i=0,j=ESNp1*ESNa; i < ESNp1; i++,j++){
      EcRjet[i]	=ESsr[j];
      EcZjet[i]	=ESsz[j];
    }
    FlagPoints	=1;
    break;
  case 3:
    FlagPoints	=1;
    break;
  case 4:
    FlagPoints	=0;
    break;
  case 5:
    break;
  case 6:
    break;
  case 7:
    PFSetJsJp();
   break;
  default:
    break;
  }
  return(0);
}

int InitFeedBack(int iFl)
{
  int i=0;
  double rD[12],zD[12];
  int iA[12];

  switch(iFl){
  case 1:
     ES2PFCCntrPoints(rD,zD,iA);
    for(i=0; i < 12; i++){
      CNTP[i].R	=rD[i];
      CNTP[i].Z	=zD[i];
      CNTP[i].kA=iA[i];
    }
    i	=0;
    break;
  case 2:
    for(i=0; i < 12; i++) CNTP[i].kA=0;
    CNTP[2].kA=1;
    i	=1;
    break;
  case 3:
    for(i=0; i < 12; i++) CNTP[i].kA=0;
    return(1);
  case 4:
    for(i=0; i < 12; i++){
      rD[i]	=CNTP[i].R;
      zD[i]	=CNTP[i].Z;
      iA[i]	=CNTP[i].kA;
    }
    PFC2ESCntrPoints(rD,zD,iA);
    break;
  default:
    break;
  }
  return(i);
}

int SetIntParam2EREI()
{
  int i,k;

  PFCnB	=0;
  PFCnY	=0;
  PFCnX	=0;
  for(i=0; i < 12; i++){
    switch(CNTP[i].kA){
    case 1:
      PFCnB++;
      break;
    case 2:
      PFCnY++;
      break;
    case 3:
      PFCnX++;
      break;
    case 4:
      PFCnX++;
      PFCnB++;
      break;
    }
  }
  PFCnQ	=PFCnY+PFCnB+2*PFCnX;
  if(PFCnB) PFCnQ--;
  PFCnF	=0;
  PFCnO	=0;
  for(i=0; i < nPFC; i++){
    k	=PFC[i].kA;
    if(k == 2) PFCnF++;
    if(k == 3) PFCnO++;
  }
  for(i=0; i < nVVC; i++){
    k	=VVC[i].kA;
    if(k == 2) PFCnF++;
    if(k == 3) PFCnO++;
  }

  nCntP	=PFCnY+PFCnB+PFCnX;
  return(1);
}

int IsFeedBackConsistent(int cFl)
{
  int k;

#ifdef H
  int i,j,k,nB,nX,nY,nQ,nF,nO;

  nB	=0;
  nY	=0;
  nX	=0;
  for(i=0; i < 12; i++){
    switch(CNTP[i].kA){
    case 1:
      nB++;
      break;
    case 2:
      nY++;
      break;
    case 3:
      nX++;
      break;
    case 4:
      nX++;
      nB++;
      break;
    }
  }
  nQ	=nY+nB+2*nX;
  if(nB) nQ--;
  nF	=0;
  nO	=0;
  for(i=0; i < nPFC; i++){
    k	=PFC[i].kA;
    if(k == 2) nF++;
    if(k == 3) nO++;
  }
  for(i=0; i < nVVC; i++){
    k	=VVC[i].kA;
    if(k == 2) nF++;
    if(k == 3) nO++;
  }
#endif
  k	=0;
  switch(cFl){
  case 0:
  case 1:
    if(PFCnO){
      CbStr2UserMessage("nO = %d != 0 in FeedBack initialization\n",PFCnO);
      k	=1;
    }
    if(PFCnF != PFCnQ){
      CbStr2UserMessage("# of conditions %d != %d # of FeedBack coils\n"
			,PFCnQ,PFCnF);
      k	=1;
    }
    break;
  case 2:
    if(PFCnF != PFCnQ){
      CbStr2UserMessage("# of conditions %d != %d # of FeedBack coils\n"
			,PFCnQ,PFCnF);
      k	=1;
    }
#ifdef H
    if(PFCnF+PFCnO < PFCnQ){
      CbStr2UserMessage("# of conditions %d > %d+%d # of FeedBack+Opt coils\n"
			,PFCnQ,PFCnF,PFCnO);
      k	=1;
    }
#endif
    break;
  }
  if(k){
    out("sIsIsIsI","nB=",PFCnB,"nY=",PFCnY,"nX=",PFCnX,"nB=",PFCnB);
    out("sIsIsI","nF=",PFCnF,"nQ=",PFCnQ,"nO=",PFCnO);
    return(0);
  }
#ifdef H
  PFCnQ	=nQ;
  PFCnY	=nY;
  PFCnB	=nB;
  PFCnX	=nX;
  PFCnF	=nF;
  PFCnO	=nO;
  nCntP	=PFCnY+PFCnB+PFCnX;
#endif
  return(1);
}

static char GrName[16][32]={
  "<ESI dimensions>",
  "<ESI O- B-points>",
  "<ESI X-points>",

  "<ESI [sa] gY gYa>",
  "<ESI r grid>",
  "<ESI z grid>",

  "<ESI [baF bsp gF gY]>",
  "<ESI T Ta P Pa>",
  "<ESI bgFa bgFaa bgYa bgYaa>",

  "<ESI gY gYr gYz gYrz>",
  "<ESI B Ba Bq Baq>",
  "<ESI rgz ragz rqgz>",    	/* only for 3D */
  "<ESI zgz zagz zqgz>",    	/* only for 3D */
  "<ESI Bgz Bagz Bqgz>",    	/* only for 3D */
  "<ESI ghgz ghagz ghqgz>", 	/* only for 3D */
  ""
};

static char GrFormat[16][0x40]={
  "%d x %d %d %e %e %s",  /*"%d x %d %d %e %e %e %e %e %e %d %s"*/
  "%e %e %e",
  "%e %e %e",
  "%e %e %e",
  "%e",
  "%e",
  "%e %e %e %e",
  "%e %e %e %e",
  "%e %e %e %e",
  "%e %e %e %e",
  "%e %e %e %e",
  "%e %e %e %e",
  "%e %e %e %e",
  "%e %e %e %e",
  "%e %e %e %e",
  "%e %e %e %e"
};

static char GrComment[16][4][0x10]={
  "Nr1","Nz1","ID","Rext",
  "R [m]","Z [m]","gY [Vsec]","",
  "R [m]","Z [m]","gY [Vsec]","",
  "a","gY [Vsec]","gY'_a","",
  "r [m]","","","",
  "z [m]","","","",
  "baF [T m]","p [MPA]","gF [Vsec]","gY'_a [Vsec]",
  "T","T'_a","P","P'_a",
  "bgF'/a","(bgF'/a)'","bgY'/a","(bgY'/a)'",
  "gY [Vsec]","gY'_r'","gY'_z","gY''_{r,z}",
  "gH=gh'_gq","gH'_a","gH'_gq","gH''_{a,gq}",
  "r'_gz","r''_{a,gz}","r''_{gq,gz}","r'''_{a,gq,gz}",
  "z'_gz","z''_{a,gz}","z''_{gq,gz}","z'''_{a,gq,gz}",
  "|B|'_gz","|B|''_{a,gz}","|B|''_{gq,gz}","|B|'''_{a,gq,gz}",
  "gH'_gz","gH''_{a,gz}","gH''_{gq,gz}","gH'''_{a,gq,gz}",
  "","","",""
};

#ifdef H
c-----------------------------------------------------------
c     Read the EQDSK file
c-----------------------------------------------------------
      write(*,*)'eqdskin= ',eqdskin

      open(30,file=eqdskin)

cBH020822  Adding nveqd (.le. nxeqd) for different number of
cBH020822  flux surfaces on which p,feqd,p',feqd',q are tabulated.
cBH020822  The standard EQDSK does not incorporate this feature,
cBH020822  although is is available in cql3d.
cBH020822  Bonoli uses it for ACCOME eqdsk output.

c      read(30,2) nxeqd,nyeqd
      nveqd=0
      write(*,*)'equilib.f before read (30,2)'

      read(30,2) nxeqd,nyeqd,nveqd

      write(*,*)'nxeqd,nyeqd,nveqd',nxeqd,nyeqd,nveqd
2     format(52x,3i4)

      if (nveqd.gt.nxeqd) stop 'nveqd.gt.nxeqd NOT ENABLED'
      if (nveqd.eq.0) nveqd=nxeqd

      call check_param(1)
c      if ((nxeqd.gt.nxeqda).or.(nyeqd.gt.nyeqda)) then
c        write(*,1000) nxeqd,nxeqda,nyeqd,nyeqda
c 1000   format('in equilib.dat in input',/,
c     .  'the dimensions of eqdsk (in eqilib.dat) nxeqd or nyeqd',/,
c     .  'are bigger than the parameters nxeqda or nyeqda in param.i'
c     .  ,/'nxeqd=',I5,'nxeqda=',I5
c     .  ,/'nyeqd=',I5,'nyeqda=',I5
c     .  ,/'Please change nxeqda or nyeqda in param.i')
c        stop
c      endif

      read(30,3) xdimeqd,ydimeqd,reqd,redeqd,ymideqd
      write(*,*)'xdimeqd,ydimeqd,reqd,redeqd,ymideqd'
      write(*,*)xdimeqd,ydimeqd,reqd,redeqd,ymideqd
3     format(5e16.9)

      read(30,3) xma,yma,psimag,psilim,beqd
      write(*,*)'xma,yma,psimag,psilim,beqd'
      write(*,*)xma,yma,psimag,psilim,beqd
      if(psimag.gt.psilim) then
        dpsimax=-1
      else
        dpsimax=1
      endif
      psimag=dpsimax*psimag
      psilim=dpsimax*psilim
      write(*,*)'in equilib psimag,psilim',psimag,psilim
      read(30,3) toteqd,psimx1,psimx2,xax1,xax2
      read(30,3) zax1,zax2,psisep,xsep,ysep
      read(30,3) (feqd(i),i=1,nveqd)
c********************************************
c      do i=1,nveqd
c        feqd(i)=beqd*xma
c         feqd(i)=feqd(i)*2.1d0/1.13d0
c      end do
c********************************************
      read(30,3) (pres(i),i=1,nveqd)
      read(30,3) (ffpeqd(i),i=1,nveqd)
      read(30,3) (ppeqd(i),i=1,nveqd)
      read(30,3) ((peqd(i,j),i=1,nxeqd),j=1,nyeqd)
c      write(*,3)((peqd(i,j),i=1,nxeqd),j=1,nyeqd)
c------------------------------------------------------------
c     creation of the poloidal flux peqd(i,j) with the minimum value
c     on the magnetic axis (psimag<psilim)
      do i=1,nxeqd
        do j=1,nyeqd
	   peqd(i,j)=dpsimax*peqd(i,j)
	enddo
      enddo
cc      write(*,*)'in equilib after change of the peqd sign'
c------------------------------------------------------------
      read(30,3) (qpsi(i),i=1,nveqd)
      write(*,*)'in equilib after qpsi'
c      read(30,4) nnlim,nnves
cc      write(*,*)'in equilib after nnlim,nnves',nnlim,nnves
 4    format(2i5)
c-----------------------------
c test
      nnlim=0
c-----------------------------
      if (nnlim.ne.0) then
c        these values must coincide with the parameters
c        nlimit= nnlim,nves=nnves in common five and fourb.cb
         read(30,3) (rlimit(i),zlimit(i),i=1,nnlim)
         read(30,3) (rves(i),zves(i),i=1,nnves)
         if(nlimit.ne.nnlim) then
           write(*,*)'nlimit=',nlimit,'is not equal to nnlim=',nnlim
           write(*,*)' see  common five and fourb.cb'
	   stop
         endif
      else
c        ------------------------------------
c        The eqdsk data without limiter points.
c        ------------------------------------
         write(*,*)'nnlim=0 eqdsk data without limiter points'
	 psisep=psilim
         write(*,*)'psisep,psilim',psisep,psilim
      endif
      close(30)
      write(*,*)' nxeqd,nyeqd,nveqd'
      write(*,2) nxeqd,nyeqd,nveqd
cc      write(*,*)'xdimeqd,ydimeqd,reqd,redeqd,ymideqd'
cc      write(*,3) xdimeqd,ydimeqd,reqd,redeqd,ymideqd
cc      write(*,*)'xma,yma,psimag,psilim,beqd'
cc      write(*,3) xma,yma,psimag,psilim,beqd
cc      write(*,*)'in equilib psimag,psilim',psimag,psilim
cc      write(*,*)'toteqd,psimx1,psixm2,xax1,xax2'
cc      write(*,3) toteqd,psimx1,psixm2,xax1,xax2
cc      write(*,*)'zax1,zax2,psisep,xsep,ysep'
cc      write(*,3) zax1,zax2,psisep,xsep,ysep
      write(*,*) 'feqd(i),i=1,nveqd'
      write(*,3) (feqd(i),i=1,nveqd)
      write(*,*) 'pres(i),i=1,nveqd'
      write(*,3) (pres(i),i=1,nveqd)
      write(*,*) 'ffpeqd(i),i=1,nveqd'
      write(*,3) (ffpeqd(i),i=1,nveqd)
      write(*,*) 'ppeqd(i),i=1,nveqd'
      write(*,3) (ppeqd(i),i=1,nveqd)

c      do i=1,nxeqd
c         do j=1,nyeqd
c            write(*,*)'i,j,peqd(i,j)',i,j,peqd(i,j)
c         enddo
c      enddo

c      write(*,*) '(peqd(i,j),i=1,nxeqd),j=1,nyeqd)'
cc      write(*,3) ((peqd(i,j),i=1,nxeqd),j=1,nyeqd)
      write(*,*) 'qpsi(i),i=1,nveqd'
      write(*,3) (qpsi(i),i=1,nveqd)
      write(*,*)'nnlim,nnves'
      write(*,4) nnlim,nnves
cc      write(*,*) 'rlimit(i),zlimit(i),i=1,nnlim'
cc      write(*,3) (rlimit(i),zlimit(i),i=1,nnlim)
cc      write(*,*) 'rves(i),zves(i),i=1,nnves'
cc      write(*,3) (rves(i),zves(i),i=1,nnves)




c-----------------------------------------------------------
c-----------------------------------------------------------

      if (nveqd.ne.nxeqd) then

c-----------------------------------------------------------
c     Interpolate feqd,pres,ffpeqd,ppeqd,qpsi to 
c     nxeqd equispaced points.
c     The nveqd option has been enabled in CQL3D, and we
c     enable it also for GENRAY.  It is not a part of the
c     standard EQDSK  (BobH, 020722).
c
c     We use the standard, well documented spline package,
c     in zcunix.f, rather than use the uncommented subroutines
c     used in the majority of GENRAY cases (BobH, 020722).
c-----------------------------------------------------------

cAdding new arrays: psiar,d2feqd,d2pres,d2ffpeqd,d2ppeqd,d2qpsi,
c                   workk,r8temp,tabl,i1p,itabl
c     Create cubic spline arrays
c
         dpsiar=(psilim-psimag)/(nveqd-1)
         do i=1,nveqd
            psiar(i)=psimag+(i-1)*dpsiar
         enddo
         write(*,*) 'psiar(i),i=1,nveqd'
         write(*,3) (psiar(i),i=1,nveqd)
c     Use cubic splines at end points to obtain coefficients:
         i1p(1)=4
         i1p(2)=4
         call coeff1(nveqd,psiar,feqd,d2feqd,i1p,1,workk)
         call coeff1(nveqd,psiar,pres,d2pres,i1p,1,workk)
         call coeff1(nveqd,psiar,ffpeqd,d2ffpeqd,i1p,1,workk)
         call coeff1(nveqd,psiar,ppeqd,d2ppeqd,i1p,1,workk)
         call coeff1(nveqd,psiar,qpsi,d2qpsi,i1p,1,workk)
         
c     Create nxeqd long array and spline onto it.
         dflux=(psilim-psimag)/(nxeqd-1)
         do i=1,nxeqd
            flux(i)=psimag+(i-1)*dflux
         enddo
         
         itabl(1)=1
         itabl(2)=0
         itabl(3)=0
         do i=1,nxeqd
            call terp1(nveqd,psiar,feqd,d2feqd,flux(i),1,tabl,itabl)
            r8temp(i)=tabl(1)
         enddo
         do i=1,nxeqd
            feqd(i)=r8temp(i)
         enddo
         
         do i=1,nxeqd
            call terp1(nveqd,psiar,pres,d2pres,flux(i),1,tabl,itabl)
            r8temp(i)=tabl(1)
         enddo
         do i=1,nxeqd
            pres(i)=r8temp(i)
         enddo
         
         do i=1,nxeqd
            call terp1(nveqd,psiar,ffpeqd,d2ffpeqd,flux(i),1,tabl,itabl)
            r8temp(i)=tabl(1)
         enddo
         do i=1,nxeqd
            ffpeqd(i)=r8temp(i)
         enddo
         
         do i=1,nxeqd
            call terp1(nveqd,psiar,ppeqd,d2ppeqd,flux(i),1,tabl,itabl)
            r8temp(i)=tabl(1)
         enddo
         do i=1,nxeqd
            ppeqd(i)=r8temp(i)
         enddo
         
         do i=1,nxeqd
            call terp1(nveqd,psiar,qpsi,d2qpsi,flux(i),1,tabl,itabl)
            r8temp(i)=tabl(1)
         enddo
         do i=1,nxeqd
            qpsi(i)=r8temp(i)
         enddo
         
         write(*,*) 'flux(i),i=1,nxeqd'
         write(*,3) (flux(i),i=1,nxeqd)
         write(*,*) 'feqd(i),i=1,nxeqd'
         write(*,3) (feqd(i),i=1,nxeqd)
         write(*,*) 'pres(i),i=1,nxeqd'
         write(*,3) (pres(i),i=1,nxeqd)
         write(*,*) 'ffpeqd(i),i=1,nxeqd'
         write(*,3) (ffpeqd(i),i=1,nxeqd)
         write(*,*) 'ppeqd(i),i=1,nxeqd'
         write(*,3) (ppeqd(i),i=1,nxeqd)
         write(*,*) 'qpsi(i),i=1,nxeqd'
         write(*,3) (qpsi(i),i=1,nxeqd)

         
c-----------------------------------------------------------
c-----------------------------------------------------------
         
      endif
      

c---------------------------------------------------------
c  normalization of the eqdsk data
c--------------------------------------------------------
      pr=1.d0/r0x
      pb=1.d0/b0
      xdimeqd=xdimeqd*pr
      ydimeqd=ydimeqd*pr
      reqd=reqd*pr
      redeqd=redeqd*pr
      ymideqd=ymideqd*pr
      xma=xma*pr
      yma=yma*pr
      psimag=psimag*pr*pr*pb
      psilim=psilim*pr*pr*pb
      write(*,*)'equilib psimag,psilim,pr,pb',psimag,psilim,pr,pb

      beqd=beqd*pb
      psimx1=psimx1*pr*pr*pb
      psimx2=psimx2*pr*pr*pb
      xax1=xax1*pb
      xax2=xax2*pb
      zax1=zax1*pr
      zax2=zax2*pr
      psisep=psisep*pr*pr*pb
      xsep=xsep*pr
      ysep=ysep*pr
      write(*,*)'in equilib psimag,psilim',psimag,psilim
      write(*,*)'nveqd,nxeqda',nveqd,nxeqda
      do 30 i=1,nveqd 
        feqd(i)=feqd(i)*pr*pb
	pres(i)=pres(i)*pr*pr*pb
 30   continue

      do 31 i=1,nxeqd
        do 32 j=1, nyeqd
 32       peqd(i,j)=peqd(i,j)*pr*pr*pb
 31   continue
      if (nnlim.gt.0) then
        do 33 i=1,nnlim
          rlimit(i)=rlimit(i)*pr
 33	  zlimit(i)=zlimit(i)*pr
      endif
c------------------------------------------------------------------
cBH020822      dpsi=(psilim-psimag)/(nxmax-1)
      dpsi=(psilim-psimag)/(nxeqd-1)
      do 15 i=1,nxeqd
        flux(i)=psimag+dpsi*(i-1)
15     continue

      dstep=xdimeqd/(nxeqd-1)
      do 100 i=1,nxeqd
        rr(i)=redeqd+dstep*(i-1)
 100  continue
      dstep=ydimeqd/(nyeqd-1)
      do 200 i=1,nyeqd
        zz(i)=ymideqd+dstep*(i-1)-ydimeqd*0.5d0
 200  continue

c-------------------------------------------------------------
c     test map psi(i,j) on (R,Z) plane
c------------------------------------
c      open(40,file='psirz.dat')
c41     format(3(' ',e16.9))
c      write(40,*)' r z psi'         
c      do i=1,nxeqd
c         do j=1,nyeqd
c         write(40,41)rr(i),zz(j) ,peqd(i,j)
c         enddo
c      enddo
c      close(40)
c      stop
c     end test map
c---------------------------------------------------

      return
      end
#endif

int EqRcnstrAOE()
{
  static int Fic=0;
  int iG,ID;
  int i,j,ji,nr,nz,nr1,nz1;
  double f[ESNp1],fa[ESNp1],fq[ESNp1],faq[ESNp1],rr0;
  FILE *lF;
  char FNm[16];
  char Date[32];
  int kD;
  double R1,R2,Z1,Z2,t,s;
  double gYr2[NplG[1]][NplG[0]],gY[NplG[0]][NplG[1]]
    ,gYz2[NplG[0]][NplG[1]]
    ,Yr2[NplG[0]][NplG[1]],Yr22[NplG[0]][NplG[1]]
    ,Yr1[NplG[0]][NplG[1]],Yr12[NplG[0]][NplG[1]];
  double x[NplG[0]],y[NplG[1]];
  double dYr,dYz,dYrz,rhr,rhz,hr6,hz6;
  double *lgYr2,*lgYz2,*lgY;

  
  kD	=sizeof(double);
  ID	=64;
  nr1	=PFB[0].nr;
  nz1	=PFB[0].nz;
  nr	=nr1-1;
  nz	=nz1-1;
  R1	=PFB[0].r[0]+0.5*EGdr;
  Z1	=PFB[0].z[0]+0.5*EGdz;
  R2	=PFB[0].r[1]-0.5*EGdr;
  Z2	=PFB[0].z[1]-0.5*EGdz;

  for(j=0; j < nr1; j++) x[j]=R1+EGdr*j;
  for(i=0; i < nz1; i++) y[i]=Z1+EGdz*i;

  sprintf(FNm,"eqdsk.%2.2d",Fic);
  lF	=fopen(FNm,"w");
  /*      read(30,2) nxeqd,nyeqd,nveqd
	  2     format(52x,3i4)
  */
  fprintf(lF,"%56d %3d %3d\n",nr1,nz1,ESNa1);
  /*
    read(30,3) xdimeqd,ydimeqd,reqd,redeqd,ymideqd
    3     format(5e16.9)
    read(30,3) xma,yma,psimag,psilim,beqd
    read(30,3) toteqd,psimx1,psimx2,xax1,xax2
    read(30,3) zax1,zax2,psisep,xsep,ysep
  */
  fprintf(lF,"%16.9e%16.9e%16.9e%16.9e%16.9e\n"
	 ,R2-R1,Z2-Z1,ESRBt,R1,0.5*(Z1+Z2)); 
  fprintf(lF,"%16.9e%16.9e%16.9e%16.9e%16.9e\n"
	 ,EGaR0,EGaZ0,EGgY0,gYc[0],ESRBt/ESRext); 
  fprintf(lF,"%16.9e%16.9e%16.9e%16.9e%16.9e\n"
	 ,PFC[0].I0,EGgY0,EGgY0,EGaR0,EGaR0); 
  fprintf(lF,"%16.9e%16.9e%16.9e%16.9e%16.9e\n"
	 ,EGaZ0,EGaZ0,EGvRX[0],EGvZX[0],EGgYX[0]); 
  /*
    read(30,3) (feqd(i),i=1,nveqd)
    read(30,3) (pres(i),i=1,nveqd)
    read(30,3) (ffpeqd(i),i=1,nveqd)
    read(30,3) (ppeqd(i),i=1,nveqd)
    read(30,3) ((peqd(i,j),i=1,nxeqd),j=1,nyeqd)
  */
  for(j=0; j < ESNa1; j++){
    fprintf(lF,"%16.9e",ESaF[j]);
    if((j+1)%5 == 0) fputc('\n',lF);
  }
  if(j%5) fputc('\n',lF);
  for(j=0; j < ESNa1; j++){
    fprintf(lF,"%16.9e",ESsp[j]*crgm0*1e+6);
    if((j+1)%5 == 0) fputc('\n',lF);
  }
  if(j%5) fputc('\n',lF);
  for(j=0; j < ESNa1; j++){
    fprintf(lF,"%16.9e",ESaT[j]);
    if((j+1)%5 == 0) fputc('\n',lF);
  }
  if(j%5) fputc('\n',lF);
  for(j=0; j < ESNa1; j++){
    fprintf(lF,"%16.9e",ESPs[j]);
    if((j+1)%5 == 0) fputc('\n',lF);
  }
  if(j%5) fputc('\n',lF);
  ji	=0;
  for(i=0; i < nz1; i++){
    for(j=0; j < nr1; j++){
      fprintf(lF,"%16.9e",EGgYp[ji]);
      ji++;
      if(ji%5 == 0) fputc('\n',lF);
    }
  }
  /*
    read(30,3) (qpsi(i),i=1,nveqd)
    read(30,3) (rlimit(i),zlimit(i),i=1,nnlim)
    read(30,3) (rves(i),zves(i),i=1,nnves)

   */
  for(j=0; j < ESNa1; j++){
    fprintf(lF,"%16.9e",ESsq[j]);
    if((j+1)%5 == 0) fputc('\n',lF);
  }
  if(j%5) fputc('\n',lF);



  if(j%5) fputc('\n',lF);
  CbStr2UserMessage("\nOutput: %s\n",FNm);
  fclose(lF);
  Fic++;
  return(0);
}

int EqRcnstrAO()
{
  static int Fic=0;
  int iG,ID;
  int i,j,ji,nr,nz,nr1,nz1;
  double f[ESNp1],fa[ESNp1],fq[ESNp1],faq[ESNp1],rr0;
  FILE *lF;
  char FNm[16],str[0x80];
  char Date[32];
  int kD;
  double R1,R2,Z1,Z2,t,s;
  double gYr2[NplG[1]][NplG[0]],gY[NplG[0]][NplG[1]]
    ,gYz2[NplG[0]][NplG[1]]
    ,Yr2[NplG[0]][NplG[1]],Yr22[NplG[0]][NplG[1]]
    ,Yr1[NplG[0]][NplG[1]],Yr12[NplG[0]][NplG[1]];
  double x[NplG[0]],y[NplG[1]];
  double dYr,dYz,dYrz,rhr,rhz,hr6,hz6;
  double *lgYr2,*lgYz2,*lgY;

  kD	=sizeof(double);
  ID	=64;
  nr1	=PFB[0].nr;
  nz1	=PFB[0].nz;
  nr	=nr1-1;
  nz	=nz1-1;
  R1	=PFB[0].r[0]+0.5*EGdr;
  Z1	=PFB[0].z[0]+0.5*EGdz;
  R2	=PFB[0].r[1]-0.5*EGdr;
  Z2	=PFB[0].z[1]-0.5*EGdz;

  for(j=0; j < nr1; j++) x[j]=R1+EGdr*j;
  for(i=0; i < nz1; i++) y[i]=Z1+EGdz*i;

  sprintf(FNm,"esiRZ.%2.2d",Fic);
  lF	=fopen(FNm,"w");

  time(&stTime);
  ltm	=localtime(&stTime);
  sprintf(Date,"Date: %2.2d/%2.2d/%2.2d at %2.2d:%2.2d"
	  ,ltm->tm_mon+1,ltm->tm_mday,ltm->tm_year%100,ltm->tm_hour
	  ,ltm->tm_min); 
  fprintf(lF,"!!! Do not edit this file %s\n",Date);

  /* Group 0 */
  iG	=0;
  fprintf(lF,"%s[1](%s)\n",GrName[iG],GrFormat[iG]);
  i	=strlen("ESC");
  if(i < 4) i=4;
  sprintf(str,"%s%ds%s","!%3s x %3s %6s %5s %6s %",i+1
	  ,"   %5s %6s %7s %6s %7s %3s\n");
  fprintf(lF,str,GrComment[iG][0],GrComment[iG][1],GrComment[iG][2]
	  ,GrComment[iG][3],"RBtor","Name","Btor","R1","Z1","R2","Z2","Na1");
  sprintf(str,"%s%ds%s","%4d x %3d %6.6d %5.3f %6.3f %",i+1
	  ,"   %5.3f %6.3f %7.3f %6.3f %7.3f %3d\n");
  fprintf(lF,str,nr1,nz1,ID,ESRext,ESRBt,"ESC",ESBt,R1,Z1,R2,Z2,ESNa1);

  /* Group 1 */
  iG	=1;
  fprintf(lF,"%s[%d](%s)\n",GrName[iG],2+ngYc,GrFormat[iG]);
  fprintf(lF,"!%22s %24s %24s%3s\n",GrComment[iG][0],GrComment[iG][1]
	  ,GrComment[iG][2],"#");
  fprintf(lF,"%23.16e %24.16e %24.16e%3d\n",EGaR0,EGaZ0,EGgY0,0);
  fprintf(lF,"%23.16e %24.16e %24.16e%3d\n",EGaRb,EGaZb,EGgYb,1);
  for(j=0; j < ngYc; j++){
    fprintf(lF,"%23.16e %24.16e %24.16e%3d\n",rgYc[j],zgYc[j],gYc[j],j+2);
  }
  fprintf(lF,"!%22s %24s %24s%3s\n",GrComment[iG][0],GrComment[iG][1]
	  ,GrComment[iG][2],"#");

  /* Group 2 */
  out("$$$$qqqqq$$$$$ nR=I",nRx);

  iG	=2;
  fprintf(lF,"%s[%d](%s)\n",GrName[iG],nRx,GrFormat[iG]);
  fprintf(lF,"!%22s %24s %24s%2s\n",GrComment[iG][0],GrComment[iG][1]
	  ,GrComment[iG][2],"#");


  for(j=0; j < nRx; j++){
    fprintf(lF,"%23.16e %24.16e %24.16e%2d\n",EGvRx[j],EGvZx[j],EGvgYx[j],j);
  }
  fprintf(lF,"!%22s %24s %24s%2s\n",GrComment[iG][0],GrComment[iG][1]
	  ,GrComment[iG][2],"#");

  /* Group 4 optional if equidistant and R1 <= r <= R2 */
  iG	=4;
  fprintf(lF,"\n%s[%d](%s)\n",GrName[iG],nr1,GrFormat[iG]);
  fprintf(lF,"!%22s%4s\n",GrComment[iG][0],"#");
  for(j=0; j < nr1; j++){
    fprintf(lF,"%23.16e%4d\n",x[j],j);
  }
  fprintf(lF,"!%22s%4s\n",GrComment[iG][0],"#");

  /* Group 5 optional if equidistant and Z1 <= z <= Z2 */
  iG	=5;
  fprintf(lF,"\n%s[%d](%s)\n",GrName[iG],nz1,GrFormat[iG]);
  fprintf(lF,"!%22s%4s\n",GrComment[iG][0],"#");
  for(i=0; i < nz1; i++){
    fprintf(lF,"%23.16e%4d\n",y[i],i);
  }
  fprintf(lF,"!%22s%4s\n",GrComment[iG][0],"#");

  /* Group 9 */
  iG	=9;
  ji	=0;
  for(i=0; i < nz1; i++){
    spl(EGgYp+ji,gYr2[i],NULL,NULL,x,&nr);
    for(j=0; j < nr1; j++){
      gY[j][i]	=EGgYp[ji];
      Yr2[j][i]	=gYr2[i][j];
      ji++;
    }
  }
  for(j=0; j < nr1; j++){
    spl(gY[j],gYz2[j],NULL,NULL,y,&nz);
    spl(Yr2[j],Yr22[j],NULL,NULL,y,&nz);
  }
  rhr	=1./EGdr;
  rhz	=1./EGdz;
  hr6	=cr6*EGdr;
  hz6	=cr6*EGdz;
  ji	=0;
  for(i=0; i < nz1; i++){
    lgYr2=gYr2[i];
    j	=0;
    Yr1[j][i]=(EGgYp[ji+1]-EGgYp[ji])*rhr-(lgYr2[j+1]+2.*lgYr2[j])*hr6;
    Yr12[j][i]=(gYz2[j+1][i]-gYz2[j][i])*rhr
      -(Yr22[j+1][i]+2.*Yr22[j][i])*hr6;
    ji++;
    j++;
    for(; j < nr1; j++){
      Yr1[j][i]=(EGgYp[ji]-EGgYp[ji-1])*rhr+(2.*lgYr2[j]+lgYr2[j-1])*hr6;
      Yr12[j][i]=(gYz2[j][i]-gYz2[j-1][i])*rhr
	+(2.*Yr22[j][i]+Yr22[j-1][i])*hr6;
      ji++;
    }
  }
  fprintf(lF,"\n%s[%d](%s)\n",GrName[iG],nr1*nz1,GrFormat[iG]);
  fprintf(lF,"!%23s%24s%24s%24s %3s %3s\n",GrComment[iG][0]
	  ,GrComment[iG][1],GrComment[iG][2],GrComment[iG][3],"iz","jr");
  ji	=0;
  for(i=0; i < nz1; i++){
    lgYr2=gYr2[i];
    for(j=0; j < nr1; j++){
      if(i){
	dYz	=(gY[j][i]-gY[j][i-1])*rhz+(2.*gYz2[j][i]+gYz2[j][i-1])*hz6;
	dYrz	=(Yr1[j][i]-Yr1[j][i-1])*rhz+(2.*Yr12[j][i]+Yr12[j][i-1])*hz6;
      }else{
	dYz	=(gY[j][i+1]-gY[j][i])*rhz-(gYz2[j][i+1]+2.*gYz2[j][i])*hz6;
	dYrz	=(Yr1[j][i+1]-Yr1[j][i])*rhz-(Yr12[j][i+1]+2.*Yr12[j][i])*hz6;
      }
      fprintf(lF,"%24.16e%24.16e%24.16e%24.16e %3d %3d\n",EGgYp[ji],Yr1[j][i]
	      ,dYz,dYrz,i,j);
      ji++;
    }
  }
  ESBasicFunctions();
  esc2esi(lF);
  CbStr2UserMessage("\nOutput: %s\n",FNm);
  fclose(lF);
  Fic++;
  return(0);
}

int EqRcnstr()
{
  extern void IbPFIPlot();
  extern double ESTime;
  static int nV=1,nPE;
  static int Fl=0,eFl=0,iFl=1,jFl=2,cFl=1,vFl=2,Fic=0;
  char FNm[0x10]="esiRZ.00";
  int iPS=0,kFic=0;
  int i,j,k,n;
  static double wL=1.,wB=1.,wI=1.,wV=1.,wF=1.,wP=1.;
  static double wv=1.;

  double R[nPEC+1],Z[nPEC+1],I0[nPEC+1],Ib[nPEC+1];
  int Np,iD[nPEC+1];

  double Rp[0x400],Zp[0x400];
  double W,WI,WV,WL,WB;

  PFBLOCK *lB;
  PSBLOCK *lS;
  PFCOIL *lC,*lV,FakeVC;
  char NmC[nPEC][0x10];
  char str[64];

  int FlELM=0;
  double rELM=4.254,zELM=-3.615;

  rELM=2;
  zELM =1.8;
  nVVC=0;
  nPEC=nPFC+nVVC;;
  nV	=nVVC;
  out("&&&&& nP=I",nPFC);
  if(nV == 0){
    lB	=PFB+PFC[nPFC-1].kB[0];
    R[nPFC]	=lB->R;
    Z[nPFC]	=lB->Z;
    iD[nPFC]	=0;
    I0[nPFC]	=0.;
    Ib[nPFC]	=0.;

    lV		=&FakeVC;
    lV->kA	=0;
    nV		=1;
    strcpy(lV->Nm,"Fake");
    strcpy(NmC[nPFC],lV->Nm);
  }else{
    lV		=VVC;
  }
  nPE	=nPFC+nV;

  if(0){
    FILE *lf;
    lf	=fopen("CDX.MFp-C","w");
    fprintf(lf,"Green functions Flux Loops-Coils, [Vsec/MA]\n");
    fputs(" #",lf);
    for(j=1; j < nPFC; j++) fprintf(lf," %10s",PFC[j].Nm);
    fputc('\n',lf);
    for(i=0; i < nMFL; i++){
      fprintf(lf,"%2d",i+1);
      for(j=1; j < nPFC; j++) fprintf(lf,"%11.4e",gYiC[i][j]);
      fputc('\n',lf);
    }
    fputc('\n',lf);
    fprintf(lf,"Green functions Magnetic Probes-Coils, [T/MA]\n");
    fputs(" #",lf);
    for(j=1; j < nPFC; j++){
      fprintf(lf," %10s",PFC[j].Nm);
    }
    fputc('\n',lf);
    for(i=0; i < nMFp; i++){
      fprintf(lf,"%2d",i+1);
      for(j=1; j < nPFC; j++){
	fprintf(lf,"%11.4e",gYiC[i+nMFLS][j]);
      }
      fputc('\n',lf);
    }
    fclose(lf);
  }

  PFC[0].I0=ESIpl;
  nMFPE	=nMFL+nMFS+nMFp;
  iOH	=0;
  while(iOH < nPFC){
    if(strcmp(PFC[iOH].Nm,"OH") == 0) break;
    iOH++;
  }
  if((ESFlHole&0x10)){
    PFFirstSetSpl();
    ESFlHole	&=~0x10;
  }

  ESInpPlPr4PF();
  ESInpPlCr4PF();
  PFSetJsJp();

  FlagPoints	=1;
  for(i=0,lC=PFC; i < nPFC; i++,lC++){
    k		=lC->kB[0];
    Ib[i]	=lC->I0*PFB[k].tn;
    iD[i]	=0;
    strcpy(NmC[i],lC->Nm);
  } 

  for(j=0,lC=VVC; j < nVVC; j++,i++,lC++){
    Ib[i]	=lC->I0;
    iD[i]	=0;
    strcpy(NmC[i],lC->Nm);
  }
  
  EGaR0	=PFB[0].R;
  EGaZ0	=PFB[0].Z;
  
  if(bU == NULL){
    MSVD	=nPFC+nVVC+21+12;
    for(i=0; i < nMFPE; i++) if(MFP[i].kA) MSVD++;
    i	=MSVD/0x10;
    MSVD	=(i+1)*0x10;
    i	=(nPFC+nVVC+20+1)/0x04;
    NSVD	=(i+1)*0x04;

    out("&&&&& nP=I I I m=I I",nPFC,nVVC,nMFPE,MSVD,NSVD);

    if(Mem4EqRcnstrSVD(&bU,&bV,&bF,&bS,&bT,&bW,MSVD,NSVD)) return(1);
    aU	=bU;
    aV	=bV;
    aF	=bF;
    aS	=bS;
    aT	=bT;
    aW	=bW;
  }

  if(ESiAx) ESiAx=0;
  StD	=Step*0.5*0.6;

#ifndef Tbl_EqRcnstr
  if(nVVC == 0) lV->kA=0;
  PFC[nPFC].I=PFC[nPFC].I0;
  if(nKj > NKj) nKj=NKj;
  if(nKj < 0) nKj=0;
  if(nKp > NKp) nKp=NKp;
  if(nKp < 0) nKp=0;
  PFCnK	=nKj+nKp;

  if(iFl){
    InitFeedBack(iFl);
    iFl	=0;
  }
  SetCntrPoints();
  InitPFCoils(cFl,Ib);
  InitVVCoils(vFl,Ib+nPFC);
  SetIntParam2EREI();

  if(jFl){
    InitPlCoil(jFl);
    FlagIter=0;
    jFl	=0;
  }
  switch(eFl){
  case 1:
    ESInpPlPr4PF();
    ESInpPlCr4PF();
    PFSetJsJp();
    eFl=0;
    break;
  case 2:
    PFInitJsJp();
    eFl=0;
    break;
  case 3:
    PFReSetJsJp();
    break;
  case 4:
    PFGenerateSignals();
    Fl	=0;
    break;
  case 5:
    FlBlockIter	=1;
    Fl	=0;
    break;
  case 6:
    FlBlockIter	=0;
    Fl	=0;
    break;
  default:
    break;
  }
  if(kTimeHistory == 0 && kHist == 2) kHist=0;
  switch(Fl){
  case 0:
    CbUserPlot	=IbPFIPlot;
    break;
  case 1:
    if(IsFeedBackConsistent(cFl)){
      PFCInvEqMatr0();
      PFCSolvMatrEq0();
    }
    else{
      Fl	=0;
    }
    break;
  case 2:
#ifdef H
    PFCSolvMatrEq2(wL,wB,wI,wV,wF);
#endif
    if(IsFeedBackConsistent(Fl)){
      PFCSVD(wL,wB,wI,wV,wF,wP);
    }else{
      Fl	=0;
    }
   break;
  case 3:
    PFCSolvSVD(wL,wB,wI,wV,wF,wP);
    break;
  case 4:
  case 5:
    if(kTimeHistory){
      PFCSolvSVDHistory(wL,wB,wI,wV,wv,wF,wP,Fl);
    }
    else{
      CbStr2UserMessage("No time history for this shot\n");
      Fl=0;
    }
    break;
  case 6:
    PFCSolvMatrEq5(wL,wB,wI,wV,wF);
    break;
  default:
    break;
  }
  sprintf(FNm,"esiRZ.%2.2d",Fic);
  if(Fl){
    PFSetPFBCurrents();
    PFBoundary2ESC();
    CbUserPlot	=MFLinePlot;
    if(Fl == 3){
      kHist	=0;
      PFDiscrepancy(wL,wB,wI,wV,wF);
    }
    sprintf(str,"%s t=%5.3f",ShotNm,ESTime);
    if(kHist < 2){
      PFExpDataPlot(iPS != 4 ? iPS : iPS+1,str);
    }
#ifdef H
    if(kHist == 0){
      PFExpDataPlot(iPS != 4 ? iPS : iPS+1,str);
    }
#endif
    else{
      PFHistoryDataPlot(iPS != 4 ? iPS : iPS+1,str);
    }
    iPS	=0;
    if(Fl < 3){
      PFGetW(&W,&WI,&WV,&WL,&WB);
    }
    CbStr2UserMessage("W1=%9.3e\nwL=%9.3e\nwB=%9.3e\nwI=%9.3e\nwV=%9.3e\n"
		      "W =%9.3e\nEr=%9.3e",WI+WL+WB,WL,WB,WI,WV,W,err);

    PFPlasmaJPlot();
    if(kFic){
      EqRcnstrAO();
      EqRcnstrAOE();
    }
  }
  if(kFic) kFic=0;
  for(i=0; i < nPFC; i++){
    lC	=PFC+i;
    n		=lC->nB;
    for(j=0; j < n; j++){
      k		=lC->kB[j];
      lB	=PFB+k;
      lB->I	=lC->I;
      lB->AI	=lC->I*lB->tn;
      if(j == 0){
	Ib[i]	=lB->AI;
	R[i]	=lB->R;
	Z[i]	=lB->Z;
      }
    }
    I0[i]	=lC->I0;
  }

  for(j=0; j < nVVC; j++,i++){
    lC		=VVC+j;
    lS		=VVB+lC->kB[0];
    R[i]	=cr4*(lS->r[0]+lS->r[1]+lS->r[2]+lS->r[3]);
    Z[i]	=cr4*(lS->z[0]+lS->z[1]+lS->z[2]+lS->z[3]);
    I0[i]	=lC->I0;
    Ib[i]	=lC->I;
  }
  if(1 || ESTime != 0.){
    sprintf(str,"%s t=%5.3f",ShotNm,ESTime);
  } 
  else{
    sprintf(str,"%s.%s",ShotNm,kFileExt);
  }
  R[0]	=EGaR0;
  Z[0]	=EGaZ0;

  Np	=0;
  for(i=0; i < EGNp & Np < 1024; i++){
    if(EGkAp[i]){
      Rp[Np]	=EGaRp[i];
      Zp[Np]	=EGaZp[i];
      Np++;
    }
  }
  ESIpl	=PFC[0].I;
  SetPlotLimits(1);
  if((FlELM&0x01)) MFOutLine(RPlt+4,ZPlt+4,rELM,zELM,Step,FlELM);
  if((FlELM&0x02)) MFFullLine(RPlt+4,ZPlt+4,ESRBt,rELM,zELM,Step,FlELM);
#endif/*Tbl_EqRcnstr*/
  InitFeedBack(4);
  CbUserMessage=NULL;
  return(0);
}

int PFCInvEqMatr1(double wL,double wB,double wI,double wV)
{
  int i,ii,j,jj,k,ki,n;
  double s,sx,sy;

  n	=PFCnB+PFCnY+2*PFCnX+PFCnF+PFCnO;
  if(PFInitAA(n)) return(1);
  k	=PFCnB ? n-1 : n;
  for(i=0; i < n; i++){
    lAA[i]	=AA+i*k;
  } 
  ii	=0;
  for(i=1; i < nPFC; i++){
    if(PFC[i].kA == 2 || PFC[i].kA == 3){
      for(k=0; k < nMFL; k++){
	if(MFP[k].kA) daSi[k]=wL*MFP[k].w*gYiC[k][i];
      }
      for(; k < nMFP; k++){
	if(MFP[k].kA) daSi[k]=wB*MFP[k].w*gYiC[k][i];
      }
      jj	=ii;
      for(j=i; j < nPFC; j++){
	if(PFC[j].kA == 2 || PFC[j].kA == 3){
	  s	=0.;
	  for(k=0; k < nMFP; k++){
	    if(MFP[k].kA) s+=daSi[k]*MFP[k].w*gYiC[k][j];
	  }
	  s	+=PFC[i].wW*PFC[j].wW*gYCC[i][j];
	  lAA[ii][jj]	=s;
	  lAA[jj][ii]	=s;
	  jj++;
	}
      }
      for(j=0; j < nVVC; j++){
	if(VVC[j].kA == 2 || VVC[j].kA == 3){
	  s	=0.;
	  for(k=0; k < nMFP; k++){
	    if(MFP[k].kA) s+=daSi[k]*MFP[k].w*gYiS[k][j];
	  }
	  lAA[ii][jj]	=s;
	  lAA[jj][ii]	=s;
	  jj++;
	}
      }
      s		=PFC[i].tn;
      lAA[ii][ii]	+=PFC[i].wR*s*s;
      if(PFC[i].kA == 3)lAA[ii][ii]+=wI*PFC[i].wI*PFC[i].wI;
      s	=0.;
      for(k=0; k < nMFP; k++){
	if(MFP[k].kA){
	  s	+=daSi[k]*MFP[k].w*MFP[k].S0;
	}
      }
      FAs[ii]	=s;
      ii++;
    }
  }
  for(i=0; i < nVVC; i++){
    if(VVC[i].kA == 2 || VVC[i].kA == 3){
      for(k=0; k < nMFL; k++){
	if(MFP[k].kA){
	  daSi[k]	=wL*MFP[k].w*gYiS[k][i];
	}
      }
      for(; k < nMFP; k++){
	if(MFP[k].kA){
	  daSi[k]	=wB*MFP[k].w*gYiS[k][i];
	}
      }
      jj	=ii;
      for(j=i; j < nVVC; j++){
	if(VVC[j].kA == 2 || VVC[j].kA == 3){
	  s	=0.;
	  for(k=0; k < nMFP; k++){
	    if(MFP[k].kA){
	      s	+=daSi[k]*MFP[k].w*gYiS[k][j];
	    }
	  }
	  lAA[ii][jj]	=s;
	  lAA[jj][ii]	=s;
	  jj++;
	}
      }
      if(VVC[i].kA == 3){
	lAA[ii][ii]	+=wV*VVC[i].wI*VVC[i].wI;
      }
      s	=0.;
      for(k=0; k < nMFP; k++){
	if(MFP[k].kA){
	  s	+=daSi[k]*MFP[k].w*MFP[k].S0;
	}
      }
      FAs[ii]	=s;
      ii++;
    }
  }

  for(i=0; i < 12; i++){
    if(CNTP[i].kA == 2){
      jj	=0;
      for(j=1; j < nPFC; j++){
	if(PFC[j].kA == 2 || PFC[j].kA == 3){
	  lAA[ii][jj]	=gYcC[i][j];
	  lAA[jj][ii]	=lAA[ii][jj];
	  jj++;
	}
      }
      for(j=0; j < nVVC; j++){
	if(VVC[j].kA == 2 || VVC[j].kA == 3){
	  lAA[ii][jj]	=gYcS[i][j];
	  lAA[jj][ii]	=lAA[ii][jj];
	  jj++;
	}
      }
      FAs[ii++]	=CNTP[i].gY;
    }
    if(CNTP[i].kA == 3 || CNTP[i].kA == 4){
      jj	=0;
      for(j=1; j < nPFC; j++){
	if(PFC[j].kA == 2 || PFC[j].kA == 3){
	  lAA[ii][jj]	=BRcC[i][j];
	  lAA[jj][ii]	=lAA[ii][jj];
	  jj++;
	}
      }
      for(j=0; j < nVVC; j++){
	if(VVC[j].kA == 2 || VVC[j].kA == 3){
	  lAA[ii][jj]	=BRcS[i][j];
	  lAA[jj][ii]	=lAA[ii][jj];
	  jj++;
	}
      }
      FAs[ii++]	=0.;
      jj	=0;
      for(j=1; j < nPFC; j++){
	if(PFC[j].kA == 2 || PFC[j].kA == 3){
	  lAA[ii][jj]	=BZcC[i][j];
	  lAA[jj][ii]	=lAA[ii][jj];
	  jj++;
	}
      }
      for(j=0; j < nVVC; j++){
	if(VVC[j].kA == 2 || VVC[j].kA == 3){
	  lAA[ii][jj]	=BZcS[i][j];
	  lAA[jj][ii]	=lAA[ii][jj];
	  jj++;
	}
      }
      FAs[ii++]	=0.;
    }
  }
  if(PFCnB){
    double *l1,*l0;
    for(i=0; i < 12; i++){
      if(CNTP[i].kA == 1 || CNTP[i].kA == 4){
	jj	=0;
	for(j=1; j < nPFC; j++){
	  if(PFC[j].kA == 2 || PFC[j].kA == 3){
	    lAA[ii][jj]	=gYcC[i][j];
	    jj++;
	  }
	}
	for(j=0; j < nVVC; j++){
	  if(VVC[j].kA == 2 || VVC[j].kA == 3){
	    lAA[ii][jj]	=gYcS[i][j];
	    jj++;
	  }
	}	
	ii++;
      }
    }
    i	=ii-PFCnB;
    ii--;
    l0	=lAA[ii];
    jj	=PFCnF+PFCnO;
    for(; i < ii; i++){
      l1	=lAA[i];
      for(j=0; j < jj; j++){
	l1[j]	-=l0[j];
      }
      FAs[i]	=0.;
    }
    n--;
  }
  ii	=jj;
  for(i=ii; i < n; i++){
    for(j=0; j < ii; j++){
      lAA[j][i]	=lAA[i][j];
    }
    for(j=ii; j < n; j++){
      lAA[i][j]	=0.;
    }
  }
#ifdef H
  printf("--------------------\n");
  for(i=0; i < n; i++){
    for(j=0; j < n; j++){
      printf("%10.3e",lAA[i][j]);
    }
    putchar('\n');
  }
#endif
  LUdcmp(AA,n,iAA,&s);
  return(0);
}

int PFCOptEqRHSC(double wL,double wB,double wI,double wV)
{
  int i,ii,j,k;
  double s,sx,sy;

  for(k=0; k < nMFP; k++){
    if(MFP[k].kA){
      s	=0.;
      for(i=1; i < nPFC; i++){
	if(PFC[i].kA == 1 || PFC[i].kA == 4){
	  s	+=gYiC[k][i]*PFC[i].I;
	}
      }
      for(i=0; i < nVVC; i++){
	if(VVC[i].kA == 1 || VVC[i].kA == 4){
	  s	+=gYiS[k][i]*VVC[i].I;
	}
      }
      aSiC[k]	=MFP[k].w*s;
    }
  }
  ii	=0;
  for(i=1; i < nPFC; i++){
    if(PFC[i].kA == 2 || PFC[i].kA == 3){
      s	=0.;
      for(k=0; k < nMFL; k++){
	if(MFP[k].kA){
	  s	+=wL*MFP[k].w*aSiC[k]*gYiC[k][i];
	}
      }
      for(; k < nMFP; k++){
	if(MFP[k].kA){
	  s	+=wB*MFP[k].w*aSiC[k]*gYiC[k][i];
	}
      }
      for(j=0; j < nPFC; j++){
	if(PFC[j].kA == 1 || PFC[j].kA == 4){
	  s	+=PFC[i].wW*PFC[j].wW*gYCC[i][j]*PFC[j].I;
	}
      }
      if(PFC[i].kA == 3){
	s	-=wI*PFC[i].wI*PFC[i].wI*PFC[i].I0;
      }
      FAi[ii++]	=s;
    }
  }
  for(i=0; i < nVVC; i++){
    if(VVC[i].kA == 2 || VVC[i].kA == 3){
      s	=0.;
      for(k=0; k < nMFL; k++){
	if(MFP[k].kA){
	  s	+=wL*MFP[k].w*aSiC[k]*gYiS[k][i];
	}
      }
      for(; k < nMFP; k++){
	if(MFP[k].kA){
	  s	+=wB*MFP[k].w*aSiC[k]*gYiS[k][i];
	}
      }
      if(VVC[i].kA == 3){
	s	-=wV*VVC[i].wI*VVC[i].wI*VVC[i].I0;
      }
      FAi[ii++]	=s;
    }
  }

  for(i=0; i < 12; i++){
    if(CNTP[i].kA == 2){
      s		=0;
      for(j=1; j < nPFC; j++){
	if(PFC[j].kA == 1) s +=gYcC[i][j]*PFC[j].I;
      }
      for(j=0; j < nVVC; j++){
	if(VVC[j].kA == 1 || VVC[j].kA == 4)  s +=gYcS[i][j]*VVC[j].I;
      }
      gYc[i]	=s;
      FAi[ii++]	=s;
    }
    if(CNTP[i].kA == 3 || CNTP[i].kA == 4){
      s		=0.;
      sx	=0.;
      sy	=0.;
      for(j=1; j < nPFC; j++){
	if(PFC[j].kA == 1 || PFC[j].kA == 4){
	  s	+=gYcC[i][j]*PFC[j].I;
	  sx	+=BRcC[i][j]*PFC[j].I;
	  sy	+=BZcC[i][j]*PFC[j].I;
	}
      }	
      for(j=0; j < nVVC; j++){
	if(VVC[j].kA == 1 || VVC[j].kA == 4){
	  s	+=gYcS[i][j]*VVC[j].I;
	  sx	+=BRcS[i][j]*VVC[j].I;
	  sy	+=BZcS[i][j]*VVC[j].I;
	}
      }
      gYc[i]	=s;
      FAi[ii++]	=sx;
      FAi[ii++]	=sy;
    }
  }
  if(PFCnB){
    for(i=0; i < 12; i++){
      if(CNTP[i].kA == 1 || CNTP[i].kA == 4){
	s	=0.;
	for(j=1; j < nPFC; j++){
	  if(PFC[j].kA == 1 || PFC[j].kA == 4) s+=gYcC[i][j]*PFC[j].I;
	}	
	for(j=0; j < nVVC; j++){
	  if(VVC[j].kA == 1 || VVC[j].kA == 4) s+=gYcS[i][j]*VVC[j].I;
	}
	gYc[i]	=s;
	FAi[ii++]	=s;
      }
    }
    i	=ii-PFCnB;
    ii--;
    for(; i < ii; i++){
      FAi[i]	-=FAi[ii];
    }
  }
  return(0);
}

int PFCOptEqRHS(double wL,double wB,double wI,double wV)
{
  int i,ii,j,k,n;
  double s,Br,Bz;

  for(k=0; k < nMFP; k++){
    s	=0.;
    if(MFP[k].kA){
      for(i=0; i < EGNp; i++){
	if(EGkAp[i]){
	  s	+=gYip[k][i]*EGaIp[i];
	}
      }
      aSip[k]	=s*MFP[k].w;
    }
  }
  ii	=0;
  for(i=1; i < nPFC; i++){
    if(PFC[i].kA == 2 || PFC[i].kA == 3){
      s	=0.;
      for(k=0; k < nMFL; k++){
	if(MFP[k].kA){
	  s	+=wL*aSip[k]*MFP[k].w*gYiC[k][i];
	}
      }
      for(; k < nMFP; k++){
	if(MFP[k].kA){
	  s	+=wB*aSip[k]*MFP[k].w*gYiC[k][i];
	}
      }
      FAp[ii]	=s;
      s		=0.;
      for(k=0; k < EGNp; k++){
	if(EGkAp[k]){
	  s	+=EGaIp[k]*gYpC[k][i]*PFC[i].wW;
	}
      }
      FAp[ii++]	+=s*PFC[0].wW;
    }
  }
  for(i=0; i < nVVC; i++){
    if(VVC[i].kA == 2 || VVC[i].kA == 3){
      s	=0.;
      for(k=0; k < nMFL; k++){
	if(MFP[k].kA){
	  s	+=wL*aSip[k]*MFP[k].w*gYiS[k][i];
	}
      }
      for(; k < nMFP; k++){
	if(MFP[k].kA){
	  s	+=wB*aSip[k]*MFP[k].w*gYiS[k][i];
	}
      }
      FAp[ii]	=s;
      i++;
    }
  }
  for(i=0; i < 12; i++){
    if(CNTP[i].kA == 2){
      s	=0.;
      for(j=0; j < EGNp; j++){
	if(EGkAp[j]){
	  s	+=gYpC[i][j]*EGaIp[j];
	}
      }
      FAp[ii++]	=s;
    }
    if(CNTP[i].kA == 3 || CNTP[i].kA == 4){
      Br	=0.;
      Bz	=0.;
      for(j=0; j < EGNp; j++){
	if(EGkAp[j]){
	  Br	+=BRcp[i][j]*EGaIp[j];
	  Bz	+=BZcp[i][j]*EGaIp[j];
	}
      }
      FAp[ii++]	=Br;
      FAp[ii++]	=Bz;
    }
  }
  for(i=0; i < 12; i++){
    if(CNTP[i].kA == 1 || CNTP[i].kA == 4){
      s		=0.;
      for(j=0; j < EGNp; j++){
	if(EGkAp[j]){
	  s	+=gYcp[i][j]*EGaIp[j];
	}
      }
      FAp[ii++]	=s;
    }
  }
  if(PFCnB){
    i	=ii-PFCnB;
    ii--;
    for(; i < ii; i++){
      FAp[i]	-=FAp[ii];
    }
  }
  n	=PFCnQ+PFCnF+PFCnO;
  for(i=0; i < n; i++){
    FA[i]	=FAs[i]-FAi[i]-FAp[i];
  }
#ifdef H
  printf("FA-------------------\n");
  for(i=0; i < n; i++){
    printf("%10.3e",FA[i]);
  }
  putchar('\n');
  printf("FAs--------------------\n");
  for(i=0; i < n; i++){
    printf("%10.3e",FAs[i]);
  }
  putchar('\n');
  printf("FAi--------------------\n");
  for(i=0; i < n; i++){
    printf("%10.3e",FAi[i]);
  }
  putchar('\n');
  printf("FAp--------------------\n");
  for(i=0; i < n; i++){
    printf("%10.3e",FAp[i]);
  }
  putchar('\n');
#endif
  LUbksb(AA,n,iAA,FA);
  j	=0;
  for(i=1; i < nPFC; i++){
    if(PFC[i].kA == 2 || PFC[i].kA == 3){
      PFC[i].I	=FA[j++];
    }
  }
  for(i=0; i < nVVC; i++){
    if(VVC[i].kA == 2 || VVC[i].kA == 3){
      VVC[i].I	=FA[j++];
    }
  }
#ifdef H
  printf("I-------------------\n");
  for(i=0; i < n; i++){
    printf("%10.3e",FA[i]);
  }
  putchar('\n');
#endif
  return(0);
}

int PFCInvEqMatr2(double wL,double wB,double wI,double wV,double wF)
{
  int i,ii,j,jj,k,ki,m,n,J;
  double s,ss;
  double Igf[42],aNorm;
  static double gL[8]={0.,0.,0.,0.,0.,0.,0.,0.};

  J	=PFCnF+PFCnO;
  n	=PFCnB+PFCnY+2*PFCnX+J+PFCnK;

  if(PFInitAA(n)){
    return(1);
  }
  k	=PFCnB ? n-1 : n;
  for(i=0; i < n; i++){
    lAA[i]	=AA+i*k;
  }
  
  for(m=0; m < nMFP; m++){
    if(MFP[m].kA){
      s	=0.;
      for(j=0; j < EGNp; j++){
	if(EGkAp[j]){
	  s	+=gYip[m][j]*EGaIp[j];
	}
      }
      aSip[m]	=s;
      for(j=1; j < nPFC; j++){
	if(PFC[j].kA == 1 || PFC[j].kA == 4){
	  s	+=gYiC[m][j]*PFC[j].I;
	}
      }
      for(j=0; j < nVVC; j++){
	if(VVC[j].kA == 1 || VVC[j].kA == 4){
	  s	+=gYiS[m][j]*VVC[j].I;
	}
      }
      aSiC[m]	=MFP[m].w*(MFP[m].S0-s);
    }
  }
  ii	=0;
  for(i=1; i < nPFC; i++){
    if(PFC[i].kA == 2 || PFC[i].kA == 3){
      for(m=0; m < nMFP; m++){
	if(MFP[m].kA){
	  s	=MFP[m].w*gYiC[m][i];
	  daSi[m]=m < nMFLS ? wL*wL*s : wB*wB*s;
	}
      }
      jj	=ii;
      for(j=i; j < nPFC; j++){
	if(PFC[j].kA == 2 || PFC[j].kA == 3){
	  s	=0.;
	  for(m=0; m < nMFP; m++){
	    if(MFP[m].kA){
	      s	+=daSi[m]*MFP[m].w*gYiC[m][j];
	    }
	  }
	  s	+=PFC[i].wW*PFC[j].wW*gYCC[i][j];
	  lAA[ii][jj]	=s;
	  lAA[jj][ii]	=s;
	  jj++;
	}
      }
      s		=PFC[i].tn;
      lAA[ii][ii]	+=PFC[i].wR*s*s;
      if(PFC[i].kA == 3){
	lAA[ii][ii]	+=wI*wI*PFC[i].wI*PFC[i].wI;
      }
      for(j=0; j < nVVC; j++){
	if(VVC[j].kA == 2 || VVC[j].kA == 3){
	  s	=0.;
	  for(m=0; m < nMFP; m++){
	    if(MFP[m].kA){
	      s	+=daSi[m]*MFP[m].w*gYiS[m][j];
	    }
	  }
	  lAA[ii][jj]	=s;
	  lAA[jj][ii]	=s;
	  jj++;
	}
      }
      for(j=0; j < EGNp; j++){
	if(EGkAp[j]){
	  s	=0.;
	  for(m=0; m < nMFP; m++){
	    if(MFP[m].kA){
	      s	+=daSi[m]*MFP[m].w*gYip[m][j];
	    }
	  }
	  EGs1[j]	=s;
	}
      }
      for(k=0; k < PFCnK; k++){
	ss	=0.;
	s	=0.;
	for(j=0; j < EGNp; j++){
	  if(EGkAp[j]){
	    s	+=EGs1[j]*EGgf[k][j];
	    ss	+=gYpC[j][i]*EGgf[k][j];
	  }
	}
	s	+=PFC[0].wW*PFC[i].wW*ss;
	lAA[ii][jj]	=s;
	lAA[jj][ii]	=s;
	jj++;
      }
      s	=0.;
      for(m=0; m < nMFP; m++){
	if(MFP[m].kA){
	  s	+=daSi[m]*aSiC[m];
	}
      }
      if(PFC[i].kA == 3){
	s	+=wI*wI*PFC[i].wI*PFC[i].wI*PFC[i].I0;
      }
      if(PFC[i].wW != 0.){
	ss	=0.;
	for(j=1; j < nPFC; j++){
	  if(PFC[j].kA == 1 || PFC[j].kA == 4){
	    ss	+=PFC[j].wW*gYCC[i][j]*PFC[j].I;
	  }
	}
	s	-=PFC[i].wW*ss;
	if(PFC[0].wW != 0.){
	  ss	=0.;
	  for(j=0; j < EGNp; j++){
	    if(EGkAp[j]){
	      ss	+=gYpC[i][j]*EGaIp[j];
	    }
	  }
	  s	-=PFC[i].wW*PFC[0].wW*ss;
	}
      }
      FA[ii++]	=s;
    }
  }
  for(i=0; i < nVVC; i++){
    if(VVC[i].kA == 2 || VVC[i].kA == 3){
      for(m=0; m < nMFP; m++){
	if(MFP[m].kA){
	  s	=MFP[m].w*gYiS[m][i];
	  daSi[m]=m < nMFLS ? wL*wL*s : wB*wB*s;
	}
      }
      jj	=ii;
      for(j=i; j < nVVC; j++){
	if(VVC[j].kA == 2 || VVC[j].kA == 3){
	  s	=0.;
	  for(m=0; m < nMFP; m++){
	    if(MFP[m].kA){
	      s	+=daSi[m]*MFP[m].w*gYiS[m][j];
	    }
	  }
	  lAA[ii][jj]	=s;
	  lAA[jj][ii]	=s;
	  jj++;
	}
      }
      if(VVC[i].kA == 3){
	lAA[ii][ii]	+=wV*wV*VVC[i].wI*VVC[i].wI;
      }
      for(j=0; j < EGNp; j++){
	if(EGkAp[j]){
	  s	=0.;
	  for(m=0; m < nMFP; m++){
	    if(MFP[m].kA){
	      s	+=daSi[m]*MFP[m].w*gYip[m][j];
	    }
	  }
	  EGs1[j]	=s;
	}
      }
      for(k=0; k < PFCnK; k++){
	s	=0.;
	for(j=0; j < EGNp; j++){
	  if(EGkAp[j]){
	    s	+=EGs1[j]*EGgf[k][j];
	  }
	}
	lAA[ii][jj]	=s;
	lAA[jj][ii]	=s;
	jj++;
      }
      s	=0.;
      for(m=0; m < nMFP; m++){
	if(MFP[m].kA){
	  s	+=daSi[m]*aSiC[m];
	}
      }
      if(VVC[i].kA == 3){
	s	+=wV*wV*VVC[i].wI*VVC[i].wI*VVC[i].I0;
      }
      FA[ii++]	=s;
    }
  }

  if(PFCnK){
    for(i=0; i < PFCnK; i++){
      s	=0.;
      for(j=0; j < EGNp; j++){
	if(EGkAp[j]){
	  s	+=EGgf[i][j];
	}
      }
      Igf[i]	=s;
    }
    aNorm	=1./Igf[0];
  }
  for(i=0; i < PFCnK; i++){
    for(m=0; m < nMFP; m++){
      if(MFP[m].kA){
	s	=0.;
	for(j=0; j < EGNp; j++){
	  if(EGkAp[j]){
	    s	+=gYip[m][j]*EGgf[i][j];
	  }
	}
	s	*=MFP[m].w;
	daSi[m]	=m < nMFLS ? wL*wL*s : wB*wB*s;
      }
    }
    jj	=ii;
    for(j=0; j < EGNp; j++){
      if(EGkAp[j]){
	s	=0.;
	for(m=0; m < nMFP; m++){
	  if(MFP[m].kA){
	    s	+=daSi[m]*MFP[m].w*gYip[m][j];
	  }
	}
	EGs1[j]	=s;
      }
    }
    for(j=0; j < EGNp; j++){
      if(EGkAp[j]){
	s	=0.;
	for(m=0; m < EGNp; m++){
	  if(EGkAp[m]){
	    s	+=EGgf[i][m]*gYpp[m][j];
	  }
	}
	EGs1[j]	+=PFC[0].wW*PFC[0].wW*s;
      }
    }
    for(k=i; k < PFCnK; k++){
      s	=0.;
      for(j=0; j < EGNp; j++){
	if(EGkAp[j]){
	  s	+=EGs1[j]*EGgf[k][j];
	}
      }
      if(i == k){
	s	+=wF*wF*aNorm*aNorm*PFwrP[k/2];
      }
      s		+=wI*wI*PFC[0].wI*PFC[0].wI*Igf[i]*Igf[k]*aNorm*aNorm;
      lAA[ii][jj]	=s;
      lAA[jj][ii]	=s;
      jj++;
    }

    s	=0.;
    if(PFC[0].wW != 0.){
      for(k=1; k < nPFC; k++){
	if((PFC[k].kA == 1 || PFC[k].kA == 4) && PFC[k].wW != 0.){
	  ss	=0;
	  for(j=0; j < EGNp; j++){
	    if(EGkAp[j]){
	      ss	+=EGgf[i][j]*gYpC[j][k];
	    }
	  }
	  s	-=PFC[k].wW*PFC[k].I*ss;
	}
      }
      for(j=0; j < EGNp; j++){
	if(EGkAp[j]){
	  ss	=0;
	  for(k=0; k < EGNp; k++){
	    if(EGkAp[k]){
	      ss	+=gYpp[j][k]*EGaIp[k];
	    }
	  }
	  s	-=PFC[0].wW*EGgf[i][j]*ss;
	}
      }
      s	*=PFC[0].wW;
    }
    for(m=0; m < nMFP; m++){
      if(MFP[m].kA){
	s	+=daSi[m]*aSiC[m];
      }
    }
    FA[ii++]	=s;
  }
  for(i=0; i < 12; i++){
    if(CNTP[i].kA == 2){
      jj	=0;
      ss	=0;
      for(j=1; j < nPFC; j++){
	if(PFC[j].kA == 2 || PFC[j].kA == 3){
	  lAA[ii][jj]	=gYcC[i][j];
	  lAA[jj][ii]	=lAA[ii][jj];
	  jj++;
	}
	if(PFC[j].kA == 1 || PFC[j].kA == 4){
	  ss	+=gYcC[i][j]*PFC[j].I;
	}
      }
      for(j=0; j < nVVC; j++){
	if(VVC[j].kA == 2 || VVC[j].kA == 3){
	  lAA[ii][jj]	=gYcS[i][j];
	  lAA[jj][ii]	=lAA[ii][jj];
	  jj++;
	}
	if(VVC[j].kA == 1 || VVC[j].kA == 4){
	  ss	+=gYcS[i][j]*VVC[j].I;
	}
      }
      for(k=0; k < PFCnK; k++){
	s	=0.;
	for(j=0; j < EGNp; j++){
	  if(EGkAp[j]){
	    s	+=gYcp[i][j]*EGgf[k][j];
	  }
	}
	lAA[ii][jj]	=s;
	lAA[jj][ii]	=s;
	jj++;
      }
      for(j=0; j < EGNp; j++){
	if(EGkAp[j]){
	  ss	+=gYip[i][j]*EGaIp[j];
	}
      }
      FA[ii++]	=CNTP[i].gY-ss;
    }
    if(CNTP[i].kA == 3 || CNTP[i].kA == 4){
      jj	=0;
      ss	=0.;
      for(j=1; j < nPFC; j++){
	if(PFC[j].kA == 2 || PFC[j].kA == 3){
	  lAA[ii][jj]	=BRcC[i][j];
	  lAA[jj][ii]	=lAA[ii][jj];
	  jj++;
	}
	if(PFC[j].kA == 1 || PFC[j].kA == 4){
	  ss	+=BRcC[i][j]*PFC[j].I;
	}
      }
      for(j=0; j < nVVC; j++){
	if(VVC[j].kA == 2 || VVC[j].kA == 3){
	  lAA[ii][jj]	=BRcS[i][j];
	  lAA[jj][ii]	=lAA[ii][jj];
	  jj++;
	}
	if(VVC[j].kA == 1 || VVC[j].kA == 4){
	  ss	+=BRcS[i][j]*VVC[j].I;
	}
      }
      for(k=0; k < PFCnK; k++){
	s	=0.;
	for(j=0; j < EGNp; j++){
	  if(EGkAp[j]){
	    s	+=BRcp[i][j]*EGgf[k][j];
	  }
	}
	lAA[ii][jj]	=s;
	lAA[jj][ii]	=s;
	jj++;
      }
      for(j=0; j < EGNp; j++){
	if(EGkAp[j]){
	  ss	+=BRcp[i][j]*EGaIp[j];
	}
      }
      FA[ii++]	=-ss;
      jj	=0;
      ss	=0.;
      for(j=1; j < nPFC; j++){
	if(PFC[j].kA == 2 || PFC[j].kA == 3){
	  lAA[ii][jj]	=BZcC[i][j];
	  lAA[jj][ii]	=lAA[ii][jj];
	  jj++;
	}
	if(PFC[j].kA == 1 || PFC[j].kA == 4){
	  ss	+=BZcC[i][j]*PFC[j].I;
	}
      }
      for(j=0; j < nVVC; j++){
	if(VVC[j].kA == 2 || VVC[j].kA == 3){
	  lAA[ii][jj]	=BZcS[i][j];
	  lAA[jj][ii]	=lAA[ii][jj];
	  jj++;
	}
	if(VVC[j].kA == 1 || VVC[j].kA == 4){
	  ss	+=BZcS[i][j]*VVC[j].I;
	}
      }
      for(k=0; k < PFCnK; k++){
	s	=0.;
	for(j=0; j < EGNp; j++){
	  if(EGkAp[j]){
	    s	+=BZcp[i][j]*EGgf[k][j];
	  }
	}
	lAA[ii][jj]	=s;
	lAA[jj][ii]	=s;
	jj++;
      }
      for(j=0; j < EGNp; j++){
	if(EGkAp[j]){
	  ss	+=BZcp[i][j]*EGaIp[j];
	}
      }
      FA[ii++]	=-ss;
    }
  }

  if(PFCnB){
    double *l1,*l0;
    for(i=0; i < 12; i++){
      if(CNTP[i].kA == 1 || CNTP[i].kA == 4){
	jj	=0;
	ss	=0.;
	for(j=1; j < nPFC; j++){
	  if(PFC[j].kA == 2 || PFC[j].kA == 3){
	    lAA[ii][jj]	=gYcC[i][j];
	    jj++;
	  }
	  if(PFC[j].kA == 1 || PFC[j].kA == 4){
	    ss	+=gYcC[i][j]*PFC[j].I;
	  }
	}
	for(j=0; j < nVVC; j++){
	  if(VVC[j].kA == 2 || VVC[j].kA == 3){
	    lAA[ii][jj]	=gYcS[i][j];
	    jj++;
	  }
	  if(VVC[j].kA == 1 || VVC[j].kA == 4){
	    ss	+=gYcS[i][j]*VVC[j].I;
	  }
	}
	FAi[ii]	=ss;
	for(k=0; k < PFCnK; k++){
	  s	=0.;
	  for(j=0; j < EGNp; j++){
	    if(EGkAp[j]){
	      s	+=gYcp[i][j]*EGgf[k][j];
	    }
	  }
	  lAA[ii][jj++]	=s;
	}
	ss	=0.;
	for(j=0; j < EGNp; j++){
	  if(EGkAp[j]){
	    ss	+=gYcp[i][j]*EGaIp[j];
	  }
	}
	FAp[ii]	=ss;
	FA[ii]	=-FAp[ii]-FAi[ii];
	ii++;
      }
    }
    i	=ii-PFCnB;
    ii--;
    l0	=lAA[ii];
    jj	=J+PFCnK;
    while(i < ii){
      l1	=lAA[i];
      for(j=0; j < jj; j++){
	l1[j]	-=l0[j];
      }
      FA[i++]	-=FA[ii];
    }
    n--;
  }
  ii	=J+PFCnK;
  for(i=ii; i < n; i++){
    for(j=0; j < ii; j++){
      lAA[j][i]	=lAA[i][j];
    }
    for(j=ii; j < n; j++){
      lAA[i][j]	=0.;
    }
  }
#ifdef H
  printf("====================\n");
  out("sd","wIp",PFC[0].wI);
  for(k=0; k < PFCnK; k++){
    out("sid","wrP",k,PFwrP[k/2]);
  }
  for(i=0; i < n; i++){
    for(j=0; j < n; j++){
      printf("%10.3e",lAA[i][j]);
    }
    putchar('\n');
  }
  printf("FA====================\n");
  for(i=0; i < n; i++){
    printf("%10.3e",FA[i]);
  }
  putchar('\n');

  j	=0;
  for(i=1; i < nPFC; i++){
    if(PFC[i].kA == 2 || PFC[i].kA == 3){
      FAs[j++]	=PFC[i].I;
    }
  }
  for(k=0; k < PFCnK; k++){
    FAs[j++]	=0.;
  }
  k	=0;
  while(j < n){
    FAs[j++]	=gL[k];
  }

  for(i=0; i < n; i++){
    s	=0.;
    for(j=0; j < n; j++){
      s	+=lAA[i][j]*FAs[j];
    }
    out("siddd","RHS",i,FA[i],s,FA[i]-s);
  }
#endif
  LUdcmp(AA,n,iAA,&s);
  LUbksb(AA,n,iAA,FA);
  j	=0;
  for(i=1; i < nPFC; i++){
    if(PFC[i].kA == 2 || PFC[i].kA == 3){
      PFC[i].I	=FA[j++];
    }
  }
  for(i=0; i < nVVC; i++){
    if(VVC[i].kA == 2 || VVC[i].kA == 3){
      VVC[i].I	=FA[j++];
    }
  }
  for(k=0; k < PFCnK; k++){
    s	=FA[j++];
    EGcgf[k]	*=s;
    for(i=0; i < EGNp; i++){
      if(EGkAp[i]){
	EGaIp[i]	+=s*EGgf[k][i];
      }
    }
  }	
  k	=0;
  while(j < n){
    gL[k]	=FA[j++];
  }
  return(0);
}

int PFCSolvMatrEq2(double wL,double wB,double wI,double wV,double wF)
{
  iItr	=0;
  do{
    if(FlBlockIter){
      int i;
      for(i=0; i < EGNp;  i++){
	if(EGkAp[i]){
	  EGaIp[i]	=EGdIp[i];
	}
      }
    }
    else{
      PFSetGridAct();
      PFCgY2Ip();
    }
    PFCgY2BasicFuncIp();
    PFCInvEqMatr2(wL,wB,wI,wV,wF);
    PFaIp2gY(&err);
    iItr++;
  }while(iItr < nItr && err > 0.001);
  out("sid","Err",iItr,err);
  return(0);
}

int PFCInvEqMatr5(double wL,double wB,double wI,double wV,double wF
		  ,int M,int N,double **U)
{
  int i,ii,j,jj,k,n,J;
  double s,ss,w;
  double Igf[42],aNorm;
  double *F;

  J	=PFCnF+PFCnO;
  n	=PFCnB+PFCnY+2*PFCnX+N;
  F	=U[M];

  if(PFInitAA(n)){
    return(1);
  }
  k	=PFCnB ? n-1 : n;
  for(i=0; i < n; i++){
    lAA[i]	=AA+i*k;
  }
  ii	=0;
  for(i=1; i < nPFC; i++){
    if(PFC[i].kA == 2 || PFC[i].kA == 3){
      for(j=0; j < N; j++){
	U[ii][j]	=0.;
      }
      w		=wI*PFC[i].wI;
      U[ii][ii]	=w;
      F[ii]	=w*PFC[i].I0;
      ii++;
    }
  }
  for(i=0; i < nVVC; i++){
    if(VVC[i].kA == 2 || VVC[i].kA == 3){
      for(j=0; j < N; j++){
	U[ii][j]	=0.;
      }
      w		=wV*VVC[i].wI;
      U[ii][ii]	=w;
      F[ii]	=w*VVC[i].I0;
      ii++;
    }
  }
  if(PFCnK){
    for(i=0; i < PFCnK; i++){
      s	=0.;
      for(j=0; j < EGNp; j++){
	if(EGkAp[j]){
	  s	+=EGgf[i][j];
	}
      }
      Igf[i]	=s;
    }
    aNorm	=fabs(Igf[0]) > 1e-6 ? 1./Igf[0] : 1.;
    for(k=0; k < PFCnK; k++){
      for(j=0; j < N; j++){
	U[ii][j]	=0.;
      }
      U[ii][ii]	=wF*aNorm*PFC[0].wI*sqrt(PFwrP[k/2]);
      F[ii]	=0.;
      ii++;
    }
    for(jj=0; jj < J; jj++){
      U[ii][jj]	=0.;
    }
    w	=wI*PFC[0].wI;
    for(j=0; j < PFCnK; j++){
      U[ii][jj]	=w*Igf[j];
      jj++;
    }
    F[ii]	=0.;
    ii++;
  }
  for(i=0; i < nMFP; i++){
    if(MFP[i].kA){
      w		=i < nMFLS ? wL*MFP[i].w : wB*MFP[i].w;
      ss	=0;
      for(j=0; j < EGNp; j++){
	if(EGkAp[j]){
	  ss	+=gYip[i][j]*EGaIp[j];
	}
      }
      jj	=0;
      for(j=1; j < nPFC; j++){
	if(PFC[j].kA == 2 || PFC[j].kA == 3){
	  U[ii][jj]	=w*gYiC[i][j];
	  jj++;
	}
	if(PFC[j].kA == 1 || PFC[j].kA == 4){
	  ss	+=gYiC[i][j]*PFC[j].I;
	}
      }
      for(j=0; j < nVVC; j++){
	if(VVC[j].kA == 2 || VVC[j].kA == 3){
	  U[ii][jj]	=w*gYiS[i][j];
	  jj++;
	}
	if(VVC[j].kA == 1 || VVC[j].kA == 4){
	  ss	+=gYiS[i][j]*VVC[j].I;
	}
      }
      for(k=0; k < PFCnK; k++){
	s	=0.;
	for(j=0; j < EGNp; j++){
	  if(EGkAp[j]){
	    s	+=gYip[i][j]*EGgf[k][j];
	  }
	}
	U[ii][jj]	=w*s;
	jj++;
      }
      F[ii]	=w*(MFP[i].S0-ss);
      ii++;
    }
  }
  for(i=0; i < N; i++){
    for(j=i; j < N; j++){
      s	=0.;
      for(k=0; k < M; k++){
	s	+=U[k][i]*U[k][j];
      }
      lAA[i][j]	=s;
      lAA[j][i]	=s;
    }
    s	=0.;
    for(k=0; k < M; k++){
      s	+=U[k][i]*F[k];
    }
    FA[i]	=s;
  }

  ii	=N;
  for(i=0; i < 12; i++){
    if(CNTP[i].kA == 2){
      jj	=0;
      ss	=0;
      for(j=1; j < nPFC; j++){
	if(PFC[j].kA == 2 || PFC[j].kA == 3){
	  lAA[ii][jj]	=gYcC[i][j];
	  lAA[jj][ii]	=lAA[ii][jj];
	  jj++;
	}
	if(PFC[j].kA == 1 || PFC[j].kA == 4){
	  ss	+=gYcC[i][j]*PFC[j].I;
	}
      }
      for(j=0; j < nVVC; j++){
	if(VVC[j].kA == 2 || VVC[j].kA == 3){
	  lAA[ii][jj]	=gYcS[i][j];
	  lAA[jj][ii]	=lAA[ii][jj];
	  jj++;
	}
	if(VVC[j].kA == 1 || VVC[j].kA == 4){
	  ss	+=gYcS[i][j]*VVC[j].I;
	}
      }
      for(k=0; k < PFCnK; k++){
	s	=0.;
	for(j=0; j < EGNp; j++){
	  if(EGkAp[j]){
	    s	+=gYcp[i][j]*EGgf[k][j];
	  }
	}
	lAA[ii][jj]	=s;
	lAA[jj][ii]	=s;
	jj++;
      }
      for(j=0; j < EGNp; j++){
	if(EGkAp[j]){
	  ss	+=gYip[i][j]*EGaIp[j];
	}
      }
      FA[ii++]	=CNTP[i].gY-ss;
    }
    if(CNTP[i].kA == 3 || CNTP[i].kA == 4){
      jj	=0;
      ss	=0.;
      for(j=1; j < nPFC; j++){
	if(PFC[j].kA == 2 || PFC[j].kA == 3){
	  lAA[ii][jj]	=BRcC[i][j];
	  lAA[jj][ii]	=lAA[ii][jj];
	  jj++;
	}
	if(PFC[j].kA == 1 || PFC[j].kA == 4){
	  ss	+=BRcC[i][j]*PFC[j].I;
	}
      }
      for(j=0; j < nVVC; j++){
	if(VVC[j].kA == 2 || VVC[j].kA == 3){
	  lAA[ii][jj]	=BRcS[i][j];
	  lAA[jj][ii]	=lAA[ii][jj];
	  jj++;
	}
	if(VVC[j].kA == 1 || VVC[j].kA == 4){
	  ss	+=BRcS[i][j]*VVC[j].I;
	}
      }
      for(k=0; k < PFCnK; k++){
	s	=0.;
	for(j=0; j < EGNp; j++){
	  if(EGkAp[j]){
	    s	+=BRcp[i][j]*EGgf[k][j];
	  }
	}
	lAA[ii][jj]	=s;
	lAA[jj][ii]	=s;
	jj++;
      }
      for(j=0; j < EGNp; j++){
	if(EGkAp[j]){
	  ss	+=BRcp[i][j]*EGaIp[j];
	}
      }
      FA[ii++]	=-ss;
      jj	=0;
      ss	=0.;
      for(j=1; j < nPFC; j++){
	if(PFC[j].kA == 2 || PFC[j].kA == 3){
	  lAA[ii][jj]	=BZcC[i][j];
	  lAA[jj][ii]	=lAA[ii][jj];
	  jj++;
	}
	if(PFC[j].kA == 1 || PFC[j].kA == 4){
	  ss	+=BZcC[i][j]*PFC[j].I;
	}
      }
      for(j=0; j < nVVC; j++){
	if(VVC[j].kA == 2 || VVC[j].kA == 3){
	  lAA[ii][jj]	=BZcS[i][j];
	  lAA[jj][ii]	=lAA[ii][jj];
	  jj++;
	}
	if(VVC[j].kA == 1 || VVC[j].kA == 4){
	  ss	+=BZcS[i][j]*VVC[j].I;
	}
      }
      for(k=0; k < PFCnK; k++){
	s	=0.;
	for(j=0; j < EGNp; j++){
	  if(EGkAp[j]){
	    s	+=BZcp[i][j]*EGgf[k][j];
	  }
	}
	lAA[ii][jj]	=s;
	lAA[jj][ii]	=s;
	jj++;
      }
      for(j=0; j < EGNp; j++){
	if(EGkAp[j]){
	  ss	+=BZcp[i][j]*EGaIp[j];
	}
      }
      FA[ii++]	=-ss;
    }
  }

  if(PFCnB){
    double *l1,*l0;
    for(i=0; i < 12; i++){
      if(CNTP[i].kA == 1 || CNTP[i].kA == 4){
	jj	=0;
	ss	=0.;
	for(j=1; j < nPFC; j++){
	  if(PFC[j].kA == 2 || PFC[j].kA == 3){
	    lAA[ii][jj]	=gYcC[i][j];
	    jj++;
	  }
	  if(PFC[j].kA == 1 || PFC[j].kA == 4){
	    ss	+=gYcC[i][j]*PFC[j].I;
	  }
	}
	for(j=0; j < nVVC; j++){
	  if(VVC[j].kA == 2 || VVC[j].kA == 3){
	    lAA[ii][jj]	=gYcS[i][j];
	    jj++;
	  }
	  if(VVC[j].kA == 1 || VVC[j].kA == 4){
	    ss	+=gYcS[i][j]*VVC[j].I;
	  }
	}
	FAi[ii]	=ss;
	for(k=0; k < PFCnK; k++){
	  s	=0.;
	  for(j=0; j < EGNp; j++){
	    if(EGkAp[j]){
	      s	+=gYcp[i][j]*EGgf[k][j];
	    }
	  }
	  lAA[ii][jj++]	=s;
	}
	ss	=0.;
	for(j=0; j < EGNp; j++){
	  if(EGkAp[j]){
	    ss	+=gYcp[i][j]*EGaIp[j];
	  }
	}
	FAp[ii]	=ss;
	FA[ii]	=-FAp[ii]-FAi[ii];
	ii++;
      }
    }
    i	=ii-PFCnB;
    ii--;
    l0	=lAA[ii];
    jj	=J+PFCnK;
    while(i < ii){
      l1	=lAA[i];
      for(j=0; j < jj; j++){
	l1[j]	-=l0[j];
      }
      FA[i++]	-=FA[ii];
    }
    n--;
  }
  ii	=J+PFCnK;
  for(i=ii; i < n; i++){
    for(j=0; j < ii; j++){
      lAA[j][i]	=lAA[i][j];
    }
    for(j=ii; j < n; j++){
      lAA[i][j]	=0.;
    }
  }
#ifdef H
  printf("====================\n");
  out("sd","wIp",PFC[0].wI);
  for(k=0; k < PFCnK; k++){
    out("sid","wrP",k,PFwrP[k/2]);
  }
  for(i=0; i < n; i++){
    for(j=0; j < n; j++){
      printf("%10.3e",lAA[i][j]);
    }
    putchar('\n');
  }
  printf("FA====================\n");
  for(i=0; i < n; i++){
    printf("%10.3e",FA[i]);
  }
  putchar('\n');

  j	=0;
  for(i=1; i < nPFC; i++){
    if(PFC[i].kA == 2 || PFC[i].kA == 3){
      FAs[j++]	=PFC[i].I;
    }
  }
  for(k=0; k < PFCnK; k++){
    FAs[j++]	=0.;
  }
  k	=0;
  while(j < n){
    FAs[j++]	=gL[k];
  }

  for(i=0; i < n; i++){
    s	=0.;
    for(j=0; j < n; j++){
      s	+=lAA[i][j]*FAs[j];
    }
    out("siddd","RHS",i,FA[i],s,FA[i]-s);
  }
#endif
  LUdcmp(AA,n,iAA,&s);
  LUbksb(AA,n,iAA,FA);
  j	=0;
  for(i=1; i < nPFC; i++){
    if(PFC[i].kA == 2 || PFC[i].kA == 3){
      PFC[i].I	=FA[j++];
    }
  }
  for(i=0; i < nVVC; i++){
    if(VVC[i].kA == 2 || VVC[i].kA == 3){
      VVC[i].I	=FA[j++];
    }
  }
  for(k=0; k < PFCnK; k++){
    s	=FA[j++];
    EGcgf[k]	*=s;
    for(i=0; i < EGNp; i++){
      if(EGkAp[i]){
	EGaIp[i]	+=s*EGgf[k][i];
      }
    }
  }	
  return(0);
}

int PFCSolvMatrEq5(double wL,double wB,double wI,double wV,double wF)
{

  int i,j,M,N;
  double **U;

  N	=PFCnK+PFCnF+PFCnO;
  M	=PFCnF+PFCnO;
  if(PFCnK){
    M	+=PFCnK+1;
  }
  for(i=0; i < nMFP; i++){
    if(MFP[i].kA){
      M++;
    }
  }
  U	=(double **)malloc((M+1)*sizeof(double*));
  if(U == NULL){
    printf("No %d memory for U in PFCSolvMatrEq5()\n",M);
    return(1);
  }
  for(i=0; i < M; i++){
    U[i]	=(double*)malloc(N*sizeof(double));
    if(U[i] == NULL){
      printf("No %d memory for U[%d] in PFCSolvMatrEq5()\n",N,i);
      while(i){
	i--;
	free(U[i]);
      }
      free(U);
      return(1);
    }
  }
  U[i]	=(double*)malloc(M*sizeof(double));
  if(U[i] == NULL){
    printf("No %d memory for U[%d] in PFCSolvMatrEq5()\n",M,i);
    while(i){
      i--;
      free(U[i]);
    }
    free(U);
    return(1);
  }
  
  iItr	=0;
  do{
    if(FlBlockIter){
      int i;
      for(i=0; i < EGNp;  i++){
	if(EGkAp[i]){
	  EGaIp[i]	=EGdIp[i];
	}
      }
    }
    else{
      PFSetGridAct();
      PFCgY2Ip();
    }
    PFCgY2BasicFuncIp();
    PFCInvEqMatr5(wL,wB,wI,wV,wF,M,N,U);
    PFaIp2gY(&err);
    iItr++;
  }while(iItr < nItr && err > 0.001);
  out("sid","Err",iItr,err);
  i	=M+1;
  while(i){
    i--;
    free(U[i]);
  }
  free(U);
  return(0);
}
#endif

#ifndef stg_EqCHI

int CHISetJsJp()
{
  int i;
  for(i=0; i < ESNa1; i++){
    Js[i]	=1.;
    Js2a[i]	=0;
    Jp[i]	=0.;
    Jp2a[i]	=0.;
  }
  return(0);
}

int CHIUpDateJsJp()
{
  int i,k,kp;
  double Y[ESNa1],d2Y[ESNa1],Y0[ESNa1],d2Y0[ESNa1];

  PFGetBasicFunctionsJ(Y0,d2Y0,nKj);
  for(k=0; k < nKj; k++){
    PFGetBasicFunctionsJ(Y,d2Y,k);
    for(i=0; i < ESNa1; i++){
      Js[i]	+=EGcgf[k]*(Y[i]+EGcgf0[k]*Y0[i]);
      Js2a[i]	+=EGcgf[k]*(d2Y[i]+EGcgf0[k]*d2Y0[i]);
    }
    EGcgf[k]	=0.;
    EGcgf0[k]	=0.;
  }
  return(0);
}

int CHIaIp2gY(double *Err)
{
  int i,j,k,ki,j1,j2,na,np;
  double gY,dY,gYL0,gYL1;
  double Dr,Dz,dr,dz;
  double gYr,gYrr,gYz,gYzz,gYrz;

  Dr	=1./EGdr;
  Dz	=1./EGdz;
  *Err	=0.;
  for(i=0; i < EGNp; i++){
    gY	=0.;
    for(j=0; j < EGNp; j++){
      if (EGkAp[j]) gY +=gYpp[i][j]*EGaIp[j];
    }
    for(j=1; j < nPFC; j++) if(PFC[j].kA) gY+=gYpC[i][j]*PFC[j].I;
    for(j=0; j < nVVC; j++){
      if(VVC[j].kA) gY +=gYpS[i][j]*VVC[j].I;
    }
    dY	=fabs(gY-EGgYp[i]);
    if(*Err < dY) *Err=dY;
    EGgYe[i]	=gY;
    EGgYp[i]	=gY;
  }

  gYEl0mn	=1e+20;
  gYEl0mx	=-1e+20;
  for(k=0; k < nEl0; k++){
    i	=kEl0[k];
    j	=iGrLm[i];
    j1	=j-1;
    j2	=j+1;
    gYrr=(EGgYp[j2]-2.*EGgYp[j]+EGgYp[j1])*Dr*Dr;
    gYr	=cr2*(EGgYp[j2]-EGgYp[j1])*Dr;
    dr	=RGrLm[i]-EGaRp[j];
    if(fabs(ErGrLm[i]) >= EzGrLm[i]) gY=EGgYp[j]+(gYr+cr2*gYrr*dr)*dr;
    gYr	+=gYrr*dr;
    j	=jGrLm[i];
    gYz	=(EGgYp[j]-EGgYp[j-PFB[0].nr])*Dz;
    if(fabs(ErGrLm[i]) < EzGrLm[i]) gY=EGgYp[j]+gYz*(ZGrLm[i]-EGaZp[j]);
    dY	=1./sqrt(gYr*gYr+gYz*gYz);
    gYr	*=dY;
    gYz	*=dY;
    dY	=gYr*ErGrLm[i]+gYz*EzGrLm[i];

    if(k == 0) gYEl0mx=gY;
    if(k == nEl0-1){
      if(gY < gYEl0mx){
	gYEl0mn	=gY;
      }
      else{
	gYEl0mn	=gYEl0mx;
	gYEl0mx	=gY;
      }
    }
#ifdef H
    if(gYEl0mn > gY){
      gYEl0mn	=gY;
    }
    if(gYEl0mx < gY){
      gYEl0mx	=gY;
    }
#endif
  }
  *Err		/=(gYEl0mx-gYEl0mn);
  igYb	=0;
  EGgY0	=0.;
  EGaR0	=EGaRp[0];
  EGaZ0	=EGaZp[0];
  np	=PFB[0].nr;
  na	=PFB[0].nz;
  for(i=1; i < na-1; i++){
    for(j=1; j < np-1; j++){
      EGi0	=np*i+j;
      if(EGkA[EGi0] && EGgYp[EGi0] > EGgYp[EGi0-1]
	 && EGgYp[EGi0] > EGgYp[EGi0+1]
	 && EGgYp[EGi0] > EGgYp[EGi0-np] && EGgYp[EGi0] > EGgYp[EGi0+np]){
	EGgY0	=EGgYp[EGi0];
	j1	=EGi0+1;
	j2	=EGi0-1;
	gYrr	=(EGgYp[j1]-2.*EGgY0+EGgYp[j2])*Dr*Dr;
	gYr	=cr2*(EGgYp[j1]-EGgYp[j2])*Dr;
	j1	=EGi0+np;
	j2	=EGi0-np;
	gYzz	=(EGgYp[j1]-2.*EGgY0+EGgYp[j2])*Dz*Dz;
	gYz	=cr2*(EGgYp[j1]-EGgYp[j2])*Dz;
	gYrz	=cr4*(EGgYp[j1+1]-EGgYp[j1-1]+EGgYp[j2-1]-EGgYp[j2+1])*Dr*Dz;
	dz	=1./(gYrr*gYzz-gYrz*gYrz);
	dr	=(gYrz*gYz-gYzz*gYr)*dz;
	dz	*=gYrz*gYr-gYrr*gYz;
	EGaR0	=EGaRp[EGi0]+dr;
	EGaZ0	=EGaZp[EGi0]+dz;
	EGgY0	+=(gYr+cr2*gYrr*dr)*dr+(gYz+cr2*gYzz*dz+gYrz*dr)*dz;
	igYb	=1;
      }
    }
  }

  EGgYx	=gYEl0mn;
  EGaRx	=EGaRp[0];
  EGaZx	=EGaZp[0];
  for(i=1; i < na-1; i++){
    for(k=1; k < np-1; k++){
      j	=np*i+k;
      j2=j+1;
      j1=j-1;
      if(EGaZp[j] < 0. && EGkA[j] && EGkA[j2] && EGkA[j1] 
	 && EGkA[j+np] && EGkA[j-np]
	 && EGkA[j+np+1] && EGkA[j+np-1]
	 && EGkA[j-np+1] && EGkA[j-np-1]
	 ){
	gY	=EGgYp[j];
	if((gY >= EGgYp[j1] && gY >= EGgYp[j2]) || 
	   (gY < EGgYp[j1] && gY < EGgYp[j2])){
	  gYrr	=(EGgYp[j2]-2.*gY+EGgYp[j1])*Dr*Dr;
	  gYr	=cr2*(EGgYp[j2]-EGgYp[j1])*Dr;
	  j2	=j+np;
	  j1	=j-np;
	  gYzz	=(EGgYp[j2]-2.*gY+EGgYp[j1])*Dz*Dz;
	  gYz	=cr2*(EGgYp[j2]-EGgYp[j1])*Dz;
	  gYrz	=cr4*(EGgYp[j2+1]-EGgYp[j2-1]+EGgYp[j1-1]-EGgYp[j1+1])
	    *Dr*Dz;
	  dz	=gYrr*gYzz-gYrz*gYrz;
	  if(dz < 0.){
	    dz	=1./dz;
	    dr	=(gYrz*gYz-gYzz*gYr)*dz;
	    dz	*=gYrz*gYr-gYrr*gYz;
	    if(fabs(dr) <= EGdr && fabs(dz) <= EGdz){
	      gY	+=(gYr+cr2*gYrr*dr)*dr+(gYz+cr2*gYzz*dz+gYrz*dr)*dz;
	      EGaRx	=EGaRp[j]+dr;
	      EGaZx	=EGaZp[j]+dz;
	      EGgYx	=gY;
	      igYb	|=2;
	    }
	  }
	}
      }
    }
  }
  return(0);
}

void CHILinePlot()
{
  double Bx[2],By[2];
  extern void IbPFIPlot();

  IbPFIPlot();
  ZColor(0);

#ifdef H
  Bx[0]	=PFB[0].R-PFB[0].dR;
  Bx[1]	=PFB[0].R+PFB[0].dR;
  By[0]	=PFB[0].Z-PFB[0].dZ;
  By[1]	=PFB[0].Z+PFB[0].dZ;
  MFLines(Bx,By,CHIr0,CHIz0,n0CHI,NLines,Step);
  MFLines(Bx,By,CHIr1,CHIz1,n1CHI,NLines,Step);
#endif
  PutRectContourPlot(gYEl0mn,gYEl0mx);
  MFLinesInsideRect(NLines);
#ifdef H
  MFLines(Bx,By,RGrLm,ZGrLm,nGrLm,NLines,Step);
#endif
  return;
}

int CHICurrentPlot00()
{
  int i,k,kp;
  double y[ESNa1],y1[ESNa1],Yd[ESNa1],d2Yd[ESNa1],X[2],Y[2];
  double s;

  X[0]	=0.;
  X[1]	=1.;
  for(i=0; i < ESNa1; i++){
    y[i]	=Js[i];
    y1[i]	=Js[i];
  }
  for(k=0; k < nKj; k++){
    PFGetBasicFunctionsJ(Yd,d2Yd,k);
    for(i=0; i < ESNa1; i++){
      y[i]	+=EGcgf[k]*Yd[i];
    }
  }
  if(igYb == 3){
    for(kp=0; kp < nKp; kp++,k++){
      PFGetBasicFunctionsJ(Yd,d2Yd,kp);
      for(i=0; i < ESNa1; i++){
	y1[i]	+=EGcgf[k]*Yd[i];
      }
    }
  }
  Y[0]	=0.;
  Y[1]	=0.;
  for(i=0; i < ESNa1; i++){
    if(Y[0] > y[i]){
      Y[0]	=y[i];
    }
    if(Y[1] < y[i]){
      Y[1]	=y[i];
    }
    if(igYb == 3){
      if(Y[0] > y1[i]){
	Y[0]	=y1[i];
      }
      if(Y[1] < y1[i]){
	Y[1]	=y1[i];
      }
    }
  }
  SetPlotName("a","j CHI","CHI Current density");
  Scale2d(2,X,Y,2,6,2);
  Plot2d(2,ESsa,y,ESNa1,6,0,4,0);
  if(igYb == 3){
    Plot2d(2,ESsa,y1,ESNa1,6,0,14,0);
  }
  return(0);
}

int CHICurrentPlot(double *Xj,double *Yj)
{
  int i,k,kp,n=64,n1=n+1,n2=n+5;
  char *lc;
  double x[n2],y[n2],y1[n2],y2[n2],X[2],Y[2];
  double dx,tx,ty,r1,z1,r2,z2,R1,Z1,R2,Z2;
  int j,j1,j2,ix,iy,nr,nz;
  double Dr,Dz,dr,dz,gY,gYr,gYz,gYrr,gYrz,gYzz;
  double a,f,rdgy;

  R1	=PFB[0].R-PFB[0].dR;
  R2	=PFB[0].R+PFB[0].dR;
  Z1	=PFB[0].Z-PFB[0].dZ;
  Z2	=PFB[0].Z+PFB[0].dZ;
  Dr	=1./EGdr;
  Dz	=1./EGdz;
  tx	=Xj[1]-Xj[0];
  ty	=Yj[1]-Yj[0];
  i	=n2;
  if(fabs(tx) > fabs(ty)){
    lc	="R [m]";
    r1	=R1;
    if(r1 < Xj[0]){
      r1	=Xj[0];
      z1	=Yj[0];
    }
    else{
      z1	=Yj[0]+ty*(r1-Xj[0])/tx;
    }
    r2	=R2; 
    if(r2 > Xj[1]){
      r2	=Xj[1];
      z2	=Yj[1];
    }
    else{
      z2	=Yj[0]+ty*(r2-Xj[0])/tx;
    }
    i--;
    x[i]	=Xj[1];
    y[i]	=0.;
    y1[i]	=0.;
    y2[i]	=0.;
    i--;
    x[i]	=r2;
    y[i]	=0.;
    y1[i]	=0.;
    y2[i]	=0.;
    i	=0;
    x[i]	=Xj[0];
    y[i]	=0.;
    y1[i]	=0.;
    y2[i]	=0.;
    i++;
    x[i]	=r1;
    y[i]	=0.;
    y1[i]	=0.;
    y2[i]	=0.;
    dx	=r2-r1;
  }
  else{
    lc	="Z [m]";
    z1	=Z1;
    if(z1 < Yj[0]){
      r1	=Xj[0];
      z1	=Yj[0];
    }
    else{
      r1	=Xj[0]+tx*(z1-Yj[0])/ty;
    }
    z2	=Z2;
    if(z2 > Yj[1]){
      r2	=Xj[1];
      z2	=Yj[1];
    }
    else{
      r1	=Xj[0]+tx*(z2-Yj[0])/ty;
    }
    i--;
    x[i]	=Yj[1];
    y[i]	=0.;
    y1[i]	=0.;
    y2[i]	=0.;
    i--;
    x[i]	=z2;
    y[i]	=0.;
    y1[i]	=0.;
    y2[i]	=0.;
    i	=0;
    x[i]	=Yj[0];
    y[i]	=0.;
    y1[i]	=0.;
    y2[i]	=0.;
    i++;
    x[i]	=z1;
    y[i]	=0.;
    y1[i]	=0.;
    y2[i]	=0.;
    dx	=z2-z1;
  }
  X[0]	=x[0];
  X[1]	=x[n2-1];
  Y[0]	=0.;
  Y[1]	=0.;
  tx	=(r2-r1)/n;
  ty	=(z2-z1)/n;
  dx	/=n;
  nr	=PFB[0].nr;
  nz	=PFB[0].nz;
  rdgy	=1./(gYEl0mx-gYEl0mn);
  for(k=0; k < n1; k++){
    i++;
    x[i]	=x[1]+dx*k;
    if(R1 <= r1 && r1 <=R2 && Z1 <= z1 && z1 <= Z2){
      ix	=(r1-R1)*Dr;
      iy	=(z1-Z1)*Dz;
      if(ix == 0){
	ix++;
      }
      if(ix == nr-1){
	ix--;
      }
      if(iy == 0){
	iy++;
      }
      if(iy == nz-1){
	iy--;
      }
      j		=nr*iy+ix;
      if(EGkAp[j]){
	dr	=r1-EGaRp[j];
	dz	=z1-EGaZp[j];
	j2	=j+1;
	j1	=j-1;
	gY	=EGgYp[j];
	gYrr	=(EGgYp[j2]-2.*gY+EGgYp[j1])*Dr*Dr;
	gYr	=cr2*(EGgYp[j2]-EGgYp[j1])*Dr;
	j2	=j+nr;
	j1	=j-nr;
	gYzz	=(EGgYp[j2]-2.*gY+EGgYp[j1])*Dz*Dz;
	gYz	=cr2*(EGgYp[j2]-EGgYp[j1])*Dz;
	gYrz	=cr4*(EGgYp[j2+1]-EGgYp[j2-1]+EGgYp[j1-1]-EGgYp[j1+1])*Dr*Dz;
	gY	+=(gYr+cr2*gYrr*dr)*dr+(gYz+cr2*gYzz*dz+gYrz*dr)*dz;
	y1[i]	=0.;
	y2[i]	=0.;
	if(EGkAp[j] == 1){
	  a	=(gYEl0mx-gY)*rdgy;
	  a	=a > 0. ? sqrt(a) : 0.;
	  if(a > 1.){
	    a	=1.;
	  }
	  ESSetSplA(a);
	  splRA(y+i,NULL,Js,Js2a);
	  PFSplRA(&f,NULL,nKj);
	  for(j1=0; j1 < nKj; j1++){
	    PFSplRA(&a,NULL,j1);
	    y1[i]	+=EGcgf[j1]*(a+EGcgf0[j1]*f);
	  }
	  y[i]	+=y1[i];
	}
	if(EGkAp[j] == 2){
	  a	=(gYEl0mx-gY)*rdgy;
	  if(a < 0.){
	    a	=0.;
	  }
	  a	=a < 1. ? sqrt(a) : 1.;
	  ESSetSplA(a);
	  splRA(y+i,NULL,Js,Js2a);
	  PFSplRA(&f,NULL,nKj);
	  for(j1=0; j1 < nKj; j1++){
	    PFSplRA(&a,NULL,j1);
	    y1[i]	+=EGcgf[j1]*(a+EGcgf0[j1]*f);
	  }
	  y[i]	+=y1[i];
	  a	=(EGgY0-gY)/(EGgY0-EGgYx);
	  a	=a > 0. ? sqrt(a) : 0.;
	  PFSplRA(&f,NULL,nKp);
	  for(j2=0; j2 < nKp; j2++,j1++){
	    PFSplRA(&a,NULL,j2);
	    y2[i]	+=EGcgf[j1]*(a+EGcgf0[j1]*f);
	  }
	  y[i]	+=y2[i];
	}
	a	=EGaR0/r1;
	y[i]	*=a;
	y1[i]	*=a;
	y2[i]	*=a;
	if(Y[0] > y[i]){
	  Y[0]	=y[i];
	}
	if(Y[0] > y1[i]){
	  Y[0]	=y1[i];
	}
	if(Y[0] > y2[i]){
	  Y[0]	=y2[i];
	}
	if(Y[1] < y[i]){
	  Y[1]	=y[i];
	}
	if(Y[1] < y1[i]){
	  Y[1]	=y1[i];
	}
	if(Y[1] < y2[i]){
	  Y[1]	=y2[i];
	}
      }
      else{
	y[i]	=0.;
	y1[i]	=0.;
	y2[i]	=0.;
      }
    }
    else{
      y[i]	=0;
      y1[i]	=0.;
      y2[i]	=0.;
    }
    r1	+=tx;
    z1	+=ty;
  }
  SetPlotName(lc,"j CHI [MA/m^2]","CHI Current density");
  Scale2d(6,X,Y,2,6,2);
  Plot2d(6,x,y,n2,6,0,0,0);
  Plot2d(6,x,y1,n2,6,0,14,0);
  Plot2d(6,x,y2,n2,6,0,9,0);
  return(0);
}

int CHISetGridAct()
{
  int i;
  double rdgy;

  rdgy	=1./(gYEl0mx-gYEl0mn);
  for(i=0; i < EGNp;  i++){
    if(EGkA[i] && EGaZp[i] <ZUp && EGgYp[i] >= gYEl0mn && EGgYp[i] <= gYEl0mx){
      EGkAp[i]	=1;
      EGsa[i]	=sqrt((gYEl0mx-EGgYp[i])*rdgy);
    }
    else{
      EGkAp[i]	=0;
      EGsa[i]	=1.;
    }
  }
  if(igYb != 3){
    return(0);
  }
  rdgy	=1./(EGgY0-EGgYx);
  for(i=0; i < EGNp;  i++){
    if(EGkA[i] && EGaZp[i] > EGaZx && EGgYp[i] >= EGgYx && EGgYp[i] <= EGgY0){
      EGkAp[i]	=2;
      EGsa[i]	=sqrt((EGgY0-EGgYp[i])*rdgy);
    }
  }

  return(0);
}

int CHIgY2BasicFuncIp()
{
  int i,k,kp,k0,k1;
  double a,s,rR,rdgy;

  k0	=nKj+nKp;
  k1	=k0+1;
  for(k=0; k <= nKj; k++){
    EGcgf0[k]	=0.;
  }
  for(i=0; i < EGNp;  i++){
    if(EGkAp[i] == 1){
      rR	=EGdS*EGaR0/EGaRp[i];
      ESSetSplA(EGsa[i]);
      for(k=0; k < nKj; k++){
	PFSplRA(&s,NULL,k);
	EGgf[k][i]	=s*rR;
	EGcgf0[k]	+=EGgf[k][i];
      }
      PFSplRA(&s,NULL,nKj);
      EGgf[k0][i]	=s*rR;
      EGcgf0[nKj]	+=EGgf[k0][i];
    }
  }
  if(igYb == 3){
    for(k=0; k <= nKp; k++){
      EGcgf[k]	=0.;
    }
    rdgy	=1./(gYEl0mx-gYEl0mn);
    for(i=0; i < EGNp;  i++){
      if(EGkAp[i] == 1){
	k	=nKj;
	for(kp=0; kp < nKp; kp++){
	  EGgf[k++][i]	=0.;
	}
      }
      if(EGkAp[i] == 2){
	rR	=EGdS*EGaR0/EGaRp[i];
	a	=(gYEl0mx-EGgYp[i])*rdgy;
	if(a < 0.){
	  a	=0.;
	}
	a	=a < 1. ? sqrt(a) : 1.;
	ESSetSplA(a);
	for(k=0; k <= nKj; k++){
	  PFSplRA(&s,NULL,k);
	  EGgf[k][i]	=s*rR;
	  EGcgf0[k]	+=EGgf[k][i];
	}
	PFSplRA(&s,NULL,nKj);
	EGgf[k0][i]	=s*rR;
	EGcgf0[k]	+=EGgf[k0][i];

	ESSetSplA(EGsa[i]);
	k	=nKj;
	for(kp=0; kp < nKp; kp++){
	  PFSplRA(&s,NULL,kp);
	  EGgf[k][i]	=s*rR;
	  EGcgf[kp]	+=EGgf[k][i];
	  k++;
	}
	PFSplRA(&s,NULL,nKp);
	EGgf[k1][i]	=s*rR;
	EGcgf[nKp]	+=EGgf[k1][i];
      }
    }
  }
  s	=-1./EGcgf0[nKj];
  for(k=0; k < nKj; k++){
    EGcgf0[k]	*=s;
  }
  for(i=0; i < EGNp;  i++){
    if(EGkAp[i] == 1){
      for(k=0; k < nKj; k++){
	EGgf[k][i]	+=EGcgf0[k]*EGgf[k0][i];
      }
    }
  }
  if(igYb == 3){
    rdgy	=1./(gYEl0mx-gYEl0mn);
    s	=-1./EGcgf[nKp];
    for(kp=0; kp < nKp; kp++){
      EGcgf[kp]	*=s;
    }
    for(i=0; i < EGNp;  i++){
      if(EGkAp[i] == 2){
	for(k=0; k < nKj; k++){
	  EGgf[k][i]	+=EGcgf0[k]*EGgf[k0][i];
	}
	for(kp=0; kp < nKp; kp++){
	  EGgf[k++][i]	+=EGcgf[kp]*EGgf[k1][i];
	}
      }
    }
    k	=nKj;
    for(kp=0; kp < nKp; kp++){
      EGcgf0[k++]	=EGcgf[kp];
    }
  }
  return(0);
}

int CHIgY2Ip()
{
  int i,k;
  double a,s,Ip,rdgy;

  EGaR0	=PFB[0].R;
  EGaZ0	=PFB[0].Z;
  Ip	=0.;
  for(i=0; i < EGNp;  i++){
    if(EGkAp[i] == 1){
      ESSetSplA(EGsa[i]);
      splRA(EGjs+i,NULL,Js,Js2a);
      EGjs[i]	*=EGaR0/EGaRp[i];
      EGaIp[i]	=EGjs[i]*EGdS;
      Ip	+=EGaIp[i];
    }
  }
  if(igYb == 3){
    rdgy	=1./(gYEl0mx-gYEl0mn);
    for(i=0; i < EGNp;  i++){
      if(EGkAp[i] == 2){
	a	=(gYEl0mx-EGgYp[i])*rdgy;
	if(a < 0.){
	  a	=0.;
	}
	a	=a < 1. ? sqrt(a) : 1.;
	ESSetSplA(a);
	splRA(EGjs+i,NULL,Js,Js2a);
	EGjs[i]	*=EGaR0/EGaRp[i];
	EGaIp[i]=EGjs[i]*EGdS;
	Ip	+=EGaIp[i];
      }
    }
  }

  Inorm	=PFC[0].I0/Ip;
  for(i=0; i < ESNa1;  i++){
    Js[i]	*=Inorm;
    Js2a[i]	*=Inorm;
    Jp[i]	*=Inorm;
    Jp2a[i]	*=Inorm;
  }
  for(i=0; i < EGNp;  i++){
    if(EGkAp[i]){
      EGjs[i]	*=Inorm;
      EGaIp[i]	*=Inorm;
    }
  }
  return(0);
}

int CHIMakeSVD(double wL,double wB,double wI,double wV,double wF
	       ,int M,int N,double **U,double **V)
{
  int i,ii,j,jj,k,n;
  double w,s,ss;
  double *F,*S,*W,*T;

  W	=V[N];
  S	=V[N+1];
  T	=V[N+2];
  F	=V[N+3];
  ii	=0;

  for(i=1; i < nPFC; i++){
    if(PFC[i].kA == 2 || PFC[i].kA == 3){
      for(j=0; j < N; j++){
	U[ii][j]	=0.;
      }
      w		=wI*PFC[i].wI;
      U[ii][ii]	=w;
      F[ii]	=w*PFC[i].I0;
      ii++;
    }
  }
  for(i=0; i < nVVC; i++){
    if(VVC[i].kA == 2 || VVC[i].kA == 3){
      for(j=0; j < N; j++){
	U[ii][j]	=0.;
      }
      w		=wV*VVC[i].wI;
      U[ii][ii]	=w;
      F[ii]	=w*VVC[i].I0;
      ii++;
    }
  }
  if(PFCnK){
    if(SVDFl){
      double Y[PFCnK+1],Y2[PFCnK+1];
      for(i=0; i < ESNa1; i++){
	jj	=PFCnF+PFCnO;
	for(j=0; j < jj; j++){
	  U[ii][j]	=0.;
	}
	PFGetBasicFSetAtPoint(Y,Y2,i,nKj+1);
	s	=Y2[nKj];
	for(k=0; k < nKj; k++){
	  U[ii][j]	=wF*(Y2[k]+EGcgf0[k]*s);
	  j++;
	}
	if(igYb == 3 && k < PFCnK){
	  if(nKp > nKj){
	    PFGetBasicFSetAtPoint(Y,Y2,i,nKp+1);
	  }
	  s	=Y2[nKp];
	  jj	=0;
	  for(k=nKj; k < PFCnK; k++){
	    U[ii][j++]	=40*wF*(Y2[jj]+EGcgf0[k]*s);
	    jj++;
	  }
	}
	for(; j < N; j++){
	  U[ii][j]	=0.;
	}
	F[ii]	=-wF*Js2a[i];
	ii++;
      }
    }
    else{
      for(k=0; k < PFCnK; k++){
	for(j=0; j < N; j++){
	  U[ii][j]	=0.;
	}
	U[ii][ii]	=k < nKj ? 40.*wF*PFwrP[k] : 40.*wF*PFwrP[k-nKj];
	F[ii]	=0.;
	ii++;
      }
    }
  }
  for(i=0; i < nMFP; i++){
    if(MFP[i].kA){
      w		=i < nMFLS ? wL*MFP[i].w : wB*MFP[i].w;
      ss	=0;
      for(j=0; j < EGNp; j++){
	if(EGkAp[j]){
	  ss	+=gYip[i][j]*EGaIp[j];
	}
      }
      jj	=0;
      for(j=1; j < nPFC; j++){
	if(PFC[j].kA == 2 || PFC[j].kA == 3){
	  U[ii][jj]	=w*gYiC[i][j];
	  jj++;
	}
	if(PFC[j].kA == 1 || PFC[j].kA == 4){
	  ss	+=gYiC[i][j]*PFC[j].I;
	}
      }
      for(j=0; j < nVVC; j++){
	if(VVC[j].kA == 2 || VVC[j].kA == 3){
	  U[ii][jj]	=w*gYiS[i][j];
	  jj++;
	}
	if(VVC[j].kA == 1 || VVC[j].kA == 4){
	  ss	+=gYiS[i][j]*VVC[j].I;
	}
      }
      for(k=0; k < PFCnK; k++){
	s	=0.;
	for(j=0; j < EGNp; j++){
	  if(EGkAp[j]){
	    s	+=gYip[i][j]*EGgf[k][j];
	  }
	}
	U[ii][jj]	=w*s;
	jj++;
      }
      F[ii]	=w*(MFP[i].S0-ss);
      ii++;
    }
  }
  SVDcmp(M,N,U,V,W,T);
  s	=0.;
  for(i=0; i < N; i++){
    T[i]	=W[i];
    if(s < W[i]){
      s	=W[i];
    }
  }
  SVDsort(N,T);

  s	=1./s;
  EignV[0]=T[0]*s;
  EignV[1]=T[1]*s;
  for(i=0; i < N; i++){
    if(W[i]*s < tSVD){
      W[i]	=0.;
    }
  }
  SVDbksb(M,N,U,V,W,F,S,T);

  j	=0;
  for(i=1; i < nPFC; i++){
    if(PFC[i].kA == 2 || PFC[i].kA == 3){
      PFC[i].I	=S[j++];
    }
  }
  for(i=0; i < nVVC; i++){
    if(VVC[i].kA == 2 || VVC[i].kA == 3){
      VVC[i].I	=S[j++];
    }
  }
  for(k=0; k < PFCnK; k++){
    s	=S[j++];
    EGcgf[k]	=s;
    for(i=0; i < EGNp; i++){
      if(EGkAp[i]){
	EGaIp[i]	+=s*EGgf[k][i];
      }
    }
  }	
  s	=0.;	
  for(i=0; i < EGNp; i++){
    if(EGkAp[i]){
      s	+=EGaIp[i];
      EGdIp[i]	=EGaIp[i];
    }
  }
  PFC[0].I	=s;
  return(0);
}

int CHISolvSVD(double wL,double wB,double wI,double wV,double wF)
{
  int i,j,M,N;
  double **U,**V;
  
  N	=PFCnK+PFCnF+PFCnO;
  M	=PFCnF+PFCnO;
  if(PFCnK){
    M	=SVDFl ? M+ESNa1 : M+PFCnK;
  }
  for(i=0; i < nMFP; i++){
    if(MFP[i].kA){
      M++;
    }
  }

  U	=(double **)malloc(M*sizeof(double*));
  if(U == NULL){
    printf("No %d memory for U in CHISolvSVD()\n",M);
    return(1);
  }
  for(i=0; i < M; i++){
    U[i]	=(double*)malloc(N*sizeof(double));
    if(U[i] == NULL){
      printf("No %d memory for U[%d] in CHISolvSVD()\n",N,i);
      while(i){
	i--;
	free(U[i]);
      }
      free(U);
      return(1);
    }
  }
  V	=(double **)malloc((N+4)*sizeof(double*));
  if(V == NULL){
    printf("No %d memory for V in CHISolvSVD()\n",N);
    return(1);
  }
  for(i=0; i < N+3; i++){
    V[i]	=(double*)malloc(N*sizeof(double));
    if(V[i] == NULL){
      printf("No %d memory for V[%d] in CHISolvSVD()\n",N,i);
      while(i){
	i--;
	free(V[i]);
      }
      free(V);
      i	=M;
      while(i){
	i--;
	free(U[i]);
      }
      free(U);
      return(1);
    }
  }
  V[i]	=(double*)malloc(M*sizeof(double));
  if(V[i] == NULL){
    printf("No %d memory for V[%d] in CHISolvSVD()\n",M,i);
    while(i){
      i--;
      free(V[i]);
    }
    free(V);
    i	=M;
    while(i){
      i--;
      free(U[i]);
    }
    free(U);
    return(1);
  }

  iItr	=0;
  do{
    if(FlBlockIter){
      for(i=0; i < EGNp;  i++){
	if(EGkAp[i]){
	  EGaIp[i]	=EGdIp[i];
	}
      }
    }
    else{
      CHISetGridAct();
      CHIgY2Ip();
    } 
    CHIgY2BasicFuncIp();
    CHIMakeSVD(wL,wB,wI,wV,wF,M,N,U,V);
    CHIaIp2gY(&err);
    iItr++;
  }while(iItr < nItr && err > 0.001);
  i	=N+4;
  while(i){
    i--;
    free(V[i]);
  }
  free(V);
  i	=M;
  while(i){
    i--;
    free(U[i]);
  }
  free(U);
  return(0);
}

int CHIEqSol2PF(double wL,double wB,double wI,double wV,double wF)
{
  int i,j,k;
  double gY,gy;
  double dL,L,dB,B,dI,I,dV,V;

  I	=0.;
  for(i=0; i < EGNp; i++){
    if(EGkAp[i]){
      I		+=EGaIp[i];
    }
  }
  PFC[0].I	=I;
  for(i=0; i < nPFB; i++){
    PFB[i].I	=PFB[i].kA ? PFC[PFB[i].kC].I : 0.;
    PFB[i].AI	=PFB[i].I*PFB[i].tn;
    IbPF[i]	=PFB[i].AI;
  }
  for(j=0; j < nVVC; j++,i++){
    IbPF[i]	=VVC[j].I;
  }
  EGwNp	=0;
  for(i=0; i < EGNp; i++){
    if(EGkAp[i]){
      EGwRp[EGwNp]	=EGaRp[i];
      EGwZp[EGwNp]	=EGaZp[i];
      EGwIp[EGwNp++]	=EGaIp[i];
    }
  }
  dI	=0.;
  I	=0.;
  k	=0;
  for(i=0; i < nPFC; i++){
    gY	=PFC[i].I-PFC[i].I0;
    if(PFC[i].kA == 3){
      dI	+=gY*gY*PFC[i].wI*PFC[i].tn*PFC[i].tn;
    }
    I	+=fabs(PFC[i].I0);
    k++;
  }
  dI	*=wI*wI;
  I	/=k;

  dV	=0.;
  V	=0.;
  k	=0;
  for(i=0; i < nVVC; i++){
    gY	=VVC[i].I-VVC[i].I0;
    if(VVC[i].kA == 3){
      dV	+=VVC[i].wI*gY*gY;
    }
    V	+=fabs(VVC[i].I0);
    k++;
  }
  dV	*=wV*wV;
  V	/=k;
#ifdef H
  dI	=sqrt(k*dI)/I;
#endif
  dL	=0.;
  L	=0.;
  k	=0;
  for(i=0; i < nMFLS; i++){
    if(MFP[i].kA){
      gY	=0.;
      for(j=0; j < EGNp; j++){
	if(EGkAp[j]){
	  gY	+=gYip[i][j]*EGaIp[j];
	}
      }
      for(j=1; j < nPFC; j++){
	if(PFC[j].kA){
	  gY	+=gYiC[i][j]*PFC[j].I;
	}
      }
      for(j=0; j < nVVC; j++){
	if(VVC[j].kA){
	  gY	+=gYiS[i][j]*VVC[j].I;
	}
      }
      MFP[i].S	=gY;
      gY	-=MFP[i].S0;
      dL	+=MFP[i].w*gY*gY;
      L		+=fabs(MFP[i].S0);
      k++;
    }
  }
  L	/=k;
  dL	*=wL*wL;
#ifdef H
  dL	=sqrt(k*dL)/L;
#endif
  dB	=0.;
  B	=0.;
  k	=0;
  for(; i < nMFP; i++){
    gY	=0.;
    if(MFP[i].kA){
      for(j=0; j < EGNp; j++){
	if(EGkAp[j]){
	  gY	+=gYip[i][j]*EGaIp[j];
	}
      }
      for(j=1; j < nPFC; j++){
	if(PFC[j].kA){
	  gY	+=gYiC[i][j]*PFC[j].I;
	}
      }
      for(j=0; j < nVVC; j++){
	if(VVC[j].kA){
	  gY	+=gYiS[i][j]*VVC[j].I;
	}
      }
      MFP[i].S	=gY;
      gY	-=MFP[i].S0;
      dB	+=MFP[i].w*gY*gY;
      B		+=fabs(MFP[i].S0);
      k++;
    }
  }
  B	/=k;
  dB	*=wB*wB;
#ifdef H
  dB	=sqrt(k*dB)/B;
#endif
  return(0);
}

int CHIEquil()
{
  static int Fl=12,FlE=0;
  int i,j,k,n,m;

  static double wL=1.,wB=1.,wI=1.,wV=1.,wF=1.,RUp=0.;
  double W,WI,WV,WL,WB;

  int kc[nPEC];
  double R[nPEC],Z[nPEC],I0[nPEC],Ib[nPEC],It[nPEC];
  int Np,Np1,iD[nPEC],Ne;

  double Rp[EGNp],Zp[EGNp],Rp1[EGNp],Zp1[EGNp];
  double Re[128],Ze[128];
  double Xj[2],Yj[2];

  PFBLOCK *lB;
  PSBLOCK *lS;
  PFCOIL *lC;
  static int iF0=0,iF2=0;
  int Next0,Next1,Next2;

  static int kExt=0;
  static char Ext0[16]="00000",Ext1[16]="00000",Ext2[16]="00000";

  if(nFList == 0){
    char *lD,*lN;
    CbGetCurrentCbName(&lD,&lN);
    PFFileListEFIT(lD);
    if(nFList){
      lD	=FListEFIT[0];
      lN	=lD+strlen(lD);
      while(*lN != '.' && lN > lD){
	lN--;
      }
      if(*lN == '.'){
	kExt	=lN-lD+1;
      }
      iFList	=0;
      while(iFList < nFList && strcmp(FListEFIT[iFList]+kExt,kFileExt)){
	iFList++;
      }
      strcpy(Ext1,kFileExt);
    }
  }
  CHISetJsJp();
  PFSetCoilOptIndex();
  for(i=0; i < nPFC; i++){
    k		=PFC[i].kB[0];
    PFC[i].I	=PFC[i].I0;
    Ib[i]	=PFC[i].I*PFB[k].tn;
    kc[i]	=PFC[i].kA;
    iD[i]	=0;
  }
  for(j=0; j < nVVC; j++,i++){
    lC		=VVC+j;
    lC->I	=lC->I0;
    k		=lC->kB[0];
    Ib[i]	=lC->I;
    kc[i]	=lC->kA;
    iD[i]	=0;
  }
  Next0=0;
  Next1=0;
  Next2=0;
  ZUp	=PFB[0].Z+PFB[0].dZ;
  RUp	=PFB[0].R+PFB[0].dR;
  Xj[0]	=PFB[0].R-PFB[0].dR;
  Yj[0]	=-0.1*PFB[0].dZ;
  Xj[1]	=PFB[0].R+PFB[0].dR;
  Yj[1]	=Yj[0];
  m	=0;
#ifndef Tbl_EqCHI
  if(nFList){
    i	=iFList;
    if(Next1 == 1 && iFList < nFList-1){
      iFList++;
    }
    if(Next1 == 2 && iFList > 0){
      iFList--;
    }
    if((k=strcmp(Ext1,kFileExt))){
      if(k > 0){
	iFList++;
	while(iFList < nFList && strcmp(Ext1,FListEFIT[iFList]+kExt)){
	  iFList++;
	}
	if(iFList == nFList){
	  iFList	=i;
	}
	else{
	  Next1	=3;
	}
      }
      else{
	iFList--;
	while(iFList >= 0 && strcmp(Ext1,FListEFIT[iFList]+kExt)){
	  iFList--;
	}
	if(iFList < 0){
	  iFList	=i;
	}
	else{
	  Next1	=4;
	}
      }
    }
    if(Next1 && iFList != i){
      char *lD,*lN,NmF[128];
      CbGetCurrentCbName(&lD,&lN);
      sprintf(NmF,"%s/%s",lD,FListEFIT[iFList]);
      if(PFExpDataFromEFIT(NmF) == 0){
	strcpy(kFileExt,FListEFIT[iFList]+kExt);
      }
      else{
	iFList	=i;
      }
    }
    if(iF2 == 0){
      iF0	=0;
      iF2	=nFList-1;
    }
    if(Next0 == 1 && iF0 < iF2){
      iF0++;
    }
    if(Next0 == 2 && iF0 > 0){
      iF0--;
    }
    if(Next2 == 1 && iF2 < nFList-1){
      iF2++;
    }
    if(Next2 == 2 && iF2 > iF0){
      iF2--;
    }
    strcpy(Ext0,FListEFIT[iF0]+kExt);
    strcpy(Ext2,FListEFIT[iF2]+kExt);
    strcpy(Ext1,kFileExt);
  }
  else{
    strcpy(Ext0,"00000");
    strcpy(Ext1,"00000");
    strcpy(Ext2,"00000");
  }
  Next0	=0;
  Next1	=0;
  Next2	=0;

  if(nKj > NKj) nKj=NKj;
  if(nKj < 0) nKj=0;
  if(nKp > NKp) nKp=NKp;
  if(nKp < 0) nKp=0;
  PFCnK	=igYb == 3 ? nKj+nKp : nKj;

  PFCnQ	=0;
  PFCnY	=0;
  PFCnB	=0;
  PFCnX	=0;
  PFCnF	=0;
  PFCnO	=0;
  j	=nPFC+nVVC;
  for(i=0; i < j; i++){
    if(kc[i] == 2){
      kc[i]	=3;
    }
    if(kc[i] == 3){
      PFCnO++;
    }
  }
  nCntP	=PFCnY+PFCnB+PFCnX;

  for(i=0; i < nPFC; i++){
    lC	=PFC+i;
    lC->kA	=kc[i];
    if(lC->kA == 1){
      lC->I	=Ib[i]/PFB[lC->kB[0]].tn;
    }
  }
  for(j=0; j < nVVC; j++,i++){
    lC	=VVC+j;
    lC->kA	=kc[i];
    if(lC->kA == 1){
      lC->I	=Ib[i];
    }
  }

  FlE	=Fl/10;
  switch((Fl%10)){
  case 1:
    PFCOneCellCurrent();
    CHIaIp2gY(&err);
    break;
  case 2:
    ESSetMapBox();
    PFCFlxEq2PlPFB();
    CHIaIp2gY(&err);
    break;
  case 3:
    for(i=0; i < nPFC; i++){
      lC	=PFC+i;
      if(lC->kA == 1){
	lC->I	=lC->I0;
      }
    }
    for(j=0; j < nVVC; j++,i++){
      lC	=VVC+j;
      if(lC->kA == 1){
	lC->I	=lC->I0;
      }
    }
    break;
  case 4:
    PFGenerateSignals();
    break;
  case 5:
    CHIUpDateJsJp();
    break;
  case 6:
    CHISetJsJp();
    break;
  case 7:
    break;
  case 8:
    FlBlockIter	=1;
    CHISetJsJp();
    break;
  case 9:
    FlBlockIter	=0;
    break;
  default:
    break;
  }
  Fl	=FlE*10;
  switch(FlE){
  case 1:
    SVDFl	=0;
    CHISolvSVD(wL,wB,wI,wV,wF);
    break;
  case 2:
    SVDFl	=1;
    CHISolvSVD(wL,wB,wI,wV,wF);
    break;
  default:
    break;
  }		

  CHIEqSol2PF(wL,wB,wI,wV,wF);
  CbUserPlot	=CHILinePlot;

  for(i=0; i < nPFC; i++){
    lC	=PFC+i;
    n		=lC->nB;
    for(j=0; j < n; j++){
      k		=lC->kB[j];
      lB	=PFB+k;
      lB->I	=lC->I;
      lB->AI	=lC->I*lB->tn;
      IbPF[k]	=lB->AI;
      if(j == 0){
	Ib[i]	=lB->AI;
	R[i]	=lB->R;
	Z[i]	=lB->Z;
      }
    }
    I0[i]	=lC->I0;
    It[i]	=lC->I;
  }
  for(j=0; j < nVVC; j++,i++){
    lC		=VVC+j;
    lS		=VVB+lC->kB[0];
    R[i]	=cr4*(lS->r[0]+lS->r[1]+lS->r[2]+lS->r[3]);
    Z[i]	=cr4*(lS->z[0]+lS->z[1]+lS->z[2]+lS->z[3]);
    I0[i]	=lC->I0;
    IbPF[nPFB+j]=lC->I;
    It[i]	=lC->I;
    Ib[i]	=lC->I;
  }
  if(m == 4){
    m++;
  }
  sprintf(ln,"%s.%s",ShotNm,kFileExt);
  PFExpDataPlot(m,ln);
  m	=0;
  CHICurrentPlot(Xj,Yj);
  CHISetGridAct();
  PFGetW(&W,&WI,&WV,&WL,&WB);
  sprintf(ln,"W =%9.3e\nwI=%9.3e\nwV=%9.3e\nwL=%9.3e\nwB=%9.3e\nEr=%9.3e"
	  ,W,WI,WV,WL,WB,err);
  CbUserMessage=ln;
  Np	=0;
  Np1	=0;
  for(i=0; i < EGNp; i++){
    if(EGkAp[i] == 1){
      Rp[Np]	=EGaRp[i];
      Zp[Np]	=EGaZp[i];
      Np++;
    }
    if(EGkAp[i] == 2){
      Rp1[Np1]	=EGaRp[i];
      Zp1[Np1]	=EGaZp[i];
      Np1++;
    }
  }
  Ne	=0;
  if(igYb == 3){
    Re[0]	=EGaR0;
    Ze[0]	=EGaZ0;
    Re[1]	=EGaRx;
    Ze[1]	=EGaZx;
    Ne	=2;
  }
#endif/*Tbl_EqCHI*/
  return(0);
}

#endif

#endif
