#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include <dirent.h>
#include <sys/types.h>

#include <ctype.h>
#include "pfc.h"

#ifndef mzl_MLIB
extern double cr2,cr3,cr4,cr6,cr12,cgp,c2gp,cgp_4,cr2gp,cgm0,crgm0;
#endif

#ifndef mzl_ESC
extern double ESTime;
extern int ESkNormJ;
extern int ESNa,ESNa1,ESNp,ESNp1;
extern double ESIpl,ESBt,ESRBt,ESRext;
extern double ESa0,*ESsa,*EScs1,*ESsn1,*ESsb,*ESaR0,*ESaZ0,*ESsr;
extern double *ESdgY,*ESdgY2a,*ESaF,*ESFF,*ESFF2a,*ESqgY,*ESqgY2a
,*ESgY,*ESgY2a;

static int EFITnA=0;
static double EFITaP[128],EFITaT[128];
#endif
#ifndef mzl_PFC
extern unsigned int ESmemlevP;
extern int kTimeHistory;
extern int iSignIp,iSignBt;

#ifndef stg_PlLim
extern int ESnLm,*IndALm;
extern double*ESRLm,*ESZLm;
extern double RplG[],ZplG[];
#endif

#ifndef stg_VacV
extern int nVVB;
extern PSBLOCK *VVB;
#endif

#ifndef stg_PSElecP
extern int nVVC;
extern PFCOIL *VVC;
#endif

#ifndef stg_MFProbe
extern int nMFP,nMFL,nMFS,nMFLS,nMFp,nMFd,nMFV;
extern MFPROBE *MFP,*MFL,*MFS,*MFp,*MFd,*MFV;
#endif

#ifndef stg_PFBlocks
extern int nPFB;
extern PFBLOCK *PFB;
#endif

#ifndef stg_ElecPar
extern int nPFC,nPFC1,nPEC;
extern PFCOIL *PFC;
#endif

extern int MSEFl,MSSFl,nSightP;
extern int NMSE,nMSE,nMSS;
extern DATAMSE MSE[],MSS[];
extern double x0Mse,y0Mse,scMSE;
extern SIGHTLINE SightP[];

static int MSEkAc[8]={8*0},MSEkAs[32]={32*1},MSEnS=0,MSEnC=0;
static double MSEga[8][32]={8*32*0.},MSEgW[8][32]={8*32*0.}
,MSEgd[8][32]={8*32*0.},MSEgq[8][32]={8*32*0.};

static double MSER[8][32]={8*32*0.},MSEZ[8][32]={8*32*0.};
static double MSEA1[8][32]={8*32*0.},MSEA2[8][32]={8*32*0.}
,MSEA3[8][32]={8*32*0.},MSEA4[8][32]={8*32*0.},MSEA5[8][32]={8*32*0.}
,MSEA6[8][32]={8*32*0.};
static int nSmP=16;
extern double PFtWF,PFtWF1,PFtWF2;

static char Shot[8]="031700",DTime[8]="1212",Ext[8]="CCT",Nm[32];

extern int nDGr,nPGr,nRawP;
extern GROUPDT DGr[],*PGr;
static char IMg[NGRP][0x10]={
  "","","","","","","","","","","","","","","",""
  ,"","","","","","","","","","","","","","","",""};

static int PrGr[0x10];
static int PrDm[0x10];
static char PrNm[0x10][0x10];
static int kS[0x100],nkS=0;
#ifdef H
int nGr=0,nDGr=0;
#endif

static int kG0,nGrI=0,iGrI=0;
extern char TypeNm[][0x20];

#ifdef H
typedef struct{
  char A[0x100];	/* Name of the a-axis */
  char T[0x100];	/* Name of the t-axis */
  int k;
  int k0;
  int k1;
  int m;	/* dimension of a */
  int n;	/* dimension of t */
  int i0;
  int i;
  int i1;
  int id;	/* ID */
  int *kt;	/* activity of the time slice */
  int j;	/* index of selected time */
  double *t;
  double *a;
}GROUPPR;
#endif

extern int kCol[];
extern int nRaw,nRawS,nRawP;
static int NRaw=0;
static RAWDATA *RawI=NULL;
static RAWDATA *RawT=NULL;
static RAWDATA *RawV=NULL;
static RAWDATA *RawY=NULL;
static RAWDATA *RawB=NULL;
static RAWDATA *RawU=NULL;
static RAWDATA *RawW=NULL;
static RAWDATA *RawP=NULL;
static RAWDATA *Raw=NULL,*RawS=NULL;

static double gaI[0x10]={
  1e-16,1e-16,1e-16,1e-16,1e-16,1e-16,1e-16,1e-16
  ,1e-16,1e-16,1e-16,1e-16,1e-16,1e-16,1e-16,1e-16};
static double gaS[0x10]={
  1e-8,1e-8,1e-8,1e-8,1e-8,1e-8,1e-8,1e-8
  ,1e-8,1e-8,1e-8,1e-8,1e-8,1e-8,1e-8,1e-8};
static double ga0=0.,ga1=0.,ga2=0.;

static double s1Y=-4.9,s2Y=4.9;
static double s1B=-4.9,s2B=4.9;

static double t1,t2;
static int kAT=0;
static int kG1=0;

static char ln[256];
static int ExpDataFl=0;
static int nEft=0;
static double rEft[256],zEft[256];
static int FlAmpTn=0;

static char Mess[256];
extern char ShotNm[0x20];
static int iShot=0; 

extern int iFList,nFList,NFList;
extern char FListEFIT[][16],kFileExt[16];

int PFSetShotNm()
{
  char *lD,*lN;
  CbGetCurrentCbName(&lD,&lN);
  lN	=ShotNm;
  while(*lD != '\0'){
    if(*lD == '/'){
      lN	=ShotNm;
      lD++;
    }
    else{
      *lN++	=*lD++;
    }
  }
  *lN	='\0';
  iShot=atoi(ShotNm);
  return(0);
}

int PFIsKeyWordFound(FILE *lF, char *Message, char *Str, char *strF,int *n)
{
  char ch,ch0,*lc;
  int k;

  lc	=Str;
  ch0	=*lc;
  while(feof(lF) == 0){
    ch	=(char)fgetc(lF);
    if(ch == ch0){
      do{
	lc++;
      }while(*lc != '\0' && feof(lF) == 0 && *lc == (ch=(char)fgetc(lF)));
      if(*lc == '\0'){
	break;
      }
      else{
	lc	=Str;
      }
    }
  }
  if(feof(lF)){
    sprintf(Message+strlen(Message),": %s is absent\n",Str);
    return(0);
  }
  while(feof(lF) == 0 && ch != '('){
    ch	=(char)fgetc(lF);
    if(ch == '['){
      lc	=strF;
      while(feof(lF) == 0 && (*lc=(char)fgetc(lF)) != ']'){
	lc++;
      }
      *lc	='\0';
      if((k=sscanf(strF,"%d",n)) != 1){
	sprintf(Message+strlen(Message),": %d < 1: no N in %s\n",k,Str);
	return(0);
      }
    }
  }
  while(feof(lF) == 0 && (*strF=(char)fgetc(lF)) != ')') strF++;
  *strF	='\0';
  return(1);
}

int PFIfPatternFound(FILE *lF,char *Str)
{
  char ch,ch0,*lc;

  lc	=Str;
  ch0	=*lc;
  while(feof(lF) == 0){
    ch	=(char)fgetc(lF);
    if(ch == ch0){
      do{
	lc++;
	if(*lc == '\0'){
	  return(1);
	}
	if(feof(lF) == 0) ch	=(char)fgetc(lF);
      }while(*lc == ch);
      lc	=Str;
    }
  }
  if(feof(lF)){
    return(0);
  }
  return(1);
}

int PFReadAI(FILE *lF,char *Str,char *Ms,char *str,int n, char **lv,int *dl
	     ,int k)
{
  int i,j,m;
  char ln[128],*lc,*ls;
  char ch;

  for(i=0; i < n; i++){
    ls	=str;
    j	=0;
    while(j < k){
      while(isspace(*ls)) ls++;
      m	=isdigit(*ls) ? 0 : 1;
      while(isdigit(*ls)){
	m	=m*10+(*ls)-'0';
	ls++;
      }
      if(*ls == '%'){
	ls++;
	switch(*ls){
	case 'd':
	  while(m){
	    m--;
	    lc	=ln;
	    while(feof(lF) == 0 && (isspace(ch=(char)fgetc(lF)) || ch == '!')){
	      if(ch == '!')while(feof(lF) == 0 && (ch=(char)fgetc(lF))!= '\n');
	    }
	    *lc++	=ch;
	    while(feof(lF) == 0 && !isspace(ch=(char)fgetc(lF))) *lc++=ch;
	    *lc	='\0';
	    *(int*)lv[j]	=strtol(ln,&lc,10);
	    if(*lc != '\0'){
	      sprintf(ln,": in %s wrong [%d][%d]-th data\n",Str,i,j);
	      CbStr2UserMessage(Ms);
	      CbStr2UserMessage(ln);
	    }
	    lv[j]	+=dl[j];
	    j++;
	  }
	  ls++;
	  break;
	case 'e':
	  while(m){
	    m--;
	    lc	=ln;
	    while(feof(lF) == 0 && (isspace(ch=(char)fgetc(lF)) || ch == '!')){
	      if(ch == '!')while(feof(lF) == 0 && (ch=(char)fgetc(lF))!= '\n'){
		;
	      }
	    }
	    *lc++	=ch;
	    while(feof(lF) == 0 && !isspace(ch=(char)fgetc(lF))) *lc++=ch;
	    *lc	='\0';
	    *(double*)lv[j]	=strtod(ln,&lc);
	    if(*lc != '\0'){
	      sprintf(ln,": in %s wrong [%d][%d]-th data\n",Str,i,j);
	      CbStr2UserMessage(Ms);
	      CbStr2UserMessage(ln);
	    }
	    lv[j]	+=dl[j];
	    j++;
	  }
	  ls++;
	  break;
	case 's':
	  while(m){
	    m--;
	    lc	=ln;
	    while(feof(lF) == 0 && (isspace(ch=(char)fgetc(lF)) || ch == '!')){
	      if(ch == '!')while(feof(lF) == 0 && (ch=(char)fgetc(lF))!= '\n'){
		;
	      }
	    }
	    *lc++	=ch;
	    while(feof(lF) == 0 && !isspace(ch=(char)fgetc(lF))) *lc++=ch;
	    *lc	='\0';
	    strcpy((char*)lv[j],ln);
	    if(*lc != '\0'){
	      sprintf(ln,": in %s wrong [%d][%d]-th data\n",Str,i,j);
	      CbStr2UserMessage(Ms);
	      CbStr2UserMessage(ln);
	    }
	    lv[j]	+=dl[j];
	    j++;
	  }
	  ls++;
	  break;
	}
      }
      else{
	while(feof(lF) == 0 && (isspace(ch=(char)fgetc(lF)) || ch == '!')){
	  if(ch == '!')while(feof(lF) == 0 && (ch=(char)fgetc(lF)) != '\n') ;
	}
	while(*ls != '\0' && ch == *ls && *ls != '%' && !isspace(*ls)){
	  ls++;
	  if(feof(lF) == 0) ch=(char)fgetc(lF);
	}
      }      
    }
    while(feof(lF) == 0 && ch != '\n') ch=(char)fgetc(lF);
  }
  return(0);
}

int SetGroups()
{
  int i,k;

  for(k=0; k < nDGr; k++) DGr[k].k=0;
  for(i=0; i < nPFC1; i++){
    if(PFC[i].kG >= 0){
      k	=PFC[i].kG;
      if(DGr[k].kt < 4) DGr[k].k++;
    }
  }
  for(i=0; i < nVVC; i++){
    if(VVC[i].kG >=0){
      k	=VVC[i].kG;
      if(DGr[k].kt == 4) DGr[k].k++;
    }
  }
  for(i=0; i < nMFP; i++){
    if(MFP[i].kG >= 0){
      k	=MFP[i].kG;
      if(DGr[k].kt > 4) DGr[k].k++;
    }
  }
  nRawS	=0;
  nGrI	=0;
  for(k=0; k < nDGr; k++){
    DGr[k].k0	=nRawS;
    nRawS	+=DGr[k].k;
    DGr[k].k1	=nRawS;
    if(DGr[k].kt < 5) nGrI=k;
  }
  nGrI++;

  PGr	=DGr+nDGr;
  for(k=0; k < nPGr; k++) PGr[k].k=0;
  for(i=0; i < nRawP; i++) PGr[PrGr[i]].k++;

  i	=0;
  for(k=0; k < nPGr; k++){
    if(*PGr[k].P == '<' && *(PGr[k].P+1) == '>') *PGr[k].P=0;
    if(*PGr[k].S == '<' && *(PGr[k].S+1) == '>') *PGr[k].S=0;
    PGr[k].k0	=i;
    i	+=PGr[k].k;
    PGr[k].k1	=i;
  }
  return(0);
}

int PFDeInitWForms()
{
  int j,j1,j2,k;

  if(NRaw == 0) return(0);
  while(nPGr){
    nPGr--;
    j1	=PGr[nPGr].k0;
    j	=PGr[nPGr].k1;
    while(j > j1){
      j--;
      if(RawP[j].D != NULL) free(RawP[j].D);
      if(RawP[j].errA != NULL) free(RawP[j].errA);
    }
    if(PGr[nPGr].a != NULL) free(PGr[nPGr].a);
    if(PGr[nPGr].t != NULL) free(PGr[nPGr].t);
  }  

  while(nDGr){
    nDGr--;
    j1	=DGr[nDGr].k0;
    j	=DGr[nDGr].k1;
    while(j > j1){
      j--;
      if(RawS[j].D != NULL) free(RawS[j].D);
    }
    if(DGr[nDGr].t != NULL) free(DGr[nDGr].t);
  }  
  free(Raw);
  RawP	=NULL;
  RawS	=NULL;
  Raw	=NULL;
  RawW	=NULL;
  RawU	=NULL;
  RawB	=NULL;
  RawY	=NULL;
  RawV	=NULL;
  RawT	=NULL;
  RawI	=NULL;
  NRaw	=0;
  nRaw	=0;
  nRawS	=0;
  return(0);
}

int PFInitWForms()
{
  int i,j,k;
  RAWDATA *lR,*lS;

  if(NRaw < nRaw+nRawS+nRawP){
    if(NRaw) PFDeInitWForms();

    NRaw=nRaw+nRawS+nRawP;
    Raw	=(RAWDATA *)calloc(NRaw,sizeof(RAWDATA));
    RawI=Raw;
    RawT=RawI+nPFC;
    RawV=RawT+1;
    RawY=RawV+nVVC;
    RawB=RawY+nMFLS;
    RawU=RawB+nMFp;
    RawW=RawU+nMFV;
    RawS=Raw+nRaw;
    RawP=RawS+nRawS;

    lS	=RawS;
    lR	=Raw;
    j	=0;
    for(i=0; i < nPFC1; i++){
      strcpy(lR->Nm,PFC[i].NmS);
      lR->kA	=PFC[i].kA;
      lR->kG	=PFC[i].kG;
      lR->c	=PFC[i].c;
      if(lR->kG >= 0){
	lR->kS	=j;
	lS->kS	=i;
	strcpy(lS->Nm,lR->Nm);
	lS->kA	=lR->kA;
	lS->kG	=lR->kG;
	lS->c	=lR->c;
	lS->C	=1.;
	lS->G	=1.;
	lS->G	=1.;
	lS->A	=0.;
	lS->B	=0.;
	lS->dC	=0.01;
	lS->dG	=0.;
	lS->dA	=0.;
	lS->dB	=0.01;
	lS->dS	=0.;
	lS++;
	j++;
      }
      else{
	lR->kS	=-1;
      }
      lR++;
    }
    for(i=0; i < nVVC; i++){
      strcpy(lR->Nm,VVC[i].NmS);
      lR->kA	=VVC[i].kA;
      lR->kG	=VVC[i].kG;
      lR->c	=VVC[i].c;
      if(lR->kG == 4){
	lR->kS	=j;
	lS->kS	=i+nPFC1;
	strcpy(lS->Nm,lR->Nm);
	lS->kA	=lR->kA;
	lS->kG	=lR->kG;
	lS->c	=lR->c;
	lS->C	=1.;
	lS->G	=1.;
	lS->G	=1.;
	lS->A	=0.;
	lS->B	=0.;
	lS->dC	=0.01;
	lS->dG	=0.;
	lS->dA	=0.;
	lS->dB	=0.01;
	lS->dS	=0.;
	lS++;
	j++;
      }
      else{
	lR->kS	=-1;
      }
      lR++;
    }
    for(i=0; i < nMFP; i++){
      strcpy(lR->Nm,MFP[i].Nm);
      lR->kA	=MFP[i].kA;
      lR->kG	=MFP[i].kG;
      lR->c	=MFP[i].c;
      if(lR->kG >= 0){
	lR->kS	=j;
	lS->kS	=i+nPFC1+nVVC;
	strcpy(lS->Nm,lR->Nm);
	lS->kA	=lR->kA;
	lS->kG	=lR->kG;
	lS->c	=lR->c;
	lS->C	=1.;
	lS->G	=1.;
	lS->G	=1.;
	lS->A	=0.;
	lS->B	=0.;
	lS->dC	=0.01;
	lS->dG	=0.;
	lS->dA	=0.;
	lS->dB	=0.01;
	lS->dS	=0.;
	lS++;
	j++;
      }
      else{
	lR->kS	=-1;
      }
      lR++;
    }

    lS	=RawP;
    for(i=0; i < nRawP; i++){
      strcpy(lS->Nm,PrNm[i]);
      lS->kG	=PrGr[i];
      lS->m	=PrDm[i];
      lS->kA	=1;
      lS->c	=1;
      lS->kS	=0;
      lS->C	=1.;
      lS->G	=1.;
      lS->G	=1.;
      lS->A	=0.;
      lS->B	=0.;
      lS->dC	=0.01;
      lS->dG	=0.;
      lS->dA	=0.;
      lS->dB	=0.01;
      lS->dS	=0.;
      lS++;
    }
    ESmemlevP |=0x00040000;
  }
  return(0);
}

int YearAO(FILE *lF)
{
  int i,j,k,LN,LP,LS,LT,LA;
  char str[0x100],str1[0x100];
  char *lc;
  MFPROBE *lP;

  fputs("kG parameter specifies the group # of signals.\n"
	"Types of groups:\n",lF);
  fputs("ka parameter specifies the type of radial coordinate\n"
	"ka=0 - R, ka=1 - a\n",lF);
  for(i=0; i < NTYPEG; i++) fprintf(lF,"%2d - %s\n",i,TypeNm[i]);
  fputs("Groups with the signal type <= 3 should have the lowest kGs\n",lF);
  LP	=6;
  LS	=6;
  for(i=0; i < nDGr; i++){
    j=strlen(DGr[i].P)+2;
    if(LP < j) LP=j;
    j=strlen(DGr[i].S)+2;
    if(LS < j) LS=j;
  }
  sprintf(ln,"%s%d%s%d%s","%2d %2d %4d %",LP,"s  %",LS,"s%c");
  strcpy(str,ln);
  FormatWrite2Read(str);
  sprintf(ln,"%s%d%s%d%s","%2d %2d %4d %",LP,"s  %",LS,"s - %s \n");
  fprintf(lF,"\n<Pref & Suff of Group Names>[%d](%s)\n",nDGr,"%d %d %d %s %s");
  sprintf(str,"%s%d%s%d%s","!%1s %2s %4s %",LP,"s  %",LS,"s\n");
  fprintf(lF,str,"#","kG","Type","Pref","Suff");

  for(i=0; i < nDGr; i++){
    sprintf(DGr[nDGr].P,"\"%s\"",DGr[i].P);
    sprintf(DGr[nDGr].S,"\"%s\"",DGr[i].S);
    fprintf(lF,ln,i,i,DGr[i].kt,DGr[nDGr].P,DGr[nDGr].S,TypeNm[DGr[i].kt]);
  }
  fprintf(lF,str,"#","kG","Type","Pref","Suff");

  LN	=4;
  LP	=4;
  LS	=4;
  LT	=4;
  LA	=4;
  for(k=0; k < nPGr; k++){
    i	=strlen(PGr[k].Nm);
    if(LN < i) LN=i;
    i	=strlen(PGr[k].P);
    if(LP < i) LP=i;
    i	=strlen(PGr[k].S);
    if(LS < i) LS=i;
    i	=strlen(PGr[k].NmT);
    if(LT < i) LT=i;
    i	=strlen(PGr[k].NmA);
    if(LA < i) LA=i;
  }
  sprintf(ln,"%s%d%s%d%s%d%s%d%s%d%s","%3d %2d %2d %2d %3d %"
	  ,LN,"s %",LP,"s %",LS,"s %",LT,"s %",LA,"s%c");
  strcpy(str,ln);
  FormatWrite2Read(str);
  fprintf(lF,"<Profiles Group Names>[%d](%s)\n",nPGr,str);
  sprintf(str,"!%s%d%s%d%s%d%s%d%s%d%s\n"
	  ,"%2s %2s %2s %2s %3s %",LN,"s %",LP,"s %",LS,"s %",LT,"s %",LA,"s");
  
  sprintf(ln,"%s%d%s%d%s%d%s%d%s%d%s","%3d %2d %2d %2d %3d %"
	  ,LN,"s %",LP,"s %",LS,"s %",LT,"s %",LA,"s %s%c");
  fprintf(lF,str,"#","kG","ka","kt","na1","Tree","Pref","Suff","Time","X");
  for(k=0; k < nPGr; k++){
    fprintf(lF,ln,k,k,PGr[k].ka,PGr[k].kt,PGr[k].na1,PGr[k].Nm,PGr[k].P,PGr[k].S
	    ,PGr[k].NmT,PGr[k].NmA,TypeNm[PGr[k].kt],'\n');
  }
  fprintf(lF,str,"#","kG","ka","kt","na1","Tree","Pref","Suff","Time","X");

  LN=0;
  for(i=0; i < nPFC1; i++){
    j=strlen(PFC[i].Nm);
    if(*PFC[i].NmS == 0) strcpy(PFC[i].NmS,PFC[i].Nm);
    if(LN < j) LN=j;
  }
  sprintf(ln,"%s%d%s","%3d %10.3e %5d %2d %",LN,"s %s%c");
  strcpy(str,ln);
  FormatWrite2Read(str);
  fprintf(lF,"<PFCoils and Signals>[%d](%s)\n",nPFC1,str);

  sprintf(str,"%s%d%s","!%2s %10s %5s %2s %",LN,"s %s\n");
  fprintf(lF,str,"#","Resistance","Group","c","Coil","Signal");
  fprintf(lF,str,"","Om",""," ","Name","");
  for(i=0; i < nPFC1; i++){
    fprintf(lF,ln,i,PFC[i].Res,PFC[i].kG,PFC[i].c,PFC[i].Nm,PFC[i].NmS,'\n');
  }
  fprintf(lF,str,"#","Resistance","Group","c","Coil","Signal");
  fprintf(lF,str,"","Om",""," ","Name","");

  LN=0;
  for(i=0; i < nVVC; i++){
    j=strlen(VVC[i].Nm);
    if(LN < j) LN=j;
  }
  sprintf(ln,"%s%d%s","%3d %10.3e %5d %2d %",LN,"s %s%c");
  strcpy(str,ln);
  FormatWrite2Read(str);
  fprintf(lF,"<Vacuum Vessel Coils>[%d](%s)\n",nVVC,str);

  sprintf(str,"%s%d%s","!%2s %10s %5s %2s %",LN,"s %s\n");
  fprintf(lF,str,"#","Resistance","Group","c","Coil","Voltage");
  fprintf(lF,str,"","Om","","Index"," ","Signal");
  for(i=0; i < nVVC; i++){
    lc	=VVC[i].NmS;
    if(*lc == 0) strcpy(lc,">--<");
    fprintf(lF,ln,i,VVC[i].Res,VVC[i].kG,VVC[i].c,VVC[i].Nm,lc,'\n');
  }
  fprintf(lF,str,"#","Resistance","Group","c","Coil","Voltage");
  fprintf(lF,str,"","Om",""," ","Name","Signal");

  LN=6;
  for(i=0; i < nMFP; i++){
    j	=strlen(MFP[i].NmS);
    if(LN < j) LN=j;
  }

  sprintf(ln,"%s%ds %s","%3d %2d %2d %",LN,"%s%c");
  strcpy(str,ln);
  FormatWrite2Read(str);
  fprintf(lF,"\n<Flux Loops>[%d](%s)\n",nMFL,str);
  sprintf(str1,"%s%ds %s","!%2s %2s %2s %",LN,"%s\n");
  fprintf(lF,str1,"#","c","kG","Signal","Loop");
  for(i=0; i < nMFL; i++){
    lP	=MFP+i;
    j	=lP->kA ? lP->c : 0;
    fprintf(lF,ln,i,j,lP->kG,lP->NmS,lP->Nm,'\n');
  }
  fprintf(lF,str1,"#","c","kG","Signal","Loop");

  fprintf(lF,"\n<Saddle Coils>[%d](%s)\n",nMFS,str);
  fprintf(lF,str1,"#","c","kG","Signal","Loop");
  for(i=0; i < nMFS; i++){
    lP	=MFS+i;
    j	=lP->kA ? lP->c : 0;
    fprintf(lF,ln,i,j,lP->kG,lP->NmS,lP->Nm,'\n');
  }
  fprintf(lF,str1,"#","c","kG","Signal","Loop");

  fprintf(lF,"\n<Magnetic Probes>[%d](%s)\n",nMFp,str);
  fprintf(lF,str1,"#","c","kG","Signal","Probe");
  for(i=0; i < nMFp; i++){
    lP	=MFp+i;
    j	=lP->kA ? lP->c : 0;
    fprintf(lF,ln,i,j,lP->kG,lP->NmS,lP->Nm,'\n');
  }
  fprintf(lF,str1,"#","c","kG","Signal","Probe");

  fprintf(lF,"\n<Diamagnetic Loop>[%d](%s)\n",nMFd,str);
  fprintf(lF,str1,"#","c","kG","Signal","Loop");
  for(i=0; i < nMFd; i++){
    lP	=MFd+i;
    j	=lP->kA ? lP->c : 0;
    fprintf(lF,ln,i,j,lP->kG,lP->NmS,lP->Nm,'\n');
  }
  fprintf(lF,str1,"#","c","kG","Signal","Loop");


  fprintf(lF,"\n<V-Loop>[%d](%s)\n",nMFV,str);
  fprintf(lF,str1,"#","c","kG","Signal","Loop");
  for(i=0; i < nMFV; i++){
    lP	=MFV+i;
    j	=lP->kA ? lP->c : 0;
    fprintf(lF,ln,i,j,lP->kG,lP->NmS,lP->Nm,'\n');
  }
  fprintf(lF,str1,"#","c","kG","Signal","Loop");

  fprintf(lF,"\n<Profile List>[%d](%s)\n",nRawP,"3%d %s");
  sprintf(ln,"%s","%2d %2d %3d %s\n");
  sprintf(str1,"%s","%2s %2s %3s %s\n");
  fprintf(lF,str1,"!#","kG","m","Name");
  sprintf(ln,"%s","%2d %2d %3d %s\n");
  for(i=0; i < nRawP; i++){
    fprintf(lF,ln,i,RawP[i].kG,RawP[i].m,RawP[i].Nm);
  }
  fprintf(lF,str1,"!#","kG","m","Name");
  return(0);
}

int YearAI(FILE *lF)
{
  int i,j,k,n,m,nGr;
  char str[128];
  char *lc,*lm,*lt;
  char *lv[16];
  int kt[NTYPEG];
  int dl[16];
  int kG[NGRP];
  GROUPDT Gr[NGRP];
  MFPROBE *lP;

  lm	="Year.ai";

  memset(kt,0,NTYPEG*sizeof(int));
  nGr	=0;
  lc="<Pref & Suff of Group Names>";
  if(IsKeyWordFound(lF,lm,lc,str,&n)){
    nGr	=n;
    lv[0]	=(char*)&i;
    lv[1]	=(char*)kG;
    lv[2]	=(char*)&(Gr[0].kt);
    lv[3]	=Gr[0].P;
    lv[4]	=Gr[0].S;
    dl[0]	=0;
    dl[1]	=sizeof(int);
    dl[2]	=sizeof(GROUPDT);
    dl[3]	=dl[2];
    dl[4]	=dl[2];
    ReadAI(lF,lc,lm,str,n,lv,dl,5);
    CbStr2UserMessage("%s:%s\n",lm,lc);

    for(i=0; i < nGr; i++){
      kt[Gr[i].kt]	=1;
      j	= kG[i];
      if(nDGr < j) nDGr=j;
      DGr[j].kt=Gr[i].kt;
      lt	=DGr[j].P;
      lc	=Gr[i].P+1;
      while(*lc != '"' && *lc) *lt++=*lc++;
      *lt=0;
      lt	=DGr[j].S;
      lc	=Gr[i].S+1;
      while(*lc != '"' && *lc) *lt++=*lc++;
      *lt=0;
    }
    if(nDGr) nDGr++;
  }
  else{
    CbStr2UserMessage("Warning: %s - NO %s section.\n",lm,lc);
    printf("Warning:%s - NO %s section.\n",lm,lc);
    rewind(lF);
  }

  lc="<Profiles Group Names>";
  PGr=DGr+nDGr;
  nPGr	=0;
  if(IsKeyWordFound(lF,lm,lc,str,&n)){
    nPGr		=n;
    lv[0]	=(char*)&i;
    lv[1]	=(char*)kG;
    lv[2]	=(char*)&PGr[0].ka;
    lv[3]	=(char*)&PGr[0].kt;
    lv[4]	=(char*)&PGr[0].na1;
    lv[5]	=PGr[0].Nm;
    lv[6]	=PGr[0].P;
    lv[7]	=PGr[0].S;
    lv[8]	=PGr[0].NmT;
    lv[9]	=PGr[0].NmA;
    dl[0]	=0;
    dl[1]	=sizeof(int);
    dl[2]	=sizeof(GROUPDT);
    dl[3]	=dl[2];
    dl[4]	=dl[2];
    dl[5]	=dl[2];
    dl[6]	=dl[2];
    dl[7]	=dl[2];
    dl[8]	=dl[2];
    dl[9]	=dl[2];
    ReadAI(lF,lc,Mess,str,n,lv,dl,10);
    CbStr2UserMessage("%s:%s\n",lm,lc);
  }
  else{
    CbStr2UserWarning("Warning: %s - NO %s section.\n",lm,lc);
    printf("Warning:%s - NO %s section.\n",lm,lc);
    rewind(lF);
  }

  if(kt[0] || kt[1] ||  kt[2] ||  kt[3]){
  lc	="<PFCoils and Signals>";
  if(IsKeyWordFound(lF,lm,lc,str,&n)){
    nPFC1	=n;
    if(n){
      lv[0]	=(char*)&j;
      lv[1]	=(char*)&PFC[0].Res;
      lv[2]	=(char*)&PFC[0].kG;
      lv[3]	=(char*)&PFC[0].c;
      lv[4]	=PFC[0].Nm;
      lv[5]	=PFC[0].NmS;
      dl[0]	=0;
      dl[1]	=sizeof(PFCOIL);
      dl[2]	=dl[1];
      dl[3]	=dl[1];
      dl[4]	=dl[1];
      dl[5]	=dl[1];
      ReadAI(lF,lc,lm,str,n,lv,dl,6);
      CbStr2UserMessage("%s:%s\n",lm,lc);
    }
  }
  else{
    CbStr2UserMessage("Error:%s: %s is absent\n",lm,lc);
    printf("Error:%s: %s is absent\n",lm,lc);
    return(1);
  }
  }
  if(kt[4]){
  lc	="<Vacuum Vessel Coils>";
  if(IsKeyWordFound(lF,lm,lc,str,&n)){
    if(n){
      lv[0]	=(char*)&j;
      lv[1]	=(char*)&VVC[0].Res;
      lv[2]	=(char*)&VVC[0].kG;
      lv[3]	=(char*)&VVC[0].c;
      lv[4]	=VVC[0].Nm;
      lv[5]	=VVC[0].NmS;
      dl[0]	=0;
      dl[1]	=sizeof(PFCOIL);
      dl[2]	=dl[1];
      dl[3]	=dl[1];
      dl[4]	=dl[1];
      dl[5]	=dl[1];
      ReadAI(lF,lc,lm,str,n,lv,dl,6);
      CbStr2UserMessage("%s:%s\n",lm,lc);
    }
  }
  else{
    CbStr2UserMessage("%s: NO %s section",lm,lc);
  }
  }
  dl[0]	=0;
  dl[1]	=sizeof(MFPROBE);
  dl[2]	=dl[1];
  dl[3]	=dl[1];
  if(kt[5]){
  lc	="<Flux Loops>";
  if(IsKeyWordFound(lF,lm,lc,str,&n)){
    if(n){
      lP	=MFP;
      lv[0]	=(char*)&n;
      lv[1]	=(char*)&lP->c;
      lv[2]	=(char*)&lP->kG;
      lv[3]	=(char*)lP->NmS;
      ReadAI(lF,lc,lm,str,n,lv,dl,4);
      CbStr2UserMessage("%s:%s\n",lm,lc);
    }
  }
  else{
    CbStr2UserMessage("Error: %s: %s is absent\n",lm,lc);
    printf("Error:%s: %s is absent\n",lm,lc);
    return(1);
  }
  }
  if(kt[6]){
  lc	="<Saddle Coils>";
  if(IsKeyWordFound(lF,lm,lc,str,&n)){
    if(n){
      lP		=MFS;
      lv[0]	=(char*)&n;
      lv[1]	=(char*)&lP->c;
      lv[2]	=(char*)&lP->kG;
      lv[3]	=(char*)lP->NmS;
      ReadAI(lF,lc,lm,str,n,lv,dl,4);
      CbStr2UserMessage("%s:%s\n",lm,lc);
    }
  }
  else{
    CbStr2UserMessage("Info: %s: %s is absent\n",lm,lc);
    rewind(lF);
  }
  }
  if(kt[7]){
  lc	="<Magnetic Probes>";
  if(IsKeyWordFound(lF,lm,lc,str,&n)){
    if(n){
      lP		=MFp;
      lv[0]	=(char*)&n;
      lv[1]	=(char*)&lP->c;
      lv[2]	=(char*)&lP->kG;
      lv[3]	=(char*)lP->NmS;
      ReadAI(lF,lc,lm,str,n,lv,dl,4);
      CbStr2UserMessage("%s:%s\n",lm,lc);
    }
  }
  else{
    CbStr2UserMessage("Error: %s: %s is absent\n",lm,lc);
    printf("Error:%s: %s is absent\n",lm,lc);
    return(1);
  }
  }
  if(kt[8]){
  lc	="<Diamagnetic Loop>";
  if(IsKeyWordFound(lF,lm,lc,str,&n)){
    if(n){
      lP	=MFd;
      lv[0]	=(char*)&n;
      lv[1]	=(char*)&lP->c;
      lv[2]	=(char*)&lP->kG;
      lv[3]	=(char*)lP->NmS;
      ReadAI(lF,lc,lm,str,n,lv,dl,4);
      CbStr2UserMessage("%s:%s\n",lm,lc);
    }
  }
  else{
    CbStr2UserMessage("Info: %s: %s is absent\n",lm,lc);
    printf("Error:%s - NO %s section.\n",lm,lc);
    rewind(lF);
  }
  }
  if(kt[4]){
  lc	="<V-Loop>";
  if(IsKeyWordFound(lF,lm,lc,str,&n)){
    if(n){
      lP	=MFV;
      lv[0]	=(char*)&n;
      lv[1]	=(char*)&lP->c;
      lv[2]	=(char*)&lP->kG;
      lv[3]	=(char*)lP->NmS;
      ReadAI(lF,lc,lm,str,n,lv,dl,4);
      CbStr2UserMessage("%s:%s\n",lm,lc);
    }
  }
  else{
    CbStr2UserMessage("Info: %s: %s is absent",lm,lc);
    printf("Error:%s - NO %s section.\n",lm,lc);
    rewind(lF);
  }
  }
  for(i=0; i < nMFP; i++){
    lP	=MFP+i;
    if(lP->kA == 0) lP->c=0;
  }
  if(nPGr){
    lc	="<Profile List>";
    if(IsKeyWordFound(lF,lm,lc,str,&n)){
      nRawP	=n;
      if(n){
	lv[0]	=(char*)&n;
	lv[1]	=(char*)&PrGr;
	lv[2]	=(char*)&PrDm;
	lv[3]	=(char*)PrNm[0];
	dl[0]	=0;
	dl[1]	=sizeof(int);
	dl[2]	=sizeof(int);
	dl[3]	=0x10;
	ReadAI(lF,lc,lm,str,n,lv,dl,4);
	CbStr2UserMessage("%s:%s\n",lm,lc);
      }
    }
    else{
      CbStr2UserMessage("Info: %s: %s is absent",lm,lc);
      printf("Error:%s - NO %s section.\n",lm,lc);
    }
  }

  CbStr2UserMessage("Input:%s\n",lm);
  return(0);
}

int PFYear()
{
  static int Fl=0,kG=0;
  int i,k,m,n,n1,nGr,nS,LN,LS;
  int iS=0;
  static char Img[0x10]="";
  static char ImS[0x10]="";
  char DummyNm[0x10]="NullSignal";
  char Nm[nPFC1+nVVC+nMFP][0x10];
  char *NmS[nPFC1+nVVC+nMFP];
  int ix[nPFC1+nVVC+nMFP];
  int iy[nPFC1+nVVC+nMFP];
  int kkG[nPFC1+nVVC+nMFP];

  if(nPFC == 0) return(0);
  nDGr	=0;
  memset(DGr,0,NGRP*sizeof(GROUPDT));
  for(i=0; i < NGRP; i++) DGr[i].kt=-1;
  /*See ToDo*/
#ifndef AscI_Year
#undef AscI_Year
#endif/*AscI_Year*/

  n	=0;
  for(i=0; i < nPFC1; i++) kkG[n++]	=PFC[i].kG;
  for(i=0; i < nVVC; i++)  kkG[n++]	=VVC[i].kG;
  for(i=0; i < nMFP; i++)  kkG[n++]	=MFP[i].kG;

#ifndef Tbl_Year
  nGr	=nDGr;
  if(kG == nGr) kG=0;
  if(kG > nGr) kG=nGr-1;

  LN	=strlen(Img);
  LS	=strlen(ImS);
  n	=0;
  switch(iS){
  case 0:
    m	=0;
    for(i=0; i < nPFC1; i++){
      if(strncmp(PFC[i].Nm,Img,LN) == 0 && strncmp(PFC[i].NmS,ImS,LS) == 0){
	strcpy(Nm[n],PFC[i].Nm);
	NmS[n]=PFC[i].NmS;
	ix[n]=m+i;
	n++;
      }
    }
    break;
  case 1:
    m	=nPFC1;
    for(i=0; i < nVVC; i++){
      if(strncmp(VVC[i].Nm,Img,LN) == 0 && strncmp(VVC[i].NmS,ImS,LS) == 0){
	strcpy(Nm[n], VVC[i].Nm);
	NmS[n]=VVC[i].NmS;
	ix[n]=m+i;
	n++;
      }
    }
    break;
  case 2:
    m	=nPFC1+nVVC;
    for(i=0; i < nMFL; i++){
      if(strncmp(MFL[i].Nm,Img,LN) == 0 && strncmp(MFL[i].NmS,ImS,LS) == 0){
	strcpy(Nm[n],MFL[i].Nm);
	NmS[n]=MFL[i].NmS;
	ix[n]=m+i;
	n++;
      }
    }
    break;
  case 3:
    m	=nPFC1+nVVC+nMFL;
    for(i=0; i < nMFS; i++){
      if(strncmp(MFS[i].Nm,Img,LN) == 0 && strncmp(MFS[i].NmS,ImS,LS) == 0){
	strcpy(Nm[n],MFS[i].Nm);
	NmS[n]=MFS[i].NmS;
	ix[n]=m+i;
	n++;
      }
    }
    break;
  case 4:
    m	=nPFC1+nVVC+nMFL+nMFS;
    for(i=0; i < nMFp; i++){
      if(strncmp(MFp[i].Nm,Img,LN) == 0 && strncmp(MFp[i].NmS,ImS,LS) == 0){
	strcpy(Nm[n],MFp[i].Nm);
	NmS[n]=MFp[i].NmS;
	ix[n]=m+i;
	n++;
      }
    }
    break;
  case 5:
    m	=nPFC1+nVVC+nMFL+nMFS+nMFp;
    for(i=0; i < nMFd; i++){
      if(strncmp(MFd[i].Nm,Img,LN) == 0 && strncmp(MFd[i].NmS,ImS,LS) == 0){
	strcpy(Nm[n],MFd[i].Nm);
	NmS[n]=MFd[i].NmS;
	ix[n]=m+i;
	n++;
      }
    }
    break;
  case 6:
    m	=nPFC1+nVVC+nMFL+nMFS+nMFp+nMFd;
    for(i=0; i < nMFV; i++){
      if(strncmp(MFV[i].Nm,Img,LN) == 0 && strncmp(MFV[i].NmS,ImS,LS) == 0){
	strcpy(Nm[n],MFV[i].Nm);
	NmS[n]=MFV[i].NmS;
	ix[n]=m+i;
	n++;
      }
    }
    break;
  }
  for(i=0; i < n; i++) iy[i]=kkG[ix[i]];
  strcpy(Nm[n],"NullSensor");
  NmS[n]=DummyNm;
  iy[n]=0;
  ix[n]=m+i;
  n1=n+1;

  k	=0;
  for(i=0; i < nPFC1; i++) PFC[i].kG	=kkG[k++];
  for(i=0; i < nVVC; i++)  VVC[i].kG	=kkG[k++];
  for(i=0; i < nMFP; i++)  MFP[i].kG	=kkG[k++];
  SetGroups();
  nS	=DGr[kG].k;
#endif/*Tbl_Year*/
  nRaw	=nPFC1+nVVC+nMFP;
  if(nRawS+nRawP) PFInitWForms();
#ifndef AscO_Year
#undef AscO_Year
#endif/*AscO_Year*/
  return(0);
}

int PFGetMSEAngles(char *NmF)
{
  FILE *lF;
  int L,k,i,j=0;
  char ch,ln[80],*lc;
  double s[6];
  double *ld[8];

  if((lF=fopen(NmF,"r")) == NULL){
    printf("%s file is absent%c\n",NmF,7);
    return(1);
  }
  L	=1;
  lc	=ln;
  while(feof(lF) == 0){
    if((*lc=fgetc(lF)) == '\n'){
      *lc	='\0';
      if((lc=strstr(ln,"iLos =")) != NULL){
	lc	+=6;
	if(sscanf(lc,"%d",&j) < 1){
	  printf("%s:%d '%s'\n      -format for iLos should be 'iLos = ddd'%c\n"
		 ,NmF,L,ln,7);
	  return(1);
	}
	j--;
      }
      else{
	if((lc=strstr(ln,"pini")) == NULL){
	  if(sscanf(ln+1,"%d %lg %lg %lg %lg %lg %lg",&i,s,s+1,s+2,s+3,s+4,s+5)
	     < 7){
	    printf("%s:%d '%s'\n      - bad data%c\n",NmF,L,ln,7);
	    return(1);
	  }
	  i--;
	  MSEga[i][j]	=s[0];
	  MSEgW[i][j]	=s[1];
	  MSEgd[i][j]	=s[2];
	  MSEgq[i][j]	=s[3];
	}
      }
      L++;
      lc	=ln;
    }
    else{
      lc++;
    }
  }
  MSEnS	=j+1;
  MSEnC	=8;

  for(k=0; k < 8; k++){
    if((*lc=fgetc(lF)) != '='){
      ;
    }
    switch(k){
    case 0:
      for(j=0; j < 8; j++){
	ld[j]	=MSER[j];
      }
      break;
    case 1:
      for(j=0; j < 8; j++){
	ld[j]	=MSEZ[j];
      }
      break;
    case 2:
      for(j=0; j < 8; j++){
	ld[j]	=MSEA1[j];
      }
      break;
    case 3:
      for(j=0; j < 8; j++){
	ld[j]	=MSEA5[j];
      }
      break;
    case 4:
      for(j=0; j < 8; j++){
	ld[j]	=MSEA6[j];
      }
      break;
    case 5:
      for(j=0; j < 8; j++){
	ld[j]	=MSEA4[j];
      }
      break;
    case 6:
      for(j=0; j < 8; j++){
	ld[j]	=MSEA3[j];
      }
      break;
    case 7:
      for(j=0; j < 8; j++){
	ld[j]	=MSEA2[j];
      }
      break;
    }
    for(i=0; i < MSEnS; i++){
      L++;
      for(j=0; j < 8; j++){
	if(fscanf(lF,"%lg",ld[j]+i) < 1){
	  printf("%s:%d\n      -wrong data section %d line %d element %d%c\n"
		 ,NmF,L,k,i,j,7);
	  return(1);
	}
      }
    }
  }
  fclose(lF);

  MSEFl	=1;
  memset(MSE,0,NMSE*sizeof(DATAMSE));
  return(0);
}

int PFWriteAngData(FILE *lF)
{
  int i,j;
  for(j=0; j < MSEnS; j++){
    fprintf(lF,"iLos=%d\n",j);
    fprintf(lF,"%4s %7s %7s %7s %7s\n","pini","alpha","Omega","delta","theta");
    for(i=0; i < MSEnC; i++){
      fprintf(lF,"%4d %7.3f %7.3f %7.3f %7.3f\n",i
	     ,MSEga[i][j],MSEgW[i][j],MSEgd[i][j],MSEgq[i][j]);
    }
  }
  return(0);
}

int PFReadAngData(FILE *lF)
{
  int k,i,L=1,j=0;
  char ch,ln[80],*lc;
  double s[4],*ld[8];

#ifdef H
  lc	=ln;
  while(feof(lF) == 0){
    if((*lc=fgetc(lF)) == '\n'){
      *lc	='\0';
      if((lc=strstr(ln,"iLos=")) != NULL){
	lc	+=5;
	if(sscanf(lc,"%d",&j) < 1){
	  char *lD,*lN;
	  CbGetCurrentCbName(&lD,&lN);
	  printf("%s/%s.ai:%d '%s'\n -format for iLos should be 'iLos=ddd'%c\n"
		 ,lD,lN,L,ln,7);
	  return(1);
	}
      }
      else{
	if((lc=strstr(ln,"pini")) == NULL){
	  if(sscanf(ln+1,"%d %lg %lg %lg %lg",&i,s,s+1,s+2,s+3) < 5){
	    char *lD,*lN;
	    CbGetCurrentCbName(&lD,&lN);
	    printf("%s/%s.ai:%d '%s'\n      - bad data%c\n",lD,lN,L,ln,7);
	    return(1);
	  }
	  MSEga[i][j]	=s[0];
	  MSEgW[i][j]	=s[1];
	  MSEgd[i][j]	=s[2];
	  MSEgq[i][j]	=s[3];
	}
      }
      L++;
      lc	=ln;
    }
    else{
      lc++;
    }
  }
  MSEnS	=j+1;
  MSEnC	=8;
  MSEFl	=1;
#endif

  L	=1;
  MSEnS	=25;
  MSEnC	=8;
  for(i=0; i < MSEnS; i++){
    while((ch=fgetc(lF)) != '\n'){
      ;
    }
    L++;
    while((ch=fgetc(lF)) != '\n'){
      ;
    }
    L++;
    for(j=0; j < 8; j++){
      if(fscanf(lF,"%d %lg %lg %lg %lg",&k,s,s+1,s+2,s+3) < 5){
	char *lD,*lN;
	CbGetCurrentCbName(&lD,&lN);
	printf("%s/%s.ai:%d section=%d line=%d \n      - bad data%c\n"
	       ,lD,lN,L,i,j,7);
	return(1);
      }
      MSEga[j][i]	=s[0];
      MSEgW[j][i]	=s[1];
      MSEgd[j][i]	=s[2];
      MSEgq[j][i]	=s[3];
      while((ch=fgetc(lF)) != '\n'){
	;
      }
      L++;
    }
  }

  MSEFl	=1;
  for(k=0; k < 8; k++){
    while((ch=fgetc(lF)) != '=');
    while((ch=fgetc(lF)) != '\n') ;
    L++;
    switch(k){
    case 0:
      for(j=0; j < 8; j++){
	ld[j]	=MSER[j];
      }
      break;
    case 1:
      for(j=0; j < 8; j++){
	ld[j]	=MSEZ[j];
      }
      break;
    case 2:
      for(j=0; j < 8; j++){
	ld[j]	=MSEA1[j];
      }
      break;
    case 3:
      for(j=0; j < 8; j++){
	ld[j]	=MSEA5[j];
      }
      break;
    case 4:
      for(j=0; j < 8; j++){
	ld[j]	=MSEA6[j];
      }
      break;
    case 5:
      for(j=0; j < 8; j++){
	ld[j]	=MSEA4[j];
      }
      break;
    case 6:
      for(j=0; j < 8; j++){
	ld[j]	=MSEA3[j];
      }
      break;
    case 7:
      for(j=0; j < 8; j++){
	ld[j]	=MSEA2[j];
      }
      break;
    }
    for(i=0; i < MSEnS; i++){
      L++;
      for(j=0; j < 8; j++){
	if(fscanf(lF,"%lg",ld[j]+i) < 1){
	  printf("%s:%d\n      -wrong data section %d line %d element %d%c\n"
		 ,"MSEGeom.ai",L,k,i,j,7);
	  return(1);
	}
      }
    }
  }
  for(i=0; i < MSEnS; i++){
    out("sidd","rMSE",i,MSER[0][i],MSEZ[0][i]);
  }
  for(i=0; i < MSEnS; i++){
    out("sidddddd","Ai",i,MSEA1[0][i],MSEA2[0][i],MSEA3[0][i],MSEA4[0][i],MSEA5[0][i],MSEA6[0][i]);
  }
#ifdef H
#endif
  return(0);
}

int PFMSE_GeomAO(FILE *lF)
{
  int i;
  char str[64];
  char ln[128];

  if(MSEFl == 0) return(0);
  strcpy(ln,"%3d %11.4e %11.4e %11.4e %11.4e %11.4e\n %38.4e %11.4e %11.4e%c");
  if(nVVB > 1000) ln[1]='5';
  strcpy(str,ln);
  FormatWrite2Read(str);
  fprintf(lF,"<MSE Geometry>[%d](%s)\n",MSEnS,str);
  fprintf(lF,"!%2s %11s %11s %11s %11s %11s\n!%38s %11s %11s\n",
	  "#","R [m]","Z [m]","Nz","Nr","Nt","Dz","Dr","Dt");

  for(i=0; i < MSEnS; i++){
    fprintf(lF,ln,i,MSER[0][i],MSEZ[0][i],MSEA1[0][i],MSEA5[0][i],MSEA6[0][i]
	    ,MSEA4[0][i],MSEA3[0][i],MSEA2[0][i],'\n');
  }
  fprintf(lF,"!%2s %11s %11s %11s %11s %11s\n!%38s %11s %11s\n",
	  "#","R [m]","Z [m]","Nz","Nr","Nt","Dz","Dr","Dt");
  return(0);
}

int PFMSE_GeomAI(FILE *lF)
{
  char *RNm="PFMSE_GeomAI";
  int i,n,m,L;
  char str[128];
  char *lc;
  char *lv[9];
  int dl[9];

  MSEFl	=0;
  MSEnS	=0;
  m	=9;
  lc	="<MSE Geometry>";
  L	=sizeof(double);
  if(PFIsKeyWordFound(lF,Mess,lc,str,&n)){
    MSEnS	=n;
    i	=0;
    lv[i]=(char*)&i;
    i++;
    lv[i]=(char*)MSER[0];
    i++;
    lv[i]=(char*)MSEZ[0];
    i++;
    lv[i]=(char*)MSEA1[0];
    i++;
    lv[i]=(char*)MSEA5[0];
    i++;
    lv[i]=(char*)MSEA6[0];
    i++;
    lv[i]=(char*)MSEA4[0];
    i++;
    lv[i]=(char*)MSEA3[0];
    i++;
    lv[i]=(char*)MSEA2[0];
    i++;
    dl[0]=0;
    for(i=1; i < m; i++) dl[i]=L;
    if(n == 0){
      sprintf(Mess,"%s:%s n=%d no data\n",RNm,lc,n);
      CbStr2UserMessage(Mess);
    }
    PFReadAI(lF,lc,Mess,str,n,lv,dl,m);
  }
  else{
    sprintf(Mess,"%s:%s not found\n",RNm,lc);
    CbStr2UserMessage(Mess);
    return(1);
  }
  MSEFl	=1;
  return(0);
}

int OldMSEGeom()
{
  int i,j,iC=0,iS=0,kk=0;
  char NmF[64];
  static char str[2][16]={"./","angles.out"};
  double Bt=1.,Br=0.,Bz[2]={-0.2,0.2},gG[2]={-0.2,0.2};
  int n=51;
  double bz[n],gg[n],dBz,ga,gW,gd,gq,s;
  double sga,cga,sgW,cgW,sgd,cgd,sgq,cgq,s1,c1;

#ifndef AscIAng
#undef AscIAng
#endif/*AscIAng*/

#ifndef Tbl_Ang
  if(iC > MSEnC-1) iC=MSEnC-1;
  if(iC < 0) iC=0;
  if(iS > MSEnS-1) iS=MSEnS-1;
  if(iS < 0) iS=0;
  if(kk){
    if(*str[0] != '*'){
      sprintf(NmF,"%s%s",str[0],str[1]);
    }
    else{
      char *lD,*lN;
      CbGetCurrentCbName(&lD,&lN);
      sprintf(NmF,"%s/%s",lD,str[1]);
    }
    if(PFGetMSEAngles(NmF)) *str[1]='*';
    kk	=0;
  }
  dBz	=(Bz[1]-Bz[0])/(n-1);
  
  s1	=cgp/180.;
  ga	=MSEga[iC][iS]*s1;
  gW	=MSEgW[iC][iS]*s1;
  gd	=MSEgd[iC][iS]*s1;
  gq	=MSEgq[iC][iS]*s1;
  sga	=sin(ga);
  cga	=cos(ga);
  sgW	=sin(gW);
  cgW	=cos(gW);
  sgd	=sin(gd);
  cgd	=cos(gd);
  sgq	=sin(gq);
  cgq	=cos(gq);
  s1	=sin(gW+ga);
  c1	=cos(gW+ga);
  gG[0]	=1e+10;
  gG[1]	=-1e+10;
  for(i=0; i < n; i++){
    bz[i]	=Bz[0]+dBz*i;
    s	=-bz[i]*sgq*cgd*s1+sgq*sgd*(Bt*sgW+Br*cgW)+cgq*cgd*(Br*cga-Bt*sga);
    gg[i]	=s != 0. ? -(bz[i]*cgd*c1+sgd*(Br*sgW-Bt*cgW))/s : 0.;
    if(gG[0] > gg[i]) gG[0]=gg[i];
    if(gG[1] < gg[i]) gG[1]=gg[i];
  }
#endif/*Tbl_Ang*/

#ifndef AscOAng
#undef AscOAng
#endif/*AscOAng*/
  return(0);
}

#ifdef H
int OldPickUpMseLS(double *p, int n)
{
  int i;
  double s;
  double vx,vy,vz;
  double x,y,r,cs,sn;

  if(n == 0) return(0);
  nBmod	=n;
  nBmod1=nBmod+1;

  x	=p[4]*cgp/180.;
  vx	=-p[3]*cos(x)/nBmod;
  vy	=p[3]*sin(x)/nBmod;
  vz	=(p[5]-p[2])/nBmod;
  s	=1./sqrt(vx*vx+vy*vy);
  for(i=0; i < 3; i++){
    vBmod[0]	=vx*s;
    vBmod[1]	=vy*s;
    vBmod[2]	=vz*s;
  }
  s	=1./sqrt(vx*vx+vy*vy+vz*vz);
  for(i=0; i < nBmod1; i++){
    x	=p[0]+vx*(nBmod-i);
    y	=p[1]+vy*(nBmod-i);
    zBmod[i]	=p[2]+vz*(nBmod-i);
    xBmod[i]	=x;
    yBmod[i]	=y;
    r	=sqrt(x*x+y*y);
    rBmod[i]	=r;
    cs	=x/r;
    sn	=y/r;
    gfBmod[i]=asin(sn);
    if(x < 0.) gfBmod[i] =y > 0. ? cgp-gfBmod[i] : -cgp-gfBmod[i];
    trBmod[i]=(vx*cs+vy*sn)*s;
    tzBmod[i]=vz*s;
    tfBmod[i]=(vy*cs-vx*sn)*s;
  }
  return(0);
}
#endif

int PickUpMseLS(double *p, int n)
{
  int i,j;
  double s;
  double vx,vy,vz;
  double x,y,r,cs,sn;

  if(n == 0) return(0);
  nMSS	=n+1;
  MSSFl	=1;
  x	=p[4]*cgp/180.;
  vx	=-p[3]*cos(x)/n;
  vy	=p[3]*sin(x)/n;
  vz	=(p[5]-p[2])/n;
  s	=1./sqrt(vx*vx+vy*vy);
  for(i=0; i < nMSS; i++){
    MSS[i].vx	=vx*s;
    MSS[i].vy	=vy*s;
    MSS[i].vz	=vz*s;
  }
  s	=1./sqrt(vx*vx+vy*vy+vz*vz);
  j=nMSS;
  for(i=0; i < nMSS; i++){
    j--;
    x	=p[0]+vx*j;
    y	=p[1]+vy*j;
    MSS[i].z	=p[2]+vz*j;
    MSS[i].x	=x;
    MSS[i].y	=y;
    r	=sqrt(x*x+y*y);
    MSS[i].r	=r;
    cs	=x/r;
    sn	=y/r;
    MSS[i].gf=asin(sn);
    if(x < 0.) MSS[i].gf =y > 0. ? cgp-MSS[i].gf : -cgp-MSS[i].gf;
    MSS[i].tr=(vx*cs+vy*sn)*s;
    MSS[i].tz=vz*s;
    MSS[i].tf=(vy*cs-vx*sn)*s;
    MSE[i].w	=1.;
    MSE[i].kA	=0x0f;
  }
  return(0);
}

int PickUpMseLP(double *p,int n)
{
  int i;
  double vx,vy,vz;
  double x,y;

  if(n == 0) return(0);
  nMSE	=n+1;
  MSEFl	=1;
  memset(MSE,0,NMSE*sizeof(DATAMSE));
  x	=p[4]*cgp/180.;
  vx	=-p[3]*cos(x)/n;
  vy	=p[3]*sin(x)/n;
  vz	=(p[5]-p[2])/n;
  for(i=0; i < nMSE; i++){
    x	=p[0]+vx*(n-i);
    y	=p[1]+vy*(n-i);
    MSE[i].x	=x;
    MSE[i].y	=y;
    MSE[i].z	=p[2]+vz*(n-i);
    MSE[i].r	=sqrt(x*x+y*y);
    MSE[i].w	=1.;
    MSE[i].kA	=0x0f;
    y	/=MSE[i].r;
    MSE[i].gf=asin(y);
    if(x < 0.) MSE[i].gf =y > 0. ? cgp-MSE[i].gf : -cgp-MSE[i].gf;
  }
  return(0);
}

int MSEGeomAO(FILE *lF)
{
  int i,k,LN,LP,LS,LT,LA;
  char str[0x80];
  char ln[0x80];

  strcpy(ln,"%3d %8.4f %8.4f %8.4f %7.4f %6.2f %6.2f %6.2f %6.2f %6.2f%c");
  strcpy(str,ln);
  FormatWrite2Read(str);
  fprintf(lF,"<MSE-LP PickUp Points>[%d](%s)\n",nMSE,str);
  fprintf(lF,"!%2s %8s %8s %8s %7s %6s %6s %6s %6s %6s\n",
	  "#","x [m]","y [m]","z [m]","r [m]","gf^o"
	  ,"gd^o","gq^o","ga^o","gW^o");
  for(i=0; i < nMSE; i++){
    fprintf(lF,ln,i,MSE[i].x,MSE[i].y,MSE[i].z,MSE[i].r,MSE[i].gf
	    ,MSE[i].gd,MSE[i].gq,MSE[i].ga,MSE[i].gW,'\n');
  }
  fprintf(lF,"!%2s %8s %8s %8s %7s %6s %6s %6s %6s %6s\n",
	  "#","x [m]","y [m]","z [m]","r [m]","gf^o"
	  ,"gd^o","gq^o","ga^o","gW^o");

  strcpy(ln,"%3d %8.4f %8.4f %8.4f %7.4f %6.2f %6.2f %6.2f %6.2f %6.2f%c");
  strcpy(str,ln);
  FormatWrite2Read(str);
  fprintf(lF,"\n<MSE-LS PickUp Points>[%d](%s)\n",nMSS,str);
  fprintf(lF,"!%2s %8s %8s %8s %7s %6s %6s %6s %6s %6s\n",
	  "#","x [m]","y [m]","z [m]","r [m]","gf^o"
	  ,"gd^o","gq^o","ga^o","gW^o");
  for(i=0; i < nMSS; i++){
    fprintf(lF,ln,i,MSS[i].x,MSS[i].y,MSS[i].z,MSS[i].r,MSS[i].gf
	    ,MSS[i].gd,MSS[i].gq,MSS[i].ga,MSS[i].gW,'\n');
  }
  fprintf(lF,"!%2s %8s %8s %8s %7s %6s %6s %6s %6s %6s\n",
	  "#","x [m]","y [m]","z [m]","r [m]","gf^o"
	  ,"gd^o","gq^o","ga^o","gW^o");

  if(nMSS){
    int i0[8],n=0;
    double vx=0.,vy=0.,vz=0.;
    for(i=0; i < nMSS; i++){
      if(fabs(MSS[i].vx-vx) > 1e-8
	 || fabs(MSS[i].vy-vy) > 1e-8
	 || fabs(MSS[i].vz-vz) > 1e-8){
	vx	=MSS[i].vx;
	vy	=MSS[i].vy;
	vz	=MSS[i].vz;
	i0[n]	=i;
	n++;
      }
    }
    i0[n]	=nMSS;
    fprintf(lF,"<MSE-LS Beam Vector>[%d](%s)\n",n,"3%e %d %d");
    fprintf(lF,"!%11s %12s %12s %2s %2s\n","vx","vy","vz","i0","i1");
    for(k=0; k < n; k++){
      i	=i0[k];
      fprintf(lF,"%12.5e %12.5e %12.5e %2d %2d\n"
	      ,MSS[i].vx,MSS[i].vy,MSS[i].vz,i0[k],i0[k+1]);
    }
    fprintf(lF,"!%11s %12s %12s %2s %2s\n","vx","vy","vz","i0","i1");
  }else{
    fprintf(lF,"<MSE-LS Beam Vector>[%d](%s)\n",0,"3%e %d %d");
  }
  return(0);
}

int MSEGeomAI(FILE *lF)
{
  extern int nBeam;
  extern double Err4Beam[][4];
  int i,n,m,kD,L;
  int i0[4],i1[4];
  double vx[4],vy[4],vz[4];
  char str[128];
  char *lc,*lm;
  char *lv[0x10];
  int dl[0x10];
  SIGHTLINE *lS;
  double t,*ld;
  double ga,gW,gd,gq,sga,cga,sgW,cgW,sgd,cgd,sgq,cgq;
  double x,y;
 
  kD	=sizeof(double);
  L	=sizeof(DATAMSE);
  m	=10;
  lm	="MSEGeom.ai";
  lc	="<MSE-LP PickUp Points>";
  if(IsKeyWordFound(lF,lm,lc,str,&n)){
    memset(MSE,0,NMSE*sizeof(DATAMSE));
    MSEFl	=1;
    nMSE	=n;
    i	=0;
    lv[i]=(char*)&i;
    i++;
    lv[i]=(char*)&MSE[0].x;
    i++;
    lv[i]=(char*)&MSE[0].y;
    i++;
    lv[i]=(char*)&MSE[0].z;
    i++;
    lv[i]=(char*)&MSE[0].r;
    i++;
    lv[i]=(char*)&MSE[0].gf;
    i++;
    lv[i]=(char*)&MSE[0].gd;
    i++;
    lv[i]=(char*)&MSE[0].gq;
    i++;
    lv[i]=(char*)&MSE[0].ga;
    i++;
    lv[i]=(char*)&MSE[0].gW;
    i++;
    dl[0]=0;
    for(i=1; i < m; i++) dl[i]=L;
    if(n == 0) CbStr2UserWarning("%s:%s no data\n",lm,lc);
    else ReadAI(lF,lc,lm,str,n,lv,dl,m);
  }
  else{
    CbStr2UserWarning("Error:%s:%s is absent\n",lm,lc);
    rewind(lF);
  }

  t	=cgp/180.;
  for(i=0; i < nMSE; i++){
    MSE[i].w	=1.;
    MSE[i].kA	=1;
    gd	=MSE[i].gd*t;
    gq	=MSE[i].gq*t;
    ga	=MSE[i].ga*t;
    gW	=MSE[i].gW*t;

    sga	=sin(ga);
    cga	=cos(ga);
    sgW	=sin(gW);
    cgW	=cos(gW);
    sgd	=sin(gd);
    cgd	=cos(gd);
    sgq	=sin(gq);
    cgq	=cos(gq);

    ld		=MSE[i].P;
    ld[0]	=-sgW*sgd; /*B_r*/
    ld[1]	=cgd*cos(gW+ga); /*B_z*/
    ld[2]	=-cgW*sgd; /*B_\gf*/
    ld[3]	=cga*cgq*cgd+cgW*sgq*sgd; /*B_r*/
    ld[4]	=sgq*cgd*sin(gW+ga); /*B_z*/
    ld[5]	=sga*cgq*cgd-sgW*sgq*sgd; /*B_\gf*/
  }

  lc	="<MSE-LS PickUp Points>";
  if(IsKeyWordFound(lF,lm,lc,str,&n)){
    memset(MSS,0,NMSE*sizeof(DATAMSE));
    MSSFl	=1;
    nMSS	=n;
    if(n){
      i	=0;
      lv[i]=(char*)&i;
      i++;
      lv[i]=(char*)&MSS[0].x;
      i++;
      lv[i]=(char*)&MSS[0].y;
      i++;
      lv[i]=(char*)&MSS[0].z;
      i++;
      lv[i]=(char*)&MSS[0].r;
      i++;
      lv[i]=(char*)&MSS[0].gf;
      i++;
      lv[i]=(char*)&MSS[0].gd;
      i++;
      lv[i]=(char*)&MSS[0].gq;
      i++;
      lv[i]=(char*)&MSS[0].ga;
      i++;
      lv[i]=(char*)&MSS[0].gW;
      i++;
      dl[0]=0;
      for(i=1; i < m; i++) dl[i]=L;
      ReadAI(lF,lc,lm,str,n,lv,dl,m);
    }else{
      CbStr2UserWarning("%s:%s no data\n",lm,lc);
      rewind(lF);
    }
    m	=9;
    lc	="<MSE-LS Beam Vector>";
    if(IsKeyWordFound(lF,lm,lc,str,&n)){
      nBeam	=n;
      i	=0;
      lv[i]=(char*)vx;
      dl[i]=sizeof(double);
      i++;
      lv[i]=(char*)vy;
      dl[i]=sizeof(double);
      i++;
      lv[i]=(char*)vz;
      dl[i]=sizeof(double);
      i++;
      lv[i]=(char*)Err4Beam[0];
      dl[i]=4*LDBL;
      i++;
      lv[i]=(char*)(Err4Beam[0]+1);
      dl[i]=4*LDBL;
      i++;
      lv[i]=(char*)(Err4Beam[0]+2);
      dl[i]=4*LDBL;
      i++;
      lv[i]=(char*)(Err4Beam[0]+3);
      dl[i]=4*LDBL;
      i++;

      lv[i]=(char*)i0;
      dl[i]=sizeof(int);
      i++;
      lv[i]=(char*)i1;
      dl[i]=sizeof(int);
      if(n) ReadAI(lF,lc,lm,str,n,lv,dl,m);
      for(m=0; m < n; m++){
	for(i=i0[m]; i < i1[m]; i++){
	  MSS[i].w	=1.;
	  MSS[i].kA	=1;
	  MSS[i].vx	=vx[m];
	  MSS[i].vy	=vy[m];
	  MSS[i].vz	=vz[m];

	  MSS[i].m	=m;
	  MSS[i].errR	=Err4Beam[m][2];
	  MSS[i].errA	=Err4Beam[m][3];
	}
      }
    }
    else{
      CbStr2UserWarning("Error:%s:%s is absent\n",lm,lc);
      return(1);
    }
    for(m=0; m < nBeam; m++){
      for(i=i0[m]; i < i1[m]; i++){
	MSE[i].m	=m;
	MSE[i].errR	=Err4Beam[m][0];
	MSE[i].errA	=Err4Beam[m][1];
      }
    }
  }

  L	=sizeof(SIGHTLINE);
  lS	=SightP;
  m	=7;
  lc	="<Polarimetry SightLines>";
  if(IsKeyWordFound(lF,lm,lc,str,&n)){
    lS	=SightP;
    nSightP	=n;
    i	=0;
    lv[i]=(char*)&i;
    i++;
    lv[i]=(char*)lS->x;
    i++;
    lv[i]=(char*)lS->y;
    i++;
    lv[i]=(char*)lS->z;
    i++;
    lv[i]=(char*)(lS->x+1);
    i++;
    lv[i]=(char*)(lS->y+1);
    i++;
    lv[i]=(char*)(lS->z+1);
    i++;
    dl[0]=0;
    for(i=1; i < m; i++) dl[i]=L;
    if(n == 0) CbStr2UserWarning("%s:%s no data\n",lm,lc);
    else ReadAI(lF,lc,lm,str,n,lv,dl,m);

    for(i=0,lS=SightP; i < n; i++,lS++){
      x	=lS->x[0];
      y	=lS->y[0];
      lS->rP[0]=sqrt(x*x+y*y);
      x	=lS->x[1];
      y	=lS->y[1];
      lS->rP[1]=sqrt(x*x+y*y);
      lS->tx	=lS->x[1]-lS->x[0];
      lS->ty	=lS->y[1]-lS->y[0];
      lS->tz	=lS->z[1]-lS->z[0];
      lS->tE[0]	=0.;
      lS->tE[1]	=0.;
      lS->n1	=0;
    }
  }
  else{
    CbStr2UserWarning("Error:%s:%s is absent\n",lm,lc);
    rewind(lF);
  }
  return(0);
}

int MSEDiagnosticPlot()
{
  int i,k;
  for(i=0; i < nMSE; i++){
    k	=MSE[i].kA ? 14 : 14;
    ZPlotIntRect(MSE[i].r,MSE[i].z,2,2,k);
  }
  for(i=0; i < nMSS; i++){
    k	=MSS[i].kA ? 4 : 4;
    ZPlotIntRect(MSS[i].r,MSS[i].z,2,2,k);
  }
  return(0);
}

void MSEPickUpPlot(double x0,double y0,double sc)
{
  int j;
  double x[ESNp1],y[ESNp1];
  double r;

  if(nMSE || nMSS){
    ZColor(14);
    r	=scMSE*0.5*(RplG[0]+RplG[1]);
    for(j=0; j < ESNp1; j++){
      x[j]	=x0Mse+r*EScs1[j];
      y[j]	=y0Mse+r*ESsn1[j];
    }
    ZPlotPolyLine(x,y,ESNp1);
    ZColor(4);
    r	=scMSE*RplG[1];
    for(j=0; j < ESNp1; j++){
      x[j]	=x0Mse+r*EScs1[j];
      y[j]	=y0Mse+r*ESsn1[j];
    }
    ZPlotPolyLine(x,y,ESNp1);
    r	=scMSE*RplG[0];
    for(j=0; j < ESNp1; j++){
      x[j]	=x0Mse+r*EScs1[j];
      y[j]	=y0Mse+r*ESsn1[j];
    }
    ZPlotPolyLine(x,y,ESNp1);
    if(nMSE){
      for(j=0; j < nMSE; j++){
	ZPlotIntRect(x0Mse+scMSE*MSE[j].y,y0Mse-scMSE*MSE[j].x,1,1,14);
	ZPlotIntRect(MSE[j].r,MSE[j].z,1,1,14);
      }
    }
    if(nMSS){
      for(j=0; j < nMSS; j++){
	ZPlotIntRect(x0Mse+scMSE*MSS[j].y,y0Mse-scMSE*MSS[j].x,1,1,4);
	ZPlotIntRect(MSS[j].r,MSS[j].z,1,1,4);
      }
      ZColor(11);
      j	=nMSS-1;
      x[2]	=MSS[j].x-MSS[j].y;
      y[2]	=MSS[j].y-MSS[j].y;
      x[2]	=sqrt(x[2]*x[2]+y[2]*y[2]);
      j	=nMSS/2;
      x[0]	=x0Mse+scMSE*(MSS[j].y-x[2]*MSS[j].vy);
      x[1]	=x0Mse+scMSE*(MSS[j].y+x[2]*MSS[j].vy);
      y[0]	=y0Mse-scMSE*(MSS[j].x-x[2]*MSS[j].vx);
      y[1]	=y0Mse-scMSE*(MSS[j].x+x[2]*MSS[j].vx);
      ZPlotPolyLine(x,y,2);
    }
  }
  return;
}

void SightLinesFPlot()
{
  SIGHTLINE *lS;
  double x,y,r[2],z[2];
  int i,j,n1;

  ZColor(13);
  for(i=0,lS=SightP; i < nSightP; i++,lS++){
    r[0]	=lS->rP[0];
    z[0]	=lS->z[0];
    r[1]	=r[0]+(lS->rP[1]-lS->rP[0])*lS->tE[0];
    z[1]	=z[0]+lS->tz*lS->tE[0];
    ZPlotPolyLine(r,z,2);
    ZColor(12);
    r[0]	=r[1];
    z[0]	=z[1];
    r[1]	=lS->rP[0]+(lS->rP[1]-lS->rP[0])*lS->tE[1];
    z[1]	=lS->z[0]+lS->tz*lS->tE[1];
    ZPlotPolyLine(r,z,2);
    ZColor(13);
    r[0]	=r[1];
    z[0]	=z[1];
    r[1]	=lS->rP[1];
    z[1]	=lS->z[1];
    ZPlotPolyLine(r,z,2);
    n1	=lS->n1;
    for(j=0; j < n1; j++){
      x	=lS->x[0]+lS->tx*lS->t[j];
      y	=lS->y[0]+lS->ty*lS->t[j];
      r[0]	=sqrt(x*x+y*y);
      z[0]	=lS->z[0]+lS->tz*lS->t[j];
      ZPlotIntRect(r[0],z[0],2,2,14);
    }
  }

  return;
}

void MSEGeomPlot()
{
  extern void IbPFCPlot();

  if(nPFC) IbPFCPlot();
  else LimPlot0();
  if(nMSE || nMSS) MSEPickUpPlot(x0Mse,y0Mse,scMSE);
  if(nSightP) SightLinesFPlot();
  return;
}

int MSEGeom()
{
  int i,iALP=1,iALS=1,nLP=0,nLS=0;
  extern void IbPFCPlot();
  double P[6]={1.,0.,0.,0.5,0.,0.};
  double S[6]={1.,0.,0.,0.5,0.,0.};
  double x[2],y[2];
  double x0=0.,y0=0.,z0=0.;
  double gwLP=0,gwLS=0,LLP=0.5,LLS=0.5;
  double rx,ry;

  int k;
#ifndef AscI_MSEGeom
#undef AscI_MSEGeom
#endif/*AscI_MSEGeom*/

  if(nMSE){
    i	=nMSE-1;
    P[0]	=MSE[i].x;
    P[1]	=MSE[i].y;
    P[2]	=MSE[i].z;
    rx	=P[0]-MSE[0].x;
    ry	=P[1]-MSE[0].y;
    LLP	=sqrt(rx*rx+ry*ry);
    gwLP=asin(ry/LLP)*360.*cr2gp;
    P[3]	=LLP;
    P[4]	=gwLP;
    P[5]	=MSE[0].z;
    nLP	=nMSE-1;
  }
  if(nMSS){
    i	=nMSS-1;
    S[0]	=MSS[i].x;
    S[1]	=MSS[i].y;
    S[2]	=MSS[i].z;
    rx	=S[0]-MSS[0].x;
    ry	=S[1]-MSS[0].y;
    LLS	=sqrt(rx*rx+ry*ry);
    gwLS=asin(ry/LLS)*360.*cr2gp;
    S[3]	=LLS;
    S[4]	=gwLS;
    S[5]	=MSS[0].z;
    nLS	=nMSS-1;
  }
  x[0]	=ESRLm[0];
  x[1]	=x[0];
  y[0]	=0.;
  y[1]	=0.;
  for(i=0; i < ESnLm; i++){
    if(x[0] > ESRLm[i]) x[0]=ESRLm[i];
    if(x[1] < ESRLm[i]) x[1]=ESRLm[i];
    if(y[0] > ESZLm[i]) y[0]=ESZLm[i];
    if(y[1] < ESZLm[i]) y[1]=ESZLm[i];
  }
  x0Mse	=1.5*RplG[1]-RplG[0];
  y0Mse	=0.75*ZplG[1];
#ifndef Tbl_MSEGeom
  i	=nMSE-1;
  if(nMSE-1 != nLP || P[0] != MSE[i].x || P[1] != MSE[i].y
     || P[2] != MSE[i].z || P[5] != MSE[0].z || P[3] != LLP
     ||  P[4] != gwLP){
    P[3]	=LLP;
    P[4]	=gwLP;
    PickUpMseLP(P,nLP);
  }
  i	=nMSS-1;
  if(nMSS-1 != nLS || S[0] != MSS[i].x || S[1] != MSS[i].y
     || S[2] != MSS[i].z || S[5] !=  MSS[0].z || S[3] != LLS
     ||  S[4] != gwLS){
    S[3]	=LLS;
    S[4]	=gwLS;
    PickUpMseLS(S,nLS);
  }
  CbUserPlot=nMSE || nMSS ? MSEGeomPlot : IbPFCPlot;
#endif/*Tbl_MSEGeom*/
#ifndef AscO_MSEGeom
#undef AscO_MSEGeom
#endif/*AscO_MSEGeom*/
  return(0);
}

int SigLayOutAO(FILE *lF)
{
  int i,j,k,m,n,L0,LN;
  char str[0x100],str1[0x100];
  RAWDATA *lS;

  if(nRawS == 0) return(0);
  fputs("! Signal=C/G(RawS-A*t-B), kG - group number,"
	" kA=0/1 - activity\n",lF);
  fprintf(lF,"<Layout of Signals>[%d](%%d%%s 3%%d 9%%e)\n",nRawS);
  LN	=4;
  for(i=0; i < nRawS; i++){
    j=strlen(RawS[i].Nm);
    if(LN < j) LN=j;
  }
  i	=0;
  for(k=0; k < nDGr; k++) if(i < DGr[k].k) i=DGr[k].k;
  L0	=4;
  if(i < 1000) L0=3;
  if(i < 100) L0=2;

  sprintf(str1,"!%c%ds %c%ds%s%ds%s",'%',L0-1,'%',LN
	  ,"%3s%3s%4s%11s%11s%11s%11s%11s\n!%",L0+LN+21,"%11s%11s%11s\n");
  fprintf(lF,str1,"#","Name","kA","Gr","c","C","Gain","A","B"
	  ,"Error dS","Error dC","Error dG","Error dA","Error dB");
  sprintf(str,"%c%dd %c%ds%s%d.3e %s",'%',L0,'%',LN
	  ,"%3d%3d%4d%11.3e%11.3e%11.3e%11.3e%11.3e\n%",L0+LN+22
	  ,"%10.3e %10.3e %10.3e\n");
  lS=RawS;
  for(k=0; k < nDGr; k++){
    n	=DGr[k].k;
    for(j=0,i=DGr[k].k0; j < n; j++,i++){
      fprintf(lF,str,j,lS->Nm,lS->kA,lS->kG,lS->c,lS->C,lS->G,lS->A,lS->B
	      ,lS->dS,lS->dC,lS->dG,lS->dA,lS->dB);
      lS++;
    }
  }
  fprintf(lF,str1,"#","Name","kA","Gr","c","C","Gain","A","B"
	  ,"Error dS","Error dC","Error dG","Error dA","Error dB");
  
  lS=RawP;
  for(k=0; k < nPGr; k++){
    n	=PGr[k].k;
    m	=PGr[k].na1;
    for(j=0; j < n; j++){
      fprintf(lF,"\n<%s[%d][%d]>[%d](%s)\n",lS->Nm,k,j,m,"%d %e %e");
      fprintf(lF,"%2s%11s%11s\n","!#","errR","errA");
      for(i=0; i < m; i++)
	fprintf(lF,"%2d%11.3e%11.3e\n",i,lS->errR[i],lS->errA[i]);
      lS++;
    }
    fprintf(lF,"%2s%11s%11s\n","!#","errR","errA");
  }

  fprintf(lF,"\nBad sensors:\n");
  lS=RawS;
  for(k=0; k < nDGr; k++){
    n	=DGr[k].k;
    for(j=0,i=DGr[k].k0; j < n; j++,i++){
      if(lS->kA == 0){
	fprintf(lF,"Nm[%2d][%2d] %d <%s>\n",k,j,lS->kA,lS->Nm);
      }
      lS++;
    }
  }
  return(0);
}

int SigLayOutAI(FILE *lf)
{
  int i,j,k,n,m,L;
  char str[0x80],ln[0x80];
  char *lc,*lm;
  char *lv[16];
  int dl[16];
  int kS[nRaw];
  RAWDATA *lS;
  L	=sizeof(RAWDATA);
  m	=14;

  lm	="SigLayOut.ai";
  lc	="<Layout of Signals>";
  if(IsKeyWordFound(lf,lm,lc,str,&n)){
    if(nRawS != n){
      CbStr2UserWarning("Error:%s: %s nRaw =%d != %d signals\n",lm,lc,nRawS,n);
      printf("Error:%s: %s nRawS =%d != %d signals\n",lm,lc,nRawS,n);
      return(1);
    }
    i	=0;
    lv[i]=(char*)&j;
    i++;
    lv[i]=RawS[0].Nm;
    i++;
    lv[i]=(char*)&RawS[0].kA;
    i++;
    lv[i]=(char*)&RawS[0].kG;
    i++;
    lv[i]=(char*)&RawS[0].c;
    i++;
    lv[i]=(char*)&RawS[0].C;
    i++;
    lv[i]=(char*)&RawS[0].G;
    i++;
    lv[i]=(char*)&RawS[0].A;
    i++;
    lv[i]=(char*)&RawS[0].B;
    i++;
    lv[i]=(char*)&RawS[0].dS;
    i++;
    lv[i]=(char*)&RawS[0].dC;
    i++;
    lv[i]=(char*)&RawS[0].dG;
    i++;
    lv[i]=(char*)&RawS[0].dA;
    i++;
    lv[i]=(char*)&RawS[0].dB;
    dl[0]=0;
    for(i=1; i < m; i++) dl[i]=L;
    ReadAI(lf,lc,lm,str,n,lv,dl,m);
  }
  else{
    CbStr2UserWarning("Error: %s: %s is absent\n",lm,lc);
    printf("Error: %s: %s is absent\n",lm,lc);
    return(1);
  }
  
  lS=RawP;
  lc	=ln;
  dl[0]	=0;
  dl[1]	=sizeof(double);
  dl[2]	=sizeof(double);
  for(k=0; k < nPGr; k++){
    n	=PGr[k].k;
    m	=PGr[k].na1;
    for(j=0; j < n; j++){
      sprintf(ln,"<%s[%d][%d]>",lS->Nm,k,j);
      if(IsKeyWordFound(lf,lm,lc,str,&i)){
	if(m != i){
	  CbStr2UserWarning("Error:%s: %s na1[%d][%d]=%d != %d a[i]\n"
			    ,lm,lc,k,j,m,i);
	  printf("Error:%s: %s na1[%d][%d]=%d != %d a[i]\n",lm,lc,k,j,m,i);
	  return(1);
	}
	lv[0]=(char*)&i;
	lv[1]=(char*)lS->errR;
	lv[2]=(char*)lS->errA;
	ReadAI(lf,lc,lm,str,m,lv,dl,3);
      }
      lS++;
    }
  }
  m	=14;
  lc	="<Layout of Profiles>";
  if(IsKeyWordFound(lf,lm,lc,str,&n)){
    if(nRawP != n){
      CbStr2UserWarning("Error:%s: %s nRawP =%d != %d signals\n",lm,lc,nRawP,n);
      printf("Error:%s: %s nRawP =%d != %d signals\n",lm,lc,nRawP,n);
      return(1);
    }
    i	=0;
    lv[i]=(char*)&j;
    i++;
    lv[i]=RawP[0].Nm;
    i++;
    lv[i]=(char*)&RawP[0].kA;
    i++;
    lv[i]=(char*)&RawP[0].kG;
    i++;
    lv[i]=(char*)&RawP[0].m;
    i++;
    lv[i]=(char*)&RawP[0].C;
    i++;
    lv[i]=(char*)&RawP[0].G;
    i++;
    lv[i]=(char*)&RawP[0].A;
    i++;
    lv[i]=(char*)&RawP[0].B;
    i++;
    lv[i]=(char*)&RawP[0].dS;
    i++;
    lv[i]=(char*)&RawP[0].dC;
    i++;
    lv[i]=(char*)&RawP[0].dG;
    i++;
    lv[i]=(char*)&RawP[0].dA;
    i++;
    lv[i]=(char*)&RawP[0].dB;
    dl[0]=0;
    for(i=1; i < m; i++) dl[i]=L;
    ReadAI(lf,lc,lm,str,n,lv,dl,m);
  }
  else{
    CbStr2UserWarning("Error: %s: %s is absent\n",lm,lc);
    printf("Error: %s: %s is absent\n",lm,lc);
    return(1);
  }
  return(0);
}

int SetSensorC(double *SensorC,double *SensorG)
{
  RAWDATA *lS;
  int k,j,m,i;

  lS	=RawS;
  i	=0;
  for(k=0; k < 4; k++){
    m	=DGr[k].k;
    while(m){
      m--;
      lS->C	=SensorC[i];
      if(SensorG[i] != 0. || lS->kG > 3){
	lS->G=SensorG[i];
      }
      else{
	lS->kA=0;
	lS->c=0;
      }
      lS++;
      i++;
    }
  }
  return(0);
}

int PFSig2Raw()
{
  int j,i;
  RAWDATA *lR;
  RAWDATA *lS;

  lS	=RawS;
  lS->kA=1;
  if(lS->c == 0)lS->c =1;
  for(j=0; j < nRawS; j++){
    lR		=Raw+lS->kS;	
    lR->C	=lS->C;
    lR->G	=lS->G;
    lR->A	=lS->A;
    lR->B	=lS->B;
    lR->dC	=lS->dC;
    lR->dG	=lS->dG;
    lR->dA	=lS->dA;
    lR->dB	=lS->dB;
    lR->dS	=lS->dS;
    lR->kA	=lS->kA;
    lR->kG	=lS->kG;
    if(lS->kA == 0) lS->c=0;
    lR->c	=lS->c;
    lS++;
  }

#ifdef H
  lR		=Raw;
  for(j=0; j < nRaw; j++){
    if(lR->kA == 0) lR->c=0;
    out("&&--&& Ri i II I <c><s>"
	,j,lR->kS,lR->kA,lR->c,lR->kG,lR->c == 0 ? '*' : ' '
	,lR->Nm);
    lR++;
  }
#endif
  return(0);
}

void SigLayOutXW()
{
  int i,j,i0,i1,n,kG;
  double x[2],y[2];
  RAWDATA *lR;
  if(kG1 == 0){
    i0	=0;
    i1	=nRaw;
    kG	=0;
  } 
  else{
    kG	=kG1-1;
    lR	=RawS+DGr[kG].k0;
    i0	=lR->kS;
    lR	=RawS+DGr[kG].k1;
    i1	=kG1 < nDGr ? lR->kS : nRaw;
  }
  y[0]=0.;
  for(i=i0,lR=Raw+i0; i < i1; i++,lR++){
    x[0]	=i;
    x[1]	=x[0];
    y[1]	=lR->kG;
    if(lR->kA && (i == 0 || lR->kS)){
      ZColor(kCol[lR->c-1]);
      ZPlotPolyLine(x,y,2);
    }
  }
  return;
}

int SigLayOut()
{
  static int Fl=0,kG;
  int i,i0,i1,j,k,m,nY;
  int n1;
  static char Img[16]="";
  double Y[3]={0.,0.,0.};

  double B[16][nRaw];
  char *Nm[nRaw];
  double x[nRaw];
  double g[nRaw];
  RAWDATA *lR,*lS;
  /*See ToDo*/
  for(k=0; k < nPGr; k++){
    m	=PGr[k].na1;
    if(m){
      for(j=0,lR=RawP+PGr[k].k0; j < PGr[k].k; j++,lR++){
	if(lR->errA != NULL) free(lR->errA);
	lR->errA=(double*)calloc(2*m,sizeof(double));
	lR->errR=lR->errA+m;
	for(i=0; i < m; i++) lR->errR[i]=0.01;
      }
    }
  }

#ifndef AscI_SigLayOut
#undef AscI_SigLayOut
#endif/*AscI_SigLayOut*/

#ifndef BnrI_SigLayOut
#undef BnrI_SigLayOut
#endif/*BnrI_SigLayOut*/

  if(nRawS == 0){
    CbStr2UserWarning("Warning: No SigLayOut\n");
    return(0);
  }
  PFSig2Raw();

#ifndef Tbl_SigLayOut
  if(kG1 == 0){
    i0	=0;
    i1	=nRaw;
    kG	=0;
  } 
  else{
    kG	=kG1-1;
    lS	=RawS+DGr[kG].k0;
    i0	=lS->kS;
    lS	=RawS+DGr[kG].k1;
    i1	=kG1 < nDGr ? lS->kS : nRaw;
  }
  m	=0;
  lR	=Raw+i0;
  j	=0;
  for(i=i0; i < i1; i++){
    x[j]	=i;
    Nm[j]	=lR->Nm;
    if(lR->kA && (i == 0 || lR->kS)){
      B[0][j]=lR->kG;
      B[1][j]=lR->C;
      B[2][j]=lR->G;
      B[3][j]=lR->A;
      B[4][j]=lR->B;
      B[5][j]=lR->dC;
      B[6][j]=lR->dG;
      B[7][j]=lR->dA;
      B[8][j]=lR->dB;
      m++;
    }
    else{
      B[0][j]=0.;
      B[1][j]=0.;
      B[2][j]=0.;
      B[3][j]=0.;
      B[4][j]=0.;
      B[5][j]=0.;
      B[6][j]=0.;
      B[7][j]=0.;
      B[8][j]=0.;
    }
    j++;
    lR++;
  }
  lR	=Raw+i0;
  n1	=i1-i0;	
  CbUserPlot	=SigLayOutXW;
#endif/*Tbl_SigLayOut*/

#ifndef AscO_SigLayOut
#undef AscO_SigLayOut
#endif/*AscO_SigLayOut*/
  return(0);
}

int PFSetTimeRange(int kG)
{
  int i,j,k,n;
  int i1,ii,i2;
  double *lt;
  
  for(k=0; k <= kG; k++){
    if(DGr[k].k && DGr[k].n){
      j	=DGr[k].k0;
      lt	=DGr[k].t;
      n	=DGr[k].n-1;
      if(PFtWF1 < lt[0]) PFtWF1=lt[0];
      if(PFtWF2 > lt[n]) PFtWF2=lt[n];
    }
  }

  if(PFtWF < PFtWF1) PFtWF=PFtWF1;
  if(PFtWF > PFtWF2) PFtWF=PFtWF2;
  for(k=0; k <= kG; k++){
    if(DGr[k].k && DGr[k].n){
      j	=DGr[k].k0;
      lt	=DGr[k].t;
      n	=DGr[k].n;
      i2	=0;
      ii	=0;
      i1	=0;
      for(i=0; i < n; i++){
	if(lt[i] <= PFtWF1) i1=i;
	if(lt[i] <= PFtWF)  ii=i;
	if(lt[i] <= PFtWF2) i2=i;
      }
      i2++;
      if(ii >= i2) ii=i2-1;
      DGr[k].i0	=i1;
      DGr[k].i	=ii;
      DGr[k].i1	=i2;
      if(k < nDGr){
	n	=DGr[k].k1;
	for(i=DGr[k].k0; i < n; i++){
	  RawS[i].i1=i1;
	  RawS[i].i	=ii;
	  RawS[i].i2=i2;
	  j	=RawS[i].kS;
	  Raw[j].i1	=i1;
	  Raw[j].i	=ii;
	  Raw[j].i2	=i2;
	}
      }
      else{
	n	=PGr[k-nDGr].k1;
	for(i=PGr[k-nDGr].k0; i < n; i++){
	  RawP[i].i1=i1;
	  RawP[i].i=ii;
	  RawP[i].i2=i2;
	}
      }
    }
  }
  return(0);
}

int PlotRawWF(int kG)
{
  int i,j,i1,i2,n;
  double *lt,*ld;
  double s,dS,Sm[0x20],SmP[0x20],SmM[0x20],Sm2[0x20];
  double C,G,A,B,dC,dG,dA,dB;
  int nSm,nSm1,iSm;
  RAWDATA *lR,*lS;
  char ln[0x40];

  if(DGr[kG].n == 0) return(0);
  nSm	=16;
  nSm1	=nSm+1;
  i1	=DGr[kG].i0;
  i2	=DGr[kG].i1;
  iSm	=DGr[kG].i-nSm1/2;
  if(iSm < 0) iSm=0;
  n	=DGr[kG].n;
  if(iSm+nSm1 > n) iSm=n-nSm1;
  n	=i2-i1;
  lt	=DGr[kG].T+iSm;
  ZColor(0);
  i=sprintf(ln,"%s",TypeNm[DGr[kG].kt]);
  ZPlotUTopMString(ln,i);

  for(j=0; j < nkS; j++){
    lS	=RawS+kS[j];
    lR	=Raw+lS->kS;
    if(lS->kA && lS->c && (lS->c&0x100) == 0){
      C	=1.;
      G	=1.;
      A	=lR->A;
      B	=lR->B;
      dC=lR->dC;
      dG=lR->dG;
      dA=lR->dA;
      dB=lR->dB;
      ld=lR->D+iSm;
      f2spl(Sm,Sm2,NULL,NULL,ld,NULL,lt,&nSm,&ga0,&ga1,&ga2,gaS+kG);
      dS	=0.;
      for(i=0; i < nSm1; i++){
	s	=ld[i]-Sm[i];
	dS	+=s*s;
      }
      dS	=2.*sqrt(dS/nSm1);
      for(i=0; i < nSm1; i++){
	s	=(dS+fabs(dB)+fabs(dA*PFtWF))/fabs(G);
	if(C != 0.) s+=fabs(dC*(Sm[i]-(A*PFtWF+B))/C)/fabs(G);
	SmP[i]	=Sm[i]+s;
	SmM[i]	=Sm[i]-s;
      }
      splr0(&(lR->S),NULL,&PFtWF,Sm,Sm2,lt,&nSm);
      ZColor(kCol[lS->c-1]);
      ZPlotPolyLine(lR->T+i1,lR->D+i1,n);
      ZColor(4);
      ZPlotPolyLine(lt,Sm,nSm1);
      ZPlotPolyLine(lt,SmP,nSm1);
      ZPlotPolyLine(lt,SmM,nSm1);
    }
    lS++;
  }
  return(0);
}

int CheckIfSplinedI(int Fl)
{
  int k,k0,k1,kt;
  int i1,i2;
  int i,n,I1;
  RAWDATA *lS;

  for(k=0; i < nGrI; k++){
    k0	=DGr[k].k0;
    k1	=DGr[k].k1;
    i1	=DGr[k].i0;
    i2	=DGr[k].i1;
    n	=i2-i1;
    for(i=k0,lS=RawS+k0; i < k1; i++,lS++){
      if(lS->kA && (lS->ti-lS->T != i1 || lS->I1 != n)){
	lS->I1	=n;
	lS->ti	=lS->T+i1;
	Raw[lS->kS].I1=n;
	Raw[lS->kS].ti=lS->ti;
	ISignal2Splines(lS->V0,lS->V2,lS->D+i1,lS->ti,n,gaI[k]);
      }
    }
  }
  kTimeHistory |= Fl ? 0x04 : 0x02;
  return(0);
}

int TimeHistoryVirtualI()
{
  extern double EmnIV;
  int i1,i2;
  int i,j,n,nw1;
  double r,z,*ti,*ld,*lv;
  RAWDATA *lR;
  extern WALL VVWall;
  extern double GPring(double,double,double,double);
  double gY[0x100],Iim[nPFC];

  nw1	=VVWall.n1;
  if(nw1 == 0) return(0);

  i1	=RawS[0].i1;
  i2	=RawS[0].i2;
  ti	=RawS[0].T+i1;
  ld	=RawS[0].D+i1;
  n	=i2-i1;

  r	=PFB[0].R;
  z	=PFB[0].Z;
  for(i=0; i < nw1; i++) gY[i]=GPring(VVWall.r[i],VVWall.z[i],r,z);
  GetSVDExpansion4Wall(Iim+1,gY,EmnIV);
  Iim[0]=0.;

  ZMessage("Making time history of I virtual");
  lR	=RawI+1;
  for(j=1; j < nPFC; j++){
    r=Iim[j]*RawI[0].C*lR->G/(RawI[0].G*lR->C);
    lv	=lR->V;
    for(i=0; i < n; i++) *lv++=r*ld[i]; 
    lR++;
  }
  PFGiveRawAddress(Raw);
  kTimeHistory |=0x02;
  return(0);
}

int IfSplinedDiamag()
{
  int i1,i2;
  int i,n;
  RAWDATA *lS;
  
  if(nMFd == 0) return(0);
  i	=DGr[nDGr-1].k0;
  lS	=RawS+i;
  for(; i < nRaw; i++){
    i1	=lS->i1;
    i2	=lS->i2;
    n	=i2-i1;
    lS->I1	=n;
    lS->ti	=lS->T+i1;
    Raw[i].I1	=n;
    Raw[i].ti	=lS->ti;
    ISignal2Splines(lS->V0,lS->V2,lS->D+i1,lS->ti,n,gaI[1]);
    lS++;
  }
  kTimeHistory |=0x20;
  return(0);
}

int TimeHistorySignal(int Fl)
{
  int i1,i2;
  int i,j,n,I1,L,K1;
  double *r0,*r2,*tk,*ti;
  RAWDATA *lS,*lR;
  
  I1	=Fl ? nMFP : nMFLS; 
  i1	=RawS[0].i1;
  i2	=RawS[0].i2;
  n	=i2-i1;
  L	=n*sizeof(double);
  ti	=RawS[0].T+i1;
  for(i=0,lR=RawY; i < I1; i++,lR++){
    lS	=RawS+lR->kS;
    if(lS->kA && (lS->ti !=ti || lS->I1 != n)){
      ZMessageF("Making time history of %s-signal",lS->Nm);
      lS->I1	=n;
      lS->ti	=ti;
      lR->I1	=n;
      lR->ti	=ti;
      memset(lS->V0,'\0',L);
      for(j=1; j < nPFC; j++){
	GetRespFunction(&r0,&r2,&tk,&K1,i,j);
	MakeSignalF(lS->ti,lS->V0,n,r0,r2,tk,K1
		    ,Raw[j].V0,Raw[j].V2,Raw[j].ti,Raw[j].I1);
      }
    }
  }
  kTimeHistory |= Fl ? 0x18 : 0x08;
  if(Fl == 0 && nMFd) IfSplinedDiamag();
  return(0);
}

int WFormYBO(FILE *lF)
{
  int i,i1,i2,n,Ld,Li;
  RAWDATA *lR;
  
  Li	=sizeof(int);
  Ld	=sizeof(double);

  i1	=RawS[0].i1;
  i2	=RawS[0].i2;
  fwrite(&i1,Li,1,lF);
  fwrite(&i2,Li,1,lF);
  n	=i2-i1;
  lR	=RawY;
  i	=nMFLS;
  while(i){
    i--;
    fwrite(&lR->kA,Li,1,lF);
    if(lR->kA) fwrite(lR->V0,Ld,n,lF);
    lR++;
  }
  return(0);
}

int WFormYBI(FILE *lF)
{
  int i,i1,i2,Ld,Li;
  int n;
  RAWDATA *lR,*lS;

  Li	=sizeof(int);
  Ld	=sizeof(double);

  lS	=RawS;
  fread(&i1,Li,1,lF);
  fread(&i2,Li,1,lF);
  if(i1 !=lS->i1 || i2 !=lS->i2) return(1);
  n	=i2-i1;
  
  lR	=RawY;
  i	=nMFLS;
  while(i){
    i--;
    fread(&i1,Li,1,lF);
    if(i1 != lR->kA) return(1);
    lS	=RawS+lR->kS;
    if(lR->kA){
      fread(lS->V0,Ld,n,lF);
      lS->I1	=n;
      lS->ti	=Raw[0].T+i1;
      lR->I1	=n;
      lR->ti	=lS->ti;
    }
    lR++;
  }
  kTimeHistory	|=0x08;
  return(0);
}

int WFormPBO(FILE *lF)
{
  int i,i1,i2,n,Ld,Li;
  RAWDATA *lR;

  Li	=sizeof(int);
  Ld	=sizeof(double);

  i1	=RawS[0].i1;
  i2	=RawS[0].i2;
  fwrite(&i1,Li,1,lF);
  fwrite(&i2,Li,1,lF);
  n	=i2-i1;
  lR	=RawB;
  i	=nMFP-nMFLS;
  while(i){
    i--;
    fwrite(&lR->kA,Li,1,lF);
    if(lR->kA)fwrite(lR->V0,Ld,n,lF);
    lR++;
  }
  return(0);
}

int WFormPBI(FILE *lF)
{
  int i,i1,i2,Ld,Li;
  int n;
  RAWDATA *lS,*lR;

  Li	=sizeof(int);
  Ld	=sizeof(double);

  lS	=RawS;
  fread(&i1,Li,1,lF);
  fread(&i2,Li,1,lF);
  if(i1 !=lS->i1 || i2 !=lS->i2) return(1);
  n	=i2-i1;

  lR	=RawB;
  i	=nMFP-nMFLS;
  while(i){
    i--;
    fread(&i1,Li,1,lF);
    if(i1 != lR->kA) return(1);
    lS	=RawS+lR->kS;
    if(lS->kA){
      fread(lS->V0,Ld,n,lF);
      lS->I1	=n;
      lS->ti	=Raw[0].T+i1;
      lR->I1	=n;
      lR->ti	=lS->ti;
    }
    lR++;
  }
  kTimeHistory	|=0x10;
  return(0);
}

int PlotSplinedWF(int kG)
{
  int j;
  RAWDATA *lS;
  char ln[0x40];

  ZColor(0);
  j=sprintf(ln,"%s",TypeNm[DGr[kG].kt]);
  ZPlotUTopMString(ln,j);

  lS	=RawS+DGr[kG].k0;
  j	=DGr[kG].k;
  while(j){
    j--;
    if(lS->kA && (lS->c&0x100) == 0 && lS->c){
      ZColor(kCol[lS->c-1]);
      ZPlotPolyLine(lS->ti,lS->V0,lS->I1);
    }
    lS++;
  }
  return(0);
}

void PlotVirtualI()
{
  int j;
  int i1,i2,n;
  double *ti;
  RAWDATA *lS;
  
  i1	=RawS[0].i1;
  i2	=RawS[0].i2;
  ti	=RawS[0].T+i1;
  n	=i2-i1;
  for(j=1; j < nPFC; j++){
    lS=RawS+Raw[j].kS;
    if((lS->c&0x100) == 0 && lS->c){
      ZColor(kCol[lS->c-1]);
      ZPlotPolyLine(ti,Raw[j].V,n);
    }
  }
}

void PlotPlasmaAndEddyWForm()
{
  int i,ii,j;
  int i1,i2,n;
  double *d,*ld,*lv,*ti,*tj;
  RAWDATA *lS;
  
  lS	=RawS;
  i1	=RawS->i1;
  i2	=RawS->i2;
  n	=i2-i1;
  d	=(double*)malloc(n*sizeof(double));
  if(d == NULL){
    CbStr2UserMessage("%d - No memory in PlotPlasmaAndEddyWF\n",n);
    return;
  }
  if(kG0 < 4){
    lS	+=DGr[kG0].k0;
    j	=DGr[kG0].k;
    while(j){
      j--;
      if((lS->c&0x100) == 0 && lS->c){
	ZColor(kCol[lS->c-1]);
	lv	=lS->V0;
	ld	=lS->D+lS->i1;
	tj	=lS->T+lS->i1;
	ti	=lS->ti;
	ii	=0;
	while(tj[ii] < ti[0]) ii++;
	if(ii == 0) ii=1;
	for(i=0; i < n; i++){
	  while(tj[ii] < ti[i]) ii++;
	  d[i]=((tj[ii-1]-ti[i])*ld[ii]+(ti[i]-tj[ii])*ld[ii-1])
	    /(tj[ii-1]-tj[ii])-lv[i];
	}
	ZPlotPolyLine(ti,d,n);
      }
      lS++;
    }
  }
  else{
    memset(d,'\0',n*sizeof(double));
    ti	=RawS[0].ti;
    j	=DGr[kG0].k;
    while(j){
      j--;
      if((lS->c&0x100) == 0 && lS->c){
	ZColor(kCol[lS->c-1]);
	ZPlotPolyLine(ti,d,n);
      }
      lS++;
    }
  }
  free(d);
}

void PlotPFCWFormY()
{
  int i,j,k,kc[8]={0,0,14,11,4,0,0,0};
  int i1,n,m;
  double *d,*ld,*ti;
  double s,Gi;
  RAWDATA *lS;
  RAWDATA *lR;
  extern double **gYiC;
  
  lR	=RawS+DGr[1].k0;

  i1	=lR->i1;
  ti	=lR->T+i1;
  n	=lR->i2-i1;
  d	=(double*)malloc(n*sizeof(double));
  if(d == NULL){
    CbStr2UserMessage("%d - PlotPFCWFormY\n",n);
    return;
  }
  lS	=RawS+DGr[kG0].k0;
  m	=DGr[kG0].k;
  for(i=0; i < m; i++){
    if((lS->c&0x100) == 0 && lS->c){
      ZColor(kc[lS->c]);
      Gi	=lS->G/lS->C;
      memset(d,'\0',n*sizeof(double));
      for(j=1,lR=Raw+1; j < nPFC; j++,lR++){
	ld	=lR->D+i1;
	s	=Gi*gYiC[i][j]*lR->C/lR->G;
	for(k=0; k < n; k++) d[k]+=s*(*ld++);
      }
      ZPlotPolyLine(ti,d,n);
    }
    lS++;
  }
  free(d);
}

void PlotPFCWFormW()
{
  int i,j,k,kc[8]={0,0,14,11,4,0,0,0};
  int i1,n,m;
  double *d,*ld,*ti;
  double s,Gi;
  RAWDATA *lS;
  RAWDATA *lR;
  extern double **gYiC;
  
  lR	=RawS+DGr[1].k0;
  i1	=lR->i1;
  ti	=lR->T+i1;
  n	=lR->i2-i1;
  d	=(double*)malloc(n*sizeof(double));
  if(d == NULL){
    CbStr2UserMessage("%d - PlotPFCWFormY\n",n);
    return;
  }
  lS	=RawS+DGr[kG0].k0;
  m	=DGr[kG0].k;
  for(i=0; i < m; i++){
    if((lS->c&0x100) == 0 && lS->c){
      ZColor(kc[lS->c]);
      Gi	=lS->G/lS->C;
      memset(d,'\0',n*sizeof(double));
      for(j=1,lR=Raw+1; j < nPFC; j++,lR++){
	ld	=lR->D+i1;
	s	=Gi*gYiC[i][j]*lR->C/lR->G;
	for(k=0; k < n; k++) d[k]+=s*(*ld++);
      }
      ZPlotPolyLine(ti,d,n);
    }
    lS++;
  }
  free(d);
}

int PlotSplinedAndRawWF(int kG)
{
  int j;
  RAWDATA *lS;

  ZColor(14);
  lS	=RawS+DGr[kG].k0;
  j	=DGr[kG].k;
  while(j){
    j--;
    if((lS->c&0x100) == 0 && lS->c) ZPlotPolyLine(lS->ti,lS->V0,lS->I1);
    lS++;
  }
  PlotRawWF(kG);
  return(0);
}

void PlotWForm()
{
  PlotRawWF(kG0);
}

void PlotSplinedWForm()
{
  PlotSplinedWF(kG0);
}

void PlotSplinedAndRawWForm()
{
  PlotSplinedAndRawWF(kG0);
}

int TimeSlice(int kG)
{
  extern double ESgDgFexp;
  int i,j,k,n,k0,k1,m,kt;
  double d,S,dS;
  double C,G,A,B,dC,dG,dA,dB;
  double Sm[0x20],Sm2[0x20],*lt,*ld;
  int nSm,nSm1,iSm;
  RAWDATA *lR;

  if(DGr[kG].k == 0 || DGr[kG].n == 0) return(0);
  nSm	=16;
  nSm1	=nSm+1;
  k0	=DGr[kG].k0;
  k1	=DGr[kG].k1;
  n	=DGr[kG].n;
  kt	=DGr[kG].kt;

  iSm	=DGr[kG].i-nSm1/2;
  if(iSm < 0) iSm=0;
  if(iSm+nSm1 > n) iSm=n-nSm1;
  lt	=DGr[kG].T+iSm;
  for(i=k0; i < k1; i++){
    if(RawS[i].kA){
      k	=RawS[i].kS;
      lR=Raw+k;
      C	=lR->C;
      C	=iSignIp ? -lR->C : lR->C;
      G	=lR->G;
      A	=lR->A;
      B	=lR->B;
      dC=lR->dC;
      dG=lR->dG;
      dA=lR->dA;
      dB=lR->dB;
      ld=lR->D+iSm;
      f2spl(Sm,Sm2,NULL,NULL,ld,NULL,lt,&nSm,&ga0,&ga1,&ga2,gaS+kG);
      splr0(&S,NULL,&PFtWF,Sm,Sm2,lt,&nSm);
      dS	=0.;
      for(j=0; j < nSm1; j++){
	d	=ld[j]-Sm[j];
	dS	+=d*d;
      }
      dS	=2.*sqrt(dS/nSm1);
      lR->S	=C*(S-(A*PFtWF+B))/G;
      lR->dS	=(fabs(C*dS)+fabs(C*dB)+fabs(dC*(S-(A*PFtWF+B)))
		  +fabs(C*dA*PFtWF)+fabs(lR->S*dG))/fabs(G);
      if(kt < 4){
	PFC[k].I0	=lR->S;
	PFC[k].I	=0.;
	PFC[k].dI	=lR->dS;
      }
      else if(kt == 4){
	j =k-nPFC1;
	VVC[j].I0	=lR->S;
	VVC[j].I	=0.;
	VVC[j].dI	=lR->dS;
	if(kt == 3) iSignBt = lR->S < 0. ? 1 : 0;
      }
      else{
	j =k-nPFC1-nVVC;
	MFP[j].S0	=lR->S;
	MFP[j].S	=0.;
	MFP[j].dS	=lR->dS;
	if(kt == 8) ESgDgFexp=MFP[j].S0;
	if((kt < 7 && (kTimeHistory&0x08)) || (kTimeHistory&0x10)){
	  m	=Raw[0].i-Raw[0].i1;
	  MFP[j].V0=lR->S-(lR->V0[m]*C/G);
#ifdef H
	  out("??? +++=> 1Vidd<s>",j,MFP[j].S0,MFP[j].V0,lR->Nm);
	  out("??? ==>iddddd<s>",j,Raw[0].T[Raw[0].i],S,lR->V0[m]
	      ,MFP[j].S0,MFP[j].V0,lR->Nm);
#endif
	}
      }
    }
  }
  return(0);
}

int PlotTimeSlice(int kG)
{
  int j,j1,j2,m,ic,kt,kH;
  double x[2],y[2],s,d;
  double *ld;
  RAWDATA *lS,*lR;
  char YNm[0x10][16]={
    "Ip [MA]"
    ,"OH [MA]"
    ,"PFC [MA]"
    ,"TFC [MA]"
    ,"VVC [MA]"
    ,"gY [Vsec]"
    ,"gS [Vsec]"
    ,"B [T]"
    ,"Diamag [Vsec]"
    ,"","","","","","",""
  };

  if(DGr[kG].k == 0 || DGr[kG].n == 0) return(0);

  kt	=DGr[kG].kt;
  SetPlotName("#",YNm[kt],TypeNm[kt]);
  j1	=DGr[kG].k0;
  j2	=DGr[kG].k1;
  m	=RawS[0].i-RawS[0].i1;
  kH	=0;
  if((kTimeHistory&0x08 && kt > 4 && kt < 8)
     || (kTimeHistory&0x10 && kt == 8)) kH	=1;
  y[0]	=0.;
  y[1]	=0.;
  x[0]	=j2;
  x[1]	=j1;
  for(j=j1,lS=RawS+j1; j < j2; j++,lS++){
    if(lS->kA && (lS->c&0x100) == 0 && lS->c){
      lR	=Raw+lS->kS;
      s	=lR->S-lR->dS;
      if(y[0] > s) y[0]=s;
      s	=lR->S+lR->dS;
      if(y[1] < s) y[1]=s;
      if(kH){
	s	=lR->S-lR->V0[m]*lR->C/lR->G;
	if(iSignIp) s=-s;
	if(y[0] > s) y[0]=s;
	if(y[1] < s) y[1]=s;
      }	
      if(x[0] > j) x[0]=j;
      if(x[1] < j) x[1]=j;
    }
  }
  x[0]	-=0.5;
  x[1]	+=0.5;
  Scale2d(2,x,y,2,6,2);

  for(j=j1,lS=RawS+j1; j < j2; j++,lS++){
    if(lS->kA && (lS->c&0x100) == 0 && lS->c){
      lR	=Raw+lS->kS;
      ic	=kCol[lS->c-1];
      x[0]	=j;
      y[0]	=lR->S+lR->dS;
      Plot2d(2,x,y,1,6,0x0110,ic,0);
      y[0]	=lR->S-lR->dS;
      Plot2d(2,x,y,1,6,0x0110,ic,0);
      y[0]	=lR->S;
      Plot2d(2,x,y,1,6,0x08,ic,0);
    }
  }
  
  if(kH){
    ic	=14;
    for(j=j1,lS=RawS+j1; j < j2; j++,lS++){
      if(lS->kA && (lS->c&0x100) == 0 && lS->c){
	lR	=Raw+lS->kS;
	x[0]	=j+0.1;
	y[0]	=lR->S-lR->V0[m]*lR->C/lR->G;
	if(iSignIp) y[0]=-y[0];
	Plot2d(2,x,y,1,6,0x0108,ic,0);
      }
    }
  }
  return(0);
}

int WFormIpAO(FILE *lF)
{
  int kI,kD;
  int i,j,k,m,n,i0,i1,L,mF;
  char FNm[0x100];
  char str[0x80];
  char *lDir,*lN;
  FILE *lFb;
  RAWDATA *lS;

  kI	=sizeof(int);
  kD	=sizeof(double);

  fprintf(lF,"<WForm Groups>[%d](%s)\n",nDGr,"7%d");
  fprintf(lF,"!%2s %2s %3s %5s %5s %5s %8s\n","Gr","kt","k","n","i0","i1","ID");
  PFSetTimeRange(nDGr-1);
  for(k=0; k < nDGr; k++){
    fprintf(lF,"%3d %2d %3d %5d %5d %5d %8d - %s\n",k,DGr[k].kt,DGr[k].k
	    ,DGr[k].n,DGr[k].i0,DGr[k].i1,iShot,TypeNm[DGr[k].kt]);
  }
  fprintf(lF,"!%2s %2s %3s %5s %5s %5s %8s\n","Gr","kt","k","n","i0","i1","ID");

  fprintf(lF,"<WForm List>[%d](%s)\n",nRawS,"6%d %e %s");
  fprintf(lF,"!%2s %2s %2s %5s %5s %5s %10s <%s>\n","#","Gr","C","n","i0","i1"
	  ,"ga","Name");
  L	=0;
  n	=0;
  for(k=0; k < nDGr; k++){
    lS	=RawS+DGr[k].k0;
    j	=DGr[k].k;
    i0	=DGr[k].i0;
    i1	=DGr[k].i1;
    for(i=0; i < j; i++){
      m	=lS->kA;
      if(lS->c == 0) m=0;
      fprintf(lF,"%3d %2d %2d %5d %5d %5d %10.3e %s\n",n,lS->kG,m
	      ,lS->n,i0,i1,lS->ga,lS->Nm);
      m	=strlen(lS->Nm);
      if(L < m) L=m;
      lS++;
      n++;
    }
  }
  fprintf(lF,"!%2s %2s %2s %5s %5s %5s %10s <%s>\n","#","Gr","C","n","i0","i1"
	  ,"ga","Name");

  sprintf(str,"%s%d%s%d%s","%",nRawS < 100 ? 2 : 3,"d <Data: %"
	  ,L,"s>[%d @ %d: ](%s)\n");

  CbGetCurrentCbName(&lDir,&lN);
  realpath(lDir,FNm);
  L	=strlen(FNm);
  sprintf(FNm+L,"/Wrk/WFormAll.bi");
  lFb	=fopen(FNm,"w");
  if(lFb == NULL) return(0);
  n	=0;
  mF	=0;
  for(k=0; k < nDGr; k++){ 
    j	=DGr[k].k;
    if(j){
      lS	=RawS+DGr[k].k0;
      i0	=DGr[k].i0;
      i1	=DGr[k].i1;
      m	=j ? i1-i0 : 0;
      if(k) fprintf(lF,"%d <Data: t[%d]>[%d @ %d:](%s)\n",n,k,m,mF,"%e");
      else fprintf(lF,"%d <Data: t[%d]>[%d @ %d:%s](%s)\n",n,k,mF,m
		   ,"Wrk/WFormAll.bi","%e");
      fwrite((void*)(DGr[k].T+i0),kD,m,lFb);
      mF	+=kD*m;
      for(i=0; i < j; i++){
	if(lS->kA && lS->c){
	  fprintf(lF,str,n,lS->Nm,m,mF,"%e");
	  fwrite((void*)(lS->D+i0),kD,m,lFb);
	  mF	+=kD*m;
	}
	else{
	  fprintf(lF,str,n,lS->Nm,0,mF,"%e");
	}
	n++;
	lS++;
      }
    }
  }
  fclose(lFb);
  printf("Output: %s\n",FNm);
  CbStr2UserMessage("Output: %s\n",FNm);
  return(0);
}

int WFormIpAI(FILE *lF)
{
  int kI,kD;
  int i,j,k,m,n,L,mF;
  char str[64];
  char *lc;
  char *lm;
  char *lv[0x10];
  int dl[0x10];
  int kGr[0x10],kt[0x10];
  double s;
  char FNm[0x100],Nm[0x40];
  char *lDir,*lN;
  RAWDATA *lS,*lR;
  double *lT;
  FILE *lFb=NULL;

  kI	=sizeof(int);
  kD	=sizeof(double);

  lm	="WFormIp.ai";
  lc	="<WForm Groups>";
  k	=sizeof(GROUPDT);
  if(IsKeyWordFound(lF,lm,lc,str,&m)){
    nDGr	=m;
    lv[0]	=(char*)&i;
    lv[1]	=(char*)kt;
    lv[2]	=(char*)kGr;
    lv[3]	=(char*)&DGr[0].n;
    lv[4]	=(char*)&DGr[0].i0;
    lv[5]	=(char*)&DGr[0].i1;
    lv[6]	=(char*)&DGr[k].id;
    dl[0]	=0;
    dl[1]	=kI;
    dl[2]	=kI;
    dl[3]	=k;
    dl[4]	=k;
    dl[5]	=k;
    dl[6]	=k;
    ReadAI(lF,lc,lm,str,m,lv,dl,7);
  }
  else{
    CbStr2UserWarning("Error: %s: %s is absent.\n",lm,lc);
    printf("Error:%s: %s is absent.\n",lm,lc);
    return(1);
  }
  for(k=0; k < nDGr; k++){
    if(DGr[k].k	!= kGr[k] || DGr[k].kt	!= kt[k]){
      CbStr2UserMessage("Error:%s: %s: DGr[%d].k=%d != %d || kt=%d != %d\n"
			,lm,lc,k,DGr[k].k,kGr[k],DGr[k].kt,kt[k]);
      printf("Error:%s: %s: DGr[%d].k=%d != %d || kt=%d != %d\n"
	     ,lm,lc,k,DGr[k].k,kGr[k],DGr[k].kt,kt[k]);
      return(0);
    }
    if(k){
      if(DGr[k].n){
	DGr[k].n	=DGr[k].i1-DGr[k].i0;
	DGr[k].i1	=DGr[k].n;
      }else{
	DGr[k].i1	=0;
      }
      DGr[k].i0	=0;
      DGr[k].i	=0;
    }
  }
  lc	="<WForm List>";
  if(IsKeyWordFound(lF,lm,lc,str,&m)){
    if(nRawS != m){
      printf("Error:%s: %s: RawS=%d != %d = m\n",lm,lc,nRawS,m);
      return(1);
    }
    if(m){
      nRawS	=m;
      lv[0]	=(char*)&i;
      lv[1]	=(char*)&RawS[0].kG;
      lv[2]	=(char*)&RawS[0].c;
      lv[3]	=(char*)&RawS[0].n;
      lv[4]	=(char*)&RawS[0].i1;
      lv[5]	=(char*)&RawS[0].i2;
      lv[6]	=(char*)&RawS[0].ga;
      lv[7]	=RawS[0].Nm;
      k	=sizeof(RAWDATA);
      dl[0]	=0;
      dl[1]	=k;
      dl[2]	=k;
      dl[3]	=k;
      dl[4]	=k;
      dl[5]	=k;
      dl[6]	=k;
      dl[7]	=k;
      ReadAI(lF,lc,lm,str,m,lv,dl,8);
    }
  }
  else{
    CbStr2UserWarning("Error: %s: %s is absent.\n",lm,lc);
    printf("Error: %s: %s is absent.\n",lm,lc);
    return(1);
  }
  for(k=0,lS=RawS; k < nRawS; k++,lS++){
    lS->n	=0;
    lS->i2	-=lS->i1;
    lS->i1	=0;
    lR	=Raw+lS->kS;
    if(lS->c == 0){
      lS->kA	=0;
      lR->kS	=0;
      if(lS->kG >= nGrI) lR->kA=0;
    }
    if(lS->kA) lS->c	=lR->c;
  }
  lc	="<Data: t[0]>";
  *FNm	=0;
  mF	=0;
  k=IsRecordHeadFound(lF,lm,lc,&mF,Nm,str,&m);
  if(k == 0){
    CbStr2UserWarning("Error: %s: %s is absent.\n",lm,lc);
    printf("Error: %s: %s is absent.\n",lm,lc);
    return(1);
  }
#ifdef H
  out("???? k=I",k);
  if(k > 1) out("???? mF=I",mF);
  if(k > 2) out("???? FNm=<s>",Nm);
#endif
  if(k > 2){
    CbGetCurrentCbName(&lDir,&lN);
    realpath(lDir,FNm);
    L	=strlen(FNm);
    if(*Nm != '/') FNm[L++]='/';
    strcpy(FNm+L,Nm);
    lFb	=fopen(FNm,"r");
  }
  if(lFb == NULL) return(0);
  mF	=0;
  for(k=0; k < nDGr-1; k++){
    m	=DGr[k].k;
    if(m && DGr[k].n){
      lS	=RawS+DGr[k].k0;
      n	=DGr[k].n;
      lT=(double *)malloc(n*kD);
      if(lT == NULL){
	CbStr2UserWarning("Error:%s: DGr[%d].T %d -no memory\n",lm,k,kD*n);
	printf("Error:%s: DGr[%d].k %d -no memory\n",lm,k,kD*n);
	return(1);
      }
      DGr[k].T=lT;
      DGr[k].t=lT;
      i	=fread((void*)lT,kD,n,lFb);
      if(i < n){
	CbStr2UserWarning("Error:%s: DGr[%d].T %d -bad record\n",lm,k,n);
	printf("Error:%s: DGr[%d].T %d -bad record\n",lm,k,n);
	return(1);
      }
      mF	+=kD*n;
      for(i=0; i < m; i++){
	lS->T	=lT;
	lR	=Raw+lS->kS;
	if(lS->kA){
	  if(lS->n != n){
	    if(lS->D != NULL) free(lS->D);
	    if(k < nGrI){
	      lS->D	=(double *)malloc((3*n+RawS[0].n)*kD);
	    }
	    else{
	      lS->D	=(double *)malloc(3*n*kD);
	    }
	    if(lS->D == NULL){
	      CbStr2UserWarning("Error:%s: %s %d -no memory\n"
				,lm,lS->Nm,(3*n+RawS[0].n)*kD);
	      printf("Error:%s: %s %d -no memory\n"
		     ,lm,lS->Nm,(3*n+RawS[0].n)*kD);
	    }
	  }
	  lS->V0	=lS->D+n;
	  lS->V2	=lS->V0+n;
	  lS->V	=lS-RawS < nPFC1 ? lS->V2+n : NULL; 
	  j=fread((void*)(lS->D),kD,n,lFb);
	  if(j < n){
	    CbStr2UserWarning("Error:%s: %s %d < %d -bad record\n"
			      ,lm,lS->Nm,j,n);
	    printf("Error:%s: %s %d < %d -bad record\n",lm,lS->Nm,j,n);
	    return(1);
	  }
	  mF	+=kD*n;
	  lS->ti=lT;
	  lS->I1=0;
	  lS->i1=0;
	  lS->i	=0;
	  lS->i2=n;
	  lS->n	=n;

	  lR->T	=lS->T;
	  lR->D	=lS->D;
	  lR->V0=lS->V0;
	  lR->V2=lS->V2;
	  lR->V	=lS->V;
	  lR->ti=lS->ti;
	  lR->I1=lS->I1;
	  lR->n	=lS->n;
	  lR->i1=lS->i1;
	  lR->i	=lS->i;
	  lR->i2=lS->i2;
	}
	else{
	  lR->n=0;
	  lR->T=NULL;
	  lR->D=NULL;
	  lR->kA=0;
	  lR->c	=0;
	  lS->T=NULL;
	  if(lS->D !=NULL) free(lS->D);
	  lS->D	=NULL;
	  lS->T=NULL;
	  lS->c	=0;
	  lS->n	=0;
#ifdef H
	  CbStr2UserMessage("Error:%s: [%d %d]: %s\n",lm,k,i,lS->Nm);
	  printf("Bad signals:%s: [%d %d]: %s\n",lm,k,i,lS->Nm);
#endif
	}
	lS++;
      }
    }
    pppp();
  }
  fclose(lFb);
  printf("Input: %s\n",FNm);
  CbStr2UserMessage("Input: %s\n",FNm);

  PFtWF1	=RawS[0].T[0];
  PFtWF2	=RawS[0].T[RawS[0].n-1];
  PFtWF		=0.5*(PFtWF1+PFtWF2);
  ppppp();
  return(0);
}

int WFormIpBI(FILE *lF)
{
  int kI,kD,m;
  int i,j,k,n,kSig;
  double *lT;
  RAWDATA *lS,*lR;

  kI	=sizeof(int);
  kD	=sizeof(double);

  fread(&nDGr,kI,1,lF);
  for(j=0; j < nDGr; j++){
    lS	=RawS+DGr[j].k0;
    fread(&i,kI,1,lF);
    if(i != DGr[j].k){
      CbStr2UserMessage("Error:%d != DGr[%d].k=%d\n",i,j,DGr[j].k);
      return(1);
    }
    while(i){
      fread(&k,kI,1,lF);
      fread(lS->Nm,1,k,lF);
      lS->Nm[k]='\0';
      fread(&k,kI,1,lF);
      if(k == 0){
	lS->kA=0;
	lS->c=0;
      }
#ifdef H
      if(lS->kA != k ||lS->kG != j){
	CbStr2UserMessage("WFormIp.bi:%s: kA=%d!=%d kG=%d!=%d\n"
			  ,lS->Nm,lS->kA,k,lS->kG,j);
      }
#endif
      if(k) break;
      if(lS->n) free(lS->T);
      lS->n	=0;
      i--;
      lS++;
    }
    n	=0;
    lT	=NULL;
    if(i){
      fread(&n,kI,1,lF);
      if(DGr[j].n != n){
	if(lS->n) free(lS->T);
	lT	=(double*)malloc(n*kD);
      }
      fread(lT,kD,n,lF);
      DGr[j].t=lT;
      DGr[j].n=n;
    }
    while(i){
      lR	=Raw+lS->kS;
      lS->T	=lT;
      lR->kA	=lS->kA;
      if(k){
	if(lS->n != n){
	  if(lS->n) free(lS->D);
	  if(lS-RawS < nPFC1){
	    lS->D	=(double *)malloc((3*n+RawS[0].n)*kD);
	  }
	  else{
	    lS->D	=(double *)malloc(3*n*kD);
	  }
	  if(lS->D == NULL)CbStr2UserWarning("PFReadWFormAI():%s %d -no memory"
					     ,lS->Nm,(3*n+RawS[0].n)*kD);
	}
	lS->V0	=lS->D+n;
	lS->V2	=lS->V0+n;
	lS->V	=lS-RawS < nPFC1 ? lS->V2+n :NULL; 
	fread(lS->D,kD,n,lF);
	lS->ti	=lT;
	lS->I1	=0;
	lS->n	=n;
	lS->i1	=0;
	lS->i	=0;
	lS->i2	=n;
	lR->T	=lS->T;
	lR->D	=lS->D;
	lR->V0	=lS->V0;
	lR->V2	=lS->V2;
	lR->V	=lS->V;
	lR->ti	=lS->ti;
	lR->I1	=lS->I1;
	lR->n	=lS->n;
	lR->i1	=lS->i1;
	lR->i	=lS->i;
	lR->i2	=lS->i2;
      }
      else{
	lS->kA	=0;
	lS->c	=0;
	lS->n	=0;
	CbStr2UserMessage("%d: %s\n",j,lS->Nm);
      }
      lS++;
      i--;
      if(i){
	fread(&k,kI,1,lF);
	fread(lS->Nm,1,k,lF);
	lS->Nm[k]='\0';
	fread(&k,kI,1,lF);
	if(k == 0){
	  lS->kA=0;
	  lS->c=0;
	}
#ifdef H
	if(lS->kA != k ||lS->kG != j){
	  CbStr2UserMessage("WFormIp.bi:%s: kA=%d!=%d kG=%d!=%d\n"
			    ,lS->Nm,lS->kA,k,lS->kG,j);
	}
#endif
      }
    }
  }
  for(i=0,lS=RawS; i < nRaw; i++,lS++) if(lS->kA == 0 && lS->c) lS->c=2;

#ifdef H
  lS	=Raw;
  n	=lS->n;
  for(i=0; i < n; i++) out("???? iIdd",i,n,lS->T[i],lS->D[i]);
#endif
  return(0);
}

int PFReadWFormAI(FILE *lf,int kG)
{
  int i,k,m,n;
  char RecNm[8][32]={
    "WaveFormIp",
    "WaveFormI",
    "WaveFormY",
    "WaveFormB",
    "WaveFormW",
    "",
    "",
    ""
  };
  char str[128];
  char *lc;
  char *lv[nRaw];
  int dl[nRaw];
  double *lT;
  RAWDATA *lS,*lR;

  lc	=RecNm[kG];
  lS	=RawS+DGr[kG].k0;
  if(IsKeyWordFound(lf,lc,lc,str,&n)){
    lR	=Raw+lS->kS;
    if(lS->n != n){
      if(lS->n) free(lS->T);
      lS->T	=(double*)malloc(n*sizeof(double));
    }
    lT	=lS->T;
    m	=0;
    lv[m]	=(char*)lT;
    dl[m]	=sizeof(double);
    m++;
    if(kG < 2){
      k	=(kG ? 3*n+RawS[0].n : 4*n)*sizeof(double);
    }
    else{
      k	=(kG > 3 ? 3*n+RawS[0].n : 2*n)*sizeof(double);
    }
    i	=DGr[kG].k;
    while(i){
      lR	=Raw+lS->kS;
      lS->T	=lT;
      if(lS->n != n){
	if(lS->n) free(lS->D);
	lS->D=(double*)malloc(k);
	if(lS->D == NULL)CbStr2UserWarning("PFReadWFormAI(): %d -no memory",k);
      }
      lS->V0	=lS->D+n;

      if(kG < 2 || kG > 3){
	lS->V2	=lS->V0+n;
	lS->V	=lS->V2+n;
      }
      else{
	lS->V2	=NULL;
	lS->V	=NULL;
      }
      lS->ti	=lT;
      lS->I1	=0;
      lS->n	=n;
      lS->i1	=0;
      lS->i	=0;
      lS->i2	=n;
      lR->T	=lS->T;
      lR->D	=lS->D;
      lR->V0	=lS->V0;
      lR->V2	=lS->V2;
      lR->V	=lS->V;
      lR->ti	=lS->ti;
      lR->I1	=lS->I1;
      lR->n	=lS->n;
      lR->i1	=lS->i1;
      lR->i	=lS->i;
      lR->i2	=lS->i2;
      lv[m]	=(char*)lS->D;
      dl[m]	=sizeof(double);
      lS++;
      m++;
      i--;
    }

    PFReadAI(lf,lc,lc,str,n,lv,dl,m);
    if(kG == 0){
      PFtWF1=RawI[0].T[0];
      PFtWF =PFtWF1;
      PFtWF2=RawI[0].T[n-1];
    }
  }
  else{
    CbStr2UserMessage("WForm*.ai: NO %s section.\n",lc);
    puts(lc);
    if(kG > 3){
      nMFd	=0;
      nRaw	=DGr[kG].k0;
      DGr[kG].k1=nRaw;
      DGr[kG+1].k0=nRaw;
      DGr[kG].k	=0;
    }
  }
  return(0);
}

int PFReadWFormIpAI(FILE *lf)
{
  int i,m,n,kG;
  char str[128];
  char *lc;
  char *lv[nRaw];
  int dl[nRaw];
  double *lT;
  RAWDATA *lR;

  strcpy(Mess,"WFormIp.ai");
#ifdef H
  lc	="<Scale Factors Ip>";
  if(PFIsKeyWordFound(lf,Mess,lc,str,&m)){
    for(i=0; i < nPFC; i++){
      lv[i]	=(char*)&RawI[i].C;
      dl[i]	=sizeof(double);
    }
    PFReadAI(lf,lc,Mess,str,m,lv,dl,nPFC);
  }
  else{
    sprintf(Mess,"WFormIp.ai: NO %s section.\n",lc);
    CbStr2UserMessage(Mess);
  }
#endif
  kG	=0;
  i	=0;
  while(i< nRaw && Raw[i].kG != kG) i++;
  lR	=Raw+i;
  lc	="<WaveFormIp>";

  if(PFIsKeyWordFound(lf,Mess,lc,str,&n)){
    if(lR->n < n){
      if(lR->n) free(lR->T);
      lR->T	=(double*)malloc(n*sizeof(double));
    }
    lT	=lR->T;
    m	=0;
    lv[m]	=(char*)lT;
    dl[m]	=sizeof(double);
    m++;
    for(; i < nRaw; i++){
      if(Raw[i].kG == kG){
	lR	=Raw+i;
	if(lR->n < n){
	  if(lR->n) free(lR->D);
	  lR->D=(double*)malloc(n*sizeof(double));
	}
	lR->T	=lT;
	lR->n	=n;
	lR->i1	=0;
	lR->i	=0;
	lR->i2	=n;
	lv[m]	=(char*)lR->D;
	dl[m]	=sizeof(double);
	m++;
      }
    }
    PFReadAI(lf,lc,Mess,str,n,lv,dl,m);
    PFtWF1=RawI[0].T[0];
    PFtWF	=PFtWF1;
    PFtWF2=RawI[0].T[n-1];
  }
  else{
    sprintf(Mess,"WFormIp.ai: NO %s section.\n",lc);
    CbStr2UserMessage(Mess);
  }
  return(0);
}

int GetJETI(int FlR)
{
  int kD,kt,kT;
  int i,ii,j,k,n,ierr,I;
  float yd[0x10000],td[0x10000],yE[0x10000],yO[0x10000],yf;
  double cE,cO,s;
  double *ld,*lT;
  char NmSig[32];
  char *lp,*ls;

  FILE *lF;
  char FNmO[256],str[256];
  RAWDATA *lS,*lR;

  kD	=sizeof(double);
#ifdef JET
  if(FlR > 1) FlR=nDGr;
  for(k=0; k < FlR; k++){
    DGr[k].id	=iShot;
    kt=DGr[k].kt;
    lp	=DGr[k].P;
    ls	=DGr[k].S;
    lS 	=RawS+DGr[k].k0;
    I	=kt < 3 ? DGr[k].k : 0;
    ii=0;
    for(i=0; i < I; i++){
      if(lS->kA && lS->c){
	lR	=Raw+lS->kS;
	sprintf(NmSig,"%s%s%s",lp,lS->Nm,ls);
	n	=0x10000;
	ierr=getsignal_(NmSig,&iShot,yd,td,&n);
	if(ierr == 0){
	  if(ii == 0){
	    if(DGr[k].n < n){
	      if(DGr[k].n) free(DGr[k].T);
	      lT	=(double*)malloc(n*kD);
	      DGr[k].T	=lT;
	    }else{
	      lT	=DGr[k].T;
	    }
	    DGr[k].n	=n;
	    DGr[k].i0	=0;
	    DGr[k].i	=0;
	    DGr[k].i1	=n;
	    DGr[k].t	=lT;
	    ld	=lT;
	    for(j=0; j < n; j++) *ld++=td[j];
	    ii	=1;
	  }
	  if(lS->n < n){
	    if(lS->n) free(lS->D);
	    lS->D=(double *)malloc((3*n+DGr[0].n)*kD);
	  }
	  lS->V0	=lS->D+n;
	  lS->V2	=lS->V0+n;
	  lS->V	=k < nGrI ? lS->V2+n : NULL; 
	  ld	=lS->D;
	  for(j=0; j < n; j++) *ld++=yd[j]*1e-6;
	  lS->T	=lT;
	  lS->ti	=lT;
	  lS->I1	=0;
	  lS->n	=n;
	  lS->i1	=0;
	  lS->i	=0;
	  lS->i2	=n;
	  lS->ga	=1e-14;
	  
	  lR->T	=lS->T;
	  lR->D	=lS->D;
	  lR->V0	=lS->V0;
	  lR->V2	=lS->V2;
	  lR->V	=lS->V;
	  lR->ti	=lS->ti;
	  lR->I1	=lS->I1;
	  lR->n	=lS->n;
	  lR->i1	=lS->i1;
	  lR->i	=lS->i;
	  lR->i2	=lS->i2;
	  lR->ga	=lS->ga;
	}
	else{
	  lS->kS	=0;
	  lS->c		=0;
	  lS->n		=0;
	  lR->kS	=0;
	  lR->c		=0;
	  lR->n		=0;
	}
      }
      ZMessageF("%d %3d %10s",k,i,lS->Nm);
      lS++;
    }
  }
  if(FlR < 2) return(0);

  for(k=0; k < nDGr; k++){
    kt=DGr[k].kt;
    lp	=DGr[k].P;
    ls	=DGr[k].S;
    lS 	=RawS+DGr[k].k0;
    I	=kt == 3 ? DGr[k].k : 0;
    if(I){
      sprintf(NmSig,"%sITFEVN",lp);
      n	=0x10000;
      ierr=getsignal_(NmSig,&iShot,yE,td,&n);
      sprintf(NmSig,"%sITFODD",lp);
      n	=0x10000;
      ierr=getsignal_(NmSig,&iShot,yO,td,&n);
    }
    ii=0;
    for(i=0; i < I; i++){
      if(lS->kA && lS->c){
	lR	=Raw+lS->kS;
	sprintf(NmSig,"%s%s%s",lp,lS->Nm,ls);
	if(ierr == 0){
	  if(ii == 0){
	    if(DGr[k].n < n){
	      if(DGr[k].n) free(DGr[k].T);
	      lT	=(double*)malloc(n*kD);
	      DGr[k].T	=lT;
	    }else{
	      lT	=DGr[k].T;
	    }
	    DGr[k].n	=n;
	    DGr[k].i0	=0;
	    DGr[k].i	=0;
	    DGr[k].i1	=n;
	    DGr[k].t	=lT;
	    ld	=lT;
	    for(j=0; j < n; j++) *ld++=td[j];
	    ii	=1;
	  }
	  if(lS->n < n){
	    if(lS->n) free(lS->D);
	    lS->D=(double *)malloc((3*n+DGr[0].n)*kD);
	  }
	  lS->V0	=lS->D+n;
	  lS->V2	=lS->V0+n;
	  lS->V	=k < nGrI ? lS->V2+n : NULL; 
	  ld	=lS->D;
	  for(j=0; j < n; j++) *ld++=0.5*(yO[j]+yE[j])*1e-6;
	  lS->T	=lT;
	  lS->ti	=lT;
	  lS->I1	=0;
	  lS->n	=n;
	  lS->i1	=0;
	  lS->i	=0;
	  lS->i2	=n;
	  lS->ga	=1e-14;
	  
	  lR->T	=lS->T;
	  lR->D	=lS->D;
	  lR->V0	=lS->V0;
	  lR->V2	=lS->V2;
	  lR->V	=lS->V;
	  lR->ti	=lS->ti;
	  lR->I1	=lS->I1;
	  lR->n	=lS->n;
	  lR->i1	=lS->i1;
	  lR->i	=lS->i;
	  lR->i2	=lS->i2;
	  lR->ga	=lS->ga;
	}else{
	  lS->kS	=0;
	  lS->c		=0;
	  lS->n		=0;
	  lR->kS	=0;
	  lR->c		=0;
	  lR->n		=0;
	}
      }
      ZMessageF("%d %3d %10s",k,i,lS->Nm);
      lS++;
    }
  }

  for(k=0; k < nDGr; k++){
    kt=DGr[k].kt;
    kT=kt == 5 || kt == 6 || kt == 7 ? 1 : 0;
    lp	=DGr[k].P;
    ls	=DGr[k].S;
    lS 	=RawS+DGr[k].k0;
    I	=kt < 4 ? 0 : DGr[k].k;
    if(strcmp(lp,"DA/C2E-") == 0) kT=0;
    if(I && kT){
      sprintf(NmSig,"%sITFEVN",lp);
      n	=0x10000;
      ierr=getsignal_(NmSig,&iShot,yE,td,&n);
      if(ierr) kT=0;
      sprintf(NmSig,"%sITFODD",lp);
      n	=0x10000;
      ierr=getsignal_(NmSig,&iShot,yO,td,&n);
      if(ierr) kT=0;
      if(kT == 0) out("si I P=<s>","DGr",k,kt,DGr[k].P);
    }
    ii=0;
    for(i=0; i < I; i++){
      if(lS->kA && lS->c){
	lR	=Raw+lS->kS;
	if(kT){
	  cE=0.;
	  cO=0.;
	  sprintf(NmSig,"%s%s<TFE",lp,lS->Nm);
	  ierr=getcoef_(NmSig,&iShot,&yf);
	  cE	=ierr ? 0. : yf;
	  sprintf(NmSig,"%s%s<TFO",lp,lS->Nm);
	  ierr=getcoef_(NmSig,&iShot,&yf);
	  cO	=ierr ? 0. : yf;
	}
	sprintf(NmSig,"%s%s%s",lp,lS->Nm,ls);
	n	=0x10000;
	ierr=getsignal_(NmSig,&iShot,yd,td,&n);
	if(ierr == 0){
	  if(ii == 0){
	    if(DGr[k].n < n){
	      if(DGr[k].n) free(DGr[k].T);
	      lT	=(double*)malloc(n*kD);
	      DGr[k].T	=lT;
	    }else{
	      lT	=DGr[k].T;
	    }
	    DGr[k].n	=n;
	    DGr[k].i0	=0;
	    DGr[k].i	=0;
	    DGr[k].i1	=n;
	    DGr[k].t	=lT;
	    ld	=lT;
	    for(j=0; j < n; j++) *ld++=td[j];
	    ii	=1;
	  }
	  if(lS->n < n){
	    if(lS->n) free(lS->D);
	    lS->D=(double *)malloc(k < nGrI ? (3*n+DGr[0].n)*kD : 3*n*kD);
	  }
	  lS->V0	=lS->D+n;
	  lS->V2	=lS->V0+n;
	  lS->V	=k < nGrI ? lS->V2+n : NULL; 
	  ld	=lS->D;
	  if(kT){
	    for(j=0; j < n; j++) *ld++=yd[j]-cO*yO[j]-cE*yE[j];
	  }else if(kt < 5){
	    for(j=0; j < n; j++) *ld++=yd[j]*1e-6;
	  }else{
	    for(j=0; j < n; j++) *ld++=yd[j];
	  }
	  lS->T	=lT;
	  lS->ti=lT;
	  lS->I1=0;
	  lS->n	=n;
	  lS->i1=0;
	  lS->i	=0;
	  lS->i2=n;
	  lS->ga=1e-14;

	  lR->T	=lS->T;
	  lR->D	=lS->D;
	  lR->V0=lS->V0;
	  lR->V2=lS->V2;
	  lR->V	=lS->V;
	  lR->ti=lS->ti;
	  lR->I1=lS->I1;
	  lR->n	=lS->n;
	  lR->i1=lS->i1;
	  lR->i	=lS->i;
	  lR->i2=lS->i2;
	  lR->ga	=lS->ga;
	}
	else{
	  lS->kS	=0;
	  lS->c		=0;
	  lS->n		=0;
	  lR->kS	=0;
	  lR->c		=0;
	  lR->n		=0;
	}
      }
      ZMessageF("%d %3d %10s",k,i,lS->Nm);
      lS++;
    }
  }

#endif
  return(0);
}

int GetJETDisr()
{
  int kD,kF,j0,j1,J1,Fl,kT;
  int nSht,iSht,iSgn;
  int iShot;
  double tS[6][0x1000];
  double dS[148][0x1000];
  char NmSig[32];
  char *lp,*ls;
  float *lf,*lft;
  float t0,t1,y,ym;

  int i,ii,j,k,n,ierr,I;
  float yd[0x10000],td[0x10000],yE[0x10000],yO[0x10000],yf;
  double cE,cO;
  FILE *lF;
  char FNmO[256];
  int DisrShot[4772];

  char Pr[6][0x10]={
    "PF/SC-",
    "DA/C2-",
    "DA/C2-",
    "DA/C2E-",
    "DA/C2-"
    "DA/C2E-",
  };
  char Sf[6][0x10]={
    "<MS",
    "",
    "",
    "",
    "",
    ""
  };
  char NmSgn[136][8]={
    "IP",
    "ITF",
    "FL05",
    "FL11",
    "FLRRU",
    "FLRRL",
    "FLD2",
    "FLD3",

    "SX01",
    "SX02",
    "SX03",
    "SX04",
    "SX05",
    "SX06",
    "SX07",
    "SX08",
    "SX09",
    "SX10",
    "SX11",
    "SX12",
    "SX13",
    "SX14",

    "SY01",
    "SY02",
    "SY03",
    "SY04",
    "SY05",
    "SY06",
    "SY07",
    "SY08",
    "SY09",
    "SY10",
    "SY11",
    "SY12",
    "SY13",
    "SY14",

    "S101",
    "S102",
    "S103",
    "S104",
    "S105",
    "S106",
    "S107",
    "S108",
    "S109",
    "S110",
    "S111",
    "S112",
    "S113",
    "S114",

    "S501",
    "S502",
    "S503",
    "S504",
    "S505",
    "S506",
    "S507",
    "S508",
    "S509",
    "S510",
    "S511",
    "S512",
    "S513",
    "S514",

    "CX01",
    "CX02",
    "CX03",
    "CX04",
    "CX05",
    "CX06",
    "CX07",
    "CX08",
    "CX09",
    "CX10",
    "CX11",
    "CX12",
    "CX13",
    "CX14",
    "CX15",
    "CX16",
    "CX17",
    "CX18",
    "CY01",
    "CY02",
    "CY03",
    "CY04",
    "CY05",
    "CY06",
    "CY07",
    "CY08",
    "CY09",
    "CY10",
    "CY11",
    "CY12",
    "CY13",
    "CY14",
    "CY15",
    "CY16",
    "CY17",
    "CY18",

    "C101",
    "C102",
    "C103",
    "C104",
    "C105",
    "C106",
    "C107",
    "C108",
    "C109",
    "C110",
    "C111",
    "C112",
    "C113",
    "C114",
    "C115",
    "C116",
    "C117",
    "C118",
    "C501",
    "C502",
    "C503",
    "C504",
    "C505",
    "C506",
    "C507",
    "C508",
    "C509",
    "C510",
    "C511",
    "C512",
    "C513",
    "C514",
    "C515",
    "C516",
    "C517",
    "C518",
  };
  int nSgn[6]={1,9,28,28,36,36};

  kD	=sizeof(double);
  kF	=sizeof(float);
  nSht	=0;
  lF	=fopen("/home/lzakh/ShotList09","r");
  fscanf(lF,"%d",&nSht);
  for(iSht=0; iSht < nSht; iSht++) fscanf(lF,"%d",DisrShot+iSht);
  fclose(lF);
  lF	=NULL;
  
  for(iSht=0; iSht < nSht; iSht++){
    if(iSht%200 == 0){
      if(lF != NULL){
	fclose(lF);
	puts(FNmO);
      }
      sprintf(FNmO,"D%4.4d.d",iSht);
      lF	=fopen(FNmO,"w");
    }
    iShot	=DisrShot[iSht];
    iSgn	=0;
    k	=0;
    lp	=Pr[k];
    ls	=Sf[k];
    sprintf(NmSig,"%s%s%s",lp,NmSgn[iSgn],ls);
    n	=0x10000;
#ifdef JET
    ierr=getsignal_(NmSig,&iShot,yd,td,&n);
#endif
    if(ierr == 0){
      j	=0;
      while(td[j] < 40.) j++;
      lft	=td+j;
      lf	=yd+j;
      ym	=0.;
      y		=0.5;
      while(y > 0.5*ym){
	y	=fabs((double)yd[j]);
	if(ym < y) ym=y;
	j++;
      }
      t0	=td[j]-0.1;
      t1	=td[j]+0.1;
      j0	=j;
      while(td[j0] > t0) j0--;
      j1	=j;
      while(td[j1] < t1) j1++;
      J1	=j1-j0;
      fwrite(&J1,sizeof(int),1,lF);
      fwrite(td+j0,kF,J1,lF);
      fwrite(yd+j0,kF,J1,lF);
    }else{
      J1	=0;
      fwrite(&J1,sizeof(int),1,lF);
    }
    iSgn++;

    for(k=1; k < 6; k++){
      kT	=0;
      if(k > 3){
	sprintf(NmSig,"%sITFEVN",lp);
	n	=0x10000;
#ifdef JET
	ierr=getsignal_(NmSig,&iShot,yE,td,&n);
#endif
	if(ierr == 0){
	  sprintf(NmSig,"%sITFODD",lp);
	  n	=0x10000;
#ifdef JET
	  ierr=getsignal_(NmSig,&iShot,yO,td,&n);
#endif
	  if(ierr == 0) kT	=1;
	}
      }
      Fl	=0;
      lp	=Pr[k];
      ls	=Sf[k];
      for(i=0; i < nSgn[k]; i++){
	sprintf(NmSig,"%s%s%s",lp,NmSgn[iSgn],ls);
	n	=0x10000;
#ifdef JET
	ierr=getsignal_(NmSig,&iShot,yd,td,&n);
#endif
	if(ierr == 0){
	  if(Fl == 0){
	    j0	=0;
	    while(td[j0] < t0) j0++;
	    j1	=j0;
	    while(td[j1] < t1) j1++;
	    J1	=j1-j0;
	    fwrite(&J1,sizeof(int),1,lF);
	    fwrite(td+j0,kF,J1,lF);
	    Fl	=1;
	  }
	  fwrite(&J1,sizeof(int),1,lF);
	  if(kT && k > 3){
	    cE=0.;
	    cO=0.;
	    sprintf(NmSig,"%s%s<TFE",lp,NmSgn[iSgn]);
#ifdef JET
	    ierr=getcoef_(NmSig,&iShot,&yf);
#endif
	    cE	=ierr ? 0. : yf;
	    sprintf(NmSig,"%s%s<TFO",lp,NmSgn[iSgn]);
#ifdef JET
	    ierr=getcoef_(NmSig,&iShot,&yf);
#endif
	    cO	=ierr ? 0. : yf;
	    for(j=j0; j < j1; j++) yd[j] -=cO*yO[j]+cE*yE[j];
	  }
	  fwrite(yd+j0,kF,J1,lF);
	}else{
	  j	=0;
	  fwrite(&j,sizeof(int),1,lF);
	}
	iSgn++;
      }
    }
  }
  if(lF != NULL){
    fclose(lF);
    puts(FNmO);
  }
  return(0);
}

int WFormIp()
{	
  static int Fl=0,FlR=0;
  int k0,k1,nS,kG=0;
  char *Img;
  char Nm[nRaw][0x10];
  int i,i1,i2,j,k,n;
  double Y[4]={0.,0.5,0.5,1.};
  double *ld;
  RAWDATA *lS;

  if(nDGr == 0) return(0);
#ifndef AscIIp
#undef AscIIp
#endif/*AscIIp*/

  if(nDGr == 0) return(0);
#ifndef TblIp
  if(kG > nGrI) kG=nGrI-1;
  while(DGr[kG].k == 0 && kG < nGrI) kG++; 
  if(kG >= nGrI) kG=0;
  k0	=DGr[kG].k0;
  k1	=DGr[kG].k1;
  nS	=k1-k0;
  switch(FlR){
  case 0:
    break;
  case 1:
    GetJETI(FlR);
    break;
  case 2:
    GetJETI(FlR);
    break;
  case 3:
#ifndef BnrIIp
#undef BnrIIp
#endif/*BnrIIp*/
    break;
  }
  if(FlR){
    FlR=0;
    if(DGr[kG].n){
      PFtWF1	=DGr[kG].T[0];
      PFtWF2	=DGr[kG].T[DGr[kG].n-1];
      PFtWF	=0.5*(PFtWF1+PFtWF2);
    }
  }

  Img	=IMg[kG];
  k	=strlen(Img);
  for(j=k0; j < k1; j++) if(strncmp(RawS[j].Nm,Img,k) == 0) break;
  if(j == k1){
    *Img='\0';
    k	=0;
  }
  nkS	=0;
  for(j=k0,lS=RawS+k0; j < k1; j++,lS++){
    if(strncmp(Img,lS->Nm,k) == 0){
      strcpy(Nm[nkS],lS->Nm);
      kS[nkS]	=j;
      nkS++;
    }
  }

  n	=0;
  if(DGr[kG].n){
    PFSetTimeRange(kG);
    i1	=DGr[kG].i0;
    i2	=DGr[kG].i1;
    iSignIp=RawS->C*RawS->D[(i1+i2)/2]/RawS->G < 0.? -1 : 0;
    n	=i2-i1;
    Y[0]	= 1e+20;
    Y[3]	=-1e+20;
    for(j=0; j < nkS; j++){
      lS=RawS+kS[j];
      if(lS->kA == 0) lS->c=0;
      if(lS->c){
	ld	=lS->D+i1;
	for(i=i1; i < i2; i++){
	  if(Y[0] > *ld) Y[0]=*ld;
	  if(Y[3] < *ld) Y[3]=*ld;
	  ld++;
	}
	if(Fl){
	  lS->I1	=n;
	  lS->ti	=lS->T+i1;
	  i	=RawS[j].kS;
	  Raw[i].I1	=n;
	  Raw[i].ti	=lS->ti;
	  ISignal2Splines(lS->V0,lS->V2,lS->D+i1,lS->ti,n,gaI[kG]);
	}
      }
    }
    Y[1]=(Y[0] < 0. && Y[3]<0.) || (Y[0]>0. && Y[3] >0.) ? cr2*(Y[0]+Y[3]) : 0.;
    TimeSlice(kG);
    i	=DGr[kG].i;
    j	=k0;
    while(j < k1 && RawS[j].kA == 0) j++;
    if(j < k1) Y[2] =RawS[j].D[i];
    PlotTimeSlice(kG);
    kG0	=kG;
    switch(Fl){
    case 0:
      CbUserPlot	=PlotWForm;
      break;
    case 1:
      CbUserPlot	=PlotSplinedWForm;
      break;
    case 2:
      CbUserPlot	=PlotSplinedAndRawWForm;
      break;
    default:
      CbUserPlot	=PlotWForm;
      break;
    }
  }
#endif/*TblIp*/
  
#ifndef AscOIp
#undef AscOIp
#endif/*AscOIp*/
  return(0);
}

int WFormI()
{	
  static int Fl=0;
  char *Img;
  int k0,k1,kG=1;
  char Nm[nRawS][0x10];
  int i,i1,i2,j,k,m,n;
  double Y[4]={0.,0.,0.,0.};
  double *ld;
  RAWDATA *lS;
  
#ifndef AscIWFI
#undef AscIWFI
#endif/*AscIWFI*/

  if(nDGr == 0) return(0);
#ifndef Tbl_WFI
  if(kG > nGrI) kG=nGrI-1;
  while(DGr[kG].k == 0 && kG < nGrI) kG++; 
  if(kG >= nGrI) kG=0;
  k0	=DGr[kG].k0;
  k1	=DGr[kG].k1;
  m	=k1-k0;

  Img	=IMg[kG];
  k	=strlen(Img);
  for(j=k0; j < k1; j++) if(strncmp(RawS[j].Nm,Img,k) == 0) break;
  if(j == k1){
    *Img='\0';
    k	=0;
  }
  nkS	=0;
  for(j=k0,lS=RawS+k0; j < k1; j++,lS++){
    if(strncmp(Img,lS->Nm,k) == 0){
      strcpy(Nm[nkS],lS->Nm);
      kS[nkS]	=j;
      nkS++;
    }
  }

  n	=0;
  if(DGr[kG].n){
    PFSetTimeRange(kG);
    i1	=DGr[kG].i0;
    i2	=DGr[kG].i1;
    n	=i2-i1;
    Y[0]= 1e+20;
    Y[2]=-1e+20;
    for(j=0; j < nkS; j++){
      lS=RawS+kS[j];
      if(lS->kA == 0) lS->c=0;
      if(lS->c){
	ld	=lS->D+i1;
	for(i=i1; i< i2; i++){
	  if(Y[0] > *ld) Y[0]=*ld;
	  if(Y[2] < *ld) Y[2]=*ld;
	  ld++;
	}
	if(Fl){
	  lS->I1	=n;
	  lS->ti	=lS->T+i1;
	  Raw[lS->kS].I1	=n;
	  Raw[lS->kS].ti	=lS->ti;
	  ISignal2Splines(lS->V0,lS->V2,lS->D+i1,lS->ti,n,gaI[kG]);
	}
      }
    }
    Y[1]=(Y[0]<0. && Y[2]< 0.) || (Y[0]> 0. && Y[2]>0.) ? cr2*(Y[0]+Y[2]) : 0.;
    TimeSlice(kG);
    kG0	=kG;
    PlotTimeSlice(kG);
    if(kTimeHistory == 0 && Fl > 2) Fl=0;
    switch(Fl){
    case 0:
      CbUserPlot	=PlotWForm;
      break;
    case 1:
      CbUserPlot	=PlotSplinedWForm;
      break;
    case 2:
      CbUserPlot	=PlotSplinedAndRawWForm;
      break;
    case 3:
      CheckIfSplinedI(1);
      TimeHistoryVirtualI();
      Y[0]= 1e+20;
      Y[2]=-1e+20;
      for(m=0; m < nkS; m++){
	j	=kS[m];
	ld	=RawS[j].V;
	for(i=0; i< n; i++){
	  if(Y[0] > *ld) Y[0]=*ld;
	  if(Y[2] < *ld) Y[2]=*ld;
	  ld++;
	}
      }
      Y[1]=(Y[0]<0. && Y[2]< 0.) || (Y[0]> 0. && Y[2]>0.) ? cr2*(Y[0]+Y[2]) : 0.;
      CbUserPlot	=PlotVirtualI;
      break;
    default:
      CbUserPlot	=PlotWForm;
      break;
    }
  }
  else{
    for(j=k0,nkS=0; j < k1; j++,nkS++){
      kS[nkS]	=j;
      strcpy(Nm[nkS],RawS[j].Nm);
    }
  }
#endif/*Tbl_WFI*/
  if(kTimeHistory){
    CheckIfSplinedI(1);
    TimeHistoryVirtualI();
  }
#ifndef AscOWFI
#undef AscOWFI
#endif/*AscOWFI*/
  return(0);
}

int PlotSnapShotIp()
{
  int i,i1,k;
  double x[2],y[2],s,d;
  double *ld;

  SetPlotName("#","Ip [MA]","Plasma Current");
  y[0]	=PFC[0].I0-PFC[0].dI;
  if(y[0] > 0.) y[0]=0.;
  y[1]	=PFC[0].I0+PFC[0].dI;
  if(y[1] < 0.) y[1]=0.;
  x[0]	=0;
  x[1]	=nPFC1;

  Scale2d(2,x,y,2,6,2);
  x[0]	=1;
  y[0]	=PFC[0].I0+PFC[0].dI;
  Plot2d(2,x,y,1,6,0x0110,0,0);
  y[0]	=PFC[0].I0-PFC[0].dI;
  Plot2d(2,x,y,1,6,0x0110,0,0);
  y[0]	=PFC[0].I0;
  Plot2d(2,x,y,1,6,0x08,0,0);
  return(0);
}

int PlotSnapShotY(int FlY)
{
  int j,k,n,m;
  double v,s,x[nMFP],y[nMFP];
  MFPROBE *lM;

  switch(FlY){
  case 0:
    SetPlotName("Loop #","Y [Vsec]","Loop Signals");
    m	=nMFLS;
    lM	=MFP;
    break;
  case 1:
    SetPlotName("Loop #","Y [Vsec]","Loop Signals");
    m	=nMFL;
    lM	=MFP;
    break;
  case 2:
    SetPlotName("Loop #","Y [Vsec]","Saddle Loop");
    m	=nMFS;
    lM	=MFS;
    break;
  case 3:
    SetPlotName("Probe #","B [T]","Probe Signals");
    m	=nMFp;
    lM	=MFp;
    break;
  case 4:
    SetPlotName("Probe #","gF [Vsec]","Diamagnetic Signal");
    m	=nMFd;
    lM	=MFd;
    break;
  }

  y[0]	=1e+20;
  y[1]	=-1e+20;
  for(j=0; j < m; j++){
    if(lM[j].kA){
      v	=lM[j].S0-lM[j].dS;
      if(y[0] > v) y[0]=v;
      v	=lM[j].S0+lM[j].dS;
      if(y[1] < v) y[1]=v;
    }
    else{
      lM[j].S0	=0.;
      lM[j].dS	=0.;
    }
    lM[j].S	=0.;
  }

  if((FlY < 3 && (kTimeHistory&0x08)) || (FlY == 3 && (kTimeHistory&0x10))){
    for(j=0; j < m; j++){
      if(lM[j].kA){
	v	=lM[j].V0;
	if(y[0] > v) y[0]=v;
	if(y[1] < v) y[1]=v;
      }
    }
  }

  if(y[0] > 0.) y[0]=0.;
  if(y[1] < 0.) y[1]=0.;

  x[0]	=0;
  x[1]	=j+1;
  Scale2d(2,x,y,2,6,2);
  k	=0;
  for(j=0; j < m; j++){
    if(lM[j].kA){
      y[k]	=lM[j].S0+lM[j].dS;
      x[k]	=j+1;
      k++;
    }
  }
  Plot2d(2,x,y,k,6,0x0110,0,0);
  k	=0;
  for(j=0; j < m; j++){
    if(lM[j].kA){
      y[k]	=lM[j].S0-lM[j].dS;
      k++;
    }
  }
  Plot2d(2,x,y,k,6,0x0110,0,0);
  k	=0;
  for(j=0; j < m; j++){
    if(lM[j].kA){
      y[k]	=lM[j].S0;
      k++;
    }
  }
  Plot2d(2,x,y,k,6,0x08,0,0);
  k	=0;
  for(j=0; j < m; j++){
    if(lM[j].kA == 0){
      y[k]	=lM[j].S0;
      x[k]	=j+1;
      k++;
    }
  }
  Plot2d(2,x,y,k,6,0xc0,14,0);

  if((FlY < 3 && (kTimeHistory&0x08)) || (FlY == 3 && (kTimeHistory&0x10))){
    k	=0;
    for(j=0; j < m; j++){
      if(lM[j].kA){
	y[k]	=lM[j].V0;
	x[k]	=j+1+0.1;
	k++;
      }
    }
    Plot2d(2,x,y,k,6,0x108,14,0);
  }
  return(0);
}

int GetJETgY()
{
  int i,j,n;
  int ierr;
  float yd[0x10000],td[0x10000],yE[0x10000],yO[0x10000];
  double cE,cO;
  double *ld,*lt;
  char NmSig[32],PreNm[8]="DA/C2-";

 double CXY[18]={
 0.8705
 ,0.5200
 ,0.5200
 ,0.5750
 ,0.6300
 ,0.6300
 ,0.6300
 ,0.6300
 ,0.5620
 ,0.5620
 ,0.6300
 ,0.6300
 ,0.6300
 ,0.6300
 ,0.5750
 ,0.5200
 ,0.5200
 ,0.8705
};
double CD[4]={15.60,14.30,15.80,21.80};
double RVL[2]={0.00140,0.00140};

  sscanf(ShotNm,"%d",&iShot);
#ifdef JET
  sprintf(NmSig,"%sITFEVN",PreNm);
  n	=0x10000;
  ierr=getsignal_(NmSig,&iShot,yE,td,&n);
  sprintf(NmSig,"%sITFODD",PreNm);
  n	=0x10000;
  ierr=getsignal_(NmSig,&iShot,yO,td,&n);

  if(RawT->n < n){
    if(RawT->n){
      free(RawT->T);
      free(RawT->D);
    }
    RawT->T	=(double*)malloc(n*sizeof(double));
    RawT->D	=(double*)malloc(n*sizeof(double));

    RawT->V0	=RawT->D;
    RawT->V2	=RawT->V0;
    RawT->ti	=RawI[0].T;
    RawT->I1	=0;
  }
  RawT->n	=n;
  lt	=RawT->T;
  ld	=RawT->D;
  for(j=0; j < n; j++){
    *lt++=td[j];
    *ld++=0.5*(yE[j]+yO[j])*1e-6;
  }
  for(i=0; i < nMFP; i++){
    RawY[i].kA	=MFP[i].kA;
    RawY[i].c	=1;
    RawY[i].C	=MFP[i].s;
    sprintf(NmSig,"%s%s<TFE",PreNm,MFP[i].Nm);
    ierr=getcoef_(NmSig,&iShot,yd);
    cE	=ierr ? 0 : yd[0];
    sprintf(NmSig,"%s%s<TFO",PreNm,MFP[i].Nm);
    ierr=getcoef_(NmSig,&iShot,yd);
    cO	=ierr ? 0 : yd[0];
    sprintf(NmSig,"%s%s",PreNm,MFP[i].Nm);
    n	=0x10000;
    ierr=getsignal_(NmSig,&iShot,yd,td,&n);
    if(ierr == 0){
      RawY[i].kA=MFP[i].kA;
      RawY[i].T	=RawT->T;
      if(RawY[i].n < n){
	if(RawY[i].n) free(RawY[i].D);
	RawY[i].D	=(double*)malloc(2*n*sizeof(double));
	RawY[i].V0	=RawY[i].D+n;
	RawY[i].V2	=NULL;
	RawY[i].ti	=RawT->T;
	RawY[i].I1	=0;
      }
      RawY[i].n	=n;
      ld	=RawY[i].D;
      for(j=0; j < n; j++) *ld++=yd[j]-cE*yE[j]-cO*yO[j];
#ifdef H
      if(strcmp(MFP[i].Nm,"S7I")== 0){
	j=4483;
	printf("%5d %12.5e %12.5e %12.5e %12.5e %12.5e %12.5e\n"
	       ,j+1,cE,cO,yE[j],yO[j],yd[j],RawY[i].D[j]);
      }
#endif
    }
    else{
      RawY[i].kA=0;
      MFP[i].kA	=0;
    }
#ifdef H
    out("iI\t|s| |s|",i,RawY[i].n,MFP[i].Nm,NmSig);
#endif
  }

#ifdef H
  for(k=0,i=nMFP-2; k < 2; k++,i++){
    RawY[i].kA	=MFP[i].kA;
    RawY[i].c	=1;
    RawY[i].C	=MFP[i].s;
    strcpy(MFP[i].Nm,k == 0 ? "VLRRU" : "VLRRL");
    sprintf(NmSig,"%s%s",PreNm,MFP[i].Nm);
    strcpy(RawY[i].Nm,MFP[i].Nm);
    strcpy(RawS[RawY[i].kS].Nm,MFP[i].Nm);
    n	=0x10000;
    ierr=getsignal_(NmSig,&iShot,yd,td,&n);
    if(ierr == 0){
      RawY[i].kA=MFP[i].kA;
      RawY[i].T	=RawT->T;
      if(RawY[i].n < n){
        if(RawY[i].n) free(RawY[i].D);
        RawY[i].D	=(double*)malloc(n*sizeof(double));
      }
      RawY[i].n	=n;
      ld	=RawY[i].D;
      s		=1e-6/RVL[k];
      for(j=0; j < n; j++) *ld++=yd[j]*s;
    }
    else{
      RawY[i].kA=0;
      MFP[i].kA	=0;
    }
    out("iI\t|s| <s><s>|s|",i,RawY[i].n,RawY[i].Nm,RawS[RawY[i].kS].Nm
	,MFP[i].Nm,NmSig);
 }

 
C2-CX01 or C2-CY01 0.8705
C2-CX02 or C2-CY02 0.5200
C2-CX03 or C2-CY03 0.5200
C2-CX04 or C2-CY04 0.5750
C2-CX05 or C2-CY05 0.6300
C2-CX06 or C2-CY06 0.6300
C2-CX07 or C2-CY07 0.6300
C2-CX08 or C2-CY08 0.6300
C2-CX09 or C2-CY09 0.5620
C2-CX10 or C2-CY10 0.5620
C2-CX11 or C2-CY11 0.6300
C2-CX12 or C2-CY12 0.6300
C2-CX13 or C2-CY13 0.6300
C2-CX14 or C2-CY14 0.6300
C2-CX15 or C2-CY15 0.5750
C2-CX16 or C2-CY16 0.5200
C2-CX17 or C2-CY17 0.5200
C2-CX18 or C2-CY18 0.8705

Divertor Structure Current 	a
C2-ID1 15.60
C2-ID2 14.30
C2-ID3 15.80
C2-ID4 21.80

C2-I-MK2 till #59441 1.20
C2-I-MK2 for #59442 onward 0

Restrain Ring Loop Voltages
RRR[Ohm]
C2-VLRRU 0.00140
C2-VLRRL 0.00140
#endif

#ifdef H
  n=0;
  for(i=0; i < nRaw; i++){
    j=strlen(Raw[i].Nm);
    if(n < j) n=j;
  }
  strcpy(FNmO,"/w/dB0/JET/2004/62665/In/SigLayOut.ai");

  strcpy(FNmO,"SigLayOut.ai");

  lF	=fopen(FNmO,"w");
  fputs("! Signal=C/G(RawS+A*t+B), kG - group number, kA=0/1 - activity\n",lF);
  fprintf(lF,"<Layout of Signals>[%d](%%s 3%%d 9%%e)\n",nRaw);
  *str='!';
  *(str+1)='%';
  sprintf(str+2,"%d",n-1);
  strcpy(str+strlen(str)
	 ,"s%3s%6s%4s%11s%11s%11s%11s%11s\n!%30s%11s%11s%11s\n");
  fprintf(lF,str,"Name","kA","Group","kS","C","Gain","A","B"
	  ,"Error dS","Error dC","Error dG","Error dA","Error dB");
  *str='%';
  sprintf(str+1,"%d",n);
  strcpy(str+strlen(str),"s%3d%6d%4d%11.3e%11.3e%11.3e%11.3e%11.3e\n%31.3e %10.3e %10.3e %10.3e\n");
  lS	=Raw;
  for(i=0; i < nRaw; i++){
    fprintf(lF,str,lS->Nm,lS->kA,lS->kG,lS->kS,lS->C,lS->G,lS->A,lS->B,lS->dS
	    ,lS->dC,lS->dG,lS->dA,lS->dB);
    lS++;
  }
  fclose(lF);
  printf("Output: %s\n",FNmO);
#endif
#endif
  return(0);
}

int PFWriteWFormAO(FILE *lf,int kG)
{
  int i,j,k,j1,j2,i1,i2;
  char *lNmW[4]={"Ip","I","Y","B"};
  char *lc;

  j1	=DGr[kG].k0;
  j2	=DGr[kG].k0;

  i1	=RawS[j1].i1;
  i2	=RawS[j1].i2;
  fprintf(lf,"<WaveForm%s>[%d](t=%d%%e)\n",lNmW[kG],i2-i1,j2-j1+1);
  fprintf(lf,"!%11s","t");
  k	=0;
  for(j=j1; j < j2; j++){
    k++;
    lc	=k%6 ? " %12s" : "\n!%11s";
    fprintf(lf,lc,RawS[j].Nm);
  }
  if(k%6) putc('\n',lf);

  for(i=i1; i < i2; i++){
    fprintf(lf,"t=%10.5f",RawS[j1].T[i]);
    k	=0;
    for(j=j1; j < j2; j++){
      k++;
      fprintf(lf,k%6 ? " %12.5e" : "\n%12.5e",RawS[j].D[i]);
    }
    if(k%6) putc('\n',lf);
  }
  return(0);
}

int WFormY()
{	
  int i,j,k,n,i1,i2;
  int k0,k1,kG,iG=0;
  static int Fl=0,FlR=0;
  char Nm[nRawS][0x10];
  char *Img;
  double Y[4]={0.,0.,0.,0.};
  double *ld;
  RAWDATA *lS;

#ifndef AscIWFY
#undef AscIWFY
#endif/*AscIWFY*/

  if(nDGr == 0) return(0);
#ifndef Tbl_WFY
  kG	=nGrI+iG;
  while(DGr[kG].k == 0 && kG < nDGr) kG++; 
  if(kG >= nDGr) kG=nGrI;
  iG	=kG-nGrI;
  k0	=DGr[kG].k0;
  k1	=DGr[kG].k1;
  switch(FlR){
  case 0:
    break;
  case 1:
    GetJETgY();
    break;
  }
  FlR	=0;
  Img	=IMg[kG];
  k	=strlen(Img);
  for(j=k0; j < k1; j++) if(strncmp(RawS[j].Nm,Img,k) == 0) break;
  if(j == k1){
    *Img='\0';
    k	=0;
  }
  nkS	=0;
  for(j=k0,lS=RawS+k0; j < k1; j++,lS++){
    if(strncmp(Img,lS->Nm,k) == 0){
      strcpy(Nm[nkS],lS->Nm);
      kS[nkS]	=j;
      nkS++;
    }
  }

  n	=0;
  if(DGr[kG].n){
    PFSetTimeRange(kG);
    i1	=DGr[kG].i0;
    i2	=DGr[kG].i1;
    n	=i2-i1;
    Y[0]= 1e+20;
    Y[2]=-1e+20;
    for(j=0; j < nkS; j++){
      lS=RawS+kS[j];
      if(lS->kA == 0) lS->c=0;
      Raw[lS->kS].c=lS->c;
      if(lS->c){
	ld	=lS->D+i1;
	for(i=i1; i< i2; i++){
	  if(Y[0] > *ld) Y[0]=*ld;
	  if(Y[2] < *ld) Y[2]=*ld;
	  ld++;
	}
	if(Fl && lS->kA){
	  lS->I1	=n;
	  lS->ti	=lS->T+i1;
	  Raw[lS->kS].I1	=n;
	  Raw[lS->kS].ti	=lS->ti;
	  ISignal2Splines(lS->V0,lS->V2,lS->D+i1,lS->ti,n,gaI[kG]);
	}
      }
    }
    TimeSlice(kG);
    kG0	=kG;
    if(kTimeHistory == 0 && Fl > 2) Fl =0;
    if(Fl > 2){
      CheckIfSplinedI(1);
      if(nMFd) IfSplinedDiamag();
      TimeHistorySignal(0);
      for(j=k0; j < k1; j++){
	if((RawS[j].c) == 0){
	  ld	=RawS[j].V0;
	  i	=RawS[j].I1;
	  while(i){
	    i--;
	    if(Y[0] > *ld) Y[0]=*ld;
	    if(Y[2] < *ld) Y[2]=*ld;
	    ld++;
	  }
	}
      }
    }
    PlotTimeSlice(kG);
    Y[1]=(Y[0]<0. && Y[2]< 0.)|| (Y[0]> 0. && Y[2]>0.) ? cr2*(Y[0]+Y[2]) : 0.;
    switch(Fl){
    case 1:
      CbUserPlot	=PlotSplinedWForm;
      break;
    case 2:
      CbUserPlot	=PlotSplinedAndRawWForm;
      break;
    case 4:
      CbUserPlot	=PlotPlasmaAndEddyWForm;
      break;
    case 8:
      CbUserPlot	=PlotPFCWFormY;
      break;
    default:
      CbUserPlot	=PlotWForm;
      break;
    }
  }
  else{
    for(j=k0,nkS=0; j < k1; j++,nkS++){
      kS[nkS]	=j;
      strcpy(Nm[nkS],RawS[j].Nm);
    }
  }
#endif/*Tbl_WFY*/
  if(kTimeHistory){
    CheckIfSplinedI(1);
    if((kTimeHistory&0x08) == 0){
#ifndef BnrIWFY
#undef BnrIWFY
#endif/*BnrIWFY*/
    }
    if((kTimeHistory&0x08) == 0) TimeHistorySignal(0);
    if((kTimeHistory&0x20) == 0 && nMFd) IfSplinedDiamag();
#ifndef BnrOWFY
#undef BnrOWFY
#endif/*BnrOWFY*/
  }
#ifndef AscOWFY
#undef AscOWFY
#endif/*AscOWFY*/
  return(0);
}

int PTimeSlice(int iG)
{
  int i,j,k,n,m,k0,k1,kt,kG;
  double d;
  double S,dS;
  double Sm[0x20],Sm2[0x20],*lt,*ld;
  int nSm,nSm1,iSm;
  RAWDATA *lP;

  if(PGr[iG].k == 0 || PGr[iG].n == 0) return(0);
  k0	=PGr[iG].k0;
  k1	=PGr[iG].k1;
  n	=PGr[iG].n;
  m	=PGr[iG].na1;

  kG	=nDGr+iG;

  nSm	=nSmP;
  nSm1	=nSm+1;
  kt	=PGr[iG].kt;
  iSm	=PGr[iG].i-nSm1/2;
  if(iSm < 0) iSm=0;
  if(iSm+nSm1 > n) iSm=n-nSm1;
  lt	=PGr[iG].T+iSm;
  lP	=RawP+k0;
  for(k=k0,lP=RawP+k0; k < k1; k++,lP++){
    if(lP->kA){
      for(i=0,ld=lP->D+iSm*m; i < m; i++,ld++){
	dS	=0.;
	if(nSm){
	  for(j=0; j < nSm1; j++) Sm[j]=ld[m*j];
	  f2spl(Sm,Sm2,NULL,NULL,Sm,NULL,lt,&nSm,&ga0,&ga1,&ga2,gaS+kG);
	  splr0(&S,NULL,&PFtWF,Sm,Sm2,lt,&nSm);
	  for(j=0; j < nSm1; j++){
	    d	=ld[m*j]-Sm[j];
	    dS	+=d*d;
	  }
	  dS	=2.*sqrt(dS/nSm1);
	}
	lP->V[i]=S;
	lP->dV[i]=S*lP->errR[i]+lP->errA[i]+dS;
	if(kt == 12){
	  MSE[i].gg	=iSignIp ? lP->V[i]-180. : lP->V[i];
	  MSE[i].dgg	=lP->dV[i];
	  d	=tan(lP->V[i]*cgp/180.);
	  MSE[i].S0	=d;
	  MSE[i].dS	=(1.+d*d)*lP->dV[i]*cgp/180.;
	}
      }
    }
  }
  return(0);
}

int PTimeSlicePL(RAWDATA *lP,int iG,int Fl)
{
  int iW=2;
  int i,k,k0,k1,m,ic,kt;
  double x[2],y[2],s,t;
  double *ld,*lv;
  char str[0x20];
  char YNm[8][0x10]={
    "gg^o"
    ,"MSE-LS"
    ,"Transp"
    ,""
    ,"tg(gg)"
    ,"MSE-LS"
    ,"Transp"
    ,""
  };

  if(PGr[iG].n == 0 || PGr[iG].k == 0) return(0);
  m	=PGr[iG].na1;
  kt	=PGr[iG].kt;
  if(kt != 12) Fl=0;

  i	=kt-12;
  if(Fl) i+=4;
  SetPlotName("#",YNm[i],TypeNm[kt]);
  y[0]	=0.;
  y[1]	=0.;
  x[0]	=0.;
  x[1]	=m;

  t	=cgp/180.;
  lv	=lP->V;
  ld	=lP->dV;
  for(i=0; i < m; i++){
    s	=lv[i]-ld[i];
    if(Fl) s=tan(s*t);
    if(y[0] > s) y[0]=s;
    s	=lv[i]+ld[i];
    if(Fl) s=tan(s*t);
    if(y[1] < s) y[1]=s;
  }
  x[0]	-=0.5;
  x[1]	+=0.5;
  Scale2d(iW,x,y,2,6,2);
  
  ic	=kCol[lP->c-1];
  lv	=lP->V;
  ld	=lP->dV;

  for(i=0; i < m; i++){
    x[0]	=i;
    x[1]	=x[0];
    y[0]	=lv[i]+ld[i];
    if(Fl) y[0]	=tan(y[0]*t);
    Plot2d(iW,x,y,1,6,0x0110,ic,0);
    y[0]	=lv[i]-ld[i];
    if(Fl) y[0]=tan(y[0]*t);
    Plot2d(iW,x,y,1,6,0x0110,ic,0);
    y[0]	=lv[i];
    if(Fl) y[0]=tan(y[0]*t);
    Plot2d(iW,x,y,1,6,0x08,ic,0);
  }
  return(0);
}

int WFormPAI(FILE *lF)
{
  int kI,kD,L;
  int i,j,k,m,n,i0,i1,mF;
  char str[64];
  char *lc;
  char *lm;
  char *lv[0x10];
  int dl[0x10];
  double s;
  double *lA,*lT;
  char *lDir,*lN;
  char FNm[0x100],Nm[0x40];
  FILE *lFb=NULL;
  RAWDATA *lP;

  kI	=sizeof(int);
  kD	=sizeof(double);

  lm	="WFormP.ai";
  lc	="<Profile Groups>";
  if(IsKeyWordFound(lF,lm,lc,str,&n)){
    nPGr	=n;
    lv[0]	=(char*)&i;
    lv[1]	=(char*)&j;
    lv[2]	=(char*)&PGr[0].k;
    lv[3]	=(char*)&PGr[0].na1;
    lv[4]	=(char*)&PGr[0].n;
    lv[5]	=(char*)&PGr[0].i0;
    lv[6]	=(char*)&PGr[0].i1;
    lv[7]	=(char*)&PGr[0].id;

    dl[0]	=0;
    dl[1]	=0;
    k	=sizeof(GROUPDT);
    dl[2]	=k;
    dl[3]	=k;
    dl[4]	=k;
    dl[5]	=k;
    dl[6]	=k;
    dl[7]	=k;
    ReadAI(lF,lc,lm,str,n,lv,dl,8);
  }
  else{
    CbStr2UserMessage("%s: %s record is absent.\n",lm,lc);
    return(1);
  }
  n	=0;
  for(k=0; k < nPGr; k++){
    PGr[k].n	=PGr[k].i1-PGr[k].i0;
    PGr[k].i0	=0;
    PGr[k].i1	=PGr[k].n;
    PGr[k].k0	=n;
    n	+=PGr[k].k;
    PGr[k].k1	=n;
  }
  lc	="<Profile List>";
  if(IsKeyWordFound(lF,lm,lc,str,&n)){
    nRawP	=n;
    lv[0]	=(char*)&i;
    lv[1]	=(char*)&RawP[0].kG;
    lv[2]	=(char*)&RawP[0].m;
    lv[3]	=(char*)&RawP[0].n;
    lv[4]	=(char*)&RawP[0].i1;
    lv[5]	=(char*)&RawP[0].i2;
    lv[6]	=RawP[0].Nm;
    k	=sizeof(RAWDATA);
    dl[0]	=0;
    dl[1]	=k;
    dl[2]	=k;
    dl[3]	=k;
    dl[4]	=k;
    dl[5]	=k;
    dl[6]	=k;
    ReadAI(lF,lc,lm,str,n,lv,dl,7);
  }
  else{
    CbStr2UserMessage("%s: %s record is absent.\n",lm,lc);
    return(1);
  }
  for(k=0,lP=RawP; k < nRawP; k++,lP++){
    lP->n	=lP->i2-lP->i1;
    lP->i1	=0;
    lP->i2	=lP->n;
    if(lP->n == 0) lP->kA=0; 
  }

  lc	="<Data: a[0]>";
  *FNm	=0;
  mF	=0;

  k=IsRecordHeadFound(lF,lm,lc,&mF,Nm,str,&m);
  if(k == 0){
    CbStr2UserWarning("Error: %s: %s is absent.\n",lm,lc);
    printf("Error: %s: %s is absent.\n",lm,lc);
    return(1);
  }
  if(k > 2){
    CbGetCurrentCbName(&lDir,&lN);
    realpath(lDir,FNm);
    L	=strlen(FNm);
    if(*Nm != '/') FNm[L++]='/';
    strcpy(FNm+L,Nm);
    lFb	=fopen(FNm,"r");
  }
  if(lFb == NULL) return(0);
  mF	=0;
  for(k=0; k < nDGr; k++){
    if(PGr[k].k && PGr[k].n){
      n	=PGr[k].n;
      m	=PGr[k].na1;
      if(PGr[k].a != NULL) free(PGr[k].a);
      lA	=(double *)malloc(m*kD);
      if(lA == NULL){
	CbStr2UserWarning("Error:%s: PGr[%d].a %d -no memory\n",lm,k,kD*m);
	printf("Error:%s: PGr[%d].k %d -no memory\n",lm,k,kD*m);
	return(1);
      }
      PGr[k].a=lA;
      i	=fread((void*)lA,kD,m,lFb);
      if(i < m){
	CbStr2UserWarning("Error:%s: PGr[%d].a %d -bad record\n",lm,k,n);
	printf("Error:%s: PGr[%d].a %d -bad record\n",lm,k,n);
	return(1);
      }
      mF	+=kD*m;
      if(PGr[k].T != NULL) free(PGr[k].T);
      lT=(double *)malloc(2*n*kD);
      if(lT == NULL){
	CbStr2UserWarning("Error:%s: DGr[%d].T %d -no memory\n",lm,k,kD*n);
	printf("Error:%s: DGr[%d].k %d -no memory\n",lm,k,kD*n);
	return(1);
      }
      PGr[k].T=lT;
      PGr[k].t=lT;
      i	=fread((void*)lT,kD,n,lFb);
      if(i < n){
	CbStr2UserWarning("Error:%s: DGr[%d].T %d -bad record\n",lm,k,n);
	printf("Error:%s: DGr[%d].T %d -bad record\n",lm,k,n);
	return(1);
      }
      mF	+=kD*n;
      i1	=PGr[k].k;
      for(i=0,lP=RawP+PGr[k].k0; i < i1; i++,lP++){
	lP->a	=lA;
	lP->T	=lT;
	if(lP->kA){
	  if(lP->D != NULL) free(lP->D);
	  lP->D	=(double *)malloc((3*n+2)*m*kD);
	  if(lP->D == NULL){
	    CbStr2UserWarning("Error:%s: %s %d -no memory\n"
			      ,lm,lP->Nm,(3*n+2)*m*kD);
	    printf("Error:%s: %s %d -no memory\n"
		   ,lm,lP->Nm,(3*n+2)*m*kD);
	  }
	  lP->V0	=lP->D+n*m;
	  lP->V2	=lP->V0+n*m;
	  lP->V		=lP->V2+n*m; 
	  lP->dV	=lP->V+m; 
	  j	=fread((void*)(lP->D),kD,n*m,lFb);
	  if(j < n*m){
	    CbStr2UserWarning("Error:%s: %s %d < %d -bad record\n"
			      ,lm,lP->Nm,j,n*m);
	    printf("Error:%s: %s %d < %d -bad record\n",lm,lP->Nm,j,n*m);
	    return(1);
	  }
	  mF		+=kD*n*m;
	  lP->ti	=lT;
	  lP->I1	=0;
	  lP->i1	=0;
	  lP->i		=0;
	  lP->i2	=n;
	  lP->m		=m;
	  lP->n		=n;
	  lP->kA	=1;
	  lP->c		=1;
	}
	else{
	  lP->kA=0;
	  lP->c	=0;
	  lP->n	=0;
	  if(lP->D !=NULL) free(lP->D);
	  lP->D	=NULL;
	  lP->T	=NULL;
	}
      }
    }
  }
  fclose(lFb);
  printf("Input: %s\n",FNm);
  CbStr2UserMessage("Input: %s\n",FNm);
  return(0);
}

static RAWDATA *lP0;
void WFormPPL()
{
  int i,j,i1,i2,kt,m,n,iG;
  double *lt,*ld,*lD;
  double s,d,Sm[0x20],SmP[0x20],SmM[0x20],Sm2[0x20];
  double C,dS,dC,dB;
  int nSm,nSm1,iSm;
  RAWDATA *lP;
  char ln[0x40];
  
  iG	=kG0-nDGr;
  if(PGr[iG].n == 0 || PGr[iG].k == 0 || lP0->kA == 0) return;
  n	=PGr[iG].n;
  m	=PGr[iG].na1;
  lD	=PGr[iG].T+n;
  i1	=PGr[iG].i0;
  i2	=PGr[iG].i1;
  lP	=lP0;

  nSm	=nSmP ? nSmP : 16;
  nSm1	=nSm+1;
  kt	=PGr[iG].kt;
  iSm	=PGr[iG].i-nSm1/2;
  if(iSm < 0) iSm=0;
  if(iSm+nSm1 > n) iSm=n-nSm1;
  n	=i2-i1;
  lt	=PGr[iG].T+iSm;
  ZColor(0);
  i=sprintf(ln,"%s",TypeNm[PGr[iG].kt]);
  ZPlotUTopMString(ln,i);

  C =lP->C;
  dC=lP->dC;
  dB=lP->dB;
  for(i=0; i < m; i++){
    ld	=lP->D+i;
    for(j=i1; j < i2; j++) lD[j]=ld[m*j];
    dS	=0.;
    if(nSmP){
      ld	=lD+iSm;
      f2spl(Sm,Sm2,NULL,NULL,ld,NULL,lt,&nSm,&ga0,&ga1,&ga2,gaS+kG0);
      for(j=0; j < nSm1; j++){
	d	=ld[j]-Sm[j];
	dS+=d*d;
      }
      dS	=2.*sqrt(dS/nSm1);
    }
    else{
      memcpy(Sm,lD+iSm,nSm1*sizeof(double));
    }
    for(j=0; j < nSm1; j++){
      s	=dS+fabs(dB);
      if(C != 0.) s+=fabs(dC*Sm[j]/C);
      SmP[j]	=Sm[j]+s;
      SmM[j]	=Sm[j]-s;
    }
    ZColor(kCol[lP->c-1]);
    ZPlotPolyLine(lP->T+i1,lD+i1,n);
    ZColor(4);
    ZPlotPolyLine(lt,Sm,nSm1);
    ZPlotPolyLine(lt,SmP,nSm1);
    ZPlotPolyLine(lt,SmM,nSm1);
  }
  return;
}

int WFormP()
{	
  int i,ii,j,k,n,i1,i2;
  int k0,k1,iG=0;
  static int Fl=0;
  double Y[4]={0.,0.,0.,0.};
  double *ld;
  RAWDATA *lP;

  PGr=DGr+nDGr;
#ifndef AscI_WFormP
#undef AscI_WFormP
#endif/*AscI_WFormP*/
  if(nPGr == 0) return(0);
#ifndef Tbl_WFormP
  if(iG >= nPGr) iG=nPGr-1;
  kG0	=nDGr+iG;
  k0	=PGr[iG].k0;
  k1	=PGr[iG].k1;
  n	=0;
  if(PGr[iG].n){
    PFSetTimeRange(kG0);
    i1	=PGr[iG].i0;
    i2	=PGr[iG].i1;
    n	=i2-i1;
    Y[0]= 1e+20;
    Y[2]=-1e+20;
    lP	=RawP+k0;
    for(j=k0,lP=RawP+k0; j < k1; j++,lP++){
      if(lP->kA == 0) lP->c=0;
      if(lP->c) break;
    }
    if(j == k1){
      for(j=k0,lP=RawP+k0; j < k1; j++,lP++){
	if(lP->kA){
	  lP->c=1;
	  break;
	}
      }
    }
    ld	=lP->D+i1*lP->m;
    for(i=i1; i < i2; i++){
      ii	=lP->m;
      while(ii){
	ii--;
	if(Y[0] > *ld) Y[0]=*ld;
	if(Y[2] < *ld) Y[2]=*ld;
	ld++;
      }
    }
#ifdef H
    if(Fl && lP->kA){
      lP->I1	=n;
      lP->ti	=lP->T+i1;
      Raw[lP->kS].I1	=n;
      Raw[lP->kS].ti	=lP->ti;
      ISignal2Splines(lP->V0,lP->V2,lP->D+i1,lP->ti,n,gaI[kG]);
    }
#endif
    PTimeSlice(iG);
    PTimeSlicePL(lP,iG,0);
    Y[1]=(Y[0]<0. && Y[2]< 0.) || (Y[0]> 0. && Y[2]>0.) ? cr2*(Y[0]+Y[2]) : 0.;
    lP0	=lP;
    CbUserPlot	=WFormPPL;
  }
#endif/*Tbl_WFormP*/
  for(j=k0; j < k1;j++) RawS[j].c &=0xff;
  if(kTimeHistory){
    CheckIfSplinedI(1);
    if((kTimeHistory&0x10) == 0){
#ifndef BnrI_WFormP
#undef BnrI_WFormP
#endif/*BnrI_WFormP*/
    }
    if((kTimeHistory&0x10) == 0) TimeHistorySignal(1);
#ifndef BnrO_WFormP
#undef BnrO_WFormP
#endif/*BnrO_WFormP*/
  }
#ifndef AscO_WFormP
#undef AscO_WFormP
#endif/*AscO_WFormP*/
  return(0);
}

int TimeSliceOfAll()
{
  extern double ESgDgFexp;
  int i,j,k,k0,k1,m,n,kG,kt;
  double d,S,dS;
  double C,G,A,B,dC,dG,dA,dB;
  double Sm[0x20],Sm2[0x20],*lt,*ld;
  int nSm,nSm1,iSm;
  RAWDATA *lS,*lR;

  nSm	=16;
  nSm1	=nSm+1;

  for(kG=0; kG < nDGr; kG++){
    if(DGr[kG].k && DGr[kG].n){
      k0	=DGr[kG].k0;
      k1	=DGr[kG].k1;
      n	=DGr[kG].n;
      kt	=DGr[kG].kt;
      iSm	=DGr[kG].i-nSm1/2;
      if(iSm < 0) iSm=0;
      if(iSm+nSm1 > n) iSm=n-nSm1;
      lt	=DGr[kG].T+iSm;

      for(k=k0,lS=RawS+k0; k < k1; k++,lS++){
	if(lS->kA){
	  G	=lS->G;
	  C	=iSignIp ? -lS->C : lS->C;
	  A	=lS->A;
	  B	=lS->B;
	  dC	=lS->dC;
	  dG	=lS->dG;
	  dA	=lS->dA;
	  dB	=lS->dB;

	  ld	=lS->D+iSm;
	  f2spl(Sm,Sm2,NULL,NULL,ld,NULL,lt,&nSm,&ga0,&ga1,&ga2,gaS+kG);
	  splr0(&S,NULL,&PFtWF,Sm,Sm2,lt,&nSm);
	  dS	=0.;
	  for(j=0; j < nSm1; j++){
	    d	=ld[j]-Sm[j];
	    dS	+=d*d;
	  }
	  dS	=2.*sqrt(dS/nSm1);
	  lS->S=C*(S-(A*PFtWF+B))/G;
	  lS->dS=(fabs(C*dS)+fabs(C*dB)+fabs(dC*(S-(A*PFtWF+B)))
		  +fabs(C*dA*PFtWF)+fabs(lS->S*dG))/fabs(G);
	  j	=lS->kS;
	  lR	=Raw+j;
	  lR->S	=lS->S;
	  lR->dS=lS->dS;

	  if(kt < 4){
	    PFC[j].I0	=lR->S;
	    PFC[j].dI	=lR->dS;
	    if(kt == 3) iSignBt = lS->S < 0. ? 1 : 0;
	  }
	  else if(kt == 4){
	    j	-=nPFC1;
	    VVC[j].I0	=lS->S;
	    VVC[j].dI	=lS->dS;
	  }
	  else{
	    j	-=nPFC1+nVVC;
	    MFP[j].S0	=lS->S;
	    MFP[j].dS	=lS->dS;
	    if(kt == 8) ESgDgFexp=MFP[j].S0;
	    lS->ti	=Raw[0].T+Raw[0].i1;
	    if((kt < 7 && (kTimeHistory&0x08)) || (kTimeHistory&0x10)){
	      m	=Raw[0].i-Raw[0].i1;
	      MFP[j].V0=lS->S-(lS->V0[m]*C/G);
	    }
	  }
	}
      }
    }
  }
  if(nPGr){
    for(kG=0; kG < nPGr; kG++) PTimeSlice(kG);
  }
  return(0);
}

int PlotSnapShotI()
{
  int i,m,k,kc[5]={0,0,14,11,4};
  double v,x[nPFC+1],y[nPFC+1];

  m	=nPFC+1;
  y[0]=1e+20;
  y[1]=-1e+20;
  for(i=0; i < m; i++){
    if(RawI[i].c){
      v	=PFC[i].I0-PFC[i].dI;
      if(y[0] > v) y[0]=v;
      v	=PFC[i].I0+PFC[i].dI;
      if(y[1] < v) y[1]=v;
    }
  }
  if(y[0] > 0.) y[0]=0.;
  if(y[1] < 0.) y[1]=0.;

  SetPlotName("Coil #","I [MA]","Coil Currents");
  x[0]	=0;
  x[1]	=m+1;
  Scale2d(2,x,y,2,6,2);

  k	=0;
  for(i=0; i < m; i++){
    if(RawI[i].c){
      y[k]	=PFC[i].I0+PFC[i].dI;
      x[k]	=i+1;
      k++;
    }
  }
  Plot2d(2,x,y,k,6,0x0110,0,0);
  k	=0;
  for(i=0; i < m; i++){
    if(RawI[i].c){
      y[k]	=PFC[i].I0-PFC[i].dI;
      k++;
    }
  }
  Plot2d(2,x,y,k,6,0x0110,0,0);
  k	=0;
  for(i=0; i < m; i++){
    if(RawI[i].c){
      y[k]	=PFC[i].I0;
      k++;
    }
  }
  Plot2d(2,x,y,k,6,0x08,0,0);
  return(0);
}

int AsymData()
{	
  extern double **gYiC,**gYiS;
  int i,i0,ii,k,kk,m,j,j1,kG;
  double I[4],Z[4],X[4],aI,II[4],a,sI,IRing[2],IMK2;
  double ZJ[4],XJ[4],Zpm,Xpm;
  FILE *lF0,*lF1,*lF2,*lF;
  char FNm[0x20],FNm1[0x20],FNm2[0x20];
  double s;
  double *CXY;
  /*
  double CXYD[4][18]={
    ,0.8705
    ,0.5200
    ,0.5200
    ,0.5750
    ,0.6300
    ,0.6300
    ,0.6300
    ,0.6300
    ,0.5620

    ,0.5620
    ,0.6300
    ,0.6300
    ,0.6300
    ,0.6300
    ,0.5750
    ,0.5200
    ,0.5200
    ,0.8705
  };
  */
  double CXYD[4][18]={
     0.8735,0.5204,0.5190,0.5722,0.6241,0.6244,0.6290,0.6314,0.5624
    ,0.5624,0.6314,0.6290,0.6244,0.6241,0.5722,0.5190,0.5204,0.8735
    ,0.8735,0.5204,0.5190,0.5722,0.6241,0.6244,0.6290,0.6314,0.5624
    ,0.5624,0.6314,0.6290,0.6244,0.6241,0.5722,0.5190,0.5204,0.8735
    ,0.8745,0.5210,0.5196,0.5728,0.6248,0.6251,0.6297,0.6321,0.5630
    ,0.5630,0.6321,0.6297,0.6251,0.6248,0.5728,0.5196,0.5210,0.8745
    ,0.8749,0.5212,0.5198,0.5731,0.6250,0.6254,0.6300,0.6323,0.5632
    ,0.5632,0.6323,0.6300,0.6254,0.6250,0.5731,0.5198,0.5212,0.8749
  };
  double CXB[18]={
        1.4295, 0.7030, 0.4887, 0.2633,-0.0861,-0.4073,-0.5609,-0.6091,-0.5629
      ,-0.5629,-0.6091,-0.5609,-0.4073,-0.0861, 0.2633, 0.4887, 0.7030, 1.4295
  };
  double CXS[14]={
        0.0178, 0.0604, 0.0970, 0.1169,-0.1133,-0.0771,-0.0262
      ,-0.0262,-0.0771,-0.1133, 0.1169, 0.0970, 0.0604, 0.0178
  };
  double CXD[4]={-10.28,-5.63,-2.21,9.91};
  double CXV[2]={-386.5,-386.5};
  double CXIMK2=-0.3;
  double CZB[18]={
        0.5268, 0.5635, 0.7801, 1.0537, 1.3200, 1.2570, 0.9421, 0.5519, 0.1388
      ,-0.1388,-0.5519,-0.9421,-1.2570,-1.3200,-1.0537,-0.7801,-0.5635,-0.5268
  };
  double CZS[14]={
        0.0644, 0.0537, 0.0338, 0.0025,-0.0465,-0.0890,-0.1028
      ,-0.1028,-0.0890,-0.0465, 0.0025, 0.0338, 0.0537, 0.0644
  };
  double CZD[4]={-24.2,-26.6,-29.7,-33.9};
  double CZV[2]={533.7,-533.7};
  double CZIMK2=-2.;

  double CD[4]={15.60,14.30,15.80,21.80};
  double RVL[2]={0.00140,0.00140};
  MFPROBE *lP;
  
  iShot=atoi(ShotNm);
  if(iShot > 59441){
    CXIMK2=0.;
    CZIMK2=0.;
  }

  lF0	=fopen(ShotNm,"w");
  sprintf(FNm1,"%sZ",ShotNm);
  lF1	=fopen(FNm1,"w");
  sprintf(FNm2,"%sJ",ShotNm);
  lF2	=fopen(FNm2,"w");
  sprintf(FNm,"%sz",ShotNm);
  lF	=fopen(FNm,"w");

  if(nMFV == 0) return(0);
  kG	=nGrI;
  while(kG < nDGr && DGr[kG].kt != 9) kG++;
  if(kG == nDGr) return(1);

  j	=DGr[0].i;
  j1	=DGr[0].i1;
  while(j < j1){
    PFtWF=DGr[0].T[j];
    PFSetTimeRange(nDGr-1);
    TimeSliceOfAll();
    Xpm	=MFV[0].S0/PFC[0].I0;
    Zpm	=MFV[1].S0/PFC[0].I0;

    IMK2	=1.2*MFV[2].S0*1e-6;
    IRing[0]	=MFV[3].S0*1e-6/RVL[0];
    IRing[1]	=MFV[4].S0*1e-6/RVL[1];

    for(k=0; k < 4; k++){
      CXY	=CXYD[k];
      i0	=k*18;
      lP	=MFp+i0;
      i0	+=nMFLS;
      I[k]=0.;
      II[k]=0.;
      X[k]=0.;
      Z[k]=0.;
      for(i=0,lP=MFp+k*18; i < 18; i++,lP++){
	s	=crgm0*CXY[i]*lP->S0;
	I[k]	+=s;
	II[k]	+=s;
	Z[k]	+=s*lP->Z;
	X[k]	+=s*lP->R*lP->R;
	for(kk=0,ii=6; kk < 4; kk++,ii++){
	  s	=crgm0*CXY[i]*gYiC[i0+i][ii]*CD[i]*PFC[ii].I0/PFC[ii].tn;
	  Z[k]	-=s*lP->Z;
	  X[k]	-=s*lP->R*lP->R;
	  II[k]	-=s;
	}

	for(kk=0; kk < 2; kk++){
	  s	=crgm0*CXY[i]*gYiS[i0+i][kk]*IRing[kk];
	  Z[k]	-=s*lP->Z;
	  X[k]	-=s*lP->R*lP->R;
	  II[k]	-=s;
	}
	kk	=2;
	s	=crgm0*CXY[i]*gYiS[i0+i][kk]*IMK2;
	Z[k]	-=s*lP->Z;
	X[k]	-=s*lP->R*lP->R;
	II[k]	-=s;
      }
      Z[k]	/=II[k];
      X[k]	=0.5*(X[k]/(II[k]*ESRext)-ESRext);
      s	=0.;
      for(i=0; i < 4; i++){
	s	+=CD[i]*PFC[6+i].I0;
      }
      s	+=IMK2;
      I[k]	-=s+IRing[0]+IRing[1];
      if(fabs(Z[k]) > 9.9) Z[k]=9.9*Z[k]/fabs(Z[k]);
      if(fabs(X[k]) > 9.9) X[k]=9.9*X[k]/fabs(X[k]);
    }

    for(k=0; k < 4; k++){
      i0	=k*18;
      lP	=MFp+i0;
      i0	+=nMFLS;
      XJ[k]	=0.;
      ZJ[k]	=0.;
      for(i=0,lP=MFp+k*18; i < 18; i++,lP++){
	s	=lP->S0;
	ZJ[k]	+=CZB[i]*s;
	XJ[k]	+=CXB[i]*s;
      }
      for(i=0,lP=MFS+k*14; i < 14; i++,lP++){
	s	=lP->S0;
	ZJ[k]	+=CZS[i]*s;
	XJ[k]	+=CXS[i]*s;
      }
      for(i=0,ii=6; i < 4; i++,ii++){
	s	=PFC[ii].I0;
	ZJ[k]	+=CZD[i]*s;
	XJ[k]	+=CXD[i]*s;
      }
      ZJ[k]	+=(CZV[0]*MFV[3].S0+CZV[1]*MFV[4].S0)*1e-6;
      XJ[k]	+=(CXV[0]*MFV[3].S0+CXV[1]*MFV[4].S0)*1e-6;

#ifdef H
      ZJ[k]	+=CZIMK2*MFV[2].S0*1e-6;
      XJ[k]	+=CXIMK2*MFV[2].S0*1e-6;
#endif
      ZJ[k]	/=PFC[0].I0;
      XJ[k]	/=PFC[0].I0;
      if(fabs(ZJ[k]) > 9.9) ZJ[k]=9.9*ZJ[k]/fabs(ZJ[k]);
      if(fabs(XJ[k]) > 9.9) XJ[k]=9.9*XJ[k]/fabs(XJ[k]);
    }

    a	=2.-Z[3];
    sI	=a*(Z[3]-Z[1])*ESBt/(0.2*cgp*ESRext);
#ifdef H
    q	=s*s*ESBt/(ESRext*0.2*PFC[0].I0);
#endif

    fprintf(lF0,"%8.4f %7.4f %7.4f %7.4f %7.4f %7.4f %7.4f %7.4f %7.4f %7.4f\n"
	    ,PFtWF,PFC[0].I0,I[0],I[1],I[2],I[3],II[0],II[1],II[2],II[3]);
    fprintf(lF1,"%8.4f %7.4f %7.4f %7.4f %7.4f %7.4f"
	    " %7.4f %7.4f %7.4f %7.4f %7.4f\n"
	    ,PFtWF,Zpm,Z[0],Z[1],Z[2],Z[3],Xpm,X[0],X[1],X[2],X[3]);
    fprintf(lF2,"%8.4f %7.4f %7.4f %7.4f %7.4f %7.4f"
	    " %7.4f %7.4f %7.4f %7.4f %7.4f\n"
	    ,PFtWF,Zpm,ZJ[0],ZJ[1],ZJ[2],ZJ[3],Xpm,XJ[0],XJ[1],XJ[2],XJ[3]);
    fprintf(lF,"%8.4f %10.3e %10.3e %10.3e %7.4f %7.4f %7.4f %7.4f\n"
	    ,PFtWF,I[2]-I[0],I[3]-I[1],sI,Z[2]-Z[0],Z[3]-Z[1]
	    ,X[2]-X[0],X[3]-X[1]);
    j++;
  }
  fprintf(lF0,"%8s %7s %7s %7s %7s %7s %7s %7s %7s %7s %7s\n"
	  ,"t","Ipl","I1","I3","I5","I7","Ipl","II1","II3","II5","II7");
  fprintf(lF2,"%8s %7s %7s %7s %7s %7s %7s %7s %7s %7s %7s\n"
	  ,"t","Zpm","ZJ1","ZJ3","ZJ5","ZJ7","Xpm","XJ1","XJ3","XJ5","XJ7");
  fprintf(lF1,"%8s %7s %7s %7s %7s %7s %7s %7s %7s %7s %7s\n"
	  ,"t","Zpm","Z1","Z3","Z5","Z7","Xpm","X1","X3","X5","X7");
  fprintf(lF,"%8s %10s %10s %10s %7s %7s %7s %7s\n"
	  ,"t","I5-I1","I7-I3","Isurf","Z5-Z1","Z7-Z3","X5-X1","X7-X3");

  ESRBt		=0.2*PFC[nPFC].I0*PFC[nPFC].tn;
  ESBt		=ESRBt/ESRext;
  fprintf(lF0,"Btor=%6.4f Rext=%5.3f\n",ESBt,ESRext);
  fclose(lF);
  fclose(lF2);
  fclose(lF1);
  fclose(lF0);
  out("???? <s> <s> <s> <s> s",ShotNm,FNm1,FNm2,FNm,"have been written");
  return(0);
}

int SnapShot()
{	
  static int Nxt=0;
  int nS,Fl=0,kG=0,iG;
  int i,i1,i2,j,j1,k,k0,k1,n,m;
  char Nm[nRaw][0x10];
  int kc[nRaw];
  char *Img;
  double Y[4]={0.,0.,0.,0.},*ld,a,b,s;
  RAWDATA *lR,*lS;

  if(RawI == NULL || RawI[0].n == 0) return(1);
#ifdef SHMEM
  {
    extern int ESShMem;
    extern double *ESShMemT;
    if(ESShMem) PFtWF=*ESShMemT;
  }
#endif

#ifndef Tbl_SnapShot

#ifdef H
#ifndef AscIISnapShot
#undef AscISnapShot
#endif/*AscISnapShot*/
#endif
  switch(Nxt){
  case 0:
    break;
  case 1:
    i	=DGr[0].i+1;
    if(i >= DGr[0].i1) i=DGr[0].i1-1;
    PFtWF=DGr[0].T[i];
    break;
  case 2:
    i	=DGr[0].i-1;
    if(i < DGr[0].i1) i=DGr[0].i1;
    PFtWF=DGr[0].T[i];
    break;
  case 3:
    AsymData();
    break;
  }

  PFSetTimeRange(nDGr-1);
  TimeSliceOfAll();

  for(i=0,lR=RawV; i < nVVC; i++,lR++){
    if(lR->kG < 0){
      VVC[i].I0	=0.;
      VVC[i].dI	=PFC[0].dI;
      VVC[i].I	=0.;
    }
  }
  if(kG < nDGr){
    while((DGr[kG].k == 0 || DGr[kG].n == 0) && kG < nDGr) kG++;
    if(kG == nDGr) kG	=0;
    kG0	=kG;
    k0	=DGr[kG].k0;
    k1	=DGr[kG].k1;

    Img	=IMg[kG];
    k	=strlen(Img);
    for(j=k0; j < k1; j++) if(strncmp(RawS[j].Nm,Img,k) == 0) break;
    if(j == k1){
      *Img='\0';
      k	=0;
    }
    nkS	=0;
    for(j=k0,lS=RawS+k0; j < k1; j++,lS++){
      if(strncmp(Img,lS->Nm,k) == 0){
	strcpy(Nm[nkS],lS->Nm);
	kS[nkS]	=j;
	nkS++;
      }
    }	
    i1	=DGr[kG].i0;
    i2	=DGr[kG].i1;
    n	=i2-i1;
    Y[0]=0.;
    Y[2]=0.;
    for(j=0; j < nkS; j++){
      lS=RawS+kS[j];
      lR=Raw+lS->kS;
      if(lS->kA == 0) lS->c=0;
      lR->c=lS->c;
      if(lS->c){
	ld	=lS->D+i1;
	for(i=i1; i< i2; i++){
	  if(Y[0] > *ld) Y[0]=*ld;
	  if(Y[2] < *ld) Y[2]=*ld;
	  ld++;
	}
      }
      if(Fl && lS->c){
	lS->I1	=n;
	lS->ti	=lS->T+i1;
	lR->I1	=n;
	lR->ti	=lS->ti;
	ISignal2Splines(lS->V0,lS->V2,lS->D+i1,lS->ti,n,gaI[kG]);
      }
    }
    Y[1]=(Y[0]<0. && Y[2]< 0.) || (Y[0]> 0. && Y[2]>0.) ? cr2*(Y[0]+Y[2]) : 0.;
    PlotTimeSlice(kG);
    switch(Fl){
    case 0:
      CbUserPlot	=PlotWForm;
      break;
    case 1:
      CbUserPlot	=PlotSplinedWForm;
      break;
    case 2:
      CbUserPlot	=PlotSplinedAndRawWForm;
      break;
    default:
      CbUserPlot	=PlotWForm;
      break;
    }
  }
  else{
    int ii;
    RAWDATA *lP;

    iG	=kG-nDGr;
    while((PGr[iG].k == 0 || PGr[iG].n == 0) && iG < nPGr) iG++;
    if(iG == nPGr) iG=0;
    kG	=nDGr+iG;
    kG0	=kG;
    k0	=PGr[iG].k0;
    k1	=PGr[iG].k1;

    Img	=IMg[kG];
    *Img=0;
    n	=0;
    if(PGr[iG].n){
      i1	=PGr[iG].i0;
      i2	=PGr[iG].i1;
      n	=i2-i1;
      Y[0]= 1e+20;
      Y[2]=-1e+20;
      lP	=RawP+k0;
      for(j=k0,lP=RawP+k0; j < k1; j++,lP++){
	if(lP->kA == 0) lP->c=0;
	if(lP->c) break;
      }
      if(j == k1){
	for(j=k0,lP=RawP+k0; j < k1; j++,lP++){
	  if(lP->kA){
	    lP->c=1;
	    break;
	  }
	}
      }
      ld	=lP->D+i1*lP->m;
      for(i=i1; i < i2; i++){
	ii	=lP->m;
	while(ii){
	  ii--;
	  if(Y[0] > *ld) Y[0]=*ld;
	  if(Y[2] < *ld) Y[2]=*ld;
	  ld++;
	}
      }
      PTimeSlicePL(lP,iG,1);
      Y[1]=(Y[0]<0. && Y[2]< 0.) || (Y[0]> 0. && Y[2]>0.)? cr2*(Y[0]+Y[2]) : 0.;
      lP0	=lP;
      CbUserPlot	=WFormPPL;
    }
  }
  ESRBt		=0.2*PFC[nPFC].I0*PFC[nPFC].tn;
  i	=nPFC;
  if(ESRBt < 0.){
    extern char ESMessage[];
    ESRBt=-ESRBt;
    CbStr2UserMessage("Negative Btor. Sign changed\n");
  }
  ESTime	=Raw[0].T[Raw[0].i];
  ESBt		=ESRBt/ESRext;
  ESIpl		=PFC[0].I0;
#endif/*Tbl_SnapShot*/
#ifdef H
#ifndef AscOSnapShot
#undef AscOSnapShot
#endif/*AscOSnapShot*/
#endif

  for(j=0,lS=RawS; j < nRawS; j++,lS++){
    if(lS->kA == 0) lS->c=0;
    lR	=Raw+lS->kS;
    lR->c=lS->c;
  }
  return(0);
}

static int SignFl=0;
int PFEfitBoundPlot()
{
  if((ExpDataFl&0x02)){
    ZColor(14);
    ZPlotPolyLine(rEft,zEft,nEft);
  }
  return(0);
}

void MFSignalPlot()
{
  int i,j;
  char ln[16];
  extern double PSfh;
  double fh=PSfh,r1,r2,z1,z2;
  PFBLOCK *lB;

  PSfh	=7.;
  ZColor(0);
  lB	=PFB;
  strcpy(ln,"Ip=");
  numstr(lB->AI,ln+3,6);
  i	=CbStrCpy(ln+3,ln+3);
  ZPlotLUString(lB->R,lB->Z,ln,i+3);
  for(j=1; j < nPFB; j++){
    lB	=PFB+j;
    r1	=lB->R-lB->dR;
    r2	=lB->R+lB->dR;
    z1	=lB->Z-lB->dZ;
    z2	=lB->Z+lB->dZ;
    i	=strncmp(lB->Nm,"OH",2) == 0 ? 14 : 4;
    ZPlotRect(r1,z1,r2,z2,i);
    strcpy(ln,"I=");
    numstr(lB->AI,ln+2,6);
    i	=CbStrCpy(ln+2,ln+2);
    ZPlotLUString(r2+0.01,z1,ln,i+2);
  }
  MFPPlot();
  ZColor(0);
  ZPlotPolyLine(ESRLm,ESZLm,ESnLm);
  PFEfitBoundPlot();
  if(MSEFl){
    MSEDiagnosticPlot();
  }
  PSfh	=fh;
}

int PFSaveExpData(FILE *lF)
{
  int i,n;

  fprintf(lF,"Rext=%7.4f Btor=%9.6f\n",ESRext,ESBt);
  if(FlAmpTn){
    fprintf(lF,"! PFCoil Ampere-Turn Currents\n");
  }
  else{
    fprintf(lF,"! PFCoil One-Turn Currents\n");
  }
  fprintf(lF,"%3d\n",nPFC);
  if(FlAmpTn){
    for(i=0; i < nPFC; i++){
      fprintf(lF,"%3d %13.6e %13.6e\n",i,PFC[i].I0*PFC[i].tn
	      ,PFC[i].dI*PFC[i].tn);
    }
  }
  else{
    for(i=0; i < nPFC; i++){
      fprintf(lF,"%3d %13.6e %13.6e %8s\n",i,PFC[i].I0,PFC[i].dI,PFC[i].Nm);
    }
  }
  fprintf(lF,"%3s %13s %13s\n","#","I PFC","Error bars");

  fprintf(lF,"! Screen Currents\n");
  fprintf(lF,"%3d\n",nVVC);
  for(i=0; i < nVVC; i++){
    fprintf(lF,"%3d %13.6e %13.6e %8s\n",i,VVC[i].I0,VVC[i].dI,VVC[i].Nm);
  }
  fprintf(lF,"%3s %13s %13s\n","#","I PSC","Error bars");
  
  fprintf(lF,"! Loop signals\n");
  n	=0;
  for(i=0; i < nMFL; i++){
    if(MFL[i].kA){
      n++;
    }
  }
  fprintf(lF,"%3d\n",n);
  n	=0;
  for(i=0; i < nMFL; i++){
    if(MFL[i].kA){
      fprintf(lF,"%3d %13.6e %13.6e %8s\n",i,MFL[i].S0,MFL[i].dS,MFL[i].Nm);
      n++;
    }
  }
  fprintf(lF,"%3s %13s %13s\n","#","Loop Signal","Error bars");

  fprintf(lF,"! Saddle signals\n");
  n	=0;
  for(i=0; i < nMFS; i++){
    if(MFS[i].kA){
      n++;
    }
  }
  fprintf(lF,"%3d\n",n);
  n	=0;
  for(i=0; i < nMFS; i++){
    if(MFS[i].kA){
      fprintf(lF,"%3d %13.6e %13.6e %8s\n",i,MFS[i].S0,MFS[i].dS,MFS[i].Nm);
      n++;
    }
  }
  fprintf(lF,"%3s %13s %13s\n","#","Saddle Signal","Error bars");

  fprintf(lF,"! Probe signals\n");
  n	=0;
  for(i=0; i < nMFp; i++){
    if(MFp[i].kA){
      n++;
    }
  }
  fprintf(lF,"%3d\n",n);
  n	=0;
  for(i=0; i < nMFp; i++){
    if(MFp[i].kA){
      fprintf(lF,"%3d %13.6e %13.6e %8s\n",i,MFp[i].S0,MFp[i].dS,MFp[i].Nm);
      n++;
    }
  }
  fprintf(lF,"%3s %13s %13s\n","#","Probe Signal","Error bars");

  if(MSEFl == 0 || nMSE == 0) return(0);
  fprintf(lF,"! MSE signals\n");
  fprintf(lF,"%3d\n",nMSE);
  for(i=0; i < nMSE; i++){
    fprintf(lF,"%3d %7.4f %8.4f %12.5e %12.5e %9.2e %3d\n",i
	    ,MSE[i].r,MSE[i].z,MSE[i].S0,MSE[i].dS,MSE[i].w,MSE[i].kA&0x03);
  }
  fprintf(lF,"%3s %7s %8s %12s %12s %9s %3s\n"
	  ,"#","R","Z","tan(gg)","Error bars","Weight","Act");
  return(0);
}

int MSESetCoeff()
{
  int i;
  int iS,iC;
  double t,*ld;
  double ga,gW,gd,gq,sga,cga,sgW,cgW,sgd,cgd,sgq,cgq,s1,c1;

  if(nMSE == 0) return(0);
  t	=cgp/180.;
  for(i=0; i < nMSE; i++){
    gd	=MSE[i].gd*t;
    gq	=MSE[i].gd*t;
    ga	=MSE[i].gd*t;
    gW	=MSE[i].gd*t;

    sga	=sin(ga);
    cga	=cos(ga);
    sgW	=sin(gW);
    cgW	=cos(gW);
    sgd	=sin(gd);
    cgd	=cos(gd);
    sgq	=sin(gq);
    cgq	=cos(gq);

    ld		=MSE[i].P;
    ld[0]	=-sgW*sgd; /*B_r*/
    ld[1]	=cgd*cos(gW+ga); /*B_z*/
    ld[2]	=-cgW*sgd; /*B_\gf*/
    ld[3]	=cga*cgq*cgd+cgW*sgq*sgd; /*B_r*/
    ld[4]	=sgq*cgd*sin(gW+ga); /*B_z*/
    ld[5]	=sga*cgq*cgd-sgW*sgq*sgd; /*B_\gf*/
  }

#ifdef H
  iC	=0;
  t	=cgp/180.;
  for(i=0; i < nMSE; i++){
    iS	=i;
    ga	=MSEga[iC][iS]*t;
    gW	=MSEgW[iC][iS]*t;
    gd	=MSEgd[iC][iS]*t;
    gq	=MSEgq[iC][iS]*t;
    sga	=sin(ga);
    cga	=cos(ga);
    sgW	=sin(gW);
    cgW	=cos(gW);
    sgd	=sin(gd);
    cgd	=cos(gd);
    sgq	=sin(gq);
    cgq	=cos(gq);
    s1	=sin(gW+ga);
    c1	=cos(gW+ga);
    ld	=MSE[i].P;
    ld[0]	=-sgd*sgW;
    ld[1]	=-cgd*c1;
    ld[2]	=sgd*cgW;
    ld[3]	=sgq*sgd*cgW+cgq*cgd*cga;
    ld[4]	=-sgq*cgd*s1;
    ld[5]	=sgq*sgd*sgW-cgq*cgd*sga;

    ld[0]	=MSEA5[0][i];
    ld[1]	=MSEA1[0][i];
    ld[2]	=MSEA6[0][i];
    ld[3]	=MSEA3[0][i];
    ld[4]	=MSEA4[0][i];
    ld[5]	=MSEA2[0][i];
  }
#endif
  return(0);
}

int PFReadExpData(FILE *lF)
{
  int i,j,k,n;
  double t,S,dS;
  char ch;

  i	=0;
  if(PFIfPatternFound(lF,"Rext=")){
    if(fscanf(lF,"%lg",&ESRext) == 1){
      i++;
    }
  }
  else{
    rewind(lF);
  }
  if(PFIfPatternFound(lF,"Btor=")){
    if(fscanf(lF,"%lg",&ESBt) == 1){
      i++;
    }
  }
  else{
    rewind(lF);
  }
  if(i == 2) ESRBt=ESRext*ESBt;
  i	=PFIfPatternFound(lF,"PFCoil One-Turn Currents");
  if(i){
    FlAmpTn	=0;
  }
  else{
    rewind(lF);
    i	=PFIfPatternFound(lF,"PFCoil Ampere-Turn Currents");
    if(i){
      FlAmpTn	=1;
    }
  }
  if(i){
    if(fscanf(lF,"%d",&n) < 1){
      printf("PFCoil Currents data are missed%c\n",7);
    }
    else{
      for(i=0; i < n; i++){
	if(fscanf(lF,"%d %lg %lg\n",&k,&S,&dS) == 3){
	  if(FlAmpTn){
	    t	=1./PFC[i].tn;
	    PFC[i].I0	=S*t;
	    PFC[i].dI	=fabs(dS)*t;
	  }
	  else{
	    PFC[i].I0	=S;
	    PFC[i].dI	=fabs(dS);
	  }
	  PFC[i].I	=PFC[i].I0;
	  for(j=0; j < PFC[i].nB; j++){
	    k	=PFC[i].kB[j];
	    PFB[k].I	=PFC[i].I0;
	    PFB[k].AI	=PFC[i].I0*PFB[k].tn;
	  }
	}
	else{
	  printf("#%d PFCoil Currents data are missed%c\n",i,7);
	  rewind(lF);
	  break;
	}
      }
    }
  }
  else{
    printf("PFCoil Currents data are missed%c\n",7);
    rewind(lF);
  }
  if(PFIfPatternFound(lF,"Screen Currents")){
    if(fscanf(lF,"%d",&n) < 1){
      printf("Screen Currents data are missed%c\n",7);
    }
    else{
      for(i=0; i < n; i++){
	if(fscanf(lF,"%d %lg %lg\n",&k,&S,&dS) == 3){
	  VVC[i].I0	=S;
	  VVC[i].dI	=fabs(dS);
	}
	else{
	  printf("#%d Screen Currents data are missed%c\n",i,7);
	  rewind(lF);
	  break;
	}
      }
    }
  }
  else{
    printf("Passive Screen Currents data are missed%c\n",7);
    rewind(lF);
  }
  if(PFIfPatternFound(lF,"Loop signals")){
    if(fscanf(lF,"%d",&n) < 1){
      printf("Loop signals data are missed%c\n",7);
    }
    else{
      j	=0;
      for(i=0; i < n; i++){
	if(fscanf(lF,"%d %lg %lg\n",&k,&S,&dS) == 3){
	  while(j < k){
	    MFL[j].S0	=0.;
	    MFL[j].dS	=0.;
	    MFL[j].kA	=0;
	    j++;
	  }
	  MFL[j].S0	=S;
	  MFL[j].dS	=fabs(dS);
	  j++;
	}
	else{
	  printf("#%d Loop signals data are missed%c\n",i,7);
	  rewind(lF);
	  break;
	}
      }
      while(j < nMFL){
	MFL[j].S0	=0.;
	MFL[j].dS	=0.;
	MFL[j].kA	=0;
	j++;
      }
    }
  }
  else{
    rewind(lF);
  }
  if(PFIfPatternFound(lF,"Saddle signals")){
    if(fscanf(lF,"%d",&n) < 1){
      printf("Saddle Loop signals data are missed%c\n",7);
    }
    else{
      j	=0;
      for(i=0; i < n; i++){
	if(fscanf(lF,"%d %lg %lg\n",&k,&S,&dS) == 3){
	  while(j < k){
	    MFS[j].S0	=0.;
	    MFS[j].dS	=0.;
	    MFS[j].kA	=0;
	    j++;
	  }
	  MFS[j].S0	=S;
	  MFS[j].dS	=fabs(dS);
	  j++;
	}
	else{
	  printf("#%d Saddle Loop signals data are missed%c\n",i,7);
	  rewind(lF);
	  break;
	}
      }
      while(j < nMFS){
	MFS[j].S0	=0.;
	MFS[j].dS	=0.;
	MFS[j].kA	=0;
	j++;
      }
    }
  }
  else{
    rewind(lF);
  }
  if(PFIfPatternFound(lF,"Probe signals")){
    if(fscanf(lF,"%d",&n) < 1){
      printf("Probe signals data are missed%c\n",7);
    }
    else{
      j	=0;
      for(i=0; i < n; i++){
	if(fscanf(lF,"%d %lg %lg\n",&k,&S,&dS) == 3){
	  while(j < k){
	    MFp[j].kA	=0;
	    MFp[j].S0	=0.;
	    MFp[j].dS	=0.;
	    j++;
	  }
	  MFp[j].S0	=S;
	  MFp[j].dS	=fabs(dS);
	  j++;
	}
	else{
	  printf("#%d Probe signals data are missed%c\n",i,7);
	}
      }
      while(j < nMFp){
	MFp[j].S0	=0.;
	MFp[j].dS	=0.;
	MFp[j].kA	=0;
	j++;
      }
    }
  }
  else{
    rewind(lF);
  }
  if(MSEFl == 0) return(0);

  if(PFIfPatternFound(lF,"MSE signals")){
    if(fscanf(lF,"%d",&n) < 1){
      printf("MSE data are missed%c\n",7);
    }
    else{
      double s[5];
      nMSE	=n;
      for(i=0; i < n; i++){
	if(fscanf(lF,"%d %lg %lg %lg %lg %lg %d\n"
		  ,&j,s,s+1,s+2,s+3,s+4,&k) == 7){
	  MSE[i].r	=s[0];
	  MSE[i].z	=s[1];
	  MSE[i].S0	=s[2];
	  MSE[i].dS	=fabs(s[3]);
	  MSE[i].w	=s[4];
	  MSE[i].kA	=k;
	}
	else{
	  printf("#%d MSE data are missed%c\n",i,7);
	  rewind(lF);
	  break;
	}
      }
      MSESetCoeff();
    }
  }
  else{
    rewind(lF);
  }
  return(0);
}

int PFExpDataAO(FILE *lF)
{
  int i,n;
  char str[32]="%d %e %e %s";

  fputs("<Btor at Rext>[1](%e %e %e)\n",lF);
  fprintf(lF,"!%8s %9s %7s\n","time","Btor [T]","Rext [m]");
  fprintf(lF,"%9.6f %9.6f %7.4f\n\n",ESTime,ESBt,ESRext);

  fprintf(lF,"<PFCoil One-Turn Currents>[%d](%s)\n",nPFC,str);
  fprintf(lF,"!%2s %13s %13s %8s\n","#","I PFC","Error bars","NmC");
  for(i=0; i < nPFC; i++){
    fprintf(lF,"%3d %13.6e %13.6e %8s\n",i,PFC[i].I0,PFC[i].dI,PFC[i].Nm);
  }
  fprintf(lF,"!%2s %13s %13s %8s\n","#","I PFC","Error bars","NmC");

  fprintf(lF,"\n<Screen Currents>[%d](%s)\n",nVVC,str);
  fprintf(lF,"!%2s %13s %13s %8s\n","#","I PSC","Error bars","NmVVC");
  for(i=0; i < nVVC; i++){
    fprintf(lF,"%3d %13.6e %13.6e %8s\n",i,VVC[i].I0,VVC[i].dI,VVC[i].Nm);
  }

  n	=0;
  for(i=0; i < nMFL; i++){
    if(MFL[i].kA) n++;
  }
  fprintf(lF,"\n<Loop signals>[%d](%s)\n",n,str);
  fprintf(lF,"!%2s %13s %13s %8s\n","#","Loop Signal","Error bars","NmLoop");
  for(i=0; i < nMFL; i++){
    if(MFL[i].kA){
      fprintf(lF,"%3d %13.6e %13.6e %8s\n",i,MFL[i].S0,MFL[i].dS,MFL[i].Nm);
    }
  }
  fprintf(lF,"!%2s %13s %13s %8s\n","#","Loop Signal","Error bars","NmLoop");

  n	=0;
  for(i=0; i < nMFS; i++){
    if(MFS[i].kA) n++;
  }
  fprintf(lF,"\n<Saddle coil signals>[%d](%s)\n",n,str);
  fprintf(lF,"!%2s %13s %13s %8s\n","#","Saddle Signal","Error bars"
	  ,"NmSaddle");
  for(i=0; i < nMFS; i++){
    if(MFS[i].kA){
      fprintf(lF,"%3d %13.6e %13.6e %8s\n",i,MFS[i].S0,MFS[i].dS,MFS[i].Nm);
    }
  }
  fprintf(lF,"!%2s %13s %13s %8s\n","#","Saddle Signal","Error bars"
	  ,"NmSaddle");

  n	=0;
  for(i=0; i < nMFp; i++){
    if(MFp[i].kA) n++;
  }
  fprintf(lF,"\n<B-Probe signals>[%d](%s)\n",n,str);
  fprintf(lF,"!%2s %13s %13s %8s\n","#","B-Probe Signal","Error bars"
	  ,"NmBProbe");
  for(i=0; i < nMFp; i++){
    if(MFp[i].kA){
      fprintf(lF,"%3d %13.6e %13.6e %8s\n",i,MFp[i].S0,MFp[i].dS,MFp[i].Nm);
    }
  }
  fprintf(lF,"!%2s %13s %13s %8s\n","#","B-Probe Signal","Error bars"
	  ,"NmBProbe");
  if(MSEFl == 0 || nMSE == 0) return(0);
  strcpy(str,"%d %e %e %e %d %e %e");
  fprintf(lF,"\n<MSE data>[%d](%s)\n",nMSE,str);
  fprintf(lF,"!%2s %13s %10s %9s %2s %8s %8s\n"
	  ,"#","tan gg","d tan gg","w tan gg","kA","R gg [m]","Z gg [m]");
  for(i=0; i < nMSE; i++){
    fprintf(lF,"%3d %13.6f %10.3f %9.2e %2d %8.4f %8.4f\n",i
	    ,MSE[i].S0,MSE[i].dS,MSE[i].w,MSE[i].kA,MSE[i].r,MSE[i].z);
  }
  fprintf(lF,"!%2s %13s %10s %9s %2s %8s %8s\n"
	  ,"#","tan gg","d tan gg","w tan gg","kA","R gg [m]","Z gg [m]");
  return(0);
}

int PFExpDataAI(FILE *lF)
{
  char *RNm="PFExpDataAI";
  char str[128];
  char ln[32];
  char *lc;
  char *lv[8];
  int dl[8];
  int i,j,k,m,n,L;
  int kk[256];
  double S[256],dS[256];

  n	=0;
  m	=3;
  lc	="<Btor at Rext>";
  if(PFIsKeyWordFound(lF,Mess,lc,str,&n)){
    i	=0;
    lv[i]=(char*)&ESTime;
    i++;
    lv[i]=(char*)&ESBt;
    i++;
    lv[i]=(char*)&ESRext;
    i++;
    dl[0]=0;
    dl[1]=0;
    dl[2]=0;
    if(n == 0){
      sprintf(Mess,"%s:%s n=%d no data\n",RNm,lc,n);
      CbStr2UserMessage(Mess);
      return(1);
    }
    PFReadAI(lF,lc,Mess,str,n,lv,dl,m);
  }
  else{
    sprintf(Mess,"%s:%s not found\n",RNm,lc);
    CbStr2UserMessage(Mess);
    return(1);
  }
  ESRBt=ESRext*ESBt;

  n	=0;
  m	=4;
  lc	="<PFCoil One-Turn Currents>";
  L	=sizeof(PFCOIL);
  if(PFIsKeyWordFound(lF,Mess,lc,str,&n)){
    FlAmpTn	=0;
    i	=0;
    lv[i]=(char*)&i;
    i++;
    lv[i]=(char*)&PFC[0].I0;
    i++;
    lv[i]=(char*)&PFC[0].dI;
    i++;
    lv[i]=ln;
    i++;
    dl[0]=0;
    dl[1]=L;
    dl[2]=L;
    dl[3]=0;
    if(n == 0){
      sprintf(Mess,"%s:%s n=%d no data\n",RNm,lc,n);
      CbStr2UserMessage(Mess);
      return(1);
    }
    PFReadAI(lF,lc,Mess,str,n,lv,dl,m);
  }
  else{
    sprintf(Mess,"%s:%s not found\n",RNm,lc);
    CbStr2UserMessage(Mess);
    return(1);
  }

  for(i=0; i < n; i++){
    PFC[i].I	=PFC[i].I0;
    for(j=0; j < PFC[i].nB; j++){
      k	=PFC[i].kB[j];
      PFB[k].I	=PFC[i].I0;
      PFB[k].AI	=PFC[i].I0*PFB[k].tn;
    }
  }

  n	=0;
  lc	="<Screen Currents>";
  if(PFIsKeyWordFound(lF,Mess,lc,str,&n)){
    i	=0;
    lv[i]=(char*)&i;
    i++;
    lv[i]=(char*)&VVC[0].I0;
    i++;
    lv[i]=(char*)&VVC[0].dI;
    i++;
    lv[i]=ln;
    i++;
    dl[0]=0;
    dl[1]=L;
    dl[2]=L;
    dl[3]=0;
    if(n == 0){
      sprintf(Mess,"%s:%s n=%d no data\n",RNm,lc,n);
      CbStr2UserMessage(Mess);
      return(1);
    }
    PFReadAI(lF,lc,Mess,str,n,lv,dl,m);
  }
  else{
    sprintf(Mess,"%s:%s not found\n",RNm,lc);
    CbStr2UserMessage(Mess);
    return(1);
  }

  n	=0;
  lc	="<Loop signals>";
  L	=sizeof(double);
  if(PFIsKeyWordFound(lF,Mess,lc,str,&n)){
    i	=0;
    lv[i]=(char*)kk;
    i++;
    lv[i]=(char*)S;
    i++;
    lv[i]=(char*)dS;
    i++;
    lv[i]=ln;
    i++;
    dl[0]=sizeof(int);
    dl[1]=L;
    dl[2]=L;
    dl[3]=0;
    if(n == 0){
      sprintf(Mess,"%s:%s n=%d no data\n",RNm,lc,n);
      CbStr2UserMessage(Mess);
      return(1);
    }
    PFReadAI(lF,lc,Mess,str,n,lv,dl,m);
  }
  else{
    sprintf(Mess,"%s:%s not found\n",RNm,lc);
    CbStr2UserMessage(Mess);
    return(1);
  }
  j	=0;
  for(i=0; i < n; i++){
    k	=kk[i];
    while(j < k){
      MFL[j].S0	=0.;
      MFL[j].dS	=0.;
      MFL[j].kA	=0;
      j++;
    }
    MFL[j].S0	=S[i];
    MFL[j].dS	=fabs(dS[i]);
    MFL[j].kA	=1;
    j++;
  }
  while(j < nMFL){
    MFL[j].S0	=0.;
    MFL[j].dS	=0.;
    MFL[j].kA	=0;
    j++;
  }

  n	=0;
  lc	="<Saddle coil signals>";
  if(PFIsKeyWordFound(lF,Mess,lc,str,&n) && n){
    i	=0;
    lv[i]=(char*)kk;
    i++;
    lv[i]=(char*)S;
    i++;
    lv[i]=(char*)dS;
    i++;
    lv[i]=ln;
    i++;
    dl[0]=sizeof(int);
    dl[1]=L;
    dl[2]=L;
    dl[3]=0;
    PFReadAI(lF,lc,Mess,str,n,lv,dl,m);
  }
  else{
    sprintf(Mess,"%s:%s not found\n",RNm,lc);
    CbStr2UserMessage(Mess);
  }

  j	=0;
  for(i=0; i < n; i++){
    k	=kk[i];
    while(j < k){
      MFS[j].S0	=0.;
      MFS[j].dS	=0.;
      MFS[j].kA	=0;
      j++;
    }
    MFS[j].S0	=S[i];
    MFS[j].dS	=fabs(dS[i]);
    MFS[j].kA	=2;
    j++;
  }
  while(j < nMFS){
    MFS[j].S0	=0.;
    MFS[j].dS	=0.;
    MFS[j].kA	=0;
    j++;
  }

  n	=0;
  lc	="<B-Probe signals>";
  if(PFIsKeyWordFound(lF,Mess,lc,str,&n)){
    i	=0;
    lv[i]=(char*)kk;
    i++;
    lv[i]=(char*)S;
    i++;
    lv[i]=(char*)dS;
    i++;
    lv[i]=ln;
    i++;
    dl[0]=sizeof(int);
    dl[1]=L;
    dl[2]=L;
    dl[3]=0;
    if(n == 0){
      sprintf(Mess,"%s:%s n=%d no data\n",RNm,lc,n);
      CbStr2UserMessage(Mess);
      return(1);
    }
    PFReadAI(lF,lc,Mess,str,n,lv,dl,m);
  }
  else{
    sprintf(Mess,"%s:%s not found\n",RNm,lc);
    CbStr2UserMessage(Mess);
    return(1);
  }
  j	=0;
  for(i=0; i < n; i++){
    k	=kk[i];
    while(j < k){
      MFp[j].S0	=0.;
      MFp[j].dS	=0.;
      MFp[j].kA	=0;
      j++;
    }
    MFp[j].S0	=S[i];
    MFp[j].dS	=fabs(dS[i]);
    MFp[j].kA	=3;
    j++;
  }
  while(j < nMFp){
    MFp[j].S0	=0.;
    MFp[j].dS	=0.;
    MFp[j].kA	=0;
    j++;
  }
  if(MSEFl == 0) return(0);

  n	=0;
  m	=7;
  lc	="<MSE data>";
  L	=sizeof(DATAMSE);
  if(PFIsKeyWordFound(lF,Mess,lc,str,&n)){
    nMSE=n;
    i	=0;
    lv[i]=(char*)kk;
    i++;
    lv[i]=(char*)&MSE[0].S0;
    i++;
    lv[i]=(char*)&MSE[0].dS;
    i++;
    lv[i]=(char*)&MSE[0].w;
    i++;
    lv[i]=(char*)&MSE[0].kA;
    i++;
    lv[i]=(char*)&MSE[0].r;
    i++;
    lv[i]=(char*)&MSE[0].z;
    i++;
    dl[0]=0;
    dl[1]=L;
    dl[2]=L;
    dl[3]=L;
    dl[4]=L;
    dl[5]=L;
    dl[6]=L;
    if(n == 0){
      sprintf(Mess,"%s:%s n=%d no data\n",RNm,lc,n);
      CbStr2UserMessage(Mess);
      return(1);
    }
    PFReadAI(lF,lc,Mess,str,n,lv,dl,m);
  }
  else{
    sprintf(Mess,"%s:%s not found\n",RNm,lc);
    CbStr2UserMessage(Mess);
    return(1);
  }
  MSESetCoeff();
  return(0);
}

int MSEtangg()
{
  double dRa,dRp,dZa,dZp;
  double Br,Bz,Bt,rqg;
  double a,t,x,y,a0,t0;
  double tx,ty;
  int i,k;
  double *ld;
  extern double *rcT1a,*ESsb1a;

  for(i=0; i < nMSE; i++){
    a	=2.*rcT1a[ESNa1]/ESsb1a[0];

    y	=(MSE[i].z-ESaZ0[0])/ESsb[3];
    x	=(MSE[i].r-ESaR0[0])/(a*ESsb[3]);

    a	=sqrt(y*y+x*x);	
    if(a > 1.){
      k	=ESNp1*ESNa;
      x	=2.*(MSE[i].r-ESaR0[0])/(ESsr[k]-ESsr[k+ESNp/2]);
      y	=(MSE[i].z-ESaZ0[0])/ESsb[ESNa];
      a	=sqrt(y*y+x*x);	
      t	=asin(y/a);
      a	*=ESsa[ESNa];
      if(a > ESsa[ESNa]) a=ESsa[ESNa]*0.95;
    }
    else{
      t	=asin(y/a);
      a	*=ESsa[3];
    }
    a0	=a;
    t0	=t;
    MSE[i].kA	&=0x03;
    k	=ESGetLabMetrics(&dRa,&dRp,&dZa,&dZp,&a,&t,MSE[i].r,MSE[i].z);
    if(k){
      MSE[i].a	=1.;
      MSE[i].S	=0.;
#ifdef H
      printf("k=%d - failure in MSE geometry at R[%d]=%7.4f %8.4f\n"
	     ,k,i,MSE[i].r,MSE[i].z);
      out("sidddddd","MSE x",i,x,MSE[i].z-ESaZ0[0],a0,t0,ESsa[1],ESsb[1]);
#endif
    }	
    else{
#ifdef H
      out("siidddd","MSE x",i,k,a,t,MSE[i].r,MSE[i].z);
#endif
      MSE[i].kA	|=0x08;
      MSE[i].a	=a;
      MSE[i].gt	=t;
      ESSetSplA(a);
      splRA(&rqg,NULL,ESdgY,ESdgY2a);

      rqg	*=a/(MSE[i].r*(dRa*dZp-dRp*dZa));
      Br	=dRp*rqg;
      Bz	=dZp*rqg;
      splRA(&Bt,NULL,ESFF,ESFF2a);
      Bt	=sqrt(Bt)/MSE[i].r;
      if(iSignBt) Bt=-Bt;
      ld	=MSE[i].P;
      t		=Br*ld[3]+Bz*ld[4]+Bt*ld[5];
      MSE[i].S	=t != 0. ? (Br*ld[0]+Bz*ld[1]+Bt*ld[2])/t : 0.;
      splRA(&Br,&rqg,ESgY,ESgY2a);
      rqg	/=MSE[i].r*(dRa*dZp-dRp*dZa);
      Br	=dRp*rqg;
      Bz	=dZp*rqg;
      t		=Br*ld[3]+Bz*ld[4]+Bt*ld[5];
      MSE[i].S1	=t != 0. ? (Br*ld[0]+Bz*ld[1]+Bt*ld[2])/t : 0.;

#ifdef H
      MSE[i].S0*(Br*ld[3]+Bz*ld[4]+Bt*ld[5])  =Br*ld[0]+Bz*ld[1]+Bt*ld[2];
      Br*(MSE[i].S0*ld[3]-ld[0])+Bz*(MSE[i].S0*ld[4]-ld[1])
	=Bt*(ld[2]-MSE[i].S0*ld[5]);

      tx	=MSE[i].S0*ld[3]-ld[0];
      ty	=MSE[i].S0*ld[4]-ld[1];
      t	=1./sqrt(tx*tx+ty*ty);
      tx	*=t;
      ty	*=t;
      t		*=ld[2]-MSE[i].S0*ld[5];
      out("sidddd","Bz",i,ty,tx,t,MSE[i].r);
#endif
    }
  }
  return(0);
}

int MSEtanggHole()
{
  double dRa,dRp,dZa,dZp;
  double Br,Bz,Bt,rqg,R1,R2;
  double a,t,x,y,a0,t0;
  double tx,ty;
  int i,k;
  double *ld;
  
  for(i=0; i < nMSE; i++){
    k	=ESIsOutsidePlasma(&R1,&R2,MSE[i].r,MSE[i].z);
    if(k == 0){
      x	=2.*(MSE[i].r-ESaR0[0])/(ESsr[0]-ESsr[ESNp/2]);
      y	=(MSE[i].z-ESaZ0[0])/ESsb[0];
      a	=sqrt(y*y+x*x);	
      t =asin(y/a);
      if(MSE[i].r < R1){
	t	=cgp-t;
      }
      a	*=ESa0;
      if(a > ESsa[ESNa]){
	a	=ESsa[ESNa]*0.95;
      }
      if(a < ESa0){
	a	=ESa0*1.05;
      }
#ifdef H
      x	=MSE[i].r-ESaR0[0];
      y	=(MSE[i].z-ESaZ0[0])*ESsa[1]/ESsb[1];
      a	=sqrt(y*y+x*x);	
      if(a > 1.){
	y	=(MSE[i].z-ESaZ0[0])*ESsa[ESNa]/ESsb[ESNa];
	a	=sqrt(y*y+x*x);	
      }
      t	=x > 0. ? asin(y/a) : cgp-asin(y/a);
      if(a > 1.){
	a	=0.95;
      }
#endif
      a0	=a;
      t0	=t;
      MSE[i].kA	&=0x03;
      k	=ESGetLabMetrics(&dRa,&dRp,&dZa,&dZp,&a,&t,MSE[i].r,MSE[i].z);
      if(k){
	MSE[i].a	=1.;
	MSE[i].S	=0.;
      }	
      else{

      out("siidddd","MSE x",i,k,a,t,MSE[i].r,MSE[i].z);

	MSE[i].kA	|=0x08;
	MSE[i].a	=a;
	MSE[i].gt	=t;
	ESSetSplA(a);
	splRA(&rqg,NULL,ESdgY,ESdgY2a);
	rqg	*=a/(MSE[i].r*(dRa*dZp-dRp*dZa));
	Br	=dRp*rqg;
	Bz	=dZp*rqg;
	splRA(&Bt,NULL,ESFF,ESFF2a);
	Bt	=sqrt(Bt)/MSE[i].r;
	if(iSignBt) Bt=-Bt;

	ld	=MSE[i].P;
	t		=Br*ld[3]+Bz*ld[4]+Bt*ld[5];
	MSE[i].S	=t != 0. ? (Br*ld[0]+Bz*ld[1]+Bt*ld[2])/t : 0.;
	splRA(&Br,&rqg,ESgY,ESgY2a);
	rqg	/=MSE[i].r*(dRa*dZp-dRp*dZa);
	Br	=dRp*rqg;
	Bz	=dZp*rqg;
	t		=Br*ld[3]+Bz*ld[4]+Bt*ld[5];
	MSE[i].S1	=t != 0. ? (Br*ld[0]+Bz*ld[1]+Bt*ld[2])/t : 0.;
      }
    }
    else{
      if(k == 1){
	MSE[i].kA	|=0x08;
	MSE[i].a	=0.;
	MSE[i].gt	=0.;

	ESSetSplA(a);
	Br	=0.;
	Bz	=0.;
	Bt	=ESaF[0]/MSE[i].r;
	if(ESRBt < 0.){
	  Bt	=-Bt;
	}
	ld	=MSE[i].P;
	t	=Bt*ld[5];
	MSE[i].S=t != 0. ? Bt*ld[2]/t : 0.;
	Br	=0.;
	Bz	=0.;
	t	=Bt*ld[5];
	MSE[i].S1	=t != 0. ? Bt*ld[2]/t : 0.;
      }
      else{
	MSE[i].a	=1.;
	MSE[i].S	=0.;
      }
    }
  }
  return(0);
}

int MSEPitchAngle()
{
  int i;
  double dRa,dRp,dZa,dZp;
  double Bt,rqg,t,s;
  double *ld;
  for(i=0; i < nMSE; i++){
    if((MSE[i].kA&0x08)){
      ESGetMetrics(&dRa,&dRp,&dZa,&dZp,MSE[i].a,MSE[i].gt);
      ESSetSplA(MSE[i].a);

      splRA(&Bt,NULL,ESFF,ESFF2a);
      Bt	=sqrt(Bt)/MSE[i].r;
      if(iSignBt) Bt=-Bt;
      ld	=MSE[i].P;
      t	=dRp*ld[0]+dZp*ld[1]-MSE[i].S0*(dRp*ld[3]+dZp*ld[4]);
      rqg	=t != 0. ? (MSE[i].S0*ld[5]-ld[2])/t : 0;
      MSE[i].Bz	=dZp*rqg*Bt;

      MSE[i].dgY=rqg*Bt*MSE[i].r*(dRa*dZp-dRp*dZa); /* gY' */
      MSE[i].gi	=rqg*MSE[i].r*(dRa*dZp-dRp*dZa); /* gi */

      s		=MSE[i].S0+MSE[i].dS;
      t		=dRp*ld[0]+dZp*ld[1]-s*(dRp*ld[3]+dZp*ld[4]);
      rqg	=t != 0. ? (s*ld[5]-ld[2])/t : 0;
      MSE[i].dBz=dZp*rqg*Bt;
      s		=MSE[i].S0-MSE[i].dS;
      t		=dRp*ld[0]+dZp*ld[1]-s*(dRp*ld[3]+dZp*ld[4]);
      rqg	=t != 0. ? (s*ld[5]-ld[2])/t : 0;
      MSE[i].dBz	=cr2*fabs(MSE[i].dBz-dZp*rqg*Bt);
#ifdef H
      out("siddsd","MSE",i,MSE[i].S0,MSE[i].S,"Bz=",Bz);
#endif
    }
  }
  return(0);
}

int MSEPitchAngleHole()
{
  int i;
  double dRa,dRp,dZa,dZp;
  double Bt,rqg,t,s;
  double *ld;
  for(i=0; i < nMSE; i++){
    if((MSE[i].kA&0x08)){
      if(MSE[i].a > ESa0){
	ESGetMetrics(&dRa,&dRp,&dZa,&dZp,MSE[i].a,MSE[i].gt);
	ESSetSplA(MSE[i].a);
	splRA(&Bt,NULL,ESFF,ESFF2a);
	Bt	=sqrt(Bt)/MSE[i].r;
	if(iSignBt) Bt=-Bt;

	ld	=MSE[i].P;
	t	=dRp*ld[0]+dZp*ld[1]-MSE[i].S0*(dRp*ld[3]+dZp*ld[4]);
	rqg	=t != 0. ? (MSE[i].S0*ld[5]-ld[2])/t : 0;
	MSE[i].Bz	=dZp*rqg*Bt;
	MSE[i].dgY=rqg*Bt*MSE[i].r*(dRa*dZp-dRp*dZa); /* gY' */
	MSE[i].gi	=rqg*MSE[i].r*(dRa*dZp-dRp*dZa); /* gi */
	
	s		=MSE[i].S0+MSE[i].dS;
	t		=dRp*ld[0]+dZp*ld[1]-s*(dRp*ld[3]+dZp*ld[4]);
	rqg	=t != 0. ? (s*ld[5]-ld[2])/t : 0;
	MSE[i].dBz=dZp*rqg*Bt;
	s		=MSE[i].S0-MSE[i].dS;
	t		=dRp*ld[0]+dZp*ld[1]-s*(dRp*ld[3]+dZp*ld[4]);
	rqg	=t != 0. ? (s*ld[5]-ld[2])/t : 0;
	MSE[i].dBz	=cr2*fabs(MSE[i].dBz-dZp*rqg*Bt);
#ifdef H
	out("siddsd","MSE",i,MSE[i].S0,MSE[i].S,"Bz=",Bz);
#endif
      }
      else{
	Bt	=ESaF[0]/MSE[i].r;
	if(iSignBt) Bt=-Bt;
	ld	=MSE[i].P;
	MSE[i].Bz	=0.;
	MSE[i].dgY	=0.;
	MSE[i].gi	=0.;
	MSE[i].dBz	=0.;
#ifdef H
	out("siddsd","MSE",i,MSE[i].S0,MSE[i].S,"Bz=",Bz);
#endif
      }
    }
  }
  return(0);
}

int MSEPitchAnglePLot(int W)
{
  int i,j;
  double gY,d,Re,x[nMSE],y[nMSE],y1[nMSE];
  double dRa,dRp,dZa,dZp;
  double Bt,rqg;
  double a,t;
  
  Re	=ESsr != NULL ? ESsr[ESNp1*ESNa] : 0.5*(RplG[0]+RplG[1]);

  y[0]	=0.;
  y[1]	=0.;
  j	=0;
  for(i=0; i < nMSE; i++){
    if((MSE[i].kA&0x01)){
      d	=MSE[i].gi;
      if(y[0] > d) y[0]=d;
      if(y[1] < d) y[1]=d;
      a	=MSE[i].a;
      ESGetMetrics(&dRa,&dRp,&dZa,&dZp,a,MSE[i].gt);
      splRA(&gY,&d,ESgY,ESgY2a);
      d		*=dZp/(MSE[i].r*(dRa*dZp-dRp*dZa));
#ifdef H
#endif
      y1[j++]	=d;
      if(y[0] > d) y[0]=d;
      if(y[1] < d) y[1]=d;
    }
  }
  i	=nMSE-1;
  x[0]	=MSE[0].r < MSE[i].r ? MSE[0].r : MSE[i].r;
  x[1]	=MSE[0].r < MSE[i].r ? MSE[i].r : MSE[0].r;
  if(x[1] < Re) x[1]=Re;
#ifdef H
  x[0]	=0.;
  x[1]	=1.;
#endif

  SetPlotName("R","gY'","MSE Data");
  Scale2d(W,x,y,2,6,2);
  y[2]	=0.;
  y[3]	=0.;
  x[2]	=ESaR0[0];
  x[3]	=ESaR0[0];
  x[4]	=Re;
  x[5]	=Re;
  Plot2d(W,x,y+2,2,6,0,9,0);
  Plot2d(W,x+2,y,2,6,0,9,0);
  Plot2d(W,x+4,y,2,6,0,9,0);
  j	=0;
  for(i=0; i < nMSE; i++){
    if((MSE[i].kA&0x01)){
      y[j]	=MSE[i].gi;
      x[j++]	=MSE[i].r;
    }
  }
  Plot2d(W,x,y,j,6,0x08,0,0);
  Plot2d(W,x,y1,j,6,0x08,4,0);
  return(0);
}

int MSEDataPlot(int W,int Fl,char *str)
{
  int i,j;
  double d,Re,x[64],y[64],y1[64];
  char ln[32];

  if(nMSE == 0) return(0);
  if(Fl == 2) PSFileOpen(1,1);

  Re	=ESsr[ESNp1*ESNa];

  y[0]	=0.;
  y[1]	=-y[0];
  for(i=0; i < nMSE; i++){
    if((MSE[i].kA&0x03)){
      d	=MSE[i].S0-MSE[i].dS;
      if(y[0] > d) y[0]=d;
      d	=MSE[i].S0+MSE[i].dS;
      if(y[1] < d) y[1]=d;
      if(y[0] > MSE[i].S) y[0]=MSE[i].S;
      if(y[1] < MSE[i].S) y[1]=MSE[i].S;
    }
  }
  i	=nMSE-1;
  x[0]	=MSE[0].r < MSE[i].r ? MSE[0].r : MSE[i].r;
  x[1]	=MSE[0].r < MSE[i].r ? MSE[i].r : MSE[0].r;
  y[2]	=0.;
  y[3]	=0.;
  x[2]	=ESaR0[0];
  x[3]	=x[2];
  x[4]	=Re;
  x[5]	=Re;
  x[6]	=ESsr[ESNp1*ESNa];
  x[7]	=x[6];
  x[8]	=ESsr[ESNp1*ESNa+ESNp/2];
  x[8]	=cr2*(x[8]+x[2]);
  x[9]	=x[8];

  if(x[0] > x[8]) x[0]=x[8];
  if(x[1] < Re) x[1]=Re;

  sprintf(ln,"%s MSE Data",str);
  SetPlotName("R","tan(gg)",ln);
  Scale2d(W,x,y,2,6,2);

  Plot2d(W,x,y+2,2,6,0,9,0);
  Plot2d(W,x+2,y,2,6,0,9,0);
  Plot2d(W,x+4,y,2,6,0,9,0);
  Plot2d(W,x+6,y,2,6,0,14,0);
  Plot2d(W,x+8,y,2,6,0,14,0);
  if(Fl){
    PSNewFrame();
    PSPlot2d(x,y+2,2,6,0,9,0);
    PSPlot2d(x+2,y,2,6,0,9,0);
    PSPlot2d(x+4,y,2,6,0,9,0);
    PSPlot2d(x+6,y,2,6,0,14,0);
    PSPlot2d(x+8,y,2,6,0,14,0);
  }

  j	=0;
  for(i=0; i < nMSE; i++){
    if((MSE[i].kA&0x01)){
      y[j]	=MSE[i].S0+MSE[i].dS;
      x[j++]	=MSE[i].r;
    }
  }
  Plot2d(W,x,y,j,6,0x0110,0,0);
  if(Fl) PSPlot2d(x,y,j,6,0x0110,0,0);
  j	=0;
  for(i=0; i < nMSE; i++){
    if((MSE[i].kA&0x01)) y[j++]=MSE[i].S0-MSE[i].dS;
  }
  Plot2d(W,x,y,j,6,0x110,0,0);
  if(Fl) PSPlot2d(x,y,j,6,0x110,0,0);

  j	=0;
  for(i=0; i < nMSE; i++){
    if((MSE[i].kA&0x03) == 2){
      y[j]	=MSE[i].S0+MSE[i].dS;
      x[j++]	=MSE[i].r;
    }
  }
  Plot2d(W,x,y,j,6,0x0110,4,0);
  if(Fl) PSPlot2d(x,y,j,6,0x0110,4,0);
  j	=0;
  for(i=0; i < nMSE; i++){
    if((MSE[i].kA&0x03) == 2) y[j++]=MSE[i].S0-MSE[i].dS;
  }
  Plot2d(W,x,y,j,6,0x110,4,0);
  if(Fl) PSPlot2d(x,y,j,6,0x110,4,0);

  j	=0;
  for(i=0; i < nMSE; i++){
    if((MSE[i].kA&0x03) == 0){
      y[j]	=MSE[i].S0+MSE[i].dS;
      x[j++]	=MSE[i].r;
    }
  }
  Plot2d(W,x,y,j,6,0x0110,14,0);
  if(Fl) PSPlot2d(x,y,j,6,0x0110,14,0);
  j	=0;
  for(i=0; i < nMSE; i++){
    if((MSE[i].kA&0x03) == 0) y[j++]=MSE[i].S0-MSE[i].dS;
  }
  Plot2d(W,x,y,j,6,0x110,14,0);
  if(Fl) PSPlot2d(x,y,j,6,0x110,14,0);

  for(i=0; i < nMSE; i++){
    y[i]	=MSE[i].S0;
    x[i]	=MSE[i].r;
  }
  Plot2d(W,x,y,nMSE,6,0x08,0,0);
  if(Fl) PSPlot2d(x,y,nMSE,6,0x08,0,0);
  if((ExpDataFl&0x01)){
    j	=0;
    for(i=0; i < nMSE; i++){
      if((MSE[i].kA&0x08)){
	y[j]	=MSE[i].Se;
	x[j++]	=MSE[i].r;
      }
    }
    Plot2d(W,x,y,j,6,0x08,14,0);
    if(Fl) PSPlot2d(x,y,j,6,0x08,14,0);
  }

  j	=0;
  for(i=0; i < nMSE; i++){
    if((MSE[i].kA&0x08)){
      y[j]	=MSE[i].S;
      y1[j]	=MSE[i].S1;
      x[j++]	=MSE[i].r;
    }
  }
#ifdef H
  Plot2d(W,x,y,j,6,0x08,4,0);
#endif
  Plot2d(W,x,y1,j,6,0x09,14,0);
  if(Fl){
#ifdef H
    PSPlot2d(x,y,j,6,0x08,4,0);
#endif
    PSPlot2d(x,y1,j,6,0x09,14,0);
  }

  if(Fl == 2) PSFileClose();
  return(0);
}

int PFGetW(double *W,double *WI,double *WV,double *WL,double *WB)
{
  int i;
  double s,wI,wV,wL,wB;
  
  wI	=0.;
  wV	=0.;
  wL	=0.;
  wB	=0.;
  for(i=1; i < nPFC; i++){
    if(PFC[i].kA){
      s		=PFC[i].I0-PFC[i].I;
      if(PFC[i].dI != 0.) s /=PFC[i].dI;
      wI	+=s*s;
    }
  }
  for(i=0; i < nVVC; i++){
    if(VVC[i].kA){
      s		=VVC[i].I0-VVC[i].I;
      if(VVC[i].dI != 0.) s/=VVC[i].dI;
      wV	+=s*s;
    }
  }
  for(i=0; i < nMFLS; i++){
    if(MFL[i].kA){
      s		=MFL[i].S0-MFL[i].S;
      if(MFL[i].dS != 0.) s /=MFL[i].dS;
      wL	+=s*s;
    }
  }
  for(i=0; i < nMFp; i++){
    if(MFp[i].kA){
      s		=MFp[i].S0-MFp[i].S;
      if(MFp[i].dS != 0.) s/=MFp[i].dS;
      wB	+=s*s;
    }
  }
  *WI	=wI;
  *WV	=wV;
  *WL	=wL;
  *WB	=wB;
  *W	=wI+wV+wL+wB;
  return(0);
}

int PFExpDataComparisonStore()
{
  int i,j;
  static char FNm[16];
  static int kF=0;
  FILE *lF;

  lF	=NULL;
  if(*ShotNm != '\0'){
    sprintf(FNm,"%s.out",ShotNm);
  }
  else{
    sprintf(FNm,"ESCFit.out");
  }
  lF	=fopen(FNm,kF ? "a" : "w");
  kF++;

  /* Coils */
  fprintf(lF,"%2d --- Coil currents:\n",kF);
  fprintf(lF,"%3s %11s %11s %9s %9s %6s %6s\n"
	  ,"  #","I calc","I exper","Error","Err bar","R","Z");
  for(i=0; i < nPFC; i++){
    if(PFC[i].kA){
      j	=PFC[i].kB[0];
      if(fabs(PFC[i].I-PFC[i].I0) <= PFC[i].dI){ 
	fprintf(lF,"%3d %11.4e %11.4e %9.2e %9.2e %6.3f %6.3f\n"
		,i,PFC[i].I,PFC[i].I0,PFC[i].I-PFC[i].I0,PFC[i].dI
		,PFB[j].R,PFB[j].Z);
      }
      else{
	fprintf(lF,"%3d %11.4e %11.4e %9.2e %9.2e %6.3f %6.3f *\n"
		,i,PFC[i].I,PFC[i].I0,PFC[i].I-PFC[i].I0,PFC[i].dI
		,PFB[j].R,PFB[j].Z);
      }
    }
  }

  /* Screens */
  if(nVVC){
    fprintf(lF,"%2d --- Screen currents:\n",kF);
    fprintf(lF,"%3s %11s %11s %9s %9s %6s %6s\n"
	    ,"  #","I calc","I exper","Error","Err bar","R","Z");
    for(i=0; i < nVVC; i++){
      if(VVC[i].kA){
	j	=VVC[i].kB[0];
	if(fabs(VVC[i].I-VVC[i].I0) <= VVC[i].dI){ 
	  fprintf(lF,"%3d %11.4e %11.4e %9.2e %9.2e %6.3f %6.3f\n"
		  ,i,VVC[i].I,VVC[i].I0,VVC[i].I-VVC[i].I0,VVC[i].dI
		  ,VVB[j].R,VVB[j].Z);
	}
	else{
	  fprintf(lF,"%3d %11.4e %11.4e %9.2e %9.2e %6.3f %6.3f *\n"
		  ,i,VVC[i].I,VVC[i].I0,VVC[i].I-VVC[i].I0,VVC[i].dI
		  ,VVB[j].R,VVB[j].Z);
	}
      }
    }
  }
  /* Loops */
  if(nMFL){
    fprintf(lF,"%2d --- Flux loop signals:\n",kF);
    fprintf(lF,"%3s %11s %11s %9s %9s %6s %6s\n"
	    ,"  #","S calc","S exper","Error","Err bar","R","Z");
    for(i=0; i < nMFL; i++){
      if(MFL[i].kA){
	if(fabs(MFL[i].S-MFL[i].S0) <= MFL[i].dS){ 
	  fprintf(lF,"%3d %11.4e %11.4e %9.2e %9.2e %6.3f %6.3f\n"
		  ,i,MFL[i].S,MFL[i].S0,MFL[i].S-MFL[i].S0,MFL[i].dS
		  ,MFL[i].R,MFL[i].Z);
	}
	else{
	  fprintf(lF,"%3d %11.4e %11.4e %9.2e %9.2e %6.3f %6.3f *\n"
		  ,i,MFL[i].S,MFL[i].S0,MFL[i].S-MFL[i].S0,MFL[i].dS
		  ,MFL[i].R,MFL[i].Z);
	}
      }
    }
  }

  if(nMFS){
    fprintf(lF,"%2d --- Saddle coil signals:\n",kF);
    fprintf(lF,"%3s %11s %11s %9s %9s %6s %6s\n"
	    ,"  #","S calc","S exper","Error","Err bar","R","Z");
    for(i=0; i < nMFS; i++){
      if(MFS[i].kA){
	if(fabs(MFS[i].S-MFS[i].S0) <= MFS[i].dS){ 
	  fprintf(lF,"%3d %11.4e %11.4e %9.2e %9.2e %6.3f %6.3f\n"
		  ,i,MFS[i].S,MFS[i].S0,MFS[i].S-MFS[i].S0,MFS[i].dS
		  ,MFS[i].R,MFS[i].Z);
	}
	else{
	  fprintf(lF,"%3d %11.4e %11.4e %9.2e %9.2e %6.3f %6.3f *\n"
		  ,i,MFS[i].S,MFS[i].S0,MFS[i].S-MFS[i].S0,MFS[i].dS
		  ,MFS[i].R,MFS[i].Z);
	}
      }
    }
  }

  if(nMFp){
    fprintf(lF,"%2d --- Magnetic Probe signals:\n",kF);
    fprintf(lF,"%3s %11s %11s %9s %9s %6s %6s\n"
	    ,"  #","S calc","S exper","Error","Err bar","R","Z");
    for(i=0; i < nMFp; i++){
      if(MFp[i].kA){
	if(fabs(MFp[i].S-MFp[i].S0) <= MFp[i].dS){ 
	  fprintf(lF,"%3d %11.4e %11.4e %9.2e %9.2e %6.3f %6.3f\n"
		  ,i,MFp[i].S,MFp[i].S0,MFp[i].S-MFp[i].S0,MFp[i].dS
		  ,MFp[i].R,MFp[i].Z);
	}
	else{
	  fprintf(lF,"%3d %11.4e %11.4e %9.2e %9.2e %6.3f %6.3f *\n"
		  ,i,MFp[i].S,MFp[i].S0,MFp[i].S-MFp[i].S0,MFp[i].dS
		  ,MFp[i].R,MFp[i].Z);
	}
      }
    }
  }

  /* MSE data */
  if(MSEFl && nMSE){
    fprintf(lF,"%2d --- MSE signals:\n",kF);
    fprintf(lF,"%3s %11s %11s %9s %9s %6s %6s\n"
	    ,"  #","S calc","S exper","Error","Err bar","R","Z");
    for(i=0; i < nMSE; i++){
      if((MSE[i].kA&0x03)){
	if(fabs(MSE[i].S-MSE[i].S0) <= MSE[i].dS){ 
	  fprintf(lF,"%3d %11.4e %11.4e %9.2e %9.2e %6.3f %6.3f\n"
		  ,i,MSE[i].S,MSE[i].S0,MSE[i].S-MSE[i].S0,MSE[i].dS
		  ,MSE[i].r,MSE[i].z);
	}
	else{
	  fprintf(lF,"%3d %11.4e %11.4e %9.2e %9.2e %6.3f %6.3f *\n"
		  ,i,MSE[i].S,MSE[i].S0,MSE[i].S-MSE[i].S0,MSE[i].dS
		  ,MSE[i].r,MSE[i].z);
	}
      }
    }
  }
  fclose(lF);
  return(0);
}

int PFExpDataPlot(int Fl,char *str)
{
  extern int NWin;
  int i,j,n,kW;
  static int inx=1,iny=1;
  char ln[128];
  double s,x[256],y[256];
  double dI,dV,dL,dB;
  double dIe,dVe,dLe,dBe;
  double wIe,wVe,wLe,wBe;
  double wI,wV,wL,wB;
  double I,V,L,B;
  
  I	=0.;
  V	=0.;
  L	=0.;
  B	=0.;
  dI	=0.;
  dV	=0.;
  dL	=0.;
  dB	=0.;
  dIe	=0.;
  dVe	=0.;
  dLe	=0.;
  dBe	=0.;
  wI	=0.;
  wV	=0.;
  wL	=0.;
  wB	=0.;
  wIe	=0.;
  wVe	=0.;
  wLe	=0.;
  wBe	=0.;

  /* Coils */
  kW	=6;
  y[0]	=0.;
  y[1]	=0.;
  j	=0;
  n	=nPFC+1;
  for(i=1; i < n; i++){
    if(PFC[i].kA){
      s		=PFC[i].I0-PFC[i].I;
      if(i < nPFC){
	dI	+=fabs(s)*PFC[i].tn;
	I	+=fabs(PFC[i].I0)*PFC[i].tn;
	s	=PFC[i].dI != 0. ? s/PFC[i].dI : s;
	wI	+=s*s;
      }
      if(1 || strncmp(PFC[i].Nm,"OH",2)){
	s=FlAmpTn ? (PFC[i].I0-PFC[i].dI)*PFC[i].tn : PFC[i].I0-PFC[i].dI;
	if(y[0] > s) y[0]=s;
	s=FlAmpTn ? (PFC[i].I0+PFC[i].dI)*PFC[i].tn : PFC[i].I0+PFC[i].dI;
	if(y[1] < s) y[1]=s;
	s	=FlAmpTn ? PFC[i].I*PFC[i].tn : PFC[i].I;
	if(y[0] > s) y[0]=s;
	if(y[1] < s) y[1]=s;
	if((ExpDataFl&0x01)){
	  s	=PFC[i].I0-PFC[i].Ie;
	  dIe	+=fabs(s)*PFC[i].tn;
	  s	=PFC[i].dI != 0. ? s/PFC[i].dI : s;
	  wIe	+=s*s;
	  s	=FlAmpTn ? PFC[i].Ie*PFC[i].tn : PFC[i].Ie;
	  if(y[0] > s) y[0]=s;
	  if(y[1] < s) y[1]=s;
	}
	j++;
      }
    }
  }
  dIe	/=nPFC;
  dI	/=nPFC;
  I	/=nPFC;
  x[0]	=0;
  x[1]	=j;
  x[1]	=n+1;
  if(Fl){
    static int kPS=1;
    static char PSFileNm[16];
    if(Fl > 1){
      inx	=Fl-1;
      iny	=Fl-1;
    }
    if(kPS && *ShotNm != '\0'){
      sprintf(PSFileNm,"%s.ps",ShotNm);
      PSSetFileName(PSFileNm);
      kPS	=0;
    }
    PSFileOpen(inx,iny);
  }
  sprintf(ln,"%s  Coil Currents",str);
  SetPlotName("Coil #",FlAmpTn ? "I*tn [MA]" : "I [MA]",ln);
  Scale2d(kW,x,y,2,6,2);
  j	=0;
  for(i=1; i < n; i++){
    if(1 || strncmp(PFC[i].Nm,"OH",2)){
      x[j]	=i;
      y[j++]=FlAmpTn ? (PFC[i].I0+PFC[i].dI)*PFC[i].tn : PFC[i].I0+PFC[i].dI;
    }
  }
  Plot2d(kW,x,y,j,6,0x0110,14,0);
  if(Fl){
    PSNewFrame();
    PSPlot2d(x,y,j,6,0x0110,14,0);
  }
  j	=0;
  for(i=1; i < n; i++){
    if(1 || strncmp(PFC[i].Nm,"OH",2)){
      y[j++]=FlAmpTn ? (PFC[i].I0-PFC[i].dI)*PFC[i].tn : PFC[i].I0-PFC[i].dI;
    }
  }
  Plot2d(kW,x,y,j,6,0x110,14,0);
  if(Fl){
    PSPlot2d(x,y,j,6,0x10,14,0);
  }
  j	=0;
  for(i=1; i < n; i++){
    if(1 || strncmp(PFC[i].Nm,"OH",2)){
      y[j++]	=FlAmpTn ? PFC[i].I0*PFC[i].tn : PFC[i].I0;
    }
  }
  Plot2d(kW,x,y,j,6,0x108,0,0);
  if(Fl){
    PSPlot2d(x,y,j,6,0x108,0,0);
  }
  if((ExpDataFl&0x01)){
    j	=0;
    for(i=1; i < nPFC; i++){
      if(1 || strncmp(PFC[i].Nm,"OH",2)){
	y[j++]	=FlAmpTn ? PFC[i].Ie*PFC[i].tn : PFC[i].Ie;
      }
    }
    Plot2d(kW,x,y,j,6,0x08,14,0);
    if(Fl){
      PSPlot2d(x,y,j,6,0x08,14,0);
    }
  }
  j	=0;
  for(i=1; i < n; i++){
    if(1 || strncmp(PFC[i].Nm,"OH",2)){
      y[j++]	=FlAmpTn ? PFC[i].I*PFC[i].tn : PFC[i].I;
    }
  }
  Plot2d(kW,x,y,j,6,0x08,4,0);
  if(Fl){
    PSPlot2d(x,y,j,6,0x08,4,0);
  }

  /* Screens */
  kW	=8;
  if(nVVC && kW < NWin){
    sprintf(ln,"%s  Screen Current",str);
    SetPlotName("Coil #","I [MA]",ln);
    y[0]	=VVC[0].I;
    y[1]	=VVC[0].I;
    for(i=0; i < nVVC; i++){
      if(VVC[i].kA){
	s	=VVC[i].I0-VVC[i].I;
	dV	+=fabs(s);
	V	+=fabs(VVC[i].I0);
	s	=VVC[i].dI != 0. ? s/VVC[i].dI : s;
	wV	+=s*s;
	if(y[0] > VVC[i].I0-VVC[i].dI) y[0]=VVC[i].I0-VVC[i].dI;
	if(y[1] < VVC[i].I0+VVC[i].dI) y[1]=VVC[i].I0+VVC[i].dI;
	if(y[0] > VVC[i].I) y[0]=VVC[i].I;
	if(y[1] < VVC[i].I) y[1]=VVC[i].I;
	if((ExpDataFl&0x01)){
	  s	=VVC[i].I0-VVC[i].Ie;
	  dVe	+=fabs(s);
	  s	/=VVC[i].dI;
	  wVe	+=s*s;
	  if(y[0] > VVC[i].Ie) y[0]=VVC[i].Ie;
	  if(y[1] < VVC[i].Ie) y[1]=VVC[i].Ie;
	}
      }
    }
    dVe	/=nVVC;
    dV	/=nVVC;
    V	/=nVVC;
    x[0]	=-1;
    x[1]	=nVVC;

    Scale2d(kW,x,y,2,6,2);
    for(i=0; i < nVVC; i++){
      y[i]	=VVC[i].I0+VVC[i].dI;
      x[i]	=i;
    }
    Plot2d(kW,x,y,nVVC,6,0x0110,14,0);
    if(Fl && (Fl&0x06) == 0){
      PSNewFrame();
      PSPlot2d(x,y,nVVC,6,0x0110,14,0);
    }

    for(i=0; i < nVVC; i++) y[i]=VVC[i].I0-VVC[i].dI;
    Plot2d(kW,x,y,nVVC,6,0x110,14,0);
    if(Fl && (Fl&0x06) == 0) PSPlot2d(x,y,nVVC,6,0x110,14,0);
    for(i=0; i < nVVC; i++) y[i]=VVC[i].I0;
    Plot2d(kW,x,y,nVVC,6,0x108,0,0);
    if(Fl && (Fl&0x06) == 0) PSPlot2d(x,y,nVVC,6,0x108,0,0);
    if((ExpDataFl&0x01)){
      for(i=0; i < nVVC; i++){
	y[i]	=VVC[i].Ie;
	x[i]	=i;
      }
      Plot2d(kW,x,y,nVVC,6,0x08,14,0);
      if(Fl && (Fl&0x06) == 0){
	PSPlot2d(x,y,nVVC,6,0x08,14,0);
      }
    }
    for(i=0; i < nVVC; i++){
      y[i]	=VVC[i].I;
      x[i]	=i;
    }
    Plot2d(kW,x,y,nVVC,6,0x08,4,0);
    if(Fl && (Fl&0x06) == 0) PSPlot2d(x,y,nVVC,6,0x08,4,0);
  }

  /* Loops */
  kW	=4;
  y[0]	=0.;
  y[1]	=0.;
  j	=0;
  for(i=0; i < nMFLS; i++){
    if(MFL[i].kA){
      L		+=fabs(MFL[i].S0);
      s		=MFL[i].S0-MFL[i].S;
      dL	+=fabs(s);
      s		=MFL[i].dS != 0. ? s/MFL[i].dS : s;
      wL	+=s*s;
      if(y[0] > MFL[i].S0-MFL[i].dS) y[0]=MFL[i].S0-MFL[i].dS;
      if(y[1] < MFL[i].S0+MFL[i].dS) y[1]=MFL[i].S0+MFL[i].dS;
      if(y[0] > MFL[i].S) y[0]=MFL[i].S;
      if(y[1] < MFL[i].S) y[1]=MFL[i].S;

      if((ExpDataFl&0x01)){
	s	=MFL[i].S0-MFL[i].Se;
	dLe	+=fabs(s);
	s	/=MFL[i].dS;
	wLe	+=s*s;
	if(y[0] > MFL[i].Se) y[0]=MFL[i].Se;
	if(y[1] < MFL[i].Se) y[1]=MFL[i].Se;
      }
      j++;
    }
  }
  dLe	/=j;
  dL	/=j;
  L	/=j;
  x[0]	=0;
  x[1]	=j+1;
  x[1]	=nMFLS+1;
  sprintf(ln,"%s  Loop Signals",str);
  SetPlotName("Loop #","gY [Vsec]",ln);
  Scale2d(kW,x,y,2,6,2);
  j	=0;
  for(i=0; i < nMFLS; i++){
    if(MFL[i].kA){
      x[j]	=i+1;
      y[j++]	=MFL[i].S0+MFL[i].dS;
    }
  }
  Plot2d(kW,x,y,j,6,0x0110,14,0);
  if(Fl){
    PSNewFrame();
    PSPlot2d(x,y,j,6,0x0110,14,0);
  }
  j	=0;
  for(i=0; i < nMFLS; i++){
    if(MFL[i].kA) y[j++]=MFL[i].S0-MFL[i].dS;
  }
  Plot2d(kW,x,y,j,6,0x110,14,0);
  if(Fl) PSPlot2d(x,y,j,6,0x110,14,0);
  j	=0;
  for(i=0; i < nMFLS; i++) if(MFL[i].kA) y[j++]=MFL[i].S0;
  Plot2d(kW,x,y,j,6,0x108,0,0);
  if(Fl) PSPlot2d(x,y,j,6,0x108,0,0);
  if((ExpDataFl&0x01)){
    j	=0;
    for(i=0; i < nMFLS; i++) if(MFL[i].kA) y[j++]=MFL[i].Se;
    Plot2d(kW,x,y,j,6,0x08,14,0);
    if(Fl) PSPlot2d(x,y,j,6,0x08,14,0);
  }
  j	=0;
  for(i=0; i < nMFLS; i++){
    if(MFL[i].kA){
      x[j]+=0.1;
      y[j++]=MFL[i].S;
    }
  }
  Plot2d(kW,x,y,j,6,0x08,4,0);
  if(Fl) PSPlot2d(x,y,j,6,0x08,4,0);

  /* Magnetic probes */
  if(nMFp){
    kW	=5; 
    y[0]	=0.;
    y[1]	=0.;
    x[0]	=0;
    x[1]	=nMFp+1;
    j	=0;
    for(i=0; i < nMFp; i++){
      if(MFp[i].kA){
	B		+=fabs(MFp[i].S0);
	s		=MFp[i].S0-MFp[i].S;
	dB	+=fabs(s);
	s		=MFp[i].dS != 0. ? s/MFp[i].dS : s;
	wB	+=s*s;
	if(y[0] > MFp[i].S0-MFp[i].dS) y[0]=MFp[i].S0-MFp[i].dS;
	if(y[1] < MFp[i].S0+MFp[i].dS) y[1]=MFp[i].S0+MFp[i].dS;
	if(y[0] > MFp[i].S) y[0]=MFp[i].S;
	if(y[1] < MFp[i].S) y[1]=MFp[i].S;
	if((ExpDataFl&0x01)){
	  s	=MFp[i].S0-MFp[i].Se;
	  dB	+=fabs(s);
	  s	/=MFp[i].dS;
	  wBe	+=s*s;
	  if(y[0] > MFp[i].Se) y[0]=MFp[i].Se;
	  if(y[1] < MFp[i].Se) y[1]=MFp[i].Se;
	}
	j++;
      }
    }
    dB	/=j;
    B	/=j;
  }
#ifdef H
  if((ExpDataFl&0x01)){
    dBe	/=j;
    out("sdddd","|<dSe>| EFIT =",dIe,dVe,dLe,dBe);
    out("sdddd","|<dS>|       =",dI,dV,dL,dB);
    out("sdddd","|<dSe>|/|<S0>|=",dIe/I,dVe/V,dLe/L,dBe/B);
    out("sdddd","|<dS>|/|<S0>| =",dI/I,dV/V,dL/L,dB/B);
    out("sddddd","We=",wIe+wVe+wLe+wBe,wIe,wVe,wLe,wBe);
  }
  out("sddddd","W =",wI+wV+wL+wB,wI,wV,wL,wB);
#endif
  sprintf(ln,"%s  Magnetic Probe Signals",str);
  SetPlotName("Probe #","B [T]",ln);
  x[1]	+=1.;
  Scale2d(kW,x,y,2,6,2);

  j	=0;
  for(i=0; i < nMFp; i++){
    if(MFp[i].kA){
      x[j]	=i+1;
      y[j++]	=MFp[i].S0+MFp[i].dS;
    }
  }

  Plot2d(kW,x,y,j,6,0x0110,14,0);
  if(Fl){
    PSNewFrame();
    PSPlot2d(x,y,j,6,0x0110,14,0);
  }
  j	=0;
  for(i=0; i < nMFp; i++) if(MFp[i].kA) y[j++]=MFp[i].S0-MFp[i].dS;
  Plot2d(kW,x,y,j,6,0x110,14,0);
  if(Fl) PSPlot2d(x,y,j,6,0x110,14,0);
  j	=0;
  for(i=0; i < nMFp; i++) if(MFp[i].kA) y[j++]=MFp[i].S0;
  Plot2d(kW,x,y,j,6,0x108,0,0);
  if(Fl) PSPlot2d(x,y,j,6,0x108,0,0);
  if((ExpDataFl&0x01)){
    j	=0;
    for(i=0; i < nMFp; i++) if(MFp[i].kA) y[j++]=MFp[i].Se;
    Plot2d(kW,x,y,j,6,0x08,14,0);
    if(Fl) PSPlot2d(x,y,j,6,0x08,14,0);
  }
  j	=0;
  for(i=0; i < nMFp; i++) if(MFp[i].kA){
    x[j]	+=0.1;
    y[j++]=MFp[i].S;
  }
  Plot2d(kW,x,y,j,6,0x08,4,0);
  if(Fl) PSPlot2d(x,y,j,6,0x08,4,0);


  /* MSE data */
  if(MSEFl && nMSE) MSEDataPlot(2,Fl,str);

  if(Fl){
    PSFileClose();
    PFExpDataComparisonStore();
  }
  return(0);
}

int PFHistoryDataPlot(int Fl,char *str)
{
  extern int NWin;
  int i,j,n,kW;
  static int inx=1,iny=1;
  char ln[128];
  double s,x[256],y[256];
  double dI,dV,dL,dB;
  double dIe,dVe,dLe,dBe;
  double wIe,wVe,wLe,wBe;
  double wI,wV,wL,wB;
  double I,V,L,B;
  
  I	=0.;
  V	=0.;
  L	=0.;
  B	=0.;
  dI	=0.;
  dV	=0.;
  dL	=0.;
  dB	=0.;
  dIe	=0.;
  dVe	=0.;
  dLe	=0.;
  dBe	=0.;
  wI	=0.;
  wV	=0.;
  wL	=0.;
  wB	=0.;
  wIe	=0.;
  wVe	=0.;
  wLe	=0.;
  wBe	=0.;

  /* Coils */
  kW	=6;
  y[0]	=0.;
  y[1]	=0.;
  j	=0;
  n	=nPFC+1;
  for(i=1; i < n; i++){
    if(PFC[i].kA){
      s		=PFC[i].I0-PFC[i].I;
      if(i < nPFC){
	dI	+=fabs(s)*PFC[i].tn;
	I	+=fabs(PFC[i].I0)*PFC[i].tn;
	s	=PFC[i].dI != 0. ? s/PFC[i].dI : s;
	wI	+=s*s;
      }
      if(1 || strncmp(PFC[i].Nm,"OH",2)){
	s=FlAmpTn ? (PFC[i].I0-PFC[i].dI)*PFC[i].tn : PFC[i].I0-PFC[i].dI;
	if(y[0] > s) y[0]=s;
	s=FlAmpTn ? (PFC[i].I0+PFC[i].dI)*PFC[i].tn : PFC[i].I0+PFC[i].dI;
	if(y[1] < s) y[1]=s;
	s	=FlAmpTn ? PFC[i].I*PFC[i].tn : PFC[i].I;
	if(y[0] > s) y[0]=s;
	if(y[1] < s) y[1]=s;
	if((ExpDataFl&0x01)){
	  s	=PFC[i].I0-PFC[i].Ie;
	  dIe	+=fabs(s)*PFC[i].tn;
	  s	=PFC[i].dI != 0. ? s/PFC[i].dI : s;
	  wIe	+=s*s;
	  s	=FlAmpTn ? PFC[i].Ie*PFC[i].tn : PFC[i].Ie;
	  if(y[0] > s) y[0]=s;
	  if(y[1] < s) y[1]=s;
	}
	j++;
      }
    }
  }
  dIe	/=nPFC;
  dI	/=nPFC;
  I	/=nPFC;
  x[0]	=0;
  x[1]	=j;
  x[1]	=n+1;
  if(Fl){
    static int kPS=1;
    static char PSFileNm[16];
    if(Fl > 1){
      inx	=Fl-1;
      iny	=Fl-1;
    }
    if(kPS && *ShotNm != '\0'){
      sprintf(PSFileNm,"%s.ps",ShotNm);
      PSSetFileName(PSFileNm);
      kPS	=0;
    }
    PSFileOpen(inx,iny);
  }
  sprintf(ln,"%s  Coil Currents",str);
  SetPlotName("Coil #",FlAmpTn ? "I*tn [MA]" : "I [MA]",ln);
  Scale2d(kW,x,y,2,6,2);
  j	=0;
  for(i=1; i < n; i++){
    if(1 || strncmp(PFC[i].Nm,"OH",2)){
      x[j]	=i;
      y[j++]=FlAmpTn ? (PFC[i].I0+PFC[i].dI)*PFC[i].tn : PFC[i].I0+PFC[i].dI;
    }
  }
  Plot2d(kW,x,y,j,6,0x0110,14,0);
  if(Fl){
    PSNewFrame();
    PSPlot2d(x,y,j,6,0x0110,14,0);
  }
  j	=0;
  for(i=1; i < n; i++){
    if(1 || strncmp(PFC[i].Nm,"OH",2)){
      y[j++]=FlAmpTn ? (PFC[i].I0-PFC[i].dI)*PFC[i].tn : PFC[i].I0-PFC[i].dI;
    }
  }
  Plot2d(kW,x,y,j,6,0x110,14,0);
  if(Fl) PSPlot2d(x,y,j,6,0x10,14,0);
  j	=0;
  for(i=1; i < n; i++){
    if(1 || strncmp(PFC[i].Nm,"OH",2)){
      y[j++]	=FlAmpTn ? PFC[i].I0*PFC[i].tn : PFC[i].I0;
    }
  }
  Plot2d(kW,x,y,j,6,0x108,0,0);
  if(Fl) PSPlot2d(x,y,j,6,0x108,0,0);
  j	=0;
  for(i=1; i < n; i++){
    if(1 || strncmp(PFC[i].Nm,"OH",2)){
      y[j++]	=FlAmpTn ? PFC[i].I*PFC[i].tn : PFC[i].I;
    }
  }
  Plot2d(kW,x,y,j,6,0x08,4,0);
  if(Fl) PSPlot2d(x,y,j,6,0x08,4,0);


  /* Screens */
  kW	=8;
  if(nVVC && kW < NWin){
    sprintf(ln,"%s  Screen Current",str);
    SetPlotName("Coil #","I [MA]",ln);
    y[0]	=VVC[0].I;
    y[1]	=VVC[0].I;
    for(i=0; i < nVVC; i++){
      if(VVC[i].kA){
	if(y[0] > VVC[i].I0-VVC[i].dI) y[0]=VVC[i].I0-VVC[i].dI;
	if(y[1] < VVC[i].I0+VVC[i].dI) y[1]=VVC[i].I0+VVC[i].dI;
	if(y[0] > VVC[i].I) y[0]=VVC[i].I;
	if(y[1] < VVC[i].I) y[1]=VVC[i].I;
	if(y[0] > VVC[i].Ie) y[0]=VVC[i].Ie;
	if(y[1] < VVC[i].Ie) y[1]=VVC[i].Ie;
      }
    }
    x[0]	=-1;
    x[1]	=nVVC;

    Scale2d(kW,x,y,2,6,2);
    for(i=0; i < nVVC; i++){
      y[i]	=VVC[i].I0+VVC[i].dI;
      x[i]	=i;
    }
    Plot2d(kW,x,y,nVVC,6,0x0110,14,0);
    if(Fl && (Fl&0x06) == 0){
      PSNewFrame();
      PSPlot2d(x,y,nVVC,6,0x0110,14,0);
    }

    for(i=0; i < nVVC; i++) y[i]=VVC[i].I0-VVC[i].dI;
    Plot2d(kW,x,y,nVVC,6,0x110,14,0);
    if(Fl && (Fl&0x06) == 0) PSPlot2d(x,y,nVVC,6,0x110,14,0);
    for(i=0; i < nVVC; i++) y[i]=VVC[i].I0;
    Plot2d(kW,x,y,nVVC,6,0x108,0,0);
    if(Fl && (Fl&0x06) == 0) PSPlot2d(x,y,nVVC,6,0x108,0,0);
    for(i=0; i < nVVC; i++){
      y[i]	=VVC[i].Ie;
      x[i]	=i;
    }
    Plot2d(kW,x,y,nVVC,6,0x08,14,0);
    if(Fl && (Fl&0x06) == 0) PSPlot2d(x,y,nVVC,6,0x08,14,0);
    for(i=0; i < nVVC; i++){
      y[i]	=VVC[i].I;
      x[i]	=i;
    }
    Plot2d(kW,x,y,nVVC,6,0x08,4,0);
    if(Fl && (Fl&0x06) == 0) PSPlot2d(x,y,nVVC,6,0x08,4,0);
  }

  /* Loops */
  kW	=4;
  y[0]	=0.;
  y[1]	=0.;
  j	=0;
  for(i=0; i < nMFLS; i++){
    if(MFL[i].kA){
      if(y[0] > MFL[i].S0-MFL[i].dS) y[0]=MFL[i].S0-MFL[i].dS;
      if(y[1] < MFL[i].S0+MFL[i].dS) y[1]=MFL[i].S0+MFL[i].dS;
      if(y[0] > MFL[i].S) y[0]=MFL[i].S;
      if(y[1] < MFL[i].S) y[1]=MFL[i].S;

      if(y[0] > MFL[i].V0-MFL[i].dS) y[0]=MFL[i].V0-MFL[i].dS;
      if(y[1] < MFL[i].V0+MFL[i].dS) y[1]=MFL[i].V0+MFL[i].dS;
      if(y[0] > MFL[i].V) y[0]=MFL[i].V;
      if(y[1] < MFL[i].V) y[1]=MFL[i].V;
      j++;
    }
  }
  x[0]	=0;
  x[1]	=j+1;
  x[1]	=nMFLS+1;
  sprintf(ln,"%s  Loop Signals",str);
  SetPlotName("Loop #","gY [Vsec]",ln);
  Scale2d(kW,x,y,2,6,2);
  j	=0;
  for(i=0; i < nMFLS; i++){
    if(MFL[i].kA){
      x[j]	=i+1;
      y[j++]	=MFL[i].V0+MFL[i].dS;
    }
  }
  Plot2d(kW,x,y,j,6,0x0110,14,0);
  if(Fl){
    PSNewFrame();
    PSPlot2d(x,y,j,6,0x0110,14,0);
  }
  j	=0;
  for(i=0; i < nMFLS; i++) if(MFL[i].kA) y[j++]=MFL[i].V0-MFL[i].dS;
  Plot2d(kW,x,y,j,6,0x110,14,0);
  if(Fl) PSPlot2d(x,y,j,6,0x110,14,0);
  j	=0;
  for(i=0; i < nMFLS; i++) if(MFL[i].kA) y[j++]=MFL[i].V0;
  Plot2d(kW,x,y,j,6,0x108,0,0);
  if(Fl) PSPlot2d(x,y,j,6,0x108,0,0);
  j	=0;
  for(i=0; i < nMFLS; i++){
    if(MFL[i].kA){
      x[j]	+=0.1;
      y[j++]=MFL[i].V;
    }
  }
  Plot2d(kW,x,y,j,6,0x08,14,0);
  if(Fl) PSPlot2d(x,y,j,6,0x08,14,0);
  j	=0;
  for(i=0; i < nMFLS; i++) if(MFL[i].kA){
    x[j]	=i+1;
    y[j++]=MFL[i].S0+MFL[i].dS;
  }
  Plot2d(kW,x,y,j,6,0x110,14,0);
  if(Fl) PSPlot2d(x,y,j,6,0x110,14,0);
  j	=0;
  for(i=0; i < nMFLS; i++) if(MFL[i].kA) y[j++]=MFL[i].S0-MFL[i].dS;
  Plot2d(kW,x,y,j,6,0x110,14,0);
  if(Fl) PSPlot2d(x,y,j,6,0x110,14,0);
  j	=0;
  for(i=0; i < nMFLS; i++) if(MFL[i].kA) y[j++]=MFL[i].S0;
  Plot2d(kW,x,y,j,6,0x108,0,0);
  if(Fl) PSPlot2d(x,y,j,6,0x108,0,0);
  j	=0;
  for(i=0; i < nMFLS; i++){
    if(MFL[i].kA){
      x[j]+=0.1;
      y[j++]=MFL[i].S;
    }
  }
  Plot2d(kW,x,y,j,6,0x08,4,0);
  if(Fl) PSPlot2d(x,y,j,6,0x08,4,0);

  /* Magnetic probes */
  kW	=5; 
  y[0]	=0.;
  y[1]	=0.;
  x[0]	=0;
  x[1]	=nMFp+1;
  x[1]	=0;
  j	=0;
  for(i=0; i < nMFp; i++){
    if(MFp[i].kA){
      B		+=fabs(MFp[i].V0);
      s		=MFp[i].V0-MFp[i].V;
      dB	+=fabs(s);
      s		=MFp[i].dS != 0. ? s/MFp[i].dS : s;
      wB	+=s*s;
      if(y[0] > MFp[i].V0-MFp[i].dS) y[0]=MFp[i].V0-MFp[i].dS;
      if(y[1] < MFp[i].V0+MFp[i].dS) y[1]=MFp[i].V0+MFp[i].dS;
      if(y[0] > MFp[i].V) y[0]=MFp[i].V;
      if(y[1] < MFp[i].V) y[1]=MFp[i].V;
      if(x[1] < i) x[1]=i+1;
      j++;
    }
  }
  dB	/=j;
  B	/=j;
  sprintf(ln,"%s  Magnetic Probe Signals",str);
  SetPlotName("Probe #","B [T]",ln);
  x[1]	+=1.;
  Scale2d(kW,x,y,2,6,2);

  j	=0;
  for(i=0; i < nMFp; i++){
    if(MFp[i].kA){
      x[j]	=i+1;
      y[j++]	=MFp[i].V0+MFp[i].dS;
    }
  }

  Plot2d(kW,x,y,j,6,0x0110,14,0);
  if(Fl){
    PSNewFrame();
    PSPlot2d(x,y,j,6,0x0110,14,0);
  }
  j	=0;
  for(i=0; i < nMFp; i++) if(MFp[i].kA) y[j++]=MFp[i].V0-MFp[i].dS;
  Plot2d(kW,x,y,j,6,0x110,14,0);
  if(Fl) PSPlot2d(x,y,j,6,0x110,14,0);
  j	=0;
  for(i=0; i < nMFp; i++) if(MFp[i].kA) y[j++]=MFp[i].V0;
  Plot2d(kW,x,y,j,6,0x108,0,0);
  if(Fl) PSPlot2d(x,y,j,6,0x108,0,0);
  j	=0;
  for(i=0; i < nMFp; i++) if(MFp[i].kA){
    x[j]+=0.1;
    y[j++]=MFp[i].V;
  }
  Plot2d(kW,x,y,j,6,0x08,4,0);
  if(Fl) PSPlot2d(x,y,j,6,0x08,4,0);

  /* MSE data */
  if(MSEFl && nMSE) MSEDataPlot(2,Fl,str);

  if(Fl){
    PSFileClose();
    PFExpDataComparisonStore();
  }
  return(0);
}

int PFEfitOutPlot()
{
  int i,k;
  double x[128],y[128];

  for(i=0; i < nPFB && i < 128; i++){
    k		=PFB[i].kC;
    y[i]	=PFC[k].Ie;
    x[i]	=i;
  }
  Plot2d(3,x+1,y+1,i-1,6,0x08,14,0);
  
  for(i=0; i < nVVC; i++){
    y[i]	=VVC[i].Ie;
    x[i]	=i;
  }
  Plot2d(2,x,y,nVVC,6,0x08,14,0);

  k	=0;
  for(i=0; i < nMFS && i < 128; i++){
    if(MFL[i].kA){
      y[k]	=MFL[i].Se;
      x[k++]	=i+1;
    }
  }
  Plot2d(4,x,y,k,6,0x08,14,0);

  k	=0;
  for(i=0; i < nMFp && i < 128; i++){
    if(MFp[i].kA){
      y[k]	=MFp[i].Se;
      x[k++]	=i+1;
    }
  }
  Plot2d(5,x,y,k,6,0x08,14,0);
  return(0);
}

int PFGenerateSignals()
{
  int i;
  double s;

  s	=0.;
  for(i=1; i < nPFC; i++){
    if(s < fabs(PFC[i].I)){
      s	=fabs(PFC[i].I);
    }
  }
  s	*=0.01;
  for(i=0; i < nPFC; i++){
    PFC[i].I0	=PFC[i].I;
    PFC[i].dI	=s;
  }
  for(i=0; i < nVVC; i++){
    VVC[i].I0	=VVC[i].I;
    VVC[i].dI	=s;
  }

  s	=0.;
  for(i=0; i < nMFLS; i++){
    if(MFL[i].kA){
      if(s < fabs(MFL[i].S)){
	s	=fabs(MFL[i].S);
      }
    }
  }
  s	*=0.01;
  for(i=0; i < nMFLS; i++){
    if(MFL[i].kA){
      MFL[i].S0	=MFL[i].S;
      MFL[i].dS	=s;
    }
  }
  s	=0.;
  for(i=0; i < nMFp; i++){
    if(MFp[i].kA){
      if(s < fabs(MFp[i].S)){
	s	=fabs(MFp[i].S);
      }
    }
  }
  s	*=0.01;
  for(i=0; i < nMFp; i++){
    if(MFp[i].kA){
      MFp[i].S0	=MFp[i].S;
      MFp[i].dS	=s;
    }
  }
  return(0);
}

int PFSetExpDataWeights0()
{
  int i;
  double s,ss;

  ss	=0.;
  for(i=0; i < nPFC; i++){
    if(PFC[i].kA){
      s	=fabs(PFC[i].dI);
      if(ss < s) ss=s;
    }
  }
  if(ss == 0.) ss=1e-3;
  for(i=0; i < nPFC; i++){
    if(PFC[i].dI == 0)  PFC[i].dI=ss;
    PFC[i].wI	=1./(PFC[i].dI*PFC[i].dI);
  }
  for(i=0; i < nVVC; i++){
    if(VVC[i].dI == 0.) VVC[i].dI=ss;
    VVC[i].wI	=1./(VVC[i].dI*VVC[i].dI);
  }
  ss	=0.;
  for(i=0; i < nMFLS; i++){
    if(MFL[i].kA){
      s	=fabs(MFL[i].dS);
      if(ss < s) ss=s;
    }
  }
  if(ss == 0.) ss=1e-3;
  for(i=0; i < nMFLS; i++){
    if(MFL[i].dS == 0.) MFL[i].dS=ss;
    MFL[i].w	=1./(MFL[i].dS*MFL[i].dS);
  }
  ss	=0.;
  for(i=0; i < nMFp; i++){
    if(MFp[i].kA){
      s	=fabs(MFp[i].dS);
      if(ss < s) ss=s;
    }
  }
  if(ss == 0.) ss=1e-3;
  for(i=0; i < nMFp; i++){
    if(MFp[i].dS == 0.) MFp[i].dS=ss;
    MFp[i].w	=1./(MFp[i].dS*MFp[i].dS);
  }
  return(0);
}

int PFSetExpDataWeights()
{
  int i;
  double s,ss;

  ss	=0.;
  for(i=0; i < nPFC; i++){
    if(PFC[i].kA){
      s	=fabs(PFC[i].dI);
      if(ss < s) ss=s;
    }
  }
  if(ss == 0.) ss=1e-3;
  for(i=0; i < nPFC; i++){
    if(PFC[i].dI == 0) PFC[i].dI=ss;
    PFC[i].wI	=1./PFC[i].dI;
  }
  for(i=0; i < nVVC; i++){
    if(VVC[i].dI == 0.) VVC[i].dI=ss;
    VVC[i].wI	=1./VVC[i].dI;
  }
  ss	=0.;
  for(i=0; i < nMFLS; i++){
    if(MFL[i].kA){
      s	=fabs(MFL[i].dS);
      if(ss < s) ss=s;
    }
  }
  if(ss == 0.) ss=1e-3;
  for(i=0; i < nMFLS; i++){
    if(MFL[i].dS == 0.) MFL[i].dS=ss;
    MFL[i].w	=1./MFL[i].dS;
  }
  ss	=0.;
  for(i=0; i < nMFp; i++){
    if(MFp[i].kA){
      s	=fabs(MFp[i].dS);
      if(ss < s) ss=s;
    }
  }
  if(ss == 0.) ss=1e-3;
  for(i=0; i < nMFp; i++){
    if(MFp[i].dS == 0.) MFp[i].dS=ss;
    MFp[i].w	=1./MFp[i].dS;
  }
  return(0);
}

int PFSetExpDataWeightsJET()
{
  int i,n;
  double s,ss;

  ss	=0.;
  n	=nPFC+1;
  for(i=1; i < n; i++){
    if(PFC[i].kA){
      s	=PFC[i].dI;
      if(ss < s) ss=s;
    }
  }
  if(ss == 0.) ss=1e-3;
  if(PFC[0].dI == 0.) PFC[0].dI=0.01;
  PFC[0].wI	=1./PFC[0].dI;
  for(i=1; i < n; i++){
    if(PFC[i].dI == 0)  PFC[i].dI=ss;
    PFC[i].wI	=1./PFC[i].dI;
  }

/**** JET *******/
  for(i=1; i < nPFC; i++){
    if(PFC[i].Tn == 0.) PFC[i].Tn=1.;
    PFC[i].dI	=1e-3/PFC[i].Tn;
    PFC[i].wI	=1./PFC[i].dI;
  }

  s	=0.;
  for(i=0; i < nPFC; i++){
    if(PFC[i].kA) s+=PFC[i].I0*PFC[i].Tn;
  }
  ss	=0.;
  for(i=0; i < nVVC; i++){
    ss	+=1./VVC[i].Res;
  }
  s	*=1./ss;
  s	=fabs(s);
  for(i=0; i < nVVC; i++){
    VVC[i].dI	=s/VVC[i].Res;
    if(VVC[i].dI == 0.) VVC[i].dI=.0001;
    VVC[i].wI	=1./VVC[i].dI;
  }
/**** JET *******/
  for(i=0; i < nVVC; i++){
    VVC[i].dI	=0.01;
    VVC[i].wI	=1./VVC[i].dI;
  }
  ss	=0.;
  for(i=0; i < nMFLS; i++){
    if(MFL[i].kA && ss < MFL[i].dS) ss=MFL[i].dS;
  }
  if(ss == 0.) ss=1e-3;
  for(i=0; i < nMFLS; i++){
    if(MFL[i].dS == 0.) MFL[i].dS=ss;
    MFL[i].w	=1./MFL[i].dS;
  }
  ss	=0.;
  for(i=0; i < nMFp; i++){
    if(MFp[i].kA && ss < MFp[i].dS) ss=MFp[i].dS;
  }
  if(ss == 0.) ss=1e-3;
  for(i=0; i < nMFp; i++){
    if(MFp[i].dS == 0.) MFp[i].dS=ss;
    MFp[i].w	=1./MFp[i].dS;
  }
  return(0);
}

int PFExpDataFromEFIT(char *NmF)
{
  int i,j,k,n,k0,kk;
  char Dir[64];
  char *lD,*lN;
  double sI[128],sY[128],sS[128],sB[256];
  double dI[128],dY[128],dS[128],dB[256];
  int kI[128],kY[128],kS[128],kB[128];
  
  for(i=0; i < 128; i++) kI[i]=-1;

  /* kI[i] is the Coils number to which i-th signal should go */
  for(i=0; i < nPFC; i++){
    n	=PFC[i].nB;
    for(j=0; j < n; j++){
      kk	=PFC[i].kB[j];
      k0	=PFB[kk].kD;
      for(k =0; k < j; k++){
	kk	=PFC[i].kB[k];
	if(PFB[kk].kD == k0){
	  break;
	}
      }
      if(k == j) kI[k0]=i;
    }
  }
  for(i=0; i < nVVC; i++){
    n	=VVC[i].nB;
    for(j=0; j < n; j++){
      kk	=VVC[i].kB[j];
      k0	=VVB[kk].kD;
      for(k =0; k < j; k++){
	kk	=VVC[i].kB[k];
	if(VVB[kk].kD == k0) break;
      }
      if(k == j) kI[k0]=i+nPFC;
    }
  }
  CbGetCurrentCbName(&lD,&lN);
  sprintf(Dir,"%s/",lD);
  if(readefitk_(&ESRext,&ESBt,sI,dI,kI,sY,dY,kY,sS,dS,kS,sB,dB,kB,Dir,NmF)){
    return(1);
  }
  if(ESRext == 0) ESRext=PFB[0].R;
  ESRBt	=ESRext*ESBt;
  if(FlAmpTn){
    double t;
    for(i=0; i < nPFC && i < 128; i++){
      t	=1./PFC[i].tn;
      if(dI[i] < 0.) PFC[i].kA=1;
      if(strncmp(PFC[i].Nm,"OH",2)){  /* JET caviat */
	PFC[i].I0	=sI[i]*t;
	PFC[i].dI	=dI[i]*t;
      }
      else{
	PFC[i].I0	=sI[i];
	PFC[i].dI	=dI[i];
      }
      PFC[i].I	=PFC[i].I0;
    }
  }
  else{
    for(i=0; i < nPFC && i < 128; i++){
      if(dI[i] < 0.) PFC[i].kA=0;
      PFC[i].I0	=sI[i];
      PFC[i].dI	=dI[i];
      PFC[i].I	=PFC[i].I0;
    }
  }
  for(i=0,j=nPFC; i < nVVC && j < 128; i++,j++){
    if(dI[j] < 0.) VVC[i].kA=0;
    VVC[i].I0	=sI[j];
    VVC[i].dI	=dI[j];
    VVC[i].I	=VVC[i].I0;
  }
  i	=0;
  for(k=0; k < nMFL; k++){
    if(k == kY[i]){
      MFL[k].S0	=sY[i];
      MFL[k].dS	=dY[i];
      i++;
    }
    else{
      MFL[k].S0	=0.;
      MFL[k].dS	=0.;
      MFL[k].kA	=0;
    }
  }
  i	=0;
  for(k=0; k < nMFS; k++){
    if(k == kS[i]){
      MFS[k].S0	=sS[i];
      MFS[k].dS	=dS[i];
      i++;
    }
    else{
      MFS[k].S0	=0.;
      MFS[k].dS	=0.;
      MFS[k].kA	=0;
    }
  }
  i	=0;
  for(k=0; k < nMFp; k++){
    if(k == kB[i]){
      MFp[k].S0	=sB[i];
      MFp[k].dS	=dB[i];
      i++;
    }
    else{
      MFp[k].S0	=0.;
      MFp[k].dS	=0.;
      MFp[k].kA	=0;
    }
  }
  return(0);
}

int PFOutAFromEFIT(char *NmF)
{
  int i,j,k,n,k0,kk,n1;
  double sI[nPEC],sY[nMFL],sS[nMFS],sB[nMFp];
  int kI[nPEC],kS1[nMFS],kS2[nMFS];

  for(i=0; i < nPEC; i++){
    kI[i]	=-1;
  }
  for(i=0; i < nPFC; i++){
    n	=PFC[i].nB;
    for(j=0; j < n; j++){
      kk	=PFC[i].kB[j];
      k0	=PFB[kk].kD;
      for(k =0; k < j; k++){
	kk	=PFC[i].kB[k];
	if(PFB[kk].kD == k0){
	  break;
	}
      }
      if(k == j){
	kI[k0]	=i;
      }
    }
  }
  n1	=0;
  for(i=0; i < nVVC; i++){
    n	=VVC[i].nB;
    for(j=0; j < n; j++){
      kk	=VVC[i].kB[j];
      k0	=VVB[kk].kD;
      for(k =0; k < j; k++){
	kk	=VVC[i].kB[k];
	if(VVB[kk].kD == k0){
	  break;
	}
      }
      if(k == j){
	kI[k0]	=i+nPFC;
	if(n1 < k0){
	  n1	=k0;
	}
      }
    }
  }
  {
    FILE *lF;

    lF=fopen("JET/In/SaddleL.map","r");
    fscanf(lF,"%d %d",&i,&j);
    for(i=0; i < nMFS; i++){
      fscanf(lF,"%d %d %d",&j,kS1+i,kS2+i);
    }
  }
  if(readefita_(sI,kI,&n1,sY,&nMFL,kS1,kS2,sS,&nMFS,sB,&nMFp,NmF)){
    return(1);
  }
  for(i=0; i < nPFC; i++){
    PFC[i].Ie	=FlAmpTn ? sI[i]/PFC[i].tn : sI[i];
  }
  for(i=0,j=nPFC; i < nVVC; i++,j++){
    VVC[i].Ie	=sI[j];
  }
  for(i=0; i < nMFL; i++){
    MFL[i].Se	=sY[i];
  }
  for(i=0; i < nMFS; i++){
    MFS[i].Se	=sS[i];
  }
  for(i=0; i < nMFp; i++){
    MFp[i].Se	=sB[i];
  }
  ExpDataFl	|=1;
  return(0);
}

void EFITjpPlot()
{
  int i;
  double a,s,ds,qgy,t,x[EFITnA],y[EFITnA],R0;
  extern double *ESjp,*ESjp2a;

  if(EFITnA < 2 || ESsa[0] != 0.){
    return;
  }
  t	=ESsa[ESNa]/(EFITnA-1);
  R0	=ESaR0[0];
  x[0]	=0.;
  y[0]	=EFITaP[0]*R0;
  for(i=1; i < EFITnA; i++){
    qgy	=sqrt(t*i);
    a	=qgy;
    do{
      ESSetSplA(a);
      splRA(&s,&ds,ESqgY,ESqgY2a);
      a		+=(qgy-s)/ds;
    }while(fabs(qgy-s) > 1e-8);
    x[i]	=a;
    y[i]	=EFITaP[i]*R0;
  }
  ZColor(14);
  ZPlotPolyLine(x,y,EFITnA);
}

void EFITjsPlot()
{
  int i;
  double a,s,ds,qgy,t,x[EFITnA],y[EFITnA],R0,rR0;
  extern double *ESjs,*ESjs2a,*ESaT,*ESaT2a;
  
  if(EFITnA < 2 || ESsa[0] != 0.){
    return;
  }
  t	=1./(EFITnA-1);
  R0	=ESaR0[0];
  rR0	=1./R0;
  x[0]	=0.;
  y[0]	=EFITaT[0]*rR0+EFITaP[0]*R0;
  for(i=1; i < EFITnA; i++){
    qgy	=sqrt(t*i);
    a	=qgy;
    do{
      ESSetSplA(a);
      splRA(&s,&ds,ESqgY,ESqgY2a);
      a		+=(qgy-s)/ds;
    }while(fabs(qgy-s) > 1e-8);
    x[i]	=a;
    y[i]	=EFITaT[i]*rR0+EFITaP[i]*R0;
  }
  ZColor(14);
  ZPlotPolyLine(x,y,EFITnA);
}

int EFITaP2Jp(double *xd,double *yd, int nd)
{
  int i,n;
  double s,R0,x[EFITnA],d2g[EFITnA];

  if(EFITnA < 2 || ESsa[0] != 0.){
    return(0);
  }

  s	=ESsa[ESNa]/(EFITnA-1);
  for(i=0; i < EFITnA; i++){
    x[i]	=s*i;
  }
  n	=EFITnA-1;
  spl(EFITaP,d2g,NULL,NULL,x,&n);
  R0	=ESaR0[0];
  yd[0]	=EFITaP[0]*R0;
  for(i=1; i < nd; i++){
    ESSetSplA(xd[i]);
    splRA(&s,NULL,ESqgY,ESqgY2a);
    SetIspl(x,s*s,n);
    splR(yd+i,NULL,EFITaP,d2g);
    yd[i]	*=R0;
  }
  return(0);
}

int EFITaT2Js(double *xd,double *yd, int nd)
{
  int i,n;
  double s,rR0,R0,x[EFITnA],d2g[EFITnA],d2f[EFITnA];

  if(EFITnA < 2 || ESsa[0] != 0.){
    return(0);
  }

  s	=ESsa[ESNa]/(EFITnA-1);
  for(i=0; i < EFITnA; i++){
    x[i]	=s*i;
  }
  n	=EFITnA-1;
  spl(EFITaP,d2g,NULL,NULL,x,&n);
  spl(EFITaT,d2f,NULL,NULL,x,&n);
  R0	=ESaR0[0];
  rR0	=1./R0;
  yd[0]	=EFITaT[0]*rR0+EFITaP[0]*R0;
  for(i=1; i < nd; i++){
    ESSetSplA(xd[i]);
    splRA(&s,NULL,ESqgY,ESqgY2a);
    SetIspl(x,s*s,n);
    splR(yd+i,NULL,EFITaP,d2g);
    splR(&s,NULL,EFITaT,d2f);
    yd[i]	=s*rR0+yd[i]*R0;
  }
  return(0);
}

int PFFileListEFIT(char*DirNm)
{
  int i,k;
  char*p,*lc;
  DIR *dirp;
  struct dirent*direntp;

  nFList	=0;
  if((dirp	=opendir(DirNm)) != NULL){
    while((direntp=readdir(dirp)) != NULL){
      p	=direntp->d_name;
      if(strlen(p) > 15){
	printf("%s:%s: - too long EFIT file name (> 15)%c\n",DirNm,p,'\a'); 
	break;
      }
      if(*p == 'k' && nFList < NFList){
	lc	=FListEFIT[nFList]; 
	/* Sorting */
	if(nFList){
	  i	=nFList;
	  while(i > 0){
	    i--;
	    if(strcmp(p,FListEFIT[i]) > 0){
	      break;
	    }
	    strcpy(lc,FListEFIT[i]);
	    lc	=FListEFIT[i]; 
	  }
	}
	strcpy(lc,p);
	nFList++;
      }
    }
    closedir(dirp);
  }
  p	=FListEFIT[0];
  while(*p != '.') p++;
  k	=p+3-FListEFIT[0];
  for(i=0; i < nFList; i++){
    out("si",FListEFIT[i]+k,i);
  }
  return(0);
}

int PFExpDataFileList(char*DirNm)
{
  int i,k;
  char*p,*lc;
  DIR *dirp;
  struct dirent*direntp;
  char DNm[128];

  sprintf(DNm,"%s/In",DirNm);
  nFList	=0;
  if((dirp	=opendir(DNm)) != NULL){
    while((direntp=readdir(dirp)) != NULL){
      p	=direntp->d_name;
      k	=strlen(p);
      if(k == 15 && *p == 'E' && nFList < NFList){
	lc	=FListEFIT[nFList]; 
	/* Sorting */
	if(nFList){
	  i	=nFList;
	  while(i > 0){
	    i--;
	    if(strcmp(p,FListEFIT[i]) > 0) break;
	    strcpy(lc,FListEFIT[i]);
	    lc	=FListEFIT[i]; 
	  }
	}
	strcpy(lc,p);
	nFList++;
      }
    }
    closedir(dirp);
  }
  p	=FListEFIT[0];
  while(*p != '.') p++;
  k	=p+1-FListEFIT[0];
  for(i=0; i < nFList; i++) out("si",FListEFIT[i]+k,i);
  return(0);
}

int GetExpData()
{
  FILE *lF;
  static int Fl=0,FlD=0;
  double Bt;
  int i,j,n,kk;
  int nI,nL,nP,nM;
  double  r[nMFP],z[nMFP],s[nMFP];
  char *Nm[nMFP],NmF[nMFP];
  static char str[2][16]={"*","*"};
  static char ln[32];
  double gg[200],dgg[200],wgg[200],rm[200],zm[200];

  kk	=0;
#ifndef Tbl_ExpData
  if(str[0][0] == '*' && str[0][1] == '\0' 
     && str[1][0] == '*' && str[1][1] == '\0'){
#ifndef AscI_ExpData
#undef AscI_ExpData
#endif/*AscI_ExpData*/
    str[0][1]	='*';
    str[0][2]	='\0';
    str[1][1]	='*';
    str[1][2]	='\0';
  }
  switch(FlD){
  case 1: /* Make file list */
    {
      char *lD,*lN;
      CbGetCurrentCbName(&lD,&lN);
#ifdef H
      PFExpDataFileList(lD);
#endif
      PFFileListEFIT(lD);
      iFList	=0;
      str[0][1]	='\0';
    }
    FlD	=0;
    break;
  case 2:
    if(iFList < nFList){
      strcpy(str[1],FListEFIT[iFList]);
      iFList++;
    }
    break;
  case 3:
    if(iFList > 0){
      iFList--;
      strcpy(str[1],FListEFIT[iFList]);
    }
    break;
  default:
    break;
  }
  switch(kk){
  case 1: /* ExpData.aiTime file */
    *str[1]='E';
    if(*str[0] != '*'){
      sprintf(NmF,"%s/In/%s",str[0],str[1]);
    }
    else{
      char *lD,*lN;
      CbGetCurrentCbName(&lD,&lN);
      sprintf(NmF,"%s/In/%s",lD,str[1]);
      out("s<s><s><s>","Nm=",NmF,lD,str[1]);
    }
    *kFileExt	='\0';
    lF	=fopen(NmF,"r");
    if(lF == NULL || PFExpDataAI(lF)){
      *str[1]='*';
    }
    else{
      char *lc;
      lc	=str[1];
      while(*lc != '\0' && *lc != '.') lc++;
      if(*lc == '.') strcpy(kFileExt,lc+1);
    }
    if(lF != NULL) fclose(lF);
    break;
  case 2:
    *str[1]='k';
    if(*str[0] != '*'){
      sprintf(NmF,"%s%s",str[0],str[1]);
    }
    else{
      char *lD,*lN;
      CbGetCurrentCbName(&lD,&lN);
      sprintf(NmF,"%s/%s",lD,str[1]);
      out("s<s><s><s>","Nm=",NmF,lD,str[1]);
    }
    *kFileExt	='\0';
    if(PFExpDataFromEFIT(NmF)){
      *str[1]='*';
    }
    else{
      char *lc;
      lc	=str[1];
      while(*lc != '\0' && *lc != '.')lc++;
      if(*lc == '.') strcpy(kFileExt,lc+1);
    }
    break;
  case 3:
    *str[1]='a';
    if(*str[0] != '*'){
      sprintf(NmF,"%s%s",str[0],str[1]);
    }
    else{
      char *lD,*lN;
      CbGetCurrentCbName(&lD,&lN);
      sprintf(NmF,"%s/%s",lD,str[1]);
    }
    if(PFOutAFromEFIT(NmF)){
      *str[1]='*';
    }
    break;
  case 4:
    *str[1]='g';
    if(*str[0] != '*'){
      sprintf(NmF,"%s%s",str[0],str[1]);
    }
    else{
      char *lD,*lN;
      CbGetCurrentCbName(&lD,&lN);
      sprintf(NmF,"%s/%s",lD,str[1]);
    }
    if((readefitg_(rEft,zEft,&nEft,EFITaP,EFITaT,&EFITnA,NmF)&0x01) == 0){
      ExpDataFl	|=2;
    }
    break;
  case 5:
    out("sI","MSEFl==",MSEFl);
    if(MSEFl){
      char *lD,*lN,Dir[64];
      CbGetCurrentCbName(&lD,&lN);
      sprintf(Dir,"%s/",lD);
      *str[1]='k';
      if(*str[0] != '*'){
	sprintf(NmF,"%s%s",str[0],str[1]);
      }
      else{
	sprintf(NmF,"%s/%s",lD,str[1]);
      }
      out("ss","NmF=",NmF);
      if(getefitmsek_(&i,gg,dgg,wgg,r,z,Dir,NmF)){
	*str[1]='*';
	nMSE	=0;
      }
      else{
	nMSE	=i;
	for(i=0; i < nMSE; i++){
	  MSE[i].r	=r[i];
	  MSE[i].z	=z[i];
	  MSE[i].S0	=gg[i];
	  MSE[i].dS	=fabs(dgg[i]);
	  MSE[i].w	=wgg[i];
	  MSE[i].kA	=wgg[i] < 1e-6 ? 0 : 1;
	}
	MSESetCoeff();
      }
    }
    break;
  case 6: /* All files list */
    *str[1]='k';
    if(*str[0] != '*'){
      sprintf(NmF,"%s",str[0]);
    }
    else{
      char *lD,*lN;
      CbGetCurrentCbName(&lD,&lN);
      sprintf(NmF,"%s",lD);
    }
    j	=strlen(NmF);
    if(NmF[j-1] != '/'){
      NmF[j++]	='/';
      NmF[j]	='\0';
    }
    strcpy(NmF+j,str[1]);
    if(PFExpDataFromEFIT(NmF)){
      printf("%s: Bad file\n",NmF);
    }
    *str[1]='a';
    strcpy(NmF+j,str[1]);
    if(PFOutAFromEFIT(NmF)){
      printf("%s: Bad file\n",NmF);
    }
    *str[1]='g';
    strcpy(NmF+j,str[1]);
    if((readefitg_(rEft,zEft,&nEft,EFITaP,EFITaT,&EFITnA,NmF)&0x01) == 0){
      ExpDataFl	|=2;
    }
    else{
      printf("%s: Bad file\n",NmF);
    }
    break;
  default:
    break;
  }
  if(ESRBt < 0.){
    ESRBt=-ESRBt;
    ESBt=-ESBt;
    CbStr2UserMessage("Negative Btor. Sign changed");
  }

  if(FlD < 2) kk=0;
  n	=0;
  switch(SignFl){
  case 0:
    n	=nPFB+1;
    if(n < nMFP){
      for(i=0; i < n; i++){
	r[i]	=PFB[i].R;
	z[i]	=PFB[i].Z;
	j	=PFB[i].kC;
	s[i]	=PFC[j].I0;
	Nm[i]	=PFB[i].Nm;
      }
    }
    else{
      n	=nPFC;
      for(i=0; i < n; i++){
	j	=PFC[i].kB[0];
	r[i]	=PFB[j].R;
	z[i]	=PFB[j].Z;
	s[i]	=PFC[i].I0;
	Nm[i]	=PFC[i].Nm;
      }
    }
    break;
  case 1:
    for(i=0; i < nMFL; i++){
      r[i]	=MFL[i].R;
      z[i]	=MFL[i].Z;
      s[i]	=MFL[i].S0;
      Nm[i]	=MFL[i].Nm;
    }
    n	=i;
    break;
  case 2:
    for(i=0; i < nMFS; i++){
      r[i]	=MFS[i].R;
      z[i]	=MFS[i].Z;
      s[i]	=MFS[i].S0;
      Nm[i]	=MFS[i].Nm;
    }
    n	=i;
    break;
  case 3:
    for(i=0; i < nMFp; i++){
      r[i]	=MFp[i].R;
      z[i]	=MFp[i].Z;
      s[i]	=MFp[i].S0;
      Nm[i]	=MFp[i].Nm;
    }
    n	=nMFp;
    break;
  default:
    n	=nPFB+1;
    for(i=0; i < n; i++){
      r[i]	=PFB[i].R;
      z[i]	=PFB[i].Z;
      j		=PFB[i].kC;
      s[i]	=PFC[j].I0;
      Nm[i]	=PFB[i].Nm;
    }
    break;
  }
  if(Fl == 4) Fl++;
  PFSetExpDataWeights();
  if(ESTime != 0.){
    sprintf(ln,"%s t=%5.3f",ShotNm,ESTime);
  } 
  else{
    strcpy(ln,str[1]);
  }
  PFExpDataPlot(Fl,ln);
  Fl	=0.;
  ESIpl	=PFC[0].I0;

  if(ESIpl != 0.) ESkNormJ=1;

  Bt	=ESBt;
  nI	=0;
  for(i=0; i < nPFC; i++) if(PFC[i].kA) nI++;
  for(i=0; i < nVVC; i++) if(VVC[i].kA) nI++;
  nL	=0;
  for(i=0; i < nMFLS; i++) if(MFL[i].kA) nL++;
  nP	=0;
  for(i=0; i < nMFp; i++) if(MFp[i].kA) nP++;
  nM	=0;	
  for(i=0; i < nMSE; i++) if((MSE[i].kA&0x01)) nM++;
  CbUserPlot	=MFSignalPlot;
#endif/*Tbl_ExpData*/

#ifndef AscO_ExpData
#undef AscO_ExpData
#endif/*AscO_ExpData*/
  return(0);
}
#endif
