#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <sys/stat.h>
#include <unistd.h>
#include <ctype.h>
#include "CbType.h"

extern CbUnits*XUnits;
extern int NXUnits;

int CbExchangeBLB(int*nblb0,BLB**blb0,int*nCbB0);
int Cb2IOBlbTblAddress(int nblb0,BLB*blb0,int nTbl0,InpTblPar*Tbl0,
		       FILE***fpTbl);

int FailureAlarm(char*p,char*RoutineName);
int CbDeInitInpTables();
int ReadCbTableFile(char*NmTbl,int iT);
int CbGetTblStructure(char*NmTblF,int iT);
int CbGetTblHlpStructure(char*NmTblF,int iT);
int CbGetPltStructure(char*NmPltF,int iT);
int CbDeInitPlt();
int CbInitRangePar(int iT);
int CbDeInitRangePar();

static FILE*fp;
static char NmF[80],NmTblF[80],ln[80];
static int*nMI,*iMI,kMI;

static CbVectorNm*VecNm;
static int NVecNm;

static BLB*blb;
static int nblb,iblb,nCbB;
static char*NoHelpMess= "Help not provided";

static InpTblPar*Tbl,*pntT;
static char**TblHlp;
static int nTbl;

static PltPar *Plt, *pntP;

static RngPar*Rng;

static int NCbIO= 8;

static int nAttr0=3,iAttr[3],nAttr=5,kAttr[5]={2,3,3,1,1};
static char* Attr[5]={"SF","Beg","End","W","L"};

static CbIOPar*BRc,*BSv,*BRd,*BWr,*BnrI,*BnrO,*AscI,*AscO,*CbIO[8];
static int FlagEdit= 0;
static int NType= 11,NpB[11],RdFl[11],IOInsFl[11];

static char *pN[11],*pntN[11]={"Tbl_","Hlp","Plt","BRc_","BSv_","BRd_","BWr_",
				 "BnrI","BnrO","AscI","AscO"};

static char**BuffIO;

static char*InsDel[4]= {"insert(","delete(","INSERT(","DELETE("},*pID[4];
static char*InsBuff,*DelBuff;
static int NIns,nIns,*pIns,*pInsT,*pInsF,*pInsB,*pInsS,NpIns,npIns,
NDel,nDel,*pDel,*pDelT,*pDelF,*pDelB,*pDelE,NpDel,npDel;

static FILE***fpTbl;


static int NLoop= 50,nLoop;
static CbIOLoop*IOLoop;

static int NPar= 50,nPar;
static char**NmPar;

static int NIOVec= 50,nIOVec;
static CbIOVec*IOVec;

static int NIOObj= 50,nIOObj;
static CbIOObj*IOObj;
static CbPltSet*PltSet;
static int*kGO,NGO;
static CbIOSet**IOSet;
static int NIOStr= 132;
static char*IOStr;
static char*CbIOType[6]= {"  char ","  double ","  int ",
			    " float  ","  long int ","  char "};
static int NIOFunc=3;
static char*CbIOFunc[3]= {"get","send","plot"};
static int nCW=10,LCW=3;
static char *CW[10]={"str","dbl","int","flt","lng"
		       ,"fch","Dbl","Int","Flt","Lng"};

int CbSetFlagEdit()
{
  FlagEdit= 1;
  return(0);
}

int *CbGetTblVectorSize(int iT)
{
  return(Tbl[iT].lV);
}

int *CbGetTblVectorIndSize(int iT)
{
  return(Tbl[iT].laV);
}

int CbSetTblVectorSize(int j,int iT,int n)
{
  if(Tbl[iT].lV[j] == n){
    return(0);
  }
  if(n > Tbl[iT].LV[j]){
    CbMem4TblVector(j,iT,n);
    return(2);
  }
  Tbl[iT].lV[j]	=n;
  return(1);
}

int CbSetTblVectorIndSize(int j,int iT,int n)
{
  if(Tbl[iT].laV[j] == n){
    return(0);
  }
  if(n > Tbl[iT].LaV[j]){
    CbMem4TblVectorInd(j,iT,n);
    return(2);
  }
  Tbl[iT].laV[j]	=n;
  return(1);
}

char ***CbGetTblVectorAddress(int iT)
{
  return(Tbl[iT].V);
}

int ***CbGetTblVectorIndAddress(int iT)
{
  return(Tbl[iT].vaV);
}

int *CbGetRngIntAddress(int iT)
{
  return(Rng[iT].vi);
}

double *CbGetRngDblAddress(int iT)
{
  return(Rng[iT].vd);
}

char **CbGetTblParamAddress(int iT)
{
  return(Tbl[iT].P);
}

int **CbGetTblParamIndAddress(int iT)
{
  return(Tbl[iT].vaP);
}

int CbInitInpTables()
{
  int i,k,n,FlTbl;
  char*pnt,*pnt1;
  int iB,nB,iM,nM,iS,nS;

  CbExchangeBLB(&nblb,&blb,&nCbB);
  nTbl	=0;
  for(iB=0; iB < nblb; iB++){
    if(blb[iB].TbB != NULL){
      nTbl++;
    }
    nM	=blb[iB].nM;
    for(iM=0; iM < nM; iM++){
      nS	=blb[iB].nS[iM];
      for(iS=0; iS < nS; iS++){
	if(blb[iB].TbS[iM][iS] != NULL){
	  nTbl++;
	}
      }
    }
  }
  NType	=3+NCbIO;
  BuffIO=(char**)malloc(NType*sizeof(char*));
  NIns	=1024;
  nIns	=0;
  NDel	=1024;
  nDel	=0;
  InsBuff=(char*)malloc(NIns*sizeof(char*));
  FailureAlarm(InsBuff," - no memory for InsBuff in CbInitInpTables");
  DelBuff=(char*)malloc(NDel*sizeof(char*));
  FailureAlarm(DelBuff," - no memory for DelBuff in CbInitInpTables");
  NpIns	=10;
  npIns	=0;
  pIns	=(int*)malloc(NpIns*sizeof(int));
  pInsT	=(int*)malloc(NpIns*sizeof(int));
  pInsF	=(int*)malloc(NpIns*sizeof(int));
  pInsB	=(int*)malloc(NpIns*sizeof(int));
  pInsS	=(int*)malloc(NpIns*sizeof(int));
  NpDel	=10;
  npDel	=0;;
  pDel	=(int*)malloc(NpDel*sizeof(int));
  pDelT	=(int*)malloc(NpDel*sizeof(int));
  pDelF	=(int*)malloc(NpDel*sizeof(int));
  pDelB	=(int*)malloc(NpDel*sizeof(int));
  pDelE	=(int*)malloc(NpDel*sizeof(int));

  Tbl	=(InpTblPar*)malloc(nTbl*sizeof(InpTblPar));
  TblHlp	=(char**)malloc(nTbl*sizeof(char*));
  Plt	=(PltPar*)malloc(nTbl*sizeof(PltPar));
  Rng	=(RngPar*)malloc(nTbl*sizeof(RngPar));

  IOLoop	=(CbIOLoop*)malloc(NLoop*sizeof(CbIOLoop));
  nLoop	=0;
  IOObj	=(CbIOObj*)malloc(NIOObj*sizeof(CbIOObj));
  nIOObj	=0;
  PltSet	=(CbPltSet*)malloc(nTbl*sizeof(CbPltSet));
  for(k=0; k <nTbl; k++){
    PltSet[k].N	=0;
    PltSet[k].n	=0;
    PltSet[k].k	=0;
    PltSet[k].nP	=0;
    PltSet[k].kP	=0;
    PltSet[k].nV	=0;
    PltSet[k].kV	=0;
  }
  IOSet	=(CbIOSet**)malloc(NType*sizeof(CbIOSet*));
  for(n=0; n < NType; n++){
    IOSet[n]	=(CbIOSet*)malloc(nTbl*sizeof(CbIOSet));
    for(k=0; k < nTbl; k++){
      IOSet[n][k].N	=0;
      IOSet[n][k].n	=0;
      IOSet[n][k].k	=0;
      IOSet[n][k].nP	=0;
      IOSet[n][k].kP	=0;
      IOSet[n][k].nV	=0;
      IOSet[n][k].kV	=0;
    }
  }
  IOStr	=(char*)malloc(NIOStr*sizeof(char));
  nPar	=0;
  NmPar	=(char**)malloc(NPar*sizeof(char*));
  nIOVec	=0;
  IOVec	=(CbIOVec*)malloc(NIOVec*sizeof(CbIOVec));
  BRc	=(CbIOPar*)malloc(NCbIO*nTbl*sizeof(CbIOPar));
  BSv	=BRc+nTbl;
  BRd	=BSv+nTbl;
  BWr	=BRd+nTbl;
  BnrI	=BWr+nTbl;
  BnrO	=BnrI+nTbl;
  AscI	=BnrO+nTbl;
  AscO	=AscI+nTbl;

  CbIO[0]	=BRc;
  CbIO[1]	=BSv;
  CbIO[2]	=BRd;
  CbIO[3]	=BWr;
  CbIO[4]	=BnrI;
  CbIO[5]	=BnrO;
  CbIO[6]	=AscI;
  CbIO[7]	=AscO;

  iB	=NType-3;
  fpTbl	=(FILE***)malloc(iB*sizeof(FILE**));
  for(k=0; k < iB; k++){
    fpTbl[k]	=(FILE**)malloc(nTbl*sizeof(FILE*));
  }
  Cb2IOBlbTblAddress(nblb,blb,nTbl,Tbl,fpTbl);

  for(k=0; k < NType; k++){
    if(k != 1){
      NpB[k]	=1024;
      BuffIO[k]	=(char*)malloc(NpB[k]*sizeof(char));
      FailureAlarm(BuffIO[k]," - no memory for BuffIO[k] in CbInitInpTables");
    }
    else{
      NpB[k]	=0;
      BuffIO[k]	=NULL;
    }
  }

  kMI	=5;
  nMI	=(int*)malloc(2*kMI*sizeof(int));
  iMI	=nMI+kMI;
  NVecNm	=10;
  VecNm	=(CbVectorNm*)malloc(NVecNm*sizeof(CbVectorNm));
  for(i=0; i < NVecNm; i++){
    VecNm[i].pi0	=NULL;
    VecNm[i].pi1	=NULL;
  }

  NGO	=10;
  kGO	=(int*)malloc(NGO*sizeof(int));

  nTbl	=0;
  for(iB=0; iB < nblb; iB++){
    if(blb[iB].TbB != NULL){
      pnt1	=blb[iB].TbB;
      Tbl[nTbl].Nm	=blb[iB].NmB;
      Tbl[nTbl].iB	=iB;
      Tbl[nTbl].iM	=-1;
      Tbl[nTbl].iS	=-1;
      Tbl[nTbl].iT	=nTbl;
      Tbl[nTbl].W	=1;
      Tbl[nTbl].nL	=1;
      Tbl[nTbl].SF	=NULL;
      Tbl[nTbl].Beg	=NULL;
      Tbl[nTbl].End	=NULL;
      Plt[nTbl].iT	=nTbl;
      Plt[nTbl].nP	=0;
      Rng[nTbl].ni	=0;
      Rng[nTbl].nd	=0;
      for(k=0; k < NCbIO; k++){
	CbIO[k][nTbl].iT	=nTbl;
	CbIO[k][nTbl].SF	=NULL;
	CbIO[k][nTbl].Beg	=NULL;
	CbIO[k][nTbl].End	=NULL;
	CbIO[k][nTbl].N	=0;
      }
      FlTbl	=CbReadTblFile(pnt1,nTbl);
      if(FlTbl == 1){
	printf("%-20s does not exist for blb_%s\n",pnt1,blb[iB].NmB);
      }
      else{
	if((FlTbl&6) == 2){
	  printf("%s - wrong or absent Hlp section for blb_%s\n",pnt1,
		 blb[iB].NmB);
	  CbDeInitInpTables();
	  exit(0);
	}
	if((FlTbl&2)){
	  if(CbGetTblStructure(pnt1,nTbl)){
	    CbDeInitInpTables();
	    exit(0);
	  }
	  if(CbGetTblHlpStructure(pnt1,nTbl)){
	    CbDeInitInpTables();
	    exit(0);
	  }
	}
	if((FlTbl&8)){
	  if(CbGetPltStructure(pnt1,nTbl)){
	    CbDeInitPlt();
	    CbDeInitInpTables();
	    exit(0);
	  }
	}
	if((FlTbl&0xE)){
	  CbInitRangePar(nTbl);
	}
	n	=16;
	for(k=0; k < NCbIO; k++){
	  if((FlTbl&n)){
	    if(CbGetIOStructure(pnt1,k,nTbl)){
	      CbDeInitRangePar();
	      CbDeInitPlt();
	      CbDeInitInpTables();
	      exit(0);
	    }
	    if(CbInitIOSet(pnt1,k,nTbl)){
	      CbDeInitIOSet();
	      CbDeInitRangePar();
	      CbDeInitPlt();
	      CbDeInitInpTables();
	      exit(0);
	    }
	  }
	  n	*=2;
	}
      }
      nTbl++;
    }
    nM	=blb[iB].nM;
    for(iM=0; iM < nM; iM++){
      nS	=blb[iB].nS[iM];
      for(iS=0; iS < nS; iS++){
	if(blb[iB].TbS[iM][iS] != NULL){
	  pnt1	=blb[iB].TbS[iM][iS];
	  Tbl[nTbl].Nm	=blb[iB].NmS[iM][iS];
	  Tbl[nTbl].iB	=iB;
	  Tbl[nTbl].iM	=iM;
	  Tbl[nTbl].iS	=iS;
	  Tbl[nTbl].iT	=nTbl;
	  Plt[nTbl].iT	=nTbl;
	  Tbl[nTbl].W	=1;
	  Tbl[nTbl].nL	=1;
	  Tbl[nTbl].SF	=NULL;
	  Tbl[nTbl].Beg	=NULL;
	  Tbl[nTbl].End	=NULL;
	  Plt[nTbl].nP	=0;
	  Rng[nTbl].ni	=0;
	  Rng[nTbl].nd	=0;
	  for(k=0; k < NCbIO; k++){
	    CbIO[k][nTbl].iT	=nTbl;
	    CbIO[k][nTbl].SF	=NULL;
	    CbIO[k][nTbl].Beg	=NULL;
	    CbIO[k][nTbl].End	=NULL;
	    CbIO[k][nTbl].N	=0;
	  }
	  FlTbl	=CbReadTblFile(pnt1,nTbl);
	  if(FlTbl==1){
	    printf("%-20s does not exist for blb_%s\n",
		   pnt1,blb[iB].NmS[iM][iS]);
	  }
	  else{
	    if((FlTbl&6)==2){
	      printf("%s - wrong or absent Hlp section for stg_%s\n",pnt1,
		     blb[iB].NmS[iM][iS]);
	      CbDeInitInpTables();
	      exit(0);
	    }
	    if((FlTbl&2)){
	      if(CbGetTblStructure(pnt1,nTbl)){
		CbDeInitInpTables();
		exit(0);
	      }
	      if(CbGetTblHlpStructure(pnt1,nTbl)){
		CbDeInitInpTables();
		exit(0);
	      }
	    }
	    if((FlTbl&8)){
	      if(CbGetPltStructure(pnt1,nTbl)){
		CbDeInitPlt();
		CbDeInitInpTables();
		exit(0);
	      }
	    }
	    if((FlTbl&0xE)){
	      CbInitRangePar(nTbl);
	    }
	    n	=16;
	    for(k=0; k < NCbIO;k++){
	      if((FlTbl&n)){
		if(CbGetIOStructure(pnt1,k,nTbl)){
		  CbDeInitRangePar();
		  CbDeInitPlt();
		  CbDeInitInpTables();
		  exit(0);
		}
		if(CbInitIOSet(pnt1,k,nTbl)){
		  CbDeInitIOSet();
		  CbDeInitRangePar();
		  CbDeInitPlt();
		  CbDeInitInpTables();
		  exit(0);
		}
	      }
	      n	*= 2;
	    }
	  }
	  nTbl++;
	}
      }
    }
  }
  free(kGO);
  CbGiveIOStruct(IOLoop,IOVec,IOObj,IOSet);
  for(i=0; i < NVecNm; i++){
    if(VecNm[i].pi0 != NULL){
      free(VecNm[i].pi0);
    }
    if(VecNm[i].pi1 != NULL){
      free(VecNm[i].pi1);
    }
  }
  free(VecNm);
  free(nMI);
  for(k=0; k < NType; k++){
    if(k != 1){
      free(BuffIO[k]);
    }
  }
  free(BuffIO);
  free(pDel);
  if(FlagEdit==0){
    free(pIns);
    free(pInsT);
    free(pInsF);
    free(pInsS);
    free(pInsB);
    free(pDelT);
    free(pDelF);
    free(pDelB);
    free(pDelE);
    free(DelBuff);
    free(InsBuff);
    CbDeInitIONmPar();
  }
  return(0);
}

int CbDeInitInpTables()
{
  int i,j,k,n;

  n	=NType-3;
  for(k= 0;k<n;k++){
    free(fpTbl[k]);
  }
  free(fpTbl);
  
  for(i= 0;i<nTbl;i++){
    if(Tbl[i].SF != NULL){
      pntT	=Tbl+i;
      n	=pntT->NM;
      for(j=0;j < n; j++){
	free(pntT->nmM[j]);
      }
      n	=pntT->NP;
      for(j=0;j < n; j++){
	if(pntT->iCP[j]==0){
	  free(pntT->P1[j]);
	}
	if(pntT->nmP[j]!=NULL){
	  free(pntT->nmP[j]);
	}
	free(pntT->nmEP[j]);
	if(pntT->aP[j]!=NULL){
	  free(pntT->aP[j]);
	}
	if(pntT->aEP[j]!=NULL){
	  free(pntT->aEP[j]);
	}
      }
      free(pntT->SF);
      free(pntT->Beg);
      free(pntT->End);
      free(pntT->nP);
      free(pntT->scP);
      free(pntT->vaP);
      free(pntT->nmP);

      n		=pntT->NNmV;
      for(j=0; j < n;j++){
	if(pntT->nmEV[j] != NULL){
	  free(pntT->nmEV[j]);
	}
	if(pntT->nmV[j] != NULL){
	  if((pntT->iCV[j]&7) == 0 && pntT->LV[j] != 0){
	    free(pntT->V1[j][0]);
	  }
	  free(pntT->nmV[j]);
	  if(pntT->aEV[j] != NULL){
	    free(pntT->aEV[j]);
	  }
	  if(pntT->vaV[j] != NULL){
	    free(pntT->vaV[j]);
	  }
	  if(pntT->aV[j] != NULL){
	    free(pntT->aV[j]);
	  }
	  free(pntT->V[j]);
	}
	if(pntT->cV[j] != NULL){
	  free(pntT->cV[j]);
	}
      }
      free(pntT->nmV);
      free(pntT->nNmV);
      free(pntT->scV);
      free(pntT->cV);
      free(pntT->vaV);
      free(pntT->V);
      free(TblHlp[i]);
    }
  }
  free(Tbl);
  free(TblHlp);
  return(0);
}


int CbDeInitPlt()
{
  int i,j,n;

  for(i= 0;i<nTbl;i++){
    pntP= Plt+i;

    n= pntP->nP;
    if(n){
      free(pntP->scV);

      n= pntP->nV;
      for(j= 0;j<n;j++){
	free(pntP->V1[j]);
	free(pntP->V[j]);
	free(pntP->nmEV[j]);
	free(pntP->nmV[j]);
	free(pntP->kV[j]);
      }
      free(pntP->V1);
      free(pntP->V);
      free(pntP->kV);
      free(pntP->nmV);
      free(pntP->sizeV);

      n= pntP->nM;
      for(j= 0;j<n;j++){
	free(pntP->nmM[j]);
      }
      free(pntP->mV);
      free(pntP->nmM);

      n= pntP->nP;
      for(j= 0;j<n;j++){
	free(pntP->nmP[j]);
	if(pntP->opt[j]!=NULL)
	  free(pntP->opt[j]);
      }
      free(pntP->nmP);
      free(pntP->i0);
    }
  }
  free(Plt);
  return(0);
}

int CbExchangeTbl(int*nTbl0,InpTblPar**Tbl0,PltPar**Plt0,RngPar**Rng0)
{
  *nTbl0=nTbl;
  *Tbl0	=Tbl;
  *Plt0	=Plt;
  *Rng0	=Rng;
  return(0);
}

int CbExchangeInsDel(char**InsBuff0,
		 int**pIns0,int**pInsT0,int**pInsF0,int**pInsB0,
		 int**pInsS0,int*npIns0,char**DelBuff0,int**pDelT0,
		 int**pDelF0,int**pDelB0,int**pDelE0,int*npDel0)
{
  *InsBuff0= InsBuff;
  *DelBuff0= DelBuff;
  *pIns0= pIns;
  *pInsT0= pInsT;
  *pInsF0= pInsF;
  *pInsB0= pInsB;
  *pInsS0= pInsS;
  *npIns0= npIns;
  *pDelT0= pDelT;
  *pDelF0= pDelF;
  *pDelB0= pDelB;
  *pDelE0= pDelE;
  *npDel0= npDel;
  return(0);
}

int CbExchangeIO(int*NCbIO0,CbIOPar***CbIO0)
{
  *NCbIO0= NCbIO;
  *CbIO0= CbIO;
  return(0);
}

int CbReadTblFile(char*NmTbl,int iT)
{
  char ch,ch1,*pnt,*pntB;
  int i,ic,Fl,n,n1,n2,N,Flstr,FlID,icID;
  int iN;
  struct stat st;

  TblHlp[iT]	=NULL;

  sprintf(NmTblF,"In/%s",NmTbl);
  if(stat(NmTblF,&st)){
    return(1);
  }

  fp	=fopen(NmTblF,"r");

  for(i=0; i < NType; i++){
    if(i == 1 && NpB[i] == 0){
      NpB[i]	=1024;
      BuffIO[i]	=(char*)malloc(NpB[i]*sizeof(char));
    }
    RdFl[i]	=0;
    IOInsFl[i]	=0;
    pN[i]	=pntN[i];
  }

  Fl	=0;
  Flstr	=0;
  FlID	=0;
  ch	='\n';
  ic	=-1;
  n	=0;
  while(feof(fp) == 0 && ic != 0){
    ch1	=ch;
    ch	=getc(fp);
    if(ch == '"'){
      Flstr	^= 1;
    }
    if(Flstr == 0 && ch1 == '/' && ch == '*'){
      ch	='+';
      while(feof(fp) == 0 && (ch1 != '*' || ch != '/')){
	ch1	=ch;
	ch	=getc(fp);
      }
      if(feof(fp)){
	break;
      }
      ch1	=' ';
      ch	=' ';
      if(Fl && n > 0){
	pnt--;
	n--;
      }
    }
    if(ch == '#' && Flstr == 0 && FlID == 0 && ic < 0){
      while(feof(fp) == 0 && ch != '\n'){
	ch1	=ch;
	ch	=getc(fp);
      }
      if(feof(fp)){
	break;
      }
    }

    if(Fl){
      if(n == N){
	N	+=1024;
	pntB	=(char*)realloc((void*)pntB,N*sizeof(char));
	BuffIO[iN]	=pntB;
	NpB[iN]	=N;
	pnt	=pntB+n;
      }

      if(FlID < 2 && (ch == *pID[0] || ch == *pID[2])){
	if(pID[0] == InsDel[0]){
	  if(isspace(ch1)){
	    n1	=n;
	    FlID	=1;
	    pID[0]++;
	    pID[2]++;
	  }
	}
	else{
	  pID[0]++;
	  pID[2]++;
	}
	if(*pID[0]=='\0'){
	  FlID	=2;
	  icID	=-1;
	}
      }
      else{
	if(FlID==1){
	  if(*pID[0]!='('){
	    pID[0]	=InsDel[0];
	    pID[2]	=InsDel[2];
	    FlID	=0;
	    n1	=n;
	  }
	  else{
	    if(!isspace(ch)){
	      *pnt	='\0';
	      printf("Warning: wrong simbol after '%s' in %s section %s%c\n",
		     pntB+n1,NmTblF,pntN[iN],7);
	      exit(1);
	    }
	  }
	}
      }
      if((FlID == 0 || FlID == 3) && (ch == *pID[1] || ch== *pID[3])){
	if(pID[1] == InsDel[1]){
	  if(isspace(ch1)){
	    n1	=n;
	    FlID	=3;
	    pID[1]++;
	    pID[3]++;
	  }
	}
	else{
	  pID[1]++;
	  pID[3]++;
	}
	if(*pID[1] == '\0'){
	  FlID	=4;
	  icID	=-1;
	}
      }
      else{
	if(FlID == 3){
	  if(*pID[1]!='('){
	    pID[1]	=InsDel[1];
	    pID[3]	=InsDel[3];
	    FlID	=0;
	    n1	=n;
	  }
	  else{
	    if(!isspace(ch)){
	      *pnt	='\0';
	      printf("Warning: wrong simbol after '%s' in %s section %s%c\n",
		     pntB+n1,NmTblF,pntN[iN],7);
	      exit(1);
	    }
	  }
	}
      }
      *pnt	=ch;
      pnt++;
      n++;
      if(FlID == 2){
	if(ch == '('&&icID<0){
	  n2	=pnt-1-pntB;
	}
	if(ch == '{'){
	  if(icID<0){
	    icID	=0;
	  }
	  icID++;
	}
	if(ch == '}')
	  icID--;
	if(icID == 0){
	  FlID	=0;
	  *(pnt-1)	='\0';
	  *pnt	='\0';
	  pID[0]	=InsDel[0];
	  pID[2]	=InsDel[2];
	  i	=n-n2+1;
	  if(nIns+i>=NIns){
	    NIns	=nIns+i;
	    InsBuff	=(char*)realloc((void*)InsBuff,NIns*sizeof(char*));
	    FailureAlarm(InsBuff,
			 " - no memory for InsBuff in CbInitInpTables");
	  }
	  if(Flstr){
	    printf("%s Unbalanced '\"' in Insert Section of",
		   NmTblF);
	    printf(" %s:\n<%s>%c\n",pntN[iN],pntB+n2,7);
	    exit(1);
	  }
	  pIns[npIns]	=nIns;
	  pInsT[npIns]	=iT;
	  strcpy(InsBuff+nIns,pntB+n2);
	  nIns	+=i;
	  i	=n-n1;
	  pnt	-=i;
	  n	-=i;
	  *pnt	='\0';
	  CbGetInsertPar(iN);
	  IOInsFl[iN]	=1;
	  npIns++;
	  if(npIns>=NpIns){
	    NpIns	+=10;
	    pIns	=(int*)realloc((void*)pIns,NpIns*sizeof(int));
	    pInsT	=(int*)realloc((void*)pInsT,NpIns*sizeof(int));
	    pInsF	=(int*)realloc((void*)pInsF,NpIns*sizeof(int));
	    pInsB	=(int*)realloc((void*)pInsB,NpIns*sizeof(int));
	    pInsS	=(int*)realloc((void*)pInsS,NpIns*sizeof(int));
	  }
	}
      }


      if(FlID == 4){
	if(ch == '('){
	  if(icID<0){
	    n2	=n-1;
	    icID	=0;
	  }
	  icID++;
	}
	if(ch == ')')
	  icID--;
	if(icID == 0&&ch == ';'){
	  FlID	=0;
	  *pnt	='\0';
	  pID[1]	=InsDel[1];
	  pID[3]	=InsDel[3];
	  i	=n-n2+1;
	  if(nDel+i>=NDel){
	    NDel	=nDel+i;
	    DelBuff	=(char*)realloc((void*)DelBuff,NDel*sizeof(char*));
	    FailureAlarm(DelBuff,
			 " - no memory for DelBuff in CbInitInpTables");
	  }
	  pDel[npDel]	=nDel;
	  pDelT[npDel]	=iT;
	  strcpy(DelBuff+nDel,pntB+n2);
	  if(Flstr){
	    printf("%s Unbalanced '\"' in Delete Section of",
		   NmTblF);
	    printf(" %s:\n<%s>%c\n",pntN[iN],pntB+n2,7);
	    exit(1);
	  }
	  nDel	+=i;
	  i	=n-n1;
	  pnt	-=i;
	  n	-=i;
	  *pnt	='\0';
	  CbGetDeletePar(iN);
	  npDel++;
	  if(npDel>=NpDel){
	    NpDel	+=10;
	    pDel	=(int*)realloc((void*)pDel,NpDel*sizeof(int));
	    pDelT	=(int*)realloc((void*)pDelT,NpDel*sizeof(int));
	    pDelF	=(int*)realloc((void*)pDelF,NpDel*sizeof(int));
	    pDelB	=(int*)realloc((void*)pDelB,NpDel*sizeof(int));
	    pDelE	=(int*)realloc((void*)pDelE,NpDel*sizeof(int));
	  }
	}
      }
    }

    if(Fl == 0){
      for(i=0; i < NType; i++){
	if(ch == *pN[i]){
	  if(pN[i] == pntN[i]){
	    if(isspace(ch1)){
	      pN[i]++;
	    }
	  }
	  else{
	    pN[i]++;
	  }
	  if(*pN[i] == '\0'){
	    if(RdFl[i] == 0){
	      RdFl[i]	=1;
	      iN	=i;
	      pntB	=BuffIO[i];
	      N	=NpB[i];
	      sprintf(pntB,"%s",pntN[i]);
	      n	=strlen(pntB);
	      pnt	=pntB+n;
	      pID[0]	=InsDel[0];
	      pID[1]	=InsDel[1];
	      pID[2]	=InsDel[2];
	      pID[3]	=InsDel[3];
	      FlID	=0;
	      icID	=-1;
	      Fl	=1;
	    }
	    else{
	      printf("Warning: %s file has more than one section %s\n",
		     NmTblF,pntN[i]);
	      printf(" Only the first one has been accepted\n");
	      pN[i]	=pntN[i];
	    }
	    break;
	  }
	}
	else{
	  pN[i]	=pntN[i];
	}
      }
    }
    
    if(Fl && ch == '{'){
      if(ic == -1){
	ic	=0;
      }
      ic++;
    }

    if(Fl && ch == '}'){
      ic--;
      if(ic == 0){
	*pnt	='\0';
	if(Flstr){
	  printf("%s Unbalanced '\"' in Section ",NmTblF);
	  printf(" %s:\n<%s>%c\n",pntN[iN],BuffIO[iN],7);
	  exit(1);
	}
	RdFl[iN]	=2;
	if(iN == 1){
	  NpB[iN]	=0;
	  TblHlp[iT]	=BuffIO[iN];
	}
	BuffIO[iN][n]	='\0';
	for(i=0; i < NType; i++){
	  if(RdFl[i] == 0){
	    break;
	  }
	}
	ic	=-1;
	Fl	=0;
	if(i == NType)
	  break;
      }
    }
  }
  fclose(fp);

  ic	=0;
  N	=2;
  for(i=0; i < NType; i++){
    if(RdFl[i] == 2){
      ic	+=N;
    }
    N	*=2;
  }
  return(ic);
}

int CbGetInsertPar(int iBf)
{
  char*p,*p1,*NmE[2]= {"SF","Beg"};
  int i,Fl;

  if(iBf == 1){
    printf("%s Insert{} is not allowed in Hlp Section:\n<%s>\n",
	   NmTblF,InsBuff+pIns[npIns]);
    exit(1);
  }

  p= InsBuff+pIns[npIns];
  pInsF[npIns]= -1;
  pInsB[npIns]= -1;
  pInsS[npIns]= iBf;

  while(*p!='('&&*p!='\0')
    p++;
  if(*p!='('){
    printf("%s has no '(' in Insert Section:\n<%s>\n",
	   NmTblF,InsBuff+pIns[npIns]);
    exit(1);
  }

  Fl= 0;
  while(*p!=')'&&*p!='{'&&*p!='\0'){
    if(*p == '='){
#ifdef H
      if(iBf>2){
	printf("%s It should be no '=' between '( )' in the Insert Section",
	       NmTblF);
	printf(" for %s:\n<%s>\n",pntN[iBf],InsBuff+pIns[npIns]);
	exit(1);
      }
#endif
      p1= p-1;
      while(isspace(*p1))
	p1--;
      if(strncmp(p1-1,NmE[0],2) == 0&&
	 (isspace(*(p1-2))||*(p1-2) == ','||*(p1-2) == '(')){
	if((Fl&1)){
	  printf("%s Double use of 'SF' as Insert Section parameter:\n<%s>\n",
		 NmTblF,InsBuff+pIns[npIns]);
	  exit(1);
	}
	i= 0;
	Fl	+=1;
      }
      else if(strncmp(p1-2,NmE[1],3) == 0&&
	      (isspace(*(p1-3))||*(p1-3) == ','||*(p1-3) == '(')){
	if((Fl&2)){
	  printf("%s Double use of 'Beg' as Insert Section parameter:\n<%s>\n",
		 NmTblF,InsBuff+pIns[npIns]);
	  exit(1);
	}
	i= 1;
	Fl	+=2;
      }
      else{
	printf("%s Wrong Name of Insert Section parameter:\n<%s>\n",
	       NmTblF,InsBuff+pIns[npIns]);
	printf("Either '%s' or '%s' can be used !\n\n",NmE[0],NmE[1]);
	exit(1);
      }
      while(*p!='"'&&*p!=')'&&*p!='{'&&*p!='\0'){
	p++;
      }
      if(*p!='"'){
	printf("%s has no '\"' after '%s='in Insert Section:\n<%s>\n",
	       NmTblF,NmE[i],InsBuff+pIns[npIns]);
	exit(1);
      }
      p++;
      if((Fl&1)&&pInsF[npIns]<0){
	pInsF[npIns]= p-InsBuff;
      }
      if((Fl&2)&&pInsB[npIns]<0){
	pInsB[npIns]= p-InsBuff;
      }
      while(*p!='"'&&*p!=')'&&*p!='{'&&*p!='\0'){
	p++;
      }
      if(*p!='"'){
	printf("%s has no second '\"' after 'SF='in Insert Section:\n<%s>\n",
	       NmTblF,InsBuff+pIns[npIns]);
	exit(1);
      }
      *p= '\0';
    }
    p++;
  }
  if(*p!=')'){
    printf("%s has no ')' in Insert Section:\n<%s>\n",
	   NmTblF,InsBuff+pIns[npIns]);
    exit(1);
  }
  while(*p!='{'&&*p!='\0')
    p++;
  if(*p!='{'){
    printf("%s has no '{' in Insert Section:\n<%s>\n"
	   ,NmTblF,InsBuff+pIns[npIns]);
    exit(1);
  }
  pIns[npIns]= p+1-InsBuff;

  if(iBf == 2){
    if(pInsF[npIns]<0){
      printf("%s no 'SF=' in Insert Section:\n<%s>\n",
	     NmTblF,InsBuff+pIns[npIns]);
      exit(1);
    }
    if(pInsB[npIns]<0){
      printf("%s no 'Beg=' in Insert Section:\n<%s>\n",
	     NmTblF,InsBuff+pIns[npIns]);
      exit(1);
    }
  }

  if(Fl<3){
    p= BuffIO[iBf];
    while(*p!='('&&*p!='\0')
      p++;
    if(*p!='('){
      printf("%s has no '(' in %s Section:\n<%s>\n",
	     pntN[iBf],NmTblF,BuffIO[iBf]);
      exit(1);
    }
    while(*p!=')'&&*p!='{'&&*p!='\0'){
      if(*p == '='){
	p1= p-1;
	while(isspace(*p1))
	  p1--;
	Fl= 0;

	if(strncmp(p1-1,NmE[0],2) == 0&&
	   (isspace(*(p1-2))||*(p1-2) == ','||*(p1-2) == '(')){
	  if(pInsF[npIns]<0){
	    pInsF[npIns]= nIns;
	    i= 0;
	    Fl= 1;
	  }
	}
	else if(strncmp(p1-2,NmE[1],3) == 0&&
		(isspace(*(p1-3))||*(p1-3) == ','||*(p1-3) == '(')){
	  if(pInsB[npIns]<0){
	    pInsB[npIns]= nIns;
	    i= 1;
	    Fl= 2;
	  }
	}
	if(Fl){
	  while(*p!='"'&&*p!=')'&&*p!='{'&&*p!='\0'){
	    p++;
	  }
	  if(*p!='"'){
	    printf("%s has no '\"' after '%s='in %s Section:\n<%s>\n",
		   NmTblF,NmE[i],pntN[iBf],BuffIO[iBf]);
	    exit(1);
	  }
	  p++;
	  if(Fl){
	    p1= InsBuff+nIns;
	    while(*p!='"'&&*p!=')'&&*p!='{'&&*p!='\0'){
	      *p1++	=*p++;
	      nIns++;
	      if(nIns>=NIns){
		NIns= nIns+20;
		InsBuff= (char*)realloc((void*)InsBuff,NIns*sizeof(char*));
		FailureAlarm(InsBuff,
			     " - no memory for InsBuff in CbGetInsertPar");
		p1= InsBuff+nIns;
	      }
	    }
	    if(*p!='"'){
	      printf("%s has no second '\"' after '%s='in %s Section:\n<%s>\n",
		     NmTblF,NmE[i],pntN[iBf],BuffIO[iBf]);
	      exit(1);
	    }
	    *p1= '\0';
	    nIns++;
	    if(nIns>=NIns){
	      NIns= nIns+20;
	      InsBuff= (char*)realloc((void*)InsBuff,NIns*sizeof(char*));
	      FailureAlarm(InsBuff,
			   " - no memory for InsBuff in CbGetInsertPar");
	    }
	  }
	}
      }
      p++;
    }
    if(*p!=')'){
      printf("%s has no ')' in %s Section:\n<%s>\n",
	     NmTblF,pntN[iBf],BuffIO[iBf]);
      exit(1);
    }
  }
  if(pInsB[npIns]<0){
    printf("%s has no 'Beg' parameter for Insert in %s Section\n",
	   NmTblF,pntN[iBf]);
    exit(1);
  }
  if(pInsF[npIns]<0){
    printf("%s has no 'SF' parameter for Insert in %s Section\n",
	   NmTblF,pntN[iBf]);
    exit(1);
  }
  return(0);
}

int CbGetDeletePar(int iBf)
{
  char*p,*p1,*NmE[3]= {"SF","Beg","End"};
  int i,Fl;

  if(iBf == 1){
    printf("%s Delete{} is not allowed in Hlp Section:\n<%s>\n",
	   NmTblF,DelBuff+pDel[npDel]);
    exit(1);
  }

  p= DelBuff+pDel[npDel];
  pDelF[npDel]= -1;
  pDelB[npDel]= -1;
  pDelE[npDel]= -1;

  while(*p!='('&&*p!='\0')
    p++;
  if(*p!='('){
    printf("%s has no '(' in Delete Section:\n<%s>\n",
	   NmTblF,DelBuff+pDel[npDel]);
    exit(1);
  }

  Fl= 0;
  while(*p!=')'&&*p!='{'&&*p!='\0'){
    if(*p == '='){
      p1= p-1;
      while(isspace(*p1))
	p1--;
      if(strncmp(p1-1,NmE[0],2) == 0&&
	 (isspace(*(p1-2))||*(p1-2) == ','||*(p1-2) == '(')){
	if((Fl&1)){
	  printf("%s Double use of 'SF' as Delete Section parameter:\n<%s>\n",
		 NmTblF,DelBuff+pDel[npDel]);
	  exit(1);
	}
	i= 0;
	Fl	+=1;
      }
      else if(strncmp(p1-2,NmE[1],3) == 0&&
	      (isspace(*(p1-3))||*(p1-3) == ','||*(p1-3) == '(')){
	if((Fl&2)){
	  printf("%s Double use of 'Beg' as Delete Section parameter:\n<%s>\n",
		 NmTblF,DelBuff+pDel[npDel]);
	  exit(1);
	}
	i= 1;
	Fl	+=2;
      }
      else if(strncmp(p1-2,NmE[2],3) == 0&&
	      (isspace(*(p1-3))||*(p1-3) == ','||*(p1-3) == '(')){
	if((Fl&4)){
	  printf("%s Double use of 'End' as Delete Section parameter:\n<%s>\n",
		 NmTblF,DelBuff+pDel[npDel]);
	  exit(1);
	}
	i= 2;
	Fl	+=4;
      }
      else{
	printf("%s Wrong Name of Delete Section parameter:\n<%s>\n",
	       NmTblF,DelBuff+pDel[npDel]);
	printf("Either '%s', '%s' or '%s' can be used !\n\n",
	       NmE[0],NmE[1],NmE[1]);
	exit(1);
      }
      while(*p!='"'&&*p!=')'&&*p!='{'&&*p!='\0'){
	p++;
      }
      if(*p!='"'){
	printf("%s has no '\"' after '%s='in Delete Section:\n<%s>\n",
	       NmTblF,NmE[i],DelBuff+pDel[npDel]);
	exit(1);
      }
      p++;
      if((Fl&1)&&pDelF[npDel]<0){
	pDelF[npDel]= p-DelBuff;
      }
      if((Fl&2)&&pDelB[npDel]<0){
	pDelB[npDel]= p-DelBuff;
      }
      if((Fl&4)&&pDelE[npDel]<0){
	pDelE[npDel]= p-DelBuff;
      }
      while(*p!='"'&&*p!=')'&&*p!='{'&&*p!='\0'){
	p++;
      }
      if(*p!='"'){
	printf("%s has no second '\"' after 'SF='in Delete Section:\n<%s>\n",
	       NmTblF,DelBuff+pDel[npDel]);
	exit(1);
      }
      *p= '\0';
    }
    p++;
  }
  if(*p!=')'){
    printf("%s has no ')' in Delete Section:\n<%s>\n",
	   NmTblF,DelBuff+pDel[npDel]);
    exit(1);
  }
  while(*p!=';'&&*p!='\0')
    p++;
  if(*p!=';'){
    printf("%s has no '{' in Delete Section:\n<%s>\n"
	   ,NmTblF,DelBuff+pDel[npDel]);
    exit(1);
  }
  if(pDelF[npDel]<0){
    printf("%s has no 'SF' parameter for Delete in %s Section\n",
	   NmTblF,pntN[iBf]);
    exit(1);
  }
  if(pDelB[npDel]<0){
    printf("%s has no 'Beg' parameter for Delete in %s Section\n",
	   NmTblF,pntN[iBf]);
    exit(1);
  }
  if(pDelE[npDel]<0){
    printf("%s has no 'End' parameter for Delete in %s Section\n",
	   NmTblF,pntN[iBf]);
    exit(1);
  }
  return(0);
}

char *TblHeadSyntaxCheck(char *lc0,char*NmTblFile,InpTblPar *lT)
{
  int i,k;
  char *lc,*p;

  lc	=lc0;
  while(isspace(*lc)){
    lc++;
  }
  if(*lc++ != 'T' || *lc++ !='b' || *lc++ != 'l' || *lc++ != '_'){
    printf("In/%s - no \"Tbl_\" before Table name in Tbl, line:\n",NmTblFile);
    PPrintLine(lc0,lc);
    return(NULL);
  }
  p	=lT->Nm;
  while(*lc == *p){
    lc++;
    *p++;
  }
  if(*p != '\0'){
    printf("In/%s - Wrong Table name after \"Tbl_\" in line:\n",NmTblFile);
    PPrintLine(lc0,lc);
    printf("Tbl_%s is expected\n",lT->Nm);
    return(NULL);
  }
  while(isspace(*lc)){
    lc++;
  }
  if(*lc != '('){
    printf("In/%s - no '(' after Table name in Tbl, line:\n",NmTblFile);
    PPrintLine(lc0,lc);
    return(NULL);
  }
  for(i=0; i < nAttr0; i++){
    iAttr[i]	=0;
  }
  while(*lc != ')' && *lc != '\0'){
    lc++;
    while(isspace(*lc)){
      lc++;
    }
    for(i=0; i < nAttr; i++){
      if(strncmp(lc,Attr[i],kAttr[i]) == 0){
	lc	+=kAttr[i];
	while(isspace(*lc)){
	  lc++;
	}
	break;
      }
    }
    if(i == nAttr){
      printf("In/%s - wrong type of Table attribute in  line:\n",NmTblFile);
      PPrintLine(lc0,lc);
      return(NULL);
    }
    if(*lc != '='){
      printf("In/%s - no '=' after %s in Tbl, line:\n",NmTblFile,Attr[i]);
      PPrintLine(lc0,lc);
      return(NULL);
    }
    lc++;
    while(isspace(*lc)){
      lc++;
    }
    if(i > 2){
      if(sscanf(lc,"%d",&k) == 0){
	printf("In/%s - no number after %s= in Table attributes, line:\n"
	       ,NmTblFile,Attr[i]);
	PPrintLine(lc0,lc);
	return(NULL);
      }
      while(isdigit(*lc)){
	lc++;
      }
    }
    else{
      if(*lc != '"'){
	printf("In/%s - no '\"' after %s= in Table attributes, line:\n"
	       ,NmTblFile,Attr[i]);
	PPrintLine(lc0,lc);
	return(NULL);
      }
      lc++;
      k	=0;
      p	=ln;
      while(*lc != '"' && *lc != ')' && *lc != '{' && *lc != '\0'){
	*p++	=*lc++;
	k++;
      }
      if(*lc != '"'){
	printf("In/%s - no second '\"' after %s= in Table attributes, line:\n"
	       ,NmTblFile,Attr[i]);
	PPrintLine(lc0,lc);
	return(NULL);
      }
      lc++;
      *p	='\0';
      k++;
    }
    switch(i){
    case 0:
      lT->SF	=(char*)malloc(k*sizeof(char));
      strcpy(lT->SF,ln);
      iAttr[i]	=1;
      break;
    case 1:
      lT->Beg	=(char*)malloc(k*sizeof(char));
      strcpy(lT->Beg,ln);
      iAttr[i]	=1;
      break;
    case 2:
      lT->End	=(char*)malloc(k*sizeof(char));
      strcpy(lT->End,ln);
      iAttr[i]	=1;
      break;
    case 3:
      lT->W	=k;
      break;
    case 4:
      lT->nL	=k;
    default:
      break;
    }
    while(isspace(*lc)){
      lc++;
    }
  }
  k	=0;
  for(i=0; i < nAttr0; i++){
    if(iAttr[i] == 0){
      printf("In/%s - no attribute %s for Tbl, line:\n",NmTblFile,Attr[i]);
      k	=1;
    }
  }
  if(k){
    return(NULL);
  }
  if(*lc != ')'){
    printf("In/%s - no ')' after End in Tbl, line:\n",NmTblFile);
    PPrintLine(lc0,lc);
    return(NULL);
  }
  lc++;
  while(isspace(*lc)){
    lc++;
  }
  return(lc);
}

int CbMem4TblVector(int j,int iT,int n)
{
  int k,*li;

  k	=Tbl[iT].LV[j];
  if(k > n){
    return(0);
  }
  if(k){
    if((Tbl[iT].iCV[j]&7) == 0){
      free(Tbl[iT].V1[j][0]);
    }
    free(Tbl[iT].cV[j]);
    free(Tbl[iT].V[j]);
  }
  Tbl[iT].LV[j]	=n;
  Tbl[iT].lV[j]	=n;
  Tbl[iT].V[j]	=(char**)malloc(2*n*sizeof(char*));
  Tbl[iT].cV[j]	=(int*)malloc(n*sizeof(int));
  if(Tbl[iT].V[j] == NULL || Tbl[iT].cV[j] == NULL){
    printf("%s.Tbl - No memory for vectors.\n",Tbl[iT].Nm);
    exit(1);
  }
  Tbl[iT].V1[j]	=Tbl[iT].V[j]+n;
  li	=Tbl[iT].cV[j];
  for(k=0; k < n; k++){
    *li++	=0;
  }
  if((Tbl[iT].iCV[j]&7) == 0){
    char *lc,**p;
    int L;
    L	=Tbl[iT].iUV[j]+1;
    lc	=(char*)malloc(n*L*sizeof(char));
    p	=Tbl[iT].V1[j];
    for(k=0; k < n; k++){
      p[k]	=lc+L*k;
    }
  }
  return(0);
}

int CbMem4TblVectorInd(int j,int iT,int n)
{
  int k,**li;

  k	=Tbl[iT].LaV[j];
  if(k > n){
    return(0);
  }
  if(k){
    free(Tbl[iT].vaV[j]);
  }
  Tbl[iT].LaV[j]	=n;
  Tbl[iT].laV[j]	=n;
  li	=(int**)malloc(n*sizeof(int*));
  if(li == NULL){
    printf("%s.Tbl - No memory for vectors.\n",Tbl[iT].Nm);
    exit(1);
  }
  Tbl[iT].vaV[j]	=li;
  for(k=0; k < n; k++){
    li[k]	=NULL;
  }
  return(0);
}

int CbSetUnitScale(double *sc,int nU,int iU)
{
  *sc	=1.;
  if(nU < 0 || iU == 0){
    return(0);
  }
  while(iU < XUnits[nU].nU){
    *sc	*=XUnits[nU].scU[iU];
    iU++;
  }
  return(0);
}

int CbGetParCellOptions(int *ix,int *iy, int *in,char *pnt)
{
  char *lc;
  int i,n=3;
  char ch[3]={'x','y','l'};
  char Ch[3]={'X','Y','L'};
  int *li;

  lc	=pnt;
  lc++;
  do{
    while(isspace(*lc)){
      lc++;
    }
    if(*lc == ')'){
      lc++;
      while(isspace(*lc)){
	lc++;
      }
      return((int)(lc-pnt));
    }
    if(*lc == 'x' || *lc == 'X'){
      li	=ix;
    }
    else{
      if(*lc == 'y' || *lc == 'Y'){
	li	=iy;
      }
      else{
	if(*lc == 'l' || *lc == 'L'){
	  li	=in;
	}
	else{
	  return(-1);
	}
      }
    }
    lc++;
    while(isspace(*lc)){
      lc++;
    }
    if(*lc != '='){
      return(-1);
    }
    lc++;
    while(isspace(*lc)){
      lc++;
    }
    if(sscanf(lc,"%d",*li) < 1){
      return(-1);
    }
    while(isdigit(*lc)){
      lc++;
    }
    while(isspace(*lc)){
      lc++;
    }
    if(*lc == ','){
      lc++;
    }
    if(*lc == '\0'){
      return(-1);
    }
  }while(*lc != ')');
  lc++;
  while(isspace(*lc)){
    lc++;
  }
  return((int)(lc-pnt));
}

int CbGetExtName(char *Str,int *L,char *pnt)
{
  int i;
  char *lc,*lc1;

  lc	=pnt+1;
  i	=0;
  lc1	=Str;
  while(*lc != '"'){
    *lc1++	=*lc++;
    i++;
  }
  *lc1	='\0';
  lc++;
  while(isspace(*lc)){
    lc++;
  }
  *L	=i;
  return((int)(lc-pnt));
}

int CbGetObjUnits(int *iU,int *nU,char *pnt)
{
  int j,i;
  char *lc,*lc1,*lc2,ch;

  lc	=pnt;

  if(*lc != '('){
    *nU	=-1;
    *iU	=0;
    return(0);
  }

  lc++;
  while(isspace(*lc)){
    lc++;
  }
  lc1	=lc;
  while(*lc != '.'){
    lc++;
  }
  *lc	='\0';
  lc++;
  lc2	=lc;
  while(*lc != ')' && !isspace(*lc)){
    lc++;
  }
  ch	=*lc;
  *lc	='\0';
  for(j=0; j < NXUnits; j++){
    if(strcmp(lc1,XUnits[j].nmU) == 0){
      for(i=0; i < XUnits[j].nU; i++){
	if(strcmp(lc2,XUnits[j].U[i]) == 0){
	  break;
	}
      }
      if(i < XUnits[j].nU){
	break;
      }
    }
  }
  if(j < NXUnits && i < XUnits[j].nU){
    *nU	=j;
    *iU	=i;
  }
  else{
    *nU	=-1;
    *iU	=0;
  }
  *(lc2-1)	='.';
  *lc	=ch;
  while(*lc != ')'){
    lc++;
  }
  lc++;
  while(isspace(*lc)){
    lc++;
  }  
  return((int)(lc-pnt));
}

int CbGetIndexList(char *Str,int *L,char *pnt)
{
  char *lc;

  lc	=pnt;
  if(*lc != ','){
    *Str	='\0';
    while(isspace(*lc)){
      lc++;
    }
    return((int)(lc-pnt));
  }

  lc++;
  while(*lc != '"'){
    lc++;
  }
  lc++;
  L	=0;
  while(*lc != '"'){
    *Str++	=*lc++;
    L++;
  }
  *Str	='\0';
  lc++;
  while(isspace(*lc)){
    lc++;
  }
  return((int)(lc-pnt));
}

int CbGetTypeObj(int * iType, int *iV, int *L,char *pnt)
{
  char ch,*lc,*lc1;
  int iCW;

  lc	=pnt;
  lc++;
  while(isspace(*lc)){
    lc++;
  }
  lc1	=lc;
  lc	+=3;

  ch	=*lc;
  *lc= '\0';
  for(iCW=0; iCW < nCW; iCW++){
    if(strcmp(lc1,CW[iCW]) == 0){
      break;
    }
  }	
  if(iCW == 5){
    iCW	=iCW-5;
  }
  if(iCW > 5){
    iCW	=(iCW-5)|16;
  }
  *iType	=iCW;
  *lc	=ch;
  if(*lc == '*'){
    *iV	=1;
    lc++;
  }
  else{
    *iV	=0;
  }
  if(iCW == 0){
    if(*lc != '*'){
      *iV	=0;
    }
    else{
      lc++;
    }
    sscanf(lc,"%d",L);
    while(isdigit(*lc)){
      lc++;
    }
    if(*lc == '*'){
      *iV	=1;
      lc++;
    }
  }
  while(isspace(*lc)){
    lc++;
  }
  lc++;
  while(isspace(*lc)){
    lc++;
  }
  return((int)(lc-pnt));
}

int CbCheckExtName(char *pnt, char *lc0,char *Str,char *NmTblFile)
{
  char *lc;

  lc	=pnt;
  if(*lc != '"'){
    printf("In/%s - no first '\"' in Ext name in %s, line:\n",Str,NmTblFile);
    PPrintLine(lc0,lc);
    return(-1);
  }
  lc++;
  while(*lc != '"' && *lc != '\0'){
    lc++;
  }
  if(*lc != '"'){
    printf("In/%s - no second '\"' in Ext name in %s, line:\n",Str,NmTblFile);
    PPrintLine(lc0,lc);
    return(-11);
  }
  lc++;
  while(isspace(*lc)){
    lc++;
  }

  if(*lc == '('){
    while(*lc != '.' && *lc != ')' && *lc != '=' && *lc != ';' && *lc != '}'
	  && *lc != '\0'){
      lc++;
    }
    if(*lc != '.'){
      printf("In/%s - no '.' in Unit section of %s, line:\n",Str,NmTblFile);
      PPrintLine(lc0,lc);
      return(-1);
    }
    while(*lc != ')' && *lc != '=' && *lc != ';' && *lc != '}' && *lc != '\0'){
      lc++;
    }
    if(*lc != ')'){
      printf("In/%s - no ')' in Unit section of %s, line:\n",Str,NmTblFile);
      PPrintLine(lc0,lc);
      return(-1);
    }
    lc++;
    while(isspace(*lc)){
      lc++;
    }
  }
  if(*lc == ','){
    lc++;
    while(isspace(*lc)){
      lc++;
    }
    if(*lc != '"'){
      printf("In/%s - no '\"' in Index list in %s, line:\n",Str,NmTblFile);
      PPrintLine(lc0,lc);
      return(-1);
    }
    lc++;
    while(*lc != '"' && *lc != '=' && *lc != ';' && *lc != '}' && *lc != '\0'){
      lc++;
    }
    if(*lc != '"'){
      printf("In/%s - no second '\"' in Index list of %s, line:\n"
	     ,Str,NmTblFile);
      PPrintLine(lc0,lc);
      return(-1);
    }
    lc++;
    while(isspace(*lc)){
      lc++;
    }
  }
  return((int)(lc-pnt));
}

int CbCheckType(int * iType, int *iV,char *pnt,char *lc0,char *Str
		,char *NmTblFile)
{
  char ch,*lc,*lc1;
  int iCW,L;

  lc	=pnt;
  lc++;
  while(isspace(*lc)){
    lc++;
  }
  lc1	=lc;
  lc	+=3;

  if(*lc != '*' && *lc != ')' && !isspace(*lc)){
    printf("In/%s - wrong C-Type in %s section, line\n",Str,NmTblFile);
    PPrintLine(lc0,lc);
    return(-1);
  }

  ch	=*lc;
  *lc= '\0';
  for(iCW=0; iCW < nCW; iCW++){
    if(strcmp(lc1,CW[iCW]) == 0){
      break;
    }
  }	
  *iType	=iCW;
  if(iCW == nCW){
    printf("In/%s - wrong C-Type in %s section, line\n",Str,NmTblFile);
    PPrintLine(lc0,lc);
    return(-1);
  }
  *lc	=ch;
  if(*lc == '*'){
    *iV	=1;
    lc++;
  }
  else{
    *iV	=0;
  }
  if(iCW == 0 || iCW == 5){
    if(ch != '*'){
      printf("In/%s - no '*' after 'str'in %s section, line\n"
	     ,Str,NmTblFile);
      PPrintLine(lc0,lc);
      return(-1);
    }
    if(*lc != '*'){
      *iV	=0;
    }
    else{
      lc++;
    }
    if(sscanf(lc,"%d",&L) < 1){
      printf("In/%s - no str length after 'str*'in %s section, line\n",Str,
	     NmTblFile);
      PPrintLine(lc0,lc);
      return(-1);
    }
    while(isdigit(*lc)){
      lc++;
    }
    if(*lc == '*'){
      if(*iV == 1){
	printf("In/%s - Extra '*' in 'str*' type in %s section, line\n",Str,
	       NmTblFile);
	PPrintLine(lc0,lc);
	return(-1);
      }
      *iV	=1;
      lc++;
    }
  }
  while(isspace(*lc)){
    lc++;
  }
  if(*lc != ')'){
    printf("In/%s - no ')' in %s section, line\n",Str,NmTblFile);
    PPrintLine(lc0,lc);
    return(-1);
  }
  lc++;
  while(isspace(*lc)){
    lc++;
  }
  return((int)(lc-pnt));
}

int CbSetInternalName(char **NmP,char *pnt)
{
  int i;
  char *lc,*p;
  
  lc	=pnt;
  i	=0;
  while(*lc != '"'){
    if(!isspace(*lc)){
      i++;
    }
    lc++;
  }

  *NmP	=(char*)malloc((i+1)*sizeof(char));
  p	=*NmP;
  lc	=pnt;
  while(*lc != '"'){
    if(!isspace(*lc)){
      *p++	=*lc;
    }
    lc++;
  }
  *p	='\0';
  lc++;
  while(isspace(*lc)){
    lc++;
  }
  return((int)(lc-pnt));
}

int CbCheckInternalName(char *pnt,char *lc0,char *Str,char *NmTblFile)
{
  int i;
  char *lc;

  lc	=pnt;

  if(*lc != '"'){
    printf("In/%s - no first '\"' in Internal name in %s section, line\n"
	   ,Str,NmTblFile);
    PPrintLine(lc0,lc);
    return(-1);
  }
  lc++;
  i	=0;
  while(*lc != '"' && *lc != ';' && *lc != '\0'){
    if(!isspace(*lc)){
      i++;
    }
    lc++;
  }
  if(i == 0){
    printf("In/%s - empty Internal name in %s, line:\n",Str,NmTblFile);
    PPrintLine(lc0,lc);
    return(-1);
  }
  if(*lc != '"'){
    printf("In/%s - no second '\"' in Internal name in %s section, line:\n"
	   ,Str,NmTblFile);
    PPrintLine(lc0,lc);
    return(-1);
  }
  lc++;
  while(isspace(*lc)){
    lc++;
  }
  return((int)(lc-pnt));
}

int CbSetScale(double *sc,char **ScNm,char *pnt)
{
  int i,j;
  char *lc,*lc1;
  double s;

  lc	=pnt;
  if(*lc != '*' && *lc != '/'){
    return(0);
  }
  lc++;

  while(isspace(*lc)){
    lc++;
  }
  j	=CbCheckIfCName(&i,lc);
  if(j == 1){
    i	=CbCheckIfCNumber(lc);
    sscanf(lc,"%lg",&s);
    if(*pnt == '/'){
      *sc	/=s;
    }
    if(*pnt == '*'){
      *sc	*=s;
    }
    lc	+=i;
  }
  else{
    *ScNm	=(char*)malloc((i+2)*sizeof(char));
    *(*ScNm)	=*pnt;
    lc1		=(*ScNm)+1;
    j	=0;
    while(j < i){
      *lc1++	=*lc++;
      j++;
    }
    *lc1= '\0';
  }
  while(isspace(*lc)){
    lc++;
  }
  return((int)(lc-pnt));
}

int CbCompareScale(double ss, double sc,char *ScNm,char *pnt)
{
  int i,j;
  char *lc;
  double s;

  lc	=pnt;
  if(*lc != '*' && *lc != '/'){
    ss	/=sc;
    if(fabs(ss-1.) > 1e-12){
      return(-1);
    }
    return(0);
  }

  lc++;
  while(isspace(*lc)){
    lc++;
  }

  j	=CbCheckIfCName(&i,lc);
  if(j == 1){
    i	=CbCheckIfCNumber(lc);
    sscanf(lc,"%lg",&s);
    if(*pnt == '/'){
      ss	/=s;
    }
    if(*pnt == '*'){
      ss	*=s;
    }
    s	=ss/sc;
    if(fabs(s-1.) > 1e-12){
      return(-1);
    }
    lc	+=i;
  }
  else{
    if(*pnt != *ScNm){
      return(-1);
    }
    ScNm++;
    if(i != strlen(ScNm) || strncmp(lc,ScNm,i)){
      return(-1);
    }
    lc	+=i;
  }
  while(isspace(*lc)){
    lc++;
  }
  return((int)(lc-pnt));
}


int CbCheckScale(char *pnt,char *lc0,char *Str,char *NmTblFile)
{
  int i,j;
  char *lc;

  lc	=pnt;
  if(*lc != '*' && *lc != '/'){
    return(0);
  }
  lc++;
  while(isspace(*lc)){
    lc++;
  }
  j	=CbCheckIfCName(&i,lc);
  if(j < 0){
    printf("In/%s - wrong scale factor name in %s, line:\n",Str,NmTblFile);
    PPrintLine(lc0,lc);
    return(-1);
  }
  if(j == 1){
    i	=CbCheckIfCNumber(lc);
    if(i < 0){
      printf("In/%s - wrong scale factor in %s, line:\n",Str,NmTblFile);
      PPrintLine(lc0,lc);
      return(-1);
    }
  }
  lc	+=i;
  while(isspace(*lc)){
    lc++;
  }
  return((int)(lc-pnt));
}
int CbSetIndexName(char **IndNm,char *pnt)
{
  int i;
  char *lc,*lc1;

  lc	=pnt;
  while(*lc != '"'){
    lc++;
  }
  lc++;
  lc1	=lc;
  i	=0;
  while(*lc != '"'){
    if(!isspace(*lc)){
      i++;
    }
    lc++;
  }
  *IndNm	=(char*)malloc((i+1)*sizeof(char));
  lc	=lc1;
  lc1	=*IndNm;
  while(*lc != '"'){
    if(!isspace(*lc)){
      *lc1++	=*lc;
    }
    lc++;
  }
  *lc1	='\0';
  lc++;
  while(isspace(*lc)){
    lc++;
  }
  return((int)(lc-pnt));
}

int CbCompareIndexName(char *Nm,char *pnt)
{
  char *lc,*lc1;

  lc	=pnt+1;
  if(Nm == NULL){
    return(-1);
  }
  while(*lc != '"'){
    lc++;
  }
  lc++;
  lc1	=Nm;
  while(*lc != '"'){
    if(!isspace(*lc)){
      if(*lc1 != *lc){
	return(-1);
      }
      lc1++;
    }
    lc++;
  }
  lc++;
  while(isspace(*lc)){
    lc++;
  }
  return((int)(lc-pnt));
}

int CbCheckIndexName(char *pnt,char *lc0,char *Str,char *NmTblFile)
{
  char *lc;

  lc	=pnt;
  if(*lc != '"'){
    printf("In/%s - no first '\"' in Index Name in %s, line:\n",Str,NmTblFile);
    PPrintLine(lc0,lc);
    return(-1);
  }
  lc++;
  while(*lc != '"' && *lc != ';' && *lc != '}' && *lc != '\0'){
    lc++;
  }
  if(*lc != '"'){
    printf("In/%s - no second '\"' in Index Name in %s, line\n",Str,NmTblFile);
    PPrintLine(lc0,lc);
    return(-1);
  }
  lc++;
  while(isspace(*lc)){
    lc++;
  }
  return((int)(lc-pnt));
}

int CbCheckTblObj(char *pnt,char *lc0,char *Str,char *NmTblFile)
{
  int i;
  char *lc;

  lc	=pnt;

  if((i=CbCheckExtName(lc,lc0,Str,NmTblFile)) < 0){
    return(1);
  }
  lc 	+=i;
  if(*lc != '='){
    printf("In/%s - no '=' in Tbl, line:\n",NmTblFile);
    PPrintLine(lc0,lc);
    return(1);
  }
  lc++;
  while(isspace(*lc)){
    lc++;
  }
  return((int)(lc-pnt));
}

int CbGetTblStructure(char *NmTblFile,int iT)
{
  char ch,*pnt0,*pnt,*pnt1,*pnt2,Str[4]="Tbl",Index[32];
  int nL,nP,nM,nPC,nV,nNmV,nNmVC,iIndex;

  int ic,ip,iv,im,imm,immm,i,j,len,k,k1,k2,n;
  int Flp,Flv,Flm,Flstar;
  int iCW;
  int iU,nU,Lstr;
  int ix,iy,in;
  double s;

  pnt0	=BuffIO[0];
  pnt	=pnt0;
  ic	=0;
  ip	=0;
  iv	=0;
  im	=0;
  imm	=0;
  immm	=0;
  Flp	=0;
  Flv	=0;
  Flm	=0;
  Flstar=0;
  nM	=0;
  nP	=0;
  nPC	=0;
  nV	=0;
  nNmV	=0;
  nNmVC	=0;
  nL	=0;

  if((pnt=TblHeadSyntaxCheck(pnt,NmTblFile,Tbl+iT)) == NULL){
    printf("In/%s - Wrong Head in Tbl section, line:\n",NmTblFile);
    PPrintLine(pnt0,pnt);
    return(1);
  }
  if(*pnt != '{'){
    printf("In/%s - no '{' after Tbl attributes, line:\n",NmTblFile);
    PPrintLine(pnt0,pnt);
    return(1);
  }

  while(*pnt != '\0'){
    ch	=*pnt;
    if(ch == '"'){
      if((i=CbCheckTblObj(pnt,pnt0,Str,NmTblFile)) < 0){
	return(1);
      }
      pnt 	+=i;
      switch(*pnt){
      case '(':
	if((i=CbCheckType(&iCW,&Flstar,pnt,pnt0,Str,NmTblFile)) < 0){
	  return(1);
	}
	pnt 	+=i;
	if(*pnt == '('){
	  i	=CbGetParCellOptions(&ix,&iy,&in,pnt);
	  if(i < 0){
	    printf("In/%s - wrong parameter option in Tbl section, line\n"
		   ,NmTblFile);
	    PPrintLine(pnt0,pnt);
	    return(1);
	  }
	  pnt	+=i;
	}
	if((i=CbCheckInternalName(pnt,pnt0,Str,NmTblFile)) < 0){
	  return(1);
	}
	pnt 	+=i;
	if((i=CbCheckScale(pnt,pnt0,Str,NmTblFile)) < 0){
	  return(1);
	}
	pnt 	+=i;
	if(*pnt == ','){
	  pnt++;
	  while(isspace(*pnt)){
	    pnt++;
	  }
	  if((i=CbCheckIndexName(pnt,pnt0,Str,NmTblFile)) < 0){
	    return(1);
	  }
	  pnt 	+=i;
	}
	if(*pnt != ';'){
	  printf("In/%s - no ';' in Tbl, line:\n",NmTblFile);
	  PPrintLine(pnt0,pnt);
	  return(1);
	}
	if(Flp && Flstar == 0){
	  nP++;
	  nPC++;
	}
	if(Flv && Flstar){
	  nV++;
	  nNmV++;
	  nL++;
	  nNmVC++;
	}
	break;
      case '{':
	if(Flp){
	  nP++;
	}
	if(Flv){
	  nNmV++;
	}
	nM++;
	break;
      case '"':
	if((i=CbCheckInternalName(pnt,pnt0,Str,NmTblFile)) < 0){
	  return(1);
	}
	pnt 	+=i;
	if(Flp){
	  nP++;
	}
	if(Flv){
	  nV++;
	  nNmV++;
	}
	if((i=CbCheckScale(pnt,pnt0,Str,NmTblFile)) < 0){
	  return(1);
	}
	pnt 	+=i;
	if(*pnt == ','){
	  pnt++;
	  while(isspace(*pnt)){
	    pnt++;
	  }
	  if((i=CbCheckIndexName(pnt,pnt0,Str,NmTblFile)) < 0){
	    return(1);
	  }
	  pnt 	+=i;
	}
	if(*pnt != ';'){
	  printf("In/%s - no ';' in Tbl, line:\n",NmTblFile);
	  PPrintLine(pnt0,pnt);
	  return(1);
	}
	break;
      default:
	printf("In/%s - no '(' or '{' or '\"' after '=' in Tbl, line:\n"
	       ,NmTblFile);
	PPrintLine(pnt0,pnt);
	return(1);
	break;
      }
    }
    else if(!isspace(ch) && ch != '}' && ic){
      while(*pnt != '=' && *pnt != '}' && *pnt != '\0'){
	pnt++;
      }
      if(*pnt != '='){
	printf("In/%s - no '=' in Tbl, line:\n",NmTblFile);
	PPrintLine(pnt0,pnt);
	return(1);
      }
      nM++;
      pnt++;
      while(isspace(*pnt)){
	pnt++;
      }
      if((i=CbCheckType(&iCW,&Flstar,pnt,pnt0,Str,NmTblFile)) < 0){
	return(1);
      }
      pnt 	+=i;
      if(*pnt == '('){
	i	=CbGetParCellOptions(&ix,&iy,&in,pnt);
	if(i < 0){
	  printf("In/%s - wrong Menu option in Tbl section, line\n"
		 ,NmTblFile);
	  PPrintLine(pnt0,pnt);
	  return(1);
	}
	pnt	+=i;
      }
      if(*pnt != '{'){
	printf("In/%s - no '{' in Tbl, line:\n",NmTblFile);
	PPrintLine(pnt0,pnt);
	return(1);
      }
      Flm	=1;
      if(Flstar){
	Flp	=0;
	nL++;
      }
      else{
	Flv= 0;
      }
    }
    ch	=*pnt;
    if(ch == '{'){
      if(Flp){
	ip++;
      }
      if(Flv){
	iv++;
      }
      if(Flm){
	im++;
	if(im>imm){
	  imm= im;
	}
      }
      if(ic == 0){
	Flp	=1;
	Flv	=1;
      }
      ic++;
    }
    if(ch == '}'){
      ic--;
      if(ic == 0){
	Flp	=0;
	Flv	=0;
      }
      if(Flp){
	ip--;
      }
      if(Flv){
	iv--;
      }
      if(Flm){
	im--;
	if(im == 0){
	  if(Flp){
	    nPC	+=imm;
	  }
	  if(Flv){
	    nNmVC	+=imm;
	  }
	  Flp	=1;
	  Flv	=1;
	  Flm	=0;
	  if(immm < imm){
	    immm	=imm;
	  }
	  imm	=0;
	}
      }
    }
    pnt++;
  }
  if(ic){
    if(ic > 0){
      printf("In/%s - extra  %d '{' in Tbl section\n",NmTblFile,ic);
      if(ip){
	if(ip > 0)
	  printf("extra  %d '{' in parameter section\n",ip);
	if(ip < 0)
	  printf("extra  %d '}' in parameter section\n",-ip);
      }
      if(iv){
	if(iv > 0)
	  printf("extra  %d '{' in vector section\n",iv);
	if(iv < 0)
	  printf("extra  %d '}' in vector section\n",-iv);
      }
    }
    if(ic < 0){
      printf("In/%s - extra  %d '}' in Tbl section\n",NmTblFile,-ic);
      if(ip){
	if(ip > 0)
	  printf("extra  %d '{' in parameter section\n",ip);
	if(ip < 0)
	  printf("extra  %d '}' in parameter section\n",-ip);
      }
      if(iv){
	if(iv > 0)
	  printf("extra  %d '{' in vector section\n",iv);
	if(iv < 0)
	  printf("extra  %d '}' in vector section\n",-iv);
      }
    }
    return(1);
  }
  if(ip){
    if(ip > 0)
      printf("In/%s - extra  %d '{' in Tbl parameter section\n",NmTblFile,ip);
    if(ip < 0)
      printf("In/%s - extra  %d '}' in Tbl parameter section\n",NmTblFile,-ip);
    return(1);
  }
  if(iv){
    if(iv > 0)
      printf("In/%s - extra  %d '{' in Tbl vector section\n",NmTblFile,iv);
    if(iv < 0)
      printf("In/%s - extra  %d '}' in Tbl vector section\n",NmTblFile,-iv);
    return(1);
  }

  if(nP == 0 && nV == 0){
    printf("%s - No parameters or vectors in Tbl section\n",NmTblFile);
    return(1);
  }

  Tbl[iT].mode	=0;
  Tbl[iT].nL	=nL < Tbl[iT].nL ? Tbl[iT].nL : nL;
  Tbl[iT].NM	=nM;
  Tbl[iT].NP	=nP;
  Tbl[iT].NPC	=nPC;
  Tbl[iT].nP	=(int*)malloc(9*nP*sizeof(int));
  Tbl[iT].nUP	=Tbl[iT].nP+nP;
  Tbl[iT].iUP	=Tbl[iT].nUP+nP;
  Tbl[iT].iCP	=Tbl[iT].iUP+nP;
  Tbl[iT].iPP	=Tbl[iT].iCP+nP;
  Tbl[iT].cP	=Tbl[iT].iPP+nP;
  Tbl[iT].ixP	=Tbl[iT].cP+nP;
  Tbl[iT].iyP	=Tbl[iT].ixP+nP;
  Tbl[iT].inP	=Tbl[iT].iyP+nP;
  Tbl[iT].nmP	=(char**)malloc((8*nP+nM)*sizeof(char*));
  Tbl[iT].aP	=Tbl[iT].nmP+nP;
  Tbl[iT].nmEP	=Tbl[iT].aP+nP;
  Tbl[iT].aEP	=Tbl[iT].nmEP+nP;
  Tbl[iT].HlpP	=Tbl[iT].aEP+nP;
  Tbl[iT].ScpP	=Tbl[iT].HlpP+nP;
  Tbl[iT].P	=Tbl[iT].ScpP+nP;
  Tbl[iT].P1	=Tbl[iT].P+nP;
  Tbl[iT].nmM	=Tbl[iT].P1+nP;
  Tbl[iT].vaP	=(int**)malloc(nP*sizeof(int*));
  for(i=0; i < nM; i++){
    Tbl[iT].nmM[i]	=NULL;
  }
  for(i=0; i < nP; i++){
    Tbl[iT].aEP[i]	=NULL;
    Tbl[iT].ScpP[i]	=NULL;
    Tbl[iT].aP[i]	=NULL;
    Tbl[iT].vaP[i]	=NULL;
    Tbl[iT].HlpP[i]	=NULL;
  }

  Tbl[iT].scP	=(double*)malloc(nP*sizeof(double));
  Tbl[iT].NNmV	=nNmV;
  Tbl[iT].NNmVC	=nNmVC;
  Tbl[iT].NV	=nV;
  Tbl[iT].nmV	=(char**)malloc(7*nNmV*sizeof(char*));
  Tbl[iT].aV	=Tbl[iT].nmV+nNmV;
  Tbl[iT].nmEV	=Tbl[iT].aV+nNmV;
  Tbl[iT].nmEVs	=Tbl[iT].nmEV+nNmV;
  Tbl[iT].aEV	=Tbl[iT].nmEVs+nNmV;
  Tbl[iT].HlpV	=Tbl[iT].aEV+nNmV;
  Tbl[iT].ScpV	=Tbl[iT].HlpV+nNmV;
  Tbl[iT].nNmV	=(int*)malloc(9*nNmV*sizeof(int));
  Tbl[iT].LaV	=Tbl[iT].nNmV+nNmV;
  Tbl[iT].laV	=Tbl[iT].LaV+nNmV;
  Tbl[iT].LV	=Tbl[iT].laV+nNmV;
  Tbl[iT].lV	=Tbl[iT].LV+nNmV;
  Tbl[iT].iCV	=Tbl[iT].lV+nNmV;
  Tbl[iT].nUV	=Tbl[iT].iCV+nNmV;
  Tbl[iT].iUV	=Tbl[iT].nUV+nNmV;
  Tbl[iT].iPV	=Tbl[iT].iUV+nNmV;
  Tbl[iT].V	=(char***)malloc(2*nNmV*sizeof(char**));
  Tbl[iT].V1	=Tbl[iT].V+nNmV;
  Tbl[iT].vaV	=(int***)malloc(nNmV*sizeof(int**));
  Tbl[iT].cV	=(int**)malloc(nNmV*sizeof(int*));
  Tbl[iT].scV	=(double*)malloc(nNmV*sizeof(double));
  for(i=0; i < nNmV; i++){
    Tbl[iT].aEV[i]	=NULL;
    Tbl[iT].ScpV[i]	=NULL;
    Tbl[iT].LV[i]	=0;
    Tbl[iT].lV[i]	=0;
    Tbl[iT].LaV[i]	=0;
    Tbl[iT].laV[i]	=0;
    Tbl[iT].nmV[i]	=NULL;
    Tbl[iT].nmEV[i]	=NULL;
    Tbl[iT].HlpV[i]	=NULL;
    Tbl[iT].V[i]	=NULL;
    Tbl[iT].cV[i]	=NULL;
    Tbl[iT].aV[i]	=NULL;
    Tbl[iT].vaV[i]	=NULL;
    Tbl[iT].scV[i]	=1.;
  }
  if(immm >= kMI){
    kMI	=immm;
    nMI	=(int*)realloc((void*)nMI,2*kMI*sizeof(int));
    iMI	=nMI+kMI;
  }
  pnt	=BuffIO[0];
  ic	=0;
  ip	=0;
  iv	=0;
  im	=0;
  imm	=0;
  Flp	=0;
  Flv	=0;
  Flm	=0;
  Flstar=0;
  nM	=0;
  nP	=0;
  nPC	=0;
  nV	=0;
  nNmV	=0;
  nNmVC	=0;
  *Index='\0';
  while(*pnt != '{'){
    pnt++;
  }
  while(*pnt != '\0'){
    ch	=*pnt;
    if(ch == '"'){
      pnt	+=CbGetExtName(ln,&len,pnt);
      pnt	+=CbGetObjUnits(&iU,&nU,pnt);
      pnt	+=CbGetIndexList(Index,&iIndex,pnt);
      pnt++;
      while(isspace(*pnt)){
	pnt++;
      }
      switch(*pnt){
      case '(':
	pnt	+=CbGetTypeObj(&iCW,&Flstar,&Lstr,pnt);
	ix	=0;
	iy	=0;
	in	=0;
	if(*pnt == '('){
	  pnt	+=CbGetParCellOptions(&ix,&iy,&in,pnt);
	}
	while(*pnt != '"'){
	  pnt++;
	}
	pnt++;
	if(Flp && Flstar == 0){
	  Tbl[iT].nmEP[nP]	=(char*)malloc((len+1)*sizeof(char));
	  strcpy(Tbl[iT].nmEP[nP],ln);
	  if(*Index != '\0'){
	    Tbl[iT].aEP[nP]	=(char*)malloc((iIndex+1)*sizeof(char));
	    strcpy(Tbl[iT].aEP[nP],Index);
	    *Index	='\0';
	  }
	  Tbl[iT].iCP[nP]	=iCW;
	  Tbl[iT].nP[nP]	=1;
	  Tbl[iT].nUP[nP]	=nU;
	  Tbl[iT].iUP[nP]	=iU;
	  if(iCW == 0){
	    Tbl[iT].iUP[nP]	=Lstr;
	    Tbl[iT].P1[nP]	=(char*)malloc((Lstr+1)*sizeof(char));
	  }
	  CbSetUnitScale(Tbl[iT].scP+nP,nU,iU);
	  Tbl[iT].iPP[nP]	=(iCW&16) ? 1 : 0;
	  Tbl[iT].cP[nP]	=0;
	  pnt	+=CbSetInternalName(Tbl[iT].nmP+nP,pnt);
	  pnt	+=CbSetScale(Tbl[iT].scP+nP,Tbl[iT].ScpP+nP,pnt);
	  if(*pnt == ','){
	    pnt	+=CbSetIndexName(Tbl[iT].aP+nP,pnt);
	  }
	  nP++;
	}
	if(Flv && Flstar){
	  Tbl[iT].nmEV[nNmV]	=(char*)malloc(2*(len+1)*sizeof(char));
	  Tbl[iT].nmEVs[nNmV]	=Tbl[iT].nmEV[nNmV]+len+1;
	  strcpy(Tbl[iT].nmEV[nNmV],ln);
	  strcpy(Tbl[iT].nmEVs[nNmV],ln);
	  if(*Index != '\0'){
	    Tbl[iT].aEV[nNmV]	=(char*)malloc((iIndex+1)*sizeof(char));
	    strcpy(Tbl[iT].aEV[nNmV],Index);
	    Tbl[iT].LaV[nNmV]	=1;
	    Tbl[iT].laV[nNmV]	=1;
	    *Index	='\0';
	  }
	  Tbl[iT].LV[nNmV]	=0;
	  Tbl[iT].lV[nNmV]	=0;
	  Tbl[iT].iCV[nNmV]	=iCW;
	  Tbl[iT].nNmV[nNmV]	=1;
	  Tbl[iT].nUV[nNmV]	=nU;
	  Tbl[iT].iUV[nNmV]	=iU;

	  if(iCW == 0){
	    Tbl[iT].iUV[nNmV]	=Lstr;
	  }
	  CbSetUnitScale(Tbl[iT].scV+nNmV,nU,iU);
	  Tbl[iT].iPV[nNmV]	=(iCW&16) ? 1 : 0;
	  pnt	+=CbSetInternalName(Tbl[iT].nmV+nNmV,pnt);
	  CbNmV2(&k,ln,Tbl[iT].nmV[nNmV]);
	  n	=0;
	  for(i=0; i < k; i++){
	    if(VecNm[i].pi0 == NULL && VecNm[i].pi1 == NULL){
	      n	+=(VecNm[i].i1-VecNm[i].i0)*VecNm[i].k;
	    }
	  }
	  if(Tbl[iT].iPV[nNmV]){
	    n	+=2;
	  }
	  if(n == 0){
	    n	=1;
	  }
	  CbMem4TblVector(nNmV,iT,n);
	  pnt	+=CbSetScale(Tbl[iT].scV+nNmV,Tbl[iT].ScpV+nNmV,pnt);
	  if(*pnt == ','){
	    pnt	+=CbSetIndexName(Tbl[iT].aV+nNmV,pnt);
	    CbNmV2(&k,ln,Tbl[iT].aV[nNmV]);
	    n	=0;
	    for(i=0; i < k; i++){
	      if(VecNm[i].pi0 == NULL && VecNm[i].pi1 == NULL){
		n	+=(VecNm[i].i1-VecNm[i].i0)*VecNm[i].k;
	      }
	    }
	    if(n == 0){
	      n	=1;
	    }
	    CbMem4TblVectorInd(nNmV,iT,n);
	  }
	  nV++;
	  nNmV++;
	}
	break;
      case '{':
	if(Flp){
	  Tbl[iT].nmEP[nP]= (char*)malloc((len+1)*sizeof(char));
	  strcpy(Tbl[iT].nmEP[nP],ln);
	  Tbl[iT].iCP[nP]= 0;
	  Tbl[iT].nP[nP]= 0;
	  Tbl[iT].nUP[nP]= nU;
	  Tbl[iT].iUP[nP]= iU;
	  Tbl[iT].iPP[nP]= 0;
	  Tbl[iT].cP[nP]= 0;
	  Tbl[iT].P[nP]= NULL;
	  Tbl[iT].P1[nP]= NULL;
	  CbSetUnitScale(Tbl[iT].scP+nP,nU,iU);
	  Tbl[iT].nmP[nP]	=NULL;
	  nP++;
	}
	if(Flv){
	  Tbl[iT].nmEV[nNmV]	=(char*)malloc(2*(len+1)*sizeof(char));
	  Tbl[iT].nmEVs[nNmV]	=Tbl[iT].nmEV[nNmV]+len+1;
	  strcpy(Tbl[iT].nmEV[nNmV],ln);
	  strcpy(Tbl[iT].nmEVs[nNmV],ln);
	  Tbl[iT].LV[nNmV]= 0;
	  Tbl[iT].lV[nNmV]= 0;
	  Tbl[iT].cV[nNmV]= (int*)malloc(sizeof(int));
	  Tbl[iT].cV[nNmV][0]= 0;
	  Tbl[iT].iCV[nNmV]= 0;
	  Tbl[iT].nNmV[nNmV]= 0;
	  Tbl[iT].nUV[nNmV]= nU;
	  Tbl[iT].iUV[nNmV]= iU;
	  Tbl[iT].iPV[nNmV]= 0;
	  Tbl[iT].nmV[nNmV]= NULL;
	  Tbl[iT].V[nNmV]= NULL;
	  Tbl[iT].V1[nNmV]= NULL;
	  nNmV++;
	}
	Tbl[iT].nmM[nM]	=(char*)malloc((len+1)*sizeof(char));
	strcpy(Tbl[iT].nmM[nM],ln);
	for(i=0; i < nM; i++){
	  if(strcmp(Tbl[iT].nmM[i],ln) == 0){
	    printf("In/%s - M-name <%s> has been used already in Tbl, line:\n"
		   ,NmTblFile,ln);
	    PPrintLine(pnt0,pnt);
	    return(1);
	  }
	}
	nM++;
	nMI[im-1]++;
	break;
      case '"':
	pnt++;
	if(Flp){
	  Tbl[iT].nmEP[nP]= (char*)malloc((len+1)*sizeof(char));
	  strcpy(Tbl[iT].nmEP[nP],ln);
	  if(*Index != '\0'){
	    Tbl[iT].aEP[nP]= (char*)malloc((iIndex+1)*sizeof(char));
	    strcpy(Tbl[iT].aEP[nP],Index);
	    *Index	='\0';
	  }
	  Tbl[iT].iCP[nP]	=iCW;
	  Tbl[iT].nP[nP]	=0;
	  Tbl[iT].nUP[nP]	=nU;
	  Tbl[iT].iUP[nP]	=iU;
	  if(iCW == 0){
	    Tbl[iT].iUP[nP]= Lstr;
	    Tbl[iT].P1[nP]= (char*)malloc((Lstr+1)*sizeof(char));
	  }
	  CbSetUnitScale(Tbl[iT].scP+nP,nU,iU);
	  Tbl[iT].iPP[nP]= iCW&16?1:0;
	  Tbl[iT].cP[nP]= 0;
	  pnt	+=CbSetInternalName(Tbl[iT].nmP+nP,pnt);
	  pnt	+=CbSetScale(Tbl[iT].scP+nP,Tbl[iT].ScpP+nP,pnt);
	  if(*pnt == ','){
	    pnt	+=CbSetIndexName(Tbl[iT].aP+nP,pnt);
	  }
	  nP++;
	}
	if(Flv){
	  Tbl[iT].nmEV[nNmV]= (char*)malloc(2*(len+1)*sizeof(char));
	  Tbl[iT].nmEVs[nNmV]	=Tbl[iT].nmEV[nNmV]+len+1;
	  strcpy(Tbl[iT].nmEV[nNmV],ln);
	  strcpy(Tbl[iT].nmEVs[nNmV],ln);
	  if(*Index != '\0'){
	    Tbl[iT].aEV[nNmV]= (char*)malloc((iIndex+1)*sizeof(char));
	    strcpy(Tbl[iT].aEV[nNmV],Index);
	    Tbl[iT].LaV[nNmV]= 1;
	    Tbl[iT].laV[nNmV]= 1;
	    *Index	='\0';
	  }
	  Tbl[iT].LV[nNmV]	=0;
	  Tbl[iT].lV[nNmV]	=0;
	  Tbl[iT].iCV[nNmV]	=iCW;
	  Tbl[iT].nNmV[nNmV]	=0;
	  Tbl[iT].nUV[nNmV]	=nU;
	  Tbl[iT].iUV[nNmV]	=iU;
	  if(iCW == 0){
	    Tbl[iT].iUV[nNmV]= Lstr;
	  }
	  CbSetUnitScale(Tbl[iT].scV+nNmV,nU,iU);
	  Tbl[iT].iPV[nNmV]= iCW&16?1:0;
	  pnt	+=CbSetInternalName(Tbl[iT].nmV+nNmV,pnt);
	  CbNmV2(&k,ln,Tbl[iT].nmV[nNmV]);
	  n	=0;
	  for(i=0; i < k; i++){
	    if(VecNm[i].pi0 == NULL && VecNm[i].pi1 == NULL){
	      n	+=(VecNm[i].i1-VecNm[i].i0)*VecNm[i].k;
	    }
	  }
	  if(Tbl[iT].iPV[nNmV]){
	    n	+=2;
	  }
	  if(n == 0){
	    n	=1;
	  }
	  CbMem4TblVector(nNmV,iT,n);
	  pnt	+=CbSetScale(Tbl[iT].scV+nNmV,Tbl[iT].ScpV+nNmV,pnt);
	  if(*pnt == ','){
	    pnt	+=CbSetIndexName(Tbl[iT].aV+nNmV,pnt);
	    CbNmV2(&k,ln,Tbl[iT].aV[nNmV]);
	    n=0;
	    for(i=0; i < k; i++){
	      if(VecNm[i].pi0 == NULL && VecNm[i].pi1 == NULL){
		n	+=(VecNm[i].i1-VecNm[i].i0)*VecNm[i].k;
	      }
	    }
	    if(n == 0){
	      n= 1;
	    }
	    CbMem4TblVectorInd(nNmV,iT,n);
	  }
	  nV++;
	  nNmV++;
	}
	nMI[im-1]++;
	break;
      default:
	break;
      }
    }
    else if(!isspace(ch) && ch != '}' && ic){
      i= 0;
      pnt1	=pnt;
      while(!isspace(*pnt)&&*pnt != '='){
	i++;
	pnt++;
      }
      Tbl[iT].nmM[nM]	=(char*)malloc((i+1)*sizeof(char));
      pnt	=pnt1;
      pnt1	=Tbl[iT].nmM[nM];
      while(!isspace(*pnt) && *pnt != '='){
	*pnt1= *pnt;
	pnt1++;
	pnt++;
      }
      *pnt1	='\0';
      pnt1	=Tbl[iT].nmM[nM];
      for(i=0; i < nM; i++){
	if(strcmp(Tbl[iT].nmM[i],pnt1) == 0){
	  printf("In/%s - M-name <%s> has been used already in Tbl, line:\n"
		 ,NmTblFile,pnt1);
	  PPrintLine(pnt0,pnt);
	  return(1);
	}
      }
      nM++;
      while(*pnt != '('){
	pnt++;
      }
      pnt	+=CbGetTypeObj(&iCW,&Flstar,&Lstr,pnt);
      while(*pnt != '{'){
	pnt++;
      }
      if(Flstar){
	Flp= 0;
      }
      else{
	Flv= 0;
      }
      Flm= 1;
    }

    ch= *pnt;
    if(ch == '{'){
      if(Flp)
	ip++;
      if(Flv)
	iv++;
      if(Flm){
	if(Flp)
	  iMI[im]= nP;
	if(Flv)
	  iMI[im]= nNmV;
	nMI[im]= 0;
	im++;
	if(im>imm)
	  imm= im;
      }
      if(ic == 0){
	Flp= 1;
	Flv= 1;
      }
      ic++;
    }
    if(ch == '}'){
      ic--;
      if(ic == 0){
	Flp= 0;
	Flv= 0;
      }
      if(Flp)
	ip--;
      if(Flv)
	iv--;
      if(Flm){
	im--;
	i= iMI[im];
	if(Flp){
	  Tbl[iT].nP[i]= nMI[im];
	  if(im+1 == imm){
	    Tbl[iT].iCP[i]|= 8;
	  }
	  else{
	    Tbl[iT].iCP[i]= 8;
	    Tbl[iT].iPP[i]= 0;
	  }
	}
	if(Flv){
	  Tbl[iT].nNmV[i]= nMI[im];
	  if(im+1 == imm)
	    Tbl[iT].iCV[i]|= 8;
	  else{
	    Tbl[iT].iCV[i]= 8;
	    Tbl[iT].iPV[i]= 0;
	  }
	}
	if(im == 0){
	  if(Flp)
	    nPC	+=imm;
	  if(Flv)
	    nNmVC	+=imm;
	  Flp= 1;
	  Flv= 1;
	  Flm= 0;
	  imm= 0;
	}
      }
    }
    pnt++;
  }
  return(0);
}

int CbDeInitUnits()
{
  int i,j;

  for(i=0; i < NXUnits; i++){
    if(XUnits[i].nU){
      for(j=0; j < XUnits[i].nU; j++){
	free(XUnits[i].U[j]);
      }
      free(XUnits[i].scU);
      free(XUnits[i].U);
    }
  }
  free(XUnits);
  XUnits	=NULL;
  NXUnits	=0;
  return(0);
}

int CbReadXUnits()
{
  char *NmF;
  FILE *lf;
  char ln[132],*p,*p1,*p2;
  double sc;
  int i,j,n;

  NmF	="In/Units";
  lf	=fopen(NmF,"r");
  if(lf == NULL){
    return(1);
  }
  NXUnits	=0;
  while(fgets(ln,132,lf) == ln){
    p	=ln;
    while(isspace(*p)){
      p++;
    }
    while(*p != ':' && *p != '\0'){
      p++;
    }
    if(*p == ':'){
      NXUnits++;
    }
    else{
      continue;
    }
  }
  XUnits	=(CbUnits*)malloc(NXUnits*sizeof(CbUnits));
  if(XUnits == NULL){
    FailureAlarm((char*)XUnits," - no memory for XUnits in CbReadXUnits()");
    return(1);
  }
  for(i=0; i < NXUnits; i++){
    XUnits[i].nU	=0;
  }
  rewind(lf);
  i	=0;
  while(fgets(ln,132,lf) == ln){
    p	=ln;
    while(isspace(*p)){
      p++;
    }
    p1	=p;
    while(*p != ':' && *p != '\0'){
      p++;
    }
    if(*p == ':'){
      *p	='\0';
      CbStrCpy(XUnits[i].nmU,p1);
    }
    else{
      continue;
    }
    p++;
    p2	=p;
    n	=0;
    while(*p != ';' && *p != '\0'){
      if(*p == '('){
	p++;
	p1	=XUnits[i].nmU;
	while(*p == *p1){
	  p++;
	  p1++;
	}
	if(*p != '.' || *p1 != '\0'){
	  printf("%s - Bad Units format in line\n%s%c:\n",NmF,ln,7);
	  CbDeInitUnits();
	  fclose(lf);
	  return(1);
	}
	p++;
	while(*p != ')' && *p != '\0'){
	  p++;
	}
	if(*p != ')'){
	  printf("%s - Bad Units format in line\n%s%c:\n",NmF,ln,7);
	  CbDeInitUnits();
	  fclose(lf);
	  return(1);
	}
	n++;
      }
      p++;
    }
    if(*p != ';'){
      printf("%s - Bad Units format in line\n%s%c:\n",NmF,ln,7);
      CbDeInitUnits();
      fclose(lf);
      return(1);
    }
    XUnits[i].nU	=n;
    XUnits[i].U		=(char**)malloc(2*n*sizeof(char*));
    XUnits[i].TU	=XUnits[i].U+n;
    XUnits[i].Ln	=4;
    XUnits[i].U[0]	="";
    XUnits[i].scU	=(double*)malloc(n*sizeof(double));
    XUnits[i].scU[0]	=1.;
    XUnits[i].sc	=1.;
    XUnits[i].rsc	=1.;
    XUnits[i].iU	=0;
    p	=p2;
    n	=0;
    while(*p != ';'){
      if(*p == '.'){
	p++;
	p1	=(char*)malloc(32*sizeof(char));
	XUnits[i].U[n]	=p1;
	XUnits[i].TU[n]	=p1+16;
	while(*p != ')'){
	  *p1++	=*p++;
	}
	*p1	='\0';
	sprintf(XUnits[i].TU[n],"%4s",XUnits[i].U[n]);
	n++;
      }
      p++;
    }
    XUnits[i].pntU	=XUnits[i].TU[0];
    p++;
    j	=n;
    sc	=1.;
    for(j=0; j < n; j++){
      if(fscanf(lf,"%lg",XUnits[i].scU+j) < 1){
	printf("%s - Bad Scale format after line\n%s%c:\n",NmF,ln,7);
	CbDeInitUnits();
	fclose(lf);
      }
      if(j == 0){
	XUnits[i].scU[j]	=1.;
      }
      else{
	if(j < n-1){
	  sc	*=XUnits[i].scU[j];
	}
	else{
	  XUnits[i].scU[j]	=1./sc;
	}
      }
    }
    if(fgets(ln,132,lf) != ln){
      printf("%s - Bad Scale format, line\n%s%c:\n",NmF,ln,7);
      CbDeInitUnits();
      fclose(lf);
    }
    i++;
  }    
  fclose(lf);

  printf("%s was used for initialization of Units\n",NmF);
  return(0);
}

int CbInitUnits()
{
  int i,j;

  if(CbReadXUnits()){
    NXUnits= 13;
    XUnits= (CbUnits*)malloc(NXUnits*sizeof(CbUnits));
    FailureAlarm((char*)XUnits," - no memory for XUnits in CbInitUnits");
    i= 0;
    strcpy(XUnits[i].nmU,"1");
    XUnits[i].nU= 1;
    i= 1;
    strcpy(XUnits[i].nmU,"t");
    XUnits[i].nU= 3;
    i= 2;
    strcpy(XUnits[i].nmU,"L");
    XUnits[i].nU= 3;
    i= 3;
    strcpy(XUnits[i].nmU,"B");
    XUnits[i].nU= 4;
    i= 4;
    strcpy(XUnits[i].nmU,"I");
    XUnits[i].nU= 4;
    i= 5;
    strcpy(XUnits[i].nmU,"V");
    XUnits[i].nU= 3;
    i= 6;
    strcpy(XUnits[i].nmU,"gY");
    XUnits[i].nU= 3;
    i= 7;
    strcpy(XUnits[i].nmU,"p");
    XUnits[i].nU= 3;
    i= 8;
    strcpy(XUnits[i].nmU,"n");
    XUnits[i].nU= 5;
    i= 9;
    strcpy(XUnits[i].nmU,"T");
    XUnits[i].nU= 5;
    i= 10;
    strcpy(XUnits[i].nmU,"j");
    XUnits[i].nU= 4;
    i= 11;
    strcpy(XUnits[i].nmU,"m");
    XUnits[i].nU= 3;
    i= 12;
    strcpy(XUnits[i].nmU,"R");
    XUnits[i].nU= 4;

    for(i= 0;i<NXUnits;i++){
      XUnits[i].U= (char**)malloc(2*XUnits[i].nU*sizeof(char*));
      XUnits[i].TU= XUnits[i].U+XUnits[i].nU;
      XUnits[i].Ln= 4;
      XUnits[i].U[0]= "";
      XUnits[i].scU= (double*)malloc(XUnits[i].nU*sizeof(double));
      XUnits[i].scU[0]= 1.;
      XUnits[i].sc= 1.;
      XUnits[i].rsc= 1.;
    }

    i= 1;
    XUnits[i].U[1]= "sec";
    XUnits[i].U[2]= "msec";
    XUnits[i].scU[1]= 1000.;
    XUnits[i].scU[2]= 0.001;
    i= 2;
    XUnits[i].U[1]= "m";
    XUnits[i].U[2]= "cm";
    XUnits[i].scU[1]= 100.;
    XUnits[i].scU[2]= 0.01;
    i= 3;
    XUnits[i].U[1]= "T";
    XUnits[i].U[2]= "kG";
    XUnits[i].U[3]= "G";
    XUnits[i].scU[1]= 10.;
    XUnits[i].scU[2]= 1000.;
    XUnits[i].scU[3]= 1e-4;
    i= 4;
    XUnits[i].U[1]= "MA";
    XUnits[i].U[2]= "kA";
    XUnits[i].U[3]= "A";
    XUnits[i].scU[1]= 1000.;
    XUnits[i].scU[2]= 1000.;
    XUnits[i].scU[3]= 1e-6;
    i= 5;
    XUnits[i].U[1]= "V";
    XUnits[i].U[2]= "kV";
    XUnits[i].scU[1]= 0.001;
    XUnits[i].scU[2]= 1000.;
    i= 6;
    XUnits[i].U[1]= "Vsec";
    XUnits[i].U[2]= "mVs";
    XUnits[i].scU[1]= 1000.;
    XUnits[i].scU[2]= 0.001;
    i= 7;
    XUnits[i].U[1]= "MPa";
    XUnits[i].U[2]= "Pa";
    XUnits[i].scU[1]= 1e+6;
    XUnits[i].scU[2]= 1e-6;
    i= 8;
    XUnits[i].U[1]= "e+13";
    XUnits[i].U[2]= "e+20";
    XUnits[i].U[3]= "cm-3";
    XUnits[i].U[4]= "m-3";
    XUnits[i].scU[1]= 0.1;
    XUnits[i].scU[2]= 1e+14;
    XUnits[i].scU[3]= 1e+6;
    XUnits[i].scU[4]= 1e-19;
    i= 9;
    XUnits[i].U[1]= "keV";
    XUnits[i].U[2]= "eV";
    XUnits[i].U[3]= "erg";
    XUnits[i].U[4]= "K^o";
    XUnits[i].scU[1]= 1000.;
    XUnits[i].scU[2]= 1.6022e-12;
    XUnits[i].scU[3]= 1.1604e+4/1.6022e-12;
    XUnits[i].scU[4]= 1./1.1604e+7;
    i= 10;
    XUnits[i].U[1]= "MA/m";
    XUnits[i].U[2]= "kA/m";
    XUnits[i].U[3]= "A/cm";
    XUnits[i].scU[1]= 1000.;
    XUnits[i].scU[2]= 0.1;
    XUnits[i].scU[3]= 0.01;
    i= 11;
    XUnits[i].U[1]= "g";
    XUnits[i].U[2]= "kg";
    XUnits[i].scU[1]= 0.001;
    XUnits[i].scU[2]= 1000.;
    i= 12;
    XUnits[i].U[1]= "mkOm";
    XUnits[i].U[2]= "mOm";
    XUnits[i].U[3]= "Om";
    XUnits[i].scU[1]= 0.001;
    XUnits[i].scU[2]= 0.001;
    XUnits[i].scU[3]= 1e+6;
    for(i=0; i < NXUnits; i++){
      for(j=0;j < XUnits[i].nU; j++){
	XUnits[i].TU[j]	=(char*)malloc(5*sizeof(char));
	sprintf(XUnits[i].TU[j],"%4s",XUnits[i].U[j]);
      }
      XUnits[i].iU= 0;
      XUnits[i].pntU= XUnits[i].TU[0];
    }
  }
  fp	=fopen("In/Units","r");
  if(fp == NULL){
    WriteXUnits("Out/Units");
  }
  else{
    fclose(fp);
  }
  return(0);
}

int WriteXUnits(char *Nm)
{
  int i,j;
  if(Nm != NULL){
    fp= fopen(Nm,"w");
    for(i= 0;i<NXUnits;i++){
      fprintf(fp,"%2s: ",XUnits[i].nmU);
      for(j= 0;j<XUnits[i].nU;j++){
	strcpy(ln,"(");
	strcat(ln,XUnits[i].nmU);
	strcat(ln,".");
	strcat(ln,XUnits[i].U[j]);
	strcat(ln,")");
	fprintf(fp," %10s",ln);
      }
      fprintf(fp,";\n");
      fprintf(fp,"%4s"," ");
      for(j= 0;j<XUnits[i].nU;j++)
	fprintf(fp," %10.3e",XUnits[i].scU[j]);
      fprintf(fp,";\n");
    }
    printf("%s with available Units has been written by zcb%c\n",Nm,7);
    printf("   Move it into In/ directory for further use\n");
    fclose(fp);
  }
  else{
    printf("%6s %2s %2s   %6s   %6s ]\n","Name","Ln","N","Units"," ... ");
    for(i= 0;i<NXUnits;i++){
      printf("%6s %2d %2d",XUnits[i].nmU,XUnits[i].Ln,XUnits[i].nU);
      for(j= 0;j<XUnits[i].nU;j++)
	printf("   %s.%s",XUnits[i].nmU,XUnits[i].U[j]);
      printf("\n");
      printf("%12s"," ");
      printf(" %10s"," ");
      for(j= 1;j<XUnits[i].nU;j++)
	printf(" %10.3e",XUnits[i].scU[j]);
      printf("\n");
    }
  }
  return(0);
}

int CbGetTblHlpStructure(char*NmTblFile,int iT)
{
  char ch,*pnt0,*pnt,*pnt1,*pnt2,*pntH,Str[4]="Hlp",Index[32];
  int nL,nP,nPC,nV,nNmV,nNmVC,iIndex;

  int ic,ip,iv,im,imm,immm,i,j,len,k,k1,k2,n;
  int Flp,Flv,Flm,Flstar;
  int iCW,ix,iy,in;
  int iU,nU,Lstr;
  double s,ss;

  pnt0= TblHlp[iT];
  pnt= pnt0;

  ic= 0;
  ip= 0;
  iv= 0;
  im= 0;
  imm= 0;
  immm= 0;
  Flp= 0;
  Flv= 0;
  Flm= 0;
  Flstar= 0;
  nP= 0;
  nPC= 0;
  nV= 0;
  nNmV= 0;
  nNmVC= 0;
  nL= 0;

  while(isspace(*pnt))
    pnt++;
  if(*pnt != 'H'||*(++pnt) != 'l'||*(++pnt) != 'p'){
    printf("In/%s - no \"Hlp\" in beginning of Hlp section, line:\n"
	   ,NmTblFile);
    PPrintLine(pnt0,pnt);
    return(1);
  }
  pnt++;
  while(isspace(*pnt))
    pnt++;
  if(*pnt != '{'){
    printf("In/%s - no '{' after Hlp, line:\n",NmTblFile);
    PPrintLine(pnt0,pnt);
    return(1);
  }

  while(*pnt != '\0'){
    ch	=*pnt;
    if(ch == '"'){
      if((i=CbCheckExtName(pnt,pnt0,Str,NmTblFile)) < 0){
	return(1);
      }
      pnt 	+=i;
      if(*pnt != '='){
	printf("In/%s - no '=' in Hlp, line:\n",NmTblFile);
	PPrintLine(pnt0,pnt);
	return(1);
      }
      pnt++;
      while(isspace(*pnt)){
	pnt++;
      }
      switch(*pnt){
      case '(':
	if((i=CbCheckType(&iCW,&Flstar,pnt,pnt0,Str,NmTblFile)) < 0){
	  return(1);
	}
	pnt 	+=i;
	if(*pnt == '('){
	  i	=CbGetParCellOptions(&ix,&iy,&in,pnt);
	  if(i < 0){
	    printf("In/%s - wrong parameter option in Hlp section, line\n"
		   ,NmTblFile);
	    PPrintLine(pnt0,pnt);
	    return(1);
	  }
	  pnt	+=i;
	}
	if((i=CbCheckInternalName(pnt,pnt0,Str,NmTblFile)) < 0){
	  return(1);
	}
	pnt 	+=i;
	if((i=CbCheckScale(pnt,pnt0,Str,NmTblFile)) < 0){
	  return(1);
	}
	pnt 	+=i;
	if(*pnt == ','){
	  pnt++;
	  while(isspace(*pnt)){
	    pnt++;
	  }
	  if((i=CbCheckIndexName(pnt,pnt0,Str,NmTblFile)) < 0){
	    return(1);
	  }
	  pnt 	+=i;
	}
	if(*pnt != ';'){
	  printf("In/%s - no ';' before Help statement in Hlp, line:\n"
		 ,NmTblFile);
	  PPrintLine(pnt0,pnt);
	  return(1);
	}
	while((*pnt != ';' || *(pnt-1) != '\\') && *pnt != '\0'){
	  pnt++;
	}
	if(*pnt != ';'){
	  printf("In/%s - no '\\;' after the Help statement in Hlp, line:\n"
		 ,NmTblFile);
	  PPrintLine(pnt0,pnt);
	  return(1);
	}
	if(Flp && Flstar == 0){
	  nP++;
	  nPC++;
	}
	if(Flv&&Flstar){
	  nV++;
	  nNmV++;
	  nL++;
	  nNmVC++;
	}
	break;
      case '{':
	if(Flp){
	  nP++;
	}
	if(Flv){
	  nNmV++;
	}
	break;
      case '"':	
	if((i=CbCheckInternalName(pnt,pnt0,Str,NmTblFile)) < 0){
	  return(1);
	}
	pnt 	+=i;
	if(Flp){
	  if(Tbl[iT].ScpP[nP] == NULL){
	    if((*pnt == '*' || *pnt == '/') && CbCheckIfCNumber(pnt+1) < 0){
	      printf("In/%s - it should be no Scale factor. Mismatch\n"
		     ,NmTblFile);
	      printf(" between Tbl and Hlp sections:\n");
	      PPrintLine(pnt0,pnt);
	      return(1);
	    }
	  }
	  else{
	    if((*pnt != '*' && *pnt != '/') || CbCheckIfCName(&i,pnt+1)){
	      printf("In/%s - Scale factor should be here. Mismatch\n"
		     ,NmTblFile);
	      printf(" between Tbl and Hlp sections:\n");
	      PPrintLine(pnt0,pnt);
	      return(1);
	    }
	  }
	  nP++;
	}
	if(Flv){
	  if(Tbl[iT].ScpV[nNmV] == NULL){
	    if((*pnt == '*' || *pnt == '/') && CbCheckIfCNumber(pnt+1) < 0){
	      printf("In/%s - it should be no Scale factor. Mismatch\n"
		     ,NmTblFile);
	      printf(" between Tbl and Hlp sections:\n");
	      PPrintLine(pnt0,pnt);
	      return(1);
	    }
	  }
	  else{
	    if((*pnt != '*'&&*pnt != '/') || CbCheckIfCName(&i,pnt+1)){
	      printf("In/%s - Scale factor should be here. Mismatch\n"
		     ,NmTblFile);
	      printf(" between Tbl and Hlp sections:\n");
	      PPrintLine(pnt0,pnt);
	      return(1);
	    }
	  }
	  nV++;
	  nNmV++;
	}
	if((i=CbCheckScale(pnt,pnt0,Str,NmTblFile)) < 0){
	  return(1);
	}
	pnt 	+=i;
	if(*pnt == ','){
	  pnt++;
	  while(isspace(*pnt)){
	    pnt++;
	  }
	  if((i=CbCheckIndexName(pnt,pnt0,Str,NmTblFile)) < 0){
	    return(1);
	  }
	  pnt 	+=i;
	}
	if(*pnt != ';'){
	  printf("In/%s - no ';' before the Help statement in Hlp, line:\n"
		 ,NmTblFile);
	  PPrintLine(pnt0,pnt);
	  return(1);
	}
	while((*pnt != ';' || *(pnt-1) != '\\') && *pnt != '\0'){
	  pnt++;
	}
	if(*pnt != ';'){
	  printf("In/%s - no '\\;' after the Help statement in Hlp, line:\n"
		 ,NmTblFile);
	  PPrintLine(pnt0,pnt);
	  return(1);
	}
	break;
      default:
	while((*pnt != ';'||*(pnt-1) != '\\') && *pnt != '{' && *pnt != '\0'){
	  pnt++;
	}
	if(*pnt != ';'){
	  printf("In/%s - no \"\\;\" after '=' in Hlp, line:\n",NmTblFile);
	  PPrintLine(pnt0,pnt);
	  return(1);
	}
	pnt++;
	while(isspace(*pnt)){
	  pnt++;
	}
	if(*pnt != '{'){
	  printf("In/%s - no '{' after \"\\;\" in Hlp, line:\n",NmTblFile);
	  PPrintLine(pnt0,pnt);
	  return(1);
	}
	if(Flp){
	  nP++;
	}
	if(Flv){
	  nNmV++;
	}
	break;
      }
    }
    else if(!isspace(ch) && ch != '}' && ic){
      while(*pnt != '=' && *pnt != '}' && *pnt != '\0'){
	pnt++;
      }
      if(*pnt != '='){
	printf("In/%s - no '=' in Hlp, line:\n",NmTblFile);
	PPrintLine(pnt0,pnt);
	return(1);
      }
      pnt++;
      while(isspace(*pnt)){
	pnt++;
      }
      if((i=CbCheckType(&iCW,&Flstar,pnt,pnt0,Str,NmTblFile)) < 0){
	return(1);
      }
      pnt 	+=i;
      if(*pnt == '('){
	i	=CbGetParCellOptions(&ix,&iy,&in,pnt);
	if(i < 0){
	  printf("In/%s - wrong Menu option in Hlp section, line\n"
		 ,NmTblFile);
	  PPrintLine(pnt0,pnt);
	  return(1);
	}
	pnt	+=i;
      }
      if(*pnt != '{'){
	printf("In/%s - no '{' in Hlp, line:\n",NmTblFile);
	PPrintLine(pnt0,pnt);
	return(1);
      }
      Flm	=1;
      if(Flstar){
	Flp	=0;
	nL++;
      }
      else{
	Flv	=0;
      }
    }

    ch= *pnt;
    if(ch == '{'){
      if(Flp){
	ip++;
      }
      if(Flv){
	iv++;
      }
      if(Flm){
	im++;
	if(im>imm){
	  imm= im;
	}
      }
      if(ic == 0){
	Flp= 1;
	Flv= 1;
      }
      ic++;
    }
    if(ch == '}'){
      ic--;
      if(ic == 0){
	Flp= 0;
	Flv= 0;
      }
      if(Flp)
	ip--;
      if(Flv)
	iv--;
      if(Flm){
	im--;
	if(im == 0){
	  if(Flp)
	    nPC	+=imm;
	  if(Flv)
	    nNmVC	+=imm;
	  Flp= 1;
	  Flv= 1;
	  Flm= 0;
	  if(immm<imm)
	    immm= imm;
	  imm= 0;
	}
      }
    }
    pnt++;
  }
  if(ic){
    if(ic>0){
      printf("In/%s - extra  %d '{' in Hlp section\n",NmTblFile,ic);
      if(ip){
	if(ip>0)
	  printf("extra  %d '{' in parameter section\n",ip);
	if(ip<0)
	  printf("extra  %d '}' in parameter section\n",-ip);
      }
      if(iv){
	if(iv>0)
	  printf("extra  %d '{' in vector section\n",iv);
	if(iv<0)
	  printf("extra  %d '}' in vector section\n",-iv);
      }
    }
    if(ic<0){
      printf("In/%s - extra  %d '}' in Hlp section\n",NmTblFile,-ic);
      if(ip){
	if(ip>0)
	  printf("extra  %d '{' in parameter section\n",ip);
	if(ip<0)
	  printf("extra  %d '}' in parameter section\n",-ip);
      }
      if(iv){
	if(iv>0)
	  printf("extra  %d '{' in vector section\n",iv);
	if(iv<0)
	  printf("extra  %d '}' in vector section\n",-iv);
      }
    }
    return(1);
  }
  if(ip){
    if(ip>0)
      printf("In/%s - extra  %d '{' in Hlp parameter section\n",NmTblFile,ip);
    if(ip<0)
      printf("In/%s - extra  %d '}' in Hlp parameter section\n",NmTblFile,-ip);
    return(1);
  }
  if(iv){
    if(iv>0)
      printf("In/%s - extra  %d '{' in Hlp vector section\n",NmTblFile,iv);
    if(iv<0)
      printf("In/%s - extra  %d '}' in Hlp vector section\n",NmTblFile,-iv);
    return(1);
  }

  if(nP == 0&&nV == 0){
    printf("%s - No parameters or vectors in Hlp section\n",NmTblFile);
    return(1);
  }

  pnt= TblHlp[iT];
  ic	=0;
  ip	=0;
  iv	=0;
  im	=0;
  imm	=0;
  Flp	=0;
  Flv	=0;
  Flm	=0;
  Flstar=0;
  nP	=0;
  nPC	=0;
  nV	=0;
  nNmV	=0;
  nNmVC	=0;
  *Index='\0';
  while(*pnt != '{'){
    pnt++;
  }
  while(*pnt != '\0'){
    ch= *pnt;
    if(ch == '"'){
      pntH	=pnt;
      pnt	+=CbGetExtName(ln,&len,pnt);
      pnt	+=CbGetObjUnits(&iU,&nU,pnt);
      pnt	+=CbGetIndexList(Index,&iIndex,pnt);
      pnt++;
      while(isspace(*pnt)){
	pnt++;
      }
      switch(*pnt){
      case '(':
	pnt	+=CbGetTypeObj(&iCW,&Flstar,&Lstr,pnt);
	if(iCW == 0){
	  iU	=Lstr;
	}
	ix	=0;
	iy	=0;
	in	=0;
	if(*pnt == '('){
	  pnt	+=CbGetParCellOptions(&ix,&iy,&in,pnt);
	}
	while(*pnt != '"'){
	  pnt++;
	}
	pnt++;
	if(Flp && Flstar == 0){
	  if(strcmp(Tbl[iT].nmEP[nP],ln)){
	    printf("In/%s - <%s>  !=  <%s> no match between Ext names\n"
		   ,NmTblFile,Tbl[iT].nmEP[nP],ln);
	    printf(" in Tbl and Hlp sections:\n");
	    PPrintLine(pnt0,pnt);
	    return(1);
	  }
	  if(*Index != '\0'){
	    if(Tbl[iT].aEP[nP] == NULL){
	      printf("In/%s - <NULL>  !=  <%s> no match between Index Lists\n"
		     ,NmTblFile,Index);
	      printf(" in Tbl and Hlp sections:\n");
	      PPrintLine(pnt0,pnt);
	      return(1);
	    }
	    if(strcmp(Tbl[iT].aEP[nP],Index)){
	      printf("In/%s - <%s>  !=  <%s> no match between Index Lists\n"
		     ,NmTblFile,Tbl[iT].aEP[nP],Index);
	      printf(" in Tbl and Hlp sections:\n");
	      PPrintLine(pnt0,pnt);
	      return(1);
	    }
	    *Index	='\0';
	  }
	  if(Tbl[iT].iCP[nP] != iCW){
	    printf("In/%s <%d>  !=  <%d> - no match between Types\n",NmTblFile,
		   Tbl[iT].iCP[nP],iCW);
	    printf(" in Tbl and Hlp sections:\n");
	    PPrintLine(pnt0,pnt);
	    return(1);
	  }
	  if(Tbl[iT].nUP[nP] != nU){
	    printf("In/%s <%d>  !=  <%d> - no match between Units\n",NmTblFile,
		   Tbl[iT].nUP[nP],nU);
	    printf(" in Tbl and Hlp sections:\n");
	    PPrintLine(pnt0,pnt);
	    return(1);
	  }
	  if((Tbl[iT].iCP[nP]&7)){
	    if(Tbl[iT].iUP[nP] != iU){
	      printf("In/%s <%d>  !=  <%d> - no match between Units\n",
		     NmTblFile,Tbl[iT].iUP[nP],iU);
	      printf(" in Tbl and Hlp sections:\n");
	      PPrintLine(pnt0,pnt);
	      return(1);
	    }
	  }
	  else{
	    if(Tbl[iT].iUP[nP] != Lstr){
	      printf("In/%s <%d> != <%d> - no match between lengths of Str\n",
		     NmTblFile,Tbl[iT].iUP[nP],iU);
	      printf(" in Tbl and Hlp sections:\n");
	      PPrintLine(pnt0,pnt);
	      return(1);
	    }
	  }
	  CbSetUnitScale(&ss,nU,iU);
	  pnt1	=ln;
	  while(*pnt != '"'){
	    if(!isspace(*pnt)){
	      *pnt1= *pnt;
	      pnt1++;
	    }
	    pnt++;
	  }
	  *pnt1	='\0';
	  if(strcmp(Tbl[iT].nmP[nP],ln)){
	    printf("In/%s - <%s>  !=  <%s> no matching in names\n"
		   ,NmTblFile,Tbl[iT].nmP[nP],ln);
	    printf(" between Tbl and Hlp sections:\n");
	    PPrintLine(pnt0,pnt);
	    return(1);
	  }
	  pnt++;
	  while(isspace(*pnt)){
	    pnt++;
	  }
	  if((i=CbCompareScale(ss,Tbl[iT].scP[nP],Tbl[iT].ScpP[nP],pnt)) < 0){
	    printf("In/%s - no match in scale factor\n",NmTblFile);
	    printf(" between Tbl and Hlp sections:\n");
	    PPrintLine(pnt0,pnt);
	    return(1);
	  }
	  pnt	+=i;
	  if(*pnt == ','){
	    if(Tbl[iT].aP[nP] == NULL){
	      printf("In/%s - <NULL>  !=  <%s> no match in Index Name\n"
		     ,NmTblFile,ln);
	      printf(" between Tbl and Hlp sections:\n");
	      PPrintLine(pnt0,pnt);
	      return(1);
	    }
	    pnt++;
	    while(*pnt != '"'){
	      pnt++;
	    }
	    pnt++;
	    pnt1	=ln;
	    while(*pnt != '"'){
	      *pnt1++	=*pnt++;
	    }
	    *pnt1	='\0';
	    pnt++;
	    if(strcmp(Tbl[iT].aP[nP],ln)){
	      printf("In/%s - <%s>  !=  <%s> no match in Index Name\n"
		     ,NmTblFile,Tbl[iT].aP[nP],ln);
	      printf(" between Tbl and Hlp sections:\n");
	      PPrintLine(pnt0,pnt);
	      return(1);
	    }
	  }
	  Tbl[iT].HlpP[nP]	=pntH;
	  nP++;
	}
	if(Flv && Flstar){
	  if(strcmp(Tbl[iT].nmEV[nNmV],ln)){
	    printf("In/%s - <%s>  !=  <%s> no matching in Ext names\n"
		   ,NmTblFile,Tbl[iT].nmEV[nNmV],ln);
	    printf(" between Tbl and Hlp sections:\n");
	    PPrintLine(pnt0,pnt);
	    return(1);
	  }
	  if(*Index != '\0'){
	    if(Tbl[iT].aEV[nNmV] == NULL){
	      printf("In/%s - <NULL>  !=  <%s> no match between Index Lists\n"
		     ,NmTblFile,Index);
	      printf(" in Tbl and Hlp sections:\n");
	      PPrintLine(pnt0,pnt);
	      return(1);
	    }
	    if(strcmp(Tbl[iT].aEV[nNmV],Index)){
	      printf("In/%s - <%s>  !=  <%s> no match between Index Lists\n"
		     ,NmTblFile,Tbl[iT].aEV[nNmV],Index);
	      printf(" in Tbl and Hlp sections:\n");
	      PPrintLine(pnt0,pnt);
	      return(1);
	    }
	    *Index	='\0';
	  }
	  if(Tbl[iT].iCV[nNmV] != iCW){
	    printf("In/%s <%d>  !=  <%d> - no matching in Types\n",NmTblFile,
		   Tbl[iT].iCV[nNmV],iCW);
	    printf(" between Tbl and Hlp sections:\n");
	    PPrintLine(pnt0,pnt);
	    return(1);
	  }
	  if(Tbl[iT].nUV[nNmV] != nU){
	    printf("In/%s <%d>  !=  <%d> - no matching in Units set\n"
		   ,NmTblFile,
		   Tbl[iT].nUV[nNmV],nU);
	    printf(" between Tbl and Hlp sections:\n");
	    PPrintLine(pnt0,pnt);
	    return(1);
	  }
	  if((Tbl[iT].iCV[nNmV]&7)){
	    if(Tbl[iT].iUV[nNmV] != iU){
	      printf("In/%s <%d>  !=  <%d> - no matching in Units\n",
		     NmTblFile,Tbl[iT].iUV[nNmV],iU);
	      printf(" between Tbl and Hlp sections:\n");
	      PPrintLine(pnt0,pnt);
	      return(1);
	    }
	  }
	  else{
	    if(Tbl[iT].iUV[nNmV] != Lstr){
	      printf("In/%s <%d>  !=  <%d> - no matching in size of Str\n",
		     NmTblFile,Tbl[iT].iUV[nNmV],iU);
	      printf(" between Tbl and Hlp sections:\n");
	      PPrintLine(pnt0,pnt);
	      return(1);
	    }
	  }
	  CbSetUnitScale(&ss,nU,iU);
	  pnt1= ln;
	  while(*pnt != '"'){
	    if(!isspace(*pnt)){
	      *pnt1++	=*pnt;
	    }
	    pnt++;
	  }
	  *pnt1= '\0';
	  if(strcmp(Tbl[iT].nmV[nNmV],ln)){
	    printf("In/%s - <%s>  !=  <%s> no match in Internal Names\n"
		   ,NmTblFile,Tbl[iT].nmV[nNmV],ln);
	    printf(" between Tbl and Hlp sections:\n");
	    PPrintLine(pnt0,pnt);
	    return(1);
	  }
	  pnt++;
	  while(isspace(*pnt))
	    pnt++;
	  if((i=CbCompareScale(ss,Tbl[iT].scV[nNmV],Tbl[iT].ScpV[nNmV],pnt))
	     < 0){
	    printf("In/%s - no match in scale factor\n",NmTblFile);
	    printf(" between Tbl and Hlp sections:\n");
	    PPrintLine(pnt0,pnt);
	    return(1);
	  }
	  pnt	+=i;
	  if(*pnt == ','){
	    if((i=CbCompareIndexName(Tbl[iT].aV[nNmV],pnt)) < 0){
	      if(Tbl[iT].aV[nNmV] == NULL){
		printf("In/%s - <NULL>  !=  <! NULL> no match in Index Name\n"
		       ,NmTblFile);
	      }
	      else{
		printf("In/%s - <%s>  no match in Index Name\n"
		       ,NmTblFile,Tbl[iT].aV[nNmV]);
	      }
	      printf(" between Tbl and Hlp sections:\n");
	      PPrintLine(pnt0,pnt);
	      return(1);
	    }
	    pnt	+=i;
	  }
	  Tbl[iT].HlpV[nNmV]	=pntH;
	  nV++;
	  nNmV++;
	}
	while(*pnt != ';'||*(pnt-1) != '\\'){
	  pnt++;
	}
	*(pnt-1)= '\0';
	break;
      case '{':
	if(Flp){
	  if(strcmp(Tbl[iT].nmEP[nP],ln)){
	    printf("In/%s - <%s>  !=  <%s> no matching in Ext names\n"
		   ,NmTblFile,Tbl[iT].nmEP[nP],ln);
	    printf(" between Tbl and Hlp sections:\n");
	    PPrintLine(pnt0,pnt);
	    return(1);
	  }
	  Tbl[iT].HlpP[nP]= pntH;
	  nP++;
	}
	if(Flv){
	  if(strcmp(Tbl[iT].nmEV[nNmV],ln)){
	    printf("In/%s - <%s>  !=  <%s> no matching in Ext names\n"
		   ,NmTblFile,Tbl[iT].nmEV[nNmV],ln);
	    printf(" between Tbl and Hlp sections:\n");
	    PPrintLine(pnt0,pnt);
	    return(1);
	  }
	  Tbl[iT].HlpV[nNmV]= pntH;
	  nNmV++;
	}
	*(pnt-1)= '\0';
	nMI[im-1]++;
	break;
      case '"':
	pnt++;
	if(Flp){
	  if(strcmp(Tbl[iT].nmEP[nP],ln)){
	    printf("In/%s - <%s>  !=  <%s> no matching in Ext names\n"
		   ,NmTblFile,Tbl[iT].nmEP[nP],ln);
	    printf(" between Tbl and Hlp sections:\n");
	    PPrintLine(pnt0,pnt);
	    return(1);
	  }
	  if(*Index != '\0'){
	    if(Tbl[iT].aEP[nP] == NULL){
	      printf("In/%s - <NULL>  !=  <%s> no match in Index List\n"
		     ,NmTblFile,Index);
	      printf(" between Tbl and Hlp sections:\n");
	      PPrintLine(pnt0,pnt);
	      return(1);
	    }
	    if(strcmp(Tbl[iT].aEP[nP],Index)){
	      printf("In/%s - <%s>  !=  <%s> no match in Index List\n"
		     ,NmTblFile,Tbl[iT].aEP[nP],Index);
	      printf(" between Tbl and Hlp sections:\n");
	      PPrintLine(pnt0,pnt);
	      return(1);
	    }
	  }
	  if(Tbl[iT].iCP[nP] != iCW && iMI[im-1] != nP){
	    printf("In/%s <%d>  !=  <%d> - no matching in C-Types\n",NmTblFile,
		   Tbl[iT].iCP[nP],iCW);
	    printf(" between Tbl and Hlp sections:\n");
	    PPrintLine(pnt0,pnt);
	    return(1);
	  }
	  if(Tbl[iT].nUP[nP] != nU){
	    printf("In/%s <%d>  !=  <%d> - no matching in Unit set\n",NmTblFile,
		   Tbl[iT].nUP[nP],nU);
	    printf("In/%s - no matching in Units\n",NmTblFile);
	    printf(" between Tbl and Hlp sections:\n");
	    PPrintLine(pnt0,pnt);
	    return(1);
	  }
	  if((Tbl[iT].iCP[nP]&7)){
	    if(Tbl[iT].iUP[nP] != iU){
	      printf("In/%s <%d>  !=  <%d> - no matching in Units\n",
		     NmTblFile,Tbl[iT].iUP[nP],iU);
	      printf(" between Tbl and Hlp sections:\n");
	      PPrintLine(pnt0,pnt);
	      return(1);
	    }
	  }
	  else{
	    if(Tbl[iT].iUP[nP] != Lstr){
	      printf("In/%s <%d>  !=  <%d> - no matching in size of Str\n",
		     NmTblFile,Tbl[iT].iUP[nP],iU);
	      printf(" between Tbl and Hlp sections:\n");
	      PPrintLine(pnt0,pnt);
	      return(1);
	    }
	  }
	  CbSetUnitScale(&ss,nU,iU);
	  pnt1= ln;
	  while(*pnt != '"'){
	    if(!isspace(*pnt)){
	      *pnt1= *pnt;
	      pnt1++;
	    }
	    pnt++;
	  }
	  *pnt1= '\0';
	  if(strcmp(Tbl[iT].nmP[nP],ln)){
	    printf("In/%s - <%s>  !=  <%s> no matching in names\n"
		   ,NmTblFile,Tbl[iT].nmP[nP],ln);
	    printf(" between Tbl and Hlp sections:\n");
	    PPrintLine(pnt0,pnt);
	    return(1);
	  }
	  pnt++;
	  while(isspace(*pnt))
	    pnt++;
	  if((i=CbCompareScale(ss,Tbl[iT].scP[nP],Tbl[iT].ScpP[nP],pnt)) < 0){
	    printf("In/%s - no match in scale factor\n",NmTblFile);
	    printf(" between Tbl and Hlp sections:\n");
	    PPrintLine(pnt0,pnt);
	    return(1);
	  }
	  pnt	+=i;
	  if(*pnt == ','){
	    if(Tbl[iT].aP[nP] == NULL){
	      printf("In/%s - <NULL>  !=  <%s> no match in Index Name\n"
		     ,NmTblFile,ln);
	      printf(" between Tbl and Hlp sections:\n");
	      PPrintLine(pnt0,pnt);
	      return(1);
	    }
	    pnt++;
	    while(*pnt != '"'){
	      pnt++;
	    }
	    pnt++;
	    pnt1= ln;
	    while(*pnt != '"'){
	      *pnt1++	=*pnt++;
	    }
	    *pnt1	='\0';
	    pnt++;
	    if(strcmp(Tbl[iT].aP[nP],ln)){
	      printf("In/%s - <%s>  !=  <%s> no match in Index Name\n"
		     ,NmTblFile,Tbl[iT].aP[nP],ln);
	      printf(" between Tbl and Hlp sections:\n");
	      PPrintLine(pnt0,pnt);
	      return(1);
	    }
	  }
	  Tbl[iT].HlpP[nP]	=pntH;
	  nP++;
	}
	if(Flv){
	  if(strcmp(Tbl[iT].nmEV[nNmV],ln)){
	    printf("In/%s - <%s>  !=  <%s> no matching in Ext names\n"
		   ,NmTblFile,Tbl[iT].nmEV[nNmV],ln);
	    printf(" between Tbl and Hlp sections:\n");
	    PPrintLine(pnt0,pnt);
	    return(1);
	  }
	  if(*Index != '\0'){
	    if(Tbl[iT].aEV[nNmV] == NULL){
	      printf("In/%s - <NULL>  !=  <%s> no match between Index Lists\n"
		     ,NmTblFile,Index);
	      printf(" in Tbl and Hlp sections:\n");
	      PPrintLine(pnt0,pnt);
	      return(1);
	    }
	    if(strcmp(Tbl[iT].aEV[nNmV],Index)){
	      printf("In/%s - <%s>  !=  <%s> no match between Index Lists\n"
		     ,NmTblFile,Tbl[iT].aEV[nNmV],Index);
	      printf(" in Tbl and Hlp sections:\n");
	      PPrintLine(pnt0,pnt);
	      return(1);
	    }
	    *Index	='\0';
	  }
	  if(Tbl[iT].iCV[nNmV] != iCW && iMI[im-1] != nNmV){
	    printf("In/%s <%d>  !=  <%d> - no matching in Types\n",NmTblFile,
		   Tbl[iT].iCV[nNmV],iCW);
	    printf(" between Tbl and Hlp sections:\n");
	    PPrintLine(pnt0,pnt);
	    return(1);
	  }
	  if(Tbl[iT].nUV[nNmV] != nU){
	    printf("In/%s <%d>  !=  <%d> - no matching in Units set\n"
		   ,NmTblFile,
		   Tbl[iT].nUV[nNmV],nU);
	    printf(" between Tbl and Hlp sections:\n");
	    PPrintLine(pnt0,pnt);
	    return(1);
	  }
	  if((Tbl[iT].iCV[nNmV]&7)){
	    if(Tbl[iT].iUV[nNmV] != iU){
	      printf("In/%s <%d>  !=  <%d> - no matching in Units\n",
		     NmTblFile,Tbl[iT].iUV[nNmV],iU);
	      printf(" between Tbl and Hlp sections:\n");
	      PPrintLine(pnt0,pnt);
	      return(1);
	    }
	  }
	  else{
	    if(Tbl[iT].iUV[nNmV] != Lstr){
	      printf("In/%s <%d>  !=  <%d> - no matching in size of Str\n",
		     NmTblFile,Tbl[iT].iUV[nNmV],iU);
	      printf(" between Tbl and Hlp sections:\n");
	      PPrintLine(pnt0,pnt);
	      return(1);
	    }
	  }
	  CbSetUnitScale(&ss,nU,iU);
	  pnt1= ln;
	  while(*pnt != '"'){
	    if(!isspace(*pnt)){
	      *pnt1= *pnt;
	      pnt1++;
	    }
	    pnt++;
	  }
	  *pnt1= '\0';
	  if(strcmp(Tbl[iT].nmV[nNmV],ln)){
	    printf("In/%s - <%s>  !=  <%s> no match in Internal Vector Names\n"
		   ,NmTblFile,Tbl[iT].nmV[nNmV],ln);
	    printf(" between Tbl and Hlp sections:\n");
	    PPrintLine(pnt0,pnt);
	    return(1);
	  }
	  pnt++;
	  while(isspace(*pnt))
	    pnt++;
	  if((i=CbCompareScale(ss,Tbl[iT].scV[nNmV],Tbl[iT].ScpV[nNmV],pnt))
	     < 0){
	    printf("In/%s - no match in scale factor\n",NmTblFile);
	    printf(" between Tbl and Hlp sections:\n");
	    PPrintLine(pnt0,pnt);
	    return(1);
	  }
	  pnt	+=i;
	  if(*pnt == ','){
	    if((i=CbCompareIndexName(Tbl[iT].aV[nNmV],pnt)) < 0){
	      if(Tbl[iT].aV[nNmV] == NULL){
		printf("In/%s - <NULL>  !=  <! NULL> no match in Index Name\n"
		       ,NmTblFile);
	      }
	      else{
		printf("In/%s - <%s>  no match in Index Name\n"
		       ,NmTblFile,Tbl[iT].aV[nNmV]);
	      }
	      printf(" between Tbl and Hlp sections:\n");
	      PPrintLine(pnt0,pnt);
	      return(1);
	    }
	    pnt	+=i;
	  }
	  Tbl[iT].HlpV[nNmV]= pntH;
	  nV++;
	  nNmV++;
	}
	while(*pnt != ';'||*(pnt-1) != '\\'){
	  pnt++;
	}
	*(pnt-1)= '\0';
	nMI[im-1]++;
	break;
      default:
	while(*pnt != ';'||*(pnt-1) != '\\')
	  pnt++;
	*(pnt-1)= '\0';
	pnt++;
	while(*pnt != '{')
	  pnt++;
	if(Flp){
	  if(strcmp(Tbl[iT].nmEP[nP],ln)){
	    printf("In/%s - <%s>  !=  <%s> no matching in Ext names\n"
		   ,NmTblFile,Tbl[iT].nmEP[nP],ln);
	    printf(" between Tbl and Hlp sections:\n");
	    PPrintLine(pnt0,pnt);
	    return(1);
	  }
	  Tbl[iT].HlpP[nP]= pntH;
	  nP++;
	}
	if(Flv){
	  if(strcmp(Tbl[iT].nmEV[nNmV],ln)){
	    printf("In/%s - <%s>  !=  <%s> no matching in Ext names\n"
		   ,NmTblFile,Tbl[iT].nmEV[nNmV],ln);
	    printf(" between Tbl and Hlp sections:\n");
	    PPrintLine(pnt0,pnt);
	    return(1);
	  }
	  Tbl[iT].HlpV[nNmV]= pntH;
	  nNmV++;
	}
	nMI[im-1]++;
	break;
      }
    }
    else if(!isspace(ch) && ch != '}' && ic){
      while(*pnt != '('){
	pnt++;
      }
      pnt	+=CbGetTypeObj(&iCW,&Flstar,&Lstr,pnt);
      if(iCW == 0){
	iU= Lstr;
      }
      while(*pnt != '{')
	pnt++;
      if(Flstar){
	Flp= 0;
      }
      else{
	Flv= 0;
      }
      Flm= 1;
    }

    ch= *pnt;
    if(ch == '{'){
      if(Flp)
	ip++;
      if(Flv)
	iv++;
      if(Flm){
	if(Flp)
	  iMI[im]= nP;
	if(Flv)
	  iMI[im]= nNmV;
	nMI[im]= 0;
	im++;
	if(im>imm)
	  imm= im;
      }
      if(ic == 0){
	Flp= 1;
	Flv= 1;
      }
      ic++;
    }
    if(ch == '}'){
      ic--;
      if(ic == 0){
	Flp= 0;
	Flv= 0;
      }
      if(Flp)
	ip--;
      if(Flv)
	iv--;
      if(Flm){
	im--;
	i= iMI[im];
	if(Flp){
	  if(im+1 == imm){
	    if(Tbl[iT].iCP[i] != (iCW|8)){
	      printf("In/%s <%d>  !=  <%d> - no match inTypes\n",NmTblFile,
		     Tbl[iT].iCP[i],iCW|8);
	      printf(" between Tbl and Hlp sections for\n");
	      printf("\"%s\"\n",Tbl[iT].nmEP[i]);
	      return(1);
	    }
	  }
	  else{
	    if(Tbl[iT].iCP[i] != 8){
	      printf("In/%s <%d>  !=  <%d> - no match in Types\n",NmTblFile,
		     Tbl[iT].iCP[i],8);
	      printf(" between Tbl and Hlp sections for\n");
	      printf("\"%s\"\n",Tbl[iT].nmEP[i]);
	      return(1);
	    }
	  }
	}
	if(Flv){
	  if(im+1 == imm){
	    if(Tbl[iT].iCV[i] != (iCW|8)){
	      printf("In/%s <%d>  !=  <%d> - no match in Types\n",NmTblFile,
		     Tbl[iT].iCV[i],iCW|8);
	      printf(" between Tbl and Hlp sections for\n");
	      printf("\"%s\"\n",Tbl[iT].nmEV[i]);
	      return(1);
	    }
	  }
	  else{
	    if(Tbl[iT].iCV[i] != 8){
	      printf("In/%s <%d>  !=  <%d> - no match in Types\n",NmTblFile,
		     Tbl[iT].iCV[i],8);
	      printf(" between Tbl and Hlp sections for\n");
	      printf("\"%s\"\n",Tbl[iT].nmEV[i]);
	      return(1);
	    }
	  }
	}
	if(im == 0){
	  if(Flp)
	    nPC	+=imm;
	  if(Flv)
	    nNmVC	+=imm;
	  Flp= 1;
	  Flv= 1;
	  Flm= 0;
	  imm= 0;
	}
      }
    }
    pnt++;
  }

  Flp= 0;
  nP	=Tbl[iT].NP;
  for(i=0; i < nP; i++){
    if(Tbl[iT].HlpP[i] == NULL){
      if(Flp == 0){
	printf("\n");
      }
      printf("\"%s\" has no Help in Tbl_%s in file In/%s\n",Tbl[iT].nmEP[i],
	     Tbl[iT].Nm,NmTblFile);
      Flp= 1;
    }
  }
  nV	=Tbl[iT].NNmV;
  for(i=0; i < nV;i++){
    if(Tbl[iT].HlpV[i] == NULL){
      if(Flp == 0){
	printf("\n");
      }
      printf("\"%s\" has no Help in Tbl_%s in file In/%s\n",
	     Tbl[iT].nmEV[i],Tbl[iT].Nm,NmTblFile);
      Flp= 1;
    }
  }
  if(Flp){
    printf("\nPlease, make Help for listed items%c\n",7);
    return(1);
  }
  return(0);
}

int CbNmV2(int*n,char *line,char*str)
{
  char*p,*p1,*s1,*s;
  int i,j,n1,k,i0,i1,L;

  p	=line;
  s	=str;
  if(*s == '\0'){
    *p	='\0';
    *n	=0;
    return(0);
  }
  n1	=0;
  while(*s != '\0'){
    if(n1 == NVecNm){
      NVecNm	+=10;
      VecNm	=(CbVectorNm*)realloc((void*)VecNm,NVecNm*sizeof(CbVectorNm));
      for(i=n1; i < NVecNm; i++){
	VecNm[i].k	=0;
	VecNm[i].i0	=0;
	VecNm[i].i1	=0;
	VecNm[i].pi0	=NULL;
	VecNm[i].pi1	=NULL;
      }
    }
    VecNm[n1].k	=0;
    if(VecNm[n1].pi0 != NULL){
      free(VecNm[n1].pi0);
    }
    if(VecNm[n1].pi1 != NULL){
      free(VecNm[n1].pi1);
    }
    VecNm[n1].pi0	=NULL;
    VecNm[n1].pi1	=NULL;
    VecNm[n1].i0	=0;
    VecNm[n1].i1	=0;
    if(*s == '('){
      s++;
      s1	=s;
      while(*s1 != '='){
	s1++;
      }
      i0	=0;
      p1	=s1+1;
      j		=CbCheckIfCName(&i,p1);
      if(j == 1){
	i	=CbCheckIfCNumber(p1);
	if(i < 0){
	  printf("Wrong size of array:\n%s in\n%s\n",p1,str);
	  return(1);
	}
	sscanf(p1,"%d",&i0);
	p1	+=i;
      }
      else{
	VecNm[n1].pi0	=(char*)malloc((i+1)*sizeof(char));
	j	=0;
	while(j < i){
	  VecNm[n1].pi0[j]	=*p1++;
	  j++;
	}
	VecNm[n1].pi0[j]	='\0';
      }
      if(*p1 != '<'){
	printf("no '<' in size of array in\n%s\n",str);
	return(1);
      }
      i1	=0;
      p1++;
      j	=CbCheckIfCName(&i,p1);
      if(j == 1){
	i	=CbCheckIfCNumber(p1);
	if(i < 0){
	  printf("Wrong size of array:\n%s in\n%s\n",p1,str);
	  return(1);
	}
	sscanf(p1,"%d",&i1);
	p1	+=i;
      }
      else{
	VecNm[n1].pi1	=(char*)malloc((i+1)*sizeof(char));
	j	=0;
	while(j<i){
	  VecNm[n1].pi1[j]	=*p1++;
	  j++;
	}
	VecNm[n1].pi1[j]	='\0';
      }
      if(*p1 != ')'){
	printf("Wrong description of the size of the array in\n%s\n",str);
	return(1);
      }
      s1--;
      L	=0;
      while(*s1 != ','&&s1>s){
	L++;
	s1--;
      }
      s1++;
      k	=0;
      while(s < s1){
	while(*s != ','){
	  *p++	=*s++;
	  if(*s == '['){
	    while(*s != ']'){
	      *p++	=*s++;
	      if(strncmp(s,s1,L) == 0&&isalnum(*(s-1)) == 0&&*(s-1) != '_'
		 &&isalnum(*(s+L)) == 0&&*(s+L) != '_'){
		*p++	='#';
		s	+=L;
	      }
	    }
	  }
	}
	if(*s == ','){
	  *p++	=*s;
	  k++;
	}
	s++;
      }

      while(*s != ')')
	s++;
      while(*s != ','&&*s != '\0')
	s++;
      if(*s == ','){
	s++;
      }
      VecNm[n1].k	=k;
      VecNm[n1].i0	=i0;
      VecNm[n1].i1	=i1;
      n1++;
    }
    else{
      while(*s != ','&&*s != '\0'){
	*p= *s;
	p++;
	s++;
      }
      *p= *s;
      p++;
      VecNm[n1].k	=1;
      VecNm[n1].i0	=0;
      VecNm[n1].i1	=1;
      n1++;
      if(*s == '\0'){
	break;
      }
      s++;
    }
  }
  *p	='\0';
  *n	=n1;
  return(0);
}

int CbGetPltStructure(char*NmPltF,int iT)
{
  char ch,*pnt0,*pnt,*pnt1,*pnt2;
  int nP,nM,NM,nV;

  int ic,ip,iv,im,imm,immm,i,j,len,k,k1,k2,n;
  int Flv,Flm,Flcase;
  int iCW;
  int iU,nU;
  double s;

  pnt0= BuffIO[2];
  pnt= pnt0;
  ic= 0;
  iv= 0;
  im= 0;
  imm= 0;
  immm= 0;
  Flv= 0;
  Flm= 0;
  nP= 0;
  nV= 0;
  while(isspace(*pnt))
    pnt++;
  if(*pnt != 'P'||*(++pnt) != 'l'||*(++pnt) != 't'){
    printf("In/%s - no \"Plt_\" in front of Plt, line:\n",NmPltF);
    PPrintLine(pnt0,pnt);
    return(1);
  }
  pnt++;
  while(isspace(*pnt))
    pnt++;
  if(*pnt != '{'){
    printf("In/%s - no '{' after Plt, line:\n",NmPltF);
    PPrintLine(pnt0,pnt);
    return(1);
  }

  while(*pnt != '\0'){
    ch= *pnt;
    if(ch == '"'){
      pnt++;
      while(*pnt != '"'&&*pnt != '}')
	pnt++;
      if(*pnt != '"'){
	printf("In/%s - no second '\"' in Ext name in Plt, line:\n",NmPltF);
	PPrintLine(pnt0,pnt);
	return(1);
      }
      pnt++;
      while(isspace(*pnt))
	pnt++;
      if(*pnt == '('){
	while(*pnt != '.'&&*pnt != '='&&*pnt != ';'&&*pnt != '}')
	  pnt++;
	if(*pnt != '.'){
	  printf("In/%s - no '.' in Unit section of Plt, line:\n",NmPltF);
	  PPrintLine(pnt0,pnt);
	  return(1);
	}
	while(*pnt != ')'&&*pnt != '='&&*pnt != ';'&&*pnt != '}')
	  pnt++;
	if(*pnt != ')'){
	  printf("In/%s - no ')' in Unit section of Plt, line:\n",NmPltF);
	  PPrintLine(pnt0,pnt);
	  return(1);
	}
	pnt++;
	while(isspace(*pnt))
	  pnt++;
      }
      if(*pnt != '='){
	printf("In/%s - no '=' in Plt, line:\n",NmPltF);
	PPrintLine(pnt0,pnt);
	return(1);
      }
      pnt++;
      while(isspace(*pnt))
	pnt++;

      switch(*pnt){
      case '(':
	pnt++;
	while(isspace(*pnt))
	  pnt++;
	pnt1= pnt;
	pnt	+=3;
	if(*pnt != '*'){
	  printf("In/%s - no* in C-Type in Plt section, line\n",NmPltF);
	  PPrintLine(pnt0,pnt);
	  return(1);
	}
	*pnt= '\0';
	for(iCW= 0;iCW<nCW;iCW++){
	  if(strcmp(pnt1,CW[iCW]) == 0)
	    break;
	}
	if(iCW == nCW){
	  printf("In/%s - wrong C-Type in Plt section, line\n",NmPltF);
	  PPrintLine(pnt0,pnt);
	  return(1);
	}
	*pnt= '*';
	pnt++;
	while(isspace(*pnt))
	  pnt++;
	if(*pnt != ')'){
	  printf("In/%s - no ')' in Plt section, line\n",NmPltF);
	  PPrintLine(pnt0,pnt);
	  return(1);
	}
	pnt++;
	while(isspace(*pnt))
	  pnt++;
	if(*pnt != '"'){
	  printf("In/%s - no third '\"' in Plt section, line\n",NmPltF);
	  PPrintLine(pnt0,pnt);
	  return(1);
	}
      case '"':
	pnt++;
	if(Flv){
	  i= 0;
	  while(*pnt != '"'&&*pnt != ';'&&*pnt != '\0'){
	    if(isspace(*pnt) == 0)
	      i++;
	    pnt++;
	  }
	  if(*pnt != '"'){
	    printf("In/%s - no or wrong place for fourth '\"' in Plt, line:\n"
		   ,NmPltF);
	    PPrintLine(pnt0,pnt);
	    return(1);
	  }
	  if(i == 0){
	    printf("In/%s - empty name in Plt, line:\n",NmPltF);
	    PPrintLine(pnt0,pnt);
	    return(1);
	  }
	  nV++;
	}
	pnt++;
	while(isspace(*pnt))
	  pnt++;
	if(*pnt == '*'||*pnt == '/'){
	  pnt++;
	  while(isspace(*pnt))
	    pnt++;
	  j= CbCheckIfCName(&i,pnt);
	  if(j<0){
	    printf("In/%s - wrong scale factor name in Plt, line:\n"
		   ,NmPltF);
	    PPrintLine(pnt0,pnt);
	    return(1);
	  }
	  if(j == 1){
	    i= CbCheckIfCNumber(pnt);
	    if(i<0){
	      printf("In/%s - wrong scale factor in Plt, line:\n"
		     ,NmPltF);
	      PPrintLine(pnt0,pnt);
	      return(1);
	    }
	    else{
	      pnt	+=i;
	    }
	  }
	  else{
	    pnt	+=i;
	  }
	  while(isspace(*pnt))
	    pnt++;
	}
	if(*pnt != ';'){
	  printf("In/%s - no ';' in Plt, line:\n",NmPltF);
	  PPrintLine(pnt0,pnt);
	  return(1);
	}
	break;
      case '{':
	break;
      default:
	printf("In/%s - no '(' or '{' or '\"' after '=' in Plt, line:\n"
	       ,NmPltF);
	PPrintLine(pnt0,pnt);
	return(1);
	break;
      }
    }


    else if(!isspace(ch)&&ch != '}'&&ic){
      if(strncmp(pnt,"plot",4) == 0){
	pnt	+=4;
	while(isspace(*pnt))
	  pnt++;
	if(*pnt != '('){
	  printf("In/%s - no '(' after 'plot' in Plt, line:\n",NmPltF);
	  PPrintLine(pnt0,pnt);
	  return(1);
	}
	while(*pnt != ')'&&*pnt != ';'&&*pnt != '\0')
	  pnt++;
	if(*pnt != ')'){
	  printf("In/%s - no ')' in Plt, line:\n",NmPltF);
	  PPrintLine(pnt0,pnt);
	  return(1);
	}
	pnt++;
	while(isspace(*pnt))
	  pnt++;
	if(*pnt == '('){
	  while(*pnt != ')'&&*pnt != ';'&&*pnt != '\0')
	    pnt++;
	  if(*pnt != ')'){
	    printf("In/%s - no second ')' in Plt, line:\n",NmPltF);
	    PPrintLine(pnt0,pnt);
	    return(1);
	  }
	  pnt++;
	  while(isspace(*pnt))
	    pnt++;
	}
	if(*pnt != ';'){
	  printf("In/%s - no ';' in Plt, line:\n",NmPltF);
	  PPrintLine(pnt0,pnt);
	  return(1);
	}
	nP++;
      }
      else{
	while(*pnt != '='&&*pnt != '}')
	  pnt++;
	if(*pnt != '='){
	  printf("In/%s - no '=' in Plt, line:\n",NmPltF);
	  PPrintLine(pnt0,pnt);
	  return(1);
	}
	pnt++;
	while(isspace(*pnt))
	  pnt++;
	if(*pnt != '('){
	  printf("In/%s - no '(' after '=' in Plt, line:\n",NmPltF);
	  PPrintLine(pnt0,pnt);
	  return(1);
	}
	pnt++;
	while(isspace(*pnt))
	  pnt++;

	pnt1= pnt;
	pnt	+=3;
	if(*pnt != '*'){
	  printf("In/%s - no '*' in C-Type in Plt section, line\n",NmPltF);
	  PPrintLine(pnt0,pnt);
	  return(1);
	}
	*pnt= '\0';
	for(iCW= 0;iCW<nCW;iCW++){
	  if(strcmp(pnt1,CW[iCW]) == 0)
	    break;
	}
	if(iCW == nCW){
	  printf("In/%s - wrong C-Type in Plt section, line\n",NmPltF);
	  PPrintLine(pnt0,pnt);
	  return(1);
	}
	*pnt= '*';
	pnt++;
	while(isspace(*pnt))
	  pnt++;
	if(*pnt != ')'){
	  printf("In/%s - no ')' in Plt section, line\n",NmPltF);
	  PPrintLine(pnt0,pnt);
	  return(1);
	}
	pnt++;
	while(isspace(*pnt))
	  pnt++;
	if(*pnt != '{'){
	  printf("In/%s - no '{' in Plt, line:\n",NmPltF);
	  PPrintLine(pnt0,pnt);
	  return(1);
	}
	Flm= 1;
      }
    }
    ch= *pnt;
    if(ch == '{'){
      if(Flv)
	iv++;
      if(Flm){
	im++;
	if(im>imm)
	  imm= im;
      }
      if(ic == 0){
	Flv= 1;
      }
      ic++;
    }
    if(ch == '}'){
      ic--;
      if(ic == 0){
	Flv= 0;
      }
      if(Flv)
	iv--;
      if(Flm){
	im--;
	if(im == 0){
	  Flv= 1;
	  Flm= 0;
	  if(immm<imm)
	    immm= imm;
	  imm= 0;
	}
      }
    }
    pnt++;
  }

  if(ic){
    if(ic>0){
      printf("In/%s - extra  %d '{' in Plt section\n",NmPltF,ic);
      if(iv){
	if(iv>0)
	  printf("extra  %d '{' in vector section\n",iv);
	if(iv<0)
	  printf("extra  %d '}' in vector section\n",-iv);
      }
    }
    if(ic<0){
      printf("In/%s - extra  %d '}' in Plt section\n",NmPltF,-ic);
      if(iv){
	if(iv>0)
	  printf("extra  %d '{' in vector section\n",iv);
	if(iv<0)
	  printf("extra  %d '}' in vector section\n",-iv);
      }
    }
    return(1);
  }

  if(nV == 0){
    printf("%s - Warning: no vectors in Plt section\n",NmPltF);
    return(0);
  }
  NM= Tbl[iT].NM;
  Plt[iT].nM= NM;
  Plt[iT].nP= nP;
  Plt[iT].nV= nV;

  Plt[iT].i0= (int*)malloc(7*nP*sizeof(int));
  Plt[iT].i1= Plt[iT].i0+nP;
  Plt[iT].iX= Plt[iT].i1+nP;
  Plt[iT].iY= Plt[iT].iX+nP;
  Plt[iT].c= Plt[iT].iY+nP;
  Plt[iT].f= Plt[iT].c+nP;
  Plt[iT].s= Plt[iT].f+nP;

  Plt[iT].nmP= (char**)malloc(5*nP*sizeof(char*));
  Plt[iT].pi0= Plt[iT].nmP+nP;
  Plt[iT].pi1= Plt[iT].pi0+nP;
  Plt[iT].opt= Plt[iT].pi1+nP;
  Plt[iT].pc= Plt[iT].opt+nP;

  Plt[iT].nmM= (char**)malloc(NM*sizeof(char*));
  Plt[iT].mV= (int*)malloc(2*NM*sizeof(int));
  Plt[iT].iV= Plt[iT].mV+NM;

  Plt[iT].sizeV= (int*)malloc(5*nV*sizeof(int));
  Plt[iT].nKV= Plt[iT].sizeV+nV;
  Plt[iT].nUV= Plt[iT].nKV+nV;
  Plt[iT].iUV= Plt[iT].nUV+nV;
  Plt[iT].iCV= Plt[iT].iUV+nV;

  Plt[iT].kV= (int**)malloc(3*nV*sizeof(int*));
  Plt[iT].i0V= Plt[iT].kV+nV;
  Plt[iT].i1V= Plt[iT].i0V+nV;
  Plt[iT].nmV= (char**)malloc(3*nV*sizeof(char*));
  Plt[iT].nmEV= Plt[iT].nmV+nV;
  Plt[iT].ScpV= Plt[iT].nmEV+nV;
  Plt[iT].V= (char***)malloc(3*nV*sizeof(char**));
  Plt[iT].pi0V= Plt[iT].V+nV;
  Plt[iT].pi1V= Plt[iT].pi0V+nV;
  Plt[iT].V1= (double**)malloc(nV*sizeof(char*));
  Plt[iT].scV= (double*)malloc(nV*sizeof(double));

  for(i= 0;i<NM;i++){
    pnt= Tbl[iT].nmM[i];
    Plt[iT].nmM[i]= (char*)malloc((strlen(pnt)+1)*sizeof(char));
    strcpy(Plt[iT].nmM[i],pnt);
    Plt[iT].mV[i]= -1;
    Plt[iT].iV[i]= -1;
  }
  for(i= 0;i<nV;i++){
    Plt[iT].ScpV[i]= NULL;
  }
  for(i= 0;i<nP;i++){
    Plt[iT].opt[i]= NULL;
    Plt[iT].pc[i]= NULL;
    Plt[iT].c[i]= 0;
    Plt[iT].f[i]= 0;
    Plt[iT].s[i]= 0;
  }


  if(immm >= kMI){
    kMI	=immm;
    nMI	=(int*)realloc((void*)nMI,2*kMI*sizeof(int));
    iMI	=nMI+kMI;
  }
  pnt= BuffIO[2];
  ic= 0;
  iv= 0;
  im= 0;
  imm= 0;
  Flv= 0;
  Flm= 0;
  nM= 0;
  nP= 0;
  nV= 0;


  while(*pnt != '{')
    pnt++;

  while(*pnt != '\0'){
    ch= *pnt;
    if(ch == '"'){
      pnt++;
      len= 0;
      pnt1= pnt;
      while(*pnt != '"'){
	len++;
	pnt++;
      }
      *pnt= '\0';
      strcpy(ln,pnt1);
      pnt++;
      while(*pnt != '('&&*pnt != '=')
	pnt++;
      if(*pnt == '('){
	pnt++;
	while(isspace(*pnt))
	  pnt++;
	pnt1= pnt;
	while(*pnt != '.')
	  pnt++;
	*pnt= '\0';
	pnt++;
	pnt2= pnt;
	while(isspace(*pnt) == 0&&*pnt != ')')
	  pnt++;
	*pnt= '\0';
	for(nU= 0;nU<NXUnits;nU++){
	  if(strcmp(pnt1,XUnits[nU].nmU) == 0){
	    for(iU= 0;iU<XUnits[nU].nU;iU++){
	      if(strcmp(pnt2,XUnits[nU].U[iU]) == 0){
		break;
	      }
	    }
	    if(iU<XUnits[nU].nU){
	      break;
	    }
	  }
	}
	if(nU<NXUnits&&iU<XUnits[nU].nU){
	}
	else{
	  nU= -1;
	  iU= 0;
	}
	while(*pnt != '=')
	  pnt++;
      }
      else{
	nU= -1;
	iU= 0;
      }
      pnt++;
      while(isspace(*pnt))
	pnt++;

      Flcase= 1;
      switch(*pnt){
      case '(':
	Flcase= 0;
	pnt++;
	while(isspace(*pnt))
	  pnt++;
	pnt1= pnt;
	pnt	+=3;
	*pnt= '\0';
	for(iCW= 0;iCW<nCW;iCW++){
	  if(strcmp(pnt1,CW[iCW]) == 0)
	    break;
	}
	if(iCW == 5)
	  iCW= iCW-5;
	if(iCW>4)
	  iCW= iCW-5;
	while(*pnt != '"')
	  pnt++;
      case '"':
	pnt++;
	if(Flv){
	  Plt[iT].nmEV[nV]= (char*)malloc((len+1)*sizeof(char));
	  strcpy(Plt[iT].nmEV[nV],ln);
	  Plt[iT].iCV[nV]= iCW;
	  Plt[iT].nUV[nV]= nU;
	  Plt[iT].iUV[nV]= iU;
	  CbSetUnitScale(Plt[iT].scV+nV,nU,iU);
	  pnt1= pnt;
	  i= 0;
	  while(*pnt != '"'){
	    if(isspace(*pnt) == 0)
	      i++;
	    pnt++;
	  }
	  Plt[iT].nmV[nV]= (char*)malloc((i+1)*sizeof(char));
	  pnt= pnt1;
	  pnt1= Plt[iT].nmV[nV];
	  while(*pnt != '"'){
	    if(isspace(*pnt) == 0){
	      *pnt1= *pnt;
	      pnt1++;
	    }
	    pnt++;
	  }
	  *pnt1= '\0';
	  if(CbNmV2(&k,ln,Plt[iT].nmV[nV])){
	    printf("In/%s - Wrong vector description in Plt, line:\n",NmPltF);
	    PPrintLine(pnt0,pnt);
	    return(1);
	  }
	  Plt[iT].nKV[nV]= k;
	  Plt[iT].kV[nV]= (int*)malloc(3*k*sizeof(int));
	  Plt[iT].i0V[nV]= Plt[iT].kV[nV]+k;
	  Plt[iT].i1V[nV]= Plt[iT].i0V[nV]+k;
	  j= 0;
	  n= 0;
	  for(i= 0;i<k;i++){
	    Plt[iT].kV[nV][i]= VecNm[i].k;
	    j	+=VecNm[i].k;
	    n	+=(VecNm[i].i1-VecNm[i].i0)*VecNm[i].k;
	  }
	  Plt[iT].sizeV[nV]= n;
	  Plt[iT].V[nV]= (char**)malloc((j+2*k)*sizeof(char*));
	  Plt[iT].pi0V[nV]= Plt[iT].V[nV]+j;
	  Plt[iT].pi1V[nV]= Plt[iT].pi0V[nV]+k;
	  for(i= 0;i<k;i++){
	    if(VecNm[i].pi0 != NULL){
	      Plt[iT].pi0V[nV][i]= VecNm[i].pi0;
	      Plt[iT].i0V[nV][i]= 0;
	      VecNm[i].pi0	=NULL;
	    }
	    else{
	      Plt[iT].pi0V[nV][i]= NULL;
	      Plt[iT].i0V[nV][i]= VecNm[i].i0;
	    }
	    if(VecNm[i].pi1 != NULL){
	      Plt[iT].pi1V[nV][i]= VecNm[i].pi1;
	      Plt[iT].i1V[nV][i]= 0;
	      VecNm[i].pi1	=NULL;
	    }
	    else{
	      Plt[iT].pi1V[nV][i]= NULL;
	      Plt[iT].i1V[nV][i]= VecNm[i].i1;
	    }
	  }
	  Plt[iT].V1[nV]= (double*)malloc(n*sizeof(double));
	  for(i=0;i < n; i++){
	    Plt[iT].V1[nV][i]= 0;
	  }
	  pnt++;
	  while(isspace(*pnt))
	    pnt++;
	  if(*pnt == '*'||*pnt == '/'){
	    pnt2= pnt;
	    pnt++;
	    while(isspace(*pnt))
	      pnt++;
	    j= CbCheckIfCName(&i,pnt);
	    if(j == 1){
	      i= CbCheckIfCNumber(pnt);
	      sscanf(pnt,"%lg",&s);
	      if(*pnt2 == '/')
		Plt[iT].scV[nV]/= s;
	      if(*pnt2 == '*')
		Plt[iT].scV[nV]*= s;
	      pnt	+=i;
	    }
	    else{
	      Plt[iT].ScpV[nV]= (char*)malloc((i+2)*sizeof(char));
	      Plt[iT].ScpV[nV][0]= *pnt2;
	      pnt1= Plt[iT].ScpV[nV]+1;
	      j= 0;
	      while(j<i){
		*pnt1= *pnt;
		pnt1++;
		pnt++;
		j++;
	      }
	      *pnt1= '\0';
	    }
	  }
	  nV++;
	}
	while(*pnt != ';'){
	  pnt++;
	}
	if(Flcase){
	  nMI[im-1]++;
	}
	break;
      case '{':
	if(Flv){
	  for(i= nM;i<NM;i++){
	    if(strcmp(Plt[iT].nmM[i],ln) == 0){
	      nM= i;
	      break;
	    }
	  }
	  if(i == NM){
	    printf("In/%s - M-name <%s> in Plt does not match Tbl, line:\n"
		   ,NmPltF,ln);
	    PPrintLine(pnt0,pnt);
	    return(1);
	  }
	  Plt[iT].mV[nM]= nV;
	  Plt[iT].iV[nM]= nV;
	  nM++;
	}
	nMI[im-1]++;
	break;
      default:
	break;
      }
    }


    else if(!isspace(ch)&&ch != '}'&&ic){
      if(strncmp(pnt,"plot",4) == 0){
	pnt	+=4;
	while(isspace(*pnt))
	  pnt++;
	pnt++;
	i= 0;
	pnt1= pnt;
	while(*pnt1 != ')'){
	  if(!isspace(*pnt1))
	    i++;
	  pnt1++;
	}
	Plt[iT].nmP[nP]= (char*)malloc((i+2)*sizeof(char));
	pnt1= Plt[iT].nmP[nP];
	while(*pnt != ')'){
	  if(!isspace(*pnt)){
	    *pnt1= *pnt;
	    pnt1++;
	  }
	  pnt++;
	}
	*pnt1= *pnt;
	pnt1++;
	*pnt1= '\0';

	pnt++;
	while(isspace(*pnt))
	  pnt++;
	if(*pnt == '('){
	  pnt++;
	  i= 0;
	  pnt1= pnt;
	  while(*pnt1 != ')'){
	    if(!isspace(*pnt1))
	      i++;
	    pnt1++;
	  }
	  Plt[iT].opt[nP]= (char*)malloc((i+2)*sizeof(char));
	  pnt1= Plt[iT].opt[nP];
	  while(*pnt != ')'){
	    if(!isspace(*pnt)){
	      *pnt1= *pnt;
	      pnt1++;
	    }
	    pnt++;
	  }
	  *pnt1= *pnt;
	  pnt1++;
	  *pnt1= '\0';
	  pnt++;
	  while(isspace(*pnt))
	    pnt++;
	}
	while(*pnt != ';')
	  pnt++;
	nP++;
      }
      else{
	pnt1= pnt;
	while(!isspace(*pnt)&&*pnt != '='){
	  pnt++;
	}
	*pnt= '\0';
	for(i= nM;i<NM;i++){
	  if(strcmp(Plt[iT].nmM[i],pnt1) == 0){
	    nM= i;
	    break;
	  }
	}
	if(i == NM){
	  printf("In/%s - M-name <%s> in Plt does not match Tbl, line:\n"
		 ,NmPltF,ln);
	  PPrintLine(pnt0,pnt);
	  return(1);
	}
	Plt[iT].mV[nM]= nV;
	Plt[iT].iV[nM]= nV;
	nM++;
	while(*pnt != '(')
	  pnt++;
	pnt++;
	while(isspace(*pnt))
	  pnt++;
	pnt1= pnt;
	pnt	+=3;
	*pnt= '\0';
	for(iCW= 0;iCW<nCW;iCW++){
	  if(strcmp(pnt1,CW[iCW]) == 0)
	    break;
	}
	if(iCW == 5)
	  iCW= iCW-5;
	if(iCW>4)
	  iCW= iCW-5;
	while(*pnt != '{')
	  pnt++;
	Flm= 1;
      }
    }

    ch= *pnt;
    if(ch == '{'){
      if(Flv)
	iv++;
      if(Flm){
	if(Flv){
	  iMI[im]= nV;
	}
	nMI[im]= 0;
	im++;
	if(im>imm)
	  imm= im;
      }
      if(ic == 0){
	Flv= 1;
      }
      ic++;
    }
    if(ch == '}'){
      ic--;
      if(ic == 0){
	Flv= 0;
      }
      if(Flv)
	iv--;
      if(Flm){
	im--;
	i= iMI[im];
	if(im == 0){
	  Flv= 1;
	  Flm= 0;
	  imm= 0;
	}
      }
    }
    pnt++;
  }
  if(CbDecodePltNm(iT)){
    return(1);
  }
  if(CbDecodePltOpt(iT)){
    return(1);
  }
  return(0);
}

int CbDecodePltNm(int iT)
{
  int i,ii,j,i0,i1,nP,nV,nM;
  PltPar*pP;
  char*p,*p1;
  int iX,iY;

  pP	=Plt+iT;
  nP	=pP->nP;
  nV	=pP->nV;
  nM	=pP->nM;

  for(i=0; i < nP;i++){
    p	=pP->nmP[i];
    if(*p != '*'){
      p1	= p;
      while(*p != ','&&*p != '\0'){
	p++;
      }
      if(*p != ','){
	printf("In Table %s: %s is a wrong plot specification\n",
	       Tbl[iT].Nm,pP->nmP[i]);
	return(1);
      }
      *p	='\0';
      iX	=nV;
      for(j=0; j < nV; j++){
	if(strcmp(pP->nmEV[j],p1) == 0){
	  if(iX < nV){
	    printf("In Table %s: %s is a double used name\n",
		   Tbl[iT].Nm,p1);
	    printf(" in plot specification\n%s\n",pP->nmP[i]);
	    return(1);
	  }
	  iX	=j;
	}
      }
      if(iX == nV){
	printf("In Table %s: %s is a wrong name\n",Tbl[iT].Nm,p1);
	printf(" in plot specification\n%s\n",pP->nmP[i]);
	return(1);
      }
      else{
	pP->iX[i]	=iX;
      }
    }
    else{
      p++;
      p1	=p;
      while(*p != ','&&*p != '\0'){
	p++;
      }
      if(*p != ','){
	printf("In Table %s: %s is a wrong plot specification\n",
	       Tbl[iT].Nm,pP->nmP[i]);
	return(1);
      }
      *p	='\0';
      iX	=0;
      for(j=0; j < nM; j++){
	if(strcmp(pP->nmM[j],p1) == 0){
	  if(iX){
	    printf("In Table %s: %s is a double used name\n",
		   Tbl[iT].Nm,p1);
	    printf(" in plot specification\n%s\n",pP->nmP[i]);
	    return(1);
	  }
	  iX	=nV+j;
	}
      }
      if(iX == 0){
	printf("In Table %s: %s is a wrong name\n",Tbl[iT].Nm,p1);
	printf(" in plot specification\n%s\n",pP->nmP[i]);
	return(1);
      }
      else{
	pP->iX[i]	=iX;
      }
    }

    p++;
    if(*p != '*'){
      p1	=p;
      while(*p != ','&&*p != '\0'){
	p++;
      }
      if(*p != ','){
	printf("In Table %s: %s is a wrong plot specification\n",
	       Tbl[iT].Nm,pP->nmP[i]);
	return(1);
      }
      *p	='\0';
      iY	=nV;
      for(j=0; j < nV; j++){
	if(strcmp(pP->nmEV[j],p1) == 0){
	  if(iY < nV){
	    printf("In Table %s: %s is a double used name\n",
		   Tbl[iT].Nm,p1);
	    printf(" in plot specification\n%s\n",pP->nmP[i]);
	    return(1);
	  }
	  iY	=j;
	}
      }
      if(iY == nV){
	printf("In Table %s: %s is a wrong name\n",Tbl[iT].Nm,p1);
	printf(" in plot specification\n%s\n",pP->nmP[i]);
	return(1);
      }
      else{
	pP->iY[i]	=iY;
      }
    }
    else{
      p++;
      p1	=p;
      while(*p != ','&&*p != '\0'){
	p++;
      }
      if(*p != ','){
	printf("In Table %s: %s is a wrong plot specification\n",
	       Tbl[iT].Nm,pP->nmP[i]);
	return(1);
      }
      *p	='\0';
      iY	=0;
      for(j=0; j < nM; j++){
	if(strcmp(pP->nmM[j],p1) == 0){
	  if(iY){
	    printf("In Table %s: %s is a double used name\n",
		   Tbl[iT].Nm,p1);
	    printf(" in plot specification\n%s\n",pP->nmP[i]);
	    return(1);
	  }
	  iY	=nV+j;
	}
      }
      if(iY == 0){
	printf("In Table %s: %s is a wrong name\n",Tbl[iT].Nm,p1);
	printf(" in plot specification\n%s\n",pP->nmP[i]);
	return(1);
      }
      else{
	pP->iY[i]= iY;
      }
    }
    p++;
    while(*p != '=' && *p != '\0'){
      p++;
    }
    if(*p != '='){
      printf("In Table %s: %s no '=' in plot specification\n",
	     Tbl[iT].Nm,pP->nmP[i]);
      return(1);
    }
    p++;
    i0	=0;
    p1	=p;
    j	=CbCheckIfCName(&ii,p1);
    if(j == 1){
      ii	=CbCheckIfCNumber(p1);
      if(ii<0){
	printf("Wrong size of array:\n%s in\n%s\n",p1,pP->nmP[i]);
	return(1);
      }
      pP->pi0[i]	=NULL;
      sscanf(p1,"%d",&i0);
      p1	+=ii;
    }
    else{
      pP->pi0[i]	=(char*)malloc((ii+1)*sizeof(char));
      j	=0;
      while(j<ii){
	pP->pi0[i][j]	=*p1;
	p1++;
	j++;
      }
      pP->pi0[i][j]	='\0';
    }
    if(*p1 != '<'){
      printf("no '<' in size of array in\n%s\n",pP->nmP[i]);
      return(1);
    }
    i1	=0;
    p1++;
    j	=CbCheckIfCName(&ii,p1);
    if(j  ==  1){
      ii 	=CbCheckIfCNumber(p1);
      if(ii < 0){
	printf("Wrong size of array:\n%s in\n%s\n",p1,pP->nmP[i]);
	return(1);
      }
      pP->pi1[i] =NULL;
      sscanf(p1,"%d",&i1);
      p1	+=ii;
    }
    else{
      pP->pi1[i]	=(char*)malloc((ii+1)*sizeof(char));
      j	=0;
      while(j<ii){
	pP->pi1[i][j]	=*p1;
	p1++;
	j++;
      }
      pP->pi1[i][j]	='\0';
    }
    if(*p1  !=  ')'){
      printf("Wrong description of the size of the array in\n%s\n",pP->nmP[i]);
      return(1);
    }
    pP->i0[i]	=i0;
    pP->i1[i]	=i1;
  }
  return(0);
}

int CbDecodePltOpt(int iT)
{
  int i,j,nP;
  PltPar*pP;
  char*p,*p1;
  char*Opt[3]= {"c","f","s"};
  static int nOpt= 3,iOpt;

  pP= Plt+iT;
  nP= pP->nP;
  for(i= 0;i<nP;i++){
    p= pP->opt[i];

    if(p != NULL){
      strcpy(ln,p);
      while(*p != '\0'){
	p1= p;
	while(isalpha(*p)){
	  p++;
	}
	if(*p != '='){
	  *p= '\0';
	  printf("In Table %s: %s has an error in the plot option name: %s\n",
		 Tbl[iT].Nm,ln,p1);
	  return(1);
	}
	*p= '\0';
	for(iOpt= 0;iOpt<nOpt;iOpt++){
	  if(strcmp(p1,Opt[iOpt]) == 0){
	    break;
	  }
	}
	if(iOpt<nOpt){
	  p++;
	  p1= p;
	  if(CbIsSimpleCName(&j,p)){
	    p	+=j;
	    if(*p != ','&&*p != ')'&&*p != '\0'){
	      *p= '\0';
	      printf("In Table %s:\n",Tbl[iT].Nm);
	      printf("%s C-name is wrong in the plot option %s\n",p1,ln);
	      return(1);
	    }
	    *p= '\0';
	    switch(iOpt){
	    case 0:
	      pP->pc[i]= (char*)malloc((j+1)*sizeof(char));
	      strcpy(pP->pc[i],p1);
	      break;
	    default:
	      printf("In Table %s:\n",Tbl[iT].Nm);
	      printf("%s non-Integer as an option value %s\n",p1,ln);
	      return(1);
	    }
	  }
	  else if(CbIsInteger(&j,p)){
	    p	+=j;
	    if(*p != ','&&*p != ')'&&*p != '\0'){
	      *p= '\0';
	      printf("In Table %s:\n",Tbl[iT].Nm);
	      printf("%s -Integer is wrong in the plot option %s\n",p1,ln);
	      return(1);
	    }
	    *p= '\0';
	    sscanf(p1,"%d",&j);
	    switch(iOpt){
	    case 0:
	      pP->c[i]= j;
	      break;
	    case 1:
	      pP->f[i]= j;
	      if(pP->s[i] == 0)
		pP->s[i]= 1;
	      break;
	    case 2:
	      pP->s[i]= j;
	      break;
	    }
	  }
	  else{
	    p	+=j;
	    *p= '\0';
	    printf("In Table %s:\n",Tbl[iT].Nm);
	    printf("%s -value is wrong in the plot option %s\n",p1,ln);
	    return(1);
	  }
	}
	else{
	  printf("In Table %s: %s has a wrong plot option name: %s\n",
		 Tbl[iT].Nm,ln,p1);
	  printf("Choose from the following set:\n");
	  for(iOpt= 0;iOpt<nOpt;iOpt++){
	    printf("%s\n",Opt[iOpt]);
	  }
	  return(1);
	}
	p++;
      }
    }
  }
  return(0);
}

int CbInitRangePar(int iT)
{
  int i,ii,j,k,ni,nd,nP,nV;
  char*pnt,**p;

  ni	=0;
  nd	=0;

  nP	=Tbl[iT].NP;
  for(i=0; i < nP;i++){
    if(Tbl[iT].ScpP[i] != NULL){
      nd++;
    }
  }
  nV	=Tbl[iT].NNmV;
  for(i=0; i < nV; i++){
    if(Tbl[iT].ScpV[i] != NULL){
      nd++;
    }
  }
  if(Plt[iT].nP){
    nP	=Plt[iT].nP;
    for(i=0; i < nP; i++){
      if(Plt[iT].pi0[i] != NULL){
	ni++;
      }
      if(Plt[iT].pi1[i] != NULL){
	ni++;
      }
      if(Plt[iT].pc[i] != NULL){
	ni++;
      }
    }
    nV	=Plt[iT].nV;
    for(i=0; i < nV; i++){
      if(Plt[iT].ScpV[i] != NULL){
	nd++;
      }
      k	=Plt[iT].nKV[i];
      for(j=0; j < k; j++){
	if(Plt[iT].pi0V[i][j] != NULL){
	  ni++;
	}
	if(Plt[iT].pi1V[i][j] != NULL){
	  ni++;
	}
      }
    }
  }

  Rng[iT].ni	=ni;
  if(ni){
    Rng[iT].vi	=(int*)malloc(ni*sizeof(int));
    Rng[iT].pvi	=(char**)malloc(ni*sizeof(int*));
  }
  else{
    Rng[iT].vi	=NULL;
    Rng[iT].pvi	=NULL;
  }
  Rng[iT].nd	=nd;
  if(nd){
    Rng[iT].vd	=(double*)malloc(nd*sizeof(double));
    Rng[iT].pvd	=(char**)malloc(nd*sizeof(double*));
  }
  else{
    Rng[iT].vd	=NULL;
    Rng[iT].pvd	=NULL;
  }

  if(nd){
    nd	=0;
    p	=Rng[iT].pvd;
    nP	=Tbl[iT].NP;
    for(i=0; i < nP; i++){
      if(Tbl[iT].ScpP[i] != NULL){
	pnt	=Tbl[iT].ScpP[i];
	for(j=0; j < nd; j++){
	  if(strcmp(p[j],pnt) == 0){
	    free(Tbl[iT].ScpP[i]);
	    Tbl[iT].ScpP[i]	=(char*)(Rng[iT].vd+j);
	    break;
	  }
	}
	if(j == nd){
	  p[nd]	=pnt;
	  Tbl[iT].ScpP[i]	=(char*)(Rng[iT].vd+j);
	  nd++;
	}
      }
    }
    nV	=Tbl[iT].NNmV;
    for(i=0; i < nV; i++){
      if(Tbl[iT].ScpV[i] != NULL){
	pnt	=Tbl[iT].ScpV[i];
	for(j=0; j < nd; j++){
	  if(strcmp(p[j],pnt) == 0){
	    free(Tbl[iT].ScpV[i]);
	    Tbl[iT].ScpV[i]	=(char*)(Rng[iT].vd+j);
	    break;
	  }
	}
	if(j == nd){
	  p[nd]	=pnt;
	  Tbl[iT].ScpV[i]	=(char*)(Rng[iT].vd+j);
	  nd++;
	}
      }
    }

    if(Plt[iT].nP){
      nV	=Plt[iT].nV;
      for(i=0; i < nV; i++){
	if(Plt[iT].ScpV[i] != NULL){
	  pnt	=Plt[iT].ScpV[i];
	  for(j=0; j < nd; j++){
	    if(strcmp(p[j],pnt) == 0){
	      free(pnt);
	      Plt[iT].ScpV[i]	=(char*)(Rng[iT].vd+j);
	      break;
	    }
	  }
	  if(j == nd){
	    p[nd]	=pnt;
	    Plt[iT].ScpV[i]	=(char*)(Rng[iT].vd+j);
	    nd++;
	  }
	}
      }
    }
    Rng[iT].nd	=nd;
  }
  else{
    Rng[iT].nd	=0;
  }

  if(ni){
    ni	=0;
    p	=Rng[iT].pvi;
    nP	=Plt[iT].nP;
    for(i=0; i < nP; i++){
      if(Plt[iT].pi0[i] != NULL){
	pnt	=Plt[iT].pi0[i];
	for(j=0; j < ni; j++){
	  if(strcmp(p[j],pnt) == 0){
	    free(Plt[iT].pi0[i]);
	    Plt[iT].pi0[i]	=(char*)(Rng[iT].vi+j);
	    break;
	  }
	}
	if(j == ni){
	  p[ni]	=pnt;
	  Plt[iT].pi0[i]	=(char*)(Rng[iT].vi+j);
	  ni++;
	}
      }
      if(Plt[iT].pi1[i]  !=  NULL){
	pnt	=Plt[iT].pi1[i];
	for(j=0; j < ni; j++){
	  if(strcmp(p[j],pnt)  ==  0){
	    free(Plt[iT].pi1[i]);
	    Plt[iT].pi1[i]	=(char*)(Rng[iT].vi+j);
	    break;
	  }
	}
	if(j  ==  ni){
	  p[ni]	=pnt;
	  Plt[iT].pi1[i]	=(char*)(Rng[iT].vi+j);
	  ni++;
	}
      }
      if(Plt[iT].pc[i] != NULL){
	pnt	=Plt[iT].pc[i];
	for(j= 0;j<ni;j++){
	  if(strcmp(p[j],pnt) == 0){
	    free(Plt[iT].pc[i]);
	    Plt[iT].pc[i]	=(char*)(Rng[iT].vi+j);
	    break;
	  }
	}
	if(j == ni){
	  p[ni]	=pnt;
	  Plt[iT].pc[i]	=(char*)(Rng[iT].vi+j);
	  ni++;
	}
      }
    }
    nV	=Plt[iT].nV;
    for(i=0; i < nV; i++){
      k	=Plt[iT].nKV[i];
      for(ii=0; ii < k; ii++){
	if(Plt[iT].pi0V[i][ii] != NULL){
	  pnt	=Plt[iT].pi0V[i][ii];
	  for(j=0;j < ni; j++){
	    if(strcmp(p[j],pnt) == 0){
	      free(Plt[iT].pi0V[i][ii]);
	      Plt[iT].pi0V[i][ii]	=(char*)(Rng[iT].vi+j);
	      break;
	    }
	  }
	  if(j == ni){
	    p[ni]	=pnt;
	    Plt[iT].pi0V[i][ii]	=(char*)(Rng[iT].vi+j);
	    ni++;
	  }
	}
	if(Plt[iT].pi1V[i][ii] != NULL){
	  pnt	=Plt[iT].pi1V[i][ii];
	  for(j=0;j < ni; j++){
	    if(strcmp(p[j],pnt) == 0){
	      free(Plt[iT].pi1V[i][ii]);
	      Plt[iT].pi1V[i][ii]= (char*)(Rng[iT].vi+j);
	      break;
	    }
	  }
	  if(j == ni){
	    p[ni]	=pnt;
	    Plt[iT].pi1V[i][ii]	=(char*)(Rng[iT].vi+j);
	    ni++;
	  }
	}
      }
    }
    Rng[iT].ni= ni;
  }
  else{
    Rng[iT].ni= 0;
  }
  return(0);
}

int CbDeInitRangePar()
{
  int i,j,n;

  for(i=0; i < nTbl; i++){
    if(Tbl[i].SF != NULL){
      n	=Rng[i].ni;
      if(n != 0){
	for(j=0; j < n; j++){
	  free(Rng[i].pvi[j]);
	}
	free(Rng[i].vi);
	free(Rng[i].pvi);
      }
      n	=Rng[i].nd;
      if(n != 0){
	for(j=0; j < n; j++){
	  free(Rng[i].pvd[j]);
	}
	free(Rng[i].vd);
	free(Rng[i].pvd);
      }
    }
  }
  free(Rng);
  return(0);
}

int CbCheckIfCName(int*k,char*pnt)
{
  int i,ic;

  if(isalpha(*pnt) == 0&&*pnt != '_')
    return(1);
  ic= 0;
  pnt++;
  i= 1;
  while(isalnum(*pnt)||*pnt == '_'||*pnt == '.'
	||*pnt == '['||*pnt == ']'){
    if(*pnt == '[')
      ic++;
    if(*pnt == ']')
      ic--;
    i++;
    pnt++;
  }
  if(ic)
    return(-1);

  *k= i;
  return(0);
}

int CbIsSimpleCName(int*k,char*pnt)
{
  int i;

  if(isalpha(*pnt) == 0&&*pnt != '_')
    return(0);
  pnt++;
  i= 1;
  while(isalnum(*pnt)||*pnt == '_'){
    i++;
    pnt++;
  }
  *k= i;
  return(1);
}

int CbCheckIfCNumber(char*p)
{
  int i,k,id,ie,ip,im;

  i= 0;
  if(*p == '+'||*p == '-'){
    i++;
    p++;
  }
  if(isdigit(*p) == 0&&*p != '.')
    return(-1);
  if(*p == '.'){
    id= 1;
    k= i+1;
  }
  else{
    id= 0;
    k= i;
  }

  ip= 0;
  im= 0;
  while(isdigit(*p)||*p == '+'||*p == '-'||*p == '.'
	||*p == 'e'||*p == 'E'){

    if(*p == '.'){
      id++;
      if(id>1){
	return(-1);
      }
    }
    if(*p == '+'){
      ip++;
      if(ip>1||(*(p-1) != 'e'&&*(p-1) != 'E')){
	return(-1);
      }
    }
    if(*p == '-'){
      im++;
      if(im>1||(*(p-1) != 'e'&&*(p-1) != 'E')){
	return(-1);
      }
    }
    i++;
    p++;
  }
  if(k == i){
    return(-1);
  }
  return(i);
}

int CbIsInteger(int*k,char*p)
{
  int i;

  i= 0;
  if(*p == '+'||*p == '-'){
    i++;
    p++;
  }
  *k= i;
  while(isdigit(*p)){
    i++;
    p++;
  }
  if(*k&&i == 1){
    return(0);
  }
  *k= i;
  return(1);
}

int CbGetIOStructure(char*NmBnrF,int iB,int iT)
{
  CbIOPar*pIO;
  char*p,*p0,*p1,*NmE[3]= {"SF","Beg","End"},*NmIO,*NmTbl;
  int i,L,Fl,ic;

  p0= BuffIO[iB+3];
  p= p0;

  pIO= CbIO[iB]+iT;
  NmIO= pntN[3+iB];

  if(Tbl[iT].iS<0){
    NmTbl= blb[Tbl[iT].iB].NmB;
  }
  else{
    NmTbl= blb[Tbl[iT].iB].NmS[Tbl[iT].iM][Tbl[iT].iS];
  }


  while(isspace(*p))
    p++;
  L= strlen(NmIO);
  if(strncmp(p,NmIO,L)){
    *(p+L)= '\0';
    printf("%s is a wrong I/O type is Section %s in file %s, line:\n",
	   p,NmIO,NmTblF);
    PPrintLine(p0,p);
    exit(1);
  }
  if(iB<4){
    p	+=L;
    L= strlen(NmTbl);
    if(strncmp(p,NmTbl,L)){
      *(p+L)= '\0';
      printf("%s is a wrong Name for Section %s in file %s, line:\n",
	     p,NmIO,NmTblF);
      PPrintLine(p0,p);
      printf("It does not match the Cb Block name %s\n",NmTbl);
      exit(1);
    }
  }
  p	+=L;
  while(isspace(*p))
    p++;
  if(*p != '('){
    printf("%s has no '(' in %s Section:\n<%s>\n",
	   NmTblF,NmIO,p0);
    exit(1);
  }
  while(*p != ')'&&*p != '{'&&*p != '\0'){
    if(*p == '='){
      p1= p-1;
      while(isspace(*p1))
	p1--;
      Fl= -1;
      if(strncmp(p1-1,NmE[0],2) == 0&&
	 (isspace(*(p1-2))||*(p1-2) == ','||*(p1-2) == '(')){
	if(pIO->SF != NULL){
	  printf("%s Double use of 'SF' as %s Section parameter:\n<%s>\n",
		 NmTblF,NmIO,p0);
	  exit(1);
	}
	Fl= 0;
      }
      else if(strncmp(p1-2,NmE[1],3) == 0&&
	      (isspace(*(p1-3))||*(p1-3) == ','||*(p1-3) == '(')){
	if(pIO->Beg != NULL){
	  printf("%s Double use of 'Beg' as %s Section parameter:\n<%s>\n",
		 NmTblF,NmIO,p0);
	  exit(1);
	}
	Fl= 1;
      }
      else if(strncmp(p1-2,NmE[2],3) == 0&&
	      (isspace(*(p1-3))||*(p1-3) == ','||*(p1-3) == '(')){
	if(pIO->End != NULL){
	  printf("%s Double use of 'End' as %s Section parameter:\n<%s>\n",
		 NmTblF,NmIO,p0);
	  exit(1);
	}
	Fl= 2;
      }
      if(Fl<0){
	*p= '\0';
	printf("%s, %s is a wrong parameter type in %s Section:\n<%s>\n",
	       NmTblF,p,NmIO,p0);
	exit(1);
      }
      p++;
      while(isspace(*p))
	p++;
      if(*p != '"'){
	printf("%s, No '\"' after '%s= 'in %s Section:\n<%s>\n",
	       NmTblF,NmE[Fl],NmIO,p0);
	exit(1);
      }
      p++;
      while(isspace(*p))
	p++;
      i= 1;
      p1= p;
      while(*p != '"'&&*p != ')'&&*p != '{'&&*p != '\0'){
	p++;
	i++;
      }
      if(*p != '"'){
	printf("%s, No second '\"' after '%s= 'in %s Section:\n<%s>\n",
	       NmTblF,NmE[Fl],NmIO,p0);
	exit(1);
      }
      *p= '\0';
      switch(Fl){
      case 0:
	pIO->SF= (char*)malloc(i*sizeof(char));
	strcpy(pIO->SF,p1);
	break;
      case 1:
	pIO->Beg= (char*)malloc(i*sizeof(char));
	strcpy(pIO->Beg,p1);
	break;
      case 2:
	pIO->End= (char*)malloc(i*sizeof(char));
	strcpy(pIO->End,p1);
	break;
      }
      *p= '"';
    }
    p++;
  }
  if(*p != ')'){
    printf("%s has no ')' in %s Section:\n<%s>\n",
	   NmTblF,NmIO,p0);
    exit(1);
  }
  p++;
  while(isspace(*p))
    p++;
  if(*p != '{'){
    printf("%s has no '{' in %s Section:\n<%s>\n",
	   NmTblF,NmIO,p0);
    exit(1);
  }
  p++;
  ic= 1;

  while(*p != '\0'){
    p++;
    if(*p == '{')
      ic++;
    if(*p == '}')
      ic--;
  }
  if(ic>0){
    printf("%s has %d unbalanced '{' in %s Section:\n<%s>\n",
	   NmTblF,ic,NmIO,p0);
    exit(1);
  }
  if(ic<0){
    printf("%s has %d unbalanced '}' in %s Section:\n<%s>\n",
	   NmTblF,-ic,NmIO,p0);
    exit(1);
  }

  return(0);
}

int CbGetUnits(int*nU,int*iU,char*Str)
{
  int i,n;
  char*p,*p1,ch;

  if(*Str == '\0'){
    *nU= -1;
    *iU= 0;
  }
  p= Str;
  while(isspace(*p)&&*p != '\0'){
    p++;
  }
  p1= p;
  while(*p != '.'&&*p != '\0'){
    p++;
  }
  if(*p != '.'){
    printf("%s - no '.' in Unit description%c\n",Str,7);
    return(1);
  }
  *p= '\0';

  for(n= 0;n<NXUnits;n++){
    if(strcmp(p1,XUnits[n].nmU) == 0){
      *nU= n;
      *p= '.';
      p++;
      p1= p;
      while(isspace(*p) == 0&&*p != '\0'){
	p++;
      }
      ch= '\0';
      if(*p != '\0'){
	ch= *p;
	*p= '\0';
      }
      for(i= 0;i<XUnits[n].nU;i++){
	if(strcmp(p1,XUnits[n].U[i]) == 0){
	  *iU= i;
	  break;
	}
      }
      if(ch != '\0'){
	*p= ch;
      }
      if(i == XUnits[n].nU){
	if(p-p1>0){
	  printf("%s - wrong Unit name in (%s.) set%c\n",Str,XUnits[n].nmU,7);
	  return(1);
	}
	*iU= 0;
      }
      break;
    }
  }
  if(n == NXUnits){
    printf("%s - wrong Units Set%c\n",Str,7);
    return(1);
  }

  return(0);
}

int CbGetType(int*Flstar,int*id,char*Str)
{
  char*p;
  int i,n= 10;
  char*CW[10]= {"str","dbl","int","flt","lng","fch","Dbl","Int","Flt","Lng"};

  if(Str[3] == '*'){
    *Flstar= 1;
    Str[3]= '\0';
  }
  else{
    if(Str[3] != '\0'){
      printf("%s - wrong Type%c\n",Str,7);
      return(1);
    }
    *Flstar= 0;
  }

  for(i= 0;i<n;i++){
    if(strncmp(Str,CW[i],3) == 0){
      break;
    }
  }
  if(*Flstar){
    Str[3]= '*';
  }

  if(i == n){
    printf("%s - wrong Type%c\n",Str,7);
    return(1);
  }

  if(i == 0||i == 5){
    if(*Flstar == 0){
      printf("%s - no '*' in  string object of %s type%c\n",Str,CW[i],7);
      return(1);
    }
    else{
      p= Str+4;
      while(*p != '\0'){
	if(isdigit(*p) == 0){
	  printf("%s - non-digit character '%c' in string length%c\n",
		 Str,*p,7);
	  return(1);
	}
	p++;
      }
      sscanf(Str+4,"%d",Flstar);
    }
    *id= i;
  }
  else{
    if(i>5){
      *id= 8+i-5;
    }
    else{
      *id= i;
    }
  }
  return(0);
}

int CbNm2IOVec(CbIOVec *IOvector,char *NmIOVec)
{
  int d,ic,k,L;
  int Fl;
  char*p,*p1;

  p= NmIOVec;
  IOvector->d= 0;
  d= 0;
  ic= 0;
  L= 0;
  k= 0;
  Fl= 0;
  while(*p != '\0'){
    if(*p == '['){
      ic++;
      if(isdigit(*(p+1))){
	Fl= 1;
      }
      else{
	Fl= 2;
      }
      if(ic>1){
	printf("%s has a nested '[' %c\n",NmIOVec,7);
	return(1);
      }
    }
    if(ic == 0){
      L++;
      k= d;
    }
    if(*p == ']'){
      ic--;
      d++;
      if(ic<0){
	printf("%s has more ']' than '[' %c\n",NmIOVec,7);
	return(1);
      }
    }
    if(ic&&*p != '['){
      if(Fl == 1){
	if(isdigit(*p) == 0){
	  printf("%s wrong number inside %d's bracket %c\n",NmIOVec,d+1,7);
	  return(1);
	}
      }
      else{
	if(isalnum(*p) == 0&&*p != '_'){
	  printf("%s wrong name of parameter inside %d's bracket %c\n",
		 NmIOVec,d+1,7);
	  return(1);
	}
      }
    }
    p++;
  }
  if(ic>0){
    printf("%s has more '[' than ']' %c\n",NmIOVec,7);
    return(1);
  }
  if(ic<0){
    printf("%s has more ']' than '[' %c\n",NmIOVec,7);
    return(1);
  }
  if(L == 0){
    printf("%s has no Name of Vector%c\n",NmIOVec,7);
    return(1);
  }

  IOvector->Nm= (char*)malloc((L+1+3*k)*sizeof(char));
  p= NmIOVec;
  p1= IOvector->Nm;

  IOvector->id= k<<4;
  L= 0;
  while(*p != '\0'){
    if(*p == '['){
      ic++;
    }
    if(ic == 0){
      *p1++=*p;
    }
    if(*p == ']'){
      L= 8;
      ic--;
      if(k){
	*p1++	='[';
	*p1++	='0';
	*p1++	=']';
	L= 0;
	k--;
      }
    }
    p++;
  }
  *p1= '\0';
  IOvector->id|= L;
  IOvector->d= d;
  if(d == 0){
    return(0);
  }
  IOvector->st= (int*)malloc(d*sizeof(int));
  for(k= 0;k<d;k++){
    IOvector->st[k]= 0;
  }
  return(0);
}

int CbDeInitIOVec()
{
  int i,k;
  for(i= 0;i<nIOVec;i++){
    free(IOVec[i].Nm);
    if(IOVec[i].d){
      free(IOVec[i].st);
    }
  }
  free(IOVec);
  return(0);
}

int CbAdd2IOParList(int n0,char*str)
{
  int i;

  for(i= n0;i<nPar;i++){
    if(strcmp(str,NmPar[i]) == 0)
      return(i);
  }
  NmPar[i]= (char*)malloc((strlen(str)+1)*sizeof(char));
  strcpy(NmPar[i],str);
  nPar++;
  if(nPar>=NPar){
    NPar	+=10;
    NmPar= (char**)realloc((void*)NmPar,NPar*sizeof(char*));
  }
  return(i);
}

int CbDeInitIONmPar()
{
  int i;

  for(i= 0;i<nPar;i++){
    free(NmPar[i]);
  }
  free(NmPar);
  free(IOStr);
  return(0);
}

int CbAdd2IOVecList(int nL0,int nP0,int n0,int ObjID,char*NmVec)
{
  int i,j,d,d0,id;
  char*p;
  CbIOVec*pV;

  i= CbNm2IOVec(IOVec+nIOVec,NmVec);
  if(i)
    return(-1);
  pV= IOVec+nIOVec;
  pV->id|= (ObjID&7);
  p= pV->Nm;
  id= pV->id;
  d= pV->d;
  d0= pV->id>>4;
  for(i= n0;i<nIOVec;i++){
    if(strcmp(IOVec[i].Nm,p) == 0){
      if(IOVec[i].id != id){
	printf("%s vector type <%s> does not match its previous type %s%c\n",
	       p,CbIOType[id],CbIOType[IOVec[i].id],7);
	return(-1);
      }
      if(IOVec[i].d != d){
	printf("%s vector depth %d does not match its previous value %d%c\n",
	       p,d,IOVec[i].d,7);
	return(-1);
      }
      free(pV->Nm);
      if(pV->d){
	free(pV->st);
      }
      return(i);
    }
  }
  nIOVec++;
  if(nIOVec>=NIOVec){
    NIOVec	+=10;
    IOVec= (CbIOVec*)realloc((void*)IOVec,NIOVec*sizeof(CbIOVec));
  }
  return(i);
}

int CbStr2VecPar(int kL,int kV,int nP0,char*NmIOVec)
{
  int d,ic,k,L;
  char*p,*p1,ch;
  CbIOLoop*pL;
  int d0,*iV,*fV;
  char**piV;

  pL= IOLoop+kL;
  k= pL->kV[kV];
  iV= pL->iV[kV];
  fV= pL->fV[kV];
  piV= pL->piV[kV];
  d0= IOVec[k].d;

  p= NmIOVec;
  ic= 0;
  d= 0;
  while(*p != '\0'){
    if(*p == '['){
      p1= p+1;
      ic++;
    }
    if(*p == ']'){
      if(isdigit(*p1)){
	sscanf(p1,"%d",&k);
	while(p1<p){
	  if(!isdigit(*p1)){
	    printf("%s contains a non-digit after '[' %c\n",NmIOVec,7);
	    return(1);
	  }
	  p1++;
	}
	piV[d]= NULL;
	iV[d]= k;
	fV[d]= -1;
      }
      else{
	ch= *p;
	*p= '\0';
	ic= pL->d;
	k= kL;
	while(ic){
	  if(IOLoop[k].NmI != NULL&&strcmp(IOLoop[k].NmI,p1) == 0){
	    fV[d]= k;
	    break;
	  }
	  k= IOLoop[k].pL;
	  ic= IOLoop[k].d;
	}
	L= p-p1;
	piV[d]= (char*)malloc(L*sizeof(char));
	p= p1;
	p1= piV[d];
	while(*p != '\0'){
	  *p1++	=*p++;
	}
	*p1= '\0';
	iV[d]= 0;

	if(ic == 0){
	  fV[d]= -1;
	  CbAdd2IOParList(nP0,piV[d]);
	}
	else{
	  fV[d]= ic;
	}
	*p= ch;
      }
      d++;
      ic= 0;
    }
    p++;
  }
  return(0);
}

int CbStr2IOLoop(int nP0,int nV0,int ObjID,char*Str)
{
  int i,n,nV,nL,nL0;
  int kpL,ic,ic1,d,k,L;
  char*p,*p1,*p2;
  CbIOLoop*pIO;

  nL0= nLoop;
  pIO= IOLoop+nLoop;
  kpL= pIO->pL;
  if(kpL<0){
    pIO->d= 0;
  }
  else{
    pIO->d= IOLoop[kpL].d+1;
  }

  p= Str;
  ic= 0;
  ic1= 0;
  nV= 0;
  nL= 0;
  while(*p != '\0'){
    if(ic1 == 0){
      if(*p == '['){
	if(ic){
	  printf("%s\n has extra '[':\n%s %c\n",Str,p,7);
	  return(1);
	}
	ic++;
      }
      if(*p == ']'){
	ic--;
	if(ic<0){
	  printf("%s\n has extra ']':\n%s %c\n",Str,p,7);
	  return(1);
	}
      }
      if(*p == '('){
	if(ic>0){
	  printf("%s\n has extra '[' before:\n%s%c\n",Str,p,7);
	  return(1);
	}
	if(ic<0){
	  printf("%s\n has extra ']' before:\n%s%c\n",Str,p,7);
	  return(1);
	}
	if(p>Str&&*(p-1) != ','){
	  printf("%s\n no ',' before '(':\n%s%c\n",Str,p,7);
	  return(1);
	}
      }
    }

    if(*p == '('){
      ic1++;
    }
    if(*p == ')'){
      ic1--;
      if(ic1<0){
	printf("%s\n extra ')' in loop:\n%s%c\n",Str,p,7);
	return(1);
      }
      if(*(p+1) != '\0'&&*(p+1) != ','){
	printf("%s\n no ',' after ')':\n%s%c\n",Str,p,7);
	return(1);
      }
    }
    if(ic == 0&&ic1 == 0){
      if(*p == ','){
	if(*(p-1) == ')')
	  nL++;
	else
	  nV++;
      }
      if(*p == '='){
	break;
      }
    }
    p++;
  }


  if(*p == '\0'){
    if(ic>0){
      printf("%s vector has extra '[' %c\n",Str,7);
      return(1);
    }
    if(ic<0){
      printf("%s vector has extra ']' %c\n",Str,7);
      return(1);
    }
    if(ic1>0){
      printf("%s loop has extra '(' %c\n",Str,7);
      return(1);
    }
    if(ic1<0){
      printf("%s loop has extra ')' %c\n",Str,7);
      return(1);
    }
    if(*(p-1) == ')')
      nL++;
    else
      nV++;
    pIO->i0= 0;
    pIO->i1= 1;
    pIO->st= 1;
    pIO->NmI= NULL;
    pIO->pi0= NULL;
    pIO->pi1= NULL;
    pIO->pst= NULL;
  }

  if(*p == '='){
    p1= p;
    while(*p1 != '\0'){
      if(*p1 == '('){
	printf("%s has extra '(' after '='%c\n",Str,7);
	return(1);
      }
      if(*p1 == ')'){
	ic1--;
      }
      p1++;
    }
    if(ic1>0){
      printf("%s loop has extra '(' %c\n",Str,7);
      return(1);
    }
    if(ic1<0){
      printf("%s loop has extra ')' after '='%c\n",Str,7);
      return(1);
    }

    p1= p;
    while(*p1 != ','&&p1>Str)
      p1--;
    L= p-p1;
    pIO->NmI= (char*)malloc(L*sizeof(char));
    p1++;
    p2= pIO->NmI;
    while(p1<p){
      *p2++	=*p1++;
    }
    *p2= '\0';

    p++;
    while(*p != '<'&&*p != '\0'){
      p++;
    }
    if(*p != '<'){
      printf("%s contains no '<' sign after '=':\n%s %c\n",Str,p1,7);
      return(1);
    }
    L= p-p1;
    p1++;
    if(isdigit(*p1)){
      sscanf(p1,"%d",&k);
      while(p1<p){
	if(!isdigit(*p1)){
	  printf("%s contains a non-digit starting at\n%s %c\n",Str,p1,7);
	  return(1);
	}
	p1++;
      }
      pIO->i0= k;
      pIO->pi0= NULL;
    }
    else{
      pIO->pi0= (char*)malloc(L*sizeof(char));
      p2= pIO->pi0;
      while(p1<p){
	*p2++	=*p1++;
      }
      *p2= '\0';
      pIO->i0= 0;
      if(CbAdd2IOParList(nP0,pIO->pi0)<0)
	return(1);
    }
    p++;
    while(*p != ':'&&*p != ';'&&*p != '\0'){
      p++;
    }
    L= p-p1;
    p1++;
    if(isdigit(*p1)){
      sscanf(p1,"%d",&k);
      while(p1<p){
	if(!isdigit(*p1)){
	  printf("%s contains a non-digit starting at\n%s %c\n",Str,p1,7);
	  return(1);
	}
	p1++;
      }
      pIO->i1= k;
      pIO->pi1= NULL;
    }
    else{
      pIO->pi1= (char*)malloc(L*sizeof(char));
      p2= pIO->pi1;
      while(p1<p){
	*p2++	=*p1++;
      }
      *p2= '\0';
      pIO->i1= 0;
      if(CbAdd2IOParList(nP0,pIO->pi1)<0)
	return(1);
    }
    if(*p != ':'){
      pIO->st= 1;
      pIO->pst= NULL;
    }
    else{
      p++;
      while(*p != '\0'){
	p++;
      }
      L= p-p1;
      p1++;
      if(isdigit(*p1)){
	sscanf(p1,"%d",&k);
	while(p1<p){
	  if(!isdigit(*p1)){
	    printf("%s contains a non-digit starting at\n%s %c\n",Str,p1,7);
	    return(1);
	  }
	  p1++;
	}
	pIO->st= k;
	pIO->pi1= NULL;
      }
      else{
	pIO->pst= (char*)malloc(L*sizeof(char));
	p2= pIO->pst;
	while(p1<p){
	  *p2++	=*p1++;
	}
	*p2= '\0';
	pIO->st= 0;
	if(CbAdd2IOParList(nP0,pIO->pst)<0)
	  return(1);
      }
    }
  }

  n= nV+nL;
  pIO->n= n;
  pIO->nV= nV;
  pIO->nL= nL;
  if(n)
    pIO->t= (int*)malloc(n*sizeof(int));
  if(nV){
    pIO->kV= (int*)malloc(3*nV*sizeof(int));
    pIO->i0V= pIO->kV+nV;
    pIO->stV= pIO->i0V+nV;
    pIO->iV= (int**)malloc(2*nV*sizeof(int*));
    pIO->fV= pIO->iV+nV;
    pIO->ImV= (char**)malloc(nV*sizeof(char*));
    pIO->piV= (char***)malloc(nV*sizeof(char**));
  }
  if(nL){
    pIO->kL= (int*)malloc(nL*sizeof(int));
  }

  p= Str;


  ic= 0;
  ic1= 0;
  nV= 0;
  nL= 0;
  n= 0;
  p1= p;
  while(*p != '\0'){
    if(ic1 == 0){
      if(*p == '['){
	ic++;
      }
      if(*p == ']'){
	ic--;
      }
    }
    if(*p == '('){
      ic1++;
    }
    if(*p == ')'){
      ic1--;
    }
    if(ic == 0&&ic1 == 0){
      if(*p == ','){
	if(*(p-1) == ')'){
	  if(*p1 != '('){
	    printf("%s has no '(' at beginning of the loop:\n%s %c\n",
		   Str,p1,7);
	    return(1);
	  }
	  *(p-1)= '\0';
	  pIO->t[n]= 8;
	  nLoop++;
	  pIO->kL[nL]= nLoop;
	  if(nLoop>=NLoop){
	    NLoop	+=10;
	    IOLoop= (CbIOLoop*)realloc((void*)IOLoop,NLoop*sizeof(CbIOLoop));
	  }
	  IOLoop[nLoop].pL= nL0;
	  if(CbStr2IOLoop(nP0,nV0,ObjID,p1+1))
	    return(1);
	  p1= p+1;
	  n++;
	  nL++;
	}
	else{
	  *p= '\0';
	  L= p-p1;
	  pIO->ImV[nV]= (char*)malloc(L*sizeof(char));
	  strcpy(pIO->ImV[nV],p1);
	  k= CbAdd2IOVecList(nL0,nP0,nV0,ObjID,p1);
	  pIO->kV[nV]= k;
	  if(k<0){
	    printf("%s has wrong vector:\n%s %c\n",Str,p1,7);
	    *p= ',';
	    return(1);
	  }
	  pIO->t[n]= 1;
	  d= IOVec[k].d;
	  if(d){
	    pIO->iV[nV]= (int*)malloc(2*d*sizeof(int));
	    pIO->fV[nV]= pIO->iV[nV]+d;
	    pIO->piV[nV]= (char**)malloc(d*sizeof(char*));
	    if(CbStr2VecPar(nL0,nV,nP0,p1)){
	      printf("%s has wrong vector parameters:\n%s %c\n",Str,p1,7);
	      return(1);
	    }
	  }
	  *p= ',';
	  p1= p+1;
	  nV++;
	  n++;
	}
      }
      if(*p == '=')
	break;
    }
    p++;
  }
  if(*p == '\0'){
    if(*(p-1) == ')'){
      if(*p1 != '('){
	printf("%s has no '(' at beginning of the loop:\n%s %c\n",
	       Str,p1,7);
	return(1);
      }
      *(p-1)= '\0';
      pIO->t[n]= 8;
      nLoop++;
      pIO->kL[nL]= nLoop;
      if(nLoop>=NLoop){
	NLoop	+=10;
	IOLoop= (CbIOLoop*)realloc((void*)IOLoop,NLoop*sizeof(CbIOLoop));
      }
      IOLoop[nLoop].pL= nL0;
      if(CbStr2IOLoop(nP0,nV0,ObjID,p1+1))
	return(1);
      p1= p+1;
      n++;
      nL++;
    }
    else{
      *p= '\0';
      L= p-p1;
      pIO->ImV[nV]= (char*)malloc(L*sizeof(char));
      strcpy(pIO->ImV[nV],p1);
      k= CbAdd2IOVecList(nL0,nP0,nV0,ObjID,p1);
      pIO->kV[nV]= k;
      if(k<0){
	printf("%s has wrong vector:\n%s %c\n",Str,p1,7);
	*p= ',';
	return(1);
      }
      pIO->t[n]= 1;
      d= IOVec[k].d;
      if(d){
	pIO->iV[nV]= (int*)malloc(2*d*sizeof(int));
	pIO->fV[nV]= pIO->iV[nV]+d;
	pIO->piV[nV]= (char**)malloc(d*sizeof(char*));
	if(CbStr2VecPar(nL0,nV,nP0,p1)){
	  printf("%s has wrong vector parameters:\n%s %c\n",Str,p1,7);
	  return(1);
	}
      }
      *p= ',';
      p1= p+1;
      nV++;
      n++;
    }
  }

  if(kpL<0){
    nLoop++;
    if(nLoop>=NLoop){
      NLoop	+=10;
      IOLoop= (CbIOLoop*)realloc((void*)IOLoop,NLoop*sizeof(CbIOLoop));
    }
  }

  return(0);
}

int CbDeInitOneIOLoop(int*ia)
{
  int i,j,n,k,m,iV,iL,iVL,nVL;

  i= *ia;
  iV= 0;
  iL= 0;
  iVL= 0;
  nVL= IOLoop[i].n;
  while(iVL<nVL){
    if(IOLoop[i].t[iVL] == 8){
      *ia= IOLoop[i].kL[iL];
      CbDeInitOneIOLoop(ia);
      iL++;
    }
    else{
      k= IOLoop[i].kV[iV];
      if(IOVec[k].d){
	for(m= 0;m<IOVec[k].d;m++){
	  if(IOLoop[i].piV[iV][m] != NULL)
	    free(IOLoop[i].piV[iV][m]);
	}
	free(IOLoop[i].iV[iV]);
	free(IOLoop[i].piV[iV]);
      }
      free(IOLoop[i].ImV[iV]);
      iV++;
    }
    iVL++;
  }
  if(IOLoop[i].nV){
    free(IOLoop[i].ImV);
    free(IOLoop[i].kV);
    free(IOLoop[i].iV);
    free(IOLoop[i].piV);
  }

  if(IOLoop[i].nL){
    free(IOLoop[i].kL);
  }
  if(IOLoop[i].n){
    free(IOLoop[i].t);
  }
  if(IOLoop[i].NmI != NULL){
    free(IOLoop[i].NmI);
  }
  if(IOLoop[i].pi0 != NULL){
    free(IOLoop[i].pi0);
  }
  if(IOLoop[i].pi1 != NULL){
    free(IOLoop[i].pi1);
  }
  if(IOLoop[i].pst != NULL){
    free(IOLoop[i].pst);
  }
  return(0);
}

int CbDeInitIOLoop()
{
  int i,j,n,k,m;

  i= 0;
  while(i<nLoop){
    CbDeInitOneIOLoop(&i);
    i++;
  }
  free(IOLoop);
  return(0);
}

int CbCheckIOFuncPar(char*p,char*NmFile,char*pF)
{
  while(isspace(*p))
    p++;
  if(*p != '('){
    printf("%s file: wrong character after %s in I/O function:\n\n",
	   NmFile,pF);
    return(1);
  }
  p++;
  while(*p != ')'&&*p != ';'&&*p != '\0'){
    p++;
  }
  if(*p != ')'){
    printf("%s file: no ')' in I/O function %s:\n\n",
	   NmFile,pF);
    return(1);
  }
  p++;
  while(*p != ';'&&*p != '\0'){
    p++;
  }
  if(*p != ';'){
    printf("%s file: no ';' after %s() in I/O function:\n\n",
	   NmFile,pF);
    return(1);
  }
  return(0);
}

int CbGetIOFuncPar(CbIOSet*pS,int N,char*p,char*NmFile,char*pF)
{
  char*p1,ch;
  int i,k,n;

  pS->i0[N]= 0;
  pS->ki0[N]= -1;
  pS->i1[N]= (unsigned)(-1)>>1;
  pS->ki1[N]= -1;

  while(*p != '(')
    p++;
  p++;
  while(isspace(*p))
    p++;
  if(*p != '"'){
    printf("%s file: no first '\"' inside I/O function %s:\n\n",
	   NmFile,pF);
    return(1);
  }
  p++;
  p1= p;
  while(*p != '"'&&*p != '='&&*p != '\0')
    p++;
  if(*p != '"'){
    printf("%s file: no second '\"' inside I/O function %s:\n\n",
	   NmFile,pF);
    return(1);
  }
  *p= '\0';
  k= pS->k;
  n= pS->n;
  for(i= k;i<n;i++){
    if(strcmp(p1,IOObj[i].NmE) == 0){
      pS->kO[N]= i;
      break;
    }
  }
  if(i == n){
    printf("%s file: wrong object name \"%s\" inside I/O function %s:\n\n",
	   NmFile,p1,pF);
    return(1);
  }
  *p= '"';
  p++;
  while(isspace(*p))
    p++;
  if(*p != ')'){
    if(*p != ','){
      printf("%s file: no ',' after object name inside I/O function %s:\n\n",
	     NmFile,pF);
      return(1);
    }
    p++;
    while(isalnum(*p)||*p == '_')
      p++;
    if(*p != '='){
      printf("%s file: no '=' after ',' inside I/O function %s:\n\n",
	     NmFile,pF);
      return(1);
    }
    p++;
    while(isspace(*p))
      p++;
    p1= p;
    if(isdigit(*p1)){
      p++;
      while(isdigit(*p))
	p++;
      while(isspace(*p))
	p++;
      if(*p != '<'&&*p != ')'){
	printf("%s file: wrong number after  '=' inside I/O function %s:\n\n",
	       NmFile,pF);
	return(1);
      }
      ch= *p;
      *p= '\0';
      sscanf(p1,"%d",&i);
      pS->i0[N]= i;
      pS->ki0[N]= -1;
      *p= ch;
    }
    else{
      p++;
      while(isalnum(*p)||*p == '_')
	p++;
      while(isspace(*p))
	p++;
      if(*p != '<'&&*p != ')'){
	printf("%s file: wrong variable after '=' inside I/O function %s:\n\n",
	       NmFile,pF);
	return(1);
      }
      ch= *p;
      *p= '\0';
      i= CbAdd2IOParList(pS->kP,p1);
      pS->ki0[N]= i;
      *p= ch;
    }
    if(*p == '<'){
      p++;
      while(isspace(*p))
	p++;
      p1= p;
      if(isdigit(*p1)){
	p++;
	while(isdigit(*p))
	  p++;
	while(isspace(*p))
	  p++;
	if(*p != ')'){
	  printf("%s file: wrong number after '<' inside I/O function %s:\n\n",
		 NmFile,pF);
	  return(1);
	}
	*p= '\0';
	sscanf(p1,"%d",&i);
	pS->i1[N]= i;
	pS->ki1[N]= -1;
	*p= ')';
      }
      else{
	p++;
	while(isalnum(*p)||*p == '_')
	  p++;
	while(isspace(*p))
	  p++;
	if(*p != ')'){
	  printf("%s file: wrong name after '<' inside I/O function %s:\n\n",
		 NmFile,pF);
	  return(1);
	}
	*p= '\0';
	i= CbAdd2IOParList(pS->kP,p1);
	pS->ki1[N]= i;
	*p= ')';
      }
    }
  }
  p++;
  while(isspace(*p))
    p++;
  if(*p != ';'){
    printf("%s file: no ';' after %s() in I/O function:\n\n",
	   NmFile,pF);
    return(1);
  }
  return(0);
}

int CbInitIOSet(char*NmFile,int iI,int iT)
{
  int i,L,iN,N,Lf;
  char*p,*p1,*p2,*p0;
  char*pF;
  CbIOSet*pS;
  CbIOObj*pO;

  iN= iI+3;
  pS= IOSet[iN]+iT;
  if(IOInsFl[iN])
    return(0);

  pF= CbIOFunc[iI%2];
  Lf= strlen(pF);
  pS->k= nIOObj;
  pS->kP= nPar;
  pS->kV= nIOVec;

  p= BuffIO[iN];
  N= 0;
  while(*p != '{')
    p++;
  p++;
  while(*p != '}'){
    pO= IOObj+nIOObj;
    while(isspace(*p))
      p++;
    if(*p == '}')
      break;
    if(*p != '"'){
      p0= p;
      if(strncmp(pF,p,Lf) == 0){
	p	+=Lf;
	if(CbCheckIOFuncPar(p,NmFile,pF)){
	  PPrintLine(p0,p);
	  printf("\n in Section <%s>%c\n",BuffIO[iN],7);
	  return(1);
	}
	p++;
	while(*p != ';'&&*p != '\0')
	  p++;
	if(*p != ';'){
	  printf("%s file: no  ';' in I/O object:\n\n",NmFile);
	  PPrintLine(p0,p);
	  printf("\n in Section <%s>%c\n",BuffIO[iN],7);
	  return(1);
	}
	N++;
      }
      else{
	printf("%s file: no first '\"' in I/O object:\n\n",NmFile);
	PPrintLine(p0,p);
	printf("\n in Section <%s>%c\n",BuffIO[iN],7);
	return(1);
      }
    }
    else{
      p0= p;
      p++;
      while(isspace(*p))
	p++;
      p1= p;
      while(*p != '"'&&*p != '='&&*p != ';'&&*p != '}'){
	p++;
      }
      if(*p != '"'){
	printf("%s file: no second '\"' in I/O object:\n\n",NmFile);
	PPrintLine(p0,p);
	printf("\n in Section <%s>%c\n",BuffIO[iN],7);
	return(1);
      }
      L= p-p1;
      if(L){
	p--;
	while(isspace(*p))
	  p--;
	p++;
      }
      else{
	printf("%s file: External name of object is absent\n\n",NmFile);
	PPrintLine(p0,p);
	printf("\n in Section <%s>%c\n",BuffIO[iN],7);
	return(1);
      }
      L= p-p1;
      pO->NmE= (char*)malloc(L*sizeof(char));
      p2= pO->NmE;
      while(p1<p){
	*p2++	=*p1++;
      }
      *p2= '\0';
      while(*p != '"'){
	p++;
      }
      p2= pO->NmE;
      for(i= pS->k;i<nIOObj;i++){
	if(strcmp(p2,IOObj[i].NmE) == 0){
	  printf("%s file: External name '%s'  ==  '%s' ",
		 NmFile,p2,IOObj[i].NmE);
	  printf("is double defined in I/O object%c:\n\n",7);
	  PPrintLine(p0,p);
	  printf("\n in Section <%s>%c\n",BuffIO[iN],7);
	  free(pO->NmE);
	  return(1);
	}
      }
      p++;
      while(isspace(*p))
	p++;
      if(*p != '('){
	pO->nU= -1;
	pO->iU= 0;
      }
      else{
	p++;
	p1= p;
	while(*p != ')'&&*p != '='&&*p != '"'&&*p != ';'&&*p != '}'){
	  p++;
	}
	if(*p != ')'){
	  printf("%s file: no second ')' in I/O object:\n\n",NmFile);
	  PPrintLine(p0,p);
	  printf("\n\n in Section <%s>%c\n",BuffIO[iN],7);
	  return(1);
	}
	*p= '\0';
	if(CbGetUnits(&(pO->nU),&(pO->iU),p1)){
	  printf("%s file: wrong Units description in I/O object:\n\n",NmFile);
	  PPrintLine(p0,p);
	  printf("\n in Section <%s>%c\n",BuffIO[iN],7);
	  return(1);
	}
	*p= ')';
	p++;
	while(isspace(*p))
	  p++;
      }
      if(*p != '='){
	printf("%s file: no '=' in I/O object:\n\n",NmFile);
	PPrintLine(p0,p);
	printf("\n in Section <%s>%c\n",BuffIO[iN],7);
	return(1);
      }
      p++;
      while(isspace(*p))
	p++;
      if(*p != '('){
	printf("%s file: no '(' after '=' in I/O object:\n\n",NmFile);
	PPrintLine(p0,p);
	printf("\n in Section <%s>%c\n",BuffIO[iN],7);
	return(1);
      }
      p++;
      p1= p;
      while(*p != ')'&&*p != '"'&&*p != ';'&&*p != '}'){
	p++;
      }
      if(*p != ')'){
	printf("%s file: no ')' after '=(' in I/O object:\n\n",NmFile);
	PPrintLine(p0,p);
	printf("\n in Section <%s>%c\n",BuffIO[iN],7);
	return(1);
      }

      *p= '\0';
      if(CbGetType(&i,&(pO->id),p1)){
	printf("%s file: wrong Type  in I/O object:\n\n",NmFile);
	PPrintLine(p0,p);
	printf("\n in Section <%s>%c\n",BuffIO[iN],7);
	return(1);
      }
      pO->id&= 7;
      *p= ')';
      p++;
      while(isspace(*p))
	p++;
      if(*p != '"'){
	printf("%s file: no third '\"' in I/O object:\n\n",NmFile);
	PPrintLine(p0,p);
	printf("\n in Section <%s>%c\n",BuffIO[iN],7);
	return(1);
      }
      p++;
      p1= p;
      L= 0;
      while(*p != '"'&&*p != ';'&&*p != '}'){
	if(isspace(*p) == 0)
	  L++;
	p++;
      }
      if(*p != '"'){
	printf("%s file: no fourth '\"' in I/O object:\n\n",NmFile);
	PPrintLine(p0,p);
	printf("\n in Section <%s>%c\n",BuffIO[iN],7);
	return(1);
      }
      if(L == 0){
	printf("%s file: object is absent\n\n",NmFile);
	PPrintLine(p0,p);
	printf("\n in Section <%s>%c\n",BuffIO[iN],7);
	return(1);
      }

      if(L>NIOStr){
	NIOStr	+=NIOStr-L+132;
	free(IOStr);
	IOStr= (char*)malloc(NIOStr*sizeof(char));
      }
      p= p1;
      p2= IOStr;
      while(*p != '"'){
	if(isspace(*p) == 0){
	  *p2++	=*p;
	}
	p++;
      }
      *p2= '\0';
      pO->nL= nLoop;
      IOLoop[nLoop].pL= -1;
      if(CbStr2IOLoop(pS->kP,pS->kV,pO->id,IOStr)){
	printf("%s file: wrong object\n\n",NmFile);
	PPrintLine(p0,p);
	printf("\n in Section <%s>%c\n",BuffIO[iN],7);
	return(1);
      }
      p++;
      while(isspace(*p))
	p++;
      if(*p == '*'){
	p++;
	while(isspace(*p))
	  p++;
	p1= p;
	p2= IOStr;
	while(*p != ';'&&isspace(*p) == 0&&*p != '}'){
	  *p2++	=*p++;
	}
	*p2= '\0';
	L= p2-IOStr;
	if(isdigit(*IOStr)){
	  p2= IOStr;
	  while(isdigit(*p2))
	    p++;
	  if(*p2 != '\0'){
	    printf("%s file: wrong Scale factor in I/O object\n\n",NmFile);
	    PPrintLine(p0,p);
	    printf("\n in Section <%s>%c\n",BuffIO[iN],7);
	    return(1);
	  }
	  pO->pSc= NULL;
	  sscanf(IOStr,"%lg",&(pO->Sc));
	}
	else{
	  pO->pSc= (char*)malloc(L*sizeof(char));
	  strcpy(pO->pSc,IOStr);
	  pO->Sc= 1.;
	}
	while(isspace(*p))
	  p++;
      }
      if(*p != ';'){
	printf("%s file: no  ';' at the end of I/O object:\n\n",NmFile);
	PPrintLine(p0,p);
	printf("\n in Section <%s>%c\n",BuffIO[iN],7);
	return(1);
      }
      nIOObj++;
      if(nIOObj>=NIOObj){
	NIOObj	+=50;
	IOObj= (CbIOObj*)realloc((void*)IOObj,NIOObj*sizeof(CbIOObj));
      }
    }
    p++;
  }

  pS->n= nIOObj-pS->k;
  pS->N= N;
  pS->kO= (int*)malloc(5*N*sizeof(int));
  pS->i0= pS->kO+N;
  pS->i1= pS->i0+N;
  pS->ki0= pS->i1+N;
  pS->ki1= pS->ki0+N;

  p= BuffIO[iN];
  N= 0;
  while(*p != '{')
    p++;
  p++;
  while(*p != '}'){
    while(isspace(*p))
      p++;
    if(*p == '}')
      break;
    if(*p != '"'){
      if(strncmp(pF,p,Lf) == 0){
	p	+=Lf;
	if(CbGetIOFuncPar(pS,N,p,NmFile,pF)){
	  PPrintLine(p0,p);
	  printf("\n in Section <%s>%c\n",BuffIO[iN],7);
	  return(1);
	}
	N++;
      }
      p++;
      while(*p != ';'&&*p != '\0')
	p++;
    }
    else{
      p++;
      while(*p != ';'&&*p != '\0')
	p++;
    }
    p++;
  }

  pS->kS= nPar;
  for(i= pS->k;i<nIOObj;i++){
    pO= IOObj+i;
    if(pO->pSc != NULL){
      CbAdd2IOParList(pS->kP,pO->pSc);
    }
  }

  pS->nP= nPar-pS->kP;
  pS->nV= nIOVec-pS->kV;
  return(0);
}

int CbDeInitIOObj()
{
  int k;

  for(k= 0;k<NIOObj;k++){
    free(IOObj[k].NmE);
  }
  free(IOObj);
  return(0);
}

int CbDeInitIOSet()
{
  int k,i;

  CbDeInitIOLoop();
  CbDeInitIOVec();
  CbDeInitIOObj();
  for(k= 0;k<NType;k++){
    for(i= 0;i<nTbl;i++){
      if(IOSet[k][i].N){
	free(IOSet[k][i].kO);
      }
    }
    free(IOSet[k]);
  }
  free(IOSet);
  return(0);
}

int CbGetIOStrAdd(char***Nm,char**Str,CbIOLoop**Loop,CbIOVec**Vec,
		  CbIOObj**Obj,CbPltSet**Plt0,CbIOSet***Set)
{
  *Nm	=NmPar;
  *Str	=IOStr;
  *Loop	=IOLoop;
  *Vec	=IOVec;
  *Obj	=IOObj;
  *Plt0	=PltSet;
  *Set	=IOSet;
  return(0);
}

int CbGetIOStruct2AR(CbIOLoop**Loop,CbIOVec**Vec,
		     CbIOObj**Obj,CbPltSet**Plt0,CbIOSet***Set)
{
  *Loop	=IOLoop;
  *Vec	=IOVec;
  *Obj	=IOObj;
  *Plt0	=PltSet;
  *Set	=IOSet;
  return(0);
}
