#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <dirent.h>
#include <sys/stat.h>
#include <unistd.h>
#include <ctype.h>
#include "CbType.h"

#ifdef CRAY
#define kblbmd_ KBLBMD
#define kstgmd_ KSTGMD
#define kblbsv_ KBLBSV
#define kstgsv_ KSTGSV
#define kblbrd_ KBLBRD
#define kstgrd_ KSTGRD
#define kblbwr_ KBLBWR
#define kstgwr_ KSTGWR
#define kblbbo_ KBLBBO
#define kstgbo_ KSTGBO
#define kblbtb_ KBLBTB
#define kstgtb_ KSTGTB
#define kblbbi_ KBLBBI
#define kstgbi_ KSTGBI
#define kblbai_ KBLBAI
#define kstgai_ KSTGAI
#define kblbao_ KBLBAO
#define kstgao_ KSTGAO
#define kexitm_ KEXITM
#endif

#ifdef HP
#define kblbmd_ kblbmd
#define kstgmd_ kstgmd
#define kblbsv_ kblbsv
#define kstgsv_ kstgsv
#define kblbrd_ kblbrd
#define kstgrd_ kstgrd
#define kblbwr_ kblbwr
#define kstgwr_ kstgwr
#define kblbbo_ kblbbo
#define kstgbo_ kstgbo
#define kblbtb_ kblbtb
#define kstgtb_ kstgtb
#define kblbbi_ kblbbi
#define kstgbi_ kstgbi
#define kblbai_ kblbai
#define kstgai_ kstgai
#define kblbao_ kblbao
#define kstgao_ kstgao
#define kexitm_ kexitm
#endif

extern int CbMemoryL;
extern CbUnits*XUnits;
extern int NXUnits;

extern int NCbMode,iCbModeSet,NCbOut,iCbOutSet,NCbInp,iCbInpSet;

extern char*CbUAliasMode;
extern char*CbLAliasMode;
extern char*CbUAliasOut;
extern char*CbLAliasOut;
extern char*CbUAliasInp;
extern char*CbLAliasInp;

static FILE*fp;
static char NmF[80],ln[80],ln1[80];
static int NBuff,nBuff;
static char*Buff,*pBuff;
static int NDBuff,nDBuff;
static char*DBuff,*pDBuff,*eDBuff;
static int*nMI,*iMI,kMI;

static CbVectorNm*VecNm;
static int NVecNm;

static BLB*blb;
static int Nblb,nblb=0,iblb,nCbB;

static int nBlb=0,nMzl=0,nStg=0;
static BBLB *Blb;
static STG *Stg;
static MZL *Mzl;

static char*NoHelpMess= "Help is NOT written yet.\n";

static int*BDpth,*MDpth,*SDpth,*EDpth,nDpth,NDpth;
static int instB= 0,instM= -1,instS= -1;

static DIR*dirp;
static struct dirent*direntp;
static struct stat statbuf;
static char***BlbInpFNmD,***BlbInpFNmW,***BlbInpFNmO,***BlbInpFNmI;
static char****MzlInpFNmW,****MzlInpFNmO,****MzlInpFNmI;
static char*****StgInpFNmW,*****StgInpFNmO,*****StgInpFNmI;
static int*kBlbInpDir,NExtW= 4,NExtO= 2,NExtI= 4;
static char*InpFExtW[]= {".sv",".rd",".wr",".tb"};
static char*InpFExtO[]= {".bo",".ao"};
static char*InpFExtI[]= {".bi",".ai",".bo",".ao"};

char *CbGetCodeNm()
{
  return(blb[0].NmB);
}

int ReadCbTofContent()
{
  char ch,ch1;
  int ic;

  pBuff	=Buff;
  nBuff	=0;
  ch	='\n';
  ic	=-1;
  while(feof(fp) == 0 && ic != 0){
    ch1	=ch;
    ch	=getc(fp);
    if(ch1 == '/' && ch == '*'){
      ch	='+';
      while(feof(fp) == 0 && (ch1!='*'||ch!='/')){
	ch1	=ch;
	ch	=getc(fp);
      }
      ch1	=' ';
      ch	=' ';
      pBuff--;
      nBuff--;
      continue;
    }
    if(ch == '#'){
      while(feof(fp) == 0 && ch != '\n'){
	ch1	=ch;
	ch	=getc(fp);
      }
      if(pBuff > Buff && *(pBuff-1) != '\n'){
	*pBuff++	='\n';
	nBuff++;
      }
      continue;
    }
    if(ch == '{'){
      if(ic == -1){
	ic =0;
      }
      ic++;
    }
    if(ch == '}'){
      ic--;
      if(ic < 0){
	*pBuff	='\0';
	return(nBuff);
      }
    }
    *pBuff++	=ch;
    nBuff++;
  }
  if(feof(fp)){
    *pBuff	='\0';
    return(0);
  }
  *pBuff	='\0';
  return(nBuff);
}

int ReadCbDescription()
{
  char ch,ch1,*pnt;
  int ic,icB,Fl,FlBl;
  static int nCbW=5,LCbW=3,iCbW,jCbW;
  char*CbW[5]= {"stg_","Stg_","mzl_","blb_","Blb_"};
  char *lHlp="Hlp=";

  pDBuff	=DBuff;
  *pDBuff++	='\n';
  ch	='\n';
  ic	=0;
  icB	=1;
  pnt	=CbW[0];
  Fl	=0;
  jCbW	=0;
  FlBl	=0;
  while(feof(fp) == 0){
    ch1	=ch;
    ch	=getc(fp);
    if(ch1 == '/' && ch == '*'){
      ch	='+';
      while(feof(fp) == 0 && (ch1 != '*' || ch != '/')){
	ch1	=ch;
	ch	=getc(fp);
      }
      ch1	=' ';
      ch	=' ';
      if(Fl){
	pDBuff--;
      }
      continue;
    }
    if(ch == '#'){
      while(feof(fp) == 0 && ch != '\n'){
	ch1	=ch;
	ch	=getc(fp);
      }
      if(Fl && pDBuff > DBuff && *(pDBuff-1) != '\n'){
	*pDBuff++= '\n';
      }
      continue;
    }
    if(jCbW == 0){
      for(iCbW=0 ; iCbW < nCbW; iCbW++){
	if(ch == *CbW[iCbW]){
	  break;
	}
      }
      if(iCbW < nCbW){
	jCbW++;
	pnt	=CbW[iCbW]+1;
	Fl	=1;
	icB	=ic+1;
      }
    }
    else{
      if(*pnt != '\0'){
	if(ch == *pnt){
	  jCbW++;
	  pnt++;
	}
	else{
	  pDBuff	-=jCbW;
	  Fl	=0;
	  jCbW	=0;
	}
      }
    }
    if(Fl){
      if(!isspace(ch)){
	if(ch == '}'){
	  *pDBuff++	='\n';
	}
	*pDBuff++	=ch;
	if(ch == ';' || ch == '{'){
	  *pDBuff++	='\n';
	}
	if(ch == '=' && strncmp(pDBuff-4,lHlp,4) == 0){
	  while(feof(fp) == 0 && (ch1 != '\\' || ch != ';')){
	    ch1	=ch;
	    ch	=getc(fp);
	    *pDBuff++	=ch;
	  }
	}
      }
    }
    if(ch == '{'){
      ic++;
    }
    if(ch == '}'){
      ic--;
      if(ic < icB){
	*pDBuff++	='\n';
	Fl	=0;
	jCbW	=0;
      }
    }
  }
  *pDBuff	='\0';
  nDBuff	=pDBuff-DBuff;
  eDBuff	=pDBuff;
  return(0);
}

int CbFreeBuff()
{
  free(Buff);
  return(0);
}

int CbFreeBLB()
{
  int i,iM,iS,nS;
#ifdef H
  CbSaveCntrPanel(".");
#endif
  for(i=0; i < nblb; i++){
    free(blb[i].pathI);
    free(blb[i].path);
    for(iM= 0;iM<blb[i].nM;iM++){
      nS	=blb[i].nS[iM];
      for(iS= 0;iS<nS;iS++){
	free(blb[i].NmS[iM][iS]);
      }
      if(blb[i].nB[iM]){
	free(blb[i].kB[iM]);
      }
      free(blb[i].NmM[iM]);
      free(blb[i].NmS[iM]);
      free(blb[i].mS[iM]);
      free(blb[i].NmSTF[iM]);
    }
    if(blb[i].nM){
      free(blb[i].NmS);
      free(blb[i].NmM);
      free(blb[i].mS);
      free(blb[i].nS);
    }
    free(blb[i].NmB);
  }
  nblb	=0;
  nCbB	=0;
  return(0);
}

int CbFreeDepth()
{
  free(BDpth);
  return(0);
}


int CbFreeBlb()
{
  int i;
  for(i=0; i < nMzl; i++){
    free(Mzl[i].S);
  }
  for(i=0; i < nBlb; i++){
    free(Blb[i].M);
  }
  free(Stg);
  free(Mzl);
  free(Blb);
  return(0);
}

int CbFreeHlp2TxtFile()
{
  int i;

  for(i=0; i < nStg; i++){
    if(Stg[i].Hlp != NULL){
      free(Stg[i].Hlp);
    }
  }
  for(i=0; i < nMzl; i++){
    if(Mzl[i].Hlp != NULL){
      free(Mzl[i].Hlp);
    }
  }
  for(i=0; i < nBlb; i++){
    if(Blb[i].Hlp != NULL){
      free(Blb[i].Hlp);
    }
  }
  return(0);
}

int CbRedirectHlp2TxtFile()
{
  BLB *pntB;
  BBLB *lB;
  STG *lS;
  MZL *lM;
  int i,im,is,iM,nM,iS,nS,iB,nB,k;
  char NmF[64];

  im	=0;
  is	=0;
  for(iB=0; iB < nblb; iB++){
    pntB=blb+iB;
    lB	=Blb+iB;
    pntB->HpB	=NULL;
    sprintf(NmF,"Hlp/%s.txt",lB->Nm);
    if(stat(NmF,&statbuf) == 0){
      k		=statbuf.st_size;
      fp	=fopen(NmF,"r");
      if(fp != NULL){
	pntB->HpB	=(char*)malloc((k+1)*sizeof(char));
	fread(pntB->HpB,k,1,fp);
	fclose(fp);
      }
    }
    lB->Hlp	=pntB->HpB;

    nM	=lB->nM;
    for(iM=0; iM < nM; iM++){
      lB->M[iM]	=is;
      lM	=Mzl+im;
      pntB->HpM[iM]	=NULL;
      sprintf(NmF,"Hlp/%s.txt",lM->Nm);
      if(stat(NmF,&statbuf) == 0){
	k	=statbuf.st_size;
	fp	=fopen(NmF,"r");
	if(fp != NULL){
	  pntB->HpM[iM]	=(char*)malloc((k+1)*sizeof(char));
	  fread(pntB->HpM[iM],k,1,fp);
	  fclose(fp);
	}
      }
      lM->Hlp	=pntB->HpM[iM];
      nS	=lM->nS;
      for(iS=0; iS < nS; iS++){
	lS	=Stg+is;
	pntB->HpS[iM][iS]	=NULL;
	sprintf(NmF,"Hlp/%s.txt",lS->Nm);
	if(stat(NmF,&statbuf) == 0){
	  k	=statbuf.st_size;
	  fp	=fopen(NmF,"r");
	  if(fp != NULL){
	    pntB->HpS[iM][iS]	=(char*)malloc((k+1)*sizeof(char));
	    fread(pntB->HpS[iM][iS],k,1,fp);
	    fclose(fp);
	  }
	}
	lS->Hlp	=pntB->HpS[iM][iS];
	is++;
      }
      im++;
    }
  }
  CbMemoryL |=0x00001000;
  return(0);
}

int CbConvertBLB()
{
  BLB *pntB;
  BBLB *lB;
  STG *lS;
  MZL *lM;
  int i,im,is,iM,nM,iS,nS,iB,nB,kB;
  char str[16];

  nMzl	=0;
  nStg	=0;
  for(iB=0; iB < nblb; iB++){
    pntB	=blb+iB;
    nMzl	+=pntB->nM;
    nM	=pntB->nM;
    for(iM=0; iM < nM; iM++){
      nStg	+=pntB->nS[iM];
    }
  }
  nBlb	=nblb;
  Blb	=(BBLB*)malloc(nBlb*sizeof(BBLB));
  Mzl	=(MZL*)malloc(nMzl*sizeof(MZL));
  Stg	=(STG*)malloc(nStg*sizeof(STG));
  CbMemoryL |=0x00000800;

  im	=0;
  is	=0;
  for(iB=0; iB < nblb; iB++){
    pntB=blb+iB;
    lB	=Blb+iB;
    lB->Nm	=pntB->NmB;
    lB->TF	=pntB->NmBTF;
    lB->SF	=pntB->NmBSF;
    lB->Tt	=pntB->TtB;
    lB->Tb	=pntB->TbB;
    lB->Hlp	=pntB->HpB;
    lB->m	=pntB->mB;
    lB->O	=pntB->OB;
    lB->I	=pntB->IB;
    lB->mt	=pntB->mBt;
    lB->Ot	=pntB->OBt;
    lB->It	=pntB->IBt;
    lB->im	=pntB->imB;
    lB->iO	=pntB->iOB;
    lB->iI	=pntB->iIB;
    lB->imt	=pntB->imBt;
    lB->iOt	=pntB->iOBt;
    lB->iIt	=pntB->iIBt;
    lB->iB	=pntB->iB;
    lB->iM	=pntB->iM;
    lB->kB	=pntB->kS;
    lB->dDB	=pntB->dDB;
    lB->dCb	=pntB->dCb;
    strcpy(lB->OD,pntB->OD);
    strcpy(lB->ID,pntB->ID);
    lB->t[0]	=pntB->t[0];
    lB->t[1]	=pntB->t[1];
    lB->t[2]	=pntB->t[2];
    lB->lO	=pntB->path;
    lB->lI	=pntB->pathI;
    lB->LO	=pntB->Lpath;
    lB->LI	=pntB->LpathI;
    lB->s	=pntB->s;
    lB->xM	=pntB->xM;
    lB->iC	=pntB->iCB;
    lB->jC	=pntB->jCB;
    lB->jD	=pntB->jDB;
    nM		=pntB->nM;
    lB->nM	=nM;
    lB->xM	=pntB->xM;
    lB->M	=(int*)malloc(nM*sizeof(int));
    for(iM=0; iM < nM; iM++){
      lB->M[iM]	=is;
      lM	=Mzl+im;
      lM->Nm	=pntB->NmM[iM];
      lM->TF	=pntB->NmMTF[iM];
      lM->SF	=pntB->NmMSF[iM];
      lM->Tt	=pntB->TtM[iM];
      lM->Tb	=pntB->TbM[iM];
      lM->Hlp	=pntB->HpM[iM];

      lM->m	=pntB->mM[iM];
      lM->O	=pntB->OM[iM];
      lM->I	=pntB->IM[iM];
      lM->mt	=pntB->mMt[iM];
      lM->Ot	=pntB->OMt[iM];
      lM->It	=pntB->IMt[iM];
      lM->im	=pntB->imM[iM];
      lM->iO	=pntB->iOM[iM];
      lM->iI	=pntB->iIM[iM];
      lM->imt	=pntB->imMt[iM];
      lM->iOt	=pntB->iOMt[iM];
      lM->iIt	=pntB->iIMt[iM];
      lM->iB	=pntB->iMB[iM];

      lM->iC	=pntB->iCM[iM];
      lM->jC	=pntB->jCM[iM];

      lM->nB	=pntB->nB[iM];
      lM->kB	=pntB->kB[iM];
      lM->B	=pntB->nxtB[iM];
      nS	=pntB->nS[iM];
      lM->nS	=nS;
      lM->S	=(int*)malloc(nS*sizeof(int));
      for(iS=0; iS < nS; iS++){
	lM->S[iS]=is;
	lS	=Stg+is;
	lS->Nm	=pntB->NmS[iM][iS];
	lS->TF	=pntB->NmSTF[iM][iS];
	lS->SF	=pntB->NmSSF[iM][iS];
	lS->Tt	=pntB->TtS[iM][iS];
	lS->Tb	=pntB->TbS[iM][iS];
	lS->Hlp	=pntB->HpS[iM][iS];
	
	lS->m	=pntB->mS[iM][iS];
	lS->O	=pntB->OS[iM][iS];
	lS->I	=pntB->IS[iM][iS];
	lS->mt	=pntB->mSt[iM][iS];
	lS->Ot	=pntB->OSt[iM][iS];
	lS->It	=pntB->ISt[iM][iS];
	lS->im	=pntB->imS[iM][iS];
	lS->iO	=pntB->iOS[iM][iS];
	lS->iI	=pntB->iIS[iM][iS];
	lS->imt	=pntB->imSt[iM][iS];
	lS->iOt	=pntB->iOSt[iM][iS];
	lS->iIt	=pntB->iISt[iM][iS];
	lS->iB	=iB;
	lS->iM	=iM;
	
	lS->iC	=pntB->iCS[iM][iS];
	lS->jC	=pntB->jCS[iM][iS];
	is++;
      }
      im++;
    }
  }
  return(0);
}

int CbInitBLB(char*argv)
{
  int i,j,nM,iM;
  char ch,*p,*p1;
  
  iCbModeSet	=NCbMode-1;
  iCbOutSet	=NCbOut-1;
  iCbInpSet	=NCbInp-1;
  
  strcpy(NmF,argv);

  if(stat(NmF,&statbuf)){
    return(1);
  }
  NDBuff	=statbuf.st_size;
  fp	=fopen(NmF,"r");
  if(fp == NULL){
    fclose(fp);
    return(1);
  }
  Buff	=(char*)malloc(NDBuff*sizeof(char));
  CbMemoryL |=0x00000001;
  
  FailureAlarm((char*)Buff,"CbInitBLB() - no memory for Buff");
  NBuff	=ReadCbTofContent();
  if(NBuff == 0){
    fclose(fp);
    CbDeInitCb();
    return(1);
  }
  NDBuff	-=NBuff;
  DBuff		=Buff+NBuff;
  if(ReadCbDescription()){
    fclose(fp);
    CbDeInitCb();
    return(1);
  }
  fclose(fp);
  
  Nblb	=10;
  blb	=(BLB*)malloc(Nblb*sizeof(BLB));
  CbMemoryL |=0x00000002;
  FailureAlarm((char*)blb,"CbInitBLB() - no memory for blb");
  
  if(GetCbTofContent()){
    CbDeInitCb();
    return(1);
  }
  
  for(i=0; i <nblb; i++){
    blb[i].OD[0]	='\0';
    blb[i].ID[0]	='\0';
    blb[i].t[0]	=0.;
    blb[i].t[1]	=1.;
    blb[i].t[2]	=0.1;
  }

#ifdef H
  i	=0;
  CbPrintBLB(0,&i);
#endif
  
  if(GetCbDescription()){
    CbDeInitCb();
    return(1);
  }
  NDpth	=1;
  CbInitBlbDepth(0);
  NDpth	+=2;
  
  for(i=0; i < nblb; i++){
    nM	=blb[i].nM;
    for(iM=0; iM < nM; iM++){
      j	=blb[i].iMB[iM];
      if(j >= 0){
	blb[i].HpM[iM]	=blb[j].HpM[blb[i].iMM[iM]];
      }
    }
  }

  BDpth	=(int*)malloc(4*NDpth*sizeof(int));
  CbMemoryL |=0x00000004;
  MDpth	=BDpth+NDpth;
  SDpth	=MDpth+NDpth;
  EDpth	=SDpth+NDpth;
  nDpth		=0;
  BDpth[0]	=0;
  MDpth[0]	=0;
  SDpth[0]	=0;
  EDpth[0]	=0; 

  CbRestoreCntrPanel(".");
  CbInitBlbOutPath(0);
  CbInitListInputFiles();
  CbInitModeSetting();
  CbInitUnits();

  CbConvertBLB();
  CbRedirectHlp2TxtFile();
  return(0);
}

int CbSaveCntrPanel(char *Dir)
{
  int i,k,iB,iM,iS,nM,nS,m;
  BLB*pntB;
  pntB	=blb;
  sprintf(NmF,"%s/Wrk/%s.Cntr",Dir,pntB->NmB);
  fp	=fopen(NmF,"r");
  if(fp != NULL){
    char ln[64];
    sprintf(ln,"mv %s %sO",NmF,NmF);
    system(ln); 
    fclose(fp);
  }
  fp	=fopen(NmF,"w");
  if(fp != NULL){
    for(iB	=0; iB < nblb;iB++){
      pntB	=blb+iB;
      m	=pntB->mBt;
      CbSwitch2Str(ln,CbLAliasMode,m);
      fprintf(fp,"%2d %2d %6s",pntB->s,m&0x7f,ln);
      CbSwitch2Str(ln,CbLAliasMode,pntB->imBt);
      fprintf(fp," %6s",ln);
      m	=pntB->OBt;
      CbSwitch2Str(ln,CbLAliasOut,m);
      fprintf(fp," %2d %6s",m&0x7f,ln);
      CbSwitch2Str(ln,CbLAliasOut,pntB->iOBt);
      fprintf(fp," %6s",ln);
      m	=pntB->IBt;
      CbSwitch2Str(ln,CbLAliasInp,m);
      fprintf(fp," %2d %6s",m&0x7f,ln);
      CbSwitch2Str(ln,CbLAliasInp,pntB->iIBt);
      fprintf(fp," %6s --- Blb : %s\n",ln,pntB->NmB);
      nM	=pntB->nM;
      for(iM= 0;iM<nM;iM++){
	m	=pntB->mMt[iM];
	CbSwitch2Str(ln,CbLAliasMode,m);
	fprintf(fp,"   %2d %6s",m&0x7f,ln);
	CbSwitch2Str(ln,CbLAliasMode,pntB->imMt[iM]);
	fprintf(fp," %6s",ln);
	m	=pntB->OMt[iM];
	CbSwitch2Str(ln,CbLAliasOut,m);
	fprintf(fp," %2d %6s",m&0x7f,ln);
	CbSwitch2Str(ln,CbLAliasOut,pntB->iOMt[iM]);
	fprintf(fp," %6s",ln);
	m	=pntB->IMt[iM];
	CbSwitch2Str(ln,CbLAliasInp,m);
	fprintf(fp," %2d %6s",m&0x7f,ln);
	CbSwitch2Str(ln,CbLAliasInp,pntB->iIMt[iM]);
	fprintf(fp," %6s ---   Mzl : %s\n",ln,pntB->NmM[iM]);
	nS	=pntB->nS[iM];
	for(iS=0; iS < nS; iS++){
	  m	=pntB->mSt[iM][iS];
	  CbSwitch2Str(ln,CbLAliasMode,m);
	  fprintf(fp,"   %2d %6s",m&0x7f,ln);
	  CbSwitch2Str(ln,CbLAliasMode,pntB->imSt[iM][iS]);
	  fprintf(fp," %6s",ln);
	  m	=pntB->OSt[iM][iS];
	  CbSwitch2Str(ln,CbLAliasOut,m);
	  fprintf(fp," %2d %6s",m&0x7f,ln);
	  CbSwitch2Str(ln,CbLAliasOut,pntB->iOSt[iM][iS]);
	  fprintf(fp," %6s",ln);
	  m	=pntB->ISt[iM][iS];
	  CbSwitch2Str(ln,CbLAliasInp,m);
	  fprintf(fp," %2d %6s",m&0x7f,ln);
	  CbSwitch2Str(ln,CbLAliasInp,pntB->iISt[iM][iS]);
	  fprintf(fp," %6s ---     Stg : %s\n",ln,pntB->NmS[iM][iS]);
	}
      }
    }
    fputs("St pM   Mode   Mode       Out    Out       Inp    Inp\n",fp);
    fprintf(fp,"%16s %16s %16s\n",CbLAliasMode,CbLAliasOut,CbLAliasInp);
    fputs("Consistency Vector:\n",fp);
    for(iB=0; iB < nblb; iB++){
      pntB	=blb+iB;
      m	=pntB->mBt;
      fprintf(fp,"%c | %s\n",(m&0x100) ? '-' : '+',pntB->NmB);
      nM	=pntB->nM;
      for(iM=0; iM < nM; iM++){
	m	=pntB->mMt[iM];
	fprintf(fp,"%c |  %s\n",(m&0x100) ? '-' : '+',pntB->NmM[iM]);
	nS	=pntB->nS[iM];
	for(iS=0; iS < nS; iS++){
	  m	=pntB->mSt[iM][iS];
	  fprintf(fp,"%c |   %s\n",(m&0x100) ? '-' : '+',pntB->NmS[iM][iS]);
	}
      }
    }	
    fclose(fp);
    out("ss",NmF," code control file has been written");
  }
  pntB	=blb;
  sprintf(NmF,"Wrk/%s.ioD",pntB->NmB);
  fp	=fopen(NmF,"w");
  if(fp!=NULL){
#ifdef H
    fprintf(fp,"dB pathO: %s\n",pntB->path);
    fprintf(fp,"dB pathI: %s\n",*pntB->pathI == '\0' ? "." : pntB->pathI);
#endif
    sprintf(ln,"\"%%%ds\", \"%%%ds\" --- %%s\n",LBLBID,LBLBID);
    for(iB=0; iB < nblb; iB++){
      pntB	=blb+iB;
      if(pntB->OD[0] != '\0'){
	fprintf(fp,ln,pntB->OD,pntB->ID,pntB->NmB);
      }
    }
  }
  fclose(fp);
  return(0);
}

int CbPrintBLB(int IB,int*ix0)
{
  BLB*pntB;
  static int indent= 0;
  int i,j,iM,nM,iS,nS,iB,nB,kB,n;
  int ix,ix1,ix2,iyM,ixM;

  pntB	=blb+IB;
  ix	=*ix0;
  ix1	=ix;
  for(i= 0;i<ix;i++){
    if(i%2)
      putchar('.');
    else
      putchar('|');
    putchar(' ');
  }
  printf("%s{\n",pntB->NmB);
  ix++;
  nM	=pntB->nM;
  for(iM= 0;iM<nM;iM++){
    for(i= 0;i<ix;i++){
      if(i%2)
	putchar('.');
      else
	putchar('|');
      putchar(' ');
    }
    printf("%s{\n",pntB->NmM[iM]);
    ix++;

    nS	=pntB->nS[iM];
    nB	=pntB->nB[iM];
    n	=nS+nB;
    iB	=0;
    iS	=0;
    i	=0;
    if(nB)
      kB	=pntB->kB[iM][iB];
    while(i<n){
      if(iB<nB&&i==kB){
	ix2	=ix;
	CbPrintBLB(pntB->nxtB[iM][iB],&ix2);
	iB++;
	if(iB<nB)
	  kB	=pntB->kB[iM][iB];
      }
      else{
	if(iS<nS){
	  for(j= 0;j<ix;j++){
	    if(j%2)
	      putchar('.');
	    else
	      putchar('|');
	    putchar(' ');
	  }
	  printf("%s;\n",pntB->NmS[iM][iS]);
	  iS++;
	}
      }
      i++;
    }
    ix--;
    for(i= 0;i<ix;i++){
      if(i%2)
	putchar('.');
      else
	putchar('|');
      putchar(' ');
    }
    printf("}\n");
  }
  ix--;
  for(i= 0;i<ix;i++){
    if(i%2)
      putchar('.');
    else
      putchar('|');
    putchar(' ');
  }
  printf("}\n");
  *ix0	=ix;
  return(0);
}

int CbSwitch2Str(char*str,char *Alias,int m)
{
  int k;
  char *lc;

  lc	=str;
  k	=0x80;
  while(*Alias != '!'){
    if((m&k)){
      *lc++	=*Alias;
    }
    k	<<= 1;
    Alias++;
  }
  if(lc == str){
    *lc++	='.';
  }
  *lc	='\0';
  return(0);
}

int CbSwitch2StrL(char*str,char *Alias,int m)
{
  int k;
  k	=0x80;
  while(*Alias != '!'){
    *str++	=(m&k) ? *Alias : ' ';
    k	<<= 1;
    Alias++;
  }
  *str	='\0';
  return(0);
}

int CbPrintOperMode2Str0(char*str,int m)
{
  int i,k,mv;

  mv	=0x100;
  k	=0;
  for(i=0; i < NCbMode; i++){
    str[i]	=' ';
    if(i == 0 && (m&mv) == 0){
      str[k]	='y';
      k++;
    }
    if((m&mv)){
      str[k]= CbLAliasMode[i];
      k++;
    }
    if(i == iCbModeSet){
      mv	=0x80;
      if((m&mv) == 0){
	str[k]	='u';
	k++;
      }
    }
    mv	<<= 1;
  }
  str[NCbMode]	='\0';
  return(0);
}

int CbAliases2ModeOutIn(char**pc,int*k1,int*ik1,int*k2,int*ik2,int*k3,int*ik3)
{
  char ch,*p,*p1,u,y,d;
  int i,m,mv;
  d	='.';
  u	='u';
  y	='y';

  p	=*pc;
  while(isspace(*p)) p++;
  if(isdigit(*p) && sscanf(p,"%d",&m) == 1){
    if(m > iCbModeSet) m	=0;
    *k1	|=m;
    while(isdigit(*p)) p++;
    while(isspace(*p)) p++;
  }
  p1	=p;
  while(!isspace(*p) && *p != ',' && *p != ')' && *p != '\0') p++;
  ch	=*p;
  *p	='\0';
  m	=(*k1)&0x7f;
  while(*p1 != '\0'){
    for(i=0; i < NCbMode; i++){
      if(*p1 == CbLAliasMode[i] || *p1 == CbUAliasMode[i]){
	m	|=(0x80<<i);
	break;
      }
    }
    if(i == NCbMode && *p1 != d && *p1 != y && *p1 != u){
      printf("%c in %s does not match any of Mode specifications: '%s'\n",
	     *p1,p1,CbLAliasMode);
    }
    p1++;
  }
  *k1	=m;
  *p	=ch;
  p++;
  while(isspace(*p)) p++;
  p1	=p;
  while(!isspace(*p) && *p != ',' && *p!= ')' && *p != '\0') p++;
  ch	=*p;
  *p	='\0';
  m	=(*ik1)&0x7f;
  while(*p1 != '\0'){
    for(i=0; i < NCbMode; i++){
      if(*p1 == CbLAliasMode[i] || *p1 == CbUAliasMode[i]){
	m	|=(0x80<<i);
	break;
      }
    }
    if(i == NCbMode && *p1 != d && *p1 != y && *p1 != u){
      printf("%c in %s does not match any of Mode specifications: '%s'\n",
	     *p1,p1,CbLAliasMode);
    }
    p1++;
  }
  *ik1	=m;
  *p	=ch;
  p++;
  while(isspace(*p)) p++;
  if(isdigit(*p) && sscanf(p,"%d",&m) == 1){
    if(m > iCbOutSet) m	=0;
    *k2	|=m;
    while(isdigit(*p)) p++;
    while(isspace(*p)) p++;
  }
  p1	=p;
  while(!isspace(*p) && *p != ',' && *p != ')' && *p != '\0') p++;
  ch	=*p;
  *p	='\0';
  m	=(*k2)&0x7f;
  while(*p1 != '\0'){
    for(i=0; i < NCbOut; i++){
      if(*p1 == CbLAliasOut[i] || *p1 == CbUAliasOut[i]){
	m	|=(0x80<<i);
	break;
      }
    }
    if(i == NCbOut && *p1 != d && *p1 != y && *p1 != u){
      printf("%c in %s does not match any of Out parameters: '%s'\n",
	     *p1,p1,CbLAliasOut);
    }
    p1++;
  }
  *k2	=m;
  *p	=ch;
  p++;
  while(isspace(*p)) p++;
  p1	=p;
  while(!isspace(*p) && *p!= ',' && *p != ')' && *p != '\0') p++;
  ch	=*p;
  *p	='\0';
  m	=(*ik2)&0x7f;
  while(*p1 != '\0'){
    for(i=0; i < NCbOut; i++){
      if(*p1 == CbLAliasOut[i] || *p1 == CbUAliasOut[i]){
	m	|=(0x80<<i);
	break;
      }
    }
    if(i == NCbOut && *p1 != d && *p1 != y && *p1 != u){
      printf("%c in %s does not match any of Out parameters: '%s'\n",
	     *p1,p1,CbLAliasOut);
    }
    p1++;
  }
  *ik2	=m;

  *p	=ch;
  p++;
  while(isspace(*p))  p++;
  if(isdigit(*p) && sscanf(p,"%d",&m) == 1){
    if(m > iCbInpSet) m	=0;
    *k3	|=m;
    while(isdigit(*p)) p++;
    while(isspace(*p)) p++;
  }
  p1	=p;
  while(!isspace(*p) && *p != ',' && *p != ')' && *p!= '\0') p++;
  ch	=*p;
  *p	='\0';
  m	=(*k3)&0x7f;
  while(*p1 != '\0'){
    for(i=0; i < NCbInp; i++){
      if(*p1 == CbLAliasInp[i] || *p1 == CbUAliasInp[i]){
	m	|=(0x80<<i);
	break;
      }
    }
    if(i == NCbInp && *p1 != d && *p1 != y && *p1 != u){
      printf("%c in %s does not match any of Inp parameters: '%s'\n",
	     *p1,p1,CbLAliasInp);
    }
    p1++;
  }
  *k3	=m;

  *p	=ch;
  *pc	=p;
  p++;
  while(isspace(*p))  p++;
  p1	=p;
  while(!isspace(*p) && *p != ',' && *p != ')' && *p!='\0') p++;
  ch	=*p;
  *p	='\0';
  m	=(*ik3)&0x7f;
  while(*p1 != '\0'){
    for(i=0; i < NCbInp; i++){
      if(*p1 == CbLAliasInp[i] || *p1 == CbUAliasInp[i]){
	m	|=(0x80<<i);
	break;
      }
    }
    if(i == NCbInp && *p1 != d && *p1 != y && *p1 != u){
      printf("%c in %s does not match any of Inp parameters: '%s'\n",
	     *p1,p1,CbLAliasInp);
    }
    p1++;
  }
  *ik3	=m;
  *p	=ch;
  return(0);
}

int CbRestoreCntrPanel(char *Dir)
{
  int iB,iM,iS,nM,nS;
  int k1;
  BLB*pntB;
  char ln[81],*pc,*pc1;

  pntB	=blb;
  sprintf(NmF,"%s/Wrk/%s.Cntr",Dir,pntB->NmB);
  fp	=fopen(NmF,"r");
  if(fp == NULL){
    out("ss",NmF," file does not exist");
    return(1);
  }
  for(iB=0;iB < nblb;iB++){
    pntB	=blb+iB;
    if(fgets(ln,80,fp)==NULL){
      out("ssss",NmF,": ",pntB->NmB," is not described");
      fclose(fp);
      return(1);
    }
    pc	=ln;
    while(isspace(*pc)){
      pc++;
    }
    if(sscanf(pc,"%d",&pntB->s) < 1){
      out("ssss",NmF,": ",pntB->NmB," line has a wrong format");
      fclose(fp);
      return(1);
    }
    while(isalnum(*pc)){
      pc++;
    }
    if(CbAliases2ModeOutIn(&pc,&pntB->mBt,&pntB->imBt,&pntB->OBt
			   ,&pntB->iOBt,&pntB->IBt,&pntB->iIBt)){
      out("ssss",NmF,": ",pntB->NmB," line has a wrong format");
      fclose(fp);
      return(1);
    }
    while(*pc!=':'){
      pc++;
    }
    pc++;
    while(isspace(*pc)){
      pc++;
    }
    pc1	=pntB->NmB;
    while(*pc1 == *pc){
      pc1++;
      pc++;
    }
    if(*pc1 != '\0' && (!isspace(*pc)||*pc!='\0')){
      out("ssss",NmF,": ",pntB->NmB," name does not match description");
      fclose(fp);
      return(1);
    }

    nM	=pntB->nM;
    for(iM=0;iM<nM;iM++){
      if(fgets(ln,80,fp)==NULL){
	out("ssss",NmF,": ",pntB->NmM[iM]," is not described");
	fclose(fp);
	return(1);
      }
      pc	=ln;
      if(CbAliases2ModeOutIn(&pc,&pntB->mMt[iM],&pntB->imMt[iM]
			     ,&pntB->OMt[iM],&pntB->iOMt[iM]
			     ,&pntB->IMt[iM],&pntB->iIMt[iM])){
	out("ssss",NmF,": ",pntB->NmM[iM]," line has a wrong format");
	fclose(fp);
	return(1);
      }
      while(*pc!=':')
	pc++;
      pc++;
      while(isspace(*pc))
	pc++;
      pc1= pntB->NmM[iM];
      while(*pc1==*pc){
	pc1++;
	pc++;
      }
      if(*pc1!='\0'&&(!isspace(*pc)||*pc!='\0')){
	out("ssss",NmF,": ",pntB->NmM[iM]," name does not match description");
	fclose(fp);
	return(1);
      }

      nS	=pntB->nS[iM];
      for(iS	=0;iS<nS;iS++){
	if(fgets(ln,80,fp)==NULL){
	  out("ssss",NmF,": ",pntB->NmS[iM][iS]," is not described");
	  fclose(fp);
	  return(1);
	}
	pc	=ln;
	if(CbAliases2ModeOutIn(&pc,&pntB->mSt[iM][iS],&pntB->imSt[iM][iS]
			       ,&pntB->OSt[iM][iS],&pntB->iOSt[iM][iS]
			       ,&pntB->ISt[iM][iS],&pntB->iISt[iM][iS])){
	  out("ssss",NmF,": ",pntB->NmS[iM][iS]," line has a wrong format");
	  fclose(fp);
	  return(1);
	}
	while(*pc!=':')
	  pc++;
	pc++;
	while(isspace(*pc))
	  pc++;
	pc1= pntB->NmS[iM][iS];
	while(*pc1==*pc){
	  pc1++;
	  pc++;
	}
	if(*pc1!='\0'&&(!isspace(*pc)||*pc!='\0')){
	  out("ssss",NmF,": ",pntB->NmS[iM][iS]
	      ," name does not match description");
	  fclose(fp);
	  return(1);
	}
      }
    }
  }
  fclose(fp);
  out("ss",NmF," code control file has been used");

  pntB	=blb;

  sprintf(NmF,"In/%s.ioD",Dir,pntB->NmB);
  fp	=fopen(NmF,"r");
  if(fp == NULL){
    sprintf(NmF,"Wrk/%s.ioD",Dir,pntB->NmB);
    fp	=fopen(NmF,"r");
  }
  if(fp == NULL){
    return(0);
  }
  for(iB=0; iB < nblb; iB++){
    pntB	=blb+iB;
    if(*pntB->OD != '\0'){
      pc	=ln;
      while(feof(fp) ==0 && (*pc=getc(fp)) != '"'){
	;
      }
      while(feof(fp) ==0 && (*pc=getc(fp)) != '"'){
	pc++;
      }
      if(*pc != '"'){
	return(0);
      }
      *pc	='\0';
      CbStrCpyD(pntB->OD,ln);
      pc	=ln;
      while(feof(fp) ==0 && (*pc=getc(fp)) != '"'){
	;
      }
      while(feof(fp) ==0 && (*pc=getc(fp)) != '"'){
	pc++;
      }
      if(*pc != '"'){
	return(0);
      }
      *pc	='\0';
      CbStrCpyD(pntB->ID,ln);
    }
  }
  fclose(fp);
  return(0);
}

int CbInitBlbOutPath(int kB)
{
  BLB*pntB;
  int i,iM,nM,iB,nB,L;
  char*p,*p1;

  pntB= blb+kB;

  L	=(pntB->dDB+1)*(LBLBID+1);
  pntB->path	=(char*)malloc(L*sizeof(char));
  pntB->pathI	=(char*)malloc(L*sizeof(char));
  if(kB == 0){
    pntB->Lpath	=CbStrCpyD(pntB->path,pntB->OD);
    pntB->LpathI=CbStrCpyD(pntB->pathI,pntB->ID);
    if(pntB->LpathI==0){
      strcpy(pntB->pathI,pntB->path);
      pntB->LpathI	=pntB->Lpath;
    }
#ifdef H
    p= getcwd(ln,(size_t)80);
    if(p!=NULL){
      p= ln+strlen(ln);
      while(p>ln&&*(p-1)!='/')
	p--;
      p1= pntB->path+2;
      if(strcmp(p,p1)){
	printf("\nthe current pwd does not match that in the %s-file%c\n",
	       NmF,7);
	printf("\"%s\" != \"%s\"\n",p,p1);
	printf("\ntype 'y' to proceed ->");
	if(getchar()!='y'){
	  printf("\nCheck your working directory\n");
	  printf("It should be %s\n",p1);
	  CbDeInitBLB();
	  exit(1);
	}
	else{
	  p= pntB->path;
	  L= 0;
	  while(*p1!='\0'){
	    *p++	=*p1++;
	    L++;
	  }
	  *p= '\0';
	  pntB->Lpath= L;
	}
      }
    }
#endif
  }
  else{
    *pntB->pathI	='\0';
    pntB->LpathI	= 0;
    i	=pntB->iB;
    p1	=pntB->path;
    strcpy(p1,blb[i].path);
    p1	+=blb[i].Lpath;
    p	=pntB->OD;
    while(isspace(*p)) p++;
    if(*p != '\0'){
      *p1++	='/';
      while(!isspace(*p) && *p!='\0'){
	*p1++	=*p++;
      }
      *p1= '\0';
    }
    pntB->Lpath=p1-pntB->path;
  }

  nM	=pntB->nM;
  for(iM=0; iM < nM; iM++){
    nB	=pntB->nB[iM];
    for(iB= 0;iB<nB;iB++){
      CbInitBlbOutPath(pntB->nxtB[iM][iB]);
    }
  }
  return(0);
}

int CbReSetBlbOutPath(int kB)
{
  BLB*pntB;
  int i,iM,nM,iB,nB;
  char*p,*p1;

  pntB= blb+kB;

  if(kB==0){
    p= pntB->OD;
    while(isspace(*p))
      p++;
    p1= pntB->path;
    while(!isspace(*p)&&*p!='\0'){
      *p1++	=*p++;
    }
    *p1= '\0';
    pntB->Lpath= p1-pntB->path;
  }
  else{
    i= pntB->iB;
    p1= pntB->path;
    strcpy(p1,blb[i].path);
    p1	+=blb[i].Lpath;
    p= pntB->OD;
    while(isspace(*p))
      p++;
    if(*p!='\0'){
      *p1++	='/';
      while(!isspace(*p)&&*p!='\0'){
	*p1++	=*p++;
      }
      *p1= '\0';
    }
    pntB->Lpath= p1-pntB->path;
  }

  nM= pntB->nM;
  for(iM= 0;iM<nM;iM++){
    nB= pntB->nB[iM];
    for(iB= 0;iB<nB;iB++){
      CbReSetBlbOutPath(pntB->nxtB[iM][iB]);
    }
  }
  return(0);
}

int CbInitBlbDepth(int kB)
{
  BLB*pntB;
  int i,iM,nM,iB,nB,L;

  pntB	=blb+kB;

  if(kB == 0){
    pntB->dDB	=0;
    pntB->dCb	=0;
  }
  else{
    pntB->dDB	=*pntB->OD != '\0' ? blb[pntB->iB].dDB+1 : blb[pntB->iB].dDB;
    pntB->dCb	=blb[pntB->iB].dCb+1;
  }

  nM	=pntB->nM;
  i	=0;
  for(iM = 0; iM < nM; iM++){
    if(pntB->nB[iM]) i	=1;
  }
  if(i){
    NDpth++;
  }
  for(iM=0; iM < nM; iM++){
    nB	=pntB->nB[iM];
    for(iB=0; iB < nB; iB++){
      i	=pntB->nxtB[iM][iB];
      CbInitBlbDepth(i);
    }
  }
  return(0);
}

int CbInitDirectorySet()
{
  int i,j,L,n;
  char *Dir[3]={"/Wrk","/Out","/In"};
  char*p;
  
  n	=3;

  CbReSetBlbOutPath(0);
  strcpy(ln,"mkdir ");
  for(i=0; i < nblb;i++){
    if(blb[i].OD[0]!='\0'){
      strcpy(ln+6,blb[i].path);
      L	=6+blb[i].Lpath;
      fp	=fopen(ln+6,"r");
      if(fp != NULL){
	fclose(fp);
      }
      else{
	system(ln);
	printf("%s directory has been created%c\n",ln+6,7);
      }
      for(j=0; j < n; j++){
	strcpy(ln+L,Dir[j]);
	fp	=fopen(ln+6,"r");
	if(fp == NULL){
	  system(ln);
	  printf("%s directory has been created%c\n",ln+6,7);
	}
	else{
	  fclose(fp);
	}
      }
      ln[L]= '\0';
      CbUpdateDirFile(ln+6,i);
    }
  }
  return(0);
}

int CbInitDirectorySet0()
{
  int i,L;
  char*p;

  CbReSetBlbOutPath(0);
  strcpy(ln,"mkdir ");
  for(i= 0;i<nblb;i++){
    if((i==0||blb[i].OD[0]!='\0')){
      strcpy(ln+6,blb[i].path);
      L= 6+blb[i].Lpath;
      ln[L]= '/';
      L++;
      ln[L]= '\0';
      fp= fopen(ln+6,"r");
      if(fp==NULL){
	L--;
	ln[L]= '\0';
	system(ln);
	ln[L]= '/';
	L++;
	ln[L]= '\0';
	printf("%s directory has been created%c\n",ln+6,7);
	strcpy(ln+L,"Wrk");
	system(ln);
	printf("%s directory has been created%c\n",ln+6,7);
	strcpy(ln+L,"In");
	system(ln);
	printf("%s directory has been created%c\n",ln+6,7);
	strcpy(ln+L,"Out");
	system(ln);
	printf("%s directory has been created%c\n",ln+6,7);
	ln[L]= '\0';
      }
      else{
	fclose(fp);
	strcpy(ln+L,"Wrk");
	fp= fopen(ln+6,"r");
	if(fp==NULL){
	  system(ln);
	  printf("%s directory has been created%c\n",ln+6,7);
	}
	else{
	  fclose(fp);
	}
	strcpy(ln+L,"In");
	fp= fopen(ln+6,"r");
	if(fp==NULL){
	  system(ln);
	  printf("%s directory has been created%c\n",ln+6,7);
	}
	else{
	  fclose(fp);
	}
	strcpy(ln+L,"Out");
	fp= fopen(ln+6,"r");
	if(fp==NULL){
	  system(ln);
	  printf("%s directory has been created%c\n",ln+6,7);
	}
	else{
	  fclose(fp);
	}
	ln[L]= '\0';
      }
      CbUpdateDirFile(ln+6,i);
    }
  }
  return(0);
}

int CbUpdateDirFile(char*DirNm,int iB)
{
  int i,Fl,L;
  char*p,*p1;
  FILE*fp1;

  p	=NmF;
  p1	=DirNm;
  while(*p1!='\0'){
    *p++	=*p1++;
  }
  strcpy(p,"/In/CbDir.st");
  fp1	=fopen(NmF,"r+");
  if(fp1 == NULL){
    fp1	=fopen(NmF,"w");
  }
  if(fp1 == NULL){
    return(1);
  }
  p= ln1;
  i= iB;
  while(i>=0){
    p1= blb[i].NmB;
    while(*p1!='\0')
      *p++	=*p1++;
    if(i>0)
      *p++	='/';
    i= blb[i].iB;
  }
  *p= '\0';
  L= p-ln1;

  Fl= 0;
  while(feof(fp1)==0){
    p= fgets(NmF,80,fp1);
    if(p==NULL)
      break;
    while(*p!='"'&&*p!='\0'){
      p++;
    }
    if(*p=='"'){
      p++;
      while(isspace(*p))
	p++;
      if(strncmp(p,ln1,L)==0&&p[L]=='"'){
	Fl= 1;
	break;
      }
    }
  }

  if(Fl==0){
    i= iB;
    fputc('"',fp1);
    while(i>=0){
      if(i<iB)
	fputc('/',fp1);
      fprintf(fp1,"%s",blb[i].NmB);
      i= blb[i].iB;
    }
    fputc('"',fp1);
    fputc('\n',fp1);
  }
  fclose(fp1);
  return(0);
}

int CbExchangeBlb(int *nB, BBLB **B,int *nM,MZL **M,int *nS, STG **S)
{
  *nB	=nBlb;
  *B	=Blb;
  *nM	=nMzl;
  *M	=Mzl;
  *nS	=nStg;
  *S	=Stg;
  return(0);
}

int CbExchangeBLB(int *nB,BLB **B, int*nC)
{
  *nB	=nblb;
  *B	=blb;
  *nC	=nCbB;
  return(0);
}

int CbExchangeInpList(int**kBlbInpDir0,
		      char****BlbInpFNmD0,char****BlbInpFNmW0,
		      char****BlbInpFNmO0,char****BlbInpFNmI0,
		      char*****MzlInpFNmW0,char*****MzlInpFNmO0,
		      char*****MzlInpFNmI0,char******StgInpFNmW0,
		      char******StgInpFNmO0,char******StgInpFNmI0)
{
  *kBlbInpDir0= kBlbInpDir;
  *BlbInpFNmD0= BlbInpFNmD;
  *BlbInpFNmW0= BlbInpFNmW;
  *BlbInpFNmO0= BlbInpFNmO;
  *BlbInpFNmI0= BlbInpFNmI;
  *MzlInpFNmW0= MzlInpFNmW;
  *MzlInpFNmO0= MzlInpFNmO;
  *MzlInpFNmI0= MzlInpFNmI;
  *StgInpFNmW0= StgInpFNmW;
  *StgInpFNmO0= StgInpFNmO;
  *StgInpFNmI0= StgInpFNmI;
  return(0);
}

int CbInitListInputFiles()
{
  int i,iM,nM,iB,nB,iS,nS;
  char **Ps;

  kBlbInpDir	=(int*)malloc(nblb*sizeof(int));
  BlbInpFNmD	=(char***)calloc(nblb,sizeof(char**));
  BlbInpFNmW	=(char***)malloc(nblb*sizeof(char**));
  BlbInpFNmO	=(char***)malloc(nblb*sizeof(char**));
  BlbInpFNmI	=(char***)malloc(nblb*sizeof(char**));

  MzlInpFNmW	=(char****)malloc(nblb*sizeof(char***));
  MzlInpFNmO	=(char****)malloc(nblb*sizeof(char***));
  MzlInpFNmI	=(char****)malloc(nblb*sizeof(char***));
  StgInpFNmW	=(char*****)malloc(nblb*sizeof(char****));
  StgInpFNmO	=(char*****)malloc(nblb*sizeof(char****));
  StgInpFNmI	=(char*****)malloc(nblb*sizeof(char****));

  for(iB=0; iB < nblb; iB++){
    kBlbInpDir[iB]=0;
    BlbInpFNmD[iB]	=NULL;
    nM	=blb[iB].nM;
    MzlInpFNmW[iB]	=(char***)malloc(nM*sizeof(char**));
    MzlInpFNmO[iB]	=(char***)malloc(nM*sizeof(char**));
    MzlInpFNmI[iB]	=(char***)malloc(nM*sizeof(char**));
    StgInpFNmW[iB]	=(char****)malloc(nM*sizeof(char***));
    StgInpFNmO[iB]	=(char****)malloc(nM*sizeof(char***));
    StgInpFNmI[iB]	=(char****)malloc(nM*sizeof(char***));
    for(iM=0; iM < nM; iM++){
      MzlInpFNmW[iB][iM]	=(char**)malloc((NExtW+2)*sizeof(char*));
      MzlInpFNmO[iB][iM]	=(char**)malloc((NExtO+2)*sizeof(char*));
      MzlInpFNmI[iB][iM]	=(char**)malloc((NExtI+2)*sizeof(char*));
      Ps	=MzlInpFNmW[iB][iM];
      for(i=0; i < NExtW; i++){
	Ps[i]	=(char*)malloc(4*sizeof(char));
	strcpy(Ps[i],InpFExtW[i]);
      }
      Ps[i]	=(char*)malloc(4*sizeof(char));
      strcpy(Ps[i],".__");
      i++;
      Ps[i]	=NULL;
      Ps	=MzlInpFNmO[iB][iM];
      for(i=0;i < NExtO; i++){
	Ps[i]	=(char*)malloc(4*sizeof(char));
	strcpy(Ps[i],InpFExtO[i]);
      }
      Ps[i]	=(char*)malloc(4*sizeof(char));
      strcpy(Ps[i],".__");
      i++;
      Ps[i]	=NULL;
      Ps	=MzlInpFNmI[iB][iM];
      for(i=0; i < NExtI; i++){
	Ps[i]	=(char*)malloc(4*sizeof(char));
	strcpy(Ps[i],InpFExtI[i]);
      }
      Ps[i]	=(char*)malloc(4*sizeof(char));
      strcpy(Ps[i],".__");
      i++;
      Ps[i]	=NULL;

      nS	=blb[iB].nS[iM];
      if(nS){
	StgInpFNmW[iB][iM]	=(char***)malloc(nS*sizeof(char**));
	StgInpFNmO[iB][iM]	=(char***)malloc(nS*sizeof(char**));
	StgInpFNmI[iB][iM]	=(char***)malloc(nS*sizeof(char**));
      }
    }
  }
  CbMemoryL |=0x00000008;

  CbInitBlbInputFiles(0,NULL,NULL,NULL,NULL);
  return(0);
}

int CbDeInitListInputFiles()
{
  int iM,nM,iB,nB,iS,nS;
  char **p;

  for(iB=0; iB < nblb; iB++){
    nM	=blb[iB].nM;
    for(iM=0;iM < nM;iM++){
      nS	=blb[iB].nS[iM];
      if(nS){
	for(iS=0; iS < nS; iS++){
	  p	=StgInpFNmI[iB][iM][iS];
	  while(*p != NULL){
	    free(*p);
	    p++;
	  }
	  p	=StgInpFNmO[iB][iM][iS];
	  while(*p != NULL){
	    free(*p);
	    p++;
	  }
	  p	=StgInpFNmW[iB][iM][iS];
	  while(*p != NULL){
	    free(*p);
	    p++;
	  }
	  free(StgInpFNmI[iB][iM][iS]);
	  free(StgInpFNmO[iB][iM][iS]);
	  free(StgInpFNmW[iB][iM][iS]);
	}
	free(StgInpFNmI[iB][iM]);
	free(StgInpFNmO[iB][iM]);
	free(StgInpFNmW[iB][iM]);
      }
      p	=MzlInpFNmI[iB][iM];
      while(*p != NULL){
	free(*p);
	p++;
      }
      p	=MzlInpFNmO[iB][iM];
      while(*p != NULL){
	free(*p);
	p++;
      }
      p	=MzlInpFNmW[iB][iM];
      while(*p != NULL){
	free(*p);
	p++;
      }
      free(MzlInpFNmI[iB][iM]);
      free(MzlInpFNmO[iB][iM]);
      free(MzlInpFNmW[iB][iM]);
    }
    free(StgInpFNmI[iB]);
    free(StgInpFNmO[iB]);
    free(StgInpFNmW[iB]);
    free(MzlInpFNmI[iB]);
    free(MzlInpFNmO[iB]);
    free(MzlInpFNmW[iB]);
    p	=BlbInpFNmI[iB];
    while(*p != NULL){
      free(*p);
      p++;
    }
    p	=BlbInpFNmO[iB];
    while(*p != NULL){
      free(*p);
      p++;
    }
    p	=BlbInpFNmW[iB];
    while(*p != NULL){
      free(*p);
      p++;
    }
    p	=BlbInpFNmD[iB];
    if(p != NULL){
      while(*p != NULL){
	free(*p++);
      }
    }
    free(BlbInpFNmI[iB]);
    free(BlbInpFNmO[iB]);
    free(BlbInpFNmW[iB]);
    free(BlbInpFNmD[iB]);
  }
  free(StgInpFNmI);
  free(StgInpFNmO);
  free(StgInpFNmW);
  free(MzlInpFNmI);
  free(MzlInpFNmO);
  free(MzlInpFNmW);
  free(BlbInpFNmI);
  free(BlbInpFNmO);
  free(BlbInpFNmW);
  free(BlbInpFNmD);
  free(kBlbInpDir);
  return(0);
}

int CbInpFileListW(char*DirNm,char***FDList0)
{
  int i;
  int Fl,ND,iD;
  char*p,*p1,*p2,**FDList;

  ND= 10;
  FDList= (char**)malloc(ND*sizeof(char*));
  iD= 0;
  if((dirp= opendir(DirNm))!=NULL){
    while((direntp= readdir(dirp))!=NULL){
      p1= direntp->d_name;
      Fl= 0;
      while(*p1!='\0'&&*p1!='.'){
	p1++;
      }
      if(*p1=='.'){
	for(i= 0;i<NExtW;i++){
	  if(strcmp(p1,InpFExtW[i])==0){
	    Fl= 1;
	    break;
	  }
	}
      }
      if(Fl){
	p1= direntp->d_name;
	sprintf(ln,"%s/%s",DirNm,p1);
	stat(ln,&statbuf);
	i= statbuf.st_mode&S_IFMT;
	if(i==S_IFREG||i==S_IFLNK){
	  FDList[iD]= (char*)malloc((strlen(p1)+1)*sizeof(char));
	  strcpy(FDList[iD],p1);
	  iD++;
	  if(iD+1>=ND){
	    ND	+=10;
	    FDList= (char**)realloc((void*)FDList,ND*sizeof(char*));
	  }
#ifdef H_strange_mistake
	  fclose(fp);
#endif
	}
      }
    }
    closedir(dirp);
  }
  FDList[iD]= NULL;
  *FDList0= FDList;
  return(0);
}

int CbInpFileListO(char*DirNm,char***FDList0)
{
  int i;
  int Fl,ND,iD;
  char*p,*p1,*p2,**FDList;

  ND= 10;
  FDList= (char**)malloc(ND*sizeof(char*));
  iD= 0;
  if((dirp= opendir(DirNm))!=NULL){
    while((direntp= readdir(dirp))!=NULL){
      p1= direntp->d_name;
      Fl= 0;
      while(*p1!='\0'&&*p1!='.'){
	p1++;
      }
      if(*p1=='.'){
	for(i= 0;i<NExtO;i++){
	  if(strcmp(p1,InpFExtO[i])==0){
	    Fl= 1;
	    break;
	  }
	}
      }
      if(Fl){
	p1= direntp->d_name;
	sprintf(ln,"%s/%s",DirNm,p1);
	stat(ln,&statbuf);
	if((statbuf.st_mode&S_IFMT)==S_IFREG){
	  FDList[iD]= (char*)malloc((strlen(p1)+1)*sizeof(char));
	  strcpy(FDList[iD],p1);
	  iD++;
	  if(iD+1>=ND){
	    ND	+=10;
	    FDList= (char**)realloc((void*)FDList,ND*sizeof(char*));
	  }
#ifdef H
	  fclose(fp);
#endif
	}
      }
    }
    closedir(dirp);
  }
  FDList[iD]= NULL;
  *FDList0= FDList;
  return(0);
}

int CbInpFileListI(char*DirNm,char***FDList0)
{
  int i;
  int Fl,ND,iD;
  char*p,*p1,*p2,**FDList;

  ND= 10;
  FDList= (char**)malloc(ND*sizeof(char*));
  iD= 0;
  if((dirp= opendir(DirNm))!=NULL){
    while((direntp= readdir(dirp))!=NULL){
      p1= direntp->d_name;
      Fl= 0;
      while(*p1!='\0'&&*p1!='.'){
	p1++;
      }
      if(*p1=='.'){
	for(i= 0;i<NExtI;i++){
	  if(strcmp(p1,InpFExtI[i])==0){
	    Fl= 1;
	    break;
	  }
	}
      }
      if(Fl){
	p1= direntp->d_name;
	sprintf(ln,"%s/%s",DirNm,p1);
	stat(ln,&statbuf);
	if((statbuf.st_mode&S_IFMT)==S_IFREG){
	  FDList[iD]= (char*)malloc((strlen(p1)+1)*sizeof(char));
	  strcpy(FDList[iD],p1);
	  iD++;
	  if(iD+1>=ND){
	    ND	+=10;
	    FDList= (char**)realloc((void*)FDList,ND*sizeof(char*));
	  }
#ifdef H
	  fclose(fp);
#endif
	}
      }
    }
    closedir(dirp);
  }
  FDList[iD]	=NULL;
  *FDList0	=FDList;
  return(0);
}

int IsNotCodeInpDir(char NmD[],int L)
{
  char ch;
  char *lc;

  strcpy(NmD+L,"/In/CbDir.st");
  if((fp=fopen(NmD,"r")) == NULL){
    printf("%s-file does not exist\n",NmF);
    return(2);
  }
  NmD[L]	='\0';

  while(feof(fp)==0){
    ch	=fgetc(fp);
    if(ch == '"'){
      lc	=blb->NmB;
      while(feof(fp) == 0 && (ch =fgetc(fp)) != '"'){
	if(*lc != ch){
	  lc	=blb->NmB;
	}
	lc++;
	if(*lc == '\0'){
	  fclose(fp);
	  return(0);
	}
      }
    }
  }
  fclose(fp);
  printf("%s/In/CbDir.st-file does not contain \"%s\"-line\n",NmD,blb->NmB);
  return(1);
}

int CbIsCodeInpDir(char NmD[],int L)
{
  char ch;
  char *lc;

  strcpy(NmD+L,"/In/CbDir.st");
  if((fp=fopen(NmD,"r")) == NULL){
    NmD[L]	='\0';
    return(0);
  }
  NmD[L]	='\0';

  while(feof(fp)==0){
    ch	=fgetc(fp);
    if(ch == '"'){
      lc	=blb->NmB;
      while(feof(fp) == 0 && (ch =fgetc(fp)) != '"'){
	if(*lc != ch){
	  lc	=blb->NmB;
	}
	lc++;
	if(*lc == '\0'){
	  fclose(fp);
	  return(1);
	}
      }
    }
  }
  fclose(fp);
  return(0);
}


int CbInitBlbInputFiles(int kB,char**FDListDE,
			char**FDListWE,char**FDListOE,char**FDListIE)
{
  BLB*pntB;
  int i,n,iB,nB,iM,nM,iS,nS;
  int Fl,ND,iD,L;
  char*p,*p1,*p2,**Ps;
  char**FDListW,**FDListO,**FDListI,**FDListD;
  
  pntB	=blb+kB;
  p	=pntB->OD;
  if(*p == '\0'){
    FDListD	=FDListDE;
    FDListW	=FDListWE;
    FDListO	=FDListOE;
    FDListI	=FDListIE;
    i	=pntB->iB;
    strcpy(pntB->pathI,blb[i].pathI);
    pntB->LpathI	=blb[i].LpathI;
    kBlbInpDir[kB]	=0;
  }
  else{
    if(kB){
      i	=pntB->iB;
      strcpy(NmF,blb[i].pathI);
      L	=blb[i].LpathI;
      iD	=0;
      i	=0;
      p1	=pntB->NmB;
      while(FDListDE[i] != NULL){
	FDListDE[i][0]	=' ';
	sprintf(NmF+L,"/%s",FDListDE[i]+1);
	if(CbIsCodeInpDir(NmF,strlen(NmF))){
	  FDListDE[i][0]	='+';
	  iD++;
	}
	i++;
      }
      if(iD){
	Ps	=(char**)malloc((iD+1)*sizeof(char*));
	i	=0;
	iD	=0;
	while(FDListDE[i] != NULL){
	  if(FDListDE[i][0] == '+'){
	    Ps[iD]	=(char*)malloc((LBLBID+1)*sizeof(char));
	    CbStrCpyD(Ps[iD],FDListDE[i]+1);
	    iD++;
	  }
	  i++;
	}
      }
      else{
	iD	=1;
	Ps	=(char**)malloc((iD+1)*sizeof(char*));
	Ps[0]	=(char*)malloc((LBLBID+1)*sizeof(char));
	CbStrCpyD(Ps[0],".");
      }
      Ps[iD]	=NULL;
      BlbInpFNmD[kB]	=Ps;
      p	=pntB->pathI;
      i	=pntB->iB;
      strcpy(p,blb[i].pathI);
      L	=blb[i].LpathI;
      p	+=L;
      *p++	='/';
      L++;
      p1	=pntB->ID;
      CbStrCpy(ln1,p1);
      i	=CbIsInInpList(Ps,ln1);
      if(i < 0){
	if(Ps[0] != NULL){
	  CbStrCpy(ln1,Ps[0]);
	}
	else{
	  strcpy(ln1,".");
	}
	CbStrCpyD(pntB->ID,ln1);
	kBlbInpDir[kB]	=0;
      }
      else{
	kBlbInpDir[kB]	=i;
      }
      p2	=ln1;
      while(*p2!='\0'){
	*p++	=*p2++;
      }
      *p	='\0';
      pntB->LpathI	=L+p2-ln1;
    }
    else{ /* list of top directories for the dB search */
      int i,j,L,N;
      pntB->LpathI	=CbStrCpy(pntB->pathI,pntB->ID);
      N		=8;
      Ps	=(char**)malloc(N*sizeof(char*));
      i		=0;
      Ps[i]	=(char*)malloc((LBLBID+1)*sizeof(char));
      CbStrCpyD(Ps[i],pntB->ID);
      i++;
      if(CbStrCmp(Ps[0],".")){
	Ps[i]	=(char*)malloc((LBLBID+1)*sizeof(char));
	CbStrCpyD(Ps[i],".");
	i++;
      }
      strcpy(ln,"../");
      if((dirp	=opendir(ln)) != NULL){
	p	=ln+3;
	while((direntp=readdir(dirp)) != NULL){
	  L	=3+CbStrCpy(p,direntp->d_name);
	  if(strncmp(p,"dB",2) == 0 && strlen(ln) <= LBLBID
	     && stat(ln,&statbuf) == 0 && S_ISDIR(statbuf.st_mode)
	     && CbIsCodeInpDir(ln,L)){
	    j	=0;
	    while(j < i && CbStrCmp(ln,Ps[j])){
	      j++;
	    }
	    if(j == i){
	      Ps[i]	=(char*)malloc((LBLBID+1)*sizeof(char));
	      CbStrCpyD(Ps[i],ln);
	      i++;
	      if(i+2 >= N){
		N	+=8;
		Ps	=(char**)realloc((void*)Ps,N*sizeof(char*));
	      }
	    }
	  }
	}
	closedir(dirp);
      }
      Ps[i]	=(char*)malloc((LBLBID+1)*sizeof(char));
      CbStrCpyD(Ps[i]," ");
      i++;
      Ps[i]	=NULL;
      kBlbInpDir[kB]	=0;
      BlbInpFNmD[kB]	=Ps;
    }

    strcpy(NmF,pntB->pathI);
    n	=pntB->LpathI;
    strcpy(NmF+n,"/Wrk");
    CbInpFileListW(NmF,&FDListW);
    strcpy(NmF+n,"/Out");
    CbInpFileListO(NmF,&FDListO);
    strcpy(NmF+n,"/In");
    CbInpFileListI(NmF,&FDListI);
    NmF[n]	='\0';
    
    p2	=ln1;
    i	=kB;
    while(i>=0){
      p1= blb[i].NmB;
      while(*p1!='\0')
	*p2++	=*p1++;
      if(i>0)
	*p2++	='/';
      i= blb[i].iB;
    }
    *p2= '\0';
    L	=p2-ln1;
    ND	=8;
    FDListD=(char**)malloc(ND*sizeof(char*));
    iD	=0;
    if((dirp=opendir(NmF))!=NULL){
      while((direntp=readdir(dirp))!=NULL){
	p1	=direntp->d_name;
	Fl	=0;
	if(strcmp(p1,"Wrk")&&strcmp(p1,"Out")&&strcmp(p1,"In")
	   &&strcmp(p1,"Csrc")){
	  Fl	=1;
	}
	if(strcmp(p1,"..") == 0){
	  Fl	=0;
	}
	if(Fl){
	  p1	=direntp->d_name;
	  sprintf(NmF+n,"/%s",p1);
	  stat(NmF,&statbuf);
	  if((statbuf.st_mode&S_IFMT)==S_IFDIR){
	    if(CbIsCodeInpDir(NmF,strlen(NmF))){
	      FDListD[iD]	=(char*)malloc((LBLBID+2)*sizeof(char));
	      FDListD[iD][0]	=' ';
	      strcpy(FDListD[iD]+1,p1);
	      iD++;
	      if(iD+1 >= ND){
		ND	+=8;
		FDListD	=(char**)realloc((void*)FDListD,ND*sizeof(char*));
	      }
	    }
	  }
	}
      }
      closedir(dirp);
    }
    FDListD[iD]= NULL;
  }

  p1	=pntB->NmB;
  L	=strlen(p1);
  n	=0;
  iB	=0;
  while(FDListW[iB]!=NULL){
    p= FDListW[iB];
    if(strncmp(p,p1,L)==0&&p[L]=='.')
      n++;
    iB++;
  }
  n++;
  BlbInpFNmW[kB]= (char**)malloc((n+1)*sizeof(char*));
  Ps= BlbInpFNmW[kB];
  for(i= 0;i<n;i++){
    Ps[i]= (char*)malloc(4*sizeof(char));
  }
  n= 0;
  iB= 0;
  while(FDListW[iB]!=NULL){
    p= FDListW[iB];
    if(strncmp(p,p1,L)==0&&p[L]=='.'){
      strcpy(Ps[n],p+L);
      n++;
    }
    iB++;
  }
  strcpy(Ps[n],".__");
  n++;
  Ps[n]= NULL;


  n= 0;
  iB= 0;
  while(FDListO[iB]!=NULL){
    p= FDListO[iB];
    if(strncmp(p,p1,L)==0&&p[L]=='.')
      n++;
    iB++;
  }
  n++;
  BlbInpFNmO[kB]= (char**)malloc((n+1)*sizeof(char*));
  Ps= BlbInpFNmO[kB];
  for(i= 0;i<n;i++){
    Ps[i]= (char*)malloc(4*sizeof(char));
  }
  n= 0;
  iB= 0;
  while(FDListO[iB]!=NULL){
    p= FDListO[iB];
    if(strncmp(p,p1,L)==0&&p[L]=='.'){
      strcpy(Ps[n],p+L);
      n++;
    }
    iB++;
  }
  strcpy(Ps[n],".__");
  n++;
  Ps[n]= NULL;


  n= 0;
  iB= 0;
  while(FDListI[iB]!=NULL){
    p= FDListI[iB];
    if(strncmp(p,p1,L)==0&&p[L]=='.')
      n++;
    iB++;
  }
  n++;
  BlbInpFNmI[kB]= (char**)malloc((n+1)*sizeof(char*));
  Ps= BlbInpFNmI[kB];
  for(i= 0;i<n;i++){
    Ps[i]= (char*)malloc(4*sizeof(char));
  }
  n= 0;
  iB= 0;
  while(FDListI[iB]!=NULL){
    p= FDListI[iB];
    if(strncmp(p,p1,L)==0&&p[L]=='.'){
      strcpy(Ps[n],p+L);
      n++;
    }
    iB++;
  }
  strcpy(Ps[n],".__");
  n++;
  Ps[n]= NULL;

  nM= pntB->nM;
  for(iM= 0;iM<nM;iM++){
    nS= pntB->nS[iM];
    for(iS= 0;iS<nS;iS++){
      p1= pntB->NmS[iM][iS];
      L= strlen(p1);
      n= 0;
      i= 0;
      while(FDListW[i]!=NULL){
	p= FDListW[i];
	if(strncmp(p,p1,L)==0&&p[L]=='.')
	  n++;
	i++;
      }
      n++;
      StgInpFNmW[kB][iM][iS]= (char**)malloc((n+1)*sizeof(char*));
      Ps= StgInpFNmW[kB][iM][iS];
      for(i= 0;i<n;i++){
	Ps[i]= (char*)malloc(4*sizeof(char));
      }
      n= 0;
      i= 0;
      while(FDListW[i]!=NULL){
	p= FDListW[i];
	if(strncmp(p,p1,L)==0&&p[L]=='.'){
	  strcpy(Ps[n],p+L);
	  n++;
	}
	i++;
      }
      strcpy(Ps[n],".__");
      n++;
      Ps[n]= NULL;
      

      n= 0;
      i= 0;
      while(FDListO[i]!=NULL){
	p= FDListO[i];
	if(strncmp(p,p1,L)==0&&p[L]=='.')
	  n++;
	i++;
      }
      n++;
      StgInpFNmO[kB][iM][iS]= (char**)malloc((n+1)*sizeof(char*));
      Ps= StgInpFNmO[kB][iM][iS];
      for(i= 0;i<n;i++){
	Ps[i]= (char*)malloc(4*sizeof(char));
      }
      n= 0;
      i= 0;
      while(FDListO[i]!=NULL){
	p= FDListO[i];
	if(strncmp(p,p1,L)==0&&p[L]=='.'){
	  strcpy(Ps[n],p+L);
	  n++;
	}
	i++;
      }
      strcpy(Ps[n],".__");
      n++;
      Ps[n]= NULL;
      
      
      n= 0;
      i= 0;
      while(FDListI[i]!=NULL){
	p= FDListI[i];
	if(strncmp(p,p1,L)==0&&p[L]=='.')
	  n++;
	i++;
      }
      n++;
      StgInpFNmI[kB][iM][iS]= (char**)malloc((n+1)*sizeof(char*));
      Ps= StgInpFNmI[kB][iM][iS];
      for(i= 0;i<n;i++){
	Ps[i]= (char*)malloc(4*sizeof(char));
      }
      n= 0;
      i= 0;
      while(FDListI[i]!=NULL){
	p= FDListI[i];
	if(strncmp(p,p1,L)==0&&p[L]=='.'){
	  strcpy(Ps[n],p+L);
	  n++;
	}
	i++;
      }
      strcpy(Ps[n],".__");
      n++;
      Ps[n]= NULL;
    }

    nB= pntB->nB[iM];
    for(iB= 0;iB<nB;iB++){
      i= pntB->nxtB[iM][iB];
      CbInitBlbInputFiles(i,FDListD,FDListW,FDListO,FDListI);
    }
  }
  if(pntB->OD[0]!='\0'){
    if(FDListI!=NULL){
      iB= 0;
      while(FDListI!=NULL&&FDListI[iB]!=NULL){
	free(FDListI[iB]);
	iB++;
      }
      free(FDListI);
    }
    if(FDListO!=NULL){
      iB= 0;
      while(FDListO[iB]!=NULL){
	free(FDListO[iB]);
	iB++;
      }
      free(FDListO);
    }
    if(FDListW!=NULL){
      iB= 0;
      while(FDListW[iB]!=NULL){
	free(FDListW[iB]);
	iB++;
      }
      free(FDListW);
    }
    if(FDListD!=NULL){
      iB= 0;
      while(FDListD[iB]!=NULL){
	free(FDListD[iB]);
	iB++;
      }
      free(FDListD);
    }
  }
  return(0);
}

int CbReSetBlbInputFiles(int Flag,int kB,char**FDListDE,
			 char**FDListWE,char**FDListOE,char**FDListIE)
{
  BLB*pntB;
  int i,k,n,iB,nB,iM,nM,iS,nS;
  int Fl,ND,iD,L;
  char*p,*p1,*p2,**Ps,**Ps1;
  char**FDListW,**FDListO,**FDListI,**FDListD;

  pntB	=blb+kB;

  p	=pntB->OD;
  if(*p == '\0'){
    FDListD	=FDListDE;
    FDListW	=FDListWE;
    FDListO	=FDListOE;
    FDListI	=FDListIE;
    if(Flag){
      i	=pntB->iB;
      strcpy(pntB->pathI,blb[i].pathI);
      pntB->LpathI	=blb[i].LpathI;
    }
  }
  else{
    k	=kBlbInpDir[kB];
    Ps	=BlbInpFNmD[kB];
    if(Flag == 0){
      if(CbStrCmp(Ps[k],pntB->ID)){
	Flag	=1;
      }
    }
    else{
      Flag++;
    }
    if(Flag){
      if(kB == 0){
	int L;
	i	=0;
	while(Ps[i] != NULL){
	  i++;
	}
	i--;
	if(k == i){
	  L	=CbStrCpy(NmF,Ps[i]);
	  if(L){
	    if(CbIsCodeInpDir(NmF,L) == 0){
	      printf("%s is not an Input directory for %s%c\n",NmF,blb->NmB,7);
	      return(1);
	    }
	    CbStrCpyD(pntB->ID,Ps[k]);
	    Ps	=(char**)realloc((void*)Ps,(i+3)*sizeof(char*));
	    n	=i+1;
	    Ps[n]	=(char*)malloc((LBLBID+1)*sizeof(char));
	    CbStrCpyD(Ps[n]," ");
	    n++;
	    Ps[n]	=NULL;
	    BlbInpFNmD[kB]	=Ps;
	  }
	}	  
	else{
	  CbStrCpyD(pntB->ID,Ps[k]);
	}
      }
      else{
	CbStrCpyD(pntB->ID,Ps[k]);
	if(Flag>1){
	  i	=pntB->iB;
	  strcpy(NmF,blb[i].pathI);
	  L	=blb[i].LpathI;
	  iD	=0;
	  i	=0;
	  p1	=pntB->NmB;
	  while(FDListDE[i]!=NULL){
	    FDListDE[i][0]	=' ';
	    sprintf(NmF+L,"/%s/In/CbDir.st",FDListDE[i]+1);
	    if((fp= fopen(NmF,"r"))!=NULL){
	      while(feof(fp)==0){
		p	=fgets(ln,80,fp);
		if(p==NULL)
		  break;
		while(*p!='"'&&*p!='\0'){
		  p++;
		}
		if(*p=='"'){
		  p++;
		  while(isspace(*p))
		    p++;
		  p2	=p;
		  while(*p2!='/'&&*p2!='\0'){
		    p2++;
		  }
		  *p2	='\0';
		  if(strcmp(p,p1)==0){
		    FDListDE[i][0]	='+';
		    iD++;
		    break;
		  }
		}
	      }
	      fclose(fp);
	    }
	    i++;
	  }
	  Ps	=BlbInpFNmD[kB];
	  i	=0;
	  while(Ps[i]!=NULL){
	    free(Ps[i]);
	    i++;
	  }
	  free(Ps);
	  if(iD){
	    Ps	=(char**)malloc((iD+1)*sizeof(char*));
	    i	=0;
	    iD	=0;
	    while(FDListDE[i]!=NULL){
	      if(FDListDE[i][0]=='+'){
		Ps[iD]	=(char*)malloc((LBLBID+1)*sizeof(char));
		CbStrCpyD(Ps[iD],FDListDE[i]+1);
		iD++;
	      }
	      i++;
	    }
	  }
	  else{
	    iD	=1;
	    Ps	=(char**)malloc((iD+1)*sizeof(char*));
	    Ps[0]	=(char*)malloc((LBLBID+1)*sizeof(char));
	    CbStrCpyD(Ps[0],".");
	  }
	  Ps[iD]	=NULL;
	  BlbInpFNmD[kB]	=Ps;

	  p1	=pntB->ID;
	  for(k	=0;k<iD;k++){
	    if(CbStrCmp(Ps[k],p1)==0){
	      kBlbInpDir[kB]	=k;
	      break;
	    }
	  }
	  if(k==iD){
	    printf("%s is not an Input directory for <%s>%c\n",
		   pntB->ID,pntB->NmB,7);
	    k	=0;
	    kBlbInpDir[kB]	=0;
	    CbStrCpyD(pntB->ID,Ps[k]);
	  }
	}
      }
      p	=pntB->pathI;
      L	=0;
      if(kB){
	i	=pntB->iB;
	strcpy(p,blb[i].pathI);
	L	=blb[i].LpathI;
	p	+=L;
	*p++	='/';
	L++;
      }
      pntB->LpathI	=L+CbStrCpy(p,pntB->ID);
      strcpy(NmF,pntB->pathI);
      n	=pntB->LpathI;
      strcpy(NmF+n,"/Wrk");
      CbInpFileListW(NmF,&FDListW);
      strcpy(NmF+n,"/Out");
      CbInpFileListO(NmF,&FDListO);
      strcpy(NmF+n,"/In");
      CbInpFileListI(NmF,&FDListI);
      NmF[n]	='\0';

      p	=ln1;
      i	=kB;
      while(i>=0){
	p1	=blb[i].NmB;
	while(*p1!='\0')
	  *p++	=*p1++;
	if(i>0)
	  *p++	='/';
	i	=blb[i].iB;
      }
      *p	='\0';
      L	=p-ln1;
      ND	=10;
      FDListD	=(char**)malloc(ND*sizeof(char*));
      iD	=0;
      if((dirp=opendir(NmF)) != NULL){
	while((direntp= readdir(dirp))!=NULL){
	  p1	=direntp->d_name;
	  Fl	=0;
	  if(strcmp(p1,"Wrk")&&strcmp(p1,"Out")&&strcmp(p1,"In")
	     &&strcmp(p1,"Csrc")&&strcmp(p1,"Fsrc")){
	    Fl	=1;
	  }
	  if(strcmp(p1,"..") == 0){
	    Fl	=0;
	  }
	  if(Fl){
	    p1	=direntp->d_name;
	    sprintf(NmF+n,"/%s",p1);
	    stat(NmF,&statbuf);
	    if((statbuf.st_mode&S_IFMT)==S_IFDIR){
	      if(CbIsCodeInpDir(NmF,strlen(NmF))){
		FDListD[iD]	=(char*)malloc((LBLBID+2)*sizeof(char));
		FDListD[iD][0]	=' ';
		strcpy(FDListD[iD]+1,p1);
		iD++;
		if(iD+1>=ND){
		  ND	+=10;
		  FDListD=(char**)realloc((void*)FDListD,ND*sizeof(char*));
		}
	      }	
	    }
	  }
	}
	closedir(dirp);
      }
      FDListD[iD]	=NULL;
    }
    else{
      FDListD	=FDListDE;
      FDListW	=FDListWE;
      FDListO	=FDListOE;
      FDListI	=FDListIE;
    }
  }

  if(Flag){
    p1	=pntB->NmB;
    L	=strlen(p1);


    n	=0;
    iB	=0;
    while(FDListW[iB]!=NULL){
      p	=FDListW[iB];
      if(strncmp(p,p1,L)==0&&p[L]=='.')
	n++;
      iB++;
    }
    n++;
    Ps	=BlbInpFNmW[kB];
    i	=0;
    while(Ps[i]!=NULL){
      free(Ps[i]);
      i++;
    }
    free(Ps);
    Ps	=(char**)malloc((n+1)*sizeof(char*));
    BlbInpFNmW[kB]	=Ps;
    for(i= 0;i<n;i++){
      Ps[i]	=(char*)malloc(4*sizeof(char));
    }
    n	=0;
    iB	=0;
    while(FDListW[iB]!=NULL){
      p	=FDListW[iB];
      if(strncmp(p,p1,L)==0&&p[L]=='.'){
	strcpy(Ps[n],p+L);
	n++;
      }
      iB++;
    }
    strcpy(Ps[n],".__");
    n++;
    Ps[n]	=NULL;

    n	=0;
    iB	=0;
    while(FDListO[iB]!=NULL){
      p	=FDListO[iB];
      if(strncmp(p,p1,L)==0&&p[L]=='.')
	n++;
      iB++;
    }
    n++;
    Ps	=BlbInpFNmO[kB];
    i	=0;
    while(Ps[i]!=NULL){
      free(Ps[i]);
      i++;
    }
    free(Ps);
    Ps	=(char**)malloc((n+1)*sizeof(char*));
    BlbInpFNmO[kB]	=Ps;
    for(i= 0;i<n;i++){
      Ps[i]	=(char*)malloc(4*sizeof(char));
    }
    n	=0;
    iB	=0;
    while(FDListO[iB]!=NULL){
      p	=FDListO[iB];
      if(strncmp(p,p1,L)==0&&p[L]=='.'){
	strcpy(Ps[n],p+L);
	n++;
      }
      iB++;
    }
    strcpy(Ps[n],".__");
    n++;
    Ps[n]	=NULL;


    n	=0;
    iB	=0;
    while(FDListI[iB]!=NULL){
      p	=FDListI[iB];
      if(strncmp(p,p1,L)==0&&p[L]=='.')
	n++;
      iB++;
    }
    n++;
    Ps	=BlbInpFNmI[kB];
    i	=0;
    while(Ps[i]!=NULL){
      free(Ps[i]);
      i++;
    }
    free(Ps);
    Ps	=(char**)malloc((n+1)*sizeof(char*));
    BlbInpFNmI[kB]	=Ps;
    for(i= 0;i<n;i++){
      Ps[i]	=(char*)malloc(4*sizeof(char));
    }
    n	=0;
    iB	=0;
    while(FDListI[iB]!=NULL){
      p	=FDListI[iB];
      if(strncmp(p,p1,L)==0&&p[L]=='.'){
	strcpy(Ps[n],p+L);
	n++;
      }
      iB++;
    }
    strcpy(Ps[n],".__");
    n++;
    Ps[n]	=NULL;
  }

  nM	=pntB->nM;
  for(iM= 0;iM<nM;iM++){
    nS	=pntB->nS[iM];
    for(iS	=0;iS<nS;iS++){
      if(Flag){
	p1	=pntB->NmS[iM][iS];
	L	=strlen(p1);


	n	=0;
	i	=0;
	while(FDListW[i]!=NULL){
	  p	=FDListW[i];
	  if(strncmp(p,p1,L)==0&&p[L]=='.')
	    n++;
	  i++;
	}
	n++;
	Ps	=StgInpFNmW[kB][iM][iS];
	i	=0;
	while(Ps[i]!=NULL){
	  free(Ps[i]);
	  i++;
	}
	free(Ps);
	Ps	=(char**)malloc((n+1)*sizeof(char*));
	StgInpFNmW[kB][iM][iS]	=Ps;
	for(i= 0;i<n;i++){
	  Ps[i]	=(char*)malloc(4*sizeof(char));
	}
	n	=0;
	i	=0;
	while(FDListW[i]!=NULL){
	  p	=FDListW[i];
	  if(strncmp(p,p1,L)==0&&p[L]=='.'){
	    strcpy(Ps[n],p+L);
	    n++;
	  }
	  i++;
	}
	strcpy(Ps[n],".__");
	n++;
	Ps[n]	=NULL;


	n	=0;
	i	=0;
	while(FDListO[i]!=NULL){
	  p	=FDListO[i];
	  if(strncmp(p,p1,L)==0&&p[L]=='.')
	    n++;
	  i++;
	}
	n++;
	Ps	=StgInpFNmO[kB][iM][iS];
	i	=0;
	while(Ps[i]!=NULL){
	  free(Ps[i]);
	  i++;
	}
	free(Ps);
	Ps	=(char**)malloc((n+1)*sizeof(char*));
	StgInpFNmO[kB][iM][iS]	=Ps;
	for(i= 0;i<n;i++){
	  Ps[i]	=(char*)malloc(4*sizeof(char));
	}
	n	=0;
	i	=0;
	while(FDListO[i]!=NULL){
	  p	=FDListO[i];
	  if(strncmp(p,p1,L)==0&&p[L]=='.'){
	    strcpy(Ps[n],p+L);
	    n++;
	  }
	  i++;
	}
	strcpy(Ps[n],".__");
	n++;
	Ps[n]	=NULL;


	n	=0;
	i	=0;
	while(FDListI[i]!=NULL){
	  p	=FDListI[i];
	  if(strncmp(p,p1,L)==0&&p[L]=='.')
	    n++;
	  i++;
	}
	n++;
	Ps	=StgInpFNmI[kB][iM][iS];
	i	=0;
	while(Ps[i]!=NULL){
	  free(Ps[i]);
	  i++;
	}
	free(Ps);
	Ps	=(char**)malloc((n+1)*sizeof(char*));
	StgInpFNmI[kB][iM][iS]	=Ps;
	for(i= 0;i<n;i++){
	  Ps[i]	=(char*)malloc(4*sizeof(char));
	}
	n	=0;
	i	=0;
	while(FDListI[i]!=NULL){
	  p	=FDListI[i];
	  if(strncmp(p,p1,L)==0&&p[L]=='.'){
	    strcpy(Ps[n],p+L);
	    n++;
	  }
	  i++;
	}
	strcpy(Ps[n],".__");
	n++;
	Ps[n]	=NULL;
      }
    }

    nB	=pntB->nB[iM];
    for(iB= 0;iB<nB;iB++){
      i	=pntB->nxtB[iM][iB];
      CbReSetBlbInputFiles(Flag,i,FDListD,FDListW,FDListO,FDListI);
    }
  }

  if(pntB->OD[0]!='\0'){
    if(FDListI!=NULL){
      iB	=0;
      while(FDListI!=NULL&&FDListI[iB]!=NULL){
	free(FDListI[iB]);
	iB++;
      }
      free(FDListI);
    }
    if(FDListO!=NULL){
      iB	=0;
      while(FDListO[iB]!=NULL){
	free(FDListO[iB]);
	iB++;
      }
      free(FDListO);
    }
    if(FDListW!=NULL){
      iB	=0;
      while(FDListW[iB]!=NULL){
	free(FDListW[iB]);
	iB++;
      }
      free(FDListW);
    }
    if(FDListD!=NULL){
      iB	=0;
      while(FDListD[iB]!=NULL){
	free(FDListD[iB]);
	iB++;
      }
      free(FDListD);
    }
  }
  return(0);
}

int CbIsInpDir(char*buf,char*str)
{
  if(*str == '\0'){
    return(0);
  }
  sprintf(buf,"%s/In",str);
  if(stat(buf,&statbuf) || (statbuf.st_mode&S_IFDIR) == 0){
    return(0);
  }
  return(1);
}

int CbIsInInpList(char**List,char*str)
{
  int i;

  if(List==NULL||*str=='\0')
    return(-1);

  i= 0;
  while(List[i]!=NULL){
    if(CbStrCmp(List[i],str)==0){
      return(i);
    }
    i++;
  }
  return(-1);
}

int CbIsInNameList(char**List,char*str)
{
  int i,L;
  char*p;

  if(List==NULL||*str=='\0')
    return(-1);

  L= strlen(str);
  i= 0;
  while(List[i]!=NULL){
    p= List[i];
    while(isspace(*p))
      p++;
    if(strncmp(p,str,L)==0&&(p[L]=='\0'||isspace(p[L])))
      return(i);
    i++;
  }
  return(-1);
}

int CbStrCpyD(char*p1,char*p2)
{
  int i;

  i= 0;
  while(*p2!='\0'&&i<LBLBID){
    *p1++	=*p2++;
    i++;
  }
  while(i<LBLBID){
    *p1++	=' ';
    i++;
  }
  *p1= '\0';
  return(0);
}

static char**pNmM;
static int NM,kM,*LNmM,*iMB,*iMM;
typedef struct TOCMEM{
  char** pBin;
  int*	KB;
  char** pSt;
  char** pNmM;
  int* LNmM;
}TOCMEM;

int CbFreeToC(TOCMEM *pT){
  free(pT->LNmM);
  free(pT->pNmM);
  free(pT->pSt);
  free(pT->KB);
  free(pT->pBin);
  return(0);
} 

int GetCbTofContent()
{
  char ch,*pnt,*pnt1,*pnt2;

  char**pBin,**pBout,**pSt;
  int nBin,nBout,iBin,NBin,NSt,*KB;
  int nM;
  int k,k0,k1,k2,ik0,ik1,ik2;

  int ic,i,j,iM,iS,iB,nB,kB;
  int nCbW= 5,LCbW= 3,iCbW;
  char*CbW[5]= {"stg","Stg","mzl","blb","Blb"};
  TOCMEM TM;

  NBin	=128;

  TM.pBin	=(char**)malloc(2*NBin*sizeof(char*));
  pBin	=TM.pBin;
  pBout	=pBin+NBin;
  TM.KB	=(int*)malloc(NBin*sizeof(int));
  KB	=TM.KB;
  NSt	=128;
  TM.pSt	=(char**)malloc(NSt*sizeof(char*));
  pSt	=TM.pSt;
  pnt	=Buff;
  NM	=0;
  while(*pnt != '\0'){
    if(*pnt == 'm' && strncmp(pnt,"mzl_",4) == 0){
      NM++;
    }
    pnt++;
  }
  TM.pNmM	=(char**)malloc(NM*sizeof(char*));
  TM.LNmM	=(int*)malloc(NM*sizeof(int));
  pNmM	=TM.pNmM;
  LNmM	=TM.LNmM;
  
  nBin	=1;
  nblb	=1;
  iblb	=0;
  pBin[0]	=Buff;
  do{
    nBout	=0;
    for(iBin=0; iBin < nBin; iBin++,iblb++){
      blb[iblb].path	=NULL;
      pnt	=pBin[iBin];
      if(ReadCbElmAlias(&pnt,&blb[iblb].NmB)){
	printf("ReadCbElmAlias(&pnt,&blb[%s].NmB)\n",iblb);
	CbFreeToC(&TM);
	return(1);
      }
      if(ReadCbElmParam(&pnt,&blb[iblb].mB,&blb[iblb].imB
			,&blb[iblb].OB,&blb[iblb].iOB
			,&blb[iblb].IB,&blb[iblb].iIB)){
	printf("ReadCbElmParam\n");
	CbFreeToC(&TM);
	return(1);
      }
      blb[iblb].mBt	=blb[iblb].mB;
      blb[iblb].OBt	=blb[iblb].OB;
      blb[iblb].IBt	=blb[iblb].IB;

      blb[iblb].imB	=0;
      blb[iblb].iOB	=0;
      blb[iblb].iIB	=0;
      blb[iblb].imBt	=blb[iblb].imB;
      blb[iblb].iOBt	=blb[iblb].iOB;
      blb[iblb].iIBt	=blb[iblb].iIB;

      if(*pnt != '{'){
	printf("Blb %d has no onen {\n",iblb);
	CbFreeToC(&TM);
	return(1);
      }
      ic	=0;
      nM	=0;
      pnt1	=pnt;
      do{
	ch	=*pnt;
	if(ch == '{')	ic++;
	if(ch == '}')   ic--;
	if(ic == 1){
	  if(strncmp(pnt,"mzl_",4) == 0){
	    pnt	+=4;
	    pNmM[nM]	=pnt;
	    j	=0;
	    while(*pnt!='('&&*pnt!='{'&&*pnt!=';'&&*pnt!='\n'&&*pnt!='\0'){
	      pnt++;
	      j++;
	    }
	    LNmM[nM]=j;
	    for(i=0; i < nM; i++){
	      if(LNmM[i] == j && strncmp(pNmM[i],pNmM[nM],j) == 0){
		break;
	      }
	    }
	    if(i == nM) nM++;
	    while(*pnt != '{' && *pnt != '\0') pnt++;
	    if(*pnt != '{'){
	      printf("No '{' in line:\n");
	      PrintLine(pnt);
	      CbFreeToC(&TM);
	      return(1);
	    }
	    pnt--;
	  }
	}
	pnt++;
      }while(ic && *pnt != '\0');

      blb[iblb].nM	=nM;
      if(nM == 0) continue;

      blb[iblb].path	=NULL;
      if(nM == 0){
	CbFreeToC(&TM);
	printf("Error: %s  does not contain any mzl\n",blb[iblb].NmB);
	CbDeInitCb();
	exit(0);
      }

      blb[iblb].nS	=(int*)malloc(18*nM*sizeof(int));
      blb[iblb].nB	=blb[iblb].nS+nM;
      blb[iblb].mM	=blb[iblb].nB+nM;
      blb[iblb].OM	=blb[iblb].mM+nM;
      blb[iblb].IM	=blb[iblb].OM+nM;
      blb[iblb].mMt	=blb[iblb].IM+nM;
      blb[iblb].OMt	=blb[iblb].mMt+nM;
      blb[iblb].IMt	=blb[iblb].OMt+nM;
      blb[iblb].iMB	=blb[iblb].IMt+nM;
      blb[iblb].iMM	=blb[iblb].iMB+nM;
      blb[iblb].iCM	=blb[iblb].iMM+nM;
      blb[iblb].jCM	=blb[iblb].iCM+nM;
      blb[iblb].imM	=blb[iblb].jCM+nM;
      blb[iblb].iOM	=blb[iblb].imM+nM;
      blb[iblb].iIM	=blb[iblb].iOM+nM;
      blb[iblb].imMt	=blb[iblb].iIM+nM;
      blb[iblb].iOMt	=blb[iblb].imMt+nM;
      blb[iblb].iIMt	=blb[iblb].iOMt+nM;

      blb[iblb].mS	=(int**)malloc(16*nM*sizeof(int*));
      blb[iblb].OS	=blb[iblb].mS+nM;
      blb[iblb].IS	=blb[iblb].OS+nM;
      blb[iblb].mSt	=blb[iblb].IS+nM;
      blb[iblb].OSt	=blb[iblb].mSt+nM;
      blb[iblb].ISt	=blb[iblb].OSt+nM;
      blb[iblb].iCS	=blb[iblb].ISt+nM;
      blb[iblb].jCS	=blb[iblb].iCS+nM;
      blb[iblb].imS	=blb[iblb].jCS+nM;
      blb[iblb].iOS	=blb[iblb].imS+nM;
      blb[iblb].iIS	=blb[iblb].iOS+nM;
      blb[iblb].imSt	=blb[iblb].iIS+nM;
      blb[iblb].iOSt	=blb[iblb].imSt+nM;
      blb[iblb].iISt	=blb[iblb].iOSt+nM;
      blb[iblb].kB	=blb[iblb].iISt+nM;
      blb[iblb].nxtB	=blb[iblb].kB+nM;

      blb[iblb].NmM	=(char**)malloc(8*nM*sizeof(char*));
      blb[iblb].NmMTF	=blb[iblb].NmM+nM;
      blb[iblb].NmMSF	=blb[iblb].NmMTF+nM;
      blb[iblb].TtM	=blb[iblb].NmMSF+nM;
      blb[iblb].TbM	=blb[iblb].TtM+nM;
      blb[iblb].bTbM	=blb[iblb].TbM+nM;
      blb[iblb].eTbM	=blb[iblb].bTbM+nM;
      blb[iblb].HpM	=blb[iblb].eTbM+nM;

      blb[iblb].NmS	=(char***)malloc(8*nM*sizeof(char**));
      blb[iblb].NmSTF	=blb[iblb].NmS+nM;
      blb[iblb].NmSSF	=blb[iblb].NmSTF+nM;
      blb[iblb].TtS	=blb[iblb].NmSSF+nM;
      blb[iblb].TbS	=blb[iblb].TtS+nM;
      blb[iblb].bTbS	=blb[iblb].TbS+nM;
      blb[iblb].eTbS	=blb[iblb].bTbS+nM;
      blb[iblb].HpS	=blb[iblb].eTbS+nM;

      if(blb[iblb].NmSTF == NULL){
	printf("No memory for blb[%d].NmSTF\n in ReadCbTofContent\n",iblb);
	CbFreeToC(&TM);
	CbDeInitCb();
	exit(1);
      }

      for(iM= 0;iM<nM;iM++){
	iS	=0;
	iB	=0;
	kB	=0;
	i	=LNmM[iM];
	blb[iblb].NmM[iM]	=(char*)malloc((i+1)*sizeof(char));
	if(blb[iblb].NmM[iM] == NULL){
	  printf("No memory for blb[%d].MmM[%d]\n in GetCbTofContent()\n",
		 iblb,iM);
	  CbFreeToC(&TM);
	  CbDeInitCb();
	  exit(1);
	}
	pnt	=pNmM[iM];
	strncpy(blb[iblb].NmM[iM],pnt,i);
	blb[iblb].NmM[iM][i]	='\0';
	pnt	+=i;
	if(ReadCbElmParam(&pnt,&blb[iblb].mM[iM],&blb[iblb].imM[iM]
			  ,&blb[iblb].OM[iM],&blb[iblb].iOM[iM]
			  ,&blb[iblb].IM[iM],&blb[iblb].iIM[iM])){
	  printf("??? ReadCbElmParam(&pn\n");
	  CbFreeToC(&TM);
	  return(1);
	}
	blb[iblb].mMt[iM]	=blb[iblb].mM[iM];
	blb[iblb].OMt[iM]	=blb[iblb].OM[iM];
	blb[iblb].IMt[iM]	=blb[iblb].IM[iM];

	blb[iblb].imM[iM]	=0;
	blb[iblb].iOM[iM]	=0;
	blb[iblb].iIM[iM]	=0;
	blb[iblb].imMt[iM]	=blb[iblb].imM[iM];
	blb[iblb].iOMt[iM]	=blb[iblb].iOM[iM];
	blb[iblb].iIMt[iM]	=blb[iblb].iIM[iM];
	pnt	=pnt1;
	ic	=0;
	do{
	  ch	=*pnt;
	  if(ch=='{')
	    ic++;
	  if(ch=='}')
	    ic--;
	  if(ic==1){
	    if(strncmp(pnt,"mzl",3)==0){
	      pnt	+=4;
	      pnt2	=pnt;
	      i	=0;
	      while(*pnt2!='('&&*pnt2!='{'&&*pnt2!=';'
		    &&*pnt2!='\n'&&*pnt2!='\0'){
		pnt2++;
		i++;
	      }
	      if(i==LNmM[iM]&&strncmp(pnt,pNmM[iM],i)==0){
		while(*pnt!='{')
		  pnt++;
		pnt--;
	      }
	      else{
		while(*pnt!='{')
		  pnt++;
		do{
		  if(*pnt=='{')
		    ic++;
		  if(*pnt=='}')
		    ic--;
		  pnt++;
		}while(ic>1);
	      }
	    }
	  }
	  if(ic==2){
	    if((strncmp(pnt,"stg",3)==0)||(strncmp(pnt,"Stg",3)==0)){
	      pnt	+=3;
	      if(iS==NSt){
		NSt	+=128;
		TM.pSt	=(char**)realloc((void*)pSt,NSt*sizeof(char*));
		pSt	=TM.pSt;
	      }
	      pSt[iS]	=pnt;
	      iS++;
	      kB++;
	      while(*pnt!=';'&&*pnt!='\n'&&*pnt!='\0')
		pnt++;
	      if(*pnt!=';'){
		printf(" No ';' in line\n");
		PrintLine(pnt);
		CbFreeToC(&TM);
		return(1);
	      }
	      pnt--;
	    }
	    if((strncmp(pnt,"blb",3)==0)||(strncmp(pnt,"Blb",3)==0)){
	      KB[iB]	=kB;
	      iB++;
	      kB++;
	      pBout[nBout]	=pnt;
	      nBout++;
	      pnt	+=3;
	      while(*pnt!='{'&&*pnt!='\0')
		pnt++;
	      if(*pnt!='{'){
		printf(" No '{' in line\n");
		CbFreeToC(&TM);
		return(1);
	      }
	      pnt--;
	      if(nBout == NBin){
		NBin	+=128;
		TM.pBin	=(char**)realloc((void*)pBin,2*NBin*sizeof(char*));
		TM.KB	=(int*)realloc((void*)KB,NBin*sizeof(int));
		pBin	=TM.pBin;
		KB	=TM.KB;
		pBout	=pBin+NBin;
	      }
	    }
	  }
	  pnt++;
	}while(ic>0&&*pnt!='\0');
	blb[iblb].nS[iM]	=iS;
	blb[iblb].mS[iM]	=(int*)malloc(14*iS*sizeof(int));
	if(blb[iblb].mS[iM]==NULL&&iS){
	  printf("No memory for blb[%d].mS[%d]\n in GetCbTofContent()\n",
		 iblb,iM);
	  CbFreeToC(&TM);
	  CbDeInitCb();
	  exit(1);
	}
	blb[iblb].OS[iM]	=blb[iblb].mS[iM]+iS;
	blb[iblb].IS[iM]	=blb[iblb].OS[iM]+iS;
	blb[iblb].mSt[iM]	=blb[iblb].IS[iM]+iS;
	blb[iblb].OSt[iM]	=blb[iblb].mSt[iM]+iS;
	blb[iblb].ISt[iM]	=blb[iblb].OSt[iM]+iS;
	blb[iblb].iCS[iM]	=blb[iblb].ISt[iM]+iS;
	blb[iblb].jCS[iM]	=blb[iblb].iCS[iM]+iS;
	blb[iblb].imS[iM]	=blb[iblb].jCS[iM]+iS;
	blb[iblb].iOS[iM]	=blb[iblb].imS[iM]+iS;
	blb[iblb].iIS[iM]	=blb[iblb].iOS[iM]+iS;
	blb[iblb].imSt[iM]	=blb[iblb].iIS[iM]+iS;
	blb[iblb].iOSt[iM]	=blb[iblb].imSt[iM]+iS;
	blb[iblb].iISt[iM]	=blb[iblb].iOSt[iM]+iS;

	blb[iblb].NmS[iM]	=(char**)malloc(iS*sizeof(char*));
	if(blb[iblb].NmS[iM] == NULL && iS){
	  printf("No memory for blb[%d].NmS[%d]\n in GetCbTofContent()\n",
		 iblb,iM);
	  CbFreeToC(&TM);
	  CbDeInitCb();
	  exit(1);
	}
	blb[iblb].NmSTF[iM]	=(char**)malloc(7*iS*sizeof(char*));
	if(blb[iblb].NmSTF[iM] == NULL && iS){
	  printf("No memory for blb[%d].NmSTF[%d]\n in GetCbTofContent()\n",
		 iblb,iM);
	  CbFreeToC(&TM);
	  CbDeInitCb();
	  exit(1);
	}
	blb[iblb].NmSSF[iM]	=blb[iblb].NmSTF[iM]+iS;
	blb[iblb].TtS[iM]	=blb[iblb].NmSSF[iM]+iS;
	blb[iblb].TbS[iM]	=blb[iblb].TtS[iM]+iS;
	blb[iblb].bTbS[iM]	=blb[iblb].TbS[iM]+iS;
	blb[iblb].eTbS[iM]	=blb[iblb].bTbS[iM]+iS;
	blb[iblb].HpS[iM]	=blb[iblb].eTbS[iM]+iS;
	for(i= 0;i<iS;i++){
	  pnt2	=pSt[i];
	  if(ReadCbElmAlias(&pnt2,&blb[iblb].NmS[iM][i])||
	     ReadCbElmParam(&pnt2,&blb[iblb].mS[iM][i],&blb[iblb].imS[iM][i],
			    &blb[iblb].OS[iM][i],&blb[iblb].iOS[iM][i],
			    &blb[iblb].IS[iM][i],&blb[iblb].iIS[iM][i])){
	    printf("???? ReadCbElmAlias(&pnt\n");
	    CbFreeToC(&TM);
	    return(1);

	  }
	  blb[iblb].mSt[iM][i]	=blb[iblb].mS[iM][i];
	  blb[iblb].OSt[iM][i]	=blb[iblb].OS[iM][i];
	  blb[iblb].ISt[iM][i]	=blb[iblb].IS[iM][i];
	  blb[iblb].imS[iM][i]	=0;
	  blb[iblb].iOS[iM][i]	=0;
	  blb[iblb].iIS[iM][i]	=0;
	  blb[iblb].imSt[iM][i]	=blb[iblb].imS[iM][i];
	  blb[iblb].iOSt[iM][i]	=blb[iblb].iOS[iM][i];
	  blb[iblb].iISt[iM][i]	=blb[iblb].iIS[iM][i];
	}

	blb[iblb].nB[iM]	=iB;
	if(iB){
	  blb[iblb].kB[iM]	=(int*)malloc(2*iB*sizeof(int));
	  if(blb[iblb].kB[iM]==NULL&&iB){
	    printf("No memory for blb[%d].kB[%d]\n in ConstructStr",iblb,iM);
	    CbFreeToC(&TM);
	    CbDeInitCb();
	    exit(1);
	  }
	  blb[iblb].nxtB[iM]	=blb[iblb].kB[iM]+iB;
	}
	if(nblb+iB>Nblb){
	  Nblb	+=10;
	  blb	=(BLB*)realloc((void*)blb,Nblb*sizeof(BLB));
	  if(blb==NULL){
	    printf("No memory for BLB\n");
	    CbFreeToC(&TM);
	    CbDeInitCb();
	    exit(1);
	  }
	}
	for(i= 0;i<iB;i++){
	  blb[iblb].kB[iM][i]	=KB[i];
	  blb[iblb].nxtB[iM][i]	=nblb;
	  nblb++;
	}
      }
    }
    nBin	=nBout;
    for(iBin	=0;iBin<nBin;iBin++){
      pBin[iBin]	=pBout[iBin];
    }
  }while(nBout!=0);

  blb[0].iB	=-1;
  blb[0].iM	=0;
  blb[0].kS	=0;
  for(iblb= 0;iblb<nblb;iblb++){
    blb[iblb].s	=0;
    blb[iblb].xM	=0;
    nM	=blb[iblb].nM;
    for(iM	=0;iM<nM;iM++){
      nB	=blb[iblb].nB[iM];
      for(iB= 0;iB<nB;iB++){
	i	=blb[iblb].nxtB[iM][iB];
	blb[i].iB	=iblb;
	blb[i].iM	=iM;
	blb[i].kS	=blb[iblb].kB[iM][iB];
      }
    }
  }

  iMB	=(int*)malloc(NM*sizeof(int));
  iMM	=(int*)malloc(NM*sizeof(int));

  kM	=0;
  CbInitChildMzl(0);
  TM.pNmM	=pNmM;

  free(iMM);
  free(iMB);
  CbFreeToC(&TM);
  return(0);
}

int CbInitChildMzl(int IB)
{
  int i,iB,nB,iM,nM;
  int *kMB, *kMM,kkM;
  char*pnt;

  kkM= kM;
  kMB= (int*)malloc(kkM*sizeof(int));
  kMM= (int*)malloc(kkM*sizeof(int));
  for(i= 0;i<kM;i++){
    kMB[i]= iMB[i];
    kMM[i]= iMM[i];
  }
  nM= blb[IB].nM;
  for(iM= 0;iM<nM;iM++){
    pnt= blb[IB].NmM[iM];
    for(i= 0;i<kM;i++){
      if(strcmp(pnt,pNmM[i])==0){
	blb[IB].iMB[iM]= iMB[i];
	blb[IB].iMM[iM]= iMM[i];
	iMB[i]= IB;
	iMM[i]= iM;
	break;
      }
    }
    if(i==kM){
      pNmM[i]= pnt;
      iMB[i]= IB;
      iMM[i]= iM;
      blb[IB].iMB[iM]= -1;
      blb[IB].iMM[iM]= -1;
      kM++;
      if(kM==NM){
	NM	+=128;
	pNmM= (char**)realloc((void*)pNmM,NM*sizeof(char*));
	iMB= (int*)realloc((void*)iMB,NM*sizeof(int));
	iMM= (int*)realloc((void*)iMM,NM*sizeof(int));
      }
    }
  }
  for(iM= 0;iM<nM;iM++){
    nB= blb[IB].nB[iM];
    for(iB= 0;iB<nB;iB++){
      i= blb[IB].nxtB[iM][iB];
      CbInitChildMzl(i);
    }
  }
  kM	=kkM;
  for(i=0; i <kM;i++){
    iMB[i]	=kMB[i];
    iMM[i]	=kMM[i];
  }

  free(kMM);
  free(kMB);
  return(0);
}

int ReadCbElmAlias(char**pnt0,char**NmB)
{
  char*lc,*lt;
  int i;

  lc	=*pnt0;
  while(*lc != '_' && *lc!='{' && *lc != ';'&& *lc!='\n' && *lc!='\0') lc++;
  if(*lc != '_'){
    printf("In %s, no Block name in line:\n",NmF);
    PrintLine(lc);
    return(1);
  }
  lc++;
  i	=0;
  lt	=lc;
  while(*lc != '(' && *lc != '{' && *lc != ';' && *lc != '\n' && *lc != '\0'){
    lc++;
    i++;
  }
  if(i == 0){
    printf("In %s, empty Block name in line:\n",NmF);
    PrintLine(lc);
    return(1);
  }
  *NmB	=(char*)malloc((i+1)*sizeof(char));
  strncpy(*NmB,lt,i);
  *(*NmB+i)	='\0';
  *pnt0	=lc;

  return(0);
}

int ReadCbElmParam(char**pnt0,int*k0,int*ik0,int*k1,int*ik1,int*k2,int*ik2)
{
  char*lc,*lc1;
  lc	=*pnt0;
  *k0	=0x2000;
  *k1	=0;
  *k2	=0x300;
  *ik0	=0x2000;
  *ik1	=0;
  *ik2	=0x300;
  while(*lc != '(' && *lc != '{' && *lc != ';' && *lc != '\0') lc++;
  if(*lc == '('){
    lc++;
    if(CbAliases2ModeOutIn(&lc,k0,ik0,k1,ik1,k2,ik2)){
      printf("In %s: wrong Block parameters in line:\n",NmF);
      PrintLine(lc);
      return(1);
    }
    while(*lc != ')' && *lc != '{' && *lc != ';' && *lc!='\0') lc++;
    if(*lc != ')'){
      printf("In %s, no ')' in Block parameters in line:\n",NmF);
      PrintLine(lc);
      return(1);
    }
  }
  while(*lc != '{' && *lc != ';' && *lc != '\0') lc++;
  *pnt0	=lc;
  return(0);
}

int PrintLine(char*pnt)
{
  while(*pnt!='\n'&&pnt>Buff)
    pnt--;
  if(*pnt=='\n')
    pnt++;
  while(*pnt!='\n'&&pnt!='\0'){
    putchar(*pnt);
    pnt++;
  }
  putchar('\n');
  return(0);
}

int PPrintLine(char*pnt0,char*pnt)
{
  while(*pnt!='\n'&&pnt>pnt0)
    pnt--;
  if(*pnt=='\n')
    pnt++;
  while(*pnt!='\n'&&pnt!='\0'){
    putchar(*pnt);
    pnt++;
  }
  putchar('\n');
  return(0);
}

int CbPrintBlbContent(int IB)
{
  static char ln0[80]= {'\0'};
  static int indent= 0;
  BLB*pntB;
  int i,iM,nM,iS,nS,iB,nB,kB,n;

  pntB= blb+IB;
  printf("%sBlb_%s{\n",ln0,pntB->NmB);
  ln0[indent]= ' ';
  indent++;
  ln0[indent]= ' ';
  indent++;
  ln0[indent]= '\0';
  nM= pntB->nM;
  for(iM= 0;iM<nM;iM++){
    printf("%smzl_%s{\n",ln0,pntB->NmM[iM]);
    ln0[indent]= ' ';
    indent++;
    ln0[indent]= ' ';
    indent++;
    ln0[indent]= '\0';
    nS= pntB->nS[iM];
    nB= pntB->nB[iM];
    n= nS+nB;
    iB= 0;
    iS= 0;
    i= 0;
    if(nB)
      kB= pntB->kB[iM][iB];
    while(i<n){
      if(iB<nB&&i==kB){
	CbPrintBlbContent(pntB->nxtB[iM][iB]);
	iB++;
	if(iB<nB)
	  kB= pntB->kB[iM][iB];
      }
      else{
	if(iS<nS){
	  printf("%sstg_%s;\n",ln0,pntB->NmS[iM][iS]);
	  iS++;
	}
      }
      i++;
    }
    indent	-=2;
    ln0[indent]= '\0';
    printf("%s}\n",ln0);
  }
  indent	-=2;
  ln0[indent]= '\0';
  printf("%s}\n",ln0);
  return(0);
}

int GetCbDescription()
{
  char ch,*pntB,*pntM,*pntS,*pnt,*pnt1,*pnt2;
  int ic,icB,Fl;
  int i,k,iM,nM,iS,nS,iB,nB;

  static int nCbW= 5,LCbW= 3,iCbW,jCbW;
  char*CbW[5]= {"stg","Stg","mzl","blb","Blb"};

  static int nCbE= 11,LCbE[11]= {3,3,2,2,4,3,4,4,2,3,3},iCbE;
  char*CbE[11]= {"mzl","blb","TF","SF","Name","TbF","&bTb","&eTb","OD","str"
		   ,"Hlp"};
  char*pntID1,*pntD[11];
  float t[3];

  i= 0;
  for(iblb= 0;iblb<nblb;iblb++){
    i++;
    blb[iblb].NmBTF= NULL;
    blb[iblb].NmBSF= NULL;
    blb[iblb].TtB= NULL;
    blb[iblb].TbB= NULL;
    blb[iblb].HpB= NoHelpMess;

    nM= blb[iblb].nM;
    for(iM= 0;iM<nM;iM++){
      i++;
      blb[iblb].NmMTF[iM]= NULL;
      blb[iblb].NmMSF[iM]= NULL;
      blb[iblb].TtM[iM]= NULL;
      blb[iblb].TbM[iM]= NULL;
      blb[iblb].bTbM[iM]= "";
      blb[iblb].eTbM[iM]= "";
      blb[iblb].HpM[iM]= NoHelpMess;
      nS= blb[iblb].nS[iM];
      for(iS= 0;iS<nS;iS++){
	i++;
	blb[iblb].NmSTF[iM][iS]= NULL;
	blb[iblb].NmSSF[iM][iS]= NULL;
	blb[iblb].TtS[iM][iS]= NULL;
	blb[iblb].TbS[iM][iS]= NULL;
	blb[iblb].bTbS[iM][iS]= "";
	blb[iblb].eTbS[iM][iS]= "";
	blb[iblb].HpS[iM][iS]= NoHelpMess;
      }
    }
  }
  nCbB= i;
  pDBuff= DBuff+1;
  while(pDBuff<eDBuff){
    Fl= 0;
    pntID1= NULL;
    pnt1= pDBuff;
    ch= *pDBuff;
    while(ch!='{'){
      if(isspace(ch)==0){
	switch(Fl){
	case 0:
	  for(iCbW= 0;iCbW<nCbW;iCbW++){
	    if(ch==CbW[iCbW][0]){
	      Fl= 1;
	      pDBuff	+=2;
	      break;
	    }
	  }
	  break;
	case 1:
	  if(ch=='_'){
	    Fl++;
	    pDBuff++;
	    pntID1= pDBuff;
	  }
	  break;
	case 2:
	  if(ch=='{'||ch=='\n'||ch=='\0'){
	    Fl++;
	    *pDBuff= '\0';
	  }
	  break;
	default:
	  break;
	}
      }
      pDBuff++;
      ch= *pDBuff;
    }
    if(Fl==2){
      Fl++;
      *pDBuff= '\0';
    }

    if(pntID1==NULL){
      printf("%s no Cb Alias in line:\n",NmF);
      PrintLine(pDBuff);
      return(1);
    }

    for(iCbE= 0;iCbE<nCbE;iCbE++){
      pntD[iCbE]= NULL;
    }
    pDBuff++;
    ic= 1;
    Fl= 0;
    do{
      ch= *pDBuff;
      if(ch=='{')
	ic++;
      if(ch=='}')
	ic--;
      switch(Fl){
      case 0:
	if(ch=='\n')
	  Fl= 1;
	break;
      case 1:
	if(!isspace(ch)){
	  for(iCbE= 0;iCbE<nCbE;iCbE++){
	    i= LCbE[iCbE];
	    if(strncmp(pDBuff,CbE[iCbE],i)==0&&!isalnum(*(pDBuff+i))){
	      pDBuff	+=i-1;
	      Fl++;
	      break;
	    }
	  }
	  if(iCbE==nCbE)
	    Fl= 0;
	}
	break;
      case 2:
	if(ch=='=')
	  Fl++;
	if(ch=='\n')
	  Fl= 1;
	break;
      case 3:
	if(!isspace(ch)){
	  if(iCbE<nCbE-1){
	    if(ch==';')
	      Fl= 0;
	    else{
	      pntD[iCbE]= pDBuff;
	      Fl++;
	    }
	  }
	  else{
	    if(ch=='\\'&&*(pDBuff+1)==';')
	      Fl= 0;
	    else{
	      pntD[iCbE]= pDBuff;
	      Fl++;
	    }
	  }
	}
	if(ch=='\n'&&iCbE<nCbE-1)
	  Fl= 1;
      case 4:
	if(ic==0){
	  if(isspace(*(pDBuff-1)))
	    *(pDBuff-1)= '\0';
	  else
	    *pDBuff= '\0';
	  Fl= 0;
	  break;
	}
	if(iCbE<nCbE-1){
	  if(ch==';'){
	    *pDBuff= '\0';
	    Fl= 0;
	  }
	  if(ch=='\n'){
	    if(isspace(*(pDBuff-1)))
	      *(pDBuff-1)= '\0';
	    else
	      *pDBuff= '\0';
	    Fl= 1;
	  }
	}
	else{
	  if(ch=='\\'&&*(pDBuff+1)==';'){
	    *pDBuff= '\0';
	    Fl= 0;
	  }
	}
	break;
      default:
	break;
      }
      pDBuff++;
    }while(ic);

#ifdef H
    printf("ID=<%s>\n",pntID1);
    for(i= 0;i<nCbE;i++)
      if(pntD[i]!= NULL)
	printf("[%d]%s=<%s>\n",i,CbE[i],pntD[i]);
#endif
    if(pntD[2]==NULL&&iCbW!=2){
      printf("%s no TF-target file name in Description Block:\n",NmF);
      PrintLine(pnt1);
      return(1);
    }
#ifdef H
    if(pntD[3]==NULL){
      printf("%s no SF-source file name in Block:\n",NmF);
      PrintLine(pnt1);
      return(1);
    }
#endif

    Fl= 0;
    switch(iCbW){
    case 0:
    case 1:
      if(pntD[0]==NULL){
	printf("%s no Reference blb in Block:\n",NmF);
	PrintLine(pnt1);
	return(1);
      }
      for(iblb= 0;iblb<nblb;iblb++){
	nM= blb[iblb].nM;
	for(iM= 0;iM<nM;iM++){
	  pntM= blb[iblb].NmM[iM];
	  if((strcmp(pntD[0],pntM)==0)){
	    nS= blb[iblb].nS[iM];
	    for(iS= 0;iS<nS;iS++){
	      if(strcmp(pntID1,blb[iblb].NmS[iM][iS])==0){
		blb[iblb].NmSTF[iM][iS]= pntD[2];
		blb[iblb].NmSSF[iM][iS]= pntD[3];
		if(pntD[4]!=NULL)
		  blb[iblb].TtS[iM][iS]= pntD[4];
		else
		  blb[iblb].TtS[iM][iS]= "";
		blb[iblb].TbS[iM][iS]= pntD[5];
		blb[iblb].bTbS[iM][iS]= pntD[6];
		blb[iblb].eTbS[iM][iS]= pntD[7];
		if(pntD[10]!=NULL)
		  blb[iblb].HpS[iM][iS]= pntD[10];
		Fl= 1;
		break;break;break;
	      }
	    }
	  }
	}
      }
      break;
    case 2:
      if(pntD[1]==NULL){
	printf("%s no Reference blb in Block:\n",NmF);
	PrintLine(pnt1);
	return(1);
      }
      for(iblb= 0;iblb<nblb;iblb++){
	pntB= blb[iblb].NmB;
	if((strcmp(pntD[1],pntB)==0)){
	  nM= blb[iblb].nM;
	  for(iM= 0;iM<nM;iM++){
	    if(strcmp(pntID1,blb[iblb].NmM[iM])==0){
	      blb[iblb].NmMTF[iM]= pntD[2];
	      blb[iblb].NmMSF[iM]= pntD[3];
	      if(pntD[4]!=NULL)
		blb[iblb].TtM[iM]= pntD[4];
	      else
		blb[iblb].TtM[iM]= "";
	      blb[iblb].TbM[iM]= pntD[5];
	      blb[iblb].bTbM[iM]= pntD[6];
	      blb[iblb].eTbM[iM]= pntD[7];
	      if(pntD[10]!=NULL)
		blb[iblb].HpM[iM]= pntD[10];
	      Fl= 1;
	      break;break;
	    }
	  }
	}
      }
      break;
    case 3:
    case 4:
      if(pntD[0]==NULL){
	printf("%s no Reference mzl in Block:\n",NmF);
	PrintLine(pnt1);
	return(1);
      }
      for(iblb= 0;iblb<nblb;iblb++){
	pntB= blb[iblb].NmB;
	if(strcmp(pntID1,pntB)==0){
	  if(iblb){
	    k= blb[iblb].iB;
	    iM= blb[iblb].iM;
	    pntM= blb[k].NmM[iM];
	  }
	  else{
	    pntM= pntB;
	  }
	  if((strcmp(pntD[0],pntM)==0)){
	    blb[iblb].NmBTF= pntD[2];
	    blb[iblb].NmBSF= pntD[3];
	    if(pntD[4]!=NULL)
	      blb[iblb].TtB= pntD[4];
	    else
	      blb[iblb].TtB= "";
	    if(pntD[5]!=NULL&&*pntD[5]!='\0')
	      blb[iblb].TbB= pntD[5];
	    else
	      blb[iblb].TbB= NULL;
#ifdef H
	    blb[iblb].bTbB= pntD[6];
	    blb[iblb].eTbB= pntD[7];
#endif
	    if(pntD[8]!=NULL){
	      if(*pntD[8]!='\0'){
		sprintf(blb[iblb].OD,"%8s",pntD[8]);
	      }
	      else{
		blb[iblb].OD[0]= '\0';
	      }
	    }
	    else{
	      blb[iblb].OD[0]= '\0';
	    }
	    if(pntD[9]!=NULL){
	      k= sscanf(pntD[9],"%g %g %g",t,t+1,t+2);
	      for(i= 0;i<k;i++){
		blb[iblb].t[i]= t[i];
	      }
	    }
	    if(pntD[10]!=NULL)
	      blb[iblb].HpB= pntD[10];
	    Fl= 1;
	    break;
	  }
	}
      }
      break;
    }
    if(Fl==0){
      printf("%s not matching Table of Content Block:\n",NmF);
      PrintLine(pnt1);
      return(1);
    }
    pDBuff++;
  }
  return(0);
}

int CbResetOutCPanel()
{
  BLB*pntB;
  int i,iM,nM,iS,nS,iB,nB,kB,n;
  int mB,mM,OB,OM,IB,IM;
  int m,mt,mp,ms;

  for(iB=0; iB < nblb; iB++){
    pntB	=blb+iB;
    m	=pntB->mB;
    mt	=pntB->mBt;
    if((m&0x80)&&(mt&0x100) == 0){
      mp	=m&0x7f;
      ms	=0x100<<mp;
      pntB->mBt	=(m&ms) ? mt|ms : mt&(~ms);
    }
    pntB->mB	&=~0x80;
    pntB->mBt	&=~0x80;
    m	=pntB->OB;
    if((m&0x80)){
      mp	=m&0x7f;
      ms	=0x100<<mp;
      pntB->OB	&=~0x80;
      pntB->OBt	=(m&ms) ? pntB->OBt | ms : pntB->OBt&(~ms);
    }
    pntB->OBt	&=~0x80;
    m	=pntB->IB;
    if((m&0x80)){
      mp	=m&0x7f;
      ms	=0x100<<mp;
      pntB->IB	&=~0x80;
      pntB->IBt	=(m&ms)?pntB->IBt|ms:pntB->IBt&(~ms);
    }
    pntB->IBt	&=~0x80;
    nM	=pntB->nM;
    for(iM=0; iM < nM; iM++){
      m	=pntB->mM[iM];
      mt=pntB->mMt[iM];
      if((m&0x80)&&(mt&0x100) == 0){
	mp	=m&0x7f;
	ms	=0x100<<mp;
	pntB->mMt[iM]	=(m&ms)?mt | ms : mt&(~ms);
      }
      pntB->mMt[iM]&= ~0x80;
      pntB->mM[iM]&= ~0x80;
      m= pntB->OM[iM];
      if((m&0x80)){
	mp= m&0x7f;
	ms= 0x100<<mp;
	pntB->OM[iM]&= ~0x80;
	pntB->OMt[iM]= (m&ms)?pntB->OMt[iM]|ms:pntB->OMt[iM]&(~ms);
      }
      pntB->OMt[iM]&= ~0x80;
      m= pntB->IM[iM];
      if((m&0x80)==0){
	mp= m&0x7f;
	ms= 0x100<<mp;
	pntB->IM[iM]&= ~0x80;
	pntB->IMt[iM]= (m&ms)?pntB->IMt[iM]|ms:pntB->IMt[iM]&(~ms);
      }
      pntB->IMt[iM]&= ~0x80;
      nS= pntB->nS[iM];
      for(iS= 0;iS<nS;iS++){
	m= pntB->mS[iM][iS];
	mt= pntB->mSt[iM][iS];
	if((m&0x80)&&(mt&0x100)==0){
	  mp= m&0x7f;
	  ms= 0x100<<mp;
	  pntB->mSt[iM][iS]= (m&ms)?mt|ms:mt&(~ms);
	}
	pntB->mS[iM][iS]&= ~0x80;
	pntB->mSt[iM][iS]&= ~0x80;
	m= pntB->OS[iM][iS];
	if((m&0x80)==0){
	  mp= m&0x7f;
	  ms= 0x100<<mp;
	  pntB->OS[iM][iS]&= ~0x80;
	  pntB->OSt[iM][iS]= (m&ms)?pntB->OSt[iM][iS]|ms:
	  pntB->OSt[iM][iS]&(~ms);
	}
	pntB->OSt[iM][iS]&= ~0x80;
	m= pntB->IS[iM][iS];
	if((m&0x80)==0){
	  mp= m&0x7f;
	  ms= 0x100<<mp;
	  pntB->IS[iM][iS]&= ~0x80;
	  pntB->ISt[iM][iS]= (m&ms)?pntB->ISt[iM][iS]|ms:
	  pntB->ISt[iM][iS]&(~ms);
	}
	pntB->ISt[iM][iS]&= ~0x80;
      }
    }
  }
  return(0);
}

int CbInitModeSetting()
{
  BLB*pntB;
  int i,iM,nM,iS,nS,iB,nB,kB,n;
  int mB,mM,OB,OM,IB,IM;

  for(iB= 0;iB<nblb;iB++){
    pntB= blb+iB;
    if(iB==0){
      mB= pntB->mBt;
      OB= pntB->OBt;
      IB= pntB->IBt;
    }
    else{
      i= pntB->iB;
      mB= blb[i].mB;
      if((mB&0x80)==0||(pntB->mBt&0x100))
	mB= pntB->mBt;
      OB= blb[i].OB;
      if((OB&0x80)==0)
	OB= pntB->OBt;
      IB= blb[i].IB;
      if((IB&0x80)==0)
	IB= pntB->IBt;
    }
    blb[iB].OB= OB;
    blb[iB].IB= IB;
    nM	=pntB->nM;
    for(iM= 0;iM<nM;iM++){
      i= pntB->iMM[iM];
      if(i<0||(pntB->mMt[iM]&0x100)){
	mM= pntB->mMt[iM];
      }
      else{
	mM= blb[pntB->iMB[iM]].mM[i];
	if((mM&0x80)==0)
	  mM= pntB->mMt[iM];
      }
      pntB->mM[iM]= mM;

      if(i<0){
	OM= pntB->OMt[iM];
      }
      else{
	OM= blb[pntB->iMB[iM]].OM[i];
	if((OM&0x80)==0)
	  OM= pntB->OMt[iM];
      }
      pntB->OM[iM]= OM;

      if(i<0){
	IM= pntB->IMt[iM];
      }
      else{
	IM= blb[pntB->iMB[iM]].IM[i];
	if((IM&0x80)==0)
	  IM= pntB->IMt[iM];
      }
      pntB->IM[iM]= IM;

      nS= pntB->nS[iM];
      for(iS= 0;iS<nS;iS++){
	if((mM&0x80)){
	  pntB->mS[iM][iS]= (pntB->mSt[iM][iS]&0x100)?
	    pntB->mSt[iM][iS]:mM;
	}
	else{
	  pntB->mS[iM][iS]= (mB&0x80)==0||(pntB->mSt[iM][iS]&0x100)?
	    pntB->mSt[iM][iS]:mB;
	}

	if((OM&0x80)){
	  pntB->OS[iM][iS]= OM;
	}
	else{
	  pntB->OS[iM][iS]= (OB&0x80)==0?pntB->OSt[iM][iS]:OB;
	}

	if((IM&0x80)){
	  pntB->IS[iM][iS]= IM;
	}
	else{
	  pntB->IS[iM][iS]= (IB&0x80)==0?pntB->ISt[iM][iS]:IB;
	}
      }
    }
  }
  return(0);
}

int CbInitInpModeSetting()
{
  BLB*pntB;
  int i,iM,nM,iS,nS,iB,nB,kB,n;
  int mB,mM,OB,OM,IB,IM;

  for(iB= 0;iB<nblb;iB++){
    pntB= blb+iB;
    if(iB==0){
      mB= pntB->imBt;
      OB= pntB->iOBt;
      IB= pntB->iIBt;
    }
    else{
      i= pntB->iB;
      mB= blb[i].imB;
      if((mB&0x80)==0||(pntB->imBt&0x100))
	mB= pntB->imBt;
      OB= blb[i].iOB;
      if((OB&0x80)==0)
	OB= pntB->iOBt;
      IB= blb[i].iIB;
      if((IB&0x80)==0)
	IB= pntB->iIBt;
    }
    blb[iB].imB= mB;
    blb[iB].iOB= OB;
    blb[iB].iIB= IB;
    nM= pntB->nM;
    for(iM= 0;iM<nM;iM++){
      i= pntB->iMM[iM];
      if(i<0||(pntB->imMt[iM]&0x100)){
	mM= pntB->imMt[iM];
      }
      else{
	mM= blb[pntB->iMB[iM]].imM[i];
	if((mM&0x80)==0)
	  mM= pntB->imMt[iM];
      }
      pntB->imM[iM]= mM;

      if(i<0){
	OM= pntB->iOMt[iM];
      }
      else{
	OM= blb[pntB->iMB[iM]].iOM[i];
	if((OM&0x80)==0)
	  OM= pntB->iOMt[iM];
      }
      pntB->iOM[iM]= OM;

      if(i<0){
	IM= pntB->iIMt[iM];
      }
      else{
	IM= blb[pntB->iMB[iM]].iIM[i];
	if((IM&0x80)==0)
	  IM= pntB->iIMt[iM];
      }
      pntB->iIM[iM]= IM;

      nS= pntB->nS[iM];
      for(iS= 0;iS<nS;iS++){
	if((mM&0x80)){
	  pntB->imS[iM][iS]= (pntB->imSt[iM][iS]&0x100)?
	    pntB->imSt[iM][iS]:mM;
	}
	else{
	  pntB->imS[iM][iS]= (mB&0x80)==0||(pntB->imSt[iM][iS]&0x100)?
	    pntB->imSt[iM][iS]:mB;
	}

	if((OM&0x80)){
	  pntB->iOS[iM][iS]= OM;
	}
	else{
	  pntB->iOS[iM][iS]= (OB&0x80)==0?pntB->iOSt[iM][iS]:OB;
	}

	if((IM&0x80)){
	  pntB->iIS[iM][iS]= IM;
	}
	else{
	  pntB->iIS[iM][iS]= (IB&0x80)==0?pntB->iISt[iM][iS]:IB;
	}
      }
    }
  }
  return(0);
}

int CbSwitchOperModeBlb(int IB)
{
  BLB*pntB;
  int i,iM,nM,iS,nS,iB,nB,kB,n;
  int mB,mM;

  pntB	=blb+IB;
  iB	=pntB->iB;
  if(IB > 0 && (blb[iB].mB&0x80)){
    pntB->mB	=(pntB->mBt&0x100) ? pntB->mBt : blb[iB].mB;
    return(0);
  }
  mB	=pntB->mB;
  pntB->mBt	=mB;

  nM	=pntB->nM;
  for(iM= 0;iM<nM;iM++){
    if((pntB->mM[iM]&0x80)==0){
      nS= pntB->nS[iM];
      for(iS= 0;iS<nS;iS++){
	pntB->mS[iM][iS]=(mB&0x80) == 0 || (pntB->mSt[iM][iS] & 0x100) ?
	  pntB->mSt[iM][iS] : mB;
      }
    }
    nB	=pntB->nB[iM];
    for(iB=0 ; iB < nB; iB++){
      i 	=pntB->nxtB[iM][iB];
      blb[i].mB	=(mB&0x80) == 0 || (blb[i].mBt&0x100) ? blb[i].mBt : mB;
      CbSetOperModeChildBlb(i);
    }
  }
  return(1);
}

int CbSwitchOperInpModeBlb(int IB)
{
  BLB*pntB;
  int i,iM,nM,iS,nS,iB,nB,kB,n;
  int mB,mM;

  pntB= blb+IB;
  iB= pntB->iB;
  if(IB>0&&(blb[iB].imB&0x80)){
    pntB->imB	=(pntB->imBt&0x100) ? pntB->imBt : blb[iB].imB;
    return(0);
  }
  mB= pntB->imB;
  pntB->imBt= mB;

  nM= pntB->nM;
  for(iM= 0;iM<nM;iM++){
    if((pntB->imM[iM]&0x80)==0){
      nS= pntB->nS[iM];
      for(iS= 0;iS<nS;iS++){
	pntB->imS[iM][iS]= (mB&0x80)==0||(pntB->imSt[iM][iS]&0x100)?
	  pntB->imSt[iM][iS]:mB;
      }
    }
    nB= pntB->nB[iM];
    for(iB= 0;iB<nB;iB++){
      i= pntB->nxtB[iM][iB];
      blb[i].imB= (mB&0x80)==0||(blb[i].imBt&0x100)?blb[i].imBt:mB;
      CbSetOperInpModeChildBlb(i);
    }
  }
  return(1);
}

int CbSetOperModeChildBlb(int IB)
{
  BLB*pntB;
  int i,iM,nM,iS,nS,iB,nB;
  int mB;

  pntB= blb+IB;
  mB= pntB->mB;

  nM= pntB->nM;
  for(iM= 0;iM<nM;iM++){
    if((pntB->mM[iM]&0x80)==0){
      nS= pntB->nS[iM];
      for(iS= 0;iS<nS;iS++){
	pntB->mS[iM][iS]= (mB&0x80)==0||(pntB->mSt[iM][iS]&0x100)?
	  pntB->mSt[iM][iS]:mB;
      }
    }
    nB= pntB->nB[iM];
    for(iB= 0;iB<nB;iB++){
      i= pntB->nxtB[iM][iB];
      blb[i].mB= (mB&0x80)==0||(blb[i].mBt&0x100)?blb[i].mBt:mB;
      CbSetOperModeChildBlb(i);
    }
  }
  return(0);
}

int CbSetOperInpModeChildBlb(int IB)
{
  BLB*pntB;
  int i,iM,nM,iS,nS,iB,nB;
  int mB;

  pntB= blb+IB;
  mB= pntB->imB;

  nM= pntB->nM;
  for(iM= 0;iM<nM;iM++){
    if((pntB->imM[iM]&0x80)==0){
      nS= pntB->nS[iM];
      for(iS= 0;iS<nS;iS++){
	pntB->imS[iM][iS]= (mB&0x80)==0||(pntB->imSt[iM][iS]&0x100)?
	  pntB->imSt[iM][iS]:mB;
      }
    }
    nB= pntB->nB[iM];
    for(iB= 0;iB<nB;iB++){
      i= pntB->nxtB[iM][iB];
      blb[i].imB= (mB&0x80)==0||(blb[i].imBt&0x100)?blb[i].imBt:mB;
      CbSetOperInpModeChildBlb(i);
    }
  }
  return(0);
}

int CbSwitchOperModeMzl(int kB,int jM)
{
  BLB*pntB;
  int i,iM,nM,iS,nS,iB,nB;
  int mB,mM;

  pntB= blb+kB;
  if(pntB->iMM[jM]>=0){
    iB= pntB->iMB[jM];
    iM= pntB->iMM[jM];
    mM= blb[iB].mM[iM];
    if((mM&0x80)){
      pntB->mM[jM]= (pntB->mMt[jM]&0x100)?pntB->mMt[jM]:mM;
      return(0);
    }
  }

  mB= pntB->mB;
  mM= pntB->mM[jM];
  pntB->mMt[jM]= mM;
  if((mM&0x80)){
    nS= pntB->nS[jM];
    for(iS= 0;iS<nS;iS++){
      if((pntB->mSt[jM][iS]&0x100)==0)
	pntB->mS[jM][iS]= mM;
    }
  }
  else{
    nS= pntB->nS[jM];
    for(iS= 0;iS<nS;iS++){
      pntB->mS[jM][iS]= (mB&0x80)==0||(pntB->mSt[jM][iS]&0x100)?
	pntB->mSt[jM][iS]:mB;
    }
  }

  nM= pntB->nM;
  for(iM= 0;iM<nM;iM++){
    nB= pntB->nB[iM];
    for(iB= 0;iB<nB;iB++){
      i= pntB->nxtB[iM][iB];
      CbSetOperModeChildMzl(i,kB,jM);
    }
  }
  return(1);
}

int CbSwitchOperInpModeMzl(int kB,int jM)
{
  BLB*pntB;
  int i,iM,nM,iS,nS,iB,nB;
  int mB,mM;

  pntB= blb+kB;
  if(pntB->iMM[jM]>=0){
    iB= pntB->iMB[jM];
    iM= pntB->iMM[jM];
    mM= blb[iB].imM[iM];
    if((mM&0x80)){
      pntB->imM[jM]= (pntB->imMt[jM]&0x100)?pntB->imMt[jM]:mM;
      return(0);
    }
  }

  mB= pntB->imB;
  mM= pntB->imM[jM];
  pntB->imMt[jM]= mM;
  if((mM&0x80)){
    nS= pntB->nS[jM];
    for(iS= 0;iS<nS;iS++){
      if((pntB->imSt[jM][iS]&0x100)==0)
	pntB->imS[jM][iS]= mM;
    }
  }
  else{
    nS= pntB->nS[jM];
    for(iS= 0;iS<nS;iS++){
      pntB->imS[jM][iS]= (mB&0x80)==0||(pntB->imSt[jM][iS]&0x100)?
	pntB->imSt[jM][iS]:mB;
    }
  }

  nM= pntB->nM;
  for(iM= 0;iM<nM;iM++){
    nB= pntB->nB[iM];
    for(iB= 0;iB<nB;iB++){
      i= pntB->nxtB[iM][iB];
      CbSetOperInpModeChildMzl(i,kB,jM);
    }
  }
  return(1);
}

int CbSetOperModeChildMzl(int IB,int kB,int jM)
{
  BLB*pntB;
  int iM,nM,iS,nS,iB,nB;
  int mB,mM;

  pntB= blb+IB;
  mB= pntB->mB;
  mM= blb[kB].mM[jM];

  nM= pntB->nM;
  for(iM= 0;iM<nM;iM++){
    if(pntB->iMM[iM]==jM&&pntB->iMB[iM]==kB){
      pntB->mM[iM]= (mM&0x80)==0||(pntB->mMt[iM]&0x100)?
	pntB->mMt[iM]:mM;
      nS= pntB->nS[iM];
      if((mM&0x80)){
	for(iS= 0;iS<nS;iS++){
	  if((pntB->mS[iM][iS]&0x100)==0){
	    pntB->mS[iM][iS]= mM;
	  }
	}
      }
      else{
	for(iS= 0;iS<nS;iS++){
	  pntB->mS[iM][iS]= (mB&0x80)==0||(pntB->mSt[iM][iS]&0x100)?
	    pntB->mSt[iM][iS]:mB;
	}
      }
      nB= pntB->nB[iM];
      for(iB= 0;iB<nB;iB++){
	CbSetOperModeChildMzl(pntB->nxtB[iM][iB],IB,iM);
      }
    }
    else{
      nB= pntB->nB[iM];
      for(iB= 0;iB<nB;iB++){
	CbSetOperModeChildMzl(pntB->nxtB[iM][iB],kB,jM);
      }
    }
  }
  return(0);
}

int CbSetOperInpModeChildMzl(int IB,int kB,int jM)
{
  BLB*pntB;
  int iM,nM,iS,nS,iB,nB;
  int mB,mM;

  pntB= blb+IB;
  mB= pntB->imB;
  mM= blb[kB].imM[jM];

  nM= pntB->nM;
  for(iM= 0;iM<nM;iM++){
    if(pntB->iMM[iM]==jM&&pntB->iMB[iM]==kB){
      pntB->imM[iM]= (mM&0x80)==0||(pntB->imMt[iM]&0x100)?
	pntB->imMt[iM]:mM;
      nS= pntB->nS[iM];
      if((mM&0x80)){
	for(iS= 0;iS<nS;iS++){
	  if((pntB->imS[iM][iS]&0x100)==0){
	    pntB->imS[iM][iS]= mM;
	  }
	}
      }
      else{
	for(iS= 0;iS<nS;iS++){
	  pntB->imS[iM][iS]= (mB&0x80)==0||(pntB->imSt[iM][iS]&0x100)?
	    pntB->imSt[iM][iS]:mB;
	}
      }
      nB= pntB->nB[iM];
      for(iB= 0;iB<nB;iB++){
	CbSetOperInpModeChildMzl(pntB->nxtB[iM][iB],IB,iM);
      }
    }
    else{
      nB= pntB->nB[iM];
      for(iB= 0;iB<nB;iB++){
	CbSetOperInpModeChildMzl(pntB->nxtB[iM][iB],kB,jM);
      }
    }
  }
  return(0);
}

int CbSwitchOperModeStg(int iB,int iM,int iS)
{
  int m;

  if((blb[iB].mM[iM]&0x80)){
    m= (blb[iB].mSt[iM][iS]&0x100)?blb[iB].mSt[iM][iS]:blb[iB].mM[iM];
  }
  else{
    if((blb[iB].mB&0x80)){
      m= (blb[iB].mSt[iM][iS]&0x100)?blb[iB].mSt[iM][iS]:blb[iB].mB;
    }
    else{
      m= blb[iB].mS[iM][iS];
      blb[iB].mSt[iM][iS]= m;
    }
  }

  blb[iB].mS[iM][iS]= m;
  return(m);
}

int CbSwitchOperInpModeStg(int iB,int iM,int iS)
{
  int m;

  if((blb[iB].imM[iM]&0x80)){
    m= (blb[iB].imSt[iM][iS]&0x100)?blb[iB].imSt[iM][iS]:blb[iB].imM[iM];
  }
  else{
    if((blb[iB].imB&0x80)){
      m= (blb[iB].imSt[iM][iS]&0x100)?blb[iB].imSt[iM][iS]:blb[iB].imB;
    }
    else{
      m= blb[iB].imS[iM][iS];
      blb[iB].imSt[iM][iS]= m;
    }
  }
  blb[iB].imS[iM][iS]= m;
  return(m);
}

int CbSwitchOutModeBlb(int kB)
{
  BLB*pntB;
  int i,iM,nM,iS,nS,iB,nB,n;
  int OB,OM;

  pntB	=blb+kB;
  iB	=pntB->iB;
  if(kB > 0 && (blb[iB].OB&0x80)){
    pntB->OB	=blb[iB].OB;
    return(0);
  }
  OB	=pntB->OB;
  pntB->OBt	=OB;

  nM	=pntB->nM;
  for(iM=0; iM < nM; iM++){
    if((pntB->OM[iM]&0x80)==0){
      nS	=pntB->nS[iM];
      for(iS=0; iS < nS; iS++){
	pntB->OS[iM][iS]	=(OB&0x80) == 0 ? pntB->OSt[iM][iS] : OB;
      }
    }
    nB	=pntB->nB[iM];
    for(iB=0; iB < nB; iB++){
      i	=pntB->nxtB[iM][iB];
      blb[i].OB	=(OB&0x80) == 0 ? blb[i].OBt : OB;
      CbSetOutModeChildBlb(i);
    }
  }
  return(1);
}

int CbSwitchOutInpModeBlb(int kB)
{
  BLB*pntB;
  int i,iM,nM,iS,nS,iB,nB,n;
  int OB,OM;

  pntB= blb+kB;
  iB= pntB->iB;
  if(kB>0&&(blb[iB].iOB&0x80)){
    pntB->iOB= blb[iB].iOB;
    return(0);
  }
  OB= pntB->iOB;
  pntB->iOBt= OB;

  nM= pntB->nM;
  for(iM= 0;iM<nM;iM++){
    if((pntB->iOM[iM]&0x80)==0){
      nS= pntB->nS[iM];
      for(iS= 0;iS<nS;iS++){
	pntB->iOS[iM][iS]= (OB&0x80)==0?pntB->iOSt[iM][iS]:OB;
      }
    }
    nB= pntB->nB[iM];
    for(iB= 0;iB<nB;iB++){
      i= pntB->nxtB[iM][iB];
      blb[i].iOB= (OB&0x80)==0?blb[i].iOBt:OB;
      CbSetOutInpModeChildBlb(i);
    }
  }
  return(1);
}

int CbSetOutModeChildBlb(int IB)
{
  BLB*pntB;
  int i,iM,nM,iS,nS,iB,nB;
  int OB;

  pntB= blb+IB;
  OB= pntB->OB;

  nM= pntB->nM;
  for(iM= 0;iM<nM;iM++){
    if((pntB->OM[iM]&0x80)==0){
      nS= pntB->nS[iM];
      for(iS= 0;iS<nS;iS++){
	pntB->OS[iM][iS]= (OB&0x80)==0?pntB->OSt[iM][iS]:OB;
      }
    }
    nB= pntB->nB[iM];
    for(iB= 0;iB<nB;iB++){
      i= pntB->nxtB[iM][iB];
      blb[i].OB= (OB&0x80)==0?blb[i].OBt:OB;
      CbSetOutModeChildBlb(i);
    }
  }
  return(0);
}

int CbSetOutInpModeChildBlb(int IB)
{
  BLB*pntB;
  int i,iM,nM,iS,nS,iB,nB;
  int OB;

  pntB= blb+IB;
  OB= pntB->iOB;

  nM= pntB->nM;
  for(iM= 0;iM<nM;iM++){
    if((pntB->iOM[iM]&0x80)==0){
      nS= pntB->nS[iM];
      for(iS= 0;iS<nS;iS++){
	pntB->iOS[iM][iS]= (OB&0x80)==0?pntB->iOSt[iM][iS]:OB;
      }
    }
    nB= pntB->nB[iM];
    for(iB= 0;iB<nB;iB++){
      i= pntB->nxtB[iM][iB];
      blb[i].iOB= (OB&0x80)==0?blb[i].iOBt:OB;
      CbSetOutInpModeChildBlb(i);
    }
  }
  return(0);
}

int CbSwitchOutModeMzl(int kB,int jM)
{
  BLB*pntB;
  int i,iM,nM,iS,nS,iB,nB;
  int OB,OM;

  pntB= blb+kB;
  if(pntB->iMM[jM]>=0){
    iB= pntB->iMB[jM];
    iM= pntB->iMM[jM];
    OM= blb[iB].OM[iM];
    if((OM&0x80)){
      pntB->OM[jM]= OM;
      return(0);
    }
  }

  OB= pntB->OB;
  OM= pntB->OM[jM];
  pntB->OMt[jM]= OM;
  if((OM&0x80)){
    nS= pntB->nS[jM];
    for(iS= 0;iS<nS;iS++){
      pntB->OS[jM][iS]= OM;
    }
  }
  else{
    nS= pntB->nS[jM];
    for(iS= 0;iS<nS;iS++){
      pntB->OS[jM][iS]= (OB&0x80)==0?pntB->OSt[jM][iS]:OB;
    }
  }

  nM= pntB->nM;
  for(iM= 0;iM<nM;iM++){
    nB= pntB->nB[iM];
    for(iB= 0;iB<nB;iB++){
      i= pntB->nxtB[iM][iB];
      CbSetOutModeChildMzl(i,kB,jM);
    }
  }
  return(1);
}

int CbSwitchOutInpModeMzl(int kB,int jM)
{
  BLB*pntB;
  int i,iM,nM,iS,nS,iB,nB;
  int OB,OM;

  pntB= blb+kB;
  if(pntB->iMM[jM]>=0){
    iB= pntB->iMB[jM];
    iM= pntB->iMM[jM];
    OM= blb[iB].iOM[iM];
    if((OM&0x80)){
      pntB->iOM[jM]= OM;
      return(0);
    }
  }

  OB= pntB->iOB;
  OM= pntB->iOM[jM];
  pntB->iOMt[jM]= OM;
  if((OM&0x80)){
    nS= pntB->nS[jM];
    for(iS= 0;iS<nS;iS++){
      pntB->iOS[jM][iS]= OM;
    }
  }
  else{
    nS= pntB->nS[jM];
    for(iS= 0;iS<nS;iS++){
      pntB->iOS[jM][iS]= (OB&0x80)==0?pntB->iOSt[jM][iS]:OB;
    }
  }

  nM= pntB->nM;
  for(iM= 0;iM<nM;iM++){
    nB= pntB->nB[iM];
    for(iB= 0;iB<nB;iB++){
      i= pntB->nxtB[iM][iB];
      CbSetOutInpModeChildMzl(i,kB,jM);
    }
  }
  return(1);
}

int CbSetOutModeChildMzl(int KB,int kB,int jM)
{
  BLB*pntB;
  int iM,nM,iS,nS,iB,nB;
  int OB,OM;

  pntB= blb+KB;
  OB= pntB->OB;
  OM= blb[kB].OM[jM];

  nM= pntB->nM;
  for(iM= 0;iM<nM;iM++){
    if(pntB->iMM[iM]==jM&&pntB->iMB[iM]==kB){
      pntB->OM[iM]= (OM&0x80)==0?pntB->OMt[iM]:OM;
      nS= pntB->nS[iM];
      if((OM&0x80)){
	for(iS= 0;iS<nS;iS++){
	  pntB->OS[iM][iS]= OM;
	}
      }
      else{
	for(iS= 0;iS<nS;iS++){
	  pntB->OS[iM][iS]= (OB&0x80)==0?pntB->OSt[iM][iS]:OB;
	}
      }
      nB= pntB->nB[iM];
      for(iB= 0;iB<nB;iB++){
	CbSetOutModeChildMzl(pntB->nxtB[iM][iB],KB,iM);
      }
    }
    else{
      nB= pntB->nB[iM];
      for(iB= 0;iB<nB;iB++){
	CbSetOutModeChildMzl(pntB->nxtB[iM][iB],kB,jM);
      }
    }
  }
  return(0);
}

int CbSetOutInpModeChildMzl(int KB,int kB,int jM)
{
  BLB*pntB;
  int iM,nM,iS,nS,iB,nB;
  int OB,OM;

  pntB= blb+KB;
  OB= pntB->iOB;
  OM= blb[kB].iOM[jM];

  nM= pntB->nM;
  for(iM= 0;iM<nM;iM++){
    if(pntB->iMM[iM]==jM&&pntB->iMB[iM]==kB){
      pntB->iOM[iM]= (OM&0x80)==0?pntB->iOMt[iM]:OM;
      nS= pntB->nS[iM];
      if((OM&0x80)){
	for(iS= 0;iS<nS;iS++){
	  pntB->iOS[iM][iS]= OM;
	}
      }
      else{
	for(iS= 0;iS<nS;iS++){
	  pntB->iOS[iM][iS]= (OB&0x80)==0?pntB->iOSt[iM][iS]:OB;
	}
      }
      nB= pntB->nB[iM];
      for(iB= 0;iB<nB;iB++){
	CbSetOutInpModeChildMzl(pntB->nxtB[iM][iB],KB,iM);
      }
    }
    else{
      nB= pntB->nB[iM];
      for(iB= 0;iB<nB;iB++){
	CbSetOutInpModeChildMzl(pntB->nxtB[iM][iB],kB,jM);
      }
    }
  }
  return(0);
}

int CbSwitchOutModeStg(int iB,int iM,int iS)
{
  int mO;

  if((blb[iB].OM[iM]&0x80)){
    mO= blb[iB].OM[iM];
  }
  else{
    if((blb[iB].OB&0x80)){
      mO= blb[iB].OB;
    }
    else{
      mO= blb[iB].OS[iM][iS];
      blb[iB].OSt[iM][iS]= mO;
    }
  }

  blb[iB].OS[iM][iS]= mO;
  return(mO);
}

int CbSwitchOutInpModeStg(int iB,int iM,int iS)
{
  int mO;

  if((blb[iB].iOM[iM]&0x80)){
    mO= blb[iB].iOM[iM];
  }
  else{
    if((blb[iB].iOB&0x80)){
      mO= blb[iB].iOB;
    }
    else{
      mO= blb[iB].iOS[iM][iS];
      blb[iB].iOSt[iM][iS]= mO;
    }
  }

  blb[iB].iOS[iM][iS]= mO;
  return(mO);
}

int CbSwitchInpModeBlb(int kB)
{
  BLB*pntB;
  int i,iM,nM,iS,nS,iB,nB,n;
  int IB,IM;

  pntB= blb+kB;
  iB= pntB->iB;
  if(kB>0&&(blb[iB].IB&0x80)){
    pntB->IB= blb[iB].IB;
    return(0);
  }
  IB= pntB->IB;
  pntB->IBt= IB;

  nM= pntB->nM;
  for(iM= 0;iM<nM;iM++){
    if((pntB->IM[iM]&0x80)==0){
      nS= pntB->nS[iM];
      for(iS= 0;iS<nS;iS++){
	pntB->IS[iM][iS]= (IB&0x80)==0?pntB->ISt[iM][iS]:IB;
      }
    }
    nB= pntB->nB[iM];
    for(iB= 0;iB<nB;iB++){
      i= pntB->nxtB[iM][iB];
      blb[i].IB= (IB&0x80)==0?blb[i].IBt:IB;
      CbSetInpModeChildBlb(i);
    }
  }
  return(1);
}

int CbSwitchInpInpModeBlb(int kB)
{
  BLB*pntB;
  int i,iM,nM,iS,nS,iB,nB,n;
  int IB,IM;

  pntB= blb+kB;
  iB= pntB->iB;
  if(kB>0&&(blb[iB].iIB&0x80)){
    pntB->iIB= blb[iB].iIB;
    return(0);
  }
  IB= pntB->iIB;
  pntB->iIBt= IB;

  nM= pntB->nM;
  for(iM= 0;iM<nM;iM++){
    if((pntB->iIM[iM]&0x80)==0){
      nS= pntB->nS[iM];
      for(iS= 0;iS<nS;iS++){
	pntB->iIS[iM][iS]= (IB&0x80)==0?pntB->iISt[iM][iS]:IB;
      }
    }
    nB= pntB->nB[iM];
    for(iB= 0;iB<nB;iB++){
      i= pntB->nxtB[iM][iB];
      blb[i].iIB= (IB&0x80)==0?blb[i].iIBt:IB;
      CbSetInpInpModeChildBlb(i);
    }
  }
  return(1);
}

int CbSetInpModeChildBlb(int kB)
{
  BLB*pntB;
  int i,iM,nM,iS,nS,iB,nB;
  int IB;

  pntB= blb+kB;
  IB= pntB->IB;

  nM= pntB->nM;
  for(iM= 0;iM<nM;iM++){
    if((pntB->IM[iM]&0x80)==0){
      nS= pntB->nS[iM];
      for(iS= 0;iS<nS;iS++){
	pntB->IS[iM][iS]= (IB&0x80)==0?pntB->ISt[iM][iS]:IB;
      }
    }
    nB= pntB->nB[iM];
    for(iB= 0;iB<nB;iB++){
      i= pntB->nxtB[iM][iB];
      blb[i].IB= (IB&0x80)==0?blb[i].IBt:IB;
      CbSetInpModeChildBlb(i);
    }
  }
  return(0);
}

int CbSetInpInpModeChildBlb(int kB)
{
  BLB*pntB;
  int i,iM,nM,iS,nS,iB,nB;
  int IB;

  pntB= blb+kB;
  IB= pntB->iIB;

  nM= pntB->nM;
  for(iM= 0;iM<nM;iM++){
    if((pntB->iIM[iM]&0x80)==0){
      nS= pntB->nS[iM];
      for(iS= 0;iS<nS;iS++){
	pntB->iIS[iM][iS]= (IB&0x80)==0?pntB->iISt[iM][iS]:IB;
      }
    }
    nB= pntB->nB[iM];
    for(iB= 0;iB<nB;iB++){
      i= pntB->nxtB[iM][iB];
      blb[i].iIB= (IB&0x80)==0?blb[i].iIBt:IB;
      CbSetInpInpModeChildBlb(i);
    }
  }
  return(0);
}

int CbSwitchInpModeMzl(int kB,int jM)
{
  BLB*pntB;
  int i,iM,nM,iS,nS,iB,nB;
  int IB,IM;

  pntB= blb+kB;
  if(pntB->iMM[jM]>=0){
    iB= pntB->iMB[jM];
    iM= pntB->iMM[jM];
    IM= blb[iB].IM[iM];
    if((IM&0x80)){
      pntB->IM[jM]= IM;
      return(0);
    }
  }

  IB= pntB->IB;
  IM= pntB->IM[jM];
  pntB->IMt[jM]= IM;
  if((IM&0x80)){
    nS= pntB->nS[jM];
    for(iS= 0;iS<nS;iS++){
      pntB->IS[jM][iS]= IM;
    }
  }
  else{
    nS= pntB->nS[jM];
    for(iS= 0;iS<nS;iS++){
      pntB->IS[jM][iS]= (IB&0x80)==0?pntB->ISt[jM][iS]:IB;
    }
  }

  nM= pntB->nM;
  for(iM= 0;iM<nM;iM++){
    nB= pntB->nB[iM];
    for(iB= 0;iB<nB;iB++){
      i= pntB->nxtB[iM][iB];
      CbSetInpModeChildMzl(i,kB,jM);
    }
  }
  return(1);
}

int CbSwitchInpInpModeMzl(int kB,int jM)
{
  BLB*pntB;
  int i,iM,nM,iS,nS,iB,nB;
  int IB,IM;

  pntB= blb+kB;
  if(pntB->iMM[jM]>=0){
    iB= pntB->iMB[jM];
    iM= pntB->iMM[jM];
    IM= blb[iB].iIM[iM];
    if((IM&0x80)){
      pntB->iIM[jM]= IM;
      return(0);
    }
  }

  IB= pntB->iIB;
  IM= pntB->iIM[jM];
  pntB->iIMt[jM]= IM;
  if((IM&0x80)){
    nS= pntB->nS[jM];
    for(iS= 0;iS<nS;iS++){
      pntB->iIS[jM][iS]= IM;
    }
  }
  else{
    nS= pntB->nS[jM];
    for(iS= 0;iS<nS;iS++){
      pntB->iIS[jM][iS]= (IB&0x80)==0?pntB->iISt[jM][iS]:IB;
    }
  }

  nM= pntB->nM;
  for(iM= 0;iM<nM;iM++){
    nB= pntB->nB[iM];
    for(iB= 0;iB<nB;iB++){
      i= pntB->nxtB[iM][iB];
      CbSetInpInpModeChildMzl(i,kB,jM);
    }
  }
  return(1);
}

int CbSetInpModeChildMzl(int KB,int kB,int jM)
{
  BLB*pntB;
  int iM,nM,iS,nS,iB,nB;
  int IB,IM;

  pntB= blb+KB;
  IB= pntB->IB;
  IM= blb[kB].IM[jM];

  nM= pntB->nM;
  for(iM= 0;iM<nM;iM++){
    if(pntB->iMM[iM]==jM&&pntB->iMB[iM]==kB){
      pntB->IM[iM]= (IM&0x80)==0?pntB->IMt[iM]:IM;
      nS= pntB->nS[iM];
      if((IM&0x80)){
	for(iS= 0;iS<nS;iS++){
	  pntB->IS[iM][iS]= IM;
	}
      }
      else{
	for(iS= 0;iS<nS;iS++){
	  pntB->IS[iM][iS]= (IB&0x80)==0?pntB->ISt[iM][iS]:IB;
	}
      }
      nB= pntB->nB[iM];
      for(iB= 0;iB<nB;iB++){
	CbSetInpModeChildMzl(pntB->nxtB[iM][iB],KB,iM);
      }
    }
    else{
      nB= pntB->nB[iM];
      for(iB= 0;iB<nB;iB++){
	CbSetInpModeChildMzl(pntB->nxtB[iM][iB],kB,jM);
      }
    }
  }
  return(0);
}

int CbSetInpInpModeChildMzl(int KB,int kB,int jM)
{
  BLB*pntB;
  int iM,nM,iS,nS,iB,nB;
  int IB,IM;

  pntB= blb+KB;
  IB= pntB->iIB;
  IM= blb[kB].iIM[jM];

  nM= pntB->nM;
  for(iM= 0;iM<nM;iM++){
    if(pntB->iMM[iM]==jM&&pntB->iMB[iM]==kB){
      pntB->iIM[iM]= (IM&0x80)==0?pntB->iIMt[iM]:IM;
      nS= pntB->nS[iM];
      if((IM&0x80)){
	for(iS= 0;iS<nS;iS++){
	  pntB->iIS[iM][iS]= IM;
	}
      }
      else{
	for(iS= 0;iS<nS;iS++){
	  pntB->iIS[iM][iS]= (IB&0x80)==0?pntB->iISt[iM][iS]:IB;
	}
      }
      nB= pntB->nB[iM];
      for(iB= 0;iB<nB;iB++){
	CbSetInpInpModeChildMzl(pntB->nxtB[iM][iB],KB,iM);
      }
    }
    else{
      nB= pntB->nB[iM];
      for(iB= 0;iB<nB;iB++){
	CbSetInpInpModeChildMzl(pntB->nxtB[iM][iB],kB,jM);
      }
    }
  }
  return(0);
}

int CbSwitchInpModeStg(int iB,int iM,int iS)
{
  int mI;

  if((blb[iB].IM[iM]&0x80)){
    mI= blb[iB].IM[iM];
  }
  else{
    if((blb[iB].IB&0x80)){
      mI= blb[iB].IB;
    }
    else{
      mI= blb[iB].IS[iM][iS];
      blb[iB].ISt[iM][iS]= mI;
    }
  }

  blb[iB].IS[iM][iS]= mI;
  return(mI);
}

int CbSwitchInpInpModeStg(int iB,int iM,int iS)
{
  int mI;

  if((blb[iB].iIM[iM]&0x80)){
    mI= blb[iB].iIM[iM];
  }
  else{
    if((blb[iB].iIB&0x80)){
      mI= blb[iB].iIB;
    }
    else{
      mI= blb[iB].iIS[iM][iS];
      blb[iB].iISt[iM][iS]= mI;
    }
  }

  blb[iB].iIS[iM][iS]= mI;
  return(mI);
}

int CbBlbModeOff(int iB)
{
  if((blb[iB].mB&0x100)){
    return(0x100);
  }

  instB	=iB;
  instM	=-1;
  instS	=-1;
  nDpth++;
  BDpth[nDpth]	=iB;
  MDpth[nDpth]	=instM;
  SDpth[nDpth]	=instS;
  EDpth[nDpth]	=0;
  if((blb[iB].mB&0x2000)) CbCheckIfEvents();
  XCbShowActiveBlock(iB,-1,-1);

  return(0);
}

int CbBlbInpModeOff(int iB)
{
  return(blb[iB].imB&0x100);
}

int kblbmd_(int*iB0)
{
  if((blb[*iB0].mB&0x100)){
    return(0x100);
  }
  instB	=*iB0;
  instM	=-1;
  instS	=-1;
  nDpth++;
  BDpth[nDpth]	=instB;
  MDpth[nDpth]	=instM;
  SDpth[nDpth]	=instS;
  EDpth[nDpth]	=0;

  if((blb[instB].mB&0x2000))
    CbCheckIfEvents();
  XCbShowActiveBlock(instB,-1,-1);
  return(0);
}

int CbBlbExitMode()
{
  int k;
  if((k=blb[instB].mB&0x2000)){
    CbCheckIfEvents();
  }
  nDpth--;
  instB	=BDpth[nDpth];
  instM	=MDpth[nDpth];
  instS	=SDpth[nDpth];
  XCbShowActiveBlock(instB,-1,-1);

#ifdef H
  return(blb[instB].mB&0x100);
#endif
  return(k);
}	

int CbExitMode()
{
  if((blb[instB].mB&0x2000)){
    CbCheckIfEvents();
  }
  nDpth--;
  instB	=BDpth[nDpth];
  instM	=MDpth[nDpth];
  instS	=SDpth[nDpth];
  XCbShowActiveBlock(instB,-1,-1);
  return(blb[instB].mB&0x100);
}	

int CbGetCurrentCbName(char **Dir, char **Nm)
{
  *Dir	=blb[instB].path;
  *Nm	=instS < 0 ? blb[instB].NmB : blb[instB].NmS[instM][instS];
  return(blb[instB].Lpath);
}

int kblbexitm_()
{
  if((blb[instB].mB&0x2000)){
    CbCheckIfEvents();
  }

  nDpth--;
  instB	=BDpth[nDpth];
  instM	=MDpth[nDpth];
  instS	=SDpth[nDpth];
  XCbShowActiveBlock(instB,-1,-1);
  return(blb[instB].mB&0x100);
}

int kexitm_()
{
  if((blb[instB].mB&0x2000)){
    CbCheckIfEvents();
  }
  nDpth--;
  instB	=BDpth[nDpth];
  instM	=MDpth[nDpth];
  instS	=SDpth[nDpth];
  XCbShowActiveBlock(instB,-1,-1);
  return(blb[instB].mB&0x100);
}

int CbStgModeOff(int iB,int iM,int iS)
{
  if((blb[iB].mS[iM][iS]&0x100)){
    return(0x100);
  }
  instB	=iB;
  instM	=iM;
  instS	=iS;
  nDpth++;
  BDpth[nDpth]	=instB;
  MDpth[nDpth]	=instM;
  SDpth[nDpth]	=instS;
  EDpth[nDpth]	=2;
  if((blb[instB].mS[instM][instS]&0x2000)){
    CbCheckIfEvents();
  }
  XCbShowActiveBlock(iB,iM,iS);
  return(0);
}

int CbStgInpModeOff(int iB,int iM,int iS)
{
  return(blb[iB].imS[iM][iS]&0x100);
}

int kstgmd_(int*iB0,int*iM0,int*iS0)
{
   if((blb[*iB0].mS[*iM0][*iS0]&0x100)){
    return(0x100);
  }
  instB= *iB0;
  instM= *iM0;
  instS= *iS0;
  nDpth++;
  BDpth[nDpth]= instB;
  MDpth[nDpth]= instM;
  SDpth[nDpth]= instS;
  EDpth[nDpth]= 2;
  if((blb[instB].mS[instM][instS]&0x2000))
    CbCheckIfEvents();
  XCbShowActiveBlock(instB,instM,instS);
  return(0);
}

int CbBlbOperMode(int iB)
{
  if(instB==iB&&(blb[iB].mB&0x100)==0)
    return(blb[iB].mB&~0xff);
  else
    return(0);
}

int CbBlbOperInpMode(int iB)
{
  if(instB==iB&&(blb[iB].imB&0x100)==0)
    return(blb[iB].imB&~0xff);
  else
    return(0);
}

int kblbsv_(int*iB)
{
  if(instB == *iB && (blb[*iB].mB&0x100) == 0)
    return(blb[*iB].mB&0x200);
  else
    return(0);
}

int kblbrd_(int*iB)
{
  if(instB==*iB&&(blb[*iB].mB&0x100)==0)
    return(blb[*iB].mB&0x800);
  else
    return(0);
}

int kblbwr_(int*iB)
{
  if(instB==*iB&&(blb[*iB].mB&0x100)==0)
    return(blb[*iB].mB&0x1000);
  else
    return(0);
}

int CbStgOperMode(int iB,int iM,int iS)
{
  int m;
  m= blb[iB].mS[iM][iS];
  if(instB==iB&&instM==iM&&instS==iS&&(m&0x100)==0)
    return(m&~0xff);
  else
    return(0);
}

int CbStgOperInpMode(int iB,int iM,int iS)
{
  int m;
  m= blb[iB].imS[iM][iS];
  if(instB==iB&&instM==iM&&instS==iS&&(m&0x100)==0)
    return(m&~0xff);
  else
    return(0);
}

int kstgsv_(int*iB,int*iM,int*iS)
{
  int m;
  m= blb[*iB].mS[*iM][*iS];
  if(instB==*iB&&instM==*iM&&instS==*iS&&(m&0x100)==0)
    return(m&0x200);
  else
    return(0);
}

int kstgrd_(int*iB,int*iM,int*iS)
{
  int m;
  m= blb[*iB].mS[*iM][*iS];
  if(instB==*iB&&instM==*iM&&instS==*iS&&(m&0x100)==0)
    return(m&0x800);
  else
    return(0);
}

int kstgwr_(int*iB,int*iM,int*iS)
{
  int m;
  m= blb[*iB].mS[*iM][*iS];
  if(instB==*iB&&instM==*iM&&instS==*iS&&(m&0x100)==0)
    return(m&0x1000);
  else
    return(0);
}

int CbBlbOutMode(int iB)
{
  if(instB==iB)
    return(blb[iB].OB&~0xff);
  else
    return(0);
}

int CbBlbOutInpMode(int iB)
{
  if(instB==iB)
    return(blb[iB].iOB&~0xff);
  else
    return(0);
}

int kblbbo_(int*iB0)
{
  if(instB==*iB0)
    return(blb[*iB0].OB&0x200);
  else
    return(0);
}

int kblbao_(int*iB0)
{
  if(instB==*iB0)
    return(blb[*iB0].OB&0x100);
  else
    return(0);
}

int CbStgOutMode(int iB,int iM,int iS)
{
  if(instB==iB&&instM==iM&&instS==iS)
    return(blb[iB].OS[iM][iS]&~0xff);
  else
    return(0);
}

int CbStgOutInpMode(int iB,int iM,int iS)
{
  if(instB==iB&&instM==iM&&instS==iS)
    return(blb[iB].iOS[iM][iS]&~0xff);
  else
    return(0);
}

int kstgbo_(int*iB,int*iM,int*iS)
{
  if(instB==*iB&&instM==*iM&&instS==*iS)
    return(blb[*iB].OS[*iM][*iS]&0x200);
  else
    return(0);
}

int kstgao_(int*iB,int*iM,int*iS)
{
  if(instB==*iB&&instM==*iM&&instS==*iS)
    return(blb[*iB].OS[*iM][*iS]&0x100);
  else
    return(0);
}

int CbBlbInpMode(int iB)
{
  if(instB==iB)
    return(blb[iB].IB&~0xff);
  else
    return(0);
}

int CbBlbInpInpMode(int iB)
{
  if(instB==iB)
    return(blb[iB].iIB&~0xff);
  else
    return(0);
}

int kblbtb_(int*iB)
{
  if(instB==*iB)
    return(blb[*iB].IB&0x300);
  else
    return(0);
}

int kblbbi_(int*iB)
{
  if(instB==*iB)
    return(blb[*iB].IB&0x800);
  else
    return(0);
}

int kblbai_(int*iB)
{
  if(instB==*iB)
    return(blb[*iB].IB&0x400);
  else
    return(0);
}

int CbStgInpMode(int iB,int iM,int iS)
{
  if(instB == iB && instM == iM && instS == iS){
    return(blb[iB].IS[iM][iS]&~0xff);
  }
  else{
    return(0);
  }
}

int CbStgInpInpMode(int iB,int iM,int iS)
{
  if(instB == iB && instM == iM && instS == iS){
    return(blb[iB].iIS[iM][iS]&~0xff);
  }
  else{
    return(0);
  }
}

int kstgtb_(int*iB,int*iM,int*iS)
{
  if(instB==*iB&&instM==*iM&&instS==*iS)
    return(blb[*iB].IS[*iM][*iS]&0x300);
  else
    return(0);
}

int kstgbi_(int*iB,int*iM,int*iS)
{
  if(instB==*iB&&instM==*iM&&instS==*iS)
    return(blb[*iB].IS[*iM][*iS]&0x800);
  else
    return(0);
}

int kstgai_(int*iB,int*iM,int*iS)
{
  if(instB==*iB&&instM==*iM&&instS==*iS)
    return(blb[*iB].IS[*iM][*iS]&0x400);
  else
    return(0);
}
