#include <string.h>
#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <ctype.h>
#include <math.h>
#include "CbType.h"
#include "XCbType.h"

#define MULTI

#ifndef mzl_XCB 
#ifdef CRAY
#define xcbitb_ XCBITB
#define ixcbtb_ IXCBTB
#endif

#ifdef HP
#define xcbitb_ xcbitb
#define ixcbtb_ ixcbtb
#endif

extern Display*theD;
extern int theD_w,theD_h;
extern Window theW,theHW,CPanelW;
extern int NWin;
extern int Wmode;
extern GC theGC,theGCE,theGCM,theGCH;
extern WinPar*WinP;
extern int wF,hF,wFHelp,hFHelp;
extern XEvent msg;
extern unsigned long int ColorPix[];
extern int XCbNColor;

extern CbUnits*XUnits;
extern int NXUnits;

extern int xshift;
extern int CbBoxFl;
extern double CbBoxX[2],CbBoxY[2];

extern char nameX[],nameY[],nameP[];
extern double PSx0,PSy0,PSsx,PSsy;
extern int FlagPS;

static int iWin,iHelpW,*FlSc,*FlReadTbl;
static double*p0,*p1,*p2,*p3,*p4,*p5,*p6,*p7;
static double xg_0,yg_0,sx,sy;
static double*Xg_0,*Yg_0,*Xmin,*Ymin,*Xmax,*Ymax,*Sx,*Sy;

static BLB*blb;
static int nblb,nCbB;

static char***BlbInpFNmD,***BlbInpFNmW,***BlbInpFNmO,***BlbInpFNmI;
static char****MzlInpFNmW,****MzlInpFNmO,****MzlInpFNmI;
static char*****StgInpFNmW,*****StgInpFNmO,*****StgInpFNmI;
static int*kBlbInpDir;

static PanelCell*CPCell;
static int nCPCell,*kCPCell,*kIDCell,nIDCell;
static InputCell*IDCell;

static InpTblPar*Tbl,*pntT;
static int nTbl,TblB,TblM,TblS;

static PltPar*Plt,*pntP;
static RngPar*Rng;

#ifndef stg_TableParStatic
static XCbMenu **XCbM,*pXCbM;

static int*nXCbM;
static int**j2i,**j2m,**j2jv,**j2nv,**i2j,**i2c;

static InputCell**Cell,*pCell;
static int nLmx;
static int wInd;
static int**va,**kx2j,**ky2j,**kx2p,**ky2p,**j2kx,**j2ky,*Nkx;

static int*pi,*pi0,Ni,Nd;
static int*dummyPi,NPi,NPd;
static double*pd,*pd0;

static double*dummyPd;

static double***Box;
static int***iBox,**sBox,*scPlot;
static char*strBox= "NY";

static char***nmv;
static int**ScInd;
static int**vi,**vi0;
static double**vd,**vd0;
#endif

#ifndef stg_TableParDynamic
static int Nvi,Nvd;
static int nP,nV,nPV;
static int nPC,nVC,nPVC,nL,*xshTbl,*NCell,*iCell;
static int *pj2i,*pj2m,*pj2jv,*pj2nv,*pi2j,*pi2c;
static int *mM,*mJ,NM;
#endif

static int**dummyVi,NdVi,NdVd,*ndVi,*ndVd;
static double**dummyVd;

static CbVectorNm*VecNm;
static int NVecNm;

static int NL= 5;

static int ih3;

#ifndef stg_PSFile
static char NmF[80],ln[81],**PageNames;
static int *FlPSopen,*FigCnt,*PageCnt;
static long int*PSFilePos;
#endif

static FILE*fp;

static int wU,wID,ih,*xB,*wB,*yB,*hB,nR;
static int jCell;

int XCbGetAddressTblCell(InputCell**ToCell,int *ToNCell
			 ,int **j2i0, int **j2jv0,int **j2nv0,int iTbl)
{
  *ToNCell	=NCell[iTbl];
  *ToCell	=Cell[iTbl];
  *j2i0		=j2i[iTbl];
  *j2jv0	=j2jv[iTbl];
  *j2nv0	=j2nv[iTbl];
  return(0);
}

int CbGetUserControlCell()
{
  return(jCell);
}

int XCbGetCellAddress(InputCell **lC,char *Nm, char*NmT)
{
  int i,j,n;

  *lC	=NULL;
  jCell	=0;
  if(Nm == NULL || NmT == NULL) return(0);
  for(i=0; i < nTbl; i++){
    if(Tbl[i].SF != NULL && strcmp(Tbl[i].Nm,NmT) == 0){
      n	=NCell[i];
      while(jCell < n && strcmp(pCell[jCell].pn,Nm)) jCell++;
      if(jCell < n) *lC	=pCell+jCell;
    }
  }
  return(jCell);
}

int CbDecodeEName(char **llT,int nNm,char *pntS, CbVectorNm *VNm,int n)
{
  char *p,*p1,*t,*t1;
  int i,j,k,m,nN;
  CbVectorNm*pV;

  p	=pntS;

  m	=0;
  nN	=0;
  for(i=0; i < n && nN < nNm; i++){
    pV	=VecNm+i;
    p1	=p;
    for(j=pV->i0; j < pV->i1 && nN < nNm; j++){
      p	=p1;
      for(k=0; k < pV->k && nN < nNm; k++){
	while(*p != '#' && *p != ',' && *p != '\0'){
	  if(*p == '\\' && *(p+1) != '\0') p++;
	  m++;
	  p++;
	}
	if(*p == '#'){
	  if(j < 10){
	    m++;
	  }
	  else{
	    m	+=2;
	  }
	  p++;
	  while(*p != ','){
	    m++;
	    p++;
	  }
	}
	m++;
	nN++;
	p++;
      }
    }
  }
  if(nNm < 10){
    m	+=2*(nNm-nN);
  }
  else{
    m	+=3*(nNm-nN);
  }
  *llT	=(char*)malloc(m*sizeof(char));
  p	=pntS;
  t	=*llT;
  nN	=0;
  for(i=0; i < n && nN < nNm; i++){
    pV	=VecNm+i;
    p1	=p;
    for(j=pV->i0; j < pV->i1 && nN < nNm; j++){
      p	=p1;
      for(k=0; k < pV->k && nN < nNm; k++){
	t1	=t;
	while(*p != '#' && *p != ',' && *p!='\0'){
	  if(*p == '\\' && *(p+1) != '\0') p++;
	  *t++=*p++;
	}
	if(*p == '#'){
	  if(j < 10){
	    t+=sprintf(t,"%d",j%10);
	  }
	  else{
	    t+=sprintf(t,"%2.2d",j%100);
	  }


	  p++;
	  while(*p!=','){
	    *t++	=*p++;
	  }
	}
	*t++	='\0';
	p++;
	nN++;
      }
    }
  }
  j	=1;
  while(nN < nNm){
    if(nNm < 10){
      sprintf(t,"%d",j%100);
      t	+=2;
    }
    else{
      sprintf(t,"%2.2d",j%100);
      t	+=3;
    }
    j++;
    nN++;
  }
  return(0);
}

int XCbCbENmV2(CbVectorNm *VNm,int *n,char *line,char *str)
{
  char*p,*s1,*s;
  int n1,k,i0,i1,L;

  p	=line;
  s	=str;

  n1	=0;
  while(*s != '\0'){
    s1	=s;
    while(isspace(*s1)){
      s1++;
    }
    if(*s1 == '('){
      s	=s1;
    }
    if(*s == '('){
      s++;
      s1	=s;
      while(*s1 != '='){
	s1++;
      }
      if(sscanf(s1+1,"%d<%d",&i0,&i1) < 2){
	printf("Wrong size of array:\n%s in\n%s\n",s1+1,str);
	return(1);
      }
      s1--;
      L	=0;
      while(*s1 != ','&& s1 > s){
	L++;
	s1--;
      }
      s1++;
      k	=0;
      while(s < s1){
	while(*s != ','){
	  if(strncmp(s,s1,L) == 0
	     && isalnum(*(s+L)) == 0 && *(s+L) != '_'){
	    *p++	='#';
	    s	+=L;
	  }
	  else{
	    *p++	=*s++;
	  }
	}
	if(*s == ','){
	  *p++	=*s;
	  k++;
	}
	s++;
      }
      while(*s != ')'){
	s++;
      }
      while(*s != ',' && *s != '\0'){
	s++;
      }
      if(*s==','){
	s++;
      }
      VNm[n1].k	=k;
      VNm[n1].i0	=i0;
      VNm[n1].i1	=i1;
      n1++;
      if(n1 == NVecNm){
	NVecNm	+=10;
	VecNm	=(CbVectorNm*)realloc((void*)VecNm,NVecNm*sizeof(CbVectorNm));
      }
    }
    else{
      while(*s != ',' && *s != '\0'){
	*p++	=*s;
	s++;
      }
      *p	=*s;
      p++;
      VNm[n1].k	=1;
      VNm[n1].i0	=0;
      VNm[n1].i1	=1;
      n1++;
      if(n1 == NVecNm){
	NVecNm	+=10;
	VecNm	=(CbVectorNm*)realloc((void*)VecNm,NVecNm*sizeof(CbVectorNm));
      }
      if(*s == '\0'){
	break;
      }
      s++;
    }
  }
  *p	='\0';
  *n	=n1;
  return(0);
}

int XCbDecodeEName(char **llNm,char *NmE,char *NmEs,int n)
{
  char ln[132],*p;
  int m;

  XCbCbENmV2(VecNm,&m,ln,NmEs);
  p	=NmE;
  while(*p != '(' && *p != ',' && *p != '\0'){
    p++;
  }
  if(*p == ','){
    *p	='\0';
  }
  if(*p == '('){
    p++;
    while(*p != ')' && *p != ',' && *p != '\0'){
      *NmE++	=*p++;
    }
    *NmE= '\0';
  }
  CbDecodeEName(llNm,n,ln,VecNm,m);
  return(0);
}

int XCbFreeCell(iT)
{
  if(NCell[iT]){
    free(Cell[iT]);
    Cell[iT]	=NULL;
    NCell[iT]	=0;
  }
  return(0);
}

int XCbInitTableCells(int iT)
{
  int i,ii,j,jj,j1,j2,ix,ix1,iw,iw1,iw2,k,iM,na,ns,nd,ni,n,k1,id;
  char*pnt;
  int n1,nkx,nU;
  int*pntkx,*pntky,*pntjx,*pntjy;

  wInd	=wF+4;
  wInd	=wF;
  pXCbM	=XCbM[iT] != NULL ? XCbM[iT] : NULL;
  pi2j	=i2j[iT];
  pi2c	=i2c[iT];
  pj2i	=j2i[iT];
  pj2m	=j2m[iT];
  pj2jv	=j2jv[iT];
  pj2nv	=j2nv[iT];

  pntT	=Tbl+iT;
  nL	=pntT->nL;
  nP	=pntT->NP;
  nV	=pntT->NNmV;
  nPV	=nP+nV;
  nPC	=pntT->NPC;
  nVC	=pntT->NNmVC;
  nPVC	=nPC+nVC;
  NL	=nL;


  n	=nPC;
  k	=nPVC;
  for(j=nPC; j < nPVC; j++){
    i	=pj2i[j];
    i	-=nP;
    iM	=pj2m[j];
    ii	=pntT->iCV[i];
    if(iM < 0 || pXCbM[iM].d == 0){
      pj2jv[j]	=k;
      pj2nv[j]	=pntT->lV[i];
      k	+=pj2nv[j]-1;
      n	+=pj2nv[j];
    }
    else{
      n++;
      pj2jv[j]	=j;
      pj2nv[j]	=0;
    }
  }
  NCell[iT]	=n;
  Cell[iT]	=(InputCell*)malloc(n*sizeof(InputCell));
  pCell	=Cell[iT];
  nU	=-2;
  na	=0;
  ns	=0;
  nd	=0;
  ni	=0;
  for(j=0; j < nPC; j++){
    i	=pj2i[j];
    iM	=pj2m[j];
    ii	=pntT->iCP[i];
    pCell[j].pH	=pntT->HlpP[i];
    pCell[j].c	=pi2c[i];
    pCell[j].h	=hF;

    k	=iM < 0 ? i : pXCbM[iM].p[0];
    pCell[j].pn	=pntT->nmEP[k];
    if((ii&16)){
      if(nU == -2){
	nU	=pntT->nUP[k];
      }
      else{
	if(nU != pntT->nUP[k]){
	  nU	=-1;
	}
      }
    }
    if(pntT->aEP[k] != NULL){
      pCell[j].ws	=wInd;
      na++;
    }
    else{
      pCell[j].ws	=0;
    }
    if(iM < 0 || pXCbM[iM].d == 0){
      switch((ii&7)){
      case 0:
	pCell[j].pv	=NULL;
	pCell[j].ids	=ii;
	ns++;
	break;
      case 1:
      case 3:
	pCell[j].pv	=(char*)(pd+nd);
	pCell[j].ids	=(ii&(~7))+1;
	nd++;
	break;
      case 2:
      case 4:
	pCell[j].pv	=(char*)(pi+ni);
	pCell[j].ids	=(ii&(~7))+2;
	ni++;
	break;
      case 5:
	pCell[j].pv	=(char*)(pi+ni);
	pCell[j].ids	=(ii&(~7))+5;
	ni++;
	break;
      default:
	break;
      }
      pCell[j].l	=pntT->inP[i];
      pCell[j].wd	=pCell[j].l ? pCell[j].l*wF : 0;
      pCell[j].il	=pCell[j].l ? pCell[j].l-1 : 0;
    }
    else{
      pCell[j].pv	=NULL;
      pCell[j].l	=0;
      pCell[j].wd	=0;
      pCell[j].il	=0;
      pCell[j].ids	=ii;
    }

    if(iM < 0){
      pCell[j].ln	=strlen(pCell[j].pn);
      pCell[j].wn	=pCell[j].ln*wF;
      pCell[j].nU	=pntT->nUP[i];
      pCell[j].lu	=pntT->nUP[i] < 0 ? 0 : XUnits[pCell[j].nU].Ln;
      pCell[j].pu	=pCell[j].lu == 0 ? NULL : XUnits[pCell[j].nU].pntU;
      pCell[j].wu	=pCell[j].lu ? pCell[j].lu*wF : 0;
    }
    else{
      iw	=0;
      iw1	=0;
      for(j1=0; j1 < pXCbM[iM].n; j1++){
	k	=pXCbM[iM].p[j1];
	ii	=strlen(pntT->nmEP[k]);
	if(iw < ii){
	  iw	=ii;
	}
	if(pntT->nUP[k] >= 0) iw1=1;
      }
      pCell[j].ln	=iw;
      pCell[j].wn	=pCell[j].ln*wF;
      if(iw1){
	pCell[j].nU	=pntT->nUP[i] < 0 ? 0 : pntT->nUP[i];
	pCell[j].lu	=XUnits[pCell[j].nU].Ln;
	pCell[j].pu	=XUnits[pCell[j].nU].pntU;
	pCell[j].wu	=pCell[j].lu*wF;
      }
      else{
	pCell[j].nU	=-1;
	pCell[j].lu	=0;
	pCell[j].pu	=NULL;
	pCell[j].wu	=0;
      }
    }
    pCell[j].w	=pCell[j].wn+pCell[j].ws+pCell[j].wd+pCell[j].wu;
  }

  n1	=0;
  ns	=0;
  nd	=0;
  ni	=0;
  jj	=0;
  
  for(j=nPC; j < nPVC; j++){
    i	=pj2i[j];
    pCell[j].c	=pi2c[i];
    i	-=nP;
    iM	=pj2m[j];
    ii	=pntT->iCV[i];
    pCell[j].pH	=pntT->HlpV[i];
    switch((ii&7)){
    case 0:
    case 1:
    case 2:
      pCell[j].ids	=ii;
      break;
    case 3:
      pCell[j].ids	=(ii&(~7))+1;
      break;
    case 4:
      pCell[j].ids	=(ii&(~7))+2;
    case 5:
      pCell[j].ids	=(ii&(~7))+5;
      break;
    }
    pCell[j].h	=hF;
    if(iM < 0 || pXCbM[iM].d == 0){
      k	=iM < 0 ? i : pXCbM[iM].p[0]-nP;
      if((ii&16)){
	if(nU == -2){
	  nU	=pntT->nUV[k];
	}
	else{
	  if(nU != pntT->nUV[k]){
	    nU	=-1;
	  }
	}
      }
      id	=k;
      XCbDecodeEName(nmv[iT]+jj,pntT->nmEV[k],pntT->nmEVs[k],pj2nv[j]);
      ix	=pntT->laV[k];
      if(pntT->aEV[k] != NULL){
	pCell[j].ws	=wInd;
	na++;
      }
      else{
	pCell[j].ws	=0;
      }
      pCell[j].pn	=nmv[iT][jj];
      pnt	=nmv[iT][jj];
      n	=0;
      while(*pnt != '\0'){
	pnt++;
	n++;
      }
      pnt++;
      pCell[j].ln	=n;
      k	=pj2jv[j];
      for(k1=1; k1 < pj2nv[j]; k1++){
	if(k1 < ix){
	  pCell[k].ws	=wInd;
	  na++;
	}
	else{
	  pCell[k].ws	=0;
	}
	pCell[k].pn	=pnt;
	n	=0;
	while(*pnt != '\0'){
	  pnt++;
	  n++;
	}
	pnt++;
	pCell[k].ln	=n;
	k++;
      }

      if(pntT->iPV[i]){
	k	-=2;
	pCell[k].ln	=3;
	id	=pntT->nL > 1 ? n1/2 : 0;
	pCell[k].vs	=sBox[iT]+id;
	pCell[k].ps	=strBox+sBox[iT][id];
	pCell[k].ps0	=strBox;
	pCell[k].ws	=wInd;
	if(n1%2 == 0){
	  pCell[k].pn	="Bx0";
	  k++;
	  pCell[k].pn	="Bx1";
	}
	else{
	  pCell[k].pn	="By0";
	  k++;
	  pCell[k].pn	="By1";
	}
	pCell[k].ln	=3;
	k++;
	n1++;
      }
      id	=ii & 8 ? ii-8 : ii;
      switch((ii&7)){
      case 0:
	pCell[j].pv	=NULL;
	pCell[j].l	=pntT->inV[i];
	pCell[j].wd	=pCell[j].l ? pCell[j].l*wF : 0;
	pCell[j].il	=pCell[j].l ? pCell[j].l-1 : 0;
	k	=pj2jv[j];
	for(k1=1; k1 < pj2nv[j]; k1++){
	  pCell[k].pv	=NULL;
	  pCell[k].l	=pCell[j].l;
	  pCell[k].pH	=pCell[j].pH;
	  pCell[k].c	=pi2c[i];
	  pCell[k].ids	=id;
	  pCell[k].h	=hF;
	  pCell[k].nU	=-1;
	  pCell[k].pu	=NULL;
	  pCell[k].lu	=0;
	  pCell[k].wn	=pCell[k].ln ? pCell[k].ln*wF : 0;
	  pCell[k].wd	=pCell[j].wd;
	  pCell[k].il	=pCell[j].il;
	  pCell[k].wu	=0;
	  pCell[k].w	=pCell[k].wn+pCell[k].ws+pCell[j].wd;
	  k++;
	}
	ns++;
	break;
      case 1:
      case 3:
	pCell[j].pv	=(char*)(vd[nd]);
	pCell[j].l	=pntT->inV[i];
	pCell[j].wd	=pCell[j].l*wF;
	pCell[j].il	=pCell[j].l-1;
	n	=pj2nv[j];
	k	=pj2jv[j];
	for(k1=1; k1 < n; k1++){
	  pCell[k].pv	=(char*)(vd[nd]+k1);
	  pCell[k].l	=pCell[j].l;
	  pCell[k].pH	=pCell[j].pH;
	  pCell[k].c	=pi2c[i];
	  pCell[k].ids	=(id&(~7))+1;
	  pCell[k].h	=hF;
	  pCell[k].nU	=-1;
	  pCell[k].pu	=NULL;
	  pCell[k].lu	=0;
	  pCell[k].wn	=pCell[k].ln ? pCell[k].ln*wF : 0;
	  pCell[k].wd	=pCell[j].wd;
	  pCell[k].il	=pCell[j].il;
	  pCell[k].wu	=0;
	  pCell[k].w	=pCell[k].wn+pCell[k].ws+pCell[k].wd;
	  k++;
	}
	nd++;
	break;
      case 2:
      case 4:
	pCell[j].pv	=(char*)(vi[ni]);
	pCell[j].l	=pntT->inV[i];
	pCell[j].wd	=pCell[j].l*wF;
	pCell[j].il	=pCell[j].l-1;
	k	=pj2jv[j];
	for(k1=1; k1 < pj2nv[j]; k1++){
	  pCell[k].pv	=(char*)(vi[ni]+k1);
	  pCell[k].l	=pCell[j].l;
	  pCell[k].pH	=pCell[j].pH;
	  pCell[k].c	=pi2c[i];
	  pCell[k].ids	=(id&(~7))+2;
	  pCell[k].h	=hF;
	  pCell[k].nU	=-1;
	  pCell[k].pu	=NULL;
	  pCell[k].lu	=0;
	  pCell[k].wn	=pCell[k].ln?pCell[k].ln*wF:0;
	  pCell[k].wd	=pCell[j].wd;
	  pCell[k].il	=pCell[j].il;
	  pCell[k].wu	=0;
	  pCell[k].w	=pCell[k].wn+pCell[k].ws+pCell[k].wd;
	  k++;
	}
	ni++;
	break;
      case 5:
	pCell[j].pv	=(char*)(vi[ni]);
	pCell[j].l	=pntT->inV[i];
	pCell[j].wd	=pCell[j].l*wF;
	pCell[j].il	=pCell[j].l-1;
	k	=pj2jv[j];
	for(k1=1; k1 < pj2nv[j]; k1++){
	  pCell[k].pv	=(char*)(vi[ni]+k1);
	  pCell[k].l	=pCell[j].l;
	  pCell[k].pH	=pCell[j].pH;
	  pCell[k].c	=pi2c[i];
	  pCell[k].ids	=(id&(~7))+5;
	  pCell[k].h	=hF;
	  pCell[k].nU	=-1;
	  pCell[k].pu	=NULL;
	  pCell[k].lu	=0;
	  pCell[k].wn	=pCell[k].ln?pCell[k].ln*wF : 0;
	  pCell[k].wd	=pCell[j].wd;
	  pCell[k].il	=pCell[j].il;
	  pCell[k].wu	=0;
	  pCell[k].w	=pCell[k].wn+pCell[k].ws+pCell[k].wd;
	  k++;
	}
	ni++;
	break;
      default:
	break;
      }
      jj++;
    }
    else{
      k	=pXCbM[iM].p[0]-nP;
      pCell[j].pn	=pntT->nmEV[k];
      if(pntT->aEV[k] != NULL){
	pCell[j].ws	=wInd;
	na++;
      }
      else{
	pCell[j].ws	=0;
      }
      pCell[j].pv	=NULL;
      pCell[j].l	=0;
      pCell[j].wd	=0;
      pCell[j].il	=0;
    }
    if(iM < 0){
      pCell[j].wn	=pCell[j].ln*wF;
      pCell[j].nU	=pntT->nUV[i];
      if(pCell[j].nU < 0){
	pCell[j].lu	=0;
	pCell[j].pu	=NULL;
	pCell[j].wu	=0;
      }
      else{
	pCell[j].lu	=XUnits[pCell[j].nU].Ln;
	pCell[j].pu	=XUnits[pCell[j].nU].pntU;
	pCell[j].wu	=pCell[j].lu*wF;
      }
    }
    else{
      iw	=0;
      iw1	=0;
      for(j1= 0;j1<pXCbM[iM].n;j1++){
	k	=pXCbM[iM].p[j1]-nP;
	if(j1){
	  ii	=strlen(pntT->nmEV[k]);
	}
	else{
	  ii	=strlen(pCell[j].pn);
	}
	if(iw<ii){
	  iw	=ii;
	}
	if(pntT->nUV[k]>=0) iw1=1;
      }
      pCell[j].ln	=iw;
      pCell[j].wn	=pCell[j].ln*wF;
      if(iw1){
	pCell[j].nU	=pntT->nUV[i]<0?0:pntT->nUV[i];
	pCell[j].lu	=XUnits[pCell[j].nU].Ln;
	pCell[j].pu	=XUnits[pCell[j].nU].pntU;
	pCell[j].wu	=pCell[j].lu*wF;
      }
      else{
	pCell[j].nU	=-1;
	pCell[j].lu	=0;
	pCell[j].pu	=NULL;
	pCell[j].wu	=0;
      }
    }
    pCell[j].w	=pCell[j].wn+pCell[j].ws+pCell[j].wd+pCell[j].wu;
  }
  if(nU >= 0){
    scPlot[iT]	=0;
  }

  /* Positions */
  ix	=0;
  ix1	=0;
  iw	=0;
  j	=0;
  while(j < nPC){
    ns	=0;
    iw	=0;
    for(jj=0,nd=hF+1; jj < nL && j < nPC; jj++, nd +=hF+1){
      iw1	=pCell[j].w;
      iw2	=0;
      iM	=pj2m[j];
      if(iM < 0 || pXCbM[iM].d == 0){
	ns	=1;
      }
      else{
	j1	=j;
	do{
	  j1++;
	  k	=pj2m[j1];
	  iw1  +=pCell[j1].w;
	}while(pXCbM[k].d);
	if(ns < 2 && nL > 1 && iw < iw1){
	  if(ns == 1){
	    j2	=j-1;
	    iw2	=pCell[j2].w;
	  }
	  else{
	    iw2	=0;
	  }
	  j1	=j;
	  while(iw2 < iw1-pCell[j1].w){
	    iw2	+=pCell[j1].w;
	    iw1	-=pCell[j1].w;
	    j1++;
	  }
	  if(iw1 < iw2){
	    iw1	=iw2;
	  }
	  iw2	=0;
	  while(j<j1){
	    pCell[j].y	=ns?pCell[j2].y:nd;
	    pCell[j].x	=ix+iw2;
	    pCell[j].xs	=pCell[j].x+pCell[j].wn;
	    pCell[j].xd	=pCell[j].xs+pCell[j].ws;
	    pCell[j].xu	=pCell[j].xd+pCell[j].wd;
	    iw2		+=pCell[j].w;
	    j++;
	  }
	  if(ns){
	    pCell[j2].x	=ix+iw1-pCell[j2].w;
	    pCell[j2].xs=pCell[j2].x+pCell[j2].wn;
	    pCell[j2].xd=pCell[j2].xs+pCell[j2].ws;
	    pCell[j2].xu=pCell[j2].xd+pCell[j2].wd;
	  }
	  else{
	    jj++;
	    nd+=hF+1;
	  }
	}
	iw2	=0;
	while(pXCbM[pj2m[j]].d){
	  pCell[j].y	=nd;
	  pCell[j].x	=ix+iw2;
	  pCell[j].xs	=pCell[j].x+pCell[j].wn;
	  pCell[j].xd	=pCell[j].xs+pCell[j].ws;
	  pCell[j].xu	=pCell[j].xd+pCell[j].wd;
	  iw2+= pCell[j].w;
	  j++;
	}
	ns	=pXCbM[iM].d+1;
      }
      if(iw < iw1) iw=iw1;

      pCell[j].y	=nd;
      pCell[j].x	=ix+iw2;
      pCell[j].xs	=pCell[j].x+pCell[j].wn;
      pCell[j].xd	=pCell[j].xs+pCell[j].ws;
      pCell[j].xu	=pCell[j].xd+pCell[j].wd;

      i	=pj2i[j];
      if(pntT->ixP[i] >= 0){
	iw	=pntT->ixP[i]*wF-pCell[j].x;
	pCell[j].x	+=iw;
	pCell[j].xs	+=iw;
	pCell[j].xd	+=iw;
	pCell[j].xu	+=iw;
      }
      else{
	if(ix1 < pCell[j].x+pCell[j].w) ix1=pCell[j].x+pCell[j].w;
      }
      if(pntT->iyP[i] >= 0){
	pCell[j].y	=pntT->iyP[i]*(hF+1);
      }
      j++;
    }
    ix	+=iw;
  }

  iw	=0;
  j	=nPC;
  ns	=0;
  for(jj=0; jj < nL && j < nPVC; jj++){
    iM	=pj2m[j];
    if(iM < 0 || pXCbM[iM].d == 0){
      iw1	=pCell[j].w;
      ns	=1;
    }
    else{
      iw1	=pCell[j].w;
      j1	=j;
      do{
	j1++;
	k	=pj2m[j1];
	iw1	+=pCell[j1].w;
      }while(pXCbM[k].d);
      if(ns == 1 && jj){
	j2	=j-1;
	iw2	=pCell[j2].w;
	j1	=j;
	while(iw2 <= iw1-pCell[j1].w){
	  iw2	+=pCell[j1].w;
	  iw1	-=pCell[j1].w;
	  ns--;
	  j1++;
	}
	if(iw1 < iw2){
	  iw1	=iw2;
	}
      }
      ns	=pXCbM[iM].d+1;
      j		+=pXCbM[iM].d;
    }

    i	=pj2i[j]-nP;
    if(iw < iw1 && pntT->ixV[i] < 0) iw=iw1;
    j++;
  }
  ix1	+=iw;

  /********/
#ifdef H
#endif
  nd	=hF+1;
  j	=nPC;
  ns	=0;
  for(jj=0; jj < nL && j < nPVC; jj++){
    iM	=pj2m[j];
    if(iM < 0 || pXCbM[iM].d == 0){
      ns	=1;
    }
    else{
      iw1	=pCell[j].w;
      j1	=j;
      do{
	j1++;
	k	=pj2m[j1];
	iw1	+=pCell[j1].w;
      }while(pXCbM[k].d);
      if(ns == 1 && jj){
	j2	=j-1;
	iw2	=pCell[j2].w;

	pCell[j2].x	=ix1-pCell[j2].w;
/******/
#ifdef H
	pCell[j2].x	=ix1;
#endif

	pCell[j2].xs	=pCell[j2].x+pCell[j2].wn;
	pCell[j2].xd	=pCell[j2].xs+pCell[j2].ws;
	pCell[j2].xu	=pCell[j2].xd+pCell[j2].wd;
	j1	=j;
	while(iw2 <= iw1-pCell[j1].w){
	  iw2	+=pCell[j1].w;
	  iw1	-=pCell[j1].w;
	  ns--;
	  j1++;
	}
	if(iw1 < iw2){
	  iw1	=iw2;
	}
	iw2	=0;
	while(j < j1){
	  pCell[j].y	=pCell[j2].y;
	  pCell[j].x	=ix1-iw+iw2;
	  pCell[j].xs	=pCell[j].x+pCell[j].wn;
	  pCell[j].xd	=pCell[j].xs+pCell[j].ws;
	  pCell[j].xu	=pCell[j].xd+pCell[j].wd;
	  iw2		+=pCell[j].w;
	  j++;
	}
      }
      iw2	=0;
      while(pXCbM[pj2m[j]].d){
	pCell[j].y	=nd;
	pCell[j].x	=ix1-iw+iw2;
	pCell[j].xs	=pCell[j].x+pCell[j].wn;
	pCell[j].xd	=pCell[j].xs+pCell[j].ws;
	pCell[j].xu	=pCell[j].xd+pCell[j].wd;
	iw2+= pCell[j].w;
	j++;
      }
      ns	=pXCbM[iM].d+1;
    }
    pCell[j].y	=nd;

    pCell[j].x	=ix1-pCell[j].w;
/******/
#ifdef H
    pCell[j].x	=ix1;
#endif

    pCell[j].xs	=pCell[j].x+pCell[j].wn;
    pCell[j].xd	=pCell[j].xs+pCell[j].ws;
    pCell[j].xu	=pCell[j].xd+pCell[j].wd;
    j++;
    nd+= hF+1;
  }
  for(j= nPC;j<nPVC;j++){
    iM	=pj2m[j];
    if(iM<0||pXCbM[iM].d==0){
      k	=pj2jv[j];
      nd	=pCell[j].y;
      iw1	=pCell[j].x+pCell[j].w;

      for(k1= 1;k1<pj2nv[j];k1++){
	pCell[k].y	=nd;
	pCell[k].x	=iw1;
	pCell[k].xs	=pCell[k].x+pCell[k].wn;
	pCell[k].xd	=pCell[k].xs+pCell[k].ws;
	pCell[k].xu	=pCell[k].xd+pCell[k].wd;
	iw1+= pCell[k].w;
	k++;
      }
    }
  }

  n	=0;
  for(j=0;j < nPC;j++){
    iM	=pj2m[j];
    if(pCell[j].ids&16&&(iM<0||pXCbM[iM].d==0)){
      n++;
    }
  }
  if(nL> 1 && n%2){
    n--;
    printf("Warning:\n %s Table%c\n",pntT->Nm,7);
    printf("non-even number of parameters for 2D-plot\n\n");
  }

  n1	=0;
  for(j=nPC; j < nPVC; j++){
    iM	=pj2m[j];
    if(pCell[j].ids&16&&(iM<0||pXCbM[iM].d==0)){
      n+= pj2nv[j];
      if(n1%2==0){
	k	=pj2nv[j];
      }
      else{
	k1	=pj2nv[j];
	if(k1!=k){
	  printf("Error:\n %s Table%c\n",pntT->Nm,7);
	  printf("unequal X-, Y- numbers of vector values for 2D-plot\n\n");
	}
      }
      n1++;
    }
  }

  if(nL > 1 && n%2){
    n--;
    printf("Warning:\n %s Table%c\n",pntT->Nm,7);
    printf("non-even number of vector values for 2D-plot\n\n");
  }

  Nkx[iT] = nL > 1 ? n/2 : n;
  nkx	=Nkx[iT];
  kx2j[iT]	=(int*)malloc((4*nkx+2*NCell[iT]+na)*sizeof(int));
  ky2j[iT]	=kx2j[iT]+nkx;
  kx2p[iT]	=ky2j[iT]+nkx;
  ky2p[iT]	=kx2p[iT]+nkx;
  j2kx[iT]	=ky2p[iT]+nkx;
  j2ky[iT]	=j2kx[iT]+NCell[iT];
  va[iT]	=j2ky[iT]+NCell[iT];

  for(j=0;j < na;j++){
    va[iT][j]	=0;
  }

  pntkx	=kx2j[iT];
  pntky	=ky2j[iT];
  pntjx	=j2kx[iT];
  pntjy	=j2ky[iT];

  n	=0;
  n1	=0;

  for(j=0; j < nPC;j++){
    iM	=pj2m[j];
    if(pCell[j].ids&16&&(iM<0||pXCbM[iM].d==0)){
      if(nL == 1){
	pntkx[n]	=j;
	pntjx[j]	=n;
	pntky[n]	=0;
	pntjy[j]	=0;
      }
      else{
	n1	=n/2;
	if(n%2==0){
	  pntkx[n1]	=j;
	  pntjx[j]	=n1;
	  pntjy[j]	=n1;
	}
	else{
	  pntjx[j]	=n1;
	  pntky[n1]	=j;
	  pntjy[j]	=n1;
	}
      }
      n++;
    }
    else{
      pntjx[j]	=-1;
      pntjy[j]	=-1;
    }
  }
  if(nL>1){
    n/=2;
  }
  n1	=0;
  for(j=nPC; j < nPVC; j++){
    iM	=pj2m[j];
    if(iM < 0 || pXCbM[iM].d == 0){
      ns	=pCell[j].ids&16;
      if(nL==1){
	if(ns){
	  pntkx[n]	=j;
	  pntky[n]	=0;
	  pntjx[j]	=n;
	  pntjy[j]	=0;
	  n++;
	}
	else{
	  pntjx[j]	=-1;
	  pntjy[j]	=-1;
	}
	k	=pj2jv[j];
	for(k1=1; k1 < pj2nv[j]; k1++){
	  if(ns){
	    pntkx[n]	=k;
	    pntky[n]	=0;
	    pntjx[k]	=n;
	    pntjy[k]	=0;
	    n++;
	  }
	  else{
	    pntjx[k]	=-1;
	    pntjy[k]	=-1;
	  }
	  k++;
	}
      }
      else{
	if(n1%2==0){
	  if(ns){
	    pntkx[n]	=j;
	    pntjx[j]	=n;
	    pntjy[j]	=n;
	    n++;
	  }
	  else{
	    pntjx[j]	=-1;
	    pntjy[j]	=-1;
	  }
	  k	=pj2jv[j];
	  for(k1= 1;k1<pj2nv[j];k1++){
	    if(ns){
	      pntkx[n]	=k;
	      pntjx[k]	=n;
	      pntjy[k]	=n;
	      n++;
	    }
	    else{
	      pntjx[k]	=-1;
	      pntjy[k]	=-1;
	    }
	    k++;
	  }
	  if(ns)
	    n-= pj2nv[j];
	}
	else{
	  if(ns){
	    pntky[n]	=j;
	    pntjx[j]	=n;
	    pntjy[j]	=n;
	    n++;
	  }
	  else{
	    pntjx[j]	=-1;
	    pntjy[j]	=-1;
	  }
	  k	=pj2jv[j];
	  for(k1= 1;k1<pj2nv[j];k1++){
	    if(ns){
	      pntky[n]	=k;
	      pntjx[k]	=n;
	      pntjy[k]	=n;
	      n++;
	    }
	    else{
	      pntjx[k]	=-1;
	      pntjy[k]	=-1;
	    }
	    k++;
	  }
	}
      }
      if(ns)
	n1++;
    }
    else{
      pntjx[j]	=-1;
      pntjy[j]	=-1;
    }
  }

#ifndef MULTI
  return(0);
#endif

#ifdef H
  for(j=0; j < nPC; j++){
    i	=pj2i[j];
    if(pntT->ixP[i] >= 0){
      iw	=pntT->ixP[i]*wF-pCell[j].x;
      pCell[j].x	+=iw;
      pCell[j].xs	+=iw;
      pCell[j].xd	+=iw;
      pCell[j].xu	+=iw;
    }
    if(pntT->iyP[i] >= 0){
      pCell[j].y	=pntT->iyP[i]*(hF+1);
    }
  }
#endif

  n	=pntT->NNmV;
  for(j=nPC; j < nPVC; j++){
    i	=pj2i[j]-nP;
    if(pntT->ixV[i] >= 0){
      iw	=pntT->ixV[i]*wF-pCell[j].x;
      pCell[j].x	+=iw;
      pCell[j].xs	+=iw;
      pCell[j].xd	+=iw;
      pCell[j].xu	+=iw;
      iM	=pj2m[j];
      if(iM < 0 || pXCbM[iM].d == 0){
	k	=pj2jv[j];
	for(k1=1; k1 < pj2nv[j]; k1++){
	  pCell[k].x	+=iw;
	  pCell[k].xs	+=iw;
	  pCell[k].xd	+=iw;
	  pCell[k].xu	+=iw;
	  k++;
	}
      }
    }
    if(pntT->iyV[i] >= 0){
      if(pntT->nL < pntT->iyV[i]) pntT->nL=pntT->iyV[i];
      iw	=pntT->iyV[i]*(hF+1);
      pCell[j].y	=iw;
      iM	=pj2m[j];
      if(iM < 0 || pXCbM[iM].d == 0){
	k	=pj2jv[j];
	for(k1=1; k1 <pj2nv[j]; k1++){
	  pCell[k].y	=iw;
	  k++;
	}
      }
    }
  }
  return(0);
}

int XCbReInitTableCells(int iT)
{
  int i,ii,j,jj,j1,j2,ix,ix1,iw,iw1,iw2,k,iM,na,ns,nd,ni,n,k1,id;
  char *pnt;
  int n1,nkx;
  int *pntkx,*pntky,*pntjx,*pntjy;
  int ids[Tbl[iT].NPC+Tbl[iT].NNmVC];
  pXCbM	=XCbM[iT] != NULL ? XCbM[iT] : NULL;
  pi2j	=i2j[iT];
  pi2c	=i2c[iT];
  pj2i	=j2i[iT];
  pj2m	=j2m[iT];
  pj2jv	=j2jv[iT];
  pj2nv	=j2nv[iT];

  pntT	=Tbl+iT;
  nL	=pntT->nL;
  nP	=pntT->NP;
  nV	=pntT->NNmV;
  nPV	=nP+nV;
  nPC	=pntT->NPC;
  nVC	=pntT->NNmVC;
  nPVC	=nPC+nVC;
  NL	=nL;

  n	=nPC;
  k	=nPVC;
  for(j=nPC; j < nPVC; j++){
    i	=pj2i[j];
    i	-=nP;
    iM	=pj2m[j];
    ii	=pntT->iCV[i];
    if(iM < 0 || pXCbM[iM].d == 0){
      pj2jv[j]	=k;
      pj2nv[j]	=pntT->lV[i];
      k	+=pj2nv[j]-1;
      n	+=pj2nv[j];
    }
    else{
      n++;
      pj2jv[j]	=j;
      pj2nv[j]	=0;
    }
  }

  pCell	=Cell[iT];
  for(j=0; j < nPVC; j++){
    ids[j]	=pCell[j].ids;
  }
  if(n != NCell[iT]){
    XCbFreeCell(iT);
    NCell[iT]	=n;
    Cell[iT]	=(InputCell*)malloc(n*sizeof(InputCell));
  }
  pCell	=Cell[iT];
  na	=0;
  ns	=0;
  nd	=0;
  ni	=0;
  for(j=0; j < nPC; j++){
    i	=pj2i[j];
    iM	=pj2m[j];
    ii	=pntT->iCP[i];
    pCell[j].pH	=pntT->HlpP[i];
    pCell[j].c	=pi2c[i];
    pCell[j].h	=hF;
    k	=iM < 0 ? i : pXCbM[iM].p[pXCbM[iM].i];
    pCell[j].pn	=pntT->nmEP[k];
    if(pntT->aEP[k] != NULL){
      pCell[j].ws	=wInd;
      na++;
    }
    else{
      pCell[j].ws	=0;
    }
    if(iM < 0 || pXCbM[iM].d == 0){
      switch(ii&7){
      case 0:
	pCell[j].pv	=NULL;
	pCell[j].ids	=ii;
	ns++;
	break;
      case 1:
      case 3:
	pCell[j].pv	=(char*)(pd+nd);
	pCell[j].l	=8;
	pCell[j].ids	=(ii&(~7))+1;
	nd++;
	break;
      case 2:
      case 4:
	pCell[j].pv	=(char*)(pi+ni);
	pCell[j].l	=4;
	pCell[j].ids	=(ii&(~7))+2;
	ni++;
	break;
      case 5:
	pCell[j].pv	=(char*)(pi+ni);
	pCell[j].l	=9;
	pCell[j].ids	=(ii&(~7))+5;
	ni++;
	break;
      default:
	break;
      }
      pCell[j].l	=pntT->inP[i];
      pCell[j].wd	=pCell[j].l ? pCell[j].l*wF : 0;
      pCell[j].il	=pCell[j].l ? pCell[j].l-1 : 0;
    }
    else{
      pCell[j].pv	=NULL;
      pCell[j].l	=0;
      pCell[j].wd	=0;
      pCell[j].il	=0;
      pCell[j].ids	=ii;
    }
    if(iM < 0){
      pCell[j].ln	=strlen(pCell[j].pn);
      pCell[j].wn	=pCell[j].ln*wF;
      pCell[j].nU	=pntT->nUP[i];
      pCell[j].lu	=pntT->nUP[i] < 0 ? 0 : XUnits[pCell[j].nU].Ln;
      pCell[j].pu	=pCell[j].lu == 0 ? NULL : XUnits[pCell[j].nU].pntU;
      pCell[j].wu	=pCell[j].lu ? pCell[j].lu*wF : 0;
    }
    else{
      iw	=0;
      iw1	=0;
      for(j1=0; j1 < pXCbM[iM].n; j1++){
	k	=pXCbM[iM].p[j1];
	ii	=strlen(pntT->nmEP[k]);
	if(iw < ii){
	  iw	=ii;
	}
	if(pntT->nUP[k] >= 0){
	  iw1	=1;
	}
      }
      pCell[j].ln	=iw;
      pCell[j].wn	=pCell[j].ln*wF;
      if(iw1){
	pCell[j].nU	=pntT->nUP[i] < 0 ? 0 : pntT->nUP[i];
	pCell[j].lu	=XUnits[pCell[j].nU].Ln;
	pCell[j].pu	=XUnits[pCell[j].nU].pntU;
	pCell[j].wu	=pCell[j].lu*wF;
      }
      else{
	pCell[j].nU	=-1;
	pCell[j].lu	=0;
	pCell[j].pu	=NULL;
	pCell[j].wu	=0;
      }
    }
    pCell[j].ids	=ids[j];
    pCell[j].w	=pCell[j].wn+pCell[j].ws+pCell[j].wd+pCell[j].wu;
  }
  n1	=0;
  ns	=0;
  nd	=0;
  ni	=0;
  jj	=0;
  for(j=nPC; j < nPVC; j++){
    i	=pj2i[j];
    pCell[j].c	=pi2c[i];
    i	-=nP;
    iM	=pj2m[j];
    ii	=pntT->iCV[i];
    pCell[j].pH	=pntT->HlpV[i];
    switch((ii&7)){
    case 0:
    case 1:
    case 2:
      pCell[j].ids	=ii;
      break;
    case 3:
      pCell[j].ids	=(ii&(~7))+1;
      break;
    case 4:
      pCell[j].ids	=(ii&(~7))+2;
      break;
    case 5:
      pCell[j].ids	=(ii&(~7))+5;
      break;
    }
    if(iM >= 0){
      pCell[j].ids	|=0x08;   /* corrected */
    }
    pCell[j].ids	=ids[j];
    pCell[j].h	=hF;
    if(iM < 0 || pXCbM[iM].d == 0){
      id	=i;
      if(nmv[iT][jj] != NULL){
	free(nmv[iT][jj]);
      }
      XCbDecodeEName(nmv[iT]+jj,pntT->nmEV[i],pntT->nmEVs[i],pj2nv[j]);
      ix	=pntT->laV[i];
      if(pntT->aEV[i] != NULL){
	pCell[j].ws	=wInd;
	na++;
      }
      else{
	pCell[j].ws	=0;
      }
      pCell[j].pn	=nmv[iT][jj];
      pnt	=nmv[iT][jj];
      n	=0;
      while(*pnt != '\0'){
	pnt++;
	n++;
      }
      pnt++;
      pCell[j].ln	=n;
      k	=pj2jv[j];
      for(k1=1; k1 < pj2nv[j]; k1++){
	if(k1 < ix){
	  pCell[k].ws	=wInd;
	  na++;
	}
	else{
	  pCell[k].ws	=0;
	}
	pCell[k].pn	=pnt;
	n	=0;
	while(*pnt!='\0'){
	  pnt++;
	  n++;
	}
	pnt++;
	pCell[k].ln	=n;
	k++;
      }
      if(pntT->iPV[i]){
	id	=pntT->nL > 1 ? n1/2 : 0;
	k	-=2;
	pCell[k].ln	=3;
	pCell[k].vs	=sBox[iT]+id;
	pCell[k].ps	=strBox+sBox[iT][id];
	pCell[k].ps0	=strBox;
	pCell[k].ws	=wInd;
	if(n1%2 == 0){
	  pCell[k].pn	="Bx0";
	  k++;
	  pCell[k].pn	="Bx1";
	}
	else{
	  pCell[k].pn	="By0";
	  k++;
	  pCell[k].pn	="By1";
	}
	pCell[k].ln	=3;
	k++;
	n1++;
      }
      id	=ii & 8 ? ii-8 : ii;
      pCell[j].l	=pntT->inV[i];
      switch((ii&7)){
      case 0:
	pCell[j].pv	=NULL;
	pCell[j].wd	=pCell[j].l ? pCell[j].l*wF : 0;
	pCell[j].il	=pCell[j].l ? pCell[j].l-1 : 0;
	n	=pj2nv[j];
	k	=pj2jv[j];
	for(k1=1; k1 < n; k1++){
	  pCell[k].pv	=NULL;
	  pCell[k].l	=pCell[j].l;
	  pCell[k].pH	=pCell[j].pH;
	  pCell[k].c	=pi2c[i];
	  pCell[k].ids	=id;
	  pCell[k].h	=hF;
	  pCell[k].nU	=-1;
	  pCell[k].pu	=NULL;
	  pCell[k].lu	=0;
	  pCell[k].wn	=pCell[k].ln ? pCell[k].ln*wF : 0;
	  pCell[k].wd	=pCell[j].wd;
	  pCell[k].il	=pCell[j].il;
	  pCell[k].wu	=0;
	  pCell[k].w	=pCell[k].wn+pCell[k].ws+pCell[k].wd;
	  k++;
	}
	ns++;
	break;
      case 1:
      case 3:
	pCell[j].pv	=(char*)(vd[nd]);
	pCell[j].wd	=pCell[j].l*wF;
	pCell[j].il	=pCell[j].l-1;
	n	=pj2nv[j];
	k	=pj2jv[j];
	for(k1=1; k1 < n; k1++){
	  pCell[k].pv	=(char*)(vd[nd]+k1);
	  pCell[k].l	=pCell[j].l;
	  pCell[k].pH	=pCell[j].pH;
	  pCell[k].c	=pi2c[i];
	  pCell[k].ids	=(id&(~7))+1;
	  pCell[k].h	=hF;
	  pCell[k].nU	=-1;
	  pCell[k].pu	=NULL;
	  pCell[k].lu	=0;
	  pCell[k].wn	=pCell[k].ln?pCell[k].ln*wF:0;
	  pCell[k].wd	=pCell[j].wd;
	  pCell[k].il	=pCell[j].il;
	  pCell[k].wu	=0;
	  pCell[k].w	=pCell[k].wn+pCell[k].ws+pCell[k].wd;
	  k++;
	}
	nd++;
	break;
      case 2:
      case 4:
	pCell[j].pv	=(char*)(vi[ni]);
	pCell[j].wd	=pCell[j].l*wF;
	pCell[j].il	=pCell[j].l-1;
	n	=pj2nv[j];
	k	=pj2jv[j];
	for(k1=1; k1 < n; k1++){
	  pCell[k].pv	=(char*)(vi[ni]+k1);
	  pCell[k].l	=pCell[j].l;
	  pCell[k].pH	=pCell[j].pH;
	  pCell[k].c	=pi2c[i];
	  pCell[k].ids	=(id&(~7))+2;
	  pCell[k].h	=hF;
	  pCell[k].nU	=-1;
	  pCell[k].pu	=NULL;
	  pCell[k].lu	=0;
	  pCell[k].wn	=pCell[k].ln?pCell[k].ln*wF : 0;
	  pCell[k].wd	=pCell[j].wd;
	  pCell[k].il	=pCell[j].il;
	  pCell[k].wu	=0;
	  pCell[k].w	=pCell[k].wn+pCell[k].ws+pCell[k].wd;
	  k++;
	}
	ni++;
	break;
      case 5:
	pCell[j].pv	=(char*)(vi[ni]);
	pCell[j].wd	=pCell[j].l*wF;
	pCell[j].il	=pCell[j].l-1;
	n	=pj2nv[j];
	k	=pj2jv[j];
	for(k1=1; k1 < n; k1++){
	  pCell[k].pv	=(char*)(vi[ni]+k1);
	  pCell[k].l	=pCell[j].l;
	  pCell[k].pH	=pCell[j].pH;
	  pCell[k].c	=pi2c[i];
	  pCell[k].ids	=(id&(~7))+5;
	  pCell[k].h	=hF;
	  pCell[k].nU	=-1;
	  pCell[k].pu	=NULL;
	  pCell[k].lu	=0;
	  pCell[k].wn	=pCell[k].ln?pCell[k].ln*wF : 0;
	  pCell[k].wd	=pCell[j].wd;
	  pCell[k].il	=pCell[j].il;
	  pCell[k].wu	=0;
	  pCell[k].w	=pCell[k].wn+pCell[k].ws+pCell[k].wd;
	  k++;
	}
	ni++;
	break;
      default:
	break;
      }
      jj++;
    }
    else{
      k	=pXCbM[iM].p[0]-nP;
      pCell[j].pn	=pntT->nmEV[k];
      if(pntT->aEV[k] != NULL){
	pCell[j].ws	=wInd;
	na++;
      }
      else{
	pCell[j].ws	=0;
      }
      pCell[j].pv	=NULL;
      pCell[j].l	=0;
      pCell[j].wd	=0;
      pCell[j].il	=0;
    }
    if(iM < 0){
      pCell[j].wn	=pCell[j].ln*wF;
      pCell[j].nU	=pntT->nUV[i];
      if(pCell[j].nU<0){
	pCell[j].lu	=0;
	pCell[j].pu	=NULL;
	pCell[j].wu	=0;
      }
      else{
	pCell[j].lu	=XUnits[pCell[j].nU].Ln;
	pCell[j].pu	=XUnits[pCell[j].nU].pntU;
	pCell[j].wu	=pCell[j].lu*wF;
      }
    }
    else{
      iw	=0;
      iw1	=0;
      for(j1=0;j1 < pXCbM[iM].n; j1++){
	k	=pXCbM[iM].p[j1]-nP;
	if(j1){
	  ii	=strlen(pntT->nmEV[k]);
	}
	else{
	  ii	=strlen(pCell[j].pn);
	}
	if(iw<ii)
	  iw	=ii;
	if(pntT->nUV[k]>=0)
	  iw1	=1;
      }
      pCell[j].ln	=iw;
      pCell[j].wn	=pCell[j].ln*wF;
      if(iw1){
	pCell[j].nU	=pntT->nUV[i]<0?0:pntT->nUV[i];
	pCell[j].lu	=XUnits[pCell[j].nU].Ln;
	pCell[j].pu	=XUnits[pCell[j].nU].pntU;
	pCell[j].wu	=pCell[j].lu*wF;
      }
      else{
	pCell[j].nU	=-1;
	pCell[j].lu	=0;
	pCell[j].pu	=NULL;
	pCell[j].wu	=0;
      }
    }
    pCell[j].w	=pCell[j].wn+pCell[j].ws+pCell[j].wd+pCell[j].wu;
  }
#ifdef H
  if(nU >= 0){
    scPlot[iT]	=0;
  }
#endif
  /* Positions */
  ix	=0;
  ix1	=0;
  iw	=0;
  j	=0;
  while(j < nPC){
    ns	=0;
    iw	=0;
    for(jj= 0,nd= hF+1;jj<nL&&j<nPC;jj++,nd+= hF+1){
      iw1	=pCell[j].w;
      iw2	=0;
      iM	=pj2m[j];
      if(iM<0||pXCbM[iM].d==0){
	ns	=1;
      }
      else{
	j1	=j;
	do{
	  j1++;
	  k	=pj2m[j1];
	  iw1+= pCell[j1].w;
	}while(pXCbM[k].d);
	if(ns<2&&nL>1&&iw<iw1){
	  if(ns==1){
	    j2	=j-1;
	    iw2	=pCell[j2].w;
	  }
	  else{
	    iw2	=0;
	  }
	  j1	=j;
	  while(iw2<iw1-pCell[j1].w){
	    iw2+= pCell[j1].w;
	    iw1-= pCell[j1].w;
	    j1++;
	  }
	  if(iw1<iw2)
	    iw1	=iw2;
	  iw2	=0;
	  while(j<j1){
	    pCell[j].y	=ns?pCell[j2].y:nd;
	    pCell[j].x	=ix+iw2;
	    pCell[j].xs	=pCell[j].x+pCell[j].wn;
	    pCell[j].xd	=pCell[j].xs+pCell[j].ws;
	    pCell[j].xu	=pCell[j].xd+pCell[j].wd;
	    iw2		+=pCell[j].w;
	    j++;
	  }
	  if(ns){
	    pCell[j2].x	=ix+iw1-pCell[j2].w;
	    pCell[j2].xs	=pCell[j2].x+pCell[j2].wn;
	    pCell[j2].xd	=pCell[j2].xs+pCell[j2].ws;
	    pCell[j2].xu	=pCell[j2].xd+pCell[j2].wd;
	  }
	  else{
	    jj++;
	    nd+= hF+1;
	  }
	}

	iw2	=0;
	while(pXCbM[pj2m[j]].d){
	  pCell[j].y	=nd;
	  pCell[j].x	=ix+iw2;
	  pCell[j].xs	=pCell[j].x+pCell[j].wn;
	  pCell[j].xd	=pCell[j].xs+pCell[j].ws;
	  pCell[j].xu	=pCell[j].xd+pCell[j].wd;
	  iw2+= pCell[j].w;
	  j++;
	}
	ns	=pXCbM[iM].d+1;
      }
      if(iw<iw1) iw	=iw1;
      pCell[j].y	=nd;
      pCell[j].x	=ix+iw2;
      pCell[j].xs	=pCell[j].x+pCell[j].wn;
      pCell[j].xd	=pCell[j].xs+pCell[j].ws;
      pCell[j].xu	=pCell[j].xd+pCell[j].wd;

      i	=pj2i[j];
      if(pntT->ixP[i] >= 0){
	iw	=pntT->ixP[i]*wF-pCell[j].x;
	pCell[j].x	+=iw;
	pCell[j].xs	+=iw;
	pCell[j].xd	+=iw;
	pCell[j].xu	+=iw;
      }
      else{
	if(ix1 < pCell[j].x+pCell[j].w) ix1=pCell[j].x+pCell[j].w;
      }
      if(pntT->iyP[i] >= 0){
	pCell[j].y	=pntT->iyP[i]*(hF+1);
      }
      j++;
    }
    ix+=iw;
  }
  iw	=0;
  j	=nPC;
  ns	=0;
  for(jj= 0;jj<nL&&j<nPVC;jj++){
    iM	=pj2m[j];
    if(iM<0||pXCbM[iM].d==0){
      iw1	=pCell[j].w;
      ns	=1;
    }
    else{
      iw1	=pCell[j].w;
      j1	=j;
      do{
	j1++;
	k	=pj2m[j1];
	iw1+= pCell[j1].w;
      }while(pXCbM[k].d);
      if(ns==1&&jj){
	j2	=j-1;
	iw2	=pCell[j2].w;
	j1	=j;
	while(iw2<=iw1-pCell[j1].w){
	  iw2+= pCell[j1].w;
	  iw1-= pCell[j1].w;
	  ns--;
	  j1++;
	}
	if(iw1<iw2){
	  iw1	=iw2;
	}
      }
      ns	=pXCbM[iM].d+1;
      j		+= pXCbM[iM].d;
    }

    i	=pj2i[j]-nP;
    if(iw < iw1 && pntT->ixV[i] < 0) iw=iw1;
    j++;
  }
  ix1	+=iw;
/******/
#ifdef H
#endif
  nd	=hF+1;
  j	=nPC;
  ns	=0;
  for(jj=0; jj < nL && j < nPVC; jj++){
    iM	=pj2m[j];
    if(iM < 0 || pXCbM[iM].d == 0){
      ns	=1;
    }
    else{
      iw1	=pCell[j].w;
      j1	=j;
      do{
	j1++;
	k	=pj2m[j1];
	iw1	+=pCell[j1].w;
      }while(pXCbM[k].d);
      if(ns == 1 && jj){
	j2	=j-1;
	iw2	=pCell[j2].w;
	pCell[j2].x	=ix1-pCell[j2].w;
/******/
#ifdef H
	pCell[j2].x	=ix1;
#endif

	pCell[j2].xs	=pCell[j2].x+pCell[j2].wn;
	pCell[j2].xd	=pCell[j2].xs+pCell[j2].ws;
	pCell[j2].xu	=pCell[j2].xd+pCell[j2].wd;
	j1	=j;
	while(iw2<=iw1-pCell[j1].w){
	  iw2+= pCell[j1].w;
	  iw1-= pCell[j1].w;
	  ns--;
	  j1++;
	}
	if(iw1<iw2){
	  iw1	=iw2;
	}
	iw2	=0;
	while(j<j1){
	  pCell[j].y	=pCell[j2].y;
	  pCell[j].x	=ix1-iw+iw2;
	  pCell[j].xs	=pCell[j].x+pCell[j].wn;
	  pCell[j].xd	=pCell[j].xs+pCell[j].ws;
	  pCell[j].xu	=pCell[j].xd+pCell[j].wd;
	  iw2+= pCell[j].w;
	  j++;
	}
      }
      iw2	=0;
      while(pXCbM[pj2m[j]].d){
	pCell[j].y	=nd;
	pCell[j].x	=ix1-iw+iw2;
	pCell[j].xs	=pCell[j].x+pCell[j].wn;
	pCell[j].xd	=pCell[j].xs+pCell[j].ws;
	pCell[j].xu	=pCell[j].xd+pCell[j].wd;
	iw2+= pCell[j].w;
	j++;
      }
      ns	=pXCbM[iM].d+1;
    }
    pCell[j].y	=nd;
    pCell[j].x	=ix1-pCell[j].w;
/******/
#ifdef H
    pCell[j].x	=ix1;
#endif

    pCell[j].xs	=pCell[j].x+pCell[j].wn;
    pCell[j].xd	=pCell[j].xs+pCell[j].ws;
    pCell[j].xu	=pCell[j].xd+pCell[j].wd;
    j++;
    nd	+=hF+1;
  }
  for(j=nPC; j < nPVC; j++){
    iM	=pj2m[j];
    if(iM < 0 || pXCbM[iM].d == 0){
      k	=pj2jv[j];
      iw1	=ix1;
      nd	=pCell[j].y;
/*****/
#ifdef H
      iw1	=pCell[j].x+pCell[j].w;
#endif
      for(k1=1; k1 < pj2nv[j]; k1++){
	pCell[k].y	=nd;
	pCell[k].x	=iw1;
	pCell[k].xs	=pCell[k].x+pCell[k].wn;
	pCell[k].xd	=pCell[k].xs+pCell[k].ws;
	pCell[k].xu	=pCell[k].xd+pCell[k].wd;
	iw1	+=pCell[k].w;
	k++;
      }
    }
  }
  n	=0;
  for(j=0; j < nPC; j++){
    iM	=pj2m[j];
    if(pCell[j].ids&16&&(iM<0||pXCbM[iM].d==0)){
      n++;
    }
  }
  if(nL> 1 && n%2){
    n--;
    printf("Warning:\n %s Table%c\n",pntT->Nm,7);
    printf("non-even number of parameters for 2D-plot\n\n");
  }

  n1	=0;
  for(j=nPC;j < nPVC; j++){
    iM	=pj2m[j];
    if(pCell[j].ids&16&&(iM<0||pXCbM[iM].d==0)){
      n	+=pj2nv[j];
      if(n1%2==0){
	k	=pj2nv[j];
      }
      else{
	k1	=pj2nv[j];
	if(k1 != k){
	  printf("Error:\n %s Table%c\n",pntT->Nm,7);
	  printf("unequal X-, Y- numbers of vector values for 2D-plot\n\n");
	}
      }
      n1++;
    }
  }
  if(nL > 1 && n%2){
    n--;
    printf("Warning:\n %s Table%c\n",pntT->Nm,7);
    printf("non-even number of vector values for 2D-plot\n\n");
  }
  if(nL > 1){
    n	/=2;
  }
  free(kx2j[iT]);
  Nkx[iT]=n;
  nkx	=n;
  kx2j[iT]	=(int*)malloc((4*nkx+2*NCell[iT]+na)*sizeof(int));
  ky2j[iT]	=kx2j[iT]+nkx;
  kx2p[iT]	=ky2j[iT]+nkx;
  ky2p[iT]	=kx2p[iT]+nkx;
  j2kx[iT]	=ky2p[iT]+nkx;
  j2ky[iT]	=j2kx[iT]+NCell[iT];
  va[iT]	=j2ky[iT]+NCell[iT];
  Nkx[iT]	 =n;

  for(j=0; j < na; j++){
    va[iT][j]	=0;
  }
  pntkx	=kx2j[iT];
  pntky	=ky2j[iT];
  pntjx	=j2kx[iT];
  pntjy	=j2ky[iT];
  n	=0;
  n1	=0;
  for(j= 0;j<nPC;j++){
    iM	=pj2m[j];
    if(pCell[j].ids&16&&(iM<0||pXCbM[iM].d==0)){
      if(nL==1){
	pntkx[n]	=j;
	pntjx[j]	=n;
	pntky[n]	=0;
	pntjy[j]	=0;
      }
      else{
	n1	=n/2;
	if(n%2==0){
	  pntkx[n1]	=j;
	  pntjx[j]	=n1;
	  pntjy[j]	=n1;
	}
	else{
	  pntjx[j]	=n1;
	  pntky[n1]	=j;
	  pntjy[j]	=n1;
	}
      }
      n++;
    }
    else{
      pntjx[j]	=-1;
      pntjy[j]	=-1;
    }
  }
  if(nL>1){
    n/=2;
  }
  n1	=0;
  for(j	=nPC;j<nPVC;j++){
    iM	=pj2m[j];
    if(iM<0||pXCbM[iM].d==0){
      ns	=pCell[j].ids&16;
      if(nL==1){
	if(ns){
	  pntkx[n]	=j;
	  pntky[n]	=0;
	  pntjx[j]	=n;
	  pntjy[j]	=0;
	  n++;
	}
	else{
	  pntjx[j]	=-1;
	  pntjy[j]	=-1;
	}
	k	=pj2jv[j];
	for(k1	=1;k1<pj2nv[j];k1++){
	  if(ns){
	    pntkx[n]	=k;
	    pntky[n]	=0;
	    pntjx[k]	=n;
	    pntjy[k]	=0;
	    n++;
	  }
	  else{
	    pntjx[k]	=-1;
	    pntjy[k]	=-1;
	  }
	  k++;
	}
      }
      else{
	if(n1%2==0){
	  if(ns){
	    pntkx[n]	=j;
	    pntjx[j]	=n;
	    pntjy[j]	=n;
	    n++;
	  }
	  else{
	    pntjx[j]	=-1;
	    pntjy[j]	=-1;
	  }
	  k	=pj2jv[j];
	  for(k1= 1;k1<pj2nv[j];k1++){
	    if(ns){
	      pntkx[n]	=k;
	      pntjx[k]	=n;
	      pntjy[k]	=n;
	      n++;
	    }
	    else{
	      pntjx[k]	=-1;
	      pntjy[k]	=-1;
	    }
	    k++;
	  }
	  if(ns)
	    n-= pj2nv[j];
	}
	else{
	  if(ns){
	    pntky[n]	=j;
	    pntjx[j]	=n;
	    pntjy[j]	=n;
	    n++;
	  }
	  else{
	    pntjx[j]	=-1;
	    pntjy[j]	=-1;
	  }
	  k	=pj2jv[j];
	  for(k1= 1;k1<pj2nv[j];k1++){
	    if(ns){
	      pntky[n]	=k;
	      pntjx[k]	=n;
	      pntjy[k]	=n;
	      n++;
	    }
	    else{
	      pntjx[k]	=-1;
	      pntjy[k]	=-1;
	    }
	    k++;
	  }
	}
      }
      if(ns)
	n1++;
    }
    else{
      pntjx[j]	=-1;
      pntjy[j]	=-1;
    }
  }

#ifndef MULTI
  return(0);
#endif

#ifdef H
  for(j=0; j < nPC; j++){
    i	=pj2i[j];
    if(pntT->ixP[i] >= 0){
      iw	=pntT->ixP[i]*wF-pCell[j].x;
      pCell[j].x	+=iw;
      pCell[j].xs	+=iw;
      pCell[j].xd	+=iw;
      pCell[j].xu	+=iw;
    }
    if(pntT->iyP[i] >= 0){
      pCell[j].y	=pntT->iyP[i]*(hF+1);
    }
  }
#endif

  for(j=nPC; j < nPVC; j++){
    i	=pj2i[j]-nP;
    if(pntT->ixV[i] >= 0){
      iw	=pntT->ixV[i]*wF-pCell[j].x;
      pCell[j].x	+=iw;
      pCell[j].xs	+=iw;
      pCell[j].xd	+=iw;
      pCell[j].xu	+=iw;
      iM	=pj2m[j];
      if(iM < 0 || pXCbM[iM].d == 0){
	k	=pj2jv[j];
	for(k1=1 ; k1 <pj2nv[j]; k1++){
	  pCell[k].x	+=iw;
	  pCell[k].xs	+=iw;
	  pCell[k].xd	+=iw;
	  pCell[k].xu	+=iw;
	  k++;
	}
      }
    }
    if(pntT->iyV[i] >= 0){
      if(pntT->nL < pntT->iyV[i]) pntT->nL=pntT->iyV[i];
      iw	=pntT->iyV[i]*(hF+1);
      pCell[j].y	=iw;
      iM	=pj2m[j];
      if(iM < 0 || pXCbM[iM].d == 0){
	k	=pj2jv[j];
	for(k1=1 ; k1 <pj2nv[j]; k1++){
	  pCell[k].y	=iw;
	  k++;
	}
      }
    }
  }
  return(0);
}

int XCbInitTableMenus(int iT)
{
  int i,iv,ii,j,k,im,imm,nM,nXM;

  pi2j	=i2j[iT];
  pi2c	=i2c[iT];
  pntT	=Tbl+iT;
  nP	=pntT->NP;
  nV	=pntT->NNmV;
  nPV	=nP+nV;

  nM	=0;
  j	=0;
  i	=0;
  im	=0;
  imm	=0;
  while(i < nP){
    pi2c[i]	=9;
    if((pntT->iCP[i]&8)){
      if(pntT->nP[i]){
	if(pntT->nmP[i] == NULL){
	  im++;
	}
	else{
	  if(imm < im){
	    imm	=im;
	  }
	  im	=0;
	}
	nM++;
      }
    }
    else{
      if(pntT->nP[i]){
	j++;
      }
    }
    i++;
  }
  iv	=0;
  im	=0;
  imm	=0;
  while(i < nPV){
    pi2c[i]	=9;
    if((pntT->iCV[iv]&8)){
      if(pntT->nNmV[iv]){
	if(pntT->nmV[iv] == NULL){
	  im++;
	}
	else{
	  if(imm < im){
	    imm	=im;
	  }
	  im	=0;
	}
	nM++;
      }
    }
    else{
      if(pntT->nNmV[iv]){
	j++;
      }
    }
    i++;
    iv++;
  }
  nXCbM[iT]	=nM;
  nXM	=nM;

  XCbM[iT]	=nXM ? (XCbMenu*)malloc(nXM*sizeof(XCbMenu)) : NULL;
  pXCbM		=nXM ? XCbM[iT] : NULL;
  imm++;
  if(NM <= imm){
    NM	=imm;
    mM	=(int*)realloc((void*)mM,2*NM*sizeof(int));
    mJ	=mM+NM;
  }
  nPC	=pntT->NPC;
  nVC	=pntT->NNmVC;
  nPVC	=nPC+nVC;
  pj2i	=j2i[iT];
  pj2m	=j2m[iT];
  pj2jv	=j2jv[iT];
  pj2nv	=j2nv[iT];
  nM	=0;
  i	=0;
  im	=0;
  imm	=0;
  j	=0;
  while(i < nP){
    if((pntT->iCP[i]&8)){
      if(pntT->nP[i]){
	pXCbM[nM].n	=pntT->nP[i];
	pXCbM[nM].i	=0;
	pXCbM[nM].p	=(int*)malloc(pXCbM[nM].n*sizeof(int));
	if(pntT->nmP[i] == NULL){
	  pXCbM[nM].d	=1;
	  pXCbM[nM].m	=(int*)malloc(pXCbM[nM].n*sizeof(int));
	}
	else{
	  pXCbM[nM].d	=0;
	  pXCbM[nM].m	=NULL;
	}
	mM[im]	=nM;
	nM++;
	k	=mM[im];
	im++;
	if(imm < im){
	  mJ[im-1]	=j;
	  pj2i[j]	=i;
	  pj2m[j]	=k;
	  j++;
	  imm	=im;
	}
      }
    }
    if(im){
      ii	=pXCbM[k].i;
      pXCbM[k].p[ii]	=i;
      pi2j[i]	=mJ[im-1];
      if(pXCbM[k].d){
	pXCbM[k].m[ii]	=nM;
      }
      else{
	while(im&&++pXCbM[k].i>=pXCbM[k].n){
	  pXCbM[k].d	=imm-im;
	  im--;
	  pXCbM[k].j	=mJ[im];
	  if(im){
	    k	=mM[im-1];
	  }
	}
	if(im==0){
	  imm	=0;
	}
      }
    }
    else{
      pi2j[i]	=j;
      pj2i[j]	=i;
      pj2m[j]	=-1;
      j++;
    }
    i++;
  }
  iv	=0;
  im	=0;
  imm	=0;
  while(i < nPV){
    if((pntT->iCV[iv]&8)){
      if(pntT->nNmV[iv]){
	pXCbM[nM].n	=pntT->nNmV[iv];
	pXCbM[nM].i	=0;
	pXCbM[nM].p	=(int*)malloc(pXCbM[nM].n*sizeof(int));
	if(pntT->nmV[iv] == NULL){
	  pXCbM[nM].d	=1;
	  pXCbM[nM].m	=(int*)malloc(pXCbM[nM].n*sizeof(int));
	}
	else{
	  pXCbM[nM].d	=0;
	  pXCbM[nM].m	=NULL;
	}
	mM[im]	=nM;
	nM++;
	k	=mM[im];
	im++;
	if(imm < im){
	  mJ[im-1]	=j;
	  pj2i[j]	=i;
	  pj2m[j]	=k;
	  j++;
	  imm	=im;
	}
      }
    }
    if(im){
      ii	=pXCbM[k].i;
      pXCbM[k].p[ii]	=i;
      pi2j[i]	=mJ[im-1];
      if(pXCbM[k].d){
	pXCbM[k].m[ii]	=nM;
      }
      else{
	while(im&&++pXCbM[k].i>=pXCbM[k].n){
	  pXCbM[k].d	=imm-im;
	  im--;
	  pXCbM[k].j	=mJ[im];
	  if(im){
	    k	=mM[im-1];
	  }
	}
	if(im==0){
	  imm	=0;
	}
      }
    }
    else{
      pi2j[i]	=j;
      pj2i[j]	=i;
      pj2m[j]	=-1;
      j++;
    }
    i++;
    iv++;
  }

  for(i=0; i < nXM;i++){
    pXCbM[i].Nm	=pntT->nmM[i];
    pXCbM[i].i	=0;
    pXCbM[i].iV	=0;
    pXCbM[i].mb	=nXM;
  }
  for(i=0; i < nXM; i++){
    if(pXCbM[i].d){
      for(j=0; j < pXCbM[i].n; j++){
	k	=pXCbM[i].m[j];
	pXCbM[k].mb	=i;
      }
    }
  }
  pntP	=Plt+iT;
  if(pntP->nP){
    for(i=0; i < nXM; i++){
      k	=i;
      while(pXCbM[k].d){
	k	=pXCbM[k].m[pXCbM[k].i];
      }
      pXCbM[i].iV	=pntP->mV[k]+pXCbM[k].i;
    }
  }
  return(0);
}

int XCbInitCellsMenus()
{
  int i,j;

  nXCbM	=(int*)malloc(nTbl*sizeof(int));
  XCbM	=(XCbMenu**)malloc(nTbl*sizeof(XCbMenu*));
  i2j	=(int**)malloc(2*nTbl*sizeof(int*));
  i2c	=i2j+nTbl;
  j2i	=(int**)malloc(11*nTbl*sizeof(int*));
  j2m	=j2i+nTbl;
  j2jv	=j2m+nTbl;
  j2nv	=j2jv+nTbl;
  kx2j	=j2nv+nTbl;
  ky2j	=kx2j+nTbl;
  kx2p	=ky2j+nTbl;
  ky2p	=kx2p+nTbl;
  j2kx	=ky2p+nTbl;
  j2ky	=j2kx+nTbl;
  va	=j2ky+nTbl;

  Cell	=(InputCell**)malloc(nTbl*sizeof(InputCell*));
  NCell	=(int*)malloc(4*nTbl*sizeof(int));
  iCell	=NCell+nTbl;
  xshTbl=iCell+nTbl;
  Nkx	=xshTbl+nTbl;
  Box	=(double***)malloc(nTbl*sizeof(double**));
  iBox	=(int***)malloc(nTbl*sizeof(int**));
  sBox	=(int**)malloc(nTbl*sizeof(int*));
  scPlot=(int*)malloc(nTbl*sizeof(int));

  nmv	=(char***)malloc(nTbl*sizeof(char**));
  ScInd	=(int**)malloc(nTbl*sizeof(int*));
  Nvi	=0;
  Nvd	=0;
  nLmx	=1;
  for(i=0; i < nTbl; i++){
    if(Tbl[i].SF != NULL){
      j		=Tbl[i].NP+Tbl[i].NNmV;
      i2j[i]	=(int*)malloc(2*j*sizeof(int));
      i2c[i]	=i2j[i]+j;
      j		=Tbl[i].NPC+Tbl[i].NNmVC;
      j2i[i]	=(int*)malloc(4*j*sizeof(int));
      j2m[i]	=j2i[i]+j;
      j2jv[i]	=j2m[i]+j;
      j2nv[i]	=j2jv[i]+j;
      pntT	=Tbl+i;

      j	=pntT->NNmV;
      if(j){
	Box[i]	=(double**)malloc(j*sizeof(double*));
	iBox[i]	=(int**)malloc(j*sizeof(int*));
	sBox[i]	=(int*)malloc(j*sizeof(int));
      }
      else{
	Box[i]	=NULL;
	iBox[i]	=NULL;
	sBox[i]	=NULL;
      }

      scPlot[i]	=2;
      nmv[i]	=(char**)malloc(Tbl[i].nL*sizeof(char*));
      for(j=0; j < Tbl[i].nL; j++){
	nmv[i][j]	=NULL;
      }
      ScInd[i]	=(int*)malloc(Tbl[i].nL*sizeof(int));

      xshTbl[i]	=0;
      iCell[i]	=0;
      if(nLmx < pntT->nL){
	nLmx	=pntT->nL;
      }
      for(j=0; j < pntT->NNmV; j++){
	Box[i][j]	=(double*)malloc(2*sizeof(double));
	iBox[i][j]	=(int*)malloc(2*sizeof(int));
	sBox[i][j]	=0;
	switch((pntT->iCV[j]&7)){
	case 1:
	case 3:
	  if(Nvd < pntT->lV[j]){
	    Nvd	=pntT->lV[j];
	  }
	  break;
	case 2:
	case 4:
	case 5:
	  if(Nvi < pntT->lV[j]){
	    Nvi	=pntT->lV[j];
	  }
	  break;
	default:
	  break;
	}
      }
    }
  }

  NM	=8;
  mM	=(int*)malloc(2*NM*sizeof(int));
  mJ	=mM+NM;
  for(i=0; i < nTbl; i++){
    if(Tbl[i].SF != NULL) XCbInitTableMenus(i);
  }
  free(mM);
  {
    int ni,nd,iM;
    Nd	=0;
    Ni	=0;
    for(i=0;i < nTbl; i++){
      if(Tbl[i].SF != NULL){
	pntT	=Tbl+i;
	nPC	=pntT->NPC;
	pXCbM	=XCbM[i] != NULL ? XCbM[i] : NULL;
	pj2i	=j2i[i];
	pj2m	=j2m[i];
	nd	=0;
	ni	=0;
	for(j=0; j < nPC; j++){
	  iM	=pj2m[j];
	  if(iM < 0 || pXCbM[iM].d == 0){
	    switch((pntT->iCP[pj2i[j]]&7)){
	    case 1:
	    case 3:
	      nd++;
	      break;
	    case 2:
	    case 4:
	    case 5:
	      ni++;
	      break;
	    default:
	      break;
	    }
	  }
	}
	if(Nd < nd){
	  Nd	=nd;
	}
	if(Ni < ni){
	  Ni	=ni;
	}
      }
    }
  }
  if(Nd){
    pd	=(double*)malloc(2*Nd*sizeof(double));
    pd0	=pd+Nd;
  }else{
    pd	=NULL;
    pd0	=NULL;
  }
  if(Ni){
    pi	=(int*)malloc(2*Ni*sizeof(int));
    pi0	=pi+Ni;
  }else{
    pi	=NULL;
    pi0	=NULL;
  }
  if(nLmx){
    vd	=(double**)malloc(2*nLmx*sizeof(double*));
    vd0	=vd+nLmx;
    vi	=(int**)malloc(2*nLmx*sizeof(int*));
    vi0	=vi+nLmx;
  }else{
    vd	=NULL;
    vd0	=NULL;
    vi	=NULL;
    vi	=NULL;
  }
  for(j=0; j < nLmx; j++){
    if(Nvd){
      vd[j]	=(double*)malloc(2*Nvd*sizeof(double));
      vd0[j]	=vd[j]+Nvd;
    }else{
      vd[j]	=NULL;
      vd0[j]	=NULL;
    }
    if(Nvi){
      vi[j]	=(int*)malloc(2*Nvi*sizeof(int));
      vi0[j]	=vi[j]+Nvi;
    }else{
      vi[j]	=NULL;
      vi0[j]	=NULL;
    }
  }

  NL	=nLmx;
  NVecNm	=10;
  VecNm	=(CbVectorNm*)malloc(NVecNm*sizeof(CbVectorNm));
  for(i=0; i < nTbl; i++){
    if(Tbl[i].SF != NULL){
      XCbInitTableCells(i);
      XCbInitTblBox(i);
    }
  }
  free(VecNm);
  return(0);
}

int XCbReInitTblBox(int iT)
{
  int i,n;

  pntT	=Tbl+iT;
  for(i=0; i < pntT->NNmV; i++){
    if(pntT->iPV[i]){
      n	=pntT->lV[i]-2;
      switch((pntT->iCV[i]&7)){
      case 1:
      case 3:
	pntT->V[i][n]	=(char*)Box[iT][i];
	n++;
	pntT->V[i][n]	=(char*)(Box[iT][i]+1);
	break;
      case 2:
      case 4:
      case 5:
	pntT->V[i][n]	=(char*)iBox[iT][i];
	n++;
	pntT->V[i][n]	=(char*)(iBox[iT][i]+1);
	break;
      default:
	break;
      }
    }
  }
  return(0);
}

int XCbInitTblBox(int iT)
{
  int i;

  pntT	=Tbl+iT;
  for(i=0; i < pntT->NNmV; i++){
    Box[iT][i][0]	=0.;
    Box[iT][i][1]	=0.;
    iBox[iT][i][0]	=0;
    iBox[iT][i][1]	=0;
  }
  XCbReInitTblBox(iT);
  return(0);
}

int XCbReInitCellsMenus(int iT)
{
  int j,ni,nd,Fl;

  pntT	=Tbl+iT;

  xshTbl[iT]	=0;
  iCell[iT]	=0;
  ni	=0;
  nd	=0;
  for(j=0; j < pntT->NNmV; j++){
    sBox[iT][j]	=0;
    switch((pntT->iCV[j]&7)){
    case 1:
    case 3:
      if(nd < pntT->lV[j]){
	nd	=pntT->lV[j];
      }
      break;
    case 2:
    case 4:
    case 5:
      if(ni < pntT->lV[j]){
	ni	=pntT->lV[j];
      }
      break;
    default:
      break;
    }
  }

  Fl	=0;
  if(Nvd < nd){
    for(j=0; j < nLmx; j++){
      if(Nvd){
	free(vd[j]);
      }
      vd[j]	=(double*)malloc(2*nd*sizeof(double));
      vd0[j]	=vd[j]+nd;
    }
    Nvd	=nd;
    Fl	|=1;
  }
  if(Nvi < ni){
    for(j=0; j < nLmx; j++){
      if(Nvi){
	free(vi[j]);
      }
      vi[j]	=(int*)malloc(2*ni*sizeof(int));
      vi0[j]	=vi[j]+ni;
    }
    Nvi	=ni;
    Fl	|=2;
  }
  NVecNm=10;
  VecNm	=(CbVectorNm*)malloc(NVecNm*sizeof(CbVectorNm));

  if(Fl){
    for(ni=0; ni < nTbl; ni++){
      if(Tbl[ni].SF != NULL){
	XCbReInitTableCells(ni);
	XCbReInitTblBox(ni);
      }
    }
  }
  else{
    XCbReInitTableCells(iT);
  }
  free(VecNm);
  XCbReInitTblBox(iT);
  return(0);
}

int XCbSetInitialPointer2CP(int IB,int*nPnCells,int*nIdCells)
{
  BLB*pntB;
  int i,iM,nM,iS,nS,iB,nB,kB,n,iC,iD,jCB,jCM;

  pntB= blb+IB;
  iC= *nPnCells;
  iD= *nIdCells;
  jCB= iC;
  pntB->jCB= iC;
  kCPCell[iC]= iC;
  iC++;
  pntB->jDB= iD;
  kIDCell[iD]= iD;
  iD++;

  nM= pntB->nM;
  if(pntB->xM>=nM)
    pntB->xM= 0;
  for(iM= 0;iM<nM;iM++){
    nS= pntB->nS[iM];
    nB= pntB->nB[iM];
    n= nS+nB;
    iB= 0;
    iS= 0;
    i= 0;
    if(nB)
      kB= pntB->kB[iM][iB];
    jCM= iC;
    pntB->jCM[iM]= jCM;
    kCPCell[iC]= iC;
    iC++;
    while(i<n){
      if(iB<nB&&i==kB){
	XCbSetInitialPointer2CP(pntB->nxtB[iM][iB],&iC,&iD);
	iB++;
	if(iB<nB)
	  kB= pntB->kB[iM][iB];
      }
      else{
	if(iS<nS){
	  pntB->jCS[iM][iS]= iC;
	  kCPCell[iC]= iC;
	  iC++;
	  iS++;
	}
      }
      i++;
    }
  }
  *nPnCells= iC;
  *nIdCells= iD;
  return(0);
}

int XCbSetCPanelCells(int IB,int IR,int*ix0,int*iy0,int*nPnCells,
		      int*nIDCells)
{
  BLB*pntB;
  int i,iM,nM,iS,nS,iB,nB,kB,n,iC,iD;
  int ix,iy,iw,ix2,iyM,ixM,ixM1,ixM2;
  int d;

  nR	=IR+1;
  pntB	=blb+IB;
  iC	=*nPnCells;
  iD	=*nIDCells;

  ix	=*ix0;
  iy	=*iy0;
  xB[IR]= ix;
  yB[IR]= iy;
  CPCell[iC].pn	=pntB->NmB;
  CPCell[iC].ln	=strlen(CPCell[iC].pn);
  CPCell[iC].pH	=pntB->HpB;
  CPCell[iC].ids=0;
  d	=pntB->dCb;
  CPCell[iC].d	=d;
  CPCell[iC].iB	=IB;
  CPCell[iC].iM	=-1;
  CPCell[iC].iS	=-1;
  CPCell[iC].s	=&(pntB->s);
  CPCell[iC].m	=&(pntB->mB);
  CPCell[iC].O	=&(pntB->OB);
  CPCell[iC].I	=&(pntB->IB);
  CPCell[iC].kW	=0;
  CPCell[iC].kO	=0;
  CPCell[iC].kI	=0;
  CPCell[iC].pW	=BlbInpFNmW[IB];
  CPCell[iC].pO	=BlbInpFNmO[IB];
  CPCell[iC].pI	=BlbInpFNmI[IB];
  CPCell[iC].w	=(CPCell[iC].ln+1)*wF-2;
  CPCell[iC].x	=ix;
  CPCell[iC].y	=iy;
  if(*pntB->OD != '\0'){
    IDCell[iD].pn	=pntB->ID;
    IDCell[iD].ps	=(char*)BlbInpFNmD[IB];
    IDCell[iD].ps0	=IDCell[iD].ps;
    IDCell[iD].vs	=kBlbInpDir+IB;
    IDCell[iD].ids	=0;
    IDCell[iD].l	=LBLBID;
    IDCell[iD].pv	=pntB->OD;
    IDCell[iD].pH	=IB ? " - base-name of files for I/O " :
      " - base-name of directory for I/O ";
    IDCell[iD].pH	=pntB->pathI;
  }
  else{
    IDCell[iD].pn	="ID1";
    IDCell[iD].ln	=0;
    IDCell[iD].ids	=1;
    IDCell[iD].l	=5;
    IDCell[iD].pv	=(char*)pntB->t;
    IDCell[iD].pH	=" Cycle parameters";
  }
  IDCell[iD].c	=iC;
  IDCell[iD].lu	=IB;
  IDCell[iD].h	=0;
  IDCell[iD].y	=iy;
  IDCell[iD].x	=CPCell[iC].x+CPCell[iC].w+10*wF+14;
  IDCell[iD].w	=wID;
  IDCell[iD].il	=IDCell[iD].l-1;
  iD++;

  ixM1	=ix+CPCell[iC].w+wU;
  ixM2	=ixM1+wID+2;
  iy	+=ih;
  iC++;

  nM	=pntB->nM;
  if(pntB->xM >= nM) pntB->xM	=0;
  ixM	=ix+2*wF;
  *iy0	=iy;
  iyM	=iy;
  for(iM=0; iM < nM; iM++){
    ix	=ixM;
    iy	=iyM;
    CPCell[iC].pn	=pntB->NmM[iM];
    CPCell[iC].ln	=strlen(CPCell[iC].pn);
    CPCell[iC].pH	=pntB->HpM[iM];
    CPCell[iC].ids	=1;
    CPCell[iC].d	=d;
    CPCell[iC].iB	=IB;
    CPCell[iC].iM	=pntB->kM[iM];	/*Index in the ID List*/
    CPCell[iC].iS	=-2;
    CPCell[iC].xM	=&(pntB->xM);
    CPCell[iC].m	=&(pntB->mM[iM]);
    CPCell[iC].O	=&(pntB->OM[iM]);
    CPCell[iC].I	=&(pntB->IM[iM]);
    CPCell[iC].w	=(CPCell[iC].ln+1)*wF-2;
    CPCell[iC].kW	=0;
    CPCell[iC].kO	=0;
    CPCell[iC].kI	=0;
    CPCell[iC].pW	=MzlInpFNmW[IB][iM];
    CPCell[iC].pO	=MzlInpFNmO[IB][iM];
    CPCell[iC].pI	=MzlInpFNmI[IB][iM];
    CPCell[iC].x	=ix;
    CPCell[iC].y	=iy;
    iw	=ix+CPCell[iC].w+wU;
    if(ixM1 < iw) ixM1	=iw;
    iy	+=ih;
    iC++;

    nS	=pntB->nS[iM];
    nB	=pntB->nB[iM];
    n	=nS+nB;
    iB	=0;
    iS	=0;
    i	=0;
    if(nB) kB	=pntB->kB[iM][iB];
    while(i < n){
      if(iB < nB && i == kB){
	ix2	=ix;
	XCbSetCPanelCells(pntB->nxtB[iM][iB],nR,&ix2,&iy,&iC,&iD);
	if(ixM1 < ix2) ixM1	=ix2;
	iB++;
	if(iB < nB) kB	=pntB->kB[iM][iB];
      }
      else{
	if(iS < nS){
	  CPCell[iC].pn	=pntB->NmS[iM][iS];
	  CPCell[iC].ln	=strlen(CPCell[iC].pn);
	  CPCell[iC].pH	=pntB->HpS[iM][iS];
	  CPCell[iC].ids=2;
	  CPCell[iC].d	=d;
	  CPCell[iC].iB	=IB;
	  CPCell[iC].iM	=pntB->kM[iM];	/*Index in the ID List*/
	  CPCell[iC].iS	=iS;
	  CPCell[iC].m	=&(pntB->mS[iM][iS]);
	  CPCell[iC].O	=&(pntB->OS[iM][iS]);
	  CPCell[iC].I	=&(pntB->IS[iM][iS]);
	  CPCell[iC].kW	=0;
	  CPCell[iC].kO	=0;
	  CPCell[iC].kI	=0;
	  CPCell[iC].pW	=StgInpFNmW[IB][iM][iS];
	  CPCell[iC].pO	=StgInpFNmO[IB][iM][iS];
	  CPCell[iC].pI	=StgInpFNmI[IB][iM][iS];
	  CPCell[iC].w	=(CPCell[iC].ln+1)*wF-2;
	  CPCell[iC].x	=ix;
	  CPCell[iC].y	=iy;
	  iw	=ix+CPCell[iC].w+wU;
	  if(ixM1<iw) ixM1=iw;
	  iy +=ih;
	  iC++;
	  iS++;
	}
      }
      i++;

    }
    ixM	=ixM1;
    if(*iy0<iy) *iy0	=iy;
  }
  ixM	=ixM1>ixM2?ixM1:ixM2;
  *ix0	=ixM+2;
  *nPnCells	=iC;
  *nIDCells	=iD;
  wB[IR]	=ixM+1-xB[IR];
  hB[IR]	=(*iy0)-yB[IR];

  return(0);
}

int XCbAlignCPanelCells()
{
  BLB*pntB;
  int iM,nM,iS,nS,iB,iC;
  int iw;

  for(iB= 0;iB<nblb;iB++){
    pntB= blb+iB;
    nM= pntB->nM;
    for(iM= 0;iM<nM;iM++){
      iC= pntB->jCM[iM];
      iw= CPCell[iC].w;
      nS= pntB->nS[iM];
      for(iS= 0;iS<nS;iS++){
	iC= pntB->jCS[iM][iS];
	if(iw<CPCell[iC].w)
	  iw= CPCell[iC].w;
      }
      CPCell[pntB->jCM[iM]].w= iw;
      nS= pntB->nS[iM];
      for(iS= 0;iS<nS;iS++){
	CPCell[pntB->jCS[iM][iS]].w= iw;
      }
    }
  }
  return(0);
}

int XCbInitCntrPanel()
{
  int i,ix0,iy0;
  CPCell= (PanelCell*)malloc(nCbB*sizeof(PanelCell));
  kCPCell= (int*)malloc(nCbB*sizeof(int));
  IDCell= (InputCell*)malloc(nblb*sizeof(InputCell));
  kIDCell= (int*)malloc(nblb*sizeof(int));

  for(i=0;i < nCbB;i++) kCPCell[i]=i;
  for(i=0;i < nblb;i++) kIDCell[i]=i;

  xB=(int*)malloc(4*nblb*sizeof(int));
  wB=xB+nblb;
  yB=wB+nblb;
  hB=yB+nblb;

  wU=10*wF+12;
  wID=LBLBID*wF+3;
  ih=hF;

  nCPCell=0;
  nIDCell=0;
  XCbSetInitialPointer2CP(0,&nCPCell,&nIDCell);
  nCPCell=0;
  nIDCell=0;
  ix0=1;
  iy0=5*hF;
  XCbSetCPanelCells(0,0,&ix0,&iy0,&nCPCell,&nIDCell);
  XCbAlignCPanelCells();
  XCbInitXCPCell(CPCell,kCPCell,&nCPCell,IDCell,kIDCell,&nIDCell);
  return(0);
}

void XCbDeInitCellsMenus()
{
  int i,j;

  for(j=0; j < nLmx; j++){
    if(vd[j] != NULL) free(vd[j]);
    if(vi[j] != NULL) free(vi[j]);
  }
  if(vd != NULL) free(vd);
  if(vi != NULL) free(vi);
  if(pd != NULL) free(pd);
  if(pi != NULL) free(pi);
  for(i=0; i < nTbl; i++){
    if(Tbl[i].SF != NULL){
      for(j=0; j < nXCbM[i]; j++){
	free(XCbM[i][j].p);
	if(XCbM[i][j].d) free(XCbM[i][j].m);
      }
      free(Cell[i]);
      free(i2j[i]);
      free(j2i[i]);
      if(XCbM[i] != NULL) free(XCbM[i]);
      free(kx2j[i]);
      for(j=0; j < Tbl[i].nL; j++){
	if(nmv[i][j] != NULL) free(nmv[i][j]);
      }
      free(ScInd[i]);
      free(nmv[i]);
      for(j=0; j < Tbl[i].NNmV; j++){
	free(iBox[i][j]);
	free(Box[i][j]);
      }
      if(Tbl[i].NNmV){
	free(sBox[i]);
	free(iBox[i]);
	free(Box[i]);
      }
    }
  }

  free(Cell);
  free(NCell);
  free(j2i);
  free(i2j);
  free(ScInd);
  free(nmv);
  free(sBox);
  free(iBox);
  free(Box);
  free(nXCbM);
  free(XCbM);
}

int XCbWriteXCustomization()
{
  extern char **ColorNames,*ColorNames1[];

  sprintf(NmF,"Out/%s.Xrc",blb[0].NmB);

  fp	=fopen(NmF,"w");
  if(fp != NULL){
    fprintf(fp,"X-font: %dx%d # choose from 7x13 6x12 6x10 5x8 8x13 9x15\n"
	    ,wF,hF);
#ifdef H
    fprintf(fp,"Help-font: %dx%d # choose from 7x13 6x12 6x10 5x8 8x13 9x15\n"
	    ,wFHelp,hFHelp);
#endif

    fprintf(fp,"Help-font: %dx%d # choose from "
	    "7x8 7x10 7x11 7x12 7x14 17x7 7x18 7x20 7x24 7x25 7x34\n"
	    "the first digit is ignored\n"
	    ,wFHelp,hFHelp);
    if(ColorNames == ColorNames1){
      fprintf(fp,"ColorMap:0 # choose from 0 1\n");
    }
    else{
      fprintf(fp,"ColorMap:1 # choose from 0 1\n");
    }
    fclose(fp);
    printf("X-Window customization file %s\n",NmF);
    printf("has been written by the CodeBuilder\n");
    printf("Inspect, edit and move it: mv %s In/\n",NmF);
  }
  return(0);
}

int XCbReadXCustomization()
{
  int wFi,hFi,iCmp;
  extern char **ColorNames,*ColorNames1[],*ColorNames2[];

  sprintf(NmF,"In/%s.Xrc",blb[0].NmB);
  iCmp	=0;
  fp	=fopen(NmF,"r");
  if(fp != NULL){
    while(feof(fp) == 0){
      if(fgets(ln,80,fp) == NULL) break;
      if(*ln == 'X'){
	if(sscanf(ln,"X-font:%dx%d",&wFi,&hFi) > 1){
	  wF	=wFi;
	  hF	=hFi;
	}
      }else if(*ln == 'H'){
	if(sscanf(ln,"Help-font:%dx%d",&wFi,&hFi) > 1){
	  wFHelp	=wFi;
	  hFHelp	=hFi;
	}
      }else if(*ln == 'C'){
	sscanf(ln,"ColorMap:%d",&iCmp);
      }
    }
    ColorNames	= iCmp == 0 ? ColorNames1 : ColorNames2;
    fclose(fp);
    return(0);
  }
  ColorNames	=ColorNames1;
  return(1);
}

int XCbSwitchColorMap()
{
  extern char **ColorNames,*ColorNames1[],*ColorNames2[];

  ColorNames	=ColorNames == ColorNames1 ? ColorNames2 : ColorNames1;

  XCbSpecifyColors();
  return(0);
}

int XCbInitX()
{
  int i,j;
  
  CbExchangeBLB(&nblb,&blb,&nCbB);
  CbExchangeInpList(&kBlbInpDir,&BlbInpFNmD,&BlbInpFNmW,
		    &BlbInpFNmO,&BlbInpFNmI,
		    &MzlInpFNmW,&MzlInpFNmO,&MzlInpFNmI,
		    &StgInpFNmW,&StgInpFNmO,&StgInpFNmI);
#ifdef H
  CbPrintBlbContent(0);
#endif
  CbExchangeTbl(&nTbl,&Tbl,&Plt,&Rng);
  if(XCbReadXCustomization()) XCbWriteXCustomization();
  ih3	=hF-3;
  XCbGetPlotLayoutAddress(&p0,&p1,&p2,&p3,&p4,&p5,&p6,&p7);
  XCbInitCellsMenus();
  XCbInitTblPlotAddress(p0,p1,p2,p3,p4,p5,p6,p7);

  FlPSopen	=(int*)calloc(3*nTbl,sizeof(int));
  FigCnt	=FlPSopen+nTbl;
  PageCnt	=FigCnt+nTbl;
  PSFilePos	=(long*)calloc(nTbl,sizeof(long));
  PageNames	=(char**)malloc(nTbl*sizeof(char*));
  FlSc		=(int*)malloc(2*nTbl*sizeof(int));
  FlReadTbl	=FlSc+nTbl;
  Xg_0	=(double*)malloc(8*nTbl*sizeof(double));
  Yg_0	=Xg_0+nTbl;
  Xmin	=Yg_0+nTbl;
  Ymin	=Xmin+nTbl;
  Xmax	=Ymin+nTbl;
  Ymax	=Xmax+nTbl;
  Sx	=Ymax+nTbl;
  Sy	=Sx+nTbl;
  
  j	=2;
  for(i=0; i < nTbl; i++){
    FlSc[i]	=0;
    FlReadTbl[i]	=1;
    PageNames[i]	=(char*)malloc(80*sizeof(char));
    if(Tbl[i].Nm != NULL){
      strcpy(PageNames[i],Tbl[i].Nm);
      if(j < Tbl[i].W+1) j=Tbl[i].W+1;
    }
    else{
      PageNames[i][0]	='\0';
    }
  }
  iHelpW	=j;
  XInitWin(j,blb[0].NmB);
  XCbInitCntrPanel();
  return(0);
}

int XCbDeInitCntrPanel()
{
  free(xB);
  free(kIDCell);
  free(IDCell);
  free(kCPCell);
  free(CPCell);
  return(0);
}

int XCbDeInitX()
{
  int i;
  extern int (*CbUserExit)(void);

  if(CbUserExit != NULL){
    CbUserExit();
    CbUserExit=NULL;
  }
  XCbDeInitCntrPanel();
  XDeInitWin();
  for(i=0; i < nTbl; i++) free(PageNames[i]);
  free(Xg_0);
  free(FlSc);
  free(PageNames);
  free(PSFilePos);
  free(FlPSopen);
  XCbDeInitCellsMenus();
  return(0);
}

int XCbSetPointer2CP(int IB,int St,int*nPnCells,int*nIdCells)
{
  BLB*pntB;
  int i,iM,iM0,iM1,nM,iS,nS,iB,nB,kB,n,iC,iD,iCB,iCM;
  int State;

  State	=St;
  pntB	=blb+IB;
  iC	=*nPnCells;
  iD	=*nIdCells;
  iCB	=iC;
  pntB->iCB	=iC;
  if(State==0){
    kCPCell[iC]= pntB->jCB;
    iC++;
    kIDCell[iD]= pntB->jDB;
    iD++;
  }

  nM= pntB->nM;
  if(pntB->xM>=nM)
    pntB->xM= 0;
  switch(pntB->s){
  case 0:
    iM0= 0;
    iM1= nM;
    break;
  case 1:
    iM0= pntB->xM;
    iM1= iM0+1;
    break;
  case 2:
    iM0= 0;
    iM1= 0;
    break;
  }
#ifdef H
  iM0= 0;
  iM1= nM;
#endif
  for(iM= 0;iM<nM;iM++){
    nS= pntB->nS[iM];
    nB= pntB->nB[iM];
    n= nS+nB;
    iB= 0;
    iS= 0;
    i= 0;
    if(nB)
      kB= pntB->kB[iM][iB];
    if(St||iM<iM0||iM>=iM1){
      iCM= iCB;
      State= 1;
    }
    else{
      iCM= iC;
      State= 0;
      kCPCell[iC]= pntB->jCM[iM];
      iC++;
    }
    pntB->iCM[iM]= iCM;
    while(i<n){
      if(iB<nB&&i==kB){
	if(State)
	  XCbSetPointer2CP(pntB->nxtB[iM][iB],State,&iCM,&iD);
	else
	  XCbSetPointer2CP(pntB->nxtB[iM][iB],State,&iC,&iD);
	iB++;
	if(iB<nB)
	  kB= pntB->kB[iM][iB];
      }
      else{
	if(iS<nS){
	  if(State){
	    pntB->iCS[iM][iS]= iCM;
	  }
	  else{
	    pntB->iCS[iM][iS]= iC;
	    kCPCell[iC]= pntB->jCS[iM][iS];
	    iC++;
	  }
	  iS++;
	}
      }
      i++;
    }
  }
  *nPnCells= iC;
  *nIdCells= iD;
  return(0);
}

#ifdef H
int XCbReInitCntrPanel0()
{
  int i,ix0,iy0;

  nCPCell= 0;
  nIDCell= 0;
  XCbSetPointer2CP(0,0,&nCPCell,&nIDCell);
  for(i=0; i < nCPCell;i++) kCPCell[i]= i;
  for(i=0; i < nIDCell;i++) kIDCell[i]= i;
  ix0= 1;
  iy0= 5*hF;
  nCPCell= 0;
  nIDCell= 0;
  XCbReInitCntrPanelBlock(0,0,&ix0,&iy0,&nCPCell,&nIDCell);
  return(0);
}
#endif

int XCbRePointCPCell(IB,IR,ix0,iy0,nPnCells,nIDCells)
     int IB,IR,*ix0,*iy0,*nPnCells,*nIDCells;
{
  BLB*pntB;
  int i,iM,iM0,iM1,nM,iS,nS,iB,nB,kB,n,iC,iD,kC,kD;
  int ix,iy,iw,ix2,iyM,ixM,ixM1,ixM2;

  nR= IR+1;
  pntB= blb+IB;
  iC= *nPnCells;
  kC= kCPCell[iC];
  iD= *nIDCells;

  ix	=*ix0;
  iy	=*iy0;
  xB[IR]=ix;
  yB[IR]=iy;

  CPCell[kC].x= ix;
  CPCell[kC].y= iy;
  kD= kIDCell[iD];
  IDCell[kD].y= iy;
  IDCell[kD].x= CPCell[kC].x+CPCell[kC].w+10*wF+14;
  iD++;

  ixM1= ix+CPCell[kC].w+wU;
  ixM2= ixM1+wID+2;
  iy+= ih;
  iC++;

  nM	=pntB->nM;
  if(pntB->xM>=nM) pntB->xM=0;
  ixM	=ix+2*wF;
  *iy0	=iy;
  iyM	=iy;
  switch(pntB->s){
  case 0:
    iM0=0;
    iM1=nM;
    break;
  case 1:
    iM0=pntB->xM;
    iM1=iM0+1;
    if(iM1 > nM) iM1=nM;
    break;
  case 2:
    iM0=0;
    iM1=0;
    break;
  }
  for(iM=iM0;iM<iM1;iM++){
    ix= ixM;
    iy= iyM;
    kC= kCPCell[iC];
    CPCell[kC].x= ix;
    CPCell[kC].y= iy;
    iw= ix+CPCell[kC].w+wU;
    if(ixM1<iw) ixM1= iw;
    iy+= ih;
    iC++;
    nS= pntB->nS[iM];
    nB= pntB->nB[iM];
    n= nS+nB;
    iB= 0;
    iS= 0;
    i= 0;
    if(nB)
      kB= pntB->kB[iM][iB];
    while(i<n){
      if(iB<nB&&i==kB){
	ix2= ix;
	XCbRePointCPCell(pntB->nxtB[iM][iB],nR,&ix2,&iy,&iC,&iD);
#ifdef H
	ix2+= wF;
#endif
	if(ixM1<ix2)
	  ixM1= ix2;
	iB++;
	if(iB<nB)
	  kB= pntB->kB[iM][iB];
      }
      else{
	if(iS<nS){
	  kC= kCPCell[iC];
	  CPCell[kC].x= ix;
	  CPCell[kC].y= iy;
	  iw= ix+CPCell[kC].w+wU;
	  if(ixM1<iw)
	    ixM1= iw;
	  iy+= ih;
	  iC++;
	  iS++;
	}
      }
      i++;

    }
    ixM= ixM1;
    if(*iy0<iy) *iy0= iy;
  }
  ixM	=ixM1 > ixM2 ? ixM1 : ixM2;
  *ix0	=ixM+2;
  *nPnCells=iC;
  *nIDCells=iD;
  wB[IR]	=ixM+1-xB[IR];
  hB[IR]	=(*iy0)-yB[IR];
  return(0);
}

int XCbReInitCntrPanel()
{
  int ix0,iy0;

  nCPCell= 0;
  nIDCell= 0;
  XCbSetPointer2CP(0,0,&nCPCell,&nIDCell);
  ix0= 1;
  iy0= 5*hF;
  nCPCell= 0;
  nIDCell= 0;
  XCbRePointCPCell(0,0,&ix0,&iy0,&nCPCell,&nIDCell);
  return(0);
}

int XCbDisplayBLB(IB,ix0,iy0)
     int IB,*ix0,*iy0;
{
  BLB*pntB;
  int i,iM,nM,iS,nS,iB,nB,kB,n;
  int ix,iy,iw,ih,ix1,ix2,iy1,iyM,ixM;

  theW= WinP[1].W;
  pntB= blb+IB;
  iw= 10*wF;
  ih= hF+1;
  ix= *ix0;
  iy= *iy0;
  iy1= iy;
  ix1= ix;

  XSetForeground(theD,theGC,ColorPix[12]);
  XFillRectangle(theD,theW,theGC,ix,iy,iw,hF);
  XSetForeground(theD,theGC,ColorPix[0]);
  iy+= ih;
  XDrawString(theD,theW,theGC,ix+1,iy-3,pntB->NmB,strlen(pntB->NmB));
  nM= pntB->nM;
  ixM= ix+2*wF;
  *iy0= iy;
  iyM= iy;
  for(iM= 0;iM<nM;iM++){
    ix= ixM;
    iy= iyM;
    XSetForeground(theD,theGC,ColorPix[14]);
    XFillRectangle(theD,theW,theGC,ix,iy,iw,hF);
    XSetForeground(theD,theGC,ColorPix[0]);
    iy+= ih;
    XDrawString(theD,theW,theGC,ix+1,iy-3,pntB->NmM[iM],strlen(pntB->NmM[iM]));
    nS= pntB->nS[iM];
    nB= pntB->nB[iM];
    n= nS+nB;
    iB= 0;
    iS= 0;
    i= 0;
    if(nB)
      kB= pntB->kB[iM][iB];
    else
      ixM+= iw+wF;
    while(i<n){
      if(iB<nB&&i==kB){
	ix2= ix;
	XCbDisplayBLB(pntB->nxtB[iM][iB],&ix2,&iy);
#ifdef H
	ix2+= wF;
#endif
	if(ixM<ix2)
	  ixM= ix2;
	iB++;
	if(iB<nB)
	  kB= pntB->kB[iM][iB];
      }
      else{
	if(iS<nS){
	  XSetForeground(theD,theGC,ColorPix[11]);
	  XFillRectangle(theD,theW,theGC,ix,iy,iw,hF);
	  XSetForeground(theD,theGC,ColorPix[0]);
	  iy+= ih;
	  XDrawString(theD,theW,theGC,ix+1,iy-3,
		      pntB->NmS[iM][iS],strlen(pntB->NmS[iM][iS]));
	  iS++;
	}
      }
      i++;
    }
    if(*iy0<iy)
      *iy0= iy;
  }
  *ix0= ixM;
  XSetForeground(theD,theGC,ColorPix[14]);
  XDrawRectangle(theD,theW,theGC,ix1,iy1,(*ix0)-ix1,(*iy0)-iy1);
  return(0);
}

static int jB= 0,jM= -1,jS= -1;

int XCbShowActiveBlock(int iB,int iM,int iS)
{
  int iC,ix,iy,jC,jx,jy,jc;

  if(jM<0){
    jC	=blb[jB].iCB;
    jc	=5;
  }
  else{
    jC	=blb[jB].iCS[jM][jS];
    jc	=11;
  }
  jx= CPCell[jC].x+3;
  jy= CPCell[jC].y+1;
  XSetForeground(theD,theGC,ColorPix[jc]);
  XFillRectangle(theD,CPanelW,theGC,jx,jy,wF,ih3);

  if(iM<0){
    iC= blb[iB].iCB;
  }
  else{
    iC= blb[iB].iCS[iM][iS];
  }
  ix= CPCell[iC].x+3;
  iy= CPCell[iC].y+1;
  XSetForeground(theD,theGC,ColorPix[14]);
  XFillRectangle(theD,CPanelW,theGC,ix,iy,wF,ih3);

  XSetForeground(theD,theGC,ColorPix[0]);
  XDrawString(theD,CPanelW,theGC,ix,iy+ih3,CPCell[iC].pn,1);
  XDrawString(theD,CPanelW,theGC,jx,jy+ih3,CPCell[jC].pn,1);

  jB= iB;
  jM= iM;
  jS= iS;

  XFlush(theD);
  return(0);
}

int XCbShowInstActiveBlock()
{
  int jC,jx,jy;

  if(jM < 0){
    jC	=blb[jB].iCB;
  }
  else{
    jC	=blb[jB].iCS[jM][jS];
  }
  jx	=CPCell[jC].x+3;
  jy	=CPCell[jC].y+1;
  XSetForeground(theD,theGC,ColorPix[14]);
  XFillRectangle(theD,CPanelW,theGC,jx,jy,wF,ih3);
  XSetForeground(theD,theGC,ColorPix[0]);
  XDrawString(theD,CPanelW,theGC,jx,jy+ih3,CPCell[jC].pn,1);
  return(0);
}

int XCntrPanelRect(int x0,int y0,int ic)
{
  int i;

  i	=ic ? 12 : 15;
  XSetForeground(theD,theGC,ColorPix[i]);
  for(i=0; i < nR; i++){
    XDrawRectangle(theD,CPanelW,theGC,x0+xB[i],y0+yB[i],wB[i],hB[i]);
  }
  return(0);
}

int XEraseCntrPanelRect(int x0,int y0,int i)
{
  XFillRectangle(theD,CPanelW,theGCE,x0+xB[i],y0+yB[i],wB[i]+1,hB[i]+1);
  return(0);
}

int XCbCreatePixCP(Pixmap *lCP,unsigned int *x,unsigned int *y
		   ,unsigned int *w,unsigned int *h)
{
  int i,jC,jx,jy;;
  *x	=xB[0];
  *y	=yB[0];
  *w	=wB[0]+1;
  *h	=hB[0]+1;
  *lCP	=XCreatePixmap(theD,theW,*w,*h,DefaultDepth(theD,0));
  XSetForeground(theD,theGC,ColorPix[15]);
  XFillRectangle(theD,*lCP,theGC,0,0,*w,*h);
  XCbCPanel2PixCP(*lCP,xB[0],yB[0]);
  XSetForeground(theD,theGC,ColorPix[12]);
  for(i=0; i < nR; i++){
    XDrawRectangle(theD,*lCP,theGC,xB[i]-xB[0],yB[i]-yB[0],wB[i],hB[i]);
  }
  if(jM < 0){
    jC	=blb[jB].iCB;
  }
  else{
    jC	=blb[jB].iCS[jM][jS];
  }
  jx	=CPCell[jC].x+3-xB[0];
  jy	=CPCell[jC].y+1-yB[0];
  XSetForeground(theD,theGC,ColorPix[14]);
  XFillRectangle(theD,*lCP,theGC,jx,jy,wF,ih3);
  XSetForeground(theD,theGC,ColorPix[0]);
  XDrawString(theD,*lCP,theGC,jx,jy+ih3,CPCell[jC].pn,1);
  return(0);
}

void XCbInitDummyValues()
{
  int i,j,ni,nd,k,idmx,iimx;

  NPd= 0;
  NPi= 0;

  NdVi= 0;
  NdVd= 0;
  idmx= 0;
  iimx= 0;
  for(i= 0;i<nTbl;i++){
    if(Tbl[i].SF != NULL){
      ni= 0;
      nd= 0;
      for(j= 0;j<Tbl[i].NP;j++){
	k= Tbl[i].iCP[j]&7;
	if(k==1||k==3)
	  nd++;
	if(k==2||k==4)
	  ni++;
      }
      if(NPd<nd)
	NPd= nd;
      if(NPi<ni)
	NPi= ni;
      ni= 0;
      nd= 0;
      for(j= 0;j<Tbl[i].NNmV;j++){
	switch((Tbl[i].iCV[j]&7)){
	case 1:
	case 3:
	  nd++;
	  k= Tbl[i].lV[j];
	  if(idmx<k){
	    idmx= k;
	  }
	  break;
	case 2:
	case 4:
	case 5:
	  ni++;
	  k= Tbl[i].lV[j];
	  if(iimx<k){
	    iimx= k;
	  }
	  break;
	default:
	  break;
	}
      }
      if(NdVd<nd)
	NdVd= nd;
      if(NdVi<ni)
	NdVi= ni;
    }
  }
  dummyPd= (double*)malloc(NPd*sizeof(double));
  dummyPi= (int*)malloc(NPi*sizeof(int));
  for(i= 0;i<NPd;i++){
    dummyPd[i]= 1.+0.3*i;
  }
  for(i= 0;i<NPi;i++){
    dummyPi[i]= 1+i;
  }

  dummyVd= (double**)malloc(NdVd*sizeof(double*));
  dummyVi= (int**)malloc(NdVi*sizeof(int*));
  ndVd= (int*)malloc(NdVd*sizeof(int));
  ndVi= (int*)malloc(NdVi*sizeof(int));
  for(i= 0;i<NdVd;i++){
    ndVd[i]= idmx;
    dummyVd[i]= (double*)malloc(idmx*sizeof(double));
    for(j= 0;j<idmx;j++){
      dummyVd[i][j]= 1.2*i+0.3*j;
    }
  }

  for(i= 0;i<NdVi;i++){
    ndVi[i]= iimx;
    dummyVi[i]= (int*)malloc(iimx*sizeof(int));
    for(j= 0;j<iimx;j++){
      dummyVi[i][j]= 10*i+j;
    }
  }
}
#ifdef H
void XCbDeInitDummyValues()
{
  int i;

  for(i= 0;i<NdVi;i++){
    free(dummyVi[i]);
  }
  for(i= 0;i<NdVd;i++){
    free(dummyVd[i]);
  }
  free(dummyVd);
  free(dummyVi);
  free(ndVd);
  free(ndVi);
  free(dummyPd);
  free(dummyPi);
}

void XCbDummyValues2TblPV(iT)
     int iT;
{
  int i,j,ni,nd,k,n,ii;
  double xmx,xmn;
  int ixmx,ixmn;
  char*p,*p1;

  ni= 0;
  nd= 0;
  pntT= Tbl+iT;

  for(i= 0;i<pntT->NP;i++){
    switch((pntT->iCP[i]&7)){
    case 0:
      ii= pntT->iUP[i];
      pntT->P[i]= (char*)malloc(2*(ii+1)*sizeof(char));
      p= pntT->P[i];
      pntT->P1[i]= p+ii+1;
      p1= pntT->P1[i];
      for(j= 0;j<ii;j++){
	*p= 'a'+j;
	*p1= *p;
	p++;
	p1++;
      }
      *p= '\0';
      *p1= '\0';
      break;
    case 1:
    case 3:
      pntT->P[i]= (char*)(dummyPd+nd);
      nd++;
      break;
    case 2:
    case 4:
    case 5:
      pntT->P[i]= (char*)(dummyPi+ni);
      ni++;
      break;
    }
  }

  ni= 0;
  nd= 0;
  for(i= 0;i<pntT->NNmV;i++){
    n= pntT->lV[i];
    switch(pntT->iCV[i]&7){
    case 0:
      ii= pntT->iUV[i];
      for(k= 0;k<n;k++){
	pntT->V[i][k]= (char*)malloc(2*(ii+1)*sizeof(char));
	p= pntT->V[i][k];
	pntT->V1[i][k]=p+ii+1;
	p1= pntT->V1[i][k];
	for(j= 0;j<ii;j++){
	  *p= 'a'+j;
	  *p1= *p;
	  p++;
	  p1++;
	}
	*p= '\0';
	*p1= '\0';
      }
      break;
    case 1:
      if(pntT->iPV[i]){
	n-= 2;
      }
      xmx= -1e+20;
      xmn= 1e+20;
      for(k= 0;k<n;k++){
	pntT->V[i][k]= (char*)(dummyVd[nd]+k);
	if(xmn>dummyVd[nd][k])
	  xmn= dummyVd[nd][k];
	if(xmx<dummyVd[nd][k])
	  xmx= dummyVd[nd][k];
      }
      if(pntT->iPV[i]){
	Box[iT][i][0]= xmn;
	Box[iT][i][1]= xmx;
	pntT->V[i][k]= (char*)Box[iT][i];
	k++;
	pntT->V[i][k]= (char*)(Box[iT][i]+1);
      }
      nd++;
      break;
    case 2:
      if(pntT->iPV[i]){
	n-= 2;
      }
      ixmx= -1000000;
      ixmn= 1000000;
      for(k= 0;k<n;k++){
	pntT->V[i][k]= (char*)(dummyVi[ni]+k);
	if(ixmn>dummyVi[ni][k])
	  ixmn= dummyVd[ni][k];
	if(ixmx<dummyVi[ni][k])
	  ixmx= dummyVi[ni][k];
      }
      if(pntT->iPV[i]){
	iBox[iT][i][0]= ixmn;
	iBox[iT][i][1]= ixmx;
	Box[iT][i][0]= ixmn;
	Box[iT][i][1]= ixmx;
	pntT->V[i][k]= (char*)iBox[iT][i];
	k++;
	pntT->V[i][k]= (char*)(iBox[iT][i]+1);
      }
      ni++;
      break;
    default:
      break;
    }
  }
}

void XCbDummyDeValues2TblPV(iT)
     int iT;
{
  int i,j,k;

  pntT= Tbl+iT;
  for(j= 0;j<pntT->NP;j++){
    if((pntT->iCP[j]&7)==0){
      free(pntT->P[j]);
    }
    pntT->P[j]= NULL;
    pntT->P1[j]= NULL;
  }

  for(i= 0;i<pntT->NNmV;i++){
    k= pntT->iCV[i]&7;
    for(j= 0;j<pntT->lV[i];j++){
      if(k == 0){
	free(pntT->V[i][j]);
      }
      pntT->V[i][j]= NULL;
      pntT->V1[i][j]= NULL;
    }
  }
}
#endif
static int Wm,Wm1,ind,FlTblRd;
void (*CbUserRoutine)(void);
void (*CbUserPlot)(void);

int (*CbUserControl)(XEvent *);
int (*CbUserXWRoutine)(XEvent *);

static int LWarning=0x400;
char CbUserWarning[0x400]="";
char *CbUserMessage=NULL;
#ifdef OPENGL
int (*CbUserGLRoutine)(XEvent *);
#endif
static void aaCbVoid()
{
  return;
}

int CbStr2UserMessage(char *str,...)
{
  static va_list ap;
  static int L=0x400;
  static char M[0x400];
  static int k=0;
  char B[128];
  int i;

  if(str == NULL){
    k	=0;
    *M	='\0';
    return(0);
  }
  if(CbUserMessage == NULL){
    k	=0;
    *M	='\0';
  }
  CbUserMessage=M;
  if(k < L){
    va_start(ap,str);
    i=vsprintf(B,str,ap);
    va_end(ap);
    if(k+i >= L){
      i	=L-k;
      B[i-1]	='\0';
    }
    strcpy(M+k,B);
    k	+=i;
  }
  return(0);
}

int ZMessageF(char*str,...)
{
  extern Window theHW;
  extern int xMessW,yMessW,kMessW;
  int ix,iy,iw,ih;
  char *p,*lc;
  static va_list ap;
  static char M[0x400];

  if(str == NULL) return(0);
  va_start(ap,str);
  vsprintf(M,str,ap);
  va_end(ap);
  ih	=0;
  iw	=0;
  p	=M;
  lc	=M;
  while(*p != '\0'){
    if(*p == '\n'){
      iy=p-lc;
      if(iw < iy) iw=iy;
      lc=p+1;
      ih++;
    }
    p++;
  }
  iy	=p-lc;
  if(iy){
    if(iw < iy) iw=iy;
    ih++;
  }
  XSetForeground(theD,theGC,ColorPix[4]);
  iw	=wF*iw+5;
  ih	=hF*ih+4;

  XMoveWindow(theD,theHW,xMessW,yMessW);
  XResizeWindow(theD,theHW,iw,ih);
  XMapWindow(theD,theHW);
  XRaiseWindow(theD,theHW);
  kMessW=1;
  ix	=0;
  iy	=0;
  XFillRectangle(theD,theHW,theGC,ix,iy,iw,ih);
  ix	+=2;
  iy	+=1;
  p	=M;
  lc	=M;
  while(*p != '\0'){
    if(*p == '\n'){
      XDrawString(theD,theHW,theGCM,ix,iy+hF,lc,(int)(p-lc));
      lc	=p+1;
      iy	+=hF;
    }
    p++;
  }
  if(lc < p) XDrawString(theD,theHW,theGCM,ix,iy+hF,lc,(int)(p-lc));
  XFlush(theD);
  return(0);
}

int CbStr2UserWarning(char *str,...)
{
  static va_list ap;
  static int k=0;
  char B[128];
  int i;

  if(str == NULL){
    k	=0;
    *CbUserWarning	='\0';
    return(0);
  }
  if(*CbUserWarning == 0) k=0;
  if(k < LWarning){
    va_start(ap,str);
    i=vsprintf(B,str,ap);
    va_end(ap);
    if(k+i >= LWarning){
      i	=LWarning-k;
      B[i-1]	='\0';
    }
    strcpy(CbUserWarning+k,B);
    k	+=i;
  }
  CbUserMessage=NULL;
  return(0);
}

int XCbInitTableDataLayout(int iT)
{
  pi2j	=i2j[iT];
  pi2c	=i2c[iT];
  pj2i	=j2i[iT];
  pj2m	=j2m[iT];
  pj2jv	=j2jv[iT];
  pj2nv	=j2nv[iT];
  pCell	=Cell[iT];
  pXCbM	=XCbM[iT] != NULL ? XCbM[iT] : NULL;
  pi2j	=i2j[iT];
  pi2c	=i2c[iT];
  pj2i	=j2i[iT];
  pj2m	=j2m[iT];
  pj2jv	=j2jv[iT];
  pj2nv	=j2nv[iT];

  pntT	=Tbl+iT;
  nL	=pntT->nL;
  nP	=pntT->NP;
  nV	=pntT->NNmV;
  nPV	=nP+nV;
  nPC	=pntT->NPC;
  nVC	=pntT->NNmVC;
  nPVC	=nPC+nVC;
  return(0);
}

int XCbInitInputTable(int iT)
{
  int i;

  CbUserRoutine	=NULL;
  CbUserXWRoutine=NULL;
#ifdef OPENGL
  CbUserGLRoutine=NULL;
#endif

  CbUserPlot	=NULL;
  CbUserControl	=NULL;
#ifdef H
  CbUserMessage	=NULL;
  *CbUserWarning=0;
#endif
  CheckIfEvents();
  iWin	=Tbl[iT].W;

  Wm	=WinP[iWin].mode&0xF;
#ifdef H
  if(Wm == 3){
    return(0);
  }
#endif

  pntT	=Tbl+iT;
  WinP[iWin].mode	&=((pntT->mode<<4)&0xF);
  Wm1	=Tbl[iT].mode;
  theW	=WinP[iWin].W;
  pXCbM	=XCbM[iT] != NULL ? XCbM[iT] : NULL;

  pntP	=Plt+iT;

  TblB	=pntT->iB;
  TblM	=pntT->iM;
  TblS	=pntT->iS;

  nL	=pntT->nL;
  nP	=pntT->NP;
  nV	=pntT->NNmV;
  nPV	=nP+nV;
  nPC	=pntT->NPC;
  nVC	=pntT->NNmVC;
  nPVC	=nPC+nVC;
  xshift	=xshTbl[iT];
  ind	=1;
  FlTblRd	=1;
  FlagPS	=0;
  if(TblS < 0){
    sprintf(NmF,"%s/Out/%s.ps",blb[TblB].path,blb[TblB].NmB);
    i	=blb[TblB].IB&0x100;
  }
  else{
    sprintf(NmF,"%s/Out/%s.ps",blb[TblB].path,blb[TblB].NmS[TblM][TblS]);
    i	=blb[TblB].IS[TblM][TblS]&0x100;
  }
  if(FlSc[iT] && i == 0){
    *p0	=Xg_0[iT];
    *p1	=Yg_0[iT];
    *p2	=Xmin[iT];
    *p3	=Ymin[iT];
    *p4	=Xmax[iT];
    *p5	=Ymax[iT];
    *p6	=Sx[iT];
    *p7	=Sy[iT];
  }
  return(0);
}

static int col=0,nLine;
static double xmn,xmx,ymn,ymx;

int XCbPlot(PltPar*lP,int i,int nx,int ny)
{
  int ii,j,Pf,Ps,Ps2,i0,i1,nU;
  double s;
  int ngx,kx,vx,nKx,Kx,i0x,i1x,jx,cx;
  int ngy,ky,vy,nKy,Ky,i0y,i1y,jy,cy;
  static double*pdx,x,x1,X,X1,scx,scPSx,PSx,PSx1,PSw,PSw2;
  static double*pdy,y,y1,Y,Y1,scy,scPSy,PSy,PSy1,PSh,PSh2;
  char**px;
  char**py;
  int*pix,ix;
  int*piy,iy;
  float*pfx;
  float*pfy;
  long int*pLx;
  long int*pLy;

  cx=lP->iCV[nx];
  if((nU= lP->nUV[nx])<=0){
    scPSx= 1.;
    scx= sx;
  }
  else{
    scPSx= XUnits[nU].sc;
    scx= sx*scPSx;
    if(XUnits[nU].iU){
      s= lP->scV[nx];
      scPSx*= s;
      scx*= s;
    }
  }
  cy= lP->iCV[ny];
  if((nU= lP->nUV[ny])<=0){
    scPSy= 1.;
    scy= sy;
  }
  else{
    scPSy= XUnits[nU].sc;
    scy= sy*scPSy;
    if(XUnits[nU].iU){
      s= lP->scV[ny];
      scPSy*= s;
      scy*= s;
    }
  }

  px=lP->V[nx];
  nKx= lP->nKV[nx];
  vx= 0;
  ngx= 0;
  kx= 0;
  Kx= lP->kV[nx][ngx];
  i0x= lP->i0V[nx][ngx];
  i1x= lP->i1V[nx][ngx];
  jx= i0x;

  py= lP->V[ny];
  nKy= lP->nKV[ny];
  vy= 0;
  ngy= 0;
  ky= 0;
  Ky= lP->kV[ny][ngy];
  i0y= lP->i0V[ny][ngy];
  i1y= lP->i1V[ny][ngy];
  jy= i0y;

  i0	=lP->i0[i];
  i1	=lP->i1[i];
  j	=lP->c[i];
  if(j != col && j < XCbNColor && 0 <= j){
    col	=j;
    XSetForeground(theD,theGC,ColorPix[col]);
  }
  Pf	=lP->f[i];
  Ps	=lP->s[i];
  if(Pf){
    Ps2	=2.*Ps;
    PSw	=0.5*Ps/sx;
    PSw2=2.*PSw;
    PSh	=0.5*Ps/fabs(sy);
    PSh2=2.*PSh;
  }

  if(FlagPS){
    CbPSBegOfLine(col);
  }

  ix= 0;
  iy= 0;
  j= 0;
  while(j < i1){
    if(j >= i0){
      PSx1= PSx;
      x1= x;
      switch(cx){
      case 1:
	pdx=(double*)px[vx+kx];
	PSx= pdx[jx]*scPSx;
	x= pdx[jx]*scx-xmn;
	break;
      case 3:
	pfx=(float*)px[vx+kx];
	PSx= pfx[jx]*scPSx;
	x= pfx[jx]*scx-xmn;
	break;
      case 2:
      case 5:
	pix=(int*)px[vx+kx];
	PSx= pix[jx]*scPSx;
	x= pix[jx]*scx-xmn;
	break;
      case 4:
	pLx=(long*)px[vx+kx];
	PSx= pLx[jx]*scPSx;
	x= pLx[jx]*scx-xmn;
	break;
      }
    }
    kx++;
    if(kx==Kx){
      jx++;
      kx= 0;
    }
    if(jx==i1x){
      ngx++;
      if(ngx<nKx){
	kx= 0;
	vx+= Kx;
	Kx= lP->kV[nx][ngx];
	i0x= lP->i0V[nx][ngx];
	i1x= lP->i1V[nx][ngx];
	jx= i0x;
      }
      else{
	j= i1;
      }
    }
    if(j>=i0){
      PSy1= PSy;
      y1= y;
      switch(cy){
      case 1:
	pdy= (double*)py[vy+ky];
	PSy= pdy[jy]*scPSy;
	y= pdy[jy]*scy-ymx;
	break;
      case 3:
	pfy= (float*)py[vy+ky];
	PSy= pfy[jy]*scPSy;
	y= pfy[jy]*scy-ymx;
	break;
      case 2:
      case 5:
	piy= (int*)py[vy+ky];
	PSy= piy[jy]*scPSy;
	y= piy[jy]*scy-ymx;
	break;
      case 4:
	pLy= (long*)py[vy+ky];
	PSy= pLy[jy]*scPSy;
	y= pLy[jy]*scy-ymx;
	break;
      }
    }
    ky++;
    if(ky==Ky){
      jy++;
      ky= 0;
    }
    if(jy==i1y){
      ngy++;
      if(ngy<nKy){
	ky= 0;
	vy+= Ky;
	Ky= lP->kV[ny][ngy];
	i0y= lP->i0V[ny][ngy];
	i1y= lP->i1V[ny][ngy];
	jy= i0y;
      }
      else{
	j= i1;
      }
    }

    if(FlagPS&&j==i0){
      if(Pf == 0){
	CbPSStartOfLine(PSx,PSy);
      }
      else{
	CbPSStartOfObj();
      }
    }
    if(Pf && j >= i0){
      X	=x;
      Y	=y;
      if(0.<= X && X <= xmx && ymn <= Y && Y <= 0.){
	switch(Pf){
	case 1:
	  XDrawRectangle(theD,theW,theGC,(int)(xg_0+X)-Ps,(int)(yg_0+Y)-Ps,
			 Ps2,Ps2);
	  break;
	case 2:
	  XFillRectangle(theD,theW,theGC,(int)(xg_0+X)-Ps,(int)(yg_0+Y)-Ps,
			 Ps2,Ps2);
	  break;
	case 3:
	  XDrawRectangle(theD,theW,theGC,(int)(xg_0+X),(int)(yg_0+Y)-Ps,
			 0,Ps2);
	  break;
	case 4:
	  XDrawRectangle(theD,theW,theGC,(int)(xg_0+X)-Ps,(int)(yg_0+Y),
			 Ps2,0);
	  break;
	case 5:
	  XDrawRectangle(theD,theW,theGC,(int)(xg_0+X)-Ps,(int)(yg_0+Y)-Ps,
			 Ps2,Ps2);
	  if(Y > 0.){
	    XDrawRectangle(theD,theW,theGC,(int)(xg_0+X),(int)yg_0,
			   0,(int)Y);
	  }
	  else{
	    XDrawRectangle(theD,theW,theGC,(int)(xg_0+X),(int)(yg_0+Y),
			   0,(int)(-Y));
	  }
	  break;
	case 6:
	  XDrawLine(theD,theW,theGC,(int)(xg_0+X)-Ps,(int)(yg_0+Y)-Ps,
			 (int)(xg_0+X)+Ps,(int)(yg_0+Y)+Ps);
	  XDrawLine(theD,theW,theGC,(int)(xg_0+X)+Ps,(int)(yg_0+Y)-Ps,
			 (int)(xg_0+X)-Ps,(int)(yg_0+Y)+Ps);
	  break;
	}
	if(FlagPS){
	  switch(Pf){
	  case 1:
	    CbPSDrawRectangle(PSx-PSw,PSy-PSh,PSw2,PSh2);
	    break;
	  case 2:
	    CbPSFillRectangle(PSx-PSw,PSy-PSh,PSw2,PSh2);
	    break;
	  case 3:
	    CbPSDrawRectangle(PSx,PSy-PSh,0.3/sx,PSh2);
	    break;
	  case 4:
	    CbPSDrawRectangle(PSx-PSw,PSy,PSw2,0.3/fabs(sy));
	    break;
	  case 5:
	    CbPSDrawRectangle(PSx-PSw,PSy-PSh,PSw2,PSh2);
	    CbPSDrawRectangle(PSx,PSy,.2*PSw,-PSy);
	    break;
	  case 6:
	    CbPSDrawLine(PSx-PSw,PSy-PSh,PSx+PSw,PSy+PSh);
	    CbPSDrawLine(PSx+PSw,PSy-PSh,PSx-PSw,PSy+PSh);
	    break;
	  }
	}
      }
    }
    if(Pf==0&&j>i0){
      ii= 1;
      X= x;
      Y= y;
      X1= x1;
      Y1= y1;
      if(Y1<ymn){
	if(Y<ymn)
	  ii= 0;
	else{
	  X1+= (X-X1)*(ymn-Y1)/(Y-Y1);
	  Y1= ymn;
	}
      }
      if(ii){
	if(0.<Y1){
	  if(0.<Y)
	    ii= 0;
	  else{
	    X1-= (X-X1)*Y1/(Y-Y1);
	    Y1= 0.;
	  }
	}
	if(ii){
	  if(X1<0.){
	    if(X<0.)
	      ii= 0;
	    else{
	      Y1-= (Y-Y1)*X1/(X-X1);
	      X1= 0.;
	    }
	  }
	  if(ii){
	    if(xmx<X1){
	      if(xmx<X)
		ii= 0;
	      else{
		Y1+= (Y-Y1)*(xmx-X1)/(X-X1);
		X1= xmx;
	      }
	    }
	    if(ii){
	      if(Y<ymn){
		X+= (X1-X)*(ymn-Y)/(Y1-Y);
		Y= ymn;
	      }
	      if(0.<Y){
		X-= (X1-X)*Y/(Y1-Y);
		Y= 0.;
	      }
	      if(X<0){
		Y-= (Y1-Y)*X/(X1-X);
		X= 0.;
	      }
	      if(xmx<X){
		Y+= (Y1-Y)*(xmx-X)/(X1-X);
		X= xmx;
	      }
	      XDrawLine(theD,theW,theGC,(int)(xg_0+X),(int)(yg_0+Y),
			(int)(xg_0+X1),(int)(yg_0+Y1));
	    }
	  }
	}
      }
      if(ii&&FlagPS){
	PSDrawSegm(PSx1,PSy1,PSx,PSy);
      }
    }
    j++;
  }
  if(FlagPS){
    if(Pf==0)
      CbPSEndOfLine();
    else
      CbPSEndOfObj();
  }
  return(0);
}
    
int XCbGiveName2Axis(int iT,int L)
{
  if(Nkx[iT]){
    int j,k;
    char *lc;

    strcpy(nameP,Tbl[iT].Nm);
    j	=kx2j[iT][0];
    k	=CbStrCpy0(nameX,pCell[j].pn);
    if(pCell[j].lu){
      lc	=pCell[j].pu;
      while(*lc == ' '){
	lc++;
      }
      if(*lc != '\0'){
	sprintf(nameX+k," [%s]",lc);
      }
    }
    if(L > 1){
      j	=ky2j[iT][0];
      k	=CbStrCpy0(nameY,pCell[j].pn);
      if(pCell[j].lu){
	lc	=pCell[j].pu;
	while(*lc == ' '){
	  lc++;
	}
	if(*lc != '\0'){
	  sprintf(nameY+k," [%s]",lc);
	}
      }		
    }
  }
  else{
    nameX[0]	='\0';
    nameY[0]	='\0';
  }
  return(0);
}

void XCbTblP2CellP(int iT)
{
  int i,ii,j,iM,na,ns,nd,ni,nU,n,k,k1,FlBx,sBx;
  double sc,scX,scY;
  double *pntd,*pntd0,**pntd1;
  float **pntf1;
  int *pnti,*pnti0,**pnti1,*pntc;
  long int **pntL1;
  char **pnt,*pch;
  static double Xd[4],Yd[4];
  int n1;

  scX		=1.;
  scY		=1.;
  sc		=1.;
  Xd[0]		=1e+20;
  Xd[1]		=-1e+20;
  if(pntT->nL > 1){
    Yd[0]	=1e+20;
    Yd[1]	=-1e+20;
  }
  else{
    Yd[0]	=0.;
    Yd[1]	=0.;
  }
  nd	=Rng[iT].nd;
  ni	=Rng[iT].ni;
  for(i=0; i < nP; i++){
    if(pntT->ScpP[i] != NULL) pntT->scP[i]=*(double*)pntT->ScpP[i];
  }
  for(i=0; i < nV; i++){
    if(pntT->ScpV[i] != NULL) pntT->scV[i]=*(double*)pntT->ScpV[i];
  }
  n1= 0;
  na= 0;
  ns= 0;
  nd= 0;
  ni= 0;
  for(j=0; j < nPC; j++){
    i	=pj2i[j];
    iM	=pj2m[j];
    ii	=pntT->iCP[i];
    pCell[j].pH	=pntT->HlpP[i];
    if(iM < 0 || pXCbM[iM].d == 0){
      if(pCell[j].ws){
	if(pntT->aEP[i] != NULL){
	  pCell[j].vs	=pntT->vaP[i];
	  pCell[j].ps	=pntT->aEP[i]+(*pCell[j].vs);
	  pCell[j].ps0	=pntT->aEP[i];
	}
	else{
	  pnti	=va[iT]+na;
	  pCell[j].vs	=pnti;
#ifdef H
	  *pnti	=*pCell[j].vs;
#endif
	}
	na++;
      }
      switch((ii&7)){
      case 0:
	if(pntT->P[i] != NULL){
#ifdef H
	  strcpy(pntT->P1[i],pntT->P[i]);
	  pCell[j].pv	=pntT->P1[i];
#endif
	  pCell[j].pv	=pntT->P[i];
	}
	ns++;
	break;
      case 1:
	pd[nd]	=*(double*)pntT->P[i];
	if((nU=pCell[j].nU) >= 0){
	  sc	=XUnits[nU].sc;
	  if(XUnits[nU].iU) sc	*=pntT->scP[i];
	  pd[nd]	*=sc;
	}
	pd0[nd]	=pd[nd];
	if(pntT->iPP[i]){
	  if(pntT->nL == 1 || n1%2 == 0){
	    if(nU >=0) scX=sc;
	    if(Xd[0] > pd[nd]) Xd[0]=pd[nd];
	    if(Xd[1] < pd[nd]) Xd[1]=pd[nd];
	  }
	  else{
	    if(nU >=0) scY=sc;
	    if(Yd[0] > pd[nd]) Yd[0]=pd[nd];
	    if(Yd[1] < pd[nd]) Yd[1]=pd[nd];
	  }
	  n1++;
	}
	nd++;
	break;
      case 3:
	pd[nd]	=*(float*)pntT->P[i];
	if((nU=pCell[j].nU) >= 0){
	  sc	=XUnits[nU].sc;
	  if(XUnits[nU].iU){
	    sc	*=pntT->scP[i];
	  }
	  pd[nd]	*=sc;
	}
	pd0[nd]= pd[nd];
	if(pntT->iPP[i]){
	  if(pntT->nL == 1 || n1%2 == 0){
	    if(nU >=0) scX=sc;
	    if(Xd[0]>pd[nd]) Xd[0]= pd[nd];
	    if(Xd[1]<pd[nd]) Xd[1]= pd[nd];
	  }
	  else{
	    if(nU >=0) scY=sc;
	    if(Yd[0]>pd[nd]) Yd[0]= pd[nd];
	    if(Yd[1]<pd[nd]) Yd[1]= pd[nd];
	  }
	  n1++;
	}
	nd++;
	break;
      case 2:
      case 5:
	pi[ni]	=*(int*)pntT->P[i];
	if((nU=pCell[j].nU) >= 0){
	  sc	=XUnits[nU].sc;
	  if(XUnits[nU].iU) sc*=pntT->scP[i];
	  pi[ni]	*=sc;
	}
	pi0[ni]	=pi[ni];
	if(pntT->iPP[i]){
	  if(pntT->nL == 1 || n1%2 == 0){
	    if(nU >=0) scX=sc;
	    if(Xd[0] > pi[ni]) Xd[0]=pi[ni];
	    if(Xd[1] < pi[ni]) Xd[1]=pi[ni];
	  }
	  else{
	    if(nU >=0) scY=sc;
	    if(Yd[0] > pi[ni]) Yd[0]=pi[ni];
	    if(Yd[1] < pi[ni]) Yd[1]=pi[ni];
	  }
	  n1++;
	}
	ni++;
	break;
      case 4:
	pi[ni]	=*(long*)pntT->P[i];
	if((nU=pCell[j].nU) >= 0){
	  sc	=XUnits[nU].sc;
	  if(XUnits[nU].iU){
	    sc	*=pntT->scP[i];
	  }
	  pi[ni]	*=sc;
	}
	pi0[ni]= pi[ni];
	if(pntT->iPP[i]){
	  if(nU >=0) scX=sc;
	  if(pntT->nL==1||n1%2==0){
	    if(Xd[0]>pi[ni]) Xd[0]= pi[ni];
	    if(Xd[1]<pi[ni]) Xd[1]= pi[ni];
	  }
	  else{
	    if(nU >=0) scY=sc;
	    if(Yd[0]>pi[ni])Yd[0]= pi[ni];
	    if(Yd[1]<pi[ni])Yd[1]= pi[ni];
	  }
	  n1++;
	}
	ni++;
	break;
      default:
	break;
      }
    }
    else{
      if(pCell[j].ws){
	pCell[j].vs	=pntT->vaP[i];
	pCell[j].ps	=pntT->aEP[i]+(*pCell[j].vs);
	pCell[j].ps0	=pntT->aEP[i];
	na++;
      }
    }
  }

  if(pntT->nL > 1){
    n1	/=2;
  }

  FlBx	=0;
  if(n1 < Nkx[iT]){
    Xd[2]	=1e+20;
    Xd[3]	=-1e+20;
    if(pntT->nL > 1){
      Yd[2]	=1e+20;
      Yd[3]	=-1e+20;
    }
    else{
      Yd[2]	=0.;
      Yd[3]	=0.;
    }
  }

  n1	=0;
  ns	=0;
  nd	=0;
  ni	=0;
  for(j=nPC; j < nPVC; j++){
    i	=pj2i[j]-nP;
    iM	=pj2m[j];
    pCell[j].pH	=pntT->HlpV[i];
    if(pCell[j].ws){
      n	=(pntT->iCV[i]&16) ? pntT->lV[i]-2 : pntT->lV[i];
      if(n){
	if(pntT->aEV[i] != NULL){
	  pch	=pntT->aEV[i];
	  pnti1	=pntT->vaV[i];
	  pCell[j].vs	=pnti1[0];
	  pCell[j].ps	=pch+(*pnti1[0]);
	  pCell[j].ps0	=pch;
	  na++;
	  k	=pj2jv[j];
	  for(k1=1; k1 < n; k1++){
	    if(pCell[k].ws==0){
	      break;
	    }
	    pCell[k].vs	=pnti1[k1];
	    pCell[k].ps	=pch+(*pnti1[k1]);
	    pCell[k].ps0=pch;
	    na++;
	    k++;
	  }
	}
	else{
	  pnti	=va[iT];
	  pCell[j].vs	=pnti+na;
#ifdef H
	  pnti[na]	=*pCell[j].vs;
#endif
	  na++;
	  k	=pj2jv[j];
	  for(k1=1; k1 < n; k1++){
	    if(pCell[k].ws==0){
	      break;
	    }
	    pCell[k].vs	=pnti+na;
#ifdef H
	    pnti[na]	=*pCell[k].vs;
#endif
	    na++;
	    k++;
	  }
	}
      }
    }
    n	=pntT->lV[i];
    k	=pj2jv[j];
    pch	=pCell[j].pH;
    for(k1=1; k1 < n; k1++){
      pCell[k].pH	=pch;
      k++;
    }
    if(iM < 0 || pXCbM[iM].d == 0){
      pntc	=pntT->cV[i];
      k1	=0;
#ifdef H
      pCell[j].c	=pntc[k1] ? 2 : 9;
#endif
      k	=pj2jv[j];
      for(k1=1; k1 < n; k1++){
#ifdef H
	pCell[k].c	=pntc[k1] ? 2 : 9;
#endif
	k++;
      }
      k	-=2;
      if(pntT->iPV[i]){
	if((CbBoxFl&0x02)){
	  sBx	=0;
	}
	else{
	  sBx	=(CbBoxFl&0x01) ? 1 : *(pCell[k].vs);
	}
	*(pCell[k].vs)	=sBx;
	pCell[k].ps	=strBox+sBx;
	pCell[k].ps0	=strBox;
	if(sBx){
	  FlBx	=1;
	}
      }
      switch((pntT->iCV[i]&7)){
      case 0:
	pnt	=pntT->V[i];
	if(pnt[0] != NULL){
	  k1	=0;
	  pCell[j].pv	=pnt[k1];
	  k	=pj2jv[j];
	  for(k1=1; k1 < n; k1++){
	    pCell[k].pv	=pnt[k1];
	    k++;
	  }
	}
	ns++;
	break;
      case 1:
	pntd	=vd[nd];
	pntd0	=vd0[nd];
	pntd1	=(double**)pntT->V[i];
	if((nU=pCell[j].nU) <= 0){
	  for(k=0; k < n; k++){
	    pntd[k]	=*pntd1[k];
	    pntd0[k]	=pntd[k];
	  }
	}
	else{
	  sc	=XUnits[nU].sc;
	  if(XUnits[nU].iU) sc*= pntT->scV[i];
	  for(k=0; k < n; k++){
	    pntd[k]	=(*pntd1[k])*sc;
	    pntd0[k]	=pntd[k];
	  }
	}
	if(pntT->iPV[i]){
	  if(pntT->nL == 1 || n1%2 == 0){
	    if(nU > 0) scX=sc;
	    for(k=0; k < n-2; k++){
	      if(Xd[0] > pntd[k]) Xd[0]=pntd[k];
	      if(Xd[1] < pntd[k]) Xd[1]=pntd[k];
	    }
	    if(sBx){
	      for(; k < n; k++){
		if(Xd[2] > pntd[k]) Xd[2]=pntd[k];
		if(Xd[3] < pntd[k]) Xd[3]=pntd[k];
	      }
	    }
	  }
	  else{
	    if(nU > 0) scY=sc;
	    for(k=0; k < n-2; k++){
	      if(Yd[0]>pntd[k]) Yd[0]=pntd[k];
	      if(Yd[1]<pntd[k])	Yd[1]=pntd[k];
	    }
	    if(sBx){
	      for(; k < n; k++){
		if(Yd[2] > pntd[k]) Yd[2]=pntd[k];
		if(Yd[3] < pntd[k]) Yd[3]=pntd[k];
	      }
	    }
	  }
	  n1++;
	}
	nd++;
	break;
      case 3:
	pntd	=vd[nd];
	pntd0	=vd0[nd];
	pntf1	=(float**)pntT->V[i];
	if((nU	=pCell[j].nU)<=0){
	  for(k=0; k < n; k++){
	    pntd[k]	=*pntf1[k];
	    pntd0[k]	=pntd[k];
	  }
	}
	else{
	  sc	=XUnits[nU].sc;
	  if(XUnits[nU].iU){
	    sc	*=pntT->scV[i];
	  }
	  for(k=0; k < n; k++){
	    pntd[k]	=(*pntf1[k])*sc;
	    pntd0[k]	=pntd[k];
	  }
	}
	if(pntT->iPV[i]){
	  if(pntT->nL==1||n1%2==0){
	    if(nU > 0) scX=sc;
	    for(k=0; k < n-2; k++){
	      if(Xd[0]>pntd[k]) Xd[0]=pntd[k];
	      if(Xd[1]<pntd[k]) Xd[1]=pntd[k];
	    }
	    if(sBx){
	      for(; k < n; k++){
		if(Xd[2]>pntd[k]) Xd[2]=pntd[k];
		if(Xd[3]<pntd[k]) Xd[3]=pntd[k];
	      }
	    }
	  }
	  else{
	    if(nU > 0) scY=sc;
	    for(k=0; k < n-2; k++){
	      if(Yd[0]>pntd[k]) Yd[0]=pntd[k];
	      if(Yd[1]<pntd[k]) Yd[1]=pntd[k];
	    }
	    if(sBx){
	      for(; k < n; k++){
		if(Yd[2]>pntd[k]) Yd[2]=pntd[k];
		if(Yd[3]<pntd[k]) Yd[3]=pntd[k];
	      }
	    }
	  }
	  n1++;
	}
	nd++;
	break;
      case 2:
      case 5:
	pnti	=vi[ni];
	pnti0	=vi0[ni];
	pnti1	=(int**)pntT->V[i];
	if((nU	=pCell[j].nU)<=0){
	  for(k=0; k < n; k++){
	    pnti[k]	=*pnti1[k];
	    pnti0[k]	=pnti[k];
	  }
	}
	else{
	  sc	=XUnits[nU].sc;
	  if(XUnits[nU].iU) sc*= pntT->scV[i];
	  for(k=0; k < n; k++){
	    pnti[k]	=(*pnti1[k])*sc;
	    pnti0[k]	=pnti[k];
	  }
	}
	if(pntT->iPV[i]){
	  if(pntT->nL == 1 || n1%2 == 0){
	    if(nU > 0) scX=sc;
	    for(k=0; k < n-2; k++){
	      if(Xd[0] > pnti[k]) Xd[0]=pnti[k];
	      if(Xd[1] < pnti[k]) Xd[1]	=pnti[k];
	    }
	    if(sBx){
	      for(; k < n; k++){
		if(Xd[2] > pnti[k]) Xd[2]=pnti[k];
		if(Xd[3] < pnti[k]) Xd[3]=pnti[k];
	      }
	    }
	  }
	  else{
	    if(nU > 0) scY=sc;
	    for(k=0; k < n-2; k++){
	      if(Yd[0]>pnti[k])	Yd[0]=pnti[k];
	      if(Yd[1]<pnti[k])	Yd[1]=pnti[k];
	    }
	    if(sBx){
	      for(; k < n; k++){
		if(Yd[2]>pnti[k]) Yd[2]=pnti[k];
		if(Yd[3]<pnti[k]) Yd[3]=pnti[k];
	      }
	    }
	  }
	  n1++;
	}
	ni++;
	break;
      case 4:
	pnti	=vi[ni];
	pnti0	=vi0[ni];
	pntL1	=(long**)pntT->V[i];
	if((nU=pCell[j].nU) <= 0){
	  for(k=0; k < n; k++){
	    pnti[k]	=*pntL1[k];
	    pnti0[k]	=pnti[k];
	  }
	}
	else{
	  sc	=XUnits[nU].sc;
	  if(XUnits[nU].iU) sc*=pntT->scV[i];
	  for(k=0; k < n; k++){
	    pnti[k]	=(*pntL1[k])*sc;
	    pnti0[k]	=pnti[k];
	  }
	}
	if(pntT->iPV[i]){
	  if(pntT->nL == 1 || n1%2 == 0){
	    if(nU > 0) scX	=sc;
	    for(k=0; k < n-2; k++){
	      if(Xd[0]>pnti[k])	Xd[0]=pnti[k];
	      if(Xd[1]<pnti[k]) Xd[1]=pnti[k];
	    }
	    if(sBx){
	      for(; k < n; k++){
		if(Xd[2] > pnti[k])Xd[2]=pnti[k];
		if(Xd[3] < pnti[k])Xd[3]=pnti[k];
	      }
	    }
	  }
	  else{
	    if(nU > 0) scY=sc;
	    for(k=0; k < n-2; k++){
	      if(Yd[0]>pnti[k])Yd[0]=pnti[k];
	      if(Yd[1]<pnti[k])Yd[1]=pnti[k];
	    }
	    if(sBx){
	      for(; k < n; k++){
		if(Yd[2] > pnti[k])Yd[2]=pnti[k];
		if(Yd[3] < pnti[k])Yd[3]=pnti[k];
	      }
	    }
	  }
	  n1++;
	}
	ni++;
	break;
      default:
	break;
      }
    }
  }

  if((CbBoxFl&0x08)){
    Xd[0]	=CbBoxX[0];
    Xd[1]	=CbBoxX[1];
    Yd[0]	=CbBoxY[0];
    Yd[1]	=CbBoxY[1];
  }
  if((CbBoxFl&0x04)){
    n1	=0;
    nd	=0;
    ni	=0;
    for(j=nPC; j < nPVC; j++){
      i	=pj2i[j]-nP;
      iM	=pj2m[j];
      n	=pntT->lV[i];
      if(iM < 0 || pXCbM[iM].d == 0){
	if(pntT->iPV[i]){
	  if(pntT->nL == 1 || n1%2 == 0){
	    Xd[2]	=Xd[0];
	    Xd[3]	=Xd[1];
	  }
	  else{
	    Xd[2]	=Yd[0];
	    Xd[3]	=Yd[1];
	  }
	  k	=n-2;
	  switch((pntT->iCV[i]&7)){
	  case 1:
	    pntd	=vd[nd];
	    pntd1	=(double**)pntT->V[i];
	    pntd[k]	=Xd[2];
	    *pntd1[k]	=Xd[2];
	    k++;
	    pntd[k]	=Xd[3];
	    *pntd1[k]	=Xd[3];
	    break;
	  case 3:
	    pntd	=vd[nd];
	    pntf1	=(float**)pntT->V[i];
	    pntd[k]	=Xd[2];
	    *pntf1[k++]	=Xd[2];
	    pntd[k]	=Xd[3];
	    *pntf1[k]	=Xd[3];
	    break;
	  case 2:
	  case 5:
	    pnti	=vi[ni];
	    pnti1	=(int**)pntT->V[i];
	    pnti[k]	=Xd[2];
	    *pnti1[k++]	=Xd[2];
	    pnti[k]	=Xd[3];
	    *pnti1[k]	=Xd[3];
	    break;
	  case 4:
	    pnti	=vi[ni];
	    pntL1	=(long**)pntT->V[i];
	    pnti[k]	=Xd[2];
	    *pntL1[k++]	=Xd[2];
	    pnti[k]	=Xd[3];
	    *pntL1[k]	=Xd[3];
	    break;
	  default:
	    break;
	  }
	  n1++;
	}
	k	=pntT->iCV[i]&7;
	if(k == 1 || k == 3){
	  nd++;
	}
	if(k == 2 || k == 4){
	  ni++;
	}
      }
    }
    Xd[2]	=Xd[0];
    Xd[3]	=Xd[1];
    Yd[2]	=Yd[0];
    Yd[3]	=Yd[1];
  }
  
  if(pntP->nP == 0 && Nkx[iT] == 0){
    VirtualFrame(pntT->W,nL);
    if(*CbUserWarning){
      ZWarning(CbUserWarning);
      *CbUserWarning	='\0';
    }
    return;
  }
  i	=TblS < 0 ? blb[TblB].IB&0x300 : blb[TblB].IS[TblM][TblS]&0x300;
  if(FlSc[iT] == 0){
    i	=0x300;
  }
  if((i&0x100)){
    XCbGiveName2Axis(iT,nL);
    if(Nkx[iT] == 0){
      Xd[0]	=0.;
      Xd[1]	=1.;
      Yd[0]	=0.;
      Yd[1]	=pntT->nL > 1 ? 1. : 0.;
    }
    k	=pntT->W;
    j	=FlBx ? 2 : 0;
    CbBoxX[0]	=Xd[j];
    CbBoxY[0]	=Yd[j];
    j++;
    CbBoxX[1]	=Xd[j];
    CbBoxY[1]	=Yd[j];
    CbBoxFl	=0;
    if(nL > 1){
      Scale2D(k,nL,CbBoxX,CbBoxY,2,5,scPlot[iT]);
      if(CbUserPlot != NULL) CbUserPlot();
    }
    else{
      Scale1D(k,CbBoxX[0],CbBoxX[1],1);
    }
    Xg_0[iT]	=*p0;
    Yg_0[iT]	=*p1;
    Xmin[iT]	=*p2;
    Ymin[iT]	=*p3;
    Xmax[iT]	=*p4;
    Ymax[iT]	=*p5;
    Sx[iT]	=*p6;
    Sy[iT]	=*p7;
    FlSc[iT]	=1;
  }

  if(nL < 2 || (i&0x300) == 0) return;

  XCbSetUnitScaleXY(scX,scY);
  if(*CbUserWarning){
    ZWarning(CbUserWarning);
    *CbUserWarning	='\0';
  }

  n	=pntP->nP;
  if(n){
    xg_0=*p0;
    yg_0=*p1;
    sx	=*p6;
    sy	=*p7;
    xmn	=(*p2)*sx;
    xmx	=(*p4)*sx-xmn;
    ymx	=(*p3)*sy;
    ymn	=(*p5)*sy-ymx;

    nd	=pntP->nV;
    for(i=0; i < nd; i++){
      if(pntP->ScpV[i] != NULL){
	pntP->scV[i]	=*(double*)pntP->ScpV[i];
      }
      k=pntP->nKV[i];
      for(j=0; j < k; j++){
	if(pntP->pi0V[i][j] != NULL){
	  pntP->i0V[i][j]	=*(int*)pntP->pi0V[i][j];
	}
	if(pntP->pi1V[i][j] != NULL){
	  pntP->i1V[i][j]	=*(int*)pntP->pi1V[i][j];
	}
      }
    }
    for(i=0; i < n;i++){
      if(pntP->pi0[i]  !=  NULL){
	pntP->i0[i]	=*(int*)pntP->pi0[i];
      }
      if(pntP->pi1[i] != NULL){
	pntP->i1[i]	=*(int*)pntP->pi1[i];
      }
      if(pntP->pc[i] != NULL){
	pntP->c[i]	=*(int*)pntP->pc[i];
      }
    }

    col		=0;
    XSetForeground(theD,theGC,ColorPix[col]);

    nLine	=0;
    for(i=0; i < n; i++){
      k	=pntP->iX[i];
      if(k >= nd){
	k	-=nd;
	k	=pXCbM[k].iV;
      }
      k1= pntP->iY[i];
      if(k1>=nd){
	k1-= nd;
	k1= pXCbM[k1].iV;
      }

      XCbPlot(pntP,i,k,k1);
    }
  }
}

int XCbCellP2TblP(iT)
     int iT;
{
  int i,ii,j,iM,ns,nd,ni,nU,k,n,k1;
  int Fl;
  double sc,*pntd,*pntd0,**pntd1;
  float**pntf1;
  int*pnti,*pnti0,**pnti1,*pntc;
  long int**pntL1;

  Fl= 0;
  ns= 0;
  nd= 0;
  ni= 0;
  for(j=0; j < nPC; j++){
    i= pj2i[j];
    iM= pj2m[j];
    ii= pntT->iCP[i];
    pi2c[i]= pCell[j].c;
    if(iM<0||pXCbM[iM].d==0){
      pntT->cP[i]= pCell[j].c==9?0:1;
      switch(ii&7){
      case 0:
#ifdef H
	if(pntT->P[i] != NULL){
	  strcpy(pntT->P[i],pntT->P1[i]);
	}
#endif
	ns++;
	break;
      case 1:
	if(pd[nd] != pd0[nd]){
	  Fl++;
	  if((nU= pCell[j].nU)<0){
	    *(double*)pntT->P[i]= pd[nd];
	  }
	  else{
	    *(double*)pntT->P[i]= pd[nd]*XUnits[nU].rsc;
	    if(XUnits[nU].iU){
	      *(double*)pntT->P[i]/= pntT->scP[i];
	    }
	  }
	}
	nd++;
	break;
      case 3:
	if(pd[nd] != pd0[nd]){
	  Fl++;
	  if((nU= pCell[j].nU)<0){
	    *(float*)pntT->P[i]= (float)pd[nd];
	  }
	  else{
	    *(float*)pntT->P[i]= (float)(pd[nd]*XUnits[nU].rsc);
	    if(XUnits[nU].iU){
	      *(float*)pntT->P[i]/= pntT->scP[i];
	    }
	  }
	}
	nd++;
	break;
      case 2:
      case 5:
	if(pi[ni] != pi0[ni]){
	  Fl++;
	  *((int*)pntT->P[i])	=pi[ni];
	}
	ni++;
	break;
      case 4:
	if(pi[ni] != pi0[ni]){
	  Fl++;
	  *((long*)pntT->P[i])= pi[ni];
	}
	ni++;
	break;
      default:
	break;
      }
    }
  }
  ns= 0;
  nd= 0;
  ni= 0;
  for(j= nPC;j<nPVC;j++){
    i= pj2i[j];
    pi2c[i]= pCell[j].c;
    i-= nP;
    iM= pj2m[j];
    if(iM<0||pXCbM[iM].d==0){
      n= pntT->lV[i];
      pntc= pntT->cV[i];
      k1= 0;
      pntc[0]= pCell[j].c==9?0:1;
      k= pj2jv[j];
      for(k1= 1;k1<n;k1++){
	pntc[k1]= pCell[k].c==9?0:1;
	k++;
      }
      switch(pntT->iCV[i]&7){
      case 0:
#ifdef H
	pnt= pntT->V[i];
	pnt1= pntT->V1[i];
	for(k1= 0;k1<n;k1++){
	  strcpy(pnt[k1],pnt1[k1]);
	}
#endif
	ns++;
	break;
      case 1:
	pntd= vd[nd];
	pntd0= vd0[nd];
	if(pCell[j].ws&&pntd[0] != pntd0[0]){
	  if(*pCell[j].ps=='*'&&pntd0[0] != 0.){
	    sc= pntd[0]/pntd0[0];
	    for(k= 1;k<n;k++){
	      pntd[k]*= sc;
	      pntd0[k]= pntd[k]+1.;
	    }
	  }
	  if(*pCell[j].ps=='+'){
	    sc= pntd[0]-pntd0[0];
	    for(k= 1;k<n;k++){
	      pntd[k]+= sc;
	      pntd0[k]= pntd[k]+1.;
	    }
	  }
	}
	pntd1= (double**)pntT->V[i];
	if((nU= pCell[j].nU)<=0){
	  for(k= 0;k<n;k++){
	    if(pntd[k] != pntd0[k]){
	      Fl++;
	      *pntd1[k]= pntd[k];
	    }
	  }
	}
	else{
	  sc= XUnits[nU].rsc;
	  if(XUnits[nU].iU){
	    sc/= pntT->scV[i];
	  }
	  for(k= 0;k<n;k++){
	    if(pntd[k] != pntd0[k]){
	      Fl++;
	      *pntd1[k]= pntd[k]*sc;
	    }
	  }
	}
	nd++;
	break;
      case 3:
	pntd= vd[nd];
	pntd0= vd0[nd];
	if(pCell[j].ws&&pntd[0] != pntd0[0]){
	  if(*pCell[j].ps=='*'&&pntd0[0] != 0.){
	    sc= pntd[0]/pntd0[0];
	    for(k= 1;k<n;k++){
	      pntd[k]*= sc;
	      pntd0[k]= pntd[k]+1.;
	    }
	  }
	  if(*pCell[j].ps=='+'){
	    sc= pntd[0]-pntd0[0];
	    for(k= 1;k<n;k++){
	      pntd[k]+= sc;
	      pntd0[k]= pntd[k]+1.;
	    }
	  }
	}
	pntf1= (float**)pntT->V[i];
	if((nU= pCell[j].nU)<=0){
	  for(k= 0;k<n;k++){
	    if(pntd[k] != pntd0[k]){
	      Fl++;
	      *pntf1[k]= (float)pntd[k];
	    }
	  }
	}
	else{
	  sc= XUnits[nU].rsc;
	  if(XUnits[nU].iU){
	    sc/= pntT->scV[i];
	  }
	  for(k= 0;k<n;k++){
	    if(pntd[k] != pntd0[k]){
	      Fl++;
	      *pntf1[k]= (float)(pntd[k]*sc);
	    }
	  }
	}
	nd++;
	break;
      case 2:
      case 5:
	pnti= vi[ni];
	pnti0= vi0[ni];
	pnti1= (int**)pntT->V[i];
	if((nU= pCell[j].nU)<=0){
	  for(k= 0;k<n;k++){
	    if(pnti[k] != pnti0[k]){
	      Fl++;
	      *pnti1[k]= pnti[k];
	    }
	  }
	}
	else{
	  sc= XUnits[nU].rsc;
	  if(XUnits[nU].iU){
	    sc/= pntT->scV[i];
	  }
	  for(k= 0;k<n;k++){
	    if(pnti[k] != pnti0[k]){
	      Fl++;
	      *pnti1[k]= pnti[k]*sc;
	    }
	  }
	}
	ni++;
	break;
      case 4:
	pnti= vi[ni];
	pnti0= vi0[ni];
	pntL1= (long**)pntT->V[i];
	if((nU= pCell[j].nU)<=0){
	  for(k= 0;k<n;k++){
	    if(pnti[k] != pnti0[k]){
	      Fl++;
	      *pntL1[k]= (long)pnti[k];
	    }
	  }
	}
	else{
	  sc= XUnits[nU].rsc;
	  if(XUnits[nU].iU){
	    sc/= pntT->scV[i];
	  }
	  for(k= 0;k<n;k++){
	    if(pnti[k] != pnti0[k]){
	      Fl++;
	      *pntL1[k]= (long)(pnti[k]*sc);
	    }
	  }
	}
	ni++;
	break;
      default:
	break;
      }
    }
  }
  return(Fl);
}

int XCbRepeatInputTable(int iT)
{
  XCbCellP2TblP(iT);
  if(FlagPS){
    CbPSFileOpen(NmF,PageNames[iT],FlPSopen+iT,FigCnt+iT
		 ,PageCnt+iT,PSFilePos+iT);
  }
  XCbTblP2CellP(iT);
  if(FlagPS) CbPSFigClose(PSFilePos+iT);
  return(0);
}

static int iTCurr;
int XCbInputTable(int iT)
{
  int k,Fl,i,kk;

  CbSend2XUTable(iT);
      
  iTCurr	=iT;
  WinP[iWin].mode	&=((pntT->mode<<4)&0xF);
  kk	=0;
  if(FlTblRd){
    i	=TblS < 0 ? blb[TblB].mB&0x400 : blb[TblB].mS[TblM][TblS]&0x400;
    if(i){
      CbReadTbl(iT,FlReadTbl[iT]);
      kk=1;
    }
    FlTblRd	=0;
  }
  Fl	=0;
  if(TblS < 0){
    if(*CbUserWarning){
      blb[TblB].IB	|=0x300;
      CpShowOneInpSwitch(blb[TblB].jCB);
      ZWarning(CbUserWarning);
      *CbUserWarning	='\0';
    }
    if((blb[TblB].IB&0x100)){
      Fl	=1;
    }
    if((blb[TblB].OB&0x400)){
      FlagPS	=1;
    }
  }
  else{
    if(*CbUserWarning){
      blb[TblB].IS[TblM][TblS]	|=0x300;
      CpShowOneInpSwitch(blb[TblB].jCS[TblM][TblS]);
      ZWarning(CbUserWarning);
      *CbUserWarning	='\0';
    }
    if((blb[TblB].IS[TblM][TblS]&0x100)){
      Fl	=1;
    }
    if((blb[TblB].OS[TblM][TblS]&0x400)){
      FlagPS	=1;
    }
  }
  if(FlagPS){
    CbPSFileOpen(NmF,PageNames[iT],FlPSopen+iT,FigCnt+iT
		 ,PageCnt+iT,PSFilePos+iT);
  }
  if(Fl) XCbCleanWindow(Tbl[iT].W);

  XCbTblP2CellP(iT);
  if(FlagPS) CbPSFigClose(PSFilePos+iT);
  if(ind == 27){
    i	=TblS < 0 ? blb[TblB].mB&0x400 : blb[TblB].mS[TblM][TblS]&0x400;
    if(i){
      CbSaveTbl(iT);
      FlReadTbl[iT]	=0;
    }
    return(ind);
  }
  if(Fl){
    if(CbUserMessage != NULL){
      if(*CbUserWarning == 0) ZMessage(CbUserMessage);
      *CbUserMessage	='\0';
      CbUserMessage	=NULL;
    }
    if(CbUserRoutine != NULL){
      CbUserRoutine();
      CbUserRoutine	=NULL;
    }
    if(nL > 1){
      ind=XCb2DTableInput(iWin,pntT->nL,pCell,NCell[iT],kx2j[iT],ky2j[iT]
			  ,j2kx[iT],j2ky[iT],kx2p[iT],ky2p[iT],Nkx[iT]
			  ,iCell+iT);
      if(*CbUserWarning && ind == 27){
	ind	=13;
      }
    }
    else{
      ind=XCb1DTableInput(iWin,pCell,NCell[iT],kx2j[iT],j2kx[iT],
			  kx2p[iT],Nkx[iT],iCell+iT);
    }
    CbUserXWRoutine	=NULL;
    CbUserControl	=NULL;
  }
  else{
    *CbUserWarning	=0;
    ind	=kk ? '\r' : 27;
    return(ind);
  }
  *CbUserWarning	=0;
  Wm	=WinP[iWin].mode&0xF;
  Wm1	=WinP[iWin].mode>>4;

  if(ind){
    k	=kk+XCbCellP2TblP(iT);
  }
  else{
    k	=0;
    k	=kk+XCbCellP2TblP(iT);
  }
  pntT->mode	=Wm1;
  switch(Wm1){
  case 0:
    break;
  case 1:
    CbReadTblA(iT,FlReadTbl[iT]);
    FlReadTbl[iT]	=0;
    break;
  case 2:
    FlagPS	=1;
    FlPSopen[iT]	=0;
    if(k == 0) k=1;
    break;
  case 3:
    CbSaveTbl(iT);
    FlReadTbl[iT]	=0;
    break;
  case 4:
    FlagPS	=1;
    if(k==0) k=1;
    CbWriteTbl(iT,"a");
    FlReadTbl[iT]	=0;
    break;
  case 5:
    if(k==0) k=1;
    CbReadTbl(iT,FlReadTbl[iT]);
    break;
  case 6:
    FlagPS	=1;
    if(k==0) k=1;
    break;
  case 7:
    if(k==0) k=1;
    CbWriteTbl(iT,"w");
    FlReadTbl[iT]	=0;
    break;
  default:
    break;
  }
  pntT->mode =0;

  xshTbl[iT]	=xshift;

  if(k){
    return(0);
  }
  else{
    if(ind == 27){
      i	=TblS < 0 ? blb[TblB].mB&0x400 : blb[TblB].mS[TblM][TblS]&0x400;
      if(i){
	CbSaveTbl(iT);
	FlReadTbl[iT]	=0;
      }
    }
    return(ind);
  }
}
#ifdef H
void XCbTestTables()
{
  int i,j,ni,nd;

  XCbInitX();
  XCbInputCntrPanel();
  CbInitDirectorySet();

  XCbInitDummyValues();

  for(i= 0;i<nTbl;i++){
    if(Tbl[i].SF != NULL){
      XCbDummyValues2TblPV(i);
      XCbInitInputTable(i);
      do{
	j= XCbInputTable(i);
      }while(j-27);
      XCbDummyDeValues2TblPV(i);
    }
  }

  XCbDeInitDummyValues();
  XCbDeInitX();
}
#endif

int ZGetMenuList4Cell(int *M,char **llc,int j)
{
  int i,k,iM;

  iM	=pj2m[j];
  if(iM < 0){
    return(0);
  }
  *M	=pXCbM[iM].i;
  for(i=0; i < pXCbM[iM].n; i++){
    k	=pXCbM[iM].p[i];
    llc[i]	=j < nPC ? pntT->nmEP[k] : pntT->nmEV[k-nP];
  }
  return(i);
}

int XCbReSetTblCells(int Bj,int k)
{
  int i,ji,iM,j,nU;

  j	=Bj;
  iM	=pj2m[j];
  if(iM < 0){
    return(0);
  }

  if(k < 0){
    i	=pXCbM[iM].i;
    i++;
    if(i == pXCbM[iM].n){
      i	=0;
    }
  }
  else{
    i	=k;
  }

  pXCbM[iM].i	=i;
  j	=pXCbM[iM].j;
  pj2i[j]	=pXCbM[iM].p[i];
  ji	=pj2i[j];
  pCell[j].c	=9;
  if(pCell[j].lu){
    nU	=j < nPC ? pntT->nUP[ji] : pntT->nUV[ji-nP];
    if(nU < 0){
      nU =0;
    }
    pCell[j].nU =nU;
    pCell[j].pu =XUnits[nU].pntU;
  }
  pCell[j].pn	=j < nPC ? pntT->nmEP[ji] : pntT->nmEV[ji-nP];
  while(pXCbM[iM].d > 0){
    iM	=pXCbM[iM].m[i];
    i	=pXCbM[iM].i;
    j	=pXCbM[iM].j;
    pj2m[j]	=iM;
    pj2i[j]	=pXCbM[iM].p[i];
    ji	=pj2i[j];
    pCell[j].c	=9;
    if(pCell[j].lu){
      nU	=j < nPC ? pntT->nUP[ji] : pntT->nUV[ji-nP];
      if(nU < 0){
	nU	=0;
      }
      pCell[j].nU	=nU;
      pCell[j].pu	=XUnits[nU].pntU;
    }
    pCell[j].pn	=j < nPC ? pntT->nmEP[ji] : pntT->nmEV[ji-nP];
  }
  if(pntP->nP){	/* ????? */
    j	=pntP->mV[iM]+i;
    pXCbM[iM].iV	=j;
    while(pXCbM[iM].mb < iM){
      iM	=pXCbM[iM].mb;
      pXCbM[iM].iV	=j;
    }
  }
  XCbCellP2TblP(iTCurr);
  XCbTblP2CellP(iTCurr);
  return(0);
}

void XCbReSetTblUnits(int Bj)
{
  int i,j,iU,nU,nd;
  char*pnt;
  double sc;
  InpTblPar*pntt;
  InputCell*pntc;

  nU	=pCell[Bj].nU;
  iU	=XUnits[nU].iU;
  sc	=XUnits[nU].scU[iU];
  iU++;
  if(iU == XUnits[nU].nU){
    iU	=0;
    XUnits[nU].sc	=1.;
    XUnits[nU].rsc	=1.;
  }
  else{
    XUnits[nU].sc	*=sc;
    XUnits[nU].rsc	=1./XUnits[nU].sc;
  }

  XUnits[nU].iU	=iU;

  pnt	=XUnits[nU].TU[iU];
  XUnits[nU].pntU	=pnt;

  for(i	=0; i < nTbl; i++){
    if(Tbl[i].SF != NULL){
      pntt	=Tbl+i;
      pntc	=Cell[i];
      nd	=pntt->NPC+pntt->NNmVC;
      for(j=0; j < nd; j++){
	if(pntc[j].nU == nU){
	  pntc[j].pu	=pnt;
	}
      }
    }
  }
  XCbCellP2TblP(iTCurr);
  XCbTblP2CellP(iTCurr);
}

void XCbBackwardTblUnits(int Bj)
{
  int i,j,iU,nU,nd;
  char*pnt;
  double sc;
  InpTblPar*pntt;
  InputCell*pntc;

  nU	=pCell[Bj].nU;
  iU	=XUnits[nU].iU;
  iU--;
  if(iU < 0){
    iU	=XUnits[nU].nU-1;
    sc	=XUnits[nU].scU[iU];
    XUnits[nU].sc	=1./sc;
    XUnits[nU].rsc	=sc;
  }
  else{
    sc	=XUnits[nU].scU[iU];
    XUnits[nU].sc	/=sc;
    XUnits[nU].rsc	=1./XUnits[nU].sc;
  }
  XUnits[nU].iU	=iU;

  pnt	=XUnits[nU].TU[iU];
  XUnits[nU].pntU	=pnt;

  for(i	=0; i < nTbl; i++){
    if(Tbl[i].SF != NULL){
      pntt	=Tbl+i;
      pntc	=Cell[i];
      nd	=pntt->NPC+pntt->NNmVC;
      for(j=0; j < nd; j++){
	if(pntc[j].nU == nU){
	  pntc[j].pu	=pnt;
	}
      }
    }
  }
  XCbCellP2TblP(iTCurr);
  XCbTblP2CellP(iTCurr);
}

void xcbitb_(int*iT)
{
  XCbInitInputTable(*iT);
}

int ixcbtb_(int*iT)
{
  return(XCbInputTable(*iT));
}

int XCbReSetCPanelCells(int IB,int*nPnCells,int*nIDCells)
{
  BLB*pntB;
  int i,iM,nM,iS,nS,iB,nB,kB,n,iC,iD;

  if(IB==0){
   CbExchangeInpList(&kBlbInpDir,&BlbInpFNmD,&BlbInpFNmW,
		      &BlbInpFNmO,&BlbInpFNmI,
		      &MzlInpFNmW,&MzlInpFNmO,&MzlInpFNmI,
		      &StgInpFNmW,&StgInpFNmO,&StgInpFNmI);
  }
  pntB= blb+IB;
  iC= *nPnCells;
  iD= *nIDCells;

  CPCell[iC].kW= 0;
  CPCell[iC].kO= 0;
  CPCell[iC].kI= 0;
  CPCell[iC].pW= BlbInpFNmW[IB];
  CPCell[iC].pO= BlbInpFNmO[IB];
  CPCell[iC].pI= BlbInpFNmI[IB];
  if(*pntB->OD != '\0'){
    IDCell[iD].ps= (char*)BlbInpFNmD[IB];
    IDCell[iD].ps0	=IDCell[iD].ps;
    IDCell[iD].vs	=kBlbInpDir+IB;
  }
  iD++;
  iC++;

  nM	=pntB->nM;
  for(iM=0; iM < nM; iM++){
    CPCell[iC].kW= 0;
    CPCell[iC].kO= 0;
    CPCell[iC].kI= 0;
    CPCell[iC].pW= MzlInpFNmW[IB][iM];
    CPCell[iC].pO= MzlInpFNmO[IB][iM];
    CPCell[iC].pI= MzlInpFNmI[IB][iM];
    iC++;

    nS= pntB->nS[iM];
    nB= pntB->nB[iM];
    n= nS+nB;
    iB= 0;
    iS= 0;
    i= 0;
    if(nB) kB=pntB->kB[iM][iB];
    while(i<n){
      if(iB < nB && i == kB){
	XCbReSetCPanelCells(pntB->nxtB[iM][iB],&iC,&iD);
	iB++;
	if(iB<nB) kB= pntB->kB[iM][iB];
      }
      else{
	if(iS<nS){
	  CPCell[iC].kW= 0;
	  CPCell[iC].kO= 0;
	  CPCell[iC].kI= 0;
	  CPCell[iC].pW= StgInpFNmW[IB][iM][iS];
	  CPCell[iC].pO= StgInpFNmO[IB][iM][iS];
	  CPCell[iC].pI= StgInpFNmI[IB][iM][iS];
	  iC++;
	  iS++;
	}
      }
      i++;
    }
  }
  *nPnCells= iC;
  *nIDCells= iD;

  return(0);
}

static int nOutNm=0;
int XCbSavingCntrPanel(int M)
{
  BLB *lB;
  int i,k;

  k	=0x20;
  if((M&k)){
    CbSaveCntrPanel(".");
    XCbSaveWindowGeom(".");
  }
  for(i=0; i < nblb; i++){
    lB	=blb+i;
    if(*lB->OD != '\0' && CbStrCmp(".",lB->OD)){
      k	<<=1;
      if((M&k)){
	CbSaveCntrPanel(lB->path);
	XCbSaveWindowGeom(lB->path);
      }
    }
  }
  return(0);
}

int XCbOutDirNames2Menu(char **llc)
{
  BLB *lB;
  int i;

  llc[0]	=".";
  nOutNm	=1;
  for(i=0; i < nblb; i++){
    lB	=blb+i;
    if(*lB->OD != '\0' && CbStrCmp(llc[0],lB->OD)){
      llc[nOutNm]	=lB->OD;
      nOutNm++;
    }
  }
  llc[nOutNm]	=NULL;
  return(0);
}

int XCbSaveCntrPanel()
{
  int i,k;
  static int M=0x20;

  k	=XCbMenuWindow(3,&M,NULL,NULL,0,hF);
  i	=0x20<<nOutNm;
  if((M&i)){
    XCbSaveWindowGeom(".");
    M	-=i;
  }
  if(k == 2){
    CbInitDirectorySet();
    XCbSavingCntrPanel(M);
  }
  return(0);
}
#ifndef stg_Switches
#endif
#endif
